/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/nls!vs/code/electron-main/main","vs/base/common/path","vs/nls","vs/base/common/network","vs/base/common/types","electron","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/objects","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/platform/window/common/window","vs/platform/window/electron-main/window","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/severity","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/issue/electron-main/processMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/issue/electron-main/processMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],ae=function(x){for(var e=[],n=0,o=x.length;n<o;n++)e[n]=oe[x[n]];return e};define(oe[138],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ob=void 0,e.$hb=n,e.$ib=o,e.$jb=P,e.$kb=D,e.$lb=A,e.$mb=I,e.$nb=b,e.$pb=f,e.$qb=d,e.$rb=g,e.$sb=w,e.$tb=h;function n(p,y){const $=o(p,y);if($!==-1)return p[$]}function o(p,y,$=p.length-1){for(let m=$;m>=0;m--){const E=p[m];if(y(E))return m}return-1}function P(p,y){const $=D(p,y);return $===-1?void 0:p[$]}function D(p,y,$=0,m=p.length){let E=$,k=m;for(;E<k;){const t=Math.floor((E+k)/2);y(p[t])?E=t+1:k=t}return E-1}function A(p,y){const $=I(p,y);return $===p.length?void 0:p[$]}function I(p,y,$=0,m=p.length){let E=$,k=m;for(;E<k;){const t=Math.floor((E+k)/2);y(p[t])?k=t:E=t+1}return E}function b(p,y,$=0,m=p.length){const E=I(p,y,$,m);return E===p.length?-1:E}class a{static{this.assertInvariants=!1}constructor(y){this.e=y,this.c=0}findLastMonotonous(y){if(a.assertInvariants){if(this.d){for(const m of this.e)if(this.d(m)&&!y(m))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=y}const $=D(this.e,y,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$ob=a;function f(p,y){if(p.length===0)return;let $=p[0];for(let m=1;m<p.length;m++){const E=p[m];y(E,$)>0&&($=E)}return $}function d(p,y){if(p.length===0)return;let $=p[0];for(let m=1;m<p.length;m++){const E=p[m];y(E,$)>=0&&($=E)}return $}function g(p,y){return f(p,($,m)=>-y($,m))}function w(p,y){if(p.length===0)return-1;let $=0;for(let m=1;m<p.length;m++){const E=p[m];y(E,p[$])>0&&($=m)}return $}function h(p,y){for(const $ of p){const m=y($);if(m!==void 0)return m}}}),define(oe[39],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(o){o[o.Null=0]="Null",o[o.Backspace=8]="Backspace",o[o.Tab=9]="Tab",o[o.LineFeed=10]="LineFeed",o[o.CarriageReturn=13]="CarriageReturn",o[o.Space=32]="Space",o[o.ExclamationMark=33]="ExclamationMark",o[o.DoubleQuote=34]="DoubleQuote",o[o.Hash=35]="Hash",o[o.DollarSign=36]="DollarSign",o[o.PercentSign=37]="PercentSign",o[o.Ampersand=38]="Ampersand",o[o.SingleQuote=39]="SingleQuote",o[o.OpenParen=40]="OpenParen",o[o.CloseParen=41]="CloseParen",o[o.Asterisk=42]="Asterisk",o[o.Plus=43]="Plus",o[o.Comma=44]="Comma",o[o.Dash=45]="Dash",o[o.Period=46]="Period",o[o.Slash=47]="Slash",o[o.Digit0=48]="Digit0",o[o.Digit1=49]="Digit1",o[o.Digit2=50]="Digit2",o[o.Digit3=51]="Digit3",o[o.Digit4=52]="Digit4",o[o.Digit5=53]="Digit5",o[o.Digit6=54]="Digit6",o[o.Digit7=55]="Digit7",o[o.Digit8=56]="Digit8",o[o.Digit9=57]="Digit9",o[o.Colon=58]="Colon",o[o.Semicolon=59]="Semicolon",o[o.LessThan=60]="LessThan",o[o.Equals=61]="Equals",o[o.GreaterThan=62]="GreaterThan",o[o.QuestionMark=63]="QuestionMark",o[o.AtSign=64]="AtSign",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.OpenSquareBracket=91]="OpenSquareBracket",o[o.Backslash=92]="Backslash",o[o.CloseSquareBracket=93]="CloseSquareBracket",o[o.Caret=94]="Caret",o[o.Underline=95]="Underline",o[o.BackTick=96]="BackTick",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.OpenCurlyBrace=123]="OpenCurlyBrace",o[o.Pipe=124]="Pipe",o[o.CloseCurlyBrace=125]="CloseCurlyBrace",o[o.Tilde=126]="Tilde",o[o.NoBreakSpace=160]="NoBreakSpace",o[o.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",o[o.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",o[o.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",o[o.U_Combining_Tilde=771]="U_Combining_Tilde",o[o.U_Combining_Macron=772]="U_Combining_Macron",o[o.U_Combining_Overline=773]="U_Combining_Overline",o[o.U_Combining_Breve=774]="U_Combining_Breve",o[o.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",o[o.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",o[o.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",o[o.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",o[o.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",o[o.U_Combining_Caron=780]="U_Combining_Caron",o[o.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",o[o.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",o[o.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",o[o.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",o[o.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",o[o.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",o[o.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",o[o.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",o[o.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",o[o.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",o[o.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",o[o.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",o[o.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",o[o.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",o[o.U_Combining_Horn=795]="U_Combining_Horn",o[o.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",o[o.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",o[o.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",o[o.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",o[o.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",o[o.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",o[o.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",o[o.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",o[o.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",o[o.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",o[o.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",o[o.U_Combining_Cedilla=807]="U_Combining_Cedilla",o[o.U_Combining_Ogonek=808]="U_Combining_Ogonek",o[o.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",o[o.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",o[o.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",o[o.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",o[o.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",o[o.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",o[o.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",o[o.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",o[o.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",o[o.U_Combining_Low_Line=818]="U_Combining_Low_Line",o[o.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",o[o.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",o[o.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",o[o.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",o[o.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",o[o.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",o[o.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",o[o.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",o[o.U_Combining_Square_Below=827]="U_Combining_Square_Below",o[o.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",o[o.U_Combining_X_Above=829]="U_Combining_X_Above",o[o.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",o[o.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",o[o.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",o[o.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",o[o.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",o[o.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",o[o.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",o[o.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",o[o.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",o[o.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",o[o.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",o[o.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",o[o.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",o[o.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",o[o.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",o[o.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",o[o.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",o[o.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",o[o.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",o[o.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",o[o.U_Combining_Fermata=850]="U_Combining_Fermata",o[o.U_Combining_X_Below=851]="U_Combining_X_Below",o[o.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",o[o.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",o[o.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",o[o.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",o[o.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",o[o.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",o[o.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",o[o.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",o[o.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",o[o.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",o[o.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",o[o.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",o[o.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",o[o.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",o[o.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",o[o.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",o[o.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",o[o.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",o[o.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",o[o.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",o[o.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",o[o.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",o[o.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",o[o.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",o[o.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",o[o.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",o[o.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",o[o.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",o[o.LINE_SEPARATOR=8232]="LINE_SEPARATOR",o[o.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",o[o.NEXT_LINE=133]="NEXT_LINE",o[o.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",o[o.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",o[o.U_DIAERESIS=168]="U_DIAERESIS",o[o.U_MACRON=175]="U_MACRON",o[o.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",o[o.U_CEDILLA=184]="U_CEDILLA",o[o.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",o[o.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",o[o.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",o[o.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",o[o.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",o[o.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",o[o.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",o[o.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",o[o.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",o[o.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",o[o.U_BREVE=728]="U_BREVE",o[o.U_DOT_ABOVE=729]="U_DOT_ABOVE",o[o.U_RING_ABOVE=730]="U_RING_ABOVE",o[o.U_OGONEK=731]="U_OGONEK",o[o.U_SMALL_TILDE=732]="U_SMALL_TILDE",o[o.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",o[o.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",o[o.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",o[o.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",o[o.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",o[o.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",o[o.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",o[o.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",o[o.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",o[o.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",o[o.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",o[o.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",o[o.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",o[o.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",o[o.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",o[o.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",o[o.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",o[o.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",o[o.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",o[o.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",o[o.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",o[o.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",o[o.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",o[o.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",o[o.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",o[o.U_GREEK_TONOS=900]="U_GREEK_TONOS",o[o.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",o[o.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",o[o.U_GREEK_PSILI=8127]="U_GREEK_PSILI",o[o.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",o[o.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",o[o.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",o[o.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",o[o.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",o[o.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",o[o.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",o[o.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",o[o.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",o[o.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",o[o.U_GREEK_VARIA=8175]="U_GREEK_VARIA",o[o.U_GREEK_OXIA=8189]="U_GREEK_OXIA",o[o.U_GREEK_DASIA=8190]="U_GREEK_DASIA",o[o.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",o[o.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",o[o.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",o[o.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",o[o.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",o[o.U_OVERLINE=8254]="U_OVERLINE",o[o.UTF8_BOM=65279]="UTF8_BOM",o[o.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",o[o.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(oe[139],ae([0,1]),function(x,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=o,e.$L=P,e.$M=D,e.$N=A;function o(b,a){const f=Object.create(null);for(const d of b){const g=a(d);let w=f[g];w||(w=f[g]=[]),w.push(d)}return f}function P(b,a){const f=[],d=[];for(const g of b)a.has(g)||f.push(g);for(const g of a)b.has(g)||d.push(g);return{removed:f,added:d}}function D(b,a){const f=[],d=[];for(const[g,w]of b)a.has(g)||f.push(w);for(const[g,w]of a)b.has(g)||d.push(w);return{removed:f,added:d}}function A(b,a){const f=new Set;for(const d of a)b.has(d)&&f.add(d);return f}class I{static{n=Symbol.toStringTag}constructor(a,f){this.b=f,this.a=new Map,this[n]="SetWithKey";for(const d of a)this.add(d)}get size(){return this.a.size}add(a){const f=this.b(a);return this.a.set(f,a),this}delete(a){return this.a.delete(this.b(a))}has(a){return this.a.has(this.b(a))}*entries(){for(const a of this.a.values())yield[a,a]}keys(){return this.values()}*values(){for(const a of this.a.values())yield a}clear(){this.a.clear()}forEach(a,f){this.a.forEach(d=>a.call(f,d,d,this))}[Symbol.iterator](){return this.values()}}e.$O=I}),define(oe[140],ae([0,1,39]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ku=e.$ju=e.$iu=e.$hu=void 0;function o(b,a){const f=Math.pow(10,a);return Math.round(b*f)/f}class P{constructor(a,f,d,g=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=o(Math.max(Math.min(1,g),0),3)}static equals(a,f){return a.r===f.r&&a.g===f.g&&a.b===f.b&&a.a===f.a}}e.$hu=P;class D{constructor(a,f,d,g){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=o(Math.max(Math.min(1,f),0),3),this.l=o(Math.max(Math.min(1,d),0),3),this.a=o(Math.max(Math.min(1,g),0),3)}static equals(a,f){return a.h===f.h&&a.s===f.s&&a.l===f.l&&a.a===f.a}static fromRGBA(a){const f=a.r/255,d=a.g/255,g=a.b/255,w=a.a,h=Math.max(f,d,g),p=Math.min(f,d,g);let y=0,$=0;const m=(p+h)/2,E=h-p;if(E>0){switch($=Math.min(m<=.5?E/(2*m):E/(2-2*m),1),h){case f:y=(d-g)/E+(d<g?6:0);break;case d:y=(g-f)/E+2;break;case g:y=(f-d)/E+4;break}y*=60,y=Math.round(y)}return new D(y,$,m,w)}static i(a,f,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?a+(f-a)*6*d:d<1/2?f:d<2/3?a+(f-a)*(2/3-d)*6:a}static toRGBA(a){const f=a.h/360,{s:d,l:g,a:w}=a;let h,p,y;if(d===0)h=p=y=g;else{const $=g<.5?g*(1+d):g+d-g*d,m=2*g-$;h=D.i(m,$,f+1/3),p=D.i(m,$,f),y=D.i(m,$,f-1/3)}return new P(Math.round(h*255),Math.round(p*255),Math.round(y*255),w)}}e.$iu=D;class A{constructor(a,f,d,g){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=o(Math.max(Math.min(1,f),0),3),this.v=o(Math.max(Math.min(1,d),0),3),this.a=o(Math.max(Math.min(1,g),0),3)}static equals(a,f){return a.h===f.h&&a.s===f.s&&a.v===f.v&&a.a===f.a}static fromRGBA(a){const f=a.r/255,d=a.g/255,g=a.b/255,w=Math.max(f,d,g),h=Math.min(f,d,g),p=w-h,y=w===0?0:p/w;let $;return p===0?$=0:w===f?$=((d-g)/p%6+6)%6:w===d?$=(g-f)/p+2:$=(f-d)/p+4,new A(Math.round($*60),y,w,a.a)}static toRGBA(a){const{h:f,s:d,v:g,a:w}=a,h=g*d,p=h*(1-Math.abs(f/60%2-1)),y=g-h;let[$,m,E]=[0,0,0];return f<60?($=h,m=p):f<120?($=p,m=h):f<180?(m=h,E=p):f<240?(m=p,E=h):f<300?($=p,E=h):f<=360&&($=h,E=p),$=Math.round(($+y)*255),m=Math.round((m+y)*255),E=Math.round((E+y)*255),new P($,m,E,w)}}e.$ju=A;class I{static fromHex(a){return I.Format.CSS.parseHex(a)||I.red}static equals(a,f){return!a&&!f?!0:!a||!f?!1:a.equals(f)}get hsla(){return this.i?this.i:D.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:A.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof P)this.rgba=a;else if(a instanceof D)this.i=a,this.rgba=D.toRGBA(a);else if(a instanceof A)this.j=a,this.rgba=A.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&P.equals(this.rgba,a.rgba)&&D.equals(this.hsla,a.hsla)&&A.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=I.k(this.rgba.r),f=I.k(this.rgba.g),d=I.k(this.rgba.b),g=.2126*a+.7152*f+.0722*d;return o(g,4)}static k(a){const f=a/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(a){const f=this.getRelativeLuminance(),d=a.getRelativeLuminance();return f>d?(f+.05)/(d+.05):(d+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const f=this.getRelativeLuminance(),d=a.getRelativeLuminance();return f>d}isDarkerThan(a){const f=this.getRelativeLuminance(),d=a.getRelativeLuminance();return f<d}lighten(a){return new I(new D(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new I(new D(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:f,g:d,b:g,a:w}=this.rgba;return new I(new P(f,d,g,w*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new I(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const f=a.rgba,d=this.rgba.a,g=f.a,w=d+g*(1-d);if(w<1e-6)return I.transparent;const h=this.rgba.r*d/w+f.r*g*(1-d)/w,p=this.rgba.g*d/w+f.g*g*(1-d)/w,y=this.rgba.b*d/w+f.b*g*(1-d)/w;return new I(new P(h,p,y,w))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:f,g:d,b:g,a:w}=this.rgba;return new I(new P(a.rgba.r-w*(a.rgba.r-f),a.rgba.g-w*(a.rgba.g-d),a.rgba.b-w*(a.rgba.b-g),1))}flatten(...a){const f=a.reduceRight((d,g)=>I.o(g,d));return I.o(this,f)}static o(a,f){const d=1-a.rgba.a;return new I(new P(d*f.rgba.r+a.rgba.a*a.rgba.r,d*f.rgba.g+a.rgba.a*a.rgba.g,d*f.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=I.Format.CSS.format(this)),this.u}static getLighterColor(a,f,d){if(a.isLighterThan(f))return a;d=d||.5;const g=a.getRelativeLuminance(),w=f.getRelativeLuminance();return d=d*(w-g)/w,a.lighten(d)}static getDarkerColor(a,f,d){if(a.isDarkerThan(f))return a;d=d||.5;const g=a.getRelativeLuminance(),w=f.getRelativeLuminance();return d=d*(g-w)/g,a.darken(d)}static{this.white=new I(new P(255,255,255,1))}static{this.black=new I(new P(0,0,0,1))}static{this.red=new I(new P(255,0,0,1))}static{this.blue=new I(new P(0,0,255,1))}static{this.green=new I(new P(0,255,0,1))}static{this.cyan=new I(new P(0,255,255,1))}static{this.lightgrey=new I(new P(211,211,211,1))}static{this.transparent=new I(new P(0,0,0,0))}}e.$ku=I,function(b){let a;(function(f){let d;(function(g){function w(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:b.Format.CSS.formatRGBA(i)}g.formatRGB=w;function h(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}g.formatRGBA=h;function p(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:b.Format.CSS.formatHSLA(i)}g.formatHSL=p;function y(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}g.formatHSLA=y;function $(i){const c=i.toString(16);return c.length!==2?"0"+c:c}function m(i){return`#${$(i.rgba.r)}${$(i.rgba.g)}${$(i.rgba.b)}`}g.formatHex=m;function E(i,c=!1){return c&&i.rgba.a===1?b.Format.CSS.formatHex(i):`#${$(i.rgba.r)}${$(i.rgba.g)}${$(i.rgba.b)}${$(Math.round(i.rgba.a*255))}`}g.formatHexA=E;function k(i){return i.isOpaque()?b.Format.CSS.formatHex(i):b.Format.CSS.formatRGBA(i)}g.format=k;function t(i){const c=i.length;if(c===0||i.charCodeAt(0)!==n.CharCode.Hash)return null;if(c===7){const s=16*r(i.charCodeAt(1))+r(i.charCodeAt(2)),u=16*r(i.charCodeAt(3))+r(i.charCodeAt(4)),l=16*r(i.charCodeAt(5))+r(i.charCodeAt(6));return new b(new P(s,u,l,1))}if(c===9){const s=16*r(i.charCodeAt(1))+r(i.charCodeAt(2)),u=16*r(i.charCodeAt(3))+r(i.charCodeAt(4)),l=16*r(i.charCodeAt(5))+r(i.charCodeAt(6)),S=16*r(i.charCodeAt(7))+r(i.charCodeAt(8));return new b(new P(s,u,l,S/255))}if(c===4){const s=r(i.charCodeAt(1)),u=r(i.charCodeAt(2)),l=r(i.charCodeAt(3));return new b(new P(16*s+s,16*u+u,16*l+l))}if(c===5){const s=r(i.charCodeAt(1)),u=r(i.charCodeAt(2)),l=r(i.charCodeAt(3)),S=r(i.charCodeAt(4));return new b(new P(16*s+s,16*u+u,16*l+l,(16*S+S)/255))}return null}g.parseHex=t;function r(i){switch(i){case n.CharCode.Digit0:return 0;case n.CharCode.Digit1:return 1;case n.CharCode.Digit2:return 2;case n.CharCode.Digit3:return 3;case n.CharCode.Digit4:return 4;case n.CharCode.Digit5:return 5;case n.CharCode.Digit6:return 6;case n.CharCode.Digit7:return 7;case n.CharCode.Digit8:return 8;case n.CharCode.Digit9:return 9;case n.CharCode.a:return 10;case n.CharCode.A:return 10;case n.CharCode.b:return 11;case n.CharCode.B:return 11;case n.CharCode.c:return 12;case n.CharCode.C:return 12;case n.CharCode.d:return 13;case n.CharCode.D:return 13;case n.CharCode.e:return 14;case n.CharCode.E:return 14;case n.CharCode.f:return 15;case n.CharCode.F:return 15}return 0}})(d=f.CSS||(f.CSS={}))})(a=b.Format||(b.Format={}))}(I||(e.$ku=I={}))}),define(oe[54],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=o,e.$$h=P,e.$_h=D;function n(A){return(I,b,a)=>{let f=null,d=null;if(typeof a.value=="function"?(f="value",d=a.value):typeof a.get=="function"&&(f="get",d=a.get),!d)throw new Error("not supported");a[f]=A(d,b)}}function o(A,I,b){let a=null,f=null;if(typeof b.value=="function"?(a="value",f=b.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(a="get",f=b.get),!f)throw new Error("not supported");const d=`$memoize$${I}`;b[a]=function(...g){return this.hasOwnProperty(d)||Object.defineProperty(this,d,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,g)}),this[d]}}function P(A,I,b){return n((a,f)=>{const d=`$debounce$${f}`,g=`$debounce$result$${f}`;return function(...w){this[g]||(this[g]=b?b():void 0),clearTimeout(this[d]),I&&(this[g]=I(this[g],...w),w=[this[g]]),this[d]=setTimeout(()=>{a.apply(this,w),this[g]=b?b():void 0},A)}})}function D(A,I,b){return n((a,f)=>{const d=`$throttle$timer$${f}`,g=`$throttle$result$${f}`,w=`$throttle$lastRun$${f}`,h=`$throttle$pending$${f}`;return function(...p){if(this[g]||(this[g]=b?b():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),I&&(this[g]=I(this[g],...p)),this[h])return;const y=this[w]+A;y<=Date.now()?(this[w]=Date.now(),a.apply(this,[this[g]]),this[g]=b?b():void 0):(this[h]=!0,this[d]=setTimeout(()=>{this[h]=!1,this[w]=Date.now(),a.apply(this,[this[g]]),this[g]=b?b():void 0},y-Date.now()))}})}}),define(oe[16],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=e.$db=e.$cb=e.$bb=e.$ab=e.$$=e.$7=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=o,e.$2=P,e.$3=D,e.$4=A,e.$5=I,e.$6=a,e.$8=d,e.$9=g,e.$0=w,e.$_=p;class n{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?E.isErrorNoTelemetry(r)?new E(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(i=>{i(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.$Y=n,e.$Z=new n;function o(t){e.$Z.setUnexpectedErrorHandler(t)}function P(t){if(!t||typeof t!="object")return!1;const r=t;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function D(t){a(t)||e.$Z.onUnexpectedError(t)}function A(t){a(t)||e.$Z.onUnexpectedExternalError(t)}function I(t){if(t instanceof Error){const{name:r,message:i}=t,c=t.stacktrace||t.stack;return{$isError:!0,name:r,message:i,stack:c,noTelemetry:E.isErrorNoTelemetry(t)}}return t}const b="Canceled";function a(t){return t instanceof f?!0:t instanceof Error&&t.name===b&&t.message===b}class f extends Error{constructor(){super(b),this.name=this.message}}e.$7=f;function d(){const t=new Error(b);return t.name=t.message,t}function g(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}function w(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}class h extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$$=h;function p(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}class y extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.$ab=y;class $ extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.$bb=$;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$cb=m;class E extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof E)return r;const i=new E;return i.message=r.message,i.stack=r.stack,i}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.$db=E;class k extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype)}}e.$eb=k}),define(oe[22],ae([0,1,16,138]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$$b=e.$0b=e.CompareResult=void 0,e.$ub=P,e.$vb=D,e.$wb=A,e.$xb=I,e.$yb=b,e.$zb=a,e.$Ab=f,e.$Bb=d,e.$Cb=g,e.$Db=w,e.$Eb=h,e.$Fb=p,e.$Gb=y,e.top=$,e.$Ib=m,e.$Jb=k,e.$Kb=t,e.$Lb=r,e.$Mb=i,e.$Nb=c,e.$Ob=s,e.$Pb=u,e.$Qb=l,e.$Rb=S,e.$Sb=v,e.$Tb=R,e.$Ub=T,e.$Vb=L,e.$Wb=O,e.$Xb=F,e.$Yb=B,e.$Zb=C,e.$1b=z,e.$2b=re,e.$3b=Q,e.$4b=le,e.$5b=K,e.$6b=ee,e.$7b=q,e.$8b=V,e.$9b=ce,e.$_b=se;function P(W,H=0){return W[W.length-(1+H)]}function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}function A(W,H,J=(X,Z)=>X===Z){if(W===H)return!0;if(!W||!H||W.length!==H.length)return!1;for(let X=0,Z=W.length;X<Z;X++)if(!J(W[X],H[X]))return!1;return!0}function I(W,H){const J=W.length-1;H<J&&(W[H]=W[J]),W.pop()}function b(W,H,J){return a(W.length,X=>J(W[X],H))}function a(W,H){let J=0,X=W-1;for(;J<=X;){const Z=(J+X)/2|0,ie=H(Z);if(ie<0)J=Z+1;else if(ie>0)X=Z-1;else return Z}return-(J+1)}function f(W,H,J){if(W=W|0,W>=H.length)throw new TypeError("invalid index");const X=H[Math.floor(H.length*Math.random())],Z=[],ie=[],de=[];for(const me of H){const we=J(me,X);we<0?Z.push(me):we>0?ie.push(me):de.push(me)}return W<Z.length?f(W,Z,J):W<Z.length+de.length?de[0]:f(W-(Z.length+de.length),ie,J)}function d(W,H){const J=[];let X;for(const Z of W.slice(0).sort(H))!X||H(X[0],Z)!==0?(X=[Z],J.push(X)):X.push(Z);return J}function*g(W,H){let J,X;for(const Z of W)X!==void 0&&H(X,Z)?J.push(Z):(J&&(yield J),J=[Z]),X=Z;J&&(yield J)}function w(W,H){for(let J=0;J<=W.length;J++)H(J===0?void 0:W[J-1],J===W.length?void 0:W[J])}function h(W,H){for(let J=0;J<W.length;J++)H(J===0?void 0:W[J-1],W[J],J+1===W.length?void 0:W[J+1])}function p(W,H,J){const X=[];function Z(me,we,Oe){if(we===0&&Oe.length===0)return;const Se=X[X.length-1];Se&&Se.start+Se.deleteCount===me?(Se.deleteCount+=we,Se.toInsert.push(...Oe)):X.push({start:me,deleteCount:we,toInsert:Oe})}let ie=0,de=0;for(;;){if(ie===W.length){Z(ie,0,H.slice(de));break}if(de===H.length){Z(ie,W.length-ie,[]);break}const me=W[ie],we=H[de],Oe=J(me,we);Oe===0?(ie+=1,de+=1):Oe<0?(Z(ie,1,[]),ie+=1):Oe>0&&(Z(ie,0,[we]),de+=1)}return X}function y(W,H,J){const X=p(W,H,J),Z=[],ie=[];for(const de of X)Z.push(...W.slice(de.start,de.start+de.deleteCount)),ie.push(...de.toInsert);return{removed:Z,added:ie}}function $(W,H,J){if(J===0)return[];const X=W.slice(0,J).sort(H);return E(W,H,X,J,W.length),X}function m(W,H,J,X,Z){return J===0?Promise.resolve([]):new Promise((ie,de)=>{(async()=>{const me=W.length,we=W.slice(0,J).sort(H);for(let Oe=J,Se=Math.min(J+X,me);Oe<me;Oe=Se,Se=Math.min(Se+X,me)){if(Oe>J&&await new Promise(ke=>setTimeout(ke)),Z&&Z.isCancellationRequested)throw new n.$7;E(W,H,we,Oe,Se)}return we})().then(ie,de)})}function E(W,H,J,X,Z){for(const ie=J.length;X<Z;X++){const de=W[X];if(H(de,J[ie-1])<0){J.pop();const me=(0,o.$mb)(J,we=>H(de,we)<0);J.splice(me,0,de)}}}function k(W){return W.filter(H=>!!H)}function t(W){let H=0;for(let J=0;J<W.length;J++)W[J]&&(W[H]=W[J],H+=1);W.length=H}function r(W,H,J){W.splice(J,0,W.splice(H,1)[0])}function i(W){return!Array.isArray(W)||W.length===0}function c(W){return Array.isArray(W)&&W.length>0}function s(W,H=J=>J){const J=new Set;return W.filter(X=>{const Z=H(X);return J.has(Z)?!1:(J.add(Z),!0)})}function u(W){const H=new Set;return J=>{const X=W(J);return H.has(X)?!1:(H.add(X),!0)}}function l(W,H){return W.length>0?W[0]:H}function S(W,H){return W.length>0?W[W.length-1]:H}function v(W,H,J=(X,Z)=>X===Z){let X=0;for(let Z=0,ie=Math.min(W.length,H.length);Z<ie&&J(W[Z],H[Z]);Z++)X++;return X}function R(W,H){let J=typeof H=="number"?W:0;typeof H=="number"?J=W:(J=0,H=W);const X=[];if(J<=H)for(let Z=J;Z<H;Z++)X.push(Z);else for(let Z=J;Z>H;Z--)X.push(Z);return X}function T(W,H,J){return W.reduce((X,Z)=>(X[H(Z)]=J?J(Z):Z,X),Object.create(null))}function L(W,H){return W.push(H),()=>O(W,H)}function O(W,H){const J=W.indexOf(H);if(J>-1)return W.splice(J,1),H}function F(W,H,J){const X=W.slice(0,H),Z=W.slice(H);return X.concat(J,Z)}function B(W,H){let J;if(typeof H=="number"){let X=H;J=()=>{const Z=Math.sin(X++)*179426549;return Z-Math.floor(Z)}}else J=Math.random;for(let X=W.length-1;X>0;X-=1){const Z=Math.floor(J()*(X+1)),ie=W[X];W[X]=W[Z],W[Z]=ie}}function C(W,H){const J=W.indexOf(H);J>-1&&(W.splice(J,1),W.unshift(H))}function z(W,H){const J=W.indexOf(H);J>-1&&(W.splice(J,1),W.push(H))}function re(W,H){for(const J of H)W.push(J)}function Q(W,H){return Array.isArray(W)?W.map(H):H(W)}function le(W){return Array.isArray(W)?W:[W]}function K(W){return W[Math.floor(Math.random()*W.length)]}function ee(W,H,J){const X=j(W,H),Z=W.length,ie=J.length;W.length=Z+ie;for(let de=Z-1;de>=X;de--)W[de+ie]=W[de];for(let de=0;de<ie;de++)W[de+X]=J[de]}function q(W,H,J,X){const Z=j(W,H);let ie=W.splice(Z,J);return ie===void 0&&(ie=[]),ee(W,Z,X),ie}function j(W,H){return H<0?Math.max(H+W.length,0):Math.min(H,W.length)}var U;(function(W){function H(ie){return ie<0}W.isLessThan=H;function J(ie){return ie<=0}W.isLessThanOrEqual=J;function X(ie){return ie>0}W.isGreaterThan=X;function Z(ie){return ie===0}W.isNeitherLessOrGreaterThan=Z,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(U||(e.CompareResult=U={}));function V(W,H){return(J,X)=>H(W(J),W(X))}function ce(...W){return(H,J)=>{for(const X of W){const Z=X(H,J);if(!U.isNeitherLessOrGreaterThan(Z))return Z}return U.neitherLessOrGreaterThan}}const G=(W,H)=>W-H;e.$0b=G;const he=(W,H)=>(0,e.$0b)(W?1:0,H?1:0);e.$$b=he;function se(W){return(H,J)=>-W(H,J)}class _{constructor(H){this.g=H,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(H){let J=this.c;for(;J<this.g.length&&H(this.g[J]);)J++;const X=J===this.c?null:this.g.slice(this.c,J);return this.c=J,X}takeFromEndWhile(H){let J=this.d;for(;J>=0&&H(this.g[J]);)J--;const X=J===this.d?null:this.g.slice(J+1,this.d+1);return this.d=J,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const H=this.g[this.c];return this.c++,H}removeLast(){const H=this.g[this.d];return this.d--,H}takeCount(H){const J=this.g.slice(this.c,this.c+H);return this.c+=H,J}}e.$ac=_;class M{static{this.empty=new M(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(J=>(H(J),!0))}toArray(){const H=[];return this.iterate(J=>(H.push(J),!0)),H}filter(H){return new M(J=>this.iterate(X=>H(X)?J(X):!0))}map(H){return new M(J=>this.iterate(X=>J(H(X))))}some(H){let J=!1;return this.iterate(X=>(J=H(X),!J)),J}findFirst(H){let J;return this.iterate(X=>H(X)?(J=X,!1):!0),J}findLast(H){let J;return this.iterate(X=>(H(X)&&(J=X),!0)),J}findLastMaxBy(H){let J,X=!0;return this.iterate(Z=>((X||U.isGreaterThan(H(Z,J)))&&(X=!1,J=Z),!0)),J}}e.$bc=M;class N{constructor(H){this.c=H}static createSortPermutation(H,J){const X=Array.from(H.keys()).sort((Z,ie)=>J(H[Z],H[ie]));return new N(X)}apply(H){return H.map((J,X)=>H[this.c[X]])}inverse(){const H=this.c.slice();for(let J=0;J<this.c.length;J++)H[this.c[J]]=J;return new N(H)}}e.$cc=N}),define(oe[141],ae([0,1,16]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=o,e.$gd=P,e.$hd=D,e.$id=A,e.$jd=I,e.$kd=b;function o(a,f){if(!a)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function P(a,f="Unreachable"){throw new Error(f)}function D(a,f="unexpected state"){if(!a)throw new n.$eb(`Assertion Failed: ${f}`)}function A(a){a||(0,n.$3)(new n.$eb("Soft Assertion Failed"))}function I(a){if(!a()){debugger;a(),(0,n.$3)(new n.$eb("Assertion Failed"))}}function b(a,f){let d=0;for(;d<a.length-1;){const g=a[d],w=a[d+1];if(!f(g,w))return!1;d++}return!0}}),define(oe[90],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=n;function n(o,P){const D=this;let A=!1,I;return function(){if(A)return I;if(A=!0,P)try{I=o.apply(D,arguments)}finally{P()}else I=o.apply(D,arguments);return I}}}),define(oe[78],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(o){function P(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}o.is=P;const D=Object.freeze([]);function A(){return D}o.empty=A;function*I(i){yield i}o.single=I;function b(i){return P(i)?i:I(i)}o.wrap=b;function a(i){return i||D}o.from=a;function*f(i){for(let c=i.length-1;c>=0;c--)yield i[c]}o.reverse=f;function d(i){return!i||i[Symbol.iterator]().next().done===!0}o.isEmpty=d;function g(i){return i[Symbol.iterator]().next().value}o.first=g;function w(i,c){let s=0;for(const u of i)if(c(u,s++))return!0;return!1}o.some=w;function h(i,c){for(const s of i)if(c(s))return s}o.find=h;function*p(i,c){for(const s of i)c(s)&&(yield s)}o.filter=p;function*y(i,c){let s=0;for(const u of i)yield c(u,s++)}o.map=y;function*$(i,c){let s=0;for(const u of i)yield*c(u,s++)}o.flatMap=$;function*m(...i){for(const c of i)yield*c}o.concat=m;function E(i,c,s){let u=s;for(const l of i)u=c(u,l);return u}o.reduce=E;function*k(i,c,s=i.length){for(c<0&&(c+=i.length),s<0?s+=i.length:s>i.length&&(s=i.length);c<s;c++)yield i[c]}o.slice=k;function t(i,c=Number.POSITIVE_INFINITY){const s=[];if(c===0)return[s,i];const u=i[Symbol.iterator]();for(let l=0;l<c;l++){const S=u.next();if(S.done)return[s,o.empty()];s.push(S.value)}return[s,{[Symbol.iterator](){return u}}]}o.consume=t;async function r(i){const c=[];for await(const s of i)c.push(s);return Promise.resolve(c)}o.asyncToArray=r})(n||(e.Iterable=n={}))}),define(oe[43],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Vn=A,e.$Wn=d,e.$Xn=g,e.$Yn=w,e.$Zn=h,e.$1n=p,e.$2n=y,e.$3n=$,e.$4n=m,e.$5n=E,e.$6n=k;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var o;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(o||(e.SyntaxKind=o={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D||(e.ParseOptions=D={}));function A(t,r=!1){let i=0;const c=t.length;let s="",u=0,l=o.Unknown,S=n.None;function v(C){let z=0,re=0;for(;z<C;){const Q=t.charCodeAt(i);if(Q>=f._0&&Q<=f._9)re=re*16+Q-f._0;else if(Q>=f.A&&Q<=f.F)re=re*16+Q-f.A+10;else if(Q>=f.a&&Q<=f.f)re=re*16+Q-f.a+10;else break;i++,z++}return z<C&&(re=-1),re}function R(C){i=C,s="",u=0,l=o.Unknown,S=n.None}function T(){const C=i;if(t.charCodeAt(i)===f._0)i++;else for(i++;i<t.length&&a(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===f.dot)if(i++,i<t.length&&a(t.charCodeAt(i)))for(i++;i<t.length&&a(t.charCodeAt(i));)i++;else return S=n.UnexpectedEndOfNumber,t.substring(C,i);let z=i;if(i<t.length&&(t.charCodeAt(i)===f.E||t.charCodeAt(i)===f.e))if(i++,(i<t.length&&t.charCodeAt(i)===f.plus||t.charCodeAt(i)===f.minus)&&i++,i<t.length&&a(t.charCodeAt(i))){for(i++;i<t.length&&a(t.charCodeAt(i));)i++;z=i}else S=n.UnexpectedEndOfNumber;return t.substring(C,z)}function L(){let C="",z=i;for(;;){if(i>=c){C+=t.substring(z,i),S=n.UnexpectedEndOfString;break}const re=t.charCodeAt(i);if(re===f.doubleQuote){C+=t.substring(z,i),i++;break}if(re===f.backslash){if(C+=t.substring(z,i),i++,i>=c){S=n.UnexpectedEndOfString;break}switch(t.charCodeAt(i++)){case f.doubleQuote:C+='"';break;case f.backslash:C+="\\";break;case f.slash:C+="/";break;case f.b:C+="\b";break;case f.f:C+="\f";break;case f.n:C+=`
`;break;case f.r:C+="\r";break;case f.t:C+="	";break;case f.u:{const le=v(4);le>=0?C+=String.fromCharCode(le):S=n.InvalidUnicode;break}default:S=n.InvalidEscapeCharacter}z=i;continue}if(re>=0&&re<=31)if(b(re)){C+=t.substring(z,i),S=n.UnexpectedEndOfString;break}else S=n.InvalidCharacter;i++}return C}function O(){if(s="",S=n.None,u=i,i>=c)return u=c,l=o.EOF;let C=t.charCodeAt(i);if(I(C)){do i++,s+=String.fromCharCode(C),C=t.charCodeAt(i);while(I(C));return l=o.Trivia}if(b(C))return i++,s+=String.fromCharCode(C),C===f.carriageReturn&&t.charCodeAt(i)===f.lineFeed&&(i++,s+=`
`),l=o.LineBreakTrivia;switch(C){case f.openBrace:return i++,l=o.OpenBraceToken;case f.closeBrace:return i++,l=o.CloseBraceToken;case f.openBracket:return i++,l=o.OpenBracketToken;case f.closeBracket:return i++,l=o.CloseBracketToken;case f.colon:return i++,l=o.ColonToken;case f.comma:return i++,l=o.CommaToken;case f.doubleQuote:return i++,s=L(),l=o.StringLiteral;case f.slash:{const z=i-1;if(t.charCodeAt(i+1)===f.slash){for(i+=2;i<c&&!b(t.charCodeAt(i));)i++;return s=t.substring(z,i),l=o.LineCommentTrivia}if(t.charCodeAt(i+1)===f.asterisk){i+=2;const re=c-1;let Q=!1;for(;i<re;){if(t.charCodeAt(i)===f.asterisk&&t.charCodeAt(i+1)===f.slash){i+=2,Q=!0;break}i++}return Q||(i++,S=n.UnexpectedEndOfComment),s=t.substring(z,i),l=o.BlockCommentTrivia}return s+=String.fromCharCode(C),i++,l=o.Unknown}case f.minus:if(s+=String.fromCharCode(C),i++,i===c||!a(t.charCodeAt(i)))return l=o.Unknown;case f._0:case f._1:case f._2:case f._3:case f._4:case f._5:case f._6:case f._7:case f._8:case f._9:return s+=T(),l=o.NumericLiteral;default:for(;i<c&&F(C);)i++,C=t.charCodeAt(i);if(u!==i){switch(s=t.substring(u,i),s){case"true":return l=o.TrueKeyword;case"false":return l=o.FalseKeyword;case"null":return l=o.NullKeyword}return l=o.Unknown}return s+=String.fromCharCode(C),i++,l=o.Unknown}}function F(C){if(I(C)||b(C))return!1;switch(C){case f.closeBrace:case f.closeBracket:case f.openBrace:case f.openBracket:case f.doubleQuote:case f.colon:case f.comma:case f.slash:return!1}return!0}function B(){let C;do C=O();while(C>=o.LineCommentTrivia&&C<=o.Trivia);return C}return{setPosition:R,getPosition:()=>i,scan:r?B:O,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>i-u,getTokenError:()=>S}}function I(t){return t===f.space||t===f.tab||t===f.verticalTab||t===f.formFeed||t===f.nonBreakingSpace||t===f.ogham||t>=f.enQuad&&t<=f.zeroWidthSpace||t===f.narrowNoBreakSpace||t===f.mathematicalSpace||t===f.ideographicSpace||t===f.byteOrderMark}function b(t){return t===f.lineFeed||t===f.carriageReturn||t===f.lineSeparator||t===f.paragraphSeparator}function a(t){return t>=f._0&&t<=f._9}var f;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(f||(f={}));function d(t,r){const i=[],c=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function S(v,R,T,L){u.value=v,u.offset=R,u.length=T,u.type=L,u.colonOffset=void 0,s=u}try{E(t,{onObjectBegin:(v,R)=>{if(r<=v)throw c;s=void 0,l=r>v,i.push("")},onObjectProperty:(v,R,T)=>{if(r<R||(S(v,R,T,"property"),i[i.length-1]=v,r<=R+T))throw c},onObjectEnd:(v,R)=>{if(r<=v)throw c;s=void 0,i.pop()},onArrayBegin:(v,R)=>{if(r<=v)throw c;s=void 0,i.push(0)},onArrayEnd:(v,R)=>{if(r<=v)throw c;s=void 0,i.pop()},onLiteralValue:(v,R,T)=>{if(r<R||(S(v,R,T,k(v)),r<=R+T))throw c},onSeparator:(v,R,T)=>{if(r<=R)throw c;if(v===":"&&s&&s.type==="property")s.colonOffset=R,l=!1,s=void 0;else if(v===","){const L=i[i.length-1];typeof L=="number"?i[i.length-1]=L+1:(l=!0,i[i.length-1]=""),s=void 0}}})}catch(v){if(v!==c)throw v}return{path:i,previousNode:s,isAtPropertyKey:l,matches:v=>{let R=0;for(let T=0;R<v.length&&T<i.length;T++)if(v[R]===i[T]||v[R]==="*")R++;else if(v[R]!=="**")return!1;return R===v.length}}}function g(t,r=[],i=D.DEFAULT){let c=null,s=[];const u=[];function l(v){Array.isArray(s)?s.push(v):c!==null&&(s[c]=v)}return E(t,{onObjectBegin:()=>{const v={};l(v),u.push(s),s=v,c=null},onObjectProperty:v=>{c=v},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const v=[];l(v),u.push(s),s=v,c=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:l,onError:(v,R,T)=>{r.push({error:v,offset:R,length:T})}},i),s[0]}function w(t,r=[],i=D.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(v){c.type==="property"&&(c.length=v-c.offset,c=c.parent)}function u(v){return c.children.push(v),v}E(t,{onObjectBegin:v=>{c=u({type:"object",offset:v,length:-1,parent:c,children:[]})},onObjectProperty:(v,R,T)=>{c=u({type:"property",offset:R,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:v,offset:R,length:T,parent:c})},onObjectEnd:(v,R)=>{c.length=v+R-c.offset,c=c.parent,s(v+R)},onArrayBegin:(v,R)=>{c=u({type:"array",offset:v,length:-1,parent:c,children:[]})},onArrayEnd:(v,R)=>{c.length=v+R-c.offset,c=c.parent,s(v+R)},onLiteralValue:(v,R,T)=>{u({type:k(v),offset:R,length:T,parent:c,value:v}),s(R+T)},onSeparator:(v,R,T)=>{c.type==="property"&&(v===":"?c.colonOffset=R:v===","&&s(R))},onError:(v,R,T)=>{r.push({error:v,offset:R,length:T})}},i);const S=c.children[0];return S&&delete S.parent,S}function h(t,r){if(!t)return;let i=t;for(const c of r)if(typeof c=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const u of i.children)if(Array.isArray(u.children)&&u.children[0].value===c){i=u.children[1],s=!0;break}if(!s)return}else{const s=c;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}function p(t){if(!t.parent||!t.parent.children)return[];const r=p(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}function y(t){switch(t.type){case"array":return t.children.map(y);case"object":{const r=Object.create(null);for(const i of t.children){const c=i.children[1];c&&(r[i.children[0].value]=y(c))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}function m(t,r,i=!1){if($(t,r,i)){const c=t.children;if(Array.isArray(c))for(let s=0;s<c.length&&c[s].offset<=r;s++){const u=m(c[s],r,i);if(u)return u}return t}}function E(t,r,i=D.DEFAULT){const c=A(t,!1);function s(V){return V?()=>V(c.getTokenOffset(),c.getTokenLength()):()=>!0}function u(V){return V?ce=>V(ce,c.getTokenOffset(),c.getTokenLength()):()=>!0}const l=s(r.onObjectBegin),S=u(r.onObjectProperty),v=s(r.onObjectEnd),R=s(r.onArrayBegin),T=s(r.onArrayEnd),L=u(r.onLiteralValue),O=u(r.onSeparator),F=s(r.onComment),B=u(r.onError),C=i&&i.disallowComments,z=i&&i.allowTrailingComma;function re(){for(;;){const V=c.scan();switch(c.getTokenError()){case n.InvalidUnicode:Q(P.InvalidUnicode);break;case n.InvalidEscapeCharacter:Q(P.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:Q(P.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:C||Q(P.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:Q(P.UnexpectedEndOfString);break;case n.InvalidCharacter:Q(P.InvalidCharacter);break}switch(V){case o.LineCommentTrivia:case o.BlockCommentTrivia:C?Q(P.InvalidCommentToken):F();break;case o.Unknown:Q(P.InvalidSymbol);break;case o.Trivia:case o.LineBreakTrivia:break;default:return V}}}function Q(V,ce=[],G=[]){if(B(V),ce.length+G.length>0){let he=c.getToken();for(;he!==o.EOF;){if(ce.indexOf(he)!==-1){re();break}else if(G.indexOf(he)!==-1)break;he=re()}}}function le(V){const ce=c.getTokenValue();return V?L(ce):S(ce),re(),!0}function K(){switch(c.getToken()){case o.NumericLiteral:{let V=0;try{V=JSON.parse(c.getTokenValue()),typeof V!="number"&&(Q(P.InvalidNumberFormat),V=0)}catch{Q(P.InvalidNumberFormat)}L(V);break}case o.NullKeyword:L(null);break;case o.TrueKeyword:L(!0);break;case o.FalseKeyword:L(!1);break;default:return!1}return re(),!0}function ee(){return c.getToken()!==o.StringLiteral?(Q(P.PropertyNameExpected,[],[o.CloseBraceToken,o.CommaToken]),!1):(le(!1),c.getToken()===o.ColonToken?(O(":"),re(),U()||Q(P.ValueExpected,[],[o.CloseBraceToken,o.CommaToken])):Q(P.ColonExpected,[],[o.CloseBraceToken,o.CommaToken]),!0)}function q(){l(),re();let V=!1;for(;c.getToken()!==o.CloseBraceToken&&c.getToken()!==o.EOF;){if(c.getToken()===o.CommaToken){if(V||Q(P.ValueExpected,[],[]),O(","),re(),c.getToken()===o.CloseBraceToken&&z)break}else V&&Q(P.CommaExpected,[],[]);ee()||Q(P.ValueExpected,[],[o.CloseBraceToken,o.CommaToken]),V=!0}return v(),c.getToken()!==o.CloseBraceToken?Q(P.CloseBraceExpected,[o.CloseBraceToken],[]):re(),!0}function j(){R(),re();let V=!1;for(;c.getToken()!==o.CloseBracketToken&&c.getToken()!==o.EOF;){if(c.getToken()===o.CommaToken){if(V||Q(P.ValueExpected,[],[]),O(","),re(),c.getToken()===o.CloseBracketToken&&z)break}else V&&Q(P.CommaExpected,[],[]);U()||Q(P.ValueExpected,[],[o.CloseBracketToken,o.CommaToken]),V=!0}return T(),c.getToken()!==o.CloseBracketToken?Q(P.CloseBracketExpected,[o.CloseBracketToken],[]):re(),!0}function U(){switch(c.getToken()){case o.OpenBracketToken:return j();case o.OpenBraceToken:return q();case o.StringLiteral:return le(!0);default:return K()}}return re(),c.getToken()===o.EOF?i.allowEmptyContent?!0:(Q(P.ValueExpected,[],[]),!1):U()?(c.getToken()!==o.EOF&&Q(P.EndOfFileExpected,[],[]),!0):(Q(P.ValueExpected,[],[]),!1)}function k(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(oe[142],ae([0,1,43]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=o,e.$8n=P,e.$9n=I,e.$0n=b;function o(a,f,d){let g,w,h,p,y;if(f){for(p=f.offset,y=p+f.length,h=p;h>0&&!b(a,h-1);)h--;let S=y;for(;S<a.length&&!b(a,S);)S++;w=a.substring(h,S),g=A(w,d)}else w=a,g=0,h=0,p=0,y=a.length;const $=I(d,a);let m=!1,E=0,k;d.insertSpaces?k=D(" ",d.tabSize||4):k="	";const t=(0,n.$Vn)(w,!1);let r=!1;function i(){return $+D(k,g+E)}function c(){let S=t.scan();for(m=!1;S===n.SyntaxKind.Trivia||S===n.SyntaxKind.LineBreakTrivia;)m=m||S===n.SyntaxKind.LineBreakTrivia,S=t.scan();return r=S===n.SyntaxKind.Unknown||t.getTokenError()!==n.ScanError.None,S}const s=[];function u(S,v,R){!r&&v<y&&R>p&&a.substring(v,R)!==S&&s.push({offset:v,length:R-v,content:S})}let l=c();if(l!==n.SyntaxKind.EOF){const S=t.getTokenOffset()+h,v=D(k,g);u(v,h,S)}for(;l!==n.SyntaxKind.EOF;){let S=t.getTokenOffset()+t.getTokenLength()+h,v=c(),R="";for(;!m&&(v===n.SyntaxKind.LineCommentTrivia||v===n.SyntaxKind.BlockCommentTrivia);){const L=t.getTokenOffset()+h;u(" ",S,L),S=t.getTokenOffset()+t.getTokenLength()+h,R=v===n.SyntaxKind.LineCommentTrivia?i():"",v=c()}if(v===n.SyntaxKind.CloseBraceToken)l!==n.SyntaxKind.OpenBraceToken&&(E--,R=i());else if(v===n.SyntaxKind.CloseBracketToken)l!==n.SyntaxKind.OpenBracketToken&&(E--,R=i());else{switch(l){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:E++,R=i();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:R=i();break;case n.SyntaxKind.BlockCommentTrivia:m?R=i():R=" ";break;case n.SyntaxKind.ColonToken:R=" ";break;case n.SyntaxKind.StringLiteral:if(v===n.SyntaxKind.ColonToken){R="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:v===n.SyntaxKind.LineCommentTrivia||v===n.SyntaxKind.BlockCommentTrivia?R=" ":v!==n.SyntaxKind.CommaToken&&v!==n.SyntaxKind.EOF&&(r=!0);break;case n.SyntaxKind.Unknown:r=!0;break}m&&(v===n.SyntaxKind.LineCommentTrivia||v===n.SyntaxKind.BlockCommentTrivia)&&(R=i())}const T=t.getTokenOffset()+h;u(R,S,T),l=v}return s}function P(a,f){const d=JSON.stringify(a,void 0,f.insertSpaces?f.tabSize||4:"	");return f.eol!==void 0?d.replace(/\r\n|\r|\n/g,f.eol):d}function D(a,f){let d="";for(let g=0;g<f;g++)d+=a;return d}function A(a,f){let d=0,g=0;const w=f.tabSize||4;for(;d<a.length;){const h=a.charAt(d);if(h===" ")g++;else if(h==="	")g+=w;else break;d++}return Math.floor(g/w)}function I(a,f){for(let d=0;d<f.length;d++){const g=f.charAt(d);if(g==="\r")return d+1<f.length&&f.charAt(d+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return a&&a.eol||`
`}function b(a,f){return`\r
`.indexOf(a.charAt(f))!==-1}}),define(oe[108],ae([0,1,43,142]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=P,e.$_n=D,e.$ao=A,e.$bo=I,e.$co=b;function P(a,f,d){return D(a,f,void 0,d)}function D(a,f,d,g,w){const h=f.slice(),p=[],y=(0,n.$Yn)(a,p);let $,m;for(;h.length>0&&(m=h.pop(),$=(0,n.$Zn)(y,h),$===void 0&&d!==void 0);)typeof m=="string"?d={[m]:d}:d=[d];if($)if($.type==="object"&&typeof m=="string"&&Array.isArray($.children)){const E=(0,n.$Zn)($,[m]);if(E!==void 0)if(d===void 0){if(!E.parent)throw new Error("Malformed AST");const k=$.children.indexOf(E.parent);let t,r=E.parent.offset+E.parent.length;if(k>0){const i=$.children[k-1];t=i.offset+i.length}else t=$.offset+1,$.children.length>1&&(r=$.children[1].offset);return A(a,{offset:t,length:r-t,content:""},g)}else return A(a,{offset:E.offset,length:E.length,content:JSON.stringify(d)},g);else{if(d===void 0)return[];const k=`${JSON.stringify(m)}: ${JSON.stringify(d)}`,t=w?w($.children.map(i=>i.children[0].value)):$.children.length;let r;if(t>0){const i=$.children[t-1];r={offset:i.offset+i.length,length:0,content:","+k}}else $.children.length===0?r={offset:$.offset+1,length:0,content:k}:r={offset:$.offset+1,length:0,content:k+","};return A(a,r,g)}}else if($.type==="array"&&typeof m=="number"&&Array.isArray($.children))if(d!==void 0){const E=`${JSON.stringify(d)}`;let k;if($.children.length===0||m===0)k={offset:$.offset+1,length:0,content:$.children.length===0?E:E+","};else{const t=m===-1||m>$.children.length?$.children.length:m,r=$.children[t-1];k={offset:r.offset+r.length,length:0,content:","+E}}return A(a,k,g)}else{const E=m,k=$.children[E];let t;if($.children.length===1)t={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===E){const r=$.children[E-1],i=r.offset+r.length,c=$.offset+$.length;t={offset:i,length:c-2-i,content:""}}else t={offset:k.offset,length:$.children[E+1].offset-k.offset,content:""};return A(a,t,g)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${$.type}`);else return d===void 0?[]:A(a,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(d)},g)}function A(a,f,d){let g=I(a,f),w=f.offset,h=f.offset+f.content.length;if(f.length===0||f.content.length===0){for(;w>0&&!(0,o.$0n)(g,w-1);)w--;for(;h<g.length&&!(0,o.$0n)(g,h);)h++}const p=(0,o.$7n)(g,{offset:w,length:h-w},d);for(let $=p.length-1;$>=0;$--){const m=p[$];g=I(g,m),w=Math.min(w,m.offset),h=Math.max(h,m.offset+m.length),h+=m.content.length-m.length}const y=a.length-(g.length-h)-w;return[{offset:w,length:y,content:g.substring(w,h)}]}function I(a,f){return a.substring(0,f.offset)+f.content+a.substring(f.offset+f.length)}function b(a,f){const d=f.slice(0).sort((w,h)=>{const p=w.offset-h.offset;return p===0?w.length-h.length:p});let g=a.length;for(let w=d.length-1;w>=0;w--){const h=d[w];if(h.offset+h.length<=g)a=I(a,h);else throw new Error("Overlapping edit");g=h.offset}return a}}),function(){function x(e,n,o,P){const D=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function A(b){return b.replace(D,function(a,f,d,g,w,h){if(g)return"";if(w){const p=w.length;return w[p-1]===`
`?w[p-2]==="\r"?`\r
`:`
`:""}else return h?a.substring(1):a})}function I(b){const a=A(b);try{return JSON.parse(a)}catch{const d=a.replace(/,\s*([}\]])/g,"$1");return JSON.parse(d)}}return{stripComments:A,parse:I}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return x()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=x():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[66],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class n{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=n}),define(oe[109],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(D){this.element=D,this.next=n.Undefined,this.prev=n.Undefined}}class o{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let D=this.a;for(;D!==n.Undefined;){const A=D.next;D.prev=n.Undefined,D.next=n.Undefined,D=A}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,A){const I=new n(D);if(this.a===n.Undefined)this.a=I,this.b=I;else if(A){const a=this.b;this.b=I,I.prev=a,a.next=I}else{const a=this.a;this.a=I,I.next=a,a.prev=I}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(I))}}shift(){if(this.a!==n.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==n.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==n.Undefined&&D.next!==n.Undefined){const A=D.prev;A.next=D.next,D.next.prev=A}else D.prev===n.Undefined&&D.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):D.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):D.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==n.Undefined;)yield D.element,D=D.next}}e.$7c=o}),define(oe[32],ae([0,1]),function(x,e){"use strict";var n,o,P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.Touch=e.$Dc=e.$Cc=void 0,e.$zc=D,e.$Ac=A,e.$Bc=I,e.$Kc=k;function D(t,r,i){let c=t.get(r);return c===void 0&&(c=i,t.set(r,c)),c}function A(t){const r=[];return t.forEach((i,c)=>{r.push(`${c} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}function I(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}class b{constructor(r,i){this.uri=r,this.value=i}}function a(t){return Array.isArray(t)}class f{static{this.c=r=>r.toString()}constructor(r,i){if(this[n]="ResourceMap",r instanceof f)this.d=new Map(r.d),this.e=i??f.c;else if(a(r)){this.d=new Map,this.e=i??f.c;for(const[c,s]of r)this.set(c,s)}else this.d=new Map,this.e=r??f.c}set(r,i){return this.d.set(this.e(r),new b(r,i)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,i){typeof i<"u"&&(r=r.bind(i));for(const[c,s]of this.d)r(s.value,s.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Cc=f;class d{constructor(r,i){this[o]="ResourceSet",!r||typeof r=="function"?this.c=new f(r):(this.c=new f(i),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,i){this.c.forEach((c,s)=>r.call(i,s,s,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(o=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Dc=d;var g;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class w{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,i=g.None){const c=this.c.get(r);if(c)return i!==g.None&&this.m(c,i),c.value}set(r,i,c=g.None){let s=this.c.get(r);if(s)s.value=i,c!==g.None&&this.m(s,c);else{switch(s={key:r,value:i,next:void 0,previous:void 0},c){case g.None:this.k(s);break;case g.AsOld:this.j(s);break;case g.AsNew:this.k(s);break;default:this.k(s);break}this.c.set(r,s),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this.c.get(r);if(i)return this.c.delete(r),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.l(r),this.f--,r.value}forEach(r,i){const c=this.g;let s=this.d;for(;s;){if(i?r.bind(i)(s.value,s.key,this):r(s.value,s.key,this),this.g!==c)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const r=this,i=this.g;let c=this.d;const s={[Symbol.iterator](){return s},next(){if(r.g!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const u={value:c.key,done:!1};return c=c.next,u}else return{value:void 0,done:!0}}};return s}values(){const r=this,i=this.g;let c=this.d;const s={[Symbol.iterator](){return s},next(){if(r.g!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const u={value:c.value,done:!1};return c=c.next,u}else return{value:void 0,done:!0}}};return s}entries(){const r=this,i=this.g;let c=this.d;const s={[Symbol.iterator](){return s},next(){if(r.g!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const u={value:[c.key,c.value],done:!1};return c=c.next,u}else return{value:void 0,done:!0}}};return s}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this.d,c=this.size;for(;i&&c>r;)this.c.delete(i.key),i=i.next,c--;this.d=i,this.f=c,i&&(i.previous=void 0),this.g++}i(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this.e,c=this.size;for(;i&&c>r;)this.c.delete(i.key),i=i.previous,c--;this.e=i,this.f=c,i&&(i.next=void 0),this.g++}j(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}k(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}l(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const i=r.next,c=r.previous;if(!i||!c)throw new Error("Invalid list");i.previous=c,c.next=i}r.next=void 0,r.previous=void 0,this.g++}m(r,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==g.AsOld&&i!==g.AsNew)){if(i===g.AsOld){if(r===this.d)return;const c=r.next,s=r.previous;r===this.e?(s.next=void 0,this.e=s):(c.previous=s,s.next=c),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(i===g.AsNew){if(r===this.e)return;const c=r.next,s=r.previous;r===this.d?(c.previous=void 0,this.d=c):(c.previous=s,s.next=c),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((i,c)=>{r.push([c,i])}),r}fromJSON(r){this.clear();for(const[i,c]of r)this.set(i,c)}}e.$Ec=w;class h extends w{constructor(r,i=1){super(),this.n=r,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(r){this.n=r,this.p()}get ratio(){return this.o}set ratio(r){this.o=Math.min(Math.max(0,r),1),this.p()}get(r,i=g.AsNew){return super.get(r,i)}peek(r){return super.get(r,g.None)}set(r,i){return super.set(r,i,g.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class p extends h{constructor(r,i=1){super(r,i)}q(r){this.h(r)}set(r,i){return super.set(r,i),this.p(),this}}e.$Fc=p;class y extends h{constructor(r,i=1){super(r,i)}q(r){this.i(r)}set(r,i){return this.n<=this.size&&!this.has(r)&&this.q(Math.round(this.n*this.o)-1),super.set(r,i),this}}e.$Gc=y;class ${constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let i=this.c.get(r)||0;return i===0?!1:(i--,i===0?this.c.delete(r):this.c.set(r,i),!0)}has(r){return this.c.has(r)}}e.$Hc=$;class m{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[i,c]of r)this.set(i,c)}clear(){this.c.clear(),this.d.clear()}set(r,i){this.c.set(r,i),this.d.set(i,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const i=this.c.get(r);return i===void 0?!1:(this.c.delete(r),this.d.delete(i),!0)}forEach(r,i){this.c.forEach((c,s)=>{r.call(i,c,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Ic=m;class E{constructor(){this.c=new Map}add(r,i){let c=this.c.get(r);c||(c=new Set,this.c.set(r,c)),c.add(i)}delete(r,i){const c=this.c.get(r);c&&(c.delete(i),c.size===0&&this.c.delete(r))}forEach(r,i){const c=this.c.get(r);c&&c.forEach(i)}get(r){const i=this.c.get(r);return i||new Set}}e.$Jc=E;function k(t,r){if(t===r)return!0;if(t.size!==r.size)return!1;for(const[i,c]of t)if(!r.has(i)||r.get(i)!==c)return!1;for(const[i]of r)if(!t.has(i))return!1;return!0}}),define(oe[2],ae([0,1,22,139,32,90,78]),function(x,e,n,o,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Lc=void 0,e.$Mc=f,e.$Nc=d,e.$Oc=g,e.$Pc=p,e.$Qc=y,e.$Rc=$,e.$Sc=m,e.$Tc=E,e.$Uc=k,e.$5c=R;const I=!1;let b=null;class a{constructor(){this.b=new Map}static{this.a=0}c(O){let F=this.b.get(O);return F||(F={parent:null,source:null,isSingleton:!1,value:O,idx:a.a++},this.b.set(O,F)),F}trackDisposable(O){const F=this.c(O);F.source||(F.source=new Error().stack)}setParent(O,F){const B=this.c(O);B.parent=F}markAsDisposed(O){this.b.delete(O)}markAsSingleton(O){this.c(O).isSingleton=!0}f(O,F){const B=F.get(O);if(B)return B;const C=O.parent?this.f(this.c(O.parent),F):O;return F.set(O,C),C}getTrackedDisposables(){const O=new Map;return[...this.b.entries()].filter(([,B])=>B.source!==null&&!this.f(B,O).isSingleton).flatMap(([B])=>B)}computeLeakingDisposables(O=10,F){let B;if(F)B=F;else{const le=new Map,K=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,le).isSingleton);if(K.length===0)return;const ee=new Set(K.map(q=>q.value));if(B=K.filter(q=>!(q.parent&&ee.has(q.parent))),B.length===0)throw new Error("There are cyclic diposable chains!")}if(!B)return;function C(le){function K(q,j){for(;q.length>0&&j.some(U=>typeof U=="string"?U===q[0]:q[0].match(U));)q.shift()}const ee=le.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return K(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const z=new P.$Jc;for(const le of B){const K=C(le);for(let ee=0;ee<=K.length;ee++)z.add(K.slice(0,ee).join(`
`),le)}B.sort((0,n.$8b)(le=>le.idx,n.$0b));let re="",Q=0;for(const le of B.slice(0,O)){Q++;const K=C(le),ee=[];for(let q=0;q<K.length;q++){let j=K[q];j=`(shared with ${z.get(K.slice(0,q+1).join(`
`)).size}/${B.length} leaks) at ${j}`;const V=z.get(K.slice(0,q).join(`
`)),ce=(0,o.$K)([...V].map(G=>C(G)[q]),G=>G);delete ce[K[q]];for(const[G,he]of Object.entries(ce))ee.unshift(`    - stacktraces of ${he.length} other leaks continue with ${G}`);ee.unshift(j)}re+=`


==================== Leaking disposable ${Q}/${B.length}: ${le.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return B.length>O&&(re+=`


... and ${B.length-O} more leaking disposables

`),{leaks:B,details:re}}}e.$Lc=a;function f(L){b=L}if(I){const L="__is_disposable_tracked__";f(new class{trackDisposable(O){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{O[L]||console.log(F)},3e3)}setParent(O,F){if(O&&O!==r.None)try{O[L]=!0}catch{}}markAsDisposed(O){if(O&&O!==r.None)try{O[L]=!0}catch{}}markAsSingleton(O){}})}function d(L){return b?.trackDisposable(L),L}function g(L){b?.markAsDisposed(L)}function w(L,O){b?.setParent(L,O)}function h(L,O){if(b)for(const F of L)b.setParent(F,O)}function p(L){return b?.markAsSingleton(L),L}function y(L){return typeof L=="object"&&L!==null&&typeof L.dispose=="function"&&L.dispose.length===0}function $(L){if(A.Iterable.is(L)){const O=[];for(const F of L)if(F)try{F.dispose()}catch(B){O.push(B)}if(O.length===1)throw O[0];if(O.length>1)throw new AggregateError(O,"Encountered errors while disposing of store");return Array.isArray(L)?[]:L}else if(L)return L.dispose(),L}function m(L){for(const O of L)y(O)&&O.dispose();return[]}function E(...L){const O=k(()=>$(L));return h(L,O),O}function k(L){const O=d({dispose:(0,D.$fb)(()=>{g(O),L()})});return O}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,d(this)}dispose(){this.g||(g(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(O){if(!O)return O;if(O===this)throw new Error("Cannot register a disposable on itself!");return w(O,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(O),O}delete(O){if(O){if(O===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(O),O.dispose()}}deleteAndLeak(O){O&&this.f.has(O)&&(this.f.delete(O),w(O,null))}}e.$Vc=t;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,d(this),w(this.q,this)}dispose(){g(this),this.q.dispose()}B(O){if(O===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(O)}}e.$Wc=r;class i{constructor(){this.b=!1,d(this)}get value(){return this.b?void 0:this.a}set value(O){this.b||O===this.a||(this.a?.dispose(),O&&w(O,this),this.a=O)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const O=this.a;return this.a=void 0,O&&w(O,null),O}}e.$Xc=i;class c{constructor(O){this.a=new i,this.b=!1,this.a.value=O}get value(){return this.a.value}set value(O){this.b||O===this.a.value||(this.a.value=O)}dispose(){this.b=!0,this.a.dispose()}}e.$Yc=c;class s{constructor(O){this.b=O,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Zc=s;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,d(this)}set(O){let F=O;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,g(this))},this}}e.$1c=u;class l{constructor(){this.a=new Map}acquire(O,...F){let B=this.a.get(O);B||(B={counter:0,object:this.b(O,...F)},this.a.set(O,B));const{object:C}=B,z=(0,D.$fb)(()=>{--B.counter===0&&(this.c(O,B.object),this.a.delete(O))});return B.counter++,{object:C,dispose:z}}}e.$2c=l;class S{constructor(O){this.a=O}async acquire(O,...F){const B=this.a.acquire(O,...F);try{return{object:await B.object,dispose:()=>B.dispose()}}catch(C){throw B.dispose(),C}}}e.$3c=S;class v{constructor(O){this.object=O}dispose(){}}e.$4c=v;function R(L){const O=new t;try{L(O)}finally{O.dispose()}}class T{constructor(){this.a=new Map,this.b=!1,d(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(O){return this.a.has(O)}get size(){return this.a.size}get(O){return this.a.get(O)}set(O,F,B=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),B||this.a.get(O)?.dispose(),this.a.set(O,F)}deleteAndDispose(O){this.a.get(O)?.dispose(),this.a.delete(O)}deleteAndLeak(O){const F=this.a.get(O);return this.a.delete(O),F}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$6c=T}),define(oe[91],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(o){o[o.Uri=1]="Uri",o[o.Regexp=2]="Regexp",o[o.ScmResource=3]="ScmResource",o[o.ScmResourceGroup=4]="ScmResourceGroup",o[o.ScmProvider=5]="ScmProvider",o[o.CommentController=6]="CommentController",o[o.CommentThread=7]="CommentThread",o[o.CommentThreadInstance=8]="CommentThreadInstance",o[o.CommentThreadReply=9]="CommentThreadReply",o[o.CommentNode=10]="CommentNode",o[o.CommentThreadNode=11]="CommentThreadNode",o[o.TimelineActionContext=12]="TimelineActionContext",o[o.NotebookCellActionContext=13]="NotebookCellActionContext",o[o.NotebookActionContext=14]="NotebookActionContext",o[o.TerminalContext=15]="TerminalContext",o[o.TestItemContext=16]="TestItemContext",o[o.Date=17]="Date",o[o.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(oe[79],ae([0,1,32]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=void 0,e.$mm=P,e.$nm=A;const o=new n.$Fc(1e4);function P(a){return b(a,"NFC",o)}const D=new n.$Fc(1e4);function A(a){return b(a,"NFD",D)}const I=/[^\u0000-\u0080]/;function b(a,f,d){if(!a)return a;const g=d.get(a);if(g)return g;let w;return I.test(a)?w=a.normalize(f):w=a,d.set(a,w),w}e.$om=function(){const a=/[\u0300-\u036f]/g;return function(f){return A(f).replace(a,"")}}()}),define(oe[143],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=n,e.rot=o,e.$Pm=I;function n(b,a,f){return Math.min(Math.max(b,a),f)}function o(b,a){return(a+b%a)%a}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=P;class D{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=D;class A{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const f=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=A;function I(b,a,f,d,g,w,h,p){const y=h-f,$=p-d,m=g-f,E=w-d,k=b-f,t=a-d,r=y*y+$*$,i=y*m+$*E,c=y*k+$*t,s=m*m+E*E,u=m*k+E*t,l=1/(r*s-i*i),S=(s*c-i*u)*l,v=(r*u-i*c)*l;return S>=0&&v>=0&&S+v<1}}),function(){function x(P){const D=[];typeof P=="number"&&D.push("code/timeOrigin",P);function A(b){D.push(b,Date.now())}function I(){const b=[];for(let a=0;a<D.length;a+=2)b.push({name:D[a],startTime:D[a+1]});return b}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))D.push({name:A.name,startTime:Math.round(P+A.startTime)});return D}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function n(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var o;typeof global=="object"?o=global:typeof self=="object"?o=self:o={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(o)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(o):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),o.perf=n(o))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var o in n)(typeof exports=="object"?exports:x)[o]=n[o]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function n(o){if(e[o])return e[o].exports;var P=e[o]={i:o,l:!1,exports:{}};return x[o].call(P.exports,P,P.exports,n),P.l=!0,P.exports}return n.m=x,n.c=e,n.d=function(o,P,D){n.o(o,P)||Object.defineProperty(o,P,{enumerable:!0,get:D})},n.r=function(o){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(o,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(o,"__esModule",{value:!0})},n.t=function(o,P){if(1&P&&(o=n(o)),8&P||4&P&&typeof o=="object"&&o&&o.__esModule)return o;var D=Object.create(null);if(n.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:o}),2&P&&typeof o!="string")for(var A in o)n.d(D,A,function(I){return o[I]}.bind(null,A));return D},n.n=function(o){var P=o&&o.__esModule?function(){return o.default}:function(){return o};return n.d(P,"a",P),P},n.o=function(o,P){return Object.prototype.hasOwnProperty.call(o,P)},n.p="",n(n.s=0)}([function(x,e,n){(function(o){var P;e=x.exports=he,P=typeof o=="object"&&o.env&&o.env.NODE_DEBUG&&/\bsemver\b/i.test(o.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],b=e.src=[],a=0,f=a++;b[f]="0|[1-9]\\d*";var d=a++;b[d]="[0-9]+";var g=a++;b[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=a++;b[w]="("+b[f]+")\\.("+b[f]+")\\.("+b[f]+")";var h=a++;b[h]="("+b[d]+")\\.("+b[d]+")\\.("+b[d]+")";var p=a++;b[p]="(?:"+b[f]+"|"+b[g]+")";var y=a++;b[y]="(?:"+b[d]+"|"+b[g]+")";var $=a++;b[$]="(?:-("+b[p]+"(?:\\."+b[p]+")*))";var m=a++;b[m]="(?:-?("+b[y]+"(?:\\."+b[y]+")*))";var E=a++;b[E]="[0-9A-Za-z-]+";var k=a++;b[k]="(?:\\+("+b[E]+"(?:\\."+b[E]+")*))";var t=a++,r="v?"+b[w]+b[$]+"?"+b[k]+"?";b[t]="^"+r+"$";var i="[v=\\s]*"+b[h]+b[m]+"?"+b[k]+"?",c=a++;b[c]="^"+i+"$";var s=a++;b[s]="((?:<|>)?=?)";var u=a++;b[u]=b[d]+"|x|X|\\*";var l=a++;b[l]=b[f]+"|x|X|\\*";var S=a++;b[S]="[v=\\s]*("+b[l]+")(?:\\.("+b[l]+")(?:\\.("+b[l]+")(?:"+b[$]+")?"+b[k]+"?)?)?";var v=a++;b[v]="[v=\\s]*("+b[u]+")(?:\\.("+b[u]+")(?:\\.("+b[u]+")(?:"+b[m]+")?"+b[k]+"?)?)?";var R=a++;b[R]="^"+b[s]+"\\s*"+b[S]+"$";var T=a++;b[T]="^"+b[s]+"\\s*"+b[v]+"$";var L=a++;b[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=a++;b[O]="(?:~>?)";var F=a++;b[F]="(\\s*)"+b[O]+"\\s+",I[F]=new RegExp(b[F],"g");var B=a++;b[B]="^"+b[O]+b[S]+"$";var C=a++;b[C]="^"+b[O]+b[v]+"$";var z=a++;b[z]="(?:\\^)";var re=a++;b[re]="(\\s*)"+b[z]+"\\s+",I[re]=new RegExp(b[re],"g");var Q=a++;b[Q]="^"+b[z]+b[S]+"$";var le=a++;b[le]="^"+b[z]+b[v]+"$";var K=a++;b[K]="^"+b[s]+"\\s*("+i+")$|^$";var ee=a++;b[ee]="^"+b[s]+"\\s*("+r+")$|^$";var q=a++;b[q]="(\\s*)"+b[s]+"\\s*("+i+"|"+b[S]+")",I[q]=new RegExp(b[q],"g");var j=a++;b[j]="^\\s*("+b[S]+")\\s+-\\s+("+b[S]+")\\s*$";var U=a++;b[U]="^\\s*("+b[v]+")\\s+-\\s+("+b[v]+")\\s*$";var V=a++;b[V]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)P(ce,b[ce]),I[ce]||(I[ce]=new RegExp(b[ce]));function G(Y,ue){if(Y instanceof he)return Y;if(typeof Y!="string"||Y.length>D||!(ue?I[c]:I[t]).test(Y))return null;try{return new he(Y,ue)}catch{return null}}function he(Y,ue){if(Y instanceof he){if(Y.loose===ue)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof he))return new he(Y,ue);P("SemVer",Y,ue),this.loose=ue;var fe=Y.trim().match(ue?I[c]:I[t]);if(!fe)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Re=+be;if(Re>=0&&Re<A)return Re}return be}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=G,e.valid=function(Y,ue){var fe=G(Y,ue);return fe?fe.version:null},e.clean=function(Y,ue){var fe=G(Y.trim().replace(/^[=v]+/,""),ue);return fe?fe.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(Y){return P("SemVer.compare",this.version,this.loose,Y),Y instanceof he||(Y=new he(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},he.prototype.compareMain=function(Y){return Y instanceof he||(Y=new he(Y,this.loose)),_(this.major,Y.major)||_(this.minor,Y.minor)||_(this.patch,Y.patch)},he.prototype.comparePre=function(Y){if(Y instanceof he||(Y=new he(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var ue=0;do{var fe=this.prerelease[ue],be=Y.prerelease[ue];if(P("prerelease compare",ue,fe,be),fe===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(fe===void 0)return-1;if(fe!==be)return _(fe,be)}while(++ue)},he.prototype.inc=function(Y,ue){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,ue,fe,be){typeof fe=="string"&&(be=fe,fe=void 0);try{return new he(Y,fe).inc(ue,be).version}catch{return null}},e.diff=function(Y,ue){if(H(Y,ue))return null;var fe=G(Y),be=G(ue);if(fe.prerelease.length||be.prerelease.length){for(var Re in fe)if((Re==="major"||Re==="minor"||Re==="patch")&&fe[Re]!==be[Re])return"pre"+Re;return"prerelease"}for(var Re in fe)if((Re==="major"||Re==="minor"||Re==="patch")&&fe[Re]!==be[Re])return Re},e.compareIdentifiers=_;var se=/^[0-9]+$/;function _(Y,ue){var fe=se.test(Y),be=se.test(ue);return fe&&be&&(Y=+Y,ue=+ue),fe&&!be?-1:be&&!fe?1:Y<ue?-1:Y>ue?1:0}function M(Y,ue,fe){return new he(Y,fe).compare(new he(ue,fe))}function N(Y,ue,fe){return M(Y,ue,fe)>0}function W(Y,ue,fe){return M(Y,ue,fe)<0}function H(Y,ue,fe){return M(Y,ue,fe)===0}function J(Y,ue,fe){return M(Y,ue,fe)!==0}function X(Y,ue,fe){return M(Y,ue,fe)>=0}function Z(Y,ue,fe){return M(Y,ue,fe)<=0}function ie(Y,ue,fe,be){var Re;switch(ue){case"===":typeof Y=="object"&&(Y=Y.version),typeof fe=="object"&&(fe=fe.version),Re=Y===fe;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof fe=="object"&&(fe=fe.version),Re=Y!==fe;break;case"":case"=":case"==":Re=H(Y,fe,be);break;case"!=":Re=J(Y,fe,be);break;case">":Re=N(Y,fe,be);break;case">=":Re=X(Y,fe,be);break;case"<":Re=W(Y,fe,be);break;case"<=":Re=Z(Y,fe,be);break;default:throw new TypeError("Invalid operator: "+ue)}return Re}function de(Y,ue){if(Y instanceof de){if(Y.loose===ue)return Y;Y=Y.value}if(!(this instanceof de))return new de(Y,ue);P("comparator",Y,ue),this.loose=ue,this.parse(Y),this.semver===me?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(Y,ue){return _(ue,Y)},e.major=function(Y,ue){return new he(Y,ue).major},e.minor=function(Y,ue){return new he(Y,ue).minor},e.patch=function(Y,ue){return new he(Y,ue).patch},e.compare=M,e.compareLoose=function(Y,ue){return M(Y,ue,!0)},e.rcompare=function(Y,ue,fe){return M(ue,Y,fe)},e.sort=function(Y,ue){return Y.sort(function(fe,be){return e.compare(fe,be,ue)})},e.rsort=function(Y,ue){return Y.sort(function(fe,be){return e.rcompare(fe,be,ue)})},e.gt=N,e.lt=W,e.eq=H,e.neq=J,e.gte=X,e.lte=Z,e.cmp=ie,e.Comparator=de;var me={};function we(Y,ue){if(Y instanceof we)return Y.loose===ue?Y:new we(Y.raw,ue);if(Y instanceof de)return new we(Y.value,ue);if(!(this instanceof we))return new we(Y,ue);if(this.loose=ue,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Oe(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function Se(Y,ue,fe,be,Re,We,Fe,Le,Ue,Ve,Ye,He,Ke){return((ue=Oe(fe)?"":Oe(be)?">="+fe+".0.0":Oe(Re)?">="+fe+"."+be+".0":">="+ue)+" "+(Le=Oe(Ue)?"":Oe(Ve)?"<"+(+Ue+1)+".0.0":Oe(Ye)?"<"+Ue+"."+(+Ve+1)+".0":He?"<="+Ue+"."+Ve+"."+Ye+"-"+He:"<="+Le)).trim()}function ke(Y,ue){for(var fe=0;fe<Y.length;fe++)if(!Y[fe].test(ue))return!1;if(ue.prerelease.length){for(fe=0;fe<Y.length;fe++)if(P(Y[fe].semver),Y[fe].semver!==me&&Y[fe].semver.prerelease.length>0){var be=Y[fe].semver;if(be.major===ue.major&&be.minor===ue.minor&&be.patch===ue.patch)return!0}return!1}return!0}function Ie(Y,ue,fe){try{ue=new we(ue,fe)}catch{return!1}return ue.test(Y)}function $e(Y,ue,fe,be){var Re,We,Fe,Le,Ue;switch(Y=new he(Y,be),ue=new we(ue,be),fe){case">":Re=N,We=Z,Fe=W,Le=">",Ue=">=";break;case"<":Re=W,We=X,Fe=N,Le="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ie(Y,ue,be))return!1;for(var Ve=0;Ve<ue.set.length;++Ve){var Ye=ue.set[Ve],He=null,Ke=null;if(Ye.forEach(function(Xe){Xe.semver===me&&(Xe=new de(">=0.0.0")),He=He||Xe,Ke=Ke||Xe,Re(Xe.semver,He.semver,be)?He=Xe:Fe(Xe.semver,Ke.semver,be)&&(Ke=Xe)}),He.operator===Le||He.operator===Ue||(!Ke.operator||Ke.operator===Le)&&We(Y,Ke.semver)||Ke.operator===Ue&&Fe(Y,Ke.semver))return!1}return!0}de.prototype.parse=function(Y){var ue=this.loose?I[K]:I[ee],fe=Y.match(ue);if(!fe)throw new TypeError("Invalid comparator: "+Y);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new he(fe[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(Y){return P("Comparator.test",Y,this.loose),this.semver===me||(typeof Y=="string"&&(Y=new he(Y,this.loose)),ie(Y,this.operator,this.semver,this.loose))},de.prototype.intersects=function(Y,ue){if(!(Y instanceof de))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new we(Y.value,ue),Ie(this.value,fe,ue);if(Y.operator==="")return fe=new we(this.value,ue),Ie(Y.semver,fe,ue);var be=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),We=this.semver.version===Y.semver.version,Fe=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),Le=ie(this.semver,"<",Y.semver,ue)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Ue=ie(this.semver,">",Y.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return be||Re||We&&Fe||Le||Ue},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(Y){var ue=this.loose;Y=Y.trim(),P("range",Y,ue);var fe=ue?I[U]:I[j];Y=Y.replace(fe,Se),P("hyphen replace",Y),Y=Y.replace(I[q],"$1$2$3"),P("comparator trim",Y,I[q]),Y=(Y=(Y=Y.replace(I[F],"$1~")).replace(I[re],"$1^")).split(/\s+/).join(" ");var be=ue?I[K]:I[ee],Re=Y.split(" ").map(function(We){return function(Fe,Le){return P("comp",Fe),Fe=function(Ue,Ve){return Ue.trim().split(/\s+/).map(function(Ye){return function(He,Ke){P("caret",He,Ke);var Xe=Ke?I[le]:I[Q];return He.replace(Xe,function(_e,Ne,te,ge,pe){var ye;return P("caret",He,_e,Ne,te,ge,pe),Oe(Ne)?ye="":Oe(te)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":Oe(ge)?ye=Ne==="0"?">="+Ne+"."+te+".0 <"+Ne+"."+(+te+1)+".0":">="+Ne+"."+te+".0 <"+(+Ne+1)+".0.0":pe?(P("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=Ne==="0"?te==="0"?">="+Ne+"."+te+"."+ge+pe+" <"+Ne+"."+te+"."+(+ge+1):">="+Ne+"."+te+"."+ge+pe+" <"+Ne+"."+(+te+1)+".0":">="+Ne+"."+te+"."+ge+pe+" <"+(+Ne+1)+".0.0"):(P("no pr"),ye=Ne==="0"?te==="0"?">="+Ne+"."+te+"."+ge+" <"+Ne+"."+te+"."+(+ge+1):">="+Ne+"."+te+"."+ge+" <"+Ne+"."+(+te+1)+".0":">="+Ne+"."+te+"."+ge+" <"+(+Ne+1)+".0.0"),P("caret return",ye),ye})}(Ye,Ve)}).join(" ")}(Fe,Le),P("caret",Fe),Fe=function(Ue,Ve){return Ue.trim().split(/\s+/).map(function(Ye){return function(He,Ke){var Xe=Ke?I[C]:I[B];return He.replace(Xe,function(_e,Ne,te,ge,pe){var ye;return P("tilde",He,_e,Ne,te,ge,pe),Oe(Ne)?ye="":Oe(te)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":Oe(ge)?ye=">="+Ne+"."+te+".0 <"+Ne+"."+(+te+1)+".0":pe?(P("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=">="+Ne+"."+te+"."+ge+pe+" <"+Ne+"."+(+te+1)+".0"):ye=">="+Ne+"."+te+"."+ge+" <"+Ne+"."+(+te+1)+".0",P("tilde return",ye),ye})}(Ye,Ve)}).join(" ")}(Fe,Le),P("tildes",Fe),Fe=function(Ue,Ve){return P("replaceXRanges",Ue,Ve),Ue.split(/\s+/).map(function(Ye){return function(He,Ke){He=He.trim();var Xe=Ke?I[T]:I[R];return He.replace(Xe,function(_e,Ne,te,ge,pe,ye){P("xRange",He,_e,Ne,te,ge,pe,ye);var Me=Oe(te),Be=Me||Oe(ge),Je=Be||Oe(pe);return Ne==="="&&Je&&(Ne=""),Me?_e=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&Je?(Be&&(ge=0),Je&&(pe=0),Ne===">"?(Ne=">=",Be?(te=+te+1,ge=0,pe=0):Je&&(ge=+ge+1,pe=0)):Ne==="<="&&(Ne="<",Be?te=+te+1:ge=+ge+1),_e=Ne+te+"."+ge+"."+pe):Be?_e=">="+te+".0.0 <"+(+te+1)+".0.0":Je&&(_e=">="+te+"."+ge+".0 <"+te+"."+(+ge+1)+".0"),P("xRange return",_e),_e})}(Ye,Ve)}).join(" ")}(Fe,Le),P("xrange",Fe),Fe=function(Ue,Ve){return P("replaceStars",Ue,Ve),Ue.trim().replace(I[V],"")}(Fe,Le),P("stars",Fe),Fe}(We,ue)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(We){return!!We.match(be)})),Re=Re.map(function(We){return new de(We,ue)})},we.prototype.intersects=function(Y,ue){if(!(Y instanceof we))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(be){return Y.set.some(function(Re){return Re.every(function(We){return be.intersects(We,ue)})})})})},e.toComparators=function(Y,ue){return new we(Y,ue).set.map(function(fe){return fe.map(function(be){return be.value}).join(" ").trim().split(" ")})},we.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new he(Y,this.loose));for(var ue=0;ue<this.set.length;ue++)if(ke(this.set[ue],Y))return!0;return!1},e.satisfies=Ie,e.maxSatisfying=function(Y,ue,fe){var be=null,Re=null;try{var We=new we(ue,fe)}catch{return null}return Y.forEach(function(Fe){We.test(Fe)&&(be&&Re.compare(Fe)!==-1||(Re=new he(be=Fe,fe)))}),be},e.minSatisfying=function(Y,ue,fe){var be=null,Re=null;try{var We=new we(ue,fe)}catch{return null}return Y.forEach(function(Fe){We.test(Fe)&&(be&&Re.compare(Fe)!==1||(Re=new he(be=Fe,fe)))}),be},e.validRange=function(Y,ue){try{return new we(Y,ue).range||"*"}catch{return null}},e.ltr=function(Y,ue,fe){return $e(Y,ue,"<",fe)},e.gtr=function(Y,ue,fe){return $e(Y,ue,">",fe)},e.outside=$e,e.prerelease=function(Y,ue){var fe=G(Y,ue);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(Y,ue,fe){return Y=new we(Y,fe),ue=new we(ue,fe),Y.intersects(ue)},e.coerce=function(Y){if(Y instanceof he)return Y;if(typeof Y!="string")return null;var ue=Y.match(I[L]);return ue==null?null:G((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,n(1))},function(x,e){var n,o,P=x.exports={};function D(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(y){if(n===setTimeout)return setTimeout(y,0);if((n===D||!n)&&setTimeout)return n=setTimeout,setTimeout(y,0);try{return n(y,0)}catch{try{return n.call(null,y,0)}catch{return n.call(this,y,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:D}catch{n=D}try{o=typeof clearTimeout=="function"?clearTimeout:A}catch{o=A}})();var b,a=[],f=!1,d=-1;function g(){f&&b&&(f=!1,b.length?a=b.concat(a):d=-1,a.length&&w())}function w(){if(!f){var y=I(g);f=!0;for(var $=a.length;$;){for(b=a,a=[];++d<$;)b&&b[d].run();d=-1,$=a.length}b=null,f=!1,function(m){if(o===clearTimeout)return clearTimeout(m);if((o===A||!o)&&clearTimeout)return o=clearTimeout,clearTimeout(m);try{o(m)}catch{try{return o.call(null,m)}catch{return o.call(this,m)}}}(y)}}function h(y,$){this.fun=y,this.array=$}function p(){}P.nextTick=function(y){var $=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)$[m-1]=arguments[m];a.push(new h(y,$)),a.length!==1||f||I(w)},h.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=p,P.addListener=p,P.once=p,P.off=p,P.removeListener=p,P.removeAllListeners=p,P.emit=p,P.prependListener=p,P.prependOnceListener=p,P.listeners=function(y){return[]},P.binding=function(y){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(y){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(oe[144],ae([0,1]),function(x,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;class o{constructor(I,b,a){this.level=I,this.key=b,this.value=a,this.forward=[]}}const P=void 0;class D{constructor(I,b=2**16){this.comparator=I,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(b)|0),this.e=new o(this.c,P,P)}get size(){return this.f}clear(){this.e=new o(this.c,P,P),this.f=0}has(I){return!!D.g(this,I,this.comparator)}get(I){return D.g(this,I,this.comparator)?.value}set(I,b){return D.h(this,I,b,this.comparator)&&(this.f+=1),this}delete(I){const b=D.k(this,I,this.comparator);return b&&(this.f-=1),b}forEach(I,b){let a=this.e.forward[0];for(;a;)I.call(b,a.value,a.key,this),a=a.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",b=this.e.forward[0];for(;b;)I+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return I}static g(I,b,a){let f=I.e;for(let d=I.d-1;d>=0;d--)for(;f.forward[d]&&a(f.forward[d].key,b)<0;)f=f.forward[d];if(f=f.forward[0],f&&a(f.key,b)===0)return f}static h(I,b,a,f){const d=[];let g=I.e;for(let w=I.d-1;w>=0;w--){for(;g.forward[w]&&f(g.forward[w].key,b)<0;)g=g.forward[w];d[w]=g}if(g=g.forward[0],g&&f(g.key,b)===0)return g.value=a,!1;{const w=D.j(I);if(w>I.d){for(let h=I.d;h<w;h++)d[h]=I.e;I.d=w}g=new o(w,b,a);for(let h=0;h<w;h++)g.forward[h]=d[h].forward[h],d[h].forward[h]=g;return!0}}static j(I,b=.5){let a=1;for(;Math.random()<b&&a<I.c;)a+=1;return a}static k(I,b,a){const f=[];let d=I.e;for(let g=I.d-1;g>=0;g--){for(;d.forward[g]&&a(d.forward[g].key,b)<0;)d=d.forward[g];f[g]=d}if(d=d.forward[0],!d||a(d.key,b)!==0)return!1;for(let g=0;g<I.d&&f[g].forward[g]===d;g++)f[g].forward[g]=d.forward[g];for(;I.d>0&&I.e.forward[I.d-1]===P;)I.d-=1;return!0}}e.$Qs=D}),define(oe[67],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class o{static create(D){return new o(D)}constructor(D){this.c=n&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ge=o}),define(oe[4],ae([0,1,16,90,2,109,67]),function(x,e,n,o,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$ie=e.Event=void 0,e.$je=w;const I=!1,b=!1,a=!1;var f;(function(C){C.None=()=>P.$Wc.None;function z(Se){if(a){const{onDidAddListener:ke}=Se,Ie=p.create();let $e=0;Se.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ie.print()),ke?.()}}}function re(Se,ke){return G(Se,()=>{},0,void 0,!0,void 0,ke)}C.defer=re;function Q(Se){return(ke,Ie=null,$e)=>{let Y=!1,ue;return ue=Se(fe=>{if(!Y)return ue?ue.dispose():Y=!0,ke.call(Ie,fe)},null,$e),Y&&ue.dispose(),ue}}C.once=Q;function le(Se,ke,Ie){return V(($e,Y=null,ue)=>Se(fe=>$e.call(Y,ke(fe)),null,ue),Ie)}C.map=le;function K(Se,ke,Ie){return V(($e,Y=null,ue)=>Se(fe=>{ke(fe),$e.call(Y,fe)},null,ue),Ie)}C.forEach=K;function ee(Se,ke,Ie){return V(($e,Y=null,ue)=>Se(fe=>ke(fe)&&$e.call(Y,fe),null,ue),Ie)}C.filter=ee;function q(Se){return Se}C.signal=q;function j(...Se){return(ke,Ie=null,$e)=>{const Y=(0,P.$Tc)(...Se.map(ue=>ue(fe=>ke.call(Ie,fe))));return ce(Y,$e)}}C.any=j;function U(Se,ke,Ie,$e){let Y=Ie;return le(Se,ue=>(Y=ke(Y,ue),Y),$e)}C.reduce=U;function V(Se,ke){let Ie;const $e={onWillAddFirstListener(){Ie=Se(Y.fire,Y)},onDidRemoveLastListener(){Ie?.dispose()}};ke||z($e);const Y=new i($e);return ke?.add(Y),Y.event}function ce(Se,ke){return ke instanceof Array?ke.push(Se):ke&&ke.add(Se),Se}function G(Se,ke,Ie=100,$e=!1,Y=!1,ue,fe){let be,Re,We,Fe=0,Le;const Ue={leakWarningThreshold:ue,onWillAddFirstListener(){be=Se(Ye=>{Fe++,Re=ke(Re,Ye),$e&&!We&&(Ve.fire(Re),Re=void 0),Le=()=>{const He=Re;Re=void 0,We=void 0,(!$e||Fe>1)&&Ve.fire(He),Fe=0},typeof Ie=="number"?(clearTimeout(We),We=setTimeout(Le,Ie)):We===void 0&&(We=0,queueMicrotask(Le))})},onWillRemoveListener(){Y&&Fe>0&&Le?.()},onDidRemoveLastListener(){Le=void 0,be.dispose()}};fe||z(Ue);const Ve=new i(Ue);return fe?.add(Ve),Ve.event}C.debounce=G;function he(Se,ke=0,Ie){return C.debounce(Se,($e,Y)=>$e?($e.push(Y),$e):[Y],ke,void 0,!0,void 0,Ie)}C.accumulate=he;function se(Se,ke=($e,Y)=>$e===Y,Ie){let $e=!0,Y;return ee(Se,ue=>{const fe=$e||!ke(ue,Y);return $e=!1,Y=ue,fe},Ie)}C.latch=se;function _(Se,ke,Ie){return[C.filter(Se,ke,Ie),C.filter(Se,$e=>!ke($e),Ie)]}C.split=_;function M(Se,ke=!1,Ie=[],$e){let Y=Ie.slice(),ue=Se(Re=>{Y?Y.push(Re):be.fire(Re)});$e&&$e.add(ue);const fe=()=>{Y?.forEach(Re=>be.fire(Re)),Y=null},be=new i({onWillAddFirstListener(){ue||(ue=Se(Re=>be.fire(Re)),$e&&$e.add(ue))},onDidAddFirstListener(){Y&&(ke?setTimeout(fe):fe())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return $e&&$e.add(be),be.event}C.buffer=M;function N(Se,ke){return($e,Y,ue)=>{const fe=ke(new H);return Se(function(be){const Re=fe.evaluate(be);Re!==W&&$e.call(Y,Re)},void 0,ue)}}C.chain=N;const W=Symbol("HaltChainable");class H{constructor(){this.f=[]}map(ke){return this.f.push(ke),this}forEach(ke){return this.f.push(Ie=>(ke(Ie),Ie)),this}filter(ke){return this.f.push(Ie=>ke(Ie)?Ie:W),this}reduce(ke,Ie){let $e=Ie;return this.f.push(Y=>($e=ke($e,Y),$e)),this}latch(ke=(Ie,$e)=>Ie===$e){let Ie=!0,$e;return this.f.push(Y=>{const ue=Ie||!ke(Y,$e);return Ie=!1,$e=Y,ue?Y:W}),this}evaluate(ke){for(const Ie of this.f)if(ke=Ie(ke),ke===W)break;return ke}}function J(Se,ke,Ie=$e=>$e){const $e=(...be)=>fe.fire(Ie(...be)),Y=()=>Se.on(ke,$e),ue=()=>Se.removeListener(ke,$e),fe=new i({onWillAddFirstListener:Y,onDidRemoveLastListener:ue});return fe.event}C.fromNodeEventEmitter=J;function X(Se,ke,Ie=$e=>$e){const $e=(...be)=>fe.fire(Ie(...be)),Y=()=>Se.addEventListener(ke,$e),ue=()=>Se.removeEventListener(ke,$e),fe=new i({onWillAddFirstListener:Y,onDidRemoveLastListener:ue});return fe.event}C.fromDOMEventEmitter=X;function Z(Se){return new Promise(ke=>Q(Se)(ke))}C.toPromise=Z;function ie(Se){const ke=new i;return Se.then(Ie=>{ke.fire(Ie)},()=>{ke.fire(void 0)}).finally(()=>{ke.dispose()}),ke.event}C.fromPromise=ie;function de(Se,ke,Ie){return ke(Ie),Se($e=>ke($e))}C.runAndSubscribe=de;class me{constructor(ke,Ie){this._observable=ke,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{ke.addObserver(this)},onDidRemoveLastListener:()=>{ke.removeObserver(this)}};Ie||z($e),this.emitter=new i($e),Ie&&Ie.add(this.emitter)}beginUpdate(ke){this.f++}handlePossibleChange(ke){}handleChange(ke,Ie){this.g=!0}endUpdate(ke){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function we(Se,ke){return new me(Se,ke).emitter.event}C.fromObservable=we;function Oe(Se){return(ke,Ie,$e)=>{let Y=0,ue=!1;const fe={beginUpdate(){Y++},endUpdate(){Y--,Y===0&&(Se.reportChanges(),ue&&(ue=!1,ke.call(Ie)))},handlePossibleChange(){},handleChange(){ue=!0}};Se.addObserver(fe),Se.reportChanges();const be={dispose(){Se.removeObserver(fe)}};return $e instanceof P.$Vc?$e.add(be):Array.isArray($e)&&$e.push(be),be}}C.fromObservableLight=Oe})(f||(e.Event=f={}));class d{static{this.all=new Set}static{this.f=0}constructor(z){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${z}_${d.f++}`,d.all.add(this)}start(z){this.g=new A.$ge,this.listenerCount=z}stop(){if(this.g){const z=this.g.elapsed();this.durations.push(z),this.elapsedOverall+=z,this.invocationCount+=1,this.g=void 0}}}e.$ie=d;let g=-1;function w(C){const z=g;return g=C,{dispose(){g=z}}}class h{static{this.f=1}constructor(z,re,Q=(h.f++).toString(16).padStart(3,"0")){this.j=z,this.threshold=re,this.name=Q,this.h=0}dispose(){this.g?.clear()}check(z,re){const Q=this.threshold;if(Q<=0||re<Q)return;this.g||(this.g=new Map);const le=this.g.get(z.value)||0;if(this.g.set(z.value,le+1),this.h-=1,this.h<=0){this.h=Q*.5;const[K,ee]=this.getMostFrequentStack(),q=`[${this.name}] potential listener LEAK detected, having ${re} listeners already. MOST frequent listener (${ee}):`;console.warn(q),console.warn(K);const j=new y(q,K);this.j(j)}return()=>{const K=this.g.get(z.value)||0;this.g.set(z.value,K-1)}}getMostFrequentStack(){if(!this.g)return;let z,re=0;for(const[Q,le]of this.g)(!z||re<le)&&(z=[Q,le],re=le);return z}}class p{static create(){const z=new Error;return new p(z.stack??"")}constructor(z){this.value=z}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y extends Error{constructor(z,re){super(z),this.name="ListenerLeakError",this.stack=re}}e.$ke=y;class $ extends Error{constructor(z,re){super(z),this.name="ListenerRefusalError",this.stack=re}}e.$le=$;let m=0;class E{constructor(z){this.value=z,this.id=m++}}const k=2,t=(C,z)=>{if(C instanceof E)z(C);else for(let re=0;re<C.length;re++){const Q=C[re];Q&&z(Q)}};let r;if(I){const C=[];setInterval(()=>{C.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(C.join(`
`)),C.length=0)},3e3),r=new FinalizationRegistry(z=>{typeof z=="string"&&C.push(z)})}class i{constructor(z){this.z=0,this.f=z,this.g=g>0||this.f?.leakWarningThreshold?new h(z?.onListenerError??n.$3,this.f?.leakWarningThreshold??g):void 0,this.j=this.f?._profName?new d(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(b){const z=this.u;queueMicrotask(()=>{t(z,re=>re.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(z,re,Q)=>{if(this.g&&this.z>this.g.threshold**2){const j=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(j);const U=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],V=new $(`${j}. HINT: Stack shows most frequent listener (${U[1]}-times)`,U[0]);return(this.f?.onListenerError||n.$3)(V),P.$Wc.None}if(this.m)return P.$Wc.None;re&&(z=z.bind(re));const le=new E(z);let K,ee;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(le.stack=p.create(),K=this.g.check(le.stack,this.z+1)),b&&(le.stack=ee??p.create()),this.u?this.u instanceof E?(this.w??=new s,this.u=[this.u,le]):this.u.push(le):(this.f?.onWillAddFirstListener?.(this),this.u=le,this.f?.onDidAddFirstListener?.(this)),this.z++;const q=(0,P.$Uc)(()=>{r?.unregister(q),K?.(),this.A(le)});if(Q instanceof P.$Vc?Q.add(q):Array.isArray(Q)&&Q.push(q),r){const j=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),U=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(j);r.register(q,U?.[2]??j,q)}return q},this.q}A(z){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const re=this.u,Q=re.indexOf(z);if(Q===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,re[Q]=void 0;const le=this.w.current===this;if(this.z*k<=re.length){let K=0;for(let ee=0;ee<re.length;ee++)re[ee]?re[K++]=re[ee]:le&&(this.w.end--,K<this.w.i&&this.w.i--);re.length=K}}B(z,re){if(!z)return;const Q=this.f?.onListenerError||n.$3;if(!Q){z.value(re);return}try{z.value(re)}catch(le){Q(le)}}C(z){const re=z.current.u;for(;z.i<z.end;)this.B(re[z.i++],z.value);z.reset()}fire(z){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof E)this.B(this.u,z);else{const re=this.w;re.enqueue(this,z,this.u.length),this.C(re)}this.j?.stop()}hasListeners(){return this.z>0}}e.$me=i;const c=()=>new s;e.$ne=c;class s{constructor(){this.i=-1,this.end=0}enqueue(z,re,Q){this.i=0,this.end=Q,this.current=z,this.value=re}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class u extends i{async fireAsync(z,re,Q){if(this.u)for(this.h||(this.h=new D.$7c),t(this.u,le=>this.h.push([le.value,z]));this.h.size>0&&!re.isCancellationRequested;){const[le,K]=this.h.shift(),ee=[],q={...K,token:re,waitUntil:j=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");Q&&(j=Q(j,le)),ee.push(j)}};try{le(q)}catch(j){(0,n.$3)(j);continue}Object.freeze(ee),await Promise.allSettled(ee).then(j=>{for(const U of j)U.status==="rejected"&&(0,n.$3)(U.reason)})}}}e.$oe=u;class l extends i{get isPaused(){return this.h!==0}constructor(z){super(z),this.h=0,this.s=new D.$7c,this.t=z?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const z=Array.from(this.s);this.s.clear(),super.fire(this.t(z))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(z){this.z&&(this.h!==0?this.s.push(z):super.fire(z))}}e.$pe=l;class S extends l{constructor(z){super(z),this.k=z.delay??100}fire(z){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(z)}}e.$qe=S;class v extends i{constructor(z){super(z),this.h=[],this.k=z?.merge}fire(z){this.hasListeners()&&(this.h.push(z),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(re=>super.fire(re)),this.h=[]}))}}e.$re=v;class R{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(z){const re={event:z,listener:null};this.h.push(re),this.g&&this.m(re);const Q=()=>{this.g&&this.o(re);const le=this.h.indexOf(re);this.h.splice(le,1)};return(0,P.$Uc)((0,o.$fb)(Q))}j(){this.g=!0,this.h.forEach(z=>this.m(z))}k(){this.g=!1,this.h.forEach(z=>this.o(z))}m(z){z.listener=z.event(re=>this.f.fire(re))}o(z){z.listener?.dispose(),z.listener=null}dispose(){this.f.dispose();for(const z of this.h)z.listener?.dispose();this.h=[]}}e.$se=R;class T{constructor(z,re,Q,le){this.f=new P.$Vc;const K=this.f.add(new R),ee=this.f.add(new P.$6c);function q(j){ee.set(j,K.add(le(j)))}for(const j of z)q(j);this.f.add(re(j=>{q(j)})),this.f.add(Q(j=>{ee.deleteAndDispose(j)})),this.event=K.event}dispose(){this.f.dispose()}}e.$te=T;class L{constructor(){this.f=[]}wrapEvent(z,re,Q){return(le,K,ee)=>z(q=>{const j=this.f[this.f.length-1];if(!re){j?j.buffers.push(()=>le.call(K,q)):le.call(K,q);return}const U=j;if(!U){le.call(K,re(Q,q));return}U.items??=[],U.items.push(q),U.buffers.length===0&&j.buffers.push(()=>{U.reducedResult??=Q?U.items.reduce(re,Q):U.items.reduce(re),le.call(K,U.reducedResult)})},void 0,ee)}bufferEvents(z){const re={buffers:new Array};this.f.push(re);const Q=z();return this.f.pop(),re.buffers.forEach(le=>le()),Q}}e.$ue=L;class O{constructor(){this.f=!1,this.g=f.None,this.h=P.$Wc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(z){this.g=z,this.f&&(this.h.dispose(),this.h=z(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ve=O;class F{static const(z){return new B(z)}constructor(z){this.g=z,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(z){z!==this.g&&(this.g=z,this.f.fire(void 0))}}e.$we=F;class B{constructor(z){this.value=z,this.onDidChange=f.None}}}),define(oe[23],ae([0,1,4]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.CancellationToken=void 0,e.$ye=I;const o=Object.freeze(function(b,a){const f=setTimeout(b.bind(a),0);return{dispose(){clearTimeout(f)}}});var P;(function(b){function a(f){return f===b.None||f===b.Cancelled||f instanceof D?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}b.isCancellationToken=a,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:o})})(P||(e.CancellationToken=P={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?o:(this.b||(this.b=new n.$me),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(a){this.f=void 0,this.g=void 0,this.g=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=P.Cancelled}dispose(a=!1){a&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=P.None}}e.$xe=A;function I(b){const a=new A;return b.add({dispose(){a.cancel()}}),a.token}}),define(oe[145],ae([0,1,23]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$af=e.$_e=e.$0e=void 0,e.$$e=P;class o{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new n.$xe,a=this.b(b.token);return this.a={promise:a,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$0e=o;function P(I){return I}class D{constructor(b,a){this.a=void 0,this.b=void 0,typeof b=="function"?(this.c=b,this.d=P):(this.c=a,this.d=b.getCacheKey)}get(b){const a=this.d(b);return this.b!==a&&(this.b=a,this.a=this.c(b)),this.a}}e.$_e=D;class A{get cachedValues(){return this.a}constructor(b,a){this.a=new Map,this.b=new Map,typeof b=="function"?(this.c=b,this.d=P):(this.c=a,this.d=b.getCacheKey)}get(b){const a=this.d(b);if(this.b.has(a))return this.b.get(a);const f=this.c(b);return this.a.set(b,f),this.b.set(a,f),f}}e.$af=A}),define(oe[68],ae([0,1,16,2]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=P,e.$Ae=D,e.$Be=A,e.$Ce=I,e.$De=a,e.$Ee=f,e.$Fe=d,e.$Ge=g,e.$He=w,e.$Ie=h,e.$Je=p,e.$Ke=y,e.$Le=$,e.$Me=m,e.$Ne=E;function P(k){const t=k;return t?typeof t.read=="function":!1}function D(k){const t=k;return t?[t.on,t.pause,t.resume,t.destroy].every(r=>typeof r=="function"):!1}function A(k){const t=k;return t?D(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function I(k,t){return new b(k,t)}class b{constructor(t,r){this.e=t,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(r=>r(t))}h(t){this.c.error.length===0?(0,n.$3)(t):this.c.error.slice(0).forEach(r=>r(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,r){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(t,r){if(this.a.destroyed)return;let i;switch(t){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const c=i.indexOf(r);c>=0&&i.splice(c,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(k,t){const r=[];let i;for(;(i=k.read())!==null;)r.push(i);return t(r)}function f(k,t,r){const i=[];let c;for(;(c=k.read())!==null&&i.length<r;)i.push(c);return c===null&&i.length>0?t(i):{read:()=>{if(i.length>0)return i.shift();if(typeof c<"u"){const s=c;return c=void 0,s}return k.read()}}}function d(k,t){return new Promise((r,i)=>{const c=[];g(k,{onData:s=>{t&&c.push(s)},onError:s=>{t?i(s):r(void 0)},onEnd:()=>{r(t?t(c):void 0)}})})}function g(k,t,r){k.on("error",i=>{r?.isCancellationRequested||t.onError(i)}),k.on("end",()=>{r?.isCancellationRequested||t.onEnd()}),k.on("data",i=>{r?.isCancellationRequested||t.onData(i)})}function w(k,t){return new Promise((r,i)=>{const c=new o.$Vc,s=[],u=v=>{if(s.push(v),s.length>t)return c.dispose(),k.pause(),r({stream:k,buffer:s,ended:!1})},l=v=>(c.dispose(),i(v)),S=()=>(c.dispose(),r({stream:k,buffer:s,ended:!0}));c.add((0,o.$Uc)(()=>k.removeListener("error",l))),k.on("error",l),c.add((0,o.$Uc)(()=>k.removeListener("end",S))),k.on("end",S),c.add((0,o.$Uc)(()=>k.removeListener("data",u))),k.on("data",u)})}function h(k,t){const r=I(t);return r.end(k),r}function p(){const k=I(()=>{throw new Error("not supported")});return k.end(),k}function y(k){let t=!1;return{read:()=>t?null:(t=!0,k)}}function $(k,t,r){const i=I(r);return g(k,{onData:c=>i.write(t.data(c)),onError:c=>i.error(t.error?t.error(c):c),onEnd:()=>i.end()}),i}function m(k,t,r){let i=!1;return{read:()=>{const c=t.read();return i?c:(i=!0,c!==null?r([k,c]):k)}}}function E(k,t,r){let i=!1;const c=I(r);return g(t,{onData:s=>i?c.write(s):(i=!0,c.write(r([k,s]))),onError:s=>c.error(s),onEnd:()=>{i||(i=!0,c.write(k)),c.end()}}),c}});var Rt=this&&this.__createBinding||(Object.create?function(x,e,n,o){o===void 0&&(o=n);var P=Object.getOwnPropertyDescriptor(e,n);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[n]}}),Object.defineProperty(x,o,P)}:function(x,e,n,o){o===void 0&&(o=n),x[o]=e[n]}),At=this&&this.__setModuleDefault||(Object.create?function(x,e){Object.defineProperty(x,"default",{enumerable:!0,value:e})}:function(x,e){x.default=e}),De=this&&this.__importStar||function(x){if(x&&x.__esModule)return x;var e={};if(x!=null)for(var n in x)n!=="default"&&Object.prototype.hasOwnProperty.call(x,n)&&Rt(e,x,n);return At(e,x),e};define(oe[17],ae([0,1,66,68]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=a,e.$Qe=f,e.$Re=d,e.$Se=g,e.$Te=w,e.$Ue=h,e.$Ve=p,e.$We=y,e.$Xe=$,e.$Ye=m,e.$Ze=E,e.$1e=k,e.$2e=t,e.$3e=r,e.$4e=i,e.$5e=c,e.$6e=s,e.$7e=u,e.$8e=l,e.$9e=R,o=De(o);const P=typeof Buffer<"u",D=new n.$X(()=>new Uint8Array(256));let A,I;class b{static alloc(L){return P?new b(Buffer.allocUnsafe(L)):new b(new Uint8Array(L))}static wrap(L){return P&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new b(L)}static fromString(L,O){return!(O?.dontUseNodeBuffer||!1)&&P?new b(Buffer.from(L)):(A||(A=new TextEncoder),new b(A.encode(L)))}static fromByteArray(L){const O=b.alloc(L.length);for(let F=0,B=L.length;F<B;F++)O.buffer[F]=L[F];return O}static concat(L,O){if(typeof O>"u"){O=0;for(let C=0,z=L.length;C<z;C++)O+=L[C].byteLength}const F=b.alloc(O);let B=0;for(let C=0,z=L.length;C<z;C++){const re=L[C];F.set(re,B),B+=re.byteLength}return F}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=b.alloc(this.byteLength);return L.set(this),L}toString(){return P?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(L,O){return new b(this.buffer.subarray(L,O))}set(L,O){if(L instanceof b)this.buffer.set(L.buffer,O);else if(L instanceof Uint8Array)this.buffer.set(L,O);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),O);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return g(this.buffer,L)}writeUInt32BE(L,O){w(this.buffer,L,O)}readUInt32LE(L){return h(this.buffer,L)}writeUInt32LE(L,O){p(this.buffer,L,O)}readUInt8(L){return y(this.buffer,L)}writeUInt8(L,O){$(this.buffer,L,O)}indexOf(L,O=0){return a(this.buffer,L instanceof b?L.buffer:L,O)}}e.$Oe=b;function a(T,L,O=0){const F=L.byteLength,B=T.byteLength;if(F===0)return 0;if(F===1)return T.indexOf(L[0]);if(F>B-O)return-1;const C=D.value;C.fill(L.length);for(let le=0;le<L.length;le++)C[L[le]]=L.length-le-1;let z=O+L.length-1,re=z,Q=-1;for(;z<B;)if(T[z]===L[re]){if(re===0){Q=z;break}z--,re--}else z+=Math.max(L.length-re,C[T[z]]),re=L.length-1;return Q}function f(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0}function d(T,L,O){T[O+0]=L&255,L=L>>>8,T[O+1]=L&255}function g(T,L){return T[L]*2**24+T[L+1]*2**16+T[L+2]*2**8+T[L+3]}function w(T,L,O){T[O+3]=L,L=L>>>8,T[O+2]=L,L=L>>>8,T[O+1]=L,L=L>>>8,T[O]=L}function h(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0|T[L+2]<<16>>>0|T[L+3]<<24>>>0}function p(T,L,O){T[O+0]=L&255,L=L>>>8,T[O+1]=L&255,L=L>>>8,T[O+2]=L&255,L=L>>>8,T[O+3]=L&255}function y(T,L){return T[L]}function $(T,L,O){T[O]=L}function m(T){return o.$De(T,L=>b.concat(L))}function E(T){return o.$Ke(T)}function k(T){return o.$Fe(T,L=>b.concat(L))}async function t(T){return T.ended?b.concat(T.buffer):b.concat([...T.buffer,await k(T.stream)])}function r(T){return o.$Ie(T,L=>b.concat(L))}function i(T){return o.$Le(T,{data:L=>typeof L=="string"?b.fromString(L):b.wrap(L)},L=>b.concat(L))}function c(T){return o.$Ce(L=>b.concat(L),T)}function s(T,L){return o.$Me(T,L,O=>b.concat(O))}function u(T,L){return o.$Ne(T,L,O=>b.concat(O))}function l(T){let L=0,O=0,F=0;const B=new Uint8Array(Math.floor(T.length/4*3)),C=re=>{switch(O){case 3:B[F++]=L|re,O=0;break;case 2:B[F++]=L|re>>>2,L=re<<6,O=3;break;case 1:B[F++]=L|re>>>4,L=re<<4,O=2;break;default:L=re<<2,O=1}};for(let re=0;re<T.length;re++){const Q=T.charCodeAt(re);if(Q>=65&&Q<=90)C(Q-65);else if(Q>=97&&Q<=122)C(Q-97+26);else if(Q>=48&&Q<=57)C(Q-48+52);else if(Q===43||Q===45)C(62);else if(Q===47||Q===95)C(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${T[re]}`)}}const z=F;for(;O>0;)C(0);return b.wrap(B).slice(0,z)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:T},L=!0,O=!1){const F=O?v:S;let B="";const C=T.byteLength%3;let z=0;for(;z<T.byteLength-C;z+=3){const re=T[z+0],Q=T[z+1],le=T[z+2];B+=F[re>>>2],B+=F[(re<<4|Q>>>4)&63],B+=F[(Q<<2|le>>>6)&63],B+=F[le&63]}if(C===1){const re=T[z+0];B+=F[re>>>2],B+=F[re<<4&63],L&&(B+="==")}else if(C===2){const re=T[z+0],Q=T[z+1];B+=F[re>>>2],B+=F[(re<<4|Q>>>4)&63],B+=F[Q<<2&63],L&&(B+="=")}return B}}),define(oe[146],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(oe[13],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=n,e.$gg=o,e.$hg=P,e.$ig=D,e.$jg=A,e.$kg=I,e.$lg=b,e.$mg=a,e.$ng=f,e.$og=d,e.$pg=g,e.$qg=w,e.$rg=h,e.$sg=y,e.$tg=$,e.$ug=m,e.$vg=E,e.$wg=k;function n(t){return typeof t=="string"}function o(t){return Array.isArray(t)&&t.every(r=>n(r))}function P(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function D(t){const r=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof r}function A(t){return typeof t=="number"&&!isNaN(t)}function I(t){return!!t&&typeof t[Symbol.iterator]=="function"}function b(t){return t===!0||t===!1}function a(t){return typeof t>"u"}function f(t){return!d(t)}function d(t){return a(t)||t===null}function g(t,r){if(!t)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function w(t){if(d(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function h(...t){const r=[];for(let i=0;i<t.length;i++){const c=t[i];if(d(c))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);r.push(c)}return r}const p=Object.prototype.hasOwnProperty;function y(t){if(!P(t))return!1;for(const r in t)if(p.call(t,r))return!1;return!0}function $(t){return typeof t=="function"}function m(...t){return t.length>0&&t.every($)}function E(t,r){const i=Math.min(t.length,r.length);for(let c=0;c<i;c++)k(t[c],r[c])}function k(t,r){if(n(r)){if(typeof t!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if($(r)){try{if(t instanceof r)return}catch{}if(!d(t)&&t.constructor===r||r.length===1&&r.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(oe[110],ae([0,1,13]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=P,e.$1j=D;const o=Object.create(null);function P(A,I){if((0,n.$fg)(I)){const b=o[I];if(b===void 0)throw new Error(`${A} references an unknown codicon: ${I}`);I=b}return o[A]=I,{id:A}}function D(){return o}}),define(oe[147],ae([0,1,110]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=void 0,e.$2j={add:(0,n.$Zj)("add",6e4),plus:(0,n.$Zj)("plus",6e4),gistNew:(0,n.$Zj)("gist-new",6e4),repoCreate:(0,n.$Zj)("repo-create",6e4),lightbulb:(0,n.$Zj)("lightbulb",60001),lightBulb:(0,n.$Zj)("light-bulb",60001),repo:(0,n.$Zj)("repo",60002),repoDelete:(0,n.$Zj)("repo-delete",60002),gistFork:(0,n.$Zj)("gist-fork",60003),repoForked:(0,n.$Zj)("repo-forked",60003),gitPullRequest:(0,n.$Zj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Zj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Zj)("record-keys",60005),keyboard:(0,n.$Zj)("keyboard",60005),tag:(0,n.$Zj)("tag",60006),gitPullRequestLabel:(0,n.$Zj)("git-pull-request-label",60006),tagAdd:(0,n.$Zj)("tag-add",60006),tagRemove:(0,n.$Zj)("tag-remove",60006),person:(0,n.$Zj)("person",60007),personFollow:(0,n.$Zj)("person-follow",60007),personOutline:(0,n.$Zj)("person-outline",60007),personFilled:(0,n.$Zj)("person-filled",60007),gitBranch:(0,n.$Zj)("git-branch",60008),gitBranchCreate:(0,n.$Zj)("git-branch-create",60008),gitBranchDelete:(0,n.$Zj)("git-branch-delete",60008),sourceControl:(0,n.$Zj)("source-control",60008),mirror:(0,n.$Zj)("mirror",60009),mirrorPublic:(0,n.$Zj)("mirror-public",60009),star:(0,n.$Zj)("star",60010),starAdd:(0,n.$Zj)("star-add",60010),starDelete:(0,n.$Zj)("star-delete",60010),starEmpty:(0,n.$Zj)("star-empty",60010),comment:(0,n.$Zj)("comment",60011),commentAdd:(0,n.$Zj)("comment-add",60011),alert:(0,n.$Zj)("alert",60012),warning:(0,n.$Zj)("warning",60012),search:(0,n.$Zj)("search",60013),searchSave:(0,n.$Zj)("search-save",60013),logOut:(0,n.$Zj)("log-out",60014),signOut:(0,n.$Zj)("sign-out",60014),logIn:(0,n.$Zj)("log-in",60015),signIn:(0,n.$Zj)("sign-in",60015),eye:(0,n.$Zj)("eye",60016),eyeUnwatch:(0,n.$Zj)("eye-unwatch",60016),eyeWatch:(0,n.$Zj)("eye-watch",60016),circleFilled:(0,n.$Zj)("circle-filled",60017),primitiveDot:(0,n.$Zj)("primitive-dot",60017),closeDirty:(0,n.$Zj)("close-dirty",60017),debugBreakpoint:(0,n.$Zj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Zj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Zj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Zj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Zj)("primitive-square",60018),edit:(0,n.$Zj)("edit",60019),pencil:(0,n.$Zj)("pencil",60019),info:(0,n.$Zj)("info",60020),issueOpened:(0,n.$Zj)("issue-opened",60020),gistPrivate:(0,n.$Zj)("gist-private",60021),gitForkPrivate:(0,n.$Zj)("git-fork-private",60021),lock:(0,n.$Zj)("lock",60021),mirrorPrivate:(0,n.$Zj)("mirror-private",60021),close:(0,n.$Zj)("close",60022),removeClose:(0,n.$Zj)("remove-close",60022),x:(0,n.$Zj)("x",60022),repoSync:(0,n.$Zj)("repo-sync",60023),sync:(0,n.$Zj)("sync",60023),clone:(0,n.$Zj)("clone",60024),desktopDownload:(0,n.$Zj)("desktop-download",60024),beaker:(0,n.$Zj)("beaker",60025),microscope:(0,n.$Zj)("microscope",60025),vm:(0,n.$Zj)("vm",60026),deviceDesktop:(0,n.$Zj)("device-desktop",60026),file:(0,n.$Zj)("file",60027),fileText:(0,n.$Zj)("file-text",60027),more:(0,n.$Zj)("more",60028),ellipsis:(0,n.$Zj)("ellipsis",60028),kebabHorizontal:(0,n.$Zj)("kebab-horizontal",60028),mailReply:(0,n.$Zj)("mail-reply",60029),reply:(0,n.$Zj)("reply",60029),organization:(0,n.$Zj)("organization",60030),organizationFilled:(0,n.$Zj)("organization-filled",60030),organizationOutline:(0,n.$Zj)("organization-outline",60030),newFile:(0,n.$Zj)("new-file",60031),fileAdd:(0,n.$Zj)("file-add",60031),newFolder:(0,n.$Zj)("new-folder",60032),fileDirectoryCreate:(0,n.$Zj)("file-directory-create",60032),trash:(0,n.$Zj)("trash",60033),trashcan:(0,n.$Zj)("trashcan",60033),history:(0,n.$Zj)("history",60034),clock:(0,n.$Zj)("clock",60034),folder:(0,n.$Zj)("folder",60035),fileDirectory:(0,n.$Zj)("file-directory",60035),symbolFolder:(0,n.$Zj)("symbol-folder",60035),logoGithub:(0,n.$Zj)("logo-github",60036),markGithub:(0,n.$Zj)("mark-github",60036),github:(0,n.$Zj)("github",60036),terminal:(0,n.$Zj)("terminal",60037),console:(0,n.$Zj)("console",60037),repl:(0,n.$Zj)("repl",60037),zap:(0,n.$Zj)("zap",60038),symbolEvent:(0,n.$Zj)("symbol-event",60038),error:(0,n.$Zj)("error",60039),stop:(0,n.$Zj)("stop",60039),variable:(0,n.$Zj)("variable",60040),symbolVariable:(0,n.$Zj)("symbol-variable",60040),array:(0,n.$Zj)("array",60042),symbolArray:(0,n.$Zj)("symbol-array",60042),symbolModule:(0,n.$Zj)("symbol-module",60043),symbolPackage:(0,n.$Zj)("symbol-package",60043),symbolNamespace:(0,n.$Zj)("symbol-namespace",60043),symbolObject:(0,n.$Zj)("symbol-object",60043),symbolMethod:(0,n.$Zj)("symbol-method",60044),symbolFunction:(0,n.$Zj)("symbol-function",60044),symbolConstructor:(0,n.$Zj)("symbol-constructor",60044),symbolBoolean:(0,n.$Zj)("symbol-boolean",60047),symbolNull:(0,n.$Zj)("symbol-null",60047),symbolNumeric:(0,n.$Zj)("symbol-numeric",60048),symbolNumber:(0,n.$Zj)("symbol-number",60048),symbolStructure:(0,n.$Zj)("symbol-structure",60049),symbolStruct:(0,n.$Zj)("symbol-struct",60049),symbolParameter:(0,n.$Zj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Zj)("symbol-type-parameter",60050),symbolKey:(0,n.$Zj)("symbol-key",60051),symbolText:(0,n.$Zj)("symbol-text",60051),symbolReference:(0,n.$Zj)("symbol-reference",60052),goToFile:(0,n.$Zj)("go-to-file",60052),symbolEnum:(0,n.$Zj)("symbol-enum",60053),symbolValue:(0,n.$Zj)("symbol-value",60053),symbolRuler:(0,n.$Zj)("symbol-ruler",60054),symbolUnit:(0,n.$Zj)("symbol-unit",60054),activateBreakpoints:(0,n.$Zj)("activate-breakpoints",60055),archive:(0,n.$Zj)("archive",60056),arrowBoth:(0,n.$Zj)("arrow-both",60057),arrowDown:(0,n.$Zj)("arrow-down",60058),arrowLeft:(0,n.$Zj)("arrow-left",60059),arrowRight:(0,n.$Zj)("arrow-right",60060),arrowSmallDown:(0,n.$Zj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Zj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Zj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Zj)("arrow-small-up",60064),arrowUp:(0,n.$Zj)("arrow-up",60065),bell:(0,n.$Zj)("bell",60066),bold:(0,n.$Zj)("bold",60067),book:(0,n.$Zj)("book",60068),bookmark:(0,n.$Zj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Zj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Zj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Zj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Zj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Zj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Zj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Zj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Zj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Zj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Zj)("briefcase",60076),broadcast:(0,n.$Zj)("broadcast",60077),browser:(0,n.$Zj)("browser",60078),bug:(0,n.$Zj)("bug",60079),calendar:(0,n.$Zj)("calendar",60080),caseSensitive:(0,n.$Zj)("case-sensitive",60081),check:(0,n.$Zj)("check",60082),checklist:(0,n.$Zj)("checklist",60083),chevronDown:(0,n.$Zj)("chevron-down",60084),chevronLeft:(0,n.$Zj)("chevron-left",60085),chevronRight:(0,n.$Zj)("chevron-right",60086),chevronUp:(0,n.$Zj)("chevron-up",60087),chromeClose:(0,n.$Zj)("chrome-close",60088),chromeMaximize:(0,n.$Zj)("chrome-maximize",60089),chromeMinimize:(0,n.$Zj)("chrome-minimize",60090),chromeRestore:(0,n.$Zj)("chrome-restore",60091),circleOutline:(0,n.$Zj)("circle-outline",60092),circle:(0,n.$Zj)("circle",60092),debugBreakpointUnverified:(0,n.$Zj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Zj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Zj)("circle-slash",60093),circuitBoard:(0,n.$Zj)("circuit-board",60094),clearAll:(0,n.$Zj)("clear-all",60095),clippy:(0,n.$Zj)("clippy",60096),closeAll:(0,n.$Zj)("close-all",60097),cloudDownload:(0,n.$Zj)("cloud-download",60098),cloudUpload:(0,n.$Zj)("cloud-upload",60099),code:(0,n.$Zj)("code",60100),collapseAll:(0,n.$Zj)("collapse-all",60101),colorMode:(0,n.$Zj)("color-mode",60102),commentDiscussion:(0,n.$Zj)("comment-discussion",60103),creditCard:(0,n.$Zj)("credit-card",60105),dash:(0,n.$Zj)("dash",60108),dashboard:(0,n.$Zj)("dashboard",60109),database:(0,n.$Zj)("database",60110),debugContinue:(0,n.$Zj)("debug-continue",60111),debugDisconnect:(0,n.$Zj)("debug-disconnect",60112),debugPause:(0,n.$Zj)("debug-pause",60113),debugRestart:(0,n.$Zj)("debug-restart",60114),debugStart:(0,n.$Zj)("debug-start",60115),debugStepInto:(0,n.$Zj)("debug-step-into",60116),debugStepOut:(0,n.$Zj)("debug-step-out",60117),debugStepOver:(0,n.$Zj)("debug-step-over",60118),debugStop:(0,n.$Zj)("debug-stop",60119),debug:(0,n.$Zj)("debug",60120),deviceCameraVideo:(0,n.$Zj)("device-camera-video",60121),deviceCamera:(0,n.$Zj)("device-camera",60122),deviceMobile:(0,n.$Zj)("device-mobile",60123),diffAdded:(0,n.$Zj)("diff-added",60124),diffIgnored:(0,n.$Zj)("diff-ignored",60125),diffModified:(0,n.$Zj)("diff-modified",60126),diffRemoved:(0,n.$Zj)("diff-removed",60127),diffRenamed:(0,n.$Zj)("diff-renamed",60128),diff:(0,n.$Zj)("diff",60129),diffSidebyside:(0,n.$Zj)("diff-sidebyside",60129),discard:(0,n.$Zj)("discard",60130),editorLayout:(0,n.$Zj)("editor-layout",60131),emptyWindow:(0,n.$Zj)("empty-window",60132),exclude:(0,n.$Zj)("exclude",60133),extensions:(0,n.$Zj)("extensions",60134),eyeClosed:(0,n.$Zj)("eye-closed",60135),fileBinary:(0,n.$Zj)("file-binary",60136),fileCode:(0,n.$Zj)("file-code",60137),fileMedia:(0,n.$Zj)("file-media",60138),filePdf:(0,n.$Zj)("file-pdf",60139),fileSubmodule:(0,n.$Zj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Zj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Zj)("file-symlink-file",60142),fileZip:(0,n.$Zj)("file-zip",60143),files:(0,n.$Zj)("files",60144),filter:(0,n.$Zj)("filter",60145),flame:(0,n.$Zj)("flame",60146),foldDown:(0,n.$Zj)("fold-down",60147),foldUp:(0,n.$Zj)("fold-up",60148),fold:(0,n.$Zj)("fold",60149),folderActive:(0,n.$Zj)("folder-active",60150),folderOpened:(0,n.$Zj)("folder-opened",60151),gear:(0,n.$Zj)("gear",60152),gift:(0,n.$Zj)("gift",60153),gistSecret:(0,n.$Zj)("gist-secret",60154),gist:(0,n.$Zj)("gist",60155),gitCommit:(0,n.$Zj)("git-commit",60156),gitCompare:(0,n.$Zj)("git-compare",60157),compareChanges:(0,n.$Zj)("compare-changes",60157),gitMerge:(0,n.$Zj)("git-merge",60158),githubAction:(0,n.$Zj)("github-action",60159),githubAlt:(0,n.$Zj)("github-alt",60160),globe:(0,n.$Zj)("globe",60161),grabber:(0,n.$Zj)("grabber",60162),graph:(0,n.$Zj)("graph",60163),gripper:(0,n.$Zj)("gripper",60164),heart:(0,n.$Zj)("heart",60165),home:(0,n.$Zj)("home",60166),horizontalRule:(0,n.$Zj)("horizontal-rule",60167),hubot:(0,n.$Zj)("hubot",60168),inbox:(0,n.$Zj)("inbox",60169),issueReopened:(0,n.$Zj)("issue-reopened",60171),issues:(0,n.$Zj)("issues",60172),italic:(0,n.$Zj)("italic",60173),jersey:(0,n.$Zj)("jersey",60174),json:(0,n.$Zj)("json",60175),kebabVertical:(0,n.$Zj)("kebab-vertical",60176),key:(0,n.$Zj)("key",60177),law:(0,n.$Zj)("law",60178),lightbulbAutofix:(0,n.$Zj)("lightbulb-autofix",60179),linkExternal:(0,n.$Zj)("link-external",60180),link:(0,n.$Zj)("link",60181),listOrdered:(0,n.$Zj)("list-ordered",60182),listUnordered:(0,n.$Zj)("list-unordered",60183),liveShare:(0,n.$Zj)("live-share",60184),loading:(0,n.$Zj)("loading",60185),location:(0,n.$Zj)("location",60186),mailRead:(0,n.$Zj)("mail-read",60187),mail:(0,n.$Zj)("mail",60188),markdown:(0,n.$Zj)("markdown",60189),megaphone:(0,n.$Zj)("megaphone",60190),mention:(0,n.$Zj)("mention",60191),milestone:(0,n.$Zj)("milestone",60192),gitPullRequestMilestone:(0,n.$Zj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Zj)("mortar-board",60193),move:(0,n.$Zj)("move",60194),multipleWindows:(0,n.$Zj)("multiple-windows",60195),mute:(0,n.$Zj)("mute",60196),noNewline:(0,n.$Zj)("no-newline",60197),note:(0,n.$Zj)("note",60198),octoface:(0,n.$Zj)("octoface",60199),openPreview:(0,n.$Zj)("open-preview",60200),package:(0,n.$Zj)("package",60201),paintcan:(0,n.$Zj)("paintcan",60202),pin:(0,n.$Zj)("pin",60203),play:(0,n.$Zj)("play",60204),run:(0,n.$Zj)("run",60204),plug:(0,n.$Zj)("plug",60205),preserveCase:(0,n.$Zj)("preserve-case",60206),preview:(0,n.$Zj)("preview",60207),project:(0,n.$Zj)("project",60208),pulse:(0,n.$Zj)("pulse",60209),question:(0,n.$Zj)("question",60210),quote:(0,n.$Zj)("quote",60211),radioTower:(0,n.$Zj)("radio-tower",60212),reactions:(0,n.$Zj)("reactions",60213),references:(0,n.$Zj)("references",60214),refresh:(0,n.$Zj)("refresh",60215),regex:(0,n.$Zj)("regex",60216),remoteExplorer:(0,n.$Zj)("remote-explorer",60217),remote:(0,n.$Zj)("remote",60218),remove:(0,n.$Zj)("remove",60219),replaceAll:(0,n.$Zj)("replace-all",60220),replace:(0,n.$Zj)("replace",60221),repoClone:(0,n.$Zj)("repo-clone",60222),repoForcePush:(0,n.$Zj)("repo-force-push",60223),repoPull:(0,n.$Zj)("repo-pull",60224),repoPush:(0,n.$Zj)("repo-push",60225),report:(0,n.$Zj)("report",60226),requestChanges:(0,n.$Zj)("request-changes",60227),rocket:(0,n.$Zj)("rocket",60228),rootFolderOpened:(0,n.$Zj)("root-folder-opened",60229),rootFolder:(0,n.$Zj)("root-folder",60230),rss:(0,n.$Zj)("rss",60231),ruby:(0,n.$Zj)("ruby",60232),saveAll:(0,n.$Zj)("save-all",60233),saveAs:(0,n.$Zj)("save-as",60234),save:(0,n.$Zj)("save",60235),screenFull:(0,n.$Zj)("screen-full",60236),screenNormal:(0,n.$Zj)("screen-normal",60237),searchStop:(0,n.$Zj)("search-stop",60238),server:(0,n.$Zj)("server",60240),settingsGear:(0,n.$Zj)("settings-gear",60241),settings:(0,n.$Zj)("settings",60242),shield:(0,n.$Zj)("shield",60243),smiley:(0,n.$Zj)("smiley",60244),sortPrecedence:(0,n.$Zj)("sort-precedence",60245),splitHorizontal:(0,n.$Zj)("split-horizontal",60246),splitVertical:(0,n.$Zj)("split-vertical",60247),squirrel:(0,n.$Zj)("squirrel",60248),starFull:(0,n.$Zj)("star-full",60249),starHalf:(0,n.$Zj)("star-half",60250),symbolClass:(0,n.$Zj)("symbol-class",60251),symbolColor:(0,n.$Zj)("symbol-color",60252),symbolConstant:(0,n.$Zj)("symbol-constant",60253),symbolEnumMember:(0,n.$Zj)("symbol-enum-member",60254),symbolField:(0,n.$Zj)("symbol-field",60255),symbolFile:(0,n.$Zj)("symbol-file",60256),symbolInterface:(0,n.$Zj)("symbol-interface",60257),symbolKeyword:(0,n.$Zj)("symbol-keyword",60258),symbolMisc:(0,n.$Zj)("symbol-misc",60259),symbolOperator:(0,n.$Zj)("symbol-operator",60260),symbolProperty:(0,n.$Zj)("symbol-property",60261),wrench:(0,n.$Zj)("wrench",60261),wrenchSubaction:(0,n.$Zj)("wrench-subaction",60261),symbolSnippet:(0,n.$Zj)("symbol-snippet",60262),tasklist:(0,n.$Zj)("tasklist",60263),telescope:(0,n.$Zj)("telescope",60264),textSize:(0,n.$Zj)("text-size",60265),threeBars:(0,n.$Zj)("three-bars",60266),thumbsdown:(0,n.$Zj)("thumbsdown",60267),thumbsup:(0,n.$Zj)("thumbsup",60268),tools:(0,n.$Zj)("tools",60269),triangleDown:(0,n.$Zj)("triangle-down",60270),triangleLeft:(0,n.$Zj)("triangle-left",60271),triangleRight:(0,n.$Zj)("triangle-right",60272),triangleUp:(0,n.$Zj)("triangle-up",60273),twitter:(0,n.$Zj)("twitter",60274),unfold:(0,n.$Zj)("unfold",60275),unlock:(0,n.$Zj)("unlock",60276),unmute:(0,n.$Zj)("unmute",60277),unverified:(0,n.$Zj)("unverified",60278),verified:(0,n.$Zj)("verified",60279),versions:(0,n.$Zj)("versions",60280),vmActive:(0,n.$Zj)("vm-active",60281),vmOutline:(0,n.$Zj)("vm-outline",60282),vmRunning:(0,n.$Zj)("vm-running",60283),watch:(0,n.$Zj)("watch",60284),whitespace:(0,n.$Zj)("whitespace",60285),wholeWord:(0,n.$Zj)("whole-word",60286),window:(0,n.$Zj)("window",60287),wordWrap:(0,n.$Zj)("word-wrap",60288),zoomIn:(0,n.$Zj)("zoom-in",60289),zoomOut:(0,n.$Zj)("zoom-out",60290),listFilter:(0,n.$Zj)("list-filter",60291),listFlat:(0,n.$Zj)("list-flat",60292),listSelection:(0,n.$Zj)("list-selection",60293),selection:(0,n.$Zj)("selection",60293),listTree:(0,n.$Zj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Zj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Zj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Zj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Zj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Zj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Zj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Zj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Zj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Zj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Zj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Zj)("symbol-string",60301),debugReverseContinue:(0,n.$Zj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Zj)("debug-step-back",60303),debugRestartFrame:(0,n.$Zj)("debug-restart-frame",60304),debugAlt:(0,n.$Zj)("debug-alt",60305),callIncoming:(0,n.$Zj)("call-incoming",60306),callOutgoing:(0,n.$Zj)("call-outgoing",60307),menu:(0,n.$Zj)("menu",60308),expandAll:(0,n.$Zj)("expand-all",60309),feedback:(0,n.$Zj)("feedback",60310),gitPullRequestReviewer:(0,n.$Zj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Zj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Zj)("ungroup-by-ref-type",60312),account:(0,n.$Zj)("account",60313),gitPullRequestAssignee:(0,n.$Zj)("git-pull-request-assignee",60313),bellDot:(0,n.$Zj)("bell-dot",60314),debugConsole:(0,n.$Zj)("debug-console",60315),library:(0,n.$Zj)("library",60316),output:(0,n.$Zj)("output",60317),runAll:(0,n.$Zj)("run-all",60318),syncIgnored:(0,n.$Zj)("sync-ignored",60319),pinned:(0,n.$Zj)("pinned",60320),githubInverted:(0,n.$Zj)("github-inverted",60321),serverProcess:(0,n.$Zj)("server-process",60322),serverEnvironment:(0,n.$Zj)("server-environment",60323),pass:(0,n.$Zj)("pass",60324),issueClosed:(0,n.$Zj)("issue-closed",60324),stopCircle:(0,n.$Zj)("stop-circle",60325),playCircle:(0,n.$Zj)("play-circle",60326),record:(0,n.$Zj)("record",60327),debugAltSmall:(0,n.$Zj)("debug-alt-small",60328),vmConnect:(0,n.$Zj)("vm-connect",60329),cloud:(0,n.$Zj)("cloud",60330),merge:(0,n.$Zj)("merge",60331),export:(0,n.$Zj)("export",60332),graphLeft:(0,n.$Zj)("graph-left",60333),magnet:(0,n.$Zj)("magnet",60334),notebook:(0,n.$Zj)("notebook",60335),redo:(0,n.$Zj)("redo",60336),checkAll:(0,n.$Zj)("check-all",60337),pinnedDirty:(0,n.$Zj)("pinned-dirty",60338),passFilled:(0,n.$Zj)("pass-filled",60339),circleLargeFilled:(0,n.$Zj)("circle-large-filled",60340),circleLarge:(0,n.$Zj)("circle-large",60341),circleLargeOutline:(0,n.$Zj)("circle-large-outline",60341),combine:(0,n.$Zj)("combine",60342),gather:(0,n.$Zj)("gather",60342),table:(0,n.$Zj)("table",60343),variableGroup:(0,n.$Zj)("variable-group",60344),typeHierarchy:(0,n.$Zj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Zj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Zj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Zj)("git-pull-request-create",60348),runAbove:(0,n.$Zj)("run-above",60349),runBelow:(0,n.$Zj)("run-below",60350),notebookTemplate:(0,n.$Zj)("notebook-template",60351),debugRerun:(0,n.$Zj)("debug-rerun",60352),workspaceTrusted:(0,n.$Zj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Zj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Zj)("workspace-unknown",60355),terminalCmd:(0,n.$Zj)("terminal-cmd",60356),terminalDebian:(0,n.$Zj)("terminal-debian",60357),terminalLinux:(0,n.$Zj)("terminal-linux",60358),terminalPowershell:(0,n.$Zj)("terminal-powershell",60359),terminalTmux:(0,n.$Zj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Zj)("terminal-ubuntu",60361),terminalBash:(0,n.$Zj)("terminal-bash",60362),arrowSwap:(0,n.$Zj)("arrow-swap",60363),copy:(0,n.$Zj)("copy",60364),personAdd:(0,n.$Zj)("person-add",60365),filterFilled:(0,n.$Zj)("filter-filled",60366),wand:(0,n.$Zj)("wand",60367),debugLineByLine:(0,n.$Zj)("debug-line-by-line",60368),inspect:(0,n.$Zj)("inspect",60369),layers:(0,n.$Zj)("layers",60370),layersDot:(0,n.$Zj)("layers-dot",60371),layersActive:(0,n.$Zj)("layers-active",60372),compass:(0,n.$Zj)("compass",60373),compassDot:(0,n.$Zj)("compass-dot",60374),compassActive:(0,n.$Zj)("compass-active",60375),azure:(0,n.$Zj)("azure",60376),issueDraft:(0,n.$Zj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Zj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Zj)("git-pull-request-draft",60379),debugAll:(0,n.$Zj)("debug-all",60380),debugCoverage:(0,n.$Zj)("debug-coverage",60381),runErrors:(0,n.$Zj)("run-errors",60382),folderLibrary:(0,n.$Zj)("folder-library",60383),debugContinueSmall:(0,n.$Zj)("debug-continue-small",60384),beakerStop:(0,n.$Zj)("beaker-stop",60385),graphLine:(0,n.$Zj)("graph-line",60386),graphScatter:(0,n.$Zj)("graph-scatter",60387),pieChart:(0,n.$Zj)("pie-chart",60388),bracket:(0,n.$Zj)("bracket",60175),bracketDot:(0,n.$Zj)("bracket-dot",60389),bracketError:(0,n.$Zj)("bracket-error",60390),lockSmall:(0,n.$Zj)("lock-small",60391),azureDevops:(0,n.$Zj)("azure-devops",60392),verifiedFilled:(0,n.$Zj)("verified-filled",60393),newline:(0,n.$Zj)("newline",60394),layout:(0,n.$Zj)("layout",60395),layoutActivitybarLeft:(0,n.$Zj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Zj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Zj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Zj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Zj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Zj)("layout-panel-right",60401),layoutPanel:(0,n.$Zj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Zj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Zj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Zj)("layout-statusbar",60405),layoutMenubar:(0,n.$Zj)("layout-menubar",60406),layoutCentered:(0,n.$Zj)("layout-centered",60407),target:(0,n.$Zj)("target",60408),indent:(0,n.$Zj)("indent",60409),recordSmall:(0,n.$Zj)("record-small",60410),errorSmall:(0,n.$Zj)("error-small",60411),terminalDecorationError:(0,n.$Zj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Zj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Zj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Zj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Zj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Zj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Zj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Zj)("layout-sidebar-left-off",60418),blank:(0,n.$Zj)("blank",60419),heartFilled:(0,n.$Zj)("heart-filled",60420),map:(0,n.$Zj)("map",60421),mapHorizontal:(0,n.$Zj)("map-horizontal",60421),foldHorizontal:(0,n.$Zj)("fold-horizontal",60421),mapFilled:(0,n.$Zj)("map-filled",60422),mapHorizontalFilled:(0,n.$Zj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Zj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Zj)("circle-small",60423),bellSlash:(0,n.$Zj)("bell-slash",60424),bellSlashDot:(0,n.$Zj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Zj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Zj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Zj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Zj)("search-fuzzy",60429),commentDraft:(0,n.$Zj)("comment-draft",60430),send:(0,n.$Zj)("send",60431),sparkle:(0,n.$Zj)("sparkle",60432),insert:(0,n.$Zj)("insert",60433),mic:(0,n.$Zj)("mic",60434),thumbsdownFilled:(0,n.$Zj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Zj)("thumbsup-filled",60436),coffee:(0,n.$Zj)("coffee",60437),snake:(0,n.$Zj)("snake",60438),game:(0,n.$Zj)("game",60439),vr:(0,n.$Zj)("vr",60440),chip:(0,n.$Zj)("chip",60441),piano:(0,n.$Zj)("piano",60442),music:(0,n.$Zj)("music",60443),micFilled:(0,n.$Zj)("mic-filled",60444),repoFetch:(0,n.$Zj)("repo-fetch",60445),copilot:(0,n.$Zj)("copilot",60446),lightbulbSparkle:(0,n.$Zj)("lightbulb-sparkle",60447),robot:(0,n.$Zj)("robot",60448),sparkleFilled:(0,n.$Zj)("sparkle-filled",60449),diffSingle:(0,n.$Zj)("diff-single",60450),diffMultiple:(0,n.$Zj)("diff-multiple",60451),surroundWith:(0,n.$Zj)("surround-with",60452),share:(0,n.$Zj)("share",60453),gitStash:(0,n.$Zj)("git-stash",60454),gitStashApply:(0,n.$Zj)("git-stash-apply",60455),gitStashPop:(0,n.$Zj)("git-stash-pop",60456),vscode:(0,n.$Zj)("vscode",60457),vscodeInsiders:(0,n.$Zj)("vscode-insiders",60458),codeOss:(0,n.$Zj)("code-oss",60459),runCoverage:(0,n.$Zj)("run-coverage",60460),runAllCoverage:(0,n.$Zj)("run-all-coverage",60461),coverage:(0,n.$Zj)("coverage",60462),githubProject:(0,n.$Zj)("github-project",60463),mapVertical:(0,n.$Zj)("map-vertical",60464),foldVertical:(0,n.$Zj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Zj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Zj)("fold-vertical-filled",60465),goToSearch:(0,n.$Zj)("go-to-search",60466),percentage:(0,n.$Zj)("percentage",60467),sortPercentage:(0,n.$Zj)("sort-percentage",60467),attach:(0,n.$Zj)("attach",60468)}}),define(oe[80],ae([0,1,110,147]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=void 0,e.$3j=P;function P(){return Object.values(e.$5j)}e.$4j={dialogError:(0,n.$Zj)("dialog-error","error"),dialogWarning:(0,n.$Zj)("dialog-warning","warning"),dialogInfo:(0,n.$Zj)("dialog-info","info"),dialogClose:(0,n.$Zj)("dialog-close","close"),treeItemExpanded:(0,n.$Zj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Zj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Zj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Zj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Zj)("tree-item-loading","loading"),menuSelection:(0,n.$Zj)("menu-selection","check"),menuSubmenu:(0,n.$Zj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Zj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Zj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Zj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Zj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Zj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Zj)("toolbar-more","more"),quickInputBack:(0,n.$Zj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Zj)("drop-down-button",60084),symbolCustomColor:(0,n.$Zj)("symbol-customcolor",60252),exportIcon:(0,n.$Zj)("export",60332),workspaceUnspecified:(0,n.$Zj)("workspace-unspecified",60355),newLine:(0,n.$Zj)("newline",60394),thumbsDownFilled:(0,n.$Zj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Zj)("thumbsup-filled",60436),gitFetch:(0,n.$Zj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Zj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Zj)("debug-breakpoint-pending",60377)},e.$5j={...o.$2j,...e.$4j}}),define(oe[36],ae([0,1,13]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=o,e.$eo=P,e.$fo=A,e.$go=b,e.$ho=a,e.$io=f,e.$jo=d,e.$ko=g,e.$lo=w,e.$mo=h,e.$no=p,e.$oo=y,e.$po=$;function o(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const E=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([k,t])=>{E[k]=t&&typeof t=="object"?o(t):t}),E}function P(m){if(!m||typeof m!="object")return m;const E=[m];for(;E.length>0;){const k=E.shift();Object.freeze(k);for(const t in k)if(D.call(k,t)){const r=k[t];typeof r=="object"&&!Object.isFrozen(r)&&!(0,n.$ig)(r)&&E.push(r)}}return m}const D=Object.prototype.hasOwnProperty;function A(m,E){return I(m,E,new Set)}function I(m,E,k){if((0,n.$og)(m))return m;const t=E(m);if(typeof t<"u")return t;if(Array.isArray(m)){const r=[];for(const i of m)r.push(I(i,E,k));return r}if((0,n.$hg)(m)){if(k.has(m))throw new Error("Cannot clone recursive data-structure");k.add(m);const r={};for(const i in m)D.call(m,i)&&(r[i]=I(m[i],E,k));return k.delete(m),r}return m}function b(m,E,k=!0){return(0,n.$hg)(m)?((0,n.$hg)(E)&&Object.keys(E).forEach(t=>{t in m?k&&((0,n.$hg)(m[t])&&(0,n.$hg)(E[t])?b(m[t],E[t],k):m[t]=E[t]):m[t]=E[t]}),m):E}function a(m,E){if(m===E)return!0;if(m==null||E===null||E===void 0||typeof m!=typeof E||typeof m!="object"||Array.isArray(m)!==Array.isArray(E))return!1;let k,t;if(Array.isArray(m)){if(m.length!==E.length)return!1;for(k=0;k<m.length;k++)if(!a(m[k],E[k]))return!1}else{const r=[];for(t in m)r.push(t);r.sort();const i=[];for(t in E)i.push(t);if(i.sort(),!a(r,i))return!1;for(k=0;k<r.length;k++)if(!a(m[r[k]],E[r[k]]))return!1}return!0}function f(m){const E=new Set;return JSON.stringify(m,(k,t)=>{if((0,n.$hg)(t)||Array.isArray(t)){if(E.has(t))return"[Circular]";E.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function d(m,E){const k=Object.create(null);return!m||!E||Object.keys(E).forEach(r=>{const i=m[r],c=E[r];a(i,c)||(k[r]=c)}),k}function g(m,E){const k=E.toLowerCase(),t=Object.keys(m).find(r=>r.toLowerCase()===k);return t?m[t]:m[E]}function w(m,E){const k=Object.create(null);for(const[t,r]of Object.entries(m))E(t,r)&&(k[t]=r);return k}function h(m){let E=[];for(;Object.prototype!==m;)E=E.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return E}function p(m){const E=[];for(const k of h(m))typeof m[k]=="function"&&E.push(k);return E}function y(m,E){const k=r=>function(){const i=Array.prototype.slice.call(arguments,0);return E(r,i)},t={};for(const r of m)t[r]=k(r);return t}function $(m,E){const k={};for(const[t,r]of Object.entries(m))k[t]=E(r,t);return k}}),define(oe[111],ae([0,1,80]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$6j=P;var o;(function(A){function I(b){return b&&typeof b=="object"&&typeof b.id=="string"}A.isThemeColor=I})(o||(e.ThemeColor=o={}));function P(A){return{id:A}}var D;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(m){const E=I.exec(m.id);if(!E)return b(n.$5j.error);const[,k,t]=E,r=["codicon","codicon-"+k];return t&&r.push("codicon-modifier-"+t.substring(1)),r}A.asClassNameArray=b;function a(m){return b(m).join(" ")}A.asClassName=a;function f(m){return"."+b(m).join(".")}A.asCSSSelector=f;function d(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||o.isThemeColor(m.color))}A.isThemeIcon=d;const g=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function w(m){const E=g.exec(m);if(!E)return;const[,k]=E;return{id:k}}A.fromString=w;function h(m){return{id:m}}A.fromId=h;function p(m,E){let k=m.id;const t=k.lastIndexOf("~");return t!==-1&&(k=k.substring(0,t)),E&&(k=`${k}~${E}`),{id:k}}A.modify=p;function y(m){const E=m.id.lastIndexOf("~");if(E!==-1)return m.id.substring(E+1)}A.getModifier=y;function $(m,E){return m.id===E.id&&m.color?.id===E.color?.id}A.isEqual=$})(D||(e.ThemeIcon=D={}))}),define(oe[148],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$bf=o,e.$cf=P;var n;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function o(D){return D<0?0:D>n.MAX_UINT_8?n.MAX_UINT_8:D|0}function P(D){return D<0?0:D>n.MAX_UINT_32?n.MAX_UINT_32:D|0}}),define(oe[26],ae([0,1,145,39,66,148]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.GraphemeBreakType=e.$5f=e.$Wf=e.$Pf=e.$Of=void 0,e.$df=A,e.$ef=b,e.$ff=f,e.$gf=d,e.$hf=g,e.$if=w,e.$jf=h,e.$kf=p,e.$lf=y,e.$mf=$,e.$nf=m,e.$of=E,e.$pf=k,e.$qf=t,e.$rf=r,e.$sf=i,e.$tf=c,e.$uf=s,e.$vf=u,e.$wf=l,e.$xf=S,e.$yf=v,e.$zf=R,e.$Af=T,e.$Bf=L,e.$Cf=O,e.$Df=F,e.$Ef=B,e.$Ff=C,e.$Gf=z,e.$Hf=re,e.$If=Q,e.$Jf=le,e.$Kf=K,e.$Lf=ee,e.$Mf=q,e.$Nf=j,e.$Qf=G,e.$Rf=he,e.$Sf=se,e.$Tf=_,e.$Uf=W,e.$Vf=J,e.$Xf=X,e.$Yf=Z,e.$Zf=ie,e.$1f=de,e.$2f=we,e.$3f=Oe,e.$4f=ke,e.$6f=Ie,e.$7f=$e,e.$8f=Y,e.$9f=ue,e.$0f=fe,e.$$f=be,e.$_f=Re,e.$ag=We,e.$bg=Ye;function A(te){return!te||typeof te!="string"?!0:te.trim().length===0}const I=/{(\d+)}/g;function b(te,...ge){return ge.length===0?te:te.replace(I,function(pe,ye){const Me=parseInt(ye,10);return isNaN(Me)||Me<0||Me>=ge.length?pe:ge[Me]})}const a=/{([^}]+)}/g;function f(te,ge){return Object.keys(ge).length===0?te:te.replace(a,(pe,ye)=>ge[ye]??pe)}function d(te){return te.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function g(te){return te.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function w(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function h(te,ge){let pe=0,ye=te.indexOf(ge);for(;ye!==-1;)pe++,ye=te.indexOf(ge,ye+ge.length);return pe}function p(te,ge,pe="\u2026"){return te.length<=ge?te:`${te.substr(0,ge)}${pe}`}function y(te,ge,pe="\u2026"){if(te.length<=ge)return te;const ye=Math.ceil(ge/2)-pe.length/2,Me=Math.floor(ge/2)-pe.length/2;return`${te.substr(0,ye)}${pe}${te.substr(te.length-Me)}`}function $(te,ge=" "){const pe=m(te,ge);return E(pe,ge)}function m(te,ge){if(!te||!ge)return te;const pe=ge.length;if(pe===0||te.length===0)return te;let ye=0;for(;te.indexOf(ge,ye)===ye;)ye=ye+pe;return te.substring(ye)}function E(te,ge){if(!te||!ge)return te;const pe=ge.length,ye=te.length;if(pe===0||ye===0)return te;let Me=ye,Be=-1;for(;Be=te.lastIndexOf(ge,Me-1),!(Be===-1||Be+pe!==Me);){if(Be===0)return"";Me=Be}return te.substring(0,Me)}function k(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(te){return te.replace(/\*/g,"")}function r(te,ge,pe={}){if(!te)throw new Error("Cannot create regex from empty string");ge||(te=w(te)),pe.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(te,ye)}function i(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}function c(te){return te.split(/\r\n|\r|\n/)}function s(te){const ge=[],pe=te.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)ge.push(pe[2*ye]+(pe[2*ye+1]??""));return ge}function u(te){for(let ge=0,pe=te.length;ge<pe;ge++){const ye=te.charCodeAt(ge);if(ye!==o.CharCode.Space&&ye!==o.CharCode.Tab)return ge}return-1}function l(te,ge=0,pe=te.length){for(let ye=ge;ye<pe;ye++){const Me=te.charCodeAt(ye);if(Me!==o.CharCode.Space&&Me!==o.CharCode.Tab)return te.substring(ge,ye)}return te.substring(ge,pe)}function S(te,ge=te.length-1){for(let pe=ge;pe>=0;pe--){const ye=te.charCodeAt(pe);if(ye!==o.CharCode.Space&&ye!==o.CharCode.Tab)return pe}return-1}function v(te,ge,pe){const ye=[];let Me=0;for(const Be of te.matchAll(ge)){if(ye.push(te.slice(Me,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");Me=Be.index+Be[0].length,ye.push(pe(Be[0],...Be.slice(1),Be.index,te,Be.groups))}return ye.push(te.slice(Me)),Promise.all(ye).then(Be=>Be.join(""))}function R(te,ge){return te<ge?-1:te>ge?1:0}function T(te,ge,pe=0,ye=te.length,Me=0,Be=ge.length){for(;pe<ye&&Me<Be;pe++,Me++){const at=te.charCodeAt(pe),rt=ge.charCodeAt(Me);if(at<rt)return-1;if(at>rt)return 1}const Je=ye-pe,lt=Be-Me;return Je<lt?-1:Je>lt?1:0}function L(te,ge){return O(te,ge,0,te.length,0,ge.length)}function O(te,ge,pe=0,ye=te.length,Me=0,Be=ge.length){for(;pe<ye&&Me<Be;pe++,Me++){let at=te.charCodeAt(pe),rt=ge.charCodeAt(Me);if(at===rt)continue;if(at>=128||rt>=128)return T(te.toLowerCase(),ge.toLowerCase(),pe,ye,Me,Be);B(at)&&(at-=32),B(rt)&&(rt-=32);const tt=at-rt;if(tt!==0)return tt}const Je=ye-pe,lt=Be-Me;return Je<lt?-1:Je>lt?1:0}function F(te){return te>=o.CharCode.Digit0&&te<=o.CharCode.Digit9}function B(te){return te>=o.CharCode.a&&te<=o.CharCode.z}function C(te){return te>=o.CharCode.A&&te<=o.CharCode.Z}function z(te,ge){return te.length===ge.length&&O(te,ge)===0}function re(te,ge){const pe=ge.length;return ge.length>te.length?!1:O(te,ge,0,pe)===0}function Q(te,ge){const pe=Math.min(te.length,ge.length);let ye;for(ye=0;ye<pe;ye++)if(te.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return pe}function le(te,ge){const pe=Math.min(te.length,ge.length);let ye;const Me=te.length-1,Be=ge.length-1;for(ye=0;ye<pe;ye++)if(te.charCodeAt(Me-ye)!==ge.charCodeAt(Be-ye))return ye;return pe}function K(te){return 55296<=te&&te<=56319}function ee(te){return 56320<=te&&te<=57343}function q(te,ge){return(te-55296<<10)+(ge-56320)+65536}function j(te,ge,pe){const ye=te.charCodeAt(pe);if(K(ye)&&pe+1<ge){const Me=te.charCodeAt(pe+1);if(ee(Me))return q(ye,Me)}return ye}function U(te,ge){const pe=te.charCodeAt(ge-1);if(ee(pe)&&ge>1){const ye=te.charCodeAt(ge-2);if(K(ye))return q(ye,pe)}return pe}class V{get offset(){return this.e}constructor(ge,pe=0){this.c=ge,this.d=ge.length,this.e=pe}setOffset(ge){this.e=ge}prevCodePoint(){const ge=U(this.c,this.e);return this.e-=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=j(this.c,this.d,this.e);return this.e+=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Of=V;class ce{get offset(){return this.c.offset}constructor(ge,pe=0){this.c=new V(ge,pe)}nextGraphemeLength(){const ge=Ue.getInstance(),pe=this.c,ye=pe.offset;let Me=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Be=pe.offset,Je=ge.getGraphemeBreakType(pe.nextCodePoint());if(Fe(Me,Je)){pe.setOffset(Be);break}Me=Je}return pe.offset-ye}prevGraphemeLength(){const ge=Ue.getInstance(),pe=this.c,ye=pe.offset;let Me=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Be=pe.offset,Je=ge.getGraphemeBreakType(pe.prevCodePoint());if(Fe(Je,Me)){pe.setOffset(Be);break}Me=Je}return ye-pe.offset}eol(){return this.c.eol()}}e.$Pf=ce;function G(te,ge){return new ce(te,ge).nextGraphemeLength()}function he(te,ge){return new ce(te,ge).prevGraphemeLength()}function se(te,ge){ge>0&&ee(te.charCodeAt(ge))&&ge--;const pe=ge+G(te,ge);return[pe-he(te,pe),pe]}function _(te){const ge=new ce(te);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}let M;function N(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(te){return M||(M=N()),M.test(te)}const H=/^[\t\n\r\x20-\x7E]*$/;function J(te){return H.test(te)}e.$Wf=/[\u2028\u2029]/;function X(te){return e.$Wf.test(te)}function Z(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}function ie(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}function de(te,ge,pe=""){const ye=te.trimStart();if(ye.length<ge)return ye;const Me=/\b/g;let Be=0;for(;Me.test(ye)&&!(ye.length-Me.lastIndex<ge);)Be=Me.lastIndex,Me.lastIndex+=1;return Be===0?ye:pe+ye.substring(Be).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(te){let ge=0;for(const pe of te.matchAll(me))ge!==pe.index&&(yield{isCode:!1,str:te.substring(ge,pe.index)}),yield{isCode:!0,str:pe[0]},ge=pe.index+pe[0].length;ge!==te.length&&(yield{isCode:!1,str:te.substring(ge)})}function Oe(te){return te&&(te=te.replace(me,"")),te}const Se=/\\\[.*?\\\]/g;function ke(te){return Oe(te).replace(Se,"")}e.$5f=String.fromCharCode(o.CharCode.UTF8_BOM);function Ie(te){return!!(te&&te.length>0&&te.charCodeAt(0)===o.CharCode.UTF8_BOM)}function $e(te){return Ie(te)?te.substr(1):te}function Y(te,ge){if(!te||!ge||te.length<ge.length)return!1;const pe=ge.length,ye=te.toLowerCase();let Me=0,Be=-1;for(;Me<pe;){const Je=ye.indexOf(ge[Me],Be+1);if(Je<0)return!1;Be=Je,Me++}return!0}function ue(te,ge=!1){return te?(ge&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}function fe(te){return te.charAt(0).toUpperCase()+te.slice(1)}function be(te,ge=1){if(ge===0)return"";let pe=-1;do pe=te.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?te:(te[pe-1]==="\r"&&pe--,te.substr(0,pe))}function Re(te){const ge=o.CharCode.Z-o.CharCode.A+1;return te=te%(2*ge),te<ge?String.fromCharCode(o.CharCode.a+te):String.fromCharCode(o.CharCode.A+te-ge)}function We(te){return Ue.getInstance().getGraphemeBreakType(te)}function Fe(te,ge){return te===Le.Other?ge!==Le.Extend&&ge!==Le.SpacingMark:te===Le.CR&&ge===Le.LF?!1:te===Le.Control||te===Le.CR||te===Le.LF||ge===Le.Control||ge===Le.CR||ge===Le.LF?!0:!(te===Le.L&&(ge===Le.L||ge===Le.V||ge===Le.LV||ge===Le.LVT)||(te===Le.LV||te===Le.V)&&(ge===Le.V||ge===Le.T)||(te===Le.LVT||te===Le.T)&&ge===Le.T||ge===Le.Extend||ge===Le.ZWJ||ge===Le.SpacingMark||te===Le.Prepend||te===Le.ZWJ&&ge===Le.Extended_Pictographic||te===Le.Regional_Indicator&&ge===Le.Regional_Indicator)}var Le;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=Ve()}getGraphemeBreakType(ge){if(ge<32)return ge===o.CharCode.LineFeed?Le.LF:ge===o.CharCode.CarriageReturn?Le.CR:Le.Control;if(ge<127)return Le.Other;const pe=this.d,ye=pe.length/3;let Me=1;for(;Me<=ye;)if(ge<pe[3*Me])Me=2*Me;else if(ge>pe[3*Me+1])Me=2*Me+1;else return pe[3*Me+2];return Le.Other}}function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ye(te,ge){if(te===0)return 0;const pe=He(te,ge);if(pe!==void 0)return pe;const ye=new V(ge,te);return ye.prevCodePoint(),ye.offset}function He(te,ge){const pe=new V(ge,te);let ye=pe.prevCodePoint();for(;Ke(ye)||ye===Xe.emojiVariantSelector||ye===Xe.enclosingKeyCap;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!ie(ye))return;let Me=pe.offset;return Me>0&&pe.prevCodePoint()===Xe.zwj&&(Me=pe.offset),Me}function Ke(te){return 127995<=te&&te<=127999}var Xe;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.$cg="\xA0";class _e{static{this.c=new P.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$_e({getCacheKey:JSON.stringify},ge=>{function pe(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function ye(tt,ut){const ct=new Map(tt);for(const[ft,gt]of ut)ct.set(ft,gt);return ct}function Me(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ft,gt]of tt)ut.has(ft)&&ct.set(ft,gt);return ct}const Be=this.c.value;let Je=ge.filter(tt=>!tt.startsWith("_")&&tt in Be);Je.length===0&&(Je=["_default"]);let lt;for(const tt of Je){const ut=pe(Be[tt]);lt=Me(lt,ut)}const at=pe(Be._common),rt=ye(at,lt);return new _e(rt)})}static getInstance(ge){return _e.d.get(Array.from(ge))}static{this.e=new P.$X(()=>Object.keys(_e.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return _e.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$dg=_e;class Ne{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ne.c())),this.d}static isInvisibleCharacter(ge){return Ne.e().has(ge)}static containsInvisibleCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&Ne.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ne.e()}}e.$eg=Ne}),define(oe[46],ae([0,1,26]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$xj=void 0,e.$tj=o,e.$uj=P,e.$vj=D,e.$wj=I,e.$yj=p,n=De(n);function o($){return P($,0)}function P($,m){switch(typeof $){case"object":return $===null?D(349,m):Array.isArray($)?b($,m):a($,m);case"string":return I($,m);case"boolean":return A($,m);case"number":return D($,m);case"undefined":return D(937,m);default:return D(617,m)}}function D($,m){return(m<<5)-m+$|0}function A($,m){return D($?433:863,m)}function I($,m){m=D(149417,m);for(let E=0,k=$.length;E<k;E++)m=D($.charCodeAt(E),m);return m}function b($,m){return m=D(104579,m),$.reduce((E,k)=>P(k,E),m)}function a($,m){return m=D(181387,m),Object.keys($).sort().reduce((E,k)=>(E=I(k,E),P($[k],E)),m)}class f{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=P(m,this.g),this.g}}e.$xj=f;var d;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(d||(d={}));function g($,m,E=32){const k=E-m,t=~((1<<k)-1);return($<<m|(t&$)>>>k)>>>0}function w($,m=0,E=$.byteLength,k=0){for(let t=0;t<E;t++)$[m+t]=k}function h($,m,E="0"){for(;$.length<m;)$=E+$;return $}function p($,m=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(E=>E.toString(16).padStart(2,"0")).join(""):h(($>>>0).toString(16),m/4)}class y{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(d.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const E=m.length;if(E===0)return;const k=this.p;let t=this.r,r=this.u,i,c;for(r!==0?(i=r,c=-1,r=0):(i=m.charCodeAt(0),c=0);;){let s=i;if(n.$Kf(i))if(c+1<E){const u=m.charCodeAt(c+1);n.$Lf(u)?(c++,s=n.$Mf(i,u)):s=d.UNICODE_REPLACEMENT}else{r=i;break}else n.$Lf(i)&&(s=d.UNICODE_REPLACEMENT);if(t=this.w(k,t,s),c++,c<E)i=m.charCodeAt(c);else break}this.r=t,this.u=r}w(m,E,k){return k<128?m[E++]=k:k<2048?(m[E++]=192|(k&1984)>>>6,m[E++]=128|(k&63)>>>0):k<65536?(m[E++]=224|(k&61440)>>>12,m[E++]=128|(k&4032)>>>6,m[E++]=128|(k&63)>>>0):(m[E++]=240|(k&1835008)>>>18,m[E++]=128|(k&258048)>>>12,m[E++]=128|(k&4032)>>>6,m[E++]=128|(k&63)>>>0),E>=d.BLOCK_SIZE&&(this.y(),E-=d.BLOCK_SIZE,this.t+=d.BLOCK_SIZE,m[0]=m[d.BLOCK_SIZE+0],m[1]=m[d.BLOCK_SIZE+1],m[2]=m[d.BLOCK_SIZE+2]),E}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,d.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=y.g,E=this.q;for(let S=0;S<64;S+=4)m.setUint32(S,E.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)m.setUint32(S,g(m.getUint32(S-12,!1)^m.getUint32(S-32,!1)^m.getUint32(S-56,!1)^m.getUint32(S-64,!1),1),!1);let k=this.h,t=this.l,r=this.m,i=this.n,c=this.o,s,u,l;for(let S=0;S<80;S++)S<20?(s=t&r|~t&i,u=1518500249):S<40?(s=t^r^i,u=1859775393):S<60?(s=t&r|t&i|r&i,u=2400959708):(s=t^r^i,u=3395469782),l=g(k,5)+s+c+u+m.getUint32(S*4,!1)&4294967295,c=i,i=r,r=g(t,30),t=k,k=l;this.h=this.h+k&4294967295,this.l=this.l+t&4294967295,this.m=this.m+r&4294967295,this.n=this.n+i&4294967295,this.o=this.o+c&4294967295}}e.$zj=y}),define(oe[81],ae([0,1,26]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n=De(n);var o;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(o||(o={})),function(P){const D="error",A="warning",I="warn",b="info",a="ignore";function f(g){return g?n.$Gf(D,g)?P.Error:n.$Gf(A,g)||n.$Gf(I,g)?P.Warning:n.$Gf(b,g)?P.Info:P.Ignore:P.Ignore}P.fromValue=f;function d(g){switch(g){case P.Error:return D;case P.Warning:return A;case P.Info:return b;default:return a}}P.toString=d}(o||(o={})),e.default=o}),define(oe[61],ae([0,1,22,39,26]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class D{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const p=h.charCodeAt(0),y=this.b.charCodeAt(this.c);return p-y}value(){return this.b[this.c]}}e.$Hi=D;class A{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===o.CharCode.Period)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,P.$Af)(h,this.b,0,h.length,this.c,this.d):(0,P.$Cf)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=A;class I{constructor(h=!0,p=!0){this.f=h,this.g=p}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let p=h.length-1;p>=0;p--,this.c--){const y=this.b.charCodeAt(p);if(!(y===o.CharCode.Slash||this.f&&y===o.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===o.CharCode.Slash||this.f&&p===o.CharCode.Backslash)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,P.$Af)(h,this.b,0,h.length,this.d,this.e):(0,P.$Cf)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=I;var b;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(b||(b={}));class a{constructor(h,p){this.f=h,this.g=p,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(b.Scheme),this.c.authority&&this.d.push(b.Authority),this.c.path&&(this.b=new I(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(b.Path)),this.g(h)||(this.c.query&&this.d.push(b.Query),this.c.fragment&&this.d.push(b.Fragment)),this.e=0,this}next(){return this.d[this.e]===b.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===b.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===b.Scheme)return(0,P.$Bf)(h,this.c.scheme);if(this.d[this.e]===b.Authority)return(0,P.$Bf)(h,this.c.authority);if(this.d[this.e]===b.Path)return this.b.cmp(h);if(this.d[this.e]===b.Query)return(0,P.$zf)(h,this.c.query);if(this.d[this.e]===b.Fragment)return(0,P.$zf)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===b.Scheme)return this.c.scheme;if(this.d[this.e]===b.Authority)return this.c.authority;if(this.d[this.e]===b.Path)return this.b.value();if(this.d[this.e]===b.Query)return this.c.query;if(this.d[this.e]===b.Fragment)return this.c.fragment;throw new Error}}e.$Ki=a;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(d||(d={}));class g{static forUris(h=()=>!1,p=()=>!1){return new g(new a(h,p))}static forPaths(h=!1){return new g(new I(void 0,!h))}static forStrings(){return new g(new D)}static forConfigKeys(){return new g(new A)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,p){if(p){const y=p.slice(0);(0,n.$Yb)(y);for(const $ of y)this.set($,h)}else{const y=h.slice(0);(0,n.$Yb)(y);for(const $ of y)this.set($[0],$[1])}}set(h,p){const y=this.b.reset(h);let $;this.c||(this.c=new f,this.c.segment=y.value());const m=[];for($=this.c;;){const k=y.cmp($.segment);if(k>0)$.left||($.left=new f,$.left.segment=y.value()),m.push([d.Left,$]),$=$.left;else if(k<0)$.right||($.right=new f,$.right.segment=y.value()),m.push([d.Right,$]),$=$.right;else if(y.hasNext())y.next(),$.mid||($.mid=new f,$.mid.segment=y.value()),m.push([d.Mid,$]),$=$.mid;else break}const E=$.value;$.value=p,$.key=h;for(let k=m.length-1;k>=0;k--){const t=m[k][1];t.updateHeight();const r=t.balanceFactor();if(r<-1||r>1){const i=m[k][0],c=m[k+1][0];if(i===d.Right&&c===d.Right)m[k][1]=t.rotateLeft();else if(i===d.Left&&c===d.Left)m[k][1]=t.rotateRight();else if(i===d.Right&&c===d.Left)t.right=m[k+1][1]=m[k+1][1].rotateRight(),m[k][1]=t.rotateLeft();else if(i===d.Left&&c===d.Right)t.left=m[k+1][1]=m[k+1][1].rotateLeft(),m[k][1]=t.rotateRight();else throw new Error;if(k>0)switch(m[k-1][0]){case d.Left:m[k-1][1].left=m[k][1];break;case d.Right:m[k-1][1].right=m[k][1];break;case d.Mid:m[k-1][1].mid=m[k][1];break}else this.c=m[0][1]}}return E}get(h){return this.d(h)?.value}d(h){const p=this.b.reset(h);let y=this.c;for(;y;){const $=p.cmp(y.segment);if($>0)y=y.left;else if($<0)y=y.right;else if(p.hasNext())p.next(),y=y.mid;else break}return y}has(h){const p=this.d(h);return!(p?.value===void 0&&p?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,p){const y=this.b.reset(h),$=[];let m=this.c;for(;m;){const E=y.cmp(m.segment);if(E>0)$.push([d.Left,m]),m=m.left;else if(E<0)$.push([d.Right,m]),m=m.right;else if(y.hasNext())y.next(),$.push([d.Mid,m]),m=m.mid;else break}if(m){if(p?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const E=this.f(m.right);if(E.key){const{key:k,value:t,segment:r}=E;this.e(E.key,!1),m.key=k,m.value=t,m.segment=r}}else{const E=m.left??m.right;if($.length>0){const[k,t]=$[$.length-1];switch(k){case d.Left:t.left=E;break;case d.Mid:t.mid=E;break;case d.Right:t.right=E;break}}else this.c=E}for(let E=$.length-1;E>=0;E--){const k=$[E][1];k.updateHeight();const t=k.balanceFactor();if(t>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),$[E][1]=k.rotateLeft()):t<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),$[E][1]=k.rotateRight()),E>0)switch($[E-1][0]){case d.Left:$[E-1][1].left=$[E][1];break;case d.Right:$[E-1][1].right=$[E][1];break;case d.Mid:$[E-1][1].mid=$[E][1];break}else this.c=$[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const p=this.b.reset(h);let y=this.c,$;for(;y;){const m=p.cmp(y.segment);if(m>0)y=y.left;else if(m<0)y=y.right;else if(p.hasNext())p.next(),$=y.value||$,y=y.mid;else break}return y&&y.value||$}findSuperstr(h){return this.g(h,!1)}g(h,p){const y=this.b.reset(h);let $=this.c;for(;$;){const m=y.cmp($.segment);if(m>0)$=$.left;else if(m<0)$=$.right;else if(y.hasNext())y.next(),$=$.mid;else return $.mid?this.h($.mid):p?$.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[p,y]of this)h(y,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const p=[];return this.j(h,p),p[Symbol.iterator]()}j(h,p){h&&(h.left&&this.j(h.left,p),h.value&&p.push([h.key,h.value]),h.mid&&this.j(h.mid,p),h.right&&this.j(h.right,p))}_isBalanced(){const h=p=>{if(!p)return!0;const y=p.balanceFactor();return y<-1||y>1?!1:h(p.left)&&h(p.right)};return h(this.c)}}e.$Li=g}),define(oe[33],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=o;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function o(P){return n.test(P)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(I){for(let b=0;b<I.length;b++)I[b]=Math.floor(Math.random()*256);return I};const D=new Uint8Array(16),A=[];for(let I=0;I<256;I++)A.push(I.toString(16).padStart(2,"0"));return function(){P(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let b=0,a="";return a+=A[D[b++]],a+=A[D[b++]],a+=A[D[b++]],a+=A[D[b++]],a+="-",a+=A[D[b++]],a+=A[D[b++]],a+="-",a+=A[D[b++]],a+=A[D[b++]],a+="-",a+=A[D[b++]],a+=A[D[b++]],a+="-",a+=A[D[b++]],a+=A[D[b++]],a+=A[D[b++]],a+=A[D[b++]],a+=A[D[b++]],a+=A[D[b++]],a}}()}),define(oe[149],ae([0,1,92,47,90]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yX=D,n=De(n),o=De(o);async function D(A,I){if(await new Promise((f,d)=>{const g=o.createReadStream(A),w=n.createHash("sha256");g.pipe(w);const h=(0,P.$fb)((p,y)=>{g.removeAllListeners(),w.removeAllListeners(),p?d(p):f(y)});g.once("error",h),g.once("end",h),w.once("error",h),w.once("data",p=>h(void 0,p.toString("hex")))})!==I)throw new Error("Hash mismatch")}}),define(oe[150],ae([0,1,27]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=D;const o=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(A){const I=A.replace(/\-/g,":").toLowerCase();return!o.has(I)}function D(){const A=(0,n.networkInterfaces)();for(const I in A){const b=A[I];if(b){for(const{mac:a}of b)if(P(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(oe[112],ae([0,1,93]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=o,e.$6g=D,n=De(n);function o(I,b,a,f=1){let d=!1;return new Promise(g=>{const w=setTimeout(()=>{if(!d)return d=!0,g(0)},a);P(I,b,f,h=>{if(!d)return d=!0,clearTimeout(w),g(h)})})}function P(I,b,a,f){if(b===0)return f(0);const d=new n.Socket;d.once("connect",()=>(A(d),P(I+a,b-1,a,f))),d.once("data",()=>{}),d.once("error",g=>(A(d),g.code!=="ECONNREFUSED"?P(I+a,b-1,a,f):f(I))),d.connect(I,"127.0.0.1")}e.$5g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(I,b,a,f="127.0.0.1"){let d=!1,g,w=1;const h=n.createServer({pauseOnConnect:!0});function p(y,$){d||(d=!0,h.removeAllListeners(),h.close(),g&&clearTimeout(g),$(y))}return new Promise(y=>{g=setTimeout(()=>{p(0,y)},a),h.on("listening",()=>{p(I,y)}),h.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&w<b?(I++,w++,h.listen(I,f)):p(0,y)}),h.on("close",()=>{p(0,y)}),h.listen(I,f)})}function A(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(b){console.error(b)}}}),function(){function x(){function e(){return process.uncHostAllowlist}function n(b){const a=new Set;if(Array.isArray(b))for(const f of b)typeof f=="string"&&a.add(f);return Array.from(a)}function o(){const b=e();return b?Array.from(b):[]}function P(b){if(process.platform!=="win32")return;const a=e();if(a)if(typeof b=="string")a.add(b.toLowerCase());else for(const f of n(b))P(f)}function D(b){if(typeof b!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let f;for(const d of a){if(b.indexOf(d)!==0)continue;const w=b.indexOf("\\",d.length);if(w===-1)continue;const h=b.substring(d.length,w);if(h){f=h;break}}return f}function A(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:o,addUNCHostToAllowlist:P,getUNCHost:D,disableUNCAccessRestrictions:A,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return x()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=x():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[151],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EX=e.$DX=void 0,e.$DX="vscode:contextmenu",e.$EX="vscode:onCloseContextMenu"}),define(oe[152],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LX=void 0;class n{constructor(P,D){this.a=P,this.onMessage=D}send(P){try{this.a.send("vscode:message",P.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$LX=n}),define(oe[153],ae([11,9]),function(x,e){return x.create("vs/base/common/date",e)}),define(oe[154],ae([0,1,153]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=a,e.$2m=f,e.$3m=d;const o=60,P=o*60,D=P*24,A=D*7,I=D*30,b=D*365;function a(g,w,h,p){typeof g!="number"&&(g=g.getTime());const y=Math.round((new Date().getTime()-g)/1e3);if(y<-30)return(0,n.localize)(0,null,a(new Date().getTime()+y*1e3,!1));if(!p&&y<30)return(0,n.localize)(1,null);let $;return y<o?($=y,w?$===1?h?(0,n.localize)(2,null,$):(0,n.localize)(3,null,$):h?(0,n.localize)(4,null,$):(0,n.localize)(5,null,$):$===1?h?(0,n.localize)(6,null,$):(0,n.localize)(7,null,$):h?(0,n.localize)(8,null,$):(0,n.localize)(9,null,$)):y<P?($=Math.floor(y/o),w?$===1?h?(0,n.localize)(10,null,$):(0,n.localize)(11,null,$):h?(0,n.localize)(12,null,$):(0,n.localize)(13,null,$):$===1?h?(0,n.localize)(14,null,$):(0,n.localize)(15,null,$):h?(0,n.localize)(16,null,$):(0,n.localize)(17,null,$)):y<D?($=Math.floor(y/P),w?$===1?h?(0,n.localize)(18,null,$):(0,n.localize)(19,null,$):h?(0,n.localize)(20,null,$):(0,n.localize)(21,null,$):$===1?h?(0,n.localize)(22,null,$):(0,n.localize)(23,null,$):h?(0,n.localize)(24,null,$):(0,n.localize)(25,null,$)):y<A?($=Math.floor(y/D),w?$===1?(0,n.localize)(26,null,$):(0,n.localize)(27,null,$):$===1?(0,n.localize)(28,null,$):(0,n.localize)(29,null,$)):y<I?($=Math.floor(y/A),w?$===1?h?(0,n.localize)(30,null,$):(0,n.localize)(31,null,$):h?(0,n.localize)(32,null,$):(0,n.localize)(33,null,$):$===1?h?(0,n.localize)(34,null,$):(0,n.localize)(35,null,$):h?(0,n.localize)(36,null,$):(0,n.localize)(37,null,$)):y<b?($=Math.floor(y/I),w?$===1?h?(0,n.localize)(38,null,$):(0,n.localize)(39,null,$):h?(0,n.localize)(40,null,$):(0,n.localize)(41,null,$):$===1?h?(0,n.localize)(42,null,$):(0,n.localize)(43,null,$):h?(0,n.localize)(44,null,$):(0,n.localize)(45,null,$)):($=Math.floor(y/b),w?$===1?h?(0,n.localize)(46,null,$):(0,n.localize)(47,null,$):h?(0,n.localize)(48,null,$):(0,n.localize)(49,null,$):$===1?h?(0,n.localize)(50,null,$):(0,n.localize)(51,null,$):h?(0,n.localize)(52,null,$):(0,n.localize)(53,null,$))}function f(g,w){const h=Math.abs(g/1e3);return h<1?w?(0,n.localize)(54,null,g):(0,n.localize)(55,null,g):h<o?w?(0,n.localize)(56,null,Math.round(g)/1e3):(0,n.localize)(57,null,Math.round(g)/1e3):h<P?w?(0,n.localize)(58,null,Math.round(g/(1e3*o))):(0,n.localize)(59,null,Math.round(g/(1e3*o))):h<D?w?(0,n.localize)(60,null,Math.round(g/(1e3*P))):(0,n.localize)(61,null,Math.round(g/(1e3*P))):(0,n.localize)(62,null,Math.round(g/(1e3*D)))}function d(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(oe[155],ae([11,9]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(oe[55],ae([0,1,22,13,155]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=b,e.$rj=a,e.$sj=f,n=De(n),o=De(o),P=De(P);function D(d,g){return g&&(d.stack||d.stacktrace)?P.localize(0,null,I(d),A(d.stack)||A(d.stacktrace)):I(d)}function A(d){return Array.isArray(d)?d.join(`
`):d}function I(d){return d.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?P.localize(1,null,d.message):d.message||P.localize(2,null)}function b(d=null,g=!1){if(!d)return P.localize(3,null);if(Array.isArray(d)){const w=n.$Jb(d),h=b(w[0],g);return w.length>1?P.localize(4,null,h,w.length):h}if(o.$fg(d))return d;if(d.detail){const w=d.detail;if(w.error)return D(w.error,g);if(w.exception)return D(w.exception,g)}return d.stack?D(d,g):d.message?d.message:P.localize(5,null)}function a(d){const g=d;return g instanceof Error&&Array.isArray(g.actions)}function f(d,g){let w;return typeof d=="string"?w=new Error(d):w=d,w.actions=g,w}}),define(oe[156],ae([11,9]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(oe[157],ae([0,1,156,43]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=P;function P(D){switch(D){case o.ParseErrorCode.InvalidSymbol:return(0,n.localize)(0,null);case o.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(1,null);case o.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(2,null);case o.ParseErrorCode.ValueExpected:return(0,n.localize)(3,null);case o.ParseErrorCode.ColonExpected:return(0,n.localize)(4,null);case o.ParseErrorCode.CommaExpected:return(0,n.localize)(5,null);case o.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(6,null);case o.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(7,null);case o.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(8,null);default:return""}}}),define(oe[158],ae([11,9]),function(x,e){return x.create("vs/base/common/platform",e)}),define(oe[3],ae([0,1,158]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=i,e.$D=v,e.$J=R,n=De(n),e.$g="en";let o=!1,P=!1,D=!1,A=!1,I=!1,b=!1,a=!1,f=!1,d=!1,g=!1,w,h=e.$g,p=e.$g,y,$;const m=globalThis;let E;typeof m.vscode<"u"&&typeof m.vscode.process<"u"?E=m.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(E=process);const k=typeof E?.versions?.electron=="string",t=k&&E?.type==="renderer";if(typeof E=="object"){o=E.platform==="win32",P=E.platform==="darwin",D=E.platform==="linux",A=D&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,a=k,d=!!E.env.CI||!!E.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.$g,h=e.$g;const T=E.env.VSCODE_NLS_CONFIG;if(T)try{const L=JSON.parse(T),O=L.availableLanguages["*"];w=L.locale,p=L.osLocale,h=O||e.$g,y=L._translationsConfigFile}catch{}I=!0}else typeof navigator=="object"&&!t?($=navigator.userAgent,o=$.indexOf("Windows")>=0,P=$.indexOf("Macintosh")>=0,f=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=$.indexOf("Linux")>=0,g=$?.indexOf("Mobi")>=0,b=!0,w=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,h=w,p=navigator.language):console.error("Unable to resolve platform.");var r;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(r||(e.Platform=r={}));function i(T){switch(T){case r.Web:return"Web";case r.Mac:return"Mac";case r.Linux:return"Linux";case r.Windows:return"Windows"}}let c=r.Web;P?c=r.Mac:o?c=r.Windows:D&&(c=r.Linux),e.$i=o,e.$j=P,e.$k=D,e.$l=A,e.$m=I,e.$n=a,e.$o=b,e.$p=b&&typeof m.importScripts=="function",e.$q=e.$p?m.origin:void 0,e.$r=f,e.$s=g,e.$t=d,e.$u=c,e.$v=$,e.$w=h;var s;(function(T){function L(){return e.$w}T.value=L;function O(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}T.isDefaultVariant=O;function F(){return e.$w==="en"}T.isDefault=F})(s||(e.Language=s={})),e.$x=w,e.$y=p,e.$z=y,e.$A=typeof m.postMessage=="function"&&!m.importScripts,e.$B=(()=>{if(e.$A){const T=[];m.addEventListener("message",O=>{if(O.data&&O.data.vscodeScheduleAsyncWork)for(let F=0,B=T.length;F<B;F++){const C=T[F];if(C.id===O.data.vscodeScheduleAsyncWork){T.splice(F,1),C.callback();return}}});let L=0;return O=>{const F=++L;T.push({id:F,callback:O}),m.postMessage({vscodeScheduleAsyncWork:F},"*")}}return T=>setTimeout(T)})();var u;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(u||(e.OperatingSystem=u={})),e.OS=P||f?u.Macintosh:o?u.Windows:u.Linux;let l=!0,S=!1;function v(){if(!S){S=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,l=new Uint16Array(T.buffer)[0]===513}return l}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function R(T){return parseFloat(T)>=20}}),define(oe[37],ae([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gc=e.$fc=e.env=e.cwd=void 0;let o;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const D=P.process;o={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?o={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:o={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=o.cwd,e.env=o.env,e.$fc=o.platform,e.$gc=o.arch}),define(oe[10],ae([0,1,37]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.sep=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=void 0,n=De(n);const o=65,P=97,D=90,A=122,I=46,b=47,a=92,f=58,d=63;class g extends Error{constructor(i,c,s){let u;typeof c=="string"&&c.indexOf("not ")===0?(u="must not be",c=c.replace(/^not /,"")):u="must be";const l=i.indexOf(".")!==-1?"property":"argument";let S=`The "${i}" ${l} ${u} of type ${c}`;S+=`. Received type ${typeof s}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function w(r,i){if(r===null||typeof r!="object")throw new g(i,"Object",r)}function h(r,i){if(typeof r!="string")throw new g(i,"string",r)}const p=n.$fc==="win32";function y(r){return r===b||r===a}function $(r){return r===b}function m(r){return r>=o&&r<=D||r>=P&&r<=A}function E(r,i,c,s){let u="",l=0,S=-1,v=0,R=0;for(let T=0;T<=r.length;++T){if(T<r.length)R=r.charCodeAt(T);else{if(s(R))break;R=b}if(s(R)){if(!(S===T-1||v===1))if(v===2){if(u.length<2||l!==2||u.charCodeAt(u.length-1)!==I||u.charCodeAt(u.length-2)!==I){if(u.length>2){const L=u.lastIndexOf(c);L===-1?(u="",l=0):(u=u.slice(0,L),l=u.length-1-u.lastIndexOf(c)),S=T,v=0;continue}else if(u.length!==0){u="",l=0,S=T,v=0;continue}}i&&(u+=u.length>0?`${c}..`:"..",l=2)}else u.length>0?u+=`${c}${r.slice(S+1,T)}`:u=r.slice(S+1,T),l=T-S-1;S=T,v=0}else R===I&&v!==-1?++v:v=-1}return u}function k(r,i){w(i,"pathObject");const c=i.dir||i.root,s=i.base||`${i.name||""}${i.ext||""}`;return c?c===i.root?`${c}${s}`:`${c}${r}${s}`:s}e.$hc={resolve(...r){let i="",c="",s=!1;for(let u=r.length-1;u>=-1;u--){let l;if(u>=0){if(l=r[u],h(l,"path"),l.length===0)continue}else i.length===0?l=n.cwd():(l=n.env[`=${i}`]||n.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==i.toLowerCase()&&l.charCodeAt(2)===a)&&(l=`${i}\\`));const S=l.length;let v=0,R="",T=!1;const L=l.charCodeAt(0);if(S===1)y(L)&&(v=1,T=!0);else if(y(L))if(T=!0,y(l.charCodeAt(1))){let O=2,F=O;for(;O<S&&!y(l.charCodeAt(O));)O++;if(O<S&&O!==F){const B=l.slice(F,O);for(F=O;O<S&&y(l.charCodeAt(O));)O++;if(O<S&&O!==F){for(F=O;O<S&&!y(l.charCodeAt(O));)O++;(O===S||O!==F)&&(R=`\\\\${B}\\${l.slice(F,O)}`,v=O)}}}else v=1;else m(L)&&l.charCodeAt(1)===f&&(R=l.slice(0,2),v=2,S>2&&y(l.charCodeAt(2))&&(T=!0,v=3));if(R.length>0)if(i.length>0){if(R.toLowerCase()!==i.toLowerCase())continue}else i=R;if(s){if(i.length>0)break}else if(c=`${l.slice(v)}\\${c}`,s=T,T&&i.length>0)break}return c=E(c,!s,"\\",y),s?`${i}\\${c}`:`${i}${c}`||"."},normalize(r){h(r,"path");const i=r.length;if(i===0)return".";let c=0,s,u=!1;const l=r.charCodeAt(0);if(i===1)return $(l)?"\\":r;if(y(l))if(u=!0,y(r.charCodeAt(1))){let v=2,R=v;for(;v<i&&!y(r.charCodeAt(v));)v++;if(v<i&&v!==R){const T=r.slice(R,v);for(R=v;v<i&&y(r.charCodeAt(v));)v++;if(v<i&&v!==R){for(R=v;v<i&&!y(r.charCodeAt(v));)v++;if(v===i)return`\\\\${T}\\${r.slice(R)}\\`;v!==R&&(s=`\\\\${T}\\${r.slice(R,v)}`,c=v)}}}else c=1;else m(l)&&r.charCodeAt(1)===f&&(s=r.slice(0,2),c=2,i>2&&y(r.charCodeAt(2))&&(u=!0,c=3));let S=c<i?E(r.slice(c),!u,"\\",y):"";return S.length===0&&!u&&(S="."),S.length>0&&y(r.charCodeAt(i-1))&&(S+="\\"),s===void 0?u?`\\${S}`:S:u?`${s}\\${S}`:`${s}${S}`},isAbsolute(r){h(r,"path");const i=r.length;if(i===0)return!1;const c=r.charCodeAt(0);return y(c)||i>2&&m(c)&&r.charCodeAt(1)===f&&y(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let i,c;for(let l=0;l<r.length;++l){const S=r[l];h(S,"path"),S.length>0&&(i===void 0?i=c=S:i+=`\\${S}`)}if(i===void 0)return".";let s=!0,u=0;if(typeof c=="string"&&y(c.charCodeAt(0))){++u;const l=c.length;l>1&&y(c.charCodeAt(1))&&(++u,l>2&&(y(c.charCodeAt(2))?++u:s=!1))}if(s){for(;u<i.length&&y(i.charCodeAt(u));)u++;u>=2&&(i=`\\${i.slice(u)}`)}return e.$hc.normalize(i)},relative(r,i){if(h(r,"from"),h(i,"to"),r===i)return"";const c=e.$hc.resolve(r),s=e.$hc.resolve(i);if(c===s||(r=c.toLowerCase(),i=s.toLowerCase(),r===i))return"";let u=0;for(;u<r.length&&r.charCodeAt(u)===a;)u++;let l=r.length;for(;l-1>u&&r.charCodeAt(l-1)===a;)l--;const S=l-u;let v=0;for(;v<i.length&&i.charCodeAt(v)===a;)v++;let R=i.length;for(;R-1>v&&i.charCodeAt(R-1)===a;)R--;const T=R-v,L=S<T?S:T;let O=-1,F=0;for(;F<L;F++){const C=r.charCodeAt(u+F);if(C!==i.charCodeAt(v+F))break;C===a&&(O=F)}if(F!==L){if(O===-1)return s}else{if(T>L){if(i.charCodeAt(v+F)===a)return s.slice(v+F+1);if(F===2)return s.slice(v+F)}S>L&&(r.charCodeAt(u+F)===a?O=F:F===2&&(O=3)),O===-1&&(O=0)}let B="";for(F=u+O+1;F<=l;++F)(F===l||r.charCodeAt(F)===a)&&(B+=B.length===0?"..":"\\..");return v+=O,B.length>0?`${B}${s.slice(v,R)}`:(s.charCodeAt(v)===a&&++v,s.slice(v,R))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const i=e.$hc.resolve(r);if(i.length<=2)return r;if(i.charCodeAt(0)===a){if(i.charCodeAt(1)===a){const c=i.charCodeAt(2);if(c!==d&&c!==I)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(m(i.charCodeAt(0))&&i.charCodeAt(1)===f&&i.charCodeAt(2)===a)return`\\\\?\\${i}`;return r},dirname(r){h(r,"path");const i=r.length;if(i===0)return".";let c=-1,s=0;const u=r.charCodeAt(0);if(i===1)return y(u)?r:".";if(y(u)){if(c=s=1,y(r.charCodeAt(1))){let v=2,R=v;for(;v<i&&!y(r.charCodeAt(v));)v++;if(v<i&&v!==R){for(R=v;v<i&&y(r.charCodeAt(v));)v++;if(v<i&&v!==R){for(R=v;v<i&&!y(r.charCodeAt(v));)v++;if(v===i)return r;v!==R&&(c=s=v+1)}}}}else m(u)&&r.charCodeAt(1)===f&&(c=i>2&&y(r.charCodeAt(2))?3:2,s=c);let l=-1,S=!0;for(let v=i-1;v>=s;--v)if(y(r.charCodeAt(v))){if(!S){l=v;break}}else S=!1;if(l===-1){if(c===-1)return".";l=c}return r.slice(0,l)},basename(r,i){i!==void 0&&h(i,"ext"),h(r,"path");let c=0,s=-1,u=!0,l;if(r.length>=2&&m(r.charCodeAt(0))&&r.charCodeAt(1)===f&&(c=2),i!==void 0&&i.length>0&&i.length<=r.length){if(i===r)return"";let S=i.length-1,v=-1;for(l=r.length-1;l>=c;--l){const R=r.charCodeAt(l);if(y(R)){if(!u){c=l+1;break}}else v===-1&&(u=!1,v=l+1),S>=0&&(R===i.charCodeAt(S)?--S===-1&&(s=l):(S=-1,s=v))}return c===s?s=v:s===-1&&(s=r.length),r.slice(c,s)}for(l=r.length-1;l>=c;--l)if(y(r.charCodeAt(l))){if(!u){c=l+1;break}}else s===-1&&(u=!1,s=l+1);return s===-1?"":r.slice(c,s)},extname(r){h(r,"path");let i=0,c=-1,s=0,u=-1,l=!0,S=0;r.length>=2&&r.charCodeAt(1)===f&&m(r.charCodeAt(0))&&(i=s=2);for(let v=r.length-1;v>=i;--v){const R=r.charCodeAt(v);if(y(R)){if(!l){s=v+1;break}continue}u===-1&&(l=!1,u=v+1),R===I?c===-1?c=v:S!==1&&(S=1):c!==-1&&(S=-1)}return c===-1||u===-1||S===0||S===1&&c===u-1&&c===s+1?"":r.slice(c,u)},format:k.bind(null,"\\"),parse(r){h(r,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return i;const c=r.length;let s=0,u=r.charCodeAt(0);if(c===1)return y(u)?(i.root=i.dir=r,i):(i.base=i.name=r,i);if(y(u)){if(s=1,y(r.charCodeAt(1))){let O=2,F=O;for(;O<c&&!y(r.charCodeAt(O));)O++;if(O<c&&O!==F){for(F=O;O<c&&y(r.charCodeAt(O));)O++;if(O<c&&O!==F){for(F=O;O<c&&!y(r.charCodeAt(O));)O++;O===c?s=O:O!==F&&(s=O+1)}}}}else if(m(u)&&r.charCodeAt(1)===f){if(c<=2)return i.root=i.dir=r,i;if(s=2,y(r.charCodeAt(2))){if(c===3)return i.root=i.dir=r,i;s=3}}s>0&&(i.root=r.slice(0,s));let l=-1,S=s,v=-1,R=!0,T=r.length-1,L=0;for(;T>=s;--T){if(u=r.charCodeAt(T),y(u)){if(!R){S=T+1;break}continue}v===-1&&(R=!1,v=T+1),u===I?l===-1?l=T:L!==1&&(L=1):l!==-1&&(L=-1)}return v!==-1&&(l===-1||L===0||L===1&&l===v-1&&l===S+1?i.base=i.name=r.slice(S,v):(i.name=r.slice(S,l),i.base=r.slice(S,v),i.ext=r.slice(l,v))),S>0&&S!==s?i.dir=r.slice(0,S-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(p){const r=/\\/g;return()=>{const i=n.cwd().replace(r,"/");return i.slice(i.indexOf("/"))}}return()=>n.cwd()})();e.$ic={resolve(...r){let i="",c=!1;for(let s=r.length-1;s>=-1&&!c;s--){const u=s>=0?r[s]:t();h(u,"path"),u.length!==0&&(i=`${u}/${i}`,c=u.charCodeAt(0)===b)}return i=E(i,!c,"/",$),c?`/${i}`:i.length>0?i:"."},normalize(r){if(h(r,"path"),r.length===0)return".";const i=r.charCodeAt(0)===b,c=r.charCodeAt(r.length-1)===b;return r=E(r,!i,"/",$),r.length===0?i?"/":c?"./":".":(c&&(r+="/"),i?`/${r}`:r)},isAbsolute(r){return h(r,"path"),r.length>0&&r.charCodeAt(0)===b},join(...r){if(r.length===0)return".";let i;for(let c=0;c<r.length;++c){const s=r[c];h(s,"path"),s.length>0&&(i===void 0?i=s:i+=`/${s}`)}return i===void 0?".":e.$ic.normalize(i)},relative(r,i){if(h(r,"from"),h(i,"to"),r===i||(r=e.$ic.resolve(r),i=e.$ic.resolve(i),r===i))return"";const c=1,s=r.length,u=s-c,l=1,S=i.length-l,v=u<S?u:S;let R=-1,T=0;for(;T<v;T++){const O=r.charCodeAt(c+T);if(O!==i.charCodeAt(l+T))break;O===b&&(R=T)}if(T===v)if(S>v){if(i.charCodeAt(l+T)===b)return i.slice(l+T+1);if(T===0)return i.slice(l+T)}else u>v&&(r.charCodeAt(c+T)===b?R=T:T===0&&(R=0));let L="";for(T=c+R+1;T<=s;++T)(T===s||r.charCodeAt(T)===b)&&(L+=L.length===0?"..":"/..");return`${L}${i.slice(l+R)}`},toNamespacedPath(r){return r},dirname(r){if(h(r,"path"),r.length===0)return".";const i=r.charCodeAt(0)===b;let c=-1,s=!0;for(let u=r.length-1;u>=1;--u)if(r.charCodeAt(u)===b){if(!s){c=u;break}}else s=!1;return c===-1?i?"/":".":i&&c===1?"//":r.slice(0,c)},basename(r,i){i!==void 0&&h(i,"ext"),h(r,"path");let c=0,s=-1,u=!0,l;if(i!==void 0&&i.length>0&&i.length<=r.length){if(i===r)return"";let S=i.length-1,v=-1;for(l=r.length-1;l>=0;--l){const R=r.charCodeAt(l);if(R===b){if(!u){c=l+1;break}}else v===-1&&(u=!1,v=l+1),S>=0&&(R===i.charCodeAt(S)?--S===-1&&(s=l):(S=-1,s=v))}return c===s?s=v:s===-1&&(s=r.length),r.slice(c,s)}for(l=r.length-1;l>=0;--l)if(r.charCodeAt(l)===b){if(!u){c=l+1;break}}else s===-1&&(u=!1,s=l+1);return s===-1?"":r.slice(c,s)},extname(r){h(r,"path");let i=-1,c=0,s=-1,u=!0,l=0;for(let S=r.length-1;S>=0;--S){const v=r.charCodeAt(S);if(v===b){if(!u){c=S+1;break}continue}s===-1&&(u=!1,s=S+1),v===I?i===-1?i=S:l!==1&&(l=1):i!==-1&&(l=-1)}return i===-1||s===-1||l===0||l===1&&i===s-1&&i===c+1?"":r.slice(i,s)},format:k.bind(null,"/"),parse(r){h(r,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return i;const c=r.charCodeAt(0)===b;let s;c?(i.root="/",s=1):s=0;let u=-1,l=0,S=-1,v=!0,R=r.length-1,T=0;for(;R>=s;--R){const L=r.charCodeAt(R);if(L===b){if(!v){l=R+1;break}continue}S===-1&&(v=!1,S=R+1),L===I?u===-1?u=R:T!==1&&(T=1):u!==-1&&(T=-1)}if(S!==-1){const L=l===0&&c?1:l;u===-1||T===0||T===1&&u===S-1&&u===l+1?i.base=i.name=r.slice(L,S):(i.name=r.slice(L,u),i.base=r.slice(L,S),i.ext=r.slice(u,S))}return l>0?i.dir=r.slice(0,l-1):c&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$ic.win32=e.$hc.win32=e.$hc,e.$ic.posix=e.$hc.posix=e.$ic,e.$jc=p?e.$hc.normalize:e.$ic.normalize,e.$kc=p?e.$hc.isAbsolute:e.$ic.isAbsolute,e.$lc=p?e.$hc.join:e.$ic.join,e.$mc=p?e.$hc.resolve:e.$ic.resolve,e.$nc=p?e.$hc.relative:e.$ic.relative,e.$oc=p?e.$hc.dirname:e.$ic.dirname,e.$pc=p?e.$hc.basename:e.$ic.basename,e.$qc=p?e.$hc.extname:e.$ic.extname,e.$rc=p?e.$hc.format:e.$ic.format,e.$sc=p?e.$hc.parse:e.$ic.parse,e.$tc=p?e.$hc.toNamespacedPath:e.$ic.toNamespacedPath,e.sep=p?e.$hc.sep:e.$ic.sep,e.$vc=p?e.$hc.delimiter:e.$ic.delimiter}),define(oe[31],ae([0,1,39,10,3,26,13]),function(x,e,n,o,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=I,e.$yg=b,e.$zg=a,e.$Ag=f,e.$Bg=d,e.$Cg=p,e.$Dg=y,e.$Eg=$,e.$Fg=m,e.$Gg=E,e.$Hg=k,e.$Ig=t,e.$Jg=r,e.$Kg=i,e.$Lg=c,e.$Mg=s,e.$Ng=S;function I(v){return v===n.CharCode.Slash||v===n.CharCode.Backslash}function b(v){return v.replace(/[\\/]/g,o.$ic.sep)}function a(v){return v.indexOf("/")===-1&&(v=b(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function f(v,R=o.$ic.sep){if(!v)return"";const T=v.length,L=v.charCodeAt(0);if(I(L)){if(I(v.charCodeAt(1))&&!I(v.charCodeAt(2))){let F=3;const B=F;for(;F<T&&!I(v.charCodeAt(F));F++);if(B!==F&&!I(v.charCodeAt(F+1))){for(F+=1;F<T;F++)if(I(v.charCodeAt(F)))return v.slice(0,F+1).replace(/[\\/]/g,R)}}return R}else if(m(L)&&v.charCodeAt(1)===n.CharCode.Colon)return I(v.charCodeAt(2))?v.slice(0,2)+R:v.slice(0,2);let O=v.indexOf("://");if(O!==-1){for(O+=3;O<T;O++)if(I(v.charCodeAt(O)))return v.slice(0,O+1)}return""}function d(v){if(!P.$i||!v||v.length<5)return!1;let R=v.charCodeAt(0);if(R!==n.CharCode.Backslash||(R=v.charCodeAt(1),R!==n.CharCode.Backslash))return!1;let T=2;const L=T;for(;T<v.length&&(R=v.charCodeAt(T),R!==n.CharCode.Backslash);T++);return!(L===T||(R=v.charCodeAt(T+1),isNaN(R)||R===n.CharCode.Backslash))}const g=/[\\/:\*\?"<>\|]/g,w=/[/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(v,R=P.$i){const T=R?g:w;return!(!v||v.length===0||/^\s+$/.test(v)||(T.lastIndex=0,T.test(v))||R&&h.test(v)||v==="."||v===".."||R&&v[v.length-1]==="."||R&&v.length!==v.trim().length||v.length>255)}function y(v,R,T){const L=v===R;return!T||L?L:!v||!R?!1:(0,D.$Gf)(v,R)}function $(v,R,T,L=o.sep){if(v===R)return!0;if(!v||!R||R.length>v.length)return!1;if(T){if(!(0,D.$Hf)(v,R))return!1;if(R.length===v.length)return!0;let F=R.length;return R.charAt(R.length-1)===L&&F--,v.charAt(F)===L}return R.charAt(R.length-1)!==L&&(R+=L),v.indexOf(R)===0}function m(v){return v>=n.CharCode.A&&v<=n.CharCode.Z||v>=n.CharCode.a&&v<=n.CharCode.z}function E(v,R){return P.$i&&v.endsWith(":")&&(v+=o.sep),(0,o.$kc)(v)||(v=(0,o.$lc)(R,v)),v=(0,o.$jc)(v),k(v)}function k(v){return P.$i?(v=(0,D.$of)(v,o.sep),v.endsWith(":")&&(v+=o.sep)):(v=(0,D.$of)(v,o.sep),v||(v=o.sep)),v}function t(v){const R=(0,o.$jc)(v);return P.$i?v.length>3?!1:r(R)&&(v.length===2||R.charCodeAt(2)===n.CharCode.Backslash):R===o.$ic.sep}function r(v,R=P.$i){return R?m(v.charCodeAt(0))&&v.charCodeAt(1)===n.CharCode.Colon:!1}function i(v,R=P.$i){return r(v,R)?v[0]:void 0}function c(v,R,T){return R.length>v.length?-1:v===R?0:(T&&(v=v.toLowerCase(),R=R.toLowerCase()),v.indexOf(R))}function s(v){const R=v.split(":");let T,L,O;for(const F of R){const B=Number(F);(0,A.$jg)(B)?L===void 0?L=B:O===void 0&&(O=B):T=T?[T,F].join(":"):F}if(!T)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:T,line:L!==void 0?L:void 0,column:O!==void 0?O:L!==void 0?1:void 0}}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(v,R,T=8){let L="";for(let F=0;F<T;F++){let B;F===0&&P.$i&&!R&&(T===3||T===4)?B=l:B=u,L+=B.charAt(Math.floor(Math.random()*B.length))}let O;return R?O=`${R}-${L}`:O=L,v?(0,o.$lc)(v,O):O}}),define(oe[82],ae([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$km=D,e.$lm=A;var o;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(o||(e.Source=o={}));var P;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function D(I,...b){const a=b.reduce((g,w)=>(g[w]=!0,g),{}),f=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(g=>!a[g]).forEach(g=>{for(let w=0;w<f.length;w++)if(g.search(f[w])!==-1){delete I[g];break}})}function A(I){I&&(delete I.DEBUG,n.$j&&delete I.DYLD_LIBRARY_PATH,n.$k&&delete I.LD_PRELOAD)}}),define(oe[7],ae([0,1,39,91,10,3]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$xc=y,e.$yc=r,P=De(P);const A=/^\w[\w\d+.-]*$/,I=/^\//,b=/^\/\//;function a(l,S){if(!l.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!A.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!I.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(l,S){return!l&&!S?"file":l}function d(l,S){switch(l){case"https":case"http":case"file":S?S[0]!==w&&(S=w+S):S=w;break}return S}const g="",w="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(S){return S instanceof p?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,v,R,T,L,O=!1){typeof S=="object"?(this.scheme=S.scheme||g,this.authority=S.authority||g,this.path=S.path||g,this.query=S.query||g,this.fragment=S.fragment||g):(this.scheme=f(S,O),this.authority=v||g,this.path=d(this.scheme,R||g),this.query=T||g,this.fragment=L||g,a(this,O))}get fsPath(){return r(this,!1)}with(S){if(!S)return this;let{scheme:v,authority:R,path:T,query:L,fragment:O}=S;return v===void 0?v=this.scheme:v===null&&(v=g),R===void 0?R=this.authority:R===null&&(R=g),T===void 0?T=this.path:T===null&&(T=g),L===void 0?L=this.query:L===null&&(L=g),O===void 0?O=this.fragment:O===null&&(O=g),v===this.scheme&&R===this.authority&&T===this.path&&L===this.query&&O===this.fragment?this:new m(v,R,T,L,O)}static parse(S,v=!1){const R=h.exec(S);return R?new m(R[2]||g,u(R[4]||g),u(R[5]||g),u(R[7]||g),u(R[9]||g),v):new m(g,g,g,g,g)}static file(S){let v=g;if(D.$i&&(S=S.replace(/\\/g,w)),S[0]===w&&S[1]===w){const R=S.indexOf(w,2);R===-1?(v=S.substring(2),S=w):(v=S.substring(2,R),S=S.substring(R)||w)}return new m("file",v,S,g,g)}static from(S,v){return new m(S.scheme,S.authority,S.path,S.query,S.fragment,v)}static joinPath(S,...v){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return D.$i&&S.scheme==="file"?R=p.file(P.$hc.join(r(S,!0),...v)).path:R=P.$ic.join(S.path,...v),S.with({path:R})}toString(S=!1){return i(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof p)return S;{const v=new m(S);return v._formatted=S.external??null,v._fsPath=S._sep===$?S.fsPath??null:null,v}}else return S}}e.URI=p;function y(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const $=D.$i?1:void 0;class m extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(S=!1){return S?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const S={$mid:o.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=$),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const E={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function k(l,S,v){let R,T=-1;for(let L=0;L<l.length;L++){const O=l.charCodeAt(L);if(O>=n.CharCode.a&&O<=n.CharCode.z||O>=n.CharCode.A&&O<=n.CharCode.Z||O>=n.CharCode.Digit0&&O<=n.CharCode.Digit9||O===n.CharCode.Dash||O===n.CharCode.Period||O===n.CharCode.Underline||O===n.CharCode.Tilde||S&&O===n.CharCode.Slash||v&&O===n.CharCode.OpenSquareBracket||v&&O===n.CharCode.CloseSquareBracket||v&&O===n.CharCode.Colon)T!==-1&&(R+=encodeURIComponent(l.substring(T,L)),T=-1),R!==void 0&&(R+=l.charAt(L));else{R===void 0&&(R=l.substr(0,L));const F=E[O];F!==void 0?(T!==-1&&(R+=encodeURIComponent(l.substring(T,L)),T=-1),R+=F):T===-1&&(T=L)}}return T!==-1&&(R+=encodeURIComponent(l.substring(T))),R!==void 0?R:l}function t(l){let S;for(let v=0;v<l.length;v++){const R=l.charCodeAt(v);R===n.CharCode.Hash||R===n.CharCode.QuestionMark?(S===void 0&&(S=l.substr(0,v)),S+=E[R]):S!==void 0&&(S+=l[v])}return S!==void 0?S:l}function r(l,S){let v;return l.authority&&l.path.length>1&&l.scheme==="file"?v=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===n.CharCode.Slash&&(l.path.charCodeAt(1)>=n.CharCode.A&&l.path.charCodeAt(1)<=n.CharCode.Z||l.path.charCodeAt(1)>=n.CharCode.a&&l.path.charCodeAt(1)<=n.CharCode.z)&&l.path.charCodeAt(2)===n.CharCode.Colon?S?v=l.path.substr(1):v=l.path[1].toLowerCase()+l.path.substr(2):v=l.path,D.$i&&(v=v.replace(/\//g,"\\")),v}function i(l,S){const v=S?t:k;let R="",{scheme:T,authority:L,path:O,query:F,fragment:B}=l;if(T&&(R+=T,R+=":"),(L||T==="file")&&(R+=w,R+=w),L){let C=L.indexOf("@");if(C!==-1){const z=L.substr(0,C);L=L.substr(C+1),C=z.lastIndexOf(":"),C===-1?R+=v(z,!1,!1):(R+=v(z.substr(0,C),!1,!1),R+=":",R+=v(z.substr(C+1),!1,!0)),R+="@"}L=L.toLowerCase(),C=L.lastIndexOf(":"),C===-1?R+=v(L,!1,!0):(R+=v(L.substr(0,C),!1,!0),R+=L.substr(C))}if(O){if(O.length>=3&&O.charCodeAt(0)===n.CharCode.Slash&&O.charCodeAt(2)===n.CharCode.Colon){const C=O.charCodeAt(1);C>=n.CharCode.A&&C<=n.CharCode.Z&&(O=`/${String.fromCharCode(C+32)}:${O.substr(3)}`)}else if(O.length>=2&&O.charCodeAt(1)===n.CharCode.Colon){const C=O.charCodeAt(0);C>=n.CharCode.A&&C<=n.CharCode.Z&&(O=`${String.fromCharCode(C+32)}:${O.substr(2)}`)}R+=v(O,!0,!1)}return F&&(R+="?",R+=v(F,!1,!1)),B&&(R+="#",R+=S?B:k(B,!1,!1)),R}function c(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+c(l.substr(3)):l}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(l){return l.match(s)?l.replace(s,S=>c(S)):l}}),define(oe[159],ae([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=o,e.$br=P,e.$cr=D,e.log=I;function o(a){const f=a;return f&&typeof f.type=="string"&&typeof f.severity=="string"}function P(a){const f=[];let d;try{const g=JSON.parse(a.arguments),w=g[g.length-1];w&&w.__$stack&&(g.pop(),d=w.__$stack),f.push(...g)}catch{f.push("Unable to log remote console arguments",a.arguments)}return{args:f,stack:d}}function D(a){if(typeof a!="string")return D(P(a).stack);const f=a;if(f){const d=A(f),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(g&&g.length===4)return{uri:n.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}function A(a){if(!a)return a;const f=a.indexOf(`
`);return f===-1?a:a.substring(0,f)}function I(a,f){const{args:d,stack:g}=P(a),w=typeof d[0]=="string"&&d.length===1;let h=A(g);h&&(h=`(${h.trim()})`);let p=[];if(typeof d[0]=="string"?h&&w?p=[`%c[${f}] %c${d[0]} %c${h}`,b("blue"),b(""),b("grey")]:p=[`%c[${f}] %c${d[0]}`,b("blue"),b(""),...d.slice(1)]:p=[`%c[${f}]%`,b("blue"),...d],h&&!w&&p.push(h),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,p)}function b(a){return`color: ${a}`}}),define(oe[83],ae([0,1,17,7,91]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=D,e.$bi=A,e.$ci=b;function D(a){return JSON.stringify(a,I)}function A(a){let f=JSON.parse(a);return f=b(f),f}function I(a,f){return f instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:f.source,flags:f.flags}:f}function b(a,f=0){if(!a||f>200)return a;if(typeof a=="object"){switch(a.$mid){case P.MarshalledId.Uri:return o.URI.revive(a);case P.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case P.MarshalledId.Date:return new Date(a.source)}if(a instanceof n.$Oe||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let d=0;d<a.length;++d)a[d]=b(a[d],f+1);else for(const d in a)Object.hasOwnProperty.call(a,d)&&(a[d]=b(a[d],f+1))}return a}}),define(oe[12],ae([0,1,16,3,26,7,10]),function(x,e,n,o,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=b,e.$Pg=a,e.$Tg=d,n=De(n),o=De(o),A=De(A);var I;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",h.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.commentsInput="comment",h.codeSetting="code-setting"})(I||(e.Schemas=I={}));function b(h,p){return D.URI.isUri(h)?(0,P.$Gf)(h.scheme,p):(0,P.$Hf)(h,p+":")}function a(h,...p){return p.some(y=>b(h,y))}e.$Qg="vscode-tkn",e.$Rg="tkn";class f{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p,y){this.f=d(p,y)}getServerRootPath(){return this.f}get g(){return A.$ic.join(this.f,I.vscodeRemoteResource)}set(p,y,$){this.a[p]=y,this.b[p]=$}setConnectionToken(p,y){this.c[p]=y}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(t){return n.$3(t),p}const y=p.authority;let $=this.a[y];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const m=this.b[y],E=this.c[y];let k=`path=${encodeURIComponent(p.path)}`;return typeof E=="string"&&(k+=`&${e.$Rg}=${encodeURIComponent(E)}`),D.URI.from({scheme:o.$o?this.d:I.vscodeRemoteResource,authority:`${$}:${m}`,path:this.g,query:k})}}e.$Sg=new f;function d(h,p){return A.$ic.join(p??"/",`${h.quality??"oss"}-${h.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class g{static{this.a=e.$Yg}asBrowserUri(p){const y=this.b(p,x);return this.uriToBrowserUri(y)}uriToBrowserUri(p){return p.scheme===I.vscodeRemote?e.$Sg.rewrite(p):p.scheme===I.file&&(o.$m||o.$q===`${I.vscodeFileResource}://${g.a}`)?p.with({scheme:I.vscodeFileResource,authority:p.authority||g.a,query:null,fragment:null}):p}asFileUri(p){const y=this.b(p,x);return this.uriToFileUri(y)}uriToFileUri(p){return p.scheme===I.vscodeFileResource?p.with({scheme:I.file,authority:p.authority!==g.a?p.authority:null,query:null,fragment:null}):p}b(p,y){return D.URI.isUri(p)?p:D.URI.parse(y.toUrl(p))}}e.$Zg=new g;var w;(function(h){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(p.get("3"));const y="vscode-coi";function $(E){let k;typeof E=="string"?k=new URL(E).searchParams:E instanceof URL?k=E.searchParams:D.URI.isUri(E)&&(k=new URL(E.toString(!0)).searchParams);const t=k?.get(y);if(t)return p.get(t)}h.getHeadersFromQuery=$;function m(E,k,t){if(!globalThis.crossOriginIsolated)return;const r=k&&t?"3":t?"2":"1";E instanceof URLSearchParams?E.set(y,r):E[y]=r}h.addSearchParam=m})(w||(e.COI=w={}))}),define(oe[19],ae([0,1,39,31,12,10,3,26,7]),function(x,e,n,o,P,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=a,e.$ph=d,e.$qh=w,o=De(o),D=De(D);function a(h){return(0,b.$yc)(h,!0)}class f{constructor(p){this.a=p}compare(p,y,$=!1){return p===y?0:(0,I.$zf)(this.getComparisonKey(p,$),this.getComparisonKey(y,$))}isEqual(p,y,$=!1){return p===y?!0:!p||!y?!1:this.getComparisonKey(p,$)===this.getComparisonKey(y,$)}getComparisonKey(p,y=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,y,$=!1){if(p.scheme===y.scheme){if(p.scheme===P.Schemas.file)return o.$Eg(a(p),a(y),this.a(p))&&p.query===y.query&&($||p.fragment===y.fragment);if((0,e.$lh)(p.authority,y.authority))return o.$Eg(p.path,y.path,this.a(p),"/")&&p.query===y.query&&($||p.fragment===y.fragment)}return!1}joinPath(p,...y){return b.URI.joinPath(p,...y)}basenameOrAuthority(p){return(0,e.$dh)(p)||p.authority}basename(p){return D.$ic.basename(p.path)}extname(p){return D.$ic.extname(p.path)}dirname(p){if(p.path.length===0)return p;let y;return p.scheme===P.Schemas.file?y=b.URI.file(D.$oc(a(p))).path:(y=D.$ic.dirname(p.path),p.authority&&y.length&&y.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${p.toString})) resulted in a relative path`),y="/")),p.with({path:y})}normalizePath(p){if(!p.path.length)return p;let y;return p.scheme===P.Schemas.file?y=b.URI.file(D.$jc(a(p))).path:y=D.$ic.normalize(p.path),p.with({path:y})}relativePath(p,y){if(p.scheme!==y.scheme||!(0,e.$lh)(p.authority,y.authority))return;if(p.scheme===P.Schemas.file){const E=D.$nc(a(p),a(y));return A.$i?o.$yg(E):E}let $=p.path||"/";const m=y.path||"/";if(this.a(p)){let E=0;for(const k=Math.min($.length,m.length);E<k&&!($.charCodeAt(E)!==m.charCodeAt(E)&&$.charAt(E).toLowerCase()!==m.charAt(E).toLowerCase());E++);$=m.substr(0,E)+$.substr(E)}return D.$ic.relative($,m)}resolvePath(p,y){if(p.scheme===P.Schemas.file){const $=b.URI.file(D.$mc(a(p),y));return p.with({authority:$.authority,path:$.path})}return y=o.$zg(y),p.with({path:D.$ic.resolve(p.path,y)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,y){return p===y||p!==void 0&&y!==void 0&&(0,I.$Gf)(p,y)}hasTrailingPathSeparator(p,y=D.sep){if(p.scheme===P.Schemas.file){const $=a(p);return $.length>o.$Ag($).length&&$[$.length-1]===y}else{const $=p.path;return $.length>1&&$.charCodeAt($.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,y=D.sep){return(0,e.$mh)(p,y)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,y=D.sep){let $=!1;if(p.scheme===P.Schemas.file){const m=a(p);$=m!==void 0&&m.length===o.$Ag(m).length&&m[m.length-1]===y}else{y="/";const m=p.path;$=m.length===1&&m.charCodeAt(m.length-1)===n.CharCode.Slash}return!$&&!(0,e.$mh)(p,y)?p.with({path:p.path+"/"}):p}}e.$8g=f,e.$9g=new f(()=>!1),e.$0g=new f(h=>h.scheme===P.Schemas.file?!A.$k:!0),e.$$g=new f(h=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function d(h,p){const y=[];for(let $=0;$<h.length;$++){const m=p(h[$]);h.some((E,k)=>k===$?!1:(0,e.$ah)(m,p(E)))||y.push(h[$])}return y}var g;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function p(y){const $=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(k=>{const[t,r]=k.split(":");t&&r&&$.set(t,r)});const E=y.path.substring(0,y.path.indexOf(";"));return E&&$.set(h.META_DATA_MIME,E),$}h.parseMetaData=p})(g||(e.DataUri=g={}));function w(h,p,y){if(p){let $=h.path;return $&&$[0]!==D.$ic.sep&&($=D.$ic.sep+$),h.with({scheme:y,authority:p,path:$})}return h.with({scheme:y})}}),define(oe[8],ae([0,1,23,16,4,2,19,3,146,66]),function(x,e,n,o,P,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=f,e.$sh=d,e.$th=g,e.$uh=w,e.$vh=h,e.$wh=p,e.$xh=y,e.$yh=$,e.$Gh=l,e.$Hh=S,e.$Ih=v,e.$Jh=R,e.$Kh=T,e.$Zh=j,e.$8h=H;function f(X){return!!X&&typeof X.then=="function"}function d(X){const Z=new n.$xe,ie=X(Z.token),de=new Promise((me,we)=>{const Oe=Z.token.onCancellationRequested(()=>{Oe.dispose(),we(new o.$7)});Promise.resolve(ie).then(Se=>{Oe.dispose(),Z.dispose(),me(Se)},Se=>{Oe.dispose(),Z.dispose(),we(Se)})});return new class{cancel(){Z.cancel(),Z.dispose()}then(me,we){return de.then(me,we)}catch(me){return this.then(void 0,me)}finally(me){return de.finally(me)}}}function g(X,Z,ie){return new Promise((de,me)=>{const we=Z.onCancellationRequested(()=>{we.dispose(),de(ie)});X.then(de,me).finally(()=>we.dispose())})}function w(X,Z){return new Promise((ie,de)=>{const me=Z.onCancellationRequested(()=>{me.dispose(),de(new o.$7)});X.then(ie,de).finally(()=>me.dispose())})}async function h(X){let Z=-1;const ie=X.map((de,me)=>de.then(we=>(Z=me,we)));try{return await Promise.race(ie)}finally{X.forEach((de,me)=>{me!==Z&&de.cancel()})}}function p(X,Z,ie){let de;const me=setTimeout(()=>{de?.(void 0),ie?.()},Z);return Promise.race([X.finally(()=>clearTimeout(me)),new Promise(we=>de=we)])}function y(X){return new Promise((Z,ie)=>{const de=X();f(de)?de.then(Z,ie):Z(de)})}function $(){let X,Z;return{promise:new Promise((de,me)=>{X=de,Z=me}),resolve:X,reject:Z}}class m{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const ie=()=>{if(this.b=null,this.f)return;const de=this.queue(this.d);return this.d=null,de};this.b=new Promise(de=>{this.a.then(ie,ie).then(de)})}return new Promise((ie,de)=>{this.b.then(ie,de)})}return this.a=Z(),new Promise((ie,de)=>{this.a.then(me=>{this.a=null,ie(me)},me=>{this.a=null,de(me)})})}dispose(){this.f=!0}}e.$zh=m;class E{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$Ah=E;class k{constructor(){this.a=new Map}queue(Z,ie){const me=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(Z)===me&&this.a.delete(Z)});return this.a.set(Z,me),me}}e.$Bh=k;const t=(X,Z)=>{let ie=!0;const de=setTimeout(()=>{ie=!1,Z()},X);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(de),ie=!1}}},r=X=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,X())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class i{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,ie=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((me,we)=>{this.d=me,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const de=()=>{this.a=null,this.d?.(null)};return this.a=ie===b.$he?r(de):t(ie,de),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new o.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=i;class c{constructor(Z){this.a=new i(Z),this.b=new m}trigger(Z,ie){return this.a.trigger(()=>this.b.queue(Z),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=c;class s{constructor(){this.a=!1,this.b=new Promise((Z,ie)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=s;class u extends s{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$Fh=u;function l(X,Z){return Z?new Promise((ie,de)=>{const me=setTimeout(()=>{we.dispose(),ie()},X),we=Z.onCancellationRequested(()=>{clearTimeout(me),we.dispose(),de(new o.$7)})}):d(ie=>l(X,ie))}function S(X,Z=0,ie){const de=setTimeout(()=>{X(),ie&&me.dispose()},Z),me=(0,D.$Uc)(()=>{clearTimeout(de),ie?.deleteAndLeak(me)});return ie?.add(me),me}function v(X){const Z=[];let ie=0;const de=X.length;function me(){return ie<de?X[ie++]():null}function we(Oe){Oe!=null&&Z.push(Oe);const Se=me();return Se?Se.then(we):Promise.resolve(Z)}return Promise.resolve(null).then(we)}function R(X,Z=de=>!!de,ie=null){let de=0;const me=X.length,we=()=>{if(de>=me)return Promise.resolve(ie);const Oe=X[de++];return Promise.resolve(Oe()).then(ke=>Z(ke)?Promise.resolve(ke):we())};return we()}function T(X,Z=de=>!!de,ie=null){if(X.length===0)return Promise.resolve(ie);let de=X.length;const me=()=>{de=-1;for(const we of X)we.cancel?.()};return new Promise((we,Oe)=>{for(const Se of X)Se.then(ke=>{--de>=0&&Z(ke)?(me(),we(ke)):de===0&&we(ie)}).catch(ke=>{--de>=0&&(me(),Oe(ke))})})}class L{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new P.$me}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,de)=>{this.g.push({factory:Z,c:ie,e:de}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const ie=Z.factory();ie.then(Z.c,Z.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=L;class O extends L{constructor(){super(1)}}e.$Mh=O;class F{constructor(){this.a=new U,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$Nh=F;class B{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new G;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,ie=A.$9g){const de=ie.getComparisonKey(Z);return this.a.get(de)?.size??0}queueFor(Z,ie,de=A.$9g){const me=de.getComparisonKey(Z);let we=this.a.get(me);if(!we){we=new O;const Oe=this.f++,Se=P.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Oe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$6c),this.d.set(Oe,Se),this.a.set(me,we)}return we.queue(ie)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=B;class C{constructor(Z,ie){this.b=!1,this.a=-1,typeof Z=="function"&&typeof ie=="number"&&this.setIfNotSet(Z,ie)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,ie){if(this.b)throw new o.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},ie)}setIfNotSet(Z,ie){if(this.b)throw new o.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},ie))}}e.$Ph=C;class z{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,ie,de=globalThis){if(this.f)throw new o.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=de.setInterval(()=>{Z()},ie);this.d=(0,D.$Uc)(()=>{de.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=z;class re{constructor(Z,ie){this.b=-1,this.a=Z,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=re;class Q{constructor(Z,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=Z,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=Q;class le extends re{constructor(Z,ie){super(Z,ie),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Th=le;class K extends D.$Wc{constructor(Z,ie){super(),this.g=Z,this.h=ie,this.a=[],this.b=this.B(new D.$Xc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of Z)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new re(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(X,Z)=>{(0,I.$B)(()=>{if(ie)return;const de=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$Wh=(X,Z,ie)=>{const de=X.requestIdleCallback(Z,typeof ie=="number"?{timeout:ie}:void 0);let me=!1;return{dispose(){me||(me=!0,X.cancelIdleCallback(de))}}},e.$Vh=X=>(0,e.$Wh)(globalThis,X)}();class ee{constructor(Z,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(de){this.l=de}finally{this.g=!0}},this.f=(0,e.$Wh)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=ee;class q extends ee{constructor(Z){super(globalThis,Z)}}e.$Yh=q;async function j(X,Z,ie){let de;for(let me=0;me<ie;me++)try{return await X()}catch(we){de=we,await l(Z)}throw de}class U{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,ie,de){return this.a={taskId:Z,cancel:()=>de?.(),promise:ie},ie.then(()=>this.d(Z),()=>this.d(Z)),ie}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:ie,resolve:de,reject:me}=$();this.b={run:Z,promise:ie,promiseResolve:de,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=U;class V{constructor(Z,ie=()=>Date.now()){this.d=Z,this.f=ie,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$2h=V;var ce;(function(X){X[X.Resolved=0]="Resolved",X[X.Rejected=1]="Rejected"})(ce||(ce={}));class G{get isRejected(){return this.d?.outcome===ce.Rejected}get isResolved(){return this.d?.outcome===ce.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ce.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Z,ie)=>{this.a=Z,this.b=ie})}complete(Z){return new Promise(ie=>{this.a(Z),this.d={outcome:ce.Resolved,value:Z},ie()})}error(Z){return new Promise(ie=>{this.b(Z),this.d={outcome:ce.Rejected,value:Z},ie()})}cancel(){return this.error(new o.$7)}}e.$3h=G;var he;(function(X){async function Z(de){let me;const we=await Promise.all(de.map(Oe=>Oe.then(Se=>Se,Se=>{me||(me=Se)})));if(typeof me<"u")throw me;return we}X.settled=Z;function ie(de){return new Promise(async(me,we)=>{try{await de(me,we)}catch(Oe){we(Oe)}})}X.withAsyncBody=ie})(he||(e.Promises=he={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new o.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=se;class _{constructor(Z){this.b=Z,this.a=new a.$X(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=_;var M;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(M||(M={}));class N{static fromArray(Z){return new N(ie=>{ie.emitMany(Z)})}static fromPromise(Z){return new N(async ie=>{ie.emitMany(await Z)})}static fromPromises(Z){return new N(async ie=>{await Promise.all(Z.map(async de=>ie.emitOne(await de)))})}static merge(Z){return new N(async ie=>{await Promise.all(Z.map(async de=>{for await(const me of de)ie.emitOne(me)}))})}static{this.EMPTY=N.fromArray([])}constructor(Z,ie){this.a=M.Initial,this.b=[],this.d=null,this.f=ie,this.g=new P.$me,queueMicrotask(async()=>{const de={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(Z(de)),this.k()}catch(me){this.l(me)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===M.DoneError)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===M.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,ie){return new N(async de=>{for await(const me of Z)de.emitOne(ie(me))})}map(Z){return N.map(this,Z)}static filter(Z,ie){return new N(async de=>{for await(const me of Z)ie(me)&&de.emitOne(me)})}filter(Z){return N.filter(this,Z)}static coalesce(Z){return N.filter(Z,ie=>!!ie)}coalesce(){return N.coalesce(this)}static async toPromise(Z){const ie=[];for await(const de of Z)ie.push(de);return ie}toPromise(){return N.toPromise(this)}h(Z){this.a===M.Initial&&(this.b.push(Z),this.g.fire())}j(Z){this.a===M.Initial&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===M.Initial&&(this.a=M.DoneOK,this.g.fire())}l(Z){this.a===M.Initial&&(this.a=M.DoneError,this.d=Z,this.g.fire())}}e.$6h=N;class W extends N{constructor(Z,ie){super(ie),this.m=Z}cancel(){this.m.cancel()}}e.$7h=W;function H(X){const Z=new n.$xe,ie=X(Z.token);return new W(Z,async de=>{const me=Z.token.onCancellationRequested(()=>{me.dispose(),Z.dispose(),de.reject(new o.$7)});try{for await(const we of ie){if(Z.token.isCancellationRequested)return;de.emitOne(we)}me.dispose(),Z.dispose()}catch(we){me.dispose(),Z.dispose(),de.reject(we)}})}class J{constructor(Z){this.a=new G,this.b=new N(me=>{if(ie){me.reject(ie);return}return de&&me.emitMany(de),this.d=we=>me.reject(we),this.f=we=>me.emitOne(we),this.a.p},Z);let ie,de;this.f=me=>{de||(de=[]),de.push(me)},this.d=me=>{ie||(ie=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$9h=J}),define(oe[113],ae([0,1,22,8,39,31,32,10,3,26]),function(x,e,n,o,P,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=f,e.$xk=p,e.$yk=F,e.$zk=B,e.$Ak=C,e.$Bk=z,e.$Ck=re,e.$Dk=ee;function f(){return Object.create(null)}e.$vk="**",e.$wk="/";const d="[/\\\\]",g="[^/\\\\]",w=/\//g;function h(q,j){switch(q){case 0:return"";case 1:return`${g}*?`;default:return`(?:${d}|${g}+${d}${j?`|${d}${g}+`:""})*?`}}function p(q,j){if(!q)return[];const U=[];let V=!1,ce=!1,G="";for(const he of q){switch(he){case j:if(!V&&!ce){U.push(G),G="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}G+=he}return G&&U.push(G),U}function y(q){if(!q)return"";let j="";const U=p(q,e.$wk);if(U.every(V=>V===e.$vk))j=".*";else{let V=!1;U.forEach((ce,G)=>{if(ce===e.$vk){if(V)return;j+=h(2,G===U.length-1)}else{let he=!1,se="",_=!1,M="";for(const N of ce){if(N!=="}"&&he){se+=N;continue}if(_&&(N!=="]"||!M)){let W;N==="-"?W=N:(N==="^"||N==="!")&&!M?W="^":N===e.$wk?W="":W=(0,a.$if)(N),M+=W;continue}switch(N){case"{":he=!0;continue;case"[":_=!0;continue;case"}":{const H=`(?:${p(se,",").map(J=>y(J)).join("|")})`;j+=H,he=!1,se="";break}case"]":{j+="["+M+"]",_=!1,M="";break}case"?":j+=g;continue;case"*":j+=h(1);continue;default:j+=(0,a.$if)(N)}}G<U.length-1&&(U[G+1]!==e.$vk||G+2<U.length)&&(j+=d)}V=ce===e.$vk})}return j}const $=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new A.$Fc(1e4),c=function(){return!1},s=function(){return null};function u(q,j){if(!q)return s;let U;typeof q!="string"?U=q.pattern:U=q,U=U.trim();const V=`${U}_${!!j.trimForExclusions}`;let ce=i.get(V);if(ce)return l(ce,q);let G;return $.test(U)?ce=v(U.substr(4),U):(G=m.exec(S(U,j)))?ce=R(G[1],U):(j.trimForExclusions?k:E).test(U)?ce=T(U,j):(G=t.exec(S(U,j)))?ce=L(G[1].substr(1),U,!0):(G=r.exec(S(U,j)))?ce=L(G[1],U,!1):ce=O(U),i.set(V,ce),l(ce,q)}function l(q,j){if(typeof j=="string")return q;const U=function(V,ce){return(0,D.$Eg)(V,j.base,!b.$k)?q((0,a.$nf)(V.substr(j.base.length),I.sep),ce):null};return U.allBasenames=q.allBasenames,U.allPaths=q.allPaths,U.basenames=q.basenames,U.patterns=q.patterns,U}function S(q,j){return j.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function v(q,j){return function(U,V){return typeof U=="string"&&U.endsWith(q)?j:null}}function R(q,j){const U=`/${q}`,V=`\\${q}`,ce=function(he,se){return typeof he!="string"?null:se?se===q?j:null:he===q||he.endsWith(U)||he.endsWith(V)?j:null},G=[q];return ce.basenames=G,ce.patterns=[j],ce.allBasenames=G,ce}function T(q,j){const U=K(q.slice(1,-1).split(",").map(se=>u(se,j)).filter(se=>se!==s),q),V=U.length;if(!V)return s;if(V===1)return U[0];const ce=function(se,_){for(let M=0,N=U.length;M<N;M++)if(U[M](se,_))return q;return null},G=U.find(se=>!!se.allBasenames);G&&(ce.allBasenames=G.allBasenames);const he=U.reduce((se,_)=>_.allPaths?se.concat(_.allPaths):se,[]);return he.length&&(ce.allPaths=he),ce}function L(q,j,U){const V=I.sep===I.$ic.sep,ce=V?q:q.replace(w,I.sep),G=I.sep+ce,he=I.$ic.sep+q;let se;return U?se=function(_,M){return typeof _=="string"&&(_===ce||_.endsWith(G)||!V&&(_===q||_.endsWith(he)))?j:null}:se=function(_,M){return typeof _=="string"&&(_===ce||!V&&_===q)?j:null},se.allPaths=[(U?"*/":"./")+q],se}function O(q){try{const j=new RegExp(`^${y(q)}$`);return function(U){return j.lastIndex=0,typeof U=="string"&&j.test(U)?q:null}}catch{return s}}function F(q,j,U){return!q||typeof j!="string"?!1:B(q)(j,void 0,U)}function B(q,j={}){if(!q)return c;if(typeof q=="string"||C(q)){const U=u(q,j);if(U===s)return c;const V=function(ce,G){return!!U(ce,G)};return U.allBasenames&&(V.allBasenames=U.allBasenames),U.allPaths&&(V.allPaths=U.allPaths),V}return Q(q,j)}function C(q){const j=q;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}function z(q){return q.allBasenames||[]}function re(q){return q.allPaths||[]}function Q(q,j){const U=K(Object.getOwnPropertyNames(q).map(se=>le(se,q[se],j)).filter(se=>se!==s)),V=U.length;if(!V)return s;if(!U.some(se=>!!se.requiresSiblings)){if(V===1)return U[0];const se=function(N,W){let H;for(let J=0,X=U.length;J<X;J++){const Z=U[J](N,W);if(typeof Z=="string")return Z;(0,o.$rh)(Z)&&(H||(H=[]),H.push(Z))}return H?(async()=>{for(const J of H){const X=await J;if(typeof X=="string")return X}return null})():null},_=U.find(N=>!!N.allBasenames);_&&(se.allBasenames=_.allBasenames);const M=U.reduce((N,W)=>W.allPaths?N.concat(W.allPaths):N,[]);return M.length&&(se.allPaths=M),se}const ce=function(se,_,M){let N,W;for(let H=0,J=U.length;H<J;H++){const X=U[H];X.requiresSiblings&&M&&(_||(_=(0,I.$pc)(se)),N||(N=_.substr(0,_.length-(0,I.$qc)(se).length)));const Z=X(se,_,N,M);if(typeof Z=="string")return Z;(0,o.$rh)(Z)&&(W||(W=[]),W.push(Z))}return W?(async()=>{for(const H of W){const J=await H;if(typeof J=="string")return J}return null})():null},G=U.find(se=>!!se.allBasenames);G&&(ce.allBasenames=G.allBasenames);const he=U.reduce((se,_)=>_.allPaths?se.concat(_.allPaths):se,[]);return he.length&&(ce.allPaths=he),ce}function le(q,j,U){if(j===!1)return s;const V=u(q,U);if(V===s)return s;if(typeof j=="boolean")return V;if(j){const ce=j.when;if(typeof ce=="string"){const G=(he,se,_,M)=>{if(!M||!V(he,se))return null;const N=ce.replace("$(basename)",()=>_),W=M(N);return(0,o.$rh)(W)?W.then(H=>H?q:null):W?q:null};return G.requiresSiblings=!0,G}}return V}function K(q,j){const U=q.filter(se=>!!se.basenames);if(U.length<2)return q;const V=U.reduce((se,_)=>{const M=_.basenames;return M?se.concat(M):se},[]);let ce;if(j){ce=[];for(let se=0,_=V.length;se<_;se++)ce.push(j)}else ce=U.reduce((se,_)=>{const M=_.patterns;return M?se.concat(M):se},[]);const G=function(se,_){if(typeof se!="string")return null;if(!_){let N;for(N=se.length;N>0;N--){const W=se.charCodeAt(N-1);if(W===P.CharCode.Slash||W===P.CharCode.Backslash)break}_=se.substr(N)}const M=V.indexOf(_);return M!==-1?ce[M]:null};G.basenames=V,G.patterns=ce,G.allBasenames=V;const he=q.filter(se=>!se.basenames);return he.push(G),he}function ee(q,j){return(0,n.$wb)(q,j,(U,V)=>typeof U=="string"&&typeof V=="string"?U===V:typeof U!="string"&&typeof V!="string"?U.base===V.base&&U.pattern===V.pattern:!1)}}),define(oe[48],ae([0,1,22,31,10,3,19,26]),function(x,e,n,o,P,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vw=b,e.$Ww=f,e.$Xw=g,e.$Yw=w,e.$Zw=$,e.$1w=E,e.$2w=k,e.$3w=t,e.$4w=r,e.$5w=i;function b(s,u){const{os:l,tildify:S,relative:v}=u;if(v){const L=a(s,v,l);if(typeof L=="string")return L}let R=s.fsPath;if(l===D.OperatingSystem.Windows&&!D.$i?R=R.replace(/\//g,"\\"):l!==D.OperatingSystem.Windows&&D.$i&&(R=R.replace(/\\/g,"/")),l!==D.OperatingSystem.Windows&&S?.userHome){const L=S.userHome.fsPath;let O;s.scheme!==S.userHome.scheme&&s.path[0]===P.$ic.sep&&s.path[1]!==P.$ic.sep?O=S.userHome.with({path:s.path}).fsPath:O=R,R=g(O,L,l)}return(l===D.OperatingSystem.Windows?P.$hc:P.$ic).normalize(f(R,l===D.OperatingSystem.Windows))}function a(s,u,l){const S=l===D.OperatingSystem.Windows?P.$hc:P.$ic,v=l===D.OperatingSystem.Linux?A.$9g:A.$$g,R=u.getWorkspace(),T=(0,n.$Qb)(R.folders);if(!T)return;s.scheme!==T.uri.scheme&&s.path[0]===P.$ic.sep&&s.path[1]!==P.$ic.sep&&(s=T.uri.with({path:s.path}));const L=u.getWorkspaceFolder(s);if(!L)return;let O;if(v.isEqual(L.uri,s)?O="":O=v.relativePath(L.uri,s)??"",O&&(O=S.normalize(O)),R.folders.length>1&&!u.noPrefix){const F=L.name?L.name:v.basenameOrAuthority(L.uri);O=O?`${F} \u2022 ${O}`:F}return O}function f(s,u=D.$i){return(0,o.$Jg)(s,u)?s.charAt(0).toUpperCase()+s.slice(1):s}let d=Object.create(null);function g(s,u,l=D.OS){if(l===D.OperatingSystem.Windows||!s||!u)return s;let S=d.original===u?d.normalized:void 0;S||(S=u,D.$i&&(S=(0,o.$yg)(S)),S=`${(0,I.$of)(S,P.$ic.sep)}${P.$ic.sep}`,d={original:u,normalized:S});let v=s;return D.$i&&(v=(0,o.$yg)(v)),(l===D.OperatingSystem.Linux?v.startsWith(S):(0,I.$Hf)(v,S))?`~/${v.substr(S.length)}`:s}function w(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}const h="\u2026",p="\\\\",y="~";function $(s,u=P.sep){const l=new Array(s.length);let S=!1;for(let v=0;v<s.length;v++){const R=s[v];if(R===""){l[v]=`.${u}`;continue}if(!R){l[v]=R;continue}S=!0;let T="",L=R;L.indexOf(p)===0?(T=L.substr(0,L.indexOf(p)+p.length),L=L.substr(L.indexOf(p)+p.length)):L.indexOf(u)===0?(T=L.substr(0,L.indexOf(u)+u.length),L=L.substr(L.indexOf(u)+u.length)):L.indexOf(y)===0&&(T=L.substr(0,L.indexOf(y)+y.length),L=L.substr(L.indexOf(y)+y.length));const O=L.split(u);for(let F=1;S&&F<=O.length;F++)for(let B=O.length-F;S&&B>=0;B--){S=!1;let C=O.slice(B,B+F).join(u);for(let z=0;!S&&z<s.length;z++)if(z!==v&&s[z]&&s[z].indexOf(C)>-1){const re=B+F===O.length,Q=B>0&&s[z].indexOf(u)>-1?u+C:C,le=s[z].endsWith(Q);S=!re||le}if(!S){let z="";(O[0].endsWith(":")||T!=="")&&(B===1&&(B=0,F++,C=O[0]+u+C),B>0&&(z=O[0]+u),z=T+z),B>0&&(z=z+h+u),z=z+C,B+F<O.length&&(z=z+u+h),l[v]=z}}S&&(l[v]=R)}return l}var m;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function E(s,u=Object.create(null)){const l=[];let S=!1,v="";for(const R of s)if(R==="$"||S&&R==="{")v&&l.push({value:v,type:m.TEXT}),v="",S=!0;else if(R==="}"&&S){const T=u[v];if(typeof T=="string")T.length&&l.push({value:T,type:m.VARIABLE});else if(T){const L=l[l.length-1];(!L||L.type!==m.SEPARATOR)&&l.push({value:T.label,type:m.SEPARATOR})}v="",S=!1}else v+=R;return v&&!S&&l.push({value:v,type:m.TEXT}),l.filter((R,T)=>{if(R.type===m.SEPARATOR){const L=l[T-1],O=l[T+1];return[L,O].every(F=>F&&(F.type===m.VARIABLE||F.type===m.TEXT)&&F.value.length>0)}return!0}).map(R=>R.value).join("")}function k(s,u){return D.$j||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.$j?"&":"&&"):s.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function t(s,u){return D.$j||u?s.replace(/\(&&\w\)|&&/g,""):D.$i?s.replace(/&&|&/g,l=>l==="&"?"&&":"&"):s.replace(/&&/g,"_")}function r(s){return s.replace(/&/g,"&&")}function i(s){if(s.endsWith("]")){const u=s.lastIndexOf(" [",s.length-2);if(u!==-1){const l=c(s.substring(0,u)),S=s.substring(u);return{name:l.name+S,parentPath:l.parentPath}}}return c(s)}function c(s){const u=s.indexOf("/")!==-1?P.$ic:P.$hc,l=u.basename(s),S=u.dirname(s);return l.length?{name:l,parentPath:S}:{name:S,parentPath:""}}}),define(oe[160],ae([0,1,17,91,7]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=void 0,e.$Nn=b,e.$On=f,e.$Pn=d;function D(g){return g.toJSON()}class A{constructor(w){this.a=w}transformIncoming(w){const h=this.a.transformIncoming(w);return h===w?w:D(P.URI.from(h))}transformOutgoing(w){const h=this.a.transformOutgoing(w);return h===w?w:D(P.URI.from(h))}transformOutgoingURI(w){const h=this.a.transformOutgoing(w);return h===w?w:P.URI.from(h)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Ln=A,e.$Mn=new class{transformIncoming(g){return g}transformOutgoing(g){return g}transformOutgoingURI(g){return g}transformOutgoingScheme(g){return g}};function I(g,w,h){if(!g||h>200)return null;if(typeof g=="object"){if(g instanceof P.URI)return w.transformOutgoing(g);for(const p in g)if(Object.hasOwnProperty.call(g,p)){const y=I(g[p],w,h+1);y!==null&&(g[p]=y)}}return null}function b(g,w){const h=I(g,w,0);return h===null?g:h}function a(g,w,h,p){if(!g||p>200)return null;if(typeof g=="object"){if(g.$mid===o.MarshalledId.Uri)return h?P.URI.revive(w.transformIncoming(g)):w.transformIncoming(g);if(g instanceof n.$Oe)return null;for(const y in g)if(Object.hasOwnProperty.call(g,y)){const $=a(g[y],w,h,p+1);$!==null&&(g[y]=$)}}return null}function f(g,w){const h=a(g,w,!1,0);return h===null?g:h}function d(g,w){const h=a(g,w,!0,0);return h===null?g:h}}),define(oe[94],ae([0,1,27,61,33,150,3]),function(x,e,n,o,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=void 0,e.$Sn=b,e.$Tn=d,e.$Un=g,P=De(P),e.$Rn=new class{c(w){return this.a||(this.a=o.$Li.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,h=0;const p=(0,n.networkInterfaces)();for(const y in p){const $=p[y];if($)for(const{mac:m,internal:E}of $)E||(h+=1,this.c(m.toUpperCase())&&(w+=1))}this.b=h>0?w/h:0}return this.b}};let I;async function b(w){return I||(I=(async()=>await a(w)||P.$2g())()),I}async function a(w){try{const h=await new Promise((y,$)=>{x(["crypto"],y,$)}).then(De),p=(0,D.$Qn)();return h.createHash("sha256").update(p,"utf8").digest("hex")}catch(h){w(h);return}}const f="Software\\Microsoft\\SQMClient";async function d(w){if(A.$i){const h=await new Promise((p,y)=>{x(["@vscode/windows-registry"],p,y)}).then(De);try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",f,"MachineId")||""}catch(p){return w(p),""}}return""}async function g(w){try{return await(await new Promise((y,$)=>{x(["@vscode/deviceid"],y,$)}).then(De)).getDeviceId()}catch(h){return w(h),""}}}),define(oe[21],ae([0,1,47,27,161,8,31,79,10,3,19,7]),function(x,e,n,o,P,D,A,I,b,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=y,e.readdirSync=E,e.whenDeleted=r,e.configureFlushOnWrite=l,e.writeFileSync=v,n=De(n);var g;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function w(Q,le=g.UNLINK,K){if((0,A.$Ig)(Q))throw new Error("rimraf - will refuse to recursively delete root");return le===g.UNLINK?p(Q):h(Q,K)}async function h(Q,le=(0,A.$Ng)((0,o.tmpdir)())){try{try{await n.promises.rename(Q,le)}catch(K){return K.code==="ENOENT"?void 0:p(Q)}p(le).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function p(Q){return n.promises.rm(Q,{recursive:!0,force:!0,maxRetries:3})}function y(Q){if((0,A.$Ig)(Q))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(Q,{recursive:!0,force:!0,maxRetries:3})}async function $(Q,le){return k(await(le?m(Q):n.promises.readdir(Q)))}async function m(Q){try{return await n.promises.readdir(Q,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const le=[],K=await $(Q);for(const ee of K){let q=!1,j=!1,U=!1;try{const V=await e.Promises.lstat((0,b.$lc)(Q,ee));q=V.isFile(),j=V.isDirectory(),U=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}le.push({name:ee,isFile:()=>q,isDirectory:()=>j,isSymbolicLink:()=>U})}return le}function E(Q){return k(n.readdirSync(Q))}function k(Q){return Q.map(le=>typeof le=="string"?a.$j?(0,I.$mm)(le):le:(le.name=a.$j?(0,I.$mm)(le.name):le.name,le))}async function t(Q){const le=await $(Q),K=[];for(const ee of le)await i.existsDirectory((0,b.$lc)(Q,ee))&&K.push(ee);return K}function r(Q,le=1e3){return new Promise(K=>{let ee=!1;const q=setInterval(()=>{ee||(ee=!0,n.access(Q,j=>{ee=!1,j&&(clearInterval(q),K(void 0))}))},le)})}var i;(function(Q){async function le(q){let j;try{if(j=await e.Promises.lstat(q),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(a.$i&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw V}throw U}}Q.stat=le;async function K(q){try{const{stat:j,symbolicLink:U}=await Q.stat(q);return j.isFile()&&U?.dangling!==!0}catch{}return!1}Q.existsFile=K;async function ee(q){try{const{stat:j,symbolicLink:U}=await Q.stat(q);return j.isDirectory()&&U?.dangling!==!0}catch{}return!1}Q.existsDirectory=ee})(i||(e.SymlinkSupport=i={}));const c=new D.$Oh;function s(Q,le,K){return c.queueFor(d.URI.file(Q),()=>{const ee=R(K);return new Promise((q,j)=>S(Q,le,ee,U=>U?j(U):q()))},f.$0g)}let u=!0;function l(Q){u=Q}function S(Q,le,K,ee){if(!u)return n.writeFile(Q,le,{mode:K.mode,flag:K.flag},ee);n.open(Q,K.flag,K.mode,(q,j)=>{if(q)return ee(q);n.writeFile(j,le,U=>{if(U)return n.close(j,()=>ee(U));n.fdatasync(j,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),l(!1)),n.close(j,ce=>ee(ce))))})})}function v(Q,le,K){const ee=R(K);if(!u)return n.writeFileSync(Q,le,{mode:ee.mode,flag:ee.flag});const q=n.openSync(Q,ee.flag,ee.mode);try{n.writeFileSync(q,le);try{n.fdatasyncSync(q)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),l(!1)}}finally{n.closeSync(q)}}function R(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function T(Q,le,K=6e4){if(Q!==le)try{a.$i&&typeof K=="number"?await L(Q,le,Date.now(),K):await n.promises.rename(Q,le)}catch(ee){if(Q.toLowerCase()!==le.toLowerCase()&&ee.code==="EXDEV"||Q.endsWith("."))await O(Q,le,{preserveSymlinks:!1}),await w(Q,g.MOVE);else throw ee}}async function L(Q,le,K,ee,q=0){try{return await n.promises.rename(Q,le)}catch(j){if(j.code!=="EACCES"&&j.code!=="EPERM"&&j.code!=="EBUSY")throw j;if(Date.now()-K>=ee)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${j}`),j;if(q===0){let U=!1;try{const{stat:V}=await i.stat(le);V.isFile()||(U=!0)}catch{}if(U)throw j}return await(0,D.$Gh)(Math.min(100,q*10)),L(Q,le,K,ee,q+1)}}async function O(Q,le,K){return B(Q,le,{root:{source:Q,target:le},options:K,handledSourcePaths:new Set})}const F=511;async function B(Q,le,K){if(K.handledSourcePaths.has(Q))return;K.handledSourcePaths.add(Q);const{stat:ee,symbolicLink:q}=await i.stat(Q);if(q){if(K.options.preserveSymlinks)try{return await re(Q,le,K)}catch{}if(q.dangling)return}return ee.isDirectory()?C(Q,le,ee.mode&F,K):z(Q,le,ee.mode&F)}async function C(Q,le,K,ee){await e.Promises.mkdir(le,{recursive:!0,mode:K});const q=await $(Q);for(const j of q)await B((0,b.$lc)(Q,j),(0,b.$lc)(le,j),ee)}async function z(Q,le,K){await e.Promises.copyFile(Q,le),await e.Promises.chmod(le,K)}async function re(Q,le,K){let ee=await e.Promises.readlink(Q);(0,A.$Eg)(ee,K.root.source,!a.$k)&&(ee=(0,b.$lc)(K.root.target,ee.substr(K.root.source.length+1))),await e.Promises.symlink(ee,le)}e.Promises=new class{get access(){return n.promises.access}get stat(){return n.promises.stat}get lstat(){return n.promises.lstat}get utimes(){return n.promises.utimes}get read(){return(Q,le,K,ee,q)=>new Promise((j,U)=>{n.read(Q,le,K,ee,q,(V,ce,G)=>V?U(V):j({bytesRead:ce,buffer:G}))})}get readFile(){return n.promises.readFile}get write(){return(Q,le,K,ee,q)=>new Promise((j,U)=>{n.write(Q,le,K,ee,q,(V,ce,G)=>V?U(V):j({bytesWritten:ce,buffer:G}))})}get appendFile(){return n.promises.appendFile}get fdatasync(){return(0,P.promisify)(n.fdatasync)}get truncate(){return n.promises.truncate}get copyFile(){return n.promises.copyFile}get open(){return(0,P.promisify)(n.open)}get close(){return(0,P.promisify)(n.close)}get symlink(){return n.promises.symlink}get readlink(){return n.promises.readlink}get chmod(){return n.promises.chmod}get mkdir(){return n.promises.mkdir}get unlink(){return n.promises.unlink}get rmdir(){return n.promises.rmdir}get realpath(){return(0,P.promisify)(n.realpath)}async exists(Q){try{return await e.Promises.access(Q),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return t}get writeFile(){return s}get rm(){return w}get rename(){return T}get copy(){return O}}}),define(oe[114],ae([0,1,47,10,3,26,21]),function(x,e,n,o,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=I,e.$jr=b,e.$kr=a,e.$lr=f,n=De(n);function I(g){if(P.$k)return g;const w=(0,o.$oc)(g);if(g===w)return g;const h=((0,o.$pc)(g)||g).toLowerCase();try{const y=(0,A.readdirSync)(w).filter($=>$.toLowerCase()===h);if(y.length===1){const $=I(w);if($)return(0,o.$lc)($,y[0])}else if(y.length>1){const $=y.indexOf(h);if($>=0){const m=I(w);if(m)return(0,o.$lc)(m,y[$])}}}catch{}return null}async function b(g,w){if(P.$k)return g;const h=(0,o.$oc)(g);if(g===h)return g;const p=((0,o.$pc)(g)||g).toLowerCase();try{if(w?.isCancellationRequested)return null;const $=(await A.Promises.readdir(h)).filter(m=>m.toLowerCase()===p);if($.length===1){const m=await b(h,w);if(m)return(0,o.$lc)(m,$[0])}else if($.length>1){const m=$.indexOf(p);if(m>=0){const E=await b(h,w);if(E)return(0,o.$lc)(E,$[m])}}}catch{}return null}async function a(g){try{return await A.Promises.realpath(g)}catch{const h=d(g);return await A.Promises.access(h,n.constants.R_OK),h}}function f(g){try{return n.realpathSync(g)}catch{const h=d(g);return n.accessSync(h,n.constants.R_OK),h}}function d(g){return(0,D.$of)((0,o.$jc)(g),o.sep)}}),define(oe[115],ae([0,1,27,10,21]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=m,e.$wm=E,n=De(n),o=De(o),P=De(P);const D=/^\d+$/,A=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var b;(function(k){k[k.x64=0]="x64",k[k.x86=1]="x86",k[k.ARM=2]="ARM"})(b||(b={}));let a;switch(process.arch){case"ia32":a=b.x86;break;case"arm":case"arm64":a=b.ARM;break;default:a=b.x64;break}let f;process.env.PROCESSOR_ARCHITEW6432?f=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?b.ARM:b.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?f=b.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?f=b.x86:f=b.x64;class d{constructor(t,r,i){this.exePath=t,this.displayName=r,this.a=i}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:k=!1}={}){return k?a===b.x64?process.env["ProgramFiles(x86)"]||null:f===b.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:k=!1,findPreview:t=!1}={}){const r=g({useAlternateBitness:k});if(!r)return null;const i=o.$lc(r,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(i))return null;let c=-1,s=null;for(const S of await P.Promises.readdir(i)){let v=-1;if(t){const T=S.indexOf("-");if(T<0)continue;const L=S.substring(0,T);if(!D.test(L)||S.substring(T+1)!=="preview")continue;v=parseInt(L,10)}else{if(!D.test(S))continue;v=parseInt(S,10)}if(v<=c)continue;const R=o.$lc(i,S,"pwsh.exe");await P.SymlinkSupport.existsFile(R)&&(s=R,c=v)}if(!s)return null;const u=r.includes("x86")?" (x86)":"",l=t?" Preview":"";return new d(s,`PowerShell${l}${u}`,!0)}async function h({findPreview:k}={}){if(!process.env.LOCALAPPDATA)return null;const t=o.$lc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:r,pwshMsixName:i}=k?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const c of await P.Promises.readdir(t))if(r.test(c)){const s=o.$lc(t,c,"pwsh.exe");return new d(s,i)}return null}function p(){const k=o.$lc(n.homedir(),".dotnet","tools","pwsh.exe");return new d(k,".NET Core PowerShell Global Tool")}function y(){const k=o.$lc(process.env.windir,a===b.x86&&f!==b.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new d(k,"Windows PowerShell",!0)}async function*$(){let k=await w();k&&(yield k),k=await w({useAlternateBitness:!0}),k&&(yield k),k=await h(),k&&(yield k),k=p(),k&&(yield k),k=await w({findPreview:!0}),k&&(yield k),k=await h({findPreview:!0}),k&&(yield k),k=await w({useAlternateBitness:!0,findPreview:!0}),k&&(yield k),k=y(),k&&(yield k)}async function*m(){for await(const k of $())await k.exists()&&(yield k)}async function E(){for await(const k of m())return k;return null}}),define(oe[95],ae([0,1,10,3,37,82,13,21]),function(x,e,n,o,P,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$xm=b,e.$ym=a,n=De(n),o=De(o),P=De(P),A=De(A),I=De(I),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function b(d=P.env){return d.comspec||"cmd.exe"}function a(d){let g=[],w=!1;const h=function(p){if(w){g.push(p);return}(!d.send(p,$=>{if($&&console.error($),w=!1,g.length>0){const m=g.slice(0);g=[],m.forEach(E=>h(E))}})||o.$i)&&(w=!0)};return{send:h}}var f;(function(d){async function g(w,h,p){if(n.$kc(w))return w;if(h===void 0&&(h=P.cwd()),n.$oc(w)!=="."||(p===void 0&&A.$fg(P.env.PATH)&&(p=P.env.PATH.split(n.$vc)),p===void 0||p.length===0))return n.$lc(h,w);async function $(m){if(await I.Promises.exists(m)){let E;try{E=await I.Promises.stat(m)}catch(k){k.message.startsWith("EACCES")&&(E=await I.Promises.lstat(m))}return E?!E.isDirectory():!1}return!1}for(const m of p){let E;if(n.$kc(m)?E=n.$lc(m,w):E=n.$lc(h,m,w),await $(E))return E;let k=E+".com";if(await $(k)||(k=E+".exe",await $(k)))return k}return n.$lc(h,w)}d.findExecutable=g})(f||(e.win32=f={}))}),define(oe[116],ae([0,1,49,12]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=P;function P(A){return new Promise((I,b)=>{let a;const f=new Map;function d(w,h,p,y,$){const m=f.get(h);if(w===A||m){const E={name:g(p),cmd:p,pid:w,ppid:h,load:y,mem:$};f.set(w,E),w===A&&(a=E),m&&(m.children||(m.children=[]),m.children.push(E),m.children.length>1&&(m.children=m.children.sort((k,t)=>k.pid-t.pid)))}}function g(w){const h=/--utility-sub-type=network/i,p=/--crashes-directory/i,y=/\\pipe\\winpty-control/i,$=/conhost\.exe.+--headless/i,m=/--type=([a-zA-Z-]+)/;if(p.exec(w))return"electron-crash-reporter";if(y.exec(w))return"winpty-agent";if($.exec(w))return"conpty-agent";let E=m.exec(w);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?h.exec(w)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const k=/[a-zA-Z-]+\.js/g;let t="";do E=k.exec(w),E&&(t+=E+" ");while(E);return t&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron-nodejs (${t})`:w}if(process.platform==="win32"){const w=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substring(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substring(5):h;new Promise((h,p)=>{x(["@vscode/windows-process-tree"],h,p)}).then(De).then(h=>{h.getProcessList(A,p=>{if(!p){b(new Error(`Root process ${A} not found`));return}h.getProcessCpuUsage(p,y=>{const $=new Map;y.forEach(m=>{const E=w(m.commandLine||"");$.set(m.pid,{name:g(E),cmd:E,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),a=$.get(A),a?($.forEach(m=>{const E=$.get(m.ppid);E&&(E.children||(E.children=[]),E.children.push(m))}),$.forEach(m=>{m.children&&(m.children=m.children.sort((E,k)=>E.pid-k.pid))}),I(a)):b(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let w=function(){let h=[a];const p=[];for(;h.length;){const $=h.shift();$&&(p.push($.pid),$.children&&(h=h.concat($.children)))}let y=JSON.stringify(o.$Zg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);y+=" "+p.join(" "),(0,n.exec)(y,{},($,m,E)=>{if($||E)b($||new Error(E.toString()));else{const k=m.toString().split(`
`);for(let t=0;t<p.length;t++){const r=f.get(p[t]);r.load=parseFloat(k[t])}if(!a){b(new Error(`Root process ${A} not found`));return}I(a)}})};(0,n.exec)("which ps",{},(h,p,y)=>{if(h||y)if(process.platform!=="linux")b(h||new Error(y.toString()));else{const $=JSON.stringify(o.$Zg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)($,{},(m,E,k)=>{m||k?b(m||new Error(k.toString())):(D(E,d),w())})}else{const $=p.toString().trim();(0,n.exec)(`${$} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(E,k,t)=>{E||t&&!t.includes("screen size is bogus")?b(E||new Error(t.toString())):(D(k,d),process.platform==="linux"?w():a?I(a):b(new Error(`Root process ${A} not found`)))})}})}})}function D(A,I){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=A.toString().split(`
`);for(const f of a){const d=b.exec(f.trim());d&&d.length===6&&I(parseInt(d[1]),parseInt(d[2]),d[5],parseFloat(d[3]),parseFloat(d[4]))}}}),define(oe[117],ae([0,1,27,3,115,95]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=A,o=De(o),D=De(D);async function A(d,g){return d===o.OperatingSystem.Windows?o.$i?f():D.$xm(g):b(d,g)}let I=null;function b(d,g){if(o.$k&&d===o.OperatingSystem.Macintosh||o.$j&&d===o.OperatingSystem.Linux)return"/bin/bash";if(!I){let w;if(o.$i)w="/bin/bash";else{if(w=g.SHELL,!w)try{w=(0,n.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}I=w}return I}let a=null;async function f(){return a||(a=(await(0,P.$wm)()).exePath),a}});var Pe=this&&this.__decorate||function(x,e,n,o){var P=arguments.length,D=P<3?e:o===null?o=Object.getOwnPropertyDescriptor(e,n):o,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(x,e,n,o);else for(var I=x.length-1;I>=0;I--)(A=x[I])&&(D=(P<3?A(D):P>3?A(e,n,D):A(e,n))||D);return P>3&&D&&Object.defineProperty(e,n,D),D};define(oe[44],ae([0,1,22,8,17,23,54,16,4,2,83,26,13]),function(x,e,n,o,P,D,A,I,b,a,f,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=l,e.$gi=S,e.$li=F,e.$mi=B,d=De(d);var w;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(w||(w={}));function h(q){switch(q){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var p;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(p||(p={}));function y(q){switch(q){case p.Initialize:return"init";case p.PromiseSuccess:return"reply:";case p.PromiseError:case p.PromiseErrorObj:return"replyErr:";case p.EventFire:return"event:"}}var $;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})($||($={}));function m(q){let j=0;for(let U=0;;U+=7){const V=q.read(1);if(j|=(V.buffer[0]&127)<<U,!(V.buffer[0]&128))return j}}const E=c(0);function k(q,j){if(j===0){q.write(E);return}let U=0;for(let ce=j;ce!==0;ce=ce>>>7)U++;const V=P.$Oe.alloc(U);for(let ce=0;j!==0;ce++)V.buffer[ce]=j&127,j=j>>>7,j>0&&(V.buffer[ce]|=128);q.write(V)}class t{constructor(j){this.b=j,this.a=0}read(j){const U=this.b.slice(this.a,this.a+j);return this.a+=U.byteLength,U}}e.$di=t;class r{constructor(){this.a=[]}get buffer(){return P.$Oe.concat(this.a)}write(j){this.a.push(j)}}e.$ei=r;var i;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(i||(i={}));function c(q){const j=P.$Oe.alloc(1);return j.writeUInt8(q,0),j}const s={Undefined:c(i.Undefined),String:c(i.String),Buffer:c(i.Buffer),VSBuffer:c(i.VSBuffer),Array:c(i.Array),Object:c(i.Object),Uint:c(i.Int)},u=typeof Buffer<"u";function l(q,j){if(typeof j>"u")q.write(s.Undefined);else if(typeof j=="string"){const U=P.$Oe.fromString(j);q.write(s.String),k(q,U.byteLength),q.write(U)}else if(u&&Buffer.isBuffer(j)){const U=P.$Oe.wrap(j);q.write(s.Buffer),k(q,U.byteLength),q.write(U)}else if(j instanceof P.$Oe)q.write(s.VSBuffer),k(q,j.byteLength),q.write(j);else if(Array.isArray(j)){q.write(s.Array),k(q,j.length);for(const U of j)l(q,U)}else if(typeof j=="number"&&(j|0)===j)q.write(s.Uint),k(q,j);else{const U=P.$Oe.fromString(JSON.stringify(j));q.write(s.Object),k(q,U.byteLength),q.write(U)}}function S(q){switch(q.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return q.read(m(q)).toString();case i.Buffer:return q.read(m(q)).buffer;case i.VSBuffer:return q.read(m(q));case i.Array:{const U=m(q),V=[];for(let ce=0;ce<U;ce++)V.push(S(q));return V}case i.Object:return JSON.parse(q.read(m(q)).toString());case i.Int:return m(q)}}class v{constructor(j,U,V=null,ce=1e3){this.h=j,this.j=U,this.k=V,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:p.Initialize})}registerChannel(j,U){this.b.set(j,U),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case p.Initialize:{const U=this.o([j.type]);this.k?.logOutgoing(U,0,R.OtherSide,y(j.type));return}case p.PromiseSuccess:case p.PromiseError:case p.EventFire:case p.PromiseErrorObj:{const U=this.o([j.type,j.id],j.data);this.k?.logOutgoing(U,j.id,R.OtherSide,y(j.type),j.data);return}}}o(j,U=void 0){const V=new r;return l(V,j),l(V,U),this.p(V.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const U=new t(j),V=S(U),ce=S(U),G=V[0];switch(G){case w.Promise:return this.k?.logIncoming(j.byteLength,V[1],R.OtherSide,`${h(G)}: ${V[2]}.${V[3]}`,ce),this.s({type:G,id:V[1],channelName:V[2],name:V[3],arg:ce});case w.EventListen:return this.k?.logIncoming(j.byteLength,V[1],R.OtherSide,`${h(G)}: ${V[2]}.${V[3]}`,ce),this.t({type:G,id:V[1],channelName:V[2],name:V[3],arg:ce});case w.PromiseCancel:return this.k?.logIncoming(j.byteLength,V[1],R.OtherSide,`${h(G)}`),this.u({type:G,id:V[1]});case w.EventDispose:return this.k?.logIncoming(j.byteLength,V[1],R.OtherSide,`${h(G)}`),this.u({type:G,id:V[1]})}}s(j){const U=this.b.get(j.channelName);if(!U){this.v(j);return}const V=new D.$xe;let ce;try{ce=U.call(this.j,j.name,j.arg,V.token)}catch(se){ce=Promise.reject(se)}const G=j.id;ce.then(se=>{this.m({id:G,data:se,type:p.PromiseSuccess})},se=>{se instanceof Error?this.m({id:G,data:{message:se.message,name:se.name,stack:se.stack?se.stack.split(`
`):void 0},type:p.PromiseError}):this.m({id:G,data:se,type:p.PromiseErrorObj})}).finally(()=>{he.dispose(),this.d.delete(j.id)});const he=(0,a.$Uc)(()=>V.cancel());this.d.set(j.id,he)}t(j){const U=this.b.get(j.channelName);if(!U){this.v(j);return}const V=j.id,G=U.listen(this.j,j.name,j.arg)(he=>this.m({id:V,data:he,type:p.EventFire}));this.d.set(j.id,G)}u(j){const U=this.d.get(j.id);U&&(U.dispose(),this.d.delete(j.id))}v(j){let U=this.g.get(j.channelName);U||(U=[],this.g.set(j.channelName,U));const V=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===w.Promise&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:p.PromiseError})},this.l);U.push({request:j,timeoutTimer:V})}w(j){const U=this.g.get(j);if(U){for(const V of U)switch(clearTimeout(V.timeoutTimer),V.request.type){case w.Promise:this.s(V.request);break;case w.EventListen:this.t(V.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Rc)(this.d.values()),this.d.clear()}}e.$hi=v;var R;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class T{constructor(j,U=null){this.l=j,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=U}getChannel(j){const U=this;return{call(V,ce,G){return U.a?Promise.reject(new I.$7):U.m(j,V,ce,G)},listen(V,ce){return U.a?b.Event.None:U.o(j,V,ce)}}}m(j,U,V,ce=D.CancellationToken.None){const G=this.g++,he=w.Promise,se={id:G,type:he,channelName:j,name:U,arg:V};if(ce.isCancellationRequested)return Promise.reject(new I.$7);let _;return new Promise((N,W)=>{if(ce.isCancellationRequested)return W(new I.$7);const H=()=>{const ie=de=>{switch(de.type){case p.PromiseSuccess:this.f.delete(G),N(de.data);break;case p.PromiseError:{this.f.delete(G);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,W(me);break}case p.PromiseErrorObj:this.f.delete(G),W(de.data);break}};this.f.set(G,ie),this.p(se)};let J=null;this.b===$.Idle?H():(J=(0,o.$sh)(ie=>this.u()),J.then(()=>{J=null,H()}));const X=()=>{J?(J.cancel(),J=null):this.p({id:G,type:w.PromiseCancel}),W(new I.$7)},Z=ce.onCancellationRequested(X);_=(0,a.$Tc)((0,a.$Uc)(X),Z),this.d.add(_)}).finally(()=>{_.dispose(),this.d.delete(_)})}o(j,U,V){const ce=this.g++,G=w.EventListen,he={id:ce,type:G,channelName:j,name:U,arg:V};let se=null;const _=new b.$me({onWillAddFirstListener:()=>{se=(0,o.$sh)(N=>this.u()),se.then(()=>{se=null,this.d.add(_),this.p(he)})},onDidRemoveLastListener:()=>{se?(se.cancel(),se=null):(this.d.delete(_),this.p({id:ce,type:w.EventDispose}))}}),M=N=>_.fire(N.data);return this.f.set(ce,M),_.event}p(j){switch(j.type){case w.Promise:case w.EventListen:{const U=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(U,j.id,R.LocalSide,`${h(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case w.PromiseCancel:case w.EventDispose:{const U=this.q([j.type,j.id]);this.j?.logOutgoing(U,j.id,R.LocalSide,h(j.type));return}}}q(j,U=void 0){const V=new r;return l(V,j),l(V,U),this.r(V.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const U=new t(j),V=S(U),ce=S(U),G=V[0];switch(G){case p.Initialize:return this.j?.logIncoming(j.byteLength,0,R.LocalSide,y(G)),this.t({type:V[0]});case p.PromiseSuccess:case p.PromiseError:case p.EventFire:case p.PromiseErrorObj:return this.j?.logIncoming(j.byteLength,V[1],R.LocalSide,y(G),ce),this.t({type:V[0],id:V[1],data:ce})}}t(j){if(j.type===p.Initialize){this.b=$.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Rc)(this.d.values()),this.d.clear()}}e.$ii=T,Pe([A.$0h],T.prototype,"onDidInitializePromise",null);class L{get connections(){const j=[];return this.f.forEach(U=>j.push(U)),j}constructor(j,U,V){this.a=new Map,this.f=new Set,this.g=new b.$me,this.onDidAddConnection=this.g.event,this.h=new b.$me,this.onDidRemoveConnection=this.h.event,this.j=new a.$Vc,this.j.add(j(({protocol:ce,onDidClientDisconnect:G})=>{const he=b.Event.once(ce.onMessage);this.j.add(he(se=>{const _=new t(se),M=S(_),N=new v(ce,M,U,V),W=new T(ce,U);this.a.forEach((J,X)=>N.registerChannel(X,J));const H={channelServer:N,channelClient:W,ctx:M};this.f.add(H),this.g.fire(H),this.j.add(G(()=>{N.dispose(),W.dispose(),this.f.delete(H),this.h.fire(H)}))}))}))}getChannel(j,U){const V=this;return{call(ce,G,he){let se;if((0,g.$tg)(U)){const M=(0,n.$5b)(V.connections.filter(U));se=M?Promise.resolve(M):b.Event.toPromise(b.Event.filter(V.onDidAddConnection,U))}else se=U.routeCall(V,ce,G);const _=se.then(M=>M.channelClient.getChannel(j));return F(_).call(ce,G,he)},listen(ce,G){if((0,g.$tg)(U))return V.k(j,U,ce,G);const he=U.routeEvent(V,ce,G).then(se=>se.channelClient.getChannel(j));return F(he).listen(ce,G)}}}k(j,U,V,ce){const G=this;let he;const se=new b.$me({onWillAddFirstListener:()=>{he=new a.$Vc;const _=new b.$se,M=new Map,N=H=>{const X=H.channelClient.getChannel(j).listen(V,ce),Z=_.add(X);M.set(H,Z)},W=H=>{const J=M.get(H);J&&(J.dispose(),M.delete(H))};G.connections.filter(U).forEach(N),b.Event.filter(G.onDidAddConnection,U)(N,void 0,he),G.onDidRemoveConnection(W,void 0,he),_.event(se.fire,se,he),he.add(_)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return se.event}registerChannel(j,U){this.a.set(j,U);for(const V of this.f)V.channelServer.registerChannel(j,U)}dispose(){this.j.dispose();for(const j of this.f)j.channelClient.dispose(),j.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=L;class O{constructor(j,U,V=null){const ce=new r;l(ce,U),j.send(ce.buffer),this.a=new T(j,V),this.d=new v(j,U,V)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,U){this.d.registerChannel(j,U)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=O;function F(q){return{call(j,U,V){return q.then(ce=>ce.call(j,U,V))},listen(j,U){const V=new b.$ve;return q.then(ce=>V.input=ce.listen(j,U)),V.event}}}function B(q){let j=!1;return{call(U,V,ce){return j?q.call(U,V,ce):(0,o.$Gh)(0).then(()=>j=!0).then(()=>q.call(U,V,ce))},listen(U,V){if(j)return q.listen(U,V);const ce=new b.$ve;return(0,o.$Gh)(0).then(()=>j=!0).then(()=>ce.input=q.listen(U,V)),ce.event}}}class C{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const U of j.connections)if(await Promise.resolve(this.a(U.ctx)))return Promise.resolve(U);return await b.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.$ni=C;var z;(function(q){function j(G,he,se){const _=G,M=se&&se.disableMarshalling,N=new Map;for(const W in _)V(W)&&N.set(W,b.Event.buffer(_[W],!0,void 0,he));return new class{listen(W,H,J){const X=N.get(H);if(X)return X;const Z=_[H];if(typeof Z=="function"){if(ce(H))return Z.call(_,J);if(V(H))return N.set(H,b.Event.buffer(_[H],!0,void 0,he)),N.get(H)}throw new I.$db(`Event not found: ${H}`)}call(W,H,J){const X=_[H];if(typeof X=="function"){if(!M&&Array.isArray(J))for(let ie=0;ie<J.length;ie++)J[ie]=(0,f.$ci)(J[ie]);let Z=X.apply(_,J);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new I.$db(`Method not found: ${H}`)}}}q.fromService=j;function U(G,he){const se=he&&he.disableMarshalling;return new Proxy({},{get(_,M){if(typeof M=="string")return he?.properties?.has(M)?he.properties.get(M):ce(M)?function(N){return G.listen(M,N)}:V(M)?G.listen(M):async function(...N){let W;he&&!(0,g.$og)(he.context)?W=[he.context,...N]:W=N;const H=await G.call(M,W);return se?H:(0,f.$ci)(H)};throw new I.$db(`Property not found: ${String(M)}`)}})}q.toService=U;function V(G){return G[0]==="o"&&G[1]==="n"&&d.$Ff(G.charCodeAt(2))}function ce(G){return/^onDynamic/.test(G)&&d.$Ff(G.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const j=q.toString();if(j!=="[object Object]")return j}return q}function le(q){return Array.isArray(q)?q.map(Q):Q(q)}function K(q,j,U,V,ce,G,he){he=le(he);const se=re[ce],_=se[V%se.length];let M=[`%c[${q}]%c[${String(j).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test(G)?(M=M.concat(he),M.push(")")):M.push(he),console.log.apply(console,M)}class ee{constructor(j,U){this.d=j,this.f=U,this.a=0,this.b=0}logOutgoing(j,U,V,ce,G){this.b+=j,K(this.d,this.b,j,U,V,ce,G)}logIncoming(j,U,V,ce,G){this.a+=j,K(this.f,this.a,j,U,V,ce,G)}}e.$oi=ee}),define(oe[162],ae([0,1,17,4,44]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JX=e.$IX=void 0;class D{constructor(b){this.a=b,this.onMessage=o.Event.fromDOMEventEmitter(this.a,"message",a=>a.data?n.$Oe.wrap(a.data):n.$Oe.alloc(0)),b.start()}send(b){this.a.postMessage(b.buffer)}disconnect(){this.a.close()}}e.$IX=D;class A extends P.$ki{constructor(b,a){const f=new D(b);super(f,a),this.b=f}dispose(){this.b.disconnect(),super.dispose()}}e.$JX=A}),define(oe[118],ae([0,1,17,4,2,44]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.ProtocolConstants=e.$pi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const u=new WeakMap;let l=0;function S(R,T){if(!u.has(R)){const L=String(++l);u.set(R,L)}return u.get(R)}function v(R,T,L,O){if(!s.enableDiagnostics)return;const F=S(R,T);if(O instanceof n.$Oe||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const B=n.$Oe.alloc(O.byteLength);B.set(O),s.records.push({timestamp:Date.now(),id:F,label:T,type:L,buff:B})}else s.records.push({timestamp:Date.now(),id:F,label:T,type:L,data:O})}s.traceSocketEvent=v})(I||(e.SocketDiagnostics=I={}));var b;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let a=null;function f(){return a||(a=n.$Oe.alloc(0)),a}class d{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(u){this.a.push(u),this.b+=u.byteLength}read(u){return this.c(u,!0)}peek(u){return this.c(u,!1)}c(u,l){if(u===0)return f();if(u>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===u){const T=this.a[0];return l&&(this.a.shift(),this.b-=u),T}if(this.a[0].byteLength>u){const T=this.a[0].slice(0,u);return l&&(this.a[0]=this.a[0].slice(u),this.b-=u),T}const S=n.$Oe.alloc(u);let v=0,R=0;for(;u>0;){const T=this.a[R];if(T.byteLength>u){const L=T.slice(0,u);S.set(L,v),v+=u,l&&(this.a[R]=T.slice(u),this.b-=u),u-=u}else S.set(T,v),v+=T.byteLength,l?(this.a.shift(),this.b-=T.byteLength):R++,u-=T.byteLength}return S}}e.$pi=d;var g;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(g||(g={}));function w(s){switch(s){case g.None:return"None";case g.Regular:return"Regular";case g.Control:return"Control";case g.Ack:return"Ack";case g.Disconnect:return"Disconnect";case g.ReplayRequest:return"ReplayRequest";case g.Pause:return"PauseWriting";case g.Resume:return"ResumeWriting";case g.KeepAlive:return"KeepAlive"}}var h;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(h||(e.ProtocolConstants=h={}));class p{constructor(u,l,S,v){this.type=u,this.id=l,this.ack=S,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends P.$Wc{constructor(u){super(),this.f=this.B(new o.$me),this.onMessage=this.f.event,this.g={readHead:!0,readLen:h.HeaderLength,messageType:g.None,id:0,ack:0},this.a=u,this.b=!1,this.c=new d,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(u){if(!(!u||u.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(u);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent(A.ProtocolHeaderRead,{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,v=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=h.HeaderLength,this.g.messageType=g.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(A.ProtocolMessageRead,l),this.f.fire(new p(S,v,R,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(u){this.k=null,this.a=!1,this.b=!1,this.c=u,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(u){if(this.a)return;u.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=n.$Oe.alloc(h.HeaderLength);l.writeUInt8(u.type,0),l.writeUInt32BE(u.id,1),l.writeUInt32BE(u.ack,5),l.writeUInt32BE(u.data.byteLength,9),this.c.traceSocketEvent(A.ProtocolHeaderWrite,{messageType:w(u.type),id:u.id,ack:u.ack,messageSize:u.data.byteLength}),this.c.traceSocketEvent(A.ProtocolMessageWrite,u.data),this.j(l,u.data)}g(u,l){const S=this.f===0;return this.d.push(u,l),this.f+=u.byteLength+l.byteLength,S}h(){const u=n.$Oe.concat(this.d,this.f);return this.d.length=0,this.f=0,u}j(u,l){this.g(u,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const u=this.h();this.c.traceSocketEvent(A.ProtocolWrite,{byteLength:u.byteLength}),this.c.write(u)}}class m extends P.$Wc{constructor(u){super(),this.f=new o.$me,this.onMessage=this.f.event,this.g=new o.$me,this.onDidDispose=this.g.event,this.a=u,this.b=this.B(new $(this.a)),this.c=this.B(new y(this.a)),this.B(this.c.onMessage(l=>{l.type===g.Regular&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(u){this.b.write(new p(g.Regular,0,0,u))}}e.$qi=m;class E extends D.$ki{static fromSocket(u,l){return new E(new m(u),l)}get onDidDispose(){return this.b.onDidDispose}constructor(u,l,S=null){super(u,l,S),this.b=u}dispose(){super.dispose();const u=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),u.end()}}e.$ri=E;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new o.$me({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(u){this.b?this.d.length>0?this.d.push(u):this.a.fire(u):this.d.push(u)}flushBuffer(){this.d=[]}}e.$si=k;class t{constructor(u){this.data=u,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let u=0,l=this.a;for(;l;)l=l.next,u++;return u}peek(){return this.a?this.a.data:null}toArray(){const u=[];let l=0,S=this.a;for(;S;)u[l++]=S.data,S=S.next;return u}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(u){const l=new t(u);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const u=Date.now();for(let l=0;l<i.a;l++)this.c[l]=u-1e3*l;setInterval(()=>{for(let l=i.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const u=Date.now(),l=(1+i.a)*1e3;let S=0;for(let v=0;v<i.a;v++)u-this.c[v]<=l&&S++;return 1-S/i.a}hasHighLoad(){return this.d()>=.5}}class c{get unacknowledgedCount(){return this.c-this.d}constructor(u){this.u=new k,this.onControlMessage=this.u.event,this.v=new k,this.onMessage=this.v.event,this.w=new k,this.onDidDispose=this.w.event,this.x=new k,this.onSocketClose=this.x.event,this.y=new k,this.onSocketTimeout=this.y.event,this.s=u.loadEstimator??i.getInstance(),this.t=u.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new P.$Vc,this.o=u.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),u.initialChunk&&this.q.acceptChunk(u.initialChunk),this.t?this.l=setInterval(()=>{this.D()},h.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const u=new p(g.Disconnect,0,0,f());this.p.write(u),this.p.flush()}sendPause(){const u=new p(g.Pause,0,0,f());this.p.write(u)}sendResume(){const u=new p(g.Resume,0,0,f());this.p.write(u)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(u,l){this.a=!0,this.r.dispose(),this.r=new P.$Vc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=u,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(S=>this.z(S))),this.r.add(this.o.onClose(S=>this.x.fire(S))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const u=new p(g.Ack,0,this.h,f());this.p.write(u);const l=this.b.toArray();for(let S=0,v=l.length;S<v;S++)this.p.write(l[S]);this.B()}acceptDisconnect(){this.w.fire()}z(u){if(u.ack>this.d){this.d=u.ack;do{const l=this.b.peek();if(l&&l.id<=u.ack)this.b.pop();else break}while(!0)}switch(u.type){case g.None:break;case g.Regular:{if(u.id>this.g)if(u.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new p(g.ReplayRequest,0,0,f())))}else this.g=u.id,this.j=Date.now(),this.A(),this.v.fire(u.data);break}case g.Control:{this.u.fire(u.data);break}case g.Ack:break;case g.Disconnect:{this.w.fire();break}case g.ReplayRequest:{const l=this.b.toArray();for(let S=0,v=l.length;S<v;S++)this.p.write(l[S]);this.B();break}case g.Pause:{this.p.pause();break}case g.Resume:{this.p.resume();break}case g.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(u){const l=++this.c;this.h=this.g;const S=new p(g.Regular,l,this.h,u);this.b.push(S),this.a||(this.p.write(S),this.B())}sendControl(u){const l=new p(g.Control,0,0,u);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const u=Date.now()-this.j;if(u>=h.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},h.AcknowledgeTime-u+5)}B(){if(this.c<=this.d||this.f||this.a)return;const u=this.b.peek(),l=Date.now()-u.writtenTime,S=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(l>=h.TimeoutTime&&S>=h.TimeoutTime&&v>=h.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:S});return}const R=Math.max(h.TimeoutTime-l,h.TimeoutTime-S,h.TimeoutTime-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},R)}C(){if(this.g<=this.h)return;this.h=this.g;const u=new p(g.Ack,0,this.h,f());this.p.write(u)}D(){this.h=this.g;const u=new p(g.KeepAlive,0,this.h,f());this.p.write(u)}}e.$ti=c}),define(oe[35],ae([0,1,14,16,12]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FX=void 0;class D{constructor(){this.a=new WeakMap}on(I,b){const a=(f,...d)=>{this.b(I,f)&&b(f,...d)};return this.a.set(b,a),n.ipcMain.on(I,a),this}once(I,b){return n.ipcMain.once(I,(a,...f)=>{this.b(I,a)&&b(a,...f)}),this}handle(I,b){return n.ipcMain.handle(I,(a,...f)=>this.b(I,a)?b(a,...f):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return n.ipcMain.removeHandler(I),this}removeListener(I,b){const a=this.a.get(b);return a&&(n.ipcMain.removeListener(I,a),this.a.delete(b)),this}b(I,b){if(!I||!I.startsWith("vscode:"))return(0,o.$3)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const a=b.senderFrame,f=a.url;if(!f||f==="about:blank")return!0;let d="unknown";try{d=new URL(f).host}catch{return(0,o.$3)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${f}'.`),!1}return d!==P.$Yg?((0,o.$3)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${d}'.`),!1):a.parent!==null?((0,o.$3)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${d}' is not a main frame.`),!1):!0}}e.$FX=new D}),define(oe[163],ae([0,1,14,35,151]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GX=D;function D(){o.$FX.on(P.$DX,(I,b,a,f,d)=>{const g=A(I,f,a);g.popup({x:d?d.x:void 0,y:d?d.y:void 0,positioningItem:d?d.positioningItem:void 0,callback:()=>{g&&I.sender.send(P.$EX,b)}})})}function A(I,b,a){const f=new n.Menu;return a.forEach(d=>{let g;d.type==="separator"?g=new n.MenuItem({type:d.type}):Array.isArray(d.submenu)?g=new n.MenuItem({submenu:A(I,b,d.submenu),label:d.label}):g=new n.MenuItem({label:d.label,type:d.type,accelerator:d.accelerator,checked:d.checked,enabled:d.enabled,visible:d.visible,click:(w,h,p)=>I.sender.send(b,d.id,p)}),f.append(g)}),f}}),define(oe[164],ae([0,1,35,17,4,2,44,152]),function(x,e,n,o,P,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MX=void 0;function b(f,d){const g=P.Event.fromNodeEventEmitter(n.$FX,d,(h,p)=>({event:h,message:p})),w=P.Event.filter(g,({event:h})=>h.sender.id===f);return P.Event.map(w,({message:h})=>h&&o.$Oe.wrap(h))}class a extends A.$ji{static{this.b=new Map}static d(){const d=P.Event.fromNodeEventEmitter(n.$FX,"vscode:hello",({sender:g})=>g);return P.Event.map(d,g=>{const w=g.id;a.b.get(w)?.dispose();const p=new P.$me;a.b.set(w,(0,D.$Uc)(()=>p.fire()));const y=b(w,"vscode:message"),$=P.Event.any(P.Event.signal(b(w,"vscode:disconnect")),p.event);return{protocol:new I.$LX(g,y),onDidClientDisconnect:$}})}constructor(){super(a.d())}}e.$MX=a}),define(oe[119],ae([0,1,35,4,33,162]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NX=void 0,e.$OX=I;class A extends D.$JX{constructor(a,f){super({addEventListener:(d,g)=>a.addListener(d,g),removeEventListener:(d,g)=>a.removeListener(d,g),postMessage:d=>a.postMessage(d),start:()=>a.start(),close:()=>a.close()},f)}}e.$NX=A;async function I(b){if(b.isDestroyed()||b.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,P.$2g)();b.webContents.send("vscode:createMessageChannel",a);const f=o.Event.fromNodeEventEmitter(n.$FX,"vscode:createMessageChannelResult",(g,w)=>({nonce:w,port:g.ports[0]})),{port:d}=await o.Event.toPromise(o.Event.once(o.Event.filter(f,g=>g.nonce===a)));return d}}),define(oe[165],ae([0,1,49,8,17,23,159,16,4,2,36,95,82,44]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0,I=De(I);class h extends w.$hi{constructor($){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",m=>P.$Oe.wrap(Buffer.from(m,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$er=h;class p{constructor($,m){this.i=$,this.j=m,this.c=new Set,this.g=new Map,this.h=new b.$me,this.onDidProcessExit=this.h.event;const E=m&&m.timeout?m.timeout:6e4;this.b=new o.$Ch(E),this.d=null,this.f=null}getChannel($){const m=this;return{call(E,k,t){return m.k($,E,k,t)},listen(E,k){return m.l($,E,k)}}}k($,m,E,k=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(k.isCancellationRequested)return Promise.reject(I.$8());this.b.cancel();const t=this.n($),r=(0,o.$sh)(s=>t.call(m,E,s)),i=k.onCancellationRequested(()=>r.cancel()),c=(0,a.$Uc)(()=>r.cancel());return this.c.add(c),r.finally(()=>{i.dispose(),this.c.delete(c),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),r}l($,m,E){if(!this.b)return b.Event.None;this.b.cancel();let k;const t=new b.$me({onWillAddFirstListener:()=>{k=this.n($).listen(m,E)(t.fire,t),this.c.add(k)},onDidRemoveLastListener:()=>{this.c.delete(k),k.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,f.$do)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,g.$lm)(m.env),this.d=(0,n.fork)(this.i,$,m);const E=new b.$me,t=b.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,A.$ar)(l)){(0,A.log)(l,`IPC Library: ${this.j.serverName}`);return}E.fire(P.$Oe.wrap(Buffer.from(l,"base64")))}),r=this.j.useQueue?(0,d.$ym)(this.d):this.d,i=l=>this.d&&this.d.connected&&r.send(l.buffer.toString("base64")),c=E.event,s={send:i,onMessage:c};this.f=new w.$ii(s);const u=()=>this.o();process.once("exit",u),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,S)=>{process.removeListener("exit",u),t.dispose(),this.c.forEach(v=>(0,a.$Rc)(v)),this.c.clear(),l!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+S),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:S})})}return this.f}n($){let m=this.g.get($);return m||(m=this.m.getChannel($),this.g.set($,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$fr=p}),define(oe[120],ae([0,1,8,4,2,83,13]),function(x,e,n,o,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.StorageState=e.StorageHint=void 0,e.$aq=b;var I;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function b(g){const w=g;return w?.changed instanceof Map||w?.deleted instanceof Set}var a;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(a||(e.StorageState=a={}));class f extends P.$Wc{static{this.a=100}constructor(w,h=Object.create(null)){super(),this.r=w,this.s=h,this.b=this.B(new o.$pe),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new n.$Dh(f.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((h,p)=>this.w(p,h)),w.deleted?.forEach(h=>this.w(h,void 0))}finally{this.b.resume()}}w(w,h){if(this.c===a.Closed)return;let p=!1;(0,A.$og)(h)?p=this.f.delete(w):this.f.get(w)!==h&&(this.f.set(w,h),p=!0),p&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,h){const p=this.f.get(w);return(0,A.$og)(p)?h:p}getBoolean(w,h){const p=this.get(w);return(0,A.$og)(p)?h:p==="true"}getNumber(w,h){const p=this.get(w);return(0,A.$og)(p)?h:parseInt(p,10)}getObject(w,h){const p=this.get(w);return(0,A.$og)(p)?h:(0,D.$bi)(p)}async set(w,h,p=!1){if(this.c===a.Closed)return;if((0,A.$og)(h))return this.delete(w,p);const y=(0,A.$hg)(h)||Array.isArray(h)?(0,D.$ai)(h):String(h);if(this.f.get(w)!==y)return this.f.set(w,y),this.j.set(w,y),this.h.delete(w),this.b.fire({key:w,external:p}),this.D()}async delete(w,h=!1){if(!(this.c===a.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:h}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===a.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$bq=f;class d{constructor(){this.onDidChangeItemsExternal=o.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((h,p)=>this.a.set(p,h)),w.delete?.forEach(h=>this.a.delete(h))}async optimize(){}async close(){}}e.$cq=d}),define(oe[166],ae([0,1,8,4,32,10,21]),function(x,e,n,o,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$X=void 0;class I{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return o.Event.None}static{this.a=2e3}static{this.b=256}constructor(f,d=Object.create(null)){this.g=f,this.h=d,this.c=(0,D.$pc)(this.g),this.d=new b(this.h.logging),this.f=this.n(this.g)}async getItems(){const f=await this.f,d=new Map;return(await this.s(f,"SELECT * FROM ItemTable")).forEach(w=>d.set(w.key,w.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${d.size} rows`),d}async updateItems(f){const d=await this.f;return this.j(d,f)}j(f,d){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${d.insert?(0,P.$Ac)(d.insert):"0"}), delete(${d.delete?(0,P.$Bc)(d.delete):"0"})`),this.t(f,()=>{const g=d.insert,w=d.delete;if(g&&g.size>0){const h=[];h.push([]);let p=0;g.forEach((y,$)=>{let m=h[p];m.length>I.b&&(p++,m=[],h.push(m)),m.push($,y)}),h.forEach(y=>{this.u(f,`INSERT INTO ItemTable VALUES ${new Array(y.length/2).fill("(?,?)").join(",")}`,$=>$.run(y),()=>{const $=[];let m=0;return g.forEach((E,k)=>{$.push(k),m+=E.length}),`Keys: ${$.join(", ")} Length: ${m}`})})}if(w&&w.size){const h=[];h.push([]);let p=0;w.forEach(y=>{let $=h[p];$.length>I.b&&(p++,$=[],h.push($)),$.push(y)}),h.forEach(y=>{this.u(f,`DELETE FROM ItemTable WHERE key IN (${new Array(y.length).fill("?").join(",")})`,$=>$.run(y),()=>{const $=[];return w.forEach(m=>{$.push(m)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const f=await this.f;return this.q(f,"VACUUM")}async close(f){this.d.trace(`[storage ${this.c}] close()`);const d=await this.f;return this.k(d,f)}k(f,d){return new Promise((g,w)=>{f.db.close(h=>(h&&this.o(f,`[storage ${this.c}] close(): ${h}`),this.g===I.IN_MEMORY_PATH?g():!f.isErroneous&&!f.isInMemory?this.l().then(g,p=>(this.d.error(`[storage ${this.c}] backup(): ${p}`),g())):typeof d=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(p=>{const y=()=>this.k(p,void 0);return this.j(p,{insert:d()}).then(()=>y(),$=>(y(),Promise.reject($)))})).then(g,w):w(h||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const f=this.m(this.g);return A.Promises.copy(this.g,f,{preserveSymlinks:!1})}m(f){return`${f}.backup`}async checkIntegrity(f){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${f})`);const d=await this.f,g=await this.r(d,f?"PRAGMA integrity_check":"PRAGMA quick_check"),w=f?g.integrity_check:g.quick_check;return d.isErroneous?`${w} (last error: ${d.lastError})`:d.isInMemory?`${w} (in-memory!)`:w}async n(f,d=!0){this.d.trace(`[storage ${this.c}] open(${f}, retryOnBusy: ${d})`);try{return await this.p(f)}catch(g){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${g}`),g.code==="SQLITE_BUSY"&&d)return await(0,n.$Gh)(I.a),this.n(f,!1);try{await A.Promises.unlink(f);try{await A.Promises.rename(this.m(f),f,!1)}catch{}return await this.p(f)}catch(w){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${w}`),this.p(I.IN_MEMORY_PATH)}}}o(f,d){f.isErroneous=!0,f.lastError=d,this.d.error(d)}p(f){return new Promise((d,g)=>{new Promise((w,h)=>{x(["@vscode/sqlite3"],w,h)}).then(De).then(w=>{const h={db:new(this.d.isTracing?w.verbose().Database:w.Database)(f,p=>p?h.db&&p.code!=="SQLITE_CANTOPEN"?h.db.close(()=>g(p)):g(p):this.q(h,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>d(h),y=>h.db.close(()=>g(y)))),isInMemory:f===I.IN_MEMORY_PATH};h.db.on("error",p=>this.o(h,`[storage ${this.c}] Error (event): ${p}`)),this.d.isTracing&&h.db.on("trace",p=>this.d.trace(`[storage ${this.c}] Trace (event): ${p}`))},g)})}q(f,d){return new Promise((g,w)=>{f.db.exec(d,h=>h?(this.o(f,`[storage ${this.c}] exec(): ${h}`),w(h)):g())})}r(f,d){return new Promise((g,w)=>{f.db.get(d,(h,p)=>h?(this.o(f,`[storage ${this.c}] get(): ${h}`),w(h)):g(p))})}s(f,d){return new Promise((g,w)=>{f.db.all(d,(h,p)=>h?(this.o(f,`[storage ${this.c}] all(): ${h}`),w(h)):g(p))})}t(f,d){return new Promise((g,w)=>{f.db.serialize(()=>{f.db.run("BEGIN TRANSACTION"),d(),f.db.run("END TRANSACTION",h=>h?(this.o(f,`[storage ${this.c}] transaction(): ${h}`),w(h)):g())})})}u(f,d,g,w){const h=f.db.prepare(d),p=y=>{this.o(f,`[storage ${this.c}] prepare(): ${y} (${d}). Details: ${w()}`)};h.on("error",p),g(h),h.finalize(y=>{y&&p(y),h.removeListener("error",p)})}}e.$$X=I;class b{static{this.a="VSCODE_TRACE_STORAGE"}constructor(f){f&&typeof f.logTrace=="function"&&process.env[b.a]&&(this.b=f.logTrace),f&&typeof f.logError=="function"&&(this.c=f.logError)}get isTracing(){return!!this.b}trace(f){this.b?.(f)}error(f){this.c?.(f)}}}),define(oe[167],ae([11,9]),function(x,e){return x.create("vs/code/electron-main/app",e)}),define(oe[168],ae([11,9]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[169],ae([11,9]),function(x,e){return x.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[170],ae([11,9]),function(x,e){return x.create("vs/platform/contextkey/common/scanner",e)}),define(oe[171],ae([11,9]),function(x,e){return x.create("vs/platform/dialogs/common/dialogs",e)}),define(oe[172],ae([11,9]),function(x,e){return x.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(oe[173],ae([11,9]),function(x,e){return x.create("vs/platform/environment/node/argv",e)}),define(oe[174],ae([11,9]),function(x,e){return x.create("vs/platform/environment/node/argvHelper",e)}),define(oe[175],ae([11,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[176],ae([11,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[177],ae([11,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[178],ae([11,9]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[179],ae([11,9]),function(x,e){return x.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(oe[180],ae([11,9]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(oe[181],ae([11,9]),function(x,e){return x.create("vs/platform/files/common/files",e)}),define(oe[182],ae([11,9]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(oe[183],ae([11,9]),function(x,e){return x.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(oe[184],ae([11,9]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[185],ae([11,9]),function(x,e){return x.create("vs/platform/issue/electron-main/issueMainService",e)}),define(oe[186],ae([11,9]),function(x,e){return x.create("vs/platform/issue/electron-main/processMainService",e)}),define(oe[187],ae([11,9]),function(x,e){return x.create("vs/platform/log/common/log",e)}),define(oe[188],ae([11,9]),function(x,e){return x.create("vs/platform/menubar/electron-main/menubar",e)}),define(oe[189],ae([11,9]),function(x,e){return x.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(oe[190],ae([11,9]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(oe[191],ae([11,9]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(oe[192],ae([11,9]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[193],ae([11,9]),function(x,e){return x.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[194],ae([11,9]),function(x,e){return x.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[195],ae([11,9]),function(x,e){return x.create("vs/platform/update/common/update.config.contribution",e)}),define(oe[196],ae([11,9]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[197],ae([11,9]),function(x,e){return x.create("vs/platform/windows/electron-main/windowImpl",e)}),define(oe[198],ae([11,9]),function(x,e){return x.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(oe[199],ae([11,9]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(oe[200],ae([11,9]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(oe[201],ae([11,9]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(oe[202],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhb=n,e.$Whb=o;function n(P){return P&&P.hasOwnProperty("folderUri")}function o(P){return P&&P.hasOwnProperty("workspace")}}),define(oe[203],ae([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=o,e.$Mec=P,e.$Nec=D;function o(A){return typeof A?.backupFolder=="string"}function P(A){let I=[];try{Array.isArray(A.workspaces)&&(I=A.workspaces.map(b=>({workspace:{id:b.id,configPath:n.URI.parse(b.configURIPath)},remoteAuthority:b.remoteAuthority})))}catch{}return I}function D(A){let I=[];try{Array.isArray(A.folders)&&(I=A.folders.map(b=>({folderUri:n.URI.parse(b.folderUri),remoteAuthority:b.remoteAuthority})))}catch{}return I}}),define(oe[204],ae([0,1,39,16,170]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var D;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(D||(e.TokenType=D={}));function A(...f){switch(f.length){case 1:return(0,P.localize)(0,null,f[0]);case 2:return(0,P.localize)(1,null,f[0],f[1]);case 3:return(0,P.localize)(2,null,f[0],f[1],f[2]);default:return}}const I=(0,P.localize)(3,null),b=(0,P.localize)(4,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(d){switch(d.type){case D.LParen:return"(";case D.RParen:return")";case D.Neg:return"!";case D.Eq:return d.isTripleEq?"===":"==";case D.NotEq:return d.isTripleEq?"!==":"!=";case D.Lt:return"<";case D.LtEq:return"<=";case D.Gt:return">=";case D.GtEq:return">=";case D.RegexOp:return"=~";case D.RegexStr:return d.lexeme;case D.True:return"true";case D.False:return"false";case D.In:return"in";case D.Not:return"not";case D.And:return"&&";case D.Or:return"||";case D.Str:return d.lexeme;case D.QuotedStr:return d.lexeme;case D.Error:return d.lexeme;case D.EOF:return"EOF";default:throw(0,o.$0)(`unhandled token type: ${JSON.stringify(d)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0)))}static{this.b=new Map([["not",D.Not],["in",D.In],["false",D.False],["true",D.True]])}get errors(){return this.g}reset(d){return this.c=d,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case n.CharCode.OpenParen:this.k(D.LParen);break;case n.CharCode.CloseParen:this.k(D.RParen);break;case n.CharCode.ExclamationMark:if(this.h(n.CharCode.Equals)){const g=this.h(n.CharCode.Equals);this.f.push({type:D.NotEq,offset:this.d,isTripleEq:g})}else this.k(D.Neg);break;case n.CharCode.SingleQuote:this.o();break;case n.CharCode.Slash:this.q();break;case n.CharCode.Equals:if(this.h(n.CharCode.Equals)){const g=this.h(n.CharCode.Equals);this.f.push({type:D.Eq,offset:this.d,isTripleEq:g})}else this.h(n.CharCode.Tilde)?this.k(D.RegexOp):this.l(A("==","=~"));break;case n.CharCode.LessThan:this.k(this.h(n.CharCode.Equals)?D.LtEq:D.Lt);break;case n.CharCode.GreaterThan:this.k(this.h(n.CharCode.Equals)?D.GtEq:D.Gt);break;case n.CharCode.Ampersand:this.h(n.CharCode.Ampersand)?this.k(D.And):this.l(A("&&"));break;case n.CharCode.Pipe:this.h(n.CharCode.Pipe)?this.k(D.Or):this.l(A("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(D.EOF),Array.from(this.f)}h(d){return this.r()||this.c.charCodeAt(this.e)!==d?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?n.CharCode.Null:this.c.charCodeAt(this.e)}k(d){this.f.push({type:d,offset:this.d})}l(d){const g=this.d,w=this.c.substring(this.d,this.e),h={type:D.Error,offset:this.d,lexeme:w};this.g.push({offset:g,lexeme:w,additionalInfo:d}),this.f.push(h)}n(){this.m.lastIndex=this.d;const d=this.m.exec(this.c);if(d){this.e=this.d+d[0].length;const g=this.c.substring(this.d,this.e),w=a.b.get(g);w?this.k(w):this.f.push({type:D.Str,lexeme:g,offset:this.d})}}o(){for(;this.j()!==n.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:D.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let d=this.e,g=!1,w=!1;for(;;){if(d>=this.c.length){this.e=d,this.l(b);return}const p=this.c.charCodeAt(d);if(g)g=!1;else if(p===n.CharCode.Slash&&!w){d++;break}else p===n.CharCode.OpenSquareBracket?w=!0:p===n.CharCode.Backslash?g=!0:p===n.CharCode.CloseSquareBracket&&(w=!1);d++}for(;d<this.c.length&&a.a.has(this.c.charCodeAt(d));)d++;this.e=d;const h=this.c.substring(this.d,this.e);this.f.push({type:D.RegexStr,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=a}),define(oe[205],ae([0,1,4,2]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=void 0;class P{constructor(){this.a=new n.$me,this.b=new n.$me,this.c=new n.$me,this.d=new n.$me}static{this.ChannelName="extensionhostdebugservice"}call(I,b,a){switch(b){case"close":return Promise.resolve(this.a.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(I,b,a){switch(b){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Wo=P;class D extends o.$Wc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,b,a){this.b.call("attach",[I,b,a])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,b){this.b.call("terminate",[I,b])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,b){return this.b.call("openExtensionDevelopmentHostWindow",[I,b])}}e.$Xo=D}),define(oe[206],ae([0,1,154,54,12,10,37,19,7]),function(x,e,n,o,P,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$6m=f,e.$7m=d,e.$4m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,D.$oc)(P.$Zg.asFileUri("").fsPath)}get userHome(){return b.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return b.URI.file((0,D.$lc)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.b.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,I.$gh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:P.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$gh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,n.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$lc)(this.userDataPath,"logs",w)}return b.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$gh)(b.URI.file((0,D.$lc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$gh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$gh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$gh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=A.env.VSCODE_PORTABLE;return w?b.URI.file((0,D.$lc)(w,"argv.json")):(0,I.$gh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,D.$lc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,D.$mc)(w):(0,D.$jc)((0,D.$lc)(P.$Zg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?b.URI.file((0,D.$mc)(w)):b.URI.file((0,D.$lc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,D.$mc)(w);const h=A.env.VSCODE_EXTENSIONS;if(h)return h;const p=A.env.VSCODE_PORTABLE;return p?(0,D.$lc)(p,"extensions"):(0,I.$gh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(h=>/^[^:/?#]+?:\/\//.test(h)?b.URI.parse(h):b.URI.file((0,D.$jc)(h)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?b.URI.parse(w):b.URI.file((0,D.$jc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return f(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$4m.test(w))}get extensionLogLevel(){const w=[];for(const h of this.args.log||[]){const p=e.$4m.exec(h);p&&p[1]&&p[2]&&w.push([p[1],p[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,I.$gh)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=A.env.VSCODE_PORTABLE;return w?b.URI.file((0,D.$lc)(w,"policy.json")):(0,I.$gh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,h,p){this.a=w,this.b=h,this.c=p,this.editSessionId=this.args.editSessionId}}e.$5m=a,Pe([o.$0h],a.prototype,"appRoot",null),Pe([o.$0h],a.prototype,"userHome",null),Pe([o.$0h],a.prototype,"userDataPath",null),Pe([o.$0h],a.prototype,"appSettingsHome",null),Pe([o.$0h],a.prototype,"tmpDir",null),Pe([o.$0h],a.prototype,"cacheHome",null),Pe([o.$0h],a.prototype,"stateResource",null),Pe([o.$0h],a.prototype,"userRoamingDataHome",null),Pe([o.$0h],a.prototype,"userDataSyncHome",null),Pe([o.$0h],a.prototype,"sync",null),Pe([o.$0h],a.prototype,"machineSettingsResource",null),Pe([o.$0h],a.prototype,"workspaceStorageHome",null),Pe([o.$0h],a.prototype,"localHistoryHome",null),Pe([o.$0h],a.prototype,"keyboardLayoutResource",null),Pe([o.$0h],a.prototype,"argvResource",null),Pe([o.$0h],a.prototype,"isExtensionDevelopment",null),Pe([o.$0h],a.prototype,"untitledWorkspacesHome",null),Pe([o.$0h],a.prototype,"builtinExtensionsPath",null),Pe([o.$0h],a.prototype,"extensionsPath",null),Pe([o.$0h],a.prototype,"extensionDevelopmentLocationURI",null),Pe([o.$0h],a.prototype,"extensionDevelopmentKind",null),Pe([o.$0h],a.prototype,"extensionTestsLocationURI",null),Pe([o.$0h],a.prototype,"debugExtensionHost",null),Pe([o.$0h],a.prototype,"logLevel",null),Pe([o.$0h],a.prototype,"extensionLogLevel",null),Pe([o.$0h],a.prototype,"serviceMachineIdResource",null),Pe([o.$0h],a.prototype,"disableTelemetry",null),Pe([o.$0h],a.prototype,"disableWorkspaceTrust",null),Pe([o.$0h],a.prototype,"useInMemorySecretStorage",null),Pe([o.$0h],a.prototype,"policyFile",null);function f(g,w){return d(g["inspect-extensions"],g["inspect-brk-extensions"],5870,w,g.debugId,g.extensionEnvironment)}function d(g,w,h,p,y,$){const E=Number(w||g)||(p?null:h),k=E?!!w:!1;let t;if($)try{t=JSON.parse($)}catch{}return{port:E,break:k,debugId:y,env:t}}});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[121],ae([0,1,319,3,173]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=void 0,e.$Cm=I,e.$Dm=a,e.$Em=w,e.$Fm=h,n=et(n);const D={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.$Am=["tunnel","serve-web"],e.$Bm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,P.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,P.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,P.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,P.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(p,y,$=A){const m=p.find(l=>l.length>0&&l[0]!=="-"),E={},k=["_"],t=[],r={};let i;for(const l in y){const S=y[l];S.type==="subcommand"?l===m&&(i=S):(S.alias&&(E[l]=S.alias),S.type==="string"||S.type==="string[]"?(k.push(l),S.deprecates&&k.push(...S.deprecates)):S.type==="boolean"&&(t.push(l),S.deprecates&&t.push(...S.deprecates)),S.global&&(r[l]=S))}if(i&&m){const l=r;for(const T in i.options)l[T]=i.options[T];const S=p.filter(T=>T!==m),v=$.getSubcommandReporter?$.getSubcommandReporter(m):void 0,R=I(S,l,v);return{[m]:R,_:[]}}const c=(0,n.default)(p,{string:k,boolean:t,alias:E}),s={},u=c;s._=c._.map(l=>String(l)).filter(l=>l.length>0),delete u._;for(const l in y){const S=y[l];if(S.type==="subcommand")continue;S.alias&&delete u[S.alias];let v=u[l];if(S.deprecates)for(const R of S.deprecates)u.hasOwnProperty(R)&&(v||(v=u[R],v&&$.onDeprecatedOption(R,S.deprecationMessage||(0,P.localize)(39,null,l))),delete u[R]);if(typeof v<"u"){if(S.type==="string[]"){if(Array.isArray(v)||(v=[v]),!S.allowEmptyValue){const R=v.filter(T=>T.length>0);R.length!==v.length&&($.onEmptyValue(l),v=R.length>0?R:void 0)}}else S.type==="string"&&(Array.isArray(v)?(v=v.pop(),$.onMultipleValues(l,v)):!v&&!S.allowEmptyValue&&($.onEmptyValue(l),v=void 0));s[l]=v,S.deprecationMessage&&$.onDeprecatedOption(l,S.deprecationMessage)}delete u[l]}for(const l in u)$.onUnknownOption(l);return s}function b(p,y){let $="";return y.args&&(Array.isArray(y.args)?$=` <${y.args.join("> <")}>`:$=` <${y.args}>`),y.alias?`-${y.alias} --${p}${$}`:`--${p}${$}`}function a(p,y){const $=[];for(const m in p){const E=p[m],k=b(m,E);$.push([k,E.description])}return f($,y)}function f(p,y){const m=p.reduce((t,r)=>Math.max(t,r[0].length),12)+2+1;if(y-m<25)return p.reduce((t,r)=>t.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);const E=y-m-1,k=[];for(const t of p){const r=t[0],i=g(t[1],E),c=d(m-r.length-2);k.push("  "+r+c+i[0]);for(let s=1;s<i.length;s++)k.push(d(m)+i[s])}return k}function d(p){return" ".repeat(p)}function g(p,y){const $=[];for(;p.length;){const m=p.length<y?p.length:p.lastIndexOf(" ",y),E=p.slice(0,m).trim();p=p.slice(m),$.push(E)}return $}function w(p,y,$,m,E){const k=process.stdout.isTTY&&process.stdout.columns||80,t=E?.noInputFiles!==!0?`[${(0,P.localize)(40,null)}...]`:"",r=[`${p} ${$}`];r.push(""),r.push(`${(0,P.localize)(41,null)}: ${y} [${(0,P.localize)(42,null)}]${t}`),r.push(""),E?.noPipe!==!0&&(o.$i?r.push((0,P.localize)(43,null,y)):r.push((0,P.localize)(44,null,y)),r.push(""));const i={},c=[];for(const s in m){const u=m[s];if(u.type==="subcommand")u.description&&c.push({command:s,description:u.description});else if(u.description&&u.cat){let l=i[u.cat];l||(i[u.cat]=l={}),l[s]=u}}for(const s in i){const u=s,l=i[u];l&&(r.push(D[u]),r.push(...a(l,k)),r.push(""))}return c.length&&(r.push((0,P.localize)(45,null)),r.push(...f(c.map(s=>[s.command,s.description]),k)),r.push("")),r.join(`
`)}function h(p,y){return`${p||(0,P.localize)(46,null)}
${y||(0,P.localize)(47,null)}
${process.arch}`}});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[69],ae([0,1,320,174,121]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=I,e.$Hm=b,e.$Im=a,e.$Jm=f,n=et(n);function D(d,g){const w=(E,k)=>{console.warn((0,o.localize)(0,null,E,k))},h=E=>{console.warn((0,o.localize)(1,null,E))},p=(E,k)=>{console.warn((0,o.localize)(2,null,E,k))},y=E=>({onUnknownOption:k=>{P.$Am.includes(E)||console.warn((0,o.localize)(3,null,k,E))},onMultipleValues:w,onEmptyValue:h,onDeprecatedOption:p,getSubcommandReporter:P.$Am.includes(E)?y:void 0}),$={onUnknownOption:E=>{console.warn((0,o.localize)(4,null,E))},onMultipleValues:w,onEmptyValue:h,onDeprecatedOption:p,getSubcommandReporter:y},m=(0,P.$Cm)(d,P.$Bm,g?$:void 0);return m.goto&&m._.forEach(E=>(0,n.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(E),(0,o.localize)(5,null))),m}function A(d){const g=d.findIndex(w=>!/^-/.test(w));if(g>-1)return[...d.slice(0,g),...d.slice(g+1)]}function I(d){let[,...g]=d;process.env.VSCODE_DEV&&(g=A(g)||[]);const w=!f(process.env);return D(g,w)}function b(d){let[,,...g]=d;return process.env.VSCODE_DEV&&(g=A(g)||[]),D(g,!0)}function a(d,...g){const w=d.indexOf("--");return w===-1?d.push(...g):d.splice(w,0,...g),d}function f(d){return d.VSCODE_CLI==="1"}}),function(){"use strict";function x(e,n,o){function P(A,I){const b=D(A,I),a=[b];return e.isAbsolute(b)||a.unshift(o),e.resolve(...a)}function D(A,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,I);const f=A["user-data-dir"];if(f)return f;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const d=process.env.USERPROFILE;if(typeof d!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(d,"AppData","Roaming")}break;case"darwin":a=e.join(n.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,I)}return{getUserDataPath:P}}if(typeof define=="function")define(oe[207],ae([122,27,37]),function(e,n,o){return x(e,n,o.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=x(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[96],ae([0,1,27,206,207]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$9m=A,e.$0m=I;class D extends o.$5m{constructor(a,f){super(a,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,P.getUserDataPath)(a,f.nameShort)},f)}}e.$8m=D;function A(b,a){return(0,o.$7m)(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,a,b.extensionEnvironment)}function I(b,a){return(0,o.$7m)(b["inspect-sharedprocess"],b["inspect-brk-sharedprocess"],5879,a,b.extensionEnvironment)}}),define(oe[208],ae([0,1,47,27,31]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=D;function D(A){const I=(0,P.$Ng)((0,o.tmpdir)());try{return(0,n.writeFileSync)(I,""),A&&console.log(`Marker file for --wait created: ${I}`),I}catch(b){A&&console.error(`Failed to create marker file for --wait: ${b}`);return}}}),define(oe[209],ae([0,1,13,176]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=P;function P(A,I,b,a){try{D(A,I,b,a)}catch(f){A.error(f?.message??f)}return I}function D(A,I,b,a){const f=(d,g,w)=>{const h=d[g];if((0,n.$fg)(h)){const p=h,y=p.length;if(y>1&&p[0]==="%"&&p[y-1]==="%"){const $=p.substr(1,y-2);let m=b[$];m===void 0&&a&&(m=a[$]);const E=typeof m=="string"?m:m?.message,k=a?.[$],t=typeof k=="string"?k:k?.message;if(!E){t||A.warn(`[${I.name}]: ${(0,o.localize)(0,null,$)}`);return}if(w&&(g==="title"||g==="category")&&t&&t!==E){const r={value:E,original:t};d[g]=r}else d[g]=E}}else if((0,n.$hg)(h))for(const p in h)h.hasOwnProperty(p)&&(p==="commands"?f(h,p,!0):f(h,p,w));else if(Array.isArray(h))for(let p=0;p<h.length;p++)f(h,p,w)};for(const d in I)I.hasOwnProperty(d)&&f(I,d)}}),define(oe[210],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const n={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(n)}),define(oe[84],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class n{constructor(P,D=[],A=!1){this.ctor=P,this.staticArguments=D,this.supportsDelayedInstantiation=A}}e.$Ci=n}),define(oe[211],ae([0,1,84]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Os=D,e.$Ps=A;const o=[];var P;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function D(I,b,a){b instanceof n.$Ci||(b=new n.$Ci(b,[],!!a)),o.push([I,b])}function A(){return o}}),define(oe[212],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0;class n{constructor(D,A){this.key=D,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$rr=n;class o{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const A of this.a.values())A.outgoing.size===0&&D.push(A);return D}insertEdge(D,A){const I=this.lookupOrInsertNode(D),b=this.lookupOrInsertNode(A);I.outgoing.set(b.key,b),b.incoming.set(I.key,I)}removeNode(D){const A=this.b(D);this.a.delete(A);for(const I of this.a.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(D){const A=this.b(D);let I=this.a.get(A);return I||(I=new n(A,D),this.a.set(A,I)),I}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[A,I]of this.a)D.push(`${A}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,A]of this.a){const I=new Set([D]),b=this.c(A,I);if(b)return b}}c(D,A){for(const[I,b]of D.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const a=this.c(b,A);if(a)return a;A.delete(I)}}}e.$sr=o}),define(oe[6],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=P,e.$Gi=D;var n;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function I(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=I})(n||(e._util=n={})),e.$Ei=P("instantiationService");function o(A,I,b){I[n.DI_TARGET]===I?I[n.DI_DEPENDENCIES].push({id:A,index:b}):(I[n.DI_DEPENDENCIES]=[{id:A,index:b}],I[n.DI_TARGET]=I)}function P(A){if(n.serviceIds.has(A))return n.serviceIds.get(A);const I=function(b,a,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");o(I,b,f)};return I.toString=()=>A,n.serviceIds.set(A,I),I}function D(A){return A}}),define(oe[85],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0,e.$Ffc=(0,n.$Fi)("auxiliaryWindowsMainService")}),define(oe[70],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0,e.$Oec=(0,n.$Fi)("backupMainService")}),define(oe[18],ae([0,1,13,7,6]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=D,e.$bj=A,e.$cj=b,e.$dj=a,e.$ej=f,e.$fj=d,e.$gj=g,e.$hj=h,e.$ij=p,e.$jj=y,n=De(n),e.$_i=(0,P.$Fi)("configurationService");function D($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof o.URI)}function A($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof o.URI)}var I;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function b($){switch($){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function a($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function f($,m){const E=Object.create(null);for(const k in $)d(E,k,$[k],m);return E}function d($,m,E,k){const t=m.split("."),r=t.pop();let i=$;for(let c=0;c<t.length;c++){const s=t[c];let u=i[s];switch(typeof u){case"undefined":u=i[s]=Object.create(null);break;case"object":if(u===null){k(`Ignoring ${m} as ${t.slice(0,c+1).join(".")} is null`);return}break;default:k(`Ignoring ${m} as ${t.slice(0,c+1).join(".")} is ${JSON.stringify(u)}`);return}i=u}if(typeof i=="object"&&i!==null)try{i[r]=E}catch{k(`Ignoring ${m} as ${t.join(".")} is ${JSON.stringify(i)}`)}else k(`Ignoring ${m} as ${t.join(".")} is ${JSON.stringify(i)}`)}function g($,m){const E=m.split(".");w($,E)}function w($,m){const E=m.shift();if(m.length===0){delete $[E];return}if(Object.keys($).indexOf(E)!==-1){const k=$[E];typeof k=="object"&&!Array.isArray(k)&&(w(k,m),Object.keys(k).length===0&&delete $[E])}}function h($,m,E){function k(i,c){let s=i;for(const u of c){if(typeof s!="object"||s===null)return;s=s[u]}return s}const t=m.split("."),r=k($,t);return typeof r>"u"?E:r}function p($,m,E){Object.keys(m).forEach(k=>{k!=="__proto__"&&(k in $?n.$hg($[k])&&n.$hg(m[k])?p($[k],m[k],E):E&&($[k]=m[k]):$[k]=m[k])})}function y($){return $.replace(/[\[\]]/g,"")}}),define(oe[123],ae([0,1,39,3,26,204,6,169,16]),function(x,e,n,o,P,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=f,e.$Ej=c,e.$Fj=s,e.$Yj=G;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",o.$j),a.set("isLinux",o.$k),a.set("isWindows",o.$i),a.set("isWeb",o.$o),a.set("isMacNative",o.$j&&!o.$o),a.set("isEdge",o.$H),a.set("isFirefox",o.$F),a.set("isChrome",o.$E),a.set("isSafari",o.$G);function f(_,M){if(a.get(_)!==void 0)throw(0,b.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(_,M)}const d=Object.prototype.hasOwnProperty;var g;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(g||(e.ContextKeyExprType=g={}));const w={regexParsingWithErrorRecovery:!0},h=(0,I.localize)(0,null),p=(0,I.localize)(1,null),y=(0,I.localize)(2,null),$=(0,I.localize)(3,null),m=(0,I.localize)(4,null),E=(0,I.localize)(5,null),k=(0,I.localize)(6,null),t=(0,I.localize)(7,null);class r{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(M=w){this.k=M,this.d=new D.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(M){if(M===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(M).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const W=this.D(),H=W.type===D.TokenType.Str?E:void 0;throw this.h.push({message:m,offset:W.offset,lexeme:D.$Aj.getLexeme(W),additionalInfo:H}),r.c}return N}catch(N){if(N!==r.c)throw N;return}}l(){return this.m()}m(){const M=[this.o()];for(;this.y(D.TokenType.Or);){const N=this.o();M.push(N)}return M.length===1?M[0]:i.or(...M)}o(){const M=[this.s()];for(;this.y(D.TokenType.And);){const N=this.s();M.push(N)}return M.length===1?M[0]:i.and(...M)}s(){if(this.y(D.TokenType.Neg)){const M=this.D();switch(M.type){case D.TokenType.True:return this.z(),l.INSTANCE;case D.TokenType.False:return this.z(),S.INSTANCE;case D.TokenType.LParen:{this.z();const N=this.l();return this.A(D.TokenType.RParen,$),N?.negate()}case D.TokenType.Str:return this.z(),F.create(M.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",M)}}return this.t()}t(){const M=this.D();switch(M.type){case D.TokenType.True:return this.z(),i.true();case D.TokenType.False:return this.z(),i.false();case D.TokenType.LParen:{this.z();const N=this.l();return this.A(D.TokenType.RParen,$),N}case D.TokenType.Str:{const N=M.lexeme;if(this.z(),this.y(D.TokenType.RegexOp)){const H=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),H.type!==D.TokenType.RegexStr)throw this.B("REGEX",H);const J=H.lexeme,X=J.lastIndexOf("/"),Z=X===J.length-1?void 0:this.w(J.substring(X+1));let ie;try{ie=new RegExp(J.substring(1,X),Z)}catch{throw this.B("REGEX",H)}return le.create(N,ie)}switch(H.type){case D.TokenType.RegexStr:case D.TokenType.Error:{const J=[H.lexeme];this.z();let X=this.D(),Z=0;for(let Oe=0;Oe<H.lexeme.length;Oe++)H.lexeme.charCodeAt(Oe)===n.CharCode.OpenParen?Z++:H.lexeme.charCodeAt(Oe)===n.CharCode.CloseParen&&Z--;for(;!this.E()&&X.type!==D.TokenType.And&&X.type!==D.TokenType.Or;){switch(X.type){case D.TokenType.LParen:Z++;break;case D.TokenType.RParen:Z--;break;case D.TokenType.RegexStr:case D.TokenType.QuotedStr:for(let Oe=0;Oe<X.lexeme.length;Oe++)X.lexeme.charCodeAt(Oe)===n.CharCode.OpenParen?Z++:H.lexeme.charCodeAt(Oe)===n.CharCode.CloseParen&&Z--}if(Z<0)break;J.push(D.$Aj.getLexeme(X)),this.z(),X=this.D()}const ie=J.join(""),de=ie.lastIndexOf("/"),me=de===ie.length-1?void 0:this.w(ie.substring(de+1));let we;try{we=new RegExp(ie.substring(1,de),me)}catch{throw this.B("REGEX",H)}return i.regex(N,we)}case D.TokenType.QuotedStr:{const J=H.lexeme;this.z();let X=null;if(!(0,P.$df)(J)){const Z=J.indexOf("/"),ie=J.lastIndexOf("/");if(Z!==ie&&Z>=0){const de=J.slice(Z+1,ie),me=J[ie+1]==="i"?"i":"";try{X=new RegExp(de,me)}catch{throw this.B("REGEX",H)}}}if(X===null)throw this.B("REGEX",H);return le.create(N,X)}default:throw this.B("REGEX",this.D())}}if(this.y(D.TokenType.Not)){this.A(D.TokenType.In,y);const H=this.u();return i.notIn(N,H)}switch(this.D().type){case D.TokenType.Eq:{this.z();const H=this.u();if(this.x().type===D.TokenType.QuotedStr)return i.equals(N,H);switch(H){case"true":return i.has(N);case"false":return i.not(N);default:return i.equals(N,H)}}case D.TokenType.NotEq:{this.z();const H=this.u();if(this.x().type===D.TokenType.QuotedStr)return i.notEquals(N,H);switch(H){case"true":return i.not(N);case"false":return i.has(N);default:return i.notEquals(N,H)}}case D.TokenType.Lt:return this.z(),re.create(N,this.u());case D.TokenType.LtEq:return this.z(),Q.create(N,this.u());case D.TokenType.Gt:return this.z(),C.create(N,this.u());case D.TokenType.GtEq:return this.z(),z.create(N,this.u());case D.TokenType.In:return this.z(),i.in(N,this.u());default:return i.has(N)}}case D.TokenType.EOF:throw this.h.push({message:k,offset:M.offset,lexeme:"",additionalInfo:t}),r.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const M=this.D();switch(M.type){case D.TokenType.Str:case D.TokenType.QuotedStr:return this.z(),M.lexeme;case D.TokenType.True:return this.z(),"true";case D.TokenType.False:return this.z(),"false";case D.TokenType.In:return this.z(),"in";default:return""}}w(M){return M.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(M){return this.C(M)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(M,N){if(this.C(M))return this.z();throw this.B(N,this.D())}B(M,N,W){const H=(0,I.localize)(8,null,M,D.$Aj.getLexeme(N)),J=N.offset,X=D.$Aj.getLexeme(N);return this.h.push({message:H,offset:J,lexeme:X,additionalInfo:W}),r.c}C(M){return this.D().type===M}D(){return this.f[this.g]}E(){return this.D().type===D.TokenType.EOF}}e.$Cj=r;class i{static false(){return l.INSTANCE}static true(){return S.INSTANCE}static has(M){return v.create(M)}static equals(M,N){return R.create(M,N)}static notEquals(M,N){return O.create(M,N)}static regex(M,N){return le.create(M,N)}static in(M,N){return T.create(M,N)}static notIn(M,N){return L.create(M,N)}static not(M){return F.create(M)}static and(...M){return q.create(M,null,!0)}static or(...M){return j.create(M,null,!0)}static greater(M,N){return C.create(M,N)}static greaterEquals(M,N){return z.create(M,N)}static smaller(M,N){return re.create(M,N)}static smallerEquals(M,N){return Q.create(M,N)}static{this.c=new r({regexParsingWithErrorRecovery:!1})}static deserialize(M){return M==null?void 0:this.c.parse(M)}}e.$Dj=i;function c(_){const M=new r({regexParsingWithErrorRecovery:!1});return _.map(N=>(M.parse(N),M.lexingErrors.length>0?M.lexingErrors.map(W=>({errorMessage:W.additionalInfo?(0,I.localize)(9,null,W.additionalInfo):(0,I.localize)(10,null),offset:W.offset,length:W.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(W=>({errorMessage:W.additionalInfo?`${W.message}. ${W.additionalInfo}`:W.message,offset:W.offset,length:W.lexeme.length})):[]))}function s(_,M){const N=_?_.substituteConstants():void 0,W=M?M.substituteConstants():void 0;return!N&&!W?!0:!N||!W?!1:N.equals(W)}function u(_,M){return _.cmp(M)}class l{static{this.INSTANCE=new l}constructor(){this.type=g.False}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return S.INSTANCE}}e.$Gj=l;class S{static{this.INSTANCE=new S}constructor(){this.type=g.True}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return l.INSTANCE}}e.$Hj=S;class v{static create(M,N=null){const W=a.get(M);return typeof W=="boolean"?W?S.INSTANCE:l.INSTANCE:new v(M,N)}constructor(M,N){this.key=M,this.c=N,this.type=g.Defined}cmp(M){return M.type!==this.type?this.type-M.type:V(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=a.get(this.key);return typeof M=="boolean"?M?S.INSTANCE:l.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Ij=v;class R{static create(M,N,W=null){if(typeof N=="boolean")return N?v.create(M,W):F.create(M,W);const H=a.get(M);return typeof H=="boolean"?N===(H?"true":"false")?S.INSTANCE:l.INSTANCE:new R(M,N,W)}constructor(M,N,W){this.c=M,this.d=N,this.f=W,this.type=g.Equals}cmp(M){return M.type!==this.type?this.type-M.type:ce(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=a.get(this.c);if(typeof M=="boolean"){const N=M?"true":"false";return this.d===N?S.INSTANCE:l.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Jj=R;class T{static create(M,N){return new T(M,N)}constructor(M,N){this.d=M,this.f=N,this.type=g.In,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:ce(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const N=M.getValue(this.f),W=M.getValue(this.d);return Array.isArray(N)?N.includes(W):typeof W=="string"&&typeof N=="object"&&N!==null?d.call(N,W):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=L.create(this.d,this.f)),this.c}}e.$Kj=T;class L{static create(M,N){return new L(M,N)}constructor(M,N){this.d=M,this.f=N,this.type=g.NotIn,this.c=T.create(M,N)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=L;class O{static create(M,N,W=null){if(typeof N=="boolean")return N?F.create(M,W):v.create(M,W);const H=a.get(M);return typeof H=="boolean"?N===(H?"true":"false")?l.INSTANCE:S.INSTANCE:new O(M,N,W)}constructor(M,N,W){this.c=M,this.d=N,this.f=W,this.type=g.NotEquals}cmp(M){return M.type!==this.type?this.type-M.type:ce(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=a.get(this.c);if(typeof M=="boolean"){const N=M?"true":"false";return this.d===N?l.INSTANCE:S.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Mj=O;class F{static create(M,N=null){const W=a.get(M);return typeof W=="boolean"?W?l.INSTANCE:S.INSTANCE:new F(M,N)}constructor(M,N){this.c=M,this.d=N,this.type=g.Not}cmp(M){return M.type!==this.type?this.type-M.type:V(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=a.get(this.c);return typeof M=="boolean"?M?l.INSTANCE:S.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Nj=F;function B(_,M){if(typeof _=="string"){const N=parseFloat(_);isNaN(N)||(_=N)}return typeof _=="string"||typeof _=="number"?M(_):l.INSTANCE}class C{static create(M,N,W=null){return B(N,H=>new C(M,H,W))}constructor(M,N,W){this.c=M,this.d=N,this.f=W,this.type=g.Greater}cmp(M){return M.type!==this.type?this.type-M.type:ce(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Oj=C;class z{static create(M,N,W=null){return B(N,H=>new z(M,H,W))}constructor(M,N,W){this.c=M,this.d=N,this.f=W,this.type=g.GreaterEquals}cmp(M){return M.type!==this.type?this.type-M.type:ce(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Pj=z;class re{static create(M,N,W=null){return B(N,H=>new re(M,H,W))}constructor(M,N,W){this.c=M,this.d=N,this.f=W,this.type=g.Smaller}cmp(M){return M.type!==this.type?this.type-M.type:ce(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Qj=re;class Q{static create(M,N,W=null){return B(N,H=>new Q(M,H,W))}constructor(M,N,W){this.c=M,this.d=N,this.f=W,this.type=g.SmallerEquals}cmp(M){return M.type!==this.type?this.type-M.type:ce(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Rj=Q;class le{static create(M,N){return new le(M,N)}constructor(M,N){this.d=M,this.f=N,this.type=g.Regex,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const N=this.f?this.f.source:"",W=M.f?M.f.source:"";return N<W?-1:N>W?1:0}equals(M){if(M.type===this.type){const N=this.f?this.f.source:"",W=M.f?M.f.source:"";return this.d===M.d&&N===W}return!1}substituteConstants(){return this}evaluate(M){const N=M.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Sj=le;class K{static create(M){return new K(M)}constructor(M){this.c=M,this.type=g.NotRegex}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(M){return new K(this.c.map(M))}negate(){return this.c}}e.$Tj=K;function ee(_){let M=null;for(let N=0,W=_.length;N<W;N++){const H=_[N].substituteConstants();if(_[N]!==H&&M===null){M=[];for(let J=0;J<N;J++)M[J]=_[J]}M!==null&&(M[N]=H)}return M===null?_:M}class q{static create(M,N,W){return q.d(M,N,W)}constructor(M,N){this.expr=M,this.c=N,this.type=g.And}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let N=0,W=this.expr.length;N<W;N++){const H=u(this.expr[N],M.expr[N]);if(H!==0)return H}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].equals(M.expr[N]))return!1;return!0}return!1}substituteConstants(){const M=ee(this.expr);return M===this.expr?this:q.create(M,this.c,!1)}evaluate(M){for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].evaluate(M))return!1;return!0}static d(M,N,W){const H=[];let J=!1;for(const X of M)if(X){if(X.type===g.True){J=!0;continue}if(X.type===g.False)return l.INSTANCE;if(X.type===g.And){H.push(...X.expr);continue}H.push(X)}if(H.length===0&&J)return S.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(u);for(let X=1;X<H.length;X++)H[X-1].equals(H[X])&&(H.splice(X,1),X--);if(H.length===1)return H[0];for(;H.length>1;){const X=H[H.length-1];if(X.type!==g.Or)break;H.pop();const Z=H.pop(),ie=H.length===0,de=j.create(X.expr.map(me=>q.create([me,Z],null,W)),null,ie);de&&(H.push(de),H.sort(u))}if(H.length===1)return H[0];if(W){for(let X=0;X<H.length;X++)for(let Z=X+1;Z<H.length;Z++)if(H[X].negate().equals(H[Z]))return l.INSTANCE;if(H.length===1)return H[0]}return new q(H,N)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const N of this.expr)M.push(...N.keys());return M}map(M){return new q(this.expr.map(N=>N.map(M)),null)}negate(){if(!this.c){const M=[];for(const N of this.expr)M.push(N.negate());this.c=j.create(M,this,!0)}return this.c}}e.$Uj=q;class j{static create(M,N,W){return j.d(M,N,W)}constructor(M,N){this.expr=M,this.c=N,this.type=g.Or}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let N=0,W=this.expr.length;N<W;N++){const H=u(this.expr[N],M.expr[N]);if(H!==0)return H}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].equals(M.expr[N]))return!1;return!0}return!1}substituteConstants(){const M=ee(this.expr);return M===this.expr?this:j.create(M,this.c,!1)}evaluate(M){for(let N=0,W=this.expr.length;N<W;N++)if(this.expr[N].evaluate(M))return!0;return!1}static d(M,N,W){let H=[],J=!1;if(M){for(let X=0,Z=M.length;X<Z;X++){const ie=M[X];if(ie){if(ie.type===g.False){J=!0;continue}if(ie.type===g.True)return S.INSTANCE;if(ie.type===g.Or){H=H.concat(ie.expr);continue}H.push(ie)}}if(H.length===0&&J)return l.INSTANCE;H.sort(u)}if(H.length!==0){if(H.length===1)return H[0];for(let X=1;X<H.length;X++)H[X-1].equals(H[X])&&(H.splice(X,1),X--);if(H.length===1)return H[0];if(W){for(let X=0;X<H.length;X++)for(let Z=X+1;Z<H.length;Z++)if(H[X].negate().equals(H[Z]))return S.INSTANCE;if(H.length===1)return H[0]}return new j(H,N)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const N of this.expr)M.push(...N.keys());return M}map(M){return new j(this.expr.map(N=>N.map(M)),null)}negate(){if(!this.c){const M=[];for(const N of this.expr)M.push(N.negate());for(;M.length>1;){const N=M.shift(),W=M.shift(),H=[];for(const J of se(N))for(const X of se(W))H.push(q.create([J,X],null,!1));M.unshift(j.create(H,null,!1))}this.c=j.create(M,this,!0)}return this.c}}e.$Vj=j;class U extends v{static{this.d=[]}static all(){return U.d.values()}constructor(M,N,W){super(M,null),this.f=N,typeof W=="object"?U.d.push({...W,key:M}):W!==!0&&U.d.push({key:M,description:W,type:N!=null?typeof N:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return R.create(this.key,M)}notEqualsTo(M){return O.create(this.key,M)}}e.$Wj=U,e.$Xj=(0,A.$Fi)("contextKeyService");function V(_,M){return _<M?-1:_>M?1:0}function ce(_,M,N,W){return _<N?-1:_>N?1:M<W?-1:M>W?1:0}function G(_,M){if(_.type===g.False||M.type===g.True)return!0;if(_.type===g.Or)return M.type===g.Or?he(_.expr,M.expr):!1;if(M.type===g.Or){for(const N of M.expr)if(G(_,N))return!0;return!1}if(_.type===g.And){if(M.type===g.And)return he(M.expr,_.expr);for(const N of _.expr)if(G(N,M))return!0;return!1}return _.equals(M)}function he(_,M){let N=0,W=0;for(;N<_.length&&W<M.length;){const H=_[N].cmp(M[W]);if(H<0)return!1;H===0&&N++,W++}return N===_.length}function se(_){return _.type===g.Or?_.expr:[_]}}),define(oe[97],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Sm=e.ID=void 0,e.$Tm=o,e.ID="diagnosticsService",e.$Sm=(0,n.$Fi)(e.ID);function o(D){return!!D.hostName&&!!D.errorMessage}class P{async getPerformanceInfo(A,I){return{}}async getSystemInfo(A,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,I){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.$Um=P});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[124],ae([0,1,19,81,171,6,48,3,36]),function(x,e,n,o,P,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$8w=e.$7w=e.$6w=void 0,e.$9w=w,e.$0w=h,o=et(o),e.$6w=(0,D.$Fi)("dialogService");var a;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(a||(a={}));class f{a(y){return this.d(y,a.Confirmation)}b(y){return this.d(y,a.Prompt)}c(y){return this.d(y,a.Input)}d(y,$){const m=[];switch($){case a.Confirmation:{const E=y;E.primaryButton?m.push(E.primaryButton):m.push((0,P.localize)(0,null)),E.cancelButton?m.push(E.cancelButton):m.push((0,P.localize)(1,null));break}case a.Prompt:{const E=y;Array.isArray(E.buttons)&&E.buttons.length>0&&m.push(...E.buttons.map(k=>k.label)),E.cancelButton&&(E.cancelButton===!0?m.push((0,P.localize)(2,null)):typeof E.cancelButton=="string"?m.push(E.cancelButton):E.cancelButton.label?m.push(E.cancelButton.label):m.push((0,P.localize)(3,null))),m.length===0&&m.push((0,P.localize)(4,null));break}case a.Input:{const E=y;E.primaryButton?m.push(E.primaryButton):m.push((0,P.localize)(5,null)),E.cancelButton?m.push(E.cancelButton):m.push((0,P.localize)(6,null));break}}return m}e(y){if(typeof y=="string")return y;if(typeof y=="number")return y===o.default.Info?"info":y===o.default.Error?"error":y===o.default.Warning?"warning":"none"}f(y,$,m){const E=[...y.buttons??[]];y.cancelButton&&typeof y.cancelButton!="string"&&typeof y.cancelButton!="boolean"&&E.push(y.cancelButton);let k=E[$]?.run({checkboxChecked:m});return k instanceof Promise||(k=Promise.resolve(k)),{result:k,checkboxChecked:m}}}e.$7w=f,e.$8w=(0,D.$Fi)("fileDialogService");var d;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(d||(e.ConfirmResult=d={}));const g=10;function w(p){const y=[];return y.push(...p.slice(0,g).map($=>typeof $=="string"?$:(0,n.$dh)($))),p.length>g&&(p.length-g===1?y.push((0,P.localize)(7,null)):y.push((0,P.localize)(8,null,p.length-g))),y.push(""),y.join(`
`)}function h(p,y){const $=(0,b.$do)(p);let m=($.buttons??[]).map(r=>(0,A.$3w)(r)),E=(p.buttons||[]).map((r,i)=>i),k=0,t=$.cancelId??m.length-1;if(m.length>1){const r=typeof t=="number"?m[t]:void 0;if(I.$k||I.$j){if(typeof r=="string"&&m.length>1&&t!==1){m.splice(t,1),m.splice(1,0,r);const i=E[t];E.splice(t,1),E.splice(1,0,i),t=1}I.$k&&m.length>1&&(m=m.reverse(),E=E.reverse(),k=m.length-1,typeof r=="string"&&(t=k-1))}else if(I.$i&&typeof r=="string"&&m.length>1&&t!==m.length-1){m.splice(t,1),m.push(r);const i=E[t];E.splice(t,1),E.push(i),t=m.length-1}}return $.buttons=m,$.defaultId=k,$.cancelId=t,$.noLink=!0,$.title=$.title||y.nameLong,{options:$,buttonIndeces:E}}}),define(oe[98],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$oY=e.$nY=void 0,e.$pY=D,e.$qY=A,e.$nY=(0,n.$Fi)("encryptionService"),e.$oY=(0,n.$Fi)("encryptionMainService");var o;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(o||(e.PasswordStoreCLIOption=o={}));var P;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(P||(e.KnownStorageProvider=P={}));function D(I){return I===P.kwallet||I===P.kwallet5||I===P.kwallet6}function A(I){return I===P.gnomeAny||I===P.gnomeLibsecret||I===P.gnomeKeyring}}),define(oe[38],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,n.$Fi)("environmentService"),e.$Ni=(0,n.$Gi)(e.$Mi)}),define(oe[213],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=e.$ufc=void 0,e.$ufc=(0,n.$Fi)("extensionHostStarter"),e.$vfc="extensionHostStarter"}),define(oe[214],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L9b=e.$K9b=void 0,e.$K9b=(0,n.$Fi)("externalTerminal"),e.$L9b="Terminal.app"}),define(oe[215],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0,e.$xfc=(0,n.$Fi)("externalTerminal")}),define(oe[216],ae([0,1,49,54,12,10,3,82,21,95,179,214]),function(x,e,n,o,P,D,A,I,b,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=e.$yfc=void 0,n=De(n),D=De(D),A=De(A),b=De(b),a=De(a),f=De(f);const g=f.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await y.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends w{static{this.b="cmd.exe"}openTerminal(t,r){return this.spawnTerminal(n,t,a.$xm(),r)}spawnTerminal(t,r,i,c){const s=r.windowsExec||h.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const u=D.$pc(s,".exe").toLowerCase();if(u==="cmder")return t.spawn(s,c?[c]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push('""'),l.push(s),u==="wt"&&l.push("-d ."),new Promise((S,v)=>{const R=$(process),T=t.spawn(i,l,{cwd:c,env:R,detached:!0});T.on("error",v),T.on("exit",()=>S())})}async runInTerminal(t,r,i,c,s){const u="windowsExec"in s&&s.windowsExec?s.windowsExec:h.getDefaultTerminalWindows(),l=await h.f();return new Promise((S,v)=>{const R=`"${r} - ${g}"`,T=`"${i.join('" "')}" & pause`,L=Object.assign({},$(process),c);Object.keys(L).filter(z=>L[z]===null).forEach(z=>delete L[z]);const O={cwd:r,env:L,windowsVerbatimArguments:!0};let F,B;D.$pc(u,".exe")==="wt"?(F=u,B=["-d",".",h.b,"/c",T]):l?(F=l,B=["-d",".",u,"/c",T]):(F=h.b,B=["/c","start",R,"/wait",u,"/c",`"${T}"`]),n.spawn(F,B,O).on("error",z=>{v(m(z))}),S(void 0)})}static getDefaultTerminalWindows(){if(!h.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return h.d}static async f(){try{const t=await a.win32.findExecutable("wt");return await b.Promises.exists(t)?t:void 0}catch{return}}}e.$yfc=h,Pe([o.$0h],h,"f",null);class p extends w{static{this.b="/usr/bin/osascript"}openTerminal(t,r){return this.spawnTerminal(n,t,r)}runInTerminal(t,r,i,c,s){const u=s.osxExec||d.$L9b;return new Promise((l,S)=>{if(u===d.$L9b||u==="iTerm.app"){const v=u===d.$L9b?"TerminalHelper":"iTermHelper",T=[P.$Zg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${v}.scpt`).fsPath,"-t",t||g,"-w",r];for(const F of i)T.push("-a"),T.push(F);if(c){const F=Object.assign({},$(process),c);for(const B in F){const C=F[B];C===null?(T.push("-u"),T.push(B)):(T.push("-e"),T.push(`${B}=${C}`))}}let L="";const O=n.spawn(p.b,T);O.on("error",F=>{S(m(F))}),O.stderr.on("data",F=>{L+=F.toString()}),O.on("exit",F=>{if(F===0)l(void 0);else if(L){const B=L.split(`
`,1);S(new Error(B[0]))}else S(new Error(f.localize(1,null,v,F)))})}else S(new Error(f.localize(2,null,u)))})}spawnTerminal(t,r,i){const c=r.osxExec||d.$L9b;return new Promise((s,u)=>{const l=["-a",c];i&&l.push(i);const S=$(process),v=t.spawn("/usr/bin/open",l,{cwd:i,env:S});v.on("error",u),v.on("exit",()=>s())})}}e.$zfc=p;class y extends w{static{this.b=f.localize(3,null)}openTerminal(t,r){return this.spawnTerminal(n,t,r)}runInTerminal(t,r,i,c,s){const u=s.linuxExec?Promise.resolve(s.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((l,S)=>{const v=[];u.then(R=>{R.indexOf("gnome-terminal")>=0?v.push("-x"):v.push("-e"),v.push("bash"),v.push("-c");const T=`${E(i)}; echo; read -p "${y.b}" -n1;`;v.push(`''${T}''`);const L=Object.assign({},$(process),c);Object.keys(L).filter(C=>L[C]===null).forEach(C=>delete L[C]);const O={cwd:r,env:L};let F="";const B=n.spawn(R,v,O);B.on("error",C=>{S(m(C))}),B.stderr.on("data",C=>{F+=C.toString()}),B.on("exit",C=>{if(C===0)l(void 0);else if(F){const z=F.split(`
`,1);S(new Error(z[0]))}else S(new Error(f.localize(4,null,R,C)))})})})}static async getDefaultTerminalLinuxReady(){if(!y.d)if(!A.$k)y.d=Promise.resolve("xterm");else{const t=await b.Promises.exists("/etc/debian_version");y.d=new Promise(r=>{t?r("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?r("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?r("konsole"):process.env.COLORTERM?r(process.env.COLORTERM):process.env.TERM?r(process.env.TERM):r("xterm")})}return y.d}spawnTerminal(t,r,i){const c=r.linuxExec?Promise.resolve(r.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((s,u)=>{c.then(l=>{const S=$(process),v=t.spawn(l,[],{cwd:i,env:S});v.on("error",u),v.on("exit",()=>s())})})}}e.$Afc=y;function $(k){const t={...k.env};return(0,I.$km)(t),t}function m(k){return"errno"in k&&k.errno==="ENOENT"&&"path"in k&&typeof k.path=="string"?new Error(f.localize(5,null,k.path)):k}function E(k){let t="";for(const r of k)r.indexOf(" ")>=0?t+='"'+r+'"':t+=r,t+=" ";return t}}),define(oe[15],ae([0,1,61,10,26,13,7,181,6,3,12,66]),function(x,e,n,o,P,D,A,I,b,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=g,e.$bl=y,e.$cl=m,e.$dl=E,e.$el=k,e.$fl=t,e.$gl=r,e.$hl=i,e.$il=c,e.$jl=s,e.$kl=u,e.$ml=v,e.$nl=R,e.$ol=T,e.$pl=L,e.$ql=O,e.$tl=re,e.$Fl=j,e.$Gl=U,e.$Il=ce,e.$_k=(0,b.$Fi)("fileService");function g(G){return G.create===!0}var w;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var h;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var p;(function(G){G[G.UPDATED=2]="UPDATED",G[G.ADDED=4]="ADDED",G[G.DELETED=8]="DELETED"})(p||(e.FileChangeFilter=p={}));function y(G){const he=G;return!!he&&typeof he.onDidChange=="function"}var $;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function m(G){return!!(G.capabilities&$.FileReadWrite)}function E(G){return!!(G.capabilities&$.FileFolderCopy)}function k(G){return!!(G.capabilities&$.FileClone)}function t(G){return!!(G.capabilities&$.FileOpenReadWriteClose)}function r(G){return!!(G.capabilities&$.FileReadStream)}function i(G){return m(G)?!!(G.capabilities&$.FileAtomicRead):!1}function c(G){return m(G)?!!(G.capabilities&$.FileAtomicWrite):!1}function s(G){return!!(G.capabilities&$.FileAtomicDelete)}function u(G){return!!(G.capabilities&$.Readonly)}var l;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class S extends Error{static create(he,se){const _=new S(he.toString(),se);return T(_,se),_}constructor(he,se){super(he),this.code=se}}e.$ll=S;function v(G,he){return S.create(G,he)}function R(G){return G||v((0,I.localize)(0,null),l.Unknown)}function T(G,he){return G.name=he?`${he} (FileSystemError)`:"FileSystemError",G}function L(G){if(!G)return l.Unknown;if(G instanceof S)return G.code;const he=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!he)return l.Unknown;switch(he[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}function O(G){if(G instanceof Q)return G.fileOperationResult;switch(L(G)){case l.FileNotFound:return ee.FILE_NOT_FOUND;case l.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case l.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case l.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case l.NoPermissions:return ee.FILE_PERMISSION_DENIED;case l.FileExists:return ee.FILE_MOVE_CONFLICT;case l.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var F;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class B{constructor(he,se,_){this.resource=he,this.operation=se,this.target=_}isOperation(he){return this.operation===he}}e.$rl=B;var C;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(C||(e.FileChangeType=C={}));class z{static{this.a=null}constructor(he,se){this.c=se,this.b=void 0,this.d=new d.$X(()=>{const _=n.$Li.forUris(()=>this.c);return _.fill(this.rawAdded.map(M=>[M,!0])),_}),this.f=new d.$X(()=>{const _=n.$Li.forUris(()=>this.c);return _.fill(this.rawUpdated.map(M=>[M,!0])),_}),this.g=new d.$X(()=>{const _=n.$Li.forUris(()=>this.c);return _.fill(this.rawDeleted.map(M=>[M,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of he){switch(_.type){case C.ADDED:this.rawAdded.push(_.resource);break;case C.UPDATED:this.rawUpdated.push(_.resource);break;case C.DELETED:this.rawDeleted.push(_.resource);break}this.b!==z.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(he,...se){return this.h(he,{includeChildren:!1},...se)}affects(he,...se){return this.h(he,{includeChildren:!0},...se)}h(he,se,..._){if(!he)return!1;const M=_.length>0;return!!((!M||_.includes(C.ADDED))&&(this.d.value.get(he)||se.includeChildren&&this.d.value.findSuperstr(he))||(!M||_.includes(C.UPDATED))&&(this.f.value.get(he)||se.includeChildren&&this.f.value.findSuperstr(he))||(!M||_.includes(C.DELETED))&&(this.g.value.findSubstr(he)||se.includeChildren&&this.g.value.findSuperstr(he)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(he){return this.b===he}hasCorrelation(){return typeof this.b=="number"}}e.$sl=z;function re(G,he,se){return!G||!he||G===he||he.length>G.length?!1:(he.charAt(he.length-1)!==o.sep&&(he+=o.sep),se?(0,P.$Hf)(G,he):G.indexOf(he)===0)}class Q extends Error{constructor(he,se,_){super(he),this.fileOperationResult=se,this.options=_}}e.$ul=Q;class le extends Q{constructor(he,se,_,M){super(he,se,M),this.fileOperationResult=se,this.size=_}}e.$vl=le;class K extends Q{constructor(he,se,_){super(he,ee.FILE_NOT_MODIFIED_SINCE,_),this.stat=se}}e.$wl=K;var ee;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var q;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.$El="";function j(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}async function U(G,he){if(!he.hasProvider(A.URI.from({scheme:G.scheme})))return new Promise(se=>{const _=he.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===G.scheme&&M.added&&(_.dispose(),se())})})}class V{static{this.KB=1024}static{this.MB=V.KB*V.KB}static{this.GB=V.MB*V.KB}static{this.TB=V.GB*V.KB}static formatSize(he){return(0,D.$jg)(he)||(he=0),he<V.KB?(0,I.localize)(1,null,he.toFixed(0)):he<V.MB?(0,I.localize)(2,null,(he/V.KB).toFixed(2)):he<V.GB?(0,I.localize)(3,null,(he/V.MB).toFixed(2)):he<V.TB?(0,I.localize)(4,null,(he/V.GB).toFixed(2)):(0,I.localize)(5,null,(he/V.TB).toFixed(2))}}e.$Hl=V;function ce(G){const he=typeof G=="string"||G?.scheme===f.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===f.Schemas.file?1024*V.MB:he?10*V.MB:a.$o?50*V.MB:1024*V.MB}}),define(oe[125],ae([0,1,17,16,182,15]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=A;async function A(f,d,g,w,h,p){let y;try{await I(f,d,g,w,h,p)}catch($){y=$}finally{y&&h.errorTransformer&&(y=h.errorTransformer(y)),typeof y<"u"&&g.error(y),g.end()}}async function I(f,d,g,w,h,p){b(p);const y=await f.open(d,{create:!1});try{b(p);let $=0,m=0,E=h&&typeof h.length=="number"?h.length:void 0,k=n.$Oe.alloc(Math.min(h.bufferSize,typeof E=="number"?E:h.bufferSize)),t=h&&typeof h.position=="number"?h.position:0,r=0;do m=await f.read(y,t,k.buffer,r,k.byteLength-r),t+=m,r+=m,$+=m,typeof E=="number"&&(E-=m),r===k.byteLength&&(await g.write(w(k)),k=n.$Oe.alloc(Math.min(h.bufferSize,typeof E=="number"?E:h.bufferSize)),r=0);while(m>0&&(typeof E!="number"||E>0)&&b(p)&&a($,h));if(r>0){let i=r;typeof E=="number"&&(i=Math.min(r,E)),g.write(w(k.slice(0,i)))}}catch($){throw(0,D.$nl)($)}finally{await f.close(y)}}function b(f){if(f.isCancellationRequested)throw(0,o.$8)();return!0}function a(f,d){if(typeof d?.limits?.size=="number"&&f>d.limits.size)throw(0,D.$ml)((0,P.localize)(0,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[62],ae([0,1,113,2,10,3,7,15]),function(x,e,n,o,P,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=void 0,e.$1q=b,e.$2q=a,e.$6q=w,e.$7q=h,e.$8q=p,e.$9q=y,e.$0q=m,e.$$q=E;function b(k){return typeof k.correlationId=="number"}function a(k){return k.recursive===!0}class f extends o.$Wc{static{this.a=5}constructor(t,r,i,c){super(),this.h=t,this.j=r,this.m=i,this.n=c,this.c=this.B(new o.$Xc),this.f=void 0,this.g=0}s(){const t=new o.$Vc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(r=>this.h(r))),t.add(this.b.onDidLogMessage(r=>this.j(r))),t.add(this.b.onDidError(r=>this.t(r.error,r.request)))}t(t,r){this.u(t,r)?this.g<f.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,r){return!(!this.n.restartOnError||r||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$3q=f;class d extends f{constructor(t,r,i){super(t,r,i,{type:"node.js",restartOnError:!1})}}e.$4q=d;class g extends f{constructor(t,r,i){super(t,r,i,{type:"universal",restartOnError:!0})}}e.$5q=g;function w(k){return k.map(t=>({type:t.type,resource:A.URI.revive(t.resource),cId:t.cId}))}function h(k){const t=new $;for(const r of k)t.processEvent(r);return t.coalesce()}function p(k,t){return typeof t=="string"&&!t.startsWith(n.$vk)&&!(0,P.$kc)(t)?{base:k,pattern:t}:t}function y(k,t){const r=[];for(const i of t)r.push((0,n.$zk)(p(k,i)));return r}class ${constructor(){this.a=new Set,this.b=new Map}c(t){return D.$k?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const r=this.b.get(this.c(t));let i=!1;if(r){const c=r.type,s=t.type;r.resource.fsPath!==t.resource.fsPath&&(t.type===I.FileChangeType.DELETED||t.type===I.FileChangeType.ADDED)?i=!0:c===I.FileChangeType.ADDED&&s===I.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(r)):c===I.FileChangeType.DELETED&&s===I.FileChangeType.ADDED?r.type=I.FileChangeType.UPDATED:c===I.FileChangeType.ADDED&&s===I.FileChangeType.UPDATED||(r.type=s)}else i=!0;i&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],r=[];return Array.from(this.a).filter(i=>i.type!==I.FileChangeType.DELETED?(t.push(i),!1):!0).sort((i,c)=>i.resource.fsPath.length-c.resource.fsPath.length).filter(i=>r.some(c=>(0,I.$tl)(i.resource.fsPath,c,!D.$k))?!1:(r.push(i.resource.fsPath),!0)).concat(t)}}function m(k,t){if(typeof t=="number")switch(k.type){case I.FileChangeType.ADDED:return(t&I.FileChangeFilter.ADDED)===0;case I.FileChangeType.DELETED:return(t&I.FileChangeFilter.DELETED)===0;case I.FileChangeType.UPDATED:return(t&I.FileChangeFilter.UPDATED)===0}return!1}function E(k){if(typeof k=="number"){const t=[];return k&I.FileChangeFilter.ADDED&&t.push("Added"),k&I.FileChangeFilter.DELETED&&t.push("Deleted"),k&I.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(oe[217],ae([0,1,17,55,16,4,2,68,33,15,62]),function(x,e,n,o,P,D,A,I,b,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Q=e.$9Q=void 0,e.$9Q="localFilesystem";class d extends A.$Wc{constructor(w,h){super(),this.a=w,this.b=h,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.$me),this.onDidChangeFile=this.f.event,this.g=this.B(new D.$me),this.onDidWatchError=this.g.event,this.h=(0,b.$2g)(),this.j()}get capabilities(){return this.c||(this.c=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=a.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=a.FileSystemProviderCapabilities.Trash)),this.c}stat(w){return this.a.call("stat",[w])}readdir(w){return this.a.call("readdir",[w])}async readFile(w,h){const{buffer:p}=await this.a.call("readFile",[w,h]);return p}readFileStream(w,h,p){const y=(0,I.$Ce)(m=>n.$Oe.concat(m.map(E=>n.$Oe.wrap(E))).buffer),$=new A.$Vc;return $.add(this.a.listen("readFileStream",[w,h])(m=>{if(m instanceof n.$Oe)y.write(m.buffer);else{if(m==="end")y.end();else{let E;if(m instanceof Error)E=m;else{const k=m;E=(0,a.$ml)(k.message??(0,o.$qj)(k),k.code??a.FileSystemProviderErrorCode.Unknown)}y.error(E),y.end()}$.dispose()}})),$.add(p.onCancellationRequested(()=>{y.error((0,P.$8)()),y.end(),$.dispose()})),y}writeFile(w,h,p){return this.a.call("writeFile",[w,n.$Oe.wrap(h),p])}open(w,h){return this.a.call("open",[w,h])}close(w){return this.a.call("close",[w])}async read(w,h,p,y,$){const[m,E]=await this.a.call("read",[w,h,$]);return p.set(m.buffer.slice(0,E),y),E}write(w,h,p,y,$){return this.a.call("write",[w,h,n.$Oe.wrap(p),y,$])}mkdir(w){return this.a.call("mkdir",[w])}delete(w,h){return this.a.call("delete",[w,h])}rename(w,h,p){return this.a.call("rename",[w,h,p])}copy(w,h,p){return this.a.call("copy",[w,h,p])}cloneFile(w,h){return this.a.call("cloneFile",[w,h])}j(){this.B(this.a.listen("fileChange",[this.h])(w=>{if(Array.isArray(w)){const h=w;this.f.fire((0,f.$6q)(h))}else{const h=w;this.g.fire(h)}}))}watch(w,h){const p=(0,b.$2g)();return this.a.call("watch",[this.h,p,w,h]),(0,A.$Uc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$0Q=d}),define(oe[218],ae([0,1,47,2,62,4,15,7,8]),function(x,e,n,o,P,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class a extends o.$Wc{constructor(){super(),this.a=this.B(new D.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new D.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new o.$6c),this.m=new Set,this.n=this.B(new b.$Dh(this.y())),this.r=5007,this.s=new b.$3h,this.R=!1,this.B(this.f(d=>this.t(d)))}t(d){this.u(d)&&this.z(d)}u(d){return(0,P.$1q)(d)}async watch(d){this.s.isSettled||this.s.complete(),this.s=new b.$3h;try{this.h.clear(),this.g.clear();for(const g of d)this.u(g)?this.h.set(g.correlationId,g):this.g.add(g);for(const[g]of this.j)this.h.has(g)||(this.j.deleteAndDispose(g),this.m.delete(g));return await this.w(!1)}finally{this.s.complete()}}w(d){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(g=>!this.j.has(g.correlationId))]),d?this.y():0)}y(){return 800}isSuspended(d){return typeof d.correlationId!="number"?!1:this.m.has(d.correlationId)?"polling":this.j.has(d.correlationId)}async z(d){if(this.j.has(d.correlationId))return;const g=new o.$Vc;this.j.set(d.correlationId,g),await this.s.p,!g.isDisposed&&(this.D(d,g),this.w(!0))}C(d){this.j.deleteAndDispose(d.correlationId),this.m.delete(d.correlationId),this.w(!1)}D(d,g){this.F(d,g)?(this.P(`reusing an existing recursive watcher to monitor ${d.path}`),this.m.delete(d.correlationId)):(this.G(d,g),this.m.add(d.correlationId))}F(d,g){const w=this.O?.subscribe(d.path,(h,p)=>{g.isDisposed||(h?this.D(d,g):p?.type===A.FileChangeType.ADDED&&this.H(d))});return w?(g.add(w),!0):!1}G(d,g){let w=!1;const h=(p,y)=>{if(g.isDisposed)return;const $=this.I(p),m=this.I(y),E=w;w=$,!$&&(m||E)&&this.H(d)};this.P(`starting fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,n.watchFile)(d.path,{persistent:!1,interval:this.r},h)}catch(p){this.Q(`fs.watchFile() failed with error ${p} on path ${d.path} (correlationId: ${d.correlationId})`)}g.add((0,o.$Uc)(()=>{this.P(`stopping fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,n.unwatchFile)(d.path,h)}catch(p){this.Q(`fs.unwatchFile() failed with error ${p} on path ${d.path} (correlationId: ${d.correlationId})`)}}))}H(d){this.P(`detected ${d.path} exists again, resuming watcher (correlationId: ${d.correlationId})`);const g={resource:I.URI.file(d.path),type:A.FileChangeType.ADDED,cId:d.correlationId};this.a.fire([g]),this.J(g,d),this.C(d)}I(d){return d.ctimeMs===0&&d.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(d,g){if(this.R){const w=` >> normalized ${d.type===A.FileChangeType.ADDED?"[ADDED]":d.type===A.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`;this.L(w,g)}}L(d,g){this.R&&this.P(`${d}${typeof g.correlationId=="number"?` <${g.correlationId}> `:""}`)}M(d){return`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, filter: ${(0,P.$$q)(d.filter)}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`}async setVerboseLogging(d){this.R=d}}e.$hr=a}),define(oe[219],ae([0,1,47,8,23,31,2,79,10,3,19,7,114,21,15,62]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0,e.$nr=$;class y extends A.$Wc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(E,k,t,r,i,c){super(),this.s=E,this.t=k,this.u=t,this.w=r,this.y=i,this.z=c,this.c=this.B(new o.$Uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new o.$Th(s=>this.M(s),y.b)),this.g=(0,p.$9q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,p.$9q)(this.s.path,this.s.includes):void 0,this.j=(0,p.$1q)(this.s)?this.s.filter:void 0,this.m=new P.$xe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const E=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const k=await w.Promises.stat(E);if(this.m.token.isCancellationRequested)return;this.B(await this.G(E,k.isDirectory()))}catch(E){E.code!=="ENOENT"?this.O(E):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${E})`),this.D()}}D(){this.r=!0,this.w?.()}async F(E){let k=E.path;try{k=await w.Promises.realpath(E.path),E.path===k&&(k=await(0,g.$jr)(E.path,this.m.token)??E.path),E.path!==k&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${E.path}, real: ${k})`)}catch{}return k}async G(E,k){const t=new A.$Vc;return this.H(E,k,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(E,k,t)),t}H(E,k,t){if(k)return!1;const r=d.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(c,s)=>{if(!t.isDisposed)if(c){const u=await this.G(E,k);t.isDisposed?u.dispose():t.add(u)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:r,type:s.type,cId:this.s.correlationId},!0)});return i?(t.add(i),!0):!1}async I(E,k,t){if(a.$j&&(0,D.$Eg)(E,"/Volumes/",!0)){this.O(`Refusing to watch ${E} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const r=new P.$xe(this.m.token);t.add((0,A.$Uc)(()=>r.dispose(!0)));const i=new A.$Vc;t.add(i);try{const c=d.URI.file(this.s.path),s=(0,b.$pc)(E),u=(0,n.watch)(E);i.add((0,A.$Uc)(()=>{u.removeAllListeners(),u.close()})),this.Q(`Started watching: '${E}'`);const l=new Set;if(k)try{for(const v of await w.Promises.readdir(E))l.add(v)}catch(v){this.O(v)}if(r.token.isCancellationRequested)return;const S=new Map;i.add((0,A.$Uc)(()=>{for(const[,v]of S)v.dispose();S.clear()})),u.on("error",(v,R)=>{r.token.isCancellationRequested||(this.O(`Failed to watch ${E} for changes using fs.watch() (${v}, ${R})`),this.D())}),u.on("change",(v,R)=>{if(r.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${v}"] ${R}`);let T="";if(R&&(T=R.toString(),a.$j&&(T=(0,I.$mm)(T))),!(!T||v!=="change"&&v!=="rename"))if(k)if(v==="rename"){S.get(T)?.dispose();const L=setTimeout(async()=>{if(S.delete(T),T===s&&!await w.Promises.exists(E)){this.J(c);return}if(r.token.isCancellationRequested)return;const O=await this.N((0,b.$lc)(E,T));if(r.token.isCancellationRequested)return;let F;O?l.has(T)?F=h.FileChangeType.UPDATED:(F=h.FileChangeType.ADDED,l.add(T)):(l.delete(T),F=h.FileChangeType.DELETED),this.L({resource:(0,f.$gh)(c,T),type:F,cId:this.s.correlationId})},y.a);S.set(T,(0,A.$Uc)(()=>clearTimeout(L)))}else{let L;l.has(T)?L=h.FileChangeType.UPDATED:(L=h.FileChangeType.ADDED,l.add(T)),this.L({resource:(0,f.$gh)(c,T),type:L,cId:this.s.correlationId})}else if(v==="rename"||T!==s){const L=setTimeout(async()=>{const O=await w.Promises.exists(E);r.token.isCancellationRequested||(O?(this.L({resource:c,type:h.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(E,!1))):this.J(c))},y.a);i.clear(),i.add((0,A.$Uc)(()=>clearTimeout(L)))}else this.L({resource:c,type:h.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(c){r.token.isCancellationRequested||this.O(`Failed to watch ${E} for changes using fs.watch() (${c.toString()})`),this.D()}}J(E){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:E,type:h.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(E,k=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${E.type===h.FileChangeType.ADDED?"[ADDED]":E.type===h.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`),!k&&this.g.some(t=>t(E.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${E.resource.fsPath}`):!k&&this.h&&this.h.length>0&&!this.h.some(t=>t(E.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${E.resource.fsPath}`):this.f.work(E))}M(E){const k=(0,p.$7q)(E),t=[];for(const i of k){if((0,p.$0q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}t.push(i)}if(t.length===0)return;if(this.z)for(const i of t)this.R(` >> normalized ${i.type===h.FileChangeType.ADDED?"[ADDED]":i.type===h.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(E){if(a.$k)return w.Promises.exists(E);try{const k=(0,b.$pc)(E);return(await w.Promises.readdir((0,b.$oc)(E))).some(r=>r===k)}catch(k){return this.Q(k),!1}}setVerboseLogging(E){this.z=E}O(E){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${E}`})}P(E){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${E}`})}Q(E){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${E}`})}R(E){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${E}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$mr=y;async function $(m,E,k,t,r=512){const i=await w.Promises.open(m,"r"),c=Buffer.allocUnsafe(r),s=new P.$xe(t);let u,l=!1;const S={path:m,excludes:[],recursive:!1},v=new y(S,void 0,R=>{(async()=>{for(const{type:T}of R)if(T===h.FileChangeType.UPDATED){if(l)return;l=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:L}=await w.Promises.read(i,c,0,r,null);if(!L||s.token.isCancellationRequested)break;E(c.slice(0,L))}}catch(L){u=new Error(L),s.dispose(!0)}finally{l=!1}}})()});return await v.ready,k(),new Promise((R,T)=>{s.token.onCancellationRequested(async()=>{v.dispose();try{await w.Promises.close(i)}catch(L){u=new Error(L)}u?T(u):R()})})}}),define(oe[220],ae([0,1,4,113,218,3,219,31]),function(x,e,n,o,P,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class b extends P.$hr{constructor(f){super(),this.O=f,this.onDidError=n.Event.None,this.watchers=new Set}async N(f){f=this.Z(f);const d=[],g=new Set(Array.from(this.watchers));for(const w of f){const h=this.W(w);h&&(0,o.$Dk)(h.request.excludes,w.excludes)&&(0,o.$Dk)(h.request.includes,w.includes)?g.delete(h):d.push(w)}d.length&&this.P(`Request to start watching: ${d.map(w=>this.M(w)).join(",")}`),g.size&&this.P(`Request to stop watching: ${Array.from(g).map(w=>this.M(w.request)).join(",")}`);for(const w of g)this.Y(w);for(const w of d)this.X(w)}W(f){for(const d of this.watchers)if(typeof f.correlationId=="number"||typeof d.request.correlationId=="number"){if(d.request.correlationId===f.correlationId)return d}else if((0,I.$Dg)(d.request.path,f.path,!D.$k))return d}X(f){const d=new A.$mr(f,this.O,w=>this.a.fire(w),()=>this.c.fire(f),w=>this.b.fire(w),this.R),g={request:f,instance:d};this.watchers.add(g)}async stop(){await super.stop();for(const f of this.watchers)this.Y(f)}Y(f){this.P("stopping file watcher",f),this.watchers.delete(f),f.instance.dispose()}Z(f){const d=new Map;for(const g of f){const w=D.$k?g.path:g.path.toLowerCase();let h=d.get(g.correlationId);h||(h=new Map,d.set(g.correlationId,h)),h.has(w)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(g)}`),h.set(w,g)}return Array.from(d.values()).map(g=>Array.from(g.values())).flat()}async setVerboseLogging(f){super.setVerboseLogging(f);for(const d of this.watchers)d.instance.setVerboseLogging(f)}P(f,d){this.R&&this.b.fire({type:"trace",message:this.bb(f,d)})}Q(f){this.b.fire({type:"warn",message:this.bb(f)})}bb(f,d){return d?`[File Watcher (node.js)] ${f} (${this.M(d.request)})`:`[File Watcher (node.js)] ${f}`}}e.$or=b}),define(oe[221],ae([0,1,62,220]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class P extends n.$4q{constructor(A,I,b){super(A,I,b),this.s()}r(A){return A.add(new o.$or(void 0))}}e.$pr=P}),define(oe[222],ae([0,1,12,44,165,62]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class A extends D.$5q{constructor(b,a,f){super(b,a,f),this.s()}r(b){const a=b.add(new P.$fr(n.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(a.onDidProcessExit(({code:f,signal:d})=>this.t(`terminated by itself with code ${f}, signal: ${d} (ETERM)`))),o.ProxyChannel.toService((0,o.$mi)(a.getChannel("watcher")))}}e.$gr=A}),define(oe[99],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class n{constructor(...P){this.a=new Map;for(const[D,A]of P)this.set(D,A)}set(P,D){const A=this.a.get(P);return this.a.set(P,D),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Di=n}),define(oe[223],ae([0,1,8,16,2,84,212,6,99,109]),function(x,e,n,o,P,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;const f=!1;class d extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class g{constructor(y=new b.$Di,$=!1,m,E=f){this.i=y,this.j=$,this.k=m,this.l=E,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Ei,this),this._globalGraph=E?m?._globalGraph??new A.$sr(k=>k):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Rc)(this.h),this.h.clear();for(const y of this.g)(0,P.$Qc)(y)&&y.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(y,$){this.m();const m=this,E=new class extends g{dispose(){m.h.delete(E),super.dispose()}}(y,this.j,this,this.l);return this.h.add(E),$?.add(E),E}invokeFunction(y,...$){this.m();const m=h.traceInvocation(this.l,y);let E=!1;try{return y({get:t=>{if(E)throw(0,o.$0)("service accessor is only valid during the invocation of its target method");const r=this.s(t,m);if(!r)throw new Error(`[invokeFunction] unknown service '${t}'`);return r}},...$)}finally{E=!0,m.stop()}}createInstance(y,...$){this.m();let m,E;return y instanceof D.$Ci?(m=h.traceCreation(this.l,y.ctor),E=this.o(y.ctor,y.staticArguments.concat($),m)):(m=h.traceCreation(this.l,y),E=this.o(y,$,m)),m.stop(),E}o(y,$=[],m){const E=I._util.getServiceDependencies(y).sort((r,i)=>r.index-i.index),k=[];for(const r of E){const i=this.s(r.id,m);i||this.y(`[createInstance] ${y.name} depends on UNKNOWN service ${r.id}.`,!1),k.push(i)}const t=E.length>0?E[0].index:$.length;if($.length!==t){console.trace(`[createInstance] First service dependency of ${y.name} at position ${t+1} conflicts with ${$.length} static arguments`);const r=t-$.length;r>0?$=$.concat(new Array(r)):$=$.slice(0,t)}return Reflect.construct(y,$.concat(k))}q(y,$){if(this.i.get(y)instanceof D.$Ci)this.i.set(y,$);else if(this.k)this.k.q(y,$);else throw new Error("illegalState - setting UNKNOWN service instance")}r(y){const $=this.i.get(y);return!$&&this.k?this.k.r(y):$}s(y,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(y));const m=this.r(y);return m instanceof D.$Ci?this.u(y,m,$.branch(y,!0)):($.branch(y,!1),m)}u(y,$,m){if(this.t.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this.t.add(y);try{return this.v(y,$,m)}finally{this.t.delete(y)}}v(y,$,m){const E=new A.$sr(r=>r.id.toString());let k=0;const t=[{id:y,desc:$,_trace:m}];for(;t.length;){const r=t.pop();if(E.lookupOrInsertNode(r),k++>1e3)throw new d(E);for(const i of I._util.getServiceDependencies(r.desc.ctor)){const c=this.r(i.id);if(c||this.y(`[createInstance] ${y} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(i.id)),c instanceof D.$Ci){const s={id:i.id,desc:c,_trace:r._trace.branch(i.id,!0)};E.insertEdge(r,s),t.push(s)}}}for(;;){const r=E.roots();if(r.length===0){if(!E.isEmpty())throw new d(E);break}for(const{data:i}of r){if(this.r(i.id)instanceof D.$Ci){const s=this.w(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.q(i.id,s)}E.removeNode(i)}}return this.r(y)}w(y,$,m=[],E,k){if(this.i.get(y)instanceof D.$Ci)return this.x(y,$,m,E,k,this.g);if(this.k)return this.k.w(y,$,m,E,k);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}x(y,$,m=[],E,k,t){if(E){const r=new g(void 0,this.j,this,this.l);r.c=String(y);const i=new Map,c=new n.$Yh(()=>{const s=r.o($,m,k);for(const[u,l]of i){const S=s[u];if(typeof S=="function")for(const v of l)v.disposable=S.apply(s,v.listener)}return i.clear(),t.add(s),s});return new Proxy(Object.create(null),{get(s,u){if(!c.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let v=i.get(u);return v||(v=new a.$7c,i.set(u,v)),(T,L,O)=>{if(c.isInitialized)return c.value[u](T,L,O);{const F={listener:[T,L,O],disposable:void 0},B=v.push(F);return(0,P.$Uc)(()=>{B(),F.disposable?.dispose()})}}}if(u in s)return s[u];const l=c.value;let S=l[u];return typeof S!="function"||(S=S.bind(l),s[u]=S),S},set(s,u,l){return c.value[u]=l,!0},getPrototypeOf(s){return $.prototype}})}else{const r=this.o($,m,k);return t.add(r),r}}y(y,$){if($&&console.warn(y),this.j)throw new Error(y)}}e.$tr=g;var w;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(w||(w={}));class h{static{this.all=new Set}static{this.c=new class extends h{constructor(){super(w.None,null)}stop(){}branch(){return this}}}static traceInvocation(y,$){return y?new h(w.Invocation,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(y,$){return y?new h(w.Creation,$.name):h.c}static{this.f=0}constructor(y,$){this.type=y,this.name=$,this.g=Date.now(),this.h=[]}branch(y,$){const m=new h(w.Branch,y.toString());return this.h.push([y,$,m]),m}stop(){const y=Date.now()-this.g;h.f+=y;let $=!1;function m(k,t){const r=[],i=new Array(k+1).join("	");for(const[c,s,u]of t.h)if(s&&u){$=!0,r.push(`${i}CREATES -> ${c}`);const l=m(k+1,u);l&&r.push(l)}else r.push(`${i}uses -> ${c}`);return r.join(`
`)}const E=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(y>2||$)&&h.all.add(E.join(`
`))}}e.$ur=h}),define(oe[224],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f_b=e.$e_b=e.IssueSource=e.IssueType=void 0;var o;(function(D){D[D.Bug=0]="Bug",D[D.PerformanceIssue=1]="PerformanceIssue",D[D.FeatureRequest=2]="FeatureRequest"})(o||(e.IssueType=o={}));var P;(function(D){D.VSCode="vscode",D.Extension="extension",D.Marketplace="marketplace"})(P||(e.IssueSource=P={})),e.$e_b=(0,n.$Fi)("issueService"),e.$f_b=(0,n.$Fi)("processService")}),define(oe[5],ae([0,1,187,55,4,46,2,32,3,19,13,7,123,6]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=p,e.log=$,e.$nk=S,e.$ok=v,e.$pk=R,e.$qk=T,n=De(n),e.$_j=(0,w.$Fi)("logService"),e.$ak=(0,w.$Fi)("loggerService");function h(){return new Date().toISOString()}function p(L){return(0,f.$jg)(L)}var y;(function(L){L[L.Off=0]="Off",L[L.Trace=1]="Trace",L[L.Debug=2]="Debug",L[L.Info=3]="Info",L[L.Warning=4]="Warning",L[L.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$ck=y.Info;function $(L,O,F){switch(O){case y.Trace:L.trace(F);break;case y.Debug:L.debug(F);break;case y.Info:L.info(F);break;case y.Warning:L.warn(F);break;case y.Error:L.error(F);break;case y.Off:break;default:throw new Error(`Invalid log level ${O}`)}}function m(L,O=!1){let F="";for(let B=0;B<L.length;B++){let C=L[B];if(C instanceof Error&&(C=(0,o.$qj)(C,O)),typeof C=="object")try{C=JSON.stringify(C)}catch{}F+=(B>0?" ":"")+C}return F}class E extends A.$Wc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new P.$me),this.onDidChangeLogLevel=this.c.event}setLevel(O){this.b!==O&&(this.b=O,this.c.fire(this.b))}getLevel(){return this.b}f(O){return this.b!==y.Off&&this.b<=O}}e.$ek=E;class k extends E{constructor(O){super(),this.h=O}f(O){return this.h||super.f(O)}trace(O,...F){this.f(y.Trace)&&this.g(y.Trace,m([O,...F],!0))}debug(O,...F){this.f(y.Debug)&&this.g(y.Debug,m([O,...F]))}info(O,...F){this.f(y.Info)&&this.g(y.Info,m([O,...F]))}warn(O,...F){this.f(y.Warning)&&this.g(y.Warning,m([O,...F]))}error(O,...F){if(this.f(y.Error))if(O instanceof Error){const B=Array.prototype.slice.call(arguments);B[0]=O.stack,this.g(y.Error,m(B))}else this.g(y.Error,m([O,...F]))}flush(){}}e.$fk=k;class t extends E{constructor(O=e.$ck){super(),this.setLevel(O),this.g=!b.$i}trace(O,...F){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,O,...F):console.log(`[main ${h()}]`,O,...F))}debug(O,...F){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,O,...F):console.log(`[main ${h()}]`,O,...F))}info(O,...F){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,O,...F):console.log(`[main ${h()}]`,O,...F))}warn(O,...F){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,O,...F):console.warn(`[main ${h()}]`,O,...F))}error(O,...F){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,O,...F):console.error(`[main ${h()}]`,O,...F))}flush(){}}e.$gk=t;class r extends E{constructor(O=e.$ck,F=!0){super(),this.g=F,this.setLevel(O)}trace(O,...F){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",O,...F):console.log(O,...F))}debug(O,...F){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",O,...F):console.log(O,...F))}info(O,...F){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",O,...F):console.log(O,...F))}warn(O,...F){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",O,...F):console.log(O,...F))}error(O,...F){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",O,...F):console.error(O,...F))}flush(){}}e.$hk=r;class i extends E{constructor(O,F=e.$ck){super(),this.g=O,this.setLevel(F)}trace(O,...F){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(O),...F])}debug(O,...F){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(O),...F])}info(O,...F){this.f(y.Info)&&this.g.log(y.Info,[this.h(O),...F])}warn(O,...F){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(O),...F])}error(O,...F){this.f(y.Error)&&this.g.log(y.Error,[this.h(O),...F])}h(O){return typeof O=="string"?O:(0,o.$qj)(O,this.f(y.Trace))}flush(){}}e.$ik=i;class c extends E{constructor(O){super(),this.g=O,O.length&&this.setLevel(O[0].getLevel())}setLevel(O){for(const F of this.g)F.setLevel(O);super.setLevel(O)}trace(O,...F){for(const B of this.g)B.trace(O,...F)}debug(O,...F){for(const B of this.g)B.debug(O,...F)}info(O,...F){for(const B of this.g)B.info(O,...F)}warn(O,...F){for(const B of this.g)B.warn(O,...F)}error(O,...F){for(const B of this.g)B.error(O,...F)}flush(){for(const O of this.g)O.flush()}dispose(){for(const O of this.g)O.dispose();super.dispose()}}e.$jk=c;class s extends A.$Wc{constructor(O,F,B){if(super(),this.h=O,this.j=F,this.b=new I.$Cc,this.c=this.B(new P.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$me),this.onDidChangeVisibility=this.g.event,B)for(const C of B)this.b.set(C.resource,{logger:void 0,info:C})}m(O){return(0,f.$fg)(O)?[...this.b.values()].find(F=>F.info.id===O):this.b.get(O)}getLogger(O){return this.m(O)?.logger}createLogger(O,F){const B=this.n(O),C=(0,f.$fg)(O)?O:F?.id??(0,D.$tj)(B.toString()).toString(16);let z=this.b.get(B)?.logger;const re=F?.logLevel==="always"?y.Trace:F?.logLevel;z||(z=this.s(B,re??this.getLogLevel(B)??this.h,{...F,id:C}));const Q={logger:z,info:{resource:B,id:C,logLevel:re,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(Q.info),this.b.set(B,Q),z}n(O){return(0,f.$fg)(O)?(0,a.$gh)(this.j,`${O}.log`):O}setLogLevel(O,F){if(d.URI.isUri(O)){const B=O,C=F,z=this.b.get(B);z&&C!==z.info.logLevel&&(z.info.logLevel=C===this.h?void 0:C,z.logger?.setLevel(C),this.b.set(z.info.resource,z),this.f.fire([B,C]))}else{this.h=O;for(const[B,C]of this.b.entries())this.b.get(B)?.info.logLevel===void 0&&C.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(O,F){const B=this.m(O);B&&F!==!B.info.hidden&&(B.info.hidden=!F,this.b.set(B.info.resource,B),this.g.fire([B.info.resource,F]))}getLogLevel(O){let F;return O&&(F=this.b.get(O)?.info.logLevel),F??this.h}registerLogger(O){const F=this.b.get(O.resource);F?F.info.hidden!==O.hidden&&this.setVisibility(O.resource,!O.hidden):(this.b.set(O.resource,{info:O,logger:void 0}),this.c.fire({added:[O],removed:[]}))}deregisterLogger(O){const F=this.b.get(O);F&&(F.logger&&F.logger.dispose(),this.b.delete(O),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const O of this.b.values())yield O.info}getRegisteredLogger(O){return this.b.get(O)?.info}dispose(){this.b.forEach(O=>O.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=s;class u{constructor(){this.onDidChangeLogLevel=new P.$me().event}setLevel(O){}getLevel(){return y.Info}trace(O,...F){}debug(O,...F){}info(O,...F){}warn(O,...F){}error(O,...F){}critical(O,...F){}dispose(){}flush(){}}e.$lk=u;class l extends u{}e.$mk=l;function S(L){if(L.verbose)return y.Trace;if(typeof L.logLevel=="string"){const O=T(L.logLevel.toLowerCase());if(O!==void 0)return O}return e.$ck}function v(L){switch(L){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}function R(L){switch(L){case y.Trace:return{original:"Trace",value:n.localize(0,null)};case y.Debug:return{original:"Debug",value:n.localize(1,null)};case y.Info:return{original:"Info",value:n.localize(2,null)};case y.Warning:return{original:"Warning",value:n.localize(3,null)};case y.Error:return{original:"Error",value:n.localize(4,null)};case y.Off:return{original:"Off",value:n.localize(5,null)}}}function T(L){switch(L){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$rk=new g.$Wj("logLevel",v(y.Info))});var ne=this&&this.__param||function(x,e){return function(n,o){e(n,o,x)}};define(oe[225],ae([0,1,14,3,98,5]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=void 0;const A=n.safeStorage;let I=class{constructor(a){this.a=a,n.app.commandLine.getSwitchValue("password-store")===P.PasswordStoreCLIOption.basic&&A.setUsePlainTextEncryption?.(!0)}async encrypt(a){this.a.trace("[EncryptionMainService] Encrypting value.");try{const f=JSON.stringify(A.encryptString(a));return this.a.trace("[EncryptionMainService] Encrypted value."),f}catch(f){throw this.a.error(f),f}}async decrypt(a){let f;try{if(f=JSON.parse(a),!f.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${a}`);const d=Buffer.from(f.data);this.a.trace("[EncryptionMainService] Decrypting value.");const g=A.decryptString(d);return this.a.trace("[EncryptionMainService] Decrypted value."),g}catch(d){throw this.a.error(d),d}}isEncryptionAvailable(){return Promise.resolve(A.isEncryptionAvailable())}getKeyStorageProvider(){if(o.$i)return Promise.resolve(P.KnownStorageProvider.dplib);if(o.$j)return Promise.resolve(P.KnownStorageProvider.keychainAccess);if(A.getSelectedStorageBackend)try{const a=A.getSelectedStorageBackend();return Promise.resolve(a)}catch(a){this.a.error(a)}return Promise.resolve(P.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(o.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(o.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!A.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");A.setUsePlainTextEncryption(!0)}};e.$tfc=I,e.$tfc=I=Pe([ne(0,D.$_j)],I)}),define(oe[226],ae([0,1,22,8,16,4,31,2,10,62,5]),function(x,e,n,o,P,D,A,I,b,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class d extends I.$Wc{constructor(w,h){super(),this.a=w,this.b=h,this.c=this.B(new D.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new D.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new o.$Dh(0)),this.w=[],this.y=this.B(new o.$Dh(0))}watch(w,h){return h.recursive||this.b?.watcher?.forceUniversal?this.n(w,h):this.z(w,h)}n(w,h){const p={path:this.J(w),excludes:h.excludes,includes:h.includes,recursive:h.recursive,filter:h.filter,correlationId:h.correlationId},y=(0,n.$Vb)(this.j,p);return this.r(),(0,I.$Uc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,P.$3)(w))}s(){this.h||(this.h=this.B(this.t(h=>this.c.fire((0,a.$6q)(h)),h=>this.G(h),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const h of this.j)(0,a.$2q)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const h of this.j)(0,a.$2q)(h)&&w.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,h){const p={path:this.J(w),excludes:h.excludes,includes:h.includes,recursive:!1,filter:h.filter,correlationId:h.correlationId},y=(0,n.$Vb)(this.w,p);return this.C(),(0,I.$Uc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,P.$3)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,a.$6q)(w)),w=>this.G(w),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,b.$jc)(w.fsPath)}J(w){const h=this.I(w);return(0,A.$Hg)(h)}}e.$_q=d}),define(oe[227],ae([0,1,22,8,17,23,4,46,78,2,61,12,71,19,68,180,15,125,5,16]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m,E){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;let t=class extends a.$Wc{static{k=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new A.$me),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$me),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$me),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$me),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$me),this.Y=this.B(new A.$me),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$me),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new o.$Oh)}registerProvider(i,c){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${i}`);const s=new a.$Vc;return this.h.set(i,c),this.c.fire({added:!0,scheme:i,provider:c}),s.add(c.onDidChangeFile(u=>{const l=new y.$sl(u,!this.S(c));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof c.onDidWatchError=="function"&&s.add(c.onDidWatchError(u=>this.Z.fire(new Error(u)))),s.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:i}))),(0,a.$Uc)(()=>{this.c.fire({added:!1,scheme:i,provider:c}),this.h.delete(i),(0,a.$Rc)(s)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const c=[];this.f.fire({scheme:i,join(s){c.push(s)}}),!this.h.has(i)&&await o.Promises.settled(c)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,c){const s=this.h.get(i.scheme);return!!(s&&s.capabilities&c)}listCapabilities(){return b.Iterable.map(this.h,([i,c])=>({scheme:i,capabilities:c.capabilities}))}async j(i){if(!(0,w.$kh)(i))throw new y.$ul((0,p.localize)(0,null,this.sb(i)),y.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const c=this.h.get(i.scheme);if(!c){const s=new E.$db;throw s.message=(0,p.localize)(1,null,i.toString()),s}return c}async m(i){const c=await this.j(i);if((0,y.$fl)(c)||(0,y.$cl)(c)||(0,y.$gl)(c))return c;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const c=await this.j(i);if((0,y.$fl)(c)||(0,y.$cl)(c))return c;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,c){try{return await this.s(i,c)}catch(s){throw(0,y.$pl)(s)===y.FileSystemProviderErrorCode.FileNotFound?new y.$ul((0,p.localize)(2,null,this.sb(i)),y.FileOperationResult.FILE_NOT_FOUND):(0,y.$nl)(s)}}async s(i,c){const s=await this.j(i),u=this.S(s),l=c?.resolveTo,S=c?.resolveSingleChildDescendants,v=c?.resolveMetadata,R=await s.stat(i);let T;return this.t(s,i,R,void 0,!!v,(L,O)=>(T||(T=f.$Li.forUris(()=>!u),T.set(i,!0),l&&T.fill(!0,l)),T.get(L.resource)||T.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&S?O===1:!1))}async t(i,c,s,u,l,S){const{providerExtUri:v}=this.R(i),R={resource:c,name:v.basename(c),isFile:(s.type&y.FileType.File)!==0,isDirectory:(s.type&y.FileType.Directory)!==0,isSymbolicLink:(s.type&y.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&y.FilePermission.Readonly)||!!(i.capabilities&y.FileSystemProviderCapabilities.Readonly),locked:!!((s.permissions??0)&y.FilePermission.Locked),etag:(0,y.$Fl)({mtime:s.mtime,size:s.size}),children:void 0};if(R.isDirectory&&S(R,u)){try{const T=await i.readdir(c),L=await o.Promises.settled(T.map(async([O,F])=>{try{const B=v.joinPath(c,O),C=l?await i.stat(B):{type:F};return await this.t(i,B,C,T.length,l,S)}catch(B){return this.b.trace(B),null}}));R.children=(0,n.$Jb)(L)}catch(T){this.b.trace(T),R.children=[]}return R}return R}async resolveAll(i){return o.Promises.settled(i.map(async c=>{try{return{stat:await this.s(c.resource,c.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(i){const c=await this.j(i),s=await c.stat(i);return this.t(c,i,s,void 0,!0,()=>!1)}async exists(i){const c=await this.j(i);try{return!!await c.stat(i)}catch{return!1}}async canCreateFile(i,c){try{await this.u(i,c)}catch(s){return s}return!0}async u(i,c){if(!c?.overwrite&&await this.exists(i))throw new y.$ul((0,p.localize)(3,null,this.sb(i)),y.FileOperationResult.FILE_MODIFIED_SINCE,c)}async createFile(i,c=P.$Oe.fromString(""),s){await this.u(i,s);const u=await this.writeFile(i,c);return this.r.fire(new y.$rl(i,y.FileOperation.CREATE,u)),u}async writeFile(i,c,s){const u=this.qb(await this.n(i),i),{providerExtUri:l}=this.R(u);let S=s;if((0,y.$il)(u)&&!S?.atomic){const v=u.enforceAtomicWriteFile?.(i);v&&(S={...s,atomic:v})}try{await this.w(u,i,S)||await this.U(u,l.dirname(i));let R;if((0,y.$cl)(u)&&!(c instanceof P.$Oe))if((0,h.$Ae)(c)){const T=await(0,h.$He)(c,3);T.ended?R=P.$Oe.concat(T.buffer):R=T}else R=(0,h.$Ee)(c,T=>P.$Oe.concat(T),3);else R=c;!(0,y.$fl)(u)||(0,y.$cl)(u)&&R instanceof P.$Oe||(0,y.$cl)(u)&&(0,y.$il)(u)&&S?.atomic?await this.hb(u,i,S,R):await this.db(u,i,S,R instanceof P.$Oe?(0,P.$Ze)(R):R),this.r.fire(new y.$rl(i,y.FileOperation.WRITE))}catch(v){throw new y.$ul((0,p.localize)(4,null,this.sb(i),(0,y.$nl)(v).toString()),(0,y.$ql)(v),S)}return this.resolve(i,{resolveMetadata:!0})}async w(i,c,s){const u=!!s?.unlock;if(u&&!(i.capabilities&y.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,p.localize)(5,null,this.sb(c)));if(!!s?.atomic){if(!(i.capabilities&y.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,p.localize)(6,null,this.sb(c)));if(!(i.capabilities&y.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,p.localize)(7,null,this.sb(c)));if(u)throw new Error((0,p.localize)(8,null,this.sb(c)))}let S;try{S=await i.stat(c)}catch{return}if(S.type&y.FileType.Directory)throw new y.$ul((0,p.localize)(9,null,this.sb(c)),y.FileOperationResult.FILE_IS_DIRECTORY,s);if(this.rb(c,S),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==y.$El&&typeof S.mtime=="number"&&typeof S.size=="number"&&s.mtime<S.mtime&&s.etag!==(0,y.$Fl)({mtime:s.mtime,size:S.size}))throw new y.$ul((0,p.localize)(10,null),y.FileOperationResult.FILE_MODIFIED_SINCE,s);return S}async readFile(i,c,s){const u=await this.m(i);return c?.atomic?this.z(u,i,c,s):this.C(u,i,c,s)}async z(i,c,s,u){return new Promise((l,S)=>{this.cb.queueFor(c,async()=>{try{const v=await this.C(i,c,s,u);l(v)}catch(v){S(v)}},this.R(i).providerExtUri)})}async C(i,c,s,u){const l=await this.D(i,c,{...s,preferUnbuffered:!0},u);return{...l,value:await(0,P.$1e)(l.value)}}async readFileStream(i,c,s){const u=await this.m(i);return this.D(u,i,c,s)}async D(i,c,s,u){const l=new D.$xe(u);let S=s;(0,y.$hl)(i)&&i.enforceAtomicReadFile?.(c)&&(S={...s,atomic:!0});const v=this.J(c,S).then(T=>T,T=>{throw l.dispose(!0),T});let R;try{return typeof S?.etag=="string"&&S.etag!==y.$El&&await v,S?.atomic&&(0,y.$hl)(i)||!((0,y.$fl)(i)||(0,y.$gl)(i))||(0,y.$cl)(i)&&S?.preferUnbuffered?R=this.I(i,c,S):(0,y.$gl)(i)?R=this.G(i,c,l.token,S):R=this.H(i,c,l.token,S),R.on("end",()=>l.dispose()),R.on("error",()=>l.dispose()),{...await v,value:R}}catch(T){throw R&&await(0,h.$Fe)(R),this.F(T,c,S)}}F(i,c,s){const u=(0,p.localize)(11,null,this.sb(c),(0,y.$nl)(i).toString());return i instanceof y.$wl?new y.$wl(u,i.stat,s):i instanceof y.$vl?new y.$vl(u,i.fileOperationResult,i.size,i.options):new y.$ul(u,(0,y.$ql)(i),s)}G(i,c,s,u=Object.create(null)){const l=i.readFileStream(c,u,s);return(0,h.$Le)(l,{data:S=>S instanceof P.$Oe?S:P.$Oe.wrap(S),error:S=>this.F(S,c,u)},S=>P.$Oe.concat(S))}H(i,c,s,u=Object.create(null)){const l=(0,P.$5e)();return(0,$.$Yq)(i,c,l,S=>S,{...u,bufferSize:this.a,errorTransformer:S=>this.F(S,c,u)},s),l}I(i,c,s){const u=(0,h.$Ce)(l=>P.$Oe.concat(l));return(async()=>{try{let l;s?.atomic&&(0,y.$hl)(i)?l=await i.readFile(c,{atomic:!0}):l=await i.readFile(c),typeof s?.position=="number"&&(l=l.slice(s.position)),typeof s?.length=="number"&&(l=l.slice(0,s.length)),this.L(c,l.byteLength,s),u.end(P.$Oe.wrap(l))}catch(l){u.error(l),u.end()}})(),u}async J(i,c){const s=await this.resolve(i,{resolveMetadata:!0});if(s.isDirectory)throw new y.$ul((0,p.localize)(12,null,this.sb(i)),y.FileOperationResult.FILE_IS_DIRECTORY,c);if(typeof c?.etag=="string"&&c.etag!==y.$El&&c.etag===s.etag)throw new y.$wl((0,p.localize)(13,null),s,c);return this.L(i,s.size,c),s}L(i,c,s){if(typeof s?.limits?.size=="number"&&c>s.limits.size)throw new y.$vl((0,p.localize)(14,null,this.sb(i)),y.FileOperationResult.FILE_TOO_LARGE,c,s)}async canMove(i,c,s){return this.M(i,c,"move",s)}async canCopy(i,c,s){return this.M(i,c,"copy",s)}async M(i,c,s,u){if(i.toString()!==c.toString())try{const l=s==="move"?this.qb(await this.n(i),i):await this.m(i),S=this.qb(await this.n(c),c);await this.Q(l,i,S,c,s,u)}catch(l){return l}return!0}async move(i,c,s){const u=this.qb(await this.n(i),i),l=this.qb(await this.n(c),c),S=await this.N(u,i,l,c,"move",!!s),v=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new y.$rl(i,S==="move"?y.FileOperation.MOVE:y.FileOperation.COPY,v)),v}async copy(i,c,s){const u=await this.m(i),l=this.qb(await this.n(c),c),S=await this.N(u,i,l,c,"copy",!!s),v=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new y.$rl(i,S==="copy"?y.FileOperation.COPY:y.FileOperation.MOVE,v)),v}async N(i,c,s,u,l,S){if(c.toString()===u.toString())return l;const{exists:v,isSameResourceWithDifferentPathCase:R}=await this.Q(i,c,s,u,l,S);if(v&&!R&&S&&await this.del(u,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(u)),l==="copy"){if(i===s&&(0,y.$dl)(i))await i.copy(c,u,{overwrite:S});else{const T=await this.resolve(c);T.isDirectory?await this.P(i,T,s,u):await this.O(i,c,s,u)}return l}else return i===s?(await i.rename(c,u,{overwrite:S}),l):(await this.N(i,c,s,u,"copy",S),await this.del(c,{recursive:!0}),"copy")}async O(i,c,s,u){if((0,y.$fl)(i)&&(0,y.$fl)(s))return this.jb(i,c,s,u);if((0,y.$fl)(i)&&(0,y.$cl)(s))return this.pb(i,c,s,u);if((0,y.$cl)(i)&&(0,y.$fl)(s))return this.nb(i,c,s,u);if((0,y.$cl)(i)&&(0,y.$cl)(s))return this.lb(i,c,s,u)}async P(i,c,s,u){await s.mkdir(u),Array.isArray(c.children)&&await o.Promises.settled(c.children.map(async l=>{const S=this.R(s).providerExtUri.joinPath(u,l.name);return l.isDirectory?this.P(i,await this.resolve(l.resource),s,S):this.O(i,l.resource,s,S)}))}async Q(i,c,s,u,l,S){let v=!1;if(i===s){const{providerExtUri:T,isPathCaseSensitive:L}=this.R(i);if(L||(v=T.isEqual(c,u)),v&&l==="copy")throw new Error((0,p.localize)(15,null,this.sb(c),this.sb(u)));if(!v&&T.isEqualOrParent(u,c))throw new Error((0,p.localize)(16,null,this.sb(c),this.sb(u)))}const R=await this.exists(u);if(R&&!v){if(!S)throw new y.$ul((0,p.localize)(17,null,this.sb(c),this.sb(u)),y.FileOperationResult.FILE_MOVE_CONFLICT);if(i===s){const{providerExtUri:T}=this.R(i);if(T.isEqualOrParent(c,u))throw new Error((0,p.localize)(18,null,this.sb(c),this.sb(u)))}}return{exists:R,isSameResourceWithDifferentPathCase:v}}R(i){const c=this.S(i);return{providerExtUri:c?w.$9g:w.$$g,isPathCaseSensitive:c}}S(i){return!!(i.capabilities&y.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const c=this.qb(await this.j(i),i);await this.U(c,i);const s=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new y.$rl(i,y.FileOperation.CREATE,s)),s}async U(i,c){const s=[],{providerExtUri:u}=this.R(i);for(;!u.isEqual(c,u.dirname(c));)try{if(!((await i.stat(c)).type&y.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(c)));break}catch(l){if((0,y.$pl)(l)!==y.FileSystemProviderErrorCode.FileNotFound)throw l;s.push(u.basename(c)),c=u.dirname(c)}for(let l=s.length-1;l>=0;l--){c=u.joinPath(c,s[l]);try{await i.mkdir(c)}catch(S){if((0,y.$pl)(S)!==y.FileSystemProviderErrorCode.FileExists)throw S}}}async canDelete(i,c){try{await this.W(i,c)}catch(s){return s}return!0}async W(i,c){const s=this.qb(await this.j(i),i),u=!!c?.useTrash;if(u&&!(s.capabilities&y.FileSystemProviderCapabilities.Trash))throw new Error((0,p.localize)(20,null,this.sb(i)));const l=c?.atomic;if(l&&!(s.capabilities&y.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,p.localize)(21,null,this.sb(i)));if(u&&l)throw new Error((0,p.localize)(22,null,this.sb(i)));let S;try{S=await s.stat(i)}catch{}if(S)this.rb(i,S);else throw new y.$ul((0,p.localize)(23,null,this.sb(i)),y.FileOperationResult.FILE_NOT_FOUND);if(!!!c?.recursive){const R=await this.resolve(i);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(i)))}return s}async del(i,c){const s=await this.W(i,c);let u=c;if((0,y.$jl)(s)&&!u?.atomic){const R=s.enforceAtomicDelete?.(i);R&&(u={...c,atomic:R})}const l=!!u?.useTrash,S=!!u?.recursive,v=u?.atomic??!1;await s.delete(i,{recursive:S,useTrash:l,atomic:v}),this.r.fire(new y.$rl(i,y.FileOperation.DELETE))}async cloneFile(i,c){const s=await this.j(i),u=this.qb(await this.n(c),c);if(!(s===u&&this.R(s).providerExtUri.isEqual(i,c)))return s===u&&(0,y.$el)(s)?s.cloneFile(i,c):(await this.U(u,this.R(u).providerExtUri.dirname(c)),s===u&&(0,y.$dl)(s)?this.cb.queueFor(i,()=>s.copy(i,c,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(i,()=>this.O(s,i,u,c),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(i,c){return this.watch(i,{...c,correlationId:k.ab++})}watch(i,c={recursive:!1,excludes:[]}){const s=new a.$Vc;let u=!1,l=()=>{u=!0};s.add((0,a.$Uc)(()=>l())),(async()=>{try{const v=await this.bb(i,c);u?(0,a.$Rc)(v):l=()=>(0,a.$Rc)(v)}catch(v){this.b.error(v)}})();const S=c.correlationId;if(typeof S=="number"){const v=s.add(new A.$me);return s.add(this.X.event(T=>{T.correlates(S)&&v.fire(T)})),{onDidChange:v.event,dispose:()=>s.dispose()}}return s}async bb(i,c){const s=await this.j(i),u=(0,I.$tj)([this.R(s).providerExtUri.getComparisonKey(i),c]);let l=this.$.get(u);return l||(l={count:0,disposable:s.watch(i,c)},this.$.set(u,l)),l.count+=1,(0,a.$Uc)(()=>{l&&(l.count--,l.count===0&&((0,a.$Rc)(l.disposable),this.$.delete(u)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,a.$Rc)(i.disposable);this.$.clear()}async db(i,c,s,u){return this.cb.queueFor(c,async()=>{const l=await i.open(c,{create:!0,unlock:s?.unlock??!1});try{(0,h.$Ae)(u)||(0,h.$Be)(u)?await this.eb(i,l,u):await this.fb(i,l,u)}catch(S){throw(0,y.$nl)(S)}finally{await i.close(l)}},this.R(i).providerExtUri)}async eb(i,c,s){let u=0,l;if((0,h.$Be)(s)){if(s.buffer.length>0){const S=P.$Oe.concat(s.buffer);await this.gb(i,c,S,S.byteLength,u,0),u+=S.byteLength}if(s.ended)return;l=s.stream}else l=s;return new Promise((S,v)=>{(0,h.$Ge)(l,{onData:async R=>{l.pause();try{await this.gb(i,c,R,R.byteLength,u,0)}catch(T){return v(T)}u+=R.byteLength,setTimeout(()=>l.resume())},onError:R=>v(R),onEnd:()=>S()})})}async fb(i,c,s){let u=0,l;for(;(l=s.read())!==null;)await this.gb(i,c,l,l.byteLength,u,0),u+=l.byteLength}async gb(i,c,s,u,l,S){let v=0;for(;v<u;){const R=await i.write(c,l+v,s.buffer,S+v,u-v);v+=R}}async hb(i,c,s,u){return this.cb.queueFor(c,()=>this.ib(i,c,s,u),this.R(i).providerExtUri)}async ib(i,c,s,u){let l;u instanceof P.$Oe?l=u:(0,h.$Ae)(u)?l=await(0,P.$1e)(u):(0,h.$Be)(u)?l=await(0,P.$2e)(u):l=(0,P.$Ye)(u),await i.writeFile(c,l.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(i,c,s,u){return this.cb.queueFor(u,()=>this.kb(i,c,s,u),this.R(s).providerExtUri)}async kb(i,c,s,u){let l,S;try{l=await i.open(c,{create:!1}),S=await s.open(u,{create:!0,unlock:!1});const v=P.$Oe.alloc(this.a);let R=0,T=0,L=0;do L=await i.read(l,R,v.buffer,T,v.byteLength-T),await this.gb(s,S,v,L,R,T),R+=L,T+=L,T===v.byteLength&&(T=0);while(L>0)}catch(v){throw(0,y.$nl)(v)}finally{await o.Promises.settled([typeof l=="number"?i.close(l):Promise.resolve(),typeof S=="number"?s.close(S):Promise.resolve()])}}async lb(i,c,s,u){return this.cb.queueFor(u,()=>this.mb(i,c,s,u),this.R(s).providerExtUri)}async mb(i,c,s,u){return s.writeFile(u,await i.readFile(c),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,c,s,u){return this.cb.queueFor(u,()=>this.ob(i,c,s,u),this.R(s).providerExtUri)}async ob(i,c,s,u){const l=await s.open(u,{create:!0,unlock:!1});try{const S=await i.readFile(c);await this.gb(s,l,P.$Oe.wrap(S),S.byteLength,0,0)}catch(S){throw(0,y.$nl)(S)}finally{await s.close(l)}}async pb(i,c,s,u){const l=await(0,P.$1e)(this.H(i,c,D.CancellationToken.None));await this.hb(s,u,void 0,l)}qb(i,c){if(i.capabilities&y.FileSystemProviderCapabilities.Readonly)throw new y.$ul((0,p.localize)(25,null,this.sb(c)),y.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,c){if((c.permissions??0)&y.FilePermission.Readonly)throw new y.$ul((0,p.localize)(26,null,this.sb(i)),y.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===d.Schemas.file?i.fsPath:i.toString(!0)}};e.$Zq=t,e.$Zq=t=k=Pe([ne(0,m.$_j)],t)}),define(oe[100],ae([0,1,8,32,17,4,31,2,10,3,19,68,21,184,15,125,226,222,221]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class E extends y.$_q{static{this.L=!1}constructor(t,r){super(t,r),this.onDidChangeCapabilities=D.Event.None,this.P=new o.$Cc(i=>f.$0g.getComparisonKey(i)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=h.FileSystemProviderCapabilities.FileReadWrite|h.FileSystemProviderCapabilities.FileOpenReadWriteClose|h.FileSystemProviderCapabilities.FileReadStream|h.FileSystemProviderCapabilities.FileFolderCopy|h.FileSystemProviderCapabilities.FileWriteUnlock|h.FileSystemProviderCapabilities.FileAtomicRead|h.FileSystemProviderCapabilities.FileAtomicWrite|h.FileSystemProviderCapabilities.FileAtomicDelete|h.FileSystemProviderCapabilities.FileClone,a.$k&&(this.M|=h.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(t){try{const{stat:r,symbolicLink:i}=await g.SymlinkSupport.stat(this.I(t));return{type:this.O(r,i),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:h.FilePermission.Locked}}catch(r){throw this.hb(r)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const r=await g.Promises.readdir(this.I(t),{withFileTypes:!0}),i=[];return await Promise.all(r.map(async c=>{try{let s;c.isSymbolicLink()?s=(await this.stat((0,f.$gh)(t,c.name))).type:s=this.O(c),i.push([c.name,s])}catch(s){this.a.trace(s)}})),i}catch(r){throw this.hb(r)}}O(t,r){let i;return r?.dangling?i=h.FileType.Unknown:t.isFile()?i=h.FileType.File:t.isDirectory()?i=h.FileType.Directory:i=h.FileType.Unknown,r&&(i|=h.FileType.SymbolicLink),i}async Q(t){const r=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let i;for(;i=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await i.wait();const c=new n.$Eh;return this.P.set(t,c),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,I.$Uc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.P.get(t)===c&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(t,r){let i;try{r?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),i=await this.Q(t));const c=this.I(t);return await g.Promises.readFile(c)}catch(c){throw this.hb(c)}finally{i?.dispose()}}R(t){E.L&&this.a.trace(t)}readFileStream(t,r,i){const c=(0,d.$Ce)(s=>P.$Oe.concat(s.map(u=>P.$Oe.wrap(u))).buffer);return(0,p.$Yq)(this,t,c,s=>s.buffer,{...r,bufferSize:256*1024},i),c}async writeFile(t,r,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.S(t)?this.U(t,(0,f.$gh)((0,f.$fh)(t),`${(0,f.$dh)(t)}${i.atomic.postfix}`),r,i):this.W(t,r,i)}async S(t){try{const r=this.I(t),{symbolicLink:i}=await g.SymlinkSupport.stat(r);if(i)return!1}catch{}return!0}async U(t,r,i,c){const s=new I.$Vc;try{s.add(await this.Q(t)),s.add(await this.Q(r)),await this.W(r,i,c,!0);try{await this.rename(r,t,{overwrite:!0})}catch(u){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw u}}finally{s.dispose()}}async W(t,r,i,c){let s;try{const u=this.I(t);if(!i.create||!i.overwrite){if(await g.Promises.exists(u)){if(!i.overwrite)throw(0,h.$ml)((0,w.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,h.$ml)((0,w.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(t,{create:!0,unlock:i.unlock},c),await this.write(s,0,r,0,r.byteLength)}catch(u){throw await this.ib(t,u)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(t){E.$=t}async open(t,r,i){const c=this.I(t);let s;(0,h.$al)(r)&&!i&&(s=await this.Q(t));let u;try{if((0,h.$al)(r)&&r.unlock)try{const{stat:S}=await g.SymlinkSupport.stat(c);S.mode&128||await g.Promises.chmod(c,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}let l;if((0,h.$al)(r)){if(a.$i)try{await g.Promises.truncate(c,0),l="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}l||(l="w")}else l="r";u=await g.Promises.open(c,l)}catch(l){throw s?.dispose(),(0,h.$al)(r)?await this.ib(t,l):this.hb(l)}if(this.X.set(u,0),(0,h.$al)(r)&&this.Z.set(u,t),s){const l=this.Y.get(u);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${c})`),this.Y.set(u,s),l&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${c})`),l.dispose())}return u}async close(t){const r=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&E.$)try{await g.Promises.fdatasync(t)}catch(i){E.configureFlushOnWrite(!1),this.a.error(i)}return await g.Promises.close(t)}catch(i){throw this.hb(i)}finally{r&&(this.Y.get(t)===r&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,i,c,s){const u=this.ab(t,r);let l=null;try{l=(await g.Promises.read(t,i,c,s,u)).bytesRead}catch(S){throw this.hb(S)}finally{this.bb(t,u,l)}return l}ab(t,r){return r===this.X.get(t)?null:r}bb(t,r,i){const c=this.X.get(t);typeof c=="number"&&(typeof r=="number"||(typeof i=="number"?this.X.set(t,c+i):this.X.delete(t)))}async write(t,r,i,c,s){return(0,n.$Zh)(()=>this.cb(t,r,i,c,s),100,3)}async cb(t,r,i,c,s){const u=this.ab(t,r);let l=null;try{l=(await g.Promises.write(t,i,c,s,u)).bytesWritten}catch(S){throw await this.ib(this.Z.get(t),S)}finally{this.bb(t,u,l)}return l}async mkdir(t){try{await g.Promises.mkdir(this.I(t))}catch(r){throw this.hb(r)}}async delete(t,r){try{const i=this.I(t);if(r.recursive){let c;r?.atomic!==!1&&r.atomic.postfix&&(c=(0,b.$lc)((0,b.$oc)(i),`${(0,b.$pc)(i)}${r.atomic.postfix}`)),await g.Promises.rm(i,g.RimRafMode.MOVE,c)}else try{await g.Promises.unlink(i)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let s=!1;try{const{stat:u,symbolicLink:l}=await g.SymlinkSupport.stat(i);s=u.isDirectory()&&!l}catch{}if(s)await g.Promises.rmdir(i);else throw c}else throw c}}catch(i){throw this.hb(i)}}async rename(t,r,i){const c=this.I(t),s=this.I(r);if(c!==s)try{await this.db(t,r,"move",i.overwrite),await g.Promises.rename(c,s)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,w.localize)(2,null,(0,b.$pc)(c),(0,b.$pc)((0,b.$oc)(s)),u.toString()))),this.hb(u)}}async copy(t,r,i){const c=this.I(t),s=this.I(r);if(c!==s)try{await this.db(t,r,"copy",i.overwrite),await g.Promises.copy(c,s,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,w.localize)(3,null,(0,b.$pc)(c),(0,b.$pc)((0,b.$oc)(s)),u.toString()))),this.hb(u)}}async db(t,r,i,c){const s=this.I(t),u=this.I(r);let l=!1;if(!!(this.capabilities&h.FileSystemProviderCapabilities.PathCaseSensitive)||(l=(0,A.$Dg)(s,u,!0)),l){if(i==="copy")throw(0,h.$ml)((0,w.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const v=await this.N(t);if(!v)throw(0,h.$ml)((0,w.localize)(5,null),h.FileSystemProviderErrorCode.FileNotFound);const R=await this.N(r);if(R){if(!c)throw(0,h.$ml)((0,w.localize)(6,null),h.FileSystemProviderErrorCode.FileExists);v.type&h.FileType.File&&R.type&h.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,r){return this.eb(t,r,!1)}async eb(t,r,i){const c=this.I(t),s=this.I(r),u=!!(this.capabilities&h.FileSystemProviderCapabilities.PathCaseSensitive);if((0,A.$Dg)(c,s,!u))return;const l=new I.$Vc;try{l.add(await this.Q(t)),l.add(await this.Q(r)),i&&await g.Promises.mkdir((0,b.$oc)(s),{recursive:!0}),await g.Promises.copyFile(c,s)}catch(S){if(S.code==="ENOENT"&&!i)return this.eb(t,r,!0);throw this.hb(S)}finally{l.dispose()}}t(t,r,i){return new $.$gr(c=>t(c),c=>r(c),i)}F(t,r,i){return new m.$pr(c=>t(c),c=>r(c),i)}hb(t){if(t instanceof h.$ll)return t;let r=t,i;switch(t.code){case"ENOENT":i=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=h.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=h.FileSystemProviderErrorCode.Unknown;break;default:i=h.FileSystemProviderErrorCode.Unknown}return(0,h.$ml)(r,i)}async ib(t,r){let i=this.hb(r);if(t&&i.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await g.SymlinkSupport.stat(this.I(t));c.mode&128||(i=(0,h.$ml)(r,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return i}}e.$qr=E}),define(oe[228],ae([0,1,4,100,2,17,68,23]),function(x,e,n,o,P,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=void 0;class b extends P.$Wc{constructor(d,g){super(),this.a=d,this.b=g,this.F=new Map,this.G=new Map}call(d,g,w){const h=this.c(d);switch(g){case"stat":return this.g(h,w[0]);case"readdir":return this.h(h,w[0]);case"open":return this.r(h,w[0],w[1]);case"close":return this.s(w[0]);case"read":return this.t(w[0],w[1],w[2]);case"readFile":return this.j(h,w[0],w[1]);case"write":return this.u(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.n(h,w[0],w[1],w[2]);case"rename":return this.z(h,w[0],w[1],w[2]);case"copy":return this.C(h,w[0],w[1],w[2]);case"cloneFile":return this.D(h,w[0],w[1]);case"mkdir":return this.w(h,w[0]);case"delete":return this.y(h,w[0],w[1]);case"watch":return this.I(h,w[0],w[1],w[2],w[3]);case"unwatch":return this.J(w[0],w[1])}throw new Error(`IPC Command ${g} not found`)}listen(d,g,w){const h=this.c(d);switch(g){case"fileChange":return this.H(h,w[0]);case"readFileStream":return this.m(h,w[0],w[1])}throw new Error(`Unknown event ${g}`)}g(d,g){const w=this.f(d,g,!0);return this.a.stat(w)}h(d,g){const w=this.f(d,g);return this.a.readdir(w)}async j(d,g,w){const h=this.f(d,g,!0),p=await this.a.readFile(h,w);return D.$Oe.wrap(p)}m(d,g,w){const h=this.f(d,g,!0),p=new I.$xe,y=new n.$me({onDidRemoveLastListener:()=>{p.cancel()}}),$=this.a.readFileStream(h,w,p.token);return(0,A.$Ge)($,{onData:m=>y.fire(D.$Oe.wrap(m)),onError:m=>y.fire(m),onEnd:()=>{y.fire("end"),y.dispose(),p.dispose()}}),y.event}n(d,g,w,h){const p=this.f(d,g);return this.a.writeFile(p,w.buffer,h)}r(d,g,w){const h=this.f(d,g,!0);return this.a.open(h,w)}s(d){return this.a.close(d)}async t(d,g,w){const h=D.$Oe.alloc(w),y=await this.a.read(d,g,h.buffer,0,w);return[h,y]}u(d,g,w,h,p){return this.a.write(d,g,w.buffer,h,p)}w(d,g){const w=this.f(d,g);return this.a.mkdir(w)}y(d,g,w){const h=this.f(d,g);return this.a.delete(h,w)}z(d,g,w,h){const p=this.f(d,g),y=this.f(d,w);return this.a.rename(p,y,h)}C(d,g,w,h){const p=this.f(d,g),y=this.f(d,w);return this.a.copy(p,y,h)}D(d,g,w){const h=this.f(d,g),p=this.f(d,w);return this.a.cloneFile(h,p)}H(d,g){const w=new n.$me({onWillAddFirstListener:()=>{this.F.set(g,this.L(d,w))},onDidRemoveLastListener:()=>{(0,P.$Rc)(this.F.get(g)),this.F.delete(g)}});return w.event}async I(d,g,w,h,p){const y=this.F.get(g);if(y){const $=this.f(d,h),m=y.watch(w,$,p);this.G.set(g+w,m)}}async J(d,g){const w=d+g,h=this.G.get(w);h&&((0,P.$Rc)(h),this.G.delete(w))}dispose(){super.dispose();for(const[,d]of this.G)d.dispose();this.G.clear();for(const[,d]of this.F)d.dispose();this.F.clear()}}e.$1s=b;class a extends P.$Wc{constructor(d,g,w,h){super(),this.c=d,this.f=w,this.g=h,this.a=new Map,this.b=this.B(new o.$qr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(g)}h(d){const g=this.B(new n.$me);this.B(g.event(w=>{d.fire(w.map(h=>({resource:this.c.transformOutgoingURI(h.resource),type:h.type,cId:h.cId})))})),this.B(this.b.onDidChangeFile(w=>g.fire(w))),this.B(this.b.onDidWatchError(w=>d.fire(w)))}j(d){}m(d){}watch(d,g,w){const h=this.m(this.g);return Array.isArray(h)&&(w.excludes=[...w.excludes,...h]),this.a.set(d,this.b.watch(g,w)),(0,P.$Uc)(()=>{(0,P.$Rc)(this.a.get(d)),this.a.delete(d)})}dispose(){for(const[,d]of this.a)d.dispose();this.a.clear(),super.dispose()}}e.$2s=a}),define(oe[229],ae([0,1,14,183,3,7,15,10,228,160,55]),function(x,e,n,o,P,D,A,I,b,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;class d extends b.$1s{constructor(h,p,y){super(h,p),this.M=y}c(h){return a.$Mn}f(h,p){return D.URI.revive(p)}async y(h,p,y){if(!y.useTrash)return super.y(h,p,y);const $=this.f(h,p),m=(0,I.$jc)($.fsPath);try{await n.shell.trashItem(m)}catch(E){throw(0,A.$ml)(P.$i?(0,o.localize)(0,null,(0,I.$pc)(m),(0,f.$qj)(E)):(0,o.localize)(1,null,(0,I.$pc)(m),(0,f.$qj)(E)),A.FileSystemProviderErrorCode.Unknown)}}L(h,p){return new g(h,p,this.b,this.M)}}e.$Bfc=d;class g extends b.$2s{watch(h,p,y){if(y.recursive)throw(0,A.$ml)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(h,p,y)}}}),define(oe[230],ae([0,1,5]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;class o extends n.$fk{constructor(D=n.$ck){super(),this.m=[],this.n=void 0,this.setLevel(D),this.B(this.onDidChangeLogLevel(A=>{this.n?.setLevel(A)}))}set logger(D){this.n=D;for(const{level:A,message:I}of this.m)(0,n.log)(D,A,I);this.m=[]}g(D,A){this.n?(0,n.log)(this.n,D,A):this.getLevel()<=D&&this.m.push({level:D,message:A})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$icc=o}),define(oe[231],ae([0,1,7,4,5,2]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=e.$qs=void 0;class A extends P.$kk{constructor(d,g,w,h,p){super(g,w,h),this.r=d,this.t=p,this.B(p.listen("onDidChangeLogLevel",d)(y=>{(0,P.$bk)(y)?super.setLogLevel(y):super.setLogLevel(n.URI.revive(y[0]),y[1])})),this.B(p.listen("onDidChangeVisibility",d)(([y,$])=>super.setVisibility(n.URI.revive(y),$))),this.B(p.listen("onDidChangeLoggers",d)(({added:y,removed:$})=>{for(const m of y)super.registerLogger({...m,resource:n.URI.revive(m.resource)});for(const m of $)super.deregisterLogger(m.resource)}))}createConsoleMainLogger(){return new P.$ik({log:(d,g)=>{this.t.call("consoleLog",[d,g])}})}registerLogger(d){super.registerLogger(d),this.t.call("registerLogger",[d,this.r])}deregisterLogger(d){super.deregisterLogger(d),this.t.call("deregisterLogger",[d,this.r])}setLogLevel(d,g){super.setLogLevel(d,g),this.t.call("setLogLevel",[d,g])}setVisibility(d,g){super.setVisibility(d,g),this.t.call("setVisibility",[this.n(d),g])}s(d,g,w){return new I(this.t,d,g,w,this.r)}static setLogLevel(d,g,w){return d.call("setLogLevel",[g,w])}}e.$qs=A;class I extends P.$fk{constructor(d,g,w,h,p){super(h?.logLevel==="always"),this.r=d,this.s=g,this.m=!1,this.n=[],this.setLevel(w),this.r.call("createLogger",[g,h,p]).then(()=>{this.u(this.n),this.m=!0})}g(d,g){const w=[[d,g]];this.m?this.u(w):this.n.push(...w)}u(d){this.r.call("log",[this.s,d])}}class b{constructor(d,g){this.a=d,this.b=g}listen(d,g){const w=this.b(d);switch(g){case"onDidChangeLoggers":return o.Event.map(this.a.onDidChangeLoggers,h=>({added:[...h.added].map(p=>this.c(p,w)),removed:[...h.removed].map(p=>this.c(p,w))}));case"onDidChangeVisibility":return o.Event.map(this.a.onDidChangeVisibility,h=>[w.transformOutgoingURI(h[0]),h[1]]);case"onDidChangeLogLevel":return o.Event.map(this.a.onDidChangeLogLevel,h=>(0,P.$bk)(h)?h:[w.transformOutgoingURI(h[0]),h[1]])}throw new Error(`Event not found: ${g}`)}async call(d,g,w){const h=this.b(d);switch(g){case"setLogLevel":return(0,P.$bk)(w[0])?this.a.setLogLevel(w[0]):this.a.setLogLevel(n.URI.revive(h.transformIncoming(w[0][0])),w[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,h)))}throw new Error(`Call not found: ${g}`)}c(d,g){return{...d,resource:g.transformOutgoingURI(d.resource)}}}e.$rs=b;class a extends D.$Wc{constructor(d,g){super(),g.call("setLogLevel",[d.getLogLevel()]),this.B(d.onDidChangeLogLevel(w=>g.call("setLogLevel",[w]))),g.call("getRegisteredLoggers").then(w=>{for(const h of w)d.registerLogger({...h,resource:n.URI.revive(h.resource)})}),this.B(g.listen("onDidChangeVisibility")(([w,h])=>d.setVisibility(n.URI.revive(w),h))),this.B(g.listen("onDidChangeLoggers")(({added:w,removed:h})=>{for(const p of w)d.registerLogger({...p,resource:n.URI.revive(p.resource)});for(const p of h)d.deregisterLogger(p.resource)}))}}e.$ss=a}),define(oe[232],ae([0,1,2,5]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class P extends n.$Wc{constructor(A,I=[]){super(),this.a=new o.$jk([A,...I]),this.B(A.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...I){this.a.trace(A,...I)}debug(A,...I){this.a.debug(A,...I)}info(A,...I){this.a.info(A,...I)}warn(A,...I){this.a.warn(A,...I)}error(A,...I){this.a.error(A,...I)}flush(){this.a.flush()}}e.$oR=P}),define(oe[233],ae([0,1,32,7,5]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;class D{constructor(I){this.b=I,this.a=new n.$Cc}listen(I,b,a){switch(b){case"onDidChangeLoggers":return a?this.b.getOnDidChangeLoggersEvent(a):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.b.getOnDidChangeLogLevelEvent(a):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.b.getOnDidChangeVisibilityEvent(a):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${b}`)}async call(I,b,a){switch(b){case"createLogger":this.c(o.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.e(o.URI.revive(a[0]),a[1]);case"consoleLog":return this.d(a[0],a[1]);case"setLogLevel":return(0,P.$bk)(a[0])?this.b.setLogLevel(a[0]):this.b.setLogLevel(o.URI.revive(a[0]),a[1]);case"setVisibility":return this.b.setVisibility(o.URI.revive(a[0]),a[1]);case"registerLogger":return this.b.registerLogger({...a[0],resource:o.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.b.deregisterLogger(o.URI.revive(a[0]))}throw new Error(`Call not found: ${b}`)}c(I,b,a){this.a.set(I,this.b.createLogger(I,b,a))}d(I,b){let a=console.log;switch(I){case P.LogLevel.Error:a=console.error;break;case P.LogLevel.Warning:a=console.warn;break;case P.LogLevel.Info:a=console.info;break}a.call(console,...b)}e(I,b){const a=this.a.get(I);if(!a)throw new Error("Create the logger before logging");for(const[f,d]of b)(0,P.log)(a,f,d)}}e.$zgc=D}),define(oe[234],ae([0,1,15,5]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=void 0;var P;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(P||(P={}));async function D(a,f,d,g,w){try{const h=await new Promise((y,$)=>{x(["@vscode/spdlog"],y,$)}).then(De);h.setFlushOn(P.Trace);const p=await h.createAsyncRotatingLogger(a,f,d,g);return w?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(h){console.error(h)}return null}function A(a,f,d){switch(f){case o.LogLevel.Trace:a.trace(d);break;case o.LogLevel.Debug:a.debug(d);break;case o.LogLevel.Info:a.info(d);break;case o.LogLevel.Warning:a.warn(d);break;case o.LogLevel.Error:a.error(d);break;case o.LogLevel.Off:break;default:throw new Error(`Invalid log level ${f}`)}}function I(a,f){switch(f){case o.LogLevel.Trace:a.setLevel(P.Trace);break;case o.LogLevel.Debug:a.setLevel(P.Debug);break;case o.LogLevel.Info:a.setLevel(P.Info);break;case o.LogLevel.Warning:a.setLevel(P.Warning);break;case o.LogLevel.Error:a.setLevel(P.Error);break;case o.LogLevel.Off:a.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${f}`)}}class b extends o.$fk{constructor(f,d,g,w,h){super(),this.m=[],this.setLevel(h),this.n=this.s(f,d,g,w),this.B(this.onDidChangeLogLevel(p=>{this.r&&I(this.r,p)}))}async s(f,d,g,w){const h=g?6:1,p=30/h*n.$Hl.MB,y=await D(f,d,p,h,w);if(y){this.r=y,I(this.r,this.getLevel());for(const{level:$,message:m}of this.m)A(this.r,$,m);this.m=[]}}g(f,d){this.r?A(this.r,f,d):this.getLevel()<=f&&this.m.push({level:f,message:d})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$dR=b}),define(oe[235],ae([0,1,33,5,234]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eR=void 0;class D extends o.$kk{s(I,b,a){return new P.$dR((0,n.$2g)(),I.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,b)}}e.$eR=D}),define(oe[72],ae([0,1,32,4,6,5,235]),function(x,e,n,o,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=e.$9ec=void 0,e.$9ec=(0,P.$Gi)(D.$ak);class I extends A.$eR{constructor(){super(...arguments),this.u=new n.$Cc}createLogger(a,f,d){d!==void 0&&this.u.set(this.n(a),d);try{return super.createLogger(a,f)}catch(g){throw this.u.delete(this.n(a)),g}}registerLogger(a,f){f!==void 0&&this.u.set(a.resource,f),super.registerLogger(a)}deregisterLogger(a){this.u.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const f=[];for(const d of super.getRegisteredLoggers())a===this.u.get(d.resource)&&f.push(d);return f}getOnDidChangeLogLevelEvent(a){return o.Event.filter(this.onDidChangeLogLevel,f=>(0,D.$bk)(f)||this.w(f[0],a))}getOnDidChangeVisibilityEvent(a){return o.Event.filter(this.onDidChangeVisibility,([f])=>this.w(f,a))}getOnDidChangeLoggersEvent(a){return o.Event.filter(o.Event.map(this.onDidChangeLoggers,f=>({added:[...f.added].filter(g=>this.w(g.resource,a)),removed:[...f.removed].filter(g=>this.w(g.resource,a))})),f=>f.added.length>0||f.removed.length>0)}deregisterLoggers(a){for(const[f,d]of this.u)d===a&&this.deregisterLogger(f)}w(a,f){const d=this.u.get(a);return d===void 0||d===f}dispose(){super.dispose(),this.u.clear()}}e.$0ec=I}),define(oe[236],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=n,e.$Qfc=o,e.$Rfc=P,e.$Sfc=D;function n(A){return A.submenu!==void 0}function o(A){return A.id==="vscode.menubar.separator"}function P(A){return A.uri!==void 0}function D(A){return!n(A)&&!o(A)&&!P(A)}}),define(oe[40],ae([0,1,4,78,2,6]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=void 0,e.$so=(0,D.$Fi)("policy");class A extends P.$Wc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$me),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const f=Object.keys(this.f).length;return this.f={...a,...this.f},f!==Object.keys(this.f).length&&await this.j(a),o.Iterable.reduce(this.g.entries(),(d,[g,w])=>({...d,[g]:w}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return o.Iterable.reduce(Object.entries(this.f),(a,[f,d])=>({...a,[f]:{definition:d,value:this.g.get(f)}}),{})}}e.$to=A;class I{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$uo=I}),define(oe[237],ae([0,1,8,4,78,13,15,5,40]),function(x,e,n,o,P,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=void 0;function a(d,g){const w=[];for(const h of new Set(P.Iterable.concat(d.keys(),g.keys())))d.get(h)!==g.get(h)&&w.push(h);return w}let f=class extends b.$to{constructor(g,w,h){super(),this.m=g,this.n=w,this.s=h,this.c=this.B(new n.$Dh(500));const p=o.Event.filter(w.onDidFilesChange,y=>y.affects(g));this.B(w.watch(g)),this.B(p(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const g=new Map;try{const w=await this.n.readFile(this.m),h=JSON.parse(w.value.toString());if(!(0,D.$hg)(h))throw new Error("Policy file isn't a JSON object");for(const p of Object.keys(h))this.f[p]&&g.set(p,h[p])}catch(w){w.fileOperationResult!==A.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",w)}return g}async w(){const g=await this.u(),w=a(this.g,g);this.g=g,w.length>0&&this.h.fire(w)}};e.$Sgc=f,e.$Sgc=f=Pe([ne(1,A.$_k),ne(2,I.$_j)],f)}),define(oe[238],ae([0,1,4,2,40]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=e.$ogc=void 0;class D{constructor(b){this.b=b,this.a=new o.$Vc}listen(b,a){switch(a){case"onDidChange":return n.Event.map(this.b.onDidChange,f=>f.reduce((d,g)=>({...d,[g]:this.b.getPolicyValue(g)??null}),{}),this.a)}throw new Error(`Event not found: ${a}`)}call(b,a,f){switch(a){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(f)}throw new Error(`Call not found: ${a}`)}dispose(){this.a.dispose()}}e.$ogc=D;class A extends P.$to{constructor(b,a){super(),this.a=a;for(const f in b){const{definition:d,value:g}=b[f];this.f[f]=d,g!==void 0&&this.g.set(f,g)}this.a.listen("onDidChange")(f=>{for(const d in f){const g=f[d];g===null?this.g.delete(d):this.g.set(d,g)}this.h.fire(Object.keys(f))})}async j(b){const a=await this.a.call("updatePolicyDefinitions",b);for(const f in a)this.g.set(f,a[f])}}e.$pgc=A}),define(oe[239],ae([0,1,40,8,2,5]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgc=void 0;let A=class extends n.$to{constructor(b,a){super(),this.m=b,this.n=a,this.a=new o.$zh,this.b=this.B(new P.$Xc)}async j(b){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(b).length} policy definitions`);const{createWatcher:a}=await new Promise((f,d)=>{x(["@vscode/policy-watcher"],f,d)}).then(De);await this.a.queue(()=>new Promise((f,d)=>{try{this.b.value=a(this.n,b,g=>{this.t(g),f()})}catch(g){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),d(g)}}))}t(b){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(b)}`);for(const a in b){const f=b[a];f===void 0?this.g.delete(a):this.g.set(a,f)}this.h.fire(Object.keys(b))}};e.$Rgc=A,e.$Rgc=A=Pe([ne(0,D.$_j)],A)}),define(oe[73],ae([0,1,37]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let o;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.context<"u"){const D=P.context.configuration();if(D)o=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(o=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`,serverDataFolderName:o.serverDataFolderName?`${o.serverDataFolderName}-dev`:void 0}),!o.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(o,{version:D.version})}}else o={},Object.keys(o).length===0&&Object.assign(o,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=o}),define(oe[28],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,n.$Fi)("productService"),e.$tk="vscode://schemas/vscode-product"}),define(oe[240],ae([0,1,8,5]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;let P=class{constructor(A,I,b){this.a=A,this.b=I,this.c=b}async inspect(A){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$Gh)(A);const b=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),b.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};e.$Efc=P,e.$Efc=P=Pe([ne(2,o.$_j)],P)}),define(oe[74],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0,e.$Rec=(0,n.$Fi)("protocolMainService")}),define(oe[45],ae([0,1,141,13]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,n=De(n),o=De(o);class P{constructor(){this.a=new Map}add(A,I){n.ok(o.$fg(A)),n.ok(o.$hg(I)),n.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,I)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$qo=new P}),define(oe[241],ae([0,1,4,45]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,o=De(o),e.$ro={JSONContribution:"base.contributions.json"};function P(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class D{constructor(){this.b=new n.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,a){this.a[P(b)]=a,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const A=new D;o.$qo.add(e.$ro.JSONContribution,A)}),define(oe[56],ae([0,1,22,4,13,168,18,241,45]),function(x,e,n,o,P,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.ConfigurationScope=e.$vo=e.EditPresentationTypes=void 0,e.$Go=p,e.$Ho=y,e.$Io=$,e.$Jo=E,e.$Ko=k,P=De(P),D=De(D);var a;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$vo={Configuration:"base.contributions.configuration"};var f;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f||(e.ConfigurationScope=f={})),e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co="vscode://schemas/settings/resourceLanguage",e.$Do="vscode://schemas/settings/configurationDefaults";const d=b.$qo.as(I.$ro.JSONContribution);class g{constructor(){this.h=new Set,this.i=new o.$me,this.onDidSchemaChange=this.i.event,this.j=new o.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},d.registerSchema(e.$Co,this.g),this.v()}registerConfiguration(r,i=!0){this.registerConfigurations([r],i)}registerConfigurations(r,i=!0){const c=new Set;this.n(r,i,c),d.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(r){const i=new Set;this.o(r,i),d.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:r,remove:i}){const c=new Set;this.o(i,c),this.n(r,!1,c),d.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(r){const i=new Set;this.k(r,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}k(r,i){const c=[];for(const{overrides:s,source:u}of r)for(const l in s)if(i.add(l),e.$Fo.test(l)){const S=this.a.get(l),v=S?.valuesSources??new Map;if(u)for(const O of Object.keys(s[l]))v.set(O,u);const R={...S?.value||{},...s[l]};this.a.set(l,{source:u,value:R,valuesSources:v});const T=(0,A.$jj)(l),L={type:"object",default:R,description:D.localize(1,null,T),$ref:e.$Co,defaultDefaultValue:R,source:P.$fg(u)?void 0:u,defaultValueSource:u};c.push(...p(l)),this.d[l]=L,this.b.properties[l]=L}else{this.a.set(l,{value:s[l],source:u});const S=this.d[l];S&&(this.w(l,S),this.r(l,S))}this.m(c)}deregisterDefaultConfigurations(r){const i=new Set;this.l(r,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}l(r,i){for(const{overrides:c,source:s}of r)for(const u in c){const l=this.a.get(u),S=P.$fg(s)?s:s?.id,v=P.$fg(l?.source)?l?.source:l?.source?.id;if(S===v)if(i.add(u),this.a.delete(u),e.$Fo.test(u))delete this.d[u],delete this.b.properties[u];else{const R=this.d[u];R&&(this.w(u,R),this.r(u,R))}}this.u()}deltaConfiguration(r){let i=!1;const c=new Set;r.removedDefaults&&(this.l(r.removedDefaults,c),i=!0),r.addedDefaults&&(this.k(r.addedDefaults,c),i=!0),r.removedConfigurations&&this.o(r.removedConfigurations,c),r.addedConfigurations&&this.n(r.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const i of r)this.h.add(i);this.u()}n(r,i,c){r.forEach(s=>{this.p(s,i,s.extensionInfo,s.restrictedProperties,void 0,c),this.c.push(s),this.q(s)})}o(r,i){const c=s=>{if(s.properties)for(const u in s.properties){i.add(u);const l=this.d[u];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[u],this.s(u,s.properties[u])}s.allOf?.forEach(u=>c(u))};for(const s of r){c(s);const u=this.c.indexOf(s);u!==-1&&this.c.splice(u,1)}}p(r,i=!0,c,s,u=f.WINDOW,l){u=P.$og(r.scope)?u:r.scope;const S=r.properties;if(S)for(const R in S){const T=S[R];if(i&&E(R,T)){delete S[R];continue}if(T.source=c,T.defaultDefaultValue=S[R].default,this.w(R,T),e.$Fo.test(R)?T.scope=void 0:(T.scope=P.$og(T.scope)?u:T.scope,T.restricted=P.$og(T.restricted)?!!s?.includes(R):T.restricted),S[R].hasOwnProperty("included")&&!S[R].included){this.f[R]=S[R],delete S[R];continue}else this.d[R]=S[R],S[R].policy?.name&&this.e.set(S[R].policy.name,R);!S[R].deprecationMessage&&S[R].markdownDeprecationMessage&&(S[R].deprecationMessage=S[R].markdownDeprecationMessage),l.add(R)}const v=r.allOf;if(v)for(const R of v)this.p(R,i,c,s,u,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const i=c=>{const s=c.properties;if(s)for(const l in s)this.r(l,s[l]);c.allOf?.forEach(i)};i(r)}r(r,i){switch(e.$wo.properties[r]=i,i.scope){case f.APPLICATION:e.$xo.properties[r]=i;break;case f.MACHINE:e.$yo.properties[r]=i;break;case f.MACHINE_OVERRIDABLE:e.$zo.properties[r]=i;break;case f.WINDOW:e.$Ao.properties[r]=i;break;case f.RESOURCE:e.$Bo.properties[r]=i;break;case f.LANGUAGE_OVERRIDABLE:e.$Bo.properties[r]=i,this.g.properties[r]=i;break}}s(r,i){switch(delete e.$wo.properties[r],i.scope){case f.APPLICATION:delete e.$xo.properties[r];break;case f.MACHINE:delete e.$yo.properties[r];break;case f.MACHINE_OVERRIDABLE:delete e.$zo.properties[r];break;case f.WINDOW:delete e.$Ao.properties[r];break;case f.RESOURCE:case f.LANGUAGE_OVERRIDABLE:delete e.$Bo.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const i=`[${r}]`,c={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.$Co};this.w(i,c),e.$wo.properties[i]=c,e.$xo.properties[i]=c,e.$yo.properties[i]=c,e.$zo.properties[i]=c,e.$Ao.properties[i]=c,e.$Bo.properties[i]=c}}v(){const r={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.$Co};e.$wo.patternProperties[e.$Eo]=r,e.$xo.patternProperties[e.$Eo]=r,e.$yo.patternProperties[e.$Eo]=r,e.$zo.patternProperties[e.$Eo]=r,e.$Ao.patternProperties[e.$Eo]=r,e.$Bo.patternProperties[e.$Eo]=r,this.i.fire()}w(r,i){const c=this.a.get(r);let s=c?.value,u=c?.source;P.$mg(s)&&(s=i.defaultDefaultValue,u=void 0),P.$mg(s)&&(s=$(i.type)),i.default=s,i.defaultValueSource=u}}const w="\\[([^\\]]+)\\]",h=new RegExp(w,"g");e.$Eo=`^(${w})+$`,e.$Fo=new RegExp(e.$Eo);function p(t){const r=[];if(e.$Fo.test(t)){let i=h.exec(t);for(;i?.length;){const c=i[1].trim();c&&r.push(c),i=h.exec(t)}}return(0,n.$Ob)(r)}function y(t){return t.reduce((r,i)=>`${r}[${i}]`,"")}function $(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new g;b.$qo.add(e.$vo.Configuration,m);function E(t,r){return t.trim()?e.$Fo.test(t)?D.localize(7,null,t):m.getConfigurationProperties()[t]!==void 0?D.localize(8,null,t):r.policy?.name&&m.getPolicyConfigurations().get(r.policy?.name)!==void 0?D.localize(9,null,t,r.policy?.name,m.getPolicyConfigurations().get(r.policy?.name)):null:D.localize(6,null)}function k(){const t=[],r=m.getConfigurationProperties();for(const i of Object.keys(r))t.push([i,r[i].scope]);return t.push(["launch",f.RESOURCE]),t.push(["task",f.RESOURCE]),t}}),define(oe[126],ae([0,1,22,4,43,2,32,36,13,7,18,56,15,45]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0,e.$Po=k,n=De(n),P=De(P),I=De(I),b=De(b);function h(c){return Object.isFrozen(c)?c:I.$eo(c)}class p{static createEmptyModel(s){return new p({},[],[],void 0,s)}constructor(s,u,l,S,v){this.b=s,this.c=u,this.d=l,this.raw=S,this.f=v,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(u=>{if(u instanceof p)return u;const l=new y("",this.f);return l.parseRaw(u),l.configurationModel});this.g=s.reduce((u,l)=>l===u?l:u.merge(l),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,f.$hj)(this.contents,s):this.contents}inspect(s,u){const l=this;return{get value(){return h(l.rawConfiguration.getValue(s))},get override(){return u?h(l.rawConfiguration.getOverrideValue(s,u)):void 0},get merged(){return h(u?l.rawConfiguration.override(u).getValue(s):l.rawConfiguration.getValue(s))},get overrides(){const S=[];for(const{contents:v,identifiers:R,keys:T}of l.rawConfiguration.overrides){const L=new p(v,T,[],void 0,l.f).getValue(s);L!==void 0&&S.push({identifiers:R,value:L})}return S.length?h(S):void 0}}}getOverrideValue(s,u){const l=this.j(u);return l?s?(0,f.$hj)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const u=[];for(const l of this.overrides)l.identifiers.includes(s)&&u.push(...l.keys);return n.$Ob(u)}getAllOverrideIdentifiers(){const s=[];for(const u of this.overrides)s.push(...u.identifiers);return n.$Ob(s)}override(s){let u=this.a.get(s);return u||(u=this.h(s),this.a.set(s,u)),u}merge(...s){const u=I.$do(this.contents),l=I.$do(this.overrides),S=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const R of s)if(v.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.i(u,R.contents);for(const T of R.overrides){const[L]=l.filter(O=>n.$wb(O.identifiers,T.identifiers));L?(this.i(L.contents,T.contents),L.keys.push(...T.keys),L.keys=n.$Ob(L.keys)):l.push(I.$do(T))}for(const T of R.keys)S.indexOf(T)===-1&&S.push(T)}return new p(u,S,l,v.every(R=>R instanceof p)?void 0:v,this.f)}h(s){const u=this.j(s);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const l={};for(const S of n.$Ob([...Object.keys(this.contents),...Object.keys(u)])){let v=this.contents[S];const R=u[S];R&&(typeof v=="object"&&typeof R=="object"?(v=I.$do(v),this.i(v,R)):v=R),l[S]=v}return new p(l,this.keys,this.overrides,void 0,this.f)}i(s,u){for(const l of Object.keys(u)){if(l in s&&b.$hg(s[l])&&b.$hg(u[l])){this.i(s[l],u[l]);continue}s[l]=I.$do(u[l])}}j(s){let u=null,l=null;const S=v=>{v&&(l?this.i(l,v):l=I.$do(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===s?u=v.contents:v.identifiers.includes(s)&&S(v.contents);return S(u),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,u){this.k(s,u,!0)}setValue(s,u){this.k(s,u,!1)}removeValue(s){const u=this.keys.indexOf(s);u!==-1&&(this.keys.splice(u,1),(0,f.$gj)(this.contents,s),d.$Fo.test(s)&&this.overrides.splice(this.overrides.findIndex(l=>n.$wb(l.identifiers,(0,d.$Go)(s))),1))}k(s,u,l){(0,f.$fj)(this.contents,s,u,S=>this.f.error(S)),l=l||this.keys.indexOf(s)===-1,l&&this.keys.push(s),d.$Fo.test(s)&&this.overrides.push({identifiers:(0,d.$Go)(s),keys:Object.keys(this.contents[s]),contents:(0,f.$ej)(this.contents[s],S=>this.f.error(S))})}}e.$Lo=p;class y{constructor(s,u){this.f=s,this.g=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||p.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,u){if(!b.$og(s)){const l=this.h(s);this.parseRaw(l,u)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,u){this.a=s;const{contents:l,keys:S,overrides:v,restricted:R,hasExcludedProperties:T}=this.i(s,u);this.b=new p(l,S,v,T?[s]:void 0,this.g),this.c=R||[]}h(s){let u={},l=null,S=[];const v=[],R=[];function T(O){Array.isArray(S)?S.push(O):l!==null&&(S[l]=O)}const L={onObjectBegin:()=>{const O={};T(O),v.push(S),S=O,l=null},onObjectProperty:O=>{l=O},onObjectEnd:()=>{S=v.pop()},onArrayBegin:()=>{const O=[];T(O),v.push(S),S=O,l=null},onArrayEnd:()=>{S=v.pop()},onLiteralValue:T,onError:(O,F,B)=>{R.push({error:O,offset:F,length:B})}};if(s)try{P.$5n(s,L),u=S[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return u}i(s,u){const l=w.$qo.as(d.$vo.Configuration).getConfigurationProperties(),S=this.j(s,l,!0,u);s=S.raw;const v=(0,f.$ej)(s,L=>this.g.error(`Conflict in settings file ${this.f}: ${L}`)),R=Object.keys(s),T=this.l(s,L=>this.g.error(`Conflict in settings file ${this.f}: ${L}`));return{contents:v,keys:R,overrides:T,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(s,u,l,S){let v=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:v};const R={},T=[];for(const L in s)if(d.$Fo.test(L)&&l){const O=this.j(s[L],u,!1,S);R[L]=O.raw,v=v||O.hasExcludedProperties,T.push(...O.restricted)}else{const O=u[L],F=O?typeof O.scope<"u"?O.scope:d.ConfigurationScope.WINDOW:void 0;O?.restricted&&T.push(L),!S.exclude?.includes(L)&&(S.include?.includes(L)||(F===void 0||S.scopes===void 0||S.scopes.includes(F))&&!(S.skipRestricted&&O?.restricted))?R[L]=s[L]:v=!0}return{raw:R,restricted:T,hasExcludedProperties:v}}l(s,u){const l=[];for(const S of Object.keys(s))if(d.$Fo.test(S)){const v={};for(const R in s[S])v[R]=s[S][R];l.push({identifiers:(0,d.$Go)(S),keys:Object.keys(v),contents:(0,f.$ej)(v,u)})}return l}}e.$Mo=y;class $ extends D.$Wc{constructor(s,u,l,S,v){super(),this.c=s,this.f=u,this.g=S,this.h=v,this.b=this.B(new o.$me),this.onDidChange=this.b.event,this.a=new y(this.c.toString(),v),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(o.Event.any(o.Event.filter(this.g.onDidFilesChange,R=>R.contains(this.c)),o.Event.filter(this.g.onDidRunOperation,R=>(R.isOperation(g.FileOperation.CREATE)||R.isOperation(g.FileOperation.COPY)||R.isOperation(g.FileOperation.DELETE)||R.isOperation(g.FileOperation.WRITE))&&l.isEqual(R.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return p.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$No=$;class m{constructor(s,u,l,S,v,R,T,L,O,F,B,C,z){this.a=s,this.b=u,this.c=l,this.overrideIdentifiers=S,this.d=v,this.f=R,this.g=T,this.h=L,this.i=O,this.j=F,this.k=B,this.l=C,this.m=z}get value(){return h(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class E{constructor(s,u,l,S,v,R,T,L,O,F){this.j=s,this.l=u,this.m=l,this.n=S,this.p=v,this.q=R,this.r=T,this.s=L,this.t=O,this.u=F,this.h=null,this.i=new A.$Cc,this.v=null}getValue(s,u,l){return this.w(s,u,l).getValue(s)}updateValue(s,u,l={}){let S;l.resource?(S=this.t.get(l.resource),S||(S=p.createEmptyModel(this.u),this.t.set(l.resource,S))):S=this.s,u===void 0?S.removeValue(s):S.setValue(s,u),l.resource||(this.h=null)}inspect(s,u,l){const S=this.w(s,u,l),v=this.A(u.resource,l),R=u.resource?this.t.get(u.resource)||this.s:this.s,T=new Set;for(const L of S.overrides)for(const O of L.identifiers)S.getOverrideValue(s,O)!==void 0&&T.add(O);return new m(s,u,S.getValue(s),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.q:void 0,v||void 0,R)}keys(s){const u=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,u){this.r.set(s,u),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,u){const l=[];if(!u){const{added:S,updated:v,removed:R}=r(this.j,s);u=[...S,...v,...R]}for(const S of u)for(const v of(0,d.$Go)(S)){const R=this.j.getKeysForOverrideIdentifier(v),T=s.getKeysForOverrideIdentifier(v),L=[...T.filter(O=>R.indexOf(O)===-1),...R.filter(O=>T.indexOf(O)===-1),...R.filter(O=>!I.$ho(this.j.override(v).getValue(O),s.override(v).getValue(O)))];l.push([v,L])}return this.updateDefaultConfiguration(s),{keys:u,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:u,updated:l,removed:S}=r(this.l,s),v=[...u,...l,...S];return v.length&&this.updatePolicyConfiguration(s),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:u,updated:l,removed:S,overrides:v}=r(this.applicationConfiguration,s),R=[...u,...l,...S];return R.length&&this.updateApplicationConfiguration(s),{keys:R,overrides:v}}compareAndUpdateLocalUserConfiguration(s){const{added:u,updated:l,removed:S,overrides:v}=r(this.localUserConfiguration,s),R=[...u,...l,...S];return R.length&&this.updateLocalUserConfiguration(s),{keys:R,overrides:v}}compareAndUpdateRemoteUserConfiguration(s){const{added:u,updated:l,removed:S,overrides:v}=r(this.remoteUserConfiguration,s),R=[...u,...l,...S];return R.length&&this.updateRemoteUserConfiguration(s),{keys:R,overrides:v}}compareAndUpdateWorkspaceConfiguration(s){const{added:u,updated:l,removed:S,overrides:v}=r(this.workspaceConfiguration,s),R=[...u,...l,...S];return R.length&&this.updateWorkspaceConfiguration(s),{keys:R,overrides:v}}compareAndUpdateFolderConfiguration(s,u){const l=this.folderConfigurations.get(s),{added:S,updated:v,removed:R,overrides:T}=r(l,u),L=[...S,...v,...R];return(L.length||!l)&&this.updateFolderConfiguration(s,u),{keys:L,overrides:T}}compareAndDeleteFolderConfiguration(s){const u=this.folderConfigurations.get(s);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:S,removed:v,overrides:R}=r(u,void 0);return{keys:[...l,...S,...v],overrides:R}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,u,l){let S=this.x(u,l);return u.overrideIdentifier&&(S=S.override(u.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(S=S.merge(this.l)),S}x({resource:s},u){let l=this.y();if(u&&s){const S=u.getFolder(s);S&&(l=this.z(S.uri)||l);const v=this.t.get(s);v&&(l=l.merge(v))}return l}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let u=this.i.get(s);if(!u){const l=this.y(),S=this.r.get(s);S?(u=l.merge(S),this.i.set(s,u)):u=l}return u}A(s,u){if(u&&s){const l=u.getFolder(s);if(l)return this.r.get(l.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,u)=>{const{contents:l,overrides:S,keys:v}=this.r.get(u);return s.push([u,{contents:l,overrides:S,keys:v}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(u=>s.add(u)),this.userConfiguration.keys.forEach(u=>s.add(u)),this.q.keys.forEach(u=>s.add(u)),this.r.forEach(u=>u.keys.forEach(l=>s.add(l))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(u=>s.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>s.add(u)),this.q.getAllOverrideIdentifiers().forEach(u=>s.add(u)),this.r.forEach(u=>u.getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}D(s){const u=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(l=>u.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>u.add(l)),this.q.getKeysForOverrideIdentifier(s).forEach(l=>u.add(l)),this.r.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(S=>u.add(S))),[...u.values()]}static parse(s,u){const l=this.E(s.defaults,u),S=this.E(s.policy,u),v=this.E(s.application,u),R=this.E(s.user,u),T=this.E(s.workspace,u),L=s.folders.reduce((O,F)=>(O.set(a.URI.revive(F[0]),this.E(F[1],u)),O),new A.$Cc);return new E(l,S,v,R,p.createEmptyModel(u),T,L,p.createEmptyModel(u),new A.$Cc,u)}static E(s,u){return new p(s.contents,s.keys,s.overrides,void 0,u)}}e.$Oo=E;function k(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const s=new Set,u=new Map;for(const S of c)S.keys.forEach(v=>s.add(v)),S.overrides.forEach(([v,R])=>{const T=(0,A.$zc)(u,v,new Set);R.forEach(L=>T.add(L))});const l=[];return u.forEach((S,v)=>l.push([v,[...S.values()]])),{keys:[...s.values()],overrides:l}}class t{constructor(s,u,l,S,v){this.change=s,this.f=u,this.g=l,this.h=S,this.i=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const R of s.keys)this.affectedKeys.add(R);for(const[,R]of s.overrides)for(const T of R)this.affectedKeys.add(T);this.d=this.a;for(const R of this.affectedKeys)this.d+=R+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=E.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,u){const l=this.a+s,S=this.d.indexOf(l);if(S<0)return!1;const v=S+l.length;if(v>=this.d.length)return!1;const R=this.d.charCodeAt(v);if(R!==this.b&&R!==this.c)return!1;if(u){const T=this.previousConfiguration?this.previousConfiguration.getValue(s,u,this.f?.workspace):void 0,L=this.g.getValue(s,u,this.h);return!I.$ho(T,L)}return!0}}e.$Qo=t;function r(c,s){const{added:u,removed:l,updated:S}=i(s?.rawConfiguration,c?.rawConfiguration),v=[],R=c?.getAllOverrideIdentifiers()||[],T=s?.getAllOverrideIdentifiers()||[];if(s){const L=T.filter(O=>!R.includes(O));for(const O of L)v.push([O,s.getKeysForOverrideIdentifier(O)])}if(c){const L=R.filter(O=>!T.includes(O));for(const O of L)v.push([O,c.getKeysForOverrideIdentifier(O)])}if(s&&c){for(const L of R)if(T.includes(L)){const O=i({contents:c.getOverrideValue(void 0,L)||{},keys:c.getKeysForOverrideIdentifier(L)},{contents:s.getOverrideValue(void 0,L)||{},keys:s.getKeysForOverrideIdentifier(L)});v.push([L,[...O.added,...O.removed,...O.updated]])}}return{added:u,removed:l,updated:S,overrides:v}}function i(c,s){const u=c?s?c.keys.filter(v=>s.keys.indexOf(v)===-1):[...c.keys]:[],l=s?c?s.keys.filter(v=>c.keys.indexOf(v)===-1):[...s.keys]:[],S=[];if(c&&s){for(const v of s.keys)if(c.keys.indexOf(v)!==-1){const R=(0,f.$hj)(s.contents,v),T=(0,f.$hj)(c.contents,v);I.$ho(R,T)||S.push(v)}}return{added:u,removed:l,updated:S}}}),define(oe[242],ae([0,1,22,4,2,36,13,126,56,5,40,45]),function(x,e,n,o,P,D,A,I,b,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.$Ro=void 0;class g extends P.$Wc{get configurationModel(){return this.b}constructor(y){super(),this.c=y,this.a=this.B(new o.$me),this.onDidChangeConfiguration=this.a.event,this.b=I.$Lo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(d.$qo.as(b.$vo.Configuration).onDidUpdateConfiguration(({properties:y,defaultsOverrides:$})=>this.f(Array.from(y),$))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(y,$){this.j(y,d.$qo.as(b.$vo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:y})}g(){return{}}h(){this.b=I.$Lo.createEmptyModel(this.c);const y=d.$qo.as(b.$vo.Configuration).getConfigurationProperties();this.j(Object.keys(y),y)}j(y,$){const m=this.g();for(const E of y){const k=m[E],t=$[E];k!==void 0?this.b.addValue(E,k):t?this.b.addValue(E,t.default):this.b.removeValue(E)}}}e.$Ro=g;class w{constructor(){this.onDidChangeConfiguration=o.Event.None,this.configurationModel=I.$Lo.createEmptyModel(new a.$mk)}async initialize(){return this.configurationModel}}e.$So=w;let h=class extends P.$Wc{get configurationModel(){return this.b}constructor(y,$,m){super(),this.c=y,this.f=$,this.g=m,this.a=this.B(new o.$me),this.onDidChangeConfiguration=this.a.event,this.b=I.$Lo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(y=>this.j(y))),this.B(this.c.onDidChangeConfiguration(async({properties:y})=>this.m(await this.h(y),!0))),this.b}async h(y){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",y);const $={},m=[],E=d.$qo.as(b.$vo.Configuration).getConfigurationProperties();for(const k of y){const t=E[k];if(!t){m.push(k);continue}if(t.policy){if(t.type!=="string"&&t.type!=="number"){this.g.warn(`Policy ${t.policy.name} has unsupported type ${t.type}`);continue}m.push(k),$[t.policy.name]={type:t.type}}}return(0,A.$sg)($)||await this.f.updatePolicyDefinitions($),m}j(y){this.g.trace("PolicyConfiguration#onDidChangePolicies",y);const $=d.$qo.as(b.$vo.Configuration).getPolicyConfigurations(),m=(0,n.$Jb)(y.map(E=>$.get(E)));this.m(m,!0)}m(y,$){this.g.trace("PolicyConfiguration#update",y);const m=d.$qo.as(b.$vo.Configuration).getConfigurationProperties(),E=[],k=this.b.isEmpty();for(const t of y){const r=m[t]?.policy?.name;if(r){const i=this.f.getPolicyValue(r);(k?i!==void 0:!(0,D.$ho)(this.b.getValue(t),i))&&E.push([t,i])}else this.b.getValue(t)!==void 0&&E.push([t,void 0])}if(E.length){this.g.trace("PolicyConfiguration#changed",E);const t=this.b;this.b=I.$Lo.createEmptyModel(this.g);for(const r of t.keys)this.b.setValue(r,t.getValue(r));for(const[r,i]of E)i===void 0?this.b.removeValue(r):this.b.setValue(r,i);$&&this.a.fire(this.b)}}};e.$To=h,e.$To=h=Pe([ne(1,f.$so),ne(2,a.$_j)],h)}),define(oe[243],ae([0,1,22,8,17,4,43,108,2,32,36,3,19,18,126,56,242,15,40]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=void 0;class E extends b.$Wc{constructor(r,i,c,s){super(),this.m=r,this.n=s,this.h=this.B(new D.$me),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new y.$Ro(s)),this.c=c instanceof m.$uo?new y.$So:this.B(new y.$To(this.b,c,s)),this.f=this.B(new h.$No(this.m,{},g.$0g,i,s)),this.a=new h.$Oo(this.b.configurationModel,this.c.configurationModel,h.$Lo.createEmptyModel(s),h.$Lo.createEmptyModel(s),h.$Lo.createEmptyModel(s),h.$Lo.createEmptyModel(s),new a.$Cc,h.$Lo.createEmptyModel(s),new a.$Cc,s),this.j=new k(r,i,this),this.g=this.B(new o.$Rh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:u,properties:l})=>this.s(u,l))),this.B(this.c.onDidChangeConfiguration(u=>this.t(u))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[r,i,c]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new h.$Oo(r,i,h.$Lo.createEmptyModel(this.n),c,h.$Lo.createEmptyModel(this.n),h.$Lo.createEmptyModel(this.n),new a.$Cc,h.$Lo.createEmptyModel(this.n),new a.$Cc,this.n)}getConfigurationData(){return this.a.toData()}getValue(r,i){const c=typeof r=="string"?r:void 0,s=(0,w.$aj)(r)?r:(0,w.$aj)(i)?i:{};return this.a.getValue(c,s,void 0)}async updateValue(r,i,c,s,u){const l=(0,w.$bj)(c)?c:(0,w.$aj)(c)?{resource:c.resource,overrideIdentifiers:c.overrideIdentifier?[c.overrideIdentifier]:void 0}:void 0,S=l?s:c;if(S!==void 0&&S!==w.ConfigurationTarget.USER_LOCAL&&S!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${r} to target ${S}.`);l?.overrideIdentifiers&&(l.overrideIdentifiers=(0,n.$Ob)(l.overrideIdentifiers),l.overrideIdentifiers=l.overrideIdentifiers.length?l.overrideIdentifiers:void 0);const v=this.inspect(r,{resource:l?.resource,overrideIdentifier:l?.overrideIdentifiers?l.overrideIdentifiers[0]:void 0});if(v.policyValue!==void 0)throw new Error(`Unable to write ${r} because it is configured in system policy.`);if((0,f.$ho)(i,v.defaultValue)&&(i=void 0),l?.overrideIdentifiers?.length&&l.overrideIdentifiers.length>1){const T=l.overrideIdentifiers.sort(),L=this.a.localUserConfiguration.overrides.find(O=>(0,n.$wb)([...O.identifiers].sort(),T));L&&(l.overrideIdentifiers=L.identifiers)}const R=l?.overrideIdentifiers?.length?[(0,p.$Ho)(l.overrideIdentifiers),r]:[r];await this.j.write(R,i),await this.reloadConfiguration()}inspect(r,i={}){return this.a.inspect(r,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const r=await this.f.loadConfiguration();this.r(r)}r(r){const i=this.a.toData(),c=this.a.compareAndUpdateLocalUserConfiguration(r);this.u(c,i,w.ConfigurationTarget.USER)}s(r,i){const c=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(r,i);this.u(s,c,w.ConfigurationTarget.DEFAULT)}t(r){const i=this.a.toData(),c=this.a.compareAndUpdatePolicyConfiguration(r);this.u(c,i,w.ConfigurationTarget.DEFAULT)}u(r,i,c){const s=new h.$Qo(r,{data:i},this.a,void 0,this.n);s.source=c,this.h.fire(s)}}e.$Uo=E;class k{constructor(r,i,c){this.b=r,this.c=i,this.d=c,this.a=new o.$Mh}write(r,i){return this.a.queue(()=>this.e(r,i))}async e(r,i){let c;try{c=(await this.c.readFile(this.b)).value.toString()}catch(l){if(l.fileOperationResult===$.FileOperationResult.FILE_NOT_FOUND)c="{}";else throw l}const s=[];if((0,A.$Xn)(c,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const u=this.f(c,r,i);c=(0,I.$co)(c,u),await this.c.writeFile(this.b,P.$Oe.fromString(c))}f(r,i,c){const{tabSize:s,insertSpaces:u,eol:l}=this.h;if(!i.length){const S=JSON.stringify(c,null,u?" ".repeat(s):"	");return[{content:S,length:S.length,offset:0}]}return(0,I.$_n)(r,i,c,{tabSize:s,insertSpaces:u,eol:l})}get h(){if(!this.g){let r=d.OS===d.OperatingSystem.Linux||d.OS===d.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(r=i),this.g={eol:r,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(oe[244],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=e.$Fgc=e.$Egc=void 0,e.$Egc="request",e.$Fgc="remoteResourceHandler";class n{async routeCall(P,D,A){if(D!==e.$Egc)throw new Error(`Call not found: ${D}`);const I=A[0];if(I?.authority){const b=P.connections.find(a=>a.ctx===I.authority);if(b)return b}throw new Error("Caller not found")}routeEvent(P,D){throw new Error(`Event not found: ${D}`)}}e.$Ggc=n}),define(oe[245],ae([0,1,16,6]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=a,e.$Ql=(0,o.$Fi)("remoteAuthorityResolverService");var P;(function(f){f[f.WebSocket=0]="WebSocket",f[f.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class D{constructor(d){this.id=d,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=D;class A{constructor(d,g){this.host=d,this.port=g,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=A;var I;(function(f){f.Unknown="Unknown",f.NotAvailable="NotAvailable",f.TemporarilyNotAvailable="TemporarilyNotAvailable",f.NoResolverFound="NoResolverFound",f.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class b extends n.$db{static isNotAvailable(d){return d instanceof b&&d._code===I.NotAvailable}static isTemporarilyNotAvailable(d){return d instanceof b&&d._code===I.TemporarilyNotAvailable}static isNoResolverFound(d){return d instanceof b&&d._code===I.NoResolverFound}static isInvalidAuthority(d){return d instanceof b&&d._code===I.InvalidAuthority}static isHandled(d){return d instanceof b&&d.isHandled}constructor(d,g=I.Unknown,w){super(d),this._message=d,this._code=g,this._detail=w,this.isHandled=g===I.NotAvailable&&w===!0,Object.setPrototypeOf(this,b.prototype)}}e.$Tl=b;function a(f){const d=f.indexOf("+");return d===-1?f:f.substring(0,d)}}),define(oe[246],ae([0,1,8,17,23,16,4,2,12,71,67,33,118,245]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Zl=v,e.$1l=R,e.$2l=L,a=De(a);const h=30*1e3;var p;(function(se){se[se.Management=1]="Management",se[se.ExtensionHost=2]="ExtensionHost",se[se.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function y(se){switch(se){case p.Management:return"Management";case p.ExtensionHost:return"ExtensionHost";case p.Tunnel:return"Tunnel"}}function $(se){const _=new P.$xe;return setTimeout(()=>_.cancel(),se),_.token}function m(se,_){if(se.isCancellationRequested||_.isCancellationRequested)return P.CancellationToken.Cancelled;const M=new P.$xe;return se.onCancellationRequested(()=>M.cancel()),_.onCancellationRequested(()=>M.cancel()),M.token}class E{get didTimeout(){return this.c==="timedout"}constructor(_){this.c="pending",this.d=new I.$Vc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$yh)(),_.isCancellationRequested?this.h():this.d.add(_.onCancellationRequested(()=>this.h()))}registerDisposable(_){this.c==="pending"?this.d.add(_):_.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const _=new Error("Time limit reached");return _.code="ETIMEDOUT",_.syscall="connect",_}resolve(_){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(_))}reject(_){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(_))}}function k(se,_){const M=new E(_);return M.registerDisposable(se.onControlMessage(N=>{const W=JSON.parse(N.toString()),H=j(W);H?M.reject(H):M.resolve(W)})),M.promise}function t(se,_,M,N,W,H,J,X){const Z=new E(X),ie=f.$ge.create(!1);return se.info(`Creating a socket (${J})...`),a.mark(`code/willCreateSocket/${H}`),_.connect(M,N,W,J).then(de=>{Z.didTimeout?(a.mark(`code/didCreateSocketError/${H}`),se.info(`Creating a socket (${J}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):(a.mark(`code/didCreateSocketOK/${H}`),se.info(`Creating a socket (${J}) was successful after ${ie.elapsed()} ms.`),Z.resolve(de))},de=>{a.mark(`code/didCreateSocketError/${H}`),se.info(`Creating a socket (${J}) returned an error after ${ie.elapsed()} ms.`),se.error(de),Z.reject(de)}),Z.promise}function r(se,_){const M=new E(_);return se.then(N=>{M.didTimeout||M.resolve(N)},N=>{M.didTimeout||M.reject(N)}),M.promise}async function i(se,_,M,N){const W=G(se,_);se.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let H;try{H=await t(se.logService,se.remoteSocketFactoryService,se.connectTo,b.$Sg.getServerRootPath(),`reconnectionToken=${se.reconnectionToken}&reconnection=${se.reconnectionProtocol?"true":"false"}`,y(_),`renderer-${y(_)}-${se.reconnectionToken}`,N)}catch(de){throw se.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),se.logService.error(de),de}se.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let J,X;se.reconnectionProtocol?(se.reconnectionProtocol.beginAcceptReconnection(H,null),J=se.reconnectionProtocol,X=!1):(J=new g.$ti({socket:H}),X=!0),se.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const Z=await r(se.signService.createNewMessage((0,d.$2g)()),N),ie={type:"auth",auth:se.connectionToken||"00000000000000000000",data:Z.data};J.sendControl(o.$Oe.fromString(JSON.stringify(ie)));try{const de=await k(J,m(N,$(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(se.logService.trace(`${W} 4/6. received SignRequest control message.`),!await r(se.signService.validate(Z,de.signedData),N)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const we=await r(se.signService.sign(de.data),N),Oe={type:"connectionType",commit:se.commit,signedData:we,desiredConnectionType:_};return M&&(Oe.args=M),se.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(o.$Oe.fromString(JSON.stringify(Oe))),{protocol:J,ownsProtocol:X}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(se.logService.error(`${W} the handshake timed out. Error:`),se.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(se.logService.error(`${W} received error control message when negotiating connection. Error:`),se.logService.error(de)),X&&q(J),de}}async function c(se,_,M,N){const W=Date.now(),H=G(se,_),{protocol:J,ownsProtocol:X}=await i(se,_,M,N),Z=new E(N);return Z.registerDisposable(J.onControlMessage(ie=>{const de=JSON.parse(ie.toString()),me=j(de);me?(se.logService.error(`${H} received error control message when negotiating connection. Error:`),se.logService.error(me),X&&q(J),Z.reject(me)):(se.reconnectionProtocol?.endAcceptReconnection(),se.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${he(W)}!`),Z.resolve({protocol:J,firstMessage:de}))})),Z.promise}async function s(se,_){const{protocol:M}=await c(se,p.Management,void 0,_);return{protocol:M}}async function u(se,_,M){const{protocol:N,firstMessage:W}=await c(se,p.ExtensionHost,_,M),H=W&&W.debugPort;return{protocol:N,debugPort:H}}async function l(se,_,M){const N=Date.now(),W=G(se,p.Tunnel),{protocol:H}=await i(se,p.Tunnel,_,M);return se.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${he(N)}!`),H}async function S(se,_,M){const{connectTo:N,connectionToken:W}=await se.addressProvider.getAddress();return{commit:se.commit,quality:se.quality,connectTo:N,connectionToken:W,reconnectionToken:_,reconnectionProtocol:M,remoteSocketFactoryService:se.remoteSocketFactoryService,signService:se.signService,logService:se.logService}}async function v(se,_,M){return T(se,async N=>{const{protocol:W}=await s(N,P.CancellationToken.None);return new K(se,_,M,N.reconnectionToken,W)})}async function R(se,_){return T(se,async M=>{const{protocol:N,debugPort:W}=await u(M,_,P.CancellationToken.None);return new ee(se,_,M.reconnectionToken,N,W)})}async function T(se,_){for(let N=1;;N++)try{const W=(0,d.$2g)(),H=await S(se,W,null);return await _(H)}catch(W){if(N<5)se.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),se.logService.error(W);else throw se.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),se.logService.error(W),le.triggerPermanentFailure(0,0,w.$Tl.isHandled(W)),W}}async function L(se,_,M){const N=await S(se,(0,d.$2g)(),null);return await l(N,{host:_,port:M},P.CancellationToken.None)}function O(se){return(0,n.$sh)(_=>new Promise((M,N)=>{const W=setTimeout(M,se*1e3);_.onCancellationRequested(()=>{clearTimeout(W),M()})}))}var F;(function(se){se[se.ConnectionLost=0]="ConnectionLost",se[se.ReconnectionWait=1]="ReconnectionWait",se[se.ReconnectionRunning=2]="ReconnectionRunning",se[se.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",se[se.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class B{constructor(_,M){this.reconnectionToken=_,this.millisSinceLastIncomingData=M,this.type=F.ConnectionLost}}e.$3l=B;class C{constructor(_,M,N,W){this.reconnectionToken=_,this.millisSinceLastIncomingData=M,this.durationSeconds=N,this.c=W,this.type=F.ReconnectionWait}skipWait(){this.c.cancel()}}e.$4l=C;class z{constructor(_,M,N){this.reconnectionToken=_,this.millisSinceLastIncomingData=M,this.attempt=N,this.type=F.ReconnectionRunning}}e.$5l=z;class re{constructor(_,M,N){this.reconnectionToken=_,this.millisSinceLastIncomingData=M,this.attempt=N,this.type=F.ConnectionGain}}e.$6l=re;class Q{constructor(_,M,N,W){this.reconnectionToken=_,this.millisSinceLastIncomingData=M,this.attempt=N,this.handled=W,this.type=F.ReconnectionPermanentFailure}}e.$7l=Q;class le extends I.$Wc{static triggerPermanentFailure(_,M,N){this._permanentFailure=!0,this.f=_,this.g=M,this.h=N,this.j.forEach(W=>W.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(_=>_.y())}static debugPauseSocketWriting(){this.j.forEach(_=>_.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||le._permanentFailure}constructor(_,M,N,W,H){super(),this.t=_,this.u=M,this.reconnectionToken=N,this.protocol=W,this.w=H,this.m=this.B(new A.$me),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new re(this.reconnectionToken,0,0)),this.B(W.onSocketClose(J=>{const X=ce(this.t,this.reconnectionToken,!0);J?J.type===g.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${X} received socket close event (hadError: ${J.hadError}).`),J.error&&this.u.logService.error(J.error)):(this.u.logService.info(`${X} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.u.logService.error(J.event)):this.u.logService.info(`${X} received socket close event.`),this.y()})),this.B(W.onSocketTimeout(J=>{const X=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${X} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.y()})),le.j.push(this),this.B((0,I.$Uc)(()=>{const J=le.j.indexOf(this);J>=0&&le.j.splice(J,1)})),this.n&&this.D(le.f,le.g,le.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const _=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const W=N<M.length?M[N]:M[M.length-1];try{if(W>0){const J=O(W);this.m.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,J)),this.u.logService.info(`${_} waiting for ${W} seconds before reconnecting...`);try{await J}catch{}}if(this.n){this.u.logService.error(`${_} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this.u.logService.info(`${_} resolving connection...`);const H=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${_} connecting to ${H.connectTo}...`),await this.G(H,$(h)),this.u.logService.info(`${_} reconnected!`),this.m.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${_} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this.u.logService.error(`${_} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(w.$Tl.isTemporarilyNotAvailable(H)){this.u.logService.info(`${_} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this.u.logService.info(`${_} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((0,D.$6)(H)){this.u.logService.info(`${_} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if(H instanceof w.$Tl){this.u.logService.error(`${_} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,w.$Tl.isHandled(H));break}this.u.logService.error(`${_} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this.n&&!this.s)}C(_,M,N){this.w?le.triggerPermanentFailure(_,M,N):this.D(_,M,N)}D(_,M,N){this.m.fire(new Q(this.reconnectionToken,_,M,N)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$8l=le;class K extends le{constructor(_,M,N,W,H){super(p.Management,_,W,H,!0),this.client=this.B(new g.$ri(H,{remoteAuthority:M,clientId:N},_.ipcLogger))}async G(_,M){await s(_,M)}}e.$9l=K;class ee extends le{constructor(_,M,N,W,H){super(p.ExtensionHost,_,N,W,!1),this.H=M,this.debugPort=H}async G(_,M){await u(_,this.H,M)}}e.$0l=ee;function q(se){try{se.acceptDisconnect();const _=se.getSocket();se.dispose(),_.dispose()}catch(_){(0,D.$3)(_)}}function j(se){if(se&&se.type==="error"){const _=new Error(`Connection error: ${se.reason}`);return _.code="VSCODE_CONNECTION_ERROR",_}return null}function U(se,_){for(;se.length<_;)se+=" ";return se}function V(se,_){return`[remote-connection][${U(y(se),13)}][${_.substr(0,5)}\u2026]`}function ce(se,_,M){return`${V(se,_)}[${M?"reconnect":"initial"}]`}function G(se,_){return`${ce(_,se.reconnectionToken,!!se.reconnectionProtocol)}[${se.connectTo}]`}function he(se){return`${Date.now()-se} ms`}}),define(oe[75],ae([0,1,12]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=o,e.$hn=P,e.$in=D,e.$jn=A;function o(b){return b.scheme===n.Schemas.vscodeRemote?b.authority:void 0}function P(b){if(!b)return;const a=b.indexOf("+");return a<0?b:b.substr(0,a)}function D(b){const{host:a,port:f}=I(b);if(typeof f>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:f}}function A(b,a){let{host:f,port:d}=I(b);return typeof d>"u"&&(d=a),{host:f,port:d}}function I(b){const a=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const f=b.match(/^(\[[0-9a-z:]+\])$/);if(f)return{host:f[1],port:void 0};const d=b.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:b,port:void 0}}}),define(oe[86],ae([0,1,26,6,75]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=D,e.$tn=d,e.$un=g,e.$vn=w,e.$wn=h,e.$xn=p,e.$yn=y,n=De(n),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function D($){if(typeof $=="object"&&$!==null&&$.supported!==!0)return $.description}e.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function($){$[$.System=0]="System",$[$.User=1]="User"})(A||(e.ExtensionType=A={}));var I;(function($){$.WIN32_X64="win32-x64",$.WIN32_ARM64="win32-arm64",$.LINUX_X64="linux-x64",$.LINUX_ARM64="linux-arm64",$.LINUX_ARMHF="linux-armhf",$.ALPINE_X64="alpine-x64",$.ALPINE_ARM64="alpine-arm64",$.DARWIN_X64="darwin-x64",$.DARWIN_ARM64="darwin-arm64",$.WEB="web",$.UNIVERSAL="universal",$.UNKNOWN="unknown",$.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class b{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,E){if(typeof m>"u"||m===null)return typeof E>"u"||E===null;if(typeof E>"u"||E===null)return!1;if(typeof m=="string"||typeof E=="string"){const k=typeof m=="string"?m:m.value,t=typeof E=="string"?E:E.value;return n.$Gf(k,t)}return m._lower===E._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$qn=b;class a{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const E of m)this.add(E)}add(m){this.c.add(b.toKey(m))}delete(m){return this.c.delete(b.toKey(m))}has(m){return this.c.has(b.toKey(m))}}e.$rn=a;class f{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(b.toKey(m))}get(m){return this.c.get(b.toKey(m))}has(m){return this.c.has(b.toKey(m))}set(m,E){this.c.set(b.toKey(m),E)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=f;function d($){return g($)}function g($){return $.contributes&&$.contributes.localizations?$.contributes.localizations.length>0:!1}function w($){return $.contributes&&$.contributes.authentication?$.contributes.authentication.length>0:!1}function h($,m){if(m){const E=`onResolveRemoteAuthority:${(0,P.$hn)(m)}`;return!!$.activationEvents?.includes(E)}return!1}function p($){return $.map(m=>{const[E,k]=m.split("@");return{proposalName:E,version:k?parseInt(k):void 0}})}function y($){return $.map(m=>m.split("@")[0])}e.$zn=(0,o.$Fi)("IBuiltinExtensionsScannerService")}),define(oe[127],ae([0,1,3,175,86,6]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.ExtensionManagementErrorCode=e.$jp=e.ExtensionGalleryErrorCode=e.$ip=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$cp=I,e.$dp=b,e.$ep=a,e.$fp=f,e.$gp=d,e.$hp=g,e.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9o=new RegExp(e.$8o),e.$0o="__web_extension",e.$$o="skipWalkthrough",e.$_o="extensionInstallSource",e.$ap="dependecyOrPackExtensionInstall",e.$bp="clientTargetPlatform";var A;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function I(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function b(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function a(t,r){switch(t){case n.Platform.Windows:return r==="x64"?P.TargetPlatform.WIN32_X64:r==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case n.Platform.Linux:return r==="x64"?P.TargetPlatform.LINUX_X64:r==="arm64"?P.TargetPlatform.LINUX_ARM64:r==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return r==="x64"?P.TargetPlatform.ALPINE_X64:r==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case n.Platform.Mac:return r==="x64"?P.TargetPlatform.DARWIN_X64:r==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case n.Platform.Web:return P.TargetPlatform.WEB}}function f(t,r){return r===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function d(t,r,i){return f(r,i)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===i}function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var w;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var h;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(h||(e.SortOrder=h={}));var p;(function(t){t.Install="install",t.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var y;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$ip=(0,D.$Fi)("extensionGalleryService");var $;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})($||(e.ExtensionGalleryErrorCode=$={}));class m extends Error{constructor(r,i){super(r),this.code=i,this.name=i}}e.$jp=m;var E;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));class k extends Error{constructor(r,i){super(r),this.code=i,this.name=i}}e.$kp=k,e.$lp=(0,D.$Fi)("extensionManagementService"),e.$mp="extensionsIdentifiers/disabled",e.$np="extensionsIdentifiers/enabled",e.$op=(0,D.$Fi)("IGlobalExtensionEnablementService"),e.$pp=(0,D.$Fi)("IExtensionTipsService"),e.$qp=(0,o.localize2)(0,"Extensions"),e.$rp=(0,o.localize2)(1,"Preferences")});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[247],ae([0,1,19,81,178,248,86,210]),function(x,e,n,o,P,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=f,e.$Xp=d,e.$Yp=g,e.$Zp=w,e.$1p=h,e.$2p=p,e.$3p=y,e.$4p=$,o=et(o),P=De(P),D=De(D);const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function f(k){return k=k.trim(),k==="*"||b.test(k)}function d(k){if(!f(k))return null;if(k=k.trim(),k==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=k.match(b);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function g(k){if(!k)return null;const t=k.majorBase,r=k.majorMustEqual,i=k.minorBase;let c=k.minorMustEqual;const s=k.patchBase;let u=k.patchMustEqual;k.hasCaret&&(t===0||(c=!1),u=!1);let l=0;if(k.preRelease){const S=a.exec(k.preRelease);if(S){const[,v,R,T]=S;l=Date.UTC(Number(v),Number(R)-1,Number(T))}}return{majorBase:t,majorMustEqual:r,minorBase:i,minorMustEqual:c,patchBase:s,patchMustEqual:u,isMinimum:k.hasGreaterEquals,notBefore:l}}function w(k,t,r){let i;typeof k=="string"?i=g(d(k)):i=k;let c;t instanceof Date?c=t.getTime():typeof t=="string"&&(c=new Date(t).getTime());let s;if(typeof r=="string"?s=g(d(r)):s=r,!i||!s)return!1;const u=i.majorBase,l=i.minorBase,S=i.patchBase;let v=s.majorBase,R=s.minorBase,T=s.patchBase;const L=s.notBefore;let O=s.majorMustEqual,F=s.minorMustEqual,B=s.patchMustEqual;return s.isMinimum?u>v?!0:u<v?!1:l>R?!0:l<R||c&&c<L?!1:S>=T:(u===1&&v===0&&(!O||!F||!B)&&(v=1,R=0,T=0,O=!0,F=!1,B=!1),u<v?!1:u>v?!O:l<R?!1:l>R?!F:S<T?!1:S>T?!B:!(c&&c<L))}function h(k,t,r,i,c){const s=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return s.push([o.default.Error,P.localize(0,null)]),s;if(typeof i.name!="string")return s.push([o.default.Error,P.localize(1,null,"name")]),s;if(typeof i.version!="string")return s.push([o.default.Error,P.localize(2,null,"version")]),s;if(!i.engines)return s.push([o.default.Error,P.localize(3,null,"engines")]),s;if(typeof i.engines.vscode!="string")return s.push([o.default.Error,P.localize(4,null,"engines.vscode")]),s;if(typeof i.extensionDependencies<"u"&&!E(i.extensionDependencies))return s.push([o.default.Error,P.localize(5,null,"extensionDependencies")]),s;if(typeof i.activationEvents<"u"){if(!E(i.activationEvents))return s.push([o.default.Error,P.localize(6,null,"activationEvents")]),s;if(typeof i.main>"u"&&typeof i.browser>"u")return s.push([o.default.Error,P.localize(7,null,"activationEvents","main","browser")]),s}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&s.push([o.default.Warning,P.localize(8,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return s.push([o.default.Error,P.localize(9,null,"main")]),s;{const S=(0,n.$gh)(r,i.main);(0,n.$ah)(S,r)||s.push([o.default.Warning,P.localize(10,null,S.path,r.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return s.push([o.default.Error,P.localize(11,null,"browser")]),s;{const S=(0,n.$gh)(r,i.browser);(0,n.$ah)(S,r)||s.push([o.default.Warning,P.localize(12,null,S.path,r.path)])}}if(!D.valid(i.version))return s.push([o.default.Error,P.localize(13,null)]),s;const u=[];if(!p(k,t,i,c,u))for(const S of u)s.push([o.default.Error,S]);if(i.enabledApiProposals?.length){const S=[];if(!$([...i.enabledApiProposals],S))for(const v of S)s.push([o.default.Error,v])}return s}function p(k,t,r,i,c){return i||typeof r.main>"u"&&typeof r.browser>"u"?!0:m(k,t,r.engines.vscode,c)}function y(k,t,r){return k==="*"||m(t,r,k)}function $(k,t){if(k.length===0)return!0;const r=Array.isArray(t)?t:void 0,i=(r?void 0:t)??I.allApiProposals,c=[],s=(0,A.$xn)(k);for(const{proposalName:u,version:l}of s){const S=i[u];S&&l&&S.version!==l&&(S.version?c.push(P.localize(14,null,u,l,S.version)):c.push(P.localize(15,null,u,l)))}return r?.push(...c),c.length===0}function m(k,t,r,i=[]){const c=g(d(r));if(!c)return i.push(P.localize(16,null,r)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return i.push(P.localize(17,null,r)),!1}else if(!c.majorMustEqual)return i.push(P.localize(18,null,r)),!1;return w(k,t,c)?!0:(i.push(P.localize(19,null,k,r)),!1)}function E(k){if(!Array.isArray(k))return!1;for(let t=0,r=k.length;t<r;t++)if(typeof k[t]!="string")return!1;return!0}}),define(oe[249],ae([0,1,2,6]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl=(0,o.$Fi)("remoteSocketFactoryService");class P{constructor(){this.a={}}register(A,I){return this.a[A]??=[],this.a[A].push(I),(0,n.$Uc)(()=>{const b=this.a[A]?.indexOf(I);typeof b=="number"&&b>=0&&this.a[A]?.splice(b,1)})}b(A){return(this.a[A.type]||[]).find(b=>b.supports(A))}connect(A,I,b,a){const f=this.b(A);if(!f)throw new Error(`No socket factory found for ${A}`);return f.connect(A,I,b,a)}}e.$Wl=P}),define(oe[250],ae([0,1,27,49,21,122]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=I,n=De(n),o=De(o),D=De(D);let A;async function I(w=!1){return(A===void 0||w)&&(A=b()),A}async function b(){const w=a();if(w===void 0)return!1;if(w>=22e3){const h=d();if(h)return new Promise(p=>{o.execFile(h,["--status"],y=>p(!y))})}else{const h=g();if(h)try{if((await P.Promises.stat(h)).isFile())return!0}catch{}}return!1}function a(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if(w)return parseInt(w[3])}function f(w){const h=process.env.SystemRoot;if(h){const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return D.join(h,p?"Sysnative":"System32",w)}}function d(){return f("wsl.exe")}function g(){return f("lxss\\LxssManager.dll")}}),define(oe[57],ae([0,1,17,16,2,190,56,6,5,45]),function(x,e,n,o,P,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.$7p=g,e.$8p=w,e.$9p=h,e.$0p=p,e.$$p=y,e.$_p=$,e.$5p=(0,I.$Fi)("requestService");class f{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const r in this.b)r.toLowerCase()==="authorization"||r.toLowerCase()==="proxy-authorization"?t[r]="*****":t[r]=this.b[r];this.a=t}return this.a}}class d extends P.$Wc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,D.localize)(0,null),when:b.$rk.isEqualTo((0,b.$ok)(b.LogLevel.Trace)).serialize()})}async c(t,r,i){const c=`${t} #${++this.b}: ${r.url}`;this.a.trace(`${c} - begin`,r.type,new f(r.headers??{}));try{const s=await i();return this.a.trace(`${c} - end`,r.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${c} - error`,r.type,(0,o.$_)(s)),s}}}e.$6p=d;function g(k){return k.res.statusCode&&k.res.statusCode>=200&&k.res.statusCode<300||k.res.statusCode===1223}function w(k){return k.res.statusCode===204}async function h(k){return w(k)?null:(await(0,n.$1e)(k.stream)).toString()}async function p(k){if(!g(k))throw new Error("Server returned "+k.res.statusCode);return h(k)}async function y(k){if(!g(k))throw new Error("Server returned "+k.res.statusCode);if(w(k))return null;const r=(await(0,n.$1e)(k.stream)).toString();try{return JSON.parse(r)}catch(i){throw i.message+=`:
`+r,i}}function $(k){E(k)}let m;function E(k){const t=a.$qo.as(A.$vo.Configuration),r=m;m={id:"http",order:15,title:(0,D.localize)(1,null),type:"object",scope:k,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(6,null),(0,D.localize)(7,null),(0,D.localize)(8,null),(0,D.localize)(9,null)],default:"override",description:(0,D.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(12,null),restricted:!0}}},t.updateConfigurations({add:[m],remove:r?[r]:[]})}E(A.ConfigurationScope.APPLICATION)}),define(oe[251],ae([0,1,17,23]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.$_r=void 0;class P{constructor(I){this.a=I}listen(I,b){throw new Error("Invalid listen")}call(I,b,a,f=o.CancellationToken.None){switch(b){case"request":return this.a.request(a[0],f).then(async({res:d,stream:g})=>{const w=await(0,n.$1e)(g);return[{statusCode:d.statusCode,headers:d.headers},w]});case"resolveProxy":return this.a.resolveProxy(a[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$_r=P;class D{constructor(I){this.a=I}async request(I,b){const[a,f]=await this.a.call("request",[I],b);return{res:a,stream:(0,n.$3e)(f)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$as=D}),define(oe[252],ae([0,1,253,13]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=D;function P(A,I){return A.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:A.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function D(A,I,b={}){const a=(0,n.parse)(A),f=b.proxyUrl||P(a,I);if(!f)return null;const d=(0,n.parse)(f);if(!/^https?:$/.test(d.protocol||""))return null;const g={host:d.hostname||"",port:(d.port?+d.port:0)||(d.protocol==="https"?443:80),auth:d.auth,rejectUnauthorized:(0,o.$lg)(b.strictSSL)?b.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((w,h)=>{x(["http-proxy-agent"],w,h)}).then(De)).HttpProxyAgent(f,g):new(await new Promise((w,h)=>{x(["https-proxy-agent"],w,h)}).then(De)).HttpsProxyAgent(f,g)}}),define(oe[254],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=e.$Zfc=e.$Yfc=void 0,e.$Yfc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Zfc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$1fc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[101],ae([0,1,49,10,191,23,55,16,3,33,117,69,8,143]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=p;let h;async function p($,m,E,k){return E["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.$i?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,d.$Jm)(k)&&!E["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,d.$Jm)(k)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=g.Promises.withAsyncBody(async(t,r)=>{const i=new D.$xe;let c=1e4;const s=$.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(c=(0,w.$Km)(s,1,120)*1e3);const u=setTimeout(()=>{i.dispose(!0),r(new Error((0,P.localize)(0,null)))},c);try{t(await y(m,i.token))}catch(l){!(0,I.$6)(l)&&!i.token.isCancellationRequested?r(new Error((0,P.localize)(1,null,(0,A.$qj)(l)))):t({})}finally{clearTimeout(u),i.dispose()}})),h)}async function y($,m){const E=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",E);const k=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",k);const t=(0,a.$2g)().replace(/-/g,"").substr(0,12),r=new RegExp(t+"({.*})"+t),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",i);const c=await(0,f.$zm)(b.OS,i);return $.trace("getUnixShellEnvironment#shell",c),new Promise((s,u)=>{if(m.isCancellationRequested)return u(new I.$7);const l=(0,o.$pc)(c);let S,v;const R="";/^pwsh(-preview)?$/.test(l)?(S=`& '${process.execPath}' ${R} -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,v=["-Login","-Command"]):l==="nu"?(S=`^'${process.execPath}' ${R} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,v=["-i","-l","-c"]):l==="xonsh"?(S=`import os, json; print("${t}", json.dumps(dict(os.environ)), "${t}")`,v=["-i","-l","-c"]):(S=`'${process.execPath}' ${R} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,l==="tcsh"||l==="csh"?v=["-ic"]:v=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(v),S);const T=(0,n.spawn)(c,[...v,S],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});m.onCancellationRequested(()=>(T.kill(),u(new I.$7))),T.on("error",F=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,A.$qj)(F)),u(F)});const L=[];T.stdout.on("data",F=>L.push(F));const O=[];T.stderr.on("data",F=>O.push(F)),T.on("close",(F,B)=>{const C=Buffer.concat(L).toString("utf8");$.trace("getUnixShellEnvironment#raw",C);const z=Buffer.concat(O).toString("utf8");if(z.trim()&&$.trace("getUnixShellEnvironment#stderr",z),F||B)return u(new Error((0,P.localize)(2,null,F,B)));const re=r.exec(C),Q=re?re[1]:"{}";try{const le=JSON.parse(Q);E?le.ELECTRON_RUN_AS_NODE=E:delete le.ELECTRON_RUN_AS_NODE,k?le.ELECTRON_NO_ATTACH_CONSOLE=k:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",le),s(le)}catch(le){$.error("getUnixShellEnvironment#errorCaught",(0,A.$qj)(le)),u(le)}})})}}),define(oe[255],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(P){try{const D=await this.c();if(D){const A=String(n.a++);return this.b.set(A,D),{id:A,data:D.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,D){if(!P.id)return!0;const A=this.b.get(P.id);if(!A)return!1;this.b.delete(P.id);try{return A.validate(D)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(P){try{return await this.d(P)}catch{}return P}}e.$Kbc=n}),define(oe[102],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=void 0,e.$Xl="signService",e.$Yl=(0,n.$Fi)(e.$Xl)}),define(oe[256],ae([0,1,255]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=void 0;class o extends n.$Kbc{c(){return this.h().then(D=>new D.validator)}d(D){return this.h().then(A=>new A.signer().sign(D))}h(){return new Promise((D,A)=>x(["vsda"],D,A))}}e.$Qgc=o}),define(oe[34],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gR=e.$fR=void 0,e.$fR=(0,n.$Fi)("stateReadService"),e.$gR=(0,n.$Fi)("stateService")}),define(oe[128],ae([0,1,8,17,2,13,38,15,5]),function(x,e,n,o,P,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jR=e.$iR=e.$hR=e.SaveStrategy=void 0;var a;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class f extends P.$Wc{constructor(h,p,y,$){super(),this.h=h,this.j=p,this.m=y,this.n=$,this.a=Object.create(null),this.b="",this.c=this.B(new n.$Dh(this.j===a.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(h){h.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(h)}}getItem(h,p){const y=this.a[h];return(0,D.$og)(y)?p:y}setItem(h,p){this.setItems([{key:h,data:p}])}setItems(h){let p=!1;for(const{key:y,data:$}of h)this.a[y]!==$&&((0,D.$og)($)?(0,D.$mg)(this.a[y])||(this.a[y]=void 0,p=!0):(this.a[y]=$,p=!0));p&&this.s()}removeItem(h){(0,D.$mg)(this.a[h])||(this.a[h]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const h=JSON.stringify(this.a,null,4);if(h!==this.b)try{await this.n.writeFile(this.h,o.$Oe.fromString(h),{atomic:{postfix:".vsctmp"}}),this.b=h}catch(p){this.m.error(p)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$hR=f;let d=class extends P.$Wc{constructor(h,p,y,$){super(),this.a=this.B(new f(p.stateResource,h,y,$))}async init(){await this.a.init()}getItem(h,p){return this.a.getItem(h,p)}};e.$iR=d,e.$iR=d=Pe([ne(1,A.$Mi),ne(2,b.$_j),ne(3,I.$_k)],d);class g extends d{setItem(h,p){this.a.setItem(h,p)}setItems(h){this.a.setItems(h)}removeItem(h){this.a.removeItem(h)}close(){return this.a.close()}}e.$jR=g}),define(oe[129],ae([0,1,3,37,33]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=A,e.$tp=I;function D(b){if(n.$u===n.Platform.Linux&&/^penguin(\.|$)/i.test(b))return"chromebook"}function A(b,a,f,d,g,w,h,p,y,$){const m=Object.create(null);m["common.machineId"]=w,m["common.sqmId"]=h,m["common.devDeviceId"]=p,m.sessionID=(0,P.$2g)()+Date.now(),m.commitHash=d,m.version=g,m["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,n.$h)(n.$u),m["common.nodePlatform"]=o.$fc,m["common.nodeArch"]=f,m["common.product"]=$||"desktop",y&&(m["common.msftInternal"]=y);let E=0;const k=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-k,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),n.$l&&(m["common.snap"]="true");const t=D(a);return t&&(m["common.platformDetail"]=t),m}function I(b){const a=o.env.USERDNSDOMAIN;if(!a)return!1;const f=a.toLowerCase();return b.some(d=>f===d)}}),define(oe[25],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,n.$Fi)("telemetryService"),e.$_l=(0,n.$Fi)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var o;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(o||(e.TelemetryLevel=o={}));var P;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(oe[257],ae([0,1,27,8,43,12,10,3,67,7,94,21,116,97,15,28,25]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0,e.$Vs=m,e.$Ws=k,e.$Xs=t,n=De(n);const $=new Map;async function m(i,c){const s=`${i}::${c.join(":")}`,u=$.get(s);if(u)return u;const l=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],S=new Map,v=new Map,R=2e4;function T(O,F,B,C){const z=F.substring(O.length+1);return o.Promises.withAsyncBody(async re=>{let Q;C.readdirCount++;try{Q=await d.Promises.readdir(F,{withFileTypes:!0})}catch{re();return}if(C.count>=R){C.count+=Q.length,C.maxReached=!0,re();return}let le=Q.length;if(le===0){re();return}let K=Q;C.count+Q.length>R&&(C.maxReached=!0,le=R-C.count,K=Q.slice(0,le)),C.count+=Q.length;for(const ee of K)if(ee.isDirectory()){if(B.includes(ee.name)||await T(O,(0,A.$lc)(F,ee.name),B,C),--le===0){re();return}}else{const q=ee.name.lastIndexOf(".");if(q>=0){const j=ee.name.substring(q+1);j&&S.set(j,(S.get(j)??0)+1)}for(const j of l)j.relativePathPattern?.test(z)!==!1&&j.filePattern.test(ee.name)&&v.set(j.tag,(v.get(j.tag)??0)+1);if(--le===0){re();return}}})}const L=o.Promises.withAsyncBody(async O=>{const F={count:0,maxReached:!1,readdirCount:0},B=new b.$ge(!0);await T(i,i,c,F);const C=await t(i);O({configFiles:E(v),fileTypes:E(S),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:C,totalScanTime:B.elapsed(),totalReaddirCount:F.readdirCount})});return $.set(s,L),L}function E(i){return Array.from(i.entries(),([c,s])=>({name:c,count:s})).sort((c,s)=>s.count-c.count)}function k(){const i={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/h.$Hl.GB).toFixed(2)}GB (${(n.freemem()/h.$Hl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(f.$Rn.value()*100)}%`},c=n.cpus();return c&&c.length>0&&(i.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),i}async function t(i){try{const c=new Map,s=(0,A.$lc)(i,".vscode","launch.json"),u=await d.Promises.readFile(s),l=[],S=(0,P.$Xn)(u.toString(),l);if(l.length)return console.log(`Unable to parse ${s}`),[];if((0,P.$6n)(S)==="object"&&S.configurations)for(const v of S.configurations){const R=v.type;R&&(c.has(R)?c.set(R,c.get(R)+1):c.set(R,1))}return E(c)}catch{return[]}}let r=class{constructor(c,s){this.c=c,this.d=s}f(c){const s=[];return s.push(`OS Version:       ${c.os}`),s.push(`CPUs:             ${c.cpus}`),s.push(`Memory (System):  ${c.memory}`),s.push(`VM:               ${c.vmHint}`),s.join(`
`)}g(c){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const u=n.cpus();return u&&u.length>0&&s.push(`CPUs:             ${u[0].model} (${u.length} x ${u[0].speed})`),s.push(`Memory (System):  ${(n.totalmem()/h.$Hl.GB).toFixed(2)}GB (${(n.freemem()/h.$Hl.GB).toFixed(2)}GB free)`),I.$i||s.push(`Load (avg):       ${n.loadavg().map(l=>Math.round(l)).join(", ")}`),s.push(`VM:               ${Math.round(f.$Rn.value()*100)}%`),s.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${c.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(c,s){return Promise.all([(0,g.$Us)(c.mainPID),this.k(c)]).then(async u=>{let[l,S]=u,v=this.m(c,l);return s.forEach(R=>{if((0,w.$Tm)(R))v+=`
${R.errorMessage}`,S+=`
${R.errorMessage}`;else if(v+=`

Remote: ${R.hostName}`,R.processes&&(v+=`
${this.m(c,R.processes)}`),R.workspaceMetadata){S+=`
|  Remote: ${R.hostName}`;for(const T of Object.keys(R.workspaceMetadata)){const L=R.workspaceMetadata[T];let O=`${L.fileCount} files`;L.maxFilesReached&&(O=`more than ${O}`),S+=`|    Folder (${T}): ${O}`,S+=this.h(L)}}}),{processInfo:v,workspaceInfo:S}})}async getSystemInfo(c,s){const{memory:u,vmHint:l,os:S,cpus:v}=k(),R={os:S,memory:u,cpus:v,vmHint:l,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:s};return I.$i||(R.load=`${n.loadavg().map(T=>Math.round(T)).join(", ")}`),I.$k&&(R.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(R)}async getDiagnostics(c,s){const u=[];return(0,g.$Us)(c.mainPID).then(async l=>(u.push(""),u.push(this.g(c)),u.push(""),u.push(this.m(c,l)),c.windows.some(S=>S.folderURIs&&S.folderURIs.length>0&&!S.remoteAuthority)&&(u.push(""),u.push("Workspace Stats: "),u.push(await this.k(c))),s.forEach(S=>{if((0,w.$Tm)(S))u.push(`
${S.errorMessage}`);else if(u.push(`

`),u.push(`Remote:           ${S.hostName}`),u.push(this.f(S.machineInfo)),S.processes&&u.push(this.m(c,S.processes)),S.workspaceMetadata)for(const v of Object.keys(S.workspaceMetadata)){const R=S.workspaceMetadata[v];let T=`${R.fileCount} files`;R.maxFilesReached&&(T=`more than ${T}`),u.push(`Folder (${v}): ${T}`),u.push(this.h(R))}}),u.push(""),u.push(""),u.join(`
`)))}h(c){const s=[];let l=0;const S=(L,O)=>{const F=` ${L}(${O})`;l+F.length>60?(s.push(v),v="|                 ",l=v.length):l+=F.length,v+=F};let v="|      File types:";const R=10,T=c.fileTypes.length>R?R:c.fileTypes.length;for(let L=0;L<T;L++){const O=c.fileTypes[L];S(O.name,O.count)}if(s.push(v),c.configFiles.length>=0&&(v="|      Conf files:",l=0,c.configFiles.forEach(L=>{S(L.name,L.count)}),s.push(v)),c.launchConfigFiles.length>0){let L="|      Launch Configs:";c.launchConfigFiles.forEach(O=>{const F=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;L+=F}),s.push(L)}return s.join(`
`)}j(c){const s=Math.max(...Object.keys(c).map(u=>u.length));return Object.keys(c).map(u=>`${u}:  ${" ".repeat(s-u.length)}  ${c[u]}`).join(`
                  `)}k(c){const s=[],u=[];return c.windows.forEach(l=>{l.folderURIs.length===0||l.remoteAuthority||(s.push(`|  Window (${l.title})`),l.folderURIs.forEach(S=>{const v=a.URI.revive(S);if(v.scheme===D.Schemas.file){const R=v.fsPath;u.push(m(R,["node_modules",".git"]).then(T=>{let L=`${T.fileCount} files`;T.maxFilesReached&&(L=`more than ${L}`),s.push(`|    Folder (${(0,A.$pc)(R)}): ${L}`),s.push(this.h(T))}).catch(T=>{s.push(`|      Error: Unable to collect workspace stats for folder ${R} (${T.toString()})`)}))}else s.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(u).then(l=>s.join(`
`)).catch(l=>`Unable to collect workspace stats: ${l}`)}m(c,s){const u=new Map;c.windows.forEach(S=>u.set(S.pid,`window [${S.id}] (${S.title})`)),c.pidToNames.forEach(({pid:S,name:v})=>u.set(S,v));const l=[];return l.push("CPU %	Mem MB	   PID	Process"),s&&this.n(c.mainPID,u,l,s,0),l.join(`
`)}n(c,s,u,l,S){const v=S===0;let R;v?R=l.pid===c?`${this.d.applicationName} main`:"remote agent":s.has(l.pid)?R=s.get(l.pid):R=`${"  ".repeat(S)} ${l.name}`;const T=process.platform==="win32"?l.mem:n.totalmem()*(l.mem/100);u.push(`${l.load.toFixed(0).padStart(5," ")}	${(T/h.$Hl.MB).toFixed(0).padStart(6," ")}	${l.pid.toFixed(0).padStart(6," ")}	${R}`),Array.isArray(l.children)&&l.children.forEach(L=>this.n(c,s,u,L,S+1))}async getWorkspaceFileExtensions(c){const s=new Set;for(const{uri:u}of c.folders){const l=a.URI.revive(u);if(l.scheme!==D.Schemas.file)continue;const S=l.fsPath;try{(await m(S,["node_modules",".git"])).fileTypes.forEach(R=>s.add(R.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(c){for(const{uri:s}of c.folders){const u=a.URI.revive(s);if(u.scheme!==D.Schemas.file)continue;const l=u.fsPath;try{const S=await m(l,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),S.fileTypes.forEach(v=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:v.name,count:v.count})}),S.launchConfigFiles.forEach(v=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:v.name,count:v.count})}),S.configFiles.forEach(v=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:v.name,count:v.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:S.totalScanTime,reachedLimit:S.maxFilesReached,fileCount:S.fileCount,readdirCount:S.totalReaddirCount})}catch{}}}};e.$Ys=r,e.$Ys=r=Pe([ne(0,y.$$l),ne(1,p.$sk)],r)}),define(oe[258],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=e.$4fc=void 0;class n{constructor(D){this.b=D}listen(D,A){throw new Error(`Event not found: ${A}`)}call(D,A,{eventName:I,data:b}){return this.b.forEach(a=>a.log(I,b)),Promise.resolve(null)}}e.$4fc=n;class o{constructor(D){this.b=D}log(D,A){return this.b.call("log",{eventName:D,data:A}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$5fc=o}),define(oe[58],ae([0,1,36,13,75,129,25]),function(x,e,n,o,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=void 0,e.$Bp=f,e.$Cp=d,e.$Dp=g,e.$Ep=w,e.$Fp=p,e.$Gp=$,e.$Hp=m,e.$Ip=t;class I{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$up=I;class b{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vp=b,e.$wp=new b;class a{async publicLog(i,c,s){}async publicLogError(i,c,s){}}e.$xp=a,e.$yp="telemetry",e.$zp="extensionTelemetryLog",e.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function f(r,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!r.enableTelemetry)}function d(r,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}function g(r){const i=r.getValue(A.$hm),c=r.getValue(A.$im);if(r.getValue(A.$jm)===!1||c===!1)return A.TelemetryLevel.NONE;switch(i??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function w(r){const i={},c={},s={};y(r,s);for(let u in s){u=u.length>150?u.substr(u.length-149):u;const l=s[u];typeof l=="number"?c[u]=l:typeof l=="boolean"?c[u]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${l.length}`),i[u]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(i[u]=l)}return{properties:i,measurements:c}}const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(r){if(!r)return"none";const i=(0,P.$hn)(r);return h.has(i)?i:"other"}function y(r,i,c=0,s){if(r)for(const u of Object.getOwnPropertyNames(r)){const l=r[u],S=s?s+u:u;Array.isArray(l)?i[S]=(0,n.$io)(l):l instanceof Date?i[S]=l.toISOString():(0,o.$hg)(l)?c<2?y(l,i,c+1,S+"."):i[S]=(0,n.$io)(l):i[S]=l}}function $(r,i){const c=r.msftInternalDomains||[],s=i.getValue("telemetry.internalTesting");return(0,D.$tp)(c)||s}function m(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}function E(r,i){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let c=r;const s=[];for(const v of i)for(;;){const R=v.exec(r);if(!R)break;s.push([R.index,v.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(c="";;){const v=l.exec(r);if(!v)break;const R=s.some(([T,L])=>v.index<L&&T<l.lastIndex);!u.test(v[0])&&!R&&(c+=r.substring(S,v.index)+"<REDACTED: user-file-path>",S=l.lastIndex)}return S<r.length&&(c+=r.substr(S)),c}function k(r){if(!r)return r;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of i)if(c.regex.test(r))return`<REDACTED: ${c.label}>`;return r}function t(r,i){return(0,n.$fo)(r,c=>{if(c instanceof I||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let s=c.replaceAll("%20"," ");s=E(s,i);for(const u of i)s=s.replace(u,"");return s=k(s),s}})}}),define(oe[130],ae([0,1,26,127,86,3,7,16,37,58]),function(x,e,n,o,P,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Kp=void 0,e.$Jp=f,e.$Lp=h,e.$Mp=p,e.$Np=y,e.$Op=$,e.$Pp=m,e.$Qp=E,e.$Rp=k,e.$Tp=t,e.$Up=i;function f(c,s){return c.uuid&&s.uuid?c.uuid===s.uuid:c.id===s.id?!0:(0,n.$Bf)(c.id,s.id)===0}const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(s){const u=s.manifest?s.manifest.version:s.version,l=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new g(s.identifier,u,l)}static parse(s){const u=d.exec(s);return u&&u[1]&&u[2]?new g({id:u[1]},u[2],u[4]||void 0):null}constructor(s,u,l=P.TargetPlatform.UNDEFINED){this.identifier=s,this.version=u,this.targetPlatform=l,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof g?f(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Kp=g;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(c){const s=w.exec(c);return s&&s[1]?[y(s[1]),s[2]]:[y(c),void 0]}function p(c,s){return`${c}.${s}`}function y(c){return c.toLowerCase()}function $(c,s){return y(p(c??P.$mn,s))}function m(c,s){const u=[],l=S=>{for(const v of u)if(v.some(R=>f(s(R),s(S))))return v;return null};for(const S of c){const v=l(S);v?v.push(S):u.push([S])}return u}function E(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function k(c){return{id:new a.$up(c.identifier.id),name:new a.$up(c.name),version:c.version,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$Sp=new P.$qn("pprice.better-merge");function t(c,s){const u=[],l=s.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const S=l.shift();if(S&&u.every(v=>!f(v.identifier,{id:S}))){const v=c.filter(R=>f(R.identifier,{id:S}));v.length===1&&(u.push(v[0]),l.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}async function r(c,s){if(!D.$k)return!1;let u;try{u=(await c.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await c.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){s.debug("Error while getting the os-release file.",(0,I.$_)(S))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(c,s){const u=await r(c,s),l=(0,o.$ep)(u?"alpine":D.$u,b.$gc);return s.debug("ComputeTargetPlatform:",l),l}});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[259],ae([0,1,2,36,3,26,192,18,56,73,28,45,25,58]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,a=et(a);let h=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,m,E){this.k=m,this.l=E,this.d={},this.i=new n.$Vc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=g.TelemetryLevel.USAGE,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const k of this.f)this.j.push(new RegExp((0,D.$if)(k),"gi")),k.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.$if)(k.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(k=>{(k.affectsConfiguration(g.$hm)||k.affectsConfiguration(g.$jm)||k.affectsConfiguration(g.$im))&&this.m()}))}setExperimentProperty($,m){this.d[$]=m}m(){let $=(0,w.$Dp)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const E=m.usage?g.TelemetryLevel.USAGE:m.error?g.TelemetryLevel.ERROR:g.TelemetryLevel.NONE;$=Math.min($,E)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,m,E){this.g<m||(E=(0,o.$go)(E,this.d),E=(0,w.$Ip)(E,this.j),E=(0,o.$go)(E,this.c),this.b.forEach(k=>k.log($,E)))}publicLog($,m){this.n($,g.TelemetryLevel.USAGE,m)}publicLog2($,m){this.publicLog($,m)}publicLogError($,m){this.h&&this.n($,g.TelemetryLevel.ERROR,m)}publicLogError2($,m){this.publicLogError($,m)}};e.$es=h,e.$es=h=Pe([ne(1,I.$_i),ne(2,f.$sk)],h);function p(){const y=(0,A.localize)(0,null,a.default.nameLong),$=a.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=P.$o?"":(0,A.localize)(3,null),E=(0,A.localize)(4,null),k=(0,A.localize)(5,null),t=(0,A.localize)(6,null),r=(0,A.localize)(7,null),i=`
|       | ${E} | ${k} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,c=(0,A.localize)(8,null);return`
${y} ${$} ${m}

&nbsp;

${r}
${i}

&nbsp;

${c}
`}d.$qo.as(b.$vo.Configuration).registerConfiguration({id:g.$gm,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[g.$hm]:{type:"string",enum:[g.TelemetryConfiguration.ON,g.TelemetryConfiguration.ERROR,g.TelemetryConfiguration.CRASH,g.TelemetryConfiguration.OFF],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:p(),default:g.TelemetryConfiguration.ON,restricted:!0,scope:b.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),d.$qo.as(b.$vo.Configuration).registerConfiguration({id:g.$gm,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[g.$jm]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${g.$hm}#\``),scope:b.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[260],ae([0,1,3,94,25]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=D,e.$ugc=A,e.$vgc=I;async function D(b,a){let f=b.getItem(P.$dm);return(typeof f!="string"||n.$j&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,o.$Sn)(a.error.bind(a))),f}async function A(b,a){let f=b.getItem(P.$em);return typeof f!="string"&&(f=await(0,o.$Tn)(a.error.bind(a))),f}async function I(b,a){let f=b.getItem(P.$fm);return typeof f!="string"&&(f=await(0,o.$Un)(a.error.bind(a))),f}}),define(oe[261],ae([0,1,25,260]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=P,e.$xgc=D,e.$ygc=A;async function P(I,b){const a=await(0,o.$tgc)(I,b);return I.setItem(n.$dm,a),a}async function D(I,b){const a=await(0,o.$ugc)(I,b);return I.setItem(n.$em,a),a}async function A(I,b){const a=await(0,o.$vgc)(I,b);return I.setItem(n.$fm,a),a}}),define(oe[131],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(o){o[o.Replace=1]="Replace",o[o.Append=2]="Append",o[o.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(oe[262],ae([0,1,3,131]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0;const P=new Map([[o.EnvironmentVariableMutatorType.Append,"APPEND"],[o.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[o.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(f){this.collections=f,this.a=new Map,this.b=new Map,f.forEach((d,g)=>{this.d(d,g);const w=d.map.entries();let h=w.next();for(;!h.done;){const p=h.value[1],y=h.value[0];let $=this.a.get(y);if($||($=[],this.a.set(y,$)),$.length>0&&$[0].type===o.EnvironmentVariableMutatorType.Replace){h=w.next();continue}const m={extensionIdentifier:g,value:p.value,type:p.type,scope:p.scope,variable:p.variable,options:p.options};m.scope||delete m.scope,$.unshift(m),h=w.next()}})}async applyToProcessEnvironment(f,d,g){let w;n.$i&&(w={},Object.keys(f).forEach(h=>w[h.toLowerCase()]=h));for(const[h,p]of this.getVariableMap(d)){const y=n.$i&&w[h.toLowerCase()]||h;for(const $ of p){const m=g?await g($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case o.EnvironmentVariableMutatorType.Append:f[y]=(f[y]||"")+m;break;case o.EnvironmentVariableMutatorType.Prepend:f[y]=m+(f[y]||"");break;case o.EnvironmentVariableMutatorType.Replace:f[y]=m;break}if($.options?.applyAtShellIntegration??!1){const E=`VSCODE_ENV_${P.get($.type)}`;f[E]=(f[E]?f[E]+":":"")+h+"="+this.c(m)}}}}c(f){return f.replaceAll(":","\\x3a")}diff(f,d){const g=new Map,w=new Map,h=new Map;if(f.getVariableMap(d).forEach((p,y)=>{const $=this.getVariableMap(d).get(y),m=I(p,$);m&&g.set(y,m)}),this.getVariableMap(d).forEach((p,y)=>{const $=f.getVariableMap(d).get(y),m=I(p,$);m&&h.set(y,m)}),this.getVariableMap(d).forEach((p,y)=>{const $=f.getVariableMap(d).get(y),m=b(p,$);m&&w.set(y,m)}),!(g.size===0&&w.size===0&&h.size===0))return{added:g,changed:w,removed:h}}getVariableMap(f){const d=new Map;for(const g of this.a.values()){const w=g.filter(h=>A(h,f));w.length>0&&d.set(w[0].variable,w)}return d}getDescriptionMap(f){const d=new Map;for(const g of this.b.values()){const w=g.filter(h=>A(h,f,!0));for(const h of w)d.set(h.extensionIdentifier,h.description)}return d}d(f,d){if(!f.descriptionMap)return;const g=f.descriptionMap.entries();let w=g.next();for(;!w.done;){const h=w.value[1],p=w.value[0];let y=this.b.get(p);y||(y=[],this.b.set(p,y));const $={extensionIdentifier:d,scope:h.scope,description:h.description};$.scope||delete $.scope,y.push($),w=g.next()}}}e.$Is=D;function A(a,f,d=!1){return a.scope?!!(a.scope.workspaceFolder&&f?.workspaceFolder&&a.scope.workspaceFolder.index===f.workspaceFolder.index):d?f===a.scope:!0}function I(a,f){if(!f)return a;const d=new Set;f.forEach(w=>d.add(w.extensionIdentifier));const g=[];return a.forEach(w=>{d.has(w.extensionIdentifier)||g.push(w)}),g.length===0?void 0:g}function b(a,f){if(!f)return;const d=new Map;f.forEach(w=>d.set(w.extensionIdentifier,w));const g=[];return a.forEach(w=>{const h=d.get(w.extensionIdentifier);h&&(w.type!==h.type||w.value!==h.value||w.scope?.workspaceFolder?.index!==h.scope?.workspaceFolder?.index)&&g.push(h)}),g.length===0?void 0:g}}),define(oe[263],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=n,e.$Ds=o,e.$Es=P,e.$Fs=D,e.$Gs=A,e.$Hs=I;function n(b){return[...b.entries()]}function o(b){return b?[...b.entries()]:[]}function P(b){return new Map(b)}function D(b){return new Map(b??[])}function A(b){return Array.from(b.entries()).map(a=>[a[0],n(a[1].map),o(a[1].descriptionMap)])}function I(b){return new Map(b.map(a=>[a[0],{map:P(a[1]),descriptionMap:D(a[2])}]))}}),define(oe[264],ae([0,1,8,23,4,2,5]),function(x,e,n,o,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=void 0;let I=class extends D.$Wc{constructor(a,f){super(),this.h=f,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new P.$me),this.onCreateRequest=this.g.event,this.b=a===void 0?15e3:a,this.B((0,D.$Uc)(()=>{for(const d of this.f.values())(0,D.$Rc)(d)}))}createRequest(a){return new Promise((f,d)=>{const g=++this.a;this.c.set(g,f),this.g.fire({requestId:g,...a});const w=new o.$xe;(0,n.$Gh)(this.b,w.token).then(()=>d(`Request ${g} timed out (${this.b}ms)`)),this.f.set(g,[(0,D.$Uc)(()=>w.cancel())])})}acceptReply(a,f){const d=this.c.get(a);d?(this.c.delete(a),(0,D.$Rc)(this.f.get(a)||[]),this.f.delete(a),d(f)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.$ts=I,e.$ts=I=Pe([ne(1,A.$_j)],I)}),define(oe[76],ae([0,1,6,123,45]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.$os=e.$ns=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ms=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ls=void 0,e.$ls=new o.$Wj("terminalTabFocusMode",!1,!0);var D;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var A;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var I;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(I||(e.PosixShellType=I={}));var b;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(b||(e.WindowsShellType=b={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var f;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(f||(e.TerminalIpcChannels=f={}));var d;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(d||(e.ProcessPropertyType=d={})),e.$ms=(0,n.$Fi)("ptyService");var g;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(g||(e.HeartbeatConstants=g={}));var w;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(w||(e.TerminalLocation=w={}));var h;(function(t){t.TerminalView="view",t.Editor="editor"})(h||(e.TerminalLocationString=h={}));var p;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(p||(e.LocalReconnectConstants=p={}));var y;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(y||(e.FlowControlConstants=y={}));var $;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var m;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(m||(e.ShellIntegrationStatus=m={}));var E;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(E||(e.TerminalExitReason=E={})),e.$ns={Backend:"workbench.contributions.terminal.processBackend"};class k{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(r){const i=this.b(r.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,r)}getTerminalBackend(r){return this.a.get(this.b(r))}b(r){return r?.toLowerCase()??""}}P.$qo.add(e.$ns.Backend,new k),e.$os=(0,n.$Fi)("localPtyService"),e.$ps=(0,n.$Fi)("terminalLogService")}),define(oe[265],ae([0,1,80,7,194,111]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=A,e.$vs=a,e.$ws=f,e.$xs=d;function A(g,w){const h=[{name:null,description:(0,P.localize)(0,null)}];return h.push(...g.map(p=>({name:p.profileName,description:I(p)}))),w&&h.push(...w.map(p=>({name:p.title,description:b(p)}))),{values:h.map(p=>p.name),markdownDescriptions:h.map(p=>p.description)}}function I(g){let w=`$(${D.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:n.$5j.terminal.id}) ${g.profileName}
- path: ${g.path}`;return g.args&&(typeof g.args=="string"?w+=`
- args: "${g.args}"`:w+=`
- args: [${g.args.length===0?"":`'${g.args.join("','")}'`}]`),g.overrideName!==void 0&&(w+=`
- overrideName: ${g.overrideName}`),g.color&&(w+=`
- color: ${g.color}`),g.env&&(w+=`
- env: ${JSON.stringify(g.env)}`),w}function b(g){return`$(${D.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:n.$5j.terminal.id}) ${g.title}
- extensionIdentifier: ${g.extensionIdentifier}`}function a(g,w){if(!g&&!w)return!0;if(typeof g=="string"&&typeof w=="string")return g===w;if(Array.isArray(g)&&Array.isArray(w)){if(g.length!==w.length)return!1;for(let h=0;h<g.length;h++)if(g[h]!==w[h])return!1;return!0}return!1}function f(g,w){if(!g&&!w)return!0;if(!g||!w)return!1;if(D.ThemeIcon.isThemeIcon(g)&&D.ThemeIcon.isThemeIcon(w))return g.id===w.id&&g.color===w.color;if(typeof g=="object"&&"light"in g&&"dark"in g&&typeof w=="object"&&"light"in w&&"dark"in w){const h=g,p=w;if((o.URI.isUri(h.light)||d(h.light))&&(o.URI.isUri(h.dark)||d(h.dark))&&(o.URI.isUri(p.light)||d(p.light))&&(o.URI.isUri(p.dark)||d(p.dark)))return h.light.path===p.light.path&&h.dark.path===p.dark.path}if(o.URI.isUri(g)&&o.URI.isUri(w)||d(g)||d(w)){const h=g,p=w;return h.path===p.path&&h.scheme===p.scheme}return!1}function d(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}}),define(oe[266],ae([0,1,80,3,193,56,45,76,265]),function(x,e,n,o,P,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=e.$ys=void 0,e.$As=h,e.$Bs=y,e.$ys={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$zs={type:"string",enum:Array.from((0,n.$3j)(),$=>$.id),markdownEnumDescriptions:Array.from((0,n.$3j)(),$=>`$(${$.id})`)};const a={args:{description:(0,P.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,P.localize)(1,null),type:"boolean"},icon:{description:(0,P.localize)(2,null),...e.$zs},color:{description:(0,P.localize)(3,null),...e.$ys},env:{markdownDescription:(0,P.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},f={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(5,null),type:["string","array"],items:{type:"string"}},...a}},d={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(6,null),type:["string"],items:{type:"string"}},...a}};function g($){const m=$===o.Platform.Linux?"linux":$===o.Platform.Mac?"osx":"windows";return(0,P.localize)(7,null,(0,o.$h)($),'```json\n"terminal.integrated.profile.'+m+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,P.localize)(8,null),type:"object",properties:{[I.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,P.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,P.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,P.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:g(o.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,P.localize)(12,null),enum:["PowerShell","Git Bash"]},...a}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(13,null),type:"string"},id:{description:(0,P.localize)(14,null),type:"string"},title:{description:(0,P.localize)(15,null),type:"string"},...a}},{type:"null"},f]}},[I.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:g(o.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(16,null),type:"string"},id:{description:(0,P.localize)(17,null),type:"string"},title:{description:(0,P.localize)(18,null),type:"string"},...a}},{type:"null"},f]}},[I.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:g(o.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(19,null),type:"string"},id:{description:(0,P.localize)(20,null),type:"string"},title:{description:(0,P.localize)(21,null),type:"string"},...a}},{type:"null"},f]}},[I.TerminalSettingId.UseWslProfiles]:{description:(0,P.localize)(22,null),type:"boolean",default:!0},[I.TerminalSettingId.InheritEnv]:{scope:D.ConfigurationScope.APPLICATION,description:(0,P.localize)(23,null),type:"boolean",default:!0},[I.TerminalSettingId.PersistentSessionScrollback]:{scope:D.ConfigurationScope.APPLICATION,markdownDescription:(0,P.localize)(24,null),type:"number",default:100},[I.TerminalSettingId.ShowLinkHover]:{scope:D.ConfigurationScope.APPLICATION,description:(0,P.localize)(25,null),type:"boolean",default:!0},[I.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,P.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){A.$qo.as(D.$vo.Configuration).registerConfiguration(w),y()}let p;function y($,m){const E=A.$qo.as(D.$vo.Configuration);let k;$&&(k=(0,b.$us)($?.profiles,m));const t=p;p={id:"terminal",order:100,title:(0,P.localize)(27,null),type:"object",properties:{[I.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,P.localize)(28,null),type:["string","null"],default:null,enum:$?.os===o.OperatingSystem.Linux?k?.values:void 0,markdownEnumDescriptions:$?.os===o.OperatingSystem.Linux?k?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,P.localize)(29,null),type:["string","null"],default:null,enum:$?.os===o.OperatingSystem.Macintosh?k?.values:void 0,markdownEnumDescriptions:$?.os===o.OperatingSystem.Macintosh?k?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,P.localize)(30,null),type:["string","null"],default:null,enum:$?.os===o.OperatingSystem.Windows?k?.values:void 0,markdownEnumDescriptions:$?.os===o.OperatingSystem.Windows?k?.markdownDescriptions:void 0}}},E.updateConfigurations({add:[p],remove:t?[t]:[]})}}),define(oe[267],ae([0,1,27,12,36,10,3,37,26,13,21,131,263,262]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=h,e.$Ks=p,e.$Ls=y,n=De(n),D=De(D),I=De(I),f=De(f);function h(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let S=0;return l&&l.length===4&&(S=parseInt(l[3])),S}async function p(l,S,v,R=I.env,T=f.Promises.exists){if(D.$kc(l))return await T(l)?l:void 0;if(S===void 0&&(S=I.cwd()),D.$oc(l)!=="."){const B=D.$lc(S,l);return await T(B)?B:void 0}const O=(0,P.$ko)(R,"PATH");if(v===void 0&&(0,a.$fg)(O)&&(v=O.split(D.$vc)),v===void 0||v.length===0){const B=D.$lc(S,l);return await T(B)?B:void 0}for(const B of v){let C;if(D.$kc(B)?C=D.$lc(B,l):C=D.$lc(S,B,l),await T(C))return C;if(A.$i){let z=C+".com";if(await T(z)||(z=C+".exe",await T(z)))return z}}const F=D.$lc(S,l);return await T(F)?F:void 0}function y(l,S,v,R,T){const L=A.$i&&(!S.windowsEnableConpty||h()<18309);if(!S.shellIntegration.enabled||!l.executable||l.isFeatureTerminal&&!l.forceShellIntegration||l.ignoreShellIntegration||L)return;const O=l.args,F=I.$fc==="win32"?D.$pc(l.executable).toLowerCase():D.$pc(l.executable),B=D.$oc(o.$Zg.asFileUri("").fsPath);let C;const z={VSCODE_INJECTION:"1"};if(S.shellIntegration.nonce&&(z.VSCODE_NONCE=S.shellIntegration.nonce),A.$i){if(F==="pwsh.exe"||F==="powershell.exe")return!O||s(O)?C=E.get(m.WindowsPwsh):c(O)&&(C=E.get(m.WindowsPwshLogin)),C?(C=[...C],C[C.length-1]=(0,b.$ef)(C[C.length-1],B,""),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",S.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),{newArgs:C,envMixin:z}):void 0;if(F==="bash.exe")return!O||O.length===0?C=E.get(m.Bash):u(O)&&(z.VSCODE_SHELL_LOGIN="1",$(S,z),C=E.get(m.Bash)),C?(C=[...C],C[C.length-1]=(0,b.$ef)(C[C.length-1],B),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:C,envMixin:z}):void 0;R.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(F){case"bash":return!O||O.length===0?C=E.get(m.Bash):u(O)&&(z.VSCODE_SHELL_LOGIN="1",$(S,z),C=E.get(m.Bash)),C?(C=[...C],C[C.length-1]=(0,b.$ef)(C[C.length-1],B),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:C,envMixin:z}):void 0;case"fish":{const re=v?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Q=D.$lc(B,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${re}:${Q}`,$(S,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!O||s(O)?C=E.get(m.Pwsh):c(O)&&(C=E.get(m.PwshLogin)),C?(S.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),C=[...C],C[C.length-1]=(0,b.$ef)(C[C.length-1],B,""),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:C,envMixin:z}):void 0;case"zsh":{if(!O||O.length===0?C=E.get(m.Zsh):u(O)?(C=E.get(m.ZshLogin),$(S,z)):(O===E.get(m.Zsh)||O===E.get(m.ZshLogin))&&(C=O),!C)return;C=[...C],C[C.length-1]=(0,b.$ef)(C[C.length-1],B);let re;try{re=n.userInfo().username}catch{re="unknown"}const Q=D.$lc(n.tmpdir(),`${re}-${T.applicationName}-zsh`);z.ZDOTDIR=Q;const le=v?.ZDOTDIR??n.homedir()??"~";z.USER_ZDOTDIR=le;const K=[];return K.push({source:D.$lc(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$lc(Q,".zshrc")}),K.push({source:D.$lc(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$lc(Q,".zprofile")}),K.push({source:D.$lc(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$lc(Q,".zshenv")}),K.push({source:D.$lc(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$lc(Q,".zlogin")}),{newArgs:C,envMixin:z,filesToCopy:K}}}R.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}function $(l,S){if(A.$j&&l.environmentVariableCollections){const v=(0,g.$Hs)(l.environmentVariableCollections),T=new w.$Is(v).getVariableMap({workspaceFolder:l.workspaceFolder}).get("PATH"),L=[];if(T)for(const O of T)O.type===d.EnvironmentVariableMutatorType.Prepend&&L.push(O.value);L.length>0&&(S.VSCODE_PATH_PREFIX=L.join(""))}}var m;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})(m||(m={}));const E=new Map;E.set(m.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),E.set(m.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),E.set(m.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),E.set(m.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),E.set(m.Zsh,["-i"]),E.set(m.ZshLogin,["-il"]),E.set(m.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const k=["-login","-l"],t=["--login","-l"],r=["-i","--interactive"],i=["-nol","-nologo"];function c(l){return typeof l=="string"?k.includes(l.toLowerCase()):l.length===1&&k.includes(l[0].toLowerCase())||l.length===2&&(k.includes(l[0].toLowerCase())||k.includes(l[1].toLowerCase()))&&(i.includes(l[0].toLowerCase())||i.includes(l[1].toLowerCase()))}function s(l){return typeof l=="string"?i.includes(l.toLowerCase()):l.length===0||l?.length===1&&i.includes(l[0].toLowerCase())}function u(l){return typeof l!="string"&&(l=l.filter(S=>!r.includes(S.toLowerCase()))),l==="string"&&t.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&t.includes(l[0].toLowerCase())}}),define(oe[268],ae([0,1,49,80,10,3,13,21,115,76,267,122]),function(x,e,n,o,P,D,A,I,b,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=p,n=De(n),I=De(I);var g;(function(S){S.UnixShellsPath="/etc/shells"})(g||(g={}));let w,h=!0;function p(S,v,R,T,L=process.env,O,F,B,C){return O=O||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},D.$i?y(R,O,L,F,T.getValue(a.TerminalSettingId.UseWslProfiles)!==!1,S&&typeof S=="object"?{...S}:T.getValue(a.TerminalSettingId.ProfilesWindows),typeof v=="string"?v:T.getValue(a.TerminalSettingId.DefaultProfileWindows),C,B):s(O,F,R,S&&typeof S=="object"?{...S}:T.getValue(D.$k?a.TerminalSettingId.ProfilesLinux:a.TerminalSettingId.ProfilesMacOs),typeof v=="string"?v:T.getValue(D.$k?a.TerminalSettingId.DefaultProfileLinux:a.TerminalSettingId.DefaultProfileMacOs),C,B,L)}async function y(S,v,R,T,L,O,F,B,C){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),re=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let Q=!1;(0,f.$Js)()>=16299&&(Q=!0),await k(B);const le=new Map;if(S){le.set("PowerShell",{source:a.ProfileSource.Pwsh,icon:o.$5j.terminalPowershell,isAutoDetected:!0}),le.set("Windows PowerShell",{path:`${re}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:o.$5j.terminalPowershell,isAutoDetected:!0}),le.set("Git Bash",{source:a.ProfileSource.GitBash,isAutoDetected:!0}),le.set("Command Prompt",{path:`${re}\\cmd.exe`,icon:o.$5j.terminalCmd,isAutoDetected:!0}),le.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),le.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:o.$5j.terminalBash,isAutoDetected:!0});const ee=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;le.set("Cmder",{path:`${re}\\cmd.exe`,args:["/K",ee],requiresPath:process.env.CMDER_ROOT?ee:{path:ee,isUnsafe:!0},isAutoDetected:!0})}u(O,le);const K=await $(le.entries(),F,v,R,T,C);if(S&&L)try{const ee=await i(`${re}\\${Q?"wsl":"bash"}.exe`,F);for(const q of ee)(!O||!(q.profileName in O))&&K.push(q)}catch{h&&(T?.trace("WSL is not installed, so could not detect WSL profiles"),h=!1)}return K}async function $(S,v,R,T=process.env,L,O){const F=[];for(const[B,C]of S)F.push(m(B,C,v,R,T,L,O));return(await Promise.all(F)).filter(B=>!!B)}async function m(S,v,R,T,L=process.env,O,F){if(v===null)return;let B,C,z;if("source"in v&&!("path"in v)){const K=w?.get(v.source);if(!K)return;B=K.paths,C=v.args||K.args,v.icon?z=E(v.icon):K.icon&&(z=K.icon)}else B=Array.isArray(v.path)?v.path:[v.path],C=D.$i||Array.isArray(v.args)?v.args:void 0,z=E(v.icon);let re;if(F){const K=B.map(q=>typeof q=="string"?q:q.path),ee=await F(K);re=new Array(B.length);for(let q=0;q<B.length;q++)typeof B[q]=="string"?re[q]=ee[q]:re[q]={path:ee[q],isUnsafe:!0}}else re=B.slice();let Q;if(v.requiresPath){let K;if((0,A.$fg)(v.requiresPath)?K=v.requiresPath:(K=v.requiresPath.path,v.requiresPath.isUnsafe&&(Q=K)),!await T.existsFile(K))return}const le=await l(S,R,re,T,L,C,v.env,v.overrideName,v.isAutoDetected,Q);if(!le){O?.debug("Terminal profile not validated",S,B);return}return le.isAutoDetected=v.isAutoDetected,le.icon=z,le.color=v.color,le}function E(S){return typeof S=="string"?{id:S}:S}async function k(S){if(w&&!S)return;const[v,R]=await Promise.all([t(),S||r()]);w=new Map,w.set(a.ProfileSource.GitBash,{profileName:"Git Bash",paths:v,args:["--login","-i"]}),w.set(a.ProfileSource.Pwsh,{profileName:"PowerShell",paths:R,icon:o.$5j.terminalPowershell})}async function t(){const S=new Set,v=await(0,f.$Ks)("git.exe");if(v){const L=(0,d.dirname)(v);S.add((0,d.resolve)(L,"../.."))}function R(L,O){O&&L.add(O)}R(S,process.env.ProgramW6432),R(S,process.env.ProgramFiles),R(S,process.env["ProgramFiles(X86)"]),R(S,`${process.env.LocalAppData}\\Program`);const T=[];for(const L of S)T.push(`${L}\\Git\\bin\\bash.exe`,`${L}\\Git\\usr\\bin\\bash.exe`,`${L}\\usr\\bin\\bash.exe`);return T.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),T.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),T}async function r(){const S=[];for await(const v of(0,b.$vm)())S.push(v.exePath);return S}async function i(S,v){const R=[],T=await new Promise((F,B)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(C,z)=>{if(C)return B("Problem occurred when getting wsl distros");F(z)})});if(!T)return[];const L=new RegExp(/[\r?\n]/),O=T.split(L).filter(F=>F.trim().length>0&&F!=="");for(const F of O){if(F===""||F.startsWith("docker-desktop"))continue;const B=`${F} (WSL)`,C={profileName:B,path:S,args:["-d",`${F}`],isDefault:B===v,icon:c(F),isAutoDetected:!1};R.push(C)}return R}function c(S){return S.includes("Ubuntu")?o.$5j.terminalUbuntu:S.includes("Debian")?o.$5j.terminalDebian:o.$5j.terminalLinux}async function s(S,v,R,T,L,O,F,B){const C=new Map;if(R&&await S.existsFile(g.UnixShellsPath)){const z=(await S.readFile(g.UnixShellsPath)).toString(),re=(O||z.split(`
`)).map(le=>{const K=le.indexOf("#");return K===-1?le:le.substring(0,K)}).filter(le=>le.trim().length>0),Q=new Map;for(const le of re){let K=(0,P.$pc)(le),ee=Q.get(K)||0;ee++,ee>1&&(K=`${K} (${ee})`),Q.set(K,ee),C.set(K,{path:le,isAutoDetected:!0})}}return u(T,C),await $(C.entries(),L,S,B,v,F)}function u(S,v){if(S)for(const[R,T]of Object.entries(S))T===null||typeof T!="object"||!("path"in T)&&!("source"in T)?v.delete(R):(T.icon=T.icon||v.get(R)?.icon,v.set(R,T))}async function l(S,v,R,T,L,O,F,B,C,z){if(R.length===0)return Promise.resolve(void 0);const re=R.shift();if(re==="")return l(S,v,R,T,L,O,F,B,C);const Q=typeof re!="string"&&re.isUnsafe,le=typeof re=="string"?re:re.path,K={profileName:S,path:le,args:O,env:F,overrideName:B,isAutoDetected:C,isDefault:S===v,isUnsafePath:Q,requiresUnsafePath:z};if((0,P.$pc)(le)===le){const q=L.PATH?L.PATH.split(P.$vc):void 0,j=await(0,f.$Ks)(le,void 0,q,void 0,T.existsFile);return j?(K.path=j,K.isFromPath=!0,K):l(S,v,R,T,L,O)}return await T.existsFile((0,P.$jc)(le))?K:l(S,v,R,T,L,O,F,B,C)}}),define(oe[269],ae([0,1,4,2,3,44,18,5,231,101,264,76,266,268,117,67]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0;var y;(function(m){m[m.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let $=class extends o.$Wc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(E,k,t,r){super(),this.M=E,this.N=k,this.O=t,this.P=r,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$me),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$me),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$me),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$me),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$me),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$me),this.onProcessData=this.D.event,this.F=this.B(new n.$me),this.onProcessReady=this.F.event,this.G=this.B(new n.$me),this.onProcessReplay=this.G.event,this.H=this.B(new n.$me),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$me),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$me),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$me),this.onProcessExit=this.L.event,(0,g.$As)(),this.B(this.M),this.B((0,o.$Uc)(()=>this.W())),this.j=this.B(new f.$ts(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(n.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(d.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(P.$i)return process.env;try{return await(0,a.$Qm)(this.N,this.O,{_:[]},process.env)}catch(E){return this.O.error("ptyHost was unable to resolve shell environment",E),{}}}U(){const E=this.M.start(),k=E.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),D.ProxyChannel.toService(k.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(E.onDidProcessExit(i=>{this.u.fire(i.code),!this.m&&!this.q.isDisposed&&(this.n<=y.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${i.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const r=D.ProxyChannel.toService(k.getChannel(d.TerminalIpcChannels.PtyHost));return this.B(r.onProcessData(i=>this.D.fire(i))),this.B(r.onProcessReady(i=>this.F.fire(i))),this.B(r.onProcessExit(i=>this.L.fire(i))),this.B(r.onDidChangeProperty(i=>this.J.fire(i))),this.B(r.onProcessReplay(i=>this.G.fire(i))),this.B(r.onProcessOrphanQuestion(i=>this.H.fire(i))),this.B(r.onDidRequestDetach(i=>this.I.fire(i))),this.B(new b.$ss(this.P,k.getChannel(d.TerminalIpcChannels.Logger))),this.a=E,this.b=r,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async i=>{i.affectsConfiguration(d.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[E,r]}async createProcess(E,k,t,r,i,c,s,u,l,S,v){const R=setTimeout(()=>this.$(),d.HeartbeatConstants.CreateProcessTimeout),T=await this.f.createProcess(E,k,t,r,i,c,s,u,l,S,v);return clearTimeout(R),T}updateTitle(E,k,t){return this.f.updateTitle(E,k,t)}updateIcon(E,k,t,r){return this.f.updateIcon(E,k,t,r)}attachToProcess(E){return this.f.attachToProcess(E)}detachFromProcess(E,k){return this.f.detachFromProcess(E,k)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(E){return this.f.start(E)}shutdown(E,k){return this.f.shutdown(E,k)}input(E,k){return this.f.input(E,k)}processBinary(E,k){return this.f.processBinary(E,k)}resize(E,k,t){return this.f.resize(E,k,t)}clearBuffer(E){return this.f.clearBuffer(E)}acknowledgeDataEvent(E,k){return this.f.acknowledgeDataEvent(E,k)}setUnicodeVersion(E,k){return this.f.setUnicodeVersion(E,k)}getInitialCwd(E){return this.f.getInitialCwd(E)}getCwd(E){return this.f.getCwd(E)}async getLatency(){const E=new p.$ge,k=await this.f.getLatency();return E.stop(),[{label:"ptyhostservice<->ptyhost",latency:E.elapsed()},...k]}orphanQuestionReply(E){return this.f.orphanQuestionReply(E)}installAutoReply(E,k){return this.f.installAutoReply(E,k)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(E){return this.f.uninstallAutoReply(E)}getDefaultSystemShell(E){return this.g?.getDefaultSystemShell(E)??(0,h.$zm)(E??P.OS,process.env)}async getProfiles(E,k,t,r=!1){const i=await this.S();return(0,w.$Ms)(k,t,r,this.N,i,void 0,this.O,this.bb.bind(this,E))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(E,k){return this.f.getWslPath(E,k)}getRevivedPtyNewId(E,k){return this.f.getRevivedPtyNewId(E,k)}setTerminalLayoutInfo(E){return this.f.setTerminalLayoutInfo(E)}async getTerminalLayoutInfo(E){return this.g?.getTerminalLayoutInfo(E)}async requestDetachInstance(E,k){return this.f.requestDetachInstance(E,k)}async acceptDetachInstanceReply(E,k){return this.f.acceptDetachInstanceReply(E,k)}async freePortKillProcess(E){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(E)}async serializeTerminalState(E){return this.f.serializeTerminalState(E)}async reviveTerminalProcesses(E,k,t){return this.f.reviveTerminalProcesses(E,k,t)}async refreshProperty(E,k){return this.f.refreshProperty(E,k)}async updateProperty(E,k,t){return this.f.updateProperty(E,k,t)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(E){this.ab(),this.s=setTimeout(()=>this.Y(),E?d.HeartbeatConstants.ConnectingBeatInterval:d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(E,k){return this.j.createRequest({workspaceId:E,originalText:k})}async acceptPtyHostResolvedVariables(E,k){this.j.acceptReply(E,k)}};e.$Ns=$,e.$Ns=$=Pe([ne(1,A.$_i),ne(2,I.$_j),ne(3,I.$ak)],$)}),define(oe[77],ae([0,1,14,4,2,3,18,6,34]),function(x,e,n,o,P,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=e.$Sec=void 0;const a="#FFFFFF",f="#1E1E1E",d="#000000",g="#FFFFFF",w="theme",h="themeBackground",p="windowSplash";var y;(function(m){m.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",m.SYSTEM_COLOR_THEME="window.systemColorTheme"})(y||(y={})),e.$Sec=(0,I.$Fi)("themeMainService");let $=class extends P.$Wc{constructor(E,k){super(),this.b=E,this.c=k,this.a=this.B(new o.$me),this.onDidChangeColorScheme=this.a.event,D.$k||this.B(this.c.onDidChangeConfiguration(t=>{(t.affectsConfiguration(y.SYSTEM_COLOR_THEME)||t.affectsConfiguration(y.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(o.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(D.$k||this.c.getValue(y.DETECT_COLOR_SCHEME))n.nativeTheme.themeSource="system";else switch(this.c.getValue(y.SYSTEM_COLOR_THEME)){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(D.$i){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(D.$j){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(D.$k&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const E=this.getColorScheme();if(E.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return E.dark?d:g;let k=this.b.getItem(h,null);if(!k)switch(this.g()){case"vs":k=a;break;case"hc-black":k=d;break;case"hc-light":k=g;break;default:k=f}return D.$j&&k.toUpperCase()===f&&(k="#171717"),k}g(){switch(this.b.getItem(w,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(E,k){this.b.setItems([{key:w,data:k.baseTheme},{key:h,data:k.colorInfo.background},{key:p,data:k}]),typeof E=="number"&&this.h(E,k),this.f()}h(E,k){for(const t of n.BrowserWindow.getAllWindows())if(t.id===E){t.setBackgroundColor(k.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(p)}};e.$Tec=$,e.$Tec=$=Pe([ne(0,b.$gR),ne(1,A.$_i)],$)}),define(oe[132],ae([0,1,4,2,3,7,18,6,5]),function(x,e,n,o,P,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lw=e.$Kw=e.$Hw=e.$Fw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bw=e.$Aw=void 0,e.$Cw=d,e.$Dw=w,e.$Ew=h,e.$Gw=p,e.$Iw=y,e.$Jw=$,e.$Aw=(0,I.$Fi)("tunnelService"),e.$Bw=(0,I.$Fi)("sharedTunnelsService");var a;(function(k){k.Http="http",k.Https="https"})(a||(e.TunnelProtocol=a={}));var f;(function(k){k.ConstantPrivate="constantPrivate",k.Private="private",k.Public="public"})(f||(e.TunnelPrivacyId=f={}));function d(k){return!!k.forwardPort}var g;(function(k){k[k.Notify=1]="Notify",k[k.OpenBrowser=2]="OpenBrowser",k[k.OpenPreview=3]="OpenPreview",k[k.Silent=4]="Silent",k[k.Ignore=5]="Ignore",k[k.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function w(k){if(k.scheme!=="http"&&k.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(k.authority);if(t)return{address:t[1],port:+t[2]}}function h(k){if(k.scheme!=="http"&&k.scheme!=="https"||!k.query)return;const t=k.query.split("&");for(const r of t){const i=r.split("=")[1];if(/^https?:/.exec(i)){const c=w(D.URI.parse(i));if(c)return c}}}e.$Fw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(k){return e.$Fw.indexOf(k)>=0}e.$Hw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(k){return e.$Hw.indexOf(k)>=0}function $(k,t,r,i){if(r===P.OperatingSystem.Windows)return!1;if(r===P.OperatingSystem.Macintosh&&y(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(c?.length===4&&parseInt(c[1])>=18)return!1}return k<1024}class m{constructor(t,r,i){this.remoteAddress=t,this.localAddress=r,this.b=i,this.a=new n.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Kw=m;let E=class extends o.$Wc{constructor(t,r){super(),this.r=t,this.s=r,this.a=new n.$me,this.onTunnelOpened=this.a.event,this.b=new n.$me,this.onTunnelClosed=this.b.event,this.c=new n.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],r=Array.from(this.f.values());for(const i of r){const c=Array.from(i.values());for(const s of c){const u=await s.value;u&&typeof u!="string"&&t.push(u)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:r}of t.values())await r.then(i=>typeof i!="string"?i?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,r,i,c,s){this.z(t,r,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:r,localAddress:i,privacy:c,protocol:s,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,r){(y(t)||p(t))&&(t=e.$Fw[0]);const i=this.D(t,r);if(i)return++i.refcount,i.value}openTunnel(t,r,i,c,s,u=!1,l,S){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${i} on local port ${s}.`);const v=this.g??t;if(!v)return;if(r||(r="localhost"),c||(c=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const R=this.F(v,r,i,c,s,u,l,S);return R?R.then(T=>{if(T){if(typeof T=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(r,i),T}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(r,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const L=this.w(T);return(T.tunnelRemoteHost!==r||T.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&T.privacy!==l&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(L),L}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),R)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const r=this.f.get(t.tunnelRemoteHost);if(r){const i=r.get(t.tunnelRemotePort);i&&(i.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,i))}}}}async y(t,r,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${r}.`);const c=i.value.then(async s=>{s&&typeof s!="string"&&(await s.dispose(!0),this.b.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(r),c}}async closeTunnel(t,r){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${r} `);const i=this.f.get(t);if(i&&i.has(r)){const c=i.get(r);c.refcount=0,await this.y(t,r,c)}}z(t,r,i){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(r,{refcount:1,value:i})}async C(t,r){const i=this.f.get(t);if(i){const c=i.get(r),s=c?await c.value:void 0;(!s||typeof s=="string")&&i.delete(r),i.size===0&&this.f.delete(t)}}D(t,r){const i=[t];p(t)?(i.push(...e.$Fw),i.push(...e.$Hw)):y(t)&&i.push(...e.$Hw);const c=i.map(s=>this.f.get(s));for(const s of c){const u=s?.get(r);if(u)return u}}canTunnel(t){return!!w(t)}G(t,r,i,c,s,u,l){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${i} on local port ${c}.`);const S=i;this.n.add(S);const v=c===void 0?i:c,R={elevationRequired:s?this.isPortPrivileged(v):!1},T={remoteAddress:{host:r,port:i},localAddressPort:c,privacy:u,public:u?u!==f.Private:void 0,protocol:l},L=t.forwardPort(T,R);return L?(this.z(r,i,L),L.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(S)})):this.n.delete(S),L}};e.$Lw=E,e.$Lw=E=Pe([ne(0,b.$_j),ne(1,A.$_i)],E)}),define(oe[50],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EY=e.$DY=e.DisablementReason=e.UpdateType=e.StateType=void 0;var o;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.Disabled="disabled",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(o||(e.StateType=o={}));var P;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap"})(P||(e.UpdateType=P={}));var D;(function(A){A[A.NotBuilt=0]="NotBuilt",A[A.DisabledByEnvironment=1]="DisabledByEnvironment",A[A.ManuallyDisabled=2]="ManuallyDisabled",A[A.MissingConfiguration=3]="MissingConfiguration",A[A.InvalidConfiguration=4]="InvalidConfiguration",A[A.RunningAsAdmin=5]="RunningAsAdmin"})(D||(e.DisablementReason=D={})),e.$DY={Uninitialized:{type:o.Uninitialized},Disabled:A=>({type:o.Disabled,reason:A}),Idle:(A,I)=>({type:o.Idle,updateType:A,error:I}),CheckingForUpdates:A=>({type:o.CheckingForUpdates,explicit:A}),AvailableForDownload:A=>({type:o.AvailableForDownload,update:A}),Downloading:{type:o.Downloading},Downloaded:A=>({type:o.Downloaded,update:A}),Updating:A=>({type:o.Updating,update:A}),Ready:A=>({type:o.Ready,update:A})},e.$EY=(0,n.$Fi)("updateService")}),define(oe[270],ae([0,1,3,195,56,45]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.$qo.as(P.$vo.Configuration).registerConfiguration({id:"update",order:15,title:(0,o.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:P.ConfigurationScope.APPLICATION,description:(0,o.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,o.localize)(2,null),(0,o.localize)(3,null),(0,o.localize)(4,null),(0,o.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:P.ConfigurationScope.APPLICATION,description:(0,o.localize)(6,null),deprecationMessage:(0,o.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:P.ConfigurationScope.APPLICATION,title:(0,o.localize)(8,null),description:(0,o.localize)(9,null),included:n.$i&&!n.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:P.ConfigurationScope.APPLICATION,description:(0,o.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(oe[271],ae([0,1,4,50]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=e.$6fc=void 0;class P{constructor(I){this.a=I}listen(I,b){switch(b){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${b}`)}call(I,b,a){switch(b){case"checkForUpdates":return this.a.checkForUpdates(a);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(a)}throw new Error(`Call not found: ${b}`)}}e.$6fc=P;class D{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new n.$me,this.onStateChange=this.a.event,this.b=o.$DY.Uninitialized,this.c.listen("onStateChange")(b=>this.state=b),this.c.call("_getInitialState").then(b=>this.state=b)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.$7fc=D}),define(oe[41],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,n.$Fi)("IUriIdentityService")}),define(oe[272],ae([0,1,41,211,15,19,144,4,2]),function(x,e,n,o,P,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class a{static{this._clock=0}constructor(g){this.uri=g,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let f=class{constructor(g){this.g=g,this.c=new b.$Vc,this.f=2**16;const w=new Map,h=p=>{let y=w.get(p.scheme);return y===void 0&&(y=g.hasProvider(p)&&!this.g.hasCapability(p,P.FileSystemProviderCapabilities.PathCaseSensitive),w.set(p.scheme,y)),y};this.c.add(I.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(p=>{w.delete(p.scheme)})),this.extUri=new D.$8g(h),this.d=new A.$Qs((p,y)=>this.extUri.compare(p,y,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,D.$hh)(g));const w=this.d.get(g);return w?w.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new a(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((h,p)=>h[1].time<p[1].time?1:h[1].time>p[1].time?-1:0);a._clock=0,this.d.clear();const w=this.f*.5;for(let h=0;h<w;h++)this.d.set(g[h][0],g[h][1].touch())}};e.$Rs=f,e.$Rs=f=Pe([ne(0,P.$_k)],f),(0,o.$Os)(n.$Jl,f,o.InstantiationType.Delayed)}),define(oe[133],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uY=void 0,e.$uY=(0,n.$Fi)("urlService")}),define(oe[273],ae([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=e.$cgc=e.$bgc=void 0;class o{constructor(I){this.a=I}listen(I,b){throw new Error(`Event not found: ${b}`)}call(I,b,a){switch(b){case"handleURL":return this.a.handleURL(n.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${b}`)}}e.$bgc=o;class P{constructor(I){this.a=I}handleURL(I,b){return this.a.call("handleURL",[I.toJSON(),b])}}e.$cgc=P;class D{constructor(I,b){this.a=I,this.b=b}async routeCall(I,b,a,f){if(b!=="handleURL")throw new Error(`Call not found: ${b}`);if(Array.isArray(a)&&a.length>0){const d=n.URI.revive(a[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",d.toString(!0)),d.query){const g=/\bwindowId=(\d+)/.exec(d.query);if(g){const w=g[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${w}"`,d.toString(!0));const h=new RegExp(`window:${w}`),p=I.connections.find(y=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",y.ctx),h.test(y.ctx)));if(p)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",d.toString(!0)),p;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",d.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",d.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(I,b,a,f)}routeEvent(I,b){throw new Error(`Event not found: ${b}`)}}e.$dgc=D}),define(oe[274],ae([0,1,8,2,7,28]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wY=e.$vY=void 0;class A extends o.$Wc{constructor(){super(...arguments),this.a=new Set}open(a,f){const d=[...this.a.values()];return(0,n.$Jh)(d.map(g=>()=>g.handleURL(a,f)),void 0,!1).then(g=>g||!1)}registerHandler(a){return this.a.add(a),(0,o.$Uc)(()=>this.a.delete(a))}}e.$vY=A;let I=class extends A{constructor(a){super(),this.b=a}create(a){let{authority:f,path:d,query:g,fragment:w}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return f&&d&&d.indexOf("/")!==0&&(d=`/${d}`),P.URI.from({scheme:this.b.urlProtocol,authority:f,path:d,query:g,fragment:w})}};e.$wY=I,e.$wY=I=Pe([ne(0,D.$sk)],I)}),define(oe[275],ae([0,1,14,8,4,2,3,7]),function(x,e,n,o,P,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0;class b extends D.$Wc{constructor(f,d,g,w,h,p){if(super(),this.c=d,this.f=p,this.a=[],this.b=0,f&&(p.trace("ElectronURLListener initialUrisToHandle:",f.map(m=>m.originalUrl)),this.a=f),A.$i){const m=w.isBuilt?[]:[`"${w.appRoot}"`];m.push("--open-url","--"),n.app.setAsDefaultProtocolClient(h.urlProtocol,process.execPath,m)}const y=P.Event.map(P.Event.fromNodeEventEmitter(n.app,"open-url",(m,E)=>({event:m,url:E})),({event:m,url:E})=>(m.preventDefault(),E));this.B(y(m=>{const E=this.g(m);E&&this.c.open(E,{originalUrl:m})})),g.getWindows().filter(m=>m.isReady).length>0?(p.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(p.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(P.Event.once(g.onDidSignalReadyWindow)(()=>this.h())))}g(f){try{return I.URI.parse(f)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const f=[];for(const d of this.a)await this.c.open(d.uri,{originalUrl:d.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",d.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",d.originalUrl),f.push(d));f.length!==0&&(this.a=f,(0,o.$Hh)(()=>this.h(),500,this.q))}}e.$egc=b}),define(oe[276],ae([0,1,4,2,15,61,32]),function(x,e,n,o,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0;class I extends o.$Wc{constructor(a,f,d,g,w,h){super(),this.f=a,this.g=f,this.h=d,this.j=g,this.m=w,this.n=h,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$me),this.onDidChangeFile=this.a.event,this.b=D.$Li.forUris(()=>!(this.capabilities&P.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new A.$Dc(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(g.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,f){return this.g.open(this.t(a),f)}close(a){return this.g.close(a)}read(a,f,d,g,w){return this.g.read(a,f,d,g,w)}write(a,f,d,g,w){return this.g.write(a,f,d,g,w)}watch(a,f){this.b.set(a,a);const d=this.g.watch(this.t(a),f);return(0,o.$Uc)(()=>{this.b.delete(a),d.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,f,d){return this.g.rename(this.t(a),this.t(f),d)}readFile(a,f){return this.g.readFile(this.t(a),f)}readFileStream(a,f,d){return this.g.readFileStream(this.t(a),f,d)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,f,d){return this.g.writeFile(this.t(a),f,d)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,f){return this.g.delete(this.t(a),f)}copy(a,f,d){if((0,P.$dl)(this.g))return this.g.copy(this.t(a),this.t(f),d);throw new Error("copy not supported")}cloneFile(a,f){if((0,P.$el)(this.g))return this.g.cloneFile(this.t(a),this.t(f));throw new Error("clone not supported")}s(a){const f=[];for(const d of a){if(d.resource.scheme!==this.f)continue;const g=this.u(d.resource);this.b.findSubstr(g)&&f.push({resource:g,type:d.type,cId:d.cId})}f.length&&(this.n.debug("User data changed"),this.a.fire(f))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$Tgc=I}),define(oe[277],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0,e.$Agc="utilityProcessWorker"}),define(oe[278],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0,e.$fgc=(0,n.$Fi)("webviewManagerService")}),define(oe[279],ae([0,1,14,2,12,7]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;class A extends o.$Wc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const b=this.b.bind(this);n.protocol.registerFileProtocol(P.Schemas.vscodeWebview,b)}b(b,a){try{const f=D.URI.parse(b.url),d=A.a.get(f.path);if(typeof d=="string"){const g=`vs/workbench/contrib/webview/browser/pre/${d}`,w=P.$Zg.asFileUri(g);return a({path:w.fsPath,headers:{...P.COI.getHeadersFromQuery(b.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.$ggc=A}),define(oe[51],ae([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7D=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$XD=void 0,e.$YD=o,e.$ZD=P,e.$1D=D,e.$2D=A,e.$3D=I,e.$4D=d,e.$5D=g,e.$6D=w,e.$8D=h,e.$9D=p,e.$0D=y,e.$XD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function o($){return typeof $.parentId=="number"}function P($){return!!$.workspaceUri}function D($){return!!$.folderUri}function A($){return!!$.fileUri}function I($){const m=g($),E=$.getValue("window.menuBarVisibility");return E==="default"||m&&E==="compact"||n.$j&&n.$m?"classic":E}var b;(function($){$.TITLE_BAR_STYLE="window.titleBarStyle",$.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(b||(e.TitleBarSetting=b={}));var a;(function($){$.NATIVE="native",$.CUSTOM="custom"})(a||(e.TitlebarStyle=a={}));var f;(function($){$.AUTO="auto",$.WINDOWED="windowed",$.NEVER="never"})(f||(e.CustomTitleBarVisibility=f={}));function d($,m){return!0}function g($,m){return m||(m=w($)),m===a.NATIVE}function w($){if(n.$o)return a.CUSTOM;const m=$.getValue("window");if(m){if(n.$j&&m.nativeTabs===!0||n.$j&&m.nativeFullScreen===!1)return a.NATIVE;const t=m.titleBarStyle;if(t===a.NATIVE||t===a.CUSTOM)return t}return n.$k?a.NATIVE:a.CUSTOM}e.$7D=35;function h($){return!(!n.$i||n.$o||g($))}function p($){const m=$.getValue("window");return!m||typeof m.nativeFullScreen!="boolean"||m.nativeTabs?!0:m.nativeFullScreen!==!1}function y($=0){return Math.pow(1.2,$)}}),define(oe[52],ae([0,1,14]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$Iec=e.$Hec=e.UnloadReason=e.LoadReason=void 0;var o;(function(a){a[a.INITIAL=1]="INITIAL",a[a.LOAD=2]="LOAD",a[a.RELOAD=3]="RELOAD"})(o||(e.LoadReason=o={}));var P;(function(a){a[a.CLOSE=1]="CLOSE",a[a.QUIT=2]="QUIT",a[a.RELOAD=3]="RELOAD",a[a.LOAD=4]="LOAD"})(P||(e.UnloadReason=P={}));const D=function(a=I.Normal){return{width:1024,height:768,mode:a}};e.$Hec=D;const A=function(){const d=n.screen.getPrimaryDisplay().workArea,g=Math.max(d.x+d.width/2-800/2,0),w=Math.max(d.y+d.height/2-600/2,0);return{x:g,y:w,width:800,height:600,mode:I.Normal}};e.$Iec=A;var I;(function(a){a[a.Maximized=0]="Maximized",a[a.Normal=1]="Normal",a[a.Minimized=2]="Minimized",a[a.Fullscreen=3]="Fullscreen"})(I||(e.WindowMode=I={}));var b;(function(a){a[a.UNRESPONSIVE=1]="UNRESPONSIVE",a[a.PROCESS_GONE=2]="PROCESS_GONE",a[a.LOAD=3]="LOAD"})(b||(e.WindowError=b={}))}),define(oe[280],ae([0,1,8,4,2]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class D extends P.$Wc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:b,getActiveWindowId:a}){super(),this.a=this.B(new P.$Vc),o.Event.latch(o.Event.any(I,b))(this.f,this,this.a),this.b=(0,n.$sh)(()=>a()),(async()=>{try{const d=await this.b;this.c=typeof this.c=="number"?this.c:d}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$mgc=D}),define(oe[30],ae([0,1,199,10,61,19,7,6,12]),function(x,e,n,o,P,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=a,e.$Qi=f,e.$Ti=d,e.$Ui=g,e.$Vi=w,e.$Wi=p,e.$Xi=y,e.$1i=E,e.$6i=k,e.$7i=t,e.$9i=r,e.$0i=i,e.$$i=c,e.$Oi=(0,I.$Fi)("contextService");function a(s){const u=s;return typeof u?.id=="string"&&A.URI.isUri(u.uri)}function f(s){return typeof s?.id=="string"&&!a(s)&&!g(s)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function d(s,u){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,o.$pc)(s)}:u?e.$Ri:e.$Si;const l=s;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function g(s){const u=s;return typeof u?.id=="string"&&A.URI.isUri(u.configPath)}function w(s){const u=s;if(u?.uri)return{id:u.id,uri:A.URI.revive(u.uri)};const l=s;if(l?.configPath)return{id:l.id,configPath:A.URI.revive(l.configPath)};if(s?.id)return{id:s.id}}var h;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(h||(e.WorkbenchState=h={}));function p(s){const u=s;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}function y(s){const u=s;return!!(u&&typeof u=="object"&&A.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}class ${constructor(u,l,S,v,R){this.h=u,this.j=S,this.k=v,this.l=R,this.c=P.$Li.forUris(this.l,()=>!0),this.folders=l}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=P.$Li.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=$;class m{constructor(u,l){this.raw=l,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,D.$gh)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=m;function E(s){return new m({uri:s,index:0,name:(0,D.$ch)(s)},{uri:s.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,n.localize)(0,null),extensions:[e.$2i]}],e.$5i="workspace.json";function k(s,u){return D.$0g.isEqualOrParent(s,u.untitledWorkspacesHome)}function t(s){let u;return A.URI.isUri(s)?u=s:u=s.configuration,u?.scheme===b.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(s){return s.id===e.$8i}function i(s,u){return!k(s,u)&&!t(s)}function c(s){return(typeof s=="string"?(0,o.$qc)(s):(0,D.$eh)(s))===e.$3i}}),define(oe[53],ae([0,1,14,8,46,48,2,79,3,21,172,124,6,5,28,30]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=e.$Pec=void 0,e.$Pec=(0,g.$Fi)("dialogMainService");let y=class{constructor(m,E){this.d=m,this.e=E,this.a=new Map,this.b=new Map,this.c=new o.$Mh}pickFileFolder(m,E){return this.f({...m,pickFolders:!0,pickFiles:!0,title:(0,f.localize)(0,null)},E)}pickFolder(m,E){return this.f({...m,pickFolders:!0,title:(0,f.localize)(1,null)},E)}pickFile(m,E){return this.f({...m,pickFiles:!0,title:(0,f.localize)(2,null)},E)}pickWorkspace(m,E){const k=(0,f.localize)(3,null),t=(0,D.$3w)((0,f.localize)(4,null)),r=p.$4i;return this.f({...m,pickFiles:!0,title:k,filters:r,buttonLabel:t},E)}async f(m,E){const k={title:m.title,buttonLabel:m.buttonLabel,filters:m.filters,defaultPath:m.defaultPath};(typeof m.pickFiles=="boolean"||typeof m.pickFolders=="boolean")&&(k.properties=void 0,m.pickFiles&&m.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",m.pickFolders?"openDirectory":"openFile","createDirectory"]),b.$j&&k.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(k,(E||n.BrowserWindow.getFocusedWindow())??void 0);if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(m){if(m){let E=this.b.get(m.id);return E||(E=new o.$Mh,this.b.set(m.id,E)),E}else return this.c}showMessageBox(m,E){return this.g(E).queue(async()=>{const{options:k,buttonIndeces:t}=(0,d.$0w)(m,this.e);let r;return E?r=await n.dialog.showMessageBox(E,k):r=await n.dialog.showMessageBox(k),{response:t[r.response],checkboxChecked:r.checkboxChecked}})}async showSaveDialog(m,E){const k=this.j(m,E);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(E).queue(async()=>{let t;return E?t=await n.dialog.showSaveDialog(E,m):t=await n.dialog.showSaveDialog(m),t.filePath=this.h(t.filePath),t})}finally{(0,A.$Rc)(k)}}h(m){return m&&b.$j&&(m=(0,I.$mm)(m)),m}i(m){return m.map(E=>this.h(E))}async showOpenDialog(m,E){m.defaultPath&&(await a.Promises.exists(m.defaultPath)||(m.defaultPath=void 0));const k=this.j(m,E);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(E).queue(async()=>{let t;return E?t=await n.dialog.showOpenDialog(E,m):t=await n.dialog.showOpenDialog(m),t.filePaths=this.i(t.filePaths),t})}finally{(0,A.$Rc)(k)}}j(m,E){if(!E)return A.$Wc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",m);let k=this.a.get(E.id);k||(k=new Set,this.a.set(E.id,k));const t=(0,P.$tj)(m);if(!k.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",m),k.add(t),(0,A.$Uc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",m),k?.delete(t),k?.size===0&&this.a.delete(E.id)})}};e.$Qec=y,e.$Qec=y=Pe([ne(0,w.$_j),ne(1,h.$sk)],y)}),define(oe[281],ae([0,1,4,2,83,30]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;class A extends o.$Wc{static{this.a=100}constructor(b,a){super(),this.f=b,this.g=a,this.b=this.B(new n.$me),this.c=new Map,this.h(a.applicationStorage,this.b)}h(b,a){this.B(n.Event.debounce(b.onDidChangeStorage,(f,d)=>(f?f.push(d):f=[d],f),A.a)(f=>{f.length&&a.fire(this.j(f,b))}))}j(b,a){const f=new Map,d=new Set;return b.forEach(g=>{const w=a.get(g.key);typeof w=="string"?f.set(g.key,w):d.add(g.key)}),{changed:Array.from(f.entries()),deleted:Array.from(d.values())}}listen(b,a,f){switch(a){case"onDidChangeStorage":{const d=f.profile?(0,P.$ci)(f.profile):void 0;if(!d)return this.b.event;let g=this.c.get(d.id);return g||(g=this.B(new n.$me),this.h(this.g.profileStorage(d),g),this.c.set(d.id,g)),g.event}}throw new Error(`Event not found: ${a}`)}async call(b,a,f){const d=f.profile?(0,P.$ci)(f.profile):void 0,g=(0,D.$Vi)(f.workspace),w=await this.m(d,g);switch(a){case"getItems":return Array.from(w.items.entries());case"updateItems":{const h=f;if(h.insert)for(const[p,y]of h.insert)w.set(p,y);h.delete?.forEach(p=>w.delete(p));break}case"optimize":return w.optimize();case"isUsed":{const h=f.payload;if(typeof h=="string")return this.g.isUsed(h)}default:throw new Error(`Call not found: ${a}`)}}async m(b,a){let f;a?f=this.g.workspaceStorage(a):b?f=this.g.profileStorage(b):f=this.g.applicationStorage;try{await f.init()}catch(d){this.f.error(`StorageIPC#init: Unable to init ${a?"workspace":b?"profile":"application"} storage due to ${d}`)}return f}}e.$3fc=A}),define(oe[42],ae([0,1,46,4,2,19,7,196,38,15,6,5,30,32,41,8,33,26,13]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=k,e.$Ml=t,e.$Nl=r;var E;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(E||(e.ProfileResourceType=E={}));function k(s){const u=s;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&A.URI.isUri(u.location)&&A.URI.isUri(u.globalStorageHome)&&A.URI.isUri(u.settingsResource)&&A.URI.isUri(u.keybindingsResource)&&A.URI.isUri(u.tasksResource)&&A.URI.isUri(u.snippetsHome)&&A.URI.isUri(u.extensionsResource))}e.$Ll=(0,f.$Fi)("IUserDataProfilesService");function t(s,u){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:A.URI.revive(s.location).with({scheme:u}),globalStorageHome:A.URI.revive(s.globalStorageHome).with({scheme:u}),settingsResource:A.URI.revive(s.settingsResource).with({scheme:u}),keybindingsResource:A.URI.revive(s.keybindingsResource).with({scheme:u}),tasksResource:A.URI.revive(s.tasksResource).with({scheme:u}),snippetsHome:A.URI.revive(s.snippetsHome).with({scheme:u}),extensionsResource:A.URI.revive(s.extensionsResource).with({scheme:u}),cacheHome:A.URI.revive(s.cacheHome).with({scheme:u}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function r(s,u,l,S,v,R){return{id:s,name:u,location:l,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:R&&v?.useDefaultFlags?.globalState?R.globalStorageHome:(0,D.$gh)(l,"globalStorage"),settingsResource:R&&v?.useDefaultFlags?.settings?R.settingsResource:(0,D.$gh)(l,"settings.json"),keybindingsResource:R&&v?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,D.$gh)(l,"keybindings.json"),tasksResource:R&&v?.useDefaultFlags?.tasks?R.tasksResource:(0,D.$gh)(l,"tasks.json"),snippetsHome:R&&v?.useDefaultFlags?.snippets?R.snippetsHome:(0,D.$gh)(l,"snippets"),extensionsResource:R&&v?.useDefaultFlags?.extensions?R.extensionsResource:(0,D.$gh)(l,"extensions.json"),cacheHome:(0,D.$gh)(S,s),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}let i=class extends P.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(u,l,S,v){super(),this.t=u,this.u=l,this.w=S,this.y=v,this.f=!0,this.h=this.B(new o.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new o.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new o.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new o.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new w.$Cc,workspaces:new w.$Cc,emptyWindows:new Map},this.profilesHome=(0,D.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,D.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(u){this.f!==u&&(this.z=void 0,this.f=u)}isEnabled(){return this.f}get C(){if(!this.z){const u=this.D(),l=[u];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,m.$fg)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}l.push(r((0,D.$dh)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},u))}}catch(R){this.y.error(R)}const S=new w.$Cc,v=new Map;if(l.length)try{const R=this.Q();if(R.workspaces)for(const[T,L]of Object.entries(R.workspaces)){const O=A.URI.parse(T),F=l.find(B=>B.id===L);F&&S.set(O,F)}if(R.emptyWindows)for(const[T,L]of Object.entries(R.emptyWindows)){const O=l.find(F=>F.id===L);O&&v.set(T,O)}}catch(R){this.y.error(R)}this.z={profiles:l,workspaces:S,emptyWindows:v}}return this.z}D(){const u=r("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...u,extensionsResource:this.S()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const l="Temp",S=new RegExp(`${(0,$.$if)(l)}\\s(\\d+)`);let v=0;for(const T of this.profiles){const L=S.exec(T.name),O=L?parseInt(L[1]):0;v=O>v?O:v}const R=`${l} ${v+1}`;return this.createProfile((0,n.$tj)((0,y.$2g)()).toString(16),R,{transient:!0},u)}async createNamedProfile(u,l,S){return this.createProfile((0,n.$tj)((0,y.$2g)()).toString(16),u,l,S)}async createProfile(u,l,S,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(u,l,S);return v&&await this.setProfileForWorkspace(v,R),R}async F(u,l,S){if(!(0,m.$fg)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(l);return v||(v=(async()=>{try{if(this.profiles.find(O=>O.name===l||O.id===u))throw new Error(`Profile with ${l} name already exists`);const T=r(u,l,(0,D.$gh)(this.profilesHome,u),this.g,S,this.defaultProfile);await this.u.createFolder(T.location);const L=[];return this.j.fire({profile:T,join(O){L.push(O)}}),await p.Promises.settled(L),this.I([T],[],[]),T}finally{this.r.delete(l)}})(),this.r.set(l,v)),v}async updateProfile(u,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(v=>v.id===u.id);if(!S)throw new Error(`Profile '${u.name}' does not exist`);return S=r(S.id,l.name??S.name,S.location,this.g,{shortName:l.shortName??S.shortName,icon:l.icon===null?void 0:l.icon??S.icon,transient:l.transient??S.isTransient,useDefaultFlags:l.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(v=>v.id===u.id);if(!l)throw new Error(`Profile '${u.name}' does not exist`);const S=[];this.m.fire({profile:l,join(v){S.push(v)}});try{await Promise.allSettled(S)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(v){(0,a.$ql)(v)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(v)}}async setProfileForWorkspace(u,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(v=>v.id===l.id);if(!S)throw new Error(`Profile '${l.name}' does not exist`);this.L(u,S)}unsetWorkspace(u,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(u,void 0,l)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const u=await this.u.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(l=>l.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const u=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(u.map(l=>this.removeProfile(l)))}getProfileForWorkspace(u){const l=this.G(u),S=A.URI.isUri(l)?this.C.workspaces.get(l):this.C.emptyWindows.get(l);return S||((0,g.$Pi)(u)?this.s.folders.get(u.uri):(0,g.$Ui)(u)?this.s.workspaces.get(u.configPath):this.s.emptyWindows.get(u.id))}G(u){return(0,g.$Pi)(u)?u.uri:(0,g.$Ui)(u)?u.configPath:u.id}H(u){return!!([...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,u.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,u.location))||[...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,u.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,u.location))||[...this.s.folders.values()].some(l=>this.w.extUri.isEqual(l.location,u.location)))}I(u,l,S){const v=[...this.profiles,...u],R=[],T=this.s.profiles;this.s.profiles=[];for(let L of v){if(L.isDefault||l.some(F=>L.id===F.id))continue;L=S.find(F=>L.id===F.id)??L;const O=T.find(F=>L.id===F.id);if(L.isTransient)this.s.profiles.push(L);else{if(O){for(const[F,B]of this.s.emptyWindows.entries())if(L.id===B.id){this.L({id:F},L);break}for(const[F,B]of this.s.workspaces.entries())if(L.id===B.id){this.L({id:"",configPath:F},L);break}for(const[F,B]of this.s.folders.entries())if(L.id===B.id){this.L({id:"",uri:F},L);break}}R.push({location:L.location,name:L.name,shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags})}}this.P(R),this.z=void 0,this.J(u,l,S)}J(u,l,S){this.h.fire({added:u,removed:l,updated:S,all:this.profiles})}L(u,l,S){if(S=l?.isTransient?!0:S,S)(0,g.$Pi)(u)?(this.s.folders.delete(u.uri),l&&this.s.folders.set(u.uri,l)):(0,g.$Ui)(u)?(this.s.workspaces.delete(u.configPath),l&&this.s.workspaces.set(u.configPath,l)):(this.s.emptyWindows.delete(u.id),l&&this.s.emptyWindows.set(u.id,l));else{this.L(u,void 0,!0);const v=this.G(u);A.URI.isUri(v)?(this.C.workspaces.delete(v),l&&this.C.workspaces.set(v,l)):(this.C.emptyWindows.delete(v),l&&this.C.emptyWindows.set(v,l)),this.M()}}M(){const u={};for(const[S,v]of this.C.workspaces.entries())u[S.toString()]=v.id;const l={};for(const[S,v]of this.C.emptyWindows.entries())l[S.toString()]=v.id;this.R({workspaces:u,emptyWindows:l}),this.z=void 0}N(u){const l={},S=this.D();if(u.workspaces)for(const[R,T]of Object.entries(u.workspaces)){const L=A.URI.parse(T);l[R]=this.w.extUri.isEqual(L,S.location)?S.id:this.w.extUri.basename(L)}const v={};if(u.emptyWindows)for(const[R,T]of Object.entries(u.emptyWindows)){const L=A.URI.parse(T);v[R]=this.w.extUri.isEqual(L,S.location)?S.id:this.w.extUri.basename(L)}return{workspaces:l,emptyWindows:v}}O(){return[]}P(u){throw new Error("not implemented")}Q(){return{}}R(u){throw new Error("not implemented")}S(){}};e.$Ol=i,e.$Ol=i=Pe([ne(0,b.$Mi),ne(1,a.$_k),ne(2,h.$Jl),ne(3,d.$_j)],i);class c extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(u){this.a=u}Q(){return this.X}R(u){this.X=u}}e.$Pl=c}),define(oe[87],ae([0,1,8,17,2,4,32,7,127,130,15,6,5,42,41,13,16,25]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m||(e.ExtensionsProfileScanningErrorCode=m={}));class E extends Error{constructor(c,s){super(c),this.code=s}}e.$Fq=E,e.$Gq=(0,d.$Fi)("IExtensionsProfileScannerService");let k=class extends P.$Wc{constructor(c,s,u,l,S,v){super(),this.j=c,this.m=s,this.n=u,this.r=l,this.s=S,this.t=v,this.b=this.B(new D.$me),this.onAddExtensions=this.b.event,this.c=this.B(new D.$me),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.$me),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.$me),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Cc}scanProfileExtensions(c,s){return this.u(c,void 0,s)}async addExtensionsToProfile(c,s,u){const l=[],S=[];try{return await this.u(s,v=>{const R=[];if(u)R.push(...v);else for(const T of v)c.some(([L])=>(0,a.$Jp)(L.identifier,T.identifier)&&L.manifest.version!==T.version)?l.push(T):R.push(T);for(const[T,L]of c){const O=R.findIndex(B=>(0,a.$Jp)(B.identifier,T.identifier)&&B.version===T.manifest.version),F={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:L};O===-1?(S.push(F),R.push(F)):R.splice(O,1,F)}return S.length&&this.b.fire({extensions:S,profileLocation:s}),l.length&&this.f.fire({extensions:l,profileLocation:s}),R}),S.length&&this.c.fire({extensions:S,profileLocation:s}),l.length&&this.g.fire({extensions:l,profileLocation:s}),S}catch(v){throw S.length&&this.c.fire({extensions:S,error:v,profileLocation:s}),l.length&&this.g.fire({extensions:l,error:v,profileLocation:s}),v}}async updateMetadata(c,s){const u=[];return await this.u(s,l=>{const S=[];for(const v of l){const R=c.find(([T])=>(0,a.$Jp)(T.identifier,v.identifier)&&T.manifest.version===v.version);R&&(v.metadata={...v.metadata,...R[1]},u.push(v)),S.push(v)}return S}),u}async removeExtensionFromProfile(c,s){const u=[];try{await this.u(s,l=>{const S=[];for(const v of l)(0,a.$Jp)(v.identifier,c.identifier)?u.push(v):S.push(v);return u.length&&this.f.fire({extensions:u,profileLocation:s}),S}),u.length&&this.g.fire({extensions:u,profileLocation:s})}catch(l){throw u.length&&this.g.fire({extensions:u,error:l,profileLocation:s}),l}}async u(c,s,u){return this.F(c).queue(async()=>{let l=[],S;try{const v=await this.m.readFile(c);S=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,f.$ql)(v)!==f.FileOperationResult.FILE_NOT_FOUND)throw v;if(this.r.extUri.isEqual(c,this.n.defaultProfile.extensionsResource)&&(S=await this.D()),!S&&u?.bailOutWhenFileNotFound)throw new E((0,y.$_)(v),m.ERROR_PROFILE_NOT_FOUND)}if(S){Array.isArray(S)||this.w(c);let v=!1;for(const R of S){t(R)||this.w(c);let T;if((0,p.$fg)(R.relativeLocation)&&R.relativeLocation)T=this.z(R.relativeLocation);else if((0,p.$fg)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{T=I.URI.revive(R.location);const L=this.y(T);L&&(v=!0,R.relativeLocation=L)}(0,p.$mg)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(v=!0,R.metadata.hasPreReleaseVersion=!0),l.push({identifier:R.identifier,location:T,version:R.version,metadata:R.metadata})}v&&await this.m.writeFile(c,o.$Oe.fromString(JSON.stringify(S)))}if(s){l=s(l);const v=l.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(c,o.$Oe.fromString(JSON.stringify(v)))}return l})}w(c){const s=new E(`Invalid extensions content in ${c.toString()}`,m.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(c){return this.r.extUri.isEqual(this.r.extUri.dirname(c),this.j)?this.r.extUri.basename(c):void 0}z(c){return this.r.extUri.joinPath(this.j,c)}async D(){return this.C||(this.C=(async()=>{const c=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let u;try{u=(await this.m.readFile(c)).value.toString()}catch(S){if((0,f.$ql)(S)===f.FileOperationResult.FILE_NOT_FOUND)return;throw S}this.t.info("Migrating extensions from old default profile location",c.toString());let l;try{const S=JSON.parse(u);Array.isArray(S)&&S.every(v=>t(v))?l=S:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",S)}catch(S){this.t.error(S)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,o.$Oe.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",c.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(S){if((0,f.$ql)(S)===f.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",c.toString(),this.n.defaultProfile.extensionsResource.toString());else throw S}try{await this.m.del(c)}catch(S){(0,f.$ql)(S)!==f.FileOperationResult.FILE_NOT_FOUND&&this.t.error(S)}try{await this.m.del(s)}catch(S){(0,f.$ql)(S)!==f.FileOperationResult.FILE_NOT_FOUND&&this.t.error(S)}return l})()),this.C}F(c){let s=this.h.get(c);return s||(s=new n.$Mh,this.h.set(c,s)),s}};e.$Hq=k,e.$Hq=k=Pe([ne(1,f.$_k),ne(2,w.$Ll),ne(3,h.$Jl),ne(4,$.$$l),ne(5,g.$_j)],k);function t(i){return(0,p.$hg)(i)&&(0,b.$hp)(i.identifier)&&(r(i.location)||(0,p.$fg)(i.location)&&i.location)&&((0,p.$mg)(i.relativeLocation)||(0,p.$fg)(i.relativeLocation))&&i.version&&(0,p.$fg)(i.version)}function r(i){return i?(0,p.$fg)(i.path)&&(0,p.$fg)(i.scheme):!1}});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[134],ae([0,1,22,8,36,17,16,43,157,2,12,10,3,19,248,81,13,7,177,38,130,86,247,15,6,5,28,4,83,87,42,41,209]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m,E,k,t,r,i,c,s,u,l,S,v,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Mq=e.$Lq=e.$Kq=e.Translations=void 0,e.$Nq=re,P=De(P),d=De(d),g=De(g),h=De(h),p=et(p);var O;(function(le){function K(ee,q){if(ee===q)return!0;const j=Object.keys(ee),U=new Set;for(const V of Object.keys(q))U.add(V);if(j.length!==U.size)return!1;for(const V of j){if(ee[V]!==q[V])return!1;U.delete(V)}return U.size===0}le.equals=K})(O||(e.Translations=O={})),e.$Kq=(0,c.$Fi)("IExtensionsScannerService");let F=class extends a.$Wc{constructor(K,ee,q,j,U,V,ce,G,he,se,_,M){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=ee,this.r=q,this.s=j,this.t=U,this.u=V,this.w=ce,this.y=G,this.z=he,this.C=se,this.D=_,this.F=M,this.g=this.B(new l.$me),this.onDidChangeCache=this.g.event,this.h=(0,w.$gh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(z,this.s,this.h)),this.m=this.B(this.F.createInstance(z,this.s,this.h)),this.n=this.B(this.F.createInstance(C,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(t.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(t.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,k.$Up)(this.w,this.y)),this.G}async scanAllExtensions(K,ee,q){const[j,U]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(ee)]),V=q?await this.scanExtensionsUnderDevelopment(K,[...j,...U]):[];return this.L(j,U,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const ee=[];ee.push(this.M(!!K.useCache,K.language)),ee.push(this.N(K.language,!!K.checkControlFile));const[q,j]=await Promise.all(ee);return this.J([...q,...j],t.ExtensionType.System,K,!1)}async scanUserExtensions(K){const ee=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ee);const q=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.P(ee,!!K.profileLocation,t.ExtensionType.User,!K.includeUninstalled,K.language,!0,q,K.productVersion??this.R()),U=K.useCache&&!j.devMode&&j.excludeObsolete?this.m:this.n;let V;try{V=await U.scanExtensions(j)}catch(ce){if(ce instanceof v.$Fq&&ce.code===v.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),V=await U.scanExtensions(j);else throw ce}return V=await this.J(V,t.ExtensionType.User,K,!0),this.y.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(K,ee){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(j=>j.scheme===f.Schemas.file).map(async j=>{const U=await this.P(j,!1,t.ExtensionType.User,!0,K.language,!1,void 0,K.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(U)).map(ce=>(ce.type=ee.find(G=>(0,k.$Jp)(G.identifier,ce.identifier))?.type??ce.type,this.n.validate(ce,U)))}))).flat();return this.J(q,"development",K,!0)}return[]}async scanExistingExtension(K,ee,q){const j=await this.P(K,!1,ee,!0,q.language,!0,void 0,q.productVersion??this.R()),U=await this.n.scanExtension(j);return!U||!q.includeInvalid&&!U.isValid?null:U}async scanOneOrMultipleExtensions(K,ee,q){const j=await this.P(K,!1,ee,!0,q.language,!0,void 0,q.productVersion??this.R()),U=await this.n.scanOneOrMultipleExtensions(j);return this.J(U,ee,q,!0)}async scanMultipleExtensions(K,ee,q){const j=[];return await Promise.all(K.map(async U=>{const V=await this.scanOneOrMultipleExtensions(U,ee,q);j.push(...V)})),this.J(j,ee,q,!0)}async scanMetadata(K){const ee=(0,w.$gh)(K,"package.json"),q=(await this.w.readFile(ee)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(K,ee){const q=(0,w.$gh)(K,"package.json"),j=(await this.w.readFile(q)).value.toString(),U=JSON.parse(j);ee.isMachineScoped===!1&&delete ee.isMachineScoped,ee.isBuiltin===!1&&delete ee.isBuiltin,U.__metadata={...U.__metadata,...ee},await this.w.writeFile((0,w.$gh)(K,"package.json"),D.$Oe.fromString(JSON.stringify(U,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof v.$Fq&&K.code===v.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(ee=>[ee,ee.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,D.$Oe.fromString(JSON.stringify([])))}catch(ee){(0,i.$ql)(ee)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$_)(ee))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,ee,q,j){return q.includeAllVersions||(K=this.L(ee===t.ExtensionType.System?K:void 0,ee===t.ExtensionType.User?K:void 0,ee==="development"?K:void 0,await this.getTargetPlatform(),j)),q.includeInvalid||(K=K.filter(U=>U.isValid)),K.sort((U,V)=>{const ce=d.$pc(U.location.fsPath),G=d.$pc(V.location.fsPath);return ce<G?-1:ce>G?1:0})}L(K,ee,q,j,U){const V=(G,he,se)=>{if(G.isValid&&!he.isValid)return!1;if(G.isValid===he.isValid){if(U&&h.gt(G.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(h.eq(G.manifest.version,he.manifest.version)){if(G.type===t.ExtensionType.System)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===j)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return se?this.y.warn(`Overwriting user extension ${G.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${G.location.path} with ${he.location.path}.`),!0},ce=new t.$sn;return K?.forEach(G=>{const he=ce.get(G.identifier.id);(!he||V(he,G,!1))&&ce.set(G.identifier.id,G)}),ee?.forEach(G=>{const he=ce.get(G.identifier.id);if(!he&&K&&G.type===t.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!he||V(he,G,!1))&&ce.set(G.identifier.id,G)}),q?.forEach(G=>{const he=ce.get(G.identifier.id);(!he||V(he,G,!0))&&ce.set(G.identifier.id,G),ce.set(G.identifier.id,G)}),[...ce.values()]}async M(K,ee){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,t.ExtensionType.System,!0,ee,!0,void 0,this.R()),U=await(K&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",U.length),U}async N(K,ee){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const j=ee?await this.O():{},U=[],V=$.URI.file(d.$jc(d.$lc(f.$Zg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const G of q){const he=j[G.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":U.push((0,w.$gh)(V,G.name));break;default:U.push($.URI.file(he));break}}const ce=await Promise.all(U.map(async G=>this.n.scanExtension(await this.P(G,!1,t.ExtensionType.System,!0,K,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ce.length),(0,n.$Jb)(ce)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,ee,q,j,U,V,ce,G){const he=await this.f(U??g.$w),se=await this.Q(K),_=ee&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=_?await this.Q(_):void 0;return new B(K,se,_,M,ee,ce,q,j,V,G.version,G.date,this.C.commit,!this.z.isBuilt,U,he)}async Q(K){try{const ee=await this.w.stat(K);if(typeof ee.mtime=="number")return ee.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Lq=F,e.$Lq=F=Pe([ne(4,R.$Ll),ne(5,v.$Gq),ne(6,i.$_k),ne(7,s.$_j),ne(8,E.$Mi),ne(9,u.$sk),ne(10,T.$Jl),ne(11,c.$Ei)],F);class B{constructor(K,ee,q,j,U,V,ce,G,he,se,_,M,N,W,H){this.location=K,this.mtime=ee,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=j,this.profile=U,this.profileScanOptions=V,this.type=ce,this.excludeObsolete=G,this.validate=he,this.productVersion=se,this.productDate=_,this.productCommit=M,this.devMode=N,this.language=W,this.translations=H}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,ee){return(0,w.$_g)(K.location,ee.location)&&K.mtime===ee.mtime&&(0,w.$_g)(K.applicationExtensionslocation,ee.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===ee.applicationExtensionslocationMtime&&K.profile===ee.profile&&P.$ho(K.profileScanOptions,ee.profileScanOptions)&&K.type===ee.type&&K.excludeObsolete===ee.excludeObsolete&&K.validate===ee.validate&&K.productVersion===ee.productVersion&&K.productDate===ee.productDate&&K.productCommit===ee.productCommit&&K.devMode===ee.devMode&&K.language===ee.language&&O.equals(K.translations,ee.translations)}}e.$Mq=B;let C=class extends a.$Wc{constructor(K,ee,q,j,U,V){super(),this.g=K,this.h=ee,this.j=q,this.m=j,this.n=V,this.f=U.extensionsEnabledWithApiProposalVersion?.map(ce=>ce.toLowerCase())??[]}async scanExtensions(K){const ee=K.profile?await this.s(K):await this.r(K);let q={};if(K.excludeObsolete&&K.type===t.ExtensionType.User)try{const j=(await this.m.readFile(this.g)).value.toString();q=JSON.parse(j)}catch{}return(0,y.$sg)(q)?ee:ee.filter(j=>!q[k.$Kp.create(j).toString()])}async r(K){const ee=await this.m.resolve(K.location);if(!ee.children?.length)return[];const q=await Promise.all(ee.children.map(async j=>{if(!j.isDirectory||K.type===t.ExtensionType.User&&(0,w.$dh)(j.resource).indexOf(".")===0)return null;const U=new B(j.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(U)}));return(0,n.$Jb)(q).sort((j,U)=>j.location.path<U.location.path?-1:1)}async s(K){let ee=await this.t(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.j.extUri.isEqual(K.location,K.applicationExtensionslocation)){ee=ee.filter(j=>!j.metadata?.isApplicationScoped);const q=await this.t(K.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,K);ee.push(...q)}return ee}async t(K,ee,q){const j=await this.h.scanProfileExtensions(K,q.profileScanOptions);if(!j.length)return[];const U=await Promise.all(j.map(async V=>{if(ee(V)){const ce=new B(V.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(ce,V.metadata)}return null}));return(0,n.$Jb)(U)}async scanOneOrMultipleExtensions(K){try{if(await this.m.exists((0,w.$gh)(K.location,"package.json"))){const ee=await this.scanExtension(K);return ee?[ee]:[]}else return await this.scanExtensions(K)}catch(ee){return this.n.error(`Error scanning extensions at ${K.location.path}:`,(0,A.$_)(ee)),[]}}async scanExtension(K,ee){try{let q=await this.u(K.location);if(q){q.publisher||(q.publisher=t.$mn),ee=ee??q.__metadata,delete q.__metadata;const j=(0,k.$Op)(q.publisher,q.name),U=ee?.id?{id:j,uuid:ee.id}:{id:j},V=ee?.isSystem?t.ExtensionType.System:K.type,ce=V===t.ExtensionType.System||!!ee?.isBuiltin;q=await this.w(K.location,q,B.createNlsConfiguration(K)),q.enabledApiProposals&&!this.f?.includes(j.toLowerCase())&&(q.enabledApiProposals=(0,t.$yn)([...q.enabledApiProposals]));const G={type:V,identifier:U,manifest:q,location:K.location,isBuiltin:ce,targetPlatform:ee?.targetPlatform??t.TargetPlatform.UNDEFINED,publisherDisplayName:ee?.publisherDisplayName,metadata:ee,isValid:!0,validations:[]};return K.validate?this.validate(G,K):G}}catch(q){K.type!==t.ExtensionType.System&&this.n.error(q)}return null}validate(K,ee){let q=!0;const j=(0,r.$1p)(ee.productVersion,ee.productDate,ee.location,K.manifest,K.isBuiltin);for(const[U,V]of j)U===p.default.Error&&(q=!1,this.n.error(this.D(ee.location,V)));return K.isValid=q,K.validations=j,K}async u(K){const ee=(0,w.$gh)(K,"package.json");let q;try{q=(await this.m.readFile(ee)).value.toString()}catch(U){return(0,i.$ql)(U)!==i.FileOperationResult.FILE_NOT_FOUND&&this.n.error(this.D(K,(0,m.localize)(0,null,ee.path,U.message))),null}let j;try{j=JSON.parse(q)}catch{const V=[];(0,I.$Xn)(q,V);for(const ce of V)this.n.error(this.D(K,(0,m.localize)(1,null,ee.path,ce.offset,ce.length,(0,b.$Iq)(ce.error))));return null}return(0,I.$6n)(j)!=="object"?(this.n.error(this.D(K,(0,m.localize)(2,null,ee.path))),null):j}async w(K,ee,q){const j=await this.y(K,ee,q);if(j)try{const U=[],V=await this.z(j.default,U);if(U.length>0)return U.forEach(G=>{this.n.error(this.D(K,(0,m.localize)(3,null,j.default?.path,(0,b.$Iq)(G.error))))}),ee;if((0,I.$6n)(j)!=="object")return this.n.error(this.D(K,(0,m.localize)(4,null,j.default?.path))),ee;const ce=j.values||Object.create(null);return(0,L.$Jq)(this.n,ee,ce,V)}catch{}return ee}async y(K,ee,q){const j=(0,w.$gh)(K,"package.nls.json"),U=(he,se)=>{se.forEach(_=>{this.n.error(this.D(K,(0,m.localize)(5,null,he?.path,(0,b.$Iq)(_.error))))})},V=he=>{this.n.error(this.D(K,(0,m.localize)(6,null,he?.path)))},ce=`${ee.publisher}.${ee.name}`,G=q.translations[ce];if(G)try{const he=$.URI.file(G),se=(await this.m.readFile(he)).value.toString(),_=[],M=(0,I.$Xn)(se,_);return _.length>0?(U(he,_),{values:void 0,default:j}):(0,I.$6n)(M)!=="object"?(V(he),{values:void 0,default:j}):{values:M.contents?M.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.m.exists(j))return;let se;try{se=await this.C(K,q)}catch{return}if(!se.localized)return{values:void 0,default:se.original};try{const _=(await this.m.readFile(se.localized)).value.toString(),M=[],N=(0,I.$Xn)(_,M);return M.length>0?(U(se.localized,M),{values:void 0,default:se.original}):(0,I.$6n)(N)!=="object"?(V(se.localized),{values:void 0,default:se.original}):{values:N,default:se.original}}catch{return{values:void 0,default:se.original}}}}async z(K,ee){if(K)try{const q=(await this.m.readFile(K)).value.toString();return(0,I.$Xn)(q,ee)}catch{}}C(K,ee){return new Promise((q,j)=>{const U=V=>{const ce=(0,w.$gh)(K,`package.nls.${V}.json`);this.m.exists(ce).then(G=>{G&&q({localized:ce,original:(0,w.$gh)(K,"package.nls.json")});const he=V.lastIndexOf("-");he===-1?q({localized:(0,w.$gh)(K,"package.nls.json"),original:null}):(V=V.substring(0,he),U(V))})};if(ee.devMode||ee.pseudo||!ee.language)return q({localized:(0,w.$gh)(K,"package.nls.json"),original:null});U(ee.language)})}D(K,ee){return`[${K.path}]: ${ee}`}};C=Pe([ne(1,v.$Gq),ne(2,T.$Jl),ne(3,i.$_k),ne(4,u.$sk),ne(5,s.$_j)],C);let z=class extends C{constructor(K,ee,q,j,U,V,ce,G){super(ee,j,U,V,ce,G),this.I=K,this.J=q,this.G=this.B(new o.$Dh(3e3)),this.H=this.B(new l.$me),this.onDidChangeCache=this.H.event}async scanExtensions(K){const ee=this.O(K),q=await this.L(ee);if(this.F=K,q&&q.input&&B.equals(q.input,this.F))return this.n.debug("Using cached extensions scan result",K.type===t.ExtensionType.System?"system":"user",K.location.toString()),this.G.trigger(()=>this.N()),q.result.map(U=>(U.location=$.URI.revive(U.location),U));const j=await super.scanExtensions(K);return await this.M(ee,{input:K,result:j}),j}async L(K){try{const ee=await this.m.readFile(K),q=JSON.parse(ee.value.toString());return{result:q.result,input:(0,S.$ci)(q.input)}}catch(ee){this.n.debug("Error while reading the extension cache file:",K.path,(0,A.$_)(ee))}return null}async M(K,ee){try{await this.m.writeFile(K,D.$Oe.fromString(JSON.stringify(ee)))}catch(q){this.n.debug("Error while writing the extension cache file:",K.path,(0,A.$_)(q))}}async N(){if(!this.F)return;const K=this.O(this.F),ee=await this.L(K);if(!ee)return;const q=ee.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.F)));if(!P.$ho(j,q))try{this.n.info("Invalidating Cache",q,j),await this.m.del(K),this.H.fire()}catch(U){this.n.error(U)}}O(K){const ee=this.P(K);return this.j.extUri.joinPath(ee.cacheHome,K.type===t.ExtensionType.System?t.$ln:t.$kn)}P(K){return K.type===t.ExtensionType.System?this.J.defaultProfile:K.profile?this.j.extUri.isEqual(K.location,this.I.extensionsResource)?this.I:this.J.profiles.find(ee=>this.j.extUri.isEqual(K.location,ee.extensionsResource))??this.I:this.J.defaultProfile}};z=Pe([ne(2,R.$Ll),ne(3,v.$Gq),ne(4,T.$Jl),ne(5,i.$_k),ne(6,u.$sk),ne(7,s.$_j)],z);function re(le,K){const ee=(0,k.$Mp)(le.manifest.publisher,le.manifest.name);return{id:ee,identifier:new t.$qn(ee),isBuiltin:le.type===t.ExtensionType.System,isUserBuiltin:le.type===t.ExtensionType.User&&le.isBuiltin,isUnderDevelopment:K,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,publisherDisplayName:le.publisherDisplayName,...le.manifest}}class Q extends F{constructor(K,ee,q,j,U,V,ce,G,he,se,_,M){super(K,ee,(0,w.$gh)(q,".vscode-oss-dev","extensions","control.json"),j,U,V,ce,G,he,se,_,M),this.S=(async()=>{if(g.$z)try{const N=await this.w.readFile($.URI.file(g.$z));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}f(K){return this.S}}e.$Oq=Q}),define(oe[282],ae([0,1,5,42,41,25,87,15,38,7]),function(x,e,n,o,P,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nR=void 0;let f=class extends A.$Hq{constructor(g,w,h,p,y,$){super(a.URI.file(g.extensionsPath),w,h,p,y,$)}};e.$nR=f,e.$nR=f=Pe([ne(0,b.$Ni),ne(1,I.$_k),ne(2,o.$Ll),ne(3,P.$Jl),ne(4,D.$$l),ne(5,n.$_j)],f)}),define(oe[283],ae([0,1,7,38,87,134,15,6,5,28,41,42]),function(x,e,n,o,P,D,A,I,b,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;let g=class extends D.$Oq{constructor(h,p,y,$,m,E,k,t){super(n.URI.file(m.builtinExtensionsPath),n.URI.file(m.extensionsPath),m.userHome,h.defaultProfile,h,p,y,$,m,E,k,t)}};e.$qgc=g,e.$qgc=g=Pe([ne(0,d.$Ll),ne(1,P.$Gq),ne(2,A.$_k),ne(3,b.$_j),ne(4,o.$Ni),ne(5,a.$sk),ne(6,f.$Jl),ne(7,I.$Ei)],g)}),define(oe[284],ae([0,1,14,2,12,10,3,61,7,33,35,38,5,42]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;let h=class extends o.$Wc{constructor(y,$,m){super(),this.c=y,this.f=m,this.a=I.$Li.forPaths(!A.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(y.appRoot),this.addValidFileRoot(y.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:P.Schemas.file}).fsPath),this.addValidFileRoot(y.workspaceStorageHome.with({scheme:P.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:y}=n.session;y.protocol.registerFileProtocol(P.Schemas.vscodeFileResource,($,m)=>this.j($,m)),y.protocol.interceptFileProtocol(P.Schemas.file,($,m)=>this.h($,m)),this.B((0,o.$Uc)(()=>{y.protocol.unregisterProtocol(P.Schemas.vscodeFileResource),y.protocol.uninterceptProtocol(P.Schemas.file)}))}addValidFileRoot(y){const $=(0,D.$jc)(y);return this.a.get($)?o.$Wc.None:(this.a.set($,!0),(0,o.$Uc)(()=>this.a.delete($)))}h(y,$){const m=b.URI.parse(y.url);return this.f.error(`Refused to load resource ${m.fsPath} from ${P.Schemas.file}: protocol (original URL: ${y.url})`),$({error:-3})}j(y,$){const m=this.m(y);let E;return this.c.crossOriginIsolated&&((0,D.$pc)(m)==="workbench.html"||(0,D.$pc)(m)==="workbench-dev.html"?E=P.COI.CoopAndCoep:E=P.COI.getHeadersFromQuery(y.url)),this.a.findSubstr(m)?$({path:m,headers:E}):this.b.has((0,D.$qc)(m).toLowerCase())?$({path:m}):(this.f.error(`${P.Schemas.vscodeFileResource}: Refused to load resource ${m} from ${P.Schemas.vscodeFileResource}: protocol (original URL: ${y.url})`),$({error:-3}))}m(y){const $=b.URI.parse(y.url),m=P.$Zg.uriToFileUri($);return(0,D.$jc)(m.fsPath)}createIPCObjectUrl(){let y;const $=b.URI.from({scheme:"vscode",path:(0,a.$2g)()}),m=$.toString(),E=async()=>y;return f.$FX.handle(m,E),this.f.trace(`IPC Object URL: Registered new channel ${m}.`),{resource:$,update:k=>y=k,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${m}.`),f.$FX.removeHandler(m)}}}};e.$Kgc=h,e.$Kgc=h=Pe([ne(0,d.$Ni),ne(1,w.$Ll),ne(2,g.$_j)],h)}),define(oe[63],ae([0,1,8,4,2,71,13,120,6,42]),function(x,e,n,o,P,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fq=e.$eq=e.$dq=void 0,e.$gq=w,e.$iq=p,e.$kq=$,e.$dq="__$__isNewStorageMarker",e.$eq="__$__targetStorageMarker",e.$fq=(0,b.$Fi)("storageService");var f;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(f||(e.WillSaveStateReason=f={}));var d;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(d||(e.StorageScope=d={}));var g;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function w(m){const E=m.get(e.$eq);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}class h extends P.$Wc{static{this.a=60*1e3}constructor(E={flushInterval:h.a}){super(),this.m=E,this.b=this.B(new o.$pe),this.c=this.B(new o.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new o.$me),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(E,k,t){return o.Event.filter(this.b.event,r=>r.scope===E&&(k===void 0||r.key===k),t)}n(){this.j.value=(0,n.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.O()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(E,k){const{key:t,external:r}=k;if(t===e.$eq){switch(E){case d.APPLICATION:this.H=void 0;break;case d.PROFILE:this.F=void 0;break;case d.WORKSPACE:this.C=void 0;break}this.c.fire({scope:E})}else this.b.fire({scope:E,key:t,target:this.J(E)[t],external:r})}w(E){this.f.fire({reason:E})}get(E,k,t){return this.P(k)?.get(E,t)}getBoolean(E,k,t){return this.P(k)?.getBoolean(E,t)}getNumber(E,k,t){return this.P(k)?.getNumber(E,t)}getObject(E,k,t){return this.P(k)?.getObject(E,t)}storeAll(E,k){this.y(()=>{for(const t of E)this.store(t.key,t.value,t.scope,t.target,k)})}store(E,k,t,r,i=!1){if((0,A.$og)(k)){this.remove(E,t,i);return}this.y(()=>{this.z(E,t,r),this.P(t)?.set(E,k,i)})}remove(E,k,t=!1){this.y(()=>{this.z(E,k,void 0),this.P(k)?.delete(E,t)})}y(E){this.b.pause(),this.c.pause();try{E()}finally{this.b.resume(),this.c.resume()}}keys(E,k){const t=[],r=this.J(E);for(const i of Object.keys(r))r[i]===k&&t.push(i);return t}z(E,k,t,r=!1){const i=this.J(k);typeof t=="number"?i[E]!==t&&(i[E]=t,this.P(k)?.set(e.$eq,JSON.stringify(i),r)):typeof i[E]=="number"&&(delete i[E],this.P(k)?.set(e.$eq,JSON.stringify(i),r))}get D(){return this.C||(this.C=this.L(d.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(d.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(d.APPLICATION)),this.H}J(E){switch(E){case d.APPLICATION:return this.I;case d.PROFILE:return this.G;default:return this.D}}L(E){const k=this.P(E);return k?w(k):Object.create(null)}isNew(E){return this.getBoolean(e.$dq,E)===!0}async flush(E=f.NONE){this.f.fire({reason:E});const k=this.P(d.APPLICATION),t=this.P(d.PROFILE),r=this.P(d.WORKSPACE);switch(E){case f.NONE:await n.Promises.settled([k?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case f.SHUTDOWN:await n.Promises.settled([k?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const E=this.P(d.APPLICATION)?.items??new Map,k=this.P(d.PROFILE)?.items??new Map,t=this.P(d.WORKSPACE)?.items??new Map;return $(E,k,t,this.Q(d.APPLICATION)??"",this.Q(d.PROFILE)??"",this.Q(d.WORKSPACE)??"")}async optimize(E){return await this.flush(),this.P(E)?.optimize()}async switch(E,k){return this.w(f.NONE),(0,a.$Kl)(E)?this.R(E,k):this.S(E,k)}M(E,k){return!(E.id===k.id||p(k)&&p(E))}N(E,k,t){this.y(()=>{const r=new Set;for(const[i,c]of E)r.add(i),k.get(i)!==c&&this.u(t,{key:i,external:!0});for(const[i]of k.items)r.has(i)||this.u(t,{key:i,external:!0})})}}e.$hq=h;function p(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class y extends h{constructor(){super(),this.U=this.B(new I.$bq(new I.$cq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$bq(new I.$cq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$bq(new I.$cq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(E=>this.u(d.WORKSPACE,E))),this.B(this.W.onDidChangeStorage(E=>this.u(d.PROFILE,E))),this.B(this.U.onDidChangeStorage(E=>this.u(d.APPLICATION,E)))}P(E){switch(E){case d.APPLICATION:return this.U;case d.PROFILE:return this.W;default:return this.X}}Q(E){switch(E){case d.APPLICATION:return"inMemory (application)";case d.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(E){return!1}}e.$jq=y;async function $(m,E,k,t,r,i){const c=O=>{try{return JSON.parse(O)}catch{return O}},s=new Map,u=new Map;m.forEach((O,F)=>{s.set(F,O),u.set(F,c(O))});const l=new Map,S=new Map;E.forEach((O,F)=>{l.set(F,O),S.set(F,c(O))});const v=new Map,R=new Map;k.forEach((O,F)=>{v.set(F,O),R.set(F,c(O))}),console.group(t!==r?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const T=[];if(s.forEach((O,F)=>{T.push({key:F,value:O})}),console.table(T),console.groupEnd(),console.log(u),t!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const O=[];l.forEach((F,B)=>{O.push({key:B,value:F})}),console.table(O),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${i})`);const L=[];v.forEach((O,F)=>{L.push({key:F,value:O})}),console.table(L),console.groupEnd(),console.log(R)}}),define(oe[285],ae([0,1,17,33,63]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=D;async function D(A,I,b){let a=b&&b.get("storage.serviceMachineId",P.StorageScope.APPLICATION)||null;if(a)return a;try{const d=(await I.readFile(A.serviceMachineIdResource)).value.toString();a=(0,o.$1g)(d)?d:null}catch{a=null}if(!a){a=(0,o.$2g)();try{await I.writeFile(A.serviceMachineIdResource,n.$Oe.fromString(a))}catch{}}return b?.store("storage.serviceMachineId",a,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),a}}),define(oe[286],ae([0,1,285,25,58]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=D;async function D(A,I,b,a,f,d,g){const w={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${I.nameShort})`};if((0,P.$Bp)(I,b)&&(0,P.$Dp)(a)===o.TelemetryLevel.USAGE){const h=await(0,n.$lq)(b,f,d);w["X-Market-User-Id"]=h,w["VSCode-SessionId"]=g.machineId||h}return w}}),define(oe[287],ae([0,1,22,8,4,2,10,67,7,21,120,166,5,63,25,30,12]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=e.$ffc=e.$efc=e.$dfc=void 0;class $ extends D.$Wc{static{this.a=2e3}get storage(){return this.f}constructor(c,s){super(),this.m=c,this.n=s,this.b=this.B(new P.$me),this.onDidChangeStorage=this.b.event,this.c=this.B(new P.$me),this.onDidCloseStorage=this.c.event,this.f=this.B(new f.$bq(new f.$cq,{hint:f.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new o.$3h,this.whenInit=this.h.p,this.j=f.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===f.StorageState.None)try{const c=this.B(await this.t());this.f.dispose(),this.f=c,this.B(c.onDidChangeStorage(u=>this.b.fire(u))),await this.s(c);const s=c.getBoolean(w.$dq);s===void 0?c.set(w.$dq,!0):s&&c.set(w.$dq,!1)}catch(c){this.m.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.j=f.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===g.LogLevel.Trace?c=>this.m.trace(c):void 0,logError:c=>this.m.error(c)}}s(c){return c.init()}get items(){return this.f.items}get(c,s){return this.f.get(c,s)}set(c,s){return this.f.set(c,s)}delete(c){return this.f.delete(c)}optimize(){return this.f.optimize()}async close(){const c=new I.$ge(!1);await this.w(),c.stop(),c.elapsed()>$.a&&await this.u(c),this.c.fire()}async u(c){if(this.path)try{const s=(0,n.top)(Array.from(this.f.items.entries()).map(([l,S])=>({key:l,length:S.length})),(l,S)=>S.length-l.length,5).map(l=>`${l.key}:${l.length}`).join(", "),u=(await this.n.stat(b.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${u}b, Large Keys: ${s}`)}catch(s){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",s)}}async w(){this.g&&await this.g,this.j=f.StorageState.Closed,await this.f.close()}}class m extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,A.$lc)(this.z.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,m.y)}constructor(c,s,u,l){super(u,l),this.z=c,this.C=s}async t(){return new f.$bq(new d.$$X(this.path??d.$$X.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:f.StorageHint.STORAGE_IN_MEMORY})}}class E extends m{constructor(c,s,u,l){super(c,s,u,l)}}e.$dfc=E;class k extends m{constructor(c,s,u,l){super(s.defaultProfile,c,u,l)}async s(c){await super.s(c),this.G(c)}G(c){c.get(h.$bm,void 0)===void 0&&c.set(h.$bm,new Date().toUTCString());const u=c.get(h.$am,void 0),l=new Date().toUTCString();c.set(h.$cm,typeof u>"u"?null:u),c.set(h.$am,l)}}e.$efc=k;class t extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,A.$lc)(this.F.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,this.C.id,t.y)}constructor(c,s,u,l,S){super(u,S),this.C=c,this.D=s,this.F=l}async t(){const{storageFilePath:c,wasCreated:s}=await this.H();return new f.$bq(new d.$$X(c,{logging:this.r()}),{hint:this.D.useInMemoryStorage?f.StorageHint.STORAGE_IN_MEMORY:s?f.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:d.$$X.IN_MEMORY_PATH,wasCreated:!0};const c=(0,A.$lc)(this.F.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,this.C.id),s=(0,A.$lc)(c,t.y);return await a.Promises.exists(c)?{storageFilePath:s,wasCreated:!1}:(await a.Promises.mkdir(c,{recursive:!0}),this.I(c),{storageFilePath:s,wasCreated:!0})}async I(c){let s;if((0,p.$Pi)(this.C)?s={folder:this.C.uri.toString()}:(0,p.$Ui)(this.C)&&(s={workspace:this.C.configPath.toString()}),s)try{const u=(0,A.$lc)(c,t.z);await a.Promises.exists(u)||await a.Promises.writeFile(u,JSON.stringify(s,void 0,2))}catch(u){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.$ffc=t;class r extends ${get path(){}async t(){return new f.$bq(new f.$cq,{hint:f.StorageHint.STORAGE_IN_MEMORY})}}e.$gfc=r}),define(oe[288],ae([0,1,4,2,63]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class D extends o.$Wc{constructor(I,b,a){super(),this.b=I,this.c=b,this.f=a;const f=this.B(new o.$Xc);this.a=this.B(new n.$me({onWillAddFirstListener:()=>f.value=this.g(),onDidRemoveLastListener:()=>f.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new o.$Vc;return I.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(b,a)=>(b?b.push(a.key):b=[a.key],b),100)(b=>this.h(b))),I.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(b,a)=>{b||(b=new Map);let f=b.get(a.profile.id);return f||b.set(a.profile.id,f={profile:a.profile,keys:[],storage:a.storage}),f.keys.push(a.key),b},100)(b=>this.j(b))),I}h(I){const b=I.includes(P.$eq)?[this.c.defaultProfile]:[],a=[];if(I=I.filter(f=>f!==P.$eq),I.length){const f=(0,P.$gq)(this.b.applicationStorage.storage);a.push({profile:this.c.defaultProfile,changes:I.map(d=>({key:d,scope:P.StorageScope.PROFILE,target:f[d]}))})}this.m(b,a)}j(I){const b=[],a=new Map;for(const[f,d]of I.entries()){d.keys.includes(P.$eq)&&b.push(d.profile);const g=d.keys.filter(w=>w!==P.$eq);if(g.length){const w=(0,P.$gq)(d.storage.storage);a.set(f,{profile:d.profile,changes:g.map(h=>({key:h,scope:P.StorageScope.PROFILE,target:w[h]}))})}}this.m(b,[...a.values()])}m(I,b){(I.length||b.length)&&this.a.fire({valueChanges:b,targetChanges:I})}listen(I,b,a){switch(b){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${b}`)}async call(I,b){throw new Error(`Call not found: ${b}`)}}e.$sgc=D}),define(oe[289],ae([0,1,7,38,15,5,34,41,42,13,128]),function(x,e,n,o,P,D,A,I,b,a,f){"use strict";var d,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$mR=e.$lR=e.$kR=void 0;let w=class extends b.$Ol{static{d=this}static{this.a="profileAssociationsMigration"}constructor($,m,E,k,t){super(E,k,m,t),this.U=$,this.W=E}O(){return this.U.getItem(d.b,[]).map(m=>({...m,location:(0,a.$fg)(m.location)?this.w.extUri.joinPath(this.profilesHome,m.location):n.URI.revive(m.location)}))}Q(){const $=this.U.getItem(d.c,{});return this.U.getItem(d.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$kR=w,e.$kR=w=d=Pe([ne(0,A.$fR),ne(1,I.$Jl),ne(2,o.$Ni),ne(3,P.$_k),ne(4,D.$_j)],w);let h=g=class extends w{constructor($,m,E,k,t){super($,m,E,k,t),this.$=$}P($){$.length?this.$.setItem(g.b,$.map(m=>({...m,location:this.w.extUri.basename(m.location)}))):this.$.removeItem(g.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(g.c,$):this.$.removeItem(g.c)}Q(){const $="workspaceAndProfileInfo",m=this.$.getItem($,void 0);if(m){this.$.removeItem($);const k=m.reduce((t,{workspace:r,profile:i})=>(t[n.URI.revive(r).toString()]=n.URI.revive(i).toString(),t),{});this.$.setItem(g.c,{workspaces:k})}const E=super.Q();return this.$.getItem(g.a,!1)||(this.R(E),this.$.setItem(g.a,!0)),E}};e.$lR=h,e.$lR=h=g=Pe([ne(0,A.$gR),ne(1,I.$Jl),ne(2,o.$Ni),ne(3,P.$_k),ne(4,D.$_j)],h);let p=class extends h{constructor($,m,E,k){super(new f.$jR(f.SaveStrategy.IMMEDIATE,m,k,E),$,m,E,k)}async init(){return await this.$.init(),super.init()}};e.$mR=p,e.$mR=p=Pe([ne(0,I.$Jl),ne(1,o.$Ni),ne(2,P.$_k),ne(3,D.$_j)],p)}),define(oe[59],ae([0,1,38,15,6,5,41,42,289,34]),function(x,e,n,o,P,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=e.$Xec=void 0,e.$Xec=(0,P.$Gi)(I.$Ll);let f=class extends b.$lR{constructor(g,w,h,p,y){super(g,w,h,p,y)}getAssociatedEmptyWindows(){const g=[];for(const w of this.C.emptyWindows.keys())g.push({id:w});return g}};e.$Yec=f,e.$Yec=f=Pe([ne(0,a.$gR),ne(1,A.$Jl),ne(2,n.$Ni),ne(3,o.$_k),ne(4,D.$_j)],f)}),define(oe[135],ae([0,1,19,7,30]),function(x,e,n,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=D,e.$1ec=A,e.$2ec=I;async function D(b,a,f){for(const g of b){const w=g.openedWorkspace;if((0,P.$Ui)(w)){const h=await f(w);if(h){if(h.folders.some(p=>n.$0g.isEqualOrParent(a,p.uri)))return g}else if(n.$0g.isEqualOrParent(a,w.configPath))return g}}const d=b.filter(g=>(0,P.$Pi)(g.openedWorkspace)&&n.$0g.isEqualOrParent(a,g.openedWorkspace.uri));if(d.length)return d.sort((g,w)=>-(g.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}function A(b,a){for(const f of b)if((0,P.$Ui)(f.openedWorkspace)&&n.$0g.isEqual(f.openedWorkspace.configPath,a)||(0,P.$Pi)(f.openedWorkspace)&&n.$0g.isEqual(f.openedWorkspace.uri,a))return f}function I(b,a){const f=d=>a.some(g=>n.$0g.isEqual(o.URI.file(g),o.URI.file(d)));for(const d of b)if(d.config?.extensionDevelopmentPath?.some(g=>f(g)))return d}}),define(oe[103],ae([0,1,31,43,108,48,12,10,3,19,7,6,75,30]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhb=void 0,e.$Yhb=h,e.$Zhb=p,e.$1hb=y,e.$2hb=$,e.$3hb=k,e.$4hb=r,e.$5hb=i,e.$6hb=S,e.$7hb=v,o=De(o),P=De(P),e.$Xhb=(0,d.$Fi)("workspacesService");function h(R){return R.hasOwnProperty("workspace")}function p(R){return R.hasOwnProperty("folderUri")}function y(R){return R.hasOwnProperty("fileUri")}function $(R){return m(R)||E(R)}function m(R){const T=R;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function E(R){const T=R;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function k(R,T,L,O,F){if(R.scheme!==O.scheme)return{name:L,uri:R.toString(!0)};let B=T?void 0:F.relativePath(O,R);if(B!==void 0)B.length===0?B=".":b.$i&&(B=t(B));else if(R.scheme===A.Schemas.file)B=R.fsPath,b.$i&&(B=t(B));else if(F.isEqualAuthority(R.authority,O.authority))B=R.path;else return{name:L,uri:R.toString(!0)};return{name:L,path:B}}function t(R){return R=(0,D.$Ww)(R),(0,n.$Bg)(R)||(R=(0,n.$yg)(R)),R}function r(R,T,L){const O=[],F=new Set,B=L.dirname(T);for(const C of R){let z;if(m(C))C.path&&(z=L.resolvePath(B,C.path));else if(E(C))try{z=f.URI.parse(C.uri),z.path[0]!==I.$ic.sep&&(z=z.with({path:I.$ic.sep+z.path}))}catch(re){console.warn(re)}if(z){const re=L.getComparisonKey(z);if(!F.has(re)){F.add(re);const Q=C.name||L.basenameOrAuthority(z);O.push(new w.$Zi({uri:z,name:Q,index:O.length},C))}}}return O}function i(R,T,L,O,F){const B=c(T,R),C=F.dirname(T),z=F.dirname(O),re=[];for(const ee of B.folders){const q=m(ee)?F.resolvePath(C,ee.path):f.URI.parse(ee.uri);let j;L?j=!1:j=!m(ee)||(0,I.$kc)(ee.path),re.push(k(q,j,ee.name,z,F))}const Q={insertSpaces:!1,tabSize:4,eol:b.$k||b.$j?`
`:`\r
`},le=P.$_n(R,["folders"],re,Q);let K=P.$co(R,le);return(0,a.$lh)(B.remoteAuthority,(0,g.$gn)(O))&&(K=P.$co(K,P.$$n(K,["remoteAuthority"],Q))),K}function c(R,T){const L=o.$Xn(T);if(L&&Array.isArray(L.folders))L.folders=L.folders.filter(O=>$(O));else throw new Error(`${R} looks like an invalid workspace file.`);return L}function s(R){return R.workspace&&typeof R.workspace=="object"&&typeof R.workspace.id=="string"&&typeof R.workspace.configPath=="string"}function u(R){return typeof R.folderUri=="string"}function l(R){return typeof R.fileUri=="string"}function S(R,T){const L={workspaces:[],files:[]};if(R){const O=function(B,C){for(let z=0;z<B.length;z++)try{C(B[z],z)}catch(re){T.warn(`Error restoring recent entry ${JSON.stringify(B[z])}: ${re.toString()}. Skip entry.`)}},F=R;Array.isArray(F.entries)&&O(F.entries,B=>{const C=B.label,z=B.remoteAuthority;s(B)?L.workspaces.push({label:C,remoteAuthority:z,workspace:{id:B.workspace.id,configPath:f.URI.parse(B.workspace.configPath)}}):u(B)?L.workspaces.push({label:C,remoteAuthority:z,folderUri:f.URI.parse(B.folderUri)}):l(B)&&L.files.push({label:C,remoteAuthority:z,fileUri:f.URI.parse(B.fileUri)})})}return L}function v(R){const T={entries:[]};for(const L of R.workspaces)p(L)?T.entries.push({folderUri:L.folderUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority}):T.entries.push({workspace:{id:L.workspace.id,configPath:L.workspace.configPath.toString()},label:L.label,remoteAuthority:L.remoteAuthority});for(const L of R.files)T.entries.push({fileUri:L.fileUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority});return T}}),define(oe[104],ae([0,1,92,12,3,19]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=void 0,e.$4ec=A,e.$5ec=I,e.$6ec=b,e.$3ec=128/4;function A(a){function f(){let d=a.scheme===o.Schemas.file?(0,D.$7g)(a):a.toString();return P.$k||(d=d.toLowerCase()),(0,n.createHash)("md5").update(d).digest("hex")}return{id:f(),configPath:a}}function I(a,f){function d(){if(a.scheme!==o.Schemas.file)return(0,n.createHash)("md5").update(a.toString()).digest("hex");if(!f)return;let w;return P.$k?w=f.ino:P.$j?w=f.birthtime.getTime():P.$i&&(typeof f.birthtimeMs=="number"?w=Math.floor(f.birthtimeMs):w=f.birthtime.getTime()),(0,n.createHash)("md5").update(a.fsPath).update(w?String(w):"").digest("hex")}const g=d();if(typeof g=="string")return{id:g,uri:a}}function b(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(oe[105],ae([0,1,92,93,27,290,17,16,4,2,10,3,33,44,118]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$wi=e.$vi=e.$ui=void 0,e.$xi=s,e.$yi=u,e.$Ai=v,e.$Bi=R;const p=3e4;class y{traceSocketEvent(L,O){h.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,O)}constructor(L,O=""){this.f=!0,this.debugLabel=O,this.socket=L,this.traceSocketEvent(h.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=B=>{if(this.traceSocketEvent(h.SocketDiagnosticsEventType.Error,{code:B?.code,message:B?.message}),B){if(B.code==="EPIPE")return;(0,I.$3)(B)}},this.socket.on("error",this.a);let F;this.b=B=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.Close,{hadError:B}),this.f=!1,F&&clearTimeout(F)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,F=setTimeout(()=>L.destroy(),p)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(L){const O=F=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.Read,F),L(A.$Oe.wrap(F))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(L){const O=F=>{L({type:h.SocketCloseEventType.NodeSocketCloseEvent,hadError:F,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(L){const O=()=>{L()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(L){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(h.SocketDiagnosticsEventType.Write,L),this.socket.write(L.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,I.$3)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,I.$3)(O)}}end(){this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((L,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainEnd),L();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainEnd),L()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.$ui=y;var $;(function(T){T[T.MinHeaderByteSize=2]="MinHeaderByteSize",T[T.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var m;(function(T){T[T.PeekHeader=1]="PeekHeader",T[T.ReadHeader=2]="ReadHeader",T[T.ReadBody=3]="ReadBody",T[T.Fin=4]="Fin"})(m||(m={}));class E extends a.$Wc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(L,O){this.socket.traceSocketEvent(L,O)}constructor(L,O,F,B){super(),this.f=this.B(new b.$me),this.g=this.B(new b.$me),this.h=!1,this.j={state:m.PeekHeader,readLen:$.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=L,this.traceSocketEvent(h.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:F?.byteLength||0,recordInflateBytes:B}),this.a=this.B(new k(this,O,F,B,this.f,(C,z)=>this.m(C,z))),this.B(this.a.onError(C=>{console.error(C),(0,I.$3)(C),this.g.fire({type:h.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:C})})),this.b=new h.$pi,this.B(this.socket.onData(C=>this.n(C))),this.B(this.socket.onClose(async C=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(C)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this.f.event(L)}onClose(L){return this.g.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){let O=0;for(;O<L.byteLength;)this.a.writeMessage(L.slice(O,Math.min(O+$.MaxWebSocketMessageLength,L.byteLength)),{compressed:!0,opcode:2}),O+=$.MaxWebSocketMessageLength}m(L,{compressed:O,opcode:F}){if(this.h)return;this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,L);let B=$.MinHeaderByteSize;L.byteLength<126?B+=0:L.byteLength<2**16?B+=2:B+=8;const C=A.$Oe.alloc(B),z=O?64:0,re=F&15;if(C.writeUInt8(128|z|re,0),L.byteLength<126)C.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){C.writeUInt8(126,1);let Q=1;C.writeUInt8(L.byteLength>>>8&255,++Q),C.writeUInt8(L.byteLength>>>0&255,++Q)}else{C.writeUInt8(127,1);let Q=1;C.writeUInt8(0,++Q),C.writeUInt8(0,++Q),C.writeUInt8(0,++Q),C.writeUInt8(0,++Q),C.writeUInt8(L.byteLength>>>24&255,++Q),C.writeUInt8(L.byteLength>>>16&255,++Q),C.writeUInt8(L.byteLength>>>8&255,++Q),C.writeUInt8(L.byteLength>>>0&255,++Q)}this.socket.write(A.$Oe.concat([C,L]))}end(){this.h=!0,this.socket.end()}n(L){if(L.byteLength!==0){for(this.b.acceptChunk(L);this.b.byteLength>=this.j.readLen;)if(this.j.state===m.PeekHeader){const O=this.b.peek(this.j.readLen),F=O.readUInt8(0),B=(F&128)>>>7,C=(F&64)>>>6,z=F&15,re=O.readUInt8(1),Q=(re&128)>>>7,le=re&127;this.j.state=m.ReadHeader,this.j.readLen=$.MinHeaderByteSize+(Q?4:0)+(le===126?2:0)+(le===127?8:0),this.j.fin=B,this.j.firstFrameOfMessage&&(this.j.compressed=!!C),this.j.firstFrameOfMessage=!!B,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===m.ReadHeader){const O=this.b.read(this.j.readLen),F=O.readUInt8(1),B=(F&128)>>>7;let C=F&127,z=1;C===126?C=O.readUInt8(++z)*2**8+O.readUInt8(++z):C===127&&(C=O.readUInt8(++z)*0+O.readUInt8(++z)*0+O.readUInt8(++z)*0+O.readUInt8(++z)*0+O.readUInt8(++z)*2**24+O.readUInt8(++z)*2**16+O.readUInt8(++z)*2**8+O.readUInt8(++z));let re=0;B&&(re=O.readUInt8(++z)*2**24+O.readUInt8(++z)*2**16+O.readUInt8(++z)*2**8+O.readUInt8(++z)),this.j.state=m.ReadBody,this.j.readLen=C,this.j.mask=re,this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===m.ReadBody){const O=this.b.read(this.j.readLen);this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,O),i(O,this.j.mask),this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,O),this.j.state=m.PeekHeader,this.j.readLen=$.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$vi=E;class k extends a.$Wc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$Oe.alloc(0)}constructor(L,O,F,B,C,z){super(),this.n=L,this.r=C,this.s=z,this.a=this.B(new b.$me),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$me),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$me),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new t(this.n,B,F,{windowBits:15})),this.f=this.B(new r(this.n,{windowBits:15})),this.B(this.b.onError(re=>this.a.fire(re))),this.B(this.f.onError(re=>this.a.fire(re)))):(this.b=null,this.f=null)}writeMessage(L,O){this.g.push({data:L,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:L,options:O}=this.g.shift();if(this.f&&O.compressed){const F=await this.w(this.f,L);this.s(F,O)}else this.s(L,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(L,O){return new Promise((F,B)=>{L.write(O),L.flush(C=>F(C))})}acceptFrame(L,O,F){this.h.push({data:L,isCompressed:O,isLastFrameOfMessage:F}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const L=this.h.shift();if(this.b&&L.isCompressed){const O=await this.C(this.b,L.data,L.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(L.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(L,O,F){return new Promise((B,C)=>{L.write(O),F&&L.write(A.$Oe.fromByteArray([0,0,255,255])),L.flush(z=>B(z))})}}class t extends a.$Wc{get recordedInflateBytes(){return this.j?A.$Oe.concat(this.f):A.$Oe.alloc(0)}constructor(L,O,F,B){super(),this.h=L,this.j=O,this.a=this.B(new b.$me),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,D.createInflateRaw)(B),this.b.on("error",C=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateError,{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateData,C),this.g.push(A.$Oe.wrap(C))}),F&&(this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateInitialWrite,F.buffer),this.b.write(F.buffer),this.b.flush(()=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(L){this.j&&this.f.push(L.clone()),this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateWrite,L),this.b.write(L.buffer)}flush(L){this.b.flush(()=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateFlushFired);const O=A.$Oe.concat(this.g);this.g.length=0,L(O)})}}class r extends a.$Wc{constructor(L,O){super(),this.g=L,this.a=this.B(new b.$me),this.onError=this.a.event,this.f=[],this.b=(0,D.createDeflateRaw)({windowBits:15}),this.b.on("error",F=>{this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateError,{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateData,F),this.f.push(A.$Oe.wrap(F))})}write(L){this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateWrite,L.buffer),this.b.write(L.buffer)}flush(L){this.b.flush(2,()=>{this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateFlushFired);let O=A.$Oe.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),L(O)})}}function i(T,L){if(L===0)return;const O=T.byteLength>>>2;for(let Q=0;Q<O;Q++){const le=T.readUInt32BE(Q*4);T.writeUInt32BE(le^L,Q*4)}const F=O*4,B=T.byteLength-F,C=L>>>24&255,z=L>>>16&255,re=L>>>8&255;B>=1&&T.writeUInt8(T.readUInt8(F)^C,F),B>=2&&T.writeUInt8(T.readUInt8(F+1)^z,F+1),B>=3&&T.writeUInt8(T.readUInt8(F+2)^re,F+2)}e.$wi=process.env.XDG_RUNTIME_DIR;const c={[d.Platform.Linux]:107,[d.Platform.Mac]:103};function s(){const T=(0,g.$2g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${T}-sock`;const L=process.platform!=="darwin"&&e.$wi?e.$wi:(0,P.tmpdir)(),O=(0,f.$lc)(L,`vscode-ipc-${T}.sock`);return l(O),O}function u(T,L,O){const B=(0,n.createHash)("sha256").update(T).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${B}-${O}-${L}-sock`;const C=O.substr(0,4),z=L.substr(0,6);let re;return process.platform!=="darwin"&&e.$wi&&!process.env.VSCODE_PORTABLE?re=(0,f.$lc)(e.$wi,`vscode-${B}-${C}-${z}.sock`):re=(0,f.$lc)(T,`${C}-${z}.sock`),l(re),re}function l(T){const L=c[d.$u];typeof L=="number"&&T.length>=L&&console.warn(`WARNING: IPC handle "${T}" is longer than ${L} chars, try a shorter --user-data-dir`)}class S extends w.$ji{static b(L){const O=b.Event.fromNodeEventEmitter(L,"connection");return b.Event.map(O,F=>({protocol:new h.$qi(new y(F,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(F,"close"))}))}constructor(L){super(S.b(L)),this.d=L}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$zi=S;function v(T){return new Promise((L,O)=>{const F=(0,o.createServer)();F.on("error",O),F.listen(T,()=>{F.removeListener("error",O),L(new S(F))})})}function R(T,L){return new Promise((O,F)=>{const B=(0,o.createConnection)(T,()=>{B.removeListener("error",F),O(h.$ri.fromSocket(new y(B,`ipc-client${L}`),L))});B.once("error",F)})}}),define(oe[24],ae([0,1,54,10,3,105,38,96,6]),function(x,e,n,o,P,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=e.$Jec=void 0,e.$Jec=(0,b.$Gi)(A.$Mi);class a extends I.$8m{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,o.$lc)(this.userDataPath,"clp")}get backupHome(){return(0,o.$lc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,D.$yi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,o.$lc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(P.$k){for(const d in process.env)if(d.endsWith("_VSCODE_SNAP_ORIG")){const g=d.slice(0,-17);if(this.d[g])continue;process.env[g]&&(this.d[g]=process.env[g]),process.env[d]?process.env[g]=process.env[d]:delete process.env[g]}}}restoreSnapExportedVariables(){if(P.$k)for(const d in this.d)process.env[d]=this.d[d],delete this.d[d]}}e.$Kec=a,Pe([n.$0h],a.prototype,"cachedLanguagesPath",null),Pe([n.$0h],a.prototype,"backupHome",null),Pe([n.$0h],a.prototype,"mainIPCHandle",null),Pe([n.$0h],a.prototype,"mainLockfile",null),Pe([n.$0h],a.prototype,"disableUpdates",null),Pe([n.$0h],a.prototype,"crossOriginIsolated",null),Pe([n.$0h],a.prototype,"codeCachePath",null),Pe([n.$0h],a.prototype,"useCodeCache",null)}),define(oe[291],ae([0,1,92,31,12,10,3,19,21,203,18,24,34,15,5,202,30,104]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;let E=class{static{m=this}static{this.a="backupWorkspaces"}constructor(t,r,i,c){this.j=t,this.k=r,this.l=i,this.m=c,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.$0g,this.i={isEqual:(s,u)=>(0,o.$Dg)(s,u,!A.$k)}}async initialize(){const t=this.m.getItem(m.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(t.emptyWindows),this.d=await this.u((0,a.$Mec)(t)),this.e=await this.v((0,a.$Nec)(t)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==w.$yl.OFF}q(){return this.s()===w.$yl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||w.$yl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(t,r){this.d.some(c=>t.workspace.id===c.workspace.id)||(this.d.push(t),this.C());const i=(0,D.$lc)(this.c,t.workspace.id);return r?this.t(i,r).then(()=>i):i}async t(t,r){if(await b.Promises.exists(t)&&await this.z(t),await b.Promises.exists(r))try{await b.Promises.rename(r,t,!1)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(t){return this.e.some(r=>this.h.isEqual(t.folderUri,r.folderUri))||(this.e.push(t),this.C()),(0,D.$lc)(this.c,this.D(t))}registerEmptyWindowBackup(t){return this.g.some(r=>!!r.backupFolder&&this.i.isEqual(r.backupFolder,t.backupFolder))||(this.g.push(t),this.C()),(0,D.$lc)(this.c,t.backupFolder)}async u(t){if(!Array.isArray(t))return[];const r=new Set,i=[];for(const c of t){const s=c.workspace;if(!(0,y.$Ui)(s))return[];if(!r.has(s.id)){r.add(s.id);const u=(0,D.$lc)(this.c,s.id);await this.B(u)?s.configPath.scheme!==P.Schemas.file||await b.Promises.exists(s.configPath.fsPath)?i.push(c):await this.z(u):await this.x(u)}}return i}async v(t){if(!Array.isArray(t))return[];const r=[],i=new Set;for(const c of t){const s=c.folderUri,u=this.h.getComparisonKey(s);if(!i.has(u)){i.add(u);const l=(0,D.$lc)(this.c,this.D(c));await this.B(l)?s.scheme!==P.Schemas.file||await b.Promises.exists(s.fsPath)?r.push(c):await this.z(l):await this.x(l)}}return r}async w(t){if(!Array.isArray(t))return[];const r=[],i=new Set;for(const c of t){const s=c.backupFolder;if(typeof s!="string")return[];if(!i.has(s)){i.add(s);const u=(0,D.$lc)(this.c,s);await this.B(u)?r.push(c):await this.x(u)}}return r}async x(t){try{await b.Promises.rm(t,b.RimRafMode.MOVE)}catch(r){this.l.error(`Backup: Could not delete stale backup: ${r.toString()}`)}}y(){let t=(0,$.$6ec)();for(;this.g.some(r=>!!r.backupFolder&&this.i.isEqual(r.backupFolder,t.id));)t=(0,$.$6ec)();return{backupFolder:t.id}}async z(t){const r=this.y(),i=(0,D.$lc)(this.c,r.backupFolder);try{await b.Promises.rename(t,i,!1)}catch(c){return this.l.error(`Backup: Could not rename backup folder: ${c.toString()}`),!1}return this.g.push(r),!0}async getDirtyWorkspaces(){const t=[];for(const r of this.d)await this.A(r)&&t.push(r);for(const r of this.e)await this.A(r)&&t.push(r);return t}A(t){let r;return(0,a.$Lec)(t)?r=(0,D.$lc)(this.c,t.backupFolder):(0,p.$Vhb)(t)?r=(0,D.$lc)(this.c,this.D(t)):r=(0,D.$lc)(this.c,t.workspace.id),this.B(r)}async B(t){try{const r=await b.Promises.readdir(t);for(const i of r)try{if((await b.Promises.readdir((0,D.$lc)(t,i))).length>0)return!0}catch{}}catch{}return!1}C(){const t={workspaces:this.d.map(({workspace:r,remoteAuthority:i})=>{const c={id:r.id,configURIPath:r.configPath.toString()};return i&&(c.remoteAuthority=i),c}),folders:this.e.map(({folderUri:r,remoteAuthority:i})=>{const c={folderUri:r.toString()};return i&&(c.remoteAuthority=i),c}),emptyWindows:this.g.map(({backupFolder:r,remoteAuthority:i})=>{const c={backupFolder:r};return i&&(c.remoteAuthority=i),c})};this.m.setItem(m.a,t)}D(t){const r=t.folderUri;let i;return r.scheme===P.Schemas.file?i=A.$k?r.fsPath:r.fsPath.toLowerCase():i=r.toString().toLowerCase(),(0,n.createHash)("md5").update(i).digest("hex")}};e.$mfc=E,e.$mfc=E=m=Pe([ne(0,d.$Jec),ne(1,f.$_i),ne(2,h.$_j),ne(3,g.$gR)],E)}),define(oe[20],ae([0,1,14,35,8,4,2,3,37,13,6,5,34,52,24]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=e.LifecycleMainPhase=e.ShutdownReason=e.$bfc=void 0,e.$bfc=(0,f.$Fi)("lifecycleMainService");var y;(function(E){E[E.QUIT=1]="QUIT",E[E.KILL=2]="KILL"})(y||(e.ShutdownReason=y={}));var $;(function(E){E[E.Starting=1]="Starting",E[E.Ready=2]="Ready",E[E.AfterWindowOpen=3]="AfterWindowOpen",E[E.Eventually=4]="Eventually"})($||(e.LifecycleMainPhase=$={}));let m=class extends A.$Wc{static{p=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(k,t,r){super(),this.F=k,this.G=t,this.H=r,this.c=this.B(new D.$me),this.onBeforeShutdown=this.c.event,this.f=this.B(new D.$me),this.onWillShutdown=this.f.event,this.g=this.B(new D.$me),this.onWillLoadWindow=this.g.event,this.h=this.B(new D.$me),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=$.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when($.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(p.b),this.m&&this.G.removeItem(p.b)}J(){const k=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.$j&&this.t===0&&this.L(y.QUIT))};n.app.addListener("before-quit",k);const t=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!I.$j)&&n.app.quit()};n.app.addListener("window-all-closed",t),n.app.once("will-quit",r=>{this.S("Lifecycle#app.on(will-quit) - begin"),r.preventDefault(),this.L(y.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",k),n.app.removeListener("window-all-closed",t),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(k){if(this.y)return this.y;const t=this.F;this.S("Lifecycle#onWillShutdown.fire()");const r=[];return this.f.fire({reason:k,join(i,c){t.trace(`Lifecycle#onWillShutdown - begin '${i}'`),r.push(c.finally(()=>{t.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await P.Promises.settled(r)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(k){if(k<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===k)return;this.S(`lifecycle (main): phase changed (value: ${k})`),this.n=k;const t=this.C.get(this.n);t&&(t.open(),this.C.delete(this.n))}async when(k){if(k<=this.n)return;let t=this.C.get(k);t||(t=new P.$Eh,this.C.set(k,t)),await t.wait()}registerWindow(k){const t=new A.$Vc;this.t++,t.add(k.onWillLoad(i=>this.g.fire({window:k,workspace:i.workspace,reason:i.reason})));const r=(0,a.$qg)(k.win);t.add(D.Event.fromNodeEventEmitter(r,"close")(i=>{const c=k.id;if(this.r.has(c)){this.r.delete(c);return}this.S(`Lifecycle#window.on('close') - window ID ${k.id}`),i.preventDefault(),this.unload(k,w.UnloadReason.CLOSE).then(s=>{if(s){this.r.delete(c);return}this.r.add(c),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this.h.fire(k),k.close()})})),t.add(D.Event.fromNodeEventEmitter(r,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${k.id}`),this.t--,t.dispose(),this.t===0&&(!I.$j||this.j)&&this.L(y.QUIT)}))}registerAuxWindow(k){const t=(0,a.$qg)(k.win),r=new A.$Vc;r.add(D.Event.fromNodeEventEmitter(t,"close")(i=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${k.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),i.preventDefault())})),r.add(D.Event.fromNodeEventEmitter(t,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${k.id}`),r.dispose()}))}async reload(k,t){await this.unload(k,w.UnloadReason.RELOAD)||k.reload(t)}unload(k,t){const r=this.z.get(k.id);if(r)return r;const i=this.M(k,t).finally(()=>{this.z.delete(k.id)});return this.z.set(k.id,i),i}async M(k,t){if(!k.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${k.id}`);const r=this.j?w.UnloadReason.QUIT:t,i=await this.P(k,r);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${k.id})`),this.N(i)):(await this.Q(k,r),!1)}N(k){return k?(this.O(!0),this.j=!1,!0):!1}O(k){this.w&&(this.w(k),this.w=void 0,this.u=void 0)}P(k,t){return new Promise(r=>{const i=this.s++,c=`vscode:ok${i}`,s=`vscode:cancel${i}`;o.$FX.once(c,()=>{r(!1)}),o.$FX.once(s,()=>{r(!0)}),k.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:s,reason:t})})}Q(k,t){return new Promise(r=>{const c=`vscode:reply${this.s++}`;o.$FX.once(c,()=>r()),k.send("vscode:onWillUnload",{replyChannel:c,reason:t})})}quit(k){return this.R(k).then(t=>{if(!t&&k)try{if(I.$i){const r=(0,b.cwd)();r!==process.cwd()&&process.chdir(r)}}catch(r){this.F.error(r)}return t})}R(k){return this.S(`Lifecycle#quit() - begin (willRestart: ${k})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(k&&this.G.setItem(p.b,!0),this.u=new Promise(t=>{this.w=t,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(k){this.H.args["enable-smoke-test-driver"]?this.F.info(k):this.F.trace(k)}setRelaunchHandler(k){this.D=k}async relaunch(k){this.S("Lifecycle#relaunch()");const t=process.argv.slice(1);if(k?.addArgs&&t.push(...k.addArgs),k?.removeArgs)for(const c of k.removeArgs){const s=t.indexOf(c);s>=0&&t.splice(s,1)}const r=()=>{this.D?.handleRelaunch(k)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:t}))};n.app.once("quit",r),await this.quit(!0)&&n.app.removeListener("quit",r)}async kill(k){this.S("Lifecycle#kill()"),await this.L(y.KILL),await Promise.race([(0,P.$Gh)(1e3),(async()=>{for(const t of n.BrowserWindow.getAllWindows())if(t&&!t.isDestroyed()){let r;t.webContents&&!t.webContents.isDestroyed()?r=new Promise(i=>t.once("closed",i)):r=Promise.resolve(),t.destroy(),await r}})()]),n.app.exit(k)}};e.$cfc=m,e.$cfc=m=p=Pe([ne(0,d.$_j),ne(1,g.$gR),ne(2,h.$Jec)],m)}),define(oe[292],ae([0,1,3,4,2,6,20]),function(x,e,n,o,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=e.$Kfc=void 0,n=De(n),e.$Kfc=(0,D.$Fi)("keyboardLayoutMainService");let I=class extends P.$Wc{constructor(f){super(),this.a=this.B(new o.$me),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,f.when(A.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const f=await new Promise((d,g)=>{x(["native-keymap"],d,g)}).then(De);this.c=b(f),n.$t||f.onDidChangeKeyboardLayout(()=>{this.c=b(f),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$Lfc=I,e.$Lfc=I=Pe([ne(0,A.$bfc)],I);function b(a){const f=a.getKeyMap(),d=a.getCurrentKeyboardLayout();return{keyboardMapping:f,keyboardLayoutInfo:d}}}),define(oe[293],ae([0,1,253,8,17,16,13,18,38,101,5,57,252,290]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0,e.$ds=y;let h=class extends d.$6p{constructor(m,E,k,t){super(t),this.m=m,this.n=E,this.r=k,this.s(),this.B(m.onDidChangeConfiguration(r=>{r.affectsConfiguration("http")&&this.s()}))}s(){const m=this.m.getValue("http");this.f=m?.proxy,this.g=!!m?.proxyStrictSSL,this.h=m?.proxyAuthorization}async request(m,E){const{f:k,g:t}=this;let r;try{r=await(0,a.$Qm)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,D.$_)(s)))}const i={...process.env,...r},c=m.agent?m.agent:await(0,g.$bs)(m.url||"",i,{proxyUrl:k,strictSSL:t});return m.agent=c,m.strictSSL=t,this.h&&(m.headers={...m.headers||{},"Proxy-Authorization":this.h}),this.c(m.isChromiumNetwork?"electron":"node",m,()=>y(m,E))}async resolveProxy(m){}async loadCertificates(){return(await new Promise((E,k)=>{x(["@vscode/proxy-agent"],E,k)}).then(De)).loadSystemCertificates({log:this.r})}};e.$cs=h,e.$cs=h=Pe([ne(0,I.$_i),ne(1,b.$Ni),ne(2,f.$_j),ne(3,f.$ak)],h);async function p($){return((0,n.parse)($.url).protocol==="https:"?await new Promise((k,t)=>{x(["https"],k,t)}).then(De):await new Promise((k,t)=>{x(["http"],k,t)}).then(De)).request}async function y($,m){return o.Promises.withAsyncBody(async(E,k)=>{const t=(0,n.parse)($.url),r=$.getRawRequest?$.getRawRequest($):await p($),i={hostname:t.hostname,port:t.port?parseInt(t.port):t.protocol==="https:"?443:80,protocol:t.protocol,path:t.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,A.$lg)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(i.auth=$.user+":"+$.password);const c=r(i,s=>{const u=(0,A.$jg)($.followRedirects)?$.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&u>0&&s.headers.location)y({...$,url:s.headers.location,followRedirects:u-1},m).then(E,k);else{let l=s;!$.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(l=s.pipe((0,w.createGunzip)())),E({res:s,stream:(0,P.$4e)(l)})}});c.on("error",k),$.timeout&&c.setTimeout($.timeout),$.isChromiumNetwork&&c.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&c.write($.data),c.end(),m.onCancellationRequested(()=>{c.abort(),k(new D.$7)})})}}),define(oe[294],ae([0,1,14,293]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=void 0;function P(A){return n.net.request}class D extends o.$cs{request(I,b){return super.request({...I||{},getRawRequest:P,isChromiumNetwork:!0},b)}}e.$Pgc=D}),define(oe[88],ae([0,1,7,4,2,38,15,6,20,5,63,287,42,59,41,12]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=e.$jfc=e.$ifc=e.$hfc=void 0,e.$hfc=(0,I.$Fi)("storageMainService");let y=class extends P.$Wc{constructor(E,k,t,r,i,c){super(),this.c=E,this.f=k,this.g=t,this.h=r,this.j=i,this.m=c,this.a=void 0,this.b=this.B(new o.$me),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(b.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(E=>{E.window.profile&&this.profileStorage(E.window.profile).init(),E.workspace&&this.workspaceStorage(E.workspace).init()})),this.B(this.h.onWillShutdown(E=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=E.reason,E.join("applicationStorage",this.applicationStorage.close());for(const[,k]of this.t)E.join("profileStorage",k.close());for(const[,k]of this.w)E.join("workspaceStorage",k.close())})),this.B(this.g.onWillCreateProfile(E=>{E.join((async()=>{await this.j.exists(E.profile.globalStorageHome)||await this.j.createFolder(E.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(E=>{const k=this.t.get(E.profile.id);k&&E.join(k.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const E=new d.$efc(this.n(),this.g,this.c,this.j);return this.B(o.Event.once(E.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),E}profileStorage(E){if((0,f.$iq)(E))return this.applicationStorage;let k=this.t.get(E.id);if(!k){this.c.trace(`StorageMainService: creating profile storage (${E.name})`),k=this.B(this.u(E)),this.t.set(E.id,k);const t=this.B(k.onDidChangeStorage(r=>this.b.fire({...r,storage:k,profile:E})));this.B(o.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${E.name})`),this.t.delete(E.id),t.dispose()}))}return k}u(E){return this.a===b.ShutdownReason.KILL?new d.$gfc(this.c,this.j):new d.$dfc(E,this.n(),this.c,this.j)}workspaceStorage(E){let k=this.w.get(E.id);return k||(this.c.trace(`StorageMainService: creating workspace storage (${E.id})`),k=this.B(this.y(E)),this.w.set(E.id,k),this.B(o.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${E.id})`),this.w.delete(E.id)}))),k}y(E){return this.a===b.ShutdownReason.KILL?new d.$gfc(this.c,this.j):new d.$ffc(E,this.n(),this.c,this.f,this.j)}isUsed(E){const k=n.URI.file(E);for(const t of[this.applicationStorage,...this.t.values(),...this.w.values()])if(t.path&&this.m.extUri.isEqualOrParent(n.URI.file(t.path),k))return!0;return!1}};e.$ifc=y,e.$ifc=y=Pe([ne(0,a.$_j),ne(1,D.$Mi),ne(2,w.$Xec),ne(3,b.$bfc),ne(4,A.$_k),ne(5,h.$Jl)],y),e.$jfc=(0,I.$Fi)("applicationStorageMainService");let $=class extends f.$hq{constructor(E,k){super(),this.s=E,this.U=k,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(E){if(E===f.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(E){if(E===f.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$kfc=$,e.$kfc=$=Pe([ne(0,g.$Ll),ne(1,e.$hfc)],$)}),define(oe[295],ae([0,1,93,27,112,105,8,2,3,18,5,28,246,249,102,132,17]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=e.$Mgc=e.$Lgc=void 0,n=De(n),o=De(o);async function $(r,i,c,s,u){let l;for(let S=3;S&&(l?.dispose(),l=await new m(r,i,c,s,u).waitForReady(),!(u&&P.$5g[u]||!P.$5g[l.tunnelLocalPort]));S--);return l}class m extends I.$Wc{constructor(i,c,s,u,l){super(),this.m=c,this.n=l,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=n.createServer(),this.c=new A.$Eh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=S=>this.r(S),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=u,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(c=>{c()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,c=(0,p.$Iw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,P.$6g)(i,2,1e3,c),u=null;return this.b.listen(s,this.m),await this.c.wait(),u=this.b.address(),u||(s=0,this.b.listen(s,this.m),await this.c.wait(),u=this.b.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async r(i){i.pause();const c=(0,p.$Gw)(this.tunnelRemoteHost)||(0,p.$Iw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,g.$2l)(this.a,c,this.tunnelRemotePort),u=s.getSocket(),l=s.readEntireBuffer();s.dispose(),l.byteLength>0&&i.write(l.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),u.end()}),i.on("close",()=>u.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),u instanceof D.$ui?u.socket.destroy():u.end()}),u instanceof D.$ui?this.t(i,u):this.s(i,u),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),u.end()})}s(i,c){c.onClose(()=>i.destroy()),c.onEnd(()=>i.end()),c.onData(s=>i.write(s.buffer)),i.on("data",s=>c.write(y.$Oe.wrap(s))),i.resume()}t(i,c){const s=c.socket;s.on("end",()=>i.end()),s.on("close",()=>i.end()),s.on("error",()=>{i.destroy()}),s.pipe(i),i.pipe(s)}}e.$Lgc=m;let E=class extends p.$Lw{constructor(i,c,s,u,l){super(c,l),this.H=i,this.I=s,this.J=u}isPortPrivileged(i){return(0,p.$Jw)(i,this.t,b.OS,o.release())}F(i,c,s,u,l,S,v,R){const T=this.D(c,s);if(T)return++T.refcount,T.value;if((0,p.$Cw)(i))return this.G(i,c,s,l,S,v,R);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${s} on local port ${l}.`);const L={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},O=$(L,u,c,s,l);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(c,s,O),O}}};e.$Mgc=E,e.$Mgc=E=Pe([ne(0,w.$Vl),ne(1,f.$_j),ne(2,h.$Yl),ne(3,d.$sk),ne(4,a.$_i)],E);let k=class extends E{constructor(i,c,s,u,l){super(i,c,s,u,l)}};e.$Ngc=k,e.$Ngc=k=Pe([ne(0,w.$Vl),ne(1,f.$_j),ne(2,h.$Yl),ne(3,d.$sk),ne(4,a.$_i)],k);let t=class extends I.$Wc{constructor(i,c,s,u,l){super(),this.b=i,this.c=c,this.f=s,this.g=u,this.h=l,this.a=new Map}async openTunnel(i,c,s,u,l,S,v,R,T){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${u} on local port ${S}.`),!this.a.has(i)){const L=new k(this.b,this.c,this.g,this.f,this.h);this.B(L),this.a.set(i,L),L.onTunnelClosed(async()=>{(await L.tunnels).length===0&&(L.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(c,s,u,l,S,v,R,T)}};e.$Ogc=t,e.$Ogc=t=Pe([ne(0,w.$Vl),ne(1,f.$_j),ne(2,d.$sk),ne(3,h.$Yl),ne(4,a.$_i)],t)}),define(oe[106],ae([0,1,8,23,4,18,24,20,5,28,57,50]),function(x,e,n,o,P,D,A,I,b,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0,e.$8fc=g;function g(h,p,y){return`${y.updateUrl}/api/update/${h}/${p}/${y.commit}`}let w=class{get state(){return this.b}d(p){this.j.info("update#setState",p.type),this.b=p,this.c.fire(p)}constructor(p,y,$,m,E,k){this.f=p,this.g=y,this.h=$,this.i=m,this.j=E,this.k=k,this.b=d.$DY.Uninitialized,this.c=new P.$me,this.onStateChange=this.c.event,p.when(I.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(d.$DY.Disabled(d.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(d.$DY.Disabled(d.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(d.$DY.Disabled(d.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const p=this.g.getValue("update.mode"),y=this.m(p);if(!y){this.d(d.$DY.Disabled(d.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(y),!this.a){this.d(d.$DY.Disabled(d.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const $=new URL(this.a);$.searchParams.set("prss","true"),this.a=$.toString()}if(this.d(d.$DY.Idle(this.q())),p==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}p==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(p){return p==="none"?void 0:this.k.quality}n(p=60*60*1e3){return(0,n.$Gh)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(p){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===d.StateType.Idle&&this.t(p)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===d.StateType.AvailableForDownload&&await this.o(this.state)}async o(p){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===d.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==d.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},o.CancellationToken.None)).res.statusCode===204}catch(y){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(y);return}}async _applySpecificUpdate(p){}q(){return d.UpdateType.Archive}r(){}};e.$9fc=w,e.$9fc=w=Pe([ne(0,I.$bfc),ne(1,D.$_i),ne(2,A.$Jec),ne(3,f.$5p),ne(4,b.$_j),ne(5,a.$sk)],w)}),define(oe[296],ae([0,1,14,54,4,46,2,18,24,20,5,28,57,25,50,106]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0,n=De(n);let y=class extends p.$9fc{get v(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"error",(m,E)=>E)}get w(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(m,E,k,t)=>({version:k,productVersion:k,timestamp:t}))}constructor(m,E,k,t,r,i,c){super(m,E,t,r,i,c),this.z=k,this.u=new A.$Vc,m.setRelaunchHandler(this)}handleRelaunch(m){return m?.addArgs||m?.removeArgs||this.state.type!==h.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(m){this.z.publicLog2("update:error",{messageHash:String((0,D.$tj)(String(m)))}),this.j.error("UpdateService error:",m);const E=this.state.type===h.StateType.CheckingForUpdates&&this.state.explicit?m:void 0;this.d(h.$DY.Idle(h.UpdateType.Archive,E))}s(m){let E;this.k.darwinUniversalAssetId?E=this.k.darwinUniversalAssetId:E=process.arch==="x64"?"darwin":"darwin-arm64";const k=(0,p.$8fc)(E,m,this.k);try{n.autoUpdater.setFeedURL({url:k})}catch(t){this.j.error("Failed to set update feed URL",t);return}return k}t(m){this.d(h.$DY.CheckingForUpdates(m)),n.autoUpdater.checkForUpdates()}E(){this.state.type===h.StateType.CheckingForUpdates&&this.d(h.$DY.Downloading)}F(m){this.state.type===h.StateType.Downloading&&(this.d(h.$DY.Downloaded(m)),this.z.publicLog2("update:downloaded",{version:m.version}),this.d(h.$DY.Ready(m)))}G(){this.state.type===h.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(h.$DY.Idle(h.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$0fc=y,Pe([o.$0h],y.prototype,"v",null),Pe([o.$0h],y.prototype,"w",null),Pe([o.$0h],y.prototype,"x",null),Pe([o.$0h],y.prototype,"y",null),e.$0fc=y=Pe([ne(0,a.$bfc),ne(1,I.$_i),ne(2,w.$$l),ne(3,b.$Jec),ne(4,g.$5p),ne(5,f.$_j),ne(6,d.$sk)],y)}),define(oe[297],ae([0,1,49,47,8,4,10,24,20,5,25,50]),function(x,e,n,o,P,D,A,I,b,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0,A=De(A);let g=class{get state(){return this.a}d(p){this.g.info("update#setState",p.type),this.a=p,this.b.fire(p)}constructor(p,y,$){if(this.f=p,this.g=$,this.a=d.$DY.Uninitialized,this.b=new D.$me,this.onStateChange=this.b.event,y.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(d.$DY.Idle(this.k())),this.h(30*1e3).then(void 0,m=>this.g.error(m))}h(p=60*60*1e3){return(0,P.$Gh)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(p){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===d.StateType.Idle&&this.m(p)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===d.StateType.AvailableForDownload&&await this.i(this.state)}i(p){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===d.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==d.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return d.UpdateType.Snap}l(){}async _applySpecificUpdate(p){}};g=Pe([ne(0,b.$bfc),ne(1,I.$Jec),ne(2,a.$_j)],g);let w=class extends g{constructor(p,y,$,m,E,k){super($,m,E),this.o=p,this.p=y,this.q=k;const t=(0,o.watch)(A.$oc(this.o)),r=D.Event.fromNodeEventEmitter(t,"change",(u,l)=>l),i=D.Event.filter(r,u=>u==="current"),s=D.Event.debounce(i,(u,l)=>l,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{s.dispose(),t.close()})}m(){this.d(d.$DY.CheckingForUpdates(!1)),this.u().then(p=>{p?this.d(d.$DY.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(d.$DY.Idle(d.UpdateType.Snap)))},p=>{this.g.error(p),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(d.$DY.Idle(d.UpdateType.Snap,p.message||p))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+A.$pc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const p=await new Promise(($,m)=>(0,o.realpath)(`${A.$oc(this.o)}/current`,(E,k)=>E?m(E):$(k))),y=A.$pc(p);return this.p!==y}isLatestVersion(){return this.u().then(void 0,p=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$_fc=w,e.$_fc=w=Pe([ne(2,b.$bfc),ne(3,I.$Jec),ne(4,a.$_j),ne(5,f.$$l)],w)}),define(oe[29],ae([0,1,14,3,6,52,51,77,28,18,24,10,140]),function(x,e,n,o,P,D,A,I,b,a,f,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$Uec=void 0,e.$Vec=h,e.$Wec=p,e.$Uec=(0,P.$Fi)("windowsMainService");var w;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(w||(e.OpenContext=w={}));function h($,m,E){const k=$.get(I.$Sec),t=$.get(b.$sk),r=$.get(a.$_i),i=$.get(f.$Jec),c=r.getValue("window"),s={backgroundColor:k.getBackgroundColor(),minWidth:A.$XD.WIDTH,minHeight:A.$XD.HEIGHT,title:t.nameLong,show:m.mode!==D.WindowMode.Maximized&&m.mode!==D.WindowMode.Fullscreen,x:m.x,y:m.y,width:m.width,height:m.height,webPreferences:{...E,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,A.$0D)(m.zoomLevel??c?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(o.$k?s.icon=(0,d.$lc)(i.appRoot,"resources/linux/code.png"):o.$i&&!i.isBuilt&&(s.icon=(0,d.$lc)(i.appRoot,"resources/win32/code_150x150.png")),o.$j&&(s.acceptFirstMouse=!0,c?.clickThroughInactive===!1&&(s.acceptFirstMouse=!1)),o.$j&&!(0,A.$9D)(r)&&(s.fullscreenable=!1),o.$j&&c?.nativeTabs===!0&&(s.tabbingIdentifier=t.nameShort),!(0,A.$5D)(r)&&(s.titleBarStyle="hidden",o.$j||(s.frame=!1),(0,A.$8D)(r))){const S=k.getWindowSplash()?.colorInfo.titleBarBackground??k.getBackgroundColor(),v=g.$ku.fromHex(S).isDarker()?"#FFFFFF":"#000000";s.titleBarOverlay={height:29,color:S,symbolColor:v}}return s}function p($){let m,E=Number.MIN_VALUE;for(const k of $)k.lastFocusTime>E&&(E=k.lastFocusTime,m=k);return m}var y;(function($){function m(k,t,r=n.screen.getAllDisplays()){if(k.trace(`window#validateWindowState: validating window state on ${r.length} display(s)`,t),typeof t.x!="number"||typeof t.y!="number"||typeof t.width!="number"||typeof t.height!="number"){k.trace("window#validateWindowState: unexpected type of state values");return}if(t.width<=0||t.height<=0){k.trace("window#validateWindowState: unexpected negative values");return}if(r.length===1){const s=E(r[0]);if(k.trace("window#validateWindowState: single monitor working area",s),s){let u=function(){!t||typeof t.x!="number"||typeof t.y!="number"||!s||(t.x<s.x&&(t.x=s.x),t.y<s.y&&(t.y=s.y))};u(),t.width>s.width&&(t.width=s.width),t.height>s.height&&(t.height=s.height),t.x>s.x+s.width-128&&(t.x=s.x+s.width-t.width),t.y>s.y+s.height-128&&(t.y=s.y+s.height-t.height),u()}return t}if(t.display&&t.mode===D.WindowMode.Fullscreen){const s=r.find(u=>u.id===t.display);if(s&&typeof s.bounds?.x=="number"&&typeof s.bounds?.y=="number"){k.trace("window#validateWindowState: restoring fullscreen to previous display");const u=(0,D.$Hec)(D.WindowMode.Fullscreen);return u.x=s.bounds.x,u.y=s.bounds.y,u}}let i,c;try{i=n.screen.getDisplayMatching({x:t.x,y:t.y,width:t.width,height:t.height}),c=E(i),k.trace("window#validateWindowState: multi-monitor working area",c)}catch(s){k.error("window#validateWindowState: error finding display for window state",s)}if(i&&c&&t.x+t.width>c.x&&t.y+t.height>c.y&&t.x<c.x+c.width&&t.y<c.y+c.height)return t;k.trace("window#validateWindowState: state is outside of the multi-monitor working area")}$.validateWindowState=m;function E(k){if(k.workArea.width>0&&k.workArea.height>0)return k.workArea;if(k.bounds.width>0&&k.bounds.height>0)return k.bounds}})(y||(e.WindowStateValidator=y={}))}),define(oe[298],ae([0,1,14,23,4,46,2,33,98,5,63,88,29]),function(x,e,n,o,P,D,A,I,b,a,f,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;var w;(function(p){p[p.Initial=1]="Initial",p[p.StoredCredentialsUsed=2]="StoredCredentialsUsed",p[p.LoginDialogShown=3]="LoginDialogShown"})(w||(w={}));let h=class extends A.$Wc{constructor(y,$,m,E){super(),this.g=y,this.h=$,this.j=m,this.m=E,this.a="proxy-credentials://",this.b=void 0,this.c=w.Initial,this.f=void 0,this.n()}n(){const y=P.Event.fromNodeEventEmitter(n.app,"login",($,m,E,k,t)=>({event:$,webContents:m,req:E,authInfo:k,callback:t}));this.B(y(this.r,this))}async r({event:y,authInfo:$,req:m,callback:E}){if(!$.isProxy)return;if(!this.b&&this.c===w.LoginDialogShown&&m.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}y.preventDefault();let k;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),k=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s($);try{k=await this.b}finally{this.b=void 0}}E(k?.username,k?.password)}async s(y){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const $=await this.t(y);if($)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),$;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(y){this.g.trace("auth#doResolveProxyCredentials - enter",y);const $=String((0,D.$tj)({scheme:y.scheme,host:y.host,port:y.port}));let m,E;try{const i=this.m.get(this.a+$,f.StorageScope.APPLICATION);if(i){const c=JSON.parse(await this.j.decrypt(i));m=c.username,E=c.password}}catch(i){this.g.error(i)}if(this.c!==w.StoredCredentialsUsed&&typeof m=="string"&&typeof E=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=w.StoredCredentialsUsed,{username:m,password:E};const k=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!k){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${k.id} to handle proxy login`);const t={authInfo:y,username:this.f?.username??m,password:this.f?.password??E,replyChannel:`vscode:proxyAuthResponse:${(0,I.$2g)()}`};k.sendWhenReady("vscode:openProxyAuthenticationDialog",o.CancellationToken.None,t),this.c=w.LoginDialogShown;const r=await new Promise(i=>{const c=async(s,u,l)=>{if(u===t.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${k.id}`),k.win?.webContents.off("ipc-message",c),l){const S={username:l.username,password:l.password};try{if(l.remember){const v=await this.j.encrypt(JSON.stringify(S));this.m.store(this.a+$,v,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.m.remove(this.a+$,f.StorageScope.APPLICATION)}catch(v){this.g.error(v)}i({username:S.username,password:S.password})}else i(void 0)};k.win?.webContents.on("ipc-message",c)});return this.f=r,r}};e.$lfc=h,e.$lfc=h=Pe([ne(0,a.$_j),ne(1,g.$Uec),ne(2,b.$oY),ne(3,d.$jfc)],h)}),define(oe[299],ae([0,1,93,205,121,29]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;class A extends o.$Wo{constructor(b){super(),this.f=b}call(b,a,f){return a==="openExtensionDevelopmentHostWindow"?this.g(f[0],f[1]):super.call(b,a,f)}async g(b,a){const f=(0,P.$Cm)(b,P.$Bm);f.debugRenderer=a;const d=f.extensionDevelopmentPath;if(!d)return{success:!1};const[g]=await this.f.openExtensionDevelopmentHostWindow(d,{context:D.OpenContext.API,cli:f,forceProfile:f.profile,forceTempProfile:f["profile-temp"]});if(!a)return{success:!0};const w=g.win;if(!w)return{success:!0};const h=w.webContents.debugger;let p=h.isAttached()?1/0:0;const y=(0,n.createServer)($=>{p++===0&&h.attach();let m=!1;const E=r=>{m||$.write(JSON.stringify(r)+"\0")},k=(r,i,c,s)=>E({method:i,params:c,sessionId:s});w.on("close",()=>{h.removeListener("message",k),$.end(),m=!0}),h.addListener("message",k);let t=Buffer.alloc(0);$.on("data",r=>{t=Buffer.concat([t,r]);for(let i=t.indexOf(0);i!==-1;i=t.indexOf(0)){let c;try{const s=t.slice(0,i).toString("utf8");t=t.slice(i+1),c=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}h.sendCommand(c.method,c.params,c.sessionId).then(s=>E({id:c.id,sessionId:c.sessionId,result:s})).catch(s=>E({id:c.id,sessionId:c.sessionId,error:{code:0,message:s.message}}))}}),$.on("error",r=>{console.error("error on cdp pipe:",r)}),$.on("close",()=>{m=!0,--p===0&&h.detach()})});return await new Promise($=>y.listen(0,$)),w.on("close",()=>y.close()),{rendererDebugPort:y.address().port,success:!0}}}e.$nfc=A}),define(oe[300],ae([0,1,14,22,3,7,21,18,69,6,5,133,29]),function(x,e,n,o,P,D,A,I,b,a,f,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=e.$Nfc=e.ID=void 0,e.ID="launchMainService",e.$Nfc=(0,a.$Fi)(e.ID);let w=class{constructor(p,y,$,m){this.a=p,this.b=y,this.c=$,this.d=m}async start(p,y){this.a.trace("Received data from other instance: ",p,y),P.$j&&n.app.focus({steal:!0});const $=this.e(p);if($.length){let m=Promise.resolve();if(this.b.getWindowCount()===0){const E=(0,o.$Qb)(await this.b.openEmptyWindow({context:g.OpenContext.DESKTOP}));E&&(m=E.ready())}m.then(()=>{for(const{uri:E,originalUrl:k}of $)this.c.open(E,{originalUrl:k})})}else return this.f(p,y)}e(p){return p["open-url"]&&p._urls&&p._urls.length>0?(0,o.$Jb)(p._urls.map(y=>{try{return{uri:D.URI.parse(y),originalUrl:y}}catch{return null}})):[]}async f(p,y){const $=(0,b.$Jm)(y)?g.OpenContext.CLI:g.OpenContext.DESKTOP;let m=[];const E=p.wait&&p.waitMarkerFilePath?D.URI.file(p.waitMarkerFilePath):void 0,k=p.remote||void 0,t={context:$,cli:p,userEnv:p["preserve-env"]||$===g.OpenContext.CLI?y:void 0,waitMarkerFileURI:E,remoteAuthority:k,forceProfile:p.profile,forceTempProfile:p["profile-temp"]};if(p.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(p.extensionDevelopmentPath,t);else if(!p._.length&&!p["folder-uri"]&&!p["file-uri"]){let r=!1;if(p["new-window"]||t.forceProfile||t.forceTempProfile)r=!0;else if(p["reuse-window"])r=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":r=!0;break;case"off":r=!1;break;default:r=!P.$j}if(r)m=await this.b.open({...t,forceNewWindow:!0,forceEmpty:!0});else{const i=this.b.getLastActiveWindow();i?(this.b.openExistingWindow(i,t),m=[i]):m=await this.b.open({...t,forceEmpty:!0})}}else m=await this.b.open({...t,forceNewWindow:p["new-window"],preferNewWindow:!p["reuse-window"]&&!p.wait,forceReuseWindow:p["reuse-window"],diffMode:p.diff,mergeMode:p.merge,addMode:p.add,noRecentEntry:!!p["skip-add-to-recently-opened"],gotoLineMode:p.goto});if(E&&m.length===1&&m[0])return Promise.race([m[0].whenClosedOrLoaded,(0,A.whenDeleted)(E.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Ofc=w,e.$Ofc=w=Pe([ne(0,f.$_j),ne(1,g.$Uec),ne(2,d.$uY),ne(3,I.$_i)],w)}),define(oe[301],ae([0,1,2,20,52,59,30,8,29]),function(x,e,n,o,P,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;let a=class extends n.$Wc{constructor(d,g,w){super(),this.a=g,this.b=w,this.B(d.onWillLoadWindow(h=>{h.reason===P.LoadReason.LOAD&&this.c(h.window)})),this.B(d.onBeforeCloseWindow(h=>this.c(h))),this.B(new I.$Rh(()=>this.g(),30*1e3)).schedule()}async c(d){const g=this.f(d),w=this.a.getProfileForWorkspace(g);w?.isTransient&&(this.a.unsetWorkspace(g,w.isTransient),w.isTransient&&await this.a.cleanUpTransientProfiles())}f(d){return d.openedWorkspace??(0,A.$Ti)(d.backupPath,d.isExtensionDevelopmentHost)}g(){const d=this.a.getAssociatedEmptyWindows();if(d.length===0)return;const g=this.b.getWindows().map(w=>this.f(w));for(const w of d)g.some(h=>h.id===w.id)||this.a.unsetWorkspace(w,!1)}};e.$rgc=a,e.$rgc=a=Pe([ne(0,o.$bfc),ne(1,D.$Xec),ne(2,b.$Uec)],a)});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[64],ae([0,1,14,2,4,5,321,8,12,29,81,25,20,82,36,3,107]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=e.$ofc=void 0,f=et(f);function m(t){return typeof t.responseWindowId=="number"}let E=class extends o.$Wc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(r,i,c){super(),this.w=r,this.y=i,this.z=c,this.c=String(++$.a),this.f=this.B(new P.$me),this.onStdout=this.f.event,this.g=this.B(new P.$me),this.onStderr=this.g.event,this.h=this.B(new P.$me),this.onMessage=this.h.event,this.j=this.B(new P.$me),this.onSpawn=this.j.event,this.m=this.B(new P.$me),this.onExit=this.m.event,this.n=this.B(new P.$me),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(r,i){let c;switch(this.t?.correlationId?c=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${r}`:c=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${r}`,i){case f.default.Error:this.w.error(c);break;case f.default.Warning:this.w.warn(c);break;case f.default.Info:this.w.trace(c);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",f.default.Error),!1):!0}start(r){const i=this.F(r);return i&&r.payload&&this.postMessage(r.payload)&&this.C("payload sent via postMessage()",f.default.Info),i}F(r){if(!this.D())return!1;this.t=r;const i=`${this.t.type}-${this.c}`,c=b.$Zg.asFileUri("bootstrap-fork.js").fsPath,s=this.t.args??[],u=this.t.execArgv??[],l=this.t.allowLoadingUnsignedLibraries,S=this.t.forceAllocationsToV8Sandbox,v="pipe",R=this.G(r);return this.C("creating new...",f.default.Info),this.r=n.utilityProcess.fork(c,s,{serviceName:i,env:R,execArgv:u,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:S,stdio:v}),this.H(this.r,this.t,i),!0}G(r){const i=r.env?{...r.env}:{...(0,h.$do)(process.env)};i.VSCODE_AMD_ENTRYPOINT=r.entryPoint,typeof r.parentLifecycleBound=="number"&&(i.VSCODE_PARENT_PID=String(r.parentLifecycleBound)),i.VSCODE_CRASH_REPORTER_PROCESS_TYPE=r.type,p.$i&&((0,y.isUNCAccessRestrictionsDisabled)()?i.NODE_DISABLE_UNC_ACCESS_CHECKS="1":i.NODE_UNC_HOST_ALLOWLIST=(0,y.getUNCHostAllowlist)().join("\\")),(0,w.$lm)(i);for(const c of Object.keys(i))i[c]=String(i[c]);return i}H(r,i,c){if(r.stdout){const s=new A.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(r.stdout,"data")(u=>this.f.fire(typeof u=="string"?u:s.write(u))))}if(r.stderr){const s=new A.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(r.stderr,"data")(u=>this.g.fire(typeof u=="string"?u:s.write(u))))}this.B(P.Event.fromNodeEventEmitter(r,"message")(s=>this.h.fire(s))),this.B(P.Event.fromNodeEventEmitter(r,"spawn")(()=>{this.s=r.pid,typeof r.pid=="number"&&$.b.set(r.pid,{pid:r.pid,name:m(i)?`${i.type} [${i.responseWindowId}]`:i.type}),this.C("successfully created",f.default.Info),this.j.fire(r.pid)})),this.B(P.Event.fromNodeEventEmitter(r,"exit")(s=>{const u=this.I(s)?0:s;this.C(`received exit event with code ${u}`,f.default.Info),this.m.fire({pid:this.s,code:u,signal:"unknown"}),this.J()})),this.B(P.Event.fromNodeEventEmitter(n.app,"child-process-gone",(s,u)=>({event:s,details:u}))(({details:s})=>{s.type==="Utility"&&s.name===c&&!this.I(s.exitCode)&&(this.C(`crashed with code ${s.exitCode} and reason '${s.reason}'`,f.default.Error),this.y.publicLog2("utilityprocesscrash",{type:i.type,reason:s.reason,code:s.exitCode}),this.n.fire({pid:this.s,code:s.exitCode,reason:s.reason}),this.J())}))}once(r,i){const c=this.B(this.h.event(s=>{s===r&&(c.dispose(),i())}))}postMessage(r,i){return this.r?(this.r.postMessage(r,i),!0):!1}connect(r){const{port1:i,port2:c}=new n.MessageChannelMain;return this.postMessage(r,[c]),i}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",f.default.Info);const r=process;return typeof r._debugProcess=="function"?(r._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",f.default.Info),this.r.kill()?(this.C("successfully killed the process",f.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",f.default.Warning)}I(r){return r===0?!0:this.u&&r===15}J(){typeof this.s=="number"&&$.b.delete(this.s),this.r=void 0}async waitForExit(r){this.r&&(this.C("waiting to exit...",f.default.Info),await Promise.race([P.Event.toPromise(this.onExit),(0,I.$Gh)(r)]),this.r&&(this.C(`did not exit within ${r}ms, will kill it now...`,f.default.Info),this.kill()))}};e.$ofc=E,e.$ofc=E=$=Pe([ne(0,D.$_j),ne(1,d.$$l),ne(2,g.$bfc)],E);let k=class extends E{constructor(r,i,c,s){super(r,c,s),this.L=i}start(r){const i=this.L.getWindowById(r.responseWindowId);if(!i?.win||i.win.isDestroyed()||i.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",f.default.Error),!0;if(!super.F(r))return!1;this.M(i.win,r);const s=this.connect(r.payload);return i.win.webContents.postMessage(r.responseChannel,r.responseNonce,[s]),!0}M(r,i){i.windowLifecycleBound&&(this.B(P.Event.filter(this.z.onWillLoadWindow,c=>c.window.win===r)(()=>this.kill())),this.B(P.Event.fromNodeEventEmitter(r,"closed")(()=>this.kill())))}};e.$pfc=k,e.$pfc=k=Pe([ne(0,D.$_j),ne(1,a.$Uec),ne(2,d.$$l),ne(3,g.$bfc)],k)}),define(oe[302],ae([0,1,8,16,4,2,20,5,25,64,29]),function(x,e,n,o,P,D,A,I,b,a,f){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0;let g=class extends D.$Wc{static{d=this}static{this.a=0}constructor(h,p,y,$){super(),this.f=h,this.g=p,this.h=y,this.j=$,this.b=new Map,this.c=!1,this.B(this.g.onWillShutdown(m=>{this.c=!0,m.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}m(h){const p=this.b.get(h);if(!p)throw new Error("Unknown extension host!");return p}onDynamicStdout(h){return this.m(h).onStdout}onDynamicStderr(h){return this.m(h).onStderr}onDynamicMessage(h){return this.m(h).onMessage}onDynamicExit(h){return this.m(h).onExit}async createExtensionHost(){if(this.c)throw(0,o.$8)();const h=String(++d.a),p=new a.$pfc(this.f,this.h,this.j,this.g);this.b.set(h,p);const y=p.onExit(({pid:$,code:m,signal:E})=>{y.dispose(),this.f.info(`Extension host with pid ${$} exited with code: ${m}, signal: ${E}.`),setTimeout(()=>{p.dispose(),this.b.delete(h)}),setTimeout(()=>{try{process.kill($,0),this.f.error(`Extension host with pid ${$} still exists, forcefully killing it...`),process.kill($)}catch{}},1e3)});return{id:h}}async start(h,p){if(this.c)throw(0,o.$8)();const y=this.m(h);return y.start({...p,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:p.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:h}),{pid:await P.Event.toPromise(y.onSpawn)}}async enableInspectPort(h){if(this.c)throw(0,o.$8)();const p=this.b.get(h);return p?p.enableInspectPort():!1}async kill(h){if(this.c)throw(0,o.$8)();const p=this.b.get(h);p&&p.kill()}async _killAllNow(){for(const[,h]of this.b)h.kill()}async _waitForAllExit(h){const p=[];for(const[,y]of this.b)p.push(y.waitForExit(h));return n.Promises.settled(p).then(()=>{})}};e.$wfc=g,e.$wfc=g=d=Pe([ne(0,I.$_j),ne(1,A.$bfc),ne(2,f.$Uec),ne(3,b.$$l)],g)}),define(oe[303],ae([0,1,35,8,2,24,20,5,42,40,72,64,58,96,13,254,4]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=void 0;let $=class extends P.$Wc{constructor(E,k,t,r,i,c,s,u,l){super(),this.g=E,this.h=k,this.j=t,this.m=r,this.n=i,this.r=c,this.s=s,this.t=u,this.u=l,this.a=new o.$Eh,this.b=void 0,this.c=void 0,this.f=this.B(new y.$me),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){n.$FX.on(p.$Zfc.request,(E,k)=>this.y(E,k,p.$Zfc.response)),n.$FX.on(p.$1fc.request,(E,k)=>this.y(E,k,p.$1fc.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(E,k,t){this.s.trace(`[SharedProcess] onWindowConnection for: ${t}`),this.a.isOpen()||this.a.open(),await this.whenReady();const r=await this.connect(t);if(E.sender.isDestroyed())return r.close();E.sender.postMessage(t,k,[r])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(p.$Yfc.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const E=new o.$3h;this.b?.once(p.$Yfc.initDone,()=>E.complete()),await E.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const E=new o.$3h;this.b?.once(p.$Yfc.ipcReady,()=>E.complete()),await E.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new d.$ofc(this.s,g.$wp,this.r)),this.c=this.b.onMessage(t=>{typeof t.warning=="string"?this.s.warn(t.warning):typeof t.error=="string"&&this.s.error(t.error)});const E=(0,w.$0m)(this.m.args,this.m.isBuilt);let k;E.port&&(k=["--nolazy"],E.break?k.push(`--inspect-brk=${E.port}`):k.push(`--inspect=${E.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:k}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(E){return await this.F,(0,h.$qg)(this.b).connect(E)}};e.$2fc=$,e.$2fc=$=Pe([ne(3,D.$Jec),ne(4,b.$Ll),ne(5,A.$bfc),ne(6,I.$_j),ne(7,f.$9ec),ne(8,a.$so)],$)}),define(oe[304],ae([0,1,24,96,20,5,58,76,64,119,35,2,4,36,18,12]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;let y=class extends d.$Wc{constructor(m,E,k,t,r){super(),this.f=m,this.g=E,this.h=k,this.j=t,this.m=r,this.a=void 0,this.b=new g.$me,this.onRequestConnection=this.b.event,this.c=new g.$me,this.onWillShutdown=this.c.event,this.B(this.j.onWillShutdown(()=>this.c.fire())),f.$FX.on("vscode:createPtyHostMessageChannel",(i,c)=>this.r(i,c)),this.B((0,d.$Uc)(()=>{f.$FX.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new b.$ofc(this.m,A.$wp,this.j);const m=(0,o.$9m)(this.h.args,this.h.isBuilt),E=m.port?["--nolazy",`--inspect${m.break?"-brk":""}=${m.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:E,args:["--logsPath",this.h.logsHome.with({scheme:p.Schemas.file}).fsPath],env:this.n()});const k=this.a.connect(),t=new a.$NX(k,"ptyHost"),r=new d.$Vc;return r.add(t),r.add((0,d.$Uc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:t,store:r,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const m={...(0,w.$do)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},E=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostLatency);E&&typeof E=="number"&&(m.VSCODE_LATENCY=String(E));const k=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostStartupDelay);return k&&typeof k=="number"&&(m.VSCODE_STARTUP_DELAY=String(k)),this.h.restoreSnapExportedVariables(),m}r(m,E){this.b.fire();const k=this.a.connect();if(m.sender.isDestroyed()){k.close();return}m.sender.postMessage("vscode:createPtyHostMessageChannelResult",E,[k])}};e.$Dgc=y,e.$Dgc=y=Pe([ne(1,h.$_i),ne(2,n.$Jec),ne(3,P.$bfc),ne(4,D.$_j)],y)}),define(oe[305],ae([0,1,2,6,5,29,64,25,46,4,8,20]),function(x,e,n,o,P,D,A,I,b,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=e.$Bgc=void 0,e.$Bgc=(0,o.$Fi)("utilityProcessWorker");let g=class extends n.$Wc{constructor(p,y,$,m){super(),this.b=p,this.c=y,this.f=$,this.g=m,this.a=new Map}async createWorker(p){const y=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${y})`);const $=this.h(p);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${y})`),this.disposeWorker(p));const m=new w(this.b,this.c,this.f,this.g,p);if(!m.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,m);const E=new f.$3h;return a.Event.once(m.onDidTerminate)(k=>{k.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${k.code}, signal: ${k.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${k.code}, signal: ${k.signal}`),this.a.delete($),E.complete({reason:k})}),E.p}h(p){return(0,b.$tj)({moduleId:p.process.moduleId,windowId:p.reply.windowId})}async disposeWorker(p){const y=this.h(p),$=this.a.get(y);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),$.kill(),$.dispose(),this.a.delete(y))}};e.$Cgc=g,e.$Cgc=g=Pe([ne(0,P.$_j),ne(1,D.$Uec),ne(2,I.$$l),ne(3,d.$bfc)],g);let w=class extends n.$Wc{constructor(p,y,$,m,E){super(),this.c=p,this.f=y,this.g=$,this.h=m,this.j=E,this.a=this.B(new a.$me),this.onDidTerminate=this.a.event,this.b=this.B(new A.$pfc(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(p=>this.a.fire({code:p.code,signal:p.signal}))),this.B(this.b.onCrash(p=>this.a.fire({code:p.code,signal:"ECRASH"})))}spawn(){const y=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:y,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};w=Pe([ne(0,P.$_j),ne(1,D.$Uec),ne(2,I.$$l),ne(3,d.$bfc)],w)}),define(oe[306],ae([0,1,14,4,2,279,29]),function(x,e,n,o,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;let I=class extends P.$Wc{constructor(a){super(),this.b=a,this.a=this.B(new o.$me),this.onFoundInFrame=this.a.event,this.B(new D.$ggc)}async setIgnoreMenuShortcuts(a,f){let d;if(typeof a.windowId=="number"){const{windowId:g}=a,w=this.b.getWindowById(g);if(!w?.win)throw new Error(`Invalid windowId: ${g}`);d=w.win.webContents}else{const{webContentsId:g}=a;if(d=n.webContents.fromId(g),!d)throw new Error(`Invalid webContentsId: ${g}`)}d.isDestroyed()||d.setIgnoreMenuShortcuts(f)}async findInFrame(a,f,d,g){const h=this.c(a,f);if(typeof h.findInFrame=="function"){h.findInFrame(d,{findNext:g.findNext,forward:g.forward});const p=(y,$)=>{$.finalUpdate&&(this.a.fire($),h.removeListener("found-in-frame",p))};h.on("found-in-frame",p)}}async stopFindInFrame(a,f,d){const w=this.c(a,f);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(d.keepSelection?"keepSelection":"clearSelection")}c(a,f){const d=this.b.getWindowById(a.windowId);if(!d?.win)throw new Error(`Invalid windowId: ${a}`);const g=d.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===f);if(!g)throw new Error(`Unknown frame: ${f}`);return g}};e.$hgc=I,e.$hgc=I=Pe([ne(0,A.$Uec)],I)}),define(oe[307],ae([0,1,14,2,3,19,7,18,20,5,34,29,52,30]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0,e.$jgc=y,e.$kgc=m;let p=class extends o.$Wc{static{h=this}static{this.a="windowsState"}get state(){return this.b}constructor(t,r,i,c,s){super(),this.g=t,this.h=r,this.j=i,this.m=c,this.n=s,this.b=y(this.h.getItem(h.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.B(this.j.onBeforeCloseWindow(t=>this.u(t))),this.B(this.j.onBeforeShutdown(()=>this.s())),this.B(this.g.onDidChangeWindowsCount(t=>{t.newCount-t.oldCount>0&&(this.c=void 0)})),this.B(this.g.onDidDestroyWindow(t=>this.u(t)))}s(){this.f=!0,this.t()}t(){const t=new Set,r={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!r.lastActiveWindow){let s=this.g.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.g.getWindows().find(u=>!u.isExtensionDevelopmentHost)),s&&(r.lastActiveWindow=this.w(s),r.lastActiveWindow.uiState.mode===g.WindowMode.Fullscreen&&t.add(r.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);i&&(r.lastPluginDevelopmentHostWindow=this.w(i),r.lastPluginDevelopmentHostWindow.uiState.mode===g.WindowMode.Fullscreen&&(t.has(r.lastPluginDevelopmentHostWindow.uiState.display)?P.$j&&!i.win?.isSimpleFullScreen()&&(r.lastPluginDevelopmentHostWindow.uiState.mode=g.WindowMode.Normal):t.add(r.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(r.openedWindows=this.g.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>{const u=this.w(s);return u.uiState.mode===g.WindowMode.Fullscreen&&(t.has(u.uiState.display)?P.$j&&u.windowId!==r.lastActiveWindow?.windowId&&!s.win?.isSimpleFullScreen()&&(u.uiState.mode=g.WindowMode.Normal):t.add(u.uiState.display)),u}));const c=m(r);this.h.setItem(h.a,c),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",c)}u(t){if(this.j.quitRequested)return;const r=this.w(t);t.isExtensionDevelopmentHost&&!t.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=r:!t.isExtensionDevelopmentHost&&t.openedWorkspace&&this.b.openedWindows.forEach(i=>{const c=(0,w.$Ui)(t.openedWorkspace)&&i.workspace?.id===t.openedWorkspace.id,s=(0,w.$Pi)(t.openedWorkspace)&&i.folderUri&&D.$0g.isEqual(i.folderUri,t.openedWorkspace.uri);(c||s)&&(i.uiState=r.uiState)}),this.g.getWindowCount()===1&&(this.c=r)}w(t){return{windowId:t.id,workspace:(0,w.$Ui)(t.openedWorkspace)?t.openedWorkspace:void 0,folderUri:(0,w.$Pi)(t.openedWorkspace)?t.openedWorkspace.uri:void 0,backupPath:t.backupPath,remoteAuthority:t.remoteAuthority,uiState:t.serializeWindowState()}}getNewWindowState(t){const r=this.z(t),i=this.n.getValue("window");if(r.mode===g.WindowMode.Fullscreen){let c;r.hasDefaultState?c=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):c=!!(this.j.wasRestarted||i?.restoreFullscreen),c||(r.mode=g.WindowMode.Normal)}return r}z(t){const r=this.g.getLastActiveWindow();if(!t.extensionTestsPath){if(t.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const S=t.workspace;if((0,w.$Ui)(S)){const R=this.state.openedWindows.filter(T=>T.workspace&&T.workspace.id===S.id).map(T=>T.uiState);if(R.length)return R[0]}if((0,w.$Pi)(S)){const R=this.state.openedWindows.filter(T=>T.folderUri&&D.$0g.isEqual(T.folderUri,S.uri)).map(T=>T.uiState);if(R.length)return R[0]}else if(t.backupPath){const R=this.state.openedWindows.filter(T=>T.backupPath===t.backupPath).map(T=>T.uiState);if(R.length)return R[0]}const v=this.c||this.state.lastActiveWindow;if(!r&&v)return v.uiState}let i;const c=n.screen.getAllDisplays();if(c.length===1)i=c[0];else{if(P.$j){const S=n.screen.getCursorScreenPoint();i=n.screen.getDisplayNearestPoint(S)}!i&&r&&(i=n.screen.getDisplayMatching(r.getBounds())),i||(i=n.screen.getPrimaryDisplay()||c[0])}let s=(0,g.$Hec)();s.x=Math.round(i.bounds.x+i.bounds.width/2-s.width/2),s.y=Math.round(i.bounds.y+i.bounds.height/2-s.height/2);const u=this.n.getValue("window");let l=!0;if(u?.newWindowDimensions){if(u.newWindowDimensions==="maximized")s.mode=g.WindowMode.Maximized,l=!1;else if(u.newWindowDimensions==="fullscreen")s.mode=g.WindowMode.Fullscreen,l=!1;else if((u.newWindowDimensions==="inherit"||u.newWindowDimensions==="offset")&&r){const S=r.serializeWindowState();S.mode===g.WindowMode.Fullscreen?s.mode=g.WindowMode.Fullscreen:s={...S,zoomLevel:void 0},l=s.mode!==g.WindowMode.Fullscreen&&u.newWindowDimensions==="offset"}}return l&&(s=this.C(s)),s.hasDefaultState=!0,s}C(t){if(this.g.getWindows().length===0)return t;t.x=typeof t.x=="number"?t.x:0,t.y=typeof t.y=="number"?t.y:0;const r=this.g.getWindows().map(i=>i.getBounds());for(;r.some(i=>i.x===t.x||i.y===t.y);)t.x+=30,t.y+=30;return t}};e.$igc=p,e.$igc=p=h=Pe([ne(0,d.$Uec),ne(1,f.$gR),ne(2,b.$bfc),ne(3,a.$_j),ne(4,I.$_i)],p);function y(k){const t={openedWindows:[]},r=k||{openedWindows:[]};return r.lastActiveWindow&&(t.lastActiveWindow=$(r.lastActiveWindow)),r.lastPluginDevelopmentHostWindow&&(t.lastPluginDevelopmentHostWindow=$(r.lastPluginDevelopmentHostWindow)),Array.isArray(r.openedWindows)&&(t.openedWindows=r.openedWindows.map(i=>$(i))),t}function $(k){const t={uiState:k.uiState};return k.backupPath&&(t.backupPath=k.backupPath),k.remoteAuthority&&(t.remoteAuthority=k.remoteAuthority),k.folder&&(t.folderUri=A.URI.parse(k.folder)),k.workspaceIdentifier&&(t.workspace={id:k.workspaceIdentifier.id,configPath:A.URI.parse(k.workspaceIdentifier.configURIPath)}),t}function m(k){return{lastActiveWindow:k.lastActiveWindow&&E(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&E(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(t=>E(t))}}function E(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(oe[60],ae([0,1,14,4,43,2,12,10,19,21,201,70,53,24,6,5,59,135,30,103,104]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=e.$7ec=void 0,e.$7ec=(0,h.$Fi)("workspacesManagementMainService");let t=class extends D.$Wc{constructor(i,c,s,u,l){super(),this.g=i,this.h=c,this.j=s,this.m=u,this.n=l,this.a=this.B(new o.$me),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new o.$me),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const i=(await a.Promises.readdir(this.c.with({scheme:A.Schemas.file}).fsPath)).map(c=>(0,b.$gh)(this.c,c,m.$5i));for(const c of i){const s=(0,k.$4ec)(c),u=await this.resolveLocalWorkspace(c);u?this.f.push({workspace:s,remoteAuthority:u.remoteAuthority}):await this.deleteUntitledWorkspace(s)}}catch(i){i.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${i}).`)}}resolveLocalWorkspace(i){return this.r(i,c=>a.Promises.readFile(c,"utf8"))}r(i,c){if(this.s(i)&&i.scheme===A.Schemas.file)try{const s=c(i.fsPath);return s instanceof Promise?s.then(u=>this.t(i,u),u=>{}):this.t(i,s)}catch{return}}s(i){return(0,m.$6i)(i,this.g)||(0,m.$$i)(i)}t(i,c){try{const s=this.u(i,c),u=(0,k.$4ec)(i);return{id:u.id,configPath:u.configPath,folders:(0,E.$4hb)(s.folders,u.configPath,b.$0g),remoteAuthority:s.remoteAuthority,transient:s.transient}}catch(s){this.h.warn(s.toString())}}u(i,c){const s=(0,P.$Xn)(c);if(s&&Array.isArray(s.folders))s.folders=s.folders.filter(u=>(0,E.$2hb)(u));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return s}async createUntitledWorkspace(i,c){const{workspace:s,storedWorkspace:u}=this.w(i,c),l=s.configPath.fsPath;return await a.Promises.mkdir((0,I.$oc)(l),{recursive:!0}),await a.Promises.writeFile(l,JSON.stringify(u,null,"	")),this.f.push({workspace:s,remoteAuthority:c}),s}w(i=[],c){const s=(Date.now()+Math.round(Math.random()*1e3)).toString(),u=(0,b.$gh)(this.c,s),l=(0,b.$gh)(u,m.$5i),S=[];for(const v of i)S.push((0,E.$3hb)(v.uri,!0,v.name,u,b.$0g));return{workspace:(0,k.$4ec)(l),storedWorkspace:{folders:S,remoteAuthority:c}}}async getWorkspaceIdentifier(i){return(0,k.$4ec)(i)}isUntitledWorkspace(i){return(0,m.$6i)(i.configPath,this.g)}async deleteUntitledWorkspace(i){this.isUntitledWorkspace(i)&&(await this.y(i),this.j.isEnabled()&&this.j.unsetWorkspace(i),this.a.fire(i))}async y(i){const c=(0,b.$7g)(i.configPath);try{await a.Promises.rm((0,I.$oc)(c));const s=(0,I.$lc)(this.g.workspaceStorageHome.with({scheme:A.Schemas.file}).fsPath,i.id);await a.Promises.exists(s)&&await a.Promises.writeFile((0,I.$lc)(s,"obsolete"),""),this.f=this.f.filter(u=>u.workspace.id!==i.id)}catch(s){this.h.warn(`Unable to delete untitled workspace ${c} (${s}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(i,c,s){if(!i||!i.win||!i.isReady||!await this.z(i,c,s))return;const l=await this.C(i,(0,k.$4ec)(s));if(l)return this.b.fire({window:i,workspace:l.workspace}),l}async z(i,c,s){return s?(0,m.$Ui)(i.openedWorkspace)&&b.$0g.isEqual(i.openedWorkspace.configPath,s)?!1:(0,$.$1ec)(c,s)?(await this.n.showMessageBox({type:"info",buttons:[(0,f.localize)(0,null)],message:(0,f.localize)(1,null,(0,b.$dh)(s)),detail:(0,f.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(i,c){if(!i.config)return;i.focus();let s;return i.config.extensionDevelopmentPath||(i.config.backupPath?s=await this.m.registerWorkspaceBackup({workspace:c,remoteAuthority:i.remoteAuthority},i.config.backupPath):s=this.m.registerWorkspaceBackup({workspace:c,remoteAuthority:i.remoteAuthority})),(0,m.$Ui)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=c,i.config.backupPath=s,{workspace:c,backupPath:s}}};e.$8ec=t,e.$8ec=t=Pe([ne(0,w.$Jec),ne(1,p.$_j),ne(2,y.$Xec),ne(3,d.$Oec),ne(4,g.$Pec)],t)}),define(oe[136],ae([0,1,14,35,23,6,29,30,60,13,5,64]),function(x,e,n,o,P,D,A,I,b,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=e.$rfc=e.ID=void 0,e.ID="diagnosticsMainService",e.$rfc=(0,D.$Fi)(e.ID);let g=class{constructor(h,p,y){this.a=h,this.b=p,this.c=y}async getRemoteDiagnostics(h){const p=this.a.getWindows();return(await Promise.all(p.map(async $=>{const m=$.remoteAuthority;if(!m)return;const E=`vscode:getDiagnosticInfoResponse${$.id}`,k={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(t=>{$.sendWhenReady("vscode:getDiagnosticInfo",P.CancellationToken.None,{replyChannel:E,args:k}),o.$FX.once(E,(r,i)=>{i||t({hostName:m,errorMessage:`Unable to resolve connection to '${m}'.`}),t(i)}),setTimeout(()=>{t({hostName:m,errorMessage:`Connection to '${m}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const h=[];for(const y of n.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(y.id);$?h.push(await this.d($)):h.push(this.e(y))}const p=[];for(const{pid:y,name:$}of d.$ofc.getAll())p.push({pid:y,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,pidToNames:p,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(h){const p=await this.f(h),y=(0,a.$qg)(h.win);return this.e(y,p,h.remoteAuthority)}e(h,p=[],y){return{id:h.id,pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:p,remoteAuthority:y}}async f(h){const p=[],y=h.openedWorkspace;if((0,I.$Pi)(y))p.push(y.uri);else if((0,I.$Ui)(y)){const $=await this.b.resolveLocalWorkspace(y.configPath);$&&$.folders.forEach(E=>{p.push(E.uri)})}return p}};e.$sfc=g,e.$sfc=g=Pe([ne(0,A.$Uec),ne(1,b.$7ec),ne(2,f.$_j)],g)}),define(oe[65],ae([0,1,49,14,27,161,54,4,2,12,10,3,7,114,94,21,112,189,53,24,6,20,5,28,77,29,30,60,17,250,240,85,16]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m,E,k,t,r,i,c,s,u,l,S,v,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=void 0,e.$Gfc=(0,k.$Fi)("nativeHostMainService");let O=class extends b.$Wc{constructor(B,C,z,re,Q,le,K,ee,q){super(),this.a=B,this.b=C,this.c=z,this.f=re,this.g=Q,this.h=le,this.j=K,this.m=ee,this.n=q,this.onDidOpenMainWindow=I.Event.map(this.a.onDidOpenWindow,j=>j.id),this.onDidTriggerWindowSystemContextMenu=I.Event.any(I.Event.map(this.a.onDidTriggerSystemContextMenu,({window:j,x:U,y:V})=>({windowId:j.id,x:U,y:V})),I.Event.map(this.b.onDidTriggerSystemContextMenu,({window:j,x:U,y:V})=>({windowId:j.id,x:U,y:V}))),this.onDidMaximizeWindow=I.Event.any(I.Event.map(this.a.onDidMaximizeWindow,j=>j.id),I.Event.map(this.b.onDidMaximizeWindow,j=>j.id)),this.onDidUnmaximizeWindow=I.Event.any(I.Event.map(this.a.onDidUnmaximizeWindow,j=>j.id),I.Event.map(this.b.onDidUnmaximizeWindow,j=>j.id)),this.onDidChangeWindowFullScreen=I.Event.any(I.Event.map(this.a.onDidChangeFullScreen,j=>({windowId:j.window.id,fullscreen:j.fullscreen})),I.Event.map(this.b.onDidChangeFullScreen,j=>({windowId:j.window.id,fullscreen:j.fullscreen}))),this.onDidBlurMainWindow=I.Event.filter(I.Event.fromNodeEventEmitter(o.app,"browser-window-blur",(j,U)=>U.id),j=>!!this.a.getWindowById(j)),this.onDidFocusMainWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),j=>!!j),j=>j.id),I.Event.filter(I.Event.fromNodeEventEmitter(o.app,"browser-window-focus",(j,U)=>U.id),j=>!!this.a.getWindowById(j))),this.onDidBlurMainOrAuxiliaryWindow=I.Event.any(this.onDidBlurMainWindow,I.Event.map(I.Event.filter(I.Event.fromNodeEventEmitter(o.app,"browser-window-blur",(j,U)=>this.b.getWindowByWebContents(U.webContents)),j=>!!j),j=>j.id)),this.onDidFocusMainOrAuxiliaryWindow=I.Event.any(this.onDidFocusMainWindow,I.Event.map(I.Event.filter(I.Event.fromNodeEventEmitter(o.app,"browser-window-focus",(j,U)=>this.b.getWindowByWebContents(U.webContents)),j=>!!j),j=>j.id)),this.onDidResumeOS=I.Event.fromNodeEventEmitter(o.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new I.$me),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(o.screen,"display-metrics-changed",(j,U,V)=>V),j=>!(Array.isArray(j)&&j.length===1&&j[0]==="workArea")),I.Event.fromNodeEventEmitter(o.screen,"display-added"),I.Event.fromNodeEventEmitter(o.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(B,C){const z=this.a.getWindows().map(Q=>({id:Q.id,workspace:Q.openedWorkspace??(0,u.$Ti)(Q.backupPath,Q.isExtensionDevelopmentHost),title:Q.win?.getTitle()??"",filename:Q.getRepresentedFilename(),dirty:Q.isDocumentEdited()})),re=[];return C.includeAuxiliaryWindows&&re.push(...this.b.getWindows().map(Q=>({id:Q.id,parentId:Q.parentId,title:Q.win?.getTitle()??"",filename:Q.getRepresentedFilename()}))),[...z,...re]}async getWindowCount(B){return this.a.getWindowCount()}async getActiveWindowId(B){const C=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(C)return C.id}openWindow(B,C,z){return Array.isArray(C)?this.s(B,C,z):this.t(B,C)}async s(B,C,z=Object.create(null)){C.length>0&&await this.a.open({context:s.OpenContext.API,contextWindowId:B,urisToOpen:C,cli:this.g.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,mergeMode:z.mergeMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0,forceProfile:z.forceProfile,forceTempProfile:z.forceTempProfile})}async t(B,C){await this.a.openEmptyWindow({context:s.OpenContext.API,contextWindowId:B},C)}async isFullScreen(B,C){return this.C(C?.targetWindowId,B)?.isFullScreen??!1}async toggleFullScreen(B,C){this.C(C?.targetWindowId,B)?.toggleFullScreen()}async handleTitleDoubleClick(B,C){this.C(C?.targetWindowId,B)?.handleTitleDoubleClick()}async getCursorScreenPoint(B){const C=o.screen.getCursorScreenPoint(),z=o.screen.getDisplayNearestPoint(C);return{point:C,display:z.bounds}}async isMaximized(B,C){return this.C(C?.targetWindowId,B)?.win?.isMaximized()??!1}async maximizeWindow(B,C){this.C(C?.targetWindowId,B)?.win?.maximize()}async unmaximizeWindow(B,C){this.C(C?.targetWindowId,B)?.win?.unmaximize()}async minimizeWindow(B,C){this.C(C?.targetWindowId,B)?.win?.minimize()}async moveWindowTop(B,C){this.C(C?.targetWindowId,B)?.win?.moveTop()}async positionWindow(B,C,z){const re=this.C(z?.targetWindowId,B);if(re?.win){if(re.win.isFullScreen()){const Q=I.Event.toPromise(I.Event.once(I.Event.fromNodeEventEmitter(re.win,"leave-full-screen")));re.win.setFullScreen(!1),await Q}re.win.setBounds(C)}}async updateWindowControls(B,C){this.C(C?.targetWindowId,B)?.updateWindowControls(C)}async focusWindow(B,C){this.C(C?.targetWindowId,B)?.focus({force:C?.force??!1})}async setMinimumSize(B,C,z){const re=this.D(B);if(re?.win){const[Q,le]=re.win.getSize(),[K,ee]=re.win.getMinimumSize(),[q,j]=[C??K,z??ee],[U,V]=[Math.max(Q,q),Math.max(le,j)];(K!==q||ee!==j)&&re.win.setMinimumSize(q,j),(Q!==U||le!==V)&&re.win.setSize(U,V)}}async saveWindowSplash(B,C){this.m.saveWindowSplash(B,C)}async installShellCommand(B){const{source:C,target:z}=await this.u();try{const{symbolicLink:re}=await p.SymlinkSupport.stat(C);if(re&&!re.dangling){const Q=await(0,w.$kr)(C);if(z===Q)return}await p.Promises.unlink(C)}catch(re){if(re.code!=="ENOENT")throw re}try{await p.Promises.symlink(z,C)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:Q}=await this.showMessageBox(B,{type:"info",message:(0,$.localize)(0,null,this.j.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(Q===1)throw new L.$7;try{const le=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${C}'\\" with administrator privileges"`;await(0,D.promisify)(n.exec)(le)}catch{throw new Error((0,$.localize)(3,null,C))}}}async uninstallShellCommand(B){const{source:C}=await this.u();try{await p.Promises.unlink(C)}catch(z){switch(z.code){case"EACCES":{const{response:re}=await this.showMessageBox(B,{type:"info",message:(0,$.localize)(4,null,this.j.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(re===1)throw new L.$7;try{const Q=`osascript -e "do shell script \\"rm '${C}'\\" with administrator privileges"`;await(0,D.promisify)(n.exec)(Q)}catch{throw new Error((0,$.localize)(7,null,C))}break}case"ENOENT":break;default:throw z}}}async u(){const B=(0,f.$mc)(this.g.appRoot,"bin","code"),C=`/usr/local/bin/${this.j.applicationName}`;if(!await p.Promises.exists(B))throw new Error((0,$.localize)(8,null,B));return{source:C,target:B}}async showMessageBox(B,C){const z=this.C(C?.targetWindowId,B);return this.c.showMessageBox(C,z?.win??void 0)}async showSaveDialog(B,C){const z=this.C(C?.targetWindowId,B);return this.c.showSaveDialog(C,z?.win??void 0)}async showOpenDialog(B,C){const z=this.C(C?.targetWindowId,B);return this.c.showOpenDialog(C,z?.win??void 0)}async pickFileFolderAndOpen(B,C){const z=await this.c.pickFileFolder(C);z&&await this.w(await Promise.all(z.map(async re=>await p.SymlinkSupport.existsDirectory(re)?{folderUri:g.URI.file(re)}:{fileUri:g.URI.file(re)})),C,B)}async pickFolderAndOpen(B,C){const z=await this.c.pickFolder(C);z&&await this.w(z.map(re=>({folderUri:g.URI.file(re)})),C,B)}async pickFileAndOpen(B,C){const z=await this.c.pickFile(C);z&&await this.w(z.map(re=>({fileUri:g.URI.file(re)})),C,B)}async pickWorkspaceAndOpen(B,C){const z=await this.c.pickWorkspace(C);z&&await this.w(z.map(re=>({workspaceUri:g.URI.file(re)})),C,B)}async w(B,C,z){await this.a.open({context:s.OpenContext.DIALOG,contextWindowId:z,cli:this.g.args,urisToOpen:B,forceNewWindow:C.forceNewWindow})}async showItemInFolder(B,C){o.shell.showItemInFolder(C)}async setRepresentedFilename(B,C,z){this.C(z?.targetWindowId,B)?.setRepresentedFilename(C)}async setDocumentEdited(B,C,z){this.C(z?.targetWindowId,B)?.setDocumentEdited(C)}async openExternal(B,C){return this.g.unsetSnapExportedVariables(),o.shell.openExternal(C),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(B,C){return o.shell.trashItem(C)}async isAdmin(){let B;return d.$i?B=(await new Promise((C,z)=>{x(["native-is-elevated"],C,z)}).then(De)).default():B=process.getuid?.()===0,B}async writeElevated(B,C,z,re){const Q=await new Promise((le,K)=>{x(["@vscode/sudo-prompt"],le,K)}).then(De);return new Promise((le,K)=>{const ee=[`"${this.z}"`];re?.unlock&&ee.push("--file-chmod"),ee.push("--file-write",`"${C.fsPath}"`,`"${z.fsPath}"`);const q={name:this.j.nameLong.replace("-",""),icns:d.$j&&this.g.isBuilt?(0,f.$lc)((0,f.$oc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};Q.exec(ee.join(" "),q,(j,U,V)=>{U&&this.h.trace(`[sudo-prompt] received stdout: ${U}`),V&&this.h.trace(`[sudo-prompt] received stderr: ${V}`),j?K(j):le(void 0)})})}async isRunningUnderARM64Translation(){return d.$k||d.$i?!1:o.app.runningUnderARM64Translation}get z(){return d.$i?this.g.isBuilt?(0,f.$lc)((0,f.$oc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,f.$lc)(this.g.appRoot,"scripts","code-cli.bat"):d.$k?this.g.isBuilt?(0,f.$lc)((0,f.$oc)(process.execPath),"bin",`${this.j.applicationName}`):(0,f.$lc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,f.$lc)(this.g.appRoot,"bin","code"):(0,f.$lc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,P.totalmem)(),freemem:(0,P.freemem)(),loadavg:(0,P.loadavg)()}}async getOSProperties(){return{arch:(0,P.arch)(),platform:(0,P.platform)(),release:(0,P.release)(),type:(0,P.type)(),cpus:(0,P.cpus)()}}async getOSVirtualMachineHint(){return h.$Rn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return d.$i&&(0,v.$Dfc)()}async getProcessId(B){return this.C(void 0,B)?.win?.webContents.getOSProcessId()}async killProcess(B,C,z){process.kill(C,z)}async readClipboardText(B,C){return o.clipboard.readText(C)}async writeClipboardText(B,C,z){return o.clipboard.writeText(C,z)}async readClipboardFindText(B){return o.clipboard.readFindText()}async writeClipboardFindText(B,C){return o.clipboard.writeFindText(C)}async writeClipboardBuffer(B,C,z,re){return o.clipboard.writeBuffer(C,Buffer.from(z.buffer),re)}async readClipboardBuffer(B,C){return S.$Oe.wrap(o.clipboard.readBuffer(C))}async hasClipboard(B,C,z){return o.clipboard.has(C,z)}async newWindowTab(){await this.a.open({context:s.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){o.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){o.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){o.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){o.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){o.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(B,C){this.D(B)?.updateTouchBar(C)}async notifyReady(B){this.D(B)?.setReady()}async relaunch(B,C){return this.f.relaunch(C)}async reload(B,C){const z=this.D(B);if(z){if((0,u.$Ui)(z.openedWorkspace)){const re=z.openedWorkspace.configPath;if(re.scheme===a.Schemas.file&&(await this.n.resolveLocalWorkspace(re))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.f.reload(z,C?.disableExtensions!==void 0?{_:[],"disable-extensions":C.disableExtensions}:void 0)}}async closeWindow(B,C){return this.C(C?.targetWindowId,B)?.win?.close()}async quit(B){const C=this.a.getLastActiveWindow();C?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&C.win?C.win.close():this.f.quit()}async exit(B,C){await this.f.kill(C)}async resolveProxy(B,C){return this.D(B)?.win?.webContents?.session?.resolveProxy(C)}async loadCertificates(B){return(await new Promise((z,re)=>{x(["@vscode/proxy-agent"],z,re)}).then(De)).loadSystemCertificates({log:this.h})}findFreePort(B,C,z,re,Q=1){return(0,y.$4g)(C,z,re,Q)}async openDevTools(B,C){this.C(C?.targetWindowId,B)?.win?.webContents.openDevTools(C?.mode?{mode:C.mode,activate:C.activate}:void 0)}async toggleDevTools(B,C){this.C(C?.targetWindowId,B)?.win?.webContents.toggleDevTools()}async profileRenderer(B,C,z){const re=this.D(B);if(!re||!re.win)throw new Error;return await new R.$Efc(re.win,C,this.h).inspect(z)}async windowsGetStringRegKey(B,C,z,re){if(!d.$i)return;const Q=await new Promise((le,K)=>{x(["@vscode/windows-registry"],le,K)}).then(De);try{return Q.GetStringRegKey(C,z,re)}catch{return}}C(B,C){return this.D(B)??this.F(B)??this.D(C)}D(B){if(typeof B=="number")return this.a.getWindowById(B)}F(B){if(typeof B!="number")return;const C=o.webContents.fromId(B);if(C)return this.b.getWindowByWebContents(C)}};e.$Hfc=O,Pe([A.$0h],O.prototype,"z",null),e.$Hfc=O=Pe([ne(0,s.$Uec),ne(1,T.$Ffc),ne(2,m.$Pec),ne(3,t.$bfc),ne(4,E.$Jec),ne(5,r.$_j),ne(6,i.$sk),ne(7,c.$Sec),ne(8,l.$7ec)],O)});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[308],ae([0,1,14,27,8,23,2,12,3,35,185,53,24,5,65,73,74,51,29]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0,p=et(p);let k=class{static{E=this}static{this.a="#1E1E1E"}constructor(r,i,c,s,u,l,S){this.d=r,this.e=i,this.f=c,this.g=s,this.h=u,this.i=l,this.j=S,this.b=null,this.c=null}async openReporter(r){if(this.b)this.b&&this.k(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const i=new A.$Vc,c=i.add(this.i.createIPCObjectUrl()),s=this.m(this.c,700,800);this.b=this.l(s,c,{backgroundColor:r.styles.backgroundColor,title:(0,f.localize)(0,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1},"issue-reporter"),c.update({appRoot:this.e.appRoot,windowId:this.b.id,userEnv:this.d,data:r,disableExtensions:!!this.e.disableExtensions,os:{type:(0,o.type)(),arch:(0,o.arch)(),release:(0,o.release)()},product:p.default}),this.b.loadURL(I.$Zg.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.e.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,i.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,i.dispose())})}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.h.reload(this.c.id,{disableExtensions:!0})}catch(r){this.f.error(r)}}async $showConfirmCloseDialog(){if(this.b){const{response:r}=await this.g.showMessageBox({type:"warning",message:(0,f.localize)(1,null),buttons:[(0,f.localize)(2,null),(0,f.localize)(3,null)]},this.b);r===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:r}=await this.g.showMessageBox({type:"warning",message:(0,f.localize)(4,null),buttons:[(0,f.localize)(5,null),(0,f.localize)(6,null)]},this.b);return r===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const r=this.j.getWindowById(this.c.id);if(!r)throw new Error("Window not found");return r}async $sendReporterMenu(r,i){const c=this.issueReporterWindowCheck(),s="vscode:triggerReporterMenu",u=new D.$xe;return c.sendWhenReady(s,u.token,{replyChannel:s,extensionId:r,extensionName:i}),await(0,P.$wh)(new Promise(S=>a.$FX.once(`vscode:triggerReporterMenuResponse:${r}`,(v,R)=>S(R))),5e3,()=>{this.f.error(`Error: Extension ${r} timed out waiting for menu response`),u.cancel()})}async $closeReporter(){this.b?.close()}k(r){r.isMinimized()&&r.restore(),r.focus()}l(r,i,c,s){const u=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:c.title,backgroundColor:c.backgroundColor||E.a,webPreferences:{preload:I.$Zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`],v8CacheOptions:this.e.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,$.$0D)(c.zoomLevel),sandbox:!0},alwaysOnTop:c.alwaysOnTop,experimentalDarkMode:!0});return u.setMenuBarVisibility(!1),u}m(r,i,c){let s;const u=n.screen.getAllDisplays();if(u.length===1)s=u[0];else{if(b.$j){const v=n.screen.getCursorScreenPoint();s=n.screen.getDisplayNearestPoint(v)}!s&&r&&(s=n.screen.getDisplayMatching(r.getBounds())),s||(s=n.screen.getPrimaryDisplay()||u[0])}const l=s.bounds,S={width:i,height:c,x:l.x+l.width/2-i/2,y:l.y+l.height/2-c/2};return l.width>0&&l.height>0&&(S.x<l.x&&(S.x=l.x),S.y<l.y&&(S.y=l.y),S.x>l.x+l.width&&(S.x=l.x),S.y>l.y+l.height&&(S.y=l.y),S.width>l.width&&(S.width=l.width),S.height>l.height&&(S.height=l.height)),S}};e.$Ifc=k,e.$Ifc=k=E=Pe([ne(1,g.$Jec),ne(2,w.$_j),ne(3,d.$Pec),ne(4,h.$Gfc),ne(5,y.$Rec),ne(6,m.$Uec)],k)});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[309],ae([0,1,14,31,2,12,3,116,35,186,97,136,53,24,5,65,73,28,74,34,64,51]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m,E,k,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0,y=et(y);const i="issue.processExplorerWindowState";let c=class{static{r=this}static{this.a="#1E1E1E"}constructor(l,S,v,R,T,L,O,F,B,C){this.d=l,this.f=S,this.g=v,this.h=R,this.i=T,this.j=L,this.k=O,this.l=F,this.m=B,this.n=C,this.b=null,this.c=null,this.o()}o(){b.$FX.on("vscode:listProcesses",async l=>{const S=[];try{S.push({name:(0,a.localize)(0,null),rootProcess:await(0,I.$Us)(process.pid)}),(await this.i.getRemoteDiagnostics({includeProcesses:!0})).forEach(R=>{(0,f.$Tm)(R)?S.push({name:R.hostName,rootProcess:R}):R.processes&&S.push({name:R.hostName,rootProcess:R.processes})})}catch(v){this.g.error(`Listing processes failed: ${v}`)}this.s(l,"vscode:listProcessesResponse",S)}),b.$FX.on("vscode:workbenchCommand",(l,S)=>{const{id:v,from:R,args:T}=S;let L;switch(R){case"processExplorer":L=this.c;break;default:throw new Error(`Unexpected command source: ${R}`)}L?.webContents.send("vscode:runAction",{id:v,from:R,args:T})}),b.$FX.on("vscode:closeProcessExplorer",l=>{this.b?.close()}),b.$FX.on("vscode:pidToNameRequest",async l=>{const S=await this.i.getMainDiagnostics(),v=[];for(const R of S.windows)v.push([R.pid,`window [${R.id}] (${R.title})`]);for(const{pid:R,name:T}of k.$ofc.getAll())v.push([R,T]);this.s(l,"vscode:pidToNameResponse",v)})}async openProcessExplorer(l){if(!this.b&&(this.c=n.BrowserWindow.getFocusedWindow(),this.c)){const S=new P.$Vc,v=S.add(this.l.createIPCObjectUrl()),R=this.n.getItem(i,void 0),T=s(R)?R:this.q(this.c,800,500);this.b=this.r(T,v,{backgroundColor:l.styles.backgroundColor,title:(0,a.localize)(1,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0},"process-explorer"),v.update({appRoot:this.f.appRoot,windowId:this.b.id,userEnv:this.d,data:l,product:y.default}),this.b.loadURL(D.$Zg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.f.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,S.dispose()}),this.c.on("close",()=>{this.b&&(this.b.close(),this.b=null,S.dispose())});const L=()=>{if(!this.b)return;const O=this.b.getSize(),F=this.b.getPosition();if(!O||!F)return;const B={width:O[0],height:O[1],x:F[0],y:F[1]};this.n.setItem(i,B)};this.b.on("moved",L),this.b.on("resized",L)}this.b&&this.p(this.b)}p(l){l.isMinimized()&&l.restore(),l.focus()}q(l,S,v){let R;const T=n.screen.getAllDisplays();if(T.length===1)R=T[0];else{if(A.$j){const F=n.screen.getCursorScreenPoint();R=n.screen.getDisplayNearestPoint(F)}!R&&l&&(R=n.screen.getDisplayMatching(l.getBounds())),R||(R=n.screen.getPrimaryDisplay()||T[0])}const L=R.bounds,O={width:S,height:v,x:L.x+L.width/2-S/2,y:L.y+L.height/2-v/2};return L.width>0&&L.height>0&&(O.x<L.x&&(O.x=L.x),O.y<L.y&&(O.y=L.y),O.x>L.x+L.width&&(O.x=L.x),O.y>L.y+L.height&&(O.y=L.y),O.width>L.width&&(O.width=L.width),O.height>L.height&&(O.height=L.height)),O}async stopTracing(){if(!this.f.args.trace)return;const l=await n.contentTracing.stopRecording(`${(0,o.$Ng)(this.f.userHome.fsPath,this.m.applicationName)}.trace.txt`);await this.j.showMessageBox({type:"info",message:(0,a.localize)(2,null),detail:(0,a.localize)(3,null,l),buttons:[(0,a.localize)(4,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.k.showItemInFolder(void 0,l)}async getSystemStatus(){const[l,S]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.h.getDiagnostics(l,S)}async $getSystemInfo(){const[l,S]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.h.getSystemInfo(l,S)}async $getPerformanceInfo(){try{const[l,S]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.h.getPerformanceInfo(l,S)}catch(l){throw this.g.warn("issueService#getPerformanceInfo ",l.message),l}}r(l,S,v,R){const T=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:v.title,backgroundColor:v.backgroundColor||r.a,webPreferences:{preload:D.$Zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${S.resource.toString()}`],v8CacheOptions:this.f.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.$0D)(v.zoomLevel),sandbox:!0},alwaysOnTop:v.alwaysOnTop,experimentalDarkMode:!0});return T.setMenuBarVisibility(!1),T}s(l,S,...v){l.sender.isDestroyed()||l.sender.send(S,...v)}async closeProcessExplorer(){this.b?.close()}};e.$Jfc=c,e.$Jfc=c=r=Pe([ne(1,w.$Jec),ne(2,h.$_j),ne(3,f.$Sm),ne(4,d.$rfc),ne(5,g.$Pec),ne(6,p.$Gfc),ne(7,m.$Rec),ne(8,$.$sk),ne(9,E.$gR)],c);function s(u){return typeof u!="object"||u===null?!1:"x"in u&&"y"in u&&"width"in u&&"height"in u}}),define(oe[310],ae([0,1,23,18,24,20,5,65,28,57,25,50,106]),function(x,e,n,o,P,D,A,I,b,a,f,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=void 0;let w=class extends g.$9fc{constructor(p,y,$,m,E,k,t,r){super(p,y,m,E,k,r),this.e=$,this.u=t}s(p){return(0,g.$8fc)(`linux-${process.arch}`,p,this.k)}t(p){this.a&&(this.d(d.$DY.CheckingForUpdates(p)),this.i.request({url:this.a},n.CancellationToken.None).then(a.$$p).then(y=>{!y||!y.url||!y.version||!y.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!p}),this.d(d.$DY.Idle(d.UpdateType.Archive))):this.d(d.$DY.AvailableForDownload(y))}).then(void 0,y=>{this.j.error(y);const $=p?y.message||y:void 0;this.d(d.$DY.Idle(d.UpdateType.Archive,$))}))}async o(p){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):p.update.url&&this.u.openExternal(void 0,p.update.url),this.d(d.$DY.Idle(d.UpdateType.Archive))}};e.$$fc=w,e.$$fc=w=Pe([ne(0,D.$bfc),ne(1,o.$_i),ne(2,f.$$l),ne(3,P.$Jec),ne(4,a.$5p),ne(5,A.$_j),ne(6,I.$Gfc),ne(7,b.$sk)],w)}),define(oe[311],ae([0,1,49,47,27,8,23,54,46,10,7,149,21,18,24,15,20,5,65,28,57,25,50,106]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m,E,k,t,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0,o=De(o),a=De(a),g=De(g);async function c(S,v=1e3){for(;!S();)await(0,D.$Gh)(v)}let s;function u(){return typeof s>"u"&&(s=o.existsSync(a.$lc(a.$oc(process.execPath),"unins000.exe"))?r.UpdateType.Setup:r.UpdateType.Archive),s}let l=class extends i.$9fc{get cachePath(){const v=a.$lc((0,P.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return g.Promises.mkdir(v,{recursive:!0}).then(()=>v)}constructor(v,R,T,L,O,F,B,C,z){super(v,R,L,O,F,z),this.u=T,this.v=B,this.w=C,v.setRelaunchHandler(this)}handleRelaunch(v){return v?.addArgs||v?.removeArgs||this.state.type!==r.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(r.$DY.Disabled(r.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(v){let R=`win32-${process.arch}`;return u()===r.UpdateType.Archive?R+="-archive":this.k.target==="user"&&(R+="-user"),(0,i.$8fc)(R,v,this.k)}t(v){this.a&&(this.d(r.$DY.CheckingForUpdates(v)),this.i.request({url:this.a},A.CancellationToken.None).then(k.$$p).then(R=>{const T=u();return!R||!R.url||!R.version||!R.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!v}),this.d(r.$DY.Idle(T)),Promise.resolve(null)):T===r.UpdateType.Archive?(this.d(r.$DY.AvailableForDownload(R)),Promise.resolve(null)):(this.d(r.$DY.Downloading),this.C(R.version).then(()=>this.B(R.version).then(L=>g.Promises.exists(L).then(O=>{if(O)return Promise.resolve(L);const F=`${L}.tmp`;return this.i.request({url:R.url},A.CancellationToken.None).then(B=>this.v.writeFile(f.URI.file(F),B.stream)).then(R.sha256hash?()=>(0,d.$yX)(F,R.sha256hash):()=>{}).then(()=>g.Promises.rename(F,L,!1)).then(()=>L)})).then(L=>{this.e={packagePath:L},this.d(r.$DY.Downloaded(R)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(r.$DY.Ready(R))})))}).then(void 0,R=>{this.u.publicLog2("update:error",{messageHash:String((0,b.$tj)(String(R)))}),this.j.error(R);const T=v?R.message||R:void 0;this.d(r.$DY.Idle(u(),T))}))}async o(v){v.update.url&&this.w.openExternal(void 0,v.update.url),this.d(r.$DY.Idle(u()))}async B(v){const R=await this.cachePath;return a.$lc(R,`CodeSetup-${this.k.quality}-${v}.exe`)}async C(v=null){const R=v?F=>!new RegExp(`${this.k.quality}-${v}\\.exe$`).test(F):()=>!0,T=await this.cachePath,O=(await g.Promises.readdir(T)).filter(R).map(async F=>{try{await g.Promises.unlink(a.$lc(T,F))}catch{}});await Promise.all(O)}async p(){if(this.state.type!==r.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const v=this.state.update;this.d(r.$DY.Updating(v));const R=await this.cachePath;this.e.updateFilePath=a.$lc(R,`CodeSetup-${this.k.quality}-${v.version}.flag`),await g.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(r.$DY.Idle(u()))});const L=`${this.k.win32MutexName}-ready`,O=await new Promise((F,B)=>{x(["@vscode/windows-mutex"],F,B)}).then(De);c(()=>O.isActive(L)).then(()=>this.d(r.$DY.Ready(v)))}r(){this.state.type!==r.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?o.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return u()}async _applySpecificUpdate(v){if(this.state.type!==r.StateType.Idle)return;const R=this.g.getValue("update.enableWindowsBackgroundUpdates"),T={version:"unknown",productVersion:"unknown"};this.d(r.$DY.Downloading),this.e={packagePath:v},this.d(r.$DY.Downloaded(T)),R?this.k.target==="user"&&this.p():this.d(r.$DY.Ready(T))}};e.$agc=l,Pe([I.$0h],l.prototype,"cachePath",null),e.$agc=l=Pe([ne(0,y.$bfc),ne(1,w.$_i),ne(2,t.$$l),ne(3,h.$Jec),ne(4,k.$5p),ne(5,$.$_j),ne(6,p.$_k),ne(7,m.$Gfc),ne(8,E.$sk)],l)}),define(oe[137],ae([0,1,14,8,23,55,4,2,12,71,3,7,197,27,70,18,53,24,69,15,20,5,28,74,286,88,25,111,77,51,29,30,60,52,40,34,59,72,22,6]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m,E,k,t,r,i,c,s,u,l,S,v,R,T,L,O,F,B,C,z,re,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=e.$$ec=void 0;var le;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(le||(le={}));class K extends I.$Wc{get lastFocusTime(){return this.j}get win(){return this.m}n(j){this.m=j,this.B(A.Event.fromNodeEventEmitter(j,"maximize")(()=>this.b.fire())),this.B(A.Event.fromNodeEventEmitter(j,"unmaximize")(()=>this.c.fire())),this.B(A.Event.fromNodeEventEmitter(j,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(A.Event.fromNodeEventEmitter(j,"focus")(()=>{this.j=Date.now()})),this.B(A.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(A.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const U=!(0,v.$5D)(this.r);if(f.$j&&U&&j.setSheetOffset((0,f.$J)((0,w.release)())?28:22),U&&(f.$i&&(0,v.$8D)(this.r)||f.$j)){const V=this.s.getItem(K.D);V?this.updateWindowControls({height:V}):this.updateWindowControls({height:v.$7D})}f.$i&&U&&j.hookWindowMessage(278,()=>{const[ce,G]=j.getPosition(),he=n.screen.getCursorScreenPoint(),se=he.x-ce,_=he.y-G;return!(se>30&&_>=0&&_<=Math.max(j.getBounds().height*.15,35))||(j.setEnabled(!1),j.setEnabled(!0),this.f.fire({x:se,y:_})),0}),this.t.args["open-devtools"]===!0&&j.webContents.openDevTools(),f.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(j,U,V,ce){super(),this.r=j,this.s=U,this.t=V,this.u=ce,this.a=this.B(new A.$me),this.onDidClose=this.a.event,this.b=this.B(new A.$me),this.onDidMaximize=this.b.event,this.c=this.B(new A.$me),this.onDidUnmaximize=this.c.event,this.f=this.B(new A.$me),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new A.$me),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new A.$me),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,v.$8D)(this.r),this.G=void 0,this.H=void 0}w(j,U=n.screen.getAllDisplays().length>0){const V=this.r.getValue("window"),ce=f.$j&&V?.nativeTabs===!0;(f.$j||f.$i)&&U&&(!ce||n.BrowserWindow.getAllWindows().length===1)&&[j.width,j.height,j.x,j.y].every(G=>typeof G=="number")&&this.m?.setBounds({width:j.width,height:j.height,x:j.x,y:j.y}),(j.mode===O.WindowMode.Maximized||j.mode===O.WindowMode.Fullscreen)&&(this.m?.maximize(),j.mode===O.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(j){f.$j?this.win?.setRepresentedFilename(j):this.z=j}getRepresentedFilename(){return f.$j?this.win?.getRepresentedFilename():this.z}setDocumentEdited(j){f.$j&&this.win?.setDocumentEdited(j),this.C=j}isDocumentEdited(){return f.$j?!!this.win?.isDocumentEdited():!!this.C}focus(j){f.$j&&j?.force&&n.app.focus({steal:!0});const U=this.win;U&&(U.isMinimized()&&U.restore(),U.focus())}handleTitleDoubleClick(){const j=this.win;if(j)if(f.$j)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":j.minimize();break;case"None":break;case"Maximize":default:j.isMaximized()?j.unmaximize():j.maximize()}else j.isMaximized()?j.unmaximize():j.maximize()}static{this.D="windowControlHeight"}updateWindowControls(j){const U=this.win;if(U){if(j.height&&this.s.setItem(ee.D,j.height),f.$i&&this.F)U.setTitleBarOverlay({color:j.backgroundColor?.trim()===""?void 0:j.backgroundColor,symbolColor:j.foregroundColor?.trim()===""?void 0:j.foregroundColor,height:j.height?j.height-1:void 0});else if(f.$j&&j.height!==void 0){const V=(j.height-15)/2;V?U.setWindowButtonPosition({x:V,y:V}):U.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(j,U){(0,v.$9D)(this.r)?this.J(j,U):this.M(j)}get isFullScreen(){if(f.$j&&typeof this.G=="boolean")return this.G;const j=this.win,U=j?.isFullScreen(),V=j?.isSimpleFullScreen();return!!(U||V)}J(j,U){const V=this.win;V?.isSimpleFullScreen()&&V?.setSimpleFullScreen(!1),this.L(j,U)}L(j,U){if(f.$j){this.G=j;const ce=this.H=new o.$3h;(async()=>{const G=await Promise.race([ce.p,(0,o.$Gh)(1e4).then(()=>!1)]);this.H===ce&&(this.G=void 0,this.H=void 0,!G&&j&&U&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(j)}M(j){const U=this.win;U?.isFullScreen()&&this.L(!1,!1),U?.setSimpleFullScreen(j),U?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$$ec=K;let ee=class extends K{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const j=this.hb.profiles.find(U=>U.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&j?j:this.hb.getProfileForWorkspace(this.config.workspace??(0,T.$Ti)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(j,U,V,ce,G,he,se,_,M,N,W,H,J,X,Z,ie,de,me,we,Oe,Se){super(N,Oe,ce,U),this.fb=V,this.gb=G,this.hb=he,this.ib=se,this.jb=_,this.kb=M,this.lb=W,this.mb=H,this.nb=J,this.ob=X,this.pb=Z,this.qb=ie,this.rb=de,this.sb=me,this.tb=we,this.N=this.B(new A.$me),this.onWillLoad=this.N.event,this.O=this.B(new A.$me),this.onDidSignalReady=this.O.event,this.P=this.B(new A.$me),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=le.NONE;{const[ke,Ie]=this.Eb(j.state);this.U=ke,this.u.trace("window#ctor: using window state",ke);const $e=Se.invokeFunction(R.$Vec,this.U,{preload:b.$Zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,a.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow($e),(0,a.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,Ie),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=le.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(j=>{if(this.isReady)return j(this);this.X.push(j)})}get isReady(){return this.ub===le.READY}get whenClosedOrLoaded(){return new Promise(j=>{function U(){V.dispose(),ce.dispose(),j()}const V=this.onDidClose(()=>U()),ce=this.onWillLoad(()=>U())})}vb(){this.B(A.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(O.WindowError.UNRESPONSIVE))),this.B(A.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(U,V)=>V)(U=>this.yb(O.WindowError.PROCESS_GONE,{...U}))),this.B(A.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(U,V,ce)=>({exitCode:V,reason:ce}))(({exitCode:U,reason:V})=>this.yb(O.WindowError.LOAD,{reason:V,exitCode:U}))),this.B(A.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(U=>U.preventDefault())),this.B(A.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",P.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",P.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(U=>this.Bb(U))),this.B(this.mb.onDidDeleteUntitledWorkspace(U=>this.Ab(U)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async(U,V)=>{const ce=await this.xb();V({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,ce)})})}xb(){return this.wb||(this.wb=(0,c.$mq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(j,U){switch(j){case O.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break;case O.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case O.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:j,reason:U?.reason,code:U?.exitCode}),j){case O.WindowError.UNRESPONSIVE:case O.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(j===O.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:V,checkboxChecked:ce}=await this.pb.showMessageBox({type:"warning",buttons:[(0,g.localize)(0,null),(0,g.localize)(1,null),(0,g.localize)(2,null)],message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null),checkboxLabel:this.S?.workspace?(0,g.localize)(5,null):void 0},this.m);if(V!==2){const G=V===0;await this.zb(G,ce)}}else if(j===O.WindowError.PROCESS_GONE){let V;U?V=(0,g.localize)(7,null,U.reason,U.exitCode??"<unknown>"):V=(0,g.localize)(6,null);const{response:ce,checkboxChecked:G}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,g.localize)(8,null):(0,g.localize)(9,null),(0,g.localize)(10,null)],message:V,detail:this.S?.workspace?(0,g.localize)(11,null):(0,g.localize)(12,null),checkboxLabel:this.S?.workspace?(0,g.localize)(13,null):void 0},this.m),he=ce===0;await this.zb(he,G)}break}}async zb(j,U){const V=this.S?.workspace;if(U&&V)try{const ce=this.kb.workspaceStorage(V);await ce.init(),ce.delete("memento/workbench.parts.editor"),await ce.close()}catch(ce){this.u.error(ce)}this.P.fire();try{if(j&&this.S){let ce,G;(0,T.$Pi)(V)?ce={folderUri:V.uri}:(0,T.$Ui)(V)?ce={workspaceUri:V.configPath}:G=!0,(0,re.$Qb)(await this.tb.open({context:R.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:ce?[ce]:void 0,forceEmpty:G,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(j){this.S?.workspace?.id===j.id&&(this.S.workspace=void 0)}Bb(j){if(!j||j.affectsConfiguration("window.menuBarVisibility")){const U=this.Gb();U!==this.W&&(this.W=U,this.Hb(U))}if(!j||j.affectsConfiguration("http.proxy")){let U=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const V=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.Z||V!==this.$)){this.Z=U,this.$=V;const ce=U||"",G=V?`${V},<local>`:"<local>";this.u.trace(`Setting proxy to '${ce}', bypassing '${G}'`),this.m.webContents.session.setProxy({proxyRules:ce,proxyBypassRules:G,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:ce,proxyBypassRules:G,pacScript:""})}}}addTabbedWindow(j){f.$j&&j.win&&this.m.addTabbedWindow(j.win)}load(j,U=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!U.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),U.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(j,U),this.ub===le.NONE?this.S=j:this.db=j,this.ub=le.NAVIGATING,this.m.loadURL(b.$Zg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const V=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new o.$Rh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:j.workspace,reason:U.isReload?O.LoadReason.RELOAD:V?O.LoadReason.LOAD:O.LoadReason.INITIAL})}Cb(j,U){const V=(this.S??this.db)?.userEnv;if(V){const ce=(0,m.$Jm)(V)&&!(0,m.$Jm)(j.userEnv),G=this.isExtensionDevelopmentHost;(ce||G)&&(j.userEnv={...V,...j.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(j.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),U.disableExtensions!==void 0&&(j["disable-extensions"]=U.disableExtensions),j.fullscreen=this.isFullScreen,j.maximized=this.m.isMaximized(),j.partsSplash=this.lb.getWindowSplash(),j.zoomLevel=this.Jb(),j.isCustomZoomLevel=typeof this.ab=="number",j.isCustomZoomLevel&&j.partsSplash&&(j.partsSplash.zoomLevel=j.zoomLevel),(0,a.mark)("code/willOpenNewWindow"),j.perfMarks=(0,a.getMarks)(),this.bb.update(j)}async reload(j){const U=Object.assign({},this.S);U.workspace=await this.Db(U),delete U.filesToOpenOrCreate,delete U.filesToDiff,delete U.filesToMerge,delete U.filesToWait,this.isExtensionDevelopmentHost&&j&&(U.verbose=j.verbose,U.debugId=j.debugId,U.extensionEnvironment=j.extensionEnvironment,U["inspect-extensions"]=j["inspect-extensions"],U["inspect-brk-extensions"]=j["inspect-brk-extensions"],U["extensions-dir"]=j["extensions-dir"]),U.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),U.isInitialStartup=!1,U.policiesData=this.gb.serialize(),U.continueOn=this.t.continueOn,U.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},U.logLevel=this.fb.getLogLevel(),U.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(U,{isReload:!0,disableExtensions:j?.["disable-extensions"]})}async Db(j){if((0,T.$Ui)(j.workspace)){const U=j.workspace.configPath;if(U.scheme===b.Schemas.file&&!await this.ib.exists(U))return}else if((0,T.$Pi)(j.workspace)){const U=j.workspace.uri;if(U.scheme===b.Schemas.file&&!await this.ib.exists(U))return}return j.workspace}serializeWindowState(){if(!this.m)return(0,O.$Hec)();if(this.isFullScreen){let V;try{V=n.screen.getDisplayMatching(this.getBounds())}catch{}const ce=(0,O.$Hec)();return{mode:O.WindowMode.Fullscreen,display:V?V.id:void 0,width:this.U.width||ce.width,height:this.U.height||ce.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const j=Object.create(null);let U;if(!f.$j&&this.m.isMaximized()?U=O.WindowMode.Maximized:U=O.WindowMode.Normal,U===O.WindowMode.Maximized?j.mode=O.WindowMode.Maximized:j.mode=O.WindowMode.Normal,U===O.WindowMode.Normal||U===O.WindowMode.Maximized){let V;U===O.WindowMode.Normal?V=this.getBounds():V=this.m.getNormalBounds(),j.x=V.x,j.y=V.y,j.width=V.width,j.height=V.height}return j.zoomLevel=this.ab,j}Eb(j){(0,a.mark)("code/willRestoreCodeWindowState");let U=!1;if(j){this.ab=j.zoomLevel;try{const V=n.screen.getAllDisplays();U=V.length>1,j=R.WindowStateValidator.validateWindowState(this.u,j,V)}catch(V){this.u.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}}return(0,a.mark)("code/didRestoreCodeWindowState"),[j||(0,O.$Hec)(),U]}getBounds(){const[j,U]=this.m.getPosition(),[V,ce]=this.m.getSize();return{x:j,y:U,width:V,height:ce}}I(j,U){super.I(j,U),this.sendWhenReady(j?"vscode:enterFullScreen":"vscode:leaveFullScreen",P.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let j=(0,v.$3D)(this.r);return["visible","toggle","hidden"].indexOf(j)<0&&(j="classic"),j}Hb(j,U=!0){f.$j||(j==="toggle"&&U&&this.send("vscode:showInfoMessage",(0,g.localize)(14,null)),j==="hidden"?setTimeout(()=>{this.Ib(j)}):this.Ib(j))}Ib(j){const U=this.isFullScreen;switch(j){case"classic":this.m.setMenuBarVisibility(!U),this.m.autoHideMenuBar=U;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(j){this.ab=j}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(j,U,...V){this.isReady?this.send(j,...V):this.ready().then(()=>{U.isCancellationRequested||this.send(j,...V)})}send(j,...U){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${j}' for window that is destroyed`);return}try{this.m.webContents.send(j,...U)}catch(V){this.u.warn(`Error sending IPC message to channel '${j}' of window ${this.Q}: ${(0,D.$qj)(V)}`)}}}updateTouchBar(j){f.$j&&this.Y.forEach((U,V)=>{const ce=j[V];U.segments=this.Mb(ce)})}Kb(){if(f.$j){for(let j=0;j<10;j++){const U=this.Lb();this.Y.push(U)}this.m.setTouchBar(new n.TouchBar({items:this.Y}))}}Lb(j=[]){const U=this.Mb(j),V=new n.TouchBar.TouchBarSegmentedControl({segments:U,mode:"buttons",segmentStyle:"automatic",change:ce=>{this.sendWhenReady("vscode:runAction",P.CancellationToken.None,{id:V.segments[ce].id,from:"touchbar"})}});return V}Mb(j=[]){return j.map(V=>{let ce;V.icon&&!l.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===b.Schemas.file&&(ce=n.nativeImage.createFromPath(d.URI.revive(V.icon.dark).fsPath),ce.isEmpty()&&(ce=void 0));let G;return typeof V.title=="string"?G=V.title:G=V.title.value,{id:V.id,label:ce?void 0:G,icon:ce}})}matches(j){return this.m?.webContents.id===j.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$_ec=ee,e.$_ec=ee=Pe([ne(1,t.$_j),ne(2,z.$9ec),ne(3,$.$Jec),ne(4,F.$so),ne(5,C.$Xec),ne(6,E.$_k),ne(7,s.$jfc),ne(8,s.$hfc),ne(9,p.$_i),ne(10,S.$Sec),ne(11,L.$7ec),ne(12,h.$Oec),ne(13,u.$$l),ne(14,y.$Pec),ne(15,k.$bfc),ne(16,r.$sk),ne(17,i.$Rec),ne(18,R.$Uec),ne(19,B.$gR),ne(20,Q.$Ei)],ee)}),define(oe[312],ae([0,1,14,3,18,24,20,5,34,51,52,137]),function(x,e,n,o,P,D,A,I,b,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;let g=class extends d.$$ec{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(h,p,y,$,m,E){super($,m,p,y),this.O=h,this.P=E,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(h){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),h&&!this.N&&(this.N=!0,this.w({x:h.x,y:h.y,width:h.width,height:h.height,mode:h.show===!1?f.WindowMode.Maximized:f.WindowMode.Normal})))}Q(){if(this.m)return;const h=n.BrowserWindow.fromWebContents(this.O);h&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(h),h.setMenu(null),(o.$i||o.$k)&&(0,a.$5D)(this.r)&&h.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(h){return this.O.id===h.id}};e.$afc=g,e.$afc=g=Pe([ne(1,D.$Jec),ne(2,I.$_j),ne(3,P.$_i),ne(4,b.$gR),ne(5,A.$bfc)],g)}),define(oe[313],ae([0,1,14,4,2,12,35,312,6,5,52,29]),function(x,e,n,o,P,D,A,I,b,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=void 0;let g=class extends P.$Wc{constructor(h,p){super(),this.h=h,this.j=p,this.a=this.B(new o.$me),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new o.$me),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new o.$me),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new o.$me),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(h,p)=>{const y=this.getWindowByWebContents(p.webContents);if(y)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),y.tryClaimWindow();else{const $=new P.$Vc;$.add(o.Event.fromNodeEventEmitter(p.webContents,"did-create-window",(m,E)=>({browserWindow:m,details:E}))(({browserWindow:m,details:E})=>{const k=this.getWindowByWebContents(m.webContents);k&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),k.tryClaimWindow(E.options))})),$.add(o.Event.fromNodeEventEmitter(p,"closed")(()=>$.dispose()))}}),A.$FX.handle("vscode:registerAuxiliaryWindow",async(h,p)=>{const y=this.getWindowByWebContents(h.sender);return y&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),y.parentId=p),h.sender.id})}createWindow(h){return this.h.invokeFunction(d.$Vec,this.n(h),{preload:D.$Zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(h){const p={},y=h.features.split(",");for(const m of y){const[E,k]=m.split("=");switch(E){case"width":p.width=parseInt(k,10);break;case"height":p.height=parseInt(k,10);break;case"left":p.x=parseInt(k,10);break;case"top":p.y=parseInt(k,10);break;case"window-maximized":p.mode=f.WindowMode.Maximized;break;case"window-fullscreen":p.mode=f.WindowMode.Fullscreen;break}}const $=d.WindowStateValidator.validateWindowState(this.j,p)??(0,f.$Iec)();return this.j.trace("[aux window] using window state",$),$}registerWindow(h){const p=new P.$Vc,y=this.h.createInstance(I.$afc,h);this.g.set(y.id,y),p.add((0,P.$Uc)(()=>this.g.delete(y.id))),p.add(y.onDidMaximize(()=>this.a.fire(y))),p.add(y.onDidUnmaximize(()=>this.b.fire(y))),p.add(y.onDidEnterFullScreen(()=>this.c.fire({window:y,fullscreen:!0}))),p.add(y.onDidLeaveFullScreen(()=>this.c.fire({window:y,fullscreen:!1}))),p.add(y.onDidTriggerSystemContextMenu(({x:$,y:m})=>this.f.fire({window:y,x:$,y:m}))),o.Event.once(y.onDidClose)(()=>p.dispose())}getWindowByWebContents(h){const p=this.g.get(h.id);return p?.matches(h)?p:void 0}getFocusedWindow(){const h=n.BrowserWindow.getFocusedWindow();if(h)return this.getWindowByWebContents(h.webContents)}getLastActiveWindow(){return(0,d.$Wec)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$Hgc=g,e.$Hgc=g=Pe([ne(0,b.$Ei),ne(1,a.$_j)],g)}),define(oe[89],ae([0,1,14,22,8,4,48,2,12,3,19,7,21,200,6,20,5,63,88,103,30,60,32,53]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m,E,k,t,r,i){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=e.$Tfc=void 0,e.$Tfc=(0,h.$Fi)("workspacesHistoryMainService");let s=class extends I.$Wc{static{c=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(l,S,v,R,T){super(),this.f=l,this.g=S,this.h=v,this.j=R,this.m=T,this.c=this.B(new D.$me),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new P.$Dh(800)),this.n()}n(){this.h.when(p.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(l=>this.addRecentlyOpened([{workspace:l.workspace,remoteAuthority:l.window.remoteAuthority}])))}async addRecentlyOpened(l){let S=[],v=[];for(const T of l)if((0,E.$Yhb)(T))!this.g.isUntitledWorkspace(T.workspace)&&!this.w(S,T.workspace)&&S.push(T);else if((0,E.$Zhb)(T))this.y(S,T.folderUri)||S.push(T);else{const L=this.z(v,T.fileUri),O=T.fileUri.scheme===b.Schemas.file&&c.G.indexOf((0,f.$dh)(T.fileUri))>=0;!L&&!O&&(v.push(T),a.$i&&T.fileUri.scheme===b.Schemas.file&&n.app.addRecentDocument(T.fileUri.fsPath))}const R=await this.r({workspaces:S,files:v});S=R.workspaces,v=R.files,S.length>c.a&&(S.length=c.a),v.length>c.a&&(v.length=c.a),await this.t({workspaces:S,files:v}),this.c.fire(),a.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(l){const S=L=>{const O=this.u(L);for(const F of l)if(f.$0g.isEqual(F,O))return!1;return!0},v=await this.getRecentlyOpened(),R=v.workspaces.filter(S),T=v.files.filter(S);(R.length!==v.workspaces.length||T.length!==v.files.length)&&(await this.t({files:T,workspaces:R}),this.c.fire(),a.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(l){if(l?.confirm){const{response:S}=await this.m.showMessageBox({type:"warning",buttons:[(0,w.localize)(0,null),(0,w.localize)(1,null)],message:(0,w.localize)(2,null),detail:(0,w.localize)(3,null),cancelId:1});if(S!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(l){const S=new r.$Cc(T=>f.$0g.getComparisonKey(T));if(l?.workspaces)for(const T of l.workspaces)S.set(this.u(T),T);const v=new r.$Cc(T=>f.$0g.getComparisonKey(T));if(l?.files)for(const T of l.files)v.set(this.u(T),T);const R=await this.s();for(const T of R.workspaces){const L=S.get(this.u(T));L?L.label=L.label??T.label:S.set(this.u(T),T)}for(const T of R.files){const L=v.get(this.u(T));L?L.label=L.label??T.label:v.set(this.u(T),T)}return{workspaces:[...S.values()],files:[...v.values()]}}async s(){await this.j.whenReady;let l;const S=this.j.get(c.b,$.StorageScope.APPLICATION);if(typeof S=="string")try{l=JSON.parse(S)}catch(v){this.f.error("Unexpected error parsing opened paths list",v)}return(0,E.$6hb)(l,this.f)}async t(l){await this.j.whenReady,this.j.store(c.b,JSON.stringify((0,E.$7hb)(l)),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE)}u(l){return(0,E.$Zhb)(l)?l.folderUri:(0,E.$1hb)(l)?l.fileUri:l.workspace.configPath}w(l,S){return!!l.find(v=>(0,E.$Yhb)(v)&&v.workspace.id===S.id)}y(l,S){return!!l.find(v=>(0,E.$Zhb)(v)&&f.$0g.isEqual(v.folderUri,S))}z(l,S){return!!l.find(v=>f.$0g.isEqual(v.fileUri,S))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){a.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!a.$i)return;const l=[];if(l.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(4,null),description:(0,w.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const S=[];for(const T of n.app.getJumpListSettings().removedItems){const L=T.args;if(L){const O=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(L);O&&S.push(d.URI.parse(O[2]))}}await this.removeRecentlyOpened(S);let v=!1;const R=(0,o.$Jb)((await this.getRecentlyOpened()).workspaces.slice(0,c.F).map(T=>{const L=(0,E.$Yhb)(T)?T.workspace:T.folderUri,{title:O,description:F}=this.L(L,T.label);let B;return d.URI.isUri(L)?B=`--folder-uri "${L.toString()}"`:(v=!0,B=`--file-uri "${L.configPath.toString()}"`),{type:"task",title:O.substr(0,255),description:F.substr(0,255),program:process.execPath,args:B,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&l.push({type:"custom",name:v?(0,w.localize)(6,null):(0,w.localize)(7,null),items:R})}l.push({type:"recent"});try{const S=n.app.setJumpList(l);S&&S!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${S}`)}catch(S){this.f.warn("updateWindowsJumpList#setJumpList",S)}}L(l,S){if(S)return{title:(0,A.$5w)(S).name,description:S};if(d.URI.isUri(l))return{title:(0,f.$dh)(l),description:this.M(l)};if(this.g.isUntitledWorkspace(l))return{title:(0,w.localize)(8,null),description:""};let v=(0,f.$dh)(l.configPath);return v.endsWith(k.$2i)&&(v=v.substr(0,v.length-k.$2i.length-1)),{title:(0,w.localize)(9,null,v),description:this.M(l.configPath)}}M(l){return l.scheme==="file"?(0,A.$Ww)(l.fsPath):l.toString()}async N(){if(!a.$j)return;n.app.clearRecentDocuments();const l=await this.getRecentlyOpened(),S=[];let v=0;for(let T=0;T<l.workspaces.length&&v<c.C;T++){const L=this.u(l.workspaces[T]);if(L.scheme===b.Schemas.file){const O=(0,f.$7g)(L);await g.Promises.exists(O)&&(S.push(O),v++)}}const R=[];for(let T=0;T<l.files.length&&v<c.D;T++){const L=this.u(l.files[T]);if(L.scheme===b.Schemas.file){const O=(0,f.$7g)(L);if(c.G.includes((0,f.$dh)(L))||S.includes(O))continue;await g.Promises.exists(O)&&(R.push(O),v++)}}R.reverse().forEach(T=>n.app.addRecentDocument(T)),S.reverse().forEach(T=>n.app.addRecentDocument(T))}};e.$Ufc=s,e.$Ufc=s=c=Pe([ne(0,y.$_j),ne(1,t.$7ec),ne(2,p.$bfc),ne(3,m.$jfc),ne(4,i.$Pec)],s)}),define(oe[314],ae([0,1,14,8,23,48,3,7,188,85,18,24,20,5,236,65,28,34,25,50,51,29,89,2]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m,E,k,t,r,i){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=void 0,b=De(b);const s="menu";let u=class extends i.$Wc{static{c=this}static{this.a="lastKnownMenubarData"}constructor(v,R,T,L,O,F,B,C,z,re,Q,le){super(),this.t=v,this.u=R,this.w=T,this.y=L,this.z=O,this.C=F,this.D=B,this.F=C,this.G=z,this.H=re,this.I=Q,this.J=le,this.s=Object.create(null),this.h=new o.$Rh(()=>this.R(),0),this.j=new o.$Rh(()=>{this.m=[]},1e4),this.n=Object.create(null),this.r=Object.create(null),(A.$j||(0,k.$5D)(R))&&this.L(),this.M(),this.f=!1,this.g=!1,this.m=[],this.W(),this.N()}L(){const v=this.D.getItem(c.a);v&&(v.menus&&(this.n=v.menus),v.keybindings&&(this.r=v.keybindings))}M(){this.s["workbench.action.files.newUntitledFile"]=(F,B,C)=>{this.lb({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:B?.id})},this.s["workbench.action.newWindow"]=(F,B,C)=>this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:B?.id}),this.s["workbench.action.files.openFileFolder"]=(F,B,C)=>this.H.pickFileFolderAndOpen(void 0,{forceNewWindow:this.eb(C),telemetryExtraData:{from:s}}),this.s["workbench.action.files.openFolder"]=(F,B,C)=>this.H.pickFolderAndOpen(void 0,{forceNewWindow:this.eb(C),telemetryExtraData:{from:s}}),this.s["workbench.action.openWorkspace"]=(F,B,C)=>this.H.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.eb(C),telemetryExtraData:{from:s}}),this.s["workbench.action.clearRecentFiles"]=()=>this.C.clearRecentlyOpened({confirm:!0});const v=this.I.youTubeUrl;v&&(this.s["workbench.action.openYouTubeUrl"]=()=>this.ob(v,"openYouTubeUrl"));const R=this.I.requestFeatureUrl;R&&(this.s["workbench.action.openRequestFeatureUrl"]=()=>this.ob(R,"openUserVoiceUrl"));const T=this.I.reportIssueUrl;T&&(this.s["workbench.action.openIssueReporter"]=()=>this.ob(T,"openReportIssues"));const L=this.I.licenseUrl;L&&(this.s["workbench.action.openLicenseUrl"]=()=>{if(A.$w){const F=L.indexOf("?")>0?"&":"?";this.ob(`${L}${F}lang=${A.$w}`,"openLicenseUrl")}else this.ob(L,"openLicenseUrl")});const O=this.I.privacyStatementUrl;O&&L&&(this.s["workbench.action.openPrivacyStatementUrl"]=()=>{this.ob(O,"openPrivacyStatement")})}N(){this.B(this.F.onWillShutdown(()=>this.b=!0)),this.B(this.w.onDidChangeWindowsCount(v=>this.S(v))),this.B(this.H.onDidBlurMainWindow(()=>this.U())),this.B(this.H.onDidFocusMainWindow(()=>this.U()))}get O(){const v=this.u.getValue("window.enableMenuBarMnemonics");return typeof v!="boolean"?!0:v}get P(){if(!A.$j)return!1;const v=this.u.getValue("window.nativeTabs");return typeof v!="boolean"?!1:v}updateMenu(v,R){this.n=v.menus,this.r=v.keybindings,this.D.setItem(c.a,v),this.Q()}Q(){this.h.schedule()}R(){this.b||setTimeout(()=>{this.b||this.W()},10)}S(v){A.$j&&(v.oldCount===0&&v.newCount>0||v.oldCount>0&&v.newCount===0)&&(this.f=v.newCount===0,this.Q())}U(){if(!A.$j)return;const v=n.BrowserWindow.getFocusedWindow();this.g=!v||!!this.J.getWindowByWebContents(v.webContents),this.Q()}W(){const v=n.Menu.getApplicationMenu();if(v&&this.m.push(v),Object.keys(this.n).length===0){this.X(A.$j?new n.Menu:null);return}const R=new n.Menu;let T;if(A.$j){const O=new n.Menu;T=new n.MenuItem({label:this.I.nameShort,submenu:O}),this.Y(O),R.append(T)}if(A.$j&&!this.c){this.c=!0;const O=new n.Menu;O.append(new n.MenuItem({label:this.qb(b.localize(0,null)),click:()=>this.w.openEmptyWindow({context:t.OpenContext.DOCK})})),n.app.dock.setMenu(O)}if(this.$("File")){const O=new n.Menu,F=new n.MenuItem({label:this.qb(b.localize(1,null)),submenu:O});this.bb(O,"File"),R.append(F)}if(this.$("Edit")){const O=new n.Menu,F=new n.MenuItem({label:this.qb(b.localize(2,null)),submenu:O});this.bb(O,"Edit"),R.append(F)}if(this.$("Selection")){const O=new n.Menu,F=new n.MenuItem({label:this.qb(b.localize(3,null)),submenu:O});this.bb(O,"Selection"),R.append(F)}if(this.$("View")){const O=new n.Menu,F=new n.MenuItem({label:this.qb(b.localize(4,null)),submenu:O});this.bb(O,"View"),R.append(F)}if(this.$("Go")){const O=new n.Menu,F=new n.MenuItem({label:this.qb(b.localize(5,null)),submenu:O});this.bb(O,"Go"),R.append(F)}if(this.$("Run")){const O=new n.Menu,F=new n.MenuItem({label:this.qb(b.localize(6,null)),submenu:O});this.bb(O,"Run"),R.append(F)}if(this.$("Terminal")){const O=new n.Menu,F=new n.MenuItem({label:this.qb(b.localize(7,null)),submenu:O});this.bb(O,"Terminal"),R.append(F)}let L;if(this.$("Window")){const O=new n.Menu;L=new n.MenuItem({label:this.qb(b.localize(8,null)),submenu:O,role:"window"}),this.hb(O)}if(L&&R.append(L),this.$("Help")){const O=new n.Menu,F=new n.MenuItem({label:this.qb(b.localize(9,null)),submenu:O,role:"help"});this.bb(O,"Help"),R.append(F)}R.items&&R.items.length>0?this.X(R):this.X(null),this.j.schedule()}X(v){if(n.Menu.setApplicationMenu(v),v)for(const R of this.J.getWindows())R.win?.setMenu(null)}Y(v){const R=this.jb(b.localize(10,null,this.I.nameLong),"workbench.action.showAboutDialog"),T=this.ib();let L;if(this.$("Preferences")){const le=new n.Menu;this.bb(le,"Preferences"),L=new n.MenuItem({label:this.qb(b.localize(11,null)),submenu:le})}const O=new n.Menu,F=new n.MenuItem({label:b.localize(12,null),role:"services",submenu:O}),B=new n.MenuItem({label:b.localize(13,null,this.I.nameLong),role:"hide",accelerator:"Command+H"}),C=new n.MenuItem({label:b.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new n.MenuItem({label:b.localize(15,null),role:"unhide"}),re=new n.MenuItem(this.nb("workbench.action.quit",{label:b.localize(16,null,this.I.nameLong),click:async(le,K,ee)=>{const q=this.w.getLastActiveWindow();(this.w.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||q?.win?.isMinimized())&&await this.Z(ee)&&this.H.quit(void 0)}})),Q=[R];Q.push(...T),L&&Q.push(l(),L),Q.push(l(),F,l(),B,C,z,l(),re),Q.forEach(le=>v.append(le))}async Z(v){if(this.w.getWindowCount()===0)return!0;const R=this.u.getValue("window.confirmBeforeClose");if(R==="always"||R==="keyboardOnly"&&this.fb(v)){const{response:T}=await this.H.showMessageBox(this.w.getFocusedWindow()?.id,{type:"question",buttons:[b.localize(17,null),b.localize(18,null)],message:b.localize(19,null)});return T===0}return!0}$(v){if(!A.$j&&!(0,k.$5D)(this.u))return!1;switch(v){case"File":case"Help":if(A.$j)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n&&!!this.n[v];case"Window":if(A.$j)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n;default:return this.w.getWindowCount()>0&&!!this.n&&!!this.n[v]}}ab(v,R){R.forEach(T=>{if((0,h.$Qfc)(T))v.append(l());else if((0,h.$Pfc)(T)){const L=new n.Menu,O=new n.MenuItem({label:this.qb(T.label),submenu:L});this.ab(L,T.submenu.items),v.append(O)}else(0,h.$Rfc)(T)?v.append(this.db(T)):(0,h.$Sfc)(T)&&(T.id==="workbench.action.showAboutDialog"&&this.cb(v),A.$j?this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g?this.s[T.id]?v.append(new n.MenuItem(this.nb(T.id,{label:this.qb(T.label),click:this.s[T.id]}))):v.append(this.jb(T.label,T.id,!1,T.checked)):v.append(this.jb(T.label,T.id,T.enabled!==!1,!!T.checked)):v.append(this.jb(T.label,T.id,T.enabled!==!1,!!T.checked)))})}bb(v,R){this.n&&this.n[R]&&this.ab(v,this.n[R].items)}cb(v){const R=this.ib();R.length&&(R.forEach(T=>v.append(T)),v.append(l()))}db(v){const R=I.URI.revive(v.uri),T=v.id,L=T==="openRecentFile"?{fileUri:R}:T==="openRecentWorkspace"?{workspaceUri:R}:{folderUri:R};return new n.MenuItem(this.nb(T,{label:v.label,click:async(O,F,B)=>{const C=this.eb(B);(await this.w.open({context:t.OpenContext.MENU,cli:this.y.args,urisToOpen:[L],forceNewWindow:C,gotoLineMode:!1,remoteAuthority:v.remoteAuthority})).length>0||await this.C.removeRecentlyOpened([R])}},!1))}eb(v){return!!(v&&(!A.$j&&(v.ctrlKey||v.shiftKey)||A.$j&&(v.metaKey||v.altKey)))}fb(v){return!!(v.triggeredByAccelerator||v.altKey||v.ctrlKey||v.metaKey||v.shiftKey)}gb(v,R,T){const L={label:this.qb(v),role:T,enabled:!0};return new n.MenuItem(this.mb(R,L))}hb(v){const R=new n.MenuItem({label:b.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.w.getWindowCount()>0}),T=new n.MenuItem({label:b.localize(21,null),role:"zoom",enabled:this.w.getWindowCount()>0}),L=new n.MenuItem({label:b.localize(22,null),role:"front",enabled:this.w.getWindowCount()>0}),O=this.jb(b.localize(23,null),"workbench.action.switchWindow"),F=[];this.P&&(F.push(l()),F.push(this.jb(b.localize(24,null),"workbench.action.newWindowTab")),F.push(this.gb(b.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),F.push(this.gb(b.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),F.push(this.gb(b.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),F.push(this.gb(b.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[R,T,l(),O,...F,l(),L].forEach(B=>v.append(B))}ib(){switch(this.t.state.type){case E.StateType.Idle:return[new n.MenuItem({label:this.qb(b.localize(29,null)),click:()=>setTimeout(()=>{this.pb("CheckForUpdate"),this.t.checkForUpdates(!0)},0)})];case E.StateType.CheckingForUpdates:return[new n.MenuItem({label:b.localize(30,null),enabled:!1})];case E.StateType.AvailableForDownload:return[new n.MenuItem({label:this.qb(b.localize(31,null)),click:()=>{this.t.downloadUpdate()}})];case E.StateType.Downloading:return[new n.MenuItem({label:b.localize(32,null),enabled:!1})];case E.StateType.Downloaded:return A.$j?[]:[new n.MenuItem({label:this.qb(b.localize(33,null)),click:()=>{this.pb("InstallUpdate"),this.t.applyUpdate()}})];case E.StateType.Updating:return[new n.MenuItem({label:b.localize(34,null),enabled:!1})];case E.StateType.Ready:return[new n.MenuItem({label:this.qb(b.localize(35,null)),click:()=>{this.pb("RestartToUpdate"),this.t.quitAndInstall()}})];default:return[]}}jb(v,R,T,L){const O=this.qb(v),F=typeof R=="function"?R:(Q,le,K)=>{const ee=Q?Q.userSettingsLabel:null;let q=R;Array.isArray(R)&&(q=this.eb(K)?R[1]:R[0]),ee&&K.triggeredByAccelerator?this.lb({type:"keybinding",userSettingsLabel:ee}):this.lb({type:"commandId",commandId:q})},B=typeof T=="boolean"?T:this.w.getWindowCount()>0,C=typeof L=="boolean"?L:!1,z={label:O,click:F,enabled:B};C&&(z.type="checkbox",z.checked=C);let re;return typeof R=="string"?re=R:Array.isArray(R)&&(re=R[0]),A.$j&&(re==="editor.action.clipboardCutAction"?z.role="cut":re==="editor.action.clipboardCopyAction"?z.role="copy":re==="editor.action.clipboardPasteAction"&&(z.role="paste"),re==="undo"?z.click=this.kb(F,{inDevTools:Q=>Q.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?z.click=this.kb(F,{inDevTools:Q=>Q.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(z.click=this.kb(F,{inDevTools:Q=>Q.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.mb(re,z))}kb(v,R){return(T,L,O)=>{const F=n.BrowserWindow.getFocusedWindow();if(!F)return R.inNoWindow();if(F.webContents.isDevToolsFocused()&&F.webContents.devToolsWebContents)return R.inDevTools(F.webContents.devToolsWebContents);v(T,L||F,O)}}lb(v){let R=n.BrowserWindow.getFocusedWindow();if(R){const L=this.J.getWindowByWebContents(R.webContents);L&&(R=this.w.getWindowById(L.parentId)?.win??null)}if(!R){const L=this.w.getLastActiveWindow();L?.win?.isMinimized()&&(R=L.win)}const T=R?this.w.getWindowById(R.id):void 0;if(T){if(this.G.trace("menubar#runActionInRenderer",v),A.$j&&!this.y.isBuilt&&!T.isReady&&(v.type==="commandId"&&v.commandId==="workbench.action.toggleDevTools"||v.type!=="commandId"&&v.userSettingsLabel==="alt+cmd+i"))return!1;if(v.type==="commandId"){const L={id:v.commandId,from:"menu"};T.sendWhenReady("vscode:runAction",P.CancellationToken.None,L)}else{const L={userSettingsLabel:v.userSettingsLabel};T.sendWhenReady("vscode:runKeybinding",P.CancellationToken.None,L)}return!0}else return this.G.trace("menubar#runActionInRenderer: no active window found",v),!1}mb(v,R){const T=typeof v=="string"?this.r[v]:void 0;if(T?.label){if(T.isNative!==!1)R.accelerator=T.label,R.userSettingsLabel=T.userSettingsLabel;else if(typeof R.label=="string"){const L=R.label.indexOf("[");L>=0?R.label=`${R.label.substr(0,L)} [${T.label}]`:R.label=`${R.label} [${T.label}]`}}else R.accelerator=void 0;return R}nb(v,R,T=!R.accelerator){T&&(R=this.mb(v,R));const L=R.click;return R.click=(O,F,B)=>{this.pb(v),L?.(O,F,B)},R}ob(v,R){this.H.openExternal(void 0,v),this.pb(R)}pb(v){this.z.publicLog2("workbenchActionExecuted",{id:v,from:s})}qb(v){return(0,D.$2w)(v,!this.O)}};e.$Vfc=u,e.$Vfc=u=c=Pe([ne(0,E.$EY),ne(1,f.$_i),ne(2,t.$Uec),ne(3,d.$Jec),ne(4,m.$$l),ne(5,r.$Tfc),ne(6,$.$gR),ne(7,g.$bfc),ne(8,w.$_j),ne(9,p.$Gfc),ne(10,y.$sk),ne(11,a.$Ffc)],u);function l(){return new n.MenuItem({type:"separator"})}}),define(oe[315],ae([0,1,6,20,5,314,2]),function(x,e,n,o,P,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=void 0,e.$Wfc=(0,n.$Fi)("menubarMainService");let I=class extends A.$Wc{constructor(a,f,d){super(),this.b=a,this.c=f,this.f=d,this.a=this.g()}async g(){return await this.c.when(o.LifecycleMainPhase.AfterWindowOpen),this.B(this.b.createInstance(D.$Vfc))}async updateMenubar(a,f){this.f.trace("menubarService#updateMenubar",a),(await this.a).updateMenu(f,a)}};e.$Xfc=I,e.$Xfc=I=Pe([ne(0,n.$Ei),ne(1,o.$bfc),ne(2,P.$_j)],I)});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[316],ae([0,1,14,21,107,27,22,23,39,4,31,48,2,12,10,71,3,37,19,13,7,198,70,18,53,24,15,6,20,5,73,74,75,34,51,137,29,135,307,30,104,89,60,52,77,40,59,72,85]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m,E,k,t,r,i,c,s,u,l,S,v,R,T,L,O,F,B,C,z,re,Q,le,K,ee,q,j,U,V,ce,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0,R=et(R);function he(M){return(0,Q.$Ui)(M?.workspace)}function se(M){return(0,Q.$Pi)(M?.workspace)}let _=class extends g.$Wc{constructor(N,W,H,J,X,Z,ie,de,me,we,Oe,Se,ke,Ie,$e,Y,ue,fe,be,Re,We){super(),this.s=N,this.t=W,this.u=H,this.w=J,this.z=X,this.C=Z,this.D=ie,this.F=de,this.G=me,this.H=we,this.I=Oe,this.J=Se,this.L=ke,this.M=Ie,this.N=$e,this.O=Y,this.P=ue,this.Q=fe,this.R=be,this.S=Re,this.U=We,this.a=this.B(new a.$me),this.onDidOpenWindow=this.a.event,this.b=this.B(new a.$me),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new a.$me),this.onDidDestroyWindow=this.c.event,this.f=this.B(new a.$me),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new a.$me),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new a.$me),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new a.$me),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new a.$me),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new re.$igc(this,this.D,this.I,this.z,this.L)),this.W()}W(){this.B(this.N.onDidEnterWorkspace(N=>this.b.fire(N.window))),this.B(this.onDidSignalReadyWindow(N=>{if(N.config?.extensionDevelopmentPath||N.config?.extensionTestsPath){const W=new g.$Vc;if(W.add(a.Event.any(N.onDidClose,N.onDidDestroy)(()=>W.dispose())),N.config.extensionDevelopmentPath)for(const H of N.config.extensionDevelopmentPath)W.add(this.R.addValidFileRoot(H));N.config.extensionTestsPath&&W.add(this.R.addValidFileRoot(N.config.extensionTestsPath))}}))}openEmptyWindow(N,W){const H=this.G.args,J=W?.remoteAuthority||void 0,X=!0,Z=W?.forceReuseWindow,ie=!Z;return this.open({...N,cli:H,forceEmpty:X,forceNewWindow:ie,forceReuseWindow:Z,remoteAuthority:J,forceTempProfile:W?.forceTempProfile,forceProfile:W?.forceProfile})}openExistingWindow(N,W){N.focus(),this.X(W,[N])}async open(N){this.z.trace("windowsManager#open"),N.addMode&&(N.initialStartup||!this.getLastActiveWindow())&&(N.addMode=!1);const W=[],H=[],J=[],X=[],Z=[];let ie,de=0;const me=await this.db(N);this.z.trace("windowsManager#open pathsToOpen",me);for(const Ie of me)se(Ie)?N.addMode?W.push(Ie):H.push(Ie):he(Ie)?J.push(Ie):Ie.fileUri?(ie||(ie={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ie.remoteAuthority}),ie.filesToOpenOrCreate.push(Ie)):Ie.backupPath?Z.push({backupFolder:(0,h.$pc)(Ie.backupPath),remoteAuthority:Ie.remoteAuthority}):de++;N.diffMode&&ie&&ie.filesToOpenOrCreate.length>=2&&(ie.filesToDiff=ie.filesToOpenOrCreate.slice(0,2),ie.filesToOpenOrCreate=[]),N.mergeMode&&ie&&ie.filesToOpenOrCreate.length===4&&(ie.filesToMerge=ie.filesToOpenOrCreate.slice(0,4),ie.filesToOpenOrCreate=[],ie.filesToDiff=[]),ie&&N.waitMarkerFileURI&&(ie.filesToWait={paths:(0,A.$Jb)([...ie.filesToDiff,ie.filesToMerge[3],...ie.filesToOpenOrCreate]),waitMarkerFileUri:N.waitMarkerFileURI}),N.initialStartup?(X.push(...this.N.getUntitledWorkspaces()),J.push(...X),Z.push(...this.J.getEmptyWindowBackups())):Z.length=0;const{windows:we,filesOpenedInWindow:Oe}=await this.Y(N,J,H,Z,de,ie,W);if(this.z.trace(`windowsManager#open used window count ${we.length} (workspacesToOpen: ${J.length}, foldersToOpen: ${H.length}, emptyToRestore: ${Z.length}, emptyToOpen: ${de})`),we.length>1)if(Oe)Oe.focus();else{const Ie=this.r.state.lastActiveWindow&&!N.forceEmpty&&!N.cli._.length&&!N.cli["file-uri"]&&!N.cli["folder-uri"]&&!(N.urisToOpen&&N.urisToOpen.length);let $e=!0,Y=!0;if(Ie){const ue=we.filter(fe=>this.r.state.lastActiveWindow&&fe.backupPath===this.r.state.lastActiveWindow.backupPath);ue.length&&(ue[0].focus(),$e=!1,Y=!1)}if($e)for(let ue=we.length-1;ue>=0;ue--){const fe=we[ue];if(!(fe.openedWorkspace&&X.some(be=>fe.openedWorkspace&&be.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&Z.some(be=>fe.backupPath&&be.backupFolder===(0,h.$pc)(fe.backupPath)))){fe.focus(),Y=!1;break}}Y&&we[we.length-1].focus()}const Se=ie&&ie.filesToDiff.length>0,ke=ie&&ie.filesToMerge.length>0;if(!we.some(Ie=>Ie.isExtensionDevelopmentHost)&&!Se&&!ke&&!N.noRecentEntry){const Ie=[];for(const $e of me)he($e)&&!$e.transient?Ie.push({label:$e.label,workspace:$e.workspace,remoteAuthority:$e.remoteAuthority}):se($e)?Ie.push({label:$e.label,folderUri:$e.workspace.uri,remoteAuthority:$e.remoteAuthority}):$e.fileUri&&Ie.push({label:$e.label,fileUri:$e.fileUri,remoteAuthority:$e.remoteAuthority});this.M.addRecentlyOpened(Ie)}return this.X(N,we),we}X(N,W){const H=N.waitMarkerFileURI;N.context===C.OpenContext.CLI&&H&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.Q.del(H)}catch{}})()}async Y(N,W,H,J,X,Z,ie){const de=[];let me;function we(ue,fe){de.push(ue),fe&&(me=ue,Z=void 0)}let{openFolderInNewWindow:Oe,openFilesInNewWindow:Se}=this.pb(N);if(!N.initialStartup&&ie.length>0){const ue=ie[0].remoteAuthority,fe=this.vb(ue);fe&&we(this.ab(fe,ie.map(be=>be.workspace.uri)))}const ke=H.length+W.length+J.length;if(Z&&ke===0){const ue=Z.filesToOpenOrCreate[0]||Z.filesToDiff[0]||Z.filesToMerge[3],fe=this.getWindows().filter(Re=>Z&&(0,m.$lh)(Re.remoteAuthority,Z.remoteAuthority));let be;ue?.fileUri&&!Se&&((N.context===C.OpenContext.DESKTOP||N.context===C.OpenContext.CLI||N.context===C.OpenContext.DOCK)&&(be=await(0,z.$Zec)(fe,ue.fileUri,async Re=>Re.configPath.scheme===w.Schemas.file?this.N.resolveLocalWorkspace(Re.configPath):void 0)),be||(be=this.wb(fe))),be?(0,Q.$Ui)(be.openedWorkspace)?W.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,Q.$Pi)(be.openedWorkspace)?H.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):we(this.Z(N,be,Z),!0):we(await this.qb({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,filesToOpen:Z,forceNewWindow:!0,remoteAuthority:Z.remoteAuthority,forceNewTabbedWindow:N.forceNewTabbedWindow,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile}),!0)}const Ie=(0,A.$Ob)(W,ue=>ue.workspace.id);if(Ie.length>0){const ue=(0,A.$Jb)(Ie.map(fe=>(0,z.$1ec)(this.getWindows(),fe.workspace.configPath)));if(ue.length>0){const fe=ue[0],be=(0,m.$lh)(Z?.remoteAuthority,fe.remoteAuthority)?Z:void 0;we(this.Z(N,fe,be),!!be),Oe=!0}for(const fe of Ie){if(ue.some(We=>We.openedWorkspace&&We.openedWorkspace.id===fe.workspace.id))continue;const be=fe.remoteAuthority,Re=(0,m.$lh)(Z?.remoteAuthority,be)?Z:void 0;we(await this.cb(N,fe,Oe,Re),!!Re),Oe=!0}}const $e=(0,A.$Ob)(H,ue=>m.$0g.getComparisonKey(ue.workspace.uri));if($e.length>0){const ue=(0,A.$Jb)($e.map(fe=>(0,z.$1ec)(this.getWindows(),fe.workspace.uri)));if(ue.length>0){const fe=ue[0],be=(0,m.$lh)(Z?.remoteAuthority,fe.remoteAuthority)?Z:void 0;we(this.Z(N,fe,be),!!be),Oe=!0}for(const fe of $e){if(ue.some(We=>(0,Q.$Pi)(We.openedWorkspace)&&m.$0g.isEqual(We.openedWorkspace.uri,fe.workspace.uri)))continue;const be=fe.remoteAuthority,Re=(0,m.$lh)(Z?.remoteAuthority,be)?Z:void 0;we(await this.cb(N,fe,Oe,Re),!!Re),Oe=!0}}const Y=(0,A.$Ob)(J,ue=>ue.backupFolder);if(Y.length>0)for(const ue of Y){const fe=ue.remoteAuthority,be=(0,m.$lh)(Z?.remoteAuthority,fe)?Z:void 0;we(await this.bb(N,!0,fe,be,ue),!!be),Oe=!0}if(de.length===0||Z){Z&&!X&&X++;const ue=Z?Z.remoteAuthority:N.remoteAuthority;for(let fe=0;fe<X;fe++)we(await this.bb(N,Oe,ue,Z),!!Z),Oe=!0}return{windows:(0,A.$Ob)(de),filesOpenedInWindow:me}}Z(N,W,H){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:H}),this.$(W);const J={filesToOpenOrCreate:H?.filesToOpenOrCreate,filesToDiff:H?.filesToDiff,filesToMerge:H?.filesToMerge,filesToWait:H?.filesToWait,termProgram:N?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",I.CancellationToken.None,J),W}$(N){let W=N;const H=n.BrowserWindow.getFocusedWindow();if(H&&H.id!==N.id){const J=this.U.getWindowByWebContents(H.webContents);J&&J.parentId===N.id&&(W=J)}W.focus()}ab(N,W){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),N.focus();const H={foldersToAdd:W};return N.sendWhenReady("vscode:addFolders",I.CancellationToken.None,H),N}bb(N,W,H,J,X){this.z.trace("windowsManager#doOpenEmpty",{restore:!!X,remoteAuthority:H,filesToOpen:J,forceNewWindow:W});let Z;return!W&&typeof N.contextWindowId=="number"&&(Z=this.getWindowById(N.contextWindowId)),this.qb({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:H,forceNewWindow:W,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:J,windowToUse:Z,emptyWindowBackupInfo:X,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}cb(N,W,H,J,X){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:J}),!H&&!X&&typeof N.contextWindowId=="number"&&(X=this.getWindowById(N.contextWindowId)),this.qb({workspace:W.workspace,userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:H,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:J,windowToUse:X,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}async db(N){let W,H=!1,J=!1;if(N.urisToOpen&&N.urisToOpen.length>0?(W=await this.eb(N),H=!0):N.forceEmpty?W=[Object.create(null)]:N.cli._.length||N.cli["folder-uri"]||N.cli["file-uri"]?(W=await this.fb(N.cli),W.length===0&&W.push(Object.create(null)),H=!0):(W=await this.hb(),W.length===0&&W.push(Object.create(null)),J=!0),!N.addMode&&H){const X=W.filter(Z=>se(Z));if(X.length>1){const Z=X[0].remoteAuthority;if(X.every(ie=>(0,m.$lh)(ie.remoteAuthority,Z))){const ie=await this.N.createUntitledWorkspace(X.map(de=>({uri:de.workspace.uri})));W.push({workspace:ie,remoteAuthority:Z}),W=W.filter(de=>!se(de))}}}if(N.initialStartup&&!J&&this.L.getValue("window")?.restoreWindows==="preserve"){const X=await this.hb();W.unshift(...X.filter(Z=>he(Z)||se(Z)||Z.backupPath))}return W}async eb(N){const W={gotoLineMode:N.gotoLineMode,remoteAuthority:N.remoteAuthority},H=await Promise.all((0,A.$Jb)(N.urisToOpen||[]).map(async J=>{const X=await this.jb(J,W);if(X)return X.label=J.label,X;const Z=this.lb(J);this.P.showMessageBox({type:"info",buttons:[(0,t.localize)(0,null)],message:Z.scheme===w.Schemas.file?(0,t.localize)(1,null):(0,t.localize)(2,null),detail:Z.scheme===w.Schemas.file?(0,t.localize)(3,null,(0,d.$Vw)(Z,{os:y.OS,tildify:this.G})):(0,t.localize)(4,null,Z.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,A.$Jb)(H)}async fb(N){const W=[],H={ignoreFileNotFound:!0,gotoLineMode:N.goto,remoteAuthority:N.remote||void 0,forceOpenWorkspaceAsFile:N.diff&&N._.length===2||N.merge&&N._.length===4},J=N["folder-uri"];if(J){const ie=await Promise.all(J.map(de=>{const me=this.gb(de);if(me)return this.jb({folderUri:me},H)}));W.push(...(0,A.$Jb)(ie))}const X=N["file-uri"];if(X){const ie=await Promise.all(X.map(de=>{const me=this.gb(de);if(me)return this.jb((0,Q.$$i)(de)?{workspaceUri:me}:{fileUri:me},H)}));W.push(...(0,A.$Jb)(ie))}const Z=await Promise.all(N._.map(ie=>H.remoteAuthority?this.ob(ie,H):this.mb(ie,H)));return W.push(...(0,A.$Jb)(Z)),W}gb(N){try{const W=k.URI.parse(N);if(!W.scheme){this.z.error(`Invalid URI input string, scheme missing: ${N}`);return}return W.path?W:W.with({path:"/"})}catch(W){this.z.error(`Invalid URI input string: ${N}, ${W.message}`)}}async hb(){const N=this.ib();switch(N){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];N!=="one"&&W.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&W.push(this.r.state.lastActiveWindow);const H=await Promise.all(W.map(async J=>{if(J.workspace){const X=await this.jb({workspaceUri:J.workspace.configPath},{remoteAuthority:J.remoteAuthority,rejectTransientWorkspaces:!0});if(he(X))return X}else if(J.folderUri){const X=await this.jb({folderUri:J.folderUri},{remoteAuthority:J.remoteAuthority});if(se(X))return X}else if(N!=="folders"&&J.backupPath)return{backupPath:J.backupPath,remoteAuthority:J.remoteAuthority}}));return(0,A.$Jb)(H)}}}ib(){let N;return this.I.wasRestarted?N="all":(N=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(N)||(N="all")),N}async jb(N,W=Object.create(null)){const H=this.lb(N);return H.scheme===w.Schemas.file?((0,F.$2D)(N)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.mb(H.fsPath,W)):this.kb(N,W)}kb(N,W){let H=this.lb(N);const J=(0,L.$gn)(H)||W.remoteAuthority;if(H=(0,m.$nh)((0,m.$hh)(H)),(0,F.$2D)(N)){if(W.gotoLineMode){const{path:X,line:Z,column:ie}=(0,f.$Mg)(H.path);return{fileUri:H.with({path:X}),options:{selection:Z?{startLineNumber:Z,startColumn:ie||1}:void 0},remoteAuthority:J}}return{fileUri:H,remoteAuthority:J}}else if((0,F.$ZD)(N))return{workspace:(0,le.$4ec)(H),remoteAuthority:J};return{workspace:(0,le.$5ec)(H),remoteAuthority:J}}lb(N){return(0,F.$ZD)(N)?N.workspaceUri:(0,F.$1D)(N)?N.folderUri:N.fileUri}async mb(N,W,H){let J,X;W.gotoLineMode&&({path:N,line:J,column:X}=(0,f.$Mg)(N)),N=(0,f.$Gg)((0,h.$jc)(N),(0,$.cwd)());try{const Z=await o.Promises.stat(N);if(Z.isFile()){if(!W.forceOpenWorkspaceAsFile){const ie=await this.N.resolveLocalWorkspace(k.URI.file(N));if(ie)return ie.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:ie.id,configPath:ie.configPath},type:u.FileType.File,exists:!0,remoteAuthority:ie.remoteAuthority,transient:ie.transient}}return{fileUri:k.URI.file(N),type:u.FileType.File,exists:!0,options:{selection:J?{startLineNumber:J,startColumn:X||1}:void 0}}}else{if(Z.isDirectory())return{workspace:(0,le.$5ec)(k.URI.file(N),Z),type:u.FileType.Directory,exists:!0};if(!y.$i&&N==="/dev/null")return{fileUri:k.URI.file(N),type:u.FileType.File,exists:!0}}}catch(Z){if(Z.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!H)return this.nb(N,W);const ie=k.URI.file(N);if(this.M.removeRecentlyOpened([ie]),W.ignoreFileNotFound)return{fileUri:ie,type:u.FileType.File,exists:!1}}}async nb(N,W){const H=k.URI.file(N),{response:J,checkboxChecked:X}=await this.P.showMessageBox({type:"warning",buttons:[(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],message:(0,t.localize)(8,null,H.authority),detail:(0,t.localize)(9,null,(0,d.$Vw)(H,{os:y.OS,tildify:this.G})),checkboxLabel:(0,t.localize)(10,null,H.authority),cancelId:1});if(J===0){if((0,P.addUNCHostToAllowlist)(H.authority),X){const Z={channel:"vscode:configureAllowedUNCHost",args:H.authority};this.sendToFocused(Z.channel,Z.args),this.sendToOpeningWindow(Z.channel,Z.args)}return this.mb(N,W,!0)}if(J===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.nb(N,W)}ob(N,W){const H=N.charCodeAt(0),J=W.remoteAuthority;let X,Z;W.gotoLineMode&&({path:N,line:X,column:Z}=(0,f.$Mg)(N)),H!==b.CharCode.Slash&&((0,f.$Fg)(H)&&N.charCodeAt(N.charCodeAt(1))===b.CharCode.Colon&&(N=(0,f.$yg)(N)),N=`/${N}`);const ie=k.URI.from({scheme:w.Schemas.vscodeRemote,authority:J,path:N});if(N.charCodeAt(N.length-1)!==b.CharCode.Slash){if((0,Q.$$i)(N))return W.forceOpenWorkspaceAsFile?{fileUri:ie,options:{selection:X?{startLineNumber:X,startColumn:Z||1}:void 0},remoteAuthority:W.remoteAuthority}:{workspace:(0,le.$4ec)(ie),remoteAuthority:J};if(W.gotoLineMode||h.$ic.basename(N).indexOf(".")!==-1)return{fileUri:ie,options:{selection:X?{startLineNumber:X,startColumn:Z||1}:void 0},remoteAuthority:J}}return{workspace:(0,le.$5ec)(ie),remoteAuthority:J}}pb(N){const W=this.L.getValue("window"),H=W?.openFoldersInNewWindow||"default",J=W?.openFilesInNewWindow||"off";let X=(N.preferNewWindow||N.forceNewWindow)&&!N.forceReuseWindow;!N.forceNewWindow&&!N.forceReuseWindow&&(H==="on"||H==="off")&&(X=H==="on");let Z=!1;return N.forceNewWindow||N.forceReuseWindow?Z=!!N.forceNewWindow&&!N.forceReuseWindow:(y.$j?N.context===C.OpenContext.DOCK&&(Z=!0):N.context!==C.OpenContext.DIALOG&&N.context!==C.OpenContext.MENU&&!(N.userEnv&&N.userEnv.TERM_PROGRAM==="vscode")&&(Z=!0),!N.cli.extensionDevelopmentPath&&(J==="on"||J==="off")&&(Z=J==="on")),{openFolderInNewWindow:!!X,openFilesInNewWindow:Z}}async openExtensionDevelopmentHostWindow(N,W){const H=(0,z.$2ec)(this.getWindows(),N);if(H)return this.I.reload(H,W.cli),H.focus(),[H];let J=W.cli["folder-uri"]||[],X=W.cli["file-uri"]||[],Z=W.cli._;if(!Z.length&&!J.length&&!X.length&&!W.cli.extensionTestsPath){const me=this.r.state.lastPluginDevelopmentHostWindow,we=me?.workspace??me?.folderUri;we&&(k.URI.isUri(we)?we.scheme===w.Schemas.file?Z=[we.fsPath]:J=[we.toString()]:we.configPath.scheme===w.Schemas.file?Z=[(0,m.$7g)(we.configPath)]:X=[we.configPath.toString()])}let ie=W.remoteAuthority;for(const me of N)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const we=k.URI.parse(me),Oe=(0,L.$gn)(we);Oe&&(ie?(0,m.$lh)(Oe,ie)||this.z.error("more than one extension development path authority"):ie=Oe)}Z=Z.filter(me=>{const we=k.URI.file(me);return(0,z.$1ec)(this.getWindows(),we)?!1:(0,m.$lh)((0,L.$gn)(we),ie)}),J=J.filter(me=>{const we=this.gb(me);return we&&(0,z.$1ec)(this.getWindows(),we)?!1:we?(0,m.$lh)((0,L.$gn)(we),ie):!1}),X=X.filter(me=>{const we=this.gb(me);return we&&(0,z.$1ec)(this.getWindows(),we)?!1:we?(0,m.$lh)((0,L.$gn)(we),ie):!1}),W.cli._=Z,W.cli["folder-uri"]=J,W.cli["file-uri"]=X;const de={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:!Z.length&&!J.length&&!X.length,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:ie,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile};return this.open(de)}async qb(N){const W=this.L.getValue("window"),H=this.getLastActiveWindow(),X=(W?.newWindowProfile?this.H.profiles.find(de=>de.name===W.newWindowProfile):void 0)??H?.profile??this.H.defaultProfile;let Z;!N.forceNewWindow&&!N.forceNewTabbedWindow&&(Z=N.windowToUse||H,Z&&Z.focus());const ie={...this.G.args,...N.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:N.emptyWindowBackupInfo?(0,h.$lc)(this.G.backupHome,N.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:X},homeDir:this.G.userHome.with({scheme:w.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:w.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:N.remoteAuthority,workspace:N.workspace,userEnv:{...this.w,...N.userEnv},filesToOpenOrCreate:N.filesToOpen?.filesToOpenOrCreate,filesToDiff:N.filesToOpen?.filesToDiff,filesToMerge:N.filesToOpen?.filesToMerge,filesToWait:N.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:w.Schemas.file}).fsPath,product:R.default,isInitialStartup:N.initialStartup,perfMarks:(0,p.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)(),arch:(0,D.arch)()},autoDetectHighContrast:W?.autoDetectHighContrast??!0,autoDetectColorScheme:W?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn};if(Z){const de=Z.config;!ie.extensionDevelopmentPath&&de?.extensionDevelopmentPath&&(ie.extensionDevelopmentPath=de.extensionDevelopmentPath,ie.extensionDevelopmentKind=de.extensionDevelopmentKind,ie["enable-proposed-api"]=de["enable-proposed-api"],ie.verbose=de.verbose,ie["inspect-extensions"]=de["inspect-extensions"],ie["inspect-brk-extensions"]=de["inspect-brk-extensions"],ie.debugId=de.debugId,ie.extensionEnvironment=de.extensionEnvironment,ie["extensions-dir"]=de["extensions-dir"],ie["disable-extensions"]=de["disable-extensions"]),ie.loggers={global:ie.loggers.global,window:de?.loggers.window??ie.loggers.window}}else{const de=this.r.getNewWindowState(ie);(0,p.mark)("code/willCreateCodeWindow");const me=Z=this.O.createInstance(B.$_ec,{state:de,extensionDevelopmentPath:ie.extensionDevelopmentPath,isExtensionTestHost:!!ie.extensionTestsPath});(0,p.mark)("code/didCreateCodeWindow"),N.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.n.set(me.id,me),this.a.fire(me),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const we=new g.$Vc;we.add(me.onDidSignalReady(()=>this.b.fire(me))),we.add(a.Event.once(me.onDidClose)(()=>this.tb(me,we))),we.add(a.Event.once(me.onDidDestroy)(()=>this.ub(me))),we.add(me.onDidMaximize(()=>this.g.fire(me))),we.add(me.onDidUnmaximize(()=>this.h.fire(me))),we.add(me.onDidEnterFullScreen(()=>this.j.fire({window:me,fullscreen:!0}))),we.add(me.onDidLeaveFullScreen(()=>this.j.fire({window:me,fullscreen:!1}))),we.add(me.onDidTriggerSystemContextMenu(({x:Se,y:ke})=>this.m.fire({window:me,x:Se,y:ke})));const Oe=(0,E.$qg)(me.win?.webContents);Oe.removeAllListeners("devtools-reload-page"),we.add(a.Event.fromNodeEventEmitter(Oe,"devtools-reload-page")(()=>this.I.reload(me))),this.I.registerWindow(me)}return ie.windowId=Z.id,Z.isReady?this.I.unload(Z,q.UnloadReason.LOAD).then(async de=>{de||await this.rb(Z,ie,N,X)}):await this.rb(Z,ie,N,X),Z}async rb(N,W,H,J){if(W.extensionDevelopmentPath||((0,Q.$Ui)(W.workspace)?W.backupPath=this.J.registerWorkspaceBackup({workspace:W.workspace,remoteAuthority:W.remoteAuthority}):(0,Q.$Pi)(W.workspace)?W.backupPath=this.J.registerFolderBackup({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority}):W.backupPath=this.J.registerEmptyWindowBackup({backupFolder:H.emptyWindowBackupInfo?.backupFolder??(0,le.$6ec)().id,remoteAuthority:W.remoteAuthority})),this.H.isEnabled()){const X=W.workspace??(0,Q.$Ti)(W.backupPath,!1),Z=this.sb(H,X,J),ie=Z instanceof Promise?await Z:Z;W.profiles.profile=ie,W.extensionDevelopmentPath||await this.H.setProfileForWorkspace(X,ie)}N.load(W)}sb(N,W,H){return N.forceProfile?this.H.profiles.find(J=>J.name===N.forceProfile)??this.H.createNamedProfile(N.forceProfile):N.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(W)??H}tb(N,W){this.n.delete(N.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),W.dispose()}ub(N){this.n.delete(N.id),this.c.fire(N)}getFocusedWindow(){const N=n.BrowserWindow.getFocusedWindow();if(N)return this.getWindowById(N.id)}getLastActiveWindow(){return this.wb(this.getWindows())}vb(N){return this.wb(this.getWindows().filter(W=>(0,m.$lh)(W.remoteAuthority,N)))}wb(N){return(0,C.$Wec)(N)}sendToFocused(N,...W){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(N,I.CancellationToken.None,...W)}sendToOpeningWindow(N,...W){this.B(a.Event.once(this.onDidSignalReadyWindow)(H=>{H.sendWhenReady(N,I.CancellationToken.None,...W)}))}sendToAll(N,W,H){for(const J of this.getWindows())H&&H.indexOf(J.id)>=0||J.sendWhenReady(N,I.CancellationToken.None,W)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(N){return this.n.get(N)}getWindowByWebContents(N){const W=n.BrowserWindow.fromWebContents(N);if(!W)return;const H=this.getWindowById(W.id);return H?.matches(N)?H:void 0}};e.$lgc=_,e.$lgc=_=Pe([ne(4,v.$_j),ne(5,ce.$9ec),ne(6,O.$gR),ne(7,U.$so),ne(8,s.$Jec),ne(9,V.$Xec),ne(10,S.$bfc),ne(11,r.$Oec),ne(12,i.$_i),ne(13,K.$Tfc),ne(14,ee.$7ec),ne(15,l.$Ei),ne(16,c.$Pec),ne(17,u.$_k),ne(18,T.$Rec),ne(19,j.$Sec),ne(20,G.$Ffc)],_)}),define(oe[317],ae([0,1,70,29,89,60]),function(x,e,n,o,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;let A=class{constructor(b,a,f,d){this.a=b,this.b=a,this.c=f,this.d=d,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(b,a){const f=this.b.getWindowById(b);if(f)return this.a.enterWorkspace(f,this.b.getWindows(),a)}createUntitledWorkspace(b,a,f){return this.a.createUntitledWorkspace(a,f)}deleteUntitledWorkspace(b,a){return this.a.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(b,a){return this.a.getWorkspaceIdentifier(a)}getRecentlyOpened(b){return this.c.getRecentlyOpened()}addRecentlyOpened(b,a){return this.c.addRecentlyOpened(a)}removeRecentlyOpened(b,a){return this.c.removeRecentlyOpened(a)}clearRecentlyOpened(b){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$ngc=A,e.$ngc=A=Pe([ne(0,D.$7ec),ne(1,o.$Uec),ne(2,P.$Tfc),ne(3,n.$Oec)],A)}),define(oe[318],ae([0,1,14,107,35,27,17,55,16,31,4,322,48,2,12,10,3,13,7,33,163,44,164,119,298,167,70,291,18,299,97,136,53,98,225,24,69,101,213,302,215,216,217,15,229,100,84,6,99,224,308,309,292,300,20,5,315,65,28,75,303,102,34,281,88,129,25,258,259,58,50,271,296,310,297,311,133,273,274,275,278,306,51,29,316,280,30,103,89,317,60,40,238,59,251,57,87,134,283,301,288,8,261,282,233,72,305,277,22,76,304,269,244,66,85,313,79]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m,E,k,t,r,i,c,s,u,l,S,v,R,T,L,O,F,B,C,z,re,Q,le,K,ee,q,j,U,V,ce,G,he,se,_,M,N,W,H,J,X,Z,ie,de,me,we,Oe,Se,ke,Ie,$e,Y,ue,fe,be,Re,We,Fe,Le,Ue,Ve,Ye,He,Ke,Xe,_e,Ne,te,ge,pe,ye,Me,Be,Je,lt,at,rt,tt,ut,ct,ft,gt,Ot,Lt,mt,$t,Tt,jt,Mt,pt,Ft,Et,dt,Nt,Ct,wt,Wt,St,Ut,Pt){"use strict";var bt;Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;let yt=class extends w.$Wc{static{bt=this}static{this.a={[h.Schemas.file]:"security.promptForLocalFileProtocolHandling",[h.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ae,Te,je,ve,Ee,qe,xe,Ge,Ce,Ze,ze,Qe){super(),this.g=Ae,this.h=Te,this.j=je,this.m=ve,this.n=Ee,this.s=qe,this.t=xe,this.u=Ge,this.w=Ce,this.y=Ze,this.z=ze,this.C=Qe,this.D(),this.F()}D(){const Ae=Ce=>Ce?.startsWith(`${h.Schemas.vscodeWebview}://`),Te=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Ce,Ze,ze,Qe)=>Ae(Qe.requestingUrl)?ze(Te.has(Ze)):ze(!1)),n.session.defaultSession.setPermissionCheckHandler((Ce,Ze,ze,Qe)=>Ae(Qe.requestingUrl)?Te.has(Ze):!1);const je=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,h.Schemas.vscodeManagedRemoteResource,"devtools"]),ve=Ce=>{for(let Ze=Ce;Ze;Ze=Ze.parent)if(Ze.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},Ee=Ce=>Ce.resourceType==="xhr"||ve(Ce.frame),qe=Ce=>{const Ze=Ce.frame;if(!Ze||!this.b)return!1;const ze=n.BrowserWindow.getAllWindows();for(const Qe of ze)if(Ze.processId===Qe.webContents.mainFrame.processId)return!0;return!1},xe=(Ce,Ze)=>{if(Ce.path!=="/index.html")return!0;const ze=Ze.frame;if(!ze||!this.b)return!1;for(const Qe of this.b.getWindows())if(Qe.win&&ze.processId===Qe.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Ce,Ze)=>{const ze=m.URI.parse(Ce.url);return ze.scheme===h.Schemas.vscodeWebview&&!xe(ze,Ce)?(this.m.error("Blocked vscode-webview request",Ce.url),Ze({cancel:!0})):ze.scheme===h.Schemas.vscodeFileResource&&!qe(Ce)?(this.m.error("Blocked vscode-file request",Ce.url),Ze({cancel:!0})):ze.path.endsWith(".svg")&&!je.has(ze.scheme)?Ze({cancel:!Ee(Ce)}):Ze({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Ce,Ze)=>{const ze=Ce.responseHeaders,Qe=ze["content-type"]||ze["Content-Type"];if(Qe&&Array.isArray(Qe)){const it=m.URI.parse(Ce.url);if(it.path.endsWith(".svg")&&je.has(it.scheme))return ze["Content-Type"]=["image/svg+xml"],Ze({cancel:!1,responseHeaders:ze});if(!it.path.endsWith(h.Schemas.vscodeRemoteResource)&&Qe.some(ot=>ot.toLowerCase().includes("image/svg")))return Ze({cancel:!Ee(Ce)})}return Ze({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Ce,Ze)=>{if(Ce.url.startsWith("https://vscode.download.prss.microsoft.com/")){const ze=Ce.responseHeaders??Object.create(null);if(ze["Access-Control-Allow-Origin"]===void 0)return ze["Access-Control-Allow-Origin"]=["*"],Ze({cancel:!1,responseHeaders:ze})}return Ze({cancel:!1})});const Ge=n.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.s.codeCachePath&&Ge.setCodeCachePath((0,p.$lc)(this.s.codeCachePath,"chrome")),y.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,o.disableUNCAccessRestrictions)():(0,o.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,b.setUnexpectedErrorHandler)(je=>this.H(je)),process.on("uncaughtException",je=>{(0,b.$2)(je)||(0,b.$3)(je)}),process.on("unhandledRejection",je=>(0,b.$3)(je)),f.Event.once(this.t.onWillShutdown)(()=>this.dispose()),(0,k.$GX)(),n.app.on("accessibility-support-changed",(je,ve)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",ve)}),n.app.on("activate",async(je,ve)=>{this.m.trace("app#activate"),ve||await this.b?.openEmptyWindow({context:Ne.OpenContext.DOCK})}),n.app.on("web-contents-created",(je,ve)=>{ve?.opener?.url.startsWith(`${h.Schemas.vscodeFileResource}://${h.$Yg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(ve)),ve.on("will-navigate",Ee=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ee.preventDefault()}),ve.setWindowOpenHandler(Ee=>Ee.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Ee)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ee.url}}`),this.f?.openExternal(void 0,Ee.url),{action:"deny"}))});let Ae=[],Te;n.app.on("open-file",(je,ve)=>{ve=(0,Pt.$mm)(ve),this.m.trace("app#open-file: ",ve),je.preventDefault(),Ae.push((0,pe.$$i)(ve)?{workspaceUri:m.URI.file(ve)}:{fileUri:m.URI.file(ve)}),Te!==void 0&&(clearTimeout(Te),Te=void 0),Te=setTimeout(async()=>{await this.b?.open({context:Ne.OpenContext.DOCK,cli:this.s.args,urisToOpen:Ae,gotoLineMode:!1,preferNewWindow:!0}),Ae=[],Te=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Ne.OpenContext.DESKTOP})}),P.$FX.handle("vscode:fetchShellEnv",je=>{const ve=this.b?.getWindowByWebContents(je.sender);let Ee,qe;return ve?.config?(Ee=ve.config,qe={...process.env,...ve.config.userEnv}):(Ee=this.s.args,qe=process.env),this.X(Ee,qe,!1)}),P.$FX.handle("vscode:writeNlsFile",(je,ve,Ee)=>{const qe=this.G([ve]);if(!qe||typeof Ee!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(qe,A.$Oe.fromString(Ee))}),P.$FX.handle("vscode:readNlsFile",async(je,...ve)=>{const Ee=this.G(ve);if(!Ee)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ee)).value.toString()}),P.$FX.on("vscode:toggleDevTools",je=>je.sender.toggleDevTools()),P.$FX.on("vscode:openDevTools",je=>je.sender.openDevTools()),P.$FX.on("vscode:reloadWindow",je=>je.sender.reload()),P.$FX.handle("vscode:notifyZoomLevel",async(je,ve)=>{const Ee=this.b?.getWindowByWebContents(je.sender);Ee&&Ee.notifyZoomLevel(ve)})}G(Ae){let Te;for(const je of Ae)typeof je=="string"&&(typeof Te!="string"?Te=je:Te=(0,p.$lc)(Te,je));if(!(typeof Te!="string"||!(0,p.$kc)(Te)||!(0,a.$Eg)(Te,this.s.cachedLanguagesPath,!y.$k)))return m.URI.file(Te)}H(Ae){if(Ae){const Te={message:`[uncaught exception in main]: ${Ae.message}`,stack:Ae.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Te))}this.m.error(`[uncaught exception in main]: ${Ae}`),Ae.stack&&this.m.error(Ae.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ae=this.z.win32AppUserModelId;y.$i&&Ae&&n.app.setAppUserModelId(Ae);try{y.$j&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ze){this.m.error(ze)}const Te=new r.$MX;f.Event.once(this.t.onWillShutdown)(ze=>{ze.reason===W.ShutdownReason.KILL&&Te.dispose()}),this.m.trace("Resolving machine identifier...");const[je,ve,Ee]=await Promise.all([(0,$t.$wgc)(this.w,this.m),(0,$t.$xgc)(this.w,this.m),(0,$t.$ygc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${je}`);const{sharedProcessReady:qe,sharedProcessClient:xe}=this.P(je,ve,Ee),Ge=await this.Q(je,ve,Ee,qe);this.B(Ge.createInstance(c.$lfc)),this.B(Ge.createInstance(Ot.$rgc)),Ge.invokeFunction(ze=>this.R(ze,Te,xe));const Ce=await Ge.invokeFunction(ze=>this.I(ze,Te));this.J(Te),this.t.phase=W.LifecycleMainPhase.Ready,await Ge.invokeFunction(ze=>this.S(ze,Ce)),this.t.phase=W.LifecycleMainPhase.AfterWindowOpen,this.U(),this.B(new mt.$Rh(()=>{this.B((0,mt.$Vh)(()=>this.t.phase=W.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async I(Ae,Te){const je=this.b=Ae.get(Ne.$Uec),ve=Ae.get(Ue.$uY),Ee=this.f=Ae.get(X.$Gfc),qe=Ae.get(L.$Pec),xe=this;ve.registerHandler({async handleURL(it,ot){return xe.O(je,qe,ve,it,ot)}});const Ge=this.B(new ge.$mgc({onDidOpenMainWindow:Ee.onDidOpenMainWindow,onDidFocusMainWindow:Ee.onDidFocusMainWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),Ce=new t.$ni(it=>Ge.getActiveClientId().then(ot=>it===ot)),Ze=new Ve.$dgc(Ce,this.m),ze=Te.getChannel("urlHandler",Ze);ve.registerHandler(new Ve.$cgc(ze));const Qe=await this.L(je,qe);return this.B(new He.$egc(Qe?.urls,ve,je,this.s,this.z,this.m)),Qe}J(Ae){const Te=()=>({statusCode:404,data:"Not found"}),je=new Wt.$X(()=>Ae.getChannel(wt.$Fgc,new wt.$Ggc));n.protocol.registerBufferProtocol(h.Schemas.vscodeManagedRemoteResource,(ve,Ee)=>{const qe=m.URI.parse(ve.url);if(!qe.authority.startsWith("window:"))return Ee(Te());je.value.call(wt.$Egc,[qe]).then(xe=>Ee({...xe,data:Buffer.from(xe.body,"base64")}),xe=>{this.m.warn("error dispatching remote resource call",xe),Ee({statusCode:500,data:String(xe)})})})}async L(Ae,Te){const je=this.s.args["open-url"]?this.s.args._urls||[]:[];je.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",je);const ve=global.getOpenUrls()||[];if(ve.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",ve),je.length+ve.length===0)return;const Ee=[...je,...ve].map(Ge=>{try{return{uri:m.URI.parse(Ge),originalUrl:Ge}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),qe=[],xe=[];for(const Ge of Ee){if(!Ge)continue;const Ce=this.N(Ge.uri);if(Ce)if(await this.M(Ce,Ae,Te)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),Ce),qe.push(Ce);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),xe.push(Ge)}return{urls:xe,openables:qe}}async M(Ae,Te,je){let ve,Ee;if((0,_e.$ZD)(Ae)?(ve=Ae.workspaceUri,Ee=(0,s.localize)(0,null,ve.scheme===h.Schemas.file?(0,g.$Vw)(ve,{os:y.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(0,_e.$1D)(Ae)?(ve=Ae.folderUri,Ee=(0,s.localize)(1,null,ve.scheme===h.Schemas.file?(0,g.$Vw)(ve,{os:y.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(ve=Ae.fileUri,Ee=(0,s.localize)(2,null,ve.scheme===h.Schemas.file?(0,g.$Vw)(ve,{os:y.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)),ve.scheme!==h.Schemas.file&&ve.scheme!==h.Schemas.vscodeRemote||this.u.getValue(bt.a[ve.scheme])===!1)return!1;const{response:xe,checkboxChecked:Ge}=await je.showMessageBox({type:"warning",buttons:[(0,s.localize)(3,null),(0,s.localize)(4,null)],message:Ee,detail:(0,s.localize)(5,null),checkboxLabel:ve.scheme===h.Schemas.file?(0,s.localize)(6,null):(0,s.localize)(7,null),cancelId:1});if(xe!==0)return!0;if(Ge){const Ce={channel:"vscode:disablePromptForProtocolHandling",args:ve.scheme===h.Schemas.file?"local":"remote"};Te.sendToFocused(Ce.channel,Ce.args),Te.sendToOpeningWindow(Ce.channel,Ce.args)}return!1}N(Ae){if(Ae.path){if(Ae.authority===h.Schemas.file){const Te=m.URI.file(Ae.fsPath);return(0,pe.$$i)(Te)?{workspaceUri:Te}:{fileUri:Te}}else if(Ae.authority===h.Schemas.vscodeRemote){const Te=Ae.path.indexOf(p.$ic.sep,1);if(Te!==-1){const je=Ae.path.substring(1,Te),ve=Ae.path.substring(Te);let Ee=Ae.query;const qe=new URLSearchParams(Ae.query);qe.get("windowId")==="_blank"&&(qe.delete("windowId"),Ee=qe.toString());const xe=m.URI.from({scheme:h.Schemas.vscodeRemote,authority:je,path:ve,query:Ee,fragment:Ae.fragment});return(0,pe.$$i)(ve)?{workspaceUri:xe}:/:[\d]+$/.test(ve)?{fileUri:xe}:{folderUri:xe}}}}}async O(Ae,Te,je,ve,Ee){this.m.trace("app#handleProtocolUrl():",ve.toString(!0),Ee),ve.scheme===this.z.urlProtocol&&ve.path==="workspace"&&(ve=ve.with({authority:"file",path:m.URI.parse(ve.query).path,query:""}));let qe=!1;const xe=new URLSearchParams(ve.query);xe.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ve.toString(!0)),xe.delete("windowId"),ve=ve.with({query:xe.toString()}),qe=!0):y.$j&&Ae.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ve.toString(!0)),qe=!0);const Ge=xe.get("continueOn");Ge!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ve.toString(!0)),xe.delete("continueOn"),ve=ve.with({query:xe.toString()}),this.s.continueOn=Ge??void 0);const Ce=this.N(ve);return Ce?await this.M(Ce,Ae,Te)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",ve.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ce,ve.toString(!0)),(0,Et.$Qb)(await Ae.open({context:Ne.OpenContext.API,cli:{...this.s.args},urisToOpen:[Ce],forceNewWindow:qe,gotoLineMode:!0}))?.focus(),!0):qe?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ve.toString(!0)),await(0,Et.$Qb)(await Ae.open({context:Ne.OpenContext.API,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ie.$gn)(ve)}))?.ready(),je.open(ve,Ee)):(this.m.trace("app#handleProtocolUrl(): not handled",ve.toString(!0),Ee),!1)}P(Ae,Te,je){const ve=this.B(this.j.createInstance(de.$2fc,Ae,Te,je));this.B(ve.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const Ee=(async()=>{this.m.trace("Main->SharedProcess#connect");const xe=await ve.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new i.$NX(xe,"main")})();return{sharedProcessReady:(async()=>(await ve.whenReady(),Ee))(),sharedProcessClient:Ee}}async Q(Ae,Te,je,ve){const Ee=new G.$Di;switch(process.platform){case"win32":Ee.set(fe.$EY,new V.$Ci(Le.$agc));break;case"linux":y.$l?Ee.set(fe.$EY,new V.$Ci(Fe.$_fc,[process.env.SNAP,process.env.SNAP_REVISION])):Ee.set(fe.$EY,new V.$Ci(We.$$fc));break;case"darwin":Ee.set(fe.$EY,new V.$Ci(Re.$0fc));break}Ee.set(Ne.$Uec,new V.$Ci(te.$lgc,[Ae,Te,je,this.h],!1)),Ee.set(St.$Ffc,new V.$Ci(Ut.$Hgc,void 0,!1));const qe=new L.$Qec(this.m,this.z);Ee.set(L.$Pec,qe),Ee.set(N.$Nfc,new V.$Ci(N.$Ofc,void 0,!1)),Ee.set(T.$rfc,new V.$Ci(T.$sfc,void 0,!1)),Ee.set(R.$Sm,t.ProxyChannel.toService((0,t.$li)(ve.then(ze=>ze.getChannel("diagnostics"))))),Ee.set(he.$e_b,new V.$Ci(se.$Ifc,[this.h])),Ee.set(he.$f_b,new V.$Ci(_.$Jfc,[this.h])),Ee.set(O.$oY,new V.$Ci(F.$tfc)),Ee.set(M.$Kfc,new V.$Ci(M.$Lfc)),Ee.set(X.$Gfc,new V.$Ci(X.$Hfc,void 0,!1)),Ee.set(Ke.$fgc,new V.$Ci(Xe.$hgc)),Ee.set(J.$Wfc,new V.$Ci(J.$Xfc)),Ee.set(re.$ufc,new V.$Ci(Q.$wfc)),Ee.set(Se.$hfc,new V.$Ci(Se.$ifc)),Ee.set(Se.$jfc,new V.$Ci(Se.$kfc));const xe=new Nt.$Dgc({graceTime:dt.LocalReconnectConstants.GraceTime,shortGraceTime:dt.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(dt.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Ge=new Ct.$Ns(xe,this.u,this.m,this.n);Ee.set(dt.$os,Ge),y.$i?Ee.set(le.$xfc,new V.$Ci(K.$yfc)):y.$j?Ee.set(le.$xfc,new V.$Ci(K.$zfc)):y.$k&&Ee.set(le.$xfc,new V.$Ci(K.$Afc));const Ce=new l.$mfc(this.s,this.u,this.m,this.w);Ee.set(u.$Oec,Ce);const Ze=new Je.$8ec(this.s,this.m,this.C,Ce,qe);if(Ee.set(Je.$7ec,Ze),Ee.set(ye.$Xhb,new V.$Ci(Be.$ngc,void 0,!1)),Ee.set(Me.$Tfc,new V.$Ci(Me.$Ufc,void 0,!1)),Ee.set(Ue.$uY,new V.$Ci(Ye.$wY,void 0,!1)),(0,ue.$Bp)(this.z,this.s)){const ze=(0,ue.$Gp)(this.z,this.u),Qe=(0,t.$li)(ve.then(vt=>vt.getChannel("telemetryAppender"))),it=new $e.$5fc(Qe),ot=(0,ke.$sp)((0,D.release)(),(0,D.hostname)(),process.arch,this.z.commit,this.z.version,Ae,Te,je,ze),nt=(0,ue.$Hp)(this.s),ht={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};Ee.set(Ie.$$l,new V.$Ci(Y.$es,[ht],!1))}else Ee.set(Ie.$$l,ue.$wp);return Ee.set(ct.$Gq,new V.$Ci(Tt.$nR,void 0,!0)),Ee.set(ft.$Kq,new V.$Ci(gt.$qgc,void 0,!0)),Ee.set(pt.$Bgc,new V.$Ci(pt.$Cgc,void 0,!0)),await mt.Promises.settled([Ce.initialize(),Ze.initialize()]),this.j.createChild(Ee)}R(Ae,Te,je){const ve=this.B(new w.$Vc),Ee=t.ProxyChannel.fromService(Ae.get(N.$Nfc),ve,{disableMarshalling:!0});this.g.registerChannel("launch",Ee);const qe=t.ProxyChannel.fromService(Ae.get(T.$rfc),ve,{disableMarshalling:!0});this.g.registerChannel("diagnostics",qe);const xe=ve.add(new at.$ogc(Ae.get(lt.$so)));Te.registerChannel("policy",xe),je.then(st=>st.registerChannel("policy",xe));const Ge=this.y.getProvider(h.Schemas.file);(0,$.$pg)(Ge instanceof U.$qr);const Ce=ve.add(new j.$Bfc(Ge,this.m,this.s));Te.registerChannel(ee.$9Q,Ce),je.then(st=>st.registerChannel(ee.$9Q,Ce));const Ze=t.ProxyChannel.fromService(Ae.get(rt.$Xec),ve);Te.registerChannel("userDataProfiles",Ze),je.then(st=>st.registerChannel("userDataProfiles",Ze));const ze=new tt.$_r(Ae.get(ut.$5p));je.then(st=>st.registerChannel("request",ze));const Qe=new be.$6fc(Ae.get(fe.$EY));Te.registerChannel("update",Qe);const it=t.ProxyChannel.fromService(Ae.get(he.$e_b),ve);Te.registerChannel("issue",it);const ot=t.ProxyChannel.fromService(Ae.get(he.$f_b),ve);Te.registerChannel("process",ot);const nt=t.ProxyChannel.fromService(Ae.get(O.$oY),ve);Te.registerChannel("encryption",nt);const ht=t.ProxyChannel.fromService(Ae.get(me.$Yl),ve);Te.registerChannel("sign",ht);const vt=t.ProxyChannel.fromService(Ae.get(M.$Kfc),ve);Te.registerChannel("keyboardLayout",vt),this.f=Ae.get(X.$Gfc);const kt=t.ProxyChannel.fromService(this.f,ve);Te.registerChannel("nativeHost",kt),je.then(st=>st.registerChannel("nativeHost",kt));const Bt=t.ProxyChannel.fromService(Ae.get(ye.$Xhb),ve);Te.registerChannel("workspaces",Bt);const zt=t.ProxyChannel.fromService(Ae.get(J.$Wfc),ve);Te.registerChannel("menubar",zt);const qt=t.ProxyChannel.fromService(Ae.get(Ue.$uY),ve);Te.registerChannel("url",qt);const Ht=t.ProxyChannel.fromService(Ae.get(Ke.$fgc),ve);Te.registerChannel("webview",Ht);const It=ve.add(new Oe.$3fc(this.m,Ae.get(Se.$hfc)));Te.registerChannel("storage",It),je.then(st=>st.registerChannel("storage",It));const Zt=ve.add(new Lt.$sgc(Ae.get(Se.$hfc),Ae.get(rt.$Xec),this.m));je.then(st=>st.registerChannel("profileStorageListener",Zt));const xt=t.ProxyChannel.fromService(Ae.get(dt.$os),ve);Te.registerChannel(dt.TerminalIpcChannels.LocalPty,xt);const Vt=t.ProxyChannel.fromService(Ae.get(le.$xfc),ve);Te.registerChannel("externalTerminal",Vt);const Dt=new jt.$zgc(Ae.get(Mt.$9ec));Te.registerChannel("logger",Dt),je.then(st=>st.registerChannel("logger",Dt));const Gt=new v.$nfc(Ae.get(Ne.$Uec));Te.registerChannel("extensionhostdebugservice",Gt);const Kt=t.ProxyChannel.fromService(Ae.get(re.$ufc),ve);Te.registerChannel(re.$vfc,Kt);const Xt=t.ProxyChannel.fromService(Ae.get(pt.$Bgc),ve);Te.registerChannel(Ft.$Agc,Xt)}async S(Ae,Te){const je=this.b=Ae.get(Ne.$Uec);this.c=Ae.get(St.$Ffc);const ve=(0,C.$Jm)(process.env)?Ne.OpenContext.CLI:Ne.OpenContext.DESKTOP,Ee=this.s.args;if(Te){if(Te.openables.length>0)return je.open({context:ve,cli:Ee,urisToOpen:Te.openables,gotoLineMode:!0,initialStartup:!0});if(Te.urls.length>0)for(const nt of Te.urls){const ht=new URLSearchParams(nt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ht.toString()}),je.open({context:ve,cli:Ee,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const qe=global.macOpenFiles,xe=Ee._.length,Ge=!!Ee["folder-uri"],Ce=!!Ee["file-uri"],Ze=Ee["skip-add-to-recently-opened"]===!0,ze=Ee.wait&&Ee.waitMarkerFilePath?m.URI.file(Ee.waitMarkerFilePath):void 0,Qe=Ee.remote||void 0,it=Ee.profile,ot=Ee["profile-temp"];if(!xe&&!Ge&&!Ce){if(Ee["new-window"]||it||ot)return je.open({context:ve,cli:Ee,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ze,waitMarkerFileURI:ze,initialStartup:!0,remoteAuthority:Qe,forceProfile:it,forceTempProfile:ot});if(qe.length)return je.open({context:Ne.OpenContext.DOCK,cli:Ee,urisToOpen:qe.map(nt=>(nt=(0,Pt.$mm)(nt),(0,pe.$$i)(nt)?{workspaceUri:m.URI.file(nt)}:{fileUri:m.URI.file(nt)})),noRecentEntry:Ze,waitMarkerFileURI:ze,initialStartup:!0})}return je.open({context:ve,cli:Ee,forceNewWindow:Ee["new-window"],diffMode:Ee.diff,mergeMode:Ee.merge,noRecentEntry:Ze,waitMarkerFileURI:ze,gotoLineMode:Ee.goto,initialStartup:!0,remoteAuthority:Qe,forceProfile:it,forceTempProfile:ot})}U(){this.W(),n.protocol.registerHttpProtocol(h.Schemas.vscodeRemoteResource,(Ae,Te)=>{Te({url:Ae.url.replace(/^vscode-remote-resource:/,"http:"),method:Ae.method})}),this.X(this.s.args,process.env,!0),this.Y(),y.$j&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ae=this.z.win32MutexName;if(y.$i&&Ae)try{const Te=await new Promise((ve,Ee)=>{x(["@vscode/windows-mutex"],ve,Ee)}).then(De),je=new Te.Mutex(Ae);f.Event.once(this.t.onWillShutdown)(()=>je.release())}catch(Te){this.m.error(Te)}}async X(Ae,Te,je){try{return await(0,z.$Qm)(this.u,this.m,Ae,Te)}catch(ve){const Ee=(0,I.$qj)(ve);je?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ee):this.m.error(Ee)}return{}}async Y(){try{const Te=(await this.y.readFile(this.s.argvResource)).value.toString(),je=(0,d.parse)(Te),Ee=(0,ue.$Dp)(this.u)>=Ie.TelemetryLevel.CRASH;if(je["enable-crash-reporter"]===void 0){const qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ee},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,E.$2g)()}"`,"}"],xe=Te.substring(0,Te.length-2).concat(`,
`,qe.join(`
`));await this.y.writeFile(this.s.argvResource,A.$Oe.fromString(xe))}else{const qe=Te.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ee},`);qe!==Te&&await this.y.writeFile(this.s.argvResource,A.$Oe.fromString(qe))}}catch(Ae){this.m.error(Ae),this.b?.sendToFocused("vscode:showArgvParseWarning")}}};e.$Igc=yt,e.$Igc=yt=bt=Pe([ne(2,ce.$Ei),ne(3,H.$_j),ne(4,H.$ak),ne(5,B.$Jec),ne(6,W.$bfc),ne(7,S.$_i),ne(8,we.$gR),ne(9,q.$_k),ne(10,Z.$sk),ne(11,rt.$Xec)],yt)});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[323],ae([0,1,14,47,7,22,8,55,16,31,4,48,12,10,71,3,37,26,21,44,105,318,9,18,243,257,24,69,208,15,227,100,84,223,99,20,230,5,73,28,74,284,132,295,57,294,102,256,34,58,77,59,40,239,237,2,41,272,72,232,124,128,276,107,270]),function(x,e,n,o,P,D,A,I,b,a,f,d,g,w,h,p,y,$,m,E,k,t,r,i,c,s,u,l,S,v,R,T,L,O,F,B,C,z,re,Q,le,K,ee,q,j,U,V,ce,G,he,se,_,M,N,W,H,J,X,Z,ie,de,me,we,Oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),re=et(re);class Se{main(){try{this.a()}catch($e){console.error($e.message),n.app.exit(1)}}async a(){(0,b.setUnexpectedErrorHandler)(Le=>console.error(Le));const[$e,Y,ue,fe,be,Re,We,Fe]=this.b();try{try{await this.d(ue,Fe,fe,be,We)}catch(Le){throw this.g(ue,We,Le),Le}await $e.invokeFunction(async Le=>{const Ue=Le.get(z.$_j),Ve=Le.get(B.$bfc),Ye=Le.get(v.$_k),He=Le.get(z.$ak),Ke=await this.f(Ue,ue,Ve,$e,We,!0);return m.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Xe=>{Ue.warn(`app#startup(): Error writing main lockfile: ${Xe.stack}`)}),Re.logger=He.createLogger("main",{name:(0,r.localize)(0,null)}),f.Event.once(Ve.onWillShutdown)(Xe=>{Ye.dispose(),fe.dispose(),Xe.join("instanceLockfile",m.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),$e.createInstance(t.$Igc,Ke,Y).startup()})}catch(Le){$e.invokeFunction(this.j,Le)}}b(){const $e=new F.$Di,Y=new H.$Vc;process.once("exit",()=>Y.dispose());const ue={_serviceBrand:void 0,...re.default};$e.set(Q.$sk,ue);const fe=new u.$Kec(this.k(),ue),be=this.c(fe);$e.set(u.$Jec,fe);const Re=new Z.$0ec((0,z.$nk)(fe),fe.logsHome);$e.set(Z.$9ec,Re);const We=new C.$icc(Re.getLogLevel()),Fe=Y.add(new ie.$oR(We,[new z.$gk(Re.getLogLevel())]));$e.set(z.$_j,Fe);const Le=new R.$Zq(Fe);$e.set(v.$_k,Le);const Ue=new T.$qr(Fe);Le.registerProvider(g.Schemas.file,Ue);const Ve=new X.$Rs(Le);$e.set(J.$Jl,Ve);const Ye=new me.$jR(me.SaveStrategy.DELAYED,fe,Fe,Le);$e.set(G.$fR,Ye),$e.set(G.$gR,Ye);const He=new _.$Yec(Ye,Ve,fe,Le,Fe);$e.set(_.$Xec,He),Le.registerProvider(g.Schemas.vscodeUserData,new we.$Tgc(g.Schemas.file,Ue,g.Schemas.vscodeUserData,He,Ve,Fe));const Ke=p.$i&&ue.win32RegValueName?Y.add(new N.$Rgc(Fe,ue.win32RegValueName)):fe.policyFile?Y.add(new W.$Sgc(fe.policyFile,Le,Fe)):new M.$uo;$e.set(M.$so,Ke);const Xe=new c.$Uo(He.defaultProfile.settingsResource,Le,Ke,Fe);return $e.set(i.$_i,Xe),$e.set(B.$bfc,new L.$Ci(B.$cfc,void 0,!1)),$e.set(j.$5p,new L.$Ci(U.$Pgc,void 0,!0)),$e.set(se.$Sec,new L.$Ci(se.$Tec)),$e.set(V.$Yl,new L.$Ci(ce.$Qgc,void 0,!1)),$e.set(ee.$Aw,new L.$Ci(q.$Ngc)),$e.set(le.$Rec,new K.$Kgc(fe,He,Fe)),[new O.$tr($e,!0),be,fe,Xe,Ye,We,ue,He]}c($e){const Y={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const fe=process.env[ue];typeof fe=="string"&&(Y[ue]=fe)}),Object.assign(process.env,Y),Y}async d($e,Y,ue,fe,be){await A.Promises.settled([Promise.all([this.e($e.extensionsPath),$e.codeCachePath,$e.logsHome.with({scheme:g.Schemas.file}).fsPath,Y.defaultProfile.globalStorageHome.with({scheme:g.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:g.Schemas.file}).fsPath,$e.backupHome].map(Re=>Re?m.Promises.mkdir(Re,{recursive:!0}):void 0)),fe.init(),ue.initialize()]),Y.init()}e($e){if(p.$i){const Y=(0,Oe.getUNCHost)($e);Y&&(0,Oe.addUNCHostToAllowlist)(Y)}return $e}async f($e,Y,ue,fe,be,Re){let We;try{(0,h.mark)("code/willStartMainServer"),We=await(0,k.$Ai)(Y.mainIPCHandle),(0,h.mark)("code/didStartMainServer"),f.Event.once(ue.onWillShutdown)(()=>We.dispose())}catch(Fe){if(Fe.code!=="EADDRINUSE")throw this.g(Y,be,Fe),Fe;let Le;try{Le=await(0,k.$Bi)(Y.mainIPCHandle,"main")}catch(He){if(!Re||p.$i||He.code!=="ECONNREFUSED")throw He.code==="EPERM"&&this.h((0,r.localize)(1,null,be.nameShort),(0,r.localize)(2,null),be),He;try{(0,o.unlinkSync)(Y.mainIPCHandle)}catch(Ke){throw $e.warn("Could not delete obsolete instance handle",Ke),Ke}return this.f($e,Y,ue,fe,be,!1)}if(Y.extensionTestsLocationURI&&!Y.debugExtensionHost.break){const He=`Running extension tests from the command line is currently only supported if no other instance of ${be.nameShort} is running.`;throw $e.error(He),Le.dispose(),new Error(He)}let Ue;!Y.args.wait&&!Y.args.status&&(Ue=setTimeout(()=>{this.h((0,r.localize)(3,null,be.nameShort),(0,r.localize)(4,null),be)},1e4));const Ve=E.ProxyChannel.toService(Le.getChannel("launch"),{disableMarshalling:!0}),Ye=E.ProxyChannel.toService(Le.getChannel("diagnostics"),{disableMarshalling:!0});if(Y.args.status)return fe.invokeFunction(async()=>{const He=new s.$Ys(he.$wp,be),Ke=await Ye.getMainDiagnostics(),Xe=await Ye.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),_e=await He.getDiagnostics(Ke,Xe);throw console.log(_e),new b.$cb});throw p.$i&&await this.i(Ve,$e),$e.trace("Sending env to running instance..."),await Ve.start(Y.args,process.env),Le.dispose(),Ue&&clearTimeout(Ue),new b.$cb("Sent env to running instance. Terminating...")}if(Y.args.status)throw console.log((0,r.localize)(5,null,be.nameShort)),new b.$cb("Terminating...");return process.env.VSCODE_PID=String(process.pid),We}g($e,Y,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const fe=(0,D.$Jb)([$e.userDataPath,$e.extensionsPath,k.$wi]).map(be=>(0,d.$Vw)(P.URI.file(be),{os:p.OS,tildify:$e}));this.h((0,r.localize)(6,null),(0,r.localize)(7,null,(0,I.$qj)(ue),fe.join(`
`)),Y)}}h($e,Y,ue){n.dialog.showMessageBoxSync((0,de.$0w)({type:"warning",buttons:[(0,r.localize)(8,null)],message:$e,detail:Y},ue).options)}async i($e,Y){if(p.$i){const ue=await $e.getMainProcessId();Y.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((fe,be)=>{x(["windows-foreground-love"],fe,be)}).then(De)).allowSetForegroundWindow(ue)}catch(fe){Y.error(fe)}}}j($e,Y){const ue=$e.get(z.$_j),fe=$e.get(B.$bfc);let be=0;Y&&(Y.isExpected?Y.message&&ue.trace(Y.message):(be=1,Y.stack?ue.error(Y.stack):ue.error(`Startup error: ${Y.toString()}`))),fe.kill(be)}k(){const $e=this.l((0,l.$Gm)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const Y=(0,S.$Jgc)($e.verbose);Y&&((0,l.$Im)(process.argv,"--waitMarkerFilePath",Y),$e.waitMarkerFilePath=Y)}return $e}l($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const Y=this.m($e._,$e.goto);$e._=Y}return $e}m($e,Y){const ue=(0,y.cwd)(),fe=$e.map(We=>{let Fe=String(We),Le;Y&&(Le=(0,a.$Mg)(Fe),Fe=Le.path),Fe&&(Fe=this.n(ue,Fe));const Ue=(0,a.$Gg)(Fe,ue),Ve=(0,w.$pc)(Ue);return Ve&&!(0,a.$Cg)(Ve)?null:Y&&Le?(Le.path=Ue,this.o(Le)):Ue}),be=p.$i||p.$j,Re=(0,D.$Ob)(fe,We=>We&&be?We.toLowerCase():We||"");return(0,D.$Jb)(Re)}n($e,Y){return p.$i&&(Y=(0,$.$of)(Y,'"')),Y=(0,$.$mf)((0,$.$mf)(Y," "),"	"),p.$i&&(Y=(0,w.$mc)($e,Y),Y=(0,$.$of)(Y,".")),Y}o($e){const Y=[$e.path];return typeof $e.line=="number"&&Y.push(String($e.line)),typeof $e.column=="number"&&Y.push(String($e.column)),Y.join(":")}}new Se().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/a8f7d1c13f1922bd44e1bd4d709dfe6e7579c86a/core/vs/code/electron-main/main.js.map
