/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/platform/extensions/common/extensions","vs/base/common/process","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/errorMessage","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","fs","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],le=function(ne){for(var e=[],P=0,c=ne.length;P<c;P++)e[P]=ce[ne[P]];return e};define(ce[129],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=e.LoaderEventType=e.$V=void 0,e.$V=!1;var P;(function(C){C[C.LoaderAvailable=1]="LoaderAvailable",C[C.BeginLoadingScript=10]="BeginLoadingScript",C[C.EndLoadingScriptOK=11]="EndLoadingScriptOK",C[C.EndLoadingScriptError=12]="EndLoadingScriptError",C[C.BeginInvokeFactory=21]="BeginInvokeFactory",C[C.EndInvokeFactory=22]="EndInvokeFactory",C[C.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",C[C.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",C[C.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",C[C.NodeEndNativeRequire=34]="NodeEndNativeRequire",C[C.CachedDataFound=60]="CachedDataFound",C[C.CachedDataMissed=61]="CachedDataMissed",C[C.CachedDataRejected=62]="CachedDataRejected",C[C.CachedDataCreated=63]="CachedDataCreated"})(P||(e.LoaderEventType=P={}));class c{static get(){const O=new Map,T=new Map,k=new Map,A=new Map;function w(l,b){l.has(b.detail)||l.set(b.detail,-b.timestamp)}function S(l,b){const v=l.get(b.detail);v&&(v>=0||l.set(b.detail,v+b.timestamp))}let m=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(m=ne.getStats().slice(0).sort((l,b)=>l.timestamp-b.timestamp));for(const l of m)switch(l.type){case P.BeginLoadingScript:w(O,l);break;case P.EndLoadingScriptOK:case P.EndLoadingScriptError:S(O,l);break;case P.BeginInvokeFactory:w(T,l);break;case P.EndInvokeFactory:S(T,l);break;case P.NodeBeginNativeRequire:w(k,l);break;case P.NodeEndNativeRequire:S(k,l);break;case P.NodeBeginEvaluatingScript:w(A,l);break;case P.NodeEndEvaluatingScript:S(A,l);break}let u=0;k.forEach(l=>u+=l);function $(l){const b=[];return l.forEach((v,d)=>b.push([d,v])),b}return{amdLoad:$(O),amdInvoke:$(T),nodeRequire:$(k),nodeEval:$(A),nodeRequireTotal:u}}static toMarkdownTable(O,T){let k="";const A=[];return O.forEach((w,S)=>{A[S]=w.length}),T.forEach(w=>{w.forEach((S,m)=>{typeof S>"u"&&(S=w[m]="-");const u=S.toString().length;A[m]=Math.max(u,A[m])})}),O.forEach((w,S)=>{k+=`| ${w+" ".repeat(A[S]-w.toString().length)} `}),k+=`|
`,O.forEach((w,S)=>{k+=`| ${"-".repeat(A[S])} `}),k+=`|
`,T.forEach(w=>{w.forEach((S,m)=>{typeof S<"u"&&(k+=`| ${S+" ".repeat(A[m]-S.toString().length)} `)}),k+=`|
`}),k}}e.$W=c}),define(ce[130],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ob=void 0,e.$hb=P,e.$ib=c,e.$jb=C,e.$kb=O,e.$lb=T,e.$mb=k,e.$nb=A,e.$pb=S,e.$qb=m,e.$rb=u,e.$sb=$,e.$tb=l;function P(b,v){const d=c(b,v);if(d!==-1)return b[d]}function c(b,v,d=b.length-1){for(let p=d;p>=0;p--){const I=b[p];if(v(I))return p}return-1}function C(b,v){const d=O(b,v);return d===-1?void 0:b[d]}function O(b,v,d=0,p=b.length){let I=d,g=p;for(;I<g;){const s=Math.floor((I+g)/2);v(b[s])?I=s+1:g=s}return I-1}function T(b,v){const d=k(b,v);return d===b.length?void 0:b[d]}function k(b,v,d=0,p=b.length){let I=d,g=p;for(;I<g;){const s=Math.floor((I+g)/2);v(b[s])?g=s:I=s+1}return I}function A(b,v,d=0,p=b.length){const I=k(b,v,d,p);return I===b.length?-1:I}class w{static{this.assertInvariants=!1}constructor(v){this.e=v,this.c=0}findLastMonotonous(v){if(w.assertInvariants){if(this.d){for(const p of this.e)if(this.d(p)&&!v(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=v}const d=O(this.e,v,this.c);return this.c=d+1,d===-1?void 0:this.e[d]}}e.$ob=w;function S(b,v){if(b.length===0)return;let d=b[0];for(let p=1;p<b.length;p++){const I=b[p];v(I,d)>0&&(d=I)}return d}function m(b,v){if(b.length===0)return;let d=b[0];for(let p=1;p<b.length;p++){const I=b[p];v(I,d)>=0&&(d=I)}return d}function u(b,v){return S(b,(d,p)=>-v(d,p))}function $(b,v){if(b.length===0)return-1;let d=0;for(let p=1;p<b.length;p++){const I=b[p];v(I,b[d])>0&&(d=p)}return d}function l(b,v){for(const d of b){const p=v(d);if(p!==void 0)return p}}}),define(ce[39],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var P;(function(c){c[c.Null=0]="Null",c[c.Backspace=8]="Backspace",c[c.Tab=9]="Tab",c[c.LineFeed=10]="LineFeed",c[c.CarriageReturn=13]="CarriageReturn",c[c.Space=32]="Space",c[c.ExclamationMark=33]="ExclamationMark",c[c.DoubleQuote=34]="DoubleQuote",c[c.Hash=35]="Hash",c[c.DollarSign=36]="DollarSign",c[c.PercentSign=37]="PercentSign",c[c.Ampersand=38]="Ampersand",c[c.SingleQuote=39]="SingleQuote",c[c.OpenParen=40]="OpenParen",c[c.CloseParen=41]="CloseParen",c[c.Asterisk=42]="Asterisk",c[c.Plus=43]="Plus",c[c.Comma=44]="Comma",c[c.Dash=45]="Dash",c[c.Period=46]="Period",c[c.Slash=47]="Slash",c[c.Digit0=48]="Digit0",c[c.Digit1=49]="Digit1",c[c.Digit2=50]="Digit2",c[c.Digit3=51]="Digit3",c[c.Digit4=52]="Digit4",c[c.Digit5=53]="Digit5",c[c.Digit6=54]="Digit6",c[c.Digit7=55]="Digit7",c[c.Digit8=56]="Digit8",c[c.Digit9=57]="Digit9",c[c.Colon=58]="Colon",c[c.Semicolon=59]="Semicolon",c[c.LessThan=60]="LessThan",c[c.Equals=61]="Equals",c[c.GreaterThan=62]="GreaterThan",c[c.QuestionMark=63]="QuestionMark",c[c.AtSign=64]="AtSign",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.OpenSquareBracket=91]="OpenSquareBracket",c[c.Backslash=92]="Backslash",c[c.CloseSquareBracket=93]="CloseSquareBracket",c[c.Caret=94]="Caret",c[c.Underline=95]="Underline",c[c.BackTick=96]="BackTick",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.OpenCurlyBrace=123]="OpenCurlyBrace",c[c.Pipe=124]="Pipe",c[c.CloseCurlyBrace=125]="CloseCurlyBrace",c[c.Tilde=126]="Tilde",c[c.NoBreakSpace=160]="NoBreakSpace",c[c.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",c[c.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",c[c.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",c[c.U_Combining_Tilde=771]="U_Combining_Tilde",c[c.U_Combining_Macron=772]="U_Combining_Macron",c[c.U_Combining_Overline=773]="U_Combining_Overline",c[c.U_Combining_Breve=774]="U_Combining_Breve",c[c.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",c[c.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",c[c.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",c[c.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",c[c.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",c[c.U_Combining_Caron=780]="U_Combining_Caron",c[c.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",c[c.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",c[c.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",c[c.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",c[c.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",c[c.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",c[c.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",c[c.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",c[c.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",c[c.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",c[c.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",c[c.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",c[c.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",c[c.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",c[c.U_Combining_Horn=795]="U_Combining_Horn",c[c.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",c[c.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",c[c.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",c[c.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",c[c.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",c[c.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",c[c.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",c[c.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",c[c.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",c[c.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",c[c.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",c[c.U_Combining_Cedilla=807]="U_Combining_Cedilla",c[c.U_Combining_Ogonek=808]="U_Combining_Ogonek",c[c.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",c[c.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",c[c.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",c[c.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",c[c.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",c[c.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",c[c.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",c[c.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",c[c.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",c[c.U_Combining_Low_Line=818]="U_Combining_Low_Line",c[c.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",c[c.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",c[c.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",c[c.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",c[c.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",c[c.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",c[c.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",c[c.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",c[c.U_Combining_Square_Below=827]="U_Combining_Square_Below",c[c.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",c[c.U_Combining_X_Above=829]="U_Combining_X_Above",c[c.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",c[c.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",c[c.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",c[c.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",c[c.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",c[c.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",c[c.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",c[c.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",c[c.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",c[c.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",c[c.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",c[c.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",c[c.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",c[c.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",c[c.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",c[c.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",c[c.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",c[c.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",c[c.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",c[c.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",c[c.U_Combining_Fermata=850]="U_Combining_Fermata",c[c.U_Combining_X_Below=851]="U_Combining_X_Below",c[c.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",c[c.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",c[c.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",c[c.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",c[c.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",c[c.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",c[c.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",c[c.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",c[c.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",c[c.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",c[c.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",c[c.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",c[c.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",c[c.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",c[c.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",c[c.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",c[c.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",c[c.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",c[c.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",c[c.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",c[c.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",c[c.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",c[c.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",c[c.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",c[c.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",c[c.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",c[c.LINE_SEPARATOR=8232]="LINE_SEPARATOR",c[c.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",c[c.NEXT_LINE=133]="NEXT_LINE",c[c.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",c[c.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",c[c.U_DIAERESIS=168]="U_DIAERESIS",c[c.U_MACRON=175]="U_MACRON",c[c.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",c[c.U_CEDILLA=184]="U_CEDILLA",c[c.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",c[c.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",c[c.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",c[c.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",c[c.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",c[c.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",c[c.U_BREVE=728]="U_BREVE",c[c.U_DOT_ABOVE=729]="U_DOT_ABOVE",c[c.U_RING_ABOVE=730]="U_RING_ABOVE",c[c.U_OGONEK=731]="U_OGONEK",c[c.U_SMALL_TILDE=732]="U_SMALL_TILDE",c[c.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",c[c.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",c[c.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",c[c.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",c[c.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",c[c.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",c[c.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",c[c.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",c[c.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",c[c.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",c[c.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",c[c.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",c[c.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",c[c.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",c[c.U_GREEK_TONOS=900]="U_GREEK_TONOS",c[c.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",c[c.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",c[c.U_GREEK_PSILI=8127]="U_GREEK_PSILI",c[c.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",c[c.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",c[c.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",c[c.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",c[c.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",c[c.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",c[c.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",c[c.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",c[c.U_GREEK_VARIA=8175]="U_GREEK_VARIA",c[c.U_GREEK_OXIA=8189]="U_GREEK_OXIA",c[c.U_GREEK_DASIA=8190]="U_GREEK_DASIA",c[c.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",c[c.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",c[c.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",c[c.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",c[c.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",c[c.U_OVERLINE=8254]="U_OVERLINE",c[c.UTF8_BOM=65279]="UTF8_BOM",c[c.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",c[c.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(P||(e.CharCode=P={}))}),define(ce[131],le([0,1]),function(ne,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=c,e.$L=C,e.$M=O,e.$N=T;function c(A,w){const S=Object.create(null);for(const m of A){const u=w(m);let $=S[u];$||($=S[u]=[]),$.push(m)}return S}function C(A,w){const S=[],m=[];for(const u of A)w.has(u)||S.push(u);for(const u of w)A.has(u)||m.push(u);return{removed:S,added:m}}function O(A,w){const S=[],m=[];for(const[u,$]of A)w.has(u)||S.push($);for(const[u,$]of w)A.has(u)||m.push($);return{removed:S,added:m}}function T(A,w){const S=new Set;for(const m of w)A.has(m)&&S.add(m);return S}class k{static{P=Symbol.toStringTag}constructor(w,S){this.b=S,this.a=new Map,this[P]="SetWithKey";for(const m of w)this.add(m)}get size(){return this.a.size}add(w){const S=this.b(w);return this.a.set(S,w),this}delete(w){return this.a.delete(this.b(w))}has(w){return this.a.has(this.b(w))}*entries(){for(const w of this.a.values())yield[w,w]}keys(){return this.values()}*values(){for(const w of this.a.values())yield w}clear(){this.a.clear()}forEach(w,S){this.a.forEach(m=>w.call(S,m,m,this))}[Symbol.iterator](){return this.values()}}e.$O=k}),define(ce[88],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=c,e.$$h=C,e.$_h=O;function P(T){return(k,A,w)=>{let S=null,m=null;if(typeof w.value=="function"?(S="value",m=w.value):typeof w.get=="function"&&(S="get",m=w.get),!m)throw new Error("not supported");w[S]=T(m,A)}}function c(T,k,A){let w=null,S=null;if(typeof A.value=="function"?(w="value",S=A.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof A.get=="function"&&(w="get",S=A.get),!S)throw new Error("not supported");const m=`$memoize$${k}`;A[w]=function(...u){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,u)}),this[m]}}function C(T,k,A){return P((w,S)=>{const m=`$debounce$${S}`,u=`$debounce$result$${S}`;return function(...$){this[u]||(this[u]=A?A():void 0),clearTimeout(this[m]),k&&(this[u]=k(this[u],...$),$=[this[u]]),this[m]=setTimeout(()=>{w.apply(this,$),this[u]=A?A():void 0},T)}})}function O(T,k,A){return P((w,S)=>{const m=`$throttle$timer$${S}`,u=`$throttle$result$${S}`,$=`$throttle$lastRun$${S}`,l=`$throttle$pending$${S}`;return function(...b){if(this[u]||(this[u]=A?A():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),k&&(this[u]=k(this[u],...b)),this[l])return;const v=this[$]+T;v<=Date.now()?(this[$]=Date.now(),w.apply(this,[this[u]]),this[u]=A?A():void 0):(this[l]=!0,this[m]=setTimeout(()=>{this[l]=!1,this[$]=Date.now(),w.apply(this,[this[u]]),this[u]=A?A():void 0},v-Date.now()))}})}}),define(ce[8],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=e.$db=e.$cb=e.$bb=e.$ab=e.$$=e.$7=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=c,e.$2=C,e.$3=O,e.$4=T,e.$5=k,e.$6=w,e.$8=m,e.$9=u,e.$0=$,e.$_=b;class P{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?I.isErrorNoTelemetry(r)?new I(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(t=>{t(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.$Y=P,e.$Z=new P;function c(s){e.$Z.setUnexpectedErrorHandler(s)}function C(s){if(!s||typeof s!="object")return!1;const r=s;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function O(s){w(s)||e.$Z.onUnexpectedError(s)}function T(s){w(s)||e.$Z.onUnexpectedExternalError(s)}function k(s){if(s instanceof Error){const{name:r,message:t}=s,a=s.stacktrace||s.stack;return{$isError:!0,name:r,message:t,stack:a,noTelemetry:I.isErrorNoTelemetry(s)}}return s}const A="Canceled";function w(s){return s instanceof S?!0:s instanceof Error&&s.name===A&&s.message===A}class S extends Error{constructor(){super(A),this.name=this.message}}e.$7=S;function m(){const s=new Error(A);return s.name=s.message,s}function u(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function $(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class l extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$$=l;function b(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class v extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.$ab=v;class d extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.$bb=d;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$cb=p;class I extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof I)return r;const t=new I;return t.message=r.message,t.stack=r.stack,t}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.$db=I;class g extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype)}}e.$eb=g}),define(ce[19],le([0,1,8,130]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$$b=e.$0b=e.CompareResult=void 0,e.$ub=C,e.$vb=O,e.$wb=T,e.$xb=k,e.$yb=A,e.$zb=w,e.$Ab=S,e.$Bb=m,e.$Cb=u,e.$Db=$,e.$Eb=l,e.$Fb=b,e.$Gb=v,e.top=d,e.$Ib=p,e.$Jb=g,e.$Kb=s,e.$Lb=r,e.$Mb=t,e.$Nb=a,e.$Ob=i,e.$Pb=n,e.$Qb=o,e.$Rb=h,e.$Sb=f,e.$Tb=R,e.$Ub=L,e.$Vb=E,e.$Wb=y,e.$Xb=N,e.$Yb=F,e.$Zb=D,e.$1b=M,e.$2b=J,e.$3b=W,e.$4b=x,e.$5b=G,e.$6b=ie,e.$7b=V,e.$8b=se,e.$9b=he,e.$_b=K;function C(B,j=0){return B[B.length-(1+j)]}function O(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}function T(B,j,_=(ee,X)=>ee===X){if(B===j)return!0;if(!B||!j||B.length!==j.length)return!1;for(let ee=0,X=B.length;ee<X;ee++)if(!_(B[ee],j[ee]))return!1;return!0}function k(B,j){const _=B.length-1;j<_&&(B[j]=B[_]),B.pop()}function A(B,j,_){return w(B.length,ee=>_(B[ee],j))}function w(B,j){let _=0,ee=B-1;for(;_<=ee;){const X=(_+ee)/2|0,oe=j(X);if(oe<0)_=X+1;else if(oe>0)ee=X-1;else return X}return-(_+1)}function S(B,j,_){if(B=B|0,B>=j.length)throw new TypeError("invalid index");const ee=j[Math.floor(j.length*Math.random())],X=[],oe=[],ue=[];for(const ge of j){const be=_(ge,ee);be<0?X.push(ge):be>0?oe.push(ge):ue.push(ge)}return B<X.length?S(B,X,_):B<X.length+ue.length?ue[0]:S(B-(X.length+ue.length),oe,_)}function m(B,j){const _=[];let ee;for(const X of B.slice(0).sort(j))!ee||j(ee[0],X)!==0?(ee=[X],_.push(ee)):ee.push(X);return _}function*u(B,j){let _,ee;for(const X of B)ee!==void 0&&j(ee,X)?_.push(X):(_&&(yield _),_=[X]),ee=X;_&&(yield _)}function $(B,j){for(let _=0;_<=B.length;_++)j(_===0?void 0:B[_-1],_===B.length?void 0:B[_])}function l(B,j){for(let _=0;_<B.length;_++)j(_===0?void 0:B[_-1],B[_],_+1===B.length?void 0:B[_+1])}function b(B,j,_){const ee=[];function X(ge,be,Ie){if(be===0&&Ie.length===0)return;const pe=ee[ee.length-1];pe&&pe.start+pe.deleteCount===ge?(pe.deleteCount+=be,pe.toInsert.push(...Ie)):ee.push({start:ge,deleteCount:be,toInsert:Ie})}let oe=0,ue=0;for(;;){if(oe===B.length){X(oe,0,j.slice(ue));break}if(ue===j.length){X(oe,B.length-oe,[]);break}const ge=B[oe],be=j[ue],Ie=_(ge,be);Ie===0?(oe+=1,ue+=1):Ie<0?(X(oe,1,[]),oe+=1):Ie>0&&(X(oe,0,[be]),ue+=1)}return ee}function v(B,j,_){const ee=b(B,j,_),X=[],oe=[];for(const ue of ee)X.push(...B.slice(ue.start,ue.start+ue.deleteCount)),oe.push(...ue.toInsert);return{removed:X,added:oe}}function d(B,j,_){if(_===0)return[];const ee=B.slice(0,_).sort(j);return I(B,j,ee,_,B.length),ee}function p(B,j,_,ee,X){return _===0?Promise.resolve([]):new Promise((oe,ue)=>{(async()=>{const ge=B.length,be=B.slice(0,_).sort(j);for(let Ie=_,pe=Math.min(_+ee,ge);Ie<ge;Ie=pe,pe=Math.min(pe+ee,ge)){if(Ie>_&&await new Promise(we=>setTimeout(we)),X&&X.isCancellationRequested)throw new P.$7;I(B,j,be,Ie,pe)}return be})().then(oe,ue)})}function I(B,j,_,ee,X){for(const oe=_.length;ee<X;ee++){const ue=B[ee];if(j(ue,_[oe-1])<0){_.pop();const ge=(0,c.$mb)(_,be=>j(ue,be)<0);_.splice(ge,0,ue)}}}function g(B){return B.filter(j=>!!j)}function s(B){let j=0;for(let _=0;_<B.length;_++)B[_]&&(B[j]=B[_],j+=1);B.length=j}function r(B,j,_){B.splice(_,0,B.splice(j,1)[0])}function t(B){return!Array.isArray(B)||B.length===0}function a(B){return Array.isArray(B)&&B.length>0}function i(B,j=_=>_){const _=new Set;return B.filter(ee=>{const X=j(ee);return _.has(X)?!1:(_.add(X),!0)})}function n(B){const j=new Set;return _=>{const ee=B(_);return j.has(ee)?!1:(j.add(ee),!0)}}function o(B,j){return B.length>0?B[0]:j}function h(B,j){return B.length>0?B[B.length-1]:j}function f(B,j,_=(ee,X)=>ee===X){let ee=0;for(let X=0,oe=Math.min(B.length,j.length);X<oe&&_(B[X],j[X]);X++)ee++;return ee}function R(B,j){let _=typeof j=="number"?B:0;typeof j=="number"?_=B:(_=0,j=B);const ee=[];if(_<=j)for(let X=_;X<j;X++)ee.push(X);else for(let X=_;X>j;X--)ee.push(X);return ee}function L(B,j,_){return B.reduce((ee,X)=>(ee[j(X)]=_?_(X):X,ee),Object.create(null))}function E(B,j){return B.push(j),()=>y(B,j)}function y(B,j){const _=B.indexOf(j);if(_>-1)return B.splice(_,1),j}function N(B,j,_){const ee=B.slice(0,j),X=B.slice(j);return ee.concat(_,X)}function F(B,j){let _;if(typeof j=="number"){let ee=j;_=()=>{const X=Math.sin(ee++)*179426549;return X-Math.floor(X)}}else _=Math.random;for(let ee=B.length-1;ee>0;ee-=1){const X=Math.floor(_()*(ee+1)),oe=B[ee];B[ee]=B[X],B[X]=oe}}function D(B,j){const _=B.indexOf(j);_>-1&&(B.splice(_,1),B.unshift(j))}function M(B,j){const _=B.indexOf(j);_>-1&&(B.splice(_,1),B.push(j))}function J(B,j){for(const _ of j)B.push(_)}function W(B,j){return Array.isArray(B)?B.map(j):j(B)}function x(B){return Array.isArray(B)?B:[B]}function G(B){return B[Math.floor(Math.random()*B.length)]}function ie(B,j,_){const ee=z(B,j),X=B.length,oe=_.length;B.length=X+oe;for(let ue=X-1;ue>=ee;ue--)B[ue+oe]=B[ue];for(let ue=0;ue<oe;ue++)B[ue+ee]=_[ue]}function V(B,j,_,ee){const X=z(B,j);let oe=B.splice(X,_);return oe===void 0&&(oe=[]),ie(B,X,ee),oe}function z(B,j){return j<0?Math.max(j+B.length,0):Math.min(j,B.length)}var te;(function(B){function j(oe){return oe<0}B.isLessThan=j;function _(oe){return oe<=0}B.isLessThanOrEqual=_;function ee(oe){return oe>0}B.isGreaterThan=ee;function X(oe){return oe===0}B.isNeitherLessOrGreaterThan=X,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(te||(e.CompareResult=te={}));function se(B,j){return(_,ee)=>j(B(_),B(ee))}function he(...B){return(j,_)=>{for(const ee of B){const X=ee(j,_);if(!te.isNeitherLessOrGreaterThan(X))return X}return te.neitherLessOrGreaterThan}}const q=(B,j)=>B-j;e.$0b=q;const Z=(B,j)=>(0,e.$0b)(B?1:0,j?1:0);e.$$b=Z;function K(B){return(j,_)=>-B(j,_)}class H{constructor(j){this.g=j,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(j){let _=this.c;for(;_<this.g.length&&j(this.g[_]);)_++;const ee=_===this.c?null:this.g.slice(this.c,_);return this.c=_,ee}takeFromEndWhile(j){let _=this.d;for(;_>=0&&j(this.g[_]);)_--;const ee=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const j=this.g[this.c];return this.c++,j}removeLast(){const j=this.g[this.d];return this.d--,j}takeCount(j){const _=this.g.slice(this.c,this.c+j);return this.c+=j,_}}e.$ac=H;class U{static{this.empty=new U(j=>{})}constructor(j){this.iterate=j}forEach(j){this.iterate(_=>(j(_),!0))}toArray(){const j=[];return this.iterate(_=>(j.push(_),!0)),j}filter(j){return new U(_=>this.iterate(ee=>j(ee)?_(ee):!0))}map(j){return new U(_=>this.iterate(ee=>_(j(ee))))}some(j){let _=!1;return this.iterate(ee=>(_=j(ee),!_)),_}findFirst(j){let _;return this.iterate(ee=>j(ee)?(_=ee,!1):!0),_}findLast(j){let _;return this.iterate(ee=>(j(ee)&&(_=ee),!0)),_}findLastMaxBy(j){let _,ee=!0;return this.iterate(X=>((ee||te.isGreaterThan(j(X,_)))&&(ee=!1,_=X),!0)),_}}e.$bc=U;class Y{constructor(j){this.c=j}static createSortPermutation(j,_){const ee=Array.from(j.keys()).sort((X,oe)=>_(j[X],j[oe]));return new Y(ee)}apply(j){return j.map((_,ee)=>j[this.c[ee]])}inverse(){const j=this.c.slice();for(let _=0;_<this.c.length;_++)j[this.c[_]]=_;return new Y(j)}}e.$cc=Y}),define(ce[132],le([0,1,8]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=c,e.$gd=C,e.$hd=O,e.$id=T,e.$jd=k,e.$kd=A;function c(w,S){if(!w)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}function C(w,S="Unreachable"){throw new Error(S)}function O(w,S="unexpected state"){if(!w)throw new P.$eb(`Assertion Failed: ${S}`)}function T(w){w||(0,P.$3)(new P.$eb("Soft Assertion Failed"))}function k(w){if(!w()){debugger;w(),(0,P.$3)(new P.$eb("Assertion Failed"))}}function A(w,S){let m=0;for(;m<w.length-1;){const u=w[m],$=w[m+1];if(!S(u,$))return!1;m++}return!0}}),define(ce[89],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=P;function P(c,C){const O=this;let T=!1,k;return function(){if(T)return k;if(T=!0,C)try{k=c.apply(O,arguments)}finally{C()}else k=c.apply(O,arguments);return k}}}),define(ce[64],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(c){function C(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}c.is=C;const O=Object.freeze([]);function T(){return O}c.empty=T;function*k(t){yield t}c.single=k;function A(t){return C(t)?t:k(t)}c.wrap=A;function w(t){return t||O}c.from=w;function*S(t){for(let a=t.length-1;a>=0;a--)yield t[a]}c.reverse=S;function m(t){return!t||t[Symbol.iterator]().next().done===!0}c.isEmpty=m;function u(t){return t[Symbol.iterator]().next().value}c.first=u;function $(t,a){let i=0;for(const n of t)if(a(n,i++))return!0;return!1}c.some=$;function l(t,a){for(const i of t)if(a(i))return i}c.find=l;function*b(t,a){for(const i of t)a(i)&&(yield i)}c.filter=b;function*v(t,a){let i=0;for(const n of t)yield a(n,i++)}c.map=v;function*d(t,a){let i=0;for(const n of t)yield*a(n,i++)}c.flatMap=d;function*p(...t){for(const a of t)yield*a}c.concat=p;function I(t,a,i){let n=i;for(const o of t)n=a(n,o);return n}c.reduce=I;function*g(t,a,i=t.length){for(a<0&&(a+=t.length),i<0?i+=t.length:i>t.length&&(i=t.length);a<i;a++)yield t[a]}c.slice=g;function s(t,a=Number.POSITIVE_INFINITY){const i=[];if(a===0)return[i,t];const n=t[Symbol.iterator]();for(let o=0;o<a;o++){const h=n.next();if(h.done)return[i,c.empty()];i.push(h.value)}return[i,{[Symbol.iterator](){return n}}]}c.consume=s;async function r(t){const a=[];for await(const i of t)a.push(i);return Promise.resolve(a)}c.asyncToArray=r})(P||(e.Iterable=P={}))}),define(ce[34],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Vn=T,e.$Wn=m,e.$Xn=u,e.$Yn=$,e.$Zn=l,e.$1n=b,e.$2n=v,e.$3n=d,e.$4n=p,e.$5n=I,e.$6n=g;var P;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var c;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(c||(e.SyntaxKind=c={}));var C;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var O;(function(s){s.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function T(s,r=!1){let t=0;const a=s.length;let i="",n=0,o=c.Unknown,h=P.None;function f(D){let M=0,J=0;for(;M<D;){const W=s.charCodeAt(t);if(W>=S._0&&W<=S._9)J=J*16+W-S._0;else if(W>=S.A&&W<=S.F)J=J*16+W-S.A+10;else if(W>=S.a&&W<=S.f)J=J*16+W-S.a+10;else break;t++,M++}return M<D&&(J=-1),J}function R(D){t=D,i="",n=0,o=c.Unknown,h=P.None}function L(){const D=t;if(s.charCodeAt(t)===S._0)t++;else for(t++;t<s.length&&w(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===S.dot)if(t++,t<s.length&&w(s.charCodeAt(t)))for(t++;t<s.length&&w(s.charCodeAt(t));)t++;else return h=P.UnexpectedEndOfNumber,s.substring(D,t);let M=t;if(t<s.length&&(s.charCodeAt(t)===S.E||s.charCodeAt(t)===S.e))if(t++,(t<s.length&&s.charCodeAt(t)===S.plus||s.charCodeAt(t)===S.minus)&&t++,t<s.length&&w(s.charCodeAt(t))){for(t++;t<s.length&&w(s.charCodeAt(t));)t++;M=t}else h=P.UnexpectedEndOfNumber;return s.substring(D,M)}function E(){let D="",M=t;for(;;){if(t>=a){D+=s.substring(M,t),h=P.UnexpectedEndOfString;break}const J=s.charCodeAt(t);if(J===S.doubleQuote){D+=s.substring(M,t),t++;break}if(J===S.backslash){if(D+=s.substring(M,t),t++,t>=a){h=P.UnexpectedEndOfString;break}switch(s.charCodeAt(t++)){case S.doubleQuote:D+='"';break;case S.backslash:D+="\\";break;case S.slash:D+="/";break;case S.b:D+="\b";break;case S.f:D+="\f";break;case S.n:D+=`
`;break;case S.r:D+="\r";break;case S.t:D+="	";break;case S.u:{const x=f(4);x>=0?D+=String.fromCharCode(x):h=P.InvalidUnicode;break}default:h=P.InvalidEscapeCharacter}M=t;continue}if(J>=0&&J<=31)if(A(J)){D+=s.substring(M,t),h=P.UnexpectedEndOfString;break}else h=P.InvalidCharacter;t++}return D}function y(){if(i="",h=P.None,n=t,t>=a)return n=a,o=c.EOF;let D=s.charCodeAt(t);if(k(D)){do t++,i+=String.fromCharCode(D),D=s.charCodeAt(t);while(k(D));return o=c.Trivia}if(A(D))return t++,i+=String.fromCharCode(D),D===S.carriageReturn&&s.charCodeAt(t)===S.lineFeed&&(t++,i+=`
`),o=c.LineBreakTrivia;switch(D){case S.openBrace:return t++,o=c.OpenBraceToken;case S.closeBrace:return t++,o=c.CloseBraceToken;case S.openBracket:return t++,o=c.OpenBracketToken;case S.closeBracket:return t++,o=c.CloseBracketToken;case S.colon:return t++,o=c.ColonToken;case S.comma:return t++,o=c.CommaToken;case S.doubleQuote:return t++,i=E(),o=c.StringLiteral;case S.slash:{const M=t-1;if(s.charCodeAt(t+1)===S.slash){for(t+=2;t<a&&!A(s.charCodeAt(t));)t++;return i=s.substring(M,t),o=c.LineCommentTrivia}if(s.charCodeAt(t+1)===S.asterisk){t+=2;const J=a-1;let W=!1;for(;t<J;){if(s.charCodeAt(t)===S.asterisk&&s.charCodeAt(t+1)===S.slash){t+=2,W=!0;break}t++}return W||(t++,h=P.UnexpectedEndOfComment),i=s.substring(M,t),o=c.BlockCommentTrivia}return i+=String.fromCharCode(D),t++,o=c.Unknown}case S.minus:if(i+=String.fromCharCode(D),t++,t===a||!w(s.charCodeAt(t)))return o=c.Unknown;case S._0:case S._1:case S._2:case S._3:case S._4:case S._5:case S._6:case S._7:case S._8:case S._9:return i+=L(),o=c.NumericLiteral;default:for(;t<a&&N(D);)t++,D=s.charCodeAt(t);if(n!==t){switch(i=s.substring(n,t),i){case"true":return o=c.TrueKeyword;case"false":return o=c.FalseKeyword;case"null":return o=c.NullKeyword}return o=c.Unknown}return i+=String.fromCharCode(D),t++,o=c.Unknown}}function N(D){if(k(D)||A(D))return!1;switch(D){case S.closeBrace:case S.closeBracket:case S.openBrace:case S.openBracket:case S.doubleQuote:case S.colon:case S.comma:case S.slash:return!1}return!0}function F(){let D;do D=y();while(D>=c.LineCommentTrivia&&D<=c.Trivia);return D}return{setPosition:R,getPosition:()=>t,scan:r?F:y,getToken:()=>o,getTokenValue:()=>i,getTokenOffset:()=>n,getTokenLength:()=>t-n,getTokenError:()=>h}}function k(s){return s===S.space||s===S.tab||s===S.verticalTab||s===S.formFeed||s===S.nonBreakingSpace||s===S.ogham||s>=S.enQuad&&s<=S.zeroWidthSpace||s===S.narrowNoBreakSpace||s===S.mathematicalSpace||s===S.ideographicSpace||s===S.byteOrderMark}function A(s){return s===S.lineFeed||s===S.carriageReturn||s===S.lineSeparator||s===S.paragraphSeparator}function w(s){return s>=S._0&&s<=S._9}var S;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(S||(S={}));function m(s,r){const t=[],a=new Object;let i;const n={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function h(f,R,L,E){n.value=f,n.offset=R,n.length=L,n.type=E,n.colonOffset=void 0,i=n}try{I(s,{onObjectBegin:(f,R)=>{if(r<=f)throw a;i=void 0,o=r>f,t.push("")},onObjectProperty:(f,R,L)=>{if(r<R||(h(f,R,L,"property"),t[t.length-1]=f,r<=R+L))throw a},onObjectEnd:(f,R)=>{if(r<=f)throw a;i=void 0,t.pop()},onArrayBegin:(f,R)=>{if(r<=f)throw a;i=void 0,t.push(0)},onArrayEnd:(f,R)=>{if(r<=f)throw a;i=void 0,t.pop()},onLiteralValue:(f,R,L)=>{if(r<R||(h(f,R,L,g(f)),r<=R+L))throw a},onSeparator:(f,R,L)=>{if(r<=R)throw a;if(f===":"&&i&&i.type==="property")i.colonOffset=R,o=!1,i=void 0;else if(f===","){const E=t[t.length-1];typeof E=="number"?t[t.length-1]=E+1:(o=!0,t[t.length-1]=""),i=void 0}}})}catch(f){if(f!==a)throw f}return{path:t,previousNode:i,isAtPropertyKey:o,matches:f=>{let R=0;for(let L=0;R<f.length&&L<t.length;L++)if(f[R]===t[L]||f[R]==="*")R++;else if(f[R]!=="**")return!1;return R===f.length}}}function u(s,r=[],t=O.DEFAULT){let a=null,i=[];const n=[];function o(f){Array.isArray(i)?i.push(f):a!==null&&(i[a]=f)}return I(s,{onObjectBegin:()=>{const f={};o(f),n.push(i),i=f,a=null},onObjectProperty:f=>{a=f},onObjectEnd:()=>{i=n.pop()},onArrayBegin:()=>{const f=[];o(f),n.push(i),i=f,a=null},onArrayEnd:()=>{i=n.pop()},onLiteralValue:o,onError:(f,R,L)=>{r.push({error:f,offset:R,length:L})}},t),i[0]}function $(s,r=[],t=O.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(f){a.type==="property"&&(a.length=f-a.offset,a=a.parent)}function n(f){return a.children.push(f),f}I(s,{onObjectBegin:f=>{a=n({type:"object",offset:f,length:-1,parent:a,children:[]})},onObjectProperty:(f,R,L)=>{a=n({type:"property",offset:R,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:f,offset:R,length:L,parent:a})},onObjectEnd:(f,R)=>{a.length=f+R-a.offset,a=a.parent,i(f+R)},onArrayBegin:(f,R)=>{a=n({type:"array",offset:f,length:-1,parent:a,children:[]})},onArrayEnd:(f,R)=>{a.length=f+R-a.offset,a=a.parent,i(f+R)},onLiteralValue:(f,R,L)=>{n({type:g(f),offset:R,length:L,parent:a,value:f}),i(R+L)},onSeparator:(f,R,L)=>{a.type==="property"&&(f===":"?a.colonOffset=R:f===","&&i(R))},onError:(f,R,L)=>{r.push({error:f,offset:R,length:L})}},t);const h=a.children[0];return h&&delete h.parent,h}function l(s,r){if(!s)return;let t=s;for(const a of r)if(typeof a=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let i=!1;for(const n of t.children)if(Array.isArray(n.children)&&n.children[0].value===a){t=n.children[1],i=!0;break}if(!i)return}else{const i=a;if(t.type!=="array"||i<0||!Array.isArray(t.children)||i>=t.children.length)return;t=t.children[i]}return t}function b(s){if(!s.parent||!s.parent.children)return[];const r=b(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;r.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&r.push(t)}return r}function v(s){switch(s.type){case"array":return s.children.map(v);case"object":{const r=Object.create(null);for(const t of s.children){const a=t.children[1];a&&(r[t.children[0].value]=v(a))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}function d(s,r,t=!1){return r>=s.offset&&r<s.offset+s.length||t&&r===s.offset+s.length}function p(s,r,t=!1){if(d(s,r,t)){const a=s.children;if(Array.isArray(a))for(let i=0;i<a.length&&a[i].offset<=r;i++){const n=p(a[i],r,t);if(n)return n}return s}}function I(s,r,t=O.DEFAULT){const a=T(s,!1);function i(se){return se?()=>se(a.getTokenOffset(),a.getTokenLength()):()=>!0}function n(se){return se?he=>se(he,a.getTokenOffset(),a.getTokenLength()):()=>!0}const o=i(r.onObjectBegin),h=n(r.onObjectProperty),f=i(r.onObjectEnd),R=i(r.onArrayBegin),L=i(r.onArrayEnd),E=n(r.onLiteralValue),y=n(r.onSeparator),N=i(r.onComment),F=n(r.onError),D=t&&t.disallowComments,M=t&&t.allowTrailingComma;function J(){for(;;){const se=a.scan();switch(a.getTokenError()){case P.InvalidUnicode:W(C.InvalidUnicode);break;case P.InvalidEscapeCharacter:W(C.InvalidEscapeCharacter);break;case P.UnexpectedEndOfNumber:W(C.UnexpectedEndOfNumber);break;case P.UnexpectedEndOfComment:D||W(C.UnexpectedEndOfComment);break;case P.UnexpectedEndOfString:W(C.UnexpectedEndOfString);break;case P.InvalidCharacter:W(C.InvalidCharacter);break}switch(se){case c.LineCommentTrivia:case c.BlockCommentTrivia:D?W(C.InvalidCommentToken):N();break;case c.Unknown:W(C.InvalidSymbol);break;case c.Trivia:case c.LineBreakTrivia:break;default:return se}}}function W(se,he=[],q=[]){if(F(se),he.length+q.length>0){let Z=a.getToken();for(;Z!==c.EOF;){if(he.indexOf(Z)!==-1){J();break}else if(q.indexOf(Z)!==-1)break;Z=J()}}}function x(se){const he=a.getTokenValue();return se?E(he):h(he),J(),!0}function G(){switch(a.getToken()){case c.NumericLiteral:{let se=0;try{se=JSON.parse(a.getTokenValue()),typeof se!="number"&&(W(C.InvalidNumberFormat),se=0)}catch{W(C.InvalidNumberFormat)}E(se);break}case c.NullKeyword:E(null);break;case c.TrueKeyword:E(!0);break;case c.FalseKeyword:E(!1);break;default:return!1}return J(),!0}function ie(){return a.getToken()!==c.StringLiteral?(W(C.PropertyNameExpected,[],[c.CloseBraceToken,c.CommaToken]),!1):(x(!1),a.getToken()===c.ColonToken?(y(":"),J(),te()||W(C.ValueExpected,[],[c.CloseBraceToken,c.CommaToken])):W(C.ColonExpected,[],[c.CloseBraceToken,c.CommaToken]),!0)}function V(){o(),J();let se=!1;for(;a.getToken()!==c.CloseBraceToken&&a.getToken()!==c.EOF;){if(a.getToken()===c.CommaToken){if(se||W(C.ValueExpected,[],[]),y(","),J(),a.getToken()===c.CloseBraceToken&&M)break}else se&&W(C.CommaExpected,[],[]);ie()||W(C.ValueExpected,[],[c.CloseBraceToken,c.CommaToken]),se=!0}return f(),a.getToken()!==c.CloseBraceToken?W(C.CloseBraceExpected,[c.CloseBraceToken],[]):J(),!0}function z(){R(),J();let se=!1;for(;a.getToken()!==c.CloseBracketToken&&a.getToken()!==c.EOF;){if(a.getToken()===c.CommaToken){if(se||W(C.ValueExpected,[],[]),y(","),J(),a.getToken()===c.CloseBracketToken&&M)break}else se&&W(C.CommaExpected,[],[]);te()||W(C.ValueExpected,[],[c.CloseBracketToken,c.CommaToken]),se=!0}return L(),a.getToken()!==c.CloseBracketToken?W(C.CloseBracketExpected,[c.CloseBracketToken],[]):J(),!0}function te(){switch(a.getToken()){case c.OpenBracketToken:return z();case c.OpenBraceToken:return V();case c.StringLiteral:return x(!0);default:return G()}}return J(),a.getToken()===c.EOF?t.allowEmptyContent?!0:(W(C.ValueExpected,[],[]),!1):te()?(a.getToken()!==c.EOF&&W(C.EndOfFileExpected,[],[]),!0):(W(C.ValueExpected,[],[]),!1)}function g(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}}),define(ce[45],le([0,1,34]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=c,e.$8n=C,e.$9n=k,e.$0n=A;function c(w,S,m){let u,$,l,b,v;if(S){for(b=S.offset,v=b+S.length,l=b;l>0&&!A(w,l-1);)l--;let h=v;for(;h<w.length&&!A(w,h);)h++;$=w.substring(l,h),u=T($,m)}else $=w,u=0,l=0,b=0,v=w.length;const d=k(m,w);let p=!1,I=0,g;m.insertSpaces?g=O(" ",m.tabSize||4):g="	";const s=(0,P.$Vn)($,!1);let r=!1;function t(){return d+O(g,u+I)}function a(){let h=s.scan();for(p=!1;h===P.SyntaxKind.Trivia||h===P.SyntaxKind.LineBreakTrivia;)p=p||h===P.SyntaxKind.LineBreakTrivia,h=s.scan();return r=h===P.SyntaxKind.Unknown||s.getTokenError()!==P.ScanError.None,h}const i=[];function n(h,f,R){!r&&f<v&&R>b&&w.substring(f,R)!==h&&i.push({offset:f,length:R-f,content:h})}let o=a();if(o!==P.SyntaxKind.EOF){const h=s.getTokenOffset()+l,f=O(g,u);n(f,l,h)}for(;o!==P.SyntaxKind.EOF;){let h=s.getTokenOffset()+s.getTokenLength()+l,f=a(),R="";for(;!p&&(f===P.SyntaxKind.LineCommentTrivia||f===P.SyntaxKind.BlockCommentTrivia);){const E=s.getTokenOffset()+l;n(" ",h,E),h=s.getTokenOffset()+s.getTokenLength()+l,R=f===P.SyntaxKind.LineCommentTrivia?t():"",f=a()}if(f===P.SyntaxKind.CloseBraceToken)o!==P.SyntaxKind.OpenBraceToken&&(I--,R=t());else if(f===P.SyntaxKind.CloseBracketToken)o!==P.SyntaxKind.OpenBracketToken&&(I--,R=t());else{switch(o){case P.SyntaxKind.OpenBracketToken:case P.SyntaxKind.OpenBraceToken:I++,R=t();break;case P.SyntaxKind.CommaToken:case P.SyntaxKind.LineCommentTrivia:R=t();break;case P.SyntaxKind.BlockCommentTrivia:p?R=t():R=" ";break;case P.SyntaxKind.ColonToken:R=" ";break;case P.SyntaxKind.StringLiteral:if(f===P.SyntaxKind.ColonToken){R="";break}case P.SyntaxKind.NullKeyword:case P.SyntaxKind.TrueKeyword:case P.SyntaxKind.FalseKeyword:case P.SyntaxKind.NumericLiteral:case P.SyntaxKind.CloseBraceToken:case P.SyntaxKind.CloseBracketToken:f===P.SyntaxKind.LineCommentTrivia||f===P.SyntaxKind.BlockCommentTrivia?R=" ":f!==P.SyntaxKind.CommaToken&&f!==P.SyntaxKind.EOF&&(r=!0);break;case P.SyntaxKind.Unknown:r=!0;break}p&&(f===P.SyntaxKind.LineCommentTrivia||f===P.SyntaxKind.BlockCommentTrivia)&&(R=t())}const L=s.getTokenOffset()+l;n(R,h,L),o=f}return i}function C(w,S){const m=JSON.stringify(w,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?m.replace(/\r\n|\r|\n/g,S.eol):m}function O(w,S){let m="";for(let u=0;u<S;u++)m+=w;return m}function T(w,S){let m=0,u=0;const $=S.tabSize||4;for(;m<w.length;){const l=w.charAt(m);if(l===" ")u++;else if(l==="	")u+=$;else break;m++}return Math.floor(u/$)}function k(w,S){for(let m=0;m<S.length;m++){const u=S.charAt(m);if(u==="\r")return m+1<S.length&&S.charAt(m+1)===`
`?`\r
`:"\r";if(u===`
`)return`
`}return w&&w.eol||`
`}function A(w,S){return`\r
`.indexOf(w.charAt(S))!==-1}}),define(ce[65],le([0,1,34,45]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=C,e.$_n=O,e.$ao=T,e.$bo=k,e.$co=A;function C(w,S,m){return O(w,S,void 0,m)}function O(w,S,m,u,$){const l=S.slice(),b=[],v=(0,P.$Yn)(w,b);let d,p;for(;l.length>0&&(p=l.pop(),d=(0,P.$Zn)(v,l),d===void 0&&m!==void 0);)typeof p=="string"?m={[p]:m}:m=[m];if(d)if(d.type==="object"&&typeof p=="string"&&Array.isArray(d.children)){const I=(0,P.$Zn)(d,[p]);if(I!==void 0)if(m===void 0){if(!I.parent)throw new Error("Malformed AST");const g=d.children.indexOf(I.parent);let s,r=I.parent.offset+I.parent.length;if(g>0){const t=d.children[g-1];s=t.offset+t.length}else s=d.offset+1,d.children.length>1&&(r=d.children[1].offset);return T(w,{offset:s,length:r-s,content:""},u)}else return T(w,{offset:I.offset,length:I.length,content:JSON.stringify(m)},u);else{if(m===void 0)return[];const g=`${JSON.stringify(p)}: ${JSON.stringify(m)}`,s=$?$(d.children.map(t=>t.children[0].value)):d.children.length;let r;if(s>0){const t=d.children[s-1];r={offset:t.offset+t.length,length:0,content:","+g}}else d.children.length===0?r={offset:d.offset+1,length:0,content:g}:r={offset:d.offset+1,length:0,content:g+","};return T(w,r,u)}}else if(d.type==="array"&&typeof p=="number"&&Array.isArray(d.children))if(m!==void 0){const I=`${JSON.stringify(m)}`;let g;if(d.children.length===0||p===0)g={offset:d.offset+1,length:0,content:d.children.length===0?I:I+","};else{const s=p===-1||p>d.children.length?d.children.length:p,r=d.children[s-1];g={offset:r.offset+r.length,length:0,content:","+I}}return T(w,g,u)}else{const I=p,g=d.children[I];let s;if(d.children.length===1)s={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===I){const r=d.children[I-1],t=r.offset+r.length,a=d.offset+d.length;s={offset:t,length:a-2-t,content:""}}else s={offset:g.offset,length:d.children[I+1].offset-g.offset,content:""};return T(w,s,u)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${d.type}`);else return m===void 0?[]:T(w,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(m)},u)}function T(w,S,m){let u=k(w,S),$=S.offset,l=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;$>0&&!(0,c.$0n)(u,$-1);)$--;for(;l<u.length&&!(0,c.$0n)(u,l);)l++}const b=(0,c.$7n)(u,{offset:$,length:l-$},m);for(let d=b.length-1;d>=0;d--){const p=b[d];u=k(u,p),$=Math.min($,p.offset),l=Math.max(l,p.offset+p.length),l+=p.content.length-p.length}const v=w.length-(u.length-l)-$;return[{offset:$,length:v,content:u.substring($,l)}]}function k(w,S){return w.substring(0,S.offset)+S.content+w.substring(S.offset+S.length)}function A(w,S){const m=S.slice(0).sort(($,l)=>{const b=$.offset-l.offset;return b===0?$.length-l.length:b});let u=w.length;for(let $=m.length-1;$>=0;$--){const l=m[$];if(l.offset+l.length<=u)w=k(w,l);else throw new Error("Overlapping edit");u=l.offset}return w}}),define(ce[54],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class P{constructor(C){this.d=C,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=P}),define(ce[90],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0;class P{static{this.Undefined=new P(void 0)}constructor(O){this.element=O,this.next=P.Undefined,this.prev=P.Undefined}}class c{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let O=this.a;for(;O!==P.Undefined;){const T=O.next;O.prev=P.Undefined,O.next=P.Undefined,O=T}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,T){const k=new P(O);if(this.a===P.Undefined)this.a=k,this.b=k;else if(T){const w=this.b;this.b=k,k.prev=w,w.next=k}else{const w=this.a;this.a=k,k.next=w,w.prev=k}this.c+=1;let A=!1;return()=>{A||(A=!0,this.e(k))}}shift(){if(this.a!==P.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==P.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==P.Undefined&&O.next!==P.Undefined){const T=O.prev;T.next=O.next,O.next.prev=T}else O.prev===P.Undefined&&O.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):O.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):O.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==P.Undefined;)yield O.element,O=O.next}}e.$7c=c}),define(ce[35],le([0,1]),function(ne,e){"use strict";var P,c,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.Touch=e.$Dc=e.$Cc=void 0,e.$zc=O,e.$Ac=T,e.$Bc=k,e.$Kc=g;function O(s,r,t){let a=s.get(r);return a===void 0&&(a=t,s.set(r,a)),a}function T(s){const r=[];return s.forEach((t,a)=>{r.push(`${a} => ${t}`)}),`Map(${s.size}) {${r.join(", ")}}`}function k(s){const r=[];return s.forEach(t=>{r.push(t)}),`Set(${s.size}) {${r.join(", ")}}`}class A{constructor(r,t){this.uri=r,this.value=t}}function w(s){return Array.isArray(s)}class S{static{this.c=r=>r.toString()}constructor(r,t){if(this[P]="ResourceMap",r instanceof S)this.d=new Map(r.d),this.e=t??S.c;else if(w(r)){this.d=new Map,this.e=t??S.c;for(const[a,i]of r)this.set(a,i)}else this.d=new Map,this.e=r??S.c}set(r,t){return this.d.set(this.e(r),new A(r,t)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,t){typeof t<"u"&&(r=r.bind(t));for(const[a,i]of this.d)r(i.value,i.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Cc=S;class m{constructor(r,t){this[c]="ResourceSet",!r||typeof r=="function"?this.c=new S(r):(this.c=new S(t),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,t){this.c.forEach((a,i)=>r.call(t,i,i,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Dc=m;var u;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class ${constructor(){this[C]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,t=u.None){const a=this.c.get(r);if(a)return t!==u.None&&this.m(a,t),a.value}set(r,t,a=u.None){let i=this.c.get(r);if(i)i.value=t,a!==u.None&&this.m(i,a);else{switch(i={key:r,value:t,next:void 0,previous:void 0},a){case u.None:this.k(i);break;case u.AsOld:this.j(i);break;case u.AsNew:this.k(i);break;default:this.k(i);break}this.c.set(r,i),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const t=this.c.get(r);if(t)return this.c.delete(r),this.l(t),this.f--,t.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.l(r),this.f--,r.value}forEach(r,t){const a=this.g;let i=this.d;for(;i;){if(t?r.bind(t)(i.value,i.key,this):r(i.value,i.key,this),this.g!==a)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const r=this,t=this.g;let a=this.d;const i={[Symbol.iterator](){return i},next(){if(r.g!==t)throw new Error("LinkedMap got modified during iteration.");if(a){const n={value:a.key,done:!1};return a=a.next,n}else return{value:void 0,done:!0}}};return i}values(){const r=this,t=this.g;let a=this.d;const i={[Symbol.iterator](){return i},next(){if(r.g!==t)throw new Error("LinkedMap got modified during iteration.");if(a){const n={value:a.value,done:!1};return a=a.next,n}else return{value:void 0,done:!0}}};return i}entries(){const r=this,t=this.g;let a=this.d;const i={[Symbol.iterator](){return i},next(){if(r.g!==t)throw new Error("LinkedMap got modified during iteration.");if(a){const n={value:[a.key,a.value],done:!1};return a=a.next,n}else return{value:void 0,done:!0}}};return i}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let t=this.d,a=this.size;for(;t&&a>r;)this.c.delete(t.key),t=t.next,a--;this.d=t,this.f=a,t&&(t.previous=void 0),this.g++}i(r){if(r>=this.size)return;if(r===0){this.clear();return}let t=this.e,a=this.size;for(;t&&a>r;)this.c.delete(t.key),t=t.previous,a--;this.e=t,this.f=a,t&&(t.next=void 0),this.g++}j(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}k(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}l(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const t=r.next,a=r.previous;if(!t||!a)throw new Error("Invalid list");t.previous=a,a.next=t}r.next=void 0,r.previous=void 0,this.g++}m(r,t){if(!this.d||!this.e)throw new Error("Invalid list");if(!(t!==u.AsOld&&t!==u.AsNew)){if(t===u.AsOld){if(r===this.d)return;const a=r.next,i=r.previous;r===this.e?(i.next=void 0,this.e=i):(a.previous=i,i.next=a),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(t===u.AsNew){if(r===this.e)return;const a=r.next,i=r.previous;r===this.d?(a.previous=void 0,this.d=a):(a.previous=i,i.next=a),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((t,a)=>{r.push([a,t])}),r}fromJSON(r){this.clear();for(const[t,a]of r)this.set(t,a)}}e.$Ec=$;class l extends ${constructor(r,t=1){super(),this.n=r,this.o=Math.min(Math.max(0,t),1)}get limit(){return this.n}set limit(r){this.n=r,this.p()}get ratio(){return this.o}set ratio(r){this.o=Math.min(Math.max(0,r),1),this.p()}get(r,t=u.AsNew){return super.get(r,t)}peek(r){return super.get(r,u.None)}set(r,t){return super.set(r,t,u.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class b extends l{constructor(r,t=1){super(r,t)}q(r){this.h(r)}set(r,t){return super.set(r,t),this.p(),this}}e.$Fc=b;class v extends l{constructor(r,t=1){super(r,t)}q(r){this.i(r)}set(r,t){return this.n<=this.size&&!this.has(r)&&this.q(Math.round(this.n*this.o)-1),super.set(r,t),this}}e.$Gc=v;class d{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let t=this.c.get(r)||0;return t===0?!1:(t--,t===0?this.c.delete(r):this.c.set(r,t),!0)}has(r){return this.c.has(r)}}e.$Hc=d;class p{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[t,a]of r)this.set(t,a)}clear(){this.c.clear(),this.d.clear()}set(r,t){this.c.set(r,t),this.d.set(t,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const t=this.c.get(r);return t===void 0?!1:(this.c.delete(r),this.d.delete(t),!0)}forEach(r,t){this.c.forEach((a,i)=>{r.call(t,a,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Ic=p;class I{constructor(){this.c=new Map}add(r,t){let a=this.c.get(r);a||(a=new Set,this.c.set(r,a)),a.add(t)}delete(r,t){const a=this.c.get(r);a&&(a.delete(t),a.size===0&&this.c.delete(r))}forEach(r,t){const a=this.c.get(r);a&&a.forEach(t)}get(r){const t=this.c.get(r);return t||new Set}}e.$Jc=I;function g(s,r){if(s===r)return!0;if(s.size!==r.size)return!1;for(const[t,a]of s)if(!r.has(t)||r.get(t)!==a)return!1;for(const[t]of r)if(!s.has(t))return!1;return!0}}),define(ce[2],le([0,1,19,131,35,89,64]),function(ne,e,P,c,C,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Lc=void 0,e.$Mc=S,e.$Nc=m,e.$Oc=u,e.$Pc=b,e.$Qc=v,e.$Rc=d,e.$Sc=p,e.$Tc=I,e.$Uc=g,e.$5c=R;const k=!1;let A=null;class w{constructor(){this.b=new Map}static{this.a=0}c(y){let N=this.b.get(y);return N||(N={parent:null,source:null,isSingleton:!1,value:y,idx:w.a++},this.b.set(y,N)),N}trackDisposable(y){const N=this.c(y);N.source||(N.source=new Error().stack)}setParent(y,N){const F=this.c(y);F.parent=N}markAsDisposed(y){this.b.delete(y)}markAsSingleton(y){this.c(y).isSingleton=!0}f(y,N){const F=N.get(y);if(F)return F;const D=y.parent?this.f(this.c(y.parent),N):y;return N.set(y,D),D}getTrackedDisposables(){const y=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,y).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(y=10,N){let F;if(N)F=N;else{const x=new Map,G=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,x).isSingleton);if(G.length===0)return;const ie=new Set(G.map(V=>V.value));if(F=G.filter(V=>!(V.parent&&ie.has(V.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function D(x){function G(V,z){for(;V.length>0&&z.some(te=>typeof te=="string"?te===V[0]:V[0].match(te));)V.shift()}const ie=x.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return G(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const M=new C.$Jc;for(const x of F){const G=D(x);for(let ie=0;ie<=G.length;ie++)M.add(G.slice(0,ie).join(`
`),x)}F.sort((0,P.$8b)(x=>x.idx,P.$0b));let J="",W=0;for(const x of F.slice(0,y)){W++;const G=D(x),ie=[];for(let V=0;V<G.length;V++){let z=G[V];z=`(shared with ${M.get(G.slice(0,V+1).join(`
`)).size}/${F.length} leaks) at ${z}`;const se=M.get(G.slice(0,V).join(`
`)),he=(0,c.$K)([...se].map(q=>D(q)[V]),q=>q);delete he[G[V]];for(const[q,Z]of Object.entries(he))ie.unshift(`    - stacktraces of ${Z.length} other leaks continue with ${q}`);ie.unshift(z)}J+=`


==================== Leaking disposable ${W}/${F.length}: ${x.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return F.length>y&&(J+=`


... and ${F.length-y} more leaking disposables

`),{leaks:F,details:J}}}e.$Lc=w;function S(E){A=E}if(k){const E="__is_disposable_tracked__";S(new class{trackDisposable(y){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{y[E]||console.log(N)},3e3)}setParent(y,N){if(y&&y!==r.None)try{y[E]=!0}catch{}}markAsDisposed(y){if(y&&y!==r.None)try{y[E]=!0}catch{}}markAsSingleton(y){}})}function m(E){return A?.trackDisposable(E),E}function u(E){A?.markAsDisposed(E)}function $(E,y){A?.setParent(E,y)}function l(E,y){if(A)for(const N of E)A.setParent(N,y)}function b(E){return A?.markAsSingleton(E),E}function v(E){return typeof E=="object"&&E!==null&&typeof E.dispose=="function"&&E.dispose.length===0}function d(E){if(T.Iterable.is(E)){const y=[];for(const N of E)if(N)try{N.dispose()}catch(F){y.push(F)}if(y.length===1)throw y[0];if(y.length>1)throw new AggregateError(y,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}function p(E){for(const y of E)v(y)&&y.dispose();return[]}function I(...E){const y=g(()=>d(E));return l(E,y),y}function g(E){const y=m({dispose:(0,O.$fb)(()=>{u(y),E()})});return y}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,m(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(y){if(!y)return y;if(y===this)throw new Error("Cannot register a disposable on itself!");return $(y,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(y),y}delete(y){if(y){if(y===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(y),y.dispose()}}deleteAndLeak(y){y&&this.f.has(y)&&(this.f.delete(y),$(y,null))}}e.$Vc=s;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,m(this),$(this.q,this)}dispose(){u(this),this.q.dispose()}B(y){if(y===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(y)}}e.$Wc=r;class t{constructor(){this.b=!1,m(this)}get value(){return this.b?void 0:this.a}set value(y){this.b||y===this.a||(this.a?.dispose(),y&&$(y,this),this.a=y)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const y=this.a;return this.a=void 0,y&&$(y,null),y}}e.$Xc=t;class a{constructor(y){this.a=new t,this.b=!1,this.a.value=y}get value(){return this.a.value}set value(y){this.b||y===this.a.value||(this.a.value=y)}dispose(){this.b=!0,this.a.dispose()}}e.$Yc=a;class i{constructor(y){this.b=y,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Zc=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(y){let N=y;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,u(this))},this}}e.$1c=n;class o{constructor(){this.a=new Map}acquire(y,...N){let F=this.a.get(y);F||(F={counter:0,object:this.b(y,...N)},this.a.set(y,F));const{object:D}=F,M=(0,O.$fb)(()=>{--F.counter===0&&(this.c(y,F.object),this.a.delete(y))});return F.counter++,{object:D,dispose:M}}}e.$2c=o;class h{constructor(y){this.a=y}async acquire(y,...N){const F=this.a.acquire(y,...N);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(D){throw F.dispose(),D}}}e.$3c=h;class f{constructor(y){this.object=y}dispose(){}}e.$4c=f;function R(E){const y=new s;try{E(y)}finally{y.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,m(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(y){return this.a.has(y)}get size(){return this.a.size}get(y){return this.a.get(y)}set(y,N,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(y)?.dispose(),this.a.set(y,N)}deleteAndDispose(y){this.a.get(y)?.dispose(),this.a.delete(y)}deleteAndLeak(y){const N=this.a.get(y);return this.a.delete(y),N}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$6c=L}),define(ce[66],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var P;(function(c){c[c.Uri=1]="Uri",c[c.Regexp=2]="Regexp",c[c.ScmResource=3]="ScmResource",c[c.ScmResourceGroup=4]="ScmResourceGroup",c[c.ScmProvider=5]="ScmProvider",c[c.CommentController=6]="CommentController",c[c.CommentThread=7]="CommentThread",c[c.CommentThreadInstance=8]="CommentThreadInstance",c[c.CommentThreadReply=9]="CommentThreadReply",c[c.CommentNode=10]="CommentNode",c[c.CommentThreadNode=11]="CommentThreadNode",c[c.TimelineActionContext=12]="TimelineActionContext",c[c.NotebookCellActionContext=13]="NotebookCellActionContext",c[c.NotebookActionContext=14]="NotebookActionContext",c[c.TerminalContext=15]="TerminalContext",c[c.TestItemContext=16]="TestItemContext",c[c.Date=17]="Date",c[c.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(P||(e.MarshalledId=P={}))}),define(ce[91],le([0,1,35]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=void 0,e.$mm=C,e.$nm=T;const c=new P.$Fc(1e4);function C(w){return A(w,"NFC",c)}const O=new P.$Fc(1e4);function T(w){return A(w,"NFD",O)}const k=/[^\u0000-\u0080]/;function A(w,S,m){if(!w)return w;const u=m.get(w);if(u)return u;let $;return k.test(w)?$=w.normalize(S):$=w,m.set(w,$),$}e.$om=function(){const w=/[\u0300-\u036f]/g;return function(S){return T(S).replace(w,"")}}()}),function(){function ne(C){const O=[];typeof C=="number"&&O.push("code/timeOrigin",C);function T(A){O.push(A,Date.now())}function k(){const A=[];for(let w=0;w<O.length;w+=2)A.push({name:O[w],startTime:O[w+1]});return A}return{mark:T,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const T of performance.getEntriesByType("mark"))O.push({name:T.name,startTime:Math.round(C+T.startTime)});return O}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function P(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var c;typeof global=="object"?c=global:typeof self=="object"?c=self:c={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(c)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(c):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),c.perf=P(c))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var c in P)(typeof exports=="object"?exports:ne)[c]=P[c]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function P(c){if(e[c])return e[c].exports;var C=e[c]={i:c,l:!1,exports:{}};return ne[c].call(C.exports,C,C.exports,P),C.l=!0,C.exports}return P.m=ne,P.c=e,P.d=function(c,C,O){P.o(c,C)||Object.defineProperty(c,C,{enumerable:!0,get:O})},P.r=function(c){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(c,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(c,"__esModule",{value:!0})},P.t=function(c,C){if(1&C&&(c=P(c)),8&C||4&C&&typeof c=="object"&&c&&c.__esModule)return c;var O=Object.create(null);if(P.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:c}),2&C&&typeof c!="string")for(var T in c)P.d(O,T,function(k){return c[k]}.bind(null,T));return O},P.n=function(c){var C=c&&c.__esModule?function(){return c.default}:function(){return c};return P.d(C,"a",C),C},P.o=function(c,C){return Object.prototype.hasOwnProperty.call(c,C)},P.p="",P(P.s=0)}([function(ne,e,P){(function(c){var C;e=ne.exports=Z,C=typeof c=="object"&&c.env&&c.env.NODE_DEBUG&&/\bsemver\b/i.test(c.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],A=e.src=[],w=0,S=w++;A[S]="0|[1-9]\\d*";var m=w++;A[m]="[0-9]+";var u=w++;A[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=w++;A[$]="("+A[S]+")\\.("+A[S]+")\\.("+A[S]+")";var l=w++;A[l]="("+A[m]+")\\.("+A[m]+")\\.("+A[m]+")";var b=w++;A[b]="(?:"+A[S]+"|"+A[u]+")";var v=w++;A[v]="(?:"+A[m]+"|"+A[u]+")";var d=w++;A[d]="(?:-("+A[b]+"(?:\\."+A[b]+")*))";var p=w++;A[p]="(?:-?("+A[v]+"(?:\\."+A[v]+")*))";var I=w++;A[I]="[0-9A-Za-z-]+";var g=w++;A[g]="(?:\\+("+A[I]+"(?:\\."+A[I]+")*))";var s=w++,r="v?"+A[$]+A[d]+"?"+A[g]+"?";A[s]="^"+r+"$";var t="[v=\\s]*"+A[l]+A[p]+"?"+A[g]+"?",a=w++;A[a]="^"+t+"$";var i=w++;A[i]="((?:<|>)?=?)";var n=w++;A[n]=A[m]+"|x|X|\\*";var o=w++;A[o]=A[S]+"|x|X|\\*";var h=w++;A[h]="[v=\\s]*("+A[o]+")(?:\\.("+A[o]+")(?:\\.("+A[o]+")(?:"+A[d]+")?"+A[g]+"?)?)?";var f=w++;A[f]="[v=\\s]*("+A[n]+")(?:\\.("+A[n]+")(?:\\.("+A[n]+")(?:"+A[p]+")?"+A[g]+"?)?)?";var R=w++;A[R]="^"+A[i]+"\\s*"+A[h]+"$";var L=w++;A[L]="^"+A[i]+"\\s*"+A[f]+"$";var E=w++;A[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var y=w++;A[y]="(?:~>?)";var N=w++;A[N]="(\\s*)"+A[y]+"\\s+",k[N]=new RegExp(A[N],"g");var F=w++;A[F]="^"+A[y]+A[h]+"$";var D=w++;A[D]="^"+A[y]+A[f]+"$";var M=w++;A[M]="(?:\\^)";var J=w++;A[J]="(\\s*)"+A[M]+"\\s+",k[J]=new RegExp(A[J],"g");var W=w++;A[W]="^"+A[M]+A[h]+"$";var x=w++;A[x]="^"+A[M]+A[f]+"$";var G=w++;A[G]="^"+A[i]+"\\s*("+t+")$|^$";var ie=w++;A[ie]="^"+A[i]+"\\s*("+r+")$|^$";var V=w++;A[V]="(\\s*)"+A[i]+"\\s*("+t+"|"+A[h]+")",k[V]=new RegExp(A[V],"g");var z=w++;A[z]="^\\s*("+A[h]+")\\s+-\\s+("+A[h]+")\\s*$";var te=w++;A[te]="^\\s*("+A[f]+")\\s+-\\s+("+A[f]+")\\s*$";var se=w++;A[se]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)C(he,A[he]),k[he]||(k[he]=new RegExp(A[he]));function q(ae,de){if(ae instanceof Z)return ae;if(typeof ae!="string"||ae.length>O||!(de?k[a]:k[s]).test(ae))return null;try{return new Z(ae,de)}catch{return null}}function Z(ae,de){if(ae instanceof Z){if(ae.loose===de)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Z))return new Z(ae,de);C("SemVer",ae,de),this.loose=de;var me=ae.trim().match(de?k[a]:k[s]);if(!me)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var ke=+Pe;if(ke>=0&&ke<T)return ke}return Pe}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=q,e.valid=function(ae,de){var me=q(ae,de);return me?me.version:null},e.clean=function(ae,de){var me=q(ae.trim().replace(/^[=v]+/,""),de);return me?me.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ae){return C("SemVer.compare",this.version,this.loose,ae),ae instanceof Z||(ae=new Z(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},Z.prototype.compareMain=function(ae){return ae instanceof Z||(ae=new Z(ae,this.loose)),H(this.major,ae.major)||H(this.minor,ae.minor)||H(this.patch,ae.patch)},Z.prototype.comparePre=function(ae){if(ae instanceof Z||(ae=new Z(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var de=0;do{var me=this.prerelease[de],Pe=ae.prerelease[de];if(C("prerelease compare",de,me,Pe),me===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(me===void 0)return-1;if(me!==Pe)return H(me,Pe)}while(++de)},Z.prototype.inc=function(ae,de){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,de,me,Pe){typeof me=="string"&&(Pe=me,me=void 0);try{return new Z(ae,me).inc(de,Pe).version}catch{return null}},e.diff=function(ae,de){if(j(ae,de))return null;var me=q(ae),Pe=q(de);if(me.prerelease.length||Pe.prerelease.length){for(var ke in me)if((ke==="major"||ke==="minor"||ke==="patch")&&me[ke]!==Pe[ke])return"pre"+ke;return"prerelease"}for(var ke in me)if((ke==="major"||ke==="minor"||ke==="patch")&&me[ke]!==Pe[ke])return ke},e.compareIdentifiers=H;var K=/^[0-9]+$/;function H(ae,de){var me=K.test(ae),Pe=K.test(de);return me&&Pe&&(ae=+ae,de=+de),me&&!Pe?-1:Pe&&!me?1:ae<de?-1:ae>de?1:0}function U(ae,de,me){return new Z(ae,me).compare(new Z(de,me))}function Y(ae,de,me){return U(ae,de,me)>0}function B(ae,de,me){return U(ae,de,me)<0}function j(ae,de,me){return U(ae,de,me)===0}function _(ae,de,me){return U(ae,de,me)!==0}function ee(ae,de,me){return U(ae,de,me)>=0}function X(ae,de,me){return U(ae,de,me)<=0}function oe(ae,de,me,Pe){var ke;switch(de){case"===":typeof ae=="object"&&(ae=ae.version),typeof me=="object"&&(me=me.version),ke=ae===me;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof me=="object"&&(me=me.version),ke=ae!==me;break;case"":case"=":case"==":ke=j(ae,me,Pe);break;case"!=":ke=_(ae,me,Pe);break;case">":ke=Y(ae,me,Pe);break;case">=":ke=ee(ae,me,Pe);break;case"<":ke=B(ae,me,Pe);break;case"<=":ke=X(ae,me,Pe);break;default:throw new TypeError("Invalid operator: "+de)}return ke}function ue(ae,de){if(ae instanceof ue){if(ae.loose===de)return ae;ae=ae.value}if(!(this instanceof ue))return new ue(ae,de);C("comparator",ae,de),this.loose=de,this.parse(ae),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(ae,de){return H(de,ae)},e.major=function(ae,de){return new Z(ae,de).major},e.minor=function(ae,de){return new Z(ae,de).minor},e.patch=function(ae,de){return new Z(ae,de).patch},e.compare=U,e.compareLoose=function(ae,de){return U(ae,de,!0)},e.rcompare=function(ae,de,me){return U(de,ae,me)},e.sort=function(ae,de){return ae.sort(function(me,Pe){return e.compare(me,Pe,de)})},e.rsort=function(ae,de){return ae.sort(function(me,Pe){return e.rcompare(me,Pe,de)})},e.gt=Y,e.lt=B,e.eq=j,e.neq=_,e.gte=ee,e.lte=X,e.cmp=oe,e.Comparator=ue;var ge={};function be(ae,de){if(ae instanceof be)return ae.loose===de?ae:new be(ae.raw,de);if(ae instanceof ue)return new be(ae.value,de);if(!(this instanceof be))return new be(ae,de);if(this.loose=de,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Ie(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function pe(ae,de,me,Pe,ke,Fe,Te,Ce,Ue,qe,He,Me,Be){return((de=Ie(me)?"":Ie(Pe)?">="+me+".0.0":Ie(ke)?">="+me+"."+Pe+".0":">="+de)+" "+(Ce=Ie(Ue)?"":Ie(qe)?"<"+(+Ue+1)+".0.0":Ie(He)?"<"+Ue+"."+(+qe+1)+".0":Me?"<="+Ue+"."+qe+"."+He+"-"+Me:"<="+Ce)).trim()}function we(ae,de){for(var me=0;me<ae.length;me++)if(!ae[me].test(de))return!1;if(de.prerelease.length){for(me=0;me<ae.length;me++)if(C(ae[me].semver),ae[me].semver!==ge&&ae[me].semver.prerelease.length>0){var Pe=ae[me].semver;if(Pe.major===de.major&&Pe.minor===de.minor&&Pe.patch===de.patch)return!0}return!1}return!0}function Ee(ae,de,me){try{de=new be(de,me)}catch{return!1}return de.test(ae)}function Se(ae,de,me,Pe){var ke,Fe,Te,Ce,Ue;switch(ae=new Z(ae,Pe),de=new be(de,Pe),me){case">":ke=Y,Fe=X,Te=B,Ce=">",Ue=">=";break;case"<":ke=B,Fe=ee,Te=Y,Ce="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(ae,de,Pe))return!1;for(var qe=0;qe<de.set.length;++qe){var He=de.set[qe],Me=null,Be=null;if(He.forEach(function(ze){ze.semver===ge&&(ze=new ue(">=0.0.0")),Me=Me||ze,Be=Be||ze,ke(ze.semver,Me.semver,Pe)?Me=ze:Te(ze.semver,Be.semver,Pe)&&(Be=ze)}),Me.operator===Ce||Me.operator===Ue||(!Be.operator||Be.operator===Ce)&&Fe(ae,Be.semver)||Be.operator===Ue&&Te(ae,Be.semver))return!1}return!0}ue.prototype.parse=function(ae){var de=this.loose?k[G]:k[ie],me=ae.match(de);if(!me)throw new TypeError("Invalid comparator: "+ae);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new Z(me[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(ae){return C("Comparator.test",ae,this.loose),this.semver===ge||(typeof ae=="string"&&(ae=new Z(ae,this.loose)),oe(ae,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(ae,de){if(!(ae instanceof ue))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new be(ae.value,de),Ee(this.value,me,de);if(ae.operator==="")return me=new be(this.value,de),Ee(ae.semver,me,de);var Pe=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),ke=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Fe=this.semver.version===ae.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Ce=oe(this.semver,"<",ae.semver,de)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ue=oe(this.semver,">",ae.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Pe||ke||Fe&&Te||Ce||Ue},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ae){var de=this.loose;ae=ae.trim(),C("range",ae,de);var me=de?k[te]:k[z];ae=ae.replace(me,pe),C("hyphen replace",ae),ae=ae.replace(k[V],"$1$2$3"),C("comparator trim",ae,k[V]),ae=(ae=(ae=ae.replace(k[N],"$1~")).replace(k[J],"$1^")).split(/\s+/).join(" ");var Pe=de?k[G]:k[ie],ke=ae.split(" ").map(function(Fe){return function(Te,Ce){return C("comp",Te),Te=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(He){return function(Me,Be){C("caret",Me,Be);var ze=Be?k[x]:k[W];return Me.replace(ze,function(We,Le,re,fe,$e){var ye;return C("caret",Me,We,Le,re,fe,$e),Ie(Le)?ye="":Ie(re)?ye=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ie(fe)?ye=Le==="0"?">="+Le+"."+re+".0 <"+Le+"."+(+re+1)+".0":">="+Le+"."+re+".0 <"+(+Le+1)+".0.0":$e?(C("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=Le==="0"?re==="0"?">="+Le+"."+re+"."+fe+$e+" <"+Le+"."+re+"."+(+fe+1):">="+Le+"."+re+"."+fe+$e+" <"+Le+"."+(+re+1)+".0":">="+Le+"."+re+"."+fe+$e+" <"+(+Le+1)+".0.0"):(C("no pr"),ye=Le==="0"?re==="0"?">="+Le+"."+re+"."+fe+" <"+Le+"."+re+"."+(+fe+1):">="+Le+"."+re+"."+fe+" <"+Le+"."+(+re+1)+".0":">="+Le+"."+re+"."+fe+" <"+(+Le+1)+".0.0"),C("caret return",ye),ye})}(He,qe)}).join(" ")}(Te,Ce),C("caret",Te),Te=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(He){return function(Me,Be){var ze=Be?k[D]:k[F];return Me.replace(ze,function(We,Le,re,fe,$e){var ye;return C("tilde",Me,We,Le,re,fe,$e),Ie(Le)?ye="":Ie(re)?ye=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ie(fe)?ye=">="+Le+"."+re+".0 <"+Le+"."+(+re+1)+".0":$e?(C("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=">="+Le+"."+re+"."+fe+$e+" <"+Le+"."+(+re+1)+".0"):ye=">="+Le+"."+re+"."+fe+" <"+Le+"."+(+re+1)+".0",C("tilde return",ye),ye})}(He,qe)}).join(" ")}(Te,Ce),C("tildes",Te),Te=function(Ue,qe){return C("replaceXRanges",Ue,qe),Ue.split(/\s+/).map(function(He){return function(Me,Be){Me=Me.trim();var ze=Be?k[L]:k[R];return Me.replace(ze,function(We,Le,re,fe,$e,ye){C("xRange",Me,We,Le,re,fe,$e,ye);var Ae=Ie(re),Ne=Ae||Ie(fe),je=Ne||Ie($e);return Le==="="&&je&&(Le=""),Ae?We=Le===">"||Le==="<"?"<0.0.0":"*":Le&&je?(Ne&&(fe=0),je&&($e=0),Le===">"?(Le=">=",Ne?(re=+re+1,fe=0,$e=0):je&&(fe=+fe+1,$e=0)):Le==="<="&&(Le="<",Ne?re=+re+1:fe=+fe+1),We=Le+re+"."+fe+"."+$e):Ne?We=">="+re+".0.0 <"+(+re+1)+".0.0":je&&(We=">="+re+"."+fe+".0 <"+re+"."+(+fe+1)+".0"),C("xRange return",We),We})}(He,qe)}).join(" ")}(Te,Ce),C("xrange",Te),Te=function(Ue,qe){return C("replaceStars",Ue,qe),Ue.trim().replace(k[se],"")}(Te,Ce),C("stars",Te),Te}(Fe,de)}).join(" ").split(/\s+/);return this.loose&&(ke=ke.filter(function(Fe){return!!Fe.match(Pe)})),ke=ke.map(function(Fe){return new ue(Fe,de)})},be.prototype.intersects=function(ae,de){if(!(ae instanceof be))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Pe){return ae.set.some(function(ke){return ke.every(function(Fe){return Pe.intersects(Fe,de)})})})})},e.toComparators=function(ae,de){return new be(ae,de).set.map(function(me){return me.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new Z(ae,this.loose));for(var de=0;de<this.set.length;de++)if(we(this.set[de],ae))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(ae,de,me){var Pe=null,ke=null;try{var Fe=new be(de,me)}catch{return null}return ae.forEach(function(Te){Fe.test(Te)&&(Pe&&ke.compare(Te)!==-1||(ke=new Z(Pe=Te,me)))}),Pe},e.minSatisfying=function(ae,de,me){var Pe=null,ke=null;try{var Fe=new be(de,me)}catch{return null}return ae.forEach(function(Te){Fe.test(Te)&&(Pe&&ke.compare(Te)!==1||(ke=new Z(Pe=Te,me)))}),Pe},e.validRange=function(ae,de){try{return new be(ae,de).range||"*"}catch{return null}},e.ltr=function(ae,de,me){return Se(ae,de,"<",me)},e.gtr=function(ae,de,me){return Se(ae,de,">",me)},e.outside=Se,e.prerelease=function(ae,de){var me=q(ae,de);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(ae,de,me){return ae=new be(ae,me),de=new be(de,me),ae.intersects(de)},e.coerce=function(ae){if(ae instanceof Z)return ae;if(typeof ae!="string")return null;var de=ae.match(k[E]);return de==null?null:q((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,P(1))},function(ne,e){var P,c,C=ne.exports={};function O(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function k(v){if(P===setTimeout)return setTimeout(v,0);if((P===O||!P)&&setTimeout)return P=setTimeout,setTimeout(v,0);try{return P(v,0)}catch{try{return P.call(null,v,0)}catch{return P.call(this,v,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:O}catch{P=O}try{c=typeof clearTimeout=="function"?clearTimeout:T}catch{c=T}})();var A,w=[],S=!1,m=-1;function u(){S&&A&&(S=!1,A.length?w=A.concat(w):m=-1,w.length&&$())}function $(){if(!S){var v=k(u);S=!0;for(var d=w.length;d;){for(A=w,w=[];++m<d;)A&&A[m].run();m=-1,d=w.length}A=null,S=!1,function(p){if(c===clearTimeout)return clearTimeout(p);if((c===T||!c)&&clearTimeout)return c=clearTimeout,clearTimeout(p);try{c(p)}catch{try{return c.call(null,p)}catch{return c.call(this,p)}}}(v)}}function l(v,d){this.fun=v,this.array=d}function b(){}C.nextTick=function(v){var d=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)d[p-1]=arguments[p];w.push(new l(v,d)),w.length!==1||S||k($)},l.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=b,C.addListener=b,C.once=b,C.off=b,C.removeListener=b,C.removeAllListeners=b,C.emit=b,C.prependListener=b,C.prependOnceListener=b,C.listeners=function(v){return[]},C.binding=function(v){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(v){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(ce[133],le([0,1]),function(ne,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;class c{constructor(k,A,w){this.level=k,this.key=A,this.value=w,this.forward=[]}}const C=void 0;class O{constructor(k,A=2**16){this.comparator=k,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(A)|0),this.e=new c(this.c,C,C)}get size(){return this.f}clear(){this.e=new c(this.c,C,C),this.f=0}has(k){return!!O.g(this,k,this.comparator)}get(k){return O.g(this,k,this.comparator)?.value}set(k,A){return O.h(this,k,A,this.comparator)&&(this.f+=1),this}delete(k){const A=O.k(this,k,this.comparator);return A&&(this.f-=1),A}forEach(k,A){let w=this.e.forward[0];for(;w;)k.call(A,w.value,w.key,this),w=w.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",A=this.e.forward[0];for(;A;)k+=`node(${A.key}, ${A.value}, lvl:${A.level})`,A=A.forward[0];return k}static g(k,A,w){let S=k.e;for(let m=k.d-1;m>=0;m--)for(;S.forward[m]&&w(S.forward[m].key,A)<0;)S=S.forward[m];if(S=S.forward[0],S&&w(S.key,A)===0)return S}static h(k,A,w,S){const m=[];let u=k.e;for(let $=k.d-1;$>=0;$--){for(;u.forward[$]&&S(u.forward[$].key,A)<0;)u=u.forward[$];m[$]=u}if(u=u.forward[0],u&&S(u.key,A)===0)return u.value=w,!1;{const $=O.j(k);if($>k.d){for(let l=k.d;l<$;l++)m[l]=k.e;k.d=$}u=new c($,A,w);for(let l=0;l<$;l++)u.forward[l]=m[l].forward[l],m[l].forward[l]=u;return!0}}static j(k,A=.5){let w=1;for(;Math.random()<A&&w<k.c;)w+=1;return w}static k(k,A,w){const S=[];let m=k.e;for(let u=k.d-1;u>=0;u--){for(;m.forward[u]&&w(m.forward[u].key,A)<0;)m=m.forward[u];S[u]=m}if(m=m.forward[0],!m||w(m.key,A)!==0)return!1;for(let u=0;u<k.d&&S[u].forward[u]===m;u++)S[u].forward[u]=m.forward[u];for(;k.d>0&&k.e.forward[k.d-1]===C;)k.d-=1;return!0}}e.$Qs=O}),define(ce[55],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class c{static create(O){return new c(O)}constructor(O){this.c=P&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ge=c}),define(ce[3],le([0,1,8,89,2,90,55]),function(ne,e,P,c,C,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$ie=e.Event=void 0,e.$je=$;const k=!1,A=!1,w=!1;var S;(function(D){D.None=()=>C.$Wc.None;function M(pe){if(w){const{onDidAddListener:we}=pe,Ee=b.create();let Se=0;pe.onDidAddListener=()=>{++Se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ee.print()),we?.()}}}function J(pe,we){return q(pe,()=>{},0,void 0,!0,void 0,we)}D.defer=J;function W(pe){return(we,Ee=null,Se)=>{let ae=!1,de;return de=pe(me=>{if(!ae)return de?de.dispose():ae=!0,we.call(Ee,me)},null,Se),ae&&de.dispose(),de}}D.once=W;function x(pe,we,Ee){return se((Se,ae=null,de)=>pe(me=>Se.call(ae,we(me)),null,de),Ee)}D.map=x;function G(pe,we,Ee){return se((Se,ae=null,de)=>pe(me=>{we(me),Se.call(ae,me)},null,de),Ee)}D.forEach=G;function ie(pe,we,Ee){return se((Se,ae=null,de)=>pe(me=>we(me)&&Se.call(ae,me),null,de),Ee)}D.filter=ie;function V(pe){return pe}D.signal=V;function z(...pe){return(we,Ee=null,Se)=>{const ae=(0,C.$Tc)(...pe.map(de=>de(me=>we.call(Ee,me))));return he(ae,Se)}}D.any=z;function te(pe,we,Ee,Se){let ae=Ee;return x(pe,de=>(ae=we(ae,de),ae),Se)}D.reduce=te;function se(pe,we){let Ee;const Se={onWillAddFirstListener(){Ee=pe(ae.fire,ae)},onDidRemoveLastListener(){Ee?.dispose()}};we||M(Se);const ae=new t(Se);return we?.add(ae),ae.event}function he(pe,we){return we instanceof Array?we.push(pe):we&&we.add(pe),pe}function q(pe,we,Ee=100,Se=!1,ae=!1,de,me){let Pe,ke,Fe,Te=0,Ce;const Ue={leakWarningThreshold:de,onWillAddFirstListener(){Pe=pe(He=>{Te++,ke=we(ke,He),Se&&!Fe&&(qe.fire(ke),ke=void 0),Ce=()=>{const Me=ke;ke=void 0,Fe=void 0,(!Se||Te>1)&&qe.fire(Me),Te=0},typeof Ee=="number"?(clearTimeout(Fe),Fe=setTimeout(Ce,Ee)):Fe===void 0&&(Fe=0,queueMicrotask(Ce))})},onWillRemoveListener(){ae&&Te>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,Pe.dispose()}};me||M(Ue);const qe=new t(Ue);return me?.add(qe),qe.event}D.debounce=q;function Z(pe,we=0,Ee){return D.debounce(pe,(Se,ae)=>Se?(Se.push(ae),Se):[ae],we,void 0,!0,void 0,Ee)}D.accumulate=Z;function K(pe,we=(Se,ae)=>Se===ae,Ee){let Se=!0,ae;return ie(pe,de=>{const me=Se||!we(de,ae);return Se=!1,ae=de,me},Ee)}D.latch=K;function H(pe,we,Ee){return[D.filter(pe,we,Ee),D.filter(pe,Se=>!we(Se),Ee)]}D.split=H;function U(pe,we=!1,Ee=[],Se){let ae=Ee.slice(),de=pe(ke=>{ae?ae.push(ke):Pe.fire(ke)});Se&&Se.add(de);const me=()=>{ae?.forEach(ke=>Pe.fire(ke)),ae=null},Pe=new t({onWillAddFirstListener(){de||(de=pe(ke=>Pe.fire(ke)),Se&&Se.add(de))},onDidAddFirstListener(){ae&&(we?setTimeout(me):me())},onDidRemoveLastListener(){de&&de.dispose(),de=null}});return Se&&Se.add(Pe),Pe.event}D.buffer=U;function Y(pe,we){return(Se,ae,de)=>{const me=we(new j);return pe(function(Pe){const ke=me.evaluate(Pe);ke!==B&&Se.call(ae,ke)},void 0,de)}}D.chain=Y;const B=Symbol("HaltChainable");class j{constructor(){this.f=[]}map(we){return this.f.push(we),this}forEach(we){return this.f.push(Ee=>(we(Ee),Ee)),this}filter(we){return this.f.push(Ee=>we(Ee)?Ee:B),this}reduce(we,Ee){let Se=Ee;return this.f.push(ae=>(Se=we(Se,ae),Se)),this}latch(we=(Ee,Se)=>Ee===Se){let Ee=!0,Se;return this.f.push(ae=>{const de=Ee||!we(ae,Se);return Ee=!1,Se=ae,de?ae:B}),this}evaluate(we){for(const Ee of this.f)if(we=Ee(we),we===B)break;return we}}function _(pe,we,Ee=Se=>Se){const Se=(...Pe)=>me.fire(Ee(...Pe)),ae=()=>pe.on(we,Se),de=()=>pe.removeListener(we,Se),me=new t({onWillAddFirstListener:ae,onDidRemoveLastListener:de});return me.event}D.fromNodeEventEmitter=_;function ee(pe,we,Ee=Se=>Se){const Se=(...Pe)=>me.fire(Ee(...Pe)),ae=()=>pe.addEventListener(we,Se),de=()=>pe.removeEventListener(we,Se),me=new t({onWillAddFirstListener:ae,onDidRemoveLastListener:de});return me.event}D.fromDOMEventEmitter=ee;function X(pe){return new Promise(we=>W(pe)(we))}D.toPromise=X;function oe(pe){const we=new t;return pe.then(Ee=>{we.fire(Ee)},()=>{we.fire(void 0)}).finally(()=>{we.dispose()}),we.event}D.fromPromise=oe;function ue(pe,we,Ee){return we(Ee),pe(Se=>we(Se))}D.runAndSubscribe=ue;class ge{constructor(we,Ee){this._observable=we,this.f=0,this.g=!1;const Se={onWillAddFirstListener:()=>{we.addObserver(this)},onDidRemoveLastListener:()=>{we.removeObserver(this)}};Ee||M(Se),this.emitter=new t(Se),Ee&&Ee.add(this.emitter)}beginUpdate(we){this.f++}handlePossibleChange(we){}handleChange(we,Ee){this.g=!0}endUpdate(we){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function be(pe,we){return new ge(pe,we).emitter.event}D.fromObservable=be;function Ie(pe){return(we,Ee,Se)=>{let ae=0,de=!1;const me={beginUpdate(){ae++},endUpdate(){ae--,ae===0&&(pe.reportChanges(),de&&(de=!1,we.call(Ee)))},handlePossibleChange(){},handleChange(){de=!0}};pe.addObserver(me),pe.reportChanges();const Pe={dispose(){pe.removeObserver(me)}};return Se instanceof C.$Vc?Se.add(Pe):Array.isArray(Se)&&Se.push(Pe),Pe}}D.fromObservableLight=Ie})(S||(e.Event=S={}));class m{static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${m.f++}`,m.all.add(this)}start(M){this.g=new T.$ge,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}e.$ie=m;let u=-1;function $(D){const M=u;return u=D,{dispose(){u=M}}}class l{static{this.f=1}constructor(M,J,W=(l.f++).toString(16).padStart(3,"0")){this.j=M,this.threshold=J,this.name=W,this.h=0}dispose(){this.g?.clear()}check(M,J){const W=this.threshold;if(W<=0||J<W)return;this.g||(this.g=new Map);const x=this.g.get(M.value)||0;if(this.g.set(M.value,x+1),this.h-=1,this.h<=0){this.h=W*.5;const[G,ie]=this.getMostFrequentStack(),V=`[${this.name}] potential listener LEAK detected, having ${J} listeners already. MOST frequent listener (${ie}):`;console.warn(V),console.warn(G);const z=new v(V,G);this.j(z)}return()=>{const G=this.g.get(M.value)||0;this.g.set(M.value,G-1)}}getMostFrequentStack(){if(!this.g)return;let M,J=0;for(const[W,x]of this.g)(!M||J<x)&&(M=[W,x],J=x);return M}}class b{static create(){const M=new Error;return new b(M.stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v extends Error{constructor(M,J){super(M),this.name="ListenerLeakError",this.stack=J}}e.$ke=v;class d extends Error{constructor(M,J){super(M),this.name="ListenerRefusalError",this.stack=J}}e.$le=d;let p=0;class I{constructor(M){this.value=M,this.id=p++}}const g=2,s=(D,M)=>{if(D instanceof I)M(D);else for(let J=0;J<D.length;J++){const W=D[J];W&&M(W)}};let r;if(k){const D=[];setInterval(()=>{D.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(D.join(`
`)),D.length=0)},3e3),r=new FinalizationRegistry(M=>{typeof M=="string"&&D.push(M)})}class t{constructor(M){this.z=0,this.f=M,this.g=u>0||this.f?.leakWarningThreshold?new l(M?.onListenerError??P.$3,this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new m(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(A){const M=this.u;queueMicrotask(()=>{s(M,J=>J.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,J,W)=>{if(this.g&&this.z>this.g.threshold**2){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(z);const te=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],se=new d(`${z}. HINT: Stack shows most frequent listener (${te[1]}-times)`,te[0]);return(this.f?.onListenerError||P.$3)(se),C.$Wc.None}if(this.m)return C.$Wc.None;J&&(M=M.bind(J));const x=new I(M);let G,ie;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(x.stack=b.create(),G=this.g.check(x.stack,this.z+1)),A&&(x.stack=ie??b.create()),this.u?this.u instanceof I?(this.w??=new i,this.u=[this.u,x]):this.u.push(x):(this.f?.onWillAddFirstListener?.(this),this.u=x,this.f?.onDidAddFirstListener?.(this)),this.z++;const V=(0,C.$Uc)(()=>{r?.unregister(V),G?.(),this.A(x)});if(W instanceof C.$Vc?W.add(V):Array.isArray(W)&&W.push(V),r){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),te=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);r.register(V,te?.[2]??z,V)}return V},this.q}A(M){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const J=this.u,W=J.indexOf(M);if(W===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,J[W]=void 0;const x=this.w.current===this;if(this.z*g<=J.length){let G=0;for(let ie=0;ie<J.length;ie++)J[ie]?J[G++]=J[ie]:x&&(this.w.end--,G<this.w.i&&this.w.i--);J.length=G}}B(M,J){if(!M)return;const W=this.f?.onListenerError||P.$3;if(!W){M.value(J);return}try{M.value(J)}catch(x){W(x)}}C(M){const J=M.current.u;for(;M.i<M.end;)this.B(J[M.i++],M.value);M.reset()}fire(M){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof I)this.B(this.u,M);else{const J=this.w;J.enqueue(this,M,this.u.length),this.C(J)}this.j?.stop()}hasListeners(){return this.z>0}}e.$me=t;const a=()=>new i;e.$ne=a;class i{constructor(){this.i=-1,this.end=0}enqueue(M,J,W){this.i=0,this.end=W,this.current=M,this.value=J}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends t{async fireAsync(M,J,W){if(this.u)for(this.h||(this.h=new O.$7c),s(this.u,x=>this.h.push([x.value,M]));this.h.size>0&&!J.isCancellationRequested;){const[x,G]=this.h.shift(),ie=[],V={...G,token:J,waitUntil:z=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");W&&(z=W(z,x)),ie.push(z)}};try{x(V)}catch(z){(0,P.$3)(z);continue}Object.freeze(ie),await Promise.allSettled(ie).then(z=>{for(const te of z)te.status==="rejected"&&(0,P.$3)(te.reason)})}}}e.$oe=n;class o extends t{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new O.$7c,this.t=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.t(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.z&&(this.h!==0?this.s.push(M):super.fire(M))}}e.$pe=o;class h extends o{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}e.$qe=h;class f extends t{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(J=>super.fire(J)),this.h=[]}))}}e.$re=f;class R{constructor(){this.g=!1,this.h=[],this.f=new t({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const J={event:M,listener:null};this.h.push(J),this.g&&this.m(J);const W=()=>{this.g&&this.o(J);const x=this.h.indexOf(J);this.h.splice(x,1)};return(0,C.$Uc)((0,c.$fb)(W))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(J=>this.f.fire(J))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}e.$se=R;class L{constructor(M,J,W,x){this.f=new C.$Vc;const G=this.f.add(new R),ie=this.f.add(new C.$6c);function V(z){ie.set(z,G.add(x(z)))}for(const z of M)V(z);this.f.add(J(z=>{V(z)})),this.f.add(W(z=>{ie.deleteAndDispose(z)})),this.event=G.event}dispose(){this.f.dispose()}}e.$te=L;class E{constructor(){this.f=[]}wrapEvent(M,J,W){return(x,G,ie)=>M(V=>{const z=this.f[this.f.length-1];if(!J){z?z.buffers.push(()=>x.call(G,V)):x.call(G,V);return}const te=z;if(!te){x.call(G,J(W,V));return}te.items??=[],te.items.push(V),te.buffers.length===0&&z.buffers.push(()=>{te.reducedResult??=W?te.items.reduce(J,W):te.items.reduce(J),x.call(G,te.reducedResult)})},void 0,ie)}bufferEvents(M){const J={buffers:new Array};this.f.push(J);const W=M();return this.f.pop(),J.buffers.forEach(x=>x()),W}}e.$ue=E;class y{constructor(){this.f=!1,this.g=S.None,this.h=C.$Wc.None,this.j=new t({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ve=y;class N{static const(M){return new F(M)}constructor(M){this.g=M,this.f=new t,this.onDidChange=this.f.event}get value(){return this.g}set value(M){M!==this.g&&(this.g=M,this.f.fire(void 0))}}e.$we=N;class F{constructor(M){this.value=M,this.onDidChange=S.None}}}),define(ce[26],le([0,1,3]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.CancellationToken=void 0,e.$ye=k;const c=Object.freeze(function(A,w){const S=setTimeout(A.bind(w),0);return{dispose(){clearTimeout(S)}}});var C;(function(A){function w(S){return S===A.None||S===A.Cancelled||S instanceof O?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}A.isCancellationToken=w,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:c})})(C||(e.CancellationToken=C={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?c:(this.b||(this.b=new P.$me),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(w){this.f=void 0,this.g=void 0,this.g=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new O),this.f}cancel(){this.f?this.f instanceof O&&this.f.cancel():this.f=C.Cancelled}dispose(w=!1){w&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof O&&this.f.dispose():this.f=C.None}}e.$xe=T;function k(A){const w=new T;return A.add({dispose(){w.cancel()}}),w.token}}),define(ce[134],le([0,1,26]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$af=e.$_e=e.$0e=void 0,e.$$e=C;class c{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new P.$xe,w=this.b(A.token);return this.a={promise:w,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.$0e=c;function C(k){return k}class O{constructor(A,w){this.a=void 0,this.b=void 0,typeof A=="function"?(this.c=A,this.d=C):(this.c=w,this.d=A.getCacheKey)}get(A){const w=this.d(A);return this.b!==w&&(this.b=w,this.a=this.c(A)),this.a}}e.$_e=O;class T{get cachedValues(){return this.a}constructor(A,w){this.a=new Map,this.b=new Map,typeof A=="function"?(this.c=A,this.d=C):(this.c=w,this.d=A.getCacheKey)}get(A){const w=this.d(A);if(this.b.has(w))return this.b.get(w);const S=this.c(A);return this.a.set(A,S),this.b.set(w,S),S}}e.$af=T}),define(ce[51],le([0,1,8,2]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=C,e.$Ae=O,e.$Be=T,e.$Ce=k,e.$De=w,e.$Ee=S,e.$Fe=m,e.$Ge=u,e.$He=$,e.$Ie=l,e.$Je=b,e.$Ke=v,e.$Le=d,e.$Me=p,e.$Ne=I;function C(g){const s=g;return s?typeof s.read=="function":!1}function O(g){const s=g;return s?[s.on,s.pause,s.resume,s.destroy].every(r=>typeof r=="function"):!1}function T(g){const s=g;return s?O(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function k(g,s){return new A(g,s)}class A{constructor(s,r){this.e=s,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(r=>r(s))}h(s){this.c.error.length===0?(0,P.$3)(s):this.c.error.slice(0).forEach(r=>r(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,r){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(s,r){if(this.a.destroyed)return;let t;switch(s){case"data":t=this.c.data;break;case"end":t=this.c.end;break;case"error":t=this.c.error;break}if(t){const a=t.indexOf(r);a>=0&&t.splice(a,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(t=>t())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(g,s){const r=[];let t;for(;(t=g.read())!==null;)r.push(t);return s(r)}function S(g,s,r){const t=[];let a;for(;(a=g.read())!==null&&t.length<r;)t.push(a);return a===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof a<"u"){const i=a;return a=void 0,i}return g.read()}}}function m(g,s){return new Promise((r,t)=>{const a=[];u(g,{onData:i=>{s&&a.push(i)},onError:i=>{s?t(i):r(void 0)},onEnd:()=>{r(s?s(a):void 0)}})})}function u(g,s,r){g.on("error",t=>{r?.isCancellationRequested||s.onError(t)}),g.on("end",()=>{r?.isCancellationRequested||s.onEnd()}),g.on("data",t=>{r?.isCancellationRequested||s.onData(t)})}function $(g,s){return new Promise((r,t)=>{const a=new c.$Vc,i=[],n=f=>{if(i.push(f),i.length>s)return a.dispose(),g.pause(),r({stream:g,buffer:i,ended:!1})},o=f=>(a.dispose(),t(f)),h=()=>(a.dispose(),r({stream:g,buffer:i,ended:!0}));a.add((0,c.$Uc)(()=>g.removeListener("error",o))),g.on("error",o),a.add((0,c.$Uc)(()=>g.removeListener("end",h))),g.on("end",h),a.add((0,c.$Uc)(()=>g.removeListener("data",n))),g.on("data",n)})}function l(g,s){const r=k(s);return r.end(g),r}function b(){const g=k(()=>{throw new Error("not supported")});return g.end(),g}function v(g){let s=!1;return{read:()=>s?null:(s=!0,g)}}function d(g,s,r){const t=k(r);return u(g,{onData:a=>t.write(s.data(a)),onError:a=>t.error(s.error?s.error(a):a),onEnd:()=>t.end()}),t}function p(g,s,r){let t=!1;return{read:()=>{const a=s.read();return t?a:(t=!0,a!==null?r([g,a]):g)}}}function I(g,s,r){let t=!1;const a=k(r);return u(s,{onData:i=>t?a.write(i):(t=!0,a.write(r([g,i]))),onError:i=>a.error(i),onEnd:()=>{t||(t=!0,a.write(g)),a.end()}}),a}});var kt=this&&this.__createBinding||(Object.create?function(ne,e,P,c){c===void 0&&(c=P);var C=Object.getOwnPropertyDescriptor(e,P);(!C||("get"in C?!e.__esModule:C.writable||C.configurable))&&(C={enumerable:!0,get:function(){return e[P]}}),Object.defineProperty(ne,c,C)}:function(ne,e,P,c){c===void 0&&(c=P),ne[c]=e[P]}),At=this&&this.__setModuleDefault||(Object.create?function(ne,e){Object.defineProperty(ne,"default",{enumerable:!0,value:e})}:function(ne,e){ne.default=e}),Oe=this&&this.__importStar||function(ne){if(ne&&ne.__esModule)return ne;var e={};if(ne!=null)for(var P in ne)P!=="default"&&Object.prototype.hasOwnProperty.call(ne,P)&&kt(e,ne,P);return At(e,ne),e};define(ce[15],le([0,1,54,51]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=w,e.$Qe=S,e.$Re=m,e.$Se=u,e.$Te=$,e.$Ue=l,e.$Ve=b,e.$We=v,e.$Xe=d,e.$Ye=p,e.$Ze=I,e.$1e=g,e.$2e=s,e.$3e=r,e.$4e=t,e.$5e=a,e.$6e=i,e.$7e=n,e.$8e=o,e.$9e=R,c=Oe(c);const C=typeof Buffer<"u",O=new P.$X(()=>new Uint8Array(256));let T,k;class A{static alloc(E){return C?new A(Buffer.allocUnsafe(E)):new A(new Uint8Array(E))}static wrap(E){return C&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new A(E)}static fromString(E,y){return!(y?.dontUseNodeBuffer||!1)&&C?new A(Buffer.from(E)):(T||(T=new TextEncoder),new A(T.encode(E)))}static fromByteArray(E){const y=A.alloc(E.length);for(let N=0,F=E.length;N<F;N++)y.buffer[N]=E[N];return y}static concat(E,y){if(typeof y>"u"){y=0;for(let D=0,M=E.length;D<M;D++)y+=E[D].byteLength}const N=A.alloc(y);let F=0;for(let D=0,M=E.length;D<M;D++){const J=E[D];N.set(J,F),F+=J.byteLength}return N}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=A.alloc(this.byteLength);return E.set(this),E}toString(){return C?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(E,y){return new A(this.buffer.subarray(E,y))}set(E,y){if(E instanceof A)this.buffer.set(E.buffer,y);else if(E instanceof Uint8Array)this.buffer.set(E,y);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),y);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return u(this.buffer,E)}writeUInt32BE(E,y){$(this.buffer,E,y)}readUInt32LE(E){return l(this.buffer,E)}writeUInt32LE(E,y){b(this.buffer,E,y)}readUInt8(E){return v(this.buffer,E)}writeUInt8(E,y){d(this.buffer,E,y)}indexOf(E,y=0){return w(this.buffer,E instanceof A?E.buffer:E,y)}}e.$Oe=A;function w(L,E,y=0){const N=E.byteLength,F=L.byteLength;if(N===0)return 0;if(N===1)return L.indexOf(E[0]);if(N>F-y)return-1;const D=O.value;D.fill(E.length);for(let x=0;x<E.length;x++)D[E[x]]=E.length-x-1;let M=y+E.length-1,J=M,W=-1;for(;M<F;)if(L[M]===E[J]){if(J===0){W=M;break}M--,J--}else M+=Math.max(E.length-J,D[L[M]]),J=E.length-1;return W}function S(L,E){return L[E+0]<<0>>>0|L[E+1]<<8>>>0}function m(L,E,y){L[y+0]=E&255,E=E>>>8,L[y+1]=E&255}function u(L,E){return L[E]*2**24+L[E+1]*2**16+L[E+2]*2**8+L[E+3]}function $(L,E,y){L[y+3]=E,E=E>>>8,L[y+2]=E,E=E>>>8,L[y+1]=E,E=E>>>8,L[y]=E}function l(L,E){return L[E+0]<<0>>>0|L[E+1]<<8>>>0|L[E+2]<<16>>>0|L[E+3]<<24>>>0}function b(L,E,y){L[y+0]=E&255,E=E>>>8,L[y+1]=E&255,E=E>>>8,L[y+2]=E&255,E=E>>>8,L[y+3]=E&255}function v(L,E){return L[E]}function d(L,E,y){L[y]=E}function p(L){return c.$De(L,E=>A.concat(E))}function I(L){return c.$Ke(L)}function g(L){return c.$Fe(L,E=>A.concat(E))}async function s(L){return L.ended?A.concat(L.buffer):A.concat([...L.buffer,await g(L.stream)])}function r(L){return c.$Ie(L,E=>A.concat(E))}function t(L){return c.$Le(L,{data:E=>typeof E=="string"?A.fromString(E):A.wrap(E)},E=>A.concat(E))}function a(L){return c.$Ce(E=>A.concat(E),L)}function i(L,E){return c.$Me(L,E,y=>A.concat(y))}function n(L,E){return c.$Ne(L,E,y=>A.concat(y))}function o(L){let E=0,y=0,N=0;const F=new Uint8Array(Math.floor(L.length/4*3)),D=J=>{switch(y){case 3:F[N++]=E|J,y=0;break;case 2:F[N++]=E|J>>>2,E=J<<6,y=3;break;case 1:F[N++]=E|J>>>4,E=J<<4,y=2;break;default:E=J<<2,y=1}};for(let J=0;J<L.length;J++){const W=L.charCodeAt(J);if(W>=65&&W<=90)D(W-65);else if(W>=97&&W<=122)D(W-97+26);else if(W>=48&&W<=57)D(W-48+52);else if(W===43||W===45)D(62);else if(W===47||W===95)D(63);else{if(W===61)break;throw new SyntaxError(`Unexpected base64 character ${L[J]}`)}}const M=N;for(;y>0;)D(0);return A.wrap(F).slice(0,M)}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:L},E=!0,y=!1){const N=y?f:h;let F="";const D=L.byteLength%3;let M=0;for(;M<L.byteLength-D;M+=3){const J=L[M+0],W=L[M+1],x=L[M+2];F+=N[J>>>2],F+=N[(J<<4|W>>>4)&63],F+=N[(W<<2|x>>>6)&63],F+=N[x&63]}if(D===1){const J=L[M+0];F+=N[J>>>2],F+=N[J<<4&63],E&&(F+="==")}else if(D===2){const J=L[M+0],W=L[M+1];F+=N[J>>>2],F+=N[(J<<4|W>>>4)&63],F+=N[W<<2&63],E&&(F+="=")}return F}}),define(ce[135],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(ce[13],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=P,e.$gg=c,e.$hg=C,e.$ig=O,e.$jg=T,e.$kg=k,e.$lg=A,e.$mg=w,e.$ng=S,e.$og=m,e.$pg=u,e.$qg=$,e.$rg=l,e.$sg=v,e.$tg=d,e.$ug=p,e.$vg=I,e.$wg=g;function P(s){return typeof s=="string"}function c(s){return Array.isArray(s)&&s.every(r=>P(r))}function C(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function O(s){const r=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof r}function T(s){return typeof s=="number"&&!isNaN(s)}function k(s){return!!s&&typeof s[Symbol.iterator]=="function"}function A(s){return s===!0||s===!1}function w(s){return typeof s>"u"}function S(s){return!m(s)}function m(s){return w(s)||s===null}function u(s,r){if(!s)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function $(s){if(m(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function l(...s){const r=[];for(let t=0;t<s.length;t++){const a=s[t];if(m(a))throw new Error(`Assertion Failed: argument at index ${t} is undefined or null`);r.push(a)}return r}const b=Object.prototype.hasOwnProperty;function v(s){if(!C(s))return!1;for(const r in s)if(b.call(s,r))return!1;return!0}function d(s){return typeof s=="function"}function p(...s){return s.length>0&&s.every(d)}function I(s,r){const t=Math.min(s.length,r.length);for(let a=0;a<t;a++)g(s[a],r[a])}function g(s,r){if(P(r)){if(typeof s!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(d(r)){try{if(s instanceof r)return}catch{}if(!m(s)&&s.constructor===r||r.length===1&&r.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ce[30],le([0,1,13]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=c,e.$eo=C,e.$fo=T,e.$go=A,e.$ho=w,e.$io=S,e.$jo=m,e.$ko=u,e.$lo=$,e.$mo=l,e.$no=b,e.$oo=v,e.$po=d;function c(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const I=Array.isArray(p)?[]:{};return Object.entries(p).forEach(([g,s])=>{I[g]=s&&typeof s=="object"?c(s):s}),I}function C(p){if(!p||typeof p!="object")return p;const I=[p];for(;I.length>0;){const g=I.shift();Object.freeze(g);for(const s in g)if(O.call(g,s)){const r=g[s];typeof r=="object"&&!Object.isFrozen(r)&&!(0,P.$ig)(r)&&I.push(r)}}return p}const O=Object.prototype.hasOwnProperty;function T(p,I){return k(p,I,new Set)}function k(p,I,g){if((0,P.$og)(p))return p;const s=I(p);if(typeof s<"u")return s;if(Array.isArray(p)){const r=[];for(const t of p)r.push(k(t,I,g));return r}if((0,P.$hg)(p)){if(g.has(p))throw new Error("Cannot clone recursive data-structure");g.add(p);const r={};for(const t in p)O.call(p,t)&&(r[t]=k(p[t],I,g));return g.delete(p),r}return p}function A(p,I,g=!0){return(0,P.$hg)(p)?((0,P.$hg)(I)&&Object.keys(I).forEach(s=>{s in p?g&&((0,P.$hg)(p[s])&&(0,P.$hg)(I[s])?A(p[s],I[s],g):p[s]=I[s]):p[s]=I[s]}),p):I}function w(p,I){if(p===I)return!0;if(p==null||I===null||I===void 0||typeof p!=typeof I||typeof p!="object"||Array.isArray(p)!==Array.isArray(I))return!1;let g,s;if(Array.isArray(p)){if(p.length!==I.length)return!1;for(g=0;g<p.length;g++)if(!w(p[g],I[g]))return!1}else{const r=[];for(s in p)r.push(s);r.sort();const t=[];for(s in I)t.push(s);if(t.sort(),!w(r,t))return!1;for(g=0;g<r.length;g++)if(!w(p[r[g]],I[r[g]]))return!1}return!0}function S(p){const I=new Set;return JSON.stringify(p,(g,s)=>{if((0,P.$hg)(s)||Array.isArray(s)){if(I.has(s))return"[Circular]";I.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function m(p,I){const g=Object.create(null);return!p||!I||Object.keys(I).forEach(r=>{const t=p[r],a=I[r];w(t,a)||(g[r]=a)}),g}function u(p,I){const g=I.toLowerCase(),s=Object.keys(p).find(r=>r.toLowerCase()===g);return s?p[s]:p[I]}function $(p,I){const g=Object.create(null);for(const[s,r]of Object.entries(p))I(s,r)&&(g[s]=r);return g}function l(p){let I=[];for(;Object.prototype!==p;)I=I.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return I}function b(p){const I=[];for(const g of l(p))typeof p[g]=="function"&&I.push(g);return I}function v(p,I){const g=r=>function(){const t=Array.prototype.slice.call(arguments,0);return I(r,t)},s={};for(const r of p)s[r]=g(r);return s}function d(p,I){const g={};for(const[s,r]of Object.entries(p))g[s]=I(r,s);return g}}),define(ce[136],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$bf=c,e.$cf=C;var P;(function(O){O[O.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",O[O.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",O[O.MAX_UINT_8=255]="MAX_UINT_8",O[O.MAX_UINT_16=65535]="MAX_UINT_16",O[O.MAX_UINT_32=4294967295]="MAX_UINT_32",O[O.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P||(e.Constants=P={}));function c(O){return O<0?0:O>P.MAX_UINT_8?P.MAX_UINT_8:O|0}function C(O){return O<0?0:O>P.MAX_UINT_32?P.MAX_UINT_32:O|0}}),define(ce[27],le([0,1,134,39,54,136]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.GraphemeBreakType=e.$5f=e.$Wf=e.$Pf=e.$Of=void 0,e.$df=T,e.$ef=A,e.$ff=S,e.$gf=m,e.$hf=u,e.$if=$,e.$jf=l,e.$kf=b,e.$lf=v,e.$mf=d,e.$nf=p,e.$of=I,e.$pf=g,e.$qf=s,e.$rf=r,e.$sf=t,e.$tf=a,e.$uf=i,e.$vf=n,e.$wf=o,e.$xf=h,e.$yf=f,e.$zf=R,e.$Af=L,e.$Bf=E,e.$Cf=y,e.$Df=N,e.$Ef=F,e.$Ff=D,e.$Gf=M,e.$Hf=J,e.$If=W,e.$Jf=x,e.$Kf=G,e.$Lf=ie,e.$Mf=V,e.$Nf=z,e.$Qf=q,e.$Rf=Z,e.$Sf=K,e.$Tf=H,e.$Uf=B,e.$Vf=_,e.$Xf=ee,e.$Yf=X,e.$Zf=oe,e.$1f=ue,e.$2f=be,e.$3f=Ie,e.$4f=we,e.$6f=Ee,e.$7f=Se,e.$8f=ae,e.$9f=de,e.$0f=me,e.$$f=Pe,e.$_f=ke,e.$ag=Fe,e.$bg=He;function T(re){return!re||typeof re!="string"?!0:re.trim().length===0}const k=/{(\d+)}/g;function A(re,...fe){return fe.length===0?re:re.replace(k,function($e,ye){const Ae=parseInt(ye,10);return isNaN(Ae)||Ae<0||Ae>=fe.length?$e:fe[Ae]})}const w=/{([^}]+)}/g;function S(re,fe){return Object.keys(fe).length===0?re:re.replace(w,($e,ye)=>fe[ye]??$e)}function m(re){return re.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}function u(re){return re.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}function $(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(re,fe){let $e=0,ye=re.indexOf(fe);for(;ye!==-1;)$e++,ye=re.indexOf(fe,ye+fe.length);return $e}function b(re,fe,$e="\u2026"){return re.length<=fe?re:`${re.substr(0,fe)}${$e}`}function v(re,fe,$e="\u2026"){if(re.length<=fe)return re;const ye=Math.ceil(fe/2)-$e.length/2,Ae=Math.floor(fe/2)-$e.length/2;return`${re.substr(0,ye)}${$e}${re.substr(re.length-Ae)}`}function d(re,fe=" "){const $e=p(re,fe);return I($e,fe)}function p(re,fe){if(!re||!fe)return re;const $e=fe.length;if($e===0||re.length===0)return re;let ye=0;for(;re.indexOf(fe,ye)===ye;)ye=ye+$e;return re.substring(ye)}function I(re,fe){if(!re||!fe)return re;const $e=fe.length,ye=re.length;if($e===0||ye===0)return re;let Ae=ye,Ne=-1;for(;Ne=re.lastIndexOf(fe,Ae-1),!(Ne===-1||Ne+$e!==Ae);){if(Ne===0)return"";Ae=Ne}return re.substring(0,Ae)}function g(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function s(re){return re.replace(/\*/g,"")}function r(re,fe,$e={}){if(!re)throw new Error("Cannot create regex from empty string");fe||(re=$(re)),$e.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(re,ye)}function t(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}function a(re){return re.split(/\r\n|\r|\n/)}function i(re){const fe=[],$e=re.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil($e.length/2);ye++)fe.push($e[2*ye]+($e[2*ye+1]??""));return fe}function n(re){for(let fe=0,$e=re.length;fe<$e;fe++){const ye=re.charCodeAt(fe);if(ye!==c.CharCode.Space&&ye!==c.CharCode.Tab)return fe}return-1}function o(re,fe=0,$e=re.length){for(let ye=fe;ye<$e;ye++){const Ae=re.charCodeAt(ye);if(Ae!==c.CharCode.Space&&Ae!==c.CharCode.Tab)return re.substring(fe,ye)}return re.substring(fe,$e)}function h(re,fe=re.length-1){for(let $e=fe;$e>=0;$e--){const ye=re.charCodeAt($e);if(ye!==c.CharCode.Space&&ye!==c.CharCode.Tab)return $e}return-1}function f(re,fe,$e){const ye=[];let Ae=0;for(const Ne of re.matchAll(fe)){if(ye.push(re.slice(Ae,Ne.index)),Ne.index===void 0)throw new Error("match.index should be defined");Ae=Ne.index+Ne[0].length,ye.push($e(Ne[0],...Ne.slice(1),Ne.index,re,Ne.groups))}return ye.push(re.slice(Ae)),Promise.all(ye).then(Ne=>Ne.join(""))}function R(re,fe){return re<fe?-1:re>fe?1:0}function L(re,fe,$e=0,ye=re.length,Ae=0,Ne=fe.length){for(;$e<ye&&Ae<Ne;$e++,Ae++){const Ke=re.charCodeAt($e),Ye=fe.charCodeAt(Ae);if(Ke<Ye)return-1;if(Ke>Ye)return 1}const je=ye-$e,xe=Ne-Ae;return je<xe?-1:je>xe?1:0}function E(re,fe){return y(re,fe,0,re.length,0,fe.length)}function y(re,fe,$e=0,ye=re.length,Ae=0,Ne=fe.length){for(;$e<ye&&Ae<Ne;$e++,Ae++){let Ke=re.charCodeAt($e),Ye=fe.charCodeAt(Ae);if(Ke===Ye)continue;if(Ke>=128||Ye>=128)return L(re.toLowerCase(),fe.toLowerCase(),$e,ye,Ae,Ne);F(Ke)&&(Ke-=32),F(Ye)&&(Ye-=32);const Ve=Ke-Ye;if(Ve!==0)return Ve}const je=ye-$e,xe=Ne-Ae;return je<xe?-1:je>xe?1:0}function N(re){return re>=c.CharCode.Digit0&&re<=c.CharCode.Digit9}function F(re){return re>=c.CharCode.a&&re<=c.CharCode.z}function D(re){return re>=c.CharCode.A&&re<=c.CharCode.Z}function M(re,fe){return re.length===fe.length&&y(re,fe)===0}function J(re,fe){const $e=fe.length;return fe.length>re.length?!1:y(re,fe,0,$e)===0}function W(re,fe){const $e=Math.min(re.length,fe.length);let ye;for(ye=0;ye<$e;ye++)if(re.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return $e}function x(re,fe){const $e=Math.min(re.length,fe.length);let ye;const Ae=re.length-1,Ne=fe.length-1;for(ye=0;ye<$e;ye++)if(re.charCodeAt(Ae-ye)!==fe.charCodeAt(Ne-ye))return ye;return $e}function G(re){return 55296<=re&&re<=56319}function ie(re){return 56320<=re&&re<=57343}function V(re,fe){return(re-55296<<10)+(fe-56320)+65536}function z(re,fe,$e){const ye=re.charCodeAt($e);if(G(ye)&&$e+1<fe){const Ae=re.charCodeAt($e+1);if(ie(Ae))return V(ye,Ae)}return ye}function te(re,fe){const $e=re.charCodeAt(fe-1);if(ie($e)&&fe>1){const ye=re.charCodeAt(fe-2);if(G(ye))return V(ye,$e)}return $e}class se{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=te(this.c,this.e);return this.e-=fe>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}nextCodePoint(){const fe=z(this.c,this.d,this.e);return this.e+=fe>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}eol(){return this.e>=this.d}}e.$Of=se;class he{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new se(fe,$e)}nextGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Ne=$e.offset,je=fe.getGraphemeBreakType($e.nextCodePoint());if(Te(Ae,je)){$e.setOffset(Ne);break}Ae=je}return $e.offset-ye}prevGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Ne=$e.offset,je=fe.getGraphemeBreakType($e.prevCodePoint());if(Te(je,Ae)){$e.setOffset(Ne);break}Ae=je}return ye-$e.offset}eol(){return this.c.eol()}}e.$Pf=he;function q(re,fe){return new he(re,fe).nextGraphemeLength()}function Z(re,fe){return new he(re,fe).prevGraphemeLength()}function K(re,fe){fe>0&&ie(re.charCodeAt(fe))&&fe--;const $e=fe+q(re,fe);return[$e-Z(re,$e),$e]}function H(re){const fe=new he(re);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}let U;function Y(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function B(re){return U||(U=Y()),U.test(re)}const j=/^[\t\n\r\x20-\x7E]*$/;function _(re){return j.test(re)}e.$Wf=/[\u2028\u2029]/;function ee(re){return e.$Wf.test(re)}function X(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}function oe(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}function ue(re,fe,$e=""){const ye=re.trimStart();if(ye.length<fe)return ye;const Ae=/\b/g;let Ne=0;for(;Ae.test(ye)&&!(ye.length-Ae.lastIndex<fe);)Ne=Ae.lastIndex,Ae.lastIndex+=1;return Ne===0?ye:$e+ye.substring(Ne).trimStart()}const ge=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*be(re){let fe=0;for(const $e of re.matchAll(ge))fe!==$e.index&&(yield{isCode:!1,str:re.substring(fe,$e.index)}),yield{isCode:!0,str:$e[0]},fe=$e.index+$e[0].length;fe!==re.length&&(yield{isCode:!1,str:re.substring(fe)})}function Ie(re){return re&&(re=re.replace(ge,"")),re}const pe=/\\\[.*?\\\]/g;function we(re){return Ie(re).replace(pe,"")}e.$5f=String.fromCharCode(c.CharCode.UTF8_BOM);function Ee(re){return!!(re&&re.length>0&&re.charCodeAt(0)===c.CharCode.UTF8_BOM)}function Se(re){return Ee(re)?re.substr(1):re}function ae(re,fe){if(!re||!fe||re.length<fe.length)return!1;const $e=fe.length,ye=re.toLowerCase();let Ae=0,Ne=-1;for(;Ae<$e;){const je=ye.indexOf(fe[Ae],Ne+1);if(je<0)return!1;Ne=je,Ae++}return!0}function de(re,fe=!1){return re?(fe&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}function me(re){return re.charAt(0).toUpperCase()+re.slice(1)}function Pe(re,fe=1){if(fe===0)return"";let $e=-1;do $e=re.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?re:(re[$e-1]==="\r"&&$e--,re.substr(0,$e))}function ke(re){const fe=c.CharCode.Z-c.CharCode.A+1;return re=re%(2*fe),re<fe?String.fromCharCode(c.CharCode.a+re):String.fromCharCode(c.CharCode.A+re-fe)}function Fe(re){return Ue.getInstance().getGraphemeBreakType(re)}function Te(re,fe){return re===Ce.Other?fe!==Ce.Extend&&fe!==Ce.SpacingMark:re===Ce.CR&&fe===Ce.LF?!1:re===Ce.Control||re===Ce.CR||re===Ce.LF||fe===Ce.Control||fe===Ce.CR||fe===Ce.LF?!0:!(re===Ce.L&&(fe===Ce.L||fe===Ce.V||fe===Ce.LV||fe===Ce.LVT)||(re===Ce.LV||re===Ce.V)&&(fe===Ce.V||fe===Ce.T)||(re===Ce.LVT||re===Ce.T)&&fe===Ce.T||fe===Ce.Extend||fe===Ce.ZWJ||fe===Ce.SpacingMark||re===Ce.Prepend||re===Ce.ZWJ&&fe===Ce.Extended_Pictographic||re===Ce.Regional_Indicator&&fe===Ce.Regional_Indicator)}var Ce;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(e.GraphemeBreakType=Ce={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=qe()}getGraphemeBreakType(fe){if(fe<32)return fe===c.CharCode.LineFeed?Ce.LF:fe===c.CharCode.CarriageReturn?Ce.CR:Ce.Control;if(fe<127)return Ce.Other;const $e=this.d,ye=$e.length/3;let Ae=1;for(;Ae<=ye;)if(fe<$e[3*Ae])Ae=2*Ae;else if(fe>$e[3*Ae+1])Ae=2*Ae+1;else return $e[3*Ae+2];return Ce.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(re,fe){if(re===0)return 0;const $e=Me(re,fe);if($e!==void 0)return $e;const ye=new se(fe,re);return ye.prevCodePoint(),ye.offset}function Me(re,fe){const $e=new se(fe,re);let ye=$e.prevCodePoint();for(;Be(ye)||ye===ze.emojiVariantSelector||ye===ze.enclosingKeyCap;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!oe(ye))return;let Ae=$e.offset;return Ae>0&&$e.prevCodePoint()===ze.zwj&&(Ae=$e.offset),Ae}function Be(re){return 127995<=re&&re<=127999}var ze;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$cg="\xA0";class We{static{this.c=new C.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$_e({getCacheKey:JSON.stringify},fe=>{function $e(Ve){const _e=new Map;for(let Qe=0;Qe<Ve.length;Qe+=2)_e.set(Ve[Qe],Ve[Qe+1]);return _e}function ye(Ve,_e){const Qe=new Map(Ve);for(const[nt,at]of _e)Qe.set(nt,at);return Qe}function Ae(Ve,_e){if(!Ve)return _e;const Qe=new Map;for(const[nt,at]of Ve)_e.has(nt)&&Qe.set(nt,at);return Qe}const Ne=this.c.value;let je=fe.filter(Ve=>!Ve.startsWith("_")&&Ve in Ne);je.length===0&&(je=["_default"]);let xe;for(const Ve of je){const _e=$e(Ne[Ve]);xe=Ae(xe,_e)}const Ke=$e(Ne._common),Ye=ye(Ke,xe);return new We(Ye)})}static getInstance(fe){return We.d.get(Array.from(fe))}static{this.e=new C.$X(()=>Object.keys(We.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return We.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}containsAmbiguousCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$dg=We;class Le{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Le.c())),this.d}static isInvisibleCharacter(fe){return Le.e().has(fe)}static containsInvisibleCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&Le.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Le.e()}}e.$eg=Le}),define(ce[56],le([0,1,27]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$xj=void 0,e.$tj=c,e.$uj=C,e.$vj=O,e.$wj=k,e.$yj=b,P=Oe(P);function c(d){return C(d,0)}function C(d,p){switch(typeof d){case"object":return d===null?O(349,p):Array.isArray(d)?A(d,p):w(d,p);case"string":return k(d,p);case"boolean":return T(d,p);case"number":return O(d,p);case"undefined":return O(937,p);default:return O(617,p)}}function O(d,p){return(p<<5)-p+d|0}function T(d,p){return O(d?433:863,p)}function k(d,p){p=O(149417,p);for(let I=0,g=d.length;I<g;I++)p=O(d.charCodeAt(I),p);return p}function A(d,p){return p=O(104579,p),d.reduce((I,g)=>C(g,I),p)}function w(d,p){return p=O(181387,p),Object.keys(d).sort().reduce((I,g)=>(I=k(g,I),C(d[g],I)),p)}class S{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=C(p,this.g),this.g}}e.$xj=S;var m;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(m||(m={}));function u(d,p,I=32){const g=I-p,s=~((1<<g)-1);return(d<<p|(s&d)>>>g)>>>0}function $(d,p=0,I=d.byteLength,g=0){for(let s=0;s<I;s++)d[p+s]=g}function l(d,p,I="0"){for(;d.length<p;)d=I+d;return d}function b(d,p=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(I=>I.toString(16).padStart(2,"0")).join(""):l((d>>>0).toString(16),p/4)}class v{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(m.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const I=p.length;if(I===0)return;const g=this.p;let s=this.r,r=this.u,t,a;for(r!==0?(t=r,a=-1,r=0):(t=p.charCodeAt(0),a=0);;){let i=t;if(P.$Kf(t))if(a+1<I){const n=p.charCodeAt(a+1);P.$Lf(n)?(a++,i=P.$Mf(t,n)):i=m.UNICODE_REPLACEMENT}else{r=t;break}else P.$Lf(t)&&(i=m.UNICODE_REPLACEMENT);if(s=this.w(g,s,i),a++,a<I)t=p.charCodeAt(a);else break}this.r=s,this.u=r}w(p,I,g){return g<128?p[I++]=g:g<2048?(p[I++]=192|(g&1984)>>>6,p[I++]=128|(g&63)>>>0):g<65536?(p[I++]=224|(g&61440)>>>12,p[I++]=128|(g&4032)>>>6,p[I++]=128|(g&63)>>>0):(p[I++]=240|(g&1835008)>>>18,p[I++]=128|(g&258048)>>>12,p[I++]=128|(g&4032)>>>6,p[I++]=128|(g&63)>>>0),I>=m.BLOCK_SIZE&&(this.y(),I-=m.BLOCK_SIZE,this.t+=m.BLOCK_SIZE,p[0]=p[m.BLOCK_SIZE+0],p[1]=p[m.BLOCK_SIZE+1],p[2]=p[m.BLOCK_SIZE+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,m.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=v.g,I=this.q;for(let h=0;h<64;h+=4)p.setUint32(h,I.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)p.setUint32(h,u(p.getUint32(h-12,!1)^p.getUint32(h-32,!1)^p.getUint32(h-56,!1)^p.getUint32(h-64,!1),1),!1);let g=this.h,s=this.l,r=this.m,t=this.n,a=this.o,i,n,o;for(let h=0;h<80;h++)h<20?(i=s&r|~s&t,n=1518500249):h<40?(i=s^r^t,n=1859775393):h<60?(i=s&r|s&t|r&t,n=2400959708):(i=s^r^t,n=3395469782),o=u(g,5)+i+a+n+p.getUint32(h*4,!1)&4294967295,a=t,t=r,r=u(s,30),s=g,g=o;this.h=this.h+g&4294967295,this.l=this.l+s&4294967295,this.m=this.m+r&4294967295,this.n=this.n+t&4294967295,this.o=this.o+a&4294967295}}e.$zj=v}),define(ce[92],le([0,1,27]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),P=Oe(P);var c;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(c||(c={})),function(C){const O="error",T="warning",k="warn",A="info",w="ignore";function S(u){return u?P.$Gf(O,u)?C.Error:P.$Gf(T,u)||P.$Gf(k,u)?C.Warning:P.$Gf(A,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=S;function m(u){switch(u){case C.Error:return O;case C.Warning:return T;case C.Info:return A;default:return w}}C.toString=m}(c||(c={})),e.default=c}),define(ce[52],le([0,1,19,39,27]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class O{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const b=l.charCodeAt(0),v=this.b.charCodeAt(this.c);return b-v}value(){return this.b[this.c]}}e.$Hi=O;class T{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===c.CharCode.Period)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,C.$Af)(l,this.b,0,l.length,this.c,this.d):(0,C.$Cf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=T;class k{constructor(l=!0,b=!0){this.f=l,this.g=b}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let b=l.length-1;b>=0;b--,this.c--){const v=this.b.charCodeAt(b);if(!(v===c.CharCode.Slash||this.f&&v===c.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const b=this.b.charCodeAt(this.e);if(b===c.CharCode.Slash||this.f&&b===c.CharCode.Backslash)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,C.$Af)(l,this.b,0,l.length,this.d,this.e):(0,C.$Cf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=k;var A;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(A||(A={}));class w{constructor(l,b){this.f=l,this.g=b,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(A.Scheme),this.c.authority&&this.d.push(A.Authority),this.c.path&&(this.b=new k(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(A.Path)),this.g(l)||(this.c.query&&this.d.push(A.Query),this.c.fragment&&this.d.push(A.Fragment)),this.e=0,this}next(){return this.d[this.e]===A.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===A.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===A.Scheme)return(0,C.$Bf)(l,this.c.scheme);if(this.d[this.e]===A.Authority)return(0,C.$Bf)(l,this.c.authority);if(this.d[this.e]===A.Path)return this.b.cmp(l);if(this.d[this.e]===A.Query)return(0,C.$zf)(l,this.c.query);if(this.d[this.e]===A.Fragment)return(0,C.$zf)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===A.Scheme)return this.c.scheme;if(this.d[this.e]===A.Authority)return this.c.authority;if(this.d[this.e]===A.Path)return this.b.value();if(this.d[this.e]===A.Query)return this.c.query;if(this.d[this.e]===A.Fragment)return this.c.fragment;throw new Error}}e.$Ki=w;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(m||(m={}));class u{static forUris(l=()=>!1,b=()=>!1){return new u(new w(l,b))}static forPaths(l=!1){return new u(new k(void 0,!l))}static forStrings(){return new u(new O)}static forConfigKeys(){return new u(new T)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,b){if(b){const v=b.slice(0);(0,P.$Yb)(v);for(const d of v)this.set(d,l)}else{const v=l.slice(0);(0,P.$Yb)(v);for(const d of v)this.set(d[0],d[1])}}set(l,b){const v=this.b.reset(l);let d;this.c||(this.c=new S,this.c.segment=v.value());const p=[];for(d=this.c;;){const g=v.cmp(d.segment);if(g>0)d.left||(d.left=new S,d.left.segment=v.value()),p.push([m.Left,d]),d=d.left;else if(g<0)d.right||(d.right=new S,d.right.segment=v.value()),p.push([m.Right,d]),d=d.right;else if(v.hasNext())v.next(),d.mid||(d.mid=new S,d.mid.segment=v.value()),p.push([m.Mid,d]),d=d.mid;else break}const I=d.value;d.value=b,d.key=l;for(let g=p.length-1;g>=0;g--){const s=p[g][1];s.updateHeight();const r=s.balanceFactor();if(r<-1||r>1){const t=p[g][0],a=p[g+1][0];if(t===m.Right&&a===m.Right)p[g][1]=s.rotateLeft();else if(t===m.Left&&a===m.Left)p[g][1]=s.rotateRight();else if(t===m.Right&&a===m.Left)s.right=p[g+1][1]=p[g+1][1].rotateRight(),p[g][1]=s.rotateLeft();else if(t===m.Left&&a===m.Right)s.left=p[g+1][1]=p[g+1][1].rotateLeft(),p[g][1]=s.rotateRight();else throw new Error;if(g>0)switch(p[g-1][0]){case m.Left:p[g-1][1].left=p[g][1];break;case m.Right:p[g-1][1].right=p[g][1];break;case m.Mid:p[g-1][1].mid=p[g][1];break}else this.c=p[0][1]}}return I}get(l){return this.d(l)?.value}d(l){const b=this.b.reset(l);let v=this.c;for(;v;){const d=b.cmp(v.segment);if(d>0)v=v.left;else if(d<0)v=v.right;else if(b.hasNext())b.next(),v=v.mid;else break}return v}has(l){const b=this.d(l);return!(b?.value===void 0&&b?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,b){const v=this.b.reset(l),d=[];let p=this.c;for(;p;){const I=v.cmp(p.segment);if(I>0)d.push([m.Left,p]),p=p.left;else if(I<0)d.push([m.Right,p]),p=p.right;else if(v.hasNext())v.next(),d.push([m.Mid,p]),p=p.mid;else break}if(p){if(b?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const I=this.f(p.right);if(I.key){const{key:g,value:s,segment:r}=I;this.e(I.key,!1),p.key=g,p.value=s,p.segment=r}}else{const I=p.left??p.right;if(d.length>0){const[g,s]=d[d.length-1];switch(g){case m.Left:s.left=I;break;case m.Mid:s.mid=I;break;case m.Right:s.right=I;break}}else this.c=I}for(let I=d.length-1;I>=0;I--){const g=d[I][1];g.updateHeight();const s=g.balanceFactor();if(s>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),d[I][1]=g.rotateLeft()):s<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),d[I][1]=g.rotateRight()),I>0)switch(d[I-1][0]){case m.Left:d[I-1][1].left=d[I][1];break;case m.Right:d[I-1][1].right=d[I][1];break;case m.Mid:d[I-1][1].mid=d[I][1];break}else this.c=d[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const b=this.b.reset(l);let v=this.c,d;for(;v;){const p=b.cmp(v.segment);if(p>0)v=v.left;else if(p<0)v=v.right;else if(b.hasNext())b.next(),d=v.value||d,v=v.mid;else break}return v&&v.value||d}findSuperstr(l){return this.g(l,!1)}g(l,b){const v=this.b.reset(l);let d=this.c;for(;d;){const p=v.cmp(d.segment);if(p>0)d=d.left;else if(p<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else return d.mid?this.h(d.mid):b?d.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[b,v]of this)l(v,b)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const b=[];return this.j(l,b),b[Symbol.iterator]()}j(l,b){l&&(l.left&&this.j(l.left,b),l.value&&b.push([l.key,l.value]),l.mid&&this.j(l.mid,b),l.right&&this.j(l.right,b))}_isBalanced(){const l=b=>{if(!b)return!0;const v=b.balanceFactor();return v<-1||v>1?!1:l(b.left)&&l(b.right)};return l(this.c)}}e.$Li=u}),define(ce[32],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=c;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function c(C){return P.test(C)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(k){for(let A=0;A<k.length;A++)k[A]=Math.floor(Math.random()*256);return k};const O=new Uint8Array(16),T=[];for(let k=0;k<256;k++)T.push(k.toString(16).padStart(2,"0"));return function(){C(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let A=0,w="";return w+=T[O[A++]],w+=T[O[A++]],w+=T[O[A++]],w+=T[O[A++]],w+="-",w+=T[O[A++]],w+=T[O[A++]],w+="-",w+=T[O[A++]],w+=T[O[A++]],w+="-",w+=T[O[A++]],w+=T[O[A++]],w+="-",w+=T[O[A++]],w+=T[O[A++]],w+=T[O[A++]],w+=T[O[A++]],w+=T[O[A++]],w+=T[O[A++]],w}}()}),define(ce[137],le([0,1,38]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=O;const c=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function C(T){const k=T.replace(/\-/g,":").toLowerCase();return!c.has(k)}function O(){const T=(0,P.networkInterfaces)();for(const k in T){const A=T[k];if(A){for(const{mac:w}of A)if(C(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ce[138],le([0,1,277,15]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zX=void 0;class C extends P.Transform{constructor(T){if(super(),typeof T=="number")this.b=T,this.c=1;else{const k=Buffer.isBuffer(T)?T:Buffer.from(T);this.b=k.length===1?k[0]:k,this.c=k.length}}_transform(T,k,A){this.a?this.a=Buffer.concat([this.a,T]):this.a=T;let w=0;for(;w<this.a.length;){const S=typeof this.b=="number"?this.a.indexOf(this.b,w):(0,c.$Pe)(this.a,this.b,w);if(S===-1)break;this.push(this.a.slice(w,S+this.c)),w=S+this.c}this.a=w===this.a.length?void 0:this.a.slice(w),A()}_flush(T){this.a&&this.push(this.a),T()}}e.$zX=C}),define(ce[139],le([0,1,67]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=c,e.$6g=O,P=Oe(P);function c(k,A,w,S=1){let m=!1;return new Promise(u=>{const $=setTimeout(()=>{if(!m)return m=!0,u(0)},w);C(k,A,S,l=>{if(!m)return m=!0,clearTimeout($),u(l)})})}function C(k,A,w,S){if(A===0)return S(0);const m=new P.Socket;m.once("connect",()=>(T(m),C(k+w,A-1,w,S))),m.once("data",()=>{}),m.once("error",u=>(T(m),u.code!=="ECONNREFUSED"?C(k+w,A-1,w,S):S(k))),m.connect(k,"127.0.0.1")}e.$5g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(k,A,w,S="127.0.0.1"){let m=!1,u,$=1;const l=P.createServer({pauseOnConnect:!0});function b(v,d){m||(m=!0,l.removeAllListeners(),l.close(),u&&clearTimeout(u),d(v))}return new Promise(v=>{u=setTimeout(()=>{b(0,v)},w),l.on("listening",()=>{b(k,v)}),l.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&$<A?(k++,$++,l.listen(k,S)):b(0,v)}),l.on("close",()=>{b(0,v)}),l.listen(k,S)})}function T(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(A){console.error(A)}}}),define(ce[140],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RX=P;function P(c){return!!c.parentPort}}),define(ce[141],le([12,11]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ce[68],le([0,1,141]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=w,e.$2m=S,e.$3m=m;const c=60,C=c*60,O=C*24,T=O*7,k=O*30,A=O*365;function w(u,$,l,b){typeof u!="number"&&(u=u.getTime());const v=Math.round((new Date().getTime()-u)/1e3);if(v<-30)return(0,P.localize)(0,null,w(new Date().getTime()+v*1e3,!1));if(!b&&v<30)return(0,P.localize)(1,null);let d;return v<c?(d=v,$?d===1?l?(0,P.localize)(2,null,d):(0,P.localize)(3,null,d):l?(0,P.localize)(4,null,d):(0,P.localize)(5,null,d):d===1?l?(0,P.localize)(6,null,d):(0,P.localize)(7,null,d):l?(0,P.localize)(8,null,d):(0,P.localize)(9,null,d)):v<C?(d=Math.floor(v/c),$?d===1?l?(0,P.localize)(10,null,d):(0,P.localize)(11,null,d):l?(0,P.localize)(12,null,d):(0,P.localize)(13,null,d):d===1?l?(0,P.localize)(14,null,d):(0,P.localize)(15,null,d):l?(0,P.localize)(16,null,d):(0,P.localize)(17,null,d)):v<O?(d=Math.floor(v/C),$?d===1?l?(0,P.localize)(18,null,d):(0,P.localize)(19,null,d):l?(0,P.localize)(20,null,d):(0,P.localize)(21,null,d):d===1?l?(0,P.localize)(22,null,d):(0,P.localize)(23,null,d):l?(0,P.localize)(24,null,d):(0,P.localize)(25,null,d)):v<T?(d=Math.floor(v/O),$?d===1?(0,P.localize)(26,null,d):(0,P.localize)(27,null,d):d===1?(0,P.localize)(28,null,d):(0,P.localize)(29,null,d)):v<k?(d=Math.floor(v/T),$?d===1?l?(0,P.localize)(30,null,d):(0,P.localize)(31,null,d):l?(0,P.localize)(32,null,d):(0,P.localize)(33,null,d):d===1?l?(0,P.localize)(34,null,d):(0,P.localize)(35,null,d):l?(0,P.localize)(36,null,d):(0,P.localize)(37,null,d)):v<A?(d=Math.floor(v/k),$?d===1?l?(0,P.localize)(38,null,d):(0,P.localize)(39,null,d):l?(0,P.localize)(40,null,d):(0,P.localize)(41,null,d):d===1?l?(0,P.localize)(42,null,d):(0,P.localize)(43,null,d):l?(0,P.localize)(44,null,d):(0,P.localize)(45,null,d)):(d=Math.floor(v/A),$?d===1?l?(0,P.localize)(46,null,d):(0,P.localize)(47,null,d):l?(0,P.localize)(48,null,d):(0,P.localize)(49,null,d):d===1?l?(0,P.localize)(50,null,d):(0,P.localize)(51,null,d):l?(0,P.localize)(52,null,d):(0,P.localize)(53,null,d))}function S(u,$){const l=Math.abs(u/1e3);return l<1?$?(0,P.localize)(54,null,u):(0,P.localize)(55,null,u):l<c?$?(0,P.localize)(56,null,Math.round(u)/1e3):(0,P.localize)(57,null,Math.round(u)/1e3):l<C?$?(0,P.localize)(58,null,Math.round(u/(1e3*c))):(0,P.localize)(59,null,Math.round(u/(1e3*c))):l<O?$?(0,P.localize)(60,null,Math.round(u/(1e3*C))):(0,P.localize)(61,null,Math.round(u/(1e3*C))):(0,P.localize)(62,null,Math.round(u/(1e3*O)))}function m(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ce[142],le([12,11]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ce[41],le([0,1,19,13,142]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=A,e.$rj=w,e.$sj=S,P=Oe(P),c=Oe(c),C=Oe(C);function O(m,u){return u&&(m.stack||m.stacktrace)?C.localize(0,null,k(m),T(m.stack)||T(m.stacktrace)):k(m)}function T(m){return Array.isArray(m)?m.join(`
`):m}function k(m){return m.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${m.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?C.localize(1,null,m.message):m.message||C.localize(2,null)}function A(m=null,u=!1){if(!m)return C.localize(3,null);if(Array.isArray(m)){const $=P.$Jb(m),l=A($[0],u);return $.length>1?C.localize(4,null,l,$.length):l}if(c.$fg(m))return m;if(m.detail){const $=m.detail;if($.error)return O($.error,u);if($.exception)return O($.exception,u)}return m.stack?O(m,u):m.message?m.message:C.localize(5,null)}function w(m){const u=m;return u instanceof Error&&Array.isArray(u.actions)}function S(m,u){let $;return typeof m=="string"?$=new Error(m):$=m,$.actions=u,$}}),define(ce[143],le([12,11]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(ce[144],le([0,1,143,34]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=C;function C(O){switch(O){case c.ParseErrorCode.InvalidSymbol:return(0,P.localize)(0,null);case c.ParseErrorCode.InvalidNumberFormat:return(0,P.localize)(1,null);case c.ParseErrorCode.PropertyNameExpected:return(0,P.localize)(2,null);case c.ParseErrorCode.ValueExpected:return(0,P.localize)(3,null);case c.ParseErrorCode.ColonExpected:return(0,P.localize)(4,null);case c.ParseErrorCode.CommaExpected:return(0,P.localize)(5,null);case c.ParseErrorCode.CloseBraceExpected:return(0,P.localize)(6,null);case c.ParseErrorCode.CloseBracketExpected:return(0,P.localize)(7,null);case c.ParseErrorCode.EndOfFileExpected:return(0,P.localize)(8,null);default:return""}}}),define(ce[145],le([12,11]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ce[5],le([0,1,145]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=t,e.$D=f,e.$J=R,P=Oe(P),e.$g="en";let c=!1,C=!1,O=!1,T=!1,k=!1,A=!1,w=!1,S=!1,m=!1,u=!1,$,l=e.$g,b=e.$g,v,d;const p=globalThis;let I;typeof p.vscode<"u"&&typeof p.vscode.process<"u"?I=p.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(I=process);const g=typeof I?.versions?.electron=="string",s=g&&I?.type==="renderer";if(typeof I=="object"){c=I.platform==="win32",C=I.platform==="darwin",O=I.platform==="linux",T=O&&!!I.env.SNAP&&!!I.env.SNAP_REVISION,w=g,m=!!I.env.CI||!!I.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=e.$g,l=e.$g;const L=I.env.VSCODE_NLS_CONFIG;if(L)try{const E=JSON.parse(L),y=E.availableLanguages["*"];$=E.locale,b=E.osLocale,l=y||e.$g,v=E._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!s?(d=navigator.userAgent,c=d.indexOf("Windows")>=0,C=d.indexOf("Macintosh")>=0,S=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=d.indexOf("Linux")>=0,u=d?.indexOf("Mobi")>=0,A=!0,$=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$g,l=$,b=navigator.language):console.error("Unable to resolve platform.");var r;(function(L){L[L.Web=0]="Web",L[L.Mac=1]="Mac",L[L.Linux=2]="Linux",L[L.Windows=3]="Windows"})(r||(e.Platform=r={}));function t(L){switch(L){case r.Web:return"Web";case r.Mac:return"Mac";case r.Linux:return"Linux";case r.Windows:return"Windows"}}let a=r.Web;C?a=r.Mac:c?a=r.Windows:O&&(a=r.Linux),e.$i=c,e.$j=C,e.$k=O,e.$l=T,e.$m=k,e.$n=w,e.$o=A,e.$p=A&&typeof p.importScripts=="function",e.$q=e.$p?p.origin:void 0,e.$r=S,e.$s=u,e.$t=m,e.$u=a,e.$v=d,e.$w=l;var i;(function(L){function E(){return e.$w}L.value=E;function y(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}L.isDefaultVariant=y;function N(){return e.$w==="en"}L.isDefault=N})(i||(e.Language=i={})),e.$x=$,e.$y=b,e.$z=v,e.$A=typeof p.postMessage=="function"&&!p.importScripts,e.$B=(()=>{if(e.$A){const L=[];p.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let N=0,F=L.length;N<F;N++){const D=L[N];if(D.id===y.data.vscodeScheduleAsyncWork){L.splice(N,1),D.callback();return}}});let E=0;return y=>{const N=++E;L.push({id:N,callback:y}),p.postMessage({vscodeScheduleAsyncWork:N},"*")}}return L=>setTimeout(L)})();var n;(function(L){L[L.Windows=1]="Windows",L[L.Macintosh=2]="Macintosh",L[L.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=C||S?n.Macintosh:c?n.Windows:n.Linux;let o=!0,h=!1;function f(){if(!h){h=!0;const L=new Uint8Array(2);L[0]=1,L[1]=2,o=new Uint16Array(L.buffer)[0]===513}return o}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function R(L){return parseFloat(L)>=20}}),define(ce[37],le([0,1,5]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gc=e.$fc=e.env=e.cwd=void 0;let c;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.process<"u"){const O=C.process;c={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?c={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:c={get platform(){return P.$i?"win32":P.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=c.cwd,e.env=c.env,e.$fc=c.platform,e.$gc=c.arch}),define(ce[146],le([0,1,37]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gX=T;var c;(function(k){k.UNKNOWN="UNKNOWN",k.CINNAMON="CINNAMON",k.DEEPIN="DEEPIN",k.GNOME="GNOME",k.KDE3="KDE3",k.KDE4="KDE4",k.KDE5="KDE5",k.KDE6="KDE6",k.PANTHEON="PANTHEON",k.UNITY="UNITY",k.XFCE="XFCE",k.UKUI="UKUI",k.LXQT="LXQT"})(c||(c={}));const C="XDG_CURRENT_DESKTOP",O="KDE_SESSION_VERSION";function T(){const k=P.env[C];if(k){const w=k.split(":").map(S=>S.trim()).filter(S=>S.length>0);for(const S of w)switch(S){case"Unity":{const m=P.env.DESKTOP_SESSION;return m&&m.includes("gnome-fallback")?c.GNOME:c.UNITY}case"Deepin":return c.DEEPIN;case"GNOME":return c.GNOME;case"X-Cinnamon":return c.CINNAMON;case"KDE":{const m=P.env[O];return m==="5"?c.KDE5:m==="6"?c.KDE6:c.KDE4}case"Pantheon":return c.PANTHEON;case"XFCE":return c.XFCE;case"UKUI":return c.UKUI;case"LXQt":return c.LXQT}}const A=P.env.DESKTOP_SESSION;if(A)switch(A){case"deepin":return c.DEEPIN;case"gnome":case"mate":return c.GNOME;case"kde4":case"kde-plasma":return c.KDE4;case"kde":return O in P.env?c.KDE4:c.KDE3;case"xfce":case"xubuntu":return c.XFCE;case"ukui":return c.UKUI}return"GNOME_DESKTOP_SESSION_ID"in P.env?c.GNOME:"KDE_FULL_SESSION"in P.env?O in P.env?c.KDE4:c.KDE3:c.UNKNOWN}}),define(ce[14],le([0,1,37]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.sep=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=void 0,P=Oe(P);const c=65,C=97,O=90,T=122,k=46,A=47,w=92,S=58,m=63;class u extends Error{constructor(t,a,i){let n;typeof a=="string"&&a.indexOf("not ")===0?(n="must not be",a=a.replace(/^not /,"")):n="must be";const o=t.indexOf(".")!==-1?"property":"argument";let h=`The "${t}" ${o} ${n} of type ${a}`;h+=`. Received type ${typeof i}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function $(r,t){if(r===null||typeof r!="object")throw new u(t,"Object",r)}function l(r,t){if(typeof r!="string")throw new u(t,"string",r)}const b=P.$fc==="win32";function v(r){return r===A||r===w}function d(r){return r===A}function p(r){return r>=c&&r<=O||r>=C&&r<=T}function I(r,t,a,i){let n="",o=0,h=-1,f=0,R=0;for(let L=0;L<=r.length;++L){if(L<r.length)R=r.charCodeAt(L);else{if(i(R))break;R=A}if(i(R)){if(!(h===L-1||f===1))if(f===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==k||n.charCodeAt(n.length-2)!==k){if(n.length>2){const E=n.lastIndexOf(a);E===-1?(n="",o=0):(n=n.slice(0,E),o=n.length-1-n.lastIndexOf(a)),h=L,f=0;continue}else if(n.length!==0){n="",o=0,h=L,f=0;continue}}t&&(n+=n.length>0?`${a}..`:"..",o=2)}else n.length>0?n+=`${a}${r.slice(h+1,L)}`:n=r.slice(h+1,L),o=L-h-1;h=L,f=0}else R===k&&f!==-1?++f:f=-1}return n}function g(r,t){$(t,"pathObject");const a=t.dir||t.root,i=t.base||`${t.name||""}${t.ext||""}`;return a?a===t.root?`${a}${i}`:`${a}${r}${i}`:i}e.$hc={resolve(...r){let t="",a="",i=!1;for(let n=r.length-1;n>=-1;n--){let o;if(n>=0){if(o=r[n],l(o,"path"),o.length===0)continue}else t.length===0?o=P.cwd():(o=P.env[`=${t}`]||P.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==t.toLowerCase()&&o.charCodeAt(2)===w)&&(o=`${t}\\`));const h=o.length;let f=0,R="",L=!1;const E=o.charCodeAt(0);if(h===1)v(E)&&(f=1,L=!0);else if(v(E))if(L=!0,v(o.charCodeAt(1))){let y=2,N=y;for(;y<h&&!v(o.charCodeAt(y));)y++;if(y<h&&y!==N){const F=o.slice(N,y);for(N=y;y<h&&v(o.charCodeAt(y));)y++;if(y<h&&y!==N){for(N=y;y<h&&!v(o.charCodeAt(y));)y++;(y===h||y!==N)&&(R=`\\\\${F}\\${o.slice(N,y)}`,f=y)}}}else f=1;else p(E)&&o.charCodeAt(1)===S&&(R=o.slice(0,2),f=2,h>2&&v(o.charCodeAt(2))&&(L=!0,f=3));if(R.length>0)if(t.length>0){if(R.toLowerCase()!==t.toLowerCase())continue}else t=R;if(i){if(t.length>0)break}else if(a=`${o.slice(f)}\\${a}`,i=L,L&&t.length>0)break}return a=I(a,!i,"\\",v),i?`${t}\\${a}`:`${t}${a}`||"."},normalize(r){l(r,"path");const t=r.length;if(t===0)return".";let a=0,i,n=!1;const o=r.charCodeAt(0);if(t===1)return d(o)?"\\":r;if(v(o))if(n=!0,v(r.charCodeAt(1))){let f=2,R=f;for(;f<t&&!v(r.charCodeAt(f));)f++;if(f<t&&f!==R){const L=r.slice(R,f);for(R=f;f<t&&v(r.charCodeAt(f));)f++;if(f<t&&f!==R){for(R=f;f<t&&!v(r.charCodeAt(f));)f++;if(f===t)return`\\\\${L}\\${r.slice(R)}\\`;f!==R&&(i=`\\\\${L}\\${r.slice(R,f)}`,a=f)}}}else a=1;else p(o)&&r.charCodeAt(1)===S&&(i=r.slice(0,2),a=2,t>2&&v(r.charCodeAt(2))&&(n=!0,a=3));let h=a<t?I(r.slice(a),!n,"\\",v):"";return h.length===0&&!n&&(h="."),h.length>0&&v(r.charCodeAt(t-1))&&(h+="\\"),i===void 0?n?`\\${h}`:h:n?`${i}\\${h}`:`${i}${h}`},isAbsolute(r){l(r,"path");const t=r.length;if(t===0)return!1;const a=r.charCodeAt(0);return v(a)||t>2&&p(a)&&r.charCodeAt(1)===S&&v(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let t,a;for(let o=0;o<r.length;++o){const h=r[o];l(h,"path"),h.length>0&&(t===void 0?t=a=h:t+=`\\${h}`)}if(t===void 0)return".";let i=!0,n=0;if(typeof a=="string"&&v(a.charCodeAt(0))){++n;const o=a.length;o>1&&v(a.charCodeAt(1))&&(++n,o>2&&(v(a.charCodeAt(2))?++n:i=!1))}if(i){for(;n<t.length&&v(t.charCodeAt(n));)n++;n>=2&&(t=`\\${t.slice(n)}`)}return e.$hc.normalize(t)},relative(r,t){if(l(r,"from"),l(t,"to"),r===t)return"";const a=e.$hc.resolve(r),i=e.$hc.resolve(t);if(a===i||(r=a.toLowerCase(),t=i.toLowerCase(),r===t))return"";let n=0;for(;n<r.length&&r.charCodeAt(n)===w;)n++;let o=r.length;for(;o-1>n&&r.charCodeAt(o-1)===w;)o--;const h=o-n;let f=0;for(;f<t.length&&t.charCodeAt(f)===w;)f++;let R=t.length;for(;R-1>f&&t.charCodeAt(R-1)===w;)R--;const L=R-f,E=h<L?h:L;let y=-1,N=0;for(;N<E;N++){const D=r.charCodeAt(n+N);if(D!==t.charCodeAt(f+N))break;D===w&&(y=N)}if(N!==E){if(y===-1)return i}else{if(L>E){if(t.charCodeAt(f+N)===w)return i.slice(f+N+1);if(N===2)return i.slice(f+N)}h>E&&(r.charCodeAt(n+N)===w?y=N:N===2&&(y=3)),y===-1&&(y=0)}let F="";for(N=n+y+1;N<=o;++N)(N===o||r.charCodeAt(N)===w)&&(F+=F.length===0?"..":"\\..");return f+=y,F.length>0?`${F}${i.slice(f,R)}`:(i.charCodeAt(f)===w&&++f,i.slice(f,R))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const t=e.$hc.resolve(r);if(t.length<=2)return r;if(t.charCodeAt(0)===w){if(t.charCodeAt(1)===w){const a=t.charCodeAt(2);if(a!==m&&a!==k)return`\\\\?\\UNC\\${t.slice(2)}`}}else if(p(t.charCodeAt(0))&&t.charCodeAt(1)===S&&t.charCodeAt(2)===w)return`\\\\?\\${t}`;return r},dirname(r){l(r,"path");const t=r.length;if(t===0)return".";let a=-1,i=0;const n=r.charCodeAt(0);if(t===1)return v(n)?r:".";if(v(n)){if(a=i=1,v(r.charCodeAt(1))){let f=2,R=f;for(;f<t&&!v(r.charCodeAt(f));)f++;if(f<t&&f!==R){for(R=f;f<t&&v(r.charCodeAt(f));)f++;if(f<t&&f!==R){for(R=f;f<t&&!v(r.charCodeAt(f));)f++;if(f===t)return r;f!==R&&(a=i=f+1)}}}}else p(n)&&r.charCodeAt(1)===S&&(a=t>2&&v(r.charCodeAt(2))?3:2,i=a);let o=-1,h=!0;for(let f=t-1;f>=i;--f)if(v(r.charCodeAt(f))){if(!h){o=f;break}}else h=!1;if(o===-1){if(a===-1)return".";o=a}return r.slice(0,o)},basename(r,t){t!==void 0&&l(t,"ext"),l(r,"path");let a=0,i=-1,n=!0,o;if(r.length>=2&&p(r.charCodeAt(0))&&r.charCodeAt(1)===S&&(a=2),t!==void 0&&t.length>0&&t.length<=r.length){if(t===r)return"";let h=t.length-1,f=-1;for(o=r.length-1;o>=a;--o){const R=r.charCodeAt(o);if(v(R)){if(!n){a=o+1;break}}else f===-1&&(n=!1,f=o+1),h>=0&&(R===t.charCodeAt(h)?--h===-1&&(i=o):(h=-1,i=f))}return a===i?i=f:i===-1&&(i=r.length),r.slice(a,i)}for(o=r.length-1;o>=a;--o)if(v(r.charCodeAt(o))){if(!n){a=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":r.slice(a,i)},extname(r){l(r,"path");let t=0,a=-1,i=0,n=-1,o=!0,h=0;r.length>=2&&r.charCodeAt(1)===S&&p(r.charCodeAt(0))&&(t=i=2);for(let f=r.length-1;f>=t;--f){const R=r.charCodeAt(f);if(v(R)){if(!o){i=f+1;break}continue}n===-1&&(o=!1,n=f+1),R===k?a===-1?a=f:h!==1&&(h=1):a!==-1&&(h=-1)}return a===-1||n===-1||h===0||h===1&&a===n-1&&a===i+1?"":r.slice(a,n)},format:g.bind(null,"\\"),parse(r){l(r,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return t;const a=r.length;let i=0,n=r.charCodeAt(0);if(a===1)return v(n)?(t.root=t.dir=r,t):(t.base=t.name=r,t);if(v(n)){if(i=1,v(r.charCodeAt(1))){let y=2,N=y;for(;y<a&&!v(r.charCodeAt(y));)y++;if(y<a&&y!==N){for(N=y;y<a&&v(r.charCodeAt(y));)y++;if(y<a&&y!==N){for(N=y;y<a&&!v(r.charCodeAt(y));)y++;y===a?i=y:y!==N&&(i=y+1)}}}}else if(p(n)&&r.charCodeAt(1)===S){if(a<=2)return t.root=t.dir=r,t;if(i=2,v(r.charCodeAt(2))){if(a===3)return t.root=t.dir=r,t;i=3}}i>0&&(t.root=r.slice(0,i));let o=-1,h=i,f=-1,R=!0,L=r.length-1,E=0;for(;L>=i;--L){if(n=r.charCodeAt(L),v(n)){if(!R){h=L+1;break}continue}f===-1&&(R=!1,f=L+1),n===k?o===-1?o=L:E!==1&&(E=1):o!==-1&&(E=-1)}return f!==-1&&(o===-1||E===0||E===1&&o===f-1&&o===h+1?t.base=t.name=r.slice(h,f):(t.name=r.slice(h,o),t.base=r.slice(h,f),t.ext=r.slice(o,f))),h>0&&h!==i?t.dir=r.slice(0,h-1):t.dir=t.root,t},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(b){const r=/\\/g;return()=>{const t=P.cwd().replace(r,"/");return t.slice(t.indexOf("/"))}}return()=>P.cwd()})();e.$ic={resolve(...r){let t="",a=!1;for(let i=r.length-1;i>=-1&&!a;i--){const n=i>=0?r[i]:s();l(n,"path"),n.length!==0&&(t=`${n}/${t}`,a=n.charCodeAt(0)===A)}return t=I(t,!a,"/",d),a?`/${t}`:t.length>0?t:"."},normalize(r){if(l(r,"path"),r.length===0)return".";const t=r.charCodeAt(0)===A,a=r.charCodeAt(r.length-1)===A;return r=I(r,!t,"/",d),r.length===0?t?"/":a?"./":".":(a&&(r+="/"),t?`/${r}`:r)},isAbsolute(r){return l(r,"path"),r.length>0&&r.charCodeAt(0)===A},join(...r){if(r.length===0)return".";let t;for(let a=0;a<r.length;++a){const i=r[a];l(i,"path"),i.length>0&&(t===void 0?t=i:t+=`/${i}`)}return t===void 0?".":e.$ic.normalize(t)},relative(r,t){if(l(r,"from"),l(t,"to"),r===t||(r=e.$ic.resolve(r),t=e.$ic.resolve(t),r===t))return"";const a=1,i=r.length,n=i-a,o=1,h=t.length-o,f=n<h?n:h;let R=-1,L=0;for(;L<f;L++){const y=r.charCodeAt(a+L);if(y!==t.charCodeAt(o+L))break;y===A&&(R=L)}if(L===f)if(h>f){if(t.charCodeAt(o+L)===A)return t.slice(o+L+1);if(L===0)return t.slice(o+L)}else n>f&&(r.charCodeAt(a+L)===A?R=L:L===0&&(R=0));let E="";for(L=a+R+1;L<=i;++L)(L===i||r.charCodeAt(L)===A)&&(E+=E.length===0?"..":"/..");return`${E}${t.slice(o+R)}`},toNamespacedPath(r){return r},dirname(r){if(l(r,"path"),r.length===0)return".";const t=r.charCodeAt(0)===A;let a=-1,i=!0;for(let n=r.length-1;n>=1;--n)if(r.charCodeAt(n)===A){if(!i){a=n;break}}else i=!1;return a===-1?t?"/":".":t&&a===1?"//":r.slice(0,a)},basename(r,t){t!==void 0&&l(t,"ext"),l(r,"path");let a=0,i=-1,n=!0,o;if(t!==void 0&&t.length>0&&t.length<=r.length){if(t===r)return"";let h=t.length-1,f=-1;for(o=r.length-1;o>=0;--o){const R=r.charCodeAt(o);if(R===A){if(!n){a=o+1;break}}else f===-1&&(n=!1,f=o+1),h>=0&&(R===t.charCodeAt(h)?--h===-1&&(i=o):(h=-1,i=f))}return a===i?i=f:i===-1&&(i=r.length),r.slice(a,i)}for(o=r.length-1;o>=0;--o)if(r.charCodeAt(o)===A){if(!n){a=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":r.slice(a,i)},extname(r){l(r,"path");let t=-1,a=0,i=-1,n=!0,o=0;for(let h=r.length-1;h>=0;--h){const f=r.charCodeAt(h);if(f===A){if(!n){a=h+1;break}continue}i===-1&&(n=!1,i=h+1),f===k?t===-1?t=h:o!==1&&(o=1):t!==-1&&(o=-1)}return t===-1||i===-1||o===0||o===1&&t===i-1&&t===a+1?"":r.slice(t,i)},format:g.bind(null,"/"),parse(r){l(r,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return t;const a=r.charCodeAt(0)===A;let i;a?(t.root="/",i=1):i=0;let n=-1,o=0,h=-1,f=!0,R=r.length-1,L=0;for(;R>=i;--R){const E=r.charCodeAt(R);if(E===A){if(!f){o=R+1;break}continue}h===-1&&(f=!1,h=R+1),E===k?n===-1?n=R:L!==1&&(L=1):n!==-1&&(L=-1)}if(h!==-1){const E=o===0&&a?1:o;n===-1||L===0||L===1&&n===h-1&&n===o+1?t.base=t.name=r.slice(E,h):(t.name=r.slice(E,n),t.base=r.slice(E,h),t.ext=r.slice(n,h))}return o>0?t.dir=r.slice(0,o-1):a&&(t.dir="/"),t},sep:"/",delimiter:":",win32:null,posix:null},e.$ic.win32=e.$hc.win32=e.$hc,e.$ic.posix=e.$hc.posix=e.$ic,e.$jc=b?e.$hc.normalize:e.$ic.normalize,e.$kc=b?e.$hc.isAbsolute:e.$ic.isAbsolute,e.$lc=b?e.$hc.join:e.$ic.join,e.$mc=b?e.$hc.resolve:e.$ic.resolve,e.$nc=b?e.$hc.relative:e.$ic.relative,e.$oc=b?e.$hc.dirname:e.$ic.dirname,e.$pc=b?e.$hc.basename:e.$ic.basename,e.$qc=b?e.$hc.extname:e.$ic.extname,e.$rc=b?e.$hc.format:e.$ic.format,e.$sc=b?e.$hc.parse:e.$ic.parse,e.$tc=b?e.$hc.toNamespacedPath:e.$ic.toNamespacedPath,e.sep=b?e.$hc.sep:e.$ic.sep,e.$vc=b?e.$hc.delimiter:e.$ic.delimiter}),define(ce[42],le([0,1,39,14,5,27,13]),function(ne,e,P,c,C,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=k,e.$yg=A,e.$zg=w,e.$Ag=S,e.$Bg=m,e.$Cg=b,e.$Dg=v,e.$Eg=d,e.$Fg=p,e.$Gg=I,e.$Hg=g,e.$Ig=s,e.$Jg=r,e.$Kg=t,e.$Lg=a,e.$Mg=i,e.$Ng=h;function k(f){return f===P.CharCode.Slash||f===P.CharCode.Backslash}function A(f){return f.replace(/[\\/]/g,c.$ic.sep)}function w(f){return f.indexOf("/")===-1&&(f=A(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}function S(f,R=c.$ic.sep){if(!f)return"";const L=f.length,E=f.charCodeAt(0);if(k(E)){if(k(f.charCodeAt(1))&&!k(f.charCodeAt(2))){let N=3;const F=N;for(;N<L&&!k(f.charCodeAt(N));N++);if(F!==N&&!k(f.charCodeAt(N+1))){for(N+=1;N<L;N++)if(k(f.charCodeAt(N)))return f.slice(0,N+1).replace(/[\\/]/g,R)}}return R}else if(p(E)&&f.charCodeAt(1)===P.CharCode.Colon)return k(f.charCodeAt(2))?f.slice(0,2)+R:f.slice(0,2);let y=f.indexOf("://");if(y!==-1){for(y+=3;y<L;y++)if(k(f.charCodeAt(y)))return f.slice(0,y+1)}return""}function m(f){if(!C.$i||!f||f.length<5)return!1;let R=f.charCodeAt(0);if(R!==P.CharCode.Backslash||(R=f.charCodeAt(1),R!==P.CharCode.Backslash))return!1;let L=2;const E=L;for(;L<f.length&&(R=f.charCodeAt(L),R!==P.CharCode.Backslash);L++);return!(E===L||(R=f.charCodeAt(L+1),isNaN(R)||R===P.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,$=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(f,R=C.$i){const L=R?u:$;return!(!f||f.length===0||/^\s+$/.test(f)||(L.lastIndex=0,L.test(f))||R&&l.test(f)||f==="."||f===".."||R&&f[f.length-1]==="."||R&&f.length!==f.trim().length||f.length>255)}function v(f,R,L){const E=f===R;return!L||E?E:!f||!R?!1:(0,O.$Gf)(f,R)}function d(f,R,L,E=c.sep){if(f===R)return!0;if(!f||!R||R.length>f.length)return!1;if(L){if(!(0,O.$Hf)(f,R))return!1;if(R.length===f.length)return!0;let N=R.length;return R.charAt(R.length-1)===E&&N--,f.charAt(N)===E}return R.charAt(R.length-1)!==E&&(R+=E),f.indexOf(R)===0}function p(f){return f>=P.CharCode.A&&f<=P.CharCode.Z||f>=P.CharCode.a&&f<=P.CharCode.z}function I(f,R){return C.$i&&f.endsWith(":")&&(f+=c.sep),(0,c.$kc)(f)||(f=(0,c.$lc)(R,f)),f=(0,c.$jc)(f),g(f)}function g(f){return C.$i?(f=(0,O.$of)(f,c.sep),f.endsWith(":")&&(f+=c.sep)):(f=(0,O.$of)(f,c.sep),f||(f=c.sep)),f}function s(f){const R=(0,c.$jc)(f);return C.$i?f.length>3?!1:r(R)&&(f.length===2||R.charCodeAt(2)===P.CharCode.Backslash):R===c.$ic.sep}function r(f,R=C.$i){return R?p(f.charCodeAt(0))&&f.charCodeAt(1)===P.CharCode.Colon:!1}function t(f,R=C.$i){return r(f,R)?f[0]:void 0}function a(f,R,L){return R.length>f.length?-1:f===R?0:(L&&(f=f.toLowerCase(),R=R.toLowerCase()),f.indexOf(R))}function i(f){const R=f.split(":");let L,E,y;for(const N of R){const F=Number(N);(0,T.$jg)(F)?E===void 0?E=F:y===void 0&&(y=F):L=L?[L,N].join(":"):N}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:E!==void 0?E:void 0,column:y!==void 0?y:E!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function h(f,R,L=8){let E="";for(let N=0;N<L;N++){let F;N===0&&C.$i&&!R&&(L===3||L===4)?F=o:F=n,E+=F.charAt(Math.floor(Math.random()*F.length))}let y;return R?y=`${R}-${E}`:y=E,f?(0,c.$lc)(f,y):y}}),define(ce[147],le([0,1,14]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0,e.$9s=O,e.$0s=T,e.$$s=k,e.$_s=w,e.$8s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const c={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(S){const m=(0,P.$qc)(S),u=c[m.toLowerCase()];return u!==void 0?u:T(S)}function T(S){const m=(0,P.$qc)(S);return C[m.toLowerCase()]}function k(S){for(const m in C)if(C[m]===S)return m}const A=/^(.+)\/(.+?)(;.+)?$/;function w(S,m){const u=A.exec(S);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:m?void 0:S}}),define(ce[93],le([0,1,5]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$km=O,e.$lm=T;var c;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(c||(e.Source=c={}));var C;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function O(k,...A){const w=A.reduce((u,$)=>(u[$]=!0,u),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(u=>!w[u]).forEach(u=>{for(let $=0;$<S.length;$++)if(u.search(S[$])!==-1){delete k[u];break}})}function T(k){k&&(delete k.DEBUG,P.$j&&delete k.DYLD_LIBRARY_PATH,P.$k&&delete k.LD_PRELOAD)}}),define(ce[9],le([0,1,39,66,14,5]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$xc=v,e.$yc=r,C=Oe(C);const T=/^\w[\w\d+.-]*$/,k=/^\//,A=/^\/\//;function w(o,h){if(!o.scheme&&h)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!T.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!k.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(o,h){return!o&&!h?"file":o}function m(o,h){switch(o){case"https":case"http":case"file":h?h[0]!==$&&(h=$+h):h=$;break}return h}const u="",$="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(h){return h instanceof b?!0:h?typeof h.authority=="string"&&typeof h.fragment=="string"&&typeof h.path=="string"&&typeof h.query=="string"&&typeof h.scheme=="string"&&typeof h.fsPath=="string"&&typeof h.with=="function"&&typeof h.toString=="function":!1}constructor(h,f,R,L,E,y=!1){typeof h=="object"?(this.scheme=h.scheme||u,this.authority=h.authority||u,this.path=h.path||u,this.query=h.query||u,this.fragment=h.fragment||u):(this.scheme=S(h,y),this.authority=f||u,this.path=m(this.scheme,R||u),this.query=L||u,this.fragment=E||u,w(this,y))}get fsPath(){return r(this,!1)}with(h){if(!h)return this;let{scheme:f,authority:R,path:L,query:E,fragment:y}=h;return f===void 0?f=this.scheme:f===null&&(f=u),R===void 0?R=this.authority:R===null&&(R=u),L===void 0?L=this.path:L===null&&(L=u),E===void 0?E=this.query:E===null&&(E=u),y===void 0?y=this.fragment:y===null&&(y=u),f===this.scheme&&R===this.authority&&L===this.path&&E===this.query&&y===this.fragment?this:new p(f,R,L,E,y)}static parse(h,f=!1){const R=l.exec(h);return R?new p(R[2]||u,n(R[4]||u),n(R[5]||u),n(R[7]||u),n(R[9]||u),f):new p(u,u,u,u,u)}static file(h){let f=u;if(O.$i&&(h=h.replace(/\\/g,$)),h[0]===$&&h[1]===$){const R=h.indexOf($,2);R===-1?(f=h.substring(2),h=$):(f=h.substring(2,R),h=h.substring(R)||$)}return new p("file",f,h,u,u)}static from(h,f){return new p(h.scheme,h.authority,h.path,h.query,h.fragment,f)}static joinPath(h,...f){if(!h.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return O.$i&&h.scheme==="file"?R=b.file(C.$hc.join(r(h,!0),...f)).path:R=C.$ic.join(h.path,...f),h.with({path:R})}toString(h=!1){return t(this,h)}toJSON(){return this}static revive(h){if(h){if(h instanceof b)return h;{const f=new p(h);return f._formatted=h.external??null,f._fsPath=h._sep===d?h.fsPath??null:null,f}}else return h}}e.URI=b;function v(o){return!o||typeof o!="object"?!1:typeof o.scheme=="string"&&(typeof o.authority=="string"||typeof o.authority>"u")&&(typeof o.path=="string"||typeof o.path>"u")&&(typeof o.query=="string"||typeof o.query>"u")&&(typeof o.fragment=="string"||typeof o.fragment>"u")}const d=O.$i?1:void 0;class p extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(h=!1){return h?t(this,!0):(this._formatted||(this._formatted=t(this,!1)),this._formatted)}toJSON(){const h={$mid:c.MarshalledId.Uri};return this._fsPath&&(h.fsPath=this._fsPath,h._sep=d),this._formatted&&(h.external=this._formatted),this.path&&(h.path=this.path),this.scheme&&(h.scheme=this.scheme),this.authority&&(h.authority=this.authority),this.query&&(h.query=this.query),this.fragment&&(h.fragment=this.fragment),h}}const I={[P.CharCode.Colon]:"%3A",[P.CharCode.Slash]:"%2F",[P.CharCode.QuestionMark]:"%3F",[P.CharCode.Hash]:"%23",[P.CharCode.OpenSquareBracket]:"%5B",[P.CharCode.CloseSquareBracket]:"%5D",[P.CharCode.AtSign]:"%40",[P.CharCode.ExclamationMark]:"%21",[P.CharCode.DollarSign]:"%24",[P.CharCode.Ampersand]:"%26",[P.CharCode.SingleQuote]:"%27",[P.CharCode.OpenParen]:"%28",[P.CharCode.CloseParen]:"%29",[P.CharCode.Asterisk]:"%2A",[P.CharCode.Plus]:"%2B",[P.CharCode.Comma]:"%2C",[P.CharCode.Semicolon]:"%3B",[P.CharCode.Equals]:"%3D",[P.CharCode.Space]:"%20"};function g(o,h,f){let R,L=-1;for(let E=0;E<o.length;E++){const y=o.charCodeAt(E);if(y>=P.CharCode.a&&y<=P.CharCode.z||y>=P.CharCode.A&&y<=P.CharCode.Z||y>=P.CharCode.Digit0&&y<=P.CharCode.Digit9||y===P.CharCode.Dash||y===P.CharCode.Period||y===P.CharCode.Underline||y===P.CharCode.Tilde||h&&y===P.CharCode.Slash||f&&y===P.CharCode.OpenSquareBracket||f&&y===P.CharCode.CloseSquareBracket||f&&y===P.CharCode.Colon)L!==-1&&(R+=encodeURIComponent(o.substring(L,E)),L=-1),R!==void 0&&(R+=o.charAt(E));else{R===void 0&&(R=o.substr(0,E));const N=I[y];N!==void 0?(L!==-1&&(R+=encodeURIComponent(o.substring(L,E)),L=-1),R+=N):L===-1&&(L=E)}}return L!==-1&&(R+=encodeURIComponent(o.substring(L))),R!==void 0?R:o}function s(o){let h;for(let f=0;f<o.length;f++){const R=o.charCodeAt(f);R===P.CharCode.Hash||R===P.CharCode.QuestionMark?(h===void 0&&(h=o.substr(0,f)),h+=I[R]):h!==void 0&&(h+=o[f])}return h!==void 0?h:o}function r(o,h){let f;return o.authority&&o.path.length>1&&o.scheme==="file"?f=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===P.CharCode.Slash&&(o.path.charCodeAt(1)>=P.CharCode.A&&o.path.charCodeAt(1)<=P.CharCode.Z||o.path.charCodeAt(1)>=P.CharCode.a&&o.path.charCodeAt(1)<=P.CharCode.z)&&o.path.charCodeAt(2)===P.CharCode.Colon?h?f=o.path.substr(1):f=o.path[1].toLowerCase()+o.path.substr(2):f=o.path,O.$i&&(f=f.replace(/\//g,"\\")),f}function t(o,h){const f=h?s:g;let R="",{scheme:L,authority:E,path:y,query:N,fragment:F}=o;if(L&&(R+=L,R+=":"),(E||L==="file")&&(R+=$,R+=$),E){let D=E.indexOf("@");if(D!==-1){const M=E.substr(0,D);E=E.substr(D+1),D=M.lastIndexOf(":"),D===-1?R+=f(M,!1,!1):(R+=f(M.substr(0,D),!1,!1),R+=":",R+=f(M.substr(D+1),!1,!0)),R+="@"}E=E.toLowerCase(),D=E.lastIndexOf(":"),D===-1?R+=f(E,!1,!0):(R+=f(E.substr(0,D),!1,!0),R+=E.substr(D))}if(y){if(y.length>=3&&y.charCodeAt(0)===P.CharCode.Slash&&y.charCodeAt(2)===P.CharCode.Colon){const D=y.charCodeAt(1);D>=P.CharCode.A&&D<=P.CharCode.Z&&(y=`/${String.fromCharCode(D+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===P.CharCode.Colon){const D=y.charCodeAt(0);D>=P.CharCode.A&&D<=P.CharCode.Z&&(y=`${String.fromCharCode(D+32)}:${y.substr(2)}`)}R+=f(y,!0,!1)}return N&&(R+="?",R+=f(N,!1,!1)),F&&(R+="#",R+=h?F:g(F,!1,!1)),R}function a(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+a(o.substr(3)):o}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(o){return o.match(i)?o.replace(i,h=>a(h)):o}}),define(ce[148],le([0,1,9]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=c,e.$br=C,e.$cr=O,e.log=k;function c(w){const S=w;return S&&typeof S.type=="string"&&typeof S.severity=="string"}function C(w){const S=[];let m;try{const u=JSON.parse(w.arguments),$=u[u.length-1];$&&$.__$stack&&(u.pop(),m=$.__$stack),S.push(...u)}catch{S.push("Unable to log remote console arguments",w.arguments)}return{args:S,stack:m}}function O(w){if(typeof w!="string")return O(C(w).stack);const S=w;if(S){const m=T(S),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(u&&u.length===4)return{uri:P.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function T(w){if(!w)return w;const S=w.indexOf(`
`);return S===-1?w:w.substring(0,S)}function k(w,S){const{args:m,stack:u}=C(w),$=typeof m[0]=="string"&&m.length===1;let l=T(u);l&&(l=`(${l.trim()})`);let b=[];if(typeof m[0]=="string"?l&&$?b=[`%c[${S}] %c${m[0]} %c${l}`,A("blue"),A(""),A("grey")]:b=[`%c[${S}] %c${m[0]}`,A("blue"),A(""),...m.slice(1)]:b=[`%c[${S}]%`,A("blue"),...m],l&&!$&&b.push(l),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,b)}function A(w){return`color: ${w}`}}),define(ce[69],le([0,1,15,9,66]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=O,e.$bi=T,e.$ci=A;function O(w){return JSON.stringify(w,k)}function T(w){let S=JSON.parse(w);return S=A(S),S}function k(w,S){return S instanceof RegExp?{$mid:C.MarshalledId.Regexp,source:S.source,flags:S.flags}:S}function A(w,S=0){if(!w||S>200)return w;if(typeof w=="object"){switch(w.$mid){case C.MarshalledId.Uri:return c.URI.revive(w);case C.MarshalledId.Regexp:return new RegExp(w.source,w.flags);case C.MarshalledId.Date:return new Date(w.source)}if(w instanceof P.$Oe||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let m=0;m<w.length;++m)w[m]=A(w[m],S+1);else for(const m in w)Object.hasOwnProperty.call(w,m)&&(w[m]=A(w[m],S+1))}return w}}),define(ce[23],le([0,1,8,5,27,9,14]),function(ne,e,P,c,C,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=A,e.$Pg=w,e.$Tg=m,P=Oe(P),c=Oe(c),T=Oe(T);var k;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(k||(e.Schemas=k={}));function A(l,b){return O.URI.isUri(l)?(0,C.$Gf)(l.scheme,b):(0,C.$Hf)(l,b+":")}function w(l,...b){return b.some(v=>A(l,v))}e.$Qg="vscode-tkn",e.$Rg="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b,v){this.f=m(b,v)}getServerRootPath(){return this.f}get g(){return T.$ic.join(this.f,k.vscodeRemoteResource)}set(b,v,d){this.a[b]=v,this.b[b]=d}setConnectionToken(b,v){this.c[b]=v}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)try{return this.e(b)}catch(s){return P.$3(s),b}const v=b.authority;let d=this.a[v];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const p=this.b[v],I=this.c[v];let g=`path=${encodeURIComponent(b.path)}`;return typeof I=="string"&&(g+=`&${e.$Rg}=${encodeURIComponent(I)}`),O.URI.from({scheme:c.$o?this.d:k.vscodeRemoteResource,authority:`${d}:${p}`,path:this.g,query:g})}}e.$Sg=new S;function m(l,b){return T.$ic.join(b??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class u{static{this.a=e.$Yg}asBrowserUri(b){const v=this.b(b,ne);return this.uriToBrowserUri(v)}uriToBrowserUri(b){return b.scheme===k.vscodeRemote?e.$Sg.rewrite(b):b.scheme===k.file&&(c.$m||c.$q===`${k.vscodeFileResource}://${u.a}`)?b.with({scheme:k.vscodeFileResource,authority:b.authority||u.a,query:null,fragment:null}):b}asFileUri(b){const v=this.b(b,ne);return this.uriToFileUri(v)}uriToFileUri(b){return b.scheme===k.vscodeFileResource?b.with({scheme:k.file,authority:b.authority!==u.a?b.authority:null,query:null,fragment:null}):b}b(b,v){return O.URI.isUri(b)?b:O.URI.parse(v.toUrl(b))}}e.$Zg=new u;var $;(function(l){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(b.get("3"));const v="vscode-coi";function d(I){let g;typeof I=="string"?g=new URL(I).searchParams:I instanceof URL?g=I.searchParams:O.URI.isUri(I)&&(g=new URL(I.toString(!0)).searchParams);const s=g?.get(v);if(s)return b.get(s)}l.getHeadersFromQuery=d;function p(I,g,s){if(!globalThis.crossOriginIsolated)return;const r=g&&s?"3":s?"2":"1";I instanceof URLSearchParams?I.set(v,r):I[v]=r}l.addSearchParam=p})($||(e.COI=$={}))}),define(ce[149],le([0,1,129,23,5,9]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sE=S,C=Oe(C);class T{constructor(u,$,l){this.id=u,this.dependencies=$,this.callback=l}}class k{static{this.INSTANCE=new k}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(u,$,l)=>{typeof u!="string"&&(l=$,$=u,u=null),(typeof $!="object"||!Array.isArray($))&&(l=$,$=null),this.c.push(new T(u,$,l))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this.g();const $=await(this.a?this.i(u):this.b?this.h(u):this.j(u));if(!$)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray($.dependencies)&&$.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${$.dependencies.join(", ")}`);return typeof $.callback=="function"?$.callback([]):$.callback}h(u){return new Promise(($,l)=>{const b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript");const v=()=>{b.removeEventListener("load",d),b.removeEventListener("error",p)},d=I=>{v(),$(this.c.pop())},p=I=>{v(),l(I)};b.addEventListener("load",d),b.addEventListener("error",p),this.f&&(u=this.f.createScriptURL(u)),b.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(b)})}i(u){return new Promise(($,l)=>{try{this.f&&(u=this.f.createScriptURL(u)),importScripts(u),$(this.c.pop())}catch(b){l(b)}})}async j(u){try{const $=globalThis._VSCODE_NODE_MODULES.fs,l=globalThis._VSCODE_NODE_MODULES.vm,b=globalThis._VSCODE_NODE_MODULES.module,v=O.URI.parse(u).fsPath,d=$.readFileSync(v).toString(),p=b.wrap(d.replace(/^#!.*/,""));return new l.Script(p).runInThisContext().apply(),this.c.pop()}catch($){throw $}}}const A=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function S(m,u,$){if(P.$V){$===void 0&&($=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[m]&&(m=w[m]);const l=`${m}/${u}`;if(A.has(l))return A.get(l);let b;if(/^\w[\w\d+.-]*:\/\//.test(l))b=l;else{const I=`${$&&!C.$o?c.$Wg:c.$Vg}/${l}`;b=c.$Zg.asBrowserUri(I).toString(!0)}const v=k.INSTANCE.load(b);return A.set(l,v),v}else return await new Promise((l,b)=>{ne([m],l,b)}).then(Oe)}}),define(ce[21],le([0,1,39,42,23,14,5,27,9]),function(ne,e,P,c,C,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=w,e.$ph=m,e.$qh=$,c=Oe(c),O=Oe(O);function w(l){return(0,A.$yc)(l,!0)}class S{constructor(b){this.a=b}compare(b,v,d=!1){return b===v?0:(0,k.$zf)(this.getComparisonKey(b,d),this.getComparisonKey(v,d))}isEqual(b,v,d=!1){return b===v?!0:!b||!v?!1:this.getComparisonKey(b,d)===this.getComparisonKey(v,d)}getComparisonKey(b,v=!1){return b.with({path:this.a(b)?b.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(b){return this.a(b)}isEqualOrParent(b,v,d=!1){if(b.scheme===v.scheme){if(b.scheme===C.Schemas.file)return c.$Eg(w(b),w(v),this.a(b))&&b.query===v.query&&(d||b.fragment===v.fragment);if((0,e.$lh)(b.authority,v.authority))return c.$Eg(b.path,v.path,this.a(b),"/")&&b.query===v.query&&(d||b.fragment===v.fragment)}return!1}joinPath(b,...v){return A.URI.joinPath(b,...v)}basenameOrAuthority(b){return(0,e.$dh)(b)||b.authority}basename(b){return O.$ic.basename(b.path)}extname(b){return O.$ic.extname(b.path)}dirname(b){if(b.path.length===0)return b;let v;return b.scheme===C.Schemas.file?v=A.URI.file(O.$oc(w(b))).path:(v=O.$ic.dirname(b.path),b.authority&&v.length&&v.charCodeAt(0)!==P.CharCode.Slash&&(console.error(`dirname("${b.toString})) resulted in a relative path`),v="/")),b.with({path:v})}normalizePath(b){if(!b.path.length)return b;let v;return b.scheme===C.Schemas.file?v=A.URI.file(O.$jc(w(b))).path:v=O.$ic.normalize(b.path),b.with({path:v})}relativePath(b,v){if(b.scheme!==v.scheme||!(0,e.$lh)(b.authority,v.authority))return;if(b.scheme===C.Schemas.file){const I=O.$nc(w(b),w(v));return T.$i?c.$yg(I):I}let d=b.path||"/";const p=v.path||"/";if(this.a(b)){let I=0;for(const g=Math.min(d.length,p.length);I<g&&!(d.charCodeAt(I)!==p.charCodeAt(I)&&d.charAt(I).toLowerCase()!==p.charAt(I).toLowerCase());I++);d=p.substr(0,I)+d.substr(I)}return O.$ic.relative(d,p)}resolvePath(b,v){if(b.scheme===C.Schemas.file){const d=A.URI.file(O.$mc(w(b),v));return b.with({authority:d.authority,path:d.path})}return v=c.$zg(v),b.with({path:O.$ic.resolve(b.path,v)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,v){return b===v||b!==void 0&&v!==void 0&&(0,k.$Gf)(b,v)}hasTrailingPathSeparator(b,v=O.sep){if(b.scheme===C.Schemas.file){const d=w(b);return d.length>c.$Ag(d).length&&d[d.length-1]===v}else{const d=b.path;return d.length>1&&d.charCodeAt(d.length-1)===P.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,v=O.sep){return(0,e.$mh)(b,v)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,v=O.sep){let d=!1;if(b.scheme===C.Schemas.file){const p=w(b);d=p!==void 0&&p.length===c.$Ag(p).length&&p[p.length-1]===v}else{v="/";const p=b.path;d=p.length===1&&p.charCodeAt(p.length-1)===P.CharCode.Slash}return!d&&!(0,e.$mh)(b,v)?b.with({path:b.path+"/"}):b}}e.$8g=S,e.$9g=new S(()=>!1),e.$0g=new S(l=>l.scheme===C.Schemas.file?!T.$k:!0),e.$$g=new S(l=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function m(l,b){const v=[];for(let d=0;d<l.length;d++){const p=b(l[d]);l.some((I,g)=>g===d?!1:(0,e.$ah)(p,b(I)))||v.push(l[d])}return v}var u;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function b(v){const d=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(g=>{const[s,r]=g.split(":");s&&r&&d.set(s,r)});const I=v.path.substring(0,v.path.indexOf(";"));return I&&d.set(l.META_DATA_MIME,I),d}l.parseMetaData=b})(u||(e.DataUri=u={}));function $(l,b,v){if(b){let d=l.path;return d&&d[0]!==O.$ic.sep&&(d=O.$ic.sep+d),l.with({scheme:v,authority:b,path:d})}return l.with({scheme:v})}}),define(ce[6],le([0,1,26,8,3,2,21,5,135,54]),function(ne,e,P,c,C,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=S,e.$sh=m,e.$th=u,e.$uh=$,e.$vh=l,e.$wh=b,e.$xh=v,e.$yh=d,e.$Gh=o,e.$Hh=h,e.$Ih=f,e.$Jh=R,e.$Kh=L,e.$Zh=z,e.$8h=j;function S(ee){return!!ee&&typeof ee.then=="function"}function m(ee){const X=new P.$xe,oe=ee(X.token),ue=new Promise((ge,be)=>{const Ie=X.token.onCancellationRequested(()=>{Ie.dispose(),be(new c.$7)});Promise.resolve(oe).then(pe=>{Ie.dispose(),X.dispose(),ge(pe)},pe=>{Ie.dispose(),X.dispose(),be(pe)})});return new class{cancel(){X.cancel(),X.dispose()}then(ge,be){return ue.then(ge,be)}catch(ge){return this.then(void 0,ge)}finally(ge){return ue.finally(ge)}}}function u(ee,X,oe){return new Promise((ue,ge)=>{const be=X.onCancellationRequested(()=>{be.dispose(),ue(oe)});ee.then(ue,ge).finally(()=>be.dispose())})}function $(ee,X){return new Promise((oe,ue)=>{const ge=X.onCancellationRequested(()=>{ge.dispose(),ue(new c.$7)});ee.then(oe,ue).finally(()=>ge.dispose())})}async function l(ee){let X=-1;const oe=ee.map((ue,ge)=>ue.then(be=>(X=ge,be)));try{return await Promise.race(oe)}finally{ee.forEach((ue,ge)=>{ge!==X&&ue.cancel()})}}function b(ee,X,oe){let ue;const ge=setTimeout(()=>{ue?.(void 0),oe?.()},X);return Promise.race([ee.finally(()=>clearTimeout(ge)),new Promise(be=>ue=be)])}function v(ee){return new Promise((X,oe)=>{const ue=ee();S(ue)?ue.then(X,oe):X(ue)})}function d(){let ee,X;return{promise:new Promise((ue,ge)=>{ee=ue,X=ge}),resolve:ee,reject:X}}class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const oe=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(oe,oe).then(ue)})}return new Promise((oe,ue)=>{this.b.then(oe,ue)})}return this.a=X(),new Promise((oe,ue)=>{this.a.then(ge=>{this.a=null,oe(ge)},ge=>{this.a=null,ue(ge)})})}dispose(){this.f=!0}}e.$zh=p;class I{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$Ah=I;class g{constructor(){this.a=new Map}queue(X,oe){const ge=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.a.get(X)===ge&&this.a.delete(X)});return this.a.set(X,ge),ge}}e.$Bh=g;const s=(ee,X)=>{let oe=!0;const ue=setTimeout(()=>{oe=!1,X()},ee);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(ue),oe=!1}}},r=ee=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,ee())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class t{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,oe=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((ge,be)=>{this.d=ge,this.f=be}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=oe===A.$he?r(ue):s(oe,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new c.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=t;class a{constructor(X){this.a=new t(X),this.b=new p}trigger(X,oe){return this.a.trigger(()=>this.b.queue(X),oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=a;class i{constructor(){this.a=!1,this.b=new Promise((X,oe)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=i;class n extends i{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Fh=n;function o(ee,X){return X?new Promise((oe,ue)=>{const ge=setTimeout(()=>{be.dispose(),oe()},ee),be=X.onCancellationRequested(()=>{clearTimeout(ge),be.dispose(),ue(new c.$7)})}):m(oe=>o(ee,oe))}function h(ee,X=0,oe){const ue=setTimeout(()=>{ee(),oe&&ge.dispose()},X),ge=(0,O.$Uc)(()=>{clearTimeout(ue),oe?.deleteAndLeak(ge)});return oe?.add(ge),ge}function f(ee){const X=[];let oe=0;const ue=ee.length;function ge(){return oe<ue?ee[oe++]():null}function be(Ie){Ie!=null&&X.push(Ie);const pe=ge();return pe?pe.then(be):Promise.resolve(X)}return Promise.resolve(null).then(be)}function R(ee,X=ue=>!!ue,oe=null){let ue=0;const ge=ee.length,be=()=>{if(ue>=ge)return Promise.resolve(oe);const Ie=ee[ue++];return Promise.resolve(Ie()).then(we=>X(we)?Promise.resolve(we):be())};return be()}function L(ee,X=ue=>!!ue,oe=null){if(ee.length===0)return Promise.resolve(oe);let ue=ee.length;const ge=()=>{ue=-1;for(const be of ee)be.cancel?.()};return new Promise((be,Ie)=>{for(const pe of ee)pe.then(we=>{--ue>=0&&X(we)?(ge(),be(we)):ue===0&&be(oe)}).catch(we=>{--ue>=0&&(ge(),Ie(we))})})}class E{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new C.$me}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((oe,ue)=>{this.g.push({factory:X,c:oe,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const oe=X.factory();oe.then(X.c,X.e),oe.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=E;class y extends E{constructor(){super(1)}}e.$Mh=y;class N{constructor(){this.a=new te,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Nh=N;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new q;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,oe=T.$9g){const ue=oe.getComparisonKey(X);return this.a.get(ue)?.size??0}queueFor(X,oe,ue=T.$9g){const ge=ue.getComparisonKey(X);let be=this.a.get(ge);if(!be){be=new y;const Ie=this.f++,pe=C.Event.once(be.onDrained)(()=>{be?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(Ie),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$6c),this.d.set(Ie,pe),this.a.set(ge,be)}return be.queue(oe)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=F;class D{constructor(X,oe){this.b=!1,this.a=-1,typeof X=="function"&&typeof oe=="number"&&this.setIfNotSet(X,oe)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,oe){if(this.b)throw new c.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},oe)}setIfNotSet(X,oe){if(this.b)throw new c.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},oe))}}e.$Ph=D;class M{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,oe,ue=globalThis){if(this.f)throw new c.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=ue.setInterval(()=>{X()},oe);this.d=(0,O.$Uc)(()=>{ue.clearInterval(ge),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=M;class J{constructor(X,oe){this.b=-1,this.a=X,this.d=oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=J;class W{constructor(X,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.a=X,this.b=oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=W;class x extends J{constructor(X,oe){super(X,oe),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Th=x;class G extends O.$Wc{constructor(X,oe){super(),this.g=X,this.h=oe,this.a=[],this.b=this.B(new O.$Xc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const oe of X)this.a.push(oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new J(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=G,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(ee,X)=>{(0,k.$B)(()=>{if(oe)return;const ue=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e.$Wh=(ee,X,oe)=>{const ue=ee.requestIdleCallback(X,typeof oe=="number"?{timeout:oe}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,ee.cancelIdleCallback(ue))}}},e.$Vh=ee=>(0,e.$Wh)(globalThis,ee)}();class ie{constructor(X,oe){this.g=!1,this.d=()=>{try{this.j=oe()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Wh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=ie;class V extends ie{constructor(X){super(globalThis,X)}}e.$Yh=V;async function z(ee,X,oe){let ue;for(let ge=0;ge<oe;ge++)try{return await ee()}catch(be){ue=be,await o(X)}throw ue}class te{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,oe,ue){return this.a={taskId:X,cancel:()=>ue?.(),promise:oe},oe.then(()=>this.d(X),()=>this.d(X)),oe}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:oe,resolve:ue,reject:ge}=d();this.b={run:X,promise:oe,promiseResolve:ue,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=te;class se{constructor(X,oe=()=>Date.now()){this.d=X,this.f=oe,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$2h=se;var he;(function(ee){ee[ee.Resolved=0]="Resolved",ee[ee.Rejected=1]="Rejected"})(he||(he={}));class q{get isRejected(){return this.d?.outcome===he.Rejected}get isResolved(){return this.d?.outcome===he.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===he.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,oe)=>{this.a=X,this.b=oe})}complete(X){return new Promise(oe=>{this.a(X),this.d={outcome:he.Resolved,value:X},oe()})}error(X){return new Promise(oe=>{this.b(X),this.d={outcome:he.Rejected,value:X},oe()})}cancel(){return this.error(new c.$7)}}e.$3h=q;var Z;(function(ee){async function X(ue){let ge;const be=await Promise.all(ue.map(Ie=>Ie.then(pe=>pe,pe=>{ge||(ge=pe)})));if(typeof ge<"u")throw ge;return be}ee.settled=X;function oe(ue){return new Promise(async(ge,be)=>{try{await ue(ge,be)}catch(Ie){be(Ie)}})}ee.withAsyncBody=oe})(Z||(e.Promises=Z={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(oe=>(this.a=oe,this.d=!0,oe),oe=>{throw this.b=oe,this.d=!0,oe})}requireValue(){if(!this.d)throw new c.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=K;class H{constructor(X){this.b=X,this.a=new w.$X(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=H;var U;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(U||(U={}));class Y{static fromArray(X){return new Y(oe=>{oe.emitMany(X)})}static fromPromise(X){return new Y(async oe=>{oe.emitMany(await X)})}static fromPromises(X){return new Y(async oe=>{await Promise.all(X.map(async ue=>oe.emitOne(await ue)))})}static merge(X){return new Y(async oe=>{await Promise.all(X.map(async ue=>{for await(const ge of ue)oe.emitOne(ge)}))})}static{this.EMPTY=Y.fromArray([])}constructor(X,oe){this.a=U.Initial,this.b=[],this.d=null,this.f=oe,this.g=new C.$me,queueMicrotask(async()=>{const ue={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(X(ue)),this.k()}catch(ge){this.l(ge)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===U.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===U.DoneOK)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,oe){return new Y(async ue=>{for await(const ge of X)ue.emitOne(oe(ge))})}map(X){return Y.map(this,X)}static filter(X,oe){return new Y(async ue=>{for await(const ge of X)oe(ge)&&ue.emitOne(ge)})}filter(X){return Y.filter(this,X)}static coalesce(X){return Y.filter(X,oe=>!!oe)}coalesce(){return Y.coalesce(this)}static async toPromise(X){const oe=[];for await(const ue of X)oe.push(ue);return oe}toPromise(){return Y.toPromise(this)}h(X){this.a===U.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===U.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===U.Initial&&(this.a=U.DoneOK,this.g.fire())}l(X){this.a===U.Initial&&(this.a=U.DoneError,this.d=X,this.g.fire())}}e.$6h=Y;class B extends Y{constructor(X,oe){super(oe),this.m=X}cancel(){this.m.cancel()}}e.$7h=B;function j(ee){const X=new P.$xe,oe=ee(X.token);return new B(X,async ue=>{const ge=X.token.onCancellationRequested(()=>{ge.dispose(),X.dispose(),ue.reject(new c.$7)});try{for await(const be of oe){if(X.token.isCancellationRequested)return;ue.emitOne(be)}ge.dispose(),X.dispose()}catch(be){ge.dispose(),X.dispose(),ue.reject(be)}})}class _{constructor(X){this.a=new q,this.b=new Y(ge=>{if(oe){ge.reject(oe);return}return ue&&ge.emitMany(ue),this.d=be=>ge.reject(be),this.f=be=>ge.emitOne(be),this.a.p},X);let oe,ue;this.f=ge=>{ue||(ue=[]),ue.push(ge)},this.d=ge=>{oe||(oe=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$9h=_}),define(ce[94],le([0,1,19,6,39,42,35,14,5,27]),function(ne,e,P,c,C,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=S,e.$xk=b,e.$yk=N,e.$zk=F,e.$Ak=D,e.$Bk=M,e.$Ck=J,e.$Dk=ie;function S(){return Object.create(null)}e.$vk="**",e.$wk="/";const m="[/\\\\]",u="[^/\\\\]",$=/\//g;function l(V,z){switch(V){case 0:return"";case 1:return`${u}*?`;default:return`(?:${m}|${u}+${m}${z?`|${m}${u}+`:""})*?`}}function b(V,z){if(!V)return[];const te=[];let se=!1,he=!1,q="";for(const Z of V){switch(Z){case z:if(!se&&!he){te.push(q),q="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":he=!0;break;case"]":he=!1;break}q+=Z}return q&&te.push(q),te}function v(V){if(!V)return"";let z="";const te=b(V,e.$wk);if(te.every(se=>se===e.$vk))z=".*";else{let se=!1;te.forEach((he,q)=>{if(he===e.$vk){if(se)return;z+=l(2,q===te.length-1)}else{let Z=!1,K="",H=!1,U="";for(const Y of he){if(Y!=="}"&&Z){K+=Y;continue}if(H&&(Y!=="]"||!U)){let B;Y==="-"?B=Y:(Y==="^"||Y==="!")&&!U?B="^":Y===e.$wk?B="":B=(0,w.$if)(Y),U+=B;continue}switch(Y){case"{":Z=!0;continue;case"[":H=!0;continue;case"}":{const j=`(?:${b(K,",").map(_=>v(_)).join("|")})`;z+=j,Z=!1,K="";break}case"]":{z+="["+U+"]",H=!1,U="";break}case"?":z+=u;continue;case"*":z+=l(1);continue;default:z+=(0,w.$if)(Y)}}q<te.length-1&&(te[q+1]!==e.$vk||q+2<te.length)&&(z+=m)}se=he===e.$vk})}return z}const d=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.$Fc(1e4),a=function(){return!1},i=function(){return null};function n(V,z){if(!V)return i;let te;typeof V!="string"?te=V.pattern:te=V,te=te.trim();const se=`${te}_${!!z.trimForExclusions}`;let he=t.get(se);if(he)return o(he,V);let q;return d.test(te)?he=f(te.substr(4),te):(q=p.exec(h(te,z)))?he=R(q[1],te):(z.trimForExclusions?g:I).test(te)?he=L(te,z):(q=s.exec(h(te,z)))?he=E(q[1].substr(1),te,!0):(q=r.exec(h(te,z)))?he=E(q[1],te,!1):he=y(te),t.set(se,he),o(he,V)}function o(V,z){if(typeof z=="string")return V;const te=function(se,he){return(0,O.$Eg)(se,z.base,!A.$k)?V((0,w.$nf)(se.substr(z.base.length),k.sep),he):null};return te.allBasenames=V.allBasenames,te.allPaths=V.allPaths,te.basenames=V.basenames,te.patterns=V.patterns,te}function h(V,z){return z.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function f(V,z){return function(te,se){return typeof te=="string"&&te.endsWith(V)?z:null}}function R(V,z){const te=`/${V}`,se=`\\${V}`,he=function(Z,K){return typeof Z!="string"?null:K?K===V?z:null:Z===V||Z.endsWith(te)||Z.endsWith(se)?z:null},q=[V];return he.basenames=q,he.patterns=[z],he.allBasenames=q,he}function L(V,z){const te=G(V.slice(1,-1).split(",").map(K=>n(K,z)).filter(K=>K!==i),V),se=te.length;if(!se)return i;if(se===1)return te[0];const he=function(K,H){for(let U=0,Y=te.length;U<Y;U++)if(te[U](K,H))return V;return null},q=te.find(K=>!!K.allBasenames);q&&(he.allBasenames=q.allBasenames);const Z=te.reduce((K,H)=>H.allPaths?K.concat(H.allPaths):K,[]);return Z.length&&(he.allPaths=Z),he}function E(V,z,te){const se=k.sep===k.$ic.sep,he=se?V:V.replace($,k.sep),q=k.sep+he,Z=k.$ic.sep+V;let K;return te?K=function(H,U){return typeof H=="string"&&(H===he||H.endsWith(q)||!se&&(H===V||H.endsWith(Z)))?z:null}:K=function(H,U){return typeof H=="string"&&(H===he||!se&&H===V)?z:null},K.allPaths=[(te?"*/":"./")+V],K}function y(V){try{const z=new RegExp(`^${v(V)}$`);return function(te){return z.lastIndex=0,typeof te=="string"&&z.test(te)?V:null}}catch{return i}}function N(V,z,te){return!V||typeof z!="string"?!1:F(V)(z,void 0,te)}function F(V,z={}){if(!V)return a;if(typeof V=="string"||D(V)){const te=n(V,z);if(te===i)return a;const se=function(he,q){return!!te(he,q)};return te.allBasenames&&(se.allBasenames=te.allBasenames),te.allPaths&&(se.allPaths=te.allPaths),se}return W(V,z)}function D(V){const z=V;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function M(V){return V.allBasenames||[]}function J(V){return V.allPaths||[]}function W(V,z){const te=G(Object.getOwnPropertyNames(V).map(K=>x(K,V[K],z)).filter(K=>K!==i)),se=te.length;if(!se)return i;if(!te.some(K=>!!K.requiresSiblings)){if(se===1)return te[0];const K=function(Y,B){let j;for(let _=0,ee=te.length;_<ee;_++){const X=te[_](Y,B);if(typeof X=="string")return X;(0,c.$rh)(X)&&(j||(j=[]),j.push(X))}return j?(async()=>{for(const _ of j){const ee=await _;if(typeof ee=="string")return ee}return null})():null},H=te.find(Y=>!!Y.allBasenames);H&&(K.allBasenames=H.allBasenames);const U=te.reduce((Y,B)=>B.allPaths?Y.concat(B.allPaths):Y,[]);return U.length&&(K.allPaths=U),K}const he=function(K,H,U){let Y,B;for(let j=0,_=te.length;j<_;j++){const ee=te[j];ee.requiresSiblings&&U&&(H||(H=(0,k.$pc)(K)),Y||(Y=H.substr(0,H.length-(0,k.$qc)(K).length)));const X=ee(K,H,Y,U);if(typeof X=="string")return X;(0,c.$rh)(X)&&(B||(B=[]),B.push(X))}return B?(async()=>{for(const j of B){const _=await j;if(typeof _=="string")return _}return null})():null},q=te.find(K=>!!K.allBasenames);q&&(he.allBasenames=q.allBasenames);const Z=te.reduce((K,H)=>H.allPaths?K.concat(H.allPaths):K,[]);return Z.length&&(he.allPaths=Z),he}function x(V,z,te){if(z===!1)return i;const se=n(V,te);if(se===i)return i;if(typeof z=="boolean")return se;if(z){const he=z.when;if(typeof he=="string"){const q=(Z,K,H,U)=>{if(!U||!se(Z,K))return null;const Y=he.replace("$(basename)",()=>H),B=U(Y);return(0,c.$rh)(B)?B.then(j=>j?V:null):B?V:null};return q.requiresSiblings=!0,q}}return se}function G(V,z){const te=V.filter(K=>!!K.basenames);if(te.length<2)return V;const se=te.reduce((K,H)=>{const U=H.basenames;return U?K.concat(U):K},[]);let he;if(z){he=[];for(let K=0,H=se.length;K<H;K++)he.push(z)}else he=te.reduce((K,H)=>{const U=H.patterns;return U?K.concat(U):K},[]);const q=function(K,H){if(typeof K!="string")return null;if(!H){let Y;for(Y=K.length;Y>0;Y--){const B=K.charCodeAt(Y-1);if(B===C.CharCode.Slash||B===C.CharCode.Backslash)break}H=K.substr(Y)}const U=se.indexOf(H);return U!==-1?he[U]:null};q.basenames=se,q.patterns=he,q.allBasenames=se;const Z=V.filter(K=>!K.basenames);return Z.push(q),Z}function ie(V,z){return(0,P.$wb)(V,z,(te,se)=>typeof te=="string"&&typeof se=="string"?te===se:typeof te!="string"&&typeof se!="string"?te.base===se.base&&te.pattern===se.pattern:!1)}}),define(ce[95],le([0,1,15,66,9]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=void 0,e.$Nn=A,e.$On=S,e.$Pn=m;function O(u){return u.toJSON()}class T{constructor($){this.a=$}transformIncoming($){const l=this.a.transformIncoming($);return l===$?$:O(C.URI.from(l))}transformOutgoing($){const l=this.a.transformOutgoing($);return l===$?$:O(C.URI.from(l))}transformOutgoingURI($){const l=this.a.transformOutgoing($);return l===$?$:C.URI.from(l)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Ln=T,e.$Mn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function k(u,$,l){if(!u||l>200)return null;if(typeof u=="object"){if(u instanceof C.URI)return $.transformOutgoing(u);for(const b in u)if(Object.hasOwnProperty.call(u,b)){const v=k(u[b],$,l+1);v!==null&&(u[b]=v)}}return null}function A(u,$){const l=k(u,$,0);return l===null?u:l}function w(u,$,l,b){if(!u||b>200)return null;if(typeof u=="object"){if(u.$mid===c.MarshalledId.Uri)return l?C.URI.revive($.transformIncoming(u)):$.transformIncoming(u);if(u instanceof P.$Oe)return null;for(const v in u)if(Object.hasOwnProperty.call(u,v)){const d=w(u[v],$,l,b+1);d!==null&&(u[v]=d)}}return null}function S(u,$){const l=w(u,$,!1,0);return l===null?u:l}function m(u,$){const l=w(u,$,!0,0);return l===null?u:l}}),define(ce[150],le([0,1,38,52,32,137,5]),function(ne,e,P,c,C,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=void 0,e.$Sn=A,e.$Tn=m,e.$Un=u,C=Oe(C),e.$Rn=new class{c($){return this.a||(this.a=c.$Li.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,l=0;const b=(0,P.networkInterfaces)();for(const v in b){const d=b[v];if(d)for(const{mac:p,internal:I}of d)I||(l+=1,this.c(p.toUpperCase())&&($+=1))}this.b=l>0?$/l:0}return this.b}};let k;async function A($){return k||(k=(async()=>await w($)||C.$2g())()),k}async function w($){try{const l=await new Promise((v,d)=>{ne(["crypto"],v,d)}).then(Oe),b=(0,O.$Qn)();return l.createHash("sha256").update(b,"utf8").digest("hex")}catch(l){$(l);return}}const S="Software\\Microsoft\\SQMClient";async function m($){if(T.$i){const l=await new Promise((b,v)=>{ne(["@vscode/windows-registry"],b,v)}).then(Oe);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",S,"MachineId")||""}catch(b){return $(b),""}}return""}async function u($){try{return await(await new Promise((v,d)=>{ne(["@vscode/deviceid"],v,d)}).then(Oe)).getDeviceId()}catch(l){return $(l),""}}}),define(ce[151],le([0,1,46,152,14,37]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AX=S,e.$BX=m;const T="XDG_SESSION_TYPE",k="WAYLAND_DISPLAY",A="XDG_RUNTIME_DIR";var w;(function(u){u.Wayland="wayland",u.XWayland="xwayland",u.X11="x11",u.Unknown="unknown"})(w||(w={}));async function S(u){const $=O.env[T];if($)return $===w.Wayland||$===w.X11?$:w.Unknown;if(O.env[k]){const b=O.env[A];if(b){const v=(0,C.$lc)(b,"wayland-0");try{return await(0,c.access)(v,P.constants.R_OK),w.Wayland}catch(d){return u(d),w.Unknown}}else return w.Unknown}else return w.X11}function m(u,$){if($)switch($){case"auto":return u;case"x11":return u===w.Wayland?w.XWayland:w.X11;case"wayland":return w.Wayland;default:return w.Unknown}else return u===w.Wayland?w.XWayland:w.X11}}),define(ce[153],le([0,1,46,152,278,5]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=T,O=Oe(O);async function T(k){if(O.$j||O.$i)return;let A;for(const w of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{A=await(0,c.open)(w,P.constants.R_OK);break}catch{}if(!A){k("Unable to retrieve release information from known identifier paths.");return}try{const w=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),S={id:"unknown"};for await(const m of(0,C.createInterface)({input:A.createReadStream(),crlfDelay:1/0})){if(!m.includes("="))continue;const u=m.split("=")[0].toUpperCase().trim();if(w.has(u)){const $=m.split("=")[1].replace(/"/g,"").toLowerCase().trim();u==="ID"||u==="DISTRIB_ID"?S.id=$:u==="ID_LIKE"?S.id_like=$:(u==="VERSION_ID"||u==="DISTRIB_RELEASE")&&(S.version_id=$)}}return S}catch(w){k(w)}}}),define(ce[31],le([0,1,46,38,279,6,42,91,14,5,21,9]),function(ne,e,P,c,C,O,T,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=v,e.readdirSync=I,e.whenDeleted=r,e.configureFlushOnWrite=o,e.writeFileSync=f,P=Oe(P);var u;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function $(W,x=u.UNLINK,G){if((0,T.$Ig)(W))throw new Error("rimraf - will refuse to recursively delete root");return x===u.UNLINK?b(W):l(W,G)}async function l(W,x=(0,T.$Ng)((0,c.tmpdir)())){try{try{await P.promises.rename(W,x)}catch(G){return G.code==="ENOENT"?void 0:b(W)}b(x).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function b(W){return P.promises.rm(W,{recursive:!0,force:!0,maxRetries:3})}function v(W){if((0,T.$Ig)(W))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(W,{recursive:!0,force:!0,maxRetries:3})}async function d(W,x){return g(await(x?p(W):P.promises.readdir(W)))}async function p(W){try{return await P.promises.readdir(W,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const x=[],G=await d(W);for(const ie of G){let V=!1,z=!1,te=!1;try{const se=await e.Promises.lstat((0,A.$lc)(W,ie));V=se.isFile(),z=se.isDirectory(),te=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}x.push({name:ie,isFile:()=>V,isDirectory:()=>z,isSymbolicLink:()=>te})}return x}function I(W){return g(P.readdirSync(W))}function g(W){return W.map(x=>typeof x=="string"?w.$j?(0,k.$mm)(x):x:(x.name=w.$j?(0,k.$mm)(x.name):x.name,x))}async function s(W){const x=await d(W),G=[];for(const ie of x)await t.existsDirectory((0,A.$lc)(W,ie))&&G.push(ie);return G}function r(W,x=1e3){return new Promise(G=>{let ie=!1;const V=setInterval(()=>{ie||(ie=!0,P.access(W,z=>{ie=!1,z&&(clearInterval(V),G(void 0))}))},x)})}var t;(function(W){async function x(V){let z;try{if(z=await e.Promises.lstat(V),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(w.$i&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw se}throw te}}W.stat=x;async function G(V){try{const{stat:z,symbolicLink:te}=await W.stat(V);return z.isFile()&&te?.dangling!==!0}catch{}return!1}W.existsFile=G;async function ie(V){try{const{stat:z,symbolicLink:te}=await W.stat(V);return z.isDirectory()&&te?.dangling!==!0}catch{}return!1}W.existsDirectory=ie})(t||(e.SymlinkSupport=t={}));const a=new O.$Oh;function i(W,x,G){return a.queueFor(m.URI.file(W),()=>{const ie=R(G);return new Promise((V,z)=>h(W,x,ie,te=>te?z(te):V()))},S.$0g)}let n=!0;function o(W){n=W}function h(W,x,G,ie){if(!n)return P.writeFile(W,x,{mode:G.mode,flag:G.flag},ie);P.open(W,G.flag,G.mode,(V,z)=>{if(V)return ie(V);P.writeFile(z,x,te=>{if(te)return P.close(z,()=>ie(te));P.fdatasync(z,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),o(!1)),P.close(z,he=>ie(he))))})})}function f(W,x,G){const ie=R(G);if(!n)return P.writeFileSync(W,x,{mode:ie.mode,flag:ie.flag});const V=P.openSync(W,ie.flag,ie.mode);try{P.writeFileSync(V,x);try{P.fdatasyncSync(V)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),o(!1)}}finally{P.closeSync(V)}}function R(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function L(W,x,G=6e4){if(W!==x)try{w.$i&&typeof G=="number"?await E(W,x,Date.now(),G):await P.promises.rename(W,x)}catch(ie){if(W.toLowerCase()!==x.toLowerCase()&&ie.code==="EXDEV"||W.endsWith("."))await y(W,x,{preserveSymlinks:!1}),await $(W,u.MOVE);else throw ie}}async function E(W,x,G,ie,V=0){try{return await P.promises.rename(W,x)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-G>=ie)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${z}`),z;if(V===0){let te=!1;try{const{stat:se}=await t.stat(x);se.isFile()||(te=!0)}catch{}if(te)throw z}return await(0,O.$Gh)(Math.min(100,V*10)),E(W,x,G,ie,V+1)}}async function y(W,x,G){return F(W,x,{root:{source:W,target:x},options:G,handledSourcePaths:new Set})}const N=511;async function F(W,x,G){if(G.handledSourcePaths.has(W))return;G.handledSourcePaths.add(W);const{stat:ie,symbolicLink:V}=await t.stat(W);if(V){if(G.options.preserveSymlinks)try{return await J(W,x,G)}catch{}if(V.dangling)return}return ie.isDirectory()?D(W,x,ie.mode&N,G):M(W,x,ie.mode&N)}async function D(W,x,G,ie){await e.Promises.mkdir(x,{recursive:!0,mode:G});const V=await d(W);for(const z of V)await F((0,A.$lc)(W,z),(0,A.$lc)(x,z),ie)}async function M(W,x,G){await e.Promises.copyFile(W,x),await e.Promises.chmod(x,G)}async function J(W,x,G){let ie=await e.Promises.readlink(W);(0,T.$Eg)(ie,G.root.source,!w.$k)&&(ie=(0,A.$lc)(G.root.target,ie.substr(G.root.source.length+1))),await e.Promises.symlink(ie,x)}e.Promises=new class{get access(){return P.promises.access}get stat(){return P.promises.stat}get lstat(){return P.promises.lstat}get utimes(){return P.promises.utimes}get read(){return(W,x,G,ie,V)=>new Promise((z,te)=>{P.read(W,x,G,ie,V,(se,he,q)=>se?te(se):z({bytesRead:he,buffer:q}))})}get readFile(){return P.promises.readFile}get write(){return(W,x,G,ie,V)=>new Promise((z,te)=>{P.write(W,x,G,ie,V,(se,he,q)=>se?te(se):z({bytesWritten:he,buffer:q}))})}get appendFile(){return P.promises.appendFile}get fdatasync(){return(0,C.promisify)(P.fdatasync)}get truncate(){return P.promises.truncate}get copyFile(){return P.promises.copyFile}get open(){return(0,C.promisify)(P.open)}get close(){return(0,C.promisify)(P.close)}get symlink(){return P.promises.symlink}get readlink(){return P.promises.readlink}get chmod(){return P.promises.chmod}get mkdir(){return P.promises.mkdir}get unlink(){return P.promises.unlink}get rmdir(){return P.promises.rmdir}get realpath(){return(0,C.promisify)(P.realpath)}async exists(W){try{return await e.Promises.access(W),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return s}get writeFile(){return i}get rm(){return $}get rename(){return L}get copy(){return y}}}),define(ce[154],le([0,1,46,14,5,27,31]),function(ne,e,P,c,C,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=k,e.$jr=A,e.$kr=w,e.$lr=S,P=Oe(P);function k(u){if(C.$k)return u;const $=(0,c.$oc)(u);if(u===$)return u;const l=((0,c.$pc)(u)||u).toLowerCase();try{const v=(0,T.readdirSync)($).filter(d=>d.toLowerCase()===l);if(v.length===1){const d=k($);if(d)return(0,c.$lc)(d,v[0])}else if(v.length>1){const d=v.indexOf(l);if(d>=0){const p=k($);if(p)return(0,c.$lc)(p,v[d])}}}catch{}return null}async function A(u,$){if(C.$k)return u;const l=(0,c.$oc)(u);if(u===l)return u;const b=((0,c.$pc)(u)||u).toLowerCase();try{if($?.isCancellationRequested)return null;const d=(await T.Promises.readdir(l)).filter(p=>p.toLowerCase()===b);if(d.length===1){const p=await A(l,$);if(p)return(0,c.$lc)(p,d[0])}else if(d.length>1){const p=d.indexOf(b);if(p>=0){const I=await A(l,$);if(I)return(0,c.$lc)(I,d[p])}}}catch{}return null}async function w(u){try{return await T.Promises.realpath(u)}catch{const l=m(u);return await T.Promises.access(l,P.constants.R_OK),l}}function S(u){try{return P.realpathSync(u)}catch{const l=m(u);return P.accessSync(l,P.constants.R_OK),l}}function m(u){return(0,O.$of)((0,c.$jc)(u),c.sep)}}),define(ce[155],le([0,1,14,5,37,93,13,31]),function(ne,e,P,c,C,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$xm=A,e.$ym=w,P=Oe(P),c=Oe(c),C=Oe(C),T=Oe(T),k=Oe(k),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function A(m=C.env){return m.comspec||"cmd.exe"}function w(m){let u=[],$=!1;const l=function(b){if($){u.push(b);return}(!m.send(b,d=>{if(d&&console.error(d),$=!1,u.length>0){const p=u.slice(0);u=[],p.forEach(I=>l(I))}})||c.$i)&&($=!0)};return{send:l}}var S;(function(m){async function u($,l,b){if(P.$kc($))return $;if(l===void 0&&(l=C.cwd()),P.$oc($)!=="."||(b===void 0&&T.$fg(C.env.PATH)&&(b=C.env.PATH.split(P.$vc)),b===void 0||b.length===0))return P.$lc(l,$);async function d(p){if(await k.Promises.exists(p)){let I;try{I=await k.Promises.stat(p)}catch(g){g.message.startsWith("EACCES")&&(I=await k.Promises.lstat(p))}return I?!I.isDirectory():!1}return!1}for(const p of b){let I;if(P.$kc(p)?I=P.$lc(p,$):I=P.$lc(l,p,$),await d(I))return I;let g=I+".com";if(await d(g)||(g=I+".exe",await d(g)))return g}return P.$lc(l,$)}m.findExecutable=u})(S||(e.win32=S={}))}),define(ce[156],le([0,1,70,23]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=C;function C(T){return new Promise((k,A)=>{let w;const S=new Map;function m($,l,b,v,d){const p=S.get(l);if($===T||p){const I={name:u(b),cmd:b,pid:$,ppid:l,load:v,mem:d};S.set($,I),$===T&&(w=I),p&&(p.children||(p.children=[]),p.children.push(I),p.children.length>1&&(p.children=p.children.sort((g,s)=>g.pid-s.pid)))}}function u($){const l=/--utility-sub-type=network/i,b=/--crashes-directory/i,v=/\\pipe\\winpty-control/i,d=/conhost\.exe.+--headless/i,p=/--type=([a-zA-Z-]+)/;if(b.exec($))return"electron-crash-reporter";if(v.exec($))return"winpty-agent";if(d.exec($))return"conpty-agent";let I=p.exec($);if(I&&I.length===2)return I[1]==="renderer"?"window":I[1]==="utility"?l.exec($)?"utility-network-service":"utility-process":I[1]==="extensionHost"?"extension-host":I[1];const g=/[a-zA-Z-]+\.js/g;let s="";do I=g.exec($),I&&(s+=I+" ");while(I);return s&&$.indexOf("node ")<0&&$.indexOf("node.exe")<0?`electron-nodejs (${s})`:$}if(process.platform==="win32"){const $=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,b)=>{ne(["@vscode/windows-process-tree"],l,b)}).then(Oe).then(l=>{l.getProcessList(T,b=>{if(!b){A(new Error(`Root process ${T} not found`));return}l.getProcessCpuUsage(b,v=>{const d=new Map;v.forEach(p=>{const I=$(p.commandLine||"");d.set(p.pid,{name:u(I),cmd:I,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),w=d.get(T),w?(d.forEach(p=>{const I=d.get(p.ppid);I&&(I.children||(I.children=[]),I.children.push(p))}),d.forEach(p=>{p.children&&(p.children=p.children.sort((I,g)=>I.pid-g.pid))}),k(w)):A(new Error(`Root process ${T} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let $=function(){let l=[w];const b=[];for(;l.length;){const d=l.shift();d&&(b.push(d.pid),d.children&&(l=l.concat(d.children)))}let v=JSON.stringify(c.$Zg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+b.join(" "),(0,P.exec)(v,{},(d,p,I)=>{if(d||I)A(d||new Error(I.toString()));else{const g=p.toString().split(`
`);for(let s=0;s<b.length;s++){const r=S.get(b[s]);r.load=parseFloat(g[s])}if(!w){A(new Error(`Root process ${T} not found`));return}k(w)}})};(0,P.exec)("which ps",{},(l,b,v)=>{if(l||v)if(process.platform!=="linux")A(l||new Error(v.toString()));else{const d=JSON.stringify(c.$Zg.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(d,{},(p,I,g)=>{p||g?A(p||new Error(g.toString())):(O(I,m),$())})}else{const d=b.toString().trim();(0,P.exec)(`${d} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(I,g,s)=>{I||s&&!s.includes("screen size is bogus")?A(I||new Error(s.toString())):(O(g,m),process.platform==="linux"?$():w?k(w):A(new Error(`Root process ${T} not found`)))})}})}})}function O(T,k){const A=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=T.toString().split(`
`);for(const S of w){const m=A.exec(S.trim());m&&m.length===6&&k(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}});var ve=this&&this.__decorate||function(ne,e,P,c){var C=arguments.length,O=C<3?e:c===null?c=Object.getOwnPropertyDescriptor(e,P):c,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ne,e,P,c);else for(var k=ne.length-1;k>=0;k--)(T=ne[k])&&(O=(C<3?T(O):C>3?T(e,P,O):T(e,P))||O);return C>3&&O&&Object.defineProperty(e,P,O),O};define(ce[43],le([0,1,19,6,15,26,88,8,3,2,69,27,13]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=o,e.$gi=h,e.$li=N,e.$mi=F,m=Oe(m);var $;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})($||($={}));function l(V){switch(V){case $.Promise:return"req";case $.PromiseCancel:return"cancel";case $.EventListen:return"subscribe";case $.EventDispose:return"unsubscribe"}}var b;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(b||(b={}));function v(V){switch(V){case b.Initialize:return"init";case b.PromiseSuccess:return"reply:";case b.PromiseError:case b.PromiseErrorObj:return"replyErr:";case b.EventFire:return"event:"}}var d;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(d||(d={}));function p(V){let z=0;for(let te=0;;te+=7){const se=V.read(1);if(z|=(se.buffer[0]&127)<<te,!(se.buffer[0]&128))return z}}const I=a(0);function g(V,z){if(z===0){V.write(I);return}let te=0;for(let he=z;he!==0;he=he>>>7)te++;const se=C.$Oe.alloc(te);for(let he=0;z!==0;he++)se.buffer[he]=z&127,z=z>>>7,z>0&&(se.buffer[he]|=128);V.write(se)}class s{constructor(z){this.b=z,this.a=0}read(z){const te=this.b.slice(this.a,this.a+z);return this.a+=te.byteLength,te}}e.$di=s;class r{constructor(){this.a=[]}get buffer(){return C.$Oe.concat(this.a)}write(z){this.a.push(z)}}e.$ei=r;var t;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(t||(t={}));function a(V){const z=C.$Oe.alloc(1);return z.writeUInt8(V,0),z}const i={Undefined:a(t.Undefined),String:a(t.String),Buffer:a(t.Buffer),VSBuffer:a(t.VSBuffer),Array:a(t.Array),Object:a(t.Object),Uint:a(t.Int)},n=typeof Buffer<"u";function o(V,z){if(typeof z>"u")V.write(i.Undefined);else if(typeof z=="string"){const te=C.$Oe.fromString(z);V.write(i.String),g(V,te.byteLength),V.write(te)}else if(n&&Buffer.isBuffer(z)){const te=C.$Oe.wrap(z);V.write(i.Buffer),g(V,te.byteLength),V.write(te)}else if(z instanceof C.$Oe)V.write(i.VSBuffer),g(V,z.byteLength),V.write(z);else if(Array.isArray(z)){V.write(i.Array),g(V,z.length);for(const te of z)o(V,te)}else if(typeof z=="number"&&(z|0)===z)V.write(i.Uint),g(V,z);else{const te=C.$Oe.fromString(JSON.stringify(z));V.write(i.Object),g(V,te.byteLength),V.write(te)}}function h(V){switch(V.read(1).readUInt8(0)){case t.Undefined:return;case t.String:return V.read(p(V)).toString();case t.Buffer:return V.read(p(V)).buffer;case t.VSBuffer:return V.read(p(V));case t.Array:{const te=p(V),se=[];for(let he=0;he<te;he++)se.push(h(V));return se}case t.Object:return JSON.parse(V.read(p(V)).toString());case t.Int:return p(V)}}class f{constructor(z,te,se=null,he=1e3){this.h=z,this.j=te,this.k=se,this.l=he,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(q=>this.q(q)),this.m({type:b.Initialize})}registerChannel(z,te){this.b.set(z,te),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case b.Initialize:{const te=this.o([z.type]);this.k?.logOutgoing(te,0,R.OtherSide,v(z.type));return}case b.PromiseSuccess:case b.PromiseError:case b.EventFire:case b.PromiseErrorObj:{const te=this.o([z.type,z.id],z.data);this.k?.logOutgoing(te,z.id,R.OtherSide,v(z.type),z.data);return}}}o(z,te=void 0){const se=new r;return o(se,z),o(se,te),this.p(se.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const te=new s(z),se=h(te),he=h(te),q=se[0];switch(q){case $.Promise:return this.k?.logIncoming(z.byteLength,se[1],R.OtherSide,`${l(q)}: ${se[2]}.${se[3]}`,he),this.s({type:q,id:se[1],channelName:se[2],name:se[3],arg:he});case $.EventListen:return this.k?.logIncoming(z.byteLength,se[1],R.OtherSide,`${l(q)}: ${se[2]}.${se[3]}`,he),this.t({type:q,id:se[1],channelName:se[2],name:se[3],arg:he});case $.PromiseCancel:return this.k?.logIncoming(z.byteLength,se[1],R.OtherSide,`${l(q)}`),this.u({type:q,id:se[1]});case $.EventDispose:return this.k?.logIncoming(z.byteLength,se[1],R.OtherSide,`${l(q)}`),this.u({type:q,id:se[1]})}}s(z){const te=this.b.get(z.channelName);if(!te){this.v(z);return}const se=new O.$xe;let he;try{he=te.call(this.j,z.name,z.arg,se.token)}catch(K){he=Promise.reject(K)}const q=z.id;he.then(K=>{this.m({id:q,data:K,type:b.PromiseSuccess})},K=>{K instanceof Error?this.m({id:q,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split(`
`):void 0},type:b.PromiseError}):this.m({id:q,data:K,type:b.PromiseErrorObj})}).finally(()=>{Z.dispose(),this.d.delete(z.id)});const Z=(0,w.$Uc)(()=>se.cancel());this.d.set(z.id,Z)}t(z){const te=this.b.get(z.channelName);if(!te){this.v(z);return}const se=z.id,q=te.listen(this.j,z.name,z.arg)(Z=>this.m({id:se,data:Z,type:b.EventFire}));this.d.set(z.id,q)}u(z){const te=this.d.get(z.id);te&&(te.dispose(),this.d.delete(z.id))}v(z){let te=this.g.get(z.channelName);te||(te=[],this.g.set(z.channelName,te));const se=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===$.Promise&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:b.PromiseError})},this.l);te.push({request:z,timeoutTimer:se})}w(z){const te=this.g.get(z);if(te){for(const se of te)switch(clearTimeout(se.timeoutTimer),se.request.type){case $.Promise:this.s(se.request);break;case $.EventListen:this.t(se.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Rc)(this.d.values()),this.d.clear()}}e.$hi=f;var R;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class L{constructor(z,te=null){this.l=z,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new A.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(se=>this.s(se)),this.j=te}getChannel(z){const te=this;return{call(se,he,q){return te.a?Promise.reject(new k.$7):te.m(z,se,he,q)},listen(se,he){return te.a?A.Event.None:te.o(z,se,he)}}}m(z,te,se,he=O.CancellationToken.None){const q=this.g++,Z=$.Promise,K={id:q,type:Z,channelName:z,name:te,arg:se};if(he.isCancellationRequested)return Promise.reject(new k.$7);let H;return new Promise((Y,B)=>{if(he.isCancellationRequested)return B(new k.$7);const j=()=>{const oe=ue=>{switch(ue.type){case b.PromiseSuccess:this.f.delete(q),Y(ue.data);break;case b.PromiseError:{this.f.delete(q);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,B(ge);break}case b.PromiseErrorObj:this.f.delete(q),B(ue.data);break}};this.f.set(q,oe),this.p(K)};let _=null;this.b===d.Idle?j():(_=(0,c.$sh)(oe=>this.u()),_.then(()=>{_=null,j()}));const ee=()=>{_?(_.cancel(),_=null):this.p({id:q,type:$.PromiseCancel}),B(new k.$7)},X=he.onCancellationRequested(ee);H=(0,w.$Tc)((0,w.$Uc)(ee),X),this.d.add(H)}).finally(()=>{H.dispose(),this.d.delete(H)})}o(z,te,se){const he=this.g++,q=$.EventListen,Z={id:he,type:q,channelName:z,name:te,arg:se};let K=null;const H=new A.$me({onWillAddFirstListener:()=>{K=(0,c.$sh)(Y=>this.u()),K.then(()=>{K=null,this.d.add(H),this.p(Z)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(H),this.p({id:he,type:$.EventDispose}))}}),U=Y=>H.fire(Y.data);return this.f.set(he,U),H.event}p(z){switch(z.type){case $.Promise:case $.EventListen:{const te=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(te,z.id,R.LocalSide,`${l(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case $.PromiseCancel:case $.EventDispose:{const te=this.q([z.type,z.id]);this.j?.logOutgoing(te,z.id,R.LocalSide,l(z.type));return}}}q(z,te=void 0){const se=new r;return o(se,z),o(se,te),this.r(se.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const te=new s(z),se=h(te),he=h(te),q=se[0];switch(q){case b.Initialize:return this.j?.logIncoming(z.byteLength,0,R.LocalSide,v(q)),this.t({type:se[0]});case b.PromiseSuccess:case b.PromiseError:case b.EventFire:case b.PromiseErrorObj:return this.j?.logIncoming(z.byteLength,se[1],R.LocalSide,v(q),he),this.t({type:se[0],id:se[1],data:he})}}t(z){if(z.type===b.Initialize){this.b=d.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return A.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Rc)(this.d.values()),this.d.clear()}}e.$ii=L,ve([T.$0h],L.prototype,"onDidInitializePromise",null);class E{get connections(){const z=[];return this.f.forEach(te=>z.push(te)),z}constructor(z,te,se){this.a=new Map,this.f=new Set,this.g=new A.$me,this.onDidAddConnection=this.g.event,this.h=new A.$me,this.onDidRemoveConnection=this.h.event,this.j=new w.$Vc,this.j.add(z(({protocol:he,onDidClientDisconnect:q})=>{const Z=A.Event.once(he.onMessage);this.j.add(Z(K=>{const H=new s(K),U=h(H),Y=new f(he,U,te,se),B=new L(he,te);this.a.forEach((_,ee)=>Y.registerChannel(ee,_));const j={channelServer:Y,channelClient:B,ctx:U};this.f.add(j),this.g.fire(j),this.j.add(q(()=>{Y.dispose(),B.dispose(),this.f.delete(j),this.h.fire(j)}))}))}))}getChannel(z,te){const se=this;return{call(he,q,Z){let K;if((0,u.$tg)(te)){const U=(0,P.$5b)(se.connections.filter(te));K=U?Promise.resolve(U):A.Event.toPromise(A.Event.filter(se.onDidAddConnection,te))}else K=te.routeCall(se,he,q);const H=K.then(U=>U.channelClient.getChannel(z));return N(H).call(he,q,Z)},listen(he,q){if((0,u.$tg)(te))return se.k(z,te,he,q);const Z=te.routeEvent(se,he,q).then(K=>K.channelClient.getChannel(z));return N(Z).listen(he,q)}}}k(z,te,se,he){const q=this;let Z;const K=new A.$me({onWillAddFirstListener:()=>{Z=new w.$Vc;const H=new A.$se,U=new Map,Y=j=>{const ee=j.channelClient.getChannel(z).listen(se,he),X=H.add(ee);U.set(j,X)},B=j=>{const _=U.get(j);_&&(_.dispose(),U.delete(j))};q.connections.filter(te).forEach(Y),A.Event.filter(q.onDidAddConnection,te)(Y,void 0,Z),q.onDidRemoveConnection(B,void 0,Z),H.event(K.fire,K,Z),Z.add(H)},onDidRemoveLastListener:()=>{Z?.dispose(),Z=void 0}});return K.event}registerChannel(z,te){this.a.set(z,te);for(const se of this.f)se.channelServer.registerChannel(z,te)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=E;class y{constructor(z,te,se=null){const he=new r;o(he,te),z.send(he.buffer),this.a=new L(z,se),this.d=new f(z,te,se)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,te){this.d.registerChannel(z,te)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=y;function N(V){return{call(z,te,se){return V.then(he=>he.call(z,te,se))},listen(z,te){const se=new A.$ve;return V.then(he=>se.input=he.listen(z,te)),se.event}}}function F(V){let z=!1;return{call(te,se,he){return z?V.call(te,se,he):(0,c.$Gh)(0).then(()=>z=!0).then(()=>V.call(te,se,he))},listen(te,se){if(z)return V.listen(te,se);const he=new A.$ve;return(0,c.$Gh)(0).then(()=>z=!0).then(()=>he.input=V.listen(te,se)),he.event}}}class D{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const te of z.connections)if(await Promise.resolve(this.a(te.ctx)))return Promise.resolve(te);return await A.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$ni=D;var M;(function(V){function z(q,Z,K){const H=q,U=K&&K.disableMarshalling,Y=new Map;for(const B in H)se(B)&&Y.set(B,A.Event.buffer(H[B],!0,void 0,Z));return new class{listen(B,j,_){const ee=Y.get(j);if(ee)return ee;const X=H[j];if(typeof X=="function"){if(he(j))return X.call(H,_);if(se(j))return Y.set(j,A.Event.buffer(H[j],!0,void 0,Z)),Y.get(j)}throw new k.$db(`Event not found: ${j}`)}call(B,j,_){const ee=H[j];if(typeof ee=="function"){if(!U&&Array.isArray(_))for(let oe=0;oe<_.length;oe++)_[oe]=(0,S.$ci)(_[oe]);let X=ee.apply(H,_);return X instanceof Promise||(X=Promise.resolve(X)),X}throw new k.$db(`Method not found: ${j}`)}}}V.fromService=z;function te(q,Z){const K=Z&&Z.disableMarshalling;return new Proxy({},{get(H,U){if(typeof U=="string")return Z?.properties?.has(U)?Z.properties.get(U):he(U)?function(Y){return q.listen(U,Y)}:se(U)?q.listen(U):async function(...Y){let B;Z&&!(0,u.$og)(Z.context)?B=[Z.context,...Y]:B=Y;const j=await q.call(U,B);return K?j:(0,S.$ci)(j)};throw new k.$db(`Property not found: ${String(U)}`)}})}V.toService=te;function se(q){return q[0]==="o"&&q[1]==="n"&&m.$Ff(q.charCodeAt(2))}function he(q){return/^onDynamic/.test(q)&&m.$Ff(q.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const z=V.toString();if(z!=="[object Object]")return z}return V}function x(V){return Array.isArray(V)?V.map(W):W(V)}function G(V,z,te,se,he,q,Z){Z=x(Z);const K=J[he],H=K[se%K.length];let U=[`%c[${V}]%c[${String(z).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(q)?(U=U.concat(Z),U.push(")")):U.push(Z),console.log.apply(console,U)}class ie{constructor(z,te){this.d=z,this.f=te,this.a=0,this.b=0}logOutgoing(z,te,se,he,q){this.b+=z,G(this.d,this.b,z,te,se,he,q)}logIncoming(z,te,se,he,q){this.a+=z,G(this.f,this.a,z,te,se,he,q)}}e.$oi=ie}),define(ce[71],le([0,1,15,3,2,43]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.ProtocolConstants=e.$pi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var k;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function h(R,L){if(!n.has(R)){const E=String(++o);n.set(R,E)}return n.get(R)}function f(R,L,E,y){if(!i.enableDiagnostics)return;const N=h(R,L);if(y instanceof P.$Oe||y instanceof Uint8Array||y instanceof ArrayBuffer||ArrayBuffer.isView(y)){const F=P.$Oe.alloc(y.byteLength);F.set(y),i.records.push({timestamp:Date.now(),id:N,label:L,type:E,buff:F})}else i.records.push({timestamp:Date.now(),id:N,label:L,type:E,data:y})}i.traceSocketEvent=f})(k||(e.SocketDiagnostics=k={}));var A;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(A||(e.SocketCloseEventType=A={}));let w=null;function S(){return w||(w=P.$Oe.alloc(0)),w}class m{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return S();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const L=this.a[0];return o&&(this.a.shift(),this.b-=n),L}if(this.a[0].byteLength>n){const L=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),L}const h=P.$Oe.alloc(n);let f=0,R=0;for(;n>0;){const L=this.a[R];if(L.byteLength>n){const E=L.slice(0,n);h.set(E,f),f+=n,o&&(this.a[R]=L.slice(n),this.b-=n),n-=n}else h.set(L,f),f+=L.byteLength,o?(this.a.shift(),this.b-=L.byteLength):R++,n-=L.byteLength}return h}}e.$pi=m;var u;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(u||(u={}));function $(i){switch(i){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var l;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class b{constructor(n,o,h,f){this.type=n,this.id=o,this.ack=h,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends C.$Wc{constructor(n){super(),this.f=this.B(new c.$me),this.onMessage=this.f.event,this.g={readHead:!0,readLen:l.HeaderLength,messageType:u.None,id:0,ack:0},this.a=n,this.b=!1,this.c=new m,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:$(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const h=this.g.messageType,f=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=l.HeaderLength,this.g.messageType=u.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,o),this.f.fire(new b(h,f,R,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=P.$Oe.alloc(l.HeaderLength);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:$(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,n.data),this.j(o,n.data)}g(n,o){const h=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,h}h(){const n=P.$Oe.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:n.byteLength}),this.c.write(n)}}class p extends C.$Wc{constructor(n){super(),this.f=new c.$me,this.onMessage=this.f.event,this.g=new c.$me,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new d(this.a)),this.c=this.B(new v(this.a)),this.B(this.c.onMessage(o=>{o.type===u.Regular&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new b(u.Regular,0,0,n))}}e.$qi=p;class I extends O.$ki{static fromSocket(n,o){return new I(new p(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,h=null){super(n,o,h),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$ri=I;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new c.$me({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$si=g;class s{constructor(n){this.data=n,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,h=this.a;for(;h;)n[o++]=h.data,h=h.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new s(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class t{static{this.a=10}static{this.b=null}static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<t.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=t.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+t.a)*1e3;let h=0;for(let f=0;f<t.a;f++)n-this.c[f]<=o&&h++;return 1-h/t.a}hasHighLoad(){return this.d()>=.5}}class a{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new g,this.onControlMessage=this.u.event,this.v=new g,this.onMessage=this.v.event,this.w=new g,this.onDidDispose=this.w.event,this.x=new g,this.onSocketClose=this.x.event,this.y=new g,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??t.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new C.$Vc,this.o=n.socket,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new v(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},l.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new b(u.Disconnect,0,0,S());this.p.write(n),this.p.flush()}sendPause(){const n=new b(u.Pause,0,0,S());this.p.write(n)}sendResume(){const n=new b(u.Resume,0,0,S());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new C.$Vc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new v(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new b(u.Ack,0,this.h,S());this.p.write(n);const o=this.b.toArray();for(let h=0,f=o.length;h<f;h++)this.p.write(o[h]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case u.None:break;case u.Regular:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new b(u.ReplayRequest,0,0,S())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case u.Control:{this.u.fire(n.data);break}case u.Ack:break;case u.Disconnect:{this.w.fire();break}case u.ReplayRequest:{const o=this.b.toArray();for(let h=0,f=o.length;h<f;h++)this.p.write(o[h]);this.B();break}case u.Pause:{this.p.pause();break}case u.Resume:{this.p.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const h=new b(u.Regular,o,this.h,n);this.b.push(h),this.a||(this.p.write(h),this.B())}sendControl(n){const o=new b(u.Control,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=l.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},l.AcknowledgeTime-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,h=Date.now()-this.q.lastReadTime,f=Date.now()-this.n;if(o>=l.TimeoutTime&&h>=l.TimeoutTime&&f>=l.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:h});return}const R=Math.max(l.TimeoutTime-o,l.TimeoutTime-h,l.TimeoutTime-f,500);this.f=setTimeout(()=>{this.f=null,this.B()},R)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new b(u.Ack,0,this.h,S());this.p.write(n)}D(){this.h=this.g;const n=new b(u.KeepAlive,0,this.h,S());this.p.write(n)}}e.$ti=a}),define(ce[96],le([0,1,70,6,15,26,148,8,3,2,30,155,93,43]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0,k=Oe(k);class l extends $.$hi{constructor(d){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:A.Event.fromNodeEventEmitter(process,"message",p=>C.$Oe.wrap(Buffer.from(p,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$er=l;class b{constructor(d,p){this.i=d,this.j=p,this.c=new Set,this.g=new Map,this.h=new A.$me,this.onDidProcessExit=this.h.event;const I=p&&p.timeout?p.timeout:6e4;this.b=new c.$Ch(I),this.d=null,this.f=null}getChannel(d){const p=this;return{call(I,g,s){return p.k(d,I,g,s)},listen(I,g){return p.l(d,I,g)}}}k(d,p,I,g=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(k.$8());this.b.cancel();const s=this.n(d),r=(0,c.$sh)(i=>s.call(p,I,i)),t=g.onCancellationRequested(()=>r.cancel()),a=(0,w.$Uc)(()=>r.cancel());return this.c.add(a),r.finally(()=>{t.dispose(),this.c.delete(a),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),r}l(d,p,I){if(!this.b)return A.Event.None;this.b.cancel();let g;const s=new A.$me({onWillAddFirstListener:()=>{g=this.n(d).listen(p,I)(s.fire,s),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,S.$do)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,u.$lm)(p.env),this.d=(0,P.fork)(this.i,d,p);const I=new A.$me,s=A.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,T.$ar)(o)){(0,T.log)(o,`IPC Library: ${this.j.serverName}`);return}I.fire(C.$Oe.wrap(Buffer.from(o,"base64")))}),r=this.j.useQueue?(0,m.$ym)(this.d):this.d,t=o=>this.d&&this.d.connected&&r.send(o.buffer.toString("base64")),a=I.event,i={send:t,onMessage:a};this.f=new $.$ii(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,h)=>{process.removeListener("exit",n),s.dispose(),this.c.forEach(f=>(0,w.$Rc)(f)),this.c.clear(),o!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:h})})}return this.f}n(d){let p=this.g.get(d);return p||(p=this.m.getChannel(d),this.g.set(d,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$fr=b}),define(ce[157],le([0,1,140,15,43,3,13,19]),function(ne,e,P,c,C,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SX=void 0,e.$TX=S;class A{constructor(u){this.a=u,this.onMessage=O.Event.fromNodeEventEmitter(this.a,"message",$=>$.data?c.$Oe.wrap($.data):c.$Oe.alloc(0)),u.start()}send(u){this.a.postMessage(u.buffer)}disconnect(){this.a.close()}}class w extends C.$ji{static b(u){(0,T.$pg)((0,P.$RX)(process),"Electron Utility Process");const $=new O.$me;return process.parentPort.on("message",l=>{if(u?.handledClientConnection(l))return;const b=(0,k.$Qb)(l.ports);b&&$.fire(b)}),O.Event.map($.event,l=>({protocol:new A(l),onDidClientDisconnect:O.Event.fromNodeEventEmitter(l,"close")}))}constructor(u){super(w.b(u))}}e.$SX=w;function S(m,u,$){const l=b=>{b.data===u&&(m.removeListener("message",l),$())};m.on("message",l)}}),define(ce[72],le([0,1,6,3,2,69,13]),function(ne,e,P,c,C,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.StorageState=e.StorageHint=void 0,e.$aq=A;var k;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(e.StorageHint=k={}));function A(u){const $=u;return $?.changed instanceof Map||$?.deleted instanceof Set}var w;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(w||(e.StorageState=w={}));class S extends C.$Wc{static{this.a=100}constructor($,l=Object.create(null)){super(),this.r=$,this.s=l,this.b=this.B(new c.$pe),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=this.B(new P.$Dh(S.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((l,b)=>this.w(b,l)),$.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w($,l){if(this.c===w.Closed)return;let b=!1;(0,T.$og)(l)?b=this.f.delete($):this.f.get($)!==l&&(this.f.set($,l),b=!0),b&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,l){const b=this.f.get($);return(0,T.$og)(b)?l:b}getBoolean($,l){const b=this.get($);return(0,T.$og)(b)?l:b==="true"}getNumber($,l){const b=this.get($);return(0,T.$og)(b)?l:parseInt(b,10)}getObject($,l){const b=this.get($);return(0,T.$og)(b)?l:(0,O.$bi)(b)}async set($,l,b=!1){if(this.c===w.Closed)return;if((0,T.$og)(l))return this.delete($,b);const v=(0,T.$hg)(l)||Array.isArray(l)?(0,O.$ai)(l):String(l);if(this.f.get($)!==v)return this.f.set($,v),this.j.set($,v),this.h.delete($),this.b.fire({key:$,external:b}),this.D()}async delete($,l=!1){if(!(this.c===w.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:l}),this.D()}async optimize(){if(this.c!==w.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=w.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(!(this.c===w.Closed||this.m))return this.D($)}async D($){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}e.$bq=S;class m{constructor(){this.onDidChangeItemsExternal=c.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((l,b)=>this.a.set(b,l)),$.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$cq=m}),define(ce[158],le([12,11]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(ce[73],le([0,1,46,6,14,13,31,158]),function(ne,e,P,c,C,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=void 0,e.zip=v,e.$Aq=d,e.$Bq=I,C=Oe(C),k=Oe(k),e.$xq="end of central directory record signature not found";const A=new RegExp(e.$xq);class w extends Error{constructor(s,r){let t=r.message;switch(s){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=s,this.cause=r}}e.$yq=w;function S(g){const s=g.externalFileAttributes>>16||33188;return[448,56,7].map(r=>s&r).reduce((r,t)=>r+t,s&61440)}function m(g){if(g instanceof w)return g;let s;return A.test(g.message)&&(s="CorruptZip"),new w(s,g)}function u(g,s,r,t,a,i){const n=C.$oc(s),o=C.$lc(t,n);if(!o.startsWith(t))return Promise.reject(new Error(k.localize(0,null,s)));const h=C.$lc(t,s);let f;return i.onCancellationRequested(()=>{f?.destroy()}),Promise.resolve(T.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((R,L)=>{if(!i.isCancellationRequested)try{f=(0,P.createWriteStream)(h,{mode:r}),f.once("close",()=>R()),f.once("error",L),g.once("error",L),g.pipe(f)}catch(E){L(E)}}))}function $(g,s,r,t){let a=(0,c.$sh)(()=>Promise.resolve()),i=0;const n=t.onCancellationRequested(()=>{a.cancel(),g.close()});return new Promise((o,h)=>{const f=new c.$Ah,R=L=>{L.isCancellationRequested||(i++,g.readEntry())};g.once("error",h),g.once("close",()=>a.then(()=>{t.isCancellationRequested||g.entryCount===i?o():h(new w("Incomplete",new Error(k.localize(1,null,i,g.entryCount))))},h)),g.readEntry(),g.on("entry",L=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(L.fileName)){R(t);return}const E=L.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(E)){const F=C.$lc(s,E);a=(0,c.$sh)(D=>T.Promises.mkdir(F,{recursive:!0}).then(()=>R(D)).then(void 0,h));return}const y=b(g,L),N=S(L);a=(0,c.$sh)(F=>f.queue(()=>y.then(D=>u(D,E,N,s,r,F).then(()=>R(F)))).then(null,h))})}).finally(()=>n.dispose())}async function l(g,s=!1){const{open:r}=await new Promise((t,a)=>{ne(["yauzl"],t,a)}).then(Oe);return new Promise((t,a)=>{r(g,s?{lazyEntries:!0}:void 0,(i,n)=>{i?a(m(i)):t((0,O.$qg)(n))})})}function b(g,s){return new Promise((r,t)=>{g.openReadStream(s,(a,i)=>{a?t(m(a)):r((0,O.$qg)(i))})})}async function v(g,s){const{ZipFile:r}=await new Promise((t,a)=>{ne(["yazl"],t,a)}).then(Oe);return new Promise((t,a)=>{const i=new r;s.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const n=(0,P.createWriteStream)(g);i.outputStream.pipe(n),i.outputStream.once("error",a),n.once("error",a),n.once("finish",()=>t(g))})}function d(g,s,r={},t){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let i=l(g,!0);return r.overwrite&&(i=i.then(n=>T.Promises.rm(s).then(()=>n))),i.then(n=>$(n,s,{sourcePathRegex:a},t))}function p(g,s){return l(g).then(r=>new Promise((t,a)=>{r.on("entry",i=>{i.fileName===s&&b(r,i).then(n=>t(n),n=>a(n))}),r.once("close",()=>a(new Error(k.localize(2,null,s))))}))}function I(g,s){return p(g,s).then(r=>new Promise((t,a)=>{const i=[];r.once("error",a),r.on("data",n=>i.push(n)),r.on("end",()=>t(Buffer.concat(i)))}))}}),define(ce[159],le([12,11]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ce[160],le([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(ce[161],le([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(ce[162],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ce[163],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ce[164],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ce[165],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ce[166],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ce[167],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ce[168],le([12,11]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ce[169],le([12,11]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(ce[170],le([12,11]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ce[171],le([12,11]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(ce[172],le([12,11]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ce[173],le([12,11]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ce[174],le([12,11]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(ce[175],le([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ce[176],le([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ce[177],le([12,11]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(ce[178],le([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ce[179],le([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(ce[180],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ce[181],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ce[182],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ce[183],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ce[184],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ce[185],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ce[186],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ce[187],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ce[188],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ce[189],le([12,11]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ce[190],le([0,1,39,8,161]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var O;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(O||(e.TokenType=O={}));function T(...S){switch(S.length){case 1:return(0,C.localize)(0,null,S[0]);case 2:return(0,C.localize)(1,null,S[0],S[1]);case 3:return(0,C.localize)(2,null,S[0],S[1],S[2]);default:return}}const k=(0,C.localize)(3,null),A=(0,C.localize)(4,null);class w{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(m){switch(m.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return m.isTripleEq?"===":"==";case O.NotEq:return m.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return m.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return m.lexeme;case O.QuotedStr:return m.lexeme;case O.Error:return m.lexeme;case O.EOF:return"EOF";default:throw(0,c.$0)(`unhandled token type: ${JSON.stringify(m)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(m){return this.c=m,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case P.CharCode.OpenParen:this.k(O.LParen);break;case P.CharCode.CloseParen:this.k(O.RParen);break;case P.CharCode.ExclamationMark:if(this.h(P.CharCode.Equals)){const u=this.h(P.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:u})}else this.k(O.Neg);break;case P.CharCode.SingleQuote:this.o();break;case P.CharCode.Slash:this.q();break;case P.CharCode.Equals:if(this.h(P.CharCode.Equals)){const u=this.h(P.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:u})}else this.h(P.CharCode.Tilde)?this.k(O.RegexOp):this.l(T("==","=~"));break;case P.CharCode.LessThan:this.k(this.h(P.CharCode.Equals)?O.LtEq:O.Lt);break;case P.CharCode.GreaterThan:this.k(this.h(P.CharCode.Equals)?O.GtEq:O.Gt);break;case P.CharCode.Ampersand:this.h(P.CharCode.Ampersand)?this.k(O.And):this.l(T("&&"));break;case P.CharCode.Pipe:this.h(P.CharCode.Pipe)?this.k(O.Or):this.l(T("||"));break;case P.CharCode.Space:case P.CharCode.CarriageReturn:case P.CharCode.Tab:case P.CharCode.LineFeed:case P.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(m){return this.r()||this.c.charCodeAt(this.e)!==m?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?P.CharCode.Null:this.c.charCodeAt(this.e)}k(m){this.f.push({type:m,offset:this.d})}l(m){const u=this.d,$=this.c.substring(this.d,this.e),l={type:O.Error,offset:this.d,lexeme:$};this.g.push({offset:u,lexeme:$,additionalInfo:m}),this.f.push(l)}n(){this.m.lastIndex=this.d;const m=this.m.exec(this.c);if(m){this.e=this.d+m[0].length;const u=this.c.substring(this.d,this.e),$=w.b.get(u);$?this.k($):this.f.push({type:O.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==P.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(k);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let m=this.e,u=!1,$=!1;for(;;){if(m>=this.c.length){this.e=m,this.l(A);return}const b=this.c.charCodeAt(m);if(u)u=!1;else if(b===P.CharCode.Slash&&!$){m++;break}else b===P.CharCode.OpenSquareBracket?$=!0:b===P.CharCode.Backslash?u=!0:b===P.CharCode.CloseSquareBracket&&($=!1);m++}for(;m<this.c.length&&w.a.has(this.c.charCodeAt(m));)m++;this.e=m;const l=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=w}),define(ce[191],le([0,1,68,88,23,14,37,21,9]),function(ne,e,P,c,C,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$6m=S,e.$7m=m,e.$4m=/^([^.]+\..+)[:=](.+)$/;class w{get appRoot(){return(0,O.$oc)(C.$Zg.asFileUri("").fsPath)}get userHome(){return A.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return A.URI.file((0,O.$lc)(this.userDataPath,"User"))}get tmpDir(){return A.URI.file(this.b.tmpDir)}get cacheHome(){return A.URI.file(this.userDataPath)}get stateResource(){return(0,k.$gh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:C.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$gh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,P.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.$lc)(this.userDataPath,"logs",$)}return A.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$gh)(A.URI.file((0,O.$lc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$gh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$gh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$gh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=T.env.VSCODE_PORTABLE;return $?A.URI.file((0,O.$lc)($,"argv.json")):(0,k.$gh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return A.URI.file((0,O.$lc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,O.$mc)($):(0,O.$jc)((0,O.$lc)(C.$Zg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?A.URI.file((0,O.$mc)($)):A.URI.file((0,O.$lc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,O.$mc)($);const l=T.env.VSCODE_EXTENSIONS;if(l)return l;const b=T.env.VSCODE_PORTABLE;return b?(0,O.$lc)(b,"extensions"):(0,k.$gh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(l=>/^[^:/?#]+?:\/\//.test(l)?A.URI.parse(l):A.URI.file((0,O.$jc)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?A.URI.parse($):A.URI.file((0,O.$jc)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$4m.test($))}get extensionLogLevel(){const $=[];for(const l of this.args.log||[]){const b=e.$4m.exec(l);b&&b[1]&&b[2]&&$.push([b[1],b[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,k.$gh)(A.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=T.env.VSCODE_PORTABLE;return $?A.URI.file((0,O.$lc)($,"policy.json")):(0,k.$gh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,l,b){this.a=$,this.b=l,this.c=b,this.editSessionId=this.args.editSessionId}}e.$5m=w,ve([c.$0h],w.prototype,"appRoot",null),ve([c.$0h],w.prototype,"userHome",null),ve([c.$0h],w.prototype,"userDataPath",null),ve([c.$0h],w.prototype,"appSettingsHome",null),ve([c.$0h],w.prototype,"tmpDir",null),ve([c.$0h],w.prototype,"cacheHome",null),ve([c.$0h],w.prototype,"stateResource",null),ve([c.$0h],w.prototype,"userRoamingDataHome",null),ve([c.$0h],w.prototype,"userDataSyncHome",null),ve([c.$0h],w.prototype,"sync",null),ve([c.$0h],w.prototype,"machineSettingsResource",null),ve([c.$0h],w.prototype,"workspaceStorageHome",null),ve([c.$0h],w.prototype,"localHistoryHome",null),ve([c.$0h],w.prototype,"keyboardLayoutResource",null),ve([c.$0h],w.prototype,"argvResource",null),ve([c.$0h],w.prototype,"isExtensionDevelopment",null),ve([c.$0h],w.prototype,"untitledWorkspacesHome",null),ve([c.$0h],w.prototype,"builtinExtensionsPath",null),ve([c.$0h],w.prototype,"extensionsPath",null),ve([c.$0h],w.prototype,"extensionDevelopmentLocationURI",null),ve([c.$0h],w.prototype,"extensionDevelopmentKind",null),ve([c.$0h],w.prototype,"extensionTestsLocationURI",null),ve([c.$0h],w.prototype,"debugExtensionHost",null),ve([c.$0h],w.prototype,"logLevel",null),ve([c.$0h],w.prototype,"extensionLogLevel",null),ve([c.$0h],w.prototype,"serviceMachineIdResource",null),ve([c.$0h],w.prototype,"disableTelemetry",null),ve([c.$0h],w.prototype,"disableWorkspaceTrust",null),ve([c.$0h],w.prototype,"useInMemorySecretStorage",null),ve([c.$0h],w.prototype,"policyFile",null);function S(u,$){return m(u["inspect-extensions"],u["inspect-brk-extensions"],5870,$,u.debugId,u.extensionEnvironment)}function m(u,$,l,b,v,d){const I=Number($||u)||(b?null:l),g=I?!!$:!1;let s;if(d)try{s=JSON.parse(d)}catch{}return{port:I,break:g,debugId:v,env:s}}}),function(){"use strict";function ne(e,P,c){function C(T,k){const A=O(T,k),w=[A];return e.isAbsolute(A)||w.unshift(c),e.resolve(...w)}function O(T,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const A=process.env.VSCODE_PORTABLE;if(A)return e.join(A,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,k);const S=T["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(m,"AppData","Roaming")}break;case"darwin":w=e.join(P.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,k)}return{getUserDataPath:C}}if(typeof define=="function")define(ce[192],le([280,38,37]),function(e,P,c){return ne(e,P,c.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=ne(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[193],le([0,1,38,191,192]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$9m=T,e.$0m=k;class O extends c.$5m{constructor(w,S){super(w,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,C.getUserDataPath)(w,S.nameShort)},S)}}e.$8m=O;function T(A,w){return(0,c.$7m)(A["inspect-ptyhost"],A["inspect-brk-ptyhost"],5877,w,A.extensionEnvironment)}function k(A,w){return(0,c.$7m)(A["inspect-sharedprocess"],A["inspect-brk-sharedprocess"],5879,w,A.extensionEnvironment)}}),define(ce[194],le([0,1,13,164]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=C;function C(T,k,A,w){try{O(T,k,A,w)}catch(S){T.error(S?.message??S)}return k}function O(T,k,A,w){const S=(m,u,$)=>{const l=m[u];if((0,P.$fg)(l)){const b=l,v=b.length;if(v>1&&b[0]==="%"&&b[v-1]==="%"){const d=b.substr(1,v-2);let p=A[d];p===void 0&&w&&(p=w[d]);const I=typeof p=="string"?p:p?.message,g=w?.[d],s=typeof g=="string"?g:g?.message;if(!I){s||T.warn(`[${k.name}]: ${(0,c.localize)(0,null,d)}`);return}if($&&(u==="title"||u==="category")&&s&&s!==I){const r={value:I,original:s};m[u]=r}else m[u]=I}}else if((0,P.$hg)(l))for(const b in l)l.hasOwnProperty(b)&&(b==="commands"?S(l,b,!0):S(l,b,$));else if(Array.isArray(l))for(let b=0;b<l.length;b++)S(l,b,$)};for(const m in k)k.hasOwnProperty(m)&&S(k,m)}}),define(ce[195],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.$Ehc=void 0;class P{constructor(O){this.a=O}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(O){return this.a.call("promptImportantExtensionsInstallNotification",[O])}promptWorkspaceRecommendations(O){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Ehc=P;class c{constructor(O){this.a=O}listen(O,T){throw new Error(`Event not found: ${T}`)}call(O,T,k){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(k[0])}throw new Error(`Call not found: ${T}`)}}e.$Fhc=c}),define(ce[196],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const P={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(P)}),define(ce[74],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class P{constructor(C,O=[],T=!1){this.ctor=C,this.staticArguments=O,this.supportsDelayedInstantiation=T}}e.$Ci=P}),define(ce[197],le([0,1,74]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Os=O,e.$Ps=T;const c=[];var C;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function O(k,A,w){A instanceof P.$Ci||(A=new P.$Ci(A,[],!!w)),c.push([k,A])}function T(){return c}}),define(ce[198],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0;class P{constructor(O,T){this.key=O,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$rr=P;class c{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const T of this.a.values())T.outgoing.size===0&&O.push(T);return O}insertEdge(O,T){const k=this.lookupOrInsertNode(O),A=this.lookupOrInsertNode(T);k.outgoing.set(A.key,A),A.incoming.set(k.key,k)}removeNode(O){const T=this.b(O);this.a.delete(T);for(const k of this.a.values())k.outgoing.delete(T),k.incoming.delete(T)}lookupOrInsertNode(O){const T=this.b(O);let k=this.a.get(T);return k||(k=new P(T,O),this.a.set(T,k)),k}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[T,k]of this.a)O.push(`${T}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,T]of this.a){const k=new Set([O]),A=this.c(T,k);if(A)return A}}c(O,T){for(const[k,A]of O.outgoing){if(T.has(k))return[...T,k].join(" -> ");T.add(k);const w=this.c(A,T);if(w)return w;T.delete(k)}}}e.$sr=c}),define(ce[4],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=C,e.$Gi=O;var P;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function k(A){return A[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=k})(P||(e._util=P={})),e.$Ei=C("instantiationService");function c(T,k,A){k[P.DI_TARGET]===k?k[P.DI_DEPENDENCIES].push({id:T,index:A}):(k[P.DI_DEPENDENCIES]=[{id:T,index:A}],k[P.DI_TARGET]=k)}function C(T){if(P.serviceIds.has(T))return P.serviceIds.get(T);const k=function(A,w,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");c(k,A,S)};return k.toString=()=>T,P.serviceIds.set(T,k),k}function O(T){return T}}),define(ce[199],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0,e.$ehc=(0,P.$Fi)("checksumService")}),define(ce[22],le([0,1,13,9,4]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=O,e.$bj=T,e.$cj=A,e.$dj=w,e.$ej=S,e.$fj=m,e.$gj=u,e.$hj=l,e.$ij=b,e.$jj=v,P=Oe(P),e.$_i=(0,C.$Fi)("configurationService");function O(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof c.URI)}function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof c.URI)}var k;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function A(d){switch(d){case k.APPLICATION:return"APPLICATION";case k.USER:return"USER";case k.USER_LOCAL:return"USER_LOCAL";case k.USER_REMOTE:return"USER_REMOTE";case k.WORKSPACE:return"WORKSPACE";case k.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case k.DEFAULT:return"DEFAULT";case k.MEMORY:return"MEMORY"}}function w(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function S(d,p){const I=Object.create(null);for(const g in d)m(I,g,d[g],p);return I}function m(d,p,I,g){const s=p.split("."),r=s.pop();let t=d;for(let a=0;a<s.length;a++){const i=s[a];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":if(n===null){g(`Ignoring ${p} as ${s.slice(0,a+1).join(".")} is null`);return}break;default:g(`Ignoring ${p} as ${s.slice(0,a+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[r]=I}catch{g(`Ignoring ${p} as ${s.join(".")} is ${JSON.stringify(t)}`)}else g(`Ignoring ${p} as ${s.join(".")} is ${JSON.stringify(t)}`)}function u(d,p){const I=p.split(".");$(d,I)}function $(d,p){const I=p.shift();if(p.length===0){delete d[I];return}if(Object.keys(d).indexOf(I)!==-1){const g=d[I];typeof g=="object"&&!Array.isArray(g)&&($(g,p),Object.keys(g).length===0&&delete d[I])}}function l(d,p,I){function g(t,a){let i=t;for(const n of a){if(typeof i!="object"||i===null)return;i=i[n]}return i}const s=p.split("."),r=g(d,s);return typeof r>"u"?I:r}function b(d,p,I){Object.keys(p).forEach(g=>{g!=="__proto__"&&(g in d?P.$hg(d[g])&&P.$hg(p[g])?b(d[g],p[g],I):I&&(d[g]=p[g]):d[g]=p[g])})}function v(d){return d.replace(/[\[\]]/g,"")}}),define(ce[97],le([0,1,39,5,27,190,4,160,8]),function(ne,e,P,c,C,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=S,e.$Ej=a,e.$Fj=i,e.$Yj=q;const w=new Map;w.set("false",!1),w.set("true",!0),w.set("isMac",c.$j),w.set("isLinux",c.$k),w.set("isWindows",c.$i),w.set("isWeb",c.$o),w.set("isMacNative",c.$j&&!c.$o),w.set("isEdge",c.$H),w.set("isFirefox",c.$F),w.set("isChrome",c.$E),w.set("isSafari",c.$G);function S(H,U){if(w.get(H)!==void 0)throw(0,A.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");w.set(H,U)}const m=Object.prototype.hasOwnProperty;var u;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const $={regexParsingWithErrorRecovery:!0},l=(0,k.localize)(0,null),b=(0,k.localize)(1,null),v=(0,k.localize)(2,null),d=(0,k.localize)(3,null),p=(0,k.localize)(4,null),I=(0,k.localize)(5,null),g=(0,k.localize)(6,null),s=(0,k.localize)(7,null);class r{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=$){this.k=U,this.d=new O.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const Y=this.l();if(!this.E()){const B=this.D(),j=B.type===O.TokenType.Str?I:void 0;throw this.h.push({message:p,offset:B.offset,lexeme:O.$Aj.getLexeme(B),additionalInfo:j}),r.c}return Y}catch(Y){if(Y!==r.c)throw Y;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(O.TokenType.Or);){const Y=this.o();U.push(Y)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(O.TokenType.And);){const Y=this.s();U.push(Y)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(O.TokenType.Neg)){const U=this.D();switch(U.type){case O.TokenType.True:return this.z(),o.INSTANCE;case O.TokenType.False:return this.z(),h.INSTANCE;case O.TokenType.LParen:{this.z();const Y=this.l();return this.A(O.TokenType.RParen,d),Y?.negate()}case O.TokenType.Str:return this.z(),N.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case O.TokenType.True:return this.z(),t.true();case O.TokenType.False:return this.z(),t.false();case O.TokenType.LParen:{this.z();const Y=this.l();return this.A(O.TokenType.RParen,d),Y}case O.TokenType.Str:{const Y=U.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const j=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),j.type!==O.TokenType.RegexStr)throw this.B("REGEX",j);const _=j.lexeme,ee=_.lastIndexOf("/"),X=ee===_.length-1?void 0:this.w(_.substring(ee+1));let oe;try{oe=new RegExp(_.substring(1,ee),X)}catch{throw this.B("REGEX",j)}return x.create(Y,oe)}switch(j.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const _=[j.lexeme];this.z();let ee=this.D(),X=0;for(let Ie=0;Ie<j.lexeme.length;Ie++)j.lexeme.charCodeAt(Ie)===P.CharCode.OpenParen?X++:j.lexeme.charCodeAt(Ie)===P.CharCode.CloseParen&&X--;for(;!this.E()&&ee.type!==O.TokenType.And&&ee.type!==O.TokenType.Or;){switch(ee.type){case O.TokenType.LParen:X++;break;case O.TokenType.RParen:X--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let Ie=0;Ie<ee.lexeme.length;Ie++)ee.lexeme.charCodeAt(Ie)===P.CharCode.OpenParen?X++:j.lexeme.charCodeAt(Ie)===P.CharCode.CloseParen&&X--}if(X<0)break;_.push(O.$Aj.getLexeme(ee)),this.z(),ee=this.D()}const oe=_.join(""),ue=oe.lastIndexOf("/"),ge=ue===oe.length-1?void 0:this.w(oe.substring(ue+1));let be;try{be=new RegExp(oe.substring(1,ue),ge)}catch{throw this.B("REGEX",j)}return t.regex(Y,be)}case O.TokenType.QuotedStr:{const _=j.lexeme;this.z();let ee=null;if(!(0,C.$df)(_)){const X=_.indexOf("/"),oe=_.lastIndexOf("/");if(X!==oe&&X>=0){const ue=_.slice(X+1,oe),ge=_[oe+1]==="i"?"i":"";try{ee=new RegExp(ue,ge)}catch{throw this.B("REGEX",j)}}}if(ee===null)throw this.B("REGEX",j);return x.create(Y,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,v);const j=this.u();return t.notIn(Y,j)}switch(this.D().type){case O.TokenType.Eq:{this.z();const j=this.u();if(this.x().type===O.TokenType.QuotedStr)return t.equals(Y,j);switch(j){case"true":return t.has(Y);case"false":return t.not(Y);default:return t.equals(Y,j)}}case O.TokenType.NotEq:{this.z();const j=this.u();if(this.x().type===O.TokenType.QuotedStr)return t.notEquals(Y,j);switch(j){case"true":return t.not(Y);case"false":return t.has(Y);default:return t.notEquals(Y,j)}}case O.TokenType.Lt:return this.z(),J.create(Y,this.u());case O.TokenType.LtEq:return this.z(),W.create(Y,this.u());case O.TokenType.Gt:return this.z(),D.create(Y,this.u());case O.TokenType.GtEq:return this.z(),M.create(Y,this.u());case O.TokenType.In:return this.z(),t.in(Y,this.u());default:return t.has(Y)}}case O.TokenType.EOF:throw this.h.push({message:g,offset:U.offset,lexeme:"",additionalInfo:s}),r.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),U.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,Y){if(this.C(U))return this.z();throw this.B(Y,this.D())}B(U,Y,B){const j=(0,k.localize)(8,null,U,O.$Aj.getLexeme(Y)),_=Y.offset,ee=O.$Aj.getLexeme(Y);return this.h.push({message:j,offset:_,lexeme:ee,additionalInfo:B}),r.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$Cj=r;class t{static false(){return o.INSTANCE}static true(){return h.INSTANCE}static has(U){return f.create(U)}static equals(U,Y){return R.create(U,Y)}static notEquals(U,Y){return y.create(U,Y)}static regex(U,Y){return x.create(U,Y)}static in(U,Y){return L.create(U,Y)}static notIn(U,Y){return E.create(U,Y)}static not(U){return N.create(U)}static and(...U){return V.create(U,null,!0)}static or(...U){return z.create(U,null,!0)}static greater(U,Y){return D.create(U,Y)}static greaterEquals(U,Y){return M.create(U,Y)}static smaller(U,Y){return J.create(U,Y)}static smallerEquals(U,Y){return W.create(U,Y)}static{this.c=new r({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Dj=t;function a(H){const U=new r({regexParsingWithErrorRecovery:!1});return H.map(Y=>(U.parse(Y),U.lexingErrors.length>0?U.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,k.localize)(9,null,B.additionalInfo):(0,k.localize)(10,null),offset:B.offset,length:B.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}function i(H,U){const Y=H?H.substituteConstants():void 0,B=U?U.substituteConstants():void 0;return!Y&&!B?!0:!Y||!B?!1:Y.equals(B)}function n(H,U){return H.cmp(U)}class o{static{this.INSTANCE=new o}constructor(){this.type=u.False}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$Gj=o;class h{static{this.INSTANCE=new h}constructor(){this.type=u.True}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return o.INSTANCE}}e.$Hj=h;class f{static create(U,Y=null){const B=w.get(U);return typeof B=="boolean"?B?h.INSTANCE:o.INSTANCE:new f(U,Y)}constructor(U,Y){this.key=U,this.c=Y,this.type=u.Defined}cmp(U){return U.type!==this.type?this.type-U.type:se(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=w.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:o.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$Ij=f;class R{static create(U,Y,B=null){if(typeof Y=="boolean")return Y?f.create(U,B):N.create(U,B);const j=w.get(U);return typeof j=="boolean"?Y===(j?"true":"false")?h.INSTANCE:o.INSTANCE:new R(U,Y,B)}constructor(U,Y,B){this.c=U,this.d=Y,this.f=B,this.type=u.Equals}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=w.get(this.c);if(typeof U=="boolean"){const Y=U?"true":"false";return this.d===Y?h.INSTANCE:o.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Jj=R;class L{static create(U,Y){return new L(U,Y)}constructor(U,Y){this.d=U,this.f=Y,this.type=u.In,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:he(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const Y=U.getValue(this.f),B=U.getValue(this.d);return Array.isArray(Y)?Y.includes(B):typeof B=="string"&&typeof Y=="object"&&Y!==null?m.call(Y,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Kj=L;class E{static create(U,Y){return new E(U,Y)}constructor(U,Y){this.d=U,this.f=Y,this.type=u.NotIn,this.c=L.create(U,Y)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=E;class y{static create(U,Y,B=null){if(typeof Y=="boolean")return Y?N.create(U,B):f.create(U,B);const j=w.get(U);return typeof j=="boolean"?Y===(j?"true":"false")?o.INSTANCE:h.INSTANCE:new y(U,Y,B)}constructor(U,Y,B){this.c=U,this.d=Y,this.f=B,this.type=u.NotEquals}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=w.get(this.c);if(typeof U=="boolean"){const Y=U?"true":"false";return this.d===Y?o.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Mj=y;class N{static create(U,Y=null){const B=w.get(U);return typeof B=="boolean"?B?o.INSTANCE:h.INSTANCE:new N(U,Y)}constructor(U,Y){this.c=U,this.d=Y,this.type=u.Not}cmp(U){return U.type!==this.type?this.type-U.type:se(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=w.get(this.c);return typeof U=="boolean"?U?o.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$Nj=N;function F(H,U){if(typeof H=="string"){const Y=parseFloat(H);isNaN(Y)||(H=Y)}return typeof H=="string"||typeof H=="number"?U(H):o.INSTANCE}class D{static create(U,Y,B=null){return F(Y,j=>new D(U,j,B))}constructor(U,Y,B){this.c=U,this.d=Y,this.f=B,this.type=u.Greater}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Oj=D;class M{static create(U,Y,B=null){return F(Y,j=>new M(U,j,B))}constructor(U,Y,B){this.c=U,this.d=Y,this.f=B,this.type=u.GreaterEquals}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Pj=M;class J{static create(U,Y,B=null){return F(Y,j=>new J(U,j,B))}constructor(U,Y,B){this.c=U,this.d=Y,this.f=B,this.type=u.Smaller}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Qj=J;class W{static create(U,Y,B=null){return F(Y,j=>new W(U,j,B))}constructor(U,Y,B){this.c=U,this.d=Y,this.f=B,this.type=u.SmallerEquals}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Rj=W;class x{static create(U,Y){return new x(U,Y)}constructor(U,Y){this.d=U,this.f=Y,this.type=u.Regex,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const Y=this.f?this.f.source:"",B=U.f?U.f.source:"";return Y<B?-1:Y>B?1:0}equals(U){if(U.type===this.type){const Y=this.f?this.f.source:"",B=U.f?U.f.source:"";return this.d===U.d&&Y===B}return!1}substituteConstants(){return this}evaluate(U){const Y=U.getValue(this.d);return this.f?this.f.test(Y):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=G.create(this)),this.c}}e.$Sj=x;class G{static create(U){return new G(U)}constructor(U){this.c=U,this.type=u.NotRegex}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new G(this.c.map(U))}negate(){return this.c}}e.$Tj=G;function ie(H){let U=null;for(let Y=0,B=H.length;Y<B;Y++){const j=H[Y].substituteConstants();if(H[Y]!==j&&U===null){U=[];for(let _=0;_<Y;_++)U[_]=H[_]}U!==null&&(U[Y]=j)}return U===null?H:U}class V{static create(U,Y,B){return V.d(U,Y,B)}constructor(U,Y){this.expr=U,this.c=Y,this.type=u.And}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let Y=0,B=this.expr.length;Y<B;Y++){const j=n(this.expr[Y],U.expr[Y]);if(j!==0)return j}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let Y=0,B=this.expr.length;Y<B;Y++)if(!this.expr[Y].equals(U.expr[Y]))return!1;return!0}return!1}substituteConstants(){const U=ie(this.expr);return U===this.expr?this:V.create(U,this.c,!1)}evaluate(U){for(let Y=0,B=this.expr.length;Y<B;Y++)if(!this.expr[Y].evaluate(U))return!1;return!0}static d(U,Y,B){const j=[];let _=!1;for(const ee of U)if(ee){if(ee.type===u.True){_=!0;continue}if(ee.type===u.False)return o.INSTANCE;if(ee.type===u.And){j.push(...ee.expr);continue}j.push(ee)}if(j.length===0&&_)return h.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(n);for(let ee=1;ee<j.length;ee++)j[ee-1].equals(j[ee])&&(j.splice(ee,1),ee--);if(j.length===1)return j[0];for(;j.length>1;){const ee=j[j.length-1];if(ee.type!==u.Or)break;j.pop();const X=j.pop(),oe=j.length===0,ue=z.create(ee.expr.map(ge=>V.create([ge,X],null,B)),null,oe);ue&&(j.push(ue),j.sort(n))}if(j.length===1)return j[0];if(B){for(let ee=0;ee<j.length;ee++)for(let X=ee+1;X<j.length;X++)if(j[ee].negate().equals(j[X]))return o.INSTANCE;if(j.length===1)return j[0]}return new V(j,Y)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const Y of this.expr)U.push(...Y.keys());return U}map(U){return new V(this.expr.map(Y=>Y.map(U)),null)}negate(){if(!this.c){const U=[];for(const Y of this.expr)U.push(Y.negate());this.c=z.create(U,this,!0)}return this.c}}e.$Uj=V;class z{static create(U,Y,B){return z.d(U,Y,B)}constructor(U,Y){this.expr=U,this.c=Y,this.type=u.Or}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let Y=0,B=this.expr.length;Y<B;Y++){const j=n(this.expr[Y],U.expr[Y]);if(j!==0)return j}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let Y=0,B=this.expr.length;Y<B;Y++)if(!this.expr[Y].equals(U.expr[Y]))return!1;return!0}return!1}substituteConstants(){const U=ie(this.expr);return U===this.expr?this:z.create(U,this.c,!1)}evaluate(U){for(let Y=0,B=this.expr.length;Y<B;Y++)if(this.expr[Y].evaluate(U))return!0;return!1}static d(U,Y,B){let j=[],_=!1;if(U){for(let ee=0,X=U.length;ee<X;ee++){const oe=U[ee];if(oe){if(oe.type===u.False){_=!0;continue}if(oe.type===u.True)return h.INSTANCE;if(oe.type===u.Or){j=j.concat(oe.expr);continue}j.push(oe)}}if(j.length===0&&_)return o.INSTANCE;j.sort(n)}if(j.length!==0){if(j.length===1)return j[0];for(let ee=1;ee<j.length;ee++)j[ee-1].equals(j[ee])&&(j.splice(ee,1),ee--);if(j.length===1)return j[0];if(B){for(let ee=0;ee<j.length;ee++)for(let X=ee+1;X<j.length;X++)if(j[ee].negate().equals(j[X]))return h.INSTANCE;if(j.length===1)return j[0]}return new z(j,Y)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const Y of this.expr)U.push(...Y.keys());return U}map(U){return new z(this.expr.map(Y=>Y.map(U)),null)}negate(){if(!this.c){const U=[];for(const Y of this.expr)U.push(Y.negate());for(;U.length>1;){const Y=U.shift(),B=U.shift(),j=[];for(const _ of K(Y))for(const ee of K(B))j.push(V.create([_,ee],null,!1));U.unshift(z.create(j,null,!1))}this.c=z.create(U,this,!0)}return this.c}}e.$Vj=z;class te extends f{static{this.d=[]}static all(){return te.d.values()}constructor(U,Y,B){super(U,null),this.f=Y,typeof B=="object"?te.d.push({...B,key:U}):B!==!0&&te.d.push({key:U,description:B,type:Y!=null?typeof Y:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return R.create(this.key,U)}notEqualsTo(U){return y.create(this.key,U)}}e.$Wj=te,e.$Xj=(0,T.$Fi)("contextKeyService");function se(H,U){return H<U?-1:H>U?1:0}function he(H,U,Y,B){return H<Y?-1:H>Y?1:U<B?-1:U>B?1:0}function q(H,U){if(H.type===u.False||U.type===u.True)return!0;if(H.type===u.Or)return U.type===u.Or?Z(H.expr,U.expr):!1;if(U.type===u.Or){for(const Y of U.expr)if(q(H,Y))return!0;return!1}if(H.type===u.And){if(U.type===u.And)return Z(U.expr,H.expr);for(const Y of H.expr)if(q(Y,U))return!0;return!1}return H.equals(U)}function Z(H,U){let Y=0,B=0;for(;Y<H.length&&B<U.length;){const j=H[Y].cmp(U[B]);if(j<0)return!1;j===0&&Y++,B++}return Y===H.length}function K(H){return H.type===u.Or?H.expr:[H]}}),define(ce[98],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Sm=e.ID=void 0,e.$Tm=c,e.ID="diagnosticsService",e.$Sm=(0,P.$Fi)(e.ID);function c(O){return!!O.hostName&&!!O.errorMessage}class C{async getPerformanceInfo(T,k){return{}}async getSystemInfo(T,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,k){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.$Um=C}),define(ce[99],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=void 0,e.$Yo=(0,P.$Fi)("downloadService")}),define(ce[16],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,P.$Fi)("environmentService"),e.$Ni=(0,P.$Gi)(e.$Mi)}),define(ce[75],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D6b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$C6b=C;var c;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(c||(e.RecommendationSource=c={}));function C(T){switch(T){case c.FILE:return"file";case c.WORKSPACE:return"workspace";case c.EXE:return"exe"}}var O;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(O||(e.RecommendationsNotificationResult=O={})),e.$D6b=(0,P.$Fi)("IExtensionRecommendationNotificationService")}),define(ce[7],le([0,1,52,14,27,13,9,170,4,5,23,54]),function(ne,e,P,c,C,O,T,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=u,e.$bl=v,e.$cl=p,e.$dl=I,e.$el=g,e.$fl=s,e.$gl=r,e.$hl=t,e.$il=a,e.$jl=i,e.$kl=n,e.$ml=f,e.$nl=R,e.$ol=L,e.$pl=E,e.$ql=y,e.$tl=J,e.$Fl=z,e.$Gl=te,e.$Il=he,e.$_k=(0,A.$Fi)("fileService");function u(q){return q.create===!0}var $;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var l;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var b;(function(q){q[q.UPDATED=2]="UPDATED",q[q.ADDED=4]="ADDED",q[q.DELETED=8]="DELETED"})(b||(e.FileChangeFilter=b={}));function v(q){const Z=q;return!!Z&&typeof Z.onDidChange=="function"}var d;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function p(q){return!!(q.capabilities&d.FileReadWrite)}function I(q){return!!(q.capabilities&d.FileFolderCopy)}function g(q){return!!(q.capabilities&d.FileClone)}function s(q){return!!(q.capabilities&d.FileOpenReadWriteClose)}function r(q){return!!(q.capabilities&d.FileReadStream)}function t(q){return p(q)?!!(q.capabilities&d.FileAtomicRead):!1}function a(q){return p(q)?!!(q.capabilities&d.FileAtomicWrite):!1}function i(q){return!!(q.capabilities&d.FileAtomicDelete)}function n(q){return!!(q.capabilities&d.Readonly)}var o;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class h extends Error{static create(Z,K){const H=new h(Z.toString(),K);return L(H,K),H}constructor(Z,K){super(Z),this.code=K}}e.$ll=h;function f(q,Z){return h.create(q,Z)}function R(q){return q||f((0,k.localize)(0,null),o.Unknown)}function L(q,Z){return q.name=Z?`${Z} (FileSystemError)`:"FileSystemError",q}function E(q){if(!q)return o.Unknown;if(q instanceof h)return q.code;const Z=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!Z)return o.Unknown;switch(Z[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function y(q){if(q instanceof W)return q.fileOperationResult;switch(E(q)){case o.FileNotFound:return ie.FILE_NOT_FOUND;case o.FileIsADirectory:return ie.FILE_IS_DIRECTORY;case o.FileNotADirectory:return ie.FILE_NOT_DIRECTORY;case o.FileWriteLocked:return ie.FILE_WRITE_LOCKED;case o.NoPermissions:return ie.FILE_PERMISSION_DENIED;case o.FileExists:return ie.FILE_MOVE_CONFLICT;case o.FileTooLarge:return ie.FILE_TOO_LARGE;default:return ie.FILE_OTHER_ERROR}}var N;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class F{constructor(Z,K,H){this.resource=Z,this.operation=K,this.target=H}isOperation(Z){return this.operation===Z}}e.$rl=F;var D;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(D||(e.FileChangeType=D={}));class M{static{this.a=null}constructor(Z,K){this.c=K,this.b=void 0,this.d=new m.$X(()=>{const H=P.$Li.forUris(()=>this.c);return H.fill(this.rawAdded.map(U=>[U,!0])),H}),this.f=new m.$X(()=>{const H=P.$Li.forUris(()=>this.c);return H.fill(this.rawUpdated.map(U=>[U,!0])),H}),this.g=new m.$X(()=>{const H=P.$Li.forUris(()=>this.c);return H.fill(this.rawDeleted.map(U=>[U,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of Z){switch(H.type){case D.ADDED:this.rawAdded.push(H.resource);break;case D.UPDATED:this.rawUpdated.push(H.resource);break;case D.DELETED:this.rawDeleted.push(H.resource);break}this.b!==M.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(Z,...K){return this.h(Z,{includeChildren:!1},...K)}affects(Z,...K){return this.h(Z,{includeChildren:!0},...K)}h(Z,K,...H){if(!Z)return!1;const U=H.length>0;return!!((!U||H.includes(D.ADDED))&&(this.d.value.get(Z)||K.includeChildren&&this.d.value.findSuperstr(Z))||(!U||H.includes(D.UPDATED))&&(this.f.value.get(Z)||K.includeChildren&&this.f.value.findSuperstr(Z))||(!U||H.includes(D.DELETED))&&(this.g.value.findSubstr(Z)||K.includeChildren&&this.g.value.findSuperstr(Z)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Z){return this.b===Z}hasCorrelation(){return typeof this.b=="number"}}e.$sl=M;function J(q,Z,K){return!q||!Z||q===Z||Z.length>q.length?!1:(Z.charAt(Z.length-1)!==c.sep&&(Z+=c.sep),K?(0,C.$Hf)(q,Z):q.indexOf(Z)===0)}class W extends Error{constructor(Z,K,H){super(Z),this.fileOperationResult=K,this.options=H}}e.$ul=W;class x extends W{constructor(Z,K,H,U){super(Z,K,U),this.fileOperationResult=K,this.size=H}}e.$vl=x;class G extends W{constructor(Z,K,H){super(Z,ie.FILE_NOT_MODIFIED_SINCE,H),this.stat=K}}e.$wl=G;var ie;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var V;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.$El="";function z(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}async function te(q,Z){if(!Z.hasProvider(T.URI.from({scheme:q.scheme})))return new Promise(K=>{const H=Z.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===q.scheme&&U.added&&(H.dispose(),K())})})}class se{static{this.KB=1024}static{this.MB=se.KB*se.KB}static{this.GB=se.MB*se.KB}static{this.TB=se.GB*se.KB}static formatSize(Z){return(0,O.$jg)(Z)||(Z=0),Z<se.KB?(0,k.localize)(1,null,Z.toFixed(0)):Z<se.MB?(0,k.localize)(2,null,(Z/se.KB).toFixed(2)):Z<se.GB?(0,k.localize)(3,null,(Z/se.MB).toFixed(2)):Z<se.TB?(0,k.localize)(4,null,(Z/se.GB).toFixed(2)):(0,k.localize)(5,null,(Z/se.TB).toFixed(2))}}e.$Hl=se;function he(q){const Z=typeof q=="string"||q?.scheme===S.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===S.Schemas.file?1024*se.MB:Z?10*se.MB:w.$o?50*se.MB:1024*se.MB}});var Q=this&&this.__param||function(ne,e){return function(P,c){e(P,c,ne)}};define(ce[200],le([0,1,76,51,7]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;let O=class{constructor(k){this.a=k}async checksum(k){const A=(await this.a.readFileStream(k)).value;return new Promise((w,S)=>{const m=(0,P.createHash)("sha256");(0,c.$Ge)(A,{onData:u=>m.update(u.buffer),onError:u=>S(u),onEnd:()=>w(m.digest("base64").replace(/=+$/,""))})})}};e.$fhc=O,e.$fhc=O=ve([Q(0,C.$_k)],O)}),define(ce[100],le([0,1,15,8,171,7]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=T;async function T(S,m,u,$,l,b){let v;try{await k(S,m,u,$,l,b)}catch(d){v=d}finally{v&&l.errorTransformer&&(v=l.errorTransformer(v)),typeof v<"u"&&u.error(v),u.end()}}async function k(S,m,u,$,l,b){A(b);const v=await S.open(m,{create:!1});try{A(b);let d=0,p=0,I=l&&typeof l.length=="number"?l.length:void 0,g=P.$Oe.alloc(Math.min(l.bufferSize,typeof I=="number"?I:l.bufferSize)),s=l&&typeof l.position=="number"?l.position:0,r=0;do p=await S.read(v,s,g.buffer,r,g.byteLength-r),s+=p,r+=p,d+=p,typeof I=="number"&&(I-=p),r===g.byteLength&&(await u.write($(g)),g=P.$Oe.alloc(Math.min(l.bufferSize,typeof I=="number"?I:l.bufferSize)),r=0);while(p>0&&(typeof I!="number"||I>0)&&A(b)&&w(d,l));if(r>0){let t=r;typeof I=="number"&&(t=Math.min(r,I)),u.write($(g.slice(0,t)))}}catch(d){throw(0,O.$nl)(d)}finally{await S.close(v)}}function A(S){if(S.isCancellationRequested)throw(0,c.$8)();return!0}function w(S,m){if(typeof m?.limits?.size=="number"&&S>m.limits.size)throw(0,O.$ml)((0,C.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[47],le([0,1,94,2,14,5,9,7]),function(ne,e,P,c,C,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=void 0,e.$1q=A,e.$2q=w,e.$6q=$,e.$7q=l,e.$8q=b,e.$9q=v,e.$0q=p,e.$$q=I;function A(g){return typeof g.correlationId=="number"}function w(g){return g.recursive===!0}class S extends c.$Wc{static{this.a=5}constructor(s,r,t,a){super(),this.h=s,this.j=r,this.m=t,this.n=a,this.c=this.B(new c.$Xc),this.f=void 0,this.g=0}s(){const s=new c.$Vc;this.c.value=s,this.b=this.r(s),this.b.setVerboseLogging(this.m),s.add(this.b.onDidChangeFile(r=>this.h(r))),s.add(this.b.onDidLogMessage(r=>this.j(r))),s.add(this.b.onDidError(r=>this.t(r.error,r.request)))}t(s,r){this.u(s,r)?this.g<S.a&&this.f?(this.y(`restarting watcher after unexpected error: ${s}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${s}`):this.y(s)}u(s,r){return!(!this.n.restartOnError||r||s.indexOf("No space left on device")!==-1||s.indexOf("EMFILE")!==-1)}w(s){this.g++,this.s(),this.watch(s)}async watch(s){this.f=s,await this.b?.watch(s)}async setVerboseLogging(s){this.m=s,await this.b?.setVerboseLogging(s)}y(s){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${s}`})}z(s){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${s}`})}dispose(){return this.b=void 0,super.dispose()}}e.$3q=S;class m extends S{constructor(s,r,t){super(s,r,t,{type:"node.js",restartOnError:!1})}}e.$4q=m;class u extends S{constructor(s,r,t){super(s,r,t,{type:"universal",restartOnError:!0})}}e.$5q=u;function $(g){return g.map(s=>({type:s.type,resource:T.URI.revive(s.resource),cId:s.cId}))}function l(g){const s=new d;for(const r of g)s.processEvent(r);return s.coalesce()}function b(g,s){return typeof s=="string"&&!s.startsWith(P.$vk)&&!(0,C.$kc)(s)?{base:g,pattern:s}:s}function v(g,s){const r=[];for(const t of s)r.push((0,P.$zk)(b(g,t)));return r}class d{constructor(){this.a=new Set,this.b=new Map}c(s){return O.$k?s.resource.fsPath:s.resource.fsPath.toLowerCase()}processEvent(s){const r=this.b.get(this.c(s));let t=!1;if(r){const a=r.type,i=s.type;r.resource.fsPath!==s.resource.fsPath&&(s.type===k.FileChangeType.DELETED||s.type===k.FileChangeType.ADDED)?t=!0:a===k.FileChangeType.ADDED&&i===k.FileChangeType.DELETED?(this.b.delete(this.c(s)),this.a.delete(r)):a===k.FileChangeType.DELETED&&i===k.FileChangeType.ADDED?r.type=k.FileChangeType.UPDATED:a===k.FileChangeType.ADDED&&i===k.FileChangeType.UPDATED||(r.type=i)}else t=!0;t&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],r=[];return Array.from(this.a).filter(t=>t.type!==k.FileChangeType.DELETED?(s.push(t),!1):!0).sort((t,a)=>t.resource.fsPath.length-a.resource.fsPath.length).filter(t=>r.some(a=>(0,k.$tl)(t.resource.fsPath,a,!O.$k))?!1:(r.push(t.resource.fsPath),!0)).concat(s)}}function p(g,s){if(typeof s=="number")switch(g.type){case k.FileChangeType.ADDED:return(s&k.FileChangeFilter.ADDED)===0;case k.FileChangeType.DELETED:return(s&k.FileChangeFilter.DELETED)===0;case k.FileChangeType.UPDATED:return(s&k.FileChangeFilter.UPDATED)===0}return!1}function I(g){if(typeof g=="number"){const s=[];return g&k.FileChangeFilter.ADDED&&s.push("Added"),g&k.FileChangeFilter.DELETED&&s.push("Deleted"),g&k.FileChangeFilter.UPDATED&&s.push("Updated"),s.length===0?"<all>":`[${s.join(", ")}]`}return"<none>"}}),define(ce[201],le([0,1,15,41,8,3,2,51,32,7,47]),function(ne,e,P,c,C,O,T,k,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Q=e.$9Q=void 0,e.$9Q="localFilesystem";class m extends T.$Wc{constructor($,l){super(),this.a=$,this.b=l,this.onDidChangeCapabilities=O.Event.None,this.f=this.B(new O.$me),this.onDidChangeFile=this.f.event,this.g=this.B(new O.$me),this.onDidWatchError=this.g.event,this.h=(0,A.$2g)(),this.j()}get capabilities(){return this.c||(this.c=w.FileSystemProviderCapabilities.FileReadWrite|w.FileSystemProviderCapabilities.FileOpenReadWriteClose|w.FileSystemProviderCapabilities.FileReadStream|w.FileSystemProviderCapabilities.FileFolderCopy|w.FileSystemProviderCapabilities.FileWriteUnlock|w.FileSystemProviderCapabilities.FileAtomicRead|w.FileSystemProviderCapabilities.FileAtomicWrite|w.FileSystemProviderCapabilities.FileAtomicDelete|w.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=w.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=w.FileSystemProviderCapabilities.Trash)),this.c}stat($){return this.a.call("stat",[$])}readdir($){return this.a.call("readdir",[$])}async readFile($,l){const{buffer:b}=await this.a.call("readFile",[$,l]);return b}readFileStream($,l,b){const v=(0,k.$Ce)(p=>P.$Oe.concat(p.map(I=>P.$Oe.wrap(I))).buffer),d=new T.$Vc;return d.add(this.a.listen("readFileStream",[$,l])(p=>{if(p instanceof P.$Oe)v.write(p.buffer);else{if(p==="end")v.end();else{let I;if(p instanceof Error)I=p;else{const g=p;I=(0,w.$ml)(g.message??(0,c.$qj)(g),g.code??w.FileSystemProviderErrorCode.Unknown)}v.error(I),v.end()}d.dispose()}})),d.add(b.onCancellationRequested(()=>{v.error((0,C.$8)()),v.end(),d.dispose()})),v}writeFile($,l,b){return this.a.call("writeFile",[$,P.$Oe.wrap(l),b])}open($,l){return this.a.call("open",[$,l])}close($){return this.a.call("close",[$])}async read($,l,b,v,d){const[p,I]=await this.a.call("read",[$,l,d]);return b.set(p.buffer.slice(0,I),v),I}write($,l,b,v,d){return this.a.call("write",[$,l,P.$Oe.wrap(b),v,d])}mkdir($){return this.a.call("mkdir",[$])}delete($,l){return this.a.call("delete",[$,l])}rename($,l,b){return this.a.call("rename",[$,l,b])}copy($,l,b){return this.a.call("copy",[$,l,b])}cloneFile($,l){return this.a.call("cloneFile",[$,l])}j(){this.B(this.a.listen("fileChange",[this.h])($=>{if(Array.isArray($)){const l=$;this.f.fire((0,S.$6q)(l))}else{const l=$;this.g.fire(l)}}))}watch($,l){const b=(0,A.$2g)();return this.a.call("watch",[this.h,b,$,l]),(0,T.$Uc)(()=>this.a.call("unwatch",[this.h,b]))}}e.$0Q=m}),define(ce[202],le([0,1,46,2,47,3,7,9,6]),function(ne,e,P,c,C,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class w extends c.$Wc{constructor(){super(),this.a=this.B(new O.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new O.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new c.$6c),this.m=new Set,this.n=this.B(new A.$Dh(this.y())),this.r=5007,this.s=new A.$3h,this.R=!1,this.B(this.f(m=>this.t(m)))}t(m){this.u(m)&&this.z(m)}u(m){return(0,C.$1q)(m)}async watch(m){this.s.isSettled||this.s.complete(),this.s=new A.$3h;try{this.h.clear(),this.g.clear();for(const u of m)this.u(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.w(!1)}finally{this.s.complete()}}w(m){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))]),m?this.y():0)}y(){return 800}isSuspended(m){return typeof m.correlationId!="number"?!1:this.m.has(m.correlationId)?"polling":this.j.has(m.correlationId)}async z(m){if(this.j.has(m.correlationId))return;const u=new c.$Vc;this.j.set(m.correlationId,u),await this.s.p,!u.isDisposed&&(this.D(m,u),this.w(!0))}C(m){this.j.deleteAndDispose(m.correlationId),this.m.delete(m.correlationId),this.w(!1)}D(m,u){this.F(m,u)?(this.P(`reusing an existing recursive watcher to monitor ${m.path}`),this.m.delete(m.correlationId)):(this.G(m,u),this.m.add(m.correlationId))}F(m,u){const $=this.O?.subscribe(m.path,(l,b)=>{u.isDisposed||(l?this.D(m,u):b?.type===T.FileChangeType.ADDED&&this.H(m))});return $?(u.add($),!0):!1}G(m,u){let $=!1;const l=(b,v)=>{if(u.isDisposed)return;const d=this.I(b),p=this.I(v),I=$;$=d,!d&&(p||I)&&this.H(m)};this.P(`starting fs.watchFile() on ${m.path} (correlationId: ${m.correlationId})`);try{(0,P.watchFile)(m.path,{persistent:!1,interval:this.r},l)}catch(b){this.Q(`fs.watchFile() failed with error ${b} on path ${m.path} (correlationId: ${m.correlationId})`)}u.add((0,c.$Uc)(()=>{this.P(`stopping fs.watchFile() on ${m.path} (correlationId: ${m.correlationId})`);try{(0,P.unwatchFile)(m.path,l)}catch(b){this.Q(`fs.unwatchFile() failed with error ${b} on path ${m.path} (correlationId: ${m.correlationId})`)}}))}H(m){this.P(`detected ${m.path} exists again, resuming watcher (correlationId: ${m.correlationId})`);const u={resource:k.URI.file(m.path),type:T.FileChangeType.ADDED,cId:m.correlationId};this.a.fire([u]),this.J(u,m),this.C(m)}I(m){return m.ctimeMs===0&&m.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(m,u){if(this.R){const $=` >> normalized ${m.type===T.FileChangeType.ADDED?"[ADDED]":m.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${m.resource.fsPath}`;this.L($,u)}}L(m,u){this.R&&this.P(`${m}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}M(m){return`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"}, filter: ${(0,C.$$q)(m.filter)}, correlationId: ${typeof m.correlationId=="number"?m.correlationId:"<none>"})`}async setVerboseLogging(m){this.R=m}}e.$hr=w}),define(ce[203],le([0,1,46,6,26,42,2,91,14,5,21,9,154,31,7,47]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0,e.$nr=d;class v extends T.$Wc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(I,g,s,r,t,a){super(),this.s=I,this.t=g,this.u=s,this.w=r,this.y=t,this.z=a,this.c=this.B(new c.$Uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.u(i))),this.f=this.B(new c.$Th(i=>this.M(i),v.b)),this.g=(0,b.$9q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,b.$9q)(this.s.path,this.s.includes):void 0,this.j=(0,b.$1q)(this.s)?this.s.filter:void 0,this.m=new C.$xe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const I=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const g=await $.Promises.stat(I);if(this.m.token.isCancellationRequested)return;this.B(await this.G(I,g.isDirectory()))}catch(I){I.code!=="ENOENT"?this.O(I):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${I})`),this.D()}}D(){this.r=!0,this.w?.()}async F(I){let g=I.path;try{g=await $.Promises.realpath(I.path),I.path===g&&(g=await(0,u.$jr)(I.path,this.m.token)??I.path),I.path!==g&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${I.path}, real: ${g})`)}catch{}return g}async G(I,g){const s=new T.$Vc;return this.H(I,g,s)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(I,g,s)),s}H(I,g,s){if(g)return!1;const r=m.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(a,i)=>{if(!s.isDisposed)if(a){const n=await this.G(I,g);s.isDisposed?n.dispose():s.add(n)}else i&&(typeof i.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:r,type:i.type,cId:this.s.correlationId},!0)});return t?(s.add(t),!0):!1}async I(I,g,s){if(w.$j&&(0,O.$Eg)(I,"/Volumes/",!0)){this.O(`Refusing to watch ${I} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const r=new C.$xe(this.m.token);s.add((0,T.$Uc)(()=>r.dispose(!0)));const t=new T.$Vc;s.add(t);try{const a=m.URI.file(this.s.path),i=(0,A.$pc)(I),n=(0,P.watch)(I);t.add((0,T.$Uc)(()=>{n.removeAllListeners(),n.close()})),this.Q(`Started watching: '${I}'`);const o=new Set;if(g)try{for(const f of await $.Promises.readdir(I))o.add(f)}catch(f){this.O(f)}if(r.token.isCancellationRequested)return;const h=new Map;t.add((0,T.$Uc)(()=>{for(const[,f]of h)f.dispose();h.clear()})),n.on("error",(f,R)=>{r.token.isCancellationRequested||(this.O(`Failed to watch ${I} for changes using fs.watch() (${f}, ${R})`),this.D())}),n.on("change",(f,R)=>{if(r.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${f}"] ${R}`);let L="";if(R&&(L=R.toString(),w.$j&&(L=(0,k.$mm)(L))),!(!L||f!=="change"&&f!=="rename"))if(g)if(f==="rename"){h.get(L)?.dispose();const E=setTimeout(async()=>{if(h.delete(L),L===i&&!await $.Promises.exists(I)){this.J(a);return}if(r.token.isCancellationRequested)return;const y=await this.N((0,A.$lc)(I,L));if(r.token.isCancellationRequested)return;let N;y?o.has(L)?N=l.FileChangeType.UPDATED:(N=l.FileChangeType.ADDED,o.add(L)):(o.delete(L),N=l.FileChangeType.DELETED),this.L({resource:(0,S.$gh)(a,L),type:N,cId:this.s.correlationId})},v.a);h.set(L,(0,T.$Uc)(()=>clearTimeout(E)))}else{let E;o.has(L)?E=l.FileChangeType.UPDATED:(E=l.FileChangeType.ADDED,o.add(L)),this.L({resource:(0,S.$gh)(a,L),type:E,cId:this.s.correlationId})}else if(f==="rename"||L!==i){const E=setTimeout(async()=>{const y=await $.Promises.exists(I);r.token.isCancellationRequested||(y?(this.L({resource:a,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0),t.add(await this.G(I,!1))):this.J(a))},v.a);t.clear(),t.add((0,T.$Uc)(()=>clearTimeout(E)))}else this.L({resource:a,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(a){r.token.isCancellationRequested||this.O(`Failed to watch ${I} for changes using fs.watch() (${a.toString()})`),this.D()}}J(I){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:I,type:l.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(I,g=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${I.type===l.FileChangeType.ADDED?"[ADDED]":I.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${I.resource.fsPath}`),!g&&this.g.some(s=>s(I.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${I.resource.fsPath}`):!g&&this.h&&this.h.length>0&&!this.h.some(s=>s(I.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${I.resource.fsPath}`):this.f.work(I))}M(I){const g=(0,b.$7q)(I),s=[];for(const t of g){if((0,b.$0q)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}s.push(t)}if(s.length===0)return;if(this.z)for(const t of s)this.R(` >> normalized ${t.type===l.FileChangeType.ADDED?"[ADDED]":t.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(s)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(I){if(w.$k)return $.Promises.exists(I);try{const g=(0,A.$pc)(I);return(await $.Promises.readdir((0,A.$oc)(I))).some(r=>r===g)}catch(g){return this.Q(g),!1}}setVerboseLogging(I){this.z=I}O(I){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${I}`})}P(I){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${I}`})}Q(I){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${I}`})}R(I){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${I}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$mr=v;async function d(p,I,g,s,r=512){const t=await $.Promises.open(p,"r"),a=Buffer.allocUnsafe(r),i=new C.$xe(s);let n,o=!1;const h={path:p,excludes:[],recursive:!1},f=new v(h,void 0,R=>{(async()=>{for(const{type:L}of R)if(L===l.FileChangeType.UPDATED){if(o)return;o=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:E}=await $.Promises.read(t,a,0,r,null);if(!E||i.token.isCancellationRequested)break;I(a.slice(0,E))}}catch(E){n=new Error(E),i.dispose(!0)}finally{o=!1}}})()});return await f.ready,g(),new Promise((R,L)=>{i.token.onCancellationRequested(async()=>{f.dispose();try{await $.Promises.close(t)}catch(E){n=new Error(E)}n?L(n):R()})})}}),define(ce[204],le([0,1,3,94,202,5,203,42]),function(ne,e,P,c,C,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class A extends C.$hr{constructor(S){super(),this.O=S,this.onDidError=P.Event.None,this.watchers=new Set}async N(S){S=this.Z(S);const m=[],u=new Set(Array.from(this.watchers));for(const $ of S){const l=this.W($);l&&(0,c.$Dk)(l.request.excludes,$.excludes)&&(0,c.$Dk)(l.request.includes,$.includes)?u.delete(l):m.push($)}m.length&&this.P(`Request to start watching: ${m.map($=>this.M($)).join(",")}`),u.size&&this.P(`Request to stop watching: ${Array.from(u).map($=>this.M($.request)).join(",")}`);for(const $ of u)this.Y($);for(const $ of m)this.X($)}W(S){for(const m of this.watchers)if(typeof S.correlationId=="number"||typeof m.request.correlationId=="number"){if(m.request.correlationId===S.correlationId)return m}else if((0,k.$Dg)(m.request.path,S.path,!O.$k))return m}X(S){const m=new T.$mr(S,this.O,$=>this.a.fire($),()=>this.c.fire(S),$=>this.b.fire($),this.R),u={request:S,instance:m};this.watchers.add(u)}async stop(){await super.stop();for(const S of this.watchers)this.Y(S)}Y(S){this.P("stopping file watcher",S),this.watchers.delete(S),S.instance.dispose()}Z(S){const m=new Map;for(const u of S){const $=O.$k?u.path:u.path.toLowerCase();let l=m.get(u.correlationId);l||(l=new Map,m.set(u.correlationId,l)),l.has($)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),l.set($,u)}return Array.from(m.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(S){super.setVerboseLogging(S);for(const m of this.watchers)m.instance.setVerboseLogging(S)}P(S,m){this.R&&this.b.fire({type:"trace",message:this.bb(S,m)})}Q(S){this.b.fire({type:"warn",message:this.bb(S)})}bb(S,m){return m?`[File Watcher (node.js)] ${S} (${this.M(m.request)})`:`[File Watcher (node.js)] ${S}`}}e.$or=A}),define(ce[205],le([0,1,47,204]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class C extends P.$4q{constructor(T,k,A){super(T,k,A),this.s()}r(T){return T.add(new c.$or(void 0))}}e.$pr=C}),define(ce[206],le([0,1,23,43,96,47]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class T extends O.$5q{constructor(A,w,S){super(A,w,S),this.s()}r(A){const w=A.add(new C.$fr(P.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return A.add(w.onDidProcessExit(({code:S,signal:m})=>this.t(`terminated by itself with code ${S}, signal: ${m} (ETERM)`))),c.ProxyChannel.toService((0,c.$mi)(w.getChannel("watcher")))}}e.$gr=T}),define(ce[77],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class P{constructor(...C){this.a=new Map;for(const[O,T]of C)this.set(O,T)}set(C,O){const T=this.a.get(C);return this.a.set(C,O),T}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Di=P}),define(ce[207],le([0,1,6,8,2,74,198,4,77,90]),function(ne,e,P,c,C,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;const S=!1;class m extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class u{constructor(v=new A.$Di,d=!1,p,I=S){this.i=v,this.j=d,this.k=p,this.l=I,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(k.$Ei,this),this._globalGraph=I?p?._globalGraph??new T.$sr(g=>g):void 0}dispose(){if(!this.f){this.f=!0,(0,C.$Rc)(this.h),this.h.clear();for(const v of this.g)(0,C.$Qc)(v)&&v.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(v,d){this.m();const p=this,I=new class extends u{dispose(){p.h.delete(I),super.dispose()}}(v,this.j,this,this.l);return this.h.add(I),d?.add(I),I}invokeFunction(v,...d){this.m();const p=l.traceInvocation(this.l,v);let I=!1;try{return v({get:s=>{if(I)throw(0,c.$0)("service accessor is only valid during the invocation of its target method");const r=this.s(s,p);if(!r)throw new Error(`[invokeFunction] unknown service '${s}'`);return r}},...d)}finally{I=!0,p.stop()}}createInstance(v,...d){this.m();let p,I;return v instanceof O.$Ci?(p=l.traceCreation(this.l,v.ctor),I=this.o(v.ctor,v.staticArguments.concat(d),p)):(p=l.traceCreation(this.l,v),I=this.o(v,d,p)),p.stop(),I}o(v,d=[],p){const I=k._util.getServiceDependencies(v).sort((r,t)=>r.index-t.index),g=[];for(const r of I){const t=this.s(r.id,p);t||this.y(`[createInstance] ${v.name} depends on UNKNOWN service ${r.id}.`,!1),g.push(t)}const s=I.length>0?I[0].index:d.length;if(d.length!==s){console.trace(`[createInstance] First service dependency of ${v.name} at position ${s+1} conflicts with ${d.length} static arguments`);const r=s-d.length;r>0?d=d.concat(new Array(r)):d=d.slice(0,s)}return Reflect.construct(v,d.concat(g))}q(v,d){if(this.i.get(v)instanceof O.$Ci)this.i.set(v,d);else if(this.k)this.k.q(v,d);else throw new Error("illegalState - setting UNKNOWN service instance")}r(v){const d=this.i.get(v);return!d&&this.k?this.k.r(v):d}s(v,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const p=this.r(v);return p instanceof O.$Ci?this.u(v,p,d.branch(v,!0)):(d.branch(v,!1),p)}u(v,d,p){if(this.t.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.t.add(v);try{return this.v(v,d,p)}finally{this.t.delete(v)}}v(v,d,p){const I=new T.$sr(r=>r.id.toString());let g=0;const s=[{id:v,desc:d,_trace:p}];for(;s.length;){const r=s.pop();if(I.lookupOrInsertNode(r),g++>1e3)throw new m(I);for(const t of k._util.getServiceDependencies(r.desc.ctor)){const a=this.r(t.id);if(a||this.y(`[createInstance] ${v} depends on ${t.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(t.id)),a instanceof O.$Ci){const i={id:t.id,desc:a,_trace:r._trace.branch(t.id,!0)};I.insertEdge(r,i),s.push(i)}}}for(;;){const r=I.roots();if(r.length===0){if(!I.isEmpty())throw new m(I);break}for(const{data:t}of r){if(this.r(t.id)instanceof O.$Ci){const i=this.w(t.id,t.desc.ctor,t.desc.staticArguments,t.desc.supportsDelayedInstantiation,t._trace);this.q(t.id,i)}I.removeNode(t)}}return this.r(v)}w(v,d,p=[],I,g){if(this.i.get(v)instanceof O.$Ci)return this.x(v,d,p,I,g,this.g);if(this.k)return this.k.w(v,d,p,I,g);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}x(v,d,p=[],I,g,s){if(I){const r=new u(void 0,this.j,this,this.l);r.c=String(v);const t=new Map,a=new P.$Yh(()=>{const i=r.o(d,p,g);for(const[n,o]of t){const h=i[n];if(typeof h=="function")for(const f of o)f.disposable=h.apply(i,f.listener)}return t.clear(),s.add(i),i});return new Proxy(Object.create(null),{get(i,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let f=t.get(n);return f||(f=new w.$7c,t.set(n,f)),(L,E,y)=>{if(a.isInitialized)return a.value[n](L,E,y);{const N={listener:[L,E,y],disposable:void 0},F=f.push(N);return(0,C.$Uc)(()=>{F(),N.disposable?.dispose()})}}}if(n in i)return i[n];const o=a.value;let h=o[n];return typeof h!="function"||(h=h.bind(o),i[n]=h),h},set(i,n,o){return a.value[n]=o,!0},getPrototypeOf(i){return d.prototype}})}else{const r=this.o(d,p,g);return s.add(r),r}}y(v,d){if(d&&console.warn(v),this.j)throw new Error(v)}}e.$tr=u;var $;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})($||($={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super($.None,null)}stop(){}branch(){return this}}}static traceInvocation(v,d){return v?new l($.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(v,d){return v?new l($.Creation,d.name):l.c}static{this.f=0}constructor(v,d){this.type=v,this.name=d,this.g=Date.now(),this.h=[]}branch(v,d){const p=new l($.Branch,v.toString());return this.h.push([v,d,p]),p}stop(){const v=Date.now()-this.g;l.f+=v;let d=!1;function p(g,s){const r=[],t=new Array(g+1).join("	");for(const[a,i,n]of s.h)if(i&&n){d=!0,r.push(`${t}CREATES -> ${a}`);const o=p(g+1,n);o&&r.push(o)}else r.push(`${t}uses -> ${a}`);return r.join(`
`)}const I=[`${this.type===$.Creation?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(v>2||d)&&l.all.add(I.join(`
`))}}e.$ur=l}),define(ce[57],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=void 0,e.$Ugc=(0,P.$Fi)("mainProcessService");class c{constructor(O,T){this.a=O,this.b=T}getChannel(O){return this.a.getChannel(O,this.b)}registerChannel(O,T){this.a.registerChannel(O,T)}}e.$Vgc=c}),define(ce[10],le([0,1,174,41,3,56,2,35,5,21,13,9,97,4]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=b,e.log=d,e.$nk=h,e.$ok=f,e.$pk=R,e.$qk=L,P=Oe(P),e.$_j=(0,$.$Fi)("logService"),e.$ak=(0,$.$Fi)("loggerService");function l(){return new Date().toISOString()}function b(E){return(0,S.$jg)(E)}var v;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$ck=v.Info;function d(E,y,N){switch(y){case v.Trace:E.trace(N);break;case v.Debug:E.debug(N);break;case v.Info:E.info(N);break;case v.Warning:E.warn(N);break;case v.Error:E.error(N);break;case v.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function p(E,y=!1){let N="";for(let F=0;F<E.length;F++){let D=E[F];if(D instanceof Error&&(D=(0,c.$qj)(D,y)),typeof D=="object")try{D=JSON.stringify(D)}catch{}N+=(F>0?" ":"")+D}return N}class I extends T.$Wc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new C.$me),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==v.Off&&this.b<=y}}e.$ek=I;class g extends I{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...N){this.f(v.Trace)&&this.g(v.Trace,p([y,...N],!0))}debug(y,...N){this.f(v.Debug)&&this.g(v.Debug,p([y,...N]))}info(y,...N){this.f(v.Info)&&this.g(v.Info,p([y,...N]))}warn(y,...N){this.f(v.Warning)&&this.g(v.Warning,p([y,...N]))}error(y,...N){if(this.f(v.Error))if(y instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=y.stack,this.g(v.Error,p(F))}else this.g(v.Error,p([y,...N]))}flush(){}}e.$fk=g;class s extends I{constructor(y=e.$ck){super(),this.setLevel(y),this.g=!A.$i}trace(y,...N){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,y,...N):console.log(`[main ${l()}]`,y,...N))}debug(y,...N){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,y,...N):console.log(`[main ${l()}]`,y,...N))}info(y,...N){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,y,...N):console.log(`[main ${l()}]`,y,...N))}warn(y,...N){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,y,...N):console.warn(`[main ${l()}]`,y,...N))}error(y,...N){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,y,...N):console.error(`[main ${l()}]`,y,...N))}flush(){}}e.$gk=s;class r extends I{constructor(y=e.$ck,N=!0){super(),this.g=N,this.setLevel(y)}trace(y,...N){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...N):console.log(y,...N))}debug(y,...N){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...N):console.log(y,...N))}info(y,...N){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...N):console.log(y,...N))}warn(y,...N){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...N):console.log(y,...N))}error(y,...N){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...N):console.error(y,...N))}flush(){}}e.$hk=r;class t extends I{constructor(y,N=e.$ck){super(),this.g=y,this.setLevel(N)}trace(y,...N){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(y),...N])}debug(y,...N){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(y),...N])}info(y,...N){this.f(v.Info)&&this.g.log(v.Info,[this.h(y),...N])}warn(y,...N){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(y),...N])}error(y,...N){this.f(v.Error)&&this.g.log(v.Error,[this.h(y),...N])}h(y){return typeof y=="string"?y:(0,c.$qj)(y,this.f(v.Trace))}flush(){}}e.$ik=t;class a extends I{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const N of this.g)N.setLevel(y);super.setLevel(y)}trace(y,...N){for(const F of this.g)F.trace(y,...N)}debug(y,...N){for(const F of this.g)F.debug(y,...N)}info(y,...N){for(const F of this.g)F.info(y,...N)}warn(y,...N){for(const F of this.g)F.warn(y,...N)}error(y,...N){for(const F of this.g)F.error(y,...N)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$jk=a;class i extends T.$Wc{constructor(y,N,F){if(super(),this.h=y,this.j=N,this.b=new k.$Cc,this.c=this.B(new C.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$me),this.onDidChangeVisibility=this.g.event,F)for(const D of F)this.b.set(D.resource,{logger:void 0,info:D})}m(y){return(0,S.$fg)(y)?[...this.b.values()].find(N=>N.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,N){const F=this.n(y),D=(0,S.$fg)(y)?y:N?.id??(0,O.$tj)(F.toString()).toString(16);let M=this.b.get(F)?.logger;const J=N?.logLevel==="always"?v.Trace:N?.logLevel;M||(M=this.s(F,J??this.getLogLevel(F)??this.h,{...N,id:D}));const W={logger:M,info:{resource:F,id:D,logLevel:J,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(W.info),this.b.set(F,W),M}n(y){return(0,S.$fg)(y)?(0,w.$gh)(this.j,`${y}.log`):y}setLogLevel(y,N){if(m.URI.isUri(y)){const F=y,D=N,M=this.b.get(F);M&&D!==M.info.logLevel&&(M.info.logLevel=D===this.h?void 0:D,M.logger?.setLevel(D),this.b.set(M.info.resource,M),this.f.fire([F,D]))}else{this.h=y;for(const[F,D]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&D.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,N){const F=this.m(y);F&&N!==!F.info.hidden&&(F.info.hidden=!N,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,N]))}getLogLevel(y){let N;return y&&(N=this.b.get(y)?.info.logLevel),N??this.h}registerLogger(y){const N=this.b.get(y.resource);N?N.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const N=this.b.get(y);N&&(N.logger&&N.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=i;class n{constructor(){this.onDidChangeLogLevel=new C.$me().event}setLevel(y){}getLevel(){return v.Info}trace(y,...N){}debug(y,...N){}info(y,...N){}warn(y,...N){}error(y,...N){}critical(y,...N){}dispose(){}flush(){}}e.$lk=n;class o extends n{}e.$mk=o;function h(E){if(E.verbose)return v.Trace;if(typeof E.logLevel=="string"){const y=L(E.logLevel.toLowerCase());if(y!==void 0)return y}return e.$ck}function f(E){switch(E){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}function R(E){switch(E){case v.Trace:return{original:"Trace",value:P.localize(0,null)};case v.Debug:return{original:"Debug",value:P.localize(1,null)};case v.Info:return{original:"Info",value:P.localize(2,null)};case v.Warning:return{original:"Warning",value:P.localize(3,null)};case v.Error:return{original:"Error",value:P.localize(4,null)};case v.Off:return{original:"Off",value:P.localize(5,null)}}}function L(E){switch(E){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$rk=new u.$Wj("logLevel",f(v.Info))}),define(ce[208],le([0,1,6,8,2,23,14,21,31,16,10]),function(ne,e,P,c,C,O,T,k,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;let m=class extends C.$Wc{constructor($,l){super(),this.a=$,this.b=l,this.B(new P.$Rh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const $=(0,k.$dh)(this.a.logsHome),l=(0,k.$fh)(this.a.logsHome.with({scheme:O.Schemas.file})).fsPath,d=(await A.Promises.readdir(l)).filter(I=>/^\d{8}T\d{6}$/.test(I)).sort().filter(I=>I!==$),p=d.slice(0,Math.max(0,d.length-9));p.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${p.join(", ")}'`),await Promise.all(p.map(I=>A.Promises.rm((0,T.$lc)(l,I)))))}catch($){(0,c.$3)($)}}};e.$chc=m,e.$chc=m=ve([Q(0,w.$Mi),Q(1,S.$_j)],m)}),define(ce[209],le([0,1,19,6,8,3,42,2,14,47,10]),function(ne,e,P,c,C,O,T,k,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class m extends k.$Wc{constructor($,l){super(),this.a=$,this.b=l,this.c=this.B(new O.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new c.$Dh(0)),this.w=[],this.y=this.B(new c.$Dh(0))}watch($,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n($,l):this.z($,l)}n($,l){const b={path:this.J($),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},v=(0,P.$Vb)(this.j,b);return this.r(),(0,k.$Uc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,C.$3)($))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,w.$6q)(l)),l=>this.G(l),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const l of this.j)(0,w.$2q)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const l of this.j)(0,w.$2q)(l)&&$.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,l){const b={path:this.J($),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},v=(0,P.$Vb)(this.w,b);return this.C(),(0,k.$Uc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,C.$3)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,w.$6q)($)),$=>this.G($),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,A.$jc)($.fsPath)}J($){const l=this.I($);return(0,T.$Hg)(l)}}e.$_q=m}),define(ce[210],le([0,1,19,6,15,26,3,56,64,2,52,23,101,21,51,169,7,100,10,8]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p,I){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;let s=class extends w.$Wc{static{g=this}constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new T.$me),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.$me),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.$me),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new T.$me),this.onDidRunOperation=this.r.event,this.X=this.B(new T.$me),this.Y=this.B(new T.$me),this.onDidFilesChange=this.Y.event,this.Z=this.B(new T.$me),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new c.$Oh)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,u.mark)(`code/registerFilesystem/${t}`);const i=new w.$Vc;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(n=>{const o=new v.$sl(n,!this.S(a));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,w.$Uc)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,w.$Rc)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await c.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return A.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,$.$kh)(t))throw new v.$ul((0,b.localize)(0,null,this.sb(t)),v.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new I.$db;throw i.message=(0,b.localize)(1,null,t.toString()),i}return a}async m(t){const a=await this.j(t);if((0,v.$fl)(a)||(0,v.$cl)(a)||(0,v.$gl)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const a=await this.j(t);if((0,v.$fl)(a)||(0,v.$cl)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.s(t,a)}catch(i){throw(0,v.$pl)(i)===v.FileSystemProviderErrorCode.FileNotFound?new v.$ul((0,b.localize)(2,null,this.sb(t)),v.FileOperationResult.FILE_NOT_FOUND):(0,v.$nl)(i)}}async s(t,a){const i=await this.j(t),n=this.S(i),o=a?.resolveTo,h=a?.resolveSingleChildDescendants,f=a?.resolveMetadata,R=await i.stat(t);let L;return this.t(i,t,R,void 0,!!f,(E,y)=>(L||(L=S.$Li.forUris(()=>!n),L.set(t,!0),o&&L.fill(!0,o)),L.get(E.resource)||L.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&h?y===1:!1))}async t(t,a,i,n,o,h){const{providerExtUri:f}=this.R(t),R={resource:a,name:f.basename(a),isFile:(i.type&v.FileType.File)!==0,isDirectory:(i.type&v.FileType.Directory)!==0,isSymbolicLink:(i.type&v.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&v.FilePermission.Readonly)||!!(t.capabilities&v.FileSystemProviderCapabilities.Readonly),locked:!!((i.permissions??0)&v.FilePermission.Locked),etag:(0,v.$Fl)({mtime:i.mtime,size:i.size}),children:void 0};if(R.isDirectory&&h(R,n)){try{const L=await t.readdir(a),E=await c.Promises.settled(L.map(async([y,N])=>{try{const F=f.joinPath(a,y),D=o?await t.stat(F):{type:N};return await this.t(t,F,D,L.length,o,h)}catch(F){return this.b.trace(F),null}}));R.children=(0,P.$Jb)(E)}catch(L){this.b.trace(L),R.children=[]}return R}return R}async resolveAll(t){return c.Promises.settled(t.map(async a=>{try{return{stat:await this.s(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.t(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.u(t,a)}catch(i){return i}return!0}async u(t,a){if(!a?.overwrite&&await this.exists(t))throw new v.$ul((0,b.localize)(3,null,this.sb(t)),v.FileOperationResult.FILE_MODIFIED_SINCE,a)}async createFile(t,a=C.$Oe.fromString(""),i){await this.u(t,i);const n=await this.writeFile(t,a);return this.r.fire(new v.$rl(t,v.FileOperation.CREATE,n)),n}async writeFile(t,a,i){const n=this.qb(await this.n(t),t),{providerExtUri:o}=this.R(n);let h=i;if((0,v.$il)(n)&&!h?.atomic){const f=n.enforceAtomicWriteFile?.(t);f&&(h={...i,atomic:f})}try{await this.w(n,t,h)||await this.U(n,o.dirname(t));let R;if((0,v.$cl)(n)&&!(a instanceof C.$Oe))if((0,l.$Ae)(a)){const L=await(0,l.$He)(a,3);L.ended?R=C.$Oe.concat(L.buffer):R=L}else R=(0,l.$Ee)(a,L=>C.$Oe.concat(L),3);else R=a;!(0,v.$fl)(n)||(0,v.$cl)(n)&&R instanceof C.$Oe||(0,v.$cl)(n)&&(0,v.$il)(n)&&h?.atomic?await this.hb(n,t,h,R):await this.db(n,t,h,R instanceof C.$Oe?(0,C.$Ze)(R):R),this.r.fire(new v.$rl(t,v.FileOperation.WRITE))}catch(f){throw new v.$ul((0,b.localize)(4,null,this.sb(t),(0,v.$nl)(f).toString()),(0,v.$ql)(f),h)}return this.resolve(t,{resolveMetadata:!0})}async w(t,a,i){const n=!!i?.unlock;if(n&&!(t.capabilities&v.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,b.localize)(5,null,this.sb(a)));if(!!i?.atomic){if(!(t.capabilities&v.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,b.localize)(6,null,this.sb(a)));if(!(t.capabilities&v.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,b.localize)(7,null,this.sb(a)));if(n)throw new Error((0,b.localize)(8,null,this.sb(a)))}let h;try{h=await t.stat(a)}catch{return}if(h.type&v.FileType.Directory)throw new v.$ul((0,b.localize)(9,null,this.sb(a)),v.FileOperationResult.FILE_IS_DIRECTORY,i);if(this.rb(a,h),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==v.$El&&typeof h.mtime=="number"&&typeof h.size=="number"&&i.mtime<h.mtime&&i.etag!==(0,v.$Fl)({mtime:i.mtime,size:h.size}))throw new v.$ul((0,b.localize)(10,null),v.FileOperationResult.FILE_MODIFIED_SINCE,i);return h}async readFile(t,a,i){const n=await this.m(t);return a?.atomic?this.z(n,t,a,i):this.C(n,t,a,i)}async z(t,a,i,n){return new Promise((o,h)=>{this.cb.queueFor(a,async()=>{try{const f=await this.C(t,a,i,n);o(f)}catch(f){h(f)}},this.R(t).providerExtUri)})}async C(t,a,i,n){const o=await this.D(t,a,{...i,preferUnbuffered:!0},n);return{...o,value:await(0,C.$1e)(o.value)}}async readFileStream(t,a,i){const n=await this.m(t);return this.D(n,t,a,i)}async D(t,a,i,n){const o=new O.$xe(n);let h=i;(0,v.$hl)(t)&&t.enforceAtomicReadFile?.(a)&&(h={...i,atomic:!0});const f=this.J(a,h).then(L=>L,L=>{throw o.dispose(!0),L});let R;try{return typeof h?.etag=="string"&&h.etag!==v.$El&&await f,h?.atomic&&(0,v.$hl)(t)||!((0,v.$fl)(t)||(0,v.$gl)(t))||(0,v.$cl)(t)&&h?.preferUnbuffered?R=this.I(t,a,h):(0,v.$gl)(t)?R=this.G(t,a,o.token,h):R=this.H(t,a,o.token,h),R.on("end",()=>o.dispose()),R.on("error",()=>o.dispose()),{...await f,value:R}}catch(L){throw R&&await(0,l.$Fe)(R),this.F(L,a,h)}}F(t,a,i){const n=(0,b.localize)(11,null,this.sb(a),(0,v.$nl)(t).toString());return t instanceof v.$wl?new v.$wl(n,t.stat,i):t instanceof v.$vl?new v.$vl(n,t.fileOperationResult,t.size,t.options):new v.$ul(n,(0,v.$ql)(t),i)}G(t,a,i,n=Object.create(null)){const o=t.readFileStream(a,n,i);return(0,l.$Le)(o,{data:h=>h instanceof C.$Oe?h:C.$Oe.wrap(h),error:h=>this.F(h,a,n)},h=>C.$Oe.concat(h))}H(t,a,i,n=Object.create(null)){const o=(0,C.$5e)();return(0,d.$Yq)(t,a,o,h=>h,{...n,bufferSize:this.a,errorTransformer:h=>this.F(h,a,n)},i),o}I(t,a,i){const n=(0,l.$Ce)(o=>C.$Oe.concat(o));return(async()=>{try{let o;i?.atomic&&(0,v.$hl)(t)?o=await t.readFile(a,{atomic:!0}):o=await t.readFile(a),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.L(a,o.byteLength,i),n.end(C.$Oe.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async J(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new v.$ul((0,b.localize)(12,null,this.sb(t)),v.FileOperationResult.FILE_IS_DIRECTORY,a);if(typeof a?.etag=="string"&&a.etag!==v.$El&&a.etag===i.etag)throw new v.$wl((0,b.localize)(13,null),i,a);return this.L(t,i.size,a),i}L(t,a,i){if(typeof i?.limits?.size=="number"&&a>i.limits.size)throw new v.$vl((0,b.localize)(14,null,this.sb(t)),v.FileOperationResult.FILE_TOO_LARGE,a,i)}async canMove(t,a,i){return this.M(t,a,"move",i)}async canCopy(t,a,i){return this.M(t,a,"copy",i)}async M(t,a,i,n){if(t.toString()!==a.toString())try{const o=i==="move"?this.qb(await this.n(t),t):await this.m(t),h=this.qb(await this.n(a),a);await this.Q(o,t,h,a,i,n)}catch(o){return o}return!0}async move(t,a,i){const n=this.qb(await this.n(t),t),o=this.qb(await this.n(a),a),h=await this.N(n,t,o,a,"move",!!i),f=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new v.$rl(t,h==="move"?v.FileOperation.MOVE:v.FileOperation.COPY,f)),f}async copy(t,a,i){const n=await this.m(t),o=this.qb(await this.n(a),a),h=await this.N(n,t,o,a,"copy",!!i),f=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new v.$rl(t,h==="copy"?v.FileOperation.COPY:v.FileOperation.MOVE,f)),f}async N(t,a,i,n,o,h){if(a.toString()===n.toString())return o;const{exists:f,isSameResourceWithDifferentPathCase:R}=await this.Q(t,a,i,n,o,h);if(f&&!R&&h&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),o==="copy"){if(t===i&&(0,v.$dl)(t))await t.copy(a,n,{overwrite:h});else{const L=await this.resolve(a);L.isDirectory?await this.P(t,L,i,n):await this.O(t,a,i,n)}return o}else return t===i?(await t.rename(a,n,{overwrite:h}),o):(await this.N(t,a,i,n,"copy",h),await this.del(a,{recursive:!0}),"copy")}async O(t,a,i,n){if((0,v.$fl)(t)&&(0,v.$fl)(i))return this.jb(t,a,i,n);if((0,v.$fl)(t)&&(0,v.$cl)(i))return this.pb(t,a,i,n);if((0,v.$cl)(t)&&(0,v.$fl)(i))return this.nb(t,a,i,n);if((0,v.$cl)(t)&&(0,v.$cl)(i))return this.lb(t,a,i,n)}async P(t,a,i,n){await i.mkdir(n),Array.isArray(a.children)&&await c.Promises.settled(a.children.map(async o=>{const h=this.R(i).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.P(t,await this.resolve(o.resource),i,h):this.O(t,o.resource,i,h)}))}async Q(t,a,i,n,o,h){let f=!1;if(t===i){const{providerExtUri:L,isPathCaseSensitive:E}=this.R(t);if(E||(f=L.isEqual(a,n)),f&&o==="copy")throw new Error((0,b.localize)(15,null,this.sb(a),this.sb(n)));if(!f&&L.isEqualOrParent(n,a))throw new Error((0,b.localize)(16,null,this.sb(a),this.sb(n)))}const R=await this.exists(n);if(R&&!f){if(!h)throw new v.$ul((0,b.localize)(17,null,this.sb(a),this.sb(n)),v.FileOperationResult.FILE_MOVE_CONFLICT);if(t===i){const{providerExtUri:L}=this.R(t);if(L.isEqualOrParent(a,n))throw new Error((0,b.localize)(18,null,this.sb(a),this.sb(n)))}}return{exists:R,isSameResourceWithDifferentPathCase:f}}R(t){const a=this.S(t);return{providerExtUri:a?$.$9g:$.$$g,isPathCaseSensitive:a}}S(t){return!!(t.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(t){const a=this.qb(await this.j(t),t);await this.U(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new v.$rl(t,v.FileOperation.CREATE,i)),i}async U(t,a){const i=[],{providerExtUri:n}=this.R(t);for(;!n.isEqual(a,n.dirname(a));)try{if(!((await t.stat(a)).type&v.FileType.Directory))throw new Error((0,b.localize)(19,null,this.sb(a)));break}catch(o){if((0,v.$pl)(o)!==v.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(n.basename(a)),a=n.dirname(a)}for(let o=i.length-1;o>=0;o--){a=n.joinPath(a,i[o]);try{await t.mkdir(a)}catch(h){if((0,v.$pl)(h)!==v.FileSystemProviderErrorCode.FileExists)throw h}}}async canDelete(t,a){try{await this.W(t,a)}catch(i){return i}return!0}async W(t,a){const i=this.qb(await this.j(t),t),n=!!a?.useTrash;if(n&&!(i.capabilities&v.FileSystemProviderCapabilities.Trash))throw new Error((0,b.localize)(20,null,this.sb(t)));const o=a?.atomic;if(o&&!(i.capabilities&v.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,b.localize)(21,null,this.sb(t)));if(n&&o)throw new Error((0,b.localize)(22,null,this.sb(t)));let h;try{h=await i.stat(t)}catch{}if(h)this.rb(t,h);else throw new v.$ul((0,b.localize)(23,null,this.sb(t)),v.FileOperationResult.FILE_NOT_FOUND);if(!!!a?.recursive){const R=await this.resolve(t);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,b.localize)(24,null,this.sb(t)))}return i}async del(t,a){const i=await this.W(t,a);let n=a;if((0,v.$jl)(i)&&!n?.atomic){const R=i.enforceAtomicDelete?.(t);R&&(n={...a,atomic:R})}const o=!!n?.useTrash,h=!!n?.recursive,f=n?.atomic??!1;await i.delete(t,{recursive:h,useTrash:o,atomic:f}),this.r.fire(new v.$rl(t,v.FileOperation.DELETE))}async cloneFile(t,a){const i=await this.j(t),n=this.qb(await this.n(a),a);if(!(i===n&&this.R(i).providerExtUri.isEqual(t,a)))return i===n&&(0,v.$el)(i)?i.cloneFile(t,a):(await this.U(n,this.R(n).providerExtUri.dirname(a)),i===n&&(0,v.$dl)(i)?this.cb.queueFor(t,()=>i.copy(t,a,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(t,()=>this.O(i,t,n,a),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(t,a){return this.watch(t,{...a,correlationId:g.ab++})}watch(t,a={recursive:!1,excludes:[]}){const i=new w.$Vc;let n=!1,o=()=>{n=!0};i.add((0,w.$Uc)(()=>o())),(async()=>{try{const f=await this.bb(t,a);n?(0,w.$Rc)(f):o=()=>(0,w.$Rc)(f)}catch(f){this.b.error(f)}})();const h=a.correlationId;if(typeof h=="number"){const f=i.add(new T.$me);return i.add(this.X.event(L=>{L.correlates(h)&&f.fire(L)})),{onDidChange:f.event,dispose:()=>i.dispose()}}return i}async bb(t,a){const i=await this.j(t),n=(0,k.$tj)([this.R(i).providerExtUri.getComparisonKey(t),a]);let o=this.$.get(n);return o||(o={count:0,disposable:i.watch(t,a)},this.$.set(n,o)),o.count+=1,(0,w.$Uc)(()=>{o&&(o.count--,o.count===0&&((0,w.$Rc)(o.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.$)(0,w.$Rc)(t.disposable);this.$.clear()}async db(t,a,i,n){return this.cb.queueFor(a,async()=>{const o=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,l.$Ae)(n)||(0,l.$Be)(n)?await this.eb(t,o,n):await this.fb(t,o,n)}catch(h){throw(0,v.$nl)(h)}finally{await t.close(o)}},this.R(t).providerExtUri)}async eb(t,a,i){let n=0,o;if((0,l.$Be)(i)){if(i.buffer.length>0){const h=C.$Oe.concat(i.buffer);await this.gb(t,a,h,h.byteLength,n,0),n+=h.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((h,f)=>{(0,l.$Ge)(o,{onData:async R=>{o.pause();try{await this.gb(t,a,R,R.byteLength,n,0)}catch(L){return f(L)}n+=R.byteLength,setTimeout(()=>o.resume())},onError:R=>f(R),onEnd:()=>h()})})}async fb(t,a,i){let n=0,o;for(;(o=i.read())!==null;)await this.gb(t,a,o,o.byteLength,n,0),n+=o.byteLength}async gb(t,a,i,n,o,h){let f=0;for(;f<n;){const R=await t.write(a,o+f,i.buffer,h+f,n-f);f+=R}}async hb(t,a,i,n){return this.cb.queueFor(a,()=>this.ib(t,a,i,n),this.R(t).providerExtUri)}async ib(t,a,i,n){let o;n instanceof C.$Oe?o=n:(0,l.$Ae)(n)?o=await(0,C.$1e)(n):(0,l.$Be)(n)?o=await(0,C.$2e)(n):o=(0,C.$Ye)(n),await t.writeFile(a,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(t,a,i,n){return this.cb.queueFor(n,()=>this.kb(t,a,i,n),this.R(i).providerExtUri)}async kb(t,a,i,n){let o,h;try{o=await t.open(a,{create:!1}),h=await i.open(n,{create:!0,unlock:!1});const f=C.$Oe.alloc(this.a);let R=0,L=0,E=0;do E=await t.read(o,R,f.buffer,L,f.byteLength-L),await this.gb(i,h,f,E,R,L),R+=E,L+=E,L===f.byteLength&&(L=0);while(E>0)}catch(f){throw(0,v.$nl)(f)}finally{await c.Promises.settled([typeof o=="number"?t.close(o):Promise.resolve(),typeof h=="number"?i.close(h):Promise.resolve()])}}async lb(t,a,i,n){return this.cb.queueFor(n,()=>this.mb(t,a,i,n),this.R(i).providerExtUri)}async mb(t,a,i,n){return i.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(t,a,i,n){return this.cb.queueFor(n,()=>this.ob(t,a,i,n),this.R(i).providerExtUri)}async ob(t,a,i,n){const o=await i.open(n,{create:!0,unlock:!1});try{const h=await t.readFile(a);await this.gb(i,o,C.$Oe.wrap(h),h.byteLength,0,0)}catch(h){throw(0,v.$nl)(h)}finally{await i.close(o)}}async pb(t,a,i,n){const o=await(0,C.$1e)(this.H(t,a,O.CancellationToken.None));await this.hb(i,n,void 0,o)}qb(t,a){if(t.capabilities&v.FileSystemProviderCapabilities.Readonly)throw new v.$ul((0,b.localize)(25,null,this.sb(a)),v.FileOperationResult.FILE_PERMISSION_DENIED);return t}rb(t,a){if((a.permissions??0)&v.FilePermission.Readonly)throw new v.$ul((0,b.localize)(26,null,this.sb(t)),v.FileOperationResult.FILE_PERMISSION_DENIED)}sb(t){return t.scheme===m.Schemas.file?t.fsPath:t.toString(!0)}};e.$Zq=s,e.$Zq=s=g=ve([Q(0,p.$_j)],s)}),define(ce[211],le([0,1,6,35,15,3,42,2,14,5,21,51,31,172,7,100,209,206,205]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class I extends v.$_q{static{this.L=!1}constructor(s,r){super(s,r),this.onDidChangeCapabilities=O.Event.None,this.P=new c.$Cc(t=>S.$0g.getComparisonKey(t)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=l.FileSystemProviderCapabilities.FileReadWrite|l.FileSystemProviderCapabilities.FileOpenReadWriteClose|l.FileSystemProviderCapabilities.FileReadStream|l.FileSystemProviderCapabilities.FileFolderCopy|l.FileSystemProviderCapabilities.FileWriteUnlock|l.FileSystemProviderCapabilities.FileAtomicRead|l.FileSystemProviderCapabilities.FileAtomicWrite|l.FileSystemProviderCapabilities.FileAtomicDelete|l.FileSystemProviderCapabilities.FileClone,w.$k&&(this.M|=l.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(s){try{const{stat:r,symbolicLink:t}=await u.SymlinkSupport.stat(this.I(s));return{type:this.O(r,t),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:l.FilePermission.Locked}}catch(r){throw this.hb(r)}}async N(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const r=await u.Promises.readdir(this.I(s),{withFileTypes:!0}),t=[];return await Promise.all(r.map(async a=>{try{let i;a.isSymbolicLink()?i=(await this.stat((0,S.$gh)(s,a.name))).type:i=this.O(a),t.push([a.name,i])}catch(i){this.a.trace(i)}})),t}catch(r){throw this.hb(r)}}O(s,r){let t;return r?.dangling?t=l.FileType.Unknown:s.isFile()?t=l.FileType.File:s.isDirectory()?t=l.FileType.Directory:t=l.FileType.Unknown,r&&(t|=l.FileType.SymbolicLink),t}async Q(s){const r=this.I(s);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let t;for(;t=this.P.get(s);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await t.wait();const a=new P.$Eh;return this.P.set(s,a),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,k.$Uc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.P.get(s)===a&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.P.delete(s)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),a.open()})}async readFile(s,r){let t;try{r?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),t=await this.Q(s));const a=this.I(s);return await u.Promises.readFile(a)}catch(a){throw this.hb(a)}finally{t?.dispose()}}R(s){I.L&&this.a.trace(s)}readFileStream(s,r,t){const a=(0,m.$Ce)(i=>C.$Oe.concat(i.map(n=>C.$Oe.wrap(n))).buffer);return(0,b.$Yq)(this,s,a,i=>i.buffer,{...r,bufferSize:256*1024},t),a}async writeFile(s,r,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.S(s)?this.U(s,(0,S.$gh)((0,S.$fh)(s),`${(0,S.$dh)(s)}${t.atomic.postfix}`),r,t):this.W(s,r,t)}async S(s){try{const r=this.I(s),{symbolicLink:t}=await u.SymlinkSupport.stat(r);if(t)return!1}catch{}return!0}async U(s,r,t,a){const i=new k.$Vc;try{i.add(await this.Q(s)),i.add(await this.Q(r)),await this.W(r,t,a,!0);try{await this.rename(r,s,{overwrite:!0})}catch(n){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw n}}finally{i.dispose()}}async W(s,r,t,a){let i;try{const n=this.I(s);if(!t.create||!t.overwrite){if(await u.Promises.exists(n)){if(!t.overwrite)throw(0,l.$ml)((0,$.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,l.$ml)((0,$.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}i=await this.open(s,{create:!0,unlock:t.unlock},a),await this.write(i,0,r,0,r.byteLength)}catch(n){throw await this.ib(s,n)}finally{typeof i=="number"&&await this.close(i)}}static{this.$=!0}static configureFlushOnWrite(s){I.$=s}async open(s,r,t){const a=this.I(s);let i;(0,l.$al)(r)&&!t&&(i=await this.Q(s));let n;try{if((0,l.$al)(r)&&r.unlock)try{const{stat:h}=await u.SymlinkSupport.stat(a);h.mode&128||await u.Promises.chmod(a,h.mode|128)}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}let o;if((0,l.$al)(r)){if(w.$i)try{await u.Promises.truncate(a,0),o="r+"}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}o||(o="w")}else o="r";n=await u.Promises.open(a,o)}catch(o){throw i?.dispose(),(0,l.$al)(r)?await this.ib(s,o):this.hb(o)}if(this.X.set(n,0),(0,l.$al)(r)&&this.Z.set(n,s),i){const o=this.Y.get(n);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${n} (${a})`),this.Y.set(n,i),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${n} (${a})`),o.dispose())}return n}async close(s){const r=this.Y.get(s);try{if(this.X.delete(s),this.Z.delete(s)&&I.$)try{await u.Promises.fdatasync(s)}catch(t){I.configureFlushOnWrite(!1),this.a.error(t)}return await u.Promises.close(s)}catch(t){throw this.hb(t)}finally{r&&(this.Y.get(s)===r&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.Y.delete(s)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),r.dispose())}}async read(s,r,t,a,i){const n=this.ab(s,r);let o=null;try{o=(await u.Promises.read(s,t,a,i,n)).bytesRead}catch(h){throw this.hb(h)}finally{this.bb(s,n,o)}return o}ab(s,r){return r===this.X.get(s)?null:r}bb(s,r,t){const a=this.X.get(s);typeof a=="number"&&(typeof r=="number"||(typeof t=="number"?this.X.set(s,a+t):this.X.delete(s)))}async write(s,r,t,a,i){return(0,P.$Zh)(()=>this.cb(s,r,t,a,i),100,3)}async cb(s,r,t,a,i){const n=this.ab(s,r);let o=null;try{o=(await u.Promises.write(s,t,a,i,n)).bytesWritten}catch(h){throw await this.ib(this.Z.get(s),h)}finally{this.bb(s,n,o)}return o}async mkdir(s){try{await u.Promises.mkdir(this.I(s))}catch(r){throw this.hb(r)}}async delete(s,r){try{const t=this.I(s);if(r.recursive){let a;r?.atomic!==!1&&r.atomic.postfix&&(a=(0,A.$lc)((0,A.$oc)(t),`${(0,A.$pc)(t)}${r.atomic.postfix}`)),await u.Promises.rm(t,u.RimRafMode.MOVE,a)}else try{await u.Promises.unlink(t)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let i=!1;try{const{stat:n,symbolicLink:o}=await u.SymlinkSupport.stat(t);i=n.isDirectory()&&!o}catch{}if(i)await u.Promises.rmdir(t);else throw a}else throw a}}catch(t){throw this.hb(t)}}async rename(s,r,t){const a=this.I(s),i=this.I(r);if(a!==i)try{await this.db(s,r,"move",t.overwrite),await u.Promises.rename(a,i)}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,$.localize)(2,null,(0,A.$pc)(a),(0,A.$pc)((0,A.$oc)(i)),n.toString()))),this.hb(n)}}async copy(s,r,t){const a=this.I(s),i=this.I(r);if(a!==i)try{await this.db(s,r,"copy",t.overwrite),await u.Promises.copy(a,i,{preserveSymlinks:!0})}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,$.localize)(3,null,(0,A.$pc)(a),(0,A.$pc)((0,A.$oc)(i)),n.toString()))),this.hb(n)}}async db(s,r,t,a){const i=this.I(s),n=this.I(r);let o=!1;if(!!(this.capabilities&l.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,T.$Dg)(i,n,!0)),o){if(t==="copy")throw(0,l.$ml)((0,$.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const f=await this.N(s);if(!f)throw(0,l.$ml)((0,$.localize)(5,null),l.FileSystemProviderErrorCode.FileNotFound);const R=await this.N(r);if(R){if(!a)throw(0,l.$ml)((0,$.localize)(6,null),l.FileSystemProviderErrorCode.FileExists);f.type&l.FileType.File&&R.type&l.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,r){return this.eb(s,r,!1)}async eb(s,r,t){const a=this.I(s),i=this.I(r),n=!!(this.capabilities&l.FileSystemProviderCapabilities.PathCaseSensitive);if((0,T.$Dg)(a,i,!n))return;const o=new k.$Vc;try{o.add(await this.Q(s)),o.add(await this.Q(r)),t&&await u.Promises.mkdir((0,A.$oc)(i),{recursive:!0}),await u.Promises.copyFile(a,i)}catch(h){if(h.code==="ENOENT"&&!t)return this.eb(s,r,!0);throw this.hb(h)}finally{o.dispose()}}t(s,r,t){return new d.$gr(a=>s(a),a=>r(a),t)}F(s,r,t){return new p.$pr(a=>s(a),a=>r(a),t)}hb(s){if(s instanceof l.$ll)return s;let r=s,t;switch(s.code){case"ENOENT":t=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=l.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=l.FileSystemProviderErrorCode.Unknown;break;default:t=l.FileSystemProviderErrorCode.Unknown}return(0,l.$ml)(r,t)}async ib(s,r){let t=this.hb(r);if(s&&t.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await u.SymlinkSupport.stat(this.I(s));a.mode&128||(t=(0,l.$ml)(r,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return t}}e.$qr=I}),define(ce[102],le([0,1,3,2,4,10]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=e.$Bhc=void 0,e.$Bhc=(0,C.$Fi)("sharedProcessLifecycleService");let T=class extends c.$Wc{constructor(A){super(),this.b=A,this.a=this.B(new P.$me),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Chc=T,e.$Chc=T=ve([Q(0,O.$_j)],T)}),define(ce[212],le([0,1,9,3,10,2]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=e.$qs=void 0;class T extends C.$kk{constructor(m,u,$,l,b){super(u,$,l),this.r=m,this.t=b,this.B(b.listen("onDidChangeLogLevel",m)(v=>{(0,C.$bk)(v)?super.setLogLevel(v):super.setLogLevel(P.URI.revive(v[0]),v[1])})),this.B(b.listen("onDidChangeVisibility",m)(([v,d])=>super.setVisibility(P.URI.revive(v),d))),this.B(b.listen("onDidChangeLoggers",m)(({added:v,removed:d})=>{for(const p of v)super.registerLogger({...p,resource:P.URI.revive(p.resource)});for(const p of d)super.deregisterLogger(p.resource)}))}createConsoleMainLogger(){return new C.$ik({log:(m,u)=>{this.t.call("consoleLog",[m,u])}})}registerLogger(m){super.registerLogger(m),this.t.call("registerLogger",[m,this.r])}deregisterLogger(m){super.deregisterLogger(m),this.t.call("deregisterLogger",[m,this.r])}setLogLevel(m,u){super.setLogLevel(m,u),this.t.call("setLogLevel",[m,u])}setVisibility(m,u){super.setVisibility(m,u),this.t.call("setVisibility",[this.n(m),u])}s(m,u,$){return new k(this.t,m,u,$,this.r)}static setLogLevel(m,u,$){return m.call("setLogLevel",[u,$])}}e.$qs=T;class k extends C.$fk{constructor(m,u,$,l,b){super(l?.logLevel==="always"),this.r=m,this.s=u,this.m=!1,this.n=[],this.setLevel($),this.r.call("createLogger",[u,l,b]).then(()=>{this.u(this.n),this.m=!0})}g(m,u){const $=[[m,u]];this.m?this.u($):this.n.push(...$)}u(m){this.r.call("log",[this.s,m])}}class A{constructor(m,u){this.a=m,this.b=u}listen(m,u){const $=this.b(m);switch(u){case"onDidChangeLoggers":return c.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(b=>this.c(b,$)),removed:[...l.removed].map(b=>this.c(b,$))}));case"onDidChangeVisibility":return c.Event.map(this.a.onDidChangeVisibility,l=>[$.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return c.Event.map(this.a.onDidChangeLogLevel,l=>(0,C.$bk)(l)?l:[$.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${u}`)}async call(m,u,$){const l=this.b(m);switch(u){case"setLogLevel":return(0,C.$bk)($[0])?this.a.setLogLevel($[0]):this.a.setLogLevel(P.URI.revive(l.transformIncoming($[0][0])),$[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,l)))}throw new Error(`Call not found: ${u}`)}c(m,u){return{...m,resource:u.transformOutgoingURI(m.resource)}}}e.$rs=A;class w extends O.$Wc{constructor(m,u){super(),u.call("setLogLevel",[m.getLogLevel()]),this.B(m.onDidChangeLogLevel($=>u.call("setLogLevel",[$]))),u.call("getRegisteredLoggers").then($=>{for(const l of $)m.registerLogger({...l,resource:P.URI.revive(l.resource)})}),this.B(u.listen("onDidChangeVisibility")(([$,l])=>m.setVisibility(P.URI.revive($),l))),this.B(u.listen("onDidChangeLoggers")(({added:$,removed:l})=>{for(const b of $)m.registerLogger({...b,resource:P.URI.revive(b.resource)});for(const b of l)m.deregisterLogger(b.resource)}))}}e.$ss=w}),define(ce[213],le([0,1,2,10]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class C extends P.$Wc{constructor(T,k=[]){super(),this.a=new c.$jk([T,...k]),this.B(T.onDidChangeLogLevel(A=>this.setLevel(A)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...k){this.a.trace(T,...k)}debug(T,...k){this.a.debug(T,...k)}info(T,...k){this.a.info(T,...k)}warn(T,...k){this.a.warn(T,...k)}error(T,...k){this.a.error(T,...k)}flush(){this.a.flush()}}e.$oR=C}),define(ce[58],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=void 0,e.$Cfc=(0,P.$Fi)("nativeHostService")}),define(ce[214],le([0,1,43,57]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;let C=class{constructor(T,k){return this.windowId=T,P.ProxyChannel.toService(k.getChannel("nativeHost"),{context:T,properties:(()=>{const A=new Map;return A.set("windowId",T),A})()})}};e.$Xgc=C,e.$Xgc=C=ve([Q(1,c.$Ugc)],C)}),define(ce[59],le([0,1,3,64,2,4]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=void 0,e.$so=(0,O.$Fi)("policy");class T extends C.$Wc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$me),this.onDidChange=this.h.event}async updatePolicyDefinitions(w){const S=Object.keys(this.f).length;return this.f={...w,...this.f},S!==Object.keys(this.f).length&&await this.j(w),c.Iterable.reduce(this.g.entries(),(m,[u,$])=>({...m,[u]:$}),{})}getPolicyValue(w){return this.g.get(w)}serialize(){return c.Iterable.reduce(Object.entries(this.f),(w,[S,m])=>({...w,[S]:{definition:m,value:this.g.get(S)}}),{})}}e.$to=T;class k{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$uo=k}),define(ce[215],le([0,1,3,2,59]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=e.$ogc=void 0;class O{constructor(A){this.b=A,this.a=new c.$Vc}listen(A,w){switch(w){case"onDidChange":return P.Event.map(this.b.onDidChange,S=>S.reduce((m,u)=>({...m,[u]:this.b.getPolicyValue(u)??null}),{}),this.a)}throw new Error(`Event not found: ${w}`)}call(A,w,S){switch(w){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(S)}throw new Error(`Call not found: ${w}`)}dispose(){this.a.dispose()}}e.$ogc=O;class T extends C.$to{constructor(A,w){super(),this.a=w;for(const S in A){const{definition:m,value:u}=A[S];this.f[S]=m,u!==void 0&&this.g.set(S,u)}this.a.listen("onDidChange")(S=>{for(const m in S){const u=S[m];u===null?this.g.delete(m):this.g.set(m,u)}this.h.fire(Object.keys(S))})}async j(A){const w=await this.a.call("updatePolicyDefinitions",A);for(const S in w)this.g.set(S,w[S])}}e.$pgc=T}),define(ce[103],le([0,1,37]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let c;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.context<"u"){const O=C.context.configuration();if(O)c=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(c=globalThis._VSCODE_PRODUCT_JSON,P.env.VSCODE_DEV&&Object.assign(c,{nameShort:`${c.nameShort} Dev`,nameLong:`${c.nameLong} Dev`,dataFolderName:`${c.dataFolderName}-dev`,serverDataFolderName:c.serverDataFolderName?`${c.serverDataFolderName}-dev`:void 0}),!c.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(c,{version:O.version})}}else c={},Object.keys(c).length===0&&Object.assign(c,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=c}),define(ce[24],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,P.$Fi)("productService"),e.$tk="vscode://schemas/vscode-product"}),define(ce[216],le([0,1,6,8,2,14,31,10,24]),function(ne,e,P,c,C,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;let w=class extends C.$Wc{constructor(m,u,$){super(),this.b=u,this.c=$,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,m&&this.B(new P.$Rh(()=>{this.f(m)},3e4)).schedule()}async f(m){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const u=Date.now(),$=(0,O.$oc)(m),l=(0,O.$pc)(m),b=await T.Promises.readdir($);await Promise.all(b.map(async v=>{if(v===l)return;const d=(0,O.$lc)($,v),p=await T.Promises.stat(d);if(p.isDirectory()&&u-p.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),T.Promises.rm(d)}))}catch(u){(0,c.$3)(u)}}};e.$_gc=w,e.$_gc=w=ve([Q(1,A.$sk),Q(2,k.$_j)],w)}),define(ce[217],le([0,1,6,8,2,14,31,16,10,24]),function(ne,e,P,c,C,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;let S=class extends C.$Wc{constructor(u,$,l){super(),this.b=u,this.c=$,this.f=l,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new P.$Rh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const u=Object.create(null),$=JSON.parse(await T.Promises.readFile((0,O.$lc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const p of Object.keys($)){const I=$[p];u[`${I.hash}.${p}`]=!0}const l=(0,O.$lc)(this.b.userDataPath,"clp");if(!await T.Promises.exists(l))return;const v=await T.Promises.readdir(l);for(const p of v){if(u[p]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${p}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${p}`),await T.Promises.rm((0,O.$lc)(l,p))}const d=Date.now();for(const p of Object.keys(u)){const I=(0,O.$lc)(l,p),g=await T.Promises.readdir(I);for(const s of g){if(s==="tcf.json")continue;const r=(0,O.$lc)(I,s),t=await T.Promises.stat(r);t.isDirectory()&&d-t.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,O.$lc)(p,s)}`),await T.Promises.rm(r))}}}catch(u){(0,c.$3)(u)}}};e.$ahc=S,e.$ahc=S=ve([Q(0,k.$Ni),Q(1,A.$_j),Q(2,w.$sk)],S)}),define(ce[218],le([0,1,14,4]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$NG=void 0,e.$NG=(0,c.$Fi)("IV8InspectProfilingService");var C;(function(O){function T(A){return!!(A.samples&&A.timeDeltas)}O.isValidProfile=T;function k(A,w="noAbsolutePaths"){for(const S of A.nodes)S.callFrame&&S.callFrame.url&&((0,P.$kc)(S.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(S.callFrame.url))&&(S.callFrame.url=(0,P.$lc)(w,(0,P.$pc)(S.callFrame.url)));return A}O.rewriteAbsolutePaths=k})(C||(e.Utils=C={}))}),define(ce[219],le([0,1,32]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;class c{constructor(){this.a=new Map}async startProfiling(O){const k=await(await new Promise((w,S)=>{ne(["v8-inspect-profiler"],w,S)}).then(Oe)).startProfiling({host:O.host,port:O.port,checkForPaused:!0}),A=(0,P.$2g)();return this.a.set(A,k),A}async stopProfiling(O){const T=this.a.get(O);if(!T)throw new Error(`UNKNOWN session '${O}'`);const k=await T.stop();return this.a.delete(O),k.profile}}e.$rhc=c}),define(ce[44],le([0,1,132,13]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,P=Oe(P),c=Oe(c);class C{constructor(){this.a=new Map}add(T,k){P.ok(c.$fg(T)),P.ok(c.$hg(k)),P.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,k)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$qo=new C}),define(ce[104],le([0,1,3,44]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,c=Oe(c),e.$ro={JSONContribution:"base.contributions.json"};function C(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class O{constructor(){this.b=new P.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(A,w){this.a[C(A)]=w,this.b.fire(A)}notifySchemaChanged(A){this.b.fire(A)}getSchemaContributions(){return{schemas:this.a}}}const T=new O;c.$qo.add(e.$ro.JSONContribution,T)}),define(ce[48],le([0,1,19,3,13,159,22,104,44]),function(ne,e,P,c,C,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.ConfigurationScope=e.$vo=e.EditPresentationTypes=void 0,e.$Go=b,e.$Ho=v,e.$Io=d,e.$Jo=I,e.$Ko=g,C=Oe(C),O=Oe(O);var w;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$vo={Configuration:"base.contributions.configuration"};var S;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co="vscode://schemas/settings/resourceLanguage",e.$Do="vscode://schemas/settings/configurationDefaults";const m=A.$qo.as(k.$ro.JSONContribution);class u{constructor(){this.h=new Set,this.i=new c.$me,this.onDidSchemaChange=this.i.event,this.j=new c.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},m.registerSchema(e.$Co,this.g),this.v()}registerConfiguration(r,t=!0){this.registerConfigurations([r],t)}registerConfigurations(r,t=!0){const a=new Set;this.n(r,t,a),m.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(r){const t=new Set;this.o(r,t),m.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:t})}updateConfigurations({add:r,remove:t}){const a=new Set;this.o(t,a),this.n(r,!1,a),m.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(r){const t=new Set;this.k(r,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:!0})}k(r,t){const a=[];for(const{overrides:i,source:n}of r)for(const o in i)if(t.add(o),e.$Fo.test(o)){const h=this.a.get(o),f=h?.valuesSources??new Map;if(n)for(const y of Object.keys(i[o]))f.set(y,n);const R={...h?.value||{},...i[o]};this.a.set(o,{source:n,value:R,valuesSources:f});const L=(0,T.$jj)(o),E={type:"object",default:R,description:O.localize(1,null,L),$ref:e.$Co,defaultDefaultValue:R,source:C.$fg(n)?void 0:n,defaultValueSource:n};a.push(...b(o)),this.d[o]=E,this.b.properties[o]=E}else{this.a.set(o,{value:i[o],source:n});const h=this.d[o];h&&(this.w(o,h),this.r(o,h))}this.m(a)}deregisterDefaultConfigurations(r){const t=new Set;this.l(r,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:!0})}l(r,t){for(const{overrides:a,source:i}of r)for(const n in a){const o=this.a.get(n),h=C.$fg(i)?i:i?.id,f=C.$fg(o?.source)?o?.source:o?.source?.id;if(h===f)if(t.add(n),this.a.delete(n),e.$Fo.test(n))delete this.d[n],delete this.b.properties[n];else{const R=this.d[n];R&&(this.w(n,R),this.r(n,R))}}this.u()}deltaConfiguration(r){let t=!1;const a=new Set;r.removedDefaults&&(this.l(r.removedDefaults,a),t=!0),r.addedDefaults&&(this.k(r.addedDefaults,a),t=!0),r.removedConfigurations&&this.o(r.removedConfigurations,a),r.addedConfigurations&&this.n(r.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const t of r)this.h.add(t);this.u()}n(r,t,a){r.forEach(i=>{this.p(i,t,i.extensionInfo,i.restrictedProperties,void 0,a),this.c.push(i),this.q(i)})}o(r,t){const a=i=>{if(i.properties)for(const n in i.properties){t.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>a(n))};for(const i of r){a(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(r,t=!0,a,i,n=S.WINDOW,o){n=C.$og(r.scope)?n:r.scope;const h=r.properties;if(h)for(const R in h){const L=h[R];if(t&&I(R,L)){delete h[R];continue}if(L.source=a,L.defaultDefaultValue=h[R].default,this.w(R,L),e.$Fo.test(R)?L.scope=void 0:(L.scope=C.$og(L.scope)?n:L.scope,L.restricted=C.$og(L.restricted)?!!i?.includes(R):L.restricted),h[R].hasOwnProperty("included")&&!h[R].included){this.f[R]=h[R],delete h[R];continue}else this.d[R]=h[R],h[R].policy?.name&&this.e.set(h[R].policy.name,R);!h[R].deprecationMessage&&h[R].markdownDeprecationMessage&&(h[R].deprecationMessage=h[R].markdownDeprecationMessage),o.add(R)}const f=r.allOf;if(f)for(const R of f)this.p(R,t,a,i,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const t=a=>{const i=a.properties;if(i)for(const o in i)this.r(o,i[o]);a.allOf?.forEach(t)};t(r)}r(r,t){switch(e.$wo.properties[r]=t,t.scope){case S.APPLICATION:e.$xo.properties[r]=t;break;case S.MACHINE:e.$yo.properties[r]=t;break;case S.MACHINE_OVERRIDABLE:e.$zo.properties[r]=t;break;case S.WINDOW:e.$Ao.properties[r]=t;break;case S.RESOURCE:e.$Bo.properties[r]=t;break;case S.LANGUAGE_OVERRIDABLE:e.$Bo.properties[r]=t,this.g.properties[r]=t;break}}s(r,t){switch(delete e.$wo.properties[r],t.scope){case S.APPLICATION:delete e.$xo.properties[r];break;case S.MACHINE:delete e.$yo.properties[r];break;case S.MACHINE_OVERRIDABLE:delete e.$zo.properties[r];break;case S.WINDOW:delete e.$Ao.properties[r];break;case S.RESOURCE:case S.LANGUAGE_OVERRIDABLE:delete e.$Bo.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const t=`[${r}]`,a={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$Co};this.w(t,a),e.$wo.properties[t]=a,e.$xo.properties[t]=a,e.$yo.properties[t]=a,e.$zo.properties[t]=a,e.$Ao.properties[t]=a,e.$Bo.properties[t]=a}}v(){const r={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$Co};e.$wo.patternProperties[e.$Eo]=r,e.$xo.patternProperties[e.$Eo]=r,e.$yo.patternProperties[e.$Eo]=r,e.$zo.patternProperties[e.$Eo]=r,e.$Ao.patternProperties[e.$Eo]=r,e.$Bo.patternProperties[e.$Eo]=r,this.i.fire()}w(r,t){const a=this.a.get(r);let i=a?.value,n=a?.source;C.$mg(i)&&(i=t.defaultDefaultValue,n=void 0),C.$mg(i)&&(i=d(t.type)),t.default=i,t.defaultValueSource=n}}const $="\\[([^\\]]+)\\]",l=new RegExp($,"g");e.$Eo=`^(${$})+$`,e.$Fo=new RegExp(e.$Eo);function b(s){const r=[];if(e.$Fo.test(s)){let t=l.exec(s);for(;t?.length;){const a=t[1].trim();a&&r.push(a),t=l.exec(s)}}return(0,P.$Ob)(r)}function v(s){return s.reduce((r,t)=>`${r}[${t}]`,"")}function d(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const p=new u;A.$qo.add(e.$vo.Configuration,p);function I(s,r){return s.trim()?e.$Fo.test(s)?O.localize(7,null,s):p.getConfigurationProperties()[s]!==void 0?O.localize(8,null,s):r.policy?.name&&p.getPolicyConfigurations().get(r.policy?.name)!==void 0?O.localize(9,null,s,r.policy?.name,p.getPolicyConfigurations().get(r.policy?.name)):null:O.localize(6,null)}function g(){const s=[],r=p.getConfigurationProperties();for(const t of Object.keys(r))s.push([t,r[t].scope]);return s.push(["launch",S.RESOURCE]),s.push(["task",S.RESOURCE]),s}}),define(ce[78],le([0,1,19,3,34,2,35,30,13,9,22,48,7,44]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0,e.$Po=g,P=Oe(P),C=Oe(C),k=Oe(k),A=Oe(A);function l(a){return Object.isFrozen(a)?a:k.$eo(a)}class b{static createEmptyModel(i){return new b({},[],[],void 0,i)}constructor(i,n,o,h,f){this.b=i,this.c=n,this.d=o,this.raw=h,this.f=f,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof b)return n;const o=new v("",this.f);return o.parseRaw(n),o.configurationModel});this.g=i.reduce((n,o)=>o===n?o:n.merge(o),i[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,S.$hj)(this.contents,i):this.contents}inspect(i,n){const o=this;return{get value(){return l(o.rawConfiguration.getValue(i))},get override(){return n?l(o.rawConfiguration.getOverrideValue(i,n)):void 0},get merged(){return l(n?o.rawConfiguration.override(n).getValue(i):o.rawConfiguration.getValue(i))},get overrides(){const h=[];for(const{contents:f,identifiers:R,keys:L}of o.rawConfiguration.overrides){const E=new b(f,L,[],void 0,o.f).getValue(i);E!==void 0&&h.push({identifiers:R,value:E})}return h.length?l(h):void 0}}}getOverrideValue(i,n){const o=this.j(n);return o?i?(0,S.$hj)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const o of this.overrides)o.identifiers.includes(i)&&n.push(...o.keys);return P.$Ob(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return P.$Ob(i)}override(i){let n=this.a.get(i);return n||(n=this.h(i),this.a.set(i,n)),n}merge(...i){const n=k.$do(this.contents),o=k.$do(this.overrides),h=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const R of i)if(f.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.i(n,R.contents);for(const L of R.overrides){const[E]=o.filter(y=>P.$wb(y.identifiers,L.identifiers));E?(this.i(E.contents,L.contents),E.keys.push(...L.keys),E.keys=P.$Ob(E.keys)):o.push(k.$do(L))}for(const L of R.keys)h.indexOf(L)===-1&&h.push(L)}return new b(n,h,o,f.every(R=>R instanceof b)?void 0:f,this.f)}h(i){const n=this.j(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const h of P.$Ob([...Object.keys(this.contents),...Object.keys(n)])){let f=this.contents[h];const R=n[h];R&&(typeof f=="object"&&typeof R=="object"?(f=k.$do(f),this.i(f,R)):f=R),o[h]=f}return new b(o,this.keys,this.overrides,void 0,this.f)}i(i,n){for(const o of Object.keys(n)){if(o in i&&A.$hg(i[o])&&A.$hg(n[o])){this.i(i[o],n[o]);continue}i[o]=k.$do(n[o])}}j(i){let n=null,o=null;const h=f=>{f&&(o?this.i(o,f):o=k.$do(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===i?n=f.contents:f.identifiers.includes(i)&&h(f.contents);return h(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.k(i,n,!0)}setValue(i,n){this.k(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,S.$gj)(this.contents,i),m.$Fo.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>P.$wb(o.identifiers,(0,m.$Go)(i))),1))}k(i,n,o){(0,S.$fj)(this.contents,i,n,h=>this.f.error(h)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),m.$Fo.test(i)&&this.overrides.push({identifiers:(0,m.$Go)(i),keys:Object.keys(this.contents[i]),contents:(0,S.$ej)(this.contents[i],h=>this.f.error(h))})}}e.$Lo=b;class v{constructor(i,n){this.f=i,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||b.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!A.$og(i)){const o=this.h(i);this.parseRaw(o,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:o,keys:h,overrides:f,restricted:R,hasExcludedProperties:L}=this.i(i,n);this.b=new b(o,h,f,L?[i]:void 0,this.g),this.c=R||[]}h(i){let n={},o=null,h=[];const f=[],R=[];function L(y){Array.isArray(h)?h.push(y):o!==null&&(h[o]=y)}const E={onObjectBegin:()=>{const y={};L(y),f.push(h),h=y,o=null},onObjectProperty:y=>{o=y},onObjectEnd:()=>{h=f.pop()},onArrayBegin:()=>{const y=[];L(y),f.push(h),h=y,o=null},onArrayEnd:()=>{h=f.pop()},onLiteralValue:L,onError:(y,N,F)=>{R.push({error:y,offset:N,length:F})}};if(i)try{C.$5n(i,E),n=h[0]||{}}catch(y){this.g.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return n}i(i,n){const o=$.$qo.as(m.$vo.Configuration).getConfigurationProperties(),h=this.j(i,o,!0,n);i=h.raw;const f=(0,S.$ej)(i,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),R=Object.keys(i),L=this.l(i,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:f,keys:R,overrides:L,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}j(i,n,o,h){let f=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:f};const R={},L=[];for(const E in i)if(m.$Fo.test(E)&&o){const y=this.j(i[E],n,!1,h);R[E]=y.raw,f=f||y.hasExcludedProperties,L.push(...y.restricted)}else{const y=n[E],N=y?typeof y.scope<"u"?y.scope:m.ConfigurationScope.WINDOW:void 0;y?.restricted&&L.push(E),!h.exclude?.includes(E)&&(h.include?.includes(E)||(N===void 0||h.scopes===void 0||h.scopes.includes(N))&&!(h.skipRestricted&&y?.restricted))?R[E]=i[E]:f=!0}return{raw:R,restricted:L,hasExcludedProperties:f}}l(i,n){const o=[];for(const h of Object.keys(i))if(m.$Fo.test(h)){const f={};for(const R in i[h])f[R]=i[h][R];o.push({identifiers:(0,m.$Go)(h),keys:Object.keys(f),contents:(0,S.$ej)(f,n)})}return o}}e.$Mo=v;class d extends O.$Wc{constructor(i,n,o,h,f){super(),this.c=i,this.f=n,this.g=h,this.h=f,this.b=this.B(new c.$me),this.onDidChange=this.b.event,this.a=new v(this.c.toString(),f),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(c.Event.any(c.Event.filter(this.g.onDidFilesChange,R=>R.contains(this.c)),c.Event.filter(this.g.onDidRunOperation,R=>(R.isOperation(u.FileOperation.CREATE)||R.isOperation(u.FileOperation.COPY)||R.isOperation(u.FileOperation.DELETE)||R.isOperation(u.FileOperation.WRITE))&&o.isEqual(R.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return b.createEmptyModel(this.h)}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$No=d;class p{constructor(i,n,o,h,f,R,L,E,y,N,F,D,M){this.a=i,this.b=n,this.c=o,this.overrideIdentifiers=h,this.d=f,this.f=R,this.g=L,this.h=E,this.i=y,this.j=N,this.k=F,this.l=D,this.m=M}get value(){return l(this.c)}n(i){return i?.value!==void 0||i?.override!==void 0||i?.overrides!==void 0?i:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class I{constructor(i,n,o,h,f,R,L,E,y,N){this.j=i,this.l=n,this.m=o,this.n=h,this.p=f,this.q=R,this.r=L,this.s=E,this.t=y,this.u=N,this.h=null,this.i=new T.$Cc,this.v=null}getValue(i,n,o){return this.w(i,n,o).getValue(i)}updateValue(i,n,o={}){let h;o.resource?(h=this.t.get(o.resource),h||(h=b.createEmptyModel(this.u),this.t.set(o.resource,h))):h=this.s,n===void 0?h.removeValue(i):h.setValue(i,n),o.resource||(this.h=null)}inspect(i,n,o){const h=this.w(i,n,o),f=this.A(n.resource,o),R=n.resource?this.t.get(n.resource)||this.s:this.s,L=new Set;for(const E of h.overrides)for(const y of E.identifiers)h.getOverrideValue(i,y)!==void 0&&L.add(y);return new p(i,n,h.getValue(i),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,f||void 0,R)}keys(i){const n=this.A(void 0,i);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.j=i,this.h=null,this.i.clear()}updatePolicyConfiguration(i){this.l=i}updateApplicationConfiguration(i){this.m=i,this.h=null,this.i.clear()}updateLocalUserConfiguration(i){this.n=i,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(i){this.p=i,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(i){this.q=i,this.h=null,this.i.clear()}updateFolderConfiguration(i,n){this.r.set(i,n),this.i.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this.i.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const o=[];if(!n){const{added:h,updated:f,removed:R}=r(this.j,i);n=[...h,...f,...R]}for(const h of n)for(const f of(0,m.$Go)(h)){const R=this.j.getKeysForOverrideIdentifier(f),L=i.getKeysForOverrideIdentifier(f),E=[...L.filter(y=>R.indexOf(y)===-1),...R.filter(y=>L.indexOf(y)===-1),...R.filter(y=>!k.$ho(this.j.override(f).getValue(y),i.override(f).getValue(y)))];o.push([f,E])}return this.updateDefaultConfiguration(i),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:o,removed:h}=r(this.l,i),f=[...n,...o,...h];return f.length&&this.updatePolicyConfiguration(i),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:o,removed:h,overrides:f}=r(this.applicationConfiguration,i),R=[...n,...o,...h];return R.length&&this.updateApplicationConfiguration(i),{keys:R,overrides:f}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:o,removed:h,overrides:f}=r(this.localUserConfiguration,i),R=[...n,...o,...h];return R.length&&this.updateLocalUserConfiguration(i),{keys:R,overrides:f}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:o,removed:h,overrides:f}=r(this.remoteUserConfiguration,i),R=[...n,...o,...h];return R.length&&this.updateRemoteUserConfiguration(i),{keys:R,overrides:f}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:o,removed:h,overrides:f}=r(this.workspaceConfiguration,i),R=[...n,...o,...h];return R.length&&this.updateWorkspaceConfiguration(i),{keys:R,overrides:f}}compareAndUpdateFolderConfiguration(i,n){const o=this.folderConfigurations.get(i),{added:h,updated:f,removed:R,overrides:L}=r(o,n),E=[...h,...f,...R];return(E.length||!o)&&this.updateFolderConfiguration(i,n),{keys:E,overrides:L}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:h,removed:f,overrides:R}=r(n,void 0);return{keys:[...o,...h,...f],overrides:R}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(i,n,o){let h=this.x(n,o);return n.overrideIdentifier&&(h=h.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(i)!==void 0&&(h=h.merge(this.l)),h}x({resource:i},n){let o=this.y();if(n&&i){const h=n.getFolder(i);h&&(o=this.z(h.uri)||o);const f=this.t.get(i);f&&(o=o.merge(f))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(i){let n=this.i.get(i);if(!n){const o=this.y(),h=this.r.get(i);h?(n=o.merge(h),this.i.set(i,n)):n=o}return n}A(i,n){if(n&&i){const o=n.getFolder(i);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((i,n)=>{const{contents:o,overrides:h,keys:f}=this.r.get(n);return i.push([n,{contents:o,overrides:h,keys:f}]),i},[])}}allKeys(){const i=new Set;return this.j.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.q.keys.forEach(n=>i.add(n)),this.r.forEach(n=>n.keys.forEach(o=>i.add(o))),[...i.values()]}B(){const i=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}D(i){const n=new Set;return this.j.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.q.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(h=>n.add(h))),[...n.values()]}static parse(i,n){const o=this.E(i.defaults,n),h=this.E(i.policy,n),f=this.E(i.application,n),R=this.E(i.user,n),L=this.E(i.workspace,n),E=i.folders.reduce((y,N)=>(y.set(w.URI.revive(N[0]),this.E(N[1],n)),y),new T.$Cc);return new I(o,h,f,R,b.createEmptyModel(n),L,E,b.createEmptyModel(n),new T.$Cc,n)}static E(i,n){return new b(i.contents,i.keys,i.overrides,void 0,n)}}e.$Oo=I;function g(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const h of a)h.keys.forEach(f=>i.add(f)),h.overrides.forEach(([f,R])=>{const L=(0,T.$zc)(n,f,new Set);R.forEach(E=>L.add(E))});const o=[];return n.forEach((h,f)=>o.push([f,[...h.values()]])),{keys:[...i.values()],overrides:o}}class s{constructor(i,n,o,h,f){this.change=i,this.f=n,this.g=o,this.h=h,this.i=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const R of i.keys)this.affectedKeys.add(R);for(const[,R]of i.overrides)for(const L of R)this.affectedKeys.add(L);this.d=this.a;for(const R of this.affectedKeys)this.d+=R+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=I.parse(this.f.data,this.i)),this.j}affectsConfiguration(i,n){const o=this.a+i,h=this.d.indexOf(o);if(h<0)return!1;const f=h+o.length;if(f>=this.d.length)return!1;const R=this.d.charCodeAt(f);if(R!==this.b&&R!==this.c)return!1;if(n){const L=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,E=this.g.getValue(i,n,this.h);return!k.$ho(L,E)}return!0}}e.$Qo=s;function r(a,i){const{added:n,removed:o,updated:h}=t(i?.rawConfiguration,a?.rawConfiguration),f=[],R=a?.getAllOverrideIdentifiers()||[],L=i?.getAllOverrideIdentifiers()||[];if(i){const E=L.filter(y=>!R.includes(y));for(const y of E)f.push([y,i.getKeysForOverrideIdentifier(y)])}if(a){const E=R.filter(y=>!L.includes(y));for(const y of E)f.push([y,a.getKeysForOverrideIdentifier(y)])}if(i&&a){for(const E of R)if(L.includes(E)){const y=t({contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});f.push([E,[...y.added,...y.removed,...y.updated]])}}return{added:n,removed:o,updated:h,overrides:f}}function t(a,i){const n=a?i?a.keys.filter(f=>i.keys.indexOf(f)===-1):[...a.keys]:[],o=i?a?i.keys.filter(f=>a.keys.indexOf(f)===-1):[...i.keys]:[],h=[];if(a&&i){for(const f of i.keys)if(a.keys.indexOf(f)!==-1){const R=(0,S.$hj)(i.contents,f),L=(0,S.$hj)(a.contents,f);k.$ho(R,L)||h.push(f)}}return{added:n,removed:o,updated:h}}}),define(ce[220],le([0,1,19,3,2,30,13,78,48,10,59,44]),function(ne,e,P,c,C,O,T,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.$Ro=void 0;class u extends C.$Wc{get configurationModel(){return this.b}constructor(v){super(),this.c=v,this.a=this.B(new c.$me),this.onDidChangeConfiguration=this.a.event,this.b=k.$Lo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(m.$qo.as(A.$vo.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:d})=>this.f(Array.from(v),d))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(v,d){this.j(v,m.$qo.as(A.$vo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:v})}g(){return{}}h(){this.b=k.$Lo.createEmptyModel(this.c);const v=m.$qo.as(A.$vo.Configuration).getConfigurationProperties();this.j(Object.keys(v),v)}j(v,d){const p=this.g();for(const I of v){const g=p[I],s=d[I];g!==void 0?this.b.addValue(I,g):s?this.b.addValue(I,s.default):this.b.removeValue(I)}}}e.$Ro=u;class ${constructor(){this.onDidChangeConfiguration=c.Event.None,this.configurationModel=k.$Lo.createEmptyModel(new w.$mk)}async initialize(){return this.configurationModel}}e.$So=$;let l=class extends C.$Wc{get configurationModel(){return this.b}constructor(v,d,p){super(),this.c=v,this.f=d,this.g=p,this.a=this.B(new c.$me),this.onDidChangeConfiguration=this.a.event,this.b=k.$Lo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.j(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.m(await this.h(v),!0))),this.b}async h(v){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",v);const d={},p=[],I=m.$qo.as(A.$vo.Configuration).getConfigurationProperties();for(const g of v){const s=I[g];if(!s){p.push(g);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.g.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}p.push(g),d[s.policy.name]={type:s.type}}}return(0,T.$sg)(d)||await this.f.updatePolicyDefinitions(d),p}j(v){this.g.trace("PolicyConfiguration#onDidChangePolicies",v);const d=m.$qo.as(A.$vo.Configuration).getPolicyConfigurations(),p=(0,P.$Jb)(v.map(I=>d.get(I)));this.m(p,!0)}m(v,d){this.g.trace("PolicyConfiguration#update",v);const p=m.$qo.as(A.$vo.Configuration).getConfigurationProperties(),I=[],g=this.b.isEmpty();for(const s of v){const r=p[s]?.policy?.name;if(r){const t=this.f.getPolicyValue(r);(g?t!==void 0:!(0,O.$ho)(this.b.getValue(s),t))&&I.push([s,t])}else this.b.getValue(s)!==void 0&&I.push([s,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const s=this.b;this.b=k.$Lo.createEmptyModel(this.g);for(const r of s.keys)this.b.setValue(r,s.getValue(r));for(const[r,t]of I)t===void 0?this.b.removeValue(r):this.b.setValue(r,t);d&&this.a.fire(this.b)}}};e.$To=l,e.$To=l=ve([Q(1,S.$so),Q(2,w.$_j)],l)}),define(ce[221],le([0,1,19,6,15,3,34,65,2,35,30,5,21,22,78,48,220,7,59]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=void 0;class I extends A.$Wc{constructor(r,t,a,i){super(),this.m=r,this.n=i,this.h=this.B(new O.$me),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$Ro(i)),this.c=a instanceof p.$uo?new v.$So:this.B(new v.$To(this.b,a,i)),this.f=this.B(new l.$No(this.m,{},u.$0g,t,i)),this.a=new l.$Oo(this.b.configurationModel,this.c.configurationModel,l.$Lo.createEmptyModel(i),l.$Lo.createEmptyModel(i),l.$Lo.createEmptyModel(i),l.$Lo.createEmptyModel(i),new w.$Cc,l.$Lo.createEmptyModel(i),new w.$Cc,i),this.j=new g(r,t,this),this.g=this.B(new c.$Rh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:o})=>this.s(n,o))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[r,t,a]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$Oo(r,t,l.$Lo.createEmptyModel(this.n),a,l.$Lo.createEmptyModel(this.n),l.$Lo.createEmptyModel(this.n),new w.$Cc,l.$Lo.createEmptyModel(this.n),new w.$Cc,this.n)}getConfigurationData(){return this.a.toData()}getValue(r,t){const a=typeof r=="string"?r:void 0,i=(0,$.$aj)(r)?r:(0,$.$aj)(t)?t:{};return this.a.getValue(a,i,void 0)}async updateValue(r,t,a,i,n){const o=(0,$.$bj)(a)?a:(0,$.$aj)(a)?{resource:a.resource,overrideIdentifiers:a.overrideIdentifier?[a.overrideIdentifier]:void 0}:void 0,h=o?i:a;if(h!==void 0&&h!==$.ConfigurationTarget.USER_LOCAL&&h!==$.ConfigurationTarget.USER)throw new Error(`Unable to write ${r} to target ${h}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,P.$Ob)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const f=this.inspect(r,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(f.policyValue!==void 0)throw new Error(`Unable to write ${r} because it is configured in system policy.`);if((0,S.$ho)(t,f.defaultValue)&&(t=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const L=o.overrideIdentifiers.sort(),E=this.a.localUserConfiguration.overrides.find(y=>(0,P.$wb)([...y.identifiers].sort(),L));E&&(o.overrideIdentifiers=E.identifiers)}const R=o?.overrideIdentifiers?.length?[(0,b.$Ho)(o.overrideIdentifiers),r]:[r];await this.j.write(R,t),await this.reloadConfiguration()}inspect(r,t={}){return this.a.inspect(r,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const r=await this.f.loadConfiguration();this.r(r)}r(r){const t=this.a.toData(),a=this.a.compareAndUpdateLocalUserConfiguration(r);this.u(a,t,$.ConfigurationTarget.USER)}s(r,t){const a=this.a.toData(),i=this.a.compareAndUpdateDefaultConfiguration(r,t);this.u(i,a,$.ConfigurationTarget.DEFAULT)}t(r){const t=this.a.toData(),a=this.a.compareAndUpdatePolicyConfiguration(r);this.u(a,t,$.ConfigurationTarget.DEFAULT)}u(r,t,a){const i=new l.$Qo(r,{data:t},this.a,void 0,this.n);i.source=a,this.h.fire(i)}}e.$Uo=I;class g{constructor(r,t,a){this.b=r,this.c=t,this.d=a,this.a=new c.$Mh}write(r,t){return this.a.queue(()=>this.e(r,t))}async e(r,t){let a;try{a=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===d.FileOperationResult.FILE_NOT_FOUND)a="{}";else throw o}const i=[];if((0,T.$Xn)(a,i,{allowTrailingComma:!0,allowEmptyContent:!0}),i.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(a,r,t);a=(0,k.$co)(a,n),await this.c.writeFile(this.b,C.$Oe.fromString(a))}f(r,t,a){const{tabSize:i,insertSpaces:n,eol:o}=this.h;if(!t.length){const h=JSON.stringify(a,null,n?" ".repeat(i):"	");return[{content:h,length:h.length,offset:0}]}return(0,k.$_n)(r,t,a,{tabSize:i,insertSpaces:n,eol:o})}get h(){if(!this.g){let r=m.OS===m.OperatingSystem.Linux||m.OS===m.OperatingSystem.Macintosh?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(r=t),this.g={eol:r,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ce[222],le([0,1,15,3,2,71]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$exb=e.$cxb=e.$bxb=void 0,e.$dxb=k;const T=(w,S,m)=>{const u=new Uint8Array(16);for(let b=0;b<16;b++)u[b]=Math.round(Math.random()*256);const $=(0,P.$9e)(P.$Oe.wrap(u));return[`GET ws://localhost${w}?${S}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${$}`].join(`\r
`)+`\r
\r
`};e.$bxb=T,e.$cxb=P.$Oe.fromString(`\r
\r
`);async function k(w,S,m,u,$){w.write(P.$Oe.fromString((0,e.$bxb)(S,m,u)));const l=new C.$Vc;try{return await new Promise((b,v)=>{let d;l.add(w.onData(p=>{d?d=P.$Oe.concat([d,p],d.byteLength+p.byteLength):d=p;const I=d.indexOf(e.$cxb);if(I===-1)return;b(w),w.pauseData();const g=d.slice(I+e.$cxb.byteLength);g.byteLength&&$.onData.fire(g)})),l.add(w.onClose(p=>v(p??new Error("socket closed")))),l.add(w.onEnd(()=>v(new Error("socket ended"))))})}catch(b){throw w.dispose(),b}finally{l.dispose()}}class A extends C.$Wc{constructor(S,m){super(),this.g=S,this.a=this.B(new c.$pe),this.onData=(...u)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...u)),this.b=this.B(new c.$me),this.onDidDispose=this.b.event,this.f=!1,this.B(m.onData),this.B(m.onData.event(u=>this.a.fire(u))),this.onClose=this.B(m.onClose).event,this.onEnd=this.B(m.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(S,m){O.SocketDiagnostics.traceSocketEvent(this,this.g,S,m)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$exb=A}),define(ce[105],le([0,1,8,4]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=w,e.$Ql=(0,c.$Fi)("remoteAuthorityResolverService");var C;(function(S){S[S.WebSocket=0]="WebSocket",S[S.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class O{constructor(m){this.id=m,this.type=C.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=O;class T{constructor(m,u){this.host=m,this.port=u,this.type=C.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=T;var k;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound",S.InvalidAuthority="InvalidAuthority"})(k||(e.RemoteAuthorityResolverErrorCode=k={}));class A extends P.$db{static isNotAvailable(m){return m instanceof A&&m._code===k.NotAvailable}static isTemporarilyNotAvailable(m){return m instanceof A&&m._code===k.TemporarilyNotAvailable}static isNoResolverFound(m){return m instanceof A&&m._code===k.NoResolverFound}static isInvalidAuthority(m){return m instanceof A&&m._code===k.InvalidAuthority}static isHandled(m){return m instanceof A&&m.isHandled}constructor(m,u=k.Unknown,$){super(m),this._message=m,this._code=u,this._detail=$,this.isHandled=u===k.NotAvailable&&$===!0,Object.setPrototypeOf(this,A.prototype)}}e.$Tl=A;function w(S){const m=S.indexOf("+");return m===-1?S:S.substring(0,m)}}),define(ce[223],le([0,1,6,15,26,8,3,2,23,101,55,32,71,105]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Zl=f,e.$1l=R,e.$2l=E,w=Oe(w);const l=30*1e3;var b;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function v(K){switch(K){case b.Management:return"Management";case b.ExtensionHost:return"ExtensionHost";case b.Tunnel:return"Tunnel"}}function d(K){const H=new C.$xe;return setTimeout(()=>H.cancel(),K),H.token}function p(K,H){if(K.isCancellationRequested||H.isCancellationRequested)return C.CancellationToken.Cancelled;const U=new C.$xe;return K.onCancellationRequested(()=>U.cancel()),H.onCancellationRequested(()=>U.cancel()),U.token}class I{get didTimeout(){return this.c==="timedout"}constructor(H){this.c="pending",this.d=new k.$Vc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,P.$yh)(),H.isCancellationRequested?this.h():this.d.add(H.onCancellationRequested(()=>this.h()))}registerDisposable(H){this.c==="pending"?this.d.add(H):H.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(H))}reject(H){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(H))}}function g(K,H){const U=new I(H);return U.registerDisposable(K.onControlMessage(Y=>{const B=JSON.parse(Y.toString()),j=z(B);j?U.reject(j):U.resolve(B)})),U.promise}function s(K,H,U,Y,B,j,_,ee){const X=new I(ee),oe=S.$ge.create(!1);return K.info(`Creating a socket (${_})...`),w.mark(`code/willCreateSocket/${j}`),H.connect(U,Y,B,_).then(ue=>{X.didTimeout?(w.mark(`code/didCreateSocketError/${j}`),K.info(`Creating a socket (${_}) finished after ${oe.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(w.mark(`code/didCreateSocketOK/${j}`),K.info(`Creating a socket (${_}) was successful after ${oe.elapsed()} ms.`),X.resolve(ue))},ue=>{w.mark(`code/didCreateSocketError/${j}`),K.info(`Creating a socket (${_}) returned an error after ${oe.elapsed()} ms.`),K.error(ue),X.reject(ue)}),X.promise}function r(K,H){const U=new I(H);return K.then(Y=>{U.didTimeout||U.resolve(Y)},Y=>{U.didTimeout||U.reject(Y)}),U.promise}async function t(K,H,U,Y){const B=q(K,H);K.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let j;try{j=await s(K.logService,K.remoteSocketFactoryService,K.connectTo,A.$Sg.getServerRootPath(),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,v(H),`renderer-${v(H)}-${K.reconnectionToken}`,Y)}catch(ue){throw K.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),K.logService.error(ue),ue}K.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let _,ee;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(j,null),_=K.reconnectionProtocol,ee=!1):(_=new u.$ti({socket:j}),ee=!0),K.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const X=await r(K.signService.createNewMessage((0,m.$2g)()),Y),oe={type:"auth",auth:K.connectionToken||"00000000000000000000",data:X.data};_.sendControl(c.$Oe.fromString(JSON.stringify(oe)));try{const ue=await g(_,p(Y,d(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const pe=new Error("Unexpected handshake message");throw pe.code="VSCODE_CONNECTION_ERROR",pe}if(K.logService.trace(`${B} 4/6. received SignRequest control message.`),!await r(K.signService.validate(X,ue.signedData),Y)){const pe=new Error("Refused to connect to unsupported server");throw pe.code="VSCODE_CONNECTION_ERROR",pe}const be=await r(K.signService.sign(ue.data),Y),Ie={type:"connectionType",commit:K.commit,signedData:be,desiredConnectionType:H};return U&&(Ie.args=U),K.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(c.$Oe.fromString(JSON.stringify(Ie))),{protocol:_,ownsProtocol:ee}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(K.logService.error(`${B} the handshake timed out. Error:`),K.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${B} received error control message when negotiating connection. Error:`),K.logService.error(ue)),ee&&V(_),ue}}async function a(K,H,U,Y){const B=Date.now(),j=q(K,H),{protocol:_,ownsProtocol:ee}=await t(K,H,U,Y),X=new I(Y);return X.registerDisposable(_.onControlMessage(oe=>{const ue=JSON.parse(oe.toString()),ge=z(ue);ge?(K.logService.error(`${j} received error control message when negotiating connection. Error:`),K.logService.error(ge),ee&&V(_),X.reject(ge)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${Z(B)}!`),X.resolve({protocol:_,firstMessage:ue}))})),X.promise}async function i(K,H){const{protocol:U}=await a(K,b.Management,void 0,H);return{protocol:U}}async function n(K,H,U){const{protocol:Y,firstMessage:B}=await a(K,b.ExtensionHost,H,U),j=B&&B.debugPort;return{protocol:Y,debugPort:j}}async function o(K,H,U){const Y=Date.now(),B=q(K,b.Tunnel),{protocol:j}=await t(K,b.Tunnel,H,U);return K.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${Z(Y)}!`),j}async function h(K,H,U){const{connectTo:Y,connectionToken:B}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:Y,connectionToken:B,reconnectionToken:H,reconnectionProtocol:U,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function f(K,H,U){return L(K,async Y=>{const{protocol:B}=await i(Y,C.CancellationToken.None);return new G(K,H,U,Y.reconnectionToken,B)})}async function R(K,H){return L(K,async U=>{const{protocol:Y,debugPort:B}=await n(U,H,C.CancellationToken.None);return new ie(K,H,U.reconnectionToken,Y,B)})}async function L(K,H){for(let Y=1;;Y++)try{const B=(0,m.$2g)(),j=await h(K,B,null);return await H(j)}catch(B){if(Y<5)K.logService.error(`[remote-connection][attempt ${Y}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(B);else throw K.logService.error(`[remote-connection][attempt ${Y}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(B),x.triggerPermanentFailure(0,0,$.$Tl.isHandled(B)),B}}async function E(K,H,U){const Y=await h(K,(0,m.$2g)(),null);return await o(Y,{host:H,port:U},C.CancellationToken.None)}function y(K){return(0,P.$sh)(H=>new Promise((U,Y)=>{const B=setTimeout(U,K*1e3);H.onCancellationRequested(()=>{clearTimeout(B),U()})}))}var N;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class F{constructor(H,U){this.reconnectionToken=H,this.millisSinceLastIncomingData=U,this.type=N.ConnectionLost}}e.$3l=F;class D{constructor(H,U,Y,B){this.reconnectionToken=H,this.millisSinceLastIncomingData=U,this.durationSeconds=Y,this.c=B,this.type=N.ReconnectionWait}skipWait(){this.c.cancel()}}e.$4l=D;class M{constructor(H,U,Y){this.reconnectionToken=H,this.millisSinceLastIncomingData=U,this.attempt=Y,this.type=N.ReconnectionRunning}}e.$5l=M;class J{constructor(H,U,Y){this.reconnectionToken=H,this.millisSinceLastIncomingData=U,this.attempt=Y,this.type=N.ConnectionGain}}e.$6l=J;class W{constructor(H,U,Y,B){this.reconnectionToken=H,this.millisSinceLastIncomingData=U,this.attempt=Y,this.handled=B,this.type=N.ReconnectionPermanentFailure}}e.$7l=W;class x extends k.$Wc{static triggerPermanentFailure(H,U,Y){this._permanentFailure=!0,this.f=H,this.g=U,this.h=Y,this.j.forEach(B=>B.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(H=>H.y())}static debugPauseSocketWriting(){this.j.forEach(H=>H.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(H,U,Y,B,j){super(),this.t=H,this.u=U,this.reconnectionToken=Y,this.protocol=B,this.w=j,this.m=this.B(new T.$me),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new J(this.reconnectionToken,0,0)),this.B(B.onSocketClose(_=>{const ee=he(this.t,this.reconnectionToken,!0);_?_.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${ee} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${ee} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${ee} received socket close event.`),this.y()})),this.B(B.onSocketTimeout(_=>{const ee=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ee} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,k.$Uc)(()=>{const _=x.j.indexOf(this);_>=0&&x.j.splice(_,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const H=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let Y=-1;do{Y++;const B=Y<U.length?U[Y]:U[U.length-1];try{if(B>0){const _=y(B);this.m.fire(new D(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,_)),this.u.logService.info(`${H} waiting for ${B} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1)),this.u.logService.info(`${H} resolving connection...`);const j=await h(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${H} connecting to ${j.connectTo}...`),await this.G(j,d(l)),this.u.logService.info(`${H} reconnected!`),this.m.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if(Y>360){this.u.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if($.$Tl.isTemporarilyNotAvailable(j)){this.u.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this.u.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(j);continue}if((0,O.$6)(j)){this.u.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(j);continue}if(j instanceof $.$Tl){this.u.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,$.$Tl.isHandled(j));break}this.u.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}}while(!this.n&&!this.s)}C(H,U,Y){this.w?x.triggerPermanentFailure(H,U,Y):this.D(H,U,Y)}D(H,U,Y){this.m.fire(new W(this.reconnectionToken,H,U,Y)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$8l=x;class G extends x{constructor(H,U,Y,B,j){super(b.Management,H,B,j,!0),this.client=this.B(new u.$ri(j,{remoteAuthority:U,clientId:Y},H.ipcLogger))}async G(H,U){await i(H,U)}}e.$9l=G;class ie extends x{constructor(H,U,Y,B,j){super(b.ExtensionHost,H,Y,B,!1),this.H=U,this.debugPort=j}async G(H,U){await n(H,this.H,U)}}e.$0l=ie;function V(K){try{K.acceptDisconnect();const H=K.getSocket();K.dispose(),H.dispose()}catch(H){(0,O.$3)(H)}}function z(K){if(K&&K.type==="error"){const H=new Error(`Connection error: ${K.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function te(K,H){for(;K.length<H;)K+=" ";return K}function se(K,H){return`[remote-connection][${te(v(K),13)}][${H.substr(0,5)}\u2026]`}function he(K,H,U){return`${se(K,H)}[${U?"reconnect":"initial"}]`}function q(K,H){return`${he(H,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function Z(K){return`${Date.now()-K} ms`}}),define(ce[106],le([0,1,23]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=c,e.$hn=C,e.$in=O,e.$jn=T;function c(A){return A.scheme===P.Schemas.vscodeRemote?A.authority:void 0}function C(A){if(!A)return;const w=A.indexOf("+");return w<0?A:A.substr(0,w)}function O(A){const{host:w,port:S}=k(A);if(typeof S>"u")throw new Error(`Invalid remote authority: ${A}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:w,port:S}}function T(A,w){let{host:S,port:m}=k(A);return typeof m>"u"&&(m=w),{host:S,port:m}}function k(A){const w=A.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const S=A.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const m=A.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:A,port:void 0}}}),define(ce[36],le([0,1,27,4,106]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=O,e.$tn=m,e.$un=u,e.$vn=$,e.$wn=l,e.$xn=b,e.$yn=v,P=Oe(P),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function O(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var T;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(T||(e.ExtensionType=T={}));var k;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class A{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,I){if(typeof p>"u"||p===null)return typeof I>"u"||I===null;if(typeof I>"u"||I===null)return!1;if(typeof p=="string"||typeof I=="string"){const g=typeof p=="string"?p:p.value,s=typeof I=="string"?I:I.value;return P.$Gf(g,s)}return p._lower===I._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$qn=A;class w{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const I of p)this.add(I)}add(p){this.c.add(A.toKey(p))}delete(p){return this.c.delete(A.toKey(p))}has(p){return this.c.has(A.toKey(p))}}e.$rn=w;class S{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(A.toKey(p))}get(p){return this.c.get(A.toKey(p))}has(p){return this.c.has(A.toKey(p))}set(p,I){this.c.set(A.toKey(p),I)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=S;function m(d){return u(d)}function u(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function $(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function l(d,p){if(p){const I=`onResolveRemoteAuthority:${(0,C.$hn)(p)}`;return!!d.activationEvents?.includes(I)}return!1}function b(d){return d.map(p=>{const[I,g]=p.split("@");return{proposalName:I,version:g?parseInt(g):void 0}})}function v(d){return d.map(p=>p.split("@")[0])}e.$zn=(0,c.$Fi)("IBuiltinExtensionsScannerService")}),define(ce[28],le([0,1,5,163,36,4]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.ExtensionManagementErrorCode=e.$jp=e.ExtensionGalleryErrorCode=e.$ip=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$cp=k,e.$dp=A,e.$ep=w,e.$fp=S,e.$gp=m,e.$hp=u,e.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9o=new RegExp(e.$8o),e.$0o="__web_extension",e.$$o="skipWalkthrough",e.$_o="extensionInstallSource",e.$ap="dependecyOrPackExtensionInstall",e.$bp="clientTargetPlatform";var T;(function(s){s.COMMAND="command",s.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function k(s){switch(s){case C.TargetPlatform.WIN32_X64:return"Windows 64 bit";case C.TargetPlatform.WIN32_ARM64:return"Windows ARM";case C.TargetPlatform.LINUX_X64:return"Linux 64 bit";case C.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case C.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case C.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case C.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case C.TargetPlatform.DARWIN_X64:return"Mac";case C.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case C.TargetPlatform.WEB:return"Web";case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;case C.TargetPlatform.UNKNOWN:return C.TargetPlatform.UNKNOWN;case C.TargetPlatform.UNDEFINED:return C.TargetPlatform.UNDEFINED}}function A(s){switch(s){case C.TargetPlatform.WIN32_X64:return C.TargetPlatform.WIN32_X64;case C.TargetPlatform.WIN32_ARM64:return C.TargetPlatform.WIN32_ARM64;case C.TargetPlatform.LINUX_X64:return C.TargetPlatform.LINUX_X64;case C.TargetPlatform.LINUX_ARM64:return C.TargetPlatform.LINUX_ARM64;case C.TargetPlatform.LINUX_ARMHF:return C.TargetPlatform.LINUX_ARMHF;case C.TargetPlatform.ALPINE_X64:return C.TargetPlatform.ALPINE_X64;case C.TargetPlatform.ALPINE_ARM64:return C.TargetPlatform.ALPINE_ARM64;case C.TargetPlatform.DARWIN_X64:return C.TargetPlatform.DARWIN_X64;case C.TargetPlatform.DARWIN_ARM64:return C.TargetPlatform.DARWIN_ARM64;case C.TargetPlatform.WEB:return C.TargetPlatform.WEB;case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;default:return C.TargetPlatform.UNKNOWN}}function w(s,r){switch(s){case P.Platform.Windows:return r==="x64"?C.TargetPlatform.WIN32_X64:r==="arm64"?C.TargetPlatform.WIN32_ARM64:C.TargetPlatform.UNKNOWN;case P.Platform.Linux:return r==="x64"?C.TargetPlatform.LINUX_X64:r==="arm64"?C.TargetPlatform.LINUX_ARM64:r==="arm"?C.TargetPlatform.LINUX_ARMHF:C.TargetPlatform.UNKNOWN;case"alpine":return r==="x64"?C.TargetPlatform.ALPINE_X64:r==="arm64"?C.TargetPlatform.ALPINE_ARM64:C.TargetPlatform.UNKNOWN;case P.Platform.Mac:return r==="x64"?C.TargetPlatform.DARWIN_X64:r==="arm64"?C.TargetPlatform.DARWIN_ARM64:C.TargetPlatform.UNKNOWN;case P.Platform.Web:return C.TargetPlatform.WEB}}function S(s,r){return r===C.TargetPlatform.WEB&&!s.includes(C.TargetPlatform.WEB)}function m(s,r,t){return S(r,t)?!1:s===C.TargetPlatform.UNDEFINED||s===C.TargetPlatform.UNIVERSAL?!0:s===C.TargetPlatform.UNKNOWN?!1:s===t}function u(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}var $;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})($||(e.SortBy=$={}));var l;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var b;(function(s){s.Install="install",s.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var v;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$ip=(0,O.$Fi)("extensionGalleryService");var d;(function(s){s.Timeout="Timeout",s.Cancelled="Cancelled",s.Failed="Failed",s.DownloadFailedWriting="DownloadFailedWriting"})(d||(e.ExtensionGalleryErrorCode=d={}));class p extends Error{constructor(r,t){super(r),this.code=t,this.name=t}}e.$jp=p;var I;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleApi="IncompatibleApi",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.DownloadSignature="DownloadSignature",s.DownloadFailedWriting="DownloadFailedWriting",s.UpdateExistingMetadata="UpdateExistingMetadata",s.UpdateMetadata="UpdateMetadata",s.Extract="Extract",s.Scanning="Scanning",s.ScanningExtension="ScanningExtension",s.ReadUninstalled="ReadUninstalled",s.UnsetUninstalled="UnsetUninstalled",s.Delete="Delete",s.Rename="Rename",s.IntializeDefaultProfile="IntializeDefaultProfile",s.AddToProfile="AddToProfile",s.InstalledExtensionNotFound="InstalledExtensionNotFound",s.PostInstall="PostInstall",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.NotAllowed="NotAllowed",s.Gallery="Gallery",s.Cancelled="Cancelled",s.Unknown="Unknown",s.Internal="Internal"})(I||(e.ExtensionManagementErrorCode=I={}));class g extends Error{constructor(r,t){super(r),this.code=t,this.name=t}}e.$kp=g,e.$lp=(0,O.$Fi)("extensionManagementService"),e.$mp="extensionsIdentifiers/disabled",e.$np="extensionsIdentifiers/enabled",e.$op=(0,O.$Fi)("IGlobalExtensionEnablementService"),e.$pp=(0,O.$Fi)("IExtensionTipsService"),e.$qp=(0,c.localize2)(0,"Extensions"),e.$rp=(0,c.localize2)(1,"Preferences")}),define(ce[224],le([0,1,3,2,30,9,95,28]),function(ne,e,P,c,C,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=void 0;function A(v,d){return v?O.URI.revive(d?d.transformIncoming(v):v):void 0}function w(v,d){return d?d.transformOutgoingURI(v):v}function S(v,d){d=d||T.$Mn;const p=v.manifest;return{...(0,T.$Pn)({...v,manifest:void 0},d),manifest:p}}function m(v,d){return v?.profileLocation?(0,T.$Pn)(v,d??T.$Mn):v}function u(v,d){return d?(0,C.$fo)(v,p=>p instanceof O.URI?d.transformOutgoingURI(p):void 0):v}class ${constructor(d,p){this.a=d,this.b=p,this.onInstallExtension=P.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=P.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=P.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=P.Event.buffer(d.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=P.Event.buffer(d.onDidUpdateExtensionMetadata,!0)}listen(d,p){const I=this.b(d);switch(p){case"onInstallExtension":return P.Event.map(this.onInstallExtension,g=>({...g,profileLocation:g.profileLocation?w(g.profileLocation,I):g.profileLocation}));case"onDidInstallExtensions":return P.Event.map(this.onDidInstallExtensions,g=>g.map(s=>({...s,local:s.local?u(s.local,I):s.local,profileLocation:s.profileLocation?w(s.profileLocation,I):s.profileLocation})));case"onUninstallExtension":return P.Event.map(this.onUninstallExtension,g=>({...g,profileLocation:g.profileLocation?w(g.profileLocation,I):g.profileLocation}));case"onDidUninstallExtension":return P.Event.map(this.onDidUninstallExtension,g=>({...g,profileLocation:g.profileLocation?w(g.profileLocation,I):g.profileLocation}));case"onDidUpdateExtensionMetadata":return P.Event.map(this.onDidUpdateExtensionMetadata,g=>({local:u(g.local,I),profileLocation:w(g.profileLocation,I)}))}throw new Error("Invalid listen")}async call(d,p,I){const g=this.b(d);switch(p){case"zip":{const s=S(I[0],g),r=await this.a.zip(s);return w(r,g)}case"unzip":return this.a.unzip(A(I[0],g));case"install":return this.a.install(A(I[0],g),m(I[1],g));case"installFromLocation":return this.a.installFromLocation(A(I[0],g),A(I[1],g));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(I[0],A(I[1],g),A(I[2],g));case"getManifest":return this.a.getManifest(A(I[0],g));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(I[0]);case"installFromGallery":return this.a.installFromGallery(I[0],m(I[1],g));case"installGalleryExtensions":{const s=I[0];return this.a.installGalleryExtensions(s.map(({extension:r,options:t})=>({extension:r,options:m(t,g)??{}})))}case"uninstall":return this.a.uninstall(S(I[0],g),m(I[1],g));case"reinstallFromGallery":return this.a.reinstallFromGallery(S(I[0],g));case"getInstalled":return(await this.a.getInstalled(I[0],A(I[1],g),I[2])).map(r=>u(r,g));case"toggleAppliationScope":{const s=await this.a.toggleAppliationScope(S(I[0],g),A(I[1],g));return u(s,g)}case"copyExtensions":return this.a.copyExtensions(A(I[0],g),A(I[1],g));case"updateMetadata":{const s=await this.a.updateMetadata(S(I[0],g),I[1],A(I[2],g));return u(s,g)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(I[0],I[1],I[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$uq=$;class l extends c.$Wc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(d){super(),this.m=d,this.c=this.B(new P.$me),this.f=this.B(new P.$me),this.g=this.B(new P.$me),this.h=this.B(new P.$me),this.j=this.B(new P.$me),this.B(this.m.listen("onInstallExtension")(p=>this.n(this.c,{...p,source:this.r(p.source)?O.URI.revive(p.source):p.source,profileLocation:O.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(p=>this.n(this.f,p.map(I=>({...I,local:I.local?S(I.local,null):I.local,source:this.r(I.source)?O.URI.revive(I.source):I.source,profileLocation:O.URI.revive(I.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(p=>this.n(this.g,{...p,profileLocation:O.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(p=>this.n(this.h,{...p,profileLocation:O.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(p=>this.n(this.j,{profileLocation:O.URI.revive(p.profileLocation),local:S(p.local,null)})))}n(d,p){d.fire(p)}r(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(d){const p=await this.getTargetPlatform();return d.allTargetPlatforms.some(I=>(0,k.$gp)(I,d.allTargetPlatforms,p))}zip(d){return Promise.resolve(this.m.call("zip",[d]).then(p=>O.URI.revive(p)))}unzip(d){return Promise.resolve(this.m.call("unzip",[d]))}install(d,p){return Promise.resolve(this.m.call("install",[d,p])).then(I=>S(I,null))}installFromLocation(d,p){return Promise.resolve(this.m.call("installFromLocation",[d,p])).then(I=>S(I,null))}async installExtensionsFromProfile(d,p,I){return(await this.m.call("installExtensionsFromProfile",[d,p,I])).map(s=>S(s,null))}getManifest(d){return Promise.resolve(this.m.call("getManifest",[d]))}installFromGallery(d,p){return Promise.resolve(this.m.call("installFromGallery",[d,p])).then(I=>S(I,null))}async installGalleryExtensions(d){return(await this.m.call("installGalleryExtensions",[d])).map(I=>({...I,local:I.local?S(I.local,null):I.local,source:this.r(I.source)?O.URI.revive(I.source):I.source,profileLocation:O.URI.revive(I.profileLocation)}))}uninstall(d,p){if(d.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[d,p]))}reinstallFromGallery(d){return Promise.resolve(this.m.call("reinstallFromGallery",[d])).then(p=>S(p,null))}getInstalled(d=null,p,I){return Promise.resolve(this.m.call("getInstalled",[d,p,I])).then(g=>g.map(s=>S(s,null)))}updateMetadata(d,p,I){return Promise.resolve(this.m.call("updateMetadata",[d,p,I])).then(g=>S(g,null))}toggleAppliationScope(d,p){return this.m.call("toggleAppliationScope",[d,p]).then(I=>S(I,null))}copyExtensions(d,p){return this.m.call("copyExtensions",[d,p])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(d,p,I){const g=await this.m.call("download",[d,p,I]);return O.URI.revive(g)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$vq=l;class b{constructor(d){this.a=d}listen(d,p){throw new Error("Invalid listen")}call(d,p,I){switch(p){case"getConfigBasedTips":return this.a.getConfigBasedTips(O.URI.revive(I[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$wq=b}),define(ce[225],le([0,1,2,36,7]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class O extends P.$Wc{constructor(k,A,w,S,m){super(),this.a=k,this.b=A,this.c=w,this.f=m,this.B(S.onDidInstallExtensions(u=>this.g(u))),this.B(S.onDidUninstallExtension(u=>this.h(u)))}g(k){for(const A of k)A.local&&this.invalidate(A.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const A of this.a.profiles)this.c.extUri.isEqual(A.extensionsResource,k)&&await this.j(A);else await this.j(this.a.defaultProfile)}async j(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,c.$kn))}catch(A){(0,C.$ql)(A)!==C.FileOperationResult.FILE_NOT_FOUND&&this.f.error(A)}}}e.$Tq=O});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(ce[60],le([0,1,21,92,168,61,36,196]),function(ne,e,P,c,C,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=S,e.$Xp=m,e.$Yp=u,e.$Zp=$,e.$1p=l,e.$2p=b,e.$3p=v,e.$4p=d,c=it(c),C=Oe(C),O=Oe(O);const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function S(g){return g=g.trim(),g==="*"||A.test(g)}function m(g){if(!S(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const s=g.match(A);return s?{hasCaret:s[1]==="^",hasGreaterEquals:s[1]===">=",majorBase:s[2]==="x"?0:parseInt(s[2],10),majorMustEqual:s[2]!=="x",minorBase:s[4]==="x"?0:parseInt(s[4],10),minorMustEqual:s[4]!=="x",patchBase:s[6]==="x"?0:parseInt(s[6],10),patchMustEqual:s[6]!=="x",preRelease:s[8]||null}:null}function u(g){if(!g)return null;const s=g.majorBase,r=g.majorMustEqual,t=g.minorBase;let a=g.minorMustEqual;const i=g.patchBase;let n=g.patchMustEqual;g.hasCaret&&(s===0||(a=!1),n=!1);let o=0;if(g.preRelease){const h=w.exec(g.preRelease);if(h){const[,f,R,L]=h;o=Date.UTC(Number(f),Number(R)-1,Number(L))}}return{majorBase:s,majorMustEqual:r,minorBase:t,minorMustEqual:a,patchBase:i,patchMustEqual:n,isMinimum:g.hasGreaterEquals,notBefore:o}}function $(g,s,r){let t;typeof g=="string"?t=u(m(g)):t=g;let a;s instanceof Date?a=s.getTime():typeof s=="string"&&(a=new Date(s).getTime());let i;if(typeof r=="string"?i=u(m(r)):i=r,!t||!i)return!1;const n=t.majorBase,o=t.minorBase,h=t.patchBase;let f=i.majorBase,R=i.minorBase,L=i.patchBase;const E=i.notBefore;let y=i.majorMustEqual,N=i.minorMustEqual,F=i.patchMustEqual;return i.isMinimum?n>f?!0:n<f?!1:o>R?!0:o<R||a&&a<E?!1:h>=L:(n===1&&f===0&&(!y||!N||!F)&&(f=1,R=0,L=0,y=!0,N=!1,F=!1),n<f?!1:n>f?!y:o<R?!1:o>R?!N:h<L?!1:h>L?!F:!(a&&a<E))}function l(g,s,r,t,a){const i=[];if(typeof t.publisher<"u"&&typeof t.publisher!="string")return i.push([c.default.Error,C.localize(0,null)]),i;if(typeof t.name!="string")return i.push([c.default.Error,C.localize(1,null,"name")]),i;if(typeof t.version!="string")return i.push([c.default.Error,C.localize(2,null,"version")]),i;if(!t.engines)return i.push([c.default.Error,C.localize(3,null,"engines")]),i;if(typeof t.engines.vscode!="string")return i.push([c.default.Error,C.localize(4,null,"engines.vscode")]),i;if(typeof t.extensionDependencies<"u"&&!I(t.extensionDependencies))return i.push([c.default.Error,C.localize(5,null,"extensionDependencies")]),i;if(typeof t.activationEvents<"u"){if(!I(t.activationEvents))return i.push([c.default.Error,C.localize(6,null,"activationEvents")]),i;if(typeof t.main>"u"&&typeof t.browser>"u")return i.push([c.default.Error,C.localize(7,null,"activationEvents","main","browser")]),i}if(typeof t.extensionKind<"u"&&typeof t.main>"u"&&i.push([c.default.Warning,C.localize(8,null,"extensionKind")]),typeof t.main<"u"){if(typeof t.main!="string")return i.push([c.default.Error,C.localize(9,null,"main")]),i;{const h=(0,P.$gh)(r,t.main);(0,P.$ah)(h,r)||i.push([c.default.Warning,C.localize(10,null,h.path,r.path)])}}if(typeof t.browser<"u"){if(typeof t.browser!="string")return i.push([c.default.Error,C.localize(11,null,"browser")]),i;{const h=(0,P.$gh)(r,t.browser);(0,P.$ah)(h,r)||i.push([c.default.Warning,C.localize(12,null,h.path,r.path)])}}if(!O.valid(t.version))return i.push([c.default.Error,C.localize(13,null)]),i;const n=[];if(!b(g,s,t,a,n))for(const h of n)i.push([c.default.Error,h]);if(t.enabledApiProposals?.length){const h=[];if(!d([...t.enabledApiProposals],h))for(const f of h)i.push([c.default.Error,f])}return i}function b(g,s,r,t,a){return t||typeof r.main>"u"&&typeof r.browser>"u"?!0:p(g,s,r.engines.vscode,a)}function v(g,s,r){return g==="*"||p(s,r,g)}function d(g,s){if(g.length===0)return!0;const r=Array.isArray(s)?s:void 0,t=(r?void 0:s)??k.allApiProposals,a=[],i=(0,T.$xn)(g);for(const{proposalName:n,version:o}of i){const h=t[n];h&&o&&h.version!==o&&(h.version?a.push(C.localize(14,null,n,o,h.version)):a.push(C.localize(15,null,n,o)))}return r?.push(...a),a.length===0}function p(g,s,r,t=[]){const a=u(m(r));if(!a)return t.push(C.localize(16,null,r)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return t.push(C.localize(17,null,r)),!1}else if(!a.majorMustEqual)return t.push(C.localize(18,null,r)),!1;return $(g,s,a)?!0:(t.push(C.localize(19,null,g,r)),!1)}function I(g){if(!Array.isArray(g))return!1;for(let s=0,r=g.length;s<r;s++)if(typeof g[s]!="string")return!1;return!0}}),define(ce[79],le([0,1,26,2,5,173,28,4]),function(ne,e,P,c,C,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=e.$9r=void 0,e.$8r=A;function A(S){return S.tags.find(m=>m.startsWith("lp-"))?.split("lp-")[1]}e.$9r=(0,k.$Fi)("languagePackService");let w=class extends c.$Wc{constructor(m){super(),this.c=m}async getAvailableLanguages(){const m=new P.$xe;setTimeout(()=>m.cancel(),1e3);let u;try{u=await this.c.query({text:'category:"language packs"',pageSize:20},m.token)}catch{return[]}const l=u.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some(v=>v.startsWith("lp-"))).map(b=>{const v=b.properties.localizedLanguages?.[0],d=A(b);return{...this.f(d,v,b),extensionId:b.identifier.id,galleryExtension:b}});return l.push(this.f("en","English")),l}f(m,u,$){const l=u??m;let b;if(l!==m&&(b=`(${m})`),m.toLowerCase()===C.$w.toLowerCase()&&(b??="",b+=(0,O.localize)(0,null)),$?.installCount){b??="";const v=$.installCount;let d;v>1e6?d=`${Math.floor(v/1e5)/10}M`:v>1e3?d=`${Math.floor(v/1e3)}K`:d=String(v),b+=` $(cloud-download) ${d}`}return{id:m,label:l,description:b}}};e.$0r=w,e.$0r=w=ve([Q(0,T.$ip)],w)}),define(ce[226],le([0,1,2,79]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;let C=class extends P.$Wc{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};e.$bhc=C,e.$bhc=C=ve([Q(0,c.$9r)],C)}),define(ce[107],le([0,1,2,4]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl=(0,c.$Fi)("remoteSocketFactoryService");class C{constructor(){this.a={}}register(T,k){return this.a[T]??=[],this.a[T].push(k),(0,P.$Uc)(()=>{const A=this.a[T]?.indexOf(k);typeof A=="number"&&A>=0&&this.a[T]?.splice(A,1)})}b(T){return(this.a[T.type]||[]).find(A=>A.supports(T))}connect(T,k,A,w){const S=this.b(T);if(!S)throw new Error(`No socket factory found for ${T}`);return S.connect(T,k,A,w)}}e.$Wl=C}),define(ce[227],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=e.$ohc=void 0,e.$ohc=(0,P.$Fi)("sharedProcessTunnelService"),e.$phc="sharedProcessTunnel"}),define(ce[108],le([0,1,4,175]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=e.$yhc=e.$xhc=e.$whc=e.$vhc=e.TunnelStates=e.$uhc=e.$thc=void 0,e.$thc=(0,P.$Fi)("IRemoteTunnelService"),e.$uhc={active:!1};var C;(function(O){O.disconnected=T=>({type:"disconnected",onTokenFailed:T}),O.connected=(T,k)=>({type:"connected",info:T,serviceInstallFailed:k}),O.connecting=T=>({type:"connecting",progress:T}),O.uninitialized={type:"uninitialized"}})(C||(e.TunnelStates=C={})),e.$vhc="remote.tunnels.access",e.$whc=e.$vhc+".hostNameOverride",e.$xhc=e.$vhc+".preventSleep",e.$yhc="remoteTunnelService",e.$zhc=(0,c.localize)(0,null)}),define(ce[62],le([0,1,15,8,2,177,48,4,10,44]),function(ne,e,P,c,C,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.$7p=u,e.$8p=$,e.$9p=l,e.$0p=b,e.$$p=v,e.$_p=d,e.$5p=(0,k.$Fi)("requestService");class S{constructor(s){this.b=s}toJSON(){if(!this.a){const s=Object.create(null);for(const r in this.b)r.toLowerCase()==="authorization"||r.toLowerCase()==="proxy-authorization"?s[r]="*****":s[r]=this.b[r];this.a=s}return this.a}}class m extends C.$Wc{constructor(s){super(),this.b=0,this.a=s.createLogger("network",{name:(0,O.localize)(0,null),when:A.$rk.isEqualTo((0,A.$ok)(A.LogLevel.Trace)).serialize()})}async c(s,r,t){const a=`${s} #${++this.b}: ${r.url}`;this.a.trace(`${a} - begin`,r.type,new S(r.headers??{}));try{const i=await t();return this.a.trace(`${a} - end`,r.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${a} - error`,r.type,(0,c.$_)(i)),i}}}e.$6p=m;function u(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}function $(g){return g.res.statusCode===204}async function l(g){return $(g)?null:(await(0,P.$1e)(g.stream)).toString()}async function b(g){if(!u(g))throw new Error("Server returned "+g.res.statusCode);return l(g)}async function v(g){if(!u(g))throw new Error("Server returned "+g.res.statusCode);if($(g))return null;const r=(await(0,P.$1e)(g.stream)).toString();try{return JSON.parse(r)}catch(t){throw t.message+=`:
`+r,t}}function d(g){I(g)}let p;function I(g){const s=w.$qo.as(T.$vo.Configuration),r=p;p={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},s.updateConfigurations({add:[p],remove:r?[r]:[]})}I(T.ConfigurationScope.APPLICATION)}),define(ce[228],le([0,1,26,23,7,62]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DR=void 0;let T=class{constructor(A,w){this.a=A,this.b=w}async download(A,w,S=P.CancellationToken.None){if(A.scheme===c.Schemas.file||A.scheme===c.Schemas.vscodeRemote){await this.b.copy(A,w);return}const m={type:"GET",url:A.toString(!0)},u=await this.a.request(m,S);if(u.res.statusCode===200)await this.b.writeFile(w,u.stream);else{const $=await(0,O.$0p)(u);throw new Error(`Expected 200, got back ${u.res.statusCode} instead.

${$}`)}}};e.$DR=T,e.$DR=T=ve([Q(0,O.$5p),Q(1,C.$_k)],T)}),define(ce[229],le([0,1,15,26]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.$_r=void 0;class C{constructor(k){this.a=k}listen(k,A){throw new Error("Invalid listen")}call(k,A,w,S=c.CancellationToken.None){switch(A){case"request":return this.a.request(w[0],S).then(async({res:m,stream:u})=>{const $=await(0,P.$1e)(u);return[{statusCode:m.statusCode,headers:m.headers},$]});case"resolveProxy":return this.a.resolveProxy(w[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$_r=C;class O{constructor(k){this.a=k}async request(k,A){const[w,S]=await this.a.call("request",[k],A);return{res:w,stream:(0,P.$3e)(S)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$as=O}),define(ce[230],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=e.$Zfc=e.$Yfc=void 0,e.$Yfc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Zfc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$1fc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ce[231],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(C){try{const O=await this.c();if(O){const T=String(P.a++);return this.b.set(T,O),{id:T,data:O.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,O){if(!C.id)return!0;const T=this.b.get(C.id);if(!T)return!1;this.b.delete(C.id);try{return T.validate(O)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(C){try{return await this.d(C)}catch{}return C}}e.$Kbc=P}),define(ce[109],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=void 0,e.$Xl="signService",e.$Yl=(0,P.$Fi)(e.$Xl)}),define(ce[232],le([0,1,231]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=void 0;class c extends P.$Kbc{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(T=>new T.signer().sign(O))}h(){return new Promise((O,T)=>ne(["vsda"],O,T))}}e.$Qgc=c}),define(ce[80],le([0,1,3,2]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OMb=e.$NMb=e.$MMb=e.$LMb=void 0;class C extends c.$Wc{constructor(m,u,$){super(),this.a=m,this.b=u,this.c=$}async getItems(){const m={profile:this.b,workspace:this.c},u=await this.a.call("getItems",m);return new Map(u)}updateItems(m){const u={profile:this.b,workspace:this.c};return m.insert&&(u.insert=Array.from(m.insert.entries())),m.delete&&(u.delete=Array.from(m.delete.values())),this.a.call("updateItems",u)}optimize(){const m={profile:this.b,workspace:this.c};return this.a.call("optimize",m)}}class O extends C{constructor(m,u){super(m,u,void 0),this.f=this.B(new P.$me),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(m=>this.h(m)))}h(m){(Array.isArray(m.changed)||Array.isArray(m.deleted))&&this.f.fire({changed:m.changed?new Map(m.changed):void 0,deleted:m.deleted?new Set(m.deleted):void 0})}}class T extends O{constructor(m){super(m,void 0)}async close(){this.dispose()}}e.$LMb=T;class k extends O{constructor(m,u){super(m,u)}async close(){this.dispose()}}e.$MMb=k;class A extends C{constructor(m,u){super(m,void 0,u),this.onDidChangeItemsExternal=P.Event.None}async close(){this.dispose()}}e.$NMb=A;class w{constructor(m){this.a=m}isUsed(m){const u={payload:m,profile:void 0,workspace:void 0};return this.a.call("isUsed",u)}}e.$OMb=w}),define(ce[110],le([0,1,5,37,32]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=T,e.$tp=k;function O(A){if(P.$u===P.Platform.Linux&&/^penguin(\.|$)/i.test(A))return"chromebook"}function T(A,w,S,m,u,$,l,b,v,d){const p=Object.create(null);p["common.machineId"]=$,p["common.sqmId"]=l,p["common.devDeviceId"]=b,p.sessionID=(0,C.$2g)()+Date.now(),p.commitHash=m,p.version=u,p["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,P.$h)(P.$u),p["common.nodePlatform"]=c.$fc,p["common.nodeArch"]=S,p["common.product"]=d||"desktop",v&&(p["common.msftInternal"]=v);let I=0;const g=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>I++,enumerable:!0}}),P.$l&&(p["common.snap"]="true");const s=O(w);return s&&(p["common.platformDetail"]=s),p}function k(A){const w=c.env.USERDNSDOMAIN;if(!w)return!1;const S=w.toLowerCase();return A.some(m=>S===m)}}),define(ce[18],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,P.$Fi)("telemetryService"),e.$_l=(0,P.$Fi)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var c;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(c||(e.TelemetryLevel=c={}));var C;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(ce[233],le([0,1,38,6,34,23,14,5,55,9,150,31,156,98,7,24,18]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0,e.$Vs=p,e.$Ws=g,e.$Xs=s,P=Oe(P);const d=new Map;async function p(t,a){const i=`${t}::${a.join(":")}`,n=d.get(i);if(n)return n;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],h=new Map,f=new Map,R=2e4;function L(y,N,F,D){const M=N.substring(y.length+1);return c.Promises.withAsyncBody(async J=>{let W;D.readdirCount++;try{W=await m.Promises.readdir(N,{withFileTypes:!0})}catch{J();return}if(D.count>=R){D.count+=W.length,D.maxReached=!0,J();return}let x=W.length;if(x===0){J();return}let G=W;D.count+W.length>R&&(D.maxReached=!0,x=R-D.count,G=W.slice(0,x)),D.count+=W.length;for(const ie of G)if(ie.isDirectory()){if(F.includes(ie.name)||await L(y,(0,T.$lc)(N,ie.name),F,D),--x===0){J();return}}else{const V=ie.name.lastIndexOf(".");if(V>=0){const z=ie.name.substring(V+1);z&&h.set(z,(h.get(z)??0)+1)}for(const z of o)z.relativePathPattern?.test(M)!==!1&&z.filePattern.test(ie.name)&&f.set(z.tag,(f.get(z.tag)??0)+1);if(--x===0){J();return}}})}const E=c.Promises.withAsyncBody(async y=>{const N={count:0,maxReached:!1,readdirCount:0},F=new A.$ge(!0);await L(t,t,a,N);const D=await s(t);y({configFiles:I(f),fileTypes:I(h),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:D,totalScanTime:F.elapsed(),totalReaddirCount:N.readdirCount})});return d.set(i,E),E}function I(t){return Array.from(t.entries(),([a,i])=>({name:a,count:i})).sort((a,i)=>i.count-a.count)}function g(){const t={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/l.$Hl.GB).toFixed(2)}GB (${(P.freemem()/l.$Hl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.$Rn.value()*100)}%`},a=P.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}async function s(t){try{const a=new Map,i=(0,T.$lc)(t,".vscode","launch.json"),n=await m.Promises.readFile(i),o=[],h=(0,C.$Xn)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,C.$6n)(h)==="object"&&h.configurations)for(const f of h.configurations){const R=f.type;R&&(a.has(R)?a.set(R,a.get(R)+1):a.set(R,1))}return I(a)}catch{return[]}}let r=class{constructor(a,i){this.c=a,this.d=i}f(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}g(a){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const n=P.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(P.totalmem()/l.$Hl.GB).toFixed(2)}GB (${(P.freemem()/l.$Hl.GB).toFixed(2)}GB free)`),k.$i||i.push(`Load (avg):       ${P.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(S.$Rn.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,u.$Us)(a.mainPID),this.k(a)]).then(async n=>{let[o,h]=n,f=this.m(a,o);return i.forEach(R=>{if((0,$.$Tm)(R))f+=`
${R.errorMessage}`,h+=`
${R.errorMessage}`;else if(f+=`

Remote: ${R.hostName}`,R.processes&&(f+=`
${this.m(a,R.processes)}`),R.workspaceMetadata){h+=`
|  Remote: ${R.hostName}`;for(const L of Object.keys(R.workspaceMetadata)){const E=R.workspaceMetadata[L];let y=`${E.fileCount} files`;E.maxFilesReached&&(y=`more than ${y}`),h+=`|    Folder (${L}): ${y}`,h+=this.h(E)}}}),{processInfo:f,workspaceInfo:h}})}async getSystemInfo(a,i){const{memory:n,vmHint:o,os:h,cpus:f}=g(),R={os:h,memory:n,cpus:f,vmHint:o,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return k.$i||(R.load=`${P.loadavg().map(L=>Math.round(L)).join(", ")}`),k.$k&&(R.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(R)}async getDiagnostics(a,i){const n=[];return(0,u.$Us)(a.mainPID).then(async o=>(n.push(""),n.push(this.g(a)),n.push(""),n.push(this.m(a,o)),a.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(a))),i.forEach(h=>{if((0,$.$Tm)(h))n.push(`
${h.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${h.hostName}`),n.push(this.f(h.machineInfo)),h.processes&&n.push(this.m(a,h.processes)),h.workspaceMetadata)for(const f of Object.keys(h.workspaceMetadata)){const R=h.workspaceMetadata[f];let L=`${R.fileCount} files`;R.maxFilesReached&&(L=`more than ${L}`),n.push(`Folder (${f}): ${L}`),n.push(this.h(R))}}),n.push(""),n.push(""),n.join(`
`)))}h(a){const i=[];let o=0;const h=(E,y)=>{const N=` ${E}(${y})`;o+N.length>60?(i.push(f),f="|                 ",o=f.length):o+=N.length,f+=N};let f="|      File types:";const R=10,L=a.fileTypes.length>R?R:a.fileTypes.length;for(let E=0;E<L;E++){const y=a.fileTypes[E];h(y.name,y.count)}if(i.push(f),a.configFiles.length>=0&&(f="|      Conf files:",o=0,a.configFiles.forEach(E=>{h(E.name,E.count)}),i.push(f)),a.launchConfigFiles.length>0){let E="|      Launch Configs:";a.launchConfigFiles.forEach(y=>{const N=y.count>1?` ${y.name}(${y.count})`:` ${y.name}`;E+=N}),i.push(E)}return i.join(`
`)}j(a){const i=Math.max(...Object.keys(a).map(n=>n.length));return Object.keys(a).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${a[n]}`).join(`
                  `)}k(a){const i=[],n=[];return a.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(h=>{const f=w.URI.revive(h);if(f.scheme===O.Schemas.file){const R=f.fsPath;n.push(p(R,["node_modules",".git"]).then(L=>{let E=`${L.fileCount} files`;L.maxFilesReached&&(E=`more than ${E}`),i.push(`|    Folder (${(0,T.$pc)(R)}): ${E}`),i.push(this.h(L))}).catch(L=>{i.push(`|      Error: Unable to collect workspace stats for folder ${R} (${L.toString()})`)}))}else i.push(`|    Folder (${f.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(a,i){const n=new Map;a.windows.forEach(h=>n.set(h.pid,`window [${h.id}] (${h.title})`)),a.pidToNames.forEach(({pid:h,name:f})=>n.set(h,f));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.n(a.mainPID,n,o,i,0),o.join(`
`)}n(a,i,n,o,h){const f=h===0;let R;f?R=o.pid===a?`${this.d.applicationName} main`:"remote agent":i.has(o.pid)?R=i.get(o.pid):R=`${"  ".repeat(h)} ${o.name}`;const L=process.platform==="win32"?o.mem:P.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(L/l.$Hl.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${R}`),Array.isArray(o.children)&&o.children.forEach(E=>this.n(a,i,n,E,h+1))}async getWorkspaceFileExtensions(a){const i=new Set;for(const{uri:n}of a.folders){const o=w.URI.revive(n);if(o.scheme!==O.Schemas.file)continue;const h=o.fsPath;try{(await p(h,["node_modules",".git"])).fileTypes.forEach(R=>i.add(R.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const n=w.URI.revive(i);if(n.scheme!==O.Schemas.file)continue;const o=n.fsPath;try{const h=await p(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),h.fileTypes.forEach(f=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:f.name,count:f.count})}),h.launchConfigFiles.forEach(f=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:f.name,count:f.count})}),h.configFiles.forEach(f=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:f.name,count:f.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:h.totalScanTime,reachedLimit:h.maxFilesReached,fileCount:h.fileCount,readdirCount:h.totalReaddirCount})}catch{}}}};e.$Ys=r,e.$Ys=r=ve([Q(0,v.$$l),Q(1,b.$sk)],r)}),define(ce[111],le([0,1,8,4,10,18]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=e.ExtensionSignatureVerificationCode=e.$qq=void 0,e.$qq=(0,c.$Fi)("IExtensionSignatureVerificationService");var T;(function(w){w.Success="Success",w.RequiredArgumentMissing="RequiredArgumentMissing",w.InvalidArgument="InvalidArgument",w.PackageIsUnreadable="PackageIsUnreadable",w.UnhandledException="UnhandledException",w.SignatureManifestIsMissing="SignatureManifestIsMissing",w.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",w.SignatureIsMissing="SignatureIsMissing",w.SignatureIsUnreadable="SignatureIsUnreadable",w.CertificateIsUnreadable="CertificateIsUnreadable",w.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",w.FileAlreadyExists="FileAlreadyExists",w.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",w.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",w.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",w.SignatureIsInvalid="SignatureIsInvalid",w.SignatureManifestIsInvalid="SignatureManifestIsInvalid",w.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",w.EntryIsMissing="EntryIsMissing",w.EntryIsTampered="EntryIsTampered",w.Untrusted="Untrusted",w.CertificateRevoked="CertificateRevoked",w.SignatureIsNotValid="SignatureIsNotValid",w.UnknownError="UnknownError",w.PackageIsInvalidZip="PackageIsInvalidZip",w.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(T||(e.ExtensionSignatureVerificationCode=T={}));class k extends Error{constructor(S){super(S),this.code=S}}e.$rq=k;let A=class{constructor(S,m){this.b=S,this.c=m}d(){return this.a||(this.a=new Promise((S,m)=>ne(["@vscode/vsce-sign"],async u=>S(u),m))),this.a}async verify(S,m,u,$){let l;const b=S.identifier.id;try{l=await this.d()}catch(I){return this.b.error("Could not load vsce-sign module",(0,P.$_)(I)),this.b.info(`Extension signature verification is not done: ${b}`),!1}const v=new Date().getTime();let d;try{this.b.trace(`Verifying extension signature for ${b}...`),d=await l.verify(m,u,this.b.getLevel()===C.LogLevel.Trace)}catch(I){d={code:T.UnknownError,didExecute:!1,output:(0,P.$_)(I)}}const p=new Date().getTime()-v;if(this.b.info(`Extension signature verification result for ${b}: ${d.code}. Executed: ${d.didExecute}. Duration: ${p}ms.`),this.b.trace(`Extension signature verification output for ${b}:
${d.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:b,extensionVersion:S.version,code:d.code,internalCode:d.internalCode,duration:p,didExecute:d.didExecute,clientTargetPlatform:$}),d.code===T.Success)return!0;throw new k(d.code)}};e.$sq=A,e.$sq=A=ve([Q(0,C.$_j),Q(1,O.$$l)],A)}),define(ce[112],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=e.$4fc=void 0;class P{constructor(O){this.b=O}listen(O,T){throw new Error(`Event not found: ${T}`)}call(O,T,{eventName:k,data:A}){return this.b.forEach(w=>w.log(k,A)),Promise.resolve(null)}}e.$4fc=P;class c{constructor(O){this.b=O}log(O,T){return this.b.call("log",{eventName:O,data:T}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$5fc=c}),define(ce[49],le([0,1,30,13,106,110,18]),function(ne,e,P,c,C,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=void 0,e.$Bp=S,e.$Cp=m,e.$Dp=u,e.$Ep=$,e.$Fp=b,e.$Gp=d,e.$Hp=p,e.$Ip=s;class k{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$up=k;class A{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vp=A,e.$wp=new A;class w{async publicLog(t,a,i){}async publicLogError(t,a,i){}}e.$xp=w,e.$yp="telemetry",e.$zp="extensionTelemetryLog",e.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function S(r,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!r.enableTelemetry)}function m(r,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}function u(r){const t=r.getValue(T.$hm),a=r.getValue(T.$im);if(r.getValue(T.$jm)===!1||a===!1)return T.TelemetryLevel.NONE;switch(t??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function $(r){const t={},a={},i={};v(r,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const o=i[n];typeof o=="number"?a[n]=o:typeof o=="boolean"?a[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),t[n]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(t[n]=o)}return{properties:t,measurements:a}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function b(r){if(!r)return"none";const t=(0,C.$hn)(r);return l.has(t)?t:"other"}function v(r,t,a=0,i){if(r)for(const n of Object.getOwnPropertyNames(r)){const o=r[n],h=i?i+n:n;Array.isArray(o)?t[h]=(0,P.$io)(o):o instanceof Date?t[h]=o.toISOString():(0,c.$hg)(o)?a<2?v(o,t,a+1,h+"."):t[h]=(0,P.$io)(o):t[h]=o}}function d(r,t){const a=r.msftInternalDomains||[],i=t.getValue("telemetry.internalTesting");return(0,O.$tp)(a)||i}function p(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}function I(r,t){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let a=r;const i=[];for(const f of t)for(;;){const R=f.exec(r);if(!R)break;i.push([R.index,f.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(a="";;){const f=o.exec(r);if(!f)break;const R=i.some(([L,E])=>f.index<E&&L<o.lastIndex);!n.test(f[0])&&!R&&(a+=r.substring(h,f.index)+"<REDACTED: user-file-path>",h=o.lastIndex)}return h<r.length&&(a+=r.substr(h)),a}function g(r){if(!r)return r;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of t)if(a.regex.test(r))return`<REDACTED: ${a.label}>`;return r}function s(r,t){return(0,P.$fo)(r,a=>{if(a instanceof k||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let i=a.replaceAll("%20"," ");i=I(i,t);for(const n of t)i=i.replace(n,"");return i=g(i),i}})}}),define(ce[33],le([0,1,27,28,36,5,9,8,37,49]),function(ne,e,P,c,C,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Kp=void 0,e.$Jp=S,e.$Lp=l,e.$Mp=b,e.$Np=v,e.$Op=d,e.$Pp=p,e.$Qp=I,e.$Rp=g,e.$Tp=s,e.$Up=t;function S(a,i){return a.uuid&&i.uuid?a.uuid===i.uuid:a.id===i.id?!0:(0,P.$Bf)(a.id,i.id)===0}const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new u(i.identifier,n,o)}static parse(i){const n=m.exec(i);return n&&n[1]&&n[2]?new u({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o=C.TargetPlatform.UNDEFINED){this.identifier=i,this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==C.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof u?S(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Kp=u;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(a){const i=$.exec(a);return i&&i[1]?[v(i[1]),i[2]]:[v(a),void 0]}function b(a,i){return`${a}.${i}`}function v(a){return a.toLowerCase()}function d(a,i){return v(b(a??C.$mn,i))}function p(a,i){const n=[],o=h=>{for(const f of n)if(f.some(R=>S(i(R),i(h))))return f;return null};for(const h of a){const f=o(h);f?f.push(h):n.push([h])}return n}function I(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function g(a){return{id:new w.$up(a.identifier.id),name:new w.$up(a.name),version:a.version,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Sp=new C.$qn("pprice.better-merge");function s(a,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const h=o.shift();if(h&&n.every(f=>!S(f.identifier,{id:h}))){const f=a.filter(R=>S(R.identifier,{id:h}));f.length===1&&(n.push(f[0]),o.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function r(a,i){if(!O.$k)return!1;let n;try{n=(await a.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await a.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){i.debug("Error while getting the os-release file.",(0,k.$_)(h))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function t(a,i){const n=await r(a,i),o=(0,c.$ep)(n?"alpine":O.$u,A.$gc);return i.debug("ComputeTargetPlatform:",o),o}}),define(ce[234],le([0,1,26,28,33,36]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V6b=T;async function T(k,A,w,S,m){try{const u=await k.getExtensionsControlManifest();if(!u.deprecated)return;const $=await k.getInstalled(O.ExtensionType.User);for(const[l,b]of Object.entries(u.deprecated)){if(!b?.extension)continue;const{id:v,autoMigrate:d,preRelease:p}=b.extension;if(!d)continue;const I=$.find(s=>(0,C.$Jp)(s.identifier,{id:l}));if(!I)continue;const g=(await A.getExtensions([{id:v,preRelease:p}],{targetPlatform:await k.getTargetPlatform(),compatible:!0},P.CancellationToken.None))[0];if(!g){m.info(`Skipping migrating '${I.identifier.id}' extension because, the comaptible target '${v}' extension is not found`);continue}try{m.info(`Migrating '${I.identifier.id}' extension to '${v}' extension...`);const s=!S.getDisabledExtensions().some(t=>(0,C.$Jp)(t,I.identifier));await k.uninstall(I),m.info(`Uninstalled the unsupported extension '${I.identifier.id}'`);let r=$.find(t=>(0,C.$Jp)(t.identifier,{id:v}));(!r||!r.isPreReleaseVersion&&s)&&(r=await k.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:I.isMachineScoped,operation:c.InstallOperation.Migrate}),m.info(`Installed the pre-release extension '${r.identifier.id}'`),s||(await S.disableExtension(r.identifier),m.info(`Disabled the pre-release extension '${r.identifier.id}' because the unsupported extension '${I.identifier.id}' is disabled`)),d.storage&&(w.addToMigrationList((0,C.$Mp)(I.manifest.publisher,I.manifest.name),(0,C.$Mp)(r.manifest.publisher,r.manifest.name)),m.info("Added pre-release extension to the storage migration list"))),m.info(`Migrated '${I.identifier.id}' extension to '${v}' extension.`)}catch(s){m.error(s)}}}catch(u){m.error(u)}}}),define(ce[235],le([0,1,3,2,35,33,36,7]),function(ne,e,P,c,C,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class A extends c.$Wc{constructor(S,m,u,$,l,b,v){super(),this.f=S,this.g=m,this.h=u,this.j=$,this.m=l,this.n=b,this.r=v,this.a=this.B(new P.$me),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new c.$6c),this.s().then(null,d=>v.error(d))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(S=>this.u(S.added))),this.B(this.j.onAddExtensions(S=>this.w(S))),this.B(this.j.onDidAddExtensions(S=>this.y(S))),this.B(this.j.onRemoveExtensions(S=>this.z(S))),this.B(this.j.onDidRemoveExtensions(S=>this.C(S))),this.B(this.n.onDidFilesChange(S=>this.D(S)))}async u(S){try{S.length&&await Promise.all(S.map(m=>(this.c.set(m.id,(0,c.$Tc)(this.n.watch(this.m.extUri.dirname(m.extensionsResource)),this.n.watch(m.extensionsResource))),this.G(m.extensionsResource))))}catch(m){throw this.r.error(m),m}}async w(S){for(const m of S.extensions)this.I(this.L(m.identifier,m.version),S.profileLocation)}async y(S){for(const m of S.extensions){const u=this.L(m.identifier,m.version);S.error?this.J(u,S.profileLocation):this.I(u,S.profileLocation)}}async z(S){for(const m of S.extensions)this.J(this.L(m.identifier,m.version),S.profileLocation)}async C(S){const m=[],u=[];for(const $ of S.extensions){const l=this.L($.identifier,$.version);S.error?this.I(l,S.profileLocation):(this.J(l,S.profileLocation),this.b.has(l)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),u.push(this.f.scanInstalledExtensionAtLocation($.location).then(b=>{b?m.push(b):this.r.info("Extension not found at the location",$.location.toString())},b=>this.r.error(b)))))}try{await Promise.all(u),m.length&&await this.H(m)}catch($){this.r.error($)}}D(S){for(const m of this.h.profiles)S.contains(m.extensionsResource,k.FileChangeType.UPDATED,k.FileChangeType.ADDED)&&this.F(m.extensionsResource)}async F(S){const m=[],u=[],$=await this.j.scanProfileExtensions(S),l=new Set,b=new Set;for(const[v,d]of this.b)d.has(S)&&b.add(v);for(const v of $){const d=this.L(v.identifier,v.version);l.add(d),b.has(d)||(m.push(v.identifier),this.I(d,S))}for(const v of b)if(!l.has(v)){const d=this.M(v);d&&(u.push(d.identifier),this.J(v,S))}(m.length||u.length)&&this.a.fire({added:m.length?{extensions:m,profileLocation:S}:void 0,removed:u.length?{extensions:u,profileLocation:S}:void 0})}async G(S){const m=await this.j.scanProfileExtensions(S);for(const u of m)this.I(this.L(u.identifier,u.version),S)}async H(S){S||(S=(await this.f.scanAllUserInstalledExtensions()).filter(u=>!this.b.has(this.L(u.identifier,u.manifest.version)))),S.length&&await this.f.markAsUninstalled(...S)}I(S,m){let u=this.b.get(S);u||this.b.set(S,u=new C.$Dc($=>this.m.extUri.getComparisonKey($))),u.add(m)}J(S,m){const u=this.b.get(S);u&&u.delete(m),u?.size||this.b.delete(S)}L(S,m){return`${T.$qn.toKey(S.id)}@${m}`}M(S){const[m,u]=(0,O.$Lp)(S);return u?{identifier:{id:m},version:u}:void 0}}e.$Uq=A}),define(ce[236],le([0,1,76,19,6,2,23,14,31,16,28,33,10,79,9]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=void 0;let b=class extends $.$0r{constructor(I,g,s,r){super(s),this.h=I,this.j=r,this.g=this.B(new v(g,r)),this.h.registerParticipant({postInstall:async t=>this.m(t),postUninstall:async t=>this.n(t)})}async getBuiltInExtensionTranslationsUri(I,g){const r=(await this.g.getLanguagePacks())[g];if(!r){this.j.warn(`No language pack found for ${g}`);return}const t=r.translations[I];return t?l.URI.file(t):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),g=Object.keys(I).map(s=>{const r=I[s];return{...this.f(s,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return g.push(this.f("en","English")),g.sort((s,r)=>s.label.localeCompare(r.label)),g}async m(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",I.identifier.id),await this.update())}async n(I){const g=await this.g.getLanguagePacks();Object.keys(g).some(s=>g[s]&&g[s].extensions.some(r=>(0,m.$Jp)(r.extensionIdentifier,I.identifier)))&&(this.j.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,g]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),s=await this.g.update(g);return!(0,c.$wb)(Object.keys(I),Object.keys(s))}};e.$$r=b,e.$$r=b=ve([Q(0,S.$lp),Q(1,w.$Ni),Q(2,S.$ip),Q(3,u.$_j)],b);let v=class extends O.$Wc{constructor(I,g){super(),this.j=g,this.c={},this.f=(0,k.$lc)(I.userDataPath,"languagepacks.json"),this.g=new C.$Mh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.s(g=>{Object.keys(g).forEach(s=>delete g[s]),this.m(g,...I)}).then(()=>this.c)}m(I,...g){for(const s of g)s&&s.manifest&&s.manifest.contributes&&s.manifest.contributes.localizations&&s.manifest.contributes.localizations.length&&this.n(I,s);Object.keys(I).forEach(s=>this.r(I[s]))}n(I,g){const s=g.identifier,r=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const t of r)if(g.location.scheme===T.Schemas.file&&d(t)){let a=I[t.languageId];a||(a={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},I[t.languageId]=a);const i=a.extensions.filter(n=>(0,m.$Jp)(n.extensionIdentifier,s))[0];i?i.version=g.manifest.version:a.extensions.push({extensionIdentifier:s,version:g.manifest.version});for(const n of t.translations)a.translations[n.id]=(0,k.$lc)(g.location.fsPath,n.path)}}r(I){if(I){const g=(0,P.createHash)("md5");for(const s of I.extensions)g.update(s.extensionIdentifier.uuid||s.extensionIdentifier.id).update(s.version);I.hash=g.digest("hex")}}s(I=()=>null){return this.g.queue(()=>{let g=null;return A.Promises.readFile(this.f,"utf8").then(void 0,s=>s.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(s)).then(s=>{try{return JSON.parse(s)}catch{return{}}}).then(s=>(g=I(s),s)).then(s=>{for(const t of Object.keys(s))s[t]||delete s[t];this.c=s,this.h=!0;const r=JSON.stringify(this.c);return this.j.debug("Writing language packs",r),A.Promises.writeFile(this.f,r)}).then(()=>g,s=>this.j.error(s))})}};v=ve([Q(0,w.$Ni),Q(1,u.$_j)],v);function d(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const I of p.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(ce[237],le([0,1,149,8,30,49]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bR=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function A(S,m,u){const $=await(0,P.$sE)("@microsoft/1ds-core-js","dist/ms.core.js"),l=await(0,P.$sE)("@microsoft/1ds-post-js","dist/ms.post.js"),b=new $.AppInsightsCore,v=new l.PostChannel,d={instrumentationKey:S,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(u){d.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:u};d.extensionConfig[v.identifier]=p}return b.initialize(d,[]),b.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',m&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),b}class w{constructor(m,u,$,l,b){this.e=m,this.f=u,this.g=$,this.h=b,this.c=T,this.d=k,this.g||(this.g={}),typeof l=="function"?this.a=l():this.a=l,this.b=null}i(m){if(this.a){if(typeof this.a!="string"){m(this.a);return}this.b||(this.b=A(this.a,this.e,this.h)),this.b.then(u=>{m(u)},u=>{(0,c.$3)(u),console.error(u)})}}log(m,u){if(!this.a)return;u=(0,C.$go)(u,this.g),u=(0,O.$Ep)(u);const $=this.f+"/"+m;try{this.i(l=>{l.pluginVersionString=u?.properties.version??"Unknown",l.track({name:$,baseData:{name:$,properties:u?.properties,measurements:u?.measurements}})})}catch{}}flush(){return this.a?new Promise(m=>{this.i(u=>{u.unload(!0,()=>{this.a=void 0,m(void 0)})})}):Promise.resolve(void 0)}}e.$bR=w}),define(ce[113],le([0,1,2,178,16,10,24,49]),function(ne,e,P,c,C,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;let A=class extends P.$Wc{constructor(S,m,u,$,l=""){super(),this.b=l;const b=m.getLogger(k.$yp);if(b)this.a=this.B(b);else{const d=(0,k.$Cp)($,u)?" (Not Sent)":"",p=()=>(0,k.$Bp)($,u)&&S.getLevel()===O.LogLevel.Trace;this.a=this.B(m.createLogger(k.$yp,{name:(0,c.localize)(0,null,d),hidden:!p()})),this.B(S.onDidChangeLogLevel(()=>m.setVisibility(k.$yp,p()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(S,m){this.a.trace(`${this.b}telemetry/${S}`,(0,k.$Ep)(m))}};e.$hdc=A,e.$hdc=A=ve([Q(0,O.$_j),Q(1,O.$ak),Q(2,C.$Mi),Q(3,T.$sk)],A)});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(ce[114],le([0,1,2,30,5,27,179,22,48,103,24,44,18,49]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,w=it(w);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,p,I){this.k=p,this.l=I,this.d={},this.i=new P.$Vc,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=u.TelemetryLevel.USAGE,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,O.$if)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.$if)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(u.$hm)||g.affectsConfiguration(u.$jm)||g.affectsConfiguration(u.$im))&&this.m()}))}setExperimentProperty(d,p){this.d[d]=p}m(){let d=(0,$.$Dp)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const I=p.usage?u.TelemetryLevel.USAGE:p.error?u.TelemetryLevel.ERROR:u.TelemetryLevel.NONE;d=Math.min(d,I)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,p,I){this.g<p||(I=(0,c.$go)(I,this.d),I=(0,$.$Ip)(I,this.j),I=(0,c.$go)(I,this.c),this.b.forEach(g=>g.log(d,I)))}publicLog(d,p){this.n(d,u.TelemetryLevel.USAGE,p)}publicLog2(d,p){this.publicLog(d,p)}publicLogError(d,p){this.h&&this.n(d,u.TelemetryLevel.ERROR,p)}publicLogError2(d,p){this.publicLogError(d,p)}};e.$es=l,e.$es=l=ve([Q(1,k.$_i),Q(2,S.$sk)],l);function b(){const v=(0,T.localize)(0,null,w.default.nameLong),d=w.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=C.$o?"":(0,T.localize)(3,null),I=(0,T.localize)(4,null),g=(0,T.localize)(5,null),s=(0,T.localize)(6,null),r=(0,T.localize)(7,null),t=`
|       | ${I} | ${g} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,T.localize)(8,null);return`
${v} ${d} ${p}

&nbsp;

${r}
${t}

&nbsp;

${a}
`}m.$qo.as(A.$vo.Configuration).registerConfiguration({id:u.$gm,order:1,type:"object",title:(0,T.localize)(9,null),properties:{[u.$hm]:{type:"string",enum:[u.TelemetryConfiguration.ON,u.TelemetryConfiguration.ERROR,u.TelemetryConfiguration.CRASH,u.TelemetryConfiguration.OFF],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:b(),default:u.TelemetryConfiguration.ON,restricted:!0,scope:A.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),m.$qo.as(A.$vo.Configuration).registerConfiguration({id:u.$gm,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[u.$jm]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,T.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,T.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${u.$hm}#\``),scope:A.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[238],le([0,1,15,26,281,237]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cR=void 0,C=Oe(C);async function T(S,m){const u=await m.request(S,c.CancellationToken.None),$=(await(0,P.$1e)(u.stream)).toString(),l=u.res.statusCode??200;return{headers:u.res.headers,statusCode:l,responseData:$}}async function k(S){const m={method:S.type,headers:S.headers};return new Promise(($,l)=>{const b=C.request(S.url??"",m,v=>{v.on("data",function(d){$({headers:v.headers,statusCode:v.statusCode??200,responseData:d.toString()})}),v.on("error",function(d){l(d)})});b.write(S.data,v=>{v&&l(v)}),b.end()})}async function A(S,m,u){const $=typeof m.data=="string"?m.data:new TextDecoder().decode(m.data),l={type:"POST",headers:{...m.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(m.data).toString()},url:m.urlString,data:$};try{const b=S?await T(l,S):await k(l);u(b.statusCode,b.headers,b.responseData)}catch{u(0,{})}}class w extends O.$bR{constructor(m,u,$,l,b){const v={sendPOST:(d,p)=>{A(m,d,p)}};super(u,$,l,b,v)}}e.$cR=w}),define(ce[239],le([0,1,23,96,22,16,10,24,18,112,113,114]),function(ne,e,P,c,C,O,T,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;let u=class{constructor(l,b,v,d,p,I){this.b=l,this.c=b,this.d=v,this.e=d,this.f=p,this.g=I,this.a=new Map}h(l){if(!this.a.has(l.id)){const b=Object.create(null);b["common.vscodemachineid"]=this.c.machineId,b["common.vscodesessionid"]=this.c.sessionId;const v=[l.id,JSON.stringify(b),l.aiKey],p=new c.$fr(P.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:v,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),I=[new w.$5fc(p),new S.$hdc(this.d,this.e,this.f,this.g,`[${l.id}] `)];this.a.set(l.id,new m.$es({appenders:I,sendErrorTelemetry:l.sendErrorTelemetry},this.b,this.g))}return this.a.get(l.id)}publicLog(l,b,v){this.h(l).publicLog(b,v)}publicLogError(l,b,v){this.h(l).publicLogError(b,v)}};e.$ghc=u,e.$ghc=u=ve([Q(0,C.$_i),Q(1,A.$$l),Q(2,T.$_j),Q(3,T.$ak),Q(4,O.$Mi),Q(5,k.$sk)],u)}),define(ce[81],le([0,1,3,2,5,9,22,4,10]),function(ne,e,P,c,C,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lw=e.$Kw=e.$Hw=e.$Fw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bw=e.$Aw=void 0,e.$Cw=m,e.$Dw=$,e.$Ew=l,e.$Gw=b,e.$Iw=v,e.$Jw=d,e.$Aw=(0,k.$Fi)("tunnelService"),e.$Bw=(0,k.$Fi)("sharedTunnelsService");var w;(function(g){g.Http="http",g.Https="https"})(w||(e.TunnelProtocol=w={}));var S;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(S||(e.TunnelPrivacyId=S={}));function m(g){return!!g.forwardPort}var u;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function $(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(s)return{address:s[1],port:+s[2]}}function l(g){if(g.scheme!=="http"&&g.scheme!=="https"||!g.query)return;const s=g.query.split("&");for(const r of s){const t=r.split("=")[1];if(/^https?:/.exec(t)){const a=$(O.URI.parse(t));if(a)return a}}}e.$Fw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(g){return e.$Fw.indexOf(g)>=0}e.$Hw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(g){return e.$Hw.indexOf(g)>=0}function d(g,s,r,t){if(r===C.OperatingSystem.Windows)return!1;if(r===C.OperatingSystem.Macintosh&&v(s)){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(a?.length===4&&parseInt(a[1])>=18)return!1}return g<1024}class p{constructor(s,r,t){this.remoteAddress=s,this.localAddress=r,this.b=t,this.a=new P.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Kw=p;let I=class extends c.$Wc{constructor(s,r){super(),this.r=s,this.s=r,this.a=new P.$me,this.onTunnelOpened=this.a.event,this.b=new P.$me,this.onTunnelClosed=this.b.event,this.c=new P.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const s=this.s.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.g=s,s?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.h=s.elevation,this.m=s.privacyOptions,this.j=s.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const s=[],r=Array.from(this.f.values());for(const t of r){const a=Array.from(t.values());for(const i of a){const n=await i.value;n&&typeof n!="string"&&s.push(n)}}return s}async dispose(){super.dispose();for(const s of this.f.values()){for(const{value:r}of s.values())await r.then(t=>typeof t!="string"?t?.dispose():void 0);s.clear()}this.f.clear()}setEnvironmentTunnel(s,r,t,a,i){this.z(s,r,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:r,localAddress:t,privacy:a,protocol:i,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,r){(v(s)||b(s))&&(s=e.$Fw[0]);const t=this.D(s,r);if(t)return++t.refcount,t.value}openTunnel(s,r,t,a,i,n=!1,o,h){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${t} on local port ${i}.`);const f=this.g??s;if(!f)return;if(r||(r="localhost"),a||(a=this.t),this.g&&this.n.has(t)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const R=this.F(f,r,t,a,i,n,o,h);return R?R.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(r,t),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(r,t);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.w(L);return(L.tunnelRemoteHost!==r||L.tunnelRemotePort!==t)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&L.privacy!==o&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(E),E}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),R)}w(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const r=this.f.get(s.tunnelRemoteHost);if(r){const t=r.get(s.tunnelRemotePort);t&&(t.refcount--,await this.y(s.tunnelRemoteHost,s.tunnelRemotePort,t))}}}}async y(s,r,t){if(t.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${r}.`);const a=t.value.then(async i=>{i&&typeof i!="string"&&(await i.dispose(!0),this.b.fire({host:i.tunnelRemoteHost,port:i.tunnelRemotePort}))});return this.f.has(s)&&this.f.get(s).delete(r),a}}async closeTunnel(s,r){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${r} `);const t=this.f.get(s);if(t&&t.has(r)){const a=t.get(r);a.refcount=0,await this.y(s,r,a)}}z(s,r,t){this.f.has(s)||this.f.set(s,new Map),this.f.get(s).set(r,{refcount:1,value:t})}async C(s,r){const t=this.f.get(s);if(t){const a=t.get(r),i=a?await a.value:void 0;(!i||typeof i=="string")&&t.delete(r),t.size===0&&this.f.delete(s)}}D(s,r){const t=[s];b(s)?(t.push(...e.$Fw),t.push(...e.$Hw)):v(s)&&t.push(...e.$Hw);const a=t.map(i=>this.f.get(i));for(const i of a){const n=i?.get(r);if(n)return n}}canTunnel(s){return!!$(s)}G(s,r,t,a,i,n,o){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${t} on local port ${a}.`);const h=t;this.n.add(h);const f=a===void 0?t:a,R={elevationRequired:i?this.isPortPrivileged(f):!1},L={remoteAddress:{host:r,port:t},localAddressPort:a,privacy:n,public:n?n!==S.Private:void 0,protocol:o},E=s.forwardPort(L,R);return E?(this.z(r,t,E),E.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(h)})):this.n.delete(h),E}};e.$Lw=I,e.$Lw=I=ve([Q(0,A.$_j),Q(1,T.$_i)],I)}),define(ce[240],le([0,1,10,81,2,8,6]),function(ne,e,P,c,C,O,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=void 0;class A extends C.$Wc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.$3h),this.b.p)}setAddress(m){this.a=m,this.b&&(this.b.complete(m),this.b=null)}setTunnel(m){this.B(m)}}let w=class extends C.$Wc{static{k=this}static{this.a=0}constructor(m,u){super(),this.f=m,this.g=u,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(m=>m.dispose())}async createTunnel(){return{id:String(++k.a)}}async startTunnel(m,u,$,l,b,v,d){const p=new A,I=await Promise.resolve(this.f.openTunnel(m,p,$,l,b,v,d));if(!I||typeof I=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${$}:${l} (remote).`),p.dispose(),new Error("Could not create tunnel");if(this.c.has(u))throw this.c.delete(u),p.dispose(),await I.dispose(),(0,O.$8)();return p.setTunnel(I),this.b.set(u,p),this.g.info(`[SharedProcessTunnelService] Created tunnel ${u}: ${I.localAddress} (local) to ${$}:${l} (remote).`),{tunnelLocalPort:I.tunnelLocalPort,localAddress:I.localAddress}}async setAddress(m,u){const $=this.b.get(m);$&&$.setAddress(u)}async destroyTunnel(m){const u=this.b.get(m);if(u){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${m}.`),this.b.delete(m),await u.dispose();return}this.c.add(m)}};e.$qhc=w,e.$qhc=w=k=ve([Q(0,c.$Bw),Q(1,P.$_j)],w)}),define(ce[29],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,P.$Fi)("IUriIdentityService")}),define(ce[241],le([0,1,29,197,7,21,133,3,2]),function(ne,e,P,c,C,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class w{static{this._clock=0}constructor(u){this.uri=u,this.time=w._clock++}touch(){return this.time=w._clock++,this}}let S=class{constructor(u){this.g=u,this.c=new A.$Vc,this.f=2**16;const $=new Map,l=b=>{let v=$.get(b.scheme);return v===void 0&&(v=u.hasProvider(b)&&!this.g.hasCapability(b,C.FileSystemProviderCapabilities.PathCaseSensitive),$.set(b.scheme,v)),v};this.c.add(k.Event.any(u.onDidChangeFileSystemProviderRegistrations,u.onDidChangeFileSystemProviderCapabilities)(b=>{$.delete(b.scheme)})),this.extUri=new O.$8g(l),this.d=new T.$Qs((b,v)=>this.extUri.compare(b,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(u){this.g.hasProvider(u)&&(u=(0,O.$hh)(u));const $=this.d.get(u);return $?$.touch().uri.with({fragment:u.fragment}):(this.d.set(u,new w(u)),this.h(),u)}h(){if(this.d.size<this.f)return;const u=[...this.d.entries()].sort((l,b)=>l[1].time<b[1].time?1:l[1].time>b[1].time?-1:0);w._clock=0,this.d.clear();const $=this.f*.5;for(let l=0;l<$;l++)this.d.set(u[l][0],u[l][1].touch())}};e.$Rs=S,e.$Rs=S=ve([Q(0,C.$_k)],S),(0,c.$Os)(P.$Jl,S,c.InstantiationType.Delayed)}),define(ce[242],le([0,1,3,2,7,52,35]),function(ne,e,P,c,C,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0;class k extends c.$Wc{constructor(w,S,m,u,$,l){super(),this.f=w,this.g=S,this.h=m,this.j=u,this.m=$,this.n=l,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$me),this.onDidChangeFile=this.a.event,this.b=O.$Li.forUris(()=>!(this.capabilities&C.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new T.$Dc(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B(u.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const w of this.j.profiles)this.c.add(w.settingsResource),this.c.add(w.keybindingsResource),this.c.add(w.tasksResource),this.c.add(w.extensionsResource)}open(w,S){return this.g.open(this.t(w),S)}close(w){return this.g.close(w)}read(w,S,m,u,$){return this.g.read(w,S,m,u,$)}write(w,S,m,u,$){return this.g.write(w,S,m,u,$)}watch(w,S){this.b.set(w,w);const m=this.g.watch(this.t(w),S);return(0,c.$Uc)(()=>{this.b.delete(w),m.dispose()})}stat(w){return this.g.stat(this.t(w))}mkdir(w){return this.g.mkdir(this.t(w))}rename(w,S,m){return this.g.rename(this.t(w),this.t(S),m)}readFile(w,S){return this.g.readFile(this.t(w),S)}readFileStream(w,S,m){return this.g.readFileStream(this.t(w),S,m)}readdir(w){return this.g.readdir(this.t(w))}enforceAtomicReadFile(w){return this.c.has(w)}writeFile(w,S,m){return this.g.writeFile(this.t(w),S,m)}enforceAtomicWriteFile(w){return this.c.has(w)?{postfix:".vsctmp"}:!1}delete(w,S){return this.g.delete(this.t(w),S)}copy(w,S,m){if((0,C.$dl)(this.g))return this.g.copy(this.t(w),this.t(S),m);throw new Error("copy not supported")}cloneFile(w,S){if((0,C.$el)(this.g))return this.g.cloneFile(this.t(w),this.t(S));throw new Error("clone not supported")}s(w){const S=[];for(const m of w){if(m.resource.scheme!==this.f)continue;const u=this.u(m.resource);this.b.findSubstr(u)&&S.push({resource:u,type:m.type,cId:m.cId})}S.length&&(this.n.debug("User data changed"),this.a.fire(S))}t(w){return w.with({scheme:this.f})}u(w){return w.with({scheme:this.h})}}e.$Tgc=k}),define(ce[82],le([0,1,65]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=c,e.$rMb=C,e.$sMb=O;function c(T,k,A,w){const S=(0,P.$_n)(T,k,A,w)[0];return S&&(T=T.substring(0,S.offset)+S.content+T.substring(S.offset+S.length)),T}function C(T,k,A){let w=A;for(;w>=0;){if(T.charAt(w)===k.charAt(k.length-1)&&k.length===1)return w+1;if(w--,k.length===2&&w>=0&&T.charAt(w)===k.charAt(0))return w+2}return 0}function O(T,k,A){let w=A;for(;w>=0;)if(T.charAt(w)===k.charAt(k.length-1)&&k.length===1||(w++,k.length===2&&w>=0&&T.charAt(w)===k.charAt(1)))return w;return T.length-1}}),define(ce[243],le([0,1,30,61,13]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=O,c=Oe(c);function O($,l,b,v,d,p){const I=[],g=[],s=[];if(!l){const M=$.filter(({identifier:J})=>d.every(W=>W.toLowerCase()!==J.id.toLowerCase()));return{local:{added:I,removed:g,updated:s},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}$=$.map(m),l=l.map(m),b=b?b.map(m):null;const r=new Map,t=M=>{M.uuid&&r.set(M.id.toLowerCase(),M.uuid)};$.forEach(({identifier:M})=>t(M)),l.forEach(({identifier:M})=>t(M)),b?.forEach(({identifier:M})=>t(M)),v?.forEach(({identifier:M})=>t(M)),p?.forEach(M=>t(M));const a=M=>{const J=M.identifier.uuid||r.get(M.identifier.id.toLowerCase());return J?`uuid:${J}`:`id:${M.identifier.id.toLowerCase()}`},i=(M,J)=>(M.set(a(J),J),M),n=$.reduce(i,new Map),o=l.reduce(i,new Map),h=l.reduce((M,J)=>i(M,(0,P.$do)(J)),new Map),f=b?b.reduce(i,new Map):null,R=v.reduce(i,new Map),L=d.reduce((M,J)=>{const W=r.get(J.toLowerCase());return M.add(W?`uuid:${W}`:`id:${J.toLowerCase()}`)},new Set),E=p?p.reduce((M,{id:J,uuid:W})=>(W=W??r.get(J.toLowerCase()),M.add(W?`uuid:${W}`:`id:${J.toLowerCase()}`)),new Set):null,y=T(n,o,L,!1);if(y.added.size>0||y.removed.size>0||y.updated.size>0){const M=T(f,n,L,!1),J=T(f,o,L,!0),W=(x,G,ie,V)=>{let z,te,se;return G.installed?(z=V.pinned,se=V.preRelease,z&&(te=V.version)):(z=ie.pinned,se=ie.preRelease,z&&(te=ie.version)),z===void 0&&(z=G.pinned,z&&(te=G.version)),se===void 0&&(se=G.preRelease),{...V,installed:G.installed||ie.installed,pinned:z,preRelease:se,version:te??(ie.version&&(!G.installed||c.gt(ie.version,G.version))?ie.version:G.version),state:A(G,ie,f?.get(x))}};for(const x of J.removed.values()){const G=n.get(x);if(!G)continue;const ie=(0,C.$qg)(f?.get(x)),V=E&&!E.has(x)&&ie.installed;G.installed&&V?g.push(G.identifier):h.set(x,G)}for(const x of J.added.values()){const G=(0,C.$qg)(o.get(x)),ie=n.get(x);if(ie){if(y.updated.has(x)){const V=W(x,ie,G,G);k(ie,G,!1,!1)||s.push(u(V,x)),h.set(x,V)}}else G.installed&&I.push(u(G,x))}for(const x of J.updated.values()){const G=(0,C.$qg)(o.get(x)),ie=(0,C.$qg)(f?.get(x)),V=n.get(x);if(V)if(E&&!E.has(x)&&ie.installed&&V.installed&&!G.installed)g.push(V.identifier);else{const te=W(x,V,G,G);s.push(u(te,x)),h.set(x,te)}else G.installed&&I.push(u(G,x))}for(const x of M.added.values())J.added.has(x)||h.set(x,(0,C.$qg)(n.get(x)));for(const x of M.updated.values()){if(J.removed.has(x)||J.updated.has(x))continue;const G=(0,C.$qg)(n.get(x)),ie=(0,C.$qg)(o.get(x));h.set(x,W(x,G,ie,G))}for(const x of M.removed.values())J.updated.has(x)||J.removed.has(x)||R.has(x)||(0,C.$qg)(o.get(x)).installed&&E&&(E.has(x)||!(0,C.$qg)(f?.get(x)).installed||h.delete(x))}const N=[],F=T(o,h,new Set,!0),D=F.added.size>0||F.updated.size>0||F.removed.size>0;return D&&h.forEach((M,J)=>N.push(u(M,J))),{local:{added:I,removed:g,updated:s},remote:D?{added:[...F.added].map(M=>h.get(M)),updated:[...F.updated].map(M=>h.get(M)),removed:[...F.removed].map(M=>o.get(M)),all:N}:null}}function T($,l,b,v){const d=$?[...$.keys()].filter(r=>!b.has(r)):[],p=[...l.keys()].filter(r=>!b.has(r)),I=p.filter(r=>!d.includes(r)).reduce((r,t)=>(r.add(t),r),new Set),g=d.filter(r=>!p.includes(r)).reduce((r,t)=>(r.add(t),r),new Set),s=new Set;for(const r of d){if(g.has(r))continue;const t=$.get(r),a=l.get(r);(!a||!k(t,a,v,!0))&&s.add(r)}return{added:I,removed:g,updated:s}}function k($,l,b,v){return!($.disabled!==l.disabled||!!$.isApplicationScoped!=!!l.isApplicationScoped||v&&$.installed!==l.installed||$.installed&&l.installed&&($.preRelease!==l.preRelease||$.pinned!==l.pinned||l.pinned&&$.version!==l.version)||!S($.state,l.state)||b&&$.version!==l.version)}function A($,l,b){const v=$.state,d=l.state,p=b?.state;if(!l.version||v&&c.gt($.version,l.version))return v;if(d&&c.gt(l.version,$.version)||!v)return d;if(!d)return v;const I=(0,P.$do)(v),g=p?w(p,d):{added:Object.keys(d).reduce((r,t)=>(r.add(t),r),new Set),removed:new Set,updated:new Set},s=p?w(p,v):{added:Object.keys(v).reduce((r,t)=>(r.add(t),r),new Set),removed:new Set,updated:new Set};for(const r of[...g.added.values(),...g.updated.values()])I[r]=d[r];for(const r of g.removed.values())s.updated.has(r)||delete I[r];return I}function w($,l){const b=Object.keys($),v=Object.keys(l),d=v.filter(g=>!b.includes(g)).reduce((g,s)=>(g.add(s),g),new Set),p=b.filter(g=>!v.includes(g)).reduce((g,s)=>(g.add(s),g),new Set),I=new Set;for(const g of b){if(p.has(g))continue;const s=$[g],r=l[g];(0,P.$ho)(s,r)||I.add(g)}return{added:d,removed:p,updated:I}}function S($={},l={}){const{added:b,removed:v,updated:d}=w($,l);return b.size===0&&v.size===0&&d.size===0}function m($){return{...$,disabled:!!$.disabled,installed:!!$.installed}}function u($,l){const b={...$,identifier:{id:$.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!$.preRelease,pinned:!!$.pinned};return $.disabled||delete b.disabled,$.installed||delete b.installed,$.state||delete b.state,$.isApplicationScoped||delete b.isApplicationScoped,b}}),define(ce[115],le([0,1,19,22,4]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IOb=e.$HOb=void 0,e.$HOb=(0,C.$Fi)("IIgnoredExtensionsManagementService");let O=class{constructor(k){this.a=k}hasToNeverSyncExtension(k){return this.b().includes(k.toLowerCase())}hasToAlwaysSyncExtension(k){return this.b().includes(`-${k.toLowerCase()}`)}updateIgnoredExtensions(k,A){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return w=w.filter(S=>S!==k&&S!==`-${k}`),A&&w.push(k.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,c.ConfigurationTarget.USER)}updateSynchronizedExtensions(k,A){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return w=w.filter(S=>S!==k&&S!==`-${k}`),A&&w.push(`-${k.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,c.ConfigurationTarget.USER)}getIgnoredExtensions(k){const A=k.filter(u=>u.isMachineScoped).map(u=>u.identifier.id.toLowerCase()),w=this.b().map(u=>u.toLowerCase()),S=[],m=[];if(Array.isArray(w))for(const u of w)u.startsWith("-")?m.push(u.substring(1)):S.push(u);return(0,P.$Ob)([...A,...S].filter(u=>!m.includes(u)))}b(){let k=this.a.inspect("settingsSync.ignoredExtensions").userValue;return k!==void 0||(k=this.a.inspect("sync.ignoredExtensions").userValue,k!==void 0)?k:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(A=>A.toLowerCase())}};e.$IOb=O,e.$IOb=O=ve([Q(0,c.$_i)],O)}),define(ce[244],le([0,1,19,34,30,97,82]),function(ne,e,P,c,C,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=A,C=Oe(C),T=Oe(T);function k(g){return(0,c.$Xn)(g)||[]}async function A(g,s,r,t,a){const i=k(g),n=k(s),o=r?k(r):null,h=[...i,...n,...o||[]].map(W=>W.key),f=await a.resolveUserBindings(h),R=S(i,n,o,f);if(!R.hasLocalForwarded&&!R.hasRemoteForwarded)return{mergeContent:g,hasChanges:!1,hasConflicts:!1};if(!R.hasLocalForwarded&&R.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};if(R.hasLocalForwarded&&!R.hasRemoteForwarded)return{mergeContent:g,hasChanges:!0,hasConflicts:!1};const L=u(i),E=u(n),y=o?u(o):null,N=l(L,E,f),F=y?l(y,L,f):{added:[...L.keys()].reduce((W,x)=>(W.add(x),W),new Set),removed:new Set,updated:new Set},D=y?l(y,E,f):{added:[...E.keys()].reduce((W,x)=>(W.add(x),W),new Set),removed:new Set,updated:new Set},M=w(N,F,D);let J=g;for(const W of M.removed.values())M.conflicts.has(W)||(J=p(J,W,t));for(const W of M.added.values()){if(M.conflicts.has(W))continue;const x=E.get(W);if(x.some(G=>G.command!==`-${W}`&&R.conflicts.has(f[G.key]))){M.conflicts.add(W);continue}J=d(J,x,t)}for(const W of M.updated.values()){if(M.conflicts.has(W))continue;const x=E.get(W);if(x.some(G=>G.command!==`-${W}`&&R.conflicts.has(f[G.key]))){M.conflicts.add(W);continue}J=I(J,W,x,t)}return{mergeContent:J,hasChanges:!0,hasConflicts:M.conflicts.size>0}}function w(g,s,r){const t=new Set,a=new Set,i=new Set,n=new Set;for(const o of s.removed.values())r.updated.has(o)&&n.add(o);for(const o of r.removed.values())n.has(o)||(s.updated.has(o)?n.add(o):a.add(o));for(const o of s.added.values())n.has(o)||r.added.has(o)&&g.updated.has(o)&&n.add(o);for(const o of r.added.values())n.has(o)||(s.added.has(o)?g.updated.has(o)&&n.add(o):t.add(o));for(const o of s.updated.values())n.has(o)||r.updated.has(o)&&g.updated.has(o)&&n.add(o);for(const o of r.updated.values())n.has(o)||(s.updated.has(o)?g.updated.has(o)&&n.add(o):i.add(o));return{added:t,removed:a,updated:i,conflicts:n}}function S(g,s,r,t){const a=new Set,i=m(g,t),n=m(s,t),o=r?m(r,t):null,h=$(i,n);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:a,removed:a,updated:a,conflicts:a};const f=o?$(o,i):{added:[...i.keys()].reduce((F,D)=>(F.add(D),F),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:a,removed:a,updated:a,conflicts:a};const R=o?$(o,n):{added:[...n.keys()].reduce((F,D)=>(F.add(D),F),new Set),removed:new Set,updated:new Set};if(R.added.size===0&&R.removed.size===0&&R.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:a,removed:a,updated:a,conflicts:a};const{added:L,removed:E,updated:y,conflicts:N}=w(h,f,R);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:L,removed:E,updated:y,conflicts:N}}function m(g,s){const r=new Map;for(const t of g){const a=s[t.key];let i=r.get(a);i||(i=[],r.set(a,i)),i.push(t)}return r}function u(g){const s=new Map;for(const r of g){const t=r.command[0]==="-"?r.command.substring(1):r.command;let a=s.get(t);a||(a=[],s.set(t,a)),a.push(r)}return s}function $(g,s){const r=[...g.keys()],t=[...s.keys()],a=t.filter(o=>!r.includes(o)).reduce((o,h)=>(o.add(h),o),new Set),i=r.filter(o=>!t.includes(o)).reduce((o,h)=>(o.add(h),o),new Set),n=new Set;for(const o of r){if(i.has(o))continue;const h=g.get(o).map(R=>({...R,key:o})),f=s.get(o).map(R=>({...R,key:o}));(0,P.$wb)(h,f,(R,L)=>v(R,L))||n.add(o)}return{added:a,removed:i,updated:n}}function l(g,s,r){const t=[...g.keys()],a=[...s.keys()],i=a.filter(h=>!t.includes(h)).reduce((h,f)=>(h.add(f),h),new Set),n=t.filter(h=>!a.includes(h)).reduce((h,f)=>(h.add(f),h),new Set),o=new Set;for(const h of t){if(n.has(h))continue;const f=g.get(h).map(L=>({...L,key:r[L.key]})),R=s.get(h).map(L=>({...L,key:r[L.key]}));b(f,R)||o.add(h)}return{added:i,removed:n,updated:o}}function b(g,s){return!(!(0,P.$wb)(g.filter(({command:r})=>r[0]!=="-"),s.filter(({command:r})=>r[0]!=="-"),(r,t)=>v(r,t))||!(0,P.$wb)(g.filter(({command:r})=>r[0]==="-"),s.filter(({command:r})=>r[0]==="-"),(r,t)=>v(r,t)))}function v(g,s){if(g.command!==s.command||g.key!==s.key)return!1;const r=O.$Dj.deserialize(g.when),t=O.$Dj.deserialize(s.when);return!(r&&!t||!r&&t||r&&t&&!r.equals(t)||!C.$ho(g.args,s.args))}function d(g,s,r){for(const t of s)g=T.edit(g,[-1],t,r);return g}function p(g,s,r){const t=k(g);for(let a=t.length-1;a>=0;a--)(t[a].command===s||t[a].command===`-${s}`)&&(g=T.edit(g,[a],void 0,r));return g}function I(g,s,r,t){const a=k(g),i=a.findIndex(n=>n.command===s||n.command===`-${s}`);for(let n=a.length-1;n>=0;n--)(a[n].command===s||a[n].command===`-${s}`)&&(g=T.edit(g,[n],void 0,t));for(let n=r.length-1;n>=0;n--)g=T.edit(g,[i],r[n],t);return g}}),define(ce[245],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=P,e.$_bc=C;function P(O,T,k){const A={},w={},S=new Set;if(!T)return{local:{added:A,updated:w,removed:[...S.values()]},remote:{added:O,updated:{},removed:[]},conflicts:[]};const m=c(O,T);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{local:{added:A,updated:w,removed:[...S.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const u=c(k,O),$=c(k,T),l={},b={},v=new Set,d=new Set;for(const p of u.removed.values())$.updated.has(p)?A[p]=T[p]:v.add(p);for(const p of $.removed.values())d.has(p)||(u.updated.has(p)?d.add(p):S.add(p));for(const p of u.updated.values())d.has(p)||($.updated.has(p)?m.updated.has(p)&&d.add(p):b[p]=O[p]);for(const p of $.updated.values())d.has(p)||(u.updated.has(p)?m.updated.has(p)&&d.add(p):O[p]!==void 0&&(w[p]=T[p]));for(const p of u.added.values())d.has(p)||($.added.has(p)?m.updated.has(p)&&d.add(p):l[p]=O[p]);for(const p of $.added.values())d.has(p)||(u.added.has(p)?m.updated.has(p)&&d.add(p):A[p]=T[p]);return{local:{added:A,removed:[...S.values()],updated:w},remote:{added:l,removed:[...v.values()],updated:b},conflicts:[...d.values()]}}function c(O,T){const k=O?Object.keys(O):[],A=T?Object.keys(T):[],w=A.filter(u=>!k.includes(u)).reduce((u,$)=>(u.add($),u),new Set),S=k.filter(u=>!A.includes(u)).reduce((u,$)=>(u.add($),u),new Set),m=new Set;for(const u of k){if(S.has(u))continue;const $=O[u],l=T[u];$!==l&&m.add(u)}return{added:w,removed:S,updated:m}}function C(O,T){const{added:k,removed:A,updated:w}=c(O,T);return k.size===0&&A.size===0&&w.size===0}}),define(ce[246],le([0,1,30]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=c;function c(O,T,k,A){const w={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!T){const u=O.filter(({id:$})=>!A.includes($));return u.length?S.added=u:S=null,{local:w,remote:S}}const m=C(O,T,A);if(m.added.length>0||m.removed.length>0||m.updated.length>0){const u=C(k,O,A),$=C(k,T,A);for(const l of $.removed){const b=O.find(v=>v.id===l);b&&w.removed.push(b)}for(const l of $.added){const b=T.find(v=>v.id===l);u.added.includes(l)?m.updated.includes(l)&&w.updated.push(b):w.added.push(b)}for(const l of $.updated)w.updated.push(T.find(b=>b.id===l));for(const l of u.added)$.added.includes(l)||S.added.push(O.find(b=>b.id===l));for(const l of u.updated)$.removed.includes(l)||$.updated.includes(l)||S.updated.push(O.find(b=>b.id===l));for(const l of u.removed){const b=T.find(v=>v.id===l);b&&S.removed.push(b)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:w,remote:S}}function C(O,T,k){O=O?O.filter(({id:$})=>!k.includes($)):[],T=T.filter(({id:$})=>!k.includes($));const A=O.map(({id:$})=>$),w=T.map(({id:$})=>$),S=w.filter($=>!A.includes($)),m=A.filter($=>!w.includes($)),u=[];for(const{id:$,name:l,shortName:b,icon:v,useDefaultFlags:d}of O){if(m.includes($))continue;const p=T.find(I=>I.id===$);(!p||p.name!==l||p.shortName!==b||p.icon!==v||!(0,P.$ho)(p.useDefaultFlags,d))&&u.push($)}return{added:S,removed:m,updated:u}}}),define(ce[25],le([0,1,19,13,185,48,28,4,104,44]),function(ne,e,P,c,C,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Knb=e.$Jnb=e.$Inb=e.$Hnb=e.$Gnb=e.$Fnb=e.$Enb=e.$Dnb=e.$Cnb=e.$Anb=e.MergeState=e.Change=e.SyncStatus=e.$znb=e.$ynb=e.$xnb=e.UserDataSyncErrorCode=e.$vnb=e.$unb=e.$tnb=e.$snb=e.$rnb=e.$onb=e.SyncResource=e.$lnb=e.$knb=void 0,e.$inb=S,e.$jnb=m,e.$mnb=u,e.$nnb=$,e.$pnb=b,e.$qnb=v,e.$wnb=d,e.$Bnb=i;function S(){const n=w.$qo.as(O.$vo.Configuration).getConfigurationProperties();return Object.keys(n).filter(o=>!!n[o].disallowSyncIgnore)}function m(){const n=w.$qo.as(O.$vo.Configuration).getConfigurationProperties(),o=Object.keys(n).filter(R=>!!n[R].ignoreSync),h=Object.keys(n).filter(R=>n[R].scope===O.ConfigurationScope.MACHINE||n[R].scope===O.ConfigurationScope.MACHINE_OVERRIDABLE),f=S();return(0,P.$Ob)([...o,...h,...f])}e.$knb="settingsSync",e.$lnb="settingsSync.keybindingsPerPlatform";function u(){const n="vscode://schemas/ignoredSettings",o=w.$qo.as(O.$vo.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,C.localize)(0,null),type:"object",properties:{[e.$lnb]:{type:"boolean",description:(0,C.localize)(1,null),default:!0,scope:O.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,C.localize)(2,null),items:[{type:"string",pattern:T.$8o,errorMessage:(0,C.localize)(3,null)}],default:[],scope:O.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,C.localize)(4,null),default:[],scope:O.ConfigurationScope.APPLICATION,$ref:n,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=w.$qo.as(A.$ro.JSONContribution),f=()=>{const R=S(),L=m(),E=Object.keys(O.$wo.properties).filter(F=>!L.includes(F)),y=L.filter(F=>!R.includes(F)),N={items:{type:"string",enum:[...E,...y.map(F=>`-${F}`)]}};h.registerSchema(n,N)};return o.onDidUpdateConfiguration(()=>f())}function $(n){return n&&(0,c.$hg)(n)&&(0,c.$fg)(n.id)&&Array.isArray(n.scopes)}var l;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState",n.Profiles="profiles",n.WorkspaceState="workspaceState"})(l||(e.SyncResource=l={})),e.$onb=[l.Settings,l.Keybindings,l.Snippets,l.Tasks,l.Extensions,l.GlobalState,l.Profiles];function b(n,...o){return n?[n,...o]:o}function v(n,o,h,f){return f.joinPath(h.userDataSyncHome,...b(n,o,`lastSync${o}.json`))}e.$rnb=(0,k.$Fi)("IUserDataSyncStoreManagementService"),e.$snb=(0,k.$Fi)("IUserDataSyncStoreService"),e.$tnb=(0,k.$Fi)("IUserDataSyncLocalStoreService"),e.$unb="x-operation-id",e.$vnb="X-Execution-Id";function d(n){const o={};return o[e.$vnb]=n,o}var p;(function(n){n.Unauthorized="Unauthorized",n.Forbidden="Forbidden",n.NotFound="NotFound",n.MethodNotFound="MethodNotFound",n.Conflict="Conflict",n.Gone="Gone",n.PreconditionFailed="PreconditionFailed",n.TooLarge="TooLarge",n.UpgradeRequired="UpgradeRequired",n.PreconditionRequired="PreconditionRequired",n.TooManyRequests="RemoteTooManyRequests",n.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",n.RequestFailed="RequestFailed",n.RequestCanceled="RequestCanceled",n.RequestTimeout="RequestTimeout",n.RequestProtocolNotSupported="RequestProtocolNotSupported",n.RequestPathNotEscaped="RequestPathNotEscaped",n.RequestHeadersNotObject="RequestHeadersNotObject",n.NoCollection="NoCollection",n.NoRef="NoRef",n.EmptyResponse="EmptyResponse",n.TurnedOff="TurnedOff",n.SessionExpired="SessionExpired",n.ServiceChanged="ServiceChanged",n.DefaultServiceChanged="DefaultServiceChanged",n.LocalTooManyProfiles="LocalTooManyProfiles",n.LocalTooManyRequests="LocalTooManyRequests",n.LocalPreconditionFailed="LocalPreconditionFailed",n.LocalInvalidContent="LocalInvalidContent",n.LocalError="LocalError",n.IncompatibleLocalContent="IncompatibleLocalContent",n.IncompatibleRemoteContent="IncompatibleRemoteContent",n.Unknown="Unknown"})(p||(e.UserDataSyncErrorCode=p={}));class I extends Error{constructor(o,h,f,R){super(o),this.code=h,this.resource=f,this.operationId=R,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$xnb=I;class g extends I{constructor(o,h,f,R,L){super(o,f,void 0,L),this.url=h,this.serverCode=R}}e.$ynb=g;class s extends I{constructor(o,h){super(o,h)}}e.$znb=s,function(n){function o(h){if(h instanceof n)return h;const f=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(f&&f[1]){const R=f[2]==="unknown"?void 0:f[2],L=f[3]==="unknown"?void 0:f[3];return new n(h.message,f[1],R,L)}return new n(h.message,p.Unknown)}n.toUserDataSyncError=o}(I||(e.$xnb=I={}));var r;(function(n){n.Uninitialized="uninitialized",n.Idle="idle",n.Syncing="syncing",n.HasConflicts="hasConflicts"})(r||(e.SyncStatus=r={}));var t;(function(n){n[n.None=0]="None",n[n.Added=1]="Added",n[n.Modified=2]="Modified",n[n.Deleted=3]="Deleted"})(t||(e.Change=t={}));var a;(function(n){n.Preview="preview",n.Conflict="conflict",n.Accepted="accepted"})(a||(e.MergeState=a={})),e.$Anb="sync.store.url.type";function i(n){return`sync.enable.${n}`}e.$Cnb=(0,k.$Fi)("IUserDataSyncEnablementService"),e.$Dnb=(0,k.$Fi)("IUserDataSyncService"),e.$Enb=(0,k.$Fi)("IUserDataSyncResourceProviderService"),e.$Fnb=(0,k.$Fi)("IUserDataAutoSyncService"),e.$Gnb=(0,k.$Fi)("IUserDataSyncUtilService"),e.$Hnb=(0,k.$Fi)("IUserDataSyncLogService"),e.$Inb="userDataSync",e.$Jnb="vscode-userdata-sync",e.$Knb="preview"}),define(ce[247],le([0,1,30,25]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZNb=C,P=Oe(P);function C(T,k,A,w,S){if(!k)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const m=O(T,k);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const u=A?O(A,k):{added:Object.keys(k).reduce((p,I)=>(p.add(I),p),new Set),removed:new Set,updated:new Set},$=A?O(A,T):{added:Object.keys(T).reduce((p,I)=>(p.add(I),p),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},b=P.$do(k),v=!A;for(const p of $.added.values())p!==c.$Anb&&v&&u.added.has(p)||(b[p]=T[p]);for(const p of $.updated.values())b[p]=T[p];for(const p of $.removed.values())w.unregistered.includes(p)||delete b[p];for(const p of u.added.values()){const I=k[p];if(w.machine.includes(p)){S.info(`GlobalState: Skipped adding ${p} in local storage because it is declared as machine scoped.`);continue}if(A&&$.added.has(p))continue;const g=T[p];g&&g.value===I.value||p===c.$Anb&&v&&$.added.has(p)||(g?l.updated[p]=I:l.added[p]=I)}for(const p of u.updated.values()){const I=k[p];if(w.machine.includes(p)){S.info(`GlobalState: Skipped updating ${p} in local storage because it is declared as machine scoped.`);continue}if($.updated.has(p)||$.removed.has(p))continue;const g=T[p];g&&g.value===I.value||(l.updated[p]=I)}for(const p of u.removed.values()){if(w.machine.includes(p)){S.trace(`GlobalState: Skipped removing ${p} in local storage because it is declared as machine scoped.`);continue}$.updated.has(p)||$.removed.has(p)||l.removed.push(p)}const d=O(k,b);return{local:l,remote:{added:[...d.added],updated:[...d.updated],removed:[...d.removed],all:d.added.size===0&&d.removed.size===0&&d.updated.size===0?null:b}}}function O(T,k){const A=Object.keys(T),w=Object.keys(k),S=w.filter($=>!A.includes($)).reduce(($,l)=>($.add(l),$),new Set),m=A.filter($=>!w.includes($)).reduce(($,l)=>($.add(l),$),new Set),u=new Set;for(const $ of A){if(m.has($))continue;const l=T[$],b=k[$];P.$ho(l,b)||u.add($)}return{added:S,removed:m,updated:u}}}),define(ce[248],le([0,1,19,34,65,45,30,82,25]),function(ne,e,P,c,C,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tMb=w,e.$uMb=u,e.$vMb=$,e.$wMb=l,e.$xMb=v,e.$yMb=p,T=Oe(T),k=Oe(k);function w(h,f,R){let L=[];R?L=m(R):L=S(f);const E=[],y=[...(0,A.$inb)()];if(Array.isArray(L))for(const N of L)N.startsWith("-")?y.push(N.substring(1)):E.push(N);return(0,P.$Ob)([...h,...E].filter(N=>!y.includes(N)))}function S(h){let f=h.inspect("settingsSync.ignoredSettings").userValue;return f!==void 0||(f=h.inspect("sync.ignoredSettings").userValue,f!==void 0)?f:h.getValue("settingsSync.ignoredSettings")||[]}function m(h){const f=(0,c.$Xn)(h);return f?f["settingsSync.ignoredSettings"]||f["sync.ignoredSettings"]||[]:[]}function u(h,f){const R=(0,c.$Xn)(h)||{};let L="{}";for(const E of Object.keys(R)){const y=(0,C.$_n)(L,[E],R[E],f);L=(0,C.$co)(L,y)}return L}function $(h,f,R,L){if(R.length){const E=o(f),y=(0,c.$Xn)(f)||{},N=(0,c.$Xn)(h);if(!N)return h;const F=[];for(const D of R){const M=y[D],J=N[D];M===void 0?h=k.edit(h,[D],void 0,L):J!==void 0?h=k.edit(h,[D],M,L):F.push(r(D,E))}F.sort((D,M)=>D.startOffset-M.startOffset),F.forEach(D=>h=p(D.setting.key,f,h,L))}return h}function l(h,f,R,L,E,y){const N=$(h,f,L,y),F=R!==N,D=R!==f;if(!F&&!D)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!D)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(D&&!F)return{conflictsSettings:[],localContent:$(f,h,L,y),remoteContent:null,hasConflicts:!1};if(R===null&&v(h)){const U=b(h,f,L)?null:$(f,h,L,y);return{conflictsSettings:[],localContent:U,remoteContent:null,hasConflicts:!1}}let M=h,J=f;const W=(0,c.$Xn)(h),x=(0,c.$Xn)(f),G=R?(0,c.$Xn)(R):null,ie=L.reduce((U,Y)=>(U.add(Y),U),new Set),V=d(W,x,ie),z=d(G,W,ie),te=d(G,x,ie),se=new Map,he=new Set,q=U=>{he.add(U);const Y=E.filter(({key:B})=>B===U)[0];Y?(M=k.edit(M,[U],Y.value,y),J=k.edit(J,[U],Y.value,y)):se.set(U,{key:U,localValue:W[U],remoteValue:x[U]})};for(const U of z.removed.values())te.updated.has(U)?q(U):J=k.edit(J,[U],void 0,y);for(const U of te.removed.values())he.has(U)||(z.updated.has(U)?q(U):M=k.edit(M,[U],void 0,y));for(const U of z.updated.values())he.has(U)||(te.updated.has(U)?V.updated.has(U)&&q(U):J=k.edit(J,[U],W[U],y));for(const U of te.updated.values())he.has(U)||(z.updated.has(U)?V.updated.has(U)&&q(U):M=k.edit(M,[U],x[U],y));for(const U of z.added.values())he.has(U)||(te.added.has(U)?V.updated.has(U)&&q(U):J=p(U,M,J,y));for(const U of te.added.values())he.has(U)||(z.added.has(U)?V.updated.has(U)&&q(U):M=p(U,J,M,y));const Z=se.size>0||!b(M,J,L),K=Z||!b(M,h,[]),H=Z||!b(J,f,[]);return{localContent:K?M:null,remoteContent:H?J:null,conflictsSettings:[...se.values()],hasConflicts:Z}}function b(h,f,R){if(h===f)return!0;const L=(0,c.$Xn)(h),E=(0,c.$Xn)(f),y=R.reduce((D,M)=>(D.add(M),D),new Set),N=o(h).filter(D=>!(D.setting&&y.has(D.setting.key))),F=o(f).filter(D=>!(D.setting&&y.has(D.setting.key)));if(N.length!==F.length)return!1;for(let D=0;D<N.length;D++){const M=N[D],J=F[D];if(M.setting&&J.setting){if(M.setting.key!==J.setting.key||!T.$ho(L[M.setting.key],E[M.setting.key]))return!1}else if(!M.setting&&!J.setting){if(M.value!==J.value)return!1}else return!1}return!0}function v(h){return h?o(h).length===0:!0}function d(h,f,R){const L=h?Object.keys(h).filter(D=>!R.has(D)):[],E=Object.keys(f).filter(D=>!R.has(D)),y=E.filter(D=>!L.includes(D)).reduce((D,M)=>(D.add(M),D),new Set),N=L.filter(D=>!E.includes(D)).reduce((D,M)=>(D.add(M),D),new Set),F=new Set;if(h)for(const D of L){if(N.has(D))continue;const M=h[D],J=f[D];T.$ho(M,J)||F.add(D)}return{added:y,removed:N,updated:F}}function p(h,f,R,L){const E=(0,c.$Xn)(f),y=o(f),N=o(R),F=I(h,y,N);return g(R,h,E[h],F,N,L)}function I(h,f,R){const L=f.findIndex(y=>y.setting?.key===h),E=f[L-1];if(E){if(E.setting){const N=r(E.setting.key,R);if(N)return{index:R.indexOf(N),insertAfter:!0}}else{const N=t(L,f);if(N){const F=r(N.setting.key,R);if(F){const D=a(R.indexOf(F),R),M=i(f,N,f[L]);if(D){const J=i(R,F,D),W=n(M,J);return W?{index:R.indexOf(W),insertAfter:!0}:{index:R.indexOf(D),insertAfter:!1}}else{const J=i(R,F,R[R.length-1]),W=n(M,J);return W?{index:R.indexOf(W),insertAfter:!0}:{index:R.length-1,insertAfter:!0}}}}}const y=f[L+1];if(y)if(y.setting){const N=r(y.setting.key,R);if(N)return{index:R.indexOf(N),insertAfter:!1}}else{const N=a(L,f);if(N){const F=r(N.setting.key,R);if(F){const D=t(R.indexOf(F),R),M=i(f,f[L],N);if(D){const J=i(R,D,F),W=n(M.reverse(),J.reverse());return W?{index:R.indexOf(W),insertAfter:!1}:{index:R.indexOf(D),insertAfter:!0}}else{const J=i(R,R[0],F),W=n(M.reverse(),J.reverse());return W?{index:R.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:R.length-1,insertAfter:!0}}function g(h,f,R,L,E,y){let N;return L.index===-1?N=(0,C.$_n)(h,[f],R,y):N=s(h,f,R,L,E,y).map(F=>(0,C.$ao)(h,F,y)[0]),(0,C.$co)(h,N)}function s(h,f,R,L,E,y){const N=`${JSON.stringify(f)}: ${JSON.stringify(R)}`,F=(0,O.$9n)(y,h),D=E[L.index];if(L.insertAfter){const M=[];if(D.setting)M.push({offset:D.endOffset,length:0,content:","+N});else{const J=a(L.index,E),W=t(L.index,E),x=W?.setting?.commaOffset;W&&x===void 0&&M.push({offset:W.endOffset,length:0,content:","});const G=x!==void 0&&x>D.endOffset;M.push({offset:G?x+1:D.endOffset,length:0,content:J?F+N+",":F+N})}return M}else{if(D.setting)return[{offset:D.startOffset,length:0,content:N+","}];const M=(E[L.index-1]&&!E[L.index-1].setting?F:"")+N+(a(L.index,E)?",":"")+F;return[{offset:D.startOffset,length:0,content:M}]}}function r(h,f){return f.filter(R=>R.setting?.key===h)[0]}function t(h,f){for(let R=h-1;R>=0;R--)if(f[R].setting)return f[R]}function a(h,f){for(let R=h+1;R<f.length;R++)if(f[R].setting)return f[R]}function i(h,f,R){const L=h.indexOf(f),E=h.indexOf(R);return h.filter((y,N)=>L<N&&N<E)}function n(h,f){if(h.length&&f.length){let R=0;for(;R<f.length&&R<h.length;R++)if(h[R].value!==f[R].value)return f[R-1];return f[R-1]}}function o(h){const f=[];let R=-1,L,E;const y={onObjectBegin:N=>{R++},onObjectProperty:(N,F,D)=>{R===0&&(L=F,E=N)},onObjectEnd:(N,F)=>{R--,R===0&&f.push({startOffset:L,endOffset:N+F,value:h.substring(L,N+F),setting:{key:E,commaOffset:void 0}})},onArrayBegin:(N,F)=>{R++},onArrayEnd:(N,F)=>{R--,R===0&&f.push({startOffset:L,endOffset:N+F,value:h.substring(L,N+F),setting:{key:E,commaOffset:void 0}})},onLiteralValue:(N,F,D)=>{R===0&&f.push({startOffset:L,endOffset:F+D,value:h.substring(L,F+D),setting:{key:E,commaOffset:void 0}})},onSeparator:(N,F,D)=>{if(R===0&&N===","){let M=f.length-1;for(;M>=0&&!f[M].setting;M--);const J=f[M];J&&f.splice(M,1,{startOffset:J.startOffset,endOffset:J.endOffset,value:J.value,setting:{key:J.setting.key,commaOffset:F}})}},onComment:(N,F)=>{R===0&&f.push({startOffset:N,endOffset:N+F,value:h.substring(N,N+F)})}};return(0,c.$5n)(h,y),f}}),define(ce[83],le([0,1,3,2,4,25]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eMb=e.$dMb=void 0,e.$dMb=(0,C.$Fi)("IUserDataSyncAccountService");let T=class extends c.$Wc{get account(){return this.a}constructor(A,w){super(),this.g=A,this.h=w,this.b=this.B(new P.$me),this.onDidChangeAccount=this.b.event,this.c=this.B(new P.$me),this.onTokenFailed=this.c.event,this.f=!1,this.B(A.onTokenFailed(S=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,S),this.updateAccount(void 0),S===O.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(A.onTokenSucceed(()=>this.f=!1))}async updateAccount(A){(A&&this.a?A.token!==this.a.token||A.authenticationProviderId!==this.a.authenticationProviderId:A!==this.a)&&(this.a=A,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(A))}};e.$eMb=T,e.$eMb=T=ve([Q(0,O.$snb),Q(1,O.$Hnb)],T)}),define(ce[249],le([0,1,21,186,16,10,25]),function(ne,e,P,c,C,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JOb=void 0;let k=class extends O.$ek{constructor(w,S){super(),this.g=this.B(w.createLogger((0,P.$gh)(S.logsHome,`${T.$Inb}.log`),{id:T.$Inb,name:(0,c.localize)(0,null)}))}trace(w,...S){this.g.trace(w,...S)}debug(w,...S){this.g.debug(w,...S)}info(w,...S){this.g.info(w,...S)}warn(w,...S){this.g.warn(w,...S)}error(w,...S){this.g.error(w,...S)}flush(){this.g.flush()}};e.$JOb=k,e.$JOb=k=ve([Q(0,O.$ak),Q(1,C.$Mi)],k)}),define(ce[250],le([0,1,6,3,2]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class O extends C.$Wc{constructor({onDidOpenMainWindow:k,onDidFocusMainWindow:A,getActiveWindowId:w}){super(),this.a=this.B(new C.$Vc),c.Event.latch(c.Event.any(k,A))(this.f,this,this.a),this.b=(0,P.$sh)(()=>w()),(async()=>{try{const m=await this.b;this.c=typeof this.c=="number"?this.c:m}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$mgc=O}),define(ce[116],le([0,1,189,14,52,21,9,4,23]),function(ne,e,P,c,C,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=w,e.$Qi=S,e.$Ti=m,e.$Ui=u,e.$Vi=$,e.$Wi=b,e.$Xi=v,e.$1i=I,e.$6i=g,e.$7i=s,e.$9i=r,e.$0i=t,e.$$i=a,e.$Oi=(0,k.$Fi)("contextService");function w(i){const n=i;return typeof n?.id=="string"&&T.URI.isUri(n.uri)}function S(i){return typeof i?.id=="string"&&!w(i)&&!u(i)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function m(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,c.$pc)(i)}:n?e.$Ri:e.$Si;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function u(i){const n=i;return typeof n?.id=="string"&&T.URI.isUri(n.configPath)}function $(i){const n=i;if(n?.uri)return{id:n.id,uri:T.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var l;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function b(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function v(i){const n=i;return!!(n&&typeof n=="object"&&T.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class d{constructor(n,o,h,f,R){this.h=n,this.j=h,this.k=f,this.l=R,this.c=C.$Li.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=C.$Li.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=d;class p{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,O.$gh)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=p;function I(i){return new p({uri:i,index:0,name:(0,O.$ch)(i)},{uri:i.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,P.localize)(0,null),extensions:[e.$2i]}],e.$5i="workspace.json";function g(i,n){return O.$0g.isEqualOrParent(i,n.untitledWorkspacesHome)}function s(i){let n;return T.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===A.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(i){return i.id===e.$8i}function t(i,n){return!g(i,n)&&!s(i)}function a(i){return(typeof i=="string"?(0,c.$qc)(i):(0,O.$eh)(i))===e.$3i}}),define(ce[20],le([0,1,56,3,2,21,9,180,16,7,4,10,116,35,29,6,32,27,13]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=g,e.$Ml=s,e.$Nl=r;var I;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function g(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&T.URI.isUri(n.location)&&T.URI.isUri(n.globalStorageHome)&&T.URI.isUri(n.settingsResource)&&T.URI.isUri(n.keybindingsResource)&&T.URI.isUri(n.tasksResource)&&T.URI.isUri(n.snippetsHome)&&T.URI.isUri(n.extensionsResource))}e.$Ll=(0,S.$Fi)("IUserDataProfilesService");function s(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:T.URI.revive(i.location).with({scheme:n}),globalStorageHome:T.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:T.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:T.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:T.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:T.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:T.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:T.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function r(i,n,o,h,f,R){return{id:i,name:n,location:o,isDefault:!1,shortName:f?.shortName,icon:f?.icon,globalStorageHome:R&&f?.useDefaultFlags?.globalState?R.globalStorageHome:(0,O.$gh)(o,"globalStorage"),settingsResource:R&&f?.useDefaultFlags?.settings?R.settingsResource:(0,O.$gh)(o,"settings.json"),keybindingsResource:R&&f?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,O.$gh)(o,"keybindings.json"),tasksResource:R&&f?.useDefaultFlags?.tasks?R.tasksResource:(0,O.$gh)(o,"tasks.json"),snippetsHome:R&&f?.useDefaultFlags?.snippets?R.snippetsHome:(0,O.$gh)(o,"snippets"),extensionsResource:R&&f?.useDefaultFlags?.extensions?R.extensionsResource:(0,O.$gh)(o,"extensions.json"),cacheHome:(0,O.$gh)(h,i),useDefaultFlags:f?.useDefaultFlags,isTransient:f?.transient}}let t=class extends C.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,o,h,f){super(),this.t=n,this.u=o,this.w=h,this.y=f,this.f=!0,this.h=this.B(new c.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new c.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new c.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new c.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new $.$Cc,workspaces:new $.$Cc,emptyWindows:new Map},this.profilesHome=(0,O.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),o=[n];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,p.$fg)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}o.push(r((0,O.$dh)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},n))}}catch(R){this.y.error(R)}const h=new $.$Cc,f=new Map;if(o.length)try{const R=this.Q();if(R.workspaces)for(const[L,E]of Object.entries(R.workspaces)){const y=T.URI.parse(L),N=o.find(F=>F.id===E);N&&h.set(y,N)}if(R.emptyWindows)for(const[L,E]of Object.entries(R.emptyWindows)){const y=o.find(N=>N.id===E);y&&f.set(L,y)}}catch(R){this.y.error(R)}this.z={profiles:o,workspaces:h,emptyWindows:f}}return this.z}D(){const n=r("__default__profile__",(0,k.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",h=new RegExp(`${(0,d.$if)(o)}\\s(\\d+)`);let f=0;for(const L of this.profiles){const E=h.exec(L.name),y=E?parseInt(E[1]):0;f=y>f?y:f}const R=`${o} ${f+1}`;return this.createProfile((0,P.$tj)((0,v.$2g)()).toString(16),R,{transient:!0},n)}async createNamedProfile(n,o,h){return this.createProfile((0,P.$tj)((0,v.$2g)()).toString(16),n,o,h)}async createProfile(n,o,h,f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(n,o,h);return f&&await this.setProfileForWorkspace(f,R),R}async F(n,o,h){if(!(0,p.$fg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let f=this.r.get(o);return f||(f=(async()=>{try{if(this.profiles.find(y=>y.name===o||y.id===n))throw new Error(`Profile with ${o} name already exists`);const L=r(n,o,(0,O.$gh)(this.profilesHome,n),this.g,h,this.defaultProfile);await this.u.createFolder(L.location);const E=[];return this.j.fire({profile:L,join(y){E.push(y)}}),await b.Promises.settled(E),this.I([L],[],[]),L}finally{this.r.delete(o)}})(),this.r.set(o,f)),f}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let h=this.profiles.find(f=>f.id===n.id);if(!h)throw new Error(`Profile '${n.name}' does not exist`);return h=r(h.id,o.name??h.name,h.location,this.g,{shortName:o.shortName??h.shortName,icon:o.icon===null?void 0:o.icon??h.icon,transient:o.transient??h.isTransient,useDefaultFlags:o.useDefaultFlags??h.useDefaultFlags},this.defaultProfile),this.I([],[],[h]),h}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(f=>f.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const h=[];this.m.fire({profile:o,join(f){h.push(f)}});try{await Promise.allSettled(h)}catch(f){this.y.error(f)}for(const f of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(f)?.id&&this.C.emptyWindows.delete(f);for(const f of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(f)?.id&&this.C.workspaces.delete(f);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(f){(0,w.$ql)(f)!==w.FileOperationResult.FILE_NOT_FOUND&&this.y.error(f)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=this.profiles.find(f=>f.id===o.id);if(!h)throw new Error(`Profile '${o.name}' does not exist`);this.L(n,h)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(h=>!this.w.extUri.isEqual(h.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.G(n),h=T.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return h||((0,u.$Pi)(n)?this.s.folders.get(n.uri):(0,u.$Ui)(n)?this.s.workspaces.get(n.configPath):this.s.emptyWindows.get(n.id))}G(n){return(0,u.$Pi)(n)?n.uri:(0,u.$Ui)(n)?n.configPath:n.id}H(n){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,n.location)))}I(n,o,h){const f=[...this.profiles,...n],R=[],L=this.s.profiles;this.s.profiles=[];for(let E of f){if(E.isDefault||o.some(N=>E.id===N.id))continue;E=h.find(N=>E.id===N.id)??E;const y=L.find(N=>E.id===N.id);if(E.isTransient)this.s.profiles.push(E);else{if(y){for(const[N,F]of this.s.emptyWindows.entries())if(E.id===F.id){this.L({id:N},E);break}for(const[N,F]of this.s.workspaces.entries())if(E.id===F.id){this.L({id:"",configPath:N},E);break}for(const[N,F]of this.s.folders.entries())if(E.id===F.id){this.L({id:"",uri:N},E);break}}R.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags})}}this.P(R),this.z=void 0,this.J(n,o,h)}J(n,o,h){this.h.fire({added:n,removed:o,updated:h,all:this.profiles})}L(n,o,h){if(h=o?.isTransient?!0:h,h)(0,u.$Pi)(n)?(this.s.folders.delete(n.uri),o&&this.s.folders.set(n.uri,o)):(0,u.$Ui)(n)?(this.s.workspaces.delete(n.configPath),o&&this.s.workspaces.set(n.configPath,o)):(this.s.emptyWindows.delete(n.id),o&&this.s.emptyWindows.set(n.id,o));else{this.L(n,void 0,!0);const f=this.G(n);T.URI.isUri(f)?(this.C.workspaces.delete(f),o&&this.C.workspaces.set(f,o)):(this.C.emptyWindows.delete(f),o&&this.C.emptyWindows.set(f,o)),this.M()}}M(){const n={};for(const[h,f]of this.C.workspaces.entries())n[h.toString()]=f.id;const o={};for(const[h,f]of this.C.emptyWindows.entries())o[h.toString()]=f.id;this.R({workspaces:n,emptyWindows:o}),this.z=void 0}N(n){const o={},h=this.D();if(n.workspaces)for(const[R,L]of Object.entries(n.workspaces)){const E=T.URI.parse(L);o[R]=this.w.extUri.isEqual(E,h.location)?h.id:this.w.extUri.basename(E)}const f={};if(n.emptyWindows)for(const[R,L]of Object.entries(n.emptyWindows)){const E=T.URI.parse(L);f[R]=this.w.extUri.isEqual(E,h.location)?h.id:this.w.extUri.basename(E)}return{workspaces:o,emptyWindows:f}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Ol=t,e.$Ol=t=ve([Q(0,A.$Mi),Q(1,w.$_k),Q(2,l.$Jl),Q(3,m.$_j)],t);class a extends t{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Pl=a}),define(ce[251],le([0,1,6,2,20]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;let O=class extends c.$Wc{constructor(k){super(),this.B(new P.$Rh(()=>{k.cleanUp()},10*1e3)).schedule()}};e.$shc=O,e.$shc=O=ve([Q(0,C.$Ll)],O)}),define(ce[84],le([0,1,19,6,26,8,3,2,5,13,9,162,28,33,36,60,10,24,18,29,20]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Cq=void 0,e.$Dq=r,m=Oe(m);let s=class extends k.$Wc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,o,h,f,R,L){super(),this.z=n,this.C=o,this.D=h,this.F=f,this.G=R,this.H=L,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new T.$me),this.s=this.B(new T.$me),this.t=this.B(new T.$me),this.u=this.B(new T.$me),this.w=this.B(new T.$me),this.y=[],this.B((0,k.$Uc)(()=>{this.j.forEach(({task:E})=>E.cancel()),this.m.forEach(E=>E.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const o=await this.getTargetPlatform();return n.allTargetPlatforms.some(h=>(0,u.$gp)(h,n.allTargetPlatforms,o))}async installFromGallery(n,o={}){try{const f=(await this.installGalleryExtensions([{extension:n,options:o}])).find(({identifier:R})=>(0,$.$Jp)(R,n.identifier));if(f?.local)return f?.local;throw f?.error?f.error:new u.$kp(`Unknown error while installing extension ${n.identifier.id}`,u.ExtensionManagementErrorCode.Unknown)}catch(h){throw r(h)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new u.$kp(m.localize(0,null),u.ExtensionManagementErrorCode.NotAllowed);const o=[],h=[];return await Promise.allSettled(n.map(async({extension:f,options:R})=>{try{const L=await this.N(f,!!R?.installGivenVersion,!!R?.installPreReleaseVersion,R.productVersion??{version:this.G.version,date:this.G.date});h.push({...L,options:R})}catch(L){o.push({identifier:f.identifier,operation:u.InstallOperation.Install,source:f,error:L,profileLocation:R.profileLocation??this.X()})}})),h.length&&o.push(...await this.I(h)),o}async uninstall(n,o={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.P(n,o)}async toggleAppliationScope(n,o){if((0,l.$tn)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let h=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(h=await this.$(n,this.H.defaultProfile.extensionsResource,o));for(const f of this.H.profiles){const R=(await this.getInstalled(l.ExtensionType.User,f.extensionsResource)).find(L=>(0,$.$Jp)(L.identifier,n.identifier));R?this.w.fire({local:R,profileLocation:f.extensionsResource}):this.u.fire({identifier:n.identifier,profileLocation:f.extensionsResource})}return h}else{const h=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(n,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:h.identifier,operation:u.InstallOperation.Install,local:h,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),h}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.W(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const o=new Map,h=new Map,f=[],R=(E,y)=>`${$.$Kp.create(E).toString()}-${y.toString()}`,L=(E,y,N,F)=>{const D=this.Y(E,y,N),M=`${(0,$.$Op)(E.publisher,E.name)}-${N.profileLocation.toString()}`;h.set(M,{task:D,root:F}),this.n.fire({identifier:D.identifier,source:y,profileLocation:N.profileLocation}),this.F.info("Installing extension:",D.identifier.id,N),S.URI.isUri(y)||this.j.set(R(y,N.profileLocation),{task:D,waitingTasks:[]})};try{for(const{manifest:E,extension:y,options:N}of n){const F=N.isApplicationScoped||N.isBuiltin||(0,l.$tn)(E),D={...N,installOnlyNewlyAddedFromExtensionPack:N.installOnlyNewlyAddedFromExtensionPack??!S.URI.isUri(y),isApplicationScoped:F,profileLocation:F?this.H.defaultProfile.extensionsResource:N.profileLocation??this.X(),productVersion:N.productVersion??{version:this.G.version,date:this.G.date}},M=S.URI.isUri(y)?void 0:this.j.get(R(y,D.profileLocation));M?(this.F.info("Extension is already requested to install",M.task.identifier.id,D.profileLocation.toString()),f.push(M.task.waitUntilTaskIsFinished())):L(E,y,D,void 0)}return await Promise.all([...h.values()].map(async({task:E})=>{if(E.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",E.identifier.id);else try{const y=await this.M(E.identifier,E.manifest,!!E.options.installOnlyNewlyAddedFromExtensionPack,!!E.options.installPreReleaseVersion,E.options.profileLocation,E.options.productVersion),N=await this.getInstalled(void 0,E.options.profileLocation,E.options.productVersion),F={...E.options,context:{...E.options.context,[u.$ap]:!0}};for(const{gallery:D,manifest:M}of(0,P.$Ob)(y,({gallery:J})=>J.identifier.id)){if(h.has(`${D.identifier.id.toLowerCase()}-${F.profileLocation.toString()}`))continue;const J=this.j.get(R(D,F.profileLocation));if(J){if(this.J(E,J.task)){const W=J.task.identifier;this.F.info("Waiting for already requested installing extension",W.id,E.identifier.id,F.profileLocation.toString()),J.waitingTasks.push(E),f.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,x=>x.some(G=>(0,$.$Jp)(G.identifier,W)))).then(x=>{if(this.F.info("Finished waiting for already requested installing extension",W.id,E.identifier.id,F.profileLocation.toString()),!x.find(ie=>(0,$.$Jp)(ie.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else N.some(({identifier:W})=>(0,$.$Jp)(W,D.identifier))||L(M,D,F,E)}}catch(y){if(S.URI.isUri(E.source))(0,P.$Nb)(E.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",E.identifier.id,y.message),(0,P.$Nb)(E.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",E.identifier.id,y.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",E.identifier.id),y}})),await this.L([...h.entries()].map(async([E,{task:y}])=>{const N=new Date().getTime();let F;try{F=await y.run(),await this.L(this.y.map(D=>D.postInstall(F,y.source,y.options,C.CancellationToken.None)),u.ExtensionManagementErrorCode.PostInstall)}catch(D){const M=r(D);throw S.URI.isUri(y.source)||t(this.C,y.operation===u.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Rp)(y.source),error:M,source:y.options.context?.[u.$_o]}),o.set(E,{error:M,identifier:y.identifier,operation:y.operation,source:y.source,context:y.options.context,profileLocation:y.options.profileLocation,applicationScoped:y.options.isApplicationScoped}),this.F.error("Error while installing the extension",y.identifier.id,(0,O.$_)(M),y.options.profileLocation.toString()),M}if(!S.URI.isUri(y.source)){const D=y.operation===u.InstallOperation.Update,M=D?void 0:(new Date().getTime()-y.source.lastUpdated)/1e3;if(t(this.C,D?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Rp)(y.source),verificationStatus:y.verificationStatus,duration:new Date().getTime()-N,durationSinceUpdate:M,source:y.options.context?.[u.$_o]}),A.$o&&y.operation!==u.InstallOperation.Update)try{await this.z.reportStatistic(F.manifest.publisher,F.manifest.name,F.manifest.version,u.StatisticType.Install)}catch{}}o.set(E,{local:F,identifier:y.identifier,operation:y.operation,source:y.source,context:y.options.context,profileLocation:y.options.profileLocation,applicationScoped:F.isApplicationScoped})})),f.length&&await this.L(f),[...o.values()]}catch(E){const y=(D,M,J)=>{const W=[];D.manifest.extensionDependencies?.length&&W.push(...D.manifest.extensionDependencies),D.manifest.extensionPack?.length&&W.push(...D.manifest.extensionPack);for(const x of W){if(J.includes(x.toLowerCase()))continue;J.push(x.toLowerCase());const G=o.get(`${x.toLowerCase()}-${M.toString()}`);G?.local&&(J=y(G.local,M,J))}return J},N=D=>({identifier:D.identifier,operation:u.InstallOperation.Install,source:D.source,context:D.options.context,profileLocation:D.options.profileLocation,error:E}),F=[];for(const[D,{task:M,root:J}]of h){const W=o.get(D);W?W.local&&J&&!o.get(`${J.identifier.id.toLowerCase()}-${M.options.profileLocation.toString()}`)?.local&&(F.push(this.Z(W.local,{versionOnly:!0,profileLocation:M.options.profileLocation})),o.set(D,N(M))):(M.cancel(),o.set(D,N(M)))}for(const[D,{task:M}]of h){const J=o.get(D);if(!J?.local||M.options.donotIncludePackAndDependencies)continue;y(J.local,M.options.profileLocation,[J.local.identifier.id.toLowerCase()]).slice(1).some(x=>h.has(`${x.toLowerCase()}-${M.options.profileLocation.toString()}`)&&!o.get(`${x.toLowerCase()}-${M.options.profileLocation.toString()}`)?.local)&&(F.push(this.Z(J.local,{versionOnly:!0,profileLocation:M.options.profileLocation})),o.set(D,N(M)))}throw F.length&&await Promise.allSettled(F.map(async D=>{try{await D.run(),this.F.info("Rollback: Uninstalled extension",D.extension.identifier.id)}catch(M){this.F.warn("Rollback: Error while uninstalling extension",D.extension.identifier.id,(0,O.$_)(M))}})),E}finally{for(const{task:E}of h.values())E.source&&!S.URI.isUri(E.source)&&this.j.delete(R(E.source,E.options.profileLocation));if(o.size){const E=[...o.values()];for(const y of E)y.local&&this.F.info("Extension installed successfully:",y.identifier.id,y.profileLocation.toString());this.s.fire(E)}}}J(n,o){for(const[,{task:h,waitingTasks:f}]of this.j.entries())if(h===n&&(f.includes(o)||f.some(R=>this.J(R,o)))||h===o&&f[0]&&!this.J(n,f[0]))return!1;return!0}async L(n,o){const h=[],f=[],R=await Promise.allSettled(n);for(const E of R)E.status==="fulfilled"?h.push(E.value):f.push(r(E.reason,o));if(!f.length)return h;if(f.length===1)throw f[0];let L=new u.$kp("",u.ExtensionManagementErrorCode.Unknown);for(const E of f)L=new u.$kp(L.message?`${L.message}, ${E.message}`:E.message,E.code!==u.ExtensionManagementErrorCode.Unknown&&E.code!==u.ExtensionManagementErrorCode.Internal?E.code:L.code);throw L}async M(n,o,h,f,R,L){if(!this.z.isEnabled())return[];const E=await this.getInstalled(void 0,R,L),y=[],N=[],F=async(D,M)=>{y.push(D);const J=M.extensionDependencies||[],W=[...J];if(M.extensionPack){const x=h?E.find(G=>(0,$.$Jp)(G.identifier,D)):void 0;for(const G of M.extensionPack)x&&x.manifest.extensionPack&&x.manifest.extensionPack.some(ie=>(0,$.$Jp)({id:ie},{id:G}))||W.every(ie=>!(0,$.$Jp)({id:ie},{id:G}))&&W.push(G)}if(W.length){const x=W.filter(G=>y.every(ie=>!(0,$.$Jp)(ie,{id:G})));if(x.length){const G=await this.z.getExtensions(x.map(ie=>({id:ie,preRelease:f})),C.CancellationToken.None);for(const ie of G){if(y.find(te=>(0,$.$Jp)(te,ie.identifier)))continue;const V=J.some(te=>(0,$.$Jp)({id:te},ie.identifier));let z;try{z=await this.N(ie,!1,f,L)}catch(te){if(V)throw te;this.F.info("Skipping the packed extension as it cannot be installed",ie.identifier.id,(0,O.$_)(te));continue}N.push({gallery:z.extension,manifest:z.manifest}),await F(z.extension.identifier,z.manifest)}}}};return await F(n,o),N}async N(n,o,h,f){let R;const L=await this.getExtensionsControlManifest();if(L.malicious.some(N=>(0,$.$Jp)(n.identifier,N)))throw new u.$kp(m.localize(1,null,n.identifier.id),u.ExtensionManagementErrorCode.Malicious);const E=L.deprecated[n.identifier.id.toLowerCase()];if(E?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${E.extension.id}' extension instead.`),R=(await this.z.getExtensions([{id:E.extension.id,preRelease:E.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:f},C.CancellationToken.None))[0],!R)throw new u.$kp(m.localize(2,null,n.identifier.id,E.extension.id),u.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const N=await this.getTargetPlatform();throw new u.$kp(m.localize(3,null,n.identifier.id,this.G.nameLong,(0,u.$cp)(N)),u.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(R=await this.O(n,o,h,f),!R){const N=[];throw(0,b.$4p)(n.properties.enabledApiProposals??[],N)?!h&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],C.CancellationToken.None))[0]?new u.$kp(m.localize(5,null,n.displayName??n.identifier.id),u.ExtensionManagementErrorCode.ReleaseVersionNotFound):new u.$kp(m.localize(6,null,n.identifier.id,this.G.nameLong,this.G.version),u.ExtensionManagementErrorCode.Incompatible):new u.$kp(m.localize(4,null,n.displayName??n.identifier.id,N[0]),u.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",R.identifier.id);const y=await this.z.getManifest(R,C.CancellationToken.None);if(y===null)throw new u.$kp(`Missing manifest for extension ${R.identifier.id}`,u.ExtensionManagementErrorCode.Invalid);if(y.version!==R.version)throw new u.$kp(`Cannot install '${R.identifier.id}' extension because of version mismatch in Marketplace`,u.ExtensionManagementErrorCode.Invalid);return{extension:R,manifest:y}}async O(n,o,h,f){const R=await this.getTargetPlatform();let L=null;return!o&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==h&&(L=(await this.z.getExtensions([{...n.identifier,preRelease:h}],{targetPlatform:R,compatible:!0,productVersion:f},C.CancellationToken.None))[0]||null),!L&&await this.z.isExtensionCompatible(n,h,R,f)&&(L=n),L||(o?L=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:R,compatible:!0,productVersion:f},C.CancellationToken.None))[0]||null:L=await this.z.getCompatibleExtension(n,h,R,f)),L}async P(n,o){const h={...o,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},f=F=>`${F.id.toLowerCase()}${h.versionOnly?`-${n.manifest.version}`:""}${h.profileLocation?`@${h.profileLocation.toString()}`:""}`,R=this.m.get(f(n.identifier));if(R)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),R.waitUntilTaskIsFinished();const L=F=>{const D=this.Z(F,h);return this.m.set(f(D.extension.identifier),D),h.profileLocation?this.F.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,h.profileLocation.toString()):this.F.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.t.fire({identifier:F.identifier,profileLocation:h.profileLocation,applicationScoped:F.isApplicationScoped}),D},E=(F,D)=>{D?h.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,h.profileLocation.toString(),D.message):this.F.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,D.message):h.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,h.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,$.$Qp)(F),error:D}),this.u.fire({identifier:F.identifier,error:D?.code,profileLocation:h.profileLocation,applicationScoped:F.isApplicationScoped})},y=[],N=[];try{y.push(L(n));const F=await this.getInstalled(l.ExtensionType.User,h.profileLocation);if(h.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const D=this.S(n,F);for(const M of D)this.m.has(f(M.identifier))?this.F.info("Extensions is already requested to uninstall",M.identifier.id):y.push(L(M))}h.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.Q(y.map(D=>D.extension),F,n),await this.L(y.map(async D=>{try{if(await D.run(),await this.L(this.y.map(M=>M.postUninstall(D.extension,h,C.CancellationToken.None))),D.extension.identifier.uuid)try{await this.z.reportStatistic(D.extension.manifest.publisher,D.extension.manifest.name,D.extension.manifest.version,u.StatisticType.Uninstall)}catch{}E(D.extension)}catch(M){const J=r(M);throw E(D.extension,J),J}finally{N.push(D)}}))}catch(F){const D=r(F);for(const M of y){try{M.cancel()}catch{}N.includes(M)||E(M.extension,D)}throw D}finally{for(const F of y)this.m.delete(f(F.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}Q(n,o,h){for(const f of n){const R=this.U(f,o);if(R.length){const L=R.filter(E=>!n.some(y=>(0,$.$Jp)(y.identifier,E.identifier)));if(L.length)throw new Error(this.R(f,L,h))}}}R(n,o,h){return h===n?o.length===1?m.localize(7,null,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?m.localize(8,null,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):m.localize(9,null,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?m.localize(10,null,h.manifest.displayName||h.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?m.localize(11,null,h.manifest.displayName||h.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):m.localize(12,null,h.manifest.displayName||h.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(n,o,h=[]){if(h.indexOf(n)!==-1)return[];h.push(n);const f=n.manifest.extensionPack?n.manifest.extensionPack:[];if(f.length){const R=o.filter(E=>!E.isBuiltin&&f.some(y=>(0,$.$Jp)({id:y},E.identifier))),L=[];for(const E of R)L.push(...this.S(E,o,h));return[...R,...L]}return[]}U(n,o){return o.filter(h=>h.manifest.extensionDependencies&&h.manifest.extensionDependencies.some(f=>(0,$.$Jp)({id:f},n.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(n){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,O.$_)(n)),{malicious:[],deprecated:{},search:[]}}}};e.$Cq=s,e.$Cq=s=ve([Q(0,u.$ip),Q(1,p.$$l),Q(2,I.$Jl),Q(3,v.$_j),Q(4,d.$sk),Q(5,g.$Ll)],s);function r(i,n){if(i instanceof u.$kp)return i;let o;return i instanceof u.$jp?o=new u.$kp(i.message,i.code===u.ExtensionGalleryErrorCode.DownloadFailedWriting?u.ExtensionManagementErrorCode.DownloadFailedWriting:u.ExtensionManagementErrorCode.Gallery):o=new u.$kp(i.message,(0,O.$6)(i)?u.ExtensionManagementErrorCode.Cancelled:n??u.ExtensionManagementErrorCode.Internal),o.stack=i.stack,o}function t(i,n,{extensionData:o,verificationStatus:h,duration:f,error:R,source:L,durationSinceUpdate:E}){let y,N;(0,w.$ng)(h)&&(h===!0?h="Verified":(h===!1||(y=u.ExtensionManagementErrorCode.Signature,N=h),h="Unverified")),R&&(y=R.code,R.code===u.ExtensionManagementErrorCode.Signature&&(N=R.message)),i.publicLog(n,{...o,verificationStatus:h,success:!R,duration:f,errorcode:y,errorcodeDetail:N,durationSinceUpdate:E,source:L})}class a{constructor(){this.d=new c.$Eh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,c.$sh)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,c.$sh)(n=>new Promise((o,h)=>{const f=n.onCancellationRequested(()=>{f.dispose(),h(new O.$7)})})),this.d.open()),this.g.cancel()}}e.$Eq=a}),define(ce[53],le([0,1,6,15,2,3,35,9,28,33,7,4,10,20,29,13,8,18]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(t){t.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",t.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class I extends Error{constructor(a,i){super(a),this.code=i}}e.$Fq=I,e.$Gq=(0,m.$Fi)("IExtensionsProfileScannerService");let g=class extends C.$Wc{constructor(a,i,n,o,h,f){super(),this.j=a,this.m=i,this.n=n,this.r=o,this.s=h,this.t=f,this.b=this.B(new O.$me),this.onAddExtensions=this.b.event,this.c=this.B(new O.$me),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.$me),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.$me),this.onDidRemoveExtensions=this.g.event,this.h=new T.$Cc}scanProfileExtensions(a,i){return this.u(a,void 0,i)}async addExtensionsToProfile(a,i,n){const o=[],h=[];try{return await this.u(i,f=>{const R=[];if(n)R.push(...f);else for(const L of f)a.some(([E])=>(0,w.$Jp)(E.identifier,L.identifier)&&E.manifest.version!==L.version)?o.push(L):R.push(L);for(const[L,E]of a){const y=R.findIndex(F=>(0,w.$Jp)(F.identifier,L.identifier)&&F.version===L.manifest.version),N={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:E};y===-1?(h.push(N),R.push(N)):R.splice(y,1,N)}return h.length&&this.b.fire({extensions:h,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),R}),h.length&&this.c.fire({extensions:h,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),h}catch(f){throw h.length&&this.c.fire({extensions:h,error:f,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:f,profileLocation:i}),f}}async updateMetadata(a,i){const n=[];return await this.u(i,o=>{const h=[];for(const f of o){const R=a.find(([L])=>(0,w.$Jp)(L.identifier,f.identifier)&&L.manifest.version===f.version);R&&(f.metadata={...f.metadata,...R[1]},n.push(f)),h.push(f)}return h}),n}async removeExtensionFromProfile(a,i){const n=[];try{await this.u(i,o=>{const h=[];for(const f of o)(0,w.$Jp)(f.identifier,a.identifier)?n.push(f):h.push(f);return n.length&&this.f.fire({extensions:n,profileLocation:i}),h}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:i}),o}}async u(a,i,n){return this.F(a).queue(async()=>{let o=[],h;try{const f=await this.m.readFile(a);h=JSON.parse(f.value.toString().trim()||"[]")}catch(f){if((0,S.$ql)(f)!==S.FileOperationResult.FILE_NOT_FOUND)throw f;if(this.r.extUri.isEqual(a,this.n.defaultProfile.extensionsResource)&&(h=await this.D()),!h&&n?.bailOutWhenFileNotFound)throw new I((0,v.$_)(f),p.ERROR_PROFILE_NOT_FOUND)}if(h){Array.isArray(h)||this.w(a);let f=!1;for(const R of h){s(R)||this.w(a);let L;if((0,b.$fg)(R.relativeLocation)&&R.relativeLocation)L=this.z(R.relativeLocation);else if((0,b.$fg)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{L=k.URI.revive(R.location);const E=this.y(L);E&&(f=!0,R.relativeLocation=E)}(0,b.$mg)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(f=!0,R.metadata.hasPreReleaseVersion=!0),o.push({identifier:R.identifier,location:L,version:R.version,metadata:R.metadata})}f&&await this.m.writeFile(a,c.$Oe.fromString(JSON.stringify(h)))}if(i){o=i(o);const f=o.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(a,c.$Oe.fromString(JSON.stringify(f)))}return o})}w(a){const i=new I(`Invalid extensions content in ${a.toString()}`,p.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(a){return this.r.extUri.isEqual(this.r.extUri.dirname(a),this.j)?this.r.extUri.basename(a):void 0}z(a){return this.r.extUri.joinPath(this.j,a)}async D(){return this.C||(this.C=(async()=>{const a=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(a)).value.toString()}catch(h){if((0,S.$ql)(h)===S.FileOperationResult.FILE_NOT_FOUND)return;throw h}this.t.info("Migrating extensions from old default profile location",a.toString());let o;try{const h=JSON.parse(n);Array.isArray(h)&&h.every(f=>s(f))?o=h:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",h)}catch(h){this.t.error(h)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,c.$Oe.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",a.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(h){if((0,S.$ql)(h)===S.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",a.toString(),this.n.defaultProfile.extensionsResource.toString());else throw h}try{await this.m.del(a)}catch(h){(0,S.$ql)(h)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(h)}try{await this.m.del(i)}catch(h){(0,S.$ql)(h)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(h)}return o})()),this.C}F(a){let i=this.h.get(a);return i||(i=new P.$Mh,this.h.set(a,i)),i}};e.$Hq=g,e.$Hq=g=ve([Q(1,S.$_k),Q(2,$.$Ll),Q(3,l.$Jl),Q(4,d.$$l),Q(5,u.$_j)],g);function s(t){return(0,b.$hg)(t)&&(0,A.$hp)(t.identifier)&&(r(t.location)||(0,b.$fg)(t.location)&&t.location)&&((0,b.$mg)(t.relativeLocation)||(0,b.$fg)(t.relativeLocation))&&t.version&&(0,b.$fg)(t.version)}function r(t){return t?(0,b.$fg)(t.path)&&(0,b.$fg)(t.scheme):!1}});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(ce[85],le([0,1,19,6,30,15,8,34,144,2,23,14,5,21,61,92,13,9,165,16,33,36,60,7,4,10,24,3,69,53,20,29,194]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p,I,g,s,r,t,a,i,n,o,h,f,R,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Mq=e.$Lq=e.$Kq=e.Translations=void 0,e.$Nq=J,C=Oe(C),m=Oe(m),u=Oe(u),l=Oe(l),b=it(b);var y;(function(x){function G(ie,V){if(ie===V)return!0;const z=Object.keys(ie),te=new Set;for(const se of Object.keys(V))te.add(se);if(z.length!==te.size)return!1;for(const se of z){if(ie[se]!==V[se])return!1;te.delete(se)}return te.size===0}x.equals=G})(y||(e.Translations=y={})),e.$Kq=(0,a.$Fi)("IExtensionsScannerService");let N=class extends w.$Wc{constructor(G,ie,V,z,te,se,he,q,Z,K,H,U){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=ie,this.r=V,this.s=z,this.t=te,this.u=se,this.w=he,this.y=q,this.z=Z,this.C=K,this.D=H,this.F=U,this.g=this.B(new o.$me),this.onDidChangeCache=this.g.event,this.h=(0,$.$gh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(M,this.s,this.h)),this.m=this.B(this.F.createInstance(M,this.s,this.h)),this.n=this.B(this.F.createInstance(D,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(s.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(s.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,g.$Up)(this.w,this.y)),this.G}async scanAllExtensions(G,ie,V){const[z,te]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(ie)]),se=V?await this.scanExtensionsUnderDevelopment(G,[...z,...te]):[];return this.L(z,te,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const ie=[];ie.push(this.M(!!G.useCache,G.language)),ie.push(this.N(G.language,!!G.checkControlFile));const[V,z]=await Promise.all(ie);return this.J([...V,...z],s.ExtensionType.System,G,!1)}async scanUserExtensions(G){const ie=G.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ie);const V=this.D.extUri.isEqual(G.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(ie,!!G.profileLocation,s.ExtensionType.User,!G.includeUninstalled,G.language,!0,V,G.productVersion??this.R()),te=G.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let se;try{se=await te.scanExtensions(z)}catch(he){if(he instanceof f.$Fq&&he.code===f.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),se=await te.scanExtensions(z);else throw he}return se=await this.J(se,s.ExtensionType.User,G,!0),this.y.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(G,ie){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===S.Schemas.file).map(async z=>{const te=await this.P(z,!1,s.ExtensionType.User,!0,G.language,!1,void 0,G.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(te)).map(he=>(he.type=ie.find(q=>(0,g.$Jp)(q.identifier,he.identifier))?.type??he.type,this.n.validate(he,te)))}))).flat();return this.J(V,"development",G,!0)}return[]}async scanExistingExtension(G,ie,V){const z=await this.P(G,!1,ie,!0,V.language,!0,void 0,V.productVersion??this.R()),te=await this.n.scanExtension(z);return!te||!V.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(G,ie,V){const z=await this.P(G,!1,ie,!0,V.language,!0,void 0,V.productVersion??this.R()),te=await this.n.scanOneOrMultipleExtensions(z);return this.J(te,ie,V,!0)}async scanMultipleExtensions(G,ie,V){const z=[];return await Promise.all(G.map(async te=>{const se=await this.scanOneOrMultipleExtensions(te,ie,V);z.push(...se)})),this.J(z,ie,V,!0)}async scanMetadata(G){const ie=(0,$.$gh)(G,"package.json"),V=(await this.w.readFile(ie)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(G,ie){const V=(0,$.$gh)(G,"package.json"),z=(await this.w.readFile(V)).value.toString(),te=JSON.parse(z);ie.isMachineScoped===!1&&delete ie.isMachineScoped,ie.isBuiltin===!1&&delete ie.isBuiltin,te.__metadata={...te.__metadata,...ie},await this.w.writeFile((0,$.$gh)(G,"package.json"),O.$Oe.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof f.$Fq&&G.code===f.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw G}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.u.addExtensionsToProfile(G.map(ie=>[ie,ie.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,O.$Oe.fromString(JSON.stringify([])))}catch(ie){(0,t.$ql)(ie)!==t.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.$_)(ie))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.y.error(G)}finally{this.H=void 0}})()),this.H}async J(G,ie,V,z){return V.includeAllVersions||(G=this.L(ie===s.ExtensionType.System?G:void 0,ie===s.ExtensionType.User?G:void 0,ie==="development"?G:void 0,await this.getTargetPlatform(),z)),V.includeInvalid||(G=G.filter(te=>te.isValid)),G.sort((te,se)=>{const he=m.$pc(te.location.fsPath),q=m.$pc(se.location.fsPath);return he<q?-1:he>q?1:0})}L(G,ie,V,z,te){const se=(q,Z,K)=>{if(q.isValid&&!Z.isValid)return!1;if(q.isValid===Z.isValid){if(te&&l.gt(q.manifest.version,Z.manifest.version))return this.y.debug(`Skipping extension ${Z.location.path} with lower version ${Z.manifest.version} in favour of ${q.location.path} with version ${q.manifest.version}`),!1;if(l.eq(q.manifest.version,Z.manifest.version)){if(q.type===s.ExtensionType.System)return this.y.debug(`Skipping extension ${Z.location.path} in favour of system extension ${q.location.path} with same version`),!1;if(q.targetPlatform===z)return this.y.debug(`Skipping extension ${Z.location.path} from different target platform ${Z.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${q.location.path} with ${Z.location.path}.`):this.y.debug(`Overwriting user extension ${q.location.path} with ${Z.location.path}.`),!0},he=new s.$sn;return G?.forEach(q=>{const Z=he.get(q.identifier.id);(!Z||se(Z,q,!1))&&he.set(q.identifier.id,q)}),ie?.forEach(q=>{const Z=he.get(q.identifier.id);if(!Z&&G&&q.type===s.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${q.location.path}.`);return}(!Z||se(Z,q,!1))&&he.set(q.identifier.id,q)}),V?.forEach(q=>{const Z=he.get(q.identifier.id);(!Z||se(Z,q,!0))&&he.set(q.identifier.id,q),he.set(q.identifier.id,q)}),[...he.values()]}async M(G,ie){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,s.ExtensionType.System,!0,ie,!0,void 0,this.R()),te=await(G&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",te.length),te}async N(G,ie){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const z=ie?await this.O():{},te=[],se=d.URI.file(m.$jc(m.$lc(S.$Zg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const q of V){const Z=z[q.name]||"marketplace";switch(Z){case"disabled":break;case"marketplace":te.push((0,$.$gh)(se,q.name));break;default:te.push(d.URI.file(Z));break}}const he=await Promise.all(te.map(async q=>this.n.scanExtension(await this.P(q,!1,s.ExtensionType.System,!0,G,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",he.length),(0,P.$Jb)(he)}async O(){try{const G=await this.w.readFile(this.r);return JSON.parse(G.value.toString())}catch{return{}}}async P(G,ie,V,z,te,se,he,q){const Z=await this.f(te??u.$w),K=await this.Q(G),H=ie&&!this.D.extUri.isEqual(G,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,U=H?await this.Q(H):void 0;return new F(G,K,H,U,ie,he,V,z,se,q.version,q.date,this.C.commit,!this.z.isBuilt,te,Z)}async Q(G){try{const ie=await this.w.stat(G);if(typeof ie.mtime=="number")return ie.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Lq=N,e.$Lq=N=ve([Q(4,R.$Ll),Q(5,f.$Gq),Q(6,t.$_k),Q(7,i.$_j),Q(8,I.$Mi),Q(9,n.$sk),Q(10,L.$Jl),Q(11,a.$Ei)],N);class F{constructor(G,ie,V,z,te,se,he,q,Z,K,H,U,Y,B,j){this.location=G,this.mtime=ie,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=z,this.profile=te,this.profileScanOptions=se,this.type=he,this.excludeObsolete=q,this.validate=Z,this.productVersion=K,this.productDate=H,this.productCommit=U,this.devMode=Y,this.language=B,this.translations=j}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,ie){return(0,$.$_g)(G.location,ie.location)&&G.mtime===ie.mtime&&(0,$.$_g)(G.applicationExtensionslocation,ie.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&G.profile===ie.profile&&C.$ho(G.profileScanOptions,ie.profileScanOptions)&&G.type===ie.type&&G.excludeObsolete===ie.excludeObsolete&&G.validate===ie.validate&&G.productVersion===ie.productVersion&&G.productDate===ie.productDate&&G.productCommit===ie.productCommit&&G.devMode===ie.devMode&&G.language===ie.language&&y.equals(G.translations,ie.translations)}}e.$Mq=F;let D=class extends w.$Wc{constructor(G,ie,V,z,te,se){super(),this.g=G,this.h=ie,this.j=V,this.m=z,this.n=se,this.f=te.extensionsEnabledWithApiProposalVersion?.map(he=>he.toLowerCase())??[]}async scanExtensions(G){const ie=G.profile?await this.s(G):await this.r(G);let V={};if(G.excludeObsolete&&G.type===s.ExtensionType.User)try{const z=(await this.m.readFile(this.g)).value.toString();V=JSON.parse(z)}catch{}return(0,v.$sg)(V)?ie:ie.filter(z=>!V[g.$Kp.create(z).toString()])}async r(G){const ie=await this.m.resolve(G.location);if(!ie.children?.length)return[];const V=await Promise.all(ie.children.map(async z=>{if(!z.isDirectory||G.type===s.ExtensionType.User&&(0,$.$dh)(z.resource).indexOf(".")===0)return null;const te=new F(z.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(te)}));return(0,P.$Jb)(V).sort((z,te)=>z.location.path<te.location.path?-1:1)}async s(G){let ie=await this.t(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.j.extUri.isEqual(G.location,G.applicationExtensionslocation)){ie=ie.filter(z=>!z.metadata?.isApplicationScoped);const V=await this.t(G.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,G);ie.push(...V)}return ie}async t(G,ie,V){const z=await this.h.scanProfileExtensions(G,V.profileScanOptions);if(!z.length)return[];const te=await Promise.all(z.map(async se=>{if(ie(se)){const he=new F(se.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(he,se.metadata)}return null}));return(0,P.$Jb)(te)}async scanOneOrMultipleExtensions(G){try{if(await this.m.exists((0,$.$gh)(G.location,"package.json"))){const ie=await this.scanExtension(G);return ie?[ie]:[]}else return await this.scanExtensions(G)}catch(ie){return this.n.error(`Error scanning extensions at ${G.location.path}:`,(0,T.$_)(ie)),[]}}async scanExtension(G,ie){try{let V=await this.u(G.location);if(V){V.publisher||(V.publisher=s.$mn),ie=ie??V.__metadata,delete V.__metadata;const z=(0,g.$Op)(V.publisher,V.name),te=ie?.id?{id:z,uuid:ie.id}:{id:z},se=ie?.isSystem?s.ExtensionType.System:G.type,he=se===s.ExtensionType.System||!!ie?.isBuiltin;V=await this.w(G.location,V,F.createNlsConfiguration(G)),V.enabledApiProposals&&!this.f?.includes(z.toLowerCase())&&(V.enabledApiProposals=(0,s.$yn)([...V.enabledApiProposals]));const q={type:se,identifier:te,manifest:V,location:G.location,isBuiltin:he,targetPlatform:ie?.targetPlatform??s.TargetPlatform.UNDEFINED,publisherDisplayName:ie?.publisherDisplayName,metadata:ie,isValid:!0,validations:[]};return G.validate?this.validate(q,G):q}}catch(V){G.type!==s.ExtensionType.System&&this.n.error(V)}return null}validate(G,ie){let V=!0;const z=(0,r.$1p)(ie.productVersion,ie.productDate,ie.location,G.manifest,G.isBuiltin);for(const[te,se]of z)te===b.default.Error&&(V=!1,this.n.error(this.D(ie.location,se)));return G.isValid=V,G.validations=z,G}async u(G){const ie=(0,$.$gh)(G,"package.json");let V;try{V=(await this.m.readFile(ie)).value.toString()}catch(te){return(0,t.$ql)(te)!==t.FileOperationResult.FILE_NOT_FOUND&&this.n.error(this.D(G,(0,p.localize)(0,null,ie.path,te.message))),null}let z;try{z=JSON.parse(V)}catch{const se=[];(0,k.$Xn)(V,se);for(const he of se)this.n.error(this.D(G,(0,p.localize)(1,null,ie.path,he.offset,he.length,(0,A.$Iq)(he.error))));return null}return(0,k.$6n)(z)!=="object"?(this.n.error(this.D(G,(0,p.localize)(2,null,ie.path))),null):z}async w(G,ie,V){const z=await this.y(G,ie,V);if(z)try{const te=[],se=await this.z(z.default,te);if(te.length>0)return te.forEach(q=>{this.n.error(this.D(G,(0,p.localize)(3,null,z.default?.path,(0,A.$Iq)(q.error))))}),ie;if((0,k.$6n)(z)!=="object")return this.n.error(this.D(G,(0,p.localize)(4,null,z.default?.path))),ie;const he=z.values||Object.create(null);return(0,E.$Jq)(this.n,ie,he,se)}catch{}return ie}async y(G,ie,V){const z=(0,$.$gh)(G,"package.nls.json"),te=(Z,K)=>{K.forEach(H=>{this.n.error(this.D(G,(0,p.localize)(5,null,Z?.path,(0,A.$Iq)(H.error))))})},se=Z=>{this.n.error(this.D(G,(0,p.localize)(6,null,Z?.path)))},he=`${ie.publisher}.${ie.name}`,q=V.translations[he];if(q)try{const Z=d.URI.file(q),K=(await this.m.readFile(Z)).value.toString(),H=[],U=(0,k.$Xn)(K,H);return H.length>0?(te(Z,H),{values:void 0,default:z}):(0,k.$6n)(U)!=="object"?(se(Z),{values:void 0,default:z}):{values:U.contents?U.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.m.exists(z))return;let K;try{K=await this.C(G,V)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const H=(await this.m.readFile(K.localized)).value.toString(),U=[],Y=(0,k.$Xn)(H,U);return U.length>0?(te(K.localized,U),{values:void 0,default:K.original}):(0,k.$6n)(Y)!=="object"?(se(K.localized),{values:void 0,default:K.original}):{values:Y,default:K.original}}catch{return{values:void 0,default:K.original}}}}async z(G,ie){if(G)try{const V=(await this.m.readFile(G)).value.toString();return(0,k.$Xn)(V,ie)}catch{}}C(G,ie){return new Promise((V,z)=>{const te=se=>{const he=(0,$.$gh)(G,`package.nls.${se}.json`);this.m.exists(he).then(q=>{q&&V({localized:he,original:(0,$.$gh)(G,"package.nls.json")});const Z=se.lastIndexOf("-");Z===-1?V({localized:(0,$.$gh)(G,"package.nls.json"),original:null}):(se=se.substring(0,Z),te(se))})};if(ie.devMode||ie.pseudo||!ie.language)return V({localized:(0,$.$gh)(G,"package.nls.json"),original:null});te(ie.language)})}D(G,ie){return`[${G.path}]: ${ie}`}};D=ve([Q(1,f.$Gq),Q(2,L.$Jl),Q(3,t.$_k),Q(4,n.$sk),Q(5,i.$_j)],D);let M=class extends D{constructor(G,ie,V,z,te,se,he,q){super(ie,z,te,se,he,q),this.I=G,this.J=V,this.G=this.B(new c.$Dh(3e3)),this.H=this.B(new o.$me),this.onDidChangeCache=this.H.event}async scanExtensions(G){const ie=this.O(G),V=await this.L(ie);if(this.F=G,V&&V.input&&F.equals(V.input,this.F))return this.n.debug("Using cached extensions scan result",G.type===s.ExtensionType.System?"system":"user",G.location.toString()),this.G.trigger(()=>this.N()),V.result.map(te=>(te.location=d.URI.revive(te.location),te));const z=await super.scanExtensions(G);return await this.M(ie,{input:G,result:z}),z}async L(G){try{const ie=await this.m.readFile(G),V=JSON.parse(ie.value.toString());return{result:V.result,input:(0,h.$ci)(V.input)}}catch(ie){this.n.debug("Error while reading the extension cache file:",G.path,(0,T.$_)(ie))}return null}async M(G,ie){try{await this.m.writeFile(G,O.$Oe.fromString(JSON.stringify(ie)))}catch(V){this.n.debug("Error while writing the extension cache file:",G.path,(0,T.$_)(V))}}async N(){if(!this.F)return;const G=this.O(this.F),ie=await this.L(G);if(!ie)return;const V=ie.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.F)));if(!C.$ho(z,V))try{this.n.info("Invalidating Cache",V,z),await this.m.del(G),this.H.fire()}catch(te){this.n.error(te)}}O(G){const ie=this.P(G);return this.j.extUri.joinPath(ie.cacheHome,G.type===s.ExtensionType.System?s.$ln:s.$kn)}P(G){return G.type===s.ExtensionType.System?this.J.defaultProfile:G.profile?this.j.extUri.isEqual(G.location,this.I.extensionsResource)?this.I:this.J.profiles.find(ie=>this.j.extUri.isEqual(G.location,ie.extensionsResource))??this.I:this.J.defaultProfile}};M=ve([Q(2,R.$Ll),Q(3,f.$Gq),Q(4,L.$Jl),Q(5,t.$_k),Q(6,n.$sk),Q(7,i.$_j)],M);function J(x,G){const ie=(0,g.$Mp)(x.manifest.publisher,x.manifest.name);return{id:ie,identifier:new s.$qn(ie),isBuiltin:x.type===s.ExtensionType.System,isUserBuiltin:x.type===s.ExtensionType.User&&x.isBuiltin,isUnderDevelopment:G,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,publisherDisplayName:x.publisherDisplayName,...x.manifest}}class W extends N{constructor(G,ie,V,z,te,se,he,q,Z,K,H,U){super(G,ie,(0,$.$gh)(V,".vscode-oss-dev","extensions","control.json"),z,te,se,he,q,Z,K,H,U),this.S=(async()=>{if(u.$z)try{const Y=await this.w.readFile(d.URI.file(u.$z));return JSON.parse(Y.value.toString())}catch{}return Object.create(null)})()}f(G){return this.S}}e.$Oq=W}),define(ce[252],le([0,1,70,6,41,3,2,23,14,31,10,20]),function(ne,e,P,c,C,O,T,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;let u=class extends T.$Wc{constructor(l,b){super(),this.b=l,this.f=b,this.a=new c.$Lh(5)}async postUninstall(l){const b=this.g(l,"uninstall");b&&(this.f.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(b.script,"uninstall",b.args,!0,l),this.f.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(v){this.f.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.f.error(v)}}));try{await w.Promises.rm(this.m(l))}catch(v){this.f.error("Error while removing extension storage path",l.identifier.id),this.f.error(v)}}g(l,b){const v=`vscode:${b}`;if(l.location.scheme===k.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[v]=="string"){const d=l.manifest.scripts[v].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn(l.identifier.id,l.manifest.version,`${v} should be a node script`),null):{script:(0,A.$lc)(l.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h(l,b,v,d,p){return new Promise((I,g)=>{const s=this.j(l,b,v,p);let r;const t=a=>{r&&(clearTimeout(r),r=null),a?g(a):I(void 0)};s.on("error",a=>{t((0,C.$qj)(a)||"Unknown")}),s.on("exit",(a,i)=>{t(a?`post-${b} process exited with code ${a}`:void 0)}),d&&(r=setTimeout(()=>{r=null,s.kill(),g("timed out")},5e3))})}j(l,b,v,d){const p={silent:!0,execArgv:void 0},I=(0,P.fork)(l,[`--type=extension-post-${b}`,...v],p);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const g=O.Event.fromNodeEventEmitter(I.stdout,"data"),s=O.Event.fromNodeEventEmitter(I.stderr,"data");this.B(g(a=>this.f.info(d.identifier.id,d.manifest.version,`post-${b}`,a))),this.B(s(a=>this.f.error(d.identifier.id,d.manifest.version,`post-${b}`,a)));const r=O.Event.any(O.Event.map(g,a=>({data:`%c${a}`,format:[""]}),this.q),O.Event.map(s,a=>({data:`%c${a}`,format:["color: red"]}),this.q));return O.Event.debounce(r,(a,i)=>a?{data:a.data+i.data,format:[...a.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(a=>{console.group(d.identifier.id),console.log(a.data,...a.format),console.groupEnd()}),I}m(l){return(0,A.$lc)(this.b.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.$Sq=u,e.$Sq=u=ve([Q(0,m.$Ll),Q(1,S.$_j)],u)}),define(ce[117],le([0,1,73,167,84,28]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=T,e.$Qq=k;function T(A){let w=O.ExtensionManagementErrorCode.Extract;return A instanceof P.$yq&&(A.type==="CorruptZip"?w=O.ExtensionManagementErrorCode.CorruptZip:A.type==="Incomplete"&&(w=O.ExtensionManagementErrorCode.IncompleteZip)),(0,C.$Dq)(A,w)}async function k(A){let w;try{w=await(0,P.$Bq)(A,"extension/package.json")}catch(S){throw T(S)}try{return JSON.parse(w.toString("utf8"))}catch{throw new O.$kp((0,c.localize)(0,null),O.ExtensionManagementErrorCode.Invalid)}}}),define(ce[253],le([0,1,6,8,2,23,21,61,13,32,31,73,22,16,84,28,33,117,111,7,10,18]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p,I,g,s){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0,k=Oe(k);let t=class extends C.$Wc{static{r=this}static{this.c=".sigzip"}constructor(i,n,o,h,f,R,L){super(),this.h=n,this.j=o,this.m=h,this.n=f,this.r=R,this.t=L,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(i,n,o,h){await this.g;const f=await this.w(i,n);let R=!1;if(o&&this.u(i)){let L;try{L=await this.y(i)}catch(E){try{await this.delete(f)}catch(y){this.t.error(y)}throw E}try{R=await this.n.verify(i,f.fsPath,L.fsPath,h)}catch(E){if(R=E.code,R===p.ExtensionSignatureVerificationCode.PackageIsInvalidZip||R===p.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(f)}catch(y){this.t.error(y)}throw new b.$kp(m.$xq,b.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(L)}catch(E){this.t.error(E)}}}return{location:f,verificationStatus:R}}u(i){if(!i.isSigned)return this.t.info(`Extension is not signed: ${i.identifier.id}`),!1;const n=this.m.getValue("extensions.verifySignature");return(0,A.$lg)(n)?n:!0}async w(i,n){try{const o=(0,T.$gh)(this.extensionsDownloadDir,this.G(i)),h=await this.C(i,"vsix",async()=>{await this.z(i,o,f=>this.j.download(i,f,n));try{await this.D(o.fsPath,"extension/package.json")}catch(f){try{await this.h.del(o)}catch(R){this.t.warn(`Error while deleting: ${o.path}`,(0,c.$_)(R))}throw f}},2);return h>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:i.identifier.id,attempts:h}),o}catch(o){throw(0,l.$Dq)(o,b.ExtensionManagementErrorCode.Download)}}async y(i){try{const n=(0,T.$gh)(this.extensionsDownloadDir,`.${(0,w.$2g)()}`),o=await this.C(i,"sigzip",async()=>{await this.j.downloadSignatureArchive(i,n);try{await this.D(n.fsPath,".signature.p7s")}catch(h){try{await this.h.del(n)}catch(f){this.t.warn(`Error while deleting: ${n.path}`,(0,c.$_)(f))}throw h}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:i.identifier.id,attempts:o}),n}catch(n){throw(0,l.$Dq)(n,b.ExtensionManagementErrorCode.DownloadSignature)}}async z(i,n,o){if(await this.h.exists(n))return;if(n.scheme!==O.Schemas.file){await o(n);return}const h=(0,T.$gh)(this.extensionsDownloadDir,`.${(0,w.$2g)()}`);try{await o(h)}catch(f){try{await this.h.del(h)}catch{}throw f}try{await S.Promises.rename(h.fsPath,n.fsPath,2*60*1e3)}catch(f){try{await this.h.del(h)}catch{}let R=!1;try{R=await this.h.exists(n)}catch{}if(R)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,n.path);else throw this.t.info(`Rename failed because of ${(0,c.$_)(f)}. Deleted the file from downloaded location`,h.path),f}}async C(i,n,o,h){let f=1;for(;;)try{return await o(),f}catch(R){if(f++>h)throw R;this.t.warn(`Failed downloading ${n}. ${(0,c.$_)(R)}. Retry again...`,i.identifier.id)}}async D(i,n){try{await(0,m.$Bq)(i,n)}catch(o){throw(0,d.$Pq)(o)}}async delete(i){await this.g,await this.h.del(i)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const n=[],o=[],h=[];for(const L of i.children)if(L.name.endsWith(r.c))h.push(L.resource);else{const E=v.$Kp.parse(L.name);E&&o.push([E,L])}const f=(0,v.$Pp)(o,([L])=>L),R=[];for(const L of f)L.sort((E,y)=>k.rcompare(E[0].version,y[0].version)),n.push(...L.slice(1).map(E=>E[1].resource)),R.push(L[0][1]);R.sort((L,E)=>L.mtime-E.mtime),n.push(...R.slice(0,Math.max(0,R.length-this.f)).map(L=>L.resource)),n.push(...h),await P.Promises.settled(n.map(L=>(this.t.trace("Deleting from cache",L.path),this.h.del(L))))}}catch(i){this.t.error(i)}}G(i){return this.f?v.$Kp.create(i).toString().toLowerCase():(0,w.$2g)()}};e.$Rq=t,e.$Rq=t=r=ve([Q(0,$.$Ni),Q(1,I.$_k),Q(2,b.$ip),Q(3,u.$_i),Q(4,p.$qq),Q(5,s.$$l),Q(6,g.$_j)],t)}),define(ce[118],le([0,1,6,15,26,41,8,3,56,2,35,23,14,21,61,13,9,32,31,73,166,99,16,84,28,33,53,85,253,252,117,225,235,36,60,7,4,10,24,18,29,20]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p,I,g,s,r,t,a,i,n,o,h,f,R,L,E,y,N,F,D,M,J,W,x,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=e.$Vq=void 0,u=Oe(u),l=Oe(l),p=Oe(p),g=Oe(g),e.$Vq=(0,D.$Gi)(a.$lp);const ie=".vsctmp";let V=class extends t.$Cq{constructor(q,Z,K,H,U,Y,B,j,_,ee,X,oe){super(q,Z,X,K,ee,oe),this.eb=U,this.fb=Y,this.gb=B,this.hb=j,this.ib=_,this.db=new Map,this.tb=new S.$Dc;const ue=this.B(j.createInstance(f.$Sq));this.ab=this.B(j.createInstance(z,be=>ue.postUninstall(be))),this.bb=this.B(new L.$Tq(oe,_,X,this,this.F)),this.cb=this.B(j.createInstance(h.$Rq));const ge=this.B(new E.$Uq(this,this.eb,oe,Y,X,_,K));this.B(ge.onDidChangeExtensionsByAnotherSource(be=>this.sb(be))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Up)(this.ib,this.F)),this.jb}async zip(q){this.F.trace("ExtensionManagementService#zip",q.identifier.id);const Z=await this.rb(q),K=await(0,I.zip)((0,$.$gh)(this.cb.extensionsDownloadDir,(0,d.$2g)()).fsPath,Z);return v.URI.file(K)}async unzip(q){return this.F.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const{location:Z,cleanup:K}=await this.lb(q),H=u.$mc(Z.fsPath);try{return await(0,R.$Qq)(H)}finally{await K()}}getInstalled(q,Z=this.H.defaultProfile.extensionsResource,K={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(q??null,Z,K)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(q){return this.ab.scanUserExtensionAtLocation(q)}async install(q,Z={}){this.F.trace("ExtensionManagementService#install",q.toString());const{location:K,cleanup:H}=await this.lb(q);try{const U=await(0,R.$Qq)(u.$mc(K.fsPath)),Y=(0,i.$Op)(U.publisher,U.name);if(U.engines&&U.engines.vscode&&!(0,N.$3p)(U.engines.vscode,this.G.version,this.G.date))throw new Error(g.localize(0,null,Y,this.G.version));const j=(await this.I([{manifest:U,extension:K,options:Z}])).find(({identifier:_})=>(0,i.$Jp)(_,{id:Y}));if(j?.local)return j.local;throw j?.error?j.error:(0,t.$Dq)(new Error(`Unknown error while installing extension ${Y}`))}finally{await H()}}async installFromLocation(q,Z){this.F.trace("ExtensionManagementService#installFromLocation",q.toString());const K=await this.ab.scanUserExtensionAtLocation(q);if(!K||!K.manifest.name||!K.manifest.version)throw new Error(`Cannot find a valid extension from the location ${q.toString()}`);return await this.wb([[K,{source:"resource"}]],Z),this.F.info("Successfully installed extension",K.identifier.id,Z.toString()),K}async installExtensionsFromProfile(q,Z,K){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",q,Z.toString(),K.toString());const H=(await this.getInstalled(y.ExtensionType.User,Z)).filter(U=>q.some(Y=>(0,i.$Jp)(Y,U.identifier)));if(H.length){const U=await Promise.all(H.map(Y=>this.ab.scanMetadata(Y,Z)));await this.wb(H.map((Y,B)=>[Y,U[B]]),K),this.F.info("Successfully installed extensions",H.map(Y=>Y.identifier.id),K.toString())}return H}async updateMetadata(q,Z,K){return this.F.trace("ExtensionManagementService#updateMetadata",q.identifier.id),Z.isPreReleaseVersion&&(Z.preRelease=!0,Z.hasPreReleaseVersion=!0),Z.isMachineScoped===!1&&(Z.isMachineScoped=void 0),Z.isBuiltin===!1&&(Z.isBuiltin=void 0),Z.pinned===!1&&(Z.pinned=void 0),q=await this.ab.updateMetadata(q,Z,K),this.bb.invalidate(K),this.w.fire({local:q,profileLocation:K}),q}async reinstallFromGallery(q){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",q.identifier.id),!this.z.isEnabled())throw new Error(g.localize(1,null));const Z=await this.getTargetPlatform(),[K]=await this.z.getExtensions([{...q.identifier,preRelease:q.preRelease}],{targetPlatform:Z,compatible:!0},C.CancellationToken.None);if(!K)throw new Error(g.localize(2,null));await this.ab.setUninstalled(q);try{await this.ab.removeUninstalledExtension(q)}catch(H){throw new Error(g.localize(3,null,(0,O.$qj)(H)))}return this.installFromGallery(K)}$(q,Z,K,H){return this.ab.copyExtension(q,Z,K,H)}copyExtensions(q,Z){return this.ab.copyExtensions(q,Z,{version:this.G.version,date:this.G.date})}markAsUninstalled(...q){return this.ab.setUninstalled(...q)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(q){this.F.error(q)}}async download(q,Z,K){const{location:H}=await this.cb.download(q,Z,!K);return H}async lb(q){if(q.scheme===m.Schemas.file)return{location:q,async cleanup(){}};this.F.trace("Downloading extension from",q.toString());const Z=(0,$.$gh)(this.cb.extensionsDownloadDir,(0,d.$2g)());return await this.gb.download(q,Z),this.F.info("Downloaded extension to",Z.toString()),{location:Z,cleanup:async()=>{try{await this.ib.del(Z)}catch(H){this.F.error(H)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(q,Z,K){const H=Z instanceof v.URI?new i.$Kp({id:(0,i.$Op)(q.publisher,q.name)},q.version):i.$Kp.create(Z);return this.hb.createInstance(te,H,q,Z,K,(U,Y)=>{if(Z instanceof v.URI)return this.qb(H,Z,K,Y);let B=this.db.get(H.toString());return B||(this.db.set(H.toString(),B=this.pb(H,Z,U,K,Y)),B.finally(()=>this.db.delete(H.toString()))),B},this.ab)}Z(q,Z){return new se(q,Z.profileLocation,this.fb)}async pb(q,Z,K,H,U){const{verificationStatus:Y,location:B}=await this.cb.download(Z,K,!H.donotVerifySignature,H.context?.[a.$bp]);try{if(U.isCancellationRequested)throw new T.$7;return await(0,R.$Qq)(B.fsPath),{local:await this.ab.extractUserExtension(q,B.fsPath,{id:Z.identifier.uuid,publisherId:Z.publisherId,publisherDisplayName:Z.publisherDisplayName,targetPlatform:Z.properties.targetPlatform,isApplicationScoped:H.isApplicationScoped,isMachineScoped:H.isMachineScoped,isBuiltin:H.isBuiltin,isPreReleaseVersion:Z.properties.isPreReleaseVersion,hasPreReleaseVersion:Z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:H.installGivenVersion?!0:!!H.pinned,preRelease:(0,b.$lg)(H.preRelease)?H.preRelease:H.installPreReleaseVersion||Z.properties.isPreReleaseVersion,source:"gallery"},!1,U),verificationStatus:Y}}catch(j){try{await this.cb.delete(B)}catch(_){this.F.warn("Error while deleting the downloaded file",B.toString(),(0,T.$_)(_))}throw(0,t.$Dq)(j)}}async qb(q,Z,K,H){return{local:await this.ab.extractUserExtension(q,u.$mc(Z.fsPath),{isApplicationScoped:K.isApplicationScoped,isMachineScoped:K.isMachineScoped,isBuiltin:K.isBuiltin,installedTimestamp:Date.now(),pinned:K.installGivenVersion?!0:!!K.pinned,source:"vsix"},!0,H)}}async rb(q){const Z=async H=>{let U=await p.Promises.readdir(H);U=U.map(j=>u.$lc(H,j));const Y=await Promise.all(U.map(j=>p.Promises.stat(j)));let B=Promise.resolve([]);return Y.forEach((j,_)=>{const ee=U[_];j.isFile()&&(B=B.then(X=>[...X,ee])),j.isDirectory()&&(B=B.then(X=>Z(ee).then(oe=>[...X,...oe])))}),B};return(await Z(q.location.fsPath)).map(H=>({path:`extension/${u.$nc(q.location.fsPath,H)}`,localPath:H}))}async sb({added:q,removed:Z}){if(Z){const K=q&&this.D.extUri.isEqual(Z.profileLocation,q.profileLocation)?Z.extensions.filter(H=>q.extensions.every(U=>!(0,i.$Jp)(U,H))):Z.extensions;for(const H of K)this.F.info("Extensions removed from another source",H.id,Z.profileLocation.toString()),this.u.fire({identifier:H,profileLocation:Z.profileLocation})}if(q){const H=(await this.getInstalled(y.ExtensionType.User,q.profileLocation)).filter(U=>q.extensions.some(Y=>(0,i.$Jp)(Y,U.identifier)));this.s.fire(H.map(U=>(this.F.info("Extensions added from another source",U.identifier.id,q.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:q.profileLocation,operation:a.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(Z=>this.tb.add(Z)));const q=await this.ib.resolve(this.eb.userExtensionsLocation);for(const Z of q.children??[])Z.isDirectory&&this.tb.add(Z.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(Z=>this.vb(Z)))}async vb(q){if(!q.affects(this.eb.userExtensionsLocation,F.FileChangeType.ADDED))return;const Z=[];for(const K of q.rawAdded){if(this.tb.has(K)||!this.D.extUri.isEqual(this.D.extUri.dirname(K),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(K,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(K).startsWith(".")||!(await this.ib.stat(K)).isDirectory)continue;const H=await this.ab.scanUserExtensionAtLocation(K);H&&H.installedTimestamp===void 0&&(this.tb.add(K),Z.push(H))}Z.length&&(await this.wb(Z.map(K=>[K,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",Z.map(K=>K.identifier.id)))}async wb(q,Z){const K=q.map(H=>H[0]);await this.xb(K),await this.fb.addExtensionsToProfile(q,Z),this.s.fire(K.map(H=>({local:H,identifier:H.identifier,operation:a.InstallOperation.None,profileLocation:Z})))}async xb(q){const Z=await this.ab.getUninstalledExtensions();for(const K of q){const H=i.$Kp.create(K);Z[H.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",H.id),await this.ab.setInstalled(H),this.F.info("Removed the extension from uninstalled list:",H.id))}}};e.$Wq=V,e.$Wq=V=ve([Q(0,a.$ip),Q(1,W.$$l),Q(2,M.$_j),Q(3,r.$Ni),Q(4,o.$Kq),Q(5,n.$Gq),Q(6,s.$Yo),Q(7,D.$Ei),Q(8,F.$_k),Q(9,J.$sk),Q(10,x.$Jl),Q(11,G.$Ll)],V);let z=class extends w.$Wc{constructor(q,Z,K,H,U,Y,B){super(),this.n=q,this.s=Z,this.t=K,this.u=H,this.w=U,this.y=Y,this.z=B,this.h=this.B(new k.$me),this.onExtract=this.h.event,this.j=new S.$Cc,this.m=new S.$Cc,this.c=(0,$.$gh)(this.t.userExtensionsLocation,".obsolete"),this.g=new P.$Mh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(q,Z,K){try{const H={includeInvalid:!0,profileLocation:Z,productVersion:K};let U=[];if(q===null||q===y.ExtensionType.System){let Y=this.j.get(Z);Y||(Y=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},H,!1).finally(()=>this.j.delete(Z)),this.j.set(Z,Y)),U.push(...await Y)}else if(q===y.ExtensionType.User){let Y=this.m.get(Z);Y||(Y=this.t.scanUserExtensions(H).finally(()=>this.m.delete(Z)),this.m.set(Z,Y)),U.push(...await Y)}return U=q!==null?U.filter(Y=>Y.type===q):U,await Promise.all(U.map(Y=>this.H(Y)))}catch(H){throw(0,t.$Dq)(H,a.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(q){try{const Z=await this.t.scanUserExtensions({includeAllVersions:!q,includeInvalid:!0});return await Promise.all(Z.map(K=>this.H(K)))}catch(Z){throw(0,t.$Dq)(Z,a.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(q){try{const Z=await this.t.scanExistingExtension(q,y.ExtensionType.User,{includeInvalid:!0});if(Z)return await this.H(Z)}catch(Z){this.z.error(Z)}return null}async extractUserExtension(q,Z,K,H,U){const Y=q.toString(),B=v.URI.file(u.$lc(this.t.userExtensionsLocation.fsPath,`.${(0,d.$2g)()}`)),j=v.URI.file(u.$lc(this.t.userExtensionsLocation.fsPath,Y));let _=await this.s.exists(j);if(_&&H){try{await this.D(q.id,j,"removeExisting")}catch{throw new a.$kp(g.localize(4,null,j.fsPath,q.id),a.ExtensionManagementErrorCode.Delete)}_=!1}if(_)try{await this.t.updateMetadata(j,K)}catch(ee){throw this.y.publicLog2("extension:extract",{extensionId:q.id,code:ee.code}),(0,t.$Dq)(ee,a.ExtensionManagementErrorCode.UpdateExistingMetadata)}else try{if(U.isCancellationRequested)throw new T.$7;try{this.z.trace(`Started extracting the extension from ${Z} to ${j.fsPath}`),await(0,I.$Aq)(Z,B.fsPath,{sourcePath:"extension",overwrite:!0},U),this.z.info(`Extracted extension to ${j}:`,q.id)}catch(ee){throw(0,R.$Pq)(ee)}try{await this.t.updateMetadata(B,K)}catch(ee){throw this.y.publicLog2("extension:extract",{extensionId:q.id,code:ee.code}),(0,t.$Dq)(ee,a.ExtensionManagementErrorCode.UpdateMetadata)}if(U.isCancellationRequested)throw new T.$7;try{this.z.trace(`Started renaming the extension from ${B.fsPath} to ${j.fsPath}`),await this.G(B.fsPath,j.fsPath),this.z.info("Renamed to",j.fsPath)}catch(ee){if(ee.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",q.id);try{await this.s.del(B,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,T.$_)(ee)}. Deleted from extracted location`,B),ee}this.h.fire(j)}catch(ee){try{await this.s.del(B,{recursive:!0})}catch{}throw ee}return this.scanLocalExtension(j,y.ExtensionType.User)}async scanMetadata(q,Z){return Z?(await this.C(q,Z))?.metadata:this.t.scanMetadata(q.location)}async C(q,Z){return(await this.u.scanProfileExtensions(Z)).find(H=>(0,i.$Jp)(H.identifier,q.identifier))}async updateMetadata(q,Z,K){try{K?await this.u.updateMetadata([[q,Z]],K):await this.t.updateMetadata(q.location,Z)}catch(H){throw this.y.publicLog2("extension:extract",{extensionId:q.identifier.id,code:H.code}),(0,t.$Dq)(H,a.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(q.location,q.type,K)}async getUninstalledExtensions(){try{return await this.F()}catch(q){throw(0,t.$Dq)(q,a.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...q){const Z=q.map(K=>i.$Kp.create(K));await this.F(K=>Z.forEach(H=>{K[H.toString()]=!0,this.z.info("Marked extension as uninstalled",H.toString())}))}async setInstalled(q){try{await this.F(Z=>delete Z[q.toString()])}catch(Z){throw(0,t.$Dq)(Z,a.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(q,Z){if(this.w.extUri.isEqualOrParent(q.location,this.t.userExtensionsLocation))return this.D(q.identifier.id,q.location,Z)}async removeUninstalledExtension(q){await this.removeExtension(q,"uninstalled"),await this.F(Z=>delete Z[i.$Kp.create(q).toString()])}async copyExtension(q,Z,K,H){const U=await this.C(q,Z),Y=await this.C(q,K);if(H={...U?.metadata,...H},Y)if(this.w.extUri.isEqual(Y.location,q.location))await this.u.updateMetadata([[q,{...Y.metadata,...H}]],K);else{const B=await this.scanLocalExtension(Y.location,q.type,K);await this.u.removeExtensionFromProfile(B,K),await this.u.addExtensionsToProfile([[q,{...Y.metadata,...H}]],K)}else await this.u.addExtensionsToProfile([[q,H]],K);return this.scanLocalExtension(q.location,q.type,K)}async copyExtensions(q,Z,K){const H=await this.scanExtensions(y.ExtensionType.User,q,K),U=await Promise.all(H.filter(Y=>!Y.isApplicationScoped).map(async Y=>[Y,await this.scanMetadata(Y,q)]));await this.u.addExtensionsToProfile(U,Z)}async D(q,Z,K){this.z.trace(`Deleting ${K} extension from disk`,q,Z.fsPath);const H=this.w.extUri.joinPath(this.w.extUri.dirname(Z),`${this.w.extUri.basename(Z)}.${(0,A.$tj)((0,d.$2g)()).toString(16)}${ie}`);await this.G(Z.fsPath,H.fsPath),await this.s.del(H,{recursive:!0}),this.z.info(`Deleted ${K} extension from disk`,q,Z.fsPath)}F(q){return this.g.queue(async()=>{let Z;try{Z=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(H){if((0,F.$ql)(H)!==F.FileOperationResult.FILE_NOT_FOUND)throw H}let K={};if(Z)try{K=JSON.parse(Z)}catch{}return q&&(q(K),Object.keys(K).length?await this.s.writeFile(this.c,c.$Oe.fromString(JSON.stringify(K))):await this.s.del(this.c)),K})}async G(q,Z){try{await p.Promises.rename(q,Z,2*60*1e3)}catch(K){throw(0,t.$Dq)(K,a.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(q,Z,K){try{if(K){const U=(await this.t.scanUserExtensions({profileLocation:K})).find(Y=>this.w.extUri.isEqual(Y.location,q));if(U)return await this.H(U)}else{const H=await this.t.scanExistingExtension(q,Z,{includeInvalid:!0});if(H)return await this.H(H)}throw new a.$kp(g.localize(5,null,q.path),a.ExtensionManagementErrorCode.ScanningExtension)}catch(H){throw(0,t.$Dq)(H,a.ExtensionManagementErrorCode.ScanningExtension)}}async H(q){const Z=await this.s.resolve(q.location);let K,H;return Z.children&&(K=Z.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,H=Z.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:q.identifier,type:q.type,isBuiltin:q.isBuiltin||!!q.metadata?.isBuiltin,location:q.location,manifest:q.manifest,targetPlatform:q.targetPlatform,validations:q.validations,isValid:q.isValid,readmeUrl:K,changelogUrl:H,publisherDisplayName:q.metadata?.publisherDisplayName,publisherId:q.metadata?.publisherId||null,isApplicationScoped:!!q.metadata?.isApplicationScoped,isMachineScoped:!!q.metadata?.isMachineScoped,isPreReleaseVersion:!!q.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!q.metadata?.hasPreReleaseVersion,preRelease:!!q.metadata?.preRelease,installedTimestamp:q.metadata?.installedTimestamp,updated:!!q.metadata?.updated,pinned:!!q.metadata?.pinned,isWorkspaceScoped:!1,source:q.metadata?.source??(q.identifier.uuid?"gallery":"vsix")}}async I(){const q=await this.getUninstalledExtensions();if(Object.keys(q).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(q));const Z=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),K=new Set;for(const U of Z)q[i.$Kp.create(U).toString()]||K.add(U.identifier.id.toLowerCase());try{const U=(0,i.$Pp)(Z,Y=>Y.identifier);await P.Promises.settled(U.map(async Y=>{const B=Y.sort((j,_)=>l.rcompare(j.manifest.version,_.manifest.version))[0];K.has(B.identifier.id.toLowerCase())||await this.n(await this.H(B))}))}catch(U){this.z.error(U)}const H=Z.filter(U=>U.metadata&&q[i.$Kp.create(U).toString()]);await Promise.allSettled(H.map(U=>this.removeUninstalledExtension(U)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let q;try{q=await this.s.resolve(this.t.userExtensionsLocation)}catch(Z){(0,F.$ql)(Z)!==F.FileOperationResult.FILE_NOT_FOUND&&this.z.error(Z);return}if(q?.children)try{await Promise.allSettled(q.children.map(async Z=>{if(!(!Z.isDirectory||!Z.name.endsWith(ie))){this.z.trace("Deleting the temporarily deleted folder",Z.resource.toString());try{await this.s.del(Z.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",Z.resource.toString())}catch(K){(0,F.$ql)(K)!==F.FileOperationResult.FILE_NOT_FOUND&&this.z.error(K)}}}))}catch{}}};e.$Xq=z,e.$Xq=z=ve([Q(1,F.$_k),Q(2,o.$Kq),Q(3,n.$Gq),Q(4,x.$Jl),Q(5,W.$$l),Q(6,M.$_j)],z);let te=class extends t.$Eq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(q,Z,K,H,U,Y,B,j,_,ee,X,oe){super(),this.l=q,this.manifest=Z,this.source=K,this.options=H,this.m=U,this.n=Y,this.o=B,this.p=j,this.q=_,this.s=ee,this.t=X,this.u=oe,this.j=a.InstallOperation.Install,this.identifier=this.l.identifier}async h(q){const K=(await this.n.scanExtensions(y.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(B=>(0,i.$Jp)(B.identifier,this.identifier));K&&(this.j=a.InstallOperation.Update);const H={isApplicationScoped:this.options.isApplicationScoped||K?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||K?.isMachineScoped,isBuiltin:this.options.isBuiltin||K?.isBuiltin,isSystem:K?.type===y.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??K?.pinned,source:this.source instanceof v.URI?"vsix":"gallery"};let U;if(this.source instanceof v.URI)if(K){if(this.l.equals(new i.$Kp(K.identifier,K.manifest.version)))try{await this.n.removeExtension(K,"existing")}catch{throw new Error(g.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const B=await this.w(this.l);if(B)try{await this.n.removeExtension(B,"existing")}catch{throw new Error(g.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(H.id=this.source.identifier.uuid,H.publisherId=this.source.publisherId,H.publisherDisplayName=this.source.publisherDisplayName,H.targetPlatform=this.source.properties.targetPlatform,H.updated=!!K,H.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,H.hasPreReleaseVersion=K?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,H.preRelease=(0,b.$lg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||K?.preRelease,K&&K.type!==y.ExtensionType.System&&K.manifest.version===this.source.version)return this.n.updateMetadata(K,H,this.options.profileLocation);U=await this.w(this.l)}if(q.isCancellationRequested)throw(0,t.$Dq)(new T.$7);if(!U){const B=await this.m(this.operation,q);U=B.local,this.k=B.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(B){throw(0,t.$Dq)(B,a.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(q.isCancellationRequested)throw(0,t.$Dq)(new T.$7);try{await this.t.addExtensionsToProfile([[U,H]],this.options.profileLocation,!U.isValid)}catch(B){throw(0,t.$Dq)(B,a.ExtensionManagementErrorCode.AddToProfile)}const Y=await this.n.scanLocalExtension(U.location,y.ExtensionType.User,this.options.profileLocation);if(!Y)throw new a.$kp("Cannot find the installed extension",a.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof v.URI&&this.x(U,q),Y}async w(q){return(await this.n.getUninstalledExtensions())[q.toString()]?(this.u.trace("Removing the extension from uninstalled list:",q.id),await this.n.setInstalled(q),this.u.info("Removed the extension from uninstalled list:",q.id),(await this.n.scanAllUserExtensions(!0)).find(H=>i.$Kp.create(H).equals(q))):void 0}async x(q,Z){try{let[K]=await this.p.getExtensions([{id:q.identifier.id,version:q.manifest.version}],Z);if(K||([K]=await this.p.getExtensions([{id:q.identifier.id}],Z)),K){const H={id:K.identifier.uuid,publisherDisplayName:K.publisherDisplayName,publisherId:K.publisherId,isPreReleaseVersion:K.properties.isPreReleaseVersion,hasPreReleaseVersion:q.hasPreReleaseVersion||K.properties.isPreReleaseVersion,preRelease:K.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(q,H,this.options.profileLocation)}}catch{}}};te=ve([Q(6,x.$Jl),Q(7,a.$ip),Q(8,G.$Ll),Q(9,o.$Kq),Q(10,n.$Gq),Q(11,M.$_j)],te);class se extends t.$Eq{constructor(q,Z,K){super(),this.extension=q,this.j=Z,this.k=K}async h(q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ce[254],le([0,1,10,20,29,18,53,7,16,9]),function(ne,e,P,c,C,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nR=void 0;let S=class extends T.$Hq{constructor(u,$,l,b,v,d){super(w.URI.file(u.extensionsPath),$,l,b,v,d)}};e.$nR=S,e.$nR=S=ve([Q(0,A.$Ni),Q(1,k.$_k),Q(2,c.$Ll),Q(3,C.$Jl),Q(4,O.$$l),Q(5,P.$_j)],S)}),define(ce[255],le([0,1,9,16,53,85,7,4,10,24,29,20]),function(ne,e,P,c,C,O,T,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;let u=class extends O.$Oq{constructor(l,b,v,d,p,I,g,s){super(P.URI.file(p.builtinExtensionsPath),P.URI.file(p.extensionsPath),p.userHome,l.defaultProfile,l,b,v,d,p,I,g,s)}};e.$qgc=u,e.$qgc=u=ve([Q(0,m.$Ll),Q(1,C.$Gq),Q(2,T.$_k),Q(3,A.$_j),Q(4,c.$Ni),Q(5,w.$sk),Q(6,S.$Jl),Q(7,k.$Ei)],u)}),define(ce[17],le([0,1,6,3,2,101,13,72,4,20]),function(ne,e,P,c,C,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fq=e.$eq=e.$dq=void 0,e.$gq=$,e.$iq=b,e.$kq=d,e.$dq="__$__isNewStorageMarker",e.$eq="__$__targetStorageMarker",e.$fq=(0,A.$Fi)("storageService");var S;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var m;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(m||(e.StorageScope=m={}));var u;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function $(p){const I=p.get(e.$eq);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}class l extends C.$Wc{static{this.a=60*1e3}constructor(I={flushInterval:l.a}){super(),this.m=I,this.b=this.B(new c.$pe),this.c=this.B(new c.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new c.$me),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new C.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,g,s){return c.Event.filter(this.b.event,r=>r.scope===I&&(g===void 0||r.key===g),s)}n(){this.j.value=(0,P.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,C.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,g){const{key:s,external:r}=g;if(s===e.$eq){switch(I){case m.APPLICATION:this.H=void 0;break;case m.PROFILE:this.F=void 0;break;case m.WORKSPACE:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:s,target:this.J(I)[s],external:r})}w(I){this.f.fire({reason:I})}get(I,g,s){return this.P(g)?.get(I,s)}getBoolean(I,g,s){return this.P(g)?.getBoolean(I,s)}getNumber(I,g,s){return this.P(g)?.getNumber(I,s)}getObject(I,g,s){return this.P(g)?.getObject(I,s)}storeAll(I,g){this.y(()=>{for(const s of I)this.store(s.key,s.value,s.scope,s.target,g)})}store(I,g,s,r,t=!1){if((0,T.$og)(g)){this.remove(I,s,t);return}this.y(()=>{this.z(I,s,r),this.P(s)?.set(I,g,t)})}remove(I,g,s=!1){this.y(()=>{this.z(I,g,void 0),this.P(g)?.delete(I,s)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,g){const s=[],r=this.J(I);for(const t of Object.keys(r))r[t]===g&&s.push(t);return s}z(I,g,s,r=!1){const t=this.J(g);typeof s=="number"?t[I]!==s&&(t[I]=s,this.P(g)?.set(e.$eq,JSON.stringify(t),r)):typeof t[I]=="number"&&(delete t[I],this.P(g)?.set(e.$eq,JSON.stringify(t),r))}get D(){return this.C||(this.C=this.L(m.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(m.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(m.APPLICATION)),this.H}J(I){switch(I){case m.APPLICATION:return this.I;case m.PROFILE:return this.G;default:return this.D}}L(I){const g=this.P(I);return g?$(g):Object.create(null)}isNew(I){return this.getBoolean(e.$dq,I)===!0}async flush(I=S.NONE){this.f.fire({reason:I});const g=this.P(m.APPLICATION),s=this.P(m.PROFILE),r=this.P(m.WORKSPACE);switch(I){case S.NONE:await P.Promises.settled([g?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await P.Promises.settled([g?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P(m.APPLICATION)?.items??new Map,g=this.P(m.PROFILE)?.items??new Map,s=this.P(m.WORKSPACE)?.items??new Map;return d(I,g,s,this.Q(m.APPLICATION)??"",this.Q(m.PROFILE)??"",this.Q(m.WORKSPACE)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,g){return this.w(S.NONE),(0,w.$Kl)(I)?this.R(I,g):this.S(I,g)}M(I,g){return!(I.id===g.id||b(g)&&b(I))}N(I,g,s){this.y(()=>{const r=new Set;for(const[t,a]of I)r.add(t),g.get(t)!==a&&this.u(s,{key:t,external:!0});for(const[t]of g.items)r.has(t)||this.u(s,{key:t,external:!0})})}}e.$hq=l;function b(p){return p.isDefault||!!p.useDefaultFlags?.globalState}class v extends l{constructor(){super(),this.U=this.B(new k.$bq(new k.$cq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$bq(new k.$cq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$bq(new k.$cq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u(m.WORKSPACE,I))),this.B(this.W.onDidChangeStorage(I=>this.u(m.PROFILE,I))),this.B(this.U.onDidChangeStorage(I=>this.u(m.APPLICATION,I)))}P(I){switch(I){case m.APPLICATION:return this.U;case m.PROFILE:return this.W;default:return this.X}}Q(I){switch(I){case m.APPLICATION:return"inMemory (application)";case m.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}e.$jq=v;async function d(p,I,g,s,r,t){const a=y=>{try{return JSON.parse(y)}catch{return y}},i=new Map,n=new Map;p.forEach((y,N)=>{i.set(N,y),n.set(N,a(y))});const o=new Map,h=new Map;I.forEach((y,N)=>{o.set(N,y),h.set(N,a(y))});const f=new Map,R=new Map;g.forEach((y,N)=>{f.set(N,y),R.set(N,a(y))}),console.group(s!==r?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const L=[];if(i.forEach((y,N)=>{L.push({key:N,value:y})}),console.table(L),console.groupEnd(),console.log(n),s!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const y=[];o.forEach((N,F)=>{y.push({key:F,value:N})}),console.table(y),console.groupEnd(),console.log(h)}console.group(`Storage: Workspace (path: ${t})`);const E=[];f.forEach((y,N)=>{E.push({key:N,value:y})}),console.table(E),console.groupEnd(),console.log(R)}}),define(ce[119],le([0,1,3,2,13,28,33,17]),function(ne,e,P,c,C,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cMb=e.$bMb=void 0;let A=class extends c.$Wc{constructor(m,u){super(),this.a=new P.$me,this.onDidChangeEnablement=this.a.event,this.b=this.B(new w(m)),this.B(this.b.onDidChange($=>this.a.fire({extensions:$,source:"storage"}))),this.B(u.onDidInstallExtensions($=>$.forEach(({local:l,operation:b})=>{l&&b===O.InstallOperation.Migrate&&this.f(l.identifier)})))}async enableExtension(m,u){return this.f(m)?(this.a.fire({extensions:[m],source:u}),!0):!1}async disableExtension(m,u){return this.c(m)?(this.a.fire({extensions:[m],source:u}),!0):!1}getDisabledExtensions(){return this.h(O.$mp)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(m){const u=this.getDisabledExtensions();return u.every($=>!(0,T.$Jp)($,m))?(u.push(m),this.g(u),!0):!1}f(m){const u=this.getDisabledExtensions();for(let $=0;$<u.length;$++){const l=u[$];if((0,T.$Jp)(l,m))return u.splice($,1),this.g(u),!0}return!1}g(m){this.j(O.$mp,m)}h(m){return this.b.get(m,k.StorageScope.PROFILE)}j(m,u){this.b.set(m,u,k.StorageScope.PROFILE)}};e.$bMb=A,e.$bMb=A=ve([Q(0,k.$fq),Q(1,O.$lp)],A);class w extends c.$Wc{constructor(m){super(),this.c=m,this.a=Object.create(null),this.b=this.B(new P.$me),this.onDidChange=this.b.event,this.B(m.onDidChangeValue(k.StorageScope.PROFILE,void 0,this.B(new c.$Vc))(u=>this.f(u)))}get(m,u){let $;return u===k.StorageScope.PROFILE?((0,C.$og)(this.a[m])&&(this.a[m]=this.g(m,u)),$=this.a[m]):$=this.g(m,u),JSON.parse($)}set(m,u,$){const l=JSON.stringify(u.map(({id:v,uuid:d})=>({id:v,uuid:d})));this.g(m,$)!==l&&($===k.StorageScope.PROFILE&&(u.length?this.a[m]=l:delete this.a[m]),this.h(m,u.length?l:void 0,$))}f(m){if(!(0,C.$og)(this.a[m.key])&&this.g(m.key,m.scope)!==this.a[m.key]){const $=this.get(m.key,m.scope);delete this.a[m.key];const l=this.get(m.key,m.scope),b=$.filter(d=>!l.some(p=>(0,T.$Jp)(d,p))),v=l.filter(d=>!$.some(p=>(0,T.$Jp)(p,d)));(b.length||v.length)&&this.b.fire([...b,...v])}}g(m,u){return this.c.get(m,u,"[]")}h(m,u,$){u?this.c.store(m,u,$,k.StorageTarget.MACHINE):this.c.remove(m,$)}}e.$cMb=w}),define(ce[86],le([0,1,4,3,2,17,33,24,19,10,13]),function(ne,e,P,c,C,O,T,k,A,w,S){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=e.$mw=void 0,e.$mw=(0,P.$Fi)("IExtensionStorageService");const u=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let $=class extends C.$Wc{static{m=this}static{this.a=512*1024}static b(b){return`extensionKeys/${(0,T.$Np)(b.id)}@${b.version}`}static c(b){const v=u.exec(b);if(v&&v[1])return{id:v[1],version:v[2]}}static async removeOutdatedExtensionVersions(b,v){const d=await b.getInstalled(),p=[];for(const[I,g]of m.f(v)){const s=d.find(r=>(0,T.$Jp)(r.identifier,{id:I}))?.manifest.version;for(const r of g)s!==r&&p.push(m.b({id:I,version:r}))}for(const I of p)v.remove(I,O.StorageScope.PROFILE)}static f(b){const v=new Map,d=b.keys(O.StorageScope.PROFILE,O.StorageTarget.MACHINE);for(const p of d){const I=m.c(p);if(I){let g=v.get(I.id.toLowerCase());g||v.set(I.id.toLowerCase(),g=[]),g.push(I.version)}}return v}constructor(b,v,d){super(),this.j=b,this.m=v,this.n=d,this.g=this.B(new c.$me),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=m.f(b),this.B(this.j.onDidChangeValue(O.StorageScope.PROFILE,void 0,this.B(new C.$Vc))(p=>this.r(p)))}r(b){if(this.h.has(b.key.toLowerCase())){this.g.fire();return}const v=m.c(b.key);if(v){if(this.j.get(b.key,O.StorageScope.PROFILE)===void 0)this.h.delete(v.id.toLowerCase());else{let d=this.h.get(v.id.toLowerCase());d||this.h.set(v.id.toLowerCase(),d=[]),d.push(v.version),this.g.fire()}return}}s(b){if((0,S.$fg)(b))return b;const v=b.manifest?b.manifest.publisher:b.publisher,d=b.manifest?b.manifest.name:b.name;return(0,T.$Mp)(v,d)}getExtensionState(b,v){const d=this.s(b),p=this.getExtensionStateRaw(b,v);if(p)try{return JSON.parse(p)}catch(I){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${v}): ${I}`)}}getExtensionStateRaw(b,v){const d=this.s(b),p=this.j.get(d,v?O.StorageScope.PROFILE:O.StorageScope.WORKSPACE);return p&&p?.length>m.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${d}, global: ${v}): ${p.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),p}setExtensionState(b,v,d){const p=this.s(b);v===void 0?this.j.remove(p,d?O.StorageScope.PROFILE:O.StorageScope.WORKSPACE):this.j.store(p,JSON.stringify(v),d?O.StorageScope.PROFILE:O.StorageScope.WORKSPACE,O.StorageTarget.MACHINE)}setKeysForSync(b,v){this.j.store(m.b(b),JSON.stringify(v),O.StorageScope.PROFILE,O.StorageTarget.MACHINE)}getKeysForSync(b){const v=this.m.extensionSyncedKeys?.[b.id.toLowerCase()],d=this.j.get(m.b(b),O.StorageScope.PROFILE),p=d?JSON.parse(d):void 0;return p&&v?(0,A.$Ob)([...p,...v]):p||v}addToMigrationList(b,v){if(b!==v){const d=this.t.filter(p=>!p.includes(b)&&!p.includes(v));d.push([b,v]),this.t=d}}getSourceExtensionToMigrate(b){const v=this.t.find(([,d])=>b===d);return v?v[0]:void 0}get t(){const b=this.j.get("extensionStorage.migrationList",O.StorageScope.APPLICATION,"[]");try{const v=JSON.parse(b);if(Array.isArray(v))return v}catch{}return[]}set t(b){b.length?this.j.store("extensionStorage.migrationList",JSON.stringify(b),O.StorageScope.APPLICATION,O.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",O.StorageScope.APPLICATION)}};e.$nw=$,e.$nw=$=m=ve([Q(0,O.$fq),Q(1,k.$sk),Q(2,w.$_j)],$)}),define(ce[256],le([0,1,2,28,86,234,118,10,17]),function(ne,e,P,c,C,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;let w=class extends P.$Wc{constructor(m,u,$,l,b,v){super(),m.cleanUp(),(0,O.$V6b)(m,u,$,l,v),C.$nw.removeOutdatedExtensionVersions(m,b)}};e.$Ahc=w,e.$Ahc=w=ve([Q(0,T.$Vq),Q(1,c.$ip),Q(2,C.$mw),Q(3,c.$op),Q(4,A.$fq),Q(5,k.$_j)],w)}),define(ce[257],le([0,1,19,2,21,9,7,24,6,3,14,5,37,33,75,36,17]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=e.$Tdc=void 0;let d=class extends c.$Wc{constructor(r,t){super(),this.b=r,this.c=t,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,a])=>this.a.set(a.configPath,a))}getConfigBasedTips(r){return this.f(r)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(r){const t=[];for(const[a,i]of this.a)if(!(i.configScheme&&i.configScheme!==r.scheme))try{const n=(await this.b.readFile((0,C.$gh)(r,a))).value.toString();for(const[o,h]of Object.entries(i.recommendations))(!h.contentPattern||new RegExp(h.contentPattern,"mig").test(n))&&t.push({extensionId:o,extensionName:h.name,configName:i.configName,important:!!h.important,isExtensionPack:!!h.isExtensionPack,whenNotInstalled:h.whenNotInstalled})}catch{}return t}};e.$Tdc=d,e.$Tdc=d=ve([Q(0,T.$_k),Q(1,k.$sk)],d);const p="extensionTips/promptedExecutableTips",I="extensionTips/lastPromptedMediumImpExeTime";class g extends d{constructor(r,t,a,i,n,o,h,f){super(h,f),this.r=r,this.s=t,this.t=a,this.u=i,this.w=n,this.z=o,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,f.exeBasedExtensionTips&&Object.entries(f.exeBasedExtensionTips).forEach(([R,L])=>{const E=[],y=[],N=[];Object.entries(L.recommendations).forEach(([F,D])=>{D.important?L.important?E.push({extensionId:F,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):y.push({extensionId:F,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):N.push({extensionId:F,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),E.length&&this.g.set(R,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:E}),y.length&&this.h.set(R,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:y}),N.length&&this.j.set(R,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:N})}),(0,A.$Hh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const r=await this.O(this.g),t=await this.O(this.h);return[...r,...t]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const r=await this.O(this.g),t=await this.O(this.h),a=await this.u.getInstalled();this.m=this.D(r,a),this.n=this.D(t,a)}D(r,t){const a=new Map;r.forEach(f=>a.set(f.extensionId.toLowerCase(),f));const{installed:i,uninstalled:n}=this.N([...a.keys()],t);for(const f of i){const R=a.get(f);R&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:f,exeName:R.exeName})}for(const f of n){const R=a.get(f);R&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:f,exeName:R.exeName})}const o=this.L(),h=new Map;for(const f of n){const R=a.get(f);if(R&&(!o[R.exeName]||!o[R.exeName].includes(R.extensionId))){let L=h.get(R.exeName);L||(L=[],h.set(R.exeName,L)),L.push(R)}}return h}F(){if(this.m.size===0)return;const[r,t]=[...this.m.entries()][0];this.H(t).then(a=>{switch(a){case l.RecommendationsNotificationResult.Accepted:this.M(t[0].exeName,t);break;case l.RecommendationsNotificationResult.Ignored:this.m.delete(r);break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const i=w.Event.once(w.Event.latch(w.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case l.RecommendationsNotificationResult.TooMany:{const i=this.B(new c.$Xc);i.value=(0,A.$Hh)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const r=this.I(),t=Date.now()-r,a=7*24*60*60*1e3;if(t<a){const o=this.B(new c.$Xc);o.value=(0,A.$Hh)(()=>{o.dispose(),this.G()},a-t);return}const[i,n]=[...this.n.entries()][0];this.H(n).then(o=>{switch(o){case l.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(i),this.M(n[0].exeName,n);const h=this.B(new c.$Xc);h.value=(0,A.$Hh)(()=>{h.dispose(),this.G()},a);break}case l.RecommendationsNotificationResult.Ignored:this.n.delete(i),this.G();break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const h=w.Event.once(w.Event.latch(w.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(h(()=>this.G()));break}case l.RecommendationsNotificationResult.TooMany:{const h=this.B(new c.$Xc);h.value=(0,A.$Hh)(()=>{h.dispose(),this.G()},60*60*1e3);break}}})}async H(r){const t=await this.u.getInstalled(b.ExtensionType.User),a=r.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(n=>t.every(o=>!(0,$.$Jp)(o.identifier,{id:n})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:a,source:l.RecommendationSource.EXE,name:r[0].exeFriendlyName,searchValue:`@exe:"${r[0].exeName}"`})}I(){let r=this.w.getNumber(I,v.StorageScope.APPLICATION);return r||(r=Date.now(),this.J(r)),r}J(r){this.w.store(I,r,v.StorageScope.APPLICATION,v.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(p,v.StorageScope.APPLICATION,"{}"))}M(r,t){const a=this.L();a[r]=t.map(({extensionId:i})=>i.toLowerCase()),this.w.store(p,JSON.stringify(a),v.StorageScope.APPLICATION,v.StorageTarget.USER)}N(r,t){const a=[],i=[],n=t.reduce((o,h)=>(o.add(h.identifier.id.toLowerCase()),o),new Set);return r.forEach(o=>{n.has(o.toLowerCase())?a.push(o):i.push(o)}),{installed:a,uninstalled:i}}async O(r){const t=[],a=new Map;for(const i of r.keys()){const n=r.get(i);if(!n||!(0,P.$Nb)(n.recommendations))continue;const o=[];m.$i?n.windowsPath&&o.push(n.windowsPath.replace("%USERPROFILE%",()=>u.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>u.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>u.env.ProgramFiles).replace("%APPDATA%",()=>u.env.APPDATA).replace("%WINDIR%",()=>u.env.WINDIR)):(o.push((0,S.$lc)("/usr/local/bin",i)),o.push((0,S.$lc)("/usr/bin",i)),o.push((0,S.$lc)(this.r.fsPath,i)));for(const h of o){let f=a.get(h);if(f===void 0&&(f=await this.b.exists(O.URI.file(h)),a.set(h,f)),f)for(const{extensionId:R,extensionName:L,isExtensionPack:E,whenNotInstalled:y}of n.recommendations)t.push({extensionId:R,extensionName:L,isExtensionPack:E,exeName:i,exeFriendlyName:n.exeFriendlyName,windowsPath:n.windowsPath,whenNotInstalled:y})}}return t}}e.$Udc=g}),define(ce[258],le([0,1,28,7,24,16,75,58,17,18,257]),function(ne,e,P,c,C,O,T,k,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;let m=class extends S.$Udc{constructor($,l,b,v,d,p,I,g){super($.userHome,d,l,b,v,p,I,g)}};e.$Hhc=m,e.$Hhc=m=ve([Q(0,O.$Ni),Q(1,w.$$l),Q(2,P.$lp),Q(3,A.$fq),Q(4,k.$Cfc),Q(5,T.$D6b),Q(6,c.$_k),Q(7,C.$sk)],m)}),define(ce[50],le([0,1,15,32,17]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=O;async function O(T,k,A){let w=A&&A.get("storage.serviceMachineId",C.StorageScope.APPLICATION)||null;if(w)return w;try{const m=(await k.readFile(T.serviceMachineIdResource)).value.toString();w=(0,c.$1g)(m)?m:null}catch{w=null}if(!w){w=(0,c.$2g)();try{await k.writeFile(T.serviceMachineIdResource,P.$Oe.fromString(w))}catch{}}return A?.store("storage.serviceMachineId",w,C.StorageScope.APPLICATION,C.StorageTarget.MACHINE),w}}),define(ce[259],le([0,1,50,18,49]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=O;async function O(T,k,A,w,S,m,u){const $={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${k.nameShort})`};if((0,C.$Bp)(k,A)&&(0,C.$Dp)(w)===c.TelemetryLevel.USAGE){const l=await(0,P.$lq)(A,S,m);$["X-Market-User-Id"]=l,$["VSCode-SessionId"]=u.machineId||l}return $}}),define(ce[260],le([0,1,19,26,8,5,37,13,9,22,16,28,33,36,60,7,10,24,62,259,17,18,55]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p,I,g,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=void 0,e.$nq=q;const t=O.$o?$.TargetPlatform.WEB:(0,m.$ep)(O.$u,T.$gc),a="X-Market-Search-Activity-Id";var i;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished",B[B.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...B){return String(B.reduce((j,_)=>j|_,0))}var o;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const h={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},L={pageNumber:1,pageSize:10,sortBy:m.SortBy.NoneOrRelevance,sortOrder:m.SortOrder.Default,flags:i.None,criteria:[],assetTypes:[]};class E{constructor(j=L){this.d=j}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(j,_=this.d.pageSize){return new E({...this.d,pageNumber:j,pageSize:_})}withFilter(j,..._){const ee=[...this.d.criteria,..._.length?_.map(X=>({filterType:j,value:X})):[{filterType:j}]];return new E({...this.d,criteria:ee})}withSortBy(j){return new E({...this.d,sortBy:j})}withSortOrder(j){return new E({...this.d,sortOrder:j})}withFlags(...j){return new E({...this.d,flags:j.reduce((_,ee)=>_|ee,0)})}withAssetTypes(...j){return new E({...this.d,assetTypes:j})}withSource(j){return new E({...this.d,source:j})}get raw(){const{criteria:j,pageNumber:_,pageSize:ee,sortBy:X,sortOrder:oe,flags:ue,assetTypes:ge}=this.d;return{filters:[{criteria:j,pageNumber:_,pageSize:ee,sortBy:X,sortOrder:oe}],assetTypes:ge,flags:ue}}get searchText(){const j=this.d.criteria.filter(_=>_.filterType===o.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(j=>String(j.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function y(B,j){const _=(B||[]).filter(ee=>ee.statisticName===j)[0];return _?_.value:0}function N(B){const j="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(ee=>ee.assetType.indexOf(j)===0).reduce((ee,X)=>{const oe=M(B,X.assetType);return oe&&ee.push([X.assetType.substring(j.length),oe]),ee},[])}function F(B){if(B.properties){const j=B.properties.filter(X=>X.key===h.Repository),_=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ee=j.filter(X=>_.test(X.value))[0];return ee?{uri:ee.value,fallbackUri:ee.value}:null}return M(B,h.Repository)}function D(B){return{uri:`${B.fallbackAssetUri}/${h.VSIX}?redirect=true${B.targetPlatform?`&targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${h.VSIX}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}}function M(B,j){return B.files.filter(ee=>ee.assetType===j)[0]?{uri:`${B.assetUri}/${j}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${j}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}:null}function J(B,j){const _=B.properties?B.properties.filter(X=>X.key===j):[],ee=_.length>0&&_[0].value;return ee?ee.split(",").map(X=>(0,u.$Np)(X)):[]}function W(B){const j=B.properties?B.properties.filter(_=>_.key===f.Engine):[];return j.length>0&&j[0].value||""}function x(B){const j=B.properties?B.properties.filter(_=>_.key===f.PreRelease):[];return j.length>0&&j[0].value==="true"}function G(B){const j=B.properties?B.properties.filter(ee=>ee.key===f.EnabledApiProposals):[],_=j.length>0&&j[0].value||"";return _?_.split(","):[]}function ie(B){const j=B.properties?B.properties.filter(ee=>ee.key===f.LocalizedLanguages):[],_=j.length>0&&j[0].value||"";return _?_.split(","):[]}function V(B){return B.properties?.find(j=>j.key===f.SponsorLink)?.value}function z(B){return B.properties?.find(j=>j.key===f.SupportLink)?.value}function te(B){return B.indexOf("preview")!==-1}function se(B){return B.targetPlatform?(0,m.$dp)(B.targetPlatform):$.TargetPlatform.UNDEFINED}function he(B){const j=(0,P.$Ob)(B.versions.map(se)),_=!!B.tags?.includes(m.$0o),ee=j.indexOf($.TargetPlatform.WEB);return _?ee===-1&&j.push($.TargetPlatform.WEB):ee!==-1&&j.splice(ee,1),j}function q(B,j){for(let _=0;_<B.length;_++){const ee=B[_];if(ee.version===B[_-1]?.version){let X=_;if(se(ee)===j)for(;X>0&&B[X-1].version===ee.version;)X--;X!==_&&(B.splice(_,1),B.splice(X,0,ee))}}return B}function Z(B,j,_){B.telemetryData={index:j,querySource:_,queryActivityId:B.queryContext?.[a]}}function K(B,j,_,ee){const X=B.versions[0],oe={manifest:M(j,h.Manifest),readme:M(j,h.Details),changelog:M(j,h.Changelog),license:M(j,h.License),repository:F(j),download:D(j),icon:M(j,h.Icon),signature:M(j,h.Signature),coreTranslations:N(j)};return{type:"gallery",identifier:{id:(0,u.$Op)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:j.version,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,publisherDomain:B.publisher.domain?{link:B.publisher.domain,verified:!!B.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(X),description:B.shortDescription??"",installCount:y(B.statistics,"install"),rating:y(B.statistics,"averagerating"),ratingCount:y(B.statistics,"ratingcount"),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),allTargetPlatforms:_,assets:oe,properties:{dependencies:J(j,f.Dependency),extensionPack:J(j,f.ExtensionPack),engine:W(j),enabledApiProposals:G(j),localizedLanguages:ie(j),targetPlatform:se(j),isPreReleaseVersion:x(j)},hasPreReleaseVersion:x(X),hasReleaseVersion:!0,preview:te(B.flags),isSigned:!!oe.signature,queryContext:ee,supportLink:z(X)}}let H=class{constructor(j,_,ee,X,oe,ue,ge,be){this.l=_,this.n=ee,this.o=X,this.q=oe,this.u=ue,this.w=ge,this.x=be;const Ie=ge.extensionsGallery,pe=Ie?.servicePPEUrl&&be.getValue("_extensionsGallery.enablePPE");this.d=pe?Ie.servicePPEUrl:Ie?.serviceUrl,this.g=pe?void 0:Ie?.searchUrl,this.h=Ie?.controlUrl,this.k=ge.extensionsEnabledWithApiProposalVersion?.map(we=>we.toLowerCase())??[],this.j=(0,I.$mq)(ge.version,ge,this.o,this.x,this.u,j,this.q)}y(j=""){return`${this.d}${j}`}isEnabled(){return!!this.d}async getExtensions(j,_,ee){const X=c.CancellationToken.isCancellationToken(_)?{}:_,oe=c.CancellationToken.isCancellationToken(_)?_:ee,ue=[],ge=[],be=[],Ie=[];let pe=!0;for(const Se of j){Se.uuid?ge.push(Se.uuid):ue.push(Se.id);const ae=!!(Se.version||Se.preRelease);be.push({id:Se.id,uuid:Se.uuid,includePreRelease:ae}),Se.version&&Ie.push({id:Se.id,uuid:Se.uuid,version:Se.version}),pe=pe&&!!Se.hasPreRelease&&!ae}if(!ge.length&&!ue.length)return[];let we=new E().withPage(1,j.length);ge.length&&(we=we.withFilter(o.ExtensionId,...ge)),ue.length&&(we=we.withFilter(o.ExtensionName,...ue)),(X.queryAllVersions||pe)&&(we=we.withFlags(we.flags,i.IncludeVersions)),X.source&&(we=we.withSource(X.source));const{extensions:Ee}=await this.B(we,{targetPlatform:X.targetPlatform??t,includePreRelease:be,versions:Ie,compatible:!!X.compatible,productVersion:X.productVersion??{version:this.w.version,date:this.w.date}},oe);return X.source&&Ee.forEach((Se,ae)=>Z(Se,ae,X.source)),Ee}async getCompatibleExtension(j,_,ee,X={version:this.w.version,date:this.w.date}){if((0,m.$fp)(j.allTargetPlatforms,ee))return null;if(await this.isExtensionCompatible(j,_,ee))return j;const oe=new E().withFlags(i.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,j.identifier.uuid),{extensions:ue}=await this.B(oe,{targetPlatform:ee,compatible:!0,includePreRelease:_,productVersion:X},c.CancellationToken.None);return ue[0]||null}async isExtensionCompatible(j,_,ee,X={version:this.w.version,date:this.w.date}){if(!(0,m.$gp)(j.properties.targetPlatform,j.allTargetPlatforms,ee)||!_&&j.properties.isPreReleaseVersion)return!1;let oe=j.properties.engine;if(!oe){const ue=await this.getManifest(j,c.CancellationToken.None);if(!ue)throw new Error("Manifest was not found");oe=ue.engines.vscode}return!(!(0,l.$3p)(oe,X.version,X.date)||!this.z(j.identifier,j.properties.enabledApiProposals))}z(j,_){return!_||!this.k.includes(j.id.toLowerCase())?!0:(0,l.$4p)(_)}async A(j,_,ee,X,oe,ue,ge={version:this.w.version,date:this.w.date}){if(!(0,m.$gp)(se(_),oe,ue)||ee!=="any"&&x(_)!==(ee==="prerelease"))return!1;if(X)try{const be=await this.G(j,_);if(!(0,l.$3p)(be,ge.version,ge.date))return!1}catch(be){return this.n.error(`Error while getting the engine for the version ${_.version}.`,(0,C.$_)(be)),!1}return!0}async query(j,_){let ee=j.text||"";const X=j.pageSize??50;let oe=new E().withPage(1,X);ee?(ee=ee.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,we,Ee)=>(oe=oe.withFilter(o.Category,Ee||we),"")),ee=ee.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,we,Ee)=>(oe=oe.withFilter(o.Tag,Ee||we),"")),ee=ee.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(o.Featured),"")),ee=ee.trim(),ee&&(ee=ee.length<200?ee:ee.substring(0,200),oe=oe.withFilter(o.SearchText,ee)),oe=oe.withSortBy(m.SortBy.NoneOrRelevance)):j.ids?oe=oe.withFilter(o.ExtensionId,...j.ids):j.names?oe=oe.withFilter(o.ExtensionName,...j.names):oe=oe.withSortBy(m.SortBy.InstallCount),typeof j.sortBy=="number"&&(oe=oe.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(oe=oe.withSortOrder(j.sortOrder)),j.source&&(oe=oe.withSource(j.source));const ue=async(pe,we)=>{const{extensions:Ee,total:Se}=await this.B(pe,{targetPlatform:t,compatible:!1,includePreRelease:!!j.includePreRelease,productVersion:j.productVersion??{version:this.w.version,date:this.w.date}},we);return Ee.forEach((ae,de)=>Z(ae,(pe.pageNumber-1)*pe.pageSize+de,j.source)),{extensions:Ee,total:Se}},{extensions:ge,total:be}=await ue(oe,_),Ie=async(pe,we)=>{if(we.isCancellationRequested)throw new C.$7;const{extensions:Ee}=await ue(oe.withPage(pe+1),we);return Ee};return{firstPage:ge,total:be,pageSize:oe.pageSize,getPage:Ie}}async B(j,_,ee){const X=j.flags;j.flags&i.IncludeLatestVersionOnly&&j.flags&i.IncludeVersions&&(j=j.withFlags(j.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(j.flags&i.IncludeLatestVersionOnly)&&!(j.flags&i.IncludeVersions)&&(j=j.withFlags(j.flags,i.IncludeLatestVersionOnly)),_.versions?.length&&(j=j.withFlags(j.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),j=j.withFlags(j.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:oe,total:ue,context:ge}=await this.D(j,ee);if(!(j.flags&i.IncludeLatestVersionOnly)){const we=[];for(const Ee of oe){const Se=await this.C(Ee,_,ge);Se&&we.push(Se)}return{extensions:we,total:ue}}const Ie=[],pe=new Map;for(let we=0;we<oe.length;we++){const Ee=oe[we],Se={id:(0,u.$Op)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},ae=(0,k.$lg)(_.includePreRelease)?_.includePreRelease:!!_.includePreRelease.find(me=>(0,u.$Jp)(me,Se))?.includePreRelease;if(_.compatible&&(0,m.$fp)(he(Ee),_.targetPlatform))continue;const de=await this.C(Ee,_,ge);!de||de.properties.isPreReleaseVersion&&(!ae||!de.hasReleaseVersion)||!de.properties.isPreReleaseVersion&&de.properties.targetPlatform!==_.targetPlatform&&de.hasPreReleaseVersion?pe.set(Ee.extensionId,we):Ie.push([we,de])}if(pe.size){const we=new r.$ge,Ee=new E().withFlags(X&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,pe.size).withFilter(o.ExtensionId,...pe.keys()),{extensions:Se}=await this.B(Ee,_,ee);this.q.publicLog2("galleryService:additionalQuery",{duration:we.elapsed(),count:pe.size});for(const ae of Se){const de=pe.get(ae.identifier.uuid);Ie.push([de,ae])}}return{extensions:Ie.sort((we,Ee)=>we[0]-Ee[0]).map(([,we])=>we),total:ue}}async C(j,_,ee){const X={id:(0,u.$Op)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},oe=_.versions?.find(Ie=>(0,u.$Jp)(Ie,X))?.version,ue=(0,k.$lg)(_.includePreRelease)?_.includePreRelease:!!_.includePreRelease.find(Ie=>(0,u.$Jp)(Ie,X))?.includePreRelease,ge=he(j),be=q(j.versions,_.targetPlatform);if(_.compatible&&(0,m.$fp)(ge,_.targetPlatform))return null;for(let Ie=0;Ie<be.length;Ie++){const pe=be[Ie];if(!(oe&&pe.version!==oe)){if(await this.A(X.id,pe,ue?"any":"release",_.compatible,ge,_.targetPlatform,_.productVersion))return _.compatible&&!this.z(X,G(pe))?null:K(j,pe,ge,ee);if(oe&&pe.version===oe)return null}}return oe||_.compatible?null:K(j,j.versions[0],ge)}async D(j,_){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,i.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,n(i.Unpublished));const ee=await this.j,X=JSON.stringify(j.raw),oe={...ee,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},ue=new r.$ge;let ge,be,Ie=0;try{if(ge=await this.l.request({type:"POST",url:this.g&&j.criteria.some(we=>we.filterType===o.SearchText)?this.g:this.y("/extensionquery"),data:X,headers:oe},_),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:Ie};const pe=await(0,p.$$p)(ge);if(pe){const we=pe.results[0],Ee=we.extensions,Se=we.resultMetadata&&we.resultMetadata.filter(ae=>ae.metadataType==="ResultCount")[0];return Ie=Se&&Se.metadataItems.filter(ae=>ae.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:Ie,context:{[a]:ge.res.headers.activityid}}}return{galleryExtensions:[],total:Ie}}catch(pe){if((0,C.$6)(pe))throw be=m.ExtensionGalleryErrorCode.Cancelled,pe;{const we=(0,C.$_)(pe);throw be=we.startsWith("XHR timeout")?m.ExtensionGalleryErrorCode.Timeout:m.ExtensionGalleryErrorCode.Failed,new m.$jp(we,be)}}finally{this.q.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(X.length),duration:ue.elapsed(),success:!!ge&&(0,p.$7p)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:be,count:String(Ie)})}}async reportStatistic(j,_,ee,X){if(!this.isEnabled())return;const oe=O.$o?this.y(`/itemName/${j}.${_}/version/${ee}/statType/${X===m.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${j}/extensions/${_}/${ee}/stats?statType=${X}`),ue=O.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",be={...await this.j,Accept:ue};try{await this.l.request({type:"POST",url:oe,headers:be},c.CancellationToken.None)}catch{}}async download(j,_,ee){this.n.trace("ExtensionGalleryService#download",j.identifier.id);const X=(0,u.$Rp)(j),oe=new Date().getTime(),ue=ee===m.InstallOperation.Install?"install":ee===m.InstallOperation.Update?"update":"",ge=ue?{uri:`${j.assets.download.uri}${A.URI.parse(j.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${j.assets.download.fallbackUri}${A.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:j.assets.download,be=j.queryContext?.[a]?{[a]:j.queryContext[a]}:void 0,Ie=await this.F(j.identifier.id,ge,h.VSIX,be?{headers:be}:void 0);try{await this.u.writeFile(_,Ie.stream)}catch(pe){try{await this.u.del(_)}catch(we){this.n.warn(`Error while deleting the file ${_.toString()}`,(0,C.$_)(we))}throw new m.$jp((0,C.$_)(pe),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...X,duration:new Date().getTime()-oe})}async downloadSignatureArchive(j,_){if(!j.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",j.identifier.id);const ee=await this.F(j.identifier.id,j.assets.signature,h.Signature);try{await this.u.writeFile(_,ee.stream)}catch(X){try{await this.u.del(_)}catch(oe){this.n.warn(`Error while deleting the file ${_.toString()}`,(0,C.$_)(oe))}throw new m.$jp((0,C.$_)(X),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(j,_){if(j.assets.readme){const ee=await this.F(j.identifier.id,j.assets.readme,h.Details,{},_);return await(0,p.$0p)(ee)||""}return""}async getManifest(j,_){if(j.assets.manifest){const ee=await this.F(j.identifier.id,j.assets.manifest,h.Manifest,{},_),X=await(0,p.$0p)(ee);return X?JSON.parse(X):null}return null}async E(j,_,ee){const X=M(_,h.Manifest);if(!X)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},ue=await this.F(j,X,h.Manifest,{headers:oe});return await(0,p.$$p)(ue)}async getCoreTranslation(j,_){const ee=j.assets.coreTranslations.filter(X=>X[0]===_.toUpperCase())[0];if(ee){const X=await this.F(j.identifier.id,ee[1],ee[0]),oe=await(0,p.$0p)(X);return oe?JSON.parse(oe):null}return null}async getChangelog(j,_){if(j.assets.changelog){const ee=await this.F(j.identifier.id,j.assets.changelog,h.Changelog,{},_);return await(0,p.$0p)(ee)||""}return""}async getAllCompatibleVersions(j,_,ee){let X=new E().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);j.uuid?X=X.withFilter(o.ExtensionId,j.uuid):X=X.withFilter(o.ExtensionName,j.id);const{galleryExtensions:oe}=await this.D(X,c.CancellationToken.None);if(!oe.length)return[];const ue=he(oe[0]);if((0,m.$fp)(ue,ee))return[];const ge=[];await Promise.all(oe[0].versions.map(async pe=>{try{await this.A(j.id,pe,_?"any":"release",!0,ue,ee)&&this.z(j,G(pe))&&ge.push(pe)}catch{}}));const be=[],Ie=new Set;for(const pe of q(ge,ee))Ie.has(pe.version)||(Ie.add(pe.version),be.push({version:pe.version,date:pe.lastUpdated,isPreReleaseVersion:x(pe)}));return be}async F(j,_,ee,X={},oe=c.CancellationToken.None){const ue=await this.j,ge={type:"GET"},be={...ue,...X.headers||{}};X={...X,...ge,headers:be};const Ie=_.uri,pe=_.fallbackUri,we={...X,url:Ie};try{const Ee=await this.l.request(we,oe);if(Ee.res.statusCode===200)return Ee;const Se=await(0,p.$0p)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${Se}`)}catch(Ee){if((0,C.$6)(Ee))throw Ee;const Se=(0,C.$_)(Ee);this.q.publicLog2("galleryService:cdnFallback",{extension:j,assetType:ee,message:Se});const ae={...X,url:pe};return this.l.request(ae,oe)}}async G(j,_){let ee=W(_);if(!ee){this.q.publicLog2("galleryService:engineFallback",{extension:j,version:_.version});const X=await this.E(j,_,c.CancellationToken.None);if(!X)throw new Error("Manifest was not found");ee=X.engines.vscode}return ee}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const j=await this.l.request({type:"GET",url:this.h},c.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const _=await(0,p.$$p)(j),ee=[],X={},oe=[];if(_){for(const ue of _.malicious)ee.push({id:ue});if(_.migrateToPreRelease)for(const[ue,ge]of Object.entries(_.migrateToPreRelease))(!ge.engine||(0,l.$3p)(ge.engine,this.w.version,this.w.date))&&(X[ue.toLowerCase()]={disallowInstall:!0,extension:{id:ge.id,displayName:ge.displayName,autoMigrate:{storage:!!ge.migrateStorage},preRelease:!0}});if(_.deprecated)for(const[ue,ge]of Object.entries(_.deprecated))ge&&(X[ue.toLowerCase()]=(0,k.$lg)(ge)?{}:ge);if(_.search)for(const ue of _.search)oe.push(ue)}return{malicious:ee,deprecated:X,search:oe}}};H=ve([Q(1,p.$5p),Q(2,v.$_j),Q(3,S.$Mi),Q(4,s.$$l),Q(5,b.$_k),Q(6,d.$sk),Q(7,w.$_i)],H);let U=class extends H{constructor(j,_,ee,X,oe,ue,ge,be){super(j,_,ee,X,oe,ue,ge,be)}};e.$oq=U,e.$oq=U=ve([Q(0,g.$fq),Q(1,p.$5p),Q(2,v.$_j),Q(3,S.$Mi),Q(4,s.$$l),Q(5,b.$_k),Q(6,d.$sk),Q(7,w.$_i)],U);let Y=class extends H{constructor(j,_,ee,X,oe,ue,ge){super(void 0,j,_,ee,X,oe,ue,ge)}};e.$pq=Y,e.$pq=Y=ve([Q(0,p.$5p),Q(1,v.$_j),Q(2,S.$Mi),Q(3,s.$$l),Q(4,b.$_k),Q(5,d.$sk),Q(6,w.$_i)],Y)}),define(ce[261],le([0,1,108,3,18,16,2,10,14,70,24,5,6,102,22,176,38,17,13,138,21]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;const s=[P.$whc,P.$xhc],r="remoteTunnelSession",t="remoteTunnelIsService";let a=class extends T.$Wc{constructor(h,f,R,L,E,y,N){super(),this.y=h,this.z=f,this.C=R,this.D=y,this.F=N,this.f=new c.$me,this.onDidTokenFailed=this.f.event,this.g=new c.$me,this.onDidChangeTunnelStatus=this.g.event,this.h=new c.$me,this.onDidChangeMode=this.h.event,this.n=P.$uhc,this.w=!1,this.I=(F,D)=>{D?this.j.error(F):this.j.info(F)},this.j=this.B(L.createLogger((0,g.$gh)(R.logsHome,`${P.$yhc}.log`),{id:P.$yhc,name:P.$zhc})),this.t=new u.$Ch(100),this.B(this.j.onDidChangeLogLevel(F=>this.j.info("Log level changed to "+(0,k.$ok)(F)))),this.B(E.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(y.onDidChangeConfiguration(F=>{s.some(D=>F.affectsConfiguration(D))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=P.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(h){this.s=h,this.g.fire(h)}H(h){n(this.n,h)||(this.n=h,this.S(h),this.h.fire(this.n),h.active?(this.j.info(`Session updated: ${h.session.accountLabel} (${h.session.providerId}) (service=${h.asService})`),h.session.token&&this.j.info(`Session token updated: ${h.session.accountLabel} (${h.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(h){if(this.w)return this.s;this.w=!0,this.H(h);try{await this.t.trigger(()=>this.L())}catch(f){this.j.error(f)}return this.s}J(){if(!this.u){let h;m.$j?h=this.C.appRoot:h=(0,A.$oc)((0,A.$oc)(this.C.appRoot)),this.u=(0,A.$lc)(h,"bin",`${this.z.tunnelApplicationName}${m.$i?".exe":""}`)}return this.u}async startTunnel(h){if(n(this.n,h)&&this.s.type!=="disconnected")return this.s;this.H(h);try{await this.t.trigger(()=>this.L())}catch(f){this.j.error(f)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const h=this.n.asService;this.H(P.$uhc);try{h&&this.O("uninstallService",["service","uninstall"])}catch(f){this.j.error(f)}}try{await this.O("stop",["kill"])}catch(h){this.j.error(h)}this.G(P.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let h="",f=!1;const R=(D,M)=>{M?this.j.error(D):h+=D,!this.C.isBuilt&&D.startsWith("   Compiling")&&this.G(P.TunnelStates.connecting((0,b.localize)(0,null)))},L=this.O("status",["status"],R);this.r=L;try{if(await L,this.r!==L)return;let D;try{D=JSON.parse(h.trim().split(`
`).find(M=>M.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(h.trim())}`),this.G(P.TunnelStates.disconnected());return}if(f=D.service_installed,this.j.info(D.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!D.tunnel&&!this.n.active){this.G(P.TunnelStates.disconnected());return}}catch(D){this.j.error(D),this.G(P.TunnelStates.disconnected());return}finally{this.r===L&&(this.r=void 0)}const E=this.n.active?this.n.session:void 0;if(E&&E.token){const D=E.token;this.G(P.TunnelStates.connecting((0,b.localize)(1,null,E.accountLabel,E.providerId)));const M=(W,x)=>{W=W.replaceAll(D,"*".repeat(4)),R(W,x)},J=this.O("login",["user","login","--provider",E.providerId,"--log",(0,k.$ok)(this.j.getLevel())],M,{VSCODE_CLI_ACCESS_TOKEN:D});this.r=J;try{if(await J,this.r!==J)return}catch(W){this.j.error(W),this.r=void 0,this.f.fire(E),this.G(P.TunnelStates.disconnected(E));return}}const y=this.Q();y?this.G(P.TunnelStates.connecting((0,b.localize)(2,null,y))):this.G(P.TunnelStates.connecting((0,b.localize)(3,null)));const N=["--accept-server-license-terms","--log",(0,k.$ok)(this.j.getLevel())];y?N.push("--name",y):N.push("--random-name");let F=!1;return this.n.active&&this.n.asService&&!f&&(F=await this.M(N)===!1),this.N(E,N,F)}async M(h){let f;try{f=await this.O("serviceInstall",["service","install",...h])}catch(R){this.j.error(R),f=1}if(f!==0){const R=(0,b.localize)(4,null);return this.j.warn(R),this.G(P.TunnelStates.connecting(R)),!1}return!0}async N(h,f,R){f.push("--parent-process-id",String(process.pid)),this.P()&&f.push("--no-sleep");let L=!1;const E=this.O("tunnel",f,(y,N)=>{N?this.j.error(y):this.j.info(y),y.includes("Connected to an existing tunnel process")&&(L=!0);const F=y.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const D={link:F[1],domain:F[2],tunnelName:F[4],isAttached:L};this.G(P.TunnelStates.connected(D,R))}else y.match(/error refreshing token/)&&(E.cancel(),this.f.fire(h),this.G(P.TunnelStates.disconnected(h)))});this.r=E,E.finally(()=>{E===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=P.$uhc,this.G(P.TunnelStates.disconnected()))})}O(h,f,R=this.I,L){return(0,u.$sh)(E=>new Promise((y,N)=>{E.isCancellationRequested&&y(-1);let F;const D=["ignore","pipe","pipe"];if(E.onCancellationRequested(()=>{F&&(this.j.info(`${h} terminating(${F.pid})`),F.kill())}),!this.C.isBuilt)R(`Building tunnel CLI from sources and run
`,!1),R(`${h} Spawning: cargo run -- tunnel ${f.join(" ")}
`,!1),F=(0,w.spawn)("cargo",["run","--","tunnel",...f],{cwd:(0,A.$lc)(this.C.appRoot,"cli"),stdio:D,env:{...process.env,RUST_BACKTRACE:"1",...L}});else{R(`Running tunnel CLI
`,!1);const M=this.J();R(`${h} Spawning: ${M} tunnel ${f.join(" ")}
`,!1),F=(0,w.spawn)(M,["tunnel",...f],{cwd:(0,v.homedir)(),stdio:D,env:{...process.env,...L}})}F.stdout.pipe(new I.$zX(`
`)).on("data",M=>{if(F){const J=M.toString();R(J,!1)}}),F.stderr.pipe(new I.$zX(`
`)).on("data",M=>{if(F){const J=M.toString();R(J,!0)}}),F.on("exit",M=>{F&&(R(`${h} exit(${F.pid}): + ${M} `,!1),F=void 0,y(M||0))}),F.on("error",M=>{F&&(R(`${h} error(${F.pid}): + ${M} `,!0),F=void 0,N())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(P.$xhc)}Q(){let h=this.D.getValue(P.$whc)||(0,v.hostname)();return h=h.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),h||void 0}R(){try{const h=this.F.get(r,d.StorageScope.APPLICATION),f=this.F.getBoolean(t,d.StorageScope.APPLICATION,!1);if(h){const R=JSON.parse(h);if(R&&(0,p.$fg)(R.accountLabel)&&(0,p.$fg)(R.sessionId)&&(0,p.$fg)(R.providerId))return{active:!0,session:R,asService:f};this.j.error("Problems restoring session from storage, invalid format",R)}}catch(h){this.j.error("Problems restoring session from storage",h)}return P.$uhc}S(h){if(h.active){const f={providerId:h.session.providerId,sessionId:h.session.sessionId,accountLabel:h.session.accountLabel};this.F.store(r,JSON.stringify(f),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),this.F.store(t,h.asService,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}else this.F.remove(r,d.StorageScope.APPLICATION),this.F.remove(t,d.StorageScope.APPLICATION)}};e.$Dhc=a,e.$Dhc=a=ve([Q(0,C.$$l),Q(1,S.$sk),Q(2,O.$Ni),Q(3,k.$ak),Q(4,$.$Bhc),Q(5,l.$_i),Q(6,d.$fq)],a);function i(o,h){return o&&h?o.sessionId===h.sessionId&&o.providerId===h.providerId&&o.token===h.token:o===h}const n=(o,h)=>o.active!==h.active?!1:o.active&&h.active?o.asService===h.asService&&i(o.session,h.session):!0}),define(ce[262],le([0,1,6,2,23,21,72,17,80,20]),function(ne,e,P,c,C,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0;class S extends k.$hq{constructor(u,$,l,b){super(),this.bb=u,this.cb=$,this.db=l,this.eb=b,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new c.$Vc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new c.$Vc),this.ab=this.hb(this.bb)}fb(){const u=this.B(new A.$LMb(this.db.getChannel("storage"))),$=this.B(new T.$bq(u));return this.B($.onDidChangeStorage(l=>this.u(k.StorageScope.APPLICATION,l))),$}gb(u){this.X.clear(),this.W=u;let $;if((0,k.$iq)(u))$=this.U;else{const l=this.X.add(new A.$MMb(this.db.getChannel("storage"),u));$=this.X.add(new T.$bq(l))}return this.X.add($.onDidChangeStorage(l=>this.u(k.StorageScope.PROFILE,l))),$}hb(u){this.$.clear(),this.Z=u?.id;let $;if(u){const l=this.$.add(new A.$NMb(this.db.getChannel("storage"),u));$=this.$.add(new T.$bq(l)),this.$.add($.onDidChangeStorage(b=>this.u(k.StorageScope.WORKSPACE,b)))}return $}async O(){await P.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(u){switch(u){case k.StorageScope.APPLICATION:return this.U;case k.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q(u){switch(u){case k.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:C.Schemas.file}).fsPath;case k.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:C.Schemas.file}).fsPath;default:return this.Z?`${(0,O.$gh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:C.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(k.WillSaveStateReason.SHUTDOWN),await P.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(u){if(!this.M(this.W,u))return;const $=this.Y,l=$.items;$!==this.U&&await $.close(),this.Y=this.gb(u),await this.Y.init(),this.N(l,this.Y,k.StorageScope.PROFILE)}async S(u,$){const l=this.ab,b=l?.items??new Map;await l?.close(),this.ab=this.hb(u),await this.ab.init(),this.N(b,this.ab,k.StorageScope.WORKSPACE)}hasScope(u){return(0,w.$Kl)(u)?this.W.id===u.id:this.Z===u.id}}e.$Ihc=S}),define(ce[263],le([0,1,3,2,20,95]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vR=e.$uR=void 0;class T{constructor(w,S){this.a=w,this.b=S}listen(w,S){const m=this.b(w);switch(S){case"onDidChangeProfiles":return P.Event.map(this.a.onDidChangeProfiles,u=>({all:u.all.map($=>(0,O.$Nn)({...$},m)),added:u.added.map($=>(0,O.$Nn)({...$},m)),removed:u.removed.map($=>(0,O.$Nn)({...$},m)),updated:u.updated.map($=>(0,O.$Nn)({...$},m))}))}throw new Error(`Invalid listen ${S}`)}async call(w,S,m){const u=this.b(w);switch(S){case"createProfile":{const $=await this.a.createProfile(m[0],m[1],m[2]);return(0,O.$Nn)({...$},u)}case"updateProfile":{let $=(0,C.$Ml)((0,O.$On)(m[0],u),this.a.profilesHome.scheme);return $=await this.a.updateProfile($,m[1]),(0,O.$Nn)({...$},u)}case"removeProfile":{const $=(0,C.$Ml)((0,O.$On)(m[0],u),this.a.profilesHome.scheme);return this.a.removeProfile($)}}throw new Error(`Invalid call ${S}`)}}e.$uR=T;class k extends c.$Wc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(w,S,m){super(),this.profilesHome=S,this.f=m,this.a=[],this.b=this.B(new P.$me),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=w.map(u=>(0,C.$Ml)(u,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(u=>{const $=u.added.map(v=>(0,C.$Ml)(v,this.profilesHome.scheme)),l=u.removed.map(v=>(0,C.$Ml)(v,this.profilesHome.scheme)),b=u.updated.map(v=>(0,C.$Ml)(v,this.profilesHome.scheme));this.a=u.all.map(v=>(0,C.$Ml)(v,this.profilesHome.scheme)),this.b.fire({added:$,removed:l,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(w){this.c=w}isEnabled(){return this.c}async createNamedProfile(w,S,m){const u=await this.f.call("createNamedProfile",[w,S,m]);return(0,C.$Ml)(u,this.profilesHome.scheme)}async createProfile(w,S,m,u){const $=await this.f.call("createProfile",[w,S,m,u]);return(0,C.$Ml)($,this.profilesHome.scheme)}async createTransientProfile(w){const S=await this.f.call("createTransientProfile",[w]);return(0,C.$Ml)(S,this.profilesHome.scheme)}async setProfileForWorkspace(w,S){await this.f.call("setProfileForWorkspace",[w,S])}removeProfile(w){return this.f.call("removeProfile",[w])}async updateProfile(w,S){const m=await this.f.call("updateProfile",[w,S]);return(0,C.$Ml)(m,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$vR=k}),define(ce[63],le([0,1,2,72,4,17,3,80,20]),function(ne,e,P,c,C,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RMb=e.$QMb=e.$PMb=void 0,e.$PMb=(0,C.$Fi)("IUserDataProfileStorageService");let w=class extends P.$Wc{constructor($,l){super(),this.b=l,$&&(this.a=this.B(new P.$6c))}async readStorageData($){return this.withProfileScopedStorageService($,async l=>this.c(l))}async updateStorageData($,l,b){return this.withProfileScopedStorageService($,async v=>this.f(v,l,b))}async withProfileScopedStorageService($,l){if(this.b.hasScope($))return l(this.b);let b=this.a?.get($.id);if(!b){b=new m(this.g($)),this.a?.set($.id,b);try{await b.initialize()}catch(v){throw this.a?.has($.id)?this.a.deleteAndDispose($.id):b.dispose(),v}}try{const v=await l(b);return await b.flush(),v}finally{this.a?.has($.id)||b.dispose()}}c($){const l=new Map,b=v=>{for(const d of $.keys(O.StorageScope.PROFILE,v))l.set(d,{value:$.get(d,O.StorageScope.PROFILE),target:v})};return b(O.StorageTarget.USER),b(O.StorageTarget.MACHINE),l}f($,l,b){$.storeAll(Array.from(l.entries()).map(([v,d])=>({key:v,value:d,scope:O.StorageScope.PROFILE,target:b})),!0)}};e.$QMb=w,e.$QMb=w=ve([Q(1,O.$fq)],w);class S extends w{constructor($,l,b,v,d){super($,v),this.j=l;const p=l.getChannel("profileStorageListener"),I=this.B(new P.$Xc);this.h=this.B(new T.$me({onWillAddFirstListener:()=>{I.value=p.listen("onDidChange")(g=>{d.trace("profile storage changes",g),this.h.fire({targetChanges:g.targetChanges.map(s=>(0,A.$Ml)(s,b.profilesHome.scheme)),valueChanges:g.valueChanges.map(s=>({...s,profile:(0,A.$Ml)(s.profile,b.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>I.value=void 0})),this.onDidChange=this.h.event}async g($){const l=this.j.getChannel("storage");return(0,O.$iq)($)?new k.$LMb(l):new k.$MMb(l,$)}}e.$RMb=S;class m extends O.$hq{constructor($){super({flushInterval:100}),this.U=$}async O(){const $=await this.U,l=new c.$bq($);return this.B(l.onDidChangeStorage(b=>{this.u(O.StorageScope.PROFILE,b)})),this.B((0,P.$Uc)(()=>{l.close(),l.dispose(),(0,P.$Qc)($)&&$.dispose()})),this.s=l,this.s.init()}P($){return $===O.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ce[264],le([0,1,17,10,20,57,63]),function(ne,e,P,c,C,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;let k=class extends T.$RMb{constructor(w,S,m,u){super(!0,w,S,m,u)}};e.$nhc=k,e.$nhc=k=ve([Q(0,O.$Ugc),Q(1,C.$Ll),Q(2,P.$fq),Q(3,c.$_j)],k)}),define(ce[40],le([0,1,19,6,15,26,3,34,2,27,13,181,22,16,7,10,50,17,18,29,25,20]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p,I,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YNb=e.$XNb=e.$WNb=e.$VNb=void 0,e.$SNb=r,e.$TNb=t,e.$UNb=a;function r(f){return!!(f&&f.ref!==void 0&&typeof f.ref=="string"&&f.ref!==""&&f.syncData!==void 0&&(f.syncData===null||t(f.syncData)))}function t(f){return!!(f&&f.version!==void 0&&typeof f.version=="number"&&f.content!==void 0&&typeof f.content=="string"&&(Object.keys(f).length===2||Object.keys(f).length===3&&f.machineId!==void 0&&typeof f.machineId=="string"))}function a(f,R){return`${(0,w.$0f)(f)}${R.isDefault?"":` (${R.name})`}`}let i=class extends A.$Wc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(R,L,E,y,N,F,D,M,J,W,x,G){super(),this.syncResource=R,this.collection=L,this.G=E,this.H=y,this.I=N,this.J=F,this.L=D,this.M=M,this.N=J,this.O=W,this.P=x,this.c=null,this.m=g.SyncStatus.Idle,this.n=this.B(new T.$me),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new T.$me),this.onDidChangeConflicts=this.t.event,this.u=this.B(new c.$Dh(50)),this.w=this.B(new T.$me),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=a(R.syncResource,R.profile),this.h=G.extUri,this.f=this.h.joinPath(y.userDataSyncHome,...(0,g.$pnb)(R.profile.isDefault?void 0:R.profile.id,R.syncResource)),this.g=this.h.joinPath(this.f,g.$Knb),this.y=(0,g.$qnb)(R.profile.isDefault?void 0:R.profile.id,R.syncResource,y,this.h),this.j=(0,v.$lq)(y,E,N)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===g.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const R=await this.c;this.c=null;const L=await this.Y(R.remoteUserData,R.lastSyncUserData,!0,this.ob());this.S(L)}else{this.O.trace(`${this.D}: Checking for local changes...`);const R=await this.getLastSyncUserData();(R?await this.ub(R):!0)&&this.w.fire()}}S(R){this.m!==R&&(this.m=R,this.n.fire(R))}async sync(R,L={}){await this.U(R,!0,this.ob(),L)}async preview(R,L,E={}){return this.U(R,!1,L,E)}async apply(R,L={}){try{this.F={...L};const E=await this.ab(R);return this.S(E),this.c}finally{this.F={}}}async U(R,L,E,y){try{if(this.F={...y},this.status===g.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===g.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S(g.SyncStatus.Syncing);let N=g.SyncStatus.Idle;try{const F=await this.getLastSyncUserData(),D=await this.X(R,F);return N=await this.Y(D,F,L,E),N===g.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N===g.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(N)}}finally{this.F={}}}async replace(R){const L=this.kb(R);if(!L)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S(g.SyncStatus.Syncing);const E=await this.getLastSyncUserData(),y=await this.X(null,E),N=await this.W(y),F=await this.qb({ref:y.ref,syncData:L},E,N,this.ob(),O.CancellationToken.None),D=[];for(const M of F){const J=await this.sb(M,M.remoteResource,void 0,O.CancellationToken.None),{remoteChange:W}=await this.sb(M,M.previewResource,M.remoteContent,O.CancellationToken.None);D.push([M,{...J,remoteChange:W!==g.Change.None?W:g.Change.Modified}])}await this.tb(y,E,D,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S(g.SyncStatus.Idle)}return!0}async W(R){const L=await this.j;return!!R.syncData?.machineId&&R.syncData.machineId===L}async X(R,L){if(L){const E=R?R[this.resource]:void 0;if(L.ref===E||E===void 0&&L.syncData===null)return L}return this.getRemoteUserData(L)}async Y(R,L,E,y){if(R.syncData&&R.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new g.$xnb((0,m.localize)(0,null,this.resource,this.pb,R.syncData.version),g.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(R,L,E,y)}catch(N){if(N instanceof g.$xnb)switch(N.code){case g.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(R,L,E,y);case g.UserDataSyncErrorCode.Conflict:case g.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),R=await this.getRemoteUserData(null),L=await this.getLastSyncUserData(),this.Y(R,L,E,y)}throw N}}async Z(R,L,E,y){try{const N=await this.W(R),F=!N&&L===null&&this.gb()!==void 0,D=E&&!F;this.c||(this.c=(0,c.$sh)(J=>this.eb(R,L,N,D,y,J)));let M=await this.c;if(E&&F){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const J of M.resourcePreviews)M=await this.accept(J.remoteResource)||M}return this.cb(M.resourcePreviews),M.resourcePreviews.some(({mergeState:J})=>J===g.MergeState.Conflict)?g.SyncStatus.HasConflicts:E?await this.ab(!1):g.SyncStatus.Syncing}catch(N){throw this.c=null,N}}async merge(R){return await this.$(R,async L=>{const E=await this.rb(L,O.CancellationToken.None);await this.G.writeFile(L.previewResource,C.$Oe.fromString(E?.content||""));const y=E&&!E.hasConflicts?await this.sb(L,L.previewResource,void 0,O.CancellationToken.None):void 0;return L.acceptResult=y,L.mergeState=E.hasConflicts?g.MergeState.Conflict:y?g.MergeState.Accepted:g.MergeState.Preview,L.localChange=y?y.localChange:E.localChange,L.remoteChange=y?y.remoteChange:E.remoteChange,L}),this.c}async accept(R,L){return await this.$(R,async E=>{const y=await this.sb(E,R,L,O.CancellationToken.None);return E.acceptResult=y,E.mergeState=g.MergeState.Accepted,E.localChange=y.localChange,E.remoteChange=y.remoteChange,E}),this.c}async discard(R){return await this.$(R,async L=>{const E=await this.rb(L,O.CancellationToken.None);return await this.G.writeFile(L.previewResource,C.$Oe.fromString(E.content||"")),L.acceptResult=void 0,L.mergeState=g.MergeState.Preview,L.localChange=E.localChange,L.remoteChange=E.remoteChange,L}),this.c}async $(R,L){if(!this.c)return;let E=await this.c;const y=E.resourcePreviews.findIndex(({localResource:N,remoteResource:F,previewResource:D})=>this.h.isEqual(N,R)||this.h.isEqual(F,R)||this.h.isEqual(D,R));y!==-1&&(this.c=(0,c.$sh)(async N=>{const F=[...E.resourcePreviews];return F[y]=await L(F[y]),{...E,resourcePreviews:F}}),E=await this.c,this.cb(E.resourcePreviews),E.resourcePreviews.some(({mergeState:N})=>N===g.MergeState.Conflict)?this.S(g.SyncStatus.HasConflicts):this.S(g.SyncStatus.Syncing))}async ab(R){if(!this.c)return g.SyncStatus.Idle;const L=await this.c;return L.resourcePreviews.some(({mergeState:E})=>E===g.MergeState.Conflict)?g.SyncStatus.HasConflicts:L.resourcePreviews.some(({mergeState:E})=>E!==g.MergeState.Accepted)?g.SyncStatus.Syncing:(await this.tb(L.remoteUserData,L.lastSyncUserData,L.resourcePreviews.map(E=>[E,E.acceptResult]),R),this.c=null,await this.bb(),g.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(R){const L=R.filter(({mergeState:E})=>E===g.MergeState.Conflict);(0,P.$wb)(this.s,L,(E,y)=>this.h.isEqual(E.previewResource,y.previewResource))||(this.s=L,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const R=await this.getLastSyncUserData();return!!R&&R.syncData!==null}async db(R){const L=this.c?await this.c:null;if(L)for(const E of L.resourcePreviews){if(this.h.isEqual(E.acceptedResource,R))return E.acceptResult?E.acceptResult.content:null;if(this.h.isEqual(E.remoteResource,R))return E.remoteContent;if(this.h.isEqual(E.localResource,R))return E.localContent;if(this.h.isEqual(E.baseResource,R))return E.baseContent}return null}async resetLocal(){this.I.remove(this.z,d.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(R){(0,l.$ql)(R)!==l.FileOperationResult.FILE_NOT_FOUND&&this.O.error(R)}}async eb(R,L,E,y,N,F){const D=await this.qb(R,L,E,N,F),M=[];for(const J of D){const W=J.previewResource.with({scheme:g.$Jnb,authority:"accepted"});if(J.localChange===g.Change.None&&J.remoteChange===g.Change.None)M.push({...J,acceptedResource:W,acceptResult:{content:null,localChange:g.Change.None,remoteChange:g.Change.None},mergeState:g.MergeState.Accepted});else{const x=y?await this.rb(J,F):void 0;if(F.isCancellationRequested)break;await this.G.writeFile(J.previewResource,C.$Oe.fromString(x?.content||""));const G=x&&!x.hasConflicts?await this.sb(J,J.previewResource,void 0,F):void 0;M.push({...J,acceptResult:G,mergeState:x?.hasConflicts?g.MergeState.Conflict:G?g.MergeState.Accepted:g.MergeState.Preview,localChange:G?G.localChange:x?x.localChange:J.localChange,remoteChange:G?G.remoteChange:x?x.remoteChange:J.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:R,lastSyncUserData:L,resourcePreviews:M,isLastSyncFromCurrentMachine:E}}async getLastSyncUserData(){let R=this.gb();if(R||(R=await this.jb()),!R)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const L=JSON.parse(R),E=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!L.version&&!!E&&L.version!==E,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${L.version} is not compatible with current sync state version ${E}.`),await this.resetLocal(),null;let y,N=1;for(;y===void 0&&N++<6;)try{const F=await this.hb();F&&(F.ref===L.ref?y=F.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof l.$ul&&F.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(F instanceof g.$xnb)throw F;this.O.error(F,N)}}if(y===void 0)try{const F=await this.J.resolveResourceContent(this.resource,L.ref,this.collection,this.F);y=F===null?null:this.kb(F),await this.ib({ref:L.ref,syncData:y})}catch(F){if(F instanceof g.$xnb&&F.code===g.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw F}return y===void 0?null:{...L,syncData:y}}async fb(R,L={}){if(L.ref||L.version)throw new Error("Cannot have core properties as additional");const E=this.M.getResourceSyncStateVersion(this.resource),y={ref:R.ref,version:E,...L};this.I.store(this.z,JSON.stringify(y),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),await this.ib(R)}gb(){return this.I.get(this.z,d.StorageScope.APPLICATION)}async hb(){const R=(await this.G.readFile(this.y)).value.toString();try{const L=R?JSON.parse(R):void 0;if(r(L))return L}catch(L){this.O.error(L)}}async ib(R){await this.G.writeFile(this.y,C.$Oe.fromString(JSON.stringify(R)))}async jb(){try{const R=await this.G.readFile(this.y),L=JSON.parse(R.value.toString());await this.G.del(this.y),L.ref&&L.content!==void 0?(this.I.store(this.z,JSON.stringify({...L,content:void 0}),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),await this.ib({ref:L.ref,syncData:L.content===null?null:JSON.parse(L.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,L)}catch(R){R instanceof l.$ul&&R.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(R)}return this.I.get(this.z,d.StorageScope.APPLICATION)}async getRemoteUserData(R){const{ref:L,content:E}=await this.lb(R);let y=null;return E!==null&&(y=this.kb(E)),{ref:L,syncData:y}}kb(R){try{const L=JSON.parse(R);if(t(L))return L}catch(L){this.O.error(L)}throw new g.$xnb((0,m.localize)(1,null),g.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(R){const L=R?{ref:R.ref,content:R.syncData?JSON.stringify(R.syncData):null}:null;return this.J.readResource(this.resource,L,this.collection,this.F)}async mb(R,L){const E=await this.j,y={version:this.pb,machineId:E,content:R};try{return L=await this.J.writeResource(this.resource,JSON.stringify(y),L,this.collection,this.F),{ref:L,syncData:y}}catch(N){throw N instanceof g.$xnb&&N.code===g.UserDataSyncErrorCode.TooLarge&&(N=new g.$xnb(N.message,N.code,this.resource)),N}}async nb(R){const L={version:this.pb,content:R};return this.L.writeResource(this.resource,JSON.stringify(L),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==g.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S(g.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(g.$knb)}};e.$VNb=i,e.$VNb=i=ve([Q(2,l.$_k),Q(3,$.$Mi),Q(4,d.$fq),Q(5,g.$snb),Q(6,g.$tnb),Q(7,g.$Cnb),Q(8,p.$$l),Q(9,g.$Hnb),Q(10,u.$_i),Q(11,I.$Jl)],i);let n=class extends i{constructor(R,L,E,y,N,F,D,M,J,W,x,G,ie){super(L,E,y,N,F,D,M,J,W,x,G,ie),this.r=R,this.B(this.G.watch(this.h.dirname(R))),this.B(this.G.onDidFilesChange(V=>this.yb(V)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(R,L,E){try{L?await this.G.writeFile(this.r,C.$Oe.fromString(R),E?void 0:L):await this.G.createFile(this.r,C.$Oe.fromString(R),{overwrite:E})}catch(y){throw y instanceof l.$ul&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND||y instanceof l.$ul&&y.fileOperationResult===l.FileOperationResult.FILE_MODIFIED_SINCE?new g.$xnb(y.message,g.UserDataSyncErrorCode.LocalPreconditionFailed):y}}async xb(){try{await this.G.del(this.r)}catch(R){if(!(R instanceof l.$ul&&R.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND))throw R}}yb(R){R.contains(this.r)&&this.Q()}};e.$WNb=n,e.$WNb=n=ve([Q(3,l.$_k),Q(4,$.$Mi),Q(5,d.$fq),Q(6,g.$snb),Q(7,g.$tnb),Q(8,g.$Cnb),Q(9,p.$$l),Q(10,g.$Hnb),Q(11,u.$_i),Q(12,I.$Jl)],n);let o=class extends n{constructor(R,L,E,y,N,F,D,M,J,W,x,G,ie,V){super(R,L,E,y,N,F,D,M,J,W,x,ie,V),this.zb=G,this.Bb=void 0}Ab(R,L){const E=[],y=(0,k.$Xn)(R,E,{allowEmptyContent:!0,allowTrailingComma:!0});return E.length>0||!(0,S.$mg)(y)&&L!==Array.isArray(y)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$XNb=o,e.$XNb=o=ve([Q(3,l.$_k),Q(4,$.$Mi),Q(5,d.$fq),Q(6,g.$snb),Q(7,g.$tnb),Q(8,g.$Cnb),Q(9,p.$$l),Q(10,g.$Hnb),Q(11,g.$Gnb),Q(12,u.$_i),Q(13,I.$Jl)],o);let h=class{constructor(R,L,E,y,N,F,D){this.resource=R,this.g=L,this.h=E,this.j=y,this.k=N,this.l=F,this.d=D.extUri,this.f=(0,g.$qnb)(void 0,this.resource,E,this.d)}async initialize({ref:R,content:L}){if(!L){this.j.info("Remote content does not exist.",this.resource);return}const E=this.m(L);if(E)try{await this.o({ref:R,syncData:E})}catch(y){this.j.error(y)}}m(R){try{const L=JSON.parse(R);if(t(L))return L}catch(L){this.j.error(L)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(R,L={}){if(L.ref||L.version)throw new Error("Cannot have core properties as additional");const E={ref:R.ref,version:void 0,...L};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(E),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),await this.k.writeFile(this.f,C.$Oe.fromString(JSON.stringify(R)))}};e.$YNb=h,e.$YNb=h=ve([Q(1,s.$Ll),Q(2,$.$Mi),Q(3,b.$_j),Q(4,l.$_k),Q(5,d.$fq),Q(6,I.$Jl)],h)}),define(ce[120],le([0,1,6,26,8,3,45,2,27,22,16,119,28,33,86,36,7,4,77,10,17,18,29,20,40,243,115,25,63]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p,I,g,s,r,t,a,i,n,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=e.$2bc=e.$1bc=void 0,e.$Ybc=R,e.$Zbc=L;async function f(F,D){const M=JSON.parse(F.content);if(F.version===1||F.version===2){const J=(await D.getInstalled(b.ExtensionType.System)).filter(W=>W.isBuiltin);for(const W of M)F.version===1&&(W.enabled===!1&&(W.disabled=!0),delete W.enabled),F.version===2&&J.every(x=>!(0,$.$Jp)(x.identifier,W.identifier))&&(W.installed=!0)}return M}function R(F){return JSON.parse(F.content)}function L(F,D){return F.sort((M,J)=>!M.identifier.uuid&&J.identifier.uuid?-1:M.identifier.uuid&&!J.identifier.uuid?1:(0,A.$zf)(M.identifier.id,J.identifier.id)),D?(0,T.$8n)(F,{}):JSON.stringify(F)}let E=class extends a.$VNb{constructor(D,M,J,W,x,G,ie,V,z,te,se,he,q,Z,K,H,U){super({syncResource:o.SyncResource.Extensions,profile:D},M,W,J,x,G,ie,he,q,te,se,K),this.Cb=V,this.Db=z,this.Eb=U,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:o.$Jnb,authority:"base"}),this.yb=this.wb.with({scheme:o.$Jnb,authority:"local"}),this.zb=this.wb.with({scheme:o.$Jnb,authority:"remote"}),this.Ab=this.wb.with({scheme:o.$Jnb,authority:"accepted"}),this.Bb=this.Eb.createInstance(y),this.B(O.Event.any(O.Event.filter(this.Cb.onDidInstallExtensions,Y=>Y.some(({local:B})=>!!B)),O.Event.filter(this.Cb.onDidUninstallExtension,Y=>!Y.error),O.Event.filter(H.onDidChange,Y=>Y.valueChanges.some(({profile:B,changes:j})=>this.syncResource.profile.id===B.id&&j.some(_=>_.key===u.$mp))),Z.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(D,M){const J=D.syncData?await f(D.syncData,this.Cb):null,W=M?.skippedExtensions??[],x=M?.builtinExtensions??null,G=M?.syncData?await f(M.syncData,this.Cb):null,{localExtensions:ie,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile);J?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:te}=(0,i.$Xbc)(ie,J,G,W,V,x),se={local:z,remote:te,content:this.Hb(ie,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:te!==null?o.Change.Modified:o.Change.None},he=this.Ob(ie,!1);return[{skippedExtensions:W,builtinExtensions:x,baseResource:this.xb,baseContent:G?this.Ob(G,!1):he,localResource:this.yb,localContent:he,localExtensions:ie,remoteResource:this.zb,remoteExtensions:J,remoteContent:J?this.Ob(J,!1):null,previewResource:this.wb,previewResult:se,localChange:se.localChange,remoteChange:se.remoteChange,acceptedResource:this.Ab}]}async ub(D){const M=D.syncData?await f(D.syncData,this.Cb):null,{localExtensions:J,ignoredExtensions:W}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,i.$Xbc)(J,M,M,D.skippedExtensions||[],W,D.builtinExtensions||[]);return x!==null}Hb(D,M,J,W){const x=[...M,...J],G=new Set,ie=V=>{G.add(V.id.toLowerCase()),V.uuid&&G.add(V.uuid)};x.forEach(({identifier:V})=>ie(V)),W.forEach(ie);for(const V of D)G.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&G.has(V.identifier.uuid)||x.push(V);return this.Ob(x,!1)}async rb(D,M){return{...D.previewResult,hasConflicts:!1}}async sb(D,M,J,W){if(this.h.isEqual(M,this.yb))return this.Kb(D);if(this.h.isEqual(M,this.zb))return this.Lb(D);if(this.h.isEqual(M,this.wb))return D.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Kb(D){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),J=this.Db.getIgnoredExtensions(M),W=(0,i.$Xbc)(D.localExtensions,null,null,D.skippedExtensions,J,D.builtinExtensions),{local:x,remote:G}=W;return{content:D.localContent,local:x,remote:G,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:G!==null?o.Change.Modified:o.Change.None}}async Lb(D){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),J=this.Db.getIgnoredExtensions(M),W=D.remoteContent?JSON.parse(D.remoteContent):null;if(W!==null){const x=(0,i.$Xbc)(D.localExtensions,W,D.localExtensions,[],J,D.builtinExtensions),{local:G,remote:ie}=x;return{content:D.remoteContent,local:G,remote:ie,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:ie!==null?o.Change.Modified:o.Change.None}}else return{content:D.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:o.Change.None,remoteChange:o.Change.None}}async tb(D,M,J,W){let{skippedExtensions:x,builtinExtensions:G,localExtensions:ie}=J[0][0];const{local:V,remote:z,localChange:te,remoteChange:se}=J[0][1];if(te===o.Change.None&&se===o.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),te!==o.Change.None&&(await this.nb(JSON.stringify(ie)),x=await this.Bb.updateLocalExtensions(V.added,V.removed,V.updated,x,this.syncResource.profile)),z){this.O.trace(`${this.D}: Updating remote extensions...`);const he=JSON.stringify(z.all);D=await this.mb(he,W?null:D.ref),this.O.info(`${this.D}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(q=>q.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(q=>q.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(q=>q.identifier.id))}.`:""}`)}M?.ref!==D.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),G=this.Nb(ie,G),await this.fb(D,{skippedExtensions:x,builtinExtensions:G}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(he=>he.identifier.id))}.`:""}`))}Nb(D,M){const J=new Set,W=[];for(const x of D)J.add(x.identifier.id.toLowerCase()),x.installed||W.push(x.identifier);if(M)for(const x of M)J.has(x.id.toLowerCase())||W.push(x);return W}async resolveContent(D){if(this.h.isEqual(this.zb,D)||this.h.isEqual(this.xb,D)||this.h.isEqual(this.yb,D)||this.h.isEqual(this.Ab,D)){const M=await this.db(D);return M&&this.Ob(JSON.parse(M),!0)}return null}Ob(D,M){return L(D,M)}async hasLocalData(){try{const{localExtensions:D}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(D.some(M=>M.installed||M.disabled))return!0}catch{}return!1}};e.$1bc=E,e.$1bc=E=ve([Q(2,S.$Mi),Q(3,v.$_k),Q(4,g.$fq),Q(5,o.$snb),Q(6,o.$tnb),Q(7,u.$lp),Q(8,n.$HOb),Q(9,o.$Hnb),Q(10,w.$_i),Q(11,o.$Cnb),Q(12,s.$$l),Q(13,l.$mw),Q(14,r.$Jl),Q(15,h.$PMb),Q(16,d.$Ei)],E);let y=class{constructor(D,M,J,W,x,G){this.a=D,this.b=M,this.c=J,this.d=W,this.f=x,this.g=G}async getLocalExtensions(D){const M=await this.a.getInstalled(void 0,D.extensionsResource),J=this.d.getIgnoredExtensions(M);return{localExtensions:await this.j(D,async(x,G)=>{const ie=x.getDisabledExtensions();return M.map(V=>{const{identifier:z,isBuiltin:te,manifest:se,preRelease:he,pinned:q,isApplicationScoped:Z}=V,K={identifier:z,preRelease:he,version:se.version,pinned:!!q};Z&&!(0,b.$tn)(se)&&(K.isApplicationScoped=Z),ie.some(H=>(0,$.$Jp)(H,z))&&(K.disabled=!0),te||(K.installed=!0);try{const H=G.getKeysForSync({id:z.id,version:se.version});if(H){const U=G.getExtensionState(V,!0)||{};K.state=Object.keys(U).reduce((Y,B)=>(H.includes(B)&&(Y[B]=U[B]),Y),{})}}catch(H){this.g.info(`${(0,a.$UNb)(o.SyncResource.Extensions,D)}: Error while parsing extension state`,(0,C.$_)(H))}return K})}),ignoredExtensions:J}}async updateLocalExtensions(D,M,J,W,x){const G=(0,a.$UNb)(o.SyncResource.Extensions,x),ie=[],V=new Map,z=[],te=[],se=await this.a.getInstalled(void 0,x.extensionsResource);if((D.length||J.length)&&await this.j(x,async(Z,K)=>{await P.Promises.settled([...D,...J].map(async H=>{const U=se.find(j=>(0,$.$Jp)(j.identifier,H.identifier));if(U&&U.isBuiltin){H.state&&U.manifest.version===H.version&&this.h(H.state,U,U.manifest.version,K),Z.getDisabledExtensions().some(_=>(0,$.$Jp)(_,H.identifier))!==!!H.disabled&&(H.disabled?(this.g.trace(`${G}: Disabling extension...`,H.identifier.id),await Z.disableExtension(H.identifier),this.g.info(`${G}: Disabled extension`,H.identifier.id)):(this.g.trace(`${G}: Enabling extension...`,H.identifier.id),await Z.enableExtension(H.identifier),this.g.info(`${G}: Enabled extension`,H.identifier.id))),z.push(H.identifier);return}const Y=H.pinned?H.version:void 0,B=(await this.c.getExtensions([{...H.identifier,version:Y,preRelease:Y?void 0:H.preRelease}],c.CancellationToken.None))[0];if(H.state&&(U?U.manifest.version===H.version:B)&&this.h(H.state,U||B,U?.manifest.version,K),B)try{Z.getDisabledExtensions().some(_=>(0,$.$Jp)(_,H.identifier))!==!!H.disabled&&(H.disabled?(this.g.trace(`${G}: Disabling extension...`,H.identifier.id,B.version),await Z.disableExtension(B.identifier),this.g.info(`${G}: Disabled extension`,H.identifier.id,B.version)):(this.g.trace(`${G}: Enabling extension...`,H.identifier.id,B.version),await Z.enableExtension(B.identifier),this.g.info(`${G}: Enabled extension`,H.identifier.id,B.version))),(!U||U.preRelease!==H.preRelease||U.pinned!==H.pinned||Y&&U.manifest.version!==Y)&&(await this.a.canInstall(B)?(ie.push({extension:B,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:H.pinned&&!!H.version,pinned:H.pinned,installPreReleaseVersion:H.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:H.isApplicationScoped,context:{[u.$$o]:!0,[u.$_o]:u.ExtensionInstallSource.SETTINGS_SYNC}}}),V.set(B.identifier.id.toLowerCase(),H)):(this.g.info(`${G}: Skipped synchronizing extension because it cannot be installed.`,B.displayName||B.identifier.id),te.push(H)))}catch(j){te.push(H),this.g.error(j),this.g.info(`${G}: Skipped synchronizing extension`,B.displayName||B.identifier.id)}else te.push(H),this.g.info(`${G}: Skipped synchronizing extension because the extension is not found.`,H.identifier.id)}))}),M.length){const Z=se.filter(({identifier:K,isBuiltin:H})=>!H&&M.some(U=>(0,$.$Jp)(K,U)));await P.Promises.settled(Z.map(async K=>{this.g.trace(`${G}: Uninstalling local extension...`,K.identifier.id),await this.a.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${G}: Uninstalled local extension.`,K.identifier.id),z.push(K.identifier)}))}const he=await this.a.installGalleryExtensions(ie);for(const{identifier:Z,local:K,error:H,source:U}of he){const Y=U;if(K)this.g.info(`${G}: Installed extension.`,Z.id,Y.version),z.push(Z);else{const B=V.get(Z.id.toLowerCase());B&&(te.push(B),this.g.info(`${G}: Skipped synchronizing extension`,Y.displayName||Y.identifier.id)),H instanceof u.$kp&&[u.ExtensionManagementErrorCode.Incompatible,u.ExtensionManagementErrorCode.IncompatibleApi,u.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(H.code)?this.g.info(`${G}: Skipped synchronizing extension because the compatible extension is not found.`,Y.displayName||Y.identifier.id):H&&this.g.error(H)}}const q=[];for(const Z of W)z.some(K=>(0,$.$Jp)(K,Z.identifier))||q.push(Z);for(const Z of te)q.some(K=>(0,$.$Jp)(K.identifier,Z.identifier))||q.push(Z);return q}h(D,M,J,W){const x=W.getExtensionState(M,!0)||{},G=J?W.getKeysForSync({id:M.identifier.id,version:J}):void 0;G?G.forEach(ie=>{x[ie]=D[ie]}):Object.keys(D).forEach(ie=>x[ie]=D[ie]),W.setExtensionState(M,x,!0)}async j(D,M){return this.b.withProfileScopedStorageService(D,async J=>{const W=new k.$Vc,x=W.add(this.f.createChild(new p.$Di([g.$fq,J]))),G=W.add(x.createInstance(m.$bMb)),ie=W.add(x.createInstance(l.$nw));try{return await M(G,ie)}finally{W.dispose()}})}};e.$2bc=y,e.$2bc=y=ve([Q(0,u.$lp),Q(1,h.$PMb),Q(2,u.$ip),Q(3,n.$HOb),Q(4,d.$Ei),Q(5,o.$Hnb)],y);let N=class extends a.$YNb{constructor(D,M,J,W,x,G,ie,V){super(o.SyncResource.Extensions,W,x,G,J,ie,V),this.p=D,this.q=M}async t(D){return D.syncData?await f(D.syncData,this.p):null}u(D,M){const J=[],W=[],x=[];for(const G of D){if(this.q.hasToNeverSyncExtension(G.identifier.id))continue;const ie=M.find(V=>(0,$.$Jp)(V.identifier,G.identifier));ie?(J.push(ie),G.disabled&&x.push(G.identifier)):G.installed&&(W.push({...G.identifier,preRelease:!!G.preRelease}),G.disabled&&x.push(G.identifier))}return{installedExtensions:J,newExtensions:W,disabledExtensions:x,remoteExtensions:D}}};e.$3bc=N,e.$3bc=N=ve([Q(0,u.$lp),Q(1,n.$HOb),Q(2,v.$_k),Q(3,t.$Ll),Q(4,S.$Mi),Q(5,I.$_j),Q(6,g.$fq),Q(7,r.$Jl)],N)}),define(ce[121],le([0,1,15,8,3,34,45,5,32,22,16,7,10,50,17,18,29,40,82,247,25,20,63,4]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p,I,g,s,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Nb=e.$4Nb=e.$3Nb=e.$2Nb=void 0,e.$1Nb=n;const a="globalState.argv.",i=["locale"];function n(E,y){const N=E.storage?Object.keys(E.storage).sort():[],F={};return N.forEach(D=>F[D]=E.storage[D]),E.storage=F,y?(0,T.$8n)(E,{}):JSON.stringify(E)}const o=1;let h=class extends d.$VNb{constructor(y,N,F,D,M,J,W,x,G,ie,V,z,te,se){super({syncResource:g.SyncResource.GlobalState,profile:y},N,D,x,z,M,J,G,ie,W,V,te),this.Bb=F,this.pb=o,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:g.$Jnb,authority:"base"}),this.xb=this.vb.with({scheme:g.$Jnb,authority:"local"}),this.yb=this.vb.with({scheme:g.$Jnb,authority:"remote"}),this.zb=this.vb.with({scheme:g.$Jnb,authority:"accepted"}),this.Ab=se.createInstance(f),this.B(D.watch(this.h.dirname(this.H.argvResource))),this.B(C.Event.any(C.Event.filter(D.onDidFilesChange,he=>he.contains(this.H.argvResource)),C.Event.filter(F.onDidChange,he=>!!(he.targetChanges.some(q=>this.syncResource.profile.id===q.id)||he.valueChanges.some(({profile:q,changes:Z})=>this.syncResource.profile.id===q.id&&Z.some(K=>K.target===l.StorageTarget.USER)))))(()=>this.Q()))}async qb(y,N,F){const D=y.syncData?JSON.parse(y.syncData.content):null;N=N===null&&F?y:N;const M=N&&N.syncData?JSON.parse(N.syncData.content):null,J=await this.Ab.getLocalGlobalState(this.syncResource.profile);D?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const W=await this.Jb(M),{local:x,remote:G}=(0,I.$ZNb)(J.storage,D?D.storage:null,M?M.storage:null,W,this.O),ie={content:null,local:x,remote:G,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?g.Change.Modified:g.Change.None,remoteChange:G.all!==null?g.Change.Modified:g.Change.None},V=n(J,!1);return[{baseResource:this.wb,baseContent:M?n(M,!1):V,localResource:this.xb,localContent:V,localUserData:J,remoteResource:this.yb,remoteContent:D?n(D,!1):null,previewResource:this.vb,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.zb,storageKeys:W}]}async ub(y){const N=y.syncData?JSON.parse(y.syncData.content):null;if(N===null)return!0;const F=await this.Ab.getLocalGlobalState(this.syncResource.profile),D=await this.Jb(N),{remote:M}=(0,I.$ZNb)(F.storage,N.storage,N.storage,D,this.O);return M.all!==null}async rb(y,N){return{...y.previewResult,hasConflicts:!1}}async sb(y,N,F,D){if(this.h.isEqual(N,this.xb))return this.Gb(y);if(this.h.isEqual(N,this.yb))return this.Hb(y);if(this.h.isEqual(N,this.vb))return y.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async Gb(y){return{content:y.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(y.localUserData.storage),removed:[],updated:[],all:y.localUserData.storage},localChange:g.Change.None,remoteChange:g.Change.Modified}}async Hb(y){if(y.remoteContent!==null){const N=JSON.parse(y.remoteContent),{local:F,remote:D}=(0,I.$ZNb)(y.localUserData.storage,N.storage,null,y.storageKeys,this.O);return{content:y.remoteContent,local:F,remote:D,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?g.Change.Modified:g.Change.None,remoteChange:D!==null?g.Change.Modified:g.Change.None}}else return{content:y.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:g.Change.None,remoteChange:g.Change.None}}async tb(y,N,F,D){const{localUserData:M}=F[0][0],{local:J,remote:W,localChange:x,remoteChange:G}=F[0][1];if(x===g.Change.None&&G===g.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==g.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(M)),await this.Ab.writeLocalGlobalState(J,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),G!==g.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const ie=JSON.stringify({storage:W.all});y=await this.mb(ie,D?null:y.ref),this.O.info(`${this.D}: Updated remote ui state.${W.added.length?` Added: ${W.added}.`:""}${W.updated.length?` Updated: ${W.updated}.`:""}${W.removed.length?` Removed: ${W.removed}.`:""}`)}N?.ref!==y.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(y),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(y){if(this.h.isEqual(this.yb,y)||this.h.isEqual(this.wb,y)||this.h.isEqual(this.xb,y)||this.h.isEqual(this.zb,y)){const N=await this.db(y);return N&&n(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:y}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(y).length>1||y[`${a}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(y){const N=await this.Bb.readStorageData(this.syncResource.profile),F=[],D=[];for(const[W,x]of N)x.target===l.StorageTarget.USER?F.push(W):x.target===l.StorageTarget.MACHINE&&D.push(W);const M=[...F,...D],J=y?.storage?Object.keys(y.storage).filter(W=>!W.startsWith(a)&&!M.includes(W)&&N.get(W)!==void 0):[];if(!k.$o){const W=[...g.$onb.map(x=>(0,g.$Bnb)(x)),g.$Anb];J.push(...W),D.push(...W)}return{user:F,machine:D,unregistered:J}}};e.$2Nb=h,e.$2Nb=h=ve([Q(2,r.$PMb),Q(3,m.$_k),Q(4,g.$snb),Q(5,g.$tnb),Q(6,g.$Hnb),Q(7,S.$Mi),Q(8,g.$Cnb),Q(9,b.$$l),Q(10,w.$_i),Q(11,l.$fq),Q(12,v.$Jl),Q(13,t.$Ei)],h);let f=class{constructor(y,N,F,D){this.a=y,this.b=N,this.c=F,this.d=D}async getLocalGlobalState(y){const N={};if(y.isDefault){const D=await this.f(),M=(0,O.$Xn)(D);for(const J of i)M[J]!==void 0&&(N[`${a}${J}`]={version:1,value:M[J]})}const F=await this.c.readStorageData(y);for(const[D,M]of F)M.value&&M.target===l.StorageTarget.USER&&(N[D]={version:1,value:M.value});return{storage:N}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const y=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),y.value.toString()}catch(y){this.d.debug((0,c.$_)(y))}return"{}"}async writeLocalGlobalState({added:y,removed:N,updated:F},D){const M=(0,d.$UNb)(g.SyncResource.GlobalState,D),J={},W=new Map,x=await this.c.readStorageData(D),G=(ie,V)=>{for(const z of ie){if(z.startsWith(a)){J[z.substring(a.length)]=V?V[z].value:void 0;continue}if(V){const te=V[z];te.value!==x.get(z)?.value&&W.set(z,te.value)}else x.get(z)!==void 0&&W.set(z,void 0)}};if(G(Object.keys(y),y),G(Object.keys(F),F),G(N),Object.keys(J).length){this.d.trace(`${M}: Updating locale...`);const ie=await this.f();let V=ie;for(const z of Object.keys(J))V=(0,p.edit)(V,[z],J[z],{});ie!==V&&(this.d.trace(`${M}: Updating locale...`),await this.a.writeFile(this.b.argvResource,P.$Oe.fromString(V)),this.d.info(`${M}: Updated locale.`)),this.d.info(`${M}: Updated locale`)}W.size&&(this.d.trace(`${M}: Updating global state...`),await this.c.updateStorageData(D,W,l.StorageTarget.USER),this.d.info(`${M}: Updated global state`,[...W.keys()]))}};e.$3Nb=f,e.$3Nb=f=ve([Q(0,m.$_k),Q(1,S.$Mi),Q(2,r.$PMb),Q(3,g.$Hnb)],f);let R=class extends d.$YNb{constructor(y,N,F,D,M,J){super(g.SyncResource.GlobalState,F,D,M,N,y,J)}async o(y){const N=y.syncData?JSON.parse(y.syncData.content):null;if(!N){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},D={};for(const M of Object.keys(N.storage))M.startsWith(a)?F[M.substring(a.length)]=N.storage[M].value:this.l.get(M,l.StorageScope.PROFILE)===void 0&&(D[M]=N.storage[M].value);if(Object.keys(F).length){let M="{}";try{M=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const J of Object.keys(F))M=(0,p.edit)(M,[J],F[J],{});await this.k.writeFile(this.h.argvResource,P.$Oe.fromString(M))}if(Object.keys(D).length){const M=[];for(const J of Object.keys(D))M.push({key:J,value:D[J],scope:l.StorageScope.PROFILE,target:l.StorageTarget.USER});this.l.storeAll(M,!0)}}};e.$4Nb=R,e.$4Nb=R=ve([Q(0,l.$fq),Q(1,m.$_k),Q(2,s.$Ll),Q(3,S.$Mi),Q(4,g.$Hnb),Q(5,v.$Jl)],R);let L=class{constructor(y,N,F,D,M){this.a=y,this.b=N,this.c=F,this.d=D,this.f=M}getSyncStoreType(y){return this.h(y)?.storage[g.$Anb]?.value}async sync(y){const N=(0,g.$wnb)((0,A.$2g)());try{return await this.g(y,N)}catch(F){if(F instanceof g.$xnb)switch(F.code){case g.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(y,N)}throw F}}async g(y,N){const F=await this.a.readResource(g.SyncResource.GlobalState,null,void 0,N),D=this.h(F)||{storage:{}};D.storage[g.$Anb]={value:y,version:o};const M=await(0,$.$lq)(this.c,this.d,this.b),J={version:o,machineId:M,content:n(D,!1)};await this.a.writeResource(g.SyncResource.GlobalState,JSON.stringify(J),F.ref,void 0,N)}h({content:y}){if(!y)return null;const N=JSON.parse(y);if((0,d.$TNb)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};e.$5Nb=L,e.$5Nb=L=ve([Q(1,l.$fq),Q(2,S.$Mi),Q(3,m.$_k),Q(4,u.$_j)],L)}),define(ce[122],le([0,1,19,15,3,34,5,13,182,22,16,7,17,18,29,20,40,244,25]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=e.$6bc=void 0,e.$5bc=I;function I(r,t,a){try{const i=JSON.parse(r);if(!t)return(0,k.$mg)(i.all)?null:i.all;switch(T.OS){case T.OperatingSystem.Macintosh:return(0,k.$mg)(i.mac)?null:i.mac;case T.OperatingSystem.Linux:return(0,k.$mg)(i.linux)?null:i.linux;case T.OperatingSystem.Windows:return(0,k.$mg)(i.windows)?null:i.windows}}catch(i){return a.error(i),null}}let g=class extends v.$XNb{constructor(t,a,i,n,o,h,f,R,L,E,y,N,F){super(t.keybindingsResource,{syncResource:p.SyncResource.Keybindings,profile:t},a,R,L,E,i,n,f,N,o,y,h,F),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:p.$Jnb,authority:"base"}),this.Gb=this.Eb.with({scheme:p.$Jnb,authority:"local"}),this.Hb=this.Eb.with({scheme:p.$Jnb,authority:"remote"}),this.Ib=this.Eb.with({scheme:p.$Jnb,authority:"accepted"}),this.B(C.Event.filter(h.onDidChangeConfiguration,D=>D.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(t,a,i,n){const o=t.syncData?I(t.syncData.content,n.keybindingsPerPlatform??this.Qb(),this.O):null;a=a===null&&i?t:a;const h=a?this.Ob(a):null,f=await this.vb(),R=await this.Cb();let L=null,E=!1,y=!1,N=!1;if(o){let M=f?f.value.toString():"[]";if(M=M||"[]",this.Ab(M,!0))throw new p.$xnb((0,A.localize)(0,null),p.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!h||h!==M||h!==o){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const J=await(0,d.$4bc)(M,o,h,R,this.zb);J.hasChanges&&(L=J.mergeContent,N=J.hasConflicts,E=N||J.mergeContent!==M,y=N||J.mergeContent!==o)}}else f&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),L=f.value.toString(),y=!0);const F={content:N?h:L,localChange:E?f?p.Change.Modified:p.Change.Added:p.Change.None,remoteChange:y?p.Change.Modified:p.Change.None,hasConflicts:N},D=f?f.value.toString():null;return[{fileContent:f,baseResource:this.Fb,baseContent:h,localResource:this.Gb,localContent:D,localChange:F.localChange,remoteResource:this.Hb,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.Eb,previewResult:F,acceptedResource:this.Ib}]}async ub(t){const a=this.Ob(t);if(a===null)return!0;const i=await this.vb(),n=i?i.value.toString():"",o=await this.Cb(),h=await(0,d.$4bc)(n||"[]",a,a,o,this.zb);return h.hasConflicts||h.mergeContent!==a}async rb(t,a){return t.previewResult}async sb(t,a,i,n){if(this.h.isEqual(a,this.Gb))return{content:t.fileContent?t.fileContent.value.toString():null,localChange:p.Change.None,remoteChange:p.Change.Modified};if(this.h.isEqual(a,this.Hb))return{content:t.remoteContent,localChange:p.Change.Modified,remoteChange:p.Change.None};if(this.h.isEqual(a,this.Eb))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i,localChange:p.Change.Modified,remoteChange:p.Change.Modified};throw new Error(`Invalid Resource: ${a.toString()}`)}async tb(t,a,i,n){const{fileContent:o}=i[0][0];let{content:h,localChange:f,remoteChange:R}=i[0][1];if(f===p.Change.None&&R===p.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),h!==null&&(h=h.trim(),h=h||"[]",this.Ab(h,!0)))throw new p.$xnb((0,A.localize)(1,null),p.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(f!==p.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),o&&await this.nb(this.Pb(o.value.toString())),await this.wb(h||"[]",o,n),this.O.info(`${this.D}: Updated local keybindings`)),R!==p.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const L=this.Pb(h||"[]",t.syncData?.content);t=await this.mb(L,n?null:t.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}a?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(t,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const t=await this.vb();if(t){const a=(0,O.$Xn)(t.value.toString());if((0,P.$Nb)(a))return!0}}catch(t){if(t.fileOperationResult!==m.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.Hb,t)||this.h.isEqual(this.Fb,t)||this.h.isEqual(this.Gb,t)||this.h.isEqual(this.Ib,t)?this.db(t):null}Ob(t){return!t.syncData||t.platformSpecific!==void 0&&t.platformSpecific!==this.Qb()?null:I(t.syncData.content,this.Qb(),this.O)}Pb(t,a){let i={};try{i=JSON.parse(a||"{}")}catch(n){this.O.error(n)}switch(this.Qb()?delete i.all:i.all=t,T.OS){case T.OperatingSystem.Macintosh:i.mac=t;break;case T.OperatingSystem.Linux:i.linux=t;break;case T.OperatingSystem.Windows:i.windows=t;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(p.$lnb)}};e.$6bc=g,e.$6bc=g=ve([Q(2,p.$snb),Q(3,p.$tnb),Q(4,p.$Hnb),Q(5,w.$_i),Q(6,p.$Cnb),Q(7,m.$_k),Q(8,S.$Mi),Q(9,u.$fq),Q(10,p.$Gnb),Q(11,$.$$l),Q(12,l.$Jl)],g);let s=class extends v.$YNb{constructor(t,a,i,n,o,h){super(p.SyncResource.Keybindings,a,i,n,t,o,h)}async o(t){const a=t.syncData?this.p(t.syncData.content):null;if(!a){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,c.$Oe.fromString(a)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource),a=(0,O.$Xn)(t.value.toString());return!(0,P.$Nb)(a)}catch(t){return t.fileOperationResult===m.FileOperationResult.FILE_NOT_FOUND}}p(t){try{return I(t,!0,this.j)}catch(a){return this.j.error(a),null}}};e.$7bc=s,e.$7bc=s=ve([Q(0,m.$_k),Q(1,b.$Ll),Q(2,S.$Mi),Q(3,p.$Hnb),Q(4,u.$fq),Q(5,l.$Jl)],s)}),define(ce[123],le([0,1,15,3,183,22,78,16,28,7,17,18,29,20,40,248,25]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=e.$9bc=void 0,e.$8bc=p;function d(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function p(s){const r=JSON.parse(s);return d(r)?r:{settings:s}}let I=class extends l.$XNb{constructor(r,t,a,i,n,o,h,f,R,L,E,y,N,F){super(r.settingsResource,{syncResource:v.SyncResource.Settings,profile:r},t,a,i,n,o,h,E,y,f,R,L,F),this.Eb=N,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:v.$Jnb,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.$Jnb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.$Jnb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.$Jnb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),a=await this.X(r,t),i=this.Lb(a),n=new T.$Mo(v.$knb,this.O);return i?.settings&&n.parse(i.settings),n.configurationModel.getValue(v.$knb)||{}}async qb(r,t,a){const i=await this.vb(),n=await this.Cb(),o=this.Lb(r);t=t===null&&a?r:t;const h=t?this.Lb(t):null,f=await this.Pb();let R=null,L=!1,E=!1,y=!1;if(o){let M=i?i.value.toString().trim():"{}";M=M||"{}",this.Qb(M),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const J=(0,b.$wMb)(M,o.settings,h?h.settings:null,f,[],n);R=J.localContent||J.remoteContent,L=J.localContent!==null,E=J.remoteContent!==null,y=J.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),R=i.value.toString().trim()||"{}",this.Qb(R),E=!0);const N=i?i.value.toString():null,F=h?.settings??null,D={content:y?F:R,localChange:L?v.Change.Modified:v.Change.None,remoteChange:E?v.Change.Modified:v.Change.None,hasConflicts:y};return[{fileContent:i,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:N,localChange:D.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:D.remoteChange,previewResource:this.previewResource,previewResult:D,acceptedResource:this.acceptedResource}]}async ub(r){const t=this.Lb(r);if(t===null)return!0;const a=await this.vb(),i=a?a.value.toString().trim():"",n=await this.Pb(),o=await this.Cb();return(0,b.$wMb)(i||"{}",t.settings,t.settings,n,[],o).remoteContent!==null}async rb(r,t){const a=await this.Cb(),i=await this.Pb();return{...r.previewResult,content:r.previewResult.content?(0,b.$vMb)(r.previewResult.content,"{}",i,a):null}}async sb(r,t,a,i){const n=await this.Cb(),o=await this.Pb();if(this.h.isEqual(t,this.localResource))return{content:r.fileContent?(0,b.$vMb)(r.fileContent.value.toString(),"{}",o,n):null,localChange:v.Change.None,remoteChange:v.Change.Modified};if(this.h.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,b.$vMb)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,n):null,localChange:v.Change.Modified,remoteChange:v.Change.None};if(this.h.isEqual(t,this.previewResource))return a===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:a!==null?(0,b.$vMb)(a,r.fileContent?r.fileContent.value.toString():"{}",o,n):null,localChange:v.Change.Modified,remoteChange:v.Change.Modified};throw new Error(`Invalid Resource: ${t.toString()}`)}async tb(r,t,a,i){const{fileContent:n}=a[0][0];let{content:o,localChange:h,remoteChange:f}=a[0][1];if(h===v.Change.None&&f===v.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Qb(o),h!==v.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),n&&await this.nb(JSON.stringify(this.Nb(n.value.toString()))),await this.wb(o,n,i),await this.P.reloadConfiguration(O.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),f!==v.Change.None){const R=await this.Cb(),L=this.Lb(r),E=await this.Pb(o);o=(0,b.$vMb)(o,L?L.settings:"{}",E,R),this.O.trace(`${this.D}: Updating remote settings...`),r=await this.mb(JSON.stringify(this.Nb(o)),i?null:r.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(r),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.vb();if(r)return!(0,b.$xMb)(r.value.toString())}catch(r){if(r.fileOperationResult!==w.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.db(r):null}async db(r){let t=await super.db(r);if(t){const a=await this.Cb(),i=await this.Pb();t=(0,b.$vMb)(t,"{}",i,a)}return t}Lb(r){return r.syncData?this.Mb(r.syncData.content):null}Mb(r){try{return p(r)}catch(t){this.O.error(t)}return null}Nb(r){return{settings:r}}async Pb(r){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const a=this.B(c.Event.any(c.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:n})=>!!n)),c.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{a.dispose(),this.Ob=void 0}))}const t=await this.Ob;return(0,b.$tMb)(t,this.P,r)}Qb(r){if(this.Ab(r,!1))throw new v.$xnb((0,C.localize)(0,null),v.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$9bc=I,e.$9bc=I=ve([Q(2,w.$_k),Q(3,k.$Mi),Q(4,S.$fq),Q(5,v.$snb),Q(6,v.$tnb),Q(7,v.$Hnb),Q(8,v.$Gnb),Q(9,O.$_i),Q(10,v.$Cnb),Q(11,m.$$l),Q(12,A.$lp),Q(13,u.$Jl)],I);let g=class extends l.$YNb{constructor(r,t,a,i,n,o){super(v.SyncResource.Settings,t,a,i,r,n,o)}async o(r){const t=r.syncData?this.p(r.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,P.$Oe.fromString(t.settings)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,b.$xMb)(r.value.toString().trim())}catch(r){return r.fileOperationResult===w.FileOperationResult.FILE_NOT_FOUND}}p(r){try{return p(r)}catch(t){this.j.error(t)}return null}};e.$0bc=g,e.$0bc=g=ve([Q(0,w.$_k),Q(1,$.$Ll),Q(2,k.$Mi),Q(3,v.$Hnb),Q(4,S.$fq),Q(5,u.$Jl)],g)}),define(ce[124],le([0,1,15,3,30,22,16,7,17,18,29,20,40,245,25]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=e.$bcc=void 0,e.$acc=b;function b(p){return JSON.parse(p.content)}let v=class extends u.$VNb{constructor(I,g,s,r,t,a,i,n,o,h,f,R){super({syncResource:l.SyncResource.Snippets,profile:I},g,r,s,t,a,i,h,f,n,o,R),this.pb=1,this.vb=I.snippetsHome,this.B(this.G.watch(s.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(c.Event.filter(this.G.onDidFilesChange,L=>L.affects(this.vb))(()=>this.Q()))}async qb(I,g,s){const r=await this.Hb(),t=this.Gb(r),a=I.syncData?this.Fb(I.syncData):null;g=g===null&&s?I:g;const i=g&&g.syncData?this.Fb(g.syncData):null;a?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,$.$$bc)(t,a,i);return this.Bb(n,r,a||{},i||{})}async ub(I){const g=I.syncData?this.Fb(I.syncData):null;if(g===null)return!0;const s=await this.Hb(),r=this.Gb(s),t=(0,$.$$bc)(r,g,g);return Object.keys(t.remote.added).length>0||Object.keys(t.remote.updated).length>0||t.remote.removed.length>0||t.conflicts.length>0}async rb(I,g){return I.previewResult}async sb(I,g,s,r){if(this.h.isEqualOrParent(g,this.g.with({scheme:l.$Jnb,authority:"local"})))return{content:I.fileContent?I.fileContent.value.toString():null,localChange:l.Change.None,remoteChange:I.fileContent?I.remoteContent!==null?l.Change.Modified:l.Change.Added:l.Change.Deleted};if(this.h.isEqualOrParent(g,this.g.with({scheme:l.$Jnb,authority:"remote"})))return{content:I.remoteContent,localChange:I.remoteContent!==null?I.fileContent?l.Change.Modified:l.Change.Added:l.Change.Deleted,remoteChange:l.Change.None};if(this.h.isEqualOrParent(g,this.g))return s===void 0?{content:I.previewResult.content,localChange:I.previewResult.localChange,remoteChange:I.previewResult.remoteChange}:{content:s,localChange:s===null?I.fileContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified,remoteChange:s===null?I.remoteContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified};throw new Error(`Invalid Resource: ${g.toString()}`)}async tb(I,g,s,r){const t=s.map(([a,i])=>({...a,acceptResult:i}));t.every(({localChange:a,remoteChange:i})=>a===l.Change.None&&i===l.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),t.some(({localChange:a})=>a!==l.Change.None)&&(await this.Cb(t),await this.Db(t,r)),t.some(({remoteChange:a})=>a!==l.Change.None)&&(I=await this.Eb(t,I,r)),g?.ref!==I.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(I),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:a}of t)try{await this.G.del(a)}catch{}}Bb(I,g,s,r){const t=new Map;for(const a of Object.keys(I.local.added)){const i={content:I.local.added[a],hasConflicts:!1,localChange:l.Change.Added,remoteChange:l.Change.None};t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"remote"}),remoteContent:s[a],previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"accepted"})})}for(const a of Object.keys(I.local.updated)){const i={content:I.local.updated[a],hasConflicts:!1,localChange:l.Change.Modified,remoteChange:l.Change.None},n=g[a]?g[a].value.toString():null;t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"local"}),fileContent:g[a],localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"remote"}),remoteContent:s[a],previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"accepted"})})}for(const a of I.local.removed){const i={content:null,hasConflicts:!1,localChange:l.Change.Deleted,remoteChange:l.Change.None},n=g[a]?g[a].value.toString():null;t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"local"}),fileContent:g[a],localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"accepted"})})}for(const a of Object.keys(I.remote.added)){const i={content:I.remote.added[a],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Added},n=g[a]?g[a].value.toString():null;t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"local"}),fileContent:g[a],localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"accepted"})})}for(const a of Object.keys(I.remote.updated)){const i={content:I.remote.updated[a],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Modified},n=g[a]?g[a].value.toString():null;t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"local"}),fileContent:g[a],localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"remote"}),remoteContent:s[a],previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"accepted"})})}for(const a of I.remote.removed){const i={content:null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Deleted};t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"remote"}),remoteContent:s[a],previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"accepted"})})}for(const a of I.conflicts){const i={content:r[a]??null,hasConflicts:!0,localChange:g[a]?l.Change.Modified:l.Change.Added,remoteChange:s[a]?l.Change.Modified:l.Change.Added},n=g[a]?g[a].value.toString():null;t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"local"}),fileContent:g[a]||null,localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"remote"}),remoteContent:s[a]||null,previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"accepted"})})}for(const a of Object.keys(g))if(!t.has(a)){const i={content:g[a]?g[a].value.toString():null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.None},n=g[a]?g[a].value.toString():null;t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"local"}),fileContent:g[a]||null,localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"remote"}),remoteContent:s[a]||null,previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$Jnb,authority:"accepted"})})}return[...t.values()]}async resolveContent(I){return this.h.isEqualOrParent(I,this.g.with({scheme:l.$Jnb,authority:"remote"}))||this.h.isEqualOrParent(I,this.g.with({scheme:l.$Jnb,authority:"local"}))||this.h.isEqualOrParent(I,this.g.with({scheme:l.$Jnb,authority:"base"}))||this.h.isEqualOrParent(I,this.g.with({scheme:l.$Jnb,authority:"accepted"}))?this.db(I):null}async hasLocalData(){try{const I=await this.Hb();if(Object.keys(I).length)return!0}catch{}return!1}async Cb(I){const g={};for(const s of I)s.fileContent&&(g[this.h.basename(s.localResource)]=s.fileContent);await this.nb(JSON.stringify(this.Gb(g)))}async Db(I,g){for(const{fileContent:s,acceptResult:r,localResource:t,remoteResource:a,localChange:i}of I)if(i!==l.Change.None){const n=a?this.h.basename(a):this.h.basename(t),o=this.h.joinPath(this.vb,n);i===l.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(o)),await this.G.del(o),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(o))):i===l.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(o)),await this.G.createFile(o,P.$Oe.fromString(r.content),{overwrite:g}),this.O.info(`${this.D}: Created snippet`,this.h.basename(o))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(o)),await this.G.writeFile(o,P.$Oe.fromString(r.content),g?void 0:s),this.O.info(`${this.D}: Updated snippet`,this.h.basename(o)))}}async Eb(I,g,s){const r=g.syncData?this.Fb(g.syncData):{},t=(0,C.$do)(r);for(const{acceptResult:a,localResource:i,remoteResource:n,remoteChange:o}of I)if(o!==l.Change.None){const h=i?this.h.basename(i):this.h.basename(n);o===l.Change.Deleted?delete t[h]:t[h]=a.content}return(0,$.$_bc)(r,t)||(this.O.trace(`${this.D}: Updating remote snippets...`),g=await this.mb(JSON.stringify(t),s?null:g.ref),this.O.info(`${this.D}: Updated remote snippets`)),g}Fb(I){return b(I)}Gb(I){const g={};for(const s of Object.keys(I))g[s]=I[s].value.toString();return g}async Hb(){const I={};let g;try{g=await this.G.resolve(this.vb)}catch(s){if(s instanceof k.$ul&&s.fileOperationResult===k.FileOperationResult.FILE_NOT_FOUND)return I;throw s}for(const s of g.children||[]){const r=s.resource,t=this.h.extname(r);if(t===".json"||t===".code-snippets"){const a=this.h.relativePath(this.vb,r),i=await this.G.readFile(r);I[a]=i}}return I}};e.$bcc=v,e.$bcc=v=ve([Q(2,T.$Mi),Q(3,k.$_k),Q(4,A.$fq),Q(5,l.$snb),Q(6,l.$tnb),Q(7,l.$Hnb),Q(8,O.$_i),Q(9,l.$Cnb),Q(10,w.$$l),Q(11,S.$Jl)],v);let d=class extends u.$YNb{constructor(I,g,s,r,t,a){super(l.SyncResource.Snippets,g,s,r,I,t,a)}async o(I){const g=I.syncData?JSON.parse(I.syncData.content):null;if(!g){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const r of Object.keys(g)){const t=g[r];if(t){const a=this.d.joinPath(this.g.defaultProfile.snippetsHome,r);await this.k.createFile(a,P.$Oe.fromString(t)),this.j.info("Created snippet",this.d.basename(a))}}await this.n(I)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(I){return I.fileOperationResult===k.FileOperationResult.FILE_NOT_FOUND}}};e.$ccc=d,e.$ccc=d=ve([Q(0,k.$_k),Q(1,m.$Ll),Q(2,T.$Mi),Q(3,l.$Hnb),Q(4,A.$fq),Q(5,S.$Jl)],d)}),define(ce[125],le([0,1,15,22,16,7,17,18,29,20,40,25]),function(ne,e,P,c,C,O,T,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=e.$ecc=void 0,e.$dcc=u;function u(v,d){try{return JSON.parse(v).tasks??null}catch(p){return d.error(p),null}}let $=class extends S.$WNb{constructor(d,p,I,g,s,r,t,a,i,n,o,h){super(d.tasksResource,{syncResource:m.SyncResource.Tasks,profile:d},p,a,i,n,I,g,t,o,s,r,h),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:m.$Jnb,authority:"base"}),this.Cb=this.Ab.with({scheme:m.$Jnb,authority:"local"}),this.Db=this.Ab.with({scheme:m.$Jnb,authority:"remote"}),this.Eb=this.Ab.with({scheme:m.$Jnb,authority:"accepted"})}async qb(d,p,I,g){const s=d.syncData?u(d.syncData.content,this.O):null;p=p===null&&I?d:p;const r=p?.syncData?u(p.syncData.content,this.O):null,t=await this.vb();let a=null,i=!1,n=!1,o=!1;if(d.syncData){const R=t?t.value.toString():null;if(!r||r!==R||r!==s){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const L=b(R,s,r);a=L.content,o=L.hasConflicts,i=L.hasLocalChanged,n=L.hasRemoteChanged}}else t&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),a=t.value.toString(),n=!0);const h={content:o?r:a,localChange:i?t?m.Change.Modified:m.Change.Added:m.Change.None,remoteChange:n?m.Change.Modified:m.Change.None,hasConflicts:o},f=t?t.value.toString():null;return[{fileContent:t,baseResource:this.Bb,baseContent:r,localResource:this.Cb,localContent:f,localChange:h.localChange,remoteResource:this.Db,remoteContent:s,remoteChange:h.remoteChange,previewResource:this.Ab,previewResult:h,acceptedResource:this.Eb}]}async ub(d){const p=d?.syncData?u(d.syncData.content,this.O):null;if(p===null)return!0;const I=await this.vb(),g=I?I.value.toString():null,s=b(g,p,p);return s.hasLocalChanged||s.hasRemoteChanged}async rb(d,p){return d.previewResult}async sb(d,p,I,g){if(this.h.isEqual(p,this.Cb))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:m.Change.None,remoteChange:m.Change.Modified};if(this.h.isEqual(p,this.Db))return{content:d.remoteContent,localChange:m.Change.Modified,remoteChange:m.Change.None};if(this.h.isEqual(p,this.Ab))return I===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:I,localChange:m.Change.Modified,remoteChange:m.Change.Modified};throw new Error(`Invalid Resource: ${p.toString()}`)}async tb(d,p,I,g){const{fileContent:s}=I[0][0],{content:r,localChange:t,remoteChange:a}=I[0][1];if(t===m.Change.None&&a===m.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),t!==m.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),s&&await this.nb(JSON.stringify(this.Kb(s.value.toString()))),r?await this.wb(r,s,g):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),a!==m.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(r));d=await this.mb(i,g?null:d.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}p?.ref!==d.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(d),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(d){return this.h.isEqual(this.Db,d)||this.h.isEqual(this.Bb,d)||this.h.isEqual(this.Cb,d)||this.h.isEqual(this.Eb,d)?this.db(d):null}Kb(d){return d?{tasks:d}:{}}};e.$ecc=$,e.$ecc=$=ve([Q(2,m.$snb),Q(3,m.$tnb),Q(4,m.$Hnb),Q(5,c.$_i),Q(6,m.$Cnb),Q(7,O.$_k),Q(8,C.$Mi),Q(9,T.$fq),Q(10,k.$$l),Q(11,A.$Jl)],$);let l=class extends S.$YNb{constructor(d,p,I,g,s,r){super(m.SyncResource.Tasks,p,I,g,d,s,r),this.c=this.g.defaultProfile.tasksResource}async o(d){const p=d.syncData?u(d.syncData.content,this.j):null;if(!p){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,P.$Oe.fromString(p)),await this.n(d)}async p(){return this.k.exists(this.c)}};e.$fcc=l,e.$fcc=l=ve([Q(0,O.$_k),Q(1,w.$Ll),Q(2,C.$Mi),Q(3,m.$Hnb),Q(4,T.$fq),Q(5,A.$Jl)],l);function b(v,d,p){if(v===null&&d===null&&p===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(v===d)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const I=p!==v,g=p!==d;return!I&&!g?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:I&&!g?{content:v,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:g&&!I?{content:d,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:v,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ce[126],le([0,1,45,22,16,7,17,18,29,20,40,246,25]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0,e.$Zdc=l,e.$1dc=b;let $=class extends S.$VNb{constructor(d,p,I,g,s,r,t,a,i,n,o,h,f){super({syncResource:u.SyncResource.Profiles,profile:d},p,g,s,r,t,a,o,h,i,n,f),this.vb=I,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:u.$Jnb,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.$Jnb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.$Jnb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.$Jnb,authority:"accepted"}),this.B(I.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const d=await this.getLastSyncUserData();return d?.syncData?b(d.syncData):null}async getRemoteSyncedProfiles(d){const p=await this.getLastSyncUserData(),I=await this.X(d,p);return I?.syncData?b(I.syncData):null}async qb(d,p,I){if(!this.vb.isEnabled())throw new u.$xnb("Cannot sync profiles because they are disabled",u.UserDataSyncErrorCode.LocalError);const g=d.syncData?b(d.syncData):null,s=p?.syncData?b(p.syncData):null,r=this.Db(),{local:t,remote:a}=(0,m.$Xdc)(r,g,s,[]),i={local:t,remote:a,content:s?this.Eb(s):null,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?u.Change.Modified:u.Change.None,remoteChange:a!==null?u.Change.Modified:u.Change.None},n=l(r,!1);return[{baseResource:this.baseResource,baseContent:s?this.Eb(s):null,localResource:this.localResource,localContent:n,remoteResource:this.remoteResource,remoteContent:g?this.Eb(g):null,remoteProfiles:g,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(d){const p=d?.syncData?b(d.syncData):null,I=this.Db(),{remote:g}=(0,m.$Xdc)(I,p,p,[]);return!!g?.added.length||!!g?.removed.length||!!g?.updated.length}async rb(d,p){return{...d.previewResult,hasConflicts:!1}}async sb(d,p,I,g){if(this.h.isEqual(p,this.localResource))return this.Ab(d);if(this.h.isEqual(p,this.remoteResource))return this.Bb(d);if(this.h.isEqual(p,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${p.toString()}`)}async Ab(d){const p=this.Db(),I=(0,m.$Xdc)(p,null,null,[]),{local:g,remote:s}=I;return{content:d.localContent,local:g,remote:s,localChange:g.added.length>0||g.removed.length>0||g.updated.length>0?u.Change.Modified:u.Change.None,remoteChange:s!==null?u.Change.Modified:u.Change.None}}async Bb(d){const p=d.remoteContent?JSON.parse(d.remoteContent):null,I=[],g=[];for(const s of this.Db()){const r=p?.find(t=>t.id===s.id);r&&(I.push({id:s.id,name:s.name,collection:r.collection}),g.push(s))}if(p!==null){const s=(0,m.$Xdc)(g,p,I,[]),{local:r,remote:t}=s;return{content:d.remoteContent,local:r,remote:t,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?u.Change.Modified:u.Change.None,remoteChange:t!==null?u.Change.Modified:u.Change.None}}else return{content:d.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:u.Change.None,remoteChange:u.Change.None}}async tb(d,p,I,g){const{local:s,remote:r,localChange:t,remoteChange:a}=I[0][1];t===u.Change.None&&a===u.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=I[0][0].remoteProfiles||[];if(i.length+(r?.added.length??0)-(r?.removed.length??0)>20)throw new u.$xnb("Too many profiles to sync. Please remove some profiles and try again.",u.UserDataSyncErrorCode.LocalTooManyProfiles);if(t!==u.Change.None&&(await this.nb(l(this.Db(),!1)),await Promise.all(s.removed.map(async n=>{this.O.trace(`${this.D}: Removing '${n.name}' profile...`),await this.vb.removeProfile(n),this.O.info(`${this.D}: Removed profile '${n.name}'.`)})),await Promise.all(s.added.map(async n=>{this.O.trace(`${this.D}: Creating '${n.name}' profile...`),await this.vb.createProfile(n.id,n.name,{shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${n.name}'.`)})),await Promise.all(s.updated.map(async n=>{const o=this.vb.profiles.find(h=>h.id===n.id);o?(this.O.trace(`${this.D}: Updating '${n.name}' profile...`),await this.vb.updateProfile(o,{name:n.name,shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${n.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${n.id}' to update.`)}))),a!==u.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const n=[],o=i.length+(r?.added.length??0)<=20;if(o)for(const h of r?.added||[]){const f=await this.J.createCollection(this.F);n.push(f),i.push({id:h.id,name:h.name,collection:f,shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const h of r?.removed||[])i.splice(i.findIndex(({id:f})=>h.id===f),1);for(const h of r?.updated||[]){const f=i.find(({id:R})=>h.id===R);f&&i.splice(i.indexOf(f),1,{...f,id:h.id,name:h.name,shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags})}try{d=await this.updateRemoteProfiles(i,g?null:d.ref),this.O.info(`${this.D}: Updated remote profiles.${o&&r?.added.length?` Added: ${JSON.stringify(r.added.map(h=>h.name))}.`:""}${r?.updated.length?` Updated: ${JSON.stringify(r.updated.map(h=>h.name))}.`:""}${r?.removed.length?` Removed: ${JSON.stringify(r.removed.map(h=>h.name))}.`:""}`)}catch(h){if(n.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const f of n)await this.J.deleteCollection(f,this.F)}throw h}for(const h of r?.removed||[])await this.J.deleteCollection(h.collection,this.F)}p?.ref!==d.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(d),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(d,p){return this.mb(this.Eb(d),p)}async hasLocalData(){return this.Db().length>0}async resolveContent(d){if(this.h.isEqual(this.remoteResource,d)||this.h.isEqual(this.baseResource,d)||this.h.isEqual(this.localResource,d)||this.h.isEqual(this.acceptedResource,d)){const p=await this.db(d);return p&&(0,P.$8n)(JSON.parse(p),{})}return null}Db(){return this.vb.profiles.filter(d=>!d.isDefault&&!d.isTransient)}Eb(d){return JSON.stringify([...d].sort((p,I)=>p.name.localeCompare(I.name)))}};e.$Ydc=$,e.$Ydc=$=ve([Q(2,w.$Ll),Q(3,O.$_k),Q(4,C.$Mi),Q(5,T.$fq),Q(6,u.$snb),Q(7,u.$tnb),Q(8,u.$Hnb),Q(9,c.$_i),Q(10,u.$Cnb),Q(11,k.$$l),Q(12,A.$Jl)],$);function l(v,d){const p=[...v].sort((I,g)=>I.name.localeCompare(g.name)).map(I=>({id:I.id,name:I.name}));return d?(0,P.$8n)(p,{}):JSON.stringify(p)}function b(v){return JSON.parse(v.content)}}),define(ce[265],le([0,1,3,2,5,16,17,18,25]),function(ne,e,P,c,C,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0;const w="sync.enable";let S=class extends c.$Wc{constructor(u,$,l,b){super(),this.c=u,this.f=$,this.g=l,this.h=b,this.a=new P.$me,this.onDidChangeEnablement=this.a.event,this.b=new P.$me,this.onDidChangeResourceEnablement=this.b.event,this.B(u.onDidChangeValue(T.StorageScope.APPLICATION,void 0,this.B(new c.$Vc))(v=>this.m(v)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(w,T.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||(this.f.publicLog2(w,{enabled:u}),this.c.store(w,u,T.StorageScope.APPLICATION,T.StorageTarget.MACHINE))}isResourceEnabled(u){return this.c.getBoolean((0,A.$Bnb)(u),T.StorageScope.APPLICATION,!0)}setResourceEnablement(u,$){if(this.isResourceEnabled(u)!==$){const l=(0,A.$Bnb)(u);this.j(l,$)}}getResourceSyncStateVersion(u){}j(u,$){this.c.store(u,$,T.StorageScope.APPLICATION,C.$o?T.StorageTarget.USER:T.StorageTarget.MACHINE)}m(u){if(w===u.key){this.a.fire(this.isEnabled());return}const $=A.$onb.filter(l=>(0,A.$Bnb)(l)===u.key)[0];if($){this.b.fire([$,this.isResourceEnabled($)]);return}}};e.$Ldc=S,e.$Ldc=S=ve([Q(0,T.$fq),Q(1,k.$$l),Q(2,O.$Mi),Q(3,A.$rnb)],S)}),define(ce[266],le([0,1,6,15,68,2,21,22,16,7,20,25]),function(ne,e,P,c,C,O,T,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0;let u=class extends O.$Wc{constructor(l,b,v,d,p){super(),this.a=l,this.b=b,this.c=v,this.f=d,this.g=p,this.h()}async h(){for(const b of this.g.profiles)for(const v of m.$onb)try{await this.m(this.j(v,b.isDefault?void 0:b.id))}catch(d){this.f.error(d)}let l;try{l=await this.b.resolve(this.a.userDataSyncHome)}catch(b){(0,w.$ql)(b)!==w.FileOperationResult.FILE_NOT_FOUND&&this.f.error(b);return}if(l.children){for(const b of l.children)if(b.isDirectory&&!this.g.profiles.some(v=>v.id===b.name))try{this.f.info("Deleting non existing profile from backup",b.resource.path),await this.b.del(b.resource,{recursive:!0})}catch(v){this.f.error(v)}}}async getAllResourceRefs(l,b,v){const d=this.j(l,b,v);try{const p=await this.b.resolve(d);if(p.children)return p.children.filter(g=>g.isFile&&!g.name.startsWith("lastSync")).sort().reverse().map(g=>({ref:g.name,created:this.n(g)}))}catch(p){if((0,w.$ql)(p)!==w.FileOperationResult.FILE_NOT_FOUND)throw p}return[]}async resolveResourceContent(l,b,v,d){const p=this.j(l,v,d),I=(0,T.$gh)(p,b);try{return(await this.b.readFile(I)).value.toString()}catch(g){return this.f.error(g),null}}async writeResource(l,b,v,d,p){const I=this.j(l,d,p),g=(0,T.$gh)(I,`${(0,C.$3m)(v).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(g,c.$Oe.fromString(b))}catch(s){this.f.error(s)}}j(l,b,v=this.a.userDataSyncHome){return(0,T.$gh)(v,...b?[b,l]:[l])}async m(l){try{try{if(!await this.b.exists(l))return}catch{return}const b=await this.b.resolve(l);if(b.children){const v=b.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort(),d=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let p=v.filter(g=>Date.now()-this.n(g)>d);const I=v.length-p.length;I<10&&(p=p.slice(10-I)),await P.Promises.settled(p.map(async g=>{this.f.info("Deleting from backup",g.resource.path),await this.b.del(g.resource)}))}}catch(b){this.f.error(b)}}n(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.$Wdc=u,e.$Wdc=u=ve([Q(0,A.$Mi),Q(1,w.$_k),Q(2,k.$_i),Q(3,m.$Hnb),Q(4,S.$Ll)],u)}),define(ce[87],le([0,1,3,2,5,27,187,16,7,4,24,50,17,25]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$hnb=e.$fnb=void 0,e.$gnb=s,e.$fnb=(0,w.$Fi)("IUserDataSyncMachinesService");const b="sync.currentMachineName",v="Safari",d="Chrome",p="Edge",I="Firefox",g="Android";function s(a){switch(a){case v:case d:case p:case I:case g:case(0,C.$h)(C.Platform.Web):return!0}return!1}function r(){return C.$G?v:C.$E?d:C.$H?p:C.$F?I:C.$I?g:(0,C.$h)(C.$o?C.Platform.Web:C.$u)}let t=class extends c.$Wc{static{l=this}static{this.a=1}static{this.b="machines"}constructor(i,n,o,h,f,R){super(),this.h=o,this.j=h,this.m=f,this.n=R,this.c=this.B(new P.$me),this.onDidChange=this.c.event,this.g=null,this.f=(0,m.$lq)(i,n,o)}async getMachines(i){const n=await this.f;return(await this.s(i)).machines.map(h=>({...h,isCurrent:h.id===n}))}async addCurrentMachine(i){const n=await this.f,o=await this.s(i);o.machines.some(({id:h})=>h===n)||(o.machines.push({id:n,name:this.r(o.machines),platform:r()}),await this.t(o))}async removeCurrentMachine(i){const n=await this.f,o=await this.s(i),h=o.machines.filter(({id:f})=>f!==n);h.length!==o.machines.length&&(o.machines=h,await this.t(o))}async renameMachine(i,n,o){const h=await this.s(o),f=h.machines.find(({id:R})=>R===i);if(f){f.name=n,await this.t(h);const R=await this.f;i===R&&this.h.store(b,n,u.StorageScope.APPLICATION,u.StorageTarget.MACHINE)}}async setEnablements(i){const n=await this.s();for(const[o,h]of i){const f=n.machines.find(R=>R.id===o);f&&(f.disabled=h?void 0:!0)}await this.t(n)}r(i){const n=this.h.get(b,u.StorageScope.APPLICATION);if(n)return n;const o=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${r()} (${this.n.nameShort})`,h=new RegExp(`${(0,O.$if)(o)}\\s#(\\d+)`);let f=0;for(const R of i){const L=h.exec(R.name),E=L?parseInt(L[1]):0;f=E>f?E:f}return`${o} #${f+1}`}async s(i){this.g=await this.u(i);const n=this.w(this.g);if(n.version!==l.a)throw new Error((0,T.localize)(0,null,this.n.nameLong));return n}async t(i){const n=JSON.stringify(i),o=await this.j.writeResource(l.b,n,this.g?.ref||null);this.g={ref:o,content:n},this.c.fire()}async u(i){if(this.g){const n=i&&i.latest?i.latest[l.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.j.readResource(l.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(n){this.m.error(n)}return{version:l.a,machines:[]}}};e.$hnb=t,e.$hnb=t=l=ve([Q(0,k.$Mi),Q(1,A.$_k),Q(2,u.$fq),Q(3,$.$snb),Q(4,$.$Hnb),Q(5,S.$sk)],t)}),define(ce[267],le([0,1,6,68,41,8,3,2,5,21,9,184,24,17,18,25,83,87]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;const p="sync.disableMachineEventually",I="sync.sessionId",g="sync.storeUrl",s="sync.productQuality";let r=class extends k.$Wc{get n(){const i=this.H.get(g,$.StorageScope.APPLICATION);return i?S.URI.parse(i):void 0}set n(i){i?this.H.store(g,i.toString(),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE):this.H.remove(g,$.StorageScope.APPLICATION)}get s(){return this.H.get(s,$.StorageScope.APPLICATION)}set s(i){i?this.H.store(s,i,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE):this.H.remove(s,$.StorageScope.APPLICATION)}constructor(i,n,o,h,f,R,L,E,y,N){super(),this.u=n,this.w=o,this.y=h,this.z=f,this.C=R,this.D=L,this.F=E,this.G=y,this.H=N,this.a=this.B(new k.$Xc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.$me),this.onError=this.h.event,this.S=[],this.f=this.B(new P.$Dh(this.U())),this.j=this.n,this.n=n.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(n.onDidChangeUserDataSyncStore(()=>{(0,w.$_g)(this.n,n.userDataSyncStore?.url)||(this.j=this.n,this.n=n.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(L.onDidChangeAccount(()=>this.I())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(f.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(T.Event.filter(this.y.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:n}=this.L();i?this.a.value===void 0&&(this.a.value=new t(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.O(o))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(n&&this.C.info(n),this.a.clear()):n&&this.y.isEnabled()&&this.C.info(n))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,c.$3m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,n,o){try{this.D.account&&!o&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(I,$.StorageScope.APPLICATION),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(h){if(this.C.error(h),n)this.M(!1);else throw h}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const n=b.$xnb.toUserDataSyncError(i);n instanceof b.$znb&&this.F.publicLog2("autosync/error",{code:n.code,service:this.u.userDataSyncStore.url.toString()}),n.code===b.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):n.code===b.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):n.code===b.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):n.code===b.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):n.code===b.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):n.code===b.UserDataSyncErrorCode.UpgradeRequired||n.code===b.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):n.code===b.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with newer version than of client. Requires client upgrade.`)):n.code===b.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with older version than of client. Requires server reset.`)):n.code===b.UserDataSyncErrorCode.ServiceChanged||n.code===b.UserDataSyncErrorCode.DefaultServiceChanged?A.$o&&n.code===b.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(n),this.b++),this.h.fire(n)}async P(){this.H.store(p,!0,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE),await(0,P.$Gh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(p,$.StorageScope.APPLICATION,!1)}R(){this.H.remove(p,$.StorageScope.APPLICATION)}async triggerSync(i,n,o){if(this.a.value===void 0)return this.f.cancel();if(n&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const h=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:h}),this.S=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$3dc=r,e.$3dc=r=ve([Q(0,u.$sk),Q(1,b.$rnb),Q(2,b.$snb),Q(3,b.$Cnb),Q(4,b.$Dnb),Q(5,b.$Hnb),Q(6,v.$dMb),Q(7,l.$$l),Q(8,d.$fnb),Q(9,$.$fq)],r);class t extends k.$Wc{static{this.a="Interval"}constructor(i,n,o,h,f,R,L,E,y){super(),this.m=i,this.n=n,this.r=o,this.s=h,this.u=f,this.w=R,this.y=L,this.z=E,this.C=y,this.b=this.B(new k.$Xc),this.c=this.B(new T.$me),this.onDidStartSync=this.c.event,this.f=this.B(new T.$me),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,k.$Uc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(t.a,!1)}D(){this.b.value=(0,P.$Hh)(()=>{this.sync(t.a,!1),this.b.value=void 0},this.n)}sync(i,n){const o=(0,P.$sh)(async h=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(f){if((0,O.$6)(f))return}return this.H(i,n,h)});return this.j=o,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,w.$_g)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),n=this.r.userDataSyncStore;return!!n&&!!i&&(!(0,w.$_g)(n.defaultUrl,i.defaultUrl)||!(0,w.$_g)(n.insidersUrl,i.insidersUrl)||!(0,w.$_g)(n.stableUrl,i.stableUrl))}async H(i,n,o){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let h;try{await this.I(n,o)}catch(f){if(this.y.error(f),h=f,b.$xnb.toUserDataSyncError(f).code===b.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(n,o),h=void 0}catch(R){this.y.error(R),h=R}}this.f.fire(h)}async I(i,n){if(this.h=await this.u.createSyncTask(this.g,i),n.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new b.$znb((0,m.localize)(0,null),b.UserDataSyncErrorCode.DefaultServiceChanged):new b.$znb((0,m.localize)(1,null),b.UserDataSyncErrorCode.ServiceChanged):new b.$znb((0,m.localize)(2,null),b.UserDataSyncErrorCode.TurnedOff);const o=this.C.get(I,$.StorageScope.APPLICATION);if(o&&this.g&&o!==this.g.session)throw this.F()?await this.G()?new b.$znb((0,m.localize)(3,null),b.UserDataSyncErrorCode.DefaultServiceChanged):new b.$znb((0,m.localize)(4,null),b.UserDataSyncErrorCode.ServiceChanged):new b.$znb((0,m.localize)(5,null),b.UserDataSyncErrorCode.SessionExpired);const h=await this.w.getMachines(this.g||void 0);if(n.isCancellationRequested)return;const f=h.find(L=>L.isCurrent);if(f?.disabled)throw new b.$znb((0,m.localize)(6,null),b.UserDataSyncErrorCode.TurnedOff);const R=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-R}),this.g===null)try{this.g=await this.s.manifest(null)}catch(L){throw new b.$znb((0,C.$qj)(L),L instanceof b.$xnb?L.code:b.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==o&&this.C.store(I,this.g.session,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE),!n.isCancellationRequested&&(f||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(ce[268],le([0,1,9,188,16,7,50,17,29,25,20,40,124,123,122,22,125,120,121,4,126,45,27]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p,I,g,s,r){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;let a=class{static{t=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(n,o,h,f,R,L,E,y,N,F){this.e=n,this.f=o,this.g=h,this.h=R,this.i=L,this.j=E,this.k=y,this.l=N,this.n=F,this.d=f.extUri}async getRemoteSyncedProfiles(){const n=await this.e.readResource(w.SyncResource.Profiles,null,void 0);if(n.content){const o=this.L(n.content,w.SyncResource.Profiles);return(0,g.$1dc)(o)}return[]}async getLocalSyncedProfiles(n){const o=await this.f.getAllResourceRefs(w.SyncResource.Profiles,void 0,n);if(o.length){const h=await this.f.resolveResourceContent(w.SyncResource.Profiles,o[0].ref,void 0,n);if(h){const f=this.L(h,w.SyncResource.Profiles);return(0,g.$1dc)(f)}}return[]}async getLocalSyncedMachines(n){const o=await this.f.getAllResourceRefs("machines",void 0,n);if(o.length){const h=await this.f.resolveResourceContent("machines",o[0].ref,void 0,n);if(h)return JSON.parse(h).machines.map(R=>({...R,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(n,o){return(await this.e.getAllResourceRefs(n,o?.collection)).map(({created:f,ref:R})=>({created:f,uri:this.J({remote:!0,syncResource:n,profile:o?.id??this.k.defaultProfile.id,location:void 0,collection:o?.collection,ref:R,node:void 0})}))}async getLocalSyncResourceHandles(n,o,h){return(await this.f.getAllResourceRefs(n,o?.collection,h)).map(({created:R,ref:L})=>({created:R,uri:this.J({remote:!1,syncResource:n,profile:o?.id??this.k.defaultProfile.id,collection:o?.collection,ref:L,node:void 0,location:h})}))}resolveUserDataSyncResource({uri:n}){const o=this.K(n),h=o?this.k.profiles.find(f=>f.id===o.profile):void 0;return o&&h?{profile:h,syncResource:o?.syncResource}:void 0}async getAssociatedResources({uri:n}){const o=this.K(n);if(!o)return[];const h=this.k.profiles.find(f=>f.id===o.profile);switch(o.syncResource){case w.SyncResource.Settings:return this.s(n,h);case w.SyncResource.Keybindings:return this.u(n,h);case w.SyncResource.Tasks:return this.w(n,h);case w.SyncResource.Snippets:return this.y(n,h);case w.SyncResource.GlobalState:return this.D(n,h);case w.SyncResource.Extensions:return this.A(n,h);case w.SyncResource.Profiles:return this.G(n,h);case w.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:n}){const o=this.K(n);if(o){if(o.remote){if(o.ref){const{content:h}=await this.M(o.syncResource,o.ref,o.collection);if(h)return this.L(h,o.syncResource)?.machineId}return}if(o.location){if(o.ref){const h=await this.f.resolveResourceContent(o.syncResource,o.ref,o.collection,o.location);if(h)return this.L(h,o.syncResource)?.machineId}return}return(0,T.$lq)(this.h,this.j,this.i)}}async resolveContent(n){const o=this.K(n);if(!o||o.node===t.a)return null;if(o.ref){const h=await this.o(o.remote,o.syncResource,o.collection,o.ref,o.location);return o.node&&h?this.q(o.syncResource,h,o.node):h}return!o.remote&&!o.node?this.r(o.syncResource,o.profile):null}async o(n,o,h,f,R){if(n){const{content:L}=await this.M(o,f,h);return L}return this.f.resolveResourceContent(o,f,h,R)}q(n,o,h){const f=this.L(o,n);switch(n){case w.SyncResource.Settings:return this.t(f,h);case w.SyncResource.Keybindings:return this.v(f,h);case w.SyncResource.Tasks:return this.x(f,h);case w.SyncResource.Snippets:return this.z(f,h);case w.SyncResource.GlobalState:return this.E(f,h);case w.SyncResource.Extensions:return this.B(f,h);case w.SyncResource.Profiles:return this.H(f,h);case w.SyncResource.WorkspaceState:return null}}async r(n,o){const h=this.k.profiles.find(f=>f.id===o);if(!h)return null;switch(n){case w.SyncResource.GlobalState:return this.F(h);case w.SyncResource.Extensions:return this.C(h);case w.SyncResource.Profiles:return this.I(h);case w.SyncResource.Settings:return null;case w.SyncResource.Keybindings:return null;case w.SyncResource.Tasks:return null;case w.SyncResource.Snippets:return null;case w.SyncResource.WorkspaceState:return null}}s(n,o){const h=this.d.joinPath(n,"settings.json"),f=o?o.settingsResource:this.d.joinPath(n,t.a);return[{resource:h,comparableResource:f}]}t(n,o){switch(o){case"settings.json":return(0,$.$8bc)(n.content).settings}return null}u(n,o){const h=this.d.joinPath(n,"keybindings.json"),f=o?o.keybindingsResource:this.d.joinPath(n,t.a);return[{resource:h,comparableResource:f}]}v(n,o){switch(o){case"keybindings.json":return(0,l.$5bc)(n.content,!!this.l.getValue(w.$lnb),this.g)}return null}w(n,o){const h=this.d.joinPath(n,"tasks.json"),f=o?o.tasksResource:this.d.joinPath(n,t.a);return[{resource:h,comparableResource:f}]}x(n,o){switch(o){case"tasks.json":return(0,v.$dcc)(n.content,this.g)}return null}async y(n,o){const h=await this.resolveContent(n);if(h){const f=this.L(h,w.SyncResource.Snippets);if(f){const R=(0,u.$acc)(f),L=[];for(const E of Object.keys(R)){const y=this.d.joinPath(n,E),N=o?this.d.joinPath(o.snippetsHome,E):this.d.joinPath(n,t.a);L.push({resource:y,comparableResource:N})}return L}}return[]}z(n,o){return(0,u.$acc)(n)[o]||null}A(n,o){const h=this.d.joinPath(n,"extensions.json"),f=o?this.J({remote:!1,syncResource:w.SyncResource.Extensions,profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,t.a);return[{resource:h,comparableResource:f}]}B(n,o){switch(o){case"extensions.json":return(0,d.$Zbc)((0,d.$Ybc)(n),!0)}return null}async C(n){const{localExtensions:o}=await this.n.createInstance(d.$2bc).getLocalExtensions(n);return(0,d.$Zbc)(o,!0)}D(n,o){const h=this.d.joinPath(n,"globalState.json"),f=o?this.J({remote:!1,syncResource:w.SyncResource.GlobalState,profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,t.a);return[{resource:h,comparableResource:f}]}E(n,o){switch(o){case"globalState.json":return(0,p.$1Nb)(JSON.parse(n.content),!0)}return null}async F(n){const o=await this.n.createInstance(p.$3Nb).getLocalGlobalState(n);return(0,p.$1Nb)(o,!0)}G(n,o){const h=this.d.joinPath(n,"profiles.json"),f=this.J({remote:!1,syncResource:w.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:h,comparableResource:f}]}H(n,o){switch(o){case"profiles.json":return(0,s.$8n)(JSON.parse(n.content),{})}return null}async I(n){return(0,g.$Zdc)(this.k.profiles.filter(o=>!o.isDefault&&!o.isTransient),!0)}J(n){const o=n.remote?t.b:t.c,h=[];return n.location&&(h.push(`scheme:${n.location.scheme}`),h.push(`authority:${n.location.authority}`),h.push((0,r.$mf)(n.location.path,"/"))),h.push(`syncResource:${n.syncResource}`),h.push(`profile:${n.profile}`),n.collection&&h.push(`collection:${n.collection}`),n.ref&&h.push(`ref:${n.ref}`),n.node&&h.push(n.node),this.d.joinPath(P.URI.from({scheme:w.$Jnb,authority:o,path:"/",query:n.location?.query,fragment:n.location?.fragment}),...h)}K(n){if(n.scheme!==w.$Jnb)return;const o=[];for(;n.path!=="/";)o.unshift(this.d.basename(n)),n=this.d.dirname(n);if(o.length<2)return;const h=n.authority===t.b;let f,R;const L=[];let E,y,N,F,D;for(;o.length;){const M=o.shift();M.startsWith("scheme:")?f=M.substring(7):M.startsWith("authority:")?R=M.substring(10):M.startsWith("syncResource:")?E=M.substring(13):M.startsWith("profile:")?y=M.substring(8):M.startsWith("collection:")?N=M.substring(11):M.startsWith("ref:")?F=M.substring(4):E?D=M:L.push(M)}return{remote:h,syncResource:E,profile:y,collection:N,ref:F,node:D,location:f&&R!==void 0?this.d.joinPath(P.URI.from({scheme:f,authority:R,query:n.query,fragment:n.fragment,path:"/"}),...L):void 0}}L(n,o){try{const h=JSON.parse(n);if((0,m.$TNb)(h))return h}catch(h){this.g.error(h)}throw new w.$xnb((0,c.localize)(0,null),w.UserDataSyncErrorCode.IncompatibleRemoteContent,o)}async M(n,o,h){const f=await this.e.resolveResourceContent(n,o,h);return{ref:o,content:f}}};e.$Fec=a,e.$Fec=a=t=ve([Q(0,w.$snb),Q(1,w.$tnb),Q(2,w.$Hnb),Q(3,A.$Jl),Q(4,C.$Mi),Q(5,k.$fq),Q(6,O.$_k),Q(7,S.$Ll),Q(8,b.$_i),Q(9,I.$Ei)],a)}),define(ce[269],le([0,1,19,6,26,41,3,2,21,13,32,22,28,7,4,17,18,20,120,121,122,123,124,125,126,25]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p,I,g,s,r,t,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;const n="sync.lastSyncTime";let o=class extends k.$Wc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(E,y,N,F,D,M,J,W,x,G,ie){super(),this.C=E,this.D=y,this.F=N,this.G=F,this.H=D,this.I=M,this.J=J,this.L=W,this.M=x,this.N=G,this.O=ie,this.f=i.SyncStatus.Uninitialized,this.g=this.B(new T.$me),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.$me),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new T.$me),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new T.$me),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new T.$me),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new T.$me),this.onDidResetLocal=this.w.event,this.y=this.B(new T.$me),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=N.userDataSyncStore?i.SyncStatus.Idle:i.SyncStatus.Uninitialized,this.t=this.J.getNumber(n,b.StorageScope.APPLICATION,void 0),this.B((0,k.$Uc)(()=>this.cb())),this.B(new c.$Rh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(E,y){this.db(),this.H.info("Sync started.");const N=new Date().getTime(),F=(0,S.$2g)();try{const W=(0,i.$wnb)(F);y&&(W["Cache-Control"]="no-cache"),E=await this.D.manifest(E,W)}catch(W){const x=i.$xnb.toUserDataSyncError(W);throw R(x,F,this.F,this.I),x}const D=!1,M=this;let J;return{manifest:E,async run(){if(D)throw new Error("Can run a task only once");J=(0,c.$sh)(W=>M.P(E,!1,F,W)),await J.finally(()=>J=void 0),M.H.info(`Sync done. Took ${new Date().getTime()-N}ms`),M.ab()},stop(){return J?.cancel(),M.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new i.$xnb("Cannot start manual sync when sync is enabled",i.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const E=new Date().getTime(),y=(0,S.$2g)(),N=(0,i.$wnb)(y);let F;try{F=await this.D.manifest(null,N)}catch(J){const W=i.$xnb.toUserDataSyncError(J);throw R(W,y,this.F,this.I),W}await this.resetLocal();const D=this,M=new C.$xe;return{id:y,async merge(){return D.P(F,!0,y,M.token)},async apply(){try{try{await D.R(F,y,M.token)}catch(J){if(i.$xnb.toUserDataSyncError(J).code===i.UserDataSyncErrorCode.MethodNotFound)D.H.info("Client is making invalid requests. Cleaning up data..."),await D.cleanUpRemoteData(),D.H.info("Applying manual sync again..."),await D.R(F,y,M.token);else throw J}}catch(J){throw D.H.error(J),J}D.H.info(`Sync done. Took ${new Date().getTime()-E}ms`),D.ab()},async stop(){M.cancel(),await D.U(),await D.resetLocal()}}}async P(E,y,N,F){this.n=[];try{this.status!==i.SyncStatus.HasConflicts&&this.Z(i.SyncStatus.Syncing);const D=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(D,E,y,N,F));const M=D.enabled.find(J=>J.resource===i.SyncResource.Profiles);if(M){const J=await M.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.Q(J,E,y,N,F)}}finally{this.status!==i.SyncStatus.HasConflicts&&this.Z(i.SyncStatus.Idle),this.r.fire(this.n)}}async Q(E,y,N,F,D){for(const M of E){if(D.isCancellationRequested)return;const J=this.M.profiles.find(x=>x.id===M.id);if(!J){this.H.error(`Profile with id:${M.id} and name: ${M.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",M.name);const W=this.getOrCreateActiveProfileSynchronizer(J,M);this.n.push(...await this.S(W,y,N,F,D))}for(const[M,J]of this.z.entries())this.M.profiles.some(W=>W.id===J[0].profile.id)||(await J[0].resetLocal(),J[1].dispose(),this.z.delete(M))}async R(E,y,N){const F=this.bb();for(const x of F){if(N.isCancellationRequested)return;await x.apply(y,N)}const D=F.find(x=>x.profile.isDefault);if(!D)return;const M=D.enabled.find(x=>x.resource===i.SyncResource.Profiles);if(!M)return;const W=(await M.getRemoteSyncedProfiles(E?.latest??null)||[]).filter(x=>F.every(G=>G.profile.id!==x.id));W.length&&await this.Q(W,E,!1,y,N)}async S(E,y,N,F,D){return(await E.sync(y,N,F,D)).map(([J,W])=>({profile:E.profile,syncResource:J,error:W}))}async U(){this.status!==i.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(E=>E.stop()))}async resolveContent(E){const y=await this.N.resolveContent(E);if(y)return y;for(const N of this.bb())for(const F of N.enabled){const D=await F.resolveContent(E);if(D)return D}return null}async replace(E){this.db();const y=this.N.resolveUserDataSyncResource(E);if(!y)return;const N=await this.resolveContent(E.uri);N&&await this.X(y.profile,async F=>{if(y.syncResource===F.resource)return await F.replace(N),!0})}async accept(E,y,N,F){this.db(),await this.X(E.profile,async D=>{if(E.syncResource===D.resource)return await D.accept(y,N),F&&await D.apply((0,w.$lg)(F)?!1:F.force,(0,i.$wnb)((0,S.$2g)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async y=>{if(y.resource!==i.SyncResource.GlobalState&&await y.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async y=>{if(await y.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(E){this.H.error(E)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(n,b.StorageScope.APPLICATION);for(const[E]of this.z.values())try{await E.resetLocal()}catch(y){this.H.error(y)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const E=this.J.keys(b.StorageScope.APPLICATION,b.StorageTarget.MACHINE),y=[];for(const F of E){if(!F.endsWith(".lastSyncUserData"))continue;const D=F.split(".");D.length===3&&y.push([F,D[0]])}if(!y.length)return;const N=new k.$Vc;try{let F=this.z.get(this.M.defaultProfile.id)?.[0];F||(F=N.add(this.G.createInstance(h,this.M.defaultProfile,void 0)));const D=F.enabled.find(W=>W.resource===i.SyncResource.Profiles);if(!D)return;const J=(await D.getLastSyncedProfiles())?.map(W=>W.collection)??[];for(const[W,x]of y)J.includes(x)||(this.H.info(`Removing last sync state for stale profile: ${x}`),this.J.remove(W,b.StorageScope.APPLICATION))}finally{N.dispose()}}async cleanUpRemoteData(){const E=await this.N.getRemoteSyncedProfiles(),y=E.map(M=>M.collection),N=await this.D.getAllCollections(),F=N.filter(M=>!y.includes(M));F.length&&(this.H.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(M=>this.D.deleteCollection(M))),this.H.info("Deleted redundant collections on server"));const D=E.filter(M=>N.includes(M.collection));if(D.length!==E.length){const M=this.G.createInstance(a.$Ydc,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await M.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await M.updateRemoteProfiles(D,null),this.H.info("Updated remote profiles on server")}finally{M.dispose()}}}async saveRemoteActivityData(E){this.db();const y=await this.D.getActivityData();await this.C.writeFile(E,y)}async extractActivityData(E,y){const N=(await this.C.readFile(E)).value.toString(),F=JSON.parse(N);if(F.resources)for(const D in F.resources)for(const M of F.resources[D])await this.O.writeResource(D,M.content,new Date(M.created*1e3),void 0,y);if(F.collections)for(const D in F.collections)for(const M in F.collections[D].resources)for(const J of F.collections[D].resources?.[M]??[])await this.O.writeResource(M,J.content,new Date(J.created*1e3),D,y)}async X(E,y){const N=new k.$Vc;try{const F=this.z.get(E.id);if(F){const x=await this.Y(F[0],y,N);return(0,w.$mg)(x)?null:x}if(E.isDefault){const x=N.add(this.G.createInstance(h,E,void 0)),G=await this.Y(x,y,N);return(0,w.$mg)(G)?null:G}if(this.M.isEnabled())return null;const D=N.add(this.G.createInstance(a.$Ydc,E,void 0)),M=await this.D.manifest(null),W=(await D.getRemoteSyncedProfiles(M?.latest??null)||[]).find(x=>x.id===E.id);if(W){const x=N.add(this.G.createInstance(h,E,W.collection)),G=await this.Y(x,y,N);return(0,w.$mg)(G)?null:G}return null}finally{N.dispose()}}async Y(E,y,N){const F=[...E.enabled,...E.disabled.reduce((D,M)=>(M!==i.SyncResource.WorkspaceState&&D.push(N.add(E.createSynchronizer(M))),D),[])];for(const D of F){const M=await y(D);if(!(0,w.$mg)(M))return M}}Z(E){const y=this.f;this.f!==E&&(this.f=E,this.g.fire(E),y===i.SyncStatus.HasConflicts&&this.ab())}$(){const E=this.bb().map(y=>y.conflicts).flat();(0,P.$wb)(this.j,E,(y,N)=>y.profile.id===N.profile.id&&y.syncResource===N.syncResource&&(0,P.$wb)(y.conflicts,N.conflicts,(F,D)=>(0,A.$_g)(F.previewResource,D.previewResource)))||(this.j=E,this.m.fire(E))}ab(){this.status===i.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(n,this.t,b.StorageScope.APPLICATION,b.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(E,y){let N=this.z.get(E.id);if(N&&N[0].collection!==y?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.z.delete(E.id)),!N){const F=new k.$Vc,D=F.add(this.G.createInstance(h,E,y?.collection));F.add(D.onDidChangeStatus(M=>this.Z(M))),F.add(D.onDidChangeConflicts(M=>this.$())),F.add(D.onDidChangeLocal(M=>this.h.fire(M))),this.z.set(E.id,N=[D,F])}return N[0]}bb(){const E=[];for(const[y]of this.z.values())E.push(y);return E}cb(){this.z.forEach(([,E])=>E.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$2dc=o,e.$2dc=o=ve([Q(0,$.$_k),Q(1,i.$snb),Q(2,i.$rnb),Q(3,l.$Ei),Q(4,i.$Hnb),Q(5,v.$$l),Q(6,b.$fq),Q(7,i.$Cnb),Q(8,d.$Ll),Q(9,i.$Enb),Q(10,i.$tnb)],o);let h=class extends k.$Wc{get enabled(){return this.f.sort((E,y)=>E[1]-y[1]).map(([E])=>E)}get disabled(){return i.$onb.filter(E=>!this.r.isResourceEnabled(E))}get status(){return this.g}get conflicts(){return this.m}constructor(E,y,N,F,D,M,J,W,x,G){super(),this.profile=E,this.collection=y,this.r=N,this.t=F,this.u=D,this.w=M,this.y=J,this.z=W,this.C=x,this.D=G,this.f=[],this.g=i.SyncStatus.Idle,this.h=this.B(new T.$me),this.onDidChangeStatus=this.h.event,this.j=this.B(new T.$me),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new T.$me),this.onDidChangeConflicts=this.n.event,this.B(N.onDidChangeResourceEnablement(([ie,V])=>this.F(ie,V))),this.B((0,k.$Uc)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of i.$onb)N.isResourceEnabled(ie)&&this.G(ie)}F(E,y){y?this.G(E):this.H(E)}G(E){if(this.f.some(([D])=>D.resource===E))return;if(E===i.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(E===i.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||E===i.SyncResource.WorkspaceState)return;if(E!==i.SyncResource.Profiles&&this.profile.useDefaultFlags?.[E]){this.z.debug(`Skipping syncing ${E} in ${this.profile.name} because it is already synced by default profile`);return}const y=new k.$Vc,N=y.add(this.createSynchronizer(E));y.add(N.onDidChangeStatus(()=>this.L())),y.add(N.onDidChangeConflicts(()=>this.M())),y.add(N.onDidChangeLocal(()=>this.j.fire(E)));const F=this.N(E);this.f.push([N,F,y])}H(E){const y=this.f.findIndex(([N])=>N.resource===E);if(y!==-1){const[[N,,F]]=this.f.splice(y,1);F.dispose(),this.L(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,D=>this.z.error(D))}}createSynchronizer(E){switch(E){case i.SyncResource.Settings:return this.t.createInstance(s.$9bc,this.profile,this.collection);case i.SyncResource.Keybindings:return this.t.createInstance(g.$6bc,this.profile,this.collection);case i.SyncResource.Snippets:return this.t.createInstance(r.$bcc,this.profile,this.collection);case i.SyncResource.Tasks:return this.t.createInstance(t.$ecc,this.profile,this.collection);case i.SyncResource.GlobalState:return this.t.createInstance(I.$2Nb,this.profile,this.collection);case i.SyncResource.Extensions:return this.t.createInstance(p.$1bc,this.profile,this.collection);case i.SyncResource.Profiles:return this.t.createInstance(a.$Ydc,this.profile,this.collection)}}async sync(E,y,N,F){if(F.isCancellationRequested)return[];const D=this.enabled;if(!D.length)return[];try{const M=[],J=(0,i.$wnb)(N),W=(this.collection?E?.collections?.[this.collection]?.latest:E?.latest)??null,x=y?await this.I(W):{};for(const G of D){if(F.isCancellationRequested)return[];if(!this.r.isResourceEnabled(G.resource))return[];try{if(y){const ie=await G.preview(W,x,J);if(ie)for(const V of ie.resourcePreviews)(V.localChange!==i.Change.None||V.remoteChange!==i.Change.None)&&V.mergeState===i.MergeState.Preview&&await G.merge(V.previewResource)}else await G.sync(W,J)}catch(ie){const V=i.$xnb.toUserDataSyncError(ie);if(R(V,N,this.w,this.y),f(ie))throw V;this.z.error(ie),this.z.error(`${G.resource}: ${(0,O.$qj)(ie)}`),M.push([G.resource,V])}}return M}finally{this.L()}}async apply(E,y){const N=(0,i.$wnb)(E);for(const F of this.enabled){if(y.isCancellationRequested)return;try{await F.apply(!1,N)}catch(D){const M=i.$xnb.toUserDataSyncError(D);if(R(M,E,this.w,this.y),f(D))throw M;this.z.error(D),this.z.error(`${F.resource}: ${(0,O.$qj)(D)}`)}}}async stop(){for(const E of this.enabled)try{E.status!==i.SyncStatus.Idle&&await E.stop()}catch(y){this.z.error(y)}}async resetLocal(){for(const E of this.enabled)try{await E.resetLocal()}catch(y){this.z.error(`${E.resource}: ${(0,O.$qj)(y)}`),this.z.error(y)}}async I(E){if(!this.profile.isDefault)return{};const y=this.D.getValue(i.$knb),N=this.enabled.find(F=>F instanceof s.$9bc);if(N){const F=await N.getRemoteUserDataSyncConfiguration(E);return{...y,...F}}return y}J(E){this.g!==E&&(this.g=E,this.h.fire(E))}L(){return this.M(),this.enabled.some(E=>E.status===i.SyncStatus.HasConflicts)?this.J(i.SyncStatus.HasConflicts):this.enabled.some(E=>E.status===i.SyncStatus.Syncing)?this.J(i.SyncStatus.Syncing):this.J(i.SyncStatus.Idle)}M(){const E=this.enabled.filter(y=>y.status===i.SyncStatus.HasConflicts).filter(y=>y.conflicts.conflicts.length>0).map(y=>y.conflicts);(0,P.$wb)(this.m,E,(y,N)=>y.syncResource===N.syncResource&&(0,P.$wb)(y.conflicts,N.conflicts,(F,D)=>(0,A.$_g)(F.previewResource,D.previewResource)))||(this.m=E,this.n.fire(E))}N(E){switch(E){case i.SyncResource.Settings:return 0;case i.SyncResource.Keybindings:return 1;case i.SyncResource.Snippets:return 2;case i.SyncResource.Tasks:return 3;case i.SyncResource.GlobalState:return 4;case i.SyncResource.Extensions:return 5;case i.SyncResource.Profiles:return 6;case i.SyncResource.WorkspaceState:return 7}}};h=ve([Q(2,i.$Cnb),Q(3,l.$Ei),Q(4,u.$ip),Q(5,i.$rnb),Q(6,v.$$l),Q(7,i.$Hnb),Q(8,d.$Ll),Q(9,m.$_i)],h);function f(L){if(L instanceof i.$xnb)switch(L.code){case i.UserDataSyncErrorCode.MethodNotFound:case i.UserDataSyncErrorCode.TooLarge:case i.UserDataSyncErrorCode.TooManyRequests:case i.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case i.UserDataSyncErrorCode.LocalTooManyRequests:case i.UserDataSyncErrorCode.LocalTooManyProfiles:case i.UserDataSyncErrorCode.Gone:case i.UserDataSyncErrorCode.UpgradeRequired:case i.UserDataSyncErrorCode.IncompatibleRemoteContent:case i.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function R(L,E,y,N){N.publicLog2("sync/error",{code:L.code,serverCode:L instanceof i.$ynb?String(L.serverCode):void 0,url:L instanceof i.$ynb?L.url:void 0,resource:L.resource,executionId:E,service:y.userDataSyncStore.url.toString()})}}),define(ce[270],le([0,1,3,2,9,20,25]),function(ne,e,P,c,C,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=e.$lhc=void 0;function k(u,$){return{...u,profile:(0,O.$Ml)(u.profile,$.profilesHome.scheme)}}function A(u){return{created:u.created,uri:C.URI.revive(u.uri)}}class w{constructor($,l,b){this.c=$,this.d=l,this.f=b,this.a=new Map,this.b=new P.$me}listen($,l){switch(l){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call($,l,b){try{return await this.g($,l,b)}catch(v){throw this.f.error(v),v}}async g($,l,b){switch(l){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(C.URI.revive(b[0]));case"accept":return this.c.accept(k(b[0],this.d),C.URI.revive(b[1]),b[2],b[3]);case"replace":return this.c.replace(A(b[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(C.URI.revive(b[0]));case"extractActivityData":return this.c.extractActivityData(C.URI.revive(b[0]),C.URI.revive(b[1]));case"createManualSyncTask":return this.i()}if(l.startsWith("manualSync/")){const v=l.substring(11),d=b[0],p=this.h(d);switch(b=b.slice(1),v){case"merge":return p.merge();case"apply":return p.apply().then(()=>this.a.delete(this.j(p.id)));case"stop":return p.stop().finally(()=>this.a.delete(this.j(p.id)))}}throw new Error("Invalid call")}h($){const l=this.a.get(this.j($));if(!l)throw new Error(`Manual sync taks not found: ${$}`);return l}async i(){const $=await this.c.createManualSyncTask();return this.a.set(this.j($.id),$),$.id}j($){return`manualSyncTask-${$}`}}e.$lhc=w;let S=class extends c.$Wc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor($,l){super(),this.n=l,this.b=T.SyncStatus.Uninitialized,this.c=this.B(new P.$me),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new P.$me),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new P.$me),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new P.$me),this.onSyncErrors=this.m.event,this.a={call(b,v,d){return $.call(b,v,d).then(null,p=>{throw T.$xnb.toUserDataSyncError(p)})},listen(b,v){return $.listen(b,v)}},this.a.call("_getInitialData").then(([b,v,d])=>{this.s(b),this.t(v),d&&this.u(d),this.B(this.a.listen("onDidChangeStatus")(p=>this.s(p))),this.B(this.a.listen("onDidChangeLastSyncTime")(p=>this.u(p)))}),this.B(this.a.listen("onDidChangeConflicts")(b=>this.t(b))),this.B(this.a.listen("onSyncErrors")(b=>this.m.fire(b.map(v=>({...v,error:T.$xnb.toUserDataSyncError(v.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const $=await this.a.call("createManualSyncTask"),l=this;return new m($,{async call(v,d,p){return l.a.call(`manualSync/${v}`,[$,...Array.isArray(d)?d:[d]],p)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept($,l,b,v){return this.a.call("accept",[$,l,b,v])}resolveContent($){return this.a.call("resolveContent",[$])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace($){return this.a.call("replace",[$])}saveRemoteActivityData($){return this.a.call("getRemoteActivityData",[$])}extractActivityData($,l){return this.a.call("extractActivityData",[$,l])}async s($){this.b=$,this.c.fire($)}async t($){this.f=$.map(l=>({syncResource:l.syncResource,profile:(0,O.$Ml)(l.profile,this.n.profilesHome.scheme),conflicts:l.conflicts.map(b=>({...b,baseResource:C.URI.revive(b.baseResource),localResource:C.URI.revive(b.localResource),remoteResource:C.URI.revive(b.remoteResource),previewResource:C.URI.revive(b.previewResource)}))})),this.g.fire(this.f)}u($){this.h!==$&&(this.h=$,this.j.fire($))}};e.$mhc=S,e.$mhc=S=ve([Q(1,O.$Ll)],S);class m extends c.$Wc{constructor($,l){super(),this.id=$,this.a=l}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(ce[127],le([0,1,6,26,8,3,2,147,5,21,13,9,32,22,16,7,24,62,50,17,25]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RNb=e.$QNb=e.$PNb=e.$ONb=e.$NNb=void 0;const s="configurationSync.store",r="sync.previous.store",t="sync.donot-make-requests-until",a="sync.user-session-id",i="sync.machine-session-id",n=100,o=1e3*60*5;let h=class extends T.$Wc{get userDataSyncStore(){return this.b}get c(){return this.h.get(g.$Anb,I.StorageScope.APPLICATION)}set c(N){this.h.store(g.$Anb,N,I.StorageScope.APPLICATION,A.$o?I.StorageTarget.USER:I.StorageTarget.MACHINE)}constructor(N,F,D){super(),this.f=N,this.g=F,this.h=D,this.a=this.B(new O.$me),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const M=this.B(new T.$Vc);this.B(O.Event.filter(D.onDidChangeValue(I.StorageScope.APPLICATION,g.$Anb,M),()=>this.c!==this.userDataSyncStore?.type,M)(()=>this.j()))}j(){this.b=this.m(this.f[s]),this.a.fire()}m(N){if(N&&(N=A.$o&&N.web?{...N,...N.web}:N,(0,S.$fg)(N.url)&&(0,S.$hg)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(F=>Array.isArray(N.authenticationProviders[F].scopes)))){const F=N,D=!!F.canSwitch,M=F.url===F.insidersUrl?"insiders":"stable",J=(D?this.c:void 0)||M,W=J==="insiders"?F.insidersUrl:J==="stable"?F.stableUrl:F.url;return{url:m.URI.parse(W),type:J,defaultType:M,defaultUrl:m.URI.parse(F.url),stableUrl:m.URI.parse(F.stableUrl),insidersUrl:m.URI.parse(F.insidersUrl),canSwitch:D,authenticationProviders:Object.keys(F.authenticationProviders).reduce((x,G)=>(x.push({id:G,scopes:F.authenticationProviders[G].scopes}),x),[])}}}};e.$NNb=h,e.$NNb=h=ve([Q(0,v.$sk),Q(1,$.$_i),Q(2,I.$fq)],h);let f=class extends h{constructor(N,F,D){super(N,F,D);const M=this.h.get(r,I.StorageScope.APPLICATION);M&&(this.n=JSON.parse(M));const J=this.f[s];J?this.h.store(r,JSON.stringify(J),I.StorageScope.APPLICATION,I.StorageTarget.MACHINE):this.h.remove(r,I.StorageScope.APPLICATION)}async switch(N){N!==this.c&&(this.c=N,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$ONb=f,e.$ONb=f=ve([Q(0,v.$sk),Q(1,$.$_i),Q(2,I.$fq)],f);let R=class extends T.$Wc{get donotMakeRequestsUntil(){return this.j}constructor(N,F,D,M,J,W,x){super(),this.n=D,this.r=M,this.s=x,this.g=this.B(new O.$me),this.onTokenFailed=this.g.event,this.h=this.B(new O.$me),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new O.$me),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(N),this.c=(0,p.$lq)(J,W,x).then(G=>{const ie={"X-Client-Name":`${F.applicationName}${A.$o?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(ie["X-Client-Commit"]=F.commit),ie}),this.f=new E(n,o,this.n,this.r),this.u(),this.B((0,T.$Uc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(N,F){this.b={token:N,type:F}}t(N){this.a=N?(0,w.$gh)(N,"v1"):void 0}u(){const N=this.s.getNumber(t,I.StorageScope.APPLICATION);N&&Date.now()<N&&this.y(new Date(N))}y(N){this.j?.getTime()!==N?.getTime()&&(this.j=N,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(t,this.j.getTime(),I.StorageScope.APPLICATION,I.StorageTarget.MACHINE),this.w=(0,P.$sh)(F=>(0,P.$Gh)(this.j.getTime()-Date.now(),F).then(()=>this.y(void 0))),this.w.then(null,F=>null)):this.s.remove(t,I.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,w.$gh)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const D=await this.D(F,{type:"GET",headers:N},[],c.CancellationToken.None);return(await(0,d.$$p)(D))?.map(({id:M})=>M)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,w.$gh)(this.a,"collection").toString();N={...N},N["Content-Type"]=k.$8s.text;const D=await this.D(F,{type:"POST",headers:N},[],c.CancellationToken.None),M=await(0,d.$0p)(D);if(!M)throw new g.$ynb("Server did not return the collection id",F,g.UserDataSyncErrorCode.NoCollection,D.res.statusCode,D.res.headers[g.$unb]);return M}async deleteCollection(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const D=N?(0,w.$gh)(this.a,"collection",N).toString():(0,w.$gh)(this.a,"collection").toString();F={...F},await this.D(D,{type:"DELETE",headers:F},[],c.CancellationToken.None)}async getAllResourceRefs(N,F){if(!this.a)throw new Error("No settings sync store url configured.");const D=this.z(this.a,F,N),M={},J=await this.D(D.toString(),{type:"GET",headers:M},[],c.CancellationToken.None);return(await(0,d.$$p)(J)||[]).map(({url:x,created:G})=>({ref:(0,w.$ih)(D,D.with({path:x})),created:G*1e3}))}async resolveResourceContent(N,F,D,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=(0,w.$gh)(this.z(this.a,D,N),F).toString();M={...M},M["Cache-Control"]="no-cache";const W=await this.D(J,{type:"GET",headers:M},[],c.CancellationToken.None);return await(0,d.$0p)(W)}async deleteResource(N,F,D){if(!this.a)throw new Error("No settings sync store url configured.");const M=F!==null?(0,w.$gh)(this.z(this.a,D,N),F).toString():this.z(this.a,D,N).toString(),J={};await this.D(M,{type:"DELETE",headers:J},[],c.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,w.$gh)(this.a,"resource").toString(),F={"Content-Type":k.$8s.text};await this.D(N,{type:"DELETE",headers:F},[],c.CancellationToken.None)}async readResource(N,F,D,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=(0,w.$gh)(this.z(this.a,D,N),"latest").toString();M={...M},M["Cache-Control"]="no-cache",F&&(M["If-None-Match"]=F.ref);const W=await this.D(J,{type:"GET",headers:M},[304],c.CancellationToken.None);let x=null;if(W.res.statusCode===304&&(x=F),x===null){const G=W.res.headers.etag;if(!G)throw new g.$ynb("Server did not return the ref",J,g.UserDataSyncErrorCode.NoRef,W.res.statusCode,W.res.headers[g.$unb]);const ie=await(0,d.$0p)(W);if(!ie&&W.res.statusCode===304)throw new g.$ynb("Empty response",J,g.UserDataSyncErrorCode.EmptyResponse,W.res.statusCode,W.res.headers[g.$unb]);x={ref:G,content:ie}}return x}async writeResource(N,F,D,M,J={}){if(!this.a)throw new Error("No settings sync store url configured.");const W=this.z(this.a,M,N).toString();J={...J},J["Content-Type"]=k.$8s.text,D&&(J["If-Match"]=D);const x=await this.D(W,{type:"POST",data:F,headers:J},[],c.CancellationToken.None),G=x.res.headers.etag;if(!G)throw new g.$ynb("Server did not return the ref",W,g.UserDataSyncErrorCode.NoRef,x.res.statusCode,x.res.headers[g.$unb]);return G}async manifest(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const D=(0,w.$gh)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",N&&(F["If-None-Match"]=N.ref);const M=await this.D(D,{type:"GET",headers:F},[304],c.CancellationToken.None);let J=null;if(M.res.statusCode===304&&(J=N),!J){const x=M.res.headers.etag;if(!x)throw new g.$ynb("Server did not return the ref",D,g.UserDataSyncErrorCode.NoRef,M.res.statusCode,M.res.headers[g.$unb]);const G=await(0,d.$0p)(M);if(!G&&M.res.statusCode===304)throw new g.$ynb("Empty response",D,g.UserDataSyncErrorCode.EmptyResponse,M.res.statusCode,M.res.headers[g.$unb]);G&&(J={...JSON.parse(G),ref:x})}const W=this.s.get(a,I.StorageScope.APPLICATION);return W&&J&&W!==J.session&&this.C(),J===null&&W&&this.C(),J&&this.s.store(a,J.session,I.StorageScope.APPLICATION,I.StorageTarget.MACHINE),J}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,w.$gh)(this.a,"download").toString(),F={},D=await this.D(N,{type:"GET",headers:F},[],c.CancellationToken.None);if(!(0,d.$7p)(D))throw new g.$ynb("Server returned "+D.res.statusCode,N,g.UserDataSyncErrorCode.EmptyResponse,D.res.statusCode,D.res.headers[g.$unb]);if((0,d.$8p)(D))throw new g.$ynb("Empty response",N,g.UserDataSyncErrorCode.EmptyResponse,D.res.statusCode,D.res.headers[g.$unb]);return D.stream}z(N,F,D){return F?(0,w.$gh)(N,"collection",F,"resource",D):(0,w.$gh)(N,"resource",D)}C(){this.s.remove(a,I.StorageScope.APPLICATION),this.s.remove(i,I.StorageScope.APPLICATION)}async D(N,F,D,M){if(!this.b)throw new g.$ynb("No Auth Token Available",N,g.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new g.$ynb(`${F.type} request '${N}' failed because of too many requests (429).`,N,g.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const J=await this.c;F.headers={...F.headers||{},...J,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(F.headers),this.r.trace("Sending request to server",{url:N,type:F.type,headers:{...F.headers,authorization:void 0}});let W;try{W=await this.f.request(N,F,M)}catch(z){if(!(z instanceof g.$ynb)){let te=g.UserDataSyncErrorCode.RequestFailed;const se=(0,C.$_)(z).toLowerCase();se.includes("xhr timeout")?te=g.UserDataSyncErrorCode.RequestTimeout:se.includes("protocol")&&se.includes("not supported")?te=g.UserDataSyncErrorCode.RequestProtocolNotSupported:se.includes("request path contains unescaped characters")?te=g.UserDataSyncErrorCode.RequestPathNotEscaped:se.includes("headers must be an object")?te=g.UserDataSyncErrorCode.RequestHeadersNotObject:(0,C.$6)(z)&&(te=g.UserDataSyncErrorCode.RequestCanceled),z=new g.$ynb(`Connection refused for the request '${N}'.`,N,te,void 0,void 0)}throw this.r.info("Request failed",N),z}const x=W.res.headers[g.$unb],G={url:N,status:W.res.statusCode,"execution-id":F.headers[g.$vnb],"operation-id":x},ie=(0,d.$7p)(W)||W.res.statusCode&&D.includes(W.res.statusCode);let V="";if(ie?this.r.trace("Request succeeded",G):(V=await(0,d.$9p)(W)||"",this.r.info("Request failed",G,V)),W.res.statusCode===401||W.res.statusCode===403){if(this.b=void 0,W.res.statusCode===401)throw this.g.fire(g.UserDataSyncErrorCode.Unauthorized),new g.$ynb(`${F.type} request '${N}' failed because of Unauthorized (401).`,N,g.UserDataSyncErrorCode.Unauthorized,W.res.statusCode,x);if(W.res.statusCode===403)throw this.g.fire(g.UserDataSyncErrorCode.Forbidden),new g.$ynb(`${F.type} request '${N}' failed because the access is forbidden (403).`,N,g.UserDataSyncErrorCode.Forbidden,W.res.statusCode,x)}if(this.h.fire(),W.res.statusCode===404)throw new g.$ynb(`${F.type} request '${N}' failed because the requested resource is not found (404).`,N,g.UserDataSyncErrorCode.NotFound,W.res.statusCode,x);if(W.res.statusCode===405)throw new g.$ynb(`${F.type} request '${N}' failed because the requested endpoint is not found (405). ${V}`,N,g.UserDataSyncErrorCode.MethodNotFound,W.res.statusCode,x);if(W.res.statusCode===409)throw new g.$ynb(`${F.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,g.UserDataSyncErrorCode.Conflict,W.res.statusCode,x);if(W.res.statusCode===410)throw new g.$ynb(`${F.type} request '${N}' failed because the requested resource is not longer available (410).`,N,g.UserDataSyncErrorCode.Gone,W.res.statusCode,x);if(W.res.statusCode===412)throw new g.$ynb(`${F.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,g.UserDataSyncErrorCode.PreconditionFailed,W.res.statusCode,x);if(W.res.statusCode===413)throw new g.$ynb(`${F.type} request '${N}' failed because of too large payload (413).`,N,g.UserDataSyncErrorCode.TooLarge,W.res.statusCode,x);if(W.res.statusCode===426)throw new g.$ynb(`${F.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,g.UserDataSyncErrorCode.UpgradeRequired,W.res.statusCode,x);if(W.res.statusCode===429){const z=W.res.headers["retry-after"];throw z?(this.y(new Date(Date.now()+parseInt(z)*1e3)),new g.$ynb(`${F.type} request '${N}' failed because of too many requests (429).`,N,g.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,W.res.statusCode,x)):new g.$ynb(`${F.type} request '${N}' failed because of too many requests (429).`,N,g.UserDataSyncErrorCode.TooManyRequests,W.res.statusCode,x)}if(!ie)throw new g.$ynb("Server returned "+W.res.statusCode,N,g.UserDataSyncErrorCode.Unknown,W.res.statusCode,x);return W}F(N){let F=this.s.get(i,I.StorageScope.APPLICATION);F===void 0&&(F=(0,u.$2g)(),this.s.store(i,F,I.StorageScope.APPLICATION,I.StorageTarget.MACHINE)),N["X-Machine-Session-Id"]=F;const D=this.s.get(a,I.StorageScope.APPLICATION);D!==void 0&&(N["X-User-Session-Id"]=D)}};e.$PNb=R,e.$PNb=R=ve([Q(1,v.$sk),Q(2,d.$5p),Q(3,g.$Hnb),Q(4,l.$Mi),Q(5,b.$_k),Q(6,I.$fq)],R);let L=class extends R{constructor(N,F,D,M,J,W,x){super(N.userDataSyncStore?.url,F,D,M,J,W,x),this.B(N.onDidChangeUserDataSyncStore(()=>this.t(N.userDataSyncStore?.url)))}};e.$QNb=L,e.$QNb=L=ve([Q(0,g.$rnb),Q(1,v.$sk),Q(2,d.$5p),Q(3,g.$Hnb),Q(4,l.$Mi),Q(5,b.$_k),Q(6,I.$fq)],L);class E{constructor(N,F,D,M){this.c=N,this.d=F,this.f=D,this.g=M,this.a=[],this.b=void 0}request(N,F,D){if(this.h()&&this.i(),F.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new g.$ynb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,g.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(F,D)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$RNb=E}),define(ce[271],le([0,1,3,2,9,22,24,17,127]),function(ne,e,P,c,C,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=e.$ihc=e.$hhc=void 0;class w{constructor(l){this.a=l}listen(l,b){switch(b){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${b}`)}call(l,b,v){switch(b){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(v)}throw new Error("Invalid call")}}e.$hhc=w;class S extends c.$Wc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(l){super(),this.c=l,this.b=this.B(new P.$me),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(b=>{this.a=b,this.B(this.c.listen("onDidChangeAccount")(v=>{this.a=v,this.b.fire(v)}))})}updateAccount(l){return this.c.call("updateAccount",l)}}e.$ihc=S;class m{constructor(l){this.a=l}listen(l,b){switch(b){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${b}`)}call(l,b,v){switch(b){case"switch":return this.a.switch(v[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$jhc=m;let u=class extends A.$NNb{constructor(l,b,v,d){super(b,v,d),this.n=l,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(l){return this.n.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.n.call("getPreviousUserDataSyncStore");return this.r(l)}r(l){return{url:C.URI.revive(l.url),type:l.type,defaultUrl:C.URI.revive(l.defaultUrl),insidersUrl:C.URI.revive(l.insidersUrl),stableUrl:C.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.$khc=u,e.$khc=u=ve([Q(1,T.$sk),Q(2,O.$_i),Q(3,k.$fq)],u)}),define(ce[272],le([0,1,3,58,24,17,18,267,25,83,87]),function(ne,e,P,c,C,O,T,k,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;let m=class extends k.$3dc{constructor($,l,b,v,d,p,I,g,s,r,t){super($,l,b,v,d,I,g,s,r,t),this.B(P.Event.debounce(P.Event.any(P.Event.map(p.onDidFocusMainWindow,()=>"windowFocus"),P.Event.map(p.onDidOpenMainWindow,()=>"windowOpen")),(a,i)=>a?[...a,i]:[i],1e3)(a=>this.triggerSync(a,!0,!1)))}};e.$Ghc=m,e.$Ghc=m=ve([Q(0,C.$sk),Q(1,A.$rnb),Q(2,A.$snb),Q(3,A.$Cnb),Q(4,A.$Dnb),Q(5,c.$Cfc),Q(6,A.$Hnb),Q(7,w.$dMb),Q(8,T.$$l),Q(9,S.$fnb),Q(10,O.$fq)],m)}),define(ce[273],le([0,1,76,23,5,21]),function(ne,e,P,c,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=void 0,e.$4ec=T,e.$5ec=k,e.$6ec=A,e.$3ec=128/4;function T(w){function S(){let m=w.scheme===c.Schemas.file?(0,O.$7g)(w):w.toString();return C.$k||(m=m.toLowerCase()),(0,P.createHash)("md5").update(m).digest("hex")}return{id:S(),configPath:w}}function k(w,S){function m(){if(w.scheme!==c.Schemas.file)return(0,P.createHash)("md5").update(w.toString()).digest("hex");if(!S)return;let $;return C.$k?$=S.ino:C.$j?$=S.birthtime.getTime():C.$i&&(typeof S.birthtimeMs=="number"?$=Math.floor(S.birthtimeMs):$=S.birthtime.getTime()),(0,P.createHash)("md5").update(w.fsPath).update($?String($):"").digest("hex")}const u=m();if(typeof u=="string")return{id:u,uri:w}}function A(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ce[274],le([0,1,6,8,2,14,31,16,10,80,116,273,58,57,23]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;let b=class extends C.$Wc{constructor(d,p,I,g){super(),this.a=d,this.b=p,this.c=I,this.f=g,this.B(new P.$Rh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const d=this.a.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,p=await T.Promises.readdir(d),I=new w.$OMb(this.f.getChannel("storage"));await Promise.all(p.map(async g=>{const s=(0,O.$lc)(d,g);g.length===m.$3ec||g===S.$Ri.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(a=>a.workspace?.id===g)||await I.isUsed(s)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await T.Promises.rm(s))}))}catch(d){(0,c.$3)(d)}}};e.$dhc=b,e.$dhc=b=ve([Q(0,k.$Ni),Q(1,A.$_j),Q(2,u.$Cfc),Q(3,$.$Ugc)],b)}),define(ce[128],le([0,1,76,67,38,282,15,8,3,2,14,5,32,43,71]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$wi=e.$vi=e.$ui=void 0,e.$xi=i,e.$yi=n,e.$Ai=f,e.$Bi=R;const b=3e4;class v{traceSocketEvent(E,y){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,y)}constructor(E,y=""){this.f=!0,this.debugLabel=y,this.socket=E,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=F=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,k.$3)(F)}},this.socket.on("error",this.a);let N;this.b=F=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:F}),this.f=!1,N&&clearTimeout(N)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,N=setTimeout(()=>E.destroy(),b)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const y=N=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,N),E(T.$Oe.wrap(N))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(E){const y=N=>{E({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:N,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(E){const y=()=>{E()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,E),this.socket.write(E.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,k.$3)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,k.$3)(y)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((E,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),E();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),E()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.$ui=v;var d;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var p;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(p||(p={}));class I extends w.$Wc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,y){this.socket.traceSocketEvent(E,y)}constructor(E,y,N,F){super(),this.f=this.B(new A.$me),this.g=this.B(new A.$me),this.h=!1,this.j={state:p.PeekHeader,readLen:d.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:N?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new g(this,y,N,F,this.f,(D,M)=>this.m(D,M))),this.B(this.a.onError(D=>{console.error(D),(0,k.$3)(D),this.g.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:D})})),this.b=new l.$pi,this.B(this.socket.onData(D=>this.n(D))),this.B(this.socket.onClose(async D=>{this.a.isProcessingReadQueue()&&await A.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(D)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let y=0;for(;y<E.byteLength;)this.a.writeMessage(E.slice(y,Math.min(y+d.MaxWebSocketMessageLength,E.byteLength)),{compressed:!0,opcode:2}),y+=d.MaxWebSocketMessageLength}m(E,{compressed:y,opcode:N}){if(this.h)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,E);let F=d.MinHeaderByteSize;E.byteLength<126?F+=0:E.byteLength<2**16?F+=2:F+=8;const D=T.$Oe.alloc(F),M=y?64:0,J=N&15;if(D.writeUInt8(128|M|J,0),E.byteLength<126)D.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){D.writeUInt8(126,1);let W=1;D.writeUInt8(E.byteLength>>>8&255,++W),D.writeUInt8(E.byteLength>>>0&255,++W)}else{D.writeUInt8(127,1);let W=1;D.writeUInt8(0,++W),D.writeUInt8(0,++W),D.writeUInt8(0,++W),D.writeUInt8(0,++W),D.writeUInt8(E.byteLength>>>24&255,++W),D.writeUInt8(E.byteLength>>>16&255,++W),D.writeUInt8(E.byteLength>>>8&255,++W),D.writeUInt8(E.byteLength>>>0&255,++W)}this.socket.write(T.$Oe.concat([D,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===p.PeekHeader){const y=this.b.peek(this.j.readLen),N=y.readUInt8(0),F=(N&128)>>>7,D=(N&64)>>>6,M=N&15,J=y.readUInt8(1),W=(J&128)>>>7,x=J&127;this.j.state=p.ReadHeader,this.j.readLen=d.MinHeaderByteSize+(W?4:0)+(x===126?2:0)+(x===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!D),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===p.ReadHeader){const y=this.b.read(this.j.readLen),N=y.readUInt8(1),F=(N&128)>>>7;let D=N&127,M=1;D===126?D=y.readUInt8(++M)*2**8+y.readUInt8(++M):D===127&&(D=y.readUInt8(++M)*0+y.readUInt8(++M)*0+y.readUInt8(++M)*0+y.readUInt8(++M)*0+y.readUInt8(++M)*2**24+y.readUInt8(++M)*2**16+y.readUInt8(++M)*2**8+y.readUInt8(++M));let J=0;F&&(J=y.readUInt8(++M)*2**24+y.readUInt8(++M)*2**16+y.readUInt8(++M)*2**8+y.readUInt8(++M)),this.j.state=p.ReadBody,this.j.readLen=D,this.j.mask=J,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===p.ReadBody){const y=this.b.read(this.j.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,y),t(y,this.j.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,y),this.j.state=p.PeekHeader,this.j.readLen=d.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await A.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$vi=I;class g extends w.$Wc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Oe.alloc(0)}constructor(E,y,N,F,D,M){super(),this.n=E,this.r=D,this.s=M,this.a=this.B(new A.$me),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new A.$me),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new A.$me),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new s(this.n,F,N,{windowBits:15})),this.f=this.B(new r(this.n,{windowBits:15})),this.B(this.b.onError(J=>this.a.fire(J))),this.B(this.f.onError(J=>this.a.fire(J)))):(this.b=null,this.f=null)}writeMessage(E,y){this.g.push({data:E,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:y}=this.g.shift();if(this.f&&y.compressed){const N=await this.w(this.f,E);this.s(N,y)}else this.s(E,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,y){return new Promise((N,F)=>{E.write(y),E.flush(D=>N(D))})}acceptFrame(E,y,N){this.h.push({data:E,isCompressed:y,isLastFrameOfMessage:N}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const y=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,y,N){return new Promise((F,D)=>{E.write(y),N&&E.write(T.$Oe.fromByteArray([0,0,255,255])),E.flush(M=>F(M))})}}class s extends w.$Wc{get recordedInflateBytes(){return this.j?T.$Oe.concat(this.f):T.$Oe.alloc(0)}constructor(E,y,N,F){super(),this.h=E,this.j=y,this.a=this.B(new A.$me),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(F),this.b.on("error",D=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,D),this.g.push(T.$Oe.wrap(D))}),N&&(this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,N.buffer),this.b.write(N.buffer),this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const y=T.$Oe.concat(this.g);this.g.length=0,E(y)})}}class r extends w.$Wc{constructor(E,y){super(),this.g=E,this.a=this.B(new A.$me),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",N=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,N),this.f.push(T.$Oe.wrap(N))})}write(E){this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let y=T.$Oe.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),E(y)})}}function t(L,E){if(E===0)return;const y=L.byteLength>>>2;for(let W=0;W<y;W++){const x=L.readUInt32BE(W*4);L.writeUInt32BE(x^E,W*4)}const N=y*4,F=L.byteLength-N,D=E>>>24&255,M=E>>>16&255,J=E>>>8&255;F>=1&&L.writeUInt8(L.readUInt8(N)^D,N),F>=2&&L.writeUInt8(L.readUInt8(N+1)^M,N+1),F>=3&&L.writeUInt8(L.readUInt8(N+2)^J,N+2)}e.$wi=process.env.XDG_RUNTIME_DIR;const a={[m.Platform.Linux]:107,[m.Platform.Mac]:103};function i(){const L=(0,u.$2g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const E=process.platform!=="darwin"&&e.$wi?e.$wi:(0,C.tmpdir)(),y=(0,S.$lc)(E,`vscode-ipc-${L}.sock`);return o(y),y}function n(L,E,y){const F=(0,P.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${y}-${E}-sock`;const D=y.substr(0,4),M=E.substr(0,6);let J;return process.platform!=="darwin"&&e.$wi&&!process.env.VSCODE_PORTABLE?J=(0,S.$lc)(e.$wi,`vscode-${F}-${D}-${M}.sock`):J=(0,S.$lc)(L,`${D}-${M}.sock`),o(J),J}function o(L){const E=a[m.$u];typeof E=="number"&&L.length>=E&&console.warn(`WARNING: IPC handle "${L}" is longer than ${E} chars, try a shorter --user-data-dir`)}class h extends $.$ji{static b(E){const y=A.Event.fromNodeEventEmitter(E,"connection");return A.Event.map(y,N=>({protocol:new l.$qi(new v(N,"ipc-server-connection")),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(N,"close"))}))}constructor(E){super(h.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$zi=h;function f(L){return new Promise((E,y)=>{const N=(0,c.createServer)();N.on("error",y),N.listen(L,()=>{N.removeListener("error",y),E(new h(N))})})}function R(L,E){return new Promise((y,N)=>{const F=(0,c.createConnection)(L,()=>{F.removeListener("error",N),y(l.$ri.fromSocket(new v(F,`ipc-client${E}`),E))});F.once("error",N)})}}),define(ce[275],le([0,1,67,128,222]),function(ne,e,P,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=void 0,P=Oe(P),e.$Jhc=new class{supports(O){return!0}connect({host:O,port:T},k,A,w){return new Promise((S,m)=>{const u=P.createConnection({host:O,port:T},()=>{u.removeListener("error",m),u.write((0,C.$bxb)(k,A,w));const $=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(u.off("data",$),S(new c.$ui(u,w)))};u.on("data",$)});u.setNoDelay(!0),u.once("error",m)})}}}),define(ce[276],le([0,1,67,38,139,128,6,2,5,22,10,24,223,107,109,81,15]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=e.$Mgc=e.$Lgc=void 0,P=Oe(P),c=Oe(c);async function d(r,t,a,i,n){let o;for(let h=3;h&&(o?.dispose(),o=await new p(r,t,a,i,n).waitForReady(),!(n&&C.$5g[n]||!C.$5g[o.tunnelLocalPort]));h--);return o}class p extends k.$Wc{constructor(t,a,i,n,o){super(),this.m=a,this.n=o,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=t,this.b=P.createServer(),this.c=new T.$Eh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=h=>this.r(h),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(a=>{a()})}async waitForReady(){const t=this.n??this.tunnelRemotePort,a=(0,b.$Iw)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,C.$6g)(t,2,1e3,a),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(t){t.pause();const a=(0,b.$Gw)(this.tunnelRemoteHost)||(0,b.$Iw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,u.$2l)(this.a,a,this.tunnelRemotePort),n=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&t.write(o.buffer),t.on("end",()=>{t.localAddress&&this.j.delete(t.localAddress),n.end()}),t.on("close",()=>n.end()),t.on("error",()=>{t.localAddress&&this.j.delete(t.localAddress),n instanceof O.$ui?n.socket.destroy():n.end()}),n instanceof O.$ui?this.t(t,n):this.s(t,n),t.localAddress&&this.j.set(t.localAddress,()=>{t.end(),n.end()})}s(t,a){a.onClose(()=>t.destroy()),a.onEnd(()=>t.end()),a.onData(i=>t.write(i.buffer)),t.on("data",i=>a.write(v.$Oe.wrap(i))),t.resume()}t(t,a){const i=a.socket;i.on("end",()=>t.end()),i.on("close",()=>t.end()),i.on("error",()=>{t.destroy()}),i.pipe(t),t.pipe(i)}}e.$Lgc=p;let I=class extends b.$Lw{constructor(t,a,i,n,o){super(a,o),this.H=t,this.I=i,this.J=n}isPortPrivileged(t){return(0,b.$Jw)(t,this.t,A.OS,c.release())}F(t,a,i,n,o,h,f,R){const L=this.D(a,i);if(L)return++L.refcount,L.value;if((0,b.$Cw)(t))return this.G(t,a,i,o,h,f,R);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${i} on local port ${o}.`);const E={commit:this.J.commit,quality:this.J.quality,addressProvider:t,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},y=d(E,n,a,i,o);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(a,i,y),y}}};e.$Mgc=I,e.$Mgc=I=ve([Q(0,$.$Vl),Q(1,S.$_j),Q(2,l.$Yl),Q(3,m.$sk),Q(4,w.$_i)],I);let g=class extends I{constructor(t,a,i,n,o){super(t,a,i,n,o)}};e.$Ngc=g,e.$Ngc=g=ve([Q(0,$.$Vl),Q(1,S.$_j),Q(2,l.$Yl),Q(3,m.$sk),Q(4,w.$_i)],g);let s=class extends k.$Wc{constructor(t,a,i,n,o){super(),this.b=t,this.c=a,this.f=i,this.g=n,this.h=o,this.a=new Map}async openTunnel(t,a,i,n,o,h,f,R,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${h}.`),!this.a.has(t)){const E=new g(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(t,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(t))})}return this.a.get(t).openTunnel(a,i,n,o,h,f,R,L)}};e.$Ogc=s,e.$Ogc=s=ve([Q(0,$.$Vl),Q(1,S.$_j),Q(2,m.$sk),Q(3,l.$Yl),Q(4,w.$_i)],s)});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(ce[283],le([0,1,38,41,8,2,23,9,19,3,43,157,216,217,226,208,274,199,200,22,221,98,233,99,228,16,119,260,28,111,224,118,75,7,210,211,74,4,207,77,79,236,10,212,103,24,62,17,110,18,112,113,114,49,239,86,115,25,83,266,271,249,87,265,269,270,127,63,264,250,109,232,81,276,227,240,29,241,5,242,201,219,218,85,255,20,53,215,59,263,238,251,108,268,256,11,213,102,261,254,229,195,58,214,272,258,57,262,107,105,275,193,230,153,146,151]),function(ne,e,P,c,C,O,T,k,A,w,S,m,u,$,l,b,v,d,p,I,g,s,r,t,a,i,n,o,h,f,R,L,E,y,N,F,D,M,J,W,x,G,ie,V,z,te,se,he,q,Z,K,H,U,Y,B,j,_,ee,X,oe,ue,ge,be,Ie,pe,we,Ee,Se,ae,de,me,Pe,ke,Fe,Te,Ce,Ue,qe,He,Me,Be,ze,We,Le,re,fe,$e,ye,Ae,Ne,je,xe,Ke,Ye,Ve,_e,Qe,nt,at,Ct,Lt,Nt,Tt,Dt,Ut,Ft,yt,Mt,vt,jt,qt,Bt,ht,zt,Wt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=St,z=it(z);class Vt extends O.$Wc{constructor(Re){super(),this.f=Re,this.a=this.B(new m.$SX(this)),this.b=void 0,this.c=this.B(new w.$me),this.g()}g(){let Re=!1;const De=()=>{Re||(Re=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",De),(0,m.$TX)(process.parentPort,ht.$Yfc.exit,De)}async init(){const Re=await this.h();(0,ee.$mnb)(),Re.invokeFunction(De=>{const Je=De.get(ie.$_j),Ge=De.get(Z.$$l),et=De.get(fe.$Ll);Je.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(De),this.m(Je),this.n(Ge,et),this.B(et.onDidChangeProfiles(()=>this.n(Ge,et))),this.r(Ge,Je)}),this.B((0,O.$Tc)(Re.createInstance(u.$_gc,this.f.codeCachePath),Re.createInstance($.$ahc),Re.createInstance(v.$dhc),Re.createInstance(b.$chc),Re.createInstance(l.$bhc),Re.createInstance(Ve.$Ahc),Re.createInstance(xe.$shc)))}async h(){const Re=new W.$Di,De={_serviceBrand:void 0,...z.default};Re.set(te.$sk,De);const Je=new S.$ni(Ze=>Ze==="main"),Ge=new yt.$Vgc(this.a,Je);Re.set(yt.$Ugc,Ge);const et=this.f.policiesData?new ye.$pgc(this.f.policiesData,Ge.getChannel("policy")):new Ae.$uo;Re.set(Ae.$so,et);const Xe=new Bt.$8m(this.f.args,De);Re.set(i.$Ni,Xe);const ot=new V.$qs(void 0,this.f.logLevel,Xe.logsHome,this.f.loggers.map(Ze=>({...Ze,resource:k.URI.revive(Ze.resource)})),Ge.getChannel("logger"));Re.set(ie.$ak,ot);const ft=this.B(ot.createLogger("sharedprocess",{name:(0,_e.localize)(0,null)})),$t=this.B(new ie.$hk(ft.getLevel())),tt=this.B(new Qe.$oR(ft,[$t]));Re.set(ie.$_j,tt),this.b=this.B(new nt.$Chc(tt)),Re.set(nt.$Bhc,this.b);const st=this.B(new N.$Zq(tt));Re.set(y.$_k,st);const pt=this.B(new F.$qr(tt));st.registerProvider(T.Schemas.file,pt);const dt=new qe.$Rs(st);Re.set(Ue.$Jl,dt);const rt=this.B(new Ne.$vR(this.f.profiles.all,k.URI.revive(this.f.profiles.home).with({scheme:Xe.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));Re.set(fe.$Ll,rt);const wt=this.B(new Me.$Tgc(T.Schemas.file,this.B(new Be.$0Q(Ge.getChannel(Be.$9Q),{pathCaseSensitive:He.$k})),T.Schemas.vscodeUserData,rt,dt,tt));st.registerProvider(T.Schemas.vscodeUserData,wt);const ct=this.B(new g.$Uo(rt.defaultProfile.settingsResource,st,et,tt));Re.set(I.$_i,ct);const bt=new Mt.$Ihc(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},Ge,Xe);Re.set(he.$fq,bt),this.B((0,O.$Uc)(()=>bt.flush())),await Promise.all([ct.initialize(),bt.initialize()]);const It=new Lt.$as(Ge.getChannel("request"));Re.set(se.$5p,It),Re.set(d.$ehc,new D.$Ci(p.$fhc,void 0,!1)),Re.set(We.$NG,new D.$Ci(ze.$rhc,void 0,!1));const Rt=new Dt.$Xgc(-1,Ge);Re.set(Tt.$Cfc,Rt),Re.set(t.$Yo,new D.$Ci(a.$DR,void 0,!0));const Gt=this.B(new de.$mgc(Rt)),Jt=new S.$ni(Ze=>Gt.getActiveClientId().then(mt=>Ze===mt));Re.set(E.$D6b,new Nt.$Ehc(this.a.getChannel("extensionRecommendationNotification",Jt)));let gt;const lt=[],Pt=(0,Y.$Gp)(De,ct);if((0,Y.$Bp)(De,Xe)){const Ze=new H.$hdc(tt,ot,Xe,De);if(lt.push(Ze),!(0,Y.$Cp)(De,Xe)&&De.aiConfig?.ariaKey){const mt=new je.$cR(It,Pt,"monacoworkbench",null,De.aiConfig.ariaKey);this.B((0,O.$Uc)(()=>mt.flush())),lt.push(mt)}gt=new U.$es({appenders:lt,commonProperties:(0,q.$sp)((0,P.release)(),(0,P.hostname)(),process.arch,De.commit,De.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,Pt),sendErrorTelemetry:!0,piiPaths:(0,Y.$Hp)(Xe)},ct,De)}else{gt=Y.$wp;const Ze=Y.$Ap;lt.push(Ze)}this.a.registerChannel("telemetryAppender",new K.$4fc(lt)),Re.set(Z.$$l,gt);const Kt=new B.$ghc(ct,gt,tt,ot,Xe,De);Re.set(Z.$_l,Kt),Re.set($e.$Gq,new D.$Ci(Ct.$nR,void 0,!0)),Re.set(Le.$Kq,new D.$Ci(re.$qgc,void 0,!0)),Re.set(f.$qq,new D.$Ci(f.$sq,void 0,!0)),Re.set(L.$Vq,new D.$Ci(L.$Wq,void 0,!0)),Re.set(h.$ip,new D.$Ci(o.$oq,void 0,!0)),Re.set(h.$pp,new D.$Ci(Ft.$Hhc,void 0,!1)),Re.set(x.$9r,new D.$Ci(G.$$r,void 0,!1)),Re.set(s.$Sm,new D.$Ci(r.$Ys,void 0,!1)),Re.set(X.$dMb,new D.$Ci(X.$eMb,void 0,!0)),Re.set(ee.$Hnb,new D.$Ci(ge.$JOb,void 0,!0)),Re.set(ee.$Gnb,S.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ze=>Ze.ctx!=="main"))),Re.set(h.$op,new D.$Ci(n.$bMb,void 0,!1)),Re.set(_.$HOb,new D.$Ci(_.$IOb,void 0,!0)),Re.set(j.$mw,new D.$Ci(j.$nw)),Re.set(ee.$rnb,new D.$Ci(Ee.$ONb,void 0,!0)),Re.set(ee.$snb,new D.$Ci(Ee.$QNb,void 0,!0)),Re.set(be.$fnb,new D.$Ci(be.$hnb,void 0,!0)),Re.set(ee.$tnb,new D.$Ci(oe.$Wdc,void 0,!1)),Re.set(ee.$Cnb,new D.$Ci(Ie.$Ldc,void 0,!0)),Re.set(ee.$Dnb,new D.$Ci(pe.$2dc,void 0,!1)),Re.set(Se.$PMb,new D.$Ci(ae.$nhc,void 0,!0)),Re.set(ee.$Enb,new D.$Ci(Ye.$Fec,void 0,!0)),Re.set(me.$Yl,new D.$Ci(Pe.$Qgc,void 0,!1));const Ot=new vt.$Wl;return Re.set(vt.$Vl,Ot),Ot.register(jt.RemoteConnectionType.WebSocket,qt.$Jhc),Re.set(ke.$Bw,new D.$Ci(Fe.$Ogc)),Re.set(Te.$ohc,new D.$Ci(Ce.$qhc)),Re.set(Ke.$thc,new D.$Ci(at.$Dhc)),new J.$tr(Re)}j(Re){const De=new R.$uq(Re.get(h.$lp),()=>null);this.a.registerChannel("extensions",De);const Je=S.ProxyChannel.fromService(Re.get(x.$9r),this.q);this.a.registerChannel("languagePacks",Je);const Ge=S.ProxyChannel.fromService(Re.get(s.$Sm),this.q);this.a.registerChannel("diagnostics",Ge);const et=new R.$wq(Re.get(h.$pp));this.a.registerChannel("extensionTipsService",et);const Xe=S.ProxyChannel.fromService(Re.get(d.$ehc),this.q);this.a.registerChannel("checksum",Xe);const ot=S.ProxyChannel.fromService(Re.get(We.$NG),this.q);this.a.registerChannel("v8InspectProfiling",ot);const ft=S.ProxyChannel.fromService(Re.get(be.$fnb),this.q);this.a.registerChannel("userDataSyncMachines",ft);const $t=S.ProxyChannel.fromService(Re.get(Z.$_l),this.q);this.a.registerChannel("customEndpointTelemetry",$t);const tt=new ue.$hhc(Re.get(X.$dMb));this.a.registerChannel("userDataSyncAccount",tt);const st=new ue.$jhc(Re.get(ee.$rnb));this.a.registerChannel("userDataSyncStoreManagement",st);const pt=new we.$lhc(Re.get(ee.$Dnb),Re.get(fe.$Ll),Re.get(ie.$_j));this.a.registerChannel("userDataSync",pt);const dt=this.B(Re.get(M.$Ei).createInstance(Ut.$Ghc));this.a.registerChannel("userDataAutoSync",S.ProxyChannel.fromService(dt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",S.ProxyChannel.fromService(Re.get(ee.$Enb),this.q));const rt=S.ProxyChannel.fromService(Re.get(Te.$ohc),this.q);this.a.registerChannel(Te.$phc,rt);const wt=S.ProxyChannel.fromService(Re.get(Ke.$thc),this.q);this.a.registerChannel("remoteTunnel",wt)}m(Re){process.on("uncaughtException",De=>(0,C.$3)(De)),process.on("unhandledRejection",De=>(0,C.$3)(De)),(0,C.setUnexpectedErrorHandler)(De=>{const Je=(0,c.$qj)(De,!0);Je&&Re.error(`[uncaught exception in sharedProcess]: ${Je}`)})}n(Re,De){Re.publicLog2("profilesInfo",{count:De.profiles.length})}async r(Re,De){if(He.$k){const[Je,Ge]=await Promise.all([(0,zt.$3g)(De.error.bind(De)),(0,Et.$AX)(De.error.bind(De))]),et=(0,Wt.$gX)(),Xe=(0,Et.$BX)(Ge,this.f.args["ozone-platform"]);Je&&Re.publicLog2("clientPlatformInfo",{platformId:Je.id,platformVersionId:Je.version_id,platformIdLike:Je.id_like,desktopEnvironment:et,displayProtocol:Ge,codeDisplayProtocol:Xe})}}handledClientConnection(Re){if(Re.data!==ht.$1fc.response)return!1;const De=(0,A.$Qb)(Re.ports);return De?(this.c.fire(De),!0):!1}}async function St(ut){try{const Re=new Vt(ut);process.parentPort.postMessage(ht.$Yfc.ipcReady),await Re.init(),process.parentPort.postMessage(ht.$Yfc.initDone)}catch(Re){process.parentPort.postMessage({error:Re.toString()})}}const Ht=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ut=>{clearTimeout(Ht),St(ut.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/a8f7d1c13f1922bd44e1bd4d709dfe6e7579c86a/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
