/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/process","vs/base/common/marshalling","child_process","vs/base/common/decorators","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/iconLabels","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(ce){for(var e=[],r=0,h=ce.length;r<h;r++)e[r]=ye[ce[r]];return e};define(ye[174],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=e.LoaderEventType=e.$V=void 0,e.$V=!1;var r;(function(P){P[P.LoaderAvailable=1]="LoaderAvailable",P[P.BeginLoadingScript=10]="BeginLoadingScript",P[P.EndLoadingScriptOK=11]="EndLoadingScriptOK",P[P.EndLoadingScriptError=12]="EndLoadingScriptError",P[P.BeginInvokeFactory=21]="BeginInvokeFactory",P[P.EndInvokeFactory=22]="EndInvokeFactory",P[P.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",P[P.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",P[P.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",P[P.NodeEndNativeRequire=34]="NodeEndNativeRequire",P[P.CachedDataFound=60]="CachedDataFound",P[P.CachedDataMissed=61]="CachedDataMissed",P[P.CachedDataRejected=62]="CachedDataRejected",P[P.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class h{static get(){const O=new Map,T=new Map,R=new Map,$=new Map;function a(p,c){p.has(c.detail)||p.set(c.detail,-c.timestamp)}function I(p,c){const m=p.get(c.detail);m&&(m>=0||p.set(c.detail,m+c.timestamp))}let E=[];typeof ce=="function"&&typeof ce.getStats=="function"&&(E=ce.getStats().slice(0).sort((p,c)=>p.timestamp-c.timestamp));for(const p of E)switch(p.type){case r.BeginLoadingScript:a(O,p);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:I(O,p);break;case r.BeginInvokeFactory:a(T,p);break;case r.EndInvokeFactory:I(T,p);break;case r.NodeBeginNativeRequire:a(R,p);break;case r.NodeEndNativeRequire:I(R,p);break;case r.NodeBeginEvaluatingScript:a($,p);break;case r.NodeEndEvaluatingScript:I($,p);break}let l=0;R.forEach(p=>l+=p);function k(p){const c=[];return p.forEach((m,d)=>c.push([d,m])),c}return{amdLoad:k(O),amdInvoke:k(T),nodeRequire:k(R),nodeEval:k($),nodeRequireTotal:l}}static toMarkdownTable(O,T){let R="";const $=[];return O.forEach((a,I)=>{$[I]=a.length}),T.forEach(a=>{a.forEach((I,E)=>{typeof I>"u"&&(I=a[E]="-");const l=I.toString().length;$[E]=Math.max(l,$[E])})}),O.forEach((a,I)=>{R+=`| ${a+" ".repeat($[I]-a.toString().length)} `}),R+=`|
`,O.forEach((a,I)=>{R+=`| ${"-".repeat($[I])} `}),R+=`|
`,T.forEach(a=>{a.forEach((I,E)=>{typeof I<"u"&&(R+=`| ${I+" ".repeat($[E]-I.toString().length)} `)}),R+=`|
`}),R}}e.$W=h}),define(ye[132],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ob=void 0,e.$hb=r,e.$ib=h,e.$jb=P,e.$kb=O,e.$lb=T,e.$mb=R,e.$nb=$,e.$pb=I,e.$qb=E,e.$rb=l,e.$sb=k,e.$tb=p;function r(c,m){const d=h(c,m);if(d!==-1)return c[d]}function h(c,m,d=c.length-1){for(let g=d;g>=0;g--){const n=c[g];if(m(n))return g}return-1}function P(c,m){const d=O(c,m);return d===-1?void 0:c[d]}function O(c,m,d=0,g=c.length){let n=d,o=g;for(;n<o;){const t=Math.floor((n+o)/2);m(c[t])?n=t+1:o=t}return n-1}function T(c,m){const d=R(c,m);return d===c.length?void 0:c[d]}function R(c,m,d=0,g=c.length){let n=d,o=g;for(;n<o;){const t=Math.floor((n+o)/2);m(c[t])?o=t:n=t+1}return n}function $(c,m,d=0,g=c.length){const n=R(c,m,d,g);return n===c.length?-1:n}class a{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(a.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!m(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const d=O(this.e,m,this.c);return this.c=d+1,d===-1?void 0:this.e[d]}}e.$ob=a;function I(c,m){if(c.length===0)return;let d=c[0];for(let g=1;g<c.length;g++){const n=c[g];m(n,d)>0&&(d=n)}return d}function E(c,m){if(c.length===0)return;let d=c[0];for(let g=1;g<c.length;g++){const n=c[g];m(n,d)>=0&&(d=n)}return d}function l(c,m){return I(c,(d,g)=>-m(d,g))}function k(c,m){if(c.length===0)return-1;let d=0;for(let g=1;g<c.length;g++){const n=c[g];m(n,c[d])>0&&(d=g)}return d}function p(c,m){for(const d of c){const g=m(d);if(g!==void 0)return g}}}),define(ye[27],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(ye[79],Se([1,0]),function(ce,e){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=h,e.$L=P,e.$M=O,e.$N=T;function h($,a){const I=Object.create(null);for(const E of $){const l=a(E);let k=I[l];k||(k=I[l]=[]),k.push(E)}return I}function P($,a){const I=[],E=[];for(const l of $)a.has(l)||I.push(l);for(const l of a)$.has(l)||E.push(l);return{removed:I,added:E}}function O($,a){const I=[],E=[];for(const[l,k]of $)a.has(l)||I.push(k);for(const[l,k]of a)$.has(l)||E.push(k);return{removed:I,added:E}}function T($,a){const I=new Set;for(const E of a)$.has(E)&&I.add(E);return I}class R{static{r=Symbol.toStringTag}constructor(a,I){this.b=I,this.a=new Map,this[r]="SetWithKey";for(const E of a)this.add(E)}get size(){return this.a.size}add(a){const I=this.b(a);return this.a.set(I,a),this}delete(a){return this.a.delete(this.b(a))}has(a){return this.a.has(this.b(a))}*entries(){for(const a of this.a.values())yield[a,a]}keys(){return this.values()}*values(){for(const a of this.a.values())yield a}clear(){this.a.clear()}forEach(a,I){this.a.forEach(E=>a.call(I,E,E,this))}[Symbol.iterator](){return this.values()}}e.$O=R}),define(ye[59],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=h,e.$$h=P,e.$_h=O;function r(T){return(R,$,a)=>{let I=null,E=null;if(typeof a.value=="function"?(I="value",E=a.value):typeof a.get=="function"&&(I="get",E=a.get),!E)throw new Error("not supported");a[I]=T(E,$)}}function h(T,R,$){let a=null,I=null;if(typeof $.value=="function"?(a="value",I=$.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(a="get",I=$.get),!I)throw new Error("not supported");const E=`$memoize$${R}`;$[a]=function(...l){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,l)}),this[E]}}function P(T,R,$){return r((a,I)=>{const E=`$debounce$${I}`,l=`$debounce$result$${I}`;return function(...k){this[l]||(this[l]=$?$():void 0),clearTimeout(this[E]),R&&(this[l]=R(this[l],...k),k=[this[l]]),this[E]=setTimeout(()=>{a.apply(this,k),this[l]=$?$():void 0},T)}})}function O(T,R,$){return r((a,I)=>{const E=`$throttle$timer$${I}`,l=`$throttle$result$${I}`,k=`$throttle$lastRun$${I}`,p=`$throttle$pending$${I}`;return function(...c){if(this[l]||(this[l]=$?$():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),R&&(this[l]=R(this[l],...c)),this[p])return;const m=this[k]+T;m<=Date.now()?(this[k]=Date.now(),a.apply(this,[this[l]]),this[l]=$?$():void 0):(this[p]=!0,this[E]=setTimeout(()=>{this[p]=!1,this[k]=Date.now(),a.apply(this,[this[l]]),this[l]=$?$():void 0},m-Date.now()))}})}}),define(ye[14],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=e.$db=e.$cb=e.$bb=e.$ab=e.$$=e.$7=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=h,e.$2=P,e.$3=O,e.$4=T,e.$5=R,e.$6=a,e.$8=E,e.$9=l,e.$0=k,e.$_=c;class r{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?n.isErrorNoTelemetry(i)?new n(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(s=>{s(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$Y=r,e.$Z=new r;function h(t){e.$Z.setUnexpectedErrorHandler(t)}function P(t){if(!t||typeof t!="object")return!1;const i=t;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function O(t){a(t)||e.$Z.onUnexpectedError(t)}function T(t){a(t)||e.$Z.onUnexpectedExternalError(t)}function R(t){if(t instanceof Error){const{name:i,message:s}=t,f=t.stacktrace||t.stack;return{$isError:!0,name:i,message:s,stack:f,noTelemetry:n.isErrorNoTelemetry(t)}}return t}const $="Canceled";function a(t){return t instanceof I?!0:t instanceof Error&&t.name===$&&t.message===$}class I extends Error{constructor(){super($),this.name=this.message}}e.$7=I;function E(){const t=new Error($);return t.name=t.message,t}function l(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}function k(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}class p extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$$=p;function c(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}class m extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$ab=m;class d extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$bb=d;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$cb=g;class n extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof n)return i;const s=new n;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$db=n;class o extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$eb=o}),define(ye[19],Se([1,0,14,132]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$$b=e.$0b=e.CompareResult=void 0,e.$ub=P,e.$vb=O,e.$wb=T,e.$xb=R,e.$yb=$,e.$zb=a,e.$Ab=I,e.$Bb=E,e.$Cb=l,e.$Db=k,e.$Eb=p,e.$Fb=c,e.$Gb=m,e.top=d,e.$Ib=g,e.$Jb=o,e.$Kb=t,e.$Lb=i,e.$Mb=s,e.$Nb=f,e.$Ob=u,e.$Pb=w,e.$Qb=y,e.$Rb=D,e.$Sb=S,e.$Tb=C,e.$Ub=A,e.$Vb=b,e.$Wb=v,e.$Xb=M,e.$Yb=N,e.$Zb=L,e.$1b=j,e.$2b=z,e.$3b=F,e.$4b=B,e.$5b=_,e.$6b=re,e.$7b=U,e.$8b=ee,e.$9b=he,e.$_b=$e;function P(ae,te=0){return ae[ae.length-(1+te)]}function O(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}function T(ae,te,le=(ue,X)=>ue===X){if(ae===te)return!0;if(!ae||!te||ae.length!==te.length)return!1;for(let ue=0,X=ae.length;ue<X;ue++)if(!le(ae[ue],te[ue]))return!1;return!0}function R(ae,te){const le=ae.length-1;te<le&&(ae[te]=ae[le]),ae.pop()}function $(ae,te,le){return a(ae.length,ue=>le(ae[ue],te))}function a(ae,te){let le=0,ue=ae-1;for(;le<=ue;){const X=(le+ue)/2|0,oe=te(X);if(oe<0)le=X+1;else if(oe>0)ue=X-1;else return X}return-(le+1)}function I(ae,te,le){if(ae=ae|0,ae>=te.length)throw new TypeError("invalid index");const ue=te[Math.floor(te.length*Math.random())],X=[],oe=[],pe=[];for(const we of te){const Fe=le(we,ue);Fe<0?X.push(we):Fe>0?oe.push(we):pe.push(we)}return ae<X.length?I(ae,X,le):ae<X.length+pe.length?pe[0]:I(ae-(X.length+pe.length),oe,le)}function E(ae,te){const le=[];let ue;for(const X of ae.slice(0).sort(te))!ue||te(ue[0],X)!==0?(ue=[X],le.push(ue)):ue.push(X);return le}function*l(ae,te){let le,ue;for(const X of ae)ue!==void 0&&te(ue,X)?le.push(X):(le&&(yield le),le=[X]),ue=X;le&&(yield le)}function k(ae,te){for(let le=0;le<=ae.length;le++)te(le===0?void 0:ae[le-1],le===ae.length?void 0:ae[le])}function p(ae,te){for(let le=0;le<ae.length;le++)te(le===0?void 0:ae[le-1],ae[le],le+1===ae.length?void 0:ae[le+1])}function c(ae,te,le){const ue=[];function X(we,Fe,Ue){if(Fe===0&&Ue.length===0)return;const ke=ue[ue.length-1];ke&&ke.start+ke.deleteCount===we?(ke.deleteCount+=Fe,ke.toInsert.push(...Ue)):ue.push({start:we,deleteCount:Fe,toInsert:Ue})}let oe=0,pe=0;for(;;){if(oe===ae.length){X(oe,0,te.slice(pe));break}if(pe===te.length){X(oe,ae.length-oe,[]);break}const we=ae[oe],Fe=te[pe],Ue=le(we,Fe);Ue===0?(oe+=1,pe+=1):Ue<0?(X(oe,1,[]),oe+=1):Ue>0&&(X(oe,0,[Fe]),pe+=1)}return ue}function m(ae,te,le){const ue=c(ae,te,le),X=[],oe=[];for(const pe of ue)X.push(...ae.slice(pe.start,pe.start+pe.deleteCount)),oe.push(...pe.toInsert);return{removed:X,added:oe}}function d(ae,te,le){if(le===0)return[];const ue=ae.slice(0,le).sort(te);return n(ae,te,ue,le,ae.length),ue}function g(ae,te,le,ue,X){return le===0?Promise.resolve([]):new Promise((oe,pe)=>{(async()=>{const we=ae.length,Fe=ae.slice(0,le).sort(te);for(let Ue=le,ke=Math.min(le+ue,we);Ue<we;Ue=ke,ke=Math.min(ke+ue,we)){if(Ue>le&&await new Promise(Ie=>setTimeout(Ie)),X&&X.isCancellationRequested)throw new r.$7;n(ae,te,Fe,Ue,ke)}return Fe})().then(oe,pe)})}function n(ae,te,le,ue,X){for(const oe=le.length;ue<X;ue++){const pe=ae[ue];if(te(pe,le[oe-1])<0){le.pop();const we=(0,h.$mb)(le,Fe=>te(pe,Fe)<0);le.splice(we,0,pe)}}}function o(ae){return ae.filter(te=>!!te)}function t(ae){let te=0;for(let le=0;le<ae.length;le++)ae[le]&&(ae[te]=ae[le],te+=1);ae.length=te}function i(ae,te,le){ae.splice(le,0,ae.splice(te,1)[0])}function s(ae){return!Array.isArray(ae)||ae.length===0}function f(ae){return Array.isArray(ae)&&ae.length>0}function u(ae,te=le=>le){const le=new Set;return ae.filter(ue=>{const X=te(ue);return le.has(X)?!1:(le.add(X),!0)})}function w(ae){const te=new Set;return le=>{const ue=ae(le);return te.has(ue)?!1:(te.add(ue),!0)}}function y(ae,te){return ae.length>0?ae[0]:te}function D(ae,te){return ae.length>0?ae[ae.length-1]:te}function S(ae,te,le=(ue,X)=>ue===X){let ue=0;for(let X=0,oe=Math.min(ae.length,te.length);X<oe&&le(ae[X],te[X]);X++)ue++;return ue}function C(ae,te){let le=typeof te=="number"?ae:0;typeof te=="number"?le=ae:(le=0,te=ae);const ue=[];if(le<=te)for(let X=le;X<te;X++)ue.push(X);else for(let X=le;X>te;X--)ue.push(X);return ue}function A(ae,te,le){return ae.reduce((ue,X)=>(ue[te(X)]=le?le(X):X,ue),Object.create(null))}function b(ae,te){return ae.push(te),()=>v(ae,te)}function v(ae,te){const le=ae.indexOf(te);if(le>-1)return ae.splice(le,1),te}function M(ae,te,le){const ue=ae.slice(0,te),X=ae.slice(te);return ue.concat(le,X)}function N(ae,te){let le;if(typeof te=="number"){let ue=te;le=()=>{const X=Math.sin(ue++)*179426549;return X-Math.floor(X)}}else le=Math.random;for(let ue=ae.length-1;ue>0;ue-=1){const X=Math.floor(le()*(ue+1)),oe=ae[ue];ae[ue]=ae[X],ae[X]=oe}}function L(ae,te){const le=ae.indexOf(te);le>-1&&(ae.splice(le,1),ae.unshift(te))}function j(ae,te){const le=ae.indexOf(te);le>-1&&(ae.splice(le,1),ae.push(te))}function z(ae,te){for(const le of te)ae.push(le)}function F(ae,te){return Array.isArray(ae)?ae.map(te):te(ae)}function B(ae){return Array.isArray(ae)?ae:[ae]}function _(ae){return ae[Math.floor(Math.random()*ae.length)]}function re(ae,te,le){const ue=G(ae,te),X=ae.length,oe=le.length;ae.length=X+oe;for(let pe=X-1;pe>=ue;pe--)ae[pe+oe]=ae[pe];for(let pe=0;pe<oe;pe++)ae[pe+ue]=le[pe]}function U(ae,te,le,ue){const X=G(ae,te);let oe=ae.splice(X,le);return oe===void 0&&(oe=[]),re(ae,X,ue),oe}function G(ae,te){return te<0?Math.max(te+ae.length,0):Math.min(te,ae.length)}var Q;(function(ae){function te(oe){return oe<0}ae.isLessThan=te;function le(oe){return oe<=0}ae.isLessThanOrEqual=le;function ue(oe){return oe>0}ae.isGreaterThan=ue;function X(oe){return oe===0}ae.isNeitherLessOrGreaterThan=X,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(Q||(e.CompareResult=Q={}));function ee(ae,te){return(le,ue)=>te(ae(le),ae(ue))}function he(...ae){return(te,le)=>{for(const ue of ae){const X=ue(te,le);if(!Q.isNeitherLessOrGreaterThan(X))return X}return Q.neitherLessOrGreaterThan}}const ne=(ae,te)=>ae-te;e.$0b=ne;const De=(ae,te)=>(0,e.$0b)(ae?1:0,te?1:0);e.$$b=De;function $e(ae){return(te,le)=>-ae(te,le)}class K{constructor(te){this.g=te,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(te){let le=this.c;for(;le<this.g.length&&te(this.g[le]);)le++;const ue=le===this.c?null:this.g.slice(this.c,le);return this.c=le,ue}takeFromEndWhile(te){let le=this.d;for(;le>=0&&te(this.g[le]);)le--;const ue=le===this.d?null:this.g.slice(le+1,this.d+1);return this.d=le,ue}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const te=this.g[this.c];return this.c++,te}removeLast(){const te=this.g[this.d];return this.d--,te}takeCount(te){const le=this.g.slice(this.c,this.c+te);return this.c+=te,le}}e.$ac=K;class W{static{this.empty=new W(te=>{})}constructor(te){this.iterate=te}forEach(te){this.iterate(le=>(te(le),!0))}toArray(){const te=[];return this.iterate(le=>(te.push(le),!0)),te}filter(te){return new W(le=>this.iterate(ue=>te(ue)?le(ue):!0))}map(te){return new W(le=>this.iterate(ue=>le(te(ue))))}some(te){let le=!1;return this.iterate(ue=>(le=te(ue),!le)),le}findFirst(te){let le;return this.iterate(ue=>te(ue)?(le=ue,!1):!0),le}findLast(te){let le;return this.iterate(ue=>(te(ue)&&(le=ue),!0)),le}findLastMaxBy(te){let le,ue=!0;return this.iterate(X=>((ue||Q.isGreaterThan(te(X,le)))&&(ue=!1,le=X),!0)),le}}e.$bc=W;class se{constructor(te){this.c=te}static createSortPermutation(te,le){const ue=Array.from(te.keys()).sort((X,oe)=>le(te[X],te[oe]));return new se(ue)}apply(te){return te.map((le,ue)=>te[this.c[ue]])}inverse(){const te=this.c.slice();for(let le=0;le<this.c.length;le++)te[this.c[le]]=le;return new se(te)}}e.$cc=se}),define(ye[66],Se([1,0,14]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.$gd=P,e.$hd=O,e.$id=T,e.$jd=R,e.$kd=$;function h(a,I){if(!a)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function P(a,I="Unreachable"){throw new Error(I)}function O(a,I="unexpected state"){if(!a)throw new r.$eb(`Assertion Failed: ${I}`)}function T(a){a||(0,r.$3)(new r.$eb("Soft Assertion Failed"))}function R(a){if(!a()){debugger;a(),(0,r.$3)(new r.$eb("Assertion Failed"))}}function $(a,I){let E=0;for(;E<a.length-1;){const l=a[E],k=a[E+1];if(!I(l,k))return!1;E++}return!0}});var Un=this&&this.__createBinding||(Object.create?function(ce,e,r,h){h===void 0&&(h=r);var P=Object.getOwnPropertyDescriptor(e,r);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty(ce,h,P)}:function(ce,e,r,h){h===void 0&&(h=r),ce[h]=e[r]}),Wn=this&&this.__setModuleDefault||(Object.create?function(ce,e){Object.defineProperty(ce,"default",{enumerable:!0,value:e})}:function(ce,e){ce.default=e}),We=this&&this.__importStar||function(ce){if(ce&&ce.__esModule)return ce;var e={};if(ce!=null)for(var r in ce)r!=="default"&&Object.prototype.hasOwnProperty.call(ce,r)&&Un(e,ce,r);return Wn(e,ce),e};define(ye[175],Se([1,0,19]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0,e.$9c=P,e.$0c=O,e.$$c=T,e.$_c=R,e.$ad=$,e.$bd=a,r=We(r);const h=(k,p)=>k===p;e.$8c=h;function P(k=e.$8c){return(p,c)=>r.$wb(p,c,k)}function O(){return(k,p)=>JSON.stringify(k)===JSON.stringify(p)}function T(){return(k,p)=>k.equals(p)}function R(k,p,c){if(c!==void 0){const m=k;return m==null||p===void 0||p===null?p===m:c(m,p)}else{const m=k;return(d,g)=>d==null||g===void 0||g===null?g===d:m(d,g)}}function $(k,p){if(k===p)return!0;if(Array.isArray(k)&&Array.isArray(p)){if(k.length!==p.length)return!1;for(let c=0;c<k.length;c++)if(!$(k[c],p[c]))return!1;return!0}if(k&&typeof k=="object"&&p&&typeof p=="object"&&Object.getPrototypeOf(k)===Object.prototype&&Object.getPrototypeOf(p)===Object.prototype){const c=k,m=p,d=Object.keys(c),g=Object.keys(m),n=new Set(g);if(d.length!==g.length)return!1;for(const o of d)if(!n.has(o)||!$(c[o],m[o]))return!1;return!0}return!1}function a(k){return JSON.stringify(l(k))}let I=0;const E=new WeakMap;function l(k){if(Array.isArray(k))return k.map(l);if(k&&typeof k=="object")if(Object.getPrototypeOf(k)===Object.prototype){const p=k,c=Object.create(null);for(const m of Object.keys(p).sort())c[m]=l(p[m]);return c}else{let p=E.get(k);return p===void 0&&(p=I++,E.set(k,p)),p+"----2b76a038c20c4bcc"}return k}}),define(ye[80],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=r;function r(h,P){const O=this;let T=!1,R;return function(){if(T)return R;if(T=!0,P)try{R=h.apply(O,arguments)}finally{P()}else R=h.apply(O,arguments);return R}}}),define(ye[133],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.$6P=void 0;class r{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$6P=r,e.$7P=new r("id#")}),define(ye[40],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(h){function P(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}h.is=P;const O=Object.freeze([]);function T(){return O}h.empty=T;function*R(s){yield s}h.single=R;function $(s){return P(s)?s:R(s)}h.wrap=$;function a(s){return s||O}h.from=a;function*I(s){for(let f=s.length-1;f>=0;f--)yield s[f]}h.reverse=I;function E(s){return!s||s[Symbol.iterator]().next().done===!0}h.isEmpty=E;function l(s){return s[Symbol.iterator]().next().value}h.first=l;function k(s,f){let u=0;for(const w of s)if(f(w,u++))return!0;return!1}h.some=k;function p(s,f){for(const u of s)if(f(u))return u}h.find=p;function*c(s,f){for(const u of s)f(u)&&(yield u)}h.filter=c;function*m(s,f){let u=0;for(const w of s)yield f(w,u++)}h.map=m;function*d(s,f){let u=0;for(const w of s)yield*f(w,u++)}h.flatMap=d;function*g(...s){for(const f of s)yield*f}h.concat=g;function n(s,f,u){let w=u;for(const y of s)w=f(w,y);return w}h.reduce=n;function*o(s,f,u=s.length){for(f<0&&(f+=s.length),u<0?u+=s.length:u>s.length&&(u=s.length);f<u;f++)yield s[f]}h.slice=o;function t(s,f=Number.POSITIVE_INFINITY){const u=[];if(f===0)return[u,s];const w=s[Symbol.iterator]();for(let y=0;y<f;y++){const D=w.next();if(D.done)return[u,h.empty()];u.push(D.value)}return[u,{[Symbol.iterator](){return w}}]}h.consume=t;async function i(s){const f=[];for await(const u of s)f.push(u);return Promise.resolve(f)}h.asyncToArray=i})(r||(e.Iterable=r={}))}),define(ye[176],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Vn=T,e.$Wn=E,e.$Xn=l,e.$Yn=k,e.$Zn=p,e.$1n=c,e.$2n=m,e.$3n=d,e.$4n=g,e.$5n=n,e.$6n=o;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function T(t,i=!1){let s=0;const f=t.length;let u="",w=0,y=h.Unknown,D=r.None;function S(L){let j=0,z=0;for(;j<L;){const F=t.charCodeAt(s);if(F>=I._0&&F<=I._9)z=z*16+F-I._0;else if(F>=I.A&&F<=I.F)z=z*16+F-I.A+10;else if(F>=I.a&&F<=I.f)z=z*16+F-I.a+10;else break;s++,j++}return j<L&&(z=-1),z}function C(L){s=L,u="",w=0,y=h.Unknown,D=r.None}function A(){const L=s;if(t.charCodeAt(s)===I._0)s++;else for(s++;s<t.length&&a(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===I.dot)if(s++,s<t.length&&a(t.charCodeAt(s)))for(s++;s<t.length&&a(t.charCodeAt(s));)s++;else return D=r.UnexpectedEndOfNumber,t.substring(L,s);let j=s;if(s<t.length&&(t.charCodeAt(s)===I.E||t.charCodeAt(s)===I.e))if(s++,(s<t.length&&t.charCodeAt(s)===I.plus||t.charCodeAt(s)===I.minus)&&s++,s<t.length&&a(t.charCodeAt(s))){for(s++;s<t.length&&a(t.charCodeAt(s));)s++;j=s}else D=r.UnexpectedEndOfNumber;return t.substring(L,j)}function b(){let L="",j=s;for(;;){if(s>=f){L+=t.substring(j,s),D=r.UnexpectedEndOfString;break}const z=t.charCodeAt(s);if(z===I.doubleQuote){L+=t.substring(j,s),s++;break}if(z===I.backslash){if(L+=t.substring(j,s),s++,s>=f){D=r.UnexpectedEndOfString;break}switch(t.charCodeAt(s++)){case I.doubleQuote:L+='"';break;case I.backslash:L+="\\";break;case I.slash:L+="/";break;case I.b:L+="\b";break;case I.f:L+="\f";break;case I.n:L+=`
`;break;case I.r:L+="\r";break;case I.t:L+="	";break;case I.u:{const B=S(4);B>=0?L+=String.fromCharCode(B):D=r.InvalidUnicode;break}default:D=r.InvalidEscapeCharacter}j=s;continue}if(z>=0&&z<=31)if($(z)){L+=t.substring(j,s),D=r.UnexpectedEndOfString;break}else D=r.InvalidCharacter;s++}return L}function v(){if(u="",D=r.None,w=s,s>=f)return w=f,y=h.EOF;let L=t.charCodeAt(s);if(R(L)){do s++,u+=String.fromCharCode(L),L=t.charCodeAt(s);while(R(L));return y=h.Trivia}if($(L))return s++,u+=String.fromCharCode(L),L===I.carriageReturn&&t.charCodeAt(s)===I.lineFeed&&(s++,u+=`
`),y=h.LineBreakTrivia;switch(L){case I.openBrace:return s++,y=h.OpenBraceToken;case I.closeBrace:return s++,y=h.CloseBraceToken;case I.openBracket:return s++,y=h.OpenBracketToken;case I.closeBracket:return s++,y=h.CloseBracketToken;case I.colon:return s++,y=h.ColonToken;case I.comma:return s++,y=h.CommaToken;case I.doubleQuote:return s++,u=b(),y=h.StringLiteral;case I.slash:{const j=s-1;if(t.charCodeAt(s+1)===I.slash){for(s+=2;s<f&&!$(t.charCodeAt(s));)s++;return u=t.substring(j,s),y=h.LineCommentTrivia}if(t.charCodeAt(s+1)===I.asterisk){s+=2;const z=f-1;let F=!1;for(;s<z;){if(t.charCodeAt(s)===I.asterisk&&t.charCodeAt(s+1)===I.slash){s+=2,F=!0;break}s++}return F||(s++,D=r.UnexpectedEndOfComment),u=t.substring(j,s),y=h.BlockCommentTrivia}return u+=String.fromCharCode(L),s++,y=h.Unknown}case I.minus:if(u+=String.fromCharCode(L),s++,s===f||!a(t.charCodeAt(s)))return y=h.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return u+=A(),y=h.NumericLiteral;default:for(;s<f&&M(L);)s++,L=t.charCodeAt(s);if(w!==s){switch(u=t.substring(w,s),u){case"true":return y=h.TrueKeyword;case"false":return y=h.FalseKeyword;case"null":return y=h.NullKeyword}return y=h.Unknown}return u+=String.fromCharCode(L),s++,y=h.Unknown}}function M(L){if(R(L)||$(L))return!1;switch(L){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function N(){let L;do L=v();while(L>=h.LineCommentTrivia&&L<=h.Trivia);return L}return{setPosition:C,getPosition:()=>s,scan:i?N:v,getToken:()=>y,getTokenValue:()=>u,getTokenOffset:()=>w,getTokenLength:()=>s-w,getTokenError:()=>D}}function R(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function $(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function a(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function E(t,i){const s=[],f=new Object;let u;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function D(S,C,A,b){w.value=S,w.offset=C,w.length=A,w.type=b,w.colonOffset=void 0,u=w}try{n(t,{onObjectBegin:(S,C)=>{if(i<=S)throw f;u=void 0,y=i>S,s.push("")},onObjectProperty:(S,C,A)=>{if(i<C||(D(S,C,A,"property"),s[s.length-1]=S,i<=C+A))throw f},onObjectEnd:(S,C)=>{if(i<=S)throw f;u=void 0,s.pop()},onArrayBegin:(S,C)=>{if(i<=S)throw f;u=void 0,s.push(0)},onArrayEnd:(S,C)=>{if(i<=S)throw f;u=void 0,s.pop()},onLiteralValue:(S,C,A)=>{if(i<C||(D(S,C,A,o(S)),i<=C+A))throw f},onSeparator:(S,C,A)=>{if(i<=C)throw f;if(S===":"&&u&&u.type==="property")u.colonOffset=C,y=!1,u=void 0;else if(S===","){const b=s[s.length-1];typeof b=="number"?s[s.length-1]=b+1:(y=!0,s[s.length-1]=""),u=void 0}}})}catch(S){if(S!==f)throw S}return{path:s,previousNode:u,isAtPropertyKey:y,matches:S=>{let C=0;for(let A=0;C<S.length&&A<s.length;A++)if(S[C]===s[A]||S[C]==="*")C++;else if(S[C]!=="**")return!1;return C===S.length}}}function l(t,i=[],s=O.DEFAULT){let f=null,u=[];const w=[];function y(S){Array.isArray(u)?u.push(S):f!==null&&(u[f]=S)}return n(t,{onObjectBegin:()=>{const S={};y(S),w.push(u),u=S,f=null},onObjectProperty:S=>{f=S},onObjectEnd:()=>{u=w.pop()},onArrayBegin:()=>{const S=[];y(S),w.push(u),u=S,f=null},onArrayEnd:()=>{u=w.pop()},onLiteralValue:y,onError:(S,C,A)=>{i.push({error:S,offset:C,length:A})}},s),u[0]}function k(t,i=[],s=O.DEFAULT){let f={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(S){f.type==="property"&&(f.length=S-f.offset,f=f.parent)}function w(S){return f.children.push(S),S}n(t,{onObjectBegin:S=>{f=w({type:"object",offset:S,length:-1,parent:f,children:[]})},onObjectProperty:(S,C,A)=>{f=w({type:"property",offset:C,length:-1,parent:f,children:[]}),f.children.push({type:"string",value:S,offset:C,length:A,parent:f})},onObjectEnd:(S,C)=>{f.length=S+C-f.offset,f=f.parent,u(S+C)},onArrayBegin:(S,C)=>{f=w({type:"array",offset:S,length:-1,parent:f,children:[]})},onArrayEnd:(S,C)=>{f.length=S+C-f.offset,f=f.parent,u(S+C)},onLiteralValue:(S,C,A)=>{w({type:o(S),offset:C,length:A,parent:f,value:S}),u(C+A)},onSeparator:(S,C,A)=>{f.type==="property"&&(S===":"?f.colonOffset=C:S===","&&u(C))},onError:(S,C,A)=>{i.push({error:S,offset:C,length:A})}},s);const D=f.children[0];return D&&delete D.parent,D}function p(t,i){if(!t)return;let s=t;for(const f of i)if(typeof f=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let u=!1;for(const w of s.children)if(Array.isArray(w.children)&&w.children[0].value===f){s=w.children[1],u=!0;break}if(!u)return}else{const u=f;if(s.type!=="array"||u<0||!Array.isArray(s.children)||u>=s.children.length)return;s=s.children[u]}return s}function c(t){if(!t.parent||!t.parent.children)return[];const i=c(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const i=Object.create(null);for(const s of t.children){const f=s.children[1];f&&(i[s.children[0].value]=m(f))}return i}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function d(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}function g(t,i,s=!1){if(d(t,i,s)){const f=t.children;if(Array.isArray(f))for(let u=0;u<f.length&&f[u].offset<=i;u++){const w=g(f[u],i,s);if(w)return w}return t}}function n(t,i,s=O.DEFAULT){const f=T(t,!1);function u(ee){return ee?()=>ee(f.getTokenOffset(),f.getTokenLength()):()=>!0}function w(ee){return ee?he=>ee(he,f.getTokenOffset(),f.getTokenLength()):()=>!0}const y=u(i.onObjectBegin),D=w(i.onObjectProperty),S=u(i.onObjectEnd),C=u(i.onArrayBegin),A=u(i.onArrayEnd),b=w(i.onLiteralValue),v=w(i.onSeparator),M=u(i.onComment),N=w(i.onError),L=s&&s.disallowComments,j=s&&s.allowTrailingComma;function z(){for(;;){const ee=f.scan();switch(f.getTokenError()){case r.InvalidUnicode:F(P.InvalidUnicode);break;case r.InvalidEscapeCharacter:F(P.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:F(P.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:L||F(P.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:F(P.UnexpectedEndOfString);break;case r.InvalidCharacter:F(P.InvalidCharacter);break}switch(ee){case h.LineCommentTrivia:case h.BlockCommentTrivia:L?F(P.InvalidCommentToken):M();break;case h.Unknown:F(P.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return ee}}}function F(ee,he=[],ne=[]){if(N(ee),he.length+ne.length>0){let De=f.getToken();for(;De!==h.EOF;){if(he.indexOf(De)!==-1){z();break}else if(ne.indexOf(De)!==-1)break;De=z()}}}function B(ee){const he=f.getTokenValue();return ee?b(he):D(he),z(),!0}function _(){switch(f.getToken()){case h.NumericLiteral:{let ee=0;try{ee=JSON.parse(f.getTokenValue()),typeof ee!="number"&&(F(P.InvalidNumberFormat),ee=0)}catch{F(P.InvalidNumberFormat)}b(ee);break}case h.NullKeyword:b(null);break;case h.TrueKeyword:b(!0);break;case h.FalseKeyword:b(!1);break;default:return!1}return z(),!0}function re(){return f.getToken()!==h.StringLiteral?(F(P.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(B(!1),f.getToken()===h.ColonToken?(v(":"),z(),Q()||F(P.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):F(P.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function U(){y(),z();let ee=!1;for(;f.getToken()!==h.CloseBraceToken&&f.getToken()!==h.EOF;){if(f.getToken()===h.CommaToken){if(ee||F(P.ValueExpected,[],[]),v(","),z(),f.getToken()===h.CloseBraceToken&&j)break}else ee&&F(P.CommaExpected,[],[]);re()||F(P.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),ee=!0}return S(),f.getToken()!==h.CloseBraceToken?F(P.CloseBraceExpected,[h.CloseBraceToken],[]):z(),!0}function G(){C(),z();let ee=!1;for(;f.getToken()!==h.CloseBracketToken&&f.getToken()!==h.EOF;){if(f.getToken()===h.CommaToken){if(ee||F(P.ValueExpected,[],[]),v(","),z(),f.getToken()===h.CloseBracketToken&&j)break}else ee&&F(P.CommaExpected,[],[]);Q()||F(P.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),ee=!0}return A(),f.getToken()!==h.CloseBracketToken?F(P.CloseBracketExpected,[h.CloseBracketToken],[]):z(),!0}function Q(){switch(f.getToken()){case h.OpenBracketToken:return G();case h.OpenBraceToken:return U();case h.StringLiteral:return B(!0);default:return _()}}return z(),f.getToken()===h.EOF?s.allowEmptyContent?!0:(F(P.ValueExpected,[],[]),!1):Q()?(f.getToken()!==h.EOF&&F(P.EndOfFileExpected,[],[]),!0):(F(P.ValueExpected,[],[]),!1)}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ye[49],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class r{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=r}),define(ye[81],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0;class r{static{this.Undefined=new r(void 0)}constructor(O){this.element=O,this.next=r.Undefined,this.prev=r.Undefined}}class h{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let O=this.a;for(;O!==r.Undefined;){const T=O.next;O.prev=r.Undefined,O.next=r.Undefined,O=T}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,T){const R=new r(O);if(this.a===r.Undefined)this.a=R,this.b=R;else if(T){const a=this.b;this.b=R,R.prev=a,a.next=R}else{const a=this.a;this.a=R,R.next=a,a.prev=R}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(R))}}shift(){if(this.a!==r.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==r.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==r.Undefined&&O.next!==r.Undefined){const T=O.prev;T.next=O.next,O.next.prev=T}else O.prev===r.Undefined&&O.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):O.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):O.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==r.Undefined;)yield O.element,O=O.next}}e.$7c=h}),define(ye[29],Se([1,0]),function(ce,e){"use strict";var r,h,P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.Touch=e.$Dc=e.$Cc=void 0,e.$zc=O,e.$Ac=T,e.$Bc=R,e.$Kc=o;function O(t,i,s){let f=t.get(i);return f===void 0&&(f=s,t.set(i,f)),f}function T(t){const i=[];return t.forEach((s,f)=>{i.push(`${f} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}function R(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}class ${constructor(i,s){this.uri=i,this.value=s}}function a(t){return Array.isArray(t)}class I{static{this.c=i=>i.toString()}constructor(i,s){if(this[r]="ResourceMap",i instanceof I)this.d=new Map(i.d),this.e=s??I.c;else if(a(i)){this.d=new Map,this.e=s??I.c;for(const[f,u]of i)this.set(f,u)}else this.d=new Map,this.e=i??I.c}set(i,s){return this.d.set(this.e(i),new $(i,s)),this}get(i){return this.d.get(this.e(i))?.value}has(i){return this.d.has(this.e(i))}get size(){return this.d.size}clear(){this.d.clear()}delete(i){return this.d.delete(this.e(i))}forEach(i,s){typeof s<"u"&&(i=i.bind(s));for(const[f,u]of this.d)i(u.value,u.uri,this)}*values(){for(const i of this.d.values())yield i.value}*keys(){for(const i of this.d.values())yield i.uri}*entries(){for(const i of this.d.values())yield[i.uri,i.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.d)yield[i.uri,i.value]}}e.$Cc=I;class E{constructor(i,s){this[h]="ResourceSet",!i||typeof i=="function"?this.c=new I(i):(this.c=new I(s),i.forEach(this.add,this))}get size(){return this.c.size}add(i){return this.c.set(i,i),this}clear(){this.c.clear()}delete(i){return this.c.delete(i)}forEach(i,s){this.c.forEach((f,u)=>i.call(s,u,u,this))}has(i){return this.c.has(i)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Dc=E;var l;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(l||(e.Touch=l={}));class k{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(i){return this.c.has(i)}get(i,s=l.None){const f=this.c.get(i);if(f)return s!==l.None&&this.m(f,s),f.value}set(i,s,f=l.None){let u=this.c.get(i);if(u)u.value=s,f!==l.None&&this.m(u,f);else{switch(u={key:i,value:s,next:void 0,previous:void 0},f){case l.None:this.k(u);break;case l.AsOld:this.j(u);break;case l.AsNew:this.k(u);break;default:this.k(u);break}this.c.set(i,u),this.f++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this.c.get(i);if(s)return this.c.delete(i),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const i=this.d;return this.c.delete(i.key),this.l(i),this.f--,i.value}forEach(i,s){const f=this.g;let u=this.d;for(;u;){if(s?i.bind(s)(u.value,u.key,this):i(u.value,u.key,this),this.g!==f)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const i=this,s=this.g;let f=this.d;const u={[Symbol.iterator](){return u},next(){if(i.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const w={value:f.key,done:!1};return f=f.next,w}else return{value:void 0,done:!0}}};return u}values(){const i=this,s=this.g;let f=this.d;const u={[Symbol.iterator](){return u},next(){if(i.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const w={value:f.value,done:!1};return f=f.next,w}else return{value:void 0,done:!0}}};return u}entries(){const i=this,s=this.g;let f=this.d;const u={[Symbol.iterator](){return u},next(){if(i.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const w={value:[f.key,f.value],done:!1};return f=f.next,w}else return{value:void 0,done:!0}}};return u}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this.d,f=this.size;for(;s&&f>i;)this.c.delete(s.key),s=s.next,f--;this.d=s,this.f=f,s&&(s.previous=void 0),this.g++}i(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this.e,f=this.size;for(;s&&f>i;)this.c.delete(s.key),s=s.previous,f--;this.e=s,this.f=f,s&&(s.next=void 0),this.g++}j(i){if(!this.d&&!this.e)this.e=i;else if(this.d)i.next=this.d,this.d.previous=i;else throw new Error("Invalid list");this.d=i,this.g++}k(i){if(!this.d&&!this.e)this.d=i;else if(this.e)i.previous=this.e,this.e.next=i;else throw new Error("Invalid list");this.e=i,this.g++}l(i){if(i===this.d&&i===this.e)this.d=void 0,this.e=void 0;else if(i===this.d){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.d=i.next}else if(i===this.e){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.e=i.previous}else{const s=i.next,f=i.previous;if(!s||!f)throw new Error("Invalid list");s.previous=f,f.next=s}i.next=void 0,i.previous=void 0,this.g++}m(i,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==l.AsOld&&s!==l.AsNew)){if(s===l.AsOld){if(i===this.d)return;const f=i.next,u=i.previous;i===this.e?(u.next=void 0,this.e=u):(f.previous=u,u.next=f),i.previous=void 0,i.next=this.d,this.d.previous=i,this.d=i,this.g++}else if(s===l.AsNew){if(i===this.e)return;const f=i.next,u=i.previous;i===this.d?(f.previous=void 0,this.d=f):(f.previous=u,u.next=f),i.next=void 0,i.previous=this.e,this.e.next=i,this.e=i,this.g++}}}toJSON(){const i=[];return this.forEach((s,f)=>{i.push([f,s])}),i}fromJSON(i){this.clear();for(const[s,f]of i)this.set(s,f)}}e.$Ec=k;class p extends k{constructor(i,s=1){super(),this.n=i,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(i){this.n=i,this.p()}get ratio(){return this.o}set ratio(i){this.o=Math.min(Math.max(0,i),1),this.p()}get(i,s=l.AsNew){return super.get(i,s)}peek(i){return super.get(i,l.None)}set(i,s){return super.set(i,s,l.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class c extends p{constructor(i,s=1){super(i,s)}q(i){this.h(i)}set(i,s){return super.set(i,s),this.p(),this}}e.$Fc=c;class m extends p{constructor(i,s=1){super(i,s)}q(i){this.i(i)}set(i,s){return this.n<=this.size&&!this.has(i)&&this.q(Math.round(this.n*this.o)-1),super.set(i,s),this}}e.$Gc=m;class d{constructor(){this.c=new Map}add(i){return this.c.set(i,(this.c.get(i)||0)+1),this}delete(i){let s=this.c.get(i)||0;return s===0?!1:(s--,s===0?this.c.delete(i):this.c.set(i,s),!0)}has(i){return this.c.has(i)}}e.$Hc=d;class g{constructor(i){if(this.c=new Map,this.d=new Map,i)for(const[s,f]of i)this.set(s,f)}clear(){this.c.clear(),this.d.clear()}set(i,s){this.c.set(i,s),this.d.set(s,i)}get(i){return this.c.get(i)}getKey(i){return this.d.get(i)}delete(i){const s=this.c.get(i);return s===void 0?!1:(this.c.delete(i),this.d.delete(s),!0)}forEach(i,s){this.c.forEach((f,u)=>{i.call(s,f,u,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Ic=g;class n{constructor(){this.c=new Map}add(i,s){let f=this.c.get(i);f||(f=new Set,this.c.set(i,f)),f.add(s)}delete(i,s){const f=this.c.get(i);f&&(f.delete(s),f.size===0&&this.c.delete(i))}forEach(i,s){const f=this.c.get(i);f&&f.forEach(s)}get(i){const s=this.c.get(i);return s||new Set}}e.$Jc=n;function o(t,i){if(t===i)return!0;if(t.size!==i.size)return!1;for(const[s,f]of t)if(!i.has(s)||i.get(s)!==f)return!1;for(const[s]of i)if(!t.has(s))return!1;return!0}}),define(ye[3],Se([1,0,19,79,29,80,40]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Lc=void 0,e.$Mc=I,e.$Nc=E,e.$Oc=l,e.$Pc=c,e.$Qc=m,e.$Rc=d,e.$Sc=g,e.$Tc=n,e.$Uc=o,e.$5c=C;const R=!1;let $=null;class a{constructor(){this.b=new Map}static{this.a=0}c(v){let M=this.b.get(v);return M||(M={parent:null,source:null,isSingleton:!1,value:v,idx:a.a++},this.b.set(v,M)),M}trackDisposable(v){const M=this.c(v);M.source||(M.source=new Error().stack)}setParent(v,M){const N=this.c(v);N.parent=M}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,M){const N=M.get(v);if(N)return N;const L=v.parent?this.f(this.c(v.parent),M):v;return M.set(v,L),L}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,v).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(v=10,M){let N;if(M)N=M;else{const B=new Map,_=[...this.b.values()].filter(U=>U.source!==null&&!this.f(U,B).isSingleton);if(_.length===0)return;const re=new Set(_.map(U=>U.value));if(N=_.filter(U=>!(U.parent&&re.has(U.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function L(B){function _(U,G){for(;U.length>0&&G.some(Q=>typeof Q=="string"?Q===U[0]:U[0].match(Q));)U.shift()}const re=B.source.split(`
`).map(U=>U.trim().replace("at ","")).filter(U=>U!=="");return _(re,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),re.reverse()}const j=new P.$Jc;for(const B of N){const _=L(B);for(let re=0;re<=_.length;re++)j.add(_.slice(0,re).join(`
`),B)}N.sort((0,r.$8b)(B=>B.idx,r.$0b));let z="",F=0;for(const B of N.slice(0,v)){F++;const _=L(B),re=[];for(let U=0;U<_.length;U++){let G=_[U];G=`(shared with ${j.get(_.slice(0,U+1).join(`
`)).size}/${N.length} leaks) at ${G}`;const ee=j.get(_.slice(0,U).join(`
`)),he=(0,h.$K)([...ee].map(ne=>L(ne)[U]),ne=>ne);delete he[_[U]];for(const[ne,De]of Object.entries(he))re.unshift(`    - stacktraces of ${De.length} other leaks continue with ${ne}`);re.unshift(G)}z+=`


==================== Leaking disposable ${F}/${N.length}: ${B.value.constructor.name} ====================
${re.join(`
`)}
============================================================

`}return N.length>v&&(z+=`


... and ${N.length-v} more leaking disposables

`),{leaks:N,details:z}}}e.$Lc=a;function I(b){$=b}if(R){const b="__is_disposable_tracked__";I(new class{trackDisposable(v){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[b]||console.log(M)},3e3)}setParent(v,M){if(v&&v!==i.None)try{v[b]=!0}catch{}}markAsDisposed(v){if(v&&v!==i.None)try{v[b]=!0}catch{}}markAsSingleton(v){}})}function E(b){return $?.trackDisposable(b),b}function l(b){$?.markAsDisposed(b)}function k(b,v){$?.setParent(b,v)}function p(b,v){if($)for(const M of b)$.setParent(M,v)}function c(b){return $?.markAsSingleton(b),b}function m(b){return typeof b=="object"&&b!==null&&typeof b.dispose=="function"&&b.dispose.length===0}function d(b){if(T.Iterable.is(b)){const v=[];for(const M of b)if(M)try{M.dispose()}catch(N){v.push(N)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}function g(b){for(const v of b)m(v)&&v.dispose();return[]}function n(...b){const v=o(()=>d(b));return p(b,v),v}function o(b){const v=E({dispose:(0,O.$fb)(()=>{l(v),b()})});return v}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(l(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return k(v,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),k(v,null))}}e.$Vc=t;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,E(this),k(this.q,this)}dispose(){l(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Wc=i;class s{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&k(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,l(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&k(v,null),v}}e.$Xc=s;class f{constructor(v){this.a=new s,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Yc=f;class u{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Zc=u;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(v){let M=v;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,l(this))},this}}e.$1c=w;class y{constructor(){this.a=new Map}acquire(v,...M){let N=this.a.get(v);N||(N={counter:0,object:this.b(v,...M)},this.a.set(v,N));const{object:L}=N,j=(0,O.$fb)(()=>{--N.counter===0&&(this.c(v,N.object),this.a.delete(v))});return N.counter++,{object:L,dispose:j}}}e.$2c=y;class D{constructor(v){this.a=v}async acquire(v,...M){const N=this.a.acquire(v,...M);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(L){throw N.dispose(),L}}}e.$3c=D;class S{constructor(v){this.object=v}dispose(){}}e.$4c=S;function C(b){const v=new t;try{b(v)}finally{v.dispose()}}class A{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){l(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,M,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(v)?.dispose(),this.a.set(v,M)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const M=this.a.get(v);return this.a.delete(v),M}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$6c=A}),function(ce,e){typeof define=="function"&&define.amd?define(ye[177],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ce=typeof globalThis<"u"?globalThis:ce||self,e(ce.marked={}))}(this,function(ce){"use strict";function e(te,le){for(var ue=0;ue<le.length;ue++){var X=le[ue];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(te,X.key,X)}}function r(te,le,ue){return le&&e(te.prototype,le),ue&&e(te,ue),Object.defineProperty(te,"prototype",{writable:!1}),te}function h(te,le){if(te){if(typeof te=="string")return P(te,le);var ue=Object.prototype.toString.call(te).slice(8,-1);if(ue==="Object"&&te.constructor&&(ue=te.constructor.name),ue==="Map"||ue==="Set")return Array.from(te);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return P(te,le)}}function P(te,le){(le==null||le>te.length)&&(le=te.length);for(var ue=0,X=new Array(le);ue<le;ue++)X[ue]=te[ue];return X}function O(te,le){var ue=typeof Symbol<"u"&&te[Symbol.iterator]||te["@@iterator"];if(ue)return(ue=ue.call(te)).next.bind(ue);if(Array.isArray(te)||(ue=h(te))||le&&te&&typeof te.length=="number"){ue&&(te=ue);var X=0;return function(){return X>=te.length?{done:!0}:{done:!1,value:te[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ce.defaults=T();function R(te){ce.defaults=te}var $=/[&<>"']/,a=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(le){return l[le]};function p(te,le){if(le){if($.test(te))return te.replace(a,k)}else if(I.test(te))return te.replace(E,k);return te}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(te){return te.replace(c,function(le,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var d=/(^|[^\[])\^/g;function g(te,le){te=typeof te=="string"?te:te.source,le=le||"";var ue={replace:function(oe,pe){return pe=pe.source||pe,pe=pe.replace(d,"$1"),te=te.replace(oe,pe),ue},getRegex:function(){return new RegExp(te,le)}};return ue}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(te,le,ue){if(te){var X;try{X=decodeURIComponent(m(ue)).replace(n,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}le&&!o.test(ue)&&(ue=w(le,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var i={},s=/^[^:]+:\/*[^/]*$/,f=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(te,le){i[" "+te]||(s.test(te)?i[" "+te]=te+"/":i[" "+te]=C(te,"/",!0)),te=i[" "+te];var ue=te.indexOf(":")===-1;return le.substring(0,2)==="//"?ue?le:te.replace(f,"$1")+le:le.charAt(0)==="/"?ue?le:te.replace(u,"$1")+le:te+le}var y={exec:function(){}};function D(te){for(var le=1,ue,X;le<arguments.length;le++){ue=arguments[le];for(X in ue)Object.prototype.hasOwnProperty.call(ue,X)&&(te[X]=ue[X])}return te}function S(te,le){var ue=te.replace(/\|/g,function(pe,we,Fe){for(var Ue=!1,ke=we;--ke>=0&&Fe[ke]==="\\";)Ue=!Ue;return Ue?"|":" |"}),X=ue.split(/ \|/),oe=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>le)X.splice(le);else for(;X.length<le;)X.push("");for(;oe<X.length;oe++)X[oe]=X[oe].trim().replace(/\\\|/g,"|");return X}function C(te,le,ue){var X=te.length;if(X===0)return"";for(var oe=0;oe<X;){var pe=te.charAt(X-oe-1);if(pe===le&&!ue)oe++;else if(pe!==le&&ue)oe++;else break}return te.slice(0,X-oe)}function A(te,le){if(te.indexOf(le[1])===-1)return-1;for(var ue=te.length,X=0,oe=0;oe<ue;oe++)if(te[oe]==="\\")oe++;else if(te[oe]===le[0])X++;else if(te[oe]===le[1]&&(X--,X<0))return oe;return-1}function b(te){te&&te.sanitize&&!te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function v(te,le){if(le<1)return"";for(var ue="";le>1;)le&1&&(ue+=te),le>>=1,te+=te;return ue+te}function M(te,le,ue,X){var oe=le.href,pe=le.title?p(le.title):null,we=te[1].replace(/\\([\[\]])/g,"$1");if(te[0].charAt(0)!=="!"){X.state.inLink=!0;var Fe={type:"link",raw:ue,href:oe,title:pe,text:we,tokens:X.inlineTokens(we)};return X.state.inLink=!1,Fe}return{type:"image",raw:ue,href:oe,title:pe,text:p(we)}}function N(te,le){var ue=te.match(/^(\s+)(?:```)/);if(ue===null)return le;var X=ue[1];return le.split(`
`).map(function(oe){var pe=oe.match(/^\s+/);if(pe===null)return oe;var we=pe[0];return we.length>=X.length?oe.slice(X.length):oe}).join(`
`)}var L=function(){function te(ue){this.options=ue||ce.defaults}var le=te.prototype;return le.space=function(X){var oe=this.rules.block.newline.exec(X);if(oe&&oe[0].length>0)return{type:"space",raw:oe[0]}},le.code=function(X){var oe=this.rules.block.code.exec(X);if(oe){var pe=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:C(pe,`
`)}}},le.fences=function(X){var oe=this.rules.block.fences.exec(X);if(oe){var pe=oe[0],we=N(pe,oe[3]||"");return{type:"code",raw:pe,lang:oe[2]?oe[2].trim():oe[2],text:we}}},le.heading=function(X){var oe=this.rules.block.heading.exec(X);if(oe){var pe=oe[2].trim();if(/#$/.test(pe)){var we=C(pe,"#");(this.options.pedantic||!we||/ $/.test(we))&&(pe=we.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:pe,tokens:this.lexer.inline(pe)}}},le.hr=function(X){var oe=this.rules.block.hr.exec(X);if(oe)return{type:"hr",raw:oe[0]}},le.blockquote=function(X){var oe=this.rules.block.blockquote.exec(X);if(oe){var pe=oe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},le.list=function(X){var oe=this.rules.block.list.exec(X);if(oe){var pe,we,Fe,Ue,ke,Ie,Oe,q,V,J,x,fe,be=oe[1].trim(),Ne=be.length>1,Ge={type:"list",raw:"",ordered:Ne,start:Ne?+be.slice(0,-1):"",loose:!1,items:[]};be=Ne?"\\d{1,9}\\"+be.slice(-1):"\\"+be,this.options.pedantic&&(be=Ne?be:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+be+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(fe=!1,!(!(oe=Ze.exec(X))||this.rules.block.hr.test(X)));){if(pe=oe[0],X=X.substring(pe.length),q=oe[2].split(`
`,1)[0],V=X.split(`
`,1)[0],this.options.pedantic?(Ue=2,x=q.trimLeft()):(Ue=oe[2].search(/[^ ]/),Ue=Ue>4?1:Ue,x=q.slice(Ue),Ue+=oe[1].length),Ie=!1,!q&&/^ *$/.test(V)&&(pe+=V+`
`,X=X.substring(V.length+1),fe=!0),!fe)for(var et=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}#");X&&(J=X.split(`
`,1)[0],q=J,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(q)||nt.test(q)||et.test(q)||rt.test(X)));){if(q.search(/[^ ]/)>=Ue||!q.trim())x+=`
`+q.slice(Ue);else if(!Ie)x+=`
`+q;else break;!Ie&&!q.trim()&&(Ie=!0),pe+=J+`
`,X=X.substring(J.length+1)}Ge.loose||(Oe?Ge.loose=!0:/\n *\n *$/.test(pe)&&(Oe=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(x),we&&(Fe=we[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:pe,task:!!we,checked:Fe,loose:!1,text:x}),Ge.raw+=pe}Ge.items[Ge.items.length-1].raw=pe.trimRight(),Ge.items[Ge.items.length-1].text=x.trimRight(),Ge.raw=Ge.raw.trimRight();var ct=Ge.items.length;for(ke=0;ke<ct;ke++){this.lexer.state.top=!1,Ge.items[ke].tokens=this.lexer.blockTokens(Ge.items[ke].text,[]);var mt=Ge.items[ke].tokens.filter(function(at){return at.type==="space"}),ht=mt.every(function(at){for(var Pe=at.raw.split(""),ze=0,He=O(Pe),Le;!(Le=He()).done;){var je=Le.value;if(je===`
`&&(ze+=1),ze>1)return!0}return!1});!Ge.loose&&mt.length&&ht&&(Ge.loose=!0,Ge.items[ke].loose=!0)}return Ge}},le.html=function(X){var oe=this.rules.block.html.exec(X);if(oe){var pe={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(oe[0]):p(oe[0]);pe.type="paragraph",pe.text=we,pe.tokens=this.lexer.inline(we)}return pe}},le.def=function(X){var oe=this.rules.block.def.exec(X);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var pe=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:oe[0],href:oe[2],title:oe[3]}}},le.table=function(X){var oe=this.rules.block.table.exec(X);if(oe){var pe={type:"table",header:S(oe[1]).map(function(Oe){return{text:Oe}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]&&oe[3].trim()?oe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=oe[0];var we=pe.align.length,Fe,Ue,ke,Ie;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(pe.align[Fe])?pe.align[Fe]="right":/^ *:-+: *$/.test(pe.align[Fe])?pe.align[Fe]="center":/^ *:-+ *$/.test(pe.align[Fe])?pe.align[Fe]="left":pe.align[Fe]=null;for(we=pe.rows.length,Fe=0;Fe<we;Fe++)pe.rows[Fe]=S(pe.rows[Fe],pe.header.length).map(function(Oe){return{text:Oe}});for(we=pe.header.length,Ue=0;Ue<we;Ue++)pe.header[Ue].tokens=this.lexer.inline(pe.header[Ue].text);for(we=pe.rows.length,Ue=0;Ue<we;Ue++)for(Ie=pe.rows[Ue],ke=0;ke<Ie.length;ke++)Ie[ke].tokens=this.lexer.inline(Ie[ke].text);return pe}}},le.lheading=function(X){var oe=this.rules.block.lheading.exec(X);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:this.lexer.inline(oe[1])}},le.paragraph=function(X){var oe=this.rules.block.paragraph.exec(X);if(oe){var pe=oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1];return{type:"paragraph",raw:oe[0],text:pe,tokens:this.lexer.inline(pe)}}},le.text=function(X){var oe=this.rules.block.text.exec(X);if(oe)return{type:"text",raw:oe[0],text:oe[0],tokens:this.lexer.inline(oe[0])}},le.escape=function(X){var oe=this.rules.inline.escape.exec(X);if(oe)return{type:"escape",raw:oe[0],text:p(oe[1])}},le.tag=function(X){var oe=this.rules.inline.tag.exec(X);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):p(oe[0]):oe[0]}},le.link=function(X){var oe=this.rules.inline.link.exec(X);if(oe){var pe=oe[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var we=C(pe.slice(0,-1),"\\");if((pe.length-we.length)%2===0)return}else{var Fe=A(oe[2],"()");if(Fe>-1){var Ue=oe[0].indexOf("!")===0?5:4,ke=Ue+oe[1].length+Fe;oe[2]=oe[2].substring(0,Fe),oe[0]=oe[0].substring(0,ke).trim(),oe[3]=""}}var Ie=oe[2],Oe="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);q&&(Ie=q[1],Oe=q[3])}else Oe=oe[3]?oe[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(pe)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),M(oe,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},le.reflink=function(X,oe){var pe;if((pe=this.rules.inline.reflink.exec(X))||(pe=this.rules.inline.nolink.exec(X))){var we=(pe[2]||pe[1]).replace(/\s+/g," ");if(we=oe[we.toLowerCase()],!we||!we.href){var Fe=pe[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return M(pe,we,pe[0],this.lexer)}},le.emStrong=function(X,oe,pe){pe===void 0&&(pe="");var we=this.rules.inline.emStrong.lDelim.exec(X);if(we&&!(we[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(pe===""||this.rules.inline.punctuation.exec(pe))){var Ue=we[0].length-1,ke,Ie,Oe=Ue,q=0,V=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,oe=oe.slice(-1*X.length+Ue);(we=V.exec(oe))!=null;)if(ke=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!ke){if(Ie=ke.length,we[3]||we[4]){Oe+=Ie;continue}else if((we[5]||we[6])&&Ue%3&&!((Ue+Ie)%3)){q+=Ie;continue}if(Oe-=Ie,!(Oe>0)){if(Ie=Math.min(Ie,Ie+Oe+q),Math.min(Ue,Ie)%2){var J=X.slice(1,Ue+we.index+Ie);return{type:"em",raw:X.slice(0,Ue+we.index+Ie+1),text:J,tokens:this.lexer.inlineTokens(J)}}var x=X.slice(2,Ue+we.index+Ie-1);return{type:"strong",raw:X.slice(0,Ue+we.index+Ie+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},le.codespan=function(X){var oe=this.rules.inline.code.exec(X);if(oe){var pe=oe[2].replace(/\n/g," "),we=/[^ ]/.test(pe),Fe=/^ /.test(pe)&&/ $/.test(pe);return we&&Fe&&(pe=pe.substring(1,pe.length-1)),pe=p(pe,!0),{type:"codespan",raw:oe[0],text:pe}}},le.br=function(X){var oe=this.rules.inline.br.exec(X);if(oe)return{type:"br",raw:oe[0]}},le.del=function(X){var oe=this.rules.inline.del.exec(X);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2])}},le.autolink=function(X,oe){var pe=this.rules.inline.autolink.exec(X);if(pe){var we,Fe;return pe[2]==="@"?(we=p(this.options.mangle?oe(pe[1]):pe[1]),Fe="mailto:"+we):(we=p(pe[1]),Fe=we),{type:"link",raw:pe[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},le.url=function(X,oe){var pe;if(pe=this.rules.inline.url.exec(X)){var we,Fe;if(pe[2]==="@")we=p(this.options.mangle?oe(pe[0]):pe[0]),Fe="mailto:"+we;else{var Ue;do Ue=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(Ue!==pe[0]);we=p(pe[0]),pe[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:pe[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},le.inlineText=function(X,oe){var pe=this.rules.inline.text.exec(X);if(pe){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):p(pe[0]):pe[0]:we=p(this.options.smartypants?oe(pe[0]):pe[0]),{type:"text",raw:pe[0],text:we}}},te}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=g(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=g(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=g(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=g(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=g(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=g(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=D({},j),j.gfm=D({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=g(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=g(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=D({},j.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:y,paragraph:g(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=g(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=g(j._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=g(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=g(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=g(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=g(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=g(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=g(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=g(z.reflink).replace("label",z._label).replace("ref",j._label).getRegex(),z.nolink=g(z.nolink).replace("ref",j._label).getRegex(),z.reflinkSearch=g(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=D({},z),z.pedantic=D({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=D({},z.normal,{escape:g(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=g(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=D({},z.gfm,{br:g(z.br).replace("{2,}","*").getRegex(),text:g(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(te){return te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(te){var le="",ue,X,oe=te.length;for(ue=0;ue<oe;ue++)X=te.charCodeAt(ue),Math.random()>.5&&(X="x"+X.toString(16)),le+="&#"+X+";";return le}var _=function(){function te(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||ce.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:j.normal,inline:z.normal};this.options.pedantic?(X.block=j.pedantic,X.inline=z.pedantic):this.options.gfm&&(X.block=j.gfm,this.options.breaks?X.inline=z.breaks:X.inline=z.gfm),this.tokenizer.rules=X}te.lex=function(X,oe){var pe=new te(oe);return pe.lex(X)},te.lexInline=function(X,oe){var pe=new te(oe);return pe.inlineTokens(X)};var le=te.prototype;return le.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},le.blockTokens=function(X,oe){var pe=this;oe===void 0&&(oe=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Oe,q,V){return q+"    ".repeat(V.length)});for(var we,Fe,Ue,ke;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Oe){return(we=Oe.call({lexer:pe},X,oe))?(X=X.substring(we.raw.length),oe.push(we),!0):!1}))){if(we=this.tokenizer.space(X)){X=X.substring(we.raw.length),we.raw.length===1&&oe.length>0?oe[oe.length-1].raw+=`
`:oe.push(we);continue}if(we=this.tokenizer.code(X)){X=X.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):oe.push(we);continue}if(we=this.tokenizer.fences(X)){X=X.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.heading(X)){X=X.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.hr(X)){X=X.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.blockquote(X)){X=X.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.list(X)){X=X.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.html(X)){X=X.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.def(X)){X=X.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(X)){X=X.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.lheading(X)){X=X.substring(we.raw.length),oe.push(we);continue}if(Ue=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Oe=1/0,q=X.slice(1),V=void 0;pe.options.extensions.startBlock.forEach(function(J){V=J.call({lexer:this},q),typeof V=="number"&&V>=0&&(Oe=Math.min(Oe,V))}),Oe<1/0&&Oe>=0&&(Ue=X.substring(0,Oe+1))}(),this.state.top&&(we=this.tokenizer.paragraph(Ue))){Fe=oe[oe.length-1],ke&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):oe.push(we),ke=Ue.length!==X.length,X=X.substring(we.raw.length);continue}if(we=this.tokenizer.text(X)){X=X.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):oe.push(we);continue}if(X){var Ie="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,oe},le.inline=function(X,oe){return oe===void 0&&(oe=[]),this.inlineQueue.push({src:X,tokens:oe}),oe},le.inlineTokens=function(X,oe){var pe=this;oe===void 0&&(oe=[]);var we,Fe,Ue,ke=X,Ie,Oe,q;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)V.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ie.index)+"["+v("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"["+v("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Oe||(q=""),Oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(we=x.call({lexer:pe},X,oe))?(X=X.substring(we.raw.length),oe.push(we),!0):!1}))){if(we=this.tokenizer.escape(X)){X=X.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.tag(X)){X=X.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):oe.push(we);continue}if(we=this.tokenizer.link(X)){X=X.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):oe.push(we);continue}if(we=this.tokenizer.emStrong(X,ke,q)){X=X.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.codespan(X)){X=X.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.br(X)){X=X.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.del(X)){X=X.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.autolink(X,B)){X=X.substring(we.raw.length),oe.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(X,B))){X=X.substring(we.raw.length),oe.push(we);continue}if(Ue=X,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,fe=X.slice(1),be=void 0;pe.options.extensions.startInline.forEach(function(Ne){be=Ne.call({lexer:this},fe),typeof be=="number"&&be>=0&&(x=Math.min(x,be))}),x<1/0&&x>=0&&(Ue=X.substring(0,x+1))}(),we=this.tokenizer.inlineText(Ue,F)){X=X.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(q=we.raw.slice(-1)),Oe=!0,Fe=oe[oe.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):oe.push(we);continue}if(X){var J="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return oe},r(te,null,[{key:"rules",get:function(){return{block:j,inline:z}}}]),te}(),re=function(){function te(ue){this.options=ue||ce.defaults}var le=te.prototype;return le.code=function(X,oe,pe){var we=(oe||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(X,we);Fe!=null&&Fe!==X&&(pe=!0,X=Fe)}return X=X.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+p(we,!0)+'">'+(pe?X:p(X,!0))+`</code></pre>
`:"<pre><code>"+(pe?X:p(X,!0))+`</code></pre>
`},le.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},le.html=function(X){return X},le.heading=function(X,oe,pe,we){if(this.options.headerIds){var Fe=this.options.headerPrefix+we.slug(pe);return"<h"+oe+' id="'+Fe+'">'+X+"</h"+oe+`>
`}return"<h"+oe+">"+X+"</h"+oe+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(X,oe,pe){var we=oe?"ol":"ul",Fe=oe&&pe!==1?' start="'+pe+'"':"";return"<"+we+Fe+`>
`+X+"</"+we+`>
`},le.listitem=function(X){return"<li>"+X+`</li>
`},le.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(X){return"<p>"+X+`</p>
`},le.table=function(X,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+oe+`</table>
`},le.tablerow=function(X){return`<tr>
`+X+`</tr>
`},le.tablecell=function(X,oe){var pe=oe.header?"th":"td",we=oe.align?"<"+pe+' align="'+oe.align+'">':"<"+pe+">";return we+X+("</"+pe+`>
`)},le.strong=function(X){return"<strong>"+X+"</strong>"},le.em=function(X){return"<em>"+X+"</em>"},le.codespan=function(X){return"<code>"+X+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(X){return"<del>"+X+"</del>"},le.link=function(X,oe,pe){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var we='<a href="'+p(X)+'"';return oe&&(we+=' title="'+oe+'"'),we+=">"+pe+"</a>",we},le.image=function(X,oe,pe){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var we='<img src="'+X+'" alt="'+pe+'"';return oe&&(we+=' title="'+oe+'"'),we+=this.options.xhtml?"/>":">",we},le.text=function(X){return X},te}(),U=function(){function te(){}var le=te.prototype;return le.strong=function(X){return X},le.em=function(X){return X},le.codespan=function(X){return X},le.del=function(X){return X},le.html=function(X){return X},le.text=function(X){return X},le.link=function(X,oe,pe){return""+pe},le.image=function(X,oe,pe){return""+pe},le.br=function(){return""},te}(),G=function(){function te(){this.seen={}}var le=te.prototype;return le.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(X,oe){var pe=X,we=0;if(this.seen.hasOwnProperty(pe)){we=this.seen[X];do we++,pe=X+"-"+we;while(this.seen.hasOwnProperty(pe))}return oe||(this.seen[X]=we,this.seen[pe]=0),pe},le.slug=function(X,oe){oe===void 0&&(oe={});var pe=this.serialize(X);return this.getNextSafeSlug(pe,oe.dryrun)},te}(),Q=function(){function te(ue){this.options=ue||ce.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new U,this.slugger=new G}te.parse=function(X,oe){var pe=new te(oe);return pe.parse(X)},te.parseInline=function(X,oe){var pe=new te(oe);return pe.parseInline(X)};var le=te.prototype;return le.parse=function(X,oe){oe===void 0&&(oe=!0);var pe="",we,Fe,Ue,ke,Ie,Oe,q,V,J,x,fe,be,Ne,Ge,Ze,et,rt,ot,nt,ct=X.length;for(we=0;we<ct;we++){if(x=X[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(nt=this.options.extensions.renderers[x.type].call({parser:this},x),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){pe+=nt||"";continue}switch(x.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(x.tokens),x.depth,m(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(V="",q="",ke=x.header.length,Fe=0;Fe<ke;Fe++)q+=this.renderer.tablecell(this.parseInline(x.header[Fe].tokens),{header:!0,align:x.align[Fe]});for(V+=this.renderer.tablerow(q),J="",ke=x.rows.length,Fe=0;Fe<ke;Fe++){for(Oe=x.rows[Fe],q="",Ie=Oe.length,Ue=0;Ue<Ie;Ue++)q+=this.renderer.tablecell(this.parseInline(Oe[Ue].tokens),{header:!1,align:x.align[Ue]});J+=this.renderer.tablerow(q)}pe+=this.renderer.table(V,J);continue}case"blockquote":{J=this.parse(x.tokens),pe+=this.renderer.blockquote(J);continue}case"list":{for(fe=x.ordered,be=x.start,Ne=x.loose,ke=x.items.length,J="",Fe=0;Fe<ke;Fe++)Ze=x.items[Fe],et=Ze.checked,rt=Ze.task,Ge="",Ze.task&&(ot=this.renderer.checkbox(et),Ne?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=ot+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=ot+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:ot}):Ge+=ot),Ge+=this.parse(Ze.tokens,Ne),J+=this.renderer.listitem(Ge,rt,et);pe+=this.renderer.list(J,fe,be);continue}case"html":{pe+=this.renderer.html(x.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(J=x.tokens?this.parseInline(x.tokens):x.text;we+1<ct&&X[we+1].type==="text";)x=X[++we],J+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);pe+=oe?this.renderer.paragraph(J):J;continue}default:{var mt='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(mt);return}else throw new Error(mt)}}}return pe},le.parseInline=function(X,oe){oe=oe||this.renderer;var pe="",we,Fe,Ue,ke=X.length;for(we=0;we<ke;we++){if(Fe=X[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ue=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){pe+=Ue||"";continue}switch(Fe.type){case"escape":{pe+=oe.text(Fe.text);break}case"html":{pe+=oe.html(Fe.text);break}case"link":{pe+=oe.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,oe));break}case"image":{pe+=oe.image(Fe.href,Fe.title,Fe.text);break}case"strong":{pe+=oe.strong(this.parseInline(Fe.tokens,oe));break}case"em":{pe+=oe.em(this.parseInline(Fe.tokens,oe));break}case"codespan":{pe+=oe.codespan(Fe.text);break}case"br":{pe+=oe.br();break}case"del":{pe+=oe.del(this.parseInline(Fe.tokens,oe));break}case"text":{pe+=oe.text(Fe.text);break}default:{var Ie='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return pe},te}();function ee(te,le,ue){if(typeof te>"u"||te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");if(typeof le=="function"&&(ue=le,le=null),le=D({},ee.defaults,le||{}),b(le),ue){var X=le.highlight,oe;try{oe=_.lex(te,le)}catch(ke){return ue(ke)}var pe=function(Ie){var Oe;if(!Ie)try{le.walkTokens&&ee.walkTokens(oe,le.walkTokens),Oe=Q.parse(oe,le)}catch(q){Ie=q}return le.highlight=X,Ie?ue(Ie):ue(null,Oe)};if(!X||X.length<3||(delete le.highlight,!oe.length))return pe();var we=0;ee.walkTokens(oe,function(ke){ke.type==="code"&&(we++,setTimeout(function(){X(ke.text,ke.lang,function(Ie,Oe){if(Ie)return pe(Ie);Oe!=null&&Oe!==ke.text&&(ke.text=Oe,ke.escaped=!0),we--,we===0&&pe()})},0))}),we===0&&pe();return}function Fe(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+p(ke.message+"",!0)+"</pre>";throw ke}try{var Ue=_.lex(te,le);if(le.walkTokens){if(le.async)return Promise.all(ee.walkTokens(Ue,le.walkTokens)).then(function(){return Q.parse(Ue,le)}).catch(Fe);ee.walkTokens(Ue,le.walkTokens)}return Q.parse(Ue,le)}catch(ke){Fe(ke)}}ee.options=ee.setOptions=function(te){return D(ee.defaults,te),R(ee.defaults),ee},ee.getDefaults=T,ee.defaults=ce.defaults,ee.use=function(){for(var te=arguments.length,le=new Array(te),ue=0;ue<te;ue++)le[ue]=arguments[ue];var X=D.apply(void 0,[{}].concat(le)),oe=ee.defaults.extensions||{renderers:{},childTokens:{}},pe;le.forEach(function(we){if(we.extensions&&(pe=!0,we.extensions.forEach(function(Ue){if(!Ue.name)throw new Error("extension name required");if(Ue.renderer){var ke=oe.renderers?oe.renderers[Ue.name]:null;ke?oe.renderers[Ue.name]=function(){for(var Ie=arguments.length,Oe=new Array(Ie),q=0;q<Ie;q++)Oe[q]=arguments[q];var V=Ue.renderer.apply(this,Oe);return V===!1&&(V=ke.apply(this,Oe)),V}:oe.renderers[Ue.name]=Ue.renderer}if(Ue.tokenizer){if(!Ue.level||Ue.level!=="block"&&Ue.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");oe[Ue.level]?oe[Ue.level].unshift(Ue.tokenizer):oe[Ue.level]=[Ue.tokenizer],Ue.start&&(Ue.level==="block"?oe.startBlock?oe.startBlock.push(Ue.start):oe.startBlock=[Ue.start]:Ue.level==="inline"&&(oe.startInline?oe.startInline.push(Ue.start):oe.startInline=[Ue.start]))}Ue.childTokens&&(oe.childTokens[Ue.name]=Ue.childTokens)})),we.renderer&&function(){var Ue=ee.defaults.renderer||new re,ke=function(q){var V=Ue[q];Ue[q]=function(){for(var J=arguments.length,x=new Array(J),fe=0;fe<J;fe++)x[fe]=arguments[fe];var be=we.renderer[q].apply(Ue,x);return be===!1&&(be=V.apply(Ue,x)),be}};for(var Ie in we.renderer)ke(Ie);X.renderer=Ue}(),we.tokenizer&&function(){var Ue=ee.defaults.tokenizer||new L,ke=function(q){var V=Ue[q];Ue[q]=function(){for(var J=arguments.length,x=new Array(J),fe=0;fe<J;fe++)x[fe]=arguments[fe];var be=we.tokenizer[q].apply(Ue,x);return be===!1&&(be=V.apply(Ue,x)),be}};for(var Ie in we.tokenizer)ke(Ie);X.tokenizer=Ue}(),we.walkTokens){var Fe=ee.defaults.walkTokens;X.walkTokens=function(Ue){var ke=[];return ke.push(we.walkTokens.call(this,Ue)),Fe&&(ke=ke.concat(Fe.call(this,Ue))),ke}}pe&&(X.extensions=oe),ee.setOptions(X)})},ee.walkTokens=function(te,le){for(var ue=[],X=function(){var Fe=pe.value;switch(ue=ue.concat(le.call(ee,Fe)),Fe.type){case"table":{for(var Ue=O(Fe.header),ke;!(ke=Ue()).done;){var Ie=ke.value;ue=ue.concat(ee.walkTokens(Ie.tokens,le))}for(var Oe=O(Fe.rows),q;!(q=Oe()).done;)for(var V=q.value,J=O(V),x;!(x=J()).done;){var fe=x.value;ue=ue.concat(ee.walkTokens(fe.tokens,le))}break}case"list":{ue=ue.concat(ee.walkTokens(Fe.items,le));break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[Fe.type]?ee.defaults.extensions.childTokens[Fe.type].forEach(function(be){ue=ue.concat(ee.walkTokens(Fe[be],le))}):Fe.tokens&&(ue=ue.concat(ee.walkTokens(Fe.tokens,le)))}},oe=O(te),pe;!(pe=oe()).done;)X();return ue},ee.parseInline=function(te,le){if(typeof te>"u"||te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");le=D({},ee.defaults,le||{}),b(le);try{var ue=_.lexInline(te,le);return le.walkTokens&&ee.walkTokens(ue,le.walkTokens),Q.parseInline(ue,le)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+p(X.message+"",!0)+"</pre>";throw X}},ee.Parser=Q,ee.parser=Q.parse,ee.Renderer=re,ee.TextRenderer=U,ee.Lexer=_,ee.lexer=_.lex,ee.Tokenizer=L,ee.Slugger=G,ee.parse=ee;var he=ee.options,ne=ee.setOptions,De=ee.use,$e=ee.walkTokens,K=ee.parseInline,W=ee,se=Q.parse,ae=_.lex;ce.Lexer=_,ce.Parser=Q,ce.Renderer=re,ce.Slugger=G,ce.TextRenderer=U,ce.Tokenizer=L,ce.getDefaults=T,ce.lexer=ae,ce.marked=ee,ce.options=he,ce.parse=W,ce.parseInline=K,ce.parser=se,ce.setOptions=ne,ce.use=De,ce.walkTokens=$e,Object.defineProperty(ce,"__esModule",{value:!0})}),define(ye[41],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(ye[178],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=r;function r(c){const m=O(c);if(m&&m.length>0)return new Uint32Array(m)}let h=0;const P=new Uint32Array(10);function O(c){if(h=0,T(c,E,$.InitialConsonant),h>0||(T(c,l,$.Vowel),h>0)||(T(c,k,$.FinalConsonant),h>0)||(T(c,p,$.CompatibilityJamo),h))return P.subarray(0,h);if(c>=44032&&c<=55203){const m=c-44032,d=m%588,g=Math.floor(m/588),n=Math.floor(d/28),o=d%28-1;if(g<E.length?T(g,E,0):$.InitialConsonant+g-$.CompatibilityJamo<p.length&&T($.InitialConsonant+g,p,$.CompatibilityJamo),n<l.length?T(n,l,0):$.Vowel+n-$.CompatibilityJamo<p.length&&T($.Vowel+n-$.CompatibilityJamo,p,$.CompatibilityJamo),o>=0&&(o<k.length?T(o,k,0):$.FinalConsonant+o-$.CompatibilityJamo<p.length&&T($.FinalConsonant+o-$.CompatibilityJamo,p,$.CompatibilityJamo)),h>0)return P.subarray(0,h)}}function T(c,m,d){c>=d&&c<d+m.length&&R(m[c-d])}function R(c){c!==a.NUL&&(P[h++]=c&255,c>>8&&(P[h++]=c>>8&255),c>>16&&(P[h++]=c>>16&255))}var $;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var a;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(a||(a={}));var I;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(I||(I={}));const E=new Uint8Array([a.r,a.R,a.s,a.e,a.E,a.f,a.a,a.q,a.Q,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g]),l=new Uint16Array([a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,I.hk,I.ho,I.hl,a.y,a.n,I.nj,I.np,I.nl,a.b,a.m,I.ml,a.l]),k=new Uint16Array([a.r,a.R,I.rt,a.s,I.sw,I.sg,a.e,a.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,a.a,a.q,I.qt,a.t,a.T,a.d,a.w,a.c,a.z,a.x,a.v,a.g]),p=new Uint16Array([a.r,a.R,I.rt,a.s,I.sw,I.sg,a.e,a.E,a.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,a.a,a.q,a.Q,I.qt,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g,a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,I.hk,I.ho,I.hl,a.y,a.n,I.nj,I.np,I.nl,a.b,a.m,I.ml,a.l])}),define(ye[82],Se([1,0,29]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=void 0,e.$mm=P,e.$nm=T;const h=new r.$Fc(1e4);function P(a){return $(a,"NFC",h)}const O=new r.$Fc(1e4);function T(a){return $(a,"NFD",O)}const R=/[^\u0000-\u0080]/;function $(a,I,E){if(!a)return a;const l=E.get(a);if(l)return l;let k;return R.test(a)?k=a.normalize(I):k=a,E.set(a,k),k}e.$om=function(){const a=/[\u0300-\u036f]/g;return function(I){return T(I).replace(a,"")}}()}),define(ye[134],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=r,e.rot=h,e.$Pm=R;function r($,a,I){return Math.min(Math.max($,a),I)}function h($,a){return(a+$%a)%a}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=P;class O{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=O;class T{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const I=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=T;function R($,a,I,E,l,k,p,c){const m=p-I,d=c-E,g=l-I,n=k-E,o=$-I,t=a-E,i=m*m+d*d,s=m*g+d*n,f=m*o+d*t,u=g*g+n*n,w=g*o+n*t,y=1/(i*u-s*s),D=(u*f-s*w)*y,S=(i*w-s*f)*y;return D>=0&&S>=0&&D+S<1}}),define(ye[179],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$dd=O,e.$ed=l;class r{constructor(p,c,m){this.owner=p,this.debugNameSource=c,this.referenceFn=m}getDebugName(p){return O(p,this)}}e.$cd=r;const h=new Map,P=new WeakMap;function O(k,p){const c=P.get(k);if(c)return c;const m=T(k,p);if(m){let d=h.get(m)??0;d++,h.set(m,d);const g=d===1?m:`${m}#${d}`;return P.set(k,g),g}}function T(k,p){const c=P.get(k);if(c)return c;const m=p.owner?I(p.owner)+".":"";let d;const g=p.debugNameSource;if(g!==void 0)if(typeof g=="function"){if(d=g(),d!==void 0)return m+d}else return m+g;const n=p.referenceFn;if(n!==void 0&&(d=l(n),d!==void 0))return m+d;if(p.owner!==void 0){const o=R(p.owner,k);if(o!==void 0)return m+o}}function R(k,p){for(const c in k)if(k[c]===p)return c}const $=new Map,a=new WeakMap;function I(k){const p=a.get(k);if(p)return p;const c=E(k);let m=$.get(c)??0;m++,$.set(c,m);const d=m===1?c:`${c}#${m}`;return a.set(k,d),d}function E(k){const p=k.constructor;return p?p.name:"Object"}function l(k){const p=k.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(p);return(m?m[1]:void 0)?.trim()}}),define(ye[180],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0,e.$Ld=h,e.$Md=P;let r;function h(c){r=c}function P(){return r}class O{constructor(){this.a=0,this.d=new WeakMap}b(m){return T([R(k("|  ",this.a)),m])}c(m){return m.hadValue?m.didChange?[R(" "),a(I(m.oldValue,70),{color:"red",strikeThrough:!0}),R(" "),a(I(m.newValue,60),{color:"green"})]:[R(" (unchanged)")]:[R(" "),a(I(m.newValue,60),{color:"green"}),R(" (initial)")]}handleObservableChanged(m,d){console.log(...this.b([$("observable value changed"),a(m.debugName,{color:"BlueViolet"}),...this.c(d)]))}formatChanges(m){if(m.size!==0)return a(" (changed deps: "+[...m].map(d=>d.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const d=m.handleChange;this.d.set(m,new Set),m.handleChange=(g,n)=>(this.d.get(m).add(g),d.apply(m,[g,n]))}handleDerivedRecomputed(m,d){const g=this.d.get(m);console.log(...this.b([$("derived recomputed"),a(m.debugName,{color:"BlueViolet"}),...this.c(d),this.formatChanges(g),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),g.clear()}handleFromEventObservableTriggered(m,d){console.log(...this.b([$("observable from event triggered"),a(m.debugName,{color:"BlueViolet"}),...this.c(d),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const d=m.handleChange;this.d.set(m,new Set),m.handleChange=(g,n)=>(this.d.get(m).add(g),d.apply(m,[g,n]))}handleAutorunTriggered(m){const d=this.d.get(m);console.log(...this.b([$("autorun"),a(m.debugName,{color:"BlueViolet"}),this.formatChanges(d),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),d.clear(),this.a++}handleAutorunFinished(m){this.a--}handleBeginTransaction(m){let d=m.getDebugName();d===void 0&&(d=""),console.log(...this.b([$("transaction"),a(d,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Nd=O;function T(c){const m=new Array,d=[];let g="";function n(t){if("length"in t)for(const i of t)i&&n(i);else"text"in t?(g+=`%c${t.text}`,m.push(t.style),t.data&&d.push(...t.data)):"data"in t&&d.push(...t.data)}n(c);const o=[g,...m];return o.push(...d),o}function R(c){return a(c,{color:"black"})}function $(c){return a(p(`${c}: `,10),{color:"black",bold:!0})}function a(c,m={color:"black"}){function d(n){return Object.entries(n).reduce((o,[t,i])=>`${o}${t}:${i};`,"")}const g={color:m.color};return m.strikeThrough&&(g["text-decoration"]="line-through"),m.bold&&(g["font-weight"]="bold"),{text:c,style:d(g)}}function I(c,m){switch(typeof c){case"number":return""+c;case"string":return c.length+2<=m?`"${c}"`:`"${c.substr(0,m-7)}"+...`;case"boolean":return c?"true":"false";case"undefined":return"undefined";case"object":return c===null?"null":Array.isArray(c)?E(c,m):l(c,m);case"symbol":return c.toString();case"function":return`[[Function${c.name?" "+c.name:""}]]`;default:return""+c}}function E(c,m){let d="[ ",g=!0;for(const n of c){if(g||(d+=", "),d.length-5>m){d+="...";break}g=!1,d+=`${I(n,m-d.length)}`}return d+=" ]",d}function l(c,m){let d="{ ",g=!0;for(const[n,o]of Object.entries(c)){if(g||(d+=", "),d.length-5>m){d+="...";break}g=!1,d+=`${n}: ${I(o,m-d.length)}`}return d+=" }",d}function k(c,m){let d="";for(let g=1;g<=m;g++)d+=c;return d}function p(c,m){for(;c.length<m;)c+=" ";return c}}),define(ye[181],Se([1,0,175,179,180]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=e.$8d=e.$6d=e.$1d=e.$Zd=void 0,e.$Wd=T,e.$Xd=$,e.$Yd=I,e.$2d=k,e.$3d=c,e.$4d=m,e.$5d=d,e.$7d=n,e.$9d=t;let O;function T(s){O=s}let R;function $(s){R=s}let a;function I(s){a=s}class E{get TChange(){return null}reportChanges(){this.get()}read(f){return f?f.readObservable(this):this.get()}map(f,u){const w=u===void 0?void 0:f,y=u===void 0?f:u;return a({owner:w,debugName:()=>{const D=(0,h.$ed)(y);if(D!==void 0)return D;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(y.toString());if(C)return`${this.debugName}.${C[2]}`;if(!w)return`${this.debugName} (mapped)`},debugReferenceFn:y},D=>y(this.read(D),D))}recomputeInitiallyAndOnChange(f,u){return f.add(O(this,u)),this}keepObserved(f){return f.add(R(this)),this}get a(){return this.get()}}e.$Zd=E;class l extends E{constructor(){super(...arguments),this.b=new Set}addObserver(f){const u=this.b.size;this.b.add(f),u===0&&this.c()}removeObserver(f){this.b.delete(f)&&this.b.size===0&&this.f()}c(){}f(){}}e.$1d=l;function k(s,f){const u=new g(s,f);try{s(u)}finally{u.finish()}}let p;function c(s){if(p)s(p);else{const f=new g(s,void 0);p=f;try{s(f)}finally{f.finish(),p=void 0}}}async function m(s,f){const u=new g(s,f);try{await s(u)}finally{u.finish()}}function d(s,f,u){s?f(s):k(f,u)}class g{constructor(f,u){this._fn=f,this.b=u,this.a=[],(0,P.$Md)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,h.$ed)(this._fn)}updateObserver(f,u){this.a.push({observer:f,observable:u}),f.beginUpdate(u)}finish(){const f=this.a;for(let u=0;u<f.length;u++){const{observer:w,observable:y}=f[u];w.endUpdate(y)}this.a=null,(0,P.$Md)()?.handleEndTransaction()}}e.$6d=g;function n(s,f){let u;return typeof s=="string"?u=new h.$cd(void 0,s,void 0):u=new h.$cd(s,void 0,void 0),new o(u,f,r.$8c)}class o extends l{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(f,u,w){super(),this.e=f,this.g=w,this.d=u}get(){return this.d}set(f,u,w){if(w===void 0&&this.g(this.d,f))return;let y;u||(u=y=new g(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(f),(0,P.$Md)()?.handleObservableChanged(this,{oldValue:D,newValue:f,change:w,didChange:!0,hadValue:!0});for(const S of this.b)u.updateObserver(S,this),S.handleChange(this,w)}finally{y&&y.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(f){this.d=f}}e.$8d=o;function t(s,f){let u;return typeof s=="string"?u=new h.$cd(void 0,s,void 0):u=new h.$cd(s,void 0,void 0),new i(u,f,r.$8c)}class i extends o{h(f){this.d!==f&&(this.d&&this.d.dispose(),this.d=f)}dispose(){this.d?.dispose()}}e.$0d=i}),function(){function ce(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function T($){O.push($,Date.now())}function R(){const $=[];for(let a=0;a<O.length;a+=2)$.push({name:O[a],startTime:O[a+1]});return $}return{mark:T,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ce():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const T of performance.getEntriesByType("mark"))O.push({name:T.name,startTime:Math.round(P+T.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ce(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),ce()}function r(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=r(h))}(),define(ye[182],Se([1,0,40]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SI=void 0;const h=Symbol("unset");class P{constructor(){this.a=new T,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||r.Iterable.empty()}insert($,a,I){this.d($,E=>E._value=a,I)}mutate($,a){this.d($,I=>I._value=a(I._value===h?void 0:I._value))}mutatePath($,a){this.d($,()=>{},I=>a(I))}delete($){const a=this.c($);if(!a)return;let I=a.length-1;const E=a[I].node._value;if(E!==h){for(this.b--,a[I].node._value=h;I>0;I--){const{node:l,part:k}=a[I];if(l.children?.size||l._value!==h)break;a[I-1].node.children.delete(k)}return E}}*deleteRecursive($){const a=this.c($);if(!a)return;const I=a[a.length-1].node;for(let E=a.length-1;E>0;E--){const l=a[E-1];if(l.node.children.delete(a[E].part),l.node.children.size>0||l.node._value!==h)break}for(const E of O(I))E._value!==h&&(this.b--,yield E._value)}find($){let a=this.a;for(const I of $){const E=a.children?.get(I);if(!E)return;a=E}return a._value===h?void 0:a._value}hasKeyOrParent($){let a=this.a;for(const I of $){const E=a.children?.get(I);if(!E)return!1;if(E._value!==h)return!0;a=E}return!1}hasKeyOrChildren($){let a=this.a;for(const I of $){const E=a.children?.get(I);if(!E)return!1;a=E}return!0}hasKey($){let a=this.a;for(const I of $){const E=a.children?.get(I);if(!E)return!1;a=E}return a._value!==h}c($){const a=[{part:"",node:this.a}];let I=0;for(const E of $){const l=a[I].node.children?.get(E);if(!l)return;a.push({part:E,node:l}),I++}return a}d($,a,I){let E=this.a;for(const p of $){if(E.children)if(E.children.has(p))E=E.children.get(p);else{const c=new T;E.children.set(p,c),E=c}else{const c=new T;E.children=new Map([[p,c]]),E=c}I?.(E)}const l=E._value===h?0:1;a(E);const k=E._value===h?0:1;this.b+=k-l}*values(){for(const{_value:$}of O(this.a))$!==h&&(yield $)}}e.$SI=P;function*O(R){const $=[R];for(;$.length>0;){const a=$.pop();if(yield a,a.children)for(const I of a.children.values())$.push(I)}}class T{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value($){this._value=$===void 0?h:$}}}),function(ce,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var h in r)(typeof exports=="object"?exports:ce)[h]=r[h]}}(typeof self<"u"?self:this,function(){return function(ce){var e={};function r(h){if(e[h])return e[h].exports;var P=e[h]={i:h,l:!1,exports:{}};return ce[h].call(P.exports,P,P.exports,r),P.l=!0,P.exports}return r.m=ce,r.c=e,r.d=function(h,P,O){r.o(h,P)||Object.defineProperty(h,P,{enumerable:!0,get:O})},r.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},r.t=function(h,P){if(1&P&&(h=r(h)),8&P||4&P&&typeof h=="object"&&h&&h.__esModule)return h;var O=Object.create(null);if(r.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:h}),2&P&&typeof h!="string")for(var T in h)r.d(O,T,function(R){return h[R]}.bind(null,T));return O},r.n=function(h){var P=h&&h.__esModule?function(){return h.default}:function(){return h};return r.d(P,"a",P),P},r.o=function(h,P){return Object.prototype.hasOwnProperty.call(h,P)},r.p="",r(r.s=0)}([function(ce,e,r){(function(h){var P;e=ce.exports=De,P=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],$=e.src=[],a=0,I=a++;$[I]="0|[1-9]\\d*";var E=a++;$[E]="[0-9]+";var l=a++;$[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=a++;$[k]="("+$[I]+")\\.("+$[I]+")\\.("+$[I]+")";var p=a++;$[p]="("+$[E]+")\\.("+$[E]+")\\.("+$[E]+")";var c=a++;$[c]="(?:"+$[I]+"|"+$[l]+")";var m=a++;$[m]="(?:"+$[E]+"|"+$[l]+")";var d=a++;$[d]="(?:-("+$[c]+"(?:\\."+$[c]+")*))";var g=a++;$[g]="(?:-?("+$[m]+"(?:\\."+$[m]+")*))";var n=a++;$[n]="[0-9A-Za-z-]+";var o=a++;$[o]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var t=a++,i="v?"+$[k]+$[d]+"?"+$[o]+"?";$[t]="^"+i+"$";var s="[v=\\s]*"+$[p]+$[g]+"?"+$[o]+"?",f=a++;$[f]="^"+s+"$";var u=a++;$[u]="((?:<|>)?=?)";var w=a++;$[w]=$[E]+"|x|X|\\*";var y=a++;$[y]=$[I]+"|x|X|\\*";var D=a++;$[D]="[v=\\s]*("+$[y]+")(?:\\.("+$[y]+")(?:\\.("+$[y]+")(?:"+$[d]+")?"+$[o]+"?)?)?";var S=a++;$[S]="[v=\\s]*("+$[w]+")(?:\\.("+$[w]+")(?:\\.("+$[w]+")(?:"+$[g]+")?"+$[o]+"?)?)?";var C=a++;$[C]="^"+$[u]+"\\s*"+$[D]+"$";var A=a++;$[A]="^"+$[u]+"\\s*"+$[S]+"$";var b=a++;$[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=a++;$[v]="(?:~>?)";var M=a++;$[M]="(\\s*)"+$[v]+"\\s+",R[M]=new RegExp($[M],"g");var N=a++;$[N]="^"+$[v]+$[D]+"$";var L=a++;$[L]="^"+$[v]+$[S]+"$";var j=a++;$[j]="(?:\\^)";var z=a++;$[z]="(\\s*)"+$[j]+"\\s+",R[z]=new RegExp($[z],"g");var F=a++;$[F]="^"+$[j]+$[D]+"$";var B=a++;$[B]="^"+$[j]+$[S]+"$";var _=a++;$[_]="^"+$[u]+"\\s*("+s+")$|^$";var re=a++;$[re]="^"+$[u]+"\\s*("+i+")$|^$";var U=a++;$[U]="(\\s*)"+$[u]+"\\s*("+s+"|"+$[D]+")",R[U]=new RegExp($[U],"g");var G=a++;$[G]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var Q=a++;$[Q]="^\\s*("+$[S]+")\\s+-\\s+("+$[S]+")\\s*$";var ee=a++;$[ee]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)P(he,$[he]),R[he]||(R[he]=new RegExp($[he]));function ne(V,J){if(V instanceof De)return V;if(typeof V!="string"||V.length>O||!(J?R[f]:R[t]).test(V))return null;try{return new De(V,J)}catch{return null}}function De(V,J){if(V instanceof De){if(V.loose===J)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof De))return new De(V,J);P("SemVer",V,J),this.loose=J;var x=V.trim().match(J?R[f]:R[t]);if(!x)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var be=+fe;if(be>=0&&be<T)return be}return fe}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=ne,e.valid=function(V,J){var x=ne(V,J);return x?x.version:null},e.clean=function(V,J){var x=ne(V.trim().replace(/^[=v]+/,""),J);return x?x.version:null},e.SemVer=De,De.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},De.prototype.toString=function(){return this.version},De.prototype.compare=function(V){return P("SemVer.compare",this.version,this.loose,V),V instanceof De||(V=new De(V,this.loose)),this.compareMain(V)||this.comparePre(V)},De.prototype.compareMain=function(V){return V instanceof De||(V=new De(V,this.loose)),K(this.major,V.major)||K(this.minor,V.minor)||K(this.patch,V.patch)},De.prototype.comparePre=function(V){if(V instanceof De||(V=new De(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var J=0;do{var x=this.prerelease[J],fe=V.prerelease[J];if(P("prerelease compare",J,x,fe),x===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(x===void 0)return-1;if(x!==fe)return K(x,fe)}while(++J)},De.prototype.inc=function(V,J){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,J,x,fe){typeof x=="string"&&(fe=x,x=void 0);try{return new De(V,x).inc(J,fe).version}catch{return null}},e.diff=function(V,J){if(te(V,J))return null;var x=ne(V),fe=ne(J);if(x.prerelease.length||fe.prerelease.length){for(var be in x)if((be==="major"||be==="minor"||be==="patch")&&x[be]!==fe[be])return"pre"+be;return"prerelease"}for(var be in x)if((be==="major"||be==="minor"||be==="patch")&&x[be]!==fe[be])return be},e.compareIdentifiers=K;var $e=/^[0-9]+$/;function K(V,J){var x=$e.test(V),fe=$e.test(J);return x&&fe&&(V=+V,J=+J),x&&!fe?-1:fe&&!x?1:V<J?-1:V>J?1:0}function W(V,J,x){return new De(V,x).compare(new De(J,x))}function se(V,J,x){return W(V,J,x)>0}function ae(V,J,x){return W(V,J,x)<0}function te(V,J,x){return W(V,J,x)===0}function le(V,J,x){return W(V,J,x)!==0}function ue(V,J,x){return W(V,J,x)>=0}function X(V,J,x){return W(V,J,x)<=0}function oe(V,J,x,fe){var be;switch(J){case"===":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),be=V===x;break;case"!==":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),be=V!==x;break;case"":case"=":case"==":be=te(V,x,fe);break;case"!=":be=le(V,x,fe);break;case">":be=se(V,x,fe);break;case">=":be=ue(V,x,fe);break;case"<":be=ae(V,x,fe);break;case"<=":be=X(V,x,fe);break;default:throw new TypeError("Invalid operator: "+J)}return be}function pe(V,J){if(V instanceof pe){if(V.loose===J)return V;V=V.value}if(!(this instanceof pe))return new pe(V,J);P("comparator",V,J),this.loose=J,this.parse(V),this.semver===we?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(V,J){return K(J,V)},e.major=function(V,J){return new De(V,J).major},e.minor=function(V,J){return new De(V,J).minor},e.patch=function(V,J){return new De(V,J).patch},e.compare=W,e.compareLoose=function(V,J){return W(V,J,!0)},e.rcompare=function(V,J,x){return W(J,V,x)},e.sort=function(V,J){return V.sort(function(x,fe){return e.compare(x,fe,J)})},e.rsort=function(V,J){return V.sort(function(x,fe){return e.rcompare(x,fe,J)})},e.gt=se,e.lt=ae,e.eq=te,e.neq=le,e.gte=ue,e.lte=X,e.cmp=oe,e.Comparator=pe;var we={};function Fe(V,J){if(V instanceof Fe)return V.loose===J?V:new Fe(V.raw,J);if(V instanceof pe)return new Fe(V.value,J);if(!(this instanceof Fe))return new Fe(V,J);if(this.loose=J,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Ue(V){return!V||V.toLowerCase()==="x"||V==="*"}function ke(V,J,x,fe,be,Ne,Ge,Ze,et,rt,ot,nt,ct){return((J=Ue(x)?"":Ue(fe)?">="+x+".0.0":Ue(be)?">="+x+"."+fe+".0":">="+J)+" "+(Ze=Ue(et)?"":Ue(rt)?"<"+(+et+1)+".0.0":Ue(ot)?"<"+et+"."+(+rt+1)+".0":nt?"<="+et+"."+rt+"."+ot+"-"+nt:"<="+Ze)).trim()}function Ie(V,J){for(var x=0;x<V.length;x++)if(!V[x].test(J))return!1;if(J.prerelease.length){for(x=0;x<V.length;x++)if(P(V[x].semver),V[x].semver!==we&&V[x].semver.prerelease.length>0){var fe=V[x].semver;if(fe.major===J.major&&fe.minor===J.minor&&fe.patch===J.patch)return!0}return!1}return!0}function Oe(V,J,x){try{J=new Fe(J,x)}catch{return!1}return J.test(V)}function q(V,J,x,fe){var be,Ne,Ge,Ze,et;switch(V=new De(V,fe),J=new Fe(J,fe),x){case">":be=se,Ne=X,Ge=ae,Ze=">",et=">=";break;case"<":be=ae,Ne=ue,Ge=se,Ze="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(V,J,fe))return!1;for(var rt=0;rt<J.set.length;++rt){var ot=J.set[rt],nt=null,ct=null;if(ot.forEach(function(mt){mt.semver===we&&(mt=new pe(">=0.0.0")),nt=nt||mt,ct=ct||mt,be(mt.semver,nt.semver,fe)?nt=mt:Ge(mt.semver,ct.semver,fe)&&(ct=mt)}),nt.operator===Ze||nt.operator===et||(!ct.operator||ct.operator===Ze)&&Ne(V,ct.semver)||ct.operator===et&&Ge(V,ct.semver))return!1}return!0}pe.prototype.parse=function(V){var J=this.loose?R[_]:R[re],x=V.match(J);if(!x)throw new TypeError("Invalid comparator: "+V);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new De(x[2],this.loose):this.semver=we},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(V){return P("Comparator.test",V,this.loose),this.semver===we||(typeof V=="string"&&(V=new De(V,this.loose)),oe(V,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(V,J){if(!(V instanceof pe))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Fe(V.value,J),Oe(this.value,x,J);if(V.operator==="")return x=new Fe(this.value,J),Oe(V.semver,x,J);var fe=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Ne=this.semver.version===V.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ze=oe(this.semver,"<",V.semver,J)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),et=oe(this.semver,">",V.semver,J)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return fe||be||Ne&&Ge||Ze||et},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(V){var J=this.loose;V=V.trim(),P("range",V,J);var x=J?R[Q]:R[G];V=V.replace(x,ke),P("hyphen replace",V),V=V.replace(R[U],"$1$2$3"),P("comparator trim",V,R[U]),V=(V=(V=V.replace(R[M],"$1~")).replace(R[z],"$1^")).split(/\s+/).join(" ");var fe=J?R[_]:R[re],be=V.split(" ").map(function(Ne){return function(Ge,Ze){return P("comp",Ge),Ge=function(et,rt){return et.trim().split(/\s+/).map(function(ot){return function(nt,ct){P("caret",nt,ct);var mt=ct?R[B]:R[F];return nt.replace(mt,function(ht,at,Pe,ze,He){var Le;return P("caret",nt,ht,at,Pe,ze,He),Ue(at)?Le="":Ue(Pe)?Le=">="+at+".0.0 <"+(+at+1)+".0.0":Ue(ze)?Le=at==="0"?">="+at+"."+Pe+".0 <"+at+"."+(+Pe+1)+".0":">="+at+"."+Pe+".0 <"+(+at+1)+".0.0":He?(P("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Le=at==="0"?Pe==="0"?">="+at+"."+Pe+"."+ze+He+" <"+at+"."+Pe+"."+(+ze+1):">="+at+"."+Pe+"."+ze+He+" <"+at+"."+(+Pe+1)+".0":">="+at+"."+Pe+"."+ze+He+" <"+(+at+1)+".0.0"):(P("no pr"),Le=at==="0"?Pe==="0"?">="+at+"."+Pe+"."+ze+" <"+at+"."+Pe+"."+(+ze+1):">="+at+"."+Pe+"."+ze+" <"+at+"."+(+Pe+1)+".0":">="+at+"."+Pe+"."+ze+" <"+(+at+1)+".0.0"),P("caret return",Le),Le})}(ot,rt)}).join(" ")}(Ge,Ze),P("caret",Ge),Ge=function(et,rt){return et.trim().split(/\s+/).map(function(ot){return function(nt,ct){var mt=ct?R[L]:R[N];return nt.replace(mt,function(ht,at,Pe,ze,He){var Le;return P("tilde",nt,ht,at,Pe,ze,He),Ue(at)?Le="":Ue(Pe)?Le=">="+at+".0.0 <"+(+at+1)+".0.0":Ue(ze)?Le=">="+at+"."+Pe+".0 <"+at+"."+(+Pe+1)+".0":He?(P("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Le=">="+at+"."+Pe+"."+ze+He+" <"+at+"."+(+Pe+1)+".0"):Le=">="+at+"."+Pe+"."+ze+" <"+at+"."+(+Pe+1)+".0",P("tilde return",Le),Le})}(ot,rt)}).join(" ")}(Ge,Ze),P("tildes",Ge),Ge=function(et,rt){return P("replaceXRanges",et,rt),et.split(/\s+/).map(function(ot){return function(nt,ct){nt=nt.trim();var mt=ct?R[A]:R[C];return nt.replace(mt,function(ht,at,Pe,ze,He,Le){P("xRange",nt,ht,at,Pe,ze,He,Le);var je=Ue(Pe),Y=je||Ue(ze),de=Y||Ue(He);return at==="="&&de&&(at=""),je?ht=at===">"||at==="<"?"<0.0.0":"*":at&&de?(Y&&(ze=0),de&&(He=0),at===">"?(at=">=",Y?(Pe=+Pe+1,ze=0,He=0):de&&(ze=+ze+1,He=0)):at==="<="&&(at="<",Y?Pe=+Pe+1:ze=+ze+1),ht=at+Pe+"."+ze+"."+He):Y?ht=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":de&&(ht=">="+Pe+"."+ze+".0 <"+Pe+"."+(+ze+1)+".0"),P("xRange return",ht),ht})}(ot,rt)}).join(" ")}(Ge,Ze),P("xrange",Ge),Ge=function(et,rt){return P("replaceStars",et,rt),et.trim().replace(R[ee],"")}(Ge,Ze),P("stars",Ge),Ge}(Ne,J)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Ne){return!!Ne.match(fe)})),be=be.map(function(Ne){return new pe(Ne,J)})},Fe.prototype.intersects=function(V,J){if(!(V instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(fe){return V.set.some(function(be){return be.every(function(Ne){return fe.intersects(Ne,J)})})})})},e.toComparators=function(V,J){return new Fe(V,J).set.map(function(x){return x.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new De(V,this.loose));for(var J=0;J<this.set.length;J++)if(Ie(this.set[J],V))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(V,J,x){var fe=null,be=null;try{var Ne=new Fe(J,x)}catch{return null}return V.forEach(function(Ge){Ne.test(Ge)&&(fe&&be.compare(Ge)!==-1||(be=new De(fe=Ge,x)))}),fe},e.minSatisfying=function(V,J,x){var fe=null,be=null;try{var Ne=new Fe(J,x)}catch{return null}return V.forEach(function(Ge){Ne.test(Ge)&&(fe&&be.compare(Ge)!==1||(be=new De(fe=Ge,x)))}),fe},e.validRange=function(V,J){try{return new Fe(V,J).range||"*"}catch{return null}},e.ltr=function(V,J,x){return q(V,J,"<",x)},e.gtr=function(V,J,x){return q(V,J,">",x)},e.outside=q,e.prerelease=function(V,J){var x=ne(V,J);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(V,J,x){return V=new Fe(V,x),J=new Fe(J,x),V.intersects(J)},e.coerce=function(V){if(V instanceof De)return V;if(typeof V!="string")return null;var J=V.match(R[b]);return J==null?null:ne((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,r(1))},function(ce,e){var r,h,P=ce.exports={};function O(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(m){if(r===setTimeout)return setTimeout(m,0);if((r===O||!r)&&setTimeout)return r=setTimeout,setTimeout(m,0);try{return r(m,0)}catch{try{return r.call(null,m,0)}catch{return r.call(this,m,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:O}catch{r=O}try{h=typeof clearTimeout=="function"?clearTimeout:T}catch{h=T}})();var $,a=[],I=!1,E=-1;function l(){I&&$&&(I=!1,$.length?a=$.concat(a):E=-1,a.length&&k())}function k(){if(!I){var m=R(l);I=!0;for(var d=a.length;d;){for($=a,a=[];++E<d;)$&&$[E].run();E=-1,d=a.length}$=null,I=!1,function(g){if(h===clearTimeout)return clearTimeout(g);if((h===T||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(g);try{h(g)}catch{try{return h.call(null,g)}catch{return h.call(this,g)}}}(m)}}function p(m,d){this.fun=m,this.array=d}function c(){}P.nextTick=function(m){var d=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)d[g-1]=arguments[g];a.push(new p(m,d)),a.length!==1||I||R(k)},p.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=c,P.addListener=c,P.once=c,P.off=c,P.removeListener=c,P.removeAllListeners=c,P.emit=c,P.prependListener=c,P.prependOnceListener=c,P.listeners=function(m){return[]},P.binding=function(m){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(m){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(ye[43],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(O){return new h(O)}constructor(O){this.c=r&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ge=h}),define(ye[4],Se([1,0,14,80,3,81,43]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$ie=e.Event=void 0,e.$je=k;const R=!1,$=!1,a=!1;var I;(function(L){L.None=()=>P.$Wc.None;function j(ke){if(a){const{onDidAddListener:Ie}=ke,Oe=c.create();let q=0;ke.onDidAddListener=()=>{++q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Oe.print()),Ie?.()}}}function z(ke,Ie){return ne(ke,()=>{},0,void 0,!0,void 0,Ie)}L.defer=z;function F(ke){return(Ie,Oe=null,q)=>{let V=!1,J;return J=ke(x=>{if(!V)return J?J.dispose():V=!0,Ie.call(Oe,x)},null,q),V&&J.dispose(),J}}L.once=F;function B(ke,Ie,Oe){return ee((q,V=null,J)=>ke(x=>q.call(V,Ie(x)),null,J),Oe)}L.map=B;function _(ke,Ie,Oe){return ee((q,V=null,J)=>ke(x=>{Ie(x),q.call(V,x)},null,J),Oe)}L.forEach=_;function re(ke,Ie,Oe){return ee((q,V=null,J)=>ke(x=>Ie(x)&&q.call(V,x),null,J),Oe)}L.filter=re;function U(ke){return ke}L.signal=U;function G(...ke){return(Ie,Oe=null,q)=>{const V=(0,P.$Tc)(...ke.map(J=>J(x=>Ie.call(Oe,x))));return he(V,q)}}L.any=G;function Q(ke,Ie,Oe,q){let V=Oe;return B(ke,J=>(V=Ie(V,J),V),q)}L.reduce=Q;function ee(ke,Ie){let Oe;const q={onWillAddFirstListener(){Oe=ke(V.fire,V)},onDidRemoveLastListener(){Oe?.dispose()}};Ie||j(q);const V=new s(q);return Ie?.add(V),V.event}function he(ke,Ie){return Ie instanceof Array?Ie.push(ke):Ie&&Ie.add(ke),ke}function ne(ke,Ie,Oe=100,q=!1,V=!1,J,x){let fe,be,Ne,Ge=0,Ze;const et={leakWarningThreshold:J,onWillAddFirstListener(){fe=ke(ot=>{Ge++,be=Ie(be,ot),q&&!Ne&&(rt.fire(be),be=void 0),Ze=()=>{const nt=be;be=void 0,Ne=void 0,(!q||Ge>1)&&rt.fire(nt),Ge=0},typeof Oe=="number"?(clearTimeout(Ne),Ne=setTimeout(Ze,Oe)):Ne===void 0&&(Ne=0,queueMicrotask(Ze))})},onWillRemoveListener(){V&&Ge>0&&Ze?.()},onDidRemoveLastListener(){Ze=void 0,fe.dispose()}};x||j(et);const rt=new s(et);return x?.add(rt),rt.event}L.debounce=ne;function De(ke,Ie=0,Oe){return L.debounce(ke,(q,V)=>q?(q.push(V),q):[V],Ie,void 0,!0,void 0,Oe)}L.accumulate=De;function $e(ke,Ie=(q,V)=>q===V,Oe){let q=!0,V;return re(ke,J=>{const x=q||!Ie(J,V);return q=!1,V=J,x},Oe)}L.latch=$e;function K(ke,Ie,Oe){return[L.filter(ke,Ie,Oe),L.filter(ke,q=>!Ie(q),Oe)]}L.split=K;function W(ke,Ie=!1,Oe=[],q){let V=Oe.slice(),J=ke(be=>{V?V.push(be):fe.fire(be)});q&&q.add(J);const x=()=>{V?.forEach(be=>fe.fire(be)),V=null},fe=new s({onWillAddFirstListener(){J||(J=ke(be=>fe.fire(be)),q&&q.add(J))},onDidAddFirstListener(){V&&(Ie?setTimeout(x):x())},onDidRemoveLastListener(){J&&J.dispose(),J=null}});return q&&q.add(fe),fe.event}L.buffer=W;function se(ke,Ie){return(q,V,J)=>{const x=Ie(new te);return ke(function(fe){const be=x.evaluate(fe);be!==ae&&q.call(V,be)},void 0,J)}}L.chain=se;const ae=Symbol("HaltChainable");class te{constructor(){this.f=[]}map(Ie){return this.f.push(Ie),this}forEach(Ie){return this.f.push(Oe=>(Ie(Oe),Oe)),this}filter(Ie){return this.f.push(Oe=>Ie(Oe)?Oe:ae),this}reduce(Ie,Oe){let q=Oe;return this.f.push(V=>(q=Ie(q,V),q)),this}latch(Ie=(Oe,q)=>Oe===q){let Oe=!0,q;return this.f.push(V=>{const J=Oe||!Ie(V,q);return Oe=!1,q=V,J?V:ae}),this}evaluate(Ie){for(const Oe of this.f)if(Ie=Oe(Ie),Ie===ae)break;return Ie}}function le(ke,Ie,Oe=q=>q){const q=(...fe)=>x.fire(Oe(...fe)),V=()=>ke.on(Ie,q),J=()=>ke.removeListener(Ie,q),x=new s({onWillAddFirstListener:V,onDidRemoveLastListener:J});return x.event}L.fromNodeEventEmitter=le;function ue(ke,Ie,Oe=q=>q){const q=(...fe)=>x.fire(Oe(...fe)),V=()=>ke.addEventListener(Ie,q),J=()=>ke.removeEventListener(Ie,q),x=new s({onWillAddFirstListener:V,onDidRemoveLastListener:J});return x.event}L.fromDOMEventEmitter=ue;function X(ke){return new Promise(Ie=>F(ke)(Ie))}L.toPromise=X;function oe(ke){const Ie=new s;return ke.then(Oe=>{Ie.fire(Oe)},()=>{Ie.fire(void 0)}).finally(()=>{Ie.dispose()}),Ie.event}L.fromPromise=oe;function pe(ke,Ie,Oe){return Ie(Oe),ke(q=>Ie(q))}L.runAndSubscribe=pe;class we{constructor(Ie,Oe){this._observable=Ie,this.f=0,this.g=!1;const q={onWillAddFirstListener:()=>{Ie.addObserver(this)},onDidRemoveLastListener:()=>{Ie.removeObserver(this)}};Oe||j(q),this.emitter=new s(q),Oe&&Oe.add(this.emitter)}beginUpdate(Ie){this.f++}handlePossibleChange(Ie){}handleChange(Ie,Oe){this.g=!0}endUpdate(Ie){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Fe(ke,Ie){return new we(ke,Ie).emitter.event}L.fromObservable=Fe;function Ue(ke){return(Ie,Oe,q)=>{let V=0,J=!1;const x={beginUpdate(){V++},endUpdate(){V--,V===0&&(ke.reportChanges(),J&&(J=!1,Ie.call(Oe)))},handlePossibleChange(){},handleChange(){J=!0}};ke.addObserver(x),ke.reportChanges();const fe={dispose(){ke.removeObserver(x)}};return q instanceof P.$Vc?q.add(fe):Array.isArray(q)&&q.push(fe),fe}}L.fromObservableLight=Ue})(I||(e.Event=I={}));class E{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${E.f++}`,E.all.add(this)}start(j){this.g=new T.$ge,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$ie=E;let l=-1;function k(L){const j=l;return l=L,{dispose(){l=j}}}class p{static{this.f=1}constructor(j,z,F=(p.f++).toString(16).padStart(3,"0")){this.j=j,this.threshold=z,this.name=F,this.h=0}dispose(){this.g?.clear()}check(j,z){const F=this.threshold;if(F<=0||z<F)return;this.g||(this.g=new Map);const B=this.g.get(j.value)||0;if(this.g.set(j.value,B+1),this.h-=1,this.h<=0){this.h=F*.5;const[_,re]=this.getMostFrequentStack(),U=`[${this.name}] potential listener LEAK detected, having ${z} listeners already. MOST frequent listener (${re}):`;console.warn(U),console.warn(_);const G=new m(U,_);this.j(G)}return()=>{const _=this.g.get(j.value)||0;this.g.set(j.value,_-1)}}getMostFrequentStack(){if(!this.g)return;let j,z=0;for(const[F,B]of this.g)(!j||z<B)&&(j=[F,B],z=B);return j}}class c{static create(){const j=new Error;return new c(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(j,z){super(j),this.name="ListenerLeakError",this.stack=z}}e.$ke=m;class d extends Error{constructor(j,z){super(j),this.name="ListenerRefusalError",this.stack=z}}e.$le=d;let g=0;class n{constructor(j){this.value=j,this.id=g++}}const o=2,t=(L,j)=>{if(L instanceof n)j(L);else for(let z=0;z<L.length;z++){const F=L[z];F&&j(F)}};let i;if(R){const L=[];setInterval(()=>{L.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(L.join(`
`)),L.length=0)},3e3),i=new FinalizationRegistry(j=>{typeof j=="string"&&L.push(j)})}class s{constructor(j){this.z=0,this.f=j,this.g=l>0||this.f?.leakWarningThreshold?new p(j?.onListenerError??r.$3,this.f?.leakWarningThreshold??l):void 0,this.j=this.f?._profName?new E(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if($){const j=this.u;queueMicrotask(()=>{t(j,z=>z.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,z,F)=>{if(this.g&&this.z>this.g.threshold**2){const G=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(G);const Q=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new d(`${G}. HINT: Stack shows most frequent listener (${Q[1]}-times)`,Q[0]);return(this.f?.onListenerError||r.$3)(ee),P.$Wc.None}if(this.m)return P.$Wc.None;z&&(j=j.bind(z));const B=new n(j);let _,re;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(B.stack=c.create(),_=this.g.check(B.stack,this.z+1)),$&&(B.stack=re??c.create()),this.u?this.u instanceof n?(this.w??=new u,this.u=[this.u,B]):this.u.push(B):(this.f?.onWillAddFirstListener?.(this),this.u=B,this.f?.onDidAddFirstListener?.(this)),this.z++;const U=(0,P.$Uc)(()=>{i?.unregister(U),_?.(),this.A(B)});if(F instanceof P.$Vc?F.add(U):Array.isArray(F)&&F.push(U),i){const G=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),Q=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(G);i.register(U,Q?.[2]??G,U)}return U},this.q}A(j){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const z=this.u,F=z.indexOf(j);if(F===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,z[F]=void 0;const B=this.w.current===this;if(this.z*o<=z.length){let _=0;for(let re=0;re<z.length;re++)z[re]?z[_++]=z[re]:B&&(this.w.end--,_<this.w.i&&this.w.i--);z.length=_}}B(j,z){if(!j)return;const F=this.f?.onListenerError||r.$3;if(!F){j.value(z);return}try{j.value(z)}catch(B){F(B)}}C(j){const z=j.current.u;for(;j.i<j.end;)this.B(z[j.i++],j.value);j.reset()}fire(j){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof n)this.B(this.u,j);else{const z=this.w;z.enqueue(this,j,this.u.length),this.C(z)}this.j?.stop()}hasListeners(){return this.z>0}}e.$me=s;const f=()=>new u;e.$ne=f;class u{constructor(){this.i=-1,this.end=0}enqueue(j,z,F){this.i=0,this.end=F,this.current=j,this.value=z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class w extends s{async fireAsync(j,z,F){if(this.u)for(this.h||(this.h=new O.$7c),t(this.u,B=>this.h.push([B.value,j]));this.h.size>0&&!z.isCancellationRequested;){const[B,_]=this.h.shift(),re=[],U={..._,token:z,waitUntil:G=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");F&&(G=F(G,B)),re.push(G)}};try{B(U)}catch(G){(0,r.$3)(G);continue}Object.freeze(re),await Promise.allSettled(re).then(G=>{for(const Q of G)Q.status==="rejected"&&(0,r.$3)(Q.reason)})}}}e.$oe=w;class y extends s{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new O.$7c,this.t=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.t(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.z&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$pe=y;class D extends y{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$qe=D;class S extends s{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(z=>super.fire(z)),this.h=[]}))}}e.$re=S;class C{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const z={event:j,listener:null};this.h.push(z),this.g&&this.m(z);const F=()=>{this.g&&this.o(z);const B=this.h.indexOf(z);this.h.splice(B,1)};return(0,P.$Uc)((0,h.$fb)(F))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(z=>this.f.fire(z))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$se=C;class A{constructor(j,z,F,B){this.f=new P.$Vc;const _=this.f.add(new C),re=this.f.add(new P.$6c);function U(G){re.set(G,_.add(B(G)))}for(const G of j)U(G);this.f.add(z(G=>{U(G)})),this.f.add(F(G=>{re.deleteAndDispose(G)})),this.event=_.event}dispose(){this.f.dispose()}}e.$te=A;class b{constructor(){this.f=[]}wrapEvent(j,z,F){return(B,_,re)=>j(U=>{const G=this.f[this.f.length-1];if(!z){G?G.buffers.push(()=>B.call(_,U)):B.call(_,U);return}const Q=G;if(!Q){B.call(_,z(F,U));return}Q.items??=[],Q.items.push(U),Q.buffers.length===0&&G.buffers.push(()=>{Q.reducedResult??=F?Q.items.reduce(z,F):Q.items.reduce(z),B.call(_,Q.reducedResult)})},void 0,re)}bufferEvents(j){const z={buffers:new Array};this.f.push(z);const F=j();return this.f.pop(),z.buffers.forEach(B=>B()),F}}e.$ue=b;class v{constructor(){this.f=!1,this.g=I.None,this.h=P.$Wc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ve=v;class M{static const(j){return new N(j)}constructor(j){this.g=j,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$we=M;class N{constructor(j){this.value=j,this.onDidChange=I.None}}}),define(ye[21],Se([1,0,4]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.CancellationToken=void 0,e.$ye=R;const h=Object.freeze(function($,a){const I=setTimeout($.bind(a),0);return{dispose(){clearTimeout(I)}}});var P;(function($){function a(I){return I===$.None||I===$.Cancelled||I instanceof O?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}$.isCancellationToken=a,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(P||(e.CancellationToken=P={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?h:(this.b||(this.b=new r.$me),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(a){this.f=void 0,this.g=void 0,this.g=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new O),this.f}cancel(){this.f?this.f instanceof O&&this.f.cancel():this.f=P.Cancelled}dispose(a=!1){a&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof O&&this.f.dispose():this.f=P.None}}e.$xe=T;function R($){const a=new T;return $.add({dispose(){a.cancel()}}),a.token}}),define(ye[183],Se([1,0,21]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$af=e.$_e=e.$0e=void 0,e.$$e=P;class h{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new r.$xe,a=this.b($.token);return this.a={promise:a,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$0e=h;function P(R){return R}class O{constructor($,a){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=P):(this.c=a,this.d=$.getCacheKey)}get($){const a=this.d($);return this.b!==a&&(this.b=a,this.a=this.c($)),this.a}}e.$_e=O;class T{get cachedValues(){return this.a}constructor($,a){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=P):(this.c=a,this.d=$.getCacheKey)}get($){const a=this.d($);if(this.b.has(a))return this.b.get(a);const I=this.c($);return this.a.set($,I),this.b.set(a,I),I}}e.$af=T}),define(ye[184],Se([1,0,4,3]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=e.$bt=e.$at=e.ScrollbarVisibility=void 0;var P;(function(k){k[k.Auto=1]="Auto",k[k.Hidden=2]="Hidden",k[k.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class O{constructor(p,c,m,d,g,n,o){this.c=p,this._scrollStateBrand=void 0,this.c&&(c=c|0,m=m|0,d=d|0,g=g|0,n=n|0,o=o|0),this.rawScrollLeft=d,this.rawScrollTop=o,c<0&&(c=0),d+c>m&&(d=m-c),d<0&&(d=0),g<0&&(g=0),o+g>n&&(o=n-g),o<0&&(o=0),this.width=c,this.scrollWidth=m,this.scrollLeft=d,this.height=g,this.scrollHeight=n,this.scrollTop=o}equals(p){return this.rawScrollLeft===p.rawScrollLeft&&this.rawScrollTop===p.rawScrollTop&&this.width===p.width&&this.scrollWidth===p.scrollWidth&&this.scrollLeft===p.scrollLeft&&this.height===p.height&&this.scrollHeight===p.scrollHeight&&this.scrollTop===p.scrollTop}withScrollDimensions(p,c){return new O(this.c,typeof p.width<"u"?p.width:this.width,typeof p.scrollWidth<"u"?p.scrollWidth:this.scrollWidth,c?this.rawScrollLeft:this.scrollLeft,typeof p.height<"u"?p.height:this.height,typeof p.scrollHeight<"u"?p.scrollHeight:this.scrollHeight,c?this.rawScrollTop:this.scrollTop)}withScrollPosition(p){return new O(this.c,this.width,this.scrollWidth,typeof p.scrollLeft<"u"?p.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof p.scrollTop<"u"?p.scrollTop:this.rawScrollTop)}createScrollEvent(p,c){const m=this.width!==p.width,d=this.scrollWidth!==p.scrollWidth,g=this.scrollLeft!==p.scrollLeft,n=this.height!==p.height,o=this.scrollHeight!==p.scrollHeight,t=this.scrollTop!==p.scrollTop;return{inSmoothScrolling:c,oldWidth:p.width,oldScrollWidth:p.scrollWidth,oldScrollLeft:p.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:p.height,oldScrollHeight:p.scrollHeight,oldScrollTop:p.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:d,scrollLeftChanged:g,heightChanged:n,scrollHeightChanged:o,scrollTopChanged:t}}}e.$at=O;class T extends h.$Wc{constructor(p){super(),this._scrollableBrand=void 0,this.j=this.B(new r.$me),this.onScroll=this.j.event,this.c=p.smoothScrollDuration,this.f=p.scheduleAtNextAnimationFrame,this.g=new O(p.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(p){this.c=p}validateScrollPosition(p){return this.g.withScrollPosition(p)}getScrollDimensions(){return this.g}setScrollDimensions(p,c){const m=this.g.withScrollDimensions(p,c);this.n(m,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(p){const c=this.g.withScrollPosition(p);this.h&&(this.h.dispose(),this.h=null),this.n(c,!1)}setScrollPositionSmooth(p,c){if(this.c===0)return this.setScrollPositionNow(p);if(this.h){p={scrollLeft:typeof p.scrollLeft>"u"?this.h.to.scrollLeft:p.scrollLeft,scrollTop:typeof p.scrollTop>"u"?this.h.to.scrollTop:p.scrollTop};const m=this.g.withScrollPosition(p);if(this.h.to.scrollLeft===m.scrollLeft&&this.h.to.scrollTop===m.scrollTop)return;let d;c?d=new I(this.h.from,m,this.h.startTime,this.h.duration):d=this.h.combine(this.g,m,this.c),this.h.dispose(),this.h=d}else{const m=this.g.withScrollPosition(p);this.h=I.start(this.g,m,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const p=this.h.tick(),c=this.g.withScrollPosition(p);if(this.n(c,!0),!!this.h){if(p.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(p,c){const m=this.g;m.equals(p)||(this.g=p,this.j.fire(this.g.createScrollEvent(m,c)))}}e.$bt=T;class R{constructor(p,c,m){this.scrollLeft=p,this.scrollTop=c,this.isDone=m}}e.$ct=R;function $(k,p){const c=p-k;return function(m){return k+c*l(m)}}function a(k,p,c){return function(m){return m<c?k(m/c):p((m-c)/(1-c))}}class I{constructor(p,c,m,d){this.from=p,this.to=c,this.duration=d,this.startTime=m,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(p,c,m){if(Math.abs(p-c)>2.5*m){let g,n;return p<c?(g=p+.75*m,n=c-.75*m):(g=p-.75*m,n=c+.75*m),a($(p,g),$(n,c),.33)}return $(p,c)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(p){this.to=p.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(p){const c=(p-this.startTime)/this.duration;if(c<1){const m=this.c(c),d=this.d(c);return new R(m,d,!1)}return new R(this.to.scrollLeft,this.to.scrollTop,!0)}combine(p,c,m){return I.start(p,c,m)}static start(p,c,m){m=m+10;const d=Date.now()-10;return new I(p,c,d,m)}}e.$dt=I;function E(k){return Math.pow(k,3)}function l(k){return 1-E(1-k)}}),define(ye[104],Se([1,0,14,3]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=P,e.$Ae=O,e.$Be=T,e.$Ce=R,e.$De=a,e.$Ee=I,e.$Fe=E,e.$Ge=l,e.$He=k,e.$Ie=p,e.$Je=c,e.$Ke=m,e.$Le=d,e.$Me=g,e.$Ne=n;function P(o){const t=o;return t?typeof t.read=="function":!1}function O(o){const t=o;return t?[t.on,t.pause,t.resume,t.destroy].every(i=>typeof i=="function"):!1}function T(o){const t=o;return t?O(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function R(o,t){return new $(o,t)}class ${constructor(t,i){this.e=t,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(i=>i(t))}h(t){this.c.error.length===0?(0,r.$3)(t):this.c.error.slice(0).forEach(i=>i(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,i){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(t,i){if(this.a.destroyed)return;let s;switch(t){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const f=s.indexOf(i);f>=0&&s.splice(f,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(o,t){const i=[];let s;for(;(s=o.read())!==null;)i.push(s);return t(i)}function I(o,t,i){const s=[];let f;for(;(f=o.read())!==null&&s.length<i;)s.push(f);return f===null&&s.length>0?t(s):{read:()=>{if(s.length>0)return s.shift();if(typeof f<"u"){const u=f;return f=void 0,u}return o.read()}}}function E(o,t){return new Promise((i,s)=>{const f=[];l(o,{onData:u=>{t&&f.push(u)},onError:u=>{t?s(u):i(void 0)},onEnd:()=>{i(t?t(f):void 0)}})})}function l(o,t,i){o.on("error",s=>{i?.isCancellationRequested||t.onError(s)}),o.on("end",()=>{i?.isCancellationRequested||t.onEnd()}),o.on("data",s=>{i?.isCancellationRequested||t.onData(s)})}function k(o,t){return new Promise((i,s)=>{const f=new h.$Vc,u=[],w=S=>{if(u.push(S),u.length>t)return f.dispose(),o.pause(),i({stream:o,buffer:u,ended:!1})},y=S=>(f.dispose(),s(S)),D=()=>(f.dispose(),i({stream:o,buffer:u,ended:!0}));f.add((0,h.$Uc)(()=>o.removeListener("error",y))),o.on("error",y),f.add((0,h.$Uc)(()=>o.removeListener("end",D))),o.on("end",D),f.add((0,h.$Uc)(()=>o.removeListener("data",w))),o.on("data",w)})}function p(o,t){const i=R(t);return i.end(o),i}function c(){const o=R(()=>{throw new Error("not supported")});return o.end(),o}function m(o){let t=!1;return{read:()=>t?null:(t=!0,o)}}function d(o,t,i){const s=R(i);return l(o,{onData:f=>s.write(t.data(f)),onError:f=>s.error(t.error?t.error(f):f),onEnd:()=>s.end()}),s}function g(o,t,i){let s=!1;return{read:()=>{const f=t.read();return s?f:(s=!0,f!==null?i([o,f]):o)}}}function n(o,t,i){let s=!1;const f=R(i);return l(t,{onData:u=>s?f.write(u):(s=!0,f.write(i([o,u]))),onError:u=>f.error(u),onEnd:()=>{s||(s=!0,f.write(o)),f.end()}}),f}}),define(ye[22],Se([1,0,49,104]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=a,e.$Qe=I,e.$Re=E,e.$Se=l,e.$Te=k,e.$Ue=p,e.$Ve=c,e.$We=m,e.$Xe=d,e.$Ye=g,e.$Ze=n,e.$1e=o,e.$2e=t,e.$3e=i,e.$4e=s,e.$5e=f,e.$6e=u,e.$7e=w,e.$8e=y,e.$9e=C,h=We(h);const P=typeof Buffer<"u",O=new r.$X(()=>new Uint8Array(256));let T,R;class ${static alloc(b){return P?new $(Buffer.allocUnsafe(b)):new $(new Uint8Array(b))}static wrap(b){return P&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new $(b)}static fromString(b,v){return!(v?.dontUseNodeBuffer||!1)&&P?new $(Buffer.from(b)):(T||(T=new TextEncoder),new $(T.encode(b)))}static fromByteArray(b){const v=$.alloc(b.length);for(let M=0,N=b.length;M<N;M++)v.buffer[M]=b[M];return v}static concat(b,v){if(typeof v>"u"){v=0;for(let L=0,j=b.length;L<j;L++)v+=b[L].byteLength}const M=$.alloc(v);let N=0;for(let L=0,j=b.length;L<j;L++){const z=b[L];M.set(z,N),N+=z.byteLength}return M}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=$.alloc(this.byteLength);return b.set(this),b}toString(){return P?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(b,v){return new $(this.buffer.subarray(b,v))}set(b,v){if(b instanceof $)this.buffer.set(b.buffer,v);else if(b instanceof Uint8Array)this.buffer.set(b,v);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),v);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return l(this.buffer,b)}writeUInt32BE(b,v){k(this.buffer,b,v)}readUInt32LE(b){return p(this.buffer,b)}writeUInt32LE(b,v){c(this.buffer,b,v)}readUInt8(b){return m(this.buffer,b)}writeUInt8(b,v){d(this.buffer,b,v)}indexOf(b,v=0){return a(this.buffer,b instanceof $?b.buffer:b,v)}}e.$Oe=$;function a(A,b,v=0){const M=b.byteLength,N=A.byteLength;if(M===0)return 0;if(M===1)return A.indexOf(b[0]);if(M>N-v)return-1;const L=O.value;L.fill(b.length);for(let B=0;B<b.length;B++)L[b[B]]=b.length-B-1;let j=v+b.length-1,z=j,F=-1;for(;j<N;)if(A[j]===b[z]){if(z===0){F=j;break}j--,z--}else j+=Math.max(b.length-z,L[A[j]]),z=b.length-1;return F}function I(A,b){return A[b+0]<<0>>>0|A[b+1]<<8>>>0}function E(A,b,v){A[v+0]=b&255,b=b>>>8,A[v+1]=b&255}function l(A,b){return A[b]*2**24+A[b+1]*2**16+A[b+2]*2**8+A[b+3]}function k(A,b,v){A[v+3]=b,b=b>>>8,A[v+2]=b,b=b>>>8,A[v+1]=b,b=b>>>8,A[v]=b}function p(A,b){return A[b+0]<<0>>>0|A[b+1]<<8>>>0|A[b+2]<<16>>>0|A[b+3]<<24>>>0}function c(A,b,v){A[v+0]=b&255,b=b>>>8,A[v+1]=b&255,b=b>>>8,A[v+2]=b&255,b=b>>>8,A[v+3]=b&255}function m(A,b){return A[b]}function d(A,b,v){A[v]=b}function g(A){return h.$De(A,b=>$.concat(b))}function n(A){return h.$Ke(A)}function o(A){return h.$Fe(A,b=>$.concat(b))}async function t(A){return A.ended?$.concat(A.buffer):$.concat([...A.buffer,await o(A.stream)])}function i(A){return h.$Ie(A,b=>$.concat(b))}function s(A){return h.$Le(A,{data:b=>typeof b=="string"?$.fromString(b):$.wrap(b)},b=>$.concat(b))}function f(A){return h.$Ce(b=>$.concat(b),A)}function u(A,b){return h.$Me(A,b,v=>$.concat(v))}function w(A,b){return h.$Ne(A,b,v=>$.concat(v))}function y(A){let b=0,v=0,M=0;const N=new Uint8Array(Math.floor(A.length/4*3)),L=z=>{switch(v){case 3:N[M++]=b|z,v=0;break;case 2:N[M++]=b|z>>>2,b=z<<6,v=3;break;case 1:N[M++]=b|z>>>4,b=z<<4,v=2;break;default:b=z<<2,v=1}};for(let z=0;z<A.length;z++){const F=A.charCodeAt(z);if(F>=65&&F<=90)L(F-65);else if(F>=97&&F<=122)L(F-97+26);else if(F>=48&&F<=57)L(F-48+52);else if(F===43||F===45)L(62);else if(F===47||F===95)L(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${A[z]}`)}}const j=M;for(;v>0;)L(0);return $.wrap(N).slice(0,j)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:A},b=!0,v=!1){const M=v?S:D;let N="";const L=A.byteLength%3;let j=0;for(;j<A.byteLength-L;j+=3){const z=A[j+0],F=A[j+1],B=A[j+2];N+=M[z>>>2],N+=M[(z<<4|F>>>4)&63],N+=M[(F<<2|B>>>6)&63],N+=M[B&63]}if(L===1){const z=A[j+0];N+=M[z>>>2],N+=M[z<<4&63],b&&(N+="==")}else if(L===2){const z=A[j+0],F=A[j+1];N+=M[z>>>2],N+=M[(z<<4|F>>>4)&63],N+=M[F<<2&63],b&&(N+="=")}return N}}),define(ye[185],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(ye[18],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=r,e.$gg=h,e.$hg=P,e.$ig=O,e.$jg=T,e.$kg=R,e.$lg=$,e.$mg=a,e.$ng=I,e.$og=E,e.$pg=l,e.$qg=k,e.$rg=p,e.$sg=m,e.$tg=d,e.$ug=g,e.$vg=n,e.$wg=o;function r(t){return typeof t=="string"}function h(t){return Array.isArray(t)&&t.every(i=>r(i))}function P(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function O(t){const i=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof i}function T(t){return typeof t=="number"&&!isNaN(t)}function R(t){return!!t&&typeof t[Symbol.iterator]=="function"}function $(t){return t===!0||t===!1}function a(t){return typeof t>"u"}function I(t){return!E(t)}function E(t){return a(t)||t===null}function l(t,i){if(!t)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function k(t){if(E(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function p(...t){const i=[];for(let s=0;s<t.length;s++){const f=t[s];if(E(f))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);i.push(f)}return i}const c=Object.prototype.hasOwnProperty;function m(t){if(!P(t))return!1;for(const i in t)if(c.call(t,i))return!1;return!0}function d(t){return typeof t=="function"}function g(...t){return t.length>0&&t.every(d)}function n(t,i){const s=Math.min(t.length,i.length);for(let f=0;f<s;f++)o(t[f],i[f])}function o(t,i){if(r(i)){if(typeof t!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(d(i)){try{if(t instanceof i)return}catch{}if(!E(t)&&t.constructor===i||i.length===1&&i.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ye[105],Se([1,0,18]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=P,e.$1j=O;const h=Object.create(null);function P(T,R){if((0,r.$fg)(R)){const $=h[R];if($===void 0)throw new Error(`${T} references an unknown codicon: ${R}`);R=$}return h[T]=R,{id:T}}function O(){return h}}),define(ye[186],Se([1,0,105]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=void 0,e.$2j={add:(0,r.$Zj)("add",6e4),plus:(0,r.$Zj)("plus",6e4),gistNew:(0,r.$Zj)("gist-new",6e4),repoCreate:(0,r.$Zj)("repo-create",6e4),lightbulb:(0,r.$Zj)("lightbulb",60001),lightBulb:(0,r.$Zj)("light-bulb",60001),repo:(0,r.$Zj)("repo",60002),repoDelete:(0,r.$Zj)("repo-delete",60002),gistFork:(0,r.$Zj)("gist-fork",60003),repoForked:(0,r.$Zj)("repo-forked",60003),gitPullRequest:(0,r.$Zj)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$Zj)("git-pull-request-abandoned",60004),recordKeys:(0,r.$Zj)("record-keys",60005),keyboard:(0,r.$Zj)("keyboard",60005),tag:(0,r.$Zj)("tag",60006),gitPullRequestLabel:(0,r.$Zj)("git-pull-request-label",60006),tagAdd:(0,r.$Zj)("tag-add",60006),tagRemove:(0,r.$Zj)("tag-remove",60006),person:(0,r.$Zj)("person",60007),personFollow:(0,r.$Zj)("person-follow",60007),personOutline:(0,r.$Zj)("person-outline",60007),personFilled:(0,r.$Zj)("person-filled",60007),gitBranch:(0,r.$Zj)("git-branch",60008),gitBranchCreate:(0,r.$Zj)("git-branch-create",60008),gitBranchDelete:(0,r.$Zj)("git-branch-delete",60008),sourceControl:(0,r.$Zj)("source-control",60008),mirror:(0,r.$Zj)("mirror",60009),mirrorPublic:(0,r.$Zj)("mirror-public",60009),star:(0,r.$Zj)("star",60010),starAdd:(0,r.$Zj)("star-add",60010),starDelete:(0,r.$Zj)("star-delete",60010),starEmpty:(0,r.$Zj)("star-empty",60010),comment:(0,r.$Zj)("comment",60011),commentAdd:(0,r.$Zj)("comment-add",60011),alert:(0,r.$Zj)("alert",60012),warning:(0,r.$Zj)("warning",60012),search:(0,r.$Zj)("search",60013),searchSave:(0,r.$Zj)("search-save",60013),logOut:(0,r.$Zj)("log-out",60014),signOut:(0,r.$Zj)("sign-out",60014),logIn:(0,r.$Zj)("log-in",60015),signIn:(0,r.$Zj)("sign-in",60015),eye:(0,r.$Zj)("eye",60016),eyeUnwatch:(0,r.$Zj)("eye-unwatch",60016),eyeWatch:(0,r.$Zj)("eye-watch",60016),circleFilled:(0,r.$Zj)("circle-filled",60017),primitiveDot:(0,r.$Zj)("primitive-dot",60017),closeDirty:(0,r.$Zj)("close-dirty",60017),debugBreakpoint:(0,r.$Zj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$Zj)("debug-breakpoint-disabled",60017),debugHint:(0,r.$Zj)("debug-hint",60017),terminalDecorationSuccess:(0,r.$Zj)("terminal-decoration-success",60017),primitiveSquare:(0,r.$Zj)("primitive-square",60018),edit:(0,r.$Zj)("edit",60019),pencil:(0,r.$Zj)("pencil",60019),info:(0,r.$Zj)("info",60020),issueOpened:(0,r.$Zj)("issue-opened",60020),gistPrivate:(0,r.$Zj)("gist-private",60021),gitForkPrivate:(0,r.$Zj)("git-fork-private",60021),lock:(0,r.$Zj)("lock",60021),mirrorPrivate:(0,r.$Zj)("mirror-private",60021),close:(0,r.$Zj)("close",60022),removeClose:(0,r.$Zj)("remove-close",60022),x:(0,r.$Zj)("x",60022),repoSync:(0,r.$Zj)("repo-sync",60023),sync:(0,r.$Zj)("sync",60023),clone:(0,r.$Zj)("clone",60024),desktopDownload:(0,r.$Zj)("desktop-download",60024),beaker:(0,r.$Zj)("beaker",60025),microscope:(0,r.$Zj)("microscope",60025),vm:(0,r.$Zj)("vm",60026),deviceDesktop:(0,r.$Zj)("device-desktop",60026),file:(0,r.$Zj)("file",60027),fileText:(0,r.$Zj)("file-text",60027),more:(0,r.$Zj)("more",60028),ellipsis:(0,r.$Zj)("ellipsis",60028),kebabHorizontal:(0,r.$Zj)("kebab-horizontal",60028),mailReply:(0,r.$Zj)("mail-reply",60029),reply:(0,r.$Zj)("reply",60029),organization:(0,r.$Zj)("organization",60030),organizationFilled:(0,r.$Zj)("organization-filled",60030),organizationOutline:(0,r.$Zj)("organization-outline",60030),newFile:(0,r.$Zj)("new-file",60031),fileAdd:(0,r.$Zj)("file-add",60031),newFolder:(0,r.$Zj)("new-folder",60032),fileDirectoryCreate:(0,r.$Zj)("file-directory-create",60032),trash:(0,r.$Zj)("trash",60033),trashcan:(0,r.$Zj)("trashcan",60033),history:(0,r.$Zj)("history",60034),clock:(0,r.$Zj)("clock",60034),folder:(0,r.$Zj)("folder",60035),fileDirectory:(0,r.$Zj)("file-directory",60035),symbolFolder:(0,r.$Zj)("symbol-folder",60035),logoGithub:(0,r.$Zj)("logo-github",60036),markGithub:(0,r.$Zj)("mark-github",60036),github:(0,r.$Zj)("github",60036),terminal:(0,r.$Zj)("terminal",60037),console:(0,r.$Zj)("console",60037),repl:(0,r.$Zj)("repl",60037),zap:(0,r.$Zj)("zap",60038),symbolEvent:(0,r.$Zj)("symbol-event",60038),error:(0,r.$Zj)("error",60039),stop:(0,r.$Zj)("stop",60039),variable:(0,r.$Zj)("variable",60040),symbolVariable:(0,r.$Zj)("symbol-variable",60040),array:(0,r.$Zj)("array",60042),symbolArray:(0,r.$Zj)("symbol-array",60042),symbolModule:(0,r.$Zj)("symbol-module",60043),symbolPackage:(0,r.$Zj)("symbol-package",60043),symbolNamespace:(0,r.$Zj)("symbol-namespace",60043),symbolObject:(0,r.$Zj)("symbol-object",60043),symbolMethod:(0,r.$Zj)("symbol-method",60044),symbolFunction:(0,r.$Zj)("symbol-function",60044),symbolConstructor:(0,r.$Zj)("symbol-constructor",60044),symbolBoolean:(0,r.$Zj)("symbol-boolean",60047),symbolNull:(0,r.$Zj)("symbol-null",60047),symbolNumeric:(0,r.$Zj)("symbol-numeric",60048),symbolNumber:(0,r.$Zj)("symbol-number",60048),symbolStructure:(0,r.$Zj)("symbol-structure",60049),symbolStruct:(0,r.$Zj)("symbol-struct",60049),symbolParameter:(0,r.$Zj)("symbol-parameter",60050),symbolTypeParameter:(0,r.$Zj)("symbol-type-parameter",60050),symbolKey:(0,r.$Zj)("symbol-key",60051),symbolText:(0,r.$Zj)("symbol-text",60051),symbolReference:(0,r.$Zj)("symbol-reference",60052),goToFile:(0,r.$Zj)("go-to-file",60052),symbolEnum:(0,r.$Zj)("symbol-enum",60053),symbolValue:(0,r.$Zj)("symbol-value",60053),symbolRuler:(0,r.$Zj)("symbol-ruler",60054),symbolUnit:(0,r.$Zj)("symbol-unit",60054),activateBreakpoints:(0,r.$Zj)("activate-breakpoints",60055),archive:(0,r.$Zj)("archive",60056),arrowBoth:(0,r.$Zj)("arrow-both",60057),arrowDown:(0,r.$Zj)("arrow-down",60058),arrowLeft:(0,r.$Zj)("arrow-left",60059),arrowRight:(0,r.$Zj)("arrow-right",60060),arrowSmallDown:(0,r.$Zj)("arrow-small-down",60061),arrowSmallLeft:(0,r.$Zj)("arrow-small-left",60062),arrowSmallRight:(0,r.$Zj)("arrow-small-right",60063),arrowSmallUp:(0,r.$Zj)("arrow-small-up",60064),arrowUp:(0,r.$Zj)("arrow-up",60065),bell:(0,r.$Zj)("bell",60066),bold:(0,r.$Zj)("bold",60067),book:(0,r.$Zj)("book",60068),bookmark:(0,r.$Zj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$Zj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$Zj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$Zj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$Zj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$Zj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$Zj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$Zj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$Zj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$Zj)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$Zj)("briefcase",60076),broadcast:(0,r.$Zj)("broadcast",60077),browser:(0,r.$Zj)("browser",60078),bug:(0,r.$Zj)("bug",60079),calendar:(0,r.$Zj)("calendar",60080),caseSensitive:(0,r.$Zj)("case-sensitive",60081),check:(0,r.$Zj)("check",60082),checklist:(0,r.$Zj)("checklist",60083),chevronDown:(0,r.$Zj)("chevron-down",60084),chevronLeft:(0,r.$Zj)("chevron-left",60085),chevronRight:(0,r.$Zj)("chevron-right",60086),chevronUp:(0,r.$Zj)("chevron-up",60087),chromeClose:(0,r.$Zj)("chrome-close",60088),chromeMaximize:(0,r.$Zj)("chrome-maximize",60089),chromeMinimize:(0,r.$Zj)("chrome-minimize",60090),chromeRestore:(0,r.$Zj)("chrome-restore",60091),circleOutline:(0,r.$Zj)("circle-outline",60092),circle:(0,r.$Zj)("circle",60092),debugBreakpointUnverified:(0,r.$Zj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$Zj)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$Zj)("circle-slash",60093),circuitBoard:(0,r.$Zj)("circuit-board",60094),clearAll:(0,r.$Zj)("clear-all",60095),clippy:(0,r.$Zj)("clippy",60096),closeAll:(0,r.$Zj)("close-all",60097),cloudDownload:(0,r.$Zj)("cloud-download",60098),cloudUpload:(0,r.$Zj)("cloud-upload",60099),code:(0,r.$Zj)("code",60100),collapseAll:(0,r.$Zj)("collapse-all",60101),colorMode:(0,r.$Zj)("color-mode",60102),commentDiscussion:(0,r.$Zj)("comment-discussion",60103),creditCard:(0,r.$Zj)("credit-card",60105),dash:(0,r.$Zj)("dash",60108),dashboard:(0,r.$Zj)("dashboard",60109),database:(0,r.$Zj)("database",60110),debugContinue:(0,r.$Zj)("debug-continue",60111),debugDisconnect:(0,r.$Zj)("debug-disconnect",60112),debugPause:(0,r.$Zj)("debug-pause",60113),debugRestart:(0,r.$Zj)("debug-restart",60114),debugStart:(0,r.$Zj)("debug-start",60115),debugStepInto:(0,r.$Zj)("debug-step-into",60116),debugStepOut:(0,r.$Zj)("debug-step-out",60117),debugStepOver:(0,r.$Zj)("debug-step-over",60118),debugStop:(0,r.$Zj)("debug-stop",60119),debug:(0,r.$Zj)("debug",60120),deviceCameraVideo:(0,r.$Zj)("device-camera-video",60121),deviceCamera:(0,r.$Zj)("device-camera",60122),deviceMobile:(0,r.$Zj)("device-mobile",60123),diffAdded:(0,r.$Zj)("diff-added",60124),diffIgnored:(0,r.$Zj)("diff-ignored",60125),diffModified:(0,r.$Zj)("diff-modified",60126),diffRemoved:(0,r.$Zj)("diff-removed",60127),diffRenamed:(0,r.$Zj)("diff-renamed",60128),diff:(0,r.$Zj)("diff",60129),diffSidebyside:(0,r.$Zj)("diff-sidebyside",60129),discard:(0,r.$Zj)("discard",60130),editorLayout:(0,r.$Zj)("editor-layout",60131),emptyWindow:(0,r.$Zj)("empty-window",60132),exclude:(0,r.$Zj)("exclude",60133),extensions:(0,r.$Zj)("extensions",60134),eyeClosed:(0,r.$Zj)("eye-closed",60135),fileBinary:(0,r.$Zj)("file-binary",60136),fileCode:(0,r.$Zj)("file-code",60137),fileMedia:(0,r.$Zj)("file-media",60138),filePdf:(0,r.$Zj)("file-pdf",60139),fileSubmodule:(0,r.$Zj)("file-submodule",60140),fileSymlinkDirectory:(0,r.$Zj)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$Zj)("file-symlink-file",60142),fileZip:(0,r.$Zj)("file-zip",60143),files:(0,r.$Zj)("files",60144),filter:(0,r.$Zj)("filter",60145),flame:(0,r.$Zj)("flame",60146),foldDown:(0,r.$Zj)("fold-down",60147),foldUp:(0,r.$Zj)("fold-up",60148),fold:(0,r.$Zj)("fold",60149),folderActive:(0,r.$Zj)("folder-active",60150),folderOpened:(0,r.$Zj)("folder-opened",60151),gear:(0,r.$Zj)("gear",60152),gift:(0,r.$Zj)("gift",60153),gistSecret:(0,r.$Zj)("gist-secret",60154),gist:(0,r.$Zj)("gist",60155),gitCommit:(0,r.$Zj)("git-commit",60156),gitCompare:(0,r.$Zj)("git-compare",60157),compareChanges:(0,r.$Zj)("compare-changes",60157),gitMerge:(0,r.$Zj)("git-merge",60158),githubAction:(0,r.$Zj)("github-action",60159),githubAlt:(0,r.$Zj)("github-alt",60160),globe:(0,r.$Zj)("globe",60161),grabber:(0,r.$Zj)("grabber",60162),graph:(0,r.$Zj)("graph",60163),gripper:(0,r.$Zj)("gripper",60164),heart:(0,r.$Zj)("heart",60165),home:(0,r.$Zj)("home",60166),horizontalRule:(0,r.$Zj)("horizontal-rule",60167),hubot:(0,r.$Zj)("hubot",60168),inbox:(0,r.$Zj)("inbox",60169),issueReopened:(0,r.$Zj)("issue-reopened",60171),issues:(0,r.$Zj)("issues",60172),italic:(0,r.$Zj)("italic",60173),jersey:(0,r.$Zj)("jersey",60174),json:(0,r.$Zj)("json",60175),kebabVertical:(0,r.$Zj)("kebab-vertical",60176),key:(0,r.$Zj)("key",60177),law:(0,r.$Zj)("law",60178),lightbulbAutofix:(0,r.$Zj)("lightbulb-autofix",60179),linkExternal:(0,r.$Zj)("link-external",60180),link:(0,r.$Zj)("link",60181),listOrdered:(0,r.$Zj)("list-ordered",60182),listUnordered:(0,r.$Zj)("list-unordered",60183),liveShare:(0,r.$Zj)("live-share",60184),loading:(0,r.$Zj)("loading",60185),location:(0,r.$Zj)("location",60186),mailRead:(0,r.$Zj)("mail-read",60187),mail:(0,r.$Zj)("mail",60188),markdown:(0,r.$Zj)("markdown",60189),megaphone:(0,r.$Zj)("megaphone",60190),mention:(0,r.$Zj)("mention",60191),milestone:(0,r.$Zj)("milestone",60192),gitPullRequestMilestone:(0,r.$Zj)("git-pull-request-milestone",60192),mortarBoard:(0,r.$Zj)("mortar-board",60193),move:(0,r.$Zj)("move",60194),multipleWindows:(0,r.$Zj)("multiple-windows",60195),mute:(0,r.$Zj)("mute",60196),noNewline:(0,r.$Zj)("no-newline",60197),note:(0,r.$Zj)("note",60198),octoface:(0,r.$Zj)("octoface",60199),openPreview:(0,r.$Zj)("open-preview",60200),package:(0,r.$Zj)("package",60201),paintcan:(0,r.$Zj)("paintcan",60202),pin:(0,r.$Zj)("pin",60203),play:(0,r.$Zj)("play",60204),run:(0,r.$Zj)("run",60204),plug:(0,r.$Zj)("plug",60205),preserveCase:(0,r.$Zj)("preserve-case",60206),preview:(0,r.$Zj)("preview",60207),project:(0,r.$Zj)("project",60208),pulse:(0,r.$Zj)("pulse",60209),question:(0,r.$Zj)("question",60210),quote:(0,r.$Zj)("quote",60211),radioTower:(0,r.$Zj)("radio-tower",60212),reactions:(0,r.$Zj)("reactions",60213),references:(0,r.$Zj)("references",60214),refresh:(0,r.$Zj)("refresh",60215),regex:(0,r.$Zj)("regex",60216),remoteExplorer:(0,r.$Zj)("remote-explorer",60217),remote:(0,r.$Zj)("remote",60218),remove:(0,r.$Zj)("remove",60219),replaceAll:(0,r.$Zj)("replace-all",60220),replace:(0,r.$Zj)("replace",60221),repoClone:(0,r.$Zj)("repo-clone",60222),repoForcePush:(0,r.$Zj)("repo-force-push",60223),repoPull:(0,r.$Zj)("repo-pull",60224),repoPush:(0,r.$Zj)("repo-push",60225),report:(0,r.$Zj)("report",60226),requestChanges:(0,r.$Zj)("request-changes",60227),rocket:(0,r.$Zj)("rocket",60228),rootFolderOpened:(0,r.$Zj)("root-folder-opened",60229),rootFolder:(0,r.$Zj)("root-folder",60230),rss:(0,r.$Zj)("rss",60231),ruby:(0,r.$Zj)("ruby",60232),saveAll:(0,r.$Zj)("save-all",60233),saveAs:(0,r.$Zj)("save-as",60234),save:(0,r.$Zj)("save",60235),screenFull:(0,r.$Zj)("screen-full",60236),screenNormal:(0,r.$Zj)("screen-normal",60237),searchStop:(0,r.$Zj)("search-stop",60238),server:(0,r.$Zj)("server",60240),settingsGear:(0,r.$Zj)("settings-gear",60241),settings:(0,r.$Zj)("settings",60242),shield:(0,r.$Zj)("shield",60243),smiley:(0,r.$Zj)("smiley",60244),sortPrecedence:(0,r.$Zj)("sort-precedence",60245),splitHorizontal:(0,r.$Zj)("split-horizontal",60246),splitVertical:(0,r.$Zj)("split-vertical",60247),squirrel:(0,r.$Zj)("squirrel",60248),starFull:(0,r.$Zj)("star-full",60249),starHalf:(0,r.$Zj)("star-half",60250),symbolClass:(0,r.$Zj)("symbol-class",60251),symbolColor:(0,r.$Zj)("symbol-color",60252),symbolConstant:(0,r.$Zj)("symbol-constant",60253),symbolEnumMember:(0,r.$Zj)("symbol-enum-member",60254),symbolField:(0,r.$Zj)("symbol-field",60255),symbolFile:(0,r.$Zj)("symbol-file",60256),symbolInterface:(0,r.$Zj)("symbol-interface",60257),symbolKeyword:(0,r.$Zj)("symbol-keyword",60258),symbolMisc:(0,r.$Zj)("symbol-misc",60259),symbolOperator:(0,r.$Zj)("symbol-operator",60260),symbolProperty:(0,r.$Zj)("symbol-property",60261),wrench:(0,r.$Zj)("wrench",60261),wrenchSubaction:(0,r.$Zj)("wrench-subaction",60261),symbolSnippet:(0,r.$Zj)("symbol-snippet",60262),tasklist:(0,r.$Zj)("tasklist",60263),telescope:(0,r.$Zj)("telescope",60264),textSize:(0,r.$Zj)("text-size",60265),threeBars:(0,r.$Zj)("three-bars",60266),thumbsdown:(0,r.$Zj)("thumbsdown",60267),thumbsup:(0,r.$Zj)("thumbsup",60268),tools:(0,r.$Zj)("tools",60269),triangleDown:(0,r.$Zj)("triangle-down",60270),triangleLeft:(0,r.$Zj)("triangle-left",60271),triangleRight:(0,r.$Zj)("triangle-right",60272),triangleUp:(0,r.$Zj)("triangle-up",60273),twitter:(0,r.$Zj)("twitter",60274),unfold:(0,r.$Zj)("unfold",60275),unlock:(0,r.$Zj)("unlock",60276),unmute:(0,r.$Zj)("unmute",60277),unverified:(0,r.$Zj)("unverified",60278),verified:(0,r.$Zj)("verified",60279),versions:(0,r.$Zj)("versions",60280),vmActive:(0,r.$Zj)("vm-active",60281),vmOutline:(0,r.$Zj)("vm-outline",60282),vmRunning:(0,r.$Zj)("vm-running",60283),watch:(0,r.$Zj)("watch",60284),whitespace:(0,r.$Zj)("whitespace",60285),wholeWord:(0,r.$Zj)("whole-word",60286),window:(0,r.$Zj)("window",60287),wordWrap:(0,r.$Zj)("word-wrap",60288),zoomIn:(0,r.$Zj)("zoom-in",60289),zoomOut:(0,r.$Zj)("zoom-out",60290),listFilter:(0,r.$Zj)("list-filter",60291),listFlat:(0,r.$Zj)("list-flat",60292),listSelection:(0,r.$Zj)("list-selection",60293),selection:(0,r.$Zj)("selection",60293),listTree:(0,r.$Zj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$Zj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$Zj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$Zj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$Zj)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$Zj)("circle-small-filled",60298),debugStackframeDot:(0,r.$Zj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$Zj)("terminal-decoration-mark",60298),debugStackframe:(0,r.$Zj)("debug-stackframe",60299),debugStackframeFocused:(0,r.$Zj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$Zj)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$Zj)("symbol-string",60301),debugReverseContinue:(0,r.$Zj)("debug-reverse-continue",60302),debugStepBack:(0,r.$Zj)("debug-step-back",60303),debugRestartFrame:(0,r.$Zj)("debug-restart-frame",60304),debugAlt:(0,r.$Zj)("debug-alt",60305),callIncoming:(0,r.$Zj)("call-incoming",60306),callOutgoing:(0,r.$Zj)("call-outgoing",60307),menu:(0,r.$Zj)("menu",60308),expandAll:(0,r.$Zj)("expand-all",60309),feedback:(0,r.$Zj)("feedback",60310),gitPullRequestReviewer:(0,r.$Zj)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$Zj)("group-by-ref-type",60311),ungroupByRefType:(0,r.$Zj)("ungroup-by-ref-type",60312),account:(0,r.$Zj)("account",60313),gitPullRequestAssignee:(0,r.$Zj)("git-pull-request-assignee",60313),bellDot:(0,r.$Zj)("bell-dot",60314),debugConsole:(0,r.$Zj)("debug-console",60315),library:(0,r.$Zj)("library",60316),output:(0,r.$Zj)("output",60317),runAll:(0,r.$Zj)("run-all",60318),syncIgnored:(0,r.$Zj)("sync-ignored",60319),pinned:(0,r.$Zj)("pinned",60320),githubInverted:(0,r.$Zj)("github-inverted",60321),serverProcess:(0,r.$Zj)("server-process",60322),serverEnvironment:(0,r.$Zj)("server-environment",60323),pass:(0,r.$Zj)("pass",60324),issueClosed:(0,r.$Zj)("issue-closed",60324),stopCircle:(0,r.$Zj)("stop-circle",60325),playCircle:(0,r.$Zj)("play-circle",60326),record:(0,r.$Zj)("record",60327),debugAltSmall:(0,r.$Zj)("debug-alt-small",60328),vmConnect:(0,r.$Zj)("vm-connect",60329),cloud:(0,r.$Zj)("cloud",60330),merge:(0,r.$Zj)("merge",60331),export:(0,r.$Zj)("export",60332),graphLeft:(0,r.$Zj)("graph-left",60333),magnet:(0,r.$Zj)("magnet",60334),notebook:(0,r.$Zj)("notebook",60335),redo:(0,r.$Zj)("redo",60336),checkAll:(0,r.$Zj)("check-all",60337),pinnedDirty:(0,r.$Zj)("pinned-dirty",60338),passFilled:(0,r.$Zj)("pass-filled",60339),circleLargeFilled:(0,r.$Zj)("circle-large-filled",60340),circleLarge:(0,r.$Zj)("circle-large",60341),circleLargeOutline:(0,r.$Zj)("circle-large-outline",60341),combine:(0,r.$Zj)("combine",60342),gather:(0,r.$Zj)("gather",60342),table:(0,r.$Zj)("table",60343),variableGroup:(0,r.$Zj)("variable-group",60344),typeHierarchy:(0,r.$Zj)("type-hierarchy",60345),typeHierarchySub:(0,r.$Zj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$Zj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$Zj)("git-pull-request-create",60348),runAbove:(0,r.$Zj)("run-above",60349),runBelow:(0,r.$Zj)("run-below",60350),notebookTemplate:(0,r.$Zj)("notebook-template",60351),debugRerun:(0,r.$Zj)("debug-rerun",60352),workspaceTrusted:(0,r.$Zj)("workspace-trusted",60353),workspaceUntrusted:(0,r.$Zj)("workspace-untrusted",60354),workspaceUnknown:(0,r.$Zj)("workspace-unknown",60355),terminalCmd:(0,r.$Zj)("terminal-cmd",60356),terminalDebian:(0,r.$Zj)("terminal-debian",60357),terminalLinux:(0,r.$Zj)("terminal-linux",60358),terminalPowershell:(0,r.$Zj)("terminal-powershell",60359),terminalTmux:(0,r.$Zj)("terminal-tmux",60360),terminalUbuntu:(0,r.$Zj)("terminal-ubuntu",60361),terminalBash:(0,r.$Zj)("terminal-bash",60362),arrowSwap:(0,r.$Zj)("arrow-swap",60363),copy:(0,r.$Zj)("copy",60364),personAdd:(0,r.$Zj)("person-add",60365),filterFilled:(0,r.$Zj)("filter-filled",60366),wand:(0,r.$Zj)("wand",60367),debugLineByLine:(0,r.$Zj)("debug-line-by-line",60368),inspect:(0,r.$Zj)("inspect",60369),layers:(0,r.$Zj)("layers",60370),layersDot:(0,r.$Zj)("layers-dot",60371),layersActive:(0,r.$Zj)("layers-active",60372),compass:(0,r.$Zj)("compass",60373),compassDot:(0,r.$Zj)("compass-dot",60374),compassActive:(0,r.$Zj)("compass-active",60375),azure:(0,r.$Zj)("azure",60376),issueDraft:(0,r.$Zj)("issue-draft",60377),gitPullRequestClosed:(0,r.$Zj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$Zj)("git-pull-request-draft",60379),debugAll:(0,r.$Zj)("debug-all",60380),debugCoverage:(0,r.$Zj)("debug-coverage",60381),runErrors:(0,r.$Zj)("run-errors",60382),folderLibrary:(0,r.$Zj)("folder-library",60383),debugContinueSmall:(0,r.$Zj)("debug-continue-small",60384),beakerStop:(0,r.$Zj)("beaker-stop",60385),graphLine:(0,r.$Zj)("graph-line",60386),graphScatter:(0,r.$Zj)("graph-scatter",60387),pieChart:(0,r.$Zj)("pie-chart",60388),bracket:(0,r.$Zj)("bracket",60175),bracketDot:(0,r.$Zj)("bracket-dot",60389),bracketError:(0,r.$Zj)("bracket-error",60390),lockSmall:(0,r.$Zj)("lock-small",60391),azureDevops:(0,r.$Zj)("azure-devops",60392),verifiedFilled:(0,r.$Zj)("verified-filled",60393),newline:(0,r.$Zj)("newline",60394),layout:(0,r.$Zj)("layout",60395),layoutActivitybarLeft:(0,r.$Zj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$Zj)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$Zj)("layout-panel-left",60398),layoutPanelCenter:(0,r.$Zj)("layout-panel-center",60399),layoutPanelJustify:(0,r.$Zj)("layout-panel-justify",60400),layoutPanelRight:(0,r.$Zj)("layout-panel-right",60401),layoutPanel:(0,r.$Zj)("layout-panel",60402),layoutSidebarLeft:(0,r.$Zj)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$Zj)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$Zj)("layout-statusbar",60405),layoutMenubar:(0,r.$Zj)("layout-menubar",60406),layoutCentered:(0,r.$Zj)("layout-centered",60407),target:(0,r.$Zj)("target",60408),indent:(0,r.$Zj)("indent",60409),recordSmall:(0,r.$Zj)("record-small",60410),errorSmall:(0,r.$Zj)("error-small",60411),terminalDecorationError:(0,r.$Zj)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$Zj)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$Zj)("arrow-circle-left",60413),arrowCircleRight:(0,r.$Zj)("arrow-circle-right",60414),arrowCircleUp:(0,r.$Zj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$Zj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$Zj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$Zj)("layout-sidebar-left-off",60418),blank:(0,r.$Zj)("blank",60419),heartFilled:(0,r.$Zj)("heart-filled",60420),map:(0,r.$Zj)("map",60421),mapHorizontal:(0,r.$Zj)("map-horizontal",60421),foldHorizontal:(0,r.$Zj)("fold-horizontal",60421),mapFilled:(0,r.$Zj)("map-filled",60422),mapHorizontalFilled:(0,r.$Zj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$Zj)("fold-horizontal-filled",60422),circleSmall:(0,r.$Zj)("circle-small",60423),bellSlash:(0,r.$Zj)("bell-slash",60424),bellSlashDot:(0,r.$Zj)("bell-slash-dot",60425),commentUnresolved:(0,r.$Zj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$Zj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$Zj)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$Zj)("search-fuzzy",60429),commentDraft:(0,r.$Zj)("comment-draft",60430),send:(0,r.$Zj)("send",60431),sparkle:(0,r.$Zj)("sparkle",60432),insert:(0,r.$Zj)("insert",60433),mic:(0,r.$Zj)("mic",60434),thumbsdownFilled:(0,r.$Zj)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$Zj)("thumbsup-filled",60436),coffee:(0,r.$Zj)("coffee",60437),snake:(0,r.$Zj)("snake",60438),game:(0,r.$Zj)("game",60439),vr:(0,r.$Zj)("vr",60440),chip:(0,r.$Zj)("chip",60441),piano:(0,r.$Zj)("piano",60442),music:(0,r.$Zj)("music",60443),micFilled:(0,r.$Zj)("mic-filled",60444),repoFetch:(0,r.$Zj)("repo-fetch",60445),copilot:(0,r.$Zj)("copilot",60446),lightbulbSparkle:(0,r.$Zj)("lightbulb-sparkle",60447),robot:(0,r.$Zj)("robot",60448),sparkleFilled:(0,r.$Zj)("sparkle-filled",60449),diffSingle:(0,r.$Zj)("diff-single",60450),diffMultiple:(0,r.$Zj)("diff-multiple",60451),surroundWith:(0,r.$Zj)("surround-with",60452),share:(0,r.$Zj)("share",60453),gitStash:(0,r.$Zj)("git-stash",60454),gitStashApply:(0,r.$Zj)("git-stash-apply",60455),gitStashPop:(0,r.$Zj)("git-stash-pop",60456),vscode:(0,r.$Zj)("vscode",60457),vscodeInsiders:(0,r.$Zj)("vscode-insiders",60458),codeOss:(0,r.$Zj)("code-oss",60459),runCoverage:(0,r.$Zj)("run-coverage",60460),runAllCoverage:(0,r.$Zj)("run-all-coverage",60461),coverage:(0,r.$Zj)("coverage",60462),githubProject:(0,r.$Zj)("github-project",60463),mapVertical:(0,r.$Zj)("map-vertical",60464),foldVertical:(0,r.$Zj)("fold-vertical",60464),mapVerticalFilled:(0,r.$Zj)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$Zj)("fold-vertical-filled",60465),goToSearch:(0,r.$Zj)("go-to-search",60466),percentage:(0,r.$Zj)("percentage",60467),sortPercentage:(0,r.$Zj)("sort-percentage",60467),attach:(0,r.$Zj)("attach",60468)}}),define(ye[83],Se([1,0,105,186]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=void 0,e.$3j=P;function P(){return Object.values(e.$5j)}e.$4j={dialogError:(0,r.$Zj)("dialog-error","error"),dialogWarning:(0,r.$Zj)("dialog-warning","warning"),dialogInfo:(0,r.$Zj)("dialog-info","info"),dialogClose:(0,r.$Zj)("dialog-close","close"),treeItemExpanded:(0,r.$Zj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$Zj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$Zj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$Zj)("tree-filter-clear","close"),treeItemLoading:(0,r.$Zj)("tree-item-loading","loading"),menuSelection:(0,r.$Zj)("menu-selection","check"),menuSubmenu:(0,r.$Zj)("menu-submenu","chevron-right"),menuBarMore:(0,r.$Zj)("menubar-more","more"),scrollbarButtonLeft:(0,r.$Zj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$Zj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$Zj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$Zj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$Zj)("toolbar-more","more"),quickInputBack:(0,r.$Zj)("quick-input-back","arrow-left"),dropDownButton:(0,r.$Zj)("drop-down-button",60084),symbolCustomColor:(0,r.$Zj)("symbol-customcolor",60252),exportIcon:(0,r.$Zj)("export",60332),workspaceUnspecified:(0,r.$Zj)("workspace-unspecified",60355),newLine:(0,r.$Zj)("newline",60394),thumbsDownFilled:(0,r.$Zj)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$Zj)("thumbsup-filled",60436),gitFetch:(0,r.$Zj)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$Zj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$Zj)("debug-breakpoint-pending",60377)},e.$5j={...h.$2j,...e.$4j}}),define(ye[25],Se([1,0,18]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=h,e.$eo=P,e.$fo=T,e.$go=$,e.$ho=a,e.$io=I,e.$jo=E,e.$ko=l,e.$lo=k,e.$mo=p,e.$no=c,e.$oo=m,e.$po=d;function h(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const n=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([o,t])=>{n[o]=t&&typeof t=="object"?h(t):t}),n}function P(g){if(!g||typeof g!="object")return g;const n=[g];for(;n.length>0;){const o=n.shift();Object.freeze(o);for(const t in o)if(O.call(o,t)){const i=o[t];typeof i=="object"&&!Object.isFrozen(i)&&!(0,r.$ig)(i)&&n.push(i)}}return g}const O=Object.prototype.hasOwnProperty;function T(g,n){return R(g,n,new Set)}function R(g,n,o){if((0,r.$og)(g))return g;const t=n(g);if(typeof t<"u")return t;if(Array.isArray(g)){const i=[];for(const s of g)i.push(R(s,n,o));return i}if((0,r.$hg)(g)){if(o.has(g))throw new Error("Cannot clone recursive data-structure");o.add(g);const i={};for(const s in g)O.call(g,s)&&(i[s]=R(g[s],n,o));return o.delete(g),i}return g}function $(g,n,o=!0){return(0,r.$hg)(g)?((0,r.$hg)(n)&&Object.keys(n).forEach(t=>{t in g?o&&((0,r.$hg)(g[t])&&(0,r.$hg)(n[t])?$(g[t],n[t],o):g[t]=n[t]):g[t]=n[t]}),g):n}function a(g,n){if(g===n)return!0;if(g==null||n===null||n===void 0||typeof g!=typeof n||typeof g!="object"||Array.isArray(g)!==Array.isArray(n))return!1;let o,t;if(Array.isArray(g)){if(g.length!==n.length)return!1;for(o=0;o<g.length;o++)if(!a(g[o],n[o]))return!1}else{const i=[];for(t in g)i.push(t);i.sort();const s=[];for(t in n)s.push(t);if(s.sort(),!a(i,s))return!1;for(o=0;o<i.length;o++)if(!a(g[i[o]],n[i[o]]))return!1}return!0}function I(g){const n=new Set;return JSON.stringify(g,(o,t)=>{if((0,r.$hg)(t)||Array.isArray(t)){if(n.has(t))return"[Circular]";n.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function E(g,n){const o=Object.create(null);return!g||!n||Object.keys(n).forEach(i=>{const s=g[i],f=n[i];a(s,f)||(o[i]=f)}),o}function l(g,n){const o=n.toLowerCase(),t=Object.keys(g).find(i=>i.toLowerCase()===o);return t?g[t]:g[n]}function k(g,n){const o=Object.create(null);for(const[t,i]of Object.entries(g))n(t,i)&&(o[t]=i);return o}function p(g){let n=[];for(;Object.prototype!==g;)n=n.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return n}function c(g){const n=[];for(const o of p(g))typeof g[o]=="function"&&n.push(o);return n}function m(g,n){const o=i=>function(){const s=Array.prototype.slice.call(arguments,0);return n(i,s)},t={};for(const i of g)t[i]=o(i);return t}function d(g,n){const o={};for(const[t,i]of Object.entries(g))o[t]=n(i,t);return o}}),define(ye[50],Se([1,0,83]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$6j=P;var h;(function(T){function R($){return $&&typeof $=="object"&&typeof $.id=="string"}T.isThemeColor=R})(h||(e.ThemeColor=h={}));function P(T){return{id:T}}var O;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function $(g){const n=R.exec(g.id);if(!n)return $(r.$5j.error);const[,o,t]=n,i=["codicon","codicon-"+o];return t&&i.push("codicon-modifier-"+t.substring(1)),i}T.asClassNameArray=$;function a(g){return $(g).join(" ")}T.asClassName=a;function I(g){return"."+$(g).join(".")}T.asCSSSelector=I;function E(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||h.isThemeColor(g.color))}T.isThemeIcon=E;const l=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function k(g){const n=l.exec(g);if(!n)return;const[,o]=n;return{id:o}}T.fromString=k;function p(g){return{id:g}}T.fromId=p;function c(g,n){let o=g.id;const t=o.lastIndexOf("~");return t!==-1&&(o=o.substring(0,t)),n&&(o=`${o}~${n}`),{id:o}}T.modify=c;function m(g){const n=g.id.lastIndexOf("~");if(n!==-1)return g.id.substring(n+1)}T.getModifier=m;function d(g,n){return g.id===n.id&&g.color?.id===n.color?.id}T.isEqual=d})(O||(e.ThemeIcon=O={}))}),define(ye[84],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$bf=h,e.$cf=P;var r;(function(O){O[O.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",O[O.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",O[O.MAX_UINT_8=255]="MAX_UINT_8",O[O.MAX_UINT_16=65535]="MAX_UINT_16",O[O.MAX_UINT_32=4294967295]="MAX_UINT_32",O[O.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function h(O){return O<0?0:O>r.MAX_UINT_8?r.MAX_UINT_8:O|0}function P(O){return O<0?0:O>r.MAX_UINT_32?r.MAX_UINT_32:O|0}}),define(ye[13],Se([1,0,183,27,49,84]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.GraphemeBreakType=e.$5f=e.$Wf=e.$Pf=e.$Of=void 0,e.$df=T,e.$ef=$,e.$ff=I,e.$gf=E,e.$hf=l,e.$if=k,e.$jf=p,e.$kf=c,e.$lf=m,e.$mf=d,e.$nf=g,e.$of=n,e.$pf=o,e.$qf=t,e.$rf=i,e.$sf=s,e.$tf=f,e.$uf=u,e.$vf=w,e.$wf=y,e.$xf=D,e.$yf=S,e.$zf=C,e.$Af=A,e.$Bf=b,e.$Cf=v,e.$Df=M,e.$Ef=N,e.$Ff=L,e.$Gf=j,e.$Hf=z,e.$If=F,e.$Jf=B,e.$Kf=_,e.$Lf=re,e.$Mf=U,e.$Nf=G,e.$Qf=ne,e.$Rf=De,e.$Sf=$e,e.$Tf=K,e.$Uf=ae,e.$Vf=le,e.$Xf=ue,e.$Yf=X,e.$Zf=oe,e.$1f=pe,e.$2f=Fe,e.$3f=Ue,e.$4f=Ie,e.$6f=Oe,e.$7f=q,e.$8f=V,e.$9f=J,e.$0f=x,e.$$f=fe,e.$_f=be,e.$ag=Ne,e.$bg=ot;function T(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}const R=/{(\d+)}/g;function $(Pe,...ze){return ze.length===0?Pe:Pe.replace(R,function(He,Le){const je=parseInt(Le,10);return isNaN(je)||je<0||je>=ze.length?He:ze[je]})}const a=/{([^}]+)}/g;function I(Pe,ze){return Object.keys(ze).length===0?Pe:Pe.replace(a,(He,Le)=>ze[Le]??He)}function E(Pe){return Pe.replace(/[<>"'&]/g,ze=>{switch(ze){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ze})}function l(Pe){return Pe.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}function k(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(Pe,ze){let He=0,Le=Pe.indexOf(ze);for(;Le!==-1;)He++,Le=Pe.indexOf(ze,Le+ze.length);return He}function c(Pe,ze,He="\u2026"){return Pe.length<=ze?Pe:`${Pe.substr(0,ze)}${He}`}function m(Pe,ze,He="\u2026"){if(Pe.length<=ze)return Pe;const Le=Math.ceil(ze/2)-He.length/2,je=Math.floor(ze/2)-He.length/2;return`${Pe.substr(0,Le)}${He}${Pe.substr(Pe.length-je)}`}function d(Pe,ze=" "){const He=g(Pe,ze);return n(He,ze)}function g(Pe,ze){if(!Pe||!ze)return Pe;const He=ze.length;if(He===0||Pe.length===0)return Pe;let Le=0;for(;Pe.indexOf(ze,Le)===Le;)Le=Le+He;return Pe.substring(Le)}function n(Pe,ze){if(!Pe||!ze)return Pe;const He=ze.length,Le=Pe.length;if(He===0||Le===0)return Pe;let je=Le,Y=-1;for(;Y=Pe.lastIndexOf(ze,je-1),!(Y===-1||Y+He!==je);){if(Y===0)return"";je=Y}return Pe.substring(0,je)}function o(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(Pe){return Pe.replace(/\*/g,"")}function i(Pe,ze,He={}){if(!Pe)throw new Error("Cannot create regex from empty string");ze||(Pe=k(Pe)),He.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Le="";return He.global&&(Le+="g"),He.matchCase||(Le+="i"),He.multiline&&(Le+="m"),He.unicode&&(Le+="u"),new RegExp(Pe,Le)}function s(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}function f(Pe){return Pe.split(/\r\n|\r|\n/)}function u(Pe){const ze=[],He=Pe.split(/(\r\n|\r|\n)/);for(let Le=0;Le<Math.ceil(He.length/2);Le++)ze.push(He[2*Le]+(He[2*Le+1]??""));return ze}function w(Pe){for(let ze=0,He=Pe.length;ze<He;ze++){const Le=Pe.charCodeAt(ze);if(Le!==h.CharCode.Space&&Le!==h.CharCode.Tab)return ze}return-1}function y(Pe,ze=0,He=Pe.length){for(let Le=ze;Le<He;Le++){const je=Pe.charCodeAt(Le);if(je!==h.CharCode.Space&&je!==h.CharCode.Tab)return Pe.substring(ze,Le)}return Pe.substring(ze,He)}function D(Pe,ze=Pe.length-1){for(let He=ze;He>=0;He--){const Le=Pe.charCodeAt(He);if(Le!==h.CharCode.Space&&Le!==h.CharCode.Tab)return He}return-1}function S(Pe,ze,He){const Le=[];let je=0;for(const Y of Pe.matchAll(ze)){if(Le.push(Pe.slice(je,Y.index)),Y.index===void 0)throw new Error("match.index should be defined");je=Y.index+Y[0].length,Le.push(He(Y[0],...Y.slice(1),Y.index,Pe,Y.groups))}return Le.push(Pe.slice(je)),Promise.all(Le).then(Y=>Y.join(""))}function C(Pe,ze){return Pe<ze?-1:Pe>ze?1:0}function A(Pe,ze,He=0,Le=Pe.length,je=0,Y=ze.length){for(;He<Le&&je<Y;He++,je++){const Xe=Pe.charCodeAt(He),_e=ze.charCodeAt(je);if(Xe<_e)return-1;if(Xe>_e)return 1}const de=Le-He,Ce=Y-je;return de<Ce?-1:de>Ce?1:0}function b(Pe,ze){return v(Pe,ze,0,Pe.length,0,ze.length)}function v(Pe,ze,He=0,Le=Pe.length,je=0,Y=ze.length){for(;He<Le&&je<Y;He++,je++){let Xe=Pe.charCodeAt(He),_e=ze.charCodeAt(je);if(Xe===_e)continue;if(Xe>=128||_e>=128)return A(Pe.toLowerCase(),ze.toLowerCase(),He,Le,je,Y);N(Xe)&&(Xe-=32),N(_e)&&(_e-=32);const ut=Xe-_e;if(ut!==0)return ut}const de=Le-He,Ce=Y-je;return de<Ce?-1:de>Ce?1:0}function M(Pe){return Pe>=h.CharCode.Digit0&&Pe<=h.CharCode.Digit9}function N(Pe){return Pe>=h.CharCode.a&&Pe<=h.CharCode.z}function L(Pe){return Pe>=h.CharCode.A&&Pe<=h.CharCode.Z}function j(Pe,ze){return Pe.length===ze.length&&v(Pe,ze)===0}function z(Pe,ze){const He=ze.length;return ze.length>Pe.length?!1:v(Pe,ze,0,He)===0}function F(Pe,ze){const He=Math.min(Pe.length,ze.length);let Le;for(Le=0;Le<He;Le++)if(Pe.charCodeAt(Le)!==ze.charCodeAt(Le))return Le;return He}function B(Pe,ze){const He=Math.min(Pe.length,ze.length);let Le;const je=Pe.length-1,Y=ze.length-1;for(Le=0;Le<He;Le++)if(Pe.charCodeAt(je-Le)!==ze.charCodeAt(Y-Le))return Le;return He}function _(Pe){return 55296<=Pe&&Pe<=56319}function re(Pe){return 56320<=Pe&&Pe<=57343}function U(Pe,ze){return(Pe-55296<<10)+(ze-56320)+65536}function G(Pe,ze,He){const Le=Pe.charCodeAt(He);if(_(Le)&&He+1<ze){const je=Pe.charCodeAt(He+1);if(re(je))return U(Le,je)}return Le}function Q(Pe,ze){const He=Pe.charCodeAt(ze-1);if(re(He)&&ze>1){const Le=Pe.charCodeAt(ze-2);if(_(Le))return U(Le,He)}return He}class ee{get offset(){return this.e}constructor(ze,He=0){this.c=ze,this.d=ze.length,this.e=He}setOffset(ze){this.e=ze}prevCodePoint(){const ze=Q(this.c,this.e);return this.e-=ze>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ze}nextCodePoint(){const ze=G(this.c,this.d,this.e);return this.e+=ze>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ze}eol(){return this.e>=this.d}}e.$Of=ee;class he{get offset(){return this.c.offset}constructor(ze,He=0){this.c=new ee(ze,He)}nextGraphemeLength(){const ze=et.getInstance(),He=this.c,Le=He.offset;let je=ze.getGraphemeBreakType(He.nextCodePoint());for(;!He.eol();){const Y=He.offset,de=ze.getGraphemeBreakType(He.nextCodePoint());if(Ge(je,de)){He.setOffset(Y);break}je=de}return He.offset-Le}prevGraphemeLength(){const ze=et.getInstance(),He=this.c,Le=He.offset;let je=ze.getGraphemeBreakType(He.prevCodePoint());for(;He.offset>0;){const Y=He.offset,de=ze.getGraphemeBreakType(He.prevCodePoint());if(Ge(de,je)){He.setOffset(Y);break}je=de}return Le-He.offset}eol(){return this.c.eol()}}e.$Pf=he;function ne(Pe,ze){return new he(Pe,ze).nextGraphemeLength()}function De(Pe,ze){return new he(Pe,ze).prevGraphemeLength()}function $e(Pe,ze){ze>0&&re(Pe.charCodeAt(ze))&&ze--;const He=ze+ne(Pe,ze);return[He-De(Pe,He),He]}function K(Pe){const ze=new he(Pe);let He=0;for(;!ze.eol();)He++,ze.nextGraphemeLength();return He}let W;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ae(Pe){return W||(W=se()),W.test(Pe)}const te=/^[\t\n\r\x20-\x7E]*$/;function le(Pe){return te.test(Pe)}e.$Wf=/[\u2028\u2029]/;function ue(Pe){return e.$Wf.test(Pe)}function X(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}function oe(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}function pe(Pe,ze,He=""){const Le=Pe.trimStart();if(Le.length<ze)return Le;const je=/\b/g;let Y=0;for(;je.test(Le)&&!(Le.length-je.lastIndex<ze);)Y=je.lastIndex,je.lastIndex+=1;return Y===0?Le:He+Le.substring(Y).trimStart()}const we=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Fe(Pe){let ze=0;for(const He of Pe.matchAll(we))ze!==He.index&&(yield{isCode:!1,str:Pe.substring(ze,He.index)}),yield{isCode:!0,str:He[0]},ze=He.index+He[0].length;ze!==Pe.length&&(yield{isCode:!1,str:Pe.substring(ze)})}function Ue(Pe){return Pe&&(Pe=Pe.replace(we,"")),Pe}const ke=/\\\[.*?\\\]/g;function Ie(Pe){return Ue(Pe).replace(ke,"")}e.$5f=String.fromCharCode(h.CharCode.UTF8_BOM);function Oe(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===h.CharCode.UTF8_BOM)}function q(Pe){return Oe(Pe)?Pe.substr(1):Pe}function V(Pe,ze){if(!Pe||!ze||Pe.length<ze.length)return!1;const He=ze.length,Le=Pe.toLowerCase();let je=0,Y=-1;for(;je<He;){const de=Le.indexOf(ze[je],Y+1);if(de<0)return!1;Y=de,je++}return!0}function J(Pe,ze=!1){return Pe?(ze&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}function x(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}function fe(Pe,ze=1){if(ze===0)return"";let He=-1;do He=Pe.indexOf(`
`,He+1),ze--;while(ze>0&&He>=0);return He===-1?Pe:(Pe[He-1]==="\r"&&He--,Pe.substr(0,He))}function be(Pe){const ze=h.CharCode.Z-h.CharCode.A+1;return Pe=Pe%(2*ze),Pe<ze?String.fromCharCode(h.CharCode.a+Pe):String.fromCharCode(h.CharCode.A+Pe-ze)}function Ne(Pe){return et.getInstance().getGraphemeBreakType(Pe)}function Ge(Pe,ze){return Pe===Ze.Other?ze!==Ze.Extend&&ze!==Ze.SpacingMark:Pe===Ze.CR&&ze===Ze.LF?!1:Pe===Ze.Control||Pe===Ze.CR||Pe===Ze.LF||ze===Ze.Control||ze===Ze.CR||ze===Ze.LF?!0:!(Pe===Ze.L&&(ze===Ze.L||ze===Ze.V||ze===Ze.LV||ze===Ze.LVT)||(Pe===Ze.LV||Pe===Ze.V)&&(ze===Ze.V||ze===Ze.T)||(Pe===Ze.LVT||Pe===Ze.T)&&ze===Ze.T||ze===Ze.Extend||ze===Ze.ZWJ||ze===Ze.SpacingMark||Pe===Ze.Prepend||Pe===Ze.ZWJ&&ze===Ze.Extended_Pictographic||Pe===Ze.Regional_Indicator&&ze===Ze.Regional_Indicator)}var Ze;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Ze||(e.GraphemeBreakType=Ze={}));class et{static{this.c=null}static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=rt()}getGraphemeBreakType(ze){if(ze<32)return ze===h.CharCode.LineFeed?Ze.LF:ze===h.CharCode.CarriageReturn?Ze.CR:Ze.Control;if(ze<127)return Ze.Other;const He=this.d,Le=He.length/3;let je=1;for(;je<=Le;)if(ze<He[3*je])je=2*je;else if(ze>He[3*je+1])je=2*je+1;else return He[3*je+2];return Ze.Other}}function rt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ot(Pe,ze){if(Pe===0)return 0;const He=nt(Pe,ze);if(He!==void 0)return He;const Le=new ee(ze,Pe);return Le.prevCodePoint(),Le.offset}function nt(Pe,ze){const He=new ee(ze,Pe);let Le=He.prevCodePoint();for(;ct(Le)||Le===mt.emojiVariantSelector||Le===mt.enclosingKeyCap;){if(He.offset===0)return;Le=He.prevCodePoint()}if(!oe(Le))return;let je=He.offset;return je>0&&He.prevCodePoint()===mt.zwj&&(je=He.offset),je}function ct(Pe){return 127995<=Pe&&Pe<=127999}var mt;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(mt||(mt={})),e.$cg="\xA0";class ht{static{this.c=new P.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new r.$_e({getCacheKey:JSON.stringify},ze=>{function He(ut){const gt=new Map;for(let kt=0;kt<ut.length;kt+=2)gt.set(ut[kt],ut[kt+1]);return gt}function Le(ut,gt){const kt=new Map(ut);for(const[Nt,Bt]of gt)kt.set(Nt,Bt);return kt}function je(ut,gt){if(!ut)return gt;const kt=new Map;for(const[Nt,Bt]of ut)gt.has(Nt)&&kt.set(Nt,Bt);return kt}const Y=this.c.value;let de=ze.filter(ut=>!ut.startsWith("_")&&ut in Y);de.length===0&&(de=["_default"]);let Ce;for(const ut of de){const gt=He(Y[ut]);Ce=je(Ce,gt)}const Xe=He(Y._common),_e=Le(Xe,Ce);return new ht(_e)})}static getInstance(ze){return ht.d.get(Array.from(ze))}static{this.e=new P.$X(()=>Object.keys(ht.c.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return ht.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}containsAmbiguousCharacter(ze){for(let He=0;He<ze.length;He++){const Le=ze.codePointAt(He);if(typeof Le=="number"&&this.isAmbiguous(Le))return!0}return!1}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$dg=ht;class at{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(at.c())),this.d}static isInvisibleCharacter(ze){return at.e().has(ze)}static containsInvisibleCharacter(ze){for(let He=0;He<ze.length;He++){const Le=ze.codePointAt(He);if(typeof Le=="number"&&at.isInvisibleCharacter(Le))return!0}return!1}static get codePoints(){return at.e()}}e.$eg=at}),define(ye[135],Se([1,0,27,29,178,13]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.FuzzyScore=e.$Hk=e.$Gk=void 0,e.or=T,e.$Ik=$,e.$Jk=a,e.$Kk=l,e.$Lk=D,e.$Mk=S,e.$Nk=N,e.$Ok=L,e.$Pk=j,e.$Qk=z,e.$Rk=se,e.$Tk=ue,e.$Uk=pe,e.$Vk=we,O=We(O);function T(...ke){return function(Ie,Oe){for(let q=0,V=ke.length;q<V;q++){const J=ke[q](Ie,Oe);if(J)return J}return null}}e.$Gk=R.bind(void 0,!1),e.$Hk=R.bind(void 0,!0);function R(ke,Ie,Oe){if(!Oe||Oe.length<Ie.length)return null;let q;return ke?q=O.$Hf(Oe,Ie):q=Oe.indexOf(Ie)===0,q?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function $(ke,Ie){const Oe=Ie.toLowerCase().indexOf(ke.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+ke.length}]}function a(ke,Ie){return I(ke.toLowerCase(),Ie.toLowerCase(),0,0)}function I(ke,Ie,Oe,q){if(Oe===ke.length)return[];if(q===Ie.length)return null;if(ke[Oe]===Ie[q]){let V=null;return(V=I(ke,Ie,Oe+1,q+1))?t({start:q,end:q+1},V):null}return I(ke,Ie,Oe,q+1)}function E(ke){return r.CharCode.a<=ke&&ke<=r.CharCode.z}function l(ke){return r.CharCode.A<=ke&&ke<=r.CharCode.Z}function k(ke){return r.CharCode.Digit0<=ke&&ke<=r.CharCode.Digit9}function p(ke){return ke===r.CharCode.Space||ke===r.CharCode.Tab||ke===r.CharCode.LineFeed||ke===r.CharCode.CarriageReturn}const c=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>c.add(ke.charCodeAt(0)));function m(ke){return p(ke)||c.has(ke)}function d(ke,Ie){return ke===Ie||m(ke)&&m(Ie)}const g=new Map;function n(ke){if(g.has(ke))return g.get(ke);let Ie;const Oe=(0,P.$Ek)(ke);return Oe&&(Ie=Oe),g.set(ke,Ie),Ie}function o(ke){return E(ke)||l(ke)||k(ke)}function t(ke,Ie){return Ie.length===0?Ie=[ke]:ke.end===Ie[0].start?Ie[0].start=ke.start:Ie.unshift(ke),Ie}function i(ke,Ie){for(let Oe=Ie;Oe<ke.length;Oe++){const q=ke.charCodeAt(Oe);if(l(q)||k(q)||Oe>0&&!o(ke.charCodeAt(Oe-1)))return Oe}return ke.length}function s(ke,Ie,Oe,q){if(Oe===ke.length)return[];if(q===Ie.length)return null;if(ke[Oe]!==Ie[q].toLowerCase())return null;{let V=null,J=q+1;for(V=s(ke,Ie,Oe+1,q+1);!V&&(J=i(Ie,J))<Ie.length;)V=s(ke,Ie,Oe+1,J),J++;return V===null?null:t({start:q,end:q+1},V)}}function f(ke){let Ie=0,Oe=0,q=0,V=0,J=0;for(let Ge=0;Ge<ke.length;Ge++)J=ke.charCodeAt(Ge),l(J)&&Ie++,E(J)&&Oe++,o(J)&&q++,k(J)&&V++;const x=Ie/ke.length,fe=Oe/ke.length,be=q/ke.length,Ne=V/ke.length;return{upperPercent:x,lowerPercent:fe,alphaPercent:be,numericPercent:Ne}}function u(ke){const{upperPercent:Ie,lowerPercent:Oe}=ke;return Oe===0&&Ie>.6}function w(ke){const{upperPercent:Ie,lowerPercent:Oe,alphaPercent:q,numericPercent:V}=ke;return Oe>.2&&Ie<.8&&q>.6&&V<.2}function y(ke){let Ie=0,Oe=0,q=0,V=0;for(let J=0;J<ke.length;J++)q=ke.charCodeAt(J),l(q)&&Ie++,E(q)&&Oe++,p(q)&&V++;return(Ie===0||Oe===0)&&V===0?ke.length<=30:Ie<=5}function D(ke,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!y(ke))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Oe=f(Ie);if(!w(Oe)){if(!u(Oe))return null;Ie=Ie.toLowerCase()}let q=null,V=0;for(ke=ke.toLowerCase();V<Ie.length&&(q=s(ke,Ie,0,V))===null;)V=i(Ie,V+1);return q}function S(ke,Ie,Oe=!1){if(!Ie||Ie.length===0)return null;let q=null,V=0;for(ke=ke.toLowerCase(),Ie=Ie.toLowerCase();V<Ie.length&&(q=C(ke,Ie,0,V,Oe),q===null);)V=A(Ie,V+1);return q}function C(ke,Ie,Oe,q,V){let J=0;if(Oe===ke.length)return[];if(q===Ie.length)return null;if(!d(ke.charCodeAt(Oe),Ie.charCodeAt(q))){const be=n(ke.charCodeAt(Oe));if(!be)return null;for(let Ne=0;Ne<be.length;Ne++)if(!d(be[Ne],Ie.charCodeAt(q+Ne)))return null;J+=be.length-1}let x=null,fe=q+J+1;if(x=C(ke,Ie,Oe+1,fe,V),!V)for(;!x&&(fe=A(Ie,fe))<Ie.length;)x=C(ke,Ie,Oe+1,fe,V),fe++;if(!x)return null;if(ke.charCodeAt(Oe)!==Ie.charCodeAt(q)){const be=n(ke.charCodeAt(Oe));if(!be)return x;for(let Ne=0;Ne<be.length;Ne++)if(be[Ne]!==Ie.charCodeAt(q+Ne))return x}return t({start:q,end:q+J+1},x)}function A(ke,Ie){for(let Oe=Ie;Oe<ke.length;Oe++)if(m(ke.charCodeAt(Oe))||Oe>0&&m(ke.charCodeAt(Oe-1)))return Oe;return ke.length}const b=T(e.$Hk,D,$),v=T(e.$Hk,D,a),M=new h.$Fc(1e4);function N(ke,Ie,Oe=!1){if(typeof ke!="string"||typeof Ie!="string")return null;let q=M.get(ke);q||(q=new RegExp(O.$pf(ke),"i"),M.set(ke,q));const V=q.exec(Ie);return V?[{start:V.index,end:V.index+V[0].length}]:Oe?v(ke,Ie):b(ke,Ie)}function L(ke,Ie){const Oe=ue(ke,ke.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?z(Oe):null}function j(ke,Ie,Oe,q,V,J){const x=Math.min(13,ke.length);for(;Oe<x;Oe++){const fe=ue(ke,Ie,Oe,q,V,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,J]}function z(ke){if(typeof ke>"u")return[];const Ie=[],Oe=ke[1];for(let q=ke.length-1;q>1;q--){const V=ke[q]+Oe,J=Ie[Ie.length-1];J&&J.end===V?J.end=V+1:Ie.push({start:V,end:V+1})}return Ie}const F=128;function B(){const ke=[],Ie=[];for(let Oe=0;Oe<=F;Oe++)Ie[Oe]=0;for(let Oe=0;Oe<=F;Oe++)ke.push(Ie.slice(0));return ke}function _(ke){const Ie=[];for(let Oe=0;Oe<=ke;Oe++)Ie[Oe]=0;return Ie}const re=_(2*F),U=_(2*F),G=B(),Q=B(),ee=B(),he=!1;function ne(ke,Ie,Oe,q,V){function J(fe,be,Ne=" "){for(;fe.length<be;)fe=Ne+fe;return fe}let x=` |   |${q.split("").map(fe=>J(fe,3)).join("|")}
`;for(let fe=0;fe<=Oe;fe++)fe===0?x+=" |":x+=`${Ie[fe-1]}|`,x+=ke[fe].slice(0,V+1).map(be=>J(be.toString(),3)).join("|")+`
`;return x}function De(ke,Ie,Oe,q){ke=ke.substr(Ie),Oe=Oe.substr(q),console.log(ne(Q,ke,ke.length,Oe,Oe.length)),console.log(ne(ee,ke,ke.length,Oe,Oe.length)),console.log(ne(G,ke,ke.length,Oe,Oe.length))}function $e(ke,Ie){if(Ie<0||Ie>=ke.length)return!1;const Oe=ke.codePointAt(Ie);switch(Oe){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$Zf(Oe)}}function K(ke,Ie){if(Ie<0||Ie>=ke.length)return!1;switch(ke.charCodeAt(Ie)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function W(ke,Ie,Oe){return Ie[ke]!==Oe[ke]}function se(ke,Ie,Oe,q,V,J,x=!1){for(;Ie<Oe&&V<J;)ke[Ie]===q[V]&&(x&&(re[Ie]=V),Ie+=1),V+=1;return Ie===Oe}var ae;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(ae||(ae={}));var te;(function(ke){ke.Default=[-100,0];function Ie(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}ke.isDefault=Ie})(te||(e.FuzzyScore=te={}));class le{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Oe){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Oe}}e.$Sk=le;function ue(ke,Ie,Oe,q,V,J,x=le.default){const fe=ke.length>F?F:ke.length,be=q.length>F?F:q.length;if(Oe>=fe||J>=be||fe-Oe>be-J||!se(Ie,Oe,fe,V,J,be,!0))return;X(fe,be,Oe,J,Ie,V);let Ne=1,Ge=1,Ze=Oe,et=J;const rt=[!1];for(Ne=1,Ze=Oe;Ze<fe;Ne++,Ze++){const ht=re[Ze],at=U[Ze],Pe=Ze+1<fe?U[Ze+1]:be;for(Ge=ht-J+1,et=ht;et<Pe;Ge++,et++){let ze=Number.MIN_SAFE_INTEGER,He=!1;et<=at&&(ze=oe(ke,Ie,Ze,Oe,q,V,et,be,J,G[Ne-1][Ge-1]===0,rt));let Le=0;ze!==Number.MAX_SAFE_INTEGER&&(He=!0,Le=ze+Q[Ne-1][Ge-1]);const je=et>ht,Y=je?Q[Ne][Ge-1]+(G[Ne][Ge-1]>0?-5:0):0,de=et>ht+1&&G[Ne][Ge-1]>0,Ce=de?Q[Ne][Ge-2]+(G[Ne][Ge-2]>0?-5:0):0;if(de&&(!je||Ce>=Y)&&(!He||Ce>=Le))Q[Ne][Ge]=Ce,ee[Ne][Ge]=ae.LeftLeft,G[Ne][Ge]=0;else if(je&&(!He||Y>=Le))Q[Ne][Ge]=Y,ee[Ne][Ge]=ae.Left,G[Ne][Ge]=0;else if(He)Q[Ne][Ge]=Le,ee[Ne][Ge]=ae.Diag,G[Ne][Ge]=G[Ne-1][Ge-1]+1;else throw new Error("not possible")}}if(he&&De(ke,Oe,q,J),!rt[0]&&!x.firstMatchCanBeWeak)return;Ne--,Ge--;const ot=[Q[Ne][Ge],J];let nt=0,ct=0;for(;Ne>=1;){let ht=Ge;do{const at=ee[Ne][ht];if(at===ae.LeftLeft)ht=ht-2;else if(at===ae.Left)ht=ht-1;else break}while(ht>=1);nt>1&&Ie[Oe+Ne-1]===V[J+Ge-1]&&!W(ht+J-1,q,V)&&nt+1>G[Ne][ht]&&(ht=Ge),ht===Ge?nt++:nt=1,ct||(ct=ht),Ne--,Ge=ht-1,ot.push(Ge)}be-J===fe&&x.boostFullMatch&&(ot[0]+=2);const mt=ct-fe;return ot[0]-=mt,ot}function X(ke,Ie,Oe,q,V,J){let x=ke-1,fe=Ie-1;for(;x>=Oe&&fe>=q;)V[x]===J[fe]&&(U[x]=fe,x--),fe--}function oe(ke,Ie,Oe,q,V,J,x,fe,be,Ne,Ge){if(Ie[Oe]!==J[x])return Number.MIN_SAFE_INTEGER;let Ze=1,et=!1;return x===Oe-q?Ze=ke[Oe]===V[x]?7:5:W(x,V,J)&&(x===0||!W(x-1,V,J))?(Ze=ke[Oe]===V[x]?7:5,et=!0):$e(J,x)&&(x===0||!$e(J,x-1))?Ze=5:($e(J,x-1)||K(J,x-1))&&(Ze=5,et=!0),Ze>1&&Oe===q&&(Ge[0]=!0),et||(et=W(x,V,J)||$e(J,x-1)||K(J,x-1)),Oe===q?x>be&&(Ze-=et?3:5):Ne?Ze+=et?2:0:Ze+=et?0:1,x+1===fe&&(Ze-=et?3:5),Ze}function pe(ke,Ie,Oe,q,V,J,x){return Fe(ke,Ie,Oe,q,V,J,!0,x)}function we(ke,Ie,Oe,q,V,J,x){return Fe(ke,Ie,Oe,q,V,J,!1,x)}function Fe(ke,Ie,Oe,q,V,J,x,fe){let be=ue(ke,Ie,Oe,q,V,J,fe);if(be&&!x)return be;if(ke.length>=3){const Ne=Math.min(7,ke.length-1);for(let Ge=Oe+1;Ge<Ne;Ge++){const Ze=Ue(ke,Ge);if(Ze){const et=ue(Ze,Ze.toLowerCase(),Oe,q,V,J,fe);et&&(et[0]-=3,(!be||et[0]>be[0])&&(be=et))}}}return be}function Ue(ke,Ie){if(Ie+1>=ke.length)return;const Oe=ke[Ie],q=ke[Ie+1];if(Oe!==q)return ke.slice(0,Ie)+q+Oe+ke.slice(Ie+2)}}),define(ye[60],Se([1,0,13]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$xj=void 0,e.$tj=h,e.$uj=P,e.$vj=O,e.$wj=R,e.$yj=c,r=We(r);function h(d){return P(d,0)}function P(d,g){switch(typeof d){case"object":return d===null?O(349,g):Array.isArray(d)?$(d,g):a(d,g);case"string":return R(d,g);case"boolean":return T(d,g);case"number":return O(d,g);case"undefined":return O(937,g);default:return O(617,g)}}function O(d,g){return(g<<5)-g+d|0}function T(d,g){return O(d?433:863,g)}function R(d,g){g=O(149417,g);for(let n=0,o=d.length;n<o;n++)g=O(d.charCodeAt(n),g);return g}function $(d,g){return g=O(104579,g),d.reduce((n,o)=>P(o,n),g)}function a(d,g){return g=O(181387,g),Object.keys(d).sort().reduce((n,o)=>(n=R(o,n),P(d[o],n)),g)}class I{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=P(g,this.g),this.g}}e.$xj=I;var E;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function l(d,g,n=32){const o=n-g,t=~((1<<o)-1);return(d<<g|(t&d)>>>o)>>>0}function k(d,g=0,n=d.byteLength,o=0){for(let t=0;t<n;t++)d[g+t]=o}function p(d,g,n="0"){for(;d.length<g;)d=n+d;return d}function c(d,g=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(n=>n.toString(16).padStart(2,"0")).join(""):p((d>>>0).toString(16),g/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(E.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const n=g.length;if(n===0)return;const o=this.p;let t=this.r,i=this.u,s,f;for(i!==0?(s=i,f=-1,i=0):(s=g.charCodeAt(0),f=0);;){let u=s;if(r.$Kf(s))if(f+1<n){const w=g.charCodeAt(f+1);r.$Lf(w)?(f++,u=r.$Mf(s,w)):u=E.UNICODE_REPLACEMENT}else{i=s;break}else r.$Lf(s)&&(u=E.UNICODE_REPLACEMENT);if(t=this.w(o,t,u),f++,f<n)s=g.charCodeAt(f);else break}this.r=t,this.u=i}w(g,n,o){return o<128?g[n++]=o:o<2048?(g[n++]=192|(o&1984)>>>6,g[n++]=128|(o&63)>>>0):o<65536?(g[n++]=224|(o&61440)>>>12,g[n++]=128|(o&4032)>>>6,g[n++]=128|(o&63)>>>0):(g[n++]=240|(o&1835008)>>>18,g[n++]=128|(o&258048)>>>12,g[n++]=128|(o&4032)>>>6,g[n++]=128|(o&63)>>>0),n>=E.BLOCK_SIZE&&(this.y(),n-=E.BLOCK_SIZE,this.t+=E.BLOCK_SIZE,g[0]=g[E.BLOCK_SIZE+0],g[1]=g[E.BLOCK_SIZE+1],g[2]=g[E.BLOCK_SIZE+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,E.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=m.g,n=this.q;for(let D=0;D<64;D+=4)g.setUint32(D,n.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)g.setUint32(D,l(g.getUint32(D-12,!1)^g.getUint32(D-32,!1)^g.getUint32(D-56,!1)^g.getUint32(D-64,!1),1),!1);let o=this.h,t=this.l,i=this.m,s=this.n,f=this.o,u,w,y;for(let D=0;D<80;D++)D<20?(u=t&i|~t&s,w=1518500249):D<40?(u=t^i^s,w=1859775393):D<60?(u=t&i|t&s|i&s,w=2400959708):(u=t^i^s,w=3395469782),y=l(o,5)+u+f+w+g.getUint32(D*4,!1)&4294967295,f=s,s=i,i=l(t,30),t=o,o=y;this.h=this.h+o&4294967295,this.l=this.l+t&4294967295,this.m=this.m+i&4294967295,this.n=this.n+s&4294967295,this.o=this.o+f&4294967295}}e.$zj=m}),define(ye[136],Se([1,0,135,13,50]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=$,e.$Xk=I,e.$Yk=l,e.$Zk=k,e.$1k=c,e.$2k=m;const O="$(",T=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${T.source}`,"g");function $(d){return d.replace(R,(g,n)=>n?g:`\\${g}`)}const a=new RegExp(`\\\\${T.source}`,"g");function I(d){return d.replace(a,g=>`\\${g}`)}const E=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function l(d){return d.indexOf(O)===-1?d:d.replace(E,(g,n,o,t)=>o?g:n||t||"")}function k(d){return d?d.replace(/\$\((.*?)\)/g,(g,n)=>` ${n} `).trim():""}const p=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(d){p.lastIndex=0;let g="";const n=[];let o=0;for(;;){const t=p.lastIndex,i=p.exec(d),s=d.substring(t,i?.index);if(s.length>0){g+=s;for(let f=0;f<s.length;f++)n.push(o)}if(!i)break;o+=i[0].length}return{text:g,iconOffsets:n}}function m(d,g,n=!1){const{text:o,iconOffsets:t}=g;if(!t||t.length===0)return(0,r.$Nk)(d,o,n);const i=(0,h.$nf)(o," "),s=o.length-i.length,f=(0,r.$Nk)(d,i,n);if(f)for(const u of f){const w=t[u.start+s]+s;u.start+=w,u.end+=w}return f}}),define(ye[44],Se([1,0,13]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=We(r);var h;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(h||(h={})),function(P){const O="error",T="warning",R="warn",$="info",a="ignore";function I(l){return l?r.$Gf(O,l)?P.Error:r.$Gf(T,l)||r.$Gf(R,l)?P.Warning:r.$Gf($,l)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function E(l){switch(l){case P.Error:return O;case P.Warning:return T;case P.Info:return $;default:return a}}P.toString=E}(h||(h={})),e.default=h}),define(ye[85],Se([1,0,19,27,13]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class O{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const c=p.charCodeAt(0),m=this.b.charCodeAt(this.c);return c-m}value(){return this.b[this.c]}}e.$Hi=O;class T{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===h.CharCode.Period)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,P.$Af)(p,this.b,0,p.length,this.c,this.d):(0,P.$Cf)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=T;class R{constructor(p=!0,c=!0){this.f=p,this.g=c}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let c=p.length-1;c>=0;c--,this.c--){const m=this.b.charCodeAt(c);if(!(m===h.CharCode.Slash||this.f&&m===h.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===h.CharCode.Slash||this.f&&c===h.CharCode.Backslash)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,P.$Af)(p,this.b,0,p.length,this.d,this.e):(0,P.$Cf)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=R;var $;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})($||($={}));class a{constructor(p,c){this.f=p,this.g=c,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new R(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push($.Path)),this.g(p)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===$.Scheme)return(0,P.$Bf)(p,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,P.$Bf)(p,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(p);if(this.d[this.e]===$.Query)return(0,P.$zf)(p,this.c.query);if(this.d[this.e]===$.Fragment)return(0,P.$zf)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Ki=a;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(E||(E={}));class l{static forUris(p=()=>!1,c=()=>!1){return new l(new a(p,c))}static forPaths(p=!1){return new l(new R(void 0,!p))}static forStrings(){return new l(new O)}static forConfigKeys(){return new l(new T)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,c){if(c){const m=c.slice(0);(0,r.$Yb)(m);for(const d of m)this.set(d,p)}else{const m=p.slice(0);(0,r.$Yb)(m);for(const d of m)this.set(d[0],d[1])}}set(p,c){const m=this.b.reset(p);let d;this.c||(this.c=new I,this.c.segment=m.value());const g=[];for(d=this.c;;){const o=m.cmp(d.segment);if(o>0)d.left||(d.left=new I,d.left.segment=m.value()),g.push([E.Left,d]),d=d.left;else if(o<0)d.right||(d.right=new I,d.right.segment=m.value()),g.push([E.Right,d]),d=d.right;else if(m.hasNext())m.next(),d.mid||(d.mid=new I,d.mid.segment=m.value()),g.push([E.Mid,d]),d=d.mid;else break}const n=d.value;d.value=c,d.key=p;for(let o=g.length-1;o>=0;o--){const t=g[o][1];t.updateHeight();const i=t.balanceFactor();if(i<-1||i>1){const s=g[o][0],f=g[o+1][0];if(s===E.Right&&f===E.Right)g[o][1]=t.rotateLeft();else if(s===E.Left&&f===E.Left)g[o][1]=t.rotateRight();else if(s===E.Right&&f===E.Left)t.right=g[o+1][1]=g[o+1][1].rotateRight(),g[o][1]=t.rotateLeft();else if(s===E.Left&&f===E.Right)t.left=g[o+1][1]=g[o+1][1].rotateLeft(),g[o][1]=t.rotateRight();else throw new Error;if(o>0)switch(g[o-1][0]){case E.Left:g[o-1][1].left=g[o][1];break;case E.Right:g[o-1][1].right=g[o][1];break;case E.Mid:g[o-1][1].mid=g[o][1];break}else this.c=g[0][1]}}return n}get(p){return this.d(p)?.value}d(p){const c=this.b.reset(p);let m=this.c;for(;m;){const d=c.cmp(m.segment);if(d>0)m=m.left;else if(d<0)m=m.right;else if(c.hasNext())c.next(),m=m.mid;else break}return m}has(p){const c=this.d(p);return!(c?.value===void 0&&c?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,c){const m=this.b.reset(p),d=[];let g=this.c;for(;g;){const n=m.cmp(g.segment);if(n>0)d.push([E.Left,g]),g=g.left;else if(n<0)d.push([E.Right,g]),g=g.right;else if(m.hasNext())m.next(),d.push([E.Mid,g]),g=g.mid;else break}if(g){if(c?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const n=this.f(g.right);if(n.key){const{key:o,value:t,segment:i}=n;this.e(n.key,!1),g.key=o,g.value=t,g.segment=i}}else{const n=g.left??g.right;if(d.length>0){const[o,t]=d[d.length-1];switch(o){case E.Left:t.left=n;break;case E.Mid:t.mid=n;break;case E.Right:t.right=n;break}}else this.c=n}for(let n=d.length-1;n>=0;n--){const o=d[n][1];o.updateHeight();const t=o.balanceFactor();if(t>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),d[n][1]=o.rotateLeft()):t<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),d[n][1]=o.rotateRight()),n>0)switch(d[n-1][0]){case E.Left:d[n-1][1].left=d[n][1];break;case E.Right:d[n-1][1].right=d[n][1];break;case E.Mid:d[n-1][1].mid=d[n][1];break}else this.c=d[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const c=this.b.reset(p);let m=this.c,d;for(;m;){const g=c.cmp(m.segment);if(g>0)m=m.left;else if(g<0)m=m.right;else if(c.hasNext())c.next(),d=m.value||d,m=m.mid;else break}return m&&m.value||d}findSuperstr(p){return this.g(p,!1)}g(p,c){const m=this.b.reset(p);let d=this.c;for(;d;){const g=m.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(m.hasNext())m.next(),d=d.mid;else return d.mid?this.h(d.mid):c?d.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[c,m]of this)p(m,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const c=[];return this.j(p,c),c[Symbol.iterator]()}j(p,c){p&&(p.left&&this.j(p.left,c),p.value&&c.push([p.key,p.value]),p.mid&&this.j(p.mid,c),p.right&&this.j(p.right,c))}_isBalanced(){const p=c=>{if(!c)return!0;const m=c.balanceFactor();return m<-1||m>1?!1:p(c.left)&&p(c.right)};return p(this.c)}}e.$Li=l}),define(ye[32],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=h;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(P){return r.test(P)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(R){for(let $=0;$<R.length;$++)R[$]=Math.floor(Math.random()*256);return R};const O=new Uint8Array(16),T=[];for(let R=0;R<256;R++)T.push(R.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let $=0,a="";return a+=T[O[$++]],a+=T[O[$++]],a+=T[O[$++]],a+=T[O[$++]],a+="-",a+=T[O[$++]],a+=T[O[$++]],a+="-",a+=T[O[$++]],a+=T[O[$++]],a+="-",a+=T[O[$++]],a+=T[O[$++]],a+="-",a+=T[O[$++]],a+=T[O[$++]],a+=T[O[$++]],a+=T[O[$++]],a+=T[O[$++]],a+=T[O[$++]],a}}()}),define(ye[187],Se([1,0,19,40,32]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pu=e.$nu=void 0,e.$lu=O,e.$mu=T,e.$ou=a;function O(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}function T(E,l,k){const p={id:(0,P.$2g)(),name:E,uri:l,data:k};return{asString:async()=>"",asFile:()=>p,value:void 0}}class R{constructor(){this.a=new Map}get size(){let l=0;for(const k of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const k=[...this.a.keys()];return h.Iterable.some(this,([p,c])=>c.asFile())&&k.push("files"),I($(l),k)}get(l){return this.a.get(this.b(l))?.[0]}append(l,k){const p=this.a.get(l);p?p.push(k):this.a.set(this.b(l),[k])}replace(l,k){this.a.set(this.b(l),[k])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,k]of this.a)for(const p of k)yield[l,p]}b(l){return $(l)}}e.$nu=R;function $(E){return E.toLowerCase()}function a(E,l){return I($(E),l.map($))}function I(E,l){if(E==="*/*")return l.length>0;if(l.includes(E))return!0;const k=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[p,c,m]=k;return m==="*"?l.some(d=>d.startsWith(c+"/")):!1}e.$pu=Object.freeze({create:E=>(0,r.$Ob)(E.map(l=>l.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$pu.split(E).filter(l=>!l.startsWith("#"))})}),define(ye[188],Se([1,0,67]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=h,e.$6g=O,r=We(r);function h(R,$,a,I=1){let E=!1;return new Promise(l=>{const k=setTimeout(()=>{if(!E)return E=!0,l(0)},a);P(R,$,I,p=>{if(!E)return E=!0,clearTimeout(k),l(p)})})}function P(R,$,a,I){if($===0)return I(0);const E=new r.Socket;E.once("connect",()=>(T(E),P(R+a,$-1,a,I))),E.once("data",()=>{}),E.once("error",l=>(T(E),l.code!=="ECONNREFUSED"?P(R+a,$-1,a,I):I(R))),E.connect(R,"127.0.0.1")}e.$5g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(R,$,a,I="127.0.0.1"){let E=!1,l,k=1;const p=r.createServer({pauseOnConnect:!0});function c(m,d){E||(E=!0,p.removeAllListeners(),p.close(),l&&clearTimeout(l),d(m))}return new Promise(m=>{l=setTimeout(()=>{c(0,m)},a),p.on("listening",()=>{c(R,m)}),p.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&k<$?(R++,k++,p.listen(R,I)):c(0,m)}),p.on("close",()=>{c(0,m)}),p.listen(R,I)})}function T(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch($){console.error($)}}}),define(ye[137],Se([1,0,84]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eu=e.$du=void 0;class h{constructor(R){const $=(0,r.$bf)(R);this.c=$,this.a=h.d($),this.b=new Map}static d(R){const $=new Uint8Array(256);return $.fill(R),$}set(R,$){const a=(0,r.$bf)($);R>=0&&R<256?this.a[R]=a:this.b.set(R,a)}get(R){return R>=0&&R<256?this.a[R]:this.b.get(R)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$du=h;var P;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(P||(P={}));class O{constructor(){this.a=new h(P.False)}add(R){this.a.set(R,P.True)}has(R){return this.a.get(R)===P.True}clear(){return this.a.clear()}}e.$eu=O}),define(ye[189],Se([1,0,27]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$vu=P;var h;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function P(O){let T=0,R=0,$=0,a=h.Unknown;for(let I=0,E=O.length;I<E;I++){const l=O.charCodeAt(I);l===r.CharCode.CarriageReturn?(T===0&&(R=I),T++,I+1<E&&O.charCodeAt(I+1)===r.CharCode.LineFeed?(a|=h.CRLF,I++):a|=h.Invalid,$=I+1):l===r.CharCode.LineFeed&&(a|=h.LF,T===0&&(R=I),T++,$=I+1)}return T===0&&(R=O.length),[T,R,O.length-$,a]}}),define(ye[54],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=void 0;class r{constructor(P,O){this.lineNumber=P,this.column=O}with(P=this.lineNumber,O=this.column){return P===this.lineNumber&&O===this.column?this:new r(P,O)}delta(P=0,O=0){return this.with(this.lineNumber+P,this.column+O)}equals(P){return r.equals(this,P)}static equals(P,O){return!P&&!O?!0:!!P&&!!O&&P.lineNumber===O.lineNumber&&P.column===O.column}isBefore(P){return r.isBefore(this,P)}static isBefore(P,O){return P.lineNumber<O.lineNumber?!0:O.lineNumber<P.lineNumber?!1:P.column<O.column}isBeforeOrEqual(P){return r.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,O){return P.lineNumber<O.lineNumber?!0:O.lineNumber<P.lineNumber?!1:P.column<=O.column}static compare(P,O){const T=P.lineNumber|0,R=O.lineNumber|0;if(T===R){const $=P.column|0,a=O.column|0;return $-a}return T-R}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new r(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Kt=r}),define(ye[31],Se([1,0,54]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=void 0;class h{constructor(O,T,R,$){O>R||O===R&&T>$?(this.startLineNumber=R,this.startColumn=$,this.endLineNumber=O,this.endColumn=T):(this.startLineNumber=O,this.startColumn=T,this.endLineNumber=R,this.endColumn=$)}isEmpty(){return h.isEmpty(this)}static isEmpty(O){return O.startLineNumber===O.endLineNumber&&O.startColumn===O.endColumn}containsPosition(O){return h.containsPosition(this,O)}static containsPosition(O,T){return!(T.lineNumber<O.startLineNumber||T.lineNumber>O.endLineNumber||T.lineNumber===O.startLineNumber&&T.column<O.startColumn||T.lineNumber===O.endLineNumber&&T.column>O.endColumn)}static strictContainsPosition(O,T){return!(T.lineNumber<O.startLineNumber||T.lineNumber>O.endLineNumber||T.lineNumber===O.startLineNumber&&T.column<=O.startColumn||T.lineNumber===O.endLineNumber&&T.column>=O.endColumn)}containsRange(O){return h.containsRange(this,O)}static containsRange(O,T){return!(T.startLineNumber<O.startLineNumber||T.endLineNumber<O.startLineNumber||T.startLineNumber>O.endLineNumber||T.endLineNumber>O.endLineNumber||T.startLineNumber===O.startLineNumber&&T.startColumn<O.startColumn||T.endLineNumber===O.endLineNumber&&T.endColumn>O.endColumn)}strictContainsRange(O){return h.strictContainsRange(this,O)}static strictContainsRange(O,T){return!(T.startLineNumber<O.startLineNumber||T.endLineNumber<O.startLineNumber||T.startLineNumber>O.endLineNumber||T.endLineNumber>O.endLineNumber||T.startLineNumber===O.startLineNumber&&T.startColumn<=O.startColumn||T.endLineNumber===O.endLineNumber&&T.endColumn>=O.endColumn)}plusRange(O){return h.plusRange(this,O)}static plusRange(O,T){let R,$,a,I;return T.startLineNumber<O.startLineNumber?(R=T.startLineNumber,$=T.startColumn):T.startLineNumber===O.startLineNumber?(R=T.startLineNumber,$=Math.min(T.startColumn,O.startColumn)):(R=O.startLineNumber,$=O.startColumn),T.endLineNumber>O.endLineNumber?(a=T.endLineNumber,I=T.endColumn):T.endLineNumber===O.endLineNumber?(a=T.endLineNumber,I=Math.max(T.endColumn,O.endColumn)):(a=O.endLineNumber,I=O.endColumn),new h(R,$,a,I)}intersectRanges(O){return h.intersectRanges(this,O)}static intersectRanges(O,T){let R=O.startLineNumber,$=O.startColumn,a=O.endLineNumber,I=O.endColumn;const E=T.startLineNumber,l=T.startColumn,k=T.endLineNumber,p=T.endColumn;return R<E?(R=E,$=l):R===E&&($=Math.max($,l)),a>k?(a=k,I=p):a===k&&(I=Math.min(I,p)),R>a||R===a&&$>I?null:new h(R,$,a,I)}equalsRange(O){return h.equalsRange(this,O)}static equalsRange(O,T){return!O&&!T?!0:!!O&&!!T&&O.startLineNumber===T.startLineNumber&&O.startColumn===T.startColumn&&O.endLineNumber===T.endLineNumber&&O.endColumn===T.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(O){return new r.$Kt(O.endLineNumber,O.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(O){return new r.$Kt(O.startLineNumber,O.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(O,T){return new h(this.startLineNumber,this.startColumn,O,T)}setStartPosition(O,T){return new h(O,T,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(O){return new h(O.startLineNumber,O.startColumn,O.startLineNumber,O.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(O){return new h(O.endLineNumber,O.endColumn,O.endLineNumber,O.endColumn)}delta(O){return new h(this.startLineNumber+O,this.startColumn,this.endLineNumber+O,this.endColumn)}static fromPositions(O,T=O){return new h(O.lineNumber,O.column,T.lineNumber,T.column)}static lift(O){return O?new h(O.startLineNumber,O.startColumn,O.endLineNumber,O.endColumn):null}static isIRange(O){return O&&typeof O.startLineNumber=="number"&&typeof O.startColumn=="number"&&typeof O.endLineNumber=="number"&&typeof O.endColumn=="number"}static areIntersectingOrTouching(O,T){return!(O.endLineNumber<T.startLineNumber||O.endLineNumber===T.startLineNumber&&O.endColumn<T.startColumn||T.endLineNumber<O.startLineNumber||T.endLineNumber===O.startLineNumber&&T.endColumn<O.startColumn)}static areIntersecting(O,T){return!(O.endLineNumber<T.startLineNumber||O.endLineNumber===T.startLineNumber&&O.endColumn<=T.startColumn||T.endLineNumber<O.startLineNumber||T.endLineNumber===O.startLineNumber&&T.endColumn<=O.startColumn)}static compareRangesUsingStarts(O,T){if(O&&T){const a=O.startLineNumber|0,I=T.startLineNumber|0;if(a===I){const E=O.startColumn|0,l=T.startColumn|0;if(E===l){const k=O.endLineNumber|0,p=T.endLineNumber|0;if(k===p){const c=O.endColumn|0,m=T.endColumn|0;return c-m}return k-p}return E-l}return a-I}return(O?1:0)-(T?1:0)}static compareRangesUsingEnds(O,T){return O.endLineNumber===T.endLineNumber?O.endColumn===T.endColumn?O.startLineNumber===T.startLineNumber?O.startColumn-T.startColumn:O.startLineNumber-T.startLineNumber:O.endColumn-T.endColumn:O.endLineNumber-T.endLineNumber}static spansMultipleLines(O){return O.endLineNumber>O.startLineNumber}toJSON(){return this}}e.$Lt=h}),define(ye[190],Se([1,0,31]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=void 0;class h{static insert(O,T){return{range:new r.$Lt(O.lineNumber,O.column,O.lineNumber,O.column),text:T,forceMoveMarkers:!0}}static delete(O){return{range:O,text:null}}static replace(O,T){return{range:O,text:T}}static replaceMove(O,T){return{range:O,text:T,forceMoveMarkers:!0}}}e.$Mt=h}),define(ye[191],Se([1,0,54,31]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=e.SelectionDirection=void 0;var P;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(P||(e.SelectionDirection=P={}));class O extends h.$Lt{constructor(R,$,a,I){super(R,$,a,I),this.selectionStartLineNumber=R,this.selectionStartColumn=$,this.positionLineNumber=a,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(R){return O.selectionsEqual(this,R)}static selectionsEqual(R,$){return R.selectionStartLineNumber===$.selectionStartLineNumber&&R.selectionStartColumn===$.selectionStartColumn&&R.positionLineNumber===$.positionLineNumber&&R.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?P.LTR:P.RTL}setEndPosition(R,$){return this.getDirection()===P.LTR?new O(this.startLineNumber,this.startColumn,R,$):new O(R,$,this.startLineNumber,this.startColumn)}getPosition(){return new r.$Kt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$Kt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(R,$){return this.getDirection()===P.LTR?new O(R,$,this.endLineNumber,this.endColumn):new O(this.endLineNumber,this.endColumn,R,$)}static fromPositions(R,$=R){return new O(R.lineNumber,R.column,$.lineNumber,$.column)}static fromRange(R,$){return $===P.LTR?new O(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):new O(R.endLineNumber,R.endColumn,R.startLineNumber,R.startColumn)}static liftSelection(R){return new O(R.selectionStartLineNumber,R.selectionStartColumn,R.positionLineNumber,R.positionColumn)}static selectionsArrEqual(R,$){if(R&&!$||!R&&$)return!1;if(!R&&!$)return!0;if(R.length!==$.length)return!1;for(let a=0,I=R.length;a<I;a++)if(!this.selectionsEqual(R[a],$[a]))return!1;return!0}static isISelection(R){return R&&typeof R.selectionStartLineNumber=="number"&&typeof R.selectionStartColumn=="number"&&typeof R.positionLineNumber=="number"&&typeof R.positionColumn=="number"}static createWithDirection(R,$,a,I,E){return E===P.LTR?new O(R,$,a,I):new O(a,I,R,$)}}e.$Nt=O}),define(ye[192],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=void 0,e.$it={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[193],Se([1,0,27,29,137]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fu=e.WordCharacterClass=void 0,e.$gu=$;var O;(function(a){a[a.Regular=0]="Regular",a[a.Whitespace=1]="Whitespace",a[a.WordSeparator=2]="WordSeparator"})(O||(e.WordCharacterClass=O={}));class T extends P.$du{constructor(I,E){super(O.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=E,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let l=0,k=I.length;l<k;l++)this.set(I.charCodeAt(l),O.WordSeparator);this.set(r.CharCode.Space,O.Whitespace),this.set(r.CharCode.Tab,O.Whitespace)}findPrevIntlWordBeforeOrAtOffset(I,E){let l=null;for(const k of this.h(I)){if(k.index>E)break;l=k}return l}findNextIntlWordAtOrAfterOffset(I,E){for(const l of this.h(I))if(!(l.index<E))return l;return null}h(I){return this.e?this.f===I?this.g:(this.f=I,this.g=this.j(this.e.segment(I)),this.g):[]}j(I){const E=[];for(const l of I)this.k(l)&&E.push(l);return E}k(I){return!!I.isWordLike}}e.$fu=T;const R=new h.$Fc(10);function $(a,I){const E=`${a}/${I.join(",")}`;let l=R.get(E);return l||(l=new T(a,I),R.set(E,l)),l}}),define(ye[138],Se([1,0,40,3,81]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=e.$jt=void 0,e.$lt=T,e.$mt=$,e.$nt=a,e.$jt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function O(E=""){let l="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.$jt)E.indexOf(k)>=0||(l+="\\"+k);return l+="\\s]+)",new RegExp(l,"g")}e.$kt=O();function T(E){let l=e.$kt;if(E&&E instanceof RegExp)if(E.global)l=E;else{let k="g";E.ignoreCase&&(k+="i"),E.multiline&&(k+="m"),E.unicode&&(k+="u"),l=new RegExp(E.source,k)}return l.lastIndex=0,l}const R=new P.$7c;R.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(E){const l=R.unshift(E);return(0,h.$Uc)(l)}function a(E,l,k,p,c){if(l=T(l),c||(c=r.Iterable.first(R)),k.length>c.maxLen){let o=E-c.maxLen/2;return o<0?o=0:p+=o,k=k.substring(o,E+c.maxLen/2),a(E,l,k,p,c)}const m=Date.now(),d=E-1-p;let g=-1,n=null;for(let o=1;!(Date.now()-m>=c.timeBudget);o++){const t=d-c.windowSize*o;l.lastIndex=Math.max(0,t);const i=I(l,k,d,g);if(!i&&n||(n=i,t<=0))break;g=t}if(n){const o={word:n[0],startColumn:p+1+n.index,endColumn:p+1+n.index+n[0].length};return l.lastIndex=0,o}return null}function I(E,l,k,p){let c;for(;c=E.exec(l);){const m=c.index||0;if(m<=k&&E.lastIndex>=k)return c;if(p>0&&m>p)return null}return null}}),define(ye[106],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ru=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function($){$[$.Null=0]="Null",$[$.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var h;(function($){$[$.NotSet=-1]="NotSet",$[$.None=0]="None",$[$.Italic=1]="Italic",$[$.Bold=2]="Bold",$[$.Underline=4]="Underline",$[$.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var P;(function($){$[$.None=0]="None",$[$.DefaultForeground=1]="DefaultForeground",$[$.DefaultBackground=2]="DefaultBackground"})(P||(e.ColorId=P={}));var O;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(O||(e.StandardTokenType=O={}));var T;(function($){$[$.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",$[$.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",$[$.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",$[$.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",$[$.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",$[$.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",$[$.ITALIC_MASK=2048]="ITALIC_MASK",$[$.BOLD_MASK=4096]="BOLD_MASK",$[$.UNDERLINE_MASK=8192]="UNDERLINE_MASK",$[$.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",$[$.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",$[$.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",$[$.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",$[$.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",$[$.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",$[$.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",$[$.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",$[$.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",$[$.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",$[$.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",$[$.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",$[$.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(T||(e.MetadataConsts=T={}));class R{static getLanguageId(a){return(a&T.LANGUAGEID_MASK)>>>T.LANGUAGEID_OFFSET}static getTokenType(a){return(a&T.TOKEN_TYPE_MASK)>>>T.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(a){return(a&T.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(a){return(a&T.FONT_STYLE_MASK)>>>T.FONT_STYLE_OFFSET}static getForeground(a){return(a&T.FOREGROUND_MASK)>>>T.FOREGROUND_OFFSET}static getBackground(a){return(a&T.BACKGROUND_MASK)>>>T.BACKGROUND_OFFSET}static getClassNameFromMetadata(a){let E="mtk"+this.getForeground(a);const l=this.getFontStyle(a);return l&h.Italic&&(E+=" mtki"),l&h.Bold&&(E+=" mtkb"),l&h.Underline&&(E+=" mtku"),l&h.Strikethrough&&(E+=" mtks"),E}static getInlineStyleFromMetadata(a,I){const E=this.getForeground(a),l=this.getFontStyle(a);let k=`color: ${I[E]};`;l&h.Italic&&(k+="font-style: italic;"),l&h.Bold&&(k+="font-weight: bold;");let p="";return l&h.Underline&&(p+=" underline"),l&h.Strikethrough&&(p+=" line-through"),p&&(k+=`text-decoration:${p};`),k}static getPresentationFromMetadata(a){const I=this.getForeground(a),E=this.getFontStyle(a);return{foreground:I,italic:!!(E&h.Italic),bold:!!(E&h.Bold),underline:!!(E&h.Underline),strikethrough:!!(E&h.Strikethrough)}}}e.$ru=R}),define(ye[194],Se([1,0,27,106]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tu=e.$Su=e.IndentAction=void 0;var P;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class O{constructor(a){if(this.e=null,this.f=!1,this.open=a.open,this.close=a.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(a.notIn))for(let I=0,E=a.notIn.length;I<E;I++)switch(a.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(a){switch(a){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this.c;case h.StandardTokenType.String:return this.b;case h.StandardTokenType.RegEx:return this.d}}shouldAutoClose(a,I){if(a.getTokenCount()===0)return!0;const E=a.findTokenIndexAtOffset(I-2),l=a.getStandardTokenType(E);return this.isOK(l)}g(a,I){for(let E=a;E<=I;E++){const l=String.fromCharCode(E);if(!this.open.includes(l)&&!this.close.includes(l))return l}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(r.CharCode.Digit0,r.CharCode.Digit9)),this.e||(this.e=this.g(r.CharCode.a,r.CharCode.z)),this.e||(this.e=this.g(r.CharCode.A,r.CharCode.Z))),this.e}}e.$Su=O;class T{constructor(a){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of a)R(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),R(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),R(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),R(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&R(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$Tu=T;function R($,a,I){$.has(a)?$.get(a).push(I):$.set(a,[I])}}),define(ye[195],Se([1,0,27,137]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q4=e.$p4=e.State=void 0,e.$r4=k;var P;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(P||(e.State=P={}));class O{constructor(c,m,d){const g=new Uint8Array(c*m);for(let n=0,o=c*m;n<o;n++)g[n]=d;this.a=g,this.rows=c,this.cols=m}get(c,m){return this.a[c*this.cols+m]}set(c,m,d){this.a[c*this.cols+m]=d}}class T{constructor(c){let m=0,d=P.Invalid;for(let n=0,o=c.length;n<o;n++){const[t,i,s]=c[n];i>m&&(m=i),t>d&&(d=t),s>d&&(d=s)}m++,d++;const g=new O(d,m,P.Invalid);for(let n=0,o=c.length;n<o;n++){const[t,i,s]=c[n];g.set(t,i,s)}this.a=g,this.b=m}nextState(c,m){return m<0||m>=this.b?P.Invalid:this.a.get(c,m)}}e.$p4=T;let R=null;function $(){return R===null&&(R=new T([[P.Start,r.CharCode.h,P.H],[P.Start,r.CharCode.H,P.H],[P.Start,r.CharCode.f,P.F],[P.Start,r.CharCode.F,P.F],[P.H,r.CharCode.t,P.HT],[P.H,r.CharCode.T,P.HT],[P.HT,r.CharCode.t,P.HTT],[P.HT,r.CharCode.T,P.HTT],[P.HTT,r.CharCode.p,P.HTTP],[P.HTT,r.CharCode.P,P.HTTP],[P.HTTP,r.CharCode.s,P.BeforeColon],[P.HTTP,r.CharCode.S,P.BeforeColon],[P.HTTP,r.CharCode.Colon,P.AfterColon],[P.F,r.CharCode.i,P.FI],[P.F,r.CharCode.I,P.FI],[P.FI,r.CharCode.l,P.FIL],[P.FI,r.CharCode.L,P.FIL],[P.FIL,r.CharCode.e,P.BeforeColon],[P.FIL,r.CharCode.E,P.BeforeColon],[P.BeforeColon,r.CharCode.Colon,P.AfterColon],[P.AfterColon,r.CharCode.Slash,P.AlmostThere],[P.AlmostThere,r.CharCode.Slash,P.End]])),R}var a;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let I=null;function E(){if(I===null){I=new h.$du(a.None);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<p.length;m++)I.set(p.charCodeAt(m),a.ForceTermination);const c=".,;:";for(let m=0;m<c.length;m++)I.set(c.charCodeAt(m),a.CannotEndIn)}return I}class l{static a(c,m,d,g,n){let o=n-1;do{const t=m.charCodeAt(o);if(c.get(t)!==a.CannotEndIn)break;o--}while(o>g);if(g>0){const t=m.charCodeAt(g-1),i=m.charCodeAt(o);(t===r.CharCode.OpenParen&&i===r.CharCode.CloseParen||t===r.CharCode.OpenSquareBracket&&i===r.CharCode.CloseSquareBracket||t===r.CharCode.OpenCurlyBrace&&i===r.CharCode.CloseCurlyBrace)&&o--}return{range:{startLineNumber:d,startColumn:g+1,endLineNumber:d,endColumn:o+2},url:m.substring(g,o+1)}}static computeLinks(c,m=$()){const d=E(),g=[];for(let n=1,o=c.getLineCount();n<=o;n++){const t=c.getLineContent(n),i=t.length;let s=0,f=0,u=0,w=P.Start,y=!1,D=!1,S=!1,C=!1;for(;s<i;){let A=!1;const b=t.charCodeAt(s);if(w===P.Accept){let v;switch(b){case r.CharCode.OpenParen:y=!0,v=a.None;break;case r.CharCode.CloseParen:v=y?a.None:a.ForceTermination;break;case r.CharCode.OpenSquareBracket:S=!0,D=!0,v=a.None;break;case r.CharCode.CloseSquareBracket:S=!1,v=D?a.None:a.ForceTermination;break;case r.CharCode.OpenCurlyBrace:C=!0,v=a.None;break;case r.CharCode.CloseCurlyBrace:v=C?a.None:a.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:u===b?v=a.ForceTermination:u===r.CharCode.SingleQuote||u===r.CharCode.DoubleQuote||u===r.CharCode.BackTick?v=a.None:v=a.ForceTermination;break;case r.CharCode.Asterisk:v=u===r.CharCode.Asterisk?a.ForceTermination:a.None;break;case r.CharCode.Pipe:v=u===r.CharCode.Pipe?a.ForceTermination:a.None;break;case r.CharCode.Space:v=S?a.None:a.ForceTermination;break;default:v=d.get(b)}v===a.ForceTermination&&(g.push(l.a(d,t,n,f,s)),A=!0)}else if(w===P.End){let v;b===r.CharCode.OpenSquareBracket?(D=!0,v=a.None):v=d.get(b),v===a.ForceTermination?A=!0:w=P.Accept}else w=m.nextState(w,b),w===P.Invalid&&(A=!0);A&&(w=P.Start,y=!1,D=!1,C=!1,f=s+1,u=b),s++}w===P.Accept&&g.push(l.a(d,t,n,f,i))}return g}}e.$q4=l;function k(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:l.computeLinks(p)}}),define(ye[55],Se([1,0,25]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$dw=e.$cw=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$aw=e.$_v=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$bw=p,e.$fw=o;var h;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var P;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(P||(e.GlyphMarginLane=P={}));var O;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(O||(e.MinimapPosition=O={}));var T;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(T||(e.MinimapSectionHeaderStyle=T={}));var R;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var $;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var a;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(a||(e.DefaultEndOfLine=a={}));var I;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class E{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(i){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,i.tabSize|0),i.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,i.indentSize|0),this.a=!1),this.insertSpaces=!!i.insertSpaces,this.defaultEOL=i.defaultEOL|0,this.trimAutoWhitespace=!!i.trimAutoWhitespace,this.bracketPairColorizationOptions=i.bracketPairColorizationOptions}equals(i){return this.tabSize===i.tabSize&&this.a===i.a&&this.indentSize===i.indentSize&&this.insertSpaces===i.insertSpaces&&this.defaultEOL===i.defaultEOL&&this.trimAutoWhitespace===i.trimAutoWhitespace&&(0,r.$ho)(this.bracketPairColorizationOptions,i.bracketPairColorizationOptions)}createChangeEvent(i){return{tabSize:this.tabSize!==i.tabSize,indentSize:this.indentSize!==i.indentSize,insertSpaces:this.insertSpaces!==i.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==i.trimAutoWhitespace}}}e.$_v=E;class l{constructor(i,s){this._findMatchBrand=void 0,this.range=i,this.matches=s}}e.$aw=l;var k;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k||(e.TrackedRangeStickiness=k={}));function p(t){return t&&typeof t.read=="function"}var c;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(c||(e.PositionAffinity=c={}));var m;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class d{constructor(i,s,f,u,w,y){this.identifier=i,this.range=s,this.text=f,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=w,this._isTracked=y}}e.$cw=d;class g{constructor(i,s,f){this.regex=i,this.wordSeparators=s,this.simpleSearch=f}}e.$dw=g;class n{constructor(i,s,f){this.reverseEdits=i,this.changes=s,this.trimAutoWhitespaceLineNumbers=f}}e.$ew=n;function o(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(ye[196],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=e.NodeColor=e.$3C=void 0,e.$5C=P,e.$6C=O,e.$7C=a,e.$8C=I,e.$9C=E,e.$0C=l,e.$$C=k,e.$_C=p;class r{constructor(m,d){this.piece=m,this.color=d,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$4C)return P(this.right);let m=this;for(;m.parent!==e.$4C&&m.parent.left!==m;)m=m.parent;return m.parent===e.$4C?e.$4C:m.parent}prev(){if(this.left!==e.$4C)return O(this.left);let m=this;for(;m.parent!==e.$4C&&m.parent.right!==m;)m=m.parent;return m.parent===e.$4C?e.$4C:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$3C=r;var h;(function(c){c[c.Black=0]="Black",c[c.Red=1]="Red"})(h||(e.NodeColor=h={})),e.$4C=new r(null,h.Black),e.$4C.parent=e.$4C,e.$4C.left=e.$4C,e.$4C.right=e.$4C,e.$4C.color=h.Black;function P(c){for(;c.left!==e.$4C;)c=c.left;return c}function O(c){for(;c.right!==e.$4C;)c=c.right;return c}function T(c){return c===e.$4C?0:c.size_left+c.piece.length+T(c.right)}function R(c){return c===e.$4C?0:c.lf_left+c.piece.lineFeedCnt+R(c.right)}function $(){e.$4C.parent=e.$4C}function a(c,m){const d=m.right;d.size_left+=m.size_left+(m.piece?m.piece.length:0),d.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=d.left,d.left!==e.$4C&&(d.left.parent=m),d.parent=m.parent,m.parent===e.$4C?c.root=d:m.parent.left===m?m.parent.left=d:m.parent.right=d,d.left=m,m.parent=d}function I(c,m){const d=m.left;m.left=d.right,d.right!==e.$4C&&(d.right.parent=m),d.parent=m.parent,m.size_left-=d.size_left+(d.piece?d.piece.length:0),m.lf_left-=d.lf_left+(d.piece?d.piece.lineFeedCnt:0),m.parent===e.$4C?c.root=d:m===m.parent.right?m.parent.right=d:m.parent.left=d,d.right=m,m.parent=d}function E(c,m){let d,g;if(m.left===e.$4C?(g=m,d=g.right):m.right===e.$4C?(g=m,d=g.left):(g=P(m.right),d=g.right),g===c.root){c.root=d,d.color=h.Black,m.detach(),$(),c.root.parent=e.$4C;return}const n=g.color===h.Red;if(g===g.parent.left?g.parent.left=d:g.parent.right=d,g===m?(d.parent=g.parent,p(c,d)):(g.parent===m?d.parent=g:d.parent=g.parent,p(c,d),g.left=m.left,g.right=m.right,g.parent=m.parent,g.color=m.color,m===c.root?c.root=g:m===m.parent.left?m.parent.left=g:m.parent.right=g,g.left!==e.$4C&&(g.left.parent=g),g.right!==e.$4C&&(g.right.parent=g),g.size_left=m.size_left,g.lf_left=m.lf_left,p(c,g)),m.detach(),d.parent.left===d){const t=T(d),i=R(d);if(t!==d.parent.size_left||i!==d.parent.lf_left){const s=t-d.parent.size_left,f=i-d.parent.lf_left;d.parent.size_left=t,d.parent.lf_left=i,k(c,d.parent,s,f)}}if(p(c,d.parent),n){$();return}let o;for(;d!==c.root&&d.color===h.Black;)d===d.parent.left?(o=d.parent.right,o.color===h.Red&&(o.color=h.Black,d.parent.color=h.Red,a(c,d.parent),o=d.parent.right),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,d=d.parent):(o.right.color===h.Black&&(o.left.color=h.Black,o.color=h.Red,I(c,o),o=d.parent.right),o.color=d.parent.color,d.parent.color=h.Black,o.right.color=h.Black,a(c,d.parent),d=c.root)):(o=d.parent.left,o.color===h.Red&&(o.color=h.Black,d.parent.color=h.Red,I(c,d.parent),o=d.parent.left),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,d=d.parent):(o.left.color===h.Black&&(o.right.color=h.Black,o.color=h.Red,a(c,o),o=d.parent.left),o.color=d.parent.color,d.parent.color=h.Black,o.left.color=h.Black,I(c,d.parent),d=c.root));d.color=h.Black,$()}function l(c,m){for(p(c,m);m!==c.root&&m.parent.color===h.Red;)if(m.parent===m.parent.parent.left){const d=m.parent.parent.right;d.color===h.Red?(m.parent.color=h.Black,d.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,a(c,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,I(c,m.parent.parent))}else{const d=m.parent.parent.left;d.color===h.Red?(m.parent.color=h.Black,d.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,I(c,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,a(c,m.parent.parent))}c.root.color=h.Black}function k(c,m,d,g){for(;m!==c.root&&m!==e.$4C;)m.parent.left===m&&(m.parent.size_left+=d,m.parent.lf_left+=g),m=m.parent}function p(c,m){let d=0,g=0;if(m!==c.root){for(;m!==c.root&&m===m.parent.right;)m=m.parent;if(m!==c.root)for(m=m.parent,d=T(m.left)-m.size_left,g=R(m.left)-m.lf_left,m.size_left+=d,m.lf_left+=g;m!==c.root&&(d!==0||g!==0);)m.parent.left===m&&(m.parent.size_left+=d,m.parent.lf_left+=g),m=m.parent}}}),define(ye[197],Se([1,0,19,84]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kw=e.$jw=e.$iw=void 0;class P{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,a){$=(0,h.$cf)($);const I=this.a,E=this.b,l=a.length;return l===0?!1:(this.a=new Uint32Array(I.length+l),this.a.set(I.subarray(0,$),0),this.a.set(I.subarray($),$+l),this.a.set(a,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue($,a){return $=(0,h.$cf)($),a=(0,h.$cf)(a),this.a[$]===a?!1:(this.a[$]=a,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,a){$=(0,h.$cf)($),a=(0,h.$cf)(a);const I=this.a,E=this.b;if($>=I.length)return!1;const l=I.length-$;return a>=l&&(a=l),a===0?!1:(this.a=new Uint32Array(I.length-a),this.a.set(I.subarray(0,$),0),this.a.set(I.subarray($+a),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,h.$cf)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let a=this.c[0]+1;a===0&&(this.b[0]=this.a[0],a++),$>=this.a.length&&($=this.a.length-1);for(let I=a;I<=$;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let a=0,I=this.a.length-1,E=0,l=0,k=0;for(;a<=I;)if(E=a+(I-a)/2|0,l=this.b[E],k=l-this.a[E],$<k)I=E-1;else if($>=l)a=E+1;else break;return new T(E,$-k)}}e.$iw=P;class O{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const a=this.e[$],I=a>0?this.d[a-1]:0;return new T(a,$-I)}removeValues($,a){this.a.splice($,a),this.f($)}insertValues($,a){this.a=(0,r.$Xb)(this.a,$,a),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,a=this.a.length;$<a;$++){const I=this.a[$],E=$>0?this.d[$-1]:0;this.d[$]=E+I;for(let l=0;l<I;l++)this.e[E+l]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,a){this.a[$]!==a&&(this.a[$]=a,this.f($))}}e.$jw=O;class T{constructor($,a){this.index=$,this.remainder=a,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=a}}e.$kw=T}),define(ye[198],Se([1,0,13,54,197]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lw=void 0;class O{constructor(R,$,a,I){this.d=R,this.f=$,this.g=a,this.h=I,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(R){R.eol&&R.eol!==this.g&&(this.g=R.eol,this.j=null);const $=R.changes;for(const a of $)this.o(a.range),this.p(new h.$Kt(a.range.startLineNumber,a.range.startColumn),a.text);this.h=R.versionId,this.k=null}l(){if(!this.j){const R=this.g.length,$=this.f.length,a=new Uint32Array($);for(let I=0;I<$;I++)a[I]=this.f[I].length+R;this.j=new P.$iw(a)}}n(R,$){this.f[R]=$,this.j&&this.j.setValue(R,this.f[R].length+this.g.length)}o(R){if(R.startLineNumber===R.endLineNumber){if(R.startColumn===R.endColumn)return;this.n(R.startLineNumber-1,this.f[R.startLineNumber-1].substring(0,R.startColumn-1)+this.f[R.startLineNumber-1].substring(R.endColumn-1));return}this.n(R.startLineNumber-1,this.f[R.startLineNumber-1].substring(0,R.startColumn-1)+this.f[R.endLineNumber-1].substring(R.endColumn-1)),this.f.splice(R.startLineNumber,R.endLineNumber-R.startLineNumber),this.j&&this.j.removeValues(R.startLineNumber,R.endLineNumber-R.startLineNumber)}p(R,$){if($.length===0)return;const a=(0,r.$tf)($);if(a.length===1){this.n(R.lineNumber-1,this.f[R.lineNumber-1].substring(0,R.column-1)+a[0]+this.f[R.lineNumber-1].substring(R.column-1));return}a[a.length-1]+=this.f[R.lineNumber-1].substring(R.column-1),this.n(R.lineNumber-1,this.f[R.lineNumber-1].substring(0,R.column-1)+a[0]);const I=new Uint32Array(a.length-1);for(let E=1;E<a.length;E++)this.f.splice(R.lineNumber+E-1,0,a[E]),I[E-1]=a[E].length+this.g.length;this.j&&this.j.insertValues(R.lineNumber,I)}}e.$lw=O}),define(ye[107],Se([1,0,27,13,193,54,31,55]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fD=e.$dD=e.$aD=void 0,e.$bD=I,e.$cD=E,e.$eD=m,h=We(h);const $=999;class a{constructor(n,o,t,i){this.searchString=n,this.isRegex=o,this.matchCase=t,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=I(this.searchString):n=this.searchString.indexOf(`
`)>=0;let o=null;try{o=h.$rf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!o)return null;let t=!this.isRegex&&!n;return t&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(t=this.matchCase),new R.$dw(o,this.wordSeparators?(0,P.$gu)(this.wordSeparators,[]):null,t?this.searchString:null)}}e.$aD=a;function I(g){if(!g||g.length===0)return!1;for(let n=0,o=g.length;n<o;n++){const t=g.charCodeAt(n);if(t===r.CharCode.LineFeed)return!0;if(t===r.CharCode.Backslash){if(n++,n>=o)break;const i=g.charCodeAt(n);if(i===r.CharCode.n||i===r.CharCode.r||i===r.CharCode.W)return!0}}return!1}function E(g,n,o){if(!o)return new R.$aw(g,null);const t=[];for(let i=0,s=n.length;i<s;i++)t[i]=n[i];return new R.$aw(g,t)}class l{constructor(n){const o=[];let t=0;for(let i=0,s=n.length;i<s;i++)n.charCodeAt(i)===r.CharCode.LineFeed&&(o[t++]=i);this.a=o}findLineFeedCountBeforeOffset(n){const o=this.a;let t=0,i=o.length-1;if(i===-1||n<=o[0])return 0;for(;t<i;){const s=t+((i-t)/2>>0);o[s]>=n?i=s-1:o[s+1]>=n?(t=s,i=s):t=s+1}return t+1}}class k{static findMatches(n,o,t,i,s){const f=o.parseSearchRequest();return f?f.regex.multiline?this.b(n,t,new d(f.wordSeparators,f.regex),i,s):this.c(n,t,f,i,s):[]}static a(n,o,t,i,s,f){let u,w=0;i?(w=i.findLineFeedCountBeforeOffset(s),u=o+s+w):u=o+s;let y;if(i){const A=i.findLineFeedCountBeforeOffset(s+f.length)-w;y=u+f.length+A}else y=u+f.length;const D=n.getPositionAt(u),S=n.getPositionAt(y);return new T.$Lt(D.lineNumber,D.column,S.lineNumber,S.column)}static b(n,o,t,i,s){const f=n.getOffsetAt(o.getStartPosition()),u=n.getValueInRange(o,R.EndOfLinePreference.LF),w=n.getEOL()===`\r
`?new l(u):null,y=[];let D=0,S;for(t.reset(0);S=t.next(u);)if(y[D++]=E(this.a(n,f,u,w,S.index,S[0]),S,i),D>=s)return y;return y}static c(n,o,t,i,s){const f=[];let u=0;if(o.startLineNumber===o.endLineNumber){const y=n.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return u=this.d(t,y,o.startLineNumber,o.startColumn-1,u,f,i,s),f}const w=n.getLineContent(o.startLineNumber).substring(o.startColumn-1);u=this.d(t,w,o.startLineNumber,o.startColumn-1,u,f,i,s);for(let y=o.startLineNumber+1;y<o.endLineNumber&&u<s;y++)u=this.d(t,n.getLineContent(y),y,0,u,f,i,s);if(u<s){const y=n.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);u=this.d(t,y,o.endLineNumber,0,u,f,i,s)}return f}static d(n,o,t,i,s,f,u,w){const y=n.wordSeparators;if(!u&&n.simpleSearch){const C=n.simpleSearch,A=C.length,b=o.length;let v=-A;for(;(v=o.indexOf(C,v+A))!==-1;)if((!y||m(y,o,b,v,A))&&(f[s++]=new R.$aw(new T.$Lt(t,v+1+i,t,v+1+A+i),null),s>=w))return s;return s}const D=new d(n.wordSeparators,n.regex);let S;D.reset(0);do if(S=D.next(o),S&&(f[s++]=E(new T.$Lt(t,S.index+1+i,t,S.index+1+S[0].length+i),S,u),s>=w))return s;while(S);return s}static findNextMatch(n,o,t,i){const s=o.parseSearchRequest();if(!s)return null;const f=new d(s.wordSeparators,s.regex);return s.regex.multiline?this.e(n,t,f,i):this.f(n,t,f,i)}static e(n,o,t,i){const s=new O.$Kt(o.lineNumber,1),f=n.getOffsetAt(s),u=n.getLineCount(),w=n.getValueInRange(new T.$Lt(s.lineNumber,s.column,u,n.getLineMaxColumn(u)),R.EndOfLinePreference.LF),y=n.getEOL()===`\r
`?new l(w):null;t.reset(o.column-1);const D=t.next(w);return D?E(this.a(n,f,w,y,D.index,D[0]),D,i):o.lineNumber!==1||o.column!==1?this.e(n,new O.$Kt(1,1),t,i):null}static f(n,o,t,i){const s=n.getLineCount(),f=o.lineNumber,u=n.getLineContent(f),w=this.g(t,u,f,o.column,i);if(w)return w;for(let y=1;y<=s;y++){const D=(f+y-1)%s,S=n.getLineContent(D+1),C=this.g(t,S,D+1,1,i);if(C)return C}return null}static g(n,o,t,i,s){n.reset(i-1);const f=n.next(o);return f?E(new T.$Lt(t,f.index+1,t,f.index+1+f[0].length),f,s):null}static findPreviousMatch(n,o,t,i){const s=o.parseSearchRequest();if(!s)return null;const f=new d(s.wordSeparators,s.regex);return s.regex.multiline?this.h(n,t,f,i):this.j(n,t,f,i)}static h(n,o,t,i){const s=this.b(n,new T.$Lt(1,1,o.lineNumber,o.column),t,i,10*$);if(s.length>0)return s[s.length-1];const f=n.getLineCount();return o.lineNumber!==f||o.column!==n.getLineMaxColumn(f)?this.h(n,new O.$Kt(f,n.getLineMaxColumn(f)),t,i):null}static j(n,o,t,i){const s=n.getLineCount(),f=o.lineNumber,u=n.getLineContent(f).substring(0,o.column-1),w=this.k(t,u,f,i);if(w)return w;for(let y=1;y<=s;y++){const D=(s+f-y-1)%s,S=n.getLineContent(D+1),C=this.k(t,S,D+1,i);if(C)return C}return null}static k(n,o,t,i){let s=null,f;for(n.reset(0);f=n.next(o);)s=E(new T.$Lt(t,f.index+1,t,f.index+1+f[0].length),f,i);return s}}e.$dD=k;function p(g,n,o,t,i){if(t===0)return!0;const s=n.charCodeAt(t-1);if(g.get(s)!==P.WordCharacterClass.Regular||s===r.CharCode.CarriageReturn||s===r.CharCode.LineFeed)return!0;if(i>0){const f=n.charCodeAt(t);if(g.get(f)!==P.WordCharacterClass.Regular)return!0}return!1}function c(g,n,o,t,i){if(t+i===o)return!0;const s=n.charCodeAt(t+i);if(g.get(s)!==P.WordCharacterClass.Regular||s===r.CharCode.CarriageReturn||s===r.CharCode.LineFeed)return!0;if(i>0){const f=n.charCodeAt(t+i-1);if(g.get(f)!==P.WordCharacterClass.Regular)return!0}return!1}function m(g,n,o,t,i){return p(g,n,o,t,i)&&c(g,n,o,t,i)}class d{constructor(n,o){this._wordSeparators=n,this.a=o,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const o=n.length;let t;do{if(this.b+this.c===o||(t=this.a.exec(n),!t))return null;const i=t.index,s=t[0].length;if(i===this.b&&s===this.c){if(s===0){h.$Nf(n,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=i,this.c=s,!this._wordSeparators||m(this._wordSeparators,n,o,i,s))return t}while(t);return null}}e.$fD=d}),define(ye[139],Se([1,0,27,54,31,55,196,107]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kD=e.$jD=e.$iD=void 0,e.$gD=E,e.$hD=l;const $=65535;function a(g){let n;return g[g.length-1]<65536?n=new Uint16Array(g.length):n=new Uint32Array(g.length),n.set(g,0),n}class I{constructor(n,o,t,i,s){this.lineStarts=n,this.cr=o,this.lf=t,this.crlf=i,this.isBasicASCII=s}}function E(g,n=!0){const o=[0];let t=1;for(let i=0,s=g.length;i<s;i++){const f=g.charCodeAt(i);f===r.CharCode.CarriageReturn?i+1<s&&g.charCodeAt(i+1)===r.CharCode.LineFeed?(o[t++]=i+2,i++):o[t++]=i+1:f===r.CharCode.LineFeed&&(o[t++]=i+1)}return n?a(o):o}function l(g,n){g.length=0,g[0]=0;let o=1,t=0,i=0,s=0,f=!0;for(let w=0,y=n.length;w<y;w++){const D=n.charCodeAt(w);D===r.CharCode.CarriageReturn?w+1<y&&n.charCodeAt(w+1)===r.CharCode.LineFeed?(s++,g[o++]=w+2,w++):(t++,g[o++]=w+1):D===r.CharCode.LineFeed?(i++,g[o++]=w+1):f&&D!==r.CharCode.Tab&&(D<32||D>126)&&(f=!1)}const u=new I(a(g),t,i,s,f);return g.length=0,u}class k{constructor(n,o,t,i,s){this.bufferIndex=n,this.start=o,this.end=t,this.lineFeedCnt=i,this.length=s}}e.$iD=k;class p{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$jD=p;class c{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==T.$4C&&n.iterate(n.root,t=>(t!==T.$4C&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class m{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const t=this.b[o];if(t.nodeStartOffset<=n&&t.nodeStartOffset+t.node.piece.length>=n)return t}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const t=this.b[o];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<n&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=n)return t}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const t=this.b;for(let i=0;i<t.length;i++){const s=t[i];if(s.node.parent===null||s.nodeStartOffset>=n){t[i]=null,o=!0;continue}}if(o){const i=[];for(const s of t)s!==null&&i.push(s);this.b=i}}}class d{constructor(n,o,t){this.create(n,o,t)}create(n,o,t){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=T.$4C,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=t;let i=null;for(let s=0,f=n.length;s<f;s++)if(n[s].buffer.length>0){n[s].lineStarts||(n[s].lineStarts=E(n[s].buffer));const u=new k(s+1,{line:0,column:0},{line:n[s].lineStarts.length-1,column:n[s].buffer.length-n[s].lineStarts[n[s].lineStarts.length-1]},n[s].lineStarts.length-1,n[s].buffer.length);this.a.push(n[s]),i=this.S(i,u)}this.h=new m(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=$,t=o-Math.floor(o/3),i=t*2;let s="",f=0;const u=[];if(this.iterate(this.root,w=>{const y=this.R(w),D=y.length;if(f<=t||f+D<i)return s+=y,f+=D,!0;const S=s.replace(/\r\n|\r|\n/g,n);return u.push(new p(S,E(S))),s=y,f=D,!0}),f>0){const w=s.replace(/\r\n|\r|\n/g,n);u.push(new p(w,E(w)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new c(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,i=>{if(i===T.$4C)return!0;const s=this.R(i),f=s.length,u=n.G(o),w=n.G(o+f),y=n.getValueInRange2(u,w);return o+=f,s===y})}getOffsetAt(n,o){let t=0,i=this.root;for(;i!==T.$4C;)if(i.left!==T.$4C&&i.lf_left+1>=n)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt+1>=n){t+=i.size_left;const s=this.B(i,n-i.lf_left-2);return t+=s+o-1}else n-=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;return t}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,t=0;const i=n;for(;o!==T.$4C;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const s=this.A(o,n-o.size_left);if(t+=o.lf_left+s.index,s.index===0){const f=this.getOffsetAt(t+1,1),u=i-f;return new h.$Kt(t+1,u+1)}return new h.$Kt(t+1,s.remainder+1)}else if(n-=o.size_left+o.piece.length,t+=o.lf_left+o.piece.lineFeedCnt,o.right===T.$4C){const s=this.getOffsetAt(t+1,1),f=i-n-s;return new h.$Kt(t+1,f+1)}else o=o.right;return new h.$Kt(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const t=this.H(n.startLineNumber,n.startColumn),i=this.H(n.endLineNumber,n.endColumn),s=this.getValueInRange2(t,i);return o?o!==this.d||!this.f?s.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?s:s.replace(/\r\n|\r|\n/g,o):s}getValueInRange2(n,o){if(n.node===o.node){const u=n.node,w=this.a[u.piece.bufferIndex].buffer,y=this.u(u.piece.bufferIndex,u.piece.start);return w.substring(y+n.remainder,y+o.remainder)}let t=n.node;const i=this.a[t.piece.bufferIndex].buffer,s=this.u(t.piece.bufferIndex,t.piece.start);let f=i.substring(s+n.remainder,s+t.piece.length);for(t=t.next();t!==T.$4C;){const u=this.a[t.piece.bufferIndex].buffer,w=this.u(t.piece.bufferIndex,t.piece.start);if(t===o.node){f+=u.substring(w,w+o.remainder);break}else f+=u.substr(w,t.piece.length);t=t.next()}return f}getLinesContent(){const n=[];let o=0,t="",i=!1;return this.iterate(this.root,s=>{if(s===T.$4C)return!0;const f=s.piece;let u=f.length;if(u===0)return!0;const w=this.a[f.bufferIndex].buffer,y=this.a[f.bufferIndex].lineStarts,D=f.start.line,S=f.end.line;let C=y[D]+f.start.column;if(i&&(w.charCodeAt(C)===r.CharCode.LineFeed&&(C++,u--),n[o++]=t,t="",i=!1,u===0))return!0;if(D===S)return!this.f&&w.charCodeAt(C+u-1)===r.CharCode.CarriageReturn?(i=!0,t+=w.substr(C,u-1)):t+=w.substr(C,u),!0;t+=this.f?w.substring(C,Math.max(C,y[D+1]-this.e)):w.substring(C,y[D+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=t;for(let A=D+1;A<S;A++)t=this.f?w.substring(y[A],y[A+1]-this.e):w.substring(y[A],y[A+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=t;return!this.f&&w.charCodeAt(y[S]+f.end.column-1)===r.CharCode.CarriageReturn?(i=!0,f.end.column===0?o--:t=w.substr(y[S],f.end.column-1)):t=w.substr(y[S],f.end.column),!0}),i&&(n[o++]=t,t=""),n[o++]=t,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const t=this.a[o.piece.bufferIndex],i=this.u(o.piece.bufferIndex,o.piece.start);return t.buffer.charCodeAt(i)}else{const o=this.a[n.node.piece.bufferIndex],i=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(i)}}getLineCharCode(n,o){const t=this.H(n,o+1);return this.l(t)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}getNearestChunk(n){const o=this.G(n);if(o.remainder===o.node.piece.length){const t=o.node.next();if(!t||t===T.$4C)return"";const i=this.a[t.piece.bufferIndex],s=this.u(t.piece.bufferIndex,t.piece.start);return i.buffer.substring(s,s+t.piece.length)}else{const t=this.a[o.node.piece.bufferIndex],i=this.u(o.node.piece.bufferIndex,o.node.piece.start),s=i+o.remainder,f=i+o.node.piece.length;return t.buffer.substring(s,f)}}findMatchesInNode(n,o,t,i,s,f,u,w,y,D,S){const C=this.a[n.piece.bufferIndex],A=this.u(n.piece.bufferIndex,n.piece.start),b=this.u(n.piece.bufferIndex,s),v=this.u(n.piece.bufferIndex,f);let M;const N={line:0,column:0};let L,j;o._wordSeparators?(L=C.buffer.substring(b,v),j=z=>z+b,o.reset(0)):(L=C.buffer,j=z=>z,o.reset(b));do if(M=o.next(L),M){if(j(M.index)>=v)return D;this.s(n,j(M.index)-A,N);const z=this.t(n.piece.bufferIndex,s,N),F=N.line===s.line?N.column-s.column+i:N.column+1,B=F+M[0].length;if(S[D++]=(0,R.$cD)(new P.$Lt(t+z,F,t+z,B),M,w),j(M.index)+M[0].length>=v||D>=y)return D}while(M);return D}findMatchesLineByLine(n,o,t,i){const s=[];let f=0;const u=new R.$fD(o.wordSeparators,o.regex);let w=this.H(n.startLineNumber,n.startColumn);if(w===null)return[];const y=this.H(n.endLineNumber,n.endColumn);if(y===null)return[];let D=this.s(w.node,w.remainder);const S=this.s(y.node,y.remainder);if(w.node===y.node)return this.findMatchesInNode(w.node,u,n.startLineNumber,n.startColumn,D,S,o,t,i,f,s),s;let C=n.startLineNumber,A=w.node;for(;A!==y.node;){const v=this.t(A.piece.bufferIndex,D,A.piece.end);if(v>=1){const N=this.a[A.piece.bufferIndex].lineStarts,L=this.u(A.piece.bufferIndex,A.piece.start),j=N[D.line+v],z=C===n.startLineNumber?n.startColumn:1;if(f=this.findMatchesInNode(A,u,C,z,D,this.s(A,j-L),o,t,i,f,s),f>=i)return s;C+=v}const M=C===n.startLineNumber?n.startColumn-1:0;if(C===n.endLineNumber){const N=this.getLineContent(C).substring(M,n.endColumn-1);return f=this.n(o,u,N,n.endLineNumber,M,f,s,t,i),s}if(f=this.n(o,u,this.getLineContent(C).substr(M),C,M,f,s,t,i),f>=i)return s;C++,w=this.H(C,1),A=w.node,D=this.s(w.node,w.remainder)}if(C===n.endLineNumber){const v=C===n.startLineNumber?n.startColumn-1:0,M=this.getLineContent(C).substring(v,n.endColumn-1);return f=this.n(o,u,M,n.endLineNumber,v,f,s,t,i),s}const b=C===n.startLineNumber?n.startColumn:1;return f=this.findMatchesInNode(y.node,u,C,b,D,S,o,t,i,f,s),s}n(n,o,t,i,s,f,u,w,y){const D=n.wordSeparators;if(!w&&n.simpleSearch){const C=n.simpleSearch,A=C.length,b=t.length;let v=-A;for(;(v=t.indexOf(C,v+A))!==-1;)if((!D||(0,R.$eD)(D,t,b,v,A))&&(u[f++]=new O.$aw(new P.$Lt(i,v+1+s,i,v+1+A+s),null),f>=y))return f;return f}let S;o.reset(0);do if(S=o.next(t),S&&(u[f++]=(0,R.$cD)(new P.$Lt(i,S.index+1+s,i,S.index+1+S[0].length+s),S,w),f>=y))return f;while(S);return f}insert(n,o,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==T.$4C){const{node:i,remainder:s,nodeStartOffset:f}=this.G(n),u=i.piece,w=u.bufferIndex,y=this.s(i,s);if(i.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&f+u.length===n&&o.length<$){this.F(i,o),this.y();return}if(f===n)this.o(o,i),this.h.validate(n);else if(f+i.piece.length>n){const D=[];let S=new k(u.bufferIndex,y,u.end,this.t(u.bufferIndex,y,u.end),this.u(w,u.end)-this.u(w,y));if(this.K()&&this.M(o)&&this.I(i,s)===10){const v={line:S.start.line+1,column:0};S=new k(S.bufferIndex,v,S.end,this.t(S.bufferIndex,v,S.end),S.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(i,s-1)===13){const v=this.s(i,s-1);this.C(i,v),o="\r"+o,i.piece.length===0&&D.push(i)}else this.C(i,y);else this.C(i,y);const C=this.w(o);S.length>0&&this.S(i,S);let A=i;for(let b=0;b<C.length;b++)A=this.S(A,C[b]);this.v(D)}else this.q(o,i)}else{const i=this.w(o);let s=this.T(null,i[0]);for(let f=1;f<i.length;f++)s=this.S(s,i[f])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===T.$4C)return;const t=this.G(n),i=this.G(n+o),s=t.node,f=i.node;if(s===f){const C=this.s(s,t.remainder),A=this.s(s,i.remainder);if(t.nodeStartOffset===n){if(o===s.piece.length){const b=s.next();(0,T.$9C)(this,s),this.N(b),this.y();return}this.D(s,A),this.h.validate(n),this.N(s),this.y();return}if(t.nodeStartOffset+s.piece.length===n+o){this.C(s,C),this.O(s),this.y();return}this.E(s,C,A),this.y();return}const u=[],w=this.s(s,t.remainder);this.C(s,w),this.h.validate(n),s.piece.length===0&&u.push(s);const y=this.s(f,i.remainder);this.D(f,y),f.piece.length===0&&u.push(f);const D=s.next();for(let C=D;C!==T.$4C&&C!==f;C=C.next())u.push(C);const S=s.piece.length===0?s.prev():s;this.v(u),this.O(S),this.y()}o(n,o){const t=[];if(this.K()&&this.M(n)&&this.L(o)){const f=o.piece,u={line:f.start.line+1,column:0},w=new k(f.bufferIndex,u,f.end,this.t(f.bufferIndex,u,f.end),f.length-1);o.piece=w,n+=`
`,(0,T.$$C)(this,o,-1,-1),o.piece.length===0&&t.push(o)}const i=this.w(n);let s=this.T(o,i[i.length-1]);for(let f=i.length-2;f>=0;f--)s=this.T(s,i[f]);this.N(s),this.v(t)}q(n,o){this.Q(n,o)&&(n+=`
`);const t=this.w(n),i=this.S(o,t[0]);let s=i;for(let f=1;f<t.length;f++)s=this.S(s,t[f]);this.N(i)}s(n,o,t){const i=n.piece,s=n.piece.bufferIndex,f=this.a[s].lineStarts,w=f[i.start.line]+i.start.column+o;let y=i.start.line,D=i.end.line,S=0,C=0,A=0;for(;y<=D&&(S=y+(D-y)/2|0,A=f[S],S!==D);)if(C=f[S+1],w<A)D=S-1;else if(w>=C)y=S+1;else break;return t?(t.line=S,t.column=w-A,null):{line:S,column:w-A}}t(n,o,t){if(t.column===0)return t.line-o.line;const i=this.a[n].lineStarts;if(t.line===i.length-1)return t.line-o.line;const s=i[t.line+1],f=i[t.line]+t.column;if(s>f+1)return t.line-o.line;const u=f-1;return this.a[n].buffer.charCodeAt(u)===13?t.line-o.line+1:t.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,T.$9C)(this,n[o])}w(n){if(n.length>$){const D=[];for(;n.length>$;){const C=n.charCodeAt($-1);let A;C===r.CharCode.CarriageReturn||C>=55296&&C<=56319?(A=n.substring(0,$-1),n=n.substring($-1)):(A=n.substring(0,$),n=n.substring($));const b=E(A);D.push(new k(this.a.length,{line:0,column:0},{line:b.length-1,column:A.length-b[b.length-1]},b.length-1,A.length)),this.a.push(new p(A,b))}const S=E(n);return D.push(new k(this.a.length,{line:0,column:0},{line:S.length-1,column:n.length-S[S.length-1]},S.length-1,n.length)),this.a.push(new p(n,S)),D}let o=this.a[0].buffer.length;const t=E(n,!1);let i=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},i=this.g;for(let D=0;D<t.length;D++)t[D]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let D=0;D<t.length;D++)t[D]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=n}const s=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,u=s-this.a[0].lineStarts[f],w={line:f,column:u},y=new k(0,i,w,this.t(0,i,w),s-o);return this.g=w,[y]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let t=this.root,i="";const s=this.h.get2(n);if(s){t=s.node;const f=this.B(t,n-s.nodeStartLineNumber-1),u=this.a[t.piece.bufferIndex].buffer,w=this.u(t.piece.bufferIndex,t.piece.start);if(s.nodeStartLineNumber+t.piece.lineFeedCnt===n)i=u.substring(w+f,w+t.piece.length);else{const y=this.B(t,n-s.nodeStartLineNumber);return u.substring(w+f,w+y-o)}}else{let f=0;const u=n;for(;t!==T.$4C;)if(t.left!==T.$4C&&t.lf_left>=n-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>n-1){const w=this.B(t,n-t.lf_left-2),y=this.B(t,n-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,S=this.u(t.piece.bufferIndex,t.piece.start);return f+=t.size_left,this.h.set({node:t,nodeStartOffset:f,nodeStartLineNumber:u-(n-1-t.lf_left)}),D.substring(S+w,S+y-o)}else if(t.lf_left+t.piece.lineFeedCnt===n-1){const w=this.B(t,n-t.lf_left-2),y=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);i=y.substring(D+w,D+t.piece.length);break}else n-=t.lf_left+t.piece.lineFeedCnt,f+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==T.$4C;){const f=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const u=this.B(t,0),w=this.u(t.piece.bufferIndex,t.piece.start);return i+=f.substring(w,w+u-o),i}else{const u=this.u(t.piece.bufferIndex,t.piece.start);i+=f.substr(u,t.piece.length)}t=t.next()}return i}y(){let n=this.root,o=1,t=0;for(;n!==T.$4C;)o+=n.lf_left+n.piece.lineFeedCnt,t+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=t,this.h.validate(this.c)}A(n,o){const t=n.piece,i=this.s(n,o),s=i.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===o){const f=this.t(n.piece.bufferIndex,t.start,i);if(f!==s)return{index:f,remainder:0}}return{index:s,remainder:i.column}}B(n,o){if(o<0)return 0;const t=n.piece,i=this.a[t.bufferIndex].lineStarts,s=t.start.line+o+1;return s>t.end.line?i[t.end.line]+t.end.column-i[t.start.line]-t.start.column:i[s]-i[t.start.line]-t.start.column}C(n,o){const t=n.piece,i=t.lineFeedCnt,s=this.u(t.bufferIndex,t.end),f=o,u=this.u(t.bufferIndex,f),w=this.t(t.bufferIndex,t.start,f),y=w-i,D=u-s,S=t.length+D;n.piece=new k(t.bufferIndex,t.start,f,w,S),(0,T.$$C)(this,n,D,y)}D(n,o){const t=n.piece,i=t.lineFeedCnt,s=this.u(t.bufferIndex,t.start),f=o,u=this.t(t.bufferIndex,f,t.end),w=this.u(t.bufferIndex,f),y=u-i,D=s-w,S=t.length+D;n.piece=new k(t.bufferIndex,f,t.end,u,S),(0,T.$$C)(this,n,D,y)}E(n,o,t){const i=n.piece,s=i.start,f=i.end,u=i.length,w=i.lineFeedCnt,y=o,D=this.t(i.bufferIndex,i.start,y),S=this.u(i.bufferIndex,o)-this.u(i.bufferIndex,s);n.piece=new k(i.bufferIndex,i.start,y,D,S),(0,T.$$C)(this,n,S-u,D-w);const C=new k(i.bufferIndex,t,f,this.t(i.bufferIndex,t,f),this.u(i.bufferIndex,f)-this.u(i.bufferIndex,t)),A=this.S(n,C);this.N(A)}F(n,o){this.Q(o,n)&&(o+=`
`);const t=this.K()&&this.L(o)&&this.M(n),i=this.a[0].buffer.length;this.a[0].buffer+=o;const s=E(o,!1);for(let A=0;A<s.length;A++)s[A]+=i;if(t){const A=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:i-A}}this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1));const f=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[f],w={line:f,column:u},y=n.piece.length+o.length,D=n.piece.lineFeedCnt,S=this.t(0,n.piece.start,w),C=S-D;n.piece=new k(n.piece.bufferIndex,n.piece.start,w,S,y),this.g=w,(0,T.$$C)(this,n,o.length,C)}G(n){let o=this.root;const t=this.h.get(n);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:n-t.nodeStartOffset};let i=0;for(;o!==T.$4C;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){i+=o.size_left;const s={node:o,remainder:n-o.size_left,nodeStartOffset:i};return this.h.set(s),s}else n-=o.size_left+o.piece.length,i+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let t=this.root,i=0;for(;t!==T.$4C;)if(t.left!==T.$4C&&t.lf_left>=n-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>n-1){const s=this.B(t,n-t.lf_left-2),f=this.B(t,n-t.lf_left-1);return i+=t.size_left,{node:t,remainder:Math.min(s+o-1,f),nodeStartOffset:i}}else if(t.lf_left+t.piece.lineFeedCnt===n-1){const s=this.B(t,n-t.lf_left-2);if(s+o-1<=t.piece.length)return{node:t,remainder:s+o-1,nodeStartOffset:i};o-=t.piece.length-s;break}else n-=t.lf_left+t.piece.lineFeedCnt,i+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==T.$4C;){if(t.piece.lineFeedCnt>0){const s=this.B(t,0),f=this.J(t);return{node:t,remainder:Math.min(o-1,s),nodeStartOffset:f}}else if(t.piece.length>=o-1){const s=this.J(t);return{node:t,remainder:o-1,nodeStartOffset:s}}else o-=t.piece.length;t=t.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const t=this.a[n.piece.bufferIndex],i=this.u(n.piece.bufferIndex,n.piece.start)+o;return t.buffer.charCodeAt(i)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===T.$4C||n.piece.lineFeedCnt===0)return!1;const o=n.piece,t=this.a[o.bufferIndex].lineStarts,i=o.start.line,s=t[i]+o.start.column;return i===t.length-1||t[i+1]>s+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(s)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===T.$4C||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const t=[],i=this.a[n.piece.bufferIndex].lineStarts;let s;n.piece.end.column===0?s={line:n.piece.end.line-1,column:i[n.piece.end.line]-i[n.piece.end.line-1]-1}:s={line:n.piece.end.line,column:n.piece.end.column-1};const f=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new k(n.piece.bufferIndex,n.piece.start,s,u,f),(0,T.$$C)(this,n,-1,-1),n.piece.length===0&&t.push(n);const w={line:o.piece.start.line+1,column:0},y=o.piece.length-1,D=this.t(o.piece.bufferIndex,w,o.piece.end);o.piece=new k(o.piece.bufferIndex,w,o.piece.end,D,y),(0,T.$$C)(this,o,-1,-1),o.piece.length===0&&t.push(o);const S=this.w(`\r
`);this.S(n,S[0]);for(let C=0;C<t.length;C++)(0,T.$9C)(this,t[C])}Q(n,o){if(this.K()&&this.M(n)){const t=o.next();if(this.L(t)){if(n+=`
`,t.piece.length===1)(0,T.$9C)(this,t);else{const i=t.piece,s={line:i.start.line+1,column:0},f=i.length-1,u=this.t(i.bufferIndex,s,i.end);t.piece=new k(i.bufferIndex,s,i.end,u,f),(0,T.$$C)(this,t,-1,-1)}return!0}}return!1}iterate(n,o){if(n===T.$4C)return o(T.$4C);const t=this.iterate(n.left,o);return t&&o(n)&&this.iterate(n.right,o)}R(n){if(n===T.$4C)return"";const o=this.a[n.piece.bufferIndex],t=n.piece,i=this.u(t.bufferIndex,t.start),s=this.u(t.bufferIndex,t.end);return o.buffer.substring(i,s)}getPieceContent(n){const o=this.a[n.bufferIndex],t=this.u(n.bufferIndex,n.start),i=this.u(n.bufferIndex,n.end);return o.buffer.substring(t,i)}S(n,o){const t=new T.$3C(o,T.NodeColor.Red);if(t.left=T.$4C,t.right=T.$4C,t.parent=T.$4C,t.size_left=0,t.lf_left=0,this.root===T.$4C)this.root=t,t.color=T.NodeColor.Black;else if(n.right===T.$4C)n.right=t,t.parent=n;else{const s=(0,T.$5C)(n.right);s.left=t,t.parent=s}return(0,T.$0C)(this,t),t}T(n,o){const t=new T.$3C(o,T.NodeColor.Red);if(t.left=T.$4C,t.right=T.$4C,t.parent=T.$4C,t.size_left=0,t.lf_left=0,this.root===T.$4C)this.root=t,t.color=T.NodeColor.Black;else if(n.left===T.$4C)n.left=t,t.parent=n;else{const i=(0,T.$6C)(n.left);i.right=t,t.parent=i}return(0,T.$0C)(this,t),t}U(n){let o="";return this.iterate(n,t=>(o+=this.R(t),!0)),o}}e.$kD=d}),define(ye[199],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w_=e.$v_=void 0;class r{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const T=this.a.get(O);return this.a.delete(O),T}}addDragOperationTransfer(O,T){this.a.set(O,T)}}e.$v_=r;class h{constructor(O){this.identifier=O}}e.$w_=h}),define(ye[200],Se([1,0,4,3,106]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uu=void 0;class O{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$me,this.onDidChange=this.c.event,this.d=null}handleChange($){this.c.fire({changedLanguages:$,changedColorMap:!1})}register($,a){return this.a.set($,a),this.handleChange([$]),(0,h.$Uc)(()=>{this.a.get($)===a&&(this.a.delete($),this.handleChange([$]))})}get($){return this.a.get($)||null}registerFactory($,a){this.b.get($)?.dispose();const I=new T(this,$,a);return this.b.set($,I),(0,h.$Uc)(()=>{const E=this.b.get($);!E||E!==I||(this.b.delete($),E.dispose())})}async getOrCreate($){const a=this.get($);if(a)return a;const I=this.b.get($);return!I||I.isResolved?null:(await I.resolve(),this.get($))}isResolved($){if(this.get($))return!0;const I=this.b.get($);return!!(!I||I.isResolved)}setColorMap($){this.d=$,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>P.ColorId.DefaultBackground?this.d[P.ColorId.DefaultBackground]:null}}e.$uu=O;class T extends h.$Wc{get isResolved(){return this.c}constructor($,a,I){super(),this.f=$,this.g=a,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const $=await this.h.tokenizationSupport;this.c=!0,$&&!this.a&&this.B(this.f.register(this.g,$))}}}),define(ye[201],Se([7,8]),function(ce,e){return ce.create("vs/base/common/actions",e)}),define(ye[202],Se([1,0,4,3,201]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0,e.$pj=I,P=We(P);class O extends h.$Wc{constructor(l,k="",p="",c=!0,m){super(),this.j=this.B(new r.$me),this.onDidChange=this.j.event,this.z=!0,this.m=l,this.n=k,this.w=p,this.z=c,this.D=m}get id(){return this.m}get label(){return this.n}set label(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.j.fire({label:l}))}get tooltip(){return this.u||""}set tooltip(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.j.fire({tooltip:l}))}get class(){return this.w}set class(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.j.fire({class:l}))}get enabled(){return this.z}set enabled(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.j.fire({enabled:l}))}get checked(){return this.C}set checked(l){this.J(l)}J(l){this.C!==l&&(this.C=l,this.j.fire({checked:l}))}async run(l,k){this.D&&await this.D(l)}}e.$kj=O;class T extends h.$Wc{constructor(){super(...arguments),this.f=this.B(new r.$me),this.onWillRun=this.f.event,this.m=this.B(new r.$me),this.onDidRun=this.m.event}async run(l,k){if(!l.enabled)return;this.f.fire({action:l});let p;try{await this.u(l,k)}catch(c){p=c}this.m.fire({action:l,error:p})}async u(l,k){await l.run(k)}}e.$lj=T;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let k=[];for(const p of l)p.length&&(k.length?k=[...k,new R,...p]:k=p);return k}static{this.ID="vs.actions.separator"}async run(){}}e.$mj=R;class ${get actions(){return this.a}constructor(l,k,p,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=k,this.class=c,this.a=p}async run(){}}e.$nj=$;class a extends O{static{this.ID="vs.actions.empty"}constructor(){super(a.ID,P.localize(0,null),void 0,!1)}}e.$oj=a;function I(E){return{id:E.id,label:E.label,tooltip:E.tooltip??E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...l)=>E.run(...l)}}}),define(ye[203],Se([7,8]),function(ce,e){return ce.create("vs/base/common/date",e)}),define(ye[204],Se([1,0,203]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=a,e.$2m=I,e.$3m=E;const h=60,P=h*60,O=P*24,T=O*7,R=O*30,$=O*365;function a(l,k,p,c){typeof l!="number"&&(l=l.getTime());const m=Math.round((new Date().getTime()-l)/1e3);if(m<-30)return(0,r.localize)(0,null,a(new Date().getTime()+m*1e3,!1));if(!c&&m<30)return(0,r.localize)(1,null);let d;return m<h?(d=m,k?d===1?p?(0,r.localize)(2,null,d):(0,r.localize)(3,null,d):p?(0,r.localize)(4,null,d):(0,r.localize)(5,null,d):d===1?p?(0,r.localize)(6,null,d):(0,r.localize)(7,null,d):p?(0,r.localize)(8,null,d):(0,r.localize)(9,null,d)):m<P?(d=Math.floor(m/h),k?d===1?p?(0,r.localize)(10,null,d):(0,r.localize)(11,null,d):p?(0,r.localize)(12,null,d):(0,r.localize)(13,null,d):d===1?p?(0,r.localize)(14,null,d):(0,r.localize)(15,null,d):p?(0,r.localize)(16,null,d):(0,r.localize)(17,null,d)):m<O?(d=Math.floor(m/P),k?d===1?p?(0,r.localize)(18,null,d):(0,r.localize)(19,null,d):p?(0,r.localize)(20,null,d):(0,r.localize)(21,null,d):d===1?p?(0,r.localize)(22,null,d):(0,r.localize)(23,null,d):p?(0,r.localize)(24,null,d):(0,r.localize)(25,null,d)):m<T?(d=Math.floor(m/O),k?d===1?(0,r.localize)(26,null,d):(0,r.localize)(27,null,d):d===1?(0,r.localize)(28,null,d):(0,r.localize)(29,null,d)):m<R?(d=Math.floor(m/T),k?d===1?p?(0,r.localize)(30,null,d):(0,r.localize)(31,null,d):p?(0,r.localize)(32,null,d):(0,r.localize)(33,null,d):d===1?p?(0,r.localize)(34,null,d):(0,r.localize)(35,null,d):p?(0,r.localize)(36,null,d):(0,r.localize)(37,null,d)):m<$?(d=Math.floor(m/R),k?d===1?p?(0,r.localize)(38,null,d):(0,r.localize)(39,null,d):p?(0,r.localize)(40,null,d):(0,r.localize)(41,null,d):d===1?p?(0,r.localize)(42,null,d):(0,r.localize)(43,null,d):p?(0,r.localize)(44,null,d):(0,r.localize)(45,null,d)):(d=Math.floor(m/$),k?d===1?p?(0,r.localize)(46,null,d):(0,r.localize)(47,null,d):p?(0,r.localize)(48,null,d):(0,r.localize)(49,null,d):d===1?p?(0,r.localize)(50,null,d):(0,r.localize)(51,null,d):p?(0,r.localize)(52,null,d):(0,r.localize)(53,null,d))}function I(l,k){const p=Math.abs(l/1e3);return p<1?k?(0,r.localize)(54,null,l):(0,r.localize)(55,null,l):p<h?k?(0,r.localize)(56,null,Math.round(l)/1e3):(0,r.localize)(57,null,Math.round(l)/1e3):p<P?k?(0,r.localize)(58,null,Math.round(l/(1e3*h))):(0,r.localize)(59,null,Math.round(l/(1e3*h))):p<O?k?(0,r.localize)(60,null,Math.round(l/(1e3*P))):(0,r.localize)(61,null,Math.round(l/(1e3*P))):(0,r.localize)(62,null,Math.round(l/(1e3*O)))}function E(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ye[205],Se([7,8]),function(ce,e){return ce.create("vs/base/common/errorMessage",e)}),define(ye[51],Se([1,0,19,18,205]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=$,e.$rj=a,e.$sj=I,r=We(r),h=We(h),P=We(P);function O(E,l){return l&&(E.stack||E.stacktrace)?P.localize(0,null,R(E),T(E.stack)||T(E.stacktrace)):R(E)}function T(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?P.localize(1,null,E.message):E.message||P.localize(2,null)}function $(E=null,l=!1){if(!E)return P.localize(3,null);if(Array.isArray(E)){const k=r.$Jb(E),p=$(k[0],l);return k.length>1?P.localize(4,null,p,k.length):p}if(h.$fg(E))return E;if(E.detail){const k=E.detail;if(k.error)return O(k.error,l);if(k.exception)return O(k.exception,l)}return E.stack?O(E,l):E.message?E.message:P.localize(5,null)}function a(E){const l=E;return l instanceof Error&&Array.isArray(l.actions)}function I(E,l){let k;return typeof E=="string"?k=new Error(E):k=E,k.actions=l,k}}),define(ye[206],Se([7,8]),function(ce,e){return ce.create("vs/base/common/platform",e)}),define(ye[11],Se([1,0,206]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=s,e.$D=S,e.$J=C,r=We(r),e.$g="en";let h=!1,P=!1,O=!1,T=!1,R=!1,$=!1,a=!1,I=!1,E=!1,l=!1,k,p=e.$g,c=e.$g,m,d;const g=globalThis;let n;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?n=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const o=typeof n?.versions?.electron=="string",t=o&&n?.type==="renderer";if(typeof n=="object"){h=n.platform==="win32",P=n.platform==="darwin",O=n.platform==="linux",T=O&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,a=o,E=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.$g,p=e.$g;const A=n.env.VSCODE_NLS_CONFIG;if(A)try{const b=JSON.parse(A),v=b.availableLanguages["*"];k=b.locale,c=b.osLocale,p=v||e.$g,m=b._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!t?(d=navigator.userAgent,h=d.indexOf("Windows")>=0,P=d.indexOf("Macintosh")>=0,I=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=d.indexOf("Linux")>=0,l=d?.indexOf("Mobi")>=0,$=!0,k=r.getConfiguredDefaultLocale(r.localize(0,null))||e.$g,p=k,c=navigator.language):console.error("Unable to resolve platform.");var i;(function(A){A[A.Web=0]="Web",A[A.Mac=1]="Mac",A[A.Linux=2]="Linux",A[A.Windows=3]="Windows"})(i||(e.Platform=i={}));function s(A){switch(A){case i.Web:return"Web";case i.Mac:return"Mac";case i.Linux:return"Linux";case i.Windows:return"Windows"}}let f=i.Web;P?f=i.Mac:h?f=i.Windows:O&&(f=i.Linux),e.$i=h,e.$j=P,e.$k=O,e.$l=T,e.$m=R,e.$n=a,e.$o=$,e.$p=$&&typeof g.importScripts=="function",e.$q=e.$p?g.origin:void 0,e.$r=I,e.$s=l,e.$t=E,e.$u=f,e.$v=d,e.$w=p;var u;(function(A){function b(){return e.$w}A.value=b;function v(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}A.isDefaultVariant=v;function M(){return e.$w==="en"}A.isDefault=M})(u||(e.Language=u={})),e.$x=k,e.$y=c,e.$z=m,e.$A=typeof g.postMessage=="function"&&!g.importScripts,e.$B=(()=>{if(e.$A){const A=[];g.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let M=0,N=A.length;M<N;M++){const L=A[M];if(L.id===v.data.vscodeScheduleAsyncWork){A.splice(M,1),L.callback();return}}});let b=0;return v=>{const M=++b;A.push({id:M,callback:v}),g.postMessage({vscodeScheduleAsyncWork:M},"*")}}return A=>setTimeout(A)})();var w;(function(A){A[A.Windows=1]="Windows",A[A.Macintosh=2]="Macintosh",A[A.Linux=3]="Linux"})(w||(e.OperatingSystem=w={})),e.OS=P||I?w.Macintosh:h?w.Windows:w.Linux;let y=!0,D=!1;function S(){if(!D){D=!0;const A=new Uint8Array(2);A[0]=1,A[1]=2,y=new Uint16Array(A.buffer)[0]===513}return y}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function C(A){return parseFloat(A)>=20}}),define(ye[56],Se([1,0,11]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gc=e.$fc=e.env=e.cwd=void 0;let h;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const O=P.process;h={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return r.$i?"win32":r.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.$fc=h.platform,e.$gc=h.arch}),define(ye[17],Se([1,0,56]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.sep=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=void 0,r=We(r);const h=65,P=97,O=90,T=122,R=46,$=47,a=92,I=58,E=63;class l extends Error{constructor(s,f,u){let w;typeof f=="string"&&f.indexOf("not ")===0?(w="must not be",f=f.replace(/^not /,"")):w="must be";const y=s.indexOf(".")!==-1?"property":"argument";let D=`The "${s}" ${y} ${w} of type ${f}`;D+=`. Received type ${typeof u}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function k(i,s){if(i===null||typeof i!="object")throw new l(s,"Object",i)}function p(i,s){if(typeof i!="string")throw new l(s,"string",i)}const c=r.$fc==="win32";function m(i){return i===$||i===a}function d(i){return i===$}function g(i){return i>=h&&i<=O||i>=P&&i<=T}function n(i,s,f,u){let w="",y=0,D=-1,S=0,C=0;for(let A=0;A<=i.length;++A){if(A<i.length)C=i.charCodeAt(A);else{if(u(C))break;C=$}if(u(C)){if(!(D===A-1||S===1))if(S===2){if(w.length<2||y!==2||w.charCodeAt(w.length-1)!==R||w.charCodeAt(w.length-2)!==R){if(w.length>2){const b=w.lastIndexOf(f);b===-1?(w="",y=0):(w=w.slice(0,b),y=w.length-1-w.lastIndexOf(f)),D=A,S=0;continue}else if(w.length!==0){w="",y=0,D=A,S=0;continue}}s&&(w+=w.length>0?`${f}..`:"..",y=2)}else w.length>0?w+=`${f}${i.slice(D+1,A)}`:w=i.slice(D+1,A),y=A-D-1;D=A,S=0}else C===R&&S!==-1?++S:S=-1}return w}function o(i,s){k(s,"pathObject");const f=s.dir||s.root,u=s.base||`${s.name||""}${s.ext||""}`;return f?f===s.root?`${f}${u}`:`${f}${i}${u}`:u}e.$hc={resolve(...i){let s="",f="",u=!1;for(let w=i.length-1;w>=-1;w--){let y;if(w>=0){if(y=i[w],p(y,"path"),y.length===0)continue}else s.length===0?y=r.cwd():(y=r.env[`=${s}`]||r.cwd(),(y===void 0||y.slice(0,2).toLowerCase()!==s.toLowerCase()&&y.charCodeAt(2)===a)&&(y=`${s}\\`));const D=y.length;let S=0,C="",A=!1;const b=y.charCodeAt(0);if(D===1)m(b)&&(S=1,A=!0);else if(m(b))if(A=!0,m(y.charCodeAt(1))){let v=2,M=v;for(;v<D&&!m(y.charCodeAt(v));)v++;if(v<D&&v!==M){const N=y.slice(M,v);for(M=v;v<D&&m(y.charCodeAt(v));)v++;if(v<D&&v!==M){for(M=v;v<D&&!m(y.charCodeAt(v));)v++;(v===D||v!==M)&&(C=`\\\\${N}\\${y.slice(M,v)}`,S=v)}}}else S=1;else g(b)&&y.charCodeAt(1)===I&&(C=y.slice(0,2),S=2,D>2&&m(y.charCodeAt(2))&&(A=!0,S=3));if(C.length>0)if(s.length>0){if(C.toLowerCase()!==s.toLowerCase())continue}else s=C;if(u){if(s.length>0)break}else if(f=`${y.slice(S)}\\${f}`,u=A,A&&s.length>0)break}return f=n(f,!u,"\\",m),u?`${s}\\${f}`:`${s}${f}`||"."},normalize(i){p(i,"path");const s=i.length;if(s===0)return".";let f=0,u,w=!1;const y=i.charCodeAt(0);if(s===1)return d(y)?"\\":i;if(m(y))if(w=!0,m(i.charCodeAt(1))){let S=2,C=S;for(;S<s&&!m(i.charCodeAt(S));)S++;if(S<s&&S!==C){const A=i.slice(C,S);for(C=S;S<s&&m(i.charCodeAt(S));)S++;if(S<s&&S!==C){for(C=S;S<s&&!m(i.charCodeAt(S));)S++;if(S===s)return`\\\\${A}\\${i.slice(C)}\\`;S!==C&&(u=`\\\\${A}\\${i.slice(C,S)}`,f=S)}}}else f=1;else g(y)&&i.charCodeAt(1)===I&&(u=i.slice(0,2),f=2,s>2&&m(i.charCodeAt(2))&&(w=!0,f=3));let D=f<s?n(i.slice(f),!w,"\\",m):"";return D.length===0&&!w&&(D="."),D.length>0&&m(i.charCodeAt(s-1))&&(D+="\\"),u===void 0?w?`\\${D}`:D:w?`${u}\\${D}`:`${u}${D}`},isAbsolute(i){p(i,"path");const s=i.length;if(s===0)return!1;const f=i.charCodeAt(0);return m(f)||s>2&&g(f)&&i.charCodeAt(1)===I&&m(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,f;for(let y=0;y<i.length;++y){const D=i[y];p(D,"path"),D.length>0&&(s===void 0?s=f=D:s+=`\\${D}`)}if(s===void 0)return".";let u=!0,w=0;if(typeof f=="string"&&m(f.charCodeAt(0))){++w;const y=f.length;y>1&&m(f.charCodeAt(1))&&(++w,y>2&&(m(f.charCodeAt(2))?++w:u=!1))}if(u){for(;w<s.length&&m(s.charCodeAt(w));)w++;w>=2&&(s=`\\${s.slice(w)}`)}return e.$hc.normalize(s)},relative(i,s){if(p(i,"from"),p(s,"to"),i===s)return"";const f=e.$hc.resolve(i),u=e.$hc.resolve(s);if(f===u||(i=f.toLowerCase(),s=u.toLowerCase(),i===s))return"";let w=0;for(;w<i.length&&i.charCodeAt(w)===a;)w++;let y=i.length;for(;y-1>w&&i.charCodeAt(y-1)===a;)y--;const D=y-w;let S=0;for(;S<s.length&&s.charCodeAt(S)===a;)S++;let C=s.length;for(;C-1>S&&s.charCodeAt(C-1)===a;)C--;const A=C-S,b=D<A?D:A;let v=-1,M=0;for(;M<b;M++){const L=i.charCodeAt(w+M);if(L!==s.charCodeAt(S+M))break;L===a&&(v=M)}if(M!==b){if(v===-1)return u}else{if(A>b){if(s.charCodeAt(S+M)===a)return u.slice(S+M+1);if(M===2)return u.slice(S+M)}D>b&&(i.charCodeAt(w+M)===a?v=M:M===2&&(v=3)),v===-1&&(v=0)}let N="";for(M=w+v+1;M<=y;++M)(M===y||i.charCodeAt(M)===a)&&(N+=N.length===0?"..":"\\..");return S+=v,N.length>0?`${N}${u.slice(S,C)}`:(u.charCodeAt(S)===a&&++S,u.slice(S,C))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=e.$hc.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===a){if(s.charCodeAt(1)===a){const f=s.charCodeAt(2);if(f!==E&&f!==R)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(g(s.charCodeAt(0))&&s.charCodeAt(1)===I&&s.charCodeAt(2)===a)return`\\\\?\\${s}`;return i},dirname(i){p(i,"path");const s=i.length;if(s===0)return".";let f=-1,u=0;const w=i.charCodeAt(0);if(s===1)return m(w)?i:".";if(m(w)){if(f=u=1,m(i.charCodeAt(1))){let S=2,C=S;for(;S<s&&!m(i.charCodeAt(S));)S++;if(S<s&&S!==C){for(C=S;S<s&&m(i.charCodeAt(S));)S++;if(S<s&&S!==C){for(C=S;S<s&&!m(i.charCodeAt(S));)S++;if(S===s)return i;S!==C&&(f=u=S+1)}}}}else g(w)&&i.charCodeAt(1)===I&&(f=s>2&&m(i.charCodeAt(2))?3:2,u=f);let y=-1,D=!0;for(let S=s-1;S>=u;--S)if(m(i.charCodeAt(S))){if(!D){y=S;break}}else D=!1;if(y===-1){if(f===-1)return".";y=f}return i.slice(0,y)},basename(i,s){s!==void 0&&p(s,"ext"),p(i,"path");let f=0,u=-1,w=!0,y;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===I&&(f=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let D=s.length-1,S=-1;for(y=i.length-1;y>=f;--y){const C=i.charCodeAt(y);if(m(C)){if(!w){f=y+1;break}}else S===-1&&(w=!1,S=y+1),D>=0&&(C===s.charCodeAt(D)?--D===-1&&(u=y):(D=-1,u=S))}return f===u?u=S:u===-1&&(u=i.length),i.slice(f,u)}for(y=i.length-1;y>=f;--y)if(m(i.charCodeAt(y))){if(!w){f=y+1;break}}else u===-1&&(w=!1,u=y+1);return u===-1?"":i.slice(f,u)},extname(i){p(i,"path");let s=0,f=-1,u=0,w=-1,y=!0,D=0;i.length>=2&&i.charCodeAt(1)===I&&g(i.charCodeAt(0))&&(s=u=2);for(let S=i.length-1;S>=s;--S){const C=i.charCodeAt(S);if(m(C)){if(!y){u=S+1;break}continue}w===-1&&(y=!1,w=S+1),C===R?f===-1?f=S:D!==1&&(D=1):f!==-1&&(D=-1)}return f===-1||w===-1||D===0||D===1&&f===w-1&&f===u+1?"":i.slice(f,w)},format:o.bind(null,"\\"),parse(i){p(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const f=i.length;let u=0,w=i.charCodeAt(0);if(f===1)return m(w)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(m(w)){if(u=1,m(i.charCodeAt(1))){let v=2,M=v;for(;v<f&&!m(i.charCodeAt(v));)v++;if(v<f&&v!==M){for(M=v;v<f&&m(i.charCodeAt(v));)v++;if(v<f&&v!==M){for(M=v;v<f&&!m(i.charCodeAt(v));)v++;v===f?u=v:v!==M&&(u=v+1)}}}}else if(g(w)&&i.charCodeAt(1)===I){if(f<=2)return s.root=s.dir=i,s;if(u=2,m(i.charCodeAt(2))){if(f===3)return s.root=s.dir=i,s;u=3}}u>0&&(s.root=i.slice(0,u));let y=-1,D=u,S=-1,C=!0,A=i.length-1,b=0;for(;A>=u;--A){if(w=i.charCodeAt(A),m(w)){if(!C){D=A+1;break}continue}S===-1&&(C=!1,S=A+1),w===R?y===-1?y=A:b!==1&&(b=1):y!==-1&&(b=-1)}return S!==-1&&(y===-1||b===0||b===1&&y===S-1&&y===D+1?s.base=s.name=i.slice(D,S):(s.name=i.slice(D,y),s.base=i.slice(D,S),s.ext=i.slice(y,S))),D>0&&D!==u?s.dir=i.slice(0,D-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(c){const i=/\\/g;return()=>{const s=r.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>r.cwd()})();e.$ic={resolve(...i){let s="",f=!1;for(let u=i.length-1;u>=-1&&!f;u--){const w=u>=0?i[u]:t();p(w,"path"),w.length!==0&&(s=`${w}/${s}`,f=w.charCodeAt(0)===$)}return s=n(s,!f,"/",d),f?`/${s}`:s.length>0?s:"."},normalize(i){if(p(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===$,f=i.charCodeAt(i.length-1)===$;return i=n(i,!s,"/",d),i.length===0?s?"/":f?"./":".":(f&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return p(i,"path"),i.length>0&&i.charCodeAt(0)===$},join(...i){if(i.length===0)return".";let s;for(let f=0;f<i.length;++f){const u=i[f];p(u,"path"),u.length>0&&(s===void 0?s=u:s+=`/${u}`)}return s===void 0?".":e.$ic.normalize(s)},relative(i,s){if(p(i,"from"),p(s,"to"),i===s||(i=e.$ic.resolve(i),s=e.$ic.resolve(s),i===s))return"";const f=1,u=i.length,w=u-f,y=1,D=s.length-y,S=w<D?w:D;let C=-1,A=0;for(;A<S;A++){const v=i.charCodeAt(f+A);if(v!==s.charCodeAt(y+A))break;v===$&&(C=A)}if(A===S)if(D>S){if(s.charCodeAt(y+A)===$)return s.slice(y+A+1);if(A===0)return s.slice(y+A)}else w>S&&(i.charCodeAt(f+A)===$?C=A:A===0&&(C=0));let b="";for(A=f+C+1;A<=u;++A)(A===u||i.charCodeAt(A)===$)&&(b+=b.length===0?"..":"/..");return`${b}${s.slice(y+C)}`},toNamespacedPath(i){return i},dirname(i){if(p(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===$;let f=-1,u=!0;for(let w=i.length-1;w>=1;--w)if(i.charCodeAt(w)===$){if(!u){f=w;break}}else u=!1;return f===-1?s?"/":".":s&&f===1?"//":i.slice(0,f)},basename(i,s){s!==void 0&&p(s,"ext"),p(i,"path");let f=0,u=-1,w=!0,y;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let D=s.length-1,S=-1;for(y=i.length-1;y>=0;--y){const C=i.charCodeAt(y);if(C===$){if(!w){f=y+1;break}}else S===-1&&(w=!1,S=y+1),D>=0&&(C===s.charCodeAt(D)?--D===-1&&(u=y):(D=-1,u=S))}return f===u?u=S:u===-1&&(u=i.length),i.slice(f,u)}for(y=i.length-1;y>=0;--y)if(i.charCodeAt(y)===$){if(!w){f=y+1;break}}else u===-1&&(w=!1,u=y+1);return u===-1?"":i.slice(f,u)},extname(i){p(i,"path");let s=-1,f=0,u=-1,w=!0,y=0;for(let D=i.length-1;D>=0;--D){const S=i.charCodeAt(D);if(S===$){if(!w){f=D+1;break}continue}u===-1&&(w=!1,u=D+1),S===R?s===-1?s=D:y!==1&&(y=1):s!==-1&&(y=-1)}return s===-1||u===-1||y===0||y===1&&s===u-1&&s===f+1?"":i.slice(s,u)},format:o.bind(null,"/"),parse(i){p(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const f=i.charCodeAt(0)===$;let u;f?(s.root="/",u=1):u=0;let w=-1,y=0,D=-1,S=!0,C=i.length-1,A=0;for(;C>=u;--C){const b=i.charCodeAt(C);if(b===$){if(!S){y=C+1;break}continue}D===-1&&(S=!1,D=C+1),b===R?w===-1?w=C:A!==1&&(A=1):w!==-1&&(A=-1)}if(D!==-1){const b=y===0&&f?1:y;w===-1||A===0||A===1&&w===D-1&&w===y+1?s.base=s.name=i.slice(b,D):(s.name=i.slice(b,w),s.base=i.slice(b,D),s.ext=i.slice(w,D))}return y>0?s.dir=i.slice(0,y-1):f&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$ic.win32=e.$hc.win32=e.$hc,e.$ic.posix=e.$hc.posix=e.$ic,e.$jc=c?e.$hc.normalize:e.$ic.normalize,e.$kc=c?e.$hc.isAbsolute:e.$ic.isAbsolute,e.$lc=c?e.$hc.join:e.$ic.join,e.$mc=c?e.$hc.resolve:e.$ic.resolve,e.$nc=c?e.$hc.relative:e.$ic.relative,e.$oc=c?e.$hc.dirname:e.$ic.dirname,e.$pc=c?e.$hc.basename:e.$ic.basename,e.$qc=c?e.$hc.extname:e.$ic.extname,e.$rc=c?e.$hc.format:e.$ic.format,e.$sc=c?e.$hc.parse:e.$ic.parse,e.$tc=c?e.$hc.toNamespacedPath:e.$ic.toNamespacedPath,e.sep=c?e.$hc.sep:e.$ic.sep,e.$vc=c?e.$hc.delimiter:e.$ic.delimiter}),define(ye[140],Se([1,0,49,17]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=R,e.$yr=$,e.$zr=a,e.$Ar=I,e.$Br=E,e.$Cr=l,e.$Dr=k,e.$Er=p,e.$Fr=c,e.$Gr=m,e.$Hr=w,e.$Ir=y,e.$Jr=D;const P=new r.$X(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),O=new r.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new r.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(S,C,A=!1){const b=S||"",v=C||"",M=P.value.collator.compare(b,v);return P.value.collatorIsNumeric&&M===0&&b!==v?b<v?-1:1:M}function $(S,C){const A=O.value.collator;return S=S||"",C=C||"",o(A,S,C)}function a(S,C){const A=O.value.collator;return S=S||"",C=C||"",f(S,C)||o(A,S,C)}function I(S,C){const A=O.value.collator;return S=S||"",C=C||"",s(S,C)||o(A,S,C)}function E(S,C){return S=S||"",C=C||"",S===C?0:S<C?-1:1}function l(S,C){const[A,b]=g(S),[v,M]=g(C);let N=P.value.collator.compare(b,M);if(N===0){if(P.value.collatorIsNumeric&&b!==M)return b<M?-1:1;if(N=P.value.collator.compare(A,v),P.value.collatorIsNumeric&&N===0&&A!==v)return A<v?-1:1}return N}function k(S,C){S=S||"",C=C||"";const A=n(S),b=n(C),v=O.value.collator,M=T.value.collator;return o(M,A,b)||o(v,S,C)}function p(S,C){S=S||"",C=C||"";const A=n(S),b=n(C),v=O.value.collator,M=T.value.collator;return o(M,A,b)||f(S,C)||o(v,S,C)}function c(S,C){S=S||"",C=C||"";const A=n(S),b=n(C),v=O.value.collator,M=T.value.collator;return o(M,A,b)||s(S,C)||o(v,S,C)}function m(S,C){S=S||"",C=C||"";const A=n(S).toLowerCase(),b=n(C).toLowerCase();return A!==b?A<b?-1:1:S!==C?S<C?-1:1:0}const d=/^(.*?)(\.([^.]*))?$/;function g(S,C=!1){const A=S?d.exec(S):[];let b=[A&&A[1]||"",A&&A[3]||""];return C&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function n(S){const C=S?d.exec(S):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function o(S,C,A){const b=S.compare(C,A);return b!==0?b:C.length!==A.length?C.length<A.length?-1:1:0}function t(S){const C=S.charAt(0);return C.toLocaleUpperCase()!==C}function i(S){const C=S.charAt(0);return C.toLocaleLowerCase()!==C}function s(S,C){return t(S)&&i(C)?-1:i(S)&&t(C)?1:0}function f(S,C){return i(S)&&t(C)?-1:t(S)&&i(C)?1:0}function u(S,C,A=!1){return A||(S=S&&S.toLowerCase(),C=C&&C.toLowerCase()),S===C?0:S<C?-1:1}function w(S,C,A=!1){const b=S.split(h.sep),v=C.split(h.sep),M=b.length-1,N=v.length-1;let L,j;for(let z=0;;z++){if(L=M===z,j=N===z,L&&j)return R(b[z],v[z],A);if(L)return-1;if(j)return 1;const F=u(b[z],v[z],A);if(F!==0)return F}}function y(S,C,A){const b=S.toLowerCase(),v=C.toLowerCase(),M=D(S,C,A);if(M)return M;const N=b.endsWith(A),L=v.endsWith(A);if(N!==L)return N?-1:1;const j=R(b,v);return j!==0?j:b.localeCompare(v)}function D(S,C,A){const b=S.toLowerCase(),v=C.toLowerCase(),M=b.startsWith(A),N=v.startsWith(A);if(M!==N)return M?-1:1;if(M&&N){if(b.length<v.length)return-1;if(b.length>v.length)return 1}return 0}}),define(ye[33],Se([1,0,27,17,11,13,18]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=R,e.$yg=$,e.$zg=a,e.$Ag=I,e.$Bg=E,e.$Cg=c,e.$Dg=m,e.$Eg=d,e.$Fg=g,e.$Gg=n,e.$Hg=o,e.$Ig=t,e.$Jg=i,e.$Kg=s,e.$Lg=f,e.$Mg=u,e.$Ng=D;function R(S){return S===r.CharCode.Slash||S===r.CharCode.Backslash}function $(S){return S.replace(/[\\/]/g,h.$ic.sep)}function a(S){return S.indexOf("/")===-1&&(S=$(S)),/^[a-zA-Z]:(\/|$)/.test(S)&&(S="/"+S),S}function I(S,C=h.$ic.sep){if(!S)return"";const A=S.length,b=S.charCodeAt(0);if(R(b)){if(R(S.charCodeAt(1))&&!R(S.charCodeAt(2))){let M=3;const N=M;for(;M<A&&!R(S.charCodeAt(M));M++);if(N!==M&&!R(S.charCodeAt(M+1))){for(M+=1;M<A;M++)if(R(S.charCodeAt(M)))return S.slice(0,M+1).replace(/[\\/]/g,C)}}return C}else if(g(b)&&S.charCodeAt(1)===r.CharCode.Colon)return R(S.charCodeAt(2))?S.slice(0,2)+C:S.slice(0,2);let v=S.indexOf("://");if(v!==-1){for(v+=3;v<A;v++)if(R(S.charCodeAt(v)))return S.slice(0,v+1)}return""}function E(S){if(!P.$i||!S||S.length<5)return!1;let C=S.charCodeAt(0);if(C!==r.CharCode.Backslash||(C=S.charCodeAt(1),C!==r.CharCode.Backslash))return!1;let A=2;const b=A;for(;A<S.length&&(C=S.charCodeAt(A),C!==r.CharCode.Backslash);A++);return!(b===A||(C=S.charCodeAt(A+1),isNaN(C)||C===r.CharCode.Backslash))}const l=/[\\/:\*\?"<>\|]/g,k=/[/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(S,C=P.$i){const A=C?l:k;return!(!S||S.length===0||/^\s+$/.test(S)||(A.lastIndex=0,A.test(S))||C&&p.test(S)||S==="."||S===".."||C&&S[S.length-1]==="."||C&&S.length!==S.trim().length||S.length>255)}function m(S,C,A){const b=S===C;return!A||b?b:!S||!C?!1:(0,O.$Gf)(S,C)}function d(S,C,A,b=h.sep){if(S===C)return!0;if(!S||!C||C.length>S.length)return!1;if(A){if(!(0,O.$Hf)(S,C))return!1;if(C.length===S.length)return!0;let M=C.length;return C.charAt(C.length-1)===b&&M--,S.charAt(M)===b}return C.charAt(C.length-1)!==b&&(C+=b),S.indexOf(C)===0}function g(S){return S>=r.CharCode.A&&S<=r.CharCode.Z||S>=r.CharCode.a&&S<=r.CharCode.z}function n(S,C){return P.$i&&S.endsWith(":")&&(S+=h.sep),(0,h.$kc)(S)||(S=(0,h.$lc)(C,S)),S=(0,h.$jc)(S),o(S)}function o(S){return P.$i?(S=(0,O.$of)(S,h.sep),S.endsWith(":")&&(S+=h.sep)):(S=(0,O.$of)(S,h.sep),S||(S=h.sep)),S}function t(S){const C=(0,h.$jc)(S);return P.$i?S.length>3?!1:i(C)&&(S.length===2||C.charCodeAt(2)===r.CharCode.Backslash):C===h.$ic.sep}function i(S,C=P.$i){return C?g(S.charCodeAt(0))&&S.charCodeAt(1)===r.CharCode.Colon:!1}function s(S,C=P.$i){return i(S,C)?S[0]:void 0}function f(S,C,A){return C.length>S.length?-1:S===C?0:(A&&(S=S.toLowerCase(),C=C.toLowerCase()),S.indexOf(C))}function u(S){const C=S.split(":");let A,b,v;for(const M of C){const N=Number(M);(0,T.$jg)(N)?b===void 0?b=N:v===void 0&&(v=N):A=A?[A,M].join(":"):M}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:b!==void 0?b:void 0,column:v!==void 0?v:b!==void 0?1:void 0}}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",y="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(S,C,A=8){let b="";for(let M=0;M<A;M++){let N;M===0&&P.$i&&!C&&(A===3||A===4)?N=y:N=w,b+=N.charAt(Math.floor(Math.random()*N.length))}let v;return C?v=`${C}-${b}`:v=b,S?(0,h.$lc)(S,v):v}}),define(ye[141],Se([1,0,27,140,135,60,17,11,13]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=E,e.$Lr=d,e.$Mr=u,e.$Nr=b,e.$Or=z,e.$Pr=B;const a=0,I=[a,[]];function E(_,re,U,G){if(!_||!re)return I;const Q=_.length,ee=re.length;if(Q<ee)return I;const he=_.toLowerCase();return l(re,U,ee,_,he,Q,G)}function l(_,re,U,G,Q,ee,he){const ne=[],De=[];for(let se=0;se<U;se++){const ae=se*ee,te=ae-ee,le=se>0,ue=_[se],X=re[se];for(let oe=0;oe<ee;oe++){const pe=oe>0,we=ae+oe,Fe=we-1,Ue=te+oe-1,ke=pe?ne[Fe]:0,Ie=le&&pe?ne[Ue]:0,Oe=le&&pe?De[Ue]:0;let q;!Ie&&le?q=0:q=k(ue,X,G,Q,oe,Oe),q&&Ie+q>=ke&&(he||le||Q.startsWith(re,oe))?(De[we]=Oe+1,ne[we]=Ie+q):(De[we]=a,ne[we]=ke)}}const $e=[];let K=U-1,W=ee-1;for(;K>=0&&W>=0;){const se=K*ee+W;De[se]===a||($e.push(W),K--),W--}return[ne[U*ee-1],$e.reverse()]}function k(_,re,U,G,Q,ee){let he=0;if(!p(re,G[Q]))return he;if(he+=1,ee>0&&(he+=ee*5),_===U[Q]&&(he+=1),Q===0)he+=8;else{const ne=c(U.charCodeAt(Q-1));ne?he+=ne:(0,P.$Kk)(U.charCodeAt(Q))&&ee===0&&(he+=2)}return he}function p(_,re){return _===re?!0:_==="/"||_==="\\"?re==="/"||re==="\\":!1}function c(_){switch(_){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const m=[void 0,[]];function d(_,re,U=0,G=0){const Q=re;return Q.values&&Q.values.length>1?g(_,Q.values,U,G):n(_,re,U,G)}function g(_,re,U,G){let Q=0;const ee=[];for(const he of re){const[ne,De]=n(_,he,U,G);if(typeof ne!="number")return m;Q+=ne,ee.push(...De)}return[Q,C(ee)]}function n(_,re,U,G){const Q=(0,P.$Tk)(re.original,re.originalLowercase,U,_,_.toLowerCase(),G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,P.$Qk)(Q)]:m}const o=Object.freeze({score:0}),t=1<<18,i=1<<17,s=65536;function f(_,re,U,G){const Q=G.values?G.values:[G];return(0,O.$tj)({[G.normalized]:{values:Q.map(he=>({value:he.normalized,expectContiguousMatch:he.expectContiguousMatch})),label:_,description:re,allowNonContiguousMatches:U}})}function u(_,re,U,G,Q){if(!_||!re.normalized)return o;const ee=G.getItemLabel(_);if(!ee)return o;const he=G.getItemDescription(_),ne=f(ee,he,U,re),De=Q[ne];if(De)return De;const $e=w(ee,he,G.getItemPath(_),re,U);return Q[ne]=$e,$e}function w(_,re,U,G,Q){const ee=!U||!G.containsPathSeparator;return U&&(R.$k?G.pathNormalized===U:(0,$.$Gf)(G.pathNormalized,U))?{score:t,labelMatch:[{start:0,end:_.length}],descriptionMatch:re?[{start:0,end:re.length}]:void 0}:G.values&&G.values.length>1?y(_,re,U,G.values,ee,Q):D(_,re,U,G,ee,Q)}function y(_,re,U,G,Q,ee){let he=0;const ne=[],De=[];for(const $e of G){const{score:K,labelMatch:W,descriptionMatch:se}=D(_,re,U,$e,Q,ee);if(K===a)return o;he+=K,W&&ne.push(...W),se&&De.push(...se)}return{score:he,labelMatch:C(ne),descriptionMatch:C(De)}}function D(_,re,U,G,Q,ee){if(Q||!re){const[he,ne]=E(_,G.normalized,G.normalizedLowercase,ee&&!G.expectContiguousMatch);if(he){const De=(0,P.$Hk)(G.normalized,_);let $e;if(De){$e=i;const K=Math.round(G.normalized.length/_.length*100);$e+=K}else $e=s;return{score:$e+he,labelMatch:De||S(ne)}}}if(re){let he=re;U&&(he=`${re}${T.sep}`);const ne=he.length,De=`${he}${_}`,[$e,K]=E(De,G.normalized,G.normalizedLowercase,ee&&!G.expectContiguousMatch);if($e){const W=S(K),se=[],ae=[];return W.forEach(te=>{te.start<ne&&te.end>ne?(se.push({start:0,end:te.end-ne}),ae.push({start:te.start,end:ne})):te.start>=ne?se.push({start:te.start-ne,end:te.end-ne}):ae.push(te)}),{score:$e,labelMatch:se,descriptionMatch:ae}}}return o}function S(_){const re=[];if(!_)return re;let U;for(const G of _)U&&U.end===G?U.end+=1:(U={start:G,end:G+1},re.push(U));return re}function C(_){const re=_.sort((Q,ee)=>Q.start-ee.start),U=[];let G;for(const Q of re)!G||!A(G,Q)?(G=Q,U.push(Q)):(G.start=Math.min(G.start,Q.start),G.end=Math.max(G.end,Q.end));return U}function A(_,re){return!(_.end<re.start||re.end<_.start)}function b(_,re,U,G,Q,ee){const he=u(_,U,G,Q,ee),ne=u(re,U,G,Q,ee),De=he.score,$e=ne.score;if((De===t||$e===t)&&De!==$e)return De===t?-1:1;if(De>s||$e>s){if(De!==$e)return De>$e?-1:1;if(De<i&&$e<i){const ue=M(he.labelMatch,ne.labelMatch);if(ue!==0)return ue}const te=Q.getItemLabel(_)||"",le=Q.getItemLabel(re)||"";if(te.length!==le.length)return te.length-le.length}if(De!==$e)return De>$e?-1:1;const K=Array.isArray(he.labelMatch)&&he.labelMatch.length>0,W=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(K&&!W)return-1;if(W&&!K)return 1;const se=v(_,he,Q),ae=v(re,ne,Q);return se&&ae&&se!==ae?ae>se?-1:1:N(_,re,U,Q)}function v(_,re,U){let G=-1,Q=-1;if(re.descriptionMatch&&re.descriptionMatch.length?G=re.descriptionMatch[0].start:re.labelMatch&&re.labelMatch.length&&(G=re.labelMatch[0].start),re.labelMatch&&re.labelMatch.length){if(Q=re.labelMatch[re.labelMatch.length-1].end,re.descriptionMatch&&re.descriptionMatch.length){const ee=U.getItemDescription(_);ee&&(Q+=ee.length)}}else re.descriptionMatch&&re.descriptionMatch.length&&(Q=re.descriptionMatch[re.descriptionMatch.length-1].end);return Q-G}function M(_,re){if(!_&&!re||(!_||!_.length)&&(!re||!re.length))return 0;if(!re||!re.length)return-1;if(!_||!_.length)return 1;const U=_[0].start,Q=_[_.length-1].end-U,ee=re[0].start,ne=re[re.length-1].end-ee;return Q===ne?0:ne<Q?1:-1}function N(_,re,U,G){const Q=G.getItemLabel(_)||"",ee=G.getItemLabel(re)||"",he=G.getItemDescription(_),ne=G.getItemDescription(re),De=Q.length+(he?he.length:0),$e=ee.length+(ne?ne.length:0);if(De!==$e)return De-$e;const K=G.getItemPath(_),W=G.getItemPath(re);return K&&W&&K.length!==W.length?K.length-W.length:Q!==ee?(0,h.$Ir)(Q,ee,U.normalized):he&&ne&&he!==ne?(0,h.$Ir)(he,ne,U.normalized):K&&W&&K!==W?(0,h.$Ir)(K,W,U.normalized):0}function L(_){return _.startsWith('"')&&_.endsWith('"')}const j=" ";function z(_){typeof _!="string"&&(_="");const re=_.toLowerCase(),{pathNormalized:U,normalized:G,normalizedLowercase:Q}=F(_),ee=U.indexOf(T.sep)>=0,he=L(_);let ne;const De=_.split(j);if(De.length>1)for(const $e of De){const K=L($e),{pathNormalized:W,normalized:se,normalizedLowercase:ae}=F($e);se&&(ne||(ne=[]),ne.push({original:$e,originalLowercase:$e.toLowerCase(),pathNormalized:W,normalized:se,normalizedLowercase:ae,expectContiguousMatch:K}))}return{original:_,originalLowercase:re,pathNormalized:U,normalized:G,normalizedLowercase:Q,values:ne,containsPathSeparator:ee,expectContiguousMatch:he}}function F(_){let re;R.$i?re=_.replace(/\//g,T.sep):re=_.replace(/\\/g,T.sep);const U=(0,$.$qf)(re).replace(/\s|"/g,"");return{pathNormalized:re,normalized:U,normalizedLowercase:U.toLowerCase()}}function B(_){return Array.isArray(_)?z(_.map(re=>re.original).join(j)):z(_.original)}}),define(ye[108],Se([1,0,17]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0,e.$9s=O,e.$0s=T,e.$$s=R,e.$_s=a,e.$8s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(I){const E=(0,r.$qc)(I),l=h[E.toLowerCase()];return l!==void 0?l:T(I)}function T(I){const E=(0,r.$qc)(I);return P[E.toLowerCase()]}function R(I){for(const E in P)if(P[E]===I)return E}const $=/^(.+)\/(.+?)(;.+)?$/;function a(I,E){const l=$.exec(I);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:E?void 0:I}}),define(ye[109],Se([1,0,11]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$km=O,e.$lm=T;var h;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(h||(e.Source=h={}));var P;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function O(R,...$){const a=$.reduce((l,k)=>(l[k]=!0,l),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(l=>!a[l]).forEach(l=>{for(let k=0;k<I.length;k++)if(l.search(I[k])!==-1){delete R[l];break}})}function T(R){R&&(delete R.DEBUG,r.$j&&delete R.DYLD_LIBRARY_PATH,r.$k&&delete R.LD_PRELOAD)}}),define(ye[2],Se([1,0,27,41,17,11]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$xc=m,e.$yc=i,P=We(P);const T=/^\w[\w\d+.-]*$/,R=/^\//,$=/^\/\//;function a(y,D){if(!y.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${y.authority}", path: "${y.path}", query: "${y.query}", fragment: "${y.fragment}"}`);if(y.scheme&&!T.test(y.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(y.path){if(y.authority){if(!R.test(y.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if($.test(y.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(y,D){return!y&&!D?"file":y}function E(y,D){switch(y){case"https":case"http":case"file":D?D[0]!==k&&(D=k+D):D=k;break}return D}const l="",k="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(D){return D instanceof c?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,S,C,A,b,v=!1){typeof D=="object"?(this.scheme=D.scheme||l,this.authority=D.authority||l,this.path=D.path||l,this.query=D.query||l,this.fragment=D.fragment||l):(this.scheme=I(D,v),this.authority=S||l,this.path=E(this.scheme,C||l),this.query=A||l,this.fragment=b||l,a(this,v))}get fsPath(){return i(this,!1)}with(D){if(!D)return this;let{scheme:S,authority:C,path:A,query:b,fragment:v}=D;return S===void 0?S=this.scheme:S===null&&(S=l),C===void 0?C=this.authority:C===null&&(C=l),A===void 0?A=this.path:A===null&&(A=l),b===void 0?b=this.query:b===null&&(b=l),v===void 0?v=this.fragment:v===null&&(v=l),S===this.scheme&&C===this.authority&&A===this.path&&b===this.query&&v===this.fragment?this:new g(S,C,A,b,v)}static parse(D,S=!1){const C=p.exec(D);return C?new g(C[2]||l,w(C[4]||l),w(C[5]||l),w(C[7]||l),w(C[9]||l),S):new g(l,l,l,l,l)}static file(D){let S=l;if(O.$i&&(D=D.replace(/\\/g,k)),D[0]===k&&D[1]===k){const C=D.indexOf(k,2);C===-1?(S=D.substring(2),D=k):(S=D.substring(2,C),D=D.substring(C)||k)}return new g("file",S,D,l,l)}static from(D,S){return new g(D.scheme,D.authority,D.path,D.query,D.fragment,S)}static joinPath(D,...S){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return O.$i&&D.scheme==="file"?C=c.file(P.$hc.join(i(D,!0),...S)).path:C=P.$ic.join(D.path,...S),D.with({path:C})}toString(D=!1){return s(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof c)return D;{const S=new g(D);return S._formatted=D.external??null,S._fsPath=D._sep===d?D.fsPath??null:null,S}}else return D}}e.URI=c;function m(y){return!y||typeof y!="object"?!1:typeof y.scheme=="string"&&(typeof y.authority=="string"||typeof y.authority>"u")&&(typeof y.path=="string"||typeof y.path>"u")&&(typeof y.query=="string"||typeof y.query>"u")&&(typeof y.fragment=="string"||typeof y.fragment>"u")}const d=O.$i?1:void 0;class g extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(D=!1){return D?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const D={$mid:h.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=d),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const n={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function o(y,D,S){let C,A=-1;for(let b=0;b<y.length;b++){const v=y.charCodeAt(b);if(v>=r.CharCode.a&&v<=r.CharCode.z||v>=r.CharCode.A&&v<=r.CharCode.Z||v>=r.CharCode.Digit0&&v<=r.CharCode.Digit9||v===r.CharCode.Dash||v===r.CharCode.Period||v===r.CharCode.Underline||v===r.CharCode.Tilde||D&&v===r.CharCode.Slash||S&&v===r.CharCode.OpenSquareBracket||S&&v===r.CharCode.CloseSquareBracket||S&&v===r.CharCode.Colon)A!==-1&&(C+=encodeURIComponent(y.substring(A,b)),A=-1),C!==void 0&&(C+=y.charAt(b));else{C===void 0&&(C=y.substr(0,b));const M=n[v];M!==void 0?(A!==-1&&(C+=encodeURIComponent(y.substring(A,b)),A=-1),C+=M):A===-1&&(A=b)}}return A!==-1&&(C+=encodeURIComponent(y.substring(A))),C!==void 0?C:y}function t(y){let D;for(let S=0;S<y.length;S++){const C=y.charCodeAt(S);C===r.CharCode.Hash||C===r.CharCode.QuestionMark?(D===void 0&&(D=y.substr(0,S)),D+=n[C]):D!==void 0&&(D+=y[S])}return D!==void 0?D:y}function i(y,D){let S;return y.authority&&y.path.length>1&&y.scheme==="file"?S=`//${y.authority}${y.path}`:y.path.charCodeAt(0)===r.CharCode.Slash&&(y.path.charCodeAt(1)>=r.CharCode.A&&y.path.charCodeAt(1)<=r.CharCode.Z||y.path.charCodeAt(1)>=r.CharCode.a&&y.path.charCodeAt(1)<=r.CharCode.z)&&y.path.charCodeAt(2)===r.CharCode.Colon?D?S=y.path.substr(1):S=y.path[1].toLowerCase()+y.path.substr(2):S=y.path,O.$i&&(S=S.replace(/\//g,"\\")),S}function s(y,D){const S=D?t:o;let C="",{scheme:A,authority:b,path:v,query:M,fragment:N}=y;if(A&&(C+=A,C+=":"),(b||A==="file")&&(C+=k,C+=k),b){let L=b.indexOf("@");if(L!==-1){const j=b.substr(0,L);b=b.substr(L+1),L=j.lastIndexOf(":"),L===-1?C+=S(j,!1,!1):(C+=S(j.substr(0,L),!1,!1),C+=":",C+=S(j.substr(L+1),!1,!0)),C+="@"}b=b.toLowerCase(),L=b.lastIndexOf(":"),L===-1?C+=S(b,!1,!0):(C+=S(b.substr(0,L),!1,!0),C+=b.substr(L))}if(v){if(v.length>=3&&v.charCodeAt(0)===r.CharCode.Slash&&v.charCodeAt(2)===r.CharCode.Colon){const L=v.charCodeAt(1);L>=r.CharCode.A&&L<=r.CharCode.Z&&(v=`/${String.fromCharCode(L+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===r.CharCode.Colon){const L=v.charCodeAt(0);L>=r.CharCode.A&&L<=r.CharCode.Z&&(v=`${String.fromCharCode(L+32)}:${v.substr(2)}`)}C+=S(v,!0,!1)}return M&&(C+="?",C+=S(M,!1,!1)),N&&(C+="#",C+=D?N:o(N,!1,!1)),C}function f(y){try{return decodeURIComponent(y)}catch{return y.length>3?y.substr(0,3)+f(y.substr(3)):y}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function w(y){return y.match(u)?y.replace(u,D=>f(D)):y}}),define(ye[207],Se([1,0,2]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=h,e.$br=P,e.$cr=O,e.log=R;function h(a){const I=a;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function P(a){const I=[];let E;try{const l=JSON.parse(a.arguments),k=l[l.length-1];k&&k.__$stack&&(l.pop(),E=k.__$stack),I.push(...l)}catch{I.push("Unable to log remote console arguments",a.arguments)}return{args:I,stack:E}}function O(a){if(typeof a!="string")return O(P(a).stack);const I=a;if(I){const E=T(I),l=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(l&&l.length===4)return{uri:r.URI.file(l[1]),line:Number(l[2]),column:Number(l[3])}}}function T(a){if(!a)return a;const I=a.indexOf(`
`);return I===-1?a:a.substring(0,I)}function R(a,I){const{args:E,stack:l}=P(a),k=typeof E[0]=="string"&&E.length===1;let p=T(l);p&&(p=`(${p.trim()})`);let c=[];if(typeof E[0]=="string"?p&&k?c=[`%c[${I}] %c${E[0]} %c${p}`,$("blue"),$(""),$("grey")]:c=[`%c[${I}] %c${E[0]}`,$("blue"),$(""),...E.slice(1)]:c=[`%c[${I}]%`,$("blue"),...E],p&&!k&&c.push(p),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,c)}function $(a){return`color: ${a}`}}),define(ye[57],Se([1,0,22,2,41]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=O,e.$bi=T,e.$ci=$;function O(a){return JSON.stringify(a,R)}function T(a){let I=JSON.parse(a);return I=$(I),I}function R(a,I){return I instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function $(a,I=0){if(!a||I>200)return a;if(typeof a=="object"){switch(a.$mid){case P.MarshalledId.Uri:return h.URI.revive(a);case P.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case P.MarshalledId.Date:return new Date(a.source)}if(a instanceof r.$Oe||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let E=0;E<a.length;++E)a[E]=$(a[E],I+1);else for(const E in a)Object.hasOwnProperty.call(a,E)&&(a[E]=$(a[E],I+1))}return a}}),define(ye[15],Se([1,0,14,11,13,2,17]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=$,e.$Pg=a,e.$Tg=E,r=We(r),h=We(h),T=We(T);var R;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatCodeBlock="vscode-chat-code-block",p.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",p.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm",p.commentsInput="comment",p.codeSetting="code-setting"})(R||(e.Schemas=R={}));function $(p,c){return O.URI.isUri(p)?(0,P.$Gf)(p.scheme,c):(0,P.$Hf)(p,c+":")}function a(p,...c){return c.some(m=>$(p,m))}e.$Qg="vscode-tkn",e.$Rg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,m){this.f=E(c,m)}getServerRootPath(){return this.f}get g(){return T.$ic.join(this.f,R.vscodeRemoteResource)}set(c,m,d){this.a[c]=m,this.b[c]=d}setConnectionToken(c,m){this.c[c]=m}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(t){return r.$3(t),c}const m=c.authority;let d=this.a[m];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const g=this.b[m],n=this.c[m];let o=`path=${encodeURIComponent(c.path)}`;return typeof n=="string"&&(o+=`&${e.$Rg}=${encodeURIComponent(n)}`),O.URI.from({scheme:h.$o?this.d:R.vscodeRemoteResource,authority:`${d}:${g}`,path:this.g,query:o})}}e.$Sg=new I;function E(p,c){return T.$ic.join(c??"/",`${p.quality??"oss"}-${p.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class l{static{this.a=e.$Yg}asBrowserUri(c){const m=this.b(c,ce);return this.uriToBrowserUri(m)}uriToBrowserUri(c){return c.scheme===R.vscodeRemote?e.$Sg.rewrite(c):c.scheme===R.file&&(h.$m||h.$q===`${R.vscodeFileResource}://${l.a}`)?c.with({scheme:R.vscodeFileResource,authority:c.authority||l.a,query:null,fragment:null}):c}asFileUri(c){const m=this.b(c,ce);return this.uriToFileUri(m)}uriToFileUri(c){return c.scheme===R.vscodeFileResource?c.with({scheme:R.file,authority:c.authority!==l.a?c.authority:null,query:null,fragment:null}):c}b(c,m){return O.URI.isUri(c)?c:O.URI.parse(m.toUrl(c))}}e.$Zg=new l;var k;(function(p){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(c.get("3"));const m="vscode-coi";function d(n){let o;typeof n=="string"?o=new URL(n).searchParams:n instanceof URL?o=n.searchParams:O.URI.isUri(n)&&(o=new URL(n.toString(!0)).searchParams);const t=o?.get(m);if(t)return c.get(t)}p.getHeadersFromQuery=d;function g(n,o,t){if(!globalThis.crossOriginIsolated)return;const i=o&&t?"3":t?"2":"1";n instanceof URLSearchParams?n.set(m,i):n[m]=i}p.addSearchParam=g})(k||(e.COI=k={}))}),define(ye[208],Se([1,0,174,15,11,2]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sE=I,P=We(P);class T{constructor(l,k,p){this.id=l,this.dependencies=k,this.callback=p}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(l,k,p)=>{typeof l!="string"&&(p=k,k=l,l=null),(typeof k!="object"||!Array.isArray(k))&&(p=k,k=null),this.c.push(new T(l,k,p))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){if(l.startsWith(window.location.origin)||l.startsWith("vscode-file://vscode-app"))return l;throw new Error(`[trusted_script_src] Invalid script url: ${l}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){return l}})))}async load(l){this.g();const k=await(this.a?this.i(l):this.b?this.h(l):this.j(l));if(!k)throw new Error(`Did not receive a define call from script ${l}`);if(Array.isArray(k.dependencies)&&k.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${l}. The dependencies are: ${k.dependencies.join(", ")}`);return typeof k.callback=="function"?k.callback([]):k.callback}h(l){return new Promise((k,p)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const m=()=>{c.removeEventListener("load",d),c.removeEventListener("error",g)},d=n=>{m(),k(this.c.pop())},g=n=>{m(),p(n)};c.addEventListener("load",d),c.addEventListener("error",g),this.f&&(l=this.f.createScriptURL(l)),c.setAttribute("src",l),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(l){return new Promise((k,p)=>{try{this.f&&(l=this.f.createScriptURL(l)),importScripts(l),k(this.c.pop())}catch(c){p(c)}})}async j(l){try{const k=globalThis._VSCODE_NODE_MODULES.fs,p=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,m=O.URI.parse(l).fsPath,d=k.readFileSync(m).toString(),g=c.wrap(d.replace(/^#!.*/,""));return new p.Script(g).runInThisContext().apply(),this.c.pop()}catch(k){throw k}}}const $=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function I(E,l,k){if(r.$V){k===void 0&&(k=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[E]&&(E=a[E]);const p=`${E}/${l}`;if($.has(p))return $.get(p);let c;if(/^\w[\w\d+.-]*:\/\//.test(p))c=p;else{const n=`${k&&!P.$o?h.$Wg:h.$Vg}/${p}`;c=h.$Zg.asBrowserUri(n).toString(!0)}const m=R.INSTANCE.load(c);return $.set(p,m),m}else return await new Promise((p,c)=>{ce([E],p,c)}).then(We)}}),define(ye[23],Se([1,0,27,33,15,17,11,13,2]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=a,e.$ph=E,e.$qh=k,h=We(h),O=We(O);function a(p){return(0,$.$yc)(p,!0)}class I{constructor(c){this.a=c}compare(c,m,d=!1){return c===m?0:(0,R.$zf)(this.getComparisonKey(c,d),this.getComparisonKey(m,d))}isEqual(c,m,d=!1){return c===m?!0:!c||!m?!1:this.getComparisonKey(c,d)===this.getComparisonKey(m,d)}getComparisonKey(c,m=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,m,d=!1){if(c.scheme===m.scheme){if(c.scheme===P.Schemas.file)return h.$Eg(a(c),a(m),this.a(c))&&c.query===m.query&&(d||c.fragment===m.fragment);if((0,e.$lh)(c.authority,m.authority))return h.$Eg(c.path,m.path,this.a(c),"/")&&c.query===m.query&&(d||c.fragment===m.fragment)}return!1}joinPath(c,...m){return $.URI.joinPath(c,...m)}basenameOrAuthority(c){return(0,e.$dh)(c)||c.authority}basename(c){return O.$ic.basename(c.path)}extname(c){return O.$ic.extname(c.path)}dirname(c){if(c.path.length===0)return c;let m;return c.scheme===P.Schemas.file?m=$.URI.file(O.$oc(a(c))).path:(m=O.$ic.dirname(c.path),c.authority&&m.length&&m.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${c.toString})) resulted in a relative path`),m="/")),c.with({path:m})}normalizePath(c){if(!c.path.length)return c;let m;return c.scheme===P.Schemas.file?m=$.URI.file(O.$jc(a(c))).path:m=O.$ic.normalize(c.path),c.with({path:m})}relativePath(c,m){if(c.scheme!==m.scheme||!(0,e.$lh)(c.authority,m.authority))return;if(c.scheme===P.Schemas.file){const n=O.$nc(a(c),a(m));return T.$i?h.$yg(n):n}let d=c.path||"/";const g=m.path||"/";if(this.a(c)){let n=0;for(const o=Math.min(d.length,g.length);n<o&&!(d.charCodeAt(n)!==g.charCodeAt(n)&&d.charAt(n).toLowerCase()!==g.charAt(n).toLowerCase());n++);d=g.substr(0,n)+d.substr(n)}return O.$ic.relative(d,g)}resolvePath(c,m){if(c.scheme===P.Schemas.file){const d=$.URI.file(O.$mc(a(c),m));return c.with({authority:d.authority,path:d.path})}return m=h.$zg(m),c.with({path:O.$ic.resolve(c.path,m)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,m){return c===m||c!==void 0&&m!==void 0&&(0,R.$Gf)(c,m)}hasTrailingPathSeparator(c,m=O.sep){if(c.scheme===P.Schemas.file){const d=a(c);return d.length>h.$Ag(d).length&&d[d.length-1]===m}else{const d=c.path;return d.length>1&&d.charCodeAt(d.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,m=O.sep){return(0,e.$mh)(c,m)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,m=O.sep){let d=!1;if(c.scheme===P.Schemas.file){const g=a(c);d=g!==void 0&&g.length===h.$Ag(g).length&&g[g.length-1]===m}else{m="/";const g=c.path;d=g.length===1&&g.charCodeAt(g.length-1)===r.CharCode.Slash}return!d&&!(0,e.$mh)(c,m)?c.with({path:c.path+"/"}):c}}e.$8g=I,e.$9g=new I(()=>!1),e.$0g=new I(p=>p.scheme===P.Schemas.file?!T.$k:!0),e.$$g=new I(p=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function E(p,c){const m=[];for(let d=0;d<p.length;d++){const g=c(p[d]);p.some((n,o)=>o===d?!1:(0,e.$ah)(g,c(n)))||m.push(p[d])}return m}var l;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function c(m){const d=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(o=>{const[t,i]=o.split(":");t&&i&&d.set(t,i)});const n=m.path.substring(0,m.path.indexOf(";"));return n&&d.set(p.META_DATA_MIME,n),d}p.parseMetaData=c})(l||(e.DataUri=l={}));function k(p,c,m){if(c){let d=p.path;return d&&d[0]!==O.$ic.sep&&(d=O.$ic.sep+d),p.with({scheme:m,authority:c,path:d})}return p.with({scheme:m})}}),define(ye[9],Se([1,0,21,14,4,3,23,11,185,49]),function(ce,e,r,h,P,O,T,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=I,e.$sh=E,e.$th=l,e.$uh=k,e.$vh=p,e.$wh=c,e.$xh=m,e.$yh=d,e.$Gh=y,e.$Hh=D,e.$Ih=S,e.$Jh=C,e.$Kh=A,e.$Zh=G,e.$8h=te;function I(ue){return!!ue&&typeof ue.then=="function"}function E(ue){const X=new r.$xe,oe=ue(X.token),pe=new Promise((we,Fe)=>{const Ue=X.token.onCancellationRequested(()=>{Ue.dispose(),Fe(new h.$7)});Promise.resolve(oe).then(ke=>{Ue.dispose(),X.dispose(),we(ke)},ke=>{Ue.dispose(),X.dispose(),Fe(ke)})});return new class{cancel(){X.cancel(),X.dispose()}then(we,Fe){return pe.then(we,Fe)}catch(we){return this.then(void 0,we)}finally(we){return pe.finally(we)}}}function l(ue,X,oe){return new Promise((pe,we)=>{const Fe=X.onCancellationRequested(()=>{Fe.dispose(),pe(oe)});ue.then(pe,we).finally(()=>Fe.dispose())})}function k(ue,X){return new Promise((oe,pe)=>{const we=X.onCancellationRequested(()=>{we.dispose(),pe(new h.$7)});ue.then(oe,pe).finally(()=>we.dispose())})}async function p(ue){let X=-1;const oe=ue.map((pe,we)=>pe.then(Fe=>(X=we,Fe)));try{return await Promise.race(oe)}finally{ue.forEach((pe,we)=>{we!==X&&pe.cancel()})}}function c(ue,X,oe){let pe;const we=setTimeout(()=>{pe?.(void 0),oe?.()},X);return Promise.race([ue.finally(()=>clearTimeout(we)),new Promise(Fe=>pe=Fe)])}function m(ue){return new Promise((X,oe)=>{const pe=ue();I(pe)?pe.then(X,oe):X(pe)})}function d(){let ue,X;return{promise:new Promise((pe,we)=>{ue=pe,X=we}),resolve:ue,reject:X}}class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const oe=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(oe,oe).then(pe)})}return new Promise((oe,pe)=>{this.b.then(oe,pe)})}return this.a=X(),new Promise((oe,pe)=>{this.a.then(we=>{this.a=null,oe(we)},we=>{this.a=null,pe(we)})})}dispose(){this.f=!0}}e.$zh=g;class n{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$Ah=n;class o{constructor(){this.a=new Map}queue(X,oe){const we=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.a.get(X)===we&&this.a.delete(X)});return this.a.set(X,we),we}}e.$Bh=o;const t=(ue,X)=>{let oe=!0;const pe=setTimeout(()=>{oe=!1,X()},ue);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(pe),oe=!1}}},i=ue=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,ue())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class s{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,oe=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((we,Fe)=>{this.d=we,this.f=Fe}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=oe===$.$he?i(pe):t(oe,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new h.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=s;class f{constructor(X){this.a=new s(X),this.b=new g}trigger(X,oe){return this.a.trigger(()=>this.b.queue(X),oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=f;class u{constructor(){this.a=!1,this.b=new Promise((X,oe)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=u;class w extends u{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Fh=w;function y(ue,X){return X?new Promise((oe,pe)=>{const we=setTimeout(()=>{Fe.dispose(),oe()},ue),Fe=X.onCancellationRequested(()=>{clearTimeout(we),Fe.dispose(),pe(new h.$7)})}):E(oe=>y(ue,oe))}function D(ue,X=0,oe){const pe=setTimeout(()=>{ue(),oe&&we.dispose()},X),we=(0,O.$Uc)(()=>{clearTimeout(pe),oe?.deleteAndLeak(we)});return oe?.add(we),we}function S(ue){const X=[];let oe=0;const pe=ue.length;function we(){return oe<pe?ue[oe++]():null}function Fe(Ue){Ue!=null&&X.push(Ue);const ke=we();return ke?ke.then(Fe):Promise.resolve(X)}return Promise.resolve(null).then(Fe)}function C(ue,X=pe=>!!pe,oe=null){let pe=0;const we=ue.length,Fe=()=>{if(pe>=we)return Promise.resolve(oe);const Ue=ue[pe++];return Promise.resolve(Ue()).then(Ie=>X(Ie)?Promise.resolve(Ie):Fe())};return Fe()}function A(ue,X=pe=>!!pe,oe=null){if(ue.length===0)return Promise.resolve(oe);let pe=ue.length;const we=()=>{pe=-1;for(const Fe of ue)Fe.cancel?.()};return new Promise((Fe,Ue)=>{for(const ke of ue)ke.then(Ie=>{--pe>=0&&X(Ie)?(we(),Fe(Ie)):pe===0&&Fe(oe)}).catch(Ie=>{--pe>=0&&(we(),Ue(Ie))})})}class b{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new P.$me}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((oe,pe)=>{this.g.push({factory:X,c:oe,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const oe=X.factory();oe.then(X.c,X.e),oe.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=b;class v extends b{constructor(){super(1)}}e.$Mh=v;class M{constructor(){this.a=new Q,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Nh=M;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new ne;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,oe=T.$9g){const pe=oe.getComparisonKey(X);return this.a.get(pe)?.size??0}queueFor(X,oe,pe=T.$9g){const we=pe.getComparisonKey(X);let Fe=this.a.get(we);if(!Fe){Fe=new v;const Ue=this.f++,ke=P.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(Ue),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$6c),this.d.set(Ue,ke),this.a.set(we,Fe)}return Fe.queue(oe)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=N;class L{constructor(X,oe){this.b=!1,this.a=-1,typeof X=="function"&&typeof oe=="number"&&this.setIfNotSet(X,oe)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,oe){if(this.b)throw new h.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},oe)}setIfNotSet(X,oe){if(this.b)throw new h.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},oe))}}e.$Ph=L;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,oe,pe=globalThis){if(this.f)throw new h.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const we=pe.setInterval(()=>{X()},oe);this.d=(0,O.$Uc)(()=>{pe.clearInterval(we),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=j;class z{constructor(X,oe){this.b=-1,this.a=X,this.d=oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=z;class F{constructor(X,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.a=X,this.b=oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=F;class B extends z{constructor(X,oe){super(X,oe),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Th=B;class _ extends O.$Wc{constructor(X,oe){super(),this.g=X,this.h=oe,this.a=[],this.b=this.B(new O.$Xc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const oe of X)this.a.push(oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=_,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(ue,X)=>{(0,R.$B)(()=>{if(oe)return;const pe=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e.$Wh=(ue,X,oe)=>{const pe=ue.requestIdleCallback(X,typeof oe=="number"?{timeout:oe}:void 0);let we=!1;return{dispose(){we||(we=!0,ue.cancelIdleCallback(pe))}}},e.$Vh=ue=>(0,e.$Wh)(globalThis,ue)}();class re{constructor(X,oe){this.g=!1,this.d=()=>{try{this.j=oe()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Wh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=re;class U extends re{constructor(X){super(globalThis,X)}}e.$Yh=U;async function G(ue,X,oe){let pe;for(let we=0;we<oe;we++)try{return await ue()}catch(Fe){pe=Fe,await y(X)}throw pe}class Q{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,oe,pe){return this.a={taskId:X,cancel:()=>pe?.(),promise:oe},oe.then(()=>this.d(X),()=>this.d(X)),oe}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:oe,resolve:pe,reject:we}=d();this.b={run:X,promise:oe,promiseResolve:pe,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=Q;class ee{constructor(X,oe=()=>Date.now()){this.d=X,this.f=oe,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$2h=ee;var he;(function(ue){ue[ue.Resolved=0]="Resolved",ue[ue.Rejected=1]="Rejected"})(he||(he={}));class ne{get isRejected(){return this.d?.outcome===he.Rejected}get isResolved(){return this.d?.outcome===he.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===he.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,oe)=>{this.a=X,this.b=oe})}complete(X){return new Promise(oe=>{this.a(X),this.d={outcome:he.Resolved,value:X},oe()})}error(X){return new Promise(oe=>{this.b(X),this.d={outcome:he.Rejected,value:X},oe()})}cancel(){return this.error(new h.$7)}}e.$3h=ne;var De;(function(ue){async function X(pe){let we;const Fe=await Promise.all(pe.map(Ue=>Ue.then(ke=>ke,ke=>{we||(we=ke)})));if(typeof we<"u")throw we;return Fe}ue.settled=X;function oe(pe){return new Promise(async(we,Fe)=>{try{await pe(we,Fe)}catch(Ue){Fe(Ue)}})}ue.withAsyncBody=oe})(De||(e.Promises=De={}));class $e{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(oe=>(this.a=oe,this.d=!0,oe),oe=>{throw this.b=oe,this.d=!0,oe})}requireValue(){if(!this.d)throw new h.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=$e;class K{constructor(X){this.b=X,this.a=new a.$X(()=>new $e(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=K;var W;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(W||(W={}));class se{static fromArray(X){return new se(oe=>{oe.emitMany(X)})}static fromPromise(X){return new se(async oe=>{oe.emitMany(await X)})}static fromPromises(X){return new se(async oe=>{await Promise.all(X.map(async pe=>oe.emitOne(await pe)))})}static merge(X){return new se(async oe=>{await Promise.all(X.map(async pe=>{for await(const we of pe)oe.emitOne(we)}))})}static{this.EMPTY=se.fromArray([])}constructor(X,oe){this.a=W.Initial,this.b=[],this.d=null,this.f=oe,this.g=new P.$me,queueMicrotask(async()=>{const pe={emitOne:we=>this.h(we),emitMany:we=>this.j(we),reject:we=>this.l(we)};try{await Promise.resolve(X(pe)),this.k()}catch(we){this.l(we)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===W.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===W.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,oe){return new se(async pe=>{for await(const we of X)pe.emitOne(oe(we))})}map(X){return se.map(this,X)}static filter(X,oe){return new se(async pe=>{for await(const we of X)oe(we)&&pe.emitOne(we)})}filter(X){return se.filter(this,X)}static coalesce(X){return se.filter(X,oe=>!!oe)}coalesce(){return se.coalesce(this)}static async toPromise(X){const oe=[];for await(const pe of X)oe.push(pe);return oe}toPromise(){return se.toPromise(this)}h(X){this.a===W.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===W.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===W.Initial&&(this.a=W.DoneOK,this.g.fire())}l(X){this.a===W.Initial&&(this.a=W.DoneError,this.d=X,this.g.fire())}}e.$6h=se;class ae extends se{constructor(X,oe){super(oe),this.m=X}cancel(){this.m.cancel()}}e.$7h=ae;function te(ue){const X=new r.$xe,oe=ue(X.token);return new ae(X,async pe=>{const we=X.token.onCancellationRequested(()=>{we.dispose(),X.dispose(),pe.reject(new h.$7)});try{for await(const Fe of oe){if(X.token.isCancellationRequested)return;pe.emitOne(Fe)}we.dispose(),X.dispose()}catch(Fe){we.dispose(),X.dispose(),pe.reject(Fe)}})}class le{constructor(X){this.a=new ne,this.b=new se(we=>{if(oe){we.reject(oe);return}return pe&&we.emitMany(pe),this.d=Fe=>we.reject(Fe),this.f=Fe=>we.emitOne(Fe),this.a.p},X);let oe,pe;this.f=we=>{pe||(pe=[]),pe.push(we)},this.d=we=>{oe||(oe=we)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$9h=le}),define(ye[39],Se([1,0,19,9,27,33,29,17,11,13]),function(ce,e,r,h,P,O,T,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=I,e.$xk=c,e.$yk=M,e.$zk=N,e.$Ak=L,e.$Bk=j,e.$Ck=z,e.$Dk=re;function I(){return Object.create(null)}e.$vk="**",e.$wk="/";const E="[/\\\\]",l="[^/\\\\]",k=/\//g;function p(U,G){switch(U){case 0:return"";case 1:return`${l}*?`;default:return`(?:${E}|${l}+${E}${G?`|${E}${l}+`:""})*?`}}function c(U,G){if(!U)return[];const Q=[];let ee=!1,he=!1,ne="";for(const De of U){switch(De){case G:if(!ee&&!he){Q.push(ne),ne="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":he=!0;break;case"]":he=!1;break}ne+=De}return ne&&Q.push(ne),Q}function m(U){if(!U)return"";let G="";const Q=c(U,e.$wk);if(Q.every(ee=>ee===e.$vk))G=".*";else{let ee=!1;Q.forEach((he,ne)=>{if(he===e.$vk){if(ee)return;G+=p(2,ne===Q.length-1)}else{let De=!1,$e="",K=!1,W="";for(const se of he){if(se!=="}"&&De){$e+=se;continue}if(K&&(se!=="]"||!W)){let ae;se==="-"?ae=se:(se==="^"||se==="!")&&!W?ae="^":se===e.$wk?ae="":ae=(0,a.$if)(se),W+=ae;continue}switch(se){case"{":De=!0;continue;case"[":K=!0;continue;case"}":{const te=`(?:${c($e,",").map(le=>m(le)).join("|")})`;G+=te,De=!1,$e="";break}case"]":{G+="["+W+"]",K=!1,W="";break}case"?":G+=l;continue;case"*":G+=p(1);continue;default:G+=(0,a.$if)(se)}}ne<Q.length-1&&(Q[ne+1]!==e.$vk||ne+2<Q.length)&&(G+=E)}ee=he===e.$vk})}return G}const d=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new T.$Fc(1e4),f=function(){return!1},u=function(){return null};function w(U,G){if(!U)return u;let Q;typeof U!="string"?Q=U.pattern:Q=U,Q=Q.trim();const ee=`${Q}_${!!G.trimForExclusions}`;let he=s.get(ee);if(he)return y(he,U);let ne;return d.test(Q)?he=S(Q.substr(4),Q):(ne=g.exec(D(Q,G)))?he=C(ne[1],Q):(G.trimForExclusions?o:n).test(Q)?he=A(Q,G):(ne=t.exec(D(Q,G)))?he=b(ne[1].substr(1),Q,!0):(ne=i.exec(D(Q,G)))?he=b(ne[1],Q,!1):he=v(Q),s.set(ee,he),y(he,U)}function y(U,G){if(typeof G=="string")return U;const Q=function(ee,he){return(0,O.$Eg)(ee,G.base,!$.$k)?U((0,a.$nf)(ee.substr(G.base.length),R.sep),he):null};return Q.allBasenames=U.allBasenames,Q.allPaths=U.allPaths,Q.basenames=U.basenames,Q.patterns=U.patterns,Q}function D(U,G){return G.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function S(U,G){return function(Q,ee){return typeof Q=="string"&&Q.endsWith(U)?G:null}}function C(U,G){const Q=`/${U}`,ee=`\\${U}`,he=function(De,$e){return typeof De!="string"?null:$e?$e===U?G:null:De===U||De.endsWith(Q)||De.endsWith(ee)?G:null},ne=[U];return he.basenames=ne,he.patterns=[G],he.allBasenames=ne,he}function A(U,G){const Q=_(U.slice(1,-1).split(",").map($e=>w($e,G)).filter($e=>$e!==u),U),ee=Q.length;if(!ee)return u;if(ee===1)return Q[0];const he=function($e,K){for(let W=0,se=Q.length;W<se;W++)if(Q[W]($e,K))return U;return null},ne=Q.find($e=>!!$e.allBasenames);ne&&(he.allBasenames=ne.allBasenames);const De=Q.reduce(($e,K)=>K.allPaths?$e.concat(K.allPaths):$e,[]);return De.length&&(he.allPaths=De),he}function b(U,G,Q){const ee=R.sep===R.$ic.sep,he=ee?U:U.replace(k,R.sep),ne=R.sep+he,De=R.$ic.sep+U;let $e;return Q?$e=function(K,W){return typeof K=="string"&&(K===he||K.endsWith(ne)||!ee&&(K===U||K.endsWith(De)))?G:null}:$e=function(K,W){return typeof K=="string"&&(K===he||!ee&&K===U)?G:null},$e.allPaths=[(Q?"*/":"./")+U],$e}function v(U){try{const G=new RegExp(`^${m(U)}$`);return function(Q){return G.lastIndex=0,typeof Q=="string"&&G.test(Q)?U:null}}catch{return u}}function M(U,G,Q){return!U||typeof G!="string"?!1:N(U)(G,void 0,Q)}function N(U,G={}){if(!U)return f;if(typeof U=="string"||L(U)){const Q=w(U,G);if(Q===u)return f;const ee=function(he,ne){return!!Q(he,ne)};return Q.allBasenames&&(ee.allBasenames=Q.allBasenames),Q.allPaths&&(ee.allPaths=Q.allPaths),ee}return F(U,G)}function L(U){const G=U;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}function j(U){return U.allBasenames||[]}function z(U){return U.allPaths||[]}function F(U,G){const Q=_(Object.getOwnPropertyNames(U).map($e=>B($e,U[$e],G)).filter($e=>$e!==u)),ee=Q.length;if(!ee)return u;if(!Q.some($e=>!!$e.requiresSiblings)){if(ee===1)return Q[0];const $e=function(se,ae){let te;for(let le=0,ue=Q.length;le<ue;le++){const X=Q[le](se,ae);if(typeof X=="string")return X;(0,h.$rh)(X)&&(te||(te=[]),te.push(X))}return te?(async()=>{for(const le of te){const ue=await le;if(typeof ue=="string")return ue}return null})():null},K=Q.find(se=>!!se.allBasenames);K&&($e.allBasenames=K.allBasenames);const W=Q.reduce((se,ae)=>ae.allPaths?se.concat(ae.allPaths):se,[]);return W.length&&($e.allPaths=W),$e}const he=function($e,K,W){let se,ae;for(let te=0,le=Q.length;te<le;te++){const ue=Q[te];ue.requiresSiblings&&W&&(K||(K=(0,R.$pc)($e)),se||(se=K.substr(0,K.length-(0,R.$qc)($e).length)));const X=ue($e,K,se,W);if(typeof X=="string")return X;(0,h.$rh)(X)&&(ae||(ae=[]),ae.push(X))}return ae?(async()=>{for(const te of ae){const le=await te;if(typeof le=="string")return le}return null})():null},ne=Q.find($e=>!!$e.allBasenames);ne&&(he.allBasenames=ne.allBasenames);const De=Q.reduce(($e,K)=>K.allPaths?$e.concat(K.allPaths):$e,[]);return De.length&&(he.allPaths=De),he}function B(U,G,Q){if(G===!1)return u;const ee=w(U,Q);if(ee===u)return u;if(typeof G=="boolean")return ee;if(G){const he=G.when;if(typeof he=="string"){const ne=(De,$e,K,W)=>{if(!W||!ee(De,$e))return null;const se=he.replace("$(basename)",()=>K),ae=W(se);return(0,h.$rh)(ae)?ae.then(te=>te?U:null):ae?U:null};return ne.requiresSiblings=!0,ne}}return ee}function _(U,G){const Q=U.filter($e=>!!$e.basenames);if(Q.length<2)return U;const ee=Q.reduce(($e,K)=>{const W=K.basenames;return W?$e.concat(W):$e},[]);let he;if(G){he=[];for(let $e=0,K=ee.length;$e<K;$e++)he.push(G)}else he=Q.reduce(($e,K)=>{const W=K.patterns;return W?$e.concat(W):$e},[]);const ne=function($e,K){if(typeof $e!="string")return null;if(!K){let se;for(se=$e.length;se>0;se--){const ae=$e.charCodeAt(se-1);if(ae===P.CharCode.Slash||ae===P.CharCode.Backslash)break}K=$e.substr(se)}const W=ee.indexOf(K);return W!==-1?he[W]:null};ne.basenames=ee,ne.patterns=he,ne.allBasenames=ee;const De=U.filter($e=>!$e.basenames);return De.push(ne),De}function re(U,G){return(0,r.$wb)(U,G,(Q,ee)=>typeof Q=="string"&&typeof ee=="string"?Q===ee:typeof Q!="string"&&typeof ee!="string"?Q.base===ee.base&&Q.pattern===ee.pattern:!1)}}),define(ye[86],Se([1,0,14,136,23,13,2]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.MarkdownStringTextNewlineStyle=void 0,e.$4k=a,e.$5k=I,e.$6k=E,e.$7k=l,e.$8k=k,e.$9k=p,e.$0k=c,e.$$k=m;var R;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(R||(e.MarkdownStringTextNewlineStyle=R={}));class ${constructor(g="",n=!1){if(this.value=g,typeof this.value!="string")throw(0,r.$9)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(g,n=R.Paragraph){return this.value+=l(this.supportThemeIcons?(0,h.$Wk)(g):g).replace(/([ \t]+)/g,(o,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===R.Break?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,n){return this.value+=`
${k(n,g)}
`,this}appendLink(g,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(g),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(g,n){const o=new RegExp((0,O.$if)(n),"g");return g.replace(o,(t,i)=>g.charAt(i-1)!=="\\"?`\\${t}`:t)}}e.$3k=$;function a(d){return I(d)?!d.value:Array.isArray(d)?d.every(a):!0}function I(d){return d instanceof $?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}function E(d,g){return d===g?!0:!d||!g?!1:d.value===g.value&&d.isTrusted===g.isTrusted&&d.supportThemeIcons===g.supportThemeIcons&&d.supportHtml===g.supportHtml&&(d.baseUri===g.baseUri||!!d.baseUri&&!!g.baseUri&&(0,P.$_g)(T.URI.from(d.baseUri),T.URI.from(g.baseUri)))}function l(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function k(d,g){const n=d.match(/^`+/gm)?.reduce((t,i)=>t.length>i.length?t:i).length??0,o=n>=3?n+1:3;return[`${"`".repeat(o)}${g}`,d,`${"`".repeat(o)}`].join(`
`)}function p(d){return d.replace(/"/g,"&quot;")}function c(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(d){const g=[],n=d.split("|").map(t=>t.trim());d=n[0];const o=n[1];if(o){const t=/height=(\d+)/.exec(o),i=/width=(\d+)/.exec(o),s=t?t[1]:"",f=i?i[1]:"",u=isFinite(parseInt(f)),w=isFinite(parseInt(s));u&&g.push(`width="${f}"`),w&&g.push(`height="${s}"`)}return{href:d,dimensions:g}}}),define(ye[110],Se([1,0,19,33,17,11,23,13]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vw=$,e.$Ww=I,e.$Xw=l,e.$Yw=k,e.$Zw=d,e.$1w=n,e.$2w=o,e.$3w=t,e.$4w=i,e.$5w=s;function $(u,w){const{os:y,tildify:D,relative:S}=w;if(S){const b=a(u,S,y);if(typeof b=="string")return b}let C=u.fsPath;if(y===O.OperatingSystem.Windows&&!O.$i?C=C.replace(/\//g,"\\"):y!==O.OperatingSystem.Windows&&O.$i&&(C=C.replace(/\\/g,"/")),y!==O.OperatingSystem.Windows&&D?.userHome){const b=D.userHome.fsPath;let v;u.scheme!==D.userHome.scheme&&u.path[0]===P.$ic.sep&&u.path[1]!==P.$ic.sep?v=D.userHome.with({path:u.path}).fsPath:v=C,C=l(v,b,y)}return(y===O.OperatingSystem.Windows?P.$hc:P.$ic).normalize(I(C,y===O.OperatingSystem.Windows))}function a(u,w,y){const D=y===O.OperatingSystem.Windows?P.$hc:P.$ic,S=y===O.OperatingSystem.Linux?T.$9g:T.$$g,C=w.getWorkspace(),A=(0,r.$Qb)(C.folders);if(!A)return;u.scheme!==A.uri.scheme&&u.path[0]===P.$ic.sep&&u.path[1]!==P.$ic.sep&&(u=A.uri.with({path:u.path}));const b=w.getWorkspaceFolder(u);if(!b)return;let v;if(S.isEqual(b.uri,u)?v="":v=S.relativePath(b.uri,u)??"",v&&(v=D.normalize(v)),C.folders.length>1&&!w.noPrefix){const M=b.name?b.name:S.basenameOrAuthority(b.uri);v=v?`${M} \u2022 ${v}`:M}return v}function I(u,w=O.$i){return(0,h.$Jg)(u,w)?u.charAt(0).toUpperCase()+u.slice(1):u}let E=Object.create(null);function l(u,w,y=O.OS){if(y===O.OperatingSystem.Windows||!u||!w)return u;let D=E.original===w?E.normalized:void 0;D||(D=w,O.$i&&(D=(0,h.$yg)(D)),D=`${(0,R.$of)(D,P.$ic.sep)}${P.$ic.sep}`,E={original:w,normalized:D});let S=u;return O.$i&&(S=(0,h.$yg)(S)),(y===O.OperatingSystem.Linux?S.startsWith(D):(0,R.$Hf)(S,D))?`~/${S.substr(D.length)}`:u}function k(u,w){return u.replace(/^~($|\/|\\)/,`${w}$1`)}const p="\u2026",c="\\\\",m="~";function d(u,w=P.sep){const y=new Array(u.length);let D=!1;for(let S=0;S<u.length;S++){const C=u[S];if(C===""){y[S]=`.${w}`;continue}if(!C){y[S]=C;continue}D=!0;let A="",b=C;b.indexOf(c)===0?(A=b.substr(0,b.indexOf(c)+c.length),b=b.substr(b.indexOf(c)+c.length)):b.indexOf(w)===0?(A=b.substr(0,b.indexOf(w)+w.length),b=b.substr(b.indexOf(w)+w.length)):b.indexOf(m)===0&&(A=b.substr(0,b.indexOf(m)+m.length),b=b.substr(b.indexOf(m)+m.length));const v=b.split(w);for(let M=1;D&&M<=v.length;M++)for(let N=v.length-M;D&&N>=0;N--){D=!1;let L=v.slice(N,N+M).join(w);for(let j=0;!D&&j<u.length;j++)if(j!==S&&u[j]&&u[j].indexOf(L)>-1){const z=N+M===v.length,F=N>0&&u[j].indexOf(w)>-1?w+L:L,B=u[j].endsWith(F);D=!z||B}if(!D){let j="";(v[0].endsWith(":")||A!=="")&&(N===1&&(N=0,M++,L=v[0]+w+L),N>0&&(j=v[0]+w),j=A+j),N>0&&(j=j+p+w),j=j+L,N+M<v.length&&(j=j+w+p),y[S]=j}}D&&(y[S]=C)}return y}var g;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function n(u,w=Object.create(null)){const y=[];let D=!1,S="";for(const C of u)if(C==="$"||D&&C==="{")S&&y.push({value:S,type:g.TEXT}),S="",D=!0;else if(C==="}"&&D){const A=w[S];if(typeof A=="string")A.length&&y.push({value:A,type:g.VARIABLE});else if(A){const b=y[y.length-1];(!b||b.type!==g.SEPARATOR)&&y.push({value:A.label,type:g.SEPARATOR})}S="",D=!1}else S+=C;return S&&!D&&y.push({value:S,type:g.TEXT}),y.filter((C,A)=>{if(C.type===g.SEPARATOR){const b=y[A-1],v=y[A+1];return[b,v].every(M=>M&&(M.type===g.VARIABLE||M.type===g.TEXT)&&M.value.length>0)}return!0}).map(C=>C.value).join("")}function o(u,w){return O.$j||w?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):u.replace(/&&|&/g,y=>y==="&"?"&&":"&")}function t(u,w){return O.$j||w?u.replace(/\(&&\w\)|&&/g,""):O.$i?u.replace(/&&|&/g,y=>y==="&"?"&&":"&"):u.replace(/&&/g,"_")}function i(u){return u.replace(/&/g,"&&")}function s(u){if(u.endsWith("]")){const w=u.lastIndexOf(" [",u.length-2);if(w!==-1){const y=f(u.substring(0,w)),D=u.substring(w);return{name:y.name+D,parentPath:y.parentPath}}}return f(u)}function f(u){const w=u.indexOf("/")!==-1?P.$ic:P.$hc,y=w.basename(u),D=w.dirname(u);return y.length?{name:y,parentPath:D}:{name:D,parentPath:""}}}),define(ye[142],Se([1,0,22,41,2]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=void 0,e.$Nn=$,e.$On=I,e.$Pn=E;function O(l){return l.toJSON()}class T{constructor(k){this.a=k}transformIncoming(k){const p=this.a.transformIncoming(k);return p===k?k:O(P.URI.from(p))}transformOutgoing(k){const p=this.a.transformOutgoing(k);return p===k?k:O(P.URI.from(p))}transformOutgoingURI(k){const p=this.a.transformOutgoing(k);return p===k?k:P.URI.from(p)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$Ln=T,e.$Mn=new class{transformIncoming(l){return l}transformOutgoing(l){return l}transformOutgoingURI(l){return l}transformOutgoingScheme(l){return l}};function R(l,k,p){if(!l||p>200)return null;if(typeof l=="object"){if(l instanceof P.URI)return k.transformOutgoing(l);for(const c in l)if(Object.hasOwnProperty.call(l,c)){const m=R(l[c],k,p+1);m!==null&&(l[c]=m)}}return null}function $(l,k){const p=R(l,k,0);return p===null?l:p}function a(l,k,p,c){if(!l||c>200)return null;if(typeof l=="object"){if(l.$mid===h.MarshalledId.Uri)return p?P.URI.revive(k.transformIncoming(l)):k.transformIncoming(l);if(l instanceof r.$Oe)return null;for(const m in l)if(Object.hasOwnProperty.call(l,m)){const d=a(l[m],k,p,c+1);d!==null&&(l[m]=d)}}return null}function I(l,k){const p=a(l,k,!1,0);return p===null?l:p}function E(l,k){const p=a(l,k,!0,0);return p===null?l:p}}),define(ye[34],Se([1,0,61,68,411,9,33,82,17,11,23,2]),function(ce,e,r,h,P,O,T,R,$,a,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=n,e.whenDeleted=i,e.configureFlushOnWrite=y,e.writeFileSync=S,r=We(r);var l;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(l||(e.RimRafMode=l={}));async function k(F,B=l.UNLINK,_){if((0,T.$Ig)(F))throw new Error("rimraf - will refuse to recursively delete root");return B===l.UNLINK?c(F):p(F,_)}async function p(F,B=(0,T.$Ng)((0,h.tmpdir)())){try{try{await r.promises.rename(F,B)}catch(_){return _.code==="ENOENT"?void 0:c(F)}c(B).catch(_=>{})}catch(_){if(_.code!=="ENOENT")throw _}}async function c(F){return r.promises.rm(F,{recursive:!0,force:!0,maxRetries:3})}function m(F){if((0,T.$Ig)(F))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}async function d(F,B){return o(await(B?g(F):r.promises.readdir(F)))}async function g(F){try{return await r.promises.readdir(F,{withFileTypes:!0})}catch(re){console.warn("[node.js fs] readdir with filetypes failed with error: ",re)}const B=[],_=await d(F);for(const re of _){let U=!1,G=!1,Q=!1;try{const ee=await e.Promises.lstat((0,$.$lc)(F,re));U=ee.isFile(),G=ee.isDirectory(),Q=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}B.push({name:re,isFile:()=>U,isDirectory:()=>G,isSymbolicLink:()=>Q})}return B}function n(F){return o(r.readdirSync(F))}function o(F){return F.map(B=>typeof B=="string"?a.$j?(0,R.$mm)(B):B:(B.name=a.$j?(0,R.$mm)(B.name):B.name,B))}async function t(F){const B=await d(F),_=[];for(const re of B)await s.existsDirectory((0,$.$lc)(F,re))&&_.push(re);return _}function i(F,B=1e3){return new Promise(_=>{let re=!1;const U=setInterval(()=>{re||(re=!0,r.access(F,G=>{re=!1,G&&(clearInterval(U),_(void 0))}))},B)})}var s;(function(F){async function B(U){let G;try{if(G=await e.Promises.lstat(U),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(U),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(a.$i&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw ee}throw Q}}F.stat=B;async function _(U){try{const{stat:G,symbolicLink:Q}=await F.stat(U);return G.isFile()&&Q?.dangling!==!0}catch{}return!1}F.existsFile=_;async function re(U){try{const{stat:G,symbolicLink:Q}=await F.stat(U);return G.isDirectory()&&Q?.dangling!==!0}catch{}return!1}F.existsDirectory=re})(s||(e.SymlinkSupport=s={}));const f=new O.$Oh;function u(F,B,_){return f.queueFor(E.URI.file(F),()=>{const re=C(_);return new Promise((U,G)=>D(F,B,re,Q=>Q?G(Q):U()))},I.$0g)}let w=!0;function y(F){w=F}function D(F,B,_,re){if(!w)return r.writeFile(F,B,{mode:_.mode,flag:_.flag},re);r.open(F,_.flag,_.mode,(U,G)=>{if(U)return re(U);r.writeFile(G,B,Q=>{if(Q)return r.close(G,()=>re(Q));r.fdatasync(G,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),y(!1)),r.close(G,he=>re(he))))})})}function S(F,B,_){const re=C(_);if(!w)return r.writeFileSync(F,B,{mode:re.mode,flag:re.flag});const U=r.openSync(F,re.flag,re.mode);try{r.writeFileSync(U,B);try{r.fdatasyncSync(U)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),y(!1)}}finally{r.closeSync(U)}}function C(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function A(F,B,_=6e4){if(F!==B)try{a.$i&&typeof _=="number"?await b(F,B,Date.now(),_):await r.promises.rename(F,B)}catch(re){if(F.toLowerCase()!==B.toLowerCase()&&re.code==="EXDEV"||F.endsWith("."))await v(F,B,{preserveSymlinks:!1}),await k(F,l.MOVE);else throw re}}async function b(F,B,_,re,U=0){try{return await r.promises.rename(F,B)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-_>=re)throw console.error(`[node.js fs] rename failed after ${U} retries with error: ${G}`),G;if(U===0){let Q=!1;try{const{stat:ee}=await s.stat(B);ee.isFile()||(Q=!0)}catch{}if(Q)throw G}return await(0,O.$Gh)(Math.min(100,U*10)),b(F,B,_,re,U+1)}}async function v(F,B,_){return N(F,B,{root:{source:F,target:B},options:_,handledSourcePaths:new Set})}const M=511;async function N(F,B,_){if(_.handledSourcePaths.has(F))return;_.handledSourcePaths.add(F);const{stat:re,symbolicLink:U}=await s.stat(F);if(U){if(_.options.preserveSymlinks)try{return await z(F,B,_)}catch{}if(U.dangling)return}return re.isDirectory()?L(F,B,re.mode&M,_):j(F,B,re.mode&M)}async function L(F,B,_,re){await e.Promises.mkdir(B,{recursive:!0,mode:_});const U=await d(F);for(const G of U)await N((0,$.$lc)(F,G),(0,$.$lc)(B,G),re)}async function j(F,B,_){await e.Promises.copyFile(F,B),await e.Promises.chmod(B,_)}async function z(F,B,_){let re=await e.Promises.readlink(F);(0,T.$Eg)(re,_.root.source,!a.$k)&&(re=(0,$.$lc)(_.root.target,re.substr(_.root.source.length+1))),await e.Promises.symlink(re,B)}e.Promises=new class{get access(){return r.promises.access}get stat(){return r.promises.stat}get lstat(){return r.promises.lstat}get utimes(){return r.promises.utimes}get read(){return(F,B,_,re,U)=>new Promise((G,Q)=>{r.read(F,B,_,re,U,(ee,he,ne)=>ee?Q(ee):G({bytesRead:he,buffer:ne}))})}get readFile(){return r.promises.readFile}get write(){return(F,B,_,re,U)=>new Promise((G,Q)=>{r.write(F,B,_,re,U,(ee,he,ne)=>ee?Q(ee):G({bytesWritten:he,buffer:ne}))})}get appendFile(){return r.promises.appendFile}get fdatasync(){return(0,P.promisify)(r.fdatasync)}get truncate(){return r.promises.truncate}get copyFile(){return r.promises.copyFile}get open(){return(0,P.promisify)(r.open)}get close(){return(0,P.promisify)(r.close)}get symlink(){return r.promises.symlink}get readlink(){return r.promises.readlink}get chmod(){return r.promises.chmod}get mkdir(){return r.promises.mkdir}get unlink(){return r.promises.unlink}get rmdir(){return r.promises.rmdir}get realpath(){return(0,P.promisify)(r.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return k}get rename(){return A}get copy(){return v}}}),define(ye[111],Se([1,0,61,17,11,13,34]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=R,e.$jr=$,e.$kr=a,e.$lr=I,r=We(r);function R(l){if(P.$k)return l;const k=(0,h.$oc)(l);if(l===k)return l;const p=((0,h.$pc)(l)||l).toLowerCase();try{const m=(0,T.readdirSync)(k).filter(d=>d.toLowerCase()===p);if(m.length===1){const d=R(k);if(d)return(0,h.$lc)(d,m[0])}else if(m.length>1){const d=m.indexOf(p);if(d>=0){const g=R(k);if(g)return(0,h.$lc)(g,m[d])}}}catch{}return null}async function $(l,k){if(P.$k)return l;const p=(0,h.$oc)(l);if(l===p)return l;const c=((0,h.$pc)(l)||l).toLowerCase();try{if(k?.isCancellationRequested)return null;const d=(await T.Promises.readdir(p)).filter(g=>g.toLowerCase()===c);if(d.length===1){const g=await $(p,k);if(g)return(0,h.$lc)(g,d[0])}else if(d.length>1){const g=d.indexOf(c);if(g>=0){const n=await $(p,k);if(n)return(0,h.$lc)(n,d[g])}}}catch{}return null}async function a(l){try{return await T.Promises.realpath(l)}catch{const p=E(l);return await T.Promises.access(p,r.constants.R_OK),p}}function I(l){try{return r.realpathSync(l)}catch{const p=E(l);return r.accessSync(p,r.constants.R_OK),p}}function E(l){return(0,O.$of)((0,h.$jc)(l),h.sep)}}),define(ye[112],Se([1,0,17,11,56,109,18,34]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$xm=$,e.$ym=a,r=We(r),h=We(h),P=We(P),T=We(T),R=We(R),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function $(E=P.env){return E.comspec||"cmd.exe"}function a(E){let l=[],k=!1;const p=function(c){if(k){l.push(c);return}(!E.send(c,d=>{if(d&&console.error(d),k=!1,l.length>0){const g=l.slice(0);l=[],g.forEach(n=>p(n))}})||h.$i)&&(k=!0)};return{send:p}}var I;(function(E){async function l(k,p,c){if(r.$kc(k))return k;if(p===void 0&&(p=P.cwd()),r.$oc(k)!=="."||(c===void 0&&T.$fg(P.env.PATH)&&(c=P.env.PATH.split(r.$vc)),c===void 0||c.length===0))return r.$lc(p,k);async function d(g){if(await R.Promises.exists(g)){let n;try{n=await R.Promises.stat(g)}catch(o){o.message.startsWith("EACCES")&&(n=await R.Promises.lstat(g))}return n?!n.isDirectory():!1}return!1}for(const g of c){let n;if(r.$kc(g)?n=r.$lc(g,k):n=r.$lc(p,g,k),await d(n))return n;let o=n+".com";if(await d(o)||(o=n+".exe",await d(o)))return o}return r.$lc(p,k)}E.findExecutable=l})(I||(e.win32=I={}))});var Je=this&&this.__decorate||function(ce,e,r,h){var P=arguments.length,O=P<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,r):h,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ce,e,r,h);else for(var R=ce.length-1;R>=0;R--)(T=ce[R])&&(O=(P<3?T(O):P>3?T(e,r,O):T(e,r))||O);return P>3&&O&&Object.defineProperty(e,r,O),O};define(ye[87],Se([1,0,19,9,22,21,59,14,4,3,57,13,18]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=y,e.$gi=D,e.$li=M,e.$mi=N,E=We(E);var k;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(k||(k={}));function p(U){switch(U){case k.Promise:return"req";case k.PromiseCancel:return"cancel";case k.EventListen:return"subscribe";case k.EventDispose:return"unsubscribe"}}var c;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(c||(c={}));function m(U){switch(U){case c.Initialize:return"init";case c.PromiseSuccess:return"reply:";case c.PromiseError:case c.PromiseErrorObj:return"replyErr:";case c.EventFire:return"event:"}}var d;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(d||(d={}));function g(U){let G=0;for(let Q=0;;Q+=7){const ee=U.read(1);if(G|=(ee.buffer[0]&127)<<Q,!(ee.buffer[0]&128))return G}}const n=f(0);function o(U,G){if(G===0){U.write(n);return}let Q=0;for(let he=G;he!==0;he=he>>>7)Q++;const ee=P.$Oe.alloc(Q);for(let he=0;G!==0;he++)ee.buffer[he]=G&127,G=G>>>7,G>0&&(ee.buffer[he]|=128);U.write(ee)}class t{constructor(G){this.b=G,this.a=0}read(G){const Q=this.b.slice(this.a,this.a+G);return this.a+=Q.byteLength,Q}}e.$di=t;class i{constructor(){this.a=[]}get buffer(){return P.$Oe.concat(this.a)}write(G){this.a.push(G)}}e.$ei=i;var s;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(s||(s={}));function f(U){const G=P.$Oe.alloc(1);return G.writeUInt8(U,0),G}const u={Undefined:f(s.Undefined),String:f(s.String),Buffer:f(s.Buffer),VSBuffer:f(s.VSBuffer),Array:f(s.Array),Object:f(s.Object),Uint:f(s.Int)},w=typeof Buffer<"u";function y(U,G){if(typeof G>"u")U.write(u.Undefined);else if(typeof G=="string"){const Q=P.$Oe.fromString(G);U.write(u.String),o(U,Q.byteLength),U.write(Q)}else if(w&&Buffer.isBuffer(G)){const Q=P.$Oe.wrap(G);U.write(u.Buffer),o(U,Q.byteLength),U.write(Q)}else if(G instanceof P.$Oe)U.write(u.VSBuffer),o(U,G.byteLength),U.write(G);else if(Array.isArray(G)){U.write(u.Array),o(U,G.length);for(const Q of G)y(U,Q)}else if(typeof G=="number"&&(G|0)===G)U.write(u.Uint),o(U,G);else{const Q=P.$Oe.fromString(JSON.stringify(G));U.write(u.Object),o(U,Q.byteLength),U.write(Q)}}function D(U){switch(U.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return U.read(g(U)).toString();case s.Buffer:return U.read(g(U)).buffer;case s.VSBuffer:return U.read(g(U));case s.Array:{const Q=g(U),ee=[];for(let he=0;he<Q;he++)ee.push(D(U));return ee}case s.Object:return JSON.parse(U.read(g(U)).toString());case s.Int:return g(U)}}class S{constructor(G,Q,ee=null,he=1e3){this.h=G,this.j=Q,this.k=ee,this.l=he,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:c.Initialize})}registerChannel(G,Q){this.b.set(G,Q),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case c.Initialize:{const Q=this.o([G.type]);this.k?.logOutgoing(Q,0,C.OtherSide,m(G.type));return}case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:{const Q=this.o([G.type,G.id],G.data);this.k?.logOutgoing(Q,G.id,C.OtherSide,m(G.type),G.data);return}}}o(G,Q=void 0){const ee=new i;return y(ee,G),y(ee,Q),this.p(ee.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const Q=new t(G),ee=D(Q),he=D(Q),ne=ee[0];switch(ne){case k.Promise:return this.k?.logIncoming(G.byteLength,ee[1],C.OtherSide,`${p(ne)}: ${ee[2]}.${ee[3]}`,he),this.s({type:ne,id:ee[1],channelName:ee[2],name:ee[3],arg:he});case k.EventListen:return this.k?.logIncoming(G.byteLength,ee[1],C.OtherSide,`${p(ne)}: ${ee[2]}.${ee[3]}`,he),this.t({type:ne,id:ee[1],channelName:ee[2],name:ee[3],arg:he});case k.PromiseCancel:return this.k?.logIncoming(G.byteLength,ee[1],C.OtherSide,`${p(ne)}`),this.u({type:ne,id:ee[1]});case k.EventDispose:return this.k?.logIncoming(G.byteLength,ee[1],C.OtherSide,`${p(ne)}`),this.u({type:ne,id:ee[1]})}}s(G){const Q=this.b.get(G.channelName);if(!Q){this.v(G);return}const ee=new O.$xe;let he;try{he=Q.call(this.j,G.name,G.arg,ee.token)}catch($e){he=Promise.reject($e)}const ne=G.id;he.then($e=>{this.m({id:ne,data:$e,type:c.PromiseSuccess})},$e=>{$e instanceof Error?this.m({id:ne,data:{message:$e.message,name:$e.name,stack:$e.stack?$e.stack.split(`
`):void 0},type:c.PromiseError}):this.m({id:ne,data:$e,type:c.PromiseErrorObj})}).finally(()=>{De.dispose(),this.d.delete(G.id)});const De=(0,a.$Uc)(()=>ee.cancel());this.d.set(G.id,De)}t(G){const Q=this.b.get(G.channelName);if(!Q){this.v(G);return}const ee=G.id,ne=Q.listen(this.j,G.name,G.arg)(De=>this.m({id:ee,data:De,type:c.EventFire}));this.d.set(G.id,ne)}u(G){const Q=this.d.get(G.id);Q&&(Q.dispose(),this.d.delete(G.id))}v(G){let Q=this.g.get(G.channelName);Q||(Q=[],this.g.set(G.channelName,Q));const ee=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===k.Promise&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:c.PromiseError})},this.l);Q.push({request:G,timeoutTimer:ee})}w(G){const Q=this.g.get(G);if(Q){for(const ee of Q)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case k.Promise:this.s(ee.request);break;case k.EventListen:this.t(ee.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Rc)(this.d.values()),this.d.clear()}}e.$hi=S;var C;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));class A{constructor(G,Q=null){this.l=G,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=Q}getChannel(G){const Q=this;return{call(ee,he,ne){return Q.a?Promise.reject(new R.$7):Q.m(G,ee,he,ne)},listen(ee,he){return Q.a?$.Event.None:Q.o(G,ee,he)}}}m(G,Q,ee,he=O.CancellationToken.None){const ne=this.g++,De=k.Promise,$e={id:ne,type:De,channelName:G,name:Q,arg:ee};if(he.isCancellationRequested)return Promise.reject(new R.$7);let K;return new Promise((se,ae)=>{if(he.isCancellationRequested)return ae(new R.$7);const te=()=>{const oe=pe=>{switch(pe.type){case c.PromiseSuccess:this.f.delete(ne),se(pe.data);break;case c.PromiseError:{this.f.delete(ne);const we=new Error(pe.data.message);we.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,we.name=pe.data.name,ae(we);break}case c.PromiseErrorObj:this.f.delete(ne),ae(pe.data);break}};this.f.set(ne,oe),this.p($e)};let le=null;this.b===d.Idle?te():(le=(0,h.$sh)(oe=>this.u()),le.then(()=>{le=null,te()}));const ue=()=>{le?(le.cancel(),le=null):this.p({id:ne,type:k.PromiseCancel}),ae(new R.$7)},X=he.onCancellationRequested(ue);K=(0,a.$Tc)((0,a.$Uc)(ue),X),this.d.add(K)}).finally(()=>{K.dispose(),this.d.delete(K)})}o(G,Q,ee){const he=this.g++,ne=k.EventListen,De={id:he,type:ne,channelName:G,name:Q,arg:ee};let $e=null;const K=new $.$me({onWillAddFirstListener:()=>{$e=(0,h.$sh)(se=>this.u()),$e.then(()=>{$e=null,this.d.add(K),this.p(De)})},onDidRemoveLastListener:()=>{$e?($e.cancel(),$e=null):(this.d.delete(K),this.p({id:he,type:k.EventDispose}))}}),W=se=>K.fire(se.data);return this.f.set(he,W),K.event}p(G){switch(G.type){case k.Promise:case k.EventListen:{const Q=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(Q,G.id,C.LocalSide,`${p(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case k.PromiseCancel:case k.EventDispose:{const Q=this.q([G.type,G.id]);this.j?.logOutgoing(Q,G.id,C.LocalSide,p(G.type));return}}}q(G,Q=void 0){const ee=new i;return y(ee,G),y(ee,Q),this.r(ee.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const Q=new t(G),ee=D(Q),he=D(Q),ne=ee[0];switch(ne){case c.Initialize:return this.j?.logIncoming(G.byteLength,0,C.LocalSide,m(ne)),this.t({type:ee[0]});case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:return this.j?.logIncoming(G.byteLength,ee[1],C.LocalSide,m(ne),he),this.t({type:ee[0],id:ee[1],data:he})}}t(G){if(G.type===c.Initialize){this.b=d.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Rc)(this.d.values()),this.d.clear()}}e.$ii=A,Je([T.$0h],A.prototype,"onDidInitializePromise",null);class b{get connections(){const G=[];return this.f.forEach(Q=>G.push(Q)),G}constructor(G,Q,ee){this.a=new Map,this.f=new Set,this.g=new $.$me,this.onDidAddConnection=this.g.event,this.h=new $.$me,this.onDidRemoveConnection=this.h.event,this.j=new a.$Vc,this.j.add(G(({protocol:he,onDidClientDisconnect:ne})=>{const De=$.Event.once(he.onMessage);this.j.add(De($e=>{const K=new t($e),W=D(K),se=new S(he,W,Q,ee),ae=new A(he,Q);this.a.forEach((le,ue)=>se.registerChannel(ue,le));const te={channelServer:se,channelClient:ae,ctx:W};this.f.add(te),this.g.fire(te),this.j.add(ne(()=>{se.dispose(),ae.dispose(),this.f.delete(te),this.h.fire(te)}))}))}))}getChannel(G,Q){const ee=this;return{call(he,ne,De){let $e;if((0,l.$tg)(Q)){const W=(0,r.$5b)(ee.connections.filter(Q));$e=W?Promise.resolve(W):$.Event.toPromise($.Event.filter(ee.onDidAddConnection,Q))}else $e=Q.routeCall(ee,he,ne);const K=$e.then(W=>W.channelClient.getChannel(G));return M(K).call(he,ne,De)},listen(he,ne){if((0,l.$tg)(Q))return ee.k(G,Q,he,ne);const De=Q.routeEvent(ee,he,ne).then($e=>$e.channelClient.getChannel(G));return M(De).listen(he,ne)}}}k(G,Q,ee,he){const ne=this;let De;const $e=new $.$me({onWillAddFirstListener:()=>{De=new a.$Vc;const K=new $.$se,W=new Map,se=te=>{const ue=te.channelClient.getChannel(G).listen(ee,he),X=K.add(ue);W.set(te,X)},ae=te=>{const le=W.get(te);le&&(le.dispose(),W.delete(te))};ne.connections.filter(Q).forEach(se),$.Event.filter(ne.onDidAddConnection,Q)(se,void 0,De),ne.onDidRemoveConnection(ae,void 0,De),K.event($e.fire,$e,De),De.add(K)},onDidRemoveLastListener:()=>{De?.dispose(),De=void 0}});return $e.event}registerChannel(G,Q){this.a.set(G,Q);for(const ee of this.f)ee.channelServer.registerChannel(G,Q)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=b;class v{constructor(G,Q,ee=null){const he=new i;y(he,Q),G.send(he.buffer),this.a=new A(G,ee),this.d=new S(G,Q,ee)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,Q){this.d.registerChannel(G,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=v;function M(U){return{call(G,Q,ee){return U.then(he=>he.call(G,Q,ee))},listen(G,Q){const ee=new $.$ve;return U.then(he=>ee.input=he.listen(G,Q)),ee.event}}}function N(U){let G=!1;return{call(Q,ee,he){return G?U.call(Q,ee,he):(0,h.$Gh)(0).then(()=>G=!0).then(()=>U.call(Q,ee,he))},listen(Q,ee){if(G)return U.listen(Q,ee);const he=new $.$ve;return(0,h.$Gh)(0).then(()=>G=!0).then(()=>he.input=U.listen(Q,ee)),he.event}}}class L{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const Q of G.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await $.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$ni=L;var j;(function(U){function G(ne,De,$e){const K=ne,W=$e&&$e.disableMarshalling,se=new Map;for(const ae in K)ee(ae)&&se.set(ae,$.Event.buffer(K[ae],!0,void 0,De));return new class{listen(ae,te,le){const ue=se.get(te);if(ue)return ue;const X=K[te];if(typeof X=="function"){if(he(te))return X.call(K,le);if(ee(te))return se.set(te,$.Event.buffer(K[te],!0,void 0,De)),se.get(te)}throw new R.$db(`Event not found: ${te}`)}call(ae,te,le){const ue=K[te];if(typeof ue=="function"){if(!W&&Array.isArray(le))for(let oe=0;oe<le.length;oe++)le[oe]=(0,I.$ci)(le[oe]);let X=ue.apply(K,le);return X instanceof Promise||(X=Promise.resolve(X)),X}throw new R.$db(`Method not found: ${te}`)}}}U.fromService=G;function Q(ne,De){const $e=De&&De.disableMarshalling;return new Proxy({},{get(K,W){if(typeof W=="string")return De?.properties?.has(W)?De.properties.get(W):he(W)?function(se){return ne.listen(W,se)}:ee(W)?ne.listen(W):async function(...se){let ae;De&&!(0,l.$og)(De.context)?ae=[De.context,...se]:ae=se;const te=await ne.call(W,ae);return $e?te:(0,I.$ci)(te)};throw new R.$db(`Property not found: ${String(W)}`)}})}U.toService=Q;function ee(ne){return ne[0]==="o"&&ne[1]==="n"&&E.$Ff(ne.charCodeAt(2))}function he(ne){return/^onDynamic/.test(ne)&&E.$Ff(ne.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const G=U.toString();if(G!=="[object Object]")return G}return U}function B(U){return Array.isArray(U)?U.map(F):F(U)}function _(U,G,Q,ee,he,ne,De){De=B(De);const $e=z[he],K=$e[ee%$e.length];let W=[`%c[${U}]%c[${String(G).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${K}`];/\($/.test(ne)?(W=W.concat(De),W.push(")")):W.push(De),console.log.apply(console,W)}class re{constructor(G,Q){this.d=G,this.f=Q,this.a=0,this.b=0}logOutgoing(G,Q,ee,he,ne){this.b+=G,_(this.d,this.b,G,Q,ee,he,ne)}logIncoming(G,Q,ee,he,ne){this.a+=G,_(this.f,this.a,G,Q,ee,he,ne)}}e.$oi=re}),define(ye[69],Se([1,0,22,4,3,87]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.ProtocolConstants=e.$pi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var R;(function(u){u.enableDiagnostics=!1,u.records=[];const w=new WeakMap;let y=0;function D(C,A){if(!w.has(C)){const b=String(++y);w.set(C,b)}return w.get(C)}function S(C,A,b,v){if(!u.enableDiagnostics)return;const M=D(C,A);if(v instanceof r.$Oe||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const N=r.$Oe.alloc(v.byteLength);N.set(v),u.records.push({timestamp:Date.now(),id:M,label:A,type:b,buff:N})}else u.records.push({timestamp:Date.now(),id:M,label:A,type:b,data:v})}u.traceSocketEvent=S})(R||(e.SocketDiagnostics=R={}));var $;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let a=null;function I(){return a||(a=r.$Oe.alloc(0)),a}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(w){this.a.push(w),this.b+=w.byteLength}read(w){return this.c(w,!0)}peek(w){return this.c(w,!1)}c(w,y){if(w===0)return I();if(w>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===w){const A=this.a[0];return y&&(this.a.shift(),this.b-=w),A}if(this.a[0].byteLength>w){const A=this.a[0].slice(0,w);return y&&(this.a[0]=this.a[0].slice(w),this.b-=w),A}const D=r.$Oe.alloc(w);let S=0,C=0;for(;w>0;){const A=this.a[C];if(A.byteLength>w){const b=A.slice(0,w);D.set(b,S),S+=w,y&&(this.a[C]=A.slice(w),this.b-=w),w-=w}else D.set(A,S),S+=A.byteLength,y?(this.a.shift(),this.b-=A.byteLength):C++,w-=A.byteLength}return D}}e.$pi=E;var l;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(l||(l={}));function k(u){switch(u){case l.None:return"None";case l.Regular:return"Regular";case l.Control:return"Control";case l.Ack:return"Ack";case l.Disconnect:return"Disconnect";case l.ReplayRequest:return"ReplayRequest";case l.Pause:return"PauseWriting";case l.Resume:return"ResumeWriting";case l.KeepAlive:return"KeepAlive"}}var p;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",u[u.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(p||(e.ProtocolConstants=p={}));class c{constructor(w,y,D,S){this.type=w,this.id=y,this.ack=D,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends P.$Wc{constructor(w){super(),this.f=this.B(new h.$me),this.onMessage=this.f.event,this.g={readHead:!0,readLen:p.HeaderLength,messageType:l.None,id:0,ack:0},this.a=w,this.b=!1,this.c=new E,this.B(this.a.onData(y=>this.acceptChunk(y))),this.lastReadTime=Date.now()}acceptChunk(w){if(!(!w||w.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(w);this.c.byteLength>=this.g.readLen;){const y=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=y.readUInt32BE(9),this.g.messageType=y.readUInt8(0),this.g.id=y.readUInt32BE(1),this.g.ack=y.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:k(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const D=this.g.messageType,S=this.g.id,C=this.g.ack;if(this.g.readHead=!0,this.g.readLen=p.HeaderLength,this.g.messageType=l.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,y),this.f.fire(new c(D,S,C,y)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(w){this.k=null,this.a=!1,this.b=!1,this.c=w,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(w){if(this.a)return;w.writtenTime=Date.now(),this.lastWriteTime=Date.now();const y=r.$Oe.alloc(p.HeaderLength);y.writeUInt8(w.type,0),y.writeUInt32BE(w.id,1),y.writeUInt32BE(w.ack,5),y.writeUInt32BE(w.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:k(w.type),id:w.id,ack:w.ack,messageSize:w.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,w.data),this.j(y,w.data)}g(w,y){const D=this.f===0;return this.d.push(w,y),this.f+=w.byteLength+y.byteLength,D}h(){const w=r.$Oe.concat(this.d,this.f);return this.d.length=0,this.f=0,w}j(w,y){this.g(w,y)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const w=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:w.byteLength}),this.c.write(w)}}class g extends P.$Wc{constructor(w){super(),this.f=new h.$me,this.onMessage=this.f.event,this.g=new h.$me,this.onDidDispose=this.g.event,this.a=w,this.b=this.B(new d(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(y=>{y.type===l.Regular&&this.f.fire(y.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(w){this.b.write(new c(l.Regular,0,0,w))}}e.$qi=g;class n extends O.$ki{static fromSocket(w,y){return new n(new g(w),y)}get onDidDispose(){return this.b.onDidDispose}constructor(w,y,D=null){super(w,y,D),this.b=w}dispose(){super.dispose();const w=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),w.end()}}e.$ri=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new h.$me({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(w){this.b?this.d.length>0?this.d.push(w):this.a.fire(w):this.d.push(w)}flushBuffer(){this.d=[]}}e.$si=o;class t{constructor(w){this.data=w,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let w=0,y=this.a;for(;y;)y=y.next,w++;return w}peek(){return this.a?this.a.data:null}toArray(){const w=[];let y=0,D=this.a;for(;D;)w[y++]=D.data,D=D.next;return w}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(w){const y=new t(w);if(!this.a){this.a=y,this.b=y;return}this.b.next=y,this.b=y}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const w=Date.now();for(let y=0;y<s.a;y++)this.c[y]=w-1e3*y;setInterval(()=>{for(let y=s.a;y>=1;y--)this.c[y]=this.c[y-1];this.c[0]=Date.now()},1e3)}d(){const w=Date.now(),y=(1+s.a)*1e3;let D=0;for(let S=0;S<s.a;S++)w-this.c[S]<=y&&D++;return 1-D/s.a}hasHighLoad(){return this.d()>=.5}}class f{get unacknowledgedCount(){return this.c-this.d}constructor(w){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=w.loadEstimator??s.getInstance(),this.t=w.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new P.$Vc,this.o=w.socket,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(y=>this.z(y))),this.r.add(this.o.onClose(y=>this.x.fire(y))),w.initialChunk&&this.q.acceptChunk(w.initialChunk),this.t?this.l=setInterval(()=>{this.D()},p.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const w=new c(l.Disconnect,0,0,I());this.p.write(w),this.p.flush()}sendPause(){const w=new c(l.Pause,0,0,I());this.p.write(w)}sendResume(){const w=new c(l.Resume,0,0,I());this.p.write(w)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(w,y){this.a=!0,this.r.dispose(),this.r=new P.$Vc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=w,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(D=>this.z(D))),this.r.add(this.o.onClose(D=>this.x.fire(D))),this.q.acceptChunk(y)}endAcceptReconnection(){this.a=!1,this.h=this.g;const w=new c(l.Ack,0,this.h,I());this.p.write(w);const y=this.b.toArray();for(let D=0,S=y.length;D<S;D++)this.p.write(y[D]);this.B()}acceptDisconnect(){this.w.fire()}z(w){if(w.ack>this.d){this.d=w.ack;do{const y=this.b.peek();if(y&&y.id<=w.ack)this.b.pop();else break}while(!0)}switch(w.type){case l.None:break;case l.Regular:{if(w.id>this.g)if(w.id!==this.g+1){const y=Date.now();y-this.m>1e4&&(this.m=y,this.p.write(new c(l.ReplayRequest,0,0,I())))}else this.g=w.id,this.j=Date.now(),this.A(),this.v.fire(w.data);break}case l.Control:{this.u.fire(w.data);break}case l.Ack:break;case l.Disconnect:{this.w.fire();break}case l.ReplayRequest:{const y=this.b.toArray();for(let D=0,S=y.length;D<S;D++)this.p.write(y[D]);this.B();break}case l.Pause:{this.p.pause();break}case l.Resume:{this.p.resume();break}case l.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(w){const y=++this.c;this.h=this.g;const D=new c(l.Regular,y,this.h,w);this.b.push(D),this.a||(this.p.write(D),this.B())}sendControl(w){const y=new c(l.Control,0,0,w);this.p.write(y)}A(){if(this.g<=this.h||this.k)return;const w=Date.now()-this.j;if(w>=p.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},p.AcknowledgeTime-w+5)}B(){if(this.c<=this.d||this.f||this.a)return;const w=this.b.peek(),y=Date.now()-w.writtenTime,D=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(y>=p.TimeoutTime&&D>=p.TimeoutTime&&S>=p.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:y,timeSinceLastReceivedSomeData:D});return}const C=Math.max(p.TimeoutTime-y,p.TimeoutTime-D,p.TimeoutTime-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},C)}C(){if(this.g<=this.h)return;this.h=this.g;const w=new c(l.Ack,0,this.h,I());this.p.write(w)}D(){this.h=this.g;const w=new c(l.KeepAlive,0,this.h,I());this.p.write(w)}}e.$ti=f}),define(ye[209],Se([1,0,58,9,22,21,207,14,4,3,25,112,109,87]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0,R=We(R);class p extends k.$hi{constructor(d){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",g=>P.$Oe.wrap(Buffer.from(g,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$er=p;class c{constructor(d,g){this.i=d,this.j=g,this.c=new Set,this.g=new Map,this.h=new $.$me,this.onDidProcessExit=this.h.event;const n=g&&g.timeout?g.timeout:6e4;this.b=new h.$Ch(n),this.d=null,this.f=null}getChannel(d){const g=this;return{call(n,o,t){return g.k(d,n,o,t)},listen(n,o){return g.l(d,n,o)}}}k(d,g,n,o=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(R.$8());this.b.cancel();const t=this.n(d),i=(0,h.$sh)(u=>t.call(g,n,u)),s=o.onCancellationRequested(()=>i.cancel()),f=(0,a.$Uc)(()=>i.cancel());return this.c.add(f),i.finally(()=>{s.dispose(),this.c.delete(f),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(d,g,n){if(!this.b)return $.Event.None;this.b.cancel();let o;const t=new $.$me({onWillAddFirstListener:()=>{o=this.n(d).listen(g,n)(t.fire,t),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,I.$do)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(y=>!/^--inspect(-brk)?=/.test(y)).filter(y=>!y.startsWith("--vscode-"))),(0,l.$lm)(g.env),this.d=(0,r.fork)(this.i,d,g);const n=new $.$me,t=$.Event.fromNodeEventEmitter(this.d,"message",y=>y)(y=>{if((0,T.$ar)(y)){(0,T.log)(y,`IPC Library: ${this.j.serverName}`);return}n.fire(P.$Oe.wrap(Buffer.from(y,"base64")))}),i=this.j.useQueue?(0,E.$ym)(this.d):this.d,s=y=>this.d&&this.d.connected&&i.send(y.buffer.toString("base64")),f=n.event,u={send:s,onMessage:f};this.f=new k.$ii(u);const w=()=>this.o();process.once("exit",w),this.d.on("error",y=>console.warn('IPC "'+this.j.serverName+'" errored with '+y)),this.d.on("exit",(y,D)=>{process.removeListener("exit",w),t.dispose(),this.c.forEach(S=>(0,a.$Rc)(S)),this.c.clear(),y!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+y+" and signal "+D),this.b?.cancel(),this.o(),this.h.fire({code:y,signal:D})})}return this.f}n(d){let g=this.g.get(d);return g||(g=this.m.getChannel(d),this.g.set(d,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$fr=c}),define(ye[210],Se([1,0,9,4,3,57,18]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.StorageState=e.StorageHint=void 0,e.$aq=$;var R;(function(l){l[l.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",l[l.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function $(l){const k=l;return k?.changed instanceof Map||k?.deleted instanceof Set}var a;(function(l){l[l.None=0]="None",l[l.Initialized=1]="Initialized",l[l.Closed=2]="Closed"})(a||(e.StorageState=a={}));class I extends P.$Wc{static{this.a=100}constructor(k,p=Object.create(null)){super(),this.r=k,this.s=p,this.b=this.B(new h.$pe),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new r.$Dh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(k=>this.u(k)))}u(k){this.b.pause();try{k.changed?.forEach((p,c)=>this.w(c,p)),k.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(k,p){if(this.c===a.Closed)return;let c=!1;(0,T.$og)(p)?c=this.f.delete(k):this.f.get(k)!==p&&(this.f.set(k,p),c=!0),c&&this.b.fire({key:k,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(k,p){const c=this.f.get(k);return(0,T.$og)(c)?p:c}getBoolean(k,p){const c=this.get(k);return(0,T.$og)(c)?p:c==="true"}getNumber(k,p){const c=this.get(k);return(0,T.$og)(c)?p:parseInt(c,10)}getObject(k,p){const c=this.get(k);return(0,T.$og)(c)?p:(0,O.$bi)(c)}async set(k,p,c=!1){if(this.c===a.Closed)return;if((0,T.$og)(p))return this.delete(k,c);const m=(0,T.$hg)(p)||Array.isArray(p)?(0,O.$ai)(p):String(p);if(this.f.get(k)!==m)return this.f.set(k,m),this.j.set(k,m),this.h.delete(k),this.b.fire({key:k,external:c}),this.D()}async delete(k,p=!1){if(!(this.c===a.Closed||!this.f.delete(k)))return this.h.has(k)||this.h.add(k),this.j.delete(k),this.b.fire({key:k,external:p}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const k={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(k).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(k){if(!(this.c===a.Closed||this.m))return this.D(k)}async D(k){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),k)}async whenFlushed(){if(this.z)return new Promise(k=>this.n.push(k))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$bq=I;class E{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(k){k.insert?.forEach((p,c)=>this.a.set(c,p)),k.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$cq=E}),define(ye[211],Se([1,0,13,11,22]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$au=void 0,e.$$t=I,e.$_t=E,r=We(r),h=We(h),P=We(P);let O;function T(){return O||(O=new TextDecoder("UTF-16LE")),O}let R;function $(){return R||(R=new TextDecoder("UTF-16BE")),R}let a;function I(){return a||(a=h.$D()?T():$()),a}function E(p,c,m){const d=new Uint16Array(p.buffer,c,m);return m>0&&(d[0]===65279||d[0]===65534)?l(p,c,m):T().decode(d)}function l(p,c,m){const d=[];let g=0;for(let n=0;n<m;n++){const o=P.$Qe(p,c);c+=2,d[g++]=String.fromCharCode(o)}return d.join("")}class k{constructor(c){this.a=c|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const c=new Uint16Array(this.b.buffer,0,this.d);return I().decode(c)}f(){const c=this.e();this.d=0,this.c===null?this.c=[c]:this.c[this.c.length]=c}appendCharCode(c){const m=this.a-this.d;m<=1&&(m===0||r.$Kf(c))&&this.f(),this.b[this.d++]=c}appendASCIICharCode(c){this.d===this.a&&this.f(),this.b[this.d++]=c}appendString(c){const m=c.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=c;return}for(let d=0;d<m;d++)this.b[this.d++]=c.charCodeAt(d)}}e.$au=k}),define(ye[212],Se([1,0,22,211]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=void 0,e.$cu=T,r=We(r);function P($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(a,I,E,l){this.oldPosition=a,this.oldText=I,this.newPosition=E,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(a){return 4+2*a.length}static c(a,I,E){const l=I.length;r.$Te(a,l,E),E+=4;for(let k=0;k<l;k++)r.$Re(a,I.charCodeAt(k),E),E+=2;return E}static d(a,I){const E=r.$Se(a,I);return I+=4,(0,h.$_t)(a,I,E)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(a,I){return r.$Te(a,this.oldPosition,I),I+=4,r.$Te(a,this.newPosition,I),I+=4,I=O.c(a,this.oldText,I),I=O.c(a,this.newText,I),I}static read(a,I,E){const l=r.$Se(a,I);I+=4;const k=r.$Se(a,I);I+=4;const p=O.d(a,I);I+=O.a(p);const c=O.d(a,I);return I+=O.a(c),E.push(new O(l,p,k,c)),I}}e.$bu=O;function T($,a){return $===null||$.length===0?a:new R($,a).compress()}class R{constructor(a,I){this.a=a,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let a=0,I=0,E=this.n(a),l=this.l(I);for(;a<this.f||I<this.h;){if(E===null){this.k(l),l=this.l(++I);continue}if(l===null){this.m(E),E=this.n(++a);continue}if(l.oldEnd<=E.newPosition){this.k(l),l=this.l(++I);continue}if(E.newEnd<=l.oldPosition){this.m(E),E=this.n(++a);continue}if(l.oldPosition<E.newPosition){const[d,g]=R.r(l,E.newPosition-l.oldPosition);this.k(d),l=g;continue}if(E.newPosition<l.oldPosition){const[d,g]=R.q(E,l.oldPosition-E.newPosition);this.m(d),E=g;continue}let c,m;if(l.oldEnd===E.newEnd)c=E,m=l,E=this.n(++a),l=this.l(++I);else if(l.oldEnd<E.newEnd){const[d,g]=R.q(E,l.oldLength);c=d,m=l,E=g,l=this.l(++I)}else{const[d,g]=R.r(l,E.newLength);c=E,m=d,E=this.n(++a),l=g}this.d[this.e++]=new O(c.oldPosition,c.oldText,m.newPosition,m.newText),this.g+=c.newLength-c.oldLength,this.j+=m.newLength-m.oldLength}const k=R.s(this.d);return R.t(k)}k(a){this.d[this.e++]=R.o(this.g,a),this.j+=a.newLength-a.oldLength}l(a){return a<this.h?this.c[a]:null}m(a){this.d[this.e++]=R.p(this.j,a),this.g+=a.newLength-a.oldLength}n(a){return a<this.f?this.a[a]:null}static o(a,I){return new O(I.oldPosition-a,I.oldText,I.newPosition,I.newText)}static p(a,I){return new O(I.oldPosition,I.oldText,I.newPosition+a,I.newText)}static q(a,I){const E=a.newText.substr(0,I),l=a.newText.substr(I);return[new O(a.oldPosition,a.oldText,a.newPosition,E),new O(a.oldEnd,"",a.newPosition+I,l)]}static r(a,I){const E=a.oldText.substr(0,I),l=a.oldText.substr(I);return[new O(a.oldPosition,E,a.newPosition,a.newText),new O(a.oldPosition+I,l,a.newEnd,"")]}static s(a){if(a.length===0)return a;const I=[];let E=0,l=a[0];for(let k=1;k<a.length;k++){const p=a[k];l.oldEnd===p.oldPosition?l=new O(l.oldPosition,l.oldText+p.oldText,l.newPosition,l.newText+p.newText):(I[E++]=l,l=p)}return I[E++]=l,I}static t(a){if(a.length===0)return a;const I=[];let E=0;for(let l=0;l<a.length;l++){const k=a[l];k.oldText!==k.newText&&(I[E++]=k)}return I}}}),define(ye[213],Se([1,0,39,17]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$su=P,e.$tu=O;function P(T,R,$,a,I,E){if(Array.isArray(T)){let l=0;for(const k of T){const p=P(k,R,$,a,I,E);if(p===10)return p;p>l&&(l=p)}return l}else{if(typeof T=="string")return a?T==="*"?5:T===$?10:0:0;if(T){const{language:l,pattern:k,scheme:p,hasAccessToAllModels:c,notebookType:m}=T;if(!a&&!c)return 0;m&&I&&(R=I);let d=0;if(p)if(p===R.scheme)d=10;else if(p==="*")d=5;else return 0;if(l)if(l===$)d=10;else if(l==="*")d=Math.max(d,5);else return 0;if(m)if(m===E)d=10;else if(m==="*"&&E!==void 0)d=Math.max(d,5);else return 0;if(k){let g;if(typeof k=="string"?g=k:g={...k,base:(0,h.$jc)(k.base)},g===R.fsPath||(0,r.$yk)(g,R.fsPath))d=10;else return 0}return d}else return 0}}function O(T){return typeof T=="string"?!1:Array.isArray(T)?T.some(O):!!T.notebookType}}),define(ye[214],Se([1,0,4,13,31,55,139,189,212,3]),function(ce,e,r,h,P,O,T,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lD=void 0,h=We(h);class I extends a.$Wc{constructor(l,k,p,c,m,d,g){super(),this.m=this.B(new r.$me),this.onDidChangeContent=this.m.event,this.f=k,this.j=!d,this.g=c,this.h=m,this.c=new T.$kD(l,p,g)}equals(l){return!(l instanceof I)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,k){return this.c.getOffsetAt(l,k)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,k){const p=l+k,c=this.getPositionAt(l),m=this.getPositionAt(p);return new P.$Lt(c.lineNumber,c.column,m.lineNumber,m.column)}getValueInRange(l,k=O.EndOfLinePreference.TextDefined){if(l.isEmpty())return"";const p=this.n(k);return this.c.getValueInRange(l,p)}getValueLengthInRange(l,k=O.EndOfLinePreference.TextDefined){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const p=this.getOffsetAt(l.startLineNumber,l.startColumn),c=this.getOffsetAt(l.endLineNumber,l.endColumn);let m=0;const d=this.n(k),g=this.getEOL();if(d.length!==g.length){const n=d.length-g.length,o=l.endLineNumber-l.startLineNumber;m=n*o}return c-p+m}getCharacterCountInRange(l,k=O.EndOfLinePreference.TextDefined){if(this.j){let p=0;const c=l.startLineNumber,m=l.endLineNumber;for(let d=c;d<=m;d++){const g=this.getLineContent(d),n=d===c?l.startColumn-1:0,o=d===m?l.endColumn-1:g.length;for(let t=n;t<o;t++)h.$Kf(g.charCodeAt(t))?(p=p+1,t=t+1):p=p+1}return p+=this.n(k).length*(m-c),p}return this.getValueLengthInRange(l,k)}getNearestChunk(l){return this.c.getNearestChunk(l)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,k){return this.c.getLineCharCode(l,k)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const k=h.$vf(this.getLineContent(l));return k===-1?0:k+1}getLineLastNonWhitespaceColumn(l){const k=h.$xf(this.getLineContent(l));return k===-1?0:k+2}n(l){switch(l){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,k,p){let c=this.g,m=this.h,d=this.j,g=!0,n=[];for(let w=0;w<l.length;w++){const y=l[w];g&&y._isTracked&&(g=!1);const D=y.range;if(y.text){let v=!0;d||(v=!h.$Vf(y.text),d=v),!c&&v&&(c=h.$Uf(y.text)),!m&&v&&(m=h.$Xf(y.text))}let S="",C=0,A=0,b=0;if(y.text){let v;[C,A,b,v]=(0,R.$vu)(y.text);const M=this.getEOL(),N=M===`\r
`?R.StringEOL.CRLF:R.StringEOL.LF;v===R.StringEOL.Unknown||v===N?S=y.text:S=y.text.replace(/\r\n|\r|\n/g,M)}n[w]={sortIndex:w,identifier:y.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:S,eolCount:C,firstLineLength:A,lastLineLength:b,forceMoveMarkers:!!y.forceMoveMarkers,isAutoWhitespaceEdit:y.isAutoWhitespaceEdit||!1}}n.sort(I.u);let o=!1;for(let w=0,y=n.length-1;w<y;w++){const D=n[w].range.getEndPosition(),S=n[w+1].range.getStartPosition();if(S.isBeforeOrEqual(D)){if(S.isBefore(D))throw new Error("Overlapping ranges are not allowed!");o=!0}}g&&(n=this.s(n));const t=p||k?I._getInverseEditRanges(n):[],i=[];if(k)for(let w=0;w<n.length;w++){const y=n[w],D=t[w];if(y.isAutoWhitespaceEdit&&y.range.isEmpty())for(let S=D.startLineNumber;S<=D.endLineNumber;S++){let C="";S===D.startLineNumber&&(C=this.getLineContent(y.range.startLineNumber),h.$vf(C)!==-1)||i.push({lineNumber:S,oldContent:C})}}let s=null;if(p){let w=0;s=[];for(let y=0;y<n.length;y++){const D=n[y],S=t[y],C=this.getValueInRange(D.range),A=D.rangeOffset+w;w+=D.text.length-C.length,s[y]={sortIndex:D.sortIndex,identifier:D.identifier,range:S,text:C,textChange:new $.$bu(D.rangeOffset,C,A,D.text)}}o||s.sort((y,D)=>y.sortIndex-D.sortIndex)}this.g=c,this.h=m,this.j=d;const f=this.t(n);let u=null;if(k&&i.length>0){i.sort((w,y)=>y.lineNumber-w.lineNumber),u=[];for(let w=0,y=i.length;w<y;w++){const D=i[w].lineNumber;if(w>0&&i[w-1].lineNumber===D)continue;const S=i[w].oldContent,C=this.getLineContent(D);C.length===0||C===S||h.$vf(C)!==-1||u.push(D)}}return this.m.fire(),new O.$ew(s,f,u)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let k=!1;const p=l[0].range,c=l[l.length-1].range,m=new P.$Lt(p.startLineNumber,p.startColumn,c.endLineNumber,c.endColumn);let d=p.startLineNumber,g=p.startColumn;const n=[];for(let f=0,u=l.length;f<u;f++){const w=l[f],y=w.range;k=k||w.forceMoveMarkers,n.push(this.getValueInRange(new P.$Lt(d,g,y.startLineNumber,y.startColumn))),w.text.length>0&&n.push(w.text),d=y.endLineNumber,g=y.endColumn}const o=n.join(""),[t,i,s]=(0,R.$vu)(o);return{sortIndex:0,identifier:l[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,O.EndOfLinePreference.TextDefined),text:o,eolCount:t,firstLineLength:i,lastLineLength:s,forceMoveMarkers:k,isAutoWhitespaceEdit:!1}}t(l){l.sort(I.w);const k=[];for(let p=0;p<l.length;p++){const c=l[p],m=c.range.startLineNumber,d=c.range.startColumn,g=c.range.endLineNumber,n=c.range.endColumn;if(m===g&&d===n&&c.text.length===0)continue;c.text?(this.c.delete(c.rangeOffset,c.rangeLength),this.c.insert(c.rangeOffset,c.text,!0)):this.c.delete(c.rangeOffset,c.rangeLength);const o=new P.$Lt(m,d,g,n);k.push({range:o,rangeLength:c.rangeLength,text:c.text,rangeOffset:c.rangeOffset,forceMoveMarkers:c.forceMoveMarkers})}return k}findMatchesLineByLine(l,k,p,c){return this.c.findMatchesLineByLine(l,k,p,c)}getPieceTree(){return this.c}static _getInverseEditRange(l,k){const p=l.startLineNumber,c=l.startColumn,[m,d,g]=(0,R.$vu)(k);let n;if(k.length>0){const o=m+1;o===1?n=new P.$Lt(p,c,p,c+d):n=new P.$Lt(p,c,p+o-1,g+1)}else n=new P.$Lt(p,c,p,c);return n}static _getInverseEditRanges(l){const k=[];let p=0,c=0,m=null;for(let d=0,g=l.length;d<g;d++){const n=l[d];let o,t;m?m.range.endLineNumber===n.range.startLineNumber?(o=p,t=c+(n.range.startColumn-m.range.endColumn)):(o=p+(n.range.startLineNumber-m.range.endLineNumber),t=n.range.startColumn):(o=n.range.startLineNumber,t=n.range.startColumn);let i;if(n.text.length>0){const s=n.eolCount+1;s===1?i=new P.$Lt(o,t,o,t+n.firstLineLength):i=new P.$Lt(o,t,o+s-1,n.lastLineLength+1)}else i=new P.$Lt(o,t,o,t);p=i.endLineNumber,c=i.endColumn,k.push(i),m=n}return k}static u(l,k){const p=P.$Lt.compareRangesUsingEnds(l.range,k.range);return p===0?l.sortIndex-k.sortIndex:p}static w(l,k){const p=P.$Lt.compareRangesUsingEnds(l.range,k.range);return p===0?k.sortIndex-l.sortIndex:-p}}e.$lD=I}),define(ye[215],Se([1,0,27,13,55,139,214]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mD=void 0,h=We(h);class R{constructor(I,E,l,k,p,c,m,d,g){this.a=I,this.b=E,this.c=l,this.d=k,this.e=p,this.f=c,this.g=m,this.h=d,this.j=g}k(I){const E=this.c+this.d+this.e,l=this.c+this.e;return E===0?I===P.DefaultEndOfLine.LF?`
`:`\r
`:l>E/2?`\r
`:`
`}create(I){const E=this.k(I),l=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let p=0,c=l.length;p<c;p++){const m=l[p].buffer.replace(/\r\n|\r|\n/g,E),d=(0,O.$gD)(m);l[p]=new O.$jD(m,d)}const k=new T.$lD(l,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&h.$6f(I)&&(this.b=h.$5f,I=I.substr(1));const E=I.charCodeAt(I.length-1);E===r.CharCode.CarriageReturn||E>=55296&&E<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=E):(this.m(I,!1),this.c=!1,this.d=E)}m(I,E){!E&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const E=(0,O.$hD)(this.e,I);this.a.push(new O.$jD(I,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Uf(I)),this.k||(this.k=h.$Xf(I)))}finish(I=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const E=(0,O.$gD)(I.buffer);I.lineStarts=E,this.d===r.CharCode.CarriageReturn&&this.f++}}}e.$mD=$}),define(ye[143],Se([1,0,22,11]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdb=$,e.$Gdb=I,h=We(h);var P;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(P||(P={}));function O(E){for(let l=0,k=E.length;l<k;l+=4){const p=E[l+0],c=E[l+1],m=E[l+2],d=E[l+3];E[l+0]=d,E[l+1]=m,E[l+2]=c,E[l+3]=p}}function T(E){const l=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return h.$D()||O(l),r.$Oe.wrap(l)}function R(E){const l=E.buffer;if(h.$D()||O(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const k=new Uint8Array(l.byteLength);return k.set(l),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function $(E){const l=new Uint32Array(a(E));let k=0;if(l[k++]=E.id,E.type==="full")l[k++]=P.Full,l[k++]=E.data.length,l.set(E.data,k),k+=E.data.length;else{l[k++]=P.Delta,l[k++]=E.deltas.length;for(const p of E.deltas)l[k++]=p.start,l[k++]=p.deleteCount,p.data?(l[k++]=p.data.length,l.set(p.data,k),k+=p.data.length):l[k++]=0}return T(l)}function a(E){let l=0;if(l+=2,E.type==="full")l+=1+E.data.length;else{l+=1,l+=3*E.deltas.length;for(const k of E.deltas)k.data&&(l+=k.data.length)}return l}function I(E){const l=R(E);let k=0;const p=l[k++];if(l[k++]===P.Full){const g=l[k++],n=l.subarray(k,k+g);return k+=g,{id:p,type:"full",data:n}}const m=l[k++],d=[];for(let g=0;g<m;g++){const n=l[k++],o=l[k++],t=l[k++];let i;t>0&&(i=l.subarray(k,k+t),k+=t),d[g]={start:n,deleteCount:o,data:i}}return{id:p,type:"delta",deltas:d}}}),define(ye[216],Se([7,8]),function(ce,e){return ce.create("vs/editor/common/config/editorOptions",e)}),define(ye[217],Se([7,8]),function(ce,e){return ce.create("vs/editor/common/languages",e)}),define(ye[88],Se([1,0,83,2,190,31,200,217]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Nu=e.$Mu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Lu=e.$Ku=e.SymbolKinds=e.SymbolTag=e.$Iu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Gu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Fu=e.$Eu=e.$Du=void 0,e.$Hu=f,e.$Ju=w;class ${constructor(G,Q,ee){this.offset=G,this.type=Q,this.language=ee,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Du=$;class a{constructor(G,Q){this.tokens=G,this.endState=Q,this._tokenizationResultBrand=void 0}}e.$Eu=a;class I{constructor(G,Q){this.tokens=G,this.endState=Q,this._encodedTokenizationResultBrand=void 0}}e.$Fu=I;var E;(function(U){U[U.Increase=0]="Increase",U[U.Decrease=1]="Decrease"})(E||(e.HoverVerbosityAction=E={}));var l;(function(U){U[U.Method=0]="Method",U[U.Function=1]="Function",U[U.Constructor=2]="Constructor",U[U.Field=3]="Field",U[U.Variable=4]="Variable",U[U.Class=5]="Class",U[U.Struct=6]="Struct",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Event=10]="Event",U[U.Operator=11]="Operator",U[U.Unit=12]="Unit",U[U.Value=13]="Value",U[U.Constant=14]="Constant",U[U.Enum=15]="Enum",U[U.EnumMember=16]="EnumMember",U[U.Keyword=17]="Keyword",U[U.Text=18]="Text",U[U.Color=19]="Color",U[U.File=20]="File",U[U.Reference=21]="Reference",U[U.Customcolor=22]="Customcolor",U[U.Folder=23]="Folder",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue",U[U.Snippet=27]="Snippet"})(l||(e.CompletionItemKind=l={}));var k;(function(U){const G=new Map;G.set(l.Method,r.$5j.symbolMethod),G.set(l.Function,r.$5j.symbolFunction),G.set(l.Constructor,r.$5j.symbolConstructor),G.set(l.Field,r.$5j.symbolField),G.set(l.Variable,r.$5j.symbolVariable),G.set(l.Class,r.$5j.symbolClass),G.set(l.Struct,r.$5j.symbolStruct),G.set(l.Interface,r.$5j.symbolInterface),G.set(l.Module,r.$5j.symbolModule),G.set(l.Property,r.$5j.symbolProperty),G.set(l.Event,r.$5j.symbolEvent),G.set(l.Operator,r.$5j.symbolOperator),G.set(l.Unit,r.$5j.symbolUnit),G.set(l.Value,r.$5j.symbolValue),G.set(l.Enum,r.$5j.symbolEnum),G.set(l.Constant,r.$5j.symbolConstant),G.set(l.Enum,r.$5j.symbolEnum),G.set(l.EnumMember,r.$5j.symbolEnumMember),G.set(l.Keyword,r.$5j.symbolKeyword),G.set(l.Snippet,r.$5j.symbolSnippet),G.set(l.Text,r.$5j.symbolText),G.set(l.Color,r.$5j.symbolColor),G.set(l.File,r.$5j.symbolFile),G.set(l.Reference,r.$5j.symbolReference),G.set(l.Customcolor,r.$5j.symbolCustomColor),G.set(l.Folder,r.$5j.symbolFolder),G.set(l.TypeParameter,r.$5j.symbolTypeParameter),G.set(l.User,r.$5j.account),G.set(l.Issue,r.$5j.issues);function Q(ne){let De=G.get(ne);return De||(console.info("No codicon found for CompletionItemKind "+ne),De=r.$5j.symbolProperty),De}U.toIcon=Q;const ee=new Map;ee.set("method",l.Method),ee.set("function",l.Function),ee.set("constructor",l.Constructor),ee.set("field",l.Field),ee.set("variable",l.Variable),ee.set("class",l.Class),ee.set("struct",l.Struct),ee.set("interface",l.Interface),ee.set("module",l.Module),ee.set("property",l.Property),ee.set("event",l.Event),ee.set("operator",l.Operator),ee.set("unit",l.Unit),ee.set("value",l.Value),ee.set("constant",l.Constant),ee.set("enum",l.Enum),ee.set("enum-member",l.EnumMember),ee.set("enumMember",l.EnumMember),ee.set("keyword",l.Keyword),ee.set("snippet",l.Snippet),ee.set("text",l.Text),ee.set("color",l.Color),ee.set("file",l.File),ee.set("reference",l.Reference),ee.set("customcolor",l.Customcolor),ee.set("folder",l.Folder),ee.set("type-parameter",l.TypeParameter),ee.set("typeParameter",l.TypeParameter),ee.set("account",l.User),ee.set("issue",l.Issue);function he(ne,De){let $e=ee.get(ne);return typeof $e>"u"&&!De&&($e=l.Property),$e}U.fromString=he})(k||(e.CompletionItemKinds=k={}));var p;(function(U){U[U.Deprecated=1]="Deprecated"})(p||(e.CompletionItemTag=p={}));var c;(function(U){U[U.None=0]="None",U[U.KeepWhitespace=1]="KeepWhitespace",U[U.InsertAsSnippet=4]="InsertAsSnippet"})(c||(e.CompletionItemInsertTextRule=c={}));var m;(function(U){U[U.Word=0]="Word",U[U.Line=1]="Line",U[U.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var d;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(e.CompletionTriggerKind=d={}));var g;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class n{constructor(G,Q,ee,he){this.range=G,this.text=Q,this.completionKind=ee,this.isSnippetText=he}equals(G){return O.$Lt.lift(this.range).equalsRange(G.range)&&this.text===G.text&&this.completionKind===G.completionKind&&this.isSnippetText===G.isSnippetText}}e.$Gu=n;var o;(function(U){U[U.Invoke=1]="Invoke",U[U.Auto=2]="Auto"})(o||(e.CodeActionTriggerType=o={}));var t;(function(U){U[U.Automatic=0]="Automatic",U[U.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var i;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(i||(e.SignatureHelpTriggerKind=i={}));var s;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(s||(e.DocumentHighlightKind=s={}));function f(U){return U&&h.URI.isUri(U.uri)&&O.$Lt.isIRange(U.range)&&(O.$Lt.isIRange(U.originSelectionRange)||O.$Lt.isIRange(U.targetSelectionRange))}var u;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(u||(e.SymbolKind=u={})),e.$Iu={[u.Array]:(0,R.localize)(0,null),[u.Boolean]:(0,R.localize)(1,null),[u.Class]:(0,R.localize)(2,null),[u.Constant]:(0,R.localize)(3,null),[u.Constructor]:(0,R.localize)(4,null),[u.Enum]:(0,R.localize)(5,null),[u.EnumMember]:(0,R.localize)(6,null),[u.Event]:(0,R.localize)(7,null),[u.Field]:(0,R.localize)(8,null),[u.File]:(0,R.localize)(9,null),[u.Function]:(0,R.localize)(10,null),[u.Interface]:(0,R.localize)(11,null),[u.Key]:(0,R.localize)(12,null),[u.Method]:(0,R.localize)(13,null),[u.Module]:(0,R.localize)(14,null),[u.Namespace]:(0,R.localize)(15,null),[u.Null]:(0,R.localize)(16,null),[u.Number]:(0,R.localize)(17,null),[u.Object]:(0,R.localize)(18,null),[u.Operator]:(0,R.localize)(19,null),[u.Package]:(0,R.localize)(20,null),[u.Property]:(0,R.localize)(21,null),[u.String]:(0,R.localize)(22,null),[u.Struct]:(0,R.localize)(23,null),[u.TypeParameter]:(0,R.localize)(24,null),[u.Variable]:(0,R.localize)(25,null)};function w(U,G){return(0,R.localize)(26,null,U,e.$Iu[G])}var y;(function(U){U[U.Deprecated=1]="Deprecated"})(y||(e.SymbolTag=y={}));var D;(function(U){const G=new Map;G.set(u.File,r.$5j.symbolFile),G.set(u.Module,r.$5j.symbolModule),G.set(u.Namespace,r.$5j.symbolNamespace),G.set(u.Package,r.$5j.symbolPackage),G.set(u.Class,r.$5j.symbolClass),G.set(u.Method,r.$5j.symbolMethod),G.set(u.Property,r.$5j.symbolProperty),G.set(u.Field,r.$5j.symbolField),G.set(u.Constructor,r.$5j.symbolConstructor),G.set(u.Enum,r.$5j.symbolEnum),G.set(u.Interface,r.$5j.symbolInterface),G.set(u.Function,r.$5j.symbolFunction),G.set(u.Variable,r.$5j.symbolVariable),G.set(u.Constant,r.$5j.symbolConstant),G.set(u.String,r.$5j.symbolString),G.set(u.Number,r.$5j.symbolNumber),G.set(u.Boolean,r.$5j.symbolBoolean),G.set(u.Array,r.$5j.symbolArray),G.set(u.Object,r.$5j.symbolObject),G.set(u.Key,r.$5j.symbolKey),G.set(u.Null,r.$5j.symbolNull),G.set(u.EnumMember,r.$5j.symbolEnumMember),G.set(u.Struct,r.$5j.symbolStruct),G.set(u.Event,r.$5j.symbolEvent),G.set(u.Operator,r.$5j.symbolOperator),G.set(u.TypeParameter,r.$5j.symbolTypeParameter);function Q(ee){let he=G.get(ee);return he||(console.info("No codicon found for SymbolKind "+ee),he=r.$5j.symbolProperty),he}U.toIcon=Q})(D||(e.SymbolKinds=D={}));class S{static asEditOperation(G){return P.$Mt.replace(O.$Lt.lift(G.range),G.text)}}e.$Ku=S;class C{static{this.Comment=new C("comment")}static{this.Imports=new C("imports")}static{this.Region=new C("region")}static fromValue(G){switch(G){case"comment":return C.Comment;case"imports":return C.Imports;case"region":return C.Region}return new C(G)}constructor(G){this.value=G}}e.$Lu=C;var A;(function(U){U[U.AIGenerated=1]="AIGenerated"})(A||(e.NewSymbolNameTag=A={}));var b;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(b||(e.NewSymbolNameTriggerKind=b={}));var v;(function(U){function G(Q){return!Q||typeof Q!="object"?!1:typeof Q.id=="string"&&typeof Q.title=="string"}U.is=G})(v||(e.Command=v={}));var M;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(M||(e.CommentThreadCollapsibleState=M={}));var N;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(N||(e.CommentThreadState=N={}));var L;(function(U){U[U.Current=0]="Current",U[U.Outdated=1]="Outdated"})(L||(e.CommentThreadApplicability=L={}));var j;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(j||(e.CommentMode=j={}));var z;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(z||(e.CommentState=z={}));var F;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(F||(e.InlayHintKind=F={}));class B{constructor(G){this.b=G,this.a=null}dispose(){this.a&&this.a.then(G=>{G&&G.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Mu=B,e.$Nu=new T.$uu;var _;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(_||(e.ExternalUriOpenerPriority=_={}));var re;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(re||(e.InlineEditTriggerKind=re={}))}),define(ye[218],Se([7,8]),function(ce,e){return ce.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[219],Se([7,8]),function(ce,e){return ce.create("vs/platform/contextkey/common/contextkey",e)}),define(ye[220],Se([7,8]),function(ce,e){return ce.create("vs/platform/contextkey/common/scanner",e)}),define(ye[221],Se([7,8]),function(ce,e){return ce.create("vs/platform/dialogs/common/dialogs",e)}),define(ye[222],Se([7,8]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[223],Se([7,8]),function(ce,e){return ce.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[224],Se([7,8]),function(ce,e){return ce.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[225],Se([7,8]),function(ce,e){return ce.create("vs/platform/files/common/files",e)}),define(ye[226],Se([7,8]),function(ce,e){return ce.create("vs/platform/files/common/io",e)}),define(ye[227],Se([7,8]),function(ce,e){return ce.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ye[228],Se([7,8]),function(ce,e){return ce.create("vs/platform/log/common/log",e)}),define(ye[229],Se([7,8]),function(ce,e){return ce.create("vs/platform/markers/common/markers",e)}),define(ye[230],Se([7,8]),function(ce,e){return ce.create("vs/platform/request/common/request",e)}),define(ye[231],Se([7,8]),function(ce,e){return ce.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[232],Se([7,8]),function(ce,e){return ce.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ye[233],Se([7,8]),function(ce,e){return ce.create("vs/platform/workspace/common/workspace",e)}),define(ye[234],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[235],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[236],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ye[237],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ye[238],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLogService",e)}),define(ye[239],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostNotebook",e)}),define(ye[240],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[241],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[242],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[243],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[244],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ye[245],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[246],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[247],Se([7,8]),function(ce,e){return ce.create("vs/workbench/common/configuration",e)}),define(ye[248],Se([7,8]),function(ce,e){return ce.create("vs/workbench/common/editor",e)}),define(ye[249],Se([7,8]),function(ce,e){return ce.create("vs/workbench/common/views",e)}),define(ye[250],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ye[251],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(ye[252],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[253],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[254],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[255],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[256],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[257],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/testing/common/constants",e)}),define(ye[258],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[259],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ye[260],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[261],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ye[262],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[263],Se([1,0,27,14,220]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var O;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(O||(e.TokenType=O={}));function T(...I){switch(I.length){case 1:return(0,P.localize)(0,null,I[0]);case 2:return(0,P.localize)(1,null,I[0],I[1]);case 3:return(0,P.localize)(2,null,I[0],I[1],I[2]);default:return}}const R=(0,P.localize)(3,null),$=(0,P.localize)(4,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return E.isTripleEq?"===":"==";case O.NotEq:return E.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return E.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return E.lexeme;case O.QuotedStr:return E.lexeme;case O.Error:return E.lexeme;case O.EOF:return"EOF";default:throw(0,h.$0)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case r.CharCode.OpenParen:this.k(O.LParen);break;case r.CharCode.CloseParen:this.k(O.RParen);break;case r.CharCode.ExclamationMark:if(this.h(r.CharCode.Equals)){const l=this.h(r.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:l})}else this.k(O.Neg);break;case r.CharCode.SingleQuote:this.o();break;case r.CharCode.Slash:this.q();break;case r.CharCode.Equals:if(this.h(r.CharCode.Equals)){const l=this.h(r.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:l})}else this.h(r.CharCode.Tilde)?this.k(O.RegexOp):this.l(T("==","=~"));break;case r.CharCode.LessThan:this.k(this.h(r.CharCode.Equals)?O.LtEq:O.Lt);break;case r.CharCode.GreaterThan:this.k(this.h(r.CharCode.Equals)?O.GtEq:O.Gt);break;case r.CharCode.Ampersand:this.h(r.CharCode.Ampersand)?this.k(O.And):this.l(T("&&"));break;case r.CharCode.Pipe:this.h(r.CharCode.Pipe)?this.k(O.Or):this.l(T("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?r.CharCode.Null:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const l=this.d,k=this.c.substring(this.d,this.e),p={type:O.Error,offset:this.d,lexeme:k};this.g.push({offset:l,lexeme:k,additionalInfo:E}),this.f.push(p)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const l=this.c.substring(this.d,this.e),k=a.b.get(l);k?this.k(k):this.f.push({type:O.Str,lexeme:l,offset:this.d})}}o(){for(;this.j()!==r.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,l=!1,k=!1;for(;;){if(E>=this.c.length){this.e=E,this.l($);return}const c=this.c.charCodeAt(E);if(l)l=!1;else if(c===r.CharCode.Slash&&!k){E++;break}else c===r.CharCode.OpenSquareBracket?k=!0:c===r.CharCode.Backslash?l=!0:c===r.CharCode.CloseSquareBracket&&(k=!1);E++}for(;E<this.c.length&&a.a.has(this.c.charCodeAt(E));)E++;this.e=E;const p=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=a}),define(ye[144],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const r={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(r)}),define(ye[113],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class r{constructor(P,O=[],T=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=T}}e.$Ci=r}),define(ye[89],Se([1,0,113]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Os=O,e.$Ps=T;const h=[];var P;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function O(R,$,a){$ instanceof r.$Ci||($=new r.$Ci($,[],!!a)),h.push([R,$])}function T(){return h}}),define(ye[264],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0;class r{constructor(O,T){this.key=O,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$rr=r;class h{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const T of this.a.values())T.outgoing.size===0&&O.push(T);return O}insertEdge(O,T){const R=this.lookupOrInsertNode(O),$=this.lookupOrInsertNode(T);R.outgoing.set($.key,$),$.incoming.set(R.key,R)}removeNode(O){const T=this.b(O);this.a.delete(T);for(const R of this.a.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(O){const T=this.b(O);let R=this.a.get(T);return R||(R=new r(T,O),this.a.set(T,R)),R}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[T,R]of this.a)O.push(`${T}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,T]of this.a){const R=new Set([O]),$=this.c(T,R);if($)return $}}c(O,T){for(const[R,$]of O.outgoing){if(T.has(R))return[...T,R].join(" -> ");T.add(R);const a=this.c($,T);if(a)return a;T.delete(R)}}}e.$sr=h}),define(ye[5],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=P,e.$Gi=O;var r;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function R($){return $[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=R})(r||(e._util=r={})),e.$Ei=P("instantiationService");function h(T,R,$){R[r.DI_TARGET]===R?R[r.DI_DEPENDENCIES].push({id:T,index:$}):(R[r.DI_DEPENDENCIES]=[{id:T,index:$}],R[r.DI_TARGET]=R)}function P(T){if(r.serviceIds.has(T))return r.serviceIds.get(T);const R=function($,a,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(R,$,I)};return R.toString=()=>T,r.serviceIds.set(T,R),R}function O(T){return T}}),define(ye[45],Se([1,0,18,2,5]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=O,e.$bj=T,e.$cj=$,e.$dj=a,e.$ej=I,e.$fj=E,e.$gj=l,e.$hj=p,e.$ij=c,e.$jj=m,r=We(r),e.$_i=(0,P.$Fi)("configurationService");function O(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof h.URI)}function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof h.URI)}var R;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function $(d){switch(d){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function a(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function I(d,g){const n=Object.create(null);for(const o in d)E(n,o,d[o],g);return n}function E(d,g,n,o){const t=g.split("."),i=t.pop();let s=d;for(let f=0;f<t.length;f++){const u=t[f];let w=s[u];switch(typeof w){case"undefined":w=s[u]=Object.create(null);break;case"object":if(w===null){o(`Ignoring ${g} as ${t.slice(0,f+1).join(".")} is null`);return}break;default:o(`Ignoring ${g} as ${t.slice(0,f+1).join(".")} is ${JSON.stringify(w)}`);return}s=w}if(typeof s=="object"&&s!==null)try{s[i]=n}catch{o(`Ignoring ${g} as ${t.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${g} as ${t.join(".")} is ${JSON.stringify(s)}`)}function l(d,g){const n=g.split(".");k(d,n)}function k(d,g){const n=g.shift();if(g.length===0){delete d[n];return}if(Object.keys(d).indexOf(n)!==-1){const o=d[n];typeof o=="object"&&!Array.isArray(o)&&(k(o,g),Object.keys(o).length===0&&delete d[n])}}function p(d,g,n){function o(s,f){let u=s;for(const w of f){if(typeof u!="object"||u===null)return;u=u[w]}return u}const t=g.split("."),i=o(d,t);return typeof i>"u"?n:i}function c(d,g,n){Object.keys(g).forEach(o=>{o!=="__proto__"&&(o in d?r.$hg(d[o])&&r.$hg(g[o])?c(d[o],g[o],n):n&&(d[o]=g[o]):d[o]=g[o])})}function m(d){return d.replace(/[\[\]]/g,"")}}),define(ye[36],Se([1,0,27,11,13,263,5,219,14]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=I,e.$Ej=f,e.$Fj=u,e.$Yj=ne;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",h.$j),a.set("isLinux",h.$k),a.set("isWindows",h.$i),a.set("isWeb",h.$o),a.set("isMacNative",h.$j&&!h.$o),a.set("isEdge",h.$H),a.set("isFirefox",h.$F),a.set("isChrome",h.$E),a.set("isSafari",h.$G);function I(K,W){if(a.get(K)!==void 0)throw(0,$.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(K,W)}const E=Object.prototype.hasOwnProperty;var l;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(l||(e.ContextKeyExprType=l={}));const k={regexParsingWithErrorRecovery:!0},p=(0,R.localize)(0,null),c=(0,R.localize)(1,null),m=(0,R.localize)(2,null),d=(0,R.localize)(3,null),g=(0,R.localize)(4,null),n=(0,R.localize)(5,null),o=(0,R.localize)(6,null),t=(0,R.localize)(7,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=k){this.k=W,this.d=new O.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const se=this.l();if(!this.E()){const ae=this.D(),te=ae.type===O.TokenType.Str?n:void 0;throw this.h.push({message:g,offset:ae.offset,lexeme:O.$Aj.getLexeme(ae),additionalInfo:te}),i.c}return se}catch(se){if(se!==i.c)throw se;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(O.TokenType.Or);){const se=this.o();W.push(se)}return W.length===1?W[0]:s.or(...W)}o(){const W=[this.s()];for(;this.y(O.TokenType.And);){const se=this.s();W.push(se)}return W.length===1?W[0]:s.and(...W)}s(){if(this.y(O.TokenType.Neg)){const W=this.D();switch(W.type){case O.TokenType.True:return this.z(),y.INSTANCE;case O.TokenType.False:return this.z(),D.INSTANCE;case O.TokenType.LParen:{this.z();const se=this.l();return this.A(O.TokenType.RParen,d),se?.negate()}case O.TokenType.Str:return this.z(),M.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case O.TokenType.True:return this.z(),s.true();case O.TokenType.False:return this.z(),s.false();case O.TokenType.LParen:{this.z();const se=this.l();return this.A(O.TokenType.RParen,d),se}case O.TokenType.Str:{const se=W.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),te.type!==O.TokenType.RegexStr)throw this.B("REGEX",te);const le=te.lexeme,ue=le.lastIndexOf("/"),X=ue===le.length-1?void 0:this.w(le.substring(ue+1));let oe;try{oe=new RegExp(le.substring(1,ue),X)}catch{throw this.B("REGEX",te)}return B.create(se,oe)}switch(te.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const le=[te.lexeme];this.z();let ue=this.D(),X=0;for(let Ue=0;Ue<te.lexeme.length;Ue++)te.lexeme.charCodeAt(Ue)===r.CharCode.OpenParen?X++:te.lexeme.charCodeAt(Ue)===r.CharCode.CloseParen&&X--;for(;!this.E()&&ue.type!==O.TokenType.And&&ue.type!==O.TokenType.Or;){switch(ue.type){case O.TokenType.LParen:X++;break;case O.TokenType.RParen:X--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let Ue=0;Ue<ue.lexeme.length;Ue++)ue.lexeme.charCodeAt(Ue)===r.CharCode.OpenParen?X++:te.lexeme.charCodeAt(Ue)===r.CharCode.CloseParen&&X--}if(X<0)break;le.push(O.$Aj.getLexeme(ue)),this.z(),ue=this.D()}const oe=le.join(""),pe=oe.lastIndexOf("/"),we=pe===oe.length-1?void 0:this.w(oe.substring(pe+1));let Fe;try{Fe=new RegExp(oe.substring(1,pe),we)}catch{throw this.B("REGEX",te)}return s.regex(se,Fe)}case O.TokenType.QuotedStr:{const le=te.lexeme;this.z();let ue=null;if(!(0,P.$df)(le)){const X=le.indexOf("/"),oe=le.lastIndexOf("/");if(X!==oe&&X>=0){const pe=le.slice(X+1,oe),we=le[oe+1]==="i"?"i":"";try{ue=new RegExp(pe,we)}catch{throw this.B("REGEX",te)}}}if(ue===null)throw this.B("REGEX",te);return B.create(se,ue)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,m);const te=this.u();return s.notIn(se,te)}switch(this.D().type){case O.TokenType.Eq:{this.z();const te=this.u();if(this.x().type===O.TokenType.QuotedStr)return s.equals(se,te);switch(te){case"true":return s.has(se);case"false":return s.not(se);default:return s.equals(se,te)}}case O.TokenType.NotEq:{this.z();const te=this.u();if(this.x().type===O.TokenType.QuotedStr)return s.notEquals(se,te);switch(te){case"true":return s.not(se);case"false":return s.has(se);default:return s.notEquals(se,te)}}case O.TokenType.Lt:return this.z(),z.create(se,this.u());case O.TokenType.LtEq:return this.z(),F.create(se,this.u());case O.TokenType.Gt:return this.z(),L.create(se,this.u());case O.TokenType.GtEq:return this.z(),j.create(se,this.u());case O.TokenType.In:return this.z(),s.in(se,this.u());default:return s.has(se)}}case O.TokenType.EOF:throw this.h.push({message:o,offset:W.offset,lexeme:"",additionalInfo:t}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),W.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,se){if(this.C(W))return this.z();throw this.B(se,this.D())}B(W,se,ae){const te=(0,R.localize)(8,null,W,O.$Aj.getLexeme(se)),le=se.offset,ue=O.$Aj.getLexeme(se);return this.h.push({message:te,offset:le,lexeme:ue,additionalInfo:ae}),i.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$Cj=i;class s{static false(){return y.INSTANCE}static true(){return D.INSTANCE}static has(W){return S.create(W)}static equals(W,se){return C.create(W,se)}static notEquals(W,se){return v.create(W,se)}static regex(W,se){return B.create(W,se)}static in(W,se){return A.create(W,se)}static notIn(W,se){return b.create(W,se)}static not(W){return M.create(W)}static and(...W){return U.create(W,null,!0)}static or(...W){return G.create(W,null,!0)}static greater(W,se){return L.create(W,se)}static greaterEquals(W,se){return j.create(W,se)}static smaller(W,se){return z.create(W,se)}static smallerEquals(W,se){return F.create(W,se)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$Dj=s;function f(K){const W=new i({regexParsingWithErrorRecovery:!1});return K.map(se=>(W.parse(se),W.lexingErrors.length>0?W.lexingErrors.map(ae=>({errorMessage:ae.additionalInfo?(0,R.localize)(9,null,ae.additionalInfo):(0,R.localize)(10,null),offset:ae.offset,length:ae.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ae=>({errorMessage:ae.additionalInfo?`${ae.message}. ${ae.additionalInfo}`:ae.message,offset:ae.offset,length:ae.lexeme.length})):[]))}function u(K,W){const se=K?K.substituteConstants():void 0,ae=W?W.substituteConstants():void 0;return!se&&!ae?!0:!se||!ae?!1:se.equals(ae)}function w(K,W){return K.cmp(W)}class y{static{this.INSTANCE=new y}constructor(){this.type=l.False}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return D.INSTANCE}}e.$Gj=y;class D{static{this.INSTANCE=new D}constructor(){this.type=l.True}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return y.INSTANCE}}e.$Hj=D;class S{static create(W,se=null){const ae=a.get(W);return typeof ae=="boolean"?ae?D.INSTANCE:y.INSTANCE:new S(W,se)}constructor(W,se){this.key=W,this.c=se,this.type=l.Defined}cmp(W){return W.type!==this.type?this.type-W.type:ee(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=a.get(this.key);return typeof W=="boolean"?W?D.INSTANCE:y.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Ij=S;class C{static create(W,se,ae=null){if(typeof se=="boolean")return se?S.create(W,ae):M.create(W,ae);const te=a.get(W);return typeof te=="boolean"?se===(te?"true":"false")?D.INSTANCE:y.INSTANCE:new C(W,se,ae)}constructor(W,se,ae){this.c=W,this.d=se,this.f=ae,this.type=l.Equals}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=a.get(this.c);if(typeof W=="boolean"){const se=W?"true":"false";return this.d===se?D.INSTANCE:y.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Jj=C;class A{static create(W,se){return new A(W,se)}constructor(W,se){this.d=W,this.f=se,this.type=l.In,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:he(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const se=W.getValue(this.f),ae=W.getValue(this.d);return Array.isArray(se)?se.includes(ae):typeof ae=="string"&&typeof se=="object"&&se!==null?E.call(se,ae):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$Kj=A;class b{static create(W,se){return new b(W,se)}constructor(W,se){this.d=W,this.f=se,this.type=l.NotIn,this.c=A.create(W,se)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=b;class v{static create(W,se,ae=null){if(typeof se=="boolean")return se?M.create(W,ae):S.create(W,ae);const te=a.get(W);return typeof te=="boolean"?se===(te?"true":"false")?y.INSTANCE:D.INSTANCE:new v(W,se,ae)}constructor(W,se,ae){this.c=W,this.d=se,this.f=ae,this.type=l.NotEquals}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=a.get(this.c);if(typeof W=="boolean"){const se=W?"true":"false";return this.d===se?y.INSTANCE:D.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Mj=v;class M{static create(W,se=null){const ae=a.get(W);return typeof ae=="boolean"?ae?y.INSTANCE:D.INSTANCE:new M(W,se)}constructor(W,se){this.c=W,this.d=se,this.type=l.Not}cmp(W){return W.type!==this.type?this.type-W.type:ee(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=a.get(this.c);return typeof W=="boolean"?W?y.INSTANCE:D.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$Nj=M;function N(K,W){if(typeof K=="string"){const se=parseFloat(K);isNaN(se)||(K=se)}return typeof K=="string"||typeof K=="number"?W(K):y.INSTANCE}class L{static create(W,se,ae=null){return N(se,te=>new L(W,te,ae))}constructor(W,se,ae){this.c=W,this.d=se,this.f=ae,this.type=l.Greater}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Oj=L;class j{static create(W,se,ae=null){return N(se,te=>new j(W,te,ae))}constructor(W,se,ae){this.c=W,this.d=se,this.f=ae,this.type=l.GreaterEquals}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Pj=j;class z{static create(W,se,ae=null){return N(se,te=>new z(W,te,ae))}constructor(W,se,ae){this.c=W,this.d=se,this.f=ae,this.type=l.Smaller}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Qj=z;class F{static create(W,se,ae=null){return N(se,te=>new F(W,te,ae))}constructor(W,se,ae){this.c=W,this.d=se,this.f=ae,this.type=l.SmallerEquals}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Rj=F;class B{static create(W,se){return new B(W,se)}constructor(W,se){this.d=W,this.f=se,this.type=l.Regex,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const se=this.f?this.f.source:"",ae=W.f?W.f.source:"";return se<ae?-1:se>ae?1:0}equals(W){if(W.type===this.type){const se=this.f?this.f.source:"",ae=W.f?W.f.source:"";return this.d===W.d&&se===ae}return!1}substituteConstants(){return this}evaluate(W){const se=W.getValue(this.d);return this.f?this.f.test(se):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=_.create(this)),this.c}}e.$Sj=B;class _{static create(W){return new _(W)}constructor(W){this.c=W,this.type=l.NotRegex}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new _(this.c.map(W))}negate(){return this.c}}e.$Tj=_;function re(K){let W=null;for(let se=0,ae=K.length;se<ae;se++){const te=K[se].substituteConstants();if(K[se]!==te&&W===null){W=[];for(let le=0;le<se;le++)W[le]=K[le]}W!==null&&(W[se]=te)}return W===null?K:W}class U{static create(W,se,ae){return U.d(W,se,ae)}constructor(W,se){this.expr=W,this.c=se,this.type=l.And}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let se=0,ae=this.expr.length;se<ae;se++){const te=w(this.expr[se],W.expr[se]);if(te!==0)return te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].equals(W.expr[se]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:U.create(W,this.c,!1)}evaluate(W){for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].evaluate(W))return!1;return!0}static d(W,se,ae){const te=[];let le=!1;for(const ue of W)if(ue){if(ue.type===l.True){le=!0;continue}if(ue.type===l.False)return y.INSTANCE;if(ue.type===l.And){te.push(...ue.expr);continue}te.push(ue)}if(te.length===0&&le)return D.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(w);for(let ue=1;ue<te.length;ue++)te[ue-1].equals(te[ue])&&(te.splice(ue,1),ue--);if(te.length===1)return te[0];for(;te.length>1;){const ue=te[te.length-1];if(ue.type!==l.Or)break;te.pop();const X=te.pop(),oe=te.length===0,pe=G.create(ue.expr.map(we=>U.create([we,X],null,ae)),null,oe);pe&&(te.push(pe),te.sort(w))}if(te.length===1)return te[0];if(ae){for(let ue=0;ue<te.length;ue++)for(let X=ue+1;X<te.length;X++)if(te[ue].negate().equals(te[X]))return y.INSTANCE;if(te.length===1)return te[0]}return new U(te,se)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const se of this.expr)W.push(...se.keys());return W}map(W){return new U(this.expr.map(se=>se.map(W)),null)}negate(){if(!this.c){const W=[];for(const se of this.expr)W.push(se.negate());this.c=G.create(W,this,!0)}return this.c}}e.$Uj=U;class G{static create(W,se,ae){return G.d(W,se,ae)}constructor(W,se){this.expr=W,this.c=se,this.type=l.Or}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let se=0,ae=this.expr.length;se<ae;se++){const te=w(this.expr[se],W.expr[se]);if(te!==0)return te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].equals(W.expr[se]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:G.create(W,this.c,!1)}evaluate(W){for(let se=0,ae=this.expr.length;se<ae;se++)if(this.expr[se].evaluate(W))return!0;return!1}static d(W,se,ae){let te=[],le=!1;if(W){for(let ue=0,X=W.length;ue<X;ue++){const oe=W[ue];if(oe){if(oe.type===l.False){le=!0;continue}if(oe.type===l.True)return D.INSTANCE;if(oe.type===l.Or){te=te.concat(oe.expr);continue}te.push(oe)}}if(te.length===0&&le)return y.INSTANCE;te.sort(w)}if(te.length!==0){if(te.length===1)return te[0];for(let ue=1;ue<te.length;ue++)te[ue-1].equals(te[ue])&&(te.splice(ue,1),ue--);if(te.length===1)return te[0];if(ae){for(let ue=0;ue<te.length;ue++)for(let X=ue+1;X<te.length;X++)if(te[ue].negate().equals(te[X]))return D.INSTANCE;if(te.length===1)return te[0]}return new G(te,se)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const se of this.expr)W.push(...se.keys());return W}map(W){return new G(this.expr.map(se=>se.map(W)),null)}negate(){if(!this.c){const W=[];for(const se of this.expr)W.push(se.negate());for(;W.length>1;){const se=W.shift(),ae=W.shift(),te=[];for(const le of $e(se))for(const ue of $e(ae))te.push(U.create([le,ue],null,!1));W.unshift(G.create(te,null,!1))}this.c=G.create(W,this,!0)}return this.c}}e.$Vj=G;class Q extends S{static{this.d=[]}static all(){return Q.d.values()}constructor(W,se,ae){super(W,null),this.f=se,typeof ae=="object"?Q.d.push({...ae,key:W}):ae!==!0&&Q.d.push({key:W,description:ae,type:se!=null?typeof se:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return C.create(this.key,W)}notEqualsTo(W){return v.create(this.key,W)}}e.$Wj=Q,e.$Xj=(0,T.$Fi)("contextKeyService");function ee(K,W){return K<W?-1:K>W?1:0}function he(K,W,se,ae){return K<se?-1:K>se?1:W<ae?-1:W>ae?1:0}function ne(K,W){if(K.type===l.False||W.type===l.True)return!0;if(K.type===l.Or)return W.type===l.Or?De(K.expr,W.expr):!1;if(W.type===l.Or){for(const se of W.expr)if(ne(K,se))return!0;return!1}if(K.type===l.And){if(W.type===l.And)return De(W.expr,K.expr);for(const se of K.expr)if(ne(se,W))return!0;return!1}return K.equals(W)}function De(K,W){let se=0,ae=0;for(;se<K.length&&ae<W.length;){const te=K[se].cmp(W[ae]);if(te<0)return!1;te===0&&se++,ae++}return se===K.length}function $e(K){return K.type===l.Or?K.expr:[K]}}),define(ye[265],Se([1,0,36,5]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$pt=e.AccessibilitySupport=e.$ot=void 0,e.$qt=O,e.$ot=(0,h.$Fi)("accessibilityService");var P;(function(T){T[T.Unknown=0]="Unknown",T[T.Disabled=1]="Disabled",T[T.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$pt=new r.$Wj("accessibilityModeEnabled",!1);function O(T){return T&&typeof T=="object"&&typeof T.label=="string"&&(typeof T.role>"u"||typeof T.role=="string")}e.$rt="ACCESSIBLE_VIEW_SHOWN_"}),define(ye[114],Se([1,0,19,25,11,184,84,192,138,216,265]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=n,e.clampedInt=t,e.clampedFloat=s,e.stringSet=w,e.cursorStyleToString=N,e.filterValidationDecorations=Ie,r=We(r),h=We(h),P=We(P),a=We(a);var E;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class l{constructor(de){this.c=de}hasChanged(de){return this.c[de]}}e.ConfigurationChangedEvent=l;class k{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=k;class p{constructor(de,Ce,Xe,_e){this.id=de,this.name=Ce,this.defaultValue=Xe,this.schema=_e}applyUpdate(de,Ce){return m(de,Ce)}compute(de,Ce,Xe){return Xe}}class c{constructor(de,Ce){this.newValue=de,this.didChange=Ce}}e.ApplyUpdateResult=c;function m(Y,de){if(typeof Y!="object"||typeof de!="object"||!Y||!de)return new c(de,Y!==de);if(Array.isArray(Y)||Array.isArray(de)){const Xe=Array.isArray(Y)&&Array.isArray(de)&&r.$wb(Y,de);return new c(de,!Xe)}let Ce=!1;for(const Xe in de)if(de.hasOwnProperty(Xe)){const _e=m(Y[Xe],de[Xe]);_e.didChange&&(Y[Xe]=_e.newValue,Ce=!0)}return new c(Y,Ce)}class d{constructor(de){this.schema=void 0,this.id=de,this.name="_never_",this.defaultValue=void 0}applyUpdate(de,Ce){return m(de,Ce)}validate(de){return this.defaultValue}}class g{constructor(de,Ce,Xe,_e){this.id=de,this.name=Ce,this.defaultValue=Xe,this.schema=_e}applyUpdate(de,Ce){return m(de,Ce)}validate(de){return typeof de>"u"?this.defaultValue:de}compute(de,Ce,Xe){return Xe}}function n(Y,de){return typeof Y>"u"?de:Y==="false"?!1:!!Y}class o extends g{constructor(de,Ce,Xe,_e=void 0){typeof _e<"u"&&(_e.type="boolean",_e.default=Xe),super(de,Ce,Xe,_e)}validate(de){return n(de,this.defaultValue)}}function t(Y,de,Ce,Xe){if(typeof Y>"u")return de;let _e=parseInt(Y,10);return isNaN(_e)?de:(_e=Math.max(Ce,_e),_e=Math.min(Xe,_e),_e|0)}class i extends g{static clampedInt(de,Ce,Xe,_e){return t(de,Ce,Xe,_e)}constructor(de,Ce,Xe,_e,ut,gt=void 0){typeof gt<"u"&&(gt.type="integer",gt.default=Xe,gt.minimum=_e,gt.maximum=ut),super(de,Ce,Xe,gt),this.minimum=_e,this.maximum=ut}validate(de){return i.clampedInt(de,this.defaultValue,this.minimum,this.maximum)}}function s(Y,de,Ce,Xe){if(typeof Y>"u")return de;const _e=f.float(Y,de);return f.clamp(_e,Ce,Xe)}class f extends g{static clamp(de,Ce,Xe){return de<Ce?Ce:de>Xe?Xe:de}static float(de,Ce){if(typeof de=="number")return de;if(typeof de>"u")return Ce;const Xe=parseFloat(de);return isNaN(Xe)?Ce:Xe}constructor(de,Ce,Xe,_e,ut){typeof ut<"u"&&(ut.type="number",ut.default=Xe),super(de,Ce,Xe,ut),this.validationFn=_e}validate(de){return this.validationFn(f.float(de,this.defaultValue))}}class u extends g{static string(de,Ce){return typeof de!="string"?Ce:de}constructor(de,Ce,Xe,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.default=Xe),super(de,Ce,Xe,_e)}validate(de){return u.string(de,this.defaultValue)}}function w(Y,de,Ce,Xe){return typeof Y!="string"?de:Xe&&Y in Xe?Xe[Y]:Ce.indexOf(Y)===-1?de:Y}class y extends g{constructor(de,Ce,Xe,_e,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=_e,ut.default=Xe),super(de,Ce,Xe,ut),this.c=_e}validate(de){return w(de,this.defaultValue,this.c)}}class D extends p{constructor(de,Ce,Xe,_e,ut,gt,kt=void 0){typeof kt<"u"&&(kt.type="string",kt.enum=ut,kt.default=_e),super(de,Ce,Xe,kt),this.c=ut,this.d=gt}validate(de){return typeof de!="string"?this.defaultValue:this.c.indexOf(de)===-1?this.defaultValue:this.d(de)}}function S(Y){switch(Y){case"none":return E.None;case"keep":return E.Keep;case"brackets":return E.Brackets;case"advanced":return E.Advanced;case"full":return E.Full}}class C extends p{constructor(){super(je.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(de){switch(de){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(de,Ce,Xe){return Xe===I.AccessibilitySupport.Unknown?de.accessibilitySupport:Xe}}class A extends p{constructor(){const de={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",de,{"editor.comments.insertSpace":{type:"boolean",default:de.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:de.ignoreEmptyLines,description:a.localize(5,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{insertSpace:n(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var b;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(b||(e.TextEditorCursorBlinkingStyle=b={}));function v(Y){switch(Y){case"blink":return b.Blink;case"smooth":return b.Smooth;case"phase":return b.Phase;case"expand":return b.Expand;case"solid":return b.Solid}}var M;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function N(Y){switch(Y){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function L(Y){switch(Y){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class j extends d{constructor(){super(je.editorClassName)}compute(de,Ce,Xe){const _e=["monaco-editor"];return Ce.get(je.extraEditorClassName)&&_e.push(Ce.get(je.extraEditorClassName)),de.extraEditorClassName&&_e.push(de.extraEditorClassName),Ce.get(je.mouseStyle)==="default"?_e.push("mouse-default"):Ce.get(je.mouseStyle)==="copy"&&_e.push("mouse-copy"),Ce.get(je.showUnused)&&_e.push("showUnused"),Ce.get(je.showDeprecated)&&_e.push("showDeprecated"),_e.join(" ")}}class z extends o{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(de,Ce,Xe){return Xe&&de.emptySelectionClipboard}}class F extends p{constructor(){const de={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",de,{"editor.find.cursorMoveOnType":{type:"boolean",default:de.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:de.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:de.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:de.globalFindClipboard,description:a.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:de.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:de.loop,description:a.localize(18,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{cursorMoveOnType:n(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof de.seedSearchStringFromSelection=="boolean"?de.seedSearchStringFromSelection?"always":"never":w(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof de.autoFindInSelection=="boolean"?de.autoFindInSelection?"always":"never":w(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(Ce.loop,this.defaultValue.loop)}}}class B extends p{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de==="false"||de.length===0?B.OFF:de==="true"?B.ON:de:de?B.ON:B.OFF}}e.EditorFontLigatures=B;class _ extends p{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",_.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de==="false"?_.OFF:de==="true"?_.TRANSLATE:de:de?_.TRANSLATE:_.OFF}compute(de,Ce,Xe){return de.fontInfo.fontVariationSettings}}e.EditorFontVariations=_;class re extends d{constructor(){super(je.fontInfo)}compute(de,Ce,Xe){return de.fontInfo}}class U extends g{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(de){const Ce=f.float(de,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(Ce,6,100)}compute(de,Ce,Xe){return de.fontInfo.fontSize}}class G extends p{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.d,maximum:G.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(de){return de==="normal"||de==="bold"?de:String(i.clampedInt(de,e.EDITOR_FONT_DEFAULTS.fontWeight,G.d,G.e))}}class Q extends p{constructor(){const de={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:de.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",de,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:de.alternativeDefinitionCommand,enum:Xe,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:de.alternativeTypeDefinitionCommand,enum:Xe,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:de.alternativeDeclarationCommand,enum:Xe,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:de.alternativeImplementationCommand,enum:Xe,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:de.alternativeReferenceCommand,enum:Xe,description:a.localize(41,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{multiple:w(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??w(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??w(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??w(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??w(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??w(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:u.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:u.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:u.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:u.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:u.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends p{constructor(){const de={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",de,{"editor.hover.enabled":{type:"boolean",default:de.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:de.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:de.sticky,description:a.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:de.hidingDelay,description:a.localize(45,null)},"editor.hover.above":{type:"boolean",default:de.above,description:a.localize(46,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:n(Ce.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:n(Ce.above,this.defaultValue.above)}}}var he;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(he||(e.RenderMinimap=he={}));class ne extends d{constructor(){super(je.layoutInfo)}compute(de,Ce,Xe){return ne.computeLayout(Ce,{memory:de.memory,outerWidth:de.outerWidth,outerHeight:de.outerHeight,isDominatedByLongLines:de.isDominatedByLongLines,lineHeight:de.fontInfo.lineHeight,viewLineCount:de.viewLineCount,lineNumbersDigitCount:de.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:de.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:de.fontInfo.maxDigitWidth,pixelRatio:de.pixelRatio,glyphMarginDecorationLaneCount:de.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(de){const Ce=de.height/de.lineHeight,Xe=Math.floor(de.paddingTop/de.lineHeight);let _e=Math.floor(de.paddingBottom/de.lineHeight);de.scrollBeyondLastLine&&(_e=Math.max(_e,Ce-1));const ut=(Xe+de.viewLineCount+_e)/(de.pixelRatio*de.height),gt=Math.floor(de.viewLineCount/ut);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:_e,desiredRatio:ut,minimapLineCount:gt}}static c(de,Ce){const Xe=de.outerWidth,_e=de.outerHeight,ut=de.pixelRatio;if(!de.minimap.enabled)return{renderMinimap:he.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*_e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:_e};const gt=Ce.stableMinimapLayoutInput,kt=gt&&de.outerHeight===gt.outerHeight&&de.lineHeight===gt.lineHeight&&de.typicalHalfwidthCharacterWidth===gt.typicalHalfwidthCharacterWidth&&de.pixelRatio===gt.pixelRatio&&de.scrollBeyondLastLine===gt.scrollBeyondLastLine&&de.paddingTop===gt.paddingTop&&de.paddingBottom===gt.paddingBottom&&de.minimap.enabled===gt.minimap.enabled&&de.minimap.side===gt.minimap.side&&de.minimap.size===gt.minimap.size&&de.minimap.showSlider===gt.minimap.showSlider&&de.minimap.renderCharacters===gt.minimap.renderCharacters&&de.minimap.maxColumn===gt.minimap.maxColumn&&de.minimap.scale===gt.minimap.scale&&de.verticalScrollbarWidth===gt.verticalScrollbarWidth&&de.isViewportWrapping===gt.isViewportWrapping,Nt=de.lineHeight,Bt=de.typicalHalfwidthCharacterWidth,fi=de.scrollBeyondLastLine,it=de.minimap.renderCharacters;let At=ut>=2?Math.round(de.minimap.scale*2):de.minimap.scale;const Kt=de.minimap.maxColumn,Qt=de.minimap.size,pt=de.minimap.side,vt=de.verticalScrollbarWidth,ii=de.viewLineCount,xt=de.remainingWidth,Gt=de.isViewportWrapping,Et=it?2:3;let Ft=Math.floor(ut*_e);const ui=Ft/ut;let Ht=!1,xe=!1,_t=Et*At,ni=At/ut,hi=1;if(Qt==="fill"||Qt==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:Wt,extraLinesBeyondLastLine:Jt,desiredRatio:oi,minimapLineCount:Rt}=ne.computeContainedMinimapLineCount({viewLineCount:ii,scrollBeyondLastLine:fi,paddingTop:de.paddingTop,paddingBottom:de.paddingBottom,height:_e,lineHeight:Nt,pixelRatio:ut});if(ii/Rt>1)Ht=!0,xe=!0,At=1,_t=1,ni=At/ut;else{let wt=!1,ti=At+1;if(Qt==="fit"){const Pt=Math.ceil((Wt+ii+Jt)*_t);Gt&&kt&&xt<=Ce.stableFitRemainingWidth?(wt=!0,ti=Ce.stableFitMaxMinimapScale):wt=Pt>Ft}if(Qt==="fill"||wt){Ht=!0;const Pt=At;_t=Math.min(Nt*ut,Math.max(1,Math.floor(1/oi))),Gt&&kt&&xt<=Ce.stableFitRemainingWidth&&(ti=Ce.stableFitMaxMinimapScale),At=Math.min(ti,Math.max(1,Math.floor(_t/Et))),At>Pt&&(hi=Math.min(2,At/Pt)),ni=At/ut/hi,Ft=Math.ceil(Math.max(si,Wt+ii+Jt)*_t),Gt?(Ce.stableMinimapLayoutInput=de,Ce.stableFitRemainingWidth=xt,Ce.stableFitMaxMinimapScale=At):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const It=Math.floor(Kt*ni),Mt=Math.min(It,Math.max(0,Math.floor((xt-vt-2)*ni/(Bt+ni)))+e.MINIMAP_GUTTER_WIDTH);let Ot=Math.floor(ut*Mt);const Ut=Ot/ut;Ot=Math.floor(Ot*hi);const ri=it?he.Text:he.Blocks,ei=pt==="left"?0:Xe-Mt-vt;return{renderMinimap:ri,minimapLeft:ei,minimapWidth:Mt,minimapHeightIsEditorHeight:Ht,minimapIsSampling:xe,minimapScale:At,minimapLineHeight:_t,minimapCanvasInnerWidth:Ot,minimapCanvasInnerHeight:Ft,minimapCanvasOuterWidth:Ut,minimapCanvasOuterHeight:ui}}static computeLayout(de,Ce){const Xe=Ce.outerWidth|0,_e=Ce.outerHeight|0,ut=Ce.lineHeight|0,gt=Ce.lineNumbersDigitCount|0,kt=Ce.typicalHalfwidthCharacterWidth,Nt=Ce.maxDigitWidth,Bt=Ce.pixelRatio,fi=Ce.viewLineCount,it=de.get(je.wordWrapOverride2),At=it==="inherit"?de.get(je.wordWrapOverride1):it,Kt=At==="inherit"?de.get(je.wordWrap):At,Qt=de.get(je.wordWrapColumn),pt=Ce.isDominatedByLongLines,vt=de.get(je.glyphMargin),ii=de.get(je.lineNumbers).renderType!==Ue.Off,xt=de.get(je.lineNumbersMinChars),Gt=de.get(je.scrollBeyondLastLine),Et=de.get(je.padding),Ft=de.get(je.minimap),ui=de.get(je.scrollbar),Ht=ui.verticalScrollbarSize,xe=ui.verticalHasArrows,_t=ui.arrowSize,ni=ui.horizontalScrollbarSize,hi=de.get(je.folding),It=de.get(je.showFoldingControls)!=="never";let Mt=de.get(je.lineDecorationsWidth);hi&&It&&(Mt+=16);let Ot=0;if(ii){const Zt=Math.max(gt,xt);Ot=Math.round(Zt*Nt)}let Ut=0;vt&&(Ut=ut*Ce.glyphMarginDecorationLaneCount);let ri=0,ei=ri+Ut,si=ei+Ot,Wt=si+Mt;const Jt=Xe-Ut-Ot-Mt;let oi=!1,Rt=!1,Dt=-1;At==="inherit"&&pt?(oi=!0,Rt=!0):Kt==="on"||Kt==="bounded"?Rt=!0:Kt==="wordWrapColumn"&&(Dt=Qt);const wt=ne.c({outerWidth:Xe,outerHeight:_e,lineHeight:ut,typicalHalfwidthCharacterWidth:kt,pixelRatio:Bt,scrollBeyondLastLine:Gt,paddingTop:Et.top,paddingBottom:Et.bottom,minimap:Ft,verticalScrollbarWidth:Ht,viewLineCount:fi,remainingWidth:Jt,isViewportWrapping:Rt},Ce.memory||new k);wt.renderMinimap!==he.None&&wt.minimapLeft===0&&(ri+=wt.minimapWidth,ei+=wt.minimapWidth,si+=wt.minimapWidth,Wt+=wt.minimapWidth);const ti=Jt-wt.minimapWidth,Pt=Math.max(1,Math.floor((ti-Ht-2)/kt)),di=xe?_t:0;return Rt&&(Dt=Math.max(1,Pt),Kt==="bounded"&&(Dt=Math.min(Dt,Qt))),{width:Xe,height:_e,glyphMarginLeft:ri,glyphMarginWidth:Ut,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:ei,lineNumbersWidth:Ot,decorationsLeft:si,decorationsWidth:Mt,contentLeft:Wt,contentWidth:ti,minimap:wt,viewportColumn:Pt,isWordWrapMinified:oi,isViewportWrapping:Rt,wrappingColumn:Dt,verticalScrollbarWidth:Ht,horizontalScrollbarHeight:ni,overviewRuler:{top:di,width:Ht,height:_e-2*di,right:0}}}}e.EditorLayoutInfoComputer=ne;class De extends p{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(47,null),a.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(49,null)}})}validate(de){return w(de,"simple",["simple","advanced"])}compute(de,Ce,Xe){return Ce.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Xe}}var $e;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})($e||(e.ShowLightbulbIconMode=$e={}));class K extends p{constructor(){const de={enabled:$e.On};super(je.lightbulb,"lightbulb",de,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[$e.Off,$e.OnCode,$e.On],default:de.enabled,enumDescriptions:[a.localize(50,null),a.localize(51,null),a.localize(52,null)],description:a.localize(53,null)}})}validate(de){return!de||typeof de!="object"?this.defaultValue:{enabled:w(de.enabled,this.defaultValue.enabled,[$e.Off,$e.OnCode,$e.On])}}}class W extends p{constructor(){const de={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",de,{"editor.stickyScroll.enabled":{type:"boolean",default:de.enabled,description:a.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:de.maxLineCount,minimum:1,maximum:20,description:a.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:de.defaultModel,description:a.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:de.scrollWithEditor,description:a.localize(57,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:w(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:n(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends p{constructor(){const de={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",de,{"editor.inlayHints.enabled":{type:"string",default:de.enabled,description:a.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(59,null),a.localize(60,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),a.localize(61,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),a.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:de.fontSize,markdownDescription:a.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:de.fontFamily,markdownDescription:a.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:de.padding,description:a.localize(65,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:w(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:u.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:n(Ce.padding,this.defaultValue.padding)}}}class ae extends p{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(de){return typeof de=="string"&&/^\d+(\.\d+)?ch$/.test(de)?-parseFloat(de.substring(0,de.length-2)):i.clampedInt(de,this.defaultValue,0,1e3)}compute(de,Ce,Xe){return Xe<0?i.clampedInt(-Xe*de.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class te extends f{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,de=>f.clamp(de,0,150),{markdownDescription:a.localize(66,null)})}compute(de,Ce,Xe){return de.fontInfo.lineHeight}}class le extends p{constructor(){const de={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",de,{"editor.minimap.enabled":{type:"boolean",default:de.enabled,description:a.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:de.autohide,description:a.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(69,null),a.localize(70,null),a.localize(71,null)],default:de.size,description:a.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:de.side,description:a.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:de.showSlider,description:a.localize(74,null)},"editor.minimap.scale":{type:"number",default:de.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:de.renderCharacters,description:a.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:de.maxColumn,description:a.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:de.showRegionSectionHeaders,description:a.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:de.showMarkSectionHeaders,description:a.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:de.sectionHeaderFontSize,description:a.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:de.sectionHeaderLetterSpacing,description:a.localize(81,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),autohide:n(Ce.autohide,this.defaultValue.autohide),size:w(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(Ce.side,this.defaultValue.side,["right","left"]),showSlider:w(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ce.scale,1,1,3),maxColumn:i.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:n(Ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:n(Ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:f.clamp(Ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:f.clamp(Ce.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function ue(Y){return Y==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class X extends p{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(83,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{top:i.clampedInt(Ce.top,0,0,1e3),bottom:i.clampedInt(Ce.bottom,0,0,1e3)}}}class oe extends p{constructor(){const de={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",de,{"editor.parameterHints.enabled":{type:"boolean",default:de.enabled,description:a.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:de.cycle,description:a.localize(85,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),cycle:n(Ce.cycle,this.defaultValue.cycle)}}}class pe extends d{constructor(){super(je.pixelRatio)}compute(de,Ce,Xe){return de.pixelRatio}}class we extends p{constructor(){super(je.placeholder,"placeholder",void 0)}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de:this.defaultValue}}class Fe extends p{constructor(){const de={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(86,null),a.localize(87,null),a.localize(88,null)]}];super(je.quickSuggestions,"quickSuggestions",de,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:de.strings,description:a.localize(89,null)},comments:{anyOf:Ce,default:de.comments,description:a.localize(90,null)},other:{anyOf:Ce,default:de.other,description:a.localize(91,null)}},default:de,markdownDescription:a.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=de}validate(de){if(typeof de=="boolean"){const Bt=de?"on":"off";return{comments:Bt,strings:Bt,other:Bt}}if(!de||typeof de!="object")return this.defaultValue;const{other:Ce,comments:Xe,strings:_e}=de,ut=["on","inline","off"];let gt,kt,Nt;return typeof Ce=="boolean"?gt=Ce?"on":"off":gt=w(Ce,this.defaultValue.other,ut),typeof Xe=="boolean"?kt=Xe?"on":"off":kt=w(Xe,this.defaultValue.comments,ut),typeof _e=="boolean"?Nt=_e?"on":"off":Nt=w(_e,this.defaultValue.strings,ut),{other:gt,comments:kt,strings:Nt}}}var Ue;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(Ue||(e.RenderLineNumbersType=Ue={}));class ke extends p{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:Ue.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(93,null),a.localize(94,null),a.localize(95,null),a.localize(96,null)],default:"on",description:a.localize(97,null)})}validate(de){let Ce=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof de<"u"&&(typeof de=="function"?(Ce=Ue.Custom,Xe=de):de==="interval"?Ce=Ue.Interval:de==="relative"?Ce=Ue.Relative:de==="on"?Ce=Ue.On:Ce=Ue.Off),{renderType:Ce,renderFn:Xe}}}function Ie(Y){const de=Y.get(je.renderValidationDecorations);return de==="editable"?Y.get(je.readOnly):de!=="on"}class Oe extends p{constructor(){const de=[],Ce={type:"number",description:a.localize(98,null)};super(je.rulers,"rulers",de,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:a.localize(99,null),format:"color-hex"}}}]},default:de,description:a.localize(100,null)})}validate(de){if(Array.isArray(de)){const Ce=[];for(const Xe of de)if(typeof Xe=="number")Ce.push({column:i.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const _e=Xe;Ce.push({column:i.clampedInt(_e.column,0,0,1e4),color:_e.color})}return Ce.sort((Xe,_e)=>Xe.column-_e.column),Ce}return this.defaultValue}}class q extends p{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(de){return!de||typeof de!="object"?this.defaultValue:de}}function V(Y,de){if(typeof Y!="string")return de;switch(Y){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class J extends p{constructor(){const de={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",de,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(101,null),a.localize(102,null),a.localize(103,null)],default:"auto",description:a.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(105,null),a.localize(106,null),a.localize(107,null)],default:"auto",description:a.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:de.verticalScrollbarSize,description:a.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:de.horizontalScrollbarSize,description:a.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:de.scrollByPage,description:a.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:de.ignoreHorizontalScrollbarInContentHeight,description:a.localize(112,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de,Xe=i.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),_e=i.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:V(Ce.vertical,this.defaultValue.vertical),horizontal:V(Ce.horizontal,this.defaultValue.horizontal),useShadows:n(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:i.clampedInt(Ce.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:_e,verticalSliderSize:i.clampedInt(Ce.verticalSliderSize,_e,0,1e3),scrollByPage:n(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:n(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class x extends p{constructor(){const de={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",de,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.nonBasicASCII,description:a.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:de.invisibleCharacters,description:a.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:de.ambiguousCharacters,description:a.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.includeComments,description:a.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.includeStrings,description:a.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:de.allowedCharacters,description:a.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:de.allowedLocales,description:a.localize(119,null)}})}applyUpdate(de,Ce){let Xe=!1;Ce.allowedCharacters&&de&&(h.$ho(de.allowedCharacters,Ce.allowedCharacters)||(de={...de,allowedCharacters:Ce.allowedCharacters},Xe=!0)),Ce.allowedLocales&&de&&(h.$ho(de.allowedLocales,Ce.allowedLocales)||(de={...de,allowedLocales:Ce.allowedLocales},Xe=!0));const _e=super.applyUpdate(de,Ce);return Xe?new c(_e.newValue,!0):_e}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{nonBasicASCII:Ze(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ze(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ze(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(de.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(de.allowedLocales,this.defaultValue.allowedLocales)}}c(de,Ce){if(typeof de!="object"||!de)return Ce;const Xe={};for(const[_e,ut]of Object.entries(de))ut===!0&&(Xe[_e]=!0);return Xe}}class fe extends p{constructor(){const de={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",de,{"editor.inlineSuggest.enabled":{type:"boolean",default:de.enabled,description:a.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:de.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(121,null),a.localize(122,null),a.localize(123,null)],description:a.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:de.suppressSuggestions,description:a.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:de.fontFamily,description:a.localize(126,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),mode:w(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:w(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:n(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:u.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class be extends p{constructor(){const de={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(je.inlineEdit,"experimentalInlineEdit",de,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:de.enabled,description:a.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:de.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(128,null),a.localize(129,null),a.localize(130,null)],description:a.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:de.fontFamily,description:a.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:de.backgroundColoring,description:a.localize(133,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showToolbar:w(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:u.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:n(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:n(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Ne extends p{constructor(){const de={enabled:R.$it.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$it.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",de,{"editor.bracketPairColorization.enabled":{type:"boolean",default:de.enabled,markdownDescription:a.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:de.independentColorPoolPerBracketType,description:a.localize(135,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ge extends p{constructor(){const de={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",de,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(136,null),a.localize(137,null),a.localize(138,null)],default:de.bracketPairs,description:a.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(140,null),a.localize(141,null),a.localize(142,null)],default:de.bracketPairsHorizontal,description:a.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:de.highlightActiveBracketPair,description:a.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:de.indentation,description:a.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(146,null),a.localize(147,null),a.localize(148,null)],default:de.highlightActiveIndentation,description:a.localize(149,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{bracketPairs:Ze(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ze(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ze(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ze(Y,de,Ce){const Xe=Ce.indexOf(Y);return Xe===-1?de:Ce[Xe]}class et extends p{constructor(){const de={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",de,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(150,null),a.localize(151,null)],default:de.insertMode,description:a.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:de.filterGraceful,description:a.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:de.localityBonus,description:a.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:de.shareSuggestSelections,markdownDescription:a.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(156,null),a.localize(157,null),a.localize(158,null),a.localize(159,null)],default:de.selectionMode,markdownDescription:a.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:de.snippetsPreventQuickSuggestions,description:a.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:de.showIcons,description:a.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:de.showStatusBar,description:a.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:de.preview,description:a.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:de.showInlineDetails,description:a.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(197,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{insertMode:w(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:w(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:n(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:n(Ce.preview,this.defaultValue.preview),previewMode:w(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(Ce.showMethods,this.defaultValue.showMethods),showFunctions:n(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:n(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(Ce.showFields,this.defaultValue.showFields),showVariables:n(Ce.showVariables,this.defaultValue.showVariables),showClasses:n(Ce.showClasses,this.defaultValue.showClasses),showStructs:n(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:n(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:n(Ce.showModules,this.defaultValue.showModules),showProperties:n(Ce.showProperties,this.defaultValue.showProperties),showEvents:n(Ce.showEvents,this.defaultValue.showEvents),showOperators:n(Ce.showOperators,this.defaultValue.showOperators),showUnits:n(Ce.showUnits,this.defaultValue.showUnits),showValues:n(Ce.showValues,this.defaultValue.showValues),showConstants:n(Ce.showConstants,this.defaultValue.showConstants),showEnums:n(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:n(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(Ce.showKeywords,this.defaultValue.showKeywords),showWords:n(Ce.showWords,this.defaultValue.showWords),showColors:n(Ce.showColors,this.defaultValue.showColors),showFiles:n(Ce.showFiles,this.defaultValue.showFiles),showReferences:n(Ce.showReferences,this.defaultValue.showReferences),showFolders:n(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:n(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:n(Ce.showUsers,this.defaultValue.showUsers),showIssues:n(Ce.showIssues,this.defaultValue.showIssues)}}}class rt extends p{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:a.localize(199,null),default:!0,type:"boolean"}})}validate(de){return!de||typeof de!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(de.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:n(de.selectSubwords,this.defaultValue.selectSubwords)}}}class ot extends p{constructor(){const de=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",de,{anyOf:[{description:a.localize(200,null),type:"string"},{description:a.localize(201,null),type:"array",items:{type:"string"}}]})}validate(de){if(typeof de=="string"&&(de=[de]),Array.isArray(de)){const Ce=[];for(const Xe of de)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&Ce.push(Xe)}catch{}return Ce}return this.defaultValue}}var nt;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(nt||(e.WrappingIndent=nt={}));class ct extends p{constructor(){super(je.wrappingIndent,"wrappingIndent",nt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(202,null),a.localize(203,null),a.localize(204,null),a.localize(205,null)],description:a.localize(206,null),default:"same"}})}validate(de){switch(de){case"none":return nt.None;case"same":return nt.Same;case"indent":return nt.Indent;case"deepIndent":return nt.DeepIndent}return nt.Same}compute(de,Ce,Xe){return Ce.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?nt.None:Xe}}class mt extends d{constructor(){super(je.wrappingInfo)}compute(de,Ce,Xe){const _e=Ce.get(je.layoutInfo);return{isDominatedByLongLines:de.isDominatedByLongLines,isWordWrapMinified:_e.isWordWrapMinified,isViewportWrapping:_e.isViewportWrapping,wrappingColumn:_e.wrappingColumn}}}class ht extends p{constructor(){const de={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",de,{"editor.dropIntoEditor.enabled":{type:"boolean",default:de.enabled,markdownDescription:a.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:a.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[a.localize(209,null),a.localize(210,null)],default:"afterDrop"}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showDropSelector:w(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends p{constructor(){const de={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",de,{"editor.pasteAs.enabled":{type:"boolean",default:de.enabled,markdownDescription:a.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:a.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[a.localize(213,null),a.localize(214,null)],default:"afterPaste"}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showPasteSelector:w(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Pe="Consolas, 'Courier New', monospace",ze="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?ze:P.$k?He:Pe,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var je;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.inlineEdit=63]="inlineEdit",Y[Y.letterSpacing=64]="letterSpacing",Y[Y.lightbulb=65]="lightbulb",Y[Y.lineDecorationsWidth=66]="lineDecorationsWidth",Y[Y.lineHeight=67]="lineHeight",Y[Y.lineNumbers=68]="lineNumbers",Y[Y.lineNumbersMinChars=69]="lineNumbersMinChars",Y[Y.linkedEditing=70]="linkedEditing",Y[Y.links=71]="links",Y[Y.matchBrackets=72]="matchBrackets",Y[Y.minimap=73]="minimap",Y[Y.mouseStyle=74]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=76]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=78]="multiCursorModifier",Y[Y.multiCursorPaste=79]="multiCursorPaste",Y[Y.multiCursorLimit=80]="multiCursorLimit",Y[Y.occurrencesHighlight=81]="occurrencesHighlight",Y[Y.overviewRulerBorder=82]="overviewRulerBorder",Y[Y.overviewRulerLanes=83]="overviewRulerLanes",Y[Y.padding=84]="padding",Y[Y.pasteAs=85]="pasteAs",Y[Y.parameterHints=86]="parameterHints",Y[Y.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Y[Y.placeholder=88]="placeholder",Y[Y.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=90]="quickSuggestions",Y[Y.quickSuggestionsDelay=91]="quickSuggestionsDelay",Y[Y.readOnly=92]="readOnly",Y[Y.readOnlyMessage=93]="readOnlyMessage",Y[Y.renameOnType=94]="renameOnType",Y[Y.renderControlCharacters=95]="renderControlCharacters",Y[Y.renderFinalNewline=96]="renderFinalNewline",Y[Y.renderLineHighlight=97]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=99]="renderValidationDecorations",Y[Y.renderWhitespace=100]="renderWhitespace",Y[Y.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",Y[Y.roundedSelection=102]="roundedSelection",Y[Y.rulers=103]="rulers",Y[Y.scrollbar=104]="scrollbar",Y[Y.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=106]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=107]="scrollPredominantAxis",Y[Y.selectionClipboard=108]="selectionClipboard",Y[Y.selectionHighlight=109]="selectionHighlight",Y[Y.selectOnLineNumbers=110]="selectOnLineNumbers",Y[Y.showFoldingControls=111]="showFoldingControls",Y[Y.showUnused=112]="showUnused",Y[Y.snippetSuggestions=113]="snippetSuggestions",Y[Y.smartSelect=114]="smartSelect",Y[Y.smoothScrolling=115]="smoothScrolling",Y[Y.stickyScroll=116]="stickyScroll",Y[Y.stickyTabStops=117]="stickyTabStops",Y[Y.stopRenderingLineAfter=118]="stopRenderingLineAfter",Y[Y.suggest=119]="suggest",Y[Y.suggestFontSize=120]="suggestFontSize",Y[Y.suggestLineHeight=121]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",Y[Y.suggestSelection=123]="suggestSelection",Y[Y.tabCompletion=124]="tabCompletion",Y[Y.tabIndex=125]="tabIndex",Y[Y.unicodeHighlighting=126]="unicodeHighlighting",Y[Y.unusualLineTerminators=127]="unusualLineTerminators",Y[Y.useShadowDOM=128]="useShadowDOM",Y[Y.useTabStops=129]="useTabStops",Y[Y.wordBreak=130]="wordBreak",Y[Y.wordSegmenterLocales=131]="wordSegmenterLocales",Y[Y.wordSeparators=132]="wordSeparators",Y[Y.wordWrap=133]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=136]="wordWrapColumn",Y[Y.wordWrapOverride1=137]="wordWrapOverride1",Y[Y.wordWrapOverride2=138]="wordWrapOverride2",Y[Y.wrappingIndent=139]="wrappingIndent",Y[Y.wrappingStrategy=140]="wrappingStrategy",Y[Y.showDeprecated=141]="showDeprecated",Y[Y.inlayHints=142]="inlayHints",Y[Y.editorClassName=143]="editorClassName",Y[Y.pixelRatio=144]="pixelRatio",Y[Y.tabFocusMode=145]="tabFocusMode",Y[Y.layoutInfo=146]="layoutInfo",Y[Y.wrappingInfo=147]="wrappingInfo",Y[Y.defaultColorDecorators=148]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(215,null)})),acceptSuggestionOnEnter:Le(new y(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(216,null),""],markdownDescription:a.localize(217,null)})),accessibilitySupport:Le(new C),accessibilityPageSize:Le(new i(je.accessibilityPageSize,"accessibilityPageSize",10,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(218,null),tags:["accessibility"]})),ariaLabel:Le(new u(je.ariaLabel,"ariaLabel",a.localize(219,null))),ariaRequired:Le(new o(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:a.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Le(new y(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(221,null),a.localize(222,null),""],description:a.localize(223,null)})),autoClosingComments:Le(new y(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(224,null),a.localize(225,null),""],description:a.localize(226,null)})),autoClosingDelete:Le(new y(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(227,null),""],description:a.localize(228,null)})),autoClosingOvertype:Le(new y(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(229,null),""],description:a.localize(230,null)})),autoClosingQuotes:Le(new y(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(231,null),a.localize(232,null),""],description:a.localize(233,null)})),autoIndent:Le(new D(je.autoIndent,"autoIndent",E.Full,"full",["none","keep","brackets","advanced","full"],S,{enumDescriptions:[a.localize(234,null),a.localize(235,null),a.localize(236,null),a.localize(237,null),a.localize(238,null)],description:a.localize(239,null)})),automaticLayout:Le(new o(je.automaticLayout,"automaticLayout",!1)),autoSurround:Le(new y(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(240,null),a.localize(241,null),a.localize(242,null),""],description:a.localize(243,null)})),bracketPairColorization:Le(new Ne),bracketPairGuides:Le(new Ge),stickyTabStops:Le(new o(je.stickyTabStops,"stickyTabStops",!1,{description:a.localize(244,null)})),codeLens:Le(new o(je.codeLens,"codeLens",!0,{description:a.localize(245,null)})),codeLensFontFamily:Le(new u(je.codeLensFontFamily,"codeLensFontFamily","",{description:a.localize(246,null)})),codeLensFontSize:Le(new i(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(247,null)})),colorDecorators:Le(new o(je.colorDecorators,"colorDecorators",!0,{description:a.localize(248,null)})),colorDecoratorActivatedOn:Le(new y(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[a.localize(249,null),a.localize(250,null),a.localize(251,null)],description:a.localize(252,null)})),colorDecoratorsLimit:Le(new i(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(253,null)})),columnSelection:Le(new o(je.columnSelection,"columnSelection",!1,{description:a.localize(254,null)})),comments:Le(new A),contextmenu:Le(new o(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:a.localize(255,null)})),cursorBlinking:Le(new D(je.cursorBlinking,"cursorBlinking",b.Blink,"blink",["blink","smooth","phase","expand","solid"],v,{description:a.localize(256,null)})),cursorSmoothCaretAnimation:Le(new y(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(257,null),a.localize(258,null),a.localize(259,null)],description:a.localize(260,null)})),cursorStyle:Le(new D(je.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:a.localize(261,null)})),cursorSurroundingLines:Le(new i(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(262,null)})),cursorSurroundingLinesStyle:Le(new y(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(263,null),a.localize(264,null)],markdownDescription:a.localize(265,null)})),cursorWidth:Le(new i(je.cursorWidth,"cursorWidth",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(266,null)})),disableLayerHinting:Le(new o(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:Le(new o(je.dragAndDrop,"dragAndDrop",!0,{description:a.localize(267,null)})),emptySelectionClipboard:Le(new z),dropIntoEditor:Le(new ht),stickyScroll:Le(new W),experimentalWhitespaceRendering:Le(new y(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(268,null),a.localize(269,null),a.localize(270,null)],description:a.localize(271,null)})),extraEditorClassName:Le(new u(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Le(new f(je.fastScrollSensitivity,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:a.localize(272,null)})),find:Le(new F),fixedOverflowWidgets:Le(new o(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Le(new o(je.folding,"folding",!0,{description:a.localize(273,null)})),foldingStrategy:Le(new y(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(274,null),a.localize(275,null)],description:a.localize(276,null)})),foldingHighlight:Le(new o(je.foldingHighlight,"foldingHighlight",!0,{description:a.localize(277,null)})),foldingImportsByDefault:Le(new o(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:a.localize(278,null)})),foldingMaximumRegions:Le(new i(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(279,null)})),unfoldOnClickAfterEndOfLine:Le(new o(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(280,null)})),fontFamily:Le(new u(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(281,null)})),fontInfo:Le(new re),fontLigatures2:Le(new B),fontSize:Le(new U),fontWeight:Le(new G),fontVariations:Le(new _),formatOnPaste:Le(new o(je.formatOnPaste,"formatOnPaste",!1,{description:a.localize(282,null)})),formatOnType:Le(new o(je.formatOnType,"formatOnType",!1,{description:a.localize(283,null)})),glyphMargin:Le(new o(je.glyphMargin,"glyphMargin",!0,{description:a.localize(284,null)})),gotoLocation:Le(new Q),hideCursorInOverviewRuler:Le(new o(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:a.localize(285,null)})),hover:Le(new ee),inDiffEditor:Le(new o(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Le(new f(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>f.clamp(Y,-5,20),{description:a.localize(286,null)})),lightbulb:Le(new K),lineDecorationsWidth:Le(new ae),lineHeight:Le(new te),lineNumbers:Le(new ke),lineNumbersMinChars:Le(new i(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(je.linkedEditing,"linkedEditing",!1,{description:a.localize(287,null)})),links:Le(new o(je.links,"links",!0,{description:a.localize(288,null)})),matchBrackets:Le(new y(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:a.localize(289,null)})),minimap:Le(new le),mouseStyle:Le(new y(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new f(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:a.localize(290,null)})),mouseWheelZoom:Le(new o(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$j?a.localize(291,null):a.localize(292,null)})),multiCursorMergeOverlapping:Le(new o(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:a.localize(293,null)})),multiCursorModifier:Le(new D(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[a.localize(294,null),a.localize(295,null)],markdownDescription:a.localize(296,null)})),multiCursorPaste:Le(new y(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(297,null),a.localize(298,null)],markdownDescription:a.localize(299,null)})),multiCursorLimit:Le(new i(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(300,null)})),occurrencesHighlight:Le(new y(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[a.localize(301,null),a.localize(302,null),a.localize(303,null)],markdownDescription:a.localize(304,null)})),overviewRulerBorder:Le(new o(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:a.localize(305,null)})),overviewRulerLanes:Le(new i(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Le(new X),pasteAs:Le(new at),parameterHints:Le(new oe),peekWidgetDefaultFocus:Le(new y(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(306,null),a.localize(307,null)],description:a.localize(308,null)})),placeholder:Le(new we),definitionLinkOpensInPeek:Le(new o(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:a.localize(309,null)})),quickSuggestions:Le(new Fe),quickSuggestionsDelay:Le(new i(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(310,null)})),readOnly:Le(new o(je.readOnly,"readOnly",!1)),readOnlyMessage:Le(new q),renameOnType:Le(new o(je.renameOnType,"renameOnType",!1,{description:a.localize(311,null),markdownDeprecationMessage:a.localize(312,null)})),renderControlCharacters:Le(new o(je.renderControlCharacters,"renderControlCharacters",!0,{description:a.localize(313,null),restricted:!0})),renderFinalNewline:Le(new y(je.renderFinalNewline,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:a.localize(314,null)})),renderLineHighlight:Le(new y(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(315,null)],description:a.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(317,null)})),renderValidationDecorations:Le(new y(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new y(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(318,null),a.localize(319,null),a.localize(320,null),""],description:a.localize(321,null)})),revealHorizontalRightPadding:Le(new i(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(je.roundedSelection,"roundedSelection",!0,{description:a.localize(322,null)})),rulers:Le(new Oe),scrollbar:Le(new J),scrollBeyondLastColumn:Le(new i(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(323,null)})),scrollBeyondLastLine:Le(new o(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:a.localize(324,null)})),scrollPredominantAxis:Le(new o(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:a.localize(325,null)})),selectionClipboard:Le(new o(je.selectionClipboard,"selectionClipboard",!0,{description:a.localize(326,null),included:P.$k})),selectionHighlight:Le(new o(je.selectionHighlight,"selectionHighlight",!0,{description:a.localize(327,null)})),selectOnLineNumbers:Le(new o(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Le(new y(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(328,null),a.localize(329,null),a.localize(330,null)],description:a.localize(331,null)})),showUnused:Le(new o(je.showUnused,"showUnused",!0,{description:a.localize(332,null)})),showDeprecated:Le(new o(je.showDeprecated,"showDeprecated",!0,{description:a.localize(333,null)})),inlayHints:Le(new se),snippetSuggestions:Le(new y(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(334,null),a.localize(335,null),a.localize(336,null),a.localize(337,null)],description:a.localize(338,null)})),smartSelect:Le(new rt),smoothScrolling:Le(new o(je.smoothScrolling,"smoothScrolling",!1,{description:a.localize(339,null)})),stopRenderingLineAfter:Le(new i(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Le(new et),inlineSuggest:Le(new fe),inlineEdit:Le(new be),inlineCompletionsAccessibilityVerbose:Le(new o(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:a.localize(340,null)})),suggestFontSize:Le(new i(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new i(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:a.localize(343,null)})),suggestSelection:Le(new y(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(344,null),a.localize(345,null),a.localize(346,null)],description:a.localize(347,null)})),tabCompletion:Le(new y(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(348,null),a.localize(349,null),a.localize(350,null)],description:a.localize(351,null)})),tabIndex:Le(new i(je.tabIndex,"tabIndex",0,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Le(new x),unusualLineTerminators:Le(new y(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(352,null),a.localize(353,null),a.localize(354,null)],description:a.localize(355,null)})),useShadowDOM:Le(new o(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:Le(new o(je.useTabStops,"useTabStops",!0,{description:a.localize(356,null)})),wordBreak:Le(new y(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(357,null),a.localize(358,null)],description:a.localize(359,null)})),wordSegmenterLocales:Le(new ot),wordSeparators:Le(new u(je.wordSeparators,"wordSeparators",$.$jt,{description:a.localize(360,null)})),wordWrap:Le(new y(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(361,null),a.localize(362,null),a.localize(363,null),a.localize(364,null)],description:a.localize(365,null)})),wordWrapBreakAfterCharacters:Le(new u(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new u(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new i(je.wordWrapColumn,"wordWrapColumn",80,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(366,null)})),wordWrapOverride1:Le(new y(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new y(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new j),defaultColorDecorators:Le(new o(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:a.localize(367,null)})),pixelRatio:Le(new pe),tabFocusMode:Le(new o(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:a.localize(368,null)})),layoutInfo:Le(new ne),wrappingInfo:Le(new mt),wrappingIndent:Le(new ct),wrappingStrategy:Le(new De)}});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ye[266],Se([1,0,23,44,221,5,110,11,25]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$8w=e.$7w=e.$6w=void 0,e.$9w=k,e.$0w=p,h=zt(h),e.$6w=(0,O.$Fi)("dialogService");var a;(function(c){c[c.Confirmation=1]="Confirmation",c[c.Prompt=2]="Prompt",c[c.Input=3]="Input"})(a||(a={}));class I{a(m){return this.d(m,a.Confirmation)}b(m){return this.d(m,a.Prompt)}c(m){return this.d(m,a.Input)}d(m,d){const g=[];switch(d){case a.Confirmation:{const n=m;n.primaryButton?g.push(n.primaryButton):g.push((0,P.localize)(0,null)),n.cancelButton?g.push(n.cancelButton):g.push((0,P.localize)(1,null));break}case a.Prompt:{const n=m;Array.isArray(n.buttons)&&n.buttons.length>0&&g.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?g.push((0,P.localize)(2,null)):typeof n.cancelButton=="string"?g.push(n.cancelButton):n.cancelButton.label?g.push(n.cancelButton.label):g.push((0,P.localize)(3,null))),g.length===0&&g.push((0,P.localize)(4,null));break}case a.Input:{const n=m;n.primaryButton?g.push(n.primaryButton):g.push((0,P.localize)(5,null)),n.cancelButton?g.push(n.cancelButton):g.push((0,P.localize)(6,null));break}}return g}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===h.default.Info?"info":m===h.default.Error?"error":m===h.default.Warning?"warning":"none"}f(m,d,g){const n=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&n.push(m.cancelButton);let o=n[d]?.run({checkboxChecked:g});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:g}}}e.$7w=I,e.$8w=(0,O.$Fi)("fileDialogService");var E;(function(c){c[c.SAVE=0]="SAVE",c[c.DONT_SAVE=1]="DONT_SAVE",c[c.CANCEL=2]="CANCEL"})(E||(e.ConfirmResult=E={}));const l=10;function k(c){const m=[];return m.push(...c.slice(0,l).map(d=>typeof d=="string"?d:(0,r.$dh)(d))),c.length>l&&(c.length-l===1?m.push((0,P.localize)(7,null)):m.push((0,P.localize)(8,null,c.length-l))),m.push(""),m.join(`
`)}function p(c,m){const d=(0,$.$do)(c);let g=(d.buttons??[]).map(i=>(0,T.$3w)(i)),n=(c.buttons||[]).map((i,s)=>s),o=0,t=d.cancelId??g.length-1;if(g.length>1){const i=typeof t=="number"?g[t]:void 0;if(R.$k||R.$j){if(typeof i=="string"&&g.length>1&&t!==1){g.splice(t,1),g.splice(1,0,i);const s=n[t];n.splice(t,1),n.splice(1,0,s),t=1}R.$k&&g.length>1&&(g=g.reverse(),n=n.reverse(),o=g.length-1,typeof i=="string"&&(t=o-1))}else if(R.$i&&typeof i=="string"&&g.length>1&&t!==g.length-1){g.splice(t,1),g.push(i);const s=n[t];n.splice(t,1),n.push(s),t=g.length-1}}return d.buttons=g,d.defaultId=o,d.cancelId=t,d.noLink=!0,d.title=d.title||m.nameLong,{options:d,buttonIndeces:n}}}),define(ye[145],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,r.$Fi)("environmentService"),e.$Ni=(0,r.$Gi)(e.$Mi)}),define(ye[267],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L9b=e.$K9b=void 0,e.$K9b=(0,r.$Fi)("externalTerminal"),e.$L9b="Terminal.app"}),define(ye[268],Se([1,0,58,59,15,17,11,109,34,112,224,267]),function(ce,e,r,h,P,O,T,R,$,a,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=e.$yfc=void 0,r=We(r),O=We(O),T=We(T),$=We($),a=We(a),I=We(I);const l=I.localize(0,null);class k{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends k{static{this.b="cmd.exe"}openTerminal(t,i){return this.spawnTerminal(r,t,a.$xm(),i)}spawnTerminal(t,i,s,f){const u=i.windowsExec||p.getDefaultTerminalWindows();f&&f[1]===":"&&(f=f[0].toUpperCase()+f.substr(1));const w=O.$pc(u,".exe").toLowerCase();if(w==="cmder")return t.spawn(u,f?[f]:void 0),Promise.resolve(void 0);const y=["/c","start","/wait"];return u.indexOf(" ")>=0&&y.push('""'),y.push(u),w==="wt"&&y.push("-d ."),new Promise((D,S)=>{const C=d(process),A=t.spawn(s,y,{cwd:f,env:C,detached:!0});A.on("error",S),A.on("exit",()=>D())})}async runInTerminal(t,i,s,f,u){const w="windowsExec"in u&&u.windowsExec?u.windowsExec:p.getDefaultTerminalWindows(),y=await p.f();return new Promise((D,S)=>{const C=`"${i} - ${l}"`,A=`"${s.join('" "')}" & pause`,b=Object.assign({},d(process),f);Object.keys(b).filter(j=>b[j]===null).forEach(j=>delete b[j]);const v={cwd:i,env:b,windowsVerbatimArguments:!0};let M,N;O.$pc(w,".exe")==="wt"?(M=w,N=["-d",".",p.b,"/c",A]):y?(M=y,N=["-d",".",w,"/c",A]):(M=p.b,N=["/c","start",C,"/wait",w,"/c",`"${A}"`]),r.spawn(M,N,v).on("error",j=>{S(g(j))}),D(void 0)})}static getDefaultTerminalWindows(){if(!p.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return p.d}static async f(){try{const t=await a.win32.findExecutable("wt");return await $.Promises.exists(t)?t:void 0}catch{return}}}e.$yfc=p,Je([h.$0h],p,"f",null);class c extends k{static{this.b="/usr/bin/osascript"}openTerminal(t,i){return this.spawnTerminal(r,t,i)}runInTerminal(t,i,s,f,u){const w=u.osxExec||E.$L9b;return new Promise((y,D)=>{if(w===E.$L9b||w==="iTerm.app"){const S=w===E.$L9b?"TerminalHelper":"iTermHelper",A=[P.$Zg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",t||l,"-w",i];for(const M of s)A.push("-a"),A.push(M);if(f){const M=Object.assign({},d(process),f);for(const N in M){const L=M[N];L===null?(A.push("-u"),A.push(N)):(A.push("-e"),A.push(`${N}=${L}`))}}let b="";const v=r.spawn(c.b,A);v.on("error",M=>{D(g(M))}),v.stderr.on("data",M=>{b+=M.toString()}),v.on("exit",M=>{if(M===0)y(void 0);else if(b){const N=b.split(`
`,1);D(new Error(N[0]))}else D(new Error(I.localize(1,null,S,M)))})}else D(new Error(I.localize(2,null,w)))})}spawnTerminal(t,i,s){const f=i.osxExec||E.$L9b;return new Promise((u,w)=>{const y=["-a",f];s&&y.push(s);const D=d(process),S=t.spawn("/usr/bin/open",y,{cwd:s,env:D});S.on("error",w),S.on("exit",()=>u())})}}e.$zfc=c;class m extends k{static{this.b=I.localize(3,null)}openTerminal(t,i){return this.spawnTerminal(r,t,i)}runInTerminal(t,i,s,f,u){const w=u.linuxExec?Promise.resolve(u.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((y,D)=>{const S=[];w.then(C=>{C.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const A=`${n(s)}; echo; read -p "${m.b}" -n1;`;S.push(`''${A}''`);const b=Object.assign({},d(process),f);Object.keys(b).filter(L=>b[L]===null).forEach(L=>delete b[L]);const v={cwd:i,env:b};let M="";const N=r.spawn(C,S,v);N.on("error",L=>{D(g(L))}),N.stderr.on("data",L=>{M+=L.toString()}),N.on("exit",L=>{if(L===0)y(void 0);else if(M){const j=M.split(`
`,1);D(new Error(j[0]))}else D(new Error(I.localize(4,null,C,L)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!T.$k)m.d=Promise.resolve("xterm");else{const t=await $.Promises.exists("/etc/debian_version");m.d=new Promise(i=>{t?i("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?i("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?i("konsole"):process.env.COLORTERM?i(process.env.COLORTERM):process.env.TERM?i(process.env.TERM):i("xterm")})}return m.d}spawnTerminal(t,i,s){const f=i.linuxExec?Promise.resolve(i.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((u,w)=>{f.then(y=>{const D=d(process),S=t.spawn(y,[],{cwd:s,env:D});S.on("error",w),S.on("exit",()=>u())})})}}e.$Afc=m;function d(o){const t={...o.env};return(0,R.$km)(t),t}function g(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(I.localize(5,null,o.path)):o}function n(o){let t="";for(const i of o)i.indexOf(" ")>=0?t+='"'+i+'"':t+=i,t+=" ";return t}}),define(ye[28],Se([1,0,85,17,13,18,2,225,5,11,15,49]),function(ce,e,r,h,P,O,T,R,$,a,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=l,e.$bl=m,e.$cl=g,e.$dl=n,e.$el=o,e.$fl=t,e.$gl=i,e.$hl=s,e.$il=f,e.$jl=u,e.$kl=w,e.$ml=S,e.$nl=C,e.$ol=A,e.$pl=b,e.$ql=v,e.$tl=z,e.$Fl=G,e.$Gl=Q,e.$Il=he,e.$_k=(0,$.$Fi)("fileService");function l(ne){return ne.create===!0}var k;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(k||(e.FileType=k={}));var p;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(p||(e.FilePermission=p={}));var c;(function(ne){ne[ne.UPDATED=2]="UPDATED",ne[ne.ADDED=4]="ADDED",ne[ne.DELETED=8]="DELETED"})(c||(e.FileChangeFilter=c={}));function m(ne){const De=ne;return!!De&&typeof De.onDidChange=="function"}var d;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function g(ne){return!!(ne.capabilities&d.FileReadWrite)}function n(ne){return!!(ne.capabilities&d.FileFolderCopy)}function o(ne){return!!(ne.capabilities&d.FileClone)}function t(ne){return!!(ne.capabilities&d.FileOpenReadWriteClose)}function i(ne){return!!(ne.capabilities&d.FileReadStream)}function s(ne){return g(ne)?!!(ne.capabilities&d.FileAtomicRead):!1}function f(ne){return g(ne)?!!(ne.capabilities&d.FileAtomicWrite):!1}function u(ne){return!!(ne.capabilities&d.FileAtomicDelete)}function w(ne){return!!(ne.capabilities&d.Readonly)}var y;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(y||(e.FileSystemProviderErrorCode=y={}));class D extends Error{static create(De,$e){const K=new D(De.toString(),$e);return A(K,$e),K}constructor(De,$e){super(De),this.code=$e}}e.$ll=D;function S(ne,De){return D.create(ne,De)}function C(ne){return ne||S((0,R.localize)(0,null),y.Unknown)}function A(ne,De){return ne.name=De?`${De} (FileSystemError)`:"FileSystemError",ne}function b(ne){if(!ne)return y.Unknown;if(ne instanceof D)return ne.code;const De=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!De)return y.Unknown;switch(De[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}function v(ne){if(ne instanceof F)return ne.fileOperationResult;switch(b(ne)){case y.FileNotFound:return re.FILE_NOT_FOUND;case y.FileIsADirectory:return re.FILE_IS_DIRECTORY;case y.FileNotADirectory:return re.FILE_NOT_DIRECTORY;case y.FileWriteLocked:return re.FILE_WRITE_LOCKED;case y.NoPermissions:return re.FILE_PERMISSION_DENIED;case y.FileExists:return re.FILE_MOVE_CONFLICT;case y.FileTooLarge:return re.FILE_TOO_LARGE;default:return re.FILE_OTHER_ERROR}}var M;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class N{constructor(De,$e,K){this.resource=De,this.operation=$e,this.target=K}isOperation(De){return this.operation===De}}e.$rl=N;var L;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class j{static{this.a=null}constructor(De,$e){this.c=$e,this.b=void 0,this.d=new E.$X(()=>{const K=r.$Li.forUris(()=>this.c);return K.fill(this.rawAdded.map(W=>[W,!0])),K}),this.f=new E.$X(()=>{const K=r.$Li.forUris(()=>this.c);return K.fill(this.rawUpdated.map(W=>[W,!0])),K}),this.g=new E.$X(()=>{const K=r.$Li.forUris(()=>this.c);return K.fill(this.rawDeleted.map(W=>[W,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of De){switch(K.type){case L.ADDED:this.rawAdded.push(K.resource);break;case L.UPDATED:this.rawUpdated.push(K.resource);break;case L.DELETED:this.rawDeleted.push(K.resource);break}this.b!==j.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(De,...$e){return this.h(De,{includeChildren:!1},...$e)}affects(De,...$e){return this.h(De,{includeChildren:!0},...$e)}h(De,$e,...K){if(!De)return!1;const W=K.length>0;return!!((!W||K.includes(L.ADDED))&&(this.d.value.get(De)||$e.includeChildren&&this.d.value.findSuperstr(De))||(!W||K.includes(L.UPDATED))&&(this.f.value.get(De)||$e.includeChildren&&this.f.value.findSuperstr(De))||(!W||K.includes(L.DELETED))&&(this.g.value.findSubstr(De)||$e.includeChildren&&this.g.value.findSuperstr(De)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(De){return this.b===De}hasCorrelation(){return typeof this.b=="number"}}e.$sl=j;function z(ne,De,$e){return!ne||!De||ne===De||De.length>ne.length?!1:(De.charAt(De.length-1)!==h.sep&&(De+=h.sep),$e?(0,P.$Hf)(ne,De):ne.indexOf(De)===0)}class F extends Error{constructor(De,$e,K){super(De),this.fileOperationResult=$e,this.options=K}}e.$ul=F;class B extends F{constructor(De,$e,K,W){super(De,$e,W),this.fileOperationResult=$e,this.size=K}}e.$vl=B;class _ extends F{constructor(De,$e,K){super(De,re.FILE_NOT_MODIFIED_SINCE,K),this.stat=$e}}e.$wl=_;var re;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var U;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(U||(e.FileKind=U={})),e.$El="";function G(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function Q(ne,De){if(!De.hasProvider(T.URI.from({scheme:ne.scheme})))return new Promise($e=>{const K=De.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===ne.scheme&&W.added&&(K.dispose(),$e())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(De){return(0,O.$jg)(De)||(De=0),De<ee.KB?(0,R.localize)(1,null,De.toFixed(0)):De<ee.MB?(0,R.localize)(2,null,(De/ee.KB).toFixed(2)):De<ee.GB?(0,R.localize)(3,null,(De/ee.MB).toFixed(2)):De<ee.TB?(0,R.localize)(4,null,(De/ee.GB).toFixed(2)):(0,R.localize)(5,null,(De/ee.TB).toFixed(2))}}e.$Hl=ee;function he(ne){const De=typeof ne=="string"||ne?.scheme===I.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===I.Schemas.file?1024*ee.MB:De?10*ee.MB:a.$o?50*ee.MB:1024*ee.MB}}),define(ye[269],Se([1,0,22,14,226,28]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=T;async function T(I,E,l,k,p,c){let m;try{await R(I,E,l,k,p,c)}catch(d){m=d}finally{m&&p.errorTransformer&&(m=p.errorTransformer(m)),typeof m<"u"&&l.error(m),l.end()}}async function R(I,E,l,k,p,c){$(c);const m=await I.open(E,{create:!1});try{$(c);let d=0,g=0,n=p&&typeof p.length=="number"?p.length:void 0,o=r.$Oe.alloc(Math.min(p.bufferSize,typeof n=="number"?n:p.bufferSize)),t=p&&typeof p.position=="number"?p.position:0,i=0;do g=await I.read(m,t,o.buffer,i,o.byteLength-i),t+=g,i+=g,d+=g,typeof n=="number"&&(n-=g),i===o.byteLength&&(await l.write(k(o)),o=r.$Oe.alloc(Math.min(p.bufferSize,typeof n=="number"?n:p.bufferSize)),i=0);while(g>0&&(typeof n!="number"||n>0)&&$(c)&&a(d,p));if(i>0){let s=i;typeof n=="number"&&(s=Math.min(i,n)),l.write(k(o.slice(0,s)))}}catch(d){throw(0,O.$nl)(d)}finally{await I.close(m)}}function $(I){if(I.isCancellationRequested)throw(0,h.$8)();return!0}function a(I,E){if(typeof E?.limits?.size=="number"&&I>E.limits.size)throw(0,O.$ml)((0,P.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ye[70],Se([1,0,39,3,17,11,2,28]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=void 0,e.$1q=$,e.$2q=a,e.$6q=k,e.$7q=p,e.$8q=c,e.$9q=m,e.$0q=g,e.$$q=n;function $(o){return typeof o.correlationId=="number"}function a(o){return o.recursive===!0}class I extends h.$Wc{static{this.a=5}constructor(t,i,s,f){super(),this.h=t,this.j=i,this.m=s,this.n=f,this.c=this.B(new h.$Xc),this.f=void 0,this.g=0}s(){const t=new h.$Vc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(i=>this.h(i))),t.add(this.b.onDidLogMessage(i=>this.j(i))),t.add(this.b.onDidError(i=>this.t(i.error,i.request)))}t(t,i){this.u(t,i)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,i){return!(!this.n.restartOnError||i||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$3q=I;class E extends I{constructor(t,i,s){super(t,i,s,{type:"node.js",restartOnError:!1})}}e.$4q=E;class l extends I{constructor(t,i,s){super(t,i,s,{type:"universal",restartOnError:!0})}}e.$5q=l;function k(o){return o.map(t=>({type:t.type,resource:T.URI.revive(t.resource),cId:t.cId}))}function p(o){const t=new d;for(const i of o)t.processEvent(i);return t.coalesce()}function c(o,t){return typeof t=="string"&&!t.startsWith(r.$vk)&&!(0,P.$kc)(t)?{base:o,pattern:t}:t}function m(o,t){const i=[];for(const s of t)i.push((0,r.$zk)(c(o,s)));return i}class d{constructor(){this.a=new Set,this.b=new Map}c(t){return O.$k?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const i=this.b.get(this.c(t));let s=!1;if(i){const f=i.type,u=t.type;i.resource.fsPath!==t.resource.fsPath&&(t.type===R.FileChangeType.DELETED||t.type===R.FileChangeType.ADDED)?s=!0:f===R.FileChangeType.ADDED&&u===R.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(i)):f===R.FileChangeType.DELETED&&u===R.FileChangeType.ADDED?i.type=R.FileChangeType.UPDATED:f===R.FileChangeType.ADDED&&u===R.FileChangeType.UPDATED||(i.type=u)}else s=!0;s&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],i=[];return Array.from(this.a).filter(s=>s.type!==R.FileChangeType.DELETED?(t.push(s),!1):!0).sort((s,f)=>s.resource.fsPath.length-f.resource.fsPath.length).filter(s=>i.some(f=>(0,R.$tl)(s.resource.fsPath,f,!O.$k))?!1:(i.push(s.resource.fsPath),!0)).concat(t)}}function g(o,t){if(typeof t=="number")switch(o.type){case R.FileChangeType.ADDED:return(t&R.FileChangeFilter.ADDED)===0;case R.FileChangeType.DELETED:return(t&R.FileChangeFilter.DELETED)===0;case R.FileChangeType.UPDATED:return(t&R.FileChangeFilter.UPDATED)===0}return!1}function n(o){if(typeof o=="number"){const t=[];return o&R.FileChangeFilter.ADDED&&t.push("Added"),o&R.FileChangeFilter.DELETED&&t.push("Deleted"),o&R.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(ye[270],Se([1,0,61,3,70,4,28,2,9]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class a extends h.$Wc{constructor(){super(),this.a=this.B(new O.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new O.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new h.$6c),this.m=new Set,this.n=this.B(new $.$Dh(this.y())),this.r=5007,this.s=new $.$3h,this.R=!1,this.B(this.f(E=>this.t(E)))}t(E){this.u(E)&&this.z(E)}u(E){return(0,P.$1q)(E)}async watch(E){this.s.isSettled||this.s.complete(),this.s=new $.$3h;try{this.h.clear(),this.g.clear();for(const l of E)this.u(l)?this.h.set(l.correlationId,l):this.g.add(l);for(const[l]of this.j)this.h.has(l)||(this.j.deleteAndDispose(l),this.m.delete(l));return await this.w(!1)}finally{this.s.complete()}}w(E){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(l=>!this.j.has(l.correlationId))]),E?this.y():0)}y(){return 800}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async z(E){if(this.j.has(E.correlationId))return;const l=new h.$Vc;this.j.set(E.correlationId,l),await this.s.p,!l.isDisposed&&(this.D(E,l),this.w(!0))}C(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.w(!1)}D(E,l){this.F(E,l)?(this.P(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.G(E,l),this.m.add(E.correlationId))}F(E,l){const k=this.O?.subscribe(E.path,(p,c)=>{l.isDisposed||(p?this.D(E,l):c?.type===T.FileChangeType.ADDED&&this.H(E))});return k?(l.add(k),!0):!1}G(E,l){let k=!1;const p=(c,m)=>{if(l.isDisposed)return;const d=this.I(c),g=this.I(m),n=k;k=d,!d&&(g||n)&&this.H(E)};this.P(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,r.watchFile)(E.path,{persistent:!1,interval:this.r},p)}catch(c){this.Q(`fs.watchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}l.add((0,h.$Uc)(()=>{this.P(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,r.unwatchFile)(E.path,p)}catch(c){this.Q(`fs.unwatchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}H(E){this.P(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const l={resource:R.URI.file(E.path),type:T.FileChangeType.ADDED,cId:E.correlationId};this.a.fire([l]),this.J(l,E),this.C(E)}I(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(E,l){if(this.R){const k=` >> normalized ${E.type===T.FileChangeType.ADDED?"[ADDED]":E.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.L(k,l)}}L(E,l){this.R&&this.P(`${E}${typeof l.correlationId=="number"?` <${l.correlationId}> `:""}`)}M(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,P.$$q)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.R=E}}e.$hr=a}),define(ye[271],Se([1,0,61,9,21,33,3,82,17,11,23,2,111,34,28,70]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0,e.$nr=d;class m extends T.$Wc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,o,t,i,s,f){super(),this.s=n,this.t=o,this.u=t,this.w=i,this.y=s,this.z=f,this.c=this.B(new h.$Uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.u(u))),this.f=this.B(new h.$Th(u=>this.M(u),m.b)),this.g=(0,c.$9q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,c.$9q)(this.s.path,this.s.includes):void 0,this.j=(0,c.$1q)(this.s)?this.s.filter:void 0,this.m=new P.$xe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const o=await k.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,o.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let o=n.path;try{o=await k.Promises.realpath(n.path),n.path===o&&(o=await(0,l.$jr)(n.path,this.m.token)??n.path),n.path!==o&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${o})`)}catch{}return o}async G(n,o){const t=new T.$Vc;return this.H(n,o,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,o,t)),t}H(n,o,t){if(o)return!1;const i=E.URI.file(this.s.path),s=this.t?.subscribe(this.s.path,async(f,u)=>{if(!t.isDisposed)if(f){const w=await this.G(n,o);t.isDisposed?w.dispose():t.add(w)}else u&&(typeof u.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:i,type:u.type,cId:this.s.correlationId},!0)});return s?(t.add(s),!0):!1}async I(n,o,t){if(a.$j&&(0,O.$Eg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const i=new P.$xe(this.m.token);t.add((0,T.$Uc)(()=>i.dispose(!0)));const s=new T.$Vc;t.add(s);try{const f=E.URI.file(this.s.path),u=(0,$.$pc)(n),w=(0,r.watch)(n);s.add((0,T.$Uc)(()=>{w.removeAllListeners(),w.close()})),this.Q(`Started watching: '${n}'`);const y=new Set;if(o)try{for(const S of await k.Promises.readdir(n))y.add(S)}catch(S){this.O(S)}if(i.token.isCancellationRequested)return;const D=new Map;s.add((0,T.$Uc)(()=>{for(const[,S]of D)S.dispose();D.clear()})),w.on("error",(S,C)=>{i.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${S}, ${C})`),this.D())}),w.on("change",(S,C)=>{if(i.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${S}"] ${C}`);let A="";if(C&&(A=C.toString(),a.$j&&(A=(0,R.$mm)(A))),!(!A||S!=="change"&&S!=="rename"))if(o)if(S==="rename"){D.get(A)?.dispose();const b=setTimeout(async()=>{if(D.delete(A),A===u&&!await k.Promises.exists(n)){this.J(f);return}if(i.token.isCancellationRequested)return;const v=await this.N((0,$.$lc)(n,A));if(i.token.isCancellationRequested)return;let M;v?y.has(A)?M=p.FileChangeType.UPDATED:(M=p.FileChangeType.ADDED,y.add(A)):(y.delete(A),M=p.FileChangeType.DELETED),this.L({resource:(0,I.$gh)(f,A),type:M,cId:this.s.correlationId})},m.a);D.set(A,(0,T.$Uc)(()=>clearTimeout(b)))}else{let b;y.has(A)?b=p.FileChangeType.UPDATED:(b=p.FileChangeType.ADDED,y.add(A)),this.L({resource:(0,I.$gh)(f,A),type:b,cId:this.s.correlationId})}else if(S==="rename"||A!==u){const b=setTimeout(async()=>{const v=await k.Promises.exists(n);i.token.isCancellationRequested||(v?(this.L({resource:f,type:p.FileChangeType.UPDATED,cId:this.s.correlationId},!0),s.add(await this.G(n,!1))):this.J(f))},m.a);s.clear(),s.add((0,T.$Uc)(()=>clearTimeout(b)))}else this.L({resource:f,type:p.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(f){i.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${f.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:p.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,o=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===p.FileChangeType.ADDED?"[ADDED]":n.type===p.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!o&&this.g.some(t=>t(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!o&&this.h&&this.h.length>0&&!this.h.some(t=>t(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const o=(0,c.$7q)(n),t=[];for(const s of o){if((0,c.$0q)(s,this.j)){this.z&&this.R(` >> ignored (filtered) ${s.resource.fsPath}`);continue}t.push(s)}if(t.length===0)return;if(this.z)for(const s of t)this.R(` >> normalized ${s.type===p.FileChangeType.ADDED?"[ADDED]":s.type===p.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(a.$k)return k.Promises.exists(n);try{const o=(0,$.$pc)(n);return(await k.Promises.readdir((0,$.$oc)(n))).some(i=>i===o)}catch(o){return this.Q(o),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$mr=m;async function d(g,n,o,t,i=512){const s=await k.Promises.open(g,"r"),f=Buffer.allocUnsafe(i),u=new P.$xe(t);let w,y=!1;const D={path:g,excludes:[],recursive:!1},S=new m(D,void 0,C=>{(async()=>{for(const{type:A}of C)if(A===p.FileChangeType.UPDATED){if(y)return;y=!0;try{for(;!u.token.isCancellationRequested;){const{bytesRead:b}=await k.Promises.read(s,f,0,i,null);if(!b||u.token.isCancellationRequested)break;n(f.slice(0,b))}}catch(b){w=new Error(b),u.dispose(!0)}finally{y=!1}}})()});return await S.ready,o(),new Promise((C,A)=>{u.token.onCancellationRequested(async()=>{S.dispose();try{await k.Promises.close(s)}catch(b){w=new Error(b)}w?A(w):C()})})}}),define(ye[272],Se([1,0,4,39,270,11,271,33]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class $ extends P.$hr{constructor(I){super(),this.O=I,this.onDidError=r.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const E=[],l=new Set(Array.from(this.watchers));for(const k of I){const p=this.W(k);p&&(0,h.$Dk)(p.request.excludes,k.excludes)&&(0,h.$Dk)(p.request.includes,k.includes)?l.delete(p):E.push(k)}E.length&&this.P(`Request to start watching: ${E.map(k=>this.M(k)).join(",")}`),l.size&&this.P(`Request to stop watching: ${Array.from(l).map(k=>this.M(k.request)).join(",")}`);for(const k of l)this.Y(k);for(const k of E)this.X(k)}W(I){for(const E of this.watchers)if(typeof I.correlationId=="number"||typeof E.request.correlationId=="number"){if(E.request.correlationId===I.correlationId)return E}else if((0,R.$Dg)(E.request.path,I.path,!O.$k))return E}X(I){const E=new T.$mr(I,this.O,k=>this.a.fire(k),()=>this.c.fire(I),k=>this.b.fire(k),this.R),l={request:I,instance:E};this.watchers.add(l)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const E=new Map;for(const l of I){const k=O.$k?l.path:l.path.toLowerCase();let p=E.get(l.correlationId);p||(p=new Map,E.set(l.correlationId,p)),p.has(k)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(l)}`),p.set(k,l)}return Array.from(E.values()).map(l=>Array.from(l.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const E of this.watchers)E.instance.setVerboseLogging(I)}P(I,E){this.R&&this.b.fire({type:"trace",message:this.bb(I,E)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,E){return E?`[File Watcher (node.js)] ${I} (${this.M(E.request)})`:`[File Watcher (node.js)] ${I}`}}e.$or=$}),define(ye[273],Se([1,0,70,272]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class P extends r.$4q{constructor(T,R,$){super(T,R,$),this.s()}r(T){return T.add(new h.$or(void 0))}}e.$pr=P}),define(ye[274],Se([1,0,15,87,209,70]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class T extends O.$5q{constructor($,a,I){super($,a,I),this.s()}r($){const a=$.add(new P.$fr(r.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(a.onDidProcessExit(({code:I,signal:E})=>this.t(`terminated by itself with code ${I}, signal: ${E} (ETERM)`))),h.ProxyChannel.toService((0,h.$mi)(a.getChannel("watcher")))}}e.$gr=T}),define(ye[115],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class r{constructor(...P){this.a=new Map;for(const[O,T]of P)this.set(O,T)}set(P,O){const T=this.a.get(P);return this.a.set(P,O),T}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Di=r}),define(ye[275],Se([1,0,9,14,3,113,264,5,115,81]),function(ce,e,r,h,P,O,T,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;const I=!1;class E extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class l{constructor(m=new $.$Di,d=!1,g,n=I){this.i=m,this.j=d,this.k=g,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(R.$Ei,this),this._globalGraph=n?g?._globalGraph??new T.$sr(o=>o):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Rc)(this.h),this.h.clear();for(const m of this.g)(0,P.$Qc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m,d){this.m();const g=this,n=new class extends l{dispose(){g.h.delete(n),super.dispose()}}(m,this.j,this,this.l);return this.h.add(n),d?.add(n),n}invokeFunction(m,...d){this.m();const g=p.traceInvocation(this.l,m);let n=!1;try{return m({get:t=>{if(n)throw(0,h.$0)("service accessor is only valid during the invocation of its target method");const i=this.s(t,g);if(!i)throw new Error(`[invokeFunction] unknown service '${t}'`);return i}},...d)}finally{n=!0,g.stop()}}createInstance(m,...d){this.m();let g,n;return m instanceof O.$Ci?(g=p.traceCreation(this.l,m.ctor),n=this.o(m.ctor,m.staticArguments.concat(d),g)):(g=p.traceCreation(this.l,m),n=this.o(m,d,g)),g.stop(),n}o(m,d=[],g){const n=R._util.getServiceDependencies(m).sort((i,s)=>i.index-s.index),o=[];for(const i of n){const s=this.s(i.id,g);s||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${i.id}.`,!1),o.push(s)}const t=n.length>0?n[0].index:d.length;if(d.length!==t){console.trace(`[createInstance] First service dependency of ${m.name} at position ${t+1} conflicts with ${d.length} static arguments`);const i=t-d.length;i>0?d=d.concat(new Array(i)):d=d.slice(0,t)}return Reflect.construct(m,d.concat(o))}q(m,d){if(this.i.get(m)instanceof O.$Ci)this.i.set(m,d);else if(this.k)this.k.q(m,d);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const d=this.i.get(m);return!d&&this.k?this.k.r(m):d}s(m,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const g=this.r(m);return g instanceof O.$Ci?this.u(m,g,d.branch(m,!0)):(d.branch(m,!1),g)}u(m,d,g){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,d,g)}finally{this.t.delete(m)}}v(m,d,g){const n=new T.$sr(i=>i.id.toString());let o=0;const t=[{id:m,desc:d,_trace:g}];for(;t.length;){const i=t.pop();if(n.lookupOrInsertNode(i),o++>1e3)throw new E(n);for(const s of R._util.getServiceDependencies(i.desc.ctor)){const f=this.r(s.id);if(f||this.y(`[createInstance] ${m} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),f instanceof O.$Ci){const u={id:s.id,desc:f,_trace:i._trace.branch(s.id,!0)};n.insertEdge(i,u),t.push(u)}}}for(;;){const i=n.roots();if(i.length===0){if(!n.isEmpty())throw new E(n);break}for(const{data:s}of i){if(this.r(s.id)instanceof O.$Ci){const u=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,u)}n.removeNode(s)}}return this.r(m)}w(m,d,g=[],n,o){if(this.i.get(m)instanceof O.$Ci)return this.x(m,d,g,n,o,this.g);if(this.k)return this.k.w(m,d,g,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}x(m,d,g=[],n,o,t){if(n){const i=new l(void 0,this.j,this,this.l);i.c=String(m);const s=new Map,f=new r.$Yh(()=>{const u=i.o(d,g,o);for(const[w,y]of s){const D=u[w];if(typeof D=="function")for(const S of y)S.disposable=D.apply(u,S.listener)}return s.clear(),t.add(u),u});return new Proxy(Object.create(null),{get(u,w){if(!f.isInitialized&&typeof w=="string"&&(w.startsWith("onDid")||w.startsWith("onWill"))){let S=s.get(w);return S||(S=new a.$7c,s.set(w,S)),(A,b,v)=>{if(f.isInitialized)return f.value[w](A,b,v);{const M={listener:[A,b,v],disposable:void 0},N=S.push(M);return(0,P.$Uc)(()=>{N(),M.disposable?.dispose()})}}}if(w in u)return u[w];const y=f.value;let D=y[w];return typeof D!="function"||(D=D.bind(y),u[w]=D),D},set(u,w,y){return f.value[w]=y,!0},getPrototypeOf(u){return d.prototype}})}else{const i=this.o(d,g,o);return t.add(i),i}}y(m,d){if(d&&console.warn(m),this.j)throw new Error(m)}}e.$tr=l;var k;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(k||(k={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(k.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,d){return m?new p(k.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(m,d){return m?new p(k.Creation,d.name):p.c}static{this.f=0}constructor(m,d){this.type=m,this.name=d,this.g=Date.now(),this.h=[]}branch(m,d){const g=new p(k.Branch,m.toString());return this.h.push([m,d,g]),g}stop(){const m=Date.now()-this.g;p.f+=m;let d=!1;function g(o,t){const i=[],s=new Array(o+1).join("	");for(const[f,u,w]of t.h)if(u&&w){d=!0,i.push(`${s}CREATES -> ${f}`);const y=g(o+1,w);y&&i.push(y)}else i.push(`${s}uses -> ${f}`);return i.join(`
`)}const n=[`${this.type===k.Creation?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(m>2||d)&&p.all.add(n.join(`
`))}}e.$ur=p}),define(ye[12],Se([1,0,228,51,4,60,3,29,11,23,18,2,36,5]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=c,e.log=d,e.$nk=D,e.$ok=S,e.$pk=C,e.$qk=A,r=We(r),e.$_j=(0,k.$Fi)("logService"),e.$ak=(0,k.$Fi)("loggerService");function p(){return new Date().toISOString()}function c(b){return(0,I.$jg)(b)}var m;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$ck=m.Info;function d(b,v,M){switch(v){case m.Trace:b.trace(M);break;case m.Debug:b.debug(M);break;case m.Info:b.info(M);break;case m.Warning:b.warn(M);break;case m.Error:b.error(M);break;case m.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function g(b,v=!1){let M="";for(let N=0;N<b.length;N++){let L=b[N];if(L instanceof Error&&(L=(0,h.$qj)(L,v)),typeof L=="object")try{L=JSON.stringify(L)}catch{}M+=(N>0?" ":"")+L}return M}class n extends T.$Wc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new P.$me),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==m.Off&&this.b<=v}}e.$ek=n;class o extends n{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...M){this.f(m.Trace)&&this.g(m.Trace,g([v,...M],!0))}debug(v,...M){this.f(m.Debug)&&this.g(m.Debug,g([v,...M]))}info(v,...M){this.f(m.Info)&&this.g(m.Info,g([v,...M]))}warn(v,...M){this.f(m.Warning)&&this.g(m.Warning,g([v,...M]))}error(v,...M){if(this.f(m.Error))if(v instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=v.stack,this.g(m.Error,g(N))}else this.g(m.Error,g([v,...M]))}flush(){}}e.$fk=o;class t extends n{constructor(v=e.$ck){super(),this.setLevel(v),this.g=!$.$i}trace(v,...M){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,v,...M):console.log(`[main ${p()}]`,v,...M))}debug(v,...M){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,v,...M):console.log(`[main ${p()}]`,v,...M))}info(v,...M){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,v,...M):console.log(`[main ${p()}]`,v,...M))}warn(v,...M){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,v,...M):console.warn(`[main ${p()}]`,v,...M))}error(v,...M){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,v,...M):console.error(`[main ${p()}]`,v,...M))}flush(){}}e.$gk=t;class i extends n{constructor(v=e.$ck,M=!0){super(),this.g=M,this.setLevel(v)}trace(v,...M){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...M):console.log(v,...M))}debug(v,...M){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...M):console.log(v,...M))}info(v,...M){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...M):console.log(v,...M))}warn(v,...M){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...M):console.log(v,...M))}error(v,...M){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...M):console.error(v,...M))}flush(){}}e.$hk=i;class s extends n{constructor(v,M=e.$ck){super(),this.g=v,this.setLevel(M)}trace(v,...M){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(v),...M])}debug(v,...M){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(v),...M])}info(v,...M){this.f(m.Info)&&this.g.log(m.Info,[this.h(v),...M])}warn(v,...M){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(v),...M])}error(v,...M){this.f(m.Error)&&this.g.log(m.Error,[this.h(v),...M])}h(v){return typeof v=="string"?v:(0,h.$qj)(v,this.f(m.Trace))}flush(){}}e.$ik=s;class f extends n{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const M of this.g)M.setLevel(v);super.setLevel(v)}trace(v,...M){for(const N of this.g)N.trace(v,...M)}debug(v,...M){for(const N of this.g)N.debug(v,...M)}info(v,...M){for(const N of this.g)N.info(v,...M)}warn(v,...M){for(const N of this.g)N.warn(v,...M)}error(v,...M){for(const N of this.g)N.error(v,...M)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$jk=f;class u extends T.$Wc{constructor(v,M,N){if(super(),this.h=v,this.j=M,this.b=new R.$Cc,this.c=this.B(new P.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$me),this.onDidChangeVisibility=this.g.event,N)for(const L of N)this.b.set(L.resource,{logger:void 0,info:L})}m(v){return(0,I.$fg)(v)?[...this.b.values()].find(M=>M.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,M){const N=this.n(v),L=(0,I.$fg)(v)?v:M?.id??(0,O.$tj)(N.toString()).toString(16);let j=this.b.get(N)?.logger;const z=M?.logLevel==="always"?m.Trace:M?.logLevel;j||(j=this.s(N,z??this.getLogLevel(N)??this.h,{...M,id:L}));const F={logger:j,info:{resource:N,id:L,logLevel:z,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(F.info),this.b.set(N,F),j}n(v){return(0,I.$fg)(v)?(0,a.$gh)(this.j,`${v}.log`):v}setLogLevel(v,M){if(E.URI.isUri(v)){const N=v,L=M,j=this.b.get(N);j&&L!==j.info.logLevel&&(j.info.logLevel=L===this.h?void 0:L,j.logger?.setLevel(L),this.b.set(j.info.resource,j),this.f.fire([N,L]))}else{this.h=v;for(const[N,L]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&L.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,M){const N=this.m(v);N&&M!==!N.info.hidden&&(N.info.hidden=!M,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,M]))}getLogLevel(v){let M;return v&&(M=this.b.get(v)?.info.logLevel),M??this.h}registerLogger(v){const M=this.b.get(v.resource);M?M.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const M=this.b.get(v);M&&(M.logger&&M.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=u;class w{constructor(){this.onDidChangeLogLevel=new P.$me().event}setLevel(v){}getLevel(){return m.Info}trace(v,...M){}debug(v,...M){}info(v,...M){}warn(v,...M){}error(v,...M){}critical(v,...M){}dispose(){}flush(){}}e.$lk=w;class y extends w{}e.$mk=y;function D(b){if(b.verbose)return m.Trace;if(typeof b.logLevel=="string"){const v=A(b.logLevel.toLowerCase());if(v!==void 0)return v}return e.$ck}function S(b){switch(b){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function C(b){switch(b){case m.Trace:return{original:"Trace",value:r.localize(0,null)};case m.Debug:return{original:"Debug",value:r.localize(1,null)};case m.Info:return{original:"Info",value:r.localize(2,null)};case m.Warning:return{original:"Warning",value:r.localize(3,null)};case m.Error:return{original:"Error",value:r.localize(4,null)};case m.Off:return{original:"Off",value:r.localize(5,null)}}}function A(b){switch(b){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$rk=new l.$Wj("logLevel",S(m.Info))}),define(ye[276],Se([1,0,19,9,14,4,33,3,17,70,12]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class E extends R.$Wc{constructor(k,p){super(),this.a=k,this.b=p,this.c=this.B(new O.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new h.$Dh(0)),this.w=[],this.y=this.B(new h.$Dh(0))}watch(k,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(k,p):this.z(k,p)}n(k,p){const c={path:this.J(k),excludes:p.excludes,includes:p.includes,recursive:p.recursive,filter:p.filter,correlationId:p.correlationId},m=(0,r.$Vb)(this.j,c);return this.r(),(0,R.$Uc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(k=>(0,P.$3)(k))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,a.$6q)(p)),p=>this.G(p),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const k=this.b?.watcher?.recursive?.usePolling;if(k===!0)for(const p of this.j)(0,a.$2q)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(k))for(const p of this.j)(0,a.$2q)(p)&&k.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(k,p){const c={path:this.J(k),excludes:p.excludes,includes:p.includes,recursive:!1,filter:p.filter,correlationId:p.correlationId},m=(0,r.$Vb)(this.w,c);return this.C(),(0,R.$Uc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(k=>(0,P.$3)(k))}D(){return this.u||(this.u=this.B(this.F(k=>this.c.fire((0,a.$6q)(k)),k=>this.G(k),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(k){k.type==="error"&&this.g.fire(k.message),this.H(k)}H(k){this.a[k.type](k.message)}I(k){return(0,$.$jc)(k.fsPath)}J(k){const p=this.I(k);return(0,T.$Hg)(p)}}e.$_q=E}),define(ye[277],Se([1,0,9,29,22,4,33,3,17,11,23,104,34,227,28,269,276,274,273]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class n extends m.$_q{static{this.L=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=O.Event.None,this.P=new h.$Cc(s=>I.$0g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=p.FileSystemProviderCapabilities.FileReadWrite|p.FileSystemProviderCapabilities.FileOpenReadWriteClose|p.FileSystemProviderCapabilities.FileReadStream|p.FileSystemProviderCapabilities.FileFolderCopy|p.FileSystemProviderCapabilities.FileWriteUnlock|p.FileSystemProviderCapabilities.FileAtomicRead|p.FileSystemProviderCapabilities.FileAtomicWrite|p.FileSystemProviderCapabilities.FileAtomicDelete|p.FileSystemProviderCapabilities.FileClone,a.$k&&(this.M|=p.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(t){try{const{stat:i,symbolicLink:s}=await l.SymlinkSupport.stat(this.I(t));return{type:this.O(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:p.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await l.Promises.readdir(this.I(t),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async f=>{try{let u;f.isSymbolicLink()?u=(await this.stat((0,I.$gh)(t,f.name))).type:u=this.O(f),s.push([f.name,u])}catch(u){this.a.trace(u)}})),s}catch(i){throw this.hb(i)}}O(t,i){let s;return i?.dangling?s=p.FileType.Unknown:t.isFile()?s=p.FileType.File:t.isDirectory()?s=p.FileType.Directory:s=p.FileType.Unknown,i&&(s|=p.FileType.SymbolicLink),s}async Q(t){const i=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const f=new r.$Eh;return this.P.set(t,f),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,R.$Uc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(t)===f&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),f.open()})}async readFile(t,i){let s;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),s=await this.Q(t));const f=this.I(t);return await l.Promises.readFile(f)}catch(f){throw this.hb(f)}finally{s?.dispose()}}R(t){n.L&&this.a.trace(t)}readFileStream(t,i,s){const f=(0,E.$Ce)(u=>P.$Oe.concat(u.map(w=>P.$Oe.wrap(w))).buffer);return(0,c.$Yq)(this,t,f,u=>u.buffer,{...i,bufferSize:256*1024},s),f}async writeFile(t,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(t)?this.U(t,(0,I.$gh)((0,I.$fh)(t),`${(0,I.$dh)(t)}${s.atomic.postfix}`),i,s):this.W(t,i,s)}async S(t){try{const i=this.I(t),{symbolicLink:s}=await l.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async U(t,i,s,f){const u=new R.$Vc;try{u.add(await this.Q(t)),u.add(await this.Q(i)),await this.W(i,s,f,!0);try{await this.rename(i,t,{overwrite:!0})}catch(w){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw w}}finally{u.dispose()}}async W(t,i,s,f){let u;try{const w=this.I(t);if(!s.create||!s.overwrite){if(await l.Promises.exists(w)){if(!s.overwrite)throw(0,p.$ml)((0,k.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,p.$ml)((0,k.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:s.unlock},f),await this.write(u,0,i,0,i.byteLength)}catch(w){throw await this.ib(t,w)}finally{typeof u=="number"&&await this.close(u)}}static{this.$=!0}static configureFlushOnWrite(t){n.$=t}async open(t,i,s){const f=this.I(t);let u;(0,p.$al)(i)&&!s&&(u=await this.Q(t));let w;try{if((0,p.$al)(i)&&i.unlock)try{const{stat:D}=await l.SymlinkSupport.stat(f);D.mode&128||await l.Promises.chmod(f,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let y;if((0,p.$al)(i)){if(a.$i)try{await l.Promises.truncate(f,0),y="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}y||(y="w")}else y="r";w=await l.Promises.open(f,y)}catch(y){throw u?.dispose(),(0,p.$al)(i)?await this.ib(t,y):this.hb(y)}if(this.X.set(w,0),(0,p.$al)(i)&&this.Z.set(w,t),u){const y=this.Y.get(w);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${w} (${f})`),this.Y.set(w,u),y&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${w} (${f})`),y.dispose())}return w}async close(t){const i=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&n.$)try{await l.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await l.Promises.close(t)}catch(s){throw this.hb(s)}finally{i&&(this.Y.get(t)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,s,f,u){const w=this.ab(t,i);let y=null;try{y=(await l.Promises.read(t,s,f,u,w)).bytesRead}catch(D){throw this.hb(D)}finally{this.bb(t,w,y)}return y}ab(t,i){return i===this.X.get(t)?null:i}bb(t,i,s){const f=this.X.get(t);typeof f=="number"&&(typeof i=="number"||(typeof s=="number"?this.X.set(t,f+s):this.X.delete(t)))}async write(t,i,s,f,u){return(0,r.$Zh)(()=>this.cb(t,i,s,f,u),100,3)}async cb(t,i,s,f,u){const w=this.ab(t,i);let y=null;try{y=(await l.Promises.write(t,s,f,u,w)).bytesWritten}catch(D){throw await this.ib(this.Z.get(t),D)}finally{this.bb(t,w,y)}return y}async mkdir(t){try{await l.Promises.mkdir(this.I(t))}catch(i){throw this.hb(i)}}async delete(t,i){try{const s=this.I(t);if(i.recursive){let f;i?.atomic!==!1&&i.atomic.postfix&&(f=(0,$.$lc)((0,$.$oc)(s),`${(0,$.$pc)(s)}${i.atomic.postfix}`)),await l.Promises.rm(s,l.RimRafMode.MOVE,f)}else try{await l.Promises.unlink(s)}catch(f){if(f.code==="EPERM"||f.code==="EISDIR"){let u=!1;try{const{stat:w,symbolicLink:y}=await l.SymlinkSupport.stat(s);u=w.isDirectory()&&!y}catch{}if(u)await l.Promises.rmdir(s);else throw f}else throw f}}catch(s){throw this.hb(s)}}async rename(t,i,s){const f=this.I(t),u=this.I(i);if(f!==u)try{await this.db(t,i,"move",s.overwrite),await l.Promises.rename(f,u)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,k.localize)(2,null,(0,$.$pc)(f),(0,$.$pc)((0,$.$oc)(u)),w.toString()))),this.hb(w)}}async copy(t,i,s){const f=this.I(t),u=this.I(i);if(f!==u)try{await this.db(t,i,"copy",s.overwrite),await l.Promises.copy(f,u,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,k.localize)(3,null,(0,$.$pc)(f),(0,$.$pc)((0,$.$oc)(u)),w.toString()))),this.hb(w)}}async db(t,i,s,f){const u=this.I(t),w=this.I(i);let y=!1;if(!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive)||(y=(0,T.$Dg)(u,w,!0)),y){if(s==="copy")throw(0,p.$ml)((0,k.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const S=await this.N(t);if(!S)throw(0,p.$ml)((0,k.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(i);if(C){if(!f)throw(0,p.$ml)((0,k.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);S.type&p.FileType.File&&C.type&p.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.eb(t,i,!1)}async eb(t,i,s){const f=this.I(t),u=this.I(i),w=!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive);if((0,T.$Dg)(f,u,!w))return;const y=new R.$Vc;try{y.add(await this.Q(t)),y.add(await this.Q(i)),s&&await l.Promises.mkdir((0,$.$oc)(u),{recursive:!0}),await l.Promises.copyFile(f,u)}catch(D){if(D.code==="ENOENT"&&!s)return this.eb(t,i,!0);throw this.hb(D)}finally{y.dispose()}}t(t,i,s){return new d.$gr(f=>t(f),f=>i(f),s)}F(t,i,s){return new g.$pr(f=>t(f),f=>i(f),s)}hb(t){if(t instanceof p.$ll)return t;let i=t,s;switch(t.code){case"ENOENT":s=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=p.FileSystemProviderErrorCode.Unknown;break;default:s=p.FileSystemProviderErrorCode.Unknown}return(0,p.$ml)(i,s)}async ib(t,i){let s=this.hb(i);if(t&&s.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:f}=await l.SymlinkSupport.stat(this.I(t));f.mode&128||(s=(0,p.$ml)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(f){this.a.trace(f)}return s}}e.$qr=n}),define(ye[278],Se([1,0,3,12]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class P extends r.$Wc{constructor(T,R=[]){super(),this.a=new h.$jk([T,...R]),this.B(T.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...R){this.a.trace(T,...R)}debug(T,...R){this.a.debug(T,...R)}info(T,...R){this.a.info(T,...R)}warn(T,...R){this.a.warn(T,...R)}error(T,...R){this.a.error(T,...R)}flush(){this.a.flush()}}e.$oR=P}),define(ye[279],Se([1,0,28,12]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=void 0;var P;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(P||(P={}));async function O(a,I,E,l,k){try{const p=await new Promise((m,d)=>{ce(["@vscode/spdlog"],m,d)}).then(We);p.setFlushOn(P.Trace);const c=await p.createAsyncRotatingLogger(a,I,E,l);return k?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(p){console.error(p)}return null}function T(a,I,E){switch(I){case h.LogLevel.Trace:a.trace(E);break;case h.LogLevel.Debug:a.debug(E);break;case h.LogLevel.Info:a.info(E);break;case h.LogLevel.Warning:a.warn(E);break;case h.LogLevel.Error:a.error(E);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function R(a,I){switch(I){case h.LogLevel.Trace:a.setLevel(P.Trace);break;case h.LogLevel.Debug:a.setLevel(P.Debug);break;case h.LogLevel.Info:a.setLevel(P.Info);break;case h.LogLevel.Warning:a.setLevel(P.Warning);break;case h.LogLevel.Error:a.setLevel(P.Error);break;case h.LogLevel.Off:a.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class $ extends h.$fk{constructor(I,E,l,k,p){super(),this.m=[],this.setLevel(p),this.n=this.s(I,E,l,k),this.B(this.onDidChangeLogLevel(c=>{this.r&&R(this.r,c)}))}async s(I,E,l,k){const p=l?6:1,c=30/p*r.$Hl.MB,m=await O(I,E,c,p,k);if(m){this.r=m,R(this.r,this.getLevel());for(const{level:d,message:g}of this.m)T(this.r,d,g);this.m=[]}}g(I,E){this.r?T(this.r,I,E):this.getLevel()<=I&&this.m.push({level:I,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$dR=$});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ye[146],Se([1,0,44,229,5]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,r=zt(r);var O;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var T;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function($){function a(p,c){return c-p}$.compare=a;const I=Object.create(null);I[$.Error]=(0,h.localize)(0,null),I[$.Warning]=(0,h.localize)(1,null),I[$.Info]=(0,h.localize)(2,null);function E(p){return I[p]||""}$.toString=E;function l(p){switch(p){case r.default.Error:return $.Error;case r.default.Warning:return $.Warning;case r.default.Info:return $.Info;case r.default.Ignore:return $.Hint}}$.fromSeverity=l;function k(p){switch(p){case $.Error:return r.default.Error;case $.Warning:return r.default.Warning;case $.Info:return r.default.Info;case $.Hint:return r.default.Ignore}}$.toSeverity=k}(T||(e.MarkerSeverity=T={}));var R;(function($){const a="";function I(l){return E(l,!0)}$.makeKey=I;function E(l,k){const p=[a];return l.source?p.push(l.source.replace("\xA6","\\\xA6")):p.push(a),l.code?typeof l.code=="string"?p.push(l.code.replace("\xA6","\\\xA6")):p.push(l.code.value.replace("\xA6","\\\xA6")):p.push(a),l.severity!==void 0&&l.severity!==null?p.push(T.toString(l.severity)):p.push(a),l.message&&k?p.push(l.message.replace("\xA6","\\\xA6")):p.push(a),l.startLineNumber!==void 0&&l.startLineNumber!==null?p.push(l.startLineNumber.toString()):p.push(a),l.startColumn!==void 0&&l.startColumn!==null?p.push(l.startColumn.toString()):p.push(a),l.endLineNumber!==void 0&&l.endLineNumber!==null?p.push(l.endLineNumber.toString()):p.push(a),l.endColumn!==void 0&&l.endColumn!==null?p.push(l.endColumn.toString()):p.push(a),p.push(a),p.join("\xA6")}$.makeKeyOptionalMessage=E})(R||(e.IMarkerData=R={})),e.$Cu=(0,P.$Fi)("markerService")});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ye[280],Se([1,0,4,44,5]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sw=e.$rw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$pw=e.Severity=void 0,e.$qw=R,h=zt(h),e.Severity=h.default,e.$pw=(0,P.$Fi)("notificationService");var O;(function(E){E[E.DEFAULT=0]="DEFAULT",E[E.SILENT=1]="SILENT",E[E.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var T;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.PROFILE=1]="PROFILE",E[E.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));function R(E){if(E){const l=E;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var $;(function(E){E[E.OFF=0]="OFF",E[E.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class a{constructor(){this.progress=new I,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$rw=a;class I{infinite(){}done(){}total(l){}worked(l){}}e.$sw=I}),define(ye[281],Se([1,0,56]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.context<"u"){const O=P.context.configuration();if(O)h=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,r.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:O.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(ye[116],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,r.$Fi)("productService"),e.$tk="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(ce,e){return function(r,h){e(r,h,ce)}};define(ye[90],Se([1,0,9,21,3,5]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zw=e.$yw=e.$xw=e.$ww=e.$vw=e.$uw=e.ProgressLocation=e.$tw=void 0,e.$tw=(0,O.$Fi)("progressService");var T;(function(E){E[E.Explorer=1]="Explorer",E[E.Scm=3]="Scm",E[E.Extensions=5]="Extensions",E[E.Window=10]="Window",E[E.Notification=15]="Notification",E[E.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.$uw=Object.freeze({total(){},worked(){},done(){}});class R{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$vw=R;class ${get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const k=this.d;this.d=()=>{k?.(),l()}}):Promise.resolve()}}e.$ww=$;let a=class extends P.$Wc{constructor(l,k){super(),this.a=new r.$3h,k.withProgress(l,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,P.$Uc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$xw=a,e.$xw=a=Je([Ve(1,e.$tw)],a);class I extends P.$Wc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new P.$Vc)}start(l){this.stop();const k=++this.a,p=new h.$xe;return this.f=setTimeout(()=>{k===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,P.$Uc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Uc)(()=>p.cancel())),this.b.add((0,P.$Uc)(()=>this.c?this.c.done():void 0)),{id:k,token:p.token,stop:()=>this.h(k),isCurrent:()=>this.a===k}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$yw=I,e.$zw=(0,O.$Fi)("editorProgressService")}),define(ye[37],Se([1,0,66,18]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,r=We(r),h=We(h);class P{constructor(){this.a=new Map}add(T,R){r.ok(h.$fg(T)),r.ok(h.$hg(R)),r.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,R)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$qo=new P}),define(ye[117],Se([1,0,4,37]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,h=We(h),e.$ro={JSONContribution:"base.contributions.json"};function P(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class O{constructor(){this.b=new r.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,a){this.a[P($)]=a,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const T=new O;h.$qo.add(e.$ro.JSONContribution,T)}),define(ye[71],Se([1,0,19,4,18,218,45,117,37]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.ConfigurationScope=e.$vo=e.EditPresentationTypes=void 0,e.$Go=c,e.$Ho=m,e.$Io=d,e.$Jo=n,e.$Ko=o,P=We(P),O=We(O);var a;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$vo={Configuration:"base.contributions.configuration"};var I;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co="vscode://schemas/settings/resourceLanguage",e.$Do="vscode://schemas/settings/configurationDefaults";const E=$.$qo.as(R.$ro.JSONContribution);class l{constructor(){this.h=new Set,this.i=new h.$me,this.onDidSchemaChange=this.i.event,this.j=new h.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$Co,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const f=new Set;this.n(i,s,f),E.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:f})}deregisterConfigurations(i){const s=new Set;this.o(i,s),E.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const f=new Set;this.o(s,f),this.n(i,!1,f),E.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:f})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const f=[];for(const{overrides:u,source:w}of i)for(const y in u)if(s.add(y),e.$Fo.test(y)){const D=this.a.get(y),S=D?.valuesSources??new Map;if(w)for(const v of Object.keys(u[y]))S.set(v,w);const C={...D?.value||{},...u[y]};this.a.set(y,{source:w,value:C,valuesSources:S});const A=(0,T.$jj)(y),b={type:"object",default:C,description:O.localize(1,null,A),$ref:e.$Co,defaultDefaultValue:C,source:P.$fg(w)?void 0:w,defaultValueSource:w};f.push(...c(y)),this.d[y]=b,this.b.properties[y]=b}else{this.a.set(y,{value:u[y],source:w});const D=this.d[y];D&&(this.w(y,D),this.r(y,D))}this.m(f)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:f,source:u}of i)for(const w in f){const y=this.a.get(w),D=P.$fg(u)?u:u?.id,S=P.$fg(y?.source)?y?.source:y?.source?.id;if(D===S)if(s.add(w),this.a.delete(w),e.$Fo.test(w))delete this.d[w],delete this.b.properties[w];else{const C=this.d[w];C&&(this.w(w,C),this.r(w,C))}}this.u()}deltaConfiguration(i){let s=!1;const f=new Set;i.removedDefaults&&(this.l(i.removedDefaults,f),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,f),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,f),i.addedConfigurations&&this.n(i.addedConfigurations,!1,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,f){i.forEach(u=>{this.p(u,s,u.extensionInfo,u.restrictedProperties,void 0,f),this.c.push(u),this.q(u)})}o(i,s){const f=u=>{if(u.properties)for(const w in u.properties){s.add(w);const y=this.d[w];y?.policy?.name&&this.e.delete(y.policy.name),delete this.d[w],this.s(w,u.properties[w])}u.allOf?.forEach(w=>f(w))};for(const u of i){f(u);const w=this.c.indexOf(u);w!==-1&&this.c.splice(w,1)}}p(i,s=!0,f,u,w=I.WINDOW,y){w=P.$og(i.scope)?w:i.scope;const D=i.properties;if(D)for(const C in D){const A=D[C];if(s&&n(C,A)){delete D[C];continue}if(A.source=f,A.defaultDefaultValue=D[C].default,this.w(C,A),e.$Fo.test(C)?A.scope=void 0:(A.scope=P.$og(A.scope)?w:A.scope,A.restricted=P.$og(A.restricted)?!!u?.includes(C):A.restricted),D[C].hasOwnProperty("included")&&!D[C].included){this.f[C]=D[C],delete D[C];continue}else this.d[C]=D[C],D[C].policy?.name&&this.e.set(D[C].policy.name,C);!D[C].deprecationMessage&&D[C].markdownDeprecationMessage&&(D[C].deprecationMessage=D[C].markdownDeprecationMessage),y.add(C)}const S=i.allOf;if(S)for(const C of S)this.p(C,s,f,u,w,y)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=f=>{const u=f.properties;if(u)for(const y in u)this.r(y,u[y]);f.allOf?.forEach(s)};s(i)}r(i,s){switch(e.$wo.properties[i]=s,s.scope){case I.APPLICATION:e.$xo.properties[i]=s;break;case I.MACHINE:e.$yo.properties[i]=s;break;case I.MACHINE_OVERRIDABLE:e.$zo.properties[i]=s;break;case I.WINDOW:e.$Ao.properties[i]=s;break;case I.RESOURCE:e.$Bo.properties[i]=s;break;case I.LANGUAGE_OVERRIDABLE:e.$Bo.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.$wo.properties[i],s.scope){case I.APPLICATION:delete e.$xo.properties[i];break;case I.MACHINE:delete e.$yo.properties[i];break;case I.MACHINE_OVERRIDABLE:delete e.$zo.properties[i];break;case I.WINDOW:delete e.$Ao.properties[i];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Bo.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,f={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$Co};this.w(s,f),e.$wo.properties[s]=f,e.$xo.properties[s]=f,e.$yo.properties[s]=f,e.$zo.properties[s]=f,e.$Ao.properties[s]=f,e.$Bo.properties[s]=f}}v(){const i={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$Co};e.$wo.patternProperties[e.$Eo]=i,e.$xo.patternProperties[e.$Eo]=i,e.$yo.patternProperties[e.$Eo]=i,e.$zo.patternProperties[e.$Eo]=i,e.$Ao.patternProperties[e.$Eo]=i,e.$Bo.patternProperties[e.$Eo]=i,this.i.fire()}w(i,s){const f=this.a.get(i);let u=f?.value,w=f?.source;P.$mg(u)&&(u=s.defaultDefaultValue,w=void 0),P.$mg(u)&&(u=d(s.type)),s.default=u,s.defaultValueSource=w}}const k="\\[([^\\]]+)\\]",p=new RegExp(k,"g");e.$Eo=`^(${k})+$`,e.$Fo=new RegExp(e.$Eo);function c(t){const i=[];if(e.$Fo.test(t)){let s=p.exec(t);for(;s?.length;){const f=s[1].trim();f&&i.push(f),s=p.exec(t)}}return(0,r.$Ob)(i)}function m(t){return t.reduce((i,s)=>`${i}[${s}]`,"")}function d(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new l;$.$qo.add(e.$vo.Configuration,g);function n(t,i){return t.trim()?e.$Fo.test(t)?O.localize(7,null,t):g.getConfigurationProperties()[t]!==void 0?O.localize(8,null,t):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?O.localize(9,null,t,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:O.localize(6,null)}function o(){const t=[],i=g.getConfigurationProperties();for(const s of Object.keys(i))t.push([s,i[s].scope]);return t.push(["launch",I.RESOURCE]),t.push(["task",I.RESOURCE]),t}}),define(ye[282],Se([1,0,19,4,176,3,29,25,18,2,45,71,28,37]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0,e.$Po=o,r=We(r),P=We(P),R=We(R),$=We($);function p(f){return Object.isFrozen(f)?f:R.$eo(f)}class c{static createEmptyModel(u){return new c({},[],[],void 0,u)}constructor(u,w,y,D,S){this.b=u,this.c=w,this.d=y,this.raw=D,this.f=S,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const u=this.raw.map(w=>{if(w instanceof c)return w;const y=new m("",this.f);return y.parseRaw(w),y.configurationModel});this.g=u.reduce((w,y)=>y===w?y:w.merge(y),u[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,I.$hj)(this.contents,u):this.contents}inspect(u,w){const y=this;return{get value(){return p(y.rawConfiguration.getValue(u))},get override(){return w?p(y.rawConfiguration.getOverrideValue(u,w)):void 0},get merged(){return p(w?y.rawConfiguration.override(w).getValue(u):y.rawConfiguration.getValue(u))},get overrides(){const D=[];for(const{contents:S,identifiers:C,keys:A}of y.rawConfiguration.overrides){const b=new c(S,A,[],void 0,y.f).getValue(u);b!==void 0&&D.push({identifiers:C,value:b})}return D.length?p(D):void 0}}}getOverrideValue(u,w){const y=this.j(w);return y?u?(0,I.$hj)(y,u):y:void 0}getKeysForOverrideIdentifier(u){const w=[];for(const y of this.overrides)y.identifiers.includes(u)&&w.push(...y.keys);return r.$Ob(w)}getAllOverrideIdentifiers(){const u=[];for(const w of this.overrides)u.push(...w.identifiers);return r.$Ob(u)}override(u){let w=this.a.get(u);return w||(w=this.h(u),this.a.set(u,w)),w}merge(...u){const w=R.$do(this.contents),y=R.$do(this.overrides),D=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const C of u)if(S.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.i(w,C.contents);for(const A of C.overrides){const[b]=y.filter(v=>r.$wb(v.identifiers,A.identifiers));b?(this.i(b.contents,A.contents),b.keys.push(...A.keys),b.keys=r.$Ob(b.keys)):y.push(R.$do(A))}for(const A of C.keys)D.indexOf(A)===-1&&D.push(A)}return new c(w,D,y,S.every(C=>C instanceof c)?void 0:S,this.f)}h(u){const w=this.j(u);if(!w||typeof w!="object"||!Object.keys(w).length)return this;const y={};for(const D of r.$Ob([...Object.keys(this.contents),...Object.keys(w)])){let S=this.contents[D];const C=w[D];C&&(typeof S=="object"&&typeof C=="object"?(S=R.$do(S),this.i(S,C)):S=C),y[D]=S}return new c(y,this.keys,this.overrides,void 0,this.f)}i(u,w){for(const y of Object.keys(w)){if(y in u&&$.$hg(u[y])&&$.$hg(w[y])){this.i(u[y],w[y]);continue}u[y]=R.$do(w[y])}}j(u){let w=null,y=null;const D=S=>{S&&(y?this.i(y,S):y=R.$do(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===u?w=S.contents:S.identifiers.includes(u)&&D(S.contents);return D(w),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,w){this.k(u,w,!0)}setValue(u,w){this.k(u,w,!1)}removeValue(u){const w=this.keys.indexOf(u);w!==-1&&(this.keys.splice(w,1),(0,I.$gj)(this.contents,u),E.$Fo.test(u)&&this.overrides.splice(this.overrides.findIndex(y=>r.$wb(y.identifiers,(0,E.$Go)(u))),1))}k(u,w,y){(0,I.$fj)(this.contents,u,w,D=>this.f.error(D)),y=y||this.keys.indexOf(u)===-1,y&&this.keys.push(u),E.$Fo.test(u)&&this.overrides.push({identifiers:(0,E.$Go)(u),keys:Object.keys(this.contents[u]),contents:(0,I.$ej)(this.contents[u],D=>this.f.error(D))})}}e.$Lo=c;class m{constructor(u,w){this.f=u,this.g=w,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||c.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,w){if(!$.$og(u)){const y=this.h(u);this.parseRaw(y,w)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,w){this.a=u;const{contents:y,keys:D,overrides:S,restricted:C,hasExcludedProperties:A}=this.i(u,w);this.b=new c(y,D,S,A?[u]:void 0,this.g),this.c=C||[]}h(u){let w={},y=null,D=[];const S=[],C=[];function A(v){Array.isArray(D)?D.push(v):y!==null&&(D[y]=v)}const b={onObjectBegin:()=>{const v={};A(v),S.push(D),D=v,y=null},onObjectProperty:v=>{y=v},onObjectEnd:()=>{D=S.pop()},onArrayBegin:()=>{const v=[];A(v),S.push(D),D=v,y=null},onArrayEnd:()=>{D=S.pop()},onLiteralValue:A,onError:(v,M,N)=>{C.push({error:v,offset:M,length:N})}};if(u)try{P.$5n(u,b),w=D[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return w}i(u,w){const y=k.$qo.as(E.$vo.Configuration).getConfigurationProperties(),D=this.j(u,y,!0,w);u=D.raw;const S=(0,I.$ej)(u,b=>this.g.error(`Conflict in settings file ${this.f}: ${b}`)),C=Object.keys(u),A=this.l(u,b=>this.g.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:S,keys:C,overrides:A,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(u,w,y,D){let S=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:S};const C={},A=[];for(const b in u)if(E.$Fo.test(b)&&y){const v=this.j(u[b],w,!1,D);C[b]=v.raw,S=S||v.hasExcludedProperties,A.push(...v.restricted)}else{const v=w[b],M=v?typeof v.scope<"u"?v.scope:E.ConfigurationScope.WINDOW:void 0;v?.restricted&&A.push(b),!D.exclude?.includes(b)&&(D.include?.includes(b)||(M===void 0||D.scopes===void 0||D.scopes.includes(M))&&!(D.skipRestricted&&v?.restricted))?C[b]=u[b]:S=!0}return{raw:C,restricted:A,hasExcludedProperties:S}}l(u,w){const y=[];for(const D of Object.keys(u))if(E.$Fo.test(D)){const S={};for(const C in u[D])S[C]=u[D][C];y.push({identifiers:(0,E.$Go)(D),keys:Object.keys(S),contents:(0,I.$ej)(S,w)})}return y}}e.$Mo=m;class d extends O.$Wc{constructor(u,w,y,D,S){super(),this.c=u,this.f=w,this.g=D,this.h=S,this.b=this.B(new h.$me),this.onDidChange=this.b.event,this.a=new m(this.c.toString(),S),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(h.Event.any(h.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),h.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(l.FileOperation.CREATE)||C.isOperation(l.FileOperation.COPY)||C.isOperation(l.FileOperation.DELETE)||C.isOperation(l.FileOperation.WRITE))&&y.isEqual(C.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return c.createEmptyModel(this.h)}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$No=d;class g{constructor(u,w,y,D,S,C,A,b,v,M,N,L,j){this.a=u,this.b=w,this.c=y,this.overrideIdentifiers=D,this.d=S,this.f=C,this.g=A,this.h=b,this.i=v,this.j=M,this.k=N,this.l=L,this.m=j}get value(){return p(this.c)}n(u){return u?.value!==void 0||u?.override!==void 0||u?.overrides!==void 0?u:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(u,w,y,D,S,C,A,b,v,M){this.j=u,this.l=w,this.m=y,this.n=D,this.p=S,this.q=C,this.r=A,this.s=b,this.t=v,this.u=M,this.h=null,this.i=new T.$Cc,this.v=null}getValue(u,w,y){return this.w(u,w,y).getValue(u)}updateValue(u,w,y={}){let D;y.resource?(D=this.t.get(y.resource),D||(D=c.createEmptyModel(this.u),this.t.set(y.resource,D))):D=this.s,w===void 0?D.removeValue(u):D.setValue(u,w),y.resource||(this.h=null)}inspect(u,w,y){const D=this.w(u,w,y),S=this.A(w.resource,y),C=w.resource?this.t.get(w.resource)||this.s:this.s,A=new Set;for(const b of D.overrides)for(const v of b.identifiers)D.getOverrideValue(u,v)!==void 0&&A.add(v);return new g(u,w,D.getValue(u),A.size?[...A]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.q:void 0,S||void 0,C)}keys(u){const w=this.A(void 0,u);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:w?w.keys.slice(0):[]}}updateDefaultConfiguration(u){this.j=u,this.h=null,this.i.clear()}updatePolicyConfiguration(u){this.l=u}updateApplicationConfiguration(u){this.m=u,this.h=null,this.i.clear()}updateLocalUserConfiguration(u){this.n=u,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(u){this.p=u,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(u){this.q=u,this.h=null,this.i.clear()}updateFolderConfiguration(u,w){this.r.set(u,w),this.i.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.i.delete(u)}compareAndUpdateDefaultConfiguration(u,w){const y=[];if(!w){const{added:D,updated:S,removed:C}=i(this.j,u);w=[...D,...S,...C]}for(const D of w)for(const S of(0,E.$Go)(D)){const C=this.j.getKeysForOverrideIdentifier(S),A=u.getKeysForOverrideIdentifier(S),b=[...A.filter(v=>C.indexOf(v)===-1),...C.filter(v=>A.indexOf(v)===-1),...C.filter(v=>!R.$ho(this.j.override(S).getValue(v),u.override(S).getValue(v)))];y.push([S,b])}return this.updateDefaultConfiguration(u),{keys:w,overrides:y}}compareAndUpdatePolicyConfiguration(u){const{added:w,updated:y,removed:D}=i(this.l,u),S=[...w,...y,...D];return S.length&&this.updatePolicyConfiguration(u),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:w,updated:y,removed:D,overrides:S}=i(this.applicationConfiguration,u),C=[...w,...y,...D];return C.length&&this.updateApplicationConfiguration(u),{keys:C,overrides:S}}compareAndUpdateLocalUserConfiguration(u){const{added:w,updated:y,removed:D,overrides:S}=i(this.localUserConfiguration,u),C=[...w,...y,...D];return C.length&&this.updateLocalUserConfiguration(u),{keys:C,overrides:S}}compareAndUpdateRemoteUserConfiguration(u){const{added:w,updated:y,removed:D,overrides:S}=i(this.remoteUserConfiguration,u),C=[...w,...y,...D];return C.length&&this.updateRemoteUserConfiguration(u),{keys:C,overrides:S}}compareAndUpdateWorkspaceConfiguration(u){const{added:w,updated:y,removed:D,overrides:S}=i(this.workspaceConfiguration,u),C=[...w,...y,...D];return C.length&&this.updateWorkspaceConfiguration(u),{keys:C,overrides:S}}compareAndUpdateFolderConfiguration(u,w){const y=this.folderConfigurations.get(u),{added:D,updated:S,removed:C,overrides:A}=i(y,w),b=[...D,...S,...C];return(b.length||!y)&&this.updateFolderConfiguration(u,w),{keys:b,overrides:A}}compareAndDeleteFolderConfiguration(u){const w=this.folderConfigurations.get(u);if(!w)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:y,updated:D,removed:S,overrides:C}=i(w,void 0);return{keys:[...y,...D,...S],overrides:C}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(u,w,y){let D=this.x(w,y);return w.overrideIdentifier&&(D=D.override(w.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(u)!==void 0&&(D=D.merge(this.l)),D}x({resource:u},w){let y=this.y();if(w&&u){const D=w.getFolder(u);D&&(y=this.z(D.uri)||y);const S=this.t.get(u);S&&(y=y.merge(S))}return y}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(u){let w=this.i.get(u);if(!w){const y=this.y(),D=this.r.get(u);D?(w=y.merge(D),this.i.set(u,w)):w=y}return w}A(u,w){if(w&&u){const y=w.getFolder(u);if(y)return this.r.get(y.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((u,w)=>{const{contents:y,overrides:D,keys:S}=this.r.get(w);return u.push([w,{contents:y,overrides:D,keys:S}]),u},[])}}allKeys(){const u=new Set;return this.j.keys.forEach(w=>u.add(w)),this.userConfiguration.keys.forEach(w=>u.add(w)),this.q.keys.forEach(w=>u.add(w)),this.r.forEach(w=>w.keys.forEach(y=>u.add(y))),[...u.values()]}B(){const u=new Set;return this.j.getAllOverrideIdentifiers().forEach(w=>u.add(w)),this.userConfiguration.getAllOverrideIdentifiers().forEach(w=>u.add(w)),this.q.getAllOverrideIdentifiers().forEach(w=>u.add(w)),this.r.forEach(w=>w.getAllOverrideIdentifiers().forEach(y=>u.add(y))),[...u.values()]}D(u){const w=new Set;return this.j.getKeysForOverrideIdentifier(u).forEach(y=>w.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(y=>w.add(y)),this.q.getKeysForOverrideIdentifier(u).forEach(y=>w.add(y)),this.r.forEach(y=>y.getKeysForOverrideIdentifier(u).forEach(D=>w.add(D))),[...w.values()]}static parse(u,w){const y=this.E(u.defaults,w),D=this.E(u.policy,w),S=this.E(u.application,w),C=this.E(u.user,w),A=this.E(u.workspace,w),b=u.folders.reduce((v,M)=>(v.set(a.URI.revive(M[0]),this.E(M[1],w)),v),new T.$Cc);return new n(y,D,S,C,c.createEmptyModel(w),A,b,c.createEmptyModel(w),new T.$Cc,w)}static E(u,w){return new c(u.contents,u.keys,u.overrides,void 0,w)}}e.$Oo=n;function o(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const u=new Set,w=new Map;for(const D of f)D.keys.forEach(S=>u.add(S)),D.overrides.forEach(([S,C])=>{const A=(0,T.$zc)(w,S,new Set);C.forEach(b=>A.add(b))});const y=[];return w.forEach((D,S)=>y.push([S,[...D.values()]])),{keys:[...u.values()],overrides:y}}class t{constructor(u,w,y,D,S){this.change=u,this.f=w,this.g=y,this.h=D,this.i=S,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const C of u.keys)this.affectedKeys.add(C);for(const[,C]of u.overrides)for(const A of C)this.affectedKeys.add(A);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(u,w){const y=this.a+u,D=this.d.indexOf(y);if(D<0)return!1;const S=D+y.length;if(S>=this.d.length)return!1;const C=this.d.charCodeAt(S);if(C!==this.b&&C!==this.c)return!1;if(w){const A=this.previousConfiguration?this.previousConfiguration.getValue(u,w,this.f?.workspace):void 0,b=this.g.getValue(u,w,this.h);return!R.$ho(A,b)}return!0}}e.$Qo=t;function i(f,u){const{added:w,removed:y,updated:D}=s(u?.rawConfiguration,f?.rawConfiguration),S=[],C=f?.getAllOverrideIdentifiers()||[],A=u?.getAllOverrideIdentifiers()||[];if(u){const b=A.filter(v=>!C.includes(v));for(const v of b)S.push([v,u.getKeysForOverrideIdentifier(v)])}if(f){const b=C.filter(v=>!A.includes(v));for(const v of b)S.push([v,f.getKeysForOverrideIdentifier(v)])}if(u&&f){for(const b of C)if(A.includes(b)){const v=s({contents:f.getOverrideValue(void 0,b)||{},keys:f.getKeysForOverrideIdentifier(b)},{contents:u.getOverrideValue(void 0,b)||{},keys:u.getKeysForOverrideIdentifier(b)});S.push([b,[...v.added,...v.removed,...v.updated]])}}return{added:w,removed:y,updated:D,overrides:S}}function s(f,u){const w=f?u?f.keys.filter(S=>u.keys.indexOf(S)===-1):[...f.keys]:[],y=u?f?u.keys.filter(S=>f.keys.indexOf(S)===-1):[...u.keys]:[],D=[];if(f&&u){for(const S of u.keys)if(f.keys.indexOf(S)!==-1){const C=(0,I.$hj)(u.contents,S),A=(0,I.$hj)(f.contents,S);R.$ho(C,A)||D.push(S)}}return{added:w,removed:y,updated:D}}}),define(ye[283],Se([1,0,22,4,3,69]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$exb=e.$cxb=e.$bxb=void 0,e.$dxb=R;const T=(a,I,E)=>{const l=new Uint8Array(16);for(let c=0;c<16;c++)l[c]=Math.round(Math.random()*256);const k=(0,r.$9e)(r.$Oe.wrap(l));return[`GET ws://localhost${a}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${k}`].join(`\r
`)+`\r
\r
`};e.$bxb=T,e.$cxb=r.$Oe.fromString(`\r
\r
`);async function R(a,I,E,l,k){a.write(r.$Oe.fromString((0,e.$bxb)(I,E,l)));const p=new P.$Vc;try{return await new Promise((c,m)=>{let d;p.add(a.onData(g=>{d?d=r.$Oe.concat([d,g],d.byteLength+g.byteLength):d=g;const n=d.indexOf(e.$cxb);if(n===-1)return;c(a),a.pauseData();const o=d.slice(n+e.$cxb.byteLength);o.byteLength&&k.onData.fire(o)})),p.add(a.onClose(g=>m(g??new Error("socket closed")))),p.add(a.onEnd(()=>m(new Error("socket ended"))))})}catch(c){throw a.dispose(),c}finally{p.dispose()}}class $ extends P.$Wc{constructor(I,E){super(),this.g=I,this.a=this.B(new h.$pe),this.onData=(...l)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...l)),this.b=this.B(new h.$me),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(l=>this.a.fire(l))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,E){O.SocketDiagnostics.traceSocketEvent(this,this.g,I,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$exb=$}),define(ye[72],Se([1,0,14,5]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=a,e.$Ql=(0,h.$Fi)("remoteAuthorityResolverService");var P;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class O{constructor(E){this.id=E,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=O;class T{constructor(E,l){this.host=E,this.port=l,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=T;var R;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class $ extends r.$db{static isNotAvailable(E){return E instanceof $&&E._code===R.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof $&&E._code===R.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof $&&E._code===R.NoResolverFound}static isInvalidAuthority(E){return E instanceof $&&E._code===R.InvalidAuthority}static isHandled(E){return E instanceof $&&E.isHandled}constructor(E,l=R.Unknown,k){super(E),this._message=E,this._code=l,this._detail=k,this.isHandled=l===R.NotAvailable&&k===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Tl=$;function a(I){const E=I.indexOf("+");return E===-1?I:I.substring(0,E)}}),define(ye[284],Se([1,0,9,22,21,14,4,3,15,62,43,32,69,72]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Zl=S,e.$1l=C,e.$2l=b,a=We(a);const p=30*1e3;var c;(function($e){$e[$e.Management=1]="Management",$e[$e.ExtensionHost=2]="ExtensionHost",$e[$e.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function m($e){switch($e){case c.Management:return"Management";case c.ExtensionHost:return"ExtensionHost";case c.Tunnel:return"Tunnel"}}function d($e){const K=new P.$xe;return setTimeout(()=>K.cancel(),$e),K.token}function g($e,K){if($e.isCancellationRequested||K.isCancellationRequested)return P.CancellationToken.Cancelled;const W=new P.$xe;return $e.onCancellationRequested(()=>W.cancel()),K.onCancellationRequested(()=>W.cancel()),W.token}class n{get didTimeout(){return this.c==="timedout"}constructor(K){this.c="pending",this.d=new R.$Vc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,r.$yh)(),K.isCancellationRequested?this.h():this.d.add(K.onCancellationRequested(()=>this.h()))}registerDisposable(K){this.c==="pending"?this.d.add(K):K.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const K=new Error("Time limit reached");return K.code="ETIMEDOUT",K.syscall="connect",K}resolve(K){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(K))}reject(K){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(K))}}function o($e,K){const W=new n(K);return W.registerDisposable($e.onControlMessage(se=>{const ae=JSON.parse(se.toString()),te=G(ae);te?W.reject(te):W.resolve(ae)})),W.promise}function t($e,K,W,se,ae,te,le,ue){const X=new n(ue),oe=I.$ge.create(!1);return $e.info(`Creating a socket (${le})...`),a.mark(`code/willCreateSocket/${te}`),K.connect(W,se,ae,le).then(pe=>{X.didTimeout?(a.mark(`code/didCreateSocketError/${te}`),$e.info(`Creating a socket (${le}) finished after ${oe.elapsed()} ms, but this is too late and has timed out already.`),pe?.dispose()):(a.mark(`code/didCreateSocketOK/${te}`),$e.info(`Creating a socket (${le}) was successful after ${oe.elapsed()} ms.`),X.resolve(pe))},pe=>{a.mark(`code/didCreateSocketError/${te}`),$e.info(`Creating a socket (${le}) returned an error after ${oe.elapsed()} ms.`),$e.error(pe),X.reject(pe)}),X.promise}function i($e,K){const W=new n(K);return $e.then(se=>{W.didTimeout||W.resolve(se)},se=>{W.didTimeout||W.reject(se)}),W.promise}async function s($e,K,W,se){const ae=ne($e,K);$e.logService.trace(`${ae} 1/6. invoking socketFactory.connect().`);let te;try{te=await t($e.logService,$e.remoteSocketFactoryService,$e.connectTo,$.$Sg.getServerRootPath(),`reconnectionToken=${$e.reconnectionToken}&reconnection=${$e.reconnectionProtocol?"true":"false"}`,m(K),`renderer-${m(K)}-${$e.reconnectionToken}`,se)}catch(pe){throw $e.logService.error(`${ae} socketFactory.connect() failed or timed out. Error:`),$e.logService.error(pe),pe}$e.logService.trace(`${ae} 2/6. socketFactory.connect() was successful.`);let le,ue;$e.reconnectionProtocol?($e.reconnectionProtocol.beginAcceptReconnection(te,null),le=$e.reconnectionProtocol,ue=!1):(le=new l.$ti({socket:te}),ue=!0),$e.logService.trace(`${ae} 3/6. sending AuthRequest control message.`);const X=await i($e.signService.createNewMessage((0,E.$2g)()),se),oe={type:"auth",auth:$e.connectionToken||"00000000000000000000",data:X.data};le.sendControl(h.$Oe.fromString(JSON.stringify(oe)));try{const pe=await o(le,g(se,d(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if($e.logService.trace(`${ae} 4/6. received SignRequest control message.`),!await i($e.signService.validate(X,pe.signedData),se)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Fe=await i($e.signService.sign(pe.data),se),Ue={type:"connectionType",commit:$e.commit,signedData:Fe,desiredConnectionType:K};return W&&(Ue.args=W),$e.logService.trace(`${ae} 5/6. sending ConnectionTypeRequest control message.`),le.sendControl(h.$Oe.fromString(JSON.stringify(Ue))),{protocol:le,ownsProtocol:ue}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&($e.logService.error(`${ae} the handshake timed out. Error:`),$e.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&($e.logService.error(`${ae} received error control message when negotiating connection. Error:`),$e.logService.error(pe)),ue&&U(le),pe}}async function f($e,K,W,se){const ae=Date.now(),te=ne($e,K),{protocol:le,ownsProtocol:ue}=await s($e,K,W,se),X=new n(se);return X.registerDisposable(le.onControlMessage(oe=>{const pe=JSON.parse(oe.toString()),we=G(pe);we?($e.logService.error(`${te} received error control message when negotiating connection. Error:`),$e.logService.error(we),ue&&U(le),X.reject(we)):($e.reconnectionProtocol?.endAcceptReconnection(),$e.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${De(ae)}!`),X.resolve({protocol:le,firstMessage:pe}))})),X.promise}async function u($e,K){const{protocol:W}=await f($e,c.Management,void 0,K);return{protocol:W}}async function w($e,K,W){const{protocol:se,firstMessage:ae}=await f($e,c.ExtensionHost,K,W),te=ae&&ae.debugPort;return{protocol:se,debugPort:te}}async function y($e,K,W){const se=Date.now(),ae=ne($e,c.Tunnel),{protocol:te}=await s($e,c.Tunnel,K,W);return $e.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${De(se)}!`),te}async function D($e,K,W){const{connectTo:se,connectionToken:ae}=await $e.addressProvider.getAddress();return{commit:$e.commit,quality:$e.quality,connectTo:se,connectionToken:ae,reconnectionToken:K,reconnectionProtocol:W,remoteSocketFactoryService:$e.remoteSocketFactoryService,signService:$e.signService,logService:$e.logService}}async function S($e,K,W){return A($e,async se=>{const{protocol:ae}=await u(se,P.CancellationToken.None);return new _($e,K,W,se.reconnectionToken,ae)})}async function C($e,K){return A($e,async W=>{const{protocol:se,debugPort:ae}=await w(W,K,P.CancellationToken.None);return new re($e,K,W.reconnectionToken,se,ae)})}async function A($e,K){for(let se=1;;se++)try{const ae=(0,E.$2g)(),te=await D($e,ae,null);return await K(te)}catch(ae){if(se<5)$e.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),$e.logService.error(ae);else throw $e.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),$e.logService.error(ae),B.triggerPermanentFailure(0,0,k.$Tl.isHandled(ae)),ae}}async function b($e,K,W){const se=await D($e,(0,E.$2g)(),null);return await y(se,{host:K,port:W},P.CancellationToken.None)}function v($e){return(0,r.$sh)(K=>new Promise((W,se)=>{const ae=setTimeout(W,$e*1e3);K.onCancellationRequested(()=>{clearTimeout(ae),W()})}))}var M;(function($e){$e[$e.ConnectionLost=0]="ConnectionLost",$e[$e.ReconnectionWait=1]="ReconnectionWait",$e[$e.ReconnectionRunning=2]="ReconnectionRunning",$e[$e.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",$e[$e.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class N{constructor(K,W){this.reconnectionToken=K,this.millisSinceLastIncomingData=W,this.type=M.ConnectionLost}}e.$3l=N;class L{constructor(K,W,se,ae){this.reconnectionToken=K,this.millisSinceLastIncomingData=W,this.durationSeconds=se,this.c=ae,this.type=M.ReconnectionWait}skipWait(){this.c.cancel()}}e.$4l=L;class j{constructor(K,W,se){this.reconnectionToken=K,this.millisSinceLastIncomingData=W,this.attempt=se,this.type=M.ReconnectionRunning}}e.$5l=j;class z{constructor(K,W,se){this.reconnectionToken=K,this.millisSinceLastIncomingData=W,this.attempt=se,this.type=M.ConnectionGain}}e.$6l=z;class F{constructor(K,W,se,ae){this.reconnectionToken=K,this.millisSinceLastIncomingData=W,this.attempt=se,this.handled=ae,this.type=M.ReconnectionPermanentFailure}}e.$7l=F;class B extends R.$Wc{static triggerPermanentFailure(K,W,se){this._permanentFailure=!0,this.f=K,this.g=W,this.h=se,this.j.forEach(ae=>ae.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(K=>K.y())}static debugPauseSocketWriting(){this.j.forEach(K=>K.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(K,W,se,ae,te){super(),this.t=K,this.u=W,this.reconnectionToken=se,this.protocol=ae,this.w=te,this.m=this.B(new T.$me),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(ae.onSocketClose(le=>{const ue=he(this.t,this.reconnectionToken,!0);le?le.type===l.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${ue} received socket close event (hadError: ${le.hadError}).`),le.error&&this.u.logService.error(le.error)):(this.u.logService.info(`${ue} received socket close event (wasClean: ${le.wasClean}, code: ${le.code}, reason: ${le.reason}).`),le.event&&this.u.logService.error(le.event)):this.u.logService.info(`${ue} received socket close event.`),this.y()})),this.B(ae.onSocketTimeout(le=>{const ue=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ue} received socket timeout event (unacknowledgedMsgCount: ${le.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${le.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${le.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,R.$Uc)(()=>{const le=B.j.indexOf(this);le>=0&&B.j.splice(le,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const K=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${K} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const ae=se<W.length?W[se]:W[W.length-1];try{if(ae>0){const le=v(ae);this.m.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ae,le)),this.u.logService.info(`${K} waiting for ${ae} seconds before reconnecting...`);try{await le}catch{}}if(this.n){this.u.logService.error(`${K} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this.u.logService.info(`${K} resolving connection...`);const te=await D(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${K} connecting to ${te.connectTo}...`),await this.G(te,d(p)),this.u.logService.info(`${K} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(te){if(te.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${K} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this.u.logService.error(`${K} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(k.$Tl.isTemporarilyNotAvailable(te)){this.u.logService.info(`${K} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((te.code==="ETIMEDOUT"||te.code==="ENETUNREACH"||te.code==="ECONNREFUSED"||te.code==="ECONNRESET")&&te.syscall==="connect"){this.u.logService.info(`${K} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((0,O.$6)(te)){this.u.logService.info(`${K} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if(te instanceof k.$Tl){this.u.logService.error(`${K} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,k.$Tl.isHandled(te));break}this.u.logService.error(`${K} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this.n&&!this.s)}C(K,W,se){this.w?B.triggerPermanentFailure(K,W,se):this.D(K,W,se)}D(K,W,se){this.m.fire(new F(this.reconnectionToken,K,W,se)),U(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$8l=B;class _ extends B{constructor(K,W,se,ae,te){super(c.Management,K,ae,te,!0),this.client=this.B(new l.$ri(te,{remoteAuthority:W,clientId:se},K.ipcLogger))}async G(K,W){await u(K,W)}}e.$9l=_;class re extends B{constructor(K,W,se,ae,te){super(c.ExtensionHost,K,se,ae,!1),this.H=W,this.debugPort=te}async G(K,W){await w(K,this.H,W)}}e.$0l=re;function U($e){try{$e.acceptDisconnect();const K=$e.getSocket();$e.dispose(),K.dispose()}catch(K){(0,O.$3)(K)}}function G($e){if($e&&$e.type==="error"){const K=new Error(`Connection error: ${$e.reason}`);return K.code="VSCODE_CONNECTION_ERROR",K}return null}function Q($e,K){for(;$e.length<K;)$e+=" ";return $e}function ee($e,K){return`[remote-connection][${Q(m($e),13)}][${K.substr(0,5)}\u2026]`}function he($e,K,W){return`${ee($e,K)}[${W?"reconnect":"initial"}]`}function ne($e,K){return`${he(K,$e.reconnectionToken,!!$e.reconnectionProtocol)}[${$e.connectTo}]`}function De($e){return`${Date.now()-$e} ms`}}),define(ye[91],Se([1,0,15]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=h,e.$hn=P,e.$in=O,e.$jn=T;function h($){return $.scheme===r.Schemas.vscodeRemote?$.authority:void 0}function P($){if(!$)return;const a=$.indexOf("+");return a<0?$:$.substr(0,a)}function O($){const{host:a,port:I}=R($);if(typeof I>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:I}}function T($,a){let{host:I,port:E}=R($);return typeof E>"u"&&(E=a),{host:I,port:E}}function R($){const a=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const I=$.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const E=$.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:$,port:void 0}}}),define(ye[24],Se([1,0,13,5,91]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=O,e.$tn=E,e.$un=l,e.$vn=k,e.$wn=p,e.$xn=c,e.$yn=m,r=We(r),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function O(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var T;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(T||(e.ExtensionType=T={}));var R;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class ${constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,n){if(typeof g>"u"||g===null)return typeof n>"u"||n===null;if(typeof n>"u"||n===null)return!1;if(typeof g=="string"||typeof n=="string"){const o=typeof g=="string"?g:g.value,t=typeof n=="string"?n:n.value;return r.$Gf(o,t)}return g._lower===n._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$qn=$;class a{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const n of g)this.add(n)}add(g){this.c.add($.toKey(g))}delete(g){return this.c.delete($.toKey(g))}has(g){return this.c.has($.toKey(g))}}e.$rn=a;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete($.toKey(g))}get(g){return this.c.get($.toKey(g))}has(g){return this.c.has($.toKey(g))}set(g,n){this.c.set($.toKey(g),n)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=I;function E(d){return l(d)}function l(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function k(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function p(d,g){if(g){const n=`onResolveRemoteAuthority:${(0,P.$hn)(g)}`;return!!d.activationEvents?.includes(n)}return!1}function c(d){return d.map(g=>{const[n,o]=g.split("@");return{proposalName:n,version:o?parseInt(o):void 0}})}function m(d){return d.map(g=>g.split("@")[0])}e.$zn=(0,h.$Fi)("IBuiltinExtensionsScannerService")}),define(ye[147],Se([1,0,11,222,24,5]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.ExtensionManagementErrorCode=e.$jp=e.ExtensionGalleryErrorCode=e.$ip=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$cp=R,e.$dp=$,e.$ep=a,e.$fp=I,e.$gp=E,e.$hp=l,e.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9o=new RegExp(e.$8o),e.$0o="__web_extension",e.$$o="skipWalkthrough",e.$_o="extensionInstallSource",e.$ap="dependecyOrPackExtensionInstall",e.$bp="clientTargetPlatform";var T;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function R(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function $(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function a(t,i){switch(t){case r.Platform.Windows:return i==="x64"?P.TargetPlatform.WIN32_X64:i==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case r.Platform.Linux:return i==="x64"?P.TargetPlatform.LINUX_X64:i==="arm64"?P.TargetPlatform.LINUX_ARM64:i==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return i==="x64"?P.TargetPlatform.ALPINE_X64:i==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case r.Platform.Mac:return i==="x64"?P.TargetPlatform.DARWIN_X64:i==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case r.Platform.Web:return P.TargetPlatform.WEB}}function I(t,i){return i===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function E(t,i,s){return I(i,s)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===s}function l(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var k;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var p;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var c;(function(t){t.Install="install",t.Uninstall="uninstall"})(c||(e.StatisticType=c={}));var m;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$ip=(0,O.$Fi)("extensionGalleryService");var d;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(d||(e.ExtensionGalleryErrorCode=d={}));class g extends Error{constructor(i,s){super(i),this.code=s,this.name=s}}e.$jp=g;var n;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(n||(e.ExtensionManagementErrorCode=n={}));class o extends Error{constructor(i,s){super(i),this.code=s,this.name=s}}e.$kp=o,e.$lp=(0,O.$Fi)("extensionManagementService"),e.$mp="extensionsIdentifiers/disabled",e.$np="extensionsIdentifiers/enabled",e.$op=(0,O.$Fi)("IGlobalExtensionEnablementService"),e.$pp=(0,O.$Fi)("IExtensionTipsService"),e.$qp=(0,h.localize2)(0,"Extensions"),e.$rp=(0,h.localize2)(1,"Preferences")}),define(ye[148],Se([1,0,14,24]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MG=e.$LG=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(T,R){this.a.set(T,R)}readActivationEvents(T){return this.b.has(T)||this.b.set(T,this.c(T)),this.b.get(T)}createActivationEventsMap(T){const R=Object.create(null);for(const $ of T){const a=this.readActivationEvents($);a.length>0&&(R[h.$qn.toKey($.identifier)]=a)}return R}c(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const R=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];for(let $=0;$<R.length;$++)R[$]==="onUri"&&(R[$]=`onUri:${h.$qn.toKey(T.identifier)}`);if(!T.contributes)return R;for(const $ in T.contributes){const a=this.a.get($);if(!a)continue;const I=T.contributes[$],E=Array.isArray(I)?I:[I];try{a(E,R)}catch(l){(0,r.$3)(l)}}return R}}e.$LG=P,e.$MG=new P});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ye[285],Se([1,0,23,44,223,412,24,144]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=I,e.$Xp=E,e.$Yp=l,e.$Zp=k,e.$1p=p,e.$2p=c,e.$3p=m,e.$4p=d,h=zt(h),P=We(P),O=We(O);const $=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function I(o){return o=o.trim(),o==="*"||$.test(o)}function E(o){if(!I(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=o.match($);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function l(o){if(!o)return null;const t=o.majorBase,i=o.majorMustEqual,s=o.minorBase;let f=o.minorMustEqual;const u=o.patchBase;let w=o.patchMustEqual;o.hasCaret&&(t===0||(f=!1),w=!1);let y=0;if(o.preRelease){const D=a.exec(o.preRelease);if(D){const[,S,C,A]=D;y=Date.UTC(Number(S),Number(C)-1,Number(A))}}return{majorBase:t,majorMustEqual:i,minorBase:s,minorMustEqual:f,patchBase:u,patchMustEqual:w,isMinimum:o.hasGreaterEquals,notBefore:y}}function k(o,t,i){let s;typeof o=="string"?s=l(E(o)):s=o;let f;t instanceof Date?f=t.getTime():typeof t=="string"&&(f=new Date(t).getTime());let u;if(typeof i=="string"?u=l(E(i)):u=i,!s||!u)return!1;const w=s.majorBase,y=s.minorBase,D=s.patchBase;let S=u.majorBase,C=u.minorBase,A=u.patchBase;const b=u.notBefore;let v=u.majorMustEqual,M=u.minorMustEqual,N=u.patchMustEqual;return u.isMinimum?w>S?!0:w<S?!1:y>C?!0:y<C||f&&f<b?!1:D>=A:(w===1&&S===0&&(!v||!M||!N)&&(S=1,C=0,A=0,v=!0,M=!1,N=!1),w<S?!1:w>S?!v:y<C?!1:y>C?!M:D<A?!1:D>A?!N:!(f&&f<b))}function p(o,t,i,s,f){const u=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return u.push([h.default.Error,P.localize(0,null)]),u;if(typeof s.name!="string")return u.push([h.default.Error,P.localize(1,null,"name")]),u;if(typeof s.version!="string")return u.push([h.default.Error,P.localize(2,null,"version")]),u;if(!s.engines)return u.push([h.default.Error,P.localize(3,null,"engines")]),u;if(typeof s.engines.vscode!="string")return u.push([h.default.Error,P.localize(4,null,"engines.vscode")]),u;if(typeof s.extensionDependencies<"u"&&!n(s.extensionDependencies))return u.push([h.default.Error,P.localize(5,null,"extensionDependencies")]),u;if(typeof s.activationEvents<"u"){if(!n(s.activationEvents))return u.push([h.default.Error,P.localize(6,null,"activationEvents")]),u;if(typeof s.main>"u"&&typeof s.browser>"u")return u.push([h.default.Error,P.localize(7,null,"activationEvents","main","browser")]),u}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&u.push([h.default.Warning,P.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return u.push([h.default.Error,P.localize(9,null,"main")]),u;{const D=(0,r.$gh)(i,s.main);(0,r.$ah)(D,i)||u.push([h.default.Warning,P.localize(10,null,D.path,i.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return u.push([h.default.Error,P.localize(11,null,"browser")]),u;{const D=(0,r.$gh)(i,s.browser);(0,r.$ah)(D,i)||u.push([h.default.Warning,P.localize(12,null,D.path,i.path)])}}if(!O.valid(s.version))return u.push([h.default.Error,P.localize(13,null)]),u;const w=[];if(!c(o,t,s,f,w))for(const D of w)u.push([h.default.Error,D]);if(s.enabledApiProposals?.length){const D=[];if(!d([...s.enabledApiProposals],D))for(const S of D)u.push([h.default.Error,S])}return u}function c(o,t,i,s,f){return s||typeof i.main>"u"&&typeof i.browser>"u"?!0:g(o,t,i.engines.vscode,f)}function m(o,t,i){return o==="*"||g(t,i,o)}function d(o,t){if(o.length===0)return!0;const i=Array.isArray(t)?t:void 0,s=(i?void 0:t)??R.allApiProposals,f=[],u=(0,T.$xn)(o);for(const{proposalName:w,version:y}of u){const D=s[w];D&&y&&D.version!==y&&(D.version?f.push(P.localize(14,null,w,y,D.version)):f.push(P.localize(15,null,w,y)))}return i?.push(...f),f.length===0}function g(o,t,i,s=[]){const f=l(E(i));if(!f)return s.push(P.localize(16,null,i)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return s.push(P.localize(17,null,i)),!1}else if(!f.majorMustEqual)return s.push(P.localize(18,null,i)),!1;return k(o,t,f)?!0:(s.push(P.localize(19,null,o,i)),!1)}function n(o){if(!Array.isArray(o))return!1;for(let t=0,i=o.length;t<i;t++)if(typeof o[t]!="string")return!1;return!0}}),define(ye[286],Se([1,0,3,5]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl=(0,h.$Fi)("remoteSocketFactoryService");class P{constructor(){this.a={}}register(T,R){return this.a[T]??=[],this.a[T].push(R),(0,r.$Uc)(()=>{const $=this.a[T]?.indexOf(R);typeof $=="number"&&$>=0&&this.a[T]?.splice($,1)})}b(T){return(this.a[T.type]||[]).find($=>$.supports(T))}connect(T,R,$,a){const I=this.b(T);if(!I)throw new Error(`No socket factory found for ${T}`);return I.connect(T,R,$,a)}}e.$Wl=P}),define(ye[287],Se([1,0,22,14,3,230,71,5,12,37]),function(ce,e,r,h,P,O,T,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.$7p=l,e.$8p=k,e.$9p=p,e.$0p=c,e.$$p=m,e.$_p=d,e.$5p=(0,R.$Fi)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?t[i]="*****":t[i]=this.b[i];this.a=t}return this.a}}class E extends P.$Wc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,O.localize)(0,null),when:$.$rk.isEqualTo((0,$.$ok)($.LogLevel.Trace)).serialize()})}async c(t,i,s){const f=`${t} #${++this.b}: ${i.url}`;this.a.trace(`${f} - begin`,i.type,new I(i.headers??{}));try{const u=await s();return this.a.trace(`${f} - end`,i.type,u.res.statusCode,u.res.headers),u}catch(u){throw this.a.error(`${f} - error`,i.type,(0,h.$_)(u)),u}}}e.$6p=E;function l(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}function k(o){return o.res.statusCode===204}async function p(o){return k(o)?null:(await(0,r.$1e)(o.stream)).toString()}async function c(o){if(!l(o))throw new Error("Server returned "+o.res.statusCode);return p(o)}async function m(o){if(!l(o))throw new Error("Server returned "+o.res.statusCode);if(k(o))return null;const i=(await(0,r.$1e)(o.stream)).toString();try{return JSON.parse(i)}catch(s){throw s.message+=`:
`+i,s}}function d(o){n(o)}let g;function n(o){const t=a.$qo.as(T.$vo.Configuration),i=g;g={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},t.updateConfigurations({add:[g],remove:i?[i]:[]})}n(T.ConfigurationScope.APPLICATION)}),define(ye[288],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;class r{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(P){try{const O=await this.c();if(O){const T=String(r.a++);return this.b.set(T,O),{id:T,data:O.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,O){if(!P.id)return!0;const T=this.b.get(P.id);if(!T)return!1;this.b.delete(P.id);try{return T.validate(O)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(P){try{return await this.d(P)}catch{}return P}}e.$Kbc=r}),define(ye[118],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=void 0,e.$Xl="signService",e.$Yl=(0,r.$Fi)(e.$Xl)}),define(ye[149],Se([1,0,288]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=void 0;class h extends r.$Kbc{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(T=>new T.signer().sign(O))}h(){return new Promise((O,T)=>ce(["vsda"],O,T))}}e.$Qgc=h}),define(ye[289],Se([1,0,11,56,32]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=T,e.$tp=R;function O($){if(r.$u===r.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function T($,a,I,E,l,k,p,c,m,d){const g=Object.create(null);g["common.machineId"]=k,g["common.sqmId"]=p,g["common.devDeviceId"]=c,g.sessionID=(0,P.$2g)()+Date.now(),g.commitHash=E,g.version=l,g["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,r.$h)(r.$u),g["common.nodePlatform"]=h.$fc,g["common.nodeArch"]=I,g["common.product"]=d||"desktop",m&&(g["common.msftInternal"]=m);let n=0;const o=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),r.$l&&(g["common.snap"]="true");const t=O(a);return t&&(g["common.platformDetail"]=t),g}function R($){const a=h.env.USERDNSDOMAIN;if(!a)return!1;const I=a.toLowerCase();return $.some(E=>I===E)}}),define(ye[150],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,r.$Fi)("telemetryService"),e.$_l=(0,r.$Fi)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var h;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(ye[92],Se([1,0,25,18,91,289,150]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=void 0,e.$Bp=I,e.$Cp=E,e.$Dp=l,e.$Ep=k,e.$Fp=c,e.$Gp=d,e.$Hp=g,e.$Ip=t;class R{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$up=R;class ${constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vp=$,e.$wp=new $;class a{async publicLog(s,f,u){}async publicLogError(s,f,u){}}e.$xp=a,e.$yp="telemetry",e.$zp="extensionTelemetryLog",e.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function I(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry)}function E(i,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function l(i){const s=i.getValue(T.$hm),f=i.getValue(T.$im);if(i.getValue(T.$jm)===!1||f===!1)return T.TelemetryLevel.NONE;switch(s??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function k(i){const s={},f={},u={};m(i,u);for(let w in u){w=w.length>150?w.substr(w.length-149):w;const y=u[w];typeof y=="number"?f[w]=y:typeof y=="boolean"?f[w]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${y.length}`),s[w]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(s[w]=y)}return{properties:s,measurements:f}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(i){if(!i)return"none";const s=(0,P.$hn)(i);return p.has(s)?s:"other"}function m(i,s,f=0,u){if(i)for(const w of Object.getOwnPropertyNames(i)){const y=i[w],D=u?u+w:w;Array.isArray(y)?s[D]=(0,r.$io)(y):y instanceof Date?s[D]=y.toISOString():(0,h.$hg)(y)?f<2?m(y,s,f+1,D+"."):s[D]=(0,r.$io)(y):s[D]=y}}function d(i,s){const f=i.msftInternalDomains||[],u=s.getValue("telemetry.internalTesting");return(0,O.$tp)(f)||u}function g(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function n(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let f=i;const u=[];for(const S of s)for(;;){const C=S.exec(i);if(!C)break;u.push([C.index,S.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(f="";;){const S=y.exec(i);if(!S)break;const C=u.some(([A,b])=>S.index<b&&A<y.lastIndex);!w.test(S[0])&&!C&&(f+=i.substring(D,S.index)+"<REDACTED: user-file-path>",D=y.lastIndex)}return D<i.length&&(f+=i.substr(D)),f}function o(i){if(!i)return i;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of s)if(f.regex.test(i))return`<REDACTED: ${f.label}>`;return i}function t(i,s){return(0,r.$fo)(i,f=>{if(f instanceof R||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let u=f.replaceAll("%20"," ");u=n(u,s);for(const w of s)u=u.replace(w,"");return u=o(u),u}})}}),define(ye[290],Se([1,0,13,147,24,11,2,14,56,92]),function(ce,e,r,h,P,O,T,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Kp=void 0,e.$Jp=I,e.$Lp=p,e.$Mp=c,e.$Np=m,e.$Op=d,e.$Pp=g,e.$Qp=n,e.$Rp=o,e.$Tp=t,e.$Up=s;function I(f,u){return f.uuid&&u.uuid?f.uuid===u.uuid:f.id===u.id?!0:(0,r.$Bf)(f.id,u.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(u){const w=u.manifest?u.manifest.version:u.version,y=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new l(u.identifier,w,y)}static parse(u){const w=E.exec(u);return w&&w[1]&&w[2]?new l({id:w[1]},w[2],w[4]||void 0):null}constructor(u,w,y=P.TargetPlatform.UNDEFINED){this.identifier=u,this.version=w,this.targetPlatform=y,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof l?I(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$Kp=l;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(f){const u=k.exec(f);return u&&u[1]?[m(u[1]),u[2]]:[m(f),void 0]}function c(f,u){return`${f}.${u}`}function m(f){return f.toLowerCase()}function d(f,u){return m(c(f??P.$mn,u))}function g(f,u){const w=[],y=D=>{for(const S of w)if(S.some(C=>I(u(C),u(D))))return S;return null};for(const D of f){const S=y(D);S?S.push(D):w.push([D])}return w}function n(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}function o(f){return{id:new a.$up(f.identifier.id),name:new a.$up(f.name),version:f.version,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),isSigned:f.isSigned,...f.telemetryData}}e.$Sp=new P.$qn("pprice.better-merge");function t(f,u){const w=[],y=u.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const D=y.shift();if(D&&w.every(S=>!I(S.identifier,{id:D}))){const S=f.filter(C=>I(C.identifier,{id:D}));S.length===1&&(w.push(S[0]),y.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}async function i(f,u){if(!O.$k)return!1;let w;try{w=(await f.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await f.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){u.debug("Error while getting the os-release file.",(0,R.$_)(D))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(f,u){const w=await i(f,u),y=(0,h.$ep)(w?"alpine":O.$u,$.$gc);return u.debug("ComputeTargetPlatform:",y),y}}),define(ye[291],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=r,e.$Ds=h,e.$Es=P,e.$Fs=O,e.$Gs=T,e.$Hs=R;function r($){return[...$.entries()]}function h($){return $?[...$.entries()]:[]}function P($){return new Map($)}function O($){return new Map($??[])}function T($){return Array.from($.entries()).map(a=>[a[0],r(a[1].map),h(a[1].descriptionMap)])}function R($){return new Map($.map(a=>[a[0],{map:P(a[1]),descriptionMap:O(a[2])}]))}}),define(ye[292],Se([1,0,5,36,37]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.$os=e.$ns=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ms=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ls=void 0,e.$ls=new h.$Wj("terminalTabFocusMode",!1,!0);var O;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var T;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(T||(e.TerminalSettingId=T={}));var R;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(R||(e.PosixShellType=R={}));var $;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})($||(e.WindowsShellType=$={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var I;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var E;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E||(e.ProcessPropertyType=E={})),e.$ms=(0,r.$Fi)("ptyService");var l;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(l||(e.HeartbeatConstants=l={}));var k;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(k||(e.TerminalLocation=k={}));var p;(function(t){t.TerminalView="view",t.Editor="editor"})(p||(e.TerminalLocationString=p={}));var c;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(c||(e.LocalReconnectConstants=c={}));var m;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var d;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(d||(e.ProfileSource=d={}));var g;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(g||(e.ShellIntegrationStatus=g={}));var n;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$ns={Backend:"workbench.contributions.terminal.processBackend"};class o{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const s=this.b(i.remoteAuthority);if(this.a.has(s))throw new Error(`A terminal backend with remote authority '${s}' was already registered.`);this.a.set(s,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}P.$qo.add(e.$ns.Backend,new o),e.$os=(0,r.$Fi)("localPtyService"),e.$ps=(0,r.$Fi)("terminalLogService")}),define(ye[293],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wxb=void 0;class r{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,O,T=5){const R=O($=>{const a=typeof $=="string"?$:$.data;let I=this.a.get(P);if(I){I.data.push(a);return}const E=setTimeout(()=>this.flushBuffer(P),T);I={data:[a],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(P),R.dispose()}},this.a.set(P,I)});return R}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const O=this.a.get(P);O&&(this.a.delete(P),this.b(P,O.data.join("")))}}e.$wxb=r}),define(ye[294],Se([1,0,9,83,105,50,4,18,2,231,117,37]),function(ce,e,r,h,P,O,T,R,$,a,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ex=e.$Dx=e.$Cx=e.$Bx=e.$Ax=e.$zx=e.IconFontDefinition=e.IconContribution=e.$wx=void 0,e.$xx=m,e.$yx=d,E=We(E),e.$wx={IconContribution:"base.contributions.icons"};var l;(function(t){function i(s,f){let u=s.defaults;for(;O.ThemeIcon.isThemeIcon(u);){const w=c.getIcon(u.id);if(!w)return;u=w.defaults}return u}t.getDefinition=i})(l||(e.IconContribution=l={}));var k;(function(t){function i(f){return{weight:f.weight,style:f.style,src:f.src.map(u=>({format:u.format,location:u.location.toString()}))}}t.toJSONObject=i;function s(f){const u=w=>(0,R.$fg)(w)?w:void 0;if(f&&Array.isArray(f.src)&&f.src.every(w=>(0,R.$fg)(w.format)&&(0,R.$fg)(w.location)))return{weight:u(f.weight),style:u(f.style),src:f.src.map(w=>({format:w.format,location:$.URI.parse(w.location)}))}}t.fromJSONObject=s})(k||(e.IconFontDefinition=k={}));class p{constructor(){this.a=new T.$me,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,a.localize)(0,null)},fontCharacter:{type:"string",description:(0,a.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(i,s,f,u){const w=this.b[i];if(w){if(f&&!w.description){w.description=f,this.d.properties[i].markdownDescription=`${f} $(${i})`;const S=this.e.enum.indexOf(i);S!==-1&&(this.e.enumDescriptions[S]=f),this.a.fire()}return w}const y={id:i,description:f,defaults:s,deprecationMessage:u};this.b[i]=y;const D={$ref:"#/definitions/icons"};return u&&(D.deprecationMessage=u),f&&(D.markdownDescription=`${f}: $(${i})`),this.d.properties[i]=D,this.e.enum.push(i),this.e.enumDescriptions.push(f||""),this.a.fire(),{id:i}}deregisterIcon(i){delete this.b[i],delete this.d.properties[i];const s=this.e.enum.indexOf(i);s!==-1&&(this.e.enum.splice(s,1),this.e.enumDescriptions.splice(s,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(i=>this.b[i])}getIcon(i){return this.b[i]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(i,s){const f=this.f[i];return f||(this.f[i]=s,this.a.fire(),s)}deregisterIconFont(i){delete this.f[i]}getIconFont(i){return this.f[i]}toString(){const i=(w,y)=>w.id.localeCompare(y.id),s=w=>{for(;O.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(w=>this.b[w]);for(const w of u.filter(y=>!!y.description).sort(i))f.push(`|<i class="${s(w)}"></i>|${w.id}|${O.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const w of u.filter(y=>!O.ThemeIcon.isThemeIcon(y.defaults)).sort(i))f.push(`|<i class="${s(w)}"></i>|${w.id}|`);return f.join(`
`)}}const c=new p;E.$qo.add(e.$wx.IconContribution,c);function m(t,i,s,f){return c.registerIcon(t,i,s,f)}function d(){return c}function g(){const t=(0,P.$1j)();for(const i in t){const s="\\"+t[i].toString(16);c.registerIcon(i,{fontCharacter:s})}}g(),e.$zx="vscode://schemas/icons";const n=E.$qo.as(I.$ro.JSONContribution);n.registerSchema(e.$zx,c.getIconSchema());const o=new r.$Rh(()=>n.notifySchemaChanged(e.$zx),200);c.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$Ax=m("widget-close",h.$5j.close,(0,a.localize)(2,null)),e.$Bx=m("goto-previous-location",h.$5j.arrowUp,(0,a.localize)(3,null)),e.$Cx=m("goto-next-location",h.$5j.arrowDown,(0,a.localize)(4,null)),e.$Dx=O.ThemeIcon.modify(h.$5j.sync,"spin"),e.$Ex=O.ThemeIcon.modify(h.$5j.loading,"spin")}),define(ye[93],Se([1,0,4,3,11,2,45,5,12]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lw=e.$Kw=e.$Hw=e.$Fw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bw=e.$Aw=void 0,e.$Cw=E,e.$Dw=k,e.$Ew=p,e.$Gw=c,e.$Iw=m,e.$Jw=d,e.$Aw=(0,R.$Fi)("tunnelService"),e.$Bw=(0,R.$Fi)("sharedTunnelsService");var a;(function(o){o.Http="http",o.Https="https"})(a||(e.TunnelProtocol=a={}));var I;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(I||(e.TunnelPrivacyId=I={}));function E(o){return!!o.forwardPort}var l;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(l||(e.ProvidedOnAutoForward=l={}));function k(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}function p(o){if(o.scheme!=="http"&&o.scheme!=="https"||!o.query)return;const t=o.query.split("&");for(const i of t){const s=i.split("=")[1];if(/^https?:/.exec(s)){const f=k(O.URI.parse(s));if(f)return f}}}e.$Fw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function c(o){return e.$Fw.indexOf(o)>=0}e.$Hw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(o){return e.$Hw.indexOf(o)>=0}function d(o,t,i,s){if(i===P.OperatingSystem.Windows)return!1;if(i===P.OperatingSystem.Macintosh&&m(t)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(f?.length===4&&parseInt(f[1])>=18)return!1}return o<1024}class g{constructor(t,i,s){this.remoteAddress=t,this.localAddress=i,this.b=s,this.a=new r.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Kw=g;let n=class extends h.$Wc{constructor(t,i){super(),this.r=t,this.s=i,this.a=new r.$me,this.onTunnelOpened=this.a.event,this.b=new r.$me,this.onTunnelClosed=this.b.event,this.c=new r.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],i=Array.from(this.f.values());for(const s of i){const f=Array.from(s.values());for(const u of f){const w=await u.value;w&&typeof w!="string"&&t.push(w)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:i}of t.values())await i.then(s=>typeof s!="string"?s?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,i,s,f,u){this.z(t,i,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:i,localAddress:s,privacy:f,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,i){(m(t)||c(t))&&(t=e.$Fw[0]);const s=this.D(t,i);if(s)return++s.refcount,s.value}openTunnel(t,i,s,f,u,w=!1,y,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${s} on local port ${u}.`);const S=this.g??t;if(!S)return;if(i||(i="localhost"),f||(f=this.t),this.g&&this.n.has(s)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const C=this.F(S,i,s,f,u,w,y,D);return C?C.then(A=>{if(A){if(typeof A=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(i,s),A}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(i,s);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.w(A);return(A.tunnelRemoteHost!==i||A.tunnelRemotePort!==s)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),y&&A.privacy!==y&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),C)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const i=this.f.get(t.tunnelRemoteHost);if(i){const s=i.get(t.tunnelRemotePort);s&&(s.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,s))}}}}async y(t,i,s){if(s.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${i}.`);const f=s.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(i),f}}async closeTunnel(t,i){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${i} `);const s=this.f.get(t);if(s&&s.has(i)){const f=s.get(i);f.refcount=0,await this.y(t,i,f)}}z(t,i,s){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(i,{refcount:1,value:s})}async C(t,i){const s=this.f.get(t);if(s){const f=s.get(i),u=f?await f.value:void 0;(!u||typeof u=="string")&&s.delete(i),s.size===0&&this.f.delete(t)}}D(t,i){const s=[t];c(t)?(s.push(...e.$Fw),s.push(...e.$Hw)):m(t)&&s.push(...e.$Hw);const f=s.map(u=>this.f.get(u));for(const u of f){const w=u?.get(i);if(w)return w}}canTunnel(t){return!!k(t)}G(t,i,s,f,u,w,y){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${s} on local port ${f}.`);const D=s;this.n.add(D);const S=f===void 0?s:f,C={elevationRequired:u?this.isPortPrivileged(S):!1},A={remoteAddress:{host:i,port:s},localAddressPort:f,privacy:w,public:w?w!==I.Private:void 0,protocol:y},b=t.forwardPort(A,C);return b?(this.z(i,s,b),b.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),b}};e.$Lw=n,e.$Lw=n=Je([Ve(0,$.$_j),Ve(1,T.$_i)],n)}),define(ye[295],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,r.$Fi)("IUriIdentityService")}),define(ye[296],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Mw=void 0,e.$Mw=(0,r.$Fi)("editSessionIdentityService");var h;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(ye[297],Se([1,0,15]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=h,e.$5M=P,e.$6M=O,e.$7M=T,e.$8M=R;function h($){return $.scheme!==r.Schemas.file&&$.scheme!==r.Schemas.vscodeRemote}function P($){if($.folders.length)return $.folders.every(a=>h(a.uri))?$.folders[0].uri:void 0;if($.configuration&&h($.configuration))return $.configuration}function O($){return P($)?.scheme}function T($){return P($)?.authority}function R($){return P($)!==void 0}}),define(ye[46],Se([1,0,233,17,85,23,2,5,15]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=a,e.$Qi=I,e.$Ti=E,e.$Ui=l,e.$Vi=k,e.$Wi=c,e.$Xi=m,e.$1i=n,e.$6i=o,e.$7i=t,e.$9i=i,e.$0i=s,e.$$i=f,e.$Oi=(0,R.$Fi)("contextService");function a(u){const w=u;return typeof w?.id=="string"&&T.URI.isUri(w.uri)}function I(u){return typeof u?.id=="string"&&!a(u)&&!l(u)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function E(u,w){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,h.$pc)(u)}:w?e.$Ri:e.$Si;const y=u;return y.configuration?{id:y.id,configPath:y.configuration}:y.folders.length===1?{id:y.id,uri:y.folders[0].uri}:{id:y.id}}function l(u){const w=u;return typeof w?.id=="string"&&T.URI.isUri(w.configPath)}function k(u){const w=u;if(w?.uri)return{id:w.id,uri:T.URI.revive(w.uri)};const y=u;if(y?.configPath)return{id:y.id,configPath:T.URI.revive(y.configPath)};if(u?.id)return{id:u.id}}var p;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function c(u){const w=u;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}function m(u){const w=u;return!!(w&&typeof w=="object"&&T.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}class d{constructor(w,y,D,S,C){this.h=w,this.j=D,this.k=S,this.l=C,this.c=P.$Li.forUris(this.l,()=>!0),this.folders=y}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=P.$Li.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=d;class g{constructor(w,y){this.raw=y,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,O.$gh)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=g;function n(u){return new g({uri:u,index:0,name:(0,O.$ch)(u)},{uri:u.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,r.localize)(0,null),extensions:[e.$2i]}],e.$5i="workspace.json";function o(u,w){return O.$0g.isEqualOrParent(u,w.untitledWorkspacesHome)}function t(u){let w;return T.URI.isUri(u)?w=u:w=u.configuration,w?.scheme===$.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(u){return u.id===e.$8i}function s(u,w){return!o(u,w)&&!t(u)}function f(u){return(typeof u=="string"?(0,h.$qc)(u):(0,O.$eh)(u))===e.$3i}}),define(ye[151],Se([1,0,60,4,3,23,2,232,145,28,5,12,46,29,295,9,32,13,18]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=o,e.$Ml=t,e.$Nl=i;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(u){const w=u;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&typeof w.isDefault=="boolean"&&typeof w.name=="string"&&T.URI.isUri(w.location)&&T.URI.isUri(w.globalStorageHome)&&T.URI.isUri(w.settingsResource)&&T.URI.isUri(w.keybindingsResource)&&T.URI.isUri(w.tasksResource)&&T.URI.isUri(w.snippetsHome)&&T.URI.isUri(w.extensionsResource))}e.$Ll=(0,I.$Fi)("IUserDataProfilesService");function t(u,w){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:T.URI.revive(u.location).with({scheme:w}),globalStorageHome:T.URI.revive(u.globalStorageHome).with({scheme:w}),settingsResource:T.URI.revive(u.settingsResource).with({scheme:w}),keybindingsResource:T.URI.revive(u.keybindingsResource).with({scheme:w}),tasksResource:T.URI.revive(u.tasksResource).with({scheme:w}),snippetsHome:T.URI.revive(u.snippetsHome).with({scheme:w}),extensionsResource:T.URI.revive(u.extensionsResource).with({scheme:w}),cacheHome:T.URI.revive(u.cacheHome).with({scheme:w}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}function i(u,w,y,D,S,C){return{id:u,name:w,location:y,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:C&&S?.useDefaultFlags?.globalState?C.globalStorageHome:(0,O.$gh)(y,"globalStorage"),settingsResource:C&&S?.useDefaultFlags?.settings?C.settingsResource:(0,O.$gh)(y,"settings.json"),keybindingsResource:C&&S?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,O.$gh)(y,"keybindings.json"),tasksResource:C&&S?.useDefaultFlags?.tasks?C.tasksResource:(0,O.$gh)(y,"tasks.json"),snippetsHome:C&&S?.useDefaultFlags?.snippets?C.snippetsHome:(0,O.$gh)(y,"snippets"),extensionsResource:C&&S?.useDefaultFlags?.extensions?C.extensionsResource:(0,O.$gh)(y,"extensions.json"),cacheHome:(0,O.$gh)(D,u),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let s=class extends P.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(w,y,D,S){super(),this.t=w,this.u=y,this.w=D,this.y=S,this.f=!0,this.h=this.B(new h.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new h.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new h.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new h.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new k.$Cc,workspaces:new k.$Cc,emptyWindows:new Map},this.profilesHome=(0,O.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(w){this.f!==w&&(this.z=void 0,this.f=w)}isEnabled(){return this.f}get C(){if(!this.z){const w=this.D(),y=[w];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,g.$fg)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}y.push(i((0,O.$dh)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},w))}}catch(C){this.y.error(C)}const D=new k.$Cc,S=new Map;if(y.length)try{const C=this.Q();if(C.workspaces)for(const[A,b]of Object.entries(C.workspaces)){const v=T.URI.parse(A),M=y.find(N=>N.id===b);M&&D.set(v,M)}if(C.emptyWindows)for(const[A,b]of Object.entries(C.emptyWindows)){const v=y.find(M=>M.id===b);v&&S.set(A,v)}}catch(C){this.y.error(C)}this.z={profiles:y,workspaces:D,emptyWindows:S}}return this.z}D(){const w=i("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...w,extensionsResource:this.S()??w.extensionsResource,isDefault:!0}}async createTransientProfile(w){const y="Temp",D=new RegExp(`${(0,d.$if)(y)}\\s(\\d+)`);let S=0;for(const A of this.profiles){const b=D.exec(A.name),v=b?parseInt(b[1]):0;S=v>S?v:S}const C=`${y} ${S+1}`;return this.createProfile((0,r.$tj)((0,m.$2g)()).toString(16),C,{transient:!0},w)}async createNamedProfile(w,y,D){return this.createProfile((0,r.$tj)((0,m.$2g)()).toString(16),w,y,D)}async createProfile(w,y,D,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(w,y,D);return S&&await this.setProfileForWorkspace(S,C),C}async F(w,y,D){if(!(0,g.$fg)(y)||!y)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(y);return S||(S=(async()=>{try{if(this.profiles.find(v=>v.name===y||v.id===w))throw new Error(`Profile with ${y} name already exists`);const A=i(w,y,(0,O.$gh)(this.profilesHome,w),this.g,D,this.defaultProfile);await this.u.createFolder(A.location);const b=[];return this.j.fire({profile:A,join(v){b.push(v)}}),await c.Promises.settled(b),this.I([A],[],[]),A}finally{this.r.delete(y)}})(),this.r.set(y,S)),S}async updateProfile(w,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(S=>S.id===w.id);if(!D)throw new Error(`Profile '${w.name}' does not exist`);return D=i(D.id,y.name??D.name,D.location,this.g,{shortName:y.shortName??D.shortName,icon:y.icon===null?void 0:y.icon??D.icon,transient:y.transient??D.isTransient,useDefaultFlags:y.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(w.isDefault)throw new Error("Cannot remove default profile");const y=this.profiles.find(S=>S.id===w.id);if(!y)throw new Error(`Profile '${w.name}' does not exist`);const D=[];this.m.fire({profile:y,join(S){D.push(S)}});try{await Promise.allSettled(D)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])y.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])y.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[y],[]);try{await this.u.del(y.cacheHome,{recursive:!0})}catch(S){(0,a.$ql)(S)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(S)}}async setProfileForWorkspace(w,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(S=>S.id===y.id);if(!D)throw new Error(`Profile '${y.name}' does not exist`);this.L(w,D)}unsetWorkspace(w,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(w,void 0,y)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const w=await this.u.resolve(this.profilesHome);await Promise.all((w.children||[]).filter(y=>y.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,y.resource))).map(y=>this.u.del(y.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const w=this.s.profiles.filter(y=>!this.H(y));await Promise.allSettled(w.map(y=>this.removeProfile(y)))}getProfileForWorkspace(w){const y=this.G(w),D=T.URI.isUri(y)?this.C.workspaces.get(y):this.C.emptyWindows.get(y);return D||((0,l.$Pi)(w)?this.s.folders.get(w.uri):(0,l.$Ui)(w)?this.s.workspaces.get(w.configPath):this.s.emptyWindows.get(w.id))}G(w){return(0,l.$Pi)(w)?w.uri:(0,l.$Ui)(w)?w.configPath:w.id}H(w){return!!([...this.C.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.C.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.s.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.s.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.s.folders.values()].some(y=>this.w.extUri.isEqual(y.location,w.location)))}I(w,y,D){const S=[...this.profiles,...w],C=[],A=this.s.profiles;this.s.profiles=[];for(let b of S){if(b.isDefault||y.some(M=>b.id===M.id))continue;b=D.find(M=>b.id===M.id)??b;const v=A.find(M=>b.id===M.id);if(b.isTransient)this.s.profiles.push(b);else{if(v){for(const[M,N]of this.s.emptyWindows.entries())if(b.id===N.id){this.L({id:M},b);break}for(const[M,N]of this.s.workspaces.entries())if(b.id===N.id){this.L({id:"",configPath:M},b);break}for(const[M,N]of this.s.folders.entries())if(b.id===N.id){this.L({id:"",uri:M},b);break}}C.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags})}}this.P(C),this.z=void 0,this.J(w,y,D)}J(w,y,D){this.h.fire({added:w,removed:y,updated:D,all:this.profiles})}L(w,y,D){if(D=y?.isTransient?!0:D,D)(0,l.$Pi)(w)?(this.s.folders.delete(w.uri),y&&this.s.folders.set(w.uri,y)):(0,l.$Ui)(w)?(this.s.workspaces.delete(w.configPath),y&&this.s.workspaces.set(w.configPath,y)):(this.s.emptyWindows.delete(w.id),y&&this.s.emptyWindows.set(w.id,y));else{this.L(w,void 0,!0);const S=this.G(w);T.URI.isUri(S)?(this.C.workspaces.delete(S),y&&this.C.workspaces.set(S,y)):(this.C.emptyWindows.delete(S),y&&this.C.emptyWindows.set(S,y)),this.M()}}M(){const w={};for(const[D,S]of this.C.workspaces.entries())w[D.toString()]=S.id;const y={};for(const[D,S]of this.C.emptyWindows.entries())y[D.toString()]=S.id;this.R({workspaces:w,emptyWindows:y}),this.z=void 0}N(w){const y={},D=this.D();if(w.workspaces)for(const[C,A]of Object.entries(w.workspaces)){const b=T.URI.parse(A);y[C]=this.w.extUri.isEqual(b,D.location)?D.id:this.w.extUri.basename(b)}const S={};if(w.emptyWindows)for(const[C,A]of Object.entries(w.emptyWindows)){const b=T.URI.parse(A);S[C]=this.w.extUri.isEqual(b,D.location)?D.id:this.w.extUri.basename(b)}return{workspaces:y,emptyWindows:S}}O(){return[]}P(w){throw new Error("not implemented")}Q(){return{}}R(w){throw new Error("not implemented")}S(){}};e.$Ol=s,e.$Ol=s=Je([Ve(0,$.$Mi),Ve(1,a.$_k),Ve(2,p.$Jl),Ve(3,E.$_j)],s);class f extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(w){this.a=w}Q(){return this.X}R(w){this.X=w}}e.$Pl=f}),define(ye[152],Se([1,0,9,4,3,62,18,210,5,151]),function(ce,e,r,h,P,O,T,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fq=e.$eq=e.$dq=void 0,e.$gq=k,e.$iq=c,e.$kq=d,e.$dq="__$__isNewStorageMarker",e.$eq="__$__targetStorageMarker",e.$fq=(0,$.$Fi)("storageService");var I;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var E;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var l;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(l||(e.StorageTarget=l={}));function k(g){const n=g.get(e.$eq);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class p extends P.$Wc{static{this.a=60*1e3}constructor(n={flushInterval:p.a}){super(),this.m=n,this.b=this.B(new h.$pe),this.c=this.B(new h.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new h.$me),this.onWillSaveState=this.f.event,this.h=this.B(new r.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,t){return h.Event.filter(this.b.event,i=>i.scope===n&&(o===void 0||i.key===o),t)}n(){this.j.value=(0,r.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:t,external:i}=o;if(t===e.$eq){switch(n){case E.APPLICATION:this.H=void 0;break;case E.PROFILE:this.F=void 0;break;case E.WORKSPACE:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:t,target:this.J(n)[t],external:i})}w(n){this.f.fire({reason:n})}get(n,o,t){return this.P(o)?.get(n,t)}getBoolean(n,o,t){return this.P(o)?.getBoolean(n,t)}getNumber(n,o,t){return this.P(o)?.getNumber(n,t)}getObject(n,o,t){return this.P(o)?.getObject(n,t)}storeAll(n,o){this.y(()=>{for(const t of n)this.store(t.key,t.value,t.scope,t.target,o)})}store(n,o,t,i,s=!1){if((0,T.$og)(o)){this.remove(n,t,s);return}this.y(()=>{this.z(n,t,i),this.P(t)?.set(n,o,s)})}remove(n,o,t=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,t)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const t=[],i=this.J(n);for(const s of Object.keys(i))i[s]===o&&t.push(s);return t}z(n,o,t,i=!1){const s=this.J(o);typeof t=="number"?s[n]!==t&&(s[n]=t,this.P(o)?.set(e.$eq,JSON.stringify(s),i)):typeof s[n]=="number"&&(delete s[n],this.P(o)?.set(e.$eq,JSON.stringify(s),i))}get D(){return this.C||(this.C=this.L(E.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(E.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(E.APPLICATION)),this.H}J(n){switch(n){case E.APPLICATION:return this.I;case E.PROFILE:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?k(o):Object.create(null)}isNew(n){return this.getBoolean(e.$dq,n)===!0}async flush(n=I.NONE){this.f.fire({reason:n});const o=this.P(E.APPLICATION),t=this.P(E.PROFILE),i=this.P(E.WORKSPACE);switch(n){case I.NONE:await r.Promises.settled([o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await r.Promises.settled([o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(E.APPLICATION)?.items??new Map,o=this.P(E.PROFILE)?.items??new Map,t=this.P(E.WORKSPACE)?.items??new Map;return d(n,o,t,this.Q(E.APPLICATION)??"",this.Q(E.PROFILE)??"",this.Q(E.WORKSPACE)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(I.NONE),(0,a.$Kl)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||c(o)&&c(n))}N(n,o,t){this.y(()=>{const i=new Set;for(const[s,f]of n)i.add(s),o.get(s)!==f&&this.u(t,{key:s,external:!0});for(const[s]of o.items)i.has(s)||this.u(t,{key:s,external:!0})})}}e.$hq=p;function c(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class m extends p{constructor(){super(),this.U=this.B(new R.$bq(new R.$cq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$bq(new R.$cq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$bq(new R.$cq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(E.WORKSPACE,n))),this.B(this.W.onDidChangeStorage(n=>this.u(E.PROFILE,n))),this.B(this.U.onDidChangeStorage(n=>this.u(E.APPLICATION,n)))}P(n){switch(n){case E.APPLICATION:return this.U;case E.PROFILE:return this.W;default:return this.X}}Q(n){switch(n){case E.APPLICATION:return"inMemory (application)";case E.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$jq=m;async function d(g,n,o,t,i,s){const f=v=>{try{return JSON.parse(v)}catch{return v}},u=new Map,w=new Map;g.forEach((v,M)=>{u.set(M,v),w.set(M,f(v))});const y=new Map,D=new Map;n.forEach((v,M)=>{y.set(M,v),D.set(M,f(v))});const S=new Map,C=new Map;o.forEach((v,M)=>{S.set(M,v),C.set(M,f(v))}),console.group(t!==i?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const A=[];if(u.forEach((v,M)=>{A.push({key:M,value:v})}),console.table(A),console.groupEnd(),console.log(w),t!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const v=[];y.forEach((M,N)=>{v.push({key:N,value:M})}),console.table(v),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${s})`);const b=[];S.forEach((v,M)=>{b.push({key:M,value:v})}),console.table(b),console.groupEnd(),console.log(C)}}),define(ye[119],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=void 0;class r{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const O=this.c++;return this.b.set(O,P),this.e(),O}get(P,O){return this.b.has(P)?this.b.get(P)[O]:void 0}delete(P){this.b.delete(P),this.e()}e(){r.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$hoc=r}),define(ye[63],Se([1,0,15,23,28,5]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$noc=e.$moc=void 0;class T{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new h.$8g($=>{const a=this.b.get($.scheme);return!(a===void 0||a&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,a){a===null?this.b.delete($.scheme):this.b.set($.scheme,a)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$moc=T,e.$noc=(0,O.$Fi)("IExtHostFileSystemInfo")}),define(ye[30],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0,e.$eQ=(0,r.$Fi)("IExtHostInitDataService")}),define(ye[298],Se([1,0,238,12,278,30]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vqc=void 0;let T=class extends P.$oR{constructor($,a,I){const E=I.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",l=I.remote.isRemote?(0,r.localize)(0,null):$?(0,r.localize)(1,null):(0,r.localize)(2,null);super(a.createLogger(E,{name:l}))}};e.$vqc=T,e.$vqc=T=Je([Ve(1,h.$ak),Ve(2,O.$eQ)],T)}),define(ye[299],Se([1,0,9]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=e.$5oc=void 0;class h{constructor(T,R,$){this.h=new Map,this.a=T,this.b=R,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(a=>(this.f=a,this)),this.g=this.c.onDidChangeStorage(a=>{a.shared===this.b&&a.key===this.a&&(this.f=a.value)}),this.i=new r.$Rh(()=>{const a=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of a.values())I.complete()}catch(I){for(const E of a.values())E.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this.d}get(T,R){let $=this.f[T];return typeof $>"u"&&($=R),$}update(T,R){this.f[T]=R;const $=this.h.get(T);if($!==void 0)return $.p;const a=new r.$3h;return this.h.set(T,a),this.i.isScheduled()||this.i.schedule(),a.p}dispose(){this.g.dispose()}}e.$5oc=h;class P extends h{setKeysForSync(T){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},T)}constructor(T,R){super(T.identifier.value,!0,R),this.j=T}}e.$6oc=P}),define(ye[300],Se([1,0,4,2]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=void 0;class P{constructor(T){this.c=T,this.a=new r.$me,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.$me,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(T,R,$,a){const E=this.c.getNotebookDocument(h.URI.revive(T)).acceptModelChanged(R.value,$,a);this.b.fire(E)}$acceptDirtyStateChanged(T,R){this.c.getNotebookDocument(h.URI.revive(T)).acceptDirty(R)}$acceptModelSaved(T){const R=this.c.getNotebookDocument(h.URI.revive(T));this.a.fire(R.apiNotebook)}}e.$Ypc=P}),define(ye[20],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0,e.$1P=(0,r.$Fi)("IExtHostRpcService");class h{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$2P=h}),define(ye[301],Se([1,0,24,4]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=void 0;class P{#e;constructor(T,R){this.a=r.$qn.toKey(T.identifier),this.#e=R,this.onDidChange=h.Event.map(h.Event.filter(this.#e.onDidChangePassword,$=>$.extensionId===this.a),$=>({key:$.key}))}get(T){return this.#e.get(this.a,T)}store(T,R){return this.#e.store(this.a,T,R)}delete(T){return this.#e.delete(this.a,T)}}e.$cpc=P}),define(ye[73],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=e.$Coc=void 0,e.$Coc=(0,r.$Fi)("IURITransformerService");class h{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.$Doc=h}),define(ye[302],Se([1,0,303,413,414,67,2,12,415]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4qc=I,r=We(r),h=We(h),P=We(P),O=We(O);const a=!1;function I(n,o,t,i,s,f){const u=f.environment.useHostProxy,w=typeof u=="boolean"?u:!f.remote.isRemote,y={resolveProxy:C=>n.resolveProxy(C),lookupProxyAuthorization:m.bind(void 0,i,s,o,{},f.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>l(o),addCertificatesV2:()=>k(o),log:i,getLogLevel:()=>{const C=i.getLevel();switch(C){case R.LogLevel.Trace:return $.LogLevel.Trace;case R.LogLevel.Debug:return $.LogLevel.Debug;case R.LogLevel.Info:return $.LogLevel.Info;case R.LogLevel.Warning:return $.LogLevel.Warning;case R.LogLevel.Error:return $.LogLevel.Error;case R.LogLevel.Off:return $.LogLevel.Off;default:return A(C)}function A(b){return i.error("Unknown log level",b),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:w,loadAdditionalCertificates:async()=>{const C=[];if(f.remote.isRemote&&C.push((0,$.loadSystemCertificates)({log:i})),w){i.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const A=n.loadCertificates();A.then(b=>i.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",b.length)),C.push(A)}return(await Promise.all(C)).flat()},env:process.env},D=(0,$.createProxyResolver)(y),S=E(y,D);return c(t,S)}function E(n,o){function t(i,s){return Object.assign(i.default||i,s)}return{http:t(r,(0,$.createHttpPatch)(n,r,o)),https:t(h,(0,$.createHttpPatch)(n,h,o)),net:t(O,(0,$.createNetPatch)(n,O)),tls:t(P,(0,$.createTlsPatch)(n,P))}}function l(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",a)&&!!o.get("systemCertificates")}function k(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",a)&&!!o.get("systemCertificates")}const p=new Map;function c(n,o){return n.getExtensionPathIndex().then(t=>{const i=globalThis._VSCODE_NODE_MODULES.module,s=i._load;i._load=function(u,w,y){if(u==="net")return o.net;if(u==="tls")return o.tls;if(u!=="http"&&u!=="https")return s.apply(this,arguments);const D=t.findSubstr(T.URI.file(w.filename));let S=p.get(D);if(S||p.set(D,S={}),!S[u]){const C=o[u];S[u]={...C}}return S[u]}})}async function m(n,o,t,i,s,f,u,w){const y=i[f];u&&(i[f]=u),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${f}`,`proxyAuthenticate:${u}`,`proxyAuthenticateCache:${y}`);const D=u||y,S=Array.isArray(D)?D:typeof D=="string"?[D]:[];if(g(o,S,s),S.some(C=>/^(Negotiate|Kerberos)( |$)/i.test(C))&&!w.kerberosRequested)try{w.kerberosRequested=!0;const C=await new Promise((N,L)=>{ce(["kerberos"],N,L)}).then(We),A=new URL(f),b=t.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${A.hostname}`:`HTTP@${A.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${f}`,`spn:${b}`),"Negotiate "+await(await C.initializeClient(b)).step("")}catch(C){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",C)}}let d=!1;function g(n,o,t){d||!o.length||(d=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(i=>i.split(" ")[0]).join(","),extensionHostType:t?"remote":"local"}))}}),define(ye[304],Se([1,0,142]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=P;function h(O){return{transformIncoming:T=>T.scheme==="vscode-remote"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="file"?{scheme:"vscode-local",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoing:T=>T.scheme==="file"?{scheme:"vscode-remote",authority:O,path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="vscode-local"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoingScheme:T=>T==="file"?"vscode-remote":T==="vscode-local"?"file":T}}function P(O){return new r.$Ln(h(O))}});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ye[153],Se([1,0,248,18,2,3,5,37,28,15,51,202,44]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$eG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$7F=e.EditorInputCapabilities=e.$6F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0,e.$WF=c,e.$XF=m,e.$YF=d,e.$ZF=g,e.$1F=n,e.$2F=o,e.$3F=t,e.$4F=i,e.$5F=s,e.$8F=S,e.$9F=A,e.$0F=b,e.$$F=v,e.$_F=M,e.$aG=N,e.$bG=L,e.$cG=j,e.$dG=U,e.$fG=ee,e.$gG=ne,e.$hG=De,e.$iG=$e,l=zt(l),e.$RF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$SF={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.$TF="workbench.editor.sidebysideEditor",e.$UF="workbench.editors.textDiffEditor",e.$VF="workbench.editors.binaryResourceDiffEditor";var k;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var p;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function c(K){const W=K;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}function m(K){const W=K;return!!W&&typeof W.getScrollPosition=="function"&&typeof W.setScrollPosition=="function"&&!!W.onDidChangeScroll}function d(K,W,se){for(const ae of se.visibleEditorPanes)if(ae.group.id===W&&K.matches(ae.input))return ae.getViewState()}function g(K){if(S(K))return!1;const W=K;return P.URI.isUri(W?.resource)}function n(K){if(S(K))return!1;const W=K;return W?.original!==void 0&&W.modified!==void 0}function o(K){if(S(K))return!1;const W=K;return!W||W.resources&&!Array.isArray(W.resources)?!1:!!W.resources||!!W.multiDiffSource}function t(K){if(S(K)||n(K))return!1;const W=K;return W?.primary!==void 0&&W.secondary!==void 0}function i(K){if(S(K))return!1;const W=K;return W?W.resource===void 0||W.resource.scheme===a.Schemas.untitled||W.forceUntitled===!0:!1}function s(K){if(S(K))return!1;const W=K;return P.URI.isUri(W?.base?.resource)&&P.URI.isUri(W?.input1?.resource)&&P.URI.isUri(W?.input2?.resource)&&P.URI.isUri(W?.result?.resource)}var f;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var u;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class w{constructor(){this.a=new Map}registerSource(W,se){let ae=this.a.get(W);return ae||(ae={source:W,label:se},this.a.set(W,ae)),ae.source}getSourceLabel(W){return this.a.get(W)?.label??W}}e.$6F=new w;var y;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor",K[K.MultipleEditors=256]="MultipleEditors",K[K.Scratchpad=512]="Scratchpad"})(y||(e.EditorInputCapabilities=y={}));class D extends O.$Wc{}e.$7F=D;function S(K){return K instanceof D}function C(K){const W=K;return P.URI.isUri(W?.preferredResource)}function A(K){const W=K;return S(W?.primary)&&S(W?.secondary)}function b(K){const W=K;return S(W?.modified)&&S(W?.original)}function v(K,W,se,ae,te){return $e(ae,[(0,E.$pj)({id:"workbench.action.openLargeFile",label:(0,r.localize)(2,null),run:()=>{const le={...se,limits:{size:Number.MAX_VALUE}};K.openEditor(W,le)}}),(0,E.$pj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(3,null),run:()=>te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function M(K){return S(K?.editor)}function N(K){const W=K;return M(K)&&W?.group!==void 0}function L(K){const W=K;return typeof W?.groupId=="number"&&S(W.editor)}function j(K){return typeof K?.groupId=="number"}var z;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var F;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LABEL=2]="GROUP_LABEL",K[K.GROUP_LOCKED=3]="GROUP_LOCKED",K[K.EDITORS_SELECTION=4]="EDITORS_SELECTION",K[K.EDITOR_OPEN=5]="EDITOR_OPEN",K[K.EDITOR_CLOSE=6]="EDITOR_CLOSE",K[K.EDITOR_MOVE=7]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=9]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=11]="EDITOR_PIN",K[K.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",K[K.EDITOR_STICKY=13]="EDITOR_STICKY",K[K.EDITOR_DIRTY=14]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var B;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class _{getOriginalUri(W,se){if(!W)return;if(s(W))return e.$eG.getOriginalUri(W.result,se);if(se?.supportSideBySide){const{primary:te,secondary:le}=this.a(W);if(te&&le){if(se?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===B.ANY)return this.getOriginalUri(te,{filterByScheme:se.filterByScheme})??this.getOriginalUri(le,{filterByScheme:se.filterByScheme});W=se.supportSideBySide===B.PRIMARY?te:le}}if(n(W)||o(W)||t(W)||s(W))return;const ae=C(W)?W.preferredResource:W.resource;return!ae||!se||!se.filterByScheme?ae:this.b(ae,se.filterByScheme)}a(W){return A(W)||t(W)?{primary:W.primary,secondary:W.secondary}:b(W)||n(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,se){if(!W)return;if(s(W))return e.$eG.getCanonicalUri(W.result,se);if(se?.supportSideBySide){const{primary:te,secondary:le}=this.a(W);if(te&&le){if(se?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===B.ANY)return this.getCanonicalUri(te,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:se.filterByScheme});W=se.supportSideBySide===B.PRIMARY?te:le}}if(n(W)||o(W)||t(W)||s(W))return;const ae=W.resource;return!ae||!se||!se.filterByScheme?ae:this.b(ae,se.filterByScheme)}b(W,se){if(Array.isArray(se)){if(se.some(ae=>W.scheme===ae))return W}else if(se===W.scheme)return W}}var re;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.KEYBOARD=1]="KEYBOARD",K[K.MOUSE=2]="MOUSE"})(re||(e.EditorCloseMethod=re={}));function U(K,W,se,ae){if(!K.isSticky(W))return!1;switch(ae.preventPinnedEditorClose){case"keyboardAndMouse":return se===re.MOUSE||se===re.KEYBOARD;case"mouse":return se===re.MOUSE;case"keyboard":return se===re.KEYBOARD}return!1}e.$eG=new _;var G;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(G||(e.CloseDirection=G={}));class Q{constructor(){this.c=new Map,this.d=new Map}start(W){const se=this.a=W.get(T.$Ei);for(const[ae,te]of this.c)this.e(ae,te,se);this.c.clear()}e(W,se,ae){const te=ae.createInstance(se);this.d.set(W,te)}registerFileEditorFactory(W){if(this.b)throw new Error("Can only register one file editor factory.");this.b=W}getFileEditorFactory(){return(0,h.$qg)(this.b)}registerEditorSerializer(W,se){if(this.c.has(W)||this.d.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.a?this.e(W,se,this.a):this.c.set(W,se),(0,O.$Uc)(()=>{this.c.delete(W),this.d.delete(W)})}getEditorSerializer(W){return this.d.get(typeof W=="string"?W:W.typeId)}}R.$qo.add(e.$RF.EditorFactory,new Q);async function ee(K,W,se){return!K||!K.length?[]:await Promise.all(K.map(async ae=>{const te=P.URI.revive(ae.fileUri);if(!te){se.info("Cannot resolve the path because it is not valid.",ae);return}if(!await W.canHandleResource(te)){se.info("Cannot resolve the path because it cannot be handled",ae);return}let ue=ae.exists,X=ae.type;if(typeof ue!="boolean"||typeof X!="number")try{X=(await W.stat(te)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ue=!0}catch(pe){se.error(pe),ue=!1}if(!ue&&ae.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",ae);return}if(X===$.FileType.Directory){se.info("Cannot resolve the path because it is a directory",ae);return}const oe={...ae.options,pinned:!0};return ue?{resource:te,options:oe}:{resource:te,options:oe,forceUntitled:!0}}))}var he;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function ne(K){const W=K;if(!W)return!1;const se=W;if(se.modified)return ne(se.modified);const ae=W;return!!(ae.contributionsState&&ae.viewState&&Array.isArray(ae.cursorState))}function De(K){return(0,I.$rj)(K)}function $e(K,W,se){const ae=(0,I.$sj)(K,W);return ae.forceMessage=se?.forceMessage,ae.forceSeverity=se?.forceSeverity,ae.allowDialog=se?.allowDialog,ae}}),define(ye[305],Se([1,0,4,249,5,3,29,37,25,83,294]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qG=e.$pG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$oG=e.ViewContentGroups=e.$mG=e.ViewContainerLocation=e.Extensions=e.$lG=e.$kG=e.$jG=void 0,e.$nG=k,e.$jG="views",e.$kG=(0,h.localize)(0,null),e.$lG=(0,I.$xx)("default-view-icon",a.$5j.window,(0,h.localize)(1,null));var E;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(E||(e.Extensions=E={}));var l;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(l||(e.ViewContainerLocation=l={})),e.$mG=[l.Sidebar,l.Panel,l.AuxiliaryBar];function k(i){switch(i){case l.Sidebar:return"sidebar";case l.Panel:return"panel";case l.AuxiliaryBar:return"auxiliarybar"}}class p extends O.$Wc{constructor(){super(...arguments),this.c=this.B(new r.$me),this.onDidRegister=this.c.event,this.f=this.B(new r.$me),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(s,f,u){const w=this.get(s.id);if(w)return w;const y=s;return y.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,T.$zc)(this.g,f,[]).push(y),u?.isDefault&&this.h.push(y),this.c.fire({viewContainer:y,viewContainerLocation:f}),y}deregisterViewContainer(s){for(const f of this.g.keys()){const u=this.g.get(f),w=u?.indexOf(s);if(w!==-1){u?.splice(w,1),u.length===0&&this.g.delete(f),this.f.fire({viewContainer:s,viewContainerLocation:f});return}}}get(s){return this.all.filter(f=>f.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(u=>u?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(f=>this.getViewContainerLocation(f)===s)}}R.$qo.add(E.ViewContainersRegistry,new p);var c;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(c||(e.ViewContentGroups=c={}));function m(i,s){const f=i.group??c.More,u=s.group??c.More;return f!==u?f.localeCompare(u):(i.order??5)-(s.order??5)}class d extends O.$Wc{constructor(){super(...arguments),this.c=this.B(new r.$me),this.onViewsRegistered=this.c.event,this.f=this.B(new r.$me),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.$me),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.$me),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new T.$Jc}registerViews(s,f){this.registerViews2([{views:s,viewContainer:f}])}registerViews2(s){s.forEach(({views:f,viewContainer:u})=>this.r(f,u)),this.c.fire(s)}deregisterViews(s,f){const u=this.s(s,f);u.length&&this.f.fire({views:u,viewContainer:f})}moveViews(s,f){for(const u of this.m.keys())if(u!==f){const w=this.s(s,u);w.length&&(this.r(w,f),this.g.fire({views:w,from:u,to:f}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const f of this.j){const u=(this.m.get(f)||[]).filter(w=>w.id===s)[0];if(u)return u}return null}getViewContainer(s){for(const f of this.j)if((this.m.get(f)||[]).filter(w=>w.id===s)[0])return f;return null}registerViewWelcomeContent(s,f){return this.n.add(s,f),this.h.fire(s),(0,O.$Uc)(()=>{this.n.delete(s,f),this.h.fire(s)})}registerViewWelcomeContent2(s,f){const u=new Map;for(const[w,y]of f)this.n.add(s,y),u.set(w,(0,O.$Uc)(()=>{this.n.delete(s,y),this.h.fire(s)}));return this.h.fire(s),u}getViewWelcomeContent(s){const f=[];return this.n.forEach(s,u=>f.push(u)),f.sort(m)}r(s,f){let u=this.m.get(f);u||(u=[],this.m.set(f,u),this.j.push(f));for(const w of s){if(this.getView(w.id)!==null)throw new Error((0,h.localize)(2,null,w.id));u.push(w)}}s(s,f){const u=this.m.get(f);if(!u)return[];const w=[],y=[];for(const D of u)s.includes(D)?w.push(D):y.push(D);return w.length&&(y.length?this.m.set(f,y):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),w}}R.$qo.add(E.ViewsRegistry,new d),e.$oG=(0,P.$Fi)("viewDescriptorService");var g;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(g||(e.ViewVisibilityState=g={}));var n;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class o{constructor(s,f){this.c=!1,this.d=!1,(0,$.$go)(this,s),this.d=!!f,this.resolve=async u=>{if(f&&!this.c){const w=await f(u);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$pG=o;class t extends Error{constructor(s){super((0,h.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$qG=t}),define(ye[306],Se([1,0,250,36]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=void 0,e.$uG=new h.$Wj("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(0,null)}),e.$vG=new h.$Wj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(1,null)}),e.$wG=new h.$Wj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(2,null)}),e.$xG=new h.$Wj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(3,null)}),e.$yG=new h.$Wj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(4,null)}),e.$zG=new h.$Wj("chatResponse",!1,{type:"boolean",description:(0,r.localize)(5,null)}),e.$AG=new h.$Wj("chatRequest",!1,{type:"boolean",description:(0,r.localize)(6,null)}),e.$BG=new h.$Wj("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(7,null)}),e.$CG=new h.$Wj("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(8,null)}),e.$DG=new h.$Wj("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(9,null)}),e.$EG=new h.$Wj("inChatInput",!1,{type:"boolean",description:(0,r.localize)(10,null)}),e.$FG=new h.$Wj("inChat",!1,{type:"boolean",description:(0,r.localize)(11,null)}),e.$GG=new h.$Wj("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(12,null)}),e.$HG=new h.$Wj("chatCursorAtTop",!1),e.$IG=new h.$Wj("chatInputHasAgent",!1),e.$JG=new h.$Wj("chatLocation",void 0),e.$KG=new h.$Wj("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(13,null)})}),define(ye[307],Se([1,0,132,9,21,4,40,3,57,181,13,36,24,5,12,116,287,152,306]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.ChatAgentLocation=void 0,e.$OH=f,e.$PH=u;var o;(function(w){w.Panel="panel",w.Terminal="terminal",w.Notebook="notebook",w.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(w){function y(D){switch(D){case"panel":return w.Panel;case"terminal":return w.Terminal;case"notebook":return w.Notebook;case"editor":return w.Editor}return w.Panel}w.fromRaw=y}(o||(e.ChatAgentLocation=o={})),e.$JH=(0,k.$Fi)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(y){this.f=y,this.b=new Map,this.d=new O.$me,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=g.$GG.bindTo(this.f)}registerAgent(y,D){if(this.getAgent(y))throw new Error(`Agent already registered: ${JSON.stringify(y)}`);const C=this,A=D.slashCommands;D={...D,get slashCommands(){return A.filter(v=>!v.when||C.f.contextMatchesRules(E.$Dj.deserialize(v.when)))}};const b={data:D};return this.b.set(y,b),(0,R.$Uc)(()=>{this.b.delete(y),this.d.fire(void 0)})}registerAgentImplementation(y,D){const S=this.b.get(y);if(!S)throw new Error(`Unknown agent: ${JSON.stringify(y)}`);if(S.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(y)}`);return S.data.isDefault&&this.e.set(!0),S.impl=D,this.d.fire(new i(S.data,D)),(0,R.$Uc)(()=>{S.impl=void 0,this.d.fire(void 0),S.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(y,D){y.isDynamic=!0;const S={data:y,impl:D};return this.b.set(y.id,S),this.d.fire(new i(y,D)),(0,R.$Uc)(()=>{this.b.delete(y.id),this.d.fire(void 0)})}registerAgentCompletionProvider(y,D){return this.g.set(y,D),{dispose:()=>{this.g.delete(y)}}}async getAgentCompletionItems(y,D,S){return await this.g.get(y)?.(D,S)??[]}updateAgent(y,D){const S=this.b.get(y);if(!S?.impl)throw new Error(`No activated agent with id ${JSON.stringify(y)} registered`);S.data.metadata={...S.data.metadata,...D},this.d.fire(new i(S.data,S.impl))}getDefaultAgent(y){return(0,r.$hb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(y))}getContributedDefaultAgent(y){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(y))}getSecondaryAgent(){return T.Iterable.find(this.b.values(),y=>!!y.data.metadata.isSecondary)?.data}getAgent(y){if(this.h(y))return this.b.get(y)?.data}h(y){const D=this.b.get(y);return!D?.data.when||this.f.contextMatchesRules(E.$Dj.deserialize(D.data.when))}getAgentByFullyQualifiedId(y){const D=T.Iterable.find(this.b.values(),S=>f(S.data)===y)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(y=>y.data).filter(y=>this.h(y.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(y=>!!y.impl).filter(y=>this.h(y.data.id)).map(y=>new i(y.data,y.impl))}getAgentsByName(y){return this.getAgents().filter(D=>D.name===y)}agentHasDupeName(y){const D=this.getAgent(y);return D?this.getAgentsByName(D.name).filter(S=>S.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(y,D,S,C,A){const b=this.b.get(y);if(!b?.impl)throw new Error(`No activated agent with id "${y}"`);return await b.impl.invoke(D,S,C,A)}async getFollowups(y,D,S,C,A){const b=this.b.get(y);if(!b?.impl)throw new Error(`No activated agent with id "${y}"`);return b.impl?.provideFollowups?b.impl.provideFollowups(D,S,C,A):[]}};e.$KH=t,e.$KH=t=Je([Ve(0,E.$Xj)],t);class i{constructor(y,D){this.b=y,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(y,D,S,C){return this.d.invoke(y,D,S,C)}async provideFollowups(y,D,S,C){return this.d.provideFollowups?this.d.provideFollowups(y,D,S,C):[]}provideWelcomeMessage(y,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(y,D)}provideSampleQuestions(y,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(y,D)}}e.$LH=i,e.$MH=(0,k.$Fi)("chatAgentNameService");let s=class{static{n=this}static{this.b="chat.participantNameRegistry"}constructor(y,D,S,C){if(this.g=D,this.h=S,this.i=C,this.e=(0,a.$7d)(this,Object.create(null)),this.f=!1,!y.chatParticipantRegistry)return;this.d=y.chatParticipantRegistry;const A=C.get(n.b,d.StorageScope.APPLICATION);try{this.e.set(JSON.parse(A??"{}"),void 0)}catch{C.remove(n.b,d.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(y=>this.h.warn("Failed to fetch chat participant registry",y)).then(()=>(0,h.$Gh)(5*60*1e3)).then(()=>this.j())}async k(){const y=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(y.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,m.$$p)(y);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const S=D.restrictedChatParticipants;this.e.set(S,void 0),this.i.store(n.b,JSON.stringify(S),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}getAgentNameRestriction(y){const D=this.l(y.name,y).get(),S=!y.fullName||this.l(y.fullName.replace(/\s/g,""),y).get();return D&&S}l(y,D){return this.e.map(C=>C[y.toLowerCase()]).map(C=>C?C.some(A=>(0,I.$Gf)(A,A.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$NH=s,e.$NH=s=n=Je([Ve(0,c.$sk),Ve(1,m.$5p),Ve(2,p.$_j),Ve(3,d.$fq)],s);function f(w){return`${w.extensionId.value}.${w.id}`}function u(w){const y="name"in w?w:{...w,name:w.id};return"extensionPublisherId"in y||(y.extensionPublisherId=y.extensionPublisher??""),"extensionDisplayName"in y||(y.extensionDisplayName=""),"extensionId"in y||(y.extensionId=new l.$qn("")),(0,$.$ci)(y)}}),define(ye[308],Se([1,0,2,31,5]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iH=e.$hH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$fH=O,e.$gH=T;function O(a){return!!a&&typeof a=="object"&&"uri"in a&&a.uri instanceof r.URI&&"version"in a&&typeof a.version=="number"&&"ranges"in a&&Array.isArray(a.ranges)&&a.ranges.every(h.$Lt.isIRange)}function T(a){return!!a&&typeof a=="object"&&"documents"in a&&Array.isArray(a.documents)&&a.documents.every(O)}var R;(function(a){a[a.Down=0]="Down",a[a.Up=1]="Up"})(R||(e.ChatAgentVoteDirection=R={}));var $;(function(a){a[a.Action=1]="Action",a[a.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$hH=(0,P.$Fi)("IChatService"),e.$iH="accessibility.voice.keywordActivation"}),define(ye[154],Se([1,0,4,9,252]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Itb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new r.$me,this.o=new r.$me,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(R){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=R}onEvent(R){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=R}onRequest(R){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.u("response",R)}sendRequest(R,$,a,I){const E={command:R};if($&&Object.keys($).length>0&&(E.arguments=$),this.u("request",E),typeof I=="number"){const l=setTimeout(()=>{clearTimeout(l);const k=this.f.get(E.seq);if(k){this.f.delete(E.seq);const p={type:"response",seq:0,request_seq:E.seq,success:!1,command:R,message:(0,P.localize)(0,null,I,R)};k(p)}},I)}return a&&this.f.set(E.seq,a),E.seq}acceptMessage(R){this.k?this.k(R):(this.m.push(R),this.m.length===1&&this.s())}q(R,$){return R.type!=="event"||$.type!=="event"}async s(){let R;for(;this.m.length;){if((!R||this.q(this.m[0],R))&&await(0,h.$Gh)(0),R=this.m.shift(),!R)return;switch(R.type){case"event":this.j?.(R);break;case"request":this.g?.(R);break;case"response":{const $=R,a=this.f.get($.request_seq);a&&(this.f.delete($.request_seq),a($));break}}}}u(R,$){$.type=R,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach(($,a)=>R.set(a,$)),await(0,h.$Gh)(500),R.forEach(($,a)=>{$({type:"response",seq:0,request_seq:a,success:!1,command:"canceled",message:"canceled"}),this.f.delete(a)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Itb=O}),define(ye[120],Se([1,0,2,253,36,5]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$CK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$AK=e.MemoryRangeType=e.State=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=void 0,e.$zK=$,e.$BK=I,h=We(h),e.$nJ="workbench.view.debug",e.$oJ="workbench.debug.variablesView",e.$pJ="workbench.debug.watchExpressionsView",e.$qJ="workbench.debug.callStackView",e.$rJ="workbench.debug.loadedScriptsView",e.$sJ="workbench.debug.breakPointsView",e.$tJ="workbench.debug.disassemblyView",e.$uJ="workbench.panel.repl",e.$vJ="workbench.panel.repl.view",e.$wJ=new P.$Wj("debugType",void 0,{type:"string",description:h.localize(0,null)}),e.$xJ=new P.$Wj("debugConfigurationType",void 0,{type:"string",description:h.localize(1,null)}),e.$yJ=new P.$Wj("debugState","inactive",{type:"string",description:h.localize(2,null)}),e.$zJ="debugUx",e.$AJ=new P.$Wj(e.$zJ,"default",{type:"string",description:h.localize(3,null)}),e.$BJ=new P.$Wj("hasDebugged",!1,{type:"boolean",description:h.localize(4,null)}),e.$CJ=new P.$Wj("inDebugMode",!1,{type:"boolean",description:h.localize(5,null)}),e.$DJ=new P.$Wj("inDebugRepl",!1,{type:"boolean",description:h.localize(6,null)}),e.$EJ=new P.$Wj("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(7,null)}),e.$FJ=new P.$Wj("inBreakpointWidget",!1,{type:"boolean",description:h.localize(8,null)}),e.$GJ=new P.$Wj("breakpointsFocused",!0,{type:"boolean",description:h.localize(9,null)}),e.$HJ=new P.$Wj("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(10,null)}),e.$IJ=new P.$Wj("watchExpressionsExist",!1,{type:"boolean",description:h.localize(11,null)}),e.$JJ=new P.$Wj("variablesFocused",!0,{type:"boolean",description:h.localize(12,null)}),e.$KJ=new P.$Wj("expressionSelected",!1,{type:"boolean",description:h.localize(13,null)}),e.$LJ=new P.$Wj("breakpointInputFocused",!1,{type:"boolean",description:h.localize(14,null)}),e.$MJ=new P.$Wj("callStackItemType",void 0,{type:"string",description:h.localize(15,null)}),e.$NJ=new P.$Wj("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(16,null)}),e.$OJ=new P.$Wj("callStackItemStopped",!1,{type:"boolean",description:h.localize(17,null)}),e.$PJ=new P.$Wj("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(18,null)}),e.$QJ=new P.$Wj("watchItemType",void 0,{type:"string",description:h.localize(19,null)}),e.$RJ=new P.$Wj("canViewMemory",void 0,{type:"boolean",description:h.localize(20,null)}),e.$SJ=new P.$Wj("breakpointItemType",void 0,{type:"string",description:h.localize(21,null)}),e.$TJ=new P.$Wj("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(22,null)}),e.$UJ=new P.$Wj("breakpointHasModes",!1,{type:"boolean",description:h.localize(23,null)}),e.$VJ=new P.$Wj("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(24,null)}),e.$WJ=new P.$Wj("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(25,null)}),e.$XJ=new P.$Wj("loadedScriptsItemType",void 0,{type:"string",description:h.localize(26,null)}),e.$YJ=new P.$Wj("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(27,null)}),e.$ZJ=new P.$Wj("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(28,null)}),e.$1J=new P.$Wj("stepBackSupported",!1,{type:"boolean",description:h.localize(29,null)}),e.$2J=new P.$Wj("restartFrameSupported",!1,{type:"boolean",description:h.localize(30,null)}),e.$3J=new P.$Wj("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(31,null)}),e.$4J=new P.$Wj("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(32,null)}),e.$5J=new P.$Wj("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(33,null)}),e.$6J=new P.$Wj("breakpointsExist",!1,{type:"boolean",description:h.localize(34,null)}),e.$7J=new P.$Wj("debuggersAvailable",!1,{type:"boolean",description:h.localize(35,null)}),e.$8J=new P.$Wj("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(36,null)}),e.$9J=new P.$Wj("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(37,null)}),e.$0J=new P.$Wj("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(38,null)}),e.$$J=new P.$Wj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(39,null)}),e.$_J=new P.$Wj("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(40,null)}),e.$aK=new P.$Wj("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(41,null)}),e.$bK=new P.$Wj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(42,null)}),e.$cK=new P.$Wj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(43,null)}),e.$dK=new P.$Wj("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(44,null)}),e.$eK=new P.$Wj("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(45,null)}),e.$fK=new P.$Wj("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(46,null)}),e.$gK=new P.$Wj("variableIsReadonly",!1,{type:"boolean",description:h.localize(47,null)}),e.$hK=new P.$Wj("variableValue",!1,{type:"string",description:h.localize(48,null)}),e.$iK=new P.$Wj("variableType",!1,{type:"string",description:h.localize(49,null)}),e.$jK=new P.$Wj("variableInterfaces",!1,{type:"array",description:h.localize(50,null)}),e.$kK=new P.$Wj("variableName",!1,{type:"string",description:h.localize(51,null)}),e.$lK=new P.$Wj("variableLanguage",!1,{type:"string",description:h.localize(52,null)}),e.$mK=new P.$Wj("variableExtensionId",!1,{type:"string",description:h.localize(53,null)}),e.$nK=new P.$Wj("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(54,null)}),e.$oK=new P.$Wj("multiSessionRepl",!1,{type:"boolean",description:h.localize(55,null)}),e.$pK=new P.$Wj("multiSessionDebug",!1,{type:"boolean",description:h.localize(56,null)}),e.$qK=new P.$Wj("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(57,null)}),e.$rK=new P.$Wj("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(58,null)}),e.$sK=new P.$Wj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(59,null)}),e.$tK=new P.$Wj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(60,null)});const T=n=>h.localize(61,null,n);e.$uK=T,e.$vK="editor.contrib.debug",e.$wK="editor.contrib.breakpoint",e.$xK="debug",e.$yK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(62,null)};var R;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(R||(e.State=R={}));function $(n){switch(n){case R.Initializing:return"initializing";case R.Stopped:return"stopped";case R.Running:return"running";default:return"inactive"}}var a;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(a||(e.MemoryRangeType=a={})),e.$AK="vscode-debug-memory";function I(n){const o=n.presentationHint??n.source.presentationHint;return o==="deemphasize"||o==="subtle"}var E;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(E||(e.DataBreakpointSetType=E={}));var l;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(l||(e.DebugConfigurationProviderTriggerKind=l={}));var k;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(k||(e.DebuggerString=k={})),e.$CK=(0,O.$Fi)("debugService");var p;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(p||(e.BreakpointWidgetContext=p={}));var c;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(c||(e.DebugVisualizationType=c={}));var m;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var d;(function(n){n.deserialize=o=>o,n.serialize=o=>o})(d||(e.IDebugVisualizationTreeItem=d={}));var g;(function(n){n.deserialize=o=>({id:o.id,name:o.name,iconPath:o.iconPath&&{light:r.URI.revive(o.iconPath.light),dark:r.URI.revive(o.iconPath.dark)},iconClass:o.iconClass,visualization:o.visualization}),n.serialize=o=>o})(g||(e.IDebugVisualization=g={}))}),define(ye[309],Se([1,0,13,2,17,25,15,31,21,19]),function(ce,e,r,h,P,O,T,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7H=void 0,e.$UH=E,e.$VH=l,e.$WH=k,e.$XH=p,e.$YH=c,e.$ZH=m,e.$1H=d,e.$2H=n,e.$3H=i,e.$4H=s,e.$5H=u,e.$6H=y;const I=/{([^}]+)}/g;function E(S,C,A){return S.replace(I,function(b,v){return C&&v.length>0&&v[0]!=="_"?b:A&&A.hasOwnProperty(v)?A[v]:b})}function l(S){const C={};for(const A of Object.keys(S))A.startsWith("!")||(C[A]=S[A]);return C}function k(S){return S.configuration.request==="attach"&&!p(S)&&(!S.parentSession||k(S.parentSession))}function p(S){let C=S.configuration.type;if(C)return C==="vslsShare"&&(C=S.configuration.adapterProxy.configuration.type),(0,r.$Gf)(C,"extensionhost")||(0,r.$Gf)(C,"pwa-extensionhost")?S:S.parentSession?p(S.parentSession):void 0}function c(S){return S.type&&(S.label||S.program||S.runtime)}function m(S,C,A){let b,v=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=M.exec(S);){const L=N.index+1,j=L+N[0].length;if(L<=C&&j>=A){b=N[0],v=L;break}}if(b){const L=/\w+/g;let j=null;for(;(j=L.exec(b))&&!(j.index+1+v+j[0].length>=A););j&&(b=b.substring(0,L.lastIndex))}return b?{start:v,end:v+b.length-1}:{start:0,end:0}}async function d(S,C,A,b){if(S.evaluatableExpressionProvider.has(C)){const v=S.evaluatableExpressionProvider.ordered(C),M=(0,a.$Jb)(await Promise.all(v.map(async N=>{try{return await N.provideEvaluatableExpression(C,A,b??$.CancellationToken.None)}catch{return}})));if(M.length>0){let N=M[0].expression;const L=M[0].range;return N||(N=C.getLineContent(A.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:N}}}else{const v=C.getLineContent(A.lineNumber),{start:M,end:N}=m(v,A.column,A.column),L=v.substring(M-1,N);return{matchingExpression:L,range:new R.$Lt(A.lineNumber,M,A.lineNumber,M+L.length)}}return null}const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(S){return!!(S&&S.match(g))}function o(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(n(S.path))return h.URI.parse(S.path);if((0,P.$kc)(S.path))return h.URI.file(S.path)}return S.path}function t(S){if(typeof S.path=="object"){const C=h.URI.revive(S.path);if(C)return C.scheme===T.Schemas.file?C.fsPath:C.toString()}return S.path}function i(S,C){const A=C?o:t,b=(0,O.$do)(S);return f(b,(v,M)=>{v&&M&&(M.path=A(M))}),b}function s(S,C){const A=C?o:t,b=(0,O.$do)(S);return f(b,(v,M)=>{!v&&M&&(M.path=A(M))}),b}function f(S,C){switch(S.type){case"event":{const A=S;switch(A.event){case"output":C(!1,A.body.source);break;case"loadedSource":C(!1,A.body.source);break;case"breakpoint":C(!1,A.body.breakpoint.source);break;default:break}break}case"request":{const A=S;switch(A.command){case"setBreakpoints":C(!0,A.arguments.source);break;case"breakpointLocations":C(!0,A.arguments.source);break;case"source":C(!0,A.arguments.source);break;case"gotoTargets":C(!0,A.arguments.source);break;case"launchVSCode":A.arguments.args.forEach(b=>C(!1,b));break;default:break}break}case"response":{const A=S;if(A.success&&A.body)switch(A.command){case"stackTrace":A.body.stackFrames.forEach(b=>C(!1,b.source));break;case"loadedSources":A.body.sources.forEach(b=>C(!1,b));break;case"scopes":A.body.scopes.forEach(b=>C(!1,b.source));break;case"setFunctionBreakpoints":A.body.breakpoints.forEach(b=>C(!1,b.source));break;case"setBreakpoints":A.body.breakpoints.forEach(b=>C(!1,b.source));break;case"disassemble":A.body?.instructions.forEach(v=>C(!1,v.location));break;default:break}break}}}function u(S){return S.filter(C=>!C.presentation?.hidden).sort((C,A)=>C.presentation?A.presentation?C.presentation.group?A.presentation.group?C.presentation.group!==A.presentation.group?C.presentation.group.localeCompare(A.presentation.group):w(C.presentation.order,A.presentation.order):-1:A.presentation.group?1:w(C.presentation.order,A.presentation.order):-1:A.presentation?1:0)}function w(S,C){return typeof S!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:S-C}async function y(S,C){const A=S.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(A!=="none"&&(await C.saveAll(),A==="allEditorsInActiveGroup")){const b=C.activeEditorPane;b&&b.input.resource?.scheme===T.Schemas.untitled&&await C.save({editor:b.input,groupId:b.group.id})}await S.reloadConfiguration()}const D=(S,C)=>!S||!C?S===C:S.name===C.name&&S.path===C.path&&S.sourceReference===C.sourceReference;e.$7H=D}),define(ye[310],Se([1,0,58,67,25,17,11,13,34,254,154]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=e.$Eqc=e.$Dqc=e.$Cqc=e.$Bqc=void 0,r=We(r),h=We(h),P=We(P),O=We(O),T=We(T),R=We(R),a=We(a);class E extends I.$Itb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(d,g){this.l=g,this.p=Buffer.allocUnsafe(0),this.r=-1,d.on("data",n=>this.v(n))}sendMessage(d){if(this.l){const g=JSON.stringify(d);this.l.write(`Content-Length: ${Buffer.byteLength(g,"utf8")}${E.a}${g}`,"utf8")}}v(d){for(this.p=Buffer.concat([this.p,d]);;){if(this.r>=0){if(this.p.length>=this.r){const g=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,g.length>0)try{this.acceptMessage(JSON.parse(g))}catch(n){this.n.fire(new Error((n.message||n)+`
`+g))}continue}}else{const g=this.p.indexOf(E.a);if(g!==-1){const o=this.p.toString("utf8",0,g).split(E.b);for(const t of o){const i=t.split(E.i);i[0]==="Content-Length"&&(this.r=Number(i[1]))}this.p=this.p.slice(g+E.a.length);continue}}break}}}e.$Bqc=E;class l extends E{startSession(){return new Promise((d,g)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),d(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):g(new Error("connection closed"))}),this.x.on("error",o=>{n?this.n.fire(o):g(o)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Cqc=l;class k extends l{constructor(d){super(),this.z=d}y(d){return h.createConnection(this.z.port,this.z.host||"127.0.0.1",d)}}e.$Dqc=k;class p extends l{constructor(d){super(),this.z=d}y(d){return h.createConnection(this.z.path,d)}}e.$Eqc=p;class c extends E{constructor(d,g){super(),this.y=d,this.z=g}async startSession(){const d=this.y.command,g=this.y.args,n=this.y.options||{};try{if(d)if(O.$kc(d)){if(!await $.Promises.exists(d))throw new Error(a.localize(0,null,d))}else d.indexOf("/")<0&&d.indexOf("\\")<0;else throw new Error(a.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=P.$go(P.$do(process.env),n.env)),d==="node")if(Array.isArray(g)&&g.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:o,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(i.cwd=n.cwd);const s=r.fork(g[0],g.slice(1),i);if(!s.pid)throw new Error(a.localize(2,null,g[0]));this.x=s}else throw new Error(a.localize(3,null));else{const t={env:o};n.cwd&&(t.cwd=n.cwd),this.x=r.spawn(d,g,t)}this.x.on("error",t=>{this.n.fire(t)}),this.x.on("exit",(t,i)=>{this.o.fire(t)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",t=>{this.n.fire(t)}),this.x.stdin.on("error",t=>{this.n.fire(t)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(o){this.n.fire(o)}}async stopSession(){return this.x?(await this.w(),T.$i?new Promise((d,g)=>{const n=r.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,t,i){if(o)return g(o)});n.on("exit",d),n.on("error",g)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(d,g){if(!d)return;const n=Object.create(null);d.runtime&&(d.runtime.indexOf("./")===0?n.runtime=O.$lc(g,d.runtime):n.runtime=d.runtime),d.runtimeArgs&&(n.runtimeArgs=d.runtimeArgs),d.program&&(O.$kc(d.program)?n.program=d.program:n.program=O.$lc(g,d.program)),d.args&&(n.args=d.args);const o=d;return o.win&&(n.win=c.A(o.win,g)),o.winx86&&(n.winx86=c.A(o.winx86,g)),o.windows&&(n.windows=c.A(o.windows,g)),o.osx&&(n.osx=c.A(o.osx,g)),o.linux&&(n.linux=c.A(o.linux,g)),n}static platformAdapterExecutable(d,g){let n=Object.create(null);g=g.toLowerCase();for(const u of d)if(u.contributes){const w=u.contributes.debuggers;w&&w.length>0&&w.filter(y=>typeof y.type=="string"&&R.$Gf(y.type,g)).forEach(y=>{const D=c.A(y,u.extensionLocation.fsPath);n=P.$go(n,D,u.isBuiltin)})}let o;T.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:T.$i?o=n.win||n.windows:T.$j?o=n.osx:T.$k&&(o=n.linux),o=o||n;const t=o.program||n.program,i=o.args||n.args,s=o.runtime||n.runtime,f=o.runtimeArgs||n.runtimeArgs;if(s)return{type:"executable",command:s,args:(f||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.$Fqc=c}),define(ye[311],Se([1,0,58,33,11]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=T,e.$Hqc=$,r=We(r),P=We(P);function O(a,I){return new Promise((E,l)=>{let k="";const p=r.spawn(a,I);p.pid&&p.stdout.on("data",c=>{k+=c.toString()}),p.on("error",c=>{l(c)}),p.on("close",c=>{E(k)})})}async function T(a){if(a)if(P.$i){const I=await new Promise((E,l)=>{ce(["@vscode/windows-process-tree"],E,l)}).then(We);return new Promise(E=>{I.getProcessTree(a,l=>{E(!!l&&l.children.length>0)})})}else return O("/usr/bin/pgrep",["-lP",String(a)]).then(I=>{const E=I.trim();return!(E.length===0||E.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var R;(function(a){a[a.cmd=0]="cmd",a[a.powershell=1]="powershell",a[a.bash=2]="bash"})(R||(R={}));function $(a,I,E,l,k){a=a.trim().toLowerCase();let p;a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0?p=R.powershell:a.indexOf("cmd.exe")>=0?p=R.cmd:a.indexOf("bash")>=0?p=R.bash:P.$i?p=R.cmd:p=R.bash;let c,m=" ";switch(p){case R.powershell:if(c=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),l){const d=(0,h.$Kg)(l);d&&(m+=`${d}:; `),m+=`cd ${c(l)}; `}if(k)for(const d in k){const g=k[d];g===null?m+=`Remove-Item env:${d}; `:m+=`\${env:${d}}='${g}'; `}if(I.length>0){const d=I.shift(),g=E?d:c(d);m+=g[0]==="'"?`& ${g} `:`${g} `;for(const n of I)m+=n==="<"||n===">"||E?n:c(n),m+=" "}break;case R.cmd:if(c=d=>(d=d.replace(/\"/g,'""'),d=d.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>d.includes(g))||d.length===0?`"${d}"`:d),l){const d=(0,h.$Kg)(l);d&&(m+=`${d}: && `),m+=`cd ${c(l)} && `}if(k){m+='cmd /C "';for(const d in k){let g=k[d];g===null?m+=`set "${d}=" && `:(g=g.replace(/[&^|<>]/g,n=>`^${n}`),m+=`set "${d}=${g}" && `)}}for(const d of I)m+=d==="<"||d===">"||E?d:c(d),m+=" ";k&&(m+='"');break;case R.bash:{c=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),g.length===0?'""':g);const d=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(l&&(m+=`cd ${c(l)} ; `),k){m+="/usr/bin/env";for(const g in k){const n=k[g];n===null?m+=` -u ${d(g)}`:m+=` ${d(`${g}=${n}`)}`}m+=" "}for(const g of I)m+=g==="<"||g===">"||E?g:c(g),m+=" ";break}}return m}}),define(ye[312],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UK=e.CellExecutionUpdateType=void 0;var h;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.$UK=(0,r.$Fi)("INotebookExecutionService")}),define(ye[313],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YK=e.$XK=e.ProxyKernelState=e.$WK=void 0,e.$WK=100;var h;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.$XK=(0,r.$Fi)("INotebookKernelService"),e.$YK=(0,r.$Fi)("INotebookKernelHistoryService")}),define(ye[314],Se([1,0,3,31,55,215,107]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wZb=void 0;class R extends r.$Wc{constructor(a,I,E){super(),this._source=a,this.b=I,this.c=E,this.a=void 0}f(a){const I=a.getLineCount();return new h.$Lt(1,1,I,this.g(a,I))}g(a,I){if(I<1||I>a.getLineCount())throw new Error("Illegal value for lineNumber");return a.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const a=new O.$mD;a.acceptChunk(this._source);const I=a.finish(!0),{textBuffer:E,disposable:l}=I.create(P.DefaultEndOfLine.LF);this.b=E,this.B(l)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(a=>{const I=new O.$mD;I.acceptChunk(a);const E=I.finish(!0),{textBuffer:l,disposable:k}=E.create(P.DefaultEndOfLine.LF);return this.B(k),l})),this.a}findInInputs(a){const E=new T.$aD(a,!1,!1,null).parseSearchRequest();if(!E)return[];const l=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(l,E,!0,5e3)}findInOutputs(a){const E=new T.$aD(a,!1,!1,null).parseSearchRequest();return E?this.outputTextBuffers.map(l=>{const k=l.findMatchesLineByLine(this.f(l),E,!0,5e3);if(k.length!==0)return{textBuffer:l,matches:k}}).filter(l=>!!l):[]}}e.$wZb=R}),define(ye[74],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(O){O.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var h;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class P{static fromExtHostTestItem(T,R,$=T.parent){if(T._isRoot)return new P([R]);const a=[T.id];for(let I=$;I&&I.id!==R;I=I.parent)a.push(I.id);return a.push(R),new P(a.reverse())}static isRoot(T){return!T.includes(r.Delimiter)}static root(T){const R=T.indexOf(r.Delimiter);return R===-1?T:T.slice(0,R)}static fromString(T){return new P(T.split(r.Delimiter))}static join(T,R){return new P([...T.path,R])}static joinToString(T,R){return T.toString()+r.Delimiter+R}static parentId(T){const R=T.lastIndexOf(r.Delimiter);return R===-1?void 0:T.slice(0,R)}static localId(T){const R=T.lastIndexOf(r.Delimiter);return R===-1?T:T.slice(R+r.Delimiter.length)}static isChild(T,R){return R.startsWith(T)&&R[T.length]===r.Delimiter}static compare(T,R){return T===R?h.IsSame:P.isChild(T,R)?h.IsChild:P.isChild(R,T)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(T,R){if(T===0)return 0;let $=0;for(;$<T-1;){for(let a=1;a<T;a++){const I=R(a-1),E=R(a);if(I.path[$]!==E.path[$])return $}$++}return $}constructor(T,R=T.length){if(this.path=T,this.d=R,T.length===0||R<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let T=1;T<=this.d;T++)yield new P(this.path,T)}*idsToRoot(){for(let T=this.d;T>0;T--)yield new P(this.path,T)}compare(T){if(typeof T=="string")return P.compare(this.toString(),T);for(let R=0;R<T.d&&R<this.d;R++)if(T.path[R]!==this.path[R])return h.Disconnected;return T.d>this.d?h.IsChild:T.d<this.d?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let T=1;T<this.d;T++)this.c+=r.Delimiter,this.c+=this.path[T]}return this.c}}e.$TI=P}),define(ye[75],Se([1,0,2,54,31,74]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3I=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$2I=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$1I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$ZI=e.$YI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$XI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$WI=e.$VI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$UI=e.TestResultState=void 0;var T;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(T||(e.TestResultState=T={})),e.$UI={[T.Unset]:"unset",[T.Queued]:"queued",[T.Running]:"running",[T.Passed]:"passed",[T.Failed]:"failed",[T.Skipped]:"skipped",[T.Errored]:"errored"};var R;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var $;(function(z){z[z.Run=2]="Run",z[z.Debug=4]="Debug",z[z.Coverage=8]="Coverage",z[z.HasNonDefaultProfile=16]="HasNonDefaultProfile",z[z.HasConfigurable=32]="HasConfigurable",z[z.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$VI=[$.Run,$.Debug,$.Coverage,$.HasNonDefaultProfile,$.HasConfigurable,$.SupportsContinuousRun];const a=z=>"runId"in z;e.$WI=a;var I;(function(z){z.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),z.deserialize=(F,B)=>({range:P.$Lt.lift(B.range),uri:F.asCanonicalUri(r.URI.revive(B.uri))})})(I||(e.IRichLocation=I={}));var E;(function(z){z[z.Error=0]="Error",z[z.Output=1]="Output"})(E||(e.TestMessageType=E={}));var l;(function(z){z.serialize=F=>({message:F.message,type:E.Error,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&I.serialize(F.location)}),z.deserialize=(F,B)=>({message:B.message,type:E.Error,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&I.deserialize(F,B.location)})})(l||(e.ITestErrorMessage=l={}));const k=(z,F)=>`${F?"s":"e"}${z}`;e.$XI=k;var p;(function(z){z.serialize=F=>({message:F.message,type:E.Output,offset:F.offset,length:F.length,location:F.location&&I.serialize(F.location)}),z.deserialize=(F,B)=>({message:B.message,type:E.Output,offset:B.offset,length:B.length,location:B.location&&I.deserialize(F,B.location)})})(p||(e.ITestOutputMessage=p={}));var c;(function(z){z.serialize=F=>F.type===E.Error?l.serialize(F):p.serialize(F),z.deserialize=(F,B)=>B.type===E.Error?l.deserialize(F,B):p.deserialize(F,B)})(c||(e.ITestMessage=c={}));var m;(function(z){z.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),z.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(c.serialize)}),z.deserialize=(F,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(_=>c.deserialize(F,_))})})(m||(e.ITestTaskState=m={}));const d="\0",g=(z,F)=>z+d+F;e.$YI=g;const n=z=>{const F=z.indexOf(d);return{ctrlId:z.slice(0,F),tagId:z.slice(F+1)}};e.$ZI=n;var o;(function(z){z.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),z.deserialize=(F,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?F.asCanonicalUri(r.URI.revive(B.uri)):void 0,range:B.range?P.$Lt.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(o||(e.ITestItem=o={}));var t;(function(z){z[z.NotExpandable=0]="NotExpandable",z[z.Expandable=1]="Expandable",z[z.BusyExpanding=2]="BusyExpanding",z[z.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var i;(function(z){z.serialize=F=>({expand:F.expand,item:o.serialize(F.item)}),z.deserialize=(F,B)=>({controllerId:O.$TI.root(B.item.extId),expand:B.expand,item:o.deserialize(F,B.item)})})(i||(e.InternalTestItem=i={}));var s;(function(z){z.serialize=F=>{let B;return F.item&&(B={},F.item.label!==void 0&&(B.label=F.item.label),F.item.tags!==void 0&&(B.tags=F.item.tags),F.item.busy!==void 0&&(B.busy=F.item.busy),F.item.uri!==void 0&&(B.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(B.range=F.item.range?.toJSON()),F.item.description!==void 0&&(B.description=F.item.description),F.item.error!==void 0&&(B.error=F.item.error),F.item.sortText!==void 0&&(B.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:B}},z.deserialize=F=>{let B;return F.item&&(B={},F.item.label!==void 0&&(B.label=F.item.label),F.item.tags!==void 0&&(B.tags=F.item.tags),F.item.busy!==void 0&&(B.busy=F.item.busy),F.item.range!==void 0&&(B.range=F.item.range?P.$Lt.lift(F.item.range):null),F.item.description!==void 0&&(B.description=F.item.description),F.item.error!==void 0&&(B.error=F.item.error),F.item.sortText!==void 0&&(B.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:B}}})(s||(e.ITestItemUpdate=s={}));const f=(z,F)=>{F.expand!==void 0&&(z.expand=F.expand),F.item!==void 0&&(z.item=z.item?Object.assign(z.item,F.item):F.item)};e.$1I=f;var u;(function(z){z.serializeWithoutMessages=F=>({...i.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(m.serializeWithoutMessages)}),z.serialize=F=>({...i.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(m.serialize)}),z.deserialize=(F,B)=>({...i.deserialize(F,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(_=>m.deserialize(F,_)),retired:!0})})(u||(e.TestResultItem=u={}));var w;(function(z){z.empty=()=>({covered:0,total:0}),z.sum=(F,B)=>{F.covered+=B.covered,F.total+=B.total}})(w||(e.ICoverageCount=w={}));var y;(function(z){z.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testIds:F.testIds,uri:F.uri.toJSON()}),z.deserialize=(F,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,testIds:B.testIds,uri:F.asCanonicalUri(r.URI.revive(B.uri))}),z.empty=(F,B)=>({id:F,uri:B,statement:w.empty()})})(y||(e.IFileCoverage=y={}));function D(z){return{...z,location:z.location?.toJSON()}}function S(z){return z.location=z.location?h.$Kt.isIPosition(z.location)?h.$Kt.lift(z.location):P.$Lt.lift(z.location):void 0,z}e.$2I=3;var C;(function(z){z[z.Declaration=0]="Declaration",z[z.Statement=1]="Statement",z[z.Branch=2]="Branch"})(C||(e.DetailType=C={}));var A;(function(z){z.serialize=F=>F.type===C.Declaration?v.serialize(F):M.serialize(F),z.deserialize=F=>F.type===C.Declaration?v.deserialize(F):M.deserialize(F)})(A||(e.CoverageDetails=A={}));var b;(function(z){z.serialize=D,z.deserialize=S})(b||(e.IBranchCoverage=b={}));var v;(function(z){z.serialize=D,z.deserialize=S})(v||(e.IDeclarationCoverage=v={}));var M;(function(z){z.serialize=F=>({...D(F),branches:F.branches?.map(b.serialize)}),z.deserialize=F=>({...S(F),branches:F.branches?.map(b.deserialize)})})(M||(e.IStatementCoverage=M={}));var N;(function(z){z[z.Add=0]="Add",z[z.Update=1]="Update",z[z.DocumentSynced=2]="DocumentSynced",z[z.Remove=3]="Remove",z[z.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",z[z.Retire=5]="Retire",z[z.AddTag=6]="AddTag",z[z.RemoveTag=7]="RemoveTag"})(N||(e.TestDiffOpType=N={}));var L;(function(z){z.deserialize=(F,B)=>B.op===N.Add?{op:B.op,item:i.deserialize(F,B.item)}:B.op===N.Update?{op:B.op,item:s.deserialize(B.item)}:B.op===N.DocumentSynced?{op:B.op,uri:F.asCanonicalUri(r.URI.revive(B.uri)),docv:B.docv}:B,z.serialize=F=>F.op===N.Add?{op:F.op,item:i.serialize(F.item)}:F.op===N.Update?{op:F.op,item:s.serialize(F.item)}:F})(L||(e.TestsDiffOp=L={}));class j{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const B=this.w();for(const _ of F)switch(_.op){case N.Add:this.l(i.deserialize(this.k,_.item),B);break;case N.Update:this.p(s.deserialize(_.item),B);break;case N.Remove:this.q(_.itemId,B);break;case N.Retire:this.v(_.itemId);break;case N.IncrementPendingExtHosts:this.updatePendingRoots(_.amount);break;case N.AddTag:this.c.set(_.tag.id,_.tag);break;case N.RemoveTag:this.c.delete(_.id);break}B.complete?.()}l(F,B){const _=O.$TI.parentId(F.item.extId)?.toString();let re;if(!_)re=this.x(F),this.g.add(re),this.f.set(F.item.extId,re);else if(this.f.has(_)){const U=this.f.get(_);U.children.add(F.item.extId),re=this.x(F,U),this.f.set(F.item.extId,re)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return B.add?.(re),F.expand===t.BusyExpanding&&this.h++,re}p(F,B){const _=this.f.get(F.extId);if(_)return F.expand!==void 0&&(_.expand===t.BusyExpanding&&this.h--,F.expand===t.BusyExpanding&&this.h++),(0,e.$1I)(_,F),B.update?.(_),_}q(F,B){const _=this.f.get(F);if(!_)return;const re=O.$TI.parentId(_.item.extId)?.toString();re?this.f.get(re).children.delete(_.item.extId):this.g.delete(_);const U=[[F]];for(;U.length;)for(const G of U.pop()){const Q=this.f.get(G);Q&&(U.push(Q.children),this.f.delete(G),B.remove?.(Q,Q!==_),Q.expand===t.BusyExpanding&&this.h--)}}v(F){}updatePendingRoots(F){this.j+=F}w(){return{}}}e.$3I=j}),define(ye[315],Se([1,0,136,257,75]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$oGb=e.$nGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(E){E.ViewletId="workbench.view.extension.test",E.ExplorerViewId="workbench.view.testing",E.OutputPeekContributionId="editor.contrib.testingOutputPeek",E.DecorationsContributionId="editor.contrib.testingDecorations",E.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",E.CoverageViewId="workbench.view.testCoverage",E.ResultsPanelId="workbench.panel.testResults",E.ResultsViewId="workbench.panel.testResults.view",E.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var T;(function(E){E.List="list",E.Tree="true"})(T||(e.TestExplorerViewMode=T={}));var R;(function(E){E.ByLocation="location",E.ByStatus="status",E.ByDuration="duration"})(R||(e.TestExplorerViewSorting=R={}));const $={[P.TestResultState.Errored]:(0,h.localize)(0,null),[P.TestResultState.Failed]:(0,h.localize)(1,null),[P.TestResultState.Passed]:(0,h.localize)(2,null),[P.TestResultState.Queued]:(0,h.localize)(3,null),[P.TestResultState.Running]:(0,h.localize)(4,null),[P.TestResultState.Skipped]:(0,h.localize)(5,null),[P.TestResultState.Unset]:(0,h.localize)(6,null)},a=(E,l)=>(0,h.localize)(7,null,(0,r.$Yk)(E),$[l]);e.$nGb=a,e.$oGb={[P.TestRunProfileBitset.Debug]:(0,h.localize)(8,null),[P.TestRunProfileBitset.Run]:(0,h.localize)(9,null),[P.TestRunProfileBitset.Coverage]:(0,h.localize)(10,null)};var I;(function(E){E.CancelTestRefreshAction="testing.cancelTestRefresh",E.CancelTestRunAction="testing.cancelRun",E.ClearTestResultsAction="testing.clearTestResults",E.CollapseAllAction="testing.collapseAll",E.ConfigureTestProfilesAction="testing.configureProfile",E.ContinousRunUsingForTest="testing.continuousRunUsingForTest",E.CoverageAtCursor="testing.coverageAtCursor",E.CoverageByUri="testing.coverage.uri",E.CoverageClear="testing.coverage.close",E.CoverageCurrentFile="testing.coverageCurrentFile",E.CoverageFilterToTest="testing.coverageFilterToTest",E.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",E.CoverageLastRun="testing.coverageLastRun",E.CoverageSelectedAction="testing.coverageSelected",E.CoverageToggleToolbar="testing.coverageToggleToolbar",E.CoverageViewChangeSorting="testing.coverageViewChangeSorting",E.DebugAction="testing.debug",E.DebugAllAction="testing.debugAll",E.DebugAtCursor="testing.debugAtCursor",E.DebugByUri="testing.debug.uri",E.DebugCurrentFile="testing.debugCurrentFile",E.DebugFailedTests="testing.debugFailTests",E.DebugLastRun="testing.debugLastRun",E.DebugSelectedAction="testing.debugSelected",E.FilterAction="workbench.actions.treeView.testExplorer.filter",E.GetExplorerSelection="_testing.getExplorerSelection",E.GetSelectedProfiles="testing.getSelectedProfiles",E.GoToTest="testing.editFocusedTest",E.HideTestAction="testing.hideTest",E.OpenCoverage="testing.openCoverage",E.OpenOutputPeek="testing.openOutputPeek",E.RefreshTestsAction="testing.refreshTests",E.ReRunFailedTests="testing.reRunFailTests",E.ReRunLastRun="testing.reRunLastRun",E.RunAction="testing.run",E.RunAllAction="testing.runAll",E.RunAllWithCoverageAction="testing.coverageAll",E.RunAtCursor="testing.runAtCursor",E.RunByUri="testing.run.uri",E.RunCurrentFile="testing.runCurrentFile",E.RunSelectedAction="testing.runSelected",E.RunUsingProfileAction="testing.runUsing",E.RunWithCoverageAction="testing.coverage",E.SearchForTestExtension="testing.searchForTestExtension",E.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",E.ShowMostRecentOutputAction="testing.showMostRecentOutput",E.StartContinousRun="testing.startContinuousRun",E.StopContinousRun="testing.stopContinuousRun",E.TestingSortByDurationAction="testing.sortByDuration",E.TestingSortByLocationAction="testing.sortByLocation",E.TestingSortByStatusAction="testing.sortByStatus",E.TestingViewAsListAction="testing.viewAsList",E.TestingViewAsTreeAction="testing.viewAsTree",E.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",E.ToggleInlineTestOutput="testing.toggleInlineTestOutput",E.UnhideAllTestsAction="testing.unhideAllTests",E.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(ye[121],Se([1,0,9,4,3,66,75,74]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.TestItemEventOp=void 0;var $;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const a=(g,n)=>g===n,E=Object.entries({range:(g,n)=>g===n?!0:!g||!n?!1:g.equalsRange(n),busy:a,label:a,description:a,error:a,sortText:a,tags:(g,n)=>!(g.length!==n.length||g.some(o=>!n.includes(o)))}),l=(g,n)=>{let o;for(const[t,i]of E)i(g[t],n[t])||(o?o[t]=n[t]:o={[t]:n[t]});return o};class k extends P.$Wc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new r.$Rh(()=>this.flushDiff(),200)),this.g=this.B(new h.$me),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.J(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case T.TestDiffOpType.DocumentSynced:{for(const o of this.m)if(o.op===T.TestDiffOpType.DocumentSynced&&o.uri===n.uri){o.docv=n.docv;return}break}case T.TestDiffOpType.Update:{const o=this.m[this.m.length-1];if(o){if(o.op===T.TestDiffOpType.Update&&o.item.extId===n.item.extId){(0,T.$1I)(o.item,n.item);return}if(o.op===T.TestDiffOpType.Add&&o.item.item.extId===n.item.extId){(0,T.$1I)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const t=this.tree.get(n);if(t){if((t.expandLevels===void 0||o>t.expandLevels)&&(t.expandLevels=o),t.expand===T.TestItemExpandState.Expandable){const i=this.M(t);return i.isOpen()?this.L(t,o-1):i.wait().then(()=>this.L(t,o-1))}else if(t.expand===T.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,o-1)):this.L(t,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,o){switch(o.op){case $.RemoveChild:this.O(R.$TI.joinToString(n.fullId,o.id));break;case $.Upsert:this.z(o.item,n);break;case $.Bulk:for(const t of o.ops)this.w(n,t);break;case $.SetTags:this.C(o.new,o.old,n.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(n);break;case $.SetProp:this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:n.fullId.toString(),item:o.update}});break;case $.DocumentSynced:this.y(n.actual.uri);break;default:(0,O.$gd)(o)}}y(n){n&&this.pushDiff({op:T.TestDiffOpType.DocumentSynced,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,o){const t=R.$TI.fromExtHostTestItem(n,this.root.id,o?.actual),i=this.s.getApiFor(n);i.parent&&i.parent!==o?.actual&&this.s.getChildren(i.parent).delete(n.id);let s=this.tree.get(t.toString());if(!s){s={fullId:t,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:T.TestItemExpandState.NotExpandable},n.tags.forEach(this.D,this),this.tree.set(s.fullId.toString(),s),this.G(n,o),this.pushDiff({op:T.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(n)}}),this.I(n,s,o);return}if(s.actual===n){this.H(n,s,o);return}if(s.actual.uri?.toString()!==n.uri?.toString())return this.O(t.toString()),this.z(n,o);const f=this.s.getChildren(s.actual),u=s.actual,w=l(this.s.toITestItem(u),this.s.toITestItem(n));this.s.getApiFor(u).listener=void 0,s.actual=n,s.resolveBarrier=void 0,s.expand=T.TestItemExpandState.NotExpandable,w&&(w.hasOwnProperty("tags")&&(this.C(n.tags,u.tags,t.toString()),delete w.tags),this.w(s,{op:$.SetProp,update:w})),this.I(n,s,o);for(const[D,S]of f)this.s.getChildren(n).get(S.id)||this.O(R.$TI.joinToString(t,S.id));const y=s.expandLevels;y!==void 0&&queueMicrotask(()=>{s.expand===T.TestItemExpandState.Expandable&&(s.expandLevels=void 0,this.expand(t.toString(),y))}),this.y(s.actual.uri)}C(n,o,t){const i=new Set(o.map(s=>s.id));for(const s of n)i.delete(s.id)||this.D(s);this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:t,item:{tags:n.map(s=>(0,T.$YI)(this.s.controllerId,s.id))}}}),i.forEach(this.F,this)}D(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:T.TestDiffOpType.AddTag,tag:{id:(0,T.$YI)(this.s.controllerId,n.id)}}))}F(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:T.TestDiffOpType.RemoveTag,id:(0,T.$YI)(this.s.controllerId,n)}))}G(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}H(n,o,t){this.G(n,t);const i=this.s.getApiFor(n);i.parent=t?.actual,i.listener=s=>this.w(o,s),this.J(o)}I(n,o,t){this.H(n,o,t);for(const[i,s]of this.s.getChildren(n))this.z(s,o)}J(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?T.TestItemExpandState.Expanded:T.TestItemExpandState.BusyExpanding:o=n.actual.canResolveChildren?T.TestItemExpandState.Expandable:T.TestItemExpandState.NotExpandable:o=T.TestItemExpandState.NotExpandable,o!==n.expand&&(n.expand=o,this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:o}}),o===T.TestItemExpandState.Expandable&&n.expandLevels!==void 0&&this.M(n))}L(n,o){if(o<0)return;const t=[];for(const[i,s]of this.s.getChildren(n.actual)){const f=this.expand(R.$TI.joinToString(n.fullId,s.id),o);(0,r.$rh)(f)&&t.push(f)}if(t.length)return Promise.all(t).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const s=new r.$Eh;return s.open(),s}n.expand=T.TestItemExpandState.BusyExpanding,this.N(n);const o=n.resolveBarrier=new r.$Eh,t=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let i;try{i=this.h(n.actual===this.root?void 0:n.actual)}catch(s){t(s)}return(0,r.$rh)(i)?i.catch(t).then(()=>{o.open(),this.J(n)}):(o.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:T.TestDiffOpType.Remove,itemId:n});const t=[o];for(;t.length;){const i=t.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.F(s.id);this.tree.delete(i.fullId.toString());for(const[s,f]of this.s.getChildren(i.actual))t.push(this.tree.get(R.$TI.joinToString(i.fullId,f.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$QP=k;class p extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$RP=p;class c extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$SP=c;class m extends Error{constructor(n,o,t){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${t}".`)}}e.$TP=m;const d=(g,n,o)=>{let t=new Map;return{get size(){return t.size},forEach(i,s){for(const f of t.values())i.call(s,f,this)},[Symbol.iterator](){return t.entries()},replace(i){const s=new Map,f=new Set(t.keys()),u={op:$.Bulk,ops:[]};for(const w of i){if(!(w instanceof o))throw new c(w.id);const y=n(w).controllerId;if(y!==g.controllerId)throw new m(w.id,y,g.controllerId);if(s.has(w.id))throw new p(w.id);s.set(w.id,w),f.delete(w.id),u.ops.push({op:$.Upsert,item:w})}for(const w of f.keys())u.ops.push({op:$.RemoveChild,id:w});g.listener?.(u),t=s},add(i){if(!(i instanceof o))throw new c(i.id);t.set(i.id,i),g.listener?.({op:$.Upsert,item:i})},delete(i){t.delete(i)&&g.listener?.({op:$.RemoveChild,id:i})},get(i){return t.get(i)},toJSON(){return Array.from(t.values())}}};e.$UP=d}),define(ye[155],Se([1,0,121]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=void 0;const h=new WeakMap,P=(T,R)=>{const $={controllerId:R};return h.set(T,$),$};e.$VP=P;const O=T=>{const R=h.get(T);if(!R)throw new r.$SP(T?.id||"<unknown>");return R};e.$WP=O}),define(ye[122],Se([1,0,27,15,2]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cDb=e.$bDb=e.$aDb=void 0,e.$dDb=O,e.$eDb=R,e.$aDb="vscode-cdn.net",e.$bDb=`vscode-resource.${e.$aDb}`,e.$cDb=`'self' https://*.${e.$aDb}`;function O($,a){return $.scheme===h.Schemas.http||$.scheme===h.Schemas.https?$:(a&&a.authority&&a.isRemote&&$.scheme===h.Schemas.file&&($=P.URI.from({scheme:h.Schemas.vscodeRemote,authority:a.authority,path:$.path})),P.URI.from({scheme:h.Schemas.https,authority:`${$.scheme}+${T($.authority)}.${e.$bDb}`,path:$.path,fragment:$.fragment,query:$.query}))}function T($){return $.replace(/./g,a=>{const I=a.charCodeAt(0);return I>=r.CharCode.a&&I<=r.CharCode.z||I>=r.CharCode.A&&I<=r.CharCode.Z||I>=r.CharCode.Digit0&&I<=r.CharCode.Digit9?a:"-"+I.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(a,I)=>String.fromCharCode(parseInt(I,16)))}}),define(ye[316],Se([1,0,4,3,122]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=void 0;class O{constructor(R,$,a){this.d=R,this.e=$,this.f=a,this.a=0,this.b=new h.$Vc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const I=$.getVisibleTextEditors();for(const E of this.c.values())I.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,$,a,I,E){let l;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===R){l=n;break}if(!l)throw new Error("not a visible editor");const k=this,p=this.a++,c=new r.$me,m=new r.$me,d=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,P.$dDb)(n,k.f)}get cspSource(){return P.$cDb}set options(n){this.b=n,k.d.$setOptions(p,n)}get options(){return this.b}set html(n){this.a=n,k.d.$setHtml(p,n)}get html(){return this.a}get onDidReceiveMessage(){return c.event}postMessage(n){return k.d.$postMessage(p,n)}},g=new class{constructor(){this.editor=R,this.line=$,this.height=a,this.webview=d,this.onDidDispose=m.event}dispose(){k.c.has(p)&&(k.c.delete(p),k.d.$disposeEditorInset(p),m.fire(),m.dispose(),c.dispose())}};return this.d.$createEditorInset(p,l.id,l.value.document.uri,$+1,a,I||{},E.identifier,E.extensionLocation),this.c.set(p,{editor:R,inset:g,onDidReceiveMessage:c}),g}$onDidDispose(R){const $=this.c.get(R);$&&$.inset.dispose()}$onDidReceiveMessage(R,$){this.c.get(R)?.onDidReceiveMessage.fire($)}}e.$Aoc=O}),define(ye[156],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=e.$wM=void 0,e.$wM="__",e.$xM=(0,r.$Fi)("IAuthenticationService"),e.$yM=(0,r.$Fi)("IAuthenticationExtensionsService")}),define(ye[317],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=e.VariableKind=e.$OQ=void 0,e.$OQ=(0,r.$Fi)("configurationResolverService");var h;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(h||(e.VariableKind=h={}));class P extends Error{constructor(T,R){super(R),this.variable=T}}e.$PQ=P}),define(ye[318],Se([1,0,17,56,18,25,11,110,258,317,13]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Q=void 0,r=We(r),h=We(h),P=We(P),O=We(O);class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(k,p,c,m){this.h=new Map,this.a=k,this.b=p,this.g=c,m&&(this.c=m.then(d=>this.i(d)))}i(k){if(T.$i){const p=Object.create(null);return Object.keys(k).forEach(c=>{p[c.toLowerCase()]=k[c]}),p}return k}resolveWithEnvironment(k,p,c){return this.l({env:this.i(k),userHome:void 0},p?p.uri:void 0,c)}async resolveAsync(k,p){const c={env:await this.c,userHome:await this.g};return this.l(c,k?k.uri:void 0,p)}async j(k,p,c,m){const d=O.$do(p);T.$i&&d.windows?Object.keys(d.windows).forEach(n=>d[n]=d.windows[n]):T.$j&&d.osx?Object.keys(d.osx).forEach(n=>d[n]=d.osx[n]):T.$k&&d.linux&&Object.keys(d.linux).forEach(n=>d[n]=d.linux[n]),delete d.windows,delete d.osx,delete d.linux;const g={env:await this.c,userHome:await this.g};return this.l(g,k?k.uri:void 0,d,c,m)}async resolveAnyAsync(k,p,c){return this.j(k,p,c)}async resolveAnyMap(k,p,c){const m=new Map;return{newConfig:await this.j(k,p,c,m),resolvedVariables:m}}resolveWithInteractionReplace(k,p,c,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,p,c,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,p){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,p)}async l(k,p,c,m,d){if(P.$fg(c))return this.m(k,p,c,m,d);if(Array.isArray(c))return Promise.all(c.map(g=>this.l(k,p,g,m,d)));if(P.$hg(c)){const g=Object.create(null),n=await Promise.all(Object.keys(c).map(async o=>[await this.m(k,p,o,m,d),await this.l(k,p,c[o],m,d)]));for(const[o,t]of n)g[o]=t;return g}return c}m(k,p,c,m,d){return(0,I.$yf)(c,E.VARIABLE_REGEXP,async(g,n)=>{if(n.includes(E.VARIABLE_LHS))return g;let o=await this.o(k,g,n,p,m);return d?.set(n,o),o!==g&&P.$fg(o)&&o.match(E.VARIABLE_REGEXP)&&(o=await this.m(k,p,o,m,d)),o})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,p,c,m,d){let g;const n=c.split(":");n.length>1&&(c=n[0],g=n[1]);const o=s=>{const f=this.a.getFilePath();if(f)return(0,R.$Ww)(f);throw new a.$PQ(s,(0,$.localize)(0,null,p))},t=s=>{const f=o(s);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,R.$Ww)(u)}throw new a.$PQ(s,(0,$.localize)(1,null,p,r.$pc(f)))},i=s=>{if(g){const f=this.a.getFolderUri(g);if(f)return f;throw new a.$PQ(s,(0,$.localize)(2,null,p,g))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new a.$PQ(s,(0,$.localize)(3,null,p)):new a.$PQ(s,(0,$.localize)(4,null,p))};switch(c){case"env":if(g){if(k.env){const s=k.env[T.$i?g.toLowerCase():g];if(P.$fg(s))return s}return""}throw new a.$PQ(a.VariableKind.Env,(0,$.localize)(5,null,p));case"config":if(g){const s=this.a.getConfigurationValue(m,g);if(P.$og(s))throw new a.$PQ(a.VariableKind.Config,(0,$.localize)(6,null,p,g));if(P.$hg(s))throw new a.$PQ(a.VariableKind.Config,(0,$.localize)(7,null,p,g));return s}throw new a.$PQ(a.VariableKind.Config,(0,$.localize)(8,null,p));case"command":return this.p(a.VariableKind.Command,p,g,d,"command");case"input":return this.p(a.VariableKind.Input,p,g,d,"input");case"extensionInstallFolder":if(g){const s=await this.a.getExtension(g);if(!s)throw new a.$PQ(a.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,p,g));return this.n(s.extensionLocation)}throw new a.$PQ(a.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,p));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,R.$Ww)(this.n(i(a.VariableKind.WorkspaceFolder)));case"cwd":return m||g?(0,R.$Ww)(this.n(i(a.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.$Ww)(r.$pc(this.n(i(a.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new a.$PQ(a.VariableKind.UserHome,(0,$.localize)(11,null,p))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new a.$PQ(a.VariableKind.LineNumber,(0,$.localize)(12,null,p))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new a.$PQ(a.VariableKind.SelectedText,(0,$.localize)(13,null,p))}case"file":return o(a.VariableKind.File);case"fileWorkspaceFolder":return t(a.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.$pc(t(a.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||g?r.$nc(this.n(i(a.VariableKind.RelativeFile)),o(a.VariableKind.RelativeFile)):o(a.VariableKind.RelativeFile);case"relativeFileDirname":{const s=r.$oc(o(a.VariableKind.RelativeFileDirname));if(m||g){const f=r.$nc(this.n(i(a.VariableKind.RelativeFileDirname)),s);return f.length===0?".":f}return s}case"fileDirname":return r.$oc(o(a.VariableKind.FileDirname));case"fileExtname":return r.$qc(o(a.VariableKind.FileExtname));case"fileBasename":return r.$pc(o(a.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=r.$pc(o(a.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-r.$qc(s).length)}case"fileDirnameBasename":return r.$pc(r.$oc(o(a.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||p}case"execInstallFolder":{const s=this.a.getAppRoot();return s||p}case"pathSeparator":case"/":return r.sep;default:try{const s=g?`${c}:${g}`:c;return this.p(a.VariableKind.Unknown,p,s,d,void 0)}catch{return p}}}}p(k,p,c,m,d){if(c&&m){const g=d===void 0?m[c]:m[d+":"+c];if(typeof g=="string")return g;throw new a.$PQ(k,(0,$.localize)(14,null,p))}return p}}e.$5Q=E}),define(ye[157],Se([1,0,5,153]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$jE=void 0,e.$kE=a,e.$lE=l,e.$mE=k,e.$jE=(0,r.$Fi)("editorGroupsService");var P;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var O;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var T;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var R;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})(R||(e.GroupsArrangement=R={}));var $;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function a(p){const c=p;return(0,h.$8F)(c?.editor)&&(0,h.$8F)(c?.replacement)}var I;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var E;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function l(p){const c=p;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}function k(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(ye[319],Se([1,0,5,157]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qE=e.$pE=e.$oE=e.$nE=void 0,e.$rE=P,e.$nE=(0,r.$Fi)("editorService"),e.$oE=-1,e.$pE=-2,e.$qE=-3;function P(O){const T=O;return typeof O=="number"||(0,h.$lE)(T)}}),define(ye[158],Se([1,0,5,145]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=void 0,e.$RM=(0,r.$Gi)(h.$Mi)}),define(ye[159],Se([1,0,24,4,17,3,9]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=e.$Mcc=e.$Lcc=e.$Kcc=e.$Jcc=void 0,P=We(P);class R{constructor(g,n){this.versionId=g,this.removedDueToLooping=n}}e.$Jcc=R;class ${static isHostExtension(g,n,o){if(n.getExtensionDescription(g))return!1;const t=o.getExtensionDescription(g);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(g,n){this.j=g,this.c=new h.$me,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(c),this.f=new r.$sn,this.g=[],this.h=new Map;for(const g of this.e){if(this.f.has(g.identifier)){console.error("Extension `"+g.identifier.value+"` is already registered");continue}this.f.set(g.identifier,g),this.g.push(g);const n=this.j.readActivationEvents(g);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(g)}}set(g){return this.e=g,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(g,n){this.e=m(this.e,n),this.e=this.e.concat(g);const o=$.l(this.e);return this.e=m(this.e,o.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,o)}static l(g){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,u){this.addNode(f),this.addNode(u),this.c.has(f)?this.c.get(f).push(u):this.c.set(f,[u])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,u){const w=n.getArcs(f);for(let y=0;y<w.length;y++)if(!u.has(w[y]))return!1;return!0}getNodes(){return this.e}},o=new r.$sn;for(const f of g)if(o.set(f.identifier,f),f.extensionDependencies)for(const u of f.extensionDependencies)n.addArc(r.$qn.toKey(f.identifier),r.$qn.toKey(u));const t=new Set;n.getNodes().filter(f=>n.getArcs(f).length===0).forEach(f=>t.add(f));const i=n.getNodes().filter(f=>!t.has(f));let s;do{s=!1;for(let f=0;f<i.length;f++){const u=i[f];n.hasOnlyGoodArcs(u,t)&&(i.splice(f,1),f--,t.add(u),s=!0)}}while(s);return i.map(f=>o.get(f))}containsActivationEvent(g){return this.h.has(g)}containsExtension(g){return this.f.has(g)}getExtensionDescriptionsForActivationEvent(g){const n=this.h.get(g);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new a(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(g){const n=this.f.get(g);return n||void 0}getExtensionDescriptionByUUID(g){for(const n of this.g)if(n.uuid===g)return n}getExtensionDescriptionByIdOrUUID(g,n){return this.getExtensionDescription(g)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$Kcc=$;class a{constructor(g,n){this.versionId=g,this.extensions=n}}e.$Lcc=a;class I{constructor(g){this.d=new k,this.c=new $(g,[])}async acquireLock(g){const n=await this.d.acquire(g);return new E(this,n)}deltaExtensions(g,n,o){if(!g.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(g){return this.c.containsActivationEvent(g)}containsExtension(g){return this.c.containsExtension(g)}getExtensionDescriptionsForActivationEvent(g){return this.c.getExtensionDescriptionsForActivationEvent(g)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(g){return this.c.getExtensionDescription(g)}getExtensionDescriptionByUUID(g){return this.c.getExtensionDescriptionByUUID(g)}getExtensionDescriptionByIdOrUUID(g,n){return this.c.getExtensionDescriptionByIdOrUUID(g,n)}}e.$Mcc=I;class E extends O.$Wc{constructor(g,n){super(),this.f=g,this.c=!1,this.B(n)}isAcquiredFor(g){return!this.c&&this.f===g}}e.$Ncc=E;class l{constructor(g){this.name=g;const n=(0,T.$yh)();this.promise=n.promise,this.c=n.resolve}resolve(g){this.c(g)}}class k{constructor(){this.c=[],this.d=!1}async acquire(g){const n=new l(g);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const g=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${g.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};g.resolve((0,O.$Uc)(t))}}var p;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(p||(p={}));function c(d,g){const n=d.isBuiltin?p.Builtin:d.isUnderDevelopment?p.Dev:p.User,o=g.isBuiltin?p.Builtin:g.isUnderDevelopment?p.Dev:p.User;if(n!==o)return n-o;const t=P.$ic.basename(d.extensionLocation.path),i=P.$ic.basename(g.extensionLocation.path);return t<i?-1:t>i?1:0}function m(d,g){const n=new r.$rn(g);return d.filter(o=>!n.has(o.identifier))}}),define(ye[320],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.ExtHostConnectionType=void 0,e.$en=R,e.$fn=$;var r;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(E){this.pipeName=E,this.type=r.IPC}serialize(E){E[h.ENV_KEY]=this.pipeName}}e.$bn=h;class P{constructor(){this.type=r.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(E){E[P.ENV_KEY]="1"}}e.$cn=P;class O{constructor(){this.type=r.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(E){E[O.ENV_KEY]="1"}}e.$dn=O;function T(I){delete I[h.ENV_KEY],delete I[P.ENV_KEY],delete I[O.ENV_KEY]}function R(I,E){T(E),I.serialize(E)}function $(I){if(I[h.ENV_KEY])return a(I,new h(I[h.ENV_KEY]));if(I[P.ENV_KEY])return a(I,new P);if(I[O.ENV_KEY])return a(I,new O);throw new Error("No connection information defined in environment!")}function a(I,E){return T(I),E}}),define(ye[94],Se([1,0,22]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$An=T,e.$Bn=R;var h;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(h||(e.UIKind=h={}));var P;(function(a){a[a.VersionMismatch=55]="VersionMismatch",a[a.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var O;(function(a){a[a.Initialized=0]="Initialized",a[a.Ready=1]="Ready",a[a.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function T(a){const I=r.$Oe.alloc(1);switch(a){case O.Initialized:I.writeUInt8(1,0);break;case O.Ready:I.writeUInt8(2,0);break;case O.Terminate:I.writeUInt8(3,0);break}return I}function R(a,I){if(a.byteLength!==1)return!1;switch(a.readUInt8(0)){case 1:return I===O.Initialized;case 2:return I===O.Ready;case 3:return I===O.Terminate;default:return!1}}var $;(function(a){a.Start="START_NATIVE_LOG",a.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ye[95],Se([1,0,5,4,150,12,30,94,91,92,25,2,3,241]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$gQ=e.$fQ=void 0,e.$hQ=m;let p=class extends l.$Wc{constructor(g,n){super(),this.s=g,this.t=n,this.a=this.B(new h.$me),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new h.$me),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=E.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:a.$zp,name:(0,k.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(o=>{(0,O.$bk)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(g,n,o){const t=this.getTelemetryDetails(),i=new c(n,o,g,this.n,this.j,this.getBuiltInCommonProperties(g),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),s=this.r.get(g.identifier.value)??[];return this.r.set(g.identifier.value,[...s,i]),i.apiTelemetryLogger}$initializeTelemetryLevel(g,n,o){this.f=g,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(g){const n=Object.create(null);switch(n["common.extname"]=`${g.publisher}.${g.name}`,n["common.extversion"]=g.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$hn)((0,a.$Fp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(g){this.h=this.getTelemetryConfiguration(),this.f=g;const n=this.getTelemetryDetails();this.r.forEach((o,t)=>{const i=o.filter(s=>!s.isDisposed);i.length===0?this.r.delete(t):this.r.set(t,i)}),this.r.forEach(o=>{for(const t of o)t.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(g,n){const t=this.r.get(g.value)?.filter(s=>!s.isDisposed);if(!t)return this.r.delete(g.value),!1;let i=!1;for(const s of t)s.ignoreUnhandledExtHostErrors||(s.logError(n),i=!0);return i}};e.$fQ=p,e.$fQ=p=Je([Ve(0,T.$eQ),Ve(1,O.$ak)],p);class c{static validateSender(g){if(typeof g!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof g.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof g.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof g.flush<"u"&&typeof g.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(g,n,o,t,i,s,f){this.g=o,this.h=t,this.i=i,this.j=s,this.a=new h.$me,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=g,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(g,n){this.e&&(this.d={isUsageEnabled:g,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(g){let n="properties"in g?g.properties??{}:g;return n=(0,a.$Ip)(n,[]),this.c&&(n=(0,I.$go)(n,this.c)),this.b||(n=(0,I.$go)(n,this.j)),"properties"in g?g.properties=n:g=n,g}k(g,n){this.f&&(this.g.publisher==="vscode"?g=this.g.name+"/"+g:g=this.g.identifier.value+"/"+g,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(g,n),this.h.trace(g,n))}logUsage(g,n){this.d.isUsageEnabled&&this.k(g,n)}logError(g,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof g=="string")this.k(g,n);else{const o={name:g.name,message:g.message,stack:g.stack,cause:g.cause},t=(0,a.$Ip)(o,[]),i=new Error(t.message,{cause:t.cause});i.stack=t.stack,i.name=t.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(i,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const g=this,n={logUsage:g.logUsage.bind(g),get isUsageEnabled(){return g.d.isUsageEnabled},get isErrorsEnabled(){return g.d.isErrorsEnabled},logError:g.logError.bind(g),dispose:g.dispose.bind(g),onDidChangeEnableStates:g.a.event.bind(g)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let g=this.f;this.f=void 0,Promise.resolve(g.flush()).then(g=void 0),this.e=void 0}else this.f=void 0}}e.$gQ=c;function m(d){const g=Date.now()-new Date(d).getTime();return isNaN(g)?!1:g<1e3*60*60*24}e.$iQ=(0,r.$Fi)("IExtHostTelemetry")}),define(ye[26],Se([1,0,4,2,290,148,24,5]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_G=e.ActivationKind=e.$9G=e.$8G=e.$5G=e.ExtensionHostStartup=e.$4G=e.$3G=e.$2G=e.$1G=void 0,e.$6G=l,e.$7G=k,e.$0G=d,e.$$G=g,e.$1G=Object.freeze({identifier:new T.$qn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:T.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$2G="extensions.webWorker",e.$3G=(0,R.$Fi)("extensionService");class ${constructor(t){this.dependency=t}}e.$4G=$;var a;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(a||(e.ExtensionHostStartup=a={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,i,s){this.c=t,this.d=i.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$MG.createActivationEventsMap(this.d)}}set(t,i,s){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const f=[],u=[],w=[],y=[],D=E(this.d),S=E(i),C=(N,L)=>N.extensionLocation.toString()===L.extensionLocation.toString()||N.isBuiltin===L.isBuiltin||N.isUserBuiltin===L.isUserBuiltin||N.isUnderDevelopment===L.isUnderDevelopment;for(const N of this.d){const L=S.get(N.identifier);if(!L){f.push(N.identifier),D.delete(N.identifier);continue}if(!C(N,L)){f.push(N.identifier),D.delete(N.identifier);continue}}for(const N of i){const L=D.get(N.identifier);if(!L){u.push(N);continue}if(!C(L,N)){f.push(L.identifier),D.delete(L.identifier);continue}}const A=new T.$rn(this.e),b=new T.$rn(s);for(const N of this.e)b.has(N)||w.push(N);for(const N of s)A.has(N)||y.push(N);const v=O.$MG.createActivationEventsMap(u),M={versionId:t,toRemove:f,toAdd:u,addActivationEvents:v,myToRemove:w,myToAdd:y};return this.delta(M),M}delta(t){if(this.c>=t.versionId)return null;const{toRemove:i,toAdd:s,myToRemove:f,myToAdd:u}=t,w=new T.$rn(i),y=new T.$rn(f);for(let D=0;D<this.d.length;D++)w.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)y.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of s)this.d.push(D);for(const D of u)this.e.push(D);return this.f=null,t}containsExtension(t){for(const i of this.e)if(T.$qn.equals(i,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const s=O.$MG.readActivationEvents(i);for(const f of s)t.add(f)}return t}}e.$5G=I;function E(o){const t=new T.$sn;for(const i of o)t.set(i.identifier,i);return t}function l(o,t){return o.enabledApiProposals?o.enabledApiProposals.includes(t):!1}function k(o,t){if(!l(o,t))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}class p{constructor(t,i,s,f){this.codeLoadingTime=t,this.activateCallTime=i,this.activateResolvedTime=s,this.activationReason=f}}e.$8G=p;class c{constructor(t,i){this.description=t,this.value=i}}e.$9G=c;var m;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function d(o){return{type:o.isBuiltin?T.ExtensionType.System:T.ExtensionType.User,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,P.$Op)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}function g(o,t){const i=(0,P.$Mp)(o.manifest.publisher,o.manifest.name);return{id:i,identifier:new T.$qn(i),isBuiltin:o.type===T.ExtensionType.System,isUserBuiltin:o.type===T.ExtensionType.User&&o.isBuiltin,isUnderDevelopment:!!t,extensionLocation:o.location,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,publisherDisplayName:o.publisherDisplayName,...o.manifest}}class n{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,i){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$_G=n}),define(ye[321],Se([1,0,14,159,24,26,12,9]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=e.$1oc=e.$Zoc=e.$Yoc=e.$Xoc=e.$Woc=void 0,r=We(r);class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(d,g,n,o){this.startup=d,this.codeLoadingTime=g,this.activateCallTime=n,this.activateResolvedTime=o}}e.$Woc=$;class a{constructor(d){this.a=d,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(d,g){return d===-1||g===-1?-1:g-d}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Xoc=a;class I{constructor(d,g,n,o,t,i){this.activationFailed=d,this.activationFailedError=g,this.activationTimes=n,this.module=o,this.exports=t,this.subscriptions=i}}e.$Yoc=I;class E extends I{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Zoc=E;class l extends I{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$1oc=l;class k extends I{constructor(d){super(!0,d,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(d,g,n,o){this.g=o,this.a=d,this.b=g,this.c=n,this.d=new P.$sn,this.f=Object.create(null)}dispose(){for(const[d,g]of this.d)g.dispose()}async waitForActivatingExtensions(){const d=[];for(const[g,n]of this.d)d.push(n.wait());await Promise.all(d)}isActivated(d){const g=this.d.get(d);return!!(g&&g.value)}getActivatedExtension(d){const g=this.d.get(d);if(!g||!g.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return g.value}async activateByEvent(d,g){if(this.f[d])return;const n=this.a.getExtensionDescriptionsForActivationEvent(d);await this.h(n.map(o=>({id:o.identifier,reason:{startup:g,extensionId:o.identifier,activationEvent:d}}))),this.f[d]=!0}activateById(d,g){const n=this.a.getExtensionDescription(d);if(!n)throw new Error(`Extension '${d.value}' is not known`);return this.h([{id:n.identifier,reason:g}])}async h(d){const g=d.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(g.map(n=>n.wait()))}j(d){if(this.d.has(d.id))return this.d.get(d.id);if(this.l(d.id))return this.k(d,null,[],null);const g=this.a.getExtensionDescription(d.id);if(!g){const t=new Error(`Cannot activate unknown extension '${d.id.value}'`),i=this.k(d,null,[],new k(t));return this.c.onExtensionActivationError(d.id,t,new O.$4G(d.id.value)),i}const n=[],o=typeof g.extensionDependencies>"u"?[]:g.extensionDependencies;for(const t of o){if(this.m(t))continue;const i=this.d.get(t);if(i){n.push(i);continue}if(this.l(t)){n.push(this.j({id:this.b.getExtensionDescription(t).identifier,reason:d.reason}));continue}const s=this.a.getExtensionDescription(t);if(s){if(!s.main&&!s.browser)continue;n.push(this.j({id:s.identifier,reason:d.reason}));continue}const f=g.displayName||g.identifier.value,u=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${t}'`),w=this.k(d,g.displayName,[],new k(u));return this.c.onExtensionActivationError(g.identifier,u,new O.$4G(t)),w}return this.k(d,g.displayName,n,null)}k(d,g,n,o){const t=new c(d.id,g,d.reason,n,o,this.c,this.g);return this.d.set(d.id,t),t}l(d){return h.$Kcc.isHostExtension(d,this.a,this.b)}m(d){const g=this.b.getExtensionDescription(d);return g?!g.main&&!g.browser:!1}};e.$2oc=p,e.$2oc=p=Je([Ve(3,T.$_j)],p);let c=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(d,g,n,o,t,i,s){this.c=d,this.d=g,this.f=n,this.g=o,this.h=t,this.j=i,this.k=s,this.a=new R.$Eh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let d=0;d<this.g.length;d++){const g=this.g[d];if(g.value&&!g.value.activationFailed){this.g.splice(d,1),d--;continue}if(g.value&&g.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);n.detail=g.value.activationFailedError,this.h=new k(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(d=>d.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(d){const g=new Error;if(d&&d.name&&(g.name=d.name),d&&d.message?g.message=`Activating extension '${this.c.value}' failed: ${d.message}.`:g.message=`Activating extension '${this.c.value}' failed: ${d}.`,d&&d.stack&&(g.stack=d.stack),this.h=new k(g),this.b&&r.$6(d))return;this.j.onExtensionActivationError(this.c,g,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(d)}}};c=Je([Ve(6,T.$_j)],c)});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ye[160],Se([1,0,260,14,44,147,117,37,24,116,148,144]),function(ce,e,r,h,P,O,T,R,$,a,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=void 0,r=We(r),P=zt(P);const l=R.$qo.as(T.$ro.JSONContribution);class k{constructor(t,i,s){this.a=t,this.b=i,this.c=s}d(t,i){this.a({type:t,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(P.default.Error,t)}warn(t){this.d(P.default.Warning,t)}info(t){this.d(P.default.Info,t)}}e.$UG=k;class p{static a(t){const i=new $.$rn;for(let s=0,f=t.length;s<f;s++)i.add(t[s].description.identifier);return i}static compute(t,i){if(!t||!t.length)return new p(i,[]);if(!i||!i.length)return new p([],t);const s=this.a(t),f=this.a(i),u=i.filter(y=>!s.has(y.description.identifier)),w=t.filter(y=>!f.has(y.description.identifier));return new p(u,w)}constructor(t,i){this.added=t,this.removed=i}}e.$VG=p;class c{constructor(t,i){this.name=t,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=p.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,h.$3)(t)}}}e.$WG=c;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.$XG={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$pn},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals).map(o=>o),markdownEnumDescriptions:Object.values(E.allApiProposals).map(o=>o.proposal)}},api:{markdownDescription:r.localize(15,null),type:"string",enum:["none"],enumDescriptions:[r.localize(16,null)]},activationEvents:{description:r.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(32,null)},{label:"onUri",body:"onUri",description:r.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(37,null)},{label:"onRenderer",description:r.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(42,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:r.localize(43,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:r.localize(44,null)},{label:"*",description:r.localize(45,null),body:"*"}]}},badges:{type:"array",description:r.localize(46,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(47,null)},href:{type:"string",description:r.localize(48,null)},description:{type:"string",description:r.localize(49,null)}}}},markdown:{type:"string",description:r.localize(50,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(51,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(52,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$8o}},extensionPack:{description:r.localize(53,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$8o}},extensionKind:{description:r.localize(54,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(55,null)},{body:["workspace"],description:r.localize(56,null)},{body:["ui","workspace"],description:r.localize(57,null)},{body:["workspace","ui"],description:r.localize(58,null)},{body:[],description:r.localize(59,null)}]},capabilities:{description:r.localize(60,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(61,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(63,null),r.localize(64,null),r.localize(65,null)]},description:{type:"string",markdownDescription:r.localize(66,null)}}},untrustedWorkspaces:{description:r.localize(67,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(68,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(69,null),r.localize(70,null),r.localize(71,null)]},restrictedConfigurations:{description:r.localize(72,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(73,null)}}}}},sponsor:{description:r.localize(74,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(75,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(76,null),type:"string"},"vscode:uninstall":{description:r.localize(77,null),type:"string"}}},icon:{type:"string",description:r.localize(78,null)},l10n:{type:"string",description:r.localize(79,null)},pricing:{type:"string",markdownDescription:r.localize(80,null),enum:["Free","Trial"],default:"Free"}}};class g{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const i=new c(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,i),t.activationEventsGenerator&&I.$MG.register(t.extensionPoint,t.activationEventsGenerator),e.$XG.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,l.registerSchema(d,e.$XG),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$YG=g;const n={ExtensionsRegistry:"ExtensionsRegistry"};R.$qo.add(n.ExtensionsRegistry,new g),e.$ZG=R.$qo.as(n.ExtensionsRegistry),l.registerSchema(d,e.$XG),l.registerSchema(a.$tk,{properties:{extensionEnabledApiProposals:{description:r.localize(81,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals).map(o=>o.proposal)}}]}}}})}),define(ye[322],Se([1,0,4,40,3,13,251,24,5,12,26,160]),function(ce,e,r,h,P,O,T,R,$,a,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cH=e.$bH=e.$aH=e.ChatMessageRole=void 0;var l;(function(c){c[c.System=0]="System",c[c.User=1]="User",c[c.Assistant=2]="Assistant"})(l||(e.ChatMessageRole=l={})),e.$aH=(0,$.$Fi)("ILanguageModelsService");const k={type:"object",properties:{vendor:{type:"string",description:(0,T.localize)(0,null)}}};e.$bH=E.$ZG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,T.localize)(1,null),oneOf:[k,{type:"array",items:k}]},activationEventsGenerator:(c,m)=>{for(const d of c)m.push(`onLanguageModelChat:${d.vendor}`)}});let p=class{constructor(m,d){this.e=m,this.f=d,this.a=new P.$Vc,this.b=new Map,this.c=new Set,this.d=this.a.add(new r.$me),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$bH.setHandler(g=>{this.c.clear();for(const o of g){if(!(0,I.$6G)(o.description,"chatProvider")){o.collector.error((0,T.localize)(2,null));continue}for(const t of h.Iterable.wrap(o.value)){if(this.c.has(t.vendor)){o.collector.error((0,T.localize)(3,null,t.vendor));continue}if((0,O.$df)(t.vendor)){o.collector.error((0,T.localize)(4,null));continue}if(t.vendor.trim()!==t.vendor){o.collector.error((0,T.localize)(5,null));continue}this.c.add(t.vendor)}}const n=[];for(const[o,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(o),n.push(o));n.length>0&&this.d.fire({removed:n})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(m){return this.b.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this.e.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const g=Array.from(this.c).map(n=>this.e.activateByEvent(`onLanguageModelChat:${n}`));await Promise.all(g)}const d=[];for(const[g,n]of this.b)(m.vendor===void 0||n.metadata.vendor===m.vendor)&&(m.family===void 0||n.metadata.family===m.family)&&(m.version===void 0||n.metadata.version===m.version)&&(m.identifier===void 0||n.metadata.id===m.identifier)&&(!n.metadata.targetExtensions||n.metadata.targetExtensions.some(o=>R.$qn.equals(o,m.extension)))&&d.push(g);return this.f.trace("[LM] selected language models",m,d),d}registerLanguageModelChat(m,d){if(this.f.trace("[LM] registering language model chat",m,d.metadata),!this.c.has(d.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${d.metadata.vendor}.`);if(this.b.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this.b.set(m,d),this.d.fire({added:[{identifier:m,metadata:d.metadata}]}),(0,P.$Uc)(()=>{this.b.delete(m)&&(this.d.fire({removed:[m]}),this.f.trace("[LM] UNregistered language model chat",m,d.metadata))})}async sendChatRequest(m,d,g,n,o){const t=this.b.get(m);if(!t)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return t.sendChatRequest(g,d,n,o)}computeTokenLength(m,d,g){const n=this.b.get(m);if(!n)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return n.provideTokenCount(d,g)}};e.$cH=p,e.$cH=p=Je([Ve(0,I.$3G),Ve(1,a.$_j)],p)}),define(ye[323],Se([1,0,255,18,25,160,36,4]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HI=void 0,r=We(r),h=We(h),P=We(P);const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var a;(function(l){function k(p,c,m){if(!p)return;const d=h.$fg(p.type)?p.type:void 0;if(!d||d.length===0){m.error(r.localize(3,null));return}const g=[];if(Array.isArray(p.required))for(const n of p.required)h.$fg(n)&&g.push(n);return{extensionId:c.value,taskType:d,required:g,properties:p.properties?P.$do(p.properties):{},when:p.when?T.$Dj.deserialize(p.when):void 0}}l.from=k})(a||(a={}));const I=O.$ZG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,k)=>{for(const p of l)p.type&&k.push(`onTaskType:${p.type}`)},jsonSchema:{description:r.localize(4,null),type:"array",items:$}});class E{constructor(){this.d=new R.$me,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,p)=>{I.setHandler((c,m)=>{this.c=void 0;try{for(const d of m.removed){const g=d.value;for(const n of g)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const d of m.added){const g=d.value;for(const n of g){const o=a.from(n,d.description.identifier,d.collector);o&&(this.a[o.taskType]=o)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const p of this.all()){const c={type:"object",additionalProperties:!1};p.required.length>0&&(c.required=p.required.slice(0)),p.properties!==void 0?c.properties=P.$do(p.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[p.taskType]},k.push(c)}this.c={oneOf:k}}return this.c}}e.$HI=new E}),define(ye[324],Se([1,0,256,18,23,25,36,323,45]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$RI=e.JsonSchemaVersion=e.ExecutionEngine=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$LI=e.ShellQuoting=e.$KI=e.$JI=e.$II=void 0,r=We(r),h=We(h),P=We(P),O=We(O),e.$II="settings",e.$JI=new T.$Wj("taskRunning",!1,r.localize(0,null)),e.$KI=r.localize2(2,"Tasks");var a;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(a||(e.ShellQuoting=a={})),e.$LI="$customized",function(F){function B(_){if(!_)return F.Strong;switch(_.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=B}(a||(e.ShellQuoting=a={}));var I;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var E;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(E||(e.RevealKind=E={})),function(F){function B(_){switch(_.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=B}(E||(e.RevealKind=E={}));var l;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(l||(e.RevealProblemKind=l={})),function(F){function B(_){switch(_.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=B}(l||(e.RevealProblemKind=l={}));var k;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(k||(e.PanelKind=k={})),function(F){function B(_){switch(_.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=B}(k||(e.PanelKind=k={}));var p;(function(F){F.defaults={echo:!0,reveal:E.Always,revealProblems:l.Never,focus:!1,panel:k.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var c;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(c||(e.RuntimeType=c={})),function(F){function B(re){switch(re.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=B;function _(re){switch(re){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=_}(c||(e.RuntimeType=c={}));var m;(function(F){function B(_){return h.$fg(_)?_:_.value}F.value=B})(m||(e.CommandString=m={}));var d;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function B(re){return re===F.Clean._id||re===F.Build._id||re===F.Rebuild._id||re===F.Test._id}F.is=B;function _(re){if(re!==void 0)return h.$fg(re)?B(re)?{_id:re,isDefault:!1}:void 0:re}F.from=_})(d||(e.TaskGroup=d={}));var g;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(g||(e.TaskScope=g={}));var n;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function B(_){switch(_){case F.User:return $.ConfigurationTarget.USER;case F.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}F.toConfigurationTarget=B})(n||(e.TaskSourceKind=n={}));var o;(function(F){F.parallel="parallel",F.sequence="sequence"})(o||(e.DependsOrder=o={}));var t;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var i;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(i||(e.RunOptions=i={}));class s{constructor(B,_,re,U,G,Q){this._label="",this._id=B,_&&(this._label=_),re&&(this.type=re),this.runOptions=U,this.configurationProperties=G,this._source=Q}getDefinition(B){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,_=!1){if(B===void 0)return!1;if(h.$fg(B))return B===this._label||B===this.configurationProperties.identifier||_&&B===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.$MI=s;class f extends s{constructor(B,_,re,U,G,Q,ee,he){super(B,re,void 0,ee,he,_),this.command={},this._source=_,this.hasDefinedMatchers=Q,G&&(this.command=G)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let _;switch(this.command?this.command.runtime:void 0){case c.Shell:_="shell";break;case c.Process:_="process";break;case c.CustomExecution:_="customExecution";break;case void 0:_="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:_,_key:this._id,id:this._id}}}static is(B){return B instanceof f}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$II:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const B=this.d();if(!B)return;let _=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(_+=this._source.kind);const re={type:e.$LI,folder:B,id:_};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$dh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new f(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$NI=f;class u extends s{constructor(B,_,re,U,G,Q,ee){super(B,re,U,Q,ee,_),this._source=_,this.configures=G}static is(B){return B instanceof u}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$dh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$II:this._source.config.workspaceFolder?.uri.toString()}getKey(){const B=this.d();if(!B)return;let _=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(_+=this._source.kind);const re={type:e.$LI,folder:B,id:_};return JSON.stringify(re)}}e.$OI=u;class w extends s{constructor(B,_,re,U,G,Q,ee,he,ne){super(B,re,U,he,ne,_),this.defines=G,this.hasDefinedMatchers=ee,this.command=Q,this.icon=ne.icon,this.hide=ne.hide}clone(){return new w(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof w}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===g.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new w(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$PI=w;class y extends s{constructor(B,_,re,U,G,Q){super(B,re,U,G,Q,_),this._source=_}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new y(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.$QI=y;var D;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(F){F._default=F.Terminal}(D||(e.ExecutionEngine=D={}));var S;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class C{constructor(B){this.c=new Map;for(let _=0;_<B.length;_++)this.c.set(B[_].uri.toString(),_)}compare(B,_){const re=B.getWorkspaceFolder(),U=_.getWorkspaceFolder();if(re&&U){let G=this.c.get(re.uri.toString());G=G===void 0?0:G+1;let Q=this.c.get(U.uri.toString());return Q=Q===void 0?0:Q+1,G===Q?B._label.localeCompare(_._label):G-Q}else return!re&&U?-1:re&&!U?1:0}}e.$RI=C;var A;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(A||(e.TaskEventKind=A={}));var b;(function(F){F.SingleRun="singleRun",F.Background="background"})(b||(e.TaskRunType=b={}));var v;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var M;(function(F){function B(he){return{taskId:he._id,taskName:he.configurationProperties.name,runType:he.configurationProperties.isBackground?b.Background:b.SingleRun,group:he.configurationProperties.group,__task:he}}function _(he,ne,De){return{...B(he),kind:A.Start,terminalId:ne,resolvedVariables:De}}F.start=_;function re(he,ne,De){return{...B(he),kind:A.ProcessStarted,terminalId:ne,processId:De}}F.processStarted=re;function U(he,ne,De){return{...B(he),kind:A.ProcessEnded,terminalId:ne,exitCode:De}}F.processEnded=U;function G(he,ne,De){return{...B(he),kind:A.Terminated,exitReason:De,terminalId:ne}}F.terminated=G;function Q(he,ne,De){return{...B(ne),kind:he,terminalId:De}}F.general=Q;function ee(){return{kind:A.Changed}}F.changed=ee})(M||(e.TaskEvent=M={}));var N;(function(F){function B(re){const U=Object.keys(re).sort();let G="";for(const Q of U){let ee=re[Q];ee instanceof Object?ee=B(ee):typeof ee=="string"&&(ee=ee.replace(/,/g,",,")),G+=Q+","+ee+","}return G}function _(re){const G={_key:B(re),type:re.taskType};return Object.assign(G,re),G}F.create=_})(N||(e.KeyedTaskIdentifier=N={}));var L;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(L||(e.TaskSettingId=L={}));var j;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var z;(function(F){function B(_,re){const U=R.$HI.get(_.type);if(U===void 0){const he=O.$do(_);return delete he._key,N.create(he)}const G=Object.create(null);G.type=U.taskType;const Q=new Set;U.required.forEach(he=>Q.add(he));const ee=U.properties;for(const he of Object.keys(ee)){const ne=_[he];if(ne!=null)G[he]=ne;else if(Q.has(he)){const De=ee[he];if(De.default!==void 0)G[he]=O.$do(De.default);else switch(De.type){case"boolean":G[he]=!1;break;case"number":case"integer":G[he]=0;break;case"string":G[he]="";break;default:re.error(r.localize(1,null,JSON.stringify(_,void 0,0),he));return}}}return N.create(G)}F.createTaskIdentifier=B})(z||(e.TaskDefinition=z={}))}),define(ye[325],Se([1,0,14]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=void 0;class h{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((T,R)=>{this.b=T,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(T){this.f||this.h||(this.f=!0,this.g=T,this.a&&this.b(T))}resolveErr(T){this.f||this.h||(this.h=!0,this.i=T,this.a?this.d(T):(0,r.$3)(T))}then(T,R){return this.j().then(T,R)}catch(T){return this.j().then(void 0,T)}finally(T){return this.j().finally(T)}}e.$Occ=h;class P extends h{constructor(){super(),this.h=!0,this.i=new r.$7}}e.$Pcc=P}),define(ye[52],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tw=e.$Qw=void 0,e.$Rw=P,e.$Sw=O;class r{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++r.count}}e.$Qw=r;const h=[];function P(R){const $=new r(R);return h[$.nid]=$,$}function O(R){return h[R].sid}class T{constructor($){this.value=$}}e.$Tw=T}),define(ye[6],Se([1,0,52]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$tN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var P;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput",c[c.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var O;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var T;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var R;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(R||(e.WebviewMessageArrayBufferViewType=R={}));var $;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var a;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(a||(e.NotebookEditorRevealType=a={}));var I;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output",c[c.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class E{static{this.a=0}static mixin(m){return m._id=E.a++,m}}e.$tN=E;var l;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var k;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var p;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$uN={MainThreadAuthentication:(0,r.$Rw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.$Rw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.$Rw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.$Rw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.$Rw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.$Rw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,r.$Rw)("MainThreadChatSkills"),MainThreadClipboard:(0,r.$Rw)("MainThreadClipboard"),MainThreadCommands:(0,r.$Rw)("MainThreadCommands"),MainThreadComments:(0,r.$Rw)("MainThreadComments"),MainThreadConfiguration:(0,r.$Rw)("MainThreadConfiguration"),MainThreadConsole:(0,r.$Rw)("MainThreadConsole"),MainThreadDebugService:(0,r.$Rw)("MainThreadDebugService"),MainThreadDecorations:(0,r.$Rw)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.$Rw)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.$Rw)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.$Rw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.$Rw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.$Rw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.$Rw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.$Rw)("MainThreadEditorTabs"),MainThreadErrors:(0,r.$Rw)("MainThreadErrors"),MainThreadTreeViews:(0,r.$Rw)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.$Rw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.$Rw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.$Rw)("MainThreadLanguages"),MainThreadLogger:(0,r.$Rw)("MainThreadLogger"),MainThreadMessageService:(0,r.$Rw)("MainThreadMessageService"),MainThreadOutputService:(0,r.$Rw)("MainThreadOutputService"),MainThreadProgress:(0,r.$Rw)("MainThreadProgress"),MainThreadQuickDiff:(0,r.$Rw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.$Rw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.$Rw)("MainThreadStatusBar"),MainThreadSecretState:(0,r.$Rw)("MainThreadSecretState"),MainThreadStorage:(0,r.$Rw)("MainThreadStorage"),MainThreadSpeech:(0,r.$Rw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.$Rw)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.$Rw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.$Rw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.$Rw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.$Rw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.$Rw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.$Rw)("MainThreadCustomEditors"),MainThreadUrls:(0,r.$Rw)("MainThreadUrls"),MainThreadUriOpeners:(0,r.$Rw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.$Rw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.$Rw)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.$Rw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.$Rw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.$Rw)("MainThreadExtensionService"),MainThreadSCM:(0,r.$Rw)("MainThreadSCM"),MainThreadSearch:(0,r.$Rw)("MainThreadSearch"),MainThreadShare:(0,r.$Rw)("MainThreadShare"),MainThreadTask:(0,r.$Rw)("MainThreadTask"),MainThreadWindow:(0,r.$Rw)("MainThreadWindow"),MainThreadLabelService:(0,r.$Rw)("MainThreadLabelService"),MainThreadNotebook:(0,r.$Rw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.$Rw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.$Rw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.$Rw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.$Rw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.$Rw)("MainThreadInteractive"),MainThreadTheming:(0,r.$Rw)("MainThreadTheming"),MainThreadTunnelService:(0,r.$Rw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.$Rw)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.$Rw)("MainThreadTimeline"),MainThreadTesting:(0,r.$Rw)("MainThreadTesting"),MainThreadLocalization:(0,r.$Rw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.$Rw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.$Rw)("MainThreadAiEmbeddingVector")},e.$vN={ExtHostCommands:(0,r.$Rw)("ExtHostCommands"),ExtHostConfiguration:(0,r.$Rw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.$Rw)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.$Rw)("ExtHostDebugService"),ExtHostDecorations:(0,r.$Rw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.$Rw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.$Rw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.$Rw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.$Rw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.$Rw)("ExtHostEditors"),ExtHostTreeViews:(0,r.$Rw)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.$Rw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.$Rw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.$Rw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.$Rw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.$Rw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.$Rw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.$Rw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.$Rw)("ExtHostStatusBar"),ExtHostShare:(0,r.$Rw)("ExtHostShare"),ExtHostExtensionService:(0,r.$Rw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.$Rw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.$Rw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.$Rw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.$Rw)("ExtHostSCM"),ExtHostSearch:(0,r.$Rw)("ExtHostSearch"),ExtHostTask:(0,r.$Rw)("ExtHostTask"),ExtHostWorkspace:(0,r.$Rw)("ExtHostWorkspace"),ExtHostWindow:(0,r.$Rw)("ExtHostWindow"),ExtHostWebviews:(0,r.$Rw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.$Rw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.$Rw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.$Rw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.$Rw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.$Rw)("ExtHostEditorTabs"),ExtHostProgress:(0,r.$Rw)("ExtHostProgress"),ExtHostComments:(0,r.$Rw)("ExtHostComments"),ExtHostSecretState:(0,r.$Rw)("ExtHostSecretState"),ExtHostStorage:(0,r.$Rw)("ExtHostStorage"),ExtHostUrls:(0,r.$Rw)("ExtHostUrls"),ExtHostUriOpeners:(0,r.$Rw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.$Rw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.$Rw)("ExtHostOutputService"),ExtHostLabelService:(0,r.$Rw)("ExtHostLabelService"),ExtHostNotebook:(0,r.$Rw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.$Rw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.$Rw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.$Rw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.$Rw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.$Rw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.$Rw)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.$Rw)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.$Rw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,r.$Rw)("ExtHostChatSkills"),ExtHostChatProvider:(0,r.$Rw)("ExtHostChatProvider"),ExtHostSpeech:(0,r.$Rw)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.$Rw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.$Rw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.$Rw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.$Rw)("ExtHostTheming"),ExtHostTunnelService:(0,r.$Rw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.$Rw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.$Rw)("ExtHostAuthentication"),ExtHostTimeline:(0,r.$Rw)("ExtHostTimeline"),ExtHostTesting:(0,r.$Rw)("ExtHostTesting"),ExtHostTelemetry:(0,r.$Rw)("ExtHostTelemetry"),ExtHostLocalization:(0,r.$Rw)("ExtHostLocalization")}}),define(ye[96],Se([1,0,5,12,6,20]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$loc=e.$koc=e.$joc=void 0,P=We(P),e.$joc=(0,r.$Fi)("IExtHostApiDeprecationService");let T=class{constructor($,a){this.c=a,this.a=new Set,this.b=$.getProxy(P.$uN.MainThreadTelemetry)}report($,a,I){const E=this.d($,a);this.a.has(E)||(this.a.add(E),a.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:a.identifier.value,apiId:$}))}d($,a){return`${$}-${a.identifier.value}`}};e.$koc=T,e.$koc=T=Je([Ve(0,O.$1P),Ve(1,h.$_j)],T),e.$loc=Object.freeze(new class{report(R,$,a){}})}),define(ye[326],Se([1,0,6]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=void 0;class h{constructor(O){const T=O.getProxy(r.$uN.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(R){return T.$writeText(R)}})}}e.$yoc=h}),define(ye[327],Se([1,0,25,6,30,20]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=void 0;let T=class{constructor(I,E){this.a=I.getProxy(h.$uN.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,E){const l=this,k=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){l.e(I,E,k,arguments)}})}e(I,E,l,k){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:$(k,this.b)}),this.c&&this.f(I,l,k)}};e.$uqc=T,e.$uqc=T=Je([Ve(0,O.$1P),Ve(1,P.$eQ)],T);const R=1e5;function $(a,I){const E=[];if(a.length)for(let l=0;l<a.length;l++){let k=a[l];if(typeof k>"u")k="undefined";else if(k instanceof Error){const p=k;p.stack?k=p.stack:k=p.toString()}E.push(k)}if(I){const l=new Error().stack;l&&E.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,r.$io)(E);return l.length>R?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(ye[328],Se([1,0,2,6,26]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Apc=void 0;class O{constructor(R){this.a=R.getProxy(h.$uN.MainThreadDialogs)}showOpenDialog(R,$){return $?.allowUIResources&&(0,P.$7G)(R,"showLocal"),this.a.$showOpenDialog($).then(a=>a?a.map(I=>r.URI.revive(I)):void 0)}showSaveDialog(R){return this.a.$showSaveDialog(R).then($=>$?r.URI.revive($):void 0)}}e.$Apc=O}),define(ye[329],Se([1,0,21,4,3,6]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=void 0;class T{constructor($){this.b=new Map,this.c=new h.$me,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(O.$uN.MainThreadEmbeddings)}registerEmbeddingsProvider($,a,I){if(this.d.has(a))throw new Error("An embeddings provider for this model is already registered");const E=this.e++;return this.a.$registerEmbeddingProvider(E,a),this.b.set(E,{id:a,provider:I}),(0,P.$Uc)(()=>{this.a.$unregisterEmbeddingProvider(E),this.b.delete(E)})}async computeEmbeddings($,a,I){I??=r.CancellationToken.None;let E=!1;typeof a=="string"&&(a=[a],E=!0);const l=await this.a.$computeEmbeddings($,a,I);if(l.length!==a.length)throw new Error;if(E){if(l.length!==1)throw new Error;return l[0]}return l}async $provideEmbeddings($,a,I){const E=this.b.get($);if(!E)return[];const l=await E.provider.provideEmbeddings(a,I);return l||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$Dpc=T}),define(ye[330],Se([1,0,3,6]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=void 0;class P{constructor(T){this.b=0,this.a=T.getProxy(h.$uN.MainThreadLabelService)}$registerResourceLabelFormatter(T){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,T),(0,r.$Uc)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.$Upc=P}),define(ye[123],Se([1,0,11,13,2,5,12,6,30,20]),function(ce,e,r,h,P,O,T,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epc=e.$dpc=void 0;let I=class{constructor(l,k,p){this.f=p,this.d=new Map,this.a=k.getProxy(R.$uN.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===r.$g}getMessage(l,k){const{message:p,args:c,comment:m}=k;if(this.c)return(0,h.$ff)(p,c??{});let d=p;m&&m.length>0&&(d+=`/${Array.isArray(m)?m.join(""):m}`);const g=this.d.get(l)?.contents[d];return g||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,h.$ff)(g??p,c??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let k;const p=await this.g(l);if(!p){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const c=await this.a.$fetchBundleContents(p),m=JSON.parse(c);k=l.isBuiltin?m.contents?.bundle:m}catch(c){this.f.error(`Failed to load translations for ${l.identifier.value} from ${p}: ${c.message}`);return}k&&this.d.set(l.identifier.value,{contents:k,uri:p})}async g(l){if(l.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return P.URI.revive(k)}return l.l10n?P.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$dpc=I,e.$dpc=I=Je([Ve(0,$.$eQ),Ve(1,a.$1P),Ve(2,T.$_j)],I),e.$epc=(0,O.$Fi)("IExtHostLocalizationService")}),define(ye[161],Se([1,0,12,6,30,20,2,57]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tqc=void 0;let $=class extends r.$kk{constructor(E,l){super(l.logLevel,l.logsLocation,l.loggers.map(k=>(0,R.$ci)(k))),this.r=E.getProxy(h.$uN.MainThreadLogger)}$setLogLevel(E,l){l?this.setLogLevel(T.URI.revive(l),E):this.setLogLevel(E)}setVisibility(E,l){super.setVisibility(E,l),this.r.$setVisibility(E,l)}s(E,l,k){return new a(this.r,E,l,k)}};e.$tqc=$,e.$tqc=$=Je([Ve(0,O.$1P),Ve(1,P.$eQ)],$);class a extends r.$fk{constructor(E,l,k,p){super(p?.logLevel==="always"),this.r=E,this.s=l,this.m=!1,this.n=[],this.setLevel(k),this.r.$createLogger(l,p).then(()=>{this.u(this.n),this.m=!0})}g(E,l){const k=[[E,l]];this.m?this.u(k):this.n.push(...k)}u(E){this.r.$log(this.s,E)}flush(){this.r.$flush(this.s)}}}),define(ye[124],Se([1,0,6,5,3,20,22]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gpc=e.$fpc=void 0,e.$fpc=(0,h.$Fi)("IExtHostManagedSockets");let R=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(r.$uN.MainThreadManagedSockets)}setFactory(E,l){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(E,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const l=++this.b,k=await this.c.makeConnection(),p=new P.$Vc;return this.d.set(l,new a(l,k,p)),p.add((0,P.$Uc)(()=>this.d.delete(l))),p.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),p.dispose()})),p.add(k.onDidClose(c=>{this.a.$onDidManagedSocketClose(l,c?.stack??c?.message),p.dispose()})),p.add(k.onDidReceiveMessage(c=>this.a.$onDidManagedSocketHaveData(l,T.$Oe.wrap(c)))),l}$remoteSocketWrite(E,l){this.d.get(E)?.actual.send(l.buffer)}$remoteSocketEnd(E){const l=this.d.get(E);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$gpc=R,e.$gpc=R=Je([Ve(0,O.$1P)],R);class ${constructor(E,l){this.socketFactoryId=E,this.makeConnection=l}}class a extends P.$Wc{constructor(E,l,k){super(),this.socketId=E,this.actual=l,this.B(k)}}}),define(ye[331],Se([1,0,6,12,26]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=void 0;function O(R){return R&&R.title}let T=class{constructor($,a){this.b=a,this.a=$.getProxy(r.$uN.MainThreadMessageService)}showMessage($,a,I,E,l){const k={source:{identifier:$.identifier,label:$.displayName||$.name}};let p;typeof E=="string"||O(E)?p=[E,...l]:(k.modal=E?.modal,k.useCustom=E?.useCustom,k.detail=E?.detail,p=l),k.useCustom&&(0,P.$7G)($,"resolvers");const c=[];let m=!1;for(let d=0;d<p.length;d++){const g=p[d];if(typeof g=="string")c.push({title:g,handle:d,isCloseAffordance:!1});else if(typeof g=="object"){const{title:n,isCloseAffordance:o}=g;c.push({title:n,isCloseAffordance:!!o,handle:d}),o&&(m?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,g):m=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,g)}return this.a.$showMessage(a,I,k,c).then(d=>{if(typeof d=="number")return p[d]})}};e.$Wpc=T,e.$Wpc=T=Je([Ve(1,h.$_j)],T)}),define(ye[332],Se([1,0,3,18,2,26,6]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=void 0;class R{constructor(a){this.b=new Map,this.a=a.getProxy(T.$uN.MainThreadProfileContentHandlers)}registerProfileContentHandler(a,I,E){if((0,O.$7G)(a,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,E),this.a.$registerProfileContentHandler(I,E.name,E.description,a.identifier.value),(0,r.$Uc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(a,I,E,l){const k=this.b.get(a);if(!k)throw new Error(`Unknown handler with id: ${a}`);return k.saveProfile(I,E,l)}async $readProfile(a,I,E){const l=this.b.get(a);if(!l)throw new Error(`Unknown handler with id: ${a}`);return l.readProfile((0,h.$fg)(I)?I:P.URI.revive(I),E)}}e.$6pc=R}),define(ye[125],Se([1,0,6,4,5]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=e.$apc=void 0;class O{constructor(R){this.b=new h.$me,this.onDidChangePassword=this.b.event,this.a=R.getProxy(r.$uN.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,$){return this.a.$getPassword(R,$)}store(R,$,a){return this.a.$setPassword(R,$,a)}delete(R,$){return this.a.$deletePassword(R,$)}}e.$apc=O,e.$bpc=(0,P.$Fi)("IExtHostSecretState")}),define(ye[333],Se([1,0,21,3,6]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aqc=void 0;class O{static{this.a=1}constructor(R){this.c=new Map,this.d=new Map,this.f=new Map,this.b=R.getProxy(P.$uN.MainThreadSpeech)}async $createSpeechToTextSession(R,$,a){const I=this.c.get(R);if(!I)return;const E=new h.$Vc,l=new r.$xe;this.d.set($,l);const k=await I.provideSpeechToTextSession(l.token,a?{language:a}:void 0);k&&(E.add(k.onDidChange(p=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,p)})),E.add(l.token.onCancellationRequested(()=>E.dispose())))}async $cancelSpeechToTextSession(R){this.d.get(R)?.dispose(!0),this.d.delete(R)}async $createTextToSpeechSession(R,$,a){const I=this.c.get(R);if(!I)return;const E=new h.$Vc,l=new r.$xe;this.d.set($,l);const k=await I.provideTextToSpeechSession(l.token,a?{language:a}:void 0);k&&(this.f.set($,k),E.add(k.onDidChange(p=>{l.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,p)})),E.add(l.token.onCancellationRequested(()=>E.dispose())))}async $synthesizeSpeech(R,$){this.f.get(R)?.synthesize($)}async $cancelTextToSpeechSession(R){this.d.get(R)?.dispose(!0),this.d.delete(R),this.f.delete(R)}async $createKeywordRecognitionSession(R,$){const a=this.c.get(R);if(!a)return;const I=new h.$Vc,E=new r.$xe;this.d.set($,E);const l=await a.provideKeywordRecognitionSession(E.token);l&&(I.add(l.onDidChange(k=>{E.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,k)})),I.add(E.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(R){this.d.get(R)?.dispose(!0),this.d.delete(R)}registerProvider(R,$,a){const I=O.a++;return this.c.set(I,a),this.b.$registerProvider(I,$,{extension:R,displayName:R.value}),(0,h.$Uc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$aqc=O}),define(ye[126],Se([1,0,6,4,5]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4oc=e.$3oc=void 0;class O{constructor(R,$){this.c=$,this.b=new h.$me,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(r.$uN.MainThreadStorage)}registerExtensionStorageKeysToSync(R,$){this.a.$registerExtensionStorageKeysToSync(R,$)}async initializeExtensionStorage(R,$,a){const I=await this.a.$initializeExtensionStorage(R,$);let E;return I&&(E=this.d(R,$,I)),E||a}setValue(R,$,a){return this.a.$setValue(R,$,a)}$acceptValue(R,$,a){const I=this.d(R,$,a);I&&this.b.fire({shared:R,key:$,value:I})}d(R,$,a){try{return JSON.parse(a)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${R}): ${I}`)}}}e.$3oc=O,e.$4oc=(0,P.$Fi)("IExtHostStorage")}),define(ye[334],Se([1,0,3,15,2,6]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mqc=void 0;class T{static{this.a=new Set([h.Schemas.http,h.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(O.$uN.MainThreadUriOpeners)}registerExternalUriOpener($,a,I,E){if(this.c.has(a))throw new Error(`Opener with id '${a}' already registered`);const l=E.schemes.find(k=>!T.a.has(k));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(a,I),this.b.$registerUriOpener(a,E.schemes,$,E.label),(0,r.$Uc)(()=>{this.c.delete(a),this.b.$unregisterUriOpener(a)})}async $canOpenUri($,a,I){const E=this.c.get($);if(!E)throw new Error(`Unknown opener with id: ${$}`);const l=P.URI.revive(a);return E.canOpenExternalUri(l,I)}async $openUri($,a,I){const E=this.c.get($);if(!E)throw new Error(`Unknown opener id: '${$}'`);return E.openExternalUri(P.URI.revive(a.resolvedUri),{sourceUri:P.URI.revive(a.sourceUri)},I)}}e.$mqc=T}),define(ye[335],Se([1,0,6,2,3,14,24]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nqc=void 0;class R{static{this.a=0}constructor(a){this.c=new T.$rn,this.d=new Map,this.b=a.getProxy(r.$uN.MainThreadUrls)}registerUriHandler(a,I){const E=a.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const l=R.a++;return this.c.add(E),this.d.set(l,I),this.b.$registerUriHandler(l,E,a.displayName||a.name),(0,P.$Uc)(()=>{this.c.delete(E),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(a,I){const E=this.d.get(a);if(!E)return Promise.resolve(void 0);try{E.handleUri(h.URI.revive(I))}catch(l){(0,O.$3)(l)}return Promise.resolve(void 0)}async createAppUri(a){return h.URI.revive(await this.b.$createAppUri(a))}}e.$nqc=R}),define(ye[336],Se([1,0,22,6]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vtb=O,e.$wtb=R,h=We(h);class P{constructor(){this.buffers=[]}add(a){let I=this.buffers.indexOf(a);return I<0&&(I=this.buffers.length,this.buffers.push(a)),I}}function O($,a){if(a.serializeBuffersForPostMessage){const I=new P,l=JSON.stringify($,(p,c)=>{if(c instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(c)};if(ArrayBuffer.isView(c)){const m=T(c);if(m)return{$$vscode_array_buffer_reference$$:!0,index:I.add(c.buffer),view:{type:m,byteLength:c.byteLength,byteOffset:c.byteOffset}}}return c}),k=I.buffers.map(p=>{const c=new Uint8Array(p);return r.$Oe.wrap(c)});return{message:l,buffers:k}}else return{message:JSON.stringify($),buffers:[]}}function T($){switch($.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function R($,a){const I=a.map(k=>{const p=new ArrayBuffer(k.byteLength);return new Uint8Array(p).set(k.buffer),p}),E=a.length?(k,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const c=p,{index:m}=c,d=I[m];if(c.view)switch(c.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(d,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(d,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(d,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(d,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(d,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(d,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(d,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(d,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(d,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(d,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(d,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return p}:void 0;return{message:JSON.parse($,E),arrayBuffers:I}}}),define(ye[97],Se([1,0,4,3,15,25,2,285,336,122,6]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Poc=e.$Noc=void 0,e.$Ooc=l,e.$Qoc=c,e.$Roc=m,O=We(O),I=We(I);class E{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(o,t,i,s,f,u,w){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new r.$me,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new r.$me,this._onDidDispose=this.#h.event,this.#e=o,this.#t=t,this.#o=i,this.#n=s,this.#s=f,this.#r=u,this.#u=l(u),this.#d=k(u),this.#i=w}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#l=!0,(0,a.$dDb)(o,this.#n)}get cspSource(){const o=this.#r.extensionLocation;if(o.scheme===P.Schemas.https||o.scheme===P.Schemas.http){let t=o.toString();return t.endsWith("/")||(t+="/"),t+" "+a.$cDb}return a.$cDb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#o}set options(o){this.a(),O.$ho(this.#o,o)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,o)),this.#o=o}async postMessage(o){if(this.#c)return!1;const t=(0,$.$vtb)(o,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const t=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,f,u,w,y,D)=>{const S=T.URI.from({scheme:w||"file",path:decodeURIComponent(y)}),C=(0,a.$dDb)(S,{isRemote:t,authority:i}).toString();return`${f}${C}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,f,u,w,y,D)=>{const S=T.URI.from({scheme:w||"file",path:decodeURIComponent(y)}),C=(0,a.$dDb)(S,{isRemote:t,authority:i}).toString();return`${f}${C}${D}`})}}e.$Noc=E;function l(n){try{const o=(0,R.$Yp)((0,R.$Xp)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}function k(n){try{const o=(0,R.$Yp)((0,R.$Xp)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class p extends h.$Wc{constructor(o,t,i,s,f){super(),this.c=t,this.f=i,this.g=s,this.h=f,this.b=new Map,this.a=o.getProxy(I.$uN.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,t,i){const s=this.j(o);if(s){const{message:f}=(0,$.$wtb)(t,i.value);s._onMessageEmitter.fire(f)}}$onMissingCsp(o,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,t,i){const s=new E(o,this.a,d(t),this.c,this.f,i,this.h);this.b.set(o,s);const f=s._onDidDispose(()=>{f.dispose(),this.deleteWebview(o)});return s}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$Poc=p;function c(n){return{id:n.identifier,location:n.extensionLocation}}function m(n,o,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||g(n,o)}}function d(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>T.URI.from(o))}}function g(n,o){return[...(o?.getWorkspaceFolders()||[]).map(t=>t.uri),n.extensionLocation]}}),define(ye[162],Se([1,0,4,15,13,2,5,20,6]),function(ce,e,r,h,P,O,T,R,$){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$qqc=e.$pqc=void 0;let I=class{static{a=this}static{this.a={focused:!0,active:!0}}getState(){const l=this.d;return{get focused(){return l.focused},get active(){return l.active}}}constructor(l){this.c=new r.$me,this.onDidChangeWindowState=this.c.event,this.d=a.a,this.b=l.getProxy($.$uN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:p})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",p)})}$onDidChangeWindowFocus(l){this.onDidChangeWindowProperty("focused",l)}$onDidChangeWindowActive(l){this.onDidChangeWindowProperty("active",l)}onDidChangeWindowProperty(l,k){k!==this.d[l]&&(this.d={...this.d,[l]:k},this.c.fire(this.d))}openUri(l,k){let p;if(typeof l=="string"){p=l;try{l=O.URI.parse(l)}catch{return Promise.reject(`Invalid uri - '${l}'`)}}return(0,P.$df)(l.scheme)?Promise.reject("Invalid scheme - cannot be empty"):l.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${l.scheme}'`):this.b.$openUri(l,p,k)}async asExternalUri(l,k){if((0,P.$df)(l.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(l,k);return O.URI.from(p)}};e.$pqc=I,e.$pqc=I=a=Je([Ve(0,R.$1P)],I),e.$qqc=(0,T.$Fi)("IExtHostWindow")}),define(ye[337],Se([1,0,327,30,20,94]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0;const T=1024*1024;let R=class extends r.$uqc{constructor(a,I){super(a,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(a,I,E){const l=a==="error"||a==="warn"?process.stderr:process.stdout;this.g=!0,l.write(`
${O.NativeLogMarkers.Start}
`),I.apply(console,E),l.write(`
${O.NativeLogMarkers.End}
`),this.g=!1}j(a,I){const E=process[a],l=E.write;let k="";Object.defineProperty(E,"write",{set:()=>{},get:()=>(p,c,m)=>{if(!this.g){k+=p.toString(c);const d=k.length>T?k.length:k.lastIndexOf(`
`);d!==-1&&(console[I](k.slice(0,d)),k=k.slice(d+1))}l.call(E,p,c,m)}})}};e.$6qc=R,e.$6qc=R=Je([Ve(0,P.$1P),Ve(1,h.$eQ)],R)}),define(ye[338],Se([1,0,161,15,279,32]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=void 0;class T extends r.$tqc{s($,a,I){return $.scheme===h.Schemas.file?new P.$dR(I?.name||(0,O.$2g)(),$.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,a):super.s($,a,I)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$frc=T}),define(ye[339],Se([1,0,9,22,21,27,14,4,3,41,142,325,52]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Qcc=g,e.$Rcc=n,T=We(T);function p(M,N){try{return JSON.stringify(M,N)}catch{return"null"}}const c="$$ref$$",m={[c]:-1};class d{constructor(N,L){this.jsonString=N,this.referencedBuffers=L}}function g(M,N=null,L=!1){const j=[];return{jsonString:(L?p:JSON.stringify)(M,(F,B)=>{if(typeof B>"u")return m;if(typeof B=="object"){if(B instanceof h.$Oe){const _=j.push(B)-1;return{[c]:_}}if(N)return N(F,B)}return B}),referencedBuffers:j}}function n(M,N,L){return JSON.parse(M,(j,z)=>{if(z){const F=z[c];if(typeof F=="number")return N[F];if(L&&z.$mid===a.MarshalledId.Uri)return L.transformIncoming(z)}return z})}function o(M,N){return JSON.stringify(M,N)}function t(M){return M?(N,L)=>L&&L.$mid===a.MarshalledId.Uri?M.transformOutgoing(L):L:null}var i;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(i||(e.RequestInitiator=i={}));var s;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const f=()=>{},u=Symbol.for("rpcProtocol"),w=Symbol.for("rpcProxy");class y extends $.$Wc{static{k=u}static{this.a=3*1e3}constructor(N,L=null,j=null){super(),this[k]=!0,this.b=this.B(new R.$me),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=L,this.g=j,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,F=l.$Qw.count;z<F;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=s.Responsive,this.z=0,this.C=0,this.D=this.B(new r.$Rh(()=>this.H(),1e3)),this.B(this.c.onMessage(z=>this.L(z)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const L=this.w[N];delete this.w[N],L.resolveErr(T.$8())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+y.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+y.a,this.z--,this.z===0&&this.D.cancel(),this.I(s.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(s.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,I.$On)(N,this.g):N}getProxy(N){const{nid:L,sid:j}=N;return this.s[L]||(this.s[L]=this.J(L,j)),this.s[L]}J(N,L){const j={get:(z,F)=>(typeof F=="string"&&!z[F]&&F.charCodeAt(0)===O.CharCode.DollarSign&&(z[F]=(...B)=>this.U(N,F,B)),F===w?L:z[F])};return new Proxy(Object.create(null),j)}set(N,L){return this.m[N.nid]=L,L}assertRegistered(N){for(let L=0,j=N.length;L<j;L++){const z=N[L];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(N){if(this.j)return;const L=N.byteLength,j=S.read(N,0),z=j.readUInt8(),F=j.readUInt32();switch(z){case b.RequestJSONArgs:case b.RequestJSONArgsWithCancellation:{let{rpcId:B,method:_,args:re}=A.deserializeRequestJSONArgs(j);this.g&&(re=(0,I.$On)(re,this.g)),this.M(L,F,B,_,re,z===b.RequestJSONArgsWithCancellation);break}case b.RequestMixedArgs:case b.RequestMixedArgsWithCancellation:{let{rpcId:B,method:_,args:re}=A.deserializeRequestMixedArgs(j);this.g&&(re=(0,I.$On)(re,this.g)),this.M(L,F,B,_,re,z===b.RequestMixedArgsWithCancellation);break}case b.Acknowledged:{this.f?.logIncoming(L,F,i.LocalSide,"ack"),this.G(F);break}case b.Cancel:{this.N(L,F);break}case b.ReplyOKEmpty:{this.O(L,F,void 0);break}case b.ReplyOKJSON:{let B=A.deserializeReplyOKJSON(j);this.g&&(B=(0,I.$On)(B,this.g)),this.O(L,F,B);break}case b.ReplyOKJSONWithBuffers:{const B=A.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(L,F,B);break}case b.ReplyOKVSBuffer:{const B=A.deserializeReplyOKVSBuffer(j);this.O(L,F,B);break}case b.ReplyErrError:{let B=A.deserializeReplyErrError(j);this.g&&(B=(0,I.$On)(B,this.g)),this.P(L,F,B);break}case b.ReplyErrEmpty:{this.P(L,F,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,L,j,z,F,B){this.f?.logIncoming(N,L,i.OtherSide,`receiveRequest ${(0,l.$Sw)(j)}.${z}(`,F);const _=String(L);let re,U;if(B){const Q=new P.$xe;F.push(Q.token),re=this.Q(j,z,F),U=()=>Q.cancel()}else re=this.Q(j,z,F),U=f;this.u[_]=U;const G=A.serializeAcknowledged(L);this.f?.logOutgoing(G.byteLength,L,i.OtherSide,"ack"),this.c.send(G),re.then(Q=>{delete this.u[_];const ee=A.serializeReplyOK(L,Q,this.h);this.f?.logOutgoing(ee.byteLength,L,i.OtherSide,"reply:",Q),this.c.send(ee)},Q=>{delete this.u[_];const ee=A.serializeReplyErr(L,Q);this.f?.logOutgoing(ee.byteLength,L,i.OtherSide,"replyErr:",Q),this.c.send(ee)})}N(N,L){this.f?.logIncoming(N,L,i.OtherSide,"receiveCancel");const j=String(L);this.u[j]?.()}O(N,L,j){this.f?.logIncoming(N,L,i.LocalSide,"receiveReply:",j);const z=String(L);if(!this.w.hasOwnProperty(z))return;const F=this.w[z];delete this.w[z],F.resolveOk(j)}P(N,L,j){this.f?.logIncoming(N,L,i.LocalSide,"receiveReplyErr:",j);const z=String(L);if(!this.w.hasOwnProperty(z))return;const F=this.w[z];delete this.w[z];let B;j&&(j.$isError?(B=new Error,B.name=j.name,B.message=j.message,B.stack=j.stack):B=j),F.resolveErr(B)}Q(N,L,j){try{return Promise.resolve(this.S(N,L,j))}catch(z){return Promise.reject(z)}}S(N,L,j){const z=this.m[N];if(!z)throw new Error("Unknown actor "+(0,l.$Sw)(N));const F=z[L];if(typeof F!="function")throw new Error("Unknown method "+L+" on actor "+(0,l.$Sw)(N));return F.apply(z,j)}U(N,L,j){if(this.j)return new E.$Pcc;let z=null;if(j.length>0&&P.CancellationToken.isCancellationToken(j[j.length-1])&&(z=j.pop()),z&&z.isCancellationRequested)return Promise.reject(T.$8());const F=A.serializeRequestArguments(j,this.h),B=++this.t,_=String(B),re=new E.$Occ,U=new $.$Vc;z&&U.add(z.onCancellationRequested(()=>{const Q=A.serializeCancel(B);this.f?.logOutgoing(Q.byteLength,B,i.LocalSide,"cancel"),this.c.send(A.serializeCancel(B))})),this.w[_]=new D(re,U),this.F(B);const G=A.serializeRequest(B,N,L,F,!!z);return this.f?.logOutgoing(G.byteLength,B,i.LocalSide,`request: ${(0,l.$Sw)(N)}.${L}(`,j),this.c.send(G),re}}e.$Scc=y;class D{constructor(N,L){this.a=N,this.b=L}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class S{static alloc(N,L,j){const z=new S(h.$Oe.alloc(j+1+4),0);return z.writeUInt8(N),z.writeUInt32(L),z}static read(N,L){return new S(N,L)}get buffer(){return this.a}constructor(N,L){this.a=N,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+N);return this.b+=N,L}static sizeMixedArray(N){let L=0;L+=1;for(let j=0,z=N.length;j<z;j++){const F=N[j];switch(L+=1,F.type){case v.String:L+=this.sizeLongString(F.value);break;case v.VSBuffer:L+=this.sizeVSBuffer(F.value);break;case v.SerializedObjectWithBuffers:L+=this.sizeUInt32,L+=this.sizeLongString(F.value);for(let B=0;B<F.buffers.length;++B)L+=this.sizeVSBuffer(F.buffers[B]);break;case v.Undefined:break}}return L}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let L=0,j=N.length;L<j;L++){const z=N[L];switch(z.type){case v.String:this.writeUInt8(v.String),this.writeLongString(z.value);break;case v.VSBuffer:this.writeUInt8(v.VSBuffer),this.writeVSBuffer(z.value);break;case v.SerializedObjectWithBuffers:this.writeUInt8(v.SerializedObjectWithBuffers),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let F=0;F<z.buffers.length;++F)this.writeBuffer(z.buffers[F]);break;case v.Undefined:this.writeUInt8(v.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const L=new Array(N);for(let j=0;j<N;j++)switch(this.readUInt8()){case v.String:L[j]=this.readLongString();break;case v.VSBuffer:L[j]=this.readVSBuffer();break;case v.SerializedObjectWithBuffers:{const F=this.readUInt32(),B=this.readLongString(),_=[];for(let re=0;re<F;++re)_.push(this.readVSBuffer());L[j]=new l.$Tw(n(B,_,null));break}case v.Undefined:L[j]=void 0;break}return L}}var C;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(C||(C={}));class A{static a(N){for(let L=0,j=N.length;L<j;L++)if(N[L]instanceof h.$Oe||N[L]instanceof l.$Tw||typeof N[L]>"u")return!0;return!1}static serializeRequestArguments(N,L){if(this.a(N)){const j=[];for(let z=0,F=N.length;z<F;z++){const B=N[z];if(B instanceof h.$Oe)j[z]={type:v.VSBuffer,value:B};else if(typeof B>"u")j[z]={type:v.Undefined};else if(B instanceof l.$Tw){const{jsonString:_,referencedBuffers:re}=g(B.value,L);j[z]={type:v.SerializedObjectWithBuffers,value:h.$Oe.fromString(_),buffers:re}}else j[z]={type:v.String,value:h.$Oe.fromString(o(B,L))}}return{type:C.Mixed,args:j}}return{type:C.Simple,args:o(N,L)}}static serializeRequest(N,L,j,z,F){switch(z.type){case C.Simple:return this.b(N,L,j,z.args,F);case C.Mixed:return this.c(N,L,j,z.args,F)}}static b(N,L,j,z,F){const B=h.$Oe.fromString(j),_=h.$Oe.fromString(z);let re=0;re+=S.sizeUInt8(),re+=S.sizeShortString(B),re+=S.sizeLongString(_);const U=S.alloc(F?b.RequestJSONArgsWithCancellation:b.RequestJSONArgs,N,re);return U.writeUInt8(L),U.writeShortString(B),U.writeLongString(_),U.buffer}static deserializeRequestJSONArgs(N){const L=N.readUInt8(),j=N.readShortString(),z=N.readLongString();return{rpcId:L,method:j,args:JSON.parse(z)}}static c(N,L,j,z,F){const B=h.$Oe.fromString(j);let _=0;_+=S.sizeUInt8(),_+=S.sizeShortString(B),_+=S.sizeMixedArray(z);const re=S.alloc(F?b.RequestMixedArgsWithCancellation:b.RequestMixedArgs,N,_);return re.writeUInt8(L),re.writeShortString(B),re.writeMixedArray(z),re.buffer}static deserializeRequestMixedArgs(N){const L=N.readUInt8(),j=N.readShortString(),z=N.readMixedArray(),F=new Array(z.length);for(let B=0,_=z.length;B<_;B++){const re=z[B];typeof re=="string"?F[B]=JSON.parse(re):F[B]=re}return{rpcId:L,method:j,args:F}}static serializeAcknowledged(N){return S.alloc(b.Acknowledged,N,0).buffer}static serializeCancel(N){return S.alloc(b.Cancel,N,0).buffer}static serializeReplyOK(N,L,j){if(typeof L>"u")return this.d(N);if(L instanceof h.$Oe)return this.e(N,L);if(L instanceof l.$Tw){const{jsonString:z,referencedBuffers:F}=g(L.value,j,!0);return this.g(N,z,F)}else return this.f(N,p(L,j))}static d(N){return S.alloc(b.ReplyOKEmpty,N,0).buffer}static e(N,L){let j=0;j+=S.sizeVSBuffer(L);const z=S.alloc(b.ReplyOKVSBuffer,N,j);return z.writeVSBuffer(L),z.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,L){const j=h.$Oe.fromString(L);let z=0;z+=S.sizeLongString(j);const F=S.alloc(b.ReplyOKJSON,N,z);return F.writeLongString(j),F.buffer}static g(N,L,j){const z=h.$Oe.fromString(L);let F=0;F+=S.sizeUInt32,F+=S.sizeLongString(z);for(const _ of j)F+=S.sizeVSBuffer(_);const B=S.alloc(b.ReplyOKJSONWithBuffers,N,F);B.writeUInt32(j.length),B.writeLongString(z);for(const _ of j)B.writeBuffer(_);return B.buffer}static deserializeReplyOKJSON(N){const L=N.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(N,L){const j=N.readUInt32(),z=N.readLongString(),F=[];for(let B=0;B<j;++B)F.push(N.readVSBuffer());return new l.$Tw(n(z,F,L))}static serializeReplyErr(N,L){const j=L?p(T.$5(L),null):void 0;if(typeof j!="string")return this.h(N);const z=h.$Oe.fromString(j);let F=0;F+=S.sizeLongString(z);const B=S.alloc(b.ReplyErrError,N,F);return B.writeLongString(z),B.buffer}static deserializeReplyErrError(N){const L=N.readLongString();return JSON.parse(L)}static h(N){return S.alloc(b.ReplyErrEmpty,N,0).buffer}}var b;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var v;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(v||(v={}))}),define(ye[340],Se([1,0,22,29,15,89,5]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TK=e.$QK=void 0,e.$RK=I,e.$SK=E,e.$QK=(0,T.$Fi)("notebookDocumentService");const R=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${R.join("")}]+`),a=7;function I(k){if(k.scheme!==P.Schemas.vscodeNotebookCell)return;const p=k.fragment.indexOf("s");if(p<0)return;const c=parseInt(k.fragment.substring(0,p).replace($,""),a),m=(0,r.$8e)(k.fragment.substring(p+1)).toString();if(!isNaN(c))return{handle:c,notebook:k.with({scheme:m,fragment:null})}}function E(k,p){const c=p.toString(a),d=`${c.length<R.length?R[c.length-1]:"z"}${c}s${(0,r.$9e)(r.$Oe.fromString(k.scheme),!0,!0)}`;return k.with({scheme:P.Schemas.vscodeNotebookCell,fragment:d})}class l{constructor(){this.a=new h.$Cc}getNotebook(p){if(p.scheme===P.Schemas.vscodeNotebookCell){const c=I(p);if(c){const m=this.a.get(c.notebook);if(m)return m}}return this.a.get(p)}addNotebookDocument(p){this.a.set(p.uri,p)}removeNotebookDocument(p){this.a.delete(p.uri)}}e.$TK=l,(0,O.$Os)(e.$QK,l,O.InstantiationType.Delayed)}),define(ye[127],Se([1,0,22,39,40,108,15,17,11,36,340]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.$yL=e.CellStatusbarAlignment=e.$xL=e.NotebookEditorPriority=e.$uL=e.$tL=e.$rL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$qL=e.$pL=e.$oL=e.$nL=e.CellKind=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=void 0,e.$sL=s,e.$vL=u,e.$wL=w,e.$zL=S,e.$AL=A,h=We(h),e.$iL="workbench.editor.notebook",e.$jL="workbench.editor.notebookTextDiffEditor",e.$kL="workbench.editor.interactive",e.$lL="workbench.editor.repl",e.$mL="replNotebook.input.execute";var E;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(E||(e.CellKind=E={})),e.$nL=["application/json","application/javascript","text/html","image/svg+xml",O.$8s.latex,O.$8s.markdown,"image/png","image/jpeg",O.$8s.text],e.$oL=[O.$8s.latex,O.$8s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$8s.text],e.$pL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$qL="_notAvailable";var l;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var k;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(k||(e.NotebookCellExecutionState=k={}));var p;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var c;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var d;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(d||(e.NotebookCellsChangeType=d={}));var g;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(g||(e.SelectionStateType=g={}));var n;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(B){B.scheme=T.Schemas.vscodeNotebookCell;function _(he,ne){return(0,I.$SK)(he,ne)}B.generate=_;function re(he){return(0,I.$RK)(he)}B.parse=re;function U(he,ne){return he.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${ne??""},${he.scheme!==T.Schemas.file?he.scheme:""}`})}B.generateCellOutputUri=U;function G(he){if(he.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const ne=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(he.fragment);if(!ne)return;const De=ne[1]&&ne[1]!==""?ne[1]:void 0,$e=ne[2];return{outputId:De,notebook:he.with({scheme:$e||T.Schemas.file,fragment:null})}}B.parseCellOutputUri=G;function Q(he,ne,De){return B.generate(he,ne).with({scheme:De})}B.generateCellPropertyUri=Q;function ee(he,ne){if(he.scheme===ne)return B.parse(he.with({scheme:B.scheme}))}B.parseCellPropertyUri=ee})(o||(e.CellUri=o={}));const t=B=>$.$i?B.replace(/\//g,"\\"):B;class i{constructor(_=[],re=e.$nL){this.e=re,this.d=[...new Set(_)].map(U=>({pattern:U,matches:h.$zk(t(U))}))}sort(_){const re=new Map(P.Iterable.map(_,G=>[G,t(G)]));let U=[];for(const{matches:G}of this.d)for(const[Q,ee]of re)if(G(ee)){U.push(Q),re.delete(Q);break}return re.size&&(U=U.concat([...re.keys()].sort((G,Q)=>this.e.indexOf(G)-this.e.indexOf(Q)))),U}prioritize(_,re){const U=this.f(_);if(U===-1){this.d.unshift({pattern:_,matches:h.$zk(t(_))});return}const G=new Set(re.map(ee=>this.f(ee,U)));G.delete(-1);const Q=Array.from(G).sort();this.d.splice(U+1,0,...Q.map(ee=>this.d[ee]));for(let ee=Q.length-1;ee>=0;ee--)this.d.splice(Q[ee],1)}toArray(){return this.d.map(_=>_.pattern)}f(_,re=this.d.length){const U=t(_);for(let G=0;G<re;G++)if(this.d[G].matches(U))return G;return-1}}e.$rL=i;function s(B,_,re,U=(G,Q)=>G===Q){const G=[];function Q(ne,De,$e){if(De===0&&$e.length===0)return;const K=G[G.length-1];K&&K.start+K.deleteCount===ne?(K.deleteCount+=De,K.toInsert.push(...$e)):G.push({start:ne,deleteCount:De,toInsert:$e})}let ee=0,he=0;for(;;){if(ee===B.length){Q(ee,0,_.slice(he));break}if(he===_.length){Q(ee,B.length-ee,[]);break}const ne=B[ee],De=_[he];if(U(ne,De)){ee+=1,he+=1;continue}re(De)?(Q(ee,1,[]),ee+=1):(Q(ee,0,[De]),he+=1)}return G}e.$tL=new a.$Wj("notebookEditorCursorAtBoundary","none"),e.$uL=new a.$Wj("notebookEditorCursorAtLineBoundary","none");var f;(function(B){B.default="default",B.option="option"})(f||(e.NotebookEditorPriority=f={}));function u(B){const _=B;return!!((typeof _.include=="string"||h.$Ak(_.include))&&(typeof _.exclude=="string"||h.$Ak(_.exclude)))}function w(B,_,re){if(Array.isArray(B.viewType)&&B.viewType.indexOf(_)>=0||B.viewType===_)return!0;if(B.filenamePattern){const U=u(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,G=u(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(h.$yk(U,(0,R.$pc)(re.fsPath).toLowerCase()))return!(G&&h.$yk(G,(0,R.$pc)(re.fsPath).toLowerCase()))}return!1}e.$xL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var y;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class D{static{this.d="notebook/"}static create(_){return`${D.d}${_}`}static parse(_){if(_.startsWith(D.d))return _.substring(D.d.length)}}e.$yL=D;function S(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const C=new TextDecoder;function A(B){const _=[];let re=!1;for(const ee of B)(_.length===0||re)&&(_.push(ee),re=!0);let U=M(_);const G=r.$Oe.concat(_.map(ee=>r.$Oe.wrap(ee))),Q=F(G);return U=U||Q.byteLength!==G.byteLength,{data:Q,didCompression:U}}e.$BL="\x1B[A";const b=e.$BL.split("").map(B=>B.charCodeAt(0)),v=10;function M(B){let _=!1;return B.forEach((re,U)=>{if(U===0||re.length<e.$BL.length)return;const G=B[U-1],Q=re.subarray(0,e.$BL.length);if(Q[0]===b[0]&&Q[1]===b[1]&&Q[2]===b[2]){const ee=G.lastIndexOf(v);if(ee===-1)return;_=!0,B[U-1]=G.subarray(0,ee),B[U]=re.subarray(e.$BL.length)}}),_}function N(B){let _=B;do B=_,_=B.replace(/[^\n]\x08/gm,"");while(_.length<B.length);return B}function L(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const _=B.match(/^(.*)\r+/m)[1];let re=B.match(/\r+(.*)$/m)[1];re=re+_.slice(re.length,_.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,re)}return B}const j=8,z=13;function F(B){return!B.buffer.includes(j)&&!B.buffer.includes(z)?B:r.$Oe.fromString(L(N(C.decode(B.buffer))))}}),define(ye[10],Se([1,0,19,14,86,29,108,13,18,2,32,24,28,72,127]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p){"use strict";var c,m,d,g,n,o,t,i,s,f,u,w,y,D,S,C,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$PP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.LanguageModelChatMessageRole=e.ChatLocation=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$sP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$fP=e.$eP=e.$dP=e.$cP=e.$aP=e.$_O=e.$$O=e.$0O=e.TestRunProfileKind=e.TestResultState=e.$9O=e.$8O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$7O=e.NotebookVariablesRequestKind=e.$6O=e.$5O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$4O=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.ColorThemeKind=e.$XO=e.$WO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$VO=e.$UO=e.DebugConsoleMode=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$OO=e.$NO=e.FileChangeType=e.$MO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$LO=e.$KO=e.$JO=e.$IO=e.InlineCompletionTriggerKind=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$vO=e.ConfigurationTarget=e.$uO=e.$tO=e.$sO=e.$rO=e.DocumentPasteTriggerKind=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$kO=e.ViewBadge=e.ProgressLocation=e.$jO=e.$iO=e.TaskScope=e.ShellQuoting=e.$hO=e.$gO=e.$fO=e.TaskPanelKind=e.TaskRevealKind=e.$eO=e.TerminalLocation=e.$dO=e.$cO=e.$bO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$aO=e.$_N=e.$$N=e.$0N=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$8N=e.$7N=e.$6N=e.$5N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$4N=e.$3N=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.LanguageStatusSeverity=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.CodeActionTriggerKind=e.$QN=e.$PN=e.SymbolTag=e.SymbolKind=e.$ON=e.$NN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.DiagnosticSeverity=e.DiagnosticTag=e.$HN=e.$GN=e.FileEditType=e.$FN=e.$EN=e.$DN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$9N=_e,e.$wO=Di,e.$bP=Ri;function b(Z){return Object.assign(Z,{apply:function(...me){if(me.length===0)return Reflect.construct(Z,[]);{const Te=me.length===1?[]:me[1];return Reflect.construct(Z,Te,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(Z,[]);{const[Te,...Ye]=me;return Reflect.construct(Z,Ye,Te.constructor)}}})}var v;(function(Z){Z[Z.Top=0]="Top",Z[Z.Bottom=1]="Bottom"})(v||(e.TerminalOutputAnchor=v={}));var M;(function(Z){Z[Z.TerminalCommand=0]="TerminalCommand",Z[Z.Opener=1]="Opener",Z[Z.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let N=c=class{static from(...H){let me=H;return new c(function(){if(me){for(const Te of me)Te&&typeof Te.dispose=="function"&&Te.dispose();me=void 0}})}#e;constructor(H){this.#e=H}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$wN=N,e.$wN=N=c=Je([b],N);let L=m=class{static Min(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Te=1;Te<H.length;Te++){const Ye=H[Te];Ye.isBefore(me)&&(me=Ye)}return me}static Max(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Te=1;Te<H.length;Te++){const Ye=H[Te];Ye.isAfter(me)&&(me=Ye)}return me}static isPosition(H){if(!H)return!1;if(H instanceof m)return!0;const{line:me,character:Te}=H;return typeof me=="number"&&typeof Te=="number"}static of(H){if(H instanceof m)return H;if(this.isPosition(H))return new m(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,me){if(H<0)throw(0,h.$9)("line must be non-negative");if(me<0)throw(0,h.$9)("character must be non-negative");this.c=H,this.e=me}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,me=0){if(H===null||me===null)throw(0,h.$9)();let Te;return typeof H>"u"?Te=0:typeof H=="number"?Te=H:(Te=typeof H.lineDelta=="number"?H.lineDelta:0,me=typeof H.characterDelta=="number"?H.characterDelta:0),Te===0&&me===0?this:new m(this.line+Te,this.character+me)}with(H,me=this.character){if(H===null||me===null)throw(0,h.$9)();let Te;return typeof H>"u"?Te=this.line:typeof H=="number"?Te=H:(Te=typeof H.line=="number"?H.line:this.line,me=typeof H.character=="number"?H.character:this.character),Te===this.line&&me===this.character?this:new m(Te,me)}toJSON(){return{line:this.line,character:this.character}}};e.$xN=L,e.$xN=L=m=Je([b],L);let j=d=class{static isRange(H){return H instanceof d?!0:H?L.isPosition(H.start)&&L.isPosition(H.end):!1}static of(H){if(H instanceof d)return H;if(this.isRange(H))return new d(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,me,Te,Ye){let st,$t;if(typeof H=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ye=="number"?(st=new L(H,me),$t=new L(Te,Ye)):L.isPosition(H)&&L.isPosition(me)&&(st=L.of(H),$t=L.of(me)),!st||!$t)throw new Error("Invalid arguments");st.isBefore($t)?(this.c=st,this.e=$t):(this.c=$t,this.e=st)}contains(H){return d.isRange(H)?this.contains(H.start)&&this.contains(H.end):L.isPosition(H)?!(L.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const me=L.Max(H.start,this.c),Te=L.Min(H.end,this.e);if(!me.isAfter(Te))return new d(me,Te)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const me=L.Min(H.start,this.c),Te=L.Max(H.end,this.end);return new d(me,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,me=this.end){if(H===null||me===null)throw(0,h.$9)();let Te;return H?L.isPosition(H)?Te=H:(Te=H.start||this.start,me=H.end||this.end):Te=this.start,Te.isEqual(this.c)&&me.isEqual(this.end)?this:new d(Te,me)}toJSON(){return[this.start,this.end]}};e.$yN=j,e.$yN=j=d=Je([b],j);let z=g=class extends j{static isSelection(H){return H instanceof g?!0:H?j.isRange(H)&&L.isPosition(H.anchor)&&L.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,me,Te,Ye){let st,$t;if(typeof H=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ye=="number"?(st=new L(H,me),$t=new L(Te,Ye)):L.isPosition(H)&&L.isPosition(me)&&(st=L.of(H),$t=L.of(me)),!st||!$t)throw new Error("Invalid arguments");super(st,$t),this.f=st,this.g=$t}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$zN=z,e.$zN=z=g=Je([b],z);const F=Z=>{if(typeof Z!="string"||Z.length===0||!/^[0-9A-Za-z_\-]+$/.test(Z))throw(0,h.$9)("connectionToken")};class B{static isResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.host=="string"&&typeof H.port=="number"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me,Te){if(typeof H!="string"||H.length===0)throw(0,h.$9)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,h.$9)("port");typeof Te<"u"&&F(Te),this.host=H,this.port=Math.round(me),this.connectionToken=Te}}e.$AN=B;class _{static isManagedResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.makeConnection=="function"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me){this.makeConnection=H,this.connectionToken=me,typeof me<"u"&&F(me)}}e.$BN=_;class re extends Error{static NotAvailable(H,me){return new re(H,k.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(H){return new re(H,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,me=k.RemoteAuthorityResolverErrorCode.Unknown,Te){super(H),this._message=H,this._code=me,this._detail=Te,Object.setPrototypeOf(this,re.prototype)}}e.$CN=re;var U;(function(Z){Z[Z.LF=1]="LF",Z[Z.CRLF=2]="CRLF"})(U||(e.EndOfLine=U={}));var G;(function(Z){Z[Z.Replace=1]="Replace",Z[Z.Append=2]="Append",Z[Z.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let Q=n=class{static isTextEdit(H){return H instanceof n?!0:H?j.isRange(H)&&typeof H.newText=="string":!1}static replace(H,me){return new n(H,me)}static insert(H,me){return n.replace(new j(H,H),me)}static delete(H){return n.replace(H,"")}static setEndOfLine(H){const me=new n(new j(new L(0,0),new L(0,0)),"");return me.newEol=H,me}get range(){return this.c}set range(H){if(H&&!j.isRange(H))throw(0,h.$9)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,h.$9)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,h.$9)("newEol");this.f=H}constructor(H,me){this.c=H,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$DN=Q,e.$DN=Q=n=Je([b],Q);let ee=o=class{static isNotebookCellEdit(H){return H instanceof o?!0:H?bt.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,me){return new o(H,me)}static insertCells(H,me){return new o(new bt(H,H),me)}static deleteCells(H){return new o(H,[])}static updateCellMetadata(H,me){const Te=new o(new bt(H,H),[]);return Te.newCellMetadata=me,Te}static updateNotebookMetadata(H){const me=new o(new bt(0,0),[]);return me.newNotebookMetadata=H,me}constructor(H,me){this.range=H,this.newCells=me}};e.$EN=ee,e.$EN=ee=o=Je([b],ee);class he{static isSnippetTextEdit(H){return H instanceof he?!0:H?j.isRange(H.range)&&$e.isSnippetString(H.snippet):!1}static replace(H,me){return new he(H,me)}static insert(H,me){return he.replace(new j(H,H),me)}constructor(H,me){this.range=H,this.snippet=me}}e.$FN=he;var ne;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text",Z[Z.Cell=3]="Cell",Z[Z.CellReplace=5]="CellReplace",Z[Z.Snippet=6]="Snippet"})(ne||(e.FileEditType=ne={}));let De=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,me,Te,Ye){this.c.push({_type:ne.File,from:H,to:me,options:Te,metadata:Ye})}createFile(H,me,Te){this.c.push({_type:ne.File,from:void 0,to:H,options:me,metadata:Te})}deleteFile(H,me,Te){this.c.push({_type:ne.File,from:H,to:void 0,options:me,metadata:Te})}e(H,me,Te){this.c.push({_type:ne.Cell,metadata:Te,uri:H,edit:{editType:p.CellEditType.DocumentMetadata,metadata:me},notebookMetadata:me})}f(H,me,Te,Ye){const st=me.start,$t=me.end;(st!==$t||Te.length>0)&&this.c.push({_type:ne.CellReplace,uri:H,index:st,count:$t-st,cells:Te,metadata:Ye})}g(H,me,Te,Ye){this.c.push({_type:ne.Cell,metadata:Ye,uri:H,edit:{editType:p.CellEditType.Metadata,index:me,metadata:Te}})}replace(H,me,Te,Ye){this.c.push({_type:ne.Text,uri:H,edit:new Q(me,Te),metadata:Ye})}insert(H,me,Te,Ye){this.replace(H,new j(me,me),Te,Ye)}delete(H,me,Te){this.replace(H,me,"",Te)}has(H){return this.c.some(me=>me._type===ne.Text&&me.uri.toString()===H.toString())}set(H,me){if(me)for(const Te of me){if(!Te)continue;let Ye,st;Array.isArray(Te)?(Ye=Te[0],st=Te[1]):Ye=Te,ee.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(H,Ye.range.start,Ye.newCellMetadata,st):Ye.newNotebookMetadata?this.e(H,Ye.newNotebookMetadata,st):this.f(H,Ye.range,Ye.newCells,st):he.isSnippetTextEdit(Ye)?this.c.push({_type:ne.Snippet,uri:H,range:Ye.range,edit:Ye.snippet,metadata:st}):this.c.push({_type:ne.Text,uri:H,edit:Ye,metadata:st})}else{for(let Te=0;Te<this.c.length;Te++){const Ye=this.c[Te];switch(Ye._type){case ne.Text:case ne.Snippet:case ne.Cell:case ne.CellReplace:Ye.uri.toString()===H.toString()&&(this.c[Te]=void 0);break}}(0,r.$Kb)(this.c)}}get(H){const me=[];for(const Te of this.c)Te._type===ne.Text&&Te.uri.toString()===H.toString()&&me.push(Te.edit);return me}entries(){const H=new O.$Cc;for(const me of this.c)if(me._type===ne.Text){let Te=H.get(me.uri);Te||(Te=[me.uri,[]],H.set(me.uri,Te)),Te[1].push(me.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$GN=De,e.$GN=De=Je([b],De);let $e=t=class{static isSnippetString(H){return H instanceof t?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=t.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,me=this.e++){if(typeof H=="function"){const Te=new t;Te.e=this.e,H(Te),this.e=Te.e,H=Te.value}else H=t.c(H);return this.value+="${",this.value+=me,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,me=this.e++){const Te=H.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(H,me){if(typeof me=="function"){const Te=new t;Te.e=this.e,me(Te),this.e=Te.e,me=Te.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$HN=$e,e.$HN=$e=t=Je([b],$e);var K;(function(Z){Z[Z.Unnecessary=1]="Unnecessary",Z[Z.Deprecated=2]="Deprecated"})(K||(e.DiagnosticTag=K={}));var W;(function(Z){Z[Z.Hint=3]="Hint",Z[Z.Information=2]="Information",Z[Z.Warning=1]="Warning",Z[Z.Error=0]="Error"})(W||(e.DiagnosticSeverity=W={}));let se=i=class{static isLocation(H){return H instanceof i?!0:H?j.isRange(H.range)&&a.URI.isUri(H.uri):!1}constructor(H,me){if(this.uri=H,me)if(j.isRange(me))this.range=j.of(me);else if(L.isPosition(me))this.range=new j(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$IN=se,e.$IN=se=i=Je([b],se);let ae=class{static is(H){return H?typeof H.message=="string"&&H.location&&j.isRange(H.location.range)&&a.URI.isUri(H.location.uri):!1}constructor(H,me){this.location=H,this.message=me}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.location.range.isEqual(me.location.range)&&H.location.uri.toString()===me.location.uri.toString()}};e.$JN=ae,e.$JN=ae=Je([b],ae);let te=class{constructor(H,me,Te=W.Error){if(!j.isRange(H))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=H,this.message=me,this.severity=Te}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.severity===me.severity&&H.code===me.code&&H.severity===me.severity&&H.source===me.source&&H.range.isEqual(me.range)&&(0,r.$wb)(H.tags,me.tags)&&(0,r.$wb)(H.relatedInformation,me.relatedInformation,ae.isEqual)}};e.$KN=te,e.$KN=te=Je([b],te);let le=class{constructor(H,me){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=me}};e.$LN=le,e.$LN=le=Je([b],le);let ue=class extends le{constructor(H,me,Te,Ye){super(H,me),this.canIncreaseHover=Te,this.canDecreaseHover=Ye}};e.$MN=ue,e.$MN=ue=Je([b],ue);var X;(function(Z){Z[Z.Increase=0]="Increase",Z[Z.Decrease=1]="Decrease"})(X||(e.HoverVerbosityAction=X={}));var oe;(function(Z){Z[Z.Text=0]="Text",Z[Z.Read=1]="Read",Z[Z.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let pe=class{constructor(H,me=oe.Text){this.range=H,this.kind=me}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$NN=pe,e.$NN=pe=Je([b],pe);let we=class{constructor(H,me){this.uri=H,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(H=>H.toJSON())}}};e.$ON=we,e.$ON=we=Je([b],we);var Fe;(function(Z){Z[Z.File=0]="File",Z[Z.Module=1]="Module",Z[Z.Namespace=2]="Namespace",Z[Z.Package=3]="Package",Z[Z.Class=4]="Class",Z[Z.Method=5]="Method",Z[Z.Property=6]="Property",Z[Z.Field=7]="Field",Z[Z.Constructor=8]="Constructor",Z[Z.Enum=9]="Enum",Z[Z.Interface=10]="Interface",Z[Z.Function=11]="Function",Z[Z.Variable=12]="Variable",Z[Z.Constant=13]="Constant",Z[Z.String=14]="String",Z[Z.Number=15]="Number",Z[Z.Boolean=16]="Boolean",Z[Z.Array=17]="Array",Z[Z.Object=18]="Object",Z[Z.Key=19]="Key",Z[Z.Null=20]="Null",Z[Z.EnumMember=21]="EnumMember",Z[Z.Struct=22]="Struct",Z[Z.Event=23]="Event",Z[Z.Operator=24]="Operator",Z[Z.TypeParameter=25]="TypeParameter"})(Fe||(e.SymbolKind=Fe={}));var Ue;(function(Z){Z[Z.Deprecated=1]="Deprecated"})(Ue||(e.SymbolTag=Ue={}));let ke=s=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,me,Te,Ye,st){this.name=H,this.kind=me,this.containerName=st,typeof Te=="string"&&(this.containerName=Te),Ye instanceof se?this.location=Ye:Te instanceof j&&(this.location=new se(Ye,Te)),s.validate(this)}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};e.$PN=ke,e.$PN=ke=s=Je([b],ke);let Ie=f=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(f.validate)}constructor(H,me,Te,Ye,st){this.name=H,this.detail=me,this.kind=Te,this.range=Ye,this.selectionRange=st,this.children=[],f.validate(this)}};e.$QN=Ie,e.$QN=Ie=f=Je([b],Ie);var Oe;(function(Z){Z[Z.Invoke=1]="Invoke",Z[Z.Automatic=2]="Automatic"})(Oe||(e.CodeActionTriggerKind=Oe={}));let q=class{constructor(H,me){this.title=H,this.kind=me}};e.$RN=q,e.$RN=q=Je([b],q);let V=class{static{u=this}static{this.c="."}constructor(H){this.value=H}append(H){return new u(this.value?this.value+u.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+u.c)}};e.$SN=V,e.$SN=V=u=Je([b],V),V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorMove=V.Refactor.append("move"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll"),V.Notebook=V.Empty.append("notebook");let J=class{constructor(H,me){if(this.range=H,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$TN=J,e.$TN=J=Je([b],J);class x{constructor(H,me,Te,Ye,st,$t){this.kind=H,this.name=me,this.detail=Te,this.uri=Ye,this.range=st,this.selectionRange=$t}}e.$UN=x;class fe{constructor(H,me){this.fromRanges=me,this.from=H}}e.$VN=fe;class be{constructor(H,me){this.fromRanges=me,this.to=H}}e.$WN=be;var Ne;(function(Z){Z[Z.Information=0]="Information",Z[Z.Warning=1]="Warning",Z[Z.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Ge=class{constructor(H,me){this.range=H,this.command=me}get isResolved(){return!!this.command}};e.$XN=Ge,e.$XN=Ge=Je([b],Ge);let Ze=w=class{#e;static isMarkdownString(H){return H instanceof w?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,me=!1){this.#e=new P.$3k(H,{supportThemeIcons:me})}get value(){return this.#e.value}set value(H){this.#e.value=H}get isTrusted(){return this.#e.isTrusted}set isTrusted(H){this.#e.isTrusted=H}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(H){this.#e.supportThemeIcons=H}get supportHtml(){return this.#e.supportHtml}set supportHtml(H){this.#e.supportHtml=H}get baseUri(){return this.#e.baseUri}set baseUri(H){this.#e.baseUri=H}appendText(H){return this.#e.appendText(H),this}appendMarkdown(H){return this.#e.appendMarkdown(H),this}appendCodeblock(H,me){return this.#e.appendCodeblock(me??"",H),this}};e.$YN=Ze,e.$YN=Ze=w=Je([b],Ze);let et=class{constructor(H,me){this.label=H,this.documentation=me}};e.$ZN=et,e.$ZN=et=Je([b],et);let rt=class{constructor(H,me){this.label=H,this.documentation=me,this.parameters=[]}};e.$1N=rt,e.$1N=rt=Je([b],rt);let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$2N=ot,e.$2N=ot=Je([b],ot);var nt;(function(Z){Z[Z.Invoke=1]="Invoke",Z[Z.TriggerCharacter=2]="TriggerCharacter",Z[Z.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var ct;(function(Z){Z[Z.Type=1]="Type",Z[Z.Parameter=2]="Parameter"})(ct||(e.InlayHintKind=ct={}));let mt=class{constructor(H){this.value=H}};e.$3N=mt,e.$3N=mt=Je([b],mt);let ht=class{constructor(H,me,Te){this.position=H,this.label=me,this.kind=Te}};e.$4N=ht,e.$4N=ht=Je([b],ht);var at;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.TriggerCharacter=1]="TriggerCharacter",Z[Z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var Pe;(function(Z){Z[Z.Text=0]="Text",Z[Z.Method=1]="Method",Z[Z.Function=2]="Function",Z[Z.Constructor=3]="Constructor",Z[Z.Field=4]="Field",Z[Z.Variable=5]="Variable",Z[Z.Class=6]="Class",Z[Z.Interface=7]="Interface",Z[Z.Module=8]="Module",Z[Z.Property=9]="Property",Z[Z.Unit=10]="Unit",Z[Z.Value=11]="Value",Z[Z.Enum=12]="Enum",Z[Z.Keyword=13]="Keyword",Z[Z.Snippet=14]="Snippet",Z[Z.Color=15]="Color",Z[Z.File=16]="File",Z[Z.Reference=17]="Reference",Z[Z.Folder=18]="Folder",Z[Z.EnumMember=19]="EnumMember",Z[Z.Constant=20]="Constant",Z[Z.Struct=21]="Struct",Z[Z.Event=22]="Event",Z[Z.Operator=23]="Operator",Z[Z.TypeParameter=24]="TypeParameter",Z[Z.User=25]="User",Z[Z.Issue=26]="Issue"})(Pe||(e.CompletionItemKind=Pe={}));var ze;(function(Z){Z[Z.Deprecated=1]="Deprecated"})(ze||(e.CompletionItemTag=ze={}));let He=class{constructor(H,me){this.label=H,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Pe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$5N=He,e.$5N=He=Je([b],He);let Le=class{constructor(H=[],me=!1){this.items=H,this.isIncomplete=me}};e.$6N=Le,e.$6N=Le=Je([b],Le);let je=class{constructor(H,me,Te){this.insertText=H,this.range=me,this.command=Te}};e.$7N=je,e.$7N=je=Je([b],je);let Y=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.$8N=Y,e.$8N=Y=Je([b],Y);var de;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.Word=1]="Word",Z[Z.Line=2]="Line",Z[Z.Suggest=3]="Suggest"})(de||(e.PartialAcceptTriggerKind=de={}));var Ce;(function(Z){Z[Z.Active=-1]="Active",Z[Z.Beside=-2]="Beside",Z[Z.One=1]="One",Z[Z.Two=2]="Two",Z[Z.Three=3]="Three",Z[Z.Four=4]="Four",Z[Z.Five=5]="Five",Z[Z.Six=6]="Six",Z[Z.Seven=7]="Seven",Z[Z.Eight=8]="Eight",Z[Z.Nine=9]="Nine"})(Ce||(e.ViewColumn=Ce={}));var Xe;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(Xe||(e.StatusBarAlignment=Xe={}));function _e(Z,H){return`${E.$qn.toKey(Z)}.${H}`}var ut;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval"})(ut||(e.TextEditorLineNumbersStyle=ut={}));var gt;(function(Z){Z[Z.Manual=1]="Manual",Z[Z.AfterDelay=2]="AfterDelay",Z[Z.FocusOut=3]="FocusOut"})(gt||(e.TextDocumentSaveReason=gt={}));var kt;(function(Z){Z[Z.Default=0]="Default",Z[Z.InCenter=1]="InCenter",Z[Z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Z[Z.AtTop=3]="AtTop"})(kt||(e.TextEditorRevealType=kt={}));var Nt;(function(Z){Z[Z.Keyboard=1]="Keyboard",Z[Z.Mouse=2]="Mouse",Z[Z.Command=3]="Command"})(Nt||(e.TextEditorSelectionChangeKind=Nt={}));var Bt;(function(Z){Z[Z.Undo=1]="Undo",Z[Z.Redo=2]="Redo"})(Bt||(e.TextDocumentChangeReason=Bt={}));var fi;(function(Z){Z[Z.OpenOpen=0]="OpenOpen",Z[Z.ClosedClosed=1]="ClosedClosed",Z[Z.OpenClosed=2]="OpenClosed",Z[Z.ClosedOpen=3]="ClosedOpen"})(fi||(e.DecorationRangeBehavior=fi={})),function(Z){function H(me){switch(me){case"keyboard":return Z.Keyboard;case"mouse":return Z.Mouse;case"api":return Z.Command}}Z.fromValue=H}(Nt||(e.TextEditorSelectionChangeKind=Nt={}));var it;(function(Z){Z[Z.Other=0]="Other",Z[Z.Comment=1]="Comment",Z[Z.String=2]="String",Z[Z.RegEx=3]="RegEx"})(it||(e.SyntaxTokenType=it={})),function(Z){function H(me){switch(me){case Z.Other:return"other";case Z.Comment:return"comment";case Z.String:return"string";case Z.RegEx:return"regex"}return"other"}Z.toString=H}(it||(e.SyntaxTokenType=it={}));let At=class{constructor(H,me){if(me&&!a.URI.isUri(me))throw(0,h.$9)("target");if(!j.isRange(H)||H.isEmpty)throw(0,h.$9)("range");this.range=H,this.target=me}};e.$0N=At,e.$0N=At=Je([b],At);let Kt=class{constructor(H,me,Te,Ye){this.red=H,this.green=me,this.blue=Te,this.alpha=Ye}};e.$$N=Kt,e.$$N=Kt=Je([b],Kt);let Qt=class{constructor(H,me){if(me&&!(me instanceof Kt))throw(0,h.$9)("color");if(!j.isRange(H)||H.isEmpty)throw(0,h.$9)("range");this.range=H,this.color=me}};e.$_N=Qt,e.$_N=Qt=Je([b],Qt);let pt=class{constructor(H){if(!H||typeof H!="string")throw(0,h.$9)("label");this.label=H}};e.$aO=pt,e.$aO=pt=Je([b],pt);var vt;(function(Z){Z[Z.RGB=0]="RGB",Z[Z.HEX=1]="HEX",Z[Z.HSL=2]="HSL"})(vt||(e.ColorFormat=vt={}));var ii;(function(Z){Z[Z.Error=0]="Error",Z[Z.Warning=1]="Warning",Z[Z.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var xt;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.Shutdown=1]="Shutdown",Z[Z.Process=2]="Process",Z[Z.User=3]="User",Z[Z.Extension=4]="Extension"})(xt||(e.TerminalExitReason=xt={}));var Gt;(function(Z){Z[Z.Low=0]="Low",Z[Z.Medium=1]="Medium",Z[Z.High=2]="High"})(Gt||(e.TerminalShellExecutionCommandLineConfidence=Gt={}));class Et{constructor(H,me,Te){if(this.startIndex=H,this.length=me,this.tooltip=Te,typeof H!="number"||H<0)throw(0,h.$9)("startIndex");if(typeof me!="number"||me<1)throw(0,h.$9)("length");if(Te!==void 0&&typeof Te!="string")throw(0,h.$9)("tooltip")}}e.$bO=Et;class Ft{constructor(H){this.uri=H}}e.$cO=Ft;class ui{constructor(H){this.terminalCommand=H}}e.$dO=ui;var Ht;(function(Z){Z[Z.Panel=1]="Panel",Z[Z.Editor=2]="Editor"})(Ht||(e.TerminalLocation=Ht={}));class xe{constructor(H){if(this.options=H,typeof H!="object")throw(0,h.$9)("options")}}e.$eO=xe;var _t;(function(Z){Z[Z.Always=1]="Always",Z[Z.Silent=2]="Silent",Z[Z.Never=3]="Never"})(_t||(e.TaskRevealKind=_t={}));var ni;(function(Z){Z[Z.Shared=1]="Shared",Z[Z.Dedicated=2]="Dedicated",Z[Z.New=3]="New"})(ni||(e.TaskPanelKind=ni={}));let hi=class{static{y=this}static{this.Clean=new y("clean","Clean")}static{this.Build=new y("build","Build")}static{this.Rebuild=new y("rebuild","Rebuild")}static{this.Test=new y("test","Test")}static from(H){switch(H){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}constructor(H,me){if(this.label=me,typeof H!="string"||typeof me!="string")throw(0,h.$9)("name");this.c=H}get id(){return this.c}};e.$fO=hi,e.$fO=hi=y=Je([b],hi);function It(Z){let H="";for(let me=0;me<Z.length;me++)H+=Z[me].replace(/,/g,",,")+",";return H}let Mt=class{constructor(H,me,Te){if(typeof H!="string")throw(0,h.$9)("process");this.e=[],this.c=H,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Te):this.f=me)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,h.$9)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const me of this.e)H.push(me);return It(H)}};e.$gO=Mt,e.$gO=Mt=Je([b],Mt);let Ot=class{constructor(H,me,Te){if(this.f=[],Array.isArray(me)){if(!H)throw(0,h.$9)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,h.$9)("command");this.e=H,this.f=me,this.g=Te}else{if(typeof H!="string")throw(0,h.$9)("commandLine");this.c=H,this.g=me}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,h.$9)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,h.$9)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)H.push(typeof me=="string"?me:me.value);return It(H)}};e.$hO=Ot,e.$hO=Ot=Je([b],Ot);var Ut;(function(Z){Z[Z.Escape=1]="Escape",Z[Z.Strong=2]="Strong",Z[Z.Weak=3]="Weak"})(Ut||(e.ShellQuoting=Ut={}));var ri;(function(Z){Z[Z.Global=1]="Global",Z[Z.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class ei{constructor(H){this.c=H}computeId(){return"customExecution"+(0,I.$2g)()}set callback(H){this.c=H}get callback(){return this.c}}e.$iO=ei;let si=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(H,me,Te,Ye,st,$t){this.k=!1,this.l=this.definition=H;let yt;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Te,this.execution=Ye,yt=st,this.k=!0):me===ri.Global||me===ri.Workspace?(this.target=me,this.o=this.name=Te,this.w=this.source=Ye,this.execution=st,yt=$t):(this.target=me,this.o=this.name=Te,this.w=this.source=Ye,this.execution=st,yt=$t),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(H){this.j=H}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Mt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof Ot?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof ei?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,I.$2g)()}}get definition(){return this.l}set definition(H){if(H==null)throw(0,h.$9)("Kind can't be undefined or null");this.B(),this.l=H}get scope(){return this.m}set target(H){this.B(),this.m=H}get name(){return this.o}set name(H){if(typeof H!="string")throw(0,h.$9)("name");this.B(),this.o=H}get execution(){return this.q}set execution(H){H===null&&(H=void 0),this.B(),this.q=H;const me=this.l.type;(D.g===me||D.e===me||D.f===me||D.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(H){if(Array.isArray(H))this.B(),this.r=H,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.B(),this.u=H}get source(){return this.w}set source(H){if(typeof H!="string"||H.length===0)throw(0,h.$9)("source must be a string of length > 0");this.B(),this.w=H}get group(){return this.x}set group(H){H===null&&(H=void 0),this.B(),this.x=H}get detail(){return this.A}set detail(H){H===null&&(H=void 0),this.A=H}get presentationOptions(){return this.y}set presentationOptions(H){H==null&&(H=Object.create(null)),this.B(),this.y=H}get runOptions(){return this.z}set runOptions(H){H==null&&(H=Object.create(null)),this.B(),this.z=H}};e.$jO=si,e.$jO=si=D=Je([b],si);var Wt;(function(Z){Z[Z.SourceControl=1]="SourceControl",Z[Z.Window=10]="Window",Z[Z.Notification=15]="Notification"})(Wt||(e.ProgressLocation=Wt={}));var Jt;(function(Z){function H(me){const Te=me;return(0,$.$jg)(Te.value)?Te.tooltip&&!(0,$.$fg)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}Z.isViewBadge=H})(Jt||(e.ViewBadge=Jt={}));let oi=S=class{static isTreeItem(H,me){const Te=H;if(Te.checkboxState!==void 0){const Ye=(0,$.$jg)(Te.checkboxState)?Te.checkboxState:(0,$.$hg)(Te.checkboxState)&&(0,$.$jg)(Te.checkboxState.state)?Te.checkboxState.state:void 0,st=!(0,$.$jg)(Te.checkboxState)&&(0,$.$hg)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==Dt.Checked&&Ye!==Dt.Unchecked||st!==void 0&&!(0,$.$fg)(st))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(H instanceof S)return!0;if(Te.label!==void 0&&!(0,$.$fg)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,$.$fg)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,$.$fg)(Te.iconPath)&&!a.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,$.$fg)(Te.iconPath.id))){const Ye=Te.iconPath;if(!Ye||!(0,$.$fg)(Ye.light)&&!a.URI.isUri(Ye.light)&&!(0,$.$fg)(Ye.dark)&&!a.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,$.$fg)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!a.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,$.$fg)(Te.tooltip)&&!(Te.tooltip instanceof Ze)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<Rt.None&&Te.collapsibleState>Rt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,$.$fg)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(H,me=Rt.None){this.collapsibleState=me,a.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.$kO=oi,e.$kO=oi=S=Je([b],oi);var Rt;(function(Z){Z[Z.None=0]="None",Z[Z.Collapsed=1]="Collapsed",Z[Z.Expanded=2]="Expanded"})(Rt||(e.TreeItemCollapsibleState=Rt={}));var Dt;(function(Z){Z[Z.Unchecked=0]="Unchecked",Z[Z.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let wt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H){this.value=H}};e.$lO=wt,e.$lO=wt=Je([b],wt);class ti extends wt{}e.$mO=ti;class Pt extends ti{#e;constructor(H){super(""),this.#e=H}asFile(){return this.#e}}e.$nO=Pt;class di{constructor(H,me,Te,Ye){this.name=H,this.uri=me,this._itemId=Te,this.c=Ye}data(){return this.c()}}e.$oO=di;let Zt=class{#e=new Map;constructor(H){for(const[me,Te]of H??[]){const Ye=this.#e.get(this.#t(me));Ye?Ye.push(Te):this.#e.set(this.#t(me),[Te])}}get(H){return this.#e.get(this.#t(H))?.[0]}set(H,me){this.#e.set(this.#t(H),[me])}forEach(H,me){for(const[Te,Ye]of this.#e)for(const st of Ye)H.call(me,st,Te,this)}*[Symbol.iterator](){for(const[H,me]of this.#e)for(const Te of me)yield[H,Te]}#t(H){return H.toLowerCase()}};e.$pO=Zt,e.$pO=Zt=Je([b],Zt);let wi=class{constructor(H,me,Te){this.insertText=H,this.title=me,this.kind=Te}};e.$qO=wi,e.$qO=wi=Je([b],wi);var vi;(function(Z){Z[Z.Automatic=0]="Automatic",Z[Z.PasteAs=1]="PasteAs"})(vi||(e.DocumentPasteTriggerKind=vi={}));class gi{static{this.c="."}constructor(H){this.value=H}append(...H){return new gi((this.value?[this.value,...H]:H).join(gi.c))}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+gi.c)}}e.$rO=gi,gi.Empty=new gi("");class qt{constructor(H,me,Te){this.title=me,this.insertText=H,this.kind=Te}}e.$sO=qt;let ai=class{constructor(H,me){this.id=H,this.color=me}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.$tO=ai,e.$tO=ai=Je([b],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Pi=class{constructor(H){this.id=H}};e.$uO=Pi,e.$uO=Pi=Je([b],Pi);var Tt;(function(Z){Z[Z.Global=1]="Global",Z[Z.Workspace=2]="Workspace",Z[Z.WorkspaceFolder=3]="WorkspaceFolder"})(Tt||(e.ConfigurationTarget=Tt={}));let Si=class{get base(){return this.c}set base(H){this.c=H,this.e=a.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,me){if(typeof H!="string"&&(!H||!a.URI.isUri(H)&&!a.URI.isUri(H.uri)))throw(0,h.$9)("base");if(typeof me!="string")throw(0,h.$9)("pattern");typeof H=="string"?this.baseUri=a.URI.file(H):a.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$vO=Si,e.$vO=Si=Je([b],Si);const Ci=new WeakMap;function Di(Z,H){Ci.set(Z,H)}let $i=class{constructor(H,me,Te,Ye,st){this.enabled=typeof H=="boolean"?H:!0,typeof me=="string"&&(this.condition=me),typeof Te=="string"&&(this.hitCondition=Te),typeof Ye=="string"&&(this.logMessage=Ye),typeof st=="string"&&(this.mode=st)}get id(){return this.c||(this.c=Ci.get(this)??(0,I.$2g)()),this.c}};e.$xO=$i,e.$xO=$i=Je([b],$i);let Ai=class extends $i{constructor(H,me,Te,Ye,st,$t){if(super(me,Te,Ye,st,$t),H===null)throw(0,h.$9)("location");this.location=H}};e.$yO=Ai,e.$yO=Ai=Je([b],Ai);let Vt=class extends $i{constructor(H,me,Te,Ye,st,$t){super(me,Te,Ye,st,$t),this.functionName=H}};e.$zO=Vt,e.$zO=Vt=Je([b],Vt);let Ae=class extends $i{constructor(H,me,Te,Ye,st,$t,yt,Yt){if(super(Ye,st,$t,yt,Yt),!me)throw(0,h.$9)("dataId");this.label=H,this.dataId=me,this.canPersist=Te}};e.$AO=Ae,e.$AO=Ae=Je([b],Ae);let Me=class{constructor(H,me,Te){this.command=H,this.args=me||[],this.options=Te}};e.$BO=Me,e.$BO=Me=Je([b],Me);let ve=class{constructor(H,me){this.port=H,this.host=me}};e.$CO=ve,e.$CO=ve=Je([b],ve);let ie=class{constructor(H){this.path=H}};e.$DO=ie,e.$DO=ie=Je([b],ie);let Re=class{constructor(H){this.implementation=H}};e.$EO=Re,e.$EO=Re=Je([b],Re);class Ke{constructor(H,me,Te){this.session=H,this.threadId=me,this.frameId=Te}}e.$FO=Ke;class tt{constructor(H,me){this.session=H,this.threadId=me}}e.$GO=tt;let Qe=class{constructor(H,me){this.range=H,this.expression=me}};e.$HO=Qe,e.$HO=Qe=Je([b],Qe);var ft;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.Automatic=1]="Automatic"})(ft||(e.InlineCompletionTriggerKind=ft={}));let Ct=class{constructor(H,me){this.range=H,this.text=me}};e.$IO=Ct,e.$IO=Ct=Je([b],Ct);let Xt=class{constructor(H,me,Te=!0){this.range=H,this.variableName=me,this.caseSensitiveLookup=Te}};e.$JO=Xt,e.$JO=Xt=Je([b],Xt);let ci=class{constructor(H,me){this.range=H,this.expression=me}};e.$KO=ci,e.$KO=ci=Je([b],ci);let jt=class{constructor(H,me){this.frameId=H,this.stoppedLocation=me}};e.$LO=jt,e.$LO=jt=Je([b],jt);var li;(function(Z){Z[Z.AIGenerated=1]="AIGenerated"})(li||(e.NewSymbolNameTag=li={}));var qi;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.Automatic=1]="Automatic"})(qi||(e.NewSymbolNameTriggerKind=qi={}));class pn{constructor(H,me){this.newSymbolName=H,this.tags=me}}e.$MO=pn;var Fi;(function(Z){Z[Z.Changed=1]="Changed",Z[Z.Created=2]="Created",Z[Z.Deleted=3]="Deleted"})(Fi||(e.FileChangeType=Fi={}));let Ti=C=class extends Error{static FileExists(H){return new C(H,l.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(H){return new C(H,l.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(H){return new C(H,l.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(H){return new C(H,l.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(H){return new C(H,l.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(H){return new C(H,l.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(H,me=l.FileSystemProviderErrorCode.Unknown,Te){super(a.URI.isUri(H)?H.toString(!0):H),this.code=Te?.name??"Unknown",(0,l.$ol)(this,me),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};e.$NO=Ti,e.$NO=Ti=C=Je([b],Ti);let Vi=class{constructor(H,me,Te){this.start=H,this.end=me,this.kind=Te}};e.$OO=Vi,e.$OO=Vi=Je([b],Vi);var xi;(function(Z){Z[Z.Comment=1]="Comment",Z[Z.Imports=2]="Imports",Z[Z.Region=3]="Region"})(xi||(e.FoldingRangeKind=xi={}));var ki;(function(Z){Z[Z.Collapsed=0]="Collapsed",Z[Z.Expanded=1]="Expanded"})(ki||(e.CommentThreadCollapsibleState=ki={}));var _i;(function(Z){Z[Z.Editing=0]="Editing",Z[Z.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var en;(function(Z){Z[Z.Published=0]="Published",Z[Z.Draft=1]="Draft"})(en||(e.CommentState=en={}));var Mi;(function(Z){Z[Z.Unresolved=0]="Unresolved",Z[Z.Resolved=1]="Resolved"})(Mi||(e.CommentThreadState=Mi={}));var tn;(function(Z){Z[Z.Current=0]="Current",Z[Z.Outdated=1]="Outdated"})(tn||(e.CommentThreadApplicability=tn={}));class Gi{constructor(H,me=[]){this.tokenTypes=H,this.tokenModifiers=me}}e.$PO=Gi;function nn(Z){return typeof Z>"u"||(0,$.$gg)(Z)}class Hi{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,H){this.m=!0;for(let me=0,Te=H.tokenTypes.length;me<Te;me++)this.k.set(H.tokenTypes[me],me);for(let me=0,Te=H.tokenModifiers.length;me<Te;me++)this.l.set(H.tokenModifiers[me],me)}}push(H,me,Te,Ye,st){if(typeof H=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ye=="number"&&(typeof st=="number"||typeof st>"u"))return typeof st>"u"&&(st=0),this.q(H,me,Te,Ye,st);if(j.isRange(H)&&typeof me=="string"&&nn(Te))return this.o(H,me,Te);throw(0,h.$9)()}o(H,me,Te){if(!this.m)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Ye=H.start.line,st=H.start.character,$t=H.end.character-H.start.character,yt=this.k.get(me);let Yt=0;if(Te)for(const pi of Te){if(!this.l.has(pi))throw new Error("`tokenModifier` is not in the provided legend");const bi=this.l.get(pi);Yt|=1<<bi>>>0}this.q(Ye,st,$t,yt,Yt)}q(H,me,Te,Ye,st){if(this.f&&(H<this.c||H===this.c&&me<this.e)){this.f=!1;const Yt=this.g.length/5|0;let pi=0,bi=0;for(let yi=0;yi<Yt;yi++){let Ii=this.g[5*yi],Xi=this.g[5*yi+1];Ii===0?(Ii=pi,Xi+=bi):Ii+=pi,this.g[5*yi]=Ii,this.g[5*yi+1]=Xi,pi=Ii,bi=Xi}}let $t=H,yt=me;this.f&&this.j>0&&($t-=this.c,$t===0&&(yt-=this.e)),this.g[this.j++]=$t,this.g[this.j++]=yt,this.g[this.j++]=Te,this.g[this.j++]=Ye,this.g[this.j++]=st,this.c=H,this.e=me}static r(H){const me=[],Te=H.length/5|0;for(let yt=0;yt<Te;yt++)me[yt]=yt;me.sort((yt,Yt)=>{const pi=H[5*yt],bi=H[5*Yt];if(pi===bi){const yi=H[5*yt+1],Ii=H[5*Yt+1];return yi-Ii}return pi-bi});const Ye=new Uint32Array(H.length);let st=0,$t=0;for(let yt=0;yt<Te;yt++){const Yt=5*me[yt],pi=H[Yt+0],bi=H[Yt+1],yi=H[Yt+2],Ii=H[Yt+3],Xi=H[Yt+4],Bn=pi-st,kr=Bn===0?bi-$t:bi,Yi=5*yt;Ye[Yi+0]=Bn,Ye[Yi+1]=kr,Ye[Yi+2]=yi,Ye[Yi+3]=Ii,Ye[Yi+4]=Xi,st=pi,$t=bi}return Ye}build(H){return this.f?new ji(new Uint32Array(this.g),H):new ji(Hi.r(this.g),H)}}e.$QO=Hi;class ji{constructor(H,me){this.resultId=me,this.data=H}}e.$RO=ji;class bn{constructor(H,me,Te){this.start=H,this.deleteCount=me,this.data=Te}}e.$SO=bn;class Li{constructor(H,me){this.resultId=me,this.edits=H}}e.$TO=Li;var rn;(function(Z){Z[Z.Separate=0]="Separate",Z[Z.MergeWithParent=1]="MergeWithParent"})(rn||(e.DebugConsoleMode=rn={}));class wn{constructor(H){this.name=H}}e.$UO=wn;let Zi=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$VO=Zi,e.$VO=Zi=Je([b],Zi);var zi;(function(Z){Z[Z.Separator=-1]="Separator",Z[Z.Default=0]="Default"})(zi||(e.QuickPickItemKind=zi={}));var Ki;(function(Z){Z[Z.Info=1]="Info",Z[Z.Warning=2]="Warning",Z[Z.Error=3]="Error"})(Ki||(e.InputBoxValidationSeverity=Ki={}));var qe;(function(Z){Z[Z.UI=1]="UI",Z[Z.Workspace=2]="Workspace"})(qe||(e.ExtensionKind=qe={}));class Ei{static validate(H){if(typeof H.badge=="string"){let me=(0,R.$Qf)(H.badge,0);if(me<H.badge.length&&(me+=(0,R.$Qf)(H.badge,me)),H.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!ai.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,me,Te){this.badge=H,this.tooltip=me,this.color=Te}}e.$WO=Ei;let Bi=class{constructor(H){this.kind=H}};e.$XO=Bi,e.$XO=Bi=Je([b],Bi);var lt;(function(Z){Z[Z.Light=1]="Light",Z[Z.Dark=2]="Dark",Z[Z.HighContrast=3]="HighContrast",Z[Z.HighContrastLight=4]="HighContrastLight"})(lt||(e.ColorThemeKind=lt={}));class bt{static isNotebookRange(H){return H instanceof bt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,me){if(H<0)throw(0,h.$9)("start must be positive");if(me<0)throw(0,h.$9)("end must be positive");H<=me?(this.c=H,this.e=me):(this.c=me,this.e=H)}with(H){let me=this.c,Te=this.e;return H.start!==void 0&&(me=H.start),H.end!==void 0&&(Te=H.end),me===this.c&&Te===this.e?this:new bt(me,Te)}}e.$YO=bt;class Ui{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(me=>Ui.isNotebookCellData(me))}static isNotebookCellData(H){return!0}constructor(H,me,Te,Ye,st,$t,yt){this.kind=H,this.value=me,this.languageId=Te,this.mime=Ye,this.outputs=st??[],this.metadata=$t,this.executionSummary=yt,Ui.validate(this)}}e.$ZO=Ui;class vn{constructor(H){this.cells=H}}e.$1O=vn;class mi{static isNotebookCellOutputItem(H){return H instanceof mi?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const me={name:H.name,message:H.message,stack:H.stack};return mi.json(me,"application/vnd.code.notebook.error")}static stdout(H){return mi.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return mi.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,me="application/octet-stream"){return new mi(H,me)}static#e=new TextEncoder;static text(H,me=T.$8s.text){const Te=mi.#e.encode(String(H));return new mi(Te,me)}static json(H,me="text/x-json"){const Te=JSON.stringify(H,void 0,"	");return mi.text(Te,me)}constructor(H,me){this.data=H,this.mime=me;const Te=(0,T.$_s)(me,!0);if(!Te)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.$2O=mi;class Wi{static isNotebookCellOutput(H){return H instanceof Wi?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,me=!1){const Te=new Set,Ye=new Set;for(let st=0;st<H.length;st++){const $t=H[st],yt=(0,T.$_s)($t.mime);if(!Te.has(yt)||(0,p.$zL)(yt)){Te.add(yt);continue}Ye.add(st),me&&console.warn(`DUPLICATED mime type '${$t.mime}' will be dropped`)}return Ye.size===0?H:H.filter((st,$t)=>!Ye.has($t))}constructor(H,me,Te){this.items=Wi.ensureUniqueMimeTypes(H,!0),typeof me=="string"?(this.id=me,this.metadata=Te):(this.id=(0,I.$2g)(),this.metadata=me??Te)}}e.$3O=Wi;var Ni;(function(Z){Z[Z.Markup=1]="Markup",Z[Z.Code=2]="Code"})(Ni||(e.NotebookCellKind=Ni={}));var sn;(function(Z){Z[Z.Idle=1]="Idle",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(sn||(e.NotebookCellExecutionState=sn={}));var on;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(on||(e.NotebookCellStatusBarAlignment=on={}));var an;(function(Z){Z[Z.Default=0]="Default",Z[Z.InCenter=1]="InCenter",Z[Z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Z[Z.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class cn{constructor(H,me){this.text=H,this.alignment=me}}e.$4O=cn;var ln;(function(Z){Z[Z.Default=1]="Default",Z[Z.Preferred=2]="Preferred"})(ln||(e.NotebookControllerAffinity=ln={}));var un;(function(Z){Z[Z.Default=1]="Default",Z[Z.Preferred=2]="Preferred",Z[Z.Hidden=-1]="Hidden"})(un||(e.NotebookControllerAffinity2=un={}));class En{constructor(H,me=[]){this.uri=H,this.provides=(0,r.$4b)(me)}}e.$5O=En;class yn{constructor(H){this.label=H}}e.$6O=yn;var hn;(function(Z){Z[Z.Named=1]="Named",Z[Z.Indexed=2]="Indexed"})(hn||(e.NotebookVariablesRequestKind=hn={}));let Qi=class{constructor(H,me){this.label=H,this.timestamp=me}};e.$7O=Qi,e.$7O=Qi=Je([b],Qi);var dn;(function(Z){Z[Z.Production=1]="Production",Z[Z.Development=2]="Development",Z[Z.Test=3]="Test"})(dn||(e.ExtensionMode=dn={}));var fn;(function(Z){Z[Z.Node=1]="Node",Z[Z.Webworker=2]="Webworker"})(fn||(e.ExtensionRuntime=fn={}));var gn;(function(Z){Z[Z.Other=0]="Other",Z[Z.Comment=1]="Comment",Z[Z.String=2]="String",Z[Z.RegEx=3]="RegEx"})(gn||(e.StandardTokenType=gn={}));class Sn{constructor(H,me){this.ranges=H,this.wordPattern=me}}e.$8O=Sn;class Dn{constructor(H){this.c=H}get autoForwardAction(){return this.c}}e.$9O=Dn;var ge;(function(Z){Z[Z.Queued=1]="Queued",Z[Z.Running=2]="Running",Z[Z.Passed=3]="Passed",Z[Z.Failed=4]="Failed",Z[Z.Skipped=5]="Skipped",Z[Z.Errored=6]="Errored"})(ge||(e.TestResultState=ge={}));var Ee;(function(Z){Z[Z.Run=1]="Run",Z[Z.Debug=2]="Debug",Z[Z.Coverage=3]="Coverage"})(Ee||(e.TestRunProfileKind=Ee={}));let Be=class{constructor(H=void 0,me=void 0,Te=void 0,Ye=!1,st=!0){this.include=H,this.exclude=me,this.profile=Te,this.continuous=Ye,this.preserveFocus=st}};e.$0O=Be,e.$0O=Be=Je([b],Be);let dt=A=class{static diff(H,me,Te){const Ye=new A(H);return Ye.expectedOutput=me,Ye.actualOutput=Te,Ye}constructor(H){this.message=H}};e.$$O=dt,e.$$O=dt=A=Je([b],dt);let St=class{constructor(H){this.id=H}};e.$_O=St,e.$_O=St=Je([b],St);class Lt{constructor(H,me){this.covered=H,this.total=me,Ri(this)}}e.$aP=Lt;function Ri(Z){if(Z){if(Z.covered>Z.total)throw new Error(`The total number of covered items (${Z.covered}) cannot be greater than the total (${Z.total})`);if(Z.total<0)throw new Error(`The number of covered items (${Z.total}) cannot be negative`)}}class Ji{static fromDetails(H,me){const Te=new Lt(0,0),Ye=new Lt(0,0),st=new Lt(0,0);for(const yt of me)if("branches"in yt){Te.total+=1,Te.covered+=yt.executed?1:0;for(const Yt of yt.branches)Ye.total+=1,Ye.covered+=Yt.executed?1:0}else st.total+=1,st.covered+=yt.executed?1:0;const $t=new Ji(H,Te,Ye.total>0?Ye:void 0,st.total>0?st:void 0);return $t.detailedCoverage=me,$t}constructor(H,me,Te,Ye,st=[]){this.uri=H,this.statementCoverage=me,this.branchCoverage=Te,this.declarationCoverage=Ye,this.fromTests=st}}e.$cP=Ji;class qn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Te=[]){this.executed=H,this.location=me,this.branches=Te}}e.$dP=qn;class Vn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Te){this.executed=H,this.location=me,this.label=Te}}e.$eP=Vn;class Gn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Te){this.name=H,this.executed=me,this.location=Te}}e.$fP=Gn;var kn;(function(Z){Z[Z.None=0]="None",Z[Z.Option=1]="Option",Z[Z.Default=2]="Default",Z[Z.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var In;(function(Z){Z[Z.Untrusted=0]="Untrusted",Z[Z.Trusted=1]="Trusted",Z[Z.Unspecified=2]="Unspecified"})(In||(e.WorkspaceTrustState=In={}));var Pn;(function(Z){Z[Z.Notify=1]="Notify",Z[Z.OpenBrowser=2]="OpenBrowser",Z[Z.OpenPreview=3]="OpenPreview",Z[Z.Silent=4]="Silent",Z[Z.Ignore=5]="Ignore",Z[Z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Pn||(e.PortAutoForwardAction=Pn={}));class Hn{constructor(H,me,Te,Ye,st,$t){this.kind=H,this.name=me,this.detail=Te,this.uri=Ye,this.range=st,this.selectionRange=$t}}e.$gP=Hn;class Zn{constructor(H){this.uri=H}}e.$hP=Zn;class Kn{constructor(H,me){this.original=H,this.modified=me}}e.$iP=Kn;class Qn{constructor(H,me,Te,Ye){this.base=H,this.input1=me,this.input2=Te,this.result=Ye}}e.$jP=Qn;class Jn{constructor(H,me){this.uri=H,this.viewType=me}}e.$kP=Jn;class Xn{constructor(H){this.viewType=H}}e.$lP=Xn;class Yn{constructor(H,me){this.uri=H,this.notebookType=me}}e.$mP=Yn;class xn{constructor(H,me,Te){this.original=H,this.modified=me,this.notebookType=Te}}e.$nP=xn;class _n{constructor(){}}e.$oP=_n;class er{constructor(H,me){this.uri=H,this.inputBoxUri=me}}e.$pP=er;class tr{constructor(){}}e.$qP=tr;class ir{constructor(H){this.textDiffs=H}}e.$rP=ir;var Cn;(function(Z){Z[Z.Down=0]="Down",Z[Z.Up=1]="Up"})(Cn||(e.InteractiveSessionVoteDirection=Cn={}));var An;(function(Z){Z[Z.Action=1]="Action",Z[Z.Toolbar=2]="Toolbar"})(An||(e.ChatCopyKind=An={}));var Rn;(function(Z){Z[Z.Short=1]="Short",Z[Z.Medium=2]="Medium",Z[Z.Full=3]="Full"})(Rn||(e.ChatVariableLevel=Rn={}));class nr{constructor(H,me,Te){this.id=H,this.label=me,this.values=Te}}e.$sP=nr;var On;(function(Z){Z[Z.Unhelpful=0]="Unhelpful",Z[Z.Helpful=1]="Helpful",Z[Z.Undone=2]="Undone",Z[Z.Accepted=3]="Accepted",Z[Z.Bug=4]="Bug"})(On||(e.InteractiveEditorResponseFeedbackKind=On={}));var Tn;(function(Z){Z[Z.Unhelpful=0]="Unhelpful",Z[Z.Helpful=1]="Helpful"})(Tn||(e.ChatResultFeedbackKind=Tn={}));class rr{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ze(H):H}}e.$tP=rr;class sr{constructor(H,me){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ze(H):H,this.vulnerabilities=me}}e.$uP=sr;class or{constructor(H,me){this.participant=H,this.command=me}}e.$vP=or;class ar{constructor(H,me,Te){this.title=H,this.message=me,this.data=Te}}e.$wP=ar;class cr{constructor(H,me){this.value=H,this.baseUri=me}}e.$xP=cr;class lr{constructor(H,me){this.value=H,this.title=me}}e.$yP=lr;class ur{constructor(H){this.value=H}}e.$zP=ur;class hr{constructor(H,me){this.value=H,this.task=me}}e.$AP=hr;class dr{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ze(H):H}}e.$BP=dr;class fr{constructor(H){this.value=H}}e.$CP=fr;class gr{constructor(H,me){this.value=H,this.iconPath=me}}e.$DP=gr;class mr{constructor(H,me){this.uri=H,this.edits=Array.isArray(me)?me:[me]}}e.$EP=mr;class $r{constructor(H,me,Te,Ye){this.prompt=H,this.command=me,this.references=Te,this.participant=Ye}}e.$FP=$r;class pr{constructor(H,me,Te,Ye){this.response=H,this.result=me,this.participant=Te,this.command=Ye}}e.$GP=pr;var Ln;(function(Z){Z[Z.Panel=1]="Panel",Z[Z.Terminal=2]="Terminal",Z[Z.Notebook=3]="Notebook",Z[Z.Editor=4]="Editor"})(Ln||(e.ChatLocation=Ln={}));var mn;(function(Z){Z[Z.User=1]="User",Z[Z.Assistant=2]="Assistant",Z[Z.System=3]="System"})(mn||(e.LanguageModelChatMessageRole=mn={}));class br{constructor(H,me,Te){this.name=H,this.content=me,this.isError=Te??!1}}e.$HP=br;class $n{static User(H,me){const Te=new $n(mn.User,typeof H=="string"?H:"",me);return Te.content2=H,Te}static Assistant(H,me){return new $n(mn.Assistant,H,me)}constructor(H,me,Te){this.role=H,this.content=me,this.content2=me,this.name=Te}}e.$IP=$n;class wr{constructor(H,me){this.name=H,this.parameters=me}}e.$JP=wr;class vr{constructor(H){this.value=H}}e.$KP=vr;class Er{constructor(H){this.content=H}}e.$LP=Er;class yr{constructor(H,me){this.content=H,this.name=me}}e.$MP=yr;class Sr{constructor(H,me){this.content=H,this.name=me}}e.$NP=Sr;class Oi extends Error{static NotFound(H){return new Oi(H,Oi.NotFound.name)}static NoPermissions(H){return new Oi(H,Oi.NoPermissions.name)}static Blocked(H){return new Oi(H,Oi.Blocked.name)}constructor(H,me,Te){super(H,{cause:Te}),this.name="LanguageModelError",this.code=me??""}}e.$OP=Oi;var Nn;(function(Z){Z[Z.SymbolInformation=1]="SymbolInformation",Z[Z.CommandInformation=2]="CommandInformation",Z[Z.SearchInformation=3]="SearchInformation",Z[Z.SettingInformation=4]="SettingInformation"})(Nn||(e.RelatedInformationType=Nn={}));var Fn;(function(Z){Z[Z.Started=1]="Started",Z[Z.Recognizing=2]="Recognizing",Z[Z.Recognized=3]="Recognized",Z[Z.Stopped=4]="Stopped",Z[Z.Error=5]="Error"})(Fn||(e.SpeechToTextStatus=Fn={}));var Mn;(function(Z){Z[Z.Started=1]="Started",Z[Z.Stopped=2]="Stopped",Z[Z.Error=3]="Error"})(Mn||(e.TextToSpeechStatus=Mn={}));var jn;(function(Z){Z[Z.Recognized=1]="Recognized",Z[Z.Stopped=2]="Stopped"})(jn||(e.KeywordRecognitionStatus=jn={}));class Dr{constructor(H,me){this.text=H,this.range=me}}e.$PP=Dr;var zn;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.Automatic=1]="Automatic"})(zn||(e.InlineEditTriggerKind=zn={}))}),define(ye[341],Se([1,0,6,10]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=void 0;class P{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(r.$uN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,R,$){if(this.a.size===0)throw new Error("No related information providers registered");const a=this.a.get(T);if(!a)throw new Error("related information provider not found");return await a.provideRelatedInformation(R,$)??[]}getRelatedInformation(T,R,$){return this.c.$getAiRelatedInformation(R,$)}registerRelatedInformationProvider(T,R,$){const a=this.b;return this.b++,this.a.set(a,$),this.c.$registerAiRelatedInformationProvider(a,R),new h.$wN(()=>{this.c.$unregisterAiRelatedInformationProvider(a),this.a.delete(a)})}}e.$ioc=P}),define(ye[128],Se([1,0,4,6,10,24,156,5,20]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=e.$toc=void 0,e.$toc=(0,R.$Fi)("IExtHostAuthentication");let a=class{constructor(l){this.b=new Map,this.c=new r.$me,this.onDidChangeSessions=this.c.event,this.d=new I,this.f=new I,this.a=l.getProxy(h.$uN.MainThreadAuthentication)}async getSession(l,k,p,c={}){const m=O.$qn.toKey(l.identifier),d=[...p].sort().join(" ");return await this.d.getOrCreate(`${m} ${k} ${d}`,async()=>{await this.a.$ensureProvider(k);const g=l.displayName||l.name;return this.a.$getSession(k,p,m,g,c)})}async getSessions(l,k,p){const c=O.$qn.toKey(l.identifier),m=[...p].sort().join(" ");return await this.f.getOrCreate(`${c} ${m}`,async()=>{await this.a.$ensureProvider(k);const d=l.displayName||l.name;return this.a.$getSessions(k,p,c,d)})}async getAccounts(l){return await this.a.$ensureProvider(l),await this.a.$getAccounts(l)}async removeSession(l,k){const p=this.b.get(l);return p?p.provider.removeSession(k):this.a.$removeSession(l,k)}registerAuthenticationProvider(l,k,p,c){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:k,provider:p,options:c??{supportsMultipleAccounts:!1}});const m=p.onDidChangeSessions(d=>this.a.$sendDidChangeSessions(l,d));return this.a.$registerAuthenticationProvider(l,k,c?.supportsMultipleAccounts??!1),new P.$wN(()=>{m.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}async $createSession(l,k,p){const c=this.b.get(l);if(c)return await c.provider.createSession(k,p);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $removeSession(l,k){const p=this.b.get(l);if(p)return await p.provider.removeSession(k);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $getSessions(l,k,p){const c=this.b.get(l);if(c)return await c.provider.getSessions(k,p);throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,k){return l.startsWith(T.$wM)||this.c.fire({provider:{id:l,label:k}}),Promise.resolve()}};e.$uoc=a,e.$uoc=a=Je([Ve(0,$.$1P)],a);class I{constructor(){this.a=new Map}getOrCreate(l,k){const p=this.a.get(l);if(p)return p;const c=k().finally(()=>this.a.delete(l));return this.a.set(l,c),c}}}),define(ye[163],Se([1,0,2,6,10,5,20,12,19,13,17,26]),function(ce,e,r,h,P,O,T,R,$,a,I,E){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$zpc=e.$ypc=void 0;let k=class{static{l=this}static{this.c=0}static{this.d=250}constructor(c,m){this.h=m,this.f=new Map,this.g=c.getProxy(h.$uN.MainThreadDecorations)}registerFileDecorationProvider(c,m){const d=l.c++;this.f.set(d,{provider:c,extensionDescription:m}),this.g.$registerDecorationProvider(d,m.identifier.value);const g=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(d,null);return}const o=(0,$.$4b)(n);if(o.length<=l.d){this.g.$onDidChange(d,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,o.length);const t=o.map(f=>({uri:f,rank:(0,a.$jf)(f.path,"/")})),i=(0,$.$Bb)(t,(f,u)=>f.rank-u.rank||(0,a.$zf)(f.uri.path,u.uri.path)),s=[];e:for(const f of i){let u;for(const w of f){const y=(0,I.$oc)(w.uri.path);if(u!==y&&(u=y,s.push(w.uri)>=l.d))break e}}this.g.$onDidChange(d,s)});return new P.$wN(()=>{g?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(c,m,d){if(!this.f.has(c))return Object.create(null);const g=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(c);return await Promise.all(m.map(async t=>{try{const{uri:i,id:s}=t,f=await Promise.resolve(n.provideFileDecoration(r.URI.revive(i),d));if(!f)return;try{P.$WO.validate(f),f.badge&&typeof f.badge!="string"&&(0,E.$7G)(o,"codiconDecoration"),g[s]=[f.propagate,f.tooltip,f.badge,f.color]}catch(u){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${u}`)}}catch(i){this.h.error(i)}})),g}};e.$ypc=k,e.$ypc=k=l=Je([Ve(0,T.$1P),Ve(1,R.$_j)],k),e.$zpc=(0,O.$Fi)("IExtHostDecorations")}),define(ye[342],Se([1,0,14,2,10,6,15,21,13]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=void 0;class a{static{this.a=0}constructor(E,l,k){this.d=l,this.e=k,this.b=new Map,this.c=E.getProxy(O.$uN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,l){if(Object.keys(T.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const k=a.a++;this.b.set(k,l),this.c.$registerTextContentProvider(k,E);let p;if(typeof l.onDidChange=="function"){let c;p=l.onDidChange(async m=>{if(m.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;c&&await c;const d=this.$provideTextDocumentContent(k,m).then(async g=>{if(!g&&typeof g!="string")return;const n=this.d.getDocument(m);if(!n)return;const o=(0,$.$tf)(g);if(!n.equalLines(o))return this.c.$onVirtualDocumentChange(m,g)}).catch(r.$3).finally(()=>{c===d&&(c=void 0)});c=d})}return new P.$wN(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(E,l){const k=this.b.get(E);return k?Promise.resolve(k.provideTextDocumentContent(h.URI.revive(l),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$Bpc=a}),define(ye[164],Se([1,0,66,15,13,198,138,10,19]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=e.$4P=void 0,e.$3P=I;const a=new Map;function I(p,c){c?a.set(p,c):a.delete(p)}function E(p){return a.get(p)}class l extends O.$lw{constructor(c,m,d,g,n,o,t){super(m,d,g,n),this.c=c,this.m=o,this.q=t,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(c){return(0,$.$wb)(this.f,c)}get document(){if(!this.a){const c=this;this.a={get uri(){return c.d},get fileName(){return c.d.fsPath},get isUntitled(){return c.d.scheme===h.Schemas.untitled},get languageId(){return c.m},get version(){return c.h},get isClosed(){return c.b},get isDirty(){return c.q},save(){return c.r()},getText(m){return m?c.s(m):c.getText()},get eol(){return c.g===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return c.f.length},lineAt(m){return c.t(m)},offsetAt(m){return c.u(m)},positionAt(m){return c.v(m)},validateRange(m){return c.w(m)},validatePosition(m){return c.x(m)},getWordRangeAtPosition(m,d){return c.y(m,d)}}}return Object.freeze(this.a)}_acceptLanguageId(c){(0,r.ok)(!this.b),this.m=c}_acceptIsDirty(c){(0,r.ok)(!this.b),this.q=c}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(c){const m=this.w(c);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const d=this.g,g=m.start.line,n=m.end.line,o=[];o.push(this.f[g].substring(m.start.character));for(let t=g+1;t<n;t++)o.push(this.f[t]);return o.push(this.f[n].substring(0,m.end.character)),o.join(d)}t(c){let m;if(c instanceof R.$xN?m=c.line:typeof c=="number"&&(m=c),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new k(m,this.f[m],m===this.f.length-1)}u(c){return c=this.x(c),this.l(),this.j.getPrefixSum(c.line-1)+c.character}v(c){c=Math.floor(c),c=Math.max(0,c),this.l();const m=this.j.getIndexOf(c),d=this.f[m.index].length;return new R.$xN(m.index,Math.min(m.remainder,d))}w(c){if(!(c instanceof R.$yN))throw new Error("Invalid argument");const m=this.x(c.start),d=this.x(c.end);return m===c.start&&d===c.end?c:new R.$yN(m.line,m.character,d.line,d.character)}x(c){if(!(c instanceof R.$xN))throw new Error("Invalid argument");if(this.f.length===0)return c.with(0,0);let{line:m,character:d}=c,g=!1;if(m<0)m=0,d=0,g=!0;else if(m>=this.f.length)m=this.f.length-1,d=this.f[m].length,g=!0;else{const n=this.f[m].length;d<0?(d=0,g=!0):d>n&&(d=n,g=!0)}return g?new R.$xN(m,d):c}y(c,m){const d=this.x(c);if(!m)m=E(this.m);else if((0,P.$sf)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const g=(0,T.$nt)(d.character+1,(0,T.$lt)(m),this.f[d.line],0);if(g)return new R.$yN(d.line,g.startColumn-1,d.line,g.endColumn-1)}}e.$4P=l;class k{constructor(c,m,d){this.a=c,this.b=m,this.c=d}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.$yN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.$yN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$5P=k}),define(ye[343],Se([1,0,6,10]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Epc=void 0;class P{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(r.$uN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,R,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const a=this.a.get(T);if(!a)throw new Error("Embedding vector provider not found");const I=await a.provideEmbeddingVector(R,$);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(T,R,$){const a=this.b;return this.b++,this.a.set(a,$),this.c.$registerAiEmbeddingVectorProvider(R,a),new h.$wN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(a),this.a.delete(a)})}}e.$Epc=P}),define(ye[76],Se([1,0,6,28,10,22,5,20,63,3,9,23,15]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=e.$Joc=void 0,h=We(h);let p=k=class{constructor(m,d){this.b=new Map,this.c=new I.$Oh,this.a=m.getProxy(r.$uN.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(n){try{let o;const t=g.b.get(n.scheme);return t?(await g.a.$ensureActivation(n.scheme),o=await t.impl.stat(n)):o=await g.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===h.FilePermission.Readonly?1:void 0}}catch(o){k.e(o)}},async readDirectory(n){try{const o=g.b.get(n.scheme);return o?(await g.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await g.a.$readdir(n)}catch(o){return k.e(o)}},async createDirectory(n){try{const o=g.b.get(n.scheme);return o&&!o.isReadonly?(await g.a.$ensureActivation(n.scheme),await g.d(o.impl,o.extUri,n)):await g.a.$mkdir(n)}catch(o){return k.e(o)}},async readFile(n){try{const o=g.b.get(n.scheme);return o?(await g.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await g.a.$readFile(n)).buffer}catch(o){return k.e(o)}},async writeFile(n,o){try{const t=g.b.get(n.scheme);return t&&!t.isReadonly?(await g.a.$ensureActivation(n.scheme),await g.d(t.impl,t.extUri,t.extUri.dirname(n)),await g.c.queueFor(n,()=>Promise.resolve(t.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await g.a.$writeFile(n,O.$Oe.wrap(o))}catch(t){return k.e(t)}},async delete(n,o){try{const t=g.b.get(n.scheme);return t&&!t.isReadonly&&!o?.useTrash?(await g.a.$ensureActivation(n.scheme),await t.impl.delete(n,{recursive:!1,...o})):await g.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(t){return k.e(t)}},async rename(n,o,t){try{return await g.a.$rename(n,o,{overwrite:!1,...t})}catch(i){return k.e(i)}},async copy(n,o,t){try{return await g.a.$copy(n,o,{overwrite:!1,...t})}catch(i){return k.e(i)}},isWritableFileSystem(n){const o=d.getCapabilities(n);if(typeof o=="number")return!(o&h.FileSystemProviderCapabilities.Readonly)}})}async d(m,d,g){const n=[];for(;!d.isEqual(g,d.dirname(g));)try{if(!((await m.stat(g)).type&h.FileType.Directory))throw P.$NO.FileExists(`Unable to create folder '${g.scheme===l.Schemas.file?g.fsPath:g.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(h.$pl(o)!==h.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(d.basename(g)),g=d.dirname(g)}for(let o=n.length-1;o>=0;o--){g=d.joinPath(g,n[o]);try{await m.createDirectory(g)}catch(t){if(h.$pl(t)!==h.FileSystemProviderErrorCode.FileExists)throw t}}}static e(m){if(m instanceof P.$NO)throw m;if(m instanceof h.$ll)switch(m.code){case h.FileSystemProviderErrorCode.FileExists:throw P.$NO.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw P.$NO.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw P.$NO.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw P.$NO.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw P.$NO.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw P.$NO.Unavailable(m.message);default:throw new P.$NO(m.message,m.name)}if(!(m instanceof Error))throw new P.$NO(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw P.$NO.Unavailable(m.message);switch(m.name){case h.FileSystemProviderErrorCode.FileExists:throw P.$NO.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw P.$NO.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw P.$NO.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw P.$NO.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw P.$NO.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw P.$NO.Unavailable(m.message);default:throw new P.$NO(m.message,m.name)}}addFileSystemProvider(m,d,g){return this.b.set(m,{impl:d,extUri:g?.isCaseSensitive?E.$9g:E.$$g,isReadonly:!!g?.isReadonly}),(0,a.$Uc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??E.$9g}};e.$Joc=p,e.$Joc=p=k=Je([Ve(0,R.$1P),Ve(1,$.$noc)],p),e.$Koc=(0,T.$Fi)("IExtHostConsumerFileSystem")}),define(ye[98],Se([1,0,5,30,12,76,2]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=e.$Loc=void 0,e.$Loc=(0,r.$Fi)("IExtensionStoragePaths");let R=class{constructor(a,I,E){this.d=I,this.f=E,this.a=a.workspace??void 0,this.b=a.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(a){return T.URI.joinPath(this.b.workspaceStorageHome,a)}async h(){if(!this.a)return Promise.resolve(void 0);const a=this.a.id,I=await this.g(a);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(T.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:T.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(a){if(this.c)return T.URI.joinPath(this.c,a.identifier.value)}globalValue(a){return T.URI.joinPath(this.b.globalStorageHome,a.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Moc=R,e.$Moc=R=Je([Ve(0,h.$eQ),Ve(1,P.$_j),Ve(2,O.$Koc)],R)}),define(ye[344],Se([1,0,10,20,4]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iqc=void 0;let O=class{constructor(R){this.a=new r.$XO(r.ColorThemeKind.Dark),this.b=new P.$me}get activeColorTheme(){return this.a}$onColorThemeChange(R){let $;switch(R){case"light":$=r.ColorThemeKind.Light;break;case"hcDark":$=r.ColorThemeKind.HighContrast;break;case"hcLight":$=r.ColorThemeKind.HighContrastLight;break;default:$=r.ColorThemeKind.Dark}this.a=new r.$XO($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$iqc=O,e.$iqc=O=Je([Ve(0,h.$1P)],O)}),define(ye[77],Se([1,0,21,4,3,244,5,12,93,6,30,20,10]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YFb=e.$XFb=e.TunnelDtoConverter=void 0,O=We(O),l=We(l);class k extends $.$Kw{}var p;(function(m){function d(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}m.fromApiTunnel=d;function g(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}m.fromServiceTunnel=g})(p||(e.TunnelDtoConverter=p={})),e.$XFb=(0,T.$Fi)("IExtHostTunnelService");let c=class extends P.$Wc{constructor(d,g,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new h.$me,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=d.getProxy(a.$uN.MainThreadTunnelService)}async openTunnel(d,g){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${g.remoteAddress.host}:${g.remoteAddress.port}.`);const n=await this.a.$openTunnel(g,d.displayName);if(n){const o=new k(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(d,g){d.portRange===void 0&&d.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:d,provider:g}),this.a.$registerPortsAttributesProvider(d,n),new l.$wN(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(d,g,n,o,t){const i=[];for(const f of d){const u=this.r.get(f);if(!u)return[];i.push(...await Promise.all(g.map(async w=>{let y;try{y=await u.provider.providePortAttributes({port:w,pid:n,commandLine:o},t)}catch{y=await u.provider.providePortAttributes(w,n,o,t)}return{providedAttributes:y,port:w}})))}const s=i.filter(f=>!!f.providedAttributes);return s.length>0?s.map(f=>({autoForwardAction:f.providedAttributes.autoForwardAction,port:f.port})):[]}async $registerCandidateFinder(d){}registerTunnelProvider(d,g){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,t)=>await d.provideTunnel(o,t,r.CancellationToken.None)??void 0;const n=g.tunnelFeatures?{elevation:!!g.tunnelFeatures?.elevation,privacyOptions:g.tunnelFeatures?.privacyOptions,protocol:g.tunnelFeatures.protocol===void 0?!0:g.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,P.$Uc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(d,g){if(d){d.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this.f=d.showCandidatePort,this.a.$setCandidateFilter());const n=d.tunnelFactory??(g?this.w(g):void 0);if(n){this.b=n;let o=d.tunnelFeatures?.privacyOptions??[];d.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const t=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,public:!!d.tunnelFeatures?.public,privacyOptions:o,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,P.$Uc)(()=>{this.b=void 0})}w(d){}async $closeTunnel(d,g){if(this.g.has(d.host)){const n=this.g.get(d.host);n.has(d.port)&&(g&&n.get(d.port).disposeListener.dispose(),await n.get(d.port).tunnel.dispose(),n.delete(d.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(d,g){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(d,g);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(d.remoteAddress.host)||this.g.set(d.remoteAddress.host,new Map);const t=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:o,disposeListener:t}),p.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(d){const g=await Promise.all(d.map(o=>this.f(o.host,o.port,o.detail??""))),n=d.filter((o,t)=>g[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$YFb=c,e.$YFb=c=Je([Ve(0,E.$1P),Ve(1,I.$eQ),Ve(2,R.$_j)],c)}),define(ye[16],Se([1,0,19,22,187,80,86,29,177,57,108,25,182,23,50,18,2,114,31,106,88,55,146,90,155,153,307,322,120,127,74,75,319,10]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o,t,i,s,f,u,w,y,D,S,C,A,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$XP=ee,e.$YP=ne,e.$ZP=De,T=We(T),g=We(g),n=We(n),o=We(o),y=We(y),S=We(S),v=We(v);var M;(function(Ae){function Me(ie){const{selectionStartLineNumber:Re,selectionStartColumn:Ke,positionLineNumber:tt,positionColumn:Qe}=ie,ft=new v.$xN(Re-1,Ke-1),Ct=new v.$xN(tt-1,Qe-1);return new v.$zN(ft,Ct)}Ae.to=Me;function ve(ie){const{anchor:Re,active:Ke}=ie;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Ke.line+1,positionColumn:Ke.character+1}}Ae.from=ve})(M||(e.Selection=M={}));var N;(function(Ae){function Me(ie){if(!ie)return;const{start:Re,end:Ke}=ie;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Ke.line+1,endColumn:Ke.character+1}}Ae.from=Me;function ve(ie){if(!ie)return;const{startLineNumber:Re,startColumn:Ke,endLineNumber:tt,endColumn:Qe}=ie;return new v.$yN(Re-1,Ke-1,tt-1,Qe-1)}Ae.to=ve})(N||(e.Range=N={}));var L;(function(Ae){function Me(ie){return{uri:ie.uri,range:N.from(ie.range)}}Ae.from=Me;function ve(ie){return new v.$IN(m.URI.revive(ie.uri),N.to(ie.range))}Ae.to=ve})(L||(e.Location=L={}));var j;(function(Ae){function Me(ve){switch(ve){case n.StandardTokenType.Comment:return v.StandardTokenType.Comment;case n.StandardTokenType.Other:return v.StandardTokenType.Other;case n.StandardTokenType.RegEx:return v.StandardTokenType.RegEx;case n.StandardTokenType.String:return v.StandardTokenType.String}}Ae.to=Me})(j||(e.TokenType=j={}));var z;(function(Ae){function Me(ie){return new v.$xN(ie.lineNumber-1,ie.column-1)}Ae.to=Me;function ve(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Ae.from=ve})(z||(e.Position=z={}));var F;(function(Ae){function Me(Re,Ke,tt){return(0,r.$Jb)((0,r.$4b)(Re).map(Qe=>ve(Qe,Ke,tt)))}Ae.from=Me;function ve(Re,Ke,tt){if(typeof Re=="string")return{$serialized:!0,language:Re,isBuiltin:tt?.isBuiltin};if(Re)return{$serialized:!0,language:Re.language,scheme:ie(Re.scheme,Ke),pattern:_e.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType,isBuiltin:tt?.isBuiltin}}function ie(Re,Ke){return Ke&&typeof Re=="string"?Ke.transformOutgoingScheme(Re):Re}})(F||(e.DocumentSelector=F={}));var B;(function(Ae){function Me(ie){switch(ie){case v.DiagnosticTag.Unnecessary:return i.MarkerTag.Unnecessary;case v.DiagnosticTag.Deprecated:return i.MarkerTag.Deprecated}}Ae.from=Me;function ve(ie){switch(ie){case i.MarkerTag.Unnecessary:return v.DiagnosticTag.Unnecessary;case i.MarkerTag.Deprecated:return v.DiagnosticTag.Deprecated;default:return}}Ae.to=ve})(B||(e.DiagnosticTag=B={}));var _;(function(Ae){function Me(ie){let Re;return ie.code&&((0,c.$fg)(ie.code)||(0,c.$jg)(ie.code)?Re=String(ie.code):Re={value:String(ie.code.value),target:ie.code.target}),{...N.from(ie.range),message:ie.message,source:ie.source,code:Re,severity:U.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(re.from),tags:Array.isArray(ie.tags)?(0,r.$Jb)(ie.tags.map(B.from)):void 0}}Ae.from=Me;function ve(ie){const Re=new v.$KN(N.to(ie),ie.message,U.to(ie.severity));return Re.source=ie.source,Re.code=(0,c.$fg)(ie.code)?ie.code:ie.code?.value,Re.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(re.to),Re.tags=ie.tags&&(0,r.$Jb)(ie.tags.map(B.to)),Re}Ae.to=ve})(_||(e.Diagnostic=_={}));var re;(function(Ae){function Me(ie){return{...N.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Ae.from=Me;function ve(ie){return new v.$JN(new v.$IN(ie.resource,N.to(ie)),ie.message)}Ae.to=ve})(re||(e.DiagnosticRelatedInformation=re={}));var U;(function(Ae){function Me(ie){switch(ie){case v.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Ae.from=Me;function ve(ie){switch(ie){case i.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}Ae.to=ve})(U||(e.DiagnosticSeverity=U={}));var G;(function(Ae){function Me(ie){return typeof ie=="number"&&ie>=v.ViewColumn.One?ie-1:ie===v.ViewColumn.Beside?b.$pE:b.$oE}Ae.from=Me;function ve(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=ve})(G||(e.ViewColumn=G={}));function Q(Ae){return typeof Ae.range<"u"}function ee(Ae){return Ae.length===0?!0:!!Q(Ae[0])}var he;(function(Ae){function Me(Qe){return Qe.map(Ae.from)}Ae.fromMany=Me;function ve(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function ie(Qe){let ft;if(ve(Qe)){const{language:jt,value:li}=Qe;ft={value:"```"+jt+`
`+li+"\n```\n"}}else v.$YN.isMarkdownString(Qe)?ft={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ft={value:Qe}:ft={value:""};const Ct=Object.create(null);ft.uris=Ct;const Xt=jt=>{try{let li=m.URI.parse(jt,!0);li=li.with({query:Re(li.query,Ct)}),Ct[jt]=li}catch{}return""},ci=new $.marked.Renderer;return ci.link=Xt,ci.image=jt=>typeof jt=="string"?Xt(T.$$k(jt).href):"",(0,$.marked)(ft.value,{renderer:ci}),ft}Ae.from=ie;function Re(Qe,ft){if(!Qe)return Qe;let Ct;try{Ct=(0,a.$bi)(Qe)}catch{}if(!Ct)return Qe;let Xt=!1;return Ct=(0,E.$fo)(Ct,ci=>{if(m.URI.isUri(ci)){const jt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[jt]=ci,Xt=!0,jt}else return}),Xt?JSON.stringify(Ct):Qe}function Ke(Qe){const ft=new v.$YN(Qe.value,Qe.supportThemeIcons);return ft.isTrusted=Qe.isTrusted,ft.supportHtml=Qe.supportHtml,ft.baseUri=Qe.baseUri?m.URI.from(Qe.baseUri):void 0,ft}Ae.to=Ke;function tt(Qe){if(Qe)return typeof Qe=="string"?Qe:Ae.from(Qe)}Ae.fromStrict=tt})(he||(e.MarkdownString=he={}));function ne(Ae){return ee(Ae)?Ae.map(Me=>({range:N.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?he.fromMany(Me.hoverMessage):Me.hoverMessage?he.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ae.map(Me=>({range:N.from(Me)}))}function De(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?m.URI.file(Ae):Ae}var $e;(function(Ae){function Me(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?De(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Ae.from=Me})($e||(e.ThemableDecorationAttachmentRenderOptions=$e={}));var K;(function(Ae){function Me(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?De(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?$e.from(ve.before):void 0,after:ve.after?$e.from(ve.after):void 0}}Ae.from=Me})(K||(e.ThemableDecorationRenderOptions=K={}));var W;(function(Ae){function Me(ve){if(typeof ve>"u")return ve;switch(ve){case v.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case v.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Ae.from=Me})(W||(e.DecorationRangeBehavior=W={}));var se;(function(Ae){function Me(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?W.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?K.from(ve.light):void 0,dark:ve.dark?K.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?De(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?$e.from(ve.before):void 0,after:ve.after?$e.from(ve.after):void 0}}Ae.from=Me})(se||(e.DecorationRenderOptions=se={}));var ae;(function(Ae){function Me(ie){return{text:ie.newText,eol:ie.newEol&&je.from(ie.newEol),range:N.from(ie.range)}}Ae.from=Me;function ve(ie){const Re=new v.$DN(N.to(ie.range),ie.text);return Re.newEol=typeof ie.eol>"u"?void 0:je.to(ie.eol),Re}Ae.to=ve})(ae||(e.TextEdit=ae={}));var te;(function(Ae){function Me(ie,Re){const Ke={edits:[]};if(ie instanceof v.$GN){const tt=new R.$Dc;for(const Qe of ie._allEntries())Qe._type===v.FileEditType.File&&m.URI.isUri(Qe.to)&&Qe.from===void 0&&tt.add(Qe.to);for(const Qe of ie._allEntries())if(Qe._type===v.FileEditType.File){let ft;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ft={type:"base64",value:(0,h.$9e)(h.$Oe.wrap(Qe.options.contents))}:ft={type:"dataTransferItem",id:Qe.options.contents._itemId}),Ke.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ft},metadata:Qe.metadata})}else Qe._type===v.FileEditType.Text?Ke.edits.push({resource:Qe.uri,textEdit:ae.from(Qe.edit),versionId:tt.has(Qe.uri)?void 0:Re?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===v.FileEditType.Snippet?Ke.edits.push({resource:Qe.uri,textEdit:{range:N.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:tt.has(Qe.uri)?void 0:Re?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===v.FileEditType.Cell?Ke.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===v.FileEditType.CellReplace&&Ke.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:S.CellEditType.Replace,index:Qe.index,count:Qe.count,cells:Qe.cells.map(At.from)}})}return Ke}Ae.from=Me;function ve(ie){const Re=new v.$GN,Ke=new R.$Cc;for(const tt of ie.edits)if(tt.textEdit){const Qe=tt,ft=m.URI.revive(Qe.resource),Ct=N.to(Qe.textEdit.range),Xt=Qe.textEdit.text,ci=Qe.textEdit.insertAsSnippet;let jt;ci?jt=v.$FN.replace(Ct,new v.$HN(Xt)):jt=v.$DN.replace(Ct,Xt);const li=Ke.get(ft);li?li.push(jt):Ke.set(ft,[jt])}else Re.renameFile(m.URI.revive(tt.oldResource),m.URI.revive(tt.newResource),tt.options);for(const[tt,Qe]of Ke)Re.set(tt,Qe);return Re}Ae.to=ve})(te||(e.WorkspaceEdit=te={}));var le;(function(Ae){const Me=Object.create(null);Me[v.SymbolKind.File]=o.SymbolKind.File,Me[v.SymbolKind.Module]=o.SymbolKind.Module,Me[v.SymbolKind.Namespace]=o.SymbolKind.Namespace,Me[v.SymbolKind.Package]=o.SymbolKind.Package,Me[v.SymbolKind.Class]=o.SymbolKind.Class,Me[v.SymbolKind.Method]=o.SymbolKind.Method,Me[v.SymbolKind.Property]=o.SymbolKind.Property,Me[v.SymbolKind.Field]=o.SymbolKind.Field,Me[v.SymbolKind.Constructor]=o.SymbolKind.Constructor,Me[v.SymbolKind.Enum]=o.SymbolKind.Enum,Me[v.SymbolKind.Interface]=o.SymbolKind.Interface,Me[v.SymbolKind.Function]=o.SymbolKind.Function,Me[v.SymbolKind.Variable]=o.SymbolKind.Variable,Me[v.SymbolKind.Constant]=o.SymbolKind.Constant,Me[v.SymbolKind.String]=o.SymbolKind.String,Me[v.SymbolKind.Number]=o.SymbolKind.Number,Me[v.SymbolKind.Boolean]=o.SymbolKind.Boolean,Me[v.SymbolKind.Array]=o.SymbolKind.Array,Me[v.SymbolKind.Object]=o.SymbolKind.Object,Me[v.SymbolKind.Key]=o.SymbolKind.Key,Me[v.SymbolKind.Null]=o.SymbolKind.Null,Me[v.SymbolKind.EnumMember]=o.SymbolKind.EnumMember,Me[v.SymbolKind.Struct]=o.SymbolKind.Struct,Me[v.SymbolKind.Event]=o.SymbolKind.Event,Me[v.SymbolKind.Operator]=o.SymbolKind.Operator,Me[v.SymbolKind.TypeParameter]=o.SymbolKind.TypeParameter;function ve(Re){return typeof Me[Re]=="number"?Me[Re]:o.SymbolKind.Property}Ae.from=ve;function ie(Re){for(const Ke in Me)if(Me[Ke]===Re)return Number(Ke);return v.SymbolKind.Property}Ae.to=ie})(le||(e.SymbolKind=le={}));var ue;(function(Ae){function Me(ie){switch(ie){case v.SymbolTag.Deprecated:return o.SymbolTag.Deprecated}}Ae.from=Me;function ve(ie){switch(ie){case o.SymbolTag.Deprecated:return v.SymbolTag.Deprecated}}Ae.to=ve})(ue||(e.SymbolTag=ue={}));var X;(function(Ae){function Me(ie){return{name:ie.name,kind:le.from(ie.kind),tags:ie.tags&&ie.tags.map(ue.from),containerName:ie.containerName,location:Ue.from(ie.location)}}Ae.from=Me;function ve(ie){const Re=new v.$PN(ie.name,le.to(ie.kind),ie.containerName,Ue.to(ie.location));return Re.tags=ie.tags&&ie.tags.map(ue.to),Re}Ae.to=ve})(X||(e.WorkspaceSymbol=X={}));var oe;(function(Ae){function Me(ie){const Re={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),kind:le.from(ie.kind),tags:ie.tags?.map(ue.from)??[]};return ie.children&&(Re.children=ie.children.map(Me)),Re}Ae.from=Me;function ve(ie){const Re=new v.$QN(ie.name,ie.detail,le.to(ie.kind),N.to(ie.range),N.to(ie.selectionRange));return(0,r.$Nb)(ie.tags)&&(Re.tags=ie.tags.map(ue.to)),ie.children&&(Re.children=ie.children.map(ve)),Re}Ae.to=ve})(oe||(e.DocumentSymbol=oe={}));var pe;(function(Ae){function Me(ie){const Re=new v.$UN(le.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Re._sessionId=ie._sessionId,Re._itemId=ie._itemId,Re}Ae.to=Me;function ve(ie,Re,Ke){if(Re=Re??ie._sessionId,Ke=Ke??ie._itemId,Re===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ke,name:ie.name,detail:ie.detail,kind:le.from(ie.kind),uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(ue.from)}}Ae.from=ve})(pe||(e.CallHierarchyItem=pe={}));var we;(function(Ae){function Me(ve){return new v.$VN(pe.to(ve.from),ve.fromRanges.map(ie=>N.to(ie)))}Ae.to=Me})(we||(e.CallHierarchyIncomingCall=we={}));var Fe;(function(Ae){function Me(ve){return new v.$WN(pe.to(ve.to),ve.fromRanges.map(ie=>N.to(ie)))}Ae.to=Me})(Fe||(e.CallHierarchyOutgoingCall=Fe={}));var Ue;(function(Ae){function Me(ie){return{range:ie.range&&N.from(ie.range),uri:ie.uri}}Ae.from=Me;function ve(ie){return new v.$IN(m.URI.revive(ie.uri),N.to(ie.range))}Ae.to=ve})(Ue||(e.location=Ue={}));var ke;(function(Ae){function Me(ie){const Re=ie,Ke=ie;return{originSelectionRange:Re.originSelectionRange?N.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Ke.uri,range:N.from(Re.targetRange?Re.targetRange:Ke.range),targetSelectionRange:Re.targetSelectionRange?N.from(Re.targetSelectionRange):void 0}}Ae.from=Me;function ve(ie){return{targetUri:m.URI.revive(ie.uri),targetRange:N.to(ie.range),targetSelectionRange:ie.targetSelectionRange?N.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?N.to(ie.originSelectionRange):void 0}}Ae.to=ve})(ke||(e.DefinitionLink=ke={}));var Ie;(function(Ae){function Me(ie){return{range:N.from(ie.range),contents:he.fromMany(ie.contents),canIncreaseVerbosity:ie.canIncreaseVerbosity,canDecreaseVerbosity:ie.canDecreaseVerbosity}}Ae.from=Me;function ve(ie){const Re=ie.contents.map(he.to),Ke=N.to(ie.range),tt=ie.canIncreaseVerbosity,Qe=ie.canDecreaseVerbosity;return new v.$MN(Re,Ke,tt,Qe)}Ae.to=ve})(Ie||(e.Hover=Ie={}));var Oe;(function(Ae){function Me(ie){return{range:N.from(ie.range),expression:ie.expression}}Ae.from=Me;function ve(ie){return new v.$HO(N.to(ie.range),ie.expression)}Ae.to=ve})(Oe||(e.EvaluatableExpression=Oe={}));var q;(function(Ae){function Me(ie){if(ie instanceof v.$IO)return{type:"text",range:N.from(ie.range),text:ie.text};if(ie instanceof v.$JO)return{type:"variable",range:N.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof v.$KO)return{type:"expression",range:N.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Me;function ve(ie){switch(ie.type){case"text":return{range:N.to(ie.range),text:ie.text};case"variable":return{range:N.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:N.to(ie.range),expression:ie.expression}}}Ae.to=ve})(q||(e.InlineValue=q={}));var V;(function(Ae){function Me(ie){return{frameId:ie.frameId,stoppedLocation:N.from(ie.stoppedLocation)}}Ae.from=Me;function ve(ie){return new v.$LO(ie.frameId,N.to(ie.stoppedLocation))}Ae.to=ve})(V||(e.InlineValueContext=V={}));var J;(function(Ae){function Me(ie){return{range:N.from(ie.range),kind:ie.kind}}Ae.from=Me;function ve(ie){return new v.$NN(N.to(ie.range),ie.kind)}Ae.to=ve})(J||(e.DocumentHighlight=J={}));var x;(function(Ae){function Me(ie){return{uri:ie.uri,highlights:ie.highlights.map(J.from)}}Ae.from=Me;function ve(ie){return new v.$ON(m.URI.revive(ie.uri),ie.highlights.map(J.to))}Ae.to=ve})(x||(e.MultiDocumentHighlight=x={}));var fe;(function(Ae){function Me(ve){switch(ve){case o.CompletionTriggerKind.TriggerCharacter:return v.CompletionTriggerKind.TriggerCharacter;case o.CompletionTriggerKind.TriggerForIncompleteCompletions:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case o.CompletionTriggerKind.Invoke:default:return v.CompletionTriggerKind.Invoke}}Ae.to=Me})(fe||(e.CompletionTriggerKind=fe={}));var be;(function(Ae){function Me(ve){return{triggerKind:fe.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Ae.to=Me})(be||(e.CompletionContext=be={}));var Ne;(function(Ae){function Me(ie){switch(ie){case v.CompletionItemTag.Deprecated:return o.CompletionItemTag.Deprecated}}Ae.from=Me;function ve(ie){switch(ie){case o.CompletionItemTag.Deprecated:return v.CompletionItemTag.Deprecated}}Ae.to=ve})(Ne||(e.CompletionItemTag=Ne={}));var Ge;(function(Ae){const Me=new Map([[v.CompletionItemKind.Method,o.CompletionItemKind.Method],[v.CompletionItemKind.Function,o.CompletionItemKind.Function],[v.CompletionItemKind.Constructor,o.CompletionItemKind.Constructor],[v.CompletionItemKind.Field,o.CompletionItemKind.Field],[v.CompletionItemKind.Variable,o.CompletionItemKind.Variable],[v.CompletionItemKind.Class,o.CompletionItemKind.Class],[v.CompletionItemKind.Interface,o.CompletionItemKind.Interface],[v.CompletionItemKind.Struct,o.CompletionItemKind.Struct],[v.CompletionItemKind.Module,o.CompletionItemKind.Module],[v.CompletionItemKind.Property,o.CompletionItemKind.Property],[v.CompletionItemKind.Unit,o.CompletionItemKind.Unit],[v.CompletionItemKind.Value,o.CompletionItemKind.Value],[v.CompletionItemKind.Constant,o.CompletionItemKind.Constant],[v.CompletionItemKind.Enum,o.CompletionItemKind.Enum],[v.CompletionItemKind.EnumMember,o.CompletionItemKind.EnumMember],[v.CompletionItemKind.Keyword,o.CompletionItemKind.Keyword],[v.CompletionItemKind.Snippet,o.CompletionItemKind.Snippet],[v.CompletionItemKind.Text,o.CompletionItemKind.Text],[v.CompletionItemKind.Color,o.CompletionItemKind.Color],[v.CompletionItemKind.File,o.CompletionItemKind.File],[v.CompletionItemKind.Reference,o.CompletionItemKind.Reference],[v.CompletionItemKind.Folder,o.CompletionItemKind.Folder],[v.CompletionItemKind.Event,o.CompletionItemKind.Event],[v.CompletionItemKind.Operator,o.CompletionItemKind.Operator],[v.CompletionItemKind.TypeParameter,o.CompletionItemKind.TypeParameter],[v.CompletionItemKind.Issue,o.CompletionItemKind.Issue],[v.CompletionItemKind.User,o.CompletionItemKind.User]]);function ve(Ke){return Me.get(Ke)??o.CompletionItemKind.Property}Ae.from=ve;const ie=new Map([[o.CompletionItemKind.Method,v.CompletionItemKind.Method],[o.CompletionItemKind.Function,v.CompletionItemKind.Function],[o.CompletionItemKind.Constructor,v.CompletionItemKind.Constructor],[o.CompletionItemKind.Field,v.CompletionItemKind.Field],[o.CompletionItemKind.Variable,v.CompletionItemKind.Variable],[o.CompletionItemKind.Class,v.CompletionItemKind.Class],[o.CompletionItemKind.Interface,v.CompletionItemKind.Interface],[o.CompletionItemKind.Struct,v.CompletionItemKind.Struct],[o.CompletionItemKind.Module,v.CompletionItemKind.Module],[o.CompletionItemKind.Property,v.CompletionItemKind.Property],[o.CompletionItemKind.Unit,v.CompletionItemKind.Unit],[o.CompletionItemKind.Value,v.CompletionItemKind.Value],[o.CompletionItemKind.Constant,v.CompletionItemKind.Constant],[o.CompletionItemKind.Enum,v.CompletionItemKind.Enum],[o.CompletionItemKind.EnumMember,v.CompletionItemKind.EnumMember],[o.CompletionItemKind.Keyword,v.CompletionItemKind.Keyword],[o.CompletionItemKind.Snippet,v.CompletionItemKind.Snippet],[o.CompletionItemKind.Text,v.CompletionItemKind.Text],[o.CompletionItemKind.Color,v.CompletionItemKind.Color],[o.CompletionItemKind.File,v.CompletionItemKind.File],[o.CompletionItemKind.Reference,v.CompletionItemKind.Reference],[o.CompletionItemKind.Folder,v.CompletionItemKind.Folder],[o.CompletionItemKind.Event,v.CompletionItemKind.Event],[o.CompletionItemKind.Operator,v.CompletionItemKind.Operator],[o.CompletionItemKind.TypeParameter,v.CompletionItemKind.TypeParameter],[o.CompletionItemKind.User,v.CompletionItemKind.User],[o.CompletionItemKind.Issue,v.CompletionItemKind.Issue]]);function Re(Ke){return ie.get(Ke)??v.CompletionItemKind.Property}Ae.to=Re})(Ge||(e.CompletionItemKind=Ge={}));var Ze;(function(Ae){function Me(ve,ie){const Re=new v.$5N(ve.label);return Re.insertText=ve.insertText,Re.kind=Ge.to(ve.kind),Re.tags=ve.tags?.map(Ne.to),Re.detail=ve.detail,Re.documentation=T.$5k(ve.documentation)?he.to(ve.documentation):ve.documentation,Re.sortText=ve.sortText,Re.filterText=ve.filterText,Re.preselect=ve.preselect,Re.commitCharacters=ve.commitCharacters,g.$Lt.isIRange(ve.range)?Re.range=N.to(ve.range):typeof ve.range=="object"&&(Re.range={inserting:N.to(ve.range.insert),replacing:N.to(ve.range.replace)}),Re.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&o.CompletionItemInsertTextRule.KeepWhitespace),typeof ve.insertTextRules<"u"&&ve.insertTextRules&o.CompletionItemInsertTextRule.InsertAsSnippet?Re.insertText=new v.$HN(ve.insertText):(Re.insertText=ve.insertText,Re.textEdit=Re.range instanceof v.$yN?new v.$DN(Re.range,Re.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Re.additionalTextEdits=ve.additionalTextEdits.map(Ke=>ae.to(Ke))),Re.command=ie&&ve.command?ie.fromInternal(ve.command):void 0,Re}Ae.to=Me})(Ze||(e.CompletionItem=Ze={}));var et;(function(Ae){function Me(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:he.fromStrict(ie.documentation)}}Ae.from=Me;function ve(ie){return{label:ie.label,documentation:T.$5k(ie.documentation)?he.to(ie.documentation):ie.documentation}}Ae.to=ve})(et||(e.ParameterInformation=et={}));var rt;(function(Ae){function Me(ie){return{label:ie.label,documentation:he.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(et.from):[],activeParameter:ie.activeParameter}}Ae.from=Me;function ve(ie){return{label:ie.label,documentation:T.$5k(ie.documentation)?he.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(et.to):[],activeParameter:ie.activeParameter}}Ae.to=ve})(rt||(e.SignatureInformation=rt={}));var ot;(function(Ae){function Me(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.from):[]}}Ae.from=Me;function ve(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.to):[]}}Ae.to=ve})(ot||(e.SignatureHelp=ot={}));var nt;(function(Ae){function Me(ve,ie){const Re=new v.$4N(z.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(ct.to.bind(void 0,ve)),ie.kind&&mt.to(ie.kind));return Re.textEdits=ie.textEdits&&ie.textEdits.map(ae.to),Re.tooltip=T.$5k(ie.tooltip)?he.to(ie.tooltip):ie.tooltip,Re.paddingLeft=ie.paddingLeft,Re.paddingRight=ie.paddingRight,Re}Ae.to=Me})(nt||(e.InlayHint=nt={}));var ct;(function(Ae){function Me(ve,ie){const Re=new v.$3N(ie.label);return Re.tooltip=T.$5k(ie.tooltip)?he.to(ie.tooltip):ie.tooltip,o.Command.is(ie.command)&&(Re.command=ve.fromInternal(ie.command)),ie.location&&(Re.location=Ue.to(ie.location)),Re}Ae.to=Me})(ct||(e.InlayHintLabelPart=ct={}));var mt;(function(Ae){function Me(ie){return ie}Ae.from=Me;function ve(ie){return ie}Ae.to=ve})(mt||(e.InlayHintKind=mt={}));var ht;(function(Ae){function Me(ie){return{range:N.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Ae.from=Me;function ve(ie){let Re;if(ie.url)try{Re=typeof ie.url=="string"?m.URI.parse(ie.url,!0):m.URI.revive(ie.url)}catch{}const Ke=new v.$0N(N.to(ie.range),Re);return Ke.tooltip=ie.tooltip,Ke}Ae.to=ve})(ht||(e.DocumentLink=ht={}));var at;(function(Ae){function Me(ie){const Re=new v.$aO(ie.label);return ie.textEdit&&(Re.textEdit=ae.to(ie.textEdit)),ie.additionalTextEdits&&(Re.additionalTextEdits=ie.additionalTextEdits.map(Ke=>ae.to(Ke))),Re}Ae.to=Me;function ve(ie){return{label:ie.label,textEdit:ie.textEdit?ae.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Re=>ae.from(Re)):void 0}}Ae.from=ve})(at||(e.ColorPresentation=at={}));var Pe;(function(Ae){function Me(ie){return new v.$$N(ie[0],ie[1],ie[2],ie[3])}Ae.to=Me;function ve(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Ae.from=ve})(Pe||(e.Color=Pe={}));var ze;(function(Ae){function Me(ie){return{range:N.from(ie.range)}}Ae.from=Me;function ve(ie){return new v.$TN(N.to(ie.range))}Ae.to=ve})(ze||(e.SelectionRange=ze={}));var He;(function(Ae){function Me(ve){switch(ve){case u.SaveReason.AUTO:return v.TextDocumentSaveReason.AfterDelay;case u.SaveReason.EXPLICIT:return v.TextDocumentSaveReason.Manual;case u.SaveReason.FOCUS_CHANGE:case u.SaveReason.WINDOW_CHANGE:return v.TextDocumentSaveReason.FocusOut}}Ae.to=Me})(He||(e.TextDocumentSaveReason=He={}));var Le;(function(Ae){function Me(ie){switch(ie){case v.TextEditorLineNumbersStyle.Off:return d.RenderLineNumbersType.Off;case v.TextEditorLineNumbersStyle.Relative:return d.RenderLineNumbersType.Relative;case v.TextEditorLineNumbersStyle.Interval:return d.RenderLineNumbersType.Interval;case v.TextEditorLineNumbersStyle.On:default:return d.RenderLineNumbersType.On}}Ae.from=Me;function ve(ie){switch(ie){case d.RenderLineNumbersType.Off:return v.TextEditorLineNumbersStyle.Off;case d.RenderLineNumbersType.Relative:return v.TextEditorLineNumbersStyle.Relative;case d.RenderLineNumbersType.Interval:return v.TextEditorLineNumbersStyle.Interval;case d.RenderLineNumbersType.On:default:return v.TextEditorLineNumbersStyle.On}}Ae.to=ve})(Le||(e.TextEditorLineNumbersStyle=Le={}));var je;(function(Ae){function Me(ie){if(ie===v.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(ie===v.EndOfLine.LF)return t.EndOfLineSequence.LF}Ae.from=Me;function ve(ie){if(ie===t.EndOfLineSequence.CRLF)return v.EndOfLine.CRLF;if(ie===t.EndOfLineSequence.LF)return v.EndOfLine.LF}Ae.to=ve})(je||(e.EndOfLine=je={}));var Y;(function(Ae){function Me(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case v.ProgressLocation.SourceControl:return s.ProgressLocation.Scm;case v.ProgressLocation.Window:return s.ProgressLocation.Window;case v.ProgressLocation.Notification:return s.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Me})(Y||(e.ProgressLocation=Y={}));var de;(function(Ae){function Me(ie){const Re={start:ie.start+1,end:ie.end+1};return ie.kind&&(Re.kind=Ce.from(ie.kind)),Re}Ae.from=Me;function ve(ie){const Re={start:ie.start-1,end:ie.end-1};return ie.kind&&(Re.kind=Ce.to(ie.kind)),Re}Ae.to=ve})(de||(e.FoldingRange=de={}));var Ce;(function(Ae){function Me(ie){if(ie)switch(ie){case v.FoldingRangeKind.Comment:return o.$Lu.Comment;case v.FoldingRangeKind.Imports:return o.$Lu.Imports;case v.FoldingRangeKind.Region:return o.$Lu.Region}}Ae.from=Me;function ve(ie){if(ie)switch(ie.value){case o.$Lu.Comment.value:return v.FoldingRangeKind.Comment;case o.$Lu.Imports.value:return v.FoldingRangeKind.Imports;case o.$Lu.Region.value:return v.FoldingRangeKind.Region}}Ae.to=ve})(Ce||(e.FoldingRangeKind=Ce={}));var Xe;(function(Ae){function Me(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?N.from(ve.selection):void 0,override:typeof ve.override=="boolean"?u.$SF.id:void 0}}Ae.from=Me})(Xe||(e.TextEditorOpenOptions=Xe={}));var _e;(function(Ae){function Me(Ke){return Ke instanceof v.$vO?Ke.toJSON():typeof Ke=="string"?Ke:ve(Ke)||ie(Ke)?new v.$vO(Ke.baseUri??Ke.base,Ke.pattern).toJSON():Ke}Ae.from=Me;function ve(Ke){const tt=Ke;return tt?m.URI.isUri(tt.baseUri)&&typeof tt.pattern=="string":!1}function ie(Ke){const tt=Ke;return tt?typeof tt.base=="string"&&typeof tt.pattern=="string":!1}function Re(Ke){return typeof Ke=="string"?Ke:new v.$vO(m.URI.revive(Ke.baseUri),Ke.pattern)}Ae.to=Re})(_e||(e.GlobPattern=_e={}));var ut;(function(Ae){function Me(ve){if(ve){if(Array.isArray(ve))return ve.map(Me);if(typeof ve=="string")return ve;{const ie=ve;return{language:ie.language,scheme:ie.scheme,pattern:_e.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Ae.from=Me})(ut||(e.LanguageSelector=ut={}));var gt;(function(Ae){function Me(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Re=>Array.isArray(Re)&&Re.every(Ke=>Ke&&typeof Ke=="object"&&"uri"in Ke&&m.URI.isUri(Ke.uri)&&"version"in Ke&&typeof Ke.version=="number"&&"ranges"in Ke&&Array.isArray(Ke.ranges)&&Ke.ranges.every(tt=>tt instanceof v.$yN)))}Ae.is=Me;function ve(ie){return{documents:ie.documents.map(Re=>Re.map(Ke=>({uri:m.URI.from(Ke.uri),version:Ke.version,ranges:Ke.ranges.map(tt=>N.from(tt))})))}}Ae.from=ve})(gt||(e.MappedEditsContext=gt={}));var kt;(function(Ae){function Me(ie){return{start:ie.start,end:ie.end}}Ae.from=Me;function ve(ie){return new v.$YO(ie.start,ie.end)}Ae.to=ve})(kt||(e.NotebookRange=kt={}));var Nt;(function(Ae){function Me(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Ae.to=Me;function ve(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Ae.from=ve})(Nt||(e.NotebookCellExecutionSummary=Nt={}));var Bt;(function(Ae){function Me(ve){if(ve===S.NotebookCellExecutionState.Unconfirmed)return v.NotebookCellExecutionState.Pending;if(ve===S.NotebookCellExecutionState.Pending)return;if(ve===S.NotebookCellExecutionState.Executing)return v.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Ae.to=Me})(Bt||(e.NotebookCellExecutionState=Bt={}));var fi;(function(Ae){function Me(ie){switch(ie){case v.NotebookCellKind.Markup:return S.CellKind.Markup;case v.NotebookCellKind.Code:default:return S.CellKind.Code}}Ae.from=Me;function ve(ie){switch(ie){case S.CellKind.Markup:return v.NotebookCellKind.Markup;case S.CellKind.Code:default:return v.NotebookCellKind.Code}}Ae.to=ve})(fi||(e.NotebookCellKind=fi={}));var it;(function(Ae){function Me(ie){const Re={metadata:ie.metadata??Object.create(null),cells:[]};for(const Ke of ie.cells)v.$ZO.validate(Ke),Re.cells.push(At.from(Ke));return Re}Ae.from=Me;function ve(ie){const Re=new v.$1O(ie.cells.map(At.to));return(0,c.$sg)(ie.metadata)||(Re.metadata=ie.metadata),Re}Ae.to=ve})(it||(e.NotebookData=it={}));var At;(function(Ae){function Me(ie){return{cellKind:fi.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Nt.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(Qt.from):[]}}Ae.from=Me;function ve(ie){return new v.$ZO(fi.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(Qt.to):void 0,ie.metadata,ie.internalMetadata?Nt.to(ie.internalMetadata):void 0)}Ae.to=ve})(At||(e.NotebookCellData=At={}));var Kt;(function(Ae){function Me(ie){return{mime:ie.mime,valueBytes:h.$Oe.wrap(ie.data)}}Ae.from=Me;function ve(ie){return new v.$2O(ie.valueBytes.buffer,ie.mime)}Ae.to=ve})(Kt||(e.NotebookCellOutputItem=Kt={}));var Qt;(function(Ae){function Me(ie){return{outputId:ie.id,items:ie.items.map(Kt.from),metadata:ie.metadata}}Ae.from=Me;function ve(ie){const Re=ie.items.map(Kt.to);return new v.$3O(Re,ie.outputId,ie.metadata)}Ae.to=ve})(Qt||(e.NotebookCellOutput=Qt={}));var pt;(function(Ae){function Me(Re){return ie(Re)?{include:_e.from(Re.include)??void 0,exclude:_e.from(Re.exclude)??void 0}:_e.from(Re)??void 0}Ae.from=Me;function ve(Re){return ie(Re)?{include:_e.to(Re.include),exclude:_e.to(Re.exclude)}:_e.to(Re)}Ae.to=ve;function ie(Re){const Ke=Re;return Ke?!(0,c.$og)(Ke.include)&&!(0,c.$og)(Ke.exclude):!1}})(pt||(e.NotebookExclusiveDocumentPattern=pt={}));var vt;(function(Ae){function Me(ve,ie,Re){const Ke=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===v.NotebookCellStatusBarAlignment.Left?S.CellStatusbarAlignment.Left:S.CellStatusbarAlignment.Right,command:ie.toInternal(Ke,Re),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Ae.from=Me})(vt||(e.NotebookStatusBarItem=vt={}));var ii;(function(Ae){function Me(ve,ie,Re){const Ke=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:ie.toInternal(Ke,Re),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Ae.from=Me})(ii||(e.NotebookKernelSourceAction=ii={}));var xt;(function(Ae){function Me(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Ae.from=Me})(xt||(e.NotebookDocumentContentOptions=xt={}));var Gt;(function(Ae){function Me(ie){return{uri:ie.uri,provides:ie.provides}}Ae.from=Me;function ve(ie){return new v.$5O(m.URI.revive(ie.uri),ie.provides)}Ae.to=ve})(Gt||(e.NotebookRendererScript=Gt={}));var Et;(function(Ae){function Me(ie){return{message:he.fromStrict(ie.message)||"",type:A.TestMessageType.Error,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:N.from(ie.location.range),uri:ie.location.uri}}}Ae.from=Me;function ve(ie){const Re=new v.$$O(typeof ie.message=="string"?ie.message:he.to(ie.message));return Re.actualOutput=ie.actual,Re.expectedOutput=ie.expected,Re.contextValue=ie.contextValue,Re.location=ie.location?Ue.to(ie.location):void 0,Re}Ae.to=ve})(Et||(e.TestMessage=Et={}));var Ft;(function(Ae){Ae.namespace=A.$YI,Ae.denamespace=A.$ZI})(Ft||(e.TestTag=Ft={}));var ui;(function(Ae){function Me(ie){const Re=(0,f.$WP)(ie).controllerId;return{extId:C.$TI.fromExtHostTestItem(ie,Re).toString(),label:ie.label,uri:m.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(Ke=>Ft.namespace(Re,Ke.id)),range:g.$Lt.lift(N.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&he.fromStrict(ie.error)||null}}Ae.from=Me;function ve(ie){return{parent:void 0,error:void 0,id:C.$TI.fromString(ie.extId).localId,label:ie.label,uri:m.URI.revive(ie.uri),tags:(ie.tags||[]).map(Re=>{const{tagId:Ke}=Ft.denamespace(Re);return new v.$_O(Ke)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Ae.toPlain=ve})(ui||(e.TestItem=ui={})),function(Ae){function Me(ie){return{id:ie.id}}Ae.from=Me;function ve(ie){return new v.$_O(ie.id)}Ae.to=ve}(Ft||(e.TestTag=Ft={}));var Ht;(function(Ae){const Me=(ie,Re)=>{const Ke=ie.value;if(!Ke)return;const tt={...ui.toPlain(Ke.item),parent:Re,taskStates:Ke.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ft=>ft.type===A.TestMessageType.Error).map(Et.to)})),children:[]};if(ie.children)for(const Qe of ie.children.values()){const ft=Me(Qe,tt);ft&&tt.children.push(ft)}return tt};function ve(ie){const Re=new l.$SI;for(const Qe of ie.items)Re.insert(C.$TI.fromString(Qe.item.extId).path,Qe);const Ke=[Re.nodes],tt=[];for(;Ke.length;)for(const Qe of Ke.pop())Qe.value?tt.push(Qe):Qe.children&&Ke.push(Qe.children.values());return{completedAt:ie.completedAt,results:tt.map(Qe=>Me(Qe)).filter(c.$ng)}}Ae.to=ve})(Ht||(e.TestResults=Ht={}));var xe;(function(Ae){function Me(Ke){return{covered:Ke.covered,total:Ke.total}}function ve(Ke){return"line"in Ke?z.from(Ke):N.from(Ke)}function ie(Ke){if(typeof Ke.executed=="number"&&Ke.executed<0)throw new Error(`Invalid coverage count ${Ke.executed}`);return"branches"in Ke?{count:Ke.executed,location:ve(Ke.location),type:A.DetailType.Statement,branches:Ke.branches.length?Ke.branches.map(tt=>({count:tt.executed,location:tt.location&&ve(tt.location),label:tt.label})):void 0}:{type:A.DetailType.Declaration,name:Ke.name,count:Ke.executed,location:ve(Ke.location)}}Ae.fromDetails=ie;function Re(Ke,tt,Qe){return v.$bP(Qe.statementCoverage),v.$bP(Qe.branchCoverage),v.$bP(Qe.declarationCoverage),{id:tt,uri:Qe.uri,statement:Me(Qe.statementCoverage),branch:Qe.branchCoverage&&Me(Qe.branchCoverage),declaration:Qe.declarationCoverage&&Me(Qe.declarationCoverage),testIds:Qe instanceof v.$cP&&Qe.fromTests.length?Qe.fromTests.map(ft=>C.$TI.fromExtHostTestItem(ft,Ke).toString()):void 0}}Ae.fromFile=Re})(xe||(e.TestCoverage=xe={}));var _t;(function(Ae){function Me(ve){switch(ve){case o.CodeActionTriggerType.Invoke:return v.CodeActionTriggerKind.Invoke;case o.CodeActionTriggerType.Auto:return v.CodeActionTriggerKind.Automatic}}Ae.to=Me})(_t||(e.CodeActionTriggerKind=_t={}));var ni;(function(Ae){function Me(ie){const Re=new v.$gP(le.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Re._sessionId=ie._sessionId,Re._itemId=ie._itemId,Re}Ae.to=Me;function ve(ie,Re,Ke){if(Re=Re??ie._sessionId,Ke=Ke??ie._itemId,Re===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ke,kind:le.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(ue.from)}}Ae.from=ve})(ni||(e.TypeHierarchyItem=ni={}));var hi;(function(Ae){function Me(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Ae.from=Me})(hi||(e.ViewBadge=hi={}));var It;(function(Ae){function Me(Ke,tt,Qe){const ft=tt.fileData;return ft?new v.$nO(new v.$oO(ft.name,m.URI.revive(ft.uri),ft.id,(0,O.$fb)(()=>Qe(ft.id)))):Ke===I.$8s.uriList&&tt.uriListData?new v.$mO(Re(tt.uriListData)):new v.$mO(tt.asString)}Ae.to=Me;async function ve(Ke,tt){const Qe=await tt.asString();if(Ke===I.$8s.uriList)return{asString:Qe,fileData:void 0,uriListData:ie(Qe)};const ft=tt.asFile();return{asString:Qe,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}Ae.from=ve;function ie(Ke){return P.$pu.split(Ke).map(tt=>{if(tt.startsWith("#"))return tt;try{return m.URI.parse(tt)}catch{}return tt})}function Re(Ke){return P.$pu.create(Ke.map(tt=>typeof tt=="string"?tt:m.URI.revive(tt)))}})(It||(e.DataTransferItem=It={}));var Mt;(function(Ae){function Me(ie,Re){const Ke=ie.items.map(([tt,Qe])=>[tt,It.to(tt,Qe,Re)]);return new v.$pO(Ke)}Ae.toDataTransfer=Me;async function ve(ie){const Re={items:[]},Ke=[];for(const[tt,Qe]of ie)Ke.push((async()=>{Re.items.push([tt,await It.from(tt,Qe)])})());return await Promise.all(Ke),Re}Ae.from=ve})(Mt||(e.DataTransfer=Mt={}));var Ot;(function(Ae){function Me(ie,Re){return{kind:"reply",agentId:ie.participant??Re?.agentId??"",subCommand:ie.command??Re?.command,message:ie.prompt,title:ie.label}}Ae.from=Me;function ve(ie){return{prompt:ie.message,label:ie.title,participant:ie.agentId,command:ie.subCommand}}Ae.to=ve})(Ot||(e.ChatFollowup=Ot={}));var Ut;(function(Ae){function Me(ie){switch(ie){case y.ChatMessageRole.System:return v.LanguageModelChatMessageRole.System;case y.ChatMessageRole.User:return v.LanguageModelChatMessageRole.User;case y.ChatMessageRole.Assistant:return v.LanguageModelChatMessageRole.Assistant}}Ae.to=Me;function ve(ie){switch(ie){case v.LanguageModelChatMessageRole.System:return y.ChatMessageRole.System;case v.LanguageModelChatMessageRole.User:return y.ChatMessageRole.User;case v.LanguageModelChatMessageRole.Assistant:return y.ChatMessageRole.Assistant}return y.ChatMessageRole.User}Ae.from=ve})(Ut||(e.LanguageModelChatMessageRole=Ut={}));var ri;(function(Ae){function Me(ie){let Re="",Ke;ie.content.type==="text"?Re=ie.content.value:Ke=new v.$HP(ie.content.name,ie.content.value,ie.content.isError);const tt=Ut.to(ie.role),Qe=new v.$IP(tt,Re,ie.name);return Ke!==void 0&&(Qe.content2=Ke),Qe}Ae.to=Me;function ve(ie){const Re=Ut.from(ie.role),Ke=ie.name;let tt;return ie.content2 instanceof v.$HP?tt={type:"function_result",name:ie.content2.name,value:ie.content2.content,isError:ie.content2.isError}:tt={type:"text",value:ie.content},{role:Re,name:Ke,content:tt}}Ae.from=ve})(ri||(e.LanguageModelChatMessage=ri={}));var ei;(function(Ae){function Me(ie){return{kind:"markdownContent",content:he.from(ie.value)}}Ae.from=Me;function ve(ie){return new v.$tP(he.to(ie.content))}Ae.to=ve})(ei||(e.ChatResponseMarkdownPart=ei={}));var si;(function(Ae){function Me(ie){return{kind:"markdownVuln",content:he.from(ie.value),vulnerabilities:ie.vulnerabilities}}Ae.from=Me;function ve(ie){return new v.$uP(he.to(ie.content),ie.vulnerabilities)}Ae.to=ve})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var Wt;(function(Ae){function Me(ie){return{kind:"agentDetection",agentId:ie.participant,command:ie.command}}Ae.from=Me;function ve(ie){return new v.$vP(ie.agentId,ie.command)}Ae.to=ve})(Wt||(e.ChatResponseDetectedParticipantPart=Wt={}));var Jt;(function(Ae){function Me(ve){return{kind:"confirmation",title:ve.title,message:ve.message,data:ve.data}}Ae.from=Me})(Jt||(e.ChatResponseConfirmationPart=Jt={}));var oi;(function(Ae){function Me(ie){const{value:Re,baseUri:Ke}=ie;function tt(Qe,ft){return Qe.map(Ct=>{const Xt=m.URI.joinPath(ft,Ct.name);return{label:Ct.name,uri:Xt,children:Ct.children&&tt(Ct.children,Xt)}})}return{kind:"treeData",treeData:{label:(0,k.$dh)(Ke),uri:Ke,children:tt(Re,Ke)}}}Ae.from=Me;function ve(ie){const Re=(0,a.$ci)(ie.treeData);function Ke(ft){return ft.map(Ct=>({name:Ct.label,children:Ct.children&&Ke(Ct.children)}))}const tt=Re.uri,Qe=Re.children?Ke(Re.children):[];return new v.$xP(Qe,tt)}Ae.to=ve})(oi||(e.ChatResponseFilesPart=oi={}));var Rt;(function(Ae){function Me(ie){const Re=Ke=>m.URI.isUri(Ke);return{kind:"inlineReference",name:ie.title,inlineReference:Re(ie.value)?ie.value:L.from(ie.value)}}Ae.from=Me;function ve(ie){const Re=(0,a.$ci)(ie);return new v.$yP(m.URI.isUri(Re.inlineReference)?Re.inlineReference:L.to(Re.inlineReference),ie.name)}Ae.to=ve})(Rt||(e.ChatResponseAnchorPart=Rt={}));var Dt;(function(Ae){function Me(ie){return{kind:"progressMessage",content:he.from(ie.value)}}Ae.from=Me;function ve(ie){return new v.$zP(ie.content.value)}Ae.to=ve})(Dt||(e.ChatResponseProgressPart=Dt={}));var wt;(function(Ae){function Me(ie){return{kind:"warning",content:he.from(ie.value)}}Ae.from=Me;function ve(ie){return new v.$BP(ie.content.value)}Ae.to=ve})(wt||(e.ChatResponseWarningPart=wt={}));var ti;(function(Ae){function Me(ve){return{kind:"progressTask",content:he.from(ve.value)}}Ae.from=Me})(ti||(e.ChatTask=ti={}));var Pt;(function(Ae){function Me(ve){return{kind:"progressTaskResult",content:typeof ve=="string"?he.from(ve):void 0}}Ae.from=Me})(Pt||(e.ChatTaskResult=Pt={}));var di;(function(Ae){function Me(ie,Re,Ke){return{kind:"command",command:Re.toInternal(ie.value,Ke)??{command:ie.value.command,title:ie.value.title}}}Ae.from=Me;function ve(ie,Re){return new v.$CP(Re.fromInternal(ie.command)??{command:ie.command.id,title:ie.command.title})}Ae.to=ve})(di||(e.ChatResponseCommandButtonPart=di={}));var Zt;(function(Ae){function Me(ie){return{kind:"textEdit",uri:ie.uri,edits:ie.edits.map(Re=>ae.from(Re))}}Ae.from=Me;function ve(ie){return new v.$EP(m.URI.revive(ie.uri),ie.edits.map(Re=>ae.to(Re)))}Ae.to=ve})(Zt||(e.ChatResponseTextEditPart=Zt={}));var wi;(function(Ae){function Me(ie){const Re=p.ThemeIcon.isThemeIcon(ie.iconPath)?ie.iconPath:m.URI.isUri(ie.iconPath)?{light:m.URI.revive(ie.iconPath)}:ie.iconPath&&"light"in ie.iconPath&&"dark"in ie.iconPath&&m.URI.isUri(ie.iconPath.light)&&m.URI.isUri(ie.iconPath.dark)?{light:m.URI.revive(ie.iconPath.light),dark:m.URI.revive(ie.iconPath.dark)}:void 0;return"variableName"in ie.value?{kind:"reference",reference:{variableName:ie.value.variableName,value:m.URI.isUri(ie.value.value)||!ie.value.value?ie.value.value:L.from(ie.value.value)},iconPath:Re}:{kind:"reference",reference:m.URI.isUri(ie.value)?ie.value:L.from(ie.value),iconPath:Re}}Ae.from=Me;function ve(ie){const Re=(0,a.$ci)(ie),Ke=tt=>m.URI.isUri(tt)?tt:L.to(tt);return new v.$DP("variableName"in Re.reference?{variableName:Re.reference.variableName,value:Re.reference.value&&Ke(Re.reference.value)}:Ke(Re.reference))}Ae.to=ve})(wi||(e.ChatResponseReferencePart=wi={}));var vi;(function(Ae){function Me(Re,Ke,tt){return Re instanceof v.$tP?ei.from(Re):Re instanceof v.$yP?Rt.from(Re):Re instanceof v.$DP?wi.from(Re):Re instanceof v.$zP?Dt.from(Re):Re instanceof v.$xP?oi.from(Re):Re instanceof v.$CP?di.from(Re,Ke,tt):Re instanceof v.$EP?Zt.from(Re):Re instanceof v.$uP?si.from(Re):Re instanceof v.$vP?Wt.from(Re):Re instanceof v.$BP?wt.from(Re):{kind:"markdownContent",content:he.from("")}}Ae.from=Me;function ve(Re,Ke){switch(Re.kind){case"reference":return wi.to(Re);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ie(Re,Ke)}}Ae.to=ve;function ie(Re,Ke){switch(Re.kind){case"markdownContent":return ei.to(Re);case"inlineReference":return Rt.to(Re);case"progressMessage":return;case"treeData":return oi.to(Re);case"command":return di.to(Re,Ke)}}Ae.toContent=ie})(vi||(e.ChatResponsePart=vi={}));var gi;(function(Ae){function Me(ve){return{prompt:ve.message,command:ve.command,attempt:ve.attempt??0,enableCommandDetection:ve.enableCommandDetection??!0,references:ve.variables.variables.map(ai.to),location:qt.to(ve.location),acceptedConfirmationData:ve.acceptedConfirmationData,rejectedConfirmationData:ve.rejectedConfirmationData}}Ae.to=Me})(gi||(e.ChatAgentRequest=gi={}));var qt;(function(Ae){function Me(ie){switch(ie){case w.ChatAgentLocation.Notebook:return v.ChatLocation.Notebook;case w.ChatAgentLocation.Terminal:return v.ChatLocation.Terminal;case w.ChatAgentLocation.Panel:return v.ChatLocation.Panel;case w.ChatAgentLocation.Editor:return v.ChatLocation.Editor}}Ae.to=Me;function ve(ie){switch(ie){case v.ChatLocation.Notebook:return w.ChatAgentLocation.Notebook;case v.ChatLocation.Terminal:return w.ChatAgentLocation.Terminal;case v.ChatLocation.Panel:return w.ChatAgentLocation.Panel;case v.ChatLocation.Editor:return w.ChatAgentLocation.Editor}}Ae.from=ve})(qt||(e.ChatLocation=qt={}));var ai;(function(Ae){function Me(ve){const ie=ve.value;if(!ie)throw new Error("Invalid value reference");return{id:ve.id,name:ve.name,range:ve.range&&[ve.range.start,ve.range.endExclusive],value:(0,m.$xc)(ie)?m.URI.revive(ie):ie&&typeof ie=="object"&&"uri"in ie&&"range"in ie&&(0,m.$xc)(ie.uri)?L.to((0,a.$ci)(ie)):ie,modelDescription:ve.modelDescription}}Ae.to=Me})(ai||(e.ChatAgentValueReference=ai={}));var Pi;(function(Ae){function Me(ve,ie,Re){return{id:ve.id,label:ve.label,fullName:ve.fullName,icon:ve.icon?.id,value:ve.values[0].value,insertText:ve.insertText,detail:ve.detail,documentation:ve.documentation,command:ie.toInternal(ve.command,Re)}}Ae.from=Me})(Pi||(e.ChatAgentCompletionItem=Pi={}));var Tt;(function(Ae){function Me(ve){return{errorDetails:ve.errorDetails,metadata:ve.metadata}}Ae.to=Me})(Tt||(e.ChatAgentResult=Tt={}));var Si;(function(Ae){function Me(ve,ie,Re){if(ie.action.kind==="vote")return;const Ke=Tt.to(ve);if(ie.action.kind==="command"){const tt=ie.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Re.fromInternal(tt)??{command:tt.id,title:tt.title}}},result:Ke}}else return ie.action.kind==="followUp"?{action:{kind:"followUp",followup:Ot.to(ie.action.followup)},result:Ke}:ie.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ie.action.action==="accepted"},result:Ke}:{action:ie.action,result:Ke}}Ae.to=Me})(Si||(e.ChatAgentUserActionEvent=Si={}));var Ci;(function(Ae){function Me(ve,ie,Re){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand,shouldExecute:ve.shouldExecute}:"uri"in ve?{uri:ve.uri}:ie.toInternal(ve,Re)}Ae.from=Me})(Ci||(e.TerminalQuickFix=Ci={}));var Di;(function(Ae){function Me(ve){return{kind:$i.to(ve.kind)}}Ae.to=Me})(Di||(e.PartialAcceptInfo=Di={}));var $i;(function(Ae){function Me(ve){switch(ve){case o.PartialAcceptTriggerKind.Word:return v.PartialAcceptTriggerKind.Word;case o.PartialAcceptTriggerKind.Line:return v.PartialAcceptTriggerKind.Line;case o.PartialAcceptTriggerKind.Suggest:return v.PartialAcceptTriggerKind.Suggest;default:return v.PartialAcceptTriggerKind.Unknown}}Ae.to=Me})($i||(e.PartialAcceptTriggerKind=$i={}));var Ai;(function(Ae){function Me(ve,ie){return{id:ie,label:ve.label,description:ve.description,canEdit:ve.canEdit,collapsibleState:ve.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:ve.contextValue}}Ae.from=Me})(Ai||(e.DebugTreeItem=Ai={}));var Vt;(function(Ae){function Me(ve){return{name:ve.name,description:ve.description,parametersSchema:ve.parametersSchema}}Ae.to=Me})(Vt||(e.LanguageModelToolDescription=Vt={}))}),define(ye[345],Se([1,0,6,20,16,52]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=void 0;let T=class{constructor($,a){this.a=$.getProxy(r.$uN.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>a.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,a,I){const E=new O.$Tw(P.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(E,void 0,I?.isRefactoring??!1)}};e.$voc=T,e.$voc=T=Je([Ve(0,h.$1P)],T)}),define(ye[346],Se([1,0,19,9,51,4,40,3,43,18,2,24,6,16,10,308,26]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=void 0,k=We(k),p=We(p);class d{constructor(t,i,s,f,u){this.j=t,this.k=i,this.l=s,this.m=f,this.n=u,this.b=$.$ge.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let i=function(f){if(t.c){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,f),u}};const t=this;this.b.reset();const s=(f,u)=>{if(typeof this.d>"u"&&"content"in f&&(this.d=this.b.elapsed()),u){const w=this.l.$handleProgressChunk(this.k.requestId,f),y={report:D=>{w?.then(S=>{S&&(p.$YN.isMarkdownString(D.value)?this.l.$handleProgressChunk(this.k.requestId,k.ChatResponseWarningPart.from(D),S):this.l.$handleProgressChunk(this.k.requestId,k.ChatResponseReferencePart.from(D),S))})}};Promise.all([w,u?.(y)]).then(([D,S])=>{D!==void 0&&S!==void 0&&this.l.$handleProgressChunk(this.k.requestId,k.ChatTaskResult.from(S),D)})}else this.l.$handleProgressChunk(this.k.requestId,f)};this.g={markdown(f){i(this.markdown);const u=new p.$tP(f),w=k.ChatResponseMarkdownPart.from(u);return s(w),this},markdownWithVulnerabilities(f,u){i(this.markdown),u&&(0,m.$7G)(t.j,"chatParticipantAdditions");const w=new p.$uP(f,u),y=k.ChatResponseMarkdownWithVulnerabilitiesPart.from(w);return s(y),this},filetree(f,u){i(this.filetree);const w=new p.$xP(f,u),y=k.ChatResponseFilesPart.from(w);return s(y),this},anchor(f,u){i(this.anchor);const w=new p.$yP(f,u),y=k.ChatResponseAnchorPart.from(w);return s(y),this},button(f){i(this.anchor);const u=new p.$CP(f),w=k.ChatResponseCommandButtonPart.from(u,t.m,t.n);return s(w),this},progress(f,u){i(this.progress);const w=new p.$AP(f,u),y=u?k.ChatTask.from(w):k.ChatResponseProgressPart.from(w);return s(y,u),this},warning(f){i(this.progress),(0,m.$7G)(t.j,"chatParticipantAdditions");const u=new p.$BP(f),w=k.ChatResponseWarningPart.from(u);return s(w),this},reference(f,u){if(i(this.reference),"variableName"in f&&(0,m.$7G)(t.j,"chatParticipantAdditions"),"variableName"in f&&!f.value){const w=t.k.variables.variables.find(y=>y.name===f.variableName);if(w){let y;if(w.references?.length)y=w.references.map(D=>({kind:"reference",reference:{variableName:f.variableName,value:D.reference}}));else{const D=new p.$DP(f,u);y=[k.ChatResponseReferencePart.from(D)]}return y.forEach(D=>s(D)),this}}else{const w=new p.$DP(f,u),y=k.ChatResponseReferencePart.from(w);s(y)}return this},textEdit(f,u){i(this.textEdit),(0,m.$7G)(t.j,"chatParticipantAdditions");const w=new p.$EP(f,u),y=k.ChatResponseTextEditPart.from(w);return s(y),this},detectedParticipant(f,u){i(this.detectedParticipant),(0,m.$7G)(t.j,"chatParticipantAdditions");const w=new p.$vP(f,u),y=k.ChatResponseDetectedParticipantPart.from(w);return s(y),this},confirmation(f,u,w){i(this.confirmation),(0,m.$7G)(t.j,"chatParticipantAdditions");const y=new p.$wP(f,u,w),D=k.ChatResponseConfirmationPart.from(y);return s(D),this},push(f){if(i(this.push),(f instanceof p.$EP||f instanceof p.$uP||f instanceof p.$vP||f instanceof p.$BP||f instanceof p.$wP)&&(0,m.$7G)(t.j,"chatParticipantAdditions"),f instanceof p.$DP)this.reference(f.value,f.iconPath);else{const u=k.ChatResponsePart.from(f,t.m,t.n);s(u)}return this}}}return this.g}}class g extends R.$Wc{static{this.b=0}constructor(t,i,s,f){super(),this.n=i,this.s=s,this.t=f,this.c=new Map,this.j=this.B(new R.$6c),this.m=this.B(new R.$6c),this.g=t.getProxy(l.$uN.MainThreadChatAgents2)}transferActiveChat(t){this.g.$transferActiveChatSession(t)}createChatAgent(t,i,s){const f=g.b++,u=new n(t,this.t,i,this.g,f,s);return this.c.set(f,u),u.isAgentEnabled()&&this.g.$registerAgent(f,t.identifier,i,{},void 0),u.apiAgent}createDynamicChatAgent(t,i,s,f){const u=g.b++,w=new n(t,this.t,i,this.g,u,f);return this.c.set(u,w),this.g.$registerAgent(u,t.identifier,i,{isSticky:!0},s),w.apiAgent}async $invokeAgent(t,i,s,f){const u=this.c.get(t);if(!u)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let w=this.j.get(i.sessionId);w||(w=new R.$Vc,this.j.set(i.sessionId,w));const y=new d(u.extension,i,this.g,this.s.converter,w);try{const D=await this.u(i.agentId,s),S=u.invoke(k.ChatAgentRequest.to(i),{history:D},y.apiObject,f);return await(0,h.$th)(Promise.resolve(S).then(C=>{if(C?.metadata)try{JSON.stringify(C.metadata)}catch(b){const v=`result.metadata MUST be JSON.stringify-able. Got error: ${b.message}`;return this.n.error(`[${u.extension.identifier.value}] [@${u.id}] ${v}`,u.extension),{errorDetails:{message:v},timings:y.timings}}let A;return C?.errorDetails&&(A={...C.errorDetails,responseIsIncomplete:!0}),A?.responseIsRedacted&&(0,m.$7G)(u.extension,"chatParticipantPrivate"),{errorDetails:A,timings:y.timings,metadata:C?.metadata}}),f)}catch(D){return this.n.error(D,u.extension),D instanceof p.$OP&&D.cause&&(D=D.cause),{errorDetails:{message:(0,P.$qj)(D),responseIsIncomplete:!0}}}finally{y.close()}}async u(t,i){const s=[];for(const f of i.history){const u=k.ChatAgentResult.to(f.result),w=t===f.request.agentId?u:{...u,metadata:void 0};s.push(new p.$FP(f.request.message,f.request.command,f.request.variables.variables.map(k.ChatAgentValueReference.to),f.request.agentId));const y=(0,r.$Jb)(f.response.map(D=>k.ChatResponsePart.toContent(D,this.s.converter)));s.push(new p.$GP(y,w,f.request.agentId,f.request.command))}return s}$releaseSession(t){this.j.deleteAndDispose(t)}async $provideFollowups(t,i,s,f,u){const w=this.c.get(i);if(!w)return Promise.resolve([]);const y=await this.u(w.id,f),D=k.ChatAgentResult.to(s);return(await w.provideFollowups(D,{history:y},u)).filter(S=>{const C=!S.participant||T.Iterable.some(this.c.values(),A=>A.id===S.participant&&E.$qn.equals(A.extension.identifier,w.extension.identifier));return C||this.n.warn(`[@${w.id}] ChatFollowup refers to an unknown participant: ${S.participant}`),C}).map(S=>k.ChatFollowup.from(S,t))}$acceptFeedback(t,i,s,f){const u=this.c.get(t);if(!u)return;const w=k.ChatAgentResult.to(i);let y;switch(s){case c.ChatAgentVoteDirection.Down:y=p.ChatResultFeedbackKind.Unhelpful;break;case c.ChatAgentVoteDirection.Up:y=p.ChatResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(f?{result:w,kind:y,reportIssue:f}:{result:w,kind:y}))}$acceptAction(t,i,s){const f=this.c.get(t);if(!f||s.action.kind==="vote")return;const u=k.ChatAgentUserActionEvent.to(i,s,this.s.converter);u&&f.acceptAction(Object.freeze(u))}async $invokeCompletionProvider(t,i,s){const f=this.c.get(t);if(!f)return[];let u=this.m.get(t);return u?u.clear():(u=new R.$Vc,this.m.set(t,u)),(await f.invokeCompletionProvider(i,s)).map(y=>k.ChatAgentCompletionItem.from(y,this.s.converter,u))}async $provideWelcomeMessage(t,i,s){const f=this.c.get(t);if(f)return await f.provideWelcomeMessage(k.ChatLocation.to(i),s)}async $provideSampleQuestions(t,i,s){const f=this.c.get(t);if(f)return(await f.provideSampleQuestions(k.ChatLocation.to(i),s)).map(u=>k.ChatFollowup.from(u,void 0))}}e.$woc=g;class n{constructor(t,i,s,f,u,w){this.extension=t,this.w=i,this.id=s,this.x=f,this.y=u,this.z=w,this.m=new O.$me,this.n=new O.$me}acceptFeedback(t){this.m.fire(t)}acceptAction(t){this.n.fire(t)}async invokeCompletionProvider(t,i){return this.q?await this.q.provider.provideCompletionItems(t,i)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,m.$6G)(this.extension,"chatParticipantPrivate"))}async provideFollowups(t,i,s){if(!this.b)return[];const f=await this.b.provideFollowups(t,i,s);return f?f.filter(u=>!(u&&"commandId"in u)).filter(u=>!(u&&"message"in u)):[]}async provideWelcomeMessage(t,i){if(!this.s)return[];const s=await this.s.provideWelcomeMessage(t,i);return s?s.map(f=>typeof f=="string"?f:k.MarkdownString.from(f)):[]}async provideSampleQuestions(t,i){if(!this.s||!this.s.provideSampleQuestions)return[];const s=await this.s.provideSampleQuestions(t,i);return s||[]}get apiAgent(){let t=!1,i=!1;const s=()=>{t||i||(i=!0,queueMicrotask(()=>{f.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof I.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof p.$tO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:k.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:k.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:k.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),i=!1)}))},f=this;return{get id(){return f.id},get iconPath(){return f.c},set iconPath(u){f.c=u,s()},get requestHandler(){return f.z},set requestHandler(u){(0,a.$pg)(typeof u=="function","Invalid request handler"),f.z=u},get followupProvider(){return f.b},set followupProvider(u){f.b=u,s()},get isDefault(){return(0,m.$7G)(f.extension,"defaultChatParticipant"),f.d},set isDefault(u){(0,m.$7G)(f.extension,"defaultChatParticipant"),f.d=u,s()},get helpTextPrefix(){return(0,m.$7G)(f.extension,"defaultChatParticipant"),f.g},set helpTextPrefix(u){(0,m.$7G)(f.extension,"defaultChatParticipant"),f.g=u,s()},get helpTextVariablesPrefix(){return(0,m.$7G)(f.extension,"defaultChatParticipant"),f.j},set helpTextVariablesPrefix(u){(0,m.$7G)(f.extension,"defaultChatParticipant"),f.j=u,s()},get helpTextPostfix(){return(0,m.$7G)(f.extension,"defaultChatParticipant"),f.k},set helpTextPostfix(u){(0,m.$7G)(f.extension,"defaultChatParticipant"),f.k=u,s()},get isSecondary(){return(0,m.$7G)(f.extension,"defaultChatParticipant"),f.l},set isSecondary(u){(0,m.$7G)(f.extension,"defaultChatParticipant"),f.l=u,s()},get supportIssueReporting(){return(0,m.$7G)(f.extension,"chatParticipantPrivate"),f.o},set supportIssueReporting(u){(0,m.$7G)(f.extension,"chatParticipantPrivate"),f.o=u,s()},get onDidReceiveFeedback(){return f.m.event},set participantVariableProvider(u){if((0,m.$7G)(f.extension,"chatParticipantAdditions"),f.q=u,u){if(!u.triggerCharacters.length)throw new Error("triggerCharacters are required");f.x.$registerAgentCompletionsProvider(f.y,f.id,u.triggerCharacters)}else f.x.$unregisterAgentCompletionsProvider(f.y,f.id)},get participantVariableProvider(){return(0,m.$7G)(f.extension,"chatParticipantAdditions"),f.q},set welcomeMessageProvider(u){(0,m.$7G)(f.extension,"defaultChatParticipant"),f.s=u,s()},get welcomeMessageProvider(){return(0,m.$7G)(f.extension,"defaultChatParticipant"),f.s},onDidPerformAction:(0,m.$6G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(u){f.t=u,s()},get requester(){return f.t},set supportsSlowReferences(u){(0,m.$7G)(f.extension,"chatParticipantPrivate"),f.u=u,s()},get supportsSlowReferences(){return(0,m.$7G)(f.extension,"chatParticipantPrivate"),f.u},dispose(){t=!0,f.b=void 0,f.m.dispose(),f.x.$unregisterAgent(f.y)}}}invoke(t,i,s,f){return this.z(t,i,s,f)}}}),define(ye[347],Se([1,0,14,3,50,6,16,10,26]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=void 0,T=We(T),R=We(R);class a{static{this.a=0}constructor(l){this.b=new Map,this.c=l.getProxy(O.$uN.MainThreadChatVariables)}async $resolveVariable(l,k,p,c){const m=this.b.get(l);if(m)try{if(m.resolver.resolve2){(0,$.$7G)(m.extension,"chatParticipantAdditions");const d=new I(k,this.c),g=await m.resolver.resolve2(m.data.name,{prompt:p},d.apiObject,c);if(g&&g[0])return g[0].value}else{const d=await m.resolver.resolve(m.data.name,{prompt:p},c);if(d&&d[0])return d[0].value}}catch(d){(0,r.$4)(d)}}registerVariableResolver(l,k,p,c,m,d,g,n,o){const t=a.a++,i=o?P.ThemeIcon.fromId(o):void 0;return this.b.set(t,{extension:l,data:{id:k,name:p,description:c,modelDescription:m,icon:i},resolver:g}),this.c.$registerVariable(t,{id:k,name:p,description:c,modelDescription:m,isSlow:d,fullName:n,icon:i}),(0,h.$Uc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$xoc=a;class I{constructor(l,k){this.c=l,this.d=k,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let k=function(c){if(l.a){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,c),m}};const l=this,p=c=>{this.d.$handleProgressChunk(this.c,c)};this.b={progress(c){k(this.progress);const m=new R.$zP(c),d=T.ChatResponseProgressPart.from(m);return p(d),this},reference(c){k(this.reference);const m=new R.$DP(c),d=T.ChatResponseReferencePart.from(m);return p(d),this},push(c){return k(this.push),c instanceof R.$DP?p(T.ChatResponseReferencePart.from(c)):c instanceof R.$zP&&p(T.ChatResponseProgressPart.from(c)),this}}}return this.b}}}),define(ye[348],Se([1,0,9,59,4,3,41,2,88,24,16,10,6,26]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=p,$=We($),I=We(I),E=We(E);function p(c,m,d){const g=c.getProxy(l.$uN.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new a.$sn,m.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===T.MarshalledId.CommentController){const C=this.b.get(S.handle);return C?C.value:S}else if(S&&S.$mid===T.MarshalledId.CommentThread){const C=S,A=this.b.get(C.commentControlHandle);if(!A)return C;const b=A.getCommentThread(C.commentThreadHandle);return b?b.value:C}else if(S&&(S.$mid===T.MarshalledId.CommentThreadReply||S.$mid===T.MarshalledId.CommentThreadInstance)){const C=this.b.get(S.thread.commentControlHandle);if(!C)return S;const A=C.getCommentThread(S.thread.commentThreadHandle);return A?S.$mid===T.MarshalledId.CommentThreadInstance?A.value:{thread:A.value,text:S.text}:S}else if(S&&S.$mid===T.MarshalledId.CommentNode){const C=this.b.get(S.thread.commentControlHandle);if(!C)return S;const A=C.getCommentThread(S.thread.commentThreadHandle);if(!A)return S;const b=S.commentUniqueId,v=A.getCommentByUniqueId(b);return v||S}else if(S&&S.$mid===T.MarshalledId.CommentThreadNode){const C=this.b.get(S.thread.commentControlHandle);if(!C)return S;const A=C.getCommentThread(S.thread.commentThreadHandle);if(!A)return S;const b=S.text,v=S.commentUniqueId,M=A.getCommentByUniqueId(v);return M?(typeof M.body=="string"?M.body=b:M.body=new E.$YN(b),M):S}return S}})}createCommentController(S,C,A){const b=n.a++,v=new t(S,b,C,A);this.b.set(v.handle,v);const M=this.c.get(S.identifier)||[];return M.push(v),this.c.set(S.identifier,M),v.value}async $createCommentThreadTemplate(S,C,A,b){const v=this.b.get(S);v&&v.$createCommentThreadTemplate(C,A,b)}async $setActiveComment(S,C){const A=this.b.get(S);A&&A.$setActiveComment(C??void 0)}async $updateCommentThreadTemplate(S,C,A){const b=this.b.get(S);b&&b.$updateCommentThreadTemplate(C,A)}$deleteCommentThread(S,C){this.b.get(S)?.$deleteCommentThread(C)}async $provideCommentingRanges(S,C,A){const b=this.b.get(S);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const v=await d.ensureDocumentData(R.URI.revive(C));return(0,r.$xh)(async()=>{const M=await b.commentingRangeProvider.provideCommentingRanges(v.document,A);let N;return Array.isArray(M)?N={ranges:M,fileComments:!1}:M?N={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:N=M??void 0,N}).then(M=>{let N;return M&&(N={ranges:M.ranges.map(L=>I.Range.from(L)),fileComments:M.fileComments}),N})}$toggleReaction(S,C,A,b,v){const M=this.b.get(S);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,r.$xh)(()=>{const N=M.getCommentThread(C);if(N){const L=N.getCommentByUniqueId(b.uniqueIdInThread);if(M!==void 0&&L&&M.reactionHandler)return M.reactionHandler(L,f(v))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(S){this.n=S}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(S){(S===void 0!=(this.p===void 0)||!S||!this.p||!S.isEqual(this.p))&&(this.p=S,this.b.range=S,this.c.fire())}get range(){return this.p}set canReply(S){this.d!==S&&(this.d=S,this.b.canReply=S,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(S){this.e=S,this.b.label=S,this.c.fire()}get contextValue(){return this.f}set contextValue(S){this.f=S,this.b.contextValue=S,this.c.fire()}get comments(){return this.q}set comments(S){this.q=S,this.b.comments=S,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(S){this.g=S,this.b.collapsibleState=S,this.c.fire()}get state(){return this.h}set state(S){this.h=S,typeof S=="object"?((0,k.$7G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=S.resolved,this.b.applicability=S.applicability):this.b.state=S,this.c.fire()}get isDisposed(){return this.j}constructor(S,C,A,b,v,M,N,L,j){this.m=C,this.n=A,this.o=b,this.p=v,this.q=M,this.extensionDescription=N,this.r=L,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$me,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Xc,this.l.value=new O.$Vc,this.n===void 0&&(this.n=`${S}.${this.handle}`),g.$createCommentThread(C,this.handle,this.n,this.o,I.Range.from(this.p),N.identifier,this.r,j),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=M,this.i.push({dispose:()=>{g.$deleteCommentThread(C,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(F){z.range=F},get comments(){return z.comments},set comments(F){z.comments=F},get collapsibleState(){return z.collapsibleState},set collapsibleState(F){z.collapsibleState=F},get canReply(){return z.canReply},set canReply(F){z.canReply=F},get contextValue(){return z.contextValue},set contextValue(F){z.contextValue=F},get label(){return z.label},set label(F){z.label=F},get state(){return z.state},set state(F){z.state=F},reveal:F=>z.reveal(F),dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Vc);const S=A=>Object.prototype.hasOwnProperty.call(this.b,A),C={};S("range")&&(C.range=I.Range.from(this.p)),S("label")&&(C.label=this.label),S("contextValue")&&(C.contextValue=this.contextValue??null),S("comments")&&(C.comments=this.q.map(A=>i(this,A,this.k,this.extensionDescription))),S("collapsibleState")&&(C.collapseState=u(this.g)),S("canReply")&&(C.canReply=this.canReply),S("state")&&(C.state=w(this.h)),S("applicability")&&(C.applicability=y(this.h)),S("isTemplate")&&(C.isTemplate=this.r),this.b={},g.$updateCommentThread(this.m,this.handle,this.n,this.o,C)}getCommentByUniqueId(S){for(const C of this.k){const A=C[0],b=C[1];if(S===b)return A}}async reveal(S){return(0,k.$7G)(this.extensionDescription,"commentReveal"),g.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...S})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(S=>S.dispose())}}Je([(0,h.$$h)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(S){this.b=S,S?.resourceHints&&(0,k.$7G)(this.h,"commentingRangeHint"),g.$updateCommentingRanges(this.handle,S?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(S){this.c=S,g.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!S})}get options(){return this.d}set options(S){this.d=S,g.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,k.$7G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,k.$7G)(this.h,"activeComment"),this.f}constructor(S,C,A,b){this.h=S,this.i=C,this.j=A,this.k=b,this.a=new Map,g.$registerCommentController(this.handle,A,b,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(M){v.options=M},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(M){v.commentingRangeProvider=M},get reactionHandler(){return v.reactionHandler},set reactionHandler(M){v.reactionHandler=M},get activeCommentThread(){return v.activeCommentThread},createCommentThread(M,N,L){return v.createCommentThread(M,N,L).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{g.$unregisterCommentController(this.handle)}})}createCommentThread(S,C,A){C===void 0&&(0,k.$7G)(this.h,"fileComments");const b=new o(this.id,this.handle,void 0,S,C,A,this.h,!1);return this.a.set(b.handle,b),b}$setActiveComment(S){if(!S){this.e=void 0,this.f=void 0;return}const C=this.a.get(S.commentThreadHandle);C&&(this.e=S.uniqueIdInThread?C.getCommentByUniqueId(S.uniqueIdInThread):void 0,this.f=C)}$createCommentThreadTemplate(S,C,A){const b=new o(this.id,this.handle,void 0,R.URI.revive(S),I.Range.to(C),[],this.h,!0,A);return b.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(b.handle,b),b}$updateCommentThreadTemplate(S,C){const A=this.a.get(S);A&&(A.range=I.Range.to(C))}$deleteCommentThread(S){this.a.get(S)?.dispose(),this.a.delete(S)}getCommentThread(S){return this.a.get(S)}dispose(){this.a.forEach(S=>{S.dispose()}),this.g.forEach(S=>S.dispose())}}function i(D,S,C,A){let b=C.get(S);return b||(b=++D.commentHandle,C.set(S,b)),S.state!==void 0&&(0,k.$7G)(A,"commentsDraftState"),S.reactions?.some(v=>v.reactors!==void 0)&&(0,k.$7G)(A,"commentReactor"),{mode:S.mode,contextValue:S.contextValue,uniqueIdInThread:b,body:typeof S.body=="string"?S.body:I.MarkdownString.from(S.body),userName:S.author.name,userIconPath:S.author.iconPath,label:S.label,commentReactions:S.reactions?S.reactions.map(v=>s(v)):void 0,state:S.state,timestamp:S.timestamp?.toJSON()}}function s(D){return{label:D.label,iconPath:D.iconPath?I.$ZP(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(S=>S.name):D.reactors}}function f(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?R.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(S=>({name:S}))}}function u(D){if(D!==void 0)switch(D){case E.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case E.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function w(D){let S;if(typeof D=="object"?S=D.resolved:S=D,S!==void 0)switch(S){case E.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case E.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function y(D){let S;if(typeof D=="object"&&(S=D.applicability),S!==void 0)switch(S){case E.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case E.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new n}}),define(ye[349],Se([1,0,21,60,3,15,23,2,16,97,119,6,10]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=void 0,$=We($),E=We(E),l=We(l);class k{constructor(s,f){this.document=s,this.b=f,this.a=1,this.c=new I.$hoc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,f){await this.f(s).undo(),f||this.disposeBackup()}async redo(s,f){await this.f(s).redo(),f||this.disposeBackup()}disposeEdits(s){for(const f of s)this.c.delete(f)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=t(this.document.uri)+this.a++;return(0,T.$gh)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const f=this.c.get(s,0);if(!f)throw new Error("No edit found");return f}}class p{constructor(){this.a=new Map}get(s,f){return this.a.get(this.b(s,f))}add(s,f,u){const w=this.b(s,f.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${s} resource:${f.uri}`);const y=new k(f,u);return this.a.set(w,y),y}delete(s,f){const u=this.b(s,f.uri);this.a.delete(u)}b(s,f){return`${s}@@@${f}`}}var c;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(c||(c={}));class m{constructor(){this.a=new Map}addTextProvider(s,f,u){return this.b(s,{type:c.Text,extension:f,provider:u})}addCustomProvider(s,f,u){return this.b(s,{type:c.Custom,extension:f,provider:u})}get(s){return this.a.get(s)}b(s,f){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,f),new l.$wN(()=>this.a.delete(s))}}class d{constructor(s,f,u,w,y){this.d=f,this.f=u,this.g=w,this.h=y,this.b=new m,this.c=new p,this.a=s.getProxy(E.$uN.MainThreadCustomEditors)}registerCustomEditorProvider(s,f,u,w){const y=new P.$Vc;return n(u)?(y.add(this.b.addTextProvider(f,s,u)),this.a.$registerTextEditorProvider((0,a.$Qoc)(s),f,w.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,a.$Ooc)(s))):(y.add(this.b.addCustomProvider(f,s,u)),g(u)&&y.add(u.onDidChangeCustomDocument(D=>{const S=this.i(f,D.document.uri);if(o(D)){const C=S.addEdit(D);this.a.$onDidEdit(D.document.uri,f,C,D.label)}else this.a.$onContentChange(D.document.uri,f)})),this.a.$registerCustomEditorProvider((0,a.$Qoc)(s),f,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,a.$Ooc)(s))),l.$wN.from(y,new l.$wN(()=>{this.a.$unregisterEditorProvider(f)}))}async $createCustomDocument(s,f,u,w,y){const D=this.b.get(f);if(!D)throw new Error(`No provider found for '${f}'`);if(D.type!==c.Custom)throw new Error(`Invalid provide type for '${f}'`);const S=R.URI.revive(s),C=await D.provider.openCustomDocument(S,{backupId:u,untitledDocumentData:w?.buffer},y);let A;return g(D.provider)&&this.f&&(A=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(f,C,A),{editable:g(D.provider)}}async $disposeCustomDocument(s,f){const u=this.b.get(f);if(!u)throw new Error(`No provider found for '${f}'`);if(u.type!==c.Custom)throw new Error(`Invalid provider type for '${f}'`);const w=R.URI.revive(s),{document:y}=this.i(f,w);this.c.delete(f,y),y.dispose()}async $resolveCustomEditor(s,f,u,w,y,D){const S=this.b.get(u);if(!S)throw new Error(`No provider found for '${u}'`);const C=$.ViewColumn.to(y),A=this.g.createNewWebview(f,w.contentOptions,S.extension),b=this.h.createNewWebviewPanel(f,u,w.title,C,w.options,A,w.active),v=R.URI.revive(s);switch(S.type){case c.Custom:{const{document:M}=this.i(u,v);return S.provider.resolveCustomEditor(M,b,D)}case c.Text:{const M=this.d.getDocument(v);return S.provider.resolveCustomTextEditor(M,b,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,f,u){this.i(f,s).disposeEdits(u)}async $onMoveCustomEditor(s,f,u){const w=this.b.get(u);if(!w)throw new Error(`No provider found for '${u}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const y=this.h.getWebviewPanel(s);if(!y)throw new Error("No webview found");const D=R.URI.revive(f),S=this.d.getDocument(D);await w.provider.moveCustomTextEditor(S,y,r.CancellationToken.None)}async $undo(s,f,u,w){return this.i(f,s).undo(u,w)}async $redo(s,f,u,w){return this.i(f,s).redo(u,w)}async $revert(s,f,u){const w=this.i(f,s);await this.j(f).revertCustomDocument(w.document,u),w.disposeBackup()}async $onSave(s,f,u){const w=this.i(f,s);await this.j(f).saveCustomDocument(w.document,u),w.disposeBackup()}async $onSaveAs(s,f,u,w){const y=this.i(f,s);return this.j(f).saveCustomDocumentAs(y.document,R.URI.revive(u),w)}async $backup(s,f,u){const w=this.i(f,s),D=await this.j(f).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},u);return w.updateBackup(D),D.id}i(s,f){const u=this.c.get(s,R.URI.revive(f));if(!u)throw new Error("No custom document found");return u}j(s){const u=this.b.get(s)?.provider;if(!u||!g(u))throw new Error("Custom document is not editable");return u}}e.$Toc=d;function g(i){return!!i.onDidChangeCustomDocument}function n(i){return typeof i.resolveCustomTextEditor=="function"}function o(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function t(i){const s=i.scheme===O.Schemas.file||i.scheme===O.Schemas.untitled?i.fsPath:i.toString();return(0,h.$tj)(s)+""}}),define(ye[350],Se([1,0,234,146,2,6,10,16,4,12,29,63]),function(ce,e,r,h,P,O,T,R,$,a,I,E){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=e.$ooc=void 0,R=We(R);class k{#e;#t;#i;constructor(m,d,g,n,o,t,i,s){this.d=m,this.e=d,this.f=g,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,g),this.#i=new I.$Cc(f=>t.getComparisonKey(f)),this.#e=i,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,d){if(!m){this.clear();return}this.j();let g=[];if(P.URI.isUri(m)){if(!d){this.delete(m);return}this.#i.set(m,d.slice()),g=[m]}else if(Array.isArray(m)){g=[];let t;m=[...m].sort(k.k);for(const i of m){const[s,f]=i;if((!t||s.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=s,g.push(s),this.#i.set(s,[])),f)this.#i.get(s)?.push(...f);else{const u=this.#i.get(s);u&&(u.length=0)}}}if(this.#t.fire(g),!this.#e)return;const n=[];let o=0;for(const t of g){let i=[];const s=this.#i.get(t);if(s)if(s.length>this.g){i=[];const f=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const w of s)if(w.severity===f[u]&&i.push({...R.Diagnostic.from(w),modelVersionId:this.h(t)})===this.g)break e;i.push({severity:h.MarkerSeverity.Info,message:(0,r.localize)(0,null,s.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=s.map(f=>({...R.Diagnostic.from(f),modelVersionId:this.h(t)}));if(n.push([t,i]),o+=i.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,d){this.j();for(const[g,n]of this)m.call(d,g,n,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const d=this.#i.get(m);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,d){return m[0].toString()<d[0].toString()?-1:m[0].toString()>d[0].toString()?1:0}}e.$ooc=k;let p=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(m){const d=new I.$Cc;for(const g of m)d.set(g,g);return{uris:Object.freeze(Array.from(d.values()))}}constructor(m,d,g,n){this.j=d,this.k=g,this.l=n,this.g=new Map,this.h=new $.$qe({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,l._mapper),this.f=m.getProxy(O.$uN.MainThreadDiagnostics)}createDiagnosticCollection(m,d){const{g,f:n,h:o,j:t,k:i,l:s}=this,f=new class{$changeMany(y,D){n.$changeMany(y,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,y,D.length===0?"CLEARING":D)}$clear(y){n.$clear(y),t.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,y)}dispose(){n.dispose()}};let u;if(!d)d="_generated_diagnostic_collection_name_#"+l.c++,u=d;else if(!g.has(d))u=d;else{this.j.warn(`DiagnosticCollection with name '${d}' does already exist.`);do u=d+l.c++;while(g.has(u))}return new class extends k{constructor(){super(d,u,l.e,l.d,y=>s.getDocument(y)?.version,i.extUri,f,o),g.set(u,this)}dispose(){super.dispose(),g.delete(u)}}}getDiagnostics(m){if(m)return this.m(m);{const d=new Map,g=[];for(const n of this.g.values())n.forEach((o,t)=>{let i=d.get(o.toString());typeof i>"u"&&(i=g.length,d.set(o.toString(),i),g.push([o,[]])),g[i][1]=g[i][1].concat(...t)});return g}}m(m){let d=[];for(const g of this.g.values())g.has(m)&&(d=d.concat(g.get(m)));return d}$acceptMarkersChange(m){if(!this.n){const d="_generated_mirror",g=new k(d,d,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(d,g),this.n=g}for(const[d,g]of m)this.n.set(P.URI.revive(d),g.map(R.Diagnostic.to))}};e.$poc=p,e.$poc=p=l=Je([Ve(1,a.$_j),Ve(2,E.$noc)],p)}),define(ye[351],Se([1,0,2,14,10,16,81,52]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=void 0;class ${constructor(I,E,l,k={timeout:1500,errors:3}){this.c=I,this.d=E,this.f=l,this.g=k,this.a=new T.$7c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(E,l,k)=>{const c={dispose:this.a.push([E,l,I])};return Array.isArray(k)&&k.push(c),c}}async $participateInSave(I,E){const l=r.URI.revive(I);let k=!1;const p=setTimeout(()=>k=!0,this.g.timeout),c=[];try{for(const m of[...this.a]){if(k)break;const d=this.d.getDocument(l),g=await this.h(m,{document:d,reason:O.TextDocumentSaveReason.to(E)});c.push(g)}}finally{clearTimeout(p)}return c}h([I,E,l],k){const p=this.b.get(I);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(l,I,E,k).then(()=>!0,c=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' threw ERROR`),this.c.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const m=this.b.get(I);this.b.set(I,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,E,l,k){const p=[],c=Date.now(),{document:m,reason:d}=k,{version:g}=m,n=Object.freeze({document:m,reason:d,waitUntil(o){if(Object.isFrozen(p))throw(0,h.$0)("waitUntil can not be called async");p.push(Promise.resolve(o))}});try{E.apply(l,[n])}catch(o){return Promise.reject(o)}return Object.freeze(p),new Promise((o,t)=>{const i=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(p).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(i),o(s)}).catch(s=>{clearTimeout(i),t(s)})}).then(o=>{const t={edits:[]};for(const i of o)if(Array.isArray(i)&&i.every(s=>s instanceof P.$DN))for(const{newText:s,newEol:f,range:u}of i)t.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:u&&O.Range.from(u),text:s,eol:f&&O.EndOfLine.from(f)}});if(t.edits.length!==0)return g===m.version?this.f.$tryApplyWorkspaceEdit(new R.$Tw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Cpc=$}),define(ye[352],Se([1,0,4,3,2,6,164,16,18,25,10]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0,R=We(R);class E{constructor(k,p){this.a=new r.$me,this.b=new r.$me,this.c=new r.$me,this.d=new r.$me,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new h.$Vc,this.h=new Map,this.f=k.getProxy(O.$uN.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(c=>{for(const m of c)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const m of c)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const p=this.g.getDocument(k);if(p)return p}getDocument(k){const p=this.getDocumentData(k);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return p.document}ensureDocumentData(k){const p=this.g.getDocument(k);if(p)return Promise.resolve(p);let c=this.h.get(k.toString());return c||(c=this.f.$tryOpenDocument(k).then(m=>{this.h.delete(k.toString());const d=P.URI.revive(m);return(0,$.$qg)(this.g.getDocument(d))},m=>(this.h.delete(k.toString()),Promise.reject(m))),this.h.set(k.toString(),c)),c}createDocumentData(k){return this.f.$tryCreateDocument(k).then(p=>P.URI.revive(p))}$acceptModelLanguageChanged(k,p){const c=P.URI.revive(k),m=this.g.getDocument(c);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(p),this.a.fire(m.document)}$acceptModelSaved(k){const p=P.URI.revive(k),c=this.g.getDocument(p);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(k,p){const c=P.URI.revive(k),m=this.g.getDocument(c);if(!m)throw new Error("unknown document");m._acceptIsDirty(p),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,p,c){const m=P.URI.revive(k),d=this.g.getDocument(m);if(!d)throw new Error("unknown document");d._acceptIsDirty(c),d.onEvents(p);let g;p.isUndoing?g=I.TextDocumentChangeReason.Undo:p.isRedoing&&(g=I.TextDocumentChangeReason.Redo),this.c.fire((0,a.$eo)({document:d.document,contentChanges:p.changes.map(n=>({range:R.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:g}))}setWordDefinitionFor(k,p){(0,T.$3P)(k,p)}}e.$qoc=E}),define(ye[78],Se([1,0,79,4,18,2,5,6,20,16,10]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=e.$Uoc=void 0,a=We(a),e.$Uoc=(0,T.$Fi)("IExtHostEditorTabs");class E{constructor(m,d,g){this.e=g,this.d=d,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,d={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(d)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case R.TabInputKind.TextInput:return new I.$hP(O.URI.revive(this.b.input.uri));case R.TabInputKind.TextDiffInput:return new I.$iP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case R.TabInputKind.TextMergeInput:return new I.$jP(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case R.TabInputKind.CustomEditorInput:return new I.$kP(O.URI.revive(this.b.input.uri),this.b.input.viewType);case R.TabInputKind.WebviewEditorInput:return new I.$lP(this.b.input.viewType);case R.TabInputKind.NotebookInput:return new I.$mP(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case R.TabInputKind.NotebookDiffInput:return new I.$nP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case R.TabInputKind.TerminalEditorInput:return new I.$oP;case R.TabInputKind.InteractiveEditorInput:return new I.$pP(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case R.TabInputKind.ChatEditorInput:return new I.$qP;case R.TabInputKind.MultiDiffEditorInput:return new I.$rP(this.b.input.diffEditors.map(m=>new I.$iP(O.URI.revive(m.original),O.URI.revive(m.modified))));default:return}}}class l{constructor(m,d){this.c=[],this.d="",this.b=m,this.e=d;for(const g of m.tabs)g.isActive&&(this.d=g.id),this.c.push(new E(g,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,d={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return a.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(g=>g.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(g=>g.apiObject))}};this.a=Object.freeze(d)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===R.TabModelOperationKind.TAB_OPEN){const g=new E(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,g),m.tabDto.isActive&&(this.d=g.tabId),g}else if(m.kind===R.TabModelOperationKind.TAB_CLOSE){const g=this.c.splice(m.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return g.tabId===this.d&&(this.d=""),g}else if(m.kind===R.TabModelOperationKind.TAB_MOVE){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this.c.splice(m.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,g),g}const d=this.c.find(g=>g.tabId===m.tabDto.id);if(!d)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),d.acceptDtoUpdate(m.tabDto),d}activeTabId(){return this.d}}let k=class{constructor(m){this.b=new h.$me,this.c=new h.$me,this.e=[],this.a=m.getProxy(R.$uN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,d={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(g=>g.apiObject))},get activeTabGroup(){const g=m.d;return(0,P.$qg)(m.e.find(o=>o.groupId===g)?.apiObject)},close:async(g,n)=>{const o=Array.isArray(g)?g:[g];return o.length?p(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(d)}return this.f}$acceptEditorTabModel(m){const d=new Set(this.e.map(f=>f.groupId)),g=new Set(m.map(f=>f.groupId)),n=(0,r.$L)(d,g),o=this.e.filter(f=>n.removed.includes(f.groupId)).map(f=>f.apiObject),t=[],i=[];this.e=m.map(f=>{const u=new l(f,()=>this.d);return n.added.includes(u.groupId)?t.push(u.apiObject):i.push(u.apiObject),u});const s=(0,P.$qg)(m.find(f=>f.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:t,closed:o,changed:i}))}$acceptTabGroupUpdate(m){const d=this.e.find(g=>g.groupId===m.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const d=this.e.find(n=>n.groupId===m.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const g=d.acceptTabOperation(m);switch(m.kind){case R.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case R.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case R.TabModelOperationKind.TAB_MOVE:case R.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}g(m){for(const d of this.e)for(const g of d.tabs)if(g.apiObject===m)return g}h(m){return this.e.find(d=>d.apiObject===m)}async i(m,d){const g=[];for(const n of m){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");g.push(o.tabId)}return this.a.$closeTab(g,d)}async j(m,d){const g=[];for(const n of m){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");g.push(o.groupId)}return this.a.$closeGroup(g,d)}};e.$Voc=k,e.$Voc=k=Je([Ve(0,$.$1P)],k);function p(c){return c.tabs!==void 0}}),define(ye[353],Se([1,0,2,6,28,3,10,16,195,13,27,22,26,86]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=void 0,P=We(P),R=We(R);class p{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const g=this.a.indexOf(d);g>=0&&(this.a.splice(g,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),g=[];let n,o,t=$.State.LastKnownState,i=$.State.LastKnownState;for(const s of d){let f=n?(0,a.$If)(n,s):0;for(f===0?o=$.State.Start:o=i;f<s.length;f++)f+1===s.length?(t=i,i=$.State.BeforeColon):i+=1,g.push([o,s.toUpperCase().charCodeAt(f),i]),g.push([o,s.toLowerCase().charCodeAt(f),i]),o=i;n=s,i=t}g.push([$.State.BeforeColon,I.CharCode.Colon,$.State.AfterColon]),g.push([$.State.AfterColon,I.CharCode.Slash,$.State.End]),this.b=new $.$p4(g)}}provideDocumentLinks(d){this.c();const g=[],n=$.$q4.computeLinks({getLineContent(o){return d.lineAt(o-1).text},getLineCount(){return d.lineCount}},this.b);for(const o of n){const t=R.DocumentLink.to(o);t.target&&g.push(t)}return g}}class c{constructor(d,g){this.i=g,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(h.$uN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,g,n,o={}){if(c.j(n),this.d.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const t=this.h++;this.b.add(g),this.d.add(g),this.c.set(t,n);let i=P.FileSystemProviderCapabilities.FileReadWrite;o.isCaseSensitive&&(i+=P.FileSystemProviderCapabilities.PathCaseSensitive),o.isReadonly&&(i+=P.FileSystemProviderCapabilities.Readonly),typeof n.copy=="function"&&(i+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,l.$7G)(d,"fsChunks"),i+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let s;o.isReadonly&&(0,k.$5k)(o.isReadonly)&&o.isReadonly.value!==""&&(s={value:o.isReadonly.value,isTrusted:o.isReadonly.isTrusted,supportThemeIcons:o.isReadonly.supportThemeIcons,supportHtml:o.isReadonly.supportHtml,baseUri:o.isReadonly.baseUri,uris:o.isReadonly.uris}),this.a.$registerFileSystemProvider(t,g,i,s).catch(u=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${g}`),console.error(u)});const f=n.onDidChangeFile(u=>{const w=[];for(const y of u){const{uri:D,type:S}=y;if(D.scheme!==g)continue;let C;switch(S){case T.FileChangeType.Changed:C=P.FileChangeType.UPDATED;break;case T.FileChangeType.Created:C=P.FileChangeType.ADDED;break;case T.FileChangeType.Deleted:C=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}w.push({resource:D,type:C})}this.a.$onFileSystemChange(t,w)});return(0,O.$Uc)(()=>{f.dispose(),this.b.delete(g),this.d.delete(g),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:g,ctime:n,mtime:o,size:t,permissions:i}=d;return{type:g,ctime:n,mtime:o,size:t,permissions:i}}$stat(d,g){return Promise.resolve(this.l(d).stat(r.URI.revive(g))).then(n=>c.k(n))}$readdir(d,g){return Promise.resolve(this.l(d).readDirectory(r.URI.revive(g)))}$readFile(d,g){return Promise.resolve(this.l(d).readFile(r.URI.revive(g))).then(n=>E.$Oe.wrap(n))}$writeFile(d,g,n,o){return Promise.resolve(this.l(d).writeFile(r.URI.revive(g),n.buffer,o))}$delete(d,g,n){return Promise.resolve(this.l(d).delete(r.URI.revive(g),n))}$rename(d,g,n,o){return Promise.resolve(this.l(d).rename(r.URI.revive(g),r.URI.revive(n),o))}$copy(d,g,n,o){const t=this.l(d);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(r.URI.revive(g),r.URI.revive(n),o))}$mkdir(d,g){return Promise.resolve(this.l(d).createDirectory(r.URI.revive(g)))}$watch(d,g,n,o){const t=this.l(d).watch(r.URI.revive(n),o);this.f.set(g,t)}$unwatch(d,g){const n=this.f.get(g);n&&(n.dispose(),this.f.delete(g))}$open(d,g,n){const o=this.l(d);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(r.URI.revive(g),n))}$close(d,g){const n=this.l(d);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(g))}$read(d,g,n,o){const t=this.l(d);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const i=E.$Oe.alloc(o);return Promise.resolve(t.read(g,n,i.buffer,0,o)).then(s=>i.slice(0,s))}$write(d,g,n,o){const t=this.l(d);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(g,n,o.buffer,0,o.byteLength))}l(d){const g=this.c.get(d);if(!g){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return g}}e.$Fpc=c}),define(ye[354],Se([1,0,4,39,2,6,16,10,28,49]),function(ce,e,r,h,P,O,T,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=void 0,T=We(T);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,c,m,d,g,n){this.a=Math.random(),this.b=new r.$me,this.c=new r.$me,this.d=new r.$me,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,h.$zk)(g),t=typeof g=="string",i=n?.correlate,s=d(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(i&&typeof f.session>"u")){if(!n?.ignoreCreateEvents)for(const u of f.created){const w=P.URI.revive(u);o(w.fsPath)&&(!t||c.getWorkspaceFolder(w))&&this.b.fire(w)}if(!n?.ignoreChangeEvents)for(const u of f.changed){const w=P.URI.revive(u);o(w.fsPath)&&(!t||c.getWorkspaceFolder(w))&&this.c.fire(w)}if(!n?.ignoreDeleteEvents)for(const u of f.deleted){const w=P.URI.revive(u);o(w.fsPath)&&(!t||c.getWorkspaceFolder(w))&&this.d.fire(w)}}});this.g=R.$wN.from(this.i(p,m,g,n,n?.correlate),this.b,this.c,this.d,s)}i(p,c,m,d,g){const n=R.$wN.from();if(typeof m=="string"||d?.ignoreChangeEvents&&d?.ignoreCreateEvents&&d?.ignoreDeleteEvents)return n;const o=p.getProxy(O.$uN.MainThreadFileSystemEventService);let t=!1;(m.pattern.includes(h.$vk)||m.pattern.includes(h.$wk))&&(t=!0);let i;return g&&(d?.ignoreChangeEvents||d?.ignoreCreateEvents||d?.ignoreDeleteEvents)&&(i=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,d?.ignoreChangeEvents&&(i&=~$.FileChangeFilter.UPDATED),d?.ignoreCreateEvents&&(i&=~$.FileChangeFilter.ADDED),d?.ignoreDeleteEvents&&(i&=~$.FileChangeFilter.DELETED)),o.$watch(c.identifier.value,this.a,m.baseUri,{recursive:t,excludes:d?.excludes??[],filter:i},!!g),R.$wN.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class E{constructor(p){this.a=p,this.session=this.a.session,this.b=new a.$X(()=>this.a.created.map(P.URI.revive)),this.c=new a.$X(()=>this.a.changed.map(P.URI.revive)),this.d=new a.$X(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class l{constructor(p,c,m){this.j=p,this.k=c,this.l=m,this.a=new r.$me,this.b=new r.$me,this.c=new r.$me,this.d=new r.$me,this.g=new r.$oe,this.h=new r.$oe,this.i=new r.$oe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,c,m,d){return new I(this.j,p,c,this.a.event,T.GlobPattern.from(m),d)}$onFileEvent(p){this.a.fire(new E(p))}$onDidRunFileOperation(p,c){switch(p){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:c.map(m=>({oldUri:P.URI.revive(m.source),newUri:P.URI.revive(m.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:c.map(m=>P.URI.revive(m.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:c.map(m=>P.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,c){return(m,d,g)=>{const n=function(t){m.call(d,t)};return n.extension=p,c.event(n,void 0,g)}}async $onWillRunFileOperation(p,c,m,d){switch(p){case $.FileOperation.MOVE:return await this.n(this.g,{files:c.map(g=>({oldUri:P.URI.revive(g.source),newUri:P.URI.revive(g.target)}))},m,d);case $.FileOperation.DELETE:return await this.n(this.i,{files:c.map(g=>P.URI.revive(g.target))},m,d);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:c.map(g=>P.URI.revive(g.target))},m,d)}}async n(p,c,m,d){const g=new Set,n=[];if(await p.fireAsync(c,d,async(t,i)=>{const s=Date.now(),f=await Promise.resolve(t);f instanceof R.$GN&&(n.push([i.extension,f]),g.add(i.extension.displayName??i.extension.identifier.value)),Date.now()-s>m&&this.k.warn("SLOW file-participant",i.extension.identifier)}),d.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,t]of n){const{edits:i}=T.WorkspaceEdit.from(t,{getTextDocumentVersion:s=>this.l.getDocument(s)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(i)}return{edit:o,extensionNames:Array.from(g)}}}e.$Gpc=l}),define(ye[355],Se([1,0,19,9,21,14,133,3,25,43,13,18,2,31,191,88,143,236,24,16,10,26,119,6]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0,c=We(c),n=We(n),s=We(s);class f{constructor(q,V){this.d=q,this.e=V}async provideDocumentSymbols(q,V){const J=this.d.getDocument(q),x=await this.e.provideDocumentSymbols(J,V);if(!(0,r.$Mb)(x))return x[0]instanceof o.$QN?x.map(n.DocumentSymbol.from):f.f(x)}static f(q){q=q.slice(0).sort((x,fe)=>{let be=x.location.range.start.compareTo(fe.location.range.start);return be===0&&(be=fe.location.range.end.compareTo(x.location.range.end)),be});const V=[],J=[];for(const x of q){const fe={name:x.name||"!!MISSING: name!!",kind:n.SymbolKind.from(x.kind),tags:x.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:n.Range.from(x.location.range),selectionRange:n.Range.from(x.location.range),children:[]};for(;;){if(J.length===0){J.push(fe),V.push(fe);break}const be=J[J.length-1];if(k.$Lt.containsRange(be.range,fe.range)&&!k.$Lt.equalsRange(be.range,fe.range)){be.children?.push(fe),J.push(fe);break}J.pop()}}return V}}class u{constructor(q,V,J,x,fe,be){this.f=q,this.g=V,this.h=J,this.j=x,this.k=fe,this.l=be,this.d=new i.$hoc("CodeLens"),this.e=new Map}async provideCodeLenses(q,V){const J=this.f.getDocument(q),x=await this.h.provideCodeLenses(J,V);if(!x||V.isCancellationRequested)return;const fe=this.d.add(x),be=new R.$Vc;this.e.set(fe,be);const Ne={cacheId:fe,lenses:[]};for(let Ge=0;Ge<x.length;Ge++)Ne.lenses.push({cacheId:[fe,Ge],range:n.Range.from(x[Ge].range),command:this.g.toInternal(x[Ge].command,be)});return Ne}async resolveCodeLens(q,V){const J=q.cacheId&&this.d.get(...q.cacheId);if(!J)return;let x;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?x=J:x=await this.h.resolveCodeLens(J,V),x||(x=J),V.isCancellationRequested)return;const fe=q.cacheId&&this.e.get(q.cacheId[0]);if(fe){if(!x.command){const be=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,be),this.l.error(be);return}return q.command=this.g.toInternal(x.command,fe),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function w(Oe){return Array.isArray(Oe)?Oe.map(n.DefinitionLink.from):Oe?[n.DefinitionLink.from(Oe)]:[]}class y{constructor(q,V){this.d=q,this.e=V}async provideDefinition(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),be=await this.e.provideDefinition(x,fe,J);return w(be)}}class D{constructor(q,V){this.d=q,this.e=V}async provideDeclaration(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),be=await this.e.provideDeclaration(x,fe,J);return w(be)}}class S{constructor(q,V){this.d=q,this.e=V}async provideImplementation(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),be=await this.e.provideImplementation(x,fe,J);return w(be)}}class C{constructor(q,V){this.d=q,this.e=V}async provideTypeDefinition(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),be=await this.e.provideTypeDefinition(x,fe,J);return w(be)}}class A{static{this.f=10}constructor(q,V){this.g=q,this.h=V,this.d=0,this.e=new Map}async provideHover(q,V,J,x){const fe=this.g.getDocument(q),be=n.Position.to(V);let Ne;if(J&&J.verbosityRequest){const rt=J.verbosityRequest.previousHover.id,ot=this.e.get(rt);if(!ot)throw new Error(`Hover with id ${rt} not found`);const nt={verbosityDelta:J.verbosityRequest.verbosityDelta,previousHover:ot};Ne=await this.h.provideHover(fe,be,x,nt)}else Ne=await this.h.provideHover(fe,be,x);if(!Ne||(0,r.$Mb)(Ne.contents))return;Ne.range||(Ne.range=fe.getWordRangeAtPosition(be)),Ne.range||(Ne.range=new o.$yN(be,be));const Ge=n.Hover.from(Ne),Ze=this.d;if(this.e.size===A.f){const rt=Math.min(...this.e.keys());this.e.delete(rt)}return this.e.set(Ze,Ne),this.d+=1,{...Ge,id:Ze}}releaseHover(q){this.e.delete(q)}}class b{constructor(q,V){this.d=q,this.e=V}async provideEvaluatableExpression(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),be=await this.e.provideEvaluatableExpression(x,fe,J);if(be)return n.EvaluatableExpression.from(be)}}class v{constructor(q,V){this.d=q,this.e=V}async provideInlineValues(q,V,J,x){const fe=this.d.getDocument(q),be=await this.e.provideInlineValues(fe,n.Range.to(V),n.InlineValueContext.to(J),x);if(Array.isArray(be))return be.map(Ne=>n.InlineValue.from(Ne))}}class M{constructor(q,V){this.d=q,this.e=V}async provideDocumentHighlights(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),be=await this.e.provideDocumentHighlights(x,fe,J);if(Array.isArray(be))return be.map(n.DocumentHighlight.from)}}class N{constructor(q,V){this.d=q,this.e=V}async provideMultiDocumentHighlights(q,V,J,x){const fe=this.d.getDocument(q),be=J.map(Ze=>this.d.getDocument(Ze)),Ne=n.Position.to(V),Ge=await this.e.provideMultiDocumentHighlights(fe,Ne,be,x);if(Array.isArray(Ge))return Ge.map(n.MultiDocumentHighlight.from)}}class L{constructor(q,V){this.d=q,this.e=V}async provideLinkedEditingRanges(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),be=await this.e.provideLinkedEditingRanges(x,fe,J);if(be&&Array.isArray(be.ranges))return{ranges:(0,r.$Jb)(be.ranges.map(n.Range.from)),wordPattern:be.wordPattern}}}class j{constructor(q,V){this.d=q,this.e=V}async provideReferences(q,V,J,x){const fe=this.d.getDocument(q),be=n.Position.to(V),Ne=await this.e.provideReferences(fe,be,J,x);if(Array.isArray(Ne))return Ne.map(n.location.from)}}class z{static{this.d=1e3}constructor(q,V,J,x,fe,be,Ne){this.g=q,this.h=V,this.j=J,this.k=x,this.l=fe,this.m=be,this.n=Ne,this.e=new i.$hoc("CodeAction"),this.f=new Map}async provideCodeActions(q,V,J,x){const fe=this.g.getDocument(q),be=p.$Nt.isISelection(V)?n.Selection.to(V):n.Range.to(V),Ne=[];for(const nt of this.j.getDiagnostics(q))if(be.intersection(nt.range)&&Ne.push(nt)>z.d)break;const Ge={diagnostics:Ne,only:J.only?new o.$SN(J.only):void 0,triggerKind:n.CodeActionTriggerKind.to(J.trigger)},Ze=await this.k.provideCodeActions(fe,be,Ge,x);if(!(0,r.$Nb)(Ze)||x.isCancellationRequested)return;const et=this.e.add(Ze),rt=new R.$Vc;this.f.set(et,rt);const ot=[];for(let nt=0;nt<Ze.length;nt++){const ct=Ze[nt];if(ct)if(z.o(ct))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:ct.title,command:this.h.toInternal(ct,rt)});else{Ge.only&&(ct.kind?Ge.only.contains(ct.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ge.only.value}' requested but returned code action is of kind '${ct.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ge.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const mt=ct.ranges??[];ot.push({cacheId:[et,nt],title:ct.title,command:ct.command&&this.h.toInternal(ct.command,rt),diagnostics:ct.diagnostics&&ct.diagnostics.map(n.Diagnostic.from),edit:ct.edit&&n.WorkspaceEdit.from(ct.edit,void 0),kind:ct.kind&&ct.kind.value,isPreferred:ct.isPreferred,isAI:(0,t.$6G)(this.m,"codeActionAI")?ct.isAI:!1,ranges:(0,t.$6G)(this.m,"codeActionRanges")?(0,r.$Jb)(mt.map(n.Range.from)):void 0,disabled:ct.disabled?.reason})}}return{cacheId:et,actions:ot}}async resolveCodeAction(q,V){const[J,x]=q,fe=this.e.get(J,x);if(!fe||z.o(fe))return{};if(!this.k.resolveCodeAction)return{};const be=await this.k.resolveCodeAction(fe,V)??fe;let Ne;be.edit&&(Ne=n.WorkspaceEdit.from(be.edit,void 0));let Ge;if(be.command){const Ze=this.f.get(J);Ze&&(Ge=this.h.toInternal(be.command,Ze))}return{edit:Ne,command:Ge}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class F{constructor(q,V,J,x,fe){this.e=q,this.f=V,this.g=J,this.h=x,this.j=fe,this.d=new i.$hoc("DocumentPasteEdit")}async prepareDocumentPaste(q,V,J,x){if(!this.g.prepareDocumentPaste)return;const fe=this.f.getDocument(q),be=V.map(Ze=>n.Range.to(Ze)),Ne=n.DataTransfer.toDataTransfer(J,()=>{throw new O.$ab});if(await this.g.prepareDocumentPaste(fe,be,Ne,x),x.isCancellationRequested)return;const Ge=Array.from(Ne).filter(([,Ze])=>!(Ze instanceof o.$mO));return n.DataTransfer.from(Ge)}async providePasteEdits(q,V,J,x,fe,be){if(!this.g.provideDocumentPasteEdits)return[];const Ne=this.f.getDocument(V),Ge=J.map(ot=>n.Range.to(ot)),Ze=n.DataTransfer.toDataTransfer(x,async ot=>(await this.e.$resolvePasteFileData(this.h,q,ot)).buffer),et=await this.g.provideDocumentPasteEdits(Ne,Ge,Ze,{only:fe.only?new o.$rO(fe.only):void 0,triggerKind:fe.triggerKind},be);if(!et||be.isCancellationRequested)return[];const rt=this.d.add(et);return et.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,d.localize)(0,null,this.j.displayName||this.j.name),kind:ot.kind,yieldTo:ot.yieldTo?.map(ct=>ct.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?n.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolvePasteEdit(q,V){const[J,x]=q,fe=this.d.get(J,x);if(!fe||!this.g.resolveDocumentPasteEdit)return{};const be=await this.g.resolveDocumentPasteEdit(fe,V)??fe;return{additionalEdit:be.additionalEdit?n.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releasePasteEdits(q){this.d.delete(q)}}class B{constructor(q,V){this.d=q,this.e=V}async provideDocumentFormattingEdits(q,V,J){const x=this.d.getDocument(q),fe=await this.e.provideDocumentFormattingEdits(x,V,J);if(Array.isArray(fe))return fe.map(n.TextEdit.from)}}class _{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeFormattingEdits(q,V,J,x){const fe=this.d.getDocument(q),be=n.Range.to(V),Ne=await this.e.provideDocumentRangeFormattingEdits(fe,be,J,x);if(Array.isArray(Ne))return Ne.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,V,J,x){(0,E.$pg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this.d.getDocument(q),be=V.map(n.Range.to),Ne=await this.e.provideDocumentRangesFormattingEdits(fe,be,J,x);if(Array.isArray(Ne))return Ne.map(n.TextEdit.from)}}class re{constructor(q,V){this.d=q,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,V,J,x,fe){const be=this.d.getDocument(q),Ne=n.Position.to(V),Ge=await this.e.provideOnTypeFormattingEdits(be,Ne,J,x,fe);if(Array.isArray(Ge))return Ge.map(n.TextEdit.from)}}class U{constructor(q,V){this.e=q,this.f=V,this.d=new i.$hoc("WorkspaceSymbols")}async provideWorkspaceSymbols(q,V){const J=await this.e.provideWorkspaceSymbols(q,V);if(!(0,r.$Nb)(J))return{symbols:[]};const x=this.d.add(J),fe={cacheId:x,symbols:[]};for(let be=0;be<J.length;be++){const Ne=J[be];if(!Ne||!Ne.name){this.f.warn("INVALID SymbolInformation",Ne);continue}fe.symbols.push({...n.WorkspaceSymbol.from(Ne),cacheId:[x,be]})}return fe}async resolveWorkspaceSymbol(q,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const J=this.d.get(...q.cacheId);if(J){const x=await this.e.resolveWorkspaceSymbol(J,V);return x&&(0,$.$go)(q,n.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class G{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,V,J){this.d=q,this.e=V,this.f=J}async provideRenameEdits(q,V,J,x){const fe=this.d.getDocument(q),be=n.Position.to(V);try{const Ne=await this.e.provideRenameEdits(fe,be,J,x);return Ne?n.WorkspaceEdit.from(Ne):void 0}catch(Ne){const Ge=G.g(Ne);return Ge?{rejectReason:Ge,edits:void 0}:Promise.reject(Ne)}}async resolveRenameLocation(q,V,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(q),fe=n.Position.to(V);try{const be=await this.e.prepareRename(x,fe,J);let Ne,Ge;if(o.$yN.isRange(be)?(Ne=be,Ge=x.getText(be)):(0,E.$hg)(be)&&(Ne=be.range,Ge=be.placeholder),!Ne||!Ge)return;if(Ne.start.line>fe.line||Ne.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Ne),text:Ge}}catch(be){const Ne=G.g(be);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(be)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class Q{static{this.d={[c.NewSymbolNameTriggerKind.Invoke]:o.NewSymbolNameTriggerKind.Invoke,[c.NewSymbolNameTriggerKind.Automatic]:o.NewSymbolNameTriggerKind.Automatic}}constructor(q,V,J){this.e=q,this.f=V,this.g=J}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(q,V,J,x){const fe=this.e.getDocument(q),be=n.Range.to(V);try{const Ne=Q.d[J],Ge=await this.f.provideNewSymbolNames(fe,be,Ne,x);return Ge?Ge.map(Ze=>typeof Ze=="string"?{newSymbolName:Ze}:{newSymbolName:Ze.newSymbolName,tags:Ze.tags}):void 0}catch(Ne){this.g.error(Q.h(Ne)??JSON.stringify(Ne,null,"	"));return}}static h(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class ee{constructor(q,V){this.resultId=q,this.tokens=V}}class he{constructor(q,V){this.f=q,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,V,J){const x=this.f.getDocument(q),fe=V!==0?this.d.get(V):null;let be=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,fe.resultId,J):await this.g.provideDocumentSemanticTokens(x,J);return fe&&this.d.delete(V),be?(be=he.h(be),this.o(he.n(fe,be),be)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return he.j(q)?he.k(q)?q:new o.$RO(new Uint32Array(q.data),q.resultId):he.l(q)?he.m(q)?q:new o.$TO(q.edits.map(V=>new o.$SO(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const V of q.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(q,V){if(!he.j(V)||!q||!q.tokens)return V;const J=q.tokens,x=J.length,fe=V.data,be=fe.length;let Ne=0;const Ge=Math.min(x,be);for(;Ne<Ge&&J[Ne]===fe[Ne];)Ne++;if(Ne===x&&Ne===be)return new o.$TO([],V.resultId);let Ze=0;const et=Ge-Ne;for(;Ze<et&&J[x-Ze-1]===fe[be-Ze-1];)Ze++;return new o.$TO([{start:Ne,deleteCount:x-Ne-Ze,data:fe.subarray(Ne,be-Ze)}],V.resultId)}o(q,V){if(he.j(q)){const J=this.e++;return this.d.set(J,new ee(q.resultId,q.data)),(0,m.$Fdb)({id:J,type:"full",data:q.data})}if(he.l(q)){const J=this.e++;return he.j(V)?this.d.set(J,new ee(V.resultId,V.data)):this.d.set(J,new ee(q.resultId)),(0,m.$Fdb)({id:J,type:"delta",deltas:(q.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class ne{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeSemanticTokens(q,V,J){const x=this.d.getDocument(q),fe=await this.e.provideDocumentRangeSemanticTokens(x,n.Range.to(V),J);return fe?this.f(fe):null}f(q){return(0,m.$Fdb)({id:0,type:"full",data:q.data})}}class De{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,V,J,x,fe){this.f=q,this.g=V,this.h=J,this.j=x,this.k=fe,this.d=new i.$hoc("CompletionItem"),this.e=new Map}async provideCompletionItems(q,V,J,x){const fe=this.f.getDocument(q),be=n.Position.to(V),Ne=fe.getWordRangeAtPosition(be)||new o.$yN(be,be),Ge=Ne.with({end:be}),Ze=new a.$ge,et=await this.h.provideCompletionItems(fe,be,x,n.CompletionContext.to(J));if(!et||x.isCancellationRequested)return;const rt=Array.isArray(et)?new o.$6N(et):et,ot=De.supportsResolving(this.h)?this.d.add(rt.items):this.d.add([]),nt=new R.$Vc;this.e.set(ot,nt);const ct=[],mt={x:ot,[s.ISuggestResultDtoField.completions]:ct,[s.ISuggestResultDtoField.defaultRanges]:{replace:n.Range.from(Ne),insert:n.Range.from(Ge)},[s.ISuggestResultDtoField.isIncomplete]:rt.isIncomplete||void 0,[s.ISuggestResultDtoField.duration]:Ze.elapsed()};for(let ht=0;ht<rt.items.length;ht++){const at=rt.items[ht],Pe=this.l(at,[ot,ht],Ge,Ne);ct.push(Pe)}return mt}async resolveCompletionItem(q,V){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...q);if(!J)return;const x=this.l(J,q),fe=await this.h.resolveCompletionItem(J,V);if(!fe)return;const be=this.l(fe,q);return(x[s.ISuggestDataDtoField.insertText]!==be[s.ISuggestDataDtoField.insertText]||x[s.ISuggestDataDtoField.insertTextRules]!==be[s.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(x[s.ISuggestDataDtoField.commandIdent]!==be[s.ISuggestDataDtoField.commandIdent]||x[s.ISuggestDataDtoField.commandId]!==be[s.ISuggestDataDtoField.commandId]||!(0,$.$ho)(x[s.ISuggestDataDtoField.commandArguments],be[s.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...x,[s.ISuggestDataDtoField.documentation]:be[s.ISuggestDataDtoField.documentation],[s.ISuggestDataDtoField.detail]:be[s.ISuggestDataDtoField.detail],[s.ISuggestDataDtoField.additionalTextEdits]:be[s.ISuggestDataDtoField.additionalTextEdits],[s.ISuggestDataDtoField.insertText]:be[s.ISuggestDataDtoField.insertText],[s.ISuggestDataDtoField.insertTextRules]:be[s.ISuggestDataDtoField.insertTextRules],[s.ISuggestDataDtoField.commandIdent]:be[s.ISuggestDataDtoField.commandIdent],[s.ISuggestDataDtoField.commandId]:be[s.ISuggestDataDtoField.commandId],[s.ISuggestDataDtoField.commandArguments]:be[s.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V,J,x){const fe=this.e.get(V[0]);if(!fe)throw Error("DisposableStore is missing...");const be=this.g.toInternal(q.command,fe),Ne={x:V,[s.ISuggestDataDtoField.label]:q.label,[s.ISuggestDataDtoField.kind]:q.kind!==void 0?n.CompletionItemKind.from(q.kind):void 0,[s.ISuggestDataDtoField.kindModifier]:q.tags&&q.tags.map(n.CompletionItemTag.from),[s.ISuggestDataDtoField.detail]:q.detail,[s.ISuggestDataDtoField.documentation]:typeof q.documentation>"u"?void 0:n.MarkdownString.fromStrict(q.documentation),[s.ISuggestDataDtoField.sortText]:q.sortText!==q.label?q.sortText:void 0,[s.ISuggestDataDtoField.filterText]:q.filterText!==q.label?q.filterText:void 0,[s.ISuggestDataDtoField.preselect]:q.preselect||void 0,[s.ISuggestDataDtoField.insertTextRules]:q.keepWhitespace?c.CompletionItemInsertTextRule.KeepWhitespace:c.CompletionItemInsertTextRule.None,[s.ISuggestDataDtoField.commitCharacters]:q.commitCharacters?.join(""),[s.ISuggestDataDtoField.additionalTextEdits]:q.additionalTextEdits&&q.additionalTextEdits.map(n.TextEdit.from),[s.ISuggestDataDtoField.commandIdent]:be?.$ident,[s.ISuggestDataDtoField.commandId]:be?.id,[s.ISuggestDataDtoField.commandArguments]:be?.$ident?void 0:be?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne[s.ISuggestDataDtoField.insertText]=q.textEdit.newText):typeof q.insertText=="string"?Ne[s.ISuggestDataDtoField.insertText]=q.insertText:q.insertText instanceof o.$HN&&(Ne[s.ISuggestDataDtoField.insertText]=q.insertText.value,Ne[s.ISuggestDataDtoField.insertTextRules]|=c.CompletionItemInsertTextRule.InsertAsSnippet);let Ge;return q.textEdit?Ge=q.textEdit.range:q.range&&(Ge=q.range),o.$yN.isRange(Ge)?Ne[s.ISuggestDataDtoField.range]=n.Range.from(Ge):Ge&&(!J?.isEqual(Ge.inserting)||!x?.isEqual(Ge.replacing))&&(Ne[s.ISuggestDataDtoField.range]={insert:n.Range.from(Ge.inserting),replace:n.Range.from(Ge.replacing)}),Ne}}class $e{async provideInlineCompletions(q,V,J,x){}async provideInlineEdits(q,V,J,x){}disposeCompletions(q){}handleDidShowCompletionItem(q,V,J){}handlePartialAccept(q,V,J,x){}}class K extends $e{constructor(q,V,J,x){super(),this.f=q,this.g=V,this.h=J,this.j=x,this.d=new se,this.e=(0,t.$6G)(this.f,"inlineCompletionsAdditions"),this.k={[c.InlineCompletionTriggerKind.Automatic]:o.InlineCompletionTriggerKind.Automatic,[c.InlineCompletionTriggerKind.Explicit]:o.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$6G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,V,J,x){const fe=this.g.getDocument(q),be=n.Position.to(V),Ne=await this.h.provideInlineCompletionItems(fe,be,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:n.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},x);if(!Ne||x.isCancellationRequested)return;const Ge=Array.isArray(Ne)?Ne:Ne.items,Ze=this.e?Array.isArray(Ne)?[]:Ne.commands||[]:[],et=this.e&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let rt;return{pid:this.d.createReferenceId({dispose(){rt?.dispose()},items:Ge}),items:Ge.map((nt,ct)=>{let mt;nt.command&&(rt||(rt=new R.$Vc),mt=this.j.toInternal(nt.command,rt));const ht=nt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:nt.filterText,range:nt.range?n.Range.from(nt.range):void 0,command:mt,idx:ct,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ze.map(nt=>(rt||(rt=new R.$Vc),this.j.toInternal(nt,rt))),suppressSuggestions:!1,enableForwardStability:et}}async provideInlineEdits(q,V,J,x){if(!this.h.provideInlineEdits)return;(0,t.$7G)(this.f,"inlineCompletionsAdditions");const fe=this.g.getDocument(q),be=n.Range.to(V),Ne=await this.h.provideInlineEdits(fe,be,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:n.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind],userPrompt:J.userPrompt},x);if(!Ne||x.isCancellationRequested)return;const Ge=Array.isArray(Ne)?Ne:Ne.items,Ze=this.e?Array.isArray(Ne)?[]:Ne.commands||[]:[],et=this.e&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let rt;return{pid:this.d.createReferenceId({dispose(){rt?.dispose()},items:Ge}),items:Ge.map((nt,ct)=>{let mt;nt.command&&(rt||(rt=new R.$Vc),mt=this.j.toInternal(nt.command,rt));const ht=nt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:nt.filterText,range:nt.range?n.Range.from(nt.range):void 0,command:mt,idx:ct,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ze.map(nt=>(rt||(rt=new R.$Vc),this.j.toInternal(nt,rt))),suppressSuggestions:!1,enableForwardStability:et}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,V,J){const x=this.d.get(q)?.items[V];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x,J)}handlePartialAccept(q,V,J,x){const fe=this.d.get(q)?.items[V];fe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(fe,J),this.h.handleDidPartiallyAcceptCompletionItem(fe,n.PartialAcceptInfo.to(x)))}}class W{async provideInlineEdits(q,V,J){const x=this.f.getDocument(q),fe=await this.g.provideInlineEdit(x,{triggerKind:this.e[V.triggerKind]},J);if(!fe||J.isCancellationRequested)return;let be;const Ne=this.d.createReferenceId({dispose(){be?.dispose()},item:fe});let Ge;fe.accepted&&(be||(be=new R.$Vc),Ge=this.h.toInternal(fe.accepted,be));let Ze;return fe.rejected&&(be||(be=new R.$Vc),Ze=this.h.toInternal(fe.rejected,be)),{pid:Ne,text:fe.text,range:n.Range.from(fe.range),accepted:Ge,rejected:Ze}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,V,J,x){this.f=V,this.g=J,this.h=x,this.d=new se,this.e={[c.InlineEditTriggerKind.Automatic]:o.InlineEditTriggerKind.Automatic,[c.InlineEditTriggerKind.Invoke]:o.InlineEditTriggerKind.Invoke}}}class se{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const V=this.e++;return this.d.set(V,q),V}disposeReferenceId(q){const V=this.d.get(q);return this.d.delete(q),V}get(q){return this.d.get(q)}}class ae{constructor(q,V){this.e=q,this.f=V,this.d=new i.$hoc("SignatureHelp")}async provideSignatureHelp(q,V,J,x){const fe=this.e.getDocument(q),be=n.Position.to(V),Ne=this.g(J),Ge=await this.f.provideSignatureHelp(fe,be,x,Ne);if(Ge){const Ze=this.d.add([Ge]);return{...n.SignatureHelp.from(Ge),id:Ze}}}g(q){let V;if(q.activeSignatureHelp){const J=n.SignatureHelp.to(q.activeSignatureHelp),x=this.d.get(q.activeSignatureHelp.id,0);x?(V=x,V.activeSignature=J.activeSignature,V.activeParameter=J.activeParameter):V=J}return{...q,activeSignatureHelp:V}}releaseSignatureHelp(q){this.d.delete(q)}}class te{constructor(q,V,J,x,fe){this.f=q,this.g=V,this.h=J,this.j=x,this.k=fe,this.d=new i.$hoc("InlayHints"),this.e=new Map}async provideInlayHints(q,V,J){const x=this.f.getDocument(q),fe=n.Range.to(V),be=await this.h.provideInlayHints(x,fe,J);if(!Array.isArray(be)||be.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(J.isCancellationRequested)return;const Ne=this.d.add(be);this.e.set(Ne,new R.$Vc);const Ge={hints:[],cacheId:Ne};for(let Ze=0;Ze<be.length;Ze++)this.l(be[Ze],fe)&&Ge.hints.push(this.m(be[Ze],[Ne,Ze]));return this.j.trace(`[InlayHints] ${Ge.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),Ge}async resolveInlayHint(q,V){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...q);if(!J)return;const x=await this.h.resolveInlayHint(J,V);if(x&&this.l(x))return this.m(x,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V){return q.label.length===0||Array.isArray(q.label)&&q.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(V&&!V.contains(q.position))}m(q,V){const J=this.e.get(V[0]);if(!J)throw Error("DisposableStore is missing...");const x={label:"",cacheId:V,tooltip:n.MarkdownString.fromStrict(q.tooltip),position:n.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(n.TextEdit.from),kind:q.kind&&n.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")x.label=q.label;else{const fe=[];x.label=fe;for(const be of q.label){if(!be.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ne={label:be.value,tooltip:n.MarkdownString.fromStrict(be.tooltip)};o.$IN.isLocation(be.location)&&(Ne.location=n.location.from(be.location)),be.command&&(Ne.command=this.g.toInternal(be.command,J)),fe.push(Ne)}}return x}}class le{constructor(q,V){this.e=q,this.f=V,this.d=new i.$hoc("DocumentLink")}async provideLinks(q,V){const J=this.e.getDocument(q),x=await this.f.provideDocumentLinks(J,V);if(!(!Array.isArray(x)||x.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(le.g).map(n.DocumentLink.from)};{const fe=this.d.add(x),be={links:[],cacheId:fe};for(let Ne=0;Ne<x.length;Ne++){if(!le.g(x[Ne]))continue;const Ge=n.DocumentLink.from(x[Ne]);Ge.cacheId=[fe,Ne],be.links.push(Ge)}return be}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,V){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...q);if(!J)return;const x=await this.f.resolveDocumentLink(J,V);if(!(!x||!le.g(x)))return n.DocumentLink.from(x)}releaseLinks(q){this.d.delete(q)}}class ue{constructor(q,V){this.d=q,this.e=V}async provideColors(q,V){const J=this.d.getDocument(q),x=await this.e.provideDocumentColors(J,V);return Array.isArray(x)?x.map(be=>({color:n.Color.from(be.color),range:n.Range.from(be.range)})):[]}async provideColorPresentations(q,V,J){const x=this.d.getDocument(q),fe=n.Range.to(V.range),be=n.Color.to(V.color),Ne=await this.e.provideColorPresentations(be,{document:x,range:fe},J);if(Array.isArray(Ne))return Ne.map(n.ColorPresentation.from)}}class X{constructor(q,V){this.d=q,this.e=V}async provideFoldingRanges(q,V,J){const x=this.d.getDocument(q),fe=await this.e.provideFoldingRanges(x,V,J);if(Array.isArray(fe))return fe.map(n.FoldingRange.from)}}class oe{constructor(q,V,J){this.d=q,this.e=V,this.f=J}async provideSelectionRanges(q,V,J){const x=this.d.getDocument(q),fe=V.map(n.Position.to),be=await this.e.provideSelectionRanges(x,fe,J);if(!(0,r.$Nb)(be))return[];if(be.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let Ge=0;Ge<fe.length;Ge++){const Ze=[];Ne.push(Ze);let et=fe[Ge],rt=be[Ge];for(;;){if(!rt.range.contains(et))throw new Error("INVALID selection range, must contain the previous range");if(Ze.push(n.SelectionRange.from(rt)),!rt.parent)break;et=rt.range,rt=rt.parent}}return Ne}}class pe{constructor(q,V){this.f=q,this.g=V,this.d=new T.$6P(""),this.e=new Map}async prepareSession(q,V,J){const x=this.f.getDocument(q),fe=n.Position.to(V),be=await this.g.prepareCallHierarchy(x,fe,J);if(!be)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(be)?be.map(Ge=>this.h(Ne,Ge)):[this.h(Ne,be)]}async provideCallsTo(q,V,J){const x=this.j(q,V);if(!x)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(x,J);if(fe)return fe.map(be=>({from:this.h(q,be.from),fromRanges:be.fromRanges.map(Ne=>n.Range.from(Ne))}))}async provideCallsFrom(q,V,J){const x=this.j(q,V);if(!x)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(x,J);if(fe)return fe.map(be=>({to:this.h(q,be.to),fromRanges:be.fromRanges.map(Ne=>n.Range.from(Ne))}))}releaseSession(q){this.e.delete(q)}h(q,V){const J=this.e.get(q),x=n.CallHierarchyItem.from(V,q,J.size.toString(36));return J.set(x._itemId,V),x}j(q,V){return this.e.get(q)?.get(V)}}class we{constructor(q,V){this.f=q,this.g=V,this.d=new T.$6P(""),this.e=new Map}async prepareSession(q,V,J){const x=this.f.getDocument(q),fe=n.Position.to(V),be=await this.g.prepareTypeHierarchy(x,fe,J);if(!be)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(be)?be.map(Ge=>this.h(Ne,Ge)):[this.h(Ne,be)]}async provideSupertypes(q,V,J){const x=this.j(q,V);if(!x)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(x,J);if(fe)return fe.map(be=>this.h(q,be))}async provideSubtypes(q,V,J){const x=this.j(q,V);if(!x)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(x,J);if(fe)return fe.map(be=>this.h(q,be))}releaseSession(q){this.e.delete(q)}h(q,V){const J=this.e.get(q),x=n.TypeHierarchyItem.from(V,q,J.size.toString(36));return J.set(x._itemId,V),x}j(q,V){return this.e.get(q)?.get(V)}}class Fe{constructor(q,V,J,x,fe){this.e=q,this.f=V,this.g=J,this.h=x,this.j=fe,this.d=new i.$hoc("DocumentDropEdit")}async provideDocumentOnDropEdits(q,V,J,x,fe){const be=this.f.getDocument(V),Ne=n.Position.to(J),Ge=n.DataTransfer.toDataTransfer(x,async ot=>(await this.e.$resolveDocumentOnDropFileData(this.h,q,ot)).buffer),Ze=await this.g.provideDocumentDropEdits(be,Ne,Ge,fe);if(!Ze)return;const et=(0,r.$4b)(Ze),rt=this.d.add(et);return et.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,d.localize)(1,null,this.j.displayName||this.j.name),kind:ot.kind?.value,yieldTo:ot.yieldTo?.map(ct=>ct.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?n.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolveDropEdit(q,V){const[J,x]=q,fe=this.d.get(J,x);if(!fe||!this.g.resolveDocumentDropEdit)return{};const be=await this.g.resolveDocumentDropEdit(fe,V)??fe;return{additionalEdit:be.additionalEdit?n.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releaseDropEdits(q){this.d.delete(q)}}class Ue{constructor(q,V){this.d=q,this.e=V}async provideMappedEdits(q,V,J,x){const fe=l.URI.revive(q),be=this.d.getDocument(fe),Ne=J.documents.map(et=>et.map(rt=>({uri:l.URI.revive(rt.uri),version:rt.version,ranges:rt.ranges.map(ot=>n.Range.to(ot))}))),Ge={documents:Ne,selections:Ne[0]?.[0]?.ranges??[]},Ze=await this.e.provideMappedEdits(be,V,Ge,x);return Ze?n.WorkspaceEdit.from(Ze):null}}class ke{constructor(q,V){this.adapter=q,this.extension=V}}class Ie{static{this.d=0}constructor(q,V,J,x,fe,be,Ne,Ge){this.g=V,this.h=J,this.j=x,this.k=fe,this.l=be,this.m=Ne,this.n=Ge,this.f=new Map,this.e=q.getProxy(s.$uN.MainThreadLanguageFeatures)}o(q,V){return n.DocumentSelector.from(q,this.g,V)}p(q){return new o.$wN(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Ie.d++}async s(q,V,J,x,fe,be=!1){const Ne=this.f.get(q);if(!Ne||!(Ne.adapter instanceof V))return x;const Ge=Date.now();be||this.l.trace(`[${Ne.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Ze=J(Ne.adapter,Ne.extension);return Promise.resolve(Ze).catch(et=>{(0,O.$6)(et)||(this.l.error(`[${Ne.extension.identifier.value}] provider FAILED`),this.l.error(et),this.n.onExtensionError(Ne.extension.identifier,et))}).finally(()=>{be||this.l.trace(`[${Ne.extension.identifier.value}] provider DONE after ${Date.now()-Ge}ms`)}),P.CancellationToken.isCancellationToken(fe)?(0,h.$uh)(Ze,fe):Ze}t(q,V){const J=this.q();return this.f.set(J,new ke(q,V)),J}static u(q){return q.displayName||q.name}static w(q){return q.identifier.value}registerDocumentSymbolProvider(q,V,J,x){const fe=this.t(new f(this.h,J),q),be=x&&x.label||Ie.u(q);return this.e.$registerDocumentSymbolProvider(fe,this.o(V,q),be),this.p(fe)}$provideDocumentSymbols(q,V,J){return this.s(q,f,x=>x.provideDocumentSymbols(l.URI.revive(V),J),void 0,J)}registerCodeLensProvider(q,V,J){const x=this.q(),fe=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new ke(new u(this.h,this.j.converter,J,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(x,this.o(V,q),fe);let be=this.p(x);if(fe!==void 0){const Ne=J.onDidChangeCodeLenses(Ge=>this.e.$emitCodeLensEvent(fe));be=o.$wN.from(be,Ne)}return be}$provideCodeLenses(q,V,J){return this.s(q,u,x=>x.provideCodeLenses(l.URI.revive(V),J),void 0,J)}$resolveCodeLens(q,V,J){return this.s(q,u,x=>x.resolveCodeLens(V,J),void 0,void 0)}$releaseCodeLenses(q,V){this.s(q,u,J=>Promise.resolve(J.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(q,V,J){const x=this.t(new y(this.h,J),q);return this.e.$registerDefinitionSupport(x,this.o(V,q)),this.p(x)}$provideDefinition(q,V,J,x){return this.s(q,y,fe=>fe.provideDefinition(l.URI.revive(V),J,x),[],x)}registerDeclarationProvider(q,V,J){const x=this.t(new D(this.h,J),q);return this.e.$registerDeclarationSupport(x,this.o(V,q)),this.p(x)}$provideDeclaration(q,V,J,x){return this.s(q,D,fe=>fe.provideDeclaration(l.URI.revive(V),J,x),[],x)}registerImplementationProvider(q,V,J){const x=this.t(new S(this.h,J),q);return this.e.$registerImplementationSupport(x,this.o(V,q)),this.p(x)}$provideImplementation(q,V,J,x){return this.s(q,S,fe=>fe.provideImplementation(l.URI.revive(V),J,x),[],x)}registerTypeDefinitionProvider(q,V,J){const x=this.t(new C(this.h,J),q);return this.e.$registerTypeDefinitionSupport(x,this.o(V,q)),this.p(x)}$provideTypeDefinition(q,V,J,x){return this.s(q,C,fe=>fe.provideTypeDefinition(l.URI.revive(V),J,x),[],x)}registerHoverProvider(q,V,J,x){const fe=this.t(new A(this.h,J),q);return this.e.$registerHoverProvider(fe,this.o(V,q)),this.p(fe)}$provideHover(q,V,J,x,fe){return this.s(q,A,be=>be.provideHover(l.URI.revive(V),J,x,fe),void 0,fe)}$releaseHover(q,V){this.s(q,A,J=>Promise.resolve(J.releaseHover(V)),void 0,void 0)}registerEvaluatableExpressionProvider(q,V,J,x){const fe=this.t(new b(this.h,J),q);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(V,q)),this.p(fe)}$provideEvaluatableExpression(q,V,J,x){return this.s(q,b,fe=>fe.provideEvaluatableExpression(l.URI.revive(V),J,x),void 0,x)}registerInlineValuesProvider(q,V,J,x){const fe=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,be=this.t(new v(this.h,J),q);this.e.$registerInlineValuesProvider(be,this.o(V,q),fe);let Ne=this.p(be);if(fe!==void 0){const Ge=J.onDidChangeInlineValues(Ze=>this.e.$emitInlineValuesEvent(fe));Ne=o.$wN.from(Ne,Ge)}return Ne}$provideInlineValues(q,V,J,x,fe){return this.s(q,v,be=>be.provideInlineValues(l.URI.revive(V),J,x,fe),void 0,fe)}registerDocumentHighlightProvider(q,V,J){const x=this.t(new M(this.h,J),q);return this.e.$registerDocumentHighlightProvider(x,this.o(V,q)),this.p(x)}registerMultiDocumentHighlightProvider(q,V,J){const x=this.t(new N(this.h,J),q);return this.e.$registerMultiDocumentHighlightProvider(x,this.o(V,q)),this.p(x)}$provideDocumentHighlights(q,V,J,x){return this.s(q,M,fe=>fe.provideDocumentHighlights(l.URI.revive(V),J,x),void 0,x)}$provideMultiDocumentHighlights(q,V,J,x,fe){return this.s(q,N,be=>be.provideMultiDocumentHighlights(l.URI.revive(V),J,x.map(Ne=>l.URI.revive(Ne)),fe),void 0,fe)}registerLinkedEditingRangeProvider(q,V,J){const x=this.t(new L(this.h,J),q);return this.e.$registerLinkedEditingRangeProvider(x,this.o(V,q)),this.p(x)}$provideLinkedEditingRanges(q,V,J,x){return this.s(q,L,async fe=>{const be=await fe.provideLinkedEditingRanges(l.URI.revive(V),J,x);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?Ie.y(be.wordPattern):void 0}},void 0,x)}registerReferenceProvider(q,V,J){const x=this.t(new j(this.h,J),q);return this.e.$registerReferenceSupport(x,this.o(V,q)),this.p(x)}$provideReferences(q,V,J,x,fe){return this.s(q,j,be=>be.provideReferences(l.URI.revive(V),J,x,fe),void 0,fe)}registerCodeActionProvider(q,V,J,x){const fe=new R.$Vc,be=this.t(new z(this.h,this.j.converter,this.k,J,this.l,q,this.m),q);return this.e.$registerCodeActionSupport(be,this.o(V,q),{providedKinds:x?.providedCodeActionKinds?.map(Ne=>Ne.value),documentation:x?.documentation?.map(Ne=>({kind:Ne.kind.value,command:this.j.converter.toInternal(Ne.command,fe)}))},Ie.u(q),Ie.w(q),!!J.resolveCodeAction),fe.add(this.p(be)),fe}$provideCodeActions(q,V,J,x,fe){return this.s(q,z,be=>be.provideCodeActions(l.URI.revive(V),J,x,fe),void 0,fe)}$resolveCodeAction(q,V,J){return this.s(q,z,x=>x.resolveCodeAction(V,J),{},void 0)}$releaseCodeActions(q,V){this.s(q,z,J=>Promise.resolve(J.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(q,V,J){const x=this.t(new B(this.h,J),q);return this.e.$registerDocumentFormattingSupport(x,this.o(V,q),q.identifier,q.displayName||q.name),this.p(x)}$provideDocumentFormattingEdits(q,V,J,x){return this.s(q,B,fe=>fe.provideDocumentFormattingEdits(l.URI.revive(V),J,x),void 0,x)}registerDocumentRangeFormattingEditProvider(q,V,J){const x=typeof J.provideDocumentRangesFormattingEdits=="function",fe=this.t(new _(this.h,J),q);return this.e.$registerRangeFormattingSupport(fe,this.o(V,q),q.identifier,q.displayName||q.name,x),this.p(fe)}$provideDocumentRangeFormattingEdits(q,V,J,x,fe){return this.s(q,_,be=>be.provideDocumentRangeFormattingEdits(l.URI.revive(V),J,x,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(q,V,J,x,fe){return this.s(q,_,be=>be.provideDocumentRangesFormattingEdits(l.URI.revive(V),J,x,fe),void 0,fe)}registerOnTypeFormattingEditProvider(q,V,J,x){const fe=this.t(new re(this.h,J),q);return this.e.$registerOnTypeFormattingSupport(fe,this.o(V,q),x,q.identifier),this.p(fe)}$provideOnTypeFormattingEdits(q,V,J,x,fe,be){return this.s(q,re,Ne=>Ne.provideOnTypeFormattingEdits(l.URI.revive(V),J,x,fe,be),void 0,be)}registerWorkspaceSymbolProvider(q,V){const J=this.t(new U(V,this.l),q);return this.e.$registerNavigateTypeSupport(J,typeof V.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(q,V,J){return this.s(q,U,x=>x.provideWorkspaceSymbols(V,J),{symbols:[]},J)}$resolveWorkspaceSymbol(q,V,J){return this.s(q,U,x=>x.resolveWorkspaceSymbol(V,J),void 0,void 0)}$releaseWorkspaceSymbols(q,V){this.s(q,U,J=>J.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(q,V,J){const x=this.t(new G(this.h,J,this.l),q);return this.e.$registerRenameSupport(x,this.o(V,q),G.supportsResolving(J)),this.p(x)}$provideRenameEdits(q,V,J,x,fe){return this.s(q,G,be=>be.provideRenameEdits(l.URI.revive(V),J,x,fe),void 0,fe)}$resolveRenameLocation(q,V,J,x){return this.s(q,G,fe=>fe.resolveRenameLocation(l.URI.revive(V),J,x),void 0,x)}registerNewSymbolNamesProvider(q,V,J){const x=this.t(new Q(this.h,J,this.l),q);return this.e.$registerNewSymbolNamesProvider(x,this.o(V,q)),this.p(x)}$supportsAutomaticNewSymbolNamesTriggerKind(q){return this.s(q,Q,V=>V.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(q,V,J,x,fe){return this.s(q,Q,be=>be.provideNewSymbolNames(l.URI.revive(V),J,x,fe),void 0,fe)}registerDocumentSemanticTokensProvider(q,V,J,x){const fe=this.t(new he(this.h,J),q),be=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(V,q),x,be);let Ne=this.p(fe);if(be){const Ge=J.onDidChangeSemanticTokens(Ze=>this.e.$emitDocumentSemanticTokensEvent(be));Ne=o.$wN.from(Ne,Ge)}return Ne}$provideDocumentSemanticTokens(q,V,J,x){return this.s(q,he,fe=>fe.provideDocumentSemanticTokens(l.URI.revive(V),J,x),null,x)}$releaseDocumentSemanticTokens(q,V){this.s(q,he,J=>J.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,V,J,x){const fe=this.t(new ne(this.h,J),q);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(V,q),x),this.p(fe)}$provideDocumentRangeSemanticTokens(q,V,J,x){return this.s(q,ne,fe=>fe.provideDocumentRangeSemanticTokens(l.URI.revive(V),J,x),null,x)}registerCompletionItemProvider(q,V,J,x){const fe=this.t(new De(this.h,this.j.converter,J,this.m,q),q);return this.e.$registerCompletionsProvider(fe,this.o(V,q),x,De.supportsResolving(J),q.identifier),this.p(fe)}$provideCompletionItems(q,V,J,x,fe){return this.s(q,De,be=>be.provideCompletionItems(l.URI.revive(V),J,x,fe),void 0,fe)}$resolveCompletionItem(q,V,J){return this.s(q,De,x=>x.resolveCompletionItem(V,J),void 0,J)}$releaseCompletionItems(q,V){this.s(q,De,J=>J.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(q,V,J,x){const fe=new K(q,this.h,J,this.j.converter),be=this.t(fe,q);return this.e.$registerInlineCompletionsSupport(be,this.o(V,q),fe.supportsHandleEvents,g.$qn.toKey(q.identifier.value),x?.yieldTo?.map(Ne=>g.$qn.toKey(Ne))||[]),this.p(be)}$provideInlineCompletions(q,V,J,x,fe){return this.s(q,$e,be=>be.provideInlineCompletions(l.URI.revive(V),J,x,fe),void 0,fe)}$provideInlineEdits(q,V,J,x,fe){return this.s(q,$e,be=>be.provideInlineEdits(l.URI.revive(V),J,x,fe),void 0,fe)}$handleInlineCompletionDidShow(q,V,J,x){this.s(q,$e,async fe=>{fe.handleDidShowCompletionItem(V,J,x)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,V,J,x,fe){this.s(q,$e,async be=>{be.handlePartialAccept(V,J,x,fe)},void 0,void 0)}$freeInlineCompletionsList(q,V){this.s(q,$e,async J=>{J.disposeCompletions(V)},void 0,void 0)}registerInlineEditProvider(q,V,J){const x=new W(q,this.h,J,this.j.converter),fe=this.t(x,q);return this.e.$registerInlineEditProvider(fe,this.o(V,q),q.identifier),this.p(fe)}$provideInlineEdit(q,V,J,x){return this.s(q,W,fe=>fe.provideInlineEdits(l.URI.revive(V),J,x),void 0,x)}$freeInlineEdit(q,V){this.s(q,W,async J=>{J.disposeEdit(V)},void 0,void 0)}registerSignatureHelpProvider(q,V,J,x){const fe=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,be=this.t(new ae(this.h,J),q);return this.e.$registerSignatureHelpProvider(be,this.o(V,q),fe),this.p(be)}$provideSignatureHelp(q,V,J,x,fe){return this.s(q,ae,be=>be.provideSignatureHelp(l.URI.revive(V),J,x,fe),void 0,fe)}$releaseSignatureHelp(q,V){this.s(q,ae,J=>J.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(q,V,J){const x=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new te(this.h,this.j.converter,J,this.l,q),q);this.e.$registerInlayHintsProvider(fe,this.o(V,q),typeof J.resolveInlayHint=="function",x,Ie.u(q));let be=this.p(fe);if(x!==void 0){const Ne=J.onDidChangeInlayHints(Ge=>this.e.$emitInlayHintsEvent(x));be=o.$wN.from(be,Ne)}return be}$provideInlayHints(q,V,J,x){return this.s(q,te,fe=>fe.provideInlayHints(l.URI.revive(V),J,x),void 0,x)}$resolveInlayHint(q,V,J){return this.s(q,te,x=>x.resolveInlayHint(V,J),void 0,J)}$releaseInlayHints(q,V){this.s(q,te,J=>J.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(q,V,J){const x=this.t(new le(this.h,J),q);return this.e.$registerDocumentLinkProvider(x,this.o(V,q),typeof J.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(q,V,J){return this.s(q,le,x=>x.provideLinks(l.URI.revive(V),J),void 0,J,V.scheme==="output")}$resolveDocumentLink(q,V,J){return this.s(q,le,x=>x.resolveLink(V,J),void 0,void 0,!0)}$releaseDocumentLinks(q,V){this.s(q,le,J=>J.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(q,V,J){const x=this.t(new ue(this.h,J),q);return this.e.$registerDocumentColorProvider(x,this.o(V,q)),this.p(x)}$provideDocumentColors(q,V,J){return this.s(q,ue,x=>x.provideColors(l.URI.revive(V),J),[],J)}$provideColorPresentations(q,V,J,x){return this.s(q,ue,fe=>fe.provideColorPresentations(l.URI.revive(V),J,x),void 0,x)}registerFoldingRangeProvider(q,V,J){const x=this.q(),fe=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new ke(new X(this.h,J),q)),this.e.$registerFoldingRangeProvider(x,this.o(V,q),q.identifier,fe);let be=this.p(x);if(fe!==void 0){const Ne=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));be=o.$wN.from(be,Ne)}return be}$provideFoldingRanges(q,V,J,x){return this.s(q,X,fe=>fe.provideFoldingRanges(l.URI.revive(V),J,x),void 0,x)}registerSelectionRangeProvider(q,V,J){const x=this.t(new oe(this.h,J,this.l),q);return this.e.$registerSelectionRangeProvider(x,this.o(V,q)),this.p(x)}$provideSelectionRanges(q,V,J,x){return this.s(q,oe,fe=>fe.provideSelectionRanges(l.URI.revive(V),J,x),[],x)}registerCallHierarchyProvider(q,V,J){const x=this.t(new pe(this.h,J),q);return this.e.$registerCallHierarchyProvider(x,this.o(V,q)),this.p(x)}$prepareCallHierarchy(q,V,J,x){return this.s(q,pe,fe=>Promise.resolve(fe.prepareSession(l.URI.revive(V),J,x)),void 0,x)}$provideCallHierarchyIncomingCalls(q,V,J,x){return this.s(q,pe,fe=>fe.provideCallsTo(V,J,x),void 0,x)}$provideCallHierarchyOutgoingCalls(q,V,J,x){return this.s(q,pe,fe=>fe.provideCallsFrom(V,J,x),void 0,x)}$releaseCallHierarchy(q,V){this.s(q,pe,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(q,V,J){const x=this.t(new we(this.h,J),q);return this.e.$registerTypeHierarchyProvider(x,this.o(V,q)),this.p(x)}$prepareTypeHierarchy(q,V,J,x){return this.s(q,we,fe=>Promise.resolve(fe.prepareSession(l.URI.revive(V),J,x)),void 0,x)}$provideTypeHierarchySupertypes(q,V,J,x){return this.s(q,we,fe=>fe.provideSupertypes(V,J,x),void 0,x)}$provideTypeHierarchySubtypes(q,V,J,x){return this.s(q,we,fe=>fe.provideSubtypes(V,J,x),void 0,x)}$releaseTypeHierarchy(q,V){this.s(q,we,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(q,V,J,x){const fe=this.q();return this.f.set(fe,new ke(new Fe(this.e,this.h,J,fe,q),q)),this.e.$registerDocumentOnDropEditProvider(fe,this.o(V,q),(0,t.$6G)(q,"documentPaste")&&x?{supportsResolve:!!J.resolveDocumentDropEdit,dropMimeTypes:x.dropMimeTypes}:void 0),this.p(fe)}$provideDocumentOnDropEdits(q,V,J,x,fe,be){return this.s(q,Fe,Ne=>Promise.resolve(Ne.provideDocumentOnDropEdits(V,l.URI.revive(J),x,fe,be)),void 0,void 0)}$resolveDropEdit(q,V,J){return this.s(q,Fe,x=>x.resolveDropEdit(V,J),{},void 0)}$releaseDocumentOnDropEdits(q,V){this.s(q,Fe,J=>Promise.resolve(J.releaseDropEdits(V)),void 0,void 0)}registerMappedEditsProvider(q,V,J){const x=this.t(new Ue(this.h,J),q);return this.e.$registerMappedEditsProvider(x,this.o(V,q)),this.p(x)}$provideMappedEdits(q,V,J,x,fe){return this.s(q,Ue,be=>Promise.resolve(be.provideMappedEdits(V,J,x,fe)),null,fe)}registerDocumentPasteEditProvider(q,V,J,x){const fe=this.q();return this.f.set(fe,new ke(new F(this.e,this.h,J,fe,q),q)),this.e.$registerPasteEditProvider(fe,this.o(V,q),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,supportsResolve:!!J.resolveDocumentPasteEdit,providedPasteEditKinds:x.providedPasteEditKinds?.map(be=>be.value),copyMimeTypes:x.copyMimeTypes,pasteMimeTypes:x.pasteMimeTypes}),this.p(fe)}$prepareDocumentPaste(q,V,J,x,fe){return this.s(q,F,be=>be.prepareDocumentPaste(l.URI.revive(V),J,x,fe),void 0,fe)}$providePasteEdits(q,V,J,x,fe,be,Ne){return this.s(q,F,Ge=>Ge.providePasteEdits(V,l.URI.revive(J),x,fe,be,Ne),void 0,Ne)}$resolvePasteEdit(q,V,J){return this.s(q,F,x=>x.resolvePasteEdit(V,J),{},void 0)}$releasePasteEdits(q,V){this.s(q,F,J=>Promise.resolve(J.releasePasteEdits(V)),void 0,void 0)}static y(q){return{pattern:q.source,flags:q.flags}}static z(q){return{decreaseIndentPattern:Ie.y(q.decreaseIndentPattern),increaseIndentPattern:Ie.y(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ie.y(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ie.y(q.unIndentedLinePattern):void 0}}static B(q){return{beforeText:Ie.y(q.beforeText),afterText:q.afterText?Ie.y(q.afterText):void 0,previousLineText:q.previousLineText?Ie.y(q.previousLineText):void 0,action:q.action}}static C(q){return q.map(Ie.B)}static D(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(V=>o.SyntaxTokenType.toString(V)):void 0}}static E(q){return q.map(Ie.D)}setLanguageConfiguration(q,V,J){const{wordPattern:x}=J;if(x&&(0,I.$sf)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(V,x):this.h.setWordDefinitionFor(V,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const fe=this.q(),be={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Ie.y(J.wordPattern):void 0,indentationRules:J.indentationRules?Ie.z(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Ie.C(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?Ie.E(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(fe,V,be),this.p(fe)}$setWordDefinitions(q){for(const V of q)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$roc=Ie}),define(ye[356],Se([1,0,3,6,16]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rqc=void 0,P=We(P);class O{constructor(R){this.a=new Map,this.c=new Map,this.b=R.getProxy(h.$uN.MainThreadLanguageModelTools),this.b.$getTools().then($=>{for(const a of $)this.c.set(a.name,a)})}async invokeTool(R,$,a){return await this.b.$invokeTool(R,$,a)}async $acceptToolDelta(R){R.added&&this.c.set(R.added.name,R.added),R.removed&&this.c.delete(R.removed)}get tools(){return Array.from(this.c.values()).map(R=>P.LanguageModelToolDescription.to(R))}async $invokeTool(R,$,a){const I=this.a.get(R);if(!I)throw new Error(`Unknown tool ${R}`);return await I.tool.invoke($,a)}registerTool(R,$,a){return this.a.set($,{extension:R,tool:a}),this.b.$registerTool($),(0,r.$Uc)(()=>{this.a.delete($),this.b.$unregisterTool($)})}}e.$rqc=O}),define(ye[129],Se([1,0,9,21,51,14,4,40,3,237,24,5,12,90,6,128,20,16,10,156,26]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=e.$$oc=void 0,d=We(d),g=We(g),e.$$oc=(0,E.$Fi)("IExtHostLanguageModels");class i{constructor(w,y){this.option=w,this.stream=new r.$9h,this.stream=y??new r.$9h}}class s{constructor(){this.a=new Map,this.b=new r.$9h,this.c=!1;const w=this;this.apiObject={get stream(){return w.b.asyncIterable},get text(){return r.$6h.map(w.b.asyncIterable,y=>{if(y instanceof g.$KP)return y.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,w]of this.a)yield w.stream;else yield this.b}handleFragment(w){if(this.c)return;let y=this.a.get(w.index);y||(this.a.size===0?y=new i(w.index,this.b):y=new i(w.index),this.a.set(w.index,y));let D;w.part.type==="text"?D=new g.$KP(w.part.value):D=new g.$JP(w.part.name,w.part.parameters),y.stream.emitOne(D)}reject(w){this.c=!0;for(const y of this.d())y.reject(w)}resolve(){this.c=!0;for(const w of this.d())w.resolve()}}let f=class{static{t=this}static{this.a=1}constructor(w,y,D){this.j=y,this.k=D,this.c=new T.$me,this.d=new T.$me,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$sn,this.i=new Map,this.s=new Set,this.b=w.getProxy(p.$uN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(w,y,D,S){const C=t.a++;this.f.set(C,{extension:w.identifier,provider:D,languageModelId:y});let A;S.auth&&(A={providerLabel:w.displayName||w.name,accountLabel:typeof S.auth=="object"?S.auth.label:void 0}),this.b.$registerLanguageModelProvider(C,`${I.$qn.toKey(w.identifier)}/${C}/${y}`,{extension:w.identifier,id:y,vendor:S.vendor??I.$qn.toKey(w.identifier),name:S.name??"",family:S.family??"",version:S.version,maxInputTokens:S.maxInputTokens,maxOutputTokens:S.maxOutputTokens,auth:A,targetExtensions:S.extensions});const b=D.onDidReceiveLanguageModelResponse2?.(({extensionId:v,participant:M,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(y,new I.$qn(v),M,N)});return(0,$.$Uc)(()=>{this.f.delete(C),this.b.$unregisterProvider(C),b?.dispose()})}async $startChatRequest(w,y,D,S,C,A){const b=this.f.get(w);if(!b)throw new Error("Provider not found");const v=new k.$vw(async N=>{if(A.isCancellationRequested){this.j.warn(`[CHAT](${b.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(N.part instanceof g.$JP?L={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof g.$KP&&(L={type:"text",value:N.part.value}),!L){this.j.warn(`[CHAT](${b.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$handleResponsePart(y,{index:N.index,part:L})});let M;if(b.provider.provideLanguageModelResponse2)M=Promise.resolve(b.provider.provideLanguageModelResponse2(S.map(d.LanguageModelChatMessage.to),C,I.$qn.toKey(D),v,A));else{const N=new k.$vw(async L=>{v.report({index:L.index,part:new g.$KP(L.part)})});M=Promise.resolve(b.provider.provideLanguageModelResponse(S.map(d.LanguageModelChatMessage.to),C?.modelOptions??{},I.$qn.toKey(D),N,A))}M.then(()=>{this.b.$handleResponseDone(y,void 0)},N=>{this.b.$handleResponseDone(y,N)})}$provideTokenLength(w,y,D){const S=this.f.get(w);return S?Promise.resolve(S.provider.provideTokenCount(y,D)):Promise.resolve(0)}$acceptChatModelMetadata(w){if(w.added)for(const{identifier:y,metadata:D}of w.added)this.g.set(y,{metadata:D,apiObjects:new I.$sn});if(w.removed)for(const y of w.removed){this.g.delete(y);for(const[D,S]of this.i)S.languageModelId===y&&(S.res.reject(new O.$7),this.i.delete(D))}w.added?.forEach(y=>this.q(y.metadata)),this.d.fire(void 0)}async selectLanguageModels(w,y){const D=await this.b.$selectChatModels({...y,extension:w.identifier}),S=[],C=this;for(const A of D){const b=this.g.get(A);if(!b)continue;this.o(w.identifier,b.metadata)&&await this.q(b.metadata);let v=b.apiObjects.get(w.identifier);v||(v={id:A,vendor:b.metadata.vendor,family:b.metadata.family,version:b.metadata.version,name:b.metadata.name,maxInputTokens:b.metadata.maxInputTokens,countTokens(M,N){if(!C.g.has(A))throw g.$OP.NotFound(A);return C.r(A,M,N??h.CancellationToken.None)},sendRequest(M,N,L){if(!C.g.has(A))throw g.$OP.NotFound(A);return C.l(w,A,M,N??{},L??h.CancellationToken.None)}},Object.freeze(v),b.apiObjects.set(w.identifier,v)),S.push(v)}return S}async l(w,y,D,S,C){const A=this.m(w,D),b=w.identifier,v=this.g.get(y)?.metadata;if(!v||!this.g.has(y))throw g.$OP.NotFound(`Language model '${y}' is unknown.`);if(this.o(b,v)&&(!await this.n(w,{identifier:v.extension,displayName:v.auth.providerLabel},S.justification,!1)||!this.h.get(b)?.has(v.extension)))throw g.$OP.NoPermissions(`Language model '${y}' cannot be used by '${b.value}'.`);try{const M=Math.random()*1e6|0,N=new s;this.i.set(M,{languageModelId:y,res:N});try{await this.b.$tryStartChatRequest(b,y,M,A,S,C)}catch(L){throw this.i.delete(M),L}return N.apiObject}catch(M){throw M.name===g.$OP.name?M:new g.$OP(`Language model '${y}' errored: ${(0,P.$qj)(M)}`,"Unknown",M)}}m(w,y){const D=[];for(const S of y)S.role===g.LanguageModelChatMessageRole.System&&(0,o.$7G)(w,"languageModelSystem"),S.content2 instanceof g.$HP&&(0,o.$7G)(w,"lmTools"),D.push(d.LanguageModelChatMessage.from(S));return D}async $acceptResponsePart(w,y){const D=this.i.get(w);D&&D.res.handleFragment(y)}async $acceptResponseDone(w,y){const D=this.i.get(w);D&&(this.i.delete(w),y?D.res.reject(y):D.res.resolve())}async n(w,y,D,S){const C=n.$wM+y.identifier.value;if(await this.k.getSession(w,C,[],{silent:!0}))return this.$updateModelAccesslist([{from:w.identifier,to:y.identifier,enabled:!0}]),!0;if(S)return!1;try{const b=D?(0,a.localize)(0,null,y.displayName,D):void 0;return await this.k.getSession(w,C,[],{forceNewSession:{detail:b}}),this.$updateModelAccesslist([{from:w.identifier,to:y.identifier,enabled:!0}]),!0}catch{return!1}}o(w,y){return!!y.auth&&!I.$qn.equals(y.extension,w)}async q(w){if(w.auth)for(const y of this.s)try{await this.n(y,{identifier:w.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r(w,y,D){if(!this.g.get(w))throw g.$OP.NotFound(`Language model '${w}' is unknown.`);const C=R.Iterable.find(this.f.values(),A=>A.languageModelId===w);return C?C.provider.provideTokenCount(y,D):this.b.$countTokens(w,typeof y=="string"?y:d.LanguageModelChatMessage.from(y),D)}$updateModelAccesslist(w){const y=new Array;for(const{from:D,to:S,enabled:C}of w){const A=this.h.get(D)??new I.$rn;if(A.has(S)!==C){C?A.add(S):A.delete(S),this.h.set(D,A);const v={from:D,to:S};y.push(v),this.c.fire(v)}}}createLanguageModelAccessInformation(w){this.s.add(w);const y=this,D=T.Event.signal(T.Event.filter(this.c.event,C=>I.$qn.equals(C.from,w.identifier))),S=T.Event.signal(this.d.event);return{get onDidChange(){return T.Event.any(D,S)},canSendRequest(C){let A;e:for(const[v,M]of y.g)for(const N of M.apiObjects.values())if(N===C){A=M.metadata;break e}if(!A)return;if(!y.o(w.identifier,A))return!0;const b=y.h.get(w.identifier);if(b)return b.has(A.extension)}}}};e.$_oc=f,e.$_oc=f=t=Je([Ve(0,m.$1P),Ve(1,l.$_j),Ve(2,c.$toc)],f)});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ye[357],Se([1,0,6,16,10,44,9,3,26]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vpc=void 0,h=We(h),O=zt(O);class a{constructor(E,l,k,p){this.c=l,this.d=k,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=E.getProxy(r.$uN.MainThreadLanguages)}$acceptLanguageIds(E){this.b=E}async getLanguages(){return this.b.slice(0)}async changeLanguage(E,l){await this.a.$changeLanguage(E,l);const k=this.c.getDocumentData(E);if(!k)throw new Error(`document '${E.toString()}' NOT found`);return k.document}async tokenAtPosition(E,l){const k=E.version,p=h.Position.from(l),c=await this.a.$tokensAtPosition(E.uri,p),m={type:P.StandardTokenType.Other,range:E.getWordRangeAtPosition(l)??new P.$yN(l.line,l.character,l.line,l.character)};if(!c)return m;const d={range:h.Range.to(c.range),type:h.TokenType.to(c.type)};return!d.range.contains(l)||k!==E.version?m:d}createLanguageStatusItem(E,l,k){const p=this.f++,c=this.a,m=this.g,d=`${E.identifier.value}/${l}`;if(m.has(d))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);m.add(d);const g={selector:k,id:l,name:E.displayName??E.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new R.$Vc,t=()=>{if(n?.dispose(),!m.has(d)){console.warn(`LanguageStatusItem (${l}) from ${E.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,T.$Hh)(()=>{o.clear(),this.a.$setLanguageStatus(p,{id:d,name:g.name??E.displayName??E.name,source:E.displayName??E.name,selector:h.DocumentSelector.from(g.selector,this.e),label:g.text,detail:g.detail??"",severity:g.severity===P.LanguageStatusSeverity.Error?O.default.Error:g.severity===P.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:g.command&&this.d.toInternal(g.command,o),accessibilityInfo:g.accessibilityInformation,busy:g.busy})},0)},i={dispose(){o.dispose(),n?.dispose(),c.$removeLanguageStatus(p),m.delete(d)},get id(){return g.id},get name(){return g.name},set name(s){g.name=s,t()},get selector(){return g.selector},set selector(s){g.selector=s,t()},get text(){return g.text},set text(s){g.text=s,t()},set text2(s){(0,$.$7G)(E,"languageStatusText"),g.text=s,t()},get text2(){return(0,$.$7G)(E,"languageStatusText"),g.text},get detail(){return g.detail},set detail(s){g.detail=s,t()},get severity(){return g.severity},set severity(s){g.severity=s,t()},get accessibilityInformation(){return g.accessibilityInformation},set accessibilityInformation(s){g.accessibilityInformation=s,t()},get command(){return g.command},set command(s){g.command=s,t()},get busy(){return g.busy},set busy(s){g.busy=s,t()}};return t(),i}}e.$Vpc=a}),define(ye[358],Se([1,0,15,2,16,10,127]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=e.$Hpc=void 0,P=We(P),T=We(T);class R{constructor(E,l,k,p){this.start=E,this.deletedCount=l,this.deletedItems=k,this.items=p}asApiEvent(){return{range:new O.$YO(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1}}constructor(E,l,k){this.notebook=E,this.h=l,this.j=k,this.handle=k.handle,this.uri=h.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(P.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return E.g},set mime(p){E.g=p},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(k)}return this.f}setOutputs(E){this.a=E.map(P.NotebookCellOutput.to)}setOutputItems(E,l,k){const p=k.map(P.NotebookCellOutputItem.to),c=this.a.find(m=>m.id===E);if(c&&(l||(c.items.length=0),c.items.push(...p),c.items.length>1&&c.items.every(m=>T.$zL(m.mime)))){const m=new Map,d=[];c.items.forEach(g=>{let n;m.has(g.mime)?n=m.get(g.mime):(n=[],m.set(g.mime,n),d.push(g.mime)),n.push(g.data)}),c.items.length=0,d.forEach(g=>{const n=T.$AL(m.get(g));c.items.push({mime:g,data:n.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$Hpc=$;class a{static{this.a=0}constructor(E,l,k,p,c){this.k=E,this.l=l,this.m=k,this.uri=p,this.handle=a.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=c.viewType,this.f=Object.freeze(c.metadata??Object.create(null)),this.r([[0,0,c.cells]],!0,void 0),this.g=c.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,l={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===r.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(k){return k=E.n(k),E.b[k].apiCell},getCells(k){return(k?E.p(k):E.b).map(c=>c.apiCell)},save(){return E.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,l,k){this.g=E.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:k});const p={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},c=[];for(const d of E.rawEvents)d.kind===T.NotebookCellsChangeType.ModelChange?this.r(d.changes,!1,p.contentChanges):d.kind===T.NotebookCellsChangeType.Move?this.s(d.index,d.length,d.newIdx,p.contentChanges):d.kind===T.NotebookCellsChangeType.Output?(this.t(d.index,d.outputs),c.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===T.NotebookCellsChangeType.OutputItem?(this.u(d.index,d.outputId,d.append,d.outputItems),c.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this.v(d.index,d.language),c.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document})):d.kind===T.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document}):d.kind===T.NotebookCellsChangeType.ChangeCellMime?this.w(d.index,d.mime):d.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this.x(d.index,d.metadata),c.push({cell:this.b[d.index].apiCell,metadata:this.b[d.index].apiCell.metadata})):d.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(d.index,d.internalMetadata),c.push({cell:this.b[d.index].apiCell,executionSummary:this.b[d.index].apiCell.executionSummary}));const m=new Map;for(let d=0;d<c.length;d++){const g=c[d],n=m.get(g.cell);if(n===void 0){const o=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});m.set(g.cell,o-1)}else p.cellChanges[n]={...p.cellChanges[n],...g}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let l=E.start|0,k=E.end|0;return l<0&&(l=0),k>this.b.length&&(k=this.b.length),E.with({start:l,end:k})}p(E){E=this.o(E);const l=[];for(let k=E.start;k<E.end;k++)l.push(this.b[k]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,l,k){if(this.j)return;const p=[],c=[],m=[];if(E.reverse().forEach(d=>{const n=d[2].map(i=>{const s=new $(this,this.l,i);return l||c.push($.asModelAddData(i)),s}),o=new R(d[0],d[1],[],n),t=this.b.splice(d[0],d[1],...n);for(const i of t)m.push(i.uri),o.deletedItems.push(i.apiCell);p.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:m}),k)for(const d of p)k.push(d.asApiEvent())}s(E,l,k,p){const c=this.b.splice(E,l);this.b.splice(k,0,...c);const m=[new R(E,l,c.map(d=>d.apiCell),[]),new R(k,0,[],c)];for(const d of m)p.push(d.asApiEvent())}t(E,l){this.b[E].setOutputs(l)}u(E,l,k,p){this.b[E].setOutputItems(l,k,p)}v(E,l){const k=this.b[E];k.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(k.uri,l)}w(E,l){const k=this.b[E];k.apiCell.mime=l}x(E,l){this.b[E].setMetadata(l)}y(E,l){this.b[E].setInternalMetadata(l)}getCellFromApiCell(E){return this.b.find(l=>l.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(l=>l.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$Ipc=a}),define(ye[359],Se([1,0,4,2,16,10,52]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpc=void 0;class R{constructor(a,I,E,l={timeout:1500,errors:3}){this.b=a,this.c=I,this.d=E,this.f=l,this.a=new r.$oe}dispose(){}getOnWillSaveNotebookDocumentEvent(a){return(I,E,l)=>{const k=function(c){I.call(E,c)};return k.extension=a,this.a.event(k,void 0,l)}}async $participateInSave(a,I,E){const l=h.URI.revive(a),k=this.c.getNotebookDocument(l);if(!k)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:k.apiNotebook,reason:P.TextDocumentSaveReason.to(I)},E,async(m,d)=>{const g=Date.now(),n=await await Promise.resolve(m);Date.now()-g>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier),!E.isCancellationRequested&&n&&(n instanceof O.$GN?p.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier,"ignored due to invalid data"))}),E.isCancellationRequested)return!1;if(p.length===0)return!0;const c={edits:[]};for(const m of p){const{edits:d}=P.WorkspaceEdit.from(m);c.edits=c.edits.concat(d)}return this.d.$tryApplyWorkspaceEdit(new T.$Tw(c))}}e.$Xpc=R}),define(ye[165],Se([1,0,14,16,10]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0,h=We(h),P=We(P);class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(R,$,a,I,E,l){this.id=R,this.f=$,this.notebookData=a,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=I,this.c=l}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection($){this.selections=[$]},get selections(){return R.a},set selections($){if(!Array.isArray($)||!$.every(P.$YO.isNotebookRange))throw(0,r.$9)("selections");R.a=$,R.g($)},get visibleRanges(){return R.b},revealRange($,a){R.f.$tryRevealRange(R.id,h.NotebookRange.from($),a??P.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(h.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}e.$Jpc=O}),define(ye[360],Se([1,0,4,12,16]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpc=void 0,P=We(P);let O=class{constructor(R,$){this.c=R,this.d=$,this.a=new r.$me,this.b=new r.$me,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,$);const a=this.d.getEditorById(R);$.visibleRanges&&a._acceptVisibleRanges($.visibleRanges.ranges.map(P.NotebookRange.to)),$.selections&&a._acceptSelections($.selections.selections.map(P.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:a.apiEditor,visibleRanges:a.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:a.apiEditor,selections:a.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const $ in R)this.d.getEditorById($)._acceptViewColumn(P.ViewColumn.to(R[$]))}};e.$Zpc=O,e.$Zpc=O=Je([Ve(0,h.$_j)],O)}),define(ye[361],Se([1,0,4,6,165]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=void 0;class O{constructor(R,$){this.c=$,this.a=new Map,this.b=R.getProxy(h.$uN.MainThreadNotebookRenderers)}$postRendererMessage(R,$,a){const I=this.c.getEditorById(R);this.a.get($)?.fire({editor:I.apiEditor,message:a})}createRendererMessaging(R,$){if(!R.contributes?.notebookRenderer?.some(I=>I.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(I,E,l)=>this.d($).event(I,E,l),postMessage:(I,E)=>{P.$Jpc.apiEditorsToExtHost.has(I)&&([I,E]=[E,I]);const l=E&&P.$Jpc.apiEditorsToExtHost.get(E);return this.b.$postMessage(l?.id,$,I)}}}d(R){let $=this.a.get(R);return $||($=new r.$me({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(R)}}),this.a.set(R,$),$)}}e.$3pc=O}),define(ye[362],Se([1,0,16,90,21,59,14]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=void 0;class R{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,l,k){const p=this.b++,{title:c,location:m,cancellable:d}=l,g={label:E.displayName||E.name,id:E.identifier.value};return this.a.$startProgress(p,{location:r.ProgressLocation.from(m),title:c,source:g,cancellable:d},E.isUnderDevelopment?void 0:E.identifier.value).catch(T.$4),this.d(p,k,!!d)}d(E,l,k){let p;k&&(p=new P.$xe,this.c.set(E,p));const c=d=>{this.a.$progressEnd(d),this.c.delete(d),p?.dispose()};let m;try{m=l(new a(this.a,E),k&&p?p.token:P.CancellationToken.None)}catch(d){throw c(E),d}return m.then(d=>c(E),d=>c(E)),m}$acceptProgressCanceled(E){const l=this.c.get(E);l&&(l.cancel(),this.c.delete(E))}}e.$7pc=R;function $(I,E){return I.message=E.message,typeof E.increment=="number"&&(typeof I.increment=="number"?I.increment+=E.increment:I.increment=E.increment),I}class a extends h.$vw{constructor(E,l){super(k=>this.throttledReport(k)),this.c=E,this.d=l}throttledReport(E){this.c.$progressReport(this.d,E)}}Je([(0,O.$_h)(100,(I,E)=>$(I,E),()=>Object.create(null))],a.prototype,"throttledReport",null)}),define(ye[363],Se([1,0,2,6,9,16]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8pc=void 0;class T{static{this.a=0}constructor($,a){this.d=a,this.c=new Map,this.b=$.getProxy(h.$uN.MainThreadQuickDiff)}$provideOriginalResource($,a,I){const E=r.URI.revive(a),l=this.c.get($);return l?(0,P.$xh)(()=>l.provideOriginalResource(E,I)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider($,a,I,E){const l=T.a++;return this.c.set(l,a),this.b.$registerQuickDiffProvider(l,O.DocumentSelector.from($,this.d),I,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$8pc=T});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ye[364],Se([1,0,21,4,3,6,2,10,14,19,44,50,26,16]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9pc=p,I=zt(I);function p(c,m,d){const g=c.getProxy(O.$uN.MainThreadQuickOpen);class n{constructor(D,S){this.e=new Map,this.f=0,this.a=D,this.b=S}showQuickPick(D,S,C,A=r.CancellationToken.None){this.c=void 0;const b=Promise.resolve(S),v=++this.f,M=g.$show(v,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},A),N={},L=M.then(()=>N);return Promise.race([L,b]).then(j=>{if(j===N)return;const z=(0,l.$6G)(D,"quickPickItemTooltip");return b.then(F=>{const B=[];for(let _=0;_<F.length;_++){const re=F[_];if(typeof re=="string")B.push({label:re,handle:_});else if(re.kind===R.QuickPickItemKind.Separator)B.push({type:"separator",label:re.label});else{re.tooltip&&!z&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const U=re.iconPath?f(re.iconPath):void 0;B.push({label:re.label,iconPath:U?.iconPath,iconClass:U?.iconClass,description:re.description,detail:re.detail,picked:re.picked,alwaysShow:re.alwaysShow,tooltip:z?k.MarkdownString.fromStrict(re.tooltip):void 0,handle:_})}}return C&&typeof C.onDidSelectItem=="function"&&(this.c=_=>{C.onDidSelectItem(F[_])}),g.$setItems(v,B),M.then(_=>{if(typeof _=="number")return F[_];if(Array.isArray(_))return _.map(re=>F[re])})})}).then(void 0,j=>{if(!(0,$.$6)(j))return g.$setError(v,j),Promise.reject(j)})}$onItemSelected(D){this.c?.(D)}showInput(D,S=r.CancellationToken.None){return this.d=D?.validateInput,g.$input(D,typeof this.d=="function",S).then(void 0,C=>{if(!(0,$.$6)(C))return Promise.reject(C)})}async $validateInput(D){if(!this.d)return;const S=await this.d(D);if(!S||typeof S=="string")return S;let C;switch(S.severity){case R.InputBoxValidationSeverity.Info:C=I.default.Info;break;case R.InputBoxValidationSeverity.Warning:C=I.default.Warning;break;case R.InputBoxValidationSeverity.Error:C=I.default.Error;break;default:C=S.message?I.default.Error:I.default.Ignore;break}return{content:S.message,severity:C}}async showWorkspaceFolderPick(D,S=r.CancellationToken.None){const C=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!C)return;const A=await this.a.getWorkspaceFolders2();if(A)return A.find(b=>b.uri.toString()===C.uri.toString())}createQuickPick(D){const S=new u(D,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(D){const S=new w(D,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(D,S){this.e.get(D)?._fireDidChangeValue(S)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,S){const C=this.e.get(D);C instanceof u&&C._fireDidChangeActive(S)}$onDidChangeSelection(D,S){const C=this.e.get(D);C instanceof u&&C._fireDidChangeSelection(S)}$onDidTriggerButton(D,S){this.e.get(D)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(D,S,C){const A=this.e.get(D);A instanceof u&&A._fireDidTriggerItemButton(S,C)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class o{static{this.a=1}constructor(D,S){this.x=D,this.y=S,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new h.$me,this.q=new h.$me,this.r=new h.$me,this.s=new h.$me,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((S,C)=>{const A=S===R.$VO.Back?-1:C;this.o.set(A,S)}),this.z({buttons:D.map((S,C)=>({...f(S.iconPath),tooltip:S.tooltip,handle:S===R.$VO.Back?-1:C}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const S=this.o.get(D);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Rc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),g.$dispose(this._id))}z(D){if(!this.v){for(const S of Object.keys(D)){const C=D[S];this.u[S]=C===void 0?null:C}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){g.$createOrUpdate(this.u),this.u={id:this._id}}}function t(y){if(y instanceof R.$tO)return{id:y.id};const D=s(y),S=i(y);return{dark:typeof D=="string"?T.URI.file(D):D,light:typeof S=="string"?T.URI.file(S):S}}function i(y){return typeof y=="object"&&"light"in y?y.light:y}function s(y){return typeof y=="object"&&"dark"in y?y.dark:y}function f(y){const D=t(y);let S,C;return"id"in D?C=E.ThemeIcon.asClassName(D):S=D,{iconPath:S,iconClass:C}}class u extends o{constructor(D,S){super(D.identifier,S),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new h.$me,this.L=[],this.M=new h.$me,this.N=new h.$me,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((A,b)=>{this.C.set(b,A),this.D.set(A,b)});const S=(0,l.$6G)(this.O,"quickPickItemTooltip"),C=[];for(let A=0;A<D.length;A++){const b=D[A];if(b.kind===R.QuickPickItemKind.Separator)C.push({type:"separator",label:b.label});else{b.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const v=b.iconPath?f(b.iconPath):void 0;C.push({handle:A,label:b.label,iconPath:v?.iconPath,iconClass:v?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:S?k.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((M,N)=>({...f(M.iconPath),tooltip:M.tooltip,handle:N}))})}}this.z({items:C})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(D){const S=(0,a.$Jb)(D.map(C=>this.C.get(C)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(D){const S=(0,a.$Jb)(D.map(C=>this.C.get(C)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(D,S){const C=this.C.get(D);if(!C||!C.buttons||!C.buttons.length)return;const A=C.buttons[S];A&&this.N.fire({button:A,item:C})}}class w extends o{constructor(D,S){super(D.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:I.default.Error}):this.z({validationMessage:D.message,severity:D.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new n(m,d)}}),define(ye[365],Se([1,0,2,4,59,3,9,6,19,140,12,24,41,50,16,26,15,11]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=e.$0pc=void 0;function n(N){return N instanceof r.URI}function o(N,L){return N.scheme===m.Schemas.file&&L.scheme===m.Schemas.file&&d.$k?N.toString()===L.toString():N.toString().toLowerCase()===L.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?r.URI.file(N.iconPath):r.URI.isUri(N.iconPath)||k.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function i(N){if(N){if(r.URI.isUri(N))return N;if(k.ThemeIcon.isThemeIcon(N))return N;{const L=N;return{light:L.light,dark:L.dark}}}else return}function s(N){const L=i(N.icon),j=N.labels?.map(z=>({title:z.title,icon:i(z.icon)}));return{...N,icon:L,labels:j}}function f(N,L){if(!N.iconPath&&!L.iconPath)return 0;if(N.iconPath){if(!L.iconPath)return 1}else return-1;const j=typeof N.iconPath=="string"?N.iconPath:r.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,z=typeof L.iconPath=="string"?L.iconPath:r.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,a.$Hr)(j,z)}function u(N,L){let j=0;if(N.strikeThrough!==L.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==L.faded)return N.faded?1:-1;if(N.tooltip!==L.tooltip)return(N.tooltip||"").localeCompare(L.tooltip||"");if(j=f(N,L),j!==0)return j;if(N.light&&L.light)j=f(N.light,L.light);else{if(N.light)return 1;if(L.light)return-1}if(j!==0)return j;if(N.dark&&L.dark)j=f(N.dark,L.dark);else{if(N.dark)return 1;if(L.dark)return-1}return j}function w(N,L){if(N.command!==L.command)return N.command<L.command?-1:1;if(N.title!==L.title)return N.title<L.title?-1:1;if(N.tooltip!==L.tooltip){if(N.tooltip!==void 0&&L.tooltip!==void 0)return N.tooltip<L.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(N.arguments===L.arguments)return 0;if(N.arguments)if(L.arguments){if(N.arguments.length!==L.arguments.length)return N.arguments.length-L.arguments.length}else return 1;else return-1;for(let j=0;j<N.arguments.length;j++){const z=N.arguments[j],F=L.arguments[j];if(z!==F&&!(n(z)&&n(F)&&o(z,F)))return z<F?-1:1}return 0}function y(N,L){let j=(0,a.$Hr)(N.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(j!==0)return j;if(N.command&&L.command)j=w(N.command,L.command);else{if(N.command)return 1;if(L.command)return-1}if(j!==0)return j;if(N.decorations&&L.decorations)j=u(N.decorations,L.decorations);else{if(N.decorations)return 1;if(L.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)j=(0,a.$Hr)(N.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)j=(0,a.$Hr)(N.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return j}function D(N,L){for(let j=0;j<N.length;j++)if(N[j]!==L[j])return!1;return!0}function S(N,L){return N.command===L.command&&N.title===L.title&&N.tooltip===L.tooltip&&(N.arguments&&L.arguments?D(N.arguments,L.arguments):N.arguments===L.arguments)}function C(N,L){return(0,$.$wb)(N,L,S)}class A{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.m,L),this.o(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.m,L),this.f=L}get validateInput(){return(0,c.$7G)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,c.$7G)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.m,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.m,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.m,L))}get document(){return(0,c.$7G)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(L,j,z,F,B){this.k=L,this.m=F,this.n=B,this.d="",this.e=new h.$me,this.f="",this.h=!0,this.j=!0,this.#t=j,this.#e=z}showValidationMessage(L,j){(0,c.$7G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,L,j)}$onInputBoxValueChange(L){this.o(L)}o(L){this.d=L,this.e.fire(L)}}e.$0pc=A;class b{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(L){this.w=L,this.s.$updateGroupLabel(this.u,this.handle,L)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(L){this.q=L,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,j,z,F,B,_,re){this.s=L,this.t=j,this.u=z,this.v=F,this.w=B,this.multiDiffEditorEnableViewChanges=_,this.x=re,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new h.$me,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new h.$me,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=b.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,j){const z=this.h.get(L);return z?(0,T.$xh)(()=>this.t.executeCommand(z.command,...z.arguments||[],j)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(y),z=(0,$.$Fb)(this.p,L,y).map(_=>{const re=_.toInsert.map(U=>{const G=this.e++;this.g.set(G,U);const Q=U.resourceUri;let ee;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"||U.command.command==="vscode.changes"){const oe=new O.$Vc;ee=this.t.converter.toInternal(U.command,oe),this.j.set(G,oe)}else this.h.set(G,U.command);const he=(0,c.$6G)(this.x,"scmMultiDiffEditor"),ne=he?U.multiDiffEditorOriginalUri:void 0,De=he?U.multiFileDiffEditorModifiedUri:void 0,$e=t(U.decorations),K=U.decorations&&t(U.decorations.light)||$e,W=U.decorations&&t(U.decorations.dark)||$e,se=[K,W],ae=U.decorations&&U.decorations.tooltip||"",te=U.decorations&&!!U.decorations.strikeThrough,le=U.decorations&&!!U.decorations.faded,ue=U.contextValue||"";return{rawResource:[G,Q,se,ae,te,le,ue,ee,ne,De],handle:G}});return{start:_.start,deleteCount:_.deleteCount,toInsert:re}}),F=z.map(({start:_,deleteCount:re,toInsert:U})=>[_,re,U.map(G=>G.rawResource)]),B=z.reverse();for(const{start:_,deleteCount:re,toInsert:U}of B){const G=U.map(ee=>ee.handle),Q=this.o.splice(_,re,...G);for(const ee of Q)this.g.delete(ee),this.h.delete(ee),this.j.get(ee)?.dispose(),this.j.delete(ee)}return this.p=L,F}dispose(){this.m=!0,this.n.fire()}}class v{static{this.d=0}#e;get id(){return this.B}get label(){return this.C}get rootUri(){return this.D}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.x,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let j;(0,c.$6G)(this.y,"quickDiffProvider")&&(j=L?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!L,quickDiffLabel:j})}get historyProvider(){return(0,c.$7G)(this.y,"scmHistoryProvider"),this.j}set historyProvider(L){(0,c.$7G)(this.y,"scmHistoryProvider"),this.j=L,this.k.value=new O.$Vc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.m=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(L){L!==this.n&&(this.n=L,this.#e.$updateSourceControl(this.x,{commitTemplate:L}))}get acceptInputCommand(){return this.p}set acceptInputCommand(L){this.o.value=new O.$Vc,this.p=L;const j=this.z.converter.toInternal(L,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:j})}get actionButton(){return(0,c.$7G)(this.y,"scmActionButton"),this.s}set actionButton(L){(0,c.$7G)(this.y,"scmActionButton"),this.q.value=new O.$Vc,this.s=L;const j=L!==void 0?{command:this.z.converter.toInternal(L.command,this.q.value),secondaryCommands:L.secondaryCommands?.map(z=>z.map(F=>this.z.converter.toInternal(F,this.q.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:j??null})}get statusBarCommands(){return this.u}set statusBarCommands(L){if(this.A.trace("ExtHostSourceControl#statusBarCommands",(L??[]).map(z=>z.command).join(", ")),this.u&&L&&C(this.u,L)){this.A.trace("ExtHostSourceControl#statusBarCommands are equal");return}this.t.value=new O.$Vc,this.u=L;const j=(L||[]).map(z=>this.z.converter.toInternal(z,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:j})}get selected(){return this.v}constructor(L,j,z,F,B,_,re,U){this.y=L,this.z=F,this.A=B,this.B=_,this.C=re,this.D=U,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Xc,this.n=void 0,this.o=new O.$Xc,this.p=void 0,this.q=new O.$Xc,this.t=new O.$Xc,this.u=void 0,this.v=!1,this.w=new h.$me,this.onDidChangeSelection=this.w.event,this.x=v.d++,this.E=new Map,this.F=new Set,this.#e=z;const G=r.URI.from({scheme:m.Schemas.vscodeSourceControl,path:`${_}/scm${this.x}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new A(L,j,this.#e,this.x,G),this.#e.$registerSourceControl(this.x,_,re,U,G)}createResourceGroup(L,j,z){const F=(0,c.$6G)(this.y,"scmMultiDiffEditor")&&z?.multiDiffEditorEnableViewChanges===!0,B=new b(this.#e,this.z,this.x,L,j,F,this.y),_=h.Event.once(B.onDidDispose)(()=>this.E.delete(B));return this.E.set(B,_),this.eventuallyAddResourceGroups(),B}eventuallyAddResourceGroups(){const L=[],j=[];for(const[z,F]of this.E){F.dispose();const B=z.onDidUpdateResourceStates(()=>{this.F.add(z),this.eventuallyUpdateResourceStates()});h.Event.once(z.onDidDispose)(()=>{this.F.delete(z),B.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.x,z.handle)}),L.push([z.handle,z.id,z.label,z.features,z.multiDiffEditorEnableViewChanges]);const _=z._takeResourceStateSnapshot();_.length>0&&j.push([z.handle,_]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.x,L,j),this.E.clear()}eventuallyUpdateResourceStates(){const L=[];this.F.forEach(j=>{const z=j._takeResourceStateSnapshot();z.length!==0&&L.push([j.handle,z])}),L.length>0&&this.#e.$spliceResourceStates(this.x,L),this.F.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.v=L,this.w.fire(L)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.x)}}Je([(0,P.$$h)(100)],v.prototype,"eventuallyAddResourceGroups",null),Je([(0,P.$$h)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{g=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(L,j,z,F){this.m=j,this.n=z,this.o=F,this.g=new Map,this.h=new E.$sn,this.j=new h.$me,this.e=L.getProxy(R.$uN.MainThreadSCM),this.f=L.getProxy(R.$uN.MainThreadTelemetry),j.registerArgumentProcessor({processArgument:B=>{if(B&&B.$mid===l.MarshalledId.ScmResource){const _=this.g.get(B.sourceControlHandle);if(!_)return B;const re=_.getResourceGroup(B.groupHandle);return re?re.getResourceState(B.handle):B}else if(B&&B.$mid===l.MarshalledId.ScmResourceGroup){const _=this.g.get(B.sourceControlHandle);return _?_.getResourceGroup(B.groupHandle):B}else if(B&&B.$mid===l.MarshalledId.ScmProvider){const _=this.g.get(B.handle);return _||B}return B}})}createSourceControl(L,j,z,F){this.o.trace("ExtHostSCM#createSourceControl",L.identifier.value,j,z,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const B=g.d++,_=new v(L,this.n,this.e,this.m,this.o,j,z,F);this.g.set(B,_);const re=this.h.get(L.identifier)||[];return re.push(_),this.h.set(L.identifier,re),_}getLastInputBox(L){this.o.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const j=this.h.get(L.identifier),z=j&&j[j.length-1];return z&&z.inputBox}$provideOriginalResource(L,j,z){const F=r.URI.revive(j);this.o.trace("ExtHostSCM#$provideOriginalResource",L,F.toString());const B=this.g.get(L);return!B||!B.quickDiffProvider||!B.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.$xh)(()=>B.quickDiffProvider.provideOriginalResource(F,z)).then(_=>_||null)}$onInputBoxValueChange(L,j){this.o.trace("ExtHostSCM#$onInputBoxValueChange",L);const z=this.g.get(L);return z&&z.inputBox.$onInputBoxValueChange(j),Promise.resolve(void 0)}$executeResourceCommand(L,j,z,F){this.o.trace("ExtHostSCM#$executeResourceCommand",L,j,z);const B=this.g.get(L);if(!B)return Promise.resolve(void 0);const _=B.getResourceGroup(j);return _?_.$executeResourceCommand(z,F):Promise.resolve(void 0)}$validateInput(L,j,z){this.o.trace("ExtHostSCM#$validateInput",L);const F=this.g.get(L);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,T.$xh)(()=>F.inputBox.validateInput(j,z)).then(B=>{if(!B)return Promise.resolve(void 0);const _=p.MarkdownString.fromStrict(B.message);return _?Promise.resolve([_,B.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,j,z,F){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(j,z,F)??void 0}async $provideHistoryItems(L,j,z,F){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(j,z,F))?.map(re=>s(re))??void 0}async $provideHistoryItems2(L,j,z){return(await this.g.get(L)?.historyProvider?.provideHistoryItems2(j,z))?.map(_=>s(_))??void 0}async $provideHistoryItemSummary(L,j,z,F){const B=this.g.get(L)?.historyProvider;if(typeof B?.provideHistoryItemSummary!="function")return;const _=await B.provideHistoryItemSummary(j,z,F);return _?s(_):void 0}async $provideHistoryItemChanges(L,j,z,F){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(j,z,F)??void 0}};e.$$pc=M,e.$$pc=M=g=Je([Ve(3,I.$_j)],M)}),define(ye[366],Se([1,0,6,16,2]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pc=void 0;class O{static{this.a=0}constructor(R,$){this.d=$,this.c=new Map,this.b=R.getProxy(r.$uN.MainThreadShare)}async $provideShare(R,$,a){return await this.c.get(R)?.provideShare({selection:h.Range.to($.selection),resourceUri:P.URI.revive($.resourceUri)},a)??void 0}registerShareProvider(R,$){const a=O.a++;return this.c.set(a,$),this.b.$registerShareProvider(a,h.DocumentSelector.from(R,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(a),this.c.delete(a)}}}}e.$_pc=O}),define(ye[367],Se([1,0,10,6,240,3,16,18]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cqc=e.$bqc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new r.$uO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.$uO("statusBarItem.warningForeground")]])}#e;#t;constructor(l,k,p,c,m,d=r.StatusBarAlignment.Left,g){if(this.i=!1,this.k="",this.q=new O.$Vc,this.#e=l,this.#t=k,m&&c){this.c=(0,r.$9N)(c.identifier,m);const n=p.get(this.c);n&&(d=n.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,g=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=c,this.f=m,this.g=d,this.h=this.u(g)}u(l){if((0,R.$jg)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!$.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new O.$Vc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let k;this.m?k=this.m:k=(0,P.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=$.b.get(this.o.id));const c=T.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,k,this.k,c,this.r?.internal,p,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$bqc=$;class a{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const k={message:l};return this.b.unshift(k),this.c(),new r.$wN(()=>{const p=this.b.indexOf(k);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(l,k){this.e=new Map,this.a=l.getProxy(h.$uN.MainThreadStatusBar),this.b=k,this.c=new a(this)}$acceptStaticEntries(l){for(const k of l)this.e.set(k.entryId,k)}createStatusBarEntry(l,k,p,c){return new $(this.a,this.b,this.e,l,k,p,c)}setStatusBarMessage(l,k){const p=this.c.setMessage(l);let c;return typeof k=="number"?c=setTimeout(()=>p.dispose(),k):typeof k<"u"&&k.then(()=>p.dispose(),()=>p.dispose()),new r.$wN(()=>{p.dispose(),clearTimeout(c)})}}e.$cqc=I}),define(ye[166],Se([1,0,31,155,74,121,75,16,2]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=e.$bQ=e.$aQ=void 0,r=We(r),R=We(R);const a=(n,o,t,i)=>{let s=o;return{enumerable:!0,configurable:!1,get(){return s},set(f){if(!t(s,f)){const u=s;s=f,n.listener?.(i(f,u))}}}},I=(n,o)=>n===o,E={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(n,o)=>!(n.length!==o.length||n.some(t=>!o.find(i=>t.id===i.id)))},l=n=>o=>({op:O.TestItemEventOp.SetProp,update:n(o)}),k=(n,o)=>({range:(()=>{let t;const i=l(s=>({range:r.$Lt.lift(R.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return t},set(s){n.listener?.({op:O.TestItemEventOp.DocumentSynced}),E.range(t,s)||(t=s,n.listener?.(i(s)))}}})(),label:a(n,o,E.label,l(t=>({label:t}))),description:a(n,void 0,E.description,l(t=>({description:t}))),sortText:a(n,void 0,E.sortText,l(t=>({sortText:t}))),canResolveChildren:a(n,!1,E.canResolveChildren,t=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:a(n,!1,E.busy,l(t=>({busy:t}))),error:a(n,void 0,E.error,l(t=>({error:R.MarkdownString.fromStrict(t)||null}))),tags:a(n,[],E.tags,(t,i)=>({op:O.TestItemEventOp.SetTags,new:t.map(R.TestTag.from),old:i.map(R.TestTag.from)}))}),p=n=>{const o=P.$TI.fromString(n.extId),t=new m(o.controllerId,o.localId,n.label,$.URI.revive(n.uri)||void 0);return t.range=R.Range.to(n.range||void 0),t.description=n.description||void 0,t.sortText=n.sortText||void 0,t.tags=n.tags.map(i=>R.TestTag.to({id:(0,T.$ZI)(i).tagId})),t},c=n=>{let o;for(const t of n.tests){const i=p(t.item);(0,h.$WP)(i).parent=o,o=i}return o};e.$aQ=c;class m{constructor(o,t,i,s){if(t.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const f=(0,h.$VP)(this,o);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof d?void 0:f.parent}},children:{value:(0,O.$UP)(f,h.$WP,m),enumerable:!0,writable:!1},...k(f,i)})}}e.$bQ=m;class d extends m{constructor(o,t){super(o,o,t,void 0),this._isRoot=!0}}e.$cQ=d;class g extends O.$QP{constructor(o,t,i){super({controllerId:o,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:h.$WP,getChildren:s=>s.children,root:new d(o,t),toITestItem:R.TestItem.from})}}e.$dQ=g}),define(ye[35],Se([1,0,18,10,16,25,6,19,12,57,31,54,2,3,5,20,166,22,52,51,43,92,95,32]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=void 0,h=We(h),P=We(P);let f=class{#e;#t;#i;constructor(C,A,b){this.b=new Map,this.c=new Map,this.#e=C.getProxy(T.$uN.MainThreadCommands),this.d=A,this.#i=b,this.#t=C.getProxy(T.$uN.MainThreadTelemetry),this.converter=new u(this,v=>{const M=this.c.get(v);return M?.result===y.Void?M:void 0},A),this.f=[{processArgument(v){return(0,a.$ci)(v)}},{processArgument(v){return(0,O.$fo)(v,function(M){if(I.$Lt.isIRange(M))return P.Range.to(M);if(E.$Kt.isIPosition(M))return P.Position.to(M);if(I.$Lt.isIRange(M.range)&&l.URI.isUri(M.uri))return P.location.to(M);if(M instanceof d.$Oe)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const A=this.registerCommand(!1,C.id,async(...b)=>{const v=C.args.map((N,L)=>{if(!N.validate(b[L]))throw new Error(`Invalid argument '${N.name}' when running '${C.id}', received: ${typeof b[L]=="object"?JSON.stringify(b[L],null,"	"):b[L]} `);return N.convert(b[L])}),M=await this.executeCommand(C.internalId,...v);return C.result.convert(M,b,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new h.$wN(()=>{A.dispose(),this.c.delete(C.id)})}registerCommand(C,A,b,v,M,N){if(this.d.trace("ExtHostCommands#registerCommand",A),!A.trim().length)throw new Error("invalid id");if(this.b.has(A))throw new Error(`command '${A}' already exists`);return this.b.set(A,{callback:b,thisArg:v,metadata:M,extension:N}),C&&this.#e.$registerCommand(A),new h.$wN(()=>{this.b.delete(A)&&C&&this.#e.$unregisterCommand(A)})}executeCommand(C,...A){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,A,!0)}async g(C,A,b){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,A,!1);{let v=!1;const M=(0,O.$fo)(A,function(N){if(N instanceof h.$xN)return P.Position.from(N);if(N instanceof h.$yN)return P.Range.from(N);if(N instanceof h.$IN)return P.location.from(N);if(h.$YO.isNotebookRange(N))return P.NotebookRange.from(N);if(N instanceof ArrayBuffer)return v=!0,d.$Oe.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return v=!0,d.$Oe.wrap(N);if(N instanceof d.$Oe)return v=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(C,v?new g.$Tw(M):M,b);return(0,a.$ci)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(C,A,!1);throw N}}}async h(C,A,b){const v=this.b.get(C);if(!v)throw new Error("Unknown command");const{callback:M,thisArg:N,metadata:L}=v;if(L?.args)for(let z=0;z<L.args.length;z++)try{(0,r.$wg)(A[z],L.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${L.args[z].name}' - ${L.args[z].description}`)}const j=o.$ge.create();try{return await M.apply(N,A)}catch(z){if(C===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...A);F&&(C=F.command)}if(this.d.error(z,C,v.extension?.identifier),!b)throw z;if(v.extension?.identifier){const F=this.#i.onExtensionError(v.extension.identifier,z);this.d.trace("forwarded error to extension?",F,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$qj)(z)),this.id=C,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,C,j.elapsed())}}j(C,A,b){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new t.$up(A),duration:b})}$executeContributedCommand(C,...A){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const b=this.b.get(C);return b?(A=A.map(v=>this.f.reduce((M,N)=>N.processArgument(M,b.extension?.identifier),v)),this.h(C,A,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(A=>(C&&(A=A.filter(b=>b[0]!=="_")),A))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[A,b]of this.b){const{metadata:v}=b;v&&(C[A]=v)}return Promise.resolve(C)}};e.$jQ=f,e.$jQ=f=Je([Ve(0,c.$1P),Ve(1,$.$_j),Ve(2,i.$iQ)],f),e.$kQ=(0,p.$Fi)("IExtHostCommands");class u{constructor(C,A,b){this.d=C,this.f=A,this.g=b,this.delegatingCommandId=`__vsc${(0,s.$2g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,A){if(!C)return;const b={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return b;const v=this.f(C.command);if(v)b.id=v.internalId,b.arguments=v.args.map((M,N)=>M.convert(C.arguments&&C.arguments[N]));else if((0,R.$Nb)(C.arguments)){const M=`${C.command} /${++this.c}`;this.b.set(M,C),A.add((0,k.$Uc)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),b.$ident=M,b.id=this.delegatingCommandId,b.arguments=[M],this.g.trace("CommandsConverter#CREATE",C.command,M)}return b}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const A=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],A?A.command:"MISSING"),A?this.d.executeCommand(A.command,...A.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$lQ=u;class w{static{this.Uri=new w("uri","Uri of a text document",C=>l.URI.isUri(C),C=>C)}static{this.Position=new w("position","A position in a text document",C=>h.$xN.isPosition(C),P.Position.from)}static{this.Range=new w("range","A range in a text document",C=>h.$yN.isRange(C),P.Range.from)}static{this.Selection=new w("selection","A selection in a text document",C=>h.$zN.isSelection(C),P.Selection.from)}static{this.Number=new w("number","",C=>typeof C=="number",C=>C)}static{this.String=new w("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=w.Arr(w.String)}static Arr(C){return new w(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,A=>Array.isArray(A)&&A.every(b=>C.validate(b)),A=>A.map(b=>C.convert(b)))}static{this.CallHierarchyItem=new w("item","A call hierarchy item",C=>C instanceof h.$UN,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new w("item","A type hierarchy item",C=>C instanceof h.$gP,P.TypeHierarchyItem.from)}static{this.TestItem=new w("testItem","A VS Code TestItem",C=>C instanceof m.$bQ,P.TestItem.from)}constructor(C,A,b,v){this.name=C,this.description=A,this.validate=b,this.convert=v}optional(){return new w(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,A){return new w(C??this.name,A??this.description,this.validate,this.convert)}}e.$mQ=w;class y{static{this.Void=new y("no result",C=>C)}constructor(C,A){this.description=C,this.convert=A}}e.$nQ=y;class D{constructor(C,A,b,v,M){this.id=C,this.internalId=A,this.description=b,this.args=v,this.result=M}}e.$oQ=D}),define(ye[368],Se([1,0,19,15,2,88,143,36,35,16,10]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=void 0,O=We(O),a=We(a),I=We(I);const E=[new $.$oQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of DocumentHighlight-instances.",k(a.DocumentHighlight.to))),new $.$oQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$mQ.Uri],new $.$nQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,m)=>{if((0,r.$Mb)(c))return;class d extends I.$PN{static to(n){const o=new d(n.name,a.SymbolKind.to(n.kind),n.containerName||"",new I.$IN(m[0],a.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=a.Range.to(n.selectionRange),o.children=n.children?n.children.map(d.to):[],o}}return c.map(d.to)})),new $.$oQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$mQ.Uri,new $.$mQ("options","Formatting options",c=>!0,c=>c)],new $.$nQ("A promise that resolves to an array of TextEdits.",k(a.TextEdit.to))),new $.$oQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$mQ.Uri,$.$mQ.Range,new $.$mQ("options","Formatting options",c=>!0,c=>c)],new $.$nQ("A promise that resolves to an array of TextEdits.",k(a.TextEdit.to))),new $.$oQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$mQ.Uri,$.$mQ.Position,new $.$mQ("ch","Trigger character",c=>typeof c=="string",c=>c),new $.$mQ("options","Formatting options",c=>!0,c=>c)],new $.$nQ("A promise that resolves to an array of TextEdits.",k(a.TextEdit.to))),new $.$oQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$oQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$oQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$oQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$oQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Location-instances.",k(a.location.to))),new $.$oQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Hover-instances.",k(a.Hover.to))),new $.$oQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$mQ.Uri,new $.$mQ("position","A position in a text document",c=>Array.isArray(c)&&c.every(m=>I.$xN.isPosition(m)),c=>c.map(a.Position.from))],new $.$nQ("A promise that resolves to an array of ranges.",c=>c.map(m=>{let d;for(const g of m.reverse())d=new I.$TN(a.Range.to(g),d);return d}))),new $.$oQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$mQ.String.with("query","Search string")],new $.$nQ("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(a.WorkspaceSymbol.to))),new $.$oQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(a.CallHierarchyItem.to))),new $.$oQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$mQ.CallHierarchyItem],new $.$nQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(a.CallHierarchyIncomingCall.to))),new $.$oQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$mQ.CallHierarchyItem],new $.$nQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(a.CallHierarchyOutgoingCall.to))),new $.$oQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:a.Range.to(c.range),placeholder:c.text}})),new $.$oQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$mQ.Uri,$.$mQ.Position,$.$mQ.String.with("newName","The new symbol name")],new $.$nQ("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return a.WorkspaceEdit.to(c)}})),new $.$oQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$mQ.Uri,$.$mQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$nQ("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(a.DocumentLink.to))),new $.$oQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$mQ.Uri],new $.$nQ("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new I.$PO(c.tokenTypes,c.tokenModifiers)})),new $.$oQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$mQ.Uri],new $.$nQ("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,T.$Gdb)(c);if(m.type==="full")return new I.$RO(m.data,void 0)})),new $.$oQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$mQ.Uri,$.$mQ.Range.optional()],new $.$nQ("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new I.$PO(c.tokenTypes,c.tokenModifiers)})),new $.$oQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$mQ.Uri,$.$mQ.Range],new $.$nQ("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,T.$Gdb)(c);if(m.type==="full")return new I.$RO(m.data,void 0)})),new $.$oQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$mQ.Uri,$.$mQ.Position,$.$mQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$mQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$nQ("A promise that resolves to a CompletionList-instance.",(c,m,d)=>{if(!c)return new I.$6N([]);const g=c.suggestions.map(n=>a.CompletionItem.to(n,d));return new I.$6N(g,c.incomplete)})),new $.$oQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$mQ.Uri,$.$mQ.Position,$.$mQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$nQ("A promise that resolves to SignatureHelp.",c=>{if(c)return a.SignatureHelp.to(c)})),new $.$oQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$mQ.Uri,$.$mQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$nQ("A promise that resolves to an array of CodeLens-instances.",(c,m,d)=>k(g=>new I.$XN(a.Range.to(g.range),g.command&&d.fromInternal(g.command)))(c))),new $.$oQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$mQ.Uri,new $.$mQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>I.$yN.isRange(c),c=>I.$zN.isSelection(c)?a.Selection.from(c):a.Range.from(c)),$.$mQ.String.with("kind","Code action kind to return code actions for").optional(),$.$mQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$nQ("A promise that resolves to an array of Command-instances.",(c,m,d)=>k(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(g.command)}else{const n=new I.$RN(g.title,g.kind?new I.$SN(g.kind):void 0);return g.edit&&(n.edit=a.WorkspaceEdit.to(g.edit)),g.command&&(n.command=d.fromInternal(g.command)),n.isPreferred=g.isPreferred,n}})(c))),new $.$oQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$mQ.Uri],new $.$nQ("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(m=>new I.$_N(a.Range.to(m.range),a.Color.to(m.color))):[])),new $.$oQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$mQ("color","The color to show and insert",c=>c instanceof I.$$N,a.Color.from),new $.$mQ("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:a.Range.from(c.range)}))],new $.$nQ("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(a.ColorPresentation.to):[])),new $.$oQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$mQ.Uri,$.$mQ.Range],new $.$nQ("A promise that resolves to an array of Inlay objects",(c,m,d)=>c.map(a.InlayHint.to.bind(void 0,d)))),new $.$oQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$mQ.Uri],new $.$nQ("A promise that resolves to an array of FoldingRange objects",(c,m)=>{if(c)return c.map(a.FoldingRange.to)})),new $.$oQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$nQ("A promise that resolves to an array of NotebookContentProvider static info objects.",k(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(m=>a.NotebookExclusiveDocumentPattern.to(m))})))),new $.$oQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$mQ.Uri,$.$mQ.Range,new $.$mQ("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof I.$yN,c=>a.InlineValueContext.from(c))],new $.$nQ("A promise that resolves to an array of InlineValue objects",c=>c.map(a.InlineValue.to))),new $.$oQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$mQ("uriOrString","Uri-instance or string (only http/https)",c=>P.URI.isUri(c)||typeof c=="string"&&(0,h.$Pg)(c,h.Schemas.http,h.Schemas.https),c=>c),new $.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[a.ViewColumn.from(c),void 0]:[a.ViewColumn.from(c.viewColumn),a.TextEditorOpenOptions.from(c)])).optional(),$.$mQ.String.with("label","").optional()],$.$nQ.Void),new $.$oQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$mQ.Uri.with("resource","Resource to open"),$.$mQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[a.ViewColumn.from(c),void 0]:[a.ViewColumn.from(c.viewColumn),a.TextEditorOpenOptions.from(c)])).optional()],$.$nQ.Void),new $.$oQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$mQ.Uri.with("left","Left-hand side resource of the diff editor"),$.$mQ.Uri.with("right","Right-hand side resource of the diff editor"),$.$mQ.String.with("title","Human readable title for the diff editor").optional(),new $.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[a.ViewColumn.from(c.viewColumn),a.TextEditorOpenOptions.from(c)]).optional()],$.$nQ.Void),new $.$oQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$mQ.String.with("title","Human readable title for the changes editor"),new $.$mQ("resourceList","List of resources to compare",c=>{for(const m of c){if(m.length!==3)return!1;const[d,g,n]=m;if(!P.URI.isUri(d)||!P.URI.isUri(g)&&g!==void 0&&g!==null||!P.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},c=>c)],$.$nQ.Void),new $.$oQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(a.TypeHierarchyItem.to))),new $.$oQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$mQ.TypeHierarchyItem],new $.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(a.TypeHierarchyItem.to))),new $.$oQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$mQ.TypeHierarchyItem],new $.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(a.TypeHierarchyItem.to))),new $.$oQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$mQ.TestItem],$.$nQ.Void),new $.$oQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$mQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$nQ.Void),new $.$oQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$mQ.String.with("name","The context key name"),new $.$mQ("value","The context key value",()=>!0,c=>c)],$.$nQ.Void),new $.$oQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$mQ.Uri,$.$mQ.StringArray,new $.$mQ("MappedEditsContext","Mapped Edits Context",c=>a.MappedEditsContext.is(c),c=>a.MappedEditsContext.from(c))],new $.$nQ("A promise that resolves to a workspace edit or null",c=>c?a.WorkspaceEdit.to(c):null)),new $.$oQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$mQ("Run arguments","",c=>!0,c=>{if(c)return{initialRange:c.initialRange?a.Range.from(c.initialRange):void 0,initialSelection:I.$zN.isSelection(c.initialSelection)?a.Selection.from(c.initialSelection):void 0,message:c.message,autoSend:c.autoSend,position:c.position?a.Position.from(c.position):void 0}})],$.$nQ.Void)];class l{static register(m){E.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",R.$Ej)}}e.$soc=l;function k(c){return m=>{if(Array.isArray(m))return m.map(c)}}function p(c){if(!Array.isArray(c))return;const m=[];for(const d of c)O.$Hu(d)?m.push(a.DefinitionLink.to(d)):m.push(a.location.to(d));return m}}),define(ye[369],Se([1,0,2,35]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tpc=void 0;class P{constructor(T,R,$,a,I){this.a=R,this.b=$,this.c=a;const E=new h.$oQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.$mQ("showOptions","Show Options",l=>!0,l=>l),new h.$mQ("resource","Interactive resource Uri",l=>!0,l=>l),new h.$mQ("controllerId","Notebook controller Id",l=>!0,l=>l),new h.$mQ("title","Interactive editor title",l=>!0,l=>l)],new h.$nQ("Notebook and input URI",l=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const k=this.a.getEditorById(l.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:r.URI.revive(l.notebookUri),inputUri:r.URI.revive(l.inputUri),notebookEditor:k.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:r.URI.revive(l.notebookUri),inputUri:r.URI.revive(l.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(T,R,$,a){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:$,uri:T,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(T,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.$Tpc=P}),define(ye[370],Se([1,0,19,9,21,4,3,29,2,24,12,6,35,16,10,122,312,26,52,313]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=void 0,e.$2pc=w,k=We(k);let o=class{constructor(D,S,C,A,b){this.m=S,this.n=C,this.o=A,this.q=b,this.b=new R.$Cc,this.c=new R.$Cc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$me,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(E.$uN.MainThreadNotebookKernels);const v=new l.$oQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$mQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const L=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:L}}else if(N&&"notebookEditor"in N){const L=this.n.getIdByEditor(N.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return N})],l.$nQ.Void),M=new l.$oQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$mQ.Uri],new l.$nQ("A promise that resolves to an array of variables",(N,L)=>N.map(j=>({variable:{name:j.name,value:j.value,expression:j.expression,type:j.type,language:j.language},hasNamedChildren:j.hasNamedChildren,indexedChildrenCount:j.indexedChildrenCount}))));this.o.registerApiCommand(v),this.o.registerApiCommand(M)}createNotebookController(D,S,C,A,b,v){for(const ne of this.j.values())if(ne.controller.id===S&&a.$qn.equals(D.identifier,ne.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const M=this.k++,N=this;this.q.trace(`NotebookController[${M}], CREATED by ${D.identifier.value}, ${S}`);const L=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${D.identifier}'`);let j=!1;const z=new O.$me,F=new O.$me,B={id:w(D.identifier,S),notebookType:C,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:A||D.identifier.value,preloads:v?v.map(k.NotebookRendererScript.from):[]};let _=b??L,re,U;this.a.$addKernel(M,B).catch(ne=>{console.log(ne),j=!0});let G=0;const Q=()=>{if(j)return;const ne=++G;Promise.resolve().then(()=>{ne===G&&this.a.$updateKernel(M,B)})},ee=new R.$Cc,he={get id(){return S},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return B.label},set label(ne){B.label=ne??D.displayName??D.name,Q()},get detail(){return B.detail??""},set detail(ne){B.detail=ne,Q()},get description(){return B.description??""},set description(ne){B.description=ne,Q()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(ne){B.supportedLanguages=ne,Q()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){B.supportsExecutionOrder=ne,Q()},get rendererScripts(){return B.preloads?B.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return _},set executeHandler(ne){_=ne??L},get interruptHandler(){return re},set interruptHandler(ne){re=ne,B.supportsInterrupt=!!ne,Q()},set variableProvider(ne){(0,d.$7G)(D,"notebookVariableProvider"),U=ne,B.hasVariableProvider=!!ne,ne?.onDidChangeVariables(De=>N.a.$variablesUpdated(De.uri)),Q()},get variableProvider(){return U},createNotebookCellExecution(ne){if(j)throw new Error("notebook controller is DISPOSED");if(!ee.has(ne.notebook.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return N._createNotebookCellExecution(ne,w(D.identifier,this.id))},createNotebookExecution(ne){if((0,d.$7G)(D,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!ee.has(ne.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return N._createNotebookExecution(ne,w(D.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${M}], DISPOSED`),j=!0,this.j.delete(M),z.dispose(),F.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(ne,De){De===p.NotebookControllerAffinity2.Hidden&&(0,d.$7G)(D,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(M,ne.uri,De)},onDidReceiveMessage:F.event,postMessage(ne,De){return(0,d.$7G)(D,"notebookMessaging"),N.a.$postMessage(M,De&&N.n.getIdByEditor(De),ne)},asWebviewUri(ne){return(0,d.$7G)(D,"notebookMessaging"),(0,c.$dDb)(ne,N.m.remote)}};return this.j.set(M,{extensionId:D.identifier,controller:he,onDidReceiveMessage:F,onDidChangeSelection:z,associatedNotebooks:ee}),he}getIdByController(D){for(const[S,C]of this.j)if(C.controller===D)return w(C.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,S){const C=this.g++,A=this;this.q.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(C,S);const b={dispose:()=>{this.f.delete(C),A.a.$removeKernelDetectionTask(C)}};return this.f.set(C,b),b}registerKernelSourceActionProvider(D,S,C){const A=this.i++,b=typeof C.onDidChangeNotebookKernelSourceActions=="function"?A:void 0,v=this;this.h.set(A,C),this.q.trace(`NotebookKernelSourceActionProvider[${A}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(A,A,S);let M;return b!==void 0&&(M=C.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.h.delete(A),v.a.$removeKernelSourceActionProvider(A,A),M?.dispose()}}}async $provideKernelSourceActions(D,S){const C=this.h.get(D);if(C){const A=new T.$Vc;return(await C.provideNotebookKernelSourceActions(S)??[]).map(v=>k.NotebookKernelSourceAction.from(v,this.o.converter,A))}return[]}$acceptNotebookAssociation(D,S,C){const A=this.j.get(D);if(A){const b=this.n.getNotebookDocument($.URI.revive(S));C?A.associatedNotebooks.set(b.uri,!0):A.associatedNotebooks.delete(b.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,b.uri.toString(),C),A.onDidChangeSelection.fire({selected:C,notebook:b.apiNotebook})}}async $executeCells(D,S,C){const A=this.j.get(D);if(!A)return;const b=this.n.getNotebookDocument($.URI.revive(S)),v=[];for(const M of C){const N=b.getCell(M);N&&v.push(N.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,b.uri.toString(),v.length),await A.controller.executeHandler.call(A.controller,v,b.apiNotebook,A.controller)}catch(M){this.q.error(`NotebookController[${D}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(D,S,C){const A=this.j.get(D);if(!A)return;const b=this.n.getNotebookDocument($.URI.revive(S));if(A.controller.interruptHandler)await A.controller.interruptHandler.call(A.controller,b.apiNotebook);else for(const v of C){const M=b.getCell(v);M&&this.b.get(M.uri)?.cancel()}if(A.controller.interruptHandler){const v=this.c.get(b.uri);this.c.delete(b.uri),C.length&&Array.isArray(v)&&v.length&&v.forEach(M=>M.dispose())}}async $provideVariables(D,S,C,A,b,v,M){const N=this.j.get(D);if(!N)return;const L=this.n.getNotebookDocument($.URI.revive(C)),j=N.controller.variableProvider;if(!j)return;let z;if(A!==void 0){if(z=this.s[A],!z)return}else this.s={};const F=b==="named"?p.NotebookVariablesRequestKind.Named:p.NotebookVariablesRequestKind.Indexed,B=j.provideVariables(L.apiNotebook,z,F,v,M);let _=0;for await(const re of B){if(M.isCancellationRequested)return;const U={id:this.r++,name:re.variable.name,value:re.variable.value,type:re.variable.type,interfaces:re.variable.interfaces,language:re.variable.language,expression:re.variable.expression,hasNamedChildren:re.hasNamedChildren,indexedChildrenCount:re.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[U.id]=re.variable,this.a.$receiveVariable(S,U),_++>=n.$WK)return}}$acceptKernelMessageFromRenderer(D,S,C){const A=this.j.get(D);if(!A)return;const b=this.n.getEditorById(S);A.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:C}))}$cellExecutionChanged(D,S,C){const b=this.n.getNotebookDocument($.URI.revive(D)).getCell(S);if(b){const v=C?k.NotebookCellExecutionState.to(C):p.NotebookCellExecutionState.Idle;v!==void 0&&this.l.fire({cell:b.apiCell,state:v})}}_createNotebookCellExecution(D,S){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const A=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!A)throw new Error("invalid cell");if(this.b.has(A.uri))throw new Error(`duplicate execution for ${A.uri}`);const b=new i(S,A,this.a);this.b.set(A.uri,b);const v=b.onDidChangeState(()=>{b.state===t.Resolved&&(b.dispose(),v.dispose(),this.b.delete(A.uri))});return b.asApiObject()}_createNotebookExecution(D,S){const C=this.n.getNotebookDocument(D.uri),A=D.getCells().find(M=>{const N=C.getCellFromApiCell(M);return N&&this.b.has(N.uri)});if(A)throw new Error(`duplicate cell execution for ${A.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const b=new f(S,C,this.a),v=b.onDidChangeState(()=>{b.state===s.Resolved&&(b.dispose(),v.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[b,v]),b.asApiObject()}};e.$1pc=o,e.$1pc=o=Je([Ve(4,I.$_j)],o);var t;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(t||(t={}));class i extends T.$Wc{static{this.a=0}get state(){return this.f}constructor(D,S,C){super(),this.m=S,this.n=C,this.b=i.a++,this.c=new O.$me,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new P.$xe),this.h=new u(10,A=>this.s(A)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const S=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new g.$Tw(S))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let S=this.m;if(D&&(S=this.m.notebook.getCellFromApiCell(D)),!S)throw new Error("INVALID cell");return S.handle}y(D){return D.map(S=>{const C=p.$3O.ensureUniqueMimeTypes(S.items,!0);return C===S.items?k.NotebookCellOutput.from(S):k.NotebookCellOutput.from({items:C,id:S.id,metadata:S.metadata})})}async z(D,S,C){const A=this.w(S),b=this.y((0,r.$4b)(D));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:A,append:C,outputs:b})}async C(D,S,C){return D=p.$3O.ensureUniqueMimeTypes((0,r.$4b)(D),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:D.map(k.NotebookCellOutputItem.from),outputId:S.id,append:C})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(C){D.j=C,D.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(C){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,A,b){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const v=b?{message:b.message,stack:b.stack,location:b?.location?{startLineNumber:b.location.start.line,startColumn:b.location.start.character,endLineNumber:b.location.end.line,endColumn:b.location.end.character}:void 0,uri:b.uri}:void 0;D.n.$completeExecution(D.b,new g.$Tw({runEndTime:A,lastRunSuccess:C,error:v}))},clearOutput(C){return D.t(),D.z([],C,!1)},appendOutput(C,A){return D.t(),D.z(C,A,!0)},replaceOutput(C,A){return D.t(),D.z(C,A,!1)},appendOutputItems(C,A){return D.t(),D.C(C,A,!0)},replaceOutputItems(C,A){return D.t(),D.C(C,A,!1)}})}}var s;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(s||(s={}));class f extends T.$Wc{static{this.a=0}get state(){return this.f}constructor(D,S,C){super(),this.h=S,this.j=C,this.b=f.a++,this.c=new O.$me,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new P.$xe),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===s.Resolved||this.f===s.Started)throw new Error("Cannot call start again");this.f=s.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===s.Resolved)throw new Error("Cannot call resolve twice");this.f=s.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor(D,S){this.f=D,this.g=S,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new h.$3h,this.b=Date.now(),(0,h.$Gh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>D.complete())}}function w(y,D){return`${y.value}/${D}`}}),define(ye[47],Se([1,0,4,6,5,2,20,3,10,242,14,291,21,32,292,293,50,9,16,35,41]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=e.$9oc=e.$8oc=e.$7oc=void 0,e.$7oc=(0,P.$Fi)("IExtHostTerminalService");class t extends R.$Wc{constructor(b,v,M,N){super(),this.u=b,this._id=v,this.w=M,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new r.$me),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(j=>this.g=j);const L=this;this.value={get name(){return L.y||""},get processId(){return L.b},get creationOptions(){return L.w},get exitStatus(){return L.j},get state(){return L.m},get selection(){return L.n},get shellIntegration(){return L.shellIntegration},sendText(j,z=!0){L.C(),L.u.$sendText(L._id,j,z)},show(j){L.C(),L.u.$show(L._id,j)},hide(){L.C(),L.u.$hide(L._id)},dispose(){L.a||(L.a=!0,L.u.$dispose(L._id))},get dimensions(){if(!(L.f===void 0||L.h===void 0))return{columns:L.f,rows:L.h}}}}dispose(){this.s.fire(),super.dispose()}async create(b,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??v?.cwd??void 0,env:b.env??void 0,icon:D(b.iconPath)??void 0,color:m.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,forceShellIntegration:v?.forceShellIntegration??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.z(b.location,v?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,v,M,N,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:m.ThemeColor.isThemeColor(L)?L.id:void 0,location:v?.location||this.z(b,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(b,v){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in b?{viewColumn:g.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.y=b}setExitStatus(b,v){this.j=Object.freeze({code:b,reason:v})}setDimensions(b,v){return b===this.f&&v===this.h||b===0||v===0?!1:(this.f=b,this.h=v,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(b){this.n=b}_setProcessId(b){this.g?(this.g(b),this.g=void 0):this.b.then(v=>{v!==b&&(this.b=Promise.resolve(b))})}}e.$8oc=t;class i{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new r.$me,this.onProcessData=this.a.event,this.b=new r.$me,this.d=new r.$me,this.onDidChangeProperty=this.d.event,this.f=new r.$me,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,v){this.g.setDimensions?.({columns:b,rows:v})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:p.ProcessPropertyType.OverrideDimensions,value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:p.ProcessPropertyType.Title,value:v})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,f=class extends R.$Wc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,v,M){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new R.$Xc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new r.$me,this.onDidCloseTerminal=this.H.event,this.I=new r.$me,this.onDidOpenTerminal=this.I.event,this.J=new r.$me,this.onDidChangeActiveTerminal=this.J.event,this.L=new r.$me,this.onDidChangeTerminalDimensions=this.L.event,this.M=new r.$me,this.onDidChangeTerminalState=this.M.event,this.N=new r.$me,this.onDidChangeShell=this.N.event,this.O=new r.$me({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new r.$me({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=M.getProxy(h.$uN.MainThreadTerminalService),this.y=new c.$wxb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:N=>{const L=j=>{const z=j;return this.getTerminalById(z.instanceId)?.value};switch(N?.$mid){case o.MarshalledId.TerminalContext:return L(N);default:{if(Array.isArray(N))for(let j=0;j<N.length&&N[j].$mid===o.MarshalledId.TerminalContext;j++)N[j]=L(N[j]);return N}}}}),this.B({dispose:()=>{for(const[N,L]of this.g)L.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,v){const M=new t(this.a,(0,k.$2g)(),b,b.name),N=new i(b.pty);return M.createExtensionTerminal(b.location,v,this.R(b,v).resolvedExtHostIdentifier,D(b.iconPath),S(b.color)).then(L=>{const j=this.S(L,N);this.h[L]=j}),this.f.push(M),M.value}R(b,v){if(v=v||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const M=b.location.parentTerminal;if(M){const N=this.f.find(L=>L.value===M);N&&(v.resolvedExtHostIdentifier=N._id)}}else b.location&&typeof b.location!="object"?v.location=b.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(b,v){if(!this.getTerminalById(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const N=new i(v),L=this.S(b,N);this.h[b]=L}async $acceptActiveTerminalChanged(b){const v=this.b;if(b===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const M=this.getTerminalById(b);M&&(this.b=M,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,v){const M=this.getTerminalById(b);M&&this.O.fire({terminal:M.value,data:v})}async $acceptTerminalDimensions(b,v,M){const N=this.getTerminalById(b);N&&N.setDimensions(v,M)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(b,v){const M=this.getTerminalById(b);M&&this.P.fire({terminal:M.value,...v})}async $acceptTerminalMaximumDimensions(b,v,M){this.g.get(b)?.resize(v,M)}async $acceptTerminalTitleChange(b,v){const M=this.getTerminalById(b);M&&(M.name=v)}async $acceptTerminalClosed(b,v,M){const N=this.X(this.f,b);if(N!==null){const L=this.f.splice(N,1)[0];L.setExitStatus(v,M),this.H.fire(L.value)}}$acceptTerminalOpened(b,v,M,N){if(v){const z=this.X(this.f,v);if(z!==null){this.f[z]._id=b,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const L={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:O.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},j=new t(this.a,b,L,M);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(b,v){this.getTerminalById(b)?._setProcessId(v)}async $startExtensionTerminal(b,v){const M=this.getTerminalById(b);if(!M)return{message:(0,a.localize)(0,null,b)};M.isOpen||await new Promise(L=>{const j=this.onDidOpenTerminal(async z=>{z===M.value&&(j.dispose(),L())})});const N=this.g.get(b);N?N.startSendingEvents(v):this.j[b]={initialDimensions:v}}S(b,v){const M=new R.$Vc;M.add(v.onProcessReady(L=>this.a.$sendProcessReady(b,L.pid,L.cwd,L.windowsPty))),M.add(v.onDidChangeProperty(L=>this.a.$sendProcessProperty(b,L))),this.y.startBuffering(b,v.onProcessData),M.add(v.onProcessExit(L=>this.U(b,L))),this.g.set(b,v);const N=this.j[b];return N&&v instanceof i&&(v.startSendingEvents(N.initialDimensions),delete this.j[b]),M}$acceptProcessAckDataEvent(b,v){this.g.get(b)?.acknowledgeDataEvent(v)}$acceptProcessInput(b,v){this.g.get(b)?.input(v)}$acceptTerminalInteraction(b){const v=this.getTerminalById(b);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection(b,v){this.getTerminalById(b)?.setSelection(v)}$acceptProcessResize(b,v,M){try{this.g.get(b)?.resize(v,M)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(b,v){this.g.get(b)?.shutdown(v)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(v=>this.a.$sendProcessProperty(b,{type:p.ProcessPropertyType.InitialCwd,value:v}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(v=>this.a.$sendProcessProperty(b,{type:p.ProcessPropertyType.Cwd,value:v}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new $.$wN(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,v,M){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,M),this.a.$registerProfileProvider(v,b.identifier.value),new $.$wN(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(b,v,M){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,M),this.a.$registerQuickFixProvider(b,v),new $.$wN(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,v){const M=new l.$xe().token;if(M.isCancellationRequested)return;const N=this.D.get(b);if(!N)return;const L=await N.provideTerminalQuickFixes(v,M);if(L===null||Array.isArray(L)&&L.length===0)return;const j=new R.$Vc;if(this.w.value=j,!Array.isArray(L))return L?g.TerminalQuickFix.from(L,this.Q.converter,j):void 0;const z=[];for(const F of L){const B=g.TerminalQuickFix.from(F,this.Q.converter,j);B&&z.push(B)}return z}async $createContributedProfileTerminal(b,v){const M=new l.$xe().token;let N=await this.C.get(b)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,v);return}this.createTerminalFromOptions(N.options,v)}}async $provideLinks(b,v){const M=this.getTerminalById(b);if(!M)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const L=new l.$xe;this.G.set(b,L);const j=[],z={terminal:M.value,line:v},F=[];for(const re of this.z)F.push(d.Promises.withAsyncBody(async U=>{L.token.onCancellationRequested(()=>U({provider:re,links:[]}));const G=await re.provideTerminalLinks(z,L.token)||[];L.token.isCancellationRequested||U({provider:re,links:G})}));const B=await Promise.all(F);if(L.token.isCancellationRequested)return[];const _=new Map;for(const re of B)re&&re.links.length>0&&j.push(...re.links.map(U=>{const G={id:s++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return _.set(G.id,{provider:re.provider,link:U}),G}));return this.F.set(b,_),j}$activateLink(b,v){const M=this.F.get(b)?.get(v);M&&M.provider.handleTerminalLink(M.link)}U(b,v){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const M=this.h[b];M&&(M.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,v)}getTerminalById(b){return this.W(this.f,b)}getTerminalIdByApiObject(b){const v=this.f.findIndex(M=>M.value===b);return v>=0?v:null}W(b,v){const M=this.X(b,v);return M!==null?b[M]:null}X(b,v){const M=b.findIndex(N=>N._id===v);return M>=0?M:null}getEnvironmentVariableCollection(b){let v=this.n.get(b.identifier.value);return v||(v=this.B(new u),this.Z(b.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Y(b,v){const M=(0,E.$Cs)(v.map),N=(0,E.$Ds)(v.descriptionMap);this.a.$setEnvironmentVariableCollection(b,v.persistent,M.length===0?void 0:M,N)}$initEnvironmentVariableCollections(b){b.forEach(v=>{const M=v[0],N=this.B(new u(v[1]));this.Z(M,N)})}$acceptDefaultProfile(b,v){const M=this.s;this.s=b,this.u=v,M?.path!==b.path&&this.N.fire(b.path)}Z(b,v){this.n.set(b,v),this.B(v.onDidChangeCollection(()=>{this.Y(b,v)}))}};e.$9oc=f,e.$9oc=f=Je([Ve(1,n.$kQ),Ve(2,T.$1P)],f);class u extends R.$Wc{get persistent(){return this.b}set persistent(b){this.b=b,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(b){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new r.$me,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const v=this.j(b);let M=this.a.get(v);return M||(M=new w(this,b),this.a.set(v,M),this.B(M.onDidChangeCollection(()=>this.f.fire()))),M}replace(b,v,M,N){this.g(b,{value:v,type:$.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:N})}append(b,v,M,N){this.g(b,{value:v,type:$.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:N})}prepend(b,v,M,N){this.g(b,{value:v,type:$.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:N})}g(b,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.h(b,v.scope),N=this.map.get(M),L=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==v.value||N.type!==v.type||N.options?.applyAtProcessCreation!==L.applyAtProcessCreation||N.options?.applyAtShellIntegration!==L.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const j=this.h(b,v.scope),z={variable:b,...v,options:L};this.map.set(j,z),this.f.fire()}}get(b,v){const M=this.h(b,v),N=this.map.get(M);return N?C(N):void 0}h(b,v){const M=this.j(v);return M.length?`${b}:::${M}`:b}j(b){return this.m(b?.workspaceFolder)??""}m(b){return b?b.uri.toString():void 0}getVariableMap(b){const v=new Map;for(const[M,N]of this.map)this.j(N.scope)===this.j(b)&&v.set(N.variable,C(N));return v}delete(b,v){const M=this.h(b,v);this.map.delete(M),this.f.fire()}clear(b){if(b?.workspaceFolder){for(const[v,M]of this.map)M.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(v);this.n(b)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(b,v){const M=this.j(v),N=this.descriptionMap.get(M);if(!N||N.description!==b){let L;typeof b=="string"?L=b:L=b?.value.split(`

`)[0];const j={description:L,scope:v};this.descriptionMap.set(M,j),this.f.fire()}}getDescription(b){const v=this.j(b);return this.descriptionMap.get(v)?.description}n(b){const v=this.j(b);this.descriptionMap.delete(v)}}class w{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,v){this.b=b,this.d=v,this.a=new r.$me}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,v,M){this.b.replace(b,v,M,this.d)}append(b,v,M){this.b.append(b,v,M,this.d)}prepend(b,v,M){this.b.prepend(b,v,M,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,v){this.b.getVariableMap(this.d).forEach((M,N)=>b.call(v,N,M,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let y=class extends f{constructor(b,v){super(!1,b,v)}createTerminal(b,v,M){throw new I.$bb}createTerminalFromOptions(b,v){throw new I.$bb}};e.$0oc=y,e.$0oc=y=Je([Ve(0,n.$kQ),Ve(1,T.$1P)],y);function D(A){if(!(!A||typeof A=="string"))return"id"in A?{id:A.id,color:A.color}:A}function S(A){return m.ThemeColor.isThemeColor(A)?A:void 0}function C(A){const b={...A};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(ye[167],Se([1,0,10,3,5,6,20,47,4,2,9]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqc=e.$gqc=void 0,e.$gqc=(0,P.$Fi)("IExtHostTerminalShellIntegration");let E=class extends h.$Wc{constructor(m,d){super(),this.h=d,this.b=new Map,this.c=new $.$me,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$me,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$me,this.onDidEndTerminalShellExecution=this.g.event,this.a=m.getProxy(O.$uN.MainThreadTerminalShellIntegration),this.B((0,h.$Uc)(()=>{for(const[g,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(m){const d=this.h.getTerminalById(m);if(!d)return;const g=d.value;let n=this.b.get(m);n||(n=new l(d.value,this.f),this.b.set(m,n),n.store.add(d.onWillDispose(()=>this.b.get(m)?.dispose())),n.store.add(n.onDidRequestShellExecution(o=>this.a.$executeCommand(m,o))),n.store.add(n.onDidRequestEndExecution(o=>this.g.fire(o))),n.store.add(n.onDidRequestChangeShellIntegration(o=>this.c.fire(o))),d.shellIntegration=n.value),this.c.fire({terminal:g,shellIntegration:n.value})}$shellExecutionStart(m,d,g,n,o){this.b.has(m)||this.$shellIntegrationChange(m);const t={value:d,confidence:g,isTrusted:n};this.b.get(m)?.startShellExecution(t,o)}$shellExecutionEnd(m,d,g,n,o){const t={value:d,confidence:g,isTrusted:n};this.b.get(m)?.endShellExecution(t,o)}$shellExecutionData(m,d){this.b.get(m)?.emitData(d)}$cwdChange(m,d){this.b.get(m)?.setCwd((0,a.$xc)(d)?a.URI.revive(d):d)}$closeTerminal(m){this.b.get(m)?.dispose(),this.b.delete(m)}};e.$hqc=E,e.$hqc=E=Je([Ve(0,T.$1P),Ve(1,R.$7oc)],E);class l extends h.$Wc{get currentExecution(){return this.a}constructor(m,d){super(),this.j=m,this.m=d,this.b=!1,this.store=this.B(new h.$Vc),this.f=this.B(new $.$me),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$me),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$me),this.onDidRequestEndExecution=this.h.event;const g=this;this.value={get cwd(){return g.c},executeCommand(n,o){let t=n;o&&(t+=` "${o.map(f=>`${f.replaceAll('"','\\"')}`).join('" "')}"`),g.g.fire(t);const i={value:t,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},s=g.startShellExecution(i,g.c,!0).value;return g.b=!0,s}}}startShellExecution(m,d,g){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new k(m,d);g?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(m){this.currentExecution?.emitData(m)}endShellExecution(m,d){this.a&&(this.a.endExecution(m),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:d}),this.a=void 0)}setCwd(m){let d=!1;a.URI.isUri(this.c)?d=!a.URI.isUri(m)||this.c.toString()!==m.toString():this.c!==m&&(d=!0),d&&(this.c=m,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class k{constructor(m,d){this.c=m,this.cwd=d,this.b=!1;const g=this;this.value={get commandLine(){return g.c},get cwd(){return g.cwd},read(){return g.d()}}}d(){if(!this.a){if(this.b)return I.$6h.EMPTY;this.a=new p}return this.a.createIterable()}emitData(m){this.a?.emitData(m)}endExecution(m){m&&(this.c=m),this.a?.endExecution(),this.a=void 0,this.b=!0}}class p extends h.$Wc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Eh);const m=this.a;return new I.$6h(async g=>{this.b.push(g),await m.wait()})}emitData(m){for(const d of this.b)d.emitOne(m)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ye[168],Se([1,0,66,14,133,16,10]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=e.$9P=e.$8P=void 0,O=We(O);class R{static{this.c=new P.$6P("TextEditorDecorationType")}constructor(l,k,p){const c=R.c.nextId();l.$registerTextEditorDecorationType(k.identifier,c,O.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:c,dispose(){l.$removeTextEditorDecorationType(c)}})}}e.$8P=R;class ${constructor(l,k){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,k){this.k();let p=null;if(l instanceof T.$xN)p=new T.$yN(l,l);else if(l instanceof T.$yN)p=l;else throw new Error("Unrecognized location");this.l(p,k,!1)}insert(l,k){this.k(),this.l(new T.$yN(l,l),k,!0)}delete(l){this.k();let k=null;if(l instanceof T.$yN)k=l;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(l,k,p){const c=this.c.validateRange(l);this.g.push({range:c,text:k,forceMoveMarkers:p})}setEndOfLine(l){if(this.k(),l!==T.EndOfLine.LF&&l!==T.EndOfLine.CRLF)throw(0,h.$9)("endOfLine");this.h=l}}class a{constructor(l,k,p,c){this.c=l,this.d=k,this._accept(p),this.e=c;const m=this;this.value={get tabSize(){return m.f},set tabSize(d){m.n(d)},get indentSize(){return m.g},set indentSize(d){m.p(d)},get insertSpaces(){return m.j},set insertSpaces(d){m.s(d)},get cursorStyle(){return m.k},set cursorStyle(d){m.t(d)},get lineNumbers(){return m.l},set lineNumbers(d){m.u(d)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const k=Math.floor(l);return k>0?k:null}if(typeof l=="string"){const k=parseInt(l,10);return isNaN(k)?null:k>0?k:null}return null}n(l){const k=this.m(l);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const k=Math.floor(l);return k>0?k:null}if(typeof l=="string"){const k=parseInt(l,10);return isNaN(k)?null:k>0?k:null}return null}p(l){const k=this.o(l);if(k!==null){if(typeof k=="number"){if(this.h===k)return;this.g=k,this.h=k}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const k=this.q(l);if(typeof k=="boolean"){if(this.j===k)return;this.j=k}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(l)})))}assign(l){const k={};let p=!1;if(typeof l.tabSize<"u"){const c=this.m(l.tabSize);c==="auto"?(p=!0,k.tabSize=c):typeof c=="number"&&this.f!==c&&(this.f=c,p=!0,k.tabSize=c)}if(typeof l.indentSize<"u"){const c=this.o(l.indentSize);c==="tabSize"?(p=!0,k.indentSize=c):typeof c=="number"&&this.h!==c&&(this.g=c,this.h=c,p=!0,k.indentSize=c)}if(typeof l.insertSpaces<"u"){const c=this.q(l.insertSpaces);c==="auto"?(p=!0,k.insertSpaces=c):this.j!==c&&(this.j=c,p=!0,k.insertSpaces=c)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,p=!0,k.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,p=!0,k.lineNumbers=O.TextEditorLineNumbersStyle.from(l.lineNumbers)),p&&this.v("setOptions",this.c.$trySetOptions(this.d,k))}v(l,k){k.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(p)})}}e.$9P=a;class I{constructor(l,k,p,c,m,d,g,n){this.id=l,this.j=k,this.k=p,this.g=!1,this.h=new Set,this.c=m,this.d=new a(this.j,this.id,d,p),this.e=g,this.f=n;const o=this;this.value=Object.freeze({get document(){return c.value},set document(t){throw new h.$$("document")},get selection(){return o.c&&o.c[0]},set selection(t){if(!(t instanceof T.$zN))throw(0,h.$9)("selection");o.c=[t],o.l()},get selections(){return o.c},set selections(t){if(!Array.isArray(t)||t.some(i=>!(i instanceof T.$zN)))throw(0,h.$9)("selections");o.c=t,o.l()},get visibleRanges(){return o.e},set visibleRanges(t){throw new h.$$("visibleRanges")},get options(){return o.d.value},set options(t){o.g||o.d.assign(t)},get viewColumn(){return o.f},set viewColumn(t){throw new h.$$("viewColumn")},edit(t,i={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new $(c.value,i);return t(s),o.m(s)},insertSnippet(t,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let f;if(!i||Array.isArray(i)&&i.length===0)f=o.c.map(u=>O.Range.from(u));else if(i instanceof T.$xN){const{lineNumber:u,column:w}=O.Position.from(i);f=[{startLineNumber:u,startColumn:w,endLineNumber:u,endColumn:w}]}else if(i instanceof T.$yN)f=[O.Range.from(i)];else{f=[];for(const u of i)if(u instanceof T.$yN)f.push(O.Range.from(u));else{const{lineNumber:w,column:y}=O.Position.from(u);f.push({startLineNumber:w,startColumn:y,endLineNumber:w,endColumn:y})}}return k.$tryInsertSnippet(l,c.value.version,t.value,f,s)},setDecorations(t,i){const s=i.length===0;s&&!o.h.has(t.key)||(s?o.h.delete(t.key):o.h.add(t.key),o.n(()=>{if(O.$XP(i))return k.$trySetDecorations(l,t.key,O.$YP(i));{const f=new Array(4*i.length);for(let u=0,w=i.length;u<w;u++){const y=i[u];f[4*u]=y.start.line+1,f[4*u+1]=y.start.character+1,f[4*u+2]=y.end.line+1,f[4*u+3]=y.end.character+1}return k.$trySetDecorationsFast(l,t.key,f)}}))},revealRange(t,i){o.n(()=>k.$tryRevealRange(l,O.Range.from(t),i||T.TextEditorRevealType.Default))},show(t){k.$tryShowEditor(l,O.ViewColumn.from(t))},hide(){k.$tryHideEditor(l)}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,r.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,r.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,r.ok)(!this.g),this.f=l}_acceptSelections(l){(0,r.ok)(!this.g),this.c=l}async l(){const l=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const k=l.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const p=k.edits.map(m=>m.range);p.sort((m,d)=>m.end.line===d.end.line?m.end.character===d.end.character?m.start.line===d.start.line?m.start.character-d.start.character:m.start.line-d.start.line:m.end.character-d.end.character:m.end.line-d.end.line);for(let m=0,d=p.length-1;m<d;m++){const g=p[m].end;if(p[m+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=k.edits.map(m=>({range:O.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,c,{setEndOfLine:typeof k.setEndOfLine=="number"?O.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$0P=I}),define(ye[64],Se([1,0,66,4,3,2,5,6,164,20,168,16,12,29,15,40,49]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=e.$$P=void 0,r=We(r),E=We(E);class d{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let g=class{constructor(o,t){this.h=o,this.i=t,this.a=null,this.b=new Map,this.c=new k.$Cc,this.d=new h.$me,this.e=new h.$me,this.f=new h.$me,this.g=new h.$me,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const t=[],i=[],s=[];if(o.removedDocuments)for(const f of o.removedDocuments){const u=O.URI.revive(f),w=this.c.get(u);w?.unref()&&(this.c.delete(u),t.push(w.value))}if(o.addedDocuments)for(const f of o.addedDocuments){const u=O.URI.revive(f.uri);let w=this.c.get(u);if(w&&u.scheme!==p.Schemas.vscodeNotebookCell&&u.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);w||(w=new d(new $.$4P(this.h.getProxy(R.$uN.MainThreadDocuments),u,f.lines,f.EOL,f.versionId,f.languageId,f.isDirty)),this.c.set(u,w),i.push(w.value)),w.ref()}if(o.removedEditors)for(const f of o.removedEditors){const u=this.b.get(f);this.b.delete(f),u&&s.push(u)}if(o.addedEditors)for(const f of o.addedEditors){const u=O.URI.revive(f.documentUri);r.ok(this.c.has(u),`document '${u}' does not exist`),r.ok(!this.b.has(f.id),`editor '${f.id}' already exists!`);const w=this.c.get(u).value,y=new I.$0P(f.id,this.h.getProxy(R.$uN.MainThreadTextEditors),this.i,new m.$X(()=>w.document),f.selections.map(E.Selection.to),f.options,f.visibleRanges.map(D=>E.Range.to(D)),typeof f.editorPosition=="number"?E.ViewColumn.to(f.editorPosition):void 0);this.b.set(f.id,y)}o.newActiveEditor!==void 0&&(r.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,P.$Rc)(t),(0,P.$Rc)(s),o.removedDocuments&&this.e.fire(t),o.addedDocuments&&this.d.fire(i),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(f=>f.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return c.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const t=this.b.get(this.a);return o?t:t?.value}allEditors(){return[...this.b.values()]}};e.$$P=g,e.$$P=g=Je([Ve(0,a.$1P),Ve(1,l.$_j)],g),e.$_P=(0,T.$Fi)("IExtHostDocumentsAndEditors")}),define(ye[99],Se([1,0,9,22,21,4,80,60,3,41,18,32,5,12,6,35,64,20,166,16,10,315,74,121,75,26]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o,t,i,s,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$spc=e.$rpc=e.$qpc=e.$ppc=e.$opc=void 0,n=We(n);let w=0;const y=new WeakMap;e.$opc=(0,l.$Fi)("IExtHostTesting");let D=class extends $.$Wc{constructor(U,G,Q,ee){super(),this.C=G,this.D=Q,this.F=ee,this.f=this.B(new O.$me),this.g=new Map,this.w=this.B(new O.$me),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(p.$uN.MainThreadTesting),this.m=new j(this.h),this.j=new b(this.h,G),Q.registerArgumentProcessor({processArgument:he=>{switch(he?.$mid){case a.MarshalledId.TestItemContext:{const ne=he,De=ne.tests[ne.tests.length-1].item.extId;return this.g.get(i.$TI.root(De))?.collection.tree.get(De)?.actual??(0,g.$aQ)(he)}case a.MarshalledId.TestMessageMenuArgs:{const{test:ne,message:De}=he,$e=ne.item.extId;return{test:this.g.get(i.$TI.root($e))?.collection.tree.get($e)?.actual??(0,g.$aQ)({$mid:a.MarshalledId.TestItemContext,tests:[ne]}),message:n.TestMessage.to(De)}}default:return he}}}),Q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const he=await Q.executeCommand(t.TestCommandId.GetExplorerSelection),ne=De=>{const $e=this.g.get(i.$TI.root(De));if($e)return i.$TI.isRoot(De)?$e.controller:$e.collection.tree.get(De)?.actual};return{include:he?.include.map(ne).filter(I.$ng)||[],exclude:he?.exclude.map(ne).filter(I.$ng)||[]}})}createTestController(U,G,Q,ee){if(this.g.has(G))throw new Error(`Attempt to insert a duplicate controller with ID "${G}"`);const he=new $.$Vc,ne=he.add(new g.$dQ(G,Q,this.F));ne.root.label=Q;const De=new Map,$e=new Set,K=this.h,W={items:ne.root.children,get label(){return Q},set label(ae){Q=ae,ne.root.label=ae,K.$updateController(G,{label:Q})},get refreshHandler(){return ee},set refreshHandler(ae){ee=ae,K.$updateController(G,{canRefresh:!!ae})},get id(){return G},createRunProfile:(ae,te,le,ue,X,oe)=>{let pe=(0,R.$tj)(ae);for(;De.has(pe);)pe++;return new F(this.h,De,$e,this.w.event,G,pe,ae,te,le,ue,X,oe)},createTestItem(ae,te,le){return new g.$bQ(G,ae,te,le)},createTestRun:(ae,te,le=!0)=>this.j.createTestRun(U,G,ne,ae,te,le),invalidateTestResults:ae=>{if(ae===void 0)this.h.$markTestRetired(void 0);else{const te=ae instanceof Array?ae:[ae];this.h.$markTestRetired(te.map(le=>i.$TI.fromExtHostTestItem(le,G).toString()))}},set resolveHandler(ae){ne.resolveHandler=ae},get resolveHandler(){return ne.resolveHandler},dispose:()=>{he.dispose()}};K.$registerTestController(G,Q,!!ee),he.add((0,$.$Uc)(()=>K.$unregisterTestController(G)));const se={controller:W,collection:ne,profiles:De,extension:U,activeProfiles:$e};return this.g.set(G,se),he.add((0,$.$Uc)(()=>this.g.delete(G))),he.add(ne.onDidGenerateDiff(ae=>K.$publishDiff(G,ae.map(f.TestsDiffOp.serialize)))),W}createTestObserver(){return this.m.checkout()}async runTests(U,G=P.CancellationToken.None){const Q=v(U);if(!Q)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ee=this.g.get(Q.controllerId);if(!ee)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:U.preserveFocus??!0,group:B[Q.kind],targets:[{testIds:U.include?.map(he=>i.$TI.fromExtHostTestItem(he,ee.collection.root.id).toString())??[ee.collection.root.id],profileId:Q.profileId,controllerId:Q.controllerId}],exclude:U.exclude?.map(he=>he.id)},G)}registerTestFollowupProvider(U){return this.y.add(U),{dispose:()=>{this.y.delete(U)}}}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $getCoverageDetails(U,G,Q){return(await this.j.getCoverageDetails(U,G,Q))?.map(n.TestCoverage.fromDetails)}async $disposeRun(U){this.j.disposeTestRun(U)}$configureRunProfile(U,G){this.g.get(U)?.profiles.get(G)?.configureHandler?.()}$setDefaultRunProfiles(U){const G=new Map;for(const[Q,ee]of Object.entries(U)){const he=this.g.get(Q);if(!he)continue;const ne=new Map,De=ee.filter(K=>!he.activeProfiles.has(K)),$e=[...he.activeProfiles].filter(K=>!ee.includes(K));for(const K of De)ne.set(K,!0),he.activeProfiles.add(K);for(const K of $e)ne.set(K,!1),he.activeProfiles.delete(K);ne.size&&G.set(Q,ne)}this.w.fire(G)}async $refreshTests(U,G){await this.g.get(U)?.controller.refreshHandler?.(G)}$publishTestResults(U){this.results=Object.freeze(U.map(G=>{const Q=n.TestResults.to(G);return y.set(Q,G.id),Q}).concat(this.results).sort((G,Q)=>Q.completedAt-G.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,G){const Q=this.g.get(i.$TI.fromString(U).controllerId)?.collection;Q&&(await Q.expand(U,G<0?1/0:G),Q.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(G=>f.TestsDiffOp.deserialize({asCanonicalUri:Q=>Q},G)))}async $runControllerTests(U,G){return Promise.all(U.map(Q=>this.G(Q,!1,G)))}async $startContinuousRun(U,G){const Q=new P.$xe(G),ee=await Promise.all(U.map(he=>this.G(he,!0,Q.token)));return!G.isCancellationRequested&&!ee.some(he=>he.error)&&await new Promise(he=>G.onCancellationRequested(he)),Q.dispose(!0),ee}async $provideTestFollowups(U,G){const Q=this.results.find(ne=>y.get(ne)===U.resultId),ee=Q&&_(i.$TI.fromString(U.extId),Q?.results);if(!ee)return[];let he=[];return await Promise.all([...this.y].map(async ne=>{try{const De=await ne.provideFollowup(Q,ee,U.taskIndex,U.messageIndex,G);De&&(he=he.concat(De))}catch(De){this.C.error("Error thrown while providing followup for test message",De)}})),G.isCancellationRequested?[]:he.map(ne=>{const De=w++;return this.z.set(De,ne),{title:ne.title,id:De}})}$disposeTestFollowups(U){for(const G of U)this.z.delete(G)}$executeTestFollowup(U){const G=this.z.get(U);return G?this.D.executeCommand(G.command,...G.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}getMetadataForRun(U){for(const G of this.j.trackers){const Q=G.getTaskIdForRun(U);if(Q)return{taskId:Q,runId:G.id}}}async G(U,G,Q){const ee=this.g.get(U.controllerId);if(!ee)return{};const{collection:he,profiles:ne,extension:De}=ee,$e=ne.get(U.profileId);if(!$e)return{};const K=U.testIds.map(te=>he.tree.get(te)).filter(I.$ng),W=U.excludeExtIds.map(te=>ee.collection.tree.get(te)).filter(I.$ng).filter(te=>K.some(le=>le.fullId.compare(te.fullId)===i.TestPosition.IsChild));if(!K.length)return{};const se=new o.$0O(K.some(te=>te.actual instanceof g.$cQ)?void 0:K.map(te=>te.actual),W.map(te=>te.actual),$e,G),ae=(0,f.$WI)(U)&&this.j.prepareForMainThreadTestRun(De,se,M.fromInternal(U,ee.collection),$e,Q);try{return await $e.runHandler(se,Q),{}}catch(te){return{error:String(te)}}finally{ae&&ae.hasRunningTasks&&!Q.isCancellationRequested&&await O.Event.toPromise(ae.onEnd)}}};e.$ppc=D,e.$ppc=D=Je([Ve(0,d.$1P),Ve(1,k.$_j),Ve(2,c.$kQ),Ve(3,m.$_P)],D);const S=1e4;var C;(function(re){re[re.Running=0]="Running",re[re.Cancelling=1]="Cancelling",re[re.Ended=2]="Ended"})(C||(C={}));class A extends $.$Wc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(U,G,Q,ee,he,ne){super(),this.z=U,this.C=G,this.D=Q,this.F=ee,this.G=he,this.c=C.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$me),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new P.$xe(ne));const De=this.B(new r.$Rh(()=>this.H(),S));this.B(this.j.token.onCancellationRequested(()=>De.schedule()));const $e=new O.$me;this.w=$e.event,this.B((0,$.$Uc)(()=>{$e.fire(),$e.dispose()}))}getTaskIdForRun(U){for(const[G,{run:Q}]of this.g)if(Q===U)return G}cancel(){this.c===C.Running?(this.j.cancel(),this.c=C.Cancelling):this.c===C.Cancelling&&this.H()}async getCoverageDetails(U,G,Q){const[,ee]=i.$TI.fromString(U).path,he=this.y.get(U);if(!he)return[];const{report:ne,extIds:De}=he,$e=this.g.get(ee);if(!$e)throw new Error("unreachable: run task was not found");let K;if(G&&ne instanceof o.$cP){const se=De.indexOf(G);if(se===-1)return[];K=ne.fromTests[se]}return await(K?this.F?.loadDetailedCoverageForTest?.($e.run,ne,K,Q):this.F?.loadDetailedCoverage?.($e.run,ne,Q))??[]}createRun(U){const G=this.z.id,Q=this.z.controllerId,ee=(0,E.$2g)(),he=K=>(W,...se)=>{if(De){this.D.warn(`Setting the state of test "${W.id}" is a no-op after the run ends.`);return}this.J(W),K(W,...se)},ne=(K,W)=>{const se=W instanceof Array?W.map(n.TestMessage.from):[n.TestMessage.from(W)];if(K.uri&&K.range){const ae={range:n.Range.from(K.range),uri:K.uri};for(const te of se)te.location=te.location||ae}this.C.$appendTestMessagesInRun(G,ee,i.$TI.fromExtHostTestItem(K,Q).toString(),se)};let De=!1;const $e={isPersisted:this.z.isPersisted,token:this.j.token,name:U,onDidDispose:this.w,addCoverage:K=>{if(De)return;const W=K instanceof o.$cP?K.fromTests:[];if(W.length){(0,u.$7G)(this.G,"attributableCoverage");for(const te of W)this.J(te)}const se=K.uri.toString(),ae=new i.$TI([G,ee,se]).toString();this.y.set(ae,{report:K,extIds:W.map(te=>i.$TI.fromExtHostTestItem(te,Q).toString())}),this.C.$appendCoverage(G,ee,n.TestCoverage.fromFile(Q,ae,K))},enqueued:he(K=>{this.C.$updateTestStateInRun(G,ee,i.$TI.fromExtHostTestItem(K,Q).toString(),f.TestResultState.Queued)}),skipped:he(K=>{this.C.$updateTestStateInRun(G,ee,i.$TI.fromExtHostTestItem(K,Q).toString(),f.TestResultState.Skipped)}),started:he(K=>{this.C.$updateTestStateInRun(G,ee,i.$TI.fromExtHostTestItem(K,Q).toString(),f.TestResultState.Running)}),errored:he((K,W,se)=>{ne(K,W),this.C.$updateTestStateInRun(G,ee,i.$TI.fromExtHostTestItem(K,Q).toString(),f.TestResultState.Errored,se)}),failed:he((K,W,se)=>{ne(K,W),this.C.$updateTestStateInRun(G,ee,i.$TI.fromExtHostTestItem(K,Q).toString(),f.TestResultState.Failed,se)}),passed:he((K,W)=>{this.C.$updateTestStateInRun(G,ee,i.$TI.fromExtHostTestItem(K,this.z.controllerId).toString(),f.TestResultState.Passed,W)}),appendOutput:(K,W,se)=>{De||(se&&this.J(se),this.C.$appendOutputToRun(G,ee,h.$Oe.fromString(K),W&&n.location.from(W),se&&i.$TI.fromExtHostTestItem(se,Q).toString()))},end:()=>{De||(De=!0,this.C.$finishedTestRunTask(G,ee),--this.f||this.I())}};return this.f++,this.g.set(ee,{run:$e}),this.C.$startedTestRunTask(G,{id:ee,name:U,running:!0}),$e}H(){for(const{run:U}of this.g.values())U.end()}I(){this.c!==C.Ended&&(this.c=C.Ended,this.m.fire())}J(U){if(!(U instanceof g.$bQ))throw new s.$SP(U.id);if(this.h.has(i.$TI.fromExtHostTestItem(U,this.z.controllerId).toString()))return;const G=[],Q=this.z.colllection.root;for(;;){const ee=n.TestItem.from(U);if(G.unshift(ee),this.h.has(ee.extId)||(this.h.add(ee.extId),U===Q))break;U=U.parent||Q}this.C.$addTestsToRun(this.z.controllerId,this.z.id,G)}dispose(){this.I(),super.dispose()}}class b{get trackers(){return this.c.values()}constructor(U,G){this.g=U,this.h=G,this.c=new Map,this.f=new Map}getCoverageDetails(U,G,Q){const ee=i.$TI.root(U);return this.f.get(ee)?.getCoverageDetails(U,G,Q)||[]}disposeTestRun(U){this.f.get(U)?.dispose(),this.f.delete(U);for(const[G,{id:Q}]of this.c)Q===U&&this.c.delete(G)}prepareForMainThreadTestRun(U,G,Q,ee,he){return this.j(G,Q,ee,U,he)}cancelRunById(U){this.f.get(U)?.cancel()}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,G,Q,ee,he,ne){const De=this.c.get(ee);if(De)return De.createRun(he);const $e=M.fromPublic(G,Q,ee,ne),K=v(ee);this.g.$startedExtensionTestRun({controllerId:G,continuous:!!ee.continuous,profile:K&&{group:B[K.kind],id:K.profileId},exclude:ee.exclude?.map(se=>i.$TI.fromExtHostTestItem(se,Q.root.id).toString())??[],id:$e.id,include:ee.include?.map(se=>i.$TI.fromExtHostTestItem(se,Q.root.id).toString())??[Q.root.id],preserveFocus:ee.preserveFocus??!0,persist:ne});const W=this.j(ee,$e,ee.profile,U);return O.Event.once(W.onEnd)(()=>{this.g.$finishedExtensionTestRun($e.id)}),W.createRun(he)}j(U,G,Q,ee,he){const ne=new A(G,this.g,this.h,Q,ee,he);return this.c.set(U,ne),this.f.set(ne.id,ne),ne}}e.$qpc=b;const v=re=>{if(re.profile){if(!(re.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return re.profile}};class M{static fromPublic(U,G,Q,ee){return new M(U,(0,E.$2g)(),ee,G)}static fromInternal(U,G){return new M(U.controllerId,U.runId,!0,G)}constructor(U,G,Q,ee){this.controllerId=U,this.id=G,this.isPersisted=Q,this.colllection=ee}}e.$rpc=M;class N{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,n.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const G=i.$TI.parentId(U.item.extId);if(G&&this.h.has(G.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:G,g:Q}=this;return{get added(){return[...U].map(ee=>ee.revived)},get updated(){return[...G].map(ee=>ee.revived)},get removed(){return[...Q].map(ee=>ee.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class L extends f.$3I{constructor(){super(...arguments),this.y=new O.$me,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}x(U,G){return{...U,revived:n.TestItem.toPlain(U.item),depth:G?G.depth+1:0,children:new Set}}w(){return new N(this.y)}}class j{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(G=>G.revived)},dispose:(0,T.$fb)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new L({asCanonicalUri:G=>G});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const z=(re,U,G,Q)=>{G?Object.assign(G,Q):U.$updateTestRunConfig(re.controllerId,re.profileId,Q)};class F{#e;#t;#i;#n;#s;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,z(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,z(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#t.add(this.profileId):this.#t.delete(this.profileId),z(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,z(this,this.#e,this.#n,{tag:U?n.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,z(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return O.Event.chain(this.#i,U=>U.map(G=>G.get(this.controllerId)?.get(this.profileId)).filter(I.$ng))}constructor(U,G,Q,ee,he,ne,De,$e,K,W=!1,se=void 0,ae=!1){this.controllerId=he,this.profileId=ne,this.f=De,this.kind=$e,this.runHandler=K,this._tag=se,this.g=ae,this.#e=U,this.#s=G,this.#t=Q,this.#i=ee,G.set(ne,this);const te=B[$e];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${$e}`);W&&Q.add(ne),this.#n={profileId:ne,controllerId:he,tag:se?n.TestTag.namespace(this.controllerId,se.id):null,label:De,group:te,isDefault:W,hasConfigurationHandler:!1,supportsContinuousRun:ae},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$spc=F;const B={[o.TestRunProfileKind.Coverage]:f.TestRunProfileBitset.Coverage,[o.TestRunProfileKind.Debug]:f.TestRunProfileBitset.Debug,[o.TestRunProfileKind.Run]:f.TestRunProfileBitset.Run};function _(re,U){for(let G=0;G<re.path.length;G++){const Q=U.find(ee=>ee.id===re.path[G]);if(!Q)return;if(G===re.path.length-1)return Q;U=Q.children}}}),define(ye[371],Se([1,0,19,4,3,6,168,16,10]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=void 0,r=We(r),R=We(R);class a extends P.$Wc{constructor(E,l){super(),this.m=l,this.a=new h.$me,this.b=new h.$me,this.c=new h.$me,this.f=new h.$me,this.g=new h.$me,this.h=new h.$me,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=E.getProxy(O.$uN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(k=>this.h.fire(k))),this.B(this.m.onDidChangeActiveTextEditor(k=>this.g.fire(k)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(E){const l=this.m.allEditors();return E?l:l.map(k=>k.value)}async showTextDocument(E,l,k){let p;typeof l=="number"?p={position:R.ViewColumn.from(l),preserveFocus:k}:typeof l=="object"?p={position:R.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selection:typeof l.selection=="object"?R.Range.from(l.selection):void 0,pinned:typeof l.preview=="boolean"?!l.preview:void 0}:p={preserveFocus:!1};const c=await this.j.$tryShowTextDocument(E.uri,p),m=c&&this.m.getEditor(c);if(m)return m.value;throw c?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}createTextEditorDecorationType(E,l){return new T.$8P(this.j,E,l).value}$acceptEditorPropertiesChanged(E,l){const k=this.m.getEditor(E);if(!k)throw new Error("unknown text editor");if(l.options&&k._acceptOptions(l.options),l.selections){const p=l.selections.selections.map(R.Selection.to);k._acceptSelections(p)}if(l.visibleRanges){const p=r.$Jb(l.visibleRanges.map(R.Range.to));k._acceptVisibleRanges(p)}if(l.options&&this.b.fire({textEditor:k.value,options:{...l.options,lineNumbers:R.TextEditorLineNumbersStyle.to(l.options.lineNumbers)}}),l.selections){const p=$.TextEditorSelectionChangeKind.fromValue(l.selections.source),c=l.selections.selections.map(R.Selection.to);this.a.fire({textEditor:k.value,selections:c,kind:p})}if(l.visibleRanges){const p=r.$Jb(l.visibleRanges.map(R.Range.to));this.c.fire({textEditor:k.value,visibleRanges:p})}}$acceptEditorPositionData(E){for(const l in E){const k=this.m.getEditor(l);if(!k)throw new Error("Unknown text editor");const p=R.ViewColumn.to(E[l]);k.value.viewColumn!==p&&(k._acceptViewColumn(p),this.f.fire({textEditor:k.value,viewColumn:p}))}}getDiffInformation(E){return Promise.resolve(this.j.$getDiffInformation(E))}}e.$zoc=a}),define(ye[372],Se([1,0,2,5,6,3,10,16,24,41,18]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=e.$jqc=void 0,e.$jqc=(0,h.$Fi)("IExtHostTimeline");class E{constructor(p,c){this.b=new Map,this.c=new Map,this.a=p.getProxy(P.$uN.MainThreadTimeline),c.registerArgumentProcessor({processArgument:(m,d)=>{if(m&&m.$mid===a.MarshalledId.TimelineActionContext)if(this.b.get(m.source)&&$.$qn.equals(d,this.b.get(m.source)?.extension)){const g=m.uri===void 0?void 0:r.URI.revive(m.uri);return this.c.get(m.source)?.get(l(g))?.get(m.handle)}else return;return m}})}async $getTimeline(p,c,m,d){return this.b.get(p)?.provider.provideTimeline(r.URI.revive(c),m,d)}registerTimelineProvider(p,c,m,d){const g=new O.$Vc,n=this.d(c.id,d,g).bind(this);let o;c.onDidChange&&(o=c.onDidChange(i=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...i,id:c.id}),this));const t=this.c;return this.f({...c,scheme:p,onDidChange:void 0,async provideTimeline(i,s,f){s?.resetCache&&(g.clear(),t.get(c.id)?.clear());const u=await c.provideTimeline(i,s,f);if(u==null)return;const w=n(i,s);return{...u,source:c.id,items:u.items.map(w)}},dispose(){for(const i of t.values())i.get(c.id)?.clear();o?.dispose(),g.dispose()}},m)}d(p,c,m){return(d,g)=>{let n;if(g?.cacheResults){let o=this.c.get(p);o===void 0&&(o=new Map,this.c.set(p,o));const t=l(d);n=o.get(t),n===void 0&&(n=new Map,o.set(t,n))}return o=>{const{iconPath:t,...i}=o,s=`${p}|${o.id??o.timestamp}`;n?.set(s,o);let f,u,w;o.iconPath&&(t instanceof T.$tO?w={id:t.id,color:t.color}:r.URI.isUri(t)?(f=t,u=t):{light:f,dark:u}=t);let y;return T.$YN.isMarkdownString(i.tooltip)?y=R.MarkdownString.from(i.tooltip):(0,I.$fg)(i.tooltip)?y=i.tooltip:T.$YN.isMarkdownString(i.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=R.MarkdownString.from(i.detail)):(0,I.$fg)(i.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=i.detail),{...i,id:i.id??void 0,handle:s,source:p,command:o.command?c.toInternal(o.command,m):void 0,icon:f,iconDark:u,themeIcon:w,tooltip:y,accessibilityInformation:o.accessibilityInformation}}}}f(p,c){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:c}),(0,O.$Uc)(()=>{for(const d of this.c.values())d.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$kqc=E;function l(k){return k?.toString()}}),define(ye[373],Se([1,0,243,23,2,4,3,305,9,10,18,19,16,86,21,199,26]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lqc=void 0,a=We(a);function d(o,t){if((0,I.$fg)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let i;return Array.isArray(o.highlights)&&(i=o.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),i=i.length?i:void 0),{label:o.label,highlights:i}}}class g extends T.$Wc{constructor(t,i,s){super(),this.f=t,this.g=i,this.h=s,this.a=new Map,this.b=new c.$v_;function f(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:u=>f(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map(w=>f(w)?this.r(w):w):u})}registerTreeDataProvider(t,i,s){const f=this.createTreeView(t,{treeDataProvider:i},s);return{dispose:()=>f.dispose()}}createTreeView(t,i,s){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=i.dragAndDropController?.dropMimeTypes??[],u=i.dragAndDropController?.dragMimeTypes??[],w=!!i.dragAndDropController?.handleDrag,y=!!i.dragAndDropController?.handleDrop,D=this.m(t,i,s),S={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:f,dragMimeTypes:u,hasHandleDrag:w,hasHandleDrop:y,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},C=this.f.$registerTreeViewDataProvider(t,S),A={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,m.$7G)(s,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,m.$7G)(s,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(b){(0,k.$5k)(b)&&(0,m.$7G)(s,"treeViewMarkdownMessage"),D.message=b},get title(){return D.title},set title(b){D.title=b},get description(){return D.description},set description(b){D.description=b},get badge(){return D.badge},set badge(b){b!==void 0&&a.ViewBadge.isViewBadge(b)?D.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(D.badge=void 0)},reveal:(b,v)=>D.reveal(b,v),dispose:async()=>{await C,this.a.delete(t),D.dispose()}};return this.B(A),A}$getChildren(t,i){const s=this.a.get(t);return s?s.getChildren(i):Promise.reject(new R.$qG(t))}async $handleDrop(t,i,s,f,u,w,y,D){const S=this.a.get(t);if(!S)return Promise.reject(new R.$qG(t));const C=l.DataTransfer.toDataTransfer(s,async A=>(await this.f.$resolveDropFileData(t,i,A)).buffer);return y===t&&D&&await this.j(C,S,D,u,w),S.onDrop(C,f,u)}async j(t,i,s,f,u){const w=this.b.removeDragOperationTransfer(u);if(w)(await w)?.forEach((y,D)=>{y&&t.set(D,y)});else if(u&&i.handleDrag){const y=i.handleDrag(s,t,f);this.b.addDragOperationTransfer(u,y),await y}return t}async $handleDrag(t,i,s,f){const u=this.a.get(t);if(!u)return Promise.reject(new R.$qG(t));const w=await this.j(new a.$pO,u,i,f,s);if(!(!w||f.isCancellationRequested))return l.DataTransfer.from(w)}async $hasResolve(t){const i=this.a.get(t);if(!i)throw new R.$qG(t);return i.hasResolve}$resolve(t,i,s){const f=this.a.get(t);if(!f)throw new R.$qG(t);return f.resolveTreeItem(i,s)}$setExpanded(t,i,s){const f=this.a.get(t);if(!f)throw new R.$qG(t);f.setExpanded(i,s)}$setSelectionAndFocus(t,i,s){const f=this.a.get(t);if(!f)throw new R.$qG(t);f.setSelectionAndFocus(i,s)}$setVisible(t,i){const s=this.a.get(t);if(!s){if(!i)return;throw new R.$qG(t)}s.setVisible(i)}$changeCheckboxState(t,i){const s=this.a.get(t);if(!s)throw new R.$qG(t);s.setCheckboxState(i)}m(t,i,s){const f=this.B(new n(t,i,this.f,this.g.converter,this.h,s));return this.a.set(t,f),f}r(t){const i=this.a.get(t.$treeViewId);return i&&"$treeItemHandle"in t?i.getExtensionElement(t.$treeItemHandle):i&&"$focusedTreeItem"in t&&t.$focusedTreeItem?i.focusedElement:null}}e.$lqc=g;class n extends T.$Wc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$og)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,i,s,f,u,w){if(super(),this.I=t,this.J=s,this.L=f,this.M=u,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$me),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$me),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$me),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$me),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$me),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$me),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$me),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$xe,w.contributes&&w.contributes.views)for(const C in w.contributes.views)for(const A of w.contributes.views[C])A.id===t&&(this.P=A.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(C=>{Array.isArray(C)&&C.length===0||this.F.fire({message:!1,element:C})}));let y,D;const S=O.Event.debounce(this.F.event,(C,A)=>(C||(C={message:!1,elements:[]}),A.element!==!1&&(y||(y=new Promise(b=>D=b),this.G=this.G.then(()=>y)),Array.isArray(A.element)?C.elements.push(...A.element):C.elements.push(A.element)),A.message&&(C.message=!0),C),200,!0);this.B(S(({message:C,elements:A})=>{A.length&&(this.H=this.H.then(()=>{const b=D;return y=null,this.$(A).then(()=>b())})),C&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const i=t?this.getExtensionElement(t):void 0;if(t&&!i)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let s=this.X(t);return s||(s=await this.Y(i)),s?s.map(f=>f.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,i){i=i||{select:!0,focus:!1};const s=(0,I.$og)(i.select)?!0:i.select,f=(0,I.$og)(i.focus)?!1:i.focus,u=(0,I.$og)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(w=>this.W(t,w[w.length-1]).then(y=>this.J.$reveal(this.I,{item:y.item,parentChain:w.map(D=>D.item)},{select:s,focus:f,expand:u})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:s,focus:f,expand:u})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=l.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,i){const s=this.getExtensionElement(t);s&&(i?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(t,i){const s=!(0,E.$wb)(this.s,t);this.s=t;const f=this.t!==i;this.t=i,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),f&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const i=(await Promise.all(t.map(async s=>{const f=this.getExtensionElement(s.treeItemHandle);return f?{extensionItem:f,treeItem:await this.f.getTreeItem(f),newState:s.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);i.forEach(s=>{s.treeItem.checkboxState=s.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(s=>[s.extensionItem,s.newState])})}async handleDrag(t,i,s){const f=[];for(const u of t){const w=this.getExtensionElement(u);w&&f.push(w)}if(!(!this.g?.handleDrag||f.length===0))return await this.g.handleDrag(f,i,s),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,i,s){const f=i?this.getExtensionElement(i):void 0;if(!(!f&&i||!this.g?.handleDrop))return(0,$.$xh)(()=>this.g?.handleDrop?this.g.handleDrop(f,t,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,i){if(!this.f.resolveTreeItem)return;const s=this.j.get(t);if(s){const f=this.m.get(s);if(f){const u=await this.f.resolveTreeItem(f.extensionItem,s,i)??f.extensionItem;return this.hb(u),f.item.tooltip=this.eb(u.tooltip),f.item.command=this.fb(f.disposableStore,u.command),f.item}}}S(t){return this.U(t).then(i=>i?this.S(i).then(s=>this.W(i,s[s.length-1]).then(f=>(s.push(f),s))):Promise.resolve([]))}U(t){const i=this.m.get(t);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,$.$xh)(()=>this.f.getParent(t))}W(t,i){const s=this.m.get(t);return s?Promise.resolve(s):(0,$.$xh)(()=>this.f.getTreeItem(t)).then(f=>this.kb(t,f,i,!0)).then(f=>this.getChildren(i?i.item.handle:void 0).then(()=>{const u=this.getExtensionElement(f);if(u){const w=this.m.get(u);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${f} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let i;if(typeof t=="string"){const s=this.getExtensionElement(t);i=s?this.m.get(s):void 0}else i=t;return i&&i.children||void 0}return this.h}async Y(t){this.rb(t);const i=new p.$xe(this.Z.token);try{const s=t?this.m.get(t):void 0,f=await this.f.getChildren(t);if(i.token.isCancellationRequested)return;const u=(0,E.$Jb)(f||[]),w=await Promise.all((0,E.$Jb)(u).map(D=>this.f.getTreeItem(D)));if(i.token.isCancellationRequested)return;const y=w.map((D,S)=>D?this.db(u[S],D,s):null);return(0,E.$Jb)(y)}finally{i.dispose()}}$(t){if(t.some(s=>!s))return this.Z.dispose(!0),this.Z=new p.$xe,this.tb(),this.J.$refresh(this.I);{const s=this.ab(t);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(t){const i=new Set,s=t.map(u=>this.m.get(u));for(const u of s)if(u&&!i.has(u.item.handle)){let w=u;for(;w&&w.parent&&s.findIndex(y=>w&&w.parent&&y&&y.item.handle===w.parent.item.handle)===-1;){const y=this.j.get(w.parent.item.handle);w=y?this.m.get(y):void 0}w&&!w.parent&&i.add(u.item.handle)}const f=[];return i.forEach(u=>{const w=this.j.get(u);if(w){const y=this.m.get(w);y&&(!y.parent||!i.has(y.parent.item.handle))&&f.push(u)}}),f}bb(t){const i={};return Promise.all(t.map(s=>this.cb(s).then(f=>{f&&(i[s]=f.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(t){const i=this.getExtensionElement(t);if(i){const s=this.m.get(i);if(s)return this.rb(i),(0,$.$xh)(()=>this.f.getTreeItem(i)).then(f=>{if(f){const u=this.ib(i,f,s.parent);return this.pb(i,u,s,s.parent),s.dispose(),u}return null})}return Promise.resolve(null)}db(t,i,s){const f=this.ib(t,i,s);if(i.id&&this.j.has(f.item.handle))throw new Error((0,r.localize)(0,null,i.id));return this.ob(t,f),this.qb(f,s),f}eb(t){return a.$YN.isMarkdownString(t)?l.MarkdownString.from(t):t}fb(t,i){return i?{...this.L.toInternal(i,t),originalId:i.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let i,s,f;return typeof t.checkboxState=="number"?i=t.checkboxState:(i=t.checkboxState.state,s=t.checkboxState.tooltip,f=t.checkboxState.accessibilityInformation),{isChecked:i===a.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:f}}hb(t){if(!a.$kO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,i,s){this.hb(i);const f=this.B(new T.$Vc),u=this.kb(t,i,s),w=this.lb(i);return{item:{handle:u,parentHandle:s?s.item.handle:void 0,label:d(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(f,i.command),contextValue:i.contextValue,icon:w,iconDark:this.mb(i)||w,themeIcon:this.jb(i),collapsibleState:(0,I.$og)(i.collapsibleState)?a.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:s,children:void 0,disposableStore:f,dispose(){f.dispose()}}}jb(t){return t.iconPath instanceof a.$tO?t.iconPath:void 0}kb(t,{id:i,label:s,resourceUri:f},u,w){if(i)return`${n.b}/${i}`;const y=d(s,this.N),D=u?u.item.handle:n.a;let S=y?y.label:f?(0,h.$dh)(f):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const C=this.m.has(t)?this.m.get(t).item.handle:void 0,A=this.X(u)||[];let b,v=0;do{if(b=`${D}/${v}:${S}`,w||!this.j.has(b)||C===b)break;v++}while(v<=A.length);return b}lb(t){if(t.iconPath&&!(t.iconPath instanceof a.$tO))return typeof t.iconPath=="string"||P.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof a.$tO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return P.URI.isUri(t)?t:P.URI.file(t)}ob(t,i){this.j.set(i.item.handle,t),this.m.set(t,i)}pb(t,i,s,f){this.j.delete(i.item.handle),this.m.delete(t),i.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(t,i);const u=this.X(f)||[],w=u.filter(y=>y.item.handle===s.item.handle)[0];w&&u.splice(u.indexOf(w),1,i)}qb(t,i){i?(i.children||(i.children=[]),i.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const i=this.m.get(t);if(i){if(i.children)for(const s of i.children){const f=this.j.get(s.item.handle);f&&this.sb(f)}i.children=void 0}}else this.tb()}sb(t){const i=this.m.get(t);if(i){if(i.children)for(const s of i.children){const f=this.j.get(s.item.handle);f&&this.sb(f)}this.m.delete(t),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ye[374],Se([1,0,4,3,2,32,16,97,6,10]),function(ce,e,r,h,P,O,T,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Soc=void 0,T=We(T),$=We($),a=We(a);class I extends h.$Wc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(p,c,m,d){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new r.$me),this.onDidDispose=this.#d.event,this.#h=this.B(new r.$me),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=c,this.#n=m,this.#i=d.viewType,this.#s=d.panelOptions,this.#o=d.viewColumn,this.#r=d.title,this.#l=d.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(p){this.c(),this.#r!==p&&(this.#r=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,P.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(p){this.#u||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#l=p.active,this.#c=p.visible,this.#o=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,c){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:T.ViewColumn.from(p),preserveFocus:!!c})}c(){if(this.#u)throw new Error("Webview is disposed")}}class E extends h.$Wc{static c(){return(0,O.$2g)()}constructor(p,c,m){super(),this.j=c,this.m=m,this.g=new Map,this.h=new Map,this.f=p.getProxy($.$uN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,c,m,d,g={}){const n=typeof d=="object"?d.viewColumn:d,o={viewColumn:T.ViewColumn.from(n),preserveFocus:typeof d=="object"&&!!d.preserveFocus},t=(0,R.$Ooc)(p),i=E.c();this.f.$createWebviewPanel((0,R.$Qoc)(p),i,c,{title:m,panelOptions:l(g),webviewOptions:(0,R.$Roc)(p,this.m,g),serializeBuffersForPostMessage:t},o);const s=this.j.createNewWebview(i,g,p);return this.createNewWebviewPanel(i,c,m,n,g,s,!0)}$onDidChangeWebviewPanelViewStates(p){const c=Object.keys(p);c.sort((m,d)=>{const g=p[m],n=p[d];return g.active?1:n.active?-1:+g.visible-+n.visible});for(const m of c){const d=this.getWebviewPanel(m);if(!d)continue;const g=p[m];d._updateViewState({active:g.active,visible:g.visible,viewColumn:T.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,c,m){if(this.h.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.h.set(c,{serializer:m,extension:p}),this.f.$registerSerializer(c,{serializeBuffersForPostMessage:(0,R.$Ooc)(p)}),new a.$wN(()=>{this.h.delete(c),this.f.$unregisterSerializer(c)})}async $deserializeWebviewPanel(p,c,m,d){const g=this.h.get(c);if(!g)throw new Error(`No serializer found for '${c}'`);const{serializer:n,extension:o}=g,t=this.j.createNewWebview(p,m.webviewOptions,o),i=this.createNewWebviewPanel(p,c,m.title,d,m.panelOptions,t,m.active);await n.deserializeWebviewPanel(i,m.state)}createNewWebviewPanel(p,c,m,d,g,n,o){const t=new I(p,this.f,n,{viewType:c,title:m,viewColumn:d,panelOptions:g,active:o});return this.g.set(p,t),t}getWebviewPanel(p){return this.g.get(p)}}e.$Soc=E;function l(k){return{enableFindWidget:k.enableFindWidget,retainContextWhenHidden:k.retainContextWhenHidden}}}),define(ye[375],Se([1,0,4,3,97,16,6,10]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oqc=void 0,T=We(T),R=We(R);class $ extends h.$Wc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(E,l,k,p,c,m){super(),this.#s=!1,this.#l=this.B(new r.$me),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new r.$me),this.onDidDispose=this.#u.event,this.#i=k,this.#a=p,this.#e=E,this.#t=l,this.#n=c,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(E){this.a(),this.#a!==E&&(this.#a=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#o}set description(E){this.a(),this.#o!==E&&(this.#o=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(E){E===this.#r||this.#s||(this.#r=E,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(E){this.a(),!(E?.value===this.#c?.value&&E?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#s)throw new Error("Webview is disposed")}}class a{constructor(E,l){this.d=l,this.b=new Map,this.c=new Map,this.a=E.getProxy(T.$uN.MainThreadWebviewViews)}registerWebviewViewProvider(E,l,k,p){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:k,extension:E}),this.a.$registerWebviewViewProvider((0,P.$Qoc)(E),l,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$Ooc)(E)}),new R.$wN(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(E,l,k,p,c){const m=this.b.get(l);if(!m)throw new Error(`No view provider found for '${l}'`);const{provider:d,extension:g}=m,n=this.d.createNewWebview(E,{},g),o=new $(E,this.a,l,k,n,!0);this.c.set(E,o),await d.resolveWebviewView(o,{state:p},c)}async $onDidChangeWebviewViewVisibility(E,l){this.e(E)._setVisible(l)}async $disposeWebviewView(E){const l=this.e(E);this.c.delete(E),l.dispose(),this.d.deleteWebview(E)}e(E){const l=this.c.get(E);if(!l)throw new Error("No webview found");return l}}e.$oqc=a}),define(ye[376],Se([1,0,76,15,12,277,28,11]),function(ce,e,r,h,P,O,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qc=void 0;let $=class{constructor(E,l){E.addFileSystemProvider(h.Schemas.file,new a(l),{isCaseSensitive:R.$k})}};e.$7qc=$,e.$7qc=$=Je([Ve(0,r.$Koc),Ve(1,P.$_j)],$);class a{constructor(E){this.b=E,this.a=new O.$qr(this.b)}async stat(E){const l=await this.a.stat(E);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions===T.FilePermission.Readonly?1:void 0}}readDirectory(E){return this.a.readdir(E)}createDirectory(E){return this.a.mkdir(E)}readFile(E){return this.a.readFile(E)}writeFile(E,l,k){return this.a.writeFile(E,l,{...k,unlock:!1,atomic:!1})}delete(E,l){return this.a.delete(E,{...l,useTrash:!1,atomic:!1})}rename(E,l,k){return this.a.rename(E,l,k)}copy(E,l,k){return this.a.copy(E,l,k)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(E,l){throw new Error("Method not implemented.")}}}),define(ye[377],Se([1,0,17,68,32,35,3,6,2,20]),function(ce,e,r,h,P,O,T,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0;let I=class extends T.$Wc{constructor(l,k){super();const p=l.getProxy(R.$uN.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async c=>{const m=$.URI.file((0,r.$lc)((0,h.tmpdir)(),(0,P.$2g)()));return await p.$download(c,m),m})}};e.$5qc=I,e.$5qc=I=Je([Ve(0,a.$1P),Ve(1,O.$kQ)],I)}),define(ye[378],Se([1,0,61,17,2,98,3,15,9,34]),function(ce,e,r,h,P,O,T,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$erc=void 0,r=We(r),h=We(h);class I extends O.$Moc{constructor(){super(...arguments),this.i=null}async g(i){const s=await super.g(i);if(s.scheme!==R.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const f=s.fsPath;let u=0;do{let w;u===0?w=f:w=/[/\\]$/.test(f)?`${f.substr(0,f.length-1)}-${u}`:`${f}-${u}`,await E(w);const y=h.$lc(w,"vscode.lock"),D=await c(this.d,y,!1);if(D)return this.i=D,process.on("exit",()=>{D.dispose()}),P.URI.file(w);u++}while(u<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$erc=I;async function E(t){try{await a.Promises.stat(t);return}catch{}try{await a.Promises.mkdir(t,{recursive:!0})}catch{}}const l=1e3,k=10*60*1e3;class p extends T.$Wc{constructor(i,s){super(),this.b=i,this.c=s,this.a=this.B(new $.$Qh),this.a.cancelAndSet(async()=>{const f=await m(i,s);(!f||f.pid!==process.pid)&&(i.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await a.Promises.utimes(s,new Date,new Date)}catch(u){i.error(u),i.info(`Lock '${s}': Could not update mtime.`)}},l)}dispose(){super.dispose();try{r.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+i};await a.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function c(t,i,s){try{const u={pid:process.pid,willReleaseAt:0};await a.Promises.writeFile(i,JSON.stringify(u),{flag:"wx"})}catch(u){t.error(u)}const f=await m(t,i);return!f||f.pid!==process.pid?s?(t.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(t.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),n(t,i)):(t.info(`Lock '${i}': Lock acquired.`),new p(t,i))}async function m(t,i){let s;try{s=await a.Promises.readFile(i)}catch(f){return t.error(f),null}try{return JSON.parse(String(s))}catch(f){return t.error(f),null}}async function d(t,i){let s;try{s=await a.Promises.stat(i)}catch(f){return t.error(f),0}return s.mtime.getTime()}function g(t){try{return process.kill(t,0),!0}catch{return!1}}async function n(t,i){const s=await m(t,i);if(!s)return t.info(`Lock '${i}': Could not read pid of lock holder.`),o(t,i);if(s.willReleaseAt){let D=s.willReleaseAt-Date.now();if(D<5e3){for(D>0?t.info(`Lock '${i}': The lockfile is scheduled to be released in ${D} ms.`):t.info(`Lock '${i}': The lockfile is scheduled to have been released.`);D>0;){if(await(0,$.$Gh)(Math.min(100,D)),await d(t,i)===0)return o(t,i);D=s.willReleaseAt-Date.now()}return o(t,i)}}if(!g(s.pid))return t.info(`Lock '${i}': The pid ${s.pid} appears to be gone.`),o(t,i);const f=await d(t,i),u=Date.now()-f;if(u<=k)return t.info(`Lock '${i}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;t.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,$.$Gh)(2e3);const w=await d(t,i),y=Date.now()-w;return y<=k?(t.info(`Lock '${i}': The lock does not look stale, elapsed: ${y} ms, giving up.`),null):(t.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),o(t,i))}async function o(t,i){t.info(`Lock '${i}': Deleting a stale lock.`);try{await a.Promises.unlink(i)}catch{}return c(t,i,!0)}}),define(ye[379],Se([1,0,32,20,47,35]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zqc=void 0;let T=class extends P.$9oc{constructor($,a){super(!0,$,a)}createTerminal($,a,I){return this.createTerminalFromOptions({name:$,shellPath:a,shellArgs:I})}createTerminalFromOptions($,a){const I=new P.$8oc(this.a,(0,r.$2g)(),$,$.name);return this.f.push(I),I.create($,this.R($,a)),I.value}};e.$zqc=T,e.$zqc=T=Je([Ve(0,O.$kQ),Ve(1,h.$1P)],T)}),define(ye[380],Se([1,0,4,37,36,5]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.OutputChannelUpdateMode=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=void 0,e.$CM="text/x-code-output",e.$DM="output",e.$EM="Log",e.$FM="text/x-code-log-output",e.$GM="log",e.$HM="workbench.panel.output",e.$IM=new P.$Wj("inOutput",!1),e.$JM=new P.$Wj("activeLogOutput",!1),e.$KM=new P.$Wj("activeLogOutput.levelSettable",!1),e.$LM=new P.$Wj("activeLogOutput.level",""),e.$MM=new P.$Wj("activeLogOutput.levelIsDefault",!1),e.$NM=new P.$Wj("outputView.scrollLock",!1),e.$OM=(0,O.$Fi)("outputService");var T;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.$PM={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new r.$me,this.onDidRegisterChannel=this.b.event,this.c=new r.$me,this.onDidRemoveChannel=this.c.event}registerChannel(a){this.a.has(a.id)||(this.a.set(a.id,a),this.b.fire(a.id))}getChannels(){const a=[];return this.a.forEach(I=>a.push(I)),a}getChannel(a){return this.a.get(a)}removeChannel(a){this.a.delete(a),this.c.fire(a)}}h.$qo.add(e.$PM.OutputChannels,new R),e.$QM=new P.$Wj("activeOutputChannel","")}),define(ye[169],Se([1,0,6,5,20,24,12,380,76,30,63,204,22,18,28,4,3]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=e.$4pc=void 0;class d extends T.$fk{get disposed(){return this.n}constructor(t,i,s,f,u){super(),this.id=t,this.name=i,this.r=s,this.s=f,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,R.OutputChannelUpdateMode.Clear,t)}replace(t){const i=this.m;this.info(t),this.s.$update(this.id,R.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(t,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:i))}hide(){this.s.$close(this.id)}g(t,i){this.m+=l.$Oe.fromString(i).byteLength,(0,T.log)(this.r,t,i),this.visible&&(this.r.flush(),this.s.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class g extends d{appendLine(t){this.append(t)}}let n=class{constructor(t,i,s,f,u,w){this.i=i,this.j=s,this.k=f,this.l=u,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(r.$uN.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,E.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(t,i,s){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const f=typeof i=="object"&&i.log,u=(0,k.$fg)(i)?i:void 0;if((0,k.$fg)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const y=this.i.environment.extensionLogLevel?.find(([S])=>O.$qn.equals(s.identifier,S))?.[1];y&&(w=(0,T.$qk)(y));const D=f?this.o(t,w,s):this.n(t,u,s);return D.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),f?this.r(t,w??this.m.getLevel(),D):this.q(t,D)}async n(t,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const f=await this.c,u=this.k.extUri.joinPath(f,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),y=await this.a.$register(t,u,i,s.identifier.value);return new d(y,t,w,this.a,s)}async o(t,i,s){const f=await this.p(s),u=t.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(f,`${u}.log`),y=`${s.identifier.value}.${u}`,D=this.l.createLogger(w,{id:y,name:t,logLevel:i,extensionId:s.identifier.value});return new g(y,t,D,this.a,s)}p(t){let i=this.d.get(t.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(f){if((0,p.$pl)(f)!==p.FileSystemProviderErrorCode.FileExists)throw f}return s})())}return i}q(t,i){let s=!1;const f=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return t},append(u){f(),i.then(w=>w.append(u))},appendLine(u){f(),i.then(w=>w.appendLine(u))},clear(){f(),i.then(u=>u.clear())},replace(u){f(),i.then(w=>w.replace(u))},show(u,w){f(),i.then(y=>y.show(u,w))},hide(){f(),i.then(u=>u.hide())},dispose(){s=!0,i.then(u=>u.dispose())}}}r(t,i,s){const f=new m.$Vc,u=()=>{if(f.isDisposed)throw new Error("Channel has been closed")},w=f.add(new c.$me);function y(D){i=D,w.fire(D)}return s.then(D=>{f.add(D),D.logLevel!==i&&y(D.logLevel),f.add(D.onDidChangeLogLevel(S=>y(S)))}),{...this.q(t,s),get logLevel(){return i},onDidChangeLogLevel:w.event,trace(D,...S){u(),s.then(C=>C.trace(D,...S))},debug(D,...S){u(),s.then(C=>C.debug(D,...S))},info(D,...S){u(),s.then(C=>C.info(D,...S))},warn(D,...S){u(),s.then(C=>C.warn(D,...S))},error(D,...S){u(),s.then(C=>C.error(D,...S))},dispose(){f.dispose()}}}};e.$4pc=n,e.$4pc=n=Je([Ve(0,P.$1P),Ve(1,a.$eQ),Ve(2,$.$Koc),Ve(3,I.$noc),Ve(4,T.$ak),Ve(5,T.$_j)],n),e.$5pc=(0,h.$Fi)("IExtHostOutputService")}),define(ye[170],Se([1,0,5,9]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0,e.$Vm=(0,r.$Fi)("remoteAgentService"),e.$Wm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let O=1/0;for(let R=0;R<this.maxSampleCount;R++){const $=await P.getRoundTripTime();if($===void 0)return;O=Math.min(O,$/2),await(0,h.$Gh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(O):T=this.initial.reduce((R,$)=>R+$,0)/this.initial.length,this.lastMeasurement={initial:T,current:O,average:this.average.reduce((R,$)=>R+$,0)/this.average.length,high:typeof T>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>T*this.highLatencyMultiple},this.lastMeasurement}}}),define(ye[381],Se([1,0,247,71,37,46,45,3,4,170,11,25,9,151]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=void 0,e.$7K=Object.freeze({id:"application",order:100,title:(0,r.localize)(0,null),type:"object"}),e.$8K=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(1,null),type:"object"}),e.$9K=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,r.localize)(2,null),type:"object",order:7}),e.$0K=Object.freeze({id:"problems",title:(0,r.localize)(3,null),type:"object",order:101}),e.$$K=Object.freeze({id:"window",order:8,title:(0,r.localize)(4,null),type:"object"}),e.$_K={ConfigurationMigration:"base.contributions.configuration.migration"};class p{constructor(){this.migrations=[],this.a=new $.$me,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const c=new p;P.$qo.add(e.$_K.ConfigurationMigration,c);let m=class extends R.$Wc{static{this.ID="workbench.contrib.configurationMigration"}constructor(o,t){super(),this.a=o,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async i=>{for(const s of i.added)await this.f(s,c.migrations)})),this.c(c.migrations),this.B(c.onDidRegisterConfigurationMigration(i=>this.c(i)))}async c(o){await this.f(void 0,o);for(const t of this.b.getWorkspace().folders)await this.f(t,o)}async f(o,t){await Promise.all([t.map(i=>this.g(i,o?.uri))])}async g(o,t){const i=this.a.inspect(o.key,{resource:t}),s=this.b.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE],["workspaceFolder",T.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE]];for(const[f,u]of s){const w=i[f];if(!w)continue;const y=[];if(w.value!==void 0){const D=await this.h(o,f,w.value,t,void 0);for(const S of D??[])y.push([S,[]])}for(const{identifiers:D,value:S}of w.overrides??[])if(S!==void 0){const C=await this.h(o,f,S,t,D);for(const A of C??[])y.push([A,D])}y.length&&await Promise.allSettled(y.map(async([[D,S],C])=>this.a.updateValue(D,S.value,{resource:t,overrideIdentifiers:C},u)))}}async h(o,t,i,s,f){const u=y=>{const S=this.a.inspect(y,{resource:s})[t];if(S)return f?S.overrides?.find(({identifiers:C})=>(0,E.$ho)(C,f))?.value:S.value},w=await o.migrateFn(i,u);return Array.isArray(w)?w:[[o.key,w]]}};e.$aL=m,e.$aL=m=Je([Ve(0,T.$_i),Ve(1,O.$Oi)],m);let d=class extends R.$Wc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(o){super(),this.b=o,this.a=new l.$3h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$i&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;P.$qo.as(h.$vo.Configuration).registerConfiguration({...e.$9K,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(5,null)},default:[],markdownDescription:(0,r.localize)(6,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(7,null),scope:h.ConfigurationScope.MACHINE}}})}};e.$bL=d,e.$bL=d=Je([Ve(0,a.$Vm)],d),e.$cL="window.newWindowProfile";let g=class extends R.$Wc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(o,t){super(),this.c=o,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(i=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(i=>{i.source!==T.ConfigurationTarget.DEFAULT&&i.affectsConfiguration(e.$cL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const o=P.$qo.as(h.$vo.Configuration),t={...e.$$K,properties:{[e.$cL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(i=>i.name),null],enumItemLabels:[...this.c.profiles.map(i=>""),(0,r.localize)(8,null)],description:(0,r.localize)(9,null),scope:h.ConfigurationScope.APPLICATION}}};this.a?o.updateConfigurations({add:[t],remove:[this.a]}):o.registerConfiguration(t),this.a=t}h(){const o=this.f.getValue(e.$cL);this.b=o?this.c.profiles.find(t=>t.name===o):void 0}j(){const o=this.f.getValue(e.$cL);if(!o)return;const t=this.b?this.c.profiles.find(i=>i.id===this.b.id):void 0;o!==t?.name&&this.f.updateValue(e.$cL,t?.name)}};e.$dL=g,e.$dL=g=Je([Ve(0,k.$Ll),Ve(1,T.$_i)],g)}),define(ye[382],Se([1,0,39,15,17,23,259,381,71,5,37]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$fL=e.$eL=void 0,e.$gL=c,e.$hL=m,r=We(r),e.$eL=(0,a.$Fi)("editorResolverService"),e.$fL="workbench.editorAssociations";const E=I.$qo.as($.$vo.Configuration),l={...R.$8K,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,T.localize)(0,null),additionalProperties:{type:"string"}}}};E.registerConfiguration(l);var k;(function(d){d.builtin="builtin",d.option="option",d.exclusive="exclusive",d.default="default"})(k||(e.RegisteredEditorPriority=k={}));var p;(function(d){d[d.ABORT=1]="ABORT",d[d.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function c(d){switch(d){case k.exclusive:return 5;case k.default:return 4;case k.builtin:return 3;case k.option:default:return 1}}function m(d,g){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(g.scheme))return!1;const t=typeof d=="string"&&d.indexOf(P.$ic.sep)>=0?`${g.scheme}:${g.path}`:(0,O.$dh)(g);return r.$yk(typeof d=="string"?d.toLowerCase():d,t.toLowerCase())}}),define(ye[383],Se([1,0,33,15,17,11,23,2,5,297,46,158,170]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=void 0,e.$9M=(0,$.$Fi)("pathService");let p=k=class{constructor(m,d,g,n){this.d=m,this.e=d,this.f=g,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??m})()}hasValidBasename(m,d,g){return typeof d=="string"||typeof d>"u"?this.a.then(n=>this.h(m,n,d)):this.h(m,d,g)}h(m,d,g){return m.scheme===h.Schemas.file||m.scheme===h.Schemas.vscodeRemote?(0,r.$Cg)(g??(0,T.$dh)(m),d===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,d){if(m.remoteAuthority)return h.Schemas.vscodeRemote;const g=(0,a.$6M)(d.getWorkspace());if(g)return g;const n=d.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=d.getWorkspace().configuration;return o?o.scheme:h.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===O.OperatingSystem.Windows?P.$hc:P.$ic)}async fileURI(m){let d="";if(await this.a===O.OperatingSystem.Windows&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const n=m.indexOf("/",2);n===-1?(d=m.substring(2),m="/"):(d=m.substring(2,n),m=m.substring(n)||"/")}return R.URI.from({scheme:h.Schemas.file,authority:d,path:m,query:"",fragment:""})}};e.$0M=p,e.$0M=p=k=Je([Ve(1,l.$Vm),Ve(2,E.$RM),Ve(3,I.$Oi)],p)}),define(ye[384],Se([1,0,261,59,4,60,3,2,45,266,12,72,152,93,46,158,26,21,18,25,36]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3M=e.$2M=e.OnPortForward=e.$WM=e.$VM=e.TunnelSource=e.TunnelCloseReason=e.$TM=e.$SM=void 0,e.$UM=u,e.$XM=D,e.$YM=S,e.$ZM=C,e.$1M=b,r=We(r);const t=10*1e3,i="remote.tunnels.toRestore",s="remote.tunnels.toRestoreExpiration",f=1e3*60*60*24*14;e.$SM="onTunnel",e.$TM=new o.$Wj("forwardedPortsViewEnabled",!1,r.localize(0,null));function u(N){const L=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(L)return{host:L[1]?.substring(0,L[1].length-1)||"localhost",port:Number(L[2])}}var w;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(w||(e.TunnelCloseReason=w={}));var y;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(y||(e.TunnelSource=y={})),e.$VM={source:y.User,description:r.localize(1,null)},e.$WM={source:y.Auto,description:r.localize(2,null)};function D(N,L,j){const z=N.get(C(L,j));if(z)return z;if((0,k.$Gw)(L))for(const F of k.$Fw){const B=C(F,j);if(N.has(B))return N.get(B)}else if((0,k.$Iw)(L))for(const F of k.$Hw){const B=C(F,j);if(N.has(B))return N.get(B)}}function S(N,L,j){const z=D(N,L,j);if(z)return z;const F=(0,k.$Iw)(L)?"localhost":(0,k.$Gw)(L)?"0.0.0.0":void 0;if(F)return D(N,F,j)}function C(N,L){return N+":"+L}var A;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(A||(e.OnPortForward=A={}));function b(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}class v extends T.$Wc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(L){super(),this.r=L,this.j=[],this.n=new P.$me,this.onDidChangeAttributes=this.n.event,this.B(L.onDidChangeConfiguration(j=>{(j.affectsConfiguration(v.c)||j.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(L,j,z){let F=this.w(L,j,z,this.j,0);const B={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;F>=0;){const _=this.j[F];_.key===L?(B.onAutoForward=_.onAutoForward??B.onAutoForward,B.elevateIfNeeded=_.elevateIfNeeded!==void 0?_.elevateIfNeeded:B.elevateIfNeeded,B.label=_.label??B.label,B.requireLocalPort=_.requireLocalPort,B.protocol=_.protocol):(B.onAutoForward=B.onAutoForward??_.onAutoForward,B.elevateIfNeeded=B.elevateIfNeeded!==void 0?B.elevateIfNeeded:_.elevateIfNeeded,B.label=B.label??_.label,B.requireLocalPort=B.requireLocalPort!==void 0?B.requireLocalPort:void 0,B.protocol=B.protocol??_.protocol),F=this.w(L,j,z,this.j,F+1)}return B.onAutoForward!==void 0||B.elevateIfNeeded!==void 0||B.label!==void 0||B.requireLocalPort!==void 0||B.protocol!==void 0?B:this.C()}t(L){return L.start!==void 0&&L.end!==void 0}u(L){return L.host!==void 0&&L.port!==void 0&&(0,g.$fg)(L.host)&&(0,g.$jg)(L.port)}w(L,j,z,F,B){if(B>=F.length)return-1;const _=!(0,k.$Gw)(j)&&!(0,k.$Iw)(j),U=F.slice(B).findIndex(G=>(0,g.$jg)(G.key)?_?!1:G.key===L:this.t(G.key)?_?!1:L>=G.key.start&&L<=G.key.end:this.u(G.key)?L===G.key.port&&j===G.key.host:z?G.key.test(z):!1);return U>=0?U+B:-1}y(){const L=this.r.getValue(v.c);if(!L||!(0,g.$hg)(L))return[];const j=[];for(const F in L){if(F===void 0)continue;const B=L[F];let _;if(Number(F))_=Number(F);else if((0,g.$fg)(F))if(v.g.test(F)){const re=F.match(v.g);_={start:Number(re[1]),end:Number(re[2])}}else if(v.h.test(F)){const re=F.match(v.h);_={host:re[1],port:Number(re[2])}}else{let re;try{re=RegExp(F)}catch{}re&&(_=re)}_&&j.push({key:_,elevateIfNeeded:B.elevateIfNeeded,onAutoForward:B.onAutoForward,label:B.label,requireLocalPort:B.requireLocalPort,protocol:B.protocol})}const z=this.r.getValue(v.f);return z&&(this.m={elevateIfNeeded:z.elevateIfNeeded,label:z.label,onAutoForward:z.onAutoForward,requireLocalPort:z.requireLocalPort,protocol:z.protocol}),this.z(j)}z(L){function j(z,F){return(0,g.$jg)(z.key)?z.key:F.t(z.key)?z.key.start:F.u(z.key)?z.key.port:Number.MAX_VALUE}return L.sort((z,F)=>j(z,this)-j(F,this))}C(){return this.m}static providedActionToAction(L){switch(L){case k.ProvidedOnAutoForward.Notify:return A.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return A.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return A.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return A.OpenPreview;case k.ProvidedOnAutoForward.Silent:return A.Silent;case k.ProvidedOnAutoForward.Ignore:return A.Ignore;default:return}}async addAttributes(L,j,z){const B=this.r.inspect(v.c).userRemoteValue;let _;!B||!(0,g.$hg)(B)?_={}:_=(0,n.$do)(B),_[`${L}`]||(_[`${L}`]={});for(const re in j)_[`${L}`][re]=j[re];return this.r.updateValue(v.c,_,z)}}e.$2M=v;let M=class extends T.$Wc{constructor(L,j,z,F,B,_,re,U,G,Q){super(),this.H=L,this.I=j,this.J=z,this.L=F,this.M=B,this.N=_,this.O=re,this.P=U,this.Q=G,this.R=Q,this.c=new Map,this.g=new P.$me,this.onForwardPort=this.g.event,this.h=new P.$me,this.onClosePort=this.h.event,this.j=new P.$me,this.onPortName=this.j.event,this.n=new P.$me,this.onCandidatesChanged=this.n.event,this.t=new P.$me,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new P.$me,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new v(z),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ee=>{const he=await this.getAttributes(ee.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of ee)if(ne.localAddress){const De=C(ne.tunnelRemoteHost,ne.tunnelRemotePort),$e=S(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set(De,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:he?.get(ne.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,he?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,runningProcess:$e?.detail,hasRunningProcess:!!$e,pid:$e?.pid,privacy:ne.privacy,source:e.$VM}),this.f.set(De,ne)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ee=>{const he=C(ee.tunnelRemoteHost,ee.tunnelRemotePort);if(!S(this.forwarded,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!S(this.detected,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!S(this.c,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&ee.localAddress){const ne=S(this.m??new Map,ee.tunnelRemoteHost,ee.tunnelRemotePort),De=(await this.getAttributes([{port:ee.tunnelRemotePort,host:ee.tunnelRemoteHost}]))?.get(ee.tunnelRemotePort);this.forwarded.set(he,{remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localAddress:ee.localAddress,protocol:De?.protocol??k.TunnelProtocol.Http,localUri:await this.X(ee.localAddress,De),localPort:ee.tunnelLocalPort,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:ee.privacy,source:e.$VM})}await this.cb(),this.f.set(he,ee),this.g.fire(this.forwarded.get(he))})),this.B(this.H.onTunnelClosed(ee=>this.W(ee,w.Other))),this.U()}S(){return this.Q.extensions.find(L=>L.activationEvents?.includes(e.$SM))?(this.R.createKey(e.$TM.key,!0),!0):!1}U(){if(this.S())return;const L=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&L.dispose()}))}async W(L,j){const z=C(L.host,L.port);this.forwarded.has(z)&&(this.forwarded.delete(z),await this.cb(),this.h.fire(L))}X(L,j){if(L.startsWith("http"))return R.URI.parse(L);const z=j?.protocol??"http";return R.URI.parse(`${z}://${L}`)}async Y(L){const j=this.N.getWorkspace(),z=j.configuration?(0,O.$tj)(j.configuration.path):j.folders.length>0?(0,O.$tj)(j.folders[0].uri.path):void 0;if(z===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${L}.${this.L.remoteAuthority}.${z}`}async Z(){return this.Y(i)}async $(){return this.Y(s)}async ab(){const L=this.I.get(i,l.StorageScope.WORKSPACE);if(L)return this.I.remove(i,l.StorageScope.WORKSPACE),await this.cb(),L;const j=await this.Z();if(j)return this.I.get(j,l.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const L=await this.s;if(L&&L!==this.y){const j=JSON.parse(L)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(z=>z.remotePort).join(", ")}`);for(const z of j){const F=S(this.detected,z.remoteHost,z.remotePort);z.source.source!==y.Extension&&!F||z.source.source===y.Extension&&F?await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,elevateIfNeeded:!0,source:z.source}):z.source.source===y.Extension&&!F&&this.D.set(C(z.remoteHost,z.remotePort),z)}}}if(this.z=!0,this.C.fire(),!this.w){const L=await this.Z();this.w=this.B(new T.$Vc),this.w.add(this.I.onDidChangeValue(l.StorageScope.PROFILE,void 0,this.w)(async j=>{j.key===L&&(this.s=Promise.resolve(this.I.get(L,l.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const L=this.I.keys(l.StorageScope.PROFILE,l.StorageTarget.USER).filter(j=>j.startsWith(s));for(const j of L){const z=this.I.getNumber(j,l.StorageScope.PROFILE);if(z&&z<Date.now()){this.s=Promise.resolve(void 0);const F=j.replace(s,i);this.I.remove(j,l.StorageScope.PROFILE),this.I.remove(F,l.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const L=Array.from(this.forwarded.values()),j=L.map(_=>({remoteHost:_.remoteHost,remotePort:_.remotePort,localPort:_.localPort,name:_.name,localAddress:_.localAddress,localUri:_.localUri,protocol:_.protocol,source:_.source}));let z;L.length>0&&(z=JSON.stringify(j));const F=await this.Z(),B=await this.$();!z&&F&&B?(this.I.remove(F,l.StorageScope.PROFILE),this.I.remove(B,l.StorageScope.PROFILE)):z!==this.y&&F&&B&&(this.I.store(F,z,l.StorageScope.PROFILE,l.StorageTarget.USER),this.I.store(B,Date.now()+f,l.StorageScope.PROFILE,l.StorageTarget.USER)),this.y=z}}async eb(L,j,z){if(!L.tunnelLocalPort||!z?.requireLocalPort||L.tunnelLocalPort===j)return;const F=new Date;if(this.db.getTime()+t>F.getTime())return;this.db=F;const B=r.localize(3,null,j,L.tunnelRemotePort,L.tunnelLocalPort);return this.P.info(B)}async forward(L,j){return!this.z&&this.L.remoteAuthority&&await P.Event.toPromise(this.C.event),this.fb(L,j)}async fb(L,j){await this.Q.activateByEvent(e.$SM);const z=S(this.forwarded,L.remote.host,L.remote.port);j=j??(j!==null?(await this.getAttributes([L.remote]))?.get(L.remote.port):void 0);const F=L.local!==void 0?L.local:L.remote.port;let B;if(z)return this.hb(z,L,j);{const _=this.L.remoteAuthority,re=_?{getAddress:async()=>(await this.M.resolveAuthority(_)).authority}:void 0,U=C(L.remote.host,L.remote.port);this.c.set(U,!0),L=this.gb(U,L);const G=await this.H.openTunnel(re,L.remote.host,L.remote.port,void 0,F,L.elevateIfNeeded?L.elevateIfNeeded:j?.elevateIfNeeded,L.privacy,j?.protocol);if(typeof G=="string")B=G;else if(G&&G.localAddress){const Q=S(this.m??new Map,L.remote.host,L.remote.port),ee=G.protocol?G.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:j?.protocol??k.TunnelProtocol.Http,he={remoteHost:G.tunnelRemoteHost,remotePort:G.tunnelRemotePort,localPort:G.tunnelLocalPort,name:j?.label??L.name,closeable:!0,localAddress:G.localAddress,protocol:ee,localUri:await this.X(G.localAddress,j),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:L.source??e.$VM,privacy:G.privacy};return this.forwarded.set(U,he),this.f.set(U,G),this.c.delete(U),await this.cb(),await this.eb(G,F,j),this.g.fire(he),G}this.c.delete(U)}return B}gb(L,j){const z=this.D.has(L)?this.D:this.F.has(L)?this.F:void 0;if(z){const F=z.get(L);z.delete(L),F&&(j.name=F.name??j.name,j.local=("local"in F?F.local:"localPort"in F?F.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(L,j,z){const F=z?.label??j.name;let B;(function(re){re[re.None=0]="None",re[re.Fire=1]="Fire",re[re.Reopen=2]="Reopen"})(B||(B={}));let _=B.None;switch(F!==L.name&&(L.name=F,_=B.Fire),(z?.protocol||L.protocol!==k.TunnelProtocol.Http)&&z?.protocol!==L.protocol&&(j.source=L.source,_=B.Reopen),j.privacy&&L.privacy!==j.privacy&&(_=B.Reopen),_){case B.Fire:{this.g.fire();break}case B.Reopen:await this.close(L.remoteHost,L.remotePort,w.User),await this.fb(j,z)}return S(this.f,j.remote.host,j.remote.port)}async name(L,j,z){const F=S(this.forwarded,L,j),B=C(L,j);if(F){F.name=z,await this.cb(),this.j.fire({host:L,port:j});return}else this.detected.has(B)&&(this.detected.get(B).name=z,this.j.fire({host:L,port:j}))}async close(L,j,z){const F=C(L,j),B=this.forwarded.get(F);return z===w.AutoForwardEnd&&B&&B.source.source===y.Auto&&this.F.set(F,{local:B.localPort,name:B.name,privacy:B.privacy}),await this.H.closeTunnel(L,j),this.W({host:L,port:j},z)}address(L,j){const z=C(L,j);return(this.forwarded.get(z)||this.detected.get(z))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(L){if(L)for(const j of L){const z=S(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),F=typeof j.localAddress=="string"?j.localAddress:C(j.localAddress.host,j.localAddress.port);this.detected.set(C(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:F,protocol:k.TunnelProtocol.Http,localUri:this.X(F),closeable:!1,runningProcess:z?.detail,hasRunningProcess:!!z,pid:z?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:y.Extension,description:r.localize(4,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,F,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(L){this.r=L}async setCandidates(L){let j=L;this.r&&(j=await this.r(L));const z=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(z.values()).map(F=>F.port).join(", ")}`),this.n.fire(z)}ib(L){const j=this.m??new Map,z=new Map;return this.m=z,L.forEach(F=>{const B=C(F.host,F.port);z.set(B,{host:F.host,port:F.port,detail:F.detail,pid:F.pid}),j.has(B)&&j.delete(B);const _=S(this.forwarded,F.host,F.port);_&&(_.runningProcess=F.detail,_.hasRunningProcess=!0,_.pid=F.pid)}),j.forEach((F,B)=>{const _=u(B);if(!_)return;const re=S(this.forwarded,_.host,_.port);re&&(re.runningProcess=void 0,re.hasRunningProcess=!1,re.pid=void 0);const U=S(this.detected,_.host,_.port);U&&(U.runningProcess=void 0,U.hasRunningProcess=!1,U.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const L=Array.from(this.forwarded.values()),j=await this.getAttributes(L.map(z=>({port:z.remotePort,host:z.remoteHost})),!1);if(j)for(const z of L){const F=j.get(z.remotePort);(F?.protocol||z.protocol!==k.TunnelProtocol.Http)&&F?.protocol!==z.protocol&&await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,source:z.source},F),F&&F.label&&F.label!==z.name&&await this.name(z.remoteHost,z.remotePort,F.label)}}async getAttributes(L,j=!0){const z=new Map,F=new Map;L.forEach(G=>{const Q=S(this.m??new Map,k.$Fw[0],G.port)??G;if(Q){z.set(G.port,Q);const ee=b(Q)?Q.pid:void 0;F.has(ee)||F.set(ee,[]),F.get(ee)?.push(G.port)}});const B=new Map;if(L.forEach(G=>{const Q=this.configPortsAttributes.getAttributes(G.port,G.host,z.get(G.port)?.detail);Q&&B.set(G.port,Q)}),this.G.length===0||!j)return B.size>0?B:void 0;const _=await Promise.all(this.G.flatMap(G=>Array.from(F.entries()).map(Q=>{const ee=Q[1],he=z.get(ee[0]);return G.providePortAttributes(ee,he?.pid,he?.detail,d.CancellationToken.None)}))),re=new Map;if(_.forEach(G=>G.forEach(Q=>{Q&&re.set(Q.port,Q)})),!B&&!re)return;const U=new Map;return L.forEach(G=>{const Q=B.get(G.port),ee=re.get(G.port);U.set(G.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??v.providedActionToAction(ee?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),U}addAttributesProvider(L){this.G.push(L)}};e.$3M=M,Je([(0,h.$$h)(1e3)],M.prototype,"cb",null),e.$3M=M=Je([Ve(0,k.$Aw),Ve(1,l.$fq),Ve(2,$.$_i),Ve(3,c.$RM),Ve(4,E.$Ql),Ve(5,p.$Oi),Ve(6,I.$_j),Ve(7,a.$6w),Ve(8,m.$3G),Ve(9,o.$Xj)],M)}),define(ye[100],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$KL=e.$JL=void 0;class r{constructor(T,R){this.line=T,this.character=R}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,R){return new r(0,0)}with(T){return new r(0,0)}}e.$JL=r;class h{constructor(T,R,$,a){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(T,R),this.end=new r($,a)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new h(0,0,0,0)}with(T){return new h(0,0,0,0)}}e.$KL=h;var P;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(ye[38],Se([1,0,19,39,25,33,13,5,17,14,100,9]),function(ce,e,r,h,P,O,T,R,$,a,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$9L=e.$2L=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$YL=e.$XL=e.$WL=e.$VL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.TextSearchCompleteMessageType=void 0,e.$SL=d,e.$TL=g,e.$UL=n,e.$ZL=D,e.$1L=S,e.$3L=b,e.$4L=v,e.$5L=M,e.$6L=N,e.$7L=L,e.$8L=j,e.$0L=F,e.$_L=re,e.$aM=U,h=We(h),P=We(P),O=We(O),$=We($),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$LL="workbench.view.search",e.$ML="workbench.panel.search",e.$NL="workbench.view.search",e.$OL="search-result",e.$PL="search.exclude",e.$QL=2e4;const l="\u27EA ",k=" characters skipped \u27EB",p=(l.length+k.length+5)*2;e.$RL=(0,R.$Fi)("searchService");var c;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text",Q[Q.aiText=2]="aiText"})(c||(e.SearchProviderType=c={}));var m;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text",Q[Q.aiText=3]="aiText"})(m||(e.QueryType=m={}));function d(Q){return!!Q.preview}function g(Q){return!!Q.resource}function n(Q){return!!Q.message}var o;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class t{constructor(ee){this.resource=ee,this.results=[]}}e.$VL=t;class i{constructor(ee,he,ne,De){this.ranges=he,this.webviewIndex=De;const $e=Array.isArray(he)?he:[he];if(ne&&ne.matchLines===1&&s($e)){ee=(0,T.$$f)(ee,ne.matchLines);let K="",W=0,se=0;const ae=Math.floor(ne.charsPerLine/5),te=[];for(const le of $e){const ue=Math.max(le.startColumn-ae,0),X=le.startColumn+ne.charsPerLine;if(ue>se+ae+p){const oe=l+(ue-se)+k;K+=oe+ee.slice(ue,X),W+=ue-(se+oe.length)}else K+=ee.slice(se,X);te.push(new u(0,le.startColumn-W,le.endColumn-W)),se=X}this.preview={text:K,matches:Array.isArray(this.ranges)?te:te[0]}}else{const K=Array.isArray(he)?he[0].startLineNumber:he.startLineNumber;this.preview={text:ee,matches:(0,r.$3b)(he,W=>new f(W.startLineNumber-K,W.startColumn,W.endLineNumber-K,W.endColumn))}}}}e.$WL=i;function s(Q){const ee=Q[0].startLineNumber;for(const he of Q)if(he.startLineNumber!==ee||he.endLineNumber!==ee)return!1;return!0}class f{constructor(ee,he,ne,De){this.startLineNumber=ee,this.startColumn=he,this.endLineNumber=ne,this.endColumn=De}}e.$XL=f;class u extends f{constructor(ee,he,ne){super(ee,he,ee,ne)}}e.$YL=u;var w;(function(Q){Q.List="list",Q.Tree="tree"})(w||(e.ViewMode=w={}));var y;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(y||(e.SearchSortOrder=y={}));function D(Q,ee=!0){const he=Q&&Q.files&&Q.files.exclude,ne=ee&&Q&&Q.search&&Q.search.exclude;if(!he&&!ne)return;if(!he||!ne)return he||ne;let De=Object.create(null);return De=P.$go(De,P.$do(he)),De=P.$go(De,P.$do(ne),!0),De}function S(Q,ee){return Q.excludePattern&&h.$yk(Q.excludePattern,ee)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&h.$yk(Q.includePattern,ee)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(he=>{const ne=he.folder.fsPath;if(O.$Eg(ee,ne)){const De=$.$nc(ne,ee);return!he.includePattern||!!h.$yk(he.includePattern,De)}else return!1}):!1:!0}var C;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(C||(e.SearchErrorCode=C={}));class A extends Error{constructor(ee,he){super(ee),this.code=he}}e.$2L=A;function b(Q){const ee=Q.message;if((0,a.$6)(Q))return new A(ee,C.canceled);try{const he=JSON.parse(ee);return new A(he.message,he.code)}catch{return new A(ee,C.other)}}function v(Q){const ee={message:Q.message,code:Q.code};return new Error(JSON.stringify(ee))}function M(Q){return Q.type==="error"?!0:Q.type==="success"}function N(Q){return Q.type==="success"}function L(Q){return!!Q.path}function j(Q,ee,he=!0){const ne=Q.searchPath?Q.searchPath:Q.relativePath;return he?(0,T.$8f)(ne,ee):h.$yk(ee,ne)}class z{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$9L=z;function F(Q,ee){const he={...Q||{},...ee||{}};return Object.keys(he).filter(ne=>{const De=he[ne];return typeof De=="boolean"&&De})}class B{constructor(ee,he){this.c=null,this.a={...ee.excludePattern||{},...he.excludePattern||{}},this.b=h.$zk(this.a);let ne=ee.includePattern;he.includePattern&&(ne?ne={...ne,...he.includePattern}:ne=he.includePattern),ne&&(this.c=h.$zk(ne))}matchesExcludesSync(ee,he,ne){return!!(this.b&&this.b(ee,he,ne))}includedInQuerySync(ee,he,ne){return!(this.b&&this.b(ee,he,ne)||this.c&&!this.c(ee,he,ne))}includedInQuery(ee,he,ne){const De=this.b(ee,he,ne),$e=()=>this.c?!!this.c(ee,he,ne):!0;return(0,E.$rh)(De)?De.then(K=>K?!1:$e()):$e()}hasSiblingExcludeClauses(){return _(this.a)}}e.$$L=B;function _(Q){for(const ee in Q)if(typeof Q[ee]!="boolean")return!0;return!1}function re(Q){if(!Q)return;let ee;return he=>(ee||(ee=(Q()||Promise.resolve([])).then(ne=>ne?G(ne):{})),ee.then(ne=>!!ne[he]))}function U(Q){if(!Q)return;let ee;return he=>{if(!ee){const ne=Q();ee=ne?G(ne):{}}return!!ee[he]}}function G(Q){const ee={};for(const he of Q)ee[he]=!0;return ee}}),define(ye[48],Se([1,0,19,9,21,4,3,85,15,134,23,13,2,245,28,5,12,280,46,63,30,20,16,10,73,38,6,57]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o,t,i,s,f,u,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=e.$Eoc=void 0;function D(L,j,z){return new I.$8g(F=>b(F,z)).isEqual(L,j)}function S(L,j,z){return D(L.uri,j.uri,z)?0:(0,E.$zf)(L.uri.toString(),j.uri.toString())}function C(L,j,z){return L.index!==j.index?L.index<j.index?-1:1:D(L.uri,j.uri,z)?(0,E.$zf)(L.name,j.name):(0,E.$zf)(L.uri.toString(),j.uri.toString())}function A(L,j,z,F){const B=L.slice(0).sort((re,U)=>z(re,U,F)),_=j.slice(0).sort((re,U)=>z(re,U,F));return(0,r.$Gb)(B,_,(re,U)=>z(re,U,F))}function b(L,j){const z=j.getCapabilities(L.scheme);return!(z&&z&p.FileSystemProviderCapabilities.PathCaseSensitive)}class v extends g.$Yi{static toExtHostWorkspace(j,z,F,B){if(!j)return{workspace:null,added:[],removed:[]};const{id:_,name:re,folders:U,configuration:G,transient:Q,isUntitled:ee}=j,he=[],ne=z;z?U.forEach((W,se)=>{const ae=l.URI.revive(W.uri),te=v.o(F||z,ae,B);te?(te.name=W.name,te.index=W.index,he.push(te)):he.push({uri:ae,name:W.name,index:se})}):he.push(...U.map(({uri:W,name:se,index:ae})=>({uri:l.URI.revive(W),name:se,index:ae}))),he.sort((W,se)=>W.index<se.index?-1:1);const De=new v(_,re,he,!!Q,G?l.URI.revive(G):null,!!ee,W=>b(W,B)),{added:$e,removed:K}=A(ne?ne.workspaceFolders:[],De.workspaceFolders,S,B);return{workspace:De,added:$e,removed:K}}static o(j,z,F){for(let B=0;B<j.folders.length;B++){const _=j.workspaceFolders[B];if(D(_.uri,z,F))return _}}constructor(j,z,F,B,_,re,U){super(j,F.map(G=>new g.$Zi(G)),B,_,U),this.t=z,this.u=re,this.q=[],this.s=R.$Li.forUris(U,()=>!0),F.forEach(G=>{this.q.push(G),this.s.set(G.uri,G)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,z){return z&&this.s.get(j)&&(j=(0,I.$fh)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let M=class{constructor(j,z,F,B,_){this.c=new O.$me,this.onDidChangeWorkspace=this.c.event,this.g=new O.$me,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$oe,this.C=new Map,this.h=B,this.s=F,this.t=_,this.j=new a.$Mm,this.k=new h.$Eh,this.o=j.getProxy(w.$uN.MainThreadWorkspace),this.q=j.getProxy(w.$uN.MainThreadMessageService);const re=z.workspace;this.l=re?new v(re.id,re.name,[],!!re.transient,re.configuration?l.URI.revive(re.configuration):null,!!re.isUntitled,U=>b(U,F)):void 0}$initializeWorkspace(j,z){this.v=z,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:$.Schemas.untitled,path:(0,I.$dh)((0,I.$fh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,z,F,...B){const _=[];if(Array.isArray(B)&&B.forEach(ee=>{l.URI.isUri(ee.uri)&&!_.some(he=>D(he.uri,ee.uri,this.s))&&_.push({uri:ee.uri,name:ee.name||(0,I.$ch)(ee.uri)})}),this.n||[z,F].some(ee=>typeof ee!="number"||ee<0)||F===0&&_.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(z+F>re.length)return!1;const U=re.slice(0);U.splice(z,F,..._.map(ee=>({uri:ee.uri,name:ee.name||(0,I.$ch)(ee.uri),index:void 0})));for(let ee=0;ee<U.length;ee++){const he=U[ee];if(U.some((ne,De)=>De!==ee&&D(he.uri,ne.uri,this.s)))return!1}U.forEach((ee,he)=>ee.index=he);const{added:G,removed:Q}=A(re,U,C,this.s);if(G.length===0&&Q.length===0)return!1;if(this.o){const ee=j.displayName||j.name;this.o.$updateWorkspaceFolders(ee,z,F,_).then(void 0,he=>{this.n=void 0;const ne={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(d.Severity.Error,(0,k.localize)(0,null,ee,he.toString()),ne,[])})}return this.y(U),!0}getWorkspaceFolder(j,z){if(this.x)return this.x.getWorkspaceFolder(j,z)}async getWorkspaceFolder2(j,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,z)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,z){let F,B="";if(typeof j=="string"?(F=l.URI.file(j),B=j):typeof j<"u"&&(F=j,B=j.fsPath),!F)return B;const _=this.getWorkspaceFolder(F,!0);if(!_)return B;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let re=(0,I.$ih)(_.uri,F);return z&&_.name&&(re=`${_.name}/${re}`),re}y(j){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:z,added:F,removed:B}=v.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:B}))}findFiles(j,z,F,B,_=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let re="",U=!0;return z===null?U=!1:z!==void 0&&(typeof z=="string"?re=z:re=z.pattern),this.z(j,void 0,{exclude:re,maxResults:F,useDefaultExcludes:U,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},_)}findFiles2(j,z={},F,B=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${F.value}, entryPoint: findFiles2`),this.z(void 0,j,z,B)}async z(j,z,F,B=P.CancellationToken.None){if(B&&B.isCancellationRequested)return Promise.resolve([]);const _=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,re={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof F.useDefaultSearchExcludes=="boolean"?!F.useDefaultSearchExcludes:!1,maxResults:F.maxResults,excludePattern:_,shouldGlobSearch:typeof F.fuzzy=="boolean"?!F.fuzzy:!0,_reason:"startFileSearch"};let U;if(j){const{includePattern:G,folder:Q}=N(i.GlobPattern.from(j));U=Q,re.includePattern=G}else{const{includePattern:G,folder:Q}=N(i.GlobPattern.from(z));U=Q,re.filePattern=G}return this.o.$startFileSearch(U??null,re,B).then(G=>Array.isArray(G)?G.map(Q=>l.URI.revive(Q)):[])}async findTextInFiles(j,z,F,B,_=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),U=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:G,folder:Q}=N(i.GlobPattern.from(z.include)),ee=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,he={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:U,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:G,excludePattern:ee},ne=!1;if(this.u[re]=De=>{if(ne)return;const $e=l.URI.revive(De.resource);De.results.forEach(K=>{const W=(0,y.$ci)(K);(0,u.$SL)(W)?F({uri:$e,preview:{text:W.preview.text,matches:(0,r.$3b)(W.preview.matches,se=>new s.$yN(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,r.$3b)(W.ranges,se=>new s.$yN(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):F({uri:$e,text:W.text,lineNumber:W.lineNumber})})},_.isCancellationRequested)return{};try{const De=await this.o.$startTextSearch(j,Q??null,he,re,_);return delete this.u[re],De||{}}catch(De){throw delete this.u[re],De}}$handleTextSearchResult(j,z){this.u[z]?.(j)}async save(j){const z=await this.o.$save(j,{saveAs:!1});return l.URI.revive(z)}async saveAs(j){const z=await this.o.$save(j,{saveAs:!0});return l.URI.revive(z)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,z){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,z);const F=this.t.transformOutgoingScheme(j),B=this.A++;return this.o.$registerEditSessionIdentityProvider(B,F),(0,T.$Uc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(j,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const F=await this.resolveWorkspaceFolder(l.URI.revive(j));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const B=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!B),!B)return;const _=await B.provideEditSessionIdentity(F,z);if(this.h.info("Provider returned edit session identifier: ",_),!!_)return _}async $provideEditSessionIdentityMatch(j,z,F,B){this.h.info("Getting edit session identifier for workspaceFolder",j);const _=await this.resolveWorkspaceFolder(l.URI.revive(j));if(!_){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",_);const re=this.w.get(_.uri.scheme);if(this.h.info(`Provider for scheme ${_.uri.scheme} is defined: `,!!re),!re)return;const U=await re.provideEditSessionIdentityMatch?.(z,F,B);if(this.h.info("Provider returned edit session identifier match result: ",U),!!U)return U}getOnWillCreateEditSessionIdentityEvent(j){return(z,F,B)=>{const _=function(U){z.call(F,U)};return _.extension=j,this.B.event(_,void 0,B)}}async $onWillCreateEditSessionIdentity(j,z,F){const B=await this.resolveWorkspaceFolder(l.URI.revive(j));if(B===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:B},z,async(_,re)=>{const U=Date.now();await Promise.resolve(_),Date.now()-U>F&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(j,z){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,z);const F=this.t.transformOutgoingScheme(j),B=this.A++;return this.o.$registerCanonicalUriProvider(B,F),(0,T.$Uc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(B)})}async provideCanonicalUri(j,z,F){const B=this.C.get(j.scheme);if(!B)return;const _=await B.provideCanonicalUri?.(l.URI.revive(j),z,F);if(_)return _}async $provideCanonicalUri(j,z,F){return this.provideCanonicalUri(l.URI.revive(j),{targetScheme:z},F)}};e.$Eoc=M,e.$Eoc=M=Je([Ve(0,t.$1P),Ve(1,o.$eQ),Ve(2,n.$noc),Ve(3,m.$_j),Ve(4,f.$Coc)],M),e.$Foc=(0,c.$Fi)("IExtHostWorkspace");function N(L){let j,z;return L&&(typeof L=="string"?j=L:(j=L.pattern,z=l.URI.revive(L.baseUri))),{includePattern:j,folder:z}}}),define(ye[42],Se([1,0,25,4,48,6,10,45,282,71,18,9,5,20,12,2]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ioc=e.$Hoc=e.$Goc=void 0;function m(f,u){if(u){const w=u.split(".");let y=f;for(let D=0;y&&D<w.length;D++)y=y[w[D]];return y}}function d(f){return f instanceof c.URI}function g(f){return f&&f.uri instanceof c.URI&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function o(f){return f&&f.uri instanceof c.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function t(f){if(d(f))return{resource:f};if(g(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(n(f))return{overrideIdentifier:f.languageId};if(o(f))return{resource:f.uri};if(f===null)return{resource:null}}let i=class{constructor(u,w,y){this.a=u.getProxy(O.$uN.MainThreadConfiguration),this.c=w,this.b=y,this.d=new E.$Eh,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new s(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,w){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(u,w))}};e.$Goc=i,e.$Goc=i=Je([Ve(0,k.$1P),Ve(1,P.$Foc),Ve(2,p.$_j)],i);class s{constructor(u,w,y,D){this.a=new h.$me,this.b=u,this.f=D,this.c=w,this.e=$.$Oo.parse(y,D),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,w){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Oo.parse(u,this.f),this.d=this.k(u.configurationScopes),this.a.fire(this.j(w,y))}getConfiguration(u,w,y){const D=t(w)||{},S=this.g(u?m(this.e.getValue(void 0,D,this.c.workspace),u):this.e.getValue(void 0,D,this.c.workspace));u&&this.h(u,D,y?.identifier);function C(b){if(b==null)return null;if(typeof b=="boolean")return b?R.ConfigurationTarget.USER:R.ConfigurationTarget.WORKSPACE;switch(b){case T.ConfigurationTarget.Global:return R.ConfigurationTarget.USER;case T.ConfigurationTarget.Workspace:return R.ConfigurationTarget.WORKSPACE;case T.ConfigurationTarget.WorkspaceFolder:return R.ConfigurationTarget.WORKSPACE_FOLDER}}const A={has(b){return typeof m(S,b)<"u"},get:(b,v)=>{this.h(u?`${u}.${b}`:b,D,y?.identifier);let M=m(S,b);if(typeof M>"u")M=v;else{let N;const L=(j,z)=>{if((0,I.$hg)(j)){let F;const B=()=>{N=N||(0,r.$do)(S),F=F||m(N,z)};return new Proxy(j,{get:(_,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return B(),()=>F;if(N)return F=F||m(N,z),F[re];const U=_[re];return typeof re=="string"?L(U,`${z}.${re}`):U},set:(_,re,U)=>(B(),F&&(F[re]=U),!0),deleteProperty:(_,re)=>(B(),F&&delete F[re],!0),defineProperty:(_,re,U)=>(B(),F&&Object.defineProperty(F,re,U),!0)})}return Array.isArray(j)?(0,r.$do)(j):j};M=L(M,b)}return M},update:(b,v,M,N)=>{b=u?`${u}.${b}`:b;const L=C(M);return v!==void 0?this.b.$updateConfigurationOption(L,b,v,D,N):this.b.$removeConfigurationOption(L,b,D,N)},inspect:b=>{b=u?`${u}.${b}`:b;const v=this.e.inspect(b,D,this.c.workspace);if(v)return{key:b,defaultValue:(0,r.$do)(v.policy?.value??v.default?.value),globalValue:(0,r.$do)(v.user?.value??v.application?.value),workspaceValue:(0,r.$do)(v.workspace?.value),workspaceFolderValue:(0,r.$do)(v.workspaceFolder?.value),defaultLanguageValue:(0,r.$do)(v.default?.override),globalLanguageValue:(0,r.$do)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,r.$do)(v.workspace?.override),workspaceFolderLanguageValue:(0,r.$do)(v.workspaceFolder?.override),languageIds:(0,r.$do)(v.overrideIdentifiers)}}};return typeof S=="object"&&(0,r.$go)(A,S,!1),Object.freeze(A)}g(u){const w=y=>(0,I.$hg)(y)?new Proxy(y,{get:(D,S)=>w(D[S]),set:(D,S,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(D,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(D,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return w(u)}h(u,w,y){const D=a.$Fo.test(u)?a.ConfigurationScope.RESOURCE:this.d.get(u),S=y?`[${y.value}] `:"";if(a.ConfigurationScope.RESOURCE===D){typeof w?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(a.ConfigurationScope.WINDOW===D){w?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,w){const y=new $.$Qo(u,w,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,S)=>y.affectsConfiguration(D,t(S))})}k(u){return u.reduce((w,y)=>(w.set(y[0],y[1]),w),new Map)}}e.$Hoc=s,e.$Ioc=(0,l.$Fi)("IExtHostConfiguration")}),define(ye[101],Se([1,0,2,9,4,6,10,48,64,42,21,47,20,30,5,15,11,12,96,324,14]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fqc=e.$eqc=e.$dqc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,T=We(T),m=We(m);var t;(function(N){function L(z){if(z!=null)return z}N.from=L;function j(z){if(z!=null)return z}N.to=j})(t||(t={}));var i;(function(N){function L(z){if(z!=null)return z}N.from=L;function j(z){if(z!=null)return z}N.to=j})(i||(i={}));var s;(function(N){function L(z){if(z!=null)return z}N.from=L;function j(z){if(z!=null)return z}N.to=j})(s||(s={}));var f;(function(N){function L(F){if(F){const B=F;return B&&!!B.process}else return!1}N.is=L;function j(F){if(F==null)return;const B={process:F.process,args:F.args};return F.options&&(B.options=s.from(F.options)),B}N.from=j;function z(F){if(F!=null)return new T.$gO(F.process,F.args,F.options)}N.to=z})(f||(f={}));var u;(function(N){function L(z){if(z!=null)return z}N.from=L;function j(z){if(z!=null)return z}N.to=j})(u||(u={}));var w;(function(N){function L(F){if(F){const B=F;return B&&(!!B.commandLine||!!B.command)}else return!1}N.is=L;function j(F){if(F==null)return;const B={};return F.commandLine!==void 0?B.commandLine=F.commandLine:(B.command=F.command,B.args=F.args),F.options&&(B.options=u.from(F.options)),B}N.from=j;function z(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new T.$hO(F.commandLine,F.options):new T.$hO(F.command,F.args?F.args:[],F.options)}N.to=z})(w||(w={}));var y;(function(N){function L(F){if(F){const B=F;return B&&B.customExecution==="customExecution"}else return!1}N.is=L;function j(F){return{customExecution:"customExecution"}}N.from=j;function z(F,B){return B.get(F)}N.to=z})(y||(e.CustomExecutionDTO=y={}));var D;(function(N){function L(j,z){let F;return j.scope!==void 0&&typeof j.scope!="number"?F=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===T.TaskScope.Workspace&&z&&z.workspaceFile?F=z.workspaceFile:F=n.$II),{id:j._id,workspaceFolder:F}}N.from=L})(D||(e.TaskHandleDTO=D={}));var S;(function(N){function L(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}N.from=L})(S||(S={}));var C;(function(N){function L(F,B){if(F==null)return[];const _=[];for(const re of F){const U=j(re,B);U&&_.push(U)}return _}N.fromMany=L;function j(F,B){if(F==null)return;let _;F.execution instanceof T.$gO?_=f.from(F.execution):F.execution instanceof T.$hO?_=w.from(F.execution):F.execution&&F.execution instanceof T.$iO&&(_=y.from(F.execution));const re=t.from(F.definition);let U;return F.scope?typeof F.scope=="number"?U=F.scope:U=F.scope.uri:U=T.TaskScope.Workspace,!re||!U?void 0:{_id:F._id,definition:re,name:F.name,source:{extensionId:B.identifier.value,label:F.source,scope:U},execution:_,isBackground:F.isBackground,group:S.from(F.group),presentationOptions:i.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}N.from=j;async function z(F,B,_){if(F==null)return;let re;f.is(F.execution)?re=f.to(F.execution):w.is(F.execution)?re=w.to(F.execution):y.is(F.execution)&&(re=y.to(F._id,_));const U=t.to(F.definition);let G;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?G=F.source.scope:G=await B.resolveWorkspaceFolder(r.URI.revive(F.source.scope)):G=T.TaskScope.Workspace),!U||!G)return;const Q=new T.$jO(U,G,F.name,F.source.label,re,F.problemMatchers);return F.isBackground!==void 0&&(Q.isBackground=F.isBackground),F.group!==void 0&&(Q.group=T.$fO.from(F.group._id),Q.group&&F.group.isDefault&&(Q.group=new T.$fO(Q.group.id,Q.group.label),F.group.isDefault===!0&&(Q.group.isDefault=F.group.isDefault))),F.presentationOptions&&(Q.presentationOptions=i.to(F.presentationOptions)),F._id&&(Q._id=F._id),F.detail&&(Q.detail=F.detail),Q}N.to=z})(C||(e.TaskDTO=C={}));var A;(function(N){function L(z){return z}N.from=L;function j(z){if(z)return Object.assign(Object.create(null),z)}N.to=j})(A||(A={}));class b{#e;constructor(L,j,z){this._id=j,this.a=z,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let v=class{constructor(L,j,z,F,B,_,re,U){this.q=new P.$me,this.r=new P.$me,this.s=new P.$me,this.u=new P.$me,this.a=L.getProxy(O.$uN.MainThreadTask),this.b=z,this.c=F,this.d=B,this.e=_,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=re,this.g=U,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,j,z){if(!z)return new T.$wN(()=>{});const F=this.x();return this.j.set(F,{type:j,provider:z,extension:L}),this.a.$registerTaskProvider(F,j),new T.$wN(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(L,j){this.a.$registerTaskSystem(L,j)}fetchTasks(L){return this.a.$fetchTasks(A.from(L)).then(async j=>{const z=[];for(const F of j){const B=await C.to(F,this.b,this.m);B&&z.push(B)}return z})}get taskExecutions(){const L=[];return this.k.forEach(j=>L.push(j)),L}terminateTask(L){if(!(L instanceof b))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,j,z){const F=this.m.get(L.id);F&&(this.o.set(L.id,F),this.e.attachPtyToTerminal(j,await F.callback(z))),this.p=L.id,this.q.fire({execution:await this.z(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){if(!this.l.has(L.id))return;const j=await this.z(L);this.l.delete(L.id),this.k.delete(L.id),this.B(L),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const j=await this.z(L.id);this.s.fire({execution:j,processId:L.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(L){const j=await this.z(L.id);this.u.fire({execution:j,exitCode:L.exitCode})}$provideTasks(L,j){const z=this.j.get(L);if(!z)return Promise.reject(new Error("no handler found"));const F=[],B=(0,h.$xh)(()=>z.provider.provideTasks(I.CancellationToken.None)).then(_=>this.v(j,F,z,_));return new Promise(_=>{B.then(re=>{Promise.all(F).then(()=>{_(re)})})})}async $resolveTask(L,j){const z=this.j.get(L);if(!z)return Promise.reject(new Error("no handler found"));if(j.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${z.type}].`);const F=await C.to(j,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const B=await z.provider.resolveTask(F,I.CancellationToken.None);if(!B)return;this.A(B,z);const _=C.from(B,z.extension);if(!_)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return y.is(_.execution)&&await this.y(_,B,!0),await this.w(_)}x(){return this.h++}async y(L,j,z){const F=await this.a.$createTaskId(L);!z&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,j.execution)),this.m.set(F,j.execution)}async z(L,j){if(typeof L=="string"){const B=this.l.get(L);if(!B)throw new o.$db("Unexpected: The specified task is missing an execution");return B}const z=this.l.get(L.id);if(z)return z;let F;return j?F=Promise.resolve(new b(this,L.id,j)):F=C.to(L.task,this.b,this.m).then(B=>{if(!B)throw new o.$db("Unexpected: Task does not exist.");return new b(this,L.id,B)}),this.l.set(L.id,F),F.then(B=>(this.k.set(L.id,B),B))}A(L,j){L._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const z=this.n.values();let F=z.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=z.next()}};e.$dqc=v,e.$dqc=v=Je([Ve(0,l.$1P),Ve(1,k.$eQ),Ve(2,R.$Foc),Ve(3,$.$_P),Ve(4,a.$Ioc),Ve(5,E.$7oc),Ve(6,d.$_j),Ve(7,g.$joc)],v);let M=class extends v{constructor(L,j,z,F,B,_,re,U){super(L,j,z,F,B,_,re,U),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:m.$h(m.Platform.Web)})}async executeTask(L,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const z=C.from(j,L);if(z===void 0)throw new Error("Task is not valid");if(y.is(z.execution))await this.y(z,j,!1);else throw new o.$bb;const F=await this.z(await this.a.$getTaskExecution(z),j);return this.a.$executeTask(z).catch(B=>{throw new Error(B)}),F}v(L,j,z,F){const B=[];if(F)for(const _ of F){if(this.A(_,z),!_.definition||!L[_.definition.type]){const U=_.source?_.source:"No task source";this.f.warn(`The task [${U}, ${_.name}] uses an undefined task type. The task will be ignored in the future.`)}const re=C.from(_,z.extension);re&&y.is(re.execution)?(B.push(re),j.push(this.y(re,_,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:z.extension}}async w(L){if(y.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,j,z){}};e.$eqc=M,e.$eqc=M=Je([Ve(0,l.$1P),Ve(1,k.$eQ),Ve(2,R.$Foc),Ve(3,$.$_P),Ve(4,a.$Ioc),Ve(5,E.$7oc),Ve(6,d.$_j),Ve(7,g.$joc)],M),e.$fqc=(0,p.$Fi)("IExtHostTask")}),define(ye[385],Se([1,0,38,31]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=void 0,e.$gM=P,e.$iM=O;function P(T){return"cellResults"in T}e.$hM="rawCell#";function O(T,R){let $=-1;const a=[];let I=[];return T.forEach(l=>{l.range.startLineNumber!==$&&I.length>0&&(a.push([...I]),I=[]),I.push(l),$=l.range.endLineNumber}),I.length>0&&a.push([...I]),a.map(l=>{const k=[],p=l[0].range.startLineNumber,c=l[l.length-1].range.endLineNumber;for(let m=p;m<=c;m++)k.push(R.getLineContent(m));return new r.$WL(k.join(`
`)+`
`,l.map(m=>new h.$Lt(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(ye[386],Se([1,0,239,22,4,3,29,41,13,18,2,28,119,6,35,16,10,52,358,165,25,15,38,314,385,382]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o,t,i,s,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=void 0,E=We(E),c=We(c),m=We(m);class w{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,S,C,A,b,v,M){this.q=C,this.r=A,this.s=b,this.t=v,this.u=M,this.f=new Map,this.g=new T.$Cc,this.h=new Map,this.j=new P.$me,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$me,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$me,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$me,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new l.$hoc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(k.$uN.MainThreadNotebook),this.c=D.getProxy(k.$uN.MainThreadNotebookDocuments),this.d=D.getProxy(k.$uN.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===R.MarshalledId.NotebookCellActionContext){const L=N.notebookEditor?.notebookUri,j=N.cell.handle,F=this.g.get(L)?.getCell(j);if(F)return F.apiCell}if(N&&N.$mid===R.MarshalledId.NotebookActionContext){const L=N.uri,j=this.g.get(L);if(j)return j.apiNotebook}return N}}),w.C(S)}getEditorById(D){const S=this.h.get(D);if(!S)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(D){for(const[S,C]of this.h)if(C.apiEditor===D)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,S){const C=this.g.get(D);if(!C&&!S)throw new Error(`NO notebook document for '${D}'`);return C}static w(D,S){if(!S)return;const C=S.filenamePattern.map(A=>c.NotebookExclusiveDocumentPattern.from(A)).filter(A=>A!==void 0);if(S.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:S.displayName,filenamePattern:C,priority:S.exclusive?u.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,S,C){const A=w.a++,b=typeof C.onDidChangeCellStatusBarItems=="function"?w.a++:void 0;this.f.set(A,C),this.b.$registerNotebookCellStatusBarItemProvider(A,b,S);let v;return b!==void 0&&(v=C.onDidChangeCellStatusBarItems(M=>this.b.$emitCellStatusBarEvent(b))),new m.$wN(()=>{this.f.delete(A),this.b.$unregisterNotebookCellStatusBarItemProvider(A,b),v?.dispose()})}async createNotebookDocument(D){const S=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&c.NotebookData.from(D.content)});return I.URI.revive(S)}async openNotebookDocument(D){const S=this.g.get(D);if(S)return S.apiNotebook;const C=await this.c.$tryOpenNotebook(D),A=this.g.get(I.URI.revive(C));return(0,a.$qg)(A?.apiNotebook)}async showNotebookDocument(D,S){I.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let C;typeof S=="object"?C={position:c.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(c.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:C={preserveFocus:!1};const A=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,C),b=A&&this.h.get(A)?.apiEditor;if(b)return b;throw A?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,S,C,A){const b=this.f.get(D),v=I.URI.revive(S),M=this.g.get(v);if(!M||!b)return;const N=M.getCellFromIndex(C);if(!N)return;const L=await b.provideCellStatusBarItems(N.apiCell,A);if(!L)return;const j=new O.$Vc,z=this.p.add([j]),B=(Array.isArray(L)?L:[L]).map(_=>c.NotebookStatusBarItem.from(_,this.i,j));return{cacheId:z,items:B}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,S,C,A,b){if((0,$.$df)(S))throw new Error("viewType cannot be empty or just whitespace");const v=this.x++;return this.y.set(v,{viewType:S,serializer:C,options:A}),this.b.$registerNotebookSerializer(v,{id:D.identifier,location:D.extensionLocation},S,c.NotebookDocumentContentOptions.from(A),w.w(D,b)),(0,O.$Uc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(D,S,C){const A=this.y.get(D);if(!A)throw new Error("NO serializer found");const b=await A.serializer.deserializeNotebook(S.buffer,C);return new d.$Tw(c.NotebookData.from(b))}async $notebookToData(D,S,C){const A=this.y.get(D);if(!A)throw new Error("NO serializer found");const b=await A.serializer.serializeNotebook(c.NotebookData.to(S.value),C);return h.$Oe.wrap(b)}async $saveNotebook(D,S,C,A,b){const v=I.URI.revive(S),M=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${C}, ${v.toString()})`),!M)throw new Error("NO serializer found");const N=this.g.get(v);if(!N)throw new Error("Document NOT found");if(N.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new E.$ul((0,r.localize)(0,null,this.A(v)),E.FileOperationResult.FILE_PERMISSION_DENIED);const L={metadata:(0,o.$lo)(N.apiNotebook.metadata,_=>!(M.options?.transientDocumentMetadata??{})[_]),cells:[]};for(const _ of N.apiNotebook.getCells()){const re=new m.$ZO(_.kind,_.document.getText(),_.document.languageId,_.mime,M.options?.transientOutputs?[]:[..._.outputs],_.metadata,_.executionSummary);re.metadata=(0,o.$lo)(_.metadata,U=>!(M.options?.transientCellMetadata??{})[U]),L.cells.push(re)}if(await this.z(v,A),b.isCancellationRequested)throw new Error("canceled");const j=await M.serializer.serializeNotebook(L,b);if(b.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${C} ${v.toString()}`),await this.s.value.writeFile(v,j),this.D(`Finished write versionId: ${C} ${v.toString()}`);const z=this.s.getFileSystemProviderExtUri(v.scheme),F=await this.s.value.stat(v),B={name:z.basename(v),isFile:(F.type&E.FileType.File)!==0,isDirectory:(F.type&E.FileType.Directory)!==0,isSymbolicLink:(F.type&E.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&E.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((F.permissions??0)&E.FilePermission.Locked),etag:E.$Fl({mtime:F.mtime,size:F.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${C}, ${v.toString()})`),B}async $searchInNotebooks(D,S,C,A,b){const v=this.y.get(D)?.serializer;if(!v)return{limitHit:!1,results:[]};const M=new T.$Dc;await(async(F,B,_)=>{await Promise.all(F.map(async re=>await Promise.all(re.filenamePatterns.map(U=>{const G={_reason:_._reason,folderQueries:_.folderQueries,includePattern:_.includePattern,excludePattern:_.excludePattern,maxResults:_.maxResults,type:i.QueryType.File,filePattern:U};return this.t.doInternalFileSearchWithCustomCallback(G,B,Q=>{Q.forEach(ee=>{M.has(ee)||A.some(ne=>re.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(De=>(0,u.$hL)(De,ee)))||M.add(ee)})}).catch(Q=>{if(Q.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Q})}))))})(C,b,S);const L=new T.$Cc;let j=!1;const z=Array.from(M).map(async F=>{const B=[];try{if(b.isCancellationRequested)return;if(S.maxResults&&[...L.values()].reduce((G,Q)=>G+Q.cellResults.length,0)>S.maxResults){j=!0;return}const _=[],re=this.g.get(F);if(re)re.apiNotebook.getCells().forEach(Q=>_.push({input:Q.document.getText(),outputs:Q.outputs.flatMap(ee=>ee.items.map(he=>he.data.toString()))}));else{const G=await this.s.value.readFile(F),Q=h.$Oe.fromString(G.toString()),ee=await v.deserializeNotebook(Q.buffer,b);if(b.isCancellationRequested)return;c.NotebookData.from(ee).cells.forEach(ne=>_.push({input:ne.source,outputs:ne.outputs.flatMap(De=>De.items.map($e=>$e.valueBytes.toString()))}))}if(b.isCancellationRequested)return;_.forEach((G,Q)=>{const ee=S.contentPattern.pattern,he=new s.$wZb(G.input,void 0,G.outputs),ne=he.findInInputs(ee),De=he.findInOutputs(ee),$e=De.flatMap(K=>(0,f.$iM)(K.matches,K.textBuffer)).map((K,W)=>(K.webviewIndex=W,K));if(ne.length>0||De.length>0){const K={index:Q,contentResults:(0,f.$iM)(ne,he.inputTextBuffer),webviewResults:$e};B.push(K)}});const U={resource:F,cellResults:B};L.set(F,U);return}catch{return}});return await Promise.all(z),{limitHit:j,results:[...L.values()]}}async z(D,S){const C=await this.s.value.stat(D);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==E.$El&&typeof C.mtime=="number"&&typeof C.size=="number"&&S.mtime<C.mtime&&S.etag!==E.$Fl({mtime:S.mtime,size:C.size}))throw new E.$ul((0,r.localize)(1,null),E.FileOperationResult.FILE_MODIFIED_SINCE,S)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,S,C){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const A=new n.$Jpc(S,this.d,D,C.visibleRanges.map(c.NotebookRange.to),C.selections.map(c.NotebookRange.to),typeof C.viewColumn=="number"?c.ViewColumn.to(C.viewColumn):void 0);this.h.set(S,A)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const C of D.value.removedDocuments){const A=I.URI.revive(C),b=this.g.get(A);b&&(b.dispose(),this.g.delete(A),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(b.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===A.toString()&&this.h.delete(v.id)}if(D.value.addedDocuments){const C=[];for(const A of D.value.addedDocuments){const b=I.URI.revive(A.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const v=new g.$Ipc(this.c,this.q,this.r,b,A);C.push(...A.cells.map(M=>g.$Hpc.asModelAddData(M))),this.g.get(b)?.dispose(),this.g.set(b,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(v.apiNotebook)}}if(D.value.addedEditors)for(const C of D.value.addedEditors){if(this.h.has(C.id))return;const A=I.URI.revive(C.documentUri),b=this.g.get(A);b&&this.B(b,C.id,C)}const S=[];if(D.value.removedEditors)for(const C of D.value.removedEditors){const A=this.h.get(C);A&&(this.h.delete(C),this.k?.id===A.id&&(this.k=void 0),S.push(A))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(A=>this.h.get(A)).filter(A=>!!A);const C=new Set;this.l.forEach(A=>C.add(A.id));for(const A of this.h.values()){const b=C.has(A.id);A._acceptVisibility(b)}this.l=[...this.h.values()].map(A=>A).filter(A=>A.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const S=p.$mQ.String.with("notebookType","A notebook type"),C=new p.$oQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new p.$mQ("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>h.$Oe.wrap(b))],new p.$nQ("Notebook Data",b=>c.NotebookData.to(b.value))),A=new p.$oQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new p.$mQ("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new d.$Tw(c.NotebookData.from(b)))],new p.$nQ("Bytes",b=>b.buffer));D.registerApiCommand(C),D.registerApiCommand(A)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$Spc=w}),define(ye[387],Se([1,0,17,21,51,39,23,43,38]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=void 0,r=We(r),O=We(O),T=We(T);class a{constructor(l,k,p){this.k=l,this.l=k,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&O.$zk(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&O.$zk(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const k=this.k.folderQueries||[];return new Promise((p,c)=>{const m=d=>{this.f++,l(d)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(d=>{const g=d.toString(),n=r.$pc(g);this.j&&this.j(g,n)||this.v(m,{base:d,basename:n})}),Promise.all(k.map(d=>this.p(d,m))).then(d=>{p({limitHit:this.e,stats:d[0]||void 0})},d=>{c(new Error((0,P.$qj)(d)))})})}async p(l,k){const p=new h.$xe,c=this.q(l),m=this.r(),d=new $.$$L(this.k,l),g=!d.hasSiblingExcludeClauses();let n;try{this.h.add(p),n=R.$ge.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},c,p.token),t=n.elapsed(),i=R.$ge.create();return this.g&&!this.e||(o&&o.forEach(s=>{const f=r.$ic.relative(l.folder.path,s.path);if(g){const u=r.$pc(s.path);this.v(k,{base:l.folder,relativePath:f,basename:u});return}this.s(m,l.folder,f,k)}),this.g&&!this.e)?null:(this.u(m,d,k),{providerTime:t,postProcessTime:i.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(l){const k=(0,$.$0L)(this.k.includePattern,l.includePattern),p=(0,$.$0L)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:p,includes:k,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},k,p,c){if(p===this.a){const d=r.$pc(this.a);this.v(c,{base:k,relativePath:this.a,basename:d})}function m(d){const g=r.$pc(d),n=r.$oc(d);let o=l[n];o||(o=l[n]=[],m(n)),o.push({base:k,relativePath:d,basename:g})}m(p)}u({rootEntries:l,pathToEntries:k},p,c){const m=this,d=this.a;function g(n){const o=(0,$.$aM)(()=>n.map(t=>t.basename));for(let t=0,i=n.length;t<i;t++){const s=n[t],{relativePath:f,basename:u}=s;if(p.matchesExcludesSync(f,u,d!==u?o:void 0))continue;const w=k[f];if(w)g(w);else{if(f===d)continue;m.v(c,s)}if(m.e)break}}g(l)}v(l,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(k))}}class I{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,k,p,c){const m=this.c(l.cacheKey),d=new a(l,k,m&&m.token);let g=0;const n=o=>{g+=o.length,p(o.map(t=>this.d(t)))};return this.e(d,I.a,n,c).then(o=>({limitHit:o.limitHit,stats:o.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:o.stats}:void 0,messages:[]}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new h.$xe),this.b.get(l)}d(l){return l.relativePath?{resource:T.$gh(l.base,l.relativePath)}:{resource:l.base}}e(l,k,p,c){const m=c.onCancellationRequested(()=>{l.cancel()}),d=n=>{n&&(g.push(n),k>0&&g.length>=k&&(p(g),g=[]))};let g=[];return l.search(d).then(n=>(g.length&&p(g),m.dispose(),n),n=>(g.length&&p(g),m.dispose(),Promise.reject(n)))}}e.$Kpc=I}),define(ye[388],Se([1,0,19,79,39,110,29,15,17,23,13,18,2,107,262,45,12,46,157,383,38]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0,e.$_M=S,r=We(r),h=We(h),P=We(P),$=We($),I=We(I),p=We(p);let t=class{constructor(A,b,v,M,N){this.a=A,this.b=b,this.c=v,this.d=M,this.e=N}text(A,b,v={}){A=this.f(A,v);const M=this.a.getValue(),N=b&&b.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(b?.map(d.$1i),v),type:o.QueryType.Text,contentPattern:A,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:M.search.usePCRE2||N||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}f(A,b){const v=this.a.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const M={...A,wordSeparators:v.editor.wordSeparators};return this.j(A,b)&&(M.isCaseSensitive=!0),this.k(A)&&(M.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),M}file(A,b={}){return{...this.h(A,b),type:o.QueryType.File,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey,shouldGlobMatchFilePattern:b.shouldGlobSearch}}g(A,b){return A?(A=Array.isArray(A)?A.map(w):w(A),b?this.parseSearchPaths(A):{pattern:s(...Array.isArray(A)?A:[A])}):{}}h(A=[],b={}){const v=this.g(b.includePattern,b.expandPatterns),M=this.g(b.excludePattern,b.expandPatterns),N=A.length>1,L=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(F=>this.q(F,b,M)):A.map(F=>this.r(F,b,M,N))).filter(F=>!!F),j={_reason:b._reason,folderQueries:L,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:M.pattern,includePattern:v.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const F=r.$Jb(this.c.groups.flatMap(re=>re.editors.map(U=>U.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const B=F.filter(re=>(0,o.$1L)(j,re.fsPath)),_=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(_)),{...j,..._}}const z=b.extraFileResources&&b.extraFileResources.filter(F=>(0,o.$1L)(j,F.fsPath));return j.extraFileResources=z&&z.length?z:void 0,j}i(A){const b=[],v=new T.$Cc,M={};let N=!1;return A.forEach(L=>{if(L.scheme===R.Schemas.walkThrough)return;if((0,a.$kh)(L)){const z=this.b.getWorkspaceFolder(L)?.uri??L.with({path:$.$oc(L.fsPath)});let F=v.get(z);F||(N=!0,F={folder:z,includePattern:{}},b.push(F),v.set(z,F));const B=$.$nc(z.fsPath,L.fsPath);(0,E.$qg)(F.includePattern)[B.replace(/\\/g,"/")]=!0}else L.fsPath&&(N=!0,M[L.fsPath]=!0)}),{folderQueries:b,includePattern:M,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(A,b){if(b.isSmartCase){if(A.isRegExp){if(I.$9f(A.pattern,!0))return!0}else if(I.$9f(A.pattern))return!0}return!!A.isCaseSensitive}k(A){return A.isMultiline||A.isRegExp&&(0,k.$bD)(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const b=_=>$.$kc(_)||/^\.\.?([\/\\]|$)/.test(_),M=(Array.isArray(A)?A:f(A)).map(_=>{const re=this.e.resolvedUserHome;return re?(0,O.$Yw)(_,re.scheme===R.Schemas.file?re.fsPath:re.path):_}),N=h.$K(M,_=>b(_)?"searchPaths":"exprSegments"),L=(N.exprSegments||[]).map(_=>I.$of(_,"/")).map(_=>I.$of(_,"\\")).map(_=>(_[0]==="."&&(_="*"+_),u(_))),j={},z=this.m(N.searchPaths||[]);z&&z.length&&(j.searchPaths=z);const F=L.flat(),B=s(...F);return B&&(j.pattern=B),j}l(A,b){return b.disregardExcludeSettings?void 0:(0,o.$ZL)(A,!b.disregardSearchExcludeSettings)}m(A){if(!A||!A.length)return[];const b=A.flatMap(M=>{let{pathPortion:N,globPortion:L}=i(M);return L&&(L=y(L)),this.n(N).flatMap(z=>this.o(z,L))}),v=new Map;return b.forEach(M=>{const N=M.searchPath.toString(),L=v.get(N);L?M.pattern&&(L.pattern=L.pattern||{},L.pattern[M.pattern]=!0):v.set(N,{searchPath:M.searchPath,pattern:M.pattern?s(M.pattern):void 0})}),Array.from(v.values())}n(A){if($.$kc(A)){const b=this.b.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==R.Schemas.file?[{searchPath:b[0].uri.with({path:A})}]:[{searchPath:l.URI.file($.$jc(A))}]}if(this.b.getWorkbenchState()===d.WorkbenchState.FOLDER){const b=this.b.getWorkspace().folders[0].uri;if(A=w(A),A.startsWith("../")||A===".."){const M=$.$ic.resolve(b.path,A);return[{searchPath:b.with({path:M})}]}const v=y(A);return[{searchPath:b,pattern:v}]}else{if(A==="./"||A===".\\")return[];{const b=A.replace(/^\.[\/\\]/,""),M=this.b.getWorkspace().folders.map(N=>{const L=b.match(new RegExp(`^${I.$if(N.name)}(?:/(.*)|$)`));return L?{match:L,folder:N}:null}).filter(E.$ng);if(M.length)return M.map(N=>{const L=N.match[1];return{searchPath:N.folder.uri,pattern:L&&y(L)}});{const N=A.match(/\.[\/\\](.+)[\/\\]?/),L=N?N[1]:A,j=p.localize(0,null,L);throw new Error(j)}}}}o(A,b){const v=A.pattern&&b?`${A.pattern}/${b}`:A.pattern||b,M=[{searchPath:A.searchPath,pattern:v}];return v&&!v.endsWith("**")&&M.push({searchPath:A.searchPath,pattern:v+"/**"}),M}q(A,b,v){const M=this.r((0,d.$1i)(A.searchPath),b,v,!1);return M?{...M,includePattern:A.pattern}:null}r(A,b,v,M){let N;const L=l.URI.isUri(A)?A:A.uri;if(v.searchPaths){const _=v.searchPaths.filter(re=>(0,a.$_g)(re.searchPath,L))[0];if(_&&!_.pattern)return null;_&&(N=_.pattern)}const j=this.a.getValue({resource:L}),F={...this.l(j,b)||{},...N||{}},B=l.URI.isUri(A)?(0,a.$dh)(A):A.name;return{folder:L,folderName:M?B:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!j.search.followSymlinks}}};e.$$M=t,e.$$M=t=Je([Ve(0,c.$_i),Ve(1,d.$Oi),Ve(2,g.$jE),Ve(3,m.$_j),Ve(4,n.$9M)],t);function i(C){const A=C.match(/[\*\{\}\(\)\[\]\?]/);if(A){const b=A.index,v=C.substr(0,b).match(/[/|\\][^/\\]*$/);if(v){let M=C.substr(0,v.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:C.substr((v.index||0)+1)}}}return{pathPortion:C}}function s(...C){return C.length?C.reduce((A,b)=>(A[b]=!0,A),Object.create(null)):void 0}function f(C){return P.$xk(C,",").map(A=>A.trim()).filter(A=>!!A.length)}function u(C){return[`**/${C}/**`,`**/${C}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function w(C){return C.replace(/\\/g,"/")}function y(C){return w(C).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(C){return C.replace(/([?*[\]])/g,"[$1]")}function S(C,A){C=r.$Ob(C,M=>M.toString());const b=[],v=A.getWorkspace();return C&&C.forEach(M=>{let N;if(A.getWorkbenchState()===d.WorkbenchState.FOLDER)N=(0,a.$ih)(v.folders[0].uri,M),N&&N!=="."&&(N="./"+N);else{const L=A.getWorkspaceFolder(M);if(L){const j=L.name;if(v.folders.filter(F=>F.name===j).length===1){const F=(0,a.$ih)(L.uri,M);F===""?N=`./${L.name}`:N=`./${L.name}/${F}`}else N=M.fsPath}}N&&b.push(D(N))}),b}}),define(ye[389],Se([1,0,23,2,21,14,5,388,38,46,9]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cyb=l,e.$dyb=c,r=We(r),O=We(O);const E=7e3;function l(m,d){const g=d.activationEvents;if(!g)return Promise.resolve(void 0);const n=[],o=[];for(const w of g)if(/^workspaceContains:/.test(w)){const y=w.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||m.forceUsingSearch?o.push(y):n.push(y)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);const{promise:t,resolve:i}=(0,I.$yh)(),s=w=>i({activationEvent:w}),f=Promise.all(n.map(w=>k(m,w,s))).then(()=>{}),u=p(m,d.identifier,o,s);return Promise.all([f,u]).then(()=>{i(void 0)}),t}async function k(m,d,g){for(const n of m.folders)if(await m.exists(r.$gh(h.URI.revive(n),d))){g(`workspaceContains:${d}`);return}}async function p(m,d,g,n){if(g.length===0)return Promise.resolve(void 0);const o=new P.$xe,t=m.checkExists(m.folders,g,o.token),i=setTimeout(async()=>{o.cancel(),m.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${g.join(",")}`)},E);let s=!1;try{s=await t}catch(f){O.$6(f)||O.$3(f)}o.dispose(),clearTimeout(i),s&&n(`workspaceContains:${g.join(",")}`)}function c(m,d,g,n){const o=m.get(T.$Ei),t=m.get($.$RL),s=o.createInstance(R.$$M).file(d.map(f=>(0,a.$1i)(h.URI.revive(f))),{_reason:"checkExists",includePattern:g,exists:!0});return t.fileSearch(s,n).then(f=>!!f.limitHit,f=>O.$6(f)?!1:Promise.reject(f))}}),define(ye[53],Se([1,0,235,17,62,23,9,3,85,2,12,6,42,321,126,48,26,159,14,24,22,299,10,72,5,30,98,20,115,77,47,129,4,389,125,301,15,123,43,11,124]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o,t,i,s,f,u,w,y,D,S,C,A,b,v,M,N,L,j,z,F,B){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.$lpc=e.$kpc=e.$jpc=e.$ipc=e.$hpc=void 0,r=We(r),h=We(h),P=We(P),g=We(g),e.$hpc=(0,f.$Fi)("IHostUtils");let re=_=class extends R.$Wc{constructor(K,W,se,ae,te,le,ue,X,oe,pe,we,Fe,Ue){super(),this.Y=Fe,this.Z=Ue,this.a=this.B(new b.$me),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=W,this.g=se,this.f=ue,this.j=ae,this.m=te,this.s=le,this.t=oe,this.u=pe,this.w=we,this.y=this.g.getProxy(E.$uN.MainThreadWorkspace),this.z=this.g.getProxy(E.$uN.MainThreadTelemetry),this.C=this.g.getProxy(E.$uN.MainThreadExtensionService),this.D=new T.$Eh,this.F=new T.$Eh,this.G=new T.$Eh,this.H=new T.$Eh,this.I=new De(this.f.extensions.activationEvents),this.L=new d.$Kcc(this.I,this.f.extensions.allExtensions);const ke=new n.$rn(this.f.extensions.myExtensions);this.J=new d.$Kcc(this.I,he(this.L,ke)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new p.$3oc(this.g,this.s),this.N=new M.$apc(this.g),this.O=X,this.h=K.createChild(new D.$Di([p.$4oc,this.M],[M.$bpc,this.N])),this.P=this.B(new k.$2oc(this.J,this.L,{onExtensionActivationError:(Ie,Oe,q)=>{this.C.$onExtensionActivationError(Ie,g.$5(Oe),q)},actualActivateExtension:async(Ie,Oe)=>{if(d.$Kcc.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,Oe),new k.$1oc;const q=this.J.getExtensionDescription(Ie);return this.fb(q,Oe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(K){g.$3(K)}}async $(){this.O.onWillDeactivateAll();let K=[];try{K=this.J.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this.eb(te))}catch{}await Promise.all(K)}terminate(K,W=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${K}`),this.s.flush(),this.u.dispose(),this.P.dispose(),g.setUnexpectedErrorHandler(ae=>{this.s.error(ae)}),this.g.dispose();const se=this.$();Promise.race([(0,T.$Gh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(K){return this.G.isOpen()?this.P.isActivated(K):!1}async getExtension(K){const W=await this.C.$getExtension(K);return W&&{...W,identifier:new n.$qn(W.identifier.value),extensionLocation:a.URI.revive(W.extensionLocation)}}ab(K,W){return this.P.activateByEvent(K,W)}bb(K,W){return this.P.activateById(K,W)}activateByIdWithErrors(K,W){return this.bb(K,W).then(()=>{const se=this.P.getActivatedExtension(K);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(K=>this.J)}getExtensionExports(K){if(this.G.isOpen())return this.P.getActivatedExtension(K).exports;try{return this.P.getActivatedExtension(K).exports}catch{return null}}async cb(K){if(K.scheme===L.Schemas.file&&this.c.fsRealpath){const W=K.fsPath;this.R.has(W)||this.R.set(W,this.c.fsRealpath(W));const se=await this.R.get(W);return a.URI.file(se)}return K}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(K=>new ne(K))),this.Q}async db(K){const W=$.$Li.forUris(se=>O.$0g.ignorePathCasing(se));return await Promise.all(K.map(async se=>{if(this.wb(se)){const ae=await this.cb(se.extensionLocation);W.set(ae,se)}})),W}eb(K){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(K))return W;const se=this.P.getActivatedExtension(K);if(!se)return W;try{typeof se.module.deactivate=="function"&&(W=Promise.resolve(se.module.deactivate()).then(void 0,ae=>(this.s.error(ae),Promise.resolve(void 0))))}catch(ae){this.s.error(`An error occurred when deactivating the extension '${K.value}':`),this.s.error(ae)}try{(0,R.$Rc)(se.subscriptions)}catch(ae){this.s.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this.s.error(ae)}return W}async fb(K,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(K.identifier):await this.C.$onWillActivateExtension(K.identifier),this.hb(K,W).then(se=>{const ae=se.activationTimes;return this.C.$onDidActivateExtension(K.identifier,ae.codeLoadingTime,ae.activateCallTime,ae.activateResolvedTime,W),this.gb(K,W,"success",ae),se},se=>{throw this.gb(K,W,"failure"),se})}gb(K,W,se,ae){const te=G(K,W);this.z.$publicLog2("extensionActivationTimes",{...te,...ae||{},outcome:se})}hb(K,W){const se=G(K,W);this.z.$publicLog2("activatePlugin",se);const ae=this.wb(K);if(!ae)return Promise.resolve(new k.$Zoc(k.$Woc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${K.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const te=new k.$Xoc(W.startup);return Promise.all([this.xb(K,(0,O.$gh)(K.extensionLocation,ae),te),this.ib(K)]).then(le=>(P.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),_.jb(this.s,K.identifier,le[0],le[1],te))).then(le=>(P.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),le))}ib(K){const W=this.Z.createLanguageModelAccessInformation(K),se=new t.$6oc(K,this.M),ae=new t.$5oc(K.identifier.value,!1,this.M),te=new N.$cpc(K,this.N),le=K.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ue=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([se.whenReady,ae.whenReady,this.O.whenReady]).then(()=>{const X=this;let oe,pe;const we=(0,m.$6G)(K,"ipc")?this.f.messagePorts?.get(n.$qn.toKey(K.identifier)):void 0;return Object.freeze({globalState:se,workspaceState:ae,secrets:te,subscriptions:[],get languageModelAccessInformation(){return W},get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(Fe){return h.$lc(K.extensionLocation.fsPath,Fe)},get storagePath(){return X.O.workspaceValue(K)?.fsPath},get globalStoragePath(){return X.O.globalValue(K).fsPath},get logPath(){return h.$lc(X.f.logsLocation.fsPath,K.identifier.value)},get logUri(){return a.URI.joinPath(X.f.logsLocation,K.identifier.value)},get storageUri(){return X.O.workspaceValue(K)},get globalStorageUri(){return X.O.globalValue(K)},get extensionMode(){return le},get extension(){return oe===void 0&&(oe=new ee(X,K.identifier,K,ue,!1)),oe},get extensionRuntime(){return(0,m.$7G)(K,"extensionRuntime"),X.extensionRuntime},get environmentVariableCollection(){return X.u.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!pe){if(!we)return;const Fe=b.Event.buffer(b.Event.fromDOMEventEmitter(we,"message",Ue=>Ue.data));we.start(),pe={onDidReceiveMessage:Fe,postMessage:we.postMessage.bind(we)}}return pe}})})}static jb(K,W,se,ae,te){return se=se||{activate:void 0,deactivate:void 0},this.kb(K,W,se,ae,te).then(le=>new k.$Yoc(!1,null,te.build(),se,le,ae.subscriptions))}static kb(K,W,se,ae,te){if(typeof se.activate=="function")try{te.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${W.value}`);const le=typeof global=="object"?global:self,ue=se.activate.apply(le,[ae]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(ue).then(X=>(te.activateResolveStop(),X))}catch(le){return Promise.reject(le)}else return Promise.resolve(se)}lb(K,W){this.bb(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:W}).then(void 0,se=>{this.s.error(se)})}mb(K,W=0){const ae=Date.now();(0,F.$B)(()=>{for(let te=W;te<K.length;te+=1){const le=K[te];for(const ue of le.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-ae>50){this.mb(K,te);break}else this.lb(le,ue)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(K=>{const W=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(W)this.mb(se);else for(const ae of se)if(ae.activationEvents)for(const te of ae.activationEvents)te==="onStartupFinished"&&this.lb(ae,te)})}ob(){const K=this.ab("*",!0).then(void 0,le=>{this.s.error(le)});this.B(this.j.onDidChangeWorkspace(le=>this.pb(le.added)));const W=this.j.workspace?this.j.workspace.folders:[],se=this.pb(W),ae=this.rb(),te=Promise.all([ae,K,se]).then(()=>{});return Promise.race([te,(0,T.$Gh)(1e4)]).then(()=>{this.nb()}),te}pb(K){return K.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.qb(K,W))).then(()=>{})}async qb(K,W){if(this.isActivated(W.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,ae={logService:this.s,folders:K.map(le=>le.uri),forceUsingSearch:se||!this.c.fsExists,exists:le=>this.c.fsExists(le.fsPath),checkExists:(le,ue,X)=>this.y.$checkExists(le,ue,X)},te=await(0,v.$cyb)(ae,W);if(te)return this.bb(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:te.activationEvent}).then(void 0,le=>this.s.error(le))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(K){throw console.error(K),K}}async sb(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:W}=this.f.environment;if(!K||!W)throw new Error(r.localize(0,null));const se=await this.xb(null,W,new k.$Xoc(!1));if(!se||typeof se.run!="function")throw new Error(r.localize(1,null,W.toString()));return new Promise((ae,te)=>{const le=(oe,pe)=>{oe?(F.$t&&this.s.error("Test runner called back with error",oe),te(oe)):(F.$t&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),ae(typeof pe=="number"&&pe>0?1:0))},ue=(0,O.$7g)(W),X=se.run(ue,le);X&&X.then&&X.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),ae(0)}).catch(oe=>{F.$t&&this.s.error("Test runner finished with error",oe),te(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,T.$Gh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,W){return this.S[K]=W,(0,R.$Uc)(()=>{delete this.S[K]})}async getRemoteExecServer(K){const{resolver:W}=await this.ub(K);return W?.resolveExecServer?.(K,{resolveAttempt:0})}async ub(K){const W=K.indexOf("+");if(W===-1)throw new i.$CN("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=K.substr(0,W);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority(K,W){const se=z.$ge.create(!1),ae=()=>`[resolveAuthority(${(0,s.$Ul)(K)},${W})][${se.elapsed()}ms] `,te=V=>this.s.info(`${ae()}${V}`),le=V=>this.s.warn(`${ae()}${V}`),ue=(V,J=void 0)=>this.s.error(`${ae()}${V}`,J),X=V=>{if(V instanceof i.$CN)return{type:"error",error:{code:V._code,message:V._message,detail:V._detail}};throw V},oe=async V=>{te(`activating resolver for ${V}...`);const{resolver:J,authorityPrefix:x}=await this.ub(V);if(!J)throw ue(`no resolver for ${x}`),new i.$CN(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:x,remoteAuthority:V}},pe=K.split(/@|%40/g).reverse();te(`activating remote resolvers ${pe.join(" -> ")}`);let we;try{we=await Promise.all(pe.map(oe)).catch(async V=>{if(!(V instanceof i.$CN)||V._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw V;return le(`resolving nested authorities failed: ${V.message}`),[await oe(K)]})}catch(V){return X(V)}const Fe=new T.$Qh;Fe.cancelAndSet(()=>te("waiting..."),1e3);let Ue,ke;for(const[V,{authorityPrefix:J,resolver:x,remoteAuthority:fe}]of we.entries())try{if(V===we.length-1)te("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${J}`),Ue=await x.resolve(fe,{resolveAttempt:W,execServer:ke}),P.mark(`code/extHost/didResolveAuthorityOK/${J}`),te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,i.$BN.isManagedResolvedAuthority(Ue)?Ue:void 0));else{if(te(`invoking resolveExecServer() for ${fe}`),P.mark(`code/extHost/willResolveExecServer/${J}`),ke=await x.resolveExecServer?.(fe,{resolveAttempt:W,execServer:ke}),!ke)throw new i.$CN(`Exec server was not available for ${fe}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(be){return P.mark(`code/extHost/didResolveAuthorityError/${J}`),ue("returned an error",be),Fe.dispose(),X(be)}Fe.dispose();const Ie={environmentTunnels:Ue.environmentTunnels,features:Ue.tunnelFeatures?{elevation:Ue.tunnelFeatures.elevation,privacyOptions:Ue.tunnelFeatures.privacyOptions,protocol:Ue.tunnelFeatures.protocol===void 0?!0:Ue.tunnelFeatures.protocol}:void 0},Oe={extensionHostEnv:Ue.extensionHostEnv,isTrusted:Ue.isTrusted,authenticationSession:Ue.authenticationSessionForInitializingExtensions?{id:Ue.authenticationSessionForInitializingExtensions.id,providerId:Ue.authenticationSessionForInitializingExtensions.providerId}:void 0};te(`returned ${i.$BN.isManagedResolvedAuthority(Ue)?"managed authority":`${Ue.host}:${Ue.port}`}`);let q;if(i.$BN.isManagedResolvedAuthority(Ue)){const V=W;this.Y.setFactory(V,Ue.makeConnection),q={authority:K,connectTo:new s.$Rl(V),connectionToken:Ue.connectionToken}}else q={authority:K,connectTo:new s.$Sl(Ue.host,Ue.port),connectionToken:Ue.connectionToken};return{type:"ok",value:{authority:q,options:Oe,tunnelInformation:Ie}}}async $getCanonicalURI(K,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Ul)(K)})`);const{resolver:se}=await this.ub(K);if(!se)return null;const ae=a.URI.revive(W);if(typeof se.getCanonicalURI>"u")return ae;const te=await(0,T.$xh)(()=>se.getCanonicalURI(ae));return te||ae}async $startExtensionHost(K){K.toAdd.forEach(le=>le.extensionLocation=a.URI.revive(le.extensionLocation));const{globalRegistry:W,myExtensions:se}=U(this.I,this.L,this.J,K),ae=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(ae),this.L.set(W.getAllExtensionDescriptions()),this.J.set(se),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.tb()}$activateByEvent(K,W){return W===m.ActivationKind.Immediate?this.D.wait().then(se=>this.ab(K,!1)):this.G.wait().then(se=>this.ab(K,!1))}async $activate(K,W){return await this.G.wait(),this.J.getExtensionDescription(K)?(await this.bb(K,W),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(le=>le.extensionLocation=a.URI.revive(le.extensionLocation));const{globalRegistry:W,myExtensions:se}=U(this.I,this.L,this.J,K),ae=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(ae),this.L.set(W.getAllExtensionDescriptions()),this.J.set(se),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const W=o.$Oe.alloc(K),se=Math.random()%256;for(let ae=0;ae<K;ae++)W.writeUInt8(se,ae);return W}async $updateRemoteConnectionData(K){this.X=K,this.a.fire()}};e.$ipc=re,e.$ipc=re=_=Je([Ve(0,f.$Ei),Ve(1,e.$hpc),Ve(2,y.$1P),Ve(3,c.$Foc),Ve(4,l.$Ioc),Ve(5,I.$_j),Ve(6,u.$eQ),Ve(7,w.$Loc),Ve(8,S.$XFb),Ve(9,C.$7oc),Ve(10,j.$epc),Ve(11,B.$fpc),Ve(12,A.$$oc)],re);function U($e,K,W,se){$e.addActivationEvents(se.addActivationEvents);const ae=new d.$Kcc($e,K.getAllExtensionDescriptions());ae.deltaExtensions(se.toAdd,se.toRemove);const te=new n.$rn(W.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of se.myToRemove)te.delete(ue);for(const ue of se.myToAdd)te.add(ue);const le=he(ae,te);return{globalRegistry:ae,myExtensions:le}}function G($e,K){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}function Q($e){return $e.getAllExtensionDescriptions().map(K=>K.identifier.value).join(",")}e.$jpc=(0,f.$Fi)("IExtHostExtensionService");class ee{#e;#t;#i;constructor(K,W,se,ae,te){this.#e=K,this.#t=W,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=h.$jc((0,O.$7g)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=ae,this.isFromDifferentExtensionHost=te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$kpc=ee;function he($e,K){return $e.getAllExtensionDescriptions().filter(W=>K.has(W.identifier))}class ne{constructor(K){this.a=K}setSearchTree(K){this.a=K}findSubstr(K){return this.a.findSubstr(K)}forEach(K){return this.a.forEach(K)}}e.$lpc=ne;class De{constructor(K){this.a=new n.$sn,this.addActivationEvents(K)}readActivationEvents(K){return this.a.get(K.identifier)??[]}addActivationEvents(K){for(const W of Object.keys(K))this.a.set(W,K[W])}}}),define(ye[390],Se([1,0,62,2,6,42,26,24,20,30,5,53,12,13]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=void 0,r=We(r);let c=class{constructor(o,t,i,s,f,u,w){this.c=o,this.d=t,this.e=i,this.f=s,this.g=f,this.h=u,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),r.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new d(this.c,t,this.d,o,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(g,t,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const t of o.nodeModuleName)this.a.set(t,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(t=>o.alternativeModuleName(t))}};e.$wqc=c,e.$wqc=c=Je([Ve(2,I.$Ei),Ve(3,O.$Ioc),Ve(4,E.$jpc),Ve(5,a.$eQ),Ve(6,l.$_j)],c);let m=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&p.a.size){const t=(0,k.$if)(this.c(o.environment.appRoot.fsPath)),i="[a-z0-9_.-]",s=`@${i}+\\/${i}+|${i}+`,f="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${f}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const t=this.b.exec(this.c(o));if(!t)return;const[,i,s,f]=t,u=p.a.get(s);if(u!==void 0)return console.warn(`${s} as been renamed to ${u}, please update your imports`),i+u+f}c(o){return o.replace(/\\/g,"/")}};m=p=Je([Ve(0,a.$eQ)],m);class d{constructor(o,t,i,s,f){this.c=o,this.d=t,this.e=i,this.f=s,this.g=f,this.nodeModuleName="vscode",this.a=new R.$sn}load(o,t){const i=this.d.findSubstr(t);if(i){let s=this.a.get(i.identifier);return s||(s=this.c(i,this.e,this.f),this.a.set(i.identifier,s)),s}if(!this.b){let s="";this.d.forEach((f,u)=>s+=`	${u} -> ${f.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${s}`),this.b=this.c(T.$1G,this.e,this.f)}return this.b}}let g=class{constructor(o,t,i){this.e=o,this.f=t,this.nodeModuleName=["open","opn"],this.d=i.getProxy(P.$uN.MainThreadTelemetry);const s=i.getProxy(P.$uN.MainThreadWindow);this.c=(f,u)=>{const w=h.URI.parse(f);return u?this.g(f,u):w.scheme==="http"||w.scheme==="https"?s.$openUri(w,f,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?s.$openUri(w,f,{}):this.g(f,u)}}load(o,t,i){const s=this.e.findSubstr(t);return s&&(this.a=s.identifier.value,this.h()),this.b=i(o),this.c}g(o,t){return this.i(),this.b(o,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};g=Je([Ve(2,$.$1P)],g)}),define(ye[65],Se([1,0,49,3,17,56,5,64,78,53,10,48,318,42]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$npc=e.$mpc=void 0,P=We(P),O=We(O),e.$mpc=(0,T.$Fi)("IExtHostVariableResolverProvider");class p extends l.$5Q{constructor(d,g,n,o,t,i,s){function f(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const w=o.tabGroups.all.find(y=>y.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof I.$iP||w.input instanceof I.$nP)return w.input.modified;if(w.input instanceof I.$hP||w.input instanceof I.$mP||w.input instanceof I.$kP)return w.input.uri}}}super({getFolderUri:u=>{const w=i.folders.filter(y=>y.name===u);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(u,w)=>t.getConfiguration(void 0,u).get(w),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=f();if(u)return P.$jc(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const u=f();if(u){const w=g.getWorkspaceFolder(u);if(w)return P.$jc(w.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>d.getExtension(u)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(O.env))}}let c=class extends h.$Wc{constructor(d,g,n,o,t){super(),this.b=d,this.c=g,this.g=n,this.h=o,this.j=t,this.a=new r.$X(async()=>{const i=await this.h.getConfigProvider(),f={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{f.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,i,f,this.m())})}getResolver(){return this.a.value}m(){}};e.$npc=c,e.$npc=c=Je([Ve(0,a.$jpc),Ve(1,E.$Foc),Ve(2,R.$_P),Ve(3,k.$Ioc),Ve(4,$.$Uoc)],c)}),define(ye[102],Se([1,0,9,4,2,3,24,5,6,78,53,20,10,48,154,120,309,42,65,50,35,16,19,99]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xpc=e.$wpc=e.$vpc=e.$upc=e.$tpc=void 0,t=We(t),e.$tpc=(0,R.$Fi)("IExtHostDebugService");let f=class extends O.$Wc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(A,b,v,M,N,L,j,z){super(),this.Y=b,this.Z=v,this.$=M,this.ab=N,this.bb=L,this.cb=j,this.db=z,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new h.$me),this.z=this.B(new h.$me),this.C=this.B(new h.$me),this.F=this.B(new h.$me),this.u=A.getProxy($.$uN.MainThreadDebugService),this.I=this.B(new h.$me),this.L=this.B(new h.$me),this.G=new w(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(F=>{this.B(F.onDidChange(B=>{this.fb(F)})),this.fb(F)})}async $getVisualizerTreeItem(A,b){const v=this.gb(b);if(!v)return;const M=await this.Q.get(A)?.getTreeItem?.(v);return M?this.eb(A,M):void 0}registerDebugVisualizationTree(A,b,v){const M=T.$qn.toKey(A.identifier),N=this.ub(M,b);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${b}' is already registered`);return this.Q.set(N,v),this.u.$registerDebugVisualizerTree(N,!!v.editItem),(0,O.$Uc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(b)})}async $getVisualizerTreeItemChildren(A,b){const v=this.S.get(b)?.item;return v?(await this.Q.get(A)?.getChildren?.(v))?.map(N=>this.eb(A,N))||[]:[]}async $editVisualizerTreeItem(A,b){const v=this.S.get(A);if(!v)return;const M=await this.Q.get(v.provider)?.editItem?.(v.item,b);return this.eb(v.provider,M||v.item)}$disposeVisualizedTree(A){const b=this.S.get(A);if(!b)return;const v=[b.children];for(const M of v)if(M)for(const N of M)v.push(this.S.get(N)?.children),this.S.delete(N)}eb(A,b){let v=this.R.get(b);return v||(v=this.O++,this.R.set(b,v),this.S.set(v,{provider:A,item:b})),t.DebugTreeItem.from(b,v)}asDebugSourceUri(A,b){const v=A;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let M=`debug:${encodeURIComponent(v.path||"")}`,N="?";return b&&(M+=`${N}session=${encodeURIComponent(b.id)}`,N="&"),M+=`${N}ref=${v.sourceReference}`,P.URI.parse(M)}else{if(v.path)return P.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(A){const b=[];for(const v of A.getAllExtensionDescriptions())if(v.contributes){const M=v.contributes.debuggers;if(M&&M.length>0)for(const N of M)(0,m.$YH)(N)&&b.push(N.type)}this.u.$registerDebugTypes(b)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const A=[];return this.H.forEach(b=>A.push(b)),A}async $resolveDebugVisualizer(A,b){const v=this.W.get(A);if(!v)throw new Error(`No debug visualizer found with id '${A}'`);let{v:M,provider:N,extensionId:L}=v;if(M.visualization||(M=await N.resolveDebugVisualization?.(M,b)||M,v.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(L,M.visualization)}async $executeDebugVisualizerCommand(A){const b=this.W.get(A);if(!b)throw new Error(`No debug visualizer found with id '${A}'`);const v=b.v.visualization;v&&"command"in v&&this.cb.executeCommand(v.command,...v.arguments||[])}gb(A){const b=this.w.get(A.sessionId);return b&&{session:b.api,variable:A.variable,containerId:A.containerId,frameId:A.frameId,threadId:A.threadId}}async $provideDebugVisualizers(A,b,v,M){const N=this.gb(v),L=this.ub(A,b),j=this.P.get(L);if(!N||!j)return[];const z=await j.provideDebugVisualization(N,M);return z?z.map(F=>{const B=++this.X;this.W.set(B,{v:F,provider:j,extensionId:A});const _=F.iconPath?this.wb(F.iconPath):void 0;return{id:B,name:F.name,iconClass:_?.iconClass,iconPath:_?.iconPath,visualization:this.vb(A,F.visualization)}}):[]}$disposeDebugVisualizers(A){for(const b of A)this.W.delete(b)}registerDebugVisualizationProvider(A,b,v){if(!A.contributes?.debugVisualizers?.some(L=>L.id===b))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${b})`);const M=T.$qn.toKey(A.identifier),N=this.ub(M,b);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${b}' is already registered`);return this.P.set(N,v),this.u.$registerDebugVisualizer(M,b),(0,O.$Uc)(()=>{this.u.$unregisterDebugVisualizer(M,b),this.P.delete(b)})}addBreakpoints(A){const b=A.filter(N=>{const L=N.id;return this.H.has(L)?!1:(this.H.set(L,N),!0)});this.rb(b,[],[]);const v=[],M=new Map;for(const N of b)if(N instanceof l.$yO){let L=M.get(N.location.uri.toString());L||(L={type:"sourceMulti",uri:N.location.uri,lines:[]},M.set(N.location.uri.toString(),L),v.push(L)),L.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof l.$zO&&v.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(v)}removeBreakpoints(A){const b=A.filter(L=>this.H.delete(L.id));this.rb([],b,[]);const v=b.filter(L=>L instanceof l.$yO).map(L=>L.id),M=b.filter(L=>L instanceof l.$zO).map(L=>L.id),N=b.filter(L=>L instanceof l.$AO).map(L=>L.id);return this.u.$unregisterBreakpoints(v,M,N)}startDebugging(A,b,v){const M=v.testRun&&this.db.getMetadataForRun(v.testRun);return this.u.$startDebugging(A?A.uri:void 0,b,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===l.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(A){return this.u.$stopDebugging(A?A.id:void 0)}registerDebugConfigurationProvider(A,b,v){if(!b)return new l.$wN(()=>{});const M=this.f++;return this.g.push({type:A,handle:M,provider:b}),this.u.$registerDebugConfigurationProvider(A,v,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,M),new l.$wN(()=>{this.g=this.g.filter(N=>N.provider!==b),this.u.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(A,b,v){if(!v)return new l.$wN(()=>{});if(!this.nb(A,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.kb(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this.h++;return this.j.push({type:b,handle:M,factory:v}),this.u.$registerDebugAdapterDescriptorFactory(b,M),new l.$wN(()=>{this.j=this.j.filter(N=>N.factory!==v),this.u.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(A,b){if(!b)return new l.$wN(()=>{});const v=this.m++;return this.n.push({type:A,handle:v,factory:b}),new l.$wN(()=>{this.n=this.n.filter(M=>M.factory!==b)})}async $runInTerminal(A,b){return Promise.resolve(void 0)}async $substituteVariables(A,b){let v;const M=await this.tb(A);return M&&(v={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(v,b)}hb(A,b){if(A.type==="implementation")return new D(A.implementation)}ib(){}async $startDASession(A,b){const v=this,M=await this.sb(b);return this.pb(this.kb(M.type),M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const L=this.jb(N),j=this.hb(L,M);if(!j)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const z=j;return this.M.set(A,z),this.ob(M).then(F=>(F&&this.N.set(A,F),z.onMessage(async B=>{if(B.type==="request"&&B.command==="handshake"){const _=B,re={type:"response",seq:0,command:_.command,request_seq:_.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const U=await this.U.sign(_.arguments.value);re.body={signature:U},z.sendResponse(re)}else throw new Error("no signer")}catch(U){re.success=!1,re.message=U.message,z.sendResponse(re)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(B),B=(0,m.$4H)(B,!0),v.u.$acceptDAMessage(A,B)}),z.onError(B=>{F&&F.onError&&F.onError(B),this.u.$acceptDAError(A,B.name,B.message,B.stack)}),z.onExit(B=>{F&&F.onExit&&F.onExit(B??void 0,void 0),this.u.$acceptDAExit(A,B??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),z.startSession()))})}$sendDAMessage(A,b){b=(0,m.$3H)(b,!1);const v=this.N.get(A);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(b),this.M.get(A)?.sendMessage(b)}$stopDASession(A){const b=this.N.get(A);this.N.delete(A),b&&b.onWillStopSession&&b.onWillStopSession();const v=this.M.get(A);return this.M.delete(A),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(A){const b=[],v=[],M=[];if(A.added)for(const N of A.added){const L=N.id;if(L&&!this.H.has(L)){let j;if(N.type==="function")j=new l.$zO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")j=new l.$AO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const z=P.URI.revive(N.uri);j=new l.$yO(new l.$IN(z,new l.$xN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,l.$wO)(j,L),this.H.set(L,j),b.push(j)}}if(A.removed)for(const N of A.removed){const L=this.H.get(N);L&&(this.H.delete(N),v.push(L))}if(A.changed){for(const N of A.changed)if(N.id){const L=this.H.get(N.id);if(L){if(L instanceof l.$zO&&N.type==="function"){const j=L;j.enabled=N.enabled,j.condition=N.condition,j.hitCondition=N.hitCondition,j.logMessage=N.logMessage,j.functionName=N.functionName}else if(L instanceof l.$yO&&N.type==="source"){const j=L;j.enabled=N.enabled,j.condition=N.condition,j.hitCondition=N.hitCondition,j.logMessage=N.logMessage,j.location=new l.$IN(P.URI.revive(N.uri),new l.$xN(N.line,N.character))}M.push(L)}}}this.rb(b,v,M)}async $acceptStackFrameFocus(A){let b;if(A){const v=await this.sb(A.sessionId);A.kind==="thread"?b=new l.$GO(v.api,A.threadId):b=new l.$FO(v.api,A.threadId,A.frameId)}this.J=b,this.L.fire(this.J)}$provideDebugConfigurations(A,b,v){return(0,r.$xh)(async()=>{const M=this.mb(A);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(b);return M.provideDebugConfigurations(N,v)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(A,b,v,M){return(0,r.$xh)(async()=>{const N=this.mb(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.tb(b);return N.resolveDebugConfiguration(L,v,M)})}$resolveDebugConfigurationWithSubstitutedVariables(A,b,v,M){return(0,r.$xh)(async()=>{const N=this.mb(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.tb(b);return N.resolveDebugConfigurationWithSubstitutedVariables(L,v,M)})}async $provideDebugAdapter(A,b){const v=this.lb(A);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.sb(b);return this.pb(v,M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(A){const b=await this.sb(A);this.y.fire(b.api)}async $acceptDebugSessionTerminated(A){const b=await this.sb(A);b&&(this.z.fire(b.api),this.w.delete(b.id))}async $acceptDebugSessionActiveChanged(A){this.D=A?await this.sb(A):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(A,b){(await this.sb(A))?._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(A,b){const M={session:(await this.sb(A)).api,event:b.event,body:b.body};this.F.fire(M)}jb(A){if(A instanceof l.$BO)return{type:"executable",command:A.command,args:A.args,options:A.options};if(A instanceof l.$CO)return{type:"server",port:A.port,host:A.host};if(A instanceof l.$DO)return{type:"pipeServer",path:A.path};if(A instanceof l.$EO)return{type:"implementation",implementation:A.implementation};throw new Error("convertToDto unexpected type")}kb(A){const b=this.j.filter(v=>v.type===A);if(b.length>0)return b[0].factory}lb(A){const b=this.j.filter(v=>v.handle===A);if(b.length>0)return b[0].factory}mb(A){const b=this.g.filter(v=>v.handle===A);if(b.length>0)return b[0].provider}nb(A,b){if(A.contributes){const v=A.contributes.debuggers;if(v&&v.length>0){for(const M of v)if(M.label&&M.type&&M.type===b)return!0}}return!1}ob(A){const v=A.configuration.type,M=this.n.filter(N=>N.type===v||N.type==="*").map(N=>(0,r.$xh)(()=>N.factory.createDebugAdapterTracker(A.api)).then(L=>L,L=>null));return Promise.race([Promise.all(M).then(N=>{const L=(0,i.$Jb)(N);if(L.length>0)return new y(L)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(A,b){const v=b.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new l.$CO(v));if(A){const N=await this.Z.getExtensionRegistry();return(0,r.$xh)(()=>A.createDebugAdapterDescriptor(b.api,this.qb(b,N))).then(L=>{if(L)return L})}const M=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(b,M))}qb(A,b){}rb(A,b,v){(A.length>0||b.length>0||v.length>0)&&this.I.fire(Object.freeze({added:A,removed:b,changed:v}))}async sb(A){if(A)if(typeof A=="string"){const b=this.w.get(A);if(b)return b}else{let b=this.w.get(A.id);if(!b){const v=await this.tb(A.folderUri),M=A.parent?this.w.get(A.parent):void 0;b=new u(this.u,A.id,A.type,A.name,v,A.configuration,M?.api),this.w.set(b.id,b),this.u.$sessionCached(b.id)}return b}throw new Error("cannot find session")}tb(A){if(A){const b=P.URI.revive(A);return this.Y.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}ub(A,b){return`${A}\0${b}`}vb(A,b){if(b){if("title"in b&&"command"in b)return{type:c.DebugVisualizationType.Command};if("treeId"in b)return{type:c.DebugVisualizationType.Tree,id:`${A}\0${b.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(A){const b=this.xb(A);let v,M;return"id"in b?M=n.ThemeIcon.asClassName(b):v=b,{iconPath:v,iconClass:M}}xb(A){if(A instanceof l.$tO)return{id:A.id};const b=typeof A=="object"&&"dark"in A?A.dark:A,v=typeof A=="object"&&"light"in A?A.light:A;return{dark:typeof b=="string"?P.URI.file(b):b,light:typeof v=="string"?P.URI.file(v):v}}};e.$upc=f,e.$upc=f=Je([Ve(0,E.$1P),Ve(1,k.$Foc),Ve(2,I.$jpc),Ve(3,d.$Ioc),Ve(4,a.$Uoc),Ve(5,g.$mpc),Ve(6,o.$kQ),Ve(7,s.$opc)],f);class u{constructor(A,b,v,M,N,L,j){this.f=A,this.g=b,this.h=v,this.j=M,this.k=N,this.l=L,this.m=j}get api(){const A=this;return this.d??=Object.freeze({id:A.g,type:A.h,get name(){return A.j},set name(b){A.j=b,A.f.$setDebugSessionName(A.g,b)},parentSession:A.m,workspaceFolder:A.k,configuration:A.l,customRequest(b,v){return A.f.$customDebugAdapterRequest(A.g,b,v)},getDebugProtocolBreakpoint(b){return A.f.$getDebugProtocolBreakpoint(A.g,b.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(A){this.j=A}get configuration(){return this.l}}e.$vpc=u;class w{constructor(A){this.value=Object.freeze({append(b){A.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.$wpc=w;class y{constructor(A){this.d=A}onWillStartSession(){this.d.forEach(A=>A.onWillStartSession?A.onWillStartSession():void 0)}onWillReceiveMessage(A){this.d.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(A):void 0)}onDidSendMessage(A){this.d.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(A):void 0)}onWillStopSession(){this.d.forEach(A=>A.onWillStopSession?A.onWillStopSession():void 0)}onError(A){this.d.forEach(b=>b.onError?b.onError(A):void 0)}onExit(A,b){this.d.forEach(v=>v.onExit?v.onExit(A,b):void 0)}}class D extends p.$Itb{constructor(A){super(),this.h=A,A.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(A){this.h.handleMessage(A)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let S=class extends f{constructor(A,b,v,M,N,L,j,z){super(A,b,v,M,N,L,j,z)}};e.$xpc=S,e.$xpc=S=Je([Ve(0,E.$1P),Ve(1,k.$Foc),Ve(2,I.$jpc),Ve(3,d.$Ioc),Ve(4,a.$Uoc),Ve(5,g.$mpc),Ve(6,o.$kQ),Ve(7,s.$opc)],S)}),define(ye[391],Se([1,0,14,62,2,6,339,12,89,115,30,275,20,73,53,95]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=e.$xqc=void 0,r=We(r),h=We(h);class m{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(R.$_j),i=n.get(l.$1P).getProxy(O.$uN.MainThreadErrors);r.setUnexpectedErrorHandler(s=>{o.error(s);const f=r.$5(s);i.$onUnexpectedError(f)})}static async installFullHandler(n){const o=n.get(R.$_j),t=n.get(l.$1P),i=n.get(p.$jpc),s=n.get(c.$iQ),f=t.getProxy(O.$uN.MainThreadExtensionService),u=t.getProxy(O.$uN.MainThreadErrors),w=await i.getExtensionPathIndex(),y=new WeakMap;function D(A,b){if(y.has(A))return y.get(A).stack;let v="",M,N;for(const j of b)v+=`
	at ${j.toString()}`,N=j.getFileName(),!M&&N&&(M=w.findSubstr(P.URI.file(N)));const L=`${A.name||"Error"}: ${A.message||""}${v}`;return y.set(A,{extensionIdentifier:M?.identifier,stack:L}),L}const S=Symbol("prepareStackTrace wrapped");let C=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return C},set(A){if(A===D||!A||A[S]){C=A||D;return}C=function(b,v){return D(b,v),A.call(Error,b,v)},Object.assign(C,{[S]:!0})}}),r.setUnexpectedErrorHandler(A=>{o.error(A);const b=r.$5(A),v=y.get(A);if(!v?.extensionIdentifier){u.$onUnexpectedError(b);return}f.$onExtensionRuntimeError(v.extensionIdentifier,b);const M=s.onExtensionError(v.extensionIdentifier,A);o.trace("forwarded error to extension?",M,v)})}}e.$xqc=m;class d{constructor(n,o,t,i,s){this.a=t,this.b=new T.$Scc(n,null,i),o=d.e(o,this.b);const f=new a.$Di(...(0,$.$Ps)());f.set(I.$eQ,{_serviceBrand:void 0,...o,messagePorts:s}),f.set(l.$1P,new l.$2P(this.b)),f.set(k.$Coc,new k.$Doc(i)),f.set(p.$hpc,t);const u=new E.$tr(f,!0);u.invokeFunction(m.installEarlyHandler),this.d=u.invokeFunction(w=>w.get(R.$_j)),h.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=u.invokeFunction(w=>w.get(p.$jpc)),this.c.initialize(),u.invokeFunction(m.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(O.$uN.MainThreadExtensionService);return P.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(i=>{i.extensionLocation=P.URI.revive(o.transformIncomingURIs(i.extensionLocation))}),n.environment.appRoot=P.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const t=n.environment.extensionDevelopmentLocationURI;return t&&(n.environment.extensionDevelopmentLocationURI=t.map(i=>P.URI.revive(o.transformIncomingURIs(i)))),n.environment.extensionTestsLocationURI=P.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=P.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=P.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=P.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=P.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=P.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$yqc=d}),define(ye[392],Se([1,0,9,11,246,268,149,102,78,53,20,47,10,65,48,310,311,42,35,99]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iqc=void 0,h=We(h),P=We(P);let o=class extends R.$upc{constructor(u,w,y,D,S,C,A,b,v){super(u,w,y,D,C,A,b,v),this.Ab=S,this.yb=new s}hb(u,w){switch(u.type){case"server":return new c.$Dqc(u);case"pipeServer":return new c.$Eqc(u);case"executable":return new c.$Fqc(u,w.type)}return super.hb(u,w)}qb(u,w){const y=c.$Fqc.platformAdapterExecutable(w.getAllExtensionDescriptions(),u.type);if(y)return new l.$BO(y.command,y.args,y.options)}ib(){return new T.$Qgc}async $runInTerminal(u,w){if(u.kind==="integrated"){this.zb||(this.zb=this.B(this.Ab.onDidCloseTerminal(z=>{this.yb.onTerminalClosed(z)})));const y=await this.$.getConfigProvider(),D=this.Ab.getDefaultShell(!0),S=this.Ab.getDefaultShellArgs(!0),C=u.title||P.localize(0,null),A=JSON.stringify({shell:D,shellArgs:S});let b=await this.yb.checkout(A,C),v,M=!1;if(b)v=u.cwd;else{const z={shellPath:D,shellArgs:S,cwd:u.cwd,name:C,iconPath:new l.$tO("debug")};M=!0,b=this.Ab.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.yb.insert(b,A)}b.show(!0);const N=await b.processId;M?await new Promise(z=>setTimeout(z,1e3)):(b.state.isInteractedWith&&(b.sendText(""),await(0,r.$Gh)(200)),y.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?b.sendText("cls"):D.indexOf("bash")>=0?b.sendText("clear"):h.$i?b.sendText("cls"):b.sendText("clear")));const L=(0,m.$Hqc)(D,u.args,!!u.argsCanBeInterpretedByShell,v,u.env);b.sendText(L);const j=this.onDidTerminateDebugSession(z=>{z.id===w&&(this.yb.free(b),j.dispose())});return N}else if(u.kind==="external")return i(u,await this.$.getConfigProvider());return super.$runInTerminal(u,w)}};e.$Iqc=o,e.$Iqc=o=Je([Ve(0,I.$1P),Ve(1,p.$Foc),Ve(2,a.$jpc),Ve(3,d.$Ioc),Ve(4,E.$7oc),Ve(5,$.$Uoc),Ve(6,k.$mpc),Ve(7,g.$kQ),Ve(8,n.$opc)],o);let t;function i(f,u){if(!t)if(h.$i)t=new O.$yfc;else if(h.$j)t=new O.$zfc;else if(h.$k)t=new O.$Afc;else throw new Error("external terminals not supported on this platform");const w=u.getConfiguration("terminal");return t.runInTerminal(f.title,f.cwd,f.args,f.env||{},w.external||{})}class s{constructor(){this.b=new Map}static{this.a=1e3}async checkout(u,w,y=!1){const S=[...this.b.entries()].map(([C,A])=>(0,r.$sh)(async b=>{if(C.name!==w||A.lastUsedAt!==-1&&await(0,m.$Gqc)(await C.processId))return null;const v=Date.now();return A.lastUsedAt+s.a>v||b.isCancellationRequested?null:A.config!==u?(y&&C.dispose(),null):(A.lastUsedAt=v,C)}));return await(0,r.$Kh)(S,C=>!!C)}insert(u,w){this.b.set(u,{lastUsedAt:Date.now(),config:w})}free(u){const w=this.b.get(u);w&&(w.lastUsedAt=-1)}onTerminalClosed(u){this.b.delete(u)}}}),define(ye[393],Se([1,0,17,2,112,48,64,42,46,47,20,30,101,15,12,96,23,68,65]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aqc=void 0,r=We(r),m=We(m);let n=class extends l.$dqc{constructor(t,i,s,f,u,w,y,D,S){super(t,i,s,f,u,w,y,D),this.C=s,this.D=S,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,i){const s=i;if(!i.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const f=l.TaskHandleDTO.from(s,this.C),u=await this.a.$getTaskExecution(f);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const w=await this.z(u,i);return this.a.$executeTask(f).catch(()=>{}),w}else{const f=l.TaskDTO.from(i,t);if(f===void 0)return Promise.reject(new Error("Task is not valid"));l.CustomExecutionDTO.is(f.execution)&&await this.y(f,i,!1);const u=await this.z(await this.a.$getTaskExecution(f),i);return this.a.$executeTask(f).catch(()=>{}),u}}v(t,i,s,f){const u=[];if(f)for(const w of f){this.A(w,s),(!w.definition||!t[w.definition.type])&&this.f.warn(`The task [${w.source}, ${w.name}] uses an undefined task type. The task will be ignored in the future.`);const y=l.TaskDTO.from(w,s.extension);y&&(u.push(y),l.CustomExecutionDTO.is(y.execution)&&i.push(this.y(y,w,!0)))}return{tasks:u,extension:s.extension}}async w(t){return t}async G(t){let i=t&&t.length>0?t[0]:void 0;if(!i){const s=h.URI.file((0,d.homedir)());i=new $.$Zi({uri:s,name:m.$dh(s),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,i){const s=h.URI.revive(t),f={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(s),w=await this.b.getWorkspaceFolders2()??[],y=await this.D.getResolver(),D=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(w);for(const S of i.variables)f.variables[S]=await y.resolveAsync(D,S);if(i.process!==void 0){let S;if(i.process.path!==void 0){S=i.process.path.split(r.$vc);for(let C=0;C<S.length;C++)S[C]=await y.resolveAsync(D,S[C])}f.process=await P.win32.findExecutable(await y.resolveAsync(D,i.process.name),i.process.cwd!==void 0?await y.resolveAsync(D,i.process.cwd):void 0,S)}return f}async $jsonTasksSupported(){return!0}async $findExecutable(t,i,s){return P.win32.findExecutable(t,i,s)}};e.$Aqc=n,e.$Aqc=n=Je([Ve(0,I.$1P),Ve(1,E.$eQ),Ve(2,O.$Foc),Ve(3,T.$_P),Ve(4,R.$Ioc),Ve(5,a.$7oc),Ve(6,p.$_j),Ve(7,c.$joc),Ve(8,g.$mpc)],n)}),define(ye[394],Se([1,0,68,65]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$grc=void 0;class P extends h.$npc{m(){return(0,r.homedir)()}}e.$grc=P}),define(ye[171],Se([1,0,19,9,21,51,15,17,23,2,38]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=e.$Mpc=e.$Lpc=void 0,e.$Npc=c,R=We(R),$=We($);class E{constructor(g,n,o){this.d=g,this.e=n,this.f=o,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(g,n){const o=this.g.folderQueries||[],t=new P.$xe(n);return new Promise((i,s)=>{this.a=new k(g);let f=!1;const u=(w,y)=>{if(!f&&!this.b){const D=this.h(w);c(w)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,f=!0,t.cancel(),w=this.j(w,this.g.maxResults-this.c));const S=this.h(w);this.c+=S,(S>0||!c(w))&&this.a.add(w,y)}};Promise.all(o.map((w,y)=>this.k(w,D=>u(D,y),t.token))).then(w=>{t.dispose(),this.a.flush();const y=w.some(D=>!!D&&!!D.limitHit);i({limitHit:this.b||y,messages:w.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},w=>{t.dispose();const y=(0,O.$qj)(w);s(new Error(y))})})}h(g){return c(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}j(g,n){const o=Array.isArray(g.ranges)?g.ranges:[g.ranges],t=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:o.slice(0,n),preview:{matches:t.slice(0,n),text:g.preview.text},uri:g.uri}}async k(g,n,o){const t=new I.$$L(this.g,g),i=[],s={report:w=>{if(!this.l(w))return;const y=g.folder.scheme===T.Schemas.file?(0,I.$_L)(()=>this.e.readdir($.$fh(w.uri))):void 0,D=$.$ih(g.folder,w.uri);if(D){const S=t.includedInQuery(D,R.$pc(D),y);(0,h.$rh)(S)?i.push(S.then(C=>{C&&n(w)})):S&&n(w)}}},f=this.n(g);let u;return this.d.query.type===I.QueryType.aiText?u=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,f,s,o):u=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),f,s,o),i.length&&await Promise.all(i),u}l(g){if(c(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(g){const n=(0,I.$0L)(this.g.includePattern,g.includePattern),o=(0,I.$0L)(this.g.excludePattern,g.excludePattern),t={folder:a.URI.from(g.folder),excludes:o,includes:n,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.e.toCanonicalName(g.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??I.$QL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$Lpc=E;function l(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class k{constructor(g){this.e=g,this.b=-1,this.d=null,this.a=new m(512,n=>this.g(n))}add(g,n){this.d&&(this.b!==n||!$.$_g(this.c,g.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:g.uri,results:[]}),this.d.results.push(p(g))}f(){const g=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,g)}flush(){this.f(),this.a.flush()}g(g){this.e(g)}}e.$Mpc=k;function p(d){return c(d)?{preview:{matches:(0,r.$3b)(d.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:d.preview.text},ranges:(0,r.$3b)(d.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function c(d){return!!d.preview}class m{static{this.a=4e3}static{this.b=50}constructor(g,n){this.g=g,this.h=n,this.c=0,this.d=[],this.e=0}addItem(g,n){g&&this.j(g,n)}addItems(g,n){g&&this.k(g,n)}j(g,n){this.d.push(g),this.e+=n,this.l()}k(g,n){this.d=this.d.concat(g),this.e+=n,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Opc=m}),define(ye[103],Se([1,0,3,6,5,387,20,73,12,2,171]),function(ce,e,r,h,P,O,T,R,$,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=e.$Ppc=void 0,e.$Rpc=l,e.$Ppc=(0,P.$Fi)("IExtHostSearch");let E=class{constructor(c,m,d){this.n=c,this.o=m,this.q=d,this.c=this.n.getProxy(h.$uN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$Kpc}s(c){return this.o.transformOutgoingScheme(c)}registerTextSearchProvider(c,m){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const d=this.d++;return this.e.set(d,m),this.c.$registerTextSearchProvider(d,this.s(c)),(0,r.$Uc)(()=>{this.g.delete(c),this.e.delete(d),this.c.$unregisterProvider(d)})}registerAITextSearchProvider(c,m){if(this.i.has(c))throw new Error(`an AI text search provider for the scheme '${c}'is already registered`);this.i.add(c);const d=this.d++;return this.h.set(d,m),this.c.$registerAITextSearchProvider(d,this.s(c)),(0,r.$Uc)(()=>{this.i.delete(c),this.h.delete(d),this.c.$unregisterProvider(d)})}registerFileSearchProvider(c,m){if(this.k.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.k.add(c);const d=this.d++;return this.j.set(d,m),this.c.$registerFileSearchProvider(d,this.s(c)),(0,r.$Uc)(()=>{this.k.delete(c),this.j.delete(d),this.c.$unregisterProvider(d)})}$provideFileSearchResults(c,m,d,g){const n=l(d),o=this.j.get(c);if(o)return this.l.fileSearch(n,o,t=>{this.c.$handleFileMatch(c,m,t.map(i=>i.resource))},g);throw new Error("3 unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,m,d){return{messages:[]}}$clearCache(c){return this.l.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,m,d,g){const n=this.e.get(c);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${c}`);const o=l(d);return this.t(o,n).search(i=>this.c.$handleTextMatch(c,m,i),g)}$provideAITextSearchResults(c,m,d,g){const n=this.h.get(c);if(!n||!n.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${c}`);const o=l(d);return this.v(o,n).search(i=>this.c.$handleTextMatch(c,m,i),g)}$enableExtensionHostSearch(){}t(c,m){return new I.$Lpc({query:c,provider:m},{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}v(c,m){return new I.$Lpc({query:c,provider:m},{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"aiTextSearchProvider")}};e.$Qpc=E,e.$Qpc=E=Je([Ve(0,T.$1P),Ve(1,R.$Coc),Ve(2,$.$_j)],E);function l(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(k),extraFileResources:p.extraFileResources&&p.extraFileResources.map(c=>a.URI.revive(c))}}function k(p){return{...p,folder:a.URI.revive(p.folder)}}});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ye[395],Se([1,0,21,14,4,3,15,44,2,114,213,194,55,24,28,12,91,92,296,6,341,368,96,128,345,346,347,326,316,35,348,42,349,102,163,350,328,342,351,352,64,78,329,343,53,353,76,354,63,30,369,330,355,129,357,123,124,331,386,359,300,360,370,361,169,332,362,363,364,20,365,103,125,366,333,367,126,98,101,95,47,167,99,371,344,372,373,77,16,10,334,73,335,97,374,375,162,48,120,94,26,100,356]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o,t,i,s,f,u,w,y,D,S,C,A,b,v,M,N,L,j,z,F,B,_,re,U,G,Q,ee,he,ne,De,$e,K,W,se,ae,te,le,ue,X,oe,pe,we,Fe,Ue,ke,Ie,Oe,q,V,J,x,fe,be,Ne,Ge,Ze,et,rt,ot,nt,ct,mt,ht,at,Pe,ze,He,Le,je,Y,de,Ce,Xe,_e,ut,gt,kt,Nt,Bt,fi,it,At,Kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sqc=Qt,h=We(h),R=zt(R),E=We(E),p=We(p),je=We(je),Y=We(Y);function Qt(pt){const vt=pt.get(De.$eQ),ii=pt.get(ne.$noc),xt=pt.get(ee.$Koc),Gt=pt.get(G.$jpc),Et=pt.get(Nt.$Foc),Ft=pt.get(nt.$iQ),ui=pt.get(A.$Ioc),Ht=pt.get(Ce.$Coc),xe=pt.get(J.$1P),_t=pt.get(et.$4oc),ni=pt.get(rt.$Loc),hi=pt.get(c.$ak),It=pt.get(c.$_j),Mt=pt.get(Le.$XFb),Ot=pt.get(i.$joc),Ut=pt.get(kt.$qqc),ri=pt.get(be.$bpc),ei=pt.get(_.$Uoc),si=pt.get(le.$fpc),Wt=pt.get(s.$toc),Jt=pt.get(se.$$oc);xe.set(n.$vN.ExtHostFileSystemInfo,ii),xe.set(n.$vN.ExtHostLogLevelServiceShape,hi),xe.set(n.$vN.ExtHostWorkspace,Et),xe.set(n.$vN.ExtHostConfiguration,ui),xe.set(n.$vN.ExtHostExtensionService,Gt),xe.set(n.$vN.ExtHostStorage,_t),xe.set(n.$vN.ExtHostTunnelService,Mt),xe.set(n.$vN.ExtHostWindow,Ut),xe.set(n.$vN.ExtHostSecretState,ri),xe.set(n.$vN.ExtHostTelemetry,Ft),xe.set(n.$vN.ExtHostEditorTabs,ei),xe.set(n.$vN.ExtHostManagedSockets,si),xe.set(n.$vN.ExtHostAuthentication,Wt),xe.set(n.$vN.ExtHostChatProvider,Jt);const oi=xe.set(n.$vN.ExtHostDecorations,pt.get(M.$zpc)),Rt=xe.set(n.$vN.ExtHostDocumentsAndEditors,pt.get(B.$_P)),Dt=xe.set(n.$vN.ExtHostCommands,pt.get(S.$kQ)),wt=xe.set(n.$vN.ExtHostTerminalService,pt.get(ct.$7oc)),ti=xe.set(n.$vN.ExtHostTerminalShellIntegration,pt.get(mt.$gqc)),Pt=xe.set(n.$vN.ExtHostDebugService,pt.get(v.$tpc)),di=xe.set(n.$vN.ExtHostSearch,pt.get(fe.$Ppc)),Zt=xe.set(n.$vN.ExtHostTask,pt.get(ot.$fqc)),wi=xe.set(n.$vN.ExtHostOutputService,pt.get(ke.$5pc)),vi=xe.set(n.$vN.ExtHostLocalization,pt.get(te.$epc)),gi=xe.set(n.$vN.ExtHostUrls,new Xe.$nqc(xe)),qt=xe.set(n.$vN.ExtHostDocuments,new F.$qoc(xe,Rt)),ai=xe.set(n.$vN.ExtHostDocumentContentProviders,new j.$Bpc(xe,Rt,It)),Pi=xe.set(n.$vN.ExtHostDocumentSaveParticipant,new z.$Cpc(It,qt,xe.getProxy(n.$uN.MainThreadBulkEdits))),Tt=xe.set(n.$vN.ExtHostNotebook,new X.$Spc(xe,Dt,Rt,qt,xt,di,It)),Si=xe.set(n.$vN.ExtHostNotebookDocuments,new pe.$Ypc(Tt)),Ci=xe.set(n.$vN.ExtHostNotebookEditors,new we.$Zpc(It,Tt)),Di=xe.set(n.$vN.ExtHostNotebookKernels,new Fe.$1pc(xe,vt,Tt,Dt,It)),$i=xe.set(n.$vN.ExtHostNotebookRenderers,new Ue.$3pc(xe,Tt)),Ai=xe.set(n.$vN.ExtHostNotebookDocumentSaveParticipant,new oe.$Xpc(It,Tt,xe.getProxy(n.$uN.MainThreadBulkEdits))),Vt=xe.set(n.$vN.ExtHostEditors,new at.$zoc(xe,Rt)),Ae=xe.set(n.$vN.ExtHostTreeViews,new He.$lqc(xe.getProxy(n.$uN.MainThreadTreeViews),Dt,It)),Me=xe.set(n.$vN.ExtHostEditorInsets,new D.$Aoc(xe.getProxy(n.$uN.MainThreadEditorInsets),Vt,vt.remote)),ve=xe.set(n.$vN.ExtHostDiagnostics,new N.$poc(xe,It,ii,Rt)),ie=xe.set(n.$vN.ExtHostLanguages,new ae.$Vpc(xe,qt,Dt.converter,Ht)),Re=xe.set(n.$vN.ExtHostLanguageFeatures,new W.$roc(xe,Ht,qt,Dt,ve,It,Ot,Ft)),Ke=xe.set(n.$vN.ExtHostFileSystem,new Q.$Fpc(xe,Re)),tt=xe.set(n.$vN.ExtHostFileSystemEventService,new he.$Gpc(xe,It,Rt)),Qe=xe.set(n.$vN.ExtHostQuickOpen,(0,V.$9pc)(xe,Et,Dt)),ft=xe.set(n.$vN.ExtHostSCM,new x.$$pc(xe,Dt,qt,It)),Ct=xe.set(n.$vN.ExtHostQuickDiff,new q.$8pc(xe,Ht)),Xt=xe.set(n.$vN.ExtHostShare,new Ne.$_pc(xe,Ht)),ci=xe.set(n.$vN.ExtHostComments,(0,C.$Boc)(xe,Dt,qt)),jt=xe.set(n.$vN.ExtHostProgress,new Oe.$7pc(xe.getProxy(n.$uN.MainThreadProgress))),li=xe.set(n.$vN.ExtHostLabelService,new K.$Upc(xe)),qi=xe.set(n.$vN.ExtHostTheming,new Pe.$iqc(xe)),pn=xe.set(n.$vN.ExtHostTimeline,new ze.$kqc(xe,Dt)),Fi=xe.set(n.$vN.ExtHostWebviews,new _e.$Poc(xe,vt.remote,Et,It,Ot)),Ti=xe.set(n.$vN.ExtHostWebviewPanels,new ut.$Soc(xe,Fi,Et)),Vi=xe.set(n.$vN.ExtHostCustomEditors,new b.$Toc(xe,qt,ni,Fi,Ti)),xi=xe.set(n.$vN.ExtHostWebviewViews,new gt.$oqc(xe,Fi)),ki=xe.set(n.$vN.ExtHostTesting,pt.get(ht.$opc)),_i=xe.set(n.$vN.ExtHostUriOpeners,new de.$mqc(xe)),en=xe.set(n.$vN.ExtHostProfileContentHandlers,new Ie.$6pc(xe));xe.set(n.$vN.ExtHostInteractive,new $e.$Tpc(xe,Tt,Rt,Dt,It));const Mi=xe.set(n.$vN.ExtHostChatAgents2,new u.$woc(xe,It,Dt,vt.quality)),tn=xe.set(n.$vN.ExtHostChatVariables,new w.$xoc(xe)),Gi=xe.set(n.$vN.ExtHostLanguageModelTools,new Kt.$rqc(xe)),nn=xe.set(n.$vN.ExtHostAiRelatedInformation,new o.$ioc(xe)),Hi=xe.set(n.$vN.ExtHostAiEmbeddingVector,new U.$Epc(xe)),ji=xe.set(n.$vN.ExtHostStatusBar,new Ze.$cqc(xe,Dt.converter)),bn=xe.set(n.$vN.ExtHostSpeech,new Ge.$aqc(xe)),Li=xe.set(n.$vN.ExtHostEmbeddings,new re.$Dpc(xe)),rn=Object.values(n.$vN);xe.assertRegistered(rn);const wn=new f.$voc(xe,Rt),Zi=new y.$yoc(xe),zi=new ue.$Wpc(xe,It),Ki=new L.$Apc(xe);return t.$soc.register(Dt),function(qe,Ei,Bi){function lt(ge){return(Ee,Be,dt)=>{const St=ge(Lt=>{try{Ee.call(Be,Lt)}catch(Ri){h.$4(new Error(`[ExtensionListenerError] Extension '${qe.identifier.value}' FAILED to handle event: ${Ri.toString()}`,{cause:Ri})),Ft.onExtensionError(qe.identifier,Ri)}});return dt?.push(St),St}}const bt=function(){let ge=!qe.isUnderDevelopment;function Ee(){ge||(It.info(`Extension '${qe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Be(dt){if(Array.isArray(dt))dt.forEach(Be);else if(typeof dt=="string")Ee();else{const St=dt;typeof St.scheme>"u"&&Ee(),typeof St.exclusive=="boolean"&&(0,it.$7G)(qe,"documentFiltersExclusive")}return dt}}(),Ui={getSession(ge,Ee,Be){return typeof Be?.forceNewSession=="object"&&Be.forceNewSession.learnMore&&(0,it.$7G)(qe,"authLearnMore"),Be?.account&&(0,it.$7G)(qe,"authGetSessions"),Wt.getSession(qe,ge,Ee,Be)},getSessions(ge,Ee){return(0,it.$7G)(qe,"authGetSessions"),Wt.getSessions(qe,ge,Ee)},getAccounts(ge){return(0,it.$7G)(qe,"authGetSessions"),Wt.getAccounts(ge)},async hasSession(ge,Ee){return(0,it.$7G)(qe,"authSession"),!!await Wt.getSession(qe,ge,Ee,{silent:!0})},get onDidChangeSessions(){return lt(Wt.onDidChangeSessions)},registerAuthenticationProvider(ge,Ee,Be,dt){return Wt.registerAuthenticationProvider(ge,Ee,Be,dt)}},vn={registerCommand(ge,Ee,Be){return Dt.registerCommand(!0,ge,Ee,Be,void 0,qe)},registerTextEditorCommand(ge,Ee,Be){return Dt.registerCommand(!0,ge,(...dt)=>{const St=Vt.getActiveTextEditor();if(!St){It.warn("Cannot execute "+ge+" because there is no active text editor.");return}return St.edit(Lt=>{Ee.apply(Be,[St,Lt,...dt])}).then(Lt=>{Lt||It.warn("Edits from command "+ge+" were not applied.")},Lt=>{It.warn("An error occurred while running command "+ge,Lt)})},void 0,void 0,qe)},registerDiffInformationCommand:(ge,Ee,Be)=>((0,it.$7G)(qe,"diffCommand"),Dt.registerCommand(!0,ge,async(...dt)=>{const St=Rt.activeEditor(!0);if(!St){It.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Lt=await Vt.getDiffInformation(St.id);Ee.apply(Be,[Lt,...dt])},void 0,void 0,qe)),executeCommand(ge,...Ee){return Dt.executeCommand(ge,...Ee)},getCommands(ge=!1){return Dt.getCommands(ge)}},mi={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Zi.value},get shell(){return wt.getDefaultShell(!1)},get onDidChangeShell(){return lt(wt.onDidChangeShell)},get isTelemetryEnabled(){return Ft.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return lt(Ft.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,it.$7G)(qe,"telemetry"),Ft.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,it.$7G)(qe,"telemetry"),lt(Ft.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,nt.$hQ)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,Ee){return nt.$gQ.validateSender(ge),Ft.instantiateLogger(qe,ge,Ee)},openExternal(ge,Ee){return Ut.openUri(ge,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===vt.environment.appUriScheme)return gi.createAppUri(ge);try{return await Ut.asExternalUri(ge,{allowTunneling:!!vt.remote.authority})}catch(Ee){if((0,T.$Og)(ge,T.Schemas.http)||(0,T.$Og)(ge,T.Schemas.https))return ge;throw Ee}},get remoteName(){return(0,m.$hn)(vt.remote.authority)},get remoteAuthority(){return(0,it.$7G)(qe,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return It.getLevel()},get onDidChangeLogLevel(){return lt(It.onDidChangeLogLevel)},get appQuality(){return(0,it.$7G)(qe,"resolvers"),vt.quality},get appCommit(){return(0,it.$7G)(qe,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(mi);const Wi={createTestController(ge,Ee,Be){return ki.createTestController(qe,ge,Ee,Be)},createTestObserver(){return(0,it.$7G)(qe,"testObserver"),ki.createTestObserver()},runTests(ge){return(0,it.$7G)(qe,"testObserver"),ki.runTests(ge)},registerTestFollowupProvider(ge){return(0,it.$7G)(qe,"testObserver"),ki.registerTestFollowupProvider(ge)},get onDidChangeTestResults(){return(0,it.$7G)(qe,"testObserver"),lt(ki.onResultsChanged)},get testResults(){return(0,it.$7G)(qe,"testObserver"),ki.results}},Ni=vt.remote.isRemote?Y.ExtensionKind.Workspace:Y.ExtensionKind.UI,sn={getExtension(ge,Ee){(0,it.$6G)(qe,"extensionsAny")||(Ee=!1);const Be=Ei.mine.getExtensionDescription(ge);if(Be)return new G.$kpc(Gt,qe.identifier,Be,Ni,!1);if(Ee){const dt=Ei.all.getExtensionDescription(ge);if(dt)return new G.$kpc(Gt,qe.identifier,dt,Ni,!0)}},get all(){const ge=[];for(const Ee of Ei.mine.getAllExtensionDescriptions())ge.push(new G.$kpc(Gt,qe.identifier,Ee,Ni,!1));return ge},get allAcrossExtensionHosts(){(0,it.$7G)(qe,"extensionsAny");const ge=new k.$rn(Ei.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),Ee=[];for(const Be of Ei.all.getAllExtensionDescriptions()){const dt=!ge.has(Be.identifier);Ee.push(new G.$kpc(Gt,qe.identifier,Be,Ni,dt))}return Ee},get onDidChange(){return(0,it.$6G)(qe,"extensionsAny")?lt(P.Event.any(Ei.mine.onDidChange,Ei.all.onDidChange)):lt(Ei.mine.onDidChange)}},on={createDiagnosticCollection(ge){return ve.createDiagnosticCollection(qe.identifier,ge)},get onDidChangeDiagnostics(){return lt(ve.onDidChangeDiagnostics)},getDiagnostics:ge=>ve.getDiagnostics(ge),getLanguages(){return ie.getLanguages()},setTextDocumentLanguage(ge,Ee){return ie.changeLanguage(ge.uri,Ee)},match(ge,Ee){const Be=je.LanguageSelector.from(ge);let dt;return(0,I.$tu)(Be)&&(dt=Tt.notebookDocuments.find(St=>St.apiNotebook.getCells().find(Lt=>Lt.document===Ee))?.apiNotebook),(0,I.$su)(Be,Ee.uri,Ee.languageId,!0,dt?.uri,dt?.notebookType)},registerCodeActionsProvider(ge,Ee,Be){return Re.registerCodeActionProvider(qe,bt(ge),Ee,Be)},registerDocumentPasteEditProvider(ge,Ee,Be){return(0,it.$7G)(qe,"documentPaste"),Re.registerDocumentPasteEditProvider(qe,bt(ge),Ee,Be)},registerCodeLensProvider(ge,Ee){return Re.registerCodeLensProvider(qe,bt(ge),Ee)},registerDefinitionProvider(ge,Ee){return Re.registerDefinitionProvider(qe,bt(ge),Ee)},registerDeclarationProvider(ge,Ee){return Re.registerDeclarationProvider(qe,bt(ge),Ee)},registerImplementationProvider(ge,Ee){return Re.registerImplementationProvider(qe,bt(ge),Ee)},registerTypeDefinitionProvider(ge,Ee){return Re.registerTypeDefinitionProvider(qe,bt(ge),Ee)},registerHoverProvider(ge,Ee){return Re.registerHoverProvider(qe,bt(ge),Ee,qe.identifier)},registerEvaluatableExpressionProvider(ge,Ee){return Re.registerEvaluatableExpressionProvider(qe,bt(ge),Ee,qe.identifier)},registerInlineValuesProvider(ge,Ee){return Re.registerInlineValuesProvider(qe,bt(ge),Ee,qe.identifier)},registerDocumentHighlightProvider(ge,Ee){return Re.registerDocumentHighlightProvider(qe,bt(ge),Ee)},registerMultiDocumentHighlightProvider(ge,Ee){return Re.registerMultiDocumentHighlightProvider(qe,bt(ge),Ee)},registerLinkedEditingRangeProvider(ge,Ee){return Re.registerLinkedEditingRangeProvider(qe,bt(ge),Ee)},registerReferenceProvider(ge,Ee){return Re.registerReferenceProvider(qe,bt(ge),Ee)},registerRenameProvider(ge,Ee){return Re.registerRenameProvider(qe,bt(ge),Ee)},registerNewSymbolNamesProvider(ge,Ee){return(0,it.$7G)(qe,"newSymbolNamesProvider"),Re.registerNewSymbolNamesProvider(qe,bt(ge),Ee)},registerDocumentSymbolProvider(ge,Ee,Be){return Re.registerDocumentSymbolProvider(qe,bt(ge),Ee,Be)},registerWorkspaceSymbolProvider(ge){return Re.registerWorkspaceSymbolProvider(qe,ge)},registerDocumentFormattingEditProvider(ge,Ee){return Re.registerDocumentFormattingEditProvider(qe,bt(ge),Ee)},registerDocumentRangeFormattingEditProvider(ge,Ee){return Re.registerDocumentRangeFormattingEditProvider(qe,bt(ge),Ee)},registerOnTypeFormattingEditProvider(ge,Ee,Be,...dt){return Re.registerOnTypeFormattingEditProvider(qe,bt(ge),Ee,[Be].concat(dt))},registerDocumentSemanticTokensProvider(ge,Ee,Be){return Re.registerDocumentSemanticTokensProvider(qe,bt(ge),Ee,Be)},registerDocumentRangeSemanticTokensProvider(ge,Ee,Be){return Re.registerDocumentRangeSemanticTokensProvider(qe,bt(ge),Ee,Be)},registerSignatureHelpProvider(ge,Ee,Be,...dt){return typeof Be=="object"?Re.registerSignatureHelpProvider(qe,bt(ge),Ee,Be):Re.registerSignatureHelpProvider(qe,bt(ge),Ee,typeof Be>"u"?[]:[Be,...dt])},registerCompletionItemProvider(ge,Ee,...Be){return Re.registerCompletionItemProvider(qe,bt(ge),Ee,Be)},registerInlineCompletionItemProvider(ge,Ee,Be){return Ee.handleDidShowCompletionItem&&(0,it.$7G)(qe,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,it.$7G)(qe,"inlineCompletionsAdditions"),Be&&(0,it.$7G)(qe,"inlineCompletionsAdditions"),Re.registerInlineCompletionsProvider(qe,bt(ge),Ee,Be)},registerInlineEditProvider(ge,Ee){return(0,it.$7G)(qe,"inlineEdit"),Re.registerInlineEditProvider(qe,bt(ge),Ee)},registerDocumentLinkProvider(ge,Ee){return Re.registerDocumentLinkProvider(qe,bt(ge),Ee)},registerColorProvider(ge,Ee){return Re.registerColorProvider(qe,bt(ge),Ee)},registerFoldingRangeProvider(ge,Ee){return Re.registerFoldingRangeProvider(qe,bt(ge),Ee)},registerSelectionRangeProvider(ge,Ee){return Re.registerSelectionRangeProvider(qe,ge,Ee)},registerCallHierarchyProvider(ge,Ee){return Re.registerCallHierarchyProvider(qe,ge,Ee)},registerTypeHierarchyProvider(ge,Ee){return Re.registerTypeHierarchyProvider(qe,ge,Ee)},setLanguageConfiguration:(ge,Ee)=>Re.setLanguageConfiguration(qe,ge,Ee),getTokenInformationAtPosition(ge,Ee){return(0,it.$7G)(qe,"tokenInformation"),ie.tokenAtPosition(ge,Ee)},registerInlayHintsProvider(ge,Ee){return Re.registerInlayHintsProvider(qe,ge,Ee)},createLanguageStatusItem(ge,Ee){return ie.createLanguageStatusItem(qe,ge,Ee)},registerDocumentDropEditProvider(ge,Ee,Be){return Re.registerDocumentOnDropEditProvider(qe,ge,Ee,(0,it.$6G)(qe,"documentPaste")?Be:void 0)}},an={get activeTextEditor(){return Vt.getActiveTextEditor()},get visibleTextEditors(){return Vt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(ge,Ee,Be){$.URI.isUri(ge)&&ge.scheme===T.Schemas.vscodeRemote&&!ge.authority&&Ot.report("workspace.showTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority.");const dt=await($.URI.isUri(ge)?Promise.resolve(cn.openTextDocument(ge)):Promise.resolve(ge));return Vt.showTextDocument(dt,Ee,Be)},createTextEditorDecorationType(ge){return Vt.createTextEditorDecorationType(qe,ge)},onDidChangeActiveTextEditor(ge,Ee,Be){return lt(Vt.onDidChangeActiveTextEditor)(ge,Ee,Be)},onDidChangeVisibleTextEditors(ge,Ee,Be){return lt(Vt.onDidChangeVisibleTextEditors)(ge,Ee,Be)},onDidChangeTextEditorSelection(ge,Ee,Be){return lt(Vt.onDidChangeTextEditorSelection)(ge,Ee,Be)},onDidChangeTextEditorOptions(ge,Ee,Be){return lt(Vt.onDidChangeTextEditorOptions)(ge,Ee,Be)},onDidChangeTextEditorVisibleRanges(ge,Ee,Be){return lt(Vt.onDidChangeTextEditorVisibleRanges)(ge,Ee,Be)},onDidChangeTextEditorViewColumn(ge,Ee,Be){return lt(Vt.onDidChangeTextEditorViewColumn)(ge,Ee,Be)},onDidCloseTerminal(ge,Ee,Be){return lt(wt.onDidCloseTerminal)(ge,Ee,Be)},onDidOpenTerminal(ge,Ee,Be){return lt(wt.onDidOpenTerminal)(ge,Ee,Be)},onDidChangeActiveTerminal(ge,Ee,Be){return lt(wt.onDidChangeActiveTerminal)(ge,Ee,Be)},onDidChangeTerminalDimensions(ge,Ee,Be){return(0,it.$7G)(qe,"terminalDimensions"),lt(wt.onDidChangeTerminalDimensions)(ge,Ee,Be)},onDidChangeTerminalState(ge,Ee,Be){return lt(wt.onDidChangeTerminalState)(ge,Ee,Be)},onDidWriteTerminalData(ge,Ee,Be){return(0,it.$7G)(qe,"terminalDataWriteEvent"),lt(wt.onDidWriteTerminalData)(ge,Ee,Be)},onDidExecuteTerminalCommand(ge,Ee,Be){return(0,it.$7G)(qe,"terminalExecuteCommandEvent"),lt(wt.onDidExecuteTerminalCommand)(ge,Ee,Be)},onDidChangeTerminalShellIntegration(ge,Ee,Be){return(0,it.$7G)(qe,"terminalShellIntegration"),lt(ti.onDidChangeTerminalShellIntegration)(ge,Ee,Be)},onDidStartTerminalShellExecution(ge,Ee,Be){return(0,it.$7G)(qe,"terminalShellIntegration"),lt(ti.onDidStartTerminalShellExecution)(ge,Ee,Be)},onDidEndTerminalShellExecution(ge,Ee,Be){return(0,it.$7G)(qe,"terminalShellIntegration"),lt(ti.onDidEndTerminalShellExecution)(ge,Ee,Be)},get state(){return Ut.getState()},onDidChangeWindowState(ge,Ee,Be){return lt(Ut.onDidChangeWindowState)(ge,Ee,Be)},showInformationMessage(ge,...Ee){return zi.showMessage(qe,R.default.Info,ge,Ee[0],Ee.slice(1))},showWarningMessage(ge,...Ee){return zi.showMessage(qe,R.default.Warning,ge,Ee[0],Ee.slice(1))},showErrorMessage(ge,...Ee){return zi.showMessage(qe,R.default.Error,ge,Ee[0],Ee.slice(1))},showQuickPick(ge,Ee,Be){return Qe.showQuickPick(qe,ge,Ee,Be)},showWorkspaceFolderPick(ge){return Qe.showWorkspaceFolderPick(ge)},showInputBox(ge,Ee){return Qe.showInput(ge,Ee)},showOpenDialog(ge){return Ki.showOpenDialog(qe,ge)},showSaveDialog(ge){return Ki.showSaveDialog(ge)},createStatusBarItem(ge,Ee,Be){let dt,St,Lt;return typeof ge=="string"?(dt=ge,St=Ee,Lt=Be):(St=ge,Lt=Ee),ji.createStatusBarEntry(qe,dt,St,Lt)},setStatusBarMessage(ge,Ee){return ji.setStatusBarMessage(ge,Ee)},withScmProgress(ge){return Ot.report("window.withScmProgress",qe,"Use 'withProgress' instead."),jt.withProgress(qe,{location:Y.ProgressLocation.SourceControl},(Ee,Be)=>ge({report(dt){}}))},withProgress(ge,Ee){return jt.withProgress(qe,ge,Ee)},createOutputChannel(ge,Ee){return wi.createOutputChannel(ge,Ee,qe)},createWebviewPanel(ge,Ee,Be,dt){return Ti.createWebviewPanel(qe,ge,Ee,Be,dt)},createWebviewTextEditorInset(ge,Ee,Be,dt){return(0,it.$7G)(qe,"editorInsets"),Me.createWebviewEditorInset(ge,Ee,Be,dt,qe)},createTerminal(ge,Ee,Be){return typeof ge=="object"?"pty"in ge?wt.createExtensionTerminal(ge):wt.createTerminalFromOptions(ge):wt.createTerminal(ge,Ee,Be)},registerTerminalLinkProvider(ge){return wt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,Ee){return wt.registerProfileProvider(qe,ge,Ee)},registerTerminalQuickFixProvider(ge,Ee){return(0,it.$7G)(qe,"terminalQuickFixProvider"),wt.registerTerminalQuickFixProvider(ge,qe.identifier.value,Ee)},registerTreeDataProvider(ge,Ee){return Ae.registerTreeDataProvider(ge,Ee,qe)},createTreeView(ge,Ee){return Ae.createTreeView(ge,Ee,qe)},registerWebviewPanelSerializer:(ge,Ee)=>Ti.registerWebviewPanelSerializer(qe,ge,Ee),registerCustomEditorProvider:(ge,Ee,Be={})=>Vi.registerCustomEditorProvider(qe,ge,Ee,Be),registerFileDecorationProvider(ge){return oi.registerFileDecorationProvider(ge,qe)},registerUriHandler(ge){return gi.registerUriHandler(qe,ge)},createQuickPick(){return Qe.createQuickPick(qe)},createInputBox(){return Qe.createInputBox(qe)},get activeColorTheme(){return qi.activeColorTheme},onDidChangeActiveColorTheme(ge,Ee,Be){return lt(qi.onDidChangeActiveColorTheme)(ge,Ee,Be)},registerWebviewViewProvider(ge,Ee,Be){return xi.registerWebviewViewProvider(qe,ge,Ee,Be?.webviewOptions)},get activeNotebookEditor(){return Tt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,Ee,Be){return lt(Tt.onDidChangeActiveNotebookEditor)(ge,Ee,Be)},get visibleNotebookEditors(){return Tt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return lt(Tt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,Ee,Be){return lt(Ci.onDidChangeNotebookEditorSelection)(ge,Ee,Be)},onDidChangeNotebookEditorVisibleRanges(ge,Ee,Be){return lt(Ci.onDidChangeNotebookEditorVisibleRanges)(ge,Ee,Be)},showNotebookDocument(ge,Ee){return Tt.showNotebookDocument(ge,Ee)},registerExternalUriOpener(ge,Ee,Be){return(0,it.$7G)(qe,"externalUriOpener"),_i.registerExternalUriOpener(qe.identifier,ge,Ee,Be)},registerProfileContentHandler(ge,Ee){return(0,it.$7G)(qe,"profileContentHandlers"),en.registerProfileContentHandler(qe,ge,Ee)},registerQuickDiffProvider(ge,Ee,Be,dt){return(0,it.$7G)(qe,"quickDiffProvider"),Ct.registerQuickDiffProvider(bt(ge),Ee,Be,dt)},get tabGroups(){return ei.tabGroups},registerShareProvider(ge,Ee){return(0,it.$7G)(qe,"shareProvider"),Xt.registerShareProvider(bt(ge),Ee)}},cn={get rootPath(){return Ot.report("workspace.rootPath",qe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Et.getPath()},set rootPath(ge){throw new h.$$("rootPath")},getWorkspaceFolder(ge){return Et.getWorkspaceFolder(ge)},get workspaceFolders(){return Et.getWorkspaceFolders()},get name(){return Et.name},set name(ge){throw new h.$$("name")},get workspaceFile(){return Et.workspaceFile},set workspaceFile(ge){throw new h.$$("workspaceFile")},updateWorkspaceFolders:(ge,Ee,...Be)=>Et.updateWorkspaceFolders(qe,ge,Ee||0,...Be),onDidChangeWorkspaceFolders:function(ge,Ee,Be){return lt(Et.onDidChangeWorkspace)(ge,Ee,Be)},asRelativePath:(ge,Ee)=>Et.getRelativePath(ge,Ee),findFiles:(ge,Ee,Be,dt)=>Et.findFiles(ge,Ee,Be,qe.identifier,dt),findFiles2:(ge,Ee,Be)=>((0,it.$7G)(qe,"findFiles2"),Et.findFiles2(ge,Ee,qe.identifier,Be)),findTextInFiles:(ge,Ee,Be,dt)=>{(0,it.$7G)(qe,"findTextInFiles");let St,Lt;return typeof Ee=="object"?(St=Ee,Lt=Be):(St={},Lt=Ee,dt=Be),Et.findTextInFiles(ge,St||{},Lt,qe.identifier,dt)},save:ge=>Et.save(ge),saveAs:ge=>Et.saveAs(ge),saveAll:ge=>Et.saveAll(ge),applyEdit(ge,Ee){return wn.applyWorkspaceEdit(ge,qe,Ee)},createFileSystemWatcher:(ge,Ee,Be,dt)=>{let St;return typeof Ee=="boolean"?St={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!dt,correlate:!1}:Ee&&((0,it.$7G)(qe,"createFileSystemWatcher"),St={...Ee,correlate:!0}),tt.createFileSystemWatcher(Et,qe,ge,St)},get textDocuments(){return qt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new h.$$("textDocuments")},openTextDocument(ge){let Ee;const Be=ge;if(typeof ge=="string")Ee=Promise.resolve($.URI.file(ge));else if($.URI.isUri(ge))Ee=Promise.resolve(ge);else if(!Be||typeof Be=="object")Ee=qt.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(dt=>(dt.scheme===T.Schemas.vscodeRemote&&!dt.authority&&Ot.report("workspace.openTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority."),qt.ensureDocumentData(dt).then(St=>St.document)))},onDidOpenTextDocument:(ge,Ee,Be)=>lt(qt.onDidAddDocument)(ge,Ee,Be),onDidCloseTextDocument:(ge,Ee,Be)=>lt(qt.onDidRemoveDocument)(ge,Ee,Be),onDidChangeTextDocument:(ge,Ee,Be)=>lt(qt.onDidChangeDocument)(ge,Ee,Be),onDidSaveTextDocument:(ge,Ee,Be)=>lt(qt.onDidSaveDocument)(ge,Ee,Be),onWillSaveTextDocument:(ge,Ee,Be)=>lt(Pi.getOnWillSaveTextDocumentEvent(qe))(ge,Ee,Be),get notebookDocuments(){return Tt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,Ee){let Be;if($.URI.isUri(ge))Be=ge,await Tt.openNotebookDocument(ge);else if(typeof ge=="string")Be=$.URI.revive(await Tt.createNotebookDocument({viewType:ge,content:Ee}));else throw new Error("Invalid arguments");return Tt.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(ge,Ee,Be){return lt(Si.onDidSaveNotebookDocument)(ge,Ee,Be)},onDidChangeNotebookDocument(ge,Ee,Be){return lt(Si.onDidChangeNotebookDocument)(ge,Ee,Be)},onWillSaveNotebookDocument(ge,Ee,Be){return lt(Ai.getOnWillSaveNotebookDocumentEvent(qe))(ge,Ee,Be)},get onDidOpenNotebookDocument(){return lt(Tt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return lt(Tt.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,Ee,Be,dt){return Tt.registerNotebookSerializer(qe,ge,Ee,Be,(0,it.$6G)(qe,"notebookLiveShare")?dt:void 0)},onDidChangeConfiguration:(ge,Ee,Be)=>lt(Bi.onDidChangeConfiguration)(ge,Ee,Be),getConfiguration(ge,Ee){return Ee=arguments.length===1?void 0:Ee,Bi.getConfiguration(ge,Ee,qe)},registerTextDocumentContentProvider(ge,Ee){return ai.registerTextDocumentContentProvider(ge,Ee)},registerTaskProvider:(ge,Ee)=>(Ot.report("window.registerTaskProvider",qe,"Use the corresponding function on the 'tasks' namespace instead"),Zt.registerTaskProvider(qe,ge,Ee)),registerFileSystemProvider(ge,Ee,Be){return(0,O.$Tc)(Ke.registerFileSystemProvider(qe,ge,Ee,Be),xt.addFileSystemProvider(ge,Ee,Be))},get fs(){return xt.value},registerFileSearchProvider:(ge,Ee)=>((0,it.$7G)(qe,"fileSearchProvider"),di.registerFileSearchProvider(ge,Ee)),registerTextSearchProvider:(ge,Ee)=>((0,it.$7G)(qe,"textSearchProvider"),di.registerTextSearchProvider(ge,Ee)),registerAITextSearchProvider:(ge,Ee)=>((0,it.$7G)(qe,"aiTextSearchProvider"),(0,it.$7G)(qe,"textSearchProvider"),di.registerAITextSearchProvider(ge,Ee)),registerRemoteAuthorityResolver:(ge,Ee)=>((0,it.$7G)(qe,"resolvers"),Gt.registerRemoteAuthorityResolver(ge,Ee)),registerResourceLabelFormatter:ge=>((0,it.$7G)(qe,"resolvers"),li.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,it.$7G)(qe,"resolvers"),Gt.getRemoteExecServer(ge)),onDidCreateFiles:(ge,Ee,Be)=>lt(tt.onDidCreateFile)(ge,Ee,Be),onDidDeleteFiles:(ge,Ee,Be)=>lt(tt.onDidDeleteFile)(ge,Ee,Be),onDidRenameFiles:(ge,Ee,Be)=>lt(tt.onDidRenameFile)(ge,Ee,Be),onWillCreateFiles:(ge,Ee,Be)=>lt(tt.getOnWillCreateFileEvent(qe))(ge,Ee,Be),onWillDeleteFiles:(ge,Ee,Be)=>lt(tt.getOnWillDeleteFileEvent(qe))(ge,Ee,Be),onWillRenameFiles:(ge,Ee,Be)=>lt(tt.getOnWillRenameFileEvent(qe))(ge,Ee,Be),openTunnel:ge=>((0,it.$7G)(qe,"tunnels"),Mt.openTunnel(qe,ge).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,it.$7G)(qe,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(ge,Ee,Be)=>((0,it.$7G)(qe,"tunnels"),lt(Mt.onDidChangeTunnels)(ge,Ee,Be)),registerPortAttributesProvider:(ge,Ee)=>((0,it.$7G)(qe,"portsAttributes"),Mt.registerPortsAttributesProvider(ge,Ee)),registerTunnelProvider:(ge,Ee)=>((0,it.$7G)(qe,"tunnelFactory"),Mt.registerTunnelProvider(ge,Ee)),registerTimelineProvider:(ge,Ee)=>((0,it.$7G)(qe,"timeline"),pn.registerTimelineProvider(ge,Ee,qe.identifier,Dt.converter)),get isTrusted(){return Et.trusted},requestWorkspaceTrust:ge=>((0,it.$7G)(qe,"workspaceTrust"),Et.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,Ee,Be)=>lt(Et.onDidGrantWorkspaceTrust)(ge,Ee,Be),registerEditSessionIdentityProvider:(ge,Ee)=>((0,it.$7G)(qe,"editSessionIdentityProvider"),Et.registerEditSessionIdentityProvider(ge,Ee)),onWillCreateEditSessionIdentity:(ge,Ee,Be)=>((0,it.$7G)(qe,"editSessionIdentityProvider"),lt(Et.getOnWillCreateEditSessionIdentityEvent(qe))(ge,Ee,Be)),registerCanonicalUriProvider:(ge,Ee)=>((0,it.$7G)(qe,"canonicalUriProvider"),Et.registerCanonicalUriProvider(ge,Ee)),getCanonicalUri:(ge,Ee,Be)=>((0,it.$7G)(qe,"canonicalUriProvider"),Et.provideCanonicalUri(ge,Ee,Be))},ln={get inputBox(){return Ot.report("scm.inputBox",qe,"Use 'SourceControl.inputBox' instead"),ft.getLastInputBox(qe)},createSourceControl(ge,Ee,Be){return ft.createSourceControl(qe,ge,Ee,Be)}},un={createCommentController(ge,Ee){return ci.createCommentController(qe,ge,Ee)}},En={get activeDebugSession(){return Pt.activeDebugSession},get activeDebugConsole(){return Pt.activeDebugConsole},get breakpoints(){return Pt.breakpoints},get activeStackItem(){return Pt.activeStackItem},registerDebugVisualizationProvider(ge,Ee){return(0,it.$7G)(qe,"debugVisualization"),Pt.registerDebugVisualizationProvider(qe,ge,Ee)},registerDebugVisualizationTreeProvider(ge,Ee){return(0,it.$7G)(qe,"debugVisualization"),Pt.registerDebugVisualizationTree(qe,ge,Ee)},onDidStartDebugSession(ge,Ee,Be){return lt(Pt.onDidStartDebugSession)(ge,Ee,Be)},onDidTerminateDebugSession(ge,Ee,Be){return lt(Pt.onDidTerminateDebugSession)(ge,Ee,Be)},onDidChangeActiveDebugSession(ge,Ee,Be){return lt(Pt.onDidChangeActiveDebugSession)(ge,Ee,Be)},onDidReceiveDebugSessionCustomEvent(ge,Ee,Be){return lt(Pt.onDidReceiveDebugSessionCustomEvent)(ge,Ee,Be)},onDidChangeBreakpoints(ge,Ee,Be){return lt(Pt.onDidChangeBreakpoints)(ge,Ee,Be)},onDidChangeActiveStackItem(ge,Ee,Be){return lt(Pt.onDidChangeActiveStackItem)(ge,Ee,Be)},registerDebugConfigurationProvider(ge,Ee,Be){return Pt.registerDebugConfigurationProvider(ge,Ee,Be||Bt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,Ee){return Pt.registerDebugAdapterDescriptorFactory(qe,ge,Ee)},registerDebugAdapterTrackerFactory(ge,Ee){return Pt.registerDebugAdapterTrackerFactory(ge,Ee)},startDebugging(ge,Ee,Be){return!Be||typeof Be=="object"&&"configuration"in Be?Pt.startDebugging(ge,Ee,{parentSession:Be}):Pt.startDebugging(ge,Ee,Be||{})},stopDebugging(ge){return Pt.stopDebugging(ge)},addBreakpoints(ge){return Pt.addBreakpoints(ge)},removeBreakpoints(ge){return Pt.removeBreakpoints(ge)},asDebugSourceUri(ge,Ee){return Pt.asDebugSourceUri(ge,Ee)}},yn={registerTaskProvider:(ge,Ee)=>Zt.registerTaskProvider(qe,ge,Ee),fetchTasks:ge=>Zt.fetchTasks(ge),executeTask:ge=>Zt.executeTask(qe,ge),get taskExecutions(){return Zt.taskExecutions},onDidStartTask:(ge,Ee,Be)=>lt(Zt.onDidStartTask)(ge,Ee,Be),onDidEndTask:(ge,Ee,Be)=>lt(Zt.onDidEndTask)(ge,Ee,Be),onDidStartTaskProcess:(ge,Ee,Be)=>lt(Zt.onDidStartTaskProcess)(ge,Ee,Be),onDidEndTaskProcess:(ge,Ee,Be)=>lt(Zt.onDidEndTaskProcess)(ge,Ee,Be)},hn={createNotebookController(ge,Ee,Be,dt,St){return Di.createNotebookController(qe,ge,Ee,Be,dt,(0,it.$6G)(qe,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(ge,Ee)=>Tt.registerNotebookCellStatusBarItemProvider(qe,ge,Ee),createRendererMessaging(ge){return $i.createRendererMessaging(qe,ge)},createNotebookControllerDetectionTask(ge){return(0,it.$7G)(qe,"notebookKernelSource"),Di.createNotebookControllerDetectionTask(qe,ge)},registerKernelSourceActionProvider(ge,Ee){return(0,it.$7G)(qe,"notebookKernelSource"),Di.registerKernelSourceActionProvider(qe,ge,Ee)},onDidChangeNotebookCellExecutionState(ge,Ee,Be){return(0,it.$7G)(qe,"notebookCellExecutionState"),lt(Di.onDidChangeNotebookCellExecutionState)(ge,Ee,Be)}},Qi={t(...ge){if(typeof ge[0]=="string"){const Ee=ge.shift(),Be=!ge||typeof ge[0]!="object"?ge:ge[0];return vi.getMessage(qe.identifier.value,{message:Ee,args:Be})}return vi.getMessage(qe.identifier.value,ge[0])},get bundle(){return vi.getBundle(qe.identifier.value)},get uri(){return vi.getBundleUri(qe.identifier.value)}},dn={_version:1,transferActiveChat(ge){return(0,it.$7G)(qe,"interactive"),Mi.transferActiveChat(ge)}},fn={getRelatedInformation(ge,Ee){return(0,it.$7G)(qe,"aiRelatedInformation"),nn.getRelatedInformation(qe,ge,Ee)},registerRelatedInformationProvider(ge,Ee){return(0,it.$7G)(qe,"aiRelatedInformation"),nn.registerRelatedInformationProvider(qe,ge,Ee)},registerEmbeddingVectorProvider(ge,Ee){return(0,it.$7G)(qe,"aiRelatedInformation"),Hi.registerEmbeddingVectorProvider(qe,ge,Ee)}},gn={_version:1,registerChatResponseProvider(ge,Ee,Be){return(0,it.$7G)(qe,"chatProvider"),Jt.registerLanguageModel(qe,ge,Ee,Be)},registerChatVariableResolver(ge,Ee,Be,dt,St,Lt,Ri,Ji){return(0,it.$7G)(qe,"chatVariableResolver"),tn.registerVariableResolver(qe,ge,Ee,Be,dt,St,Lt,Ri,Ji?.id)},registerMappedEditsProvider(ge,Ee){return(0,it.$7G)(qe,"mappedEditsProvider"),Re.registerMappedEditsProvider(qe,ge,Ee)},createChatParticipant(ge,Ee){return Mi.createChatAgent(qe,ge,Ee)},createDynamicChatParticipant(ge,Ee,Be){return(0,it.$7G)(qe,"chatParticipantPrivate"),Mi.createDynamicChatAgent(qe,ge,Ee,Be)}},Sn={selectChatModels:ge=>vt.quality==="stable"?(console.warn(`[${k.$qn.toKey(qe.identifier)}] This API is disabled in '${vt.environment.appName}'-stable.`),Promise.resolve([])):Jt.selectLanguageModels(qe,ge??{}),onDidChangeChatModels:(ge,Ee,Be)=>vt.quality==="stable"?(console.warn(`[${k.$qn.toKey(qe.identifier)}] This API is disabled in '${vt.environment.appName}'-stable.`),P.Event.None(ge,Ee,Be)):Jt.onDidChangeProviders(ge,Ee,Be),registerChatModelProvider:(ge,Ee,Be)=>((0,it.$7G)(qe,"chatProvider"),Jt.registerLanguageModel(qe,ge,Ee,Be)),get embeddingModels(){return(0,it.$7G)(qe,"embeddings"),Li.embeddingsModels},onDidChangeEmbeddingModels:(ge,Ee,Be)=>((0,it.$7G)(qe,"embeddings"),Li.onDidChange(ge,Ee,Be)),registerEmbeddingsProvider(ge,Ee){return(0,it.$7G)(qe,"embeddings"),Li.registerEmbeddingsProvider(qe,ge,Ee)},async computeEmbeddings(ge,Ee,Be){return(0,it.$7G)(qe,"embeddings"),Li.computeEmbeddings(ge,Ee,Be)},registerTool(ge,Ee){return(0,it.$7G)(qe,"lmTools"),Gi.registerTool(qe,ge,Ee)},invokeTool(ge,Ee,Be){return(0,it.$7G)(qe,"lmTools"),Gi.invokeTool(ge,Ee,Be)},get tools(){return(0,it.$7G)(qe,"lmTools"),Gi.tools}},Dn={registerSpeechProvider(ge,Ee){return(0,it.$7G)(qe,"speech"),bn.registerProvider(qe.identifier,ge,Ee)}};return{version:vt.version,ai:fn,authentication:Ui,commands:vn,comments:un,chat:gn,debug:En,env:mi,extensions:sn,interactive:dn,l10n:Qi,languages:on,lm:Sn,notebooks:hn,scm:ln,speech:Dn,tasks:yn,tests:Wi,window:an,workspace:cn,Breakpoint:Y.$xO,TerminalOutputAnchor:Y.TerminalOutputAnchor,ChatResultFeedbackKind:Y.ChatResultFeedbackKind,ChatVariableLevel:Y.ChatVariableLevel,ChatCompletionItem:Y.$sP,CallHierarchyIncomingCall:Y.$VN,CallHierarchyItem:Y.$UN,CallHierarchyOutgoingCall:Y.$WN,CancellationError:h.$7,CancellationTokenSource:r.$xe,CandidatePortSource:n.CandidatePortSource,CodeAction:Y.$RN,CodeActionKind:Y.$SN,CodeActionTriggerKind:Y.CodeActionTriggerKind,CodeLens:Y.$XN,Color:Y.$$N,ColorInformation:Y.$_N,ColorPresentation:Y.$aO,ColorThemeKind:Y.ColorThemeKind,CommentMode:Y.CommentMode,CommentState:Y.CommentState,CommentThreadCollapsibleState:Y.CommentThreadCollapsibleState,CommentThreadState:Y.CommentThreadState,CommentThreadApplicability:Y.CommentThreadApplicability,CompletionItem:Y.$5N,CompletionItemKind:Y.CompletionItemKind,CompletionItemTag:Y.CompletionItemTag,CompletionList:Y.$6N,CompletionTriggerKind:Y.CompletionTriggerKind,ConfigurationTarget:Y.ConfigurationTarget,CustomExecution:Y.$iO,DebugAdapterExecutable:Y.$BO,DebugAdapterInlineImplementation:Y.$EO,DebugAdapterNamedPipeServer:Y.$DO,DebugAdapterServer:Y.$CO,DebugConfigurationProviderTriggerKind:Bt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Y.DebugConsoleMode,DebugVisualization:Y.$UO,DecorationRangeBehavior:Y.DecorationRangeBehavior,Diagnostic:Y.$KN,DiagnosticRelatedInformation:Y.$JN,DiagnosticSeverity:Y.DiagnosticSeverity,DiagnosticTag:Y.DiagnosticTag,Disposable:Y.$wN,DocumentHighlight:Y.$NN,DocumentHighlightKind:Y.DocumentHighlightKind,MultiDocumentHighlight:Y.$ON,DocumentLink:Y.$0N,DocumentSymbol:Y.$QN,EndOfLine:Y.EndOfLine,EnvironmentVariableMutatorType:Y.EnvironmentVariableMutatorType,EvaluatableExpression:Y.$HO,InlineValueText:Y.$IO,InlineValueVariableLookup:Y.$JO,InlineValueEvaluatableExpression:Y.$KO,InlineCompletionTriggerKind:Y.InlineCompletionTriggerKind,EventEmitter:P.$me,ExtensionKind:Y.ExtensionKind,ExtensionMode:Y.ExtensionMode,ExternalUriOpenerPriority:Y.ExternalUriOpenerPriority,FileChangeType:Y.FileChangeType,FileDecoration:Y.$WO,FileDecoration2:Y.$WO,FileSystemError:Y.$NO,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:Y.$OO,FoldingRangeKind:Y.FoldingRangeKind,FunctionBreakpoint:Y.$zO,InlineCompletionItem:Y.$7N,InlineCompletionList:Y.$8N,Hover:Y.$LN,VerboseHover:Y.$MN,HoverVerbosityAction:Y.HoverVerbosityAction,IndentAction:E.IndentAction,Location:Y.$IN,MarkdownString:Y.$YN,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Y.$ZN,PortAutoForwardAction:Y.PortAutoForwardAction,Position:Y.$xN,ProcessExecution:Y.$gO,ProgressLocation:Y.ProgressLocation,QuickInputButtons:Y.$VO,Range:Y.$yN,RelativePattern:Y.$vO,Selection:Y.$zN,SelectionRange:Y.$TN,SemanticTokens:Y.$RO,SemanticTokensBuilder:Y.$QO,SemanticTokensEdit:Y.$SO,SemanticTokensEdits:Y.$TO,SemanticTokensLegend:Y.$PO,ShellExecution:Y.$hO,ShellQuoting:Y.ShellQuoting,SignatureHelp:Y.$2N,SignatureHelpTriggerKind:Y.SignatureHelpTriggerKind,SignatureInformation:Y.$1N,SnippetString:Y.$HN,SourceBreakpoint:Y.$yO,StandardTokenType:Y.StandardTokenType,StatusBarAlignment:Y.StatusBarAlignment,SymbolInformation:Y.$PN,SymbolKind:Y.SymbolKind,SymbolTag:Y.SymbolTag,Task:Y.$jO,TaskGroup:Y.$fO,TaskPanelKind:Y.TaskPanelKind,TaskRevealKind:Y.TaskRevealKind,TaskScope:Y.TaskScope,TerminalLink:Y.$bO,TerminalQuickFixTerminalCommand:Y.$dO,TerminalQuickFixOpener:Y.$cO,TerminalLocation:Y.TerminalLocation,TerminalProfile:Y.$eO,TerminalExitReason:Y.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Y.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Y.TextDocumentSaveReason,TextEdit:Y.$DN,SnippetTextEdit:Y.$FN,TextEditorCursorStyle:a.TextEditorCursorStyle,TextEditorLineNumbersStyle:Y.TextEditorLineNumbersStyle,TextEditorRevealType:Y.TextEditorRevealType,TextEditorSelectionChangeKind:Y.TextEditorSelectionChangeKind,SyntaxTokenType:Y.SyntaxTokenType,TextDocumentChangeReason:Y.TextDocumentChangeReason,ThemeColor:Y.$uO,ThemeIcon:Y.$tO,TreeItem:Y.$kO,TreeItemCheckboxState:Y.TreeItemCheckboxState,TreeItemCollapsibleState:Y.TreeItemCollapsibleState,TypeHierarchyItem:Y.$gP,UIKind:fi.UIKind,Uri:$.URI,ViewColumn:Y.ViewColumn,WorkspaceEdit:Y.$GN,DocumentPasteTriggerKind:Y.DocumentPasteTriggerKind,DocumentDropEdit:Y.$qO,DocumentDropOrPasteEditKind:Y.$rO,DocumentPasteEdit:Y.$sO,InlayHint:Y.$4N,InlayHintLabelPart:Y.$3N,InlayHintKind:Y.InlayHintKind,RemoteAuthorityResolverError:Y.$CN,ResolvedAuthority:Y.$AN,ManagedResolvedAuthority:Y.$BN,SourceControlInputBoxValidationType:Y.SourceControlInputBoxValidationType,ExtensionRuntime:Y.ExtensionRuntime,TimelineItem:Y.$7O,NotebookRange:Y.$YO,NotebookCellKind:Y.NotebookCellKind,NotebookCellExecutionState:Y.NotebookCellExecutionState,NotebookCellData:Y.$ZO,NotebookData:Y.$1O,NotebookRendererScript:Y.$5O,NotebookCellStatusBarAlignment:Y.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Y.NotebookEditorRevealType,NotebookCellOutput:Y.$3O,NotebookCellOutputItem:Y.$2O,NotebookCellStatusBarItem:Y.$4O,NotebookControllerAffinity:Y.NotebookControllerAffinity,NotebookControllerAffinity2:Y.NotebookControllerAffinity2,NotebookEdit:Y.$EN,NotebookKernelSourceAction:Y.$6O,NotebookVariablesRequestKind:Y.NotebookVariablesRequestKind,PortAttributes:Y.$9O,LinkedEditingRanges:Y.$8O,TestResultState:Y.TestResultState,TestRunRequest:Y.$0O,TestMessage:Y.$$O,TestTag:Y.$_O,TestRunProfileKind:Y.TestRunProfileKind,TextSearchCompleteMessageType:At.TextSearchCompleteMessageType,DataTransfer:Y.$pO,DataTransferItem:Y.$lO,TestCoverageCount:Y.$aP,FileCoverage:Y.$cP,FileCoverage2:Y.$cP,StatementCoverage:Y.$dP,BranchCoverage:Y.$eP,DeclarationCoverage:Y.$fP,WorkspaceTrustState:Y.WorkspaceTrustState,LanguageStatusSeverity:Y.LanguageStatusSeverity,QuickPickItemKind:Y.QuickPickItemKind,InputBoxValidationSeverity:Y.InputBoxValidationSeverity,TabInputText:Y.$hP,TabInputTextDiff:Y.$iP,TabInputTextMerge:Y.$jP,TabInputCustom:Y.$kP,TabInputNotebook:Y.$mP,TabInputNotebookDiff:Y.$nP,TabInputWebview:Y.$lP,TabInputTerminal:Y.$oP,TabInputInteractiveWindow:Y.$pP,TabInputChat:Y.$qP,TabInputTextMultiDiff:Y.$rP,TelemetryTrustedValue:d.$up,LogLevel:c.LogLevel,EditSessionIdentityMatch:g.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Y.InteractiveSessionVoteDirection,ChatCopyKind:Y.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Y.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Y.$FO,DebugThread:Y.$GO,RelatedInformationType:Y.RelatedInformationType,SpeechToTextStatus:Y.SpeechToTextStatus,TextToSpeechStatus:Y.TextToSpeechStatus,PartialAcceptTriggerKind:Y.PartialAcceptTriggerKind,KeywordRecognitionStatus:Y.KeywordRecognitionStatus,ChatResponseMarkdownPart:Y.$tP,ChatResponseFileTreePart:Y.$xP,ChatResponseAnchorPart:Y.$yP,ChatResponseProgressPart:Y.$zP,ChatResponseProgressPart2:Y.$AP,ChatResponseReferencePart:Y.$DP,ChatResponseWarningPart:Y.$BP,ChatResponseTextEditPart:Y.$EP,ChatResponseMarkdownWithVulnerabilitiesPart:Y.$uP,ChatResponseCommandButtonPart:Y.$CP,ChatResponseDetectedParticipantPart:Y.$vP,ChatResponseConfirmationPart:Y.$wP,ChatRequestTurn:Y.$FP,ChatResponseTurn:Y.$GP,ChatLocation:Y.ChatLocation,LanguageModelChatMessageRole:Y.LanguageModelChatMessageRole,LanguageModelChatMessage:Y.$IP,LanguageModelChatMessageFunctionResultPart:Y.$HP,LanguageModelChatResponseTextPart:Y.$KP,LanguageModelChatResponseFunctionUsePart:Y.$JP,LanguageModelChatMessage2:Y.$IP,LanguageModelChatSystemMessage:Y.$LP,LanguageModelChatUserMessage:Y.$MP,LanguageModelChatAssistantMessage:Y.$NP,LanguageModelError:Y.$OP,NewSymbolName:Y.$MO,NewSymbolNameTag:Y.NewSymbolNameTag,NewSymbolNameTriggerKind:Y.NewSymbolNameTriggerKind,InlineEdit:Y.$PP,InlineEditTriggerKind:Y.InlineEditTriggerKind}}}}),define(ye[396],Se([1,0,89,169,48,163,42,35,64,47,101,102,103,126,77,96,162,76,63,125,95,78,161,12,65,123,124,128,129,167,99]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o,t,i,s,f,u,w,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Os)(u.$epc,u.$dpc,r.InstantiationType.Delayed),(0,r.$Os)(s.$ak,i.$tqc,r.InstantiationType.Delayed),(0,r.$Os)(c.$joc,c.$koc,r.InstantiationType.Delayed),(0,r.$Os)(R.$kQ,R.$jQ,r.InstantiationType.Eager),(0,r.$Os)(y.$toc,y.$uoc,r.InstantiationType.Eager),(0,r.$Os)(D.$$oc,D.$_oc,r.InstantiationType.Eager),(0,r.$Os)(T.$Ioc,T.$Goc,r.InstantiationType.Eager),(0,r.$Os)(d.$Koc,d.$Joc,r.InstantiationType.Eager),(0,r.$Os)(C.$opc,C.$ppc,r.InstantiationType.Eager),(0,r.$Os)(E.$tpc,E.$xpc,r.InstantiationType.Eager),(0,r.$Os)(O.$zpc,O.$ypc,r.InstantiationType.Eager),(0,r.$Os)($.$_P,$.$$P,r.InstantiationType.Eager),(0,r.$Os)(w.$fpc,w.$gpc,r.InstantiationType.Eager),(0,r.$Os)(g.$noc,g.$moc,r.InstantiationType.Eager),(0,r.$Os)(h.$5pc,h.$4pc,r.InstantiationType.Delayed),(0,r.$Os)(l.$Ppc,l.$Qpc,r.InstantiationType.Eager),(0,r.$Os)(k.$4oc,k.$3oc,r.InstantiationType.Eager),(0,r.$Os)(I.$fqc,I.$eqc,r.InstantiationType.Eager),(0,r.$Os)(a.$7oc,a.$0oc,r.InstantiationType.Eager),(0,r.$Os)(S.$gqc,S.$hqc,r.InstantiationType.Eager),(0,r.$Os)(p.$XFb,p.$YFb,r.InstantiationType.Eager),(0,r.$Os)(m.$qqc,m.$pqc,r.InstantiationType.Eager),(0,r.$Os)(P.$Foc,P.$Eoc,r.InstantiationType.Eager),(0,r.$Os)(n.$bpc,n.$apc,r.InstantiationType.Eager),(0,r.$Os)(o.$iQ,o.$fQ,r.InstantiationType.Eager),(0,r.$Os)(t.$Uoc,t.$Voc,r.InstantiationType.Eager),(0,r.$Os)(f.$mpc,f.$npc,r.InstantiationType.Eager)}),define(ye[130],Se([1,0,19,12,38,100]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lqc=void 0,e.$Jqc=T,e.$Kqc=R,O=We(O);function T(E){return E.startsWith("**")||E.startsWith("/")?E:`/${E}`}function R(E,l,k,p){const c=(0,r.$3b)(k,$),m=new P.$WL(l,c,p),d=m.preview.matches;return{ranges:(0,r.$3b)(c,a),uri:E,preview:{text:m.preview.text,matches:(0,r.$3b)(d,a)}}}function $(E){return new P.$XL(E.start.line,E.start.character,E.end.line,E.end.character)}function a(E){return new O.$KL(E.startLineNumber,E.startColumn,E.endLineNumber,E.endColumn)}let I=class{constructor(l,k){this.a=l,this.b=k}appendLine(l){this.b.debug(`${this.a}#search`,l)}};e.$Lqc=I,e.$Lqc=I=Je([Ve(1,h.$_j)],I)}),define(ye[397],Se([1,0,58,17,82,33,11,13,130,398]),function(ce,e,r,h,P,O,T,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mqc=E,e.$Nqc=m,e.$Oqc=g,r=We(r),h=We(h),O=We(O),R=We(R);const I=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function E(n,o,t,i,s){const f=l(n,o,t,i,s),u=o.folder.fsPath;return{cmd:r.spawn(I,f.args,{cwd:u}),rgDiskPath:I,siblingClauses:f.siblingClauses,rgArgs:f,cwd:u}}function l(n,o,t,i,s){const f=["--files","--hidden","--case-sensitive","--no-require-git"];p([o],t,!1).forEach(w=>{const y=(0,$.$Jqc)(w);if(f.push("-g",y),T.$j){const D=(0,P.$nm)(y);D!==y&&f.push("-g",D)}});const u=k([o],i,void 0,!1);return u.globArgs.forEach(w=>{const y=`!${(0,$.$Jqc)(w)}`;if(f.push("-g",y),T.$j){const D=(0,P.$nm)(y);D!==y&&f.push("-g",D)}}),o.disregardIgnoreFiles!==!1?f.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),o.ignoreSymlinks||f.push("--follow"),n.exists&&f.push("--quiet"),s&&f.push("--threads",`${s}`),f.push("--no-config"),o.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:u.siblingClauses}}function k(n,o,t,i=!0){const s=[];let f={};return n.forEach(u=>{const w=Object.assign({},u.excludePattern||{},o||{}),y=c(w,i?u.folder.fsPath:void 0,t);s.push(...y.globArgs),y.siblingClauses&&(f=Object.assign(f,y.siblingClauses))}),{globArgs:s,siblingClauses:f}}function p(n,o,t=!0){const i=[];return n.forEach(s=>{const f=Object.assign({},o||{},s.includePattern||{}),u=c(f,t?s.folder.fsPath:void 0);i.push(...u.globArgs)}),i}function c(n,o,t){const i=[],s={};return Object.keys(n).forEach(f=>{if(t&&t.has(f)||!f)return;const u=n[f];f=d(o?m(o,f):f),f.startsWith("\\\\")?f="\\\\"+f.substr(2).replace(/\\/g,"/"):f=f.replace(/\\/g,"/"),typeof u=="boolean"&&u?(f.startsWith("\\\\")&&(f+="**"),i.push(g(f))):u&&u.when&&(s[f]=u)}),{globArgs:i,siblingClauses:s}}function m(n,o){return h.$kc(o)?o:h.$lc(n,o)}function d(n){return n=R.$of(n,"\\"),R.$of(n,"/")}function g(n){return O.$Ag(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(ye[399],Se([1,0,58,61,17,400,19,51,39,82,33,11,43,13,18,34,38,397,141]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qqc=e.$Pqc=void 0,r=We(r),h=We(h),P=We(P),T=We(T),$=We($),a=We(a),E=We(E),k=We(k),p=We(p);const n=new Set;process.on("exit",()=>{n.forEach(f=>f())});class o{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&$.$zk(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=u.shouldGlobMatchFilePattern?null:(0,g.$Or)(this.b).normalizedLowercase),this.u=u.excludePattern&&$.$zk(u.excludePattern),this.t=new Map,u.folderQueries.forEach(w=>{const y=Object.assign({},w.excludePattern||{},this.a.excludePattern||{}),D=w.folder.fsPath;u.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==D).forEach(S=>{(0,I.$Eg)(S,D)&&(y[P.$nc(D,S)]=!0)}),this.t.set(D,new i(y,D))})}cancel(){this.l=!0,n.forEach(u=>u())}walk(u,w,y,D,S,C){if(this.m=l.$ge.create(!1),this.l)return C(null,this.j);w.forEach(A=>{const b=P.$pc(A.fsPath);this.u&&this.u(A.fsPath,b)||this.J(D,{relativePath:A.fsPath,searchPath:void 0})}),this.r=l.$ge.create(!1),this.w(u,(A,b)=>{this.x(this.y,this,A,y,D,S,v=>{if(v){const M=(0,R.$qj)(v);console.error(M),this.q.push(M),b(v,void 0)}else b(null,void 0)})},(A,b)=>{this.m.stop();const v=A?T.$Jb(A)[0]:null;C(v,this.j)})}w(u,w,y){const D=new Array(u.length),S=new Array(u.length);let C=!1,A=0;if(u.length===0)return y(null,[]);u.forEach((b,v)=>{w(b,(M,N)=>{if(M?(C=!0,D[v]=null,S[v]=M):(D[v]=N,S[v]=null),++A===u.length)return y(C?S:null,D)})})}x(u,w,...y){try{u.apply(w,y)}catch(D){y[y.length-1](D)}}y(u,w,y,D,S){const C=u.folder.fsPath,A=E.$j,b=()=>j&&j.kill();n.add(b);let v=_=>{n.delete(b),v=()=>{},S(_)},M="";const N=this.D(),L=(0,d.$Mqc)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression,w),j=L.cmd,z=!Object.keys(L.siblingClauses).length,F=L.rgArgs.args.map(_=>_.match(/^-/)?_:`'${_}'`).join(" ");let B=`${L.rgDiskPath} ${F}
 - cwd: ${L.cwd}`;L.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(L.rgArgs.siblingClauses)}`),D({message:B}),this.s=0,this.z(j,"utf8",D,(_,re,U)=>{if(_){v(_);return}if(this.j){v();return}const Q=(M+(A?a.$mm(re||""):re)).split(`
`);if(U){const ee=Q.length;Q[ee-1]=Q[ee-1].trim(),Q[ee-1]||Q.pop()}else M=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=Q.length,z){for(const ee of Q)if(this.J(y,{base:C,relativePath:ee,searchPath:this.N(u,ee)}),this.j){b();break}(U||this.j)&&v();return}this.G(u,N,C,Q,y),U&&(this.H(N,C,y),v())})}spawnFindCmd(u){const w=this.t.get(u.folder.fsPath),y=w.getBasenameTerms(),D=w.getPathTerms(),S=["-L","."];if(y.length||D.length){S.push("-not","(","(");for(const C of y)S.push("-name",C),S.push("-o");for(const C of D)S.push("-path",C),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),r.spawn("find",S,{cwd:u.folder.fsPath})}readStdout(u,w,y){let D="";this.z(u,w,()=>{},(S,C,A)=>{if(S){y(S);return}D+=C,A&&y(null,D)})}z(u,w,y,D){let S=(b,v,M)=>{(b||M)&&(S=()=>{},this.r?.stop()),D(b,v,M)},C=!1;u.stdout?(this.A(u.stdout,w,S),u.stdout.once("data",()=>C=!0)):y({message:"stdout is null"});let A;u.stderr?A=this.B(u.stderr):y({message:"stderr is null"}),u.on("error",b=>{S(b)}),u.on("close",b=>{let v;!C&&(v=this.C(A,w))&&s(v)?S(new Error(`command failed with error code ${b}: ${this.C(A,w)}`)):(this.g&&b===0&&(this.j=!0),S(null,"",!0))})}A(u,w,y){const D=new O.StringDecoder(w);return u.on("data",S=>{y(null,D.write(S))}),D}B(u){const w=[];return u.on("data",y=>{w.push(y)}),w}C(u,w){const y=new O.StringDecoder(w);return u.map(D=>y.write(D)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:w},y,D,S){D.indexOf(this.b)!==-1&&this.J(S,{base:y,relativePath:this.b,searchPath:this.N(u,this.b)});const C=A=>{const b=P.$pc(A),v=P.$oc(A);let M=w[v];M||(M=w[v]=[],C(v)),M.push({base:y,relativePath:A,basename:b,searchPath:this.N(u,A)})};D.forEach(C)}H({rootEntries:u,pathToEntries:w},y,D){const S=this,C=this.t.get(y),A=this.b;function b(v){S.o++;const M=(0,m.$aM)(()=>v.map(N=>N.basename));for(let N=0,L=v.length;N<L;N++){const j=v[N],{relativePath:z,basename:F}=j;if(C.test(z,F,A!==F?M:void 0))continue;const B=w[z];if(B)b(B);else{if(S.p++,z===A)continue;S.J(D,j)}if(S.j)break}}b(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,w,y,D,S){const C=u.folder,A=(0,m.$aM)(()=>y);this.w(y,(b,v)=>{if(this.l||this.j)return v(null);const M=w?[w,b].join(P.sep):b;if(this.t.get(u.folder.fsPath).test(M,b,this.a.filePattern!==b?A:void 0))return v(null);const N=[C.fsPath,M].join(P.sep);h.lstat(N,(L,j)=>{if(L||this.l||this.j)return v(null);this.L(N,j,(z,F)=>z||this.l||this.j?v(null):F.isDirectory()?(this.o++,this.M(N,j,(B,_)=>B||this.l||this.j||(_=_||"",this.v[_])?v(null):(this.v[_]=!0,c.Promises.readdir(N).then(re=>{if(this.l||this.j)return v(null);this.I(u,M,re,D,U=>v(U||null))},re=>{v(null)})))):(this.p++,M===this.b||this.h&&p.$jg(F.size)&&F.size>this.h||this.J(D,{base:C.fsPath,relativePath:M,searchPath:this.N(u,M)}),v(null,void 0)))})},b=>{const v=b&&T.$Jb(b);return S(v&&v.length>0?v[0]:void 0)})}J(u,w){this.K(w)&&(!this.d||this.d(w.relativePath,P.$pc(w.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(w))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$8L)(u,this.c);if(this.b)return(0,m.$8L)(u,this.b,!1)}return!0}L(u,w,y){return w.isSymbolicLink()?h.stat(u,y):y(null,w)}M(u,w,y){return w.isSymbolicLink()?h.realpath(u,(D,S)=>D?y(D):y(null,S)):y(null,u)}N(u,w){return u.folderName?P.$lc(u.folderName,w):w}}e.$Pqc=o;class t{constructor(u,w){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.d=w,this.c=new o(u)}search(u,w,y){this.c.walk(this.a,this.b,this.d,u,w,(D,S)=>{y(D,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Qqc=t;class i{constructor(u,w){this.expression=u,this.c=w,this.d(u)}d(u){let w,y;Object.keys(u).filter(D=>u[D]).forEach(D=>{P.$kc(D)?(w=w||$.$uk(),w[D]=u[D]):(y=y||$.$uk(),y[D]=u[D])}),this.a=w&&$.$zk(w,{trimForExclusions:!0}),this.b=y&&$.$zk(y,{trimForExclusions:!0})}test(u,w,y){return this.b&&this.b(u,w,y)||this.a&&this.a(P.$lc(this.c,u),w,y)}getBasenameTerms(){const u=[];return this.a&&u.push(...$.$Bk(this.a)),this.b&&u.push(...$.$Bk(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...$.$Ck(this.a)),this.b&&u.push(...$.$Ck(this.b)),u}}function s(f){const u=f.trim().split(`
`),w=u[0].trim();if(w.startsWith("Error parsing regex"))return w;if(w.startsWith("regex parse error"))return k.$0f(u[u.length-1].trim());if(w.startsWith("error parsing glob")||w.startsWith("unsupported encoding"))return w.charAt(0).toUpperCase()+w.substr(1);if(w==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(w.startsWith("Literal "))return w}}),define(ye[401],Se([1,0,104,22,208,21,19]),function(ce,e,r,h,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KE=e.$JE=e.$BE=e.DecodeStreamErrorKind=e.$AE=e.$zE=e.$yE=e.$wE=e.$vE=e.$uE=e.$tE=void 0,e.$xE=R,e.$CE=c,e.$DE=m,e.$EE=d,e.$FE=g,e.$GE=n,e.$HE=y,e.$IE=D,e.$tE="utf8",e.$uE="utf8bom",e.$vE="utf16be",e.$wE="utf16le";function R(S){return[e.$tE,e.$uE,e.$vE,e.$wE].some(C=>C===S)}e.$yE=[254,255],e.$zE=[255,254],e.$AE=[239,187,191];const $=512,a=512,I=512*8,E=512*128;var l;(function(S){S[S.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(l||(e.DecodeStreamErrorKind=l={}));class k extends Error{constructor(C,A){super(C),this.decodeStreamErrorKind=A}}e.$BE=k;class p{static async create(C){let A;if(C!==e.$tE)A=(await(0,P.$sE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(g(C));else{const b=new TextDecoder;A={write(v){return b.decode(v,{stream:!0})},end(){return b.decode()}}}return new p(A)}constructor(C){this.a=C}write(C){return this.a.write(C)}end(){return this.a.end()}}function c(S,C){const A=C.minBytesRequiredForDetection??C.guessEncoding?I:a;return new Promise((b,v)=>{const M=(0,r.$Ce)(B=>B.join("")),N=[];let L=0,j;const z=new O.$xe,F=async()=>{try{const B=await D({buffer:h.$Oe.concat(N),bytesRead:L},C.guessEncoding,C.candidateGuessEncodings);if(B.seemsBinary&&C.acceptTextOnly)throw new k("Stream is binary but only text is accepted for decoding",l.STREAM_IS_BINARY);B.encoding=await C.overwriteEncoding(B.encoding),j=await p.create(B.encoding);const _=j.write(h.$Oe.concat(N).buffer);M.write(_),N.length=0,L=0,b({stream:M,detected:B})}catch(B){z.cancel(),M.destroy(),v(B)}};(0,r.$Ge)(S,{onData:async B=>{j?M.write(j.write(B.buffer)):(N.push(B),L+=B.byteLength,L>=A&&(S.pause(),await F(),setTimeout(()=>S.resume())))},onError:B=>M.error(B),onEnd:async()=>{j||await F(),M.end(j?.end())}},z.token)})}async function m(S,C,A){const v=(await(0,P.$sE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(g(C),A);let M=!1,N=!1;return{read(){if(N)return null;const L=S.read();if(typeof L!="string"){if(N=!0,!M&&A?.addBOM)switch(C){case e.$tE:case e.$uE:return h.$Oe.wrap(Uint8Array.from(e.$AE));case e.$vE:return h.$Oe.wrap(Uint8Array.from(e.$yE));case e.$wE:return h.$Oe.wrap(Uint8Array.from(e.$zE))}const j=v.end();return j&&j.length>0?(M=!0,h.$Oe.wrap(j)):null}return M=!0,h.$Oe.wrap(v.write(L))}}}async function d(S){return(await(0,P.$sE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(g(S))}function g(S){return S===e.$uE||S===null?e.$tE:S}function n(S,C){if(!S||C<e.$yE.length)return null;const A=S.readUInt8(0),b=S.readUInt8(1);if(A===e.$yE[0]&&b===e.$yE[1])return e.$vE;if(A===e.$zE[0]&&b===e.$zE[1])return e.$wE;if(C<e.$AE.length)return null;const v=S.readUInt8(2);return A===e.$AE[0]&&b===e.$AE[1]&&v===e.$AE[2]?e.$uE:null}const o=["ascii","utf-16","utf-32"];async function t(S,C){const A=await(0,P.$sE)("jschardet","dist/jschardet.min.js"),b=S.slice(0,E),v=w(b.buffer);C&&(C=(0,T.$Jb)(C.map(L=>u(L))),C.length===0&&(C=void 0));const M=A.detect(v,C?{detectEncodings:C}:void 0);if(!M||!M.encoding)return null;const N=M.encoding.toLowerCase();return 0<=o.indexOf(N)?null:f(M.encoding)}const i={ibm866:"cp866",big5:"cp950"};function s(S){return S.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function f(S){const C=s(S);return i[C]||C}function u(S){const C=s(S);return e.$KE[C].guessableName}function w(S){let C="";for(let A=0;A<S.length;A++)C+=String.fromCharCode(S[A]);return C}function y(S){switch(S){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const C=S.match(/windows(\d+)/);return C?"windows-"+C[1]:S}}}function D({buffer:S,bytesRead:C},A,b){let v=n(S,C),M=!1;if(v!==e.$vE&&v!==e.$wE&&S){let N=!0,L=!0,j=!1;for(let z=0;z<C&&z<$;z++){const F=z%2===1,B=S.readUInt8(z)===0;if(B&&(j=!0),N&&(F&&!B||!F&&B)&&(N=!1),L&&(F&&B||!F&&!B)&&(L=!1),B&&!N&&!L)break}j&&(N?v=e.$wE:L?v=e.$vE:M=!0)}return A&&!M&&!v&&S?t(S.slice(0,C),b).then(N=>({seemsBinary:!1,encoding:N})):{seemsBinary:M,encoding:v}}e.$JE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$KE=(()=>{const S={};for(const C in e.$JE)e.$JE[C].guessableName&&(S[C]=e.$JE[C]);return S})()}),define(ye[172],Se([1,0,401,34,171]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yqc=void 0,h=We(h);class O extends P.$Lpc{constructor(R,$,a=h,I="searchProcess"){super({query:R,provider:$},{readdir:E=>a.Promises.readdir(E.fsPath),toCanonicalName:E=>(0,r.$HE)(E)},I)}}e.$Yqc=O}),define(ye[173],Se([1,0,58,416,400,19,79,39,13,2,38,100,417,398,130]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sqc=e.$Rqc=void 0,e.$Tqc=i,e.$Uqc=f,e.$Vqc=w,e.$Wqc=y,e.$Xqc=S,r=We(r);const c=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(A,b){this.a=A,this.b=b}provideTextSearchResults(A,b,v,M){return this.a.appendLine(`provideTextSearchResults ${A.pattern}, ${JSON.stringify({...b,folder:b.folder.toString()})}`),new Promise((N,L)=>{M.onCancellationRequested(()=>Q());const j={...b,numThreads:this.b},z=i(A,j),F=b.folder.fsPath,B=z.map($e=>$e.match(/^-/)?$e:`'${$e}'`).join(" ");this.a.appendLine(`${c} ${B}
 - cwd: ${F}`);let _=r.spawn(c,z,{cwd:F});_.on("error",$e=>{console.error($e),this.a.appendLine("Error: "+($e&&$e.message)),L((0,I.$4L)(new I.$2L($e&&$e.message,I.SearchErrorCode.rgProcessError)))});let re=!1;const U=new n(b.maxResults,b.folder,b.previewOptions);U.on("result",$e=>{re=!0,he="",v.report($e)});let G=!1;const Q=()=>{G=!0,_?.kill(),U?.cancel()};let ee=!1;U.on("hitLimit",()=>{ee=!0,Q()});let he="";_.stdout.on("data",$e=>{U.handleData($e),re||(he+=$e)});let ne=!1;_.stdout.once("data",()=>ne=!0);let De="";_.stderr.on("data",$e=>{const K=$e.toString();this.a.appendLine(K),De.length+K.length<1e6&&(De+=K)}),_.on("close",()=>{if(this.a.appendLine(ne?"Got data from stdout":"No data from stdout"),this.a.appendLine(re?"Got result from parser":"No result from parser"),he&&this.a.appendLine(`Got data without result: ${he}`),this.a.appendLine(""),G)N({limitHit:ee});else{U.flush(),_=null;let $e;De&&!ne&&($e=d(De))?L((0,I.$4L)(new I.$2L($e.message,$e.code))):N({limitHit:ee})}})})}}e.$Rqc=m;function d(C){const A=C.split(`
`),b=A[0].trim();if(A.some(M=>M.startsWith("regex parse error")))return new I.$2L(g(A),I.SearchErrorCode.regexParseError);const v=b.match(/grep config error: unknown encoding: (.*)/);if(v)return new I.$2L(`Unknown encoding: ${v[1]}`,I.SearchErrorCode.unknownEncoding);if(b.startsWith("error parsing glob"))return new I.$2L(b.charAt(0).toUpperCase()+b.substr(1),I.SearchErrorCode.globParseError);if(b.startsWith("the literal"))return new I.$2L(b.charAt(0).toUpperCase()+b.substr(1),I.SearchErrorCode.invalidLiteral);if(b.startsWith("PCRE2: error compiling pattern"))return new I.$2L(b,I.SearchErrorCode.regexParseError)}function g(C){const A=["Regex parse error"],b=C.filter(v=>v.startsWith("PCRE2:"));if(b.length>=1){const v=b[0].replace("PCRE2:","");if(v.indexOf(":")!==-1&&v.split(":").length>=2){const M=v.split(":")[1];A.push(":"+M)}}return A.join("")}class n extends h.EventEmitter{constructor(A,b,v){super(),this.g=A,this.h=b,this.j=v,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new P.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(A,b){return super.on(A,b),this}handleData(A){if(this.b)return;const b=typeof A=="string"?A:this.d.write(A);this.k(b)}k(A){let b=A.indexOf(`
`);const v=this.a+A;if(b>=0)b+=this.a.length;else{this.a=v;return}let M=0;for(;b>=0;)this.m(v.substring(M,b).trim()),M=b+1,b=v.indexOf(`
`,M);this.a=v.substring(M)}m(A){if(this.b||!A)return;let b;try{b=JSON.parse(A)}catch{throw new Error(`malformed line from rg: ${A}`)}if(b.type==="match"){const v=o(b.data.path),M=a.URI.joinPath(this.h,v),N=this.n(b.data,M);this.p(N),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(b.type==="context"){const v=o(b.data.path),M=a.URI.joinPath(this.h,v);this.o(b.data,M).forEach(L=>this.p(L))}}n(A,b){const v=A.line_number-1,M=o(A.lines),N=Buffer.from(M);let L=0,j=0,z=v;A.submatches.length===0&&A.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const F=(0,O.$Jb)(A.submatches.map((B,_)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const re=o(B.match),U=N.slice(L,B.start).toString(),G=t(U),Q=G.numLines>0?G.lastLineLength:G.lastLineLength+j,ee=t(re),he=G.numLines+z,ne=ee.numLines+he,De=ee.numLines>0?ee.lastLineLength:ee.lastLineLength+Q;return L=B.end,j=De,z=ne,new E.$KL(he,Q,ne,De)}));return(0,p.$Kqc)(b,M,F,this.j)}o(A,b){const v=o(A.lines),M=A.line_number;return v.replace(/\r?\n$/,"").split(`
`).map((N,L)=>({text:N,uri:b,lineNumber:M+L}))}p(A){this.emit("result",A)}}e.$Sqc=n;function o(C){return C.bytes?Buffer.from(C.bytes,"base64").toString():C.text}function t(C){const A=/\n/g;let b=0,v=-1,M;for(;M=A.exec(C);)b++,v=M.index;const N=v>=0?C.length-v-1:C.length;return{numLines:b,lastLineLength:N}}function i(C,A){const b=["--hidden","--no-require-git"];b.push(C.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:v,otherIncludes:M}=(0,T.$K)(A.includes,L=>L.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const L=new Set;M.forEach(j=>{L.add(j)}),b.push("-g","!*"),L.forEach(j=>{s(j).map(p.$Jqc).forEach(z=>{b.push("-g",z)})})}v&&v.length&&v.forEach(L=>{b.push("-g",L)}),A.excludes.map(p.$Jqc).forEach(L=>b.push("-g",`!${L}`)),A.maxFileSize&&b.push("--max-filesize",A.maxFileSize+""),A.useIgnoreFiles?A.useParentIgnoreFiles||b.push("--no-ignore-parent"):b.push("--no-ignore"),A.followSymlinks&&b.push("--follow"),A.encoding&&A.encoding!=="utf8"&&b.push("--encoding",A.encoding),A.numThreads&&b.push("--threads",`${A.numThreads}`),C.pattern==="--"&&(C.isRegExp=!0,C.pattern="\\-\\-"),C.isMultiline&&!C.isRegExp&&(C.pattern=(0,$.$if)(C.pattern),C.isRegExp=!0),A.usePCRE2&&b.push("--pcre2"),b.push("--crlf"),C.isRegExp&&(C.pattern=f(C.pattern),b.push("--engine","auto"));let N;if(C.isWordMatch){const j=(0,$.$rf)(C.pattern,!!C.isRegExp,{wholeWord:C.isWordMatch}).source.replace(/\\\//g,"/");b.push("--regexp",j)}else if(C.isRegExp){let L=w(C.pattern);L=y(L),b.push("--regexp",L)}else N=C.pattern,b.push("--fixed-strings");return b.push("--no-config"),A.useGlobalIgnoreFiles||b.push("--no-ignore-global"),b.push("--json"),C.isMultiline&&b.push("--multiline"),A.beforeContext&&b.push("--before-context",A.beforeContext+""),A.afterContext&&b.push("--after-context",A.afterContext+""),b.push("--"),N&&b.push(N),b.push("."),b}function s(C){return S(C).flatMap(b=>{const v=(0,R.$xk)(b,"/");return v.map((M,N)=>v.slice(0,N+1).join("/"))})}function f(C){const A=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;C.match(A);)C=C.replace(A,"$1\\x{$2}");const b=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;C.match(b);)C=C.replace(b,"$1\\x{$2}");return C}const u=C=>C.type==="Assertion"&&C.kind==="lookbehind";function w(C){let A;try{A=new l.RegExpParser().parsePattern(C)}catch{return C}let b="",v=0;const M=(j,z,F)=>{b+=C.slice(v,j)+F,v=z},N=[];return new l.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const z=N[0];if(!z)M(j.start,j.end,"\\r?\\n");else if(!N.some(u))if(z.type==="CharacterClass")if(z.negate){const F=C.slice(z.start+2,j.start)+C.slice(j.end,z.end-1);z.parent?.type==="Quantifier"?M(z.start,z.end,F?`[^${F}]`:"."):M(z.start,z.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=C.slice(z.start+1,j.start)+C.slice(j.end,z.end-1);M(z.start,z.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else z.type==="Quantifier"&&M(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){N.unshift(j)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(j){N.unshift(j)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(j){N.unshift(j)},onCharacterClassLeave(){N.shift()},onAssertionEnter(j){u(j)&&N.push(j)},onAssertionLeave(j){N[0]===j&&N.shift()}}).visit(A),b+=C.slice(v),b}function y(C){return C.replace(/\n/g,"\\r?\\n")}function D(C){let A=!1,b=!1,v="",M="";for(let N=0;N<C.length;N++){const L=C[N];switch(L){case"\\":b?(A?M+="\\"+L:v+="\\"+L,b=!1):b=!0;break;case"{":if(b)A?M+=L:v+=L,b=!1;else{if(A)return{strInBraces:v+"{"+M+"{"+C.substring(N+1)};A=!0}break;case"}":if(b)A?M+=L:v+=L,b=!1;else{if(A)return{fixedStart:v,strInBraces:M,fixedEnd:C.substring(N+1)};v+=L}break;default:A?M+=(b?"\\":"")+L:v+=(b?"\\":"")+L,b=!1;break}}return{strInBraces:v+(A?"{"+M:"")}}function S(C){const{fixedStart:A,strInBraces:b,fixedEnd:v}=D(C);if(A===void 0||v===void 0)return[b];let M=(0,R.$xk)(b,",");M.length||(M=[""]);const N=S(v);return M.flatMap(L=>{const j=A+L;return N.map(z=>j+z)})}}),define(ye[402],Se([1,0,21,173,90,15]),function(ce,e,r,h,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qc=void 0;class T{constructor(a,I){this.b=a,this.c=I,this.a=new Set,process.once("exit",()=>this.e())}async provideTextSearchResults(a,I,E,l){const k=await this.c(),p=new h.$Rqc(this.b,k),c={...I,numThreads:k};if(I.folder.scheme===O.Schemas.vscodeUserData){const m={...c,folder:I.folder.with({scheme:O.Schemas.file})},d=new P.$vw(g=>E.report({...g,uri:g.uri.with({scheme:I.folder.scheme})}));return this.d(l,g=>p.provideTextSearchResults(a,m,d,g))}else return this.d(l,m=>p.provideTextSearchResults(a,c,E,m))}async d(a,I){const E=R(a);this.a.add(E);const l=await I(E.token);return this.a.delete(E),l}e(){this.a.forEach(a=>a.cancel())}}e.$2qc=T;function R($){const a=new r.$xe;return $.onCancellationRequested(()=>a.cancel()),a}}),define(ye[403],Se([1,0,34,173,172]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zqc=void 0,r=We(r);class O{constructor($,a){this.a=$,this.b=a}search($,a,I){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const E={appendLine(k){I({message:k})}},l=new P.$Yqc(this.a,new h.$Rqc(E,this.b),r);return new Promise((k,p)=>l.search(c=>{a(c.map(T))},$).then(c=>k({limitHit:c.limitHit??!1,type:"success",stats:c.stats,messages:[]}),p))}}e.$Zqc=O;function T(R){return{path:R.resource&&R.resource.fsPath,results:R.results,numMatches:(R.results||[]).reduce(($,a)=>{if(a.ranges){const I=a;return $+(Array.isArray(I.ranges)?I.ranges.length:1)}else return $+1},0)}}}),define(ye[404],Se([1,0,19,9,14,4,141,17,43,2,28,38,399,403]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1qc=void 0,r=We(r);class p{static{this.a=512}constructor(o="searchProcess",t){this.d=o,this.f=t,this.b=Object.create(null)}fileSearch(o){let t;const i=d(o),s=new O.$me({onDidAddFirstListener:()=>{t=(0,h.$sh)(async f=>{const u=await this.f?.();return this.doFileSearchWithEngine(l.$Qqc,i,w=>s.fire(w),f,p.a,u)}),t.then(f=>s.fire(f),f=>s.fire({type:"error",error:{message:f.message,stack:f.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return s.event}textSearch(o){let t;const i=d(o),s=new O.$me({onDidAddFirstListener:()=>{t=(0,h.$sh)(f=>this.g(i,u=>s.fire(u),f)),t.then(f=>s.fire(f),f=>s.fire({type:"error",error:{message:f.message,stack:f.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return s.event}async g(o,t,i){o.maxFileSize=this.h().maxFileSize;const s=await this.f?.();return new k.$Zqc(o,s).search(i,t,t)}h(){return{maxFileSize:16*I.$Hl.GB}}doFileSearch(o,t,i,s){return this.doFileSearchWithEngine(l.$Qqc,o,i,s,p.a,t)}doFileSearchWithEngine(o,t,i,s,f=p.a,u){let w=0;const y=S=>{Array.isArray(S)?(w+=S.length,i(S.map(C=>this.j(C)))):S.relativePath?(w++,i(this.j(S))):i(S)};if(t.sortByScore){let S=this.n(t,y,s);if(!S){const C=t.maxResults?Object.assign({},t,{maxResults:null}):t,A=new o(C,u);S=this.k(A,t,i,y,s)}return new Promise((C,A)=>{S.then(([b,v])=>{const M=v.map(N=>this.j(N));this.q(M,i,f),C(b)},A)})}const D=new o(t,u);return this.s(D,y,f,s).then(S=>({limitHit:S.limitHit,type:"success",stats:{detailStats:S.stats,type:this.d,fromCache:!1,resultCount:w,sortingTime:void 0},messages:[]}))}j(o){return{path:o.base?(0,R.$lc)(o.base,o.relativePath):o.relativePath}}k(o,t,i,s,f){const u=new O.$me;let w=(0,h.$sh)(D=>{let S=[];const C=A=>{Array.isArray(A)?S=A:(s(A),u.fire(A))};return this.s(o,C,-1,D).then(A=>[A,S])}),y;if(t.cacheKey){y=this.l(t.cacheKey);const D={promise:w,event:u.event,resolved:!1};y.resultsToSearchCache[t.filePattern||""]=D,w.then(()=>{D.resolved=!0},S=>{delete y.resultsToSearchCache[t.filePattern||""]}),w=this.t(w)}return w.then(([D,S])=>{const C=y?y.scorerCache:Object.create(null),A=(typeof t.maxResults!="number"||t.maxResults>0)&&$.$ge.create(!1);return this.o(t,S,C,f).then(b=>{const v=A?A.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:v,fromCache:!1,type:this.d,resultCount:b.length},messages:D.messages,limitHit:D.limitHit||typeof t.maxResults=="number"&&S.length>t.maxResults},b]})})}l(o){const t=this.b[o];return t||(this.b[o]=new c)}n(o,t,i){const s=o.cacheKey&&this.b[o.cacheKey];if(!s)return;const f=this.r(s,o.filePattern||"",t,i);if(f)return f.then(([u,w,y])=>{const D=$.$ge.create(!1);return this.o(o,w,s.scorerCache,i).then(S=>{const C=D.elapsed(),A={fromCache:!0,detailStats:y,type:this.d,resultCount:w.length,sortingTime:C};return[{type:"success",limitHit:u.limitHit||typeof o.maxResults=="number"&&w.length>o.maxResults,stats:A,messages:[]},S]})})}o(o,t,i,s){const f=(0,T.$Or)(o.filePattern||""),u=(y,D)=>(0,T.$Nr)(y,D,f,!0,m,i),w=typeof o.maxResults=="number"?o.maxResults:E.$QL;return r.$Ib(t,u,w,1e4,s)}q(o,t,i){if(i&&i>0)for(let s=0;s<o.length;s+=i)t(o.slice(s,s+i));else t(o)}r(o,t,i,s){const f=$.$ge.create(!1),u=t.indexOf(R.sep)>=0;let w;for(const C in o.resultsToSearchCache)if(t.startsWith(C)){if(u&&C.indexOf(R.sep)<0&&C!=="")continue;const A=o.resultsToSearchCache[C];w={promise:this.t(A.promise),event:A.event,resolved:A.resolved};break}if(!w)return null;const y=f.elapsed(),D=$.$ge.create(!1),S=w.event(i);return s&&s.onCancellationRequested(()=>{S.dispose()}),w.promise.then(([C,A])=>{if(s&&s.isCancellationRequested)throw(0,P.$8)();const b=[],v=(0,T.$Or)(t).normalizedLowercase;for(const M of A)(0,E.$8L)(M,v)&&b.push(M);return[C,b,{cacheWasResolved:w.resolved,cacheLookupTime:y,cacheFilterTime:D.elapsed(),cacheEntryCount:A.length}]})}s(o,t,i,s){return new Promise((f,u)=>{let w=[];s?.onCancellationRequested(()=>o.cancel()),o.search(y=>{y&&(i?(w.push(y),i>0&&w.length>=i&&(t(w),w=[])):t(y))},y=>{t(y)},(y,D)=>{w.length&&t(w),y?(t({message:"Search finished. Error: "+y.message}),u(y)):(t({message:"Search finished. Stats: "+JSON.stringify(D.stats)}),f(D))})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}t(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(t,i){return o.then(t,i)}catch(t){return this.then(void 0,t)}finally(t){return o.finally(t)}}}}e.$1qc=p;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(n){return(0,R.$pc)(n.relativePath)}getItemDescription(n){return(0,R.$oc)(n.relativePath)}getItemPath(n){return n.relativePath}};function d(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(g),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>a.URI.revive(o))}}function g(n){return{...n,folder:a.URI.revive(n.folder)}}}),define(ye[405],Se([1,0,3,15,2,34,12,42,30,20,103,73,38,404,402,130,172]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3qc=void 0,O=We(O);let d=class extends I.$Qpc{constructor(n,o,t,i,s){super(n,t,s),this.D=i,this.w=O,this.x=-1,this.y=null,this.z=!1,this.B=new r.$Vc,this.C=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.E=this.E.bind(this);const f=new c.$Lqc("RipgrepSearchUD",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new p.$2qc(f,this.getNumThreadsCached))),o.remote.isRemote&&o.remote.authority&&this.F(),i.getConfigProvider().then(u=>{this.C||this.B.add(u.onDidChangeConfiguration(this.E))})}E(n){n.affectsConfiguration("search")&&(this.A=void 0)}async getNumThreads(){return(await this.D.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this.A||(this.A=this.getNumThreads()),this.A}dispose(){this.C=!0,this.B.dispose()}$enableExtensionHostSearch(){this.F()}F(){if(this.z)return;this.z=!0;const n=new c.$Lqc("RipgrepSearchEH",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.file,new p.$2qc(n,this.getNumThreadsCached))),this.B.add(this.G(h.Schemas.file,new k.$1qc("fileSearchProvider",this.getNumThreadsCached)))}G(n,o){const t=this.d++;return this.y=o,this.x=t,this.c.$registerFileSearchProvider(t,this.s(n)),(0,r.$Uc)(()=>{this.y=null,this.c.$unregisterProvider(t)})}$provideFileSearchResults(n,o,t,i){const s=(0,I.$Rpc)(t);if(n===this.x){const f=Date.now();return this.H(n,o,s,i).then(u=>{const w=Date.now()-f;return this.q.debug(`Ext host file search time: ${w}ms`),u})}return super.$provideFileSearchResults(n,o,t,i)}async doInternalFileSearchWithCustomCallback(n,o,t){const i=f=>{if((0,l.$7L)(f)&&(f=[f]),Array.isArray(f)){t(f.map(u=>P.URI.file(u.path)));return}f.message&&this.q.debug("ExtHostSearch",f.message)};if(!this.y)throw new Error("No internal file search handler");const s=await this.getNumThreadsCached();return this.y.doFileSearch(n,s,i,o)}async H(n,o,t,i){return this.doInternalFileSearchWithCustomCallback(t,i,s=>{this.c.$handleFileMatch(n,o,s)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,o){return new m.$Yqc(n,o,void 0,"textSearchProvider")}};e.$3qc=d,e.$3qc=d=Je([Ve(0,a.$1P),Ve(1,$.$eQ),Ve(2,E.$Coc),Ve(3,R.$Ioc),Ve(4,T.$_j)],d)}),define(ye[131],Se([1,0,418,67,68,419,22,14,4,3,17,11,32,87,69]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$wi=e.$vi=e.$ui=void 0,e.$xi=u,e.$yi=w,e.$Ai=S,e.$Bi=C;const c=3e4;class m{traceSocketEvent(b,v){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,v)}constructor(b,v=""){this.f=!0,this.debugLabel=v,this.socket=b,this.traceSocketEvent(p.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=N=>{if(this.traceSocketEvent(p.SocketDiagnosticsEventType.Error,{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,R.$3)(N)}},this.socket.on("error",this.a);let M;this.b=N=>{this.traceSocketEvent(p.SocketDiagnosticsEventType.Close,{hadError:N}),this.f=!1,M&&clearTimeout(M)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,M=setTimeout(()=>b.destroy(),c)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(b){const v=M=>{this.traceSocketEvent(p.SocketDiagnosticsEventType.Read,M),b(T.$Oe.wrap(M))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(b){const v=M=>{b({type:p.SocketCloseEventType.NodeSocketCloseEvent,hadError:M,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(b){const v=()=>{b()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(b){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(p.SocketDiagnosticsEventType.Write,b),this.socket.write(b.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,R.$3)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,R.$3)(v)}}end(){this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((b,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeDrainEnd),b();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeDrainEnd),b()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$ui=m;var d;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var g;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(g||(g={}));class n extends a.$Wc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(b,v){this.socket.traceSocketEvent(b,v)}constructor(b,v,M,N){super(),this.f=this.B(new $.$me),this.g=this.B(new $.$me),this.h=!1,this.j={state:g.PeekHeader,readLen:d.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=b,this.traceSocketEvent(p.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:M?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new o(this,v,M,N,this.f,(L,j)=>this.m(L,j))),this.B(this.a.onError(L=>{console.error(L),(0,R.$3)(L),this.g.fire({type:p.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:L})})),this.b=new p.$pi,this.B(this.socket.onData(L=>this.n(L))),this.B(this.socket.onClose(async L=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(L)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this.f.event(b)}onClose(b){return this.g.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let v=0;for(;v<b.byteLength;)this.a.writeMessage(b.slice(v,Math.min(v+d.MaxWebSocketMessageLength,b.byteLength)),{compressed:!0,opcode:2}),v+=d.MaxWebSocketMessageLength}m(b,{compressed:v,opcode:M}){if(this.h)return;this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,b);let N=d.MinHeaderByteSize;b.byteLength<126?N+=0:b.byteLength<2**16?N+=2:N+=8;const L=T.$Oe.alloc(N),j=v?64:0,z=M&15;if(L.writeUInt8(128|j|z,0),b.byteLength<126)L.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){L.writeUInt8(126,1);let F=1;L.writeUInt8(b.byteLength>>>8&255,++F),L.writeUInt8(b.byteLength>>>0&255,++F)}else{L.writeUInt8(127,1);let F=1;L.writeUInt8(0,++F),L.writeUInt8(0,++F),L.writeUInt8(0,++F),L.writeUInt8(0,++F),L.writeUInt8(b.byteLength>>>24&255,++F),L.writeUInt8(b.byteLength>>>16&255,++F),L.writeUInt8(b.byteLength>>>8&255,++F),L.writeUInt8(b.byteLength>>>0&255,++F)}this.socket.write(T.$Oe.concat([L,b]))}end(){this.h=!0,this.socket.end()}n(b){if(b.byteLength!==0){for(this.b.acceptChunk(b);this.b.byteLength>=this.j.readLen;)if(this.j.state===g.PeekHeader){const v=this.b.peek(this.j.readLen),M=v.readUInt8(0),N=(M&128)>>>7,L=(M&64)>>>6,j=M&15,z=v.readUInt8(1),F=(z&128)>>>7,B=z&127;this.j.state=g.ReadHeader,this.j.readLen=d.MinHeaderByteSize+(F?4:0)+(B===126?2:0)+(B===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!L),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===g.ReadHeader){const v=this.b.read(this.j.readLen),M=v.readUInt8(1),N=(M&128)>>>7;let L=M&127,j=1;L===126?L=v.readUInt8(++j)*2**8+v.readUInt8(++j):L===127&&(L=v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j));let z=0;N&&(z=v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j)),this.j.state=g.ReadBody,this.j.readLen=L,this.j.mask=z,this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===g.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),s(v,this.j.mask),this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=g.PeekHeader,this.j.readLen=d.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$vi=n;class o extends a.$Wc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Oe.alloc(0)}constructor(b,v,M,N,L,j){super(),this.n=b,this.r=L,this.s=j,this.a=this.B(new $.$me),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$me),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$me),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new t(this.n,N,M,{windowBits:15})),this.f=this.B(new i(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(b,v){this.g.push({data:b,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:b,options:v}=this.g.shift();if(this.f&&v.compressed){const M=await this.w(this.f,b);this.s(M,v)}else this.s(b,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(b,v){return new Promise((M,N)=>{b.write(v),b.flush(L=>M(L))})}acceptFrame(b,v,M){this.h.push({data:b,isCompressed:v,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const b=this.h.shift();if(this.b&&b.isCompressed){const v=await this.C(this.b,b.data,b.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(b.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(b,v,M){return new Promise((N,L)=>{b.write(v),M&&b.write(T.$Oe.fromByteArray([0,0,255,255])),b.flush(j=>N(j))})}}class t extends a.$Wc{get recordedInflateBytes(){return this.j?T.$Oe.concat(this.f):T.$Oe.alloc(0)}constructor(b,v,M,N){super(),this.h=b,this.j=v,this.a=this.B(new $.$me),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(N),this.b.on("error",L=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateError,{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateData,L),this.g.push(T.$Oe.wrap(L))}),M&&(this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateInitialWrite,M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(b){this.j&&this.f.push(b.clone()),this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateWrite,b),this.b.write(b.buffer)}flush(b){this.b.flush(()=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=T.$Oe.concat(this.g);this.g.length=0,b(v)})}}class i extends a.$Wc{constructor(b,v){super(),this.g=b,this.a=this.B(new $.$me),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateError,{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateData,M),this.f.push(T.$Oe.wrap(M))})}write(b){this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateWrite,b.buffer),this.b.write(b.buffer)}flush(b){this.b.flush(2,()=>{this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=T.$Oe.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),b(v)})}}function s(A,b){if(b===0)return;const v=A.byteLength>>>2;for(let F=0;F<v;F++){const B=A.readUInt32BE(F*4);A.writeUInt32BE(B^b,F*4)}const M=v*4,N=A.byteLength-M,L=b>>>24&255,j=b>>>16&255,z=b>>>8&255;N>=1&&A.writeUInt8(A.readUInt8(M)^L,M),N>=2&&A.writeUInt8(A.readUInt8(M+1)^j,M+1),N>=3&&A.writeUInt8(A.readUInt8(M+2)^z,M+2)}e.$wi=process.env.XDG_RUNTIME_DIR;const f={[E.Platform.Linux]:107,[E.Platform.Mac]:103};function u(){const A=(0,l.$2g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const b=process.platform!=="darwin"&&e.$wi?e.$wi:(0,P.tmpdir)(),v=(0,I.$lc)(b,`vscode-ipc-${A}.sock`);return y(v),v}function w(A,b,v){const N=(0,r.createHash)("sha256").update(A).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${v}-${b}-sock`;const L=v.substr(0,4),j=b.substr(0,6);let z;return process.platform!=="darwin"&&e.$wi&&!process.env.VSCODE_PORTABLE?z=(0,I.$lc)(e.$wi,`vscode-${N}-${L}-${j}.sock`):z=(0,I.$lc)(A,`${L}-${j}.sock`),y(z),z}function y(A){const b=f[E.$u];typeof b=="number"&&A.length>=b&&console.warn(`WARNING: IPC handle "${A}" is longer than ${b} chars, try a shorter --user-data-dir`)}class D extends k.$ji{static b(b){const v=$.Event.fromNodeEventEmitter(b,"connection");return $.Event.map(v,M=>({protocol:new p.$qi(new m(M,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(M,"close"))}))}constructor(b){super(D.b(b)),this.d=b}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$zi=D;function S(A){return new Promise((b,v)=>{const M=(0,h.createServer)();M.on("error",v),M.listen(A,()=>{M.removeListener("error",v),b(new D(M))})})}function C(A,b){return new Promise((v,M)=>{const N=(0,h.createConnection)(A,()=>{N.removeListener("error",M),v(p.$ri.fromSocket(new m(N,`ipc-client${b}`),b))});N.once("error",M)})}}),define(ye[406],Se([1,0,67,68,188,131,9,3,11,45,12,116,284,286,118,93,22]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=e.$Mgc=e.$Lgc=void 0,r=We(r),h=We(h);async function d(i,s,f,u,w){let y;for(let D=3;D&&(y?.dispose(),y=await new g(i,s,f,u,w).waitForReady(),!(w&&P.$5g[w]||!P.$5g[y.tunnelLocalPort]));D--);return y}class g extends R.$Wc{constructor(s,f,u,w,y){super(),this.m=f,this.n=y,this.privacy=c.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=r.createServer(),this.c=new T.$Eh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=D=>this.r(D),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=w,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(f=>{f()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,f=(0,c.$Iw)(this.m)?"0.0.0.0":"127.0.0.1";let u=await(0,P.$6g)(s,2,1e3,f),w=null;return this.b.listen(u,this.m),await this.c.wait(),w=this.b.address(),w||(u=0,this.b.listen(u,this.m),await this.c.wait(),w=this.b.address()),this.tunnelLocalPort=w.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${w.port}`,this}async r(s){s.pause();const f=(0,c.$Gw)(this.tunnelRemoteHost)||(0,c.$Iw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,l.$2l)(this.a,f,this.tunnelRemotePort),w=u.getSocket(),y=u.readEntireBuffer();u.dispose(),y.byteLength>0&&s.write(y.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),w.end()}),s.on("close",()=>w.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),w instanceof O.$ui?w.socket.destroy():w.end()}),w instanceof O.$ui?this.t(s,w):this.s(s,w),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),w.end()})}s(s,f){f.onClose(()=>s.destroy()),f.onEnd(()=>s.end()),f.onData(u=>s.write(u.buffer)),s.on("data",u=>f.write(m.$Oe.wrap(u))),s.resume()}t(s,f){const u=f.socket;u.on("end",()=>s.end()),u.on("close",()=>s.end()),u.on("error",()=>{s.destroy()}),u.pipe(s),s.pipe(u)}}e.$Lgc=g;let n=class extends c.$Lw{constructor(s,f,u,w,y){super(f,y),this.H=s,this.I=u,this.J=w}isPortPrivileged(s){return(0,c.$Jw)(s,this.t,$.OS,h.release())}F(s,f,u,w,y,D,S,C){const A=this.D(f,u);if(A)return++A.refcount,A.value;if((0,c.$Cw)(s))return this.G(s,f,u,y,D,S,C);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${u} on local port ${y}.`);const b={commit:this.J.commit,quality:this.J.quality,addressProvider:s,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=d(b,w,f,u,y);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(f,u,v),v}}};e.$Mgc=n,e.$Mgc=n=Je([Ve(0,k.$Vl),Ve(1,I.$_j),Ve(2,p.$Yl),Ve(3,E.$sk),Ve(4,a.$_i)],n);let o=class extends n{constructor(s,f,u,w,y){super(s,f,u,w,y)}};e.$Ngc=o,e.$Ngc=o=Je([Ve(0,k.$Vl),Ve(1,I.$_j),Ve(2,p.$Yl),Ve(3,E.$sk),Ve(4,a.$_i)],o);let t=class extends R.$Wc{constructor(s,f,u,w,y){super(),this.b=s,this.c=f,this.f=u,this.g=w,this.h=y,this.a=new Map}async openTunnel(s,f,u,w,y,D,S,C,A){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${w} on local port ${D}.`),!this.a.has(s)){const b=new o(this.b,this.c,this.g,this.f,this.h);this.B(b),this.a.set(s,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(f,u,w,y,D,S,C,A)}};e.$Ogc=t,e.$Ogc=t=Je([Ve(0,k.$Vl),Ve(1,I.$_j),Ve(2,E.$sk),Ve(3,p.$Yl),Ve(4,a.$_i)],t)}),define(ye[407],Se([1,0,131,303,61,35,2,12,46]),function(ce,e,r,h,P,O,T,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=e.$pQ=void 0,h=We(h),P=We(P);class a{constructor(l,k,p){this.b=l,this.c=k,this.f=p,this.a=h.createServer((c,m)=>this.h(c,m)),this.g().catch(c=>(k.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",l=>this.c.error(l))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(l,k){const p=(m,d)=>{k.writeHead(m,{"content-type":"application/json"}),k.end(JSON.stringify(d||null),g=>g&&this.c.error(g))},c=[];l.setEncoding("utf8"),l.on("data",m=>c.push(m)),l.on("end",async()=>{try{const m=JSON.parse(c.join(""));let d;switch(m.type){case"open":d=await this.i(m);break;case"openExternal":d=await this.j(m);break;case"status":d=await this.l(m);break;case"extensionManagement":d=await this.k(m);break;default:p(404,`Unknown message type: ${m.type}`);break}p(200,d)}catch(m){const d=m instanceof Error?m.message:JSON.stringify(m);p(500,d),this.c.error("Error while processing pipe request",m)}})}async i(l){const{fileURIs:k,folderURIs:p,forceNewWindow:c,diffMode:m,mergeMode:d,addMode:g,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:t,remoteAuthority:i}=l,s=[];if(Array.isArray(p))for(const y of p)try{s.push({folderUri:T.URI.parse(y)})}catch{}if(Array.isArray(k))for(const y of k)try{(0,$.$$i)(y)?s.push({workspaceUri:T.URI.parse(y)}):s.push({fileUri:T.URI.parse(y)})}catch{}const f=t?T.URI.file(t):void 0,w={forceNewWindow:c,diffMode:m,mergeMode:d,addMode:g,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!f&&!g,waitMarkerFileURI:f,remoteAuthority:i};this.b.executeCommand("_remoteCLI.windowOpen",s,w)}async j(l){for(const k of l.uris){const p=T.URI.parse(k),c=p.scheme==="file"?p:k;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(l){const k=c=>c?.map(m=>/\.vsix$/i.test(m)?T.URI.parse(m):m),p={list:l.list,install:k(l.install),uninstall:k(l.uninstall),force:l.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",p)}async l(l){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&P.existsSync(this.f)&&P.unlinkSync(this.f)}}e.$pQ=a;let I=class extends a{constructor(l,k){super(l,k,(0,r.$xi)())}};e.$qQ=I,e.$qQ=I=Je([Ve(0,O.$kQ),Ve(1,R.$_j)],I)}),define(ye[408],Se([1,0,62,395,390,302,53,377,2,15,10,407,111,337,376]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8qc=void 0,r=We(r);class c extends P.$wqc{j(){const g=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(f,u,w){return f=i(f),g.a.has(f)?g.a.get(f).load(f,$.URI.file((0,l.$lr)(u.filename)),y=>o.apply(this,[y,u,w])):o.apply(this,arguments)};const t=n._resolveLookupPaths;n._resolveLookupPaths=(s,f)=>t.call(this,i(s),f);const i=s=>{for(const f of g.b){const u=f(s);if(u){s=u;break}}return s}}}class m extends T.$ipc{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async vb(){this.h.createInstance(k.$6qc);const g=this.h.invokeFunction(h.$sqc);if(this.h.createInstance(R.$5qc),this.f.remote.isRemote&&this.f.remote.authority){const t=this.h.createInstance(E.$qQ);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}this.h.createInstance(p.$7qc),await this.h.createInstance(c,g,{mine:this.J,all:this.L}).install(),r.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,O.$4qc)(this.j,o,this,this.s,this.z,this.f),r.mark("code/extHost/didInitProxyResolver")}wb(g){return g.main}async xb(g,n,o){if(n.scheme!==a.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let t=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const i=g?.identifier.value;g&&await this.w.initializeLocalizedMessages(g);try{i&&r.mark(`code/extHost/willLoadExtensionCode/${i}`),t=ce.__$__nodeRequire(n.fsPath)}finally{i&&r.mark(`code/extHost/didLoadExtensionCode/${i}`),o.codeLoadingStop()}return t}async $setRemoteEnvironment(g){if(this.f.remote.isRemote)for(const n in g){const o=g[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$8qc=m}),define(ye[409],Se([1,0,58,22,4,3,134,11,23,2,34,69,12,283,72,118,93,406,30,20,77,384]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$drc=void 0,e.$9qc=i,e.$0qc=s,e.$$qc=f,e.$_qc=u,e.$arc=y,e.$brc=D,e.$crc=S,$=We($),I=We(I);function i(b){const v=b.trim().split(`
`),M=[];return v.forEach(L=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(L);j&&j.length>=3&&M.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),M.reduce((L,j)=>(L[j.socket]=j,L),{})}function s(...b){const v=[].concat(...b.map(u));return[...new Map(v.filter(M=>M.st==="0A").map(M=>{const N=M.local_address.split(":");return{socket:parseInt(M.inode,10),ip:f(N[0]),port:parseInt(N[1],16)}}).map(M=>[M.ip+":"+M.port,M])).values()]}function f(b){let v="";if(b.length===8)for(let M=b.length-2;M>=0;M-=2)v+=parseInt(b.substr(M,2),16),M!==0&&(v+=".");else for(let M=0;M<b.length;M+=8){const N=b.substring(M,M+8);let L="";for(let j=8;j>=2;j-=2)L+=N.substring(j-2,j),(j===6||j===2)&&(L=parseInt(L,16).toString(16),v+=`${L}`,L="",M+j!==b.length-6&&(v+=":"))}return v}function u(b){const v=b.trim().split(`
`),M=v.shift().trim().split(/\s+/).filter(L=>L!=="rx_queue"&&L!=="tm->when");return v.map(L=>L.trim().split(/\s+/).reduce((j,z,F)=>(j[M[F]||F]=z,j),{}))}function w(b){return!!b.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||b.indexOf("out/server-main.js")!==-1||b.indexOf("_productName=VSCode")!==-1}function y(b){const v=b.trim().split(`
`),M=[];return v.forEach(N=>{const L=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);L&&L.length>=4&&M.push({pid:parseInt(L[1],10),ppid:parseInt(L[2]),cmd:L[3]})}),M}async function D(b,v,M){const N=M.reduce((j,z)=>(j[z.pid]=z,j),{}),L=[];return b.forEach(({socket:j,ip:z,port:F})=>{const B=v[j]?v[j].pid:void 0,_=B?N[B]?.cmd:void 0;B&&_&&!w(_)&&L.push({host:z,port:F,detail:_,pid:B})}),L}function S(b,v,M){const N=new Map,L=y(v);for(const j of b){const z=M.get(j.port);if(z){N.set(j.port,z);continue}const F=L.find(B=>B.cmd.includes(`${j.port}`));if(F){let B=F,_;do _=L.find(re=>re.ppid===B.pid),_&&(B=_);while(_);N.set(j.port,{host:j.ip,port:j.port,pid:B.pid,detail:B.cmd,ppid:B.ppid})}else N.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return N}let C=class extends o.$YFb{constructor(v,M,N,L){super(v,M,N),this.D=M,this.F=L,this.y=void 0,this.z=new Map,this.C=!1,R.$k&&M.remote.isRemote&&M.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(v){if(v&&this.C)return;this.C=v;let M;this.y&&(M=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new T.$Nm;let L=0;for(;this.C;){const j=new Date().getTime(),z=(await this.I()).filter(_=>(0,m.$Gw)(_.host)||(0,m.$Iw)(_.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(_=>_.port).join(", ")}`);const F=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${F} ms.`),L++>3&&N.update(F),(!M||JSON.stringify(M)!==JSON.stringify(z))&&(M=z,await this.a.$onFoundNewCandidates(M));const B=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${B} ms.`),await new Promise(_=>setTimeout(()=>_(),B))}}G(v){return Math.max(v*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(v=>v.port).join(", ")}`)}async I(){let v="",M="";try{v=await I.Promises.readFile("/proc/net/tcp","utf8"),M=await I.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=s(v,M),L=await new Promise(G=>{(0,r.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,ee,he)=>{G(ee)})}),j=i(L),z=await I.Promises.readdir("/proc"),F=[];for(const G of z)try{const Q=Number(G),ee=$.$gh(a.URI.file("/proc"),G);if((await I.Promises.stat(ee.fsPath)).isDirectory()&&!isNaN(Q)){const ne=await I.Promises.readlink($.$gh(ee,"cwd").fsPath),De=await I.Promises.readFile($.$gh(ee,"cmdline").fsPath,"utf8");F.push({pid:Q,cwd:ne,cmd:De})}}catch{}const B=[],_=N.filter(G=>{const Q=j[G.socket];return Q||B.push(G),Q}),re=D(_,j,F);let U;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${B.length}`),B.length>0){const G=await new Promise(Q=>{(0,r.exec)("ps -F -A -l | grep root",(ee,he,ne)=>{Q(he)})});this.z=S(B,G,this.z),U=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.map(Q=>Q.port).join(", ")}`)}return re.then(G=>U?G.concat(U):G)}w(v){return async M=>{const N=new d.$Lgc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,z,F,B){const _=await v.makeConnection();return A.connect(_,z,F,B)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new p.$Rl(0),connectionToken:v.connectionToken})}},signService:this.F},"localhost",M.remoteAddress.host||"localhost",M.remoteAddress.port,M.localAddressPort);await N.waitForReady();const L=new P.$me;return{localAddress:(0,t.$UM)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:L.event,dispose:()=>{N.dispose(),L.fire(),L.dispose()}}}}};e.$drc=C,e.$drc=C=Je([Ve(0,n.$1P),Ve(1,g.$eQ),Ve(2,l.$_j),Ve(3,c.$Yl)],C);class A extends k.$exb{static connect(v,M,N,L){const j=new O.$Vc,z={onClose:j.add(new P.$me),onData:j.add(new P.$me),onEnd:j.add(new P.$me)};j.add(v.onDidReceiveMessage(B=>z.onData.fire(h.$Oe.wrap(B)))),j.add(v.onDidEnd(()=>z.onEnd.fire())),j.add(v.onDidClose(B=>z.onClose.fire({type:E.SocketCloseEventType.NodeSocketCloseEvent,error:B,hadError:!!B})));const F=new A(v,L,z);return F.B(j),(0,k.$dxb)(F,M,N,L,z)}constructor(v,M,N){super(M,N),this.n=v}write(v){this.n.send(v.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ye[410],Se([1,0,89,379,393,392,405,408,409,102,53,103,101,47,77,98,378,338,12,394,65,298,113,118,149]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d,g,n,o,t,i,s,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Os)(I.$jpc,R.$8qc,r.InstantiationType.Eager),(0,r.$Os)(g.$ak,d.$frc,r.InstantiationType.Delayed),(0,r.$Os)(g.$_j,new i.$Ci(t.$vqc,[!1],!0)),(0,r.$Os)(s.$Yl,f.$Qgc,r.InstantiationType.Delayed),(0,r.$Os)(c.$Loc,m.$erc,r.InstantiationType.Eager),(0,r.$Os)(a.$tpc,O.$Iqc,r.InstantiationType.Eager),(0,r.$Os)(E.$Ppc,T.$3qc,r.InstantiationType.Eager),(0,r.$Os)(l.$fqc,P.$Aqc,r.InstantiationType.Eager),(0,r.$Os)(k.$7oc,h.$zqc,r.InstantiationType.Eager),(0,r.$Os)(p.$XFb,$.$drc,r.InstantiationType.Eager),(0,r.$Os)(o.$mpc,n.$grc,r.InstantiationType.Eager)});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ye[420],Se([1,0,421,67,9,22,14,62,111,34,69,131,114,281,391,304,320,94,396,410]),function(ce,e,r,h,P,O,T,R,$,a,I,E,l,k,p,c,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=zt(r),h=We(h),R=We(R),k=zt(k),function(){for(let D=0;D<process.execArgv.length;D++)process.execArgv[D]==="--inspect-port=0"&&(process.execArgv.splice(D,1),D--)}();const g=(0,r.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const y=globalThis._VSCODE_NODE_MODULES.module,D=y._load;y._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return D.apply(this,arguments)}})();const n=process.exit.bind(process),o=process.on.bind(process);function t(y){process.exit=function(D){if(y)n(D);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const D=new Error("An extension called process.crash() and this was prevented.");console.warn(D.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(D,S){D==="uncaughtException"&&(S=function(){try{return S.call(void 0,arguments)}catch{}}),o(D,S)}}let i=function(y){n()};function s(){const y=(0,m.$fn)(process.env);if(y.type===m.ExtHostConnectionType.MessagePort)return new Promise((D,S)=>{const C=A=>{const b=A[0],v=new I.$si;b.on("message",M=>v.fire(O.$Oe.wrap(M.data))),b.on("close",()=>{i("renderer closed the MessagePort")}),b.start(),D({onMessage:v.event,send:M=>b.postMessage(M.buffer)})};process.parentPort.on("message",A=>C(A.ports))});if(y.type===m.ExtHostConnectionType.Socket)return new Promise((D,S)=>{let C=null;const A=setTimeout(()=>{i("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=I.ProtocolConstants.ReconnectionGraceTime,v=I.ProtocolConstants.ReconnectionShortGraceTime,M=new P.$Sh(()=>i("renderer disconnected for too long (1)"),b),N=new P.$Sh(()=>i("renderer disconnected for too long (2)"),v);process.on("message",(j,z)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){z.setNoDelay(!0);const F=O.$Oe.wrap(Buffer.from(j.initialDataChunk,"base64"));let B;if(j.skipWebSocketFrames)B=new E.$ui(z,"extHost-socket");else{const _=O.$Oe.wrap(Buffer.from(j.inflateBytes,"base64"));B=new E.$vi(new E.$ui(z,"extHost-socket"),j.permessageDeflate,_,!1)}C?(M.cancel(),N.cancel(),C.beginAcceptReconnection(B,F),C.endAcceptReconnection(),C.sendResume()):(clearTimeout(A),C=new I.$ti({socket:B,initialChunk:F}),C.sendResume(),C.onDidDispose(()=>i("renderer disconnected")),D(C),C.onSocketClose(()=>{M.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;M.isScheduled()&&N.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(L)});{const D=y.pipeName;return new Promise((S,C)=>{const A=h.createConnection(D,()=>{A.removeListener("error",C);const b=new I.$ti({socket:new E.$ui(A,"extHost-renderer")});b.sendResume(),S(b)});A.once("error",C),A.on("close",()=>{i("renderer closed the socket")})})}}async function f(){const y=await s();return new class{constructor(){this.a=new I.$si,this.onMessage=this.a.event,this.b=!1,this.d=y.onMessage(D=>{(0,d.$Bn)(D,d.MessageType.Terminate)?(this.b=!0,this.d.dispose(),i("received terminate message from renderer")):this.a.fire(D)})}send(D){this.b||y.send(D)}async drain(){if(y.drain)return y.drain()}}}function u(y){return new Promise(D=>{const S=y.onMessage(C=>{S.dispose();const A=JSON.parse(C.toString()),b=A.commit,v=k.default.commit;if(b&&v&&b!==v&&n(d.ExtensionHostExitCode.VersionMismatch),A.parentPid){let M=0;setInterval(function(){try{process.kill(A.parentPid,0),M=0}catch(L){L&&L.code==="EPERM"?(M++,M>=3&&i(`parent process ${A.parentPid} does not exist anymore (3 x EPERM): ${L.message} (code: ${L.code}) (errno: ${L.errno})`)):i(`parent process ${A.parentPid} does not exist anymore: ${L.message} (code: ${L.code}) (errno: ${L.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(A.parentPid)}catch(L){(0,T.$3)(L)}}y.send((0,d.$An)(d.MessageType.Initialized)),D({protocol:y,initData:A})});y.send((0,d.$An)(d.MessageType.Ready))})}async function w(){const y=[];process.on("unhandledRejection",(M,N)=>{y.push(N),setTimeout(()=>{const L=y.indexOf(N);L>=0&&N.catch(j=>{y.splice(L,1),(0,T.$6)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),M&&(0,T.$3)(M))})},1e3)}),process.on("rejectionHandled",M=>{const N=y.indexOf(M);N>=0&&y.splice(N,1)}),process.on("uncaughtException",function(M){(0,T.$2)(M)||(0,T.$3)(M)}),R.mark("code/extHost/willConnectToRenderer");const D=await f();R.mark("code/extHost/didConnectToRenderer");const S=await u(D);R.mark("code/extHost/didWaitForInitData");const{initData:C}=S;t(!!C.environment.extensionTestsLocationURI),C.environment.useHostProxy=g.useHostProxy!==void 0?g.useHostProxy!=="false":void 0,C.environment.skipWorkspaceStorageLock=(0,l.boolean)(g.skipWorkspaceStorageLock,!1);const A=new class{constructor(){this.pid=process.pid}exit(N){n(N)}fsExists(N){return a.Promises.exists(N)}fsRealpath(N){return(0,$.$kr)(N)}};let b=null;C.remote.authority&&g.transformURIs&&(b=(0,c.$Ss)(C.remote.authority));const v=new p.$yqc(S.protocol,C,A,b);i=M=>v.terminate(M)}w().catch(y=>console.log(y))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/a8f7d1c13f1922bd44e1bd4d709dfe6e7579c86a/core/vs/workbench/api/node/extensionHostProcess.js.map
