/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/uuid","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/marshalling","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/model","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(oe){for(var e=[],v=0,k=oe.length;v<k;v++)e[v]=Ce[oe[v]];return e};define(Ce[72],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=k,e.$$h=C,e.$_h=O;function v(A){return(T,p,a)=>{let P=null,y=null;if(typeof a.value=="function"?(P="value",y=a.value):typeof a.get=="function"&&(P="get",y=a.get),!y)throw new Error("not supported");a[P]=A(y,p)}}function k(A,T,p){let a=null,P=null;if(typeof p.value=="function"?(a="value",P=p.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(a="get",P=p.get),!P)throw new Error("not supported");const y=`$memoize$${T}`;p[a]=function(...u){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,u)}),this[y]}}function C(A,T,p){return v((a,P)=>{const y=`$debounce$${P}`,u=`$debounce$result$${P}`;return function(...E){this[u]||(this[u]=p?p():void 0),clearTimeout(this[y]),T&&(this[u]=T(this[u],...E),E=[this[u]]),this[y]=setTimeout(()=>{a.apply(this,E),this[u]=p?p():void 0},A)}})}function O(A,T,p){return v((a,P)=>{const y=`$throttle$timer$${P}`,u=`$throttle$result$${P}`,E=`$throttle$lastRun$${P}`,d=`$throttle$pending$${P}`;return function(...n){if(this[u]||(this[u]=p?p():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),T&&(this[u]=T(this[u],...n)),this[d])return;const s=this[E]+A;s<=Date.now()?(this[E]=Date.now(),a.apply(this,[this[u]]),this[u]=p?p():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[E]=Date.now(),a.apply(this,[this[u]]),this[u]=p?p():void 0},s-Date.now()))}})}});var Bn=this&&this.__createBinding||(Object.create?function(oe,e,v,k){k===void 0&&(k=v);var C=Object.getOwnPropertyDescriptor(e,v);(!C||("get"in C?!e.__esModule:C.writable||C.configurable))&&(C={enumerable:!0,get:function(){return e[v]}}),Object.defineProperty(oe,k,C)}:function(oe,e,v,k){k===void 0&&(k=v),oe[k]=e[v]}),Wn=this&&this.__setModuleDefault||(Object.create?function(oe,e){Object.defineProperty(oe,"default",{enumerable:!0,value:e})}:function(oe,e){oe.default=e}),qe=this&&this.__importStar||function(oe){if(oe&&oe.__esModule)return oe;var e={};if(oe!=null)for(var v in oe)v!=="default"&&Object.prototype.hasOwnProperty.call(oe,v)&&Bn(e,oe,v);return Wn(e,oe),e};define(Ce[135],Ie([1,0,18]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0,e.$9c=C,e.$0c=O,e.$$c=A,e.$_c=T,e.$ad=p,e.$bd=a,v=qe(v);const k=(E,d)=>E===d;e.$8c=k;function C(E=e.$8c){return(d,n)=>v.$wb(d,n,E)}function O(){return(E,d)=>JSON.stringify(E)===JSON.stringify(d)}function A(){return(E,d)=>E.equals(d)}function T(E,d,n){if(n!==void 0){const s=E;return s==null||d===void 0||d===null?d===s:n(s,d)}else{const s=E;return(o,h)=>o==null||h===void 0||h===null?h===o:s(o,h)}}function p(E,d){if(E===d)return!0;if(Array.isArray(E)&&Array.isArray(d)){if(E.length!==d.length)return!1;for(let n=0;n<E.length;n++)if(!p(E[n],d[n]))return!1;return!0}if(E&&typeof E=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(E)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const n=E,s=d,o=Object.keys(n),h=Object.keys(s),i=new Set(h);if(o.length!==h.length)return!1;for(const r of o)if(!i.has(r)||!p(n[r],s[r]))return!1;return!0}return!1}function a(E){return JSON.stringify(u(E))}let P=0;const y=new WeakMap;function u(E){if(Array.isArray(E))return E.map(u);if(E&&typeof E=="object")if(Object.getPrototypeOf(E)===Object.prototype){const d=E,n=Object.create(null);for(const s of Object.keys(d).sort())n[s]=u(d[s]);return n}else{let d=y.get(E);return d===void 0&&(d=P++,y.set(E,d)),d+"----2b76a038c20c4bcc"}return E}}),define(Ce[97],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.$6P=void 0;class v{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$6P=v,e.$7P=new v("id#")}),define(Ce[136],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Vn=A,e.$Wn=y,e.$Xn=u,e.$Yn=E,e.$Zn=d,e.$1n=n,e.$2n=s,e.$3n=o,e.$4n=h,e.$5n=i,e.$6n=r;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k||(e.SyntaxKind=k={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(t,c=!1){let l=0;const g=t.length;let m="",$=0,S=k.Unknown,D=v.None;function b(L){let G=0,W=0;for(;G<L;){const F=t.charCodeAt(l);if(F>=P._0&&F<=P._9)W=W*16+F-P._0;else if(F>=P.A&&F<=P.F)W=W*16+F-P.A+10;else if(F>=P.a&&F<=P.f)W=W*16+F-P.a+10;else break;l++,G++}return G<L&&(W=-1),W}function I(L){l=L,m="",$=0,S=k.Unknown,D=v.None}function R(){const L=l;if(t.charCodeAt(l)===P._0)l++;else for(l++;l<t.length&&a(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===P.dot)if(l++,l<t.length&&a(t.charCodeAt(l)))for(l++;l<t.length&&a(t.charCodeAt(l));)l++;else return D=v.UnexpectedEndOfNumber,t.substring(L,l);let G=l;if(l<t.length&&(t.charCodeAt(l)===P.E||t.charCodeAt(l)===P.e))if(l++,(l<t.length&&t.charCodeAt(l)===P.plus||t.charCodeAt(l)===P.minus)&&l++,l<t.length&&a(t.charCodeAt(l))){for(l++;l<t.length&&a(t.charCodeAt(l));)l++;G=l}else D=v.UnexpectedEndOfNumber;return t.substring(L,G)}function f(){let L="",G=l;for(;;){if(l>=g){L+=t.substring(G,l),D=v.UnexpectedEndOfString;break}const W=t.charCodeAt(l);if(W===P.doubleQuote){L+=t.substring(G,l),l++;break}if(W===P.backslash){if(L+=t.substring(G,l),l++,l>=g){D=v.UnexpectedEndOfString;break}switch(t.charCodeAt(l++)){case P.doubleQuote:L+='"';break;case P.backslash:L+="\\";break;case P.slash:L+="/";break;case P.b:L+="\b";break;case P.f:L+="\f";break;case P.n:L+=`
`;break;case P.r:L+="\r";break;case P.t:L+="	";break;case P.u:{const V=b(4);V>=0?L+=String.fromCharCode(V):D=v.InvalidUnicode;break}default:D=v.InvalidEscapeCharacter}G=l;continue}if(W>=0&&W<=31)if(p(W)){L+=t.substring(G,l),D=v.UnexpectedEndOfString;break}else D=v.InvalidCharacter;l++}return L}function w(){if(m="",D=v.None,$=l,l>=g)return $=g,S=k.EOF;let L=t.charCodeAt(l);if(T(L)){do l++,m+=String.fromCharCode(L),L=t.charCodeAt(l);while(T(L));return S=k.Trivia}if(p(L))return l++,m+=String.fromCharCode(L),L===P.carriageReturn&&t.charCodeAt(l)===P.lineFeed&&(l++,m+=`
`),S=k.LineBreakTrivia;switch(L){case P.openBrace:return l++,S=k.OpenBraceToken;case P.closeBrace:return l++,S=k.CloseBraceToken;case P.openBracket:return l++,S=k.OpenBracketToken;case P.closeBracket:return l++,S=k.CloseBracketToken;case P.colon:return l++,S=k.ColonToken;case P.comma:return l++,S=k.CommaToken;case P.doubleQuote:return l++,m=f(),S=k.StringLiteral;case P.slash:{const G=l-1;if(t.charCodeAt(l+1)===P.slash){for(l+=2;l<g&&!p(t.charCodeAt(l));)l++;return m=t.substring(G,l),S=k.LineCommentTrivia}if(t.charCodeAt(l+1)===P.asterisk){l+=2;const W=g-1;let F=!1;for(;l<W;){if(t.charCodeAt(l)===P.asterisk&&t.charCodeAt(l+1)===P.slash){l+=2,F=!0;break}l++}return F||(l++,D=v.UnexpectedEndOfComment),m=t.substring(G,l),S=k.BlockCommentTrivia}return m+=String.fromCharCode(L),l++,S=k.Unknown}case P.minus:if(m+=String.fromCharCode(L),l++,l===g||!a(t.charCodeAt(l)))return S=k.Unknown;case P._0:case P._1:case P._2:case P._3:case P._4:case P._5:case P._6:case P._7:case P._8:case P._9:return m+=R(),S=k.NumericLiteral;default:for(;l<g&&M(L);)l++,L=t.charCodeAt(l);if($!==l){switch(m=t.substring($,l),m){case"true":return S=k.TrueKeyword;case"false":return S=k.FalseKeyword;case"null":return S=k.NullKeyword}return S=k.Unknown}return m+=String.fromCharCode(L),l++,S=k.Unknown}}function M(L){if(T(L)||p(L))return!1;switch(L){case P.closeBrace:case P.closeBracket:case P.openBrace:case P.openBracket:case P.doubleQuote:case P.colon:case P.comma:case P.slash:return!1}return!0}function N(){let L;do L=w();while(L>=k.LineCommentTrivia&&L<=k.Trivia);return L}return{setPosition:I,getPosition:()=>l,scan:c?N:w,getToken:()=>S,getTokenValue:()=>m,getTokenOffset:()=>$,getTokenLength:()=>l-$,getTokenError:()=>D}}function T(t){return t===P.space||t===P.tab||t===P.verticalTab||t===P.formFeed||t===P.nonBreakingSpace||t===P.ogham||t>=P.enQuad&&t<=P.zeroWidthSpace||t===P.narrowNoBreakSpace||t===P.mathematicalSpace||t===P.ideographicSpace||t===P.byteOrderMark}function p(t){return t===P.lineFeed||t===P.carriageReturn||t===P.lineSeparator||t===P.paragraphSeparator}function a(t){return t>=P._0&&t<=P._9}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function y(t,c){const l=[],g=new Object;let m;const $={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function D(b,I,R,f){$.value=b,$.offset=I,$.length=R,$.type=f,$.colonOffset=void 0,m=$}try{i(t,{onObjectBegin:(b,I)=>{if(c<=b)throw g;m=void 0,S=c>b,l.push("")},onObjectProperty:(b,I,R)=>{if(c<I||(D(b,I,R,"property"),l[l.length-1]=b,c<=I+R))throw g},onObjectEnd:(b,I)=>{if(c<=b)throw g;m=void 0,l.pop()},onArrayBegin:(b,I)=>{if(c<=b)throw g;m=void 0,l.push(0)},onArrayEnd:(b,I)=>{if(c<=b)throw g;m=void 0,l.pop()},onLiteralValue:(b,I,R)=>{if(c<I||(D(b,I,R,r(b)),c<=I+R))throw g},onSeparator:(b,I,R)=>{if(c<=I)throw g;if(b===":"&&m&&m.type==="property")m.colonOffset=I,S=!1,m=void 0;else if(b===","){const f=l[l.length-1];typeof f=="number"?l[l.length-1]=f+1:(S=!0,l[l.length-1]=""),m=void 0}}})}catch(b){if(b!==g)throw b}return{path:l,previousNode:m,isAtPropertyKey:S,matches:b=>{let I=0;for(let R=0;I<b.length&&R<l.length;R++)if(b[I]===l[R]||b[I]==="*")I++;else if(b[I]!=="**")return!1;return I===b.length}}}function u(t,c=[],l=O.DEFAULT){let g=null,m=[];const $=[];function S(b){Array.isArray(m)?m.push(b):g!==null&&(m[g]=b)}return i(t,{onObjectBegin:()=>{const b={};S(b),$.push(m),m=b,g=null},onObjectProperty:b=>{g=b},onObjectEnd:()=>{m=$.pop()},onArrayBegin:()=>{const b=[];S(b),$.push(m),m=b,g=null},onArrayEnd:()=>{m=$.pop()},onLiteralValue:S,onError:(b,I,R)=>{c.push({error:b,offset:I,length:R})}},l),m[0]}function E(t,c=[],l=O.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(b){g.type==="property"&&(g.length=b-g.offset,g=g.parent)}function $(b){return g.children.push(b),b}i(t,{onObjectBegin:b=>{g=$({type:"object",offset:b,length:-1,parent:g,children:[]})},onObjectProperty:(b,I,R)=>{g=$({type:"property",offset:I,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:b,offset:I,length:R,parent:g})},onObjectEnd:(b,I)=>{g.length=b+I-g.offset,g=g.parent,m(b+I)},onArrayBegin:(b,I)=>{g=$({type:"array",offset:b,length:-1,parent:g,children:[]})},onArrayEnd:(b,I)=>{g.length=b+I-g.offset,g=g.parent,m(b+I)},onLiteralValue:(b,I,R)=>{$({type:r(b),offset:I,length:R,parent:g,value:b}),m(I+R)},onSeparator:(b,I,R)=>{g.type==="property"&&(b===":"?g.colonOffset=I:b===","&&m(I))},onError:(b,I,R)=>{c.push({error:b,offset:I,length:R})}},l);const D=g.children[0];return D&&delete D.parent,D}function d(t,c){if(!t)return;let l=t;for(const g of c)if(typeof g=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let m=!1;for(const $ of l.children)if(Array.isArray($.children)&&$.children[0].value===g){l=$.children[1],m=!0;break}if(!m)return}else{const m=g;if(l.type!=="array"||m<0||!Array.isArray(l.children)||m>=l.children.length)return;l=l.children[m]}return l}function n(t){if(!t.parent||!t.parent.children)return[];const c=n(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;c.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&c.push(l)}return c}function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const c=Object.create(null);for(const l of t.children){const g=l.children[1];g&&(c[l.children[0].value]=s(g))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,c,l=!1){return c>=t.offset&&c<t.offset+t.length||l&&c===t.offset+t.length}function h(t,c,l=!1){if(o(t,c,l)){const g=t.children;if(Array.isArray(g))for(let m=0;m<g.length&&g[m].offset<=c;m++){const $=h(g[m],c,l);if($)return $}return t}}function i(t,c,l=O.DEFAULT){const g=A(t,!1);function m(ce){return ce?()=>ce(g.getTokenOffset(),g.getTokenLength()):()=>!0}function $(ce){return ce?we=>ce(we,g.getTokenOffset(),g.getTokenLength()):()=>!0}const S=m(c.onObjectBegin),D=$(c.onObjectProperty),b=m(c.onObjectEnd),I=m(c.onArrayBegin),R=m(c.onArrayEnd),f=$(c.onLiteralValue),w=$(c.onSeparator),M=m(c.onComment),N=$(c.onError),L=l&&l.disallowComments,G=l&&l.allowTrailingComma;function W(){for(;;){const ce=g.scan();switch(g.getTokenError()){case v.InvalidUnicode:F(C.InvalidUnicode);break;case v.InvalidEscapeCharacter:F(C.InvalidEscapeCharacter);break;case v.UnexpectedEndOfNumber:F(C.UnexpectedEndOfNumber);break;case v.UnexpectedEndOfComment:L||F(C.UnexpectedEndOfComment);break;case v.UnexpectedEndOfString:F(C.UnexpectedEndOfString);break;case v.InvalidCharacter:F(C.InvalidCharacter);break}switch(ce){case k.LineCommentTrivia:case k.BlockCommentTrivia:L?F(C.InvalidCommentToken):M();break;case k.Unknown:F(C.InvalidSymbol);break;case k.Trivia:case k.LineBreakTrivia:break;default:return ce}}}function F(ce,we=[],re=[]){if(N(ce),we.length+re.length>0){let Pe=g.getToken();for(;Pe!==k.EOF;){if(we.indexOf(Pe)!==-1){W();break}else if(re.indexOf(Pe)!==-1)break;Pe=W()}}}function V(ce){const we=g.getTokenValue();return ce?f(we):D(we),W(),!0}function ae(){switch(g.getToken()){case k.NumericLiteral:{let ce=0;try{ce=JSON.parse(g.getTokenValue()),typeof ce!="number"&&(F(C.InvalidNumberFormat),ce=0)}catch{F(C.InvalidNumberFormat)}f(ce);break}case k.NullKeyword:f(null);break;case k.TrueKeyword:f(!0);break;case k.FalseKeyword:f(!1);break;default:return!1}return W(),!0}function $e(){return g.getToken()!==k.StringLiteral?(F(C.PropertyNameExpected,[],[k.CloseBraceToken,k.CommaToken]),!1):(V(!1),g.getToken()===k.ColonToken?(w(":"),W(),se()||F(C.ValueExpected,[],[k.CloseBraceToken,k.CommaToken])):F(C.ColonExpected,[],[k.CloseBraceToken,k.CommaToken]),!0)}function _(){S(),W();let ce=!1;for(;g.getToken()!==k.CloseBraceToken&&g.getToken()!==k.EOF;){if(g.getToken()===k.CommaToken){if(ce||F(C.ValueExpected,[],[]),w(","),W(),g.getToken()===k.CloseBraceToken&&G)break}else ce&&F(C.CommaExpected,[],[]);$e()||F(C.ValueExpected,[],[k.CloseBraceToken,k.CommaToken]),ce=!0}return b(),g.getToken()!==k.CloseBraceToken?F(C.CloseBraceExpected,[k.CloseBraceToken],[]):W(),!0}function ge(){I(),W();let ce=!1;for(;g.getToken()!==k.CloseBracketToken&&g.getToken()!==k.EOF;){if(g.getToken()===k.CommaToken){if(ce||F(C.ValueExpected,[],[]),w(","),W(),g.getToken()===k.CloseBracketToken&&G)break}else ce&&F(C.CommaExpected,[],[]);se()||F(C.ValueExpected,[],[k.CloseBracketToken,k.CommaToken]),ce=!0}return R(),g.getToken()!==k.CloseBracketToken?F(C.CloseBracketExpected,[k.CloseBracketToken],[]):W(),!0}function se(){switch(g.getToken()){case k.OpenBracketToken:return ge();case k.OpenBraceToken:return _();case k.StringLiteral:return V(!0);default:return ae()}}return W(),g.getToken()===k.EOF?l.allowEmptyContent?!0:(F(C.ValueExpected,[],[]),!1):se()?(g.getToken()!==k.EOF&&F(C.EndOfFileExpected,[],[]),!0):(F(C.ValueExpected,[],[]),!1)}function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(oe,e){typeof define=="function"&&define.amd?define(Ce[137],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(ue,be){for(var de=0;de<be.length;de++){var X=be[de];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(ue,X.key,X)}}function v(ue,be,de){return be&&e(ue.prototype,be),de&&e(ue,de),Object.defineProperty(ue,"prototype",{writable:!1}),ue}function k(ue,be){if(ue){if(typeof ue=="string")return C(ue,be);var de=Object.prototype.toString.call(ue).slice(8,-1);if(de==="Object"&&ue.constructor&&(de=ue.constructor.name),de==="Map"||de==="Set")return Array.from(ue);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return C(ue,be)}}function C(ue,be){(be==null||be>ue.length)&&(be=ue.length);for(var de=0,X=new Array(be);de<be;de++)X[de]=ue[de];return X}function O(ue,be){var de=typeof Symbol<"u"&&ue[Symbol.iterator]||ue["@@iterator"];if(de)return(de=de.call(ue)).next.bind(de);if(Array.isArray(ue)||(de=k(ue))||be&&ue&&typeof ue.length=="number"){de&&(ue=de);var X=0;return function(){return X>=ue.length?{done:!0}:{done:!1,value:ue[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=A();function T(ue){oe.defaults=ue}var p=/[&<>"']/,a=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(be){return u[be]};function d(ue,be){if(be){if(p.test(ue))return ue.replace(a,E)}else if(P.test(ue))return ue.replace(y,E);return ue}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(ue){return ue.replace(n,function(be,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var o=/(^|[^\[])\^/g;function h(ue,be){ue=typeof ue=="string"?ue:ue.source,be=be||"";var de={replace:function(Z,me){return me=me.source||me,me=me.replace(o,"$1"),ue=ue.replace(Z,me),de},getRegex:function(){return new RegExp(ue,be)}};return de}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(ue,be,de){if(ue){var X;try{X=decodeURIComponent(s(de)).replace(i,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}be&&!r.test(de)&&(de=$(be,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var c={},l=/^[^:]+:\/*[^/]*$/,g=/^([^:]+:)[\s\S]*$/,m=/^([^:]+:\/*[^/]*)[\s\S]*$/;function $(ue,be){c[" "+ue]||(l.test(ue)?c[" "+ue]=ue+"/":c[" "+ue]=I(ue,"/",!0)),ue=c[" "+ue];var de=ue.indexOf(":")===-1;return be.substring(0,2)==="//"?de?be:ue.replace(g,"$1")+be:be.charAt(0)==="/"?de?be:ue.replace(m,"$1")+be:ue+be}var S={exec:function(){}};function D(ue){for(var be=1,de,X;be<arguments.length;be++){de=arguments[be];for(X in de)Object.prototype.hasOwnProperty.call(de,X)&&(ue[X]=de[X])}return ue}function b(ue,be){var de=ue.replace(/\|/g,function(me,pe,Oe){for(var ze=!1,ke=pe;--ke>=0&&Oe[ke]==="\\";)ze=!ze;return ze?"|":" |"}),X=de.split(/ \|/),Z=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>be)X.splice(be);else for(;X.length<be;)X.push("");for(;Z<X.length;Z++)X[Z]=X[Z].trim().replace(/\\\|/g,"|");return X}function I(ue,be,de){var X=ue.length;if(X===0)return"";for(var Z=0;Z<X;){var me=ue.charAt(X-Z-1);if(me===be&&!de)Z++;else if(me!==be&&de)Z++;else break}return ue.slice(0,X-Z)}function R(ue,be){if(ue.indexOf(be[1])===-1)return-1;for(var de=ue.length,X=0,Z=0;Z<de;Z++)if(ue[Z]==="\\")Z++;else if(ue[Z]===be[0])X++;else if(ue[Z]===be[1]&&(X--,X<0))return Z;return-1}function f(ue){ue&&ue.sanitize&&!ue.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function w(ue,be){if(be<1)return"";for(var de="";be>1;)be&1&&(de+=ue),be>>=1,ue+=ue;return de+ue}function M(ue,be,de,X){var Z=be.href,me=be.title?d(be.title):null,pe=ue[1].replace(/\\([\[\]])/g,"$1");if(ue[0].charAt(0)!=="!"){X.state.inLink=!0;var Oe={type:"link",raw:de,href:Z,title:me,text:pe,tokens:X.inlineTokens(pe)};return X.state.inLink=!1,Oe}return{type:"image",raw:de,href:Z,title:me,text:d(pe)}}function N(ue,be){var de=ue.match(/^(\s+)(?:```)/);if(de===null)return be;var X=de[1];return be.split(`
`).map(function(Z){var me=Z.match(/^\s+/);if(me===null)return Z;var pe=me[0];return pe.length>=X.length?Z.slice(X.length):Z}).join(`
`)}var L=function(){function ue(de){this.options=de||oe.defaults}var be=ue.prototype;return be.space=function(X){var Z=this.rules.block.newline.exec(X);if(Z&&Z[0].length>0)return{type:"space",raw:Z[0]}},be.code=function(X){var Z=this.rules.block.code.exec(X);if(Z){var me=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?me:I(me,`
`)}}},be.fences=function(X){var Z=this.rules.block.fences.exec(X);if(Z){var me=Z[0],pe=N(me,Z[3]||"");return{type:"code",raw:me,lang:Z[2]?Z[2].trim():Z[2],text:pe}}},be.heading=function(X){var Z=this.rules.block.heading.exec(X);if(Z){var me=Z[2].trim();if(/#$/.test(me)){var pe=I(me,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(me=pe.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:me,tokens:this.lexer.inline(me)}}},be.hr=function(X){var Z=this.rules.block.hr.exec(X);if(Z)return{type:"hr",raw:Z[0]}},be.blockquote=function(X){var Z=this.rules.block.blockquote.exec(X);if(Z){var me=Z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Z[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},be.list=function(X){var Z=this.rules.block.list.exec(X);if(Z){var me,pe,Oe,ze,ke,Ae,Ne,j,U,K,H,ie,fe=Z[1].trim(),Re=fe.length>1,Ue={type:"list",raw:"",ordered:Re,start:Re?+fe.slice(0,-1):"",loose:!1,items:[]};fe=Re?"\\d{1,9}\\"+fe.slice(-1):"\\"+fe,this.options.pedantic&&(fe=Re?fe:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(ie=!1,!(!(Z=Ke.exec(X))||this.rules.block.hr.test(X)));){if(me=Z[0],X=X.substring(me.length),j=Z[2].split(`
`,1)[0],U=X.split(`
`,1)[0],this.options.pedantic?(ze=2,H=j.trimLeft()):(ze=Z[2].search(/[^ ]/),ze=ze>4?1:ze,H=j.slice(ze),ze+=Z[1].length),Ae=!1,!j&&/^ *$/.test(U)&&(me+=U+`
`,X=X.substring(U.length+1),ie=!0),!ie)for(var _e=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,ze-1)+"}#");X&&(K=X.split(`
`,1)[0],j=K,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(j)||et.test(j)||_e.test(j)||tt.test(X)));){if(j.search(/[^ ]/)>=ze||!j.trim())H+=`
`+j.slice(ze);else if(!Ae)H+=`
`+j;else break;!Ae&&!j.trim()&&(Ae=!0),me+=K+`
`,X=X.substring(K.length+1)}Ue.loose||(Ne?Ue.loose=!0:/\n *\n *$/.test(me)&&(Ne=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(H),pe&&(Oe=pe[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:me,task:!!pe,checked:Oe,loose:!1,text:H}),Ue.raw+=me}Ue.items[Ue.items.length-1].raw=me.trimRight(),Ue.items[Ue.items.length-1].text=H.trimRight(),Ue.raw=Ue.raw.trimRight();var rt=Ue.items.length;for(ke=0;ke<rt;ke++){this.lexer.state.top=!1,Ue.items[ke].tokens=this.lexer.blockTokens(Ue.items[ke].text,[]);var ft=Ue.items[ke].tokens.filter(function(st){return st.type==="space"}),ct=ft.every(function(st){for(var ut=st.raw.split(""),gt=0,pt=O(ut),Be;!(Be=pt()).done;){var je=Be.value;if(je===`
`&&(gt+=1),gt>1)return!0}return!1});!Ue.loose&&ft.length&&ct&&(Ue.loose=!0,Ue.items[ke].loose=!0)}return Ue}},be.html=function(X){var Z=this.rules.block.html.exec(X);if(Z){var me={type:"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:Z[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(Z[0]):d(Z[0]);me.type="paragraph",me.text=pe,me.tokens=this.lexer.inline(pe)}return me}},be.def=function(X){var Z=this.rules.block.def.exec(X);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var me=Z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:Z[0],href:Z[2],title:Z[3]}}},be.table=function(X){var Z=this.rules.block.table.exec(X);if(Z){var me={type:"table",header:b(Z[1]).map(function(Ne){return{text:Ne}}),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Z[3]&&Z[3].trim()?Z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=Z[0];var pe=me.align.length,Oe,ze,ke,Ae;for(Oe=0;Oe<pe;Oe++)/^ *-+: *$/.test(me.align[Oe])?me.align[Oe]="right":/^ *:-+: *$/.test(me.align[Oe])?me.align[Oe]="center":/^ *:-+ *$/.test(me.align[Oe])?me.align[Oe]="left":me.align[Oe]=null;for(pe=me.rows.length,Oe=0;Oe<pe;Oe++)me.rows[Oe]=b(me.rows[Oe],me.header.length).map(function(Ne){return{text:Ne}});for(pe=me.header.length,ze=0;ze<pe;ze++)me.header[ze].tokens=this.lexer.inline(me.header[ze].text);for(pe=me.rows.length,ze=0;ze<pe;ze++)for(Ae=me.rows[ze],ke=0;ke<Ae.length;ke++)Ae[ke].tokens=this.lexer.inline(Ae[ke].text);return me}}},be.lheading=function(X){var Z=this.rules.block.lheading.exec(X);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1],tokens:this.lexer.inline(Z[1])}},be.paragraph=function(X){var Z=this.rules.block.paragraph.exec(X);if(Z){var me=Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1];return{type:"paragraph",raw:Z[0],text:me,tokens:this.lexer.inline(me)}}},be.text=function(X){var Z=this.rules.block.text.exec(X);if(Z)return{type:"text",raw:Z[0],text:Z[0],tokens:this.lexer.inline(Z[0])}},be.escape=function(X){var Z=this.rules.inline.escape.exec(X);if(Z)return{type:"escape",raw:Z[0],text:d(Z[1])}},be.tag=function(X){var Z=this.rules.inline.tag.exec(X);if(Z)return!this.lexer.state.inLink&&/^<a /i.test(Z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):d(Z[0]):Z[0]}},be.link=function(X){var Z=this.rules.inline.link.exec(X);if(Z){var me=Z[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var pe=I(me.slice(0,-1),"\\");if((me.length-pe.length)%2===0)return}else{var Oe=R(Z[2],"()");if(Oe>-1){var ze=Z[0].indexOf("!")===0?5:4,ke=ze+Z[1].length+Oe;Z[2]=Z[2].substring(0,Oe),Z[0]=Z[0].substring(0,ke).trim(),Z[3]=""}}var Ae=Z[2],Ne="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);j&&(Ae=j[1],Ne=j[3])}else Ne=Z[3]?Z[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(me)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),M(Z,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Ne&&Ne.replace(this.rules.inline._escapes,"$1")},Z[0],this.lexer)}},be.reflink=function(X,Z){var me;if((me=this.rules.inline.reflink.exec(X))||(me=this.rules.inline.nolink.exec(X))){var pe=(me[2]||me[1]).replace(/\s+/g," ");if(pe=Z[pe.toLowerCase()],!pe||!pe.href){var Oe=me[0].charAt(0);return{type:"text",raw:Oe,text:Oe}}return M(me,pe,me[0],this.lexer)}},be.emStrong=function(X,Z,me){me===void 0&&(me="");var pe=this.rules.inline.emStrong.lDelim.exec(X);if(pe&&!(pe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Oe=pe[1]||pe[2]||"";if(!Oe||Oe&&(me===""||this.rules.inline.punctuation.exec(me))){var ze=pe[0].length-1,ke,Ae,Ne=ze,j=0,U=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(U.lastIndex=0,Z=Z.slice(-1*X.length+ze);(pe=U.exec(Z))!=null;)if(ke=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!ke){if(Ae=ke.length,pe[3]||pe[4]){Ne+=Ae;continue}else if((pe[5]||pe[6])&&ze%3&&!((ze+Ae)%3)){j+=Ae;continue}if(Ne-=Ae,!(Ne>0)){if(Ae=Math.min(Ae,Ae+Ne+j),Math.min(ze,Ae)%2){var K=X.slice(1,ze+pe.index+Ae);return{type:"em",raw:X.slice(0,ze+pe.index+Ae+1),text:K,tokens:this.lexer.inlineTokens(K)}}var H=X.slice(2,ze+pe.index+Ae-1);return{type:"strong",raw:X.slice(0,ze+pe.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},be.codespan=function(X){var Z=this.rules.inline.code.exec(X);if(Z){var me=Z[2].replace(/\n/g," "),pe=/[^ ]/.test(me),Oe=/^ /.test(me)&&/ $/.test(me);return pe&&Oe&&(me=me.substring(1,me.length-1)),me=d(me,!0),{type:"codespan",raw:Z[0],text:me}}},be.br=function(X){var Z=this.rules.inline.br.exec(X);if(Z)return{type:"br",raw:Z[0]}},be.del=function(X){var Z=this.rules.inline.del.exec(X);if(Z)return{type:"del",raw:Z[0],text:Z[2],tokens:this.lexer.inlineTokens(Z[2])}},be.autolink=function(X,Z){var me=this.rules.inline.autolink.exec(X);if(me){var pe,Oe;return me[2]==="@"?(pe=d(this.options.mangle?Z(me[1]):me[1]),Oe="mailto:"+pe):(pe=d(me[1]),Oe=pe),{type:"link",raw:me[0],text:pe,href:Oe,tokens:[{type:"text",raw:pe,text:pe}]}}},be.url=function(X,Z){var me;if(me=this.rules.inline.url.exec(X)){var pe,Oe;if(me[2]==="@")pe=d(this.options.mangle?Z(me[0]):me[0]),Oe="mailto:"+pe;else{var ze;do ze=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(ze!==me[0]);pe=d(me[0]),me[1]==="www."?Oe="http://"+pe:Oe=pe}return{type:"link",raw:me[0],text:pe,href:Oe,tokens:[{type:"text",raw:pe,text:pe}]}}},be.inlineText=function(X,Z){var me=this.rules.inline.text.exec(X);if(me){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):d(me[0]):me[0]:pe=d(this.options.smartypants?Z(me[0]):me[0]),{type:"text",raw:me[0],text:pe}}},ue}(),G={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:S,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};G._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,G._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,G.def=h(G.def).replace("label",G._label).replace("title",G._title).getRegex(),G.bullet=/(?:[*+-]|\d{1,9}[.)])/,G.listItemStart=h(/^( *)(bull) */).replace("bull",G.bullet).getRegex(),G.list=h(G.list).replace(/bull/g,G.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+G.def.source+")").getRegex(),G._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",G._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,G.html=h(G.html,"i").replace("comment",G._comment).replace("tag",G._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),G.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.blockquote=h(G.blockquote).replace("paragraph",G.paragraph).getRegex(),G.normal=D({},G),G.gfm=D({},G.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),G.gfm.table=h(G.gfm.table).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.gfm.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",G.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.pedantic=D({},G.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",G._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:S,paragraph:h(G.normal._paragraph).replace("hr",G.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",G.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:S,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:S,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=h(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=h(G._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=h(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=h(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=h(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=h(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=h(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=h(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=h(W.reflink).replace("label",W._label).replace("ref",G._label).getRegex(),W.nolink=h(W.nolink).replace("ref",G._label).getRegex(),W.reflinkSearch=h(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=D({},W),W.pedantic=D({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=D({},W.normal,{escape:h(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),W.gfm.url=h(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=D({},W.gfm,{br:h(W.br).replace("{2,}","*").getRegex(),text:h(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(ue){return ue.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(ue){var be="",de,X,Z=ue.length;for(de=0;de<Z;de++)X=ue.charCodeAt(de),Math.random()>.5&&(X="x"+X.toString(16)),be+="&#"+X+";";return be}var ae=function(){function ue(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||oe.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:G.normal,inline:W.normal};this.options.pedantic?(X.block=G.pedantic,X.inline=W.pedantic):this.options.gfm&&(X.block=G.gfm,this.options.breaks?X.inline=W.breaks:X.inline=W.gfm),this.tokenizer.rules=X}ue.lex=function(X,Z){var me=new ue(Z);return me.lex(X)},ue.lexInline=function(X,Z){var me=new ue(Z);return me.inlineTokens(X)};var be=ue.prototype;return be.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var Z;Z=this.inlineQueue.shift();)this.inlineTokens(Z.src,Z.tokens);return this.tokens},be.blockTokens=function(X,Z){var me=this;Z===void 0&&(Z=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Ne,j,U){return j+"    ".repeat(U.length)});for(var pe,Oe,ze,ke;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ne){return(pe=Ne.call({lexer:me},X,Z))?(X=X.substring(pe.raw.length),Z.push(pe),!0):!1}))){if(pe=this.tokenizer.space(X)){X=X.substring(pe.raw.length),pe.raw.length===1&&Z.length>0?Z[Z.length-1].raw+=`
`:Z.push(pe);continue}if(pe=this.tokenizer.code(X)){X=X.substring(pe.raw.length),Oe=Z[Z.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+pe.raw,Oe.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Z.push(pe);continue}if(pe=this.tokenizer.fences(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.heading(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.hr(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.blockquote(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.list(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.html(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.def(X)){X=X.substring(pe.raw.length),Oe=Z[Z.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+pe.raw,Oe.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.lheading(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(ze=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ne=1/0,j=X.slice(1),U=void 0;me.options.extensions.startBlock.forEach(function(K){U=K.call({lexer:this},j),typeof U=="number"&&U>=0&&(Ne=Math.min(Ne,U))}),Ne<1/0&&Ne>=0&&(ze=X.substring(0,Ne+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(ze))){Oe=Z[Z.length-1],ke&&Oe.type==="paragraph"?(Oe.raw+=`
`+pe.raw,Oe.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Z.push(pe),ke=ze.length!==X.length,X=X.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(X)){X=X.substring(pe.raw.length),Oe=Z[Z.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+pe.raw,Oe.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Z.push(pe);continue}if(X){var Ae="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,Z},be.inline=function(X,Z){return Z===void 0&&(Z=[]),this.inlineQueue.push({src:X,tokens:Z}),Z},be.inlineTokens=function(X,Z){var me=this;Z===void 0&&(Z=[]);var pe,Oe,ze,ke=X,Ae,Ne,j;if(this.tokens.links){var U=Object.keys(this.tokens.links);if(U.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)U.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ae.index)+"["+w("a",Ae[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ae.index)+"["+w("a",Ae[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ae.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Ne||(j=""),Ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(pe=H.call({lexer:me},X,Z))?(X=X.substring(pe.raw.length),Z.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.tag(X)){X=X.substring(pe.raw.length),Oe=Z[Z.length-1],Oe&&pe.type==="text"&&Oe.type==="text"?(Oe.raw+=pe.raw,Oe.text+=pe.text):Z.push(pe);continue}if(pe=this.tokenizer.link(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(pe.raw.length),Oe=Z[Z.length-1],Oe&&pe.type==="text"&&Oe.type==="text"?(Oe.raw+=pe.raw,Oe.text+=pe.text):Z.push(pe);continue}if(pe=this.tokenizer.emStrong(X,ke,j)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.codespan(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.br(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.del(X)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(pe=this.tokenizer.autolink(X,V)){X=X.substring(pe.raw.length),Z.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(X,V))){X=X.substring(pe.raw.length),Z.push(pe);continue}if(ze=X,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ie=X.slice(1),fe=void 0;me.options.extensions.startInline.forEach(function(Re){fe=Re.call({lexer:this},ie),typeof fe=="number"&&fe>=0&&(H=Math.min(H,fe))}),H<1/0&&H>=0&&(ze=X.substring(0,H+1))}(),pe=this.tokenizer.inlineText(ze,F)){X=X.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(j=pe.raw.slice(-1)),Ne=!0,Oe=Z[Z.length-1],Oe&&Oe.type==="text"?(Oe.raw+=pe.raw,Oe.text+=pe.text):Z.push(pe);continue}if(X){var K="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return Z},v(ue,null,[{key:"rules",get:function(){return{block:G,inline:W}}}]),ue}(),$e=function(){function ue(de){this.options=de||oe.defaults}var be=ue.prototype;return be.code=function(X,Z,me){var pe=(Z||"").match(/\S*/)[0];if(this.options.highlight){var Oe=this.options.highlight(X,pe);Oe!=null&&Oe!==X&&(me=!0,X=Oe)}return X=X.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+d(pe,!0)+'">'+(me?X:d(X,!0))+`</code></pre>
`:"<pre><code>"+(me?X:d(X,!0))+`</code></pre>
`},be.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},be.html=function(X){return X},be.heading=function(X,Z,me,pe){if(this.options.headerIds){var Oe=this.options.headerPrefix+pe.slug(me);return"<h"+Z+' id="'+Oe+'">'+X+"</h"+Z+`>
`}return"<h"+Z+">"+X+"</h"+Z+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(X,Z,me){var pe=Z?"ol":"ul",Oe=Z&&me!==1?' start="'+me+'"':"";return"<"+pe+Oe+`>
`+X+"</"+pe+`>
`},be.listitem=function(X){return"<li>"+X+`</li>
`},be.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(X){return"<p>"+X+`</p>
`},be.table=function(X,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+Z+`</table>
`},be.tablerow=function(X){return`<tr>
`+X+`</tr>
`},be.tablecell=function(X,Z){var me=Z.header?"th":"td",pe=Z.align?"<"+me+' align="'+Z.align+'">':"<"+me+">";return pe+X+("</"+me+`>
`)},be.strong=function(X){return"<strong>"+X+"</strong>"},be.em=function(X){return"<em>"+X+"</em>"},be.codespan=function(X){return"<code>"+X+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(X){return"<del>"+X+"</del>"},be.link=function(X,Z,me){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return me;var pe='<a href="'+d(X)+'"';return Z&&(pe+=' title="'+Z+'"'),pe+=">"+me+"</a>",pe},be.image=function(X,Z,me){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return me;var pe='<img src="'+X+'" alt="'+me+'"';return Z&&(pe+=' title="'+Z+'"'),pe+=this.options.xhtml?"/>":">",pe},be.text=function(X){return X},ue}(),_=function(){function ue(){}var be=ue.prototype;return be.strong=function(X){return X},be.em=function(X){return X},be.codespan=function(X){return X},be.del=function(X){return X},be.html=function(X){return X},be.text=function(X){return X},be.link=function(X,Z,me){return""+me},be.image=function(X,Z,me){return""+me},be.br=function(){return""},ue}(),ge=function(){function ue(){this.seen={}}var be=ue.prototype;return be.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(X,Z){var me=X,pe=0;if(this.seen.hasOwnProperty(me)){pe=this.seen[X];do pe++,me=X+"-"+pe;while(this.seen.hasOwnProperty(me))}return Z||(this.seen[X]=pe,this.seen[me]=0),me},be.slug=function(X,Z){Z===void 0&&(Z={});var me=this.serialize(X);return this.getNextSafeSlug(me,Z.dryrun)},ue}(),se=function(){function ue(de){this.options=de||oe.defaults,this.options.renderer=this.options.renderer||new $e,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new ge}ue.parse=function(X,Z){var me=new ue(Z);return me.parse(X)},ue.parseInline=function(X,Z){var me=new ue(Z);return me.parseInline(X)};var be=ue.prototype;return be.parse=function(X,Z){Z===void 0&&(Z=!0);var me="",pe,Oe,ze,ke,Ae,Ne,j,U,K,H,ie,fe,Re,Ue,Ke,_e,tt,nt,et,rt=X.length;for(pe=0;pe<rt;pe++){if(H=X[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(et=this.options.extensions.renderers[H.type].call({parser:this},H),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){me+=et||"";continue}switch(H.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(H.tokens),H.depth,s(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(U="",j="",ke=H.header.length,Oe=0;Oe<ke;Oe++)j+=this.renderer.tablecell(this.parseInline(H.header[Oe].tokens),{header:!0,align:H.align[Oe]});for(U+=this.renderer.tablerow(j),K="",ke=H.rows.length,Oe=0;Oe<ke;Oe++){for(Ne=H.rows[Oe],j="",Ae=Ne.length,ze=0;ze<Ae;ze++)j+=this.renderer.tablecell(this.parseInline(Ne[ze].tokens),{header:!1,align:H.align[ze]});K+=this.renderer.tablerow(j)}me+=this.renderer.table(U,K);continue}case"blockquote":{K=this.parse(H.tokens),me+=this.renderer.blockquote(K);continue}case"list":{for(ie=H.ordered,fe=H.start,Re=H.loose,ke=H.items.length,K="",Oe=0;Oe<ke;Oe++)Ke=H.items[Oe],_e=Ke.checked,tt=Ke.task,Ue="",Ke.task&&(nt=this.renderer.checkbox(_e),Re?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=nt+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=nt+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:nt}):Ue+=nt),Ue+=this.parse(Ke.tokens,Re),K+=this.renderer.listitem(Ue,tt,_e);me+=this.renderer.list(K,ie,fe);continue}case"html":{me+=this.renderer.html(H.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(K=H.tokens?this.parseInline(H.tokens):H.text;pe+1<rt&&X[pe+1].type==="text";)H=X[++pe],K+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);me+=Z?this.renderer.paragraph(K):K;continue}default:{var ft='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ft);return}else throw new Error(ft)}}}return me},be.parseInline=function(X,Z){Z=Z||this.renderer;var me="",pe,Oe,ze,ke=X.length;for(pe=0;pe<ke;pe++){if(Oe=X[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(ze=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Oe.type))){me+=ze||"";continue}switch(Oe.type){case"escape":{me+=Z.text(Oe.text);break}case"html":{me+=Z.html(Oe.text);break}case"link":{me+=Z.link(Oe.href,Oe.title,this.parseInline(Oe.tokens,Z));break}case"image":{me+=Z.image(Oe.href,Oe.title,Oe.text);break}case"strong":{me+=Z.strong(this.parseInline(Oe.tokens,Z));break}case"em":{me+=Z.em(this.parseInline(Oe.tokens,Z));break}case"codespan":{me+=Z.codespan(Oe.text);break}case"br":{me+=Z.br();break}case"del":{me+=Z.del(this.parseInline(Oe.tokens,Z));break}case"text":{me+=Z.text(Oe.text);break}default:{var Ae='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return me},ue}();function ce(ue,be,de){if(typeof ue>"u"||ue===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");if(typeof be=="function"&&(de=be,be=null),be=D({},ce.defaults,be||{}),f(be),de){var X=be.highlight,Z;try{Z=ae.lex(ue,be)}catch(ke){return de(ke)}var me=function(Ae){var Ne;if(!Ae)try{be.walkTokens&&ce.walkTokens(Z,be.walkTokens),Ne=se.parse(Z,be)}catch(j){Ae=j}return be.highlight=X,Ae?de(Ae):de(null,Ne)};if(!X||X.length<3||(delete be.highlight,!Z.length))return me();var pe=0;ce.walkTokens(Z,function(ke){ke.type==="code"&&(pe++,setTimeout(function(){X(ke.text,ke.lang,function(Ae,Ne){if(Ae)return me(Ae);Ne!=null&&Ne!==ke.text&&(ke.text=Ne,ke.escaped=!0),pe--,pe===0&&me()})},0))}),pe===0&&me();return}function Oe(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+d(ke.message+"",!0)+"</pre>";throw ke}try{var ze=ae.lex(ue,be);if(be.walkTokens){if(be.async)return Promise.all(ce.walkTokens(ze,be.walkTokens)).then(function(){return se.parse(ze,be)}).catch(Oe);ce.walkTokens(ze,be.walkTokens)}return se.parse(ze,be)}catch(ke){Oe(ke)}}ce.options=ce.setOptions=function(ue){return D(ce.defaults,ue),T(ce.defaults),ce},ce.getDefaults=A,ce.defaults=oe.defaults,ce.use=function(){for(var ue=arguments.length,be=new Array(ue),de=0;de<ue;de++)be[de]=arguments[de];var X=D.apply(void 0,[{}].concat(be)),Z=ce.defaults.extensions||{renderers:{},childTokens:{}},me;be.forEach(function(pe){if(pe.extensions&&(me=!0,pe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var ke=Z.renderers?Z.renderers[ze.name]:null;ke?Z.renderers[ze.name]=function(){for(var Ae=arguments.length,Ne=new Array(Ae),j=0;j<Ae;j++)Ne[j]=arguments[j];var U=ze.renderer.apply(this,Ne);return U===!1&&(U=ke.apply(this,Ne)),U}:Z.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Z[ze.level]?Z[ze.level].unshift(ze.tokenizer):Z[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?Z.startBlock?Z.startBlock.push(ze.start):Z.startBlock=[ze.start]:ze.level==="inline"&&(Z.startInline?Z.startInline.push(ze.start):Z.startInline=[ze.start]))}ze.childTokens&&(Z.childTokens[ze.name]=ze.childTokens)})),pe.renderer&&function(){var ze=ce.defaults.renderer||new $e,ke=function(j){var U=ze[j];ze[j]=function(){for(var K=arguments.length,H=new Array(K),ie=0;ie<K;ie++)H[ie]=arguments[ie];var fe=pe.renderer[j].apply(ze,H);return fe===!1&&(fe=U.apply(ze,H)),fe}};for(var Ae in pe.renderer)ke(Ae);X.renderer=ze}(),pe.tokenizer&&function(){var ze=ce.defaults.tokenizer||new L,ke=function(j){var U=ze[j];ze[j]=function(){for(var K=arguments.length,H=new Array(K),ie=0;ie<K;ie++)H[ie]=arguments[ie];var fe=pe.tokenizer[j].apply(ze,H);return fe===!1&&(fe=U.apply(ze,H)),fe}};for(var Ae in pe.tokenizer)ke(Ae);X.tokenizer=ze}(),pe.walkTokens){var Oe=ce.defaults.walkTokens;X.walkTokens=function(ze){var ke=[];return ke.push(pe.walkTokens.call(this,ze)),Oe&&(ke=ke.concat(Oe.call(this,ze))),ke}}me&&(X.extensions=Z),ce.setOptions(X)})},ce.walkTokens=function(ue,be){for(var de=[],X=function(){var Oe=me.value;switch(de=de.concat(be.call(ce,Oe)),Oe.type){case"table":{for(var ze=O(Oe.header),ke;!(ke=ze()).done;){var Ae=ke.value;de=de.concat(ce.walkTokens(Ae.tokens,be))}for(var Ne=O(Oe.rows),j;!(j=Ne()).done;)for(var U=j.value,K=O(U),H;!(H=K()).done;){var ie=H.value;de=de.concat(ce.walkTokens(ie.tokens,be))}break}case"list":{de=de.concat(ce.walkTokens(Oe.items,be));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Oe.type]?ce.defaults.extensions.childTokens[Oe.type].forEach(function(fe){de=de.concat(ce.walkTokens(Oe[fe],be))}):Oe.tokens&&(de=de.concat(ce.walkTokens(Oe.tokens,be)))}},Z=O(ue),me;!(me=Z()).done;)X();return de},ce.parseInline=function(ue,be){if(typeof ue>"u"||ue===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");be=D({},ce.defaults,be||{}),f(be);try{var de=ae.lexInline(ue,be);return be.walkTokens&&ce.walkTokens(de,be.walkTokens),se.parseInline(de,be)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+d(X.message+"",!0)+"</pre>";throw X}},ce.Parser=se,ce.parser=se.parse,ce.Renderer=$e,ce.TextRenderer=_,ce.Lexer=ae,ce.lexer=ae.lex,ce.Tokenizer=L,ce.Slugger=ge,ce.parse=ce;var we=ce.options,re=ce.setOptions,Pe=ce.use,Me=ce.walkTokens,Y=ce.parseInline,q=ce,ee=se.parse,ve=ae.lex;oe.Lexer=ae,oe.Parser=se,oe.Renderer=$e,oe.Slugger=ge,oe.TextRenderer=_,oe.Tokenizer=L,oe.getDefaults=A,oe.lexer=ve,oe.marked=ce,oe.options=we,oe.parse=q,oe.parseInline=Y,oe.parser=ee,oe.setOptions=re,oe.use=Pe,oe.walkTokens=Me,Object.defineProperty(oe,"__esModule",{value:!0})}),define(Ce[138],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=v;function v(n){const s=O(n);if(s&&s.length>0)return new Uint32Array(s)}let k=0;const C=new Uint32Array(10);function O(n){if(k=0,A(n,y,p.InitialConsonant),k>0||(A(n,u,p.Vowel),k>0)||(A(n,E,p.FinalConsonant),k>0)||(A(n,d,p.CompatibilityJamo),k))return C.subarray(0,k);if(n>=44032&&n<=55203){const s=n-44032,o=s%588,h=Math.floor(s/588),i=Math.floor(o/28),r=o%28-1;if(h<y.length?A(h,y,0):p.InitialConsonant+h-p.CompatibilityJamo<d.length&&A(p.InitialConsonant+h,d,p.CompatibilityJamo),i<u.length?A(i,u,0):p.Vowel+i-p.CompatibilityJamo<d.length&&A(p.Vowel+i-p.CompatibilityJamo,d,p.CompatibilityJamo),r>=0&&(r<E.length?A(r,E,0):p.FinalConsonant+r-p.CompatibilityJamo<d.length&&A(p.FinalConsonant+r-p.CompatibilityJamo,d,p.CompatibilityJamo)),k>0)return C.subarray(0,k)}}function A(n,s,o){n>=o&&n<o+s.length&&T(s[n-o])}function T(n){n!==a.NUL&&(C[k++]=n&255,n>>8&&(C[k++]=n>>8&255),n>>16&&(C[k++]=n>>16&255))}var p;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var a;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(a||(a={}));var P;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(P||(P={}));const y=new Uint8Array([a.r,a.R,a.s,a.e,a.E,a.f,a.a,a.q,a.Q,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g]),u=new Uint16Array([a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,P.hk,P.ho,P.hl,a.y,a.n,P.nj,P.np,P.nl,a.b,a.m,P.ml,a.l]),E=new Uint16Array([a.r,a.R,P.rt,a.s,P.sw,P.sg,a.e,a.f,P.fr,P.fa,P.fq,P.ft,P.fx,P.fv,P.fg,a.a,a.q,P.qt,a.t,a.T,a.d,a.w,a.c,a.z,a.x,a.v,a.g]),d=new Uint16Array([a.r,a.R,P.rt,a.s,P.sw,P.sg,a.e,a.E,a.f,P.fr,P.fa,P.fq,P.ft,P.fx,P.fv,P.fg,a.a,a.q,a.Q,P.qt,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g,a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,P.hk,P.ho,P.hl,a.y,a.n,P.nj,P.np,P.nl,a.b,a.m,P.ml,a.l])}),define(Ce[139],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=v,e.rot=k,e.$Pm=T;function v(p,a,P){return Math.min(Math.max(p,a),P)}function k(p,a){return(a+p%a)%a}class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=C;class O{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=O;class A{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const P=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=P,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=A;function T(p,a,P,y,u,E,d,n){const s=d-P,o=n-y,h=u-P,i=E-y,r=p-P,t=a-y,c=s*s+o*o,l=s*h+o*i,g=s*r+o*t,m=h*h+i*i,$=h*r+i*t,S=1/(c*m-l*l),D=(m*g-l*$)*S,b=(c*$-l*g)*S;return D>=0&&b>=0&&D+b<1}}),define(Ce[140],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$dd=O,e.$ed=u;class v{constructor(d,n,s){this.owner=d,this.debugNameSource=n,this.referenceFn=s}getDebugName(d){return O(d,this)}}e.$cd=v;const k=new Map,C=new WeakMap;function O(E,d){const n=C.get(E);if(n)return n;const s=A(E,d);if(s){let o=k.get(s)??0;o++,k.set(s,o);const h=o===1?s:`${s}#${o}`;return C.set(E,h),h}}function A(E,d){const n=C.get(E);if(n)return n;const s=d.owner?P(d.owner)+".":"";let o;const h=d.debugNameSource;if(h!==void 0)if(typeof h=="function"){if(o=h(),o!==void 0)return s+o}else return s+h;const i=d.referenceFn;if(i!==void 0&&(o=u(i),o!==void 0))return s+o;if(d.owner!==void 0){const r=T(d.owner,E);if(r!==void 0)return s+r}}function T(E,d){for(const n in E)if(E[n]===d)return n}const p=new Map,a=new WeakMap;function P(E){const d=a.get(E);if(d)return d;const n=y(E);let s=p.get(n)??0;s++,p.set(n,s);const o=s===1?n:`${n}#${s}`;return a.set(E,o),o}function y(E){const d=E.constructor;return d?d.name:"Object"}function u(E){const d=E.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(s?s[1]:void 0)?.trim()}}),define(Ce[141],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0,e.$Ld=k,e.$Md=C;let v;function k(n){v=n}function C(){return v}class O{constructor(){this.a=0,this.d=new WeakMap}b(s){return A([T(E("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[T(" "),a(P(s.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),a(P(s.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),a(P(s.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(s,o){console.log(...this.b([p("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.c(o)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map(o=>o.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(h,i)=>(this.d.get(s).add(h),o.apply(s,[h,i]))}handleDerivedRecomputed(s,o){const h=this.d.get(s);console.log(...this.b([p("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.c(o),this.formatChanges(h),{data:[{fn:s._debugNameData.referenceFn??s._computeFn}]}])),h.clear()}handleFromEventObservableTriggered(s,o){console.log(...this.b([p("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.c(o),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(h,i)=>(this.d.get(s).add(h),o.apply(s,[h,i]))}handleAutorunTriggered(s){const o=this.d.get(s);console.log(...this.b([p("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges(o),{data:[{fn:s._debugNameData.referenceFn??s._runFn}]}])),o.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let o=s.getDebugName();o===void 0&&(o=""),console.log(...this.b([p("transaction"),a(o,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Nd=O;function A(n){const s=new Array,o=[];let h="";function i(t){if("length"in t)for(const c of t)c&&i(c);else"text"in t?(h+=`%c${t.text}`,s.push(t.style),t.data&&o.push(...t.data)):"data"in t&&o.push(...t.data)}i(n);const r=[h,...s];return r.push(...o),r}function T(n){return a(n,{color:"black"})}function p(n){return a(d(`${n}: `,10),{color:"black",bold:!0})}function a(n,s={color:"black"}){function o(i){return Object.entries(i).reduce((r,[t,c])=>`${r}${t}:${c};`,"")}const h={color:s.color};return s.strikeThrough&&(h["text-decoration"]="line-through"),s.bold&&(h["font-weight"]="bold"),{text:n,style:o(h)}}function P(n,s){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=s?`"${n}"`:`"${n.substr(0,s-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?y(n,s):u(n,s);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function y(n,s){let o="[ ",h=!0;for(const i of n){if(h||(o+=", "),o.length-5>s){o+="...";break}h=!1,o+=`${P(i,s-o.length)}`}return o+=" ]",o}function u(n,s){let o="{ ",h=!0;for(const[i,r]of Object.entries(n)){if(h||(o+=", "),o.length-5>s){o+="...";break}h=!1,o+=`${i}: ${P(r,s-o.length)}`}return o+=" }",o}function E(n,s){let o="";for(let h=1;h<=s;h++)o+=n;return o}function d(n,s){for(;n.length<s;)n+=" ";return n}}),define(Ce[142],Ie([1,0,135,140,141]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=e.$8d=e.$6d=e.$1d=e.$Zd=void 0,e.$Wd=A,e.$Xd=p,e.$Yd=P,e.$2d=E,e.$3d=n,e.$4d=s,e.$5d=o,e.$7d=i,e.$9d=t;let O;function A(l){O=l}let T;function p(l){T=l}let a;function P(l){a=l}class y{get TChange(){return null}reportChanges(){this.get()}read(g){return g?g.readObservable(this):this.get()}map(g,m){const $=m===void 0?void 0:g,S=m===void 0?g:m;return a({owner:$,debugName:()=>{const D=(0,k.$ed)(S);if(D!==void 0)return D;const I=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(S.toString());if(I)return`${this.debugName}.${I[2]}`;if(!$)return`${this.debugName} (mapped)`},debugReferenceFn:S},D=>S(this.read(D),D))}recomputeInitiallyAndOnChange(g,m){return g.add(O(this,m)),this}keepObserved(g){return g.add(T(this)),this}get a(){return this.get()}}e.$Zd=y;class u extends y{constructor(){super(...arguments),this.b=new Set}addObserver(g){const m=this.b.size;this.b.add(g),m===0&&this.c()}removeObserver(g){this.b.delete(g)&&this.b.size===0&&this.f()}c(){}f(){}}e.$1d=u;function E(l,g){const m=new h(l,g);try{l(m)}finally{m.finish()}}let d;function n(l){if(d)l(d);else{const g=new h(l,void 0);d=g;try{l(g)}finally{g.finish(),d=void 0}}}async function s(l,g){const m=new h(l,g);try{await l(m)}finally{m.finish()}}function o(l,g,m){l?g(l):E(g,m)}class h{constructor(g,m){this._fn=g,this.b=m,this.a=[],(0,C.$Md)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,k.$ed)(this._fn)}updateObserver(g,m){this.a.push({observer:g,observable:m}),g.beginUpdate(m)}finish(){const g=this.a;for(let m=0;m<g.length;m++){const{observer:$,observable:S}=g[m];$.endUpdate(S)}this.a=null,(0,C.$Md)()?.handleEndTransaction()}}e.$6d=h;function i(l,g){let m;return typeof l=="string"?m=new k.$cd(void 0,l,void 0):m=new k.$cd(l,void 0,void 0),new r(m,g,v.$8c)}class r extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(g,m,$){super(),this.e=g,this.g=$,this.d=m}get(){return this.d}set(g,m,$){if($===void 0&&this.g(this.d,g))return;let S;m||(m=S=new h(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(g),(0,C.$Md)()?.handleObservableChanged(this,{oldValue:D,newValue:g,change:$,didChange:!0,hadValue:!0});for(const b of this.b)m.updateObserver(b,this),b.handleChange(this,$)}finally{S&&S.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(g){this.d=g}}e.$8d=r;function t(l,g){let m;return typeof l=="string"?m=new k.$cd(void 0,l,void 0):m=new k.$cd(l,void 0,void 0),new c(m,g,v.$8c)}class c extends r{h(g){this.d!==g&&(this.d&&this.d.dispose(),this.d=g)}dispose(){this.d?.dispose()}}e.$0d=c}),function(){function oe(C){const O=[];typeof C=="number"&&O.push("code/timeOrigin",C);function A(p){O.push(p,Date.now())}function T(){const p=[];for(let a=0;a<O.length;a+=2)p.push({name:O[a],startTime:O[a+1]});return p}return{mark:A,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(C+A.startTime)});return O}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function v(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=v(k))}(),define(Ce[143],Ie([1,0,40]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SI=void 0;const k=Symbol("unset");class C{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||v.Iterable.empty()}insert(p,a,P){this.d(p,y=>y._value=a,P)}mutate(p,a){this.d(p,P=>P._value=a(P._value===k?void 0:P._value))}mutatePath(p,a){this.d(p,()=>{},P=>a(P))}delete(p){const a=this.c(p);if(!a)return;let P=a.length-1;const y=a[P].node._value;if(y!==k){for(this.b--,a[P].node._value=k;P>0;P--){const{node:u,part:E}=a[P];if(u.children?.size||u._value!==k)break;a[P-1].node.children.delete(E)}return y}}*deleteRecursive(p){const a=this.c(p);if(!a)return;const P=a[a.length-1].node;for(let y=a.length-1;y>0;y--){const u=a[y-1];if(u.node.children.delete(a[y].part),u.node.children.size>0||u.node._value!==k)break}for(const y of O(P))y._value!==k&&(this.b--,yield y._value)}find(p){let a=this.a;for(const P of p){const y=a.children?.get(P);if(!y)return;a=y}return a._value===k?void 0:a._value}hasKeyOrParent(p){let a=this.a;for(const P of p){const y=a.children?.get(P);if(!y)return!1;if(y._value!==k)return!0;a=y}return!1}hasKeyOrChildren(p){let a=this.a;for(const P of p){const y=a.children?.get(P);if(!y)return!1;a=y}return!0}hasKey(p){let a=this.a;for(const P of p){const y=a.children?.get(P);if(!y)return!1;a=y}return a._value!==k}c(p){const a=[{part:"",node:this.a}];let P=0;for(const y of p){const u=a[P].node.children?.get(y);if(!u)return;a.push({part:y,node:u}),P++}return a}d(p,a,P){let y=this.a;for(const d of p){if(y.children)if(y.children.has(d))y=y.children.get(d);else{const n=new A;y.children.set(d,n),y=n}else{const n=new A;y.children=new Map([[d,n]]),y=n}P?.(y)}const u=y._value===k?0:1;a(y);const E=y._value===k?0:1;this.b+=E-u}*values(){for(const{_value:p}of O(this.a))p!==k&&(yield p)}}e.$SI=C;function*O(T){const p=[T];for(;p.length>0;){const a=p.pop();if(yield a,a.children)for(const P of a.children.values())p.push(P)}}class A{constructor(){this._value=k}get value(){return this._value===k?void 0:this._value}set value(p){this._value=p===void 0?k:p}}}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var k in v)(typeof exports=="object"?exports:oe)[k]=v[k]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function v(k){if(e[k])return e[k].exports;var C=e[k]={i:k,l:!1,exports:{}};return oe[k].call(C.exports,C,C.exports,v),C.l=!0,C.exports}return v.m=oe,v.c=e,v.d=function(k,C,O){v.o(k,C)||Object.defineProperty(k,C,{enumerable:!0,get:O})},v.r=function(k){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},v.t=function(k,C){if(1&C&&(k=v(k)),8&C||4&C&&typeof k=="object"&&k&&k.__esModule)return k;var O=Object.create(null);if(v.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:k}),2&C&&typeof k!="string")for(var A in k)v.d(O,A,function(T){return k[T]}.bind(null,A));return O},v.n=function(k){var C=k&&k.__esModule?function(){return k.default}:function(){return k};return v.d(C,"a",C),C},v.o=function(k,C){return Object.prototype.hasOwnProperty.call(k,C)},v.p="",v(v.s=0)}([function(oe,e,v){(function(k){var C;e=oe.exports=Pe,C=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],p=e.src=[],a=0,P=a++;p[P]="0|[1-9]\\d*";var y=a++;p[y]="[0-9]+";var u=a++;p[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=a++;p[E]="("+p[P]+")\\.("+p[P]+")\\.("+p[P]+")";var d=a++;p[d]="("+p[y]+")\\.("+p[y]+")\\.("+p[y]+")";var n=a++;p[n]="(?:"+p[P]+"|"+p[u]+")";var s=a++;p[s]="(?:"+p[y]+"|"+p[u]+")";var o=a++;p[o]="(?:-("+p[n]+"(?:\\."+p[n]+")*))";var h=a++;p[h]="(?:-?("+p[s]+"(?:\\."+p[s]+")*))";var i=a++;p[i]="[0-9A-Za-z-]+";var r=a++;p[r]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var t=a++,c="v?"+p[E]+p[o]+"?"+p[r]+"?";p[t]="^"+c+"$";var l="[v=\\s]*"+p[d]+p[h]+"?"+p[r]+"?",g=a++;p[g]="^"+l+"$";var m=a++;p[m]="((?:<|>)?=?)";var $=a++;p[$]=p[y]+"|x|X|\\*";var S=a++;p[S]=p[P]+"|x|X|\\*";var D=a++;p[D]="[v=\\s]*("+p[S]+")(?:\\.("+p[S]+")(?:\\.("+p[S]+")(?:"+p[o]+")?"+p[r]+"?)?)?";var b=a++;p[b]="[v=\\s]*("+p[$]+")(?:\\.("+p[$]+")(?:\\.("+p[$]+")(?:"+p[h]+")?"+p[r]+"?)?)?";var I=a++;p[I]="^"+p[m]+"\\s*"+p[D]+"$";var R=a++;p[R]="^"+p[m]+"\\s*"+p[b]+"$";var f=a++;p[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=a++;p[w]="(?:~>?)";var M=a++;p[M]="(\\s*)"+p[w]+"\\s+",T[M]=new RegExp(p[M],"g");var N=a++;p[N]="^"+p[w]+p[D]+"$";var L=a++;p[L]="^"+p[w]+p[b]+"$";var G=a++;p[G]="(?:\\^)";var W=a++;p[W]="(\\s*)"+p[G]+"\\s+",T[W]=new RegExp(p[W],"g");var F=a++;p[F]="^"+p[G]+p[D]+"$";var V=a++;p[V]="^"+p[G]+p[b]+"$";var ae=a++;p[ae]="^"+p[m]+"\\s*("+l+")$|^$";var $e=a++;p[$e]="^"+p[m]+"\\s*("+c+")$|^$";var _=a++;p[_]="(\\s*)"+p[m]+"\\s*("+l+"|"+p[D]+")",T[_]=new RegExp(p[_],"g");var ge=a++;p[ge]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var se=a++;p[se]="^\\s*("+p[b]+")\\s+-\\s+("+p[b]+")\\s*$";var ce=a++;p[ce]="(<|>)?=?\\s*\\*";for(var we=0;we<35;we++)C(we,p[we]),T[we]||(T[we]=new RegExp(p[we]));function re(U,K){if(U instanceof Pe)return U;if(typeof U!="string"||U.length>O||!(K?T[g]:T[t]).test(U))return null;try{return new Pe(U,K)}catch{return null}}function Pe(U,K){if(U instanceof Pe){if(U.loose===K)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Pe))return new Pe(U,K);C("SemVer",U,K),this.loose=K;var H=U.trim().match(K?T[g]:T[t]);if(!H)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ie){if(/^[0-9]+$/.test(ie)){var fe=+ie;if(fe>=0&&fe<A)return fe}return ie}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=re,e.valid=function(U,K){var H=re(U,K);return H?H.version:null},e.clean=function(U,K){var H=re(U.trim().replace(/^[=v]+/,""),K);return H?H.version:null},e.SemVer=Pe,Pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Pe.prototype.toString=function(){return this.version},Pe.prototype.compare=function(U){return C("SemVer.compare",this.version,this.loose,U),U instanceof Pe||(U=new Pe(U,this.loose)),this.compareMain(U)||this.comparePre(U)},Pe.prototype.compareMain=function(U){return U instanceof Pe||(U=new Pe(U,this.loose)),Y(this.major,U.major)||Y(this.minor,U.minor)||Y(this.patch,U.patch)},Pe.prototype.comparePre=function(U){if(U instanceof Pe||(U=new Pe(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var K=0;do{var H=this.prerelease[K],ie=U.prerelease[K];if(C("prerelease compare",K,H,ie),H===void 0&&ie===void 0)return 0;if(ie===void 0)return 1;if(H===void 0)return-1;if(H!==ie)return Y(H,ie)}while(++K)},Pe.prototype.inc=function(U,K){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,K,H,ie){typeof H=="string"&&(ie=H,H=void 0);try{return new Pe(U,H).inc(K,ie).version}catch{return null}},e.diff=function(U,K){if(ue(U,K))return null;var H=re(U),ie=re(K);if(H.prerelease.length||ie.prerelease.length){for(var fe in H)if((fe==="major"||fe==="minor"||fe==="patch")&&H[fe]!==ie[fe])return"pre"+fe;return"prerelease"}for(var fe in H)if((fe==="major"||fe==="minor"||fe==="patch")&&H[fe]!==ie[fe])return fe},e.compareIdentifiers=Y;var Me=/^[0-9]+$/;function Y(U,K){var H=Me.test(U),ie=Me.test(K);return H&&ie&&(U=+U,K=+K),H&&!ie?-1:ie&&!H?1:U<K?-1:U>K?1:0}function q(U,K,H){return new Pe(U,H).compare(new Pe(K,H))}function ee(U,K,H){return q(U,K,H)>0}function ve(U,K,H){return q(U,K,H)<0}function ue(U,K,H){return q(U,K,H)===0}function be(U,K,H){return q(U,K,H)!==0}function de(U,K,H){return q(U,K,H)>=0}function X(U,K,H){return q(U,K,H)<=0}function Z(U,K,H,ie){var fe;switch(K){case"===":typeof U=="object"&&(U=U.version),typeof H=="object"&&(H=H.version),fe=U===H;break;case"!==":typeof U=="object"&&(U=U.version),typeof H=="object"&&(H=H.version),fe=U!==H;break;case"":case"=":case"==":fe=ue(U,H,ie);break;case"!=":fe=be(U,H,ie);break;case">":fe=ee(U,H,ie);break;case">=":fe=de(U,H,ie);break;case"<":fe=ve(U,H,ie);break;case"<=":fe=X(U,H,ie);break;default:throw new TypeError("Invalid operator: "+K)}return fe}function me(U,K){if(U instanceof me){if(U.loose===K)return U;U=U.value}if(!(this instanceof me))return new me(U,K);C("comparator",U,K),this.loose=K,this.parse(U),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(U,K){return Y(K,U)},e.major=function(U,K){return new Pe(U,K).major},e.minor=function(U,K){return new Pe(U,K).minor},e.patch=function(U,K){return new Pe(U,K).patch},e.compare=q,e.compareLoose=function(U,K){return q(U,K,!0)},e.rcompare=function(U,K,H){return q(K,U,H)},e.sort=function(U,K){return U.sort(function(H,ie){return e.compare(H,ie,K)})},e.rsort=function(U,K){return U.sort(function(H,ie){return e.rcompare(H,ie,K)})},e.gt=ee,e.lt=ve,e.eq=ue,e.neq=be,e.gte=de,e.lte=X,e.cmp=Z,e.Comparator=me;var pe={};function Oe(U,K){if(U instanceof Oe)return U.loose===K?U:new Oe(U.raw,K);if(U instanceof me)return new Oe(U.value,K);if(!(this instanceof Oe))return new Oe(U,K);if(this.loose=K,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function ze(U){return!U||U.toLowerCase()==="x"||U==="*"}function ke(U,K,H,ie,fe,Re,Ue,Ke,_e,tt,nt,et,rt){return((K=ze(H)?"":ze(ie)?">="+H+".0.0":ze(fe)?">="+H+"."+ie+".0":">="+K)+" "+(Ke=ze(_e)?"":ze(tt)?"<"+(+_e+1)+".0.0":ze(nt)?"<"+_e+"."+(+tt+1)+".0":et?"<="+_e+"."+tt+"."+nt+"-"+et:"<="+Ke)).trim()}function Ae(U,K){for(var H=0;H<U.length;H++)if(!U[H].test(K))return!1;if(K.prerelease.length){for(H=0;H<U.length;H++)if(C(U[H].semver),U[H].semver!==pe&&U[H].semver.prerelease.length>0){var ie=U[H].semver;if(ie.major===K.major&&ie.minor===K.minor&&ie.patch===K.patch)return!0}return!1}return!0}function Ne(U,K,H){try{K=new Oe(K,H)}catch{return!1}return K.test(U)}function j(U,K,H,ie){var fe,Re,Ue,Ke,_e;switch(U=new Pe(U,ie),K=new Oe(K,ie),H){case">":fe=ee,Re=X,Ue=ve,Ke=">",_e=">=";break;case"<":fe=ve,Re=de,Ue=ee,Ke="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(U,K,ie))return!1;for(var tt=0;tt<K.set.length;++tt){var nt=K.set[tt],et=null,rt=null;if(nt.forEach(function(ft){ft.semver===pe&&(ft=new me(">=0.0.0")),et=et||ft,rt=rt||ft,fe(ft.semver,et.semver,ie)?et=ft:Ue(ft.semver,rt.semver,ie)&&(rt=ft)}),et.operator===Ke||et.operator===_e||(!rt.operator||rt.operator===Ke)&&Re(U,rt.semver)||rt.operator===_e&&Ue(U,rt.semver))return!1}return!0}me.prototype.parse=function(U){var K=this.loose?T[ae]:T[$e],H=U.match(K);if(!H)throw new TypeError("Invalid comparator: "+U);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Pe(H[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(U){return C("Comparator.test",U,this.loose),this.semver===pe||(typeof U=="string"&&(U=new Pe(U,this.loose)),Z(U,this.operator,this.semver,this.loose))},me.prototype.intersects=function(U,K){if(!(U instanceof me))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Oe(U.value,K),Ne(this.value,H,K);if(U.operator==="")return H=new Oe(this.value,K),Ne(U.semver,H,K);var ie=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),fe=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),Re=this.semver.version===U.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Ke=Z(this.semver,"<",U.semver,K)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),_e=Z(this.semver,">",U.semver,K)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return ie||fe||Re&&Ue||Ke||_e},e.Range=Oe,Oe.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},Oe.prototype.toString=function(){return this.range},Oe.prototype.parseRange=function(U){var K=this.loose;U=U.trim(),C("range",U,K);var H=K?T[se]:T[ge];U=U.replace(H,ke),C("hyphen replace",U),U=U.replace(T[_],"$1$2$3"),C("comparator trim",U,T[_]),U=(U=(U=U.replace(T[M],"$1~")).replace(T[W],"$1^")).split(/\s+/).join(" ");var ie=K?T[ae]:T[$e],fe=U.split(" ").map(function(Re){return function(Ue,Ke){return C("comp",Ue),Ue=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){C("caret",et,rt);var ft=rt?T[V]:T[F];return et.replace(ft,function(ct,st,ut,gt,pt){var Be;return C("caret",et,ct,st,ut,gt,pt),ze(st)?Be="":ze(ut)?Be=">="+st+".0.0 <"+(+st+1)+".0.0":ze(gt)?Be=st==="0"?">="+st+"."+ut+".0 <"+st+"."+(+ut+1)+".0":">="+st+"."+ut+".0 <"+(+st+1)+".0.0":pt?(C("replaceCaret pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),Be=st==="0"?ut==="0"?">="+st+"."+ut+"."+gt+pt+" <"+st+"."+ut+"."+(+gt+1):">="+st+"."+ut+"."+gt+pt+" <"+st+"."+(+ut+1)+".0":">="+st+"."+ut+"."+gt+pt+" <"+(+st+1)+".0.0"):(C("no pr"),Be=st==="0"?ut==="0"?">="+st+"."+ut+"."+gt+" <"+st+"."+ut+"."+(+gt+1):">="+st+"."+ut+"."+gt+" <"+st+"."+(+ut+1)+".0":">="+st+"."+ut+"."+gt+" <"+(+st+1)+".0.0"),C("caret return",Be),Be})}(nt,tt)}).join(" ")}(Ue,Ke),C("caret",Ue),Ue=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){var ft=rt?T[L]:T[N];return et.replace(ft,function(ct,st,ut,gt,pt){var Be;return C("tilde",et,ct,st,ut,gt,pt),ze(st)?Be="":ze(ut)?Be=">="+st+".0.0 <"+(+st+1)+".0.0":ze(gt)?Be=">="+st+"."+ut+".0 <"+st+"."+(+ut+1)+".0":pt?(C("replaceTilde pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),Be=">="+st+"."+ut+"."+gt+pt+" <"+st+"."+(+ut+1)+".0"):Be=">="+st+"."+ut+"."+gt+" <"+st+"."+(+ut+1)+".0",C("tilde return",Be),Be})}(nt,tt)}).join(" ")}(Ue,Ke),C("tildes",Ue),Ue=function(_e,tt){return C("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(nt){return function(et,rt){et=et.trim();var ft=rt?T[R]:T[I];return et.replace(ft,function(ct,st,ut,gt,pt,Be){C("xRange",et,ct,st,ut,gt,pt,Be);var je=ze(ut),Q=je||ze(gt),x=Q||ze(pt);return st==="="&&x&&(st=""),je?ct=st===">"||st==="<"?"<0.0.0":"*":st&&x?(Q&&(gt=0),x&&(pt=0),st===">"?(st=">=",Q?(ut=+ut+1,gt=0,pt=0):x&&(gt=+gt+1,pt=0)):st==="<="&&(st="<",Q?ut=+ut+1:gt=+gt+1),ct=st+ut+"."+gt+"."+pt):Q?ct=">="+ut+".0.0 <"+(+ut+1)+".0.0":x&&(ct=">="+ut+"."+gt+".0 <"+ut+"."+(+gt+1)+".0"),C("xRange return",ct),ct})}(nt,tt)}).join(" ")}(Ue,Ke),C("xrange",Ue),Ue=function(_e,tt){return C("replaceStars",_e,tt),_e.trim().replace(T[ce],"")}(Ue,Ke),C("stars",Ue),Ue}(Re,K)}).join(" ").split(/\s+/);return this.loose&&(fe=fe.filter(function(Re){return!!Re.match(ie)})),fe=fe.map(function(Re){return new me(Re,K)})},Oe.prototype.intersects=function(U,K){if(!(U instanceof Oe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ie){return U.set.some(function(fe){return fe.every(function(Re){return ie.intersects(Re,K)})})})})},e.toComparators=function(U,K){return new Oe(U,K).set.map(function(H){return H.map(function(ie){return ie.value}).join(" ").trim().split(" ")})},Oe.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new Pe(U,this.loose));for(var K=0;K<this.set.length;K++)if(Ae(this.set[K],U))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(U,K,H){var ie=null,fe=null;try{var Re=new Oe(K,H)}catch{return null}return U.forEach(function(Ue){Re.test(Ue)&&(ie&&fe.compare(Ue)!==-1||(fe=new Pe(ie=Ue,H)))}),ie},e.minSatisfying=function(U,K,H){var ie=null,fe=null;try{var Re=new Oe(K,H)}catch{return null}return U.forEach(function(Ue){Re.test(Ue)&&(ie&&fe.compare(Ue)!==1||(fe=new Pe(ie=Ue,H)))}),ie},e.validRange=function(U,K){try{return new Oe(U,K).range||"*"}catch{return null}},e.ltr=function(U,K,H){return j(U,K,"<",H)},e.gtr=function(U,K,H){return j(U,K,">",H)},e.outside=j,e.prerelease=function(U,K){var H=re(U,K);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(U,K,H){return U=new Oe(U,H),K=new Oe(K,H),U.intersects(K)},e.coerce=function(U){if(U instanceof Pe)return U;if(typeof U!="string")return null;var K=U.match(T[f]);return K==null?null:re((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,v(1))},function(oe,e){var v,k,C=oe.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function T(s){if(v===setTimeout)return setTimeout(s,0);if((v===O||!v)&&setTimeout)return v=setTimeout,setTimeout(s,0);try{return v(s,0)}catch{try{return v.call(null,s,0)}catch{return v.call(this,s,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:O}catch{v=O}try{k=typeof clearTimeout=="function"?clearTimeout:A}catch{k=A}})();var p,a=[],P=!1,y=-1;function u(){P&&p&&(P=!1,p.length?a=p.concat(a):y=-1,a.length&&E())}function E(){if(!P){var s=T(u);P=!0;for(var o=a.length;o;){for(p=a,a=[];++y<o;)p&&p[y].run();y=-1,o=a.length}p=null,P=!1,function(h){if(k===clearTimeout)return clearTimeout(h);if((k===A||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(h);try{k(h)}catch{try{return k.call(null,h)}catch{return k.call(this,h)}}}(s)}}function d(s,o){this.fun=s,this.array=o}function n(){}C.nextTick=function(s){var o=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)o[h-1]=arguments[h];a.push(new d(s,o)),a.length!==1||P||T(E)},d.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=n,C.addListener=n,C.once=n,C.off=n,C.removeListener=n,C.removeAllListeners=n,C.emit=n,C.prependListener=n,C.prependOnceListener=n,C.listeners=function(s){return[]},C.binding=function(s){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(s){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ce[144],Ie([1,0,6,4]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=e.$bt=e.$at=e.ScrollbarVisibility=void 0;var C;(function(E){E[E.Auto=1]="Auto",E[E.Hidden=2]="Hidden",E[E.Visible=3]="Visible"})(C||(e.ScrollbarVisibility=C={}));class O{constructor(d,n,s,o,h,i,r){this.c=d,this._scrollStateBrand=void 0,this.c&&(n=n|0,s=s|0,o=o|0,h=h|0,i=i|0,r=r|0),this.rawScrollLeft=o,this.rawScrollTop=r,n<0&&(n=0),o+n>s&&(o=s-n),o<0&&(o=0),h<0&&(h=0),r+h>i&&(r=i-h),r<0&&(r=0),this.width=n,this.scrollWidth=s,this.scrollLeft=o,this.height=h,this.scrollHeight=i,this.scrollTop=r}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,n){return new O(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new O(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,n){const s=this.width!==d.width,o=this.scrollWidth!==d.scrollWidth,h=this.scrollLeft!==d.scrollLeft,i=this.height!==d.height,r=this.scrollHeight!==d.scrollHeight,t=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:n,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:s,scrollWidthChanged:o,scrollLeftChanged:h,heightChanged:i,scrollHeightChanged:r,scrollTopChanged:t}}}e.$at=O;class A extends k.$Wc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$me),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new O(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,n){const s=this.g.withScrollDimensions(d,n);this.n(s,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const n=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(d,n){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const s=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===s.scrollLeft&&this.h.to.scrollTop===s.scrollTop)return;let o;n?o=new P(this.h.from,s,this.h.startTime,this.h.duration):o=this.h.combine(this.g,s,this.c),this.h.dispose(),this.h=o}else{const s=this.g.withScrollPosition(d);this.h=P.start(this.g,s,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),n=this.g.withScrollPosition(d);if(this.n(n,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,n){const s=this.g;s.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(s,n)))}}e.$bt=A;class T{constructor(d,n,s){this.scrollLeft=d,this.scrollTop=n,this.isDone=s}}e.$ct=T;function p(E,d){const n=d-E;return function(s){return E+n*u(s)}}function a(E,d,n){return function(s){return s<n?E(s/n):d((s-n)/(1-n))}}class P{constructor(d,n,s,o){this.from=d,this.to=n,this.duration=o,this.startTime=s,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,n,s){if(Math.abs(d-n)>2.5*s){let h,i;return d<n?(h=d+.75*s,i=n-.75*s):(h=d-.75*s,i=n+.75*s),a(p(d,h),p(i,n),.33)}return p(d,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const n=(d-this.startTime)/this.duration;if(n<1){const s=this.c(n),o=this.d(n);return new T(s,o,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,n,s){return P.start(d,n,s)}static start(d,n,s){s=s+10;const o=Date.now()-10;return new P(d,n,o,s)}}e.$dt=P;function y(E){return Math.pow(E,3)}function u(E){return 1-y(1-E)}}),define(Ce[145],Ie([1,0,14,4]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=C,e.$Ae=O,e.$Be=A,e.$Ce=T,e.$De=a,e.$Ee=P,e.$Fe=y,e.$Ge=u,e.$He=E,e.$Ie=d,e.$Je=n,e.$Ke=s,e.$Le=o,e.$Me=h,e.$Ne=i;function C(r){const t=r;return t?typeof t.read=="function":!1}function O(r){const t=r;return t?[t.on,t.pause,t.resume,t.destroy].every(c=>typeof c=="function"):!1}function A(r){const t=r;return t?O(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function T(r,t){return new p(r,t)}class p{constructor(t,c){this.e=t,this.f=c,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(c=>this.d.push(c))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(c=>c(t))}h(t){this.c.error.length===0?(0,v.$3)(t):this.c.error.slice(0).forEach(c=>c(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,c){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(c),this.resume();break;case"end":this.c.end.push(c),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(c),this.a.flowing&&this.k();break}}removeListener(t,c){if(this.a.destroyed)return;let l;switch(t){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const g=l.indexOf(c);g>=0&&l.splice(g,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const c=[...this.d];this.d.length=0,c.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(r,t){const c=[];let l;for(;(l=r.read())!==null;)c.push(l);return t(c)}function P(r,t,c){const l=[];let g;for(;(g=r.read())!==null&&l.length<c;)l.push(g);return g===null&&l.length>0?t(l):{read:()=>{if(l.length>0)return l.shift();if(typeof g<"u"){const m=g;return g=void 0,m}return r.read()}}}function y(r,t){return new Promise((c,l)=>{const g=[];u(r,{onData:m=>{t&&g.push(m)},onError:m=>{t?l(m):c(void 0)},onEnd:()=>{c(t?t(g):void 0)}})})}function u(r,t,c){r.on("error",l=>{c?.isCancellationRequested||t.onError(l)}),r.on("end",()=>{c?.isCancellationRequested||t.onEnd()}),r.on("data",l=>{c?.isCancellationRequested||t.onData(l)})}function E(r,t){return new Promise((c,l)=>{const g=new k.$Vc,m=[],$=b=>{if(m.push(b),m.length>t)return g.dispose(),r.pause(),c({stream:r,buffer:m,ended:!1})},S=b=>(g.dispose(),l(b)),D=()=>(g.dispose(),c({stream:r,buffer:m,ended:!0}));g.add((0,k.$Uc)(()=>r.removeListener("error",S))),r.on("error",S),g.add((0,k.$Uc)(()=>r.removeListener("end",D))),r.on("end",D),g.add((0,k.$Uc)(()=>r.removeListener("data",$))),r.on("data",$)})}function d(r,t){const c=T(t);return c.end(r),c}function n(){const r=T(()=>{throw new Error("not supported")});return r.end(),r}function s(r){let t=!1;return{read:()=>t?null:(t=!0,r)}}function o(r,t,c){const l=T(c);return u(r,{onData:g=>l.write(t.data(g)),onError:g=>l.error(t.error?t.error(g):g),onEnd:()=>l.end()}),l}function h(r,t,c){let l=!1;return{read:()=>{const g=t.read();return l?g:(l=!0,g!==null?c([r,g]):r)}}}function i(r,t,c){let l=!1;const g=T(c);return u(t,{onData:m=>l?g.write(m):(l=!0,g.write(c([r,m]))),onError:m=>g.error(m),onEnd:()=>{l||(l=!0,g.write(r)),g.end()}}),g}}),define(Ce[23],Ie([1,0,48,145]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=a,e.$Qe=P,e.$Re=y,e.$Se=u,e.$Te=E,e.$Ue=d,e.$Ve=n,e.$We=s,e.$Xe=o,e.$Ye=h,e.$Ze=i,e.$1e=r,e.$2e=t,e.$3e=c,e.$4e=l,e.$5e=g,e.$6e=m,e.$7e=$,e.$8e=S,e.$9e=I,k=qe(k);const C=typeof Buffer<"u",O=new v.$X(()=>new Uint8Array(256));let A,T;class p{static alloc(f){return C?new p(Buffer.allocUnsafe(f)):new p(new Uint8Array(f))}static wrap(f){return C&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new p(f)}static fromString(f,w){return!(w?.dontUseNodeBuffer||!1)&&C?new p(Buffer.from(f)):(A||(A=new TextEncoder),new p(A.encode(f)))}static fromByteArray(f){const w=p.alloc(f.length);for(let M=0,N=f.length;M<N;M++)w.buffer[M]=f[M];return w}static concat(f,w){if(typeof w>"u"){w=0;for(let L=0,G=f.length;L<G;L++)w+=f[L].byteLength}const M=p.alloc(w);let N=0;for(let L=0,G=f.length;L<G;L++){const W=f[L];M.set(W,N),N+=W.byteLength}return M}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=p.alloc(this.byteLength);return f.set(this),f}toString(){return C?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(f,w){return new p(this.buffer.subarray(f,w))}set(f,w){if(f instanceof p)this.buffer.set(f.buffer,w);else if(f instanceof Uint8Array)this.buffer.set(f,w);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),w);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return u(this.buffer,f)}writeUInt32BE(f,w){E(this.buffer,f,w)}readUInt32LE(f){return d(this.buffer,f)}writeUInt32LE(f,w){n(this.buffer,f,w)}readUInt8(f){return s(this.buffer,f)}writeUInt8(f,w){o(this.buffer,f,w)}indexOf(f,w=0){return a(this.buffer,f instanceof p?f.buffer:f,w)}}e.$Oe=p;function a(R,f,w=0){const M=f.byteLength,N=R.byteLength;if(M===0)return 0;if(M===1)return R.indexOf(f[0]);if(M>N-w)return-1;const L=O.value;L.fill(f.length);for(let V=0;V<f.length;V++)L[f[V]]=f.length-V-1;let G=w+f.length-1,W=G,F=-1;for(;G<N;)if(R[G]===f[W]){if(W===0){F=G;break}G--,W--}else G+=Math.max(f.length-W,L[R[G]]),W=f.length-1;return F}function P(R,f){return R[f+0]<<0>>>0|R[f+1]<<8>>>0}function y(R,f,w){R[w+0]=f&255,f=f>>>8,R[w+1]=f&255}function u(R,f){return R[f]*2**24+R[f+1]*2**16+R[f+2]*2**8+R[f+3]}function E(R,f,w){R[w+3]=f,f=f>>>8,R[w+2]=f,f=f>>>8,R[w+1]=f,f=f>>>8,R[w]=f}function d(R,f){return R[f+0]<<0>>>0|R[f+1]<<8>>>0|R[f+2]<<16>>>0|R[f+3]<<24>>>0}function n(R,f,w){R[w+0]=f&255,f=f>>>8,R[w+1]=f&255,f=f>>>8,R[w+2]=f&255,f=f>>>8,R[w+3]=f&255}function s(R,f){return R[f]}function o(R,f,w){R[w]=f}function h(R){return k.$De(R,f=>p.concat(f))}function i(R){return k.$Ke(R)}function r(R){return k.$Fe(R,f=>p.concat(f))}async function t(R){return R.ended?p.concat(R.buffer):p.concat([...R.buffer,await r(R.stream)])}function c(R){return k.$Ie(R,f=>p.concat(f))}function l(R){return k.$Le(R,{data:f=>typeof f=="string"?p.fromString(f):p.wrap(f)},f=>p.concat(f))}function g(R){return k.$Ce(f=>p.concat(f),R)}function m(R,f){return k.$Me(R,f,w=>p.concat(w))}function $(R,f){return k.$Ne(R,f,w=>p.concat(w))}function S(R){let f=0,w=0,M=0;const N=new Uint8Array(Math.floor(R.length/4*3)),L=W=>{switch(w){case 3:N[M++]=f|W,w=0;break;case 2:N[M++]=f|W>>>2,f=W<<6,w=3;break;case 1:N[M++]=f|W>>>4,f=W<<4,w=2;break;default:f=W<<2,w=1}};for(let W=0;W<R.length;W++){const F=R.charCodeAt(W);if(F>=65&&F<=90)L(F-65);else if(F>=97&&F<=122)L(F-97+26);else if(F>=48&&F<=57)L(F-48+52);else if(F===43||F===45)L(62);else if(F===47||F===95)L(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${R[W]}`)}}const G=M;for(;w>0;)L(0);return p.wrap(N).slice(0,G)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:R},f=!0,w=!1){const M=w?b:D;let N="";const L=R.byteLength%3;let G=0;for(;G<R.byteLength-L;G+=3){const W=R[G+0],F=R[G+1],V=R[G+2];N+=M[W>>>2],N+=M[(W<<4|F>>>4)&63],N+=M[(F<<2|V>>>6)&63],N+=M[V&63]}if(L===1){const W=R[G+0];N+=M[W>>>2],N+=M[W<<4&63],f&&(N+="==")}else if(L===2){const W=R[G+0],F=R[G+1];N+=M[W>>>2],N+=M[(W<<4|F>>>4)&63],N+=M[F<<2&63],f&&(N+="=")}return N}}),define(Ce[146],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(Ce[35],Ie([1,0,98]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$6j=C;var k;(function(A){function T(p){return p&&typeof p=="object"&&typeof p.id=="string"}A.isThemeColor=T})(k||(e.ThemeColor=k={}));function C(A){return{id:A}}var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function p(h){const i=T.exec(h.id);if(!i)return p(v.$5j.error);const[,r,t]=i,c=["codicon","codicon-"+r];return t&&c.push("codicon-modifier-"+t.substring(1)),c}A.asClassNameArray=p;function a(h){return p(h).join(" ")}A.asClassName=a;function P(h){return"."+p(h).join(".")}A.asCSSSelector=P;function y(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||k.isThemeColor(h.color))}A.isThemeIcon=y;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function E(h){const i=u.exec(h);if(!i)return;const[,r]=i;return{id:r}}A.fromString=E;function d(h){return{id:h}}A.fromId=d;function n(h,i){let r=h.id;const t=r.lastIndexOf("~");return t!==-1&&(r=r.substring(0,t)),i&&(r=`${r}~${i}`),{id:r}}A.modify=n;function s(h){const i=h.id.lastIndexOf("~");if(i!==-1)return h.id.substring(i+1)}A.getModifier=s;function o(h,i){return h.id===i.id&&h.color?.id===i.color?.id}A.isEqual=o})(O||(e.ThemeIcon=O={}))}),define(Ce[147],Ie([1,0,28,29,138,13]),function(oe,e,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.FuzzyScore=e.$Hk=e.$Gk=void 0,e.or=A,e.$Ik=p,e.$Jk=a,e.$Kk=u,e.$Lk=D,e.$Mk=b,e.$Nk=N,e.$Ok=L,e.$Pk=G,e.$Qk=W,e.$Rk=ee,e.$Tk=de,e.$Uk=me,e.$Vk=pe,O=qe(O);function A(...ke){return function(Ae,Ne){for(let j=0,U=ke.length;j<U;j++){const K=ke[j](Ae,Ne);if(K)return K}return null}}e.$Gk=T.bind(void 0,!1),e.$Hk=T.bind(void 0,!0);function T(ke,Ae,Ne){if(!Ne||Ne.length<Ae.length)return null;let j;return ke?j=O.$Hf(Ne,Ae):j=Ne.indexOf(Ae)===0,j?Ae.length>0?[{start:0,end:Ae.length}]:[]:null}function p(ke,Ae){const Ne=Ae.toLowerCase().indexOf(ke.toLowerCase());return Ne===-1?null:[{start:Ne,end:Ne+ke.length}]}function a(ke,Ae){return P(ke.toLowerCase(),Ae.toLowerCase(),0,0)}function P(ke,Ae,Ne,j){if(Ne===ke.length)return[];if(j===Ae.length)return null;if(ke[Ne]===Ae[j]){let U=null;return(U=P(ke,Ae,Ne+1,j+1))?t({start:j,end:j+1},U):null}return P(ke,Ae,Ne,j+1)}function y(ke){return v.CharCode.a<=ke&&ke<=v.CharCode.z}function u(ke){return v.CharCode.A<=ke&&ke<=v.CharCode.Z}function E(ke){return v.CharCode.Digit0<=ke&&ke<=v.CharCode.Digit9}function d(ke){return ke===v.CharCode.Space||ke===v.CharCode.Tab||ke===v.CharCode.LineFeed||ke===v.CharCode.CarriageReturn}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>n.add(ke.charCodeAt(0)));function s(ke){return d(ke)||n.has(ke)}function o(ke,Ae){return ke===Ae||s(ke)&&s(Ae)}const h=new Map;function i(ke){if(h.has(ke))return h.get(ke);let Ae;const Ne=(0,C.$Ek)(ke);return Ne&&(Ae=Ne),h.set(ke,Ae),Ae}function r(ke){return y(ke)||u(ke)||E(ke)}function t(ke,Ae){return Ae.length===0?Ae=[ke]:ke.end===Ae[0].start?Ae[0].start=ke.start:Ae.unshift(ke),Ae}function c(ke,Ae){for(let Ne=Ae;Ne<ke.length;Ne++){const j=ke.charCodeAt(Ne);if(u(j)||E(j)||Ne>0&&!r(ke.charCodeAt(Ne-1)))return Ne}return ke.length}function l(ke,Ae,Ne,j){if(Ne===ke.length)return[];if(j===Ae.length)return null;if(ke[Ne]!==Ae[j].toLowerCase())return null;{let U=null,K=j+1;for(U=l(ke,Ae,Ne+1,j+1);!U&&(K=c(Ae,K))<Ae.length;)U=l(ke,Ae,Ne+1,K),K++;return U===null?null:t({start:j,end:j+1},U)}}function g(ke){let Ae=0,Ne=0,j=0,U=0,K=0;for(let Ue=0;Ue<ke.length;Ue++)K=ke.charCodeAt(Ue),u(K)&&Ae++,y(K)&&Ne++,r(K)&&j++,E(K)&&U++;const H=Ae/ke.length,ie=Ne/ke.length,fe=j/ke.length,Re=U/ke.length;return{upperPercent:H,lowerPercent:ie,alphaPercent:fe,numericPercent:Re}}function m(ke){const{upperPercent:Ae,lowerPercent:Ne}=ke;return Ne===0&&Ae>.6}function $(ke){const{upperPercent:Ae,lowerPercent:Ne,alphaPercent:j,numericPercent:U}=ke;return Ne>.2&&Ae<.8&&j>.6&&U<.2}function S(ke){let Ae=0,Ne=0,j=0,U=0;for(let K=0;K<ke.length;K++)j=ke.charCodeAt(K),u(j)&&Ae++,y(j)&&Ne++,d(j)&&U++;return(Ae===0||Ne===0)&&U===0?ke.length<=30:Ae<=5}function D(ke,Ae){if(!Ae||(Ae=Ae.trim(),Ae.length===0)||!S(ke))return null;Ae.length>60&&(Ae=Ae.substring(0,60));const Ne=g(Ae);if(!$(Ne)){if(!m(Ne))return null;Ae=Ae.toLowerCase()}let j=null,U=0;for(ke=ke.toLowerCase();U<Ae.length&&(j=l(ke,Ae,0,U))===null;)U=c(Ae,U+1);return j}function b(ke,Ae,Ne=!1){if(!Ae||Ae.length===0)return null;let j=null,U=0;for(ke=ke.toLowerCase(),Ae=Ae.toLowerCase();U<Ae.length&&(j=I(ke,Ae,0,U,Ne),j===null);)U=R(Ae,U+1);return j}function I(ke,Ae,Ne,j,U){let K=0;if(Ne===ke.length)return[];if(j===Ae.length)return null;if(!o(ke.charCodeAt(Ne),Ae.charCodeAt(j))){const fe=i(ke.charCodeAt(Ne));if(!fe)return null;for(let Re=0;Re<fe.length;Re++)if(!o(fe[Re],Ae.charCodeAt(j+Re)))return null;K+=fe.length-1}let H=null,ie=j+K+1;if(H=I(ke,Ae,Ne+1,ie,U),!U)for(;!H&&(ie=R(Ae,ie))<Ae.length;)H=I(ke,Ae,Ne+1,ie,U),ie++;if(!H)return null;if(ke.charCodeAt(Ne)!==Ae.charCodeAt(j)){const fe=i(ke.charCodeAt(Ne));if(!fe)return H;for(let Re=0;Re<fe.length;Re++)if(fe[Re]!==Ae.charCodeAt(j+Re))return H}return t({start:j,end:j+K+1},H)}function R(ke,Ae){for(let Ne=Ae;Ne<ke.length;Ne++)if(s(ke.charCodeAt(Ne))||Ne>0&&s(ke.charCodeAt(Ne-1)))return Ne;return ke.length}const f=A(e.$Hk,D,p),w=A(e.$Hk,D,a),M=new k.$Fc(1e4);function N(ke,Ae,Ne=!1){if(typeof ke!="string"||typeof Ae!="string")return null;let j=M.get(ke);j||(j=new RegExp(O.$pf(ke),"i"),M.set(ke,j));const U=j.exec(Ae);return U?[{start:U.index,end:U.index+U[0].length}]:Ne?w(ke,Ae):f(ke,Ae)}function L(ke,Ae){const Ne=de(ke,ke.toLowerCase(),0,Ae,Ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ne?W(Ne):null}function G(ke,Ae,Ne,j,U,K){const H=Math.min(13,ke.length);for(;Ne<H;Ne++){const ie=de(ke,Ae,Ne,j,U,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ie)return ie}return[0,K]}function W(ke){if(typeof ke>"u")return[];const Ae=[],Ne=ke[1];for(let j=ke.length-1;j>1;j--){const U=ke[j]+Ne,K=Ae[Ae.length-1];K&&K.end===U?K.end=U+1:Ae.push({start:U,end:U+1})}return Ae}const F=128;function V(){const ke=[],Ae=[];for(let Ne=0;Ne<=F;Ne++)Ae[Ne]=0;for(let Ne=0;Ne<=F;Ne++)ke.push(Ae.slice(0));return ke}function ae(ke){const Ae=[];for(let Ne=0;Ne<=ke;Ne++)Ae[Ne]=0;return Ae}const $e=ae(2*F),_=ae(2*F),ge=V(),se=V(),ce=V(),we=!1;function re(ke,Ae,Ne,j,U){function K(ie,fe,Re=" "){for(;ie.length<fe;)ie=Re+ie;return ie}let H=` |   |${j.split("").map(ie=>K(ie,3)).join("|")}
`;for(let ie=0;ie<=Ne;ie++)ie===0?H+=" |":H+=`${Ae[ie-1]}|`,H+=ke[ie].slice(0,U+1).map(fe=>K(fe.toString(),3)).join("|")+`
`;return H}function Pe(ke,Ae,Ne,j){ke=ke.substr(Ae),Ne=Ne.substr(j),console.log(re(se,ke,ke.length,Ne,Ne.length)),console.log(re(ce,ke,ke.length,Ne,Ne.length)),console.log(re(ge,ke,ke.length,Ne,Ne.length))}function Me(ke,Ae){if(Ae<0||Ae>=ke.length)return!1;const Ne=ke.codePointAt(Ae);switch(Ne){case v.CharCode.Underline:case v.CharCode.Dash:case v.CharCode.Period:case v.CharCode.Space:case v.CharCode.Slash:case v.CharCode.Backslash:case v.CharCode.SingleQuote:case v.CharCode.DoubleQuote:case v.CharCode.Colon:case v.CharCode.DollarSign:case v.CharCode.LessThan:case v.CharCode.GreaterThan:case v.CharCode.OpenParen:case v.CharCode.CloseParen:case v.CharCode.OpenSquareBracket:case v.CharCode.CloseSquareBracket:case v.CharCode.OpenCurlyBrace:case v.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$Zf(Ne)}}function Y(ke,Ae){if(Ae<0||Ae>=ke.length)return!1;switch(ke.charCodeAt(Ae)){case v.CharCode.Space:case v.CharCode.Tab:return!0;default:return!1}}function q(ke,Ae,Ne){return Ae[ke]!==Ne[ke]}function ee(ke,Ae,Ne,j,U,K,H=!1){for(;Ae<Ne&&U<K;)ke[Ae]===j[U]&&(H&&($e[Ae]=U),Ae+=1),U+=1;return Ae===Ne}var ve;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var ue;(function(ke){ke.Default=[-100,0];function Ae(Ne){return!Ne||Ne.length===2&&Ne[0]===-100&&Ne[1]===0}ke.isDefault=Ae})(ue||(e.FuzzyScore=ue={}));class be{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ae,Ne){this.firstMatchCanBeWeak=Ae,this.boostFullMatch=Ne}}e.$Sk=be;function de(ke,Ae,Ne,j,U,K,H=be.default){const ie=ke.length>F?F:ke.length,fe=j.length>F?F:j.length;if(Ne>=ie||K>=fe||ie-Ne>fe-K||!ee(Ae,Ne,ie,U,K,fe,!0))return;X(ie,fe,Ne,K,Ae,U);let Re=1,Ue=1,Ke=Ne,_e=K;const tt=[!1];for(Re=1,Ke=Ne;Ke<ie;Re++,Ke++){const ct=$e[Ke],st=_[Ke],ut=Ke+1<ie?_[Ke+1]:fe;for(Ue=ct-K+1,_e=ct;_e<ut;Ue++,_e++){let gt=Number.MIN_SAFE_INTEGER,pt=!1;_e<=st&&(gt=Z(ke,Ae,Ke,Ne,j,U,_e,fe,K,ge[Re-1][Ue-1]===0,tt));let Be=0;gt!==Number.MAX_SAFE_INTEGER&&(pt=!0,Be=gt+se[Re-1][Ue-1]);const je=_e>ct,Q=je?se[Re][Ue-1]+(ge[Re][Ue-1]>0?-5:0):0,x=_e>ct+1&&ge[Re][Ue-1]>0,De=x?se[Re][Ue-2]+(ge[Re][Ue-2]>0?-5:0):0;if(x&&(!je||De>=Q)&&(!pt||De>=Be))se[Re][Ue]=De,ce[Re][Ue]=ve.LeftLeft,ge[Re][Ue]=0;else if(je&&(!pt||Q>=Be))se[Re][Ue]=Q,ce[Re][Ue]=ve.Left,ge[Re][Ue]=0;else if(pt)se[Re][Ue]=Be,ce[Re][Ue]=ve.Diag,ge[Re][Ue]=ge[Re-1][Ue-1]+1;else throw new Error("not possible")}}if(we&&Pe(ke,Ne,j,K),!tt[0]&&!H.firstMatchCanBeWeak)return;Re--,Ue--;const nt=[se[Re][Ue],K];let et=0,rt=0;for(;Re>=1;){let ct=Ue;do{const st=ce[Re][ct];if(st===ve.LeftLeft)ct=ct-2;else if(st===ve.Left)ct=ct-1;else break}while(ct>=1);et>1&&Ae[Ne+Re-1]===U[K+Ue-1]&&!q(ct+K-1,j,U)&&et+1>ge[Re][ct]&&(ct=Ue),ct===Ue?et++:et=1,rt||(rt=ct),Re--,Ue=ct-1,nt.push(Ue)}fe-K===ie&&H.boostFullMatch&&(nt[0]+=2);const ft=rt-ie;return nt[0]-=ft,nt}function X(ke,Ae,Ne,j,U,K){let H=ke-1,ie=Ae-1;for(;H>=Ne&&ie>=j;)U[H]===K[ie]&&(_[H]=ie,H--),ie--}function Z(ke,Ae,Ne,j,U,K,H,ie,fe,Re,Ue){if(Ae[Ne]!==K[H])return Number.MIN_SAFE_INTEGER;let Ke=1,_e=!1;return H===Ne-j?Ke=ke[Ne]===U[H]?7:5:q(H,U,K)&&(H===0||!q(H-1,U,K))?(Ke=ke[Ne]===U[H]?7:5,_e=!0):Me(K,H)&&(H===0||!Me(K,H-1))?Ke=5:(Me(K,H-1)||Y(K,H-1))&&(Ke=5,_e=!0),Ke>1&&Ne===j&&(Ue[0]=!0),_e||(_e=q(H,U,K)||Me(K,H-1)||Y(K,H-1)),Ne===j?H>fe&&(Ke-=_e?3:5):Re?Ke+=_e?2:0:Ke+=_e?0:1,H+1===ie&&(Ke-=_e?3:5),Ke}function me(ke,Ae,Ne,j,U,K,H){return Oe(ke,Ae,Ne,j,U,K,!0,H)}function pe(ke,Ae,Ne,j,U,K,H){return Oe(ke,Ae,Ne,j,U,K,!1,H)}function Oe(ke,Ae,Ne,j,U,K,H,ie){let fe=de(ke,Ae,Ne,j,U,K,ie);if(fe&&!H)return fe;if(ke.length>=3){const Re=Math.min(7,ke.length-1);for(let Ue=Ne+1;Ue<Re;Ue++){const Ke=ze(ke,Ue);if(Ke){const _e=de(Ke,Ke.toLowerCase(),Ne,j,U,K,ie);_e&&(_e[0]-=3,(!fe||_e[0]>fe[0])&&(fe=_e))}}}return fe}function ze(ke,Ae){if(Ae+1>=ke.length)return;const Ne=ke[Ae],j=ke[Ae+1];if(Ne!==j)return ke.slice(0,Ae)+j+Ne+ke.slice(Ae+2)}}),define(Ce[99],Ie([1,0,147,13,35]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=p,e.$Xk=P,e.$Yk=u,e.$Zk=E,e.$1k=n,e.$2k=s;const O="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${A.source}`,"g");function p(o){return o.replace(T,(h,i)=>i?h:`\\${h}`)}const a=new RegExp(`\\\\${A.source}`,"g");function P(o){return o.replace(a,h=>`\\${h}`)}const y=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(o){return o.indexOf(O)===-1?o:o.replace(y,(h,i,r,t)=>r?h:i||t||"")}function E(o){return o?o.replace(/\$\((.*?)\)/g,(h,i)=>` ${i} `).trim():""}const d=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(o){d.lastIndex=0;let h="";const i=[];let r=0;for(;;){const t=d.lastIndex,c=d.exec(o),l=o.substring(t,c?.index);if(l.length>0){h+=l;for(let g=0;g<l.length;g++)i.push(r)}if(!c)break;r+=c[0].length}return{text:h,iconOffsets:i}}function s(o,h,i=!1){const{text:r,iconOffsets:t}=h;if(!t||t.length===0)return(0,v.$Nk)(o,r,i);const c=(0,k.$nf)(r," "),l=r.length-c.length,g=(0,v.$Nk)(o,c,i);if(g)for(const m of g){const $=t[m.start+l]+l;m.start+=$,m.end+=$}return g}}),define(Ce[36],Ie([1,0,13]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v=qe(v);var k;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(k||(k={})),function(C){const O="error",A="warning",T="warn",p="info",a="ignore";function P(u){return u?v.$Gf(O,u)?C.Error:v.$Gf(A,u)||v.$Gf(T,u)?C.Warning:v.$Gf(p,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=P;function y(u){switch(u){case C.Error:return O;case C.Warning:return A;case C.Info:return p;default:return a}}C.toString=y}(k||(k={})),e.default=k}),define(Ce[59],Ie([1,0,18,28,13]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class O{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const n=d.charCodeAt(0),s=this.b.charCodeAt(this.c);return n-s}value(){return this.b[this.c]}}e.$Hi=O;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===k.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,C.$Af)(d,this.b,0,d.length,this.c,this.d):(0,C.$Cf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=A;class T{constructor(d=!0,n=!0){this.f=d,this.g=n}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let n=d.length-1;n>=0;n--,this.c--){const s=this.b.charCodeAt(n);if(!(s===k.CharCode.Slash||this.f&&s===k.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const n=this.b.charCodeAt(this.e);if(n===k.CharCode.Slash||this.f&&n===k.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,C.$Af)(d,this.b,0,d.length,this.d,this.e):(0,C.$Cf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=T;var p;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(p||(p={}));class a{constructor(d,n){this.f=d,this.g=n,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new T(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(p.Path)),this.g(d)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===p.Scheme)return(0,C.$Bf)(d,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,C.$Bf)(d,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(d);if(this.d[this.e]===p.Query)return(0,C.$zf)(d,this.c.query);if(this.d[this.e]===p.Fragment)return(0,C.$zf)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Ki=a;class P{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(y||(y={}));class u{static forUris(d=()=>!1,n=()=>!1){return new u(new a(d,n))}static forPaths(d=!1){return new u(new T(void 0,!d))}static forStrings(){return new u(new O)}static forConfigKeys(){return new u(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,n){if(n){const s=n.slice(0);(0,v.$Yb)(s);for(const o of s)this.set(o,d)}else{const s=d.slice(0);(0,v.$Yb)(s);for(const o of s)this.set(o[0],o[1])}}set(d,n){const s=this.b.reset(d);let o;this.c||(this.c=new P,this.c.segment=s.value());const h=[];for(o=this.c;;){const r=s.cmp(o.segment);if(r>0)o.left||(o.left=new P,o.left.segment=s.value()),h.push([y.Left,o]),o=o.left;else if(r<0)o.right||(o.right=new P,o.right.segment=s.value()),h.push([y.Right,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new P,o.mid.segment=s.value()),h.push([y.Mid,o]),o=o.mid;else break}const i=o.value;o.value=n,o.key=d;for(let r=h.length-1;r>=0;r--){const t=h[r][1];t.updateHeight();const c=t.balanceFactor();if(c<-1||c>1){const l=h[r][0],g=h[r+1][0];if(l===y.Right&&g===y.Right)h[r][1]=t.rotateLeft();else if(l===y.Left&&g===y.Left)h[r][1]=t.rotateRight();else if(l===y.Right&&g===y.Left)t.right=h[r+1][1]=h[r+1][1].rotateRight(),h[r][1]=t.rotateLeft();else if(l===y.Left&&g===y.Right)t.left=h[r+1][1]=h[r+1][1].rotateLeft(),h[r][1]=t.rotateRight();else throw new Error;if(r>0)switch(h[r-1][0]){case y.Left:h[r-1][1].left=h[r][1];break;case y.Right:h[r-1][1].right=h[r][1];break;case y.Mid:h[r-1][1].mid=h[r][1];break}else this.c=h[0][1]}}return i}get(d){return this.d(d)?.value}d(d){const n=this.b.reset(d);let s=this.c;for(;s;){const o=n.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(n.hasNext())n.next(),s=s.mid;else break}return s}has(d){const n=this.d(d);return!(n?.value===void 0&&n?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,n){const s=this.b.reset(d),o=[];let h=this.c;for(;h;){const i=s.cmp(h.segment);if(i>0)o.push([y.Left,h]),h=h.left;else if(i<0)o.push([y.Right,h]),h=h.right;else if(s.hasNext())s.next(),o.push([y.Mid,h]),h=h.mid;else break}if(h){if(n?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const i=this.f(h.right);if(i.key){const{key:r,value:t,segment:c}=i;this.e(i.key,!1),h.key=r,h.value=t,h.segment=c}}else{const i=h.left??h.right;if(o.length>0){const[r,t]=o[o.length-1];switch(r){case y.Left:t.left=i;break;case y.Mid:t.mid=i;break;case y.Right:t.right=i;break}}else this.c=i}for(let i=o.length-1;i>=0;i--){const r=o[i][1];r.updateHeight();const t=r.balanceFactor();if(t>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),o[i][1]=r.rotateLeft()):t<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),o[i][1]=r.rotateRight()),i>0)switch(o[i-1][0]){case y.Left:o[i-1][1].left=o[i][1];break;case y.Right:o[i-1][1].right=o[i][1];break;case y.Mid:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const n=this.b.reset(d);let s=this.c,o;for(;s;){const h=n.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(n.hasNext())n.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(d){return this.g(d,!1)}g(d,n){const s=this.b.reset(d);let o=this.c;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):n?o.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[n,s]of this)d(s,n)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const n=[];return this.j(d,n),n[Symbol.iterator]()}j(d,n){d&&(d.left&&this.j(d.left,n),d.value&&n.push([d.key,d.value]),d.mid&&this.j(d.mid,n),d.right&&this.j(d.right,n))}_isBalanced(){const d=n=>{if(!n)return!0;const s=n.balanceFactor();return s<-1||s>1?!1:d(n.left)&&d(n.right)};return d(this.c)}}e.$Li=u}),define(Ce[37],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=k;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(C){return v.test(C)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(T){for(let p=0;p<T.length;p++)T[p]=Math.floor(Math.random()*256);return T};const O=new Uint8Array(16),A=[];for(let T=0;T<256;T++)A.push(T.toString(16).padStart(2,"0"));return function(){C(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let p=0,a="";return a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a+="-",a+=A[O[p++]],a+=A[O[p++]],a+="-",a+=A[O[p++]],a+=A[O[p++]],a+="-",a+=A[O[p++]],a+=A[O[p++]],a+="-",a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a}}()}),define(Ce[148],Ie([1,0,18,40,37]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pu=e.$nu=void 0,e.$lu=O,e.$mu=A,e.$ou=a;function O(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function A(y,u,E){const d={id:(0,C.$2g)(),name:y,uri:u,data:E};return{asString:async()=>"",asFile:()=>d,value:void 0}}class T{constructor(){this.a=new Map}get size(){let u=0;for(const E of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const E=[...this.a.keys()];return k.Iterable.some(this,([d,n])=>n.asFile())&&E.push("files"),P(p(u),E)}get(u){return this.a.get(this.b(u))?.[0]}append(u,E){const d=this.a.get(u);d?d.push(E):this.a.set(this.b(u),[E])}replace(u,E){this.a.set(this.b(u),[E])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,E]of this.a)for(const d of E)yield[u,d]}b(u){return p(u)}}e.$nu=T;function p(y){return y.toLowerCase()}function a(y,u){return P(p(y),u.map(p))}function P(y,u){if(y==="*/*")return u.length>0;if(u.includes(y))return!0;const E=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[d,n,s]=E;return s==="*"?u.some(o=>o.startsWith(n+"/")):!1}e.$pu=Object.freeze({create:y=>(0,v.$Ob)(y.map(u=>u.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$pu.split(y).filter(u=>!u.startsWith("#"))})}),define(Ce[149],Ie([1,0,28]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$vu=C;var k;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(k||(e.StringEOL=k={}));function C(O){let A=0,T=0,p=0,a=k.Unknown;for(let P=0,y=O.length;P<y;P++){const u=O.charCodeAt(P);u===v.CharCode.CarriageReturn?(A===0&&(T=P),A++,P+1<y&&O.charCodeAt(P+1)===v.CharCode.LineFeed?(a|=k.CRLF,P++):a|=k.Invalid,p=P+1):u===v.CharCode.LineFeed&&(a|=k.LF,A===0&&(T=P),A++,p=P+1)}return A===0&&(T=O.length),[A,T,O.length-p,a]}}),define(Ce[150],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=void 0,e.$it={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[151],Ie([1,0,28,152]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tu=e.$Su=e.IndentAction=void 0;var C;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class O{constructor(a){if(this.e=null,this.f=!1,this.open=a.open,this.close=a.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(a.notIn))for(let P=0,y=a.notIn.length;P<y;P++)switch(a.notIn[P]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(a){switch(a){case k.StandardTokenType.Other:return!0;case k.StandardTokenType.Comment:return this.c;case k.StandardTokenType.String:return this.b;case k.StandardTokenType.RegEx:return this.d}}shouldAutoClose(a,P){if(a.getTokenCount()===0)return!0;const y=a.findTokenIndexAtOffset(P-2),u=a.getStandardTokenType(y);return this.isOK(u)}g(a,P){for(let y=a;y<=P;y++){const u=String.fromCharCode(y);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(v.CharCode.Digit0,v.CharCode.Digit9)),this.e||(this.e=this.g(v.CharCode.a,v.CharCode.z)),this.e||(this.e=this.g(v.CharCode.A,v.CharCode.Z))),this.e}}e.$Su=O;class A{constructor(a){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const P of a)T(this.autoClosingPairsOpenByStart,P.open.charAt(0),P),T(this.autoClosingPairsOpenByEnd,P.open.charAt(P.open.length-1),P),T(this.autoClosingPairsCloseByStart,P.close.charAt(0),P),T(this.autoClosingPairsCloseByEnd,P.close.charAt(P.close.length-1),P),P.close.length===1&&P.open.length===1&&T(this.autoClosingPairsCloseSingleChar,P.close,P)}}e.$Tu=A;function T(p,a,P){p.has(a)?p.get(a).push(P):p.set(a,[P])}}),define(Ce[153],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=e.NodeColor=e.$3C=void 0,e.$5C=C,e.$6C=O,e.$7C=a,e.$8C=P,e.$9C=y,e.$0C=u,e.$$C=E,e.$_C=d;class v{constructor(s,o){this.piece=s,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$4C)return C(this.right);let s=this;for(;s.parent!==e.$4C&&s.parent.left!==s;)s=s.parent;return s.parent===e.$4C?e.$4C:s.parent}prev(){if(this.left!==e.$4C)return O(this.left);let s=this;for(;s.parent!==e.$4C&&s.parent.right!==s;)s=s.parent;return s.parent===e.$4C?e.$4C:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$3C=v;var k;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(k||(e.NodeColor=k={})),e.$4C=new v(null,k.Black),e.$4C.parent=e.$4C,e.$4C.left=e.$4C,e.$4C.right=e.$4C,e.$4C.color=k.Black;function C(n){for(;n.left!==e.$4C;)n=n.left;return n}function O(n){for(;n.right!==e.$4C;)n=n.right;return n}function A(n){return n===e.$4C?0:n.size_left+n.piece.length+A(n.right)}function T(n){return n===e.$4C?0:n.lf_left+n.piece.lineFeedCnt+T(n.right)}function p(){e.$4C.parent=e.$4C}function a(n,s){const o=s.right;o.size_left+=s.size_left+(s.piece?s.piece.length:0),o.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=o.left,o.left!==e.$4C&&(o.left.parent=s),o.parent=s.parent,s.parent===e.$4C?n.root=o:s.parent.left===s?s.parent.left=o:s.parent.right=o,o.left=s,s.parent=o}function P(n,s){const o=s.left;s.left=o.right,o.right!==e.$4C&&(o.right.parent=s),o.parent=s.parent,s.size_left-=o.size_left+(o.piece?o.piece.length:0),s.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),s.parent===e.$4C?n.root=o:s===s.parent.right?s.parent.right=o:s.parent.left=o,o.right=s,s.parent=o}function y(n,s){let o,h;if(s.left===e.$4C?(h=s,o=h.right):s.right===e.$4C?(h=s,o=h.left):(h=C(s.right),o=h.right),h===n.root){n.root=o,o.color=k.Black,s.detach(),p(),n.root.parent=e.$4C;return}const i=h.color===k.Red;if(h===h.parent.left?h.parent.left=o:h.parent.right=o,h===s?(o.parent=h.parent,d(n,o)):(h.parent===s?o.parent=h:o.parent=h.parent,d(n,o),h.left=s.left,h.right=s.right,h.parent=s.parent,h.color=s.color,s===n.root?n.root=h:s===s.parent.left?s.parent.left=h:s.parent.right=h,h.left!==e.$4C&&(h.left.parent=h),h.right!==e.$4C&&(h.right.parent=h),h.size_left=s.size_left,h.lf_left=s.lf_left,d(n,h)),s.detach(),o.parent.left===o){const t=A(o),c=T(o);if(t!==o.parent.size_left||c!==o.parent.lf_left){const l=t-o.parent.size_left,g=c-o.parent.lf_left;o.parent.size_left=t,o.parent.lf_left=c,E(n,o.parent,l,g)}}if(d(n,o.parent),i){p();return}let r;for(;o!==n.root&&o.color===k.Black;)o===o.parent.left?(r=o.parent.right,r.color===k.Red&&(r.color=k.Black,o.parent.color=k.Red,a(n,o.parent),r=o.parent.right),r.left.color===k.Black&&r.right.color===k.Black?(r.color=k.Red,o=o.parent):(r.right.color===k.Black&&(r.left.color=k.Black,r.color=k.Red,P(n,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=k.Black,r.right.color=k.Black,a(n,o.parent),o=n.root)):(r=o.parent.left,r.color===k.Red&&(r.color=k.Black,o.parent.color=k.Red,P(n,o.parent),r=o.parent.left),r.left.color===k.Black&&r.right.color===k.Black?(r.color=k.Red,o=o.parent):(r.left.color===k.Black&&(r.right.color=k.Black,r.color=k.Red,a(n,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=k.Black,r.left.color=k.Black,P(n,o.parent),o=n.root));o.color=k.Black,p()}function u(n,s){for(d(n,s);s!==n.root&&s.parent.color===k.Red;)if(s.parent===s.parent.parent.left){const o=s.parent.parent.right;o.color===k.Red?(s.parent.color=k.Black,o.color=k.Black,s.parent.parent.color=k.Red,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,a(n,s)),s.parent.color=k.Black,s.parent.parent.color=k.Red,P(n,s.parent.parent))}else{const o=s.parent.parent.left;o.color===k.Red?(s.parent.color=k.Black,o.color=k.Black,s.parent.parent.color=k.Red,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,P(n,s)),s.parent.color=k.Black,s.parent.parent.color=k.Red,a(n,s.parent.parent))}n.root.color=k.Black}function E(n,s,o,h){for(;s!==n.root&&s!==e.$4C;)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=h),s=s.parent}function d(n,s){let o=0,h=0;if(s!==n.root){for(;s!==n.root&&s===s.parent.right;)s=s.parent;if(s!==n.root)for(s=s.parent,o=A(s.left)-s.size_left,h=T(s.left)-s.lf_left,s.size_left+=o,s.lf_left+=h;s!==n.root&&(o!==0||h!==0);)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=h),s=s.parent}}}),define(Ce[100],Ie([1,0,28,101,33,52,153,102]),function(oe,e,v,k,C,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kD=e.$jD=e.$iD=void 0,e.$gD=y,e.$hD=u;const p=65535;function a(h){let i;return h[h.length-1]<65536?i=new Uint16Array(h.length):i=new Uint32Array(h.length),i.set(h,0),i}class P{constructor(i,r,t,c,l){this.lineStarts=i,this.cr=r,this.lf=t,this.crlf=c,this.isBasicASCII=l}}function y(h,i=!0){const r=[0];let t=1;for(let c=0,l=h.length;c<l;c++){const g=h.charCodeAt(c);g===v.CharCode.CarriageReturn?c+1<l&&h.charCodeAt(c+1)===v.CharCode.LineFeed?(r[t++]=c+2,c++):r[t++]=c+1:g===v.CharCode.LineFeed&&(r[t++]=c+1)}return i?a(r):r}function u(h,i){h.length=0,h[0]=0;let r=1,t=0,c=0,l=0,g=!0;for(let $=0,S=i.length;$<S;$++){const D=i.charCodeAt($);D===v.CharCode.CarriageReturn?$+1<S&&i.charCodeAt($+1)===v.CharCode.LineFeed?(l++,h[r++]=$+2,$++):(t++,h[r++]=$+1):D===v.CharCode.LineFeed?(c++,h[r++]=$+1):g&&D!==v.CharCode.Tab&&(D<32||D>126)&&(g=!1)}const m=new P(a(h),t,c,l,g);return h.length=0,m}class E{constructor(i,r,t,c,l){this.bufferIndex=i,this.start=r,this.end=t,this.lineFeedCnt=c,this.length=l}}e.$iD=E;class d{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$jD=d;class n{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==A.$4C&&i.iterate(i.root,t=>(t!==A.$4C&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const t=this.b;for(let c=0;c<t.length;c++){const l=t[c];if(l.node.parent===null||l.nodeStartOffset>=i){t[c]=null,r=!0;continue}}if(r){const c=[];for(const l of t)l!==null&&c.push(l);this.b=c}}}class o{constructor(i,r,t){this.create(i,r,t)}create(i,r,t){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=A.$4C,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=t;let c=null;for(let l=0,g=i.length;l<g;l++)if(i[l].buffer.length>0){i[l].lineStarts||(i[l].lineStarts=y(i[l].buffer));const m=new E(l+1,{line:0,column:0},{line:i[l].lineStarts.length-1,column:i[l].buffer.length-i[l].lineStarts[i[l].lineStarts.length-1]},i[l].lineStarts.length-1,i[l].buffer.length);this.a.push(i[l]),c=this.S(c,m)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=p,t=r-Math.floor(r/3),c=t*2;let l="",g=0;const m=[];if(this.iterate(this.root,$=>{const S=this.R($),D=S.length;if(g<=t||g+D<c)return l+=S,g+=D,!0;const b=l.replace(/\r\n|\r|\n/g,i);return m.push(new d(b,y(b))),l=S,g=D,!0}),g>0){const $=l.replace(/\r\n|\r|\n/g,i);m.push(new d($,y($)))}this.create(m,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new n(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,c=>{if(c===A.$4C)return!0;const l=this.R(c),g=l.length,m=i.G(r),$=i.G(r+g),S=i.getValueInRange2(m,$);return r+=g,l===S})}getOffsetAt(i,r){let t=0,c=this.root;for(;c!==A.$4C;)if(c.left!==A.$4C&&c.lf_left+1>=i)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt+1>=i){t+=c.size_left;const l=this.B(c,i-c.lf_left-2);return t+=l+r-1}else i-=c.lf_left+c.piece.lineFeedCnt,t+=c.size_left+c.piece.length,c=c.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,t=0;const c=i;for(;r!==A.$4C;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const l=this.A(r,i-r.size_left);if(t+=r.lf_left+l.index,l.index===0){const g=this.getOffsetAt(t+1,1),m=c-g;return new k.$Kt(t+1,m+1)}return new k.$Kt(t+1,l.remainder+1)}else if(i-=r.size_left+r.piece.length,t+=r.lf_left+r.piece.lineFeedCnt,r.right===A.$4C){const l=this.getOffsetAt(t+1,1),g=c-i-l;return new k.$Kt(t+1,g+1)}else r=r.right;return new k.$Kt(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),c=this.H(i.endLineNumber,i.endColumn),l=this.getValueInRange2(t,c);return r?r!==this.d||!this.f?l.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?l:l.replace(/\r\n|\r|\n/g,r):l}getValueInRange2(i,r){if(i.node===r.node){const m=i.node,$=this.a[m.piece.bufferIndex].buffer,S=this.u(m.piece.bufferIndex,m.piece.start);return $.substring(S+i.remainder,S+r.remainder)}let t=i.node;const c=this.a[t.piece.bufferIndex].buffer,l=this.u(t.piece.bufferIndex,t.piece.start);let g=c.substring(l+i.remainder,l+t.piece.length);for(t=t.next();t!==A.$4C;){const m=this.a[t.piece.bufferIndex].buffer,$=this.u(t.piece.bufferIndex,t.piece.start);if(t===r.node){g+=m.substring($,$+r.remainder);break}else g+=m.substr($,t.piece.length);t=t.next()}return g}getLinesContent(){const i=[];let r=0,t="",c=!1;return this.iterate(this.root,l=>{if(l===A.$4C)return!0;const g=l.piece;let m=g.length;if(m===0)return!0;const $=this.a[g.bufferIndex].buffer,S=this.a[g.bufferIndex].lineStarts,D=g.start.line,b=g.end.line;let I=S[D]+g.start.column;if(c&&($.charCodeAt(I)===v.CharCode.LineFeed&&(I++,m--),i[r++]=t,t="",c=!1,m===0))return!0;if(D===b)return!this.f&&$.charCodeAt(I+m-1)===v.CharCode.CarriageReturn?(c=!0,t+=$.substr(I,m-1)):t+=$.substr(I,m),!0;t+=this.f?$.substring(I,Math.max(I,S[D+1]-this.e)):$.substring(I,S[D+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;for(let R=D+1;R<b;R++)t=this.f?$.substring(S[R],S[R+1]-this.e):$.substring(S[R],S[R+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;return!this.f&&$.charCodeAt(S[b]+g.end.column-1)===v.CharCode.CarriageReturn?(c=!0,g.end.column===0?r--:t=$.substr(S[b],g.end.column-1)):t=$.substr(S[b],g.end.column),!0}),c&&(i[r++]=t,t=""),i[r++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const t=this.a[r.piece.bufferIndex],c=this.u(r.piece.bufferIndex,r.piece.start);return t.buffer.charCodeAt(c)}else{const r=this.a[i.node.piece.bufferIndex],c=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(c)}}getLineCharCode(i,r){const t=this.H(i,r+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}getNearestChunk(i){const r=this.G(i);if(r.remainder===r.node.piece.length){const t=r.node.next();if(!t||t===A.$4C)return"";const c=this.a[t.piece.bufferIndex],l=this.u(t.piece.bufferIndex,t.piece.start);return c.buffer.substring(l,l+t.piece.length)}else{const t=this.a[r.node.piece.bufferIndex],c=this.u(r.node.piece.bufferIndex,r.node.piece.start),l=c+r.remainder,g=c+r.node.piece.length;return t.buffer.substring(l,g)}}findMatchesInNode(i,r,t,c,l,g,m,$,S,D,b){const I=this.a[i.piece.bufferIndex],R=this.u(i.piece.bufferIndex,i.piece.start),f=this.u(i.piece.bufferIndex,l),w=this.u(i.piece.bufferIndex,g);let M;const N={line:0,column:0};let L,G;r._wordSeparators?(L=I.buffer.substring(f,w),G=W=>W+f,r.reset(0)):(L=I.buffer,G=W=>W,r.reset(f));do if(M=r.next(L),M){if(G(M.index)>=w)return D;this.s(i,G(M.index)-R,N);const W=this.t(i.piece.bufferIndex,l,N),F=N.line===l.line?N.column-l.column+c:N.column+1,V=F+M[0].length;if(b[D++]=(0,T.$cD)(new C.$Lt(t+W,F,t+W,V),M,$),G(M.index)+M[0].length>=w||D>=S)return D}while(M);return D}findMatchesLineByLine(i,r,t,c){const l=[];let g=0;const m=new T.$fD(r.wordSeparators,r.regex);let $=this.H(i.startLineNumber,i.startColumn);if($===null)return[];const S=this.H(i.endLineNumber,i.endColumn);if(S===null)return[];let D=this.s($.node,$.remainder);const b=this.s(S.node,S.remainder);if($.node===S.node)return this.findMatchesInNode($.node,m,i.startLineNumber,i.startColumn,D,b,r,t,c,g,l),l;let I=i.startLineNumber,R=$.node;for(;R!==S.node;){const w=this.t(R.piece.bufferIndex,D,R.piece.end);if(w>=1){const N=this.a[R.piece.bufferIndex].lineStarts,L=this.u(R.piece.bufferIndex,R.piece.start),G=N[D.line+w],W=I===i.startLineNumber?i.startColumn:1;if(g=this.findMatchesInNode(R,m,I,W,D,this.s(R,G-L),r,t,c,g,l),g>=c)return l;I+=w}const M=I===i.startLineNumber?i.startColumn-1:0;if(I===i.endLineNumber){const N=this.getLineContent(I).substring(M,i.endColumn-1);return g=this.n(r,m,N,i.endLineNumber,M,g,l,t,c),l}if(g=this.n(r,m,this.getLineContent(I).substr(M),I,M,g,l,t,c),g>=c)return l;I++,$=this.H(I,1),R=$.node,D=this.s($.node,$.remainder)}if(I===i.endLineNumber){const w=I===i.startLineNumber?i.startColumn-1:0,M=this.getLineContent(I).substring(w,i.endColumn-1);return g=this.n(r,m,M,i.endLineNumber,w,g,l,t,c),l}const f=I===i.startLineNumber?i.startColumn:1;return g=this.findMatchesInNode(S.node,m,I,f,D,b,r,t,c,g,l),l}n(i,r,t,c,l,g,m,$,S){const D=i.wordSeparators;if(!$&&i.simpleSearch){const I=i.simpleSearch,R=I.length,f=t.length;let w=-R;for(;(w=t.indexOf(I,w+R))!==-1;)if((!D||(0,T.$eD)(D,t,f,w,R))&&(m[g++]=new O.$aw(new C.$Lt(c,w+1+l,c,w+1+R+l),null),g>=S))return g;return g}let b;r.reset(0);do if(b=r.next(t),b&&(m[g++]=(0,T.$cD)(new C.$Lt(c,b.index+1+l,c,b.index+1+b[0].length+l),b,$),g>=S))return g;while(b);return g}insert(i,r,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==A.$4C){const{node:c,remainder:l,nodeStartOffset:g}=this.G(i),m=c.piece,$=m.bufferIndex,S=this.s(c,l);if(c.piece.bufferIndex===0&&m.end.line===this.g.line&&m.end.column===this.g.column&&g+m.length===i&&r.length<p){this.F(c,r),this.y();return}if(g===i)this.o(r,c),this.h.validate(i);else if(g+c.piece.length>i){const D=[];let b=new E(m.bufferIndex,S,m.end,this.t(m.bufferIndex,S,m.end),this.u($,m.end)-this.u($,S));if(this.K()&&this.M(r)&&this.I(c,l)===10){const w={line:b.start.line+1,column:0};b=new E(b.bufferIndex,w,b.end,this.t(b.bufferIndex,w,b.end),b.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(c,l-1)===13){const w=this.s(c,l-1);this.C(c,w),r="\r"+r,c.piece.length===0&&D.push(c)}else this.C(c,S);else this.C(c,S);const I=this.w(r);b.length>0&&this.S(c,b);let R=c;for(let f=0;f<I.length;f++)R=this.S(R,I[f]);this.v(D)}else this.q(r,c)}else{const c=this.w(r);let l=this.T(null,c[0]);for(let g=1;g<c.length;g++)l=this.S(l,c[g])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===A.$4C)return;const t=this.G(i),c=this.G(i+r),l=t.node,g=c.node;if(l===g){const I=this.s(l,t.remainder),R=this.s(l,c.remainder);if(t.nodeStartOffset===i){if(r===l.piece.length){const f=l.next();(0,A.$9C)(this,l),this.N(f),this.y();return}this.D(l,R),this.h.validate(i),this.N(l),this.y();return}if(t.nodeStartOffset+l.piece.length===i+r){this.C(l,I),this.O(l),this.y();return}this.E(l,I,R),this.y();return}const m=[],$=this.s(l,t.remainder);this.C(l,$),this.h.validate(i),l.piece.length===0&&m.push(l);const S=this.s(g,c.remainder);this.D(g,S),g.piece.length===0&&m.push(g);const D=l.next();for(let I=D;I!==A.$4C&&I!==g;I=I.next())m.push(I);const b=l.piece.length===0?l.prev():l;this.v(m),this.O(b),this.y()}o(i,r){const t=[];if(this.K()&&this.M(i)&&this.L(r)){const g=r.piece,m={line:g.start.line+1,column:0},$=new E(g.bufferIndex,m,g.end,this.t(g.bufferIndex,m,g.end),g.length-1);r.piece=$,i+=`
`,(0,A.$$C)(this,r,-1,-1),r.piece.length===0&&t.push(r)}const c=this.w(i);let l=this.T(r,c[c.length-1]);for(let g=c.length-2;g>=0;g--)l=this.T(l,c[g]);this.N(l),this.v(t)}q(i,r){this.Q(i,r)&&(i+=`
`);const t=this.w(i),c=this.S(r,t[0]);let l=c;for(let g=1;g<t.length;g++)l=this.S(l,t[g]);this.N(c)}s(i,r,t){const c=i.piece,l=i.piece.bufferIndex,g=this.a[l].lineStarts,$=g[c.start.line]+c.start.column+r;let S=c.start.line,D=c.end.line,b=0,I=0,R=0;for(;S<=D&&(b=S+(D-S)/2|0,R=g[b],b!==D);)if(I=g[b+1],$<R)D=b-1;else if($>=I)S=b+1;else break;return t?(t.line=b,t.column=$-R,null):{line:b,column:$-R}}t(i,r,t){if(t.column===0)return t.line-r.line;const c=this.a[i].lineStarts;if(t.line===c.length-1)return t.line-r.line;const l=c[t.line+1],g=c[t.line]+t.column;if(l>g+1)return t.line-r.line;const m=g-1;return this.a[i].buffer.charCodeAt(m)===13?t.line-r.line+1:t.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,A.$9C)(this,i[r])}w(i){if(i.length>p){const D=[];for(;i.length>p;){const I=i.charCodeAt(p-1);let R;I===v.CharCode.CarriageReturn||I>=55296&&I<=56319?(R=i.substring(0,p-1),i=i.substring(p-1)):(R=i.substring(0,p),i=i.substring(p));const f=y(R);D.push(new E(this.a.length,{line:0,column:0},{line:f.length-1,column:R.length-f[f.length-1]},f.length-1,R.length)),this.a.push(new d(R,f))}const b=y(i);return D.push(new E(this.a.length,{line:0,column:0},{line:b.length-1,column:i.length-b[b.length-1]},b.length-1,i.length)),this.a.push(new d(i,b)),D}let r=this.a[0].buffer.length;const t=y(i,!1);let c=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},c=this.g;for(let D=0;D<t.length;D++)t[D]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let D=0;D<t.length;D++)t[D]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const l=this.a[0].buffer.length,g=this.a[0].lineStarts.length-1,m=l-this.a[0].lineStarts[g],$={line:g,column:m},S=new E(0,c,$,this.t(0,c,$),l-r);return this.g=$,[S]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let t=this.root,c="";const l=this.h.get2(i);if(l){t=l.node;const g=this.B(t,i-l.nodeStartLineNumber-1),m=this.a[t.piece.bufferIndex].buffer,$=this.u(t.piece.bufferIndex,t.piece.start);if(l.nodeStartLineNumber+t.piece.lineFeedCnt===i)c=m.substring($+g,$+t.piece.length);else{const S=this.B(t,i-l.nodeStartLineNumber);return m.substring($+g,$+S-r)}}else{let g=0;const m=i;for(;t!==A.$4C;)if(t.left!==A.$4C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const $=this.B(t,i-t.lf_left-2),S=this.B(t,i-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,b=this.u(t.piece.bufferIndex,t.piece.start);return g+=t.size_left,this.h.set({node:t,nodeStartOffset:g,nodeStartLineNumber:m-(i-1-t.lf_left)}),D.substring(b+$,b+S-r)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const $=this.B(t,i-t.lf_left-2),S=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);c=S.substring(D+$,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==A.$4C;){const g=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const m=this.B(t,0),$=this.u(t.piece.bufferIndex,t.piece.start);return c+=g.substring($,$+m-r),c}else{const m=this.u(t.piece.bufferIndex,t.piece.start);c+=g.substr(m,t.piece.length)}t=t.next()}return c}y(){let i=this.root,r=1,t=0;for(;i!==A.$4C;)r+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=t,this.h.validate(this.c)}A(i,r){const t=i.piece,c=this.s(i,r),l=c.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===r){const g=this.t(i.piece.bufferIndex,t.start,c);if(g!==l)return{index:g,remainder:0}}return{index:l,remainder:c.column}}B(i,r){if(r<0)return 0;const t=i.piece,c=this.a[t.bufferIndex].lineStarts,l=t.start.line+r+1;return l>t.end.line?c[t.end.line]+t.end.column-c[t.start.line]-t.start.column:c[l]-c[t.start.line]-t.start.column}C(i,r){const t=i.piece,c=t.lineFeedCnt,l=this.u(t.bufferIndex,t.end),g=r,m=this.u(t.bufferIndex,g),$=this.t(t.bufferIndex,t.start,g),S=$-c,D=m-l,b=t.length+D;i.piece=new E(t.bufferIndex,t.start,g,$,b),(0,A.$$C)(this,i,D,S)}D(i,r){const t=i.piece,c=t.lineFeedCnt,l=this.u(t.bufferIndex,t.start),g=r,m=this.t(t.bufferIndex,g,t.end),$=this.u(t.bufferIndex,g),S=m-c,D=l-$,b=t.length+D;i.piece=new E(t.bufferIndex,g,t.end,m,b),(0,A.$$C)(this,i,D,S)}E(i,r,t){const c=i.piece,l=c.start,g=c.end,m=c.length,$=c.lineFeedCnt,S=r,D=this.t(c.bufferIndex,c.start,S),b=this.u(c.bufferIndex,r)-this.u(c.bufferIndex,l);i.piece=new E(c.bufferIndex,c.start,S,D,b),(0,A.$$C)(this,i,b-m,D-$);const I=new E(c.bufferIndex,t,g,this.t(c.bufferIndex,t,g),this.u(c.bufferIndex,g)-this.u(c.bufferIndex,t)),R=this.S(i,I);this.N(R)}F(i,r){this.Q(r,i)&&(r+=`
`);const t=this.K()&&this.L(r)&&this.M(i),c=this.a[0].buffer.length;this.a[0].buffer+=r;const l=y(r,!1);for(let R=0;R<l.length;R++)l[R]+=c;if(t){const R=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:c-R}}this.a[0].lineStarts=this.a[0].lineStarts.concat(l.slice(1));const g=this.a[0].lineStarts.length-1,m=this.a[0].buffer.length-this.a[0].lineStarts[g],$={line:g,column:m},S=i.piece.length+r.length,D=i.piece.lineFeedCnt,b=this.t(0,i.piece.start,$),I=b-D;i.piece=new E(i.piece.bufferIndex,i.piece.start,$,b,S),this.g=$,(0,A.$$C)(this,i,r.length,I)}G(i){let r=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let c=0;for(;r!==A.$4C;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){c+=r.size_left;const l={node:r,remainder:i-r.size_left,nodeStartOffset:c};return this.h.set(l),l}else i-=r.size_left+r.piece.length,c+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let t=this.root,c=0;for(;t!==A.$4C;)if(t.left!==A.$4C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const l=this.B(t,i-t.lf_left-2),g=this.B(t,i-t.lf_left-1);return c+=t.size_left,{node:t,remainder:Math.min(l+r-1,g),nodeStartOffset:c}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const l=this.B(t,i-t.lf_left-2);if(l+r-1<=t.piece.length)return{node:t,remainder:l+r-1,nodeStartOffset:c};r-=t.piece.length-l;break}else i-=t.lf_left+t.piece.lineFeedCnt,c+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==A.$4C;){if(t.piece.lineFeedCnt>0){const l=this.B(t,0),g=this.J(t);return{node:t,remainder:Math.min(r-1,l),nodeStartOffset:g}}else if(t.piece.length>=r-1){const l=this.J(t);return{node:t,remainder:r-1,nodeStartOffset:l}}else r-=t.piece.length;t=t.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],c=this.u(i.piece.bufferIndex,i.piece.start)+r;return t.buffer.charCodeAt(c)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$4C||i.piece.lineFeedCnt===0)return!1;const r=i.piece,t=this.a[r.bufferIndex].lineStarts,c=r.start.line,l=t[c]+r.start.column;return c===t.length-1||t[c+1]>l+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(l)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$4C||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const t=[],c=this.a[i.piece.bufferIndex].lineStarts;let l;i.piece.end.column===0?l={line:i.piece.end.line-1,column:c[i.piece.end.line]-c[i.piece.end.line-1]-1}:l={line:i.piece.end.line,column:i.piece.end.column-1};const g=i.piece.length-1,m=i.piece.lineFeedCnt-1;i.piece=new E(i.piece.bufferIndex,i.piece.start,l,m,g),(0,A.$$C)(this,i,-1,-1),i.piece.length===0&&t.push(i);const $={line:r.piece.start.line+1,column:0},S=r.piece.length-1,D=this.t(r.piece.bufferIndex,$,r.piece.end);r.piece=new E(r.piece.bufferIndex,$,r.piece.end,D,S),(0,A.$$C)(this,r,-1,-1),r.piece.length===0&&t.push(r);const b=this.w(`\r
`);this.S(i,b[0]);for(let I=0;I<t.length;I++)(0,A.$9C)(this,t[I])}Q(i,r){if(this.K()&&this.M(i)){const t=r.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,A.$9C)(this,t);else{const c=t.piece,l={line:c.start.line+1,column:0},g=c.length-1,m=this.t(c.bufferIndex,l,c.end);t.piece=new E(c.bufferIndex,l,c.end,m,g),(0,A.$$C)(this,t,-1,-1)}return!0}}return!1}iterate(i,r){if(i===A.$4C)return r(A.$4C);const t=this.iterate(i.left,r);return t&&r(i)&&this.iterate(i.right,r)}R(i){if(i===A.$4C)return"";const r=this.a[i.piece.bufferIndex],t=i.piece,c=this.u(t.bufferIndex,t.start),l=this.u(t.bufferIndex,t.end);return r.buffer.substring(c,l)}getPieceContent(i){const r=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),c=this.u(i.bufferIndex,i.end);return r.buffer.substring(t,c)}S(i,r){const t=new A.$3C(r,A.NodeColor.Red);if(t.left=A.$4C,t.right=A.$4C,t.parent=A.$4C,t.size_left=0,t.lf_left=0,this.root===A.$4C)this.root=t,t.color=A.NodeColor.Black;else if(i.right===A.$4C)i.right=t,t.parent=i;else{const l=(0,A.$5C)(i.right);l.left=t,t.parent=l}return(0,A.$0C)(this,t),t}T(i,r){const t=new A.$3C(r,A.NodeColor.Red);if(t.left=A.$4C,t.right=A.$4C,t.parent=A.$4C,t.size_left=0,t.lf_left=0,this.root===A.$4C)this.root=t,t.color=A.NodeColor.Black;else if(i.left===A.$4C)i.left=t,t.parent=i;else{const c=(0,A.$6C)(i.left);c.right=t,t.parent=c}return(0,A.$0C)(this,t),t}U(i){let r="";return this.iterate(i,t=>(r+=this.R(t),!0)),r}}e.$kD=o}),define(Ce[154],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w_=e.$v_=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const A=this.a.get(O);return this.a.delete(O),A}}addDragOperationTransfer(O,A){this.a.set(O,A)}}e.$v_=v;class k{constructor(O){this.identifier=O}}e.$w_=k}),define(Ce[155],Ie([9,10]),function(oe,e){return oe.create("vs/base/common/actions",e)}),define(Ce[156],Ie([1,0,6,4,155]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0,e.$pj=P,C=qe(C);class O extends k.$Wc{constructor(u,E="",d="",n=!0,s){super(),this.j=this.B(new v.$me),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=E,this.w=d,this.z=n,this.D=s}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,E){this.D&&await this.D(u)}}e.$kj=O;class A extends k.$Wc{constructor(){super(...arguments),this.f=this.B(new v.$me),this.onWillRun=this.f.event,this.m=this.B(new v.$me),this.onDidRun=this.m.event}async run(u,E){if(!u.enabled)return;this.f.fire({action:u});let d;try{await this.u(u,E)}catch(n){d=n}this.m.fire({action:u,error:d})}async u(u,E){await u.run(E)}}e.$lj=A;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let E=[];for(const d of u)d.length&&(E.length?E=[...E,new T,...d]:E=d);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$mj=T;class p{get actions(){return this.a}constructor(u,E,d,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=E,this.class=n,this.a=d}async run(){}}e.$nj=p;class a extends O{static{this.ID="vs.actions.empty"}constructor(){super(a.ID,C.localize(0,null),void 0,!1)}}e.$oj=a;function P(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...u)=>y.run(...u)}}}),define(Ce[157],Ie([9,10]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(Ce[158],Ie([1,0,157]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=a,e.$2m=P,e.$3m=y;const k=60,C=k*60,O=C*24,A=O*7,T=O*30,p=O*365;function a(u,E,d,n){typeof u!="number"&&(u=u.getTime());const s=Math.round((new Date().getTime()-u)/1e3);if(s<-30)return(0,v.localize)(0,null,a(new Date().getTime()+s*1e3,!1));if(!n&&s<30)return(0,v.localize)(1,null);let o;return s<k?(o=s,E?o===1?d?(0,v.localize)(2,null,o):(0,v.localize)(3,null,o):d?(0,v.localize)(4,null,o):(0,v.localize)(5,null,o):o===1?d?(0,v.localize)(6,null,o):(0,v.localize)(7,null,o):d?(0,v.localize)(8,null,o):(0,v.localize)(9,null,o)):s<C?(o=Math.floor(s/k),E?o===1?d?(0,v.localize)(10,null,o):(0,v.localize)(11,null,o):d?(0,v.localize)(12,null,o):(0,v.localize)(13,null,o):o===1?d?(0,v.localize)(14,null,o):(0,v.localize)(15,null,o):d?(0,v.localize)(16,null,o):(0,v.localize)(17,null,o)):s<O?(o=Math.floor(s/C),E?o===1?d?(0,v.localize)(18,null,o):(0,v.localize)(19,null,o):d?(0,v.localize)(20,null,o):(0,v.localize)(21,null,o):o===1?d?(0,v.localize)(22,null,o):(0,v.localize)(23,null,o):d?(0,v.localize)(24,null,o):(0,v.localize)(25,null,o)):s<A?(o=Math.floor(s/O),E?o===1?(0,v.localize)(26,null,o):(0,v.localize)(27,null,o):o===1?(0,v.localize)(28,null,o):(0,v.localize)(29,null,o)):s<T?(o=Math.floor(s/A),E?o===1?d?(0,v.localize)(30,null,o):(0,v.localize)(31,null,o):d?(0,v.localize)(32,null,o):(0,v.localize)(33,null,o):o===1?d?(0,v.localize)(34,null,o):(0,v.localize)(35,null,o):d?(0,v.localize)(36,null,o):(0,v.localize)(37,null,o)):s<p?(o=Math.floor(s/T),E?o===1?d?(0,v.localize)(38,null,o):(0,v.localize)(39,null,o):d?(0,v.localize)(40,null,o):(0,v.localize)(41,null,o):o===1?d?(0,v.localize)(42,null,o):(0,v.localize)(43,null,o):d?(0,v.localize)(44,null,o):(0,v.localize)(45,null,o)):(o=Math.floor(s/p),E?o===1?d?(0,v.localize)(46,null,o):(0,v.localize)(47,null,o):d?(0,v.localize)(48,null,o):(0,v.localize)(49,null,o):o===1?d?(0,v.localize)(50,null,o):(0,v.localize)(51,null,o):d?(0,v.localize)(52,null,o):(0,v.localize)(53,null,o))}function P(u,E){const d=Math.abs(u/1e3);return d<1?E?(0,v.localize)(54,null,u):(0,v.localize)(55,null,u):d<k?E?(0,v.localize)(56,null,Math.round(u)/1e3):(0,v.localize)(57,null,Math.round(u)/1e3):d<C?E?(0,v.localize)(58,null,Math.round(u/(1e3*k))):(0,v.localize)(59,null,Math.round(u/(1e3*k))):d<O?E?(0,v.localize)(60,null,Math.round(u/(1e3*C))):(0,v.localize)(61,null,Math.round(u/(1e3*C))):(0,v.localize)(62,null,Math.round(u/(1e3*O)))}function y(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ce[159],Ie([9,10]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(Ce[41],Ie([1,0,18,15,159]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=p,e.$rj=a,e.$sj=P,v=qe(v),k=qe(k),C=qe(C);function O(y,u){return u&&(y.stack||y.stacktrace)?C.localize(0,null,T(y),A(y.stack)||A(y.stacktrace)):T(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function T(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?C.localize(1,null,y.message):y.message||C.localize(2,null)}function p(y=null,u=!1){if(!y)return C.localize(3,null);if(Array.isArray(y)){const E=v.$Jb(y),d=p(E[0],u);return E.length>1?C.localize(4,null,d,E.length):d}if(k.$fg(y))return y;if(y.detail){const E=y.detail;if(E.error)return O(E.error,u);if(E.exception)return O(E.exception,u)}return y.stack?O(y,u):y.message?y.message:C.localize(5,null)}function a(y){const u=y;return u instanceof Error&&Array.isArray(u.actions)}function P(y,u){let E;return typeof y=="string"?E=new Error(y):E=y,E.actions=u,E}}),define(Ce[160],Ie([1,0,48,20]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=T,e.$yr=p,e.$zr=a,e.$Ar=P,e.$Br=y,e.$Cr=u,e.$Dr=E,e.$Er=d,e.$Fr=n,e.$Gr=s,e.$Hr=$,e.$Ir=S,e.$Jr=D;const C=new v.$X(()=>{const b=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:b,collatorIsNumeric:b.resolvedOptions().numeric}}),O=new v.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new v.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(b,I,R=!1){const f=b||"",w=I||"",M=C.value.collator.compare(f,w);return C.value.collatorIsNumeric&&M===0&&f!==w?f<w?-1:1:M}function p(b,I){const R=O.value.collator;return b=b||"",I=I||"",r(R,b,I)}function a(b,I){const R=O.value.collator;return b=b||"",I=I||"",g(b,I)||r(R,b,I)}function P(b,I){const R=O.value.collator;return b=b||"",I=I||"",l(b,I)||r(R,b,I)}function y(b,I){return b=b||"",I=I||"",b===I?0:b<I?-1:1}function u(b,I){const[R,f]=h(b),[w,M]=h(I);let N=C.value.collator.compare(f,M);if(N===0){if(C.value.collatorIsNumeric&&f!==M)return f<M?-1:1;if(N=C.value.collator.compare(R,w),C.value.collatorIsNumeric&&N===0&&R!==w)return R<w?-1:1}return N}function E(b,I){b=b||"",I=I||"";const R=i(b),f=i(I),w=O.value.collator,M=A.value.collator;return r(M,R,f)||r(w,b,I)}function d(b,I){b=b||"",I=I||"";const R=i(b),f=i(I),w=O.value.collator,M=A.value.collator;return r(M,R,f)||g(b,I)||r(w,b,I)}function n(b,I){b=b||"",I=I||"";const R=i(b),f=i(I),w=O.value.collator,M=A.value.collator;return r(M,R,f)||l(b,I)||r(w,b,I)}function s(b,I){b=b||"",I=I||"";const R=i(b).toLowerCase(),f=i(I).toLowerCase();return R!==f?R<f?-1:1:b!==I?b<I?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function h(b,I=!1){const R=b?o.exec(b):[];let f=[R&&R[1]||"",R&&R[3]||""];return I&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function i(b){const I=b?o.exec(b):[];return I&&I[1]&&I[1].charAt(0)!=="."&&I[3]||""}function r(b,I,R){const f=b.compare(I,R);return f!==0?f:I.length!==R.length?I.length<R.length?-1:1:0}function t(b){const I=b.charAt(0);return I.toLocaleUpperCase()!==I}function c(b){const I=b.charAt(0);return I.toLocaleLowerCase()!==I}function l(b,I){return t(b)&&c(I)?-1:c(b)&&t(I)?1:0}function g(b,I){return c(b)&&t(I)?-1:t(b)&&c(I)?1:0}function m(b,I,R=!1){return R||(b=b&&b.toLowerCase(),I=I&&I.toLowerCase()),b===I?0:b<I?-1:1}function $(b,I,R=!1){const f=b.split(k.sep),w=I.split(k.sep),M=f.length-1,N=w.length-1;let L,G;for(let W=0;;W++){if(L=M===W,G=N===W,L&&G)return T(f[W],w[W],R);if(L)return-1;if(G)return 1;const F=m(f[W],w[W],R);if(F!==0)return F}}function S(b,I,R){const f=b.toLowerCase(),w=I.toLowerCase(),M=D(b,I,R);if(M)return M;const N=f.endsWith(R),L=w.endsWith(R);if(N!==L)return N?-1:1;const G=T(f,w);return G!==0?G:f.localeCompare(w)}function D(b,I,R){const f=b.toLowerCase(),w=I.toLowerCase(),M=f.startsWith(R),N=w.startsWith(R);if(M!==N)return M?-1:1;if(M&&N){if(f.length<w.length)return-1;if(f.length>w.length)return 1}return 0}}),define(Ce[53],Ie([1,0,28,20,21,13,15]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=T,e.$yg=p,e.$zg=a,e.$Ag=P,e.$Bg=y,e.$Cg=n,e.$Dg=s,e.$Eg=o,e.$Fg=h,e.$Gg=i,e.$Hg=r,e.$Ig=t,e.$Jg=c,e.$Kg=l,e.$Lg=g,e.$Mg=m,e.$Ng=D;function T(b){return b===v.CharCode.Slash||b===v.CharCode.Backslash}function p(b){return b.replace(/[\\/]/g,k.$ic.sep)}function a(b){return b.indexOf("/")===-1&&(b=p(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function P(b,I=k.$ic.sep){if(!b)return"";const R=b.length,f=b.charCodeAt(0);if(T(f)){if(T(b.charCodeAt(1))&&!T(b.charCodeAt(2))){let M=3;const N=M;for(;M<R&&!T(b.charCodeAt(M));M++);if(N!==M&&!T(b.charCodeAt(M+1))){for(M+=1;M<R;M++)if(T(b.charCodeAt(M)))return b.slice(0,M+1).replace(/[\\/]/g,I)}}return I}else if(h(f)&&b.charCodeAt(1)===v.CharCode.Colon)return T(b.charCodeAt(2))?b.slice(0,2)+I:b.slice(0,2);let w=b.indexOf("://");if(w!==-1){for(w+=3;w<R;w++)if(T(b.charCodeAt(w)))return b.slice(0,w+1)}return""}function y(b){if(!C.$i||!b||b.length<5)return!1;let I=b.charCodeAt(0);if(I!==v.CharCode.Backslash||(I=b.charCodeAt(1),I!==v.CharCode.Backslash))return!1;let R=2;const f=R;for(;R<b.length&&(I=b.charCodeAt(R),I!==v.CharCode.Backslash);R++);return!(f===R||(I=b.charCodeAt(R+1),isNaN(I)||I===v.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,E=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(b,I=C.$i){const R=I?u:E;return!(!b||b.length===0||/^\s+$/.test(b)||(R.lastIndex=0,R.test(b))||I&&d.test(b)||b==="."||b===".."||I&&b[b.length-1]==="."||I&&b.length!==b.trim().length||b.length>255)}function s(b,I,R){const f=b===I;return!R||f?f:!b||!I?!1:(0,O.$Gf)(b,I)}function o(b,I,R,f=k.sep){if(b===I)return!0;if(!b||!I||I.length>b.length)return!1;if(R){if(!(0,O.$Hf)(b,I))return!1;if(I.length===b.length)return!0;let M=I.length;return I.charAt(I.length-1)===f&&M--,b.charAt(M)===f}return I.charAt(I.length-1)!==f&&(I+=f),b.indexOf(I)===0}function h(b){return b>=v.CharCode.A&&b<=v.CharCode.Z||b>=v.CharCode.a&&b<=v.CharCode.z}function i(b,I){return C.$i&&b.endsWith(":")&&(b+=k.sep),(0,k.$kc)(b)||(b=(0,k.$lc)(I,b)),b=(0,k.$jc)(b),r(b)}function r(b){return C.$i?(b=(0,O.$of)(b,k.sep),b.endsWith(":")&&(b+=k.sep)):(b=(0,O.$of)(b,k.sep),b||(b=k.sep)),b}function t(b){const I=(0,k.$jc)(b);return C.$i?b.length>3?!1:c(I)&&(b.length===2||I.charCodeAt(2)===v.CharCode.Backslash):I===k.$ic.sep}function c(b,I=C.$i){return I?h(b.charCodeAt(0))&&b.charCodeAt(1)===v.CharCode.Colon:!1}function l(b,I=C.$i){return c(b,I)?b[0]:void 0}function g(b,I,R){return I.length>b.length?-1:b===I?0:(R&&(b=b.toLowerCase(),I=I.toLowerCase()),b.indexOf(I))}function m(b){const I=b.split(":");let R,f,w;for(const M of I){const N=Number(M);(0,A.$jg)(N)?f===void 0?f=N:w===void 0&&(w=N):R=R?[R,M].join(":"):M}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:f!==void 0?f:void 0,column:w!==void 0?w:f!==void 0?1:void 0}}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",S="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(b,I,R=8){let f="";for(let M=0;M<R;M++){let N;M===0&&C.$i&&!I&&(R===3||R===4)?N=S:N=$,f+=N.charAt(Math.floor(Math.random()*N.length))}let w;return I?w=`${I}-${f}`:w=f,b?(0,k.$lc)(b,w):w}}),define(Ce[73],Ie([1,0,20]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0,e.$9s=O,e.$0s=A,e.$$s=T,e.$_s=a,e.$8s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(P){const y=(0,v.$qc)(P),u=k[y.toLowerCase()];return u!==void 0?u:A(P)}function A(P){const y=(0,v.$qc)(P);return C[y.toLowerCase()]}function T(P){for(const y in C)if(C[y]===P)return y}const p=/^(.+)\/(.+?)(;.+)?$/;function a(P,y){const u=p.exec(P);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:y?void 0:P}}),define(Ce[49],Ie([1,0,23,2,38]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=O,e.$bi=A,e.$ci=p;function O(a){return JSON.stringify(a,T)}function A(a){let P=JSON.parse(a);return P=p(P),P}function T(a,P){return P instanceof RegExp?{$mid:C.MarshalledId.Regexp,source:P.source,flags:P.flags}:P}function p(a,P=0){if(!a||P>200)return a;if(typeof a=="object"){switch(a.$mid){case C.MarshalledId.Uri:return k.URI.revive(a);case C.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case C.MarshalledId.Date:return new Date(a.source)}if(a instanceof v.$Oe||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let y=0;y<a.length;++y)a[y]=p(a[y],P+1);else for(const y in a)Object.hasOwnProperty.call(a,y)&&(a[y]=p(a[y],P+1))}return a}}),define(Ce[16],Ie([1,0,14,21,13,2,20]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=p,e.$Pg=a,e.$Tg=y,v=qe(v),k=qe(k),A=qe(A);var T;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(T||(e.Schemas=T={}));function p(d,n){return O.URI.isUri(d)?(0,C.$Gf)(d.scheme,n):(0,C.$Hf)(d,n+":")}function a(d,...n){return n.some(s=>p(d,s))}e.$Qg="vscode-tkn",e.$Rg="tkn";class P{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,s){this.f=y(n,s)}getServerRootPath(){return this.f}get g(){return A.$ic.join(this.f,T.vscodeRemoteResource)}set(n,s,o){this.a[n]=s,this.b[n]=o}setConnectionToken(n,s){this.c[n]=s}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(t){return v.$3(t),n}const s=n.authority;let o=this.a[s];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const h=this.b[s],i=this.c[s];let r=`path=${encodeURIComponent(n.path)}`;return typeof i=="string"&&(r+=`&${e.$Rg}=${encodeURIComponent(i)}`),O.URI.from({scheme:k.$o?this.d:T.vscodeRemoteResource,authority:`${o}:${h}`,path:this.g,query:r})}}e.$Sg=new P;function y(d,n){return A.$ic.join(n??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class u{static{this.a=e.$Yg}asBrowserUri(n){const s=this.b(n,oe);return this.uriToBrowserUri(s)}uriToBrowserUri(n){return n.scheme===T.vscodeRemote?e.$Sg.rewrite(n):n.scheme===T.file&&(k.$m||k.$q===`${T.vscodeFileResource}://${u.a}`)?n.with({scheme:T.vscodeFileResource,authority:n.authority||u.a,query:null,fragment:null}):n}asFileUri(n){const s=this.b(n,oe);return this.uriToFileUri(s)}uriToFileUri(n){return n.scheme===T.vscodeFileResource?n.with({scheme:T.file,authority:n.authority!==u.a?n.authority:null,query:null,fragment:null}):n}b(n,s){return O.URI.isUri(n)?n:O.URI.parse(s.toUrl(n))}}e.$Zg=new u;var E;(function(d){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(n.get("3"));const s="vscode-coi";function o(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:O.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const t=r?.get(s);if(t)return n.get(t)}d.getHeadersFromQuery=o;function h(i,r,t){if(!globalThis.crossOriginIsolated)return;const c=r&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(s,c):i[s]=c}d.addSearchParam=h})(E||(e.COI=E={}))}),define(Ce[24],Ie([1,0,28,53,16,20,21,13,2]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=a,e.$ph=y,e.$qh=E,k=qe(k),O=qe(O);function a(d){return(0,p.$yc)(d,!0)}class P{constructor(n){this.a=n}compare(n,s,o=!1){return n===s?0:(0,T.$zf)(this.getComparisonKey(n,o),this.getComparisonKey(s,o))}isEqual(n,s,o=!1){return n===s?!0:!n||!s?!1:this.getComparisonKey(n,o)===this.getComparisonKey(s,o)}getComparisonKey(n,s=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,s,o=!1){if(n.scheme===s.scheme){if(n.scheme===C.Schemas.file)return k.$Eg(a(n),a(s),this.a(n))&&n.query===s.query&&(o||n.fragment===s.fragment);if((0,e.$lh)(n.authority,s.authority))return k.$Eg(n.path,s.path,this.a(n),"/")&&n.query===s.query&&(o||n.fragment===s.fragment)}return!1}joinPath(n,...s){return p.URI.joinPath(n,...s)}basenameOrAuthority(n){return(0,e.$dh)(n)||n.authority}basename(n){return O.$ic.basename(n.path)}extname(n){return O.$ic.extname(n.path)}dirname(n){if(n.path.length===0)return n;let s;return n.scheme===C.Schemas.file?s=p.URI.file(O.$oc(a(n))).path:(s=O.$ic.dirname(n.path),n.authority&&s.length&&s.charCodeAt(0)!==v.CharCode.Slash&&(console.error(`dirname("${n.toString})) resulted in a relative path`),s="/")),n.with({path:s})}normalizePath(n){if(!n.path.length)return n;let s;return n.scheme===C.Schemas.file?s=p.URI.file(O.$jc(a(n))).path:s=O.$ic.normalize(n.path),n.with({path:s})}relativePath(n,s){if(n.scheme!==s.scheme||!(0,e.$lh)(n.authority,s.authority))return;if(n.scheme===C.Schemas.file){const i=O.$nc(a(n),a(s));return A.$i?k.$yg(i):i}let o=n.path||"/";const h=s.path||"/";if(this.a(n)){let i=0;for(const r=Math.min(o.length,h.length);i<r&&!(o.charCodeAt(i)!==h.charCodeAt(i)&&o.charAt(i).toLowerCase()!==h.charAt(i).toLowerCase());i++);o=h.substr(0,i)+o.substr(i)}return O.$ic.relative(o,h)}resolvePath(n,s){if(n.scheme===C.Schemas.file){const o=p.URI.file(O.$mc(a(n),s));return n.with({authority:o.authority,path:o.path})}return s=k.$zg(s),n.with({path:O.$ic.resolve(n.path,s)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,s){return n===s||n!==void 0&&s!==void 0&&(0,T.$Gf)(n,s)}hasTrailingPathSeparator(n,s=O.sep){if(n.scheme===C.Schemas.file){const o=a(n);return o.length>k.$Ag(o).length&&o[o.length-1]===s}else{const o=n.path;return o.length>1&&o.charCodeAt(o.length-1)===v.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,s=O.sep){return(0,e.$mh)(n,s)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,s=O.sep){let o=!1;if(n.scheme===C.Schemas.file){const h=a(n);o=h!==void 0&&h.length===k.$Ag(h).length&&h[h.length-1]===s}else{s="/";const h=n.path;o=h.length===1&&h.charCodeAt(h.length-1)===v.CharCode.Slash}return!o&&!(0,e.$mh)(n,s)?n.with({path:n.path+"/"}):n}}e.$8g=P,e.$9g=new P(()=>!1),e.$0g=new P(d=>d.scheme===C.Schemas.file?!A.$k:!0),e.$$g=new P(d=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function y(d,n){const s=[];for(let o=0;o<d.length;o++){const h=n(d[o]);d.some((i,r)=>r===o?!1:(0,e.$ah)(h,n(i)))||s.push(d[o])}return s}var u;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function n(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(r=>{const[t,c]=r.split(":");t&&c&&o.set(t,c)});const i=s.path.substring(0,s.path.indexOf(";"));return i&&o.set(d.META_DATA_MIME,i),o}d.parseMetaData=n})(u||(e.DataUri=u={}));function E(d,n,s){if(n){let o=d.path;return o&&o[0]!==O.$ic.sep&&(o=O.$ic.sep+o),d.with({scheme:s,authority:n,path:o})}return d.with({scheme:s})}}),define(Ce[11],Ie([1,0,22,14,6,4,24,21,146,48]),function(oe,e,v,k,C,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=P,e.$sh=y,e.$th=u,e.$uh=E,e.$vh=d,e.$wh=n,e.$xh=s,e.$yh=o,e.$Gh=S,e.$Hh=D,e.$Ih=b,e.$Jh=I,e.$Kh=R,e.$Zh=ge,e.$8h=ue;function P(de){return!!de&&typeof de.then=="function"}function y(de){const X=new v.$xe,Z=de(X.token),me=new Promise((pe,Oe)=>{const ze=X.token.onCancellationRequested(()=>{ze.dispose(),Oe(new k.$7)});Promise.resolve(Z).then(ke=>{ze.dispose(),X.dispose(),pe(ke)},ke=>{ze.dispose(),X.dispose(),Oe(ke)})});return new class{cancel(){X.cancel(),X.dispose()}then(pe,Oe){return me.then(pe,Oe)}catch(pe){return this.then(void 0,pe)}finally(pe){return me.finally(pe)}}}function u(de,X,Z){return new Promise((me,pe)=>{const Oe=X.onCancellationRequested(()=>{Oe.dispose(),me(Z)});de.then(me,pe).finally(()=>Oe.dispose())})}function E(de,X){return new Promise((Z,me)=>{const pe=X.onCancellationRequested(()=>{pe.dispose(),me(new k.$7)});de.then(Z,me).finally(()=>pe.dispose())})}async function d(de){let X=-1;const Z=de.map((me,pe)=>me.then(Oe=>(X=pe,Oe)));try{return await Promise.race(Z)}finally{de.forEach((me,pe)=>{pe!==X&&me.cancel()})}}function n(de,X,Z){let me;const pe=setTimeout(()=>{me?.(void 0),Z?.()},X);return Promise.race([de.finally(()=>clearTimeout(pe)),new Promise(Oe=>me=Oe)])}function s(de){return new Promise((X,Z)=>{const me=de();P(me)?me.then(X,Z):X(me)})}function o(){let de,X;return{promise:new Promise((me,pe)=>{de=me,X=pe}),resolve:de,reject:X}}class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const Z=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(Z,Z).then(me)})}return new Promise((Z,me)=>{this.b.then(Z,me)})}return this.a=X(),new Promise((Z,me)=>{this.a.then(pe=>{this.a=null,Z(pe)},pe=>{this.a=null,me(pe)})})}dispose(){this.f=!0}}e.$zh=h;class i{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$Ah=i;class r{constructor(){this.a=new Map}queue(X,Z){const pe=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.a.get(X)===pe&&this.a.delete(X)});return this.a.set(X,pe),pe}}e.$Bh=r;const t=(de,X)=>{let Z=!0;const me=setTimeout(()=>{Z=!1,X()},de);return{isTriggered:()=>Z,dispose:()=>{clearTimeout(me),Z=!1}}},c=de=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,de())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class l{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,Z=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((pe,Oe)=>{this.d=pe,this.f=Oe}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=Z===p.$he?c(me):t(Z,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=l;class g{constructor(X){this.a=new l(X),this.b=new h}trigger(X,Z){return this.a.trigger(()=>this.b.queue(X),Z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=g;class m{constructor(){this.a=!1,this.b=new Promise((X,Z)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=m;class $ extends m{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Fh=$;function S(de,X){return X?new Promise((Z,me)=>{const pe=setTimeout(()=>{Oe.dispose(),Z()},de),Oe=X.onCancellationRequested(()=>{clearTimeout(pe),Oe.dispose(),me(new k.$7)})}):y(Z=>S(de,Z))}function D(de,X=0,Z){const me=setTimeout(()=>{de(),Z&&pe.dispose()},X),pe=(0,O.$Uc)(()=>{clearTimeout(me),Z?.deleteAndLeak(pe)});return Z?.add(pe),pe}function b(de){const X=[];let Z=0;const me=de.length;function pe(){return Z<me?de[Z++]():null}function Oe(ze){ze!=null&&X.push(ze);const ke=pe();return ke?ke.then(Oe):Promise.resolve(X)}return Promise.resolve(null).then(Oe)}function I(de,X=me=>!!me,Z=null){let me=0;const pe=de.length,Oe=()=>{if(me>=pe)return Promise.resolve(Z);const ze=de[me++];return Promise.resolve(ze()).then(Ae=>X(Ae)?Promise.resolve(Ae):Oe())};return Oe()}function R(de,X=me=>!!me,Z=null){if(de.length===0)return Promise.resolve(Z);let me=de.length;const pe=()=>{me=-1;for(const Oe of de)Oe.cancel?.()};return new Promise((Oe,ze)=>{for(const ke of de)ke.then(Ae=>{--me>=0&&X(Ae)?(pe(),Oe(Ae)):me===0&&Oe(Z)}).catch(Ae=>{--me>=0&&(pe(),ze(Ae))})})}class f{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new C.$me}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Z,me)=>{this.g.push({factory:X,c:Z,e:me}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const Z=X.factory();Z.then(X.c,X.e),Z.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=f;class w extends f{constructor(){super(1)}}e.$Mh=w;class M{constructor(){this.a=new se,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Nh=M;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new re;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,Z=A.$9g){const me=Z.getComparisonKey(X);return this.a.get(me)?.size??0}queueFor(X,Z,me=A.$9g){const pe=me.getComparisonKey(X);let Oe=this.a.get(pe);if(!Oe){Oe=new w;const ze=this.f++,ke=C.Event.once(Oe.onDrained)(()=>{Oe?.dispose(),this.a.delete(pe),this.h(),this.d?.deleteAndDispose(ze),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$6c),this.d.set(ze,ke),this.a.set(pe,Oe)}return Oe.queue(Z)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=N;class L{constructor(X,Z){this.b=!1,this.a=-1,typeof X=="function"&&typeof Z=="number"&&this.setIfNotSet(X,Z)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,Z){if(this.b)throw new k.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},Z)}setIfNotSet(X,Z){if(this.b)throw new k.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},Z))}}e.$Ph=L;class G{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,Z,me=globalThis){if(this.f)throw new k.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const pe=me.setInterval(()=>{X()},Z);this.d=(0,O.$Uc)(()=>{me.clearInterval(pe),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=G;class W{constructor(X,Z){this.b=-1,this.a=X,this.d=Z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=W;class F{constructor(X,Z){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.a=X,this.b=Z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=F;class V extends W{constructor(X,Z){super(X,Z),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Th=V;class ae extends O.$Wc{constructor(X,Z){super(),this.g=X,this.h=Z,this.a=[],this.b=this.B(new O.$Xc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Z of X)this.a.push(Z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=ae,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(de,X)=>{(0,T.$B)(()=>{if(Z)return;const me=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.$Wh=(de,X,Z)=>{const me=de.requestIdleCallback(X,typeof Z=="number"?{timeout:Z}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,de.cancelIdleCallback(me))}}},e.$Vh=de=>(0,e.$Wh)(globalThis,de)}();class $e{constructor(X,Z){this.g=!1,this.d=()=>{try{this.j=Z()}catch(me){this.l=me}finally{this.g=!0}},this.f=(0,e.$Wh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=$e;class _ extends $e{constructor(X){super(globalThis,X)}}e.$Yh=_;async function ge(de,X,Z){let me;for(let pe=0;pe<Z;pe++)try{return await de()}catch(Oe){me=Oe,await S(X)}throw me}class se{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,Z,me){return this.a={taskId:X,cancel:()=>me?.(),promise:Z},Z.then(()=>this.d(X),()=>this.d(X)),Z}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:Z,resolve:me,reject:pe}=o();this.b={run:X,promise:Z,promiseResolve:me,promiseReject:pe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=se;class ce{constructor(X,Z=()=>Date.now()){this.d=X,this.f=Z,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$2h=ce;var we;(function(de){de[de.Resolved=0]="Resolved",de[de.Rejected=1]="Rejected"})(we||(we={}));class re{get isRejected(){return this.d?.outcome===we.Rejected}get isResolved(){return this.d?.outcome===we.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===we.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,Z)=>{this.a=X,this.b=Z})}complete(X){return new Promise(Z=>{this.a(X),this.d={outcome:we.Resolved,value:X},Z()})}error(X){return new Promise(Z=>{this.b(X),this.d={outcome:we.Rejected,value:X},Z()})}cancel(){return this.error(new k.$7)}}e.$3h=re;var Pe;(function(de){async function X(me){let pe;const Oe=await Promise.all(me.map(ze=>ze.then(ke=>ke,ke=>{pe||(pe=ke)})));if(typeof pe<"u")throw pe;return Oe}de.settled=X;function Z(me){return new Promise(async(pe,Oe)=>{try{await me(pe,Oe)}catch(ze){Oe(ze)}})}de.withAsyncBody=Z})(Pe||(e.Promises=Pe={}));class Me{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(Z=>(this.a=Z,this.d=!0,Z),Z=>{throw this.b=Z,this.d=!0,Z})}requireValue(){if(!this.d)throw new k.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=Me;class Y{constructor(X){this.b=X,this.a=new a.$X(()=>new Me(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=Y;var q;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(q||(q={}));class ee{static fromArray(X){return new ee(Z=>{Z.emitMany(X)})}static fromPromise(X){return new ee(async Z=>{Z.emitMany(await X)})}static fromPromises(X){return new ee(async Z=>{await Promise.all(X.map(async me=>Z.emitOne(await me)))})}static merge(X){return new ee(async Z=>{await Promise.all(X.map(async me=>{for await(const pe of me)Z.emitOne(pe)}))})}static{this.EMPTY=ee.fromArray([])}constructor(X,Z){this.a=q.Initial,this.b=[],this.d=null,this.f=Z,this.g=new C.$me,queueMicrotask(async()=>{const me={emitOne:pe=>this.h(pe),emitMany:pe=>this.j(pe),reject:pe=>this.l(pe)};try{await Promise.resolve(X(me)),this.k()}catch(pe){this.l(pe)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===q.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===q.DoneOK)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,Z){return new ee(async me=>{for await(const pe of X)me.emitOne(Z(pe))})}map(X){return ee.map(this,X)}static filter(X,Z){return new ee(async me=>{for await(const pe of X)Z(pe)&&me.emitOne(pe)})}filter(X){return ee.filter(this,X)}static coalesce(X){return ee.filter(X,Z=>!!Z)}coalesce(){return ee.coalesce(this)}static async toPromise(X){const Z=[];for await(const me of X)Z.push(me);return Z}toPromise(){return ee.toPromise(this)}h(X){this.a===q.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===q.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===q.Initial&&(this.a=q.DoneOK,this.g.fire())}l(X){this.a===q.Initial&&(this.a=q.DoneError,this.d=X,this.g.fire())}}e.$6h=ee;class ve extends ee{constructor(X,Z){super(Z),this.m=X}cancel(){this.m.cancel()}}e.$7h=ve;function ue(de){const X=new v.$xe,Z=de(X.token);return new ve(X,async me=>{const pe=X.token.onCancellationRequested(()=>{pe.dispose(),X.dispose(),me.reject(new k.$7)});try{for await(const Oe of Z){if(X.token.isCancellationRequested)return;me.emitOne(Oe)}pe.dispose(),X.dispose()}catch(Oe){pe.dispose(),X.dispose(),me.reject(Oe)}})}class be{constructor(X){this.a=new re,this.b=new ee(pe=>{if(Z){pe.reject(Z);return}return me&&pe.emitMany(me),this.d=Oe=>pe.reject(Oe),this.f=Oe=>pe.emitOne(Oe),this.a.p},X);let Z,me;this.f=pe=>{me||(me=[]),me.push(pe)},this.d=pe=>{Z||(Z=pe)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$9h=be}),define(Ce[42],Ie([1,0,18,11,28,53,29,20,21,13]),function(oe,e,v,k,C,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=P,e.$xk=n,e.$yk=M,e.$zk=N,e.$Ak=L,e.$Bk=G,e.$Ck=W,e.$Dk=$e;function P(){return Object.create(null)}e.$vk="**",e.$wk="/";const y="[/\\\\]",u="[^/\\\\]",E=/\//g;function d(_,ge){switch(_){case 0:return"";case 1:return`${u}*?`;default:return`(?:${y}|${u}+${y}${ge?`|${y}${u}+`:""})*?`}}function n(_,ge){if(!_)return[];const se=[];let ce=!1,we=!1,re="";for(const Pe of _){switch(Pe){case ge:if(!ce&&!we){se.push(re),re="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":we=!0;break;case"]":we=!1;break}re+=Pe}return re&&se.push(re),se}function s(_){if(!_)return"";let ge="";const se=n(_,e.$wk);if(se.every(ce=>ce===e.$vk))ge=".*";else{let ce=!1;se.forEach((we,re)=>{if(we===e.$vk){if(ce)return;ge+=d(2,re===se.length-1)}else{let Pe=!1,Me="",Y=!1,q="";for(const ee of we){if(ee!=="}"&&Pe){Me+=ee;continue}if(Y&&(ee!=="]"||!q)){let ve;ee==="-"?ve=ee:(ee==="^"||ee==="!")&&!q?ve="^":ee===e.$wk?ve="":ve=(0,a.$if)(ee),q+=ve;continue}switch(ee){case"{":Pe=!0;continue;case"[":Y=!0;continue;case"}":{const ue=`(?:${n(Me,",").map(be=>s(be)).join("|")})`;ge+=ue,Pe=!1,Me="";break}case"]":{ge+="["+q+"]",Y=!1,q="";break}case"?":ge+=u;continue;case"*":ge+=d(1);continue;default:ge+=(0,a.$if)(ee)}}re<se.length-1&&(se[re+1]!==e.$vk||re+2<se.length)&&(ge+=y)}ce=we===e.$vk})}return ge}const o=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new A.$Fc(1e4),g=function(){return!1},m=function(){return null};function $(_,ge){if(!_)return m;let se;typeof _!="string"?se=_.pattern:se=_,se=se.trim();const ce=`${se}_${!!ge.trimForExclusions}`;let we=l.get(ce);if(we)return S(we,_);let re;return o.test(se)?we=b(se.substr(4),se):(re=h.exec(D(se,ge)))?we=I(re[1],se):(ge.trimForExclusions?r:i).test(se)?we=R(se,ge):(re=t.exec(D(se,ge)))?we=f(re[1].substr(1),se,!0):(re=c.exec(D(se,ge)))?we=f(re[1],se,!1):we=w(se),l.set(ce,we),S(we,_)}function S(_,ge){if(typeof ge=="string")return _;const se=function(ce,we){return(0,O.$Eg)(ce,ge.base,!p.$k)?_((0,a.$nf)(ce.substr(ge.base.length),T.sep),we):null};return se.allBasenames=_.allBasenames,se.allPaths=_.allPaths,se.basenames=_.basenames,se.patterns=_.patterns,se}function D(_,ge){return ge.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function b(_,ge){return function(se,ce){return typeof se=="string"&&se.endsWith(_)?ge:null}}function I(_,ge){const se=`/${_}`,ce=`\\${_}`,we=function(Pe,Me){return typeof Pe!="string"?null:Me?Me===_?ge:null:Pe===_||Pe.endsWith(se)||Pe.endsWith(ce)?ge:null},re=[_];return we.basenames=re,we.patterns=[ge],we.allBasenames=re,we}function R(_,ge){const se=ae(_.slice(1,-1).split(",").map(Me=>$(Me,ge)).filter(Me=>Me!==m),_),ce=se.length;if(!ce)return m;if(ce===1)return se[0];const we=function(Me,Y){for(let q=0,ee=se.length;q<ee;q++)if(se[q](Me,Y))return _;return null},re=se.find(Me=>!!Me.allBasenames);re&&(we.allBasenames=re.allBasenames);const Pe=se.reduce((Me,Y)=>Y.allPaths?Me.concat(Y.allPaths):Me,[]);return Pe.length&&(we.allPaths=Pe),we}function f(_,ge,se){const ce=T.sep===T.$ic.sep,we=ce?_:_.replace(E,T.sep),re=T.sep+we,Pe=T.$ic.sep+_;let Me;return se?Me=function(Y,q){return typeof Y=="string"&&(Y===we||Y.endsWith(re)||!ce&&(Y===_||Y.endsWith(Pe)))?ge:null}:Me=function(Y,q){return typeof Y=="string"&&(Y===we||!ce&&Y===_)?ge:null},Me.allPaths=[(se?"*/":"./")+_],Me}function w(_){try{const ge=new RegExp(`^${s(_)}$`);return function(se){return ge.lastIndex=0,typeof se=="string"&&ge.test(se)?_:null}}catch{return m}}function M(_,ge,se){return!_||typeof ge!="string"?!1:N(_)(ge,void 0,se)}function N(_,ge={}){if(!_)return g;if(typeof _=="string"||L(_)){const se=$(_,ge);if(se===m)return g;const ce=function(we,re){return!!se(we,re)};return se.allBasenames&&(ce.allBasenames=se.allBasenames),se.allPaths&&(ce.allPaths=se.allPaths),ce}return F(_,ge)}function L(_){const ge=_;return ge?typeof ge.base=="string"&&typeof ge.pattern=="string":!1}function G(_){return _.allBasenames||[]}function W(_){return _.allPaths||[]}function F(_,ge){const se=ae(Object.getOwnPropertyNames(_).map(Me=>V(Me,_[Me],ge)).filter(Me=>Me!==m)),ce=se.length;if(!ce)return m;if(!se.some(Me=>!!Me.requiresSiblings)){if(ce===1)return se[0];const Me=function(ee,ve){let ue;for(let be=0,de=se.length;be<de;be++){const X=se[be](ee,ve);if(typeof X=="string")return X;(0,k.$rh)(X)&&(ue||(ue=[]),ue.push(X))}return ue?(async()=>{for(const be of ue){const de=await be;if(typeof de=="string")return de}return null})():null},Y=se.find(ee=>!!ee.allBasenames);Y&&(Me.allBasenames=Y.allBasenames);const q=se.reduce((ee,ve)=>ve.allPaths?ee.concat(ve.allPaths):ee,[]);return q.length&&(Me.allPaths=q),Me}const we=function(Me,Y,q){let ee,ve;for(let ue=0,be=se.length;ue<be;ue++){const de=se[ue];de.requiresSiblings&&q&&(Y||(Y=(0,T.$pc)(Me)),ee||(ee=Y.substr(0,Y.length-(0,T.$qc)(Me).length)));const X=de(Me,Y,ee,q);if(typeof X=="string")return X;(0,k.$rh)(X)&&(ve||(ve=[]),ve.push(X))}return ve?(async()=>{for(const ue of ve){const be=await ue;if(typeof be=="string")return be}return null})():null},re=se.find(Me=>!!Me.allBasenames);re&&(we.allBasenames=re.allBasenames);const Pe=se.reduce((Me,Y)=>Y.allPaths?Me.concat(Y.allPaths):Me,[]);return Pe.length&&(we.allPaths=Pe),we}function V(_,ge,se){if(ge===!1)return m;const ce=$(_,se);if(ce===m)return m;if(typeof ge=="boolean")return ce;if(ge){const we=ge.when;if(typeof we=="string"){const re=(Pe,Me,Y,q)=>{if(!q||!ce(Pe,Me))return null;const ee=we.replace("$(basename)",()=>Y),ve=q(ee);return(0,k.$rh)(ve)?ve.then(ue=>ue?_:null):ve?_:null};return re.requiresSiblings=!0,re}}return ce}function ae(_,ge){const se=_.filter(Me=>!!Me.basenames);if(se.length<2)return _;const ce=se.reduce((Me,Y)=>{const q=Y.basenames;return q?Me.concat(q):Me},[]);let we;if(ge){we=[];for(let Me=0,Y=ce.length;Me<Y;Me++)we.push(ge)}else we=se.reduce((Me,Y)=>{const q=Y.patterns;return q?Me.concat(q):Me},[]);const re=function(Me,Y){if(typeof Me!="string")return null;if(!Y){let ee;for(ee=Me.length;ee>0;ee--){const ve=Me.charCodeAt(ee-1);if(ve===C.CharCode.Slash||ve===C.CharCode.Backslash)break}Y=Me.substr(ee)}const q=ce.indexOf(Y);return q!==-1?we[q]:null};re.basenames=ce,re.patterns=we,re.allBasenames=ce;const Pe=_.filter(Me=>!Me.basenames);return Pe.push(re),Pe}function $e(_,ge){return(0,v.$wb)(_,ge,(se,ce)=>typeof se=="string"&&typeof ce=="string"?se===ce:typeof se!="string"&&typeof ce!="string"?se.base===ce.base&&se.pattern===ce.pattern:!1)}}),define(Ce[60],Ie([1,0,14,99,24,13,2]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.MarkdownStringTextNewlineStyle=void 0,e.$4k=a,e.$5k=P,e.$6k=y,e.$7k=u,e.$8k=E,e.$9k=d,e.$0k=n,e.$$k=s;var T;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class p{constructor(h="",i=!1){if(this.value=h,typeof this.value!="string")throw(0,v.$9)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(h,i=T.Paragraph){return this.value+=u(this.supportThemeIcons?(0,k.$Wk)(h):h).replace(/([ \t]+)/g,(r,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===T.Break?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,i){return this.value+=`
${E(i,h)}
`,this}appendLink(h,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(h),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(h,i){const r=new RegExp((0,O.$if)(i),"g");return h.replace(r,(t,c)=>h.charAt(c-1)!=="\\"?`\\${t}`:t)}}e.$3k=p;function a(o){return P(o)?!o.value:Array.isArray(o)?o.every(a):!0}function P(o){return o instanceof p?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function y(o,h){return o===h?!0:!o||!h?!1:o.value===h.value&&o.isTrusted===h.isTrusted&&o.supportThemeIcons===h.supportThemeIcons&&o.supportHtml===h.supportHtml&&(o.baseUri===h.baseUri||!!o.baseUri&&!!h.baseUri&&(0,C.$_g)(A.URI.from(o.baseUri),A.URI.from(h.baseUri)))}function u(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(o,h){const i=o.match(/^`+/gm)?.reduce((t,c)=>t.length>c.length?t:c).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${h}`,o,`${"`".repeat(r)}`].join(`
`)}function d(o){return o.replace(/"/g,"&quot;")}function n(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function s(o){const h=[],i=o.split("|").map(t=>t.trim());o=i[0];const r=i[1];if(r){const t=/height=(\d+)/.exec(r),c=/width=(\d+)/.exec(r),l=t?t[1]:"",g=c?c[1]:"",m=isFinite(parseInt(g)),$=isFinite(parseInt(l));m&&h.push(`width="${g}"`),$&&h.push(`height="${l}"`)}return{href:o,dimensions:h}}}),define(Ce[103],Ie([1,0,18,53,20,21,24,13]),function(oe,e,v,k,C,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vw=p,e.$Ww=P,e.$Xw=u,e.$Yw=E,e.$Zw=o,e.$1w=i,e.$2w=r,e.$3w=t,e.$4w=c,e.$5w=l;function p(m,$){const{os:S,tildify:D,relative:b}=$;if(b){const f=a(m,b,S);if(typeof f=="string")return f}let I=m.fsPath;if(S===O.OperatingSystem.Windows&&!O.$i?I=I.replace(/\//g,"\\"):S!==O.OperatingSystem.Windows&&O.$i&&(I=I.replace(/\\/g,"/")),S!==O.OperatingSystem.Windows&&D?.userHome){const f=D.userHome.fsPath;let w;m.scheme!==D.userHome.scheme&&m.path[0]===C.$ic.sep&&m.path[1]!==C.$ic.sep?w=D.userHome.with({path:m.path}).fsPath:w=I,I=u(w,f,S)}return(S===O.OperatingSystem.Windows?C.$hc:C.$ic).normalize(P(I,S===O.OperatingSystem.Windows))}function a(m,$,S){const D=S===O.OperatingSystem.Windows?C.$hc:C.$ic,b=S===O.OperatingSystem.Linux?A.$9g:A.$$g,I=$.getWorkspace(),R=(0,v.$Qb)(I.folders);if(!R)return;m.scheme!==R.uri.scheme&&m.path[0]===C.$ic.sep&&m.path[1]!==C.$ic.sep&&(m=R.uri.with({path:m.path}));const f=$.getWorkspaceFolder(m);if(!f)return;let w;if(b.isEqual(f.uri,m)?w="":w=b.relativePath(f.uri,m)??"",w&&(w=D.normalize(w)),I.folders.length>1&&!$.noPrefix){const M=f.name?f.name:b.basenameOrAuthority(f.uri);w=w?`${M} \u2022 ${w}`:M}return w}function P(m,$=O.$i){return(0,k.$Jg)(m,$)?m.charAt(0).toUpperCase()+m.slice(1):m}let y=Object.create(null);function u(m,$,S=O.OS){if(S===O.OperatingSystem.Windows||!m||!$)return m;let D=y.original===$?y.normalized:void 0;D||(D=$,O.$i&&(D=(0,k.$yg)(D)),D=`${(0,T.$of)(D,C.$ic.sep)}${C.$ic.sep}`,y={original:$,normalized:D});let b=m;return O.$i&&(b=(0,k.$yg)(b)),(S===O.OperatingSystem.Linux?b.startsWith(D):(0,T.$Hf)(b,D))?`~/${b.substr(D.length)}`:m}function E(m,$){return m.replace(/^~($|\/|\\)/,`${$}$1`)}const d="\u2026",n="\\\\",s="~";function o(m,$=C.sep){const S=new Array(m.length);let D=!1;for(let b=0;b<m.length;b++){const I=m[b];if(I===""){S[b]=`.${$}`;continue}if(!I){S[b]=I;continue}D=!0;let R="",f=I;f.indexOf(n)===0?(R=f.substr(0,f.indexOf(n)+n.length),f=f.substr(f.indexOf(n)+n.length)):f.indexOf($)===0?(R=f.substr(0,f.indexOf($)+$.length),f=f.substr(f.indexOf($)+$.length)):f.indexOf(s)===0&&(R=f.substr(0,f.indexOf(s)+s.length),f=f.substr(f.indexOf(s)+s.length));const w=f.split($);for(let M=1;D&&M<=w.length;M++)for(let N=w.length-M;D&&N>=0;N--){D=!1;let L=w.slice(N,N+M).join($);for(let G=0;!D&&G<m.length;G++)if(G!==b&&m[G]&&m[G].indexOf(L)>-1){const W=N+M===w.length,F=N>0&&m[G].indexOf($)>-1?$+L:L,V=m[G].endsWith(F);D=!W||V}if(!D){let G="";(w[0].endsWith(":")||R!=="")&&(N===1&&(N=0,M++,L=w[0]+$+L),N>0&&(G=w[0]+$),G=R+G),N>0&&(G=G+d+$),G=G+L,N+M<w.length&&(G=G+$+d),S[b]=G}}D&&(S[b]=I)}return S}var h;(function(m){m[m.TEXT=0]="TEXT",m[m.VARIABLE=1]="VARIABLE",m[m.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function i(m,$=Object.create(null)){const S=[];let D=!1,b="";for(const I of m)if(I==="$"||D&&I==="{")b&&S.push({value:b,type:h.TEXT}),b="",D=!0;else if(I==="}"&&D){const R=$[b];if(typeof R=="string")R.length&&S.push({value:R,type:h.VARIABLE});else if(R){const f=S[S.length-1];(!f||f.type!==h.SEPARATOR)&&S.push({value:R.label,type:h.SEPARATOR})}b="",D=!1}else b+=I;return b&&!D&&S.push({value:b,type:h.TEXT}),S.filter((I,R)=>{if(I.type===h.SEPARATOR){const f=S[R-1],w=S[R+1];return[f,w].every(M=>M&&(M.type===h.VARIABLE||M.type===h.TEXT)&&M.value.length>0)}return!0}).map(I=>I.value).join("")}function r(m,$){return O.$j||$?m.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):m.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function t(m,$){return O.$j||$?m.replace(/\(&&\w\)|&&/g,""):O.$i?m.replace(/&&|&/g,S=>S==="&"?"&&":"&"):m.replace(/&&/g,"_")}function c(m){return m.replace(/&/g,"&&")}function l(m){if(m.endsWith("]")){const $=m.lastIndexOf(" [",m.length-2);if($!==-1){const S=g(m.substring(0,$)),D=m.substring($);return{name:S.name+D,parentPath:S.parentPath}}}return g(m)}function g(m){const $=m.indexOf("/")!==-1?C.$ic:C.$hc,S=$.basename(m),D=$.dirname(m);return S.length?{name:S,parentPath:D}:{name:D,parentPath:""}}}),define(Ce[161],Ie([1,0,23,38,2]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=void 0,e.$Nn=p,e.$On=P,e.$Pn=y;function O(u){return u.toJSON()}class A{constructor(E){this.a=E}transformIncoming(E){const d=this.a.transformIncoming(E);return d===E?E:O(C.URI.from(d))}transformOutgoing(E){const d=this.a.transformOutgoing(E);return d===E?E:O(C.URI.from(d))}transformOutgoingURI(E){const d=this.a.transformOutgoing(E);return d===E?E:C.URI.from(d)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.$Ln=A,e.$Mn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function T(u,E,d){if(!u||d>200)return null;if(typeof u=="object"){if(u instanceof C.URI)return E.transformOutgoing(u);for(const n in u)if(Object.hasOwnProperty.call(u,n)){const s=T(u[n],E,d+1);s!==null&&(u[n]=s)}}return null}function p(u,E){const d=T(u,E,0);return d===null?u:d}function a(u,E,d,n){if(!u||n>200)return null;if(typeof u=="object"){if(u.$mid===k.MarshalledId.Uri)return d?C.URI.revive(E.transformIncoming(u)):E.transformIncoming(u);if(u instanceof v.$Oe)return null;for(const s in u)if(Object.hasOwnProperty.call(u,s)){const o=a(u[s],E,d,n+1);o!==null&&(u[s]=o)}}return null}function P(u,E){const d=a(u,E,!1,0);return d===null?u:d}function y(u,E){const d=a(u,E,!0,0);return d===null?u:d}}),define(Ce[162],Ie([1,0,11,6,4,49,15]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.StorageState=e.StorageHint=void 0,e.$aq=p;var T;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function p(u){const E=u;return E?.changed instanceof Map||E?.deleted instanceof Set}var a;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(a||(e.StorageState=a={}));class P extends C.$Wc{static{this.a=100}constructor(E,d=Object.create(null)){super(),this.r=E,this.s=d,this.b=this.B(new k.$pe),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new v.$Dh(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((d,n)=>this.w(n,d)),E.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(E,d){if(this.c===a.Closed)return;let n=!1;(0,A.$og)(d)?n=this.f.delete(E):this.f.get(E)!==d&&(this.f.set(E,d),n=!0),n&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,d){const n=this.f.get(E);return(0,A.$og)(n)?d:n}getBoolean(E,d){const n=this.get(E);return(0,A.$og)(n)?d:n==="true"}getNumber(E,d){const n=this.get(E);return(0,A.$og)(n)?d:parseInt(n,10)}getObject(E,d){const n=this.get(E);return(0,A.$og)(n)?d:(0,O.$bi)(n)}async set(E,d,n=!1){if(this.c===a.Closed)return;if((0,A.$og)(d))return this.delete(E,n);const s=(0,A.$hg)(d)||Array.isArray(d)?(0,O.$ai)(d):String(d);if(this.f.get(E)!==s)return this.f.set(E,s),this.j.set(E,s),this.h.delete(E),this.b.fire({key:E,external:n}),this.D()}async delete(E,d=!1){if(!(this.c===a.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:d}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(!(this.c===a.Closed||this.m))return this.D(E)}async D(E){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$bq=P;class y{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((d,n)=>this.a.set(n,d)),E.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$cq=y}),define(Ce[163],Ie([1,0,13,21,23]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$au=void 0,e.$$t=P,e.$_t=y,v=qe(v),k=qe(k),C=qe(C);let O;function A(){return O||(O=new TextDecoder("UTF-16LE")),O}let T;function p(){return T||(T=new TextDecoder("UTF-16BE")),T}let a;function P(){return a||(a=k.$D()?A():p()),a}function y(d,n,s){const o=new Uint16Array(d.buffer,n,s);return s>0&&(o[0]===65279||o[0]===65534)?u(d,n,s):A().decode(o)}function u(d,n,s){const o=[];let h=0;for(let i=0;i<s;i++){const r=C.$Qe(d,n);n+=2,o[h++]=String.fromCharCode(r)}return o.join("")}class E{constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return P().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const s=this.a-this.d;s<=1&&(s===0||v.$Kf(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const s=n.length;if(this.d+s>=this.a){this.f(),this.c[this.c.length]=n;return}for(let o=0;o<s;o++)this.b[this.d++]=n.charCodeAt(o)}}e.$au=E}),define(Ce[164],Ie([1,0,23,163]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=void 0,e.$cu=A,v=qe(v);function C(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(a,P,y,u){this.oldPosition=a,this.oldText=P,this.newPosition=y,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(a){return 4+2*a.length}static c(a,P,y){const u=P.length;v.$Te(a,u,y),y+=4;for(let E=0;E<u;E++)v.$Re(a,P.charCodeAt(E),y),y+=2;return y}static d(a,P){const y=v.$Se(a,P);return P+=4,(0,k.$_t)(a,P,y)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(a,P){return v.$Te(a,this.oldPosition,P),P+=4,v.$Te(a,this.newPosition,P),P+=4,P=O.c(a,this.oldText,P),P=O.c(a,this.newText,P),P}static read(a,P,y){const u=v.$Se(a,P);P+=4;const E=v.$Se(a,P);P+=4;const d=O.d(a,P);P+=O.a(d);const n=O.d(a,P);return P+=O.a(n),y.push(new O(u,d,E,n)),P}}e.$bu=O;function A(p,a){return p===null||p.length===0?a:new T(p,a).compress()}class T{constructor(a,P){this.a=a,this.c=P,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let a=0,P=0,y=this.n(a),u=this.l(P);for(;a<this.f||P<this.h;){if(y===null){this.k(u),u=this.l(++P);continue}if(u===null){this.m(y),y=this.n(++a);continue}if(u.oldEnd<=y.newPosition){this.k(u),u=this.l(++P);continue}if(y.newEnd<=u.oldPosition){this.m(y),y=this.n(++a);continue}if(u.oldPosition<y.newPosition){const[o,h]=T.r(u,y.newPosition-u.oldPosition);this.k(o),u=h;continue}if(y.newPosition<u.oldPosition){const[o,h]=T.q(y,u.oldPosition-y.newPosition);this.m(o),y=h;continue}let n,s;if(u.oldEnd===y.newEnd)n=y,s=u,y=this.n(++a),u=this.l(++P);else if(u.oldEnd<y.newEnd){const[o,h]=T.q(y,u.oldLength);n=o,s=u,y=h,u=this.l(++P)}else{const[o,h]=T.r(u,y.newLength);n=y,s=o,y=this.n(++a),u=h}this.d[this.e++]=new O(n.oldPosition,n.oldText,s.newPosition,s.newText),this.g+=n.newLength-n.oldLength,this.j+=s.newLength-s.oldLength}const E=T.s(this.d);return T.t(E)}k(a){this.d[this.e++]=T.o(this.g,a),this.j+=a.newLength-a.oldLength}l(a){return a<this.h?this.c[a]:null}m(a){this.d[this.e++]=T.p(this.j,a),this.g+=a.newLength-a.oldLength}n(a){return a<this.f?this.a[a]:null}static o(a,P){return new O(P.oldPosition-a,P.oldText,P.newPosition,P.newText)}static p(a,P){return new O(P.oldPosition,P.oldText,P.newPosition+a,P.newText)}static q(a,P){const y=a.newText.substr(0,P),u=a.newText.substr(P);return[new O(a.oldPosition,a.oldText,a.newPosition,y),new O(a.oldEnd,"",a.newPosition+P,u)]}static r(a,P){const y=a.oldText.substr(0,P),u=a.oldText.substr(P);return[new O(a.oldPosition,y,a.newPosition,a.newText),new O(a.oldPosition+P,u,a.newEnd,"")]}static s(a){if(a.length===0)return a;const P=[];let y=0,u=a[0];for(let E=1;E<a.length;E++){const d=a[E];u.oldEnd===d.oldPosition?u=new O(u.oldPosition,u.oldText+d.oldText,u.newPosition,u.newText+d.newText):(P[y++]=u,u=d)}return P[y++]=u,P}static t(a){if(a.length===0)return a;const P=[];let y=0;for(let u=0;u<a.length;u++){const E=a[u];E.oldText!==E.newText&&(P[y++]=E)}return P}}}),define(Ce[165],Ie([1,0,42,20]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$su=C,e.$tu=O;function C(A,T,p,a,P,y){if(Array.isArray(A)){let u=0;for(const E of A){const d=C(E,T,p,a,P,y);if(d===10)return d;d>u&&(u=d)}return u}else{if(typeof A=="string")return a?A==="*"?5:A===p?10:0:0;if(A){const{language:u,pattern:E,scheme:d,hasAccessToAllModels:n,notebookType:s}=A;if(!a&&!n)return 0;s&&P&&(T=P);let o=0;if(d)if(d===T.scheme)o=10;else if(d==="*")o=5;else return 0;if(u)if(u===p)o=10;else if(u==="*")o=Math.max(o,5);else return 0;if(s)if(s===y)o=10;else if(s==="*"&&y!==void 0)o=Math.max(o,5);else return 0;if(E){let h;if(typeof E=="string"?h=E:h={...E,base:(0,k.$jc)(E.base)},h===T.fsPath||(0,v.$yk)(h,T.fsPath))o=10;else return 0}return o}else return 0}}function O(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(O):!!A.notebookType}}),define(Ce[166],Ie([1,0,6,13,33,52,100,149,164,4]),function(oe,e,v,k,C,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lD=void 0,k=qe(k);class P extends a.$Wc{constructor(u,E,d,n,s,o,h){super(),this.m=this.B(new v.$me),this.onDidChangeContent=this.m.event,this.f=E,this.j=!o,this.g=n,this.h=s,this.c=new A.$kD(u,d,h)}equals(u){return!(u instanceof P)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,E){return this.c.getOffsetAt(u,E)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,E){const d=u+E,n=this.getPositionAt(u),s=this.getPositionAt(d);return new C.$Lt(n.lineNumber,n.column,s.lineNumber,s.column)}getValueInRange(u,E=O.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const d=this.n(E);return this.c.getValueInRange(u,d)}getValueLengthInRange(u,E=O.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const d=this.getOffsetAt(u.startLineNumber,u.startColumn),n=this.getOffsetAt(u.endLineNumber,u.endColumn);let s=0;const o=this.n(E),h=this.getEOL();if(o.length!==h.length){const i=o.length-h.length,r=u.endLineNumber-u.startLineNumber;s=i*r}return n-d+s}getCharacterCountInRange(u,E=O.EndOfLinePreference.TextDefined){if(this.j){let d=0;const n=u.startLineNumber,s=u.endLineNumber;for(let o=n;o<=s;o++){const h=this.getLineContent(o),i=o===n?u.startColumn-1:0,r=o===s?u.endColumn-1:h.length;for(let t=i;t<r;t++)k.$Kf(h.charCodeAt(t))?(d=d+1,t=t+1):d=d+1}return d+=this.n(E).length*(s-n),d}return this.getValueLengthInRange(u,E)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,E){return this.c.getLineCharCode(u,E)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const E=k.$vf(this.getLineContent(u));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(u){const E=k.$xf(this.getLineContent(u));return E===-1?0:E+2}n(u){switch(u){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,E,d){let n=this.g,s=this.h,o=this.j,h=!0,i=[];for(let $=0;$<u.length;$++){const S=u[$];h&&S._isTracked&&(h=!1);const D=S.range;if(S.text){let w=!0;o||(w=!k.$Vf(S.text),o=w),!n&&w&&(n=k.$Uf(S.text)),!s&&w&&(s=k.$Xf(S.text))}let b="",I=0,R=0,f=0;if(S.text){let w;[I,R,f,w]=(0,T.$vu)(S.text);const M=this.getEOL(),N=M===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;w===T.StringEOL.Unknown||w===N?b=S.text:b=S.text.replace(/\r\n|\r|\n/g,M)}i[$]={sortIndex:$,identifier:S.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:b,eolCount:I,firstLineLength:R,lastLineLength:f,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}i.sort(P.u);let r=!1;for(let $=0,S=i.length-1;$<S;$++){const D=i[$].range.getEndPosition(),b=i[$+1].range.getStartPosition();if(b.isBeforeOrEqual(D)){if(b.isBefore(D))throw new Error("Overlapping ranges are not allowed!");r=!0}}h&&(i=this.s(i));const t=d||E?P._getInverseEditRanges(i):[],c=[];if(E)for(let $=0;$<i.length;$++){const S=i[$],D=t[$];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let b=D.startLineNumber;b<=D.endLineNumber;b++){let I="";b===D.startLineNumber&&(I=this.getLineContent(S.range.startLineNumber),k.$vf(I)!==-1)||c.push({lineNumber:b,oldContent:I})}}let l=null;if(d){let $=0;l=[];for(let S=0;S<i.length;S++){const D=i[S],b=t[S],I=this.getValueInRange(D.range),R=D.rangeOffset+$;$+=D.text.length-I.length,l[S]={sortIndex:D.sortIndex,identifier:D.identifier,range:b,text:I,textChange:new p.$bu(D.rangeOffset,I,R,D.text)}}r||l.sort((S,D)=>S.sortIndex-D.sortIndex)}this.g=n,this.h=s,this.j=o;const g=this.t(i);let m=null;if(E&&c.length>0){c.sort(($,S)=>S.lineNumber-$.lineNumber),m=[];for(let $=0,S=c.length;$<S;$++){const D=c[$].lineNumber;if($>0&&c[$-1].lineNumber===D)continue;const b=c[$].oldContent,I=this.getLineContent(D);I.length===0||I===b||k.$vf(I)!==-1||m.push(D)}}return this.m.fire(),new O.$ew(l,g,m)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let E=!1;const d=u[0].range,n=u[u.length-1].range,s=new C.$Lt(d.startLineNumber,d.startColumn,n.endLineNumber,n.endColumn);let o=d.startLineNumber,h=d.startColumn;const i=[];for(let g=0,m=u.length;g<m;g++){const $=u[g],S=$.range;E=E||$.forceMoveMarkers,i.push(this.getValueInRange(new C.$Lt(o,h,S.startLineNumber,S.startColumn))),$.text.length>0&&i.push($.text),o=S.endLineNumber,h=S.endColumn}const r=i.join(""),[t,c,l]=(0,T.$vu)(r);return{sortIndex:0,identifier:u[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,O.EndOfLinePreference.TextDefined),text:r,eolCount:t,firstLineLength:c,lastLineLength:l,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(u){u.sort(P.w);const E=[];for(let d=0;d<u.length;d++){const n=u[d],s=n.range.startLineNumber,o=n.range.startColumn,h=n.range.endLineNumber,i=n.range.endColumn;if(s===h&&o===i&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const r=new C.$Lt(s,o,h,i);E.push({range:r,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return E}findMatchesLineByLine(u,E,d,n){return this.c.findMatchesLineByLine(u,E,d,n)}getPieceTree(){return this.c}static _getInverseEditRange(u,E){const d=u.startLineNumber,n=u.startColumn,[s,o,h]=(0,T.$vu)(E);let i;if(E.length>0){const r=s+1;r===1?i=new C.$Lt(d,n,d,n+o):i=new C.$Lt(d,n,d+r-1,h+1)}else i=new C.$Lt(d,n,d,n);return i}static _getInverseEditRanges(u){const E=[];let d=0,n=0,s=null;for(let o=0,h=u.length;o<h;o++){const i=u[o];let r,t;s?s.range.endLineNumber===i.range.startLineNumber?(r=d,t=n+(i.range.startColumn-s.range.endColumn)):(r=d+(i.range.startLineNumber-s.range.endLineNumber),t=i.range.startColumn):(r=i.range.startLineNumber,t=i.range.startColumn);let c;if(i.text.length>0){const l=i.eolCount+1;l===1?c=new C.$Lt(r,t,r,t+i.firstLineLength):c=new C.$Lt(r,t,r+l-1,i.lastLineLength+1)}else c=new C.$Lt(r,t,r,t);d=c.endLineNumber,n=c.endColumn,E.push(c),s=i}return E}static u(u,E){const d=C.$Lt.compareRangesUsingEnds(u.range,E.range);return d===0?u.sortIndex-E.sortIndex:d}static w(u,E){const d=C.$Lt.compareRangesUsingEnds(u.range,E.range);return d===0?E.sortIndex-u.sortIndex:-d}}e.$lD=P}),define(Ce[167],Ie([1,0,28,13,52,100,166]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mD=void 0,k=qe(k);class T{constructor(P,y,u,E,d,n,s,o,h){this.a=P,this.b=y,this.c=u,this.d=E,this.e=d,this.f=n,this.g=s,this.h=o,this.j=h}k(P){const y=this.c+this.d+this.e,u=this.c+this.e;return y===0?P===C.DefaultEndOfLine.LF?`
`:`\r
`:u>y/2?`\r
`:`
`}create(P){const y=this.k(P),u=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let d=0,n=u.length;d<n;d++){const s=u[d].buffer.replace(/\r\n|\r|\n/g,y),o=(0,O.$gD)(s);u[d]=new O.$jD(s,o)}const E=new A.$lD(u,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(P){return this.a[0].buffer.substr(0,P).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(P){if(P.length===0)return;this.a.length===0&&k.$6f(P)&&(this.b=k.$5f,P=P.substr(1));const y=P.charCodeAt(P.length-1);y===v.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(P.substr(0,P.length-1),!1),this.c=!0,this.d=y):(this.m(P,!1),this.c=!1,this.d=y)}m(P,y){!y&&P.length===0||(this.c?this.n(String.fromCharCode(this.d)+P):this.n(P))}n(P){const y=(0,O.$hD)(this.e,P);this.a.push(new O.$jD(P,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=k.$Uf(P)),this.k||(this.k=k.$Xf(P)))}finish(P=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,P)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const P=this.a[this.a.length-1];P.buffer+=String.fromCharCode(this.d);const y=(0,O.$gD)(P.buffer);P.lineStarts=y,this.d===v.CharCode.CarriageReturn&&this.f++}}}e.$mD=p}),define(Ce[104],Ie([1,0,23,21]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdb=p,e.$Gdb=P,k=qe(k);var C;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(C||(C={}));function O(y){for(let u=0,E=y.length;u<E;u+=4){const d=y[u+0],n=y[u+1],s=y[u+2],o=y[u+3];y[u+0]=o,y[u+1]=s,y[u+2]=n,y[u+3]=d}}function A(y){const u=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return k.$D()||O(u),v.$Oe.wrap(u)}function T(y){const u=y.buffer;if(k.$D()||O(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const E=new Uint8Array(u.byteLength);return E.set(u),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function p(y){const u=new Uint32Array(a(y));let E=0;if(u[E++]=y.id,y.type==="full")u[E++]=C.Full,u[E++]=y.data.length,u.set(y.data,E),E+=y.data.length;else{u[E++]=C.Delta,u[E++]=y.deltas.length;for(const d of y.deltas)u[E++]=d.start,u[E++]=d.deleteCount,d.data?(u[E++]=d.data.length,u.set(d.data,E),E+=d.data.length):u[E++]=0}return A(u)}function a(y){let u=0;if(u+=2,y.type==="full")u+=1+y.data.length;else{u+=1,u+=3*y.deltas.length;for(const E of y.deltas)E.data&&(u+=E.data.length)}return u}function P(y){const u=T(y);let E=0;const d=u[E++];if(u[E++]===C.Full){const h=u[E++],i=u.subarray(E,E+h);return E+=h,{id:d,type:"full",data:i}}const s=u[E++],o=[];for(let h=0;h<s;h++){const i=u[E++],r=u[E++],t=u[E++];let c;t>0&&(c=u.subarray(E,E+t),E+=t),o[h]={start:i,deleteCount:r,data:c}}return{id:d,type:"delta",deltas:o}}}),define(Ce[168],Ie([9,10]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(Ce[169],Ie([9,10]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[170],Ie([9,10]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[171],Ie([9,10]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[172],Ie([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[173],Ie([9,10]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[174],Ie([9,10]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(Ce[175],Ie([9,10]),function(oe,e){return oe.create("vs/platform/log/common/log",e)}),define(Ce[176],Ie([9,10]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(Ce[177],Ie([9,10]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(Ce[178],Ie([9,10]),function(oe,e){return oe.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[179],Ie([9,10]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ce[180],Ie([9,10]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(Ce[181],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[182],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[183],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[184],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ce[185],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[186],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[187],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[188],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[189],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[190],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[191],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[192],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[193],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/common/configuration",e)}),define(Ce[194],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(Ce[195],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/common/views",e)}),define(Ce[196],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ce[197],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ce[198],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[199],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[200],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[201],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[202],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/testing/common/constants",e)}),define(Ce[203],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[204],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[205],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[206],Ie([9,10]),function(oe,e){return oe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[207],Ie([1,0,28,14,171]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var O;(function(P){P[P.LParen=0]="LParen",P[P.RParen=1]="RParen",P[P.Neg=2]="Neg",P[P.Eq=3]="Eq",P[P.NotEq=4]="NotEq",P[P.Lt=5]="Lt",P[P.LtEq=6]="LtEq",P[P.Gt=7]="Gt",P[P.GtEq=8]="GtEq",P[P.RegexOp=9]="RegexOp",P[P.RegexStr=10]="RegexStr",P[P.True=11]="True",P[P.False=12]="False",P[P.In=13]="In",P[P.Not=14]="Not",P[P.And=15]="And",P[P.Or=16]="Or",P[P.Str=17]="Str",P[P.QuotedStr=18]="QuotedStr",P[P.Error=19]="Error",P[P.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...P){switch(P.length){case 1:return(0,C.localize)(0,null,P[0]);case 2:return(0,C.localize)(1,null,P[0],P[1]);case 3:return(0,C.localize)(2,null,P[0],P[1],P[2]);default:return}}const T=(0,C.localize)(3,null),p=(0,C.localize)(4,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return y.isTripleEq?"===":"==";case O.NotEq:return y.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return y.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return y.lexeme;case O.QuotedStr:return y.lexeme;case O.Error:return y.lexeme;case O.EOF:return"EOF";default:throw(0,k.$0)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case v.CharCode.OpenParen:this.k(O.LParen);break;case v.CharCode.CloseParen:this.k(O.RParen);break;case v.CharCode.ExclamationMark:if(this.h(v.CharCode.Equals)){const u=this.h(v.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:u})}else this.k(O.Neg);break;case v.CharCode.SingleQuote:this.o();break;case v.CharCode.Slash:this.q();break;case v.CharCode.Equals:if(this.h(v.CharCode.Equals)){const u=this.h(v.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:u})}else this.h(v.CharCode.Tilde)?this.k(O.RegexOp):this.l(A("==","=~"));break;case v.CharCode.LessThan:this.k(this.h(v.CharCode.Equals)?O.LtEq:O.Lt);break;case v.CharCode.GreaterThan:this.k(this.h(v.CharCode.Equals)?O.GtEq:O.Gt);break;case v.CharCode.Ampersand:this.h(v.CharCode.Ampersand)?this.k(O.And):this.l(A("&&"));break;case v.CharCode.Pipe:this.h(v.CharCode.Pipe)?this.k(O.Or):this.l(A("||"));break;case v.CharCode.Space:case v.CharCode.CarriageReturn:case v.CharCode.Tab:case v.CharCode.LineFeed:case v.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?v.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const u=this.d,E=this.c.substring(this.d,this.e),d={type:O.Error,offset:this.d,lexeme:E};this.g.push({offset:u,lexeme:E,additionalInfo:y}),this.f.push(d)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const u=this.c.substring(this.d,this.e),E=a.b.get(u);E?this.k(E):this.f.push({type:O.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==v.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,u=!1,E=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(p);return}const n=this.c.charCodeAt(y);if(u)u=!1;else if(n===v.CharCode.Slash&&!E){y++;break}else n===v.CharCode.OpenSquareBracket?E=!0:n===v.CharCode.Backslash?u=!0:n===v.CharCode.CloseSquareBracket&&(E=!1);y++}for(;y<this.c.length&&a.a.has(this.c.charCodeAt(y));)y++;this.e=y;const d=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=a}),define(Ce[105],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const v={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(v)}),define(Ce[74],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class v{constructor(C,O=[],A=!1){this.ctor=C,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.$Ci=v}),define(Ce[61],Ie([1,0,74]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Os=O,e.$Ps=A;const k=[];var C;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function O(T,p,a){p instanceof v.$Ci||(p=new v.$Ci(p,[],!!a)),k.push([T,p])}function A(){return k}}),define(Ce[208],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0;class v{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$rr=v;class k{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const A of this.a.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const T=this.lookupOrInsertNode(O),p=this.lookupOrInsertNode(A);T.outgoing.set(p.key,p),p.incoming.set(T.key,T)}removeNode(O){const A=this.b(O);this.a.delete(A);for(const T of this.a.values())T.outgoing.delete(A),T.incoming.delete(A)}lookupOrInsertNode(O){const A=this.b(O);let T=this.a.get(A);return T||(T=new v(A,O),this.a.set(A,T)),T}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[A,T]of this.a)O.push(`${A}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this.a){const T=new Set([O]),p=this.c(A,T);if(p)return p}}c(O,A){for(const[T,p]of O.outgoing){if(A.has(T))return[...A,T].join(" -> ");A.add(T);const a=this.c(p,A);if(a)return a;A.delete(T)}}}e.$sr=k}),define(Ce[3],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=C,e.$Gi=O;var v;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function T(p){return p[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=T})(v||(e._util=v={})),e.$Ei=C("instantiationService");function k(A,T,p){T[v.DI_TARGET]===T?T[v.DI_DEPENDENCIES].push({id:A,index:p}):(T[v.DI_DEPENDENCIES]=[{id:A,index:p}],T[v.DI_TARGET]=T)}function C(A){if(v.serviceIds.has(A))return v.serviceIds.get(A);const T=function(p,a,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(T,p,P)};return T.toString=()=>A,v.serviceIds.set(A,T),T}function O(A){return A}}),define(Ce[43],Ie([1,0,15,2,3]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=O,e.$bj=A,e.$cj=p,e.$dj=a,e.$ej=P,e.$fj=y,e.$gj=u,e.$hj=d,e.$ij=n,e.$jj=s,v=qe(v),e.$_i=(0,C.$Fi)("configurationService");function O(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof k.URI)}function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof k.URI)}var T;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function p(o){switch(o){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function a(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function P(o,h){const i=Object.create(null);for(const r in o)y(i,r,o[r],h);return i}function y(o,h,i,r){const t=h.split("."),c=t.pop();let l=o;for(let g=0;g<t.length;g++){const m=t[g];let $=l[m];switch(typeof $){case"undefined":$=l[m]=Object.create(null);break;case"object":if($===null){r(`Ignoring ${h} as ${t.slice(0,g+1).join(".")} is null`);return}break;default:r(`Ignoring ${h} as ${t.slice(0,g+1).join(".")} is ${JSON.stringify($)}`);return}l=$}if(typeof l=="object"&&l!==null)try{l[c]=i}catch{r(`Ignoring ${h} as ${t.join(".")} is ${JSON.stringify(l)}`)}else r(`Ignoring ${h} as ${t.join(".")} is ${JSON.stringify(l)}`)}function u(o,h){const i=h.split(".");E(o,i)}function E(o,h){const i=h.shift();if(h.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const r=o[i];typeof r=="object"&&!Array.isArray(r)&&(E(r,h),Object.keys(r).length===0&&delete o[i])}}function d(o,h,i){function r(l,g){let m=l;for(const $ of g){if(typeof m!="object"||m===null)return;m=m[$]}return m}const t=h.split("."),c=r(o,t);return typeof c>"u"?i:c}function n(o,h,i){Object.keys(h).forEach(r=>{r!=="__proto__"&&(r in o?v.$hg(o[r])&&v.$hg(h[r])?n(o[r],h[r],i):i&&(o[r]=h[r]):o[r]=h[r])})}function s(o){return o.replace(/[\[\]]/g,"")}}),define(Ce[32],Ie([1,0,28,21,13,207,3,170,14]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=P,e.$Ej=g,e.$Fj=m,e.$Yj=re;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",k.$j),a.set("isLinux",k.$k),a.set("isWindows",k.$i),a.set("isWeb",k.$o),a.set("isMacNative",k.$j&&!k.$o),a.set("isEdge",k.$H),a.set("isFirefox",k.$F),a.set("isChrome",k.$E),a.set("isSafari",k.$G);function P(Y,q){if(a.get(Y)!==void 0)throw(0,p.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(Y,q)}const y=Object.prototype.hasOwnProperty;var u;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const E={regexParsingWithErrorRecovery:!0},d=(0,T.localize)(0,null),n=(0,T.localize)(1,null),s=(0,T.localize)(2,null),o=(0,T.localize)(3,null),h=(0,T.localize)(4,null),i=(0,T.localize)(5,null),r=(0,T.localize)(6,null),t=(0,T.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=E){this.k=q,this.d=new O.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:n});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const ee=this.l();if(!this.E()){const ve=this.D(),ue=ve.type===O.TokenType.Str?i:void 0;throw this.h.push({message:h,offset:ve.offset,lexeme:O.$Aj.getLexeme(ve),additionalInfo:ue}),c.c}return ee}catch(ee){if(ee!==c.c)throw ee;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(O.TokenType.Or);){const ee=this.o();q.push(ee)}return q.length===1?q[0]:l.or(...q)}o(){const q=[this.s()];for(;this.y(O.TokenType.And);){const ee=this.s();q.push(ee)}return q.length===1?q[0]:l.and(...q)}s(){if(this.y(O.TokenType.Neg)){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),S.INSTANCE;case O.TokenType.False:return this.z(),D.INSTANCE;case O.TokenType.LParen:{this.z();const ee=this.l();return this.A(O.TokenType.RParen,o),ee?.negate()}case O.TokenType.Str:return this.z(),M.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),l.true();case O.TokenType.False:return this.z(),l.false();case O.TokenType.LParen:{this.z();const ee=this.l();return this.A(O.TokenType.RParen,o),ee}case O.TokenType.Str:{const ee=q.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const ue=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ue.type!==O.TokenType.RegexStr)throw this.B("REGEX",ue);const be=ue.lexeme,de=be.lastIndexOf("/"),X=de===be.length-1?void 0:this.w(be.substring(de+1));let Z;try{Z=new RegExp(be.substring(1,de),X)}catch{throw this.B("REGEX",ue)}return V.create(ee,Z)}switch(ue.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const be=[ue.lexeme];this.z();let de=this.D(),X=0;for(let ze=0;ze<ue.lexeme.length;ze++)ue.lexeme.charCodeAt(ze)===v.CharCode.OpenParen?X++:ue.lexeme.charCodeAt(ze)===v.CharCode.CloseParen&&X--;for(;!this.E()&&de.type!==O.TokenType.And&&de.type!==O.TokenType.Or;){switch(de.type){case O.TokenType.LParen:X++;break;case O.TokenType.RParen:X--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let ze=0;ze<de.lexeme.length;ze++)de.lexeme.charCodeAt(ze)===v.CharCode.OpenParen?X++:ue.lexeme.charCodeAt(ze)===v.CharCode.CloseParen&&X--}if(X<0)break;be.push(O.$Aj.getLexeme(de)),this.z(),de=this.D()}const Z=be.join(""),me=Z.lastIndexOf("/"),pe=me===Z.length-1?void 0:this.w(Z.substring(me+1));let Oe;try{Oe=new RegExp(Z.substring(1,me),pe)}catch{throw this.B("REGEX",ue)}return l.regex(ee,Oe)}case O.TokenType.QuotedStr:{const be=ue.lexeme;this.z();let de=null;if(!(0,C.$df)(be)){const X=be.indexOf("/"),Z=be.lastIndexOf("/");if(X!==Z&&X>=0){const me=be.slice(X+1,Z),pe=be[Z+1]==="i"?"i":"";try{de=new RegExp(me,pe)}catch{throw this.B("REGEX",ue)}}}if(de===null)throw this.B("REGEX",ue);return V.create(ee,de)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,s);const ue=this.u();return l.notIn(ee,ue)}switch(this.D().type){case O.TokenType.Eq:{this.z();const ue=this.u();if(this.x().type===O.TokenType.QuotedStr)return l.equals(ee,ue);switch(ue){case"true":return l.has(ee);case"false":return l.not(ee);default:return l.equals(ee,ue)}}case O.TokenType.NotEq:{this.z();const ue=this.u();if(this.x().type===O.TokenType.QuotedStr)return l.notEquals(ee,ue);switch(ue){case"true":return l.not(ee);case"false":return l.has(ee);default:return l.notEquals(ee,ue)}}case O.TokenType.Lt:return this.z(),W.create(ee,this.u());case O.TokenType.LtEq:return this.z(),F.create(ee,this.u());case O.TokenType.Gt:return this.z(),L.create(ee,this.u());case O.TokenType.GtEq:return this.z(),G.create(ee,this.u());case O.TokenType.In:return this.z(),l.in(ee,this.u());default:return l.has(ee)}}case O.TokenType.EOF:throw this.h.push({message:r,offset:q.offset,lexeme:"",additionalInfo:t}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),q.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,ee){if(this.C(q))return this.z();throw this.B(ee,this.D())}B(q,ee,ve){const ue=(0,T.localize)(8,null,q,O.$Aj.getLexeme(ee)),be=ee.offset,de=O.$Aj.getLexeme(ee);return this.h.push({message:ue,offset:be,lexeme:de,additionalInfo:ve}),c.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$Cj=c;class l{static false(){return S.INSTANCE}static true(){return D.INSTANCE}static has(q){return b.create(q)}static equals(q,ee){return I.create(q,ee)}static notEquals(q,ee){return w.create(q,ee)}static regex(q,ee){return V.create(q,ee)}static in(q,ee){return R.create(q,ee)}static notIn(q,ee){return f.create(q,ee)}static not(q){return M.create(q)}static and(...q){return _.create(q,null,!0)}static or(...q){return ge.create(q,null,!0)}static greater(q,ee){return L.create(q,ee)}static greaterEquals(q,ee){return G.create(q,ee)}static smaller(q,ee){return W.create(q,ee)}static smallerEquals(q,ee){return F.create(q,ee)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$Dj=l;function g(Y){const q=new c({regexParsingWithErrorRecovery:!1});return Y.map(ee=>(q.parse(ee),q.lexingErrors.length>0?q.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,T.localize)(9,null,ve.additionalInfo):(0,T.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function m(Y,q){const ee=Y?Y.substituteConstants():void 0,ve=q?q.substituteConstants():void 0;return!ee&&!ve?!0:!ee||!ve?!1:ee.equals(ve)}function $(Y,q){return Y.cmp(q)}class S{static{this.INSTANCE=new S}constructor(){this.type=u.False}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return D.INSTANCE}}e.$Gj=S;class D{static{this.INSTANCE=new D}constructor(){this.type=u.True}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return S.INSTANCE}}e.$Hj=D;class b{static create(q,ee=null){const ve=a.get(q);return typeof ve=="boolean"?ve?D.INSTANCE:S.INSTANCE:new b(q,ee)}constructor(q,ee){this.key=q,this.c=ee,this.type=u.Defined}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=a.get(this.key);return typeof q=="boolean"?q?D.INSTANCE:S.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Ij=b;class I{static create(q,ee,ve=null){if(typeof ee=="boolean")return ee?b.create(q,ve):M.create(q,ve);const ue=a.get(q);return typeof ue=="boolean"?ee===(ue?"true":"false")?D.INSTANCE:S.INSTANCE:new I(q,ee,ve)}constructor(q,ee,ve){this.c=q,this.d=ee,this.f=ve,this.type=u.Equals}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=a.get(this.c);if(typeof q=="boolean"){const ee=q?"true":"false";return this.d===ee?D.INSTANCE:S.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Jj=I;class R{static create(q,ee){return new R(q,ee)}constructor(q,ee){this.d=q,this.f=ee,this.type=u.In,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:we(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const ee=q.getValue(this.f),ve=q.getValue(this.d);return Array.isArray(ee)?ee.includes(ve):typeof ve=="string"&&typeof ee=="object"&&ee!==null?y.call(ee,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Kj=R;class f{static create(q,ee){return new f(q,ee)}constructor(q,ee){this.d=q,this.f=ee,this.type=u.NotIn,this.c=R.create(q,ee)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=f;class w{static create(q,ee,ve=null){if(typeof ee=="boolean")return ee?M.create(q,ve):b.create(q,ve);const ue=a.get(q);return typeof ue=="boolean"?ee===(ue?"true":"false")?S.INSTANCE:D.INSTANCE:new w(q,ee,ve)}constructor(q,ee,ve){this.c=q,this.d=ee,this.f=ve,this.type=u.NotEquals}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=a.get(this.c);if(typeof q=="boolean"){const ee=q?"true":"false";return this.d===ee?S.INSTANCE:D.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Mj=w;class M{static create(q,ee=null){const ve=a.get(q);return typeof ve=="boolean"?ve?S.INSTANCE:D.INSTANCE:new M(q,ee)}constructor(q,ee){this.c=q,this.d=ee,this.type=u.Not}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=a.get(this.c);return typeof q=="boolean"?q?S.INSTANCE:D.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Nj=M;function N(Y,q){if(typeof Y=="string"){const ee=parseFloat(Y);isNaN(ee)||(Y=ee)}return typeof Y=="string"||typeof Y=="number"?q(Y):S.INSTANCE}class L{static create(q,ee,ve=null){return N(ee,ue=>new L(q,ue,ve))}constructor(q,ee,ve){this.c=q,this.d=ee,this.f=ve,this.type=u.Greater}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Oj=L;class G{static create(q,ee,ve=null){return N(ee,ue=>new G(q,ue,ve))}constructor(q,ee,ve){this.c=q,this.d=ee,this.f=ve,this.type=u.GreaterEquals}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Pj=G;class W{static create(q,ee,ve=null){return N(ee,ue=>new W(q,ue,ve))}constructor(q,ee,ve){this.c=q,this.d=ee,this.f=ve,this.type=u.Smaller}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Qj=W;class F{static create(q,ee,ve=null){return N(ee,ue=>new F(q,ue,ve))}constructor(q,ee,ve){this.c=q,this.d=ee,this.f=ve,this.type=u.SmallerEquals}cmp(q){return q.type!==this.type?this.type-q.type:we(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Rj=F;class V{static create(q,ee){return new V(q,ee)}constructor(q,ee){this.d=q,this.f=ee,this.type=u.Regex,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const ee=this.f?this.f.source:"",ve=q.f?q.f.source:"";return ee<ve?-1:ee>ve?1:0}equals(q){if(q.type===this.type){const ee=this.f?this.f.source:"",ve=q.f?q.f.source:"";return this.d===q.d&&ee===ve}return!1}substituteConstants(){return this}evaluate(q){const ee=q.getValue(this.d);return this.f?this.f.test(ee):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$Sj=V;class ae{static create(q){return new ae(q)}constructor(q){this.c=q,this.type=u.NotRegex}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new ae(this.c.map(q))}negate(){return this.c}}e.$Tj=ae;function $e(Y){let q=null;for(let ee=0,ve=Y.length;ee<ve;ee++){const ue=Y[ee].substituteConstants();if(Y[ee]!==ue&&q===null){q=[];for(let be=0;be<ee;be++)q[be]=Y[be]}q!==null&&(q[ee]=ue)}return q===null?Y:q}class _{static create(q,ee,ve){return _.d(q,ee,ve)}constructor(q,ee){this.expr=q,this.c=ee,this.type=u.And}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ee=0,ve=this.expr.length;ee<ve;ee++){const ue=$(this.expr[ee],q.expr[ee]);if(ue!==0)return ue}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ee=0,ve=this.expr.length;ee<ve;ee++)if(!this.expr[ee].equals(q.expr[ee]))return!1;return!0}return!1}substituteConstants(){const q=$e(this.expr);return q===this.expr?this:_.create(q,this.c,!1)}evaluate(q){for(let ee=0,ve=this.expr.length;ee<ve;ee++)if(!this.expr[ee].evaluate(q))return!1;return!0}static d(q,ee,ve){const ue=[];let be=!1;for(const de of q)if(de){if(de.type===u.True){be=!0;continue}if(de.type===u.False)return S.INSTANCE;if(de.type===u.And){ue.push(...de.expr);continue}ue.push(de)}if(ue.length===0&&be)return D.INSTANCE;if(ue.length!==0){if(ue.length===1)return ue[0];ue.sort($);for(let de=1;de<ue.length;de++)ue[de-1].equals(ue[de])&&(ue.splice(de,1),de--);if(ue.length===1)return ue[0];for(;ue.length>1;){const de=ue[ue.length-1];if(de.type!==u.Or)break;ue.pop();const X=ue.pop(),Z=ue.length===0,me=ge.create(de.expr.map(pe=>_.create([pe,X],null,ve)),null,Z);me&&(ue.push(me),ue.sort($))}if(ue.length===1)return ue[0];if(ve){for(let de=0;de<ue.length;de++)for(let X=de+1;X<ue.length;X++)if(ue[de].negate().equals(ue[X]))return S.INSTANCE;if(ue.length===1)return ue[0]}return new _(ue,ee)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const ee of this.expr)q.push(...ee.keys());return q}map(q){return new _(this.expr.map(ee=>ee.map(q)),null)}negate(){if(!this.c){const q=[];for(const ee of this.expr)q.push(ee.negate());this.c=ge.create(q,this,!0)}return this.c}}e.$Uj=_;class ge{static create(q,ee,ve){return ge.d(q,ee,ve)}constructor(q,ee){this.expr=q,this.c=ee,this.type=u.Or}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ee=0,ve=this.expr.length;ee<ve;ee++){const ue=$(this.expr[ee],q.expr[ee]);if(ue!==0)return ue}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ee=0,ve=this.expr.length;ee<ve;ee++)if(!this.expr[ee].equals(q.expr[ee]))return!1;return!0}return!1}substituteConstants(){const q=$e(this.expr);return q===this.expr?this:ge.create(q,this.c,!1)}evaluate(q){for(let ee=0,ve=this.expr.length;ee<ve;ee++)if(this.expr[ee].evaluate(q))return!0;return!1}static d(q,ee,ve){let ue=[],be=!1;if(q){for(let de=0,X=q.length;de<X;de++){const Z=q[de];if(Z){if(Z.type===u.False){be=!0;continue}if(Z.type===u.True)return D.INSTANCE;if(Z.type===u.Or){ue=ue.concat(Z.expr);continue}ue.push(Z)}}if(ue.length===0&&be)return S.INSTANCE;ue.sort($)}if(ue.length!==0){if(ue.length===1)return ue[0];for(let de=1;de<ue.length;de++)ue[de-1].equals(ue[de])&&(ue.splice(de,1),de--);if(ue.length===1)return ue[0];if(ve){for(let de=0;de<ue.length;de++)for(let X=de+1;X<ue.length;X++)if(ue[de].negate().equals(ue[X]))return D.INSTANCE;if(ue.length===1)return ue[0]}return new ge(ue,ee)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const ee of this.expr)q.push(...ee.keys());return q}map(q){return new ge(this.expr.map(ee=>ee.map(q)),null)}negate(){if(!this.c){const q=[];for(const ee of this.expr)q.push(ee.negate());for(;q.length>1;){const ee=q.shift(),ve=q.shift(),ue=[];for(const be of Me(ee))for(const de of Me(ve))ue.push(_.create([be,de],null,!1));q.unshift(ge.create(ue,null,!1))}this.c=ge.create(q,this,!0)}return this.c}}e.$Vj=ge;class se extends b{static{this.d=[]}static all(){return se.d.values()}constructor(q,ee,ve){super(q,null),this.f=ee,typeof ve=="object"?se.d.push({...ve,key:q}):ve!==!0&&se.d.push({key:q,description:ve,type:ee!=null?typeof ee:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return I.create(this.key,q)}notEqualsTo(q){return w.create(this.key,q)}}e.$Wj=se,e.$Xj=(0,A.$Fi)("contextKeyService");function ce(Y,q){return Y<q?-1:Y>q?1:0}function we(Y,q,ee,ve){return Y<ee?-1:Y>ee?1:q<ve?-1:q>ve?1:0}function re(Y,q){if(Y.type===u.False||q.type===u.True)return!0;if(Y.type===u.Or)return q.type===u.Or?Pe(Y.expr,q.expr):!1;if(q.type===u.Or){for(const ee of q.expr)if(re(Y,ee))return!0;return!1}if(Y.type===u.And){if(q.type===u.And)return Pe(q.expr,Y.expr);for(const ee of Y.expr)if(re(ee,q))return!0;return!1}return Y.equals(q)}function Pe(Y,q){let ee=0,ve=0;for(;ee<Y.length&&ve<q.length;){const ue=Y[ee].cmp(q[ve]);if(ue<0)return!1;ue===0&&ee++,ve++}return ee===Y.length}function Me(Y){return Y.type===u.Or?Y.expr:[Y]}}),define(Ce[209],Ie([1,0,32,3]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$pt=e.AccessibilitySupport=e.$ot=void 0,e.$qt=O,e.$ot=(0,k.$Fi)("accessibilityService");var C;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(C||(e.AccessibilitySupport=C={})),e.$pt=new v.$Wj("accessibilityModeEnabled",!1);function O(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$rt="ACCESSIBLE_VIEW_SHOWN_"}),define(Ce[106],Ie([1,0,18,26,21,144,322,150,210,168,209]),function(oe,e,v,k,C,O,A,T,p,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=l,e.stringSet=$,e.cursorStyleToString=N,e.filterValidationDecorations=Ae,v=qe(v),k=qe(k),C=qe(C),a=qe(a);var y;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=u;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class d{constructor(x,De,Je,xe){this.id=x,this.name=De,this.defaultValue=Je,this.schema=xe}applyUpdate(x,De){return s(x,De)}compute(x,De,Je){return Je}}class n{constructor(x,De){this.newValue=x,this.didChange=De}}e.ApplyUpdateResult=n;function s(Q,x){if(typeof Q!="object"||typeof x!="object"||!Q||!x)return new n(x,Q!==x);if(Array.isArray(Q)||Array.isArray(x)){const Je=Array.isArray(Q)&&Array.isArray(x)&&v.$wb(Q,x);return new n(x,!Je)}let De=!1;for(const Je in x)if(x.hasOwnProperty(Je)){const xe=s(Q[Je],x[Je]);xe.didChange&&(Q[Je]=xe.newValue,De=!0)}return new n(Q,De)}class o{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,De){return s(x,De)}validate(x){return this.defaultValue}}class h{constructor(x,De,Je,xe){this.id=x,this.name=De,this.defaultValue=Je,this.schema=xe}applyUpdate(x,De){return s(x,De)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,De,Je){return Je}}function i(Q,x){return typeof Q>"u"?x:Q==="false"?!1:!!Q}class r extends h{constructor(x,De,Je,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Je),super(x,De,Je,xe)}validate(x){return i(x,this.defaultValue)}}function t(Q,x,De,Je){if(typeof Q>"u")return x;let xe=parseInt(Q,10);return isNaN(xe)?x:(xe=Math.max(De,xe),xe=Math.min(Je,xe),xe|0)}class c extends h{static clampedInt(x,De,Je,xe){return t(x,De,Je,xe)}constructor(x,De,Je,xe,ht,$t=void 0){typeof $t<"u"&&($t.type="integer",$t.default=Je,$t.minimum=xe,$t.maximum=ht),super(x,De,Je,$t),this.minimum=xe,this.maximum=ht}validate(x){return c.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function l(Q,x,De,Je){if(typeof Q>"u")return x;const xe=g.float(Q,x);return g.clamp(xe,De,Je)}class g extends h{static clamp(x,De,Je){return x<De?De:x>Je?Je:x}static float(x,De){if(typeof x=="number")return x;if(typeof x>"u")return De;const Je=parseFloat(x);return isNaN(Je)?De:Je}constructor(x,De,Je,xe,ht){typeof ht<"u"&&(ht.type="number",ht.default=Je),super(x,De,Je,ht),this.validationFn=xe}validate(x){return this.validationFn(g.float(x,this.defaultValue))}}class m extends h{static string(x,De){return typeof x!="string"?De:x}constructor(x,De,Je,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Je),super(x,De,Je,xe)}validate(x){return m.string(x,this.defaultValue)}}function $(Q,x,De,Je){return typeof Q!="string"?x:Je&&Q in Je?Je[Q]:De.indexOf(Q)===-1?x:Q}class S extends h{constructor(x,De,Je,xe,ht=void 0){typeof ht<"u"&&(ht.type="string",ht.enum=xe,ht.default=Je),super(x,De,Je,ht),this.c=xe}validate(x){return $(x,this.defaultValue,this.c)}}class D extends d{constructor(x,De,Je,xe,ht,$t,Ft=void 0){typeof Ft<"u"&&(Ft.type="string",Ft.enum=ht,Ft.default=xe),super(x,De,Je,Ft),this.c=ht,this.d=$t}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function b(Q){switch(Q){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class I extends d{constructor(){super(je.accessibilitySupport,"accessibilitySupport",P.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(x){switch(x){case"auto":return P.AccessibilitySupport.Unknown;case"off":return P.AccessibilitySupport.Disabled;case"on":return P.AccessibilitySupport.Enabled}return this.defaultValue}compute(x,De,Je){return Je===P.AccessibilitySupport.Unknown?x.accessibilitySupport:Je}}class R extends d{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:a.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{insertSpace:i(De.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(De.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var f;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(f||(e.TextEditorCursorBlinkingStyle=f={}));function w(Q){switch(Q){case"blink":return f.Blink;case"smooth":return f.Smooth;case"phase":return f.Phase;case"expand":return f.Expand;case"solid":return f.Solid}}var M;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function N(Q){switch(Q){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function L(Q){switch(Q){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class G extends o{constructor(){super(je.editorClassName)}compute(x,De,Je){const xe=["monaco-editor"];return De.get(je.extraEditorClassName)&&xe.push(De.get(je.extraEditorClassName)),x.extraEditorClassName&&xe.push(x.extraEditorClassName),De.get(je.mouseStyle)==="default"?xe.push("mouse-default"):De.get(je.mouseStyle)==="copy"&&xe.push("mouse-copy"),De.get(je.showUnused)&&xe.push("showUnused"),De.get(je.showDeprecated)&&xe.push("showDeprecated"),xe.join(" ")}}class W extends r{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(x,De,Je){return Je&&x.emptySelectionClipboard}}class F extends d{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:a.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:a.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{cursorMoveOnType:i(De.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":$(De.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":$(De.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(De.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(De.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(De.loop,this.defaultValue.loop)}}}class V extends d{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",V.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"||x.length===0?V.OFF:x==="true"?V.ON:x:x?V.ON:V.OFF}}e.EditorFontLigatures=V;class ae extends d{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",ae.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?ae.OFF:x==="true"?ae.TRANSLATE:x:x?ae.TRANSLATE:ae.OFF}compute(x,De,Je){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=ae;class $e extends o{constructor(){super(je.fontInfo)}compute(x,De,Je){return x.fontInfo}}class _ extends h{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(x){const De=g.float(x,this.defaultValue);return De===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(De,6,100)}compute(x,De,Je){return x.fontInfo.fontSize}}class ge extends d{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ge.d,maximum:ge.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ge.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(c.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,ge.d,ge.e))}}class se extends d{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},De={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...De},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...De},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...De},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...De},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...De},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Je,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Je,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Je,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Je,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Je,description:a.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{multiple:$(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:De.multipleDefinitions??$(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:De.multipleTypeDefinitions??$(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:De.multipleDeclarations??$(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:De.multipleImplementations??$(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:De.multipleReferences??$(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ce extends d{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:a.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:a.localize(45,null)},"editor.hover.above":{type:"boolean",default:x.above,description:a.localize(46,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),delay:c.clampedInt(De.delay,this.defaultValue.delay,0,1e4),sticky:i(De.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(De.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(De.above,this.defaultValue.above)}}}var we;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(we||(e.RenderMinimap=we={}));class re extends o{constructor(){super(je.layoutInfo)}compute(x,De,Je){return re.computeLayout(De,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const De=x.height/x.lineHeight,Je=Math.floor(x.paddingTop/x.lineHeight);let xe=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(xe=Math.max(xe,De-1));const ht=(Je+x.viewLineCount+xe)/(x.pixelRatio*x.height),$t=Math.floor(x.viewLineCount/ht);return{typicalViewportLineCount:De,extraLinesBeforeFirstLine:Je,extraLinesBeyondLastLine:xe,desiredRatio:ht,minimapLineCount:$t}}static c(x,De){const Je=x.outerWidth,xe=x.outerHeight,ht=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:we.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ht*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const $t=De.stableMinimapLayoutInput,Ft=$t&&x.outerHeight===$t.outerHeight&&x.lineHeight===$t.lineHeight&&x.typicalHalfwidthCharacterWidth===$t.typicalHalfwidthCharacterWidth&&x.pixelRatio===$t.pixelRatio&&x.scrollBeyondLastLine===$t.scrollBeyondLastLine&&x.paddingTop===$t.paddingTop&&x.paddingBottom===$t.paddingBottom&&x.minimap.enabled===$t.minimap.enabled&&x.minimap.side===$t.minimap.side&&x.minimap.size===$t.minimap.size&&x.minimap.showSlider===$t.minimap.showSlider&&x.minimap.renderCharacters===$t.minimap.renderCharacters&&x.minimap.maxColumn===$t.minimap.maxColumn&&x.minimap.scale===$t.minimap.scale&&x.verticalScrollbarWidth===$t.verticalScrollbarWidth&&x.isViewportWrapping===$t.isViewportWrapping,zt=x.lineHeight,Yt=x.typicalHalfwidthCharacterWidth,fi=x.scrollBeyondLastLine,Ze=x.minimap.renderCharacters;let Pt=ht>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const Kt=x.minimap.maxColumn,Qt=x.minimap.size,mt=x.minimap.side,vt=x.verticalScrollbarWidth,ii=x.viewLineCount,Zt=x.remainingWidth,qt=x.isViewportWrapping,yt=Ze?2:3;let Nt=Math.floor(ht*xe);const li=Nt/ht;let Vt=!1,Xe=!1,xt=yt*Pt,ni=Pt/ht,hi=1;if(Qt==="fill"||Qt==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:jt,extraLinesBeyondLastLine:Ht,desiredRatio:oi,minimapLineCount:Rt}=re.computeContainedMinimapLineCount({viewLineCount:ii,scrollBeyondLastLine:fi,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:xe,lineHeight:zt,pixelRatio:ht});if(ii/Rt>1)Vt=!0,Xe=!0,Pt=1,xt=1,ni=Pt/ht;else{let bt=!1,ei=Pt+1;if(Qt==="fit"){const Ct=Math.ceil((jt+ii+Ht)*xt);qt&&Ft&&Zt<=De.stableFitRemainingWidth?(bt=!0,ei=De.stableFitMaxMinimapScale):bt=Ct>Nt}if(Qt==="fill"||bt){Vt=!0;const Ct=Pt;xt=Math.min(zt*ht,Math.max(1,Math.floor(1/oi))),qt&&Ft&&Zt<=De.stableFitRemainingWidth&&(ei=De.stableFitMaxMinimapScale),Pt=Math.min(ei,Math.max(1,Math.floor(xt/yt))),Pt>Ct&&(hi=Math.min(2,Pt/Ct)),ni=Pt/ht/hi,Nt=Math.ceil(Math.max(si,jt+ii+Ht)*xt),qt?(De.stableMinimapLayoutInput=x,De.stableFitRemainingWidth=Zt,De.stableFitMaxMinimapScale=Pt):(De.stableMinimapLayoutInput=null,De.stableFitRemainingWidth=0)}}}const kt=Math.floor(Kt*ni),Lt=Math.min(kt,Math.max(0,Math.floor((Zt-vt-2)*ni/(Yt+ni)))+e.MINIMAP_GUTTER_WIDTH);let At=Math.floor(ht*Lt);const Ut=At/ht;At=Math.floor(At*hi);const ri=Ze?we.Text:we.Blocks,_t=mt==="left"?0:Je-Lt-vt;return{renderMinimap:ri,minimapLeft:_t,minimapWidth:Lt,minimapHeightIsEditorHeight:Vt,minimapIsSampling:Xe,minimapScale:Pt,minimapLineHeight:xt,minimapCanvasInnerWidth:At,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:Ut,minimapCanvasOuterHeight:li}}static computeLayout(x,De){const Je=De.outerWidth|0,xe=De.outerHeight|0,ht=De.lineHeight|0,$t=De.lineNumbersDigitCount|0,Ft=De.typicalHalfwidthCharacterWidth,zt=De.maxDigitWidth,Yt=De.pixelRatio,fi=De.viewLineCount,Ze=x.get(je.wordWrapOverride2),Pt=Ze==="inherit"?x.get(je.wordWrapOverride1):Ze,Kt=Pt==="inherit"?x.get(je.wordWrap):Pt,Qt=x.get(je.wordWrapColumn),mt=De.isDominatedByLongLines,vt=x.get(je.glyphMargin),ii=x.get(je.lineNumbers).renderType!==ze.Off,Zt=x.get(je.lineNumbersMinChars),qt=x.get(je.scrollBeyondLastLine),yt=x.get(je.padding),Nt=x.get(je.minimap),li=x.get(je.scrollbar),Vt=li.verticalScrollbarSize,Xe=li.verticalHasArrows,xt=li.arrowSize,ni=li.horizontalScrollbarSize,hi=x.get(je.folding),kt=x.get(je.showFoldingControls)!=="never";let Lt=x.get(je.lineDecorationsWidth);hi&&kt&&(Lt+=16);let At=0;if(ii){const Gt=Math.max($t,Zt);At=Math.round(Gt*zt)}let Ut=0;vt&&(Ut=ht*De.glyphMarginDecorationLaneCount);let ri=0,_t=ri+Ut,si=_t+At,jt=si+Lt;const Ht=Je-Ut-At-Lt;let oi=!1,Rt=!1,St=-1;Pt==="inherit"&&mt?(oi=!0,Rt=!0):Kt==="on"||Kt==="bounded"?Rt=!0:Kt==="wordWrapColumn"&&(St=Qt);const bt=re.c({outerWidth:Je,outerHeight:xe,lineHeight:ht,typicalHalfwidthCharacterWidth:Ft,pixelRatio:Yt,scrollBeyondLastLine:qt,paddingTop:yt.top,paddingBottom:yt.bottom,minimap:Nt,verticalScrollbarWidth:Vt,viewLineCount:fi,remainingWidth:Ht,isViewportWrapping:Rt},De.memory||new E);bt.renderMinimap!==we.None&&bt.minimapLeft===0&&(ri+=bt.minimapWidth,_t+=bt.minimapWidth,si+=bt.minimapWidth,jt+=bt.minimapWidth);const ei=Ht-bt.minimapWidth,Ct=Math.max(1,Math.floor((ei-Vt-2)/Ft)),di=Xe?xt:0;return Rt&&(St=Math.max(1,Ct),Kt==="bounded"&&(St=Math.min(St,Qt))),{width:Je,height:xe,glyphMarginLeft:ri,glyphMarginWidth:Ut,glyphMarginDecorationLaneCount:De.glyphMarginDecorationLaneCount,lineNumbersLeft:_t,lineNumbersWidth:At,decorationsLeft:si,decorationsWidth:Lt,contentLeft:jt,contentWidth:ei,minimap:bt,viewportColumn:Ct,isWordWrapMinified:oi,isViewportWrapping:Rt,wrappingColumn:St,verticalScrollbarWidth:Vt,horizontalScrollbarHeight:ni,overviewRuler:{top:di,width:Vt,height:xe-2*di,right:0}}}}e.EditorLayoutInfoComputer=re;class Pe extends d{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(47,null),a.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(49,null)}})}validate(x){return $(x,"simple",["simple","advanced"])}compute(x,De,Je){return De.get(je.accessibilitySupport)===P.AccessibilitySupport.Enabled?"advanced":Je}}var Me;(function(Q){Q.Off="off",Q.OnCode="onCode",Q.On="on"})(Me||(e.ShowLightbulbIconMode=Me={}));class Y extends d{constructor(){const x={enabled:Me.On};super(je.lightbulb,"lightbulb",x,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Me.Off,Me.OnCode,Me.On],default:x.enabled,enumDescriptions:[a.localize(50,null),a.localize(51,null),a.localize(52,null)],description:a.localize(53,null)}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{enabled:$(x.enabled,this.defaultValue.enabled,[Me.Off,Me.OnCode,Me.On])}}}class q extends d{constructor(){const x={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:a.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:20,description:a.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:a.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:a.localize(57,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(De.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:$(De.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(De.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ee extends d{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:a.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(59,null),a.localize(60,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),a.localize(61,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),a.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:a.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:a.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:a.localize(65,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return typeof De.enabled=="boolean"&&(De.enabled=De.enabled?"on":"off"),{enabled:$(De.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(De.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(De.fontFamily,this.defaultValue.fontFamily),padding:i(De.padding,this.defaultValue.padding)}}}class ve extends d{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):c.clampedInt(x,this.defaultValue,0,1e3)}compute(x,De,Je){return Je<0?c.clampedInt(-Je*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Je}}class ue extends g{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>g.clamp(x,0,150),{markdownDescription:a.localize(66,null)})}compute(x,De,Je){return x.fontInfo.lineHeight}}class be extends d{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:a.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:a.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(69,null),a.localize(70,null),a.localize(71,null)],default:x.size,description:a.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:a.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:a.localize(74,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:a.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:a.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:x.showRegionSectionHeaders,description:a.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:x.showMarkSectionHeaders,description:a.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:x.sectionHeaderFontSize,description:a.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:x.sectionHeaderLetterSpacing,description:a.localize(81,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),autohide:i(De.autohide,this.defaultValue.autohide),size:$(De.size,this.defaultValue.size,["proportional","fill","fit"]),side:$(De.side,this.defaultValue.side,["right","left"]),showSlider:$(De.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(De.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(De.scale,1,1,3),maxColumn:c.clampedInt(De.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(De.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(De.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:g.clamp(De.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:g.clamp(De.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function de(Q){return Q==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class X extends d{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(83,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{top:c.clampedInt(De.top,0,0,1e3),bottom:c.clampedInt(De.bottom,0,0,1e3)}}}class Z extends d{constructor(){const x={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:a.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:a.localize(85,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),cycle:i(De.cycle,this.defaultValue.cycle)}}}class me extends o{constructor(){super(je.pixelRatio)}compute(x,De,Je){return x.pixelRatio}}class pe extends d{constructor(){super(je.placeholder,"placeholder",void 0)}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x:this.defaultValue}}class Oe extends d{constructor(){const x={other:"on",comments:"off",strings:"off"},De=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(86,null),a.localize(87,null),a.localize(88,null)]}];super(je.quickSuggestions,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:De,default:x.strings,description:a.localize(89,null)},comments:{anyOf:De,default:x.comments,description:a.localize(90,null)},other:{anyOf:De,default:x.other,description:a.localize(91,null)}},default:x,markdownDescription:a.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const Yt=x?"on":"off";return{comments:Yt,strings:Yt,other:Yt}}if(!x||typeof x!="object")return this.defaultValue;const{other:De,comments:Je,strings:xe}=x,ht=["on","inline","off"];let $t,Ft,zt;return typeof De=="boolean"?$t=De?"on":"off":$t=$(De,this.defaultValue.other,ht),typeof Je=="boolean"?Ft=Je?"on":"off":Ft=$(Je,this.defaultValue.comments,ht),typeof xe=="boolean"?zt=xe?"on":"off":zt=$(xe,this.defaultValue.strings,ht),{other:$t,comments:Ft,strings:zt}}}var ze;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(ze||(e.RenderLineNumbersType=ze={}));class ke extends d{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:ze.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(93,null),a.localize(94,null),a.localize(95,null),a.localize(96,null)],default:"on",description:a.localize(97,null)})}validate(x){let De=this.defaultValue.renderType,Je=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?(De=ze.Custom,Je=x):x==="interval"?De=ze.Interval:x==="relative"?De=ze.Relative:x==="on"?De=ze.On:De=ze.Off),{renderType:De,renderFn:Je}}}function Ae(Q){const x=Q.get(je.renderValidationDecorations);return x==="editable"?Q.get(je.readOnly):x!=="on"}class Ne extends d{constructor(){const x=[],De={type:"number",description:a.localize(98,null)};super(je.rulers,"rulers",x,{type:"array",items:{anyOf:[De,{type:["object"],properties:{column:De,color:{type:"string",description:a.localize(99,null),format:"color-hex"}}}]},default:x,description:a.localize(100,null)})}validate(x){if(Array.isArray(x)){const De=[];for(const Je of x)if(typeof Je=="number")De.push({column:c.clampedInt(Je,0,0,1e4),color:null});else if(Je&&typeof Je=="object"){const xe=Je;De.push({column:c.clampedInt(xe.column,0,0,1e4),color:xe.color})}return De.sort((Je,xe)=>Je.column-xe.column),De}return this.defaultValue}}class j extends d{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function U(Q,x){if(typeof Q!="string")return x;switch(Q){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class K extends d{constructor(){const x={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(101,null),a.localize(102,null),a.localize(103,null)],default:"auto",description:a.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(105,null),a.localize(106,null),a.localize(107,null)],default:"auto",description:a.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:a.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:a.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:a.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:a.localize(112,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x,Je=c.clampedInt(De.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=c.clampedInt(De.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(De.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:U(De.vertical,this.defaultValue.vertical),horizontal:U(De.horizontal,this.defaultValue.horizontal),useShadows:i(De.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(De.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(De.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(De.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(De.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Je,horizontalSliderSize:c.clampedInt(De.horizontalSliderSize,Je,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:c.clampedInt(De.verticalSliderSize,xe,0,1e3),scrollByPage:i(De.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(De.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends d{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:a.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:a.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:a.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:a.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:a.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:a.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:a.localize(119,null)}})}applyUpdate(x,De){let Je=!1;De.allowedCharacters&&x&&(k.$ho(x.allowedCharacters,De.allowedCharacters)||(x={...x,allowedCharacters:De.allowedCharacters},Je=!0)),De.allowedLocales&&x&&(k.$ho(x.allowedLocales,De.allowedLocales)||(x={...x,allowedLocales:De.allowedLocales},Je=!0));const xe=super.applyUpdate(x,De);return Je?new n(xe.newValue,!0):xe}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{nonBasicASCII:Ke(De.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(De.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(De.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(De.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(De.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,De){if(typeof x!="object"||!x)return De;const Je={};for(const[xe,ht]of Object.entries(x))ht===!0&&(Je[xe]=!0);return Je}}class ie extends d{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:a.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(121,null),a.localize(122,null),a.localize(123,null)],description:a.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:a.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:x.fontFamily,description:a.localize(126,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),mode:$(De.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:$(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(De.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(De.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:m.string(De.fontFamily,this.defaultValue.fontFamily)}}}class fe extends d{constructor(){const x={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(je.inlineEdit,"experimentalInlineEdit",x,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:x.enabled,description:a.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(128,null),a.localize(129,null),a.localize(130,null)],description:a.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:x.fontFamily,description:a.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:x.backgroundColoring,description:a.localize(133,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),showToolbar:$(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:m.string(De.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(De.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:i(De.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Re extends d{constructor(){const x={enabled:T.$it.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$it.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:a.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:a.localize(135,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(De.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ue extends d{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(136,null),a.localize(137,null),a.localize(138,null)],default:x.bracketPairs,description:a.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(140,null),a.localize(141,null),a.localize(142,null)],default:x.bracketPairsHorizontal,description:a.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:a.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:a.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(146,null),a.localize(147,null),a.localize(148,null)],default:x.highlightActiveIndentation,description:a.localize(149,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{bracketPairs:Ke(De.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(De.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(De.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(De.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(De.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(Q,x,De){const Je=De.indexOf(Q);return Je===-1?x:De[Je]}class _e extends d{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(150,null),a.localize(151,null)],default:x.insertMode,description:a.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:a.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:a.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:a.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(156,null),a.localize(157,null),a.localize(158,null),a.localize(159,null)],default:x.selectionMode,markdownDescription:a.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:a.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:a.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:a.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:a.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:a.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(197,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{insertMode:$(De.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(De.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(De.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(De.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(De.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:$(De.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(De.showIcons,this.defaultValue.showIcons),showStatusBar:i(De.showStatusBar,this.defaultValue.showStatusBar),preview:i(De.preview,this.defaultValue.preview),previewMode:$(De.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(De.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(De.showMethods,this.defaultValue.showMethods),showFunctions:i(De.showFunctions,this.defaultValue.showFunctions),showConstructors:i(De.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(De.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(De.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(De.showFields,this.defaultValue.showFields),showVariables:i(De.showVariables,this.defaultValue.showVariables),showClasses:i(De.showClasses,this.defaultValue.showClasses),showStructs:i(De.showStructs,this.defaultValue.showStructs),showInterfaces:i(De.showInterfaces,this.defaultValue.showInterfaces),showModules:i(De.showModules,this.defaultValue.showModules),showProperties:i(De.showProperties,this.defaultValue.showProperties),showEvents:i(De.showEvents,this.defaultValue.showEvents),showOperators:i(De.showOperators,this.defaultValue.showOperators),showUnits:i(De.showUnits,this.defaultValue.showUnits),showValues:i(De.showValues,this.defaultValue.showValues),showConstants:i(De.showConstants,this.defaultValue.showConstants),showEnums:i(De.showEnums,this.defaultValue.showEnums),showEnumMembers:i(De.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(De.showKeywords,this.defaultValue.showKeywords),showWords:i(De.showWords,this.defaultValue.showWords),showColors:i(De.showColors,this.defaultValue.showColors),showFiles:i(De.showFiles,this.defaultValue.showFiles),showReferences:i(De.showReferences,this.defaultValue.showReferences),showFolders:i(De.showFolders,this.defaultValue.showFolders),showTypeParameters:i(De.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(De.showSnippets,this.defaultValue.showSnippets),showUsers:i(De.showUsers,this.defaultValue.showUsers),showIssues:i(De.showIssues,this.defaultValue.showIssues)}}}class tt extends d{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:a.localize(199,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(x.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends d{constructor(){const x=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",x,{anyOf:[{description:a.localize(200,null),type:"string"},{description:a.localize(201,null),type:"array",items:{type:"string"}}]})}validate(x){if(typeof x=="string"&&(x=[x]),Array.isArray(x)){const De=[];for(const Je of x)if(typeof Je=="string")try{Intl.Segmenter.supportedLocalesOf(Je).length>0&&De.push(Je)}catch{}return De}return this.defaultValue}}var et;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(et||(e.WrappingIndent=et={}));class rt extends d{constructor(){super(je.wrappingIndent,"wrappingIndent",et.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(202,null),a.localize(203,null),a.localize(204,null),a.localize(205,null)],description:a.localize(206,null),default:"same"}})}validate(x){switch(x){case"none":return et.None;case"same":return et.Same;case"indent":return et.Indent;case"deepIndent":return et.DeepIndent}return et.Same}compute(x,De,Je){return De.get(je.accessibilitySupport)===P.AccessibilitySupport.Enabled?et.None:Je}}class ft extends o{constructor(){super(je.wrappingInfo)}compute(x,De,Je){const xe=De.get(je.layoutInfo);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class ct extends d{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:a.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:a.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[a.localize(209,null),a.localize(210,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),showDropSelector:$(De.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends d{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:a.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:a.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[a.localize(213,null),a.localize(214,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),showPasteSelector:$(De.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ut="Consolas, 'Courier New', monospace",gt="Menlo, Monaco, 'Courier New', monospace",pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?gt:C.$k?pt:ut,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var je;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.ariaRequired=5]="ariaRequired",Q[Q.autoClosingBrackets=6]="autoClosingBrackets",Q[Q.autoClosingComments=7]="autoClosingComments",Q[Q.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Q[Q.autoClosingDelete=9]="autoClosingDelete",Q[Q.autoClosingOvertype=10]="autoClosingOvertype",Q[Q.autoClosingQuotes=11]="autoClosingQuotes",Q[Q.autoIndent=12]="autoIndent",Q[Q.automaticLayout=13]="automaticLayout",Q[Q.autoSurround=14]="autoSurround",Q[Q.bracketPairColorization=15]="bracketPairColorization",Q[Q.guides=16]="guides",Q[Q.codeLens=17]="codeLens",Q[Q.codeLensFontFamily=18]="codeLensFontFamily",Q[Q.codeLensFontSize=19]="codeLensFontSize",Q[Q.colorDecorators=20]="colorDecorators",Q[Q.colorDecoratorsLimit=21]="colorDecoratorsLimit",Q[Q.columnSelection=22]="columnSelection",Q[Q.comments=23]="comments",Q[Q.contextmenu=24]="contextmenu",Q[Q.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=26]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=28]="cursorStyle",Q[Q.cursorSurroundingLines=29]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=31]="cursorWidth",Q[Q.disableLayerHinting=32]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Q[Q.domReadOnly=34]="domReadOnly",Q[Q.dragAndDrop=35]="dragAndDrop",Q[Q.dropIntoEditor=36]="dropIntoEditor",Q[Q.emptySelectionClipboard=37]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=39]="extraEditorClassName",Q[Q.fastScrollSensitivity=40]="fastScrollSensitivity",Q[Q.find=41]="find",Q[Q.fixedOverflowWidgets=42]="fixedOverflowWidgets",Q[Q.folding=43]="folding",Q[Q.foldingStrategy=44]="foldingStrategy",Q[Q.foldingHighlight=45]="foldingHighlight",Q[Q.foldingImportsByDefault=46]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=47]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=49]="fontFamily",Q[Q.fontInfo=50]="fontInfo",Q[Q.fontLigatures=51]="fontLigatures",Q[Q.fontSize=52]="fontSize",Q[Q.fontWeight=53]="fontWeight",Q[Q.fontVariations=54]="fontVariations",Q[Q.formatOnPaste=55]="formatOnPaste",Q[Q.formatOnType=56]="formatOnType",Q[Q.glyphMargin=57]="glyphMargin",Q[Q.gotoLocation=58]="gotoLocation",Q[Q.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Q[Q.hover=60]="hover",Q[Q.inDiffEditor=61]="inDiffEditor",Q[Q.inlineSuggest=62]="inlineSuggest",Q[Q.inlineEdit=63]="inlineEdit",Q[Q.letterSpacing=64]="letterSpacing",Q[Q.lightbulb=65]="lightbulb",Q[Q.lineDecorationsWidth=66]="lineDecorationsWidth",Q[Q.lineHeight=67]="lineHeight",Q[Q.lineNumbers=68]="lineNumbers",Q[Q.lineNumbersMinChars=69]="lineNumbersMinChars",Q[Q.linkedEditing=70]="linkedEditing",Q[Q.links=71]="links",Q[Q.matchBrackets=72]="matchBrackets",Q[Q.minimap=73]="minimap",Q[Q.mouseStyle=74]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=76]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=78]="multiCursorModifier",Q[Q.multiCursorPaste=79]="multiCursorPaste",Q[Q.multiCursorLimit=80]="multiCursorLimit",Q[Q.occurrencesHighlight=81]="occurrencesHighlight",Q[Q.overviewRulerBorder=82]="overviewRulerBorder",Q[Q.overviewRulerLanes=83]="overviewRulerLanes",Q[Q.padding=84]="padding",Q[Q.pasteAs=85]="pasteAs",Q[Q.parameterHints=86]="parameterHints",Q[Q.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Q[Q.placeholder=88]="placeholder",Q[Q.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=90]="quickSuggestions",Q[Q.quickSuggestionsDelay=91]="quickSuggestionsDelay",Q[Q.readOnly=92]="readOnly",Q[Q.readOnlyMessage=93]="readOnlyMessage",Q[Q.renameOnType=94]="renameOnType",Q[Q.renderControlCharacters=95]="renderControlCharacters",Q[Q.renderFinalNewline=96]="renderFinalNewline",Q[Q.renderLineHighlight=97]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=99]="renderValidationDecorations",Q[Q.renderWhitespace=100]="renderWhitespace",Q[Q.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",Q[Q.roundedSelection=102]="roundedSelection",Q[Q.rulers=103]="rulers",Q[Q.scrollbar=104]="scrollbar",Q[Q.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=106]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=107]="scrollPredominantAxis",Q[Q.selectionClipboard=108]="selectionClipboard",Q[Q.selectionHighlight=109]="selectionHighlight",Q[Q.selectOnLineNumbers=110]="selectOnLineNumbers",Q[Q.showFoldingControls=111]="showFoldingControls",Q[Q.showUnused=112]="showUnused",Q[Q.snippetSuggestions=113]="snippetSuggestions",Q[Q.smartSelect=114]="smartSelect",Q[Q.smoothScrolling=115]="smoothScrolling",Q[Q.stickyScroll=116]="stickyScroll",Q[Q.stickyTabStops=117]="stickyTabStops",Q[Q.stopRenderingLineAfter=118]="stopRenderingLineAfter",Q[Q.suggest=119]="suggest",Q[Q.suggestFontSize=120]="suggestFontSize",Q[Q.suggestLineHeight=121]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",Q[Q.suggestSelection=123]="suggestSelection",Q[Q.tabCompletion=124]="tabCompletion",Q[Q.tabIndex=125]="tabIndex",Q[Q.unicodeHighlighting=126]="unicodeHighlighting",Q[Q.unusualLineTerminators=127]="unusualLineTerminators",Q[Q.useShadowDOM=128]="useShadowDOM",Q[Q.useTabStops=129]="useTabStops",Q[Q.wordBreak=130]="wordBreak",Q[Q.wordSegmenterLocales=131]="wordSegmenterLocales",Q[Q.wordSeparators=132]="wordSeparators",Q[Q.wordWrap=133]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=136]="wordWrapColumn",Q[Q.wordWrapOverride1=137]="wordWrapOverride1",Q[Q.wordWrapOverride2=138]="wordWrapOverride2",Q[Q.wrappingIndent=139]="wrappingIndent",Q[Q.wrappingStrategy=140]="wrappingStrategy",Q[Q.showDeprecated=141]="showDeprecated",Q[Q.inlayHints=142]="inlayHints",Q[Q.editorClassName=143]="editorClassName",Q[Q.pixelRatio=144]="pixelRatio",Q[Q.tabFocusMode=145]="tabFocusMode",Q[Q.layoutInfo=146]="layoutInfo",Q[Q.wrappingInfo=147]="wrappingInfo",Q[Q.defaultColorDecorators=148]="defaultColorDecorators",Q[Q.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",Q[Q.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new r(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(215,null)})),acceptSuggestionOnEnter:Be(new S(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(216,null),""],markdownDescription:a.localize(217,null)})),accessibilitySupport:Be(new I),accessibilityPageSize:Be(new c(je.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(218,null),tags:["accessibility"]})),ariaLabel:Be(new m(je.ariaLabel,"ariaLabel",a.localize(219,null))),ariaRequired:Be(new r(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new r(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:a.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Be(new S(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(221,null),a.localize(222,null),""],description:a.localize(223,null)})),autoClosingComments:Be(new S(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(224,null),a.localize(225,null),""],description:a.localize(226,null)})),autoClosingDelete:Be(new S(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(227,null),""],description:a.localize(228,null)})),autoClosingOvertype:Be(new S(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(229,null),""],description:a.localize(230,null)})),autoClosingQuotes:Be(new S(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(231,null),a.localize(232,null),""],description:a.localize(233,null)})),autoIndent:Be(new D(je.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[a.localize(234,null),a.localize(235,null),a.localize(236,null),a.localize(237,null),a.localize(238,null)],description:a.localize(239,null)})),automaticLayout:Be(new r(je.automaticLayout,"automaticLayout",!1)),autoSurround:Be(new S(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(240,null),a.localize(241,null),a.localize(242,null),""],description:a.localize(243,null)})),bracketPairColorization:Be(new Re),bracketPairGuides:Be(new Ue),stickyTabStops:Be(new r(je.stickyTabStops,"stickyTabStops",!1,{description:a.localize(244,null)})),codeLens:Be(new r(je.codeLens,"codeLens",!0,{description:a.localize(245,null)})),codeLensFontFamily:Be(new m(je.codeLensFontFamily,"codeLensFontFamily","",{description:a.localize(246,null)})),codeLensFontSize:Be(new c(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(247,null)})),colorDecorators:Be(new r(je.colorDecorators,"colorDecorators",!0,{description:a.localize(248,null)})),colorDecoratorActivatedOn:Be(new S(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[a.localize(249,null),a.localize(250,null),a.localize(251,null)],description:a.localize(252,null)})),colorDecoratorsLimit:Be(new c(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(253,null)})),columnSelection:Be(new r(je.columnSelection,"columnSelection",!1,{description:a.localize(254,null)})),comments:Be(new R),contextmenu:Be(new r(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new r(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:a.localize(255,null)})),cursorBlinking:Be(new D(je.cursorBlinking,"cursorBlinking",f.Blink,"blink",["blink","smooth","phase","expand","solid"],w,{description:a.localize(256,null)})),cursorSmoothCaretAnimation:Be(new S(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(257,null),a.localize(258,null),a.localize(259,null)],description:a.localize(260,null)})),cursorStyle:Be(new D(je.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:a.localize(261,null)})),cursorSurroundingLines:Be(new c(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(262,null)})),cursorSurroundingLinesStyle:Be(new S(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(263,null),a.localize(264,null)],markdownDescription:a.localize(265,null)})),cursorWidth:Be(new c(je.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(266,null)})),disableLayerHinting:Be(new r(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new r(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new r(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:Be(new r(je.dragAndDrop,"dragAndDrop",!0,{description:a.localize(267,null)})),emptySelectionClipboard:Be(new W),dropIntoEditor:Be(new ct),stickyScroll:Be(new q),experimentalWhitespaceRendering:Be(new S(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(268,null),a.localize(269,null),a.localize(270,null)],description:a.localize(271,null)})),extraEditorClassName:Be(new m(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Be(new g(je.fastScrollSensitivity,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:a.localize(272,null)})),find:Be(new F),fixedOverflowWidgets:Be(new r(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Be(new r(je.folding,"folding",!0,{description:a.localize(273,null)})),foldingStrategy:Be(new S(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(274,null),a.localize(275,null)],description:a.localize(276,null)})),foldingHighlight:Be(new r(je.foldingHighlight,"foldingHighlight",!0,{description:a.localize(277,null)})),foldingImportsByDefault:Be(new r(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:a.localize(278,null)})),foldingMaximumRegions:Be(new c(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(279,null)})),unfoldOnClickAfterEndOfLine:Be(new r(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(280,null)})),fontFamily:Be(new m(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(281,null)})),fontInfo:Be(new $e),fontLigatures2:Be(new V),fontSize:Be(new _),fontWeight:Be(new ge),fontVariations:Be(new ae),formatOnPaste:Be(new r(je.formatOnPaste,"formatOnPaste",!1,{description:a.localize(282,null)})),formatOnType:Be(new r(je.formatOnType,"formatOnType",!1,{description:a.localize(283,null)})),glyphMargin:Be(new r(je.glyphMargin,"glyphMargin",!0,{description:a.localize(284,null)})),gotoLocation:Be(new se),hideCursorInOverviewRuler:Be(new r(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:a.localize(285,null)})),hover:Be(new ce),inDiffEditor:Be(new r(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Be(new g(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>g.clamp(Q,-5,20),{description:a.localize(286,null)})),lightbulb:Be(new Y),lineDecorationsWidth:Be(new ve),lineHeight:Be(new ue),lineNumbers:Be(new ke),lineNumbersMinChars:Be(new c(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new r(je.linkedEditing,"linkedEditing",!1,{description:a.localize(287,null)})),links:Be(new r(je.links,"links",!0,{description:a.localize(288,null)})),matchBrackets:Be(new S(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:a.localize(289,null)})),minimap:Be(new be),mouseStyle:Be(new S(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new g(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:a.localize(290,null)})),mouseWheelZoom:Be(new r(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:C.$j?a.localize(291,null):a.localize(292,null)})),multiCursorMergeOverlapping:Be(new r(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:a.localize(293,null)})),multiCursorModifier:Be(new D(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[a.localize(294,null),a.localize(295,null)],markdownDescription:a.localize(296,null)})),multiCursorPaste:Be(new S(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(297,null),a.localize(298,null)],markdownDescription:a.localize(299,null)})),multiCursorLimit:Be(new c(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(300,null)})),occurrencesHighlight:Be(new S(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[a.localize(301,null),a.localize(302,null),a.localize(303,null)],markdownDescription:a.localize(304,null)})),overviewRulerBorder:Be(new r(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:a.localize(305,null)})),overviewRulerLanes:Be(new c(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Be(new X),pasteAs:Be(new st),parameterHints:Be(new Z),peekWidgetDefaultFocus:Be(new S(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(306,null),a.localize(307,null)],description:a.localize(308,null)})),placeholder:Be(new pe),definitionLinkOpensInPeek:Be(new r(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:a.localize(309,null)})),quickSuggestions:Be(new Oe),quickSuggestionsDelay:Be(new c(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(310,null)})),readOnly:Be(new r(je.readOnly,"readOnly",!1)),readOnlyMessage:Be(new j),renameOnType:Be(new r(je.renameOnType,"renameOnType",!1,{description:a.localize(311,null),markdownDeprecationMessage:a.localize(312,null)})),renderControlCharacters:Be(new r(je.renderControlCharacters,"renderControlCharacters",!0,{description:a.localize(313,null),restricted:!0})),renderFinalNewline:Be(new S(je.renderFinalNewline,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:a.localize(314,null)})),renderLineHighlight:Be(new S(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(315,null)],description:a.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Be(new r(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(317,null)})),renderValidationDecorations:Be(new S(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new S(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(318,null),a.localize(319,null),a.localize(320,null),""],description:a.localize(321,null)})),revealHorizontalRightPadding:Be(new c(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new r(je.roundedSelection,"roundedSelection",!0,{description:a.localize(322,null)})),rulers:Be(new Ne),scrollbar:Be(new K),scrollBeyondLastColumn:Be(new c(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(323,null)})),scrollBeyondLastLine:Be(new r(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:a.localize(324,null)})),scrollPredominantAxis:Be(new r(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:a.localize(325,null)})),selectionClipboard:Be(new r(je.selectionClipboard,"selectionClipboard",!0,{description:a.localize(326,null),included:C.$k})),selectionHighlight:Be(new r(je.selectionHighlight,"selectionHighlight",!0,{description:a.localize(327,null)})),selectOnLineNumbers:Be(new r(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Be(new S(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(328,null),a.localize(329,null),a.localize(330,null)],description:a.localize(331,null)})),showUnused:Be(new r(je.showUnused,"showUnused",!0,{description:a.localize(332,null)})),showDeprecated:Be(new r(je.showDeprecated,"showDeprecated",!0,{description:a.localize(333,null)})),inlayHints:Be(new ee),snippetSuggestions:Be(new S(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(334,null),a.localize(335,null),a.localize(336,null),a.localize(337,null)],description:a.localize(338,null)})),smartSelect:Be(new tt),smoothScrolling:Be(new r(je.smoothScrolling,"smoothScrolling",!1,{description:a.localize(339,null)})),stopRenderingLineAfter:Be(new c(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Be(new _e),inlineSuggest:Be(new ie),inlineEdit:Be(new fe),inlineCompletionsAccessibilityVerbose:Be(new r(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:a.localize(340,null)})),suggestFontSize:Be(new c(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new c(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new r(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:a.localize(343,null)})),suggestSelection:Be(new S(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(344,null),a.localize(345,null),a.localize(346,null)],description:a.localize(347,null)})),tabCompletion:Be(new S(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(348,null),a.localize(349,null),a.localize(350,null)],description:a.localize(351,null)})),tabIndex:Be(new c(je.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Be(new H),unusualLineTerminators:Be(new S(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(352,null),a.localize(353,null),a.localize(354,null)],description:a.localize(355,null)})),useShadowDOM:Be(new r(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:Be(new r(je.useTabStops,"useTabStops",!0,{description:a.localize(356,null)})),wordBreak:Be(new S(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(357,null),a.localize(358,null)],description:a.localize(359,null)})),wordSegmenterLocales:Be(new nt),wordSeparators:Be(new m(je.wordSeparators,"wordSeparators",p.$jt,{description:a.localize(360,null)})),wordWrap:Be(new S(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(361,null),a.localize(362,null),a.localize(363,null),a.localize(364,null)],description:a.localize(365,null)})),wordWrapBreakAfterCharacters:Be(new m(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new m(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new c(je.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(366,null)})),wordWrapOverride1:Be(new S(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new S(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new G),defaultColorDecorators:Be(new r(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:a.localize(367,null)})),pixelRatio:Be(new me),tabFocusMode:Be(new r(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:a.localize(368,null)})),layoutInfo:Be(new re),wrappingInfo:Be(new ft),wrappingIndent:Be(new rt),wrappingStrategy:Be(new Pe)}}),define(Ce[107],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,v.$Fi)("environmentService"),e.$Ni=(0,v.$Gi)(e.$Mi)}),define(Ce[30],Ie([1,0,59,20,13,15,2,174,3,21,16,48]),function(oe,e,v,k,C,O,A,T,p,a,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=u,e.$bl=s,e.$cl=h,e.$dl=i,e.$el=r,e.$fl=t,e.$gl=c,e.$hl=l,e.$il=g,e.$jl=m,e.$kl=$,e.$ml=b,e.$nl=I,e.$ol=R,e.$pl=f,e.$ql=w,e.$tl=W,e.$Fl=ge,e.$Gl=se,e.$Il=we,e.$_k=(0,p.$Fi)("fileService");function u(re){return re.create===!0}var E;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var d;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var n;(function(re){re[re.UPDATED=2]="UPDATED",re[re.ADDED=4]="ADDED",re[re.DELETED=8]="DELETED"})(n||(e.FileChangeFilter=n={}));function s(re){const Pe=re;return!!Pe&&typeof Pe.onDidChange=="function"}var o;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function h(re){return!!(re.capabilities&o.FileReadWrite)}function i(re){return!!(re.capabilities&o.FileFolderCopy)}function r(re){return!!(re.capabilities&o.FileClone)}function t(re){return!!(re.capabilities&o.FileOpenReadWriteClose)}function c(re){return!!(re.capabilities&o.FileReadStream)}function l(re){return h(re)?!!(re.capabilities&o.FileAtomicRead):!1}function g(re){return h(re)?!!(re.capabilities&o.FileAtomicWrite):!1}function m(re){return!!(re.capabilities&o.FileAtomicDelete)}function $(re){return!!(re.capabilities&o.Readonly)}var S;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class D extends Error{static create(Pe,Me){const Y=new D(Pe.toString(),Me);return R(Y,Me),Y}constructor(Pe,Me){super(Pe),this.code=Me}}e.$ll=D;function b(re,Pe){return D.create(re,Pe)}function I(re){return re||b((0,T.localize)(0,null),S.Unknown)}function R(re,Pe){return re.name=Pe?`${Pe} (FileSystemError)`:"FileSystemError",re}function f(re){if(!re)return S.Unknown;if(re instanceof D)return re.code;const Pe=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!Pe)return S.Unknown;switch(Pe[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}function w(re){if(re instanceof F)return re.fileOperationResult;switch(f(re)){case S.FileNotFound:return $e.FILE_NOT_FOUND;case S.FileIsADirectory:return $e.FILE_IS_DIRECTORY;case S.FileNotADirectory:return $e.FILE_NOT_DIRECTORY;case S.FileWriteLocked:return $e.FILE_WRITE_LOCKED;case S.NoPermissions:return $e.FILE_PERMISSION_DENIED;case S.FileExists:return $e.FILE_MOVE_CONFLICT;case S.FileTooLarge:return $e.FILE_TOO_LARGE;default:return $e.FILE_OTHER_ERROR}}var M;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class N{constructor(Pe,Me,Y){this.resource=Pe,this.operation=Me,this.target=Y}isOperation(Pe){return this.operation===Pe}}e.$rl=N;var L;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class G{static{this.a=null}constructor(Pe,Me){this.c=Me,this.b=void 0,this.d=new y.$X(()=>{const Y=v.$Li.forUris(()=>this.c);return Y.fill(this.rawAdded.map(q=>[q,!0])),Y}),this.f=new y.$X(()=>{const Y=v.$Li.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(q=>[q,!0])),Y}),this.g=new y.$X(()=>{const Y=v.$Li.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(q=>[q,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of Pe){switch(Y.type){case L.ADDED:this.rawAdded.push(Y.resource);break;case L.UPDATED:this.rawUpdated.push(Y.resource);break;case L.DELETED:this.rawDeleted.push(Y.resource);break}this.b!==G.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains(Pe,...Me){return this.h(Pe,{includeChildren:!1},...Me)}affects(Pe,...Me){return this.h(Pe,{includeChildren:!0},...Me)}h(Pe,Me,...Y){if(!Pe)return!1;const q=Y.length>0;return!!((!q||Y.includes(L.ADDED))&&(this.d.value.get(Pe)||Me.includeChildren&&this.d.value.findSuperstr(Pe))||(!q||Y.includes(L.UPDATED))&&(this.f.value.get(Pe)||Me.includeChildren&&this.f.value.findSuperstr(Pe))||(!q||Y.includes(L.DELETED))&&(this.g.value.findSubstr(Pe)||Me.includeChildren&&this.g.value.findSuperstr(Pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Pe){return this.b===Pe}hasCorrelation(){return typeof this.b=="number"}}e.$sl=G;function W(re,Pe,Me){return!re||!Pe||re===Pe||Pe.length>re.length?!1:(Pe.charAt(Pe.length-1)!==k.sep&&(Pe+=k.sep),Me?(0,C.$Hf)(re,Pe):re.indexOf(Pe)===0)}class F extends Error{constructor(Pe,Me,Y){super(Pe),this.fileOperationResult=Me,this.options=Y}}e.$ul=F;class V extends F{constructor(Pe,Me,Y,q){super(Pe,Me,q),this.fileOperationResult=Me,this.size=Y}}e.$vl=V;class ae extends F{constructor(Pe,Me,Y){super(Pe,$e.FILE_NOT_MODIFIED_SINCE,Y),this.stat=Me}}e.$wl=ae;var $e;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})($e||(e.FileOperationResult=$e={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var _;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(_||(e.FileKind=_={})),e.$El="";function ge(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function se(re,Pe){if(!Pe.hasProvider(A.URI.from({scheme:re.scheme})))return new Promise(Me=>{const Y=Pe.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===re.scheme&&q.added&&(Y.dispose(),Me())})})}class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize(Pe){return(0,O.$jg)(Pe)||(Pe=0),Pe<ce.KB?(0,T.localize)(1,null,Pe.toFixed(0)):Pe<ce.MB?(0,T.localize)(2,null,(Pe/ce.KB).toFixed(2)):Pe<ce.GB?(0,T.localize)(3,null,(Pe/ce.MB).toFixed(2)):Pe<ce.TB?(0,T.localize)(4,null,(Pe/ce.GB).toFixed(2)):(0,T.localize)(5,null,(Pe/ce.TB).toFixed(2))}}e.$Hl=ce;function we(re){const Pe=typeof re=="string"||re?.scheme===P.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===P.Schemas.file?1024*ce.MB:Pe?10*ce.MB:a.$o?50*ce.MB:1024*ce.MB}}),define(Ce[75],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class v{constructor(...C){this.a=new Map;for(const[O,A]of C)this.set(O,A)}set(C,O){const A=this.a.get(C);return this.a.set(C,O),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Di=v}),define(Ce[211],Ie([1,0,11,14,4,74,208,3,75,212]),function(oe,e,v,k,C,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;const P=!1;class y extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class u{constructor(s=new p.$Di,o=!1,h,i=P){this.i=s,this.j=o,this.k=h,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Ei,this),this._globalGraph=i?h?._globalGraph??new A.$sr(r=>r):void 0}dispose(){if(!this.f){this.f=!0,(0,C.$Rc)(this.h),this.h.clear();for(const s of this.g)(0,C.$Qc)(s)&&s.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(s,o){this.m();const h=this,i=new class extends u{dispose(){h.h.delete(i),super.dispose()}}(s,this.j,this,this.l);return this.h.add(i),o?.add(i),i}invokeFunction(s,...o){this.m();const h=d.traceInvocation(this.l,s);let i=!1;try{return s({get:t=>{if(i)throw(0,k.$0)("service accessor is only valid during the invocation of its target method");const c=this.s(t,h);if(!c)throw new Error(`[invokeFunction] unknown service '${t}'`);return c}},...o)}finally{i=!0,h.stop()}}createInstance(s,...o){this.m();let h,i;return s instanceof O.$Ci?(h=d.traceCreation(this.l,s.ctor),i=this.o(s.ctor,s.staticArguments.concat(o),h)):(h=d.traceCreation(this.l,s),i=this.o(s,o,h)),h.stop(),i}o(s,o=[],h){const i=T._util.getServiceDependencies(s).sort((c,l)=>c.index-l.index),r=[];for(const c of i){const l=this.s(c.id,h);l||this.y(`[createInstance] ${s.name} depends on UNKNOWN service ${c.id}.`,!1),r.push(l)}const t=i.length>0?i[0].index:o.length;if(o.length!==t){console.trace(`[createInstance] First service dependency of ${s.name} at position ${t+1} conflicts with ${o.length} static arguments`);const c=t-o.length;c>0?o=o.concat(new Array(c)):o=o.slice(0,t)}return Reflect.construct(s,o.concat(r))}q(s,o){if(this.i.get(s)instanceof O.$Ci)this.i.set(s,o);else if(this.k)this.k.q(s,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(s){const o=this.i.get(s);return!o&&this.k?this.k.r(s):o}s(s,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const h=this.r(s);return h instanceof O.$Ci?this.u(s,h,o.branch(s,!0)):(o.branch(s,!1),h)}u(s,o,h){if(this.t.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.t.add(s);try{return this.v(s,o,h)}finally{this.t.delete(s)}}v(s,o,h){const i=new A.$sr(c=>c.id.toString());let r=0;const t=[{id:s,desc:o,_trace:h}];for(;t.length;){const c=t.pop();if(i.lookupOrInsertNode(c),r++>1e3)throw new y(i);for(const l of T._util.getServiceDependencies(c.desc.ctor)){const g=this.r(l.id);if(g||this.y(`[createInstance] ${s} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(c.id),String(l.id)),g instanceof O.$Ci){const m={id:l.id,desc:g,_trace:c._trace.branch(l.id,!0)};i.insertEdge(c,m),t.push(m)}}}for(;;){const c=i.roots();if(c.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:l}of c){if(this.r(l.id)instanceof O.$Ci){const m=this.w(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.q(l.id,m)}i.removeNode(l)}}return this.r(s)}w(s,o,h=[],i,r){if(this.i.get(s)instanceof O.$Ci)return this.x(s,o,h,i,r,this.g);if(this.k)return this.k.w(s,o,h,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(s,o,h=[],i,r,t){if(i){const c=new u(void 0,this.j,this,this.l);c.c=String(s);const l=new Map,g=new v.$Yh(()=>{const m=c.o(o,h,r);for(const[$,S]of l){const D=m[$];if(typeof D=="function")for(const b of S)b.disposable=D.apply(m,b.listener)}return l.clear(),t.add(m),m});return new Proxy(Object.create(null),{get(m,$){if(!g.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let b=l.get($);return b||(b=new a.$7c,l.set($,b)),(R,f,w)=>{if(g.isInitialized)return g.value[$](R,f,w);{const M={listener:[R,f,w],disposable:void 0},N=b.push(M);return(0,C.$Uc)(()=>{N(),M.disposable?.dispose()})}}}if($ in m)return m[$];const S=g.value;let D=S[$];return typeof D!="function"||(D=D.bind(S),m[$]=D),D},set(m,$,S){return g.value[$]=S,!0},getPrototypeOf(m){return o.prototype}})}else{const c=this.o(o,h,r);return t.add(c),c}}y(s,o){if(o&&console.warn(s),this.j)throw new Error(s)}}e.$tr=u;var E;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(E||(E={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(E.None,null)}stop(){}branch(){return this}}}static traceInvocation(s,o){return s?new d(E.Invocation,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(s,o){return s?new d(E.Creation,o.name):d.c}static{this.f=0}constructor(s,o){this.type=s,this.name=o,this.g=Date.now(),this.h=[]}branch(s,o){const h=new d(E.Branch,s.toString());return this.h.push([s,o,h]),h}stop(){const s=Date.now()-this.g;d.f+=s;let o=!1;function h(r,t){const c=[],l=new Array(r+1).join("	");for(const[g,m,$]of t.h)if(m&&$){o=!0,c.push(`${l}CREATES -> ${g}`);const S=h(r+1,$);S&&c.push(S)}else c.push(`${l}uses -> ${g}`);return c.join(`
`)}const i=[`${this.type===E.Creation?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(s>2||o)&&d.all.add(i.join(`
`))}}e.$ur=d}),define(Ce[12],Ie([1,0,175,41,6,76,4,29,21,24,15,2,32,3]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=n,e.log=o,e.$nk=D,e.$ok=b,e.$pk=I,e.$qk=R,v=qe(v),e.$_j=(0,E.$Fi)("logService"),e.$ak=(0,E.$Fi)("loggerService");function d(){return new Date().toISOString()}function n(f){return(0,P.$jg)(f)}var s;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$ck=s.Info;function o(f,w,M){switch(w){case s.Trace:f.trace(M);break;case s.Debug:f.debug(M);break;case s.Info:f.info(M);break;case s.Warning:f.warn(M);break;case s.Error:f.error(M);break;case s.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function h(f,w=!1){let M="";for(let N=0;N<f.length;N++){let L=f[N];if(L instanceof Error&&(L=(0,k.$qj)(L,w)),typeof L=="object")try{L=JSON.stringify(L)}catch{}M+=(N>0?" ":"")+L}return M}class i extends A.$Wc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new C.$me),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==s.Off&&this.b<=w}}e.$ek=i;class r extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...M){this.f(s.Trace)&&this.g(s.Trace,h([w,...M],!0))}debug(w,...M){this.f(s.Debug)&&this.g(s.Debug,h([w,...M]))}info(w,...M){this.f(s.Info)&&this.g(s.Info,h([w,...M]))}warn(w,...M){this.f(s.Warning)&&this.g(s.Warning,h([w,...M]))}error(w,...M){if(this.f(s.Error))if(w instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=w.stack,this.g(s.Error,h(N))}else this.g(s.Error,h([w,...M]))}flush(){}}e.$fk=r;class t extends i{constructor(w=e.$ck){super(),this.setLevel(w),this.g=!p.$i}trace(w,...M){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...M):console.log(`[main ${d()}]`,w,...M))}debug(w,...M){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...M):console.log(`[main ${d()}]`,w,...M))}info(w,...M){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...M):console.log(`[main ${d()}]`,w,...M))}warn(w,...M){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,w,...M):console.warn(`[main ${d()}]`,w,...M))}error(w,...M){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,w,...M):console.error(`[main ${d()}]`,w,...M))}flush(){}}e.$gk=t;class c extends i{constructor(w=e.$ck,M=!0){super(),this.g=M,this.setLevel(w)}trace(w,...M){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...M):console.log(w,...M))}debug(w,...M){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...M):console.log(w,...M))}info(w,...M){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...M):console.log(w,...M))}warn(w,...M){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...M):console.log(w,...M))}error(w,...M){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...M):console.error(w,...M))}flush(){}}e.$hk=c;class l extends i{constructor(w,M=e.$ck){super(),this.g=w,this.setLevel(M)}trace(w,...M){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(w),...M])}debug(w,...M){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(w),...M])}info(w,...M){this.f(s.Info)&&this.g.log(s.Info,[this.h(w),...M])}warn(w,...M){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(w),...M])}error(w,...M){this.f(s.Error)&&this.g.log(s.Error,[this.h(w),...M])}h(w){return typeof w=="string"?w:(0,k.$qj)(w,this.f(s.Trace))}flush(){}}e.$ik=l;class g extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const M of this.g)M.setLevel(w);super.setLevel(w)}trace(w,...M){for(const N of this.g)N.trace(w,...M)}debug(w,...M){for(const N of this.g)N.debug(w,...M)}info(w,...M){for(const N of this.g)N.info(w,...M)}warn(w,...M){for(const N of this.g)N.warn(w,...M)}error(w,...M){for(const N of this.g)N.error(w,...M)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$jk=g;class m extends A.$Wc{constructor(w,M,N){if(super(),this.h=w,this.j=M,this.b=new T.$Cc,this.c=this.B(new C.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$me),this.onDidChangeVisibility=this.g.event,N)for(const L of N)this.b.set(L.resource,{logger:void 0,info:L})}m(w){return(0,P.$fg)(w)?[...this.b.values()].find(M=>M.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,M){const N=this.n(w),L=(0,P.$fg)(w)?w:M?.id??(0,O.$tj)(N.toString()).toString(16);let G=this.b.get(N)?.logger;const W=M?.logLevel==="always"?s.Trace:M?.logLevel;G||(G=this.s(N,W??this.getLogLevel(N)??this.h,{...M,id:L}));const F={logger:G,info:{resource:N,id:L,logLevel:W,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(F.info),this.b.set(N,F),G}n(w){return(0,P.$fg)(w)?(0,a.$gh)(this.j,`${w}.log`):w}setLogLevel(w,M){if(y.URI.isUri(w)){const N=w,L=M,G=this.b.get(N);G&&L!==G.info.logLevel&&(G.info.logLevel=L===this.h?void 0:L,G.logger?.setLevel(L),this.b.set(G.info.resource,G),this.f.fire([N,L]))}else{this.h=w;for(const[N,L]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&L.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,M){const N=this.m(w);N&&M!==!N.info.hidden&&(N.info.hidden=!M,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,M]))}getLogLevel(w){let M;return w&&(M=this.b.get(w)?.info.logLevel),M??this.h}registerLogger(w){const M=this.b.get(w.resource);M?M.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const M=this.b.get(w);M&&(M.logger&&M.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=m;class ${constructor(){this.onDidChangeLogLevel=new C.$me().event}setLevel(w){}getLevel(){return s.Info}trace(w,...M){}debug(w,...M){}info(w,...M){}warn(w,...M){}error(w,...M){}critical(w,...M){}dispose(){}flush(){}}e.$lk=$;class S extends ${}e.$mk=S;function D(f){if(f.verbose)return s.Trace;if(typeof f.logLevel=="string"){const w=R(f.logLevel.toLowerCase());if(w!==void 0)return w}return e.$ck}function b(f){switch(f){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}function I(f){switch(f){case s.Trace:return{original:"Trace",value:v.localize(0,null)};case s.Debug:return{original:"Debug",value:v.localize(1,null)};case s.Info:return{original:"Info",value:v.localize(2,null)};case s.Warning:return{original:"Warning",value:v.localize(3,null)};case s.Error:return{original:"Error",value:v.localize(4,null)};case s.Off:return{original:"Off",value:v.localize(5,null)}}}function R(f){switch(f){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$rk=new u.$Wj("logLevel",b(s.Info))}),define(Ce[213],Ie([1,0,4,12]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class C extends v.$Wc{constructor(A,T=[]){super(),this.a=new k.$jk([A,...T]),this.B(A.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...T){this.a.trace(A,...T)}debug(A,...T){this.a.debug(A,...T)}info(A,...T){this.a.info(A,...T)}warn(A,...T){this.a.warn(A,...T)}error(A,...T){this.a.error(A,...T)}flush(){this.a.flush()}}e.$oR=C});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[108],Ie([1,0,36,176,3]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,v=ti(v);var O;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var A;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(p){function a(d,n){return n-d}p.compare=a;const P=Object.create(null);P[p.Error]=(0,k.localize)(0,null),P[p.Warning]=(0,k.localize)(1,null),P[p.Info]=(0,k.localize)(2,null);function y(d){return P[d]||""}p.toString=y;function u(d){switch(d){case v.default.Error:return p.Error;case v.default.Warning:return p.Warning;case v.default.Info:return p.Info;case v.default.Ignore:return p.Hint}}p.fromSeverity=u;function E(d){switch(d){case p.Error:return v.default.Error;case p.Warning:return v.default.Warning;case p.Info:return v.default.Info;case p.Hint:return v.default.Ignore}}p.toSeverity=E}(A||(e.MarkerSeverity=A={}));var T;(function(p){const a="";function P(u){return y(u,!0)}p.makeKey=P;function y(u,E){const d=[a];return u.source?d.push(u.source.replace("\xA6","\\\xA6")):d.push(a),u.code?typeof u.code=="string"?d.push(u.code.replace("\xA6","\\\xA6")):d.push(u.code.value.replace("\xA6","\\\xA6")):d.push(a),u.severity!==void 0&&u.severity!==null?d.push(A.toString(u.severity)):d.push(a),u.message&&E?d.push(u.message.replace("\xA6","\\\xA6")):d.push(a),u.startLineNumber!==void 0&&u.startLineNumber!==null?d.push(u.startLineNumber.toString()):d.push(a),u.startColumn!==void 0&&u.startColumn!==null?d.push(u.startColumn.toString()):d.push(a),u.endLineNumber!==void 0&&u.endLineNumber!==null?d.push(u.endLineNumber.toString()):d.push(a),u.endColumn!==void 0&&u.endColumn!==null?d.push(u.endColumn.toString()):d.push(a),d.push(a),d.join("\xA6")}p.makeKeyOptionalMessage=y})(T||(e.IMarkerData=T={})),e.$Cu=(0,C.$Fi)("markerService")});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[214],Ie([1,0,6,36,3]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sw=e.$rw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$pw=e.Severity=void 0,e.$qw=T,k=ti(k),e.Severity=k.default,e.$pw=(0,C.$Fi)("notificationService");var O;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function T(y){if(y){const u=y;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var p;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class a{constructor(){this.progress=new P,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$rw=a;class P{infinite(){}done(){}total(u){}worked(u){}}e.$sw=P}),define(Ce[109],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,v.$Fi)("productService"),e.$tk="vscode://schemas/vscode-product"});var Qe=this&&this.__decorate||function(oe,e,v,k){var C=arguments.length,O=C<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,v):k,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(oe,e,v,k);else for(var T=oe.length-1;T>=0;T--)(A=oe[T])&&(O=(C<3?A(O):C>3?A(e,v,O):A(e,v))||O);return C>3&&O&&Object.defineProperty(e,v,O),O},Ve=this&&this.__param||function(oe,e){return function(v,k){e(v,k,oe)}};define(Ce[77],Ie([1,0,11,22,4,3]),function(oe,e,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zw=e.$yw=e.$xw=e.$ww=e.$vw=e.$uw=e.ProgressLocation=e.$tw=void 0,e.$tw=(0,O.$Fi)("progressService");var A;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$uw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$vw=T;class p{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const E=this.d;this.d=()=>{E?.(),u()}}):Promise.resolve()}}e.$ww=p;let a=class extends C.$Wc{constructor(u,E){super(),this.a=new v.$3h,E.withProgress(u,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,C.$Uc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$xw=a,e.$xw=a=Qe([Ve(1,e.$tw)],a);class P extends C.$Wc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new C.$Vc)}start(u){this.stop();const E=++this.a,d=new k.$xe;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,C.$Uc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Uc)(()=>d.cancel())),this.b.add((0,C.$Uc)(()=>this.c?this.c.done():void 0)),{id:E,token:d.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$yw=P,e.$zw=(0,O.$Fi)("editorProgressService")}),define(Ce[31],Ie([1,0,62,15]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,v=qe(v),k=qe(k);class C{constructor(){this.a=new Map}add(A,T){v.ok(k.$fg(A)),v.ok(k.$hg(T)),v.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,T)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$qo=new C}),define(Ce[78],Ie([1,0,6,31]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,k=qe(k),e.$ro={JSONContribution:"base.contributions.json"};function C(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class O{constructor(){this.b=new v.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,a){this.a[C(p)]=a,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const A=new O;k.$qo.add(e.$ro.JSONContribution,A)}),define(Ce[54],Ie([1,0,18,6,15,169,43,78,31]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.ConfigurationScope=e.$vo=e.EditPresentationTypes=void 0,e.$Go=n,e.$Ho=s,e.$Io=o,e.$Jo=i,e.$Ko=r,C=qe(C),O=qe(O);var a;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$vo={Configuration:"base.contributions.configuration"};var P;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co="vscode://schemas/settings/resourceLanguage",e.$Do="vscode://schemas/settings/configurationDefaults";const y=p.$qo.as(T.$ro.JSONContribution);class u{constructor(){this.h=new Set,this.i=new k.$me,this.onDidSchemaChange=this.i.event,this.j=new k.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$Co,this.g),this.v()}registerConfiguration(c,l=!0){this.registerConfigurations([c],l)}registerConfigurations(c,l=!0){const g=new Set;this.n(c,l,g),y.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:g})}deregisterConfigurations(c){const l=new Set;this.o(c,l),y.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:c,remove:l}){const g=new Set;this.o(l,g),this.n(c,!1,g),y.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:g})}registerDefaultConfigurations(c){const l=new Set;this.k(c,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(c,l){const g=[];for(const{overrides:m,source:$}of c)for(const S in m)if(l.add(S),e.$Fo.test(S)){const D=this.a.get(S),b=D?.valuesSources??new Map;if($)for(const w of Object.keys(m[S]))b.set(w,$);const I={...D?.value||{},...m[S]};this.a.set(S,{source:$,value:I,valuesSources:b});const R=(0,A.$jj)(S),f={type:"object",default:I,description:O.localize(1,null,R),$ref:e.$Co,defaultDefaultValue:I,source:C.$fg($)?void 0:$,defaultValueSource:$};g.push(...n(S)),this.d[S]=f,this.b.properties[S]=f}else{this.a.set(S,{value:m[S],source:$});const D=this.d[S];D&&(this.w(S,D),this.r(S,D))}this.m(g)}deregisterDefaultConfigurations(c){const l=new Set;this.l(c,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(c,l){for(const{overrides:g,source:m}of c)for(const $ in g){const S=this.a.get($),D=C.$fg(m)?m:m?.id,b=C.$fg(S?.source)?S?.source:S?.source?.id;if(D===b)if(l.add($),this.a.delete($),e.$Fo.test($))delete this.d[$],delete this.b.properties[$];else{const I=this.d[$];I&&(this.w($,I),this.r($,I))}}this.u()}deltaConfiguration(c){let l=!1;const g=new Set;c.removedDefaults&&(this.l(c.removedDefaults,g),l=!0),c.addedDefaults&&(this.k(c.addedDefaults,g),l=!0),c.removedConfigurations&&this.o(c.removedConfigurations,g),c.addedConfigurations&&this.n(c.addedConfigurations,!1,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...c){this.i.fire()}registerOverrideIdentifiers(c){this.m(c),this.i.fire()}m(c){for(const l of c)this.h.add(l);this.u()}n(c,l,g){c.forEach(m=>{this.p(m,l,m.extensionInfo,m.restrictedProperties,void 0,g),this.c.push(m),this.q(m)})}o(c,l){const g=m=>{if(m.properties)for(const $ in m.properties){l.add($);const S=this.d[$];S?.policy?.name&&this.e.delete(S.policy.name),delete this.d[$],this.s($,m.properties[$])}m.allOf?.forEach($=>g($))};for(const m of c){g(m);const $=this.c.indexOf(m);$!==-1&&this.c.splice($,1)}}p(c,l=!0,g,m,$=P.WINDOW,S){$=C.$og(c.scope)?$:c.scope;const D=c.properties;if(D)for(const I in D){const R=D[I];if(l&&i(I,R)){delete D[I];continue}if(R.source=g,R.defaultDefaultValue=D[I].default,this.w(I,R),e.$Fo.test(I)?R.scope=void 0:(R.scope=C.$og(R.scope)?$:R.scope,R.restricted=C.$og(R.restricted)?!!m?.includes(I):R.restricted),D[I].hasOwnProperty("included")&&!D[I].included){this.f[I]=D[I],delete D[I];continue}else this.d[I]=D[I],D[I].policy?.name&&this.e.set(D[I].policy.name,I);!D[I].deprecationMessage&&D[I].markdownDeprecationMessage&&(D[I].deprecationMessage=D[I].markdownDeprecationMessage),S.add(I)}const b=c.allOf;if(b)for(const I of b)this.p(I,l,g,m,$,S)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(c){const l=g=>{const m=g.properties;if(m)for(const S in m)this.r(S,m[S]);g.allOf?.forEach(l)};l(c)}r(c,l){switch(e.$wo.properties[c]=l,l.scope){case P.APPLICATION:e.$xo.properties[c]=l;break;case P.MACHINE:e.$yo.properties[c]=l;break;case P.MACHINE_OVERRIDABLE:e.$zo.properties[c]=l;break;case P.WINDOW:e.$Ao.properties[c]=l;break;case P.RESOURCE:e.$Bo.properties[c]=l;break;case P.LANGUAGE_OVERRIDABLE:e.$Bo.properties[c]=l,this.g.properties[c]=l;break}}s(c,l){switch(delete e.$wo.properties[c],l.scope){case P.APPLICATION:delete e.$xo.properties[c];break;case P.MACHINE:delete e.$yo.properties[c];break;case P.MACHINE_OVERRIDABLE:delete e.$zo.properties[c];break;case P.WINDOW:delete e.$Ao.properties[c];break;case P.RESOURCE:case P.LANGUAGE_OVERRIDABLE:delete e.$Bo.properties[c],delete this.g.properties[c];break}}u(){for(const c of this.h.values()){const l=`[${c}]`,g={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$Co};this.w(l,g),e.$wo.properties[l]=g,e.$xo.properties[l]=g,e.$yo.properties[l]=g,e.$zo.properties[l]=g,e.$Ao.properties[l]=g,e.$Bo.properties[l]=g}}v(){const c={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$Co};e.$wo.patternProperties[e.$Eo]=c,e.$xo.patternProperties[e.$Eo]=c,e.$yo.patternProperties[e.$Eo]=c,e.$zo.patternProperties[e.$Eo]=c,e.$Ao.patternProperties[e.$Eo]=c,e.$Bo.patternProperties[e.$Eo]=c,this.i.fire()}w(c,l){const g=this.a.get(c);let m=g?.value,$=g?.source;C.$mg(m)&&(m=l.defaultDefaultValue,$=void 0),C.$mg(m)&&(m=o(l.type)),l.default=m,l.defaultValueSource=$}}const E="\\[([^\\]]+)\\]",d=new RegExp(E,"g");e.$Eo=`^(${E})+$`,e.$Fo=new RegExp(e.$Eo);function n(t){const c=[];if(e.$Fo.test(t)){let l=d.exec(t);for(;l?.length;){const g=l[1].trim();g&&c.push(g),l=d.exec(t)}}return(0,v.$Ob)(c)}function s(t){return t.reduce((c,l)=>`${c}[${l}]`,"")}function o(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const h=new u;p.$qo.add(e.$vo.Configuration,h);function i(t,c){return t.trim()?e.$Fo.test(t)?O.localize(7,null,t):h.getConfigurationProperties()[t]!==void 0?O.localize(8,null,t):c.policy?.name&&h.getPolicyConfigurations().get(c.policy?.name)!==void 0?O.localize(9,null,t,c.policy?.name,h.getPolicyConfigurations().get(c.policy?.name)):null:O.localize(6,null)}function r(){const t=[],c=h.getConfigurationProperties();for(const l of Object.keys(c))t.push([l,c[l].scope]);return t.push(["launch",P.RESOURCE]),t.push(["task",P.RESOURCE]),t}}),define(Ce[215],Ie([1,0,18,6,136,4,29,26,15,2,43,54,30,31]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0,e.$Po=r,v=qe(v),C=qe(C),T=qe(T),p=qe(p);function d(g){return Object.isFrozen(g)?g:T.$eo(g)}class n{static createEmptyModel(m){return new n({},[],[],void 0,m)}constructor(m,$,S,D,b){this.b=m,this.c=$,this.d=S,this.raw=D,this.f=b,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const m=this.raw.map($=>{if($ instanceof n)return $;const S=new s("",this.f);return S.parseRaw($),S.configurationModel});this.g=m.reduce(($,S)=>S===$?S:$.merge(S),m[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(m){return m?(0,P.$hj)(this.contents,m):this.contents}inspect(m,$){const S=this;return{get value(){return d(S.rawConfiguration.getValue(m))},get override(){return $?d(S.rawConfiguration.getOverrideValue(m,$)):void 0},get merged(){return d($?S.rawConfiguration.override($).getValue(m):S.rawConfiguration.getValue(m))},get overrides(){const D=[];for(const{contents:b,identifiers:I,keys:R}of S.rawConfiguration.overrides){const f=new n(b,R,[],void 0,S.f).getValue(m);f!==void 0&&D.push({identifiers:I,value:f})}return D.length?d(D):void 0}}}getOverrideValue(m,$){const S=this.j($);return S?m?(0,P.$hj)(S,m):S:void 0}getKeysForOverrideIdentifier(m){const $=[];for(const S of this.overrides)S.identifiers.includes(m)&&$.push(...S.keys);return v.$Ob($)}getAllOverrideIdentifiers(){const m=[];for(const $ of this.overrides)m.push(...$.identifiers);return v.$Ob(m)}override(m){let $=this.a.get(m);return $||($=this.h(m),this.a.set(m,$)),$}merge(...m){const $=T.$do(this.contents),S=T.$do(this.overrides),D=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const I of m)if(b.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.i($,I.contents);for(const R of I.overrides){const[f]=S.filter(w=>v.$wb(w.identifiers,R.identifiers));f?(this.i(f.contents,R.contents),f.keys.push(...R.keys),f.keys=v.$Ob(f.keys)):S.push(T.$do(R))}for(const R of I.keys)D.indexOf(R)===-1&&D.push(R)}return new n($,D,S,b.every(I=>I instanceof n)?void 0:b,this.f)}h(m){const $=this.j(m);if(!$||typeof $!="object"||!Object.keys($).length)return this;const S={};for(const D of v.$Ob([...Object.keys(this.contents),...Object.keys($)])){let b=this.contents[D];const I=$[D];I&&(typeof b=="object"&&typeof I=="object"?(b=T.$do(b),this.i(b,I)):b=I),S[D]=b}return new n(S,this.keys,this.overrides,void 0,this.f)}i(m,$){for(const S of Object.keys($)){if(S in m&&p.$hg(m[S])&&p.$hg($[S])){this.i(m[S],$[S]);continue}m[S]=T.$do($[S])}}j(m){let $=null,S=null;const D=b=>{b&&(S?this.i(S,b):S=T.$do(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===m?$=b.contents:b.identifiers.includes(m)&&D(b.contents);return D($),S}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(m,$){this.k(m,$,!0)}setValue(m,$){this.k(m,$,!1)}removeValue(m){const $=this.keys.indexOf(m);$!==-1&&(this.keys.splice($,1),(0,P.$gj)(this.contents,m),y.$Fo.test(m)&&this.overrides.splice(this.overrides.findIndex(S=>v.$wb(S.identifiers,(0,y.$Go)(m))),1))}k(m,$,S){(0,P.$fj)(this.contents,m,$,D=>this.f.error(D)),S=S||this.keys.indexOf(m)===-1,S&&this.keys.push(m),y.$Fo.test(m)&&this.overrides.push({identifiers:(0,y.$Go)(m),keys:Object.keys(this.contents[m]),contents:(0,P.$ej)(this.contents[m],D=>this.f.error(D))})}}e.$Lo=n;class s{constructor(m,$){this.f=m,this.g=$,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||n.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(m,$){if(!p.$og(m)){const S=this.h(m);this.parseRaw(S,$)}}reparse(m){this.a&&this.parseRaw(this.a,m)}parseRaw(m,$){this.a=m;const{contents:S,keys:D,overrides:b,restricted:I,hasExcludedProperties:R}=this.i(m,$);this.b=new n(S,D,b,R?[m]:void 0,this.g),this.c=I||[]}h(m){let $={},S=null,D=[];const b=[],I=[];function R(w){Array.isArray(D)?D.push(w):S!==null&&(D[S]=w)}const f={onObjectBegin:()=>{const w={};R(w),b.push(D),D=w,S=null},onObjectProperty:w=>{S=w},onObjectEnd:()=>{D=b.pop()},onArrayBegin:()=>{const w=[];R(w),b.push(D),D=w,S=null},onArrayEnd:()=>{D=b.pop()},onLiteralValue:R,onError:(w,M,N)=>{I.push({error:w,offset:M,length:N})}};if(m)try{C.$5n(m,f),$=D[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return $}i(m,$){const S=E.$qo.as(y.$vo.Configuration).getConfigurationProperties(),D=this.j(m,S,!0,$);m=D.raw;const b=(0,P.$ej)(m,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`)),I=Object.keys(m),R=this.l(m,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:b,keys:I,overrides:R,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(m,$,S,D){let b=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:m,restricted:[],hasExcludedProperties:b};const I={},R=[];for(const f in m)if(y.$Fo.test(f)&&S){const w=this.j(m[f],$,!1,D);I[f]=w.raw,b=b||w.hasExcludedProperties,R.push(...w.restricted)}else{const w=$[f],M=w?typeof w.scope<"u"?w.scope:y.ConfigurationScope.WINDOW:void 0;w?.restricted&&R.push(f),!D.exclude?.includes(f)&&(D.include?.includes(f)||(M===void 0||D.scopes===void 0||D.scopes.includes(M))&&!(D.skipRestricted&&w?.restricted))?I[f]=m[f]:b=!0}return{raw:I,restricted:R,hasExcludedProperties:b}}l(m,$){const S=[];for(const D of Object.keys(m))if(y.$Fo.test(D)){const b={};for(const I in m[D])b[I]=m[D][I];S.push({identifiers:(0,y.$Go)(D),keys:Object.keys(b),contents:(0,P.$ej)(b,$)})}return S}}e.$Mo=s;class o extends O.$Wc{constructor(m,$,S,D,b){super(),this.c=m,this.f=$,this.g=D,this.h=b,this.b=this.B(new k.$me),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),b),this.B(this.g.watch(S.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(k.Event.any(k.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),k.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(u.FileOperation.CREATE)||I.isOperation(u.FileOperation.COPY)||I.isOperation(u.FileOperation.DELETE)||I.isOperation(u.FileOperation.WRITE))&&S.isEqual(I.resource,m)))(()=>this.b.fire()))}async loadConfiguration(){try{const m=await this.g.readFile(this.c);return this.a.parse(m.value.toString()||"{}",this.f),this.a.configurationModel}catch{return n.createEmptyModel(this.h)}}reparse(m){return m&&(this.f=m),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$No=o;class h{constructor(m,$,S,D,b,I,R,f,w,M,N,L,G){this.a=m,this.b=$,this.c=S,this.overrideIdentifiers=D,this.d=b,this.f=I,this.g=R,this.h=f,this.i=w,this.j=M,this.k=N,this.l=L,this.m=G}get value(){return d(this.c)}n(m){return m?.value!==void 0||m?.override!==void 0||m?.overrides!==void 0?m:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(m,$,S,D,b,I,R,f,w,M){this.j=m,this.l=$,this.m=S,this.n=D,this.p=b,this.q=I,this.r=R,this.s=f,this.t=w,this.u=M,this.h=null,this.i=new A.$Cc,this.v=null}getValue(m,$,S){return this.w(m,$,S).getValue(m)}updateValue(m,$,S={}){let D;S.resource?(D=this.t.get(S.resource),D||(D=n.createEmptyModel(this.u),this.t.set(S.resource,D))):D=this.s,$===void 0?D.removeValue(m):D.setValue(m,$),S.resource||(this.h=null)}inspect(m,$,S){const D=this.w(m,$,S),b=this.A($.resource,S),I=$.resource?this.t.get($.resource)||this.s:this.s,R=new Set;for(const f of D.overrides)for(const w of f.identifiers)D.getOverrideValue(m,w)!==void 0&&R.add(w);return new h(m,$,D.getValue(m),R.size?[...R]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,S?this.q:void 0,b||void 0,I)}keys(m){const $=this.A(void 0,m);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(m){this.j=m,this.h=null,this.i.clear()}updatePolicyConfiguration(m){this.l=m}updateApplicationConfiguration(m){this.m=m,this.h=null,this.i.clear()}updateLocalUserConfiguration(m){this.n=m,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(m){this.p=m,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(m){this.q=m,this.h=null,this.i.clear()}updateFolderConfiguration(m,$){this.r.set(m,$),this.i.delete(m)}deleteFolderConfiguration(m){this.folderConfigurations.delete(m),this.i.delete(m)}compareAndUpdateDefaultConfiguration(m,$){const S=[];if(!$){const{added:D,updated:b,removed:I}=c(this.j,m);$=[...D,...b,...I]}for(const D of $)for(const b of(0,y.$Go)(D)){const I=this.j.getKeysForOverrideIdentifier(b),R=m.getKeysForOverrideIdentifier(b),f=[...R.filter(w=>I.indexOf(w)===-1),...I.filter(w=>R.indexOf(w)===-1),...I.filter(w=>!T.$ho(this.j.override(b).getValue(w),m.override(b).getValue(w)))];S.push([b,f])}return this.updateDefaultConfiguration(m),{keys:$,overrides:S}}compareAndUpdatePolicyConfiguration(m){const{added:$,updated:S,removed:D}=c(this.l,m),b=[...$,...S,...D];return b.length&&this.updatePolicyConfiguration(m),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(m){const{added:$,updated:S,removed:D,overrides:b}=c(this.applicationConfiguration,m),I=[...$,...S,...D];return I.length&&this.updateApplicationConfiguration(m),{keys:I,overrides:b}}compareAndUpdateLocalUserConfiguration(m){const{added:$,updated:S,removed:D,overrides:b}=c(this.localUserConfiguration,m),I=[...$,...S,...D];return I.length&&this.updateLocalUserConfiguration(m),{keys:I,overrides:b}}compareAndUpdateRemoteUserConfiguration(m){const{added:$,updated:S,removed:D,overrides:b}=c(this.remoteUserConfiguration,m),I=[...$,...S,...D];return I.length&&this.updateRemoteUserConfiguration(m),{keys:I,overrides:b}}compareAndUpdateWorkspaceConfiguration(m){const{added:$,updated:S,removed:D,overrides:b}=c(this.workspaceConfiguration,m),I=[...$,...S,...D];return I.length&&this.updateWorkspaceConfiguration(m),{keys:I,overrides:b}}compareAndUpdateFolderConfiguration(m,$){const S=this.folderConfigurations.get(m),{added:D,updated:b,removed:I,overrides:R}=c(S,$),f=[...D,...b,...I];return(f.length||!S)&&this.updateFolderConfiguration(m,$),{keys:f,overrides:R}}compareAndDeleteFolderConfiguration(m){const $=this.folderConfigurations.get(m);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(m);const{added:S,updated:D,removed:b,overrides:I}=c($,void 0);return{keys:[...S,...D,...b],overrides:I}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(m,$,S){let D=this.x($,S);return $.overrideIdentifier&&(D=D.override($.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(m)!==void 0&&(D=D.merge(this.l)),D}x({resource:m},$){let S=this.y();if($&&m){const D=$.getFolder(m);D&&(S=this.z(D.uri)||S);const b=this.t.get(m);b&&(S=S.merge(b))}return S}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(m){let $=this.i.get(m);if(!$){const S=this.y(),D=this.r.get(m);D?($=S.merge(D),this.i.set(m,$)):$=S}return $}A(m,$){if($&&m){const S=$.getFolder(m);if(S)return this.r.get(S.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((m,$)=>{const{contents:S,overrides:D,keys:b}=this.r.get($);return m.push([$,{contents:S,overrides:D,keys:b}]),m},[])}}allKeys(){const m=new Set;return this.j.keys.forEach($=>m.add($)),this.userConfiguration.keys.forEach($=>m.add($)),this.q.keys.forEach($=>m.add($)),this.r.forEach($=>$.keys.forEach(S=>m.add(S))),[...m.values()]}B(){const m=new Set;return this.j.getAllOverrideIdentifiers().forEach($=>m.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>m.add($)),this.q.getAllOverrideIdentifiers().forEach($=>m.add($)),this.r.forEach($=>$.getAllOverrideIdentifiers().forEach(S=>m.add(S))),[...m.values()]}D(m){const $=new Set;return this.j.getKeysForOverrideIdentifier(m).forEach(S=>$.add(S)),this.userConfiguration.getKeysForOverrideIdentifier(m).forEach(S=>$.add(S)),this.q.getKeysForOverrideIdentifier(m).forEach(S=>$.add(S)),this.r.forEach(S=>S.getKeysForOverrideIdentifier(m).forEach(D=>$.add(D))),[...$.values()]}static parse(m,$){const S=this.E(m.defaults,$),D=this.E(m.policy,$),b=this.E(m.application,$),I=this.E(m.user,$),R=this.E(m.workspace,$),f=m.folders.reduce((w,M)=>(w.set(a.URI.revive(M[0]),this.E(M[1],$)),w),new A.$Cc);return new i(S,D,b,I,n.createEmptyModel($),R,f,n.createEmptyModel($),new A.$Cc,$)}static E(m,$){return new n(m.contents,m.keys,m.overrides,void 0,$)}}e.$Oo=i;function r(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const m=new Set,$=new Map;for(const D of g)D.keys.forEach(b=>m.add(b)),D.overrides.forEach(([b,I])=>{const R=(0,A.$zc)($,b,new Set);I.forEach(f=>R.add(f))});const S=[];return $.forEach((D,b)=>S.push([b,[...D.values()]])),{keys:[...m.values()],overrides:S}}class t{constructor(m,$,S,D,b){this.change=m,this.f=$,this.g=S,this.h=D,this.i=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const I of m.keys)this.affectedKeys.add(I);for(const[,I]of m.overrides)for(const R of I)this.affectedKeys.add(R);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(m,$){const S=this.a+m,D=this.d.indexOf(S);if(D<0)return!1;const b=D+S.length;if(b>=this.d.length)return!1;const I=this.d.charCodeAt(b);if(I!==this.b&&I!==this.c)return!1;if($){const R=this.previousConfiguration?this.previousConfiguration.getValue(m,$,this.f?.workspace):void 0,f=this.g.getValue(m,$,this.h);return!T.$ho(R,f)}return!0}}e.$Qo=t;function c(g,m){const{added:$,removed:S,updated:D}=l(m?.rawConfiguration,g?.rawConfiguration),b=[],I=g?.getAllOverrideIdentifiers()||[],R=m?.getAllOverrideIdentifiers()||[];if(m){const f=R.filter(w=>!I.includes(w));for(const w of f)b.push([w,m.getKeysForOverrideIdentifier(w)])}if(g){const f=I.filter(w=>!R.includes(w));for(const w of f)b.push([w,g.getKeysForOverrideIdentifier(w)])}if(m&&g){for(const f of I)if(R.includes(f)){const w=l({contents:g.getOverrideValue(void 0,f)||{},keys:g.getKeysForOverrideIdentifier(f)},{contents:m.getOverrideValue(void 0,f)||{},keys:m.getKeysForOverrideIdentifier(f)});b.push([f,[...w.added,...w.removed,...w.updated]])}}return{added:$,removed:S,updated:D,overrides:b}}function l(g,m){const $=g?m?g.keys.filter(b=>m.keys.indexOf(b)===-1):[...g.keys]:[],S=m?g?m.keys.filter(b=>g.keys.indexOf(b)===-1):[...m.keys]:[],D=[];if(g&&m){for(const b of m.keys)if(g.keys.indexOf(b)!==-1){const I=(0,P.$hj)(m.contents,b),R=(0,P.$hj)(g.contents,b);T.$ho(I,R)||D.push(b)}}return{added:$,removed:S,updated:D}}}),define(Ce[110],Ie([1,0,14,3]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=a,e.$Ql=(0,k.$Fi)("remoteAuthorityResolverService");var C;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class O{constructor(y){this.id=y,this.type=C.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=O;class A{constructor(y,u){this.host=y,this.port=u,this.type=C.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=A;var T;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class p extends v.$db{static isNotAvailable(y){return y instanceof p&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof p&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof p&&y._code===T.NoResolverFound}static isInvalidAuthority(y){return y instanceof p&&y._code===T.InvalidAuthority}static isHandled(y){return y instanceof p&&y.isHandled}constructor(y,u=T.Unknown,E){super(y),this._message=y,this._code=u,this._detail=E,this.isHandled=u===T.NotAvailable&&E===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Tl=p;function a(P){const y=P.indexOf("+");return y===-1?P:P.substring(0,y)}}),define(Ce[63],Ie([1,0,16]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=k,e.$hn=C,e.$in=O,e.$jn=A;function k(p){return p.scheme===v.Schemas.vscodeRemote?p.authority:void 0}function C(p){if(!p)return;const a=p.indexOf("+");return a<0?p:p.substr(0,a)}function O(p){const{host:a,port:P}=T(p);if(typeof P>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:P}}function A(p,a){let{host:P,port:y}=T(p);return typeof y>"u"&&(y=a),{host:P,port:y}}function T(p){const a=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const P=p.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const y=p.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:p,port:void 0}}}),define(Ce[19],Ie([1,0,13,3,63]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=O,e.$tn=y,e.$un=u,e.$vn=E,e.$wn=d,e.$xn=n,e.$yn=s,v=qe(v),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function O(o){if(typeof o=="object"&&o!==null&&o.supported!==!0)return o.description}e.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(o){o[o.System=0]="System",o[o.User=1]="User"})(A||(e.ExtensionType=A={}));var T;(function(o){o.WIN32_X64="win32-x64",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class p{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,i){if(typeof h>"u"||h===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof h=="string"||typeof i=="string"){const r=typeof h=="string"?h:h.value,t=typeof i=="string"?i:i.value;return v.$Gf(r,t)}return h._lower===i._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.$qn=p;class a{get size(){return this.c.size}constructor(h){if(this.c=new Set,h)for(const i of h)this.add(i)}add(h){this.c.add(p.toKey(h))}delete(h){return this.c.delete(p.toKey(h))}has(h){return this.c.has(p.toKey(h))}}e.$rn=a;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(h){this.c.delete(p.toKey(h))}get(h){return this.c.get(p.toKey(h))}has(h){return this.c.has(p.toKey(h))}set(h,i){this.c.set(p.toKey(h),i)}values(){return this.c.values()}forEach(h){this.c.forEach(h)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=P;function y(o){return u(o)}function u(o){return o.contributes&&o.contributes.localizations?o.contributes.localizations.length>0:!1}function E(o){return o.contributes&&o.contributes.authentication?o.contributes.authentication.length>0:!1}function d(o,h){if(h){const i=`onResolveRemoteAuthority:${(0,C.$hn)(h)}`;return!!o.activationEvents?.includes(i)}return!1}function n(o){return o.map(h=>{const[i,r]=h.split("@");return{proposalName:i,version:r?parseInt(r):void 0}})}function s(o){return o.map(h=>h.split("@")[0])}e.$zn=(0,k.$Fi)("IBuiltinExtensionsScannerService")}),define(Ce[111],Ie([1,0,21,172,19,3]),function(oe,e,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.ExtensionManagementErrorCode=e.$jp=e.ExtensionGalleryErrorCode=e.$ip=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$cp=T,e.$dp=p,e.$ep=a,e.$fp=P,e.$gp=y,e.$hp=u,e.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9o=new RegExp(e.$8o),e.$0o="__web_extension",e.$$o="skipWalkthrough",e.$_o="extensionInstallSource",e.$ap="dependecyOrPackExtensionInstall",e.$bp="clientTargetPlatform";var A;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function T(t){switch(t){case C.TargetPlatform.WIN32_X64:return"Windows 64 bit";case C.TargetPlatform.WIN32_ARM64:return"Windows ARM";case C.TargetPlatform.LINUX_X64:return"Linux 64 bit";case C.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case C.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case C.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case C.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case C.TargetPlatform.DARWIN_X64:return"Mac";case C.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case C.TargetPlatform.WEB:return"Web";case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;case C.TargetPlatform.UNKNOWN:return C.TargetPlatform.UNKNOWN;case C.TargetPlatform.UNDEFINED:return C.TargetPlatform.UNDEFINED}}function p(t){switch(t){case C.TargetPlatform.WIN32_X64:return C.TargetPlatform.WIN32_X64;case C.TargetPlatform.WIN32_ARM64:return C.TargetPlatform.WIN32_ARM64;case C.TargetPlatform.LINUX_X64:return C.TargetPlatform.LINUX_X64;case C.TargetPlatform.LINUX_ARM64:return C.TargetPlatform.LINUX_ARM64;case C.TargetPlatform.LINUX_ARMHF:return C.TargetPlatform.LINUX_ARMHF;case C.TargetPlatform.ALPINE_X64:return C.TargetPlatform.ALPINE_X64;case C.TargetPlatform.ALPINE_ARM64:return C.TargetPlatform.ALPINE_ARM64;case C.TargetPlatform.DARWIN_X64:return C.TargetPlatform.DARWIN_X64;case C.TargetPlatform.DARWIN_ARM64:return C.TargetPlatform.DARWIN_ARM64;case C.TargetPlatform.WEB:return C.TargetPlatform.WEB;case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;default:return C.TargetPlatform.UNKNOWN}}function a(t,c){switch(t){case v.Platform.Windows:return c==="x64"?C.TargetPlatform.WIN32_X64:c==="arm64"?C.TargetPlatform.WIN32_ARM64:C.TargetPlatform.UNKNOWN;case v.Platform.Linux:return c==="x64"?C.TargetPlatform.LINUX_X64:c==="arm64"?C.TargetPlatform.LINUX_ARM64:c==="arm"?C.TargetPlatform.LINUX_ARMHF:C.TargetPlatform.UNKNOWN;case"alpine":return c==="x64"?C.TargetPlatform.ALPINE_X64:c==="arm64"?C.TargetPlatform.ALPINE_ARM64:C.TargetPlatform.UNKNOWN;case v.Platform.Mac:return c==="x64"?C.TargetPlatform.DARWIN_X64:c==="arm64"?C.TargetPlatform.DARWIN_ARM64:C.TargetPlatform.UNKNOWN;case v.Platform.Web:return C.TargetPlatform.WEB}}function P(t,c){return c===C.TargetPlatform.WEB&&!t.includes(C.TargetPlatform.WEB)}function y(t,c,l){return P(c,l)?!1:t===C.TargetPlatform.UNDEFINED||t===C.TargetPlatform.UNIVERSAL?!0:t===C.TargetPlatform.UNKNOWN?!1:t===l}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var E;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var d;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var n;(function(t){t.Install="install",t.Uninstall="uninstall"})(n||(e.StatisticType=n={}));var s;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(s||(e.InstallOperation=s={})),e.$ip=(0,O.$Fi)("extensionGalleryService");var o;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(o||(e.ExtensionGalleryErrorCode=o={}));class h extends Error{constructor(c,l){super(c),this.code=l,this.name=l}}e.$jp=h;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class r extends Error{constructor(c,l){super(c),this.code=l,this.name=l}}e.$kp=r,e.$lp=(0,O.$Fi)("extensionManagementService"),e.$mp="extensionsIdentifiers/disabled",e.$np="extensionsIdentifiers/enabled",e.$op=(0,O.$Fi)("IGlobalExtensionEnablementService"),e.$pp=(0,O.$Fi)("IExtensionTipsService"),e.$qp=(0,k.localize2)(0,"Extensions"),e.$rp=(0,k.localize2)(1,"Preferences")}),define(Ce[112],Ie([1,0,14,19]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MG=e.$LG=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,T){this.a.set(A,T)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const T=Object.create(null);for(const p of A){const a=this.readActivationEvents(p);a.length>0&&(T[k.$qn.toKey(p.identifier)]=a)}return T}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const T=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let p=0;p<T.length;p++)T[p]==="onUri"&&(T[p]=`onUri:${k.$qn.toKey(A.identifier)}`);if(!A.contributes)return T;for(const p in A.contributes){const a=this.a.get(p);if(!a)continue;const P=A.contributes[p],y=Array.isArray(P)?P:[P];try{a(y,T)}catch(u){(0,v.$3)(u)}}return T}}e.$LG=C,e.$MG=new C});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[216],Ie([1,0,24,36,173,323,19,105]),function(oe,e,v,k,C,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=P,e.$Xp=y,e.$Yp=u,e.$Zp=E,e.$1p=d,e.$2p=n,e.$3p=s,e.$4p=o,k=ti(k),C=qe(C),O=qe(O);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function P(r){return r=r.trim(),r==="*"||p.test(r)}function y(r){if(!P(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=r.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(r){if(!r)return null;const t=r.majorBase,c=r.majorMustEqual,l=r.minorBase;let g=r.minorMustEqual;const m=r.patchBase;let $=r.patchMustEqual;r.hasCaret&&(t===0||(g=!1),$=!1);let S=0;if(r.preRelease){const D=a.exec(r.preRelease);if(D){const[,b,I,R]=D;S=Date.UTC(Number(b),Number(I)-1,Number(R))}}return{majorBase:t,majorMustEqual:c,minorBase:l,minorMustEqual:g,patchBase:m,patchMustEqual:$,isMinimum:r.hasGreaterEquals,notBefore:S}}function E(r,t,c){let l;typeof r=="string"?l=u(y(r)):l=r;let g;t instanceof Date?g=t.getTime():typeof t=="string"&&(g=new Date(t).getTime());let m;if(typeof c=="string"?m=u(y(c)):m=c,!l||!m)return!1;const $=l.majorBase,S=l.minorBase,D=l.patchBase;let b=m.majorBase,I=m.minorBase,R=m.patchBase;const f=m.notBefore;let w=m.majorMustEqual,M=m.minorMustEqual,N=m.patchMustEqual;return m.isMinimum?$>b?!0:$<b?!1:S>I?!0:S<I||g&&g<f?!1:D>=R:($===1&&b===0&&(!w||!M||!N)&&(b=1,I=0,R=0,w=!0,M=!1,N=!1),$<b?!1:$>b?!w:S<I?!1:S>I?!M:D<R?!1:D>R?!N:!(g&&g<f))}function d(r,t,c,l,g){const m=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return m.push([k.default.Error,C.localize(0,null)]),m;if(typeof l.name!="string")return m.push([k.default.Error,C.localize(1,null,"name")]),m;if(typeof l.version!="string")return m.push([k.default.Error,C.localize(2,null,"version")]),m;if(!l.engines)return m.push([k.default.Error,C.localize(3,null,"engines")]),m;if(typeof l.engines.vscode!="string")return m.push([k.default.Error,C.localize(4,null,"engines.vscode")]),m;if(typeof l.extensionDependencies<"u"&&!i(l.extensionDependencies))return m.push([k.default.Error,C.localize(5,null,"extensionDependencies")]),m;if(typeof l.activationEvents<"u"){if(!i(l.activationEvents))return m.push([k.default.Error,C.localize(6,null,"activationEvents")]),m;if(typeof l.main>"u"&&typeof l.browser>"u")return m.push([k.default.Error,C.localize(7,null,"activationEvents","main","browser")]),m}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&m.push([k.default.Warning,C.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return m.push([k.default.Error,C.localize(9,null,"main")]),m;{const D=(0,v.$gh)(c,l.main);(0,v.$ah)(D,c)||m.push([k.default.Warning,C.localize(10,null,D.path,c.path)])}}if(typeof l.browser<"u"){if(typeof l.browser!="string")return m.push([k.default.Error,C.localize(11,null,"browser")]),m;{const D=(0,v.$gh)(c,l.browser);(0,v.$ah)(D,c)||m.push([k.default.Warning,C.localize(12,null,D.path,c.path)])}}if(!O.valid(l.version))return m.push([k.default.Error,C.localize(13,null)]),m;const $=[];if(!n(r,t,l,g,$))for(const D of $)m.push([k.default.Error,D]);if(l.enabledApiProposals?.length){const D=[];if(!o([...l.enabledApiProposals],D))for(const b of D)m.push([k.default.Error,b])}return m}function n(r,t,c,l,g){return l||typeof c.main>"u"&&typeof c.browser>"u"?!0:h(r,t,c.engines.vscode,g)}function s(r,t,c){return r==="*"||h(t,c,r)}function o(r,t){if(r.length===0)return!0;const c=Array.isArray(t)?t:void 0,l=(c?void 0:t)??T.allApiProposals,g=[],m=(0,A.$xn)(r);for(const{proposalName:$,version:S}of m){const D=l[$];D&&S&&D.version!==S&&(D.version?g.push(C.localize(14,null,$,S,D.version)):g.push(C.localize(15,null,$,S)))}return c?.push(...g),g.length===0}function h(r,t,c,l=[]){const g=u(y(c));if(!g)return l.push(C.localize(16,null,c)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return l.push(C.localize(17,null,c)),!1}else if(!g.majorMustEqual)return l.push(C.localize(18,null,c)),!1;return E(r,t,g)?!0:(l.push(C.localize(19,null,r,c)),!1)}function i(r){if(!Array.isArray(r))return!1;for(let t=0,c=r.length;t<c;t++)if(typeof r[t]!="string")return!1;return!0}}),define(Ce[217],Ie([1,0,23,14,4,177,54,3,12,31]),function(oe,e,v,k,C,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.$7p=u,e.$8p=E,e.$9p=d,e.$0p=n,e.$$p=s,e.$_p=o,e.$5p=(0,T.$Fi)("requestService");class P{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const c in this.b)c.toLowerCase()==="authorization"||c.toLowerCase()==="proxy-authorization"?t[c]="*****":t[c]=this.b[c];this.a=t}return this.a}}class y extends C.$Wc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,O.localize)(0,null),when:p.$rk.isEqualTo((0,p.$ok)(p.LogLevel.Trace)).serialize()})}async c(t,c,l){const g=`${t} #${++this.b}: ${c.url}`;this.a.trace(`${g} - begin`,c.type,new P(c.headers??{}));try{const m=await l();return this.a.trace(`${g} - end`,c.type,m.res.statusCode,m.res.headers),m}catch(m){throw this.a.error(`${g} - error`,c.type,(0,k.$_)(m)),m}}}e.$6p=y;function u(r){return r.res.statusCode&&r.res.statusCode>=200&&r.res.statusCode<300||r.res.statusCode===1223}function E(r){return r.res.statusCode===204}async function d(r){return E(r)?null:(await(0,v.$1e)(r.stream)).toString()}async function n(r){if(!u(r))throw new Error("Server returned "+r.res.statusCode);return d(r)}async function s(r){if(!u(r))throw new Error("Server returned "+r.res.statusCode);if(E(r))return null;const c=(await(0,v.$1e)(r.stream)).toString();try{return JSON.parse(c)}catch(l){throw l.message+=`:
`+c,l}}function o(r){i(r)}let h;function i(r){const t=a.$qo.as(A.$vo.Configuration),c=h;h={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:r,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},t.updateConfigurations({add:[h],remove:c?[c]:[]})}i(A.ConfigurationScope.APPLICATION)}),define(Ce[218],Ie([1,0,21,79,37]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=A,e.$tp=T;function O(p){if(v.$u===v.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function A(p,a,P,y,u,E,d,n,s,o){const h=Object.create(null);h["common.machineId"]=E,h["common.sqmId"]=d,h["common.devDeviceId"]=n,h.sessionID=(0,C.$2g)()+Date.now(),h.commitHash=y,h.version=u,h["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,v.$h)(v.$u),h["common.nodePlatform"]=k.$fc,h["common.nodeArch"]=P,h["common.product"]=o||"desktop",s&&(h["common.msftInternal"]=s);let i=0;const r=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),v.$l&&(h["common.snap"]="true");const t=O(a);return t&&(h["common.platformDetail"]=t),h}function T(p){const a=k.env.USERDNSDOMAIN;if(!a)return!1;const P=a.toLowerCase();return p.some(y=>P===y)}}),define(Ce[113],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,v.$Fi)("telemetryService"),e.$_l=(0,v.$Fi)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var k;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(k||(e.TelemetryLevel=k={}));var C;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ce[64],Ie([1,0,26,15,63,218,113]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=void 0,e.$Bp=P,e.$Cp=y,e.$Dp=u,e.$Ep=E,e.$Fp=n,e.$Gp=o,e.$Hp=h,e.$Ip=t;class T{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$up=T;class p{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vp=p,e.$wp=new p;class a{async publicLog(l,g,m){}async publicLogError(l,g,m){}}e.$xp=a,e.$yp="telemetry",e.$zp="extensionTelemetryLog",e.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function P(c,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!c.enableTelemetry)}function y(c,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}function u(c){const l=c.getValue(A.$hm),g=c.getValue(A.$im);if(c.getValue(A.$jm)===!1||g===!1)return A.TelemetryLevel.NONE;switch(l??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function E(c){const l={},g={},m={};s(c,m);for(let $ in m){$=$.length>150?$.substr($.length-149):$;const S=m[$];typeof S=="number"?g[$]=S:typeof S=="boolean"?g[$]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${$} has been trimmed to 8192, the original length is ${S.length}`),l[$]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(l[$]=S)}return{properties:l,measurements:g}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(c){if(!c)return"none";const l=(0,C.$hn)(c);return d.has(l)?l:"other"}function s(c,l,g=0,m){if(c)for(const $ of Object.getOwnPropertyNames(c)){const S=c[$],D=m?m+$:$;Array.isArray(S)?l[D]=(0,v.$io)(S):S instanceof Date?l[D]=S.toISOString():(0,k.$hg)(S)?g<2?s(S,l,g+1,D+"."):l[D]=(0,v.$io)(S):l[D]=S}}function o(c,l){const g=c.msftInternalDomains||[],m=l.getValue("telemetry.internalTesting");return(0,O.$tp)(g)||m}function h(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}function i(c,l){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let g=c;const m=[];for(const b of l)for(;;){const I=b.exec(c);if(!I)break;m.push([I.index,b.lastIndex])}const $=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(g="";;){const b=S.exec(c);if(!b)break;const I=m.some(([R,f])=>b.index<f&&R<S.lastIndex);!$.test(b[0])&&!I&&(g+=c.substring(D,b.index)+"<REDACTED: user-file-path>",D=S.lastIndex)}return D<c.length&&(g+=c.substr(D)),g}function r(c){if(!c)return c;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of l)if(g.regex.test(c))return`<REDACTED: ${g.label}>`;return c}function t(c,l){return(0,v.$fo)(c,g=>{if(g instanceof T||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let m=g.replaceAll("%20"," ");m=i(m,l);for(const $ of l)m=m.replace($,"");return m=r(m),m}})}}),define(Ce[219],Ie([1,0,13,111,19,21,2,14,79,64]),function(oe,e,v,k,C,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Kp=void 0,e.$Jp=P,e.$Lp=d,e.$Mp=n,e.$Np=s,e.$Op=o,e.$Pp=h,e.$Qp=i,e.$Rp=r,e.$Tp=t,e.$Up=l;function P(g,m){return g.uuid&&m.uuid?g.uuid===m.uuid:g.id===m.id?!0:(0,v.$Bf)(g.id,m.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(m){const $=m.manifest?m.manifest.version:m.version,S=m.manifest?m.targetPlatform:m.properties.targetPlatform;return new u(m.identifier,$,S)}static parse(m){const $=y.exec(m);return $&&$[1]&&$[2]?new u({id:$[1]},$[2],$[4]||void 0):null}constructor(m,$,S=C.TargetPlatform.UNDEFINED){this.identifier=m,this.version=$,this.targetPlatform=S,this.id=m.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==C.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(m){return m instanceof u?P(this,m)&&this.version===m.version&&this.targetPlatform===m.targetPlatform:!1}}e.$Kp=u;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(g){const m=E.exec(g);return m&&m[1]?[s(m[1]),m[2]]:[s(g),void 0]}function n(g,m){return`${g}.${m}`}function s(g){return g.toLowerCase()}function o(g,m){return s(n(g??C.$mn,m))}function h(g,m){const $=[],S=D=>{for(const b of $)if(b.some(I=>P(m(I),m(D))))return b;return null};for(const D of g){const b=S(D);b?b.push(D):$.push([D])}return $}function i(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}function r(g){return{id:new a.$up(g.identifier.id),name:new a.$up(g.name),version:g.version,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),isSigned:g.isSigned,...g.telemetryData}}e.$Sp=new C.$qn("pprice.better-merge");function t(g,m){const $=[],S=m.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const D=S.shift();if(D&&$.every(b=>!P(b.identifier,{id:D}))){const b=g.filter(I=>P(I.identifier,{id:D}));b.length===1&&($.push(b[0]),S.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return $}async function c(g,m){if(!O.$k)return!1;let $;try{$=(await g.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await g.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){m.debug("Error while getting the os-release file.",(0,T.$_)(D))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(g,m){const $=await c(g,m),S=(0,k.$ep)($?"alpine":O.$u,p.$gc);return m.debug("ComputeTargetPlatform:",S),S}}),define(Ce[220],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=v,e.$Ds=k,e.$Es=C,e.$Fs=O,e.$Gs=A,e.$Hs=T;function v(p){return[...p.entries()]}function k(p){return p?[...p.entries()]:[]}function C(p){return new Map(p)}function O(p){return new Map(p??[])}function A(p){return Array.from(p.entries()).map(a=>[a[0],v(a[1].map),k(a[1].descriptionMap)])}function T(p){return new Map(p.map(a=>[a[0],{map:C(a[1]),descriptionMap:O(a[2])}]))}}),define(Ce[221],Ie([1,0,3,32,31]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.$os=e.$ns=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ms=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ls=void 0,e.$ls=new k.$Wj("terminalTabFocusMode",!1,!0);var O;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var A;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var T;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(T||(e.PosixShellType=T={}));var p;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(p||(e.WindowsShellType=p={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var P;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(P||(e.TerminalIpcChannels=P={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$ms=(0,v.$Fi)("ptyService");var u;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var E;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(E||(e.TerminalLocation=E={}));var d;(function(t){t.TerminalView="view",t.Editor="editor"})(d||(e.TerminalLocationString=d={}));var n;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(n||(e.LocalReconnectConstants=n={}));var s;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(s||(e.FlowControlConstants=s={}));var o;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(o||(e.ProfileSource=o={}));var h;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$ns={Backend:"workbench.contributions.terminal.processBackend"};class r{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(c){const l=this.b(c.remoteAuthority);if(this.a.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this.a.set(l,c)}getTerminalBackend(c){return this.a.get(this.b(c))}b(c){return c?.toLowerCase()??""}}C.$qo.add(e.$ns.Backend,new r),e.$os=(0,v.$Fi)("localPtyService"),e.$ps=(0,v.$Fi)("terminalLogService")}),define(Ce[222],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wxb=void 0;class v{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,O,A=5){const T=O(p=>{const a=typeof p=="string"?p:p.data;let P=this.a.get(C);if(P){P.data.push(a);return}const y=setTimeout(()=>this.flushBuffer(C),A);P={data:[a],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(C),T.dispose()}},this.a.set(C,P)});return T}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const O=this.a.get(C);O&&(this.a.delete(C),this.b(C,O.data.join("")))}}e.$wxb=v}),define(Ce[223],Ie([1,0,11,98,324,35,6,15,2,178,78,31]),function(oe,e,v,k,C,O,A,T,p,a,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ex=e.$Dx=e.$Cx=e.$Bx=e.$Ax=e.$zx=e.IconFontDefinition=e.IconContribution=e.$wx=void 0,e.$xx=s,e.$yx=o,y=qe(y),e.$wx={IconContribution:"base.contributions.icons"};var u;(function(t){function c(l,g){let m=l.defaults;for(;O.ThemeIcon.isThemeIcon(m);){const $=n.getIcon(m.id);if(!$)return;m=$.defaults}return m}t.getDefinition=c})(u||(e.IconContribution=u={}));var E;(function(t){function c(g){return{weight:g.weight,style:g.style,src:g.src.map(m=>({format:m.format,location:m.location.toString()}))}}t.toJSONObject=c;function l(g){const m=$=>(0,T.$fg)($)?$:void 0;if(g&&Array.isArray(g.src)&&g.src.every($=>(0,T.$fg)($.format)&&(0,T.$fg)($.location)))return{weight:m(g.weight),style:m(g.style),src:g.src.map($=>({format:$.format,location:p.URI.parse($.location)}))}}t.fromJSONObject=l})(E||(e.IconFontDefinition=E={}));class d{constructor(){this.a=new A.$me,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,a.localize)(0,null)},fontCharacter:{type:"string",description:(0,a.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(c,l,g,m){const $=this.b[c];if($){if(g&&!$.description){$.description=g,this.d.properties[c].markdownDescription=`${g} $(${c})`;const b=this.e.enum.indexOf(c);b!==-1&&(this.e.enumDescriptions[b]=g),this.a.fire()}return $}const S={id:c,description:g,defaults:l,deprecationMessage:m};this.b[c]=S;const D={$ref:"#/definitions/icons"};return m&&(D.deprecationMessage=m),g&&(D.markdownDescription=`${g}: $(${c})`),this.d.properties[c]=D,this.e.enum.push(c),this.e.enumDescriptions.push(g||""),this.a.fire(),{id:c}}deregisterIcon(c){delete this.b[c],delete this.d.properties[c];const l=this.e.enum.indexOf(c);l!==-1&&(this.e.enum.splice(l,1),this.e.enumDescriptions.splice(l,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(c=>this.b[c])}getIcon(c){return this.b[c]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(c,l){const g=this.f[c];return g||(this.f[c]=l,this.a.fire(),l)}deregisterIconFont(c){delete this.f[c]}getIconFont(c){return this.f[c]}toString(){const c=($,S)=>$.id.localeCompare(S.id),l=$=>{for(;O.ThemeIcon.isThemeIcon($.defaults);)$=this.b[$.defaults.id];return`codicon codicon-${$?$.id:""}`},g=[];g.push("| preview     | identifier                        | default codicon ID                | description"),g.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.b).map($=>this.b[$]);for(const $ of m.filter(S=>!!S.description).sort(c))g.push(`|<i class="${l($)}"></i>|${$.id}|${O.ThemeIcon.isThemeIcon($.defaults)?$.defaults.id:$.id}|${$.description||""}|`);g.push("| preview     | identifier                        "),g.push("| ----------- | --------------------------------- |");for(const $ of m.filter(S=>!O.ThemeIcon.isThemeIcon(S.defaults)).sort(c))g.push(`|<i class="${l($)}"></i>|${$.id}|`);return g.join(`
`)}}const n=new d;y.$qo.add(e.$wx.IconContribution,n);function s(t,c,l,g){return n.registerIcon(t,c,l,g)}function o(){return n}function h(){const t=(0,C.$1j)();for(const c in t){const l="\\"+t[c].toString(16);n.registerIcon(c,{fontCharacter:l})}}h(),e.$zx="vscode://schemas/icons";const i=y.$qo.as(P.$ro.JSONContribution);i.registerSchema(e.$zx,n.getIconSchema());const r=new v.$Rh(()=>i.notifySchemaChanged(e.$zx),200);n.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Ax=s("widget-close",k.$5j.close,(0,a.localize)(2,null)),e.$Bx=s("goto-previous-location",k.$5j.arrowUp,(0,a.localize)(3,null)),e.$Cx=s("goto-next-location",k.$5j.arrowDown,(0,a.localize)(4,null)),e.$Dx=O.ThemeIcon.modify(k.$5j.sync,"spin"),e.$Ex=O.ThemeIcon.modify(k.$5j.loading,"spin")}),define(Ce[224],Ie([1,0,6,4,21,2,43,3,12]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lw=e.$Kw=e.$Hw=e.$Fw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bw=e.$Aw=void 0,e.$Cw=y,e.$Dw=E,e.$Ew=d,e.$Gw=n,e.$Iw=s,e.$Jw=o,e.$Aw=(0,T.$Fi)("tunnelService"),e.$Bw=(0,T.$Fi)("sharedTunnelsService");var a;(function(r){r.Http="http",r.Https="https"})(a||(e.TunnelProtocol=a={}));var P;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(P||(e.TunnelPrivacyId=P={}));function y(r){return!!r.forwardPort}var u;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function E(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(t)return{address:t[1],port:+t[2]}}function d(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const t=r.query.split("&");for(const c of t){const l=c.split("=")[1];if(/^https?:/.exec(l)){const g=E(O.URI.parse(l));if(g)return g}}}e.$Fw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(r){return e.$Fw.indexOf(r)>=0}e.$Hw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function s(r){return e.$Hw.indexOf(r)>=0}function o(r,t,c,l){if(c===C.OperatingSystem.Windows)return!1;if(c===C.OperatingSystem.Macintosh&&s(t)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(g?.length===4&&parseInt(g[1])>=18)return!1}return r<1024}class h{constructor(t,c,l){this.remoteAddress=t,this.localAddress=c,this.b=l,this.a=new v.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Kw=h;let i=class extends k.$Wc{constructor(t,c){super(),this.r=t,this.s=c,this.a=new v.$me,this.onTunnelOpened=this.a.event,this.b=new v.$me,this.onTunnelClosed=this.b.event,this.c=new v.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],c=Array.from(this.f.values());for(const l of c){const g=Array.from(l.values());for(const m of g){const $=await m.value;$&&typeof $!="string"&&t.push($)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:c}of t.values())await c.then(l=>typeof l!="string"?l?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,c,l,g,m){this.z(t,c,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:c,localAddress:l,privacy:g,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,c){(s(t)||n(t))&&(t=e.$Fw[0]);const l=this.D(t,c);if(l)return++l.refcount,l.value}openTunnel(t,c,l,g,m,$=!1,S,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${l} on local port ${m}.`);const b=this.g??t;if(!b)return;if(c||(c="localhost"),g||(g=this.t),this.g&&this.n.has(l)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const I=this.F(b,c,l,g,m,$,S,D);return I?I.then(R=>{if(R){if(typeof R=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(c,l),R}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(c,l);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.w(R);return(R.tunnelRemoteHost!==c||R.tunnelRemotePort!==l)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),S&&R.privacy!==S&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),I)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const c=this.f.get(t.tunnelRemoteHost);if(c){const l=c.get(t.tunnelRemotePort);l&&(l.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,l))}}}}async y(t,c,l){if(l.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${c}.`);const g=l.value.then(async m=>{m&&typeof m!="string"&&(await m.dispose(!0),this.b.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(c),g}}async closeTunnel(t,c){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${c} `);const l=this.f.get(t);if(l&&l.has(c)){const g=l.get(c);g.refcount=0,await this.y(t,c,g)}}z(t,c,l){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(c,{refcount:1,value:l})}async C(t,c){const l=this.f.get(t);if(l){const g=l.get(c),m=g?await g.value:void 0;(!m||typeof m=="string")&&l.delete(c),l.size===0&&this.f.delete(t)}}D(t,c){const l=[t];n(t)?(l.push(...e.$Fw),l.push(...e.$Hw)):s(t)&&l.push(...e.$Hw);const g=l.map(m=>this.f.get(m));for(const m of g){const $=m?.get(c);if($)return $}}canTunnel(t){return!!E(t)}G(t,c,l,g,m,$,S){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${l} on local port ${g}.`);const D=l;this.n.add(D);const b=g===void 0?l:g,I={elevationRequired:m?this.isPortPrivileged(b):!1},R={remoteAddress:{host:c,port:l},localAddressPort:g,privacy:$,public:$?$!==P.Private:void 0,protocol:S},f=t.forwardPort(R,I);return f?(this.z(c,l,f),f.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),f}};e.$Lw=i,e.$Lw=i=Qe([Ve(0,p.$_j),Ve(1,A.$_i)],i)}),define(Ce[225],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,v.$Fi)("IUriIdentityService")}),define(Ce[226],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Mw=void 0,e.$Mw=(0,v.$Fi)("editSessionIdentityService");var k;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(k||(e.EditSessionIdentityMatch=k={}))}),define(Ce[227],Ie([1,0,16]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=k,e.$5M=C,e.$6M=O,e.$7M=A,e.$8M=T;function k(p){return p.scheme!==v.Schemas.file&&p.scheme!==v.Schemas.vscodeRemote}function C(p){if(p.folders.length)return p.folders.every(a=>k(a.uri))?p.folders[0].uri:void 0;if(p.configuration&&k(p.configuration))return p.configuration}function O(p){return C(p)?.scheme}function A(p){return C(p)?.authority}function T(p){return C(p)!==void 0}}),define(Ce[50],Ie([1,0,180,20,59,24,2,3,16]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=a,e.$Qi=P,e.$Ti=y,e.$Ui=u,e.$Vi=E,e.$Wi=n,e.$Xi=s,e.$1i=i,e.$6i=r,e.$7i=t,e.$9i=c,e.$0i=l,e.$$i=g,e.$Oi=(0,T.$Fi)("contextService");function a(m){const $=m;return typeof $?.id=="string"&&A.URI.isUri($.uri)}function P(m){return typeof m?.id=="string"&&!a(m)&&!u(m)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function y(m,$){if(typeof m=="string"||typeof m>"u")return typeof m=="string"?{id:(0,k.$pc)(m)}:$?e.$Ri:e.$Si;const S=m;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function u(m){const $=m;return typeof $?.id=="string"&&A.URI.isUri($.configPath)}function E(m){const $=m;if($?.uri)return{id:$.id,uri:A.URI.revive($.uri)};const S=m;if(S?.configPath)return{id:S.id,configPath:A.URI.revive(S.configPath)};if(m?.id)return{id:m.id}}var d;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function n(m){const $=m;return!!($&&typeof $=="object"&&typeof $.id=="string"&&Array.isArray($.folders))}function s(m){const $=m;return!!($&&typeof $=="object"&&A.URI.isUri($.uri)&&typeof $.name=="string"&&typeof $.toResource=="function")}class o{constructor($,S,D,b,I){this.h=$,this.j=D,this.k=b,this.l=I,this.c=C.$Li.forUris(this.l,()=>!0),this.folders=S}update($){this.h=$.id,this.k=$.configuration,this.j=$.transient,this.l=$.l,this.folders=$.folders}get folders(){return this.g}set folders($){this.g=$,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration($){this.k=$}getFolder($){return $&&this.c.findSubstr($)||null}n(){this.c=C.$Li.forUris(this.l,()=>!0);for(const $ of this.folders)this.c.set($.uri,$)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=o;class h{constructor($,S){this.raw=S,this.uri=$.uri,this.index=$.index,this.name=$.name}toResource($){return(0,O.$gh)(this.uri,$)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=h;function i(m){return new h({uri:m,index:0,name:(0,O.$ch)(m)},{uri:m.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,v.localize)(0,null),extensions:[e.$2i]}],e.$5i="workspace.json";function r(m,$){return O.$0g.isEqualOrParent(m,$.untitledWorkspacesHome)}function t(m){let $;return A.URI.isUri(m)?$=m:$=m.configuration,$?.scheme===p.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function c(m){return m.id===e.$8i}function l(m,$){return!r(m,$)&&!t(m)}function g(m){return(typeof m=="string"?(0,k.$qc)(m):(0,O.$eh)(m))===e.$3i}}),define(Ce[114],Ie([1,0,76,6,4,24,2,179,107,30,3,12,50,29,225,11,37,13,15]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=r,e.$Ml=t,e.$Nl=c;var i;(function(m){m.Settings="settings",m.Keybindings="keybindings",m.Snippets="snippets",m.Tasks="tasks",m.Extensions="extensions",m.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(m){const $=m;return!!($&&typeof $=="object"&&typeof $.id=="string"&&typeof $.isDefault=="boolean"&&typeof $.name=="string"&&A.URI.isUri($.location)&&A.URI.isUri($.globalStorageHome)&&A.URI.isUri($.settingsResource)&&A.URI.isUri($.keybindingsResource)&&A.URI.isUri($.tasksResource)&&A.URI.isUri($.snippetsHome)&&A.URI.isUri($.extensionsResource))}e.$Ll=(0,P.$Fi)("IUserDataProfilesService");function t(m,$){return{id:m.id,isDefault:m.isDefault,name:m.name,shortName:m.shortName,icon:m.icon,location:A.URI.revive(m.location).with({scheme:$}),globalStorageHome:A.URI.revive(m.globalStorageHome).with({scheme:$}),settingsResource:A.URI.revive(m.settingsResource).with({scheme:$}),keybindingsResource:A.URI.revive(m.keybindingsResource).with({scheme:$}),tasksResource:A.URI.revive(m.tasksResource).with({scheme:$}),snippetsHome:A.URI.revive(m.snippetsHome).with({scheme:$}),extensionsResource:A.URI.revive(m.extensionsResource).with({scheme:$}),cacheHome:A.URI.revive(m.cacheHome).with({scheme:$}),useDefaultFlags:m.useDefaultFlags,isTransient:m.isTransient}}function c(m,$,S,D,b,I){return{id:m,name:$,location:S,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:I&&b?.useDefaultFlags?.globalState?I.globalStorageHome:(0,O.$gh)(S,"globalStorage"),settingsResource:I&&b?.useDefaultFlags?.settings?I.settingsResource:(0,O.$gh)(S,"settings.json"),keybindingsResource:I&&b?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,O.$gh)(S,"keybindings.json"),tasksResource:I&&b?.useDefaultFlags?.tasks?I.tasksResource:(0,O.$gh)(S,"tasks.json"),snippetsHome:I&&b?.useDefaultFlags?.snippets?I.snippetsHome:(0,O.$gh)(S,"snippets"),extensionsResource:I&&b?.useDefaultFlags?.extensions?I.extensionsResource:(0,O.$gh)(S,"extensions.json"),cacheHome:(0,O.$gh)(D,m),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let l=class extends C.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor($,S,D,b){super(),this.t=$,this.u=S,this.w=D,this.y=b,this.f=!0,this.h=this.B(new k.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new k.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new k.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new k.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new E.$Cc,workspaces:new E.$Cc,emptyWindows:new Map},this.profilesHome=(0,O.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement($){this.f!==$&&(this.z=void 0,this.f=$)}isEnabled(){return this.f}get C(){if(!this.z){const $=this.D(),S=[$];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,h.$fg)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}S.push(c((0,O.$dh)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},$))}}catch(I){this.y.error(I)}const D=new E.$Cc,b=new Map;if(S.length)try{const I=this.Q();if(I.workspaces)for(const[R,f]of Object.entries(I.workspaces)){const w=A.URI.parse(R),M=S.find(N=>N.id===f);M&&D.set(w,M)}if(I.emptyWindows)for(const[R,f]of Object.entries(I.emptyWindows)){const w=S.find(M=>M.id===f);w&&b.set(R,w)}}catch(I){this.y.error(I)}this.z={profiles:S,workspaces:D,emptyWindows:b}}return this.z}D(){const $=c("__default__profile__",(0,T.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...$,extensionsResource:this.S()??$.extensionsResource,isDefault:!0}}async createTransientProfile($){const S="Temp",D=new RegExp(`${(0,o.$if)(S)}\\s(\\d+)`);let b=0;for(const R of this.profiles){const f=D.exec(R.name),w=f?parseInt(f[1]):0;b=w>b?w:b}const I=`${S} ${b+1}`;return this.createProfile((0,v.$tj)((0,s.$2g)()).toString(16),I,{transient:!0},$)}async createNamedProfile($,S,D){return this.createProfile((0,v.$tj)((0,s.$2g)()).toString(16),$,S,D)}async createProfile($,S,D,b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F($,S,D);return b&&await this.setProfileForWorkspace(b,I),I}async F($,S,D){if(!(0,h.$fg)(S)||!S)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.r.get(S);return b||(b=(async()=>{try{if(this.profiles.find(w=>w.name===S||w.id===$))throw new Error(`Profile with ${S} name already exists`);const R=c($,S,(0,O.$gh)(this.profilesHome,$),this.g,D,this.defaultProfile);await this.u.createFolder(R.location);const f=[];return this.j.fire({profile:R,join(w){f.push(w)}}),await n.Promises.settled(f),this.I([R],[],[]),R}finally{this.r.delete(S)}})(),this.r.set(S,b)),b}async updateProfile($,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(b=>b.id===$.id);if(!D)throw new Error(`Profile '${$.name}' does not exist`);return D=c(D.id,S.name??D.name,D.location,this.g,{shortName:S.shortName??D.shortName,icon:S.icon===null?void 0:S.icon??D.icon,transient:S.transient??D.isTransient,useDefaultFlags:S.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile($){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if($.isDefault)throw new Error("Cannot remove default profile");const S=this.profiles.find(b=>b.id===$.id);if(!S)throw new Error(`Profile '${$.name}' does not exist`);const D=[];this.m.fire({profile:S,join(b){D.push(b)}});try{await Promise.allSettled(D)}catch(b){this.y.error(b)}for(const b of[...this.C.emptyWindows.keys()])S.id===this.C.emptyWindows.get(b)?.id&&this.C.emptyWindows.delete(b);for(const b of[...this.C.workspaces.keys()])S.id===this.C.workspaces.get(b)?.id&&this.C.workspaces.delete(b);this.M(),this.I([],[S],[]);try{await this.u.del(S.cacheHome,{recursive:!0})}catch(b){(0,a.$ql)(b)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(b)}}async setProfileForWorkspace($,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(b=>b.id===S.id);if(!D)throw new Error(`Profile '${S.name}' does not exist`);this.L($,D)}unsetWorkspace($,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L($,void 0,S)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const $=await this.u.resolve(this.profilesHome);await Promise.all(($.children||[]).filter(S=>S.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,S.resource))).map(S=>this.u.del(S.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const $=this.s.profiles.filter(S=>!this.H(S));await Promise.allSettled($.map(S=>this.removeProfile(S)))}getProfileForWorkspace($){const S=this.G($),D=A.URI.isUri(S)?this.C.workspaces.get(S):this.C.emptyWindows.get(S);return D||((0,u.$Pi)($)?this.s.folders.get($.uri):(0,u.$Ui)($)?this.s.workspaces.get($.configPath):this.s.emptyWindows.get($.id))}G($){return(0,u.$Pi)($)?$.uri:(0,u.$Ui)($)?$.configPath:$.id}H($){return!!([...this.C.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,$.location))||[...this.C.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,$.location))||[...this.s.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,$.location))||[...this.s.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,$.location))||[...this.s.folders.values()].some(S=>this.w.extUri.isEqual(S.location,$.location)))}I($,S,D){const b=[...this.profiles,...$],I=[],R=this.s.profiles;this.s.profiles=[];for(let f of b){if(f.isDefault||S.some(M=>f.id===M.id))continue;f=D.find(M=>f.id===M.id)??f;const w=R.find(M=>f.id===M.id);if(f.isTransient)this.s.profiles.push(f);else{if(w){for(const[M,N]of this.s.emptyWindows.entries())if(f.id===N.id){this.L({id:M},f);break}for(const[M,N]of this.s.workspaces.entries())if(f.id===N.id){this.L({id:"",configPath:M},f);break}for(const[M,N]of this.s.folders.entries())if(f.id===N.id){this.L({id:"",uri:M},f);break}}I.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags})}}this.P(I),this.z=void 0,this.J($,S,D)}J($,S,D){this.h.fire({added:$,removed:S,updated:D,all:this.profiles})}L($,S,D){if(D=S?.isTransient?!0:D,D)(0,u.$Pi)($)?(this.s.folders.delete($.uri),S&&this.s.folders.set($.uri,S)):(0,u.$Ui)($)?(this.s.workspaces.delete($.configPath),S&&this.s.workspaces.set($.configPath,S)):(this.s.emptyWindows.delete($.id),S&&this.s.emptyWindows.set($.id,S));else{this.L($,void 0,!0);const b=this.G($);A.URI.isUri(b)?(this.C.workspaces.delete(b),S&&this.C.workspaces.set(b,S)):(this.C.emptyWindows.delete(b),S&&this.C.emptyWindows.set(b,S)),this.M()}}M(){const $={};for(const[D,b]of this.C.workspaces.entries())$[D.toString()]=b.id;const S={};for(const[D,b]of this.C.emptyWindows.entries())S[D.toString()]=b.id;this.R({workspaces:$,emptyWindows:S}),this.z=void 0}N($){const S={},D=this.D();if($.workspaces)for(const[I,R]of Object.entries($.workspaces)){const f=A.URI.parse(R);S[I]=this.w.extUri.isEqual(f,D.location)?D.id:this.w.extUri.basename(f)}const b={};if($.emptyWindows)for(const[I,R]of Object.entries($.emptyWindows)){const f=A.URI.parse(R);b[I]=this.w.extUri.isEqual(f,D.location)?D.id:this.w.extUri.basename(f)}return{workspaces:S,emptyWindows:b}}O(){return[]}P($){throw new Error("not implemented")}Q(){return{}}R($){throw new Error("not implemented")}S(){}};e.$Ol=l,e.$Ol=l=Qe([Ve(0,p.$Mi),Ve(1,a.$_k),Ve(2,d.$Jl),Ve(3,y.$_j)],l);class g extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P($){this.a=$}Q(){return this.X}R($){this.X=$}}e.$Pl=g}),define(Ce[228],Ie([1,0,11,6,4,65,15,162,3,114]),function(oe,e,v,k,C,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fq=e.$eq=e.$dq=void 0,e.$gq=E,e.$iq=n,e.$kq=o,e.$dq="__$__isNewStorageMarker",e.$eq="__$__targetStorageMarker",e.$fq=(0,p.$Fi)("storageService");var P;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var y;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var u;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function E(h){const i=h.get(e.$eq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class d extends C.$Wc{static{this.a=60*1e3}constructor(i={flushInterval:d.a}){super(),this.m=i,this.b=this.B(new k.$pe),this.c=this.B(new k.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new k.$me),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new C.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,t){return k.Event.filter(this.b.event,c=>c.scope===i&&(r===void 0||c.key===r),t)}n(){this.j.value=(0,v.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,C.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:t,external:c}=r;if(t===e.$eq){switch(i){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:c})}w(i){this.f.fire({reason:i})}get(i,r,t){return this.P(r)?.get(i,t)}getBoolean(i,r,t){return this.P(r)?.getBoolean(i,t)}getNumber(i,r,t){return this.P(r)?.getNumber(i,t)}getObject(i,r,t){return this.P(r)?.getObject(i,t)}storeAll(i,r){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,r)})}store(i,r,t,c,l=!1){if((0,A.$og)(r)){this.remove(i,t,l);return}this.y(()=>{this.z(i,t,c),this.P(t)?.set(i,r,l)})}remove(i,r,t=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const t=[],c=this.J(i);for(const l of Object.keys(c))c[l]===r&&t.push(l);return t}z(i,r,t,c=!1){const l=this.J(r);typeof t=="number"?l[i]!==t&&(l[i]=t,this.P(r)?.set(e.$eq,JSON.stringify(l),c)):typeof l[i]=="number"&&(delete l[i],this.P(r)?.set(e.$eq,JSON.stringify(l),c))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(i){switch(i){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?E(r):Object.create(null)}isNew(i){return this.getBoolean(e.$dq,i)===!0}async flush(i=P.NONE){this.f.fire({reason:i});const r=this.P(y.APPLICATION),t=this.P(y.PROFILE),c=this.P(y.WORKSPACE);switch(i){case P.NONE:await v.Promises.settled([r?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await v.Promises.settled([r?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(y.APPLICATION)?.items??new Map,r=this.P(y.PROFILE)?.items??new Map,t=this.P(y.WORKSPACE)?.items??new Map;return o(i,r,t,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(P.NONE),(0,a.$Kl)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||n(r)&&n(i))}N(i,r,t){this.y(()=>{const c=new Set;for(const[l,g]of i)c.add(l),r.get(l)!==g&&this.u(t,{key:l,external:!0});for(const[l]of r.items)c.has(l)||this.u(t,{key:l,external:!0})})}}e.$hq=d;function n(h){return h.isDefault||!!h.useDefaultFlags?.globalState}class s extends d{constructor(){super(),this.U=this.B(new T.$bq(new T.$cq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$bq(new T.$cq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$bq(new T.$cq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(y.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(y.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(y.APPLICATION,i)))}P(i){switch(i){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$jq=s;async function o(h,i,r,t,c,l){const g=w=>{try{return JSON.parse(w)}catch{return w}},m=new Map,$=new Map;h.forEach((w,M)=>{m.set(M,w),$.set(M,g(w))});const S=new Map,D=new Map;i.forEach((w,M)=>{S.set(M,w),D.set(M,g(w))});const b=new Map,I=new Map;r.forEach((w,M)=>{b.set(M,w),I.set(M,g(w))}),console.group(t!==c?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const R=[];if(m.forEach((w,M)=>{R.push({key:M,value:w})}),console.table(R),console.groupEnd(),console.log($),t!==c){console.group(`Storage: Profile (path: ${c}, profile specific)`);const w=[];S.forEach((M,N)=>{w.push({key:N,value:M})}),console.table(w),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${l})`);const f=[];b.forEach((w,M)=>{f.push({key:M,value:w})}),console.table(f),console.groupEnd(),console.log(I)}}),define(Ce[80],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=void 0;class v{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const O=this.c++;return this.b.set(O,C),this.e(),O}get(C,O){return this.b.has(C)?this.b.get(C)[O]:void 0}delete(C){this.b.delete(C),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$hoc=v}),define(Ce[51],Ie([1,0,16,24,30,3]),function(oe,e,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$noc=e.$moc=void 0;class A{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new k.$8g(p=>{const a=this.b.get(p.scheme);return!(a===void 0||a&C.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,a){a===null?this.b.delete(p.scheme):this.b.set(p.scheme,a)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$moc=A,e.$noc=(0,O.$Fi)("IExtHostFileSystemInfo")}),define(Ce[27],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0,e.$eQ=(0,v.$Fi)("IExtHostInitDataService")}),define(Ce[229],Ie([1,0,185,12,213,27]),function(oe,e,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vqc=void 0;let A=class extends C.$oR{constructor(p,a,P){const y=P.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",u=P.remote.isRemote?(0,v.localize)(0,null):p?(0,v.localize)(1,null):(0,v.localize)(2,null);super(a.createLogger(y,{name:u}))}};e.$vqc=A,e.$vqc=A=Qe([Ve(1,k.$ak),Ve(2,O.$eQ)],A)}),define(Ce[230],Ie([1,0,11]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=e.$5oc=void 0;class k{constructor(A,T,p){this.h=new Map,this.a=A,this.b=T,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(a=>(this.f=a,this)),this.g=this.c.onDidChangeStorage(a=>{a.shared===this.b&&a.key===this.a&&(this.f=a.value)}),this.i=new v.$Rh(()=>{const a=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of a.values())P.complete()}catch(P){for(const y of a.values())y.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,T){let p=this.f[A];return typeof p>"u"&&(p=T),p}update(A,T){this.f[A]=T;const p=this.h.get(A);if(p!==void 0)return p.p;const a=new v.$3h;return this.h.set(A,a),this.i.isScheduled()||this.i.schedule(),a.p}dispose(){this.g.dispose()}}e.$5oc=k;class C extends k{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,T){super(A.identifier.value,!0,T),this.j=A}}e.$6oc=C}),define(Ce[231],Ie([1,0,6,2]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=void 0;class C{constructor(A){this.c=A,this.a=new v.$me,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$me,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,T,p,a){const y=this.c.getNotebookDocument(k.URI.revive(A)).acceptModelChanged(T.value,p,a);this.b.fire(y)}$acceptDirtyStateChanged(A,T){this.c.getNotebookDocument(k.URI.revive(A)).acceptDirty(T)}$acceptModelSaved(A){const T=this.c.getNotebookDocument(k.URI.revive(A));this.a.fire(T.apiNotebook)}}e.$Ypc=C}),define(Ce[17],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0,e.$1P=(0,v.$Fi)("IExtHostRpcService");class k{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$2P=k}),define(Ce[232],Ie([1,0,19,6]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=void 0;class C{#e;constructor(A,T){this.a=v.$qn.toKey(A.identifier),this.#e=T,this.onDidChange=k.Event.map(k.Event.filter(this.#e.onDidChangePassword,p=>p.extensionId===this.a),p=>({key:p.key}))}get(A){return this.#e.get(this.a,A)}store(A,T){return this.#e.store(this.a,A,T)}delete(A){return this.#e.delete(this.a,A)}}e.$cpc=C}),define(Ce[66],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=e.$Coc=void 0,e.$Coc=(0,v.$Fi)("IURITransformerService");class k{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Doc=k});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[115],Ie([1,0,194,15,2,4,3,31,30,16,41,156,36]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$eG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$7F=e.EditorInputCapabilities=e.$6F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0,e.$WF=n,e.$XF=s,e.$YF=o,e.$ZF=h,e.$1F=i,e.$2F=r,e.$3F=t,e.$4F=c,e.$5F=l,e.$8F=b,e.$9F=R,e.$0F=f,e.$$F=w,e.$_F=M,e.$aG=N,e.$bG=L,e.$cG=G,e.$dG=_,e.$fG=ce,e.$gG=re,e.$hG=Pe,e.$iG=Me,u=ti(u),e.$RF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$SF={id:"default",displayName:(0,v.localize)(0,null),providerDisplayName:(0,v.localize)(1,null)},e.$TF="workbench.editor.sidebysideEditor",e.$UF="workbench.editors.textDiffEditor",e.$VF="workbench.editors.binaryResourceDiffEditor";var E;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var d;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function n(Y){const q=Y;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}function s(Y){const q=Y;return!!q&&typeof q.getScrollPosition=="function"&&typeof q.setScrollPosition=="function"&&!!q.onDidChangeScroll}function o(Y,q,ee){for(const ve of ee.visibleEditorPanes)if(ve.group.id===q&&Y.matches(ve.input))return ve.getViewState()}function h(Y){if(b(Y))return!1;const q=Y;return C.URI.isUri(q?.resource)}function i(Y){if(b(Y))return!1;const q=Y;return q?.original!==void 0&&q.modified!==void 0}function r(Y){if(b(Y))return!1;const q=Y;return!q||q.resources&&!Array.isArray(q.resources)?!1:!!q.resources||!!q.multiDiffSource}function t(Y){if(b(Y)||i(Y))return!1;const q=Y;return q?.primary!==void 0&&q.secondary!==void 0}function c(Y){if(b(Y))return!1;const q=Y;return q?q.resource===void 0||q.resource.scheme===a.Schemas.untitled||q.forceUntitled===!0:!1}function l(Y){if(b(Y))return!1;const q=Y;return C.URI.isUri(q?.base?.resource)&&C.URI.isUri(q?.input1?.resource)&&C.URI.isUri(q?.input2?.resource)&&C.URI.isUri(q?.result?.resource)}var g;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(g||(e.Verbosity=g={}));var m;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m||(e.SaveReason=m={}));class ${constructor(){this.a=new Map}registerSource(q,ee){let ve=this.a.get(q);return ve||(ve={source:q,label:ee},this.a.set(q,ve)),ve.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$6F=new $;var S;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class D extends O.$Wc{}e.$7F=D;function b(Y){return Y instanceof D}function I(Y){const q=Y;return C.URI.isUri(q?.preferredResource)}function R(Y){const q=Y;return b(q?.primary)&&b(q?.secondary)}function f(Y){const q=Y;return b(q?.modified)&&b(q?.original)}function w(Y,q,ee,ve,ue){return Me(ve,[(0,y.$pj)({id:"workbench.action.openLargeFile",label:(0,v.localize)(2,null),run:()=>{const be={...ee,limits:{size:Number.MAX_VALUE}};Y.openEditor(q,be)}}),(0,y.$pj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(3,null),run:()=>ue.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function M(Y){return b(Y?.editor)}function N(Y){const q=Y;return M(Y)&&q?.group!==void 0}function L(Y){const q=Y;return typeof q?.groupId=="number"&&b(q.editor)}function G(Y){return typeof Y?.groupId=="number"}var W;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var F;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LABEL=2]="GROUP_LABEL",Y[Y.GROUP_LOCKED=3]="GROUP_LOCKED",Y[Y.EDITORS_SELECTION=4]="EDITORS_SELECTION",Y[Y.EDITOR_OPEN=5]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=6]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=7]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=9]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=11]="EDITOR_PIN",Y[Y.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Y[Y.EDITOR_STICKY=13]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=14]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var V;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(V||(e.SideBySideEditor=V={}));class ae{getOriginalUri(q,ee){if(!q)return;if(l(q))return e.$eG.getOriginalUri(q.result,ee);if(ee?.supportSideBySide){const{primary:ue,secondary:be}=this.a(q);if(ue&&be){if(ee?.supportSideBySide===V.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:ee.filterByScheme}),secondary:this.getOriginalUri(be,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===V.ANY)return this.getOriginalUri(ue,{filterByScheme:ee.filterByScheme})??this.getOriginalUri(be,{filterByScheme:ee.filterByScheme});q=ee.supportSideBySide===V.PRIMARY?ue:be}}if(i(q)||r(q)||t(q)||l(q))return;const ve=I(q)?q.preferredResource:q.resource;return!ve||!ee||!ee.filterByScheme?ve:this.b(ve,ee.filterByScheme)}a(q){return R(q)||t(q)?{primary:q.primary,secondary:q.secondary}:f(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,ee){if(!q)return;if(l(q))return e.$eG.getCanonicalUri(q.result,ee);if(ee?.supportSideBySide){const{primary:ue,secondary:be}=this.a(q);if(ue&&be){if(ee?.supportSideBySide===V.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:ee.filterByScheme}),secondary:this.getCanonicalUri(be,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===V.ANY)return this.getCanonicalUri(ue,{filterByScheme:ee.filterByScheme})??this.getCanonicalUri(be,{filterByScheme:ee.filterByScheme});q=ee.supportSideBySide===V.PRIMARY?ue:be}}if(i(q)||r(q)||t(q)||l(q))return;const ve=q.resource;return!ve||!ee||!ee.filterByScheme?ve:this.b(ve,ee.filterByScheme)}b(q,ee){if(Array.isArray(ee)){if(ee.some(ve=>q.scheme===ve))return q}else if(ee===q.scheme)return q}}var $e;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.KEYBOARD=1]="KEYBOARD",Y[Y.MOUSE=2]="MOUSE"})($e||(e.EditorCloseMethod=$e={}));function _(Y,q,ee,ve){if(!Y.isSticky(q))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return ee===$e.MOUSE||ee===$e.KEYBOARD;case"mouse":return ee===$e.MOUSE;case"keyboard":return ee===$e.KEYBOARD}return!1}e.$eG=new ae;var ge;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(ge||(e.CloseDirection=ge={}));class se{constructor(){this.c=new Map,this.d=new Map}start(q){const ee=this.a=q.get(A.$Ei);for(const[ve,ue]of this.c)this.e(ve,ue,ee);this.c.clear()}e(q,ee,ve){const ue=ve.createInstance(ee);this.d.set(q,ue)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,k.$qg)(this.b)}registerEditorSerializer(q,ee){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,ee,this.a):this.c.set(q,ee),(0,O.$Uc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}T.$qo.add(e.$RF.EditorFactory,new se);async function ce(Y,q,ee){return!Y||!Y.length?[]:await Promise.all(Y.map(async ve=>{const ue=C.URI.revive(ve.fileUri);if(!ue){ee.info("Cannot resolve the path because it is not valid.",ve);return}if(!await q.canHandleResource(ue)){ee.info("Cannot resolve the path because it cannot be handled",ve);return}let de=ve.exists,X=ve.type;if(typeof de!="boolean"||typeof X!="number")try{X=(await q.stat(ue)).isDirectory?p.FileType.Directory:p.FileType.Unknown,de=!0}catch(me){ee.error(me),de=!1}if(!de&&ve.openOnlyIfExists){ee.info("Cannot resolve the path because it does not exist",ve);return}if(X===p.FileType.Directory){ee.info("Cannot resolve the path because it is a directory",ve);return}const Z={...ve.options,pinned:!0};return de?{resource:ue,options:Z}:{resource:ue,options:Z,forceUntitled:!0}}))}var we;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})(we||(e.EditorsOrder=we={}));function re(Y){const q=Y;if(!q)return!1;const ee=q;if(ee.modified)return re(ee.modified);const ve=q;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function Pe(Y){return(0,P.$rj)(Y)}function Me(Y,q,ee){const ve=(0,P.$sj)(Y,q);return ve.forceMessage=ee?.forceMessage,ve.forceSeverity=ee?.forceSeverity,ve.allowDialog=ee?.allowDialog,ve}}),define(Ce[233],Ie([1,0,6,195,3,4,29,31,26,98,223]),function(oe,e,v,k,C,O,A,T,p,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qG=e.$pG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$oG=e.ViewContentGroups=e.$mG=e.ViewContainerLocation=e.Extensions=e.$lG=e.$kG=e.$jG=void 0,e.$nG=E,e.$jG="views",e.$kG=(0,k.localize)(0,null),e.$lG=(0,P.$xx)("default-view-icon",a.$5j.window,(0,k.localize)(1,null));var y;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var u;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel",c[c.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$mG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function E(c){switch(c){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class d extends O.$Wc{constructor(){super(...arguments),this.c=this.B(new v.$me),this.onDidRegister=this.c.event,this.f=this.B(new v.$me),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(l,g,m){const $=this.get(l.id);if($)return $;const S=l;return S.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,A.$zc)(this.g,g,[]).push(S),m?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:g}),S}deregisterViewContainer(l){for(const g of this.g.keys()){const m=this.g.get(g),$=m?.indexOf(l);if($!==-1){m?.splice($,1),m.length===0&&this.g.delete(g),this.f.fire({viewContainer:l,viewContainerLocation:g});return}}}get(l){return this.all.filter(g=>g.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(g=>this.getViewContainers(g).filter(m=>m?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(g=>this.getViewContainerLocation(g)===l)}}T.$qo.add(y.ViewContainersRegistry,new d);var n;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(n||(e.ViewContentGroups=n={}));function s(c,l){const g=c.group??n.More,m=l.group??n.More;return g!==m?g.localeCompare(m):(c.order??5)-(l.order??5)}class o extends O.$Wc{constructor(){super(...arguments),this.c=this.B(new v.$me),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$me),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$me),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$me),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Jc}registerViews(l,g){this.registerViews2([{views:l,viewContainer:g}])}registerViews2(l){l.forEach(({views:g,viewContainer:m})=>this.r(g,m)),this.c.fire(l)}deregisterViews(l,g){const m=this.s(l,g);m.length&&this.f.fire({views:m,viewContainer:g})}moveViews(l,g){for(const m of this.m.keys())if(m!==g){const $=this.s(l,m);$.length&&(this.r($,g),this.g.fire({views:$,from:m,to:g}))}}getViews(l){return this.m.get(l)||[]}getView(l){for(const g of this.j){const m=(this.m.get(g)||[]).filter($=>$.id===l)[0];if(m)return m}return null}getViewContainer(l){for(const g of this.j)if((this.m.get(g)||[]).filter($=>$.id===l)[0])return g;return null}registerViewWelcomeContent(l,g){return this.n.add(l,g),this.h.fire(l),(0,O.$Uc)(()=>{this.n.delete(l,g),this.h.fire(l)})}registerViewWelcomeContent2(l,g){const m=new Map;for(const[$,S]of g)this.n.add(l,S),m.set($,(0,O.$Uc)(()=>{this.n.delete(l,S),this.h.fire(l)}));return this.h.fire(l),m}getViewWelcomeContent(l){const g=[];return this.n.forEach(l,m=>g.push(m)),g.sort(s)}r(l,g){let m=this.m.get(g);m||(m=[],this.m.set(g,m),this.j.push(g));for(const $ of l){if(this.getView($.id)!==null)throw new Error((0,k.localize)(2,null,$.id));m.push($)}}s(l,g){const m=this.m.get(g);if(!m)return[];const $=[],S=[];for(const D of m)l.includes(D)?$.push(D):S.push(D);return $.length&&(S.length?this.m.set(g,S):(this.m.delete(g),this.j.splice(this.j.indexOf(g),1))),$}}T.$qo.add(y.ViewsRegistry,new o),e.$oG=(0,C.$Fi)("viewDescriptorService");var h;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(h||(e.ViewVisibilityState=h={}));var i;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class r{constructor(l,g){this.c=!1,this.d=!1,(0,p.$go)(this,l),this.d=!!g,this.resolve=async m=>{if(g&&!this.c){const $=await g(m);$&&(this.tooltip=this.tooltip??$.tooltip,this.command=this.command??$.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$pG=r;class t extends Error{constructor(l){super((0,k.localize)(3,null,l)),this.name="NoTreeViewError"}static is(l){return l.name==="NoTreeViewError"}}e.$qG=t}),define(Ce[234],Ie([1,0,196,32]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=void 0,e.$uG=new k.$Wj("chatSessionResponseVote","",{type:"string",description:(0,v.localize)(0,null)}),e.$vG=new k.$Wj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,v.localize)(1,null)}),e.$wG=new k.$Wj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,v.localize)(2,null)}),e.$xG=new k.$Wj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,v.localize)(3,null)}),e.$yG=new k.$Wj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,v.localize)(4,null)}),e.$zG=new k.$Wj("chatResponse",!1,{type:"boolean",description:(0,v.localize)(5,null)}),e.$AG=new k.$Wj("chatRequest",!1,{type:"boolean",description:(0,v.localize)(6,null)}),e.$BG=new k.$Wj("chatEditApplied",!1,{type:"boolean",description:(0,v.localize)(7,null)}),e.$CG=new k.$Wj("chatInputHasText",!1,{type:"boolean",description:(0,v.localize)(8,null)}),e.$DG=new k.$Wj("chatInputHasFocus",!1,{type:"boolean",description:(0,v.localize)(9,null)}),e.$EG=new k.$Wj("inChatInput",!1,{type:"boolean",description:(0,v.localize)(10,null)}),e.$FG=new k.$Wj("inChat",!1,{type:"boolean",description:(0,v.localize)(11,null)}),e.$GG=new k.$Wj("chatIsEnabled",!1,{type:"boolean",description:(0,v.localize)(12,null)}),e.$HG=new k.$Wj("chatCursorAtTop",!1),e.$IG=new k.$Wj("chatInputHasAgent",!1),e.$JG=new k.$Wj("chatLocation",void 0),e.$KG=new k.$Wj("quickChatHasFocus",!1,{type:"boolean",description:(0,v.localize)(13,null)})}),define(Ce[235],Ie([1,0,325,11,22,6,40,4,49,142,13,32,19,3,12,109,217,228,234]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.ChatAgentLocation=void 0,e.$OH=g,e.$PH=m;var r;(function($){$.Panel="panel",$.Terminal="terminal",$.Notebook="notebook",$.Editor="editor"})(r||(e.ChatAgentLocation=r={})),function($){function S(D){switch(D){case"panel":return $.Panel;case"terminal":return $.Terminal;case"notebook":return $.Notebook;case"editor":return $.Editor}return $.Panel}$.fromRaw=S}(r||(e.ChatAgentLocation=r={})),e.$JH=(0,E.$Fi)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(S){this.f=S,this.b=new Map,this.d=new O.$me,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=h.$GG.bindTo(this.f)}registerAgent(S,D){if(this.getAgent(S))throw new Error(`Agent already registered: ${JSON.stringify(S)}`);const I=this,R=D.slashCommands;D={...D,get slashCommands(){return R.filter(w=>!w.when||I.f.contextMatchesRules(y.$Dj.deserialize(w.when)))}};const f={data:D};return this.b.set(S,f),(0,T.$Uc)(()=>{this.b.delete(S),this.d.fire(void 0)})}registerAgentImplementation(S,D){const b=this.b.get(S);if(!b)throw new Error(`Unknown agent: ${JSON.stringify(S)}`);if(b.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(S)}`);return b.data.isDefault&&this.e.set(!0),b.impl=D,this.d.fire(new c(b.data,D)),(0,T.$Uc)(()=>{b.impl=void 0,this.d.fire(void 0),b.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(S,D){S.isDynamic=!0;const b={data:S,impl:D};return this.b.set(S.id,b),this.d.fire(new c(S,D)),(0,T.$Uc)(()=>{this.b.delete(S.id),this.d.fire(void 0)})}registerAgentCompletionProvider(S,D){return this.g.set(S,D),{dispose:()=>{this.g.delete(S)}}}async getAgentCompletionItems(S,D,b){return await this.g.get(S)?.(D,b)??[]}updateAgent(S,D){const b=this.b.get(S);if(!b?.impl)throw new Error(`No activated agent with id ${JSON.stringify(S)} registered`);b.data.metadata={...b.data.metadata,...D},this.d.fire(new c(b.data,b.impl))}getDefaultAgent(S){return(0,v.$hb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(S))}getContributedDefaultAgent(S){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(S))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),S=>!!S.data.metadata.isSecondary)?.data}getAgent(S){if(this.h(S))return this.b.get(S)?.data}h(S){const D=this.b.get(S);return!D?.data.when||this.f.contextMatchesRules(y.$Dj.deserialize(D.data.when))}getAgentByFullyQualifiedId(S){const D=A.Iterable.find(this.b.values(),b=>g(b.data)===S)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(S=>S.data).filter(S=>this.h(S.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(S=>!!S.impl).filter(S=>this.h(S.data.id)).map(S=>new c(S.data,S.impl))}getAgentsByName(S){return this.getAgents().filter(D=>D.name===S)}agentHasDupeName(S){const D=this.getAgent(S);return D?this.getAgentsByName(D.name).filter(b=>b.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(S,D,b,I,R){const f=this.b.get(S);if(!f?.impl)throw new Error(`No activated agent with id "${S}"`);return await f.impl.invoke(D,b,I,R)}async getFollowups(S,D,b,I,R){const f=this.b.get(S);if(!f?.impl)throw new Error(`No activated agent with id "${S}"`);return f.impl?.provideFollowups?f.impl.provideFollowups(D,b,I,R):[]}};e.$KH=t,e.$KH=t=Qe([Ve(0,y.$Xj)],t);class c{constructor(S,D){this.b=S,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(S,D,b,I){return this.d.invoke(S,D,b,I)}async provideFollowups(S,D,b,I){return this.d.provideFollowups?this.d.provideFollowups(S,D,b,I):[]}provideWelcomeMessage(S,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(S,D)}provideSampleQuestions(S,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(S,D)}}e.$LH=c,e.$MH=(0,E.$Fi)("chatAgentNameService");let l=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(S,D,b,I){if(this.g=D,this.h=b,this.i=I,this.e=(0,a.$7d)(this,Object.create(null)),this.f=!1,!S.chatParticipantRegistry)return;this.d=S.chatParticipantRegistry;const R=I.get(i.b,o.StorageScope.APPLICATION);try{this.e.set(JSON.parse(R??"{}"),void 0)}catch{I.remove(i.b,o.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(S=>this.h.warn("Failed to fetch chat participant registry",S)).then(()=>(0,k.$Gh)(5*60*1e3)).then(()=>this.j())}async k(){const S=await this.g.request({type:"GET",url:this.d},C.CancellationToken.None);if(S.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,s.$$p)(S);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const b=D.restrictedChatParticipants;this.e.set(b,void 0),this.i.store(i.b,JSON.stringify(b),o.StorageScope.APPLICATION,o.StorageTarget.MACHINE)}getAgentNameRestriction(S){const D=this.l(S.name,S).get(),b=!S.fullName||this.l(S.fullName.replace(/\s/g,""),S).get();return D&&b}l(S,D){return this.e.map(I=>I[S.toLowerCase()]).map(I=>I?I.some(R=>(0,P.$Gf)(R,R.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$NH=l,e.$NH=l=i=Qe([Ve(0,n.$sk),Ve(1,s.$5p),Ve(2,d.$_j),Ve(3,o.$fq)],l);function g($){return`${$.extensionId.value}.${$.id}`}function m($){const S="name"in $?$:{...$,name:$.id};return"extensionPublisherId"in S||(S.extensionPublisherId=S.extensionPublisher??""),"extensionDisplayName"in S||(S.extensionDisplayName=""),"extensionId"in S||(S.extensionId=new u.$qn("")),(0,p.$ci)(S)}}),define(Ce[236],Ie([1,0,2,33,3]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iH=e.$hH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$fH=O,e.$gH=A;function O(a){return!!a&&typeof a=="object"&&"uri"in a&&a.uri instanceof v.URI&&"version"in a&&typeof a.version=="number"&&"ranges"in a&&Array.isArray(a.ranges)&&a.ranges.every(k.$Lt.isIRange)}function A(a){return!!a&&typeof a=="object"&&"documents"in a&&Array.isArray(a.documents)&&a.documents.every(O)}var T;(function(a){a[a.Down=0]="Down",a[a.Up=1]="Up"})(T||(e.ChatAgentVoteDirection=T={}));var p;(function(a){a[a.Action=1]="Action",a[a.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$hH=(0,C.$Fi)("IChatService"),e.$iH="accessibility.voice.keywordActivation"}),define(Ce[237],Ie([1,0,6,11,198]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Itb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new v.$me,this.o=new v.$me,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,p,a,P){const y={command:T};if(p&&Object.keys(p).length>0&&(y.arguments=p),this.u("request",y),typeof P=="number"){const u=setTimeout(()=>{clearTimeout(u);const E=this.f.get(y.seq);if(E){this.f.delete(y.seq);const d={type:"response",seq:0,request_seq:y.seq,success:!1,command:T,message:(0,C.localize)(0,null,P,T)};E(d)}},P)}return a&&this.f.set(y.seq,a),y.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,p){return T.type!=="event"||p.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,k.$Gh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const p=T,a=this.f.get(p.request_seq);a&&(this.f.delete(p.request_seq),a(p));break}}}}u(T,p){p.type=T,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((p,a)=>T.set(a,p)),await(0,k.$Gh)(500),T.forEach((p,a)=>{p({type:"response",seq:0,request_seq:a,success:!1,command:"canceled",message:"canceled"}),this.f.delete(a)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Itb=O}),define(Ce[81],Ie([1,0,2,199,32,3]),function(oe,e,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$CK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$AK=e.MemoryRangeType=e.State=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=void 0,e.$zK=p,e.$BK=P,k=qe(k),e.$nJ="workbench.view.debug",e.$oJ="workbench.debug.variablesView",e.$pJ="workbench.debug.watchExpressionsView",e.$qJ="workbench.debug.callStackView",e.$rJ="workbench.debug.loadedScriptsView",e.$sJ="workbench.debug.breakPointsView",e.$tJ="workbench.debug.disassemblyView",e.$uJ="workbench.panel.repl",e.$vJ="workbench.panel.repl.view",e.$wJ=new C.$Wj("debugType",void 0,{type:"string",description:k.localize(0,null)}),e.$xJ=new C.$Wj("debugConfigurationType",void 0,{type:"string",description:k.localize(1,null)}),e.$yJ=new C.$Wj("debugState","inactive",{type:"string",description:k.localize(2,null)}),e.$zJ="debugUx",e.$AJ=new C.$Wj(e.$zJ,"default",{type:"string",description:k.localize(3,null)}),e.$BJ=new C.$Wj("hasDebugged",!1,{type:"boolean",description:k.localize(4,null)}),e.$CJ=new C.$Wj("inDebugMode",!1,{type:"boolean",description:k.localize(5,null)}),e.$DJ=new C.$Wj("inDebugRepl",!1,{type:"boolean",description:k.localize(6,null)}),e.$EJ=new C.$Wj("breakpointWidgetVisible",!1,{type:"boolean",description:k.localize(7,null)}),e.$FJ=new C.$Wj("inBreakpointWidget",!1,{type:"boolean",description:k.localize(8,null)}),e.$GJ=new C.$Wj("breakpointsFocused",!0,{type:"boolean",description:k.localize(9,null)}),e.$HJ=new C.$Wj("watchExpressionsFocused",!0,{type:"boolean",description:k.localize(10,null)}),e.$IJ=new C.$Wj("watchExpressionsExist",!1,{type:"boolean",description:k.localize(11,null)}),e.$JJ=new C.$Wj("variablesFocused",!0,{type:"boolean",description:k.localize(12,null)}),e.$KJ=new C.$Wj("expressionSelected",!1,{type:"boolean",description:k.localize(13,null)}),e.$LJ=new C.$Wj("breakpointInputFocused",!1,{type:"boolean",description:k.localize(14,null)}),e.$MJ=new C.$Wj("callStackItemType",void 0,{type:"string",description:k.localize(15,null)}),e.$NJ=new C.$Wj("callStackSessionIsAttach",!1,{type:"boolean",description:k.localize(16,null)}),e.$OJ=new C.$Wj("callStackItemStopped",!1,{type:"boolean",description:k.localize(17,null)}),e.$PJ=new C.$Wj("callStackSessionHasOneThread",!1,{type:"boolean",description:k.localize(18,null)}),e.$QJ=new C.$Wj("watchItemType",void 0,{type:"string",description:k.localize(19,null)}),e.$RJ=new C.$Wj("canViewMemory",void 0,{type:"boolean",description:k.localize(20,null)}),e.$SJ=new C.$Wj("breakpointItemType",void 0,{type:"string",description:k.localize(21,null)}),e.$TJ=new C.$Wj("breakpointItemBytes",void 0,{type:"boolean",description:k.localize(22,null)}),e.$UJ=new C.$Wj("breakpointHasModes",!1,{type:"boolean",description:k.localize(23,null)}),e.$VJ=new C.$Wj("breakpointSupportsCondition",!1,{type:"boolean",description:k.localize(24,null)}),e.$WJ=new C.$Wj("loadedScriptsSupported",!1,{type:"boolean",description:k.localize(25,null)}),e.$XJ=new C.$Wj("loadedScriptsItemType",void 0,{type:"string",description:k.localize(26,null)}),e.$YJ=new C.$Wj("focusedSessionIsAttach",!1,{type:"boolean",description:k.localize(27,null)}),e.$ZJ=new C.$Wj("focusedSessionIsNoDebug",!1,{type:"boolean",description:k.localize(28,null)}),e.$1J=new C.$Wj("stepBackSupported",!1,{type:"boolean",description:k.localize(29,null)}),e.$2J=new C.$Wj("restartFrameSupported",!1,{type:"boolean",description:k.localize(30,null)}),e.$3J=new C.$Wj("stackFrameSupportsRestart",!1,{type:"boolean",description:k.localize(31,null)}),e.$4J=new C.$Wj("jumpToCursorSupported",!1,{type:"boolean",description:k.localize(32,null)}),e.$5J=new C.$Wj("stepIntoTargetsSupported",!1,{type:"boolean",description:k.localize(33,null)}),e.$6J=new C.$Wj("breakpointsExist",!1,{type:"boolean",description:k.localize(34,null)}),e.$7J=new C.$Wj("debuggersAvailable",!1,{type:"boolean",description:k.localize(35,null)}),e.$8J=new C.$Wj("debugExtensionAvailable",!0,{type:"boolean",description:k.localize(36,null)}),e.$9J=new C.$Wj("debugProtocolVariableMenuContext",void 0,{type:"string",description:k.localize(37,null)}),e.$0J=new C.$Wj("debugSetVariableSupported",!1,{type:"boolean",description:k.localize(38,null)}),e.$$J=new C.$Wj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:k.localize(39,null)}),e.$_J=new C.$Wj("debugSetExpressionSupported",!1,{type:"boolean",description:k.localize(40,null)}),e.$aK=new C.$Wj("breakWhenValueChangesSupported",!1,{type:"boolean",description:k.localize(41,null)}),e.$bK=new C.$Wj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:k.localize(42,null)}),e.$cK=new C.$Wj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:k.localize(43,null)}),e.$dK=new C.$Wj("terminateDebuggeeSupported",!1,{type:"boolean",description:k.localize(44,null)}),e.$eK=new C.$Wj("suspendDebuggeeSupported",!1,{type:"boolean",description:k.localize(45,null)}),e.$fK=new C.$Wj("variableEvaluateNamePresent",!1,{type:"boolean",description:k.localize(46,null)}),e.$gK=new C.$Wj("variableIsReadonly",!1,{type:"boolean",description:k.localize(47,null)}),e.$hK=new C.$Wj("variableValue",!1,{type:"string",description:k.localize(48,null)}),e.$iK=new C.$Wj("variableType",!1,{type:"string",description:k.localize(49,null)}),e.$jK=new C.$Wj("variableInterfaces",!1,{type:"array",description:k.localize(50,null)}),e.$kK=new C.$Wj("variableName",!1,{type:"string",description:k.localize(51,null)}),e.$lK=new C.$Wj("variableLanguage",!1,{type:"string",description:k.localize(52,null)}),e.$mK=new C.$Wj("variableExtensionId",!1,{type:"string",description:k.localize(53,null)}),e.$nK=new C.$Wj("exceptionWidgetVisible",!1,{type:"boolean",description:k.localize(54,null)}),e.$oK=new C.$Wj("multiSessionRepl",!1,{type:"boolean",description:k.localize(55,null)}),e.$pK=new C.$Wj("multiSessionDebug",!1,{type:"boolean",description:k.localize(56,null)}),e.$qK=new C.$Wj("disassembleRequestSupported",!1,{type:"boolean",description:k.localize(57,null)}),e.$rK=new C.$Wj("disassemblyViewFocus",!1,{type:"boolean",description:k.localize(58,null)}),e.$sK=new C.$Wj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:k.localize(59,null)}),e.$tK=new C.$Wj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:k.localize(60,null)});const A=i=>k.localize(61,null,i);e.$uK=A,e.$vK="editor.contrib.debug",e.$wK="editor.contrib.breakpoint",e.$xK="debug",e.$yK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:k.localize(62,null)};var T;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(T||(e.State=T={}));function p(i){switch(i){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var a;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(a||(e.MemoryRangeType=a={})),e.$AK="vscode-debug-memory";function P(i){const r=i.presentationHint??i.source.presentationHint;return r==="deemphasize"||r==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var E;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.$CK=(0,O.$Fi)("debugService");var d;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var n;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(n||(e.DebugVisualizationType=n={}));var s;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(s||(e.DebugTreeItemCollapsibleState=s={}));var o;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(o||(e.IDebugVisualizationTreeItem=o={}));var h;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:v.URI.revive(r.iconPath.light),dark:v.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(h||(e.IDebugVisualization=h={}))}),define(Ce[238],Ie([1,0,13,2,20,26,16,33,22,18]),function(oe,e,v,k,C,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7H=void 0,e.$UH=y,e.$VH=u,e.$WH=E,e.$XH=d,e.$YH=n,e.$ZH=s,e.$1H=o,e.$2H=i,e.$3H=c,e.$4H=l,e.$5H=m,e.$6H=S;const P=/{([^}]+)}/g;function y(b,I,R){return b.replace(P,function(f,w){return I&&w.length>0&&w[0]!=="_"?f:R&&R.hasOwnProperty(w)?R[w]:f})}function u(b){const I={};for(const R of Object.keys(b))R.startsWith("!")||(I[R]=b[R]);return I}function E(b){return b.configuration.request==="attach"&&!d(b)&&(!b.parentSession||E(b.parentSession))}function d(b){let I=b.configuration.type;if(I)return I==="vslsShare"&&(I=b.configuration.adapterProxy.configuration.type),(0,v.$Gf)(I,"extensionhost")||(0,v.$Gf)(I,"pwa-extensionhost")?b:b.parentSession?d(b.parentSession):void 0}function n(b){return b.type&&(b.label||b.program||b.runtime)}function s(b,I,R){let f,w=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=M.exec(b);){const L=N.index+1,G=L+N[0].length;if(L<=I&&G>=R){f=N[0],w=L;break}}if(f){const L=/\w+/g;let G=null;for(;(G=L.exec(f))&&!(G.index+1+w+G[0].length>=R););G&&(f=f.substring(0,L.lastIndex))}return f?{start:w,end:w+f.length-1}:{start:0,end:0}}async function o(b,I,R,f){if(b.evaluatableExpressionProvider.has(I)){const w=b.evaluatableExpressionProvider.ordered(I),M=(0,a.$Jb)(await Promise.all(w.map(async N=>{try{return await N.provideEvaluatableExpression(I,R,f??p.CancellationToken.None)}catch{return}})));if(M.length>0){let N=M[0].expression;const L=M[0].range;return N||(N=I.getLineContent(R.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:N}}}else{const w=I.getLineContent(R.lineNumber),{start:M,end:N}=s(w,R.column,R.column),L=w.substring(M-1,N);return{matchingExpression:L,range:new T.$Lt(R.lineNumber,M,R.lineNumber,M+L.length)}}return null}const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(b){return!!(b&&b.match(h))}function r(b){if(typeof b.path=="string"&&!(typeof b.sourceReference=="number"&&b.sourceReference>0)){if(i(b.path))return k.URI.parse(b.path);if((0,C.$kc)(b.path))return k.URI.file(b.path)}return b.path}function t(b){if(typeof b.path=="object"){const I=k.URI.revive(b.path);if(I)return I.scheme===A.Schemas.file?I.fsPath:I.toString()}return b.path}function c(b,I){const R=I?r:t,f=(0,O.$do)(b);return g(f,(w,M)=>{w&&M&&(M.path=R(M))}),f}function l(b,I){const R=I?r:t,f=(0,O.$do)(b);return g(f,(w,M)=>{!w&&M&&(M.path=R(M))}),f}function g(b,I){switch(b.type){case"event":{const R=b;switch(R.event){case"output":I(!1,R.body.source);break;case"loadedSource":I(!1,R.body.source);break;case"breakpoint":I(!1,R.body.breakpoint.source);break;default:break}break}case"request":{const R=b;switch(R.command){case"setBreakpoints":I(!0,R.arguments.source);break;case"breakpointLocations":I(!0,R.arguments.source);break;case"source":I(!0,R.arguments.source);break;case"gotoTargets":I(!0,R.arguments.source);break;case"launchVSCode":R.arguments.args.forEach(f=>I(!1,f));break;default:break}break}case"response":{const R=b;if(R.success&&R.body)switch(R.command){case"stackTrace":R.body.stackFrames.forEach(f=>I(!1,f.source));break;case"loadedSources":R.body.sources.forEach(f=>I(!1,f));break;case"scopes":R.body.scopes.forEach(f=>I(!1,f.source));break;case"setFunctionBreakpoints":R.body.breakpoints.forEach(f=>I(!1,f.source));break;case"setBreakpoints":R.body.breakpoints.forEach(f=>I(!1,f.source));break;case"disassemble":R.body?.instructions.forEach(w=>I(!1,w.location));break;default:break}break}}}function m(b){return b.filter(I=>!I.presentation?.hidden).sort((I,R)=>I.presentation?R.presentation?I.presentation.group?R.presentation.group?I.presentation.group!==R.presentation.group?I.presentation.group.localeCompare(R.presentation.group):$(I.presentation.order,R.presentation.order):-1:R.presentation.group?1:$(I.presentation.order,R.presentation.order):-1:R.presentation?1:0)}function $(b,I){return typeof b!="number"?typeof I!="number"?0:1:typeof I!="number"?-1:b-I}async function S(b,I){const R=b.getValue("debug.saveBeforeStart",{overrideIdentifier:I.activeTextEditorLanguageId});if(R!=="none"&&(await I.saveAll(),R==="allEditorsInActiveGroup")){const f=I.activeEditorPane;f&&f.input.resource?.scheme===A.Schemas.untitled&&await I.save({editor:f.input,groupId:f.group.id})}await b.reloadConfiguration()}const D=(b,I)=>!b||!I?b===I:b.name===I.name&&b.path===I.path&&b.sourceReference===I.sourceReference;e.$7H=D}),define(Ce[239],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UK=e.CellExecutionUpdateType=void 0;var k;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(k||(e.CellExecutionUpdateType=k={})),e.$UK=(0,v.$Fi)("INotebookExecutionService")}),define(Ce[240],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YK=e.$XK=e.ProxyKernelState=e.$WK=void 0,e.$WK=100;var k;(function(C){C[C.Disconnected=1]="Disconnected",C[C.Connected=2]="Connected",C[C.Initializing=3]="Initializing"})(k||(e.ProxyKernelState=k={})),e.$XK=(0,v.$Fi)("INotebookKernelService"),e.$YK=(0,v.$Fi)("INotebookKernelHistoryService")}),define(Ce[241],Ie([1,0,4,33,52,167,102]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wZb=void 0;class T extends v.$Wc{constructor(a,P,y){super(),this._source=a,this.b=P,this.c=y,this.a=void 0}f(a){const P=a.getLineCount();return new k.$Lt(1,1,P,this.g(a,P))}g(a,P){if(P<1||P>a.getLineCount())throw new Error("Illegal value for lineNumber");return a.getLineLength(P)+1}get inputTextBuffer(){if(!this.b){const a=new O.$mD;a.acceptChunk(this._source);const P=a.finish(!0),{textBuffer:y,disposable:u}=P.create(C.DefaultEndOfLine.LF);this.b=y,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(a=>{const P=new O.$mD;P.acceptChunk(a);const y=P.finish(!0),{textBuffer:u,disposable:E}=y.create(C.DefaultEndOfLine.LF);return this.B(E),u})),this.a}findInInputs(a){const y=new A.$aD(a,!1,!1,null).parseSearchRequest();if(!y)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,y,!0,5e3)}findInOutputs(a){const y=new A.$aD(a,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(u=>{const E=u.findMatchesLineByLine(this.f(u),y,!0,5e3);if(E.length!==0)return{textBuffer:u,matches:E}}).filter(u=>!!u):[]}}e.$wZb=T}),define(Ce[55],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(O){O.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var k;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(k||(e.TestPosition=k={}));class C{static fromExtHostTestItem(A,T,p=A.parent){if(A._isRoot)return new C([T]);const a=[A.id];for(let P=p;P&&P.id!==T;P=P.parent)a.push(P.id);return a.push(T),new C(a.reverse())}static isRoot(A){return!A.includes(v.Delimiter)}static root(A){const T=A.indexOf(v.Delimiter);return T===-1?A:A.slice(0,T)}static fromString(A){return new C(A.split(v.Delimiter))}static join(A,T){return new C([...A.path,T])}static joinToString(A,T){return A.toString()+v.Delimiter+T}static parentId(A){const T=A.lastIndexOf(v.Delimiter);return T===-1?void 0:A.slice(0,T)}static localId(A){const T=A.lastIndexOf(v.Delimiter);return T===-1?A:A.slice(T+v.Delimiter.length)}static isChild(A,T){return T.startsWith(A)&&T[A.length]===v.Delimiter}static compare(A,T){return A===T?k.IsSame:C.isChild(A,T)?k.IsChild:C.isChild(T,A)?k.IsParent:k.Disconnected}static getLengthOfCommonPrefix(A,T){if(A===0)return 0;let p=0;for(;p<A-1;){for(let a=1;a<A;a++){const P=T(a-1),y=T(a);if(P.path[p]!==y.path[p])return p}p++}return p}constructor(A,T=A.length){if(this.path=A,this.d=T,A.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let T=0;T<A.d&&T<this.d;T++)if(A.path[T]!==this.path[T])return k.Disconnected;return A.d>this.d?k.IsChild:A.d<this.d?k.IsParent:k.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=v.Delimiter,this.c+=this.path[A]}return this.c}}e.$TI=C}),define(Ce[56],Ie([1,0,2,101,33,55]),function(oe,e,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3I=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$2I=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$1I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$ZI=e.$YI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$XI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$WI=e.$VI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$UI=e.TestResultState=void 0;var A;(function(W){W[W.Unset=0]="Unset",W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$UI={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var T;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var p;(function(W){W[W.Run=2]="Run",W[W.Debug=4]="Debug",W[W.Coverage=8]="Coverage",W[W.HasNonDefaultProfile=16]="HasNonDefaultProfile",W[W.HasConfigurable=32]="HasConfigurable",W[W.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$VI=[p.Run,p.Debug,p.Coverage,p.HasNonDefaultProfile,p.HasConfigurable,p.SupportsContinuousRun];const a=W=>"runId"in W;e.$WI=a;var P;(function(W){W.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),W.deserialize=(F,V)=>({range:C.$Lt.lift(V.range),uri:F.asCanonicalUri(v.URI.revive(V.uri))})})(P||(e.IRichLocation=P={}));var y;(function(W){W[W.Error=0]="Error",W[W.Output=1]="Output"})(y||(e.TestMessageType=y={}));var u;(function(W){W.serialize=F=>({message:F.message,type:y.Error,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&P.serialize(F.location)}),W.deserialize=(F,V)=>({message:V.message,type:y.Error,expected:V.expected,actual:V.actual,contextValue:V.contextValue,location:V.location&&P.deserialize(F,V.location)})})(u||(e.ITestErrorMessage=u={}));const E=(W,F)=>`${F?"s":"e"}${W}`;e.$XI=E;var d;(function(W){W.serialize=F=>({message:F.message,type:y.Output,offset:F.offset,length:F.length,location:F.location&&P.serialize(F.location)}),W.deserialize=(F,V)=>({message:V.message,type:y.Output,offset:V.offset,length:V.length,location:V.location&&P.deserialize(F,V.location)})})(d||(e.ITestOutputMessage=d={}));var n;(function(W){W.serialize=F=>F.type===y.Error?u.serialize(F):d.serialize(F),W.deserialize=(F,V)=>V.type===y.Error?u.deserialize(F,V):d.deserialize(F,V)})(n||(e.ITestMessage=n={}));var s;(function(W){W.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),W.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(n.serialize)}),W.deserialize=(F,V)=>({state:V.state,duration:V.duration,messages:V.messages.map(ae=>n.deserialize(F,ae))})})(s||(e.ITestTaskState=s={}));const o="\0",h=(W,F)=>W+o+F;e.$YI=h;const i=W=>{const F=W.indexOf(o);return{ctrlId:W.slice(0,F),tagId:W.slice(F+1)}};e.$ZI=i;var r;(function(W){W.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),W.deserialize=(F,V)=>({extId:V.extId,label:V.label,tags:V.tags,busy:V.busy,children:void 0,uri:V.uri?F.asCanonicalUri(v.URI.revive(V.uri)):void 0,range:V.range?C.$Lt.lift(V.range):null,description:V.description,error:V.error,sortText:V.sortText})})(r||(e.ITestItem=r={}));var t;(function(W){W[W.NotExpandable=0]="NotExpandable",W[W.Expandable=1]="Expandable",W[W.BusyExpanding=2]="BusyExpanding",W[W.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var c;(function(W){W.serialize=F=>({expand:F.expand,item:r.serialize(F.item)}),W.deserialize=(F,V)=>({controllerId:O.$TI.root(V.item.extId),expand:V.expand,item:r.deserialize(F,V.item)})})(c||(e.InternalTestItem=c={}));var l;(function(W){W.serialize=F=>{let V;return F.item&&(V={},F.item.label!==void 0&&(V.label=F.item.label),F.item.tags!==void 0&&(V.tags=F.item.tags),F.item.busy!==void 0&&(V.busy=F.item.busy),F.item.uri!==void 0&&(V.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(V.range=F.item.range?.toJSON()),F.item.description!==void 0&&(V.description=F.item.description),F.item.error!==void 0&&(V.error=F.item.error),F.item.sortText!==void 0&&(V.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:V}},W.deserialize=F=>{let V;return F.item&&(V={},F.item.label!==void 0&&(V.label=F.item.label),F.item.tags!==void 0&&(V.tags=F.item.tags),F.item.busy!==void 0&&(V.busy=F.item.busy),F.item.range!==void 0&&(V.range=F.item.range?C.$Lt.lift(F.item.range):null),F.item.description!==void 0&&(V.description=F.item.description),F.item.error!==void 0&&(V.error=F.item.error),F.item.sortText!==void 0&&(V.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:V}}})(l||(e.ITestItemUpdate=l={}));const g=(W,F)=>{F.expand!==void 0&&(W.expand=F.expand),F.item!==void 0&&(W.item=W.item?Object.assign(W.item,F.item):F.item)};e.$1I=g;var m;(function(W){W.serializeWithoutMessages=F=>({...c.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(s.serializeWithoutMessages)}),W.serialize=F=>({...c.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(s.serialize)}),W.deserialize=(F,V)=>({...c.deserialize(F,V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(ae=>s.deserialize(F,ae)),retired:!0})})(m||(e.TestResultItem=m={}));var $;(function(W){W.empty=()=>({covered:0,total:0}),W.sum=(F,V)=>{F.covered+=V.covered,F.total+=V.total}})($||(e.ICoverageCount=$={}));var S;(function(W){W.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testIds:F.testIds,uri:F.uri.toJSON()}),W.deserialize=(F,V)=>({id:V.id,statement:V.statement,branch:V.branch,declaration:V.declaration,testIds:V.testIds,uri:F.asCanonicalUri(v.URI.revive(V.uri))}),W.empty=(F,V)=>({id:F,uri:V,statement:$.empty()})})(S||(e.IFileCoverage=S={}));function D(W){return{...W,location:W.location?.toJSON()}}function b(W){return W.location=W.location?k.$Kt.isIPosition(W.location)?k.$Kt.lift(W.location):C.$Lt.lift(W.location):void 0,W}e.$2I=3;var I;(function(W){W[W.Declaration=0]="Declaration",W[W.Statement=1]="Statement",W[W.Branch=2]="Branch"})(I||(e.DetailType=I={}));var R;(function(W){W.serialize=F=>F.type===I.Declaration?w.serialize(F):M.serialize(F),W.deserialize=F=>F.type===I.Declaration?w.deserialize(F):M.deserialize(F)})(R||(e.CoverageDetails=R={}));var f;(function(W){W.serialize=D,W.deserialize=b})(f||(e.IBranchCoverage=f={}));var w;(function(W){W.serialize=D,W.deserialize=b})(w||(e.IDeclarationCoverage=w={}));var M;(function(W){W.serialize=F=>({...D(F),branches:F.branches?.map(f.serialize)}),W.deserialize=F=>({...b(F),branches:F.branches?.map(f.deserialize)})})(M||(e.IStatementCoverage=M={}));var N;(function(W){W[W.Add=0]="Add",W[W.Update=1]="Update",W[W.DocumentSynced=2]="DocumentSynced",W[W.Remove=3]="Remove",W[W.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",W[W.Retire=5]="Retire",W[W.AddTag=6]="AddTag",W[W.RemoveTag=7]="RemoveTag"})(N||(e.TestDiffOpType=N={}));var L;(function(W){W.deserialize=(F,V)=>V.op===N.Add?{op:V.op,item:c.deserialize(F,V.item)}:V.op===N.Update?{op:V.op,item:l.deserialize(V.item)}:V.op===N.DocumentSynced?{op:V.op,uri:F.asCanonicalUri(v.URI.revive(V.uri)),docv:V.docv}:V,W.serialize=F=>F.op===N.Add?{op:F.op,item:c.serialize(F.item)}:F.op===N.Update?{op:F.op,item:l.serialize(F.item)}:F})(L||(e.TestsDiffOp=L={}));class G{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const V=this.w();for(const ae of F)switch(ae.op){case N.Add:this.l(c.deserialize(this.k,ae.item),V);break;case N.Update:this.p(l.deserialize(ae.item),V);break;case N.Remove:this.q(ae.itemId,V);break;case N.Retire:this.v(ae.itemId);break;case N.IncrementPendingExtHosts:this.updatePendingRoots(ae.amount);break;case N.AddTag:this.c.set(ae.tag.id,ae.tag);break;case N.RemoveTag:this.c.delete(ae.id);break}V.complete?.()}l(F,V){const ae=O.$TI.parentId(F.item.extId)?.toString();let $e;if(!ae)$e=this.x(F),this.g.add($e),this.f.set(F.item.extId,$e);else if(this.f.has(ae)){const _=this.f.get(ae);_.children.add(F.item.extId),$e=this.x(F,_),this.f.set(F.item.extId,$e)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return V.add?.($e),F.expand===t.BusyExpanding&&this.h++,$e}p(F,V){const ae=this.f.get(F.extId);if(ae)return F.expand!==void 0&&(ae.expand===t.BusyExpanding&&this.h--,F.expand===t.BusyExpanding&&this.h++),(0,e.$1I)(ae,F),V.update?.(ae),ae}q(F,V){const ae=this.f.get(F);if(!ae)return;const $e=O.$TI.parentId(ae.item.extId)?.toString();$e?this.f.get($e).children.delete(ae.item.extId):this.g.delete(ae);const _=[[F]];for(;_.length;)for(const ge of _.pop()){const se=this.f.get(ge);se&&(_.push(se.children),this.f.delete(ge),V.remove?.(se,se!==ae),se.expand===t.BusyExpanding&&this.h--)}}v(F){}updatePendingRoots(F){this.j+=F}w(){return{}}}e.$3I=G}),define(Ce[242],Ie([1,0,99,202,56]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$oGb=e.$nGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var A;(function(y){y.List="list",y.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var T;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const p={[C.TestResultState.Errored]:(0,k.localize)(0,null),[C.TestResultState.Failed]:(0,k.localize)(1,null),[C.TestResultState.Passed]:(0,k.localize)(2,null),[C.TestResultState.Queued]:(0,k.localize)(3,null),[C.TestResultState.Running]:(0,k.localize)(4,null),[C.TestResultState.Skipped]:(0,k.localize)(5,null),[C.TestResultState.Unset]:(0,k.localize)(6,null)},a=(y,u)=>(0,k.localize)(7,null,(0,v.$Yk)(y),p[u]);e.$nGb=a,e.$oGb={[C.TestRunProfileBitset.Debug]:(0,k.localize)(8,null),[C.TestRunProfileBitset.Run]:(0,k.localize)(9,null),[C.TestRunProfileBitset.Coverage]:(0,k.localize)(10,null)};var P;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(P||(e.TestCommandId=P={}))}),define(Ce[82],Ie([1,0,11,6,4,62,56,55]),function(oe,e,v,k,C,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.TestItemEventOp=void 0;var p;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const a=(h,i)=>h===i,y=Object.entries({range:(h,i)=>h===i?!0:!h||!i?!1:h.equalsRange(i),busy:a,label:a,description:a,error:a,sortText:a,tags:(h,i)=>!(h.length!==i.length||h.some(r=>!i.includes(r)))}),u=(h,i)=>{let r;for(const[t,c]of y)c(h[t],i[t])||(r?r[t]=i[t]:r={[t]:i[t]});return r};class E extends C.$Wc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new v.$Rh(()=>this.flushDiff(),200)),this.g=this.B(new k.$me),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case A.TestDiffOpType.DocumentSynced:{for(const r of this.m)if(r.op===A.TestDiffOpType.DocumentSynced&&r.uri===i.uri){r.docv=i.docv;return}break}case A.TestDiffOpType.Update:{const r=this.m[this.m.length-1];if(r){if(r.op===A.TestDiffOpType.Update&&r.item.extId===i.item.extId){(0,A.$1I)(r.item,i.item);return}if(r.op===A.TestDiffOpType.Add&&r.item.item.extId===i.item.extId){(0,A.$1I)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||r>t.expandLevels)&&(t.expandLevels=r),t.expand===A.TestItemExpandState.Expandable){const c=this.M(t);return c.isOpen()?this.L(t,r-1):c.wait().then(()=>this.L(t,r-1))}else if(t.expand===A.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,r-1)):this.L(t,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case p.RemoveChild:this.O(T.$TI.joinToString(i.fullId,r.id));break;case p.Upsert:this.z(r.item,i);break;case p.Bulk:for(const t of r.ops)this.w(i,t);break;case p.SetTags:this.C(r.new,r.old,i.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(i);break;case p.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:r.update}});break;case p.DocumentSynced:this.y(i.actual.uri);break;default:(0,O.$gd)(r)}}y(i){i&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const t=T.$TI.fromExtHostTestItem(i,this.root.id,r?.actual),c=this.s.getApiFor(i);c.parent&&c.parent!==r?.actual&&this.s.getChildren(c.parent).delete(i.id);let l=this.tree.get(t.toString());if(!l){l={fullId:t,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(l.fullId.toString(),l),this.G(i,r),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:l.expand,item:this.s.toITestItem(i)}}),this.I(i,l,r);return}if(l.actual===i){this.H(i,l,r);return}if(l.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,r);const g=this.s.getChildren(l.actual),m=l.actual,$=u(this.s.toITestItem(m),this.s.toITestItem(i));this.s.getApiFor(m).listener=void 0,l.actual=i,l.resolveBarrier=void 0,l.expand=A.TestItemExpandState.NotExpandable,$&&($.hasOwnProperty("tags")&&(this.C(i.tags,m.tags,t.toString()),delete $.tags),this.w(l,{op:p.SetProp,update:$})),this.I(i,l,r);for(const[D,b]of g)this.s.getChildren(i).get(b.id)||this.O(T.$TI.joinToString(t,b.id));const S=l.expandLevels;S!==void 0&&queueMicrotask(()=>{l.expand===A.TestItemExpandState.Expandable&&(l.expandLevels=void 0,this.expand(t.toString(),S))}),this.y(l.actual.uri)}C(i,r,t){const c=new Set(r.map(l=>l.id));for(const l of i)c.delete(l.id)||this.D(l);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(l=>(0,A.$YI)(this.s.controllerId,l.id))}}}),c.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$YI)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$YI)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,t){this.G(i,t);const c=this.s.getApiFor(i);c.parent=t?.actual,c.listener=l=>this.w(r,l),this.J(r)}I(i,r,t){this.H(i,r,t);for(const[c,l]of this.s.getChildren(i))this.z(l,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:r=i.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:r=A.TestItemExpandState.NotExpandable,r!==i.expand&&(i.expand=r,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:r}}),r===A.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const t=[];for(const[c,l]of this.s.getChildren(i.actual)){const g=this.expand(T.$TI.joinToString(i.fullId,l.id),r);(0,v.$rh)(g)&&t.push(g)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const l=new v.$Eh;return l.open(),l}i.expand=A.TestItemExpandState.BusyExpanding,this.N(i);const r=i.resolveBarrier=new v.$Eh,t=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,l)};let c;try{c=this.h(i.actual===this.root?void 0:i.actual)}catch(l){t(l)}return(0,v.$rh)(c)?c.catch(t).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:i});const t=[r];for(;t.length;){const c=t.pop();if(c){this.s.getApiFor(c.actual).listener=void 0;for(const l of c.actual.tags)this.F(l.id);this.tree.delete(c.fullId.toString());for(const[l,g]of this.s.getChildren(c.actual))t.push(this.tree.get(T.$TI.joinToString(c.fullId,g.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$QP=E;class d extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$RP=d;class n extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$SP=n;class s extends Error{constructor(i,r,t){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${t}".`)}}e.$TP=s;const o=(h,i,r)=>{let t=new Map;return{get size(){return t.size},forEach(c,l){for(const g of t.values())c.call(l,g,this)},[Symbol.iterator](){return t.entries()},replace(c){const l=new Map,g=new Set(t.keys()),m={op:p.Bulk,ops:[]};for(const $ of c){if(!($ instanceof r))throw new n($.id);const S=i($).controllerId;if(S!==h.controllerId)throw new s($.id,S,h.controllerId);if(l.has($.id))throw new d($.id);l.set($.id,$),g.delete($.id),m.ops.push({op:p.Upsert,item:$})}for(const $ of g.keys())m.ops.push({op:p.RemoveChild,id:$});h.listener?.(m),t=l},add(c){if(!(c instanceof r))throw new n(c.id);t.set(c.id,c),h.listener?.({op:p.Upsert,item:c})},delete(c){t.delete(c)&&h.listener?.({op:p.RemoveChild,id:c})},get(c){return t.get(c)},toJSON(){return Array.from(t.values())}}};e.$UP=o}),define(Ce[116],Ie([1,0,82]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=void 0;const k=new WeakMap,C=(A,T)=>{const p={controllerId:T};return k.set(A,p),p};e.$VP=C;const O=A=>{const T=k.get(A);if(!T)throw new v.$SP(A?.id||"<unknown>");return T};e.$WP=O}),define(Ce[83],Ie([1,0,28,16,2]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cDb=e.$bDb=e.$aDb=void 0,e.$dDb=O,e.$eDb=T,e.$aDb="vscode-cdn.net",e.$bDb=`vscode-resource.${e.$aDb}`,e.$cDb=`'self' https://*.${e.$aDb}`;function O(p,a){return p.scheme===k.Schemas.http||p.scheme===k.Schemas.https?p:(a&&a.authority&&a.isRemote&&p.scheme===k.Schemas.file&&(p=C.URI.from({scheme:k.Schemas.vscodeRemote,authority:a.authority,path:p.path})),C.URI.from({scheme:k.Schemas.https,authority:`${p.scheme}+${A(p.authority)}.${e.$bDb}`,path:p.path,fragment:p.fragment,query:p.query}))}function A(p){return p.replace(/./g,a=>{const P=a.charCodeAt(0);return P>=v.CharCode.a&&P<=v.CharCode.z||P>=v.CharCode.A&&P<=v.CharCode.Z||P>=v.CharCode.Digit0&&P<=v.CharCode.Digit9?a:"-"+P.toString(16).padStart(4,"0")})}function T(p){return p.replace(/-([0-9a-f]{4})/g,(a,P)=>String.fromCharCode(parseInt(P,16)))}}),define(Ce[243],Ie([1,0,6,4,83]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=void 0;class O{constructor(T,p,a){this.d=T,this.e=p,this.f=a,this.a=0,this.b=new k.$Vc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const P=p.getVisibleTextEditors();for(const y of this.c.values())P.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,p,a,P,y){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===T){u=i;break}if(!u)throw new Error("not a visible editor");const E=this,d=this.a++,n=new v.$me,s=new v.$me,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,C.$dDb)(i,E.f)}get cspSource(){return C.$cDb}set options(i){this.b=i,E.d.$setOptions(d,i)}get options(){return this.b}set html(i){this.a=i,E.d.$setHtml(d,i)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(i){return E.d.$postMessage(d,i)}},h=new class{constructor(){this.editor=T,this.line=p,this.height=a,this.webview=o,this.onDidDispose=s.event}dispose(){E.c.has(d)&&(E.c.delete(d),E.d.$disposeEditorInset(d),s.fire(),s.dispose(),n.dispose())}};return this.d.$createEditorInset(d,u.id,u.value.document.uri,p+1,a,P||{},y.identifier,y.extensionLocation),this.c.set(d,{editor:T,inset:h,onDidReceiveMessage:n}),h}$onDidDispose(T){const p=this.c.get(T);p&&p.inset.dispose()}$onDidReceiveMessage(T,p){this.c.get(T)?.onDidReceiveMessage.fire(p)}}e.$Aoc=O}),define(Ce[117],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=e.$wM=void 0,e.$wM="__",e.$xM=(0,v.$Fi)("IAuthenticationService"),e.$yM=(0,v.$Fi)("IAuthenticationExtensionsService")}),define(Ce[244],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=e.VariableKind=e.$OQ=void 0,e.$OQ=(0,v.$Fi)("configurationResolverService");var k;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(k||(e.VariableKind=k={}));class C extends Error{constructor(A,T){super(T),this.variable=A}}e.$PQ=C}),define(Ce[245],Ie([1,0,20,79,15,26,21,103,203,244,13]),function(oe,e,v,k,C,O,A,T,p,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Q=void 0,v=qe(v),k=qe(k),C=qe(C),O=qe(O);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,d,n,s){this.h=new Map,this.a=E,this.b=d,this.g=n,s&&(this.c=s.then(o=>this.i(o)))}i(E){if(A.$i){const d=Object.create(null);return Object.keys(E).forEach(n=>{d[n.toLowerCase()]=E[n]}),d}return E}resolveWithEnvironment(E,d,n){return this.l({env:this.i(E),userHome:void 0},d?d.uri:void 0,n)}async resolveAsync(E,d){const n={env:await this.c,userHome:await this.g};return this.l(n,E?E.uri:void 0,d)}async j(E,d,n,s){const o=O.$do(d);A.$i&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):A.$j&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):A.$k&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,E?E.uri:void 0,o,n,s)}async resolveAnyAsync(E,d,n){return this.j(E,d,n)}async resolveAnyMap(E,d,n){const s=new Map;return{newConfig:await this.j(E,d,n,s),resolvedVariables:s}}resolveWithInteractionReplace(E,d,n,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,d,n,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,d){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,d)}async l(E,d,n,s,o){if(C.$fg(n))return this.m(E,d,n,s,o);if(Array.isArray(n))return Promise.all(n.map(h=>this.l(E,d,h,s,o)));if(C.$hg(n)){const h=Object.create(null),i=await Promise.all(Object.keys(n).map(async r=>[await this.m(E,d,r,s,o),await this.l(E,d,n[r],s,o)]));for(const[r,t]of i)h[r]=t;return h}return n}m(E,d,n,s,o){return(0,P.$yf)(n,y.VARIABLE_REGEXP,async(h,i)=>{if(i.includes(y.VARIABLE_LHS))return h;let r=await this.o(E,h,i,d,s);return o?.set(i,r),r!==h&&C.$fg(r)&&r.match(y.VARIABLE_REGEXP)&&(r=await this.m(E,d,r,s,o)),r})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,d,n,s,o){let h;const i=n.split(":");i.length>1&&(n=i[0],h=i[1]);const r=l=>{const g=this.a.getFilePath();if(g)return(0,T.$Ww)(g);throw new a.$PQ(l,(0,p.localize)(0,null,d))},t=l=>{const g=r(l);if(this.a.getWorkspaceFolderPathForFile){const m=this.a.getWorkspaceFolderPathForFile();if(m)return(0,T.$Ww)(m)}throw new a.$PQ(l,(0,p.localize)(1,null,d,v.$pc(g)))},c=l=>{if(h){const g=this.a.getFolderUri(h);if(g)return g;throw new a.$PQ(l,(0,p.localize)(2,null,d,h))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new a.$PQ(l,(0,p.localize)(3,null,d)):new a.$PQ(l,(0,p.localize)(4,null,d))};switch(n){case"env":if(h){if(E.env){const l=E.env[A.$i?h.toLowerCase():h];if(C.$fg(l))return l}return""}throw new a.$PQ(a.VariableKind.Env,(0,p.localize)(5,null,d));case"config":if(h){const l=this.a.getConfigurationValue(s,h);if(C.$og(l))throw new a.$PQ(a.VariableKind.Config,(0,p.localize)(6,null,d,h));if(C.$hg(l))throw new a.$PQ(a.VariableKind.Config,(0,p.localize)(7,null,d,h));return l}throw new a.$PQ(a.VariableKind.Config,(0,p.localize)(8,null,d));case"command":return this.p(a.VariableKind.Command,d,h,o,"command");case"input":return this.p(a.VariableKind.Input,d,h,o,"input");case"extensionInstallFolder":if(h){const l=await this.a.getExtension(h);if(!l)throw new a.$PQ(a.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,d,h));return this.n(l.extensionLocation)}throw new a.$PQ(a.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,d));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,T.$Ww)(this.n(c(a.VariableKind.WorkspaceFolder)));case"cwd":return s||h?(0,T.$Ww)(this.n(c(a.VariableKind.Cwd))):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$Ww)(v.$pc(this.n(c(a.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new a.$PQ(a.VariableKind.UserHome,(0,p.localize)(11,null,d))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new a.$PQ(a.VariableKind.LineNumber,(0,p.localize)(12,null,d))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new a.$PQ(a.VariableKind.SelectedText,(0,p.localize)(13,null,d))}case"file":return r(a.VariableKind.File);case"fileWorkspaceFolder":return t(a.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return v.$pc(t(a.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||h?v.$nc(this.n(c(a.VariableKind.RelativeFile)),r(a.VariableKind.RelativeFile)):r(a.VariableKind.RelativeFile);case"relativeFileDirname":{const l=v.$oc(r(a.VariableKind.RelativeFileDirname));if(s||h){const g=v.$nc(this.n(c(a.VariableKind.RelativeFileDirname)),l);return g.length===0?".":g}return l}case"fileDirname":return v.$oc(r(a.VariableKind.FileDirname));case"fileExtname":return v.$qc(r(a.VariableKind.FileExtname));case"fileBasename":return v.$pc(r(a.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=v.$pc(r(a.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-v.$qc(l).length)}case"fileDirnameBasename":return v.$pc(v.$oc(r(a.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||d}case"execInstallFolder":{const l=this.a.getAppRoot();return l||d}case"pathSeparator":case"/":return v.sep;default:try{const l=h?`${n}:${h}`:n;return this.p(a.VariableKind.Unknown,d,l,o,void 0)}catch{return d}}}}p(E,d,n,s,o){if(n&&s){const h=o===void 0?s[n]:s[o+":"+n];if(typeof h=="string")return h;throw new a.$PQ(E,(0,p.localize)(14,null,d))}return d}}e.$5Q=y}),define(Ce[118],Ie([1,0,3,115]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$jE=void 0,e.$kE=a,e.$lE=u,e.$mE=E,e.$jE=(0,v.$Fi)("editorGroupsService");var C;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var O;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var A;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var T;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var p;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function a(d){const n=d;return(0,k.$8F)(n?.editor)&&(0,k.$8F)(n?.replacement)}var P;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var y;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function u(d){const n=d;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}function E(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?C.DOWN:C.RIGHT}}),define(Ce[246],Ie([1,0,3,118]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qE=e.$pE=e.$oE=e.$nE=void 0,e.$rE=C,e.$nE=(0,v.$Fi)("editorService"),e.$oE=-1,e.$pE=-2,e.$qE=-3;function C(O){const A=O;return typeof O=="number"||(0,k.$lE)(A)}}),define(Ce[247],Ie([1,0,3,107]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=void 0,e.$RM=(0,v.$Gi)(k.$Mi)}),define(Ce[119],Ie([1,0,19,6,20,4,11]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=e.$Mcc=e.$Lcc=e.$Kcc=e.$Jcc=void 0,C=qe(C);class T{constructor(h,i){this.versionId=h,this.removedDueToLooping=i}}e.$Jcc=T;class p{static isHostExtension(h,i,r){if(i.getExtensionDescription(h))return!1;const t=r.getExtensionDescription(h);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(h,i){this.j=h,this.c=new k.$me,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(n),this.f=new v.$sn,this.g=[],this.h=new Map;for(const h of this.e){if(this.f.has(h.identifier)){console.error("Extension `"+h.identifier.value+"` is already registered");continue}this.f.set(h.identifier,h),this.g.push(h);const i=this.j.readActivationEvents(h);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(h)}}set(h){return this.e=h,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(h,i){this.e=s(this.e,i),this.e=this.e.concat(h);const r=p.l(this.e);return this.e=s(this.e,r.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,r)}static l(h){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(g){this.d.has(g)||(this.d.add(g),this.e.push(g))}addArc(g,m){this.addNode(g),this.addNode(m),this.c.has(g)?this.c.get(g).push(m):this.c.set(g,[m])}getArcs(g){return this.c.has(g)?this.c.get(g):[]}hasOnlyGoodArcs(g,m){const $=i.getArcs(g);for(let S=0;S<$.length;S++)if(!m.has($[S]))return!1;return!0}getNodes(){return this.e}},r=new v.$sn;for(const g of h)if(r.set(g.identifier,g),g.extensionDependencies)for(const m of g.extensionDependencies)i.addArc(v.$qn.toKey(g.identifier),v.$qn.toKey(m));const t=new Set;i.getNodes().filter(g=>i.getArcs(g).length===0).forEach(g=>t.add(g));const c=i.getNodes().filter(g=>!t.has(g));let l;do{l=!1;for(let g=0;g<c.length;g++){const m=c[g];i.hasOnlyGoodArcs(m,t)&&(c.splice(g,1),g--,t.add(m),l=!0)}}while(l);return c.map(g=>r.get(g))}containsActivationEvent(h){return this.h.has(h)}containsExtension(h){return this.f.has(h)}getExtensionDescriptionsForActivationEvent(h){const i=this.h.get(h);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new a(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(h){const i=this.f.get(h);return i||void 0}getExtensionDescriptionByUUID(h){for(const i of this.g)if(i.uuid===h)return i}getExtensionDescriptionByIdOrUUID(h,i){return this.getExtensionDescription(h)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Kcc=p;class a{constructor(h,i){this.versionId=h,this.extensions=i}}e.$Lcc=a;class P{constructor(h){this.d=new E,this.c=new p(h,[])}async acquireLock(h){const i=await this.d.acquire(h);return new y(this,i)}deltaExtensions(h,i,r){if(!h.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(h){return this.c.containsActivationEvent(h)}containsExtension(h){return this.c.containsExtension(h)}getExtensionDescriptionsForActivationEvent(h){return this.c.getExtensionDescriptionsForActivationEvent(h)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(h){return this.c.getExtensionDescription(h)}getExtensionDescriptionByUUID(h){return this.c.getExtensionDescriptionByUUID(h)}getExtensionDescriptionByIdOrUUID(h,i){return this.c.getExtensionDescriptionByIdOrUUID(h,i)}}e.$Mcc=P;class y extends O.$Wc{constructor(h,i){super(),this.f=h,this.c=!1,this.B(i)}isAcquiredFor(h){return!this.c&&this.f===h}}e.$Ncc=y;class u{constructor(h){this.name=h;const i=(0,A.$yh)();this.promise=i.promise,this.c=i.resolve}resolve(h){this.c(h)}}class E{constructor(){this.c=[],this.d=!1}async acquire(h){const i=new u(h);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const h=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${h.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};h.resolve((0,O.$Uc)(t))}}var d;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(d||(d={}));function n(o,h){const i=o.isBuiltin?d.Builtin:o.isUnderDevelopment?d.Dev:d.User,r=h.isBuiltin?d.Builtin:h.isUnderDevelopment?d.Dev:d.User;if(i!==r)return i-r;const t=C.$ic.basename(o.extensionLocation.path),c=C.$ic.basename(h.extensionLocation.path);return t<c?-1:t>c?1:0}function s(o,h){const i=new v.$rn(h);return o.filter(r=>!i.has(r.identifier))}}),define(Ce[84],Ie([1,0,23]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$An=A,e.$Bn=T;var k;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(k||(e.UIKind=k={}));var C;(function(a){a[a.VersionMismatch=55]="VersionMismatch",a[a.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var O;(function(a){a[a.Initialized=0]="Initialized",a[a.Ready=1]="Ready",a[a.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function A(a){const P=v.$Oe.alloc(1);switch(a){case O.Initialized:P.writeUInt8(1,0);break;case O.Ready:P.writeUInt8(2,0);break;case O.Terminate:P.writeUInt8(3,0);break}return P}function T(a,P){if(a.byteLength!==1)return!1;switch(a.readUInt8(0)){case 1:return P===O.Initialized;case 2:return P===O.Ready;case 3:return P===O.Terminate;default:return!1}}var p;(function(a){a.Start="START_NATIVE_LOG",a.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Ce[67],Ie([1,0,3,6,113,12,27,84,63,64,26,2,4,188]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$gQ=e.$fQ=void 0,e.$hQ=s;let d=class extends u.$Wc{constructor(h,i){super(),this.s=h,this.t=i,this.a=this.B(new k.$me),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new k.$me),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=C.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:a.$zp,name:(0,E.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,O.$bk)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===C.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=C.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=C.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=C.TelemetryLevel.USAGE:!1}}instantiateLogger(h,i,r){const t=this.getTelemetryDetails(),c=new n(i,r,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),l=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...l,c]),c.apiTelemetryLogger}$initializeTelemetryLevel(h,i,r){this.f=h,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const i=Object.create(null);switch(i["common.extname"]=`${h.publisher}.${h.name}`,i["common.extversion"]=h.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:i["common.uikind"]="web";break;case T.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$hn)((0,a.$Fp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const i=this.getTelemetryDetails();this.r.forEach((r,t)=>{const c=r.filter(l=>!l.isDisposed);c.length===0?this.r.delete(t):this.r.set(t,c)}),this.r.forEach(r=>{for(const t of r)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,i){const t=this.r.get(h.value)?.filter(l=>!l.isDisposed);if(!t)return this.r.delete(h.value),!1;let c=!1;for(const l of t)l.ignoreUnhandledExtHostErrors||(l.logError(i),c=!0);return c}};e.$fQ=d,e.$fQ=d=Qe([Ve(0,A.$eQ),Ve(1,O.$ak)],d);class n{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,i,r,t,c,l,g){this.g=r,this.h=t,this.i=c,this.j=l,this.a=new k.$me,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(h,i){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let i="properties"in h?h.properties??{}:h;return i=(0,a.$Ip)(i,[]),this.c&&(i=(0,P.$go)(i,this.c)),this.b||(i=(0,P.$go)(i,this.j)),"properties"in h?h.properties=i:h=i,h}k(h,i){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(h,i),this.h.trace(h,i))}logUsage(h,i){this.d.isUsageEnabled&&this.k(h,i)}logError(h,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,i);else{const r={name:h.name,message:h.message,stack:h.stack,cause:h.cause},t=(0,a.$Ip)(r,[]),c=new Error(t.message,{cause:t.cause});c.stack=t.stack,c.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(c,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const h=this,i={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$gQ=n;function s(o){const h=Date.now()-new Date(o).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$iQ=(0,v.$Fi)("IExtHostTelemetry")}),define(Ce[25],Ie([1,0,6,2,219,112,19,3]),function(oe,e,v,k,C,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_G=e.ActivationKind=e.$9G=e.$8G=e.$5G=e.ExtensionHostStartup=e.$4G=e.$3G=e.$2G=e.$1G=void 0,e.$6G=u,e.$7G=E,e.$0G=o,e.$$G=h,e.$1G=Object.freeze({identifier:new A.$qn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$2G="extensions.webWorker",e.$3G=(0,T.$Fi)("extensionService");class p{constructor(t){this.dependency=t}}e.$4G=p;var a;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(a||(e.ExtensionHostStartup=a={}));class P{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,c,l){this.c=t,this.d=c.slice(0),this.e=l.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$MG.createActivationEventsMap(this.d)}}set(t,c,l){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const g=[],m=[],$=[],S=[],D=y(this.d),b=y(c),I=(N,L)=>N.extensionLocation.toString()===L.extensionLocation.toString()||N.isBuiltin===L.isBuiltin||N.isUserBuiltin===L.isUserBuiltin||N.isUnderDevelopment===L.isUnderDevelopment;for(const N of this.d){const L=b.get(N.identifier);if(!L){g.push(N.identifier),D.delete(N.identifier);continue}if(!I(N,L)){g.push(N.identifier),D.delete(N.identifier);continue}}for(const N of c){const L=D.get(N.identifier);if(!L){m.push(N);continue}if(!I(L,N)){g.push(L.identifier),D.delete(L.identifier);continue}}const R=new A.$rn(this.e),f=new A.$rn(l);for(const N of this.e)f.has(N)||$.push(N);for(const N of l)R.has(N)||S.push(N);const w=O.$MG.createActivationEventsMap(m),M={versionId:t,toRemove:g,toAdd:m,addActivationEvents:w,myToRemove:$,myToAdd:S};return this.delta(M),M}delta(t){if(this.c>=t.versionId)return null;const{toRemove:c,toAdd:l,myToRemove:g,myToAdd:m}=t,$=new A.$rn(c),S=new A.$rn(g);for(let D=0;D<this.d.length;D++)$.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)S.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of l)this.d.push(D);for(const D of m)this.e.push(D);return this.f=null,t}containsExtension(t){for(const c of this.e)if(A.$qn.equals(c,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const c of this.d){if(!this.containsExtension(c.identifier))continue;const l=O.$MG.readActivationEvents(c);for(const g of l)t.add(g)}return t}}e.$5G=P;function y(r){const t=new A.$sn;for(const c of r)t.set(c.identifier,c);return t}function u(r,t){return r.enabledApiProposals?r.enabledApiProposals.includes(t):!1}function E(r,t){if(!u(r,t))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class d{constructor(t,c,l,g){this.codeLoadingTime=t,this.activateCallTime=c,this.activateResolvedTime=l,this.activationReason=g}}e.$8G=d;class n{constructor(t,c){this.description=t,this.value=c}}e.$9G=n;var s;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function o(r){return{type:r.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,C.$Op)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function h(r,t){const c=(0,C.$Mp)(r.manifest.publisher,r.manifest.name);return{id:c,identifier:new A.$qn(c),isBuiltin:r.type===A.ExtensionType.System,isUserBuiltin:r.type===A.ExtensionType.User&&r.isBuiltin,isUnderDevelopment:!!t,extensionLocation:r.location,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,publisherDisplayName:r.publisherDisplayName,...r.manifest}}class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,c){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,c){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$_G=i}),define(Ce[248],Ie([1,0,14,119,19,25,12,11]),function(oe,e,v,k,C,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=e.$1oc=e.$Zoc=e.$Yoc=e.$Xoc=e.$Woc=void 0,v=qe(v);class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(o,h,i,r){this.startup=o,this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=r}}e.$Woc=p;class a{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,h){return o===-1||h===-1?-1:h-o}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Xoc=a;class P{constructor(o,h,i,r,t,c){this.activationFailed=o,this.activationFailedError=h,this.activationTimes=i,this.module=r,this.exports=t,this.subscriptions=c}}e.$Yoc=P;class y extends P{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Zoc=y;class u extends P{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$1oc=u;class E extends P{constructor(o){super(!0,o,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let d=class{constructor(o,h,i,r){this.g=r,this.a=o,this.b=h,this.c=i,this.d=new C.$sn,this.f=Object.create(null)}dispose(){for(const[o,h]of this.d)h.dispose()}async waitForActivatingExtensions(){const o=[];for(const[h,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const h=this.d.get(o);return!!(h&&h.value)}getActivatedExtension(o){const h=this.d.get(o);if(!h||!h.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return h.value}async activateByEvent(o,h){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(r=>({id:r.identifier,reason:{startup:h,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,h){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:i.identifier,reason:h}])}async h(o){const h=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(h.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const h=this.a.getExtensionDescription(o.id);if(!h){const t=new Error(`Cannot activate unknown extension '${o.id.value}'`),c=this.k(o,null,[],new E(t));return this.c.onExtensionActivationError(o.id,t,new O.$4G(o.id.value)),c}const i=[],r=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const t of r){if(this.m(t))continue;const c=this.d.get(t);if(c){i.push(c);continue}if(this.l(t)){i.push(this.j({id:this.b.getExtensionDescription(t).identifier,reason:o.reason}));continue}const l=this.a.getExtensionDescription(t);if(l){if(!l.main&&!l.browser)continue;i.push(this.j({id:l.identifier,reason:o.reason}));continue}const g=h.displayName||h.identifier.value,m=new Error(`Cannot activate the '${g}' extension because it depends on unknown extension '${t}'`),$=this.k(o,h.displayName,[],new E(m));return this.c.onExtensionActivationError(h.identifier,m,new O.$4G(t)),$}return this.k(o,h.displayName,i,null)}k(o,h,i,r){const t=new n(o.id,h,o.reason,i,r,this.c,this.g);return this.d.set(o.id,t),t}l(o){return k.$Kcc.isHostExtension(o,this.a,this.b)}m(o){const h=this.b.getExtensionDescription(o);return h?!h.main&&!h.browser:!1}};e.$2oc=d,e.$2oc=d=Qe([Ve(3,A.$_j)],d);let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,h,i,r,t,c,l){this.c=o,this.d=h,this.f=i,this.g=r,this.h=t,this.j=c,this.k=l,this.a=new T.$Eh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const h=this.g[o];if(h.value&&!h.value.activationFailed){this.g.splice(o,1),o--;continue}if(h.value&&h.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);i.detail=h.value.activationFailedError,this.h=new E(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const h=new Error;if(o&&o.name&&(h.name=o.name),o&&o.message?h.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:h.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(h.stack=o.stack),this.h=new E(h),this.b&&v.$6(o))return;this.j.onExtensionActivationError(this.c,h,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};n=Qe([Ve(6,A.$_j)],n)});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[120],Ie([1,0,205,14,36,111,78,31,19,109,112,105]),function(oe,e,v,k,C,O,A,T,p,a,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=void 0,v=qe(v),C=ti(C);const u=T.$qo.as(A.$ro.JSONContribution);class E{constructor(t,c,l){this.a=t,this.b=c,this.c=l}d(t,c){this.a({type:t,message:c,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(C.default.Error,t)}warn(t){this.d(C.default.Warning,t)}info(t){this.d(C.default.Info,t)}}e.$UG=E;class d{static a(t){const c=new p.$rn;for(let l=0,g=t.length;l<g;l++)c.add(t[l].description.identifier);return c}static compute(t,c){if(!t||!t.length)return new d(c,[]);if(!c||!c.length)return new d([],t);const l=this.a(t),g=this.a(c),m=c.filter(S=>!l.has(S.description.identifier)),$=t.filter(S=>!g.has(S.description.identifier));return new d(m,$)}constructor(t,c){this.added=t,this.removed=c}}e.$VG=d;class n{constructor(t,c){this.name=t,this.defaultExtensionKind=c,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=d.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,k.$3)(t)}}}e.$WG=n;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(0,null),v.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$XG={properties:{engines:{type:"object",description:v.localize(2,null),properties:{vscode:{type:"string",description:v.localize(3,null),default:"^1.22.0"}}},publisher:{description:v.localize(4,null),type:"string"},displayName:{description:v.localize(5,null),type:"string"},categories:{description:v.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$pn},{type:"string",const:"Languages",deprecationMessage:v.localize(7,null)}]}},galleryBanner:{type:"object",description:v.localize(8,null),properties:{color:{description:v.localize(9,null),type:"string"},theme:{description:v.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(13,null)},enabledApiProposals:{markdownDescription:v.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(r=>r),markdownEnumDescriptions:Object.values(y.allApiProposals).map(r=>r.proposal)}},api:{markdownDescription:v.localize(15,null),type:"string",enum:["none"],enumDescriptions:[v.localize(16,null)]},activationEvents:{description:v.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(32,null)},{label:"onUri",body:"onUri",description:v.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(37,null)},{label:"onRenderer",description:v.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:v.localize(42,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:v.localize(43,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:v.localize(44,null)},{label:"*",description:v.localize(45,null),body:"*"}]}},badges:{type:"array",description:v.localize(46,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(47,null)},href:{type:"string",description:v.localize(48,null)},description:{type:"string",description:v.localize(49,null)}}}},markdown:{type:"string",description:v.localize(50,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(51,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(52,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$8o}},extensionPack:{description:v.localize(53,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$8o}},extensionKind:{description:v.localize(54,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(55,null)},{body:["workspace"],description:v.localize(56,null)},{body:["ui","workspace"],description:v.localize(57,null)},{body:["workspace","ui"],description:v.localize(58,null)},{body:[],description:v.localize(59,null)}]},capabilities:{description:v.localize(60,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(61,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(63,null),v.localize(64,null),v.localize(65,null)]},description:{type:"string",markdownDescription:v.localize(66,null)}}},untrustedWorkspaces:{description:v.localize(67,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(68,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(69,null),v.localize(70,null),v.localize(71,null)]},restrictedConfigurations:{description:v.localize(72,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(73,null)}}}}},sponsor:{description:v.localize(74,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(75,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(76,null),type:"string"},"vscode:uninstall":{description:v.localize(77,null),type:"string"}}},icon:{type:"string",description:v.localize(78,null)},l10n:{type:"string",description:v.localize(79,null)},pricing:{type:"string",markdownDescription:v.localize(80,null),enum:["Free","Trial"],default:"Free"}}};class h{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const c=new n(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,c),t.activationEventsGenerator&&P.$MG.register(t.extensionPoint,t.activationEventsGenerator),e.$XG.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema(o,e.$XG),c}getExtensionPoints(){return Array.from(this.a.values())}}e.$YG=h;const i={ExtensionsRegistry:"ExtensionsRegistry"};T.$qo.add(i.ExtensionsRegistry,new h),e.$ZG=T.$qo.as(i.ExtensionsRegistry),u.registerSchema(o,e.$XG),u.registerSchema(a.$tk,{properties:{extensionEnabledApiProposals:{description:v.localize(81,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(r=>r.proposal)}}]}}}})}),define(Ce[249],Ie([1,0,6,40,4,13,197,19,3,12,25,120]),function(oe,e,v,k,C,O,A,T,p,a,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cH=e.$bH=e.$aH=e.ChatMessageRole=void 0;var u;(function(n){n[n.System=0]="System",n[n.User=1]="User",n[n.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$aH=(0,p.$Fi)("ILanguageModelsService");const E={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(0,null)}}};e.$bH=y.$ZG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(1,null),oneOf:[E,{type:"array",items:E}]},activationEventsGenerator:(n,s)=>{for(const o of n)s.push(`onLanguageModelChat:${o.vendor}`)}});let d=class{constructor(s,o){this.e=s,this.f=o,this.a=new C.$Vc,this.b=new Map,this.c=new Set,this.d=this.a.add(new v.$me),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$bH.setHandler(h=>{this.c.clear();for(const r of h){if(!(0,P.$6G)(r.description,"chatProvider")){r.collector.error((0,A.localize)(2,null));continue}for(const t of k.Iterable.wrap(r.value)){if(this.c.has(t.vendor)){r.collector.error((0,A.localize)(3,null,t.vendor));continue}if((0,O.$df)(t.vendor)){r.collector.error((0,A.localize)(4,null));continue}if(t.vendor.trim()!==t.vendor){r.collector.error((0,A.localize)(5,null));continue}this.c.add(t.vendor)}}const i=[];for(const[r,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(r),i.push(r));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(s){return this.b.get(s)?.metadata}async selectLanguageModels(s){if(s.vendor)await this.e.activateByEvent(`onLanguageModelChat:${s.vendor}}`);else{const h=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(h)}const o=[];for(const[h,i]of this.b)(s.vendor===void 0||i.metadata.vendor===s.vendor)&&(s.family===void 0||i.metadata.family===s.family)&&(s.version===void 0||i.metadata.version===s.version)&&(s.identifier===void 0||i.metadata.id===s.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(r=>T.$qn.equals(r,s.extension)))&&o.push(h);return this.f.trace("[LM] selected language models",s,o),o}registerLanguageModelChat(s,o){if(this.f.trace("[LM] registering language model chat",s,o.metadata),!this.c.has(o.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${o.metadata.vendor}.`);if(this.b.has(s))throw new Error(`Chat response provider with identifier ${s} is already registered.`);return this.b.set(s,o),this.d.fire({added:[{identifier:s,metadata:o.metadata}]}),(0,C.$Uc)(()=>{this.b.delete(s)&&(this.d.fire({removed:[s]}),this.f.trace("[LM] UNregistered language model chat",s,o.metadata))})}async sendChatRequest(s,o,h,i,r){const t=this.b.get(s);if(!t)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return t.sendChatRequest(h,o,i,r)}computeTokenLength(s,o,h){const i=this.b.get(s);if(!i)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return i.provideTokenCount(o,h)}};e.$cH=d,e.$cH=d=Qe([Ve(0,P.$3G),Ve(1,a.$_j)],d)}),define(Ce[250],Ie([1,0,200,15,26,120,32,6]),function(oe,e,v,k,C,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HI=void 0,v=qe(v),k=qe(k),C=qe(C);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(2,null),default:""}}};var a;(function(u){function E(d,n,s){if(!d)return;const o=k.$fg(d.type)?d.type:void 0;if(!o||o.length===0){s.error(v.localize(3,null));return}const h=[];if(Array.isArray(d.required))for(const i of d.required)k.$fg(i)&&h.push(i);return{extensionId:n.value,taskType:o,required:h,properties:d.properties?C.$do(d.properties):{},when:d.when?A.$Dj.deserialize(d.when):void 0}}u.from=E})(a||(a={}));const P=O.$ZG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,E)=>{for(const d of u)d.type&&E.push(`onTaskType:${d.type}`)},jsonSchema:{description:v.localize(4,null),type:"array",items:p}});class y{constructor(){this.d=new T.$me,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,d)=>{P.setHandler((n,s)=>{this.c=void 0;try{for(const o of s.removed){const h=o.value;for(const i of h)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of s.added){const h=o.value;for(const i of h){const r=a.from(i,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const d of this.all()){const n={type:"object",additionalProperties:!1};d.required.length>0&&(n.required=d.required.slice(0)),d.properties!==void 0?n.properties=C.$do(d.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[d.taskType]},E.push(n)}this.c={oneOf:E}}return this.c}}e.$HI=new y}),define(Ce[251],Ie([1,0,201,15,24,26,32,250,43]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$RI=e.JsonSchemaVersion=e.ExecutionEngine=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$LI=e.ShellQuoting=e.$KI=e.$JI=e.$II=void 0,v=qe(v),k=qe(k),C=qe(C),O=qe(O),e.$II="settings",e.$JI=new A.$Wj("taskRunning",!1,v.localize(0,null)),e.$KI=v.localize2(2,"Tasks");var a;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(a||(e.ShellQuoting=a={})),e.$LI="$customized",function(F){function V(ae){if(!ae)return F.Strong;switch(ae.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=V}(a||(e.ShellQuoting=a={}));var P;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(P||(e.CommandOptions=P={}));var y;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(y||(e.RevealKind=y={})),function(F){function V(ae){switch(ae.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=V}(y||(e.RevealKind=y={}));var u;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(F){function V(ae){switch(ae.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=V}(u||(e.RevealProblemKind=u={}));var E;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(E||(e.PanelKind=E={})),function(F){function V(ae){switch(ae.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=V}(E||(e.PanelKind=E={}));var d;(function(F){F.defaults={echo:!0,reveal:y.Always,revealProblems:u.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var n;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(n||(e.RuntimeType=n={})),function(F){function V($e){switch($e.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=V;function ae($e){switch($e){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=ae}(n||(e.RuntimeType=n={}));var s;(function(F){function V(ae){return k.$fg(ae)?ae:ae.value}F.value=V})(s||(e.CommandString=s={}));var o;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function V($e){return $e===F.Clean._id||$e===F.Build._id||$e===F.Rebuild._id||$e===F.Test._id}F.is=V;function ae($e){if($e!==void 0)return k.$fg($e)?V($e)?{_id:$e,isDefault:!1}:void 0:$e}F.from=ae})(o||(e.TaskGroup=o={}));var h;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(h||(e.TaskScope=h={}));var i;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function V(ae){switch(ae){case F.User:return p.ConfigurationTarget.USER;case F.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}F.toConfigurationTarget=V})(i||(e.TaskSourceKind=i={}));var r;(function(F){F.parallel="parallel",F.sequence="sequence"})(r||(e.DependsOrder=r={}));var t;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var c;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(c||(e.RunOptions=c={}));class l{constructor(V,ae,$e,_,ge,se){this._label="",this._id=V,ae&&(this._label=ae),$e&&(this.type=$e),this.runOptions=_,this.configurationProperties=ge,this._source=se}getDefinition(V){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const V={folder:this.d(),id:this._id};return JSON.stringify(V)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(V,ae=!1){if(V===void 0)return!1;if(k.$fg(V))return V===this._label||V===this.configurationProperties.identifier||ae&&V===this._id;const $e=this.getDefinition(!0);return $e!==void 0&&$e._key===V._key}getQualifiedLabel(){const V=this.getWorkspaceFolder();return V?`${this._label} (${V.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(V){this.c===void 0&&(this.c=[]),V&&(this.c=this.c.concat(V))}get taskLoadMessages(){return this.c}}e.$MI=l;class g extends l{constructor(V,ae,$e,_,ge,se,ce,we){super(V,$e,void 0,ce,we,ae),this.command={},this._source=ae,this.hasDefinedMatchers=se,ge&&(this.command=ge)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(V=!1){if(V&&this._source.customizes!==void 0)return this._source.customizes;{let ae;switch(this.command?this.command.runtime:void 0){case n.Shell:ae="shell";break;case n.Process:ae="process";break;case n.CustomExecution:ae="customExecution";break;case void 0:ae="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ae,_key:this._id,id:this._id}}}static is(V){return V instanceof g}getMapKey(){const V=this._source.config.workspaceFolder;return V?`${V.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$II:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const V=this.d();if(!V)return;let ae=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(ae+=this._source.kind);const $e={type:e.$LI,folder:V,id:ae};return JSON.stringify($e)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$dh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(V){return new g(V._id,V._source,V._label,V.type,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$NI=g;class m extends l{constructor(V,ae,$e,_,ge,se,ce){super(V,$e,_,se,ce,ae),this._source=ae,this.configures=ge}static is(V){return V instanceof m}f(V){return V}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$dh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$II:this._source.config.workspaceFolder?.uri.toString()}getKey(){const V=this.d();if(!V)return;let ae=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(ae+=this._source.kind);const $e={type:e.$LI,folder:V,id:ae};return JSON.stringify($e)}}e.$OI=m;class $ extends l{constructor(V,ae,$e,_,ge,se,ce,we,re){super(V,$e,_,we,re,ae),this.defines=ge,this.hasDefinedMatchers=ce,this.command=se,this.icon=re.icon,this.hide=re.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(V){return V instanceof $}getMapKey(){const V=this._source.workspaceFolder;return V?`${this._source.scope.toString()}|${V.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===h.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const V={type:"contributed",scope:this._source.scope,id:this._id};return V.folder=this.d(),JSON.stringify(V)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(V){return new $(V._id,V._source,V._label,V.type,V.defines,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$PI=$;class S extends l{constructor(V,ae,$e,_,ge,se){super(V,$e,_,ge,se,ae),this._source=ae}clone(){return new S(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(V){return V instanceof S}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(V){return new S(V._id,V._source,V._label,V.type,V.runOptions,V.configurationProperties)}}e.$QI=S;var D;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(F){F._default=F.Terminal}(D||(e.ExecutionEngine=D={}));var b;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class I{constructor(V){this.c=new Map;for(let ae=0;ae<V.length;ae++)this.c.set(V[ae].uri.toString(),ae)}compare(V,ae){const $e=V.getWorkspaceFolder(),_=ae.getWorkspaceFolder();if($e&&_){let ge=this.c.get($e.uri.toString());ge=ge===void 0?0:ge+1;let se=this.c.get(_.uri.toString());return se=se===void 0?0:se+1,ge===se?V._label.localeCompare(ae._label):ge-se}else return!$e&&_?-1:$e&&!_?1:0}}e.$RI=I;var R;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(R||(e.TaskEventKind=R={}));var f;(function(F){F.SingleRun="singleRun",F.Background="background"})(f||(e.TaskRunType=f={}));var w;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var M;(function(F){function V(we){return{taskId:we._id,taskName:we.configurationProperties.name,runType:we.configurationProperties.isBackground?f.Background:f.SingleRun,group:we.configurationProperties.group,__task:we}}function ae(we,re,Pe){return{...V(we),kind:R.Start,terminalId:re,resolvedVariables:Pe}}F.start=ae;function $e(we,re,Pe){return{...V(we),kind:R.ProcessStarted,terminalId:re,processId:Pe}}F.processStarted=$e;function _(we,re,Pe){return{...V(we),kind:R.ProcessEnded,terminalId:re,exitCode:Pe}}F.processEnded=_;function ge(we,re,Pe){return{...V(we),kind:R.Terminated,exitReason:Pe,terminalId:re}}F.terminated=ge;function se(we,re,Pe){return{...V(re),kind:we,terminalId:Pe}}F.general=se;function ce(){return{kind:R.Changed}}F.changed=ce})(M||(e.TaskEvent=M={}));var N;(function(F){function V($e){const _=Object.keys($e).sort();let ge="";for(const se of _){let ce=$e[se];ce instanceof Object?ce=V(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),ge+=se+","+ce+","}return ge}function ae($e){const ge={_key:V($e),type:$e.taskType};return Object.assign(ge,$e),ge}F.create=ae})(N||(e.KeyedTaskIdentifier=N={}));var L;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(L||(e.TaskSettingId=L={}));var G;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(G||(e.TasksSchemaProperties=G={}));var W;(function(F){function V(ae,$e){const _=T.$HI.get(ae.type);if(_===void 0){const we=O.$do(ae);return delete we._key,N.create(we)}const ge=Object.create(null);ge.type=_.taskType;const se=new Set;_.required.forEach(we=>se.add(we));const ce=_.properties;for(const we of Object.keys(ce)){const re=ae[we];if(re!=null)ge[we]=re;else if(se.has(we)){const Pe=ce[we];if(Pe.default!==void 0)ge[we]=O.$do(Pe.default);else switch(Pe.type){case"boolean":ge[we]=!1;break;case"number":case"integer":ge[we]=0;break;case"string":ge[we]="";break;default:$e.error(v.localize(1,null,JSON.stringify(ae,void 0,0),we));return}}}return N.create(ge)}F.createTaskIdentifier=V})(W||(e.TaskDefinition=W={}))}),define(Ce[252],Ie([1,0,14]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=void 0;class k{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,T)=>{this.b=A,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,v.$3)(A))}then(A,T){return this.j().then(A,T)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$Occ=k;class C extends k{constructor(){super(),this.h=!0,this.i=new v.$7}}e.$Pcc=C}),define(Ce[39],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tw=e.$Qw=void 0,e.$Rw=C,e.$Sw=O;class v{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++v.count}}e.$Qw=v;const k=[];function C(T){const p=new v(T);return k[p.nid]=p,p}function O(T){return k[T].sid}class A{constructor(p){this.value=p}}e.$Tw=A}),define(Ce[5],Ie([1,0,39]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$tN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var k;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(k||(e.TextEditorRevealType=k={}));var C;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput",n[n.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(C||(e.TabInputKind=C={}));var O;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var A;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var T;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var p;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var a;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(a||(e.NotebookEditorRevealType=a={}));var P;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output",n[n.Hybrid=3]="Hybrid"})(P||(e.CandidatePortSource=P={}));class y{static{this.a=0}static mixin(s){return s._id=y.a++,s}}e.$tN=y;var u;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var E;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var d;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$uN={MainThreadAuthentication:(0,v.$Rw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$Rw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,v.$Rw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,v.$Rw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,v.$Rw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,v.$Rw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,v.$Rw)("MainThreadChatSkills"),MainThreadClipboard:(0,v.$Rw)("MainThreadClipboard"),MainThreadCommands:(0,v.$Rw)("MainThreadCommands"),MainThreadComments:(0,v.$Rw)("MainThreadComments"),MainThreadConfiguration:(0,v.$Rw)("MainThreadConfiguration"),MainThreadConsole:(0,v.$Rw)("MainThreadConsole"),MainThreadDebugService:(0,v.$Rw)("MainThreadDebugService"),MainThreadDecorations:(0,v.$Rw)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$Rw)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$Rw)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$Rw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$Rw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$Rw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$Rw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$Rw)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$Rw)("MainThreadErrors"),MainThreadTreeViews:(0,v.$Rw)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$Rw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$Rw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$Rw)("MainThreadLanguages"),MainThreadLogger:(0,v.$Rw)("MainThreadLogger"),MainThreadMessageService:(0,v.$Rw)("MainThreadMessageService"),MainThreadOutputService:(0,v.$Rw)("MainThreadOutputService"),MainThreadProgress:(0,v.$Rw)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$Rw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$Rw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$Rw)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$Rw)("MainThreadSecretState"),MainThreadStorage:(0,v.$Rw)("MainThreadStorage"),MainThreadSpeech:(0,v.$Rw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,v.$Rw)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$Rw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,v.$Rw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,v.$Rw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$Rw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$Rw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$Rw)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$Rw)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$Rw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$Rw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$Rw)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$Rw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,v.$Rw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,v.$Rw)("MainThreadExtensionService"),MainThreadSCM:(0,v.$Rw)("MainThreadSCM"),MainThreadSearch:(0,v.$Rw)("MainThreadSearch"),MainThreadShare:(0,v.$Rw)("MainThreadShare"),MainThreadTask:(0,v.$Rw)("MainThreadTask"),MainThreadWindow:(0,v.$Rw)("MainThreadWindow"),MainThreadLabelService:(0,v.$Rw)("MainThreadLabelService"),MainThreadNotebook:(0,v.$Rw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$Rw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$Rw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$Rw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$Rw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$Rw)("MainThreadInteractive"),MainThreadTheming:(0,v.$Rw)("MainThreadTheming"),MainThreadTunnelService:(0,v.$Rw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$Rw)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$Rw)("MainThreadTimeline"),MainThreadTesting:(0,v.$Rw)("MainThreadTesting"),MainThreadLocalization:(0,v.$Rw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$Rw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$Rw)("MainThreadAiEmbeddingVector")},e.$vN={ExtHostCommands:(0,v.$Rw)("ExtHostCommands"),ExtHostConfiguration:(0,v.$Rw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$Rw)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$Rw)("ExtHostDebugService"),ExtHostDecorations:(0,v.$Rw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$Rw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$Rw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$Rw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$Rw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$Rw)("ExtHostEditors"),ExtHostTreeViews:(0,v.$Rw)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$Rw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$Rw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$Rw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$Rw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$Rw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$Rw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$Rw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$Rw)("ExtHostStatusBar"),ExtHostShare:(0,v.$Rw)("ExtHostShare"),ExtHostExtensionService:(0,v.$Rw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$Rw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$Rw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,v.$Rw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,v.$Rw)("ExtHostSCM"),ExtHostSearch:(0,v.$Rw)("ExtHostSearch"),ExtHostTask:(0,v.$Rw)("ExtHostTask"),ExtHostWorkspace:(0,v.$Rw)("ExtHostWorkspace"),ExtHostWindow:(0,v.$Rw)("ExtHostWindow"),ExtHostWebviews:(0,v.$Rw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$Rw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$Rw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$Rw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$Rw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$Rw)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$Rw)("ExtHostProgress"),ExtHostComments:(0,v.$Rw)("ExtHostComments"),ExtHostSecretState:(0,v.$Rw)("ExtHostSecretState"),ExtHostStorage:(0,v.$Rw)("ExtHostStorage"),ExtHostUrls:(0,v.$Rw)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$Rw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$Rw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$Rw)("ExtHostOutputService"),ExtHostLabelService:(0,v.$Rw)("ExtHostLabelService"),ExtHostNotebook:(0,v.$Rw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$Rw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$Rw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$Rw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$Rw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$Rw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$Rw)("ExtHostInteractive"),ExtHostChatAgents2:(0,v.$Rw)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$Rw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,v.$Rw)("ExtHostChatSkills"),ExtHostChatProvider:(0,v.$Rw)("ExtHostChatProvider"),ExtHostSpeech:(0,v.$Rw)("ExtHostSpeech"),ExtHostEmbeddings:(0,v.$Rw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,v.$Rw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$Rw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$Rw)("ExtHostTheming"),ExtHostTunnelService:(0,v.$Rw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$Rw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$Rw)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$Rw)("ExtHostTimeline"),ExtHostTesting:(0,v.$Rw)("ExtHostTesting"),ExtHostTelemetry:(0,v.$Rw)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$Rw)("ExtHostLocalization")}}),define(Ce[85],Ie([1,0,3,12,5,17]),function(oe,e,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$loc=e.$koc=e.$joc=void 0,C=qe(C),e.$joc=(0,v.$Fi)("IExtHostApiDeprecationService");let A=class{constructor(p,a){this.c=a,this.a=new Set,this.b=p.getProxy(C.$uN.MainThreadTelemetry)}report(p,a,P){const y=this.d(p,a);this.a.has(y)||(this.a.add(y),a.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:a.identifier.value,apiId:p}))}d(p,a){return`${p}-${a.identifier.value}`}};e.$koc=A,e.$koc=A=Qe([Ve(0,O.$1P),Ve(1,k.$_j)],A),e.$loc=Object.freeze(new class{report(T,p,a){}})}),define(Ce[253],Ie([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=void 0;class k{constructor(O){const A=O.getProxy(v.$uN.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(T){return A.$writeText(T)}})}}e.$yoc=k}),define(Ce[254],Ie([1,0,26,5,27,17]),function(oe,e,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=void 0;let A=class{constructor(P,y){this.a=P.getProxy(k.$uN.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(P,y){const u=this,E=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){u.e(P,y,E,arguments)}})}e(P,y,u,E){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:p(E,this.b)}),this.c&&this.f(P,u,E)}};e.$uqc=A,e.$uqc=A=Qe([Ve(0,O.$1P),Ve(1,C.$eQ)],A);const T=1e5;function p(a,P){const y=[];if(a.length)for(let u=0;u<a.length;u++){let E=a[u];if(typeof E>"u")E="undefined";else if(E instanceof Error){const d=E;d.stack?E=d.stack:E=d.toString()}y.push(E)}if(P){const u=new Error().stack;u&&y.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,v.$io)(y);return u.length>T?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ce[255],Ie([1,0,2,5,25]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Apc=void 0;class O{constructor(T){this.a=T.getProxy(k.$uN.MainThreadDialogs)}showOpenDialog(T,p){return p?.allowUIResources&&(0,C.$7G)(T,"showLocal"),this.a.$showOpenDialog(p).then(a=>a?a.map(P=>v.URI.revive(P)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(p=>p?v.URI.revive(p):void 0)}}e.$Apc=O}),define(Ce[256],Ie([1,0,22,6,4,5]),function(oe,e,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=void 0;class A{constructor(p){this.b=new Map,this.c=new k.$me,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(O.$uN.MainThreadEmbeddings)}registerEmbeddingsProvider(p,a,P){if(this.d.has(a))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,a),this.b.set(y,{id:a,provider:P}),(0,C.$Uc)(()=>{this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings(p,a,P){P??=v.CancellationToken.None;let y=!1;typeof a=="string"&&(a=[a],y=!0);const u=await this.a.$computeEmbeddings(p,a,P);if(u.length!==a.length)throw new Error;if(y){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(p,a,P){const y=this.b.get(p);if(!y)return[];const u=await y.provider.provideEmbeddings(a,P);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$Dpc=A}),define(Ce[257],Ie([1,0,4,5]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(k.$uN.MainThreadLabelService)}$registerResourceLabelFormatter(A){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,A),(0,v.$Uc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$Upc=C}),define(Ce[86],Ie([1,0,21,13,2,3,12,5,27,17]),function(oe,e,v,k,C,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epc=e.$dpc=void 0;let P=class{constructor(u,E,d){this.f=d,this.d=new Map,this.a=E.getProxy(T.$uN.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===v.$g}getMessage(u,E){const{message:d,args:n,comment:s}=E;if(this.c)return(0,k.$ff)(d,n??{});let o=d;s&&s.length>0&&(o+=`/${Array.isArray(s)?s.join(""):s}`);const h=this.d.get(u)?.contents[o];return h||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,k.$ff)(h??d,n??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let E;const d=await this.g(u);if(!d){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(d),s=JSON.parse(n);E=u.isBuiltin?s.contents?.bundle:s}catch(n){this.f.error(`Failed to load translations for ${u.identifier.value} from ${d}: ${n.message}`);return}E&&this.d.set(u.identifier.value,{contents:E,uri:d})}async g(u){if(u.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return C.URI.revive(E)}return u.l10n?C.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$dpc=P,e.$dpc=P=Qe([Ve(0,p.$eQ),Ve(1,a.$1P),Ve(2,A.$_j)],P),e.$epc=(0,O.$Fi)("IExtHostLocalizationService")}),define(Ce[258],Ie([1,0,12,5,27,17,2,49]),function(oe,e,v,k,C,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tqc=void 0;let p=class extends v.$kk{constructor(y,u){super(u.logLevel,u.logsLocation,u.loggers.map(E=>(0,T.$ci)(E))),this.r=y.getProxy(k.$uN.MainThreadLogger)}$setLogLevel(y,u){u?this.setLogLevel(A.URI.revive(u),y):this.setLogLevel(y)}setVisibility(y,u){super.setVisibility(y,u),this.r.$setVisibility(y,u)}s(y,u,E){return new a(this.r,y,u,E)}};e.$tqc=p,e.$tqc=p=Qe([Ve(0,O.$1P),Ve(1,C.$eQ)],p);class a extends v.$fk{constructor(y,u,E,d){super(d?.logLevel==="always"),this.r=y,this.s=u,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(u,d).then(()=>{this.u(this.n),this.m=!0})}g(y,u){const E=[[y,u]];this.m?this.u(E):this.n.push(...E)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Ce[87],Ie([1,0,5,3,4,17,23]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gpc=e.$fpc=void 0,e.$fpc=(0,k.$Fi)("IExtHostManagedSockets");let T=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(v.$uN.MainThreadManagedSockets)}setFactory(y,u){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(y,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const u=++this.b,E=await this.c.makeConnection(),d=new C.$Vc;return this.d.set(u,new a(u,E,d)),d.add((0,C.$Uc)(()=>this.d.delete(u))),d.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),d.dispose()})),d.add(E.onDidClose(n=>{this.a.$onDidManagedSocketClose(u,n?.stack??n?.message),d.dispose()})),d.add(E.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(u,A.$Oe.wrap(n)))),u}$remoteSocketWrite(y,u){this.d.get(y)?.actual.send(u.buffer)}$remoteSocketEnd(y){const u=this.d.get(y);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$gpc=T,e.$gpc=T=Qe([Ve(0,O.$1P)],T);class p{constructor(y,u){this.socketFactoryId=y,this.makeConnection=u}}class a extends C.$Wc{constructor(y,u,E){super(),this.socketId=y,this.actual=u,this.B(E)}}}),define(Ce[259],Ie([1,0,5,12,25]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=void 0;function O(T){return T&&T.title}let A=class{constructor(p,a){this.b=a,this.a=p.getProxy(v.$uN.MainThreadMessageService)}showMessage(p,a,P,y,u){const E={source:{identifier:p.identifier,label:p.displayName||p.name}};let d;typeof y=="string"||O(y)?d=[y,...u]:(E.modal=y?.modal,E.useCustom=y?.useCustom,E.detail=y?.detail,d=u),E.useCustom&&(0,C.$7G)(p,"resolvers");const n=[];let s=!1;for(let o=0;o<d.length;o++){const h=d[o];if(typeof h=="string")n.push({title:h,handle:o,isCloseAffordance:!1});else if(typeof h=="object"){const{title:i,isCloseAffordance:r}=h;n.push({title:i,isCloseAffordance:!!r,handle:o}),r&&(s?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,h):s=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,h)}return this.a.$showMessage(a,P,E,n).then(o=>{if(typeof o=="number")return d[o]})}};e.$Wpc=A,e.$Wpc=A=Qe([Ve(1,k.$_j)],A)}),define(Ce[260],Ie([1,0,4,15,2,25,5]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=void 0;class T{constructor(a){this.b=new Map,this.a=a.getProxy(A.$uN.MainThreadProfileContentHandlers)}registerProfileContentHandler(a,P,y){if((0,O.$7G)(a,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,y),this.a.$registerProfileContentHandler(P,y.name,y.description,a.identifier.value),(0,v.$Uc)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(a,P,y,u){const E=this.b.get(a);if(!E)throw new Error(`Unknown handler with id: ${a}`);return E.saveProfile(P,y,u)}async $readProfile(a,P,y){const u=this.b.get(a);if(!u)throw new Error(`Unknown handler with id: ${a}`);return u.readProfile((0,k.$fg)(P)?P:C.URI.revive(P),y)}}e.$6pc=T}),define(Ce[88],Ie([1,0,5,6,3]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=e.$apc=void 0;class O{constructor(T){this.b=new k.$me,this.onDidChangePassword=this.b.event,this.a=T.getProxy(v.$uN.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,p){return this.a.$getPassword(T,p)}store(T,p,a){return this.a.$setPassword(T,p,a)}delete(T,p){return this.a.$deletePassword(T,p)}}e.$apc=O,e.$bpc=(0,C.$Fi)("IExtHostSecretState")}),define(Ce[261],Ie([1,0,22,4,5]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aqc=void 0;class O{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(C.$uN.MainThreadSpeech)}async $createSpeechToTextSession(T,p,a){const P=this.c.get(T);if(!P)return;const y=new k.$Vc,u=new v.$xe;this.d.set(p,u);const E=await P.provideSpeechToTextSession(u.token,a?{language:a}:void 0);E&&(y.add(E.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,d)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,p,a){const P=this.c.get(T);if(!P)return;const y=new k.$Vc,u=new v.$xe;this.d.set(p,u);const E=await P.provideTextToSpeechSession(u.token,a?{language:a}:void 0);E&&(this.f.set(p,E),y.add(E.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,d)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(T,p){this.f.get(T)?.synthesize(p)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,p){const a=this.c.get(T);if(!a)return;const P=new k.$Vc,y=new v.$xe;this.d.set(p,y);const u=await a.provideKeywordRecognitionSession(y.token);u&&(P.add(u.onDidChange(E=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,E)})),P.add(y.token.onCancellationRequested(()=>P.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,p,a){const P=O.a++;return this.c.set(P,a),this.b.$registerProvider(P,p,{extension:T,displayName:T.value}),(0,k.$Uc)(()=>{this.b.$unregisterProvider(P),this.c.delete(P)})}}e.$aqc=O}),define(Ce[89],Ie([1,0,5,6,3]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4oc=e.$3oc=void 0;class O{constructor(T,p){this.c=p,this.b=new k.$me,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(v.$uN.MainThreadStorage)}registerExtensionStorageKeysToSync(T,p){this.a.$registerExtensionStorageKeysToSync(T,p)}async initializeExtensionStorage(T,p,a){const P=await this.a.$initializeExtensionStorage(T,p);let y;return P&&(y=this.d(T,p,P)),y||a}setValue(T,p,a){return this.a.$setValue(T,p,a)}$acceptValue(T,p,a){const P=this.d(T,p,a);P&&this.b.fire({shared:T,key:p,value:P})}d(T,p,a){try{return JSON.parse(a)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${T}): ${P}`)}}}e.$3oc=O,e.$4oc=(0,C.$Fi)("IExtHostStorage")}),define(Ce[262],Ie([1,0,4,16,2,5]),function(oe,e,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mqc=void 0;class A{static{this.a=new Set([k.Schemas.http,k.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(O.$uN.MainThreadUriOpeners)}registerExternalUriOpener(p,a,P,y){if(this.c.has(a))throw new Error(`Opener with id '${a}' already registered`);const u=y.schemes.find(E=>!A.a.has(E));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(a,P),this.b.$registerUriOpener(a,y.schemes,p,y.label),(0,v.$Uc)(()=>{this.c.delete(a),this.b.$unregisterUriOpener(a)})}async $canOpenUri(p,a,P){const y=this.c.get(p);if(!y)throw new Error(`Unknown opener with id: ${p}`);const u=C.URI.revive(a);return y.canOpenExternalUri(u,P)}async $openUri(p,a,P){const y=this.c.get(p);if(!y)throw new Error(`Unknown opener id: '${p}'`);return y.openExternalUri(C.URI.revive(a.resolvedUri),{sourceUri:C.URI.revive(a.sourceUri)},P)}}e.$mqc=A}),define(Ce[263],Ie([1,0,5,2,4,14,19]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nqc=void 0;class T{static{this.a=0}constructor(a){this.c=new A.$rn,this.d=new Map,this.b=a.getProxy(v.$uN.MainThreadUrls)}registerUriHandler(a,P){const y=a.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const u=T.a++;return this.c.add(y),this.d.set(u,P),this.b.$registerUriHandler(u,y,a.displayName||a.name),(0,C.$Uc)(()=>{this.c.delete(y),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(a,P){const y=this.d.get(a);if(!y)return Promise.resolve(void 0);try{y.handleUri(k.URI.revive(P))}catch(u){(0,O.$3)(u)}return Promise.resolve(void 0)}async createAppUri(a){return k.URI.revive(await this.b.$createAppUri(a))}}e.$nqc=T}),define(Ce[264],Ie([1,0,23,5]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vtb=O,e.$wtb=T,k=qe(k);class C{constructor(){this.buffers=[]}add(a){let P=this.buffers.indexOf(a);return P<0&&(P=this.buffers.length,this.buffers.push(a)),P}}function O(p,a){if(a.serializeBuffersForPostMessage){const P=new C,u=JSON.stringify(p,(d,n)=>{if(n instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:P.add(n)};if(ArrayBuffer.isView(n)){const s=A(n);if(s)return{$$vscode_array_buffer_reference$$:!0,index:P.add(n.buffer),view:{type:s,byteLength:n.byteLength,byteOffset:n.byteOffset}}}return n}),E=P.buffers.map(d=>{const n=new Uint8Array(d);return v.$Oe.wrap(n)});return{message:u,buffers:E}}else return{message:JSON.stringify(p),buffers:[]}}function A(p){switch(p.constructor.name){case"Int8Array":return k.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return k.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return k.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return k.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return k.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return k.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return k.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return k.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return k.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return k.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return k.WebviewMessageArrayBufferViewType.BigUint64Array}}function T(p,a){const P=a.map(E=>{const d=new ArrayBuffer(E.byteLength);return new Uint8Array(d).set(E.buffer),d}),y=a.length?(E,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const n=d,{index:s}=n,o=P[s];if(n.view)switch(n.view.type){case k.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(o,n.view.byteOffset,n.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(o,n.view.byteOffset,n.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(o,n.view.byteOffset,n.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(o,n.view.byteOffset,n.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(o,n.view.byteOffset,n.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(o,n.view.byteOffset,n.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(o,n.view.byteOffset,n.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(o,n.view.byteOffset,n.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(o,n.view.byteOffset,n.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(o,n.view.byteOffset,n.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(o,n.view.byteOffset,n.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return d}:void 0;return{message:JSON.parse(p,y),arrayBuffers:P}}}),define(Ce[68],Ie([1,0,6,4,16,26,2,216,264,83,5]),function(oe,e,v,k,C,O,A,T,p,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Poc=e.$Noc=void 0,e.$Ooc=u,e.$Qoc=n,e.$Roc=s,O=qe(O),P=qe(P);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,t,c,l,g,m,$){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new v.$me,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$me,this._onDidDispose=this.#h.event,this.#e=r,this.#t=t,this.#o=c,this.#n=l,this.#s=g,this.#r=m,this.#l=u(m),this.#d=E(m),this.#i=$}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,a.$dDb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===C.Schemas.https||r.scheme===C.Schemas.http){let t=r.toString();return t.endsWith("/")||(t+="/"),t+" "+a.$cDb}return a.$cDb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),O.$ho(this.#o,r)||this.#t.$setOptions(this.#e,s(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const t=(0,p.$vtb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const t=this.#r.extensionLocation?.scheme===C.Schemas.vscodeRemote,c=this.#r.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,g,m,$,S,D)=>{const b=A.URI.from({scheme:$||"file",path:decodeURIComponent(S)}),I=(0,a.$dDb)(b,{isRemote:t,authority:c}).toString();return`${g}${I}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,g,m,$,S,D)=>{const b=A.URI.from({scheme:$||"file",path:decodeURIComponent(S)}),I=(0,a.$dDb)(b,{isRemote:t,authority:c}).toString();return`${g}${I}${D}`})}}e.$Noc=y;function u(i){try{const r=(0,T.$Yp)((0,T.$Xp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function E(i){try{const r=(0,T.$Yp)((0,T.$Xp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class d extends k.$Wc{constructor(r,t,c,l,g){super(),this.c=t,this.f=c,this.g=l,this.h=g,this.b=new Map,this.a=r.getProxy(P.$uN.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,t,c){const l=this.j(r);if(l){const{message:g}=(0,p.$wtb)(t,c.value);l._onMessageEmitter.fire(g)}}$onMissingCsp(r,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,t,c){const l=new y(r,this.a,o(t),this.c,this.f,c,this.h);this.b.set(r,l);const g=l._onDidDispose(()=>{g.dispose(),this.deleteWebview(r)});return l}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$Poc=d;function n(i){return{id:i.identifier,location:i.extensionLocation}}function s(i,r,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||h(i,r)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>A.URI.from(r))}}function h(i,r){return[...(r?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Ce[121],Ie([1,0,6,16,13,2,3,17,5]),function(oe,e,v,k,C,O,A,T,p){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$qqc=e.$pqc=void 0;let P=class{static{a=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new v.$me,this.onDidChangeWindowState=this.c.event,this.d=a.a,this.b=u.getProxy(p.$uN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:E,isActive:d})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,E){E!==this.d[u]&&(this.d={...this.d,[u]:E},this.c.fire(this.d))}openUri(u,E){let d;if(typeof u=="string"){d=u;try{u=O.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,C.$df)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===k.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,d,E)}async asExternalUri(u,E){if((0,C.$df)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(u,E);return O.URI.from(d)}};e.$pqc=P,e.$pqc=P=a=Qe([Ve(0,T.$1P)],P),e.$qqc=(0,A.$Fi)("IExtHostWindow")}),define(Ce[265],Ie([1,0,254,27,17]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Esc=void 0;let O=class extends v.$uqc{constructor(T,p){super(T,p)}f(T,p,a){p.apply(console,a)}};e.$Esc=O,e.$Esc=O=Qe([Ve(0,C.$1P),Ve(1,k.$eQ)],O)}),define(Ce[266],Ie([1,0,11,23,22,28,14,6,4,38,161,252,39]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Qcc=h,e.$Rcc=i,A=qe(A);function d(M,N){try{return JSON.stringify(M,N)}catch{return"null"}}const n="$$ref$$",s={[n]:-1};class o{constructor(N,L){this.jsonString=N,this.referencedBuffers=L}}function h(M,N=null,L=!1){const G=[];return{jsonString:(L?d:JSON.stringify)(M,(F,V)=>{if(typeof V>"u")return s;if(typeof V=="object"){if(V instanceof k.$Oe){const ae=G.push(V)-1;return{[n]:ae}}if(N)return N(F,V)}return V}),referencedBuffers:G}}function i(M,N,L){return JSON.parse(M,(G,W)=>{if(W){const F=W[n];if(typeof F=="number")return N[F];if(L&&W.$mid===a.MarshalledId.Uri)return L.transformIncoming(W)}return W})}function r(M,N){return JSON.stringify(M,N)}function t(M){return M?(N,L)=>L&&L.$mid===a.MarshalledId.Uri?M.transformOutgoing(L):L:null}var c;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var l;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const g=()=>{},m=Symbol.for("rpcProtocol"),$=Symbol.for("rpcProxy");class S extends p.$Wc{static{E=m}static{this.a=3*1e3}constructor(N,L=null,G=null){super(),this[E]=!0,this.b=this.B(new T.$me),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=L,this.g=G,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,F=u.$Qw.count;W<F;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=l.Responsive,this.z=0,this.C=0,this.D=this.B(new v.$Rh(()=>this.H(),1e3)),this.B(this.c.onMessage(W=>this.L(W)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const L=this.w[N];delete this.w[N],L.resolveErr(A.$8())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+S.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+S.a,this.z--,this.z===0&&this.D.cancel(),this.I(l.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(l.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,P.$On)(N,this.g):N}getProxy(N){const{nid:L,sid:G}=N;return this.s[L]||(this.s[L]=this.J(L,G)),this.s[L]}J(N,L){const G={get:(W,F)=>(typeof F=="string"&&!W[F]&&F.charCodeAt(0)===O.CharCode.DollarSign&&(W[F]=(...V)=>this.U(N,F,V)),F===$?L:W[F])};return new Proxy(Object.create(null),G)}set(N,L){return this.m[N.nid]=L,L}assertRegistered(N){for(let L=0,G=N.length;L<G;L++){const W=N[L];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(N){if(this.j)return;const L=N.byteLength,G=b.read(N,0),W=G.readUInt8(),F=G.readUInt32();switch(W){case f.RequestJSONArgs:case f.RequestJSONArgsWithCancellation:{let{rpcId:V,method:ae,args:$e}=R.deserializeRequestJSONArgs(G);this.g&&($e=(0,P.$On)($e,this.g)),this.M(L,F,V,ae,$e,W===f.RequestJSONArgsWithCancellation);break}case f.RequestMixedArgs:case f.RequestMixedArgsWithCancellation:{let{rpcId:V,method:ae,args:$e}=R.deserializeRequestMixedArgs(G);this.g&&($e=(0,P.$On)($e,this.g)),this.M(L,F,V,ae,$e,W===f.RequestMixedArgsWithCancellation);break}case f.Acknowledged:{this.f?.logIncoming(L,F,c.LocalSide,"ack"),this.G(F);break}case f.Cancel:{this.N(L,F);break}case f.ReplyOKEmpty:{this.O(L,F,void 0);break}case f.ReplyOKJSON:{let V=R.deserializeReplyOKJSON(G);this.g&&(V=(0,P.$On)(V,this.g)),this.O(L,F,V);break}case f.ReplyOKJSONWithBuffers:{const V=R.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(L,F,V);break}case f.ReplyOKVSBuffer:{const V=R.deserializeReplyOKVSBuffer(G);this.O(L,F,V);break}case f.ReplyErrError:{let V=R.deserializeReplyErrError(G);this.g&&(V=(0,P.$On)(V,this.g)),this.P(L,F,V);break}case f.ReplyErrEmpty:{this.P(L,F,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,L,G,W,F,V){this.f?.logIncoming(N,L,c.OtherSide,`receiveRequest ${(0,u.$Sw)(G)}.${W}(`,F);const ae=String(L);let $e,_;if(V){const se=new C.$xe;F.push(se.token),$e=this.Q(G,W,F),_=()=>se.cancel()}else $e=this.Q(G,W,F),_=g;this.u[ae]=_;const ge=R.serializeAcknowledged(L);this.f?.logOutgoing(ge.byteLength,L,c.OtherSide,"ack"),this.c.send(ge),$e.then(se=>{delete this.u[ae];const ce=R.serializeReplyOK(L,se,this.h);this.f?.logOutgoing(ce.byteLength,L,c.OtherSide,"reply:",se),this.c.send(ce)},se=>{delete this.u[ae];const ce=R.serializeReplyErr(L,se);this.f?.logOutgoing(ce.byteLength,L,c.OtherSide,"replyErr:",se),this.c.send(ce)})}N(N,L){this.f?.logIncoming(N,L,c.OtherSide,"receiveCancel");const G=String(L);this.u[G]?.()}O(N,L,G){this.f?.logIncoming(N,L,c.LocalSide,"receiveReply:",G);const W=String(L);if(!this.w.hasOwnProperty(W))return;const F=this.w[W];delete this.w[W],F.resolveOk(G)}P(N,L,G){this.f?.logIncoming(N,L,c.LocalSide,"receiveReplyErr:",G);const W=String(L);if(!this.w.hasOwnProperty(W))return;const F=this.w[W];delete this.w[W];let V;G&&(G.$isError?(V=new Error,V.name=G.name,V.message=G.message,V.stack=G.stack):V=G),F.resolveErr(V)}Q(N,L,G){try{return Promise.resolve(this.S(N,L,G))}catch(W){return Promise.reject(W)}}S(N,L,G){const W=this.m[N];if(!W)throw new Error("Unknown actor "+(0,u.$Sw)(N));const F=W[L];if(typeof F!="function")throw new Error("Unknown method "+L+" on actor "+(0,u.$Sw)(N));return F.apply(W,G)}U(N,L,G){if(this.j)return new y.$Pcc;let W=null;if(G.length>0&&C.CancellationToken.isCancellationToken(G[G.length-1])&&(W=G.pop()),W&&W.isCancellationRequested)return Promise.reject(A.$8());const F=R.serializeRequestArguments(G,this.h),V=++this.t,ae=String(V),$e=new y.$Occ,_=new p.$Vc;W&&_.add(W.onCancellationRequested(()=>{const se=R.serializeCancel(V);this.f?.logOutgoing(se.byteLength,V,c.LocalSide,"cancel"),this.c.send(R.serializeCancel(V))})),this.w[ae]=new D($e,_),this.F(V);const ge=R.serializeRequest(V,N,L,F,!!W);return this.f?.logOutgoing(ge.byteLength,V,c.LocalSide,`request: ${(0,u.$Sw)(N)}.${L}(`,G),this.c.send(ge),$e}}e.$Scc=S;class D{constructor(N,L){this.a=N,this.b=L}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class b{static alloc(N,L,G){const W=new b(k.$Oe.alloc(G+1+4),0);return W.writeUInt8(N),W.writeUInt32(L),W}static read(N,L){return new b(N,L)}get buffer(){return this.a}constructor(N,L){this.a=N,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+N).toString();return this.b+=N,G}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+N).toString();return this.b+=N,G}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+N);return this.b+=N,L}static sizeMixedArray(N){let L=0;L+=1;for(let G=0,W=N.length;G<W;G++){const F=N[G];switch(L+=1,F.type){case w.String:L+=this.sizeLongString(F.value);break;case w.VSBuffer:L+=this.sizeVSBuffer(F.value);break;case w.SerializedObjectWithBuffers:L+=this.sizeUInt32,L+=this.sizeLongString(F.value);for(let V=0;V<F.buffers.length;++V)L+=this.sizeVSBuffer(F.buffers[V]);break;case w.Undefined:break}}return L}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let L=0,G=N.length;L<G;L++){const W=N[L];switch(W.type){case w.String:this.writeUInt8(w.String),this.writeLongString(W.value);break;case w.VSBuffer:this.writeUInt8(w.VSBuffer),this.writeVSBuffer(W.value);break;case w.SerializedObjectWithBuffers:this.writeUInt8(w.SerializedObjectWithBuffers),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let F=0;F<W.buffers.length;++F)this.writeBuffer(W.buffers[F]);break;case w.Undefined:this.writeUInt8(w.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const L=new Array(N);for(let G=0;G<N;G++)switch(this.readUInt8()){case w.String:L[G]=this.readLongString();break;case w.VSBuffer:L[G]=this.readVSBuffer();break;case w.SerializedObjectWithBuffers:{const F=this.readUInt32(),V=this.readLongString(),ae=[];for(let $e=0;$e<F;++$e)ae.push(this.readVSBuffer());L[G]=new u.$Tw(i(V,ae,null));break}case w.Undefined:L[G]=void 0;break}return L}}var I;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(I||(I={}));class R{static a(N){for(let L=0,G=N.length;L<G;L++)if(N[L]instanceof k.$Oe||N[L]instanceof u.$Tw||typeof N[L]>"u")return!0;return!1}static serializeRequestArguments(N,L){if(this.a(N)){const G=[];for(let W=0,F=N.length;W<F;W++){const V=N[W];if(V instanceof k.$Oe)G[W]={type:w.VSBuffer,value:V};else if(typeof V>"u")G[W]={type:w.Undefined};else if(V instanceof u.$Tw){const{jsonString:ae,referencedBuffers:$e}=h(V.value,L);G[W]={type:w.SerializedObjectWithBuffers,value:k.$Oe.fromString(ae),buffers:$e}}else G[W]={type:w.String,value:k.$Oe.fromString(r(V,L))}}return{type:I.Mixed,args:G}}return{type:I.Simple,args:r(N,L)}}static serializeRequest(N,L,G,W,F){switch(W.type){case I.Simple:return this.b(N,L,G,W.args,F);case I.Mixed:return this.c(N,L,G,W.args,F)}}static b(N,L,G,W,F){const V=k.$Oe.fromString(G),ae=k.$Oe.fromString(W);let $e=0;$e+=b.sizeUInt8(),$e+=b.sizeShortString(V),$e+=b.sizeLongString(ae);const _=b.alloc(F?f.RequestJSONArgsWithCancellation:f.RequestJSONArgs,N,$e);return _.writeUInt8(L),_.writeShortString(V),_.writeLongString(ae),_.buffer}static deserializeRequestJSONArgs(N){const L=N.readUInt8(),G=N.readShortString(),W=N.readLongString();return{rpcId:L,method:G,args:JSON.parse(W)}}static c(N,L,G,W,F){const V=k.$Oe.fromString(G);let ae=0;ae+=b.sizeUInt8(),ae+=b.sizeShortString(V),ae+=b.sizeMixedArray(W);const $e=b.alloc(F?f.RequestMixedArgsWithCancellation:f.RequestMixedArgs,N,ae);return $e.writeUInt8(L),$e.writeShortString(V),$e.writeMixedArray(W),$e.buffer}static deserializeRequestMixedArgs(N){const L=N.readUInt8(),G=N.readShortString(),W=N.readMixedArray(),F=new Array(W.length);for(let V=0,ae=W.length;V<ae;V++){const $e=W[V];typeof $e=="string"?F[V]=JSON.parse($e):F[V]=$e}return{rpcId:L,method:G,args:F}}static serializeAcknowledged(N){return b.alloc(f.Acknowledged,N,0).buffer}static serializeCancel(N){return b.alloc(f.Cancel,N,0).buffer}static serializeReplyOK(N,L,G){if(typeof L>"u")return this.d(N);if(L instanceof k.$Oe)return this.e(N,L);if(L instanceof u.$Tw){const{jsonString:W,referencedBuffers:F}=h(L.value,G,!0);return this.g(N,W,F)}else return this.f(N,d(L,G))}static d(N){return b.alloc(f.ReplyOKEmpty,N,0).buffer}static e(N,L){let G=0;G+=b.sizeVSBuffer(L);const W=b.alloc(f.ReplyOKVSBuffer,N,G);return W.writeVSBuffer(L),W.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,L){const G=k.$Oe.fromString(L);let W=0;W+=b.sizeLongString(G);const F=b.alloc(f.ReplyOKJSON,N,W);return F.writeLongString(G),F.buffer}static g(N,L,G){const W=k.$Oe.fromString(L);let F=0;F+=b.sizeUInt32,F+=b.sizeLongString(W);for(const ae of G)F+=b.sizeVSBuffer(ae);const V=b.alloc(f.ReplyOKJSONWithBuffers,N,F);V.writeUInt32(G.length),V.writeLongString(W);for(const ae of G)V.writeBuffer(ae);return V.buffer}static deserializeReplyOKJSON(N){const L=N.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(N,L){const G=N.readUInt32(),W=N.readLongString(),F=[];for(let V=0;V<G;++V)F.push(N.readVSBuffer());return new u.$Tw(i(W,F,L))}static serializeReplyErr(N,L){const G=L?d(A.$5(L),null):void 0;if(typeof G!="string")return this.h(N);const W=k.$Oe.fromString(G);let F=0;F+=b.sizeLongString(W);const V=b.alloc(f.ReplyErrError,N,F);return V.writeLongString(W),V.buffer}static deserializeReplyErrError(N){const L=N.readLongString();return JSON.parse(L)}static h(N){return b.alloc(f.ReplyErrEmpty,N,0).buffer}}var f;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var w;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(w||(w={}))}),define(Ce[267],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gsc=void 0;const v=function(O){const A=T=>{globalThis.removeEventListener("message",A);const p=T.data;Object.defineProperties(globalThis,{postMessage:{value(a,P){p.postMessage(a,P)}},onmessage:{get(){return p.onmessage},set(a){p.onmessage=a}}}),p.addEventListener("message",a=>{globalThis.dispatchEvent(new MessageEvent("message",{data:a.data,ports:a.ports?[...a.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",A)}.toString();class k extends EventTarget{constructor(O,A,T){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${v})('${A}'))`,a=new Blob([p],{type:"application/javascript"}),P=URL.createObjectURL(a),y=new MessageChannel,u=P,E={type:"_newWorker",id:u,port:y.port2,url:P,options:T};O(E,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{O({type:"_terminateWorker",id:u}),URL.revokeObjectURL(P),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(d){y.port1.onmessage=d}},onmessageerror:{get(){return y.port1.onmessageerror},set(d){y.port1.onmessageerror=d}}}),y.port1.addEventListener("messageerror",d=>{const n=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(n)}),y.port1.addEventListener("message",d=>{const n=new MessageEvent("message",{data:d.data});this.dispatchEvent(n)}),y.port1.start()}}e.$Gsc=k}),define(Ce[268],Ie([1,0,23,29,16,61,3]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TK=e.$QK=void 0,e.$RK=P,e.$SK=y,e.$QK=(0,A.$Fi)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${T.join("")}]+`),a=7;function P(E){if(E.scheme!==C.Schemas.vscodeNotebookCell)return;const d=E.fragment.indexOf("s");if(d<0)return;const n=parseInt(E.fragment.substring(0,d).replace(p,""),a),s=(0,v.$8e)(E.fragment.substring(d+1)).toString();if(!isNaN(n))return{handle:n,notebook:E.with({scheme:s,fragment:null})}}function y(E,d){const n=d.toString(a),o=`${n.length<T.length?T[n.length-1]:"z"}${n}s${(0,v.$9e)(v.$Oe.fromString(E.scheme),!0,!0)}`;return E.with({scheme:C.Schemas.vscodeNotebookCell,fragment:o})}class u{constructor(){this.a=new k.$Cc}getNotebook(d){if(d.scheme===C.Schemas.vscodeNotebookCell){const n=P(d);if(n){const s=this.a.get(n.notebook);if(s)return s}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$TK=u,(0,O.$Os)(e.$QK,u,O.InstantiationType.Delayed)}),define(Ce[90],Ie([1,0,23,42,40,73,16,20,21,32,268]),function(oe,e,v,k,C,O,A,T,p,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.$yL=e.CellStatusbarAlignment=e.$xL=e.NotebookEditorPriority=e.$uL=e.$tL=e.$rL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$qL=e.$pL=e.$oL=e.$nL=e.CellKind=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=void 0,e.$sL=l,e.$vL=m,e.$wL=$,e.$zL=b,e.$AL=R,k=qe(k),e.$iL="workbench.editor.notebook",e.$jL="workbench.editor.notebookTextDiffEditor",e.$kL="workbench.editor.interactive",e.$lL="workbench.editor.repl",e.$mL="replNotebook.input.execute";var y;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(y||(e.CellKind=y={})),e.$nL=["application/json","application/javascript","text/html","image/svg+xml",O.$8s.latex,O.$8s.markdown,"image/png","image/jpeg",O.$8s.text],e.$oL=[O.$8s.latex,O.$8s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$8s.text],e.$pL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$qL="_notAvailable";var u;(function(V){V[V.Running=1]="Running",V[V.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var E;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var d;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var n;(function(V){V[V.WithHardKernelDependency=0]="WithHardKernelDependency",V[V.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",V[V.Pure=2]="Pure",V[V.Never=3]="Never"})(n||(e.NotebookRendererMatch=n={}));var s;(function(V){V.Always="always",V.Never="never",V.Optional="optional"})(s||(e.RendererMessagingSpec=s={}));var o;(function(V){V[V.ModelChange=1]="ModelChange",V[V.Move=2]="Move",V[V.ChangeCellLanguage=5]="ChangeCellLanguage",V[V.Initialize=6]="Initialize",V[V.ChangeCellMetadata=7]="ChangeCellMetadata",V[V.Output=8]="Output",V[V.OutputItem=9]="OutputItem",V[V.ChangeCellContent=10]="ChangeCellContent",V[V.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",V[V.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",V[V.ChangeCellMime=13]="ChangeCellMime",V[V.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var h;(function(V){V[V.Handle=0]="Handle",V[V.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var i;(function(V){V[V.Replace=1]="Replace",V[V.Output=2]="Output",V[V.Metadata=3]="Metadata",V[V.CellLanguage=4]="CellLanguage",V[V.DocumentMetadata=5]="DocumentMetadata",V[V.Move=6]="Move",V[V.OutputItems=7]="OutputItems",V[V.PartialMetadata=8]="PartialMetadata",V[V.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(V){V.scheme=A.Schemas.vscodeNotebookCell;function ae(we,re){return(0,P.$SK)(we,re)}V.generate=ae;function $e(we){return(0,P.$RK)(we)}V.parse=$e;function _(we,re){return we.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${re??""},${we.scheme!==A.Schemas.file?we.scheme:""}`})}V.generateCellOutputUri=_;function ge(we){if(we.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const re=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(we.fragment);if(!re)return;const Pe=re[1]&&re[1]!==""?re[1]:void 0,Me=re[2];return{outputId:Pe,notebook:we.with({scheme:Me||A.Schemas.file,fragment:null})}}V.parseCellOutputUri=ge;function se(we,re,Pe){return V.generate(we,re).with({scheme:Pe})}V.generateCellPropertyUri=se;function ce(we,re){if(we.scheme===re)return V.parse(we.with({scheme:V.scheme}))}V.parseCellPropertyUri=ce})(r||(e.CellUri=r={}));const t=V=>p.$i?V.replace(/\//g,"\\"):V;class c{constructor(ae=[],$e=e.$nL){this.e=$e,this.d=[...new Set(ae)].map(_=>({pattern:_,matches:k.$zk(t(_))}))}sort(ae){const $e=new Map(C.Iterable.map(ae,ge=>[ge,t(ge)]));let _=[];for(const{matches:ge}of this.d)for(const[se,ce]of $e)if(ge(ce)){_.push(se),$e.delete(se);break}return $e.size&&(_=_.concat([...$e.keys()].sort((ge,se)=>this.e.indexOf(ge)-this.e.indexOf(se)))),_}prioritize(ae,$e){const _=this.f(ae);if(_===-1){this.d.unshift({pattern:ae,matches:k.$zk(t(ae))});return}const ge=new Set($e.map(ce=>this.f(ce,_)));ge.delete(-1);const se=Array.from(ge).sort();this.d.splice(_+1,0,...se.map(ce=>this.d[ce]));for(let ce=se.length-1;ce>=0;ce--)this.d.splice(se[ce],1)}toArray(){return this.d.map(ae=>ae.pattern)}f(ae,$e=this.d.length){const _=t(ae);for(let ge=0;ge<$e;ge++)if(this.d[ge].matches(_))return ge;return-1}}e.$rL=c;function l(V,ae,$e,_=(ge,se)=>ge===se){const ge=[];function se(re,Pe,Me){if(Pe===0&&Me.length===0)return;const Y=ge[ge.length-1];Y&&Y.start+Y.deleteCount===re?(Y.deleteCount+=Pe,Y.toInsert.push(...Me)):ge.push({start:re,deleteCount:Pe,toInsert:Me})}let ce=0,we=0;for(;;){if(ce===V.length){se(ce,0,ae.slice(we));break}if(we===ae.length){se(ce,V.length-ce,[]);break}const re=V[ce],Pe=ae[we];if(_(re,Pe)){ce+=1,we+=1;continue}$e(Pe)?(se(ce,1,[]),ce+=1):(se(ce,0,[Pe]),we+=1)}return ge}e.$tL=new a.$Wj("notebookEditorCursorAtBoundary","none"),e.$uL=new a.$Wj("notebookEditorCursorAtLineBoundary","none");var g;(function(V){V.default="default",V.option="option"})(g||(e.NotebookEditorPriority=g={}));function m(V){const ae=V;return!!((typeof ae.include=="string"||k.$Ak(ae.include))&&(typeof ae.exclude=="string"||k.$Ak(ae.exclude)))}function $(V,ae,$e){if(Array.isArray(V.viewType)&&V.viewType.indexOf(ae)>=0||V.viewType===ae)return!0;if(V.filenamePattern){const _=m(V.filenamePattern)?V.filenamePattern.include:V.filenamePattern,ge=m(V.filenamePattern)?V.filenamePattern.exclude:void 0;if(k.$yk(_,(0,T.$pc)($e.fsPath).toLowerCase()))return!(ge&&k.$yk(ge,(0,T.$pc)($e.fsPath).toLowerCase()))}return!1}e.$xL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var S;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class D{static{this.d="notebook/"}static create(ae){return`${D.d}${ae}`}static parse(ae){if(ae.startsWith(D.d))return ae.substring(D.d.length)}}e.$yL=D;function b(V){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(V)}const I=new TextDecoder;function R(V){const ae=[];let $e=!1;for(const ce of V)(ae.length===0||$e)&&(ae.push(ce),$e=!0);let _=M(ae);const ge=v.$Oe.concat(ae.map(ce=>v.$Oe.wrap(ce))),se=F(ge);return _=_||se.byteLength!==ge.byteLength,{data:se,didCompression:_}}e.$BL="\x1B[A";const f=e.$BL.split("").map(V=>V.charCodeAt(0)),w=10;function M(V){let ae=!1;return V.forEach(($e,_)=>{if(_===0||$e.length<e.$BL.length)return;const ge=V[_-1],se=$e.subarray(0,e.$BL.length);if(se[0]===f[0]&&se[1]===f[1]&&se[2]===f[2]){const ce=ge.lastIndexOf(w);if(ce===-1)return;ae=!0,V[_-1]=ge.subarray(0,ce),V[_]=$e.subarray(e.$BL.length)}}),ae}function N(V){let ae=V;do V=ae,ae=V.replace(/[^\n]\x08/gm,"");while(ae.length<V.length);return V}function L(V){for(V=V.replace(/\r+\n/gm,`
`);V.search(/\r[^$]/g)>-1;){const ae=V.match(/^(.*)\r+/m)[1];let $e=V.match(/\r+(.*)$/m)[1];$e=$e+ae.slice($e.length,ae.length),V=V.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,$e)}return V}const G=8,W=13;function F(V){return!V.buffer.includes(G)&&!V.buffer.includes(W)?V:v.$Oe.fromString(L(N(I.decode(V.buffer))))}}),define(Ce[7],Ie([1,0,18,14,60,29,73,13,15,2,37,19,30,110,90]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d){"use strict";var n,s,o,h,i,r,t,c,l,g,m,$,S,D,b,I,R;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$PP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.LanguageModelChatMessageRole=e.ChatLocation=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$sP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$fP=e.$eP=e.$dP=e.$cP=e.$aP=e.$_O=e.$$O=e.$0O=e.TestRunProfileKind=e.TestResultState=e.$9O=e.$8O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$7O=e.NotebookVariablesRequestKind=e.$6O=e.$5O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$4O=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.ColorThemeKind=e.$XO=e.$WO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$VO=e.$UO=e.DebugConsoleMode=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$OO=e.$NO=e.FileChangeType=e.$MO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$LO=e.$KO=e.$JO=e.$IO=e.InlineCompletionTriggerKind=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$vO=e.ConfigurationTarget=e.$uO=e.$tO=e.$sO=e.$rO=e.DocumentPasteTriggerKind=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$kO=e.ViewBadge=e.ProgressLocation=e.$jO=e.$iO=e.TaskScope=e.ShellQuoting=e.$hO=e.$gO=e.$fO=e.TaskPanelKind=e.TaskRevealKind=e.$eO=e.TerminalLocation=e.$dO=e.$cO=e.$bO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$aO=e.$_N=e.$$N=e.$0N=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$8N=e.$7N=e.$6N=e.$5N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$4N=e.$3N=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.LanguageStatusSeverity=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.CodeActionTriggerKind=e.$QN=e.$PN=e.SymbolTag=e.SymbolKind=e.$ON=e.$NN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.DiagnosticSeverity=e.DiagnosticTag=e.$HN=e.$GN=e.FileEditType=e.$FN=e.$EN=e.$DN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$9N=xe,e.$wO=Si,e.$bP=Ai;function f(B){return Object.assign(B,{apply:function(...ne){if(ne.length===0)return Reflect.construct(B,[]);{const Se=ne.length===1?[]:ne[1];return Reflect.construct(B,Se,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(B,[]);{const[Se,...He]=ne;return Reflect.construct(B,He,Se.constructor)}}})}var w;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(w||(e.TerminalOutputAnchor=w={}));var M;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let N=n=class{static from(...z){let ne=z;return new n(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$wN=N,e.$wN=N=n=Qe([f],N);let L=s=class{static Min(...z){if(z.length===0)throw new TypeError;let ne=z[0];for(let Se=1;Se<z.length;Se++){const He=z[Se];He.isBefore(ne)&&(ne=He)}return ne}static Max(...z){if(z.length===0)throw new TypeError;let ne=z[0];for(let Se=1;Se<z.length;Se++){const He=z[Se];He.isAfter(ne)&&(ne=He)}return ne}static isPosition(z){if(!z)return!1;if(z instanceof s)return!0;const{line:ne,character:Se}=z;return typeof ne=="number"&&typeof Se=="number"}static of(z){if(z instanceof s)return z;if(this.isPosition(z))return new s(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,ne){if(z<0)throw(0,k.$9)("line must be non-negative");if(ne<0)throw(0,k.$9)("character must be non-negative");this.c=z,this.e=ne}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,ne=0){if(z===null||ne===null)throw(0,k.$9)();let Se;return typeof z>"u"?Se=0:typeof z=="number"?Se=z:(Se=typeof z.lineDelta=="number"?z.lineDelta:0,ne=typeof z.characterDelta=="number"?z.characterDelta:0),Se===0&&ne===0?this:new s(this.line+Se,this.character+ne)}with(z,ne=this.character){if(z===null||ne===null)throw(0,k.$9)();let Se;return typeof z>"u"?Se=this.line:typeof z=="number"?Se=z:(Se=typeof z.line=="number"?z.line:this.line,ne=typeof z.character=="number"?z.character:this.character),Se===this.line&&ne===this.character?this:new s(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};e.$xN=L,e.$xN=L=s=Qe([f],L);let G=o=class{static isRange(z){return z instanceof o?!0:z?L.isPosition(z.start)&&L.isPosition(z.end):!1}static of(z){if(z instanceof o)return z;if(this.isRange(z))return new o(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,ne,Se,He){let it,dt;if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof He=="number"?(it=new L(z,ne),dt=new L(Se,He)):L.isPosition(z)&&L.isPosition(ne)&&(it=L.of(z),dt=L.of(ne)),!it||!dt)throw new Error("Invalid arguments");it.isBefore(dt)?(this.c=it,this.e=dt):(this.c=dt,this.e=it)}contains(z){return o.isRange(z)?this.contains(z.start)&&this.contains(z.end):L.isPosition(z)?!(L.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const ne=L.Max(z.start,this.c),Se=L.Min(z.end,this.e);if(!ne.isAfter(Se))return new o(ne,Se)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ne=L.Min(z.start,this.c),Se=L.Max(z.end,this.end);return new o(ne,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,ne=this.end){if(z===null||ne===null)throw(0,k.$9)();let Se;return z?L.isPosition(z)?Se=z:(Se=z.start||this.start,ne=z.end||this.end):Se=this.start,Se.isEqual(this.c)&&ne.isEqual(this.end)?this:new o(Se,ne)}toJSON(){return[this.start,this.end]}};e.$yN=G,e.$yN=G=o=Qe([f],G);let W=h=class extends G{static isSelection(z){return z instanceof h?!0:z?G.isRange(z)&&L.isPosition(z.anchor)&&L.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,ne,Se,He){let it,dt;if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof He=="number"?(it=new L(z,ne),dt=new L(Se,He)):L.isPosition(z)&&L.isPosition(ne)&&(it=L.of(z),dt=L.of(ne)),!it||!dt)throw new Error("Invalid arguments");super(it,dt),this.f=it,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$zN=W,e.$zN=W=h=Qe([f],W);const F=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,k.$9)("connectionToken")};class V{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ne,Se){if(typeof z!="string"||z.length===0)throw(0,k.$9)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,k.$9)("port");typeof Se<"u"&&F(Se),this.host=z,this.port=Math.round(ne),this.connectionToken=Se}}e.$AN=V;class ae{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ne){this.makeConnection=z,this.connectionToken=ne,typeof ne<"u"&&F(ne)}}e.$BN=ae;class $e extends Error{static NotAvailable(z,ne){return new $e(z,E.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(z){return new $e(z,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,ne=E.RemoteAuthorityResolverErrorCode.Unknown,Se){super(z),this._message=z,this._code=ne,this._detail=Se,Object.setPrototypeOf(this,$e.prototype)}}e.$CN=$e;var _;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(_||(e.EndOfLine=_={}));var ge;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(ge||(e.EnvironmentVariableMutatorType=ge={}));let se=i=class{static isTextEdit(z){return z instanceof i?!0:z?G.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ne){return new i(z,ne)}static insert(z,ne){return i.replace(new G(z,z),ne)}static delete(z){return i.replace(z,"")}static setEndOfLine(z){const ne=new i(new G(new L(0,0),new L(0,0)),"");return ne.newEol=z,ne}get range(){return this.c}set range(z){if(z&&!G.isRange(z))throw(0,k.$9)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,k.$9)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,k.$9)("newEol");this.f=z}constructor(z,ne){this.c=z,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$DN=se,e.$DN=se=i=Qe([f],se);let ce=r=class{static isNotebookCellEdit(z){return z instanceof r?!0:z?wt.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,ne){return new r(z,ne)}static insertCells(z,ne){return new r(new wt(z,z),ne)}static deleteCells(z){return new r(z,[])}static updateCellMetadata(z,ne){const Se=new r(new wt(z,z),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(z){const ne=new r(new wt(0,0),[]);return ne.newNotebookMetadata=z,ne}constructor(z,ne){this.range=z,this.newCells=ne}};e.$EN=ce,e.$EN=ce=r=Qe([f],ce);class we{static isSnippetTextEdit(z){return z instanceof we?!0:z?G.isRange(z.range)&&Me.isSnippetString(z.snippet):!1}static replace(z,ne){return new we(z,ne)}static insert(z,ne){return we.replace(new G(z,z),ne)}constructor(z,ne){this.range=z,this.snippet=ne}}e.$FN=we;var re;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(re||(e.FileEditType=re={}));let Pe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,ne,Se,He){this.c.push({_type:re.File,from:z,to:ne,options:Se,metadata:He})}createFile(z,ne,Se){this.c.push({_type:re.File,from:void 0,to:z,options:ne,metadata:Se})}deleteFile(z,ne,Se){this.c.push({_type:re.File,from:z,to:void 0,options:ne,metadata:Se})}e(z,ne,Se){this.c.push({_type:re.Cell,metadata:Se,uri:z,edit:{editType:d.CellEditType.DocumentMetadata,metadata:ne},notebookMetadata:ne})}f(z,ne,Se,He){const it=ne.start,dt=ne.end;(it!==dt||Se.length>0)&&this.c.push({_type:re.CellReplace,uri:z,index:it,count:dt-it,cells:Se,metadata:He})}g(z,ne,Se,He){this.c.push({_type:re.Cell,metadata:He,uri:z,edit:{editType:d.CellEditType.Metadata,index:ne,metadata:Se}})}replace(z,ne,Se,He){this.c.push({_type:re.Text,uri:z,edit:new se(ne,Se),metadata:He})}insert(z,ne,Se,He){this.replace(z,new G(ne,ne),Se,He)}delete(z,ne,Se){this.replace(z,ne,"",Se)}has(z){return this.c.some(ne=>ne._type===re.Text&&ne.uri.toString()===z.toString())}set(z,ne){if(ne)for(const Se of ne){if(!Se)continue;let He,it;Array.isArray(Se)?(He=Se[0],it=Se[1]):He=Se,ce.isNotebookCellEdit(He)?He.newCellMetadata?this.g(z,He.range.start,He.newCellMetadata,it):He.newNotebookMetadata?this.e(z,He.newNotebookMetadata,it):this.f(z,He.range,He.newCells,it):we.isSnippetTextEdit(He)?this.c.push({_type:re.Snippet,uri:z,range:He.range,edit:He.snippet,metadata:it}):this.c.push({_type:re.Text,uri:z,edit:He,metadata:it})}else{for(let Se=0;Se<this.c.length;Se++){const He=this.c[Se];switch(He._type){case re.Text:case re.Snippet:case re.Cell:case re.CellReplace:He.uri.toString()===z.toString()&&(this.c[Se]=void 0);break}}(0,v.$Kb)(this.c)}}get(z){const ne=[];for(const Se of this.c)Se._type===re.Text&&Se.uri.toString()===z.toString()&&ne.push(Se.edit);return ne}entries(){const z=new O.$Cc;for(const ne of this.c)if(ne._type===re.Text){let Se=z.get(ne.uri);Se||(Se=[ne.uri,[]],z.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$GN=Pe,e.$GN=Pe=Qe([f],Pe);let Me=t=class{static isSnippetString(z){return z instanceof t?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=t.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ne=this.e++){if(typeof z=="function"){const Se=new t;Se.e=this.e,z(Se),this.e=Se.e,z=Se.value}else z=t.c(z);return this.value+="${",this.value+=ne,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ne=this.e++){const Se=z.map(He=>He.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(z,ne){if(typeof ne=="function"){const Se=new t;Se.e=this.e,ne(Se),this.e=Se.e,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$HN=Me,e.$HN=Me=t=Qe([f],Me);var Y;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(Y||(e.DiagnosticTag=Y={}));var q;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(q||(e.DiagnosticSeverity=q={}));let ee=c=class{static isLocation(z){return z instanceof c?!0:z?G.isRange(z.range)&&a.URI.isUri(z.uri):!1}constructor(z,ne){if(this.uri=z,ne)if(G.isRange(ne))this.range=G.of(ne);else if(L.isPosition(ne))this.range=new G(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$IN=ee,e.$IN=ee=c=Qe([f],ee);let ve=class{static is(z){return z?typeof z.message=="string"&&z.location&&G.isRange(z.location.range)&&a.URI.isUri(z.location.uri):!1}constructor(z,ne){this.location=z,this.message=ne}static isEqual(z,ne){return z===ne?!0:!z||!ne?!1:z.message===ne.message&&z.location.range.isEqual(ne.location.range)&&z.location.uri.toString()===ne.location.uri.toString()}};e.$JN=ve,e.$JN=ve=Qe([f],ve);let ue=class{constructor(z,ne,Se=q.Error){if(!G.isRange(z))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=z,this.message=ne,this.severity=Se}toJSON(){return{severity:q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ne){return z===ne?!0:!z||!ne?!1:z.message===ne.message&&z.severity===ne.severity&&z.code===ne.code&&z.severity===ne.severity&&z.source===ne.source&&z.range.isEqual(ne.range)&&(0,v.$wb)(z.tags,ne.tags)&&(0,v.$wb)(z.relatedInformation,ne.relatedInformation,ve.isEqual)}};e.$KN=ue,e.$KN=ue=Qe([f],ue);let be=class{constructor(z,ne){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ne}};e.$LN=be,e.$LN=be=Qe([f],be);let de=class extends be{constructor(z,ne,Se,He){super(z,ne),this.canIncreaseHover=Se,this.canDecreaseHover=He}};e.$MN=de,e.$MN=de=Qe([f],de);var X;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(X||(e.HoverVerbosityAction=X={}));var Z;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(Z||(e.DocumentHighlightKind=Z={}));let me=class{constructor(z,ne=Z.Text){this.range=z,this.kind=ne}toJSON(){return{range:this.range,kind:Z[this.kind]}}};e.$NN=me,e.$NN=me=Qe([f],me);let pe=class{constructor(z,ne){this.uri=z,this.highlights=ne}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$ON=pe,e.$ON=pe=Qe([f],pe);var Oe;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Oe||(e.SymbolKind=Oe={}));var ze;(function(B){B[B.Deprecated=1]="Deprecated"})(ze||(e.SymbolTag=ze={}));let ke=l=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,ne,Se,He,it){this.name=z,this.kind=ne,this.containerName=it,typeof Se=="string"&&(this.containerName=Se),He instanceof ee?this.location=He:Se instanceof G&&(this.location=new ee(He,Se)),l.validate(this)}toJSON(){return{name:this.name,kind:Oe[this.kind],location:this.location,containerName:this.containerName}}};e.$PN=ke,e.$PN=ke=l=Qe([f],ke);let Ae=g=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(g.validate)}constructor(z,ne,Se,He,it){this.name=z,this.detail=ne,this.kind=Se,this.range=He,this.selectionRange=it,this.children=[],g.validate(this)}};e.$QN=Ae,e.$QN=Ae=g=Qe([f],Ae);var Ne;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ne||(e.CodeActionTriggerKind=Ne={}));let j=class{constructor(z,ne){this.title=z,this.kind=ne}};e.$RN=j,e.$RN=j=Qe([f],j);let U=class{static{m=this}static{this.c="."}constructor(z){this.value=z}append(z){return new m(this.value?this.value+m.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+m.c)}};e.$SN=U,e.$SN=U=m=Qe([f],U),U.Empty=new U(""),U.QuickFix=U.Empty.append("quickfix"),U.Refactor=U.Empty.append("refactor"),U.RefactorExtract=U.Refactor.append("extract"),U.RefactorInline=U.Refactor.append("inline"),U.RefactorMove=U.Refactor.append("move"),U.RefactorRewrite=U.Refactor.append("rewrite"),U.Source=U.Empty.append("source"),U.SourceOrganizeImports=U.Source.append("organizeImports"),U.SourceFixAll=U.Source.append("fixAll"),U.Notebook=U.Empty.append("notebook");let K=class{constructor(z,ne){if(this.range=z,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$TN=K,e.$TN=K=Qe([f],K);class H{constructor(z,ne,Se,He,it,dt){this.kind=z,this.name=ne,this.detail=Se,this.uri=He,this.range=it,this.selectionRange=dt}}e.$UN=H;class ie{constructor(z,ne){this.fromRanges=ne,this.from=z}}e.$VN=ie;class fe{constructor(z,ne){this.fromRanges=ne,this.to=z}}e.$WN=fe;var Re;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Re||(e.LanguageStatusSeverity=Re={}));let Ue=class{constructor(z,ne){this.range=z,this.command=ne}get isResolved(){return!!this.command}};e.$XN=Ue,e.$XN=Ue=Qe([f],Ue);let Ke=$=class{#e;static isMarkdownString(z){return z instanceof $?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,ne=!1){this.#e=new C.$3k(z,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,ne){return this.#e.appendCodeblock(ne??"",z),this}};e.$YN=Ke,e.$YN=Ke=$=Qe([f],Ke);let _e=class{constructor(z,ne){this.label=z,this.documentation=ne}};e.$ZN=_e,e.$ZN=_e=Qe([f],_e);let tt=class{constructor(z,ne){this.label=z,this.documentation=ne,this.parameters=[]}};e.$1N=tt,e.$1N=tt=Qe([f],tt);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$2N=nt,e.$2N=nt=Qe([f],nt);var et;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var rt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let ft=class{constructor(z){this.value=z}};e.$3N=ft,e.$3N=ft=Qe([f],ft);let ct=class{constructor(z,ne,Se){this.position=z,this.label=ne,this.kind=Se}};e.$4N=ct,e.$4N=ct=Qe([f],ct);var st;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var ut;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(ut||(e.CompletionItemKind=ut={}));var gt;(function(B){B[B.Deprecated=1]="Deprecated"})(gt||(e.CompletionItemTag=gt={}));let pt=class{constructor(z,ne){this.label=z,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&ut[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$5N=pt,e.$5N=pt=Qe([f],pt);let Be=class{constructor(z=[],ne=!1){this.items=z,this.isIncomplete=ne}};e.$6N=Be,e.$6N=Be=Qe([f],Be);let je=class{constructor(z,ne,Se){this.insertText=z,this.range=ne,this.command=Se}};e.$7N=je,e.$7N=je=Qe([f],je);let Q=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$8N=Q,e.$8N=Q=Qe([f],Q);var x;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(x||(e.PartialAcceptTriggerKind=x={}));var De;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(De||(e.ViewColumn=De={}));var Je;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Je||(e.StatusBarAlignment=Je={}));function xe(B,z){return`${y.$qn.toKey(B)}.${z}`}var ht;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(ht||(e.TextEditorLineNumbersStyle=ht={}));var $t;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})($t||(e.TextDocumentSaveReason=$t={}));var Ft;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ft||(e.TextEditorRevealType=Ft={}));var zt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(zt||(e.TextEditorSelectionChangeKind=zt={}));var Yt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Yt||(e.TextDocumentChangeReason=Yt={}));var fi;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(fi||(e.DecorationRangeBehavior=fi={})),function(B){function z(ne){switch(ne){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=z}(zt||(e.TextEditorSelectionChangeKind=zt={}));var Ze;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Ze||(e.SyntaxTokenType=Ze={})),function(B){function z(ne){switch(ne){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=z}(Ze||(e.SyntaxTokenType=Ze={}));let Pt=class{constructor(z,ne){if(ne&&!a.URI.isUri(ne))throw(0,k.$9)("target");if(!G.isRange(z)||z.isEmpty)throw(0,k.$9)("range");this.range=z,this.target=ne}};e.$0N=Pt,e.$0N=Pt=Qe([f],Pt);let Kt=class{constructor(z,ne,Se,He){this.red=z,this.green=ne,this.blue=Se,this.alpha=He}};e.$$N=Kt,e.$$N=Kt=Qe([f],Kt);let Qt=class{constructor(z,ne){if(ne&&!(ne instanceof Kt))throw(0,k.$9)("color");if(!G.isRange(z)||z.isEmpty)throw(0,k.$9)("range");this.range=z,this.color=ne}};e.$_N=Qt,e.$_N=Qt=Qe([f],Qt);let mt=class{constructor(z){if(!z||typeof z!="string")throw(0,k.$9)("label");this.label=z}};e.$aO=mt,e.$aO=mt=Qe([f],mt);var vt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(vt||(e.ColorFormat=vt={}));var ii;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var Zt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(Zt||(e.TerminalExitReason=Zt={}));var qt;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(qt||(e.TerminalShellExecutionCommandLineConfidence=qt={}));class yt{constructor(z,ne,Se){if(this.startIndex=z,this.length=ne,this.tooltip=Se,typeof z!="number"||z<0)throw(0,k.$9)("startIndex");if(typeof ne!="number"||ne<1)throw(0,k.$9)("length");if(Se!==void 0&&typeof Se!="string")throw(0,k.$9)("tooltip")}}e.$bO=yt;class Nt{constructor(z){this.uri=z}}e.$cO=Nt;class li{constructor(z){this.terminalCommand=z}}e.$dO=li;var Vt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Vt||(e.TerminalLocation=Vt={}));class Xe{constructor(z){if(this.options=z,typeof z!="object")throw(0,k.$9)("options")}}e.$eO=Xe;var xt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(xt||(e.TaskRevealKind=xt={}));var ni;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ni||(e.TaskPanelKind=ni={}));let hi=class{static{S=this}static{this.Clean=new S("clean","Clean")}static{this.Build=new S("build","Build")}static{this.Rebuild=new S("rebuild","Rebuild")}static{this.Test=new S("test","Test")}static from(z){switch(z){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(z,ne){if(this.label=ne,typeof z!="string"||typeof ne!="string")throw(0,k.$9)("name");this.c=z}get id(){return this.c}};e.$fO=hi,e.$fO=hi=S=Qe([f],hi);function kt(B){let z="";for(let ne=0;ne<B.length;ne++)z+=B[ne].replace(/,/g,",,")+",";return z}let Lt=class{constructor(z,ne,Se){if(typeof z!="string")throw(0,k.$9)("process");this.e=[],this.c=z,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=Se):this.f=ne)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,k.$9)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)z.push(ne);return kt(z)}};e.$gO=Lt,e.$gO=Lt=Qe([f],Lt);let At=class{constructor(z,ne,Se){if(this.f=[],Array.isArray(ne)){if(!z)throw(0,k.$9)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,k.$9)("command");this.e=z,this.f=ne,this.g=Se}else{if(typeof z!="string")throw(0,k.$9)("commandLine");this.c=z,this.g=ne}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,k.$9)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,k.$9)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)z.push(typeof ne=="string"?ne:ne.value);return kt(z)}};e.$hO=At,e.$hO=At=Qe([f],At);var Ut;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Ut||(e.ShellQuoting=Ut={}));var ri;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class _t{constructor(z){this.c=z}computeId(){return"customExecution"+(0,P.$2g)()}set callback(z){this.c=z}get callback(){return this.c}}e.$iO=_t;let si=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,ne,Se,He,it,dt){this.k=!1,this.l=this.definition=z;let Et;typeof ne=="string"?(this.o=this.name=ne,this.w=this.source=Se,this.execution=He,Et=it,this.k=!0):ne===ri.Global||ne===ri.Workspace?(this.target=ne,this.o=this.name=Se,this.w=this.source=He,this.execution=it,Et=dt):(this.target=ne,this.o=this.name=Se,this.w=this.source=He,this.execution=it,Et=dt),typeof Et=="string"?(this.r=[Et],this.t=!0):Array.isArray(Et)?(this.r=Et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Lt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof At?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof _t?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,P.$2g)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,k.$9)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,k.$9)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const ne=this.l.type;(D.g===ne||D.e===ne||D.f===ne||D.c===ne)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,k.$9)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$jO=si,e.$jO=si=D=Qe([f],si);var jt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(jt||(e.ProgressLocation=jt={}));var Ht;(function(B){function z(ne){const Se=ne;return(0,p.$jg)(Se.value)?Se.tooltip&&!(0,p.$fg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}B.isViewBadge=z})(Ht||(e.ViewBadge=Ht={}));let oi=b=class{static isTreeItem(z,ne){const Se=z;if(Se.checkboxState!==void 0){const He=(0,p.$jg)(Se.checkboxState)?Se.checkboxState:(0,p.$hg)(Se.checkboxState)&&(0,p.$jg)(Se.checkboxState.state)?Se.checkboxState.state:void 0,it=!(0,p.$jg)(Se.checkboxState)&&(0,p.$hg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(He===void 0||He!==St.Checked&&He!==St.Unchecked||it!==void 0&&!(0,p.$fg)(it))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(z instanceof b)return!0;if(Se.label!==void 0&&!(0,p.$fg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,p.$fg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,p.$fg)(Se.iconPath)&&!a.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,p.$fg)(Se.iconPath.id))){const He=Se.iconPath;if(!He||!(0,p.$fg)(He.light)&&!a.URI.isUri(He.light)&&!(0,p.$fg)(He.dark)&&!a.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,p.$fg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!a.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,p.$fg)(Se.tooltip)&&!(Se.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<Rt.None&&Se.collapsibleState>Rt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,p.$fg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(z,ne=Rt.None){this.collapsibleState=ne,a.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$kO=oi,e.$kO=oi=b=Qe([f],oi);var Rt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Rt||(e.TreeItemCollapsibleState=Rt={}));var St;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(St||(e.TreeItemCheckboxState=St={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$lO=bt,e.$lO=bt=Qe([f],bt);class ei extends bt{}e.$mO=ei;class Ct extends ei{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$nO=Ct;class di{constructor(z,ne,Se,He){this.name=z,this.uri=ne,this._itemId=Se,this.c=He}data(){return this.c()}}e.$oO=di;let Gt=class{#e=new Map;constructor(z){for(const[ne,Se]of z??[]){const He=this.#e.get(this.#t(ne));He?He.push(Se):this.#e.set(this.#t(ne),[Se])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,ne){this.#e.set(this.#t(z),[ne])}forEach(z,ne){for(const[Se,He]of this.#e)for(const it of He)z.call(ne,it,Se,this)}*[Symbol.iterator](){for(const[z,ne]of this.#e)for(const Se of ne)yield[z,Se]}#t(z){return z.toLowerCase()}};e.$pO=Gt,e.$pO=Gt=Qe([f],Gt);let bi=class{constructor(z,ne,Se){this.insertText=z,this.title=ne,this.kind=Se}};e.$qO=bi,e.$qO=bi=Qe([f],bi);var vi;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(vi||(e.DocumentPasteTriggerKind=vi={}));class gi{static{this.c="."}constructor(z){this.value=z}append(...z){return new gi((this.value?[this.value,...z]:z).join(gi.c))}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+gi.c)}}e.$rO=gi,gi.Empty=new gi("");class Bt{constructor(z,ne,Se){this.title=ne,this.insertText=z,this.kind=Se}}e.$sO=Bt;let ai=class{constructor(z,ne){this.id=z,this.color=ne}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$tO=ai,e.$tO=ai=Qe([f],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Ii=class{constructor(z){this.id=z}};e.$uO=Ii,e.$uO=Ii=Qe([f],Ii);var Tt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Tt||(e.ConfigurationTarget=Tt={}));let Di=class{get base(){return this.c}set base(z){this.c=z,this.e=a.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,ne){if(typeof z!="string"&&(!z||!a.URI.isUri(z)&&!a.URI.isUri(z.uri)))throw(0,k.$9)("base");if(typeof ne!="string")throw(0,k.$9)("pattern");typeof z=="string"?this.baseUri=a.URI.file(z):a.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$vO=Di,e.$vO=Di=Qe([f],Di);const Pi=new WeakMap;function Si(B,z){Pi.set(B,z)}let pi=class{constructor(z,ne,Se,He,it){this.enabled=typeof z=="boolean"?z:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof He=="string"&&(this.logMessage=He),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=Pi.get(this)??(0,P.$2g)()),this.c}};e.$xO=pi,e.$xO=pi=Qe([f],pi);let Ri=class extends pi{constructor(z,ne,Se,He,it,dt){if(super(ne,Se,He,it,dt),z===null)throw(0,k.$9)("location");this.location=z}};e.$yO=Ri,e.$yO=Ri=Qe([f],Ri);let Wt=class extends pi{constructor(z,ne,Se,He,it,dt){super(ne,Se,He,it,dt),this.functionName=z}};e.$zO=Wt,e.$zO=Wt=Qe([f],Wt);let ye=class extends pi{constructor(z,ne,Se,He,it,dt,Et,Xt){if(super(He,it,dt,Et,Xt),!ne)throw(0,k.$9)("dataId");this.label=z,this.dataId=ne,this.canPersist=Se}};e.$AO=ye,e.$AO=ye=Qe([f],ye);let Te=class{constructor(z,ne,Se){this.command=z,this.args=ne||[],this.options=Se}};e.$BO=Te,e.$BO=Te=Qe([f],Te);let le=class{constructor(z,ne){this.port=z,this.host=ne}};e.$CO=le,e.$CO=le=Qe([f],le);let J=class{constructor(z){this.path=z}};e.$DO=J,e.$DO=J=Qe([f],J);let Ee=class{constructor(z){this.implementation=z}};e.$EO=Ee,e.$EO=Ee=Qe([f],Ee);class We{constructor(z,ne,Se){this.session=z,this.threadId=ne,this.frameId=Se}}e.$FO=We;class Ye{constructor(z,ne){this.session=z,this.threadId=ne}}e.$GO=Ye;let Ge=class{constructor(z,ne){this.range=z,this.expression=ne}};e.$HO=Ge,e.$HO=Ge=Qe([f],Ge);var lt;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(lt||(e.InlineCompletionTriggerKind=lt={}));let It=class{constructor(z,ne){this.range=z,this.text=ne}};e.$IO=It,e.$IO=It=Qe([f],It);let Jt=class{constructor(z,ne,Se=!0){this.range=z,this.variableName=ne,this.caseSensitiveLookup=Se}};e.$JO=Jt,e.$JO=Jt=Qe([f],Jt);let ci=class{constructor(z,ne){this.range=z,this.expression=ne}};e.$KO=ci,e.$KO=ci=Qe([f],ci);let Mt=class{constructor(z,ne){this.frameId=z,this.stoppedLocation=ne}};e.$LO=Mt,e.$LO=Mt=Qe([f],Mt);var ui;(function(B){B[B.AIGenerated=1]="AIGenerated"})(ui||(e.NewSymbolNameTag=ui={}));var qi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(qi||(e.NewSymbolNameTriggerKind=qi={}));class $n{constructor(z,ne){this.newSymbolName=z,this.tags=ne}}e.$MO=$n;var Li;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Li||(e.FileChangeType=Li={}));let Oi=I=class extends Error{static FileExists(z){return new I(z,u.FileSystemProviderErrorCode.FileExists,I.FileExists)}static FileNotFound(z){return new I(z,u.FileSystemProviderErrorCode.FileNotFound,I.FileNotFound)}static FileNotADirectory(z){return new I(z,u.FileSystemProviderErrorCode.FileNotADirectory,I.FileNotADirectory)}static FileIsADirectory(z){return new I(z,u.FileSystemProviderErrorCode.FileIsADirectory,I.FileIsADirectory)}static NoPermissions(z){return new I(z,u.FileSystemProviderErrorCode.NoPermissions,I.NoPermissions)}static Unavailable(z){return new I(z,u.FileSystemProviderErrorCode.Unavailable,I.Unavailable)}constructor(z,ne=u.FileSystemProviderErrorCode.Unknown,Se){super(a.URI.isUri(z)?z.toString(!0):z),this.code=Se?.name??"Unknown",(0,u.$ol)(this,ne),Object.setPrototypeOf(this,I.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$NO=Oi,e.$NO=Oi=I=Qe([f],Oi);let Vi=class{constructor(z,ne,Se){this.start=z,this.end=ne,this.kind=Se}};e.$OO=Vi,e.$OO=Vi=Qe([f],Vi);var xi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(xi||(e.FoldingRangeKind=xi={}));var ki;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(ki||(e.CommentThreadCollapsibleState=ki={}));var _i;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var en;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(en||(e.CommentState=en={}));var Mi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Mi||(e.CommentThreadState=Mi={}));var tn;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(tn||(e.CommentThreadApplicability=tn={}));class Gi{constructor(z,ne=[]){this.tokenTypes=z,this.tokenModifiers=ne}}e.$PO=Gi;function nn(B){return typeof B>"u"||(0,p.$gg)(B)}class Ki{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let ne=0,Se=z.tokenTypes.length;ne<Se;ne++)this.k.set(z.tokenTypes[ne],ne);for(let ne=0,Se=z.tokenModifiers.length;ne<Se;ne++)this.l.set(z.tokenModifiers[ne],ne)}}push(z,ne,Se,He,it){if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof He=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(z,ne,Se,He,it);if(G.isRange(z)&&typeof ne=="string"&&nn(Se))return this.o(z,ne,Se);throw(0,k.$9)()}o(z,ne,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ne))throw new Error("`tokenType` is not in the provided legend");const He=z.start.line,it=z.start.character,dt=z.end.character-z.start.character,Et=this.k.get(ne);let Xt=0;if(Se)for(const $i of Se){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const wi=this.l.get($i);Xt|=1<<wi>>>0}this.q(He,it,dt,Et,Xt)}q(z,ne,Se,He,it){if(this.f&&(z<this.c||z===this.c&&ne<this.e)){this.f=!1;const Xt=this.g.length/5|0;let $i=0,wi=0;for(let Ei=0;Ei<Xt;Ei++){let Ci=this.g[5*Ei],Yi=this.g[5*Ei+1];Ci===0?(Ci=$i,Yi+=wi):Ci+=$i,this.g[5*Ei]=Ci,this.g[5*Ei+1]=Yi,$i=Ci,wi=Yi}}let dt=z,Et=ne;this.f&&this.j>0&&(dt-=this.c,dt===0&&(Et-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=Et,this.g[this.j++]=Se,this.g[this.j++]=He,this.g[this.j++]=it,this.c=z,this.e=ne}static r(z){const ne=[],Se=z.length/5|0;for(let Et=0;Et<Se;Et++)ne[Et]=Et;ne.sort((Et,Xt)=>{const $i=z[5*Et],wi=z[5*Xt];if($i===wi){const Ei=z[5*Et+1],Ci=z[5*Xt+1];return Ei-Ci}return $i-wi});const He=new Uint32Array(z.length);let it=0,dt=0;for(let Et=0;Et<Se;Et++){const Xt=5*ne[Et],$i=z[Xt+0],wi=z[Xt+1],Ei=z[Xt+2],Ci=z[Xt+3],Yi=z[Xt+4],jn=$i-it,kr=jn===0?wi-dt:wi,Zi=5*Et;He[Zi+0]=jn,He[Zi+1]=kr,He[Zi+2]=Ei,He[Zi+3]=Ci,He[Zi+4]=Yi,it=$i,dt=wi}return He}build(z){return this.f?new zi(new Uint32Array(this.g),z):new zi(Ki.r(this.g),z)}}e.$QO=Ki;class zi{constructor(z,ne){this.resultId=ne,this.data=z}}e.$RO=zi;class wn{constructor(z,ne,Se){this.start=z,this.deleteCount=ne,this.data=Se}}e.$SO=wn;class Ni{constructor(z,ne){this.resultId=ne,this.edits=z}}e.$TO=Ni;var rn;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(rn||(e.DebugConsoleMode=rn={}));class bn{constructor(z){this.name=z}}e.$UO=bn;let Qi=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$VO=Qi,e.$VO=Qi=Qe([f],Qi);var Ui;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Ui||(e.QuickPickItemKind=Ui={}));var Hi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Hi||(e.InputBoxValidationSeverity=Hi={}));var Le;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Le||(e.ExtensionKind=Le={}));class yi{static validate(z){if(typeof z.badge=="string"){let ne=(0,T.$Qf)(z.badge,0);if(ne<z.badge.length&&(ne+=(0,T.$Qf)(z.badge,ne)),z.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!ai.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,ne,Se){this.badge=z,this.tooltip=ne,this.color=Se}}e.$WO=yi;let ji=class{constructor(z){this.kind=z}};e.$XO=ji,e.$XO=ji=Qe([f],ji);var ot;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(ot||(e.ColorThemeKind=ot={}));class wt{static isNotebookRange(z){return z instanceof wt?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,ne){if(z<0)throw(0,k.$9)("start must be positive");if(ne<0)throw(0,k.$9)("end must be positive");z<=ne?(this.c=z,this.e=ne):(this.c=ne,this.e=z)}with(z){let ne=this.c,Se=this.e;return z.start!==void 0&&(ne=z.start),z.end!==void 0&&(Se=z.end),ne===this.c&&Se===this.e?this:new wt(ne,Se)}}e.$YO=wt;class Bi{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ne=>Bi.isNotebookCellData(ne))}static isNotebookCellData(z){return!0}constructor(z,ne,Se,He,it,dt,Et){this.kind=z,this.value=ne,this.languageId=Se,this.mime=He,this.outputs=it??[],this.metadata=dt,this.executionSummary=Et,Bi.validate(this)}}e.$ZO=Bi;class vn{constructor(z){this.cells=z}}e.$1O=vn;class mi{static isNotebookCellOutputItem(z){return z instanceof mi?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ne={name:z.name,message:z.message,stack:z.stack};return mi.json(ne,"application/vnd.code.notebook.error")}static stdout(z){return mi.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return mi.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ne="application/octet-stream"){return new mi(z,ne)}static#e=new TextEncoder;static text(z,ne=A.$8s.text){const Se=mi.#e.encode(String(z));return new mi(Se,ne)}static json(z,ne="text/x-json"){const Se=JSON.stringify(z,void 0,"	");return mi.text(Se,ne)}constructor(z,ne){this.data=z,this.mime=ne;const Se=(0,A.$_s)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$2O=mi;class Wi{static isNotebookCellOutput(z){return z instanceof Wi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,ne=!1){const Se=new Set,He=new Set;for(let it=0;it<z.length;it++){const dt=z[it],Et=(0,A.$_s)(dt.mime);if(!Se.has(Et)||(0,d.$zL)(Et)){Se.add(Et);continue}He.add(it),ne&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return He.size===0?z:z.filter((it,dt)=>!He.has(dt))}constructor(z,ne,Se){this.items=Wi.ensureUniqueMimeTypes(z,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,P.$2g)(),this.metadata=ne??Se)}}e.$3O=Wi;var Fi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Fi||(e.NotebookCellKind=Fi={}));var sn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(sn||(e.NotebookCellExecutionState=sn={}));var on;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(on||(e.NotebookCellStatusBarAlignment=on={}));var an;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class cn{constructor(z,ne){this.text=z,this.alignment=ne}}e.$4O=cn;var un;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(un||(e.NotebookControllerAffinity=un={}));var ln;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(ln||(e.NotebookControllerAffinity2=ln={}));class yn{constructor(z,ne=[]){this.uri=z,this.provides=(0,v.$4b)(ne)}}e.$5O=yn;class En{constructor(z){this.label=z}}e.$6O=En;var hn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(hn||(e.NotebookVariablesRequestKind=hn={}));let Ji=class{constructor(z,ne){this.label=z,this.timestamp=ne}};e.$7O=Ji,e.$7O=Ji=Qe([f],Ji);var dn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(dn||(e.ExtensionMode=dn={}));var fn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(fn||(e.ExtensionRuntime=fn={}));var gn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(gn||(e.StandardTokenType=gn={}));class Dn{constructor(z,ne){this.ranges=z,this.wordPattern=ne}}e.$8O=Dn;class Sn{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$9O=Sn;var te;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(te||(e.TestResultState=te={}));var he;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(he||(e.TestRunProfileKind=he={}));let Fe=class{constructor(z=void 0,ne=void 0,Se=void 0,He=!1,it=!0){this.include=z,this.exclude=ne,this.profile=Se,this.continuous=He,this.preserveFocus=it}};e.$0O=Fe,e.$0O=Fe=Qe([f],Fe);let at=R=class{static diff(z,ne,Se){const He=new R(z);return He.expectedOutput=ne,He.actualOutput=Se,He}constructor(z){this.message=z}};e.$$O=at,e.$$O=at=R=Qe([f],at);let Dt=class{constructor(z){this.id=z}};e.$_O=Dt,e.$_O=Dt=Qe([f],Dt);class Ot{constructor(z,ne){this.covered=z,this.total=ne,Ai(this)}}e.$aP=Ot;function Ai(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class Xi{static fromDetails(z,ne){const Se=new Ot(0,0),He=new Ot(0,0),it=new Ot(0,0);for(const Et of ne)if("branches"in Et){Se.total+=1,Se.covered+=Et.executed?1:0;for(const Xt of Et.branches)He.total+=1,He.covered+=Xt.executed?1:0}else it.total+=1,it.covered+=Et.executed?1:0;const dt=new Xi(z,Se,He.total>0?He:void 0,it.total>0?it:void 0);return dt.detailedCoverage=ne,dt}constructor(z,ne,Se,He,it=[]){this.uri=z,this.statementCoverage=ne,this.branchCoverage=Se,this.declarationCoverage=He,this.fromTests=it}}e.$cP=Xi;class qn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se=[]){this.executed=z,this.location=ne,this.branches=Se}}e.$dP=qn;class Vn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se){this.executed=z,this.location=ne,this.label=Se}}e.$eP=Vn;class Gn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se){this.name=z,this.executed=ne,this.location=Se}}e.$fP=Gn;var kn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var Cn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Cn||(e.WorkspaceTrustState=Cn={}));var In;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(In||(e.PortAutoForwardAction=In={}));class Kn{constructor(z,ne,Se,He,it,dt){this.kind=z,this.name=ne,this.detail=Se,this.uri=He,this.range=it,this.selectionRange=dt}}e.$gP=Kn;class Qn{constructor(z){this.uri=z}}e.$hP=Qn;class Hn{constructor(z,ne){this.original=z,this.modified=ne}}e.$iP=Hn;class Jn{constructor(z,ne,Se,He){this.base=z,this.input1=ne,this.input2=Se,this.result=He}}e.$jP=Jn;class Xn{constructor(z,ne){this.uri=z,this.viewType=ne}}e.$kP=Xn;class Yn{constructor(z){this.viewType=z}}e.$lP=Yn;class Zn{constructor(z,ne){this.uri=z,this.notebookType=ne}}e.$mP=Zn;class xn{constructor(z,ne,Se){this.original=z,this.modified=ne,this.notebookType=Se}}e.$nP=xn;class _n{constructor(){}}e.$oP=_n;class er{constructor(z,ne){this.uri=z,this.inputBoxUri=ne}}e.$pP=er;class tr{constructor(){}}e.$qP=tr;class ir{constructor(z){this.textDiffs=z}}e.$rP=ir;var Pn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(Pn||(e.InteractiveSessionVoteDirection=Pn={}));var Rn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(Rn||(e.ChatCopyKind=Rn={}));var An;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(An||(e.ChatVariableLevel=An={}));class nr{constructor(z,ne,Se){this.id=z,this.label=ne,this.values=Se}}e.$sP=nr;var Tn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Tn||(e.InteractiveEditorResponseFeedbackKind=Tn={}));var On;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(On||(e.ChatResultFeedbackKind=On={}));class rr{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ke(z):z}}e.$tP=rr;class sr{constructor(z,ne){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ke(z):z,this.vulnerabilities=ne}}e.$uP=sr;class or{constructor(z,ne){this.participant=z,this.command=ne}}e.$vP=or;class ar{constructor(z,ne,Se){this.title=z,this.message=ne,this.data=Se}}e.$wP=ar;class cr{constructor(z,ne){this.value=z,this.baseUri=ne}}e.$xP=cr;class ur{constructor(z,ne){this.value=z,this.title=ne}}e.$yP=ur;class lr{constructor(z){this.value=z}}e.$zP=lr;class hr{constructor(z,ne){this.value=z,this.task=ne}}e.$AP=hr;class dr{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ke(z):z}}e.$BP=dr;class fr{constructor(z){this.value=z}}e.$CP=fr;class gr{constructor(z,ne){this.value=z,this.iconPath=ne}}e.$DP=gr;class mr{constructor(z,ne){this.uri=z,this.edits=Array.isArray(ne)?ne:[ne]}}e.$EP=mr;class pr{constructor(z,ne,Se,He){this.prompt=z,this.command=ne,this.references=Se,this.participant=He}}e.$FP=pr;class $r{constructor(z,ne,Se,He){this.response=z,this.result=ne,this.participant=Se,this.command=He}}e.$GP=$r;var Nn;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(Nn||(e.ChatLocation=Nn={}));var mn;(function(B){B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.System=3]="System"})(mn||(e.LanguageModelChatMessageRole=mn={}));class wr{constructor(z,ne,Se){this.name=z,this.content=ne,this.isError=Se??!1}}e.$HP=wr;class pn{static User(z,ne){const Se=new pn(mn.User,typeof z=="string"?z:"",ne);return Se.content2=z,Se}static Assistant(z,ne){return new pn(mn.Assistant,z,ne)}constructor(z,ne,Se){this.role=z,this.content=ne,this.content2=ne,this.name=Se}}e.$IP=pn;class br{constructor(z,ne){this.name=z,this.parameters=ne}}e.$JP=br;class vr{constructor(z){this.value=z}}e.$KP=vr;class yr{constructor(z){this.content=z}}e.$LP=yr;class Er{constructor(z,ne){this.content=z,this.name=ne}}e.$MP=Er;class Dr{constructor(z,ne){this.content=z,this.name=ne}}e.$NP=Dr;class Ti extends Error{static NotFound(z){return new Ti(z,Ti.NotFound.name)}static NoPermissions(z){return new Ti(z,Ti.NoPermissions.name)}static Blocked(z){return new Ti(z,Ti.Blocked.name)}constructor(z,ne,Se){super(z,{cause:Se}),this.name="LanguageModelError",this.code=ne??""}}e.$OP=Ti;var Fn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Fn||(e.RelatedInformationType=Fn={}));var Ln;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Ln||(e.SpeechToTextStatus=Ln={}));var Mn;(function(B){B[B.Started=1]="Started",B[B.Stopped=2]="Stopped",B[B.Error=3]="Error"})(Mn||(e.TextToSpeechStatus=Mn={}));var zn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(zn||(e.KeywordRecognitionStatus=zn={}));class Sr{constructor(z,ne){this.text=z,this.range=ne}}e.$PP=Sr;var Un;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Un||(e.InlineEditTriggerKind=Un={}))}),define(Ce[269],Ie([1,0,5,7]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$uN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,T,p){if(this.a.size===0)throw new Error("No related information providers registered");const a=this.a.get(A);if(!a)throw new Error("related information provider not found");return await a.provideRelatedInformation(T,p)??[]}getRelatedInformation(A,T,p){return this.c.$getAiRelatedInformation(T,p)}registerRelatedInformationProvider(A,T,p){const a=this.b;return this.b++,this.a.set(a,p),this.c.$registerAiRelatedInformationProvider(a,T),new k.$wN(()=>{this.c.$unregisterAiRelatedInformationProvider(a),this.a.delete(a)})}}e.$ioc=C}),define(Ce[91],Ie([1,0,6,5,7,19,117,3,17]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=e.$toc=void 0,e.$toc=(0,T.$Fi)("IExtHostAuthentication");let a=class{constructor(u){this.b=new Map,this.c=new v.$me,this.onDidChangeSessions=this.c.event,this.d=new P,this.f=new P,this.a=u.getProxy(k.$uN.MainThreadAuthentication)}async getSession(u,E,d,n={}){const s=O.$qn.toKey(u.identifier),o=[...d].sort().join(" ");return await this.d.getOrCreate(`${s} ${E} ${o}`,async()=>{await this.a.$ensureProvider(E);const h=u.displayName||u.name;return this.a.$getSession(E,d,s,h,n)})}async getSessions(u,E,d){const n=O.$qn.toKey(u.identifier),s=[...d].sort().join(" ");return await this.f.getOrCreate(`${n} ${s}`,async()=>{await this.a.$ensureProvider(E);const o=u.displayName||u.name;return this.a.$getSessions(E,d,n,o)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,E){const d=this.b.get(u);return d?d.provider.removeSession(E):this.a.$removeSession(u,E)}registerAuthenticationProvider(u,E,d,n){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:E,provider:d,options:n??{supportsMultipleAccounts:!1}});const s=d.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(u,o));return this.a.$registerAuthenticationProvider(u,E,n?.supportsMultipleAccounts??!1),new C.$wN(()=>{s.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,E,d){const n=this.b.get(u);if(n)return await n.provider.createSession(E,d);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,E){const d=this.b.get(u);if(d)return await d.provider.removeSession(E);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,E,d){const n=this.b.get(u);if(n)return await n.provider.getSessions(E,d);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,E){return u.startsWith(A.$wM)||this.c.fire({provider:{id:u,label:E}}),Promise.resolve()}};e.$uoc=a,e.$uoc=a=Qe([Ve(0,p.$1P)],a);class P{constructor(){this.a=new Map}getOrCreate(u,E){const d=this.a.get(u);if(d)return d;const n=E().finally(()=>this.a.delete(u));return this.a.set(u,n),n}}}),define(Ce[122],Ie([1,0,2,5,7,3,17,12,18,13,20,25]),function(oe,e,v,k,C,O,A,T,p,a,P,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$zpc=e.$ypc=void 0;let E=class{static{u=this}static{this.c=0}static{this.d=250}constructor(n,s){this.h=s,this.f=new Map,this.g=n.getProxy(k.$uN.MainThreadDecorations)}registerFileDecorationProvider(n,s){const o=u.c++;this.f.set(o,{provider:n,extensionDescription:s}),this.g.$registerDecorationProvider(o,s.identifier.value);const h=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const r=(0,p.$4b)(i);if(r.length<=u.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,r.length);const t=r.map(g=>({uri:g,rank:(0,a.$jf)(g.path,"/")})),c=(0,p.$Bb)(t,(g,m)=>g.rank-m.rank||(0,a.$zf)(g.uri.path,m.uri.path)),l=[];e:for(const g of c){let m;for(const $ of g){const S=(0,P.$oc)($.uri.path);if(m!==S&&(m=S,l.push($.uri)>=u.d))break e}}this.g.$onDidChange(o,l)});return new C.$wN(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(n,s,o){if(!this.f.has(n))return Object.create(null);const h=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(n);return await Promise.all(s.map(async t=>{try{const{uri:c,id:l}=t,g=await Promise.resolve(i.provideFileDecoration(v.URI.revive(c),o));if(!g)return;try{C.$WO.validate(g),g.badge&&typeof g.badge!="string"&&(0,y.$7G)(r,"codiconDecoration"),h[l]=[g.propagate,g.tooltip,g.badge,g.color]}catch(m){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${m}`)}}catch(c){this.h.error(c)}})),h}};e.$ypc=E,e.$ypc=E=u=Qe([Ve(0,A.$1P),Ve(1,T.$_j)],E),e.$zpc=(0,O.$Fi)("IExtHostDecorations")}),define(Ce[270],Ie([1,0,14,2,7,5,16,22,13]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=void 0;class a{static{this.a=0}constructor(y,u,E){this.d=u,this.e=E,this.b=new Map,this.c=y.getProxy(O.$uN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,u){if(Object.keys(A.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const E=a.a++;this.b.set(E,u),this.c.$registerTextContentProvider(E,y);let d;if(typeof u.onDidChange=="function"){let n;d=u.onDidChange(async s=>{if(s.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(s))return;n&&await n;const o=this.$provideTextDocumentContent(E,s).then(async h=>{if(!h&&typeof h!="string")return;const i=this.d.getDocument(s);if(!i)return;const r=(0,p.$tf)(h);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(s,h)}).catch(v.$3).finally(()=>{n===o&&(n=void 0)});n=o})}return new C.$wN(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(y,u){const E=this.b.get(y);return E?Promise.resolve(E.provideTextDocumentContent(k.URI.revive(u),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Bpc=a}),define(Ce[123],Ie([1,0,62,16,13,326,210,7,18]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=e.$4P=void 0,e.$3P=P;const a=new Map;function P(d,n){n?a.set(d,n):a.delete(d)}function y(d){return a.get(d)}class u extends O.$lw{constructor(n,s,o,h,i,r,t){super(s,o,h,i),this.c=n,this.m=r,this.q=t,this.b=!1}dispose(){(0,v.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,p.$wb)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===k.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(s){return s?n.s(s):n.getText()},get eol(){return n.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(s){return n.t(s)},offsetAt(s){return n.u(s)},positionAt(s){return n.v(s)},validateRange(s){return n.w(s)},validatePosition(s){return n.x(s)},getWordRangeAtPosition(s,o){return n.y(s,o)}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,v.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,v.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const s=this.w(n);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const o=this.g,h=s.start.line,i=s.end.line,r=[];r.push(this.f[h].substring(s.start.character));for(let t=h+1;t<i;t++)r.push(this.f[t]);return r.push(this.f[i].substring(0,s.end.character)),r.join(o)}t(n){let s;if(n instanceof T.$xN?s=n.line:typeof n=="number"&&(s=n),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new E(s,this.f[s],s===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const s=this.j.getIndexOf(n),o=this.f[s.index].length;return new T.$xN(s.index,Math.min(s.remainder,o))}w(n){if(!(n instanceof T.$yN))throw new Error("Invalid argument");const s=this.x(n.start),o=this.x(n.end);return s===n.start&&o===n.end?n:new T.$yN(s.line,s.character,o.line,o.character)}x(n){if(!(n instanceof T.$xN))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:s,character:o}=n,h=!1;if(s<0)s=0,o=0,h=!0;else if(s>=this.f.length)s=this.f.length-1,o=this.f[s].length,h=!0;else{const i=this.f[s].length;o<0?(o=0,h=!0):o>i&&(o=i,h=!0)}return h?new T.$xN(s,o):n}y(n,s){const o=this.x(n);if(!s)s=y(this.m);else if((0,C.$sf)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const h=(0,A.$nt)(o.character+1,(0,A.$lt)(s),this.f[o.line],0);if(h)return new T.$yN(o.line,h.startColumn-1,o.line,h.endColumn-1)}}e.$4P=u;class E{constructor(n,s,o){this.a=n,this.b=s,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$yN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$yN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$5P=E}),define(Ce[271],Ie([1,0,5,7]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Epc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$uN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,T,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const a=this.a.get(A);if(!a)throw new Error("Embedding vector provider not found");const P=await a.provideEmbeddingVector(T,p);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,T,p){const a=this.b;return this.b++,this.a.set(a,p),this.c.$registerAiEmbeddingVectorProvider(T,a),new k.$wN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(a),this.a.delete(a)})}}e.$Epc=C}),define(Ce[69],Ie([1,0,5,30,7,23,3,17,51,4,11,24,16]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=e.$Joc=void 0,k=qe(k);let d=E=class{constructor(s,o){this.b=new Map,this.c=new P.$Oh,this.a=s.getProxy(v.$uN.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(i){try{let r;const t=h.b.get(i.scheme);return t?(await h.a.$ensureActivation(i.scheme),r=await t.impl.stat(i)):r=await h.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===k.FilePermission.Readonly?1:void 0}}catch(r){E.e(r)}},async readDirectory(i){try{const r=h.b.get(i.scheme);return r?(await h.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await h.a.$readdir(i)}catch(r){return E.e(r)}},async createDirectory(i){try{const r=h.b.get(i.scheme);return r&&!r.isReadonly?(await h.a.$ensureActivation(i.scheme),await h.d(r.impl,r.extUri,i)):await h.a.$mkdir(i)}catch(r){return E.e(r)}},async readFile(i){try{const r=h.b.get(i.scheme);return r?(await h.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await h.a.$readFile(i)).buffer}catch(r){return E.e(r)}},async writeFile(i,r){try{const t=h.b.get(i.scheme);return t&&!t.isReadonly?(await h.a.$ensureActivation(i.scheme),await h.d(t.impl,t.extUri,t.extUri.dirname(i)),await h.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await h.a.$writeFile(i,O.$Oe.wrap(r))}catch(t){return E.e(t)}},async delete(i,r){try{const t=h.b.get(i.scheme);return t&&!t.isReadonly&&!r?.useTrash?(await h.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...r})):await h.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(t){return E.e(t)}},async rename(i,r,t){try{return await h.a.$rename(i,r,{overwrite:!1,...t})}catch(c){return E.e(c)}},async copy(i,r,t){try{return await h.a.$copy(i,r,{overwrite:!1,...t})}catch(c){return E.e(c)}},isWritableFileSystem(i){const r=o.getCapabilities(i);if(typeof r=="number")return!(r&k.FileSystemProviderCapabilities.Readonly)}})}async d(s,o,h){const i=[];for(;!o.isEqual(h,o.dirname(h));)try{if(!((await s.stat(h)).type&k.FileType.Directory))throw C.$NO.FileExists(`Unable to create folder '${h.scheme===u.Schemas.file?h.fsPath:h.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(k.$pl(r)!==k.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(o.basename(h)),h=o.dirname(h)}for(let r=i.length-1;r>=0;r--){h=o.joinPath(h,i[r]);try{await s.createDirectory(h)}catch(t){if(k.$pl(t)!==k.FileSystemProviderErrorCode.FileExists)throw t}}}static e(s){if(s instanceof C.$NO)throw s;if(s instanceof k.$ll)switch(s.code){case k.FileSystemProviderErrorCode.FileExists:throw C.$NO.FileExists(s.message);case k.FileSystemProviderErrorCode.FileNotFound:throw C.$NO.FileNotFound(s.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw C.$NO.FileNotADirectory(s.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw C.$NO.FileIsADirectory(s.message);case k.FileSystemProviderErrorCode.NoPermissions:throw C.$NO.NoPermissions(s.message);case k.FileSystemProviderErrorCode.Unavailable:throw C.$NO.Unavailable(s.message);default:throw new C.$NO(s.message,s.name)}if(!(s instanceof Error))throw new C.$NO(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw C.$NO.Unavailable(s.message);switch(s.name){case k.FileSystemProviderErrorCode.FileExists:throw C.$NO.FileExists(s.message);case k.FileSystemProviderErrorCode.FileNotFound:throw C.$NO.FileNotFound(s.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw C.$NO.FileNotADirectory(s.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw C.$NO.FileIsADirectory(s.message);case k.FileSystemProviderErrorCode.NoPermissions:throw C.$NO.NoPermissions(s.message);case k.FileSystemProviderErrorCode.Unavailable:throw C.$NO.Unavailable(s.message);default:throw new C.$NO(s.message,s.name)}}addFileSystemProvider(s,o,h){return this.b.set(s,{impl:o,extUri:h?.isCaseSensitive?y.$9g:y.$$g,isReadonly:!!h?.isReadonly}),(0,a.$Uc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??y.$9g}};e.$Joc=d,e.$Joc=d=E=Qe([Ve(0,T.$1P),Ve(1,p.$noc)],d),e.$Koc=(0,A.$Fi)("IExtHostConsumerFileSystem")}),define(Ce[92],Ie([1,0,3,27,12,69,2]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=e.$Loc=void 0,e.$Loc=(0,v.$Fi)("IExtensionStoragePaths");let T=class{constructor(a,P,y){this.d=P,this.f=y,this.a=a.workspace??void 0,this.b=a.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(a){return A.URI.joinPath(this.b.workspaceStorageHome,a)}async h(){if(!this.a)return Promise.resolve(void 0);const a=this.a.id,P=await this.g(a);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(a){if(this.c)return A.URI.joinPath(this.c,a.identifier.value)}globalValue(a){return A.URI.joinPath(this.b.globalStorageHome,a.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Moc=T,e.$Moc=T=Qe([Ve(0,k.$eQ),Ve(1,C.$_j),Ve(2,O.$Koc)],T)}),define(Ce[272],Ie([1,0,7,17,6]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iqc=void 0;let O=class{constructor(T){this.a=new v.$XO(v.ColorThemeKind.Dark),this.b=new C.$me}get activeColorTheme(){return this.a}$onColorThemeChange(T){let p;switch(T){case"light":p=v.ColorThemeKind.Light;break;case"hcDark":p=v.ColorThemeKind.HighContrast;break;case"hcLight":p=v.ColorThemeKind.HighContrastLight;break;default:p=v.ColorThemeKind.Dark}this.a=new v.$XO(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$iqc=O,e.$iqc=O=Qe([Ve(0,k.$1P)],O)}),define(Ce[93],Ie([1,0,22,6,4,191,3,12,224,5,27,17,7]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YFb=e.$XFb=e.TunnelDtoConverter=void 0,O=qe(O),u=qe(u);class E extends p.$Kw{}var d;(function(s){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}s.fromApiTunnel=o;function h(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}s.fromServiceTunnel=h})(d||(e.TunnelDtoConverter=d={})),e.$XFb=(0,A.$Fi)("IExtHostTunnelService");let n=class extends C.$Wc{constructor(o,h,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new k.$me,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(a.$uN.MainThreadTunnelService)}async openTunnel(o,h){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const i=await this.a.$openTunnel(h,o.displayName);if(i){const r=new E(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,h){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:o,provider:h}),this.a.$registerPortsAttributesProvider(o,i),new u.$wN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,h,i,r,t){const c=[];for(const g of o){const m=this.r.get(g);if(!m)return[];c.push(...await Promise.all(h.map(async $=>{let S;try{S=await m.provider.providePortAttributes({port:$,pid:i,commandLine:r},t)}catch{S=await m.provider.providePortAttributes($,i,r,t)}return{providedAttributes:S,port:$}})))}const l=c.filter(g=>!!g.providedAttributes);return l.length>0?l.map(g=>({autoForwardAction:g.providedAttributes.autoForwardAction,port:g.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,h){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,t)=>await o.provideTunnel(r,t,v.CancellationToken.None)??void 0;const i=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,privacyOptions:h.tunnelFeatures?.privacyOptions,protocol:h.tunnelFeatures.protocol===void 0?!0:h.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,C.$Uc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,h){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(h?this.w(h):void 0);if(i){this.b=i;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const t=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,C.$Uc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,h){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(h&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,h){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,h);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const t=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:t}),d.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const h=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),i=o.filter((r,t)=>h[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$YFb=n,e.$YFb=n=Qe([Ve(0,y.$1P),Ve(1,P.$eQ),Ve(2,T.$_j)],n)}),define(Ce[8],Ie([1,0,18,23,148,273,60,29,137,49,73,26,143,24,35,15,2,106,33,152,94,52,108,77,116,115,235,249,81,90,55,56,246,7]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h,i,r,t,c,l,g,m,$,S,D,b,I,R,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$XP=ce,e.$YP=re,e.$ZP=Pe,A=qe(A),h=qe(h),i=qe(i),r=qe(r),S=qe(S),b=qe(b),w=qe(w);var M;(function(ye){function Te(J){const{selectionStartLineNumber:Ee,selectionStartColumn:We,positionLineNumber:Ye,positionColumn:Ge}=J,lt=new w.$xN(Ee-1,We-1),It=new w.$xN(Ye-1,Ge-1);return new w.$zN(lt,It)}ye.to=Te;function le(J){const{anchor:Ee,active:We}=J;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}ye.from=le})(M||(e.Selection=M={}));var N;(function(ye){function Te(J){if(!J)return;const{start:Ee,end:We}=J;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}ye.from=Te;function le(J){if(!J)return;const{startLineNumber:Ee,startColumn:We,endLineNumber:Ye,endColumn:Ge}=J;return new w.$yN(Ee-1,We-1,Ye-1,Ge-1)}ye.to=le})(N||(e.Range=N={}));var L;(function(ye){function Te(J){return{uri:J.uri,range:N.from(J.range)}}ye.from=Te;function le(J){return new w.$IN(s.URI.revive(J.uri),N.to(J.range))}ye.to=le})(L||(e.Location=L={}));var G;(function(ye){function Te(le){switch(le){case i.StandardTokenType.Comment:return w.StandardTokenType.Comment;case i.StandardTokenType.Other:return w.StandardTokenType.Other;case i.StandardTokenType.RegEx:return w.StandardTokenType.RegEx;case i.StandardTokenType.String:return w.StandardTokenType.String}}ye.to=Te})(G||(e.TokenType=G={}));var W;(function(ye){function Te(J){return new w.$xN(J.lineNumber-1,J.column-1)}ye.to=Te;function le(J){return{lineNumber:J.line+1,column:J.character+1}}ye.from=le})(W||(e.Position=W={}));var F;(function(ye){function Te(Ee,We,Ye){return(0,v.$Jb)((0,v.$4b)(Ee).map(Ge=>le(Ge,We,Ye)))}ye.from=Te;function le(Ee,We,Ye){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Ye?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:J(Ee.scheme,We),pattern:xe.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Ye?.isBuiltin}}function J(Ee,We){return We&&typeof Ee=="string"?We.transformOutgoingScheme(Ee):Ee}})(F||(e.DocumentSelector=F={}));var V;(function(ye){function Te(J){switch(J){case w.DiagnosticTag.Unnecessary:return c.MarkerTag.Unnecessary;case w.DiagnosticTag.Deprecated:return c.MarkerTag.Deprecated}}ye.from=Te;function le(J){switch(J){case c.MarkerTag.Unnecessary:return w.DiagnosticTag.Unnecessary;case c.MarkerTag.Deprecated:return w.DiagnosticTag.Deprecated;default:return}}ye.to=le})(V||(e.DiagnosticTag=V={}));var ae;(function(ye){function Te(J){let Ee;return J.code&&((0,n.$fg)(J.code)||(0,n.$jg)(J.code)?Ee=String(J.code):Ee={value:String(J.code.value),target:J.code.target}),{...N.from(J.range),message:J.message,source:J.source,code:Ee,severity:_.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map($e.from),tags:Array.isArray(J.tags)?(0,v.$Jb)(J.tags.map(V.from)):void 0}}ye.from=Te;function le(J){const Ee=new w.$KN(N.to(J),J.message,_.to(J.severity));return Ee.source=J.source,Ee.code=(0,n.$fg)(J.code)?J.code:J.code?.value,Ee.relatedInformation=J.relatedInformation&&J.relatedInformation.map($e.to),Ee.tags=J.tags&&(0,v.$Jb)(J.tags.map(V.to)),Ee}ye.to=le})(ae||(e.Diagnostic=ae={}));var $e;(function(ye){function Te(J){return{...N.from(J.location.range),message:J.message,resource:J.location.uri}}ye.from=Te;function le(J){return new w.$JN(new w.$IN(J.resource,N.to(J)),J.message)}ye.to=le})($e||(e.DiagnosticRelatedInformation=$e={}));var _;(function(ye){function Te(J){switch(J){case w.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}ye.from=Te;function le(J){switch(J){case c.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}ye.to=le})(_||(e.DiagnosticSeverity=_={}));var ge;(function(ye){function Te(J){return typeof J=="number"&&J>=w.ViewColumn.One?J-1:J===w.ViewColumn.Beside?f.$pE:f.$oE}ye.from=Te;function le(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=le})(ge||(e.ViewColumn=ge={}));function se(ye){return typeof ye.range<"u"}function ce(ye){return ye.length===0?!0:!!se(ye[0])}var we;(function(ye){function Te(Ge){return Ge.map(ye.from)}ye.fromMany=Te;function le(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function J(Ge){let lt;if(le(Ge)){const{language:Mt,value:ui}=Ge;lt={value:"```"+Mt+`
`+ui+"\n```\n"}}else w.$YN.isMarkdownString(Ge)?lt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?lt={value:Ge}:lt={value:""};const It=Object.create(null);lt.uris=It;const Jt=Mt=>{try{let ui=s.URI.parse(Mt,!0);ui=ui.with({query:Ee(ui.query,It)}),It[Mt]=ui}catch{}return""},ci=new p.marked.Renderer;return ci.link=Jt,ci.image=Mt=>typeof Mt=="string"?Jt(A.$$k(Mt).href):"",(0,p.marked)(lt.value,{renderer:ci}),lt}ye.from=J;function Ee(Ge,lt){if(!Ge)return Ge;let It;try{It=(0,a.$bi)(Ge)}catch{}if(!It)return Ge;let Jt=!1;return It=(0,y.$fo)(It,ci=>{if(s.URI.isUri(ci)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[Mt]=ci,Jt=!0,Mt}else return}),Jt?JSON.stringify(It):Ge}function We(Ge){const lt=new w.$YN(Ge.value,Ge.supportThemeIcons);return lt.isTrusted=Ge.isTrusted,lt.supportHtml=Ge.supportHtml,lt.baseUri=Ge.baseUri?s.URI.from(Ge.baseUri):void 0,lt}ye.to=We;function Ye(Ge){if(Ge)return typeof Ge=="string"?Ge:ye.from(Ge)}ye.fromStrict=Ye})(we||(e.MarkdownString=we={}));function re(ye){return ce(ye)?ye.map(Te=>({range:N.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?we.fromMany(Te.hoverMessage):Te.hoverMessage?we.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):ye.map(Te=>({range:N.from(Te)}))}function Pe(ye){return typeof ye>"u"?ye:typeof ye=="string"?s.URI.file(ye):ye}var Me;(function(ye){function Te(le){return typeof le>"u"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?Pe(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ye.from=Te})(Me||(e.ThemableDecorationAttachmentRenderOptions=Me={}));var Y;(function(ye){function Te(le){return typeof le>"u"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?Pe(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Me.from(le.before):void 0,after:le.after?Me.from(le.after):void 0}}ye.from=Te})(Y||(e.ThemableDecorationRenderOptions=Y={}));var q;(function(ye){function Te(le){if(typeof le>"u")return le;switch(le){case w.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case w.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}ye.from=Te})(q||(e.DecorationRangeBehavior=q={}));var ee;(function(ye){function Te(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?q.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?Y.from(le.light):void 0,dark:le.dark?Y.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?Pe(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Me.from(le.before):void 0,after:le.after?Me.from(le.after):void 0}}ye.from=Te})(ee||(e.DecorationRenderOptions=ee={}));var ve;(function(ye){function Te(J){return{text:J.newText,eol:J.newEol&&je.from(J.newEol),range:N.from(J.range)}}ye.from=Te;function le(J){const Ee=new w.$DN(N.to(J.range),J.text);return Ee.newEol=typeof J.eol>"u"?void 0:je.to(J.eol),Ee}ye.to=le})(ve||(e.TextEdit=ve={}));var ue;(function(ye){function Te(J,Ee){const We={edits:[]};if(J instanceof w.$GN){const Ye=new T.$Dc;for(const Ge of J._allEntries())Ge._type===w.FileEditType.File&&s.URI.isUri(Ge.to)&&Ge.from===void 0&&Ye.add(Ge.to);for(const Ge of J._allEntries())if(Ge._type===w.FileEditType.File){let lt;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?lt={type:"base64",value:(0,k.$9e)(k.$Oe.wrap(Ge.options.contents))}:lt={type:"dataTransferItem",id:Ge.options.contents._itemId}),We.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:lt},metadata:Ge.metadata})}else Ge._type===w.FileEditType.Text?We.edits.push({resource:Ge.uri,textEdit:ve.from(Ge.edit),versionId:Ye.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===w.FileEditType.Snippet?We.edits.push({resource:Ge.uri,textEdit:{range:N.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===w.FileEditType.Cell?We.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===w.FileEditType.CellReplace&&We.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:b.CellEditType.Replace,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Pt.from)}})}return We}ye.from=Te;function le(J){const Ee=new w.$GN,We=new T.$Cc;for(const Ye of J.edits)if(Ye.textEdit){const Ge=Ye,lt=s.URI.revive(Ge.resource),It=N.to(Ge.textEdit.range),Jt=Ge.textEdit.text,ci=Ge.textEdit.insertAsSnippet;let Mt;ci?Mt=w.$FN.replace(It,new w.$HN(Jt)):Mt=w.$DN.replace(It,Jt);const ui=We.get(lt);ui?ui.push(Mt):We.set(lt,[Mt])}else Ee.renameFile(s.URI.revive(Ye.oldResource),s.URI.revive(Ye.newResource),Ye.options);for(const[Ye,Ge]of We)Ee.set(Ye,Ge);return Ee}ye.to=le})(ue||(e.WorkspaceEdit=ue={}));var be;(function(ye){const Te=Object.create(null);Te[w.SymbolKind.File]=r.SymbolKind.File,Te[w.SymbolKind.Module]=r.SymbolKind.Module,Te[w.SymbolKind.Namespace]=r.SymbolKind.Namespace,Te[w.SymbolKind.Package]=r.SymbolKind.Package,Te[w.SymbolKind.Class]=r.SymbolKind.Class,Te[w.SymbolKind.Method]=r.SymbolKind.Method,Te[w.SymbolKind.Property]=r.SymbolKind.Property,Te[w.SymbolKind.Field]=r.SymbolKind.Field,Te[w.SymbolKind.Constructor]=r.SymbolKind.Constructor,Te[w.SymbolKind.Enum]=r.SymbolKind.Enum,Te[w.SymbolKind.Interface]=r.SymbolKind.Interface,Te[w.SymbolKind.Function]=r.SymbolKind.Function,Te[w.SymbolKind.Variable]=r.SymbolKind.Variable,Te[w.SymbolKind.Constant]=r.SymbolKind.Constant,Te[w.SymbolKind.String]=r.SymbolKind.String,Te[w.SymbolKind.Number]=r.SymbolKind.Number,Te[w.SymbolKind.Boolean]=r.SymbolKind.Boolean,Te[w.SymbolKind.Array]=r.SymbolKind.Array,Te[w.SymbolKind.Object]=r.SymbolKind.Object,Te[w.SymbolKind.Key]=r.SymbolKind.Key,Te[w.SymbolKind.Null]=r.SymbolKind.Null,Te[w.SymbolKind.EnumMember]=r.SymbolKind.EnumMember,Te[w.SymbolKind.Struct]=r.SymbolKind.Struct,Te[w.SymbolKind.Event]=r.SymbolKind.Event,Te[w.SymbolKind.Operator]=r.SymbolKind.Operator,Te[w.SymbolKind.TypeParameter]=r.SymbolKind.TypeParameter;function le(Ee){return typeof Te[Ee]=="number"?Te[Ee]:r.SymbolKind.Property}ye.from=le;function J(Ee){for(const We in Te)if(Te[We]===Ee)return Number(We);return w.SymbolKind.Property}ye.to=J})(be||(e.SymbolKind=be={}));var de;(function(ye){function Te(J){switch(J){case w.SymbolTag.Deprecated:return r.SymbolTag.Deprecated}}ye.from=Te;function le(J){switch(J){case r.SymbolTag.Deprecated:return w.SymbolTag.Deprecated}}ye.to=le})(de||(e.SymbolTag=de={}));var X;(function(ye){function Te(J){return{name:J.name,kind:be.from(J.kind),tags:J.tags&&J.tags.map(de.from),containerName:J.containerName,location:ze.from(J.location)}}ye.from=Te;function le(J){const Ee=new w.$PN(J.name,be.to(J.kind),J.containerName,ze.to(J.location));return Ee.tags=J.tags&&J.tags.map(de.to),Ee}ye.to=le})(X||(e.WorkspaceSymbol=X={}));var Z;(function(ye){function Te(J){const Ee={name:J.name||"!!MISSING: name!!",detail:J.detail,range:N.from(J.range),selectionRange:N.from(J.selectionRange),kind:be.from(J.kind),tags:J.tags?.map(de.from)??[]};return J.children&&(Ee.children=J.children.map(Te)),Ee}ye.from=Te;function le(J){const Ee=new w.$QN(J.name,J.detail,be.to(J.kind),N.to(J.range),N.to(J.selectionRange));return(0,v.$Nb)(J.tags)&&(Ee.tags=J.tags.map(de.to)),J.children&&(Ee.children=J.children.map(le)),Ee}ye.to=le})(Z||(e.DocumentSymbol=Z={}));var me;(function(ye){function Te(J){const Ee=new w.$UN(be.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),N.to(J.range),N.to(J.selectionRange));return Ee._sessionId=J._sessionId,Ee._itemId=J._itemId,Ee}ye.to=Te;function le(J,Ee,We){if(Ee=Ee??J._sessionId,We=We??J._itemId,Ee===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:We,name:J.name,detail:J.detail,kind:be.from(J.kind),uri:J.uri,range:N.from(J.range),selectionRange:N.from(J.selectionRange),tags:J.tags?.map(de.from)}}ye.from=le})(me||(e.CallHierarchyItem=me={}));var pe;(function(ye){function Te(le){return new w.$VN(me.to(le.from),le.fromRanges.map(J=>N.to(J)))}ye.to=Te})(pe||(e.CallHierarchyIncomingCall=pe={}));var Oe;(function(ye){function Te(le){return new w.$WN(me.to(le.to),le.fromRanges.map(J=>N.to(J)))}ye.to=Te})(Oe||(e.CallHierarchyOutgoingCall=Oe={}));var ze;(function(ye){function Te(J){return{range:J.range&&N.from(J.range),uri:J.uri}}ye.from=Te;function le(J){return new w.$IN(s.URI.revive(J.uri),N.to(J.range))}ye.to=le})(ze||(e.location=ze={}));var ke;(function(ye){function Te(J){const Ee=J,We=J;return{originSelectionRange:Ee.originSelectionRange?N.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:We.uri,range:N.from(Ee.targetRange?Ee.targetRange:We.range),targetSelectionRange:Ee.targetSelectionRange?N.from(Ee.targetSelectionRange):void 0}}ye.from=Te;function le(J){return{targetUri:s.URI.revive(J.uri),targetRange:N.to(J.range),targetSelectionRange:J.targetSelectionRange?N.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?N.to(J.originSelectionRange):void 0}}ye.to=le})(ke||(e.DefinitionLink=ke={}));var Ae;(function(ye){function Te(J){return{range:N.from(J.range),contents:we.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}ye.from=Te;function le(J){const Ee=J.contents.map(we.to),We=N.to(J.range),Ye=J.canIncreaseVerbosity,Ge=J.canDecreaseVerbosity;return new w.$MN(Ee,We,Ye,Ge)}ye.to=le})(Ae||(e.Hover=Ae={}));var Ne;(function(ye){function Te(J){return{range:N.from(J.range),expression:J.expression}}ye.from=Te;function le(J){return new w.$HO(N.to(J.range),J.expression)}ye.to=le})(Ne||(e.EvaluatableExpression=Ne={}));var j;(function(ye){function Te(J){if(J instanceof w.$IO)return{type:"text",range:N.from(J.range),text:J.text};if(J instanceof w.$JO)return{type:"variable",range:N.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof w.$KO)return{type:"expression",range:N.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Te;function le(J){switch(J.type){case"text":return{range:N.to(J.range),text:J.text};case"variable":return{range:N.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:N.to(J.range),expression:J.expression}}}ye.to=le})(j||(e.InlineValue=j={}));var U;(function(ye){function Te(J){return{frameId:J.frameId,stoppedLocation:N.from(J.stoppedLocation)}}ye.from=Te;function le(J){return new w.$LO(J.frameId,N.to(J.stoppedLocation))}ye.to=le})(U||(e.InlineValueContext=U={}));var K;(function(ye){function Te(J){return{range:N.from(J.range),kind:J.kind}}ye.from=Te;function le(J){return new w.$NN(N.to(J.range),J.kind)}ye.to=le})(K||(e.DocumentHighlight=K={}));var H;(function(ye){function Te(J){return{uri:J.uri,highlights:J.highlights.map(K.from)}}ye.from=Te;function le(J){return new w.$ON(s.URI.revive(J.uri),J.highlights.map(K.to))}ye.to=le})(H||(e.MultiDocumentHighlight=H={}));var ie;(function(ye){function Te(le){switch(le){case r.CompletionTriggerKind.TriggerCharacter:return w.CompletionTriggerKind.TriggerCharacter;case r.CompletionTriggerKind.TriggerForIncompleteCompletions:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case r.CompletionTriggerKind.Invoke:default:return w.CompletionTriggerKind.Invoke}}ye.to=Te})(ie||(e.CompletionTriggerKind=ie={}));var fe;(function(ye){function Te(le){return{triggerKind:ie.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ye.to=Te})(fe||(e.CompletionContext=fe={}));var Re;(function(ye){function Te(J){switch(J){case w.CompletionItemTag.Deprecated:return r.CompletionItemTag.Deprecated}}ye.from=Te;function le(J){switch(J){case r.CompletionItemTag.Deprecated:return w.CompletionItemTag.Deprecated}}ye.to=le})(Re||(e.CompletionItemTag=Re={}));var Ue;(function(ye){const Te=new Map([[w.CompletionItemKind.Method,r.CompletionItemKind.Method],[w.CompletionItemKind.Function,r.CompletionItemKind.Function],[w.CompletionItemKind.Constructor,r.CompletionItemKind.Constructor],[w.CompletionItemKind.Field,r.CompletionItemKind.Field],[w.CompletionItemKind.Variable,r.CompletionItemKind.Variable],[w.CompletionItemKind.Class,r.CompletionItemKind.Class],[w.CompletionItemKind.Interface,r.CompletionItemKind.Interface],[w.CompletionItemKind.Struct,r.CompletionItemKind.Struct],[w.CompletionItemKind.Module,r.CompletionItemKind.Module],[w.CompletionItemKind.Property,r.CompletionItemKind.Property],[w.CompletionItemKind.Unit,r.CompletionItemKind.Unit],[w.CompletionItemKind.Value,r.CompletionItemKind.Value],[w.CompletionItemKind.Constant,r.CompletionItemKind.Constant],[w.CompletionItemKind.Enum,r.CompletionItemKind.Enum],[w.CompletionItemKind.EnumMember,r.CompletionItemKind.EnumMember],[w.CompletionItemKind.Keyword,r.CompletionItemKind.Keyword],[w.CompletionItemKind.Snippet,r.CompletionItemKind.Snippet],[w.CompletionItemKind.Text,r.CompletionItemKind.Text],[w.CompletionItemKind.Color,r.CompletionItemKind.Color],[w.CompletionItemKind.File,r.CompletionItemKind.File],[w.CompletionItemKind.Reference,r.CompletionItemKind.Reference],[w.CompletionItemKind.Folder,r.CompletionItemKind.Folder],[w.CompletionItemKind.Event,r.CompletionItemKind.Event],[w.CompletionItemKind.Operator,r.CompletionItemKind.Operator],[w.CompletionItemKind.TypeParameter,r.CompletionItemKind.TypeParameter],[w.CompletionItemKind.Issue,r.CompletionItemKind.Issue],[w.CompletionItemKind.User,r.CompletionItemKind.User]]);function le(We){return Te.get(We)??r.CompletionItemKind.Property}ye.from=le;const J=new Map([[r.CompletionItemKind.Method,w.CompletionItemKind.Method],[r.CompletionItemKind.Function,w.CompletionItemKind.Function],[r.CompletionItemKind.Constructor,w.CompletionItemKind.Constructor],[r.CompletionItemKind.Field,w.CompletionItemKind.Field],[r.CompletionItemKind.Variable,w.CompletionItemKind.Variable],[r.CompletionItemKind.Class,w.CompletionItemKind.Class],[r.CompletionItemKind.Interface,w.CompletionItemKind.Interface],[r.CompletionItemKind.Struct,w.CompletionItemKind.Struct],[r.CompletionItemKind.Module,w.CompletionItemKind.Module],[r.CompletionItemKind.Property,w.CompletionItemKind.Property],[r.CompletionItemKind.Unit,w.CompletionItemKind.Unit],[r.CompletionItemKind.Value,w.CompletionItemKind.Value],[r.CompletionItemKind.Constant,w.CompletionItemKind.Constant],[r.CompletionItemKind.Enum,w.CompletionItemKind.Enum],[r.CompletionItemKind.EnumMember,w.CompletionItemKind.EnumMember],[r.CompletionItemKind.Keyword,w.CompletionItemKind.Keyword],[r.CompletionItemKind.Snippet,w.CompletionItemKind.Snippet],[r.CompletionItemKind.Text,w.CompletionItemKind.Text],[r.CompletionItemKind.Color,w.CompletionItemKind.Color],[r.CompletionItemKind.File,w.CompletionItemKind.File],[r.CompletionItemKind.Reference,w.CompletionItemKind.Reference],[r.CompletionItemKind.Folder,w.CompletionItemKind.Folder],[r.CompletionItemKind.Event,w.CompletionItemKind.Event],[r.CompletionItemKind.Operator,w.CompletionItemKind.Operator],[r.CompletionItemKind.TypeParameter,w.CompletionItemKind.TypeParameter],[r.CompletionItemKind.User,w.CompletionItemKind.User],[r.CompletionItemKind.Issue,w.CompletionItemKind.Issue]]);function Ee(We){return J.get(We)??w.CompletionItemKind.Property}ye.to=Ee})(Ue||(e.CompletionItemKind=Ue={}));var Ke;(function(ye){function Te(le,J){const Ee=new w.$5N(le.label);return Ee.insertText=le.insertText,Ee.kind=Ue.to(le.kind),Ee.tags=le.tags?.map(Re.to),Ee.detail=le.detail,Ee.documentation=A.$5k(le.documentation)?we.to(le.documentation):le.documentation,Ee.sortText=le.sortText,Ee.filterText=le.filterText,Ee.preselect=le.preselect,Ee.commitCharacters=le.commitCharacters,h.$Lt.isIRange(le.range)?Ee.range=N.to(le.range):typeof le.range=="object"&&(Ee.range={inserting:N.to(le.range.insert),replacing:N.to(le.range.replace)}),Ee.keepWhitespace=typeof le.insertTextRules>"u"?!1:!!(le.insertTextRules&r.CompletionItemInsertTextRule.KeepWhitespace),typeof le.insertTextRules<"u"&&le.insertTextRules&r.CompletionItemInsertTextRule.InsertAsSnippet?Ee.insertText=new w.$HN(le.insertText):(Ee.insertText=le.insertText,Ee.textEdit=Ee.range instanceof w.$yN?new w.$DN(Ee.range,Ee.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Ee.additionalTextEdits=le.additionalTextEdits.map(We=>ve.to(We))),Ee.command=J&&le.command?J.fromInternal(le.command):void 0,Ee}ye.to=Te})(Ke||(e.CompletionItem=Ke={}));var _e;(function(ye){function Te(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:we.fromStrict(J.documentation)}}ye.from=Te;function le(J){return{label:J.label,documentation:A.$5k(J.documentation)?we.to(J.documentation):J.documentation}}ye.to=le})(_e||(e.ParameterInformation=_e={}));var tt;(function(ye){function Te(J){return{label:J.label,documentation:we.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(_e.from):[],activeParameter:J.activeParameter}}ye.from=Te;function le(J){return{label:J.label,documentation:A.$5k(J.documentation)?we.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(_e.to):[],activeParameter:J.activeParameter}}ye.to=le})(tt||(e.SignatureInformation=tt={}));var nt;(function(ye){function Te(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(tt.from):[]}}ye.from=Te;function le(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(tt.to):[]}}ye.to=le})(nt||(e.SignatureHelp=nt={}));var et;(function(ye){function Te(le,J){const Ee=new w.$4N(W.to(J.position),typeof J.label=="string"?J.label:J.label.map(rt.to.bind(void 0,le)),J.kind&&ft.to(J.kind));return Ee.textEdits=J.textEdits&&J.textEdits.map(ve.to),Ee.tooltip=A.$5k(J.tooltip)?we.to(J.tooltip):J.tooltip,Ee.paddingLeft=J.paddingLeft,Ee.paddingRight=J.paddingRight,Ee}ye.to=Te})(et||(e.InlayHint=et={}));var rt;(function(ye){function Te(le,J){const Ee=new w.$3N(J.label);return Ee.tooltip=A.$5k(J.tooltip)?we.to(J.tooltip):J.tooltip,r.Command.is(J.command)&&(Ee.command=le.fromInternal(J.command)),J.location&&(Ee.location=ze.to(J.location)),Ee}ye.to=Te})(rt||(e.InlayHintLabelPart=rt={}));var ft;(function(ye){function Te(J){return J}ye.from=Te;function le(J){return J}ye.to=le})(ft||(e.InlayHintKind=ft={}));var ct;(function(ye){function Te(J){return{range:N.from(J.range),url:J.target,tooltip:J.tooltip}}ye.from=Te;function le(J){let Ee;if(J.url)try{Ee=typeof J.url=="string"?s.URI.parse(J.url,!0):s.URI.revive(J.url)}catch{}const We=new w.$0N(N.to(J.range),Ee);return We.tooltip=J.tooltip,We}ye.to=le})(ct||(e.DocumentLink=ct={}));var st;(function(ye){function Te(J){const Ee=new w.$aO(J.label);return J.textEdit&&(Ee.textEdit=ve.to(J.textEdit)),J.additionalTextEdits&&(Ee.additionalTextEdits=J.additionalTextEdits.map(We=>ve.to(We))),Ee}ye.to=Te;function le(J){return{label:J.label,textEdit:J.textEdit?ve.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Ee=>ve.from(Ee)):void 0}}ye.from=le})(st||(e.ColorPresentation=st={}));var ut;(function(ye){function Te(J){return new w.$$N(J[0],J[1],J[2],J[3])}ye.to=Te;function le(J){return[J.red,J.green,J.blue,J.alpha]}ye.from=le})(ut||(e.Color=ut={}));var gt;(function(ye){function Te(J){return{range:N.from(J.range)}}ye.from=Te;function le(J){return new w.$TN(N.to(J.range))}ye.to=le})(gt||(e.SelectionRange=gt={}));var pt;(function(ye){function Te(le){switch(le){case m.SaveReason.AUTO:return w.TextDocumentSaveReason.AfterDelay;case m.SaveReason.EXPLICIT:return w.TextDocumentSaveReason.Manual;case m.SaveReason.FOCUS_CHANGE:case m.SaveReason.WINDOW_CHANGE:return w.TextDocumentSaveReason.FocusOut}}ye.to=Te})(pt||(e.TextDocumentSaveReason=pt={}));var Be;(function(ye){function Te(J){switch(J){case w.TextEditorLineNumbersStyle.Off:return o.RenderLineNumbersType.Off;case w.TextEditorLineNumbersStyle.Relative:return o.RenderLineNumbersType.Relative;case w.TextEditorLineNumbersStyle.Interval:return o.RenderLineNumbersType.Interval;case w.TextEditorLineNumbersStyle.On:default:return o.RenderLineNumbersType.On}}ye.from=Te;function le(J){switch(J){case o.RenderLineNumbersType.Off:return w.TextEditorLineNumbersStyle.Off;case o.RenderLineNumbersType.Relative:return w.TextEditorLineNumbersStyle.Relative;case o.RenderLineNumbersType.Interval:return w.TextEditorLineNumbersStyle.Interval;case o.RenderLineNumbersType.On:default:return w.TextEditorLineNumbersStyle.On}}ye.to=le})(Be||(e.TextEditorLineNumbersStyle=Be={}));var je;(function(ye){function Te(J){if(J===w.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(J===w.EndOfLine.LF)return t.EndOfLineSequence.LF}ye.from=Te;function le(J){if(J===t.EndOfLineSequence.CRLF)return w.EndOfLine.CRLF;if(J===t.EndOfLineSequence.LF)return w.EndOfLine.LF}ye.to=le})(je||(e.EndOfLine=je={}));var Q;(function(ye){function Te(le){if(typeof le=="object")return le.viewId;switch(le){case w.ProgressLocation.SourceControl:return l.ProgressLocation.Scm;case w.ProgressLocation.Window:return l.ProgressLocation.Window;case w.ProgressLocation.Notification:return l.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}ye.from=Te})(Q||(e.ProgressLocation=Q={}));var x;(function(ye){function Te(J){const Ee={start:J.start+1,end:J.end+1};return J.kind&&(Ee.kind=De.from(J.kind)),Ee}ye.from=Te;function le(J){const Ee={start:J.start-1,end:J.end-1};return J.kind&&(Ee.kind=De.to(J.kind)),Ee}ye.to=le})(x||(e.FoldingRange=x={}));var De;(function(ye){function Te(J){if(J)switch(J){case w.FoldingRangeKind.Comment:return r.$Lu.Comment;case w.FoldingRangeKind.Imports:return r.$Lu.Imports;case w.FoldingRangeKind.Region:return r.$Lu.Region}}ye.from=Te;function le(J){if(J)switch(J.value){case r.$Lu.Comment.value:return w.FoldingRangeKind.Comment;case r.$Lu.Imports.value:return w.FoldingRangeKind.Imports;case r.$Lu.Region.value:return w.FoldingRangeKind.Region}}ye.to=le})(De||(e.FoldingRangeKind=De={}));var Je;(function(ye){function Te(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?N.from(le.selection):void 0,override:typeof le.override=="boolean"?m.$SF.id:void 0}}ye.from=Te})(Je||(e.TextEditorOpenOptions=Je={}));var xe;(function(ye){function Te(We){return We instanceof w.$vO?We.toJSON():typeof We=="string"?We:le(We)||J(We)?new w.$vO(We.baseUri??We.base,We.pattern).toJSON():We}ye.from=Te;function le(We){const Ye=We;return Ye?s.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function J(We){const Ye=We;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Ee(We){return typeof We=="string"?We:new w.$vO(s.URI.revive(We.baseUri),We.pattern)}ye.to=Ee})(xe||(e.GlobPattern=xe={}));var ht;(function(ye){function Te(le){if(le){if(Array.isArray(le))return le.map(Te);if(typeof le=="string")return le;{const J=le;return{language:J.language,scheme:J.scheme,pattern:xe.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}ye.from=Te})(ht||(e.LanguageSelector=ht={}));var $t;(function(ye){function Te(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Ee=>Array.isArray(Ee)&&Ee.every(We=>We&&typeof We=="object"&&"uri"in We&&s.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ye=>Ye instanceof w.$yN)))}ye.is=Te;function le(J){return{documents:J.documents.map(Ee=>Ee.map(We=>({uri:s.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ye=>N.from(Ye))})))}}ye.from=le})($t||(e.MappedEditsContext=$t={}));var Ft;(function(ye){function Te(J){return{start:J.start,end:J.end}}ye.from=Te;function le(J){return new w.$YO(J.start,J.end)}ye.to=le})(Ft||(e.NotebookRange=Ft={}));var zt;(function(ye){function Te(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}ye.to=Te;function le(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}ye.from=le})(zt||(e.NotebookCellExecutionSummary=zt={}));var Yt;(function(ye){function Te(le){if(le===b.NotebookCellExecutionState.Unconfirmed)return w.NotebookCellExecutionState.Pending;if(le===b.NotebookCellExecutionState.Pending)return;if(le===b.NotebookCellExecutionState.Executing)return w.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${le}`)}ye.to=Te})(Yt||(e.NotebookCellExecutionState=Yt={}));var fi;(function(ye){function Te(J){switch(J){case w.NotebookCellKind.Markup:return b.CellKind.Markup;case w.NotebookCellKind.Code:default:return b.CellKind.Code}}ye.from=Te;function le(J){switch(J){case b.CellKind.Markup:return w.NotebookCellKind.Markup;case b.CellKind.Code:default:return w.NotebookCellKind.Code}}ye.to=le})(fi||(e.NotebookCellKind=fi={}));var Ze;(function(ye){function Te(J){const Ee={metadata:J.metadata??Object.create(null),cells:[]};for(const We of J.cells)w.$ZO.validate(We),Ee.cells.push(Pt.from(We));return Ee}ye.from=Te;function le(J){const Ee=new w.$1O(J.cells.map(Pt.to));return(0,n.$sg)(J.metadata)||(Ee.metadata=J.metadata),Ee}ye.to=le})(Ze||(e.NotebookData=Ze={}));var Pt;(function(ye){function Te(J){return{cellKind:fi.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:zt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Qt.from):[]}}ye.from=Te;function le(J){return new w.$ZO(fi.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Qt.to):void 0,J.metadata,J.internalMetadata?zt.to(J.internalMetadata):void 0)}ye.to=le})(Pt||(e.NotebookCellData=Pt={}));var Kt;(function(ye){function Te(J){return{mime:J.mime,valueBytes:k.$Oe.wrap(J.data)}}ye.from=Te;function le(J){return new w.$2O(J.valueBytes.buffer,J.mime)}ye.to=le})(Kt||(e.NotebookCellOutputItem=Kt={}));var Qt;(function(ye){function Te(J){return{outputId:J.id,items:J.items.map(Kt.from),metadata:J.metadata}}ye.from=Te;function le(J){const Ee=J.items.map(Kt.to);return new w.$3O(Ee,J.outputId,J.metadata)}ye.to=le})(Qt||(e.NotebookCellOutput=Qt={}));var mt;(function(ye){function Te(Ee){return J(Ee)?{include:xe.from(Ee.include)??void 0,exclude:xe.from(Ee.exclude)??void 0}:xe.from(Ee)??void 0}ye.from=Te;function le(Ee){return J(Ee)?{include:xe.to(Ee.include),exclude:xe.to(Ee.exclude)}:xe.to(Ee)}ye.to=le;function J(Ee){const We=Ee;return We?!(0,n.$og)(We.include)&&!(0,n.$og)(We.exclude):!1}})(mt||(e.NotebookExclusiveDocumentPattern=mt={}));var vt;(function(ye){function Te(le,J,Ee){const We=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===w.NotebookCellStatusBarAlignment.Left?b.CellStatusbarAlignment.Left:b.CellStatusbarAlignment.Right,command:J.toInternal(We,Ee),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}ye.from=Te})(vt||(e.NotebookStatusBarItem=vt={}));var ii;(function(ye){function Te(le,J,Ee){const We=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{command:J.toInternal(We,Ee),label:le.label,description:le.description,detail:le.detail,documentation:le.documentation}}ye.from=Te})(ii||(e.NotebookKernelSourceAction=ii={}));var Zt;(function(ye){function Te(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{},cellContentMetadata:le?.cellContentMetadata??{}}}ye.from=Te})(Zt||(e.NotebookDocumentContentOptions=Zt={}));var qt;(function(ye){function Te(J){return{uri:J.uri,provides:J.provides}}ye.from=Te;function le(J){return new w.$5O(s.URI.revive(J.uri),J.provides)}ye.to=le})(qt||(e.NotebookRendererScript=qt={}));var yt;(function(ye){function Te(J){return{message:we.fromStrict(J.message)||"",type:R.TestMessageType.Error,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:N.from(J.location.range),uri:J.location.uri}}}ye.from=Te;function le(J){const Ee=new w.$$O(typeof J.message=="string"?J.message:we.to(J.message));return Ee.actualOutput=J.actual,Ee.expectedOutput=J.expected,Ee.contextValue=J.contextValue,Ee.location=J.location?ze.to(J.location):void 0,Ee}ye.to=le})(yt||(e.TestMessage=yt={}));var Nt;(function(ye){ye.namespace=R.$YI,ye.denamespace=R.$ZI})(Nt||(e.TestTag=Nt={}));var li;(function(ye){function Te(J){const Ee=(0,g.$WP)(J).controllerId;return{extId:I.$TI.fromExtHostTestItem(J,Ee).toString(),label:J.label,uri:s.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(We=>Nt.namespace(Ee,We.id)),range:h.$Lt.lift(N.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&we.fromStrict(J.error)||null}}ye.from=Te;function le(J){return{parent:void 0,error:void 0,id:I.$TI.fromString(J.extId).localId,label:J.label,uri:s.URI.revive(J.uri),tags:(J.tags||[]).map(Ee=>{const{tagId:We}=Nt.denamespace(Ee);return new w.$_O(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}ye.toPlain=le})(li||(e.TestItem=li={})),function(ye){function Te(J){return{id:J.id}}ye.from=Te;function le(J){return new w.$_O(J.id)}ye.to=le}(Nt||(e.TestTag=Nt={}));var Vt;(function(ye){const Te=(J,Ee)=>{const We=J.value;if(!We)return;const Ye={...li.toPlain(We.item),parent:Ee,taskStates:We.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(lt=>lt.type===R.TestMessageType.Error).map(yt.to)})),children:[]};if(J.children)for(const Ge of J.children.values()){const lt=Te(Ge,Ye);lt&&Ye.children.push(lt)}return Ye};function le(J){const Ee=new u.$SI;for(const Ge of J.items)Ee.insert(I.$TI.fromString(Ge.item.extId).path,Ge);const We=[Ee.nodes],Ye=[];for(;We.length;)for(const Ge of We.pop())Ge.value?Ye.push(Ge):Ge.children&&We.push(Ge.children.values());return{completedAt:J.completedAt,results:Ye.map(Ge=>Te(Ge)).filter(n.$ng)}}ye.to=le})(Vt||(e.TestResults=Vt={}));var Xe;(function(ye){function Te(We){return{covered:We.covered,total:We.total}}function le(We){return"line"in We?W.from(We):N.from(We)}function J(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:le(We.location),type:R.DetailType.Statement,branches:We.branches.length?We.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&le(Ye.location),label:Ye.label})):void 0}:{type:R.DetailType.Declaration,name:We.name,count:We.executed,location:le(We.location)}}ye.fromDetails=J;function Ee(We,Ye,Ge){return w.$bP(Ge.statementCoverage),w.$bP(Ge.branchCoverage),w.$bP(Ge.declarationCoverage),{id:Ye,uri:Ge.uri,statement:Te(Ge.statementCoverage),branch:Ge.branchCoverage&&Te(Ge.branchCoverage),declaration:Ge.declarationCoverage&&Te(Ge.declarationCoverage),testIds:Ge instanceof w.$cP&&Ge.fromTests.length?Ge.fromTests.map(lt=>I.$TI.fromExtHostTestItem(lt,We).toString()):void 0}}ye.fromFile=Ee})(Xe||(e.TestCoverage=Xe={}));var xt;(function(ye){function Te(le){switch(le){case r.CodeActionTriggerType.Invoke:return w.CodeActionTriggerKind.Invoke;case r.CodeActionTriggerType.Auto:return w.CodeActionTriggerKind.Automatic}}ye.to=Te})(xt||(e.CodeActionTriggerKind=xt={}));var ni;(function(ye){function Te(J){const Ee=new w.$gP(be.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),N.to(J.range),N.to(J.selectionRange));return Ee._sessionId=J._sessionId,Ee._itemId=J._itemId,Ee}ye.to=Te;function le(J,Ee,We){if(Ee=Ee??J._sessionId,We=We??J._itemId,Ee===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:We,kind:be.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:N.from(J.range),selectionRange:N.from(J.selectionRange),tags:J.tags?.map(de.from)}}ye.from=le})(ni||(e.TypeHierarchyItem=ni={}));var hi;(function(ye){function Te(le){if(le)return{value:le.value,tooltip:le.tooltip}}ye.from=Te})(hi||(e.ViewBadge=hi={}));var kt;(function(ye){function Te(We,Ye,Ge){const lt=Ye.fileData;return lt?new w.$nO(new w.$oO(lt.name,s.URI.revive(lt.uri),lt.id,(0,O.$fb)(()=>Ge(lt.id)))):We===P.$8s.uriList&&Ye.uriListData?new w.$mO(Ee(Ye.uriListData)):new w.$mO(Ye.asString)}ye.to=Te;async function le(We,Ye){const Ge=await Ye.asString();if(We===P.$8s.uriList)return{asString:Ge,fileData:void 0,uriListData:J(Ge)};const lt=Ye.asFile();return{asString:Ge,fileData:lt?{name:lt.name,uri:lt.uri,id:lt._itemId??lt.id}:void 0}}ye.from=le;function J(We){return C.$pu.split(We).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return s.URI.parse(Ye)}catch{}return Ye})}function Ee(We){return C.$pu.create(We.map(Ye=>typeof Ye=="string"?Ye:s.URI.revive(Ye)))}})(kt||(e.DataTransferItem=kt={}));var Lt;(function(ye){function Te(J,Ee){const We=J.items.map(([Ye,Ge])=>[Ye,kt.to(Ye,Ge,Ee)]);return new w.$pO(We)}ye.toDataTransfer=Te;async function le(J){const Ee={items:[]},We=[];for(const[Ye,Ge]of J)We.push((async()=>{Ee.items.push([Ye,await kt.from(Ye,Ge)])})());return await Promise.all(We),Ee}ye.from=le})(Lt||(e.DataTransfer=Lt={}));var At;(function(ye){function Te(J,Ee){return{kind:"reply",agentId:J.participant??Ee?.agentId??"",subCommand:J.command??Ee?.command,message:J.prompt,title:J.label}}ye.from=Te;function le(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}ye.to=le})(At||(e.ChatFollowup=At={}));var Ut;(function(ye){function Te(J){switch(J){case S.ChatMessageRole.System:return w.LanguageModelChatMessageRole.System;case S.ChatMessageRole.User:return w.LanguageModelChatMessageRole.User;case S.ChatMessageRole.Assistant:return w.LanguageModelChatMessageRole.Assistant}}ye.to=Te;function le(J){switch(J){case w.LanguageModelChatMessageRole.System:return S.ChatMessageRole.System;case w.LanguageModelChatMessageRole.User:return S.ChatMessageRole.User;case w.LanguageModelChatMessageRole.Assistant:return S.ChatMessageRole.Assistant}return S.ChatMessageRole.User}ye.from=le})(Ut||(e.LanguageModelChatMessageRole=Ut={}));var ri;(function(ye){function Te(J){let Ee="",We;J.content.type==="text"?Ee=J.content.value:We=new w.$HP(J.content.name,J.content.value,J.content.isError);const Ye=Ut.to(J.role),Ge=new w.$IP(Ye,Ee,J.name);return We!==void 0&&(Ge.content2=We),Ge}ye.to=Te;function le(J){const Ee=Ut.from(J.role),We=J.name;let Ye;return J.content2 instanceof w.$HP?Ye={type:"function_result",name:J.content2.name,value:J.content2.content,isError:J.content2.isError}:Ye={type:"text",value:J.content},{role:Ee,name:We,content:Ye}}ye.from=le})(ri||(e.LanguageModelChatMessage=ri={}));var _t;(function(ye){function Te(J){return{kind:"markdownContent",content:we.from(J.value)}}ye.from=Te;function le(J){return new w.$tP(we.to(J.content))}ye.to=le})(_t||(e.ChatResponseMarkdownPart=_t={}));var si;(function(ye){function Te(J){return{kind:"markdownVuln",content:we.from(J.value),vulnerabilities:J.vulnerabilities}}ye.from=Te;function le(J){return new w.$uP(we.to(J.content),J.vulnerabilities)}ye.to=le})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var jt;(function(ye){function Te(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}ye.from=Te;function le(J){return new w.$vP(J.agentId,J.command)}ye.to=le})(jt||(e.ChatResponseDetectedParticipantPart=jt={}));var Ht;(function(ye){function Te(le){return{kind:"confirmation",title:le.title,message:le.message,data:le.data}}ye.from=Te})(Ht||(e.ChatResponseConfirmationPart=Ht={}));var oi;(function(ye){function Te(J){const{value:Ee,baseUri:We}=J;function Ye(Ge,lt){return Ge.map(It=>{const Jt=s.URI.joinPath(lt,It.name);return{label:It.name,uri:Jt,children:It.children&&Ye(It.children,Jt)}})}return{kind:"treeData",treeData:{label:(0,E.$dh)(We),uri:We,children:Ye(Ee,We)}}}ye.from=Te;function le(J){const Ee=(0,a.$ci)(J.treeData);function We(lt){return lt.map(It=>({name:It.label,children:It.children&&We(It.children)}))}const Ye=Ee.uri,Ge=Ee.children?We(Ee.children):[];return new w.$xP(Ge,Ye)}ye.to=le})(oi||(e.ChatResponseFilesPart=oi={}));var Rt;(function(ye){function Te(J){const Ee=We=>s.URI.isUri(We);return{kind:"inlineReference",name:J.title,inlineReference:Ee(J.value)?J.value:L.from(J.value)}}ye.from=Te;function le(J){const Ee=(0,a.$ci)(J);return new w.$yP(s.URI.isUri(Ee.inlineReference)?Ee.inlineReference:L.to(Ee.inlineReference),J.name)}ye.to=le})(Rt||(e.ChatResponseAnchorPart=Rt={}));var St;(function(ye){function Te(J){return{kind:"progressMessage",content:we.from(J.value)}}ye.from=Te;function le(J){return new w.$zP(J.content.value)}ye.to=le})(St||(e.ChatResponseProgressPart=St={}));var bt;(function(ye){function Te(J){return{kind:"warning",content:we.from(J.value)}}ye.from=Te;function le(J){return new w.$BP(J.content.value)}ye.to=le})(bt||(e.ChatResponseWarningPart=bt={}));var ei;(function(ye){function Te(le){return{kind:"progressTask",content:we.from(le.value)}}ye.from=Te})(ei||(e.ChatTask=ei={}));var Ct;(function(ye){function Te(le){return{kind:"progressTaskResult",content:typeof le=="string"?we.from(le):void 0}}ye.from=Te})(Ct||(e.ChatTaskResult=Ct={}));var di;(function(ye){function Te(J,Ee,We){return{kind:"command",command:Ee.toInternal(J.value,We)??{command:J.value.command,title:J.value.title}}}ye.from=Te;function le(J,Ee){return new w.$CP(Ee.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}ye.to=le})(di||(e.ChatResponseCommandButtonPart=di={}));var Gt;(function(ye){function Te(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(Ee=>ve.from(Ee))}}ye.from=Te;function le(J){return new w.$EP(s.URI.revive(J.uri),J.edits.map(Ee=>ve.to(Ee)))}ye.to=le})(Gt||(e.ChatResponseTextEditPart=Gt={}));var bi;(function(ye){function Te(J){const Ee=d.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:s.URI.isUri(J.iconPath)?{light:s.URI.revive(J.iconPath)}:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&s.URI.isUri(J.iconPath.light)&&s.URI.isUri(J.iconPath.dark)?{light:s.URI.revive(J.iconPath.light),dark:s.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:s.URI.isUri(J.value.value)||!J.value.value?J.value.value:L.from(J.value.value)},iconPath:Ee}:{kind:"reference",reference:s.URI.isUri(J.value)?J.value:L.from(J.value),iconPath:Ee}}ye.from=Te;function le(J){const Ee=(0,a.$ci)(J),We=Ye=>s.URI.isUri(Ye)?Ye:L.to(Ye);return new w.$DP("variableName"in Ee.reference?{variableName:Ee.reference.variableName,value:Ee.reference.value&&We(Ee.reference.value)}:We(Ee.reference))}ye.to=le})(bi||(e.ChatResponseReferencePart=bi={}));var vi;(function(ye){function Te(Ee,We,Ye){return Ee instanceof w.$tP?_t.from(Ee):Ee instanceof w.$yP?Rt.from(Ee):Ee instanceof w.$DP?bi.from(Ee):Ee instanceof w.$zP?St.from(Ee):Ee instanceof w.$xP?oi.from(Ee):Ee instanceof w.$CP?di.from(Ee,We,Ye):Ee instanceof w.$EP?Gt.from(Ee):Ee instanceof w.$uP?si.from(Ee):Ee instanceof w.$vP?jt.from(Ee):Ee instanceof w.$BP?bt.from(Ee):{kind:"markdownContent",content:we.from("")}}ye.from=Te;function le(Ee,We){switch(Ee.kind){case"reference":return bi.to(Ee);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Ee,We)}}ye.to=le;function J(Ee,We){switch(Ee.kind){case"markdownContent":return _t.to(Ee);case"inlineReference":return Rt.to(Ee);case"progressMessage":return;case"treeData":return oi.to(Ee);case"command":return di.to(Ee,We)}}ye.toContent=J})(vi||(e.ChatResponsePart=vi={}));var gi;(function(ye){function Te(le){return{prompt:le.message,command:le.command,attempt:le.attempt??0,enableCommandDetection:le.enableCommandDetection??!0,references:le.variables.variables.map(ai.to),location:Bt.to(le.location),acceptedConfirmationData:le.acceptedConfirmationData,rejectedConfirmationData:le.rejectedConfirmationData}}ye.to=Te})(gi||(e.ChatAgentRequest=gi={}));var Bt;(function(ye){function Te(J){switch(J){case $.ChatAgentLocation.Notebook:return w.ChatLocation.Notebook;case $.ChatAgentLocation.Terminal:return w.ChatLocation.Terminal;case $.ChatAgentLocation.Panel:return w.ChatLocation.Panel;case $.ChatAgentLocation.Editor:return w.ChatLocation.Editor}}ye.to=Te;function le(J){switch(J){case w.ChatLocation.Notebook:return $.ChatAgentLocation.Notebook;case w.ChatLocation.Terminal:return $.ChatAgentLocation.Terminal;case w.ChatLocation.Panel:return $.ChatAgentLocation.Panel;case w.ChatLocation.Editor:return $.ChatAgentLocation.Editor}}ye.from=le})(Bt||(e.ChatLocation=Bt={}));var ai;(function(ye){function Te(le){const J=le.value;if(!J)throw new Error("Invalid value reference");return{id:le.id,name:le.name,range:le.range&&[le.range.start,le.range.endExclusive],value:(0,s.$xc)(J)?s.URI.revive(J):J&&typeof J=="object"&&"uri"in J&&"range"in J&&(0,s.$xc)(J.uri)?L.to((0,a.$ci)(J)):J,modelDescription:le.modelDescription}}ye.to=Te})(ai||(e.ChatAgentValueReference=ai={}));var Ii;(function(ye){function Te(le,J,Ee){return{id:le.id,label:le.label,fullName:le.fullName,icon:le.icon?.id,value:le.values[0].value,insertText:le.insertText,detail:le.detail,documentation:le.documentation,command:J.toInternal(le.command,Ee)}}ye.from=Te})(Ii||(e.ChatAgentCompletionItem=Ii={}));var Tt;(function(ye){function Te(le){return{errorDetails:le.errorDetails,metadata:le.metadata}}ye.to=Te})(Tt||(e.ChatAgentResult=Tt={}));var Di;(function(ye){function Te(le,J,Ee){if(J.action.kind==="vote")return;const We=Tt.to(le);if(J.action.kind==="command"){const Ye=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ee.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:We}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:At.to(J.action.followup)},result:We}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:We}:{action:J.action,result:We}}ye.to=Te})(Di||(e.ChatAgentUserActionEvent=Di={}));var Pi;(function(ye){function Te(le,J,Ee){return"terminalCommand"in le?{terminalCommand:le.terminalCommand,shouldExecute:le.shouldExecute}:"uri"in le?{uri:le.uri}:J.toInternal(le,Ee)}ye.from=Te})(Pi||(e.TerminalQuickFix=Pi={}));var Si;(function(ye){function Te(le){return{kind:pi.to(le.kind)}}ye.to=Te})(Si||(e.PartialAcceptInfo=Si={}));var pi;(function(ye){function Te(le){switch(le){case r.PartialAcceptTriggerKind.Word:return w.PartialAcceptTriggerKind.Word;case r.PartialAcceptTriggerKind.Line:return w.PartialAcceptTriggerKind.Line;case r.PartialAcceptTriggerKind.Suggest:return w.PartialAcceptTriggerKind.Suggest;default:return w.PartialAcceptTriggerKind.Unknown}}ye.to=Te})(pi||(e.PartialAcceptTriggerKind=pi={}));var Ri;(function(ye){function Te(le,J){return{id:J,label:le.label,description:le.description,canEdit:le.canEdit,collapsibleState:le.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:le.contextValue}}ye.from=Te})(Ri||(e.DebugTreeItem=Ri={}));var Wt;(function(ye){function Te(le){return{name:le.name,description:le.description,parametersSchema:le.parametersSchema}}ye.to=Te})(Wt||(e.LanguageModelToolDescription=Wt={}))}),define(Ce[274],Ie([1,0,5,17,8,39]),function(oe,e,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=void 0;let A=class{constructor(p,a){this.a=p.getProxy(v.$uN.MainThreadBulkEdits),this.b={getTextDocumentVersion:P=>a.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,a,P){const y=new O.$Tw(C.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,P?.isRefactoring??!1)}};e.$voc=A,e.$voc=A=Qe([Ve(0,k.$1P)],A)}),define(Ce[275],Ie([1,0,18,11,41,6,40,4,70,15,2,19,5,8,7,236,25]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=void 0,E=qe(E),d=qe(d);class o{constructor(t,c,l,g,m){this.j=t,this.k=c,this.l=l,this.m=g,this.n=m,this.b=p.$ge.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let c=function(g){if(t.c){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,g),m}};const t=this;this.b.reset();const l=(g,m)=>{if(typeof this.d>"u"&&"content"in g&&(this.d=this.b.elapsed()),m){const $=this.l.$handleProgressChunk(this.k.requestId,g),S={report:D=>{$?.then(b=>{b&&(d.$YN.isMarkdownString(D.value)?this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseWarningPart.from(D),b):this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseReferencePart.from(D),b))})}};Promise.all([$,m?.(S)]).then(([D,b])=>{D!==void 0&&b!==void 0&&this.l.$handleProgressChunk(this.k.requestId,E.ChatTaskResult.from(b),D)})}else this.l.$handleProgressChunk(this.k.requestId,g)};this.g={markdown(g){c(this.markdown);const m=new d.$tP(g),$=E.ChatResponseMarkdownPart.from(m);return l($),this},markdownWithVulnerabilities(g,m){c(this.markdown),m&&(0,s.$7G)(t.j,"chatParticipantAdditions");const $=new d.$uP(g,m),S=E.ChatResponseMarkdownWithVulnerabilitiesPart.from($);return l(S),this},filetree(g,m){c(this.filetree);const $=new d.$xP(g,m),S=E.ChatResponseFilesPart.from($);return l(S),this},anchor(g,m){c(this.anchor);const $=new d.$yP(g,m),S=E.ChatResponseAnchorPart.from($);return l(S),this},button(g){c(this.anchor);const m=new d.$CP(g),$=E.ChatResponseCommandButtonPart.from(m,t.m,t.n);return l($),this},progress(g,m){c(this.progress);const $=new d.$AP(g,m),S=m?E.ChatTask.from($):E.ChatResponseProgressPart.from($);return l(S,m),this},warning(g){c(this.progress),(0,s.$7G)(t.j,"chatParticipantAdditions");const m=new d.$BP(g),$=E.ChatResponseWarningPart.from(m);return l($),this},reference(g,m){if(c(this.reference),"variableName"in g&&(0,s.$7G)(t.j,"chatParticipantAdditions"),"variableName"in g&&!g.value){const $=t.k.variables.variables.find(S=>S.name===g.variableName);if($){let S;if($.references?.length)S=$.references.map(D=>({kind:"reference",reference:{variableName:g.variableName,value:D.reference}}));else{const D=new d.$DP(g,m);S=[E.ChatResponseReferencePart.from(D)]}return S.forEach(D=>l(D)),this}}else{const $=new d.$DP(g,m),S=E.ChatResponseReferencePart.from($);l(S)}return this},textEdit(g,m){c(this.textEdit),(0,s.$7G)(t.j,"chatParticipantAdditions");const $=new d.$EP(g,m),S=E.ChatResponseTextEditPart.from($);return l(S),this},detectedParticipant(g,m){c(this.detectedParticipant),(0,s.$7G)(t.j,"chatParticipantAdditions");const $=new d.$vP(g,m),S=E.ChatResponseDetectedParticipantPart.from($);return l(S),this},confirmation(g,m,$){c(this.confirmation),(0,s.$7G)(t.j,"chatParticipantAdditions");const S=new d.$wP(g,m,$),D=E.ChatResponseConfirmationPart.from(S);return l(D),this},push(g){if(c(this.push),(g instanceof d.$EP||g instanceof d.$uP||g instanceof d.$vP||g instanceof d.$BP||g instanceof d.$wP)&&(0,s.$7G)(t.j,"chatParticipantAdditions"),g instanceof d.$DP)this.reference(g.value,g.iconPath);else{const m=E.ChatResponsePart.from(g,t.m,t.n);l(m)}return this}}}return this.g}}class h extends T.$Wc{static{this.b=0}constructor(t,c,l,g){super(),this.n=c,this.s=l,this.t=g,this.c=new Map,this.j=this.B(new T.$6c),this.m=this.B(new T.$6c),this.g=t.getProxy(u.$uN.MainThreadChatAgents2)}transferActiveChat(t){this.g.$transferActiveChatSession(t)}createChatAgent(t,c,l){const g=h.b++,m=new i(t,this.t,c,this.g,g,l);return this.c.set(g,m),m.isAgentEnabled()&&this.g.$registerAgent(g,t.identifier,c,{},void 0),m.apiAgent}createDynamicChatAgent(t,c,l,g){const m=h.b++,$=new i(t,this.t,c,this.g,m,g);return this.c.set(m,$),this.g.$registerAgent(m,t.identifier,c,{isSticky:!0},l),$.apiAgent}async $invokeAgent(t,c,l,g){const m=this.c.get(t);if(!m)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let $=this.j.get(c.sessionId);$||($=new T.$Vc,this.j.set(c.sessionId,$));const S=new o(m.extension,c,this.g,this.s.converter,$);try{const D=await this.u(c.agentId,l),b=m.invoke(E.ChatAgentRequest.to(c),{history:D},S.apiObject,g);return await(0,k.$th)(Promise.resolve(b).then(I=>{if(I?.metadata)try{JSON.stringify(I.metadata)}catch(f){const w=`result.metadata MUST be JSON.stringify-able. Got error: ${f.message}`;return this.n.error(`[${m.extension.identifier.value}] [@${m.id}] ${w}`,m.extension),{errorDetails:{message:w},timings:S.timings}}let R;return I?.errorDetails&&(R={...I.errorDetails,responseIsIncomplete:!0}),R?.responseIsRedacted&&(0,s.$7G)(m.extension,"chatParticipantPrivate"),{errorDetails:R,timings:S.timings,metadata:I?.metadata}}),g)}catch(D){return this.n.error(D,m.extension),D instanceof d.$OP&&D.cause&&(D=D.cause),{errorDetails:{message:(0,C.$qj)(D),responseIsIncomplete:!0}}}finally{S.close()}}async u(t,c){const l=[];for(const g of c.history){const m=E.ChatAgentResult.to(g.result),$=t===g.request.agentId?m:{...m,metadata:void 0};l.push(new d.$FP(g.request.message,g.request.command,g.request.variables.variables.map(E.ChatAgentValueReference.to),g.request.agentId));const S=(0,v.$Jb)(g.response.map(D=>E.ChatResponsePart.toContent(D,this.s.converter)));l.push(new d.$GP(S,$,g.request.agentId,g.request.command))}return l}$releaseSession(t){this.j.deleteAndDispose(t)}async $provideFollowups(t,c,l,g,m){const $=this.c.get(c);if(!$)return Promise.resolve([]);const S=await this.u($.id,g),D=E.ChatAgentResult.to(l);return(await $.provideFollowups(D,{history:S},m)).filter(b=>{const I=!b.participant||A.Iterable.some(this.c.values(),R=>R.id===b.participant&&y.$qn.equals(R.extension.identifier,$.extension.identifier));return I||this.n.warn(`[@${$.id}] ChatFollowup refers to an unknown participant: ${b.participant}`),I}).map(b=>E.ChatFollowup.from(b,t))}$acceptFeedback(t,c,l,g){const m=this.c.get(t);if(!m)return;const $=E.ChatAgentResult.to(c);let S;switch(l){case n.ChatAgentVoteDirection.Down:S=d.ChatResultFeedbackKind.Unhelpful;break;case n.ChatAgentVoteDirection.Up:S=d.ChatResultFeedbackKind.Helpful;break}m.acceptFeedback(Object.freeze(g?{result:$,kind:S,reportIssue:g}:{result:$,kind:S}))}$acceptAction(t,c,l){const g=this.c.get(t);if(!g||l.action.kind==="vote")return;const m=E.ChatAgentUserActionEvent.to(c,l,this.s.converter);m&&g.acceptAction(Object.freeze(m))}async $invokeCompletionProvider(t,c,l){const g=this.c.get(t);if(!g)return[];let m=this.m.get(t);return m?m.clear():(m=new T.$Vc,this.m.set(t,m)),(await g.invokeCompletionProvider(c,l)).map(S=>E.ChatAgentCompletionItem.from(S,this.s.converter,m))}async $provideWelcomeMessage(t,c,l){const g=this.c.get(t);if(g)return await g.provideWelcomeMessage(E.ChatLocation.to(c),l)}async $provideSampleQuestions(t,c,l){const g=this.c.get(t);if(g)return(await g.provideSampleQuestions(E.ChatLocation.to(c),l)).map(m=>E.ChatFollowup.from(m,void 0))}}e.$woc=h;class i{constructor(t,c,l,g,m,$){this.extension=t,this.w=c,this.id=l,this.x=g,this.y=m,this.z=$,this.m=new O.$me,this.n=new O.$me}acceptFeedback(t){this.m.fire(t)}acceptAction(t){this.n.fire(t)}async invokeCompletionProvider(t,c){return this.q?await this.q.provider.provideCompletionItems(t,c)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,s.$6G)(this.extension,"chatParticipantPrivate"))}async provideFollowups(t,c,l){if(!this.b)return[];const g=await this.b.provideFollowups(t,c,l);return g?g.filter(m=>!(m&&"commandId"in m)).filter(m=>!(m&&"message"in m)):[]}async provideWelcomeMessage(t,c){if(!this.s)return[];const l=await this.s.provideWelcomeMessage(t,c);return l?l.map(g=>typeof g=="string"?g:E.MarkdownString.from(g)):[]}async provideSampleQuestions(t,c){if(!this.s||!this.s.provideSampleQuestions)return[];const l=await this.s.provideSampleQuestions(t,c);return l||[]}get apiAgent(){let t=!1,c=!1;const l=()=>{t||c||(c=!0,queueMicrotask(()=>{g.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof P.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof d.$tO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:E.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:E.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:E.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),c=!1)}))},g=this;return{get id(){return g.id},get iconPath(){return g.c},set iconPath(m){g.c=m,l()},get requestHandler(){return g.z},set requestHandler(m){(0,a.$pg)(typeof m=="function","Invalid request handler"),g.z=m},get followupProvider(){return g.b},set followupProvider(m){g.b=m,l()},get isDefault(){return(0,s.$7G)(g.extension,"defaultChatParticipant"),g.d},set isDefault(m){(0,s.$7G)(g.extension,"defaultChatParticipant"),g.d=m,l()},get helpTextPrefix(){return(0,s.$7G)(g.extension,"defaultChatParticipant"),g.g},set helpTextPrefix(m){(0,s.$7G)(g.extension,"defaultChatParticipant"),g.g=m,l()},get helpTextVariablesPrefix(){return(0,s.$7G)(g.extension,"defaultChatParticipant"),g.j},set helpTextVariablesPrefix(m){(0,s.$7G)(g.extension,"defaultChatParticipant"),g.j=m,l()},get helpTextPostfix(){return(0,s.$7G)(g.extension,"defaultChatParticipant"),g.k},set helpTextPostfix(m){(0,s.$7G)(g.extension,"defaultChatParticipant"),g.k=m,l()},get isSecondary(){return(0,s.$7G)(g.extension,"defaultChatParticipant"),g.l},set isSecondary(m){(0,s.$7G)(g.extension,"defaultChatParticipant"),g.l=m,l()},get supportIssueReporting(){return(0,s.$7G)(g.extension,"chatParticipantPrivate"),g.o},set supportIssueReporting(m){(0,s.$7G)(g.extension,"chatParticipantPrivate"),g.o=m,l()},get onDidReceiveFeedback(){return g.m.event},set participantVariableProvider(m){if((0,s.$7G)(g.extension,"chatParticipantAdditions"),g.q=m,m){if(!m.triggerCharacters.length)throw new Error("triggerCharacters are required");g.x.$registerAgentCompletionsProvider(g.y,g.id,m.triggerCharacters)}else g.x.$unregisterAgentCompletionsProvider(g.y,g.id)},get participantVariableProvider(){return(0,s.$7G)(g.extension,"chatParticipantAdditions"),g.q},set welcomeMessageProvider(m){(0,s.$7G)(g.extension,"defaultChatParticipant"),g.s=m,l()},get welcomeMessageProvider(){return(0,s.$7G)(g.extension,"defaultChatParticipant"),g.s},onDidPerformAction:(0,s.$6G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(m){g.t=m,l()},get requester(){return g.t},set supportsSlowReferences(m){(0,s.$7G)(g.extension,"chatParticipantPrivate"),g.u=m,l()},get supportsSlowReferences(){return(0,s.$7G)(g.extension,"chatParticipantPrivate"),g.u},dispose(){t=!0,g.b=void 0,g.m.dispose(),g.x.$unregisterAgent(g.y)}}}invoke(t,c,l,g){return this.z(t,c,l,g)}}}),define(Ce[276],Ie([1,0,14,4,35,5,8,7,25]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=void 0,A=qe(A),T=qe(T);class a{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(O.$uN.MainThreadChatVariables)}async $resolveVariable(u,E,d,n){const s=this.b.get(u);if(s)try{if(s.resolver.resolve2){(0,p.$7G)(s.extension,"chatParticipantAdditions");const o=new P(E,this.c),h=await s.resolver.resolve2(s.data.name,{prompt:d},o.apiObject,n);if(h&&h[0])return h[0].value}else{const o=await s.resolver.resolve(s.data.name,{prompt:d},n);if(o&&o[0])return o[0].value}}catch(o){(0,v.$4)(o)}}registerVariableResolver(u,E,d,n,s,o,h,i,r){const t=a.a++,c=r?C.ThemeIcon.fromId(r):void 0;return this.b.set(t,{extension:u,data:{id:E,name:d,description:n,modelDescription:s,icon:c},resolver:h}),this.c.$registerVariable(t,{id:E,name:d,description:n,modelDescription:s,isSlow:o,fullName:i,icon:c}),(0,k.$Uc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$xoc=a;class P{constructor(u,E){this.c=u,this.d=E,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let E=function(n){if(u.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,n),s}};const u=this,d=n=>{this.d.$handleProgressChunk(this.c,n)};this.b={progress(n){E(this.progress);const s=new T.$zP(n),o=A.ChatResponseProgressPart.from(s);return d(o),this},reference(n){E(this.reference);const s=new T.$DP(n),o=A.ChatResponseReferencePart.from(s);return d(o),this},push(n){return E(this.push),n instanceof T.$DP?d(A.ChatResponseReferencePart.from(n)):n instanceof T.$zP&&d(A.ChatResponseProgressPart.from(n)),this}}}return this.b}}}),define(Ce[277],Ie([1,0,11,72,6,4,38,2,94,19,8,7,5,25]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=d,p=qe(p),P=qe(P),y=qe(y);function d(n,s,o){const h=n.getProxy(u.$uN.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new a.$sn,s.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===A.MarshalledId.CommentController){const I=this.b.get(b.handle);return I?I.value:b}else if(b&&b.$mid===A.MarshalledId.CommentThread){const I=b,R=this.b.get(I.commentControlHandle);if(!R)return I;const f=R.getCommentThread(I.commentThreadHandle);return f?f.value:I}else if(b&&(b.$mid===A.MarshalledId.CommentThreadReply||b.$mid===A.MarshalledId.CommentThreadInstance)){const I=this.b.get(b.thread.commentControlHandle);if(!I)return b;const R=I.getCommentThread(b.thread.commentThreadHandle);return R?b.$mid===A.MarshalledId.CommentThreadInstance?R.value:{thread:R.value,text:b.text}:b}else if(b&&b.$mid===A.MarshalledId.CommentNode){const I=this.b.get(b.thread.commentControlHandle);if(!I)return b;const R=I.getCommentThread(b.thread.commentThreadHandle);if(!R)return b;const f=b.commentUniqueId,w=R.getCommentByUniqueId(f);return w||b}else if(b&&b.$mid===A.MarshalledId.CommentThreadNode){const I=this.b.get(b.thread.commentControlHandle);if(!I)return b;const R=I.getCommentThread(b.thread.commentThreadHandle);if(!R)return b;const f=b.text,w=b.commentUniqueId,M=R.getCommentByUniqueId(w);return M?(typeof M.body=="string"?M.body=f:M.body=new y.$YN(f),M):b}return b}})}createCommentController(b,I,R){const f=i.a++,w=new t(b,f,I,R);this.b.set(w.handle,w);const M=this.c.get(b.identifier)||[];return M.push(w),this.c.set(b.identifier,M),w.value}async $createCommentThreadTemplate(b,I,R,f){const w=this.b.get(b);w&&w.$createCommentThreadTemplate(I,R,f)}async $setActiveComment(b,I){const R=this.b.get(b);R&&R.$setActiveComment(I??void 0)}async $updateCommentThreadTemplate(b,I,R){const f=this.b.get(b);f&&f.$updateCommentThreadTemplate(I,R)}$deleteCommentThread(b,I){this.b.get(b)?.$deleteCommentThread(I)}async $provideCommentingRanges(b,I,R){const f=this.b.get(b);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const w=await o.ensureDocumentData(T.URI.revive(I));return(0,v.$xh)(async()=>{const M=await f.commentingRangeProvider.provideCommentingRanges(w.document,R);let N;return Array.isArray(M)?N={ranges:M,fileComments:!1}:M?N={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:N=M??void 0,N}).then(M=>{let N;return M&&(N={ranges:M.ranges.map(L=>P.Range.from(L)),fileComments:M.fileComments}),N})}$toggleReaction(b,I,R,f,w){const M=this.b.get(b);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,v.$xh)(()=>{const N=M.getCommentThread(I);if(N){const L=N.getCommentByUniqueId(f.uniqueIdInThread);if(M!==void 0&&L&&M.reactionHandler)return M.reactionHandler(L,g(w))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,typeof b=="object"?((0,E.$7G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=b.resolved,this.b.applicability=b.applicability):this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,I,R,f,w,M,N,L,G){this.m=I,this.n=R,this.o=f,this.p=w,this.q=M,this.extensionDescription=N,this.r=L,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$me,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Xc,this.l.value=new O.$Vc,this.n===void 0&&(this.n=`${b}.${this.handle}`),h.$createCommentThread(I,this.handle,this.n,this.o,P.Range.from(this.p),N.identifier,this.r,G),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=M,this.i.push({dispose:()=>{h.$deleteCommentThread(I,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(F){W.range=F},get comments(){return W.comments},set comments(F){W.comments=F},get collapsibleState(){return W.collapsibleState},set collapsibleState(F){W.collapsibleState=F},get canReply(){return W.canReply},set canReply(F){W.canReply=F},get contextValue(){return W.contextValue},set contextValue(F){W.contextValue=F},get label(){return W.label},set label(F){W.label=F},get state(){return W.state},set state(F){W.state=F},reveal:F=>W.reveal(F),dispose:()=>{W.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Vc);const b=R=>Object.prototype.hasOwnProperty.call(this.b,R),I={};b("range")&&(I.range=P.Range.from(this.p)),b("label")&&(I.label=this.label),b("contextValue")&&(I.contextValue=this.contextValue??null),b("comments")&&(I.comments=this.q.map(R=>c(this,R,this.k,this.extensionDescription))),b("collapsibleState")&&(I.collapseState=m(this.g)),b("canReply")&&(I.canReply=this.canReply),b("state")&&(I.state=$(this.h)),b("applicability")&&(I.applicability=S(this.h)),b("isTemplate")&&(I.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(b){for(const I of this.k){const R=I[0],f=I[1];if(b===f)return R}}async reveal(b){return(0,E.$7G)(this.extensionDescription,"commentReveal"),h.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...b})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}Qe([(0,k.$$h)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,b?.resourceHints&&(0,E.$7G)(this.h,"commentingRangeHint"),h.$updateCommentingRanges(this.handle,b?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,E.$7G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,E.$7G)(this.h,"activeComment"),this.f}constructor(b,I,R,f){this.h=b,this.i=I,this.j=R,this.k=f,this.a=new Map,h.$registerCommentController(this.handle,R,f,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(M){w.options=M},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(M){w.commentingRangeProvider=M},get reactionHandler(){return w.reactionHandler},set reactionHandler(M){w.reactionHandler=M},get activeCommentThread(){return w.activeCommentThread},createCommentThread(M,N,L){return w.createCommentThread(M,N,L).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(b,I,R){I===void 0&&(0,E.$7G)(this.h,"fileComments");const f=new r(this.id,this.handle,void 0,b,I,R,this.h,!1);return this.a.set(f.handle,f),f}$setActiveComment(b){if(!b){this.e=void 0,this.f=void 0;return}const I=this.a.get(b.commentThreadHandle);I&&(this.e=b.uniqueIdInThread?I.getCommentByUniqueId(b.uniqueIdInThread):void 0,this.f=I)}$createCommentThreadTemplate(b,I,R){const f=new r(this.id,this.handle,void 0,T.URI.revive(b),P.Range.to(I),[],this.h,!0,R);return f.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(b,I){const R=this.a.get(b);R&&(R.range=P.Range.to(I))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.g.forEach(b=>b.dispose())}}function c(D,b,I,R){let f=I.get(b);return f||(f=++D.commentHandle,I.set(b,f)),b.state!==void 0&&(0,E.$7G)(R,"commentsDraftState"),b.reactions?.some(w=>w.reactors!==void 0)&&(0,E.$7G)(R,"commentReactor"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:f,body:typeof b.body=="string"?b.body:P.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(w=>l(w)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function l(D){return{label:D.label,iconPath:D.iconPath?P.$ZP(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(b=>b.name):D.reactors}}function g(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?T.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(b=>({name:b}))}}function m(D){if(D!==void 0)switch(D){case y.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function $(D){let b;if(typeof D=="object"?b=D.resolved:b=D,b!==void 0)switch(b){case y.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function S(D){let b;if(typeof D=="object"&&(b=D.applicability),b!==void 0)switch(b){case y.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Ce[278],Ie([1,0,22,76,4,16,24,2,8,68,80,5,7]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=void 0,p=qe(p),y=qe(y),u=qe(u);class E{constructor(l,g){this.document=l,this.b=g,this.a=1,this.c=new P.$hoc("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,g){await this.f(l).undo(),g||this.disposeBackup()}async redo(l,g){await this.f(l).redo(),g||this.disposeBackup()}disposeEdits(l){for(const g of l)this.c.delete(g)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=t(this.document.uri)+this.a++;return(0,A.$gh)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const g=this.c.get(l,0);if(!g)throw new Error("No edit found");return g}}class d{constructor(){this.a=new Map}get(l,g){return this.a.get(this.b(l,g))}add(l,g,m){const $=this.b(l,g.uri);if(this.a.has($))throw new Error(`Document already exists for viewType:${l} resource:${g.uri}`);const S=new E(g,m);return this.a.set($,S),S}delete(l,g){const m=this.b(l,g.uri);this.a.delete(m)}b(l,g){return`${l}@@@${g}`}}var n;(function(c){c[c.Text=0]="Text",c[c.Custom=1]="Custom"})(n||(n={}));class s{constructor(){this.a=new Map}addTextProvider(l,g,m){return this.b(l,{type:n.Text,extension:g,provider:m})}addCustomProvider(l,g,m){return this.b(l,{type:n.Custom,extension:g,provider:m})}get(l){return this.a.get(l)}b(l,g){if(this.a.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this.a.set(l,g),new u.$wN(()=>this.a.delete(l))}}class o{constructor(l,g,m,$,S){this.d=g,this.f=m,this.g=$,this.h=S,this.b=new s,this.c=new d,this.a=l.getProxy(y.$uN.MainThreadCustomEditors)}registerCustomEditorProvider(l,g,m,$){const S=new C.$Vc;return i(m)?(S.add(this.b.addTextProvider(g,l,m)),this.a.$registerTextEditorProvider((0,a.$Qoc)(l),g,$.webviewOptions||{},{supportsMove:!!m.moveCustomTextEditor},(0,a.$Ooc)(l))):(S.add(this.b.addCustomProvider(g,l,m)),h(m)&&S.add(m.onDidChangeCustomDocument(D=>{const b=this.i(g,D.document.uri);if(r(D)){const I=b.addEdit(D);this.a.$onDidEdit(D.document.uri,g,I,D.label)}else this.a.$onContentChange(D.document.uri,g)})),this.a.$registerCustomEditorProvider((0,a.$Qoc)(l),g,$.webviewOptions||{},!!$.supportsMultipleEditorsPerDocument,(0,a.$Ooc)(l))),u.$wN.from(S,new u.$wN(()=>{this.a.$unregisterEditorProvider(g)}))}async $createCustomDocument(l,g,m,$,S){const D=this.b.get(g);if(!D)throw new Error(`No provider found for '${g}'`);if(D.type!==n.Custom)throw new Error(`Invalid provide type for '${g}'`);const b=T.URI.revive(l),I=await D.provider.openCustomDocument(b,{backupId:m,untitledDocumentData:$?.buffer},S);let R;return h(D.provider)&&this.f&&(R=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(g,I,R),{editable:h(D.provider)}}async $disposeCustomDocument(l,g){const m=this.b.get(g);if(!m)throw new Error(`No provider found for '${g}'`);if(m.type!==n.Custom)throw new Error(`Invalid provider type for '${g}'`);const $=T.URI.revive(l),{document:S}=this.i(g,$);this.c.delete(g,S),S.dispose()}async $resolveCustomEditor(l,g,m,$,S,D){const b=this.b.get(m);if(!b)throw new Error(`No provider found for '${m}'`);const I=p.ViewColumn.to(S),R=this.g.createNewWebview(g,$.contentOptions,b.extension),f=this.h.createNewWebviewPanel(g,m,$.title,I,$.options,R,$.active),w=T.URI.revive(l);switch(b.type){case n.Custom:{const{document:M}=this.i(m,w);return b.provider.resolveCustomEditor(M,f,D)}case n.Text:{const M=this.d.getDocument(w);return b.provider.resolveCustomTextEditor(M,f,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,g,m){this.i(g,l).disposeEdits(m)}async $onMoveCustomEditor(l,g,m){const $=this.b.get(m);if(!$)throw new Error(`No provider found for '${m}'`);if(!$.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${m}'`);const S=this.h.getWebviewPanel(l);if(!S)throw new Error("No webview found");const D=T.URI.revive(g),b=this.d.getDocument(D);await $.provider.moveCustomTextEditor(b,S,v.CancellationToken.None)}async $undo(l,g,m,$){return this.i(g,l).undo(m,$)}async $redo(l,g,m,$){return this.i(g,l).redo(m,$)}async $revert(l,g,m){const $=this.i(g,l);await this.j(g).revertCustomDocument($.document,m),$.disposeBackup()}async $onSave(l,g,m){const $=this.i(g,l);await this.j(g).saveCustomDocument($.document,m),$.disposeBackup()}async $onSaveAs(l,g,m,$){const S=this.i(g,l);return this.j(g).saveCustomDocumentAs(S.document,T.URI.revive(m),$)}async $backup(l,g,m){const $=this.i(g,l),D=await this.j(g).backupCustomDocument($.document,{destination:$.getNewBackupUri()},m);return $.updateBackup(D),D.id}i(l,g){const m=this.c.get(l,T.URI.revive(g));if(!m)throw new Error("No custom document found");return m}j(l){const m=this.b.get(l)?.provider;if(!m||!h(m))throw new Error("Custom document is not editable");return m}}e.$Toc=o;function h(c){return!!c.onDidChangeCustomDocument}function i(c){return typeof c.resolveCustomTextEditor=="function"}function r(c){return typeof c.undo=="function"&&typeof c.redo=="function"}function t(c){const l=c.scheme===O.Schemas.file||c.scheme===O.Schemas.untitled?c.fsPath:c.toString();return(0,k.$tj)(l)+""}}),define(Ce[279],Ie([1,0,181,108,2,5,7,8,6,12,29,51]),function(oe,e,v,k,C,O,A,T,p,a,P,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=e.$ooc=void 0,T=qe(T);class E{#e;#t;#i;constructor(s,o,h,i,r,t,c,l){this.d=s,this.e=o,this.f=h,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,h),this.#i=new P.$Cc(g=>t.getComparisonKey(g)),this.#e=c,this.#t=l}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,o){if(!s){this.clear();return}this.j();let h=[];if(C.URI.isUri(s)){if(!o){this.delete(s);return}this.#i.set(s,o.slice()),h=[s]}else if(Array.isArray(s)){h=[];let t;s=[...s].sort(E.k);for(const c of s){const[l,g]=c;if((!t||l.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=l,h.push(l),this.#i.set(l,[])),g)this.#i.get(l)?.push(...g);else{const m=this.#i.get(l);m&&(m.length=0)}}}if(this.#t.fire(h),!this.#e)return;const i=[];let r=0;for(const t of h){let c=[];const l=this.#i.get(t);if(l)if(l.length>this.g){c=[];const g=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(const $ of l)if($.severity===g[m]&&c.push({...T.Diagnostic.from($),modelVersionId:this.h(t)})===this.g)break e;c.push({severity:k.MarkerSeverity.Info,message:(0,v.localize)(0,null,l.length-this.g),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=l.map(g=>({...T.Diagnostic.from(g),modelVersionId:this.h(t)}));if(i.push([t,c]),r+=c.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,o){this.j();for(const[h,i]of this)s.call(o,h,i,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const o=this.#i.get(s);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,o){return s[0].toString()<o[0].toString()?-1:s[0].toString()>o[0].toString()?1:0}}e.$ooc=E;let d=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(s){const o=new P.$Cc;for(const h of s)o.set(h,h);return{uris:Object.freeze(Array.from(o.values()))}}constructor(s,o,h,i){this.j=o,this.k=h,this.l=i,this.g=new Map,this.h=new p.$qe({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,u._mapper),this.f=s.getProxy(O.$uN.MainThreadDiagnostics)}createDiagnosticCollection(s,o){const{g:h,f:i,h:r,j:t,k:c,l}=this,g=new class{$changeMany(S,D){i.$changeMany(S,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,S,D.length===0?"CLEARING":D)}$clear(S){i.$clear(S),t.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,S)}dispose(){i.dispose()}};let m;if(!o)o="_generated_diagnostic_collection_name_#"+u.c++,m=o;else if(!h.has(o))m=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do m=o+u.c++;while(h.has(m))}return new class extends E{constructor(){super(o,m,u.e,u.d,S=>l.getDocument(S)?.version,c.extUri,g,r),h.set(m,this)}dispose(){super.dispose(),h.delete(m)}}}getDiagnostics(s){if(s)return this.m(s);{const o=new Map,h=[];for(const i of this.g.values())i.forEach((r,t)=>{let c=o.get(r.toString());typeof c>"u"&&(c=h.length,o.set(r.toString(),c),h.push([r,[]])),h[c][1]=h[c][1].concat(...t)});return h}}m(s){let o=[];for(const h of this.g.values())h.has(s)&&(o=o.concat(h.get(s)));return o}$acceptMarkersChange(s){if(!this.n){const o="_generated_mirror",h=new E(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,h),this.n=h}for(const[o,h]of s)this.n.set(C.URI.revive(o),h.map(T.Diagnostic.to))}};e.$poc=d,e.$poc=d=u=Qe([Ve(1,a.$_j),Ve(2,y.$noc)],d)}),define(Ce[280],Ie([1,0,2,14,7,8,212,39]),function(oe,e,v,k,C,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=void 0;class p{constructor(P,y,u,E={timeout:1500,errors:3}){this.c=P,this.d=y,this.f=u,this.g=E,this.a=new A.$7c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(P){return(y,u,E)=>{const n={dispose:this.a.push([y,u,P])};return Array.isArray(E)&&E.push(n),n}}async $participateInSave(P,y){const u=v.URI.revive(P);let E=!1;const d=setTimeout(()=>E=!0,this.g.timeout),n=[];try{for(const s of[...this.a]){if(E)break;const o=this.d.getDocument(u),h=await this.h(s,{document:o,reason:O.TextDocumentSaveReason.to(y)});n.push(h)}}finally{clearTimeout(d)}return n}h([P,y,u],E){const d=this.b.get(P);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(u,P,y,E).then(()=>!0,n=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(n),!(n instanceof Error)||n.message!=="concurrent_edits"){const s=this.b.get(P);this.b.set(P,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(P,y,u,E){const d=[],n=Date.now(),{document:s,reason:o}=E,{version:h}=s,i=Object.freeze({document:s,reason:o,waitUntil(r){if(Object.isFrozen(d))throw(0,k.$0)("waitUntil can not be called async");d.push(Promise.resolve(r))}});try{y.apply(u,[i])}catch(r){return Promise.reject(r)}return Object.freeze(d),new Promise((r,t)=>{const c=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(d).then(l=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-n}ms`),clearTimeout(c),r(l)}).catch(l=>{clearTimeout(c),t(l)})}).then(r=>{const t={edits:[]};for(const c of r)if(Array.isArray(c)&&c.every(l=>l instanceof C.$DN))for(const{newText:l,newEol:g,range:m}of c)t.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:m&&O.Range.from(m),text:l,eol:g&&O.EndOfLine.from(g)}});if(t.edits.length!==0)return h===s.version?this.f.$tryApplyWorkspaceEdit(new T.$Tw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Cpc=p}),define(Ce[281],Ie([1,0,6,4,2,5,123,8,15,26,7]),function(oe,e,v,k,C,O,A,T,p,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0,T=qe(T);class y{constructor(E,d){this.a=new v.$me,this.b=new v.$me,this.c=new v.$me,this.d=new v.$me,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new k.$Vc,this.h=new Map,this.f=E.getProxy(O.$uN.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(n=>{for(const s of n)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const s of n)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const d=this.g.getDocument(E);if(d)return d}getDocument(E){const d=this.getDocumentData(E);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return d.document}ensureDocumentData(E){const d=this.g.getDocument(E);if(d)return Promise.resolve(d);let n=this.h.get(E.toString());return n||(n=this.f.$tryOpenDocument(E).then(s=>{this.h.delete(E.toString());const o=C.URI.revive(s);return(0,p.$qg)(this.g.getDocument(o))},s=>(this.h.delete(E.toString()),Promise.reject(s))),this.h.set(E.toString(),n)),n}createDocumentData(E){return this.f.$tryCreateDocument(E).then(d=>C.URI.revive(d))}$acceptModelLanguageChanged(E,d){const n=C.URI.revive(E),s=this.g.getDocument(n);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(d),this.a.fire(s.document)}$acceptModelSaved(E){const d=C.URI.revive(E),n=this.g.getDocument(d);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(E,d){const n=C.URI.revive(E),s=this.g.getDocument(n);if(!s)throw new Error("unknown document");s._acceptIsDirty(d),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,d,n){const s=C.URI.revive(E),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(n),o.onEvents(d);let h;d.isUndoing?h=P.TextDocumentChangeReason.Undo:d.isRedoing&&(h=P.TextDocumentChangeReason.Redo),this.c.fire((0,a.$eo)({document:o.document,contentChanges:d.changes.map(i=>({range:T.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:h}))}setWordDefinitionFor(E,d){(0,A.$3P)(E,d)}}e.$qoc=y}),define(Ce[71],Ie([1,0,282,6,15,2,3,5,17,8,7]),function(oe,e,v,k,C,O,A,T,p,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=e.$Uoc=void 0,a=qe(a),e.$Uoc=(0,A.$Fi)("IExtHostEditorTabs");class y{constructor(s,o,h){this.e=h,this.d=o,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new P.$hP(O.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new P.$iP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new P.$jP(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new P.$kP(O.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new P.$lP(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new P.$mP(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new P.$nP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new P.$oP;case T.TabInputKind.InteractiveEditorInput:return new P.$pP(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new P.$qP;case T.TabInputKind.MultiDiffEditorInput:return new P.$rP(this.b.input.diffEditors.map(s=>new P.$iP(O.URI.revive(s.original),O.URI.revive(s.modified))));default:return}}}class u{constructor(s,o){this.c=[],this.d="",this.b=s,this.e=o;for(const h of s.tabs)h.isActive&&(this.d=h.id),this.c.push(new y(h,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return a.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(h=>h.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(h=>h.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===T.TabModelOperationKind.TAB_OPEN){const h=new y(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,h),s.tabDto.isActive&&(this.d=h.tabId),h}else if(s.kind===T.TabModelOperationKind.TAB_CLOSE){const h=this.c.splice(s.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return h.tabId===this.d&&(this.d=""),h}else if(s.kind===T.TabModelOperationKind.TAB_MOVE){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this.c.splice(s.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,h),h}const o=this.c.find(h=>h.tabId===s.tabDto.id);if(!o)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(s.tabDto),o}activeTabId(){return this.d}}let E=class{constructor(s){this.b=new k.$me,this.c=new k.$me,this.e=[],this.a=s.getProxy(T.$uN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,o={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(h=>h.apiObject))},get activeTabGroup(){const h=s.d;return(0,C.$qg)(s.e.find(r=>r.groupId===h)?.apiObject)},close:async(h,i)=>{const r=Array.isArray(h)?h:[h];return r.length?d(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(s){const o=new Set(this.e.map(g=>g.groupId)),h=new Set(s.map(g=>g.groupId)),i=(0,v.$L)(o,h),r=this.e.filter(g=>i.removed.includes(g.groupId)).map(g=>g.apiObject),t=[],c=[];this.e=s.map(g=>{const m=new u(g,()=>this.d);return i.added.includes(m.groupId)?t.push(m.apiObject):c.push(m.apiObject),m});const l=(0,C.$qg)(s.find(g=>g.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:t,closed:r,changed:c}))}$acceptTabGroupUpdate(s){const o=this.e.find(h=>h.groupId===s.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const o=this.e.find(i=>i.groupId===s.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const h=o.acceptTabOperation(s);switch(s.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}g(s){for(const o of this.e)for(const h of o.tabs)if(h.apiObject===s)return h}h(s){return this.e.find(o=>o.apiObject===s)}async i(s,o){const h=[];for(const i of s){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");h.push(r.tabId)}return this.a.$closeTab(h,o)}async j(s,o){const h=[];for(const i of s){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");h.push(r.groupId)}return this.a.$closeGroup(h,o)}};e.$Voc=E,e.$Voc=E=Qe([Ve(0,p.$1P)],E);function d(n){return n.tabs!==void 0}}),define(Ce[283],Ie([1,0,2,5,30,4,7,8,327,13,28,23,25,60]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=void 0,C=qe(C),T=qe(T);class d{constructor(){this.a=[]}add(o){this.b=void 0,this.a.push(o)}delete(o){const h=this.a.indexOf(o);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const o=this.a.sort(),h=[];let i,r,t=p.State.LastKnownState,c=p.State.LastKnownState;for(const l of o){let g=i?(0,a.$If)(i,l):0;for(g===0?r=p.State.Start:r=c;g<l.length;g++)g+1===l.length?(t=c,c=p.State.BeforeColon):c+=1,h.push([r,l.toUpperCase().charCodeAt(g),c]),h.push([r,l.toLowerCase().charCodeAt(g),c]),r=c;i=l,c=t}h.push([p.State.BeforeColon,P.CharCode.Colon,p.State.AfterColon]),h.push([p.State.AfterColon,P.CharCode.Slash,p.State.End]),this.b=new p.$p4(h)}}provideDocumentLinks(o){this.c();const h=[],i=p.$q4.computeLinks({getLineContent(r){return o.lineAt(r-1).text},getLineCount(){return o.lineCount}},this.b);for(const r of i){const t=T.DocumentLink.to(r);t.target&&h.push(t)}return h}}class n{constructor(o,h){this.i=h,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=o.getProxy(k.$uN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(o,h,i,r={}){if(n.j(i),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(o,"*",this.b));const t=this.h++;this.b.add(h),this.d.add(h),this.c.set(t,i);let c=C.FileSystemProviderCapabilities.FileReadWrite;r.isCaseSensitive&&(c+=C.FileSystemProviderCapabilities.PathCaseSensitive),r.isReadonly&&(c+=C.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(c+=C.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$7G)(o,"fsChunks"),c+=C.FileSystemProviderCapabilities.FileOpenReadWriteClose);let l;r.isReadonly&&(0,E.$5k)(r.isReadonly)&&r.isReadonly.value!==""&&(l={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(t,h,c,l).catch(m=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${h}`),console.error(m)});const g=i.onDidChangeFile(m=>{const $=[];for(const S of m){const{uri:D,type:b}=S;if(D.scheme!==h)continue;let I;switch(b){case A.FileChangeType.Changed:I=C.FileChangeType.UPDATED;break;case A.FileChangeType.Created:I=C.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:I=C.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}$.push({resource:D,type:I})}this.a.$onFileSystemChange(t,$)});return(0,O.$Uc)(()=>{g.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(o){if(!o)throw new Error("MISSING provider");if(typeof o.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof o.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof o.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof o.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof o.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof o.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof o.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof o.rename!="function")throw new Error("Provider does NOT implement rename")}static k(o){const{type:h,ctime:i,mtime:r,size:t,permissions:c}=o;return{type:h,ctime:i,mtime:r,size:t,permissions:c}}$stat(o,h){return Promise.resolve(this.l(o).stat(v.URI.revive(h))).then(i=>n.k(i))}$readdir(o,h){return Promise.resolve(this.l(o).readDirectory(v.URI.revive(h)))}$readFile(o,h){return Promise.resolve(this.l(o).readFile(v.URI.revive(h))).then(i=>y.$Oe.wrap(i))}$writeFile(o,h,i,r){return Promise.resolve(this.l(o).writeFile(v.URI.revive(h),i.buffer,r))}$delete(o,h,i){return Promise.resolve(this.l(o).delete(v.URI.revive(h),i))}$rename(o,h,i,r){return Promise.resolve(this.l(o).rename(v.URI.revive(h),v.URI.revive(i),r))}$copy(o,h,i,r){const t=this.l(o);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(v.URI.revive(h),v.URI.revive(i),r))}$mkdir(o,h){return Promise.resolve(this.l(o).createDirectory(v.URI.revive(h)))}$watch(o,h,i,r){const t=this.l(o).watch(v.URI.revive(i),r);this.f.set(h,t)}$unwatch(o,h){const i=this.f.get(h);i&&(i.dispose(),this.f.delete(h))}$open(o,h,i){const r=this.l(o);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(v.URI.revive(h),i))}$close(o,h){const i=this.l(o);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(h))}$read(o,h,i,r){const t=this.l(o);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const c=y.$Oe.alloc(r);return Promise.resolve(t.read(h,i,c.buffer,0,r)).then(l=>c.slice(0,l))}$write(o,h,i,r){const t=this.l(o);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(h,i,r.buffer,0,r.byteLength))}l(o){const h=this.c.get(o);if(!h){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return h}}e.$Fpc=n}),define(Ce[284],Ie([1,0,6,42,2,5,8,7,30,48]),function(oe,e,v,k,C,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=void 0,A=qe(A);class P{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,n,s,o,h,i){this.a=Math.random(),this.b=new v.$me,this.c=new v.$me,this.d=new v.$me,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,k.$zk)(h),t=typeof h=="string",c=i?.correlate,l=o(g=>{if(!(typeof g.session=="number"&&g.session!==this.a)&&!(c&&typeof g.session>"u")){if(!i?.ignoreCreateEvents)for(const m of g.created){const $=C.URI.revive(m);r($.fsPath)&&(!t||n.getWorkspaceFolder($))&&this.b.fire($)}if(!i?.ignoreChangeEvents)for(const m of g.changed){const $=C.URI.revive(m);r($.fsPath)&&(!t||n.getWorkspaceFolder($))&&this.c.fire($)}if(!i?.ignoreDeleteEvents)for(const m of g.deleted){const $=C.URI.revive(m);r($.fsPath)&&(!t||n.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=T.$wN.from(this.i(d,s,h,i,i?.correlate),this.b,this.c,this.d,l)}i(d,n,s,o,h){const i=T.$wN.from();if(typeof s=="string"||o?.ignoreChangeEvents&&o?.ignoreCreateEvents&&o?.ignoreDeleteEvents)return i;const r=d.getProxy(O.$uN.MainThreadFileSystemEventService);let t=!1;(s.pattern.includes(k.$vk)||s.pattern.includes(k.$wk))&&(t=!0);let c;return h&&(o?.ignoreChangeEvents||o?.ignoreCreateEvents||o?.ignoreDeleteEvents)&&(c=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,o?.ignoreChangeEvents&&(c&=~p.FileChangeFilter.UPDATED),o?.ignoreCreateEvents&&(c&=~p.FileChangeFilter.ADDED),o?.ignoreDeleteEvents&&(c&=~p.FileChangeFilter.DELETED)),r.$watch(n.identifier.value,this.a,s.baseUri,{recursive:t,excludes:o?.excludes??[],filter:c},!!h),T.$wN.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(d){this.a=d,this.session=this.a.session,this.b=new a.$X(()=>this.a.created.map(C.URI.revive)),this.c=new a.$X(()=>this.a.changed.map(C.URI.revive)),this.d=new a.$X(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(d,n,s){this.j=d,this.k=n,this.l=s,this.a=new v.$me,this.b=new v.$me,this.c=new v.$me,this.d=new v.$me,this.g=new v.$oe,this.h=new v.$oe,this.i=new v.$oe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,n,s,o){return new P(this.j,d,n,this.a.event,A.GlobPattern.from(s),o)}$onFileEvent(d){this.a.fire(new y(d))}$onDidRunFileOperation(d,n){switch(d){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:n.map(s=>({oldUri:C.URI.revive(s.source),newUri:C.URI.revive(s.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:n.map(s=>C.URI.revive(s.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:n.map(s=>C.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,n){return(s,o,h)=>{const i=function(t){s.call(o,t)};return i.extension=d,n.event(i,void 0,h)}}async $onWillRunFileOperation(d,n,s,o){switch(d){case p.FileOperation.MOVE:return await this.n(this.g,{files:n.map(h=>({oldUri:C.URI.revive(h.source),newUri:C.URI.revive(h.target)}))},s,o);case p.FileOperation.DELETE:return await this.n(this.i,{files:n.map(h=>C.URI.revive(h.target))},s,o);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:n.map(h=>C.URI.revive(h.target))},s,o)}}async n(d,n,s,o){const h=new Set,i=[];if(await d.fireAsync(n,o,async(t,c)=>{const l=Date.now(),g=await Promise.resolve(t);g instanceof T.$GN&&(i.push([c.extension,g]),h.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-l>s&&this.k.warn("SLOW file-participant",c.extension.identifier)}),o.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,t]of i){const{edits:c}=A.WorkspaceEdit.from(t,{getTextDocumentVersion:l=>this.l.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(c)}return{edit:r,extensionNames:Array.from(h)}}}e.$Gpc=u}),define(Ce[285],Ie([1,0,18,11,22,14,97,4,26,70,13,15,2,33,328,94,104,183,19,8,7,25,80,5]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h,i,r,t,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0,n=qe(n),i=qe(i),l=qe(l);class g{constructor(j,U){this.d=j,this.e=U}async provideDocumentSymbols(j,U){const K=this.d.getDocument(j),H=await this.e.provideDocumentSymbols(K,U);if(!(0,v.$Mb)(H))return H[0]instanceof r.$QN?H.map(i.DocumentSymbol.from):g.f(H)}static f(j){j=j.slice(0).sort((H,ie)=>{let fe=H.location.range.start.compareTo(ie.location.range.start);return fe===0&&(fe=ie.location.range.end.compareTo(H.location.range.end)),fe});const U=[],K=[];for(const H of j){const ie={name:H.name||"!!MISSING: name!!",kind:i.SymbolKind.from(H.kind),tags:H.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:i.Range.from(H.location.range),selectionRange:i.Range.from(H.location.range),children:[]};for(;;){if(K.length===0){K.push(ie),U.push(ie);break}const fe=K[K.length-1];if(E.$Lt.containsRange(fe.range,ie.range)&&!E.$Lt.equalsRange(fe.range,ie.range)){fe.children?.push(ie),K.push(ie);break}K.pop()}}return U}}class m{constructor(j,U,K,H,ie,fe){this.f=j,this.g=U,this.h=K,this.j=H,this.k=ie,this.l=fe,this.d=new c.$hoc("CodeLens"),this.e=new Map}async provideCodeLenses(j,U){const K=this.f.getDocument(j),H=await this.h.provideCodeLenses(K,U);if(!H||U.isCancellationRequested)return;const ie=this.d.add(H),fe=new T.$Vc;this.e.set(ie,fe);const Re={cacheId:ie,lenses:[]};for(let Ue=0;Ue<H.length;Ue++)Re.lenses.push({cacheId:[ie,Ue],range:i.Range.from(H[Ue].range),command:this.g.toInternal(H[Ue].command,fe)});return Re}async resolveCodeLens(j,U){const K=j.cacheId&&this.d.get(...j.cacheId);if(!K)return;let H;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?H=K:H=await this.h.resolveCodeLens(K,U),H||(H=K),U.isCancellationRequested)return;const ie=j.cacheId&&this.e.get(j.cacheId[0]);if(ie){if(!H.command){const fe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,fe),this.l.error(fe);return}return j.command=this.g.toInternal(H.command,ie),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function $(Ne){return Array.isArray(Ne)?Ne.map(i.DefinitionLink.from):Ne?[i.DefinitionLink.from(Ne)]:[]}class S{constructor(j,U){this.d=j,this.e=U}async provideDefinition(j,U,K){const H=this.d.getDocument(j),ie=i.Position.to(U),fe=await this.e.provideDefinition(H,ie,K);return $(fe)}}class D{constructor(j,U){this.d=j,this.e=U}async provideDeclaration(j,U,K){const H=this.d.getDocument(j),ie=i.Position.to(U),fe=await this.e.provideDeclaration(H,ie,K);return $(fe)}}class b{constructor(j,U){this.d=j,this.e=U}async provideImplementation(j,U,K){const H=this.d.getDocument(j),ie=i.Position.to(U),fe=await this.e.provideImplementation(H,ie,K);return $(fe)}}class I{constructor(j,U){this.d=j,this.e=U}async provideTypeDefinition(j,U,K){const H=this.d.getDocument(j),ie=i.Position.to(U),fe=await this.e.provideTypeDefinition(H,ie,K);return $(fe)}}class R{static{this.f=10}constructor(j,U){this.g=j,this.h=U,this.d=0,this.e=new Map}async provideHover(j,U,K,H){const ie=this.g.getDocument(j),fe=i.Position.to(U);let Re;if(K&&K.verbosityRequest){const tt=K.verbosityRequest.previousHover.id,nt=this.e.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const et={verbosityDelta:K.verbosityRequest.verbosityDelta,previousHover:nt};Re=await this.h.provideHover(ie,fe,H,et)}else Re=await this.h.provideHover(ie,fe,H);if(!Re||(0,v.$Mb)(Re.contents))return;Re.range||(Re.range=ie.getWordRangeAtPosition(fe)),Re.range||(Re.range=new r.$yN(fe,fe));const Ue=i.Hover.from(Re),Ke=this.d;if(this.e.size===R.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Ke,Re),this.d+=1,{...Ue,id:Ke}}releaseHover(j){this.e.delete(j)}}class f{constructor(j,U){this.d=j,this.e=U}async provideEvaluatableExpression(j,U,K){const H=this.d.getDocument(j),ie=i.Position.to(U),fe=await this.e.provideEvaluatableExpression(H,ie,K);if(fe)return i.EvaluatableExpression.from(fe)}}class w{constructor(j,U){this.d=j,this.e=U}async provideInlineValues(j,U,K,H){const ie=this.d.getDocument(j),fe=await this.e.provideInlineValues(ie,i.Range.to(U),i.InlineValueContext.to(K),H);if(Array.isArray(fe))return fe.map(Re=>i.InlineValue.from(Re))}}class M{constructor(j,U){this.d=j,this.e=U}async provideDocumentHighlights(j,U,K){const H=this.d.getDocument(j),ie=i.Position.to(U),fe=await this.e.provideDocumentHighlights(H,ie,K);if(Array.isArray(fe))return fe.map(i.DocumentHighlight.from)}}class N{constructor(j,U){this.d=j,this.e=U}async provideMultiDocumentHighlights(j,U,K,H){const ie=this.d.getDocument(j),fe=K.map(Ke=>this.d.getDocument(Ke)),Re=i.Position.to(U),Ue=await this.e.provideMultiDocumentHighlights(ie,Re,fe,H);if(Array.isArray(Ue))return Ue.map(i.MultiDocumentHighlight.from)}}class L{constructor(j,U){this.d=j,this.e=U}async provideLinkedEditingRanges(j,U,K){const H=this.d.getDocument(j),ie=i.Position.to(U),fe=await this.e.provideLinkedEditingRanges(H,ie,K);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,v.$Jb)(fe.ranges.map(i.Range.from)),wordPattern:fe.wordPattern}}}class G{constructor(j,U){this.d=j,this.e=U}async provideReferences(j,U,K,H){const ie=this.d.getDocument(j),fe=i.Position.to(U),Re=await this.e.provideReferences(ie,fe,K,H);if(Array.isArray(Re))return Re.map(i.location.from)}}class W{static{this.d=1e3}constructor(j,U,K,H,ie,fe,Re){this.g=j,this.h=U,this.j=K,this.k=H,this.l=ie,this.m=fe,this.n=Re,this.e=new c.$hoc("CodeAction"),this.f=new Map}async provideCodeActions(j,U,K,H){const ie=this.g.getDocument(j),fe=d.$Nt.isISelection(U)?i.Selection.to(U):i.Range.to(U),Re=[];for(const et of this.j.getDiagnostics(j))if(fe.intersection(et.range)&&Re.push(et)>W.d)break;const Ue={diagnostics:Re,only:K.only?new r.$SN(K.only):void 0,triggerKind:i.CodeActionTriggerKind.to(K.trigger)},Ke=await this.k.provideCodeActions(ie,fe,Ue,H);if(!(0,v.$Nb)(Ke)||H.isCancellationRequested)return;const _e=this.e.add(Ke),tt=new T.$Vc;this.f.set(_e,tt);const nt=[];for(let et=0;et<Ke.length;et++){const rt=Ke[et];if(rt)if(W.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,tt)});else{Ue.only&&(rt.kind?Ue.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ft=rt.ranges??[];nt.push({cacheId:[_e,et],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,tt),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$6G)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$6G)(this.m,"codeActionRanges")?(0,v.$Jb)(ft.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:_e,actions:nt}}async resolveCodeAction(j,U){const[K,H]=j,ie=this.e.get(K,H);if(!ie||W.o(ie))return{};if(!this.k.resolveCodeAction)return{};const fe=await this.k.resolveCodeAction(ie,U)??ie;let Re;fe.edit&&(Re=i.WorkspaceEdit.from(fe.edit,void 0));let Ue;if(fe.command){const Ke=this.f.get(K);Ke&&(Ue=this.h.toInternal(fe.command,Ke))}return{edit:Re,command:Ue}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}class F{constructor(j,U,K,H,ie){this.e=j,this.f=U,this.g=K,this.h=H,this.j=ie,this.d=new c.$hoc("DocumentPasteEdit")}async prepareDocumentPaste(j,U,K,H){if(!this.g.prepareDocumentPaste)return;const ie=this.f.getDocument(j),fe=U.map(Ke=>i.Range.to(Ke)),Re=i.DataTransfer.toDataTransfer(K,()=>{throw new O.$ab});if(await this.g.prepareDocumentPaste(ie,fe,Re,H),H.isCancellationRequested)return;const Ue=Array.from(Re).filter(([,Ke])=>!(Ke instanceof r.$mO));return i.DataTransfer.from(Ue)}async providePasteEdits(j,U,K,H,ie,fe){if(!this.g.provideDocumentPasteEdits)return[];const Re=this.f.getDocument(U),Ue=K.map(nt=>i.Range.to(nt)),Ke=i.DataTransfer.toDataTransfer(H,async nt=>(await this.e.$resolvePasteFileData(this.h,j,nt)).buffer),_e=await this.g.provideDocumentPasteEdits(Re,Ue,Ke,{only:ie.only?new r.$rO(ie.only):void 0,triggerKind:ie.triggerKind},fe);if(!_e||fe.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(j,U){const[K,H]=j,ie=this.d.get(K,H);if(!ie||!this.g.resolveDocumentPasteEdit)return{};const fe=await this.g.resolveDocumentPasteEdit(ie,U)??ie;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releasePasteEdits(j){this.d.delete(j)}}class V{constructor(j,U){this.d=j,this.e=U}async provideDocumentFormattingEdits(j,U,K){const H=this.d.getDocument(j),ie=await this.e.provideDocumentFormattingEdits(H,U,K);if(Array.isArray(ie))return ie.map(i.TextEdit.from)}}class ae{constructor(j,U){this.d=j,this.e=U}async provideDocumentRangeFormattingEdits(j,U,K,H){const ie=this.d.getDocument(j),fe=i.Range.to(U),Re=await this.e.provideDocumentRangeFormattingEdits(ie,fe,K,H);if(Array.isArray(Re))return Re.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,U,K,H){(0,y.$pg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ie=this.d.getDocument(j),fe=U.map(i.Range.to),Re=await this.e.provideDocumentRangesFormattingEdits(ie,fe,K,H);if(Array.isArray(Re))return Re.map(i.TextEdit.from)}}class $e{constructor(j,U){this.d=j,this.e=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,U,K,H,ie){const fe=this.d.getDocument(j),Re=i.Position.to(U),Ue=await this.e.provideOnTypeFormattingEdits(fe,Re,K,H,ie);if(Array.isArray(Ue))return Ue.map(i.TextEdit.from)}}class _{constructor(j,U){this.e=j,this.f=U,this.d=new c.$hoc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,U){const K=await this.e.provideWorkspaceSymbols(j,U);if(!(0,v.$Nb)(K))return{symbols:[]};const H=this.d.add(K),ie={cacheId:H,symbols:[]};for(let fe=0;fe<K.length;fe++){const Re=K[fe];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}ie.symbols.push({...i.WorkspaceSymbol.from(Re),cacheId:[H,fe]})}return ie}async resolveWorkspaceSymbol(j,U){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const K=this.d.get(...j.cacheId);if(K){const H=await this.e.resolveWorkspaceSymbol(K,U);return H&&(0,p.$go)(j,i.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class ge{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,U,K){this.d=j,this.e=U,this.f=K}async provideRenameEdits(j,U,K,H){const ie=this.d.getDocument(j),fe=i.Position.to(U);try{const Re=await this.e.provideRenameEdits(ie,fe,K,H);return Re?i.WorkspaceEdit.from(Re):void 0}catch(Re){const Ue=ge.g(Re);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(j,U,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(j),ie=i.Position.to(U);try{const fe=await this.e.prepareRename(H,ie,K);let Re,Ue;if(r.$yN.isRange(fe)?(Re=fe,Ue=H.getText(fe)):(0,y.$hg)(fe)&&(Re=fe.range,Ue=fe.placeholder),!Re||!Ue)return;if(Re.start.line>ie.line||Re.end.line<ie.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Re),text:Ue}}catch(fe){const Re=ge.g(fe);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(fe)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class se{static{this.d={[n.NewSymbolNameTriggerKind.Invoke]:r.NewSymbolNameTriggerKind.Invoke,[n.NewSymbolNameTriggerKind.Automatic]:r.NewSymbolNameTriggerKind.Automatic}}constructor(j,U,K){this.e=j,this.f=U,this.g=K}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(j,U,K,H){const ie=this.e.getDocument(j),fe=i.Range.to(U);try{const Re=se.d[K],Ue=await this.f.provideNewSymbolNames(ie,fe,Re,H);return Ue?Ue.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Re){this.g.error(se.h(Re)??JSON.stringify(Re,null,"	"));return}}static h(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class ce{constructor(j,U){this.resultId=j,this.tokens=U}}class we{constructor(j,U){this.f=j,this.g=U,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,U,K){const H=this.f.getDocument(j),ie=U!==0?this.d.get(U):null;let fe=typeof ie?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ie.resultId,K):await this.g.provideDocumentSemanticTokens(H,K);return ie&&this.d.delete(U),fe?(fe=we.h(fe),this.o(we.n(ie,fe),fe)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return we.j(j)?we.k(j)?j:new r.$RO(new Uint32Array(j.data),j.resultId):we.l(j)?we.m(j)?j:new r.$TO(j.edits.map(U=>new r.$SO(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const U of j.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static n(j,U){if(!we.j(U)||!j||!j.tokens)return U;const K=j.tokens,H=K.length,ie=U.data,fe=ie.length;let Re=0;const Ue=Math.min(H,fe);for(;Re<Ue&&K[Re]===ie[Re];)Re++;if(Re===H&&Re===fe)return new r.$TO([],U.resultId);let Ke=0;const _e=Ue-Re;for(;Ke<_e&&K[H-Ke-1]===ie[fe-Ke-1];)Ke++;return new r.$TO([{start:Re,deleteCount:H-Re-Ke,data:ie.subarray(Re,fe-Ke)}],U.resultId)}o(j,U){if(we.j(j)){const K=this.e++;return this.d.set(K,new ce(j.resultId,j.data)),(0,s.$Fdb)({id:K,type:"full",data:j.data})}if(we.l(j)){const K=this.e++;return we.j(U)?this.d.set(K,new ce(U.resultId,U.data)):this.d.set(K,new ce(j.resultId)),(0,s.$Fdb)({id:K,type:"delta",deltas:(j.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class re{constructor(j,U){this.d=j,this.e=U}async provideDocumentRangeSemanticTokens(j,U,K){const H=this.d.getDocument(j),ie=await this.e.provideDocumentRangeSemanticTokens(H,i.Range.to(U),K);return ie?this.f(ie):null}f(j){return(0,s.$Fdb)({id:0,type:"full",data:j.data})}}class Pe{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,U,K,H,ie){this.f=j,this.g=U,this.h=K,this.j=H,this.k=ie,this.d=new c.$hoc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,U,K,H){const ie=this.f.getDocument(j),fe=i.Position.to(U),Re=ie.getWordRangeAtPosition(fe)||new r.$yN(fe,fe),Ue=Re.with({end:fe}),Ke=new a.$ge,_e=await this.h.provideCompletionItems(ie,fe,H,i.CompletionContext.to(K));if(!_e||H.isCancellationRequested)return;const tt=Array.isArray(_e)?new r.$6N(_e):_e,nt=Pe.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),et=new T.$Vc;this.e.set(nt,et);const rt=[],ft={x:nt,[l.ISuggestResultDtoField.completions]:rt,[l.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Re),insert:i.Range.from(Ue)},[l.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[l.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let ct=0;ct<tt.items.length;ct++){const st=tt.items[ct],ut=this.l(st,[nt,ct],Ue,Re);rt.push(ut)}return ft}async resolveCompletionItem(j,U){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...j);if(!K)return;const H=this.l(K,j),ie=await this.h.resolveCompletionItem(K,U);if(!ie)return;const fe=this.l(ie,j);return(H[l.ISuggestDataDtoField.insertText]!==fe[l.ISuggestDataDtoField.insertText]||H[l.ISuggestDataDtoField.insertTextRules]!==fe[l.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H[l.ISuggestDataDtoField.commandIdent]!==fe[l.ISuggestDataDtoField.commandIdent]||H[l.ISuggestDataDtoField.commandId]!==fe[l.ISuggestDataDtoField.commandId]||!(0,p.$ho)(H[l.ISuggestDataDtoField.commandArguments],fe[l.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,[l.ISuggestDataDtoField.documentation]:fe[l.ISuggestDataDtoField.documentation],[l.ISuggestDataDtoField.detail]:fe[l.ISuggestDataDtoField.detail],[l.ISuggestDataDtoField.additionalTextEdits]:fe[l.ISuggestDataDtoField.additionalTextEdits],[l.ISuggestDataDtoField.insertText]:fe[l.ISuggestDataDtoField.insertText],[l.ISuggestDataDtoField.insertTextRules]:fe[l.ISuggestDataDtoField.insertTextRules],[l.ISuggestDataDtoField.commandIdent]:fe[l.ISuggestDataDtoField.commandIdent],[l.ISuggestDataDtoField.commandId]:fe[l.ISuggestDataDtoField.commandId],[l.ISuggestDataDtoField.commandArguments]:fe[l.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,U,K,H){const ie=this.e.get(U[0]);if(!ie)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(j.command,ie),Re={x:U,[l.ISuggestDataDtoField.label]:j.label,[l.ISuggestDataDtoField.kind]:j.kind!==void 0?i.CompletionItemKind.from(j.kind):void 0,[l.ISuggestDataDtoField.kindModifier]:j.tags&&j.tags.map(i.CompletionItemTag.from),[l.ISuggestDataDtoField.detail]:j.detail,[l.ISuggestDataDtoField.documentation]:typeof j.documentation>"u"?void 0:i.MarkdownString.fromStrict(j.documentation),[l.ISuggestDataDtoField.sortText]:j.sortText!==j.label?j.sortText:void 0,[l.ISuggestDataDtoField.filterText]:j.filterText!==j.label?j.filterText:void 0,[l.ISuggestDataDtoField.preselect]:j.preselect||void 0,[l.ISuggestDataDtoField.insertTextRules]:j.keepWhitespace?n.CompletionItemInsertTextRule.KeepWhitespace:n.CompletionItemInsertTextRule.None,[l.ISuggestDataDtoField.commitCharacters]:j.commitCharacters?.join(""),[l.ISuggestDataDtoField.additionalTextEdits]:j.additionalTextEdits&&j.additionalTextEdits.map(i.TextEdit.from),[l.ISuggestDataDtoField.commandIdent]:fe?.$ident,[l.ISuggestDataDtoField.commandId]:fe?.id,[l.ISuggestDataDtoField.commandArguments]:fe?.$ident?void 0:fe?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re[l.ISuggestDataDtoField.insertText]=j.textEdit.newText):typeof j.insertText=="string"?Re[l.ISuggestDataDtoField.insertText]=j.insertText:j.insertText instanceof r.$HN&&(Re[l.ISuggestDataDtoField.insertText]=j.insertText.value,Re[l.ISuggestDataDtoField.insertTextRules]|=n.CompletionItemInsertTextRule.InsertAsSnippet);let Ue;return j.textEdit?Ue=j.textEdit.range:j.range&&(Ue=j.range),r.$yN.isRange(Ue)?Re[l.ISuggestDataDtoField.range]=i.Range.from(Ue):Ue&&(!K?.isEqual(Ue.inserting)||!H?.isEqual(Ue.replacing))&&(Re[l.ISuggestDataDtoField.range]={insert:i.Range.from(Ue.inserting),replace:i.Range.from(Ue.replacing)}),Re}}class Me{async provideInlineCompletions(j,U,K,H){}async provideInlineEdits(j,U,K,H){}disposeCompletions(j){}handleDidShowCompletionItem(j,U,K){}handlePartialAccept(j,U,K,H){}}class Y extends Me{constructor(j,U,K,H){super(),this.f=j,this.g=U,this.h=K,this.j=H,this.d=new ee,this.e=(0,t.$6G)(this.f,"inlineCompletionsAdditions"),this.k={[n.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[n.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$6G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,U,K,H){const ie=this.g.getDocument(j),fe=i.Position.to(U),Re=await this.h.provideInlineCompletionItems(ie,fe,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:i.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},H);if(!Re||H.isCancellationRequested)return;const Ue=Array.isArray(Re)?Re:Re.items,Ke=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],_e=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((et,rt)=>{let ft;et.command&&(tt||(tt=new T.$Vc),ft=this.j.toInternal(et.command,tt));const ct=et.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Ke.map(et=>(tt||(tt=new T.$Vc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(j,U,K,H){if(!this.h.provideInlineEdits)return;(0,t.$7G)(this.f,"inlineCompletionsAdditions");const ie=this.g.getDocument(j),fe=i.Range.to(U),Re=await this.h.provideInlineEdits(ie,fe,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:i.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind],userPrompt:K.userPrompt},H);if(!Re||H.isCancellationRequested)return;const Ue=Array.isArray(Re)?Re:Re.items,Ke=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],_e=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((et,rt)=>{let ft;et.command&&(tt||(tt=new T.$Vc),ft=this.j.toInternal(et.command,tt));const ct=et.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Ke.map(et=>(tt||(tt=new T.$Vc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,U,K){const H=this.d.get(j)?.items[U];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,K)}handlePartialAccept(j,U,K,H){const ie=this.d.get(j)?.items[U];ie&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ie,K),this.h.handleDidPartiallyAcceptCompletionItem(ie,i.PartialAcceptInfo.to(H)))}}class q{async provideInlineEdits(j,U,K){const H=this.f.getDocument(j),ie=await this.g.provideInlineEdit(H,{triggerKind:this.e[U.triggerKind]},K);if(!ie||K.isCancellationRequested)return;let fe;const Re=this.d.createReferenceId({dispose(){fe?.dispose()},item:ie});let Ue;ie.accepted&&(fe||(fe=new T.$Vc),Ue=this.h.toInternal(ie.accepted,fe));let Ke;return ie.rejected&&(fe||(fe=new T.$Vc),Ke=this.h.toInternal(ie.rejected,fe)),{pid:Re,text:ie.text,range:i.Range.from(ie.range),accepted:Ue,rejected:Ke}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,U,K,H){this.f=U,this.g=K,this.h=H,this.d=new ee,this.e={[n.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[n.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class ee{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const U=this.e++;return this.d.set(U,j),U}disposeReferenceId(j){const U=this.d.get(j);return this.d.delete(j),U}get(j){return this.d.get(j)}}class ve{constructor(j,U){this.e=j,this.f=U,this.d=new c.$hoc("SignatureHelp")}async provideSignatureHelp(j,U,K,H){const ie=this.e.getDocument(j),fe=i.Position.to(U),Re=this.g(K),Ue=await this.f.provideSignatureHelp(ie,fe,H,Re);if(Ue){const Ke=this.d.add([Ue]);return{...i.SignatureHelp.from(Ue),id:Ke}}}g(j){let U;if(j.activeSignatureHelp){const K=i.SignatureHelp.to(j.activeSignatureHelp),H=this.d.get(j.activeSignatureHelp.id,0);H?(U=H,U.activeSignature=K.activeSignature,U.activeParameter=K.activeParameter):U=K}return{...j,activeSignatureHelp:U}}releaseSignatureHelp(j){this.d.delete(j)}}class ue{constructor(j,U,K,H,ie){this.f=j,this.g=U,this.h=K,this.j=H,this.k=ie,this.d=new c.$hoc("InlayHints"),this.e=new Map}async provideInlayHints(j,U,K){const H=this.f.getDocument(j),ie=i.Range.to(U),fe=await this.h.provideInlayHints(H,ie,K);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(U)}`);return}if(K.isCancellationRequested)return;const Re=this.d.add(fe);this.e.set(Re,new T.$Vc);const Ue={hints:[],cacheId:Re};for(let Ke=0;Ke<fe.length;Ke++)this.l(fe[Ke],ie)&&Ue.hints.push(this.m(fe[Ke],[Re,Ke]));return this.j.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(U)}`),Ue}async resolveInlayHint(j,U){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...j);if(!K)return;const H=await this.h.resolveInlayHint(K,U);if(H&&this.l(H))return this.m(H,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,U){return j.label.length===0||Array.isArray(j.label)&&j.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(U&&!U.contains(j.position))}m(j,U){const K=this.e.get(U[0]);if(!K)throw Error("DisposableStore is missing...");const H={label:"",cacheId:U,tooltip:i.MarkdownString.fromStrict(j.tooltip),position:i.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(i.TextEdit.from),kind:j.kind&&i.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")H.label=j.label;else{const ie=[];H.label=ie;for(const fe of j.label){if(!fe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Re={label:fe.value,tooltip:i.MarkdownString.fromStrict(fe.tooltip)};r.$IN.isLocation(fe.location)&&(Re.location=i.location.from(fe.location)),fe.command&&(Re.command=this.g.toInternal(fe.command,K)),ie.push(Re)}}return H}}class be{constructor(j,U){this.e=j,this.f=U,this.d=new c.$hoc("DocumentLink")}async provideLinks(j,U){const K=this.e.getDocument(j),H=await this.f.provideDocumentLinks(K,U);if(!(!Array.isArray(H)||H.length===0)&&!U.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(be.g).map(i.DocumentLink.from)};{const ie=this.d.add(H),fe={links:[],cacheId:ie};for(let Re=0;Re<H.length;Re++){if(!be.g(H[Re]))continue;const Ue=i.DocumentLink.from(H[Re]);Ue.cacheId=[ie,Re],fe.links.push(Ue)}return fe}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,U){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...j);if(!K)return;const H=await this.f.resolveDocumentLink(K,U);if(!(!H||!be.g(H)))return i.DocumentLink.from(H)}releaseLinks(j){this.d.delete(j)}}class de{constructor(j,U){this.d=j,this.e=U}async provideColors(j,U){const K=this.d.getDocument(j),H=await this.e.provideDocumentColors(K,U);return Array.isArray(H)?H.map(fe=>({color:i.Color.from(fe.color),range:i.Range.from(fe.range)})):[]}async provideColorPresentations(j,U,K){const H=this.d.getDocument(j),ie=i.Range.to(U.range),fe=i.Color.to(U.color),Re=await this.e.provideColorPresentations(fe,{document:H,range:ie},K);if(Array.isArray(Re))return Re.map(i.ColorPresentation.from)}}class X{constructor(j,U){this.d=j,this.e=U}async provideFoldingRanges(j,U,K){const H=this.d.getDocument(j),ie=await this.e.provideFoldingRanges(H,U,K);if(Array.isArray(ie))return ie.map(i.FoldingRange.from)}}class Z{constructor(j,U,K){this.d=j,this.e=U,this.f=K}async provideSelectionRanges(j,U,K){const H=this.d.getDocument(j),ie=U.map(i.Position.to),fe=await this.e.provideSelectionRanges(H,ie,K);if(!(0,v.$Nb)(fe))return[];if(fe.length!==ie.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let Ue=0;Ue<ie.length;Ue++){const Ke=[];Re.push(Ke);let _e=ie[Ue],tt=fe[Ue];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Re}}class me{constructor(j,U){this.f=j,this.g=U,this.d=new A.$6P(""),this.e=new Map}async prepareSession(j,U,K){const H=this.f.getDocument(j),ie=i.Position.to(U),fe=await this.g.prepareCallHierarchy(H,ie,K);if(!fe)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(fe)?fe.map(Ue=>this.h(Re,Ue)):[this.h(Re,fe)]}async provideCallsTo(j,U,K){const H=this.j(j,U);if(!H)throw new Error("missing call hierarchy item");const ie=await this.g.provideCallHierarchyIncomingCalls(H,K);if(ie)return ie.map(fe=>({from:this.h(j,fe.from),fromRanges:fe.fromRanges.map(Re=>i.Range.from(Re))}))}async provideCallsFrom(j,U,K){const H=this.j(j,U);if(!H)throw new Error("missing call hierarchy item");const ie=await this.g.provideCallHierarchyOutgoingCalls(H,K);if(ie)return ie.map(fe=>({to:this.h(j,fe.to),fromRanges:fe.fromRanges.map(Re=>i.Range.from(Re))}))}releaseSession(j){this.e.delete(j)}h(j,U){const K=this.e.get(j),H=i.CallHierarchyItem.from(U,j,K.size.toString(36));return K.set(H._itemId,U),H}j(j,U){return this.e.get(j)?.get(U)}}class pe{constructor(j,U){this.f=j,this.g=U,this.d=new A.$6P(""),this.e=new Map}async prepareSession(j,U,K){const H=this.f.getDocument(j),ie=i.Position.to(U),fe=await this.g.prepareTypeHierarchy(H,ie,K);if(!fe)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(fe)?fe.map(Ue=>this.h(Re,Ue)):[this.h(Re,fe)]}async provideSupertypes(j,U,K){const H=this.j(j,U);if(!H)throw new Error("missing type hierarchy item");const ie=await this.g.provideTypeHierarchySupertypes(H,K);if(ie)return ie.map(fe=>this.h(j,fe))}async provideSubtypes(j,U,K){const H=this.j(j,U);if(!H)throw new Error("missing type hierarchy item");const ie=await this.g.provideTypeHierarchySubtypes(H,K);if(ie)return ie.map(fe=>this.h(j,fe))}releaseSession(j){this.e.delete(j)}h(j,U){const K=this.e.get(j),H=i.TypeHierarchyItem.from(U,j,K.size.toString(36));return K.set(H._itemId,U),H}j(j,U){return this.e.get(j)?.get(U)}}class Oe{constructor(j,U,K,H,ie){this.e=j,this.f=U,this.g=K,this.h=H,this.j=ie,this.d=new c.$hoc("DocumentDropEdit")}async provideDocumentOnDropEdits(j,U,K,H,ie){const fe=this.f.getDocument(U),Re=i.Position.to(K),Ue=i.DataTransfer.toDataTransfer(H,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,j,nt)).buffer),Ke=await this.g.provideDocumentDropEdits(fe,Re,Ue,ie);if(!Ke)return;const _e=(0,v.$4b)(Ke),tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(j,U){const[K,H]=j,ie=this.d.get(K,H);if(!ie||!this.g.resolveDocumentDropEdit)return{};const fe=await this.g.resolveDocumentDropEdit(ie,U)??ie;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releaseDropEdits(j){this.d.delete(j)}}class ze{constructor(j,U){this.d=j,this.e=U}async provideMappedEdits(j,U,K,H){const ie=u.URI.revive(j),fe=this.d.getDocument(ie),Re=K.documents.map(_e=>_e.map(tt=>({uri:u.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),Ue={documents:Re,selections:Re[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(fe,U,Ue,H);return Ke?i.WorkspaceEdit.from(Ke):null}}class ke{constructor(j,U){this.adapter=j,this.extension=U}}class Ae{static{this.d=0}constructor(j,U,K,H,ie,fe,Re,Ue){this.g=U,this.h=K,this.j=H,this.k=ie,this.l=fe,this.m=Re,this.n=Ue,this.f=new Map,this.e=j.getProxy(l.$uN.MainThreadLanguageFeatures)}o(j,U){return i.DocumentSelector.from(j,this.g,U)}p(j){return new r.$wN(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Ae.d++}async s(j,U,K,H,ie,fe=!1){const Re=this.f.get(j);if(!Re||!(Re.adapter instanceof U))return H;const Ue=Date.now();fe||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ke=K(Re.adapter,Re.extension);return Promise.resolve(Ke).catch(_e=>{(0,O.$6)(_e)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Re.extension.identifier,_e))}).finally(()=>{fe||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),C.CancellationToken.isCancellationToken(ie)?(0,k.$uh)(Ke,ie):Ke}t(j,U){const K=this.q();return this.f.set(K,new ke(j,U)),K}static u(j){return j.displayName||j.name}static w(j){return j.identifier.value}registerDocumentSymbolProvider(j,U,K,H){const ie=this.t(new g(this.h,K),j),fe=H&&H.label||Ae.u(j);return this.e.$registerDocumentSymbolProvider(ie,this.o(U,j),fe),this.p(ie)}$provideDocumentSymbols(j,U,K){return this.s(j,g,H=>H.provideDocumentSymbols(u.URI.revive(U),K),void 0,K)}registerCodeLensProvider(j,U,K){const H=this.q(),ie=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new ke(new m(this.h,this.j.converter,K,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(H,this.o(U,j),ie);let fe=this.p(H);if(ie!==void 0){const Re=K.onDidChangeCodeLenses(Ue=>this.e.$emitCodeLensEvent(ie));fe=r.$wN.from(fe,Re)}return fe}$provideCodeLenses(j,U,K){return this.s(j,m,H=>H.provideCodeLenses(u.URI.revive(U),K),void 0,K)}$resolveCodeLens(j,U,K){return this.s(j,m,H=>H.resolveCodeLens(U,K),void 0,void 0)}$releaseCodeLenses(j,U){this.s(j,m,K=>Promise.resolve(K.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider(j,U,K){const H=this.t(new S(this.h,K),j);return this.e.$registerDefinitionSupport(H,this.o(U,j)),this.p(H)}$provideDefinition(j,U,K,H){return this.s(j,S,ie=>ie.provideDefinition(u.URI.revive(U),K,H),[],H)}registerDeclarationProvider(j,U,K){const H=this.t(new D(this.h,K),j);return this.e.$registerDeclarationSupport(H,this.o(U,j)),this.p(H)}$provideDeclaration(j,U,K,H){return this.s(j,D,ie=>ie.provideDeclaration(u.URI.revive(U),K,H),[],H)}registerImplementationProvider(j,U,K){const H=this.t(new b(this.h,K),j);return this.e.$registerImplementationSupport(H,this.o(U,j)),this.p(H)}$provideImplementation(j,U,K,H){return this.s(j,b,ie=>ie.provideImplementation(u.URI.revive(U),K,H),[],H)}registerTypeDefinitionProvider(j,U,K){const H=this.t(new I(this.h,K),j);return this.e.$registerTypeDefinitionSupport(H,this.o(U,j)),this.p(H)}$provideTypeDefinition(j,U,K,H){return this.s(j,I,ie=>ie.provideTypeDefinition(u.URI.revive(U),K,H),[],H)}registerHoverProvider(j,U,K,H){const ie=this.t(new R(this.h,K),j);return this.e.$registerHoverProvider(ie,this.o(U,j)),this.p(ie)}$provideHover(j,U,K,H,ie){return this.s(j,R,fe=>fe.provideHover(u.URI.revive(U),K,H,ie),void 0,ie)}$releaseHover(j,U){this.s(j,R,K=>Promise.resolve(K.releaseHover(U)),void 0,void 0)}registerEvaluatableExpressionProvider(j,U,K,H){const ie=this.t(new f(this.h,K),j);return this.e.$registerEvaluatableExpressionProvider(ie,this.o(U,j)),this.p(ie)}$provideEvaluatableExpression(j,U,K,H){return this.s(j,f,ie=>ie.provideEvaluatableExpression(u.URI.revive(U),K,H),void 0,H)}registerInlineValuesProvider(j,U,K,H){const ie=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new w(this.h,K),j);this.e.$registerInlineValuesProvider(fe,this.o(U,j),ie);let Re=this.p(fe);if(ie!==void 0){const Ue=K.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(ie));Re=r.$wN.from(Re,Ue)}return Re}$provideInlineValues(j,U,K,H,ie){return this.s(j,w,fe=>fe.provideInlineValues(u.URI.revive(U),K,H,ie),void 0,ie)}registerDocumentHighlightProvider(j,U,K){const H=this.t(new M(this.h,K),j);return this.e.$registerDocumentHighlightProvider(H,this.o(U,j)),this.p(H)}registerMultiDocumentHighlightProvider(j,U,K){const H=this.t(new N(this.h,K),j);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(U,j)),this.p(H)}$provideDocumentHighlights(j,U,K,H){return this.s(j,M,ie=>ie.provideDocumentHighlights(u.URI.revive(U),K,H),void 0,H)}$provideMultiDocumentHighlights(j,U,K,H,ie){return this.s(j,N,fe=>fe.provideMultiDocumentHighlights(u.URI.revive(U),K,H.map(Re=>u.URI.revive(Re)),ie),void 0,ie)}registerLinkedEditingRangeProvider(j,U,K){const H=this.t(new L(this.h,K),j);return this.e.$registerLinkedEditingRangeProvider(H,this.o(U,j)),this.p(H)}$provideLinkedEditingRanges(j,U,K,H){return this.s(j,L,async ie=>{const fe=await ie.provideLinkedEditingRanges(u.URI.revive(U),K,H);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?Ae.y(fe.wordPattern):void 0}},void 0,H)}registerReferenceProvider(j,U,K){const H=this.t(new G(this.h,K),j);return this.e.$registerReferenceSupport(H,this.o(U,j)),this.p(H)}$provideReferences(j,U,K,H,ie){return this.s(j,G,fe=>fe.provideReferences(u.URI.revive(U),K,H,ie),void 0,ie)}registerCodeActionProvider(j,U,K,H){const ie=new T.$Vc,fe=this.t(new W(this.h,this.j.converter,this.k,K,this.l,j,this.m),j);return this.e.$registerCodeActionSupport(fe,this.o(U,j),{providedKinds:H?.providedCodeActionKinds?.map(Re=>Re.value),documentation:H?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,ie)}))},Ae.u(j),Ae.w(j),!!K.resolveCodeAction),ie.add(this.p(fe)),ie}$provideCodeActions(j,U,K,H,ie){return this.s(j,W,fe=>fe.provideCodeActions(u.URI.revive(U),K,H,ie),void 0,ie)}$resolveCodeAction(j,U,K){return this.s(j,W,H=>H.resolveCodeAction(U,K),{},void 0)}$releaseCodeActions(j,U){this.s(j,W,K=>Promise.resolve(K.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider(j,U,K){const H=this.t(new V(this.h,K),j);return this.e.$registerDocumentFormattingSupport(H,this.o(U,j),j.identifier,j.displayName||j.name),this.p(H)}$provideDocumentFormattingEdits(j,U,K,H){return this.s(j,V,ie=>ie.provideDocumentFormattingEdits(u.URI.revive(U),K,H),void 0,H)}registerDocumentRangeFormattingEditProvider(j,U,K){const H=typeof K.provideDocumentRangesFormattingEdits=="function",ie=this.t(new ae(this.h,K),j);return this.e.$registerRangeFormattingSupport(ie,this.o(U,j),j.identifier,j.displayName||j.name,H),this.p(ie)}$provideDocumentRangeFormattingEdits(j,U,K,H,ie){return this.s(j,ae,fe=>fe.provideDocumentRangeFormattingEdits(u.URI.revive(U),K,H,ie),void 0,ie)}$provideDocumentRangesFormattingEdits(j,U,K,H,ie){return this.s(j,ae,fe=>fe.provideDocumentRangesFormattingEdits(u.URI.revive(U),K,H,ie),void 0,ie)}registerOnTypeFormattingEditProvider(j,U,K,H){const ie=this.t(new $e(this.h,K),j);return this.e.$registerOnTypeFormattingSupport(ie,this.o(U,j),H,j.identifier),this.p(ie)}$provideOnTypeFormattingEdits(j,U,K,H,ie,fe){return this.s(j,$e,Re=>Re.provideOnTypeFormattingEdits(u.URI.revive(U),K,H,ie,fe),void 0,fe)}registerWorkspaceSymbolProvider(j,U){const K=this.t(new _(U,this.l),j);return this.e.$registerNavigateTypeSupport(K,typeof U.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(j,U,K){return this.s(j,_,H=>H.provideWorkspaceSymbols(U,K),{symbols:[]},K)}$resolveWorkspaceSymbol(j,U,K){return this.s(j,_,H=>H.resolveWorkspaceSymbol(U,K),void 0,void 0)}$releaseWorkspaceSymbols(j,U){this.s(j,_,K=>K.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider(j,U,K){const H=this.t(new ge(this.h,K,this.l),j);return this.e.$registerRenameSupport(H,this.o(U,j),ge.supportsResolving(K)),this.p(H)}$provideRenameEdits(j,U,K,H,ie){return this.s(j,ge,fe=>fe.provideRenameEdits(u.URI.revive(U),K,H,ie),void 0,ie)}$resolveRenameLocation(j,U,K,H){return this.s(j,ge,ie=>ie.resolveRenameLocation(u.URI.revive(U),K,H),void 0,H)}registerNewSymbolNamesProvider(j,U,K){const H=this.t(new se(this.h,K,this.l),j);return this.e.$registerNewSymbolNamesProvider(H,this.o(U,j)),this.p(H)}$supportsAutomaticNewSymbolNamesTriggerKind(j){return this.s(j,se,U=>U.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(j,U,K,H,ie){return this.s(j,se,fe=>fe.provideNewSymbolNames(u.URI.revive(U),K,H,ie),void 0,ie)}registerDocumentSemanticTokensProvider(j,U,K,H){const ie=this.t(new we(this.h,K),j),fe=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ie,this.o(U,j),H,fe);let Re=this.p(ie);if(fe){const Ue=K.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(fe));Re=r.$wN.from(Re,Ue)}return Re}$provideDocumentSemanticTokens(j,U,K,H){return this.s(j,we,ie=>ie.provideDocumentSemanticTokens(u.URI.revive(U),K,H),null,H)}$releaseDocumentSemanticTokens(j,U){this.s(j,we,K=>K.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,U,K,H){const ie=this.t(new re(this.h,K),j);return this.e.$registerDocumentRangeSemanticTokensProvider(ie,this.o(U,j),H),this.p(ie)}$provideDocumentRangeSemanticTokens(j,U,K,H){return this.s(j,re,ie=>ie.provideDocumentRangeSemanticTokens(u.URI.revive(U),K,H),null,H)}registerCompletionItemProvider(j,U,K,H){const ie=this.t(new Pe(this.h,this.j.converter,K,this.m,j),j);return this.e.$registerCompletionsProvider(ie,this.o(U,j),H,Pe.supportsResolving(K),j.identifier),this.p(ie)}$provideCompletionItems(j,U,K,H,ie){return this.s(j,Pe,fe=>fe.provideCompletionItems(u.URI.revive(U),K,H,ie),void 0,ie)}$resolveCompletionItem(j,U,K){return this.s(j,Pe,H=>H.resolveCompletionItem(U,K),void 0,K)}$releaseCompletionItems(j,U){this.s(j,Pe,K=>K.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider(j,U,K,H){const ie=new Y(j,this.h,K,this.j.converter),fe=this.t(ie,j);return this.e.$registerInlineCompletionsSupport(fe,this.o(U,j),ie.supportsHandleEvents,h.$qn.toKey(j.identifier.value),H?.yieldTo?.map(Re=>h.$qn.toKey(Re))||[]),this.p(fe)}$provideInlineCompletions(j,U,K,H,ie){return this.s(j,Me,fe=>fe.provideInlineCompletions(u.URI.revive(U),K,H,ie),void 0,ie)}$provideInlineEdits(j,U,K,H,ie){return this.s(j,Me,fe=>fe.provideInlineEdits(u.URI.revive(U),K,H,ie),void 0,ie)}$handleInlineCompletionDidShow(j,U,K,H){this.s(j,Me,async ie=>{ie.handleDidShowCompletionItem(U,K,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,U,K,H,ie){this.s(j,Me,async fe=>{fe.handlePartialAccept(U,K,H,ie)},void 0,void 0)}$freeInlineCompletionsList(j,U){this.s(j,Me,async K=>{K.disposeCompletions(U)},void 0,void 0)}registerInlineEditProvider(j,U,K){const H=new q(j,this.h,K,this.j.converter),ie=this.t(H,j);return this.e.$registerInlineEditProvider(ie,this.o(U,j),j.identifier),this.p(ie)}$provideInlineEdit(j,U,K,H){return this.s(j,q,ie=>ie.provideInlineEdits(u.URI.revive(U),K,H),void 0,H)}$freeInlineEdit(j,U){this.s(j,q,async K=>{K.disposeEdit(U)},void 0,void 0)}registerSignatureHelpProvider(j,U,K,H){const ie=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,fe=this.t(new ve(this.h,K),j);return this.e.$registerSignatureHelpProvider(fe,this.o(U,j),ie),this.p(fe)}$provideSignatureHelp(j,U,K,H,ie){return this.s(j,ve,fe=>fe.provideSignatureHelp(u.URI.revive(U),K,H,ie),void 0,ie)}$releaseSignatureHelp(j,U){this.s(j,ve,K=>K.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider(j,U,K){const H=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,ie=this.t(new ue(this.h,this.j.converter,K,this.l,j),j);this.e.$registerInlayHintsProvider(ie,this.o(U,j),typeof K.resolveInlayHint=="function",H,Ae.u(j));let fe=this.p(ie);if(H!==void 0){const Re=K.onDidChangeInlayHints(Ue=>this.e.$emitInlayHintsEvent(H));fe=r.$wN.from(fe,Re)}return fe}$provideInlayHints(j,U,K,H){return this.s(j,ue,ie=>ie.provideInlayHints(u.URI.revive(U),K,H),void 0,H)}$resolveInlayHint(j,U,K){return this.s(j,ue,H=>H.resolveInlayHint(U,K),void 0,K)}$releaseInlayHints(j,U){this.s(j,ue,K=>K.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider(j,U,K){const H=this.t(new be(this.h,K),j);return this.e.$registerDocumentLinkProvider(H,this.o(U,j),typeof K.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(j,U,K){return this.s(j,be,H=>H.provideLinks(u.URI.revive(U),K),void 0,K,U.scheme==="output")}$resolveDocumentLink(j,U,K){return this.s(j,be,H=>H.resolveLink(U,K),void 0,void 0,!0)}$releaseDocumentLinks(j,U){this.s(j,be,K=>K.releaseLinks(U),void 0,void 0,!0)}registerColorProvider(j,U,K){const H=this.t(new de(this.h,K),j);return this.e.$registerDocumentColorProvider(H,this.o(U,j)),this.p(H)}$provideDocumentColors(j,U,K){return this.s(j,de,H=>H.provideColors(u.URI.revive(U),K),[],K)}$provideColorPresentations(j,U,K,H){return this.s(j,de,ie=>ie.provideColorPresentations(u.URI.revive(U),K,H),void 0,H)}registerFoldingRangeProvider(j,U,K){const H=this.q(),ie=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new ke(new X(this.h,K),j)),this.e.$registerFoldingRangeProvider(H,this.o(U,j),j.identifier,ie);let fe=this.p(H);if(ie!==void 0){const Re=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ie));fe=r.$wN.from(fe,Re)}return fe}$provideFoldingRanges(j,U,K,H){return this.s(j,X,ie=>ie.provideFoldingRanges(u.URI.revive(U),K,H),void 0,H)}registerSelectionRangeProvider(j,U,K){const H=this.t(new Z(this.h,K,this.l),j);return this.e.$registerSelectionRangeProvider(H,this.o(U,j)),this.p(H)}$provideSelectionRanges(j,U,K,H){return this.s(j,Z,ie=>ie.provideSelectionRanges(u.URI.revive(U),K,H),[],H)}registerCallHierarchyProvider(j,U,K){const H=this.t(new me(this.h,K),j);return this.e.$registerCallHierarchyProvider(H,this.o(U,j)),this.p(H)}$prepareCallHierarchy(j,U,K,H){return this.s(j,me,ie=>Promise.resolve(ie.prepareSession(u.URI.revive(U),K,H)),void 0,H)}$provideCallHierarchyIncomingCalls(j,U,K,H){return this.s(j,me,ie=>ie.provideCallsTo(U,K,H),void 0,H)}$provideCallHierarchyOutgoingCalls(j,U,K,H){return this.s(j,me,ie=>ie.provideCallsFrom(U,K,H),void 0,H)}$releaseCallHierarchy(j,U){this.s(j,me,K=>Promise.resolve(K.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider(j,U,K){const H=this.t(new pe(this.h,K),j);return this.e.$registerTypeHierarchyProvider(H,this.o(U,j)),this.p(H)}$prepareTypeHierarchy(j,U,K,H){return this.s(j,pe,ie=>Promise.resolve(ie.prepareSession(u.URI.revive(U),K,H)),void 0,H)}$provideTypeHierarchySupertypes(j,U,K,H){return this.s(j,pe,ie=>ie.provideSupertypes(U,K,H),void 0,H)}$provideTypeHierarchySubtypes(j,U,K,H){return this.s(j,pe,ie=>ie.provideSubtypes(U,K,H),void 0,H)}$releaseTypeHierarchy(j,U){this.s(j,pe,K=>Promise.resolve(K.releaseSession(U)),void 0,void 0)}registerDocumentOnDropEditProvider(j,U,K,H){const ie=this.q();return this.f.set(ie,new ke(new Oe(this.e,this.h,K,ie,j),j)),this.e.$registerDocumentOnDropEditProvider(ie,this.o(U,j),(0,t.$6G)(j,"documentPaste")&&H?{supportsResolve:!!K.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ie)}$provideDocumentOnDropEdits(j,U,K,H,ie,fe){return this.s(j,Oe,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(U,u.URI.revive(K),H,ie,fe)),void 0,void 0)}$resolveDropEdit(j,U,K){return this.s(j,Oe,H=>H.resolveDropEdit(U,K),{},void 0)}$releaseDocumentOnDropEdits(j,U){this.s(j,Oe,K=>Promise.resolve(K.releaseDropEdits(U)),void 0,void 0)}registerMappedEditsProvider(j,U,K){const H=this.t(new ze(this.h,K),j);return this.e.$registerMappedEditsProvider(H,this.o(U,j)),this.p(H)}$provideMappedEdits(j,U,K,H,ie){return this.s(j,ze,fe=>Promise.resolve(fe.provideMappedEdits(U,K,H,ie)),null,ie)}registerDocumentPasteEditProvider(j,U,K,H){const ie=this.q();return this.f.set(ie,new ke(new F(this.e,this.h,K,ie,j),j)),this.e.$registerPasteEditProvider(ie,this.o(U,j),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(fe=>fe.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ie)}$prepareDocumentPaste(j,U,K,H,ie){return this.s(j,F,fe=>fe.prepareDocumentPaste(u.URI.revive(U),K,H,ie),void 0,ie)}$providePasteEdits(j,U,K,H,ie,fe,Re){return this.s(j,F,Ue=>Ue.providePasteEdits(U,u.URI.revive(K),H,ie,fe,Re),void 0,Re)}$resolvePasteEdit(j,U,K){return this.s(j,F,H=>H.resolvePasteEdit(U,K),{},void 0)}$releasePasteEdits(j,U){this.s(j,F,K=>Promise.resolve(K.releasePasteEdits(U)),void 0,void 0)}static y(j){return{pattern:j.source,flags:j.flags}}static z(j){return{decreaseIndentPattern:Ae.y(j.decreaseIndentPattern),increaseIndentPattern:Ae.y(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Ae.y(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Ae.y(j.unIndentedLinePattern):void 0}}static B(j){return{beforeText:Ae.y(j.beforeText),afterText:j.afterText?Ae.y(j.afterText):void 0,previousLineText:j.previousLineText?Ae.y(j.previousLineText):void 0,action:j.action}}static C(j){return j.map(Ae.B)}static D(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(U=>r.SyntaxTokenType.toString(U)):void 0}}static E(j){return j.map(Ae.D)}setLanguageConfiguration(j,U,K){const{wordPattern:H}=K;if(H&&(0,P.$sf)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(U,H):this.h.setWordDefinitionFor(U,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const ie=this.q(),fe={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Ae.y(K.wordPattern):void 0,indentationRules:K.indentationRules?Ae.z(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Ae.C(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Ae.E(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ie,U,fe),this.p(ie)}$setWordDefinitions(j){for(const U of j)this.h.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}e.$roc=Ae}),define(Ce[286],Ie([1,0,4,5,8]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rqc=void 0,C=qe(C);class O{constructor(T){this.a=new Map,this.c=new Map,this.b=T.getProxy(k.$uN.MainThreadLanguageModelTools),this.b.$getTools().then(p=>{for(const a of p)this.c.set(a.name,a)})}async invokeTool(T,p,a){return await this.b.$invokeTool(T,p,a)}async $acceptToolDelta(T){T.added&&this.c.set(T.added.name,T.added),T.removed&&this.c.delete(T.removed)}get tools(){return Array.from(this.c.values()).map(T=>C.LanguageModelToolDescription.to(T))}async $invokeTool(T,p,a){const P=this.a.get(T);if(!P)throw new Error(`Unknown tool ${T}`);return await P.tool.invoke(p,a)}registerTool(T,p,a){return this.a.set(p,{extension:T,tool:a}),this.b.$registerTool(p),(0,v.$Uc)(()=>{this.a.delete(p),this.b.$unregisterTool(p)})}}e.$rqc=O}),define(Ce[95],Ie([1,0,11,22,41,14,6,40,4,184,19,3,12,77,5,91,17,8,7,117,25]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h,i,r){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=e.$$oc=void 0,o=qe(o),h=qe(h),e.$$oc=(0,y.$Fi)("IExtHostLanguageModels");class c{constructor($,S){this.option=$,this.stream=new v.$9h,this.stream=S??new v.$9h}}class l{constructor(){this.a=new Map,this.b=new v.$9h,this.c=!1;const $=this;this.apiObject={get stream(){return $.b.asyncIterable},get text(){return v.$6h.map($.b.asyncIterable,S=>{if(S instanceof h.$KP)return S.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,$]of this.a)yield $.stream;else yield this.b}handleFragment($){if(this.c)return;let S=this.a.get($.index);S||(this.a.size===0?S=new c($.index,this.b):S=new c($.index),this.a.set($.index,S));let D;$.part.type==="text"?D=new h.$KP($.part.value):D=new h.$JP($.part.name,$.part.parameters),S.stream.emitOne(D)}reject($){this.c=!0;for(const S of this.d())S.reject($)}resolve(){this.c=!0;for(const $ of this.d())$.resolve()}}let g=class{static{t=this}static{this.a=1}constructor($,S,D){this.j=S,this.k=D,this.c=new A.$me,this.d=new A.$me,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new P.$sn,this.i=new Map,this.s=new Set,this.b=$.getProxy(d.$uN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel($,S,D,b){const I=t.a++;this.f.set(I,{extension:$.identifier,provider:D,languageModelId:S});let R;b.auth&&(R={providerLabel:$.displayName||$.name,accountLabel:typeof b.auth=="object"?b.auth.label:void 0}),this.b.$registerLanguageModelProvider(I,`${P.$qn.toKey($.identifier)}/${I}/${S}`,{extension:$.identifier,id:S,vendor:b.vendor??P.$qn.toKey($.identifier),name:b.name??"",family:b.family??"",version:b.version,maxInputTokens:b.maxInputTokens,maxOutputTokens:b.maxOutputTokens,auth:R,targetExtensions:b.extensions});const f=D.onDidReceiveLanguageModelResponse2?.(({extensionId:w,participant:M,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(S,new P.$qn(w),M,N)});return(0,p.$Uc)(()=>{this.f.delete(I),this.b.$unregisterProvider(I),f?.dispose()})}async $startChatRequest($,S,D,b,I,R){const f=this.f.get($);if(!f)throw new Error("Provider not found");const w=new E.$vw(async N=>{if(R.isCancellationRequested){this.j.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(N.part instanceof h.$JP?L={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof h.$KP&&(L={type:"text",value:N.part.value}),!L){this.j.warn(`[CHAT](${f.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$handleResponsePart(S,{index:N.index,part:L})});let M;if(f.provider.provideLanguageModelResponse2)M=Promise.resolve(f.provider.provideLanguageModelResponse2(b.map(o.LanguageModelChatMessage.to),I,P.$qn.toKey(D),w,R));else{const N=new E.$vw(async L=>{w.report({index:L.index,part:new h.$KP(L.part)})});M=Promise.resolve(f.provider.provideLanguageModelResponse(b.map(o.LanguageModelChatMessage.to),I?.modelOptions??{},P.$qn.toKey(D),N,R))}M.then(()=>{this.b.$handleResponseDone(S,void 0)},N=>{this.b.$handleResponseDone(S,N)})}$provideTokenLength($,S,D){const b=this.f.get($);return b?Promise.resolve(b.provider.provideTokenCount(S,D)):Promise.resolve(0)}$acceptChatModelMetadata($){if($.added)for(const{identifier:S,metadata:D}of $.added)this.g.set(S,{metadata:D,apiObjects:new P.$sn});if($.removed)for(const S of $.removed){this.g.delete(S);for(const[D,b]of this.i)b.languageModelId===S&&(b.res.reject(new O.$7),this.i.delete(D))}$.added?.forEach(S=>this.q(S.metadata)),this.d.fire(void 0)}async selectLanguageModels($,S){const D=await this.b.$selectChatModels({...S,extension:$.identifier}),b=[],I=this;for(const R of D){const f=this.g.get(R);if(!f)continue;this.o($.identifier,f.metadata)&&await this.q(f.metadata);let w=f.apiObjects.get($.identifier);w||(w={id:R,vendor:f.metadata.vendor,family:f.metadata.family,version:f.metadata.version,name:f.metadata.name,maxInputTokens:f.metadata.maxInputTokens,countTokens(M,N){if(!I.g.has(R))throw h.$OP.NotFound(R);return I.r(R,M,N??k.CancellationToken.None)},sendRequest(M,N,L){if(!I.g.has(R))throw h.$OP.NotFound(R);return I.l($,R,M,N??{},L??k.CancellationToken.None)}},Object.freeze(w),f.apiObjects.set($.identifier,w)),b.push(w)}return b}async l($,S,D,b,I){const R=this.m($,D),f=$.identifier,w=this.g.get(S)?.metadata;if(!w||!this.g.has(S))throw h.$OP.NotFound(`Language model '${S}' is unknown.`);if(this.o(f,w)&&(!await this.n($,{identifier:w.extension,displayName:w.auth.providerLabel},b.justification,!1)||!this.h.get(f)?.has(w.extension)))throw h.$OP.NoPermissions(`Language model '${S}' cannot be used by '${f.value}'.`);try{const M=Math.random()*1e6|0,N=new l;this.i.set(M,{languageModelId:S,res:N});try{await this.b.$tryStartChatRequest(f,S,M,R,b,I)}catch(L){throw this.i.delete(M),L}return N.apiObject}catch(M){throw M.name===h.$OP.name?M:new h.$OP(`Language model '${S}' errored: ${(0,C.$qj)(M)}`,"Unknown",M)}}m($,S){const D=[];for(const b of S)b.role===h.LanguageModelChatMessageRole.System&&(0,r.$7G)($,"languageModelSystem"),b.content2 instanceof h.$HP&&(0,r.$7G)($,"lmTools"),D.push(o.LanguageModelChatMessage.from(b));return D}async $acceptResponsePart($,S){const D=this.i.get($);D&&D.res.handleFragment(S)}async $acceptResponseDone($,S){const D=this.i.get($);D&&(this.i.delete($),S?D.res.reject(S):D.res.resolve())}async n($,S,D,b){const I=i.$wM+S.identifier.value;if(await this.k.getSession($,I,[],{silent:!0}))return this.$updateModelAccesslist([{from:$.identifier,to:S.identifier,enabled:!0}]),!0;if(b)return!1;try{const f=D?(0,a.localize)(0,null,S.displayName,D):void 0;return await this.k.getSession($,I,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:$.identifier,to:S.identifier,enabled:!0}]),!0}catch{return!1}}o($,S){return!!S.auth&&!P.$qn.equals(S.extension,$)}async q($){if($.auth)for(const S of this.s)try{await this.n(S,{identifier:$.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r($,S,D){if(!this.g.get($))throw h.$OP.NotFound(`Language model '${$}' is unknown.`);const I=T.Iterable.find(this.f.values(),R=>R.languageModelId===$);return I?I.provider.provideTokenCount(S,D):this.b.$countTokens($,typeof S=="string"?S:o.LanguageModelChatMessage.from(S),D)}$updateModelAccesslist($){const S=new Array;for(const{from:D,to:b,enabled:I}of $){const R=this.h.get(D)??new P.$rn;if(R.has(b)!==I){I?R.add(b):R.delete(b),this.h.set(D,R);const w={from:D,to:b};S.push(w),this.c.fire(w)}}}createLanguageModelAccessInformation($){this.s.add($);const S=this,D=A.Event.signal(A.Event.filter(this.c.event,I=>P.$qn.equals(I.from,$.identifier))),b=A.Event.signal(this.d.event);return{get onDidChange(){return A.Event.any(D,b)},canSendRequest(I){let R;e:for(const[w,M]of S.g)for(const N of M.apiObjects.values())if(N===I){R=M.metadata;break e}if(!R)return;if(!S.o($.identifier,R))return!0;const f=S.h.get($.identifier);if(f)return f.has(R.extension)}}}};e.$_oc=g,e.$_oc=g=t=Qe([Ve(0,s.$1P),Ve(1,u.$_j),Ve(2,n.$toc)],g)});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[287],Ie([1,0,5,8,7,36,11,4,25]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vpc=void 0,k=qe(k),O=ti(O);class a{constructor(y,u,E,d){this.c=u,this.d=E,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(v.$uN.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,u){await this.a.$changeLanguage(y,u);const E=this.c.getDocumentData(y);if(!E)throw new Error(`document '${y.toString()}' NOT found`);return E.document}async tokenAtPosition(y,u){const E=y.version,d=k.Position.from(u),n=await this.a.$tokensAtPosition(y.uri,d),s={type:C.StandardTokenType.Other,range:y.getWordRangeAtPosition(u)??new C.$yN(u.line,u.character,u.line,u.character)};if(!n)return s;const o={range:k.Range.to(n.range),type:k.TokenType.to(n.type)};return!o.range.contains(u)||E!==y.version?s:o}createLanguageStatusItem(y,u,E){const d=this.f++,n=this.a,s=this.g,o=`${y.identifier.value}/${u}`;if(s.has(o))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);s.add(o);const h={selector:E,id:u,name:y.displayName??y.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new T.$Vc,t=()=>{if(i?.dispose(),!s.has(o)){console.warn(`LanguageStatusItem (${u}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$Hh)(()=>{r.clear(),this.a.$setLanguageStatus(d,{id:o,name:h.name??y.displayName??y.name,source:y.displayName??y.name,selector:k.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===C.LanguageStatusSeverity.Error?O.default.Error:h.severity===C.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:h.command&&this.d.toInternal(h.command,r),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},c={dispose(){r.dispose(),i?.dispose(),n.$removeLanguageStatus(d),s.delete(o)},get id(){return h.id},get name(){return h.name},set name(l){h.name=l,t()},get selector(){return h.selector},set selector(l){h.selector=l,t()},get text(){return h.text},set text(l){h.text=l,t()},set text2(l){(0,p.$7G)(y,"languageStatusText"),h.text=l,t()},get text2(){return(0,p.$7G)(y,"languageStatusText"),h.text},get detail(){return h.detail},set detail(l){h.detail=l,t()},get severity(){return h.severity},set severity(l){h.severity=l,t()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(l){h.accessibilityInformation=l,t()},get command(){return h.command},set command(l){h.command=l,t()},get busy(){return h.busy},set busy(l){h.busy=l,t()}};return t(),c}}e.$Vpc=a}),define(Ce[288],Ie([1,0,16,2,8,7,90]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=e.$Hpc=void 0,C=qe(C),A=qe(A);class T{constructor(y,u,E,d){this.start=y,this.deletedCount=u,this.deletedItems=E,this.items=d}asApiEvent(){return{range:new O.$YO(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,u,E){this.notebook=y,this.h=u,this.j=E,this.handle=E.handle,this.uri=k.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(C.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return y.g},set mime(d){y.g=d},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(E)}return this.f}setOutputs(y){this.a=y.map(C.NotebookCellOutput.to)}setOutputItems(y,u,E){const d=E.map(C.NotebookCellOutputItem.to),n=this.a.find(s=>s.id===y);if(n&&(u||(n.items.length=0),n.items.push(...d),n.items.length>1&&n.items.every(s=>A.$zL(s.mime)))){const s=new Map,o=[];n.items.forEach(h=>{let i;s.has(h.mime)?i=s.get(h.mime):(i=[],s.set(h.mime,i),o.push(h.mime)),i.push(h.data)}),n.items.length=0,o.forEach(h=>{const i=A.$AL(s.get(h));n.items.push({mime:h,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$Hpc=p;class a{static{this.a=0}constructor(y,u,E,d,n){this.k=y,this.l=u,this.m=E,this.uri=d,this.handle=a.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,u={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===v.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(E){return E=y.n(E),y.b[E].apiCell},getCells(E){return(E?y.p(E):y.b).map(n=>n.apiCell)},save(){return y.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,u,E){this.g=y.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:E});const d={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},n=[];for(const o of y.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,d.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,d.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),n.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),n.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),n.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),n.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),n.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const s=new Map;for(let o=0;o<n.length;o++){const h=n[o],i=s.get(h.cell);if(i===void 0){const r=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});s.set(h.cell,r-1)}else d.cellChanges[i]={...d.cellChanges[i],...h}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let u=y.start|0,E=y.end|0;return u<0&&(u=0),E>this.b.length&&(E=this.b.length),y.with({start:u,end:E})}p(y){y=this.o(y);const u=[];for(let E=y.start;E<y.end;E++)u.push(this.b[E]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,u,E){if(this.j)return;const d=[],n=[],s=[];if(y.reverse().forEach(o=>{const i=o[2].map(c=>{const l=new p(this,this.l,c);return u||n.push(p.asModelAddData(c)),l}),r=new T(o[0],o[1],[],i),t=this.b.splice(o[0],o[1],...i);for(const c of t)s.push(c.uri),r.deletedItems.push(c.apiCell);d.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:s}),E)for(const o of d)E.push(o.asApiEvent())}s(y,u,E,d){const n=this.b.splice(y,u);this.b.splice(E,0,...n);const s=[new T(y,u,n.map(o=>o.apiCell),[]),new T(E,0,[],n)];for(const o of s)d.push(o.asApiEvent())}t(y,u){this.b[y].setOutputs(u)}u(y,u,E,d){this.b[y].setOutputItems(u,E,d)}v(y,u){const E=this.b[y];E.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(E.uri,u)}w(y,u){const E=this.b[y];E.apiCell.mime=u}x(y,u){this.b[y].setMetadata(u)}y(y,u){this.b[y].setInternalMetadata(u)}getCellFromApiCell(y){return this.b.find(u=>u.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(u=>u.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$Ipc=a}),define(Ce[289],Ie([1,0,6,2,8,7,39]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpc=void 0;class T{constructor(a,P,y,u={timeout:1500,errors:3}){this.b=a,this.c=P,this.d=y,this.f=u,this.a=new v.$oe}dispose(){}getOnWillSaveNotebookDocumentEvent(a){return(P,y,u)=>{const E=function(n){P.call(y,n)};return E.extension=a,this.a.event(E,void 0,u)}}async $participateInSave(a,P,y){const u=k.URI.revive(a),E=this.c.getNotebookDocument(u);if(!E)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:C.TextDocumentSaveReason.to(P)},y,async(s,o)=>{const h=Date.now(),i=await await Promise.resolve(s);Date.now()-h>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof O.$GN?d.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(d.length===0)return!0;const n={edits:[]};for(const s of d){const{edits:o}=C.WorkspaceEdit.from(s);n.edits=n.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new A.$Tw(n))}}e.$Xpc=T}),define(Ce[124],Ie([1,0,14,8,7]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0,k=qe(k),C=qe(C);class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,p,a,P,y,u){this.id=T,this.f=p,this.notebookData=a,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=P,this.c=u}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(p){this.selections=[p]},get selections(){return T.a},set selections(p){if(!Array.isArray(p)||!p.every(C.$YO.isNotebookRange))throw(0,v.$9)("selections");T.a=p,T.g(p)},get visibleRanges(){return T.b},revealRange(p,a){T.f.$tryRevealRange(T.id,k.NotebookRange.from(p),a??C.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(k.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$Jpc=O}),define(Ce[290],Ie([1,0,6,12,8]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpc=void 0,C=qe(C);let O=class{constructor(T,p){this.c=T,this.d=p,this.a=new v.$me,this.b=new v.$me,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,p);const a=this.d.getEditorById(T);p.visibleRanges&&a._acceptVisibleRanges(p.visibleRanges.ranges.map(C.NotebookRange.to)),p.selections&&a._acceptSelections(p.selections.selections.map(C.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:a.apiEditor,visibleRanges:a.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:a.apiEditor,selections:a.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const p in T)this.d.getEditorById(p)._acceptViewColumn(C.ViewColumn.to(T[p]))}};e.$Zpc=O,e.$Zpc=O=Qe([Ve(0,k.$_j)],O)}),define(Ce[291],Ie([1,0,6,5,124]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=void 0;class O{constructor(T,p){this.c=p,this.a=new Map,this.b=T.getProxy(k.$uN.MainThreadNotebookRenderers)}$postRendererMessage(T,p,a){const P=this.c.getEditorById(T);this.a.get(p)?.fire({editor:P.apiEditor,message:a})}createRendererMessaging(T,p){if(!T.contributes?.notebookRenderer?.some(P=>P.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(P,y,u)=>this.d(p).event(P,y,u),postMessage:(P,y)=>{C.$Jpc.apiEditorsToExtHost.has(P)&&([P,y]=[y,P]);const u=y&&C.$Jpc.apiEditorsToExtHost.get(y);return this.b.$postMessage(u?.id,p,P)}}}d(T){let p=this.a.get(T);return p||(p=new v.$me({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(T)}}),this.a.set(T,p),p)}}e.$3pc=O}),define(Ce[292],Ie([1,0,8,77,22,72,14]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=void 0;class T{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,u,E){const d=this.b++,{title:n,location:s,cancellable:o}=u,h={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(d,{location:v.ProgressLocation.from(s),title:n,source:h,cancellable:o},y.isUnderDevelopment?void 0:y.identifier.value).catch(A.$4),this.d(d,E,!!o)}d(y,u,E){let d;E&&(d=new C.$xe,this.c.set(y,d));const n=o=>{this.a.$progressEnd(o),this.c.delete(o),d?.dispose()};let s;try{s=u(new a(this.a,y),E&&d?d.token:C.CancellationToken.None)}catch(o){throw n(y),o}return s.then(o=>n(y),o=>n(y)),s}$acceptProgressCanceled(y){const u=this.c.get(y);u&&(u.cancel(),this.c.delete(y))}}e.$7pc=T;function p(P,y){return P.message=y.message,typeof y.increment=="number"&&(typeof P.increment=="number"?P.increment+=y.increment:P.increment=y.increment),P}class a extends k.$vw{constructor(y,u){super(E=>this.throttledReport(E)),this.c=y,this.d=u}throttledReport(y){this.c.$progressReport(this.d,y)}}Qe([(0,O.$_h)(100,(P,y)=>p(P,y),()=>Object.create(null))],a.prototype,"throttledReport",null)}),define(Ce[293],Ie([1,0,2,5,11,8]),function(oe,e,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8pc=void 0;class A{static{this.a=0}constructor(p,a){this.d=a,this.c=new Map,this.b=p.getProxy(k.$uN.MainThreadQuickDiff)}$provideOriginalResource(p,a,P){const y=v.URI.revive(a),u=this.c.get(p);return u?(0,C.$xh)(()=>u.provideOriginalResource(y,P)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(p,a,P,y){const u=A.a++;return this.c.set(u,a),this.b.$registerQuickDiffProvider(u,O.DocumentSelector.from(p,this.d),P,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$8pc=A});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[294],Ie([1,0,22,6,4,5,2,7,14,18,36,35,25,8]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9pc=d,P=ti(P);function d(n,s,o){const h=n.getProxy(O.$uN.MainThreadQuickOpen);class i{constructor(D,b){this.e=new Map,this.f=0,this.a=D,this.b=b}showQuickPick(D,b,I,R=v.CancellationToken.None){this.c=void 0;const f=Promise.resolve(b),w=++this.f,M=h.$show(w,{title:I?.title,placeHolder:I?.placeHolder,matchOnDescription:I?.matchOnDescription,matchOnDetail:I?.matchOnDetail,ignoreFocusLost:I?.ignoreFocusOut,canPickMany:I?.canPickMany},R),N={},L=M.then(()=>N);return Promise.race([L,f]).then(G=>{if(G===N)return;const W=(0,u.$6G)(D,"quickPickItemTooltip");return f.then(F=>{const V=[];for(let ae=0;ae<F.length;ae++){const $e=F[ae];if(typeof $e=="string")V.push({label:$e,handle:ae});else if($e.kind===T.QuickPickItemKind.Separator)V.push({type:"separator",label:$e.label});else{$e.tooltip&&!W&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const _=$e.iconPath?g($e.iconPath):void 0;V.push({label:$e.label,iconPath:_?.iconPath,iconClass:_?.iconClass,description:$e.description,detail:$e.detail,picked:$e.picked,alwaysShow:$e.alwaysShow,tooltip:W?E.MarkdownString.fromStrict($e.tooltip):void 0,handle:ae})}}return I&&typeof I.onDidSelectItem=="function"&&(this.c=ae=>{I.onDidSelectItem(F[ae])}),h.$setItems(w,V),M.then(ae=>{if(typeof ae=="number")return F[ae];if(Array.isArray(ae))return ae.map($e=>F[$e])})})}).then(void 0,G=>{if(!(0,p.$6)(G))return h.$setError(w,G),Promise.reject(G)})}$onItemSelected(D){this.c?.(D)}showInput(D,b=v.CancellationToken.None){return this.d=D?.validateInput,h.$input(D,typeof this.d=="function",b).then(void 0,I=>{if(!(0,p.$6)(I))return Promise.reject(I)})}async $validateInput(D){if(!this.d)return;const b=await this.d(D);if(!b||typeof b=="string")return b;let I;switch(b.severity){case T.InputBoxValidationSeverity.Info:I=P.default.Info;break;case T.InputBoxValidationSeverity.Warning:I=P.default.Warning;break;case T.InputBoxValidationSeverity.Error:I=P.default.Error;break;default:I=b.message?P.default.Error:P.default.Ignore;break}return{content:b.message,severity:I}}async showWorkspaceFolderPick(D,b=v.CancellationToken.None){const I=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!I)return;const R=await this.a.getWorkspaceFolders2();if(R)return R.find(f=>f.uri.toString()===I.uri.toString())}createQuickPick(D){const b=new m(D,()=>this.e.delete(b._id));return this.e.set(b._id,b),b}createInputBox(D){const b=new $(D,()=>this.e.delete(b._id));return this.e.set(b._id,b),b}$onDidChangeValue(D,b){this.e.get(D)?._fireDidChangeValue(b)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,b){const I=this.e.get(D);I instanceof m&&I._fireDidChangeActive(b)}$onDidChangeSelection(D,b){const I=this.e.get(D);I instanceof m&&I._fireDidChangeSelection(b)}$onDidTriggerButton(D,b){this.e.get(D)?._fireDidTriggerButton(b)}$onDidTriggerItemButton(D,b,I){const R=this.e.get(D);R instanceof m&&R._fireDidTriggerItemButton(b,I)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class r{static{this.a=1}constructor(D,b){this.x=D,this.y=b,this._id=m.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new k.$me,this.q=new k.$me,this.r=new k.$me,this.s=new k.$me,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((b,I)=>{const R=b===T.$VO.Back?-1:I;this.o.set(R,b)}),this.z({buttons:D.map((b,I)=>({...g(b.iconPath),tooltip:b.tooltip,handle:b===T.$VO.Back?-1:I}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const b=this.o.get(D);b&&this.r.fire(b)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Rc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(D){if(!this.v){for(const b of Object.keys(D)){const I=D[b];this.u[b]=I===void 0?null:I}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}function t(S){if(S instanceof T.$tO)return{id:S.id};const D=l(S),b=c(S);return{dark:typeof D=="string"?A.URI.file(D):D,light:typeof b=="string"?A.URI.file(b):b}}function c(S){return typeof S=="object"&&"light"in S?S.light:S}function l(S){return typeof S=="object"&&"dark"in S?S.dark:S}function g(S){const D=t(S);let b,I;return"id"in D?I=y.ThemeIcon.asClassName(D):b=D,{iconPath:b,iconClass:I}}class m extends r{constructor(D,b){super(D.identifier,b),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new k.$me,this.L=[],this.M=new k.$me,this.N=new k.$me,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((R,f)=>{this.C.set(f,R),this.D.set(R,f)});const b=(0,u.$6G)(this.O,"quickPickItemTooltip"),I=[];for(let R=0;R<D.length;R++){const f=D[R];if(f.kind===T.QuickPickItemKind.Separator)I.push({type:"separator",label:f.label});else{f.tooltip&&!b&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const w=f.iconPath?g(f.iconPath):void 0;I.push({handle:R,label:f.label,iconPath:w?.iconPath,iconClass:w?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:b?E.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((M,N)=>({...g(M.iconPath),tooltip:M.tooltip,handle:N}))})}}this.z({items:I})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(b=>this.D.has(b)),this.z({activeItems:this.J.map(b=>this.D.get(b))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(b=>this.D.has(b)),this.z({selectedItems:this.L.map(b=>this.D.get(b))})}_fireDidChangeActive(D){const b=(0,a.$Jb)(D.map(I=>this.C.get(I)));this.J=b,this.K.fire(b)}_fireDidChangeSelection(D){const b=(0,a.$Jb)(D.map(I=>this.C.get(I)));this.L=b,this.M.fire(b)}_fireDidTriggerItemButton(D,b){const I=this.C.get(D);if(!I||!I.buttons||!I.buttons.length)return;const R=I.buttons[b];R&&this.N.fire({button:R,item:I})}}class $ extends r{constructor(D,b){super(D.identifier,b),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:P.default.Error}):this.z({validationMessage:D.message,severity:D.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new i(s,o)}}),define(Ce[295],Ie([1,0,2,6,72,4,11,5,18,160,12,19,38,35,8,25,16,21]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=e.$0pc=void 0;function i(N){return N instanceof v.URI}function r(N,L){return N.scheme===s.Schemas.file&&L.scheme===s.Schemas.file&&o.$k?N.toString()===L.toString():N.toString().toLowerCase()===L.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?v.URI.file(N.iconPath):v.URI.isUri(N.iconPath)||E.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function c(N){if(N){if(v.URI.isUri(N))return N;if(E.ThemeIcon.isThemeIcon(N))return N;{const L=N;return{light:L.light,dark:L.dark}}}else return}function l(N){const L=c(N.icon),G=N.labels?.map(W=>({title:W.title,icon:c(W.icon)}));return{...N,icon:L,labels:G}}function g(N,L){if(!N.iconPath&&!L.iconPath)return 0;if(N.iconPath){if(!L.iconPath)return 1}else return-1;const G=typeof N.iconPath=="string"?N.iconPath:v.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,W=typeof L.iconPath=="string"?L.iconPath:v.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,a.$Hr)(G,W)}function m(N,L){let G=0;if(N.strikeThrough!==L.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==L.faded)return N.faded?1:-1;if(N.tooltip!==L.tooltip)return(N.tooltip||"").localeCompare(L.tooltip||"");if(G=g(N,L),G!==0)return G;if(N.light&&L.light)G=g(N.light,L.light);else{if(N.light)return 1;if(L.light)return-1}if(G!==0)return G;if(N.dark&&L.dark)G=g(N.dark,L.dark);else{if(N.dark)return 1;if(L.dark)return-1}return G}function $(N,L){if(N.command!==L.command)return N.command<L.command?-1:1;if(N.title!==L.title)return N.title<L.title?-1:1;if(N.tooltip!==L.tooltip){if(N.tooltip!==void 0&&L.tooltip!==void 0)return N.tooltip<L.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(N.arguments===L.arguments)return 0;if(N.arguments)if(L.arguments){if(N.arguments.length!==L.arguments.length)return N.arguments.length-L.arguments.length}else return 1;else return-1;for(let G=0;G<N.arguments.length;G++){const W=N.arguments[G],F=L.arguments[G];if(W!==F&&!(i(W)&&i(F)&&r(W,F)))return W<F?-1:1}return 0}function S(N,L){let G=(0,a.$Hr)(N.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(G!==0)return G;if(N.command&&L.command)G=$(N.command,L.command);else{if(N.command)return 1;if(L.command)return-1}if(G!==0)return G;if(N.decorations&&L.decorations)G=m(N.decorations,L.decorations);else{if(N.decorations)return 1;if(L.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)G=(0,a.$Hr)(N.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)G=(0,a.$Hr)(N.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return G}function D(N,L){for(let G=0;G<N.length;G++)if(N[G]!==L[G])return!1;return!0}function b(N,L){return N.command===L.command&&N.title===L.title&&N.tooltip===L.tooltip&&(N.arguments&&L.arguments?D(N.arguments,L.arguments):N.arguments===L.arguments)}function I(N,L){return(0,p.$wb)(N,L,b)}class R{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.m,L),this.o(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.m,L),this.f=L}get validateInput(){return(0,n.$7G)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,n.$7G)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.m,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.m,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.m,L))}get document(){return(0,n.$7G)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(L,G,W,F,V){this.k=L,this.m=F,this.n=V,this.d="",this.e=new k.$me,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=W}showValidationMessage(L,G){(0,n.$7G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,L,G)}$onInputBoxValueChange(L){this.o(L)}o(L){this.d=L,this.e.fire(L)}}e.$0pc=R;class f{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(L){this.w=L,this.s.$updateGroupLabel(this.u,this.handle,L)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(L){this.q=L,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,G,W,F,V,ae,$e){this.s=L,this.t=G,this.u=W,this.v=F,this.w=V,this.multiDiffEditorEnableViewChanges=ae,this.x=$e,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new k.$me,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new k.$me,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=f.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,G){const W=this.h.get(L);return W?(0,A.$xh)(()=>this.t.executeCommand(W.command,...W.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(S),W=(0,p.$Fb)(this.p,L,S).map(ae=>{const $e=ae.toInsert.map(_=>{const ge=this.e++;this.g.set(ge,_);const se=_.resourceUri;let ce;if(_.command)if(_.command.command==="vscode.open"||_.command.command==="vscode.diff"||_.command.command==="vscode.changes"){const Z=new O.$Vc;ce=this.t.converter.toInternal(_.command,Z),this.j.set(ge,Z)}else this.h.set(ge,_.command);const we=(0,n.$6G)(this.x,"scmMultiDiffEditor"),re=we?_.multiDiffEditorOriginalUri:void 0,Pe=we?_.multiFileDiffEditorModifiedUri:void 0,Me=t(_.decorations),Y=_.decorations&&t(_.decorations.light)||Me,q=_.decorations&&t(_.decorations.dark)||Me,ee=[Y,q],ve=_.decorations&&_.decorations.tooltip||"",ue=_.decorations&&!!_.decorations.strikeThrough,be=_.decorations&&!!_.decorations.faded,de=_.contextValue||"";return{rawResource:[ge,se,ee,ve,ue,be,de,ce,re,Pe],handle:ge}});return{start:ae.start,deleteCount:ae.deleteCount,toInsert:$e}}),F=W.map(({start:ae,deleteCount:$e,toInsert:_})=>[ae,$e,_.map(ge=>ge.rawResource)]),V=W.reverse();for(const{start:ae,deleteCount:$e,toInsert:_}of V){const ge=_.map(ce=>ce.handle),se=this.o.splice(ae,$e,...ge);for(const ce of se)this.g.delete(ce),this.h.delete(ce),this.j.get(ce)?.dispose(),this.j.delete(ce)}return this.p=L,F}dispose(){this.m=!0,this.n.fire()}}class w{static{this.d=0}#e;get id(){return this.B}get label(){return this.C}get rootUri(){return this.D}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.x,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let G;(0,n.$6G)(this.y,"quickDiffProvider")&&(G=L?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!L,quickDiffLabel:G})}get historyProvider(){return(0,n.$7G)(this.y,"scmHistoryProvider"),this.j}set historyProvider(L){(0,n.$7G)(this.y,"scmHistoryProvider"),this.j=L,this.k.value=new O.$Vc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.m=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(L){L!==this.n&&(this.n=L,this.#e.$updateSourceControl(this.x,{commitTemplate:L}))}get acceptInputCommand(){return this.p}set acceptInputCommand(L){this.o.value=new O.$Vc,this.p=L;const G=this.z.converter.toInternal(L,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:G})}get actionButton(){return(0,n.$7G)(this.y,"scmActionButton"),this.s}set actionButton(L){(0,n.$7G)(this.y,"scmActionButton"),this.q.value=new O.$Vc,this.s=L;const G=L!==void 0?{command:this.z.converter.toInternal(L.command,this.q.value),secondaryCommands:L.secondaryCommands?.map(W=>W.map(F=>this.z.converter.toInternal(F,this.q.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:G??null})}get statusBarCommands(){return this.u}set statusBarCommands(L){if(this.A.trace("ExtHostSourceControl#statusBarCommands",(L??[]).map(W=>W.command).join(", ")),this.u&&L&&I(this.u,L)){this.A.trace("ExtHostSourceControl#statusBarCommands are equal");return}this.t.value=new O.$Vc,this.u=L;const G=(L||[]).map(W=>this.z.converter.toInternal(W,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:G})}get selected(){return this.v}constructor(L,G,W,F,V,ae,$e,_){this.y=L,this.z=F,this.A=V,this.B=ae,this.C=$e,this.D=_,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Xc,this.n=void 0,this.o=new O.$Xc,this.p=void 0,this.q=new O.$Xc,this.t=new O.$Xc,this.u=void 0,this.v=!1,this.w=new k.$me,this.onDidChangeSelection=this.w.event,this.x=w.d++,this.E=new Map,this.F=new Set,this.#e=W;const ge=v.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${ae}/scm${this.x}/input`,query:_?`rootUri=${encodeURIComponent(_.toString())}`:void 0});this.f=new R(L,G,this.#e,this.x,ge),this.#e.$registerSourceControl(this.x,ae,$e,_,ge)}createResourceGroup(L,G,W){const F=(0,n.$6G)(this.y,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,V=new f(this.#e,this.z,this.x,L,G,F,this.y),ae=k.Event.once(V.onDidDispose)(()=>this.E.delete(V));return this.E.set(V,ae),this.eventuallyAddResourceGroups(),V}eventuallyAddResourceGroups(){const L=[],G=[];for(const[W,F]of this.E){F.dispose();const V=W.onDidUpdateResourceStates(()=>{this.F.add(W),this.eventuallyUpdateResourceStates()});k.Event.once(W.onDidDispose)(()=>{this.F.delete(W),V.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.x,W.handle)}),L.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const ae=W._takeResourceStateSnapshot();ae.length>0&&G.push([W.handle,ae]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.x,L,G),this.E.clear()}eventuallyUpdateResourceStates(){const L=[];this.F.forEach(G=>{const W=G._takeResourceStateSnapshot();W.length!==0&&L.push([G.handle,W])}),L.length>0&&this.#e.$spliceResourceStates(this.x,L),this.F.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.v=L,this.w.fire(L)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.x)}}Qe([(0,C.$$h)(100)],w.prototype,"eventuallyAddResourceGroups",null),Qe([(0,C.$$h)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{h=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(L,G,W,F){this.m=G,this.n=W,this.o=F,this.g=new Map,this.h=new y.$sn,this.j=new k.$me,this.e=L.getProxy(T.$uN.MainThreadSCM),this.f=L.getProxy(T.$uN.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===u.MarshalledId.ScmResource){const ae=this.g.get(V.sourceControlHandle);if(!ae)return V;const $e=ae.getResourceGroup(V.groupHandle);return $e?$e.getResourceState(V.handle):V}else if(V&&V.$mid===u.MarshalledId.ScmResourceGroup){const ae=this.g.get(V.sourceControlHandle);return ae?ae.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===u.MarshalledId.ScmProvider){const ae=this.g.get(V.handle);return ae||V}return V}})}createSourceControl(L,G,W,F){this.o.trace("ExtHostSCM#createSourceControl",L.identifier.value,G,W,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const V=h.d++,ae=new w(L,this.n,this.e,this.m,this.o,G,W,F);this.g.set(V,ae);const $e=this.h.get(L.identifier)||[];return $e.push(ae),this.h.set(L.identifier,$e),ae}getLastInputBox(L){this.o.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const G=this.h.get(L.identifier),W=G&&G[G.length-1];return W&&W.inputBox}$provideOriginalResource(L,G,W){const F=v.URI.revive(G);this.o.trace("ExtHostSCM#$provideOriginalResource",L,F.toString());const V=this.g.get(L);return!V||!V.quickDiffProvider||!V.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$xh)(()=>V.quickDiffProvider.provideOriginalResource(F,W)).then(ae=>ae||null)}$onInputBoxValueChange(L,G){this.o.trace("ExtHostSCM#$onInputBoxValueChange",L);const W=this.g.get(L);return W&&W.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(L,G,W,F){this.o.trace("ExtHostSCM#$executeResourceCommand",L,G,W);const V=this.g.get(L);if(!V)return Promise.resolve(void 0);const ae=V.getResourceGroup(G);return ae?ae.$executeResourceCommand(W,F):Promise.resolve(void 0)}$validateInput(L,G,W){this.o.trace("ExtHostSCM#$validateInput",L);const F=this.g.get(L);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,A.$xh)(()=>F.inputBox.validateInput(G,W)).then(V=>{if(!V)return Promise.resolve(void 0);const ae=d.MarkdownString.fromStrict(V.message);return ae?Promise.resolve([ae,V.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,G,W,F){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,W,F)??void 0}async $provideHistoryItems(L,G,W,F){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(G,W,F))?.map($e=>l($e))??void 0}async $provideHistoryItems2(L,G,W){return(await this.g.get(L)?.historyProvider?.provideHistoryItems2(G,W))?.map(ae=>l(ae))??void 0}async $provideHistoryItemSummary(L,G,W,F){const V=this.g.get(L)?.historyProvider;if(typeof V?.provideHistoryItemSummary!="function")return;const ae=await V.provideHistoryItemSummary(G,W,F);return ae?l(ae):void 0}async $provideHistoryItemChanges(L,G,W,F){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(G,W,F)??void 0}};e.$$pc=M,e.$$pc=M=h=Qe([Ve(3,P.$_j)],M)}),define(Ce[296],Ie([1,0,5,8,2]),function(oe,e,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pc=void 0;class O{static{this.a=0}constructor(T,p){this.d=p,this.c=new Map,this.b=T.getProxy(v.$uN.MainThreadShare)}async $provideShare(T,p,a){return await this.c.get(T)?.provideShare({selection:k.Range.to(p.selection),resourceUri:C.URI.revive(p.resourceUri)},a)??void 0}registerShareProvider(T,p){const a=O.a++;return this.c.set(a,p),this.b.$registerShareProvider(a,k.DocumentSelector.from(T,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(a),this.c.delete(a)}}}}e.$_pc=O}),define(Ce[297],Ie([1,0,7,5,187,4,8,15]),function(oe,e,v,k,C,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cqc=e.$bqc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$uO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$uO("statusBarItem.warningForeground")]])}#e;#t;constructor(u,E,d,n,s,o=v.StatusBarAlignment.Left,h){if(this.i=!1,this.k="",this.q=new O.$Vc,this.#e=u,this.#t=E,s&&n){this.c=(0,v.$9N)(n.identifier,s);const i=d.get(this.c);i&&(o=i.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,h=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(p.a++);this.e=n,this.f=s,this.g=o,this.h=this.u(h)}u(u){if((0,T.$jg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!p.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new O.$Vc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let E;this.m?E=this.m:E=(0,C.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=p.b.get(this.o.id));const n=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,E,this.k,n,this.r?.internal,d,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$bqc=p;class a{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const E={message:u};return this.b.unshift(E),this.c(),new v.$wN(()=>{const d=this.b.indexOf(E);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(u,E){this.e=new Map,this.a=u.getProxy(k.$uN.MainThreadStatusBar),this.b=E,this.c=new a(this)}$acceptStaticEntries(u){for(const E of u)this.e.set(E.entryId,E)}createStatusBarEntry(u,E,d,n){return new p(this.a,this.b,this.e,u,E,d,n)}setStatusBarMessage(u,E){const d=this.c.setMessage(u);let n;return typeof E=="number"?n=setTimeout(()=>d.dispose(),E):typeof E<"u"&&E.then(()=>d.dispose(),()=>d.dispose()),new v.$wN(()=>{d.dispose(),clearTimeout(n)})}}e.$cqc=P}),define(Ce[125],Ie([1,0,33,116,55,82,56,8,2]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=e.$bQ=e.$aQ=void 0,v=qe(v),T=qe(T);const a=(i,r,t,c)=>{let l=r;return{enumerable:!0,configurable:!1,get(){return l},set(g){if(!t(l,g)){const m=l;l=g,i.listener?.(c(g,m))}}}},P=(i,r)=>i===r,y={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(i,r)=>!(i.length!==r.length||i.some(t=>!r.find(c=>t.id===c.id)))},u=i=>r=>({op:O.TestItemEventOp.SetProp,update:i(r)}),E=(i,r)=>({range:(()=>{let t;const c=u(l=>({range:v.$Lt.lift(T.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return t},set(l){i.listener?.({op:O.TestItemEventOp.DocumentSynced}),y.range(t,l)||(t=l,i.listener?.(c(l)))}}})(),label:a(i,r,y.label,u(t=>({label:t}))),description:a(i,void 0,y.description,u(t=>({description:t}))),sortText:a(i,void 0,y.sortText,u(t=>({sortText:t}))),canResolveChildren:a(i,!1,y.canResolveChildren,t=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:a(i,!1,y.busy,u(t=>({busy:t}))),error:a(i,void 0,y.error,u(t=>({error:T.MarkdownString.fromStrict(t)||null}))),tags:a(i,[],y.tags,(t,c)=>({op:O.TestItemEventOp.SetTags,new:t.map(T.TestTag.from),old:c.map(T.TestTag.from)}))}),d=i=>{const r=C.$TI.fromString(i.extId),t=new s(r.controllerId,r.localId,i.label,p.URI.revive(i.uri)||void 0);return t.range=T.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(c=>T.TestTag.to({id:(0,A.$ZI)(c).tagId})),t},n=i=>{let r;for(const t of i.tests){const c=d(t.item);(0,k.$WP)(c).parent=r,r=c}return r};e.$aQ=n;class s{constructor(r,t,c,l){if(t.includes(C.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const g=(0,k.$VP)(this,r);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof o?void 0:g.parent}},children:{value:(0,O.$UP)(g,k.$WP,s),enumerable:!0,writable:!1},...E(g,c)})}}e.$bQ=s;class o extends s{constructor(r,t){super(r,r,t,void 0),this._isRoot=!0}}e.$cQ=o;class h extends O.$QP{constructor(r,t,c){super({controllerId:r,getDocumentVersion:l=>l&&c.getDocument(l)?.version,getApiFor:k.$WP,getChildren:l=>l.children,root:new o(r,t),toITestItem:T.TestItem.from})}}e.$dQ=h}),define(Ce[34],Ie([1,0,15,7,8,26,5,18,12,49,33,101,2,4,3,17,125,23,39,41,70,64,67,37]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h,i,r,t,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=void 0,k=qe(k),C=qe(C);let g=class{#e;#t;#i;constructor(I,R,f){this.b=new Map,this.c=new Map,this.#e=I.getProxy(A.$uN.MainThreadCommands),this.d=R,this.#i=f,this.#t=I.getProxy(A.$uN.MainThreadTelemetry),this.converter=new m(this,w=>{const M=this.c.get(w);return M?.result===S.Void?M:void 0},R),this.f=[{processArgument(w){return(0,a.$ci)(w)}},{processArgument(w){return(0,O.$fo)(w,function(M){if(P.$Lt.isIRange(M))return C.Range.to(M);if(y.$Kt.isIPosition(M))return C.Position.to(M);if(P.$Lt.isIRange(M.range)&&u.URI.isUri(M.uri))return C.location.to(M);if(M instanceof o.$Oe)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(I){this.f.push(I)}registerApiCommand(I){const R=this.registerCommand(!1,I.id,async(...f)=>{const w=I.args.map((N,L)=>{if(!N.validate(f[L]))throw new Error(`Invalid argument '${N.name}' when running '${I.id}', received: ${typeof f[L]=="object"?JSON.stringify(f[L],null,"	"):f[L]} `);return N.convert(f[L])}),M=await this.executeCommand(I.internalId,...w);return I.result.convert(M,f,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this.c.set(I.id,I),new k.$wN(()=>{R.dispose(),this.c.delete(I.id)})}registerCommand(I,R,f,w,M,N){if(this.d.trace("ExtHostCommands#registerCommand",R),!R.trim().length)throw new Error("invalid id");if(this.b.has(R))throw new Error(`command '${R}' already exists`);return this.b.set(R,{callback:f,thisArg:w,metadata:M,extension:N}),I&&this.#e.$registerCommand(R),new k.$wN(()=>{this.b.delete(R)&&I&&this.#e.$unregisterCommand(R)})}executeCommand(I,...R){return this.d.trace("ExtHostCommands#executeCommand",I),this.g(I,R,!0)}async g(I,R,f){if(this.b.has(I))return this.#e.$fireCommandActivationEvent(I),this.h(I,R,!1);{let w=!1;const M=(0,O.$fo)(R,function(N){if(N instanceof k.$xN)return C.Position.from(N);if(N instanceof k.$yN)return C.Range.from(N);if(N instanceof k.$IN)return C.location.from(N);if(k.$YO.isNotebookRange(N))return C.NotebookRange.from(N);if(N instanceof ArrayBuffer)return w=!0,o.$Oe.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return w=!0,o.$Oe.wrap(N);if(N instanceof o.$Oe)return w=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(I,w?new h.$Tw(M):M,f);return(0,a.$ci)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(I,R,!1);throw N}}}async h(I,R,f){const w=this.b.get(I);if(!w)throw new Error("Unknown command");const{callback:M,thisArg:N,metadata:L}=w;if(L?.args)for(let W=0;W<L.args.length;W++)try{(0,v.$wg)(R[W],L.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed. Illegal argument '${L.args[W].name}' - ${L.args[W].description}`)}const G=r.$ge.create();try{return await M.apply(N,R)}catch(W){if(I===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...R);F&&(I=F.command)}if(this.d.error(W,I,w.extension?.identifier),!f)throw W;if(w.extension?.identifier){const F=this.#i.onExtensionError(w.extension.identifier,W);this.d.trace("forwarded error to extension?",F,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$qj)(W)),this.id=I,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,I,G.elapsed())}}j(I,R,f){I.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new t.$up(R),duration:f})}$executeContributedCommand(I,...R){this.d.trace("ExtHostCommands#$executeContributedCommand",I);const f=this.b.get(I);return f?(R=R.map(w=>this.f.reduce((M,N)=>N.processArgument(M,f.extension?.identifier),w)),this.h(I,R,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this.d.trace("ExtHostCommands#getCommands",I),this.#e.$getCommands().then(R=>(I&&(R=R.filter(f=>f[0]!=="_")),R))}$getContributedCommandMetadata(){const I=Object.create(null);for(const[R,f]of this.b){const{metadata:w}=f;w&&(I[R]=w)}return Promise.resolve(I)}};e.$jQ=g,e.$jQ=g=Qe([Ve(0,n.$1P),Ve(1,p.$_j),Ve(2,c.$iQ)],g),e.$kQ=(0,d.$Fi)("IExtHostCommands");class m{constructor(I,R,f){this.d=I,this.f=R,this.g=f,this.delegatingCommandId=`__vsc${(0,l.$2g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(I,R){if(!I)return;const f={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return f;const w=this.f(I.command);if(w)f.id=w.internalId,f.arguments=w.args.map((M,N)=>M.convert(I.arguments&&I.arguments[N]));else if((0,T.$Nb)(I.arguments)){const M=`${I.command} /${++this.c}`;this.b.set(M,I),R.add((0,E.$Uc)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),f.$ident=M,f.id=this.delegatingCommandId,f.arguments=[M],this.g.trace("CommandsConverter#CREATE",I.command,M)}return f}fromInternal(I){return typeof I.$ident=="string"?this.b.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this.b.get(I[0])}h(...I){const R=this.getActualCommand(...I);return this.g.trace("CommandsConverter#EXECUTE",I[0],R?R.command:"MISSING"),R?this.d.executeCommand(R.command,...R.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.$lQ=m;class ${static{this.Uri=new $("uri","Uri of a text document",I=>u.URI.isUri(I),I=>I)}static{this.Position=new $("position","A position in a text document",I=>k.$xN.isPosition(I),C.Position.from)}static{this.Range=new $("range","A range in a text document",I=>k.$yN.isRange(I),C.Range.from)}static{this.Selection=new $("selection","A selection in a text document",I=>k.$zN.isSelection(I),C.Selection.from)}static{this.Number=new $("number","",I=>typeof I=="number",I=>I)}static{this.String=new $("string","",I=>typeof I=="string",I=>I)}static{this.StringArray=$.Arr($.String)}static Arr(I){return new $(`${I.name}_array`,`Array of ${I.name}, ${I.description}`,R=>Array.isArray(R)&&R.every(f=>I.validate(f)),R=>R.map(f=>I.convert(f)))}static{this.CallHierarchyItem=new $("item","A call hierarchy item",I=>I instanceof k.$UN,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new $("item","A type hierarchy item",I=>I instanceof k.$gP,C.TypeHierarchyItem.from)}static{this.TestItem=new $("testItem","A VS Code TestItem",I=>I instanceof s.$bQ,C.TestItem.from)}constructor(I,R,f,w){this.name=I,this.description=R,this.validate=f,this.convert=w}optional(){return new $(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,R){return new $(I??this.name,R??this.description,this.validate,this.convert)}}e.$mQ=$;class S{static{this.Void=new S("no result",I=>I)}constructor(I,R){this.description=I,this.convert=R}}e.$nQ=S;class D{constructor(I,R,f,w,M){this.id=I,this.internalId=R,this.description=f,this.args=w,this.result=M}}e.$oQ=D}),define(Ce[298],Ie([1,0,18,16,2,94,104,32,34,8,7]),function(oe,e,v,k,C,O,A,T,p,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=void 0,O=qe(O),a=qe(a),P=qe(P);const y=[new p.$oQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of DocumentHighlight-instances.",E(a.DocumentHighlight.to))),new p.$oQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$mQ.Uri],new p.$nQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,s)=>{if((0,v.$Mb)(n))return;class o extends P.$PN{static to(i){const r=new o(i.name,a.SymbolKind.to(i.kind),i.containerName||"",new P.$IN(s[0],a.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=a.Range.to(i.selectionRange),r.children=i.children?i.children.map(o.to):[],r}}return n.map(o.to)})),new p.$oQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$mQ.Uri,new p.$mQ("options","Formatting options",n=>!0,n=>n)],new p.$nQ("A promise that resolves to an array of TextEdits.",E(a.TextEdit.to))),new p.$oQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$mQ.Uri,p.$mQ.Range,new p.$mQ("options","Formatting options",n=>!0,n=>n)],new p.$nQ("A promise that resolves to an array of TextEdits.",E(a.TextEdit.to))),new p.$oQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$mQ.Uri,p.$mQ.Position,new p.$mQ("ch","Trigger character",n=>typeof n=="string",n=>n),new p.$mQ("options","Formatting options",n=>!0,n=>n)],new p.$nQ("A promise that resolves to an array of TextEdits.",E(a.TextEdit.to))),new p.$oQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$oQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$oQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$oQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$oQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Location-instances.",E(a.location.to))),new p.$oQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Hover-instances.",E(a.Hover.to))),new p.$oQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$mQ.Uri,new p.$mQ("position","A position in a text document",n=>Array.isArray(n)&&n.every(s=>P.$xN.isPosition(s)),n=>n.map(a.Position.from))],new p.$nQ("A promise that resolves to an array of ranges.",n=>n.map(s=>{let o;for(const h of s.reverse())o=new P.$TN(a.Range.to(h),o);return o}))),new p.$oQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$mQ.String.with("query","Search string")],new p.$nQ("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(a.WorkspaceSymbol.to))),new p.$oQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(a.CallHierarchyItem.to))),new p.$oQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$mQ.CallHierarchyItem],new p.$nQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(a.CallHierarchyIncomingCall.to))),new p.$oQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$mQ.CallHierarchyItem],new p.$nQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(a.CallHierarchyOutgoingCall.to))),new p.$oQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:a.Range.to(n.range),placeholder:n.text}})),new p.$oQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$mQ.Uri,p.$mQ.Position,p.$mQ.String.with("newName","The new symbol name")],new p.$nQ("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return a.WorkspaceEdit.to(n)}})),new p.$oQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$mQ.Uri,p.$mQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$nQ("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(a.DocumentLink.to))),new p.$oQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$mQ.Uri],new p.$nQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new P.$PO(n.tokenTypes,n.tokenModifiers)})),new p.$oQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$mQ.Uri],new p.$nQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const s=(0,A.$Gdb)(n);if(s.type==="full")return new P.$RO(s.data,void 0)})),new p.$oQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$mQ.Uri,p.$mQ.Range.optional()],new p.$nQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new P.$PO(n.tokenTypes,n.tokenModifiers)})),new p.$oQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$mQ.Uri,p.$mQ.Range],new p.$nQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const s=(0,A.$Gdb)(n);if(s.type==="full")return new P.$RO(s.data,void 0)})),new p.$oQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$mQ.Uri,p.$mQ.Position,p.$mQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$mQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$nQ("A promise that resolves to a CompletionList-instance.",(n,s,o)=>{if(!n)return new P.$6N([]);const h=n.suggestions.map(i=>a.CompletionItem.to(i,o));return new P.$6N(h,n.incomplete)})),new p.$oQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$mQ.Uri,p.$mQ.Position,p.$mQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$nQ("A promise that resolves to SignatureHelp.",n=>{if(n)return a.SignatureHelp.to(n)})),new p.$oQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$mQ.Uri,p.$mQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$nQ("A promise that resolves to an array of CodeLens-instances.",(n,s,o)=>E(h=>new P.$XN(a.Range.to(h.range),h.command&&o.fromInternal(h.command)))(n))),new p.$oQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$mQ.Uri,new p.$mQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>P.$yN.isRange(n),n=>P.$zN.isSelection(n)?a.Selection.from(n):a.Range.from(n)),p.$mQ.String.with("kind","Code action kind to return code actions for").optional(),p.$mQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$nQ("A promise that resolves to an array of Command-instances.",(n,s,o)=>E(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(h.command)}else{const i=new P.$RN(h.title,h.kind?new P.$SN(h.kind):void 0);return h.edit&&(i.edit=a.WorkspaceEdit.to(h.edit)),h.command&&(i.command=o.fromInternal(h.command)),i.isPreferred=h.isPreferred,i}})(n))),new p.$oQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$mQ.Uri],new p.$nQ("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(s=>new P.$_N(a.Range.to(s.range),a.Color.to(s.color))):[])),new p.$oQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$mQ("color","The color to show and insert",n=>n instanceof P.$$N,a.Color.from),new p.$mQ("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:a.Range.from(n.range)}))],new p.$nQ("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(a.ColorPresentation.to):[])),new p.$oQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$mQ.Uri,p.$mQ.Range],new p.$nQ("A promise that resolves to an array of Inlay objects",(n,s,o)=>n.map(a.InlayHint.to.bind(void 0,o)))),new p.$oQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$mQ.Uri],new p.$nQ("A promise that resolves to an array of FoldingRange objects",(n,s)=>{if(n)return n.map(a.FoldingRange.to)})),new p.$oQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$nQ("A promise that resolves to an array of NotebookContentProvider static info objects.",E(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(s=>a.NotebookExclusiveDocumentPattern.to(s))})))),new p.$oQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$mQ.Uri,p.$mQ.Range,new p.$mQ("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof P.$yN,n=>a.InlineValueContext.from(n))],new p.$nQ("A promise that resolves to an array of InlineValue objects",n=>n.map(a.InlineValue.to))),new p.$oQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$mQ("uriOrString","Uri-instance or string (only http/https)",n=>C.URI.isUri(n)||typeof n=="string"&&(0,k.$Pg)(n,k.Schemas.http,k.Schemas.https),n=>n),new p.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[a.ViewColumn.from(n),void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional(),p.$mQ.String.with("label","").optional()],p.$nQ.Void),new p.$oQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$mQ.Uri.with("resource","Resource to open"),p.$mQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[a.ViewColumn.from(n),void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional()],p.$nQ.Void),new p.$oQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$mQ.Uri.with("left","Left-hand side resource of the diff editor"),p.$mQ.Uri.with("right","Right-hand side resource of the diff editor"),p.$mQ.String.with("title","Human readable title for the diff editor").optional(),new p.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)]).optional()],p.$nQ.Void),new p.$oQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$mQ.String.with("title","Human readable title for the changes editor"),new p.$mQ("resourceList","List of resources to compare",n=>{for(const s of n){if(s.length!==3)return!1;const[o,h,i]=s;if(!C.URI.isUri(o)||!C.URI.isUri(h)&&h!==void 0&&h!==null||!C.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},n=>n)],p.$nQ.Void),new p.$oQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new p.$oQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$mQ.TypeHierarchyItem],new p.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new p.$oQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$mQ.TypeHierarchyItem],new p.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new p.$oQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$mQ.TestItem],p.$nQ.Void),new p.$oQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$mQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$nQ.Void),new p.$oQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$mQ.String.with("name","The context key name"),new p.$mQ("value","The context key value",()=>!0,n=>n)],p.$nQ.Void),new p.$oQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$mQ.Uri,p.$mQ.StringArray,new p.$mQ("MappedEditsContext","Mapped Edits Context",n=>a.MappedEditsContext.is(n),n=>a.MappedEditsContext.from(n))],new p.$nQ("A promise that resolves to a workspace edit or null",n=>n?a.WorkspaceEdit.to(n):null)),new p.$oQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$mQ("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?a.Range.from(n.initialRange):void 0,initialSelection:P.$zN.isSelection(n.initialSelection)?a.Selection.from(n.initialSelection):void 0,message:n.message,autoSend:n.autoSend,position:n.position?a.Position.from(n.position):void 0}})],p.$nQ.Void)];class u{static register(s){y.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",T.$Ej)}}e.$soc=u;function E(n){return s=>{if(Array.isArray(s))return s.map(n)}}function d(n){if(!Array.isArray(n))return;const s=[];for(const o of n)O.$Hu(o)?s.push(a.DefinitionLink.to(o)):s.push(a.location.to(o));return s}}),define(Ce[299],Ie([1,0,2,34]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tpc=void 0;class C{constructor(A,T,p,a,P){this.a=T,this.b=p,this.c=a;const y=new k.$oQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new k.$mQ("showOptions","Show Options",u=>!0,u=>u),new k.$mQ("resource","Interactive resource Uri",u=>!0,u=>u),new k.$mQ("controllerId","Notebook controller Id",u=>!0,u=>u),new k.$mQ("title","Interactive editor title",u=>!0,u=>u)],new k.$nQ("Notebook and input URI",u=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const E=this.a.getEditorById(u.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:v.URI.revive(u.notebookUri),inputUri:v.URI.revive(u.inputUri),notebookEditor:E.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:v.URI.revive(u.notebookUri),inputUri:v.URI.revive(u.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(A,T,p,a){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:p,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Tpc=C}),define(Ce[300],Ie([1,0,18,11,22,6,4,29,2,19,12,5,34,8,7,83,239,25,39,240]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=void 0,e.$2pc=$,E=qe(E);let r=class{constructor(D,b,I,R,f){this.m=b,this.n=I,this.o=R,this.q=f,this.b=new T.$Cc,this.c=new T.$Cc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$me,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(y.$uN.MainThreadNotebookKernels);const w=new u.$oQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$mQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const L=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:L}}else if(N&&"notebookEditor"in N){const L=this.n.getIdByEditor(N.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return N})],u.$nQ.Void),M=new u.$oQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$mQ.Uri],new u.$nQ("A promise that resolves to an array of variables",(N,L)=>N.map(G=>({variable:{name:G.name,value:G.value,expression:G.expression,type:G.type,language:G.language},hasNamedChildren:G.hasNamedChildren,indexedChildrenCount:G.indexedChildrenCount}))));this.o.registerApiCommand(w),this.o.registerApiCommand(M)}createNotebookController(D,b,I,R,f,w){for(const re of this.j.values())if(re.controller.id===b&&a.$qn.equals(D.identifier,re.extensionId))throw new Error(`notebook controller with id '${b}' ALREADY exist`);const M=this.k++,N=this;this.q.trace(`NotebookController[${M}], CREATED by ${D.identifier.value}, ${b}`);const L=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${D.identifier}'`);let G=!1;const W=new O.$me,F=new O.$me,V={id:$(D.identifier,b),notebookType:I,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:R||D.identifier.value,preloads:w?w.map(E.NotebookRendererScript.from):[]};let ae=f??L,$e,_;this.a.$addKernel(M,V).catch(re=>{console.log(re),G=!0});let ge=0;const se=()=>{if(G)return;const re=++ge;Promise.resolve().then(()=>{re===ge&&this.a.$updateKernel(M,V)})},ce=new T.$Cc,we={get id(){return b},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:W.event,get label(){return V.label},set label(re){V.label=re??D.displayName??D.name,se()},get detail(){return V.detail??""},set detail(re){V.detail=re,se()},get description(){return V.description??""},set description(re){V.description=re,se()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(re){V.supportedLanguages=re,se()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(re){V.supportsExecutionOrder=re,se()},get rendererScripts(){return V.preloads?V.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return ae},set executeHandler(re){ae=re??L},get interruptHandler(){return $e},set interruptHandler(re){$e=re,V.supportsInterrupt=!!re,se()},set variableProvider(re){(0,o.$7G)(D,"notebookVariableProvider"),_=re,V.hasVariableProvider=!!re,re?.onDidChangeVariables(Pe=>N.a.$variablesUpdated(Pe.uri)),se()},get variableProvider(){return _},createNotebookCellExecution(re){if(G)throw new Error("notebook controller is DISPOSED");if(!ce.has(re.notebook.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return N._createNotebookCellExecution(re,$(D.identifier,this.id))},createNotebookExecution(re){if((0,o.$7G)(D,"notebookExecution"),G)throw new Error("notebook controller is DISPOSED");if(!ce.has(re.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.uri.toString()}`);return N._createNotebookExecution(re,$(D.identifier,this.id))},dispose:()=>{G||(this.q.trace(`NotebookController[${M}], DISPOSED`),G=!0,this.j.delete(M),W.dispose(),F.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(re,Pe){Pe===d.NotebookControllerAffinity2.Hidden&&(0,o.$7G)(D,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(M,re.uri,Pe)},onDidReceiveMessage:F.event,postMessage(re,Pe){return(0,o.$7G)(D,"notebookMessaging"),N.a.$postMessage(M,Pe&&N.n.getIdByEditor(Pe),re)},asWebviewUri(re){return(0,o.$7G)(D,"notebookMessaging"),(0,n.$dDb)(re,N.m.remote)}};return this.j.set(M,{extensionId:D.identifier,controller:we,onDidReceiveMessage:F,onDidChangeSelection:W,associatedNotebooks:ce}),we}getIdByController(D){for(const[b,I]of this.j)if(I.controller===D)return $(I.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,b){const I=this.g++,R=this;this.q.trace(`NotebookControllerDetectionTask[${I}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(I,b);const f={dispose:()=>{this.f.delete(I),R.a.$removeKernelDetectionTask(I)}};return this.f.set(I,f),f}registerKernelSourceActionProvider(D,b,I){const R=this.i++,f=typeof I.onDidChangeNotebookKernelSourceActions=="function"?R:void 0,w=this;this.h.set(R,I),this.q.trace(`NotebookKernelSourceActionProvider[${R}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(R,R,b);let M;return f!==void 0&&(M=I.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.h.delete(R),w.a.$removeKernelSourceActionProvider(R,R),M?.dispose()}}}async $provideKernelSourceActions(D,b){const I=this.h.get(D);if(I){const R=new A.$Vc;return(await I.provideNotebookKernelSourceActions(b)??[]).map(w=>E.NotebookKernelSourceAction.from(w,this.o.converter,R))}return[]}$acceptNotebookAssociation(D,b,I){const R=this.j.get(D);if(R){const f=this.n.getNotebookDocument(p.URI.revive(b));I?R.associatedNotebooks.set(f.uri,!0):R.associatedNotebooks.delete(f.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,f.uri.toString(),I),R.onDidChangeSelection.fire({selected:I,notebook:f.apiNotebook})}}async $executeCells(D,b,I){const R=this.j.get(D);if(!R)return;const f=this.n.getNotebookDocument(p.URI.revive(b)),w=[];for(const M of I){const N=f.getCell(M);N&&w.push(N.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,f.uri.toString(),w.length),await R.controller.executeHandler.call(R.controller,w,f.apiNotebook,R.controller)}catch(M){this.q.error(`NotebookController[${D}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(D,b,I){const R=this.j.get(D);if(!R)return;const f=this.n.getNotebookDocument(p.URI.revive(b));if(R.controller.interruptHandler)await R.controller.interruptHandler.call(R.controller,f.apiNotebook);else for(const w of I){const M=f.getCell(w);M&&this.b.get(M.uri)?.cancel()}if(R.controller.interruptHandler){const w=this.c.get(f.uri);this.c.delete(f.uri),I.length&&Array.isArray(w)&&w.length&&w.forEach(M=>M.dispose())}}async $provideVariables(D,b,I,R,f,w,M){const N=this.j.get(D);if(!N)return;const L=this.n.getNotebookDocument(p.URI.revive(I)),G=N.controller.variableProvider;if(!G)return;let W;if(R!==void 0){if(W=this.s[R],!W)return}else this.s={};const F=f==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,V=G.provideVariables(L.apiNotebook,W,F,w,M);let ae=0;for await(const $e of V){if(M.isCancellationRequested)return;const _={id:this.r++,name:$e.variable.name,value:$e.variable.value,type:$e.variable.type,interfaces:$e.variable.interfaces,language:$e.variable.language,expression:$e.variable.expression,hasNamedChildren:$e.hasNamedChildren,indexedChildrenCount:$e.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[_.id]=$e.variable,this.a.$receiveVariable(b,_),ae++>=i.$WK)return}}$acceptKernelMessageFromRenderer(D,b,I){const R=this.j.get(D);if(!R)return;const f=this.n.getEditorById(b);R.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:I}))}$cellExecutionChanged(D,b,I){const f=this.n.getNotebookDocument(p.URI.revive(D)).getCell(b);if(f){const w=I?E.NotebookCellExecutionState.to(I):d.NotebookCellExecutionState.Idle;w!==void 0&&this.l.fire({cell:f.apiCell,state:w})}}_createNotebookCellExecution(D,b){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const R=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!R)throw new Error("invalid cell");if(this.b.has(R.uri))throw new Error(`duplicate execution for ${R.uri}`);const f=new c(b,R,this.a);this.b.set(R.uri,f);const w=f.onDidChangeState(()=>{f.state===t.Resolved&&(f.dispose(),w.dispose(),this.b.delete(R.uri))});return f.asApiObject()}_createNotebookExecution(D,b){const I=this.n.getNotebookDocument(D.uri),R=D.getCells().find(M=>{const N=I.getCellFromApiCell(M);return N&&this.b.has(N.uri)});if(R)throw new Error(`duplicate cell execution for ${R.document.uri}`);if(this.c.has(I.uri))throw new Error(`duplicate notebook execution for ${I.uri}`);const f=new g(b,I,this.a),w=f.onDidChangeState(()=>{f.state===l.Resolved&&(f.dispose(),w.dispose(),this.c.delete(I.uri))});return this.c.set(I.uri,[f,w]),f.asApiObject()}};e.$1pc=r,e.$1pc=r=Qe([Ve(4,P.$_j)],r);var t;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(t||(t={}));class c extends A.$Wc{static{this.a=0}get state(){return this.f}constructor(D,b,I){super(),this.m=b,this.n=I,this.b=c.a++,this.c=new O.$me,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new C.$xe),this.h=new m(10,R=>this.s(R)),this.j=b.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const b=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new h.$Tw(b))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let b=this.m;if(D&&(b=this.m.notebook.getCellFromApiCell(D)),!b)throw new Error("INVALID cell");return b.handle}y(D){return D.map(b=>{const I=d.$3O.ensureUniqueMimeTypes(b.items,!0);return I===b.items?E.NotebookCellOutput.from(b):E.NotebookCellOutput.from({items:I,id:b.id,metadata:b.metadata})})}async z(D,b,I){const R=this.w(b),f=this.y((0,v.$4b)(D));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:R,append:I,outputs:f})}async C(D,b,I){return D=d.$3O.ensureUniqueMimeTypes((0,v.$4b)(D),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:D.map(E.NotebookCellOutputItem.from),outputId:b.id,append:I})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(I){D.j=I,D.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(I){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:I})},end(I,R,f){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const w=f?{message:f.message,stack:f.stack,location:f?.location?{startLineNumber:f.location.start.line,startColumn:f.location.start.character,endLineNumber:f.location.end.line,endColumn:f.location.end.character}:void 0,uri:f.uri}:void 0;D.n.$completeExecution(D.b,new h.$Tw({runEndTime:R,lastRunSuccess:I,error:w}))},clearOutput(I){return D.t(),D.z([],I,!1)},appendOutput(I,R){return D.t(),D.z(I,R,!0)},replaceOutput(I,R){return D.t(),D.z(I,R,!1)},appendOutputItems(I,R){return D.t(),D.C(I,R,!0)},replaceOutputItems(I,R){return D.t(),D.C(I,R,!1)}})}}var l;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(l||(l={}));class g extends A.$Wc{static{this.a=0}get state(){return this.f}constructor(D,b,I){super(),this.h=b,this.j=I,this.b=g.a++,this.c=new O.$me,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new C.$xe),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===l.Resolved||this.f===l.Started)throw new Error("Cannot call start again");this.f=l.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===l.Resolved)throw new Error("Cannot call resolve twice");this.f=l.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class m{constructor(D,b){this.f=D,this.g=b,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new k.$3h,this.b=Date.now(),(0,k.$Gh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const b=this.a;return this.a=[],this.g(b).finally(()=>D.complete())}}function $(S,D){return`${S.value}/${D}`}}),define(Ce[57],Ie([1,0,6,5,3,2,17,4,7,189,14,220,22,37,221,222,35,11,8,34,38]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=e.$9oc=e.$8oc=e.$7oc=void 0,e.$7oc=(0,C.$Fi)("IExtHostTerminalService");class t extends T.$Wc{constructor(f,w,M,N){super(),this.u=f,this._id=w,this.w=M,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new v.$me),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(G=>this.g=G);const L=this;this.value={get name(){return L.y||""},get processId(){return L.b},get creationOptions(){return L.w},get exitStatus(){return L.j},get state(){return L.m},get selection(){return L.n},get shellIntegration(){return L.shellIntegration},sendText(G,W=!0){L.C(),L.u.$sendText(L._id,G,W)},show(G){L.C(),L.u.$show(L._id,G)},hide(){L.C(),L.u.$hide(L._id)},dispose(){L.a||(L.a=!0,L.u.$dispose(L._id))},get dimensions(){if(!(L.f===void 0||L.h===void 0))return{columns:L.f,rows:L.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??w?.cwd??void 0,env:f.env??void 0,icon:D(f.iconPath)??void 0,color:s.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:w?.forceShellIntegration??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.z(f.location,w?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,w,M,N,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:s.ThemeColor.isThemeColor(L)?L.id:void 0,location:w?.location||this.z(f,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,w){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in f?{viewColumn:h.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,w){this.j=Object.freeze({code:f,reason:w})}setDimensions(f,w){return f===this.f&&w===this.h||f===0||w===0?!1:(this.f=f,this.h=w,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(w=>{w!==f&&(this.b=Promise.resolve(f))})}}e.$8oc=t;class c{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new v.$me,this.onProcessData=this.a.event,this.b=new v.$me,this.d=new v.$me,this.onDidChangeProperty=this.d.event,this.f=new v.$me,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,w){this.g.setDimensions?.({columns:f,rows:w})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:d.ProcessPropertyType.Title,value:w})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,g=class extends T.$Wc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,w,M){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Xc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$me,this.onDidCloseTerminal=this.H.event,this.I=new v.$me,this.onDidOpenTerminal=this.I.event,this.J=new v.$me,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$me,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$me,this.onDidChangeTerminalState=this.M.event,this.N=new v.$me,this.onDidChangeShell=this.N.event,this.O=new v.$me({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$me({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=M.getProxy(k.$uN.MainThreadTerminalService),this.y=new n.$wxb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:N=>{const L=G=>{const W=G;return this.getTerminalById(W.instanceId)?.value};switch(N?.$mid){case r.MarshalledId.TerminalContext:return L(N);default:{if(Array.isArray(N))for(let G=0;G<N.length&&N[G].$mid===r.MarshalledId.TerminalContext;G++)N[G]=L(N[G]);return N}}}}),this.B({dispose:()=>{for(const[N,L]of this.g)L.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,w){const M=new t(this.a,(0,E.$2g)(),f,f.name),N=new c(f.pty);return M.createExtensionTerminal(f.location,w,this.R(f,w).resolvedExtHostIdentifier,D(f.iconPath),b(f.color)).then(L=>{const G=this.S(L,N);this.h[L]=G}),this.f.push(M),M.value}R(f,w){if(w=w||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const M=f.location.parentTerminal;if(M){const N=this.f.find(L=>L.value===M);N&&(w.resolvedExtHostIdentifier=N._id)}}else f.location&&typeof f.location!="object"?w.location=f.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(f,w){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const N=new c(w),L=this.S(f,N);this.h[f]=L}async $acceptActiveTerminalChanged(f){const w=this.b;if(f===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const M=this.getTerminalById(f);M&&(this.b=M,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,w){const M=this.getTerminalById(f);M&&this.O.fire({terminal:M.value,data:w})}async $acceptTerminalDimensions(f,w,M){const N=this.getTerminalById(f);N&&N.setDimensions(w,M)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(f,w){const M=this.getTerminalById(f);M&&this.P.fire({terminal:M.value,...w})}async $acceptTerminalMaximumDimensions(f,w,M){this.g.get(f)?.resize(w,M)}async $acceptTerminalTitleChange(f,w){const M=this.getTerminalById(f);M&&(M.name=w)}async $acceptTerminalClosed(f,w,M){const N=this.X(this.f,f);if(N!==null){const L=this.f.splice(N,1)[0];L.setExitStatus(w,M),this.H.fire(L.value)}}$acceptTerminalOpened(f,w,M,N){if(w){const W=this.X(this.f,w);if(W!==null){this.f[W]._id=f,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const L={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:O.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},G=new t(this.a,f,L,M);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(f,w){this.getTerminalById(f)?._setProcessId(w)}async $startExtensionTerminal(f,w){const M=this.getTerminalById(f);if(!M)return{message:(0,a.localize)(0,null,f)};M.isOpen||await new Promise(L=>{const G=this.onDidOpenTerminal(async W=>{W===M.value&&(G.dispose(),L())})});const N=this.g.get(f);N?N.startSendingEvents(w):this.j[f]={initialDimensions:w}}S(f,w){const M=new T.$Vc;M.add(w.onProcessReady(L=>this.a.$sendProcessReady(f,L.pid,L.cwd,L.windowsPty))),M.add(w.onDidChangeProperty(L=>this.a.$sendProcessProperty(f,L))),this.y.startBuffering(f,w.onProcessData),M.add(w.onProcessExit(L=>this.U(f,L))),this.g.set(f,w);const N=this.j[f];return N&&w instanceof c&&(w.startSendingEvents(N.initialDimensions),delete this.j[f]),M}$acceptProcessAckDataEvent(f,w){this.g.get(f)?.acknowledgeDataEvent(w)}$acceptProcessInput(f,w){this.g.get(f)?.input(w)}$acceptTerminalInteraction(f){const w=this.getTerminalById(f);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(f,w){this.getTerminalById(f)?.setSelection(w)}$acceptProcessResize(f,w,M){try{this.g.get(f)?.resize(w,M)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(f,w){this.g.get(f)?.shutdown(w)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.InitialCwd,value:w}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(w=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.Cwd,value:w}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new p.$wN(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,w,M){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,M),this.a.$registerProfileProvider(w,f.identifier.value),new p.$wN(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(f,w,M){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,M),this.a.$registerQuickFixProvider(f,w),new p.$wN(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,w){const M=new u.$xe().token;if(M.isCancellationRequested)return;const N=this.D.get(f);if(!N)return;const L=await N.provideTerminalQuickFixes(w,M);if(L===null||Array.isArray(L)&&L.length===0)return;const G=new T.$Vc;if(this.w.value=G,!Array.isArray(L))return L?h.TerminalQuickFix.from(L,this.Q.converter,G):void 0;const W=[];for(const F of L){const V=h.TerminalQuickFix.from(F,this.Q.converter,G);V&&W.push(V)}return W}async $createContributedProfileTerminal(f,w){const M=new u.$xe().token;let N=await this.C.get(f)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,w);return}this.createTerminalFromOptions(N.options,w)}}async $provideLinks(f,w){const M=this.getTerminalById(f);if(!M)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const L=new u.$xe;this.G.set(f,L);const G=[],W={terminal:M.value,line:w},F=[];for(const $e of this.z)F.push(o.Promises.withAsyncBody(async _=>{L.token.onCancellationRequested(()=>_({provider:$e,links:[]}));const ge=await $e.provideTerminalLinks(W,L.token)||[];L.token.isCancellationRequested||_({provider:$e,links:ge})}));const V=await Promise.all(F);if(L.token.isCancellationRequested)return[];const ae=new Map;for(const $e of V)$e&&$e.links.length>0&&G.push(...$e.links.map(_=>{const ge={id:l++,startIndex:_.startIndex,length:_.length,label:_.tooltip};return ae.set(ge.id,{provider:$e.provider,link:_}),ge}));return this.F.set(f,ae),G}$activateLink(f,w){const M=this.F.get(f)?.get(w);M&&M.provider.handleTerminalLink(M.link)}U(f,w){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const M=this.h[f];M&&(M.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,w)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const w=this.f.findIndex(M=>M.value===f);return w>=0?w:null}W(f,w){const M=this.X(f,w);return M!==null?f[M]:null}X(f,w){const M=f.findIndex(N=>N._id===w);return M>=0?M:null}getEnvironmentVariableCollection(f){let w=this.n.get(f.identifier.value);return w||(w=this.B(new m),this.Z(f.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Y(f,w){const M=(0,y.$Cs)(w.map),N=(0,y.$Ds)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(f,w.persistent,M.length===0?void 0:M,N)}$initEnvironmentVariableCollections(f){f.forEach(w=>{const M=w[0],N=this.B(new m(w[1]));this.Z(M,N)})}$acceptDefaultProfile(f,w){const M=this.s;this.s=f,this.u=w,M?.path!==f.path&&this.N.fire(f.path)}Z(f,w){this.n.set(f,w),this.B(w.onDidChangeCollection(()=>{this.Y(f,w)}))}};e.$9oc=g,e.$9oc=g=Qe([Ve(1,i.$kQ),Ve(2,A.$1P)],g);class m extends T.$Wc{get persistent(){return this.b}set persistent(f){this.b=f,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(f){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new v.$me,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const w=this.j(f);let M=this.a.get(w);return M||(M=new $(this,f),this.a.set(w,M),this.B(M.onDidChangeCollection(()=>this.f.fire()))),M}replace(f,w,M,N){this.g(f,{value:w,type:p.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:N})}append(f,w,M,N){this.g(f,{value:w,type:p.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:N})}prepend(f,w,M,N){this.g(f,{value:w,type:p.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:N})}g(f,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.h(f,w.scope),N=this.map.get(M),L=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==w.value||N.type!==w.type||N.options?.applyAtProcessCreation!==L.applyAtProcessCreation||N.options?.applyAtShellIntegration!==L.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const G=this.h(f,w.scope),W={variable:f,...w,options:L};this.map.set(G,W),this.f.fire()}}get(f,w){const M=this.h(f,w),N=this.map.get(M);return N?I(N):void 0}h(f,w){const M=this.j(w);return M.length?`${f}:::${M}`:f}j(f){return this.m(f?.workspaceFolder)??""}m(f){return f?f.uri.toString():void 0}getVariableMap(f){const w=new Map;for(const[M,N]of this.map)this.j(N.scope)===this.j(f)&&w.set(N.variable,I(N));return w}delete(f,w){const M=this.h(f,w);this.map.delete(M),this.f.fire()}clear(f){if(f?.workspaceFolder){for(const[w,M]of this.map)M.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(w);this.n(f)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(f,w){const M=this.j(w),N=this.descriptionMap.get(M);if(!N||N.description!==f){let L;typeof f=="string"?L=f:L=f?.value.split(`

`)[0];const G={description:L,scope:w};this.descriptionMap.set(M,G),this.f.fire()}}getDescription(f){const w=this.j(f);return this.descriptionMap.get(w)?.description}n(f){const w=this.j(f);this.descriptionMap.delete(w)}}class ${get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,w){this.b=f,this.d=w,this.a=new v.$me}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,w,M){this.b.replace(f,w,M,this.d)}append(f,w,M){this.b.append(f,w,M,this.d)}prepend(f,w,M){this.b.prepend(f,w,M,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,w){this.b.getVariableMap(this.d).forEach((M,N)=>f.call(w,N,M,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let S=class extends g{constructor(f,w){super(!1,f,w)}createTerminal(f,w,M){throw new P.$bb}createTerminalFromOptions(f,w){throw new P.$bb}};e.$0oc=S,e.$0oc=S=Qe([Ve(0,i.$kQ),Ve(1,A.$1P)],S);function D(R){if(!(!R||typeof R=="string"))return"id"in R?{id:R.id,color:R.color}:R}function b(R){return s.ThemeColor.isThemeColor(R)?R:void 0}function I(R){const f={...R};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Ce[126],Ie([1,0,7,4,3,5,17,57,6,2,11]),function(oe,e,v,k,C,O,A,T,p,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqc=e.$gqc=void 0,e.$gqc=(0,C.$Fi)("IExtHostTerminalShellIntegration");let y=class extends k.$Wc{constructor(s,o){super(),this.h=o,this.b=new Map,this.c=new p.$me,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$me,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$me,this.onDidEndTerminalShellExecution=this.g.event,this.a=s.getProxy(O.$uN.MainThreadTerminalShellIntegration),this.B((0,k.$Uc)(()=>{for(const[h,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(s){const o=this.h.getTerminalById(s);if(!o)return;const h=o.value;let i=this.b.get(s);i||(i=new u(o.value,this.f),this.b.set(s,i),i.store.add(o.onWillDispose(()=>this.b.get(s)?.dispose())),i.store.add(i.onDidRequestShellExecution(r=>this.a.$executeCommand(s,r))),i.store.add(i.onDidRequestEndExecution(r=>this.g.fire(r))),i.store.add(i.onDidRequestChangeShellIntegration(r=>this.c.fire(r))),o.shellIntegration=i.value),this.c.fire({terminal:h,shellIntegration:i.value})}$shellExecutionStart(s,o,h,i,r){this.b.has(s)||this.$shellIntegrationChange(s);const t={value:o,confidence:h,isTrusted:i};this.b.get(s)?.startShellExecution(t,r)}$shellExecutionEnd(s,o,h,i,r){const t={value:o,confidence:h,isTrusted:i};this.b.get(s)?.endShellExecution(t,r)}$shellExecutionData(s,o){this.b.get(s)?.emitData(o)}$cwdChange(s,o){this.b.get(s)?.setCwd((0,a.$xc)(o)?a.URI.revive(o):o)}$closeTerminal(s){this.b.get(s)?.dispose(),this.b.delete(s)}};e.$hqc=y,e.$hqc=y=Qe([Ve(0,A.$1P),Ve(1,T.$7oc)],y);class u extends k.$Wc{get currentExecution(){return this.a}constructor(s,o){super(),this.j=s,this.m=o,this.b=!1,this.store=this.B(new k.$Vc),this.f=this.B(new p.$me),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$me),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$me),this.onDidRequestEndExecution=this.h.event;const h=this;this.value={get cwd(){return h.c},executeCommand(i,r){let t=i;r&&(t+=` "${r.map(g=>`${g.replaceAll('"','\\"')}`).join('" "')}"`),h.g.fire(t);const c={value:t,confidence:v.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},l=h.startShellExecution(c,h.c,!0).value;return h.b=!0,l}}}startShellExecution(s,o,h){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new E(s,o);h?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(s){this.currentExecution?.emitData(s)}endShellExecution(s,o){this.a&&(this.a.endExecution(s),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(s){let o=!1;a.URI.isUri(this.c)?o=!a.URI.isUri(s)||this.c.toString()!==s.toString():this.c!==s&&(o=!0),o&&(this.c=s,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class E{constructor(s,o){this.c=s,this.cwd=o,this.b=!1;const h=this;this.value={get commandLine(){return h.c},get cwd(){return h.cwd},read(){return h.d()}}}d(){if(!this.a){if(this.b)return P.$6h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(s){this.a?.emitData(s)}endExecution(s){s&&(this.c=s),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends k.$Wc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new P.$Eh);const s=this.a;return new P.$6h(async h=>{this.b.push(h),await s.wait()})}emitData(s){for(const o of this.b)o.emitOne(s)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ce[127],Ie([1,0,62,14,97,8,7]),function(oe,e,v,k,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=e.$9P=e.$8P=void 0,O=qe(O);class T{static{this.c=new C.$6P("TextEditorDecorationType")}constructor(u,E,d){const n=T.c.nextId();u.$registerTextEditorDecorationType(E.identifier,n,O.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:n,dispose(){u.$removeTextEditorDecorationType(n)}})}}e.$8P=T;class p{constructor(u,E){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,E){this.k();let d=null;if(u instanceof A.$xN)d=new A.$yN(u,u);else if(u instanceof A.$yN)d=u;else throw new Error("Unrecognized location");this.l(d,E,!1)}insert(u,E){this.k(),this.l(new A.$yN(u,u),E,!0)}delete(u){this.k();let E=null;if(u instanceof A.$yN)E=u;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(u,E,d){const n=this.c.validateRange(u);this.g.push({range:n,text:E,forceMoveMarkers:d})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,k.$9)("endOfLine");this.h=u}}class a{constructor(u,E,d,n){this.c=u,this.d=E,this._accept(d),this.e=n;const s=this;this.value={get tabSize(){return s.f},set tabSize(o){s.n(o)},get indentSize(){return s.g},set indentSize(o){s.p(o)},get insertSpaces(){return s.j},set insertSpaces(o){s.s(o)},get cursorStyle(){return s.k},set cursorStyle(o){s.t(o)},get lineNumbers(){return s.l},set lineNumbers(o){s.u(o)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}n(u){const E=this.m(u);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}p(u){const E=this.o(u);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const E=this.q(u);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(u)})))}assign(u){const E={};let d=!1;if(typeof u.tabSize<"u"){const n=this.m(u.tabSize);n==="auto"?(d=!0,E.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,d=!0,E.tabSize=n)}if(typeof u.indentSize<"u"){const n=this.o(u.indentSize);n==="tabSize"?(d=!0,E.indentSize=n):typeof n=="number"&&this.h!==n&&(this.g=n,this.h=n,d=!0,E.indentSize=n)}if(typeof u.insertSpaces<"u"){const n=this.q(u.insertSpaces);n==="auto"?(d=!0,E.insertSpaces=n):this.j!==n&&(this.j=n,d=!0,E.insertSpaces=n)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,d=!0,E.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,d=!0,E.lineNumbers=O.TextEditorLineNumbersStyle.from(u.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(u,E){E.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(d)})}}e.$9P=a;class P{constructor(u,E,d,n,s,o,h,i){this.id=u,this.j=E,this.k=d,this.g=!1,this.h=new Set,this.c=s,this.d=new a(this.j,this.id,o,d),this.e=h,this.f=i;const r=this;this.value=Object.freeze({get document(){return n.value},set document(t){throw new k.$$("document")},get selection(){return r.c&&r.c[0]},set selection(t){if(!(t instanceof A.$zN))throw(0,k.$9)("selection");r.c=[t],r.l()},get selections(){return r.c},set selections(t){if(!Array.isArray(t)||t.some(c=>!(c instanceof A.$zN)))throw(0,k.$9)("selections");r.c=t,r.l()},get visibleRanges(){return r.e},set visibleRanges(t){throw new k.$$("visibleRanges")},get options(){return r.d.value},set options(t){r.g||r.d.assign(t)},get viewColumn(){return r.f},set viewColumn(t){throw new k.$$("viewColumn")},edit(t,c={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new p(n.value,c);return t(l),r.m(l)},insertSnippet(t,c,l={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let g;if(!c||Array.isArray(c)&&c.length===0)g=r.c.map(m=>O.Range.from(m));else if(c instanceof A.$xN){const{lineNumber:m,column:$}=O.Position.from(c);g=[{startLineNumber:m,startColumn:$,endLineNumber:m,endColumn:$}]}else if(c instanceof A.$yN)g=[O.Range.from(c)];else{g=[];for(const m of c)if(m instanceof A.$yN)g.push(O.Range.from(m));else{const{lineNumber:$,column:S}=O.Position.from(m);g.push({startLineNumber:$,startColumn:S,endLineNumber:$,endColumn:S})}}return E.$tryInsertSnippet(u,n.value.version,t.value,g,l)},setDecorations(t,c){const l=c.length===0;l&&!r.h.has(t.key)||(l?r.h.delete(t.key):r.h.add(t.key),r.n(()=>{if(O.$XP(c))return E.$trySetDecorations(u,t.key,O.$YP(c));{const g=new Array(4*c.length);for(let m=0,$=c.length;m<$;m++){const S=c[m];g[4*m]=S.start.line+1,g[4*m+1]=S.start.character+1,g[4*m+2]=S.end.line+1,g[4*m+3]=S.end.character+1}return E.$trySetDecorationsFast(u,t.key,g)}}))},revealRange(t,c){r.n(()=>E.$tryRevealRange(u,O.Range.from(t),c||A.TextEditorRevealType.Default))},show(t){E.$tryShowEditor(u,O.ViewColumn.from(t))},hide(){E.$tryHideEditor(u)}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,v.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,v.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,v.ok)(!this.g),this.f=u}_acceptSelections(u){(0,v.ok)(!this.g),this.c=u}async l(){const u=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const E=u.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const d=E.edits.map(s=>s.range);d.sort((s,o)=>s.end.line===o.end.line?s.end.character===o.end.character?s.start.line===o.start.line?s.start.character-o.start.character:s.start.line-o.start.line:s.end.character-o.end.character:s.end.line-o.end.line);for(let s=0,o=d.length-1;s<o;s++){const h=d[s].end;if(d[s+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=E.edits.map(s=>({range:O.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,n,{setEndOfLine:typeof E.setEndOfLine=="number"?O.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$0P=P}),define(Ce[58],Ie([1,0,62,6,4,2,3,5,123,17,127,8,12,29,16,40,48]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=e.$$P=void 0,v=qe(v),y=qe(y);class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let h=class{constructor(r,t){this.h=r,this.i=t,this.a=null,this.b=new Map,this.c=new E.$Cc,this.d=new k.$me,this.e=new k.$me,this.f=new k.$me,this.g=new k.$me,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const t=[],c=[],l=[];if(r.removedDocuments)for(const g of r.removedDocuments){const m=O.URI.revive(g),$=this.c.get(m);$?.unref()&&(this.c.delete(m),t.push($.value))}if(r.addedDocuments)for(const g of r.addedDocuments){const m=O.URI.revive(g.uri);let $=this.c.get(m);if($&&m.scheme!==d.Schemas.vscodeNotebookCell&&m.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${m} already exists!'`);$||($=new o(new p.$4P(this.h.getProxy(T.$uN.MainThreadDocuments),m,g.lines,g.EOL,g.versionId,g.languageId,g.isDirty)),this.c.set(m,$),c.push($.value)),$.ref()}if(r.removedEditors)for(const g of r.removedEditors){const m=this.b.get(g);this.b.delete(g),m&&l.push(m)}if(r.addedEditors)for(const g of r.addedEditors){const m=O.URI.revive(g.documentUri);v.ok(this.c.has(m),`document '${m}' does not exist`),v.ok(!this.b.has(g.id),`editor '${g.id}' already exists!`);const $=this.c.get(m).value,S=new P.$0P(g.id,this.h.getProxy(T.$uN.MainThreadTextEditors),this.i,new s.$X(()=>$.document),g.selections.map(y.Selection.to),g.options,g.visibleRanges.map(D=>y.Range.to(D)),typeof g.editorPosition=="number"?y.ViewColumn.to(g.editorPosition):void 0);this.b.set(g.id,S)}r.newActiveEditor!==void 0&&(v.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,C.$Rc)(t),(0,C.$Rc)(l),r.removedDocuments&&this.e.fire(t),r.addedDocuments&&this.d.fire(c),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(g=>g.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return n.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const t=this.b.get(this.a);return r?t:t?.value}allEditors(){return[...this.b.values()]}};e.$$P=h,e.$$P=h=Qe([Ve(0,a.$1P),Ve(1,u.$_j)],h),e.$_P=(0,A.$Fi)("IExtHostDocumentsAndEditors")}),define(Ce[96],Ie([1,0,11,23,22,6,273,76,4,38,15,37,3,12,5,34,58,17,125,8,7,242,55,82,56,25]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h,i,r,t,c,l,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$spc=e.$rpc=e.$qpc=e.$ppc=e.$opc=void 0,i=qe(i);let $=0;const S=new WeakMap;e.$opc=(0,u.$Fi)("IExtHostTesting");let D=class extends p.$Wc{constructor(_,ge,se,ce){super(),this.C=ge,this.D=se,this.F=ce,this.f=this.B(new O.$me),this.g=new Map,this.w=this.B(new O.$me),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=_.getProxy(d.$uN.MainThreadTesting),this.m=new G(this.h),this.j=new f(this.h,ge),se.registerArgumentProcessor({processArgument:we=>{switch(we?.$mid){case a.MarshalledId.TestItemContext:{const re=we,Pe=re.tests[re.tests.length-1].item.extId;return this.g.get(c.$TI.root(Pe))?.collection.tree.get(Pe)?.actual??(0,h.$aQ)(we)}case a.MarshalledId.TestMessageMenuArgs:{const{test:re,message:Pe}=we,Me=re.item.extId;return{test:this.g.get(c.$TI.root(Me))?.collection.tree.get(Me)?.actual??(0,h.$aQ)({$mid:a.MarshalledId.TestItemContext,tests:[re]}),message:i.TestMessage.to(Pe)}}default:return we}}}),se.registerCommand(!1,"testing.getExplorerSelection",async()=>{const we=await se.executeCommand(t.TestCommandId.GetExplorerSelection),re=Pe=>{const Me=this.g.get(c.$TI.root(Pe));if(Me)return c.$TI.isRoot(Pe)?Me.controller:Me.collection.tree.get(Pe)?.actual};return{include:we?.include.map(re).filter(P.$ng)||[],exclude:we?.exclude.map(re).filter(P.$ng)||[]}})}createTestController(_,ge,se,ce){if(this.g.has(ge))throw new Error(`Attempt to insert a duplicate controller with ID "${ge}"`);const we=new p.$Vc,re=we.add(new h.$dQ(ge,se,this.F));re.root.label=se;const Pe=new Map,Me=new Set,Y=this.h,q={items:re.root.children,get label(){return se},set label(ve){se=ve,re.root.label=ve,Y.$updateController(ge,{label:se})},get refreshHandler(){return ce},set refreshHandler(ve){ce=ve,Y.$updateController(ge,{canRefresh:!!ve})},get id(){return ge},createRunProfile:(ve,ue,be,de,X,Z)=>{let me=(0,T.$tj)(ve);for(;Pe.has(me);)me++;return new F(this.h,Pe,Me,this.w.event,ge,me,ve,ue,be,de,X,Z)},createTestItem(ve,ue,be){return new h.$bQ(ge,ve,ue,be)},createTestRun:(ve,ue,be=!0)=>this.j.createTestRun(_,ge,re,ve,ue,be),invalidateTestResults:ve=>{if(ve===void 0)this.h.$markTestRetired(void 0);else{const ue=ve instanceof Array?ve:[ve];this.h.$markTestRetired(ue.map(be=>c.$TI.fromExtHostTestItem(be,ge).toString()))}},set resolveHandler(ve){re.resolveHandler=ve},get resolveHandler(){return re.resolveHandler},dispose:()=>{we.dispose()}};Y.$registerTestController(ge,se,!!ce),we.add((0,p.$Uc)(()=>Y.$unregisterTestController(ge)));const ee={controller:q,collection:re,profiles:Pe,extension:_,activeProfiles:Me};return this.g.set(ge,ee),we.add((0,p.$Uc)(()=>this.g.delete(ge))),we.add(re.onDidGenerateDiff(ve=>Y.$publishDiff(ge,ve.map(g.TestsDiffOp.serialize)))),q}createTestObserver(){return this.m.checkout()}async runTests(_,ge=C.CancellationToken.None){const se=w(_);if(!se)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ce=this.g.get(se.controllerId);if(!ce)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:_.preserveFocus??!0,group:V[se.kind],targets:[{testIds:_.include?.map(we=>c.$TI.fromExtHostTestItem(we,ce.collection.root.id).toString())??[ce.collection.root.id],profileId:se.profileId,controllerId:se.controllerId}],exclude:_.exclude?.map(we=>we.id)},ge)}registerTestFollowupProvider(_){return this.y.add(_),{dispose:()=>{this.y.delete(_)}}}$syncTests(){for(const{collection:_}of this.g.values())_.flushDiff();return Promise.resolve()}async $getCoverageDetails(_,ge,se){return(await this.j.getCoverageDetails(_,ge,se))?.map(i.TestCoverage.fromDetails)}async $disposeRun(_){this.j.disposeTestRun(_)}$configureRunProfile(_,ge){this.g.get(_)?.profiles.get(ge)?.configureHandler?.()}$setDefaultRunProfiles(_){const ge=new Map;for(const[se,ce]of Object.entries(_)){const we=this.g.get(se);if(!we)continue;const re=new Map,Pe=ce.filter(Y=>!we.activeProfiles.has(Y)),Me=[...we.activeProfiles].filter(Y=>!ce.includes(Y));for(const Y of Pe)re.set(Y,!0),we.activeProfiles.add(Y);for(const Y of Me)re.set(Y,!1),we.activeProfiles.delete(Y);re.size&&ge.set(se,re)}this.w.fire(ge)}async $refreshTests(_,ge){await this.g.get(_)?.controller.refreshHandler?.(ge)}$publishTestResults(_){this.results=Object.freeze(_.map(ge=>{const se=i.TestResults.to(ge);return S.set(se,ge.id),se}).concat(this.results).sort((ge,se)=>se.completedAt-ge.completedAt).slice(0,32)),this.f.fire()}async $expandTest(_,ge){const se=this.g.get(c.$TI.fromString(_).controllerId)?.collection;se&&(await se.expand(_,ge<0?1/0:ge),se.flushDiff())}$acceptDiff(_){this.m.applyDiff(_.map(ge=>g.TestsDiffOp.deserialize({asCanonicalUri:se=>se},ge)))}async $runControllerTests(_,ge){return Promise.all(_.map(se=>this.G(se,!1,ge)))}async $startContinuousRun(_,ge){const se=new C.$xe(ge),ce=await Promise.all(_.map(we=>this.G(we,!0,se.token)));return!ge.isCancellationRequested&&!ce.some(we=>we.error)&&await new Promise(we=>ge.onCancellationRequested(we)),se.dispose(!0),ce}async $provideTestFollowups(_,ge){const se=this.results.find(re=>S.get(re)===_.resultId),ce=se&&ae(c.$TI.fromString(_.extId),se?.results);if(!ce)return[];let we=[];return await Promise.all([...this.y].map(async re=>{try{const Pe=await re.provideFollowup(se,ce,_.taskIndex,_.messageIndex,ge);Pe&&(we=we.concat(Pe))}catch(Pe){this.C.error("Error thrown while providing followup for test message",Pe)}})),ge.isCancellationRequested?[]:we.map(re=>{const Pe=$++;return this.z.set(Pe,re),{title:re.title,id:Pe}})}$disposeTestFollowups(_){for(const ge of _)this.z.delete(ge)}$executeTestFollowup(_){const ge=this.z.get(_);return ge?this.D.executeCommand(ge.command,...ge.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(_){_===void 0?this.j.cancelAllRuns():this.j.cancelRunById(_)}getMetadataForRun(_){for(const ge of this.j.trackers){const se=ge.getTaskIdForRun(_);if(se)return{taskId:se,runId:ge.id}}}async G(_,ge,se){const ce=this.g.get(_.controllerId);if(!ce)return{};const{collection:we,profiles:re,extension:Pe}=ce,Me=re.get(_.profileId);if(!Me)return{};const Y=_.testIds.map(ue=>we.tree.get(ue)).filter(P.$ng),q=_.excludeExtIds.map(ue=>ce.collection.tree.get(ue)).filter(P.$ng).filter(ue=>Y.some(be=>be.fullId.compare(ue.fullId)===c.TestPosition.IsChild));if(!Y.length)return{};const ee=new r.$0O(Y.some(ue=>ue.actual instanceof h.$cQ)?void 0:Y.map(ue=>ue.actual),q.map(ue=>ue.actual),Me,ge),ve=(0,g.$WI)(_)&&this.j.prepareForMainThreadTestRun(Pe,ee,M.fromInternal(_,ce.collection),Me,se);try{return await Me.runHandler(ee,se),{}}catch(ue){return{error:String(ue)}}finally{ve&&ve.hasRunningTasks&&!se.isCancellationRequested&&await O.Event.toPromise(ve.onEnd)}}};e.$ppc=D,e.$ppc=D=Qe([Ve(0,o.$1P),Ve(1,E.$_j),Ve(2,n.$kQ),Ve(3,s.$_P)],D);const b=1e4;var I;(function($e){$e[$e.Running=0]="Running",$e[$e.Cancelling=1]="Cancelling",$e[$e.Ended=2]="Ended"})(I||(I={}));class R extends p.$Wc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(_,ge,se,ce,we,re){super(),this.z=_,this.C=ge,this.D=se,this.F=ce,this.G=we,this.c=I.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$me),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new C.$xe(re));const Pe=this.B(new v.$Rh(()=>this.H(),b));this.B(this.j.token.onCancellationRequested(()=>Pe.schedule()));const Me=new O.$me;this.w=Me.event,this.B((0,p.$Uc)(()=>{Me.fire(),Me.dispose()}))}getTaskIdForRun(_){for(const[ge,{run:se}]of this.g)if(se===_)return ge}cancel(){this.c===I.Running?(this.j.cancel(),this.c=I.Cancelling):this.c===I.Cancelling&&this.H()}async getCoverageDetails(_,ge,se){const[,ce]=c.$TI.fromString(_).path,we=this.y.get(_);if(!we)return[];const{report:re,extIds:Pe}=we,Me=this.g.get(ce);if(!Me)throw new Error("unreachable: run task was not found");let Y;if(ge&&re instanceof r.$cP){const ee=Pe.indexOf(ge);if(ee===-1)return[];Y=re.fromTests[ee]}return await(Y?this.F?.loadDetailedCoverageForTest?.(Me.run,re,Y,se):this.F?.loadDetailedCoverage?.(Me.run,re,se))??[]}createRun(_){const ge=this.z.id,se=this.z.controllerId,ce=(0,y.$2g)(),we=Y=>(q,...ee)=>{if(Pe){this.D.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}this.J(q),Y(q,...ee)},re=(Y,q)=>{const ee=q instanceof Array?q.map(i.TestMessage.from):[i.TestMessage.from(q)];if(Y.uri&&Y.range){const ve={range:i.Range.from(Y.range),uri:Y.uri};for(const ue of ee)ue.location=ue.location||ve}this.C.$appendTestMessagesInRun(ge,ce,c.$TI.fromExtHostTestItem(Y,se).toString(),ee)};let Pe=!1;const Me={isPersisted:this.z.isPersisted,token:this.j.token,name:_,onDidDispose:this.w,addCoverage:Y=>{if(Pe)return;const q=Y instanceof r.$cP?Y.fromTests:[];if(q.length){(0,m.$7G)(this.G,"attributableCoverage");for(const ue of q)this.J(ue)}const ee=Y.uri.toString(),ve=new c.$TI([ge,ce,ee]).toString();this.y.set(ve,{report:Y,extIds:q.map(ue=>c.$TI.fromExtHostTestItem(ue,se).toString())}),this.C.$appendCoverage(ge,ce,i.TestCoverage.fromFile(se,ve,Y))},enqueued:we(Y=>{this.C.$updateTestStateInRun(ge,ce,c.$TI.fromExtHostTestItem(Y,se).toString(),g.TestResultState.Queued)}),skipped:we(Y=>{this.C.$updateTestStateInRun(ge,ce,c.$TI.fromExtHostTestItem(Y,se).toString(),g.TestResultState.Skipped)}),started:we(Y=>{this.C.$updateTestStateInRun(ge,ce,c.$TI.fromExtHostTestItem(Y,se).toString(),g.TestResultState.Running)}),errored:we((Y,q,ee)=>{re(Y,q),this.C.$updateTestStateInRun(ge,ce,c.$TI.fromExtHostTestItem(Y,se).toString(),g.TestResultState.Errored,ee)}),failed:we((Y,q,ee)=>{re(Y,q),this.C.$updateTestStateInRun(ge,ce,c.$TI.fromExtHostTestItem(Y,se).toString(),g.TestResultState.Failed,ee)}),passed:we((Y,q)=>{this.C.$updateTestStateInRun(ge,ce,c.$TI.fromExtHostTestItem(Y,this.z.controllerId).toString(),g.TestResultState.Passed,q)}),appendOutput:(Y,q,ee)=>{Pe||(ee&&this.J(ee),this.C.$appendOutputToRun(ge,ce,k.$Oe.fromString(Y),q&&i.location.from(q),ee&&c.$TI.fromExtHostTestItem(ee,se).toString()))},end:()=>{Pe||(Pe=!0,this.C.$finishedTestRunTask(ge,ce),--this.f||this.I())}};return this.f++,this.g.set(ce,{run:Me}),this.C.$startedTestRunTask(ge,{id:ce,name:_,running:!0}),Me}H(){for(const{run:_}of this.g.values())_.end()}I(){this.c!==I.Ended&&(this.c=I.Ended,this.m.fire())}J(_){if(!(_ instanceof h.$bQ))throw new l.$SP(_.id);if(this.h.has(c.$TI.fromExtHostTestItem(_,this.z.controllerId).toString()))return;const ge=[],se=this.z.colllection.root;for(;;){const ce=i.TestItem.from(_);if(ge.unshift(ce),this.h.has(ce.extId)||(this.h.add(ce.extId),_===se))break;_=_.parent||se}this.C.$addTestsToRun(this.z.controllerId,this.z.id,ge)}dispose(){this.I(),super.dispose()}}class f{get trackers(){return this.c.values()}constructor(_,ge){this.g=_,this.h=ge,this.c=new Map,this.f=new Map}getCoverageDetails(_,ge,se){const ce=c.$TI.root(_);return this.f.get(ce)?.getCoverageDetails(_,ge,se)||[]}disposeTestRun(_){this.f.get(_)?.dispose(),this.f.delete(_);for(const[ge,{id:se}]of this.c)se===_&&this.c.delete(ge)}prepareForMainThreadTestRun(_,ge,se,ce,we){return this.j(ge,se,ce,_,we)}cancelRunById(_){this.f.get(_)?.cancel()}cancelAllRuns(){for(const _ of this.c.values())_.cancel()}createTestRun(_,ge,se,ce,we,re){const Pe=this.c.get(ce);if(Pe)return Pe.createRun(we);const Me=M.fromPublic(ge,se,ce,re),Y=w(ce);this.g.$startedExtensionTestRun({controllerId:ge,continuous:!!ce.continuous,profile:Y&&{group:V[Y.kind],id:Y.profileId},exclude:ce.exclude?.map(ee=>c.$TI.fromExtHostTestItem(ee,se.root.id).toString())??[],id:Me.id,include:ce.include?.map(ee=>c.$TI.fromExtHostTestItem(ee,se.root.id).toString())??[se.root.id],preserveFocus:ce.preserveFocus??!0,persist:re});const q=this.j(ce,Me,ce.profile,_);return O.Event.once(q.onEnd)(()=>{this.g.$finishedExtensionTestRun(Me.id)}),q.createRun(we)}j(_,ge,se,ce,we){const re=new R(ge,this.g,this.h,se,ce,we);return this.c.set(_,re),this.f.set(re.id,re),re}}e.$qpc=f;const w=$e=>{if($e.profile){if(!($e.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return $e.profile}};class M{static fromPublic(_,ge,se,ce){return new M(_,(0,y.$2g)(),ce,ge)}static fromInternal(_,ge){return new M(_.controllerId,_.runId,!0,ge)}constructor(_,ge,se,ce){this.controllerId=_,this.id=ge,this.isPersisted=se,this.colllection=ce}}e.$rpc=M;class N{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(_){this.j=_,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(_){this.c.add(_)}update(_){Object.assign(_.revived,i.TestItem.toPlain(_.item)),this.c.has(_)||this.f.add(_)}remove(_){if(this.c.has(_)){this.c.delete(_);return}this.f.delete(_);const ge=c.$TI.parentId(_.item.extId);if(ge&&this.h.has(ge.toString())){this.h.add(_.item.extId);return}this.g.add(_)}getChangeEvent(){const{c:_,f:ge,g:se}=this;return{get added(){return[..._].map(ce=>ce.revived)},get updated(){return[...ge].map(ce=>ce.revived)},get removed(){return[...se].map(ce=>ce.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class L extends g.$3I{constructor(){super(...arguments),this.y=new O.$me,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(_){return this.f.get(_)}getMirroredTestDataByReference(_){return this.f.get(_.id)}x(_,ge){return{..._,revived:i.TestItem.toPlain(_.item),depth:ge?ge.depth+1:0,children:new Set}}w(){return new N(this.y)}}class G{constructor(_){this.f=_}checkout(){this.c||(this.c=this.g());const _=this.c;return _.observers++,{onDidChangeTest:_.tests.onDidChangeTests,get tests(){return[..._.tests.rootTests].map(ge=>ge.revived)},dispose:(0,A.$fb)(()=>{--_.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(_){return this.c?.tests.getMirroredTestDataByReference(_)}applyDiff(_){this.c?.tests.apply(_)}g(){const _=new L({asCanonicalUri:ge=>ge});return this.f.$subscribeToDiffs(),{observers:0,tests:_}}}const W=($e,_,ge,se)=>{ge?Object.assign(ge,se):_.$updateTestRunConfig($e.controllerId,$e.profileId,se)};class F{#e;#t;#i;#n;#s;get label(){return this.f}set label(_){_!==this.f&&(this.f=_,W(this,this.#e,this.#n,{label:_}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(_){_!==this.g&&(this.g=_,W(this,this.#e,this.#n,{supportsContinuousRun:_}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(_){_!==this.isDefault&&(_?this.#t.add(this.profileId):this.#t.delete(this.profileId),W(this,this.#e,this.#n,{isDefault:_}))}get tag(){return this._tag}set tag(_){_?.id!==this._tag?.id&&(this._tag=_,W(this,this.#e,this.#n,{tag:_?i.TestTag.namespace(this.controllerId,_.id):null}))}get configureHandler(){return this.c}set configureHandler(_){_!==this.c&&(this.c=_,W(this,this.#e,this.#n,{hasConfigurationHandler:!!_}))}get onDidChangeDefault(){return O.Event.chain(this.#i,_=>_.map(ge=>ge.get(this.controllerId)?.get(this.profileId)).filter(P.$ng))}constructor(_,ge,se,ce,we,re,Pe,Me,Y,q=!1,ee=void 0,ve=!1){this.controllerId=we,this.profileId=re,this.f=Pe,this.kind=Me,this.runHandler=Y,this._tag=ee,this.g=ve,this.#e=_,this.#s=ge,this.#t=se,this.#i=ce,ge.set(re,this);const ue=V[Me];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${Me}`);q&&se.add(re),this.#n={profileId:re,controllerId:we,tag:ee?i.TestTag.namespace(this.controllerId,ee.id):null,label:Pe,group:ue,isDefault:q,hasConfigurationHandler:!1,supportsContinuousRun:ve},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$spc=F;const V={[r.TestRunProfileKind.Coverage]:g.TestRunProfileBitset.Coverage,[r.TestRunProfileKind.Debug]:g.TestRunProfileBitset.Debug,[r.TestRunProfileKind.Run]:g.TestRunProfileBitset.Run};function ae($e,_){for(let ge=0;ge<$e.path.length;ge++){const se=_.find(ce=>ce.id===$e.path[ge]);if(!se)return;if(ge===$e.path.length-1)return se;_=se.children}}}),define(Ce[301],Ie([1,0,18,6,4,5,127,8,7]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=void 0,v=qe(v),T=qe(T);class a extends C.$Wc{constructor(y,u){super(),this.m=u,this.a=new k.$me,this.b=new k.$me,this.c=new k.$me,this.f=new k.$me,this.g=new k.$me,this.h=new k.$me,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(O.$uN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(E=>this.h.fire(E))),this.B(this.m.onDidChangeActiveTextEditor(E=>this.g.fire(E)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const u=this.m.allEditors();return y?u:u.map(E=>E.value)}async showTextDocument(y,u,E){let d;typeof u=="number"?d={position:T.ViewColumn.from(u),preserveFocus:E}:typeof u=="object"?d={position:T.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?T.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:d={preserveFocus:!1};const n=await this.j.$tryShowTextDocument(y.uri,d),s=n&&this.m.getEditor(n);if(s)return s.value;throw n?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,u){return new A.$8P(this.j,y,u).value}$acceptEditorPropertiesChanged(y,u){const E=this.m.getEditor(y);if(!E)throw new Error("unknown text editor");if(u.options&&E._acceptOptions(u.options),u.selections){const d=u.selections.selections.map(T.Selection.to);E._acceptSelections(d)}if(u.visibleRanges){const d=v.$Jb(u.visibleRanges.map(T.Range.to));E._acceptVisibleRanges(d)}if(u.options&&this.b.fire({textEditor:E.value,options:{...u.options,lineNumbers:T.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const d=p.TextEditorSelectionChangeKind.fromValue(u.selections.source),n=u.selections.selections.map(T.Selection.to);this.a.fire({textEditor:E.value,selections:n,kind:d})}if(u.visibleRanges){const d=v.$Jb(u.visibleRanges.map(T.Range.to));this.c.fire({textEditor:E.value,visibleRanges:d})}}$acceptEditorPositionData(y){for(const u in y){const E=this.m.getEditor(u);if(!E)throw new Error("Unknown text editor");const d=T.ViewColumn.to(y[u]);E.value.viewColumn!==d&&(E._acceptViewColumn(d),this.f.fire({textEditor:E.value,viewColumn:d}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$zoc=a}),define(Ce[302],Ie([1,0,2,3,5,4,7,8,19,38,15]),function(oe,e,v,k,C,O,A,T,p,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=e.$jqc=void 0,e.$jqc=(0,k.$Fi)("IExtHostTimeline");class y{constructor(d,n){this.b=new Map,this.c=new Map,this.a=d.getProxy(C.$uN.MainThreadTimeline),n.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===a.MarshalledId.TimelineActionContext)if(this.b.get(s.source)&&p.$qn.equals(o,this.b.get(s.source)?.extension)){const h=s.uri===void 0?void 0:v.URI.revive(s.uri);return this.c.get(s.source)?.get(u(h))?.get(s.handle)}else return;return s}})}async $getTimeline(d,n,s,o){return this.b.get(d)?.provider.provideTimeline(v.URI.revive(n),s,o)}registerTimelineProvider(d,n,s,o){const h=new O.$Vc,i=this.d(n.id,o,h).bind(this);let r;n.onDidChange&&(r=n.onDidChange(c=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:n.id}),this));const t=this.c;return this.f({...n,scheme:d,onDidChange:void 0,async provideTimeline(c,l,g){l?.resetCache&&(h.clear(),t.get(n.id)?.clear());const m=await n.provideTimeline(c,l,g);if(m==null)return;const $=i(c,l);return{...m,source:n.id,items:m.items.map($)}},dispose(){for(const c of t.values())c.get(n.id)?.clear();r?.dispose(),h.dispose()}},s)}d(d,n,s){return(o,h)=>{let i;if(h?.cacheResults){let r=this.c.get(d);r===void 0&&(r=new Map,this.c.set(d,r));const t=u(o);i=r.get(t),i===void 0&&(i=new Map,r.set(t,i))}return r=>{const{iconPath:t,...c}=r,l=`${d}|${r.id??r.timestamp}`;i?.set(l,r);let g,m,$;r.iconPath&&(t instanceof A.$tO?$={id:t.id,color:t.color}:v.URI.isUri(t)?(g=t,m=t):{light:g,dark:m}=t);let S;return A.$YN.isMarkdownString(c.tooltip)?S=T.MarkdownString.from(c.tooltip):(0,P.$fg)(c.tooltip)?S=c.tooltip:A.$YN.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=T.MarkdownString.from(c.detail)):(0,P.$fg)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=c.detail),{...c,id:c.id??void 0,handle:l,source:d,command:r.command?n.toInternal(r.command,s):void 0,icon:g,iconDark:m,themeIcon:$,tooltip:S,accessibilityInformation:r.accessibilityInformation}}}}f(d,n){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:n}),(0,O.$Uc)(()=>{for(const o of this.c.values())o.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$kqc=y;function u(E){return E?.toString()}}),define(Ce[303],Ie([1,0,190,24,2,6,4,233,11,7,15,18,8,60,22,154,25]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lqc=void 0,a=qe(a);function o(r,t){if((0,P.$fg)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let c;return Array.isArray(r.highlights)&&(c=r.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),c=c.length?c:void 0),{label:r.label,highlights:c}}}class h extends A.$Wc{constructor(t,c,l){super(),this.f=t,this.g=c,this.h=l,this.a=new Map,this.b=new n.$v_;function g(m){return m&&m.$treeViewId&&(m.$treeItemHandle||m.$selectedTreeItems||m.$focusedTreeItem)}c.registerArgumentProcessor({processArgument:m=>g(m)?this.r(m):Array.isArray(m)&&m.length>0?m.map($=>g($)?this.r($):$):m})}registerTreeDataProvider(t,c,l){const g=this.createTreeView(t,{treeDataProvider:c},l);return{dispose:()=>g.dispose()}}createTreeView(t,c,l){if(!c||!c.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=c.dragAndDropController?.dropMimeTypes??[],m=c.dragAndDropController?.dragMimeTypes??[],$=!!c.dragAndDropController?.handleDrag,S=!!c.dragAndDropController?.handleDrop,D=this.m(t,c,l),b={showCollapseAll:!!c.showCollapseAll,canSelectMany:!!c.canSelectMany,dropMimeTypes:g,dragMimeTypes:m,hasHandleDrag:$,hasHandleDrop:S,manuallyManageCheckboxes:!!c.manageCheckboxStateManually},I=this.f.$registerTreeViewDataProvider(t,b),R={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,s.$7G)(l,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,s.$7G)(l,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(f){(0,E.$5k)(f)&&(0,s.$7G)(l,"treeViewMarkdownMessage"),D.message=f},get title(){return D.title},set title(f){D.title=f},get description(){return D.description},set description(f){D.description=f},get badge(){return D.badge},set badge(f){f!==void 0&&a.ViewBadge.isViewBadge(f)?D.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(D.badge=void 0)},reveal:(f,w)=>D.reveal(f,w),dispose:async()=>{await I,this.a.delete(t),D.dispose()}};return this.B(R),R}$getChildren(t,c){const l=this.a.get(t);return l?l.getChildren(c):Promise.reject(new T.$qG(t))}async $handleDrop(t,c,l,g,m,$,S,D){const b=this.a.get(t);if(!b)return Promise.reject(new T.$qG(t));const I=u.DataTransfer.toDataTransfer(l,async R=>(await this.f.$resolveDropFileData(t,c,R)).buffer);return S===t&&D&&await this.j(I,b,D,m,$),b.onDrop(I,g,m)}async j(t,c,l,g,m){const $=this.b.removeDragOperationTransfer(m);if($)(await $)?.forEach((S,D)=>{S&&t.set(D,S)});else if(m&&c.handleDrag){const S=c.handleDrag(l,t,g);this.b.addDragOperationTransfer(m,S),await S}return t}async $handleDrag(t,c,l,g){const m=this.a.get(t);if(!m)return Promise.reject(new T.$qG(t));const $=await this.j(new a.$pO,m,c,g,l);if(!(!$||g.isCancellationRequested))return u.DataTransfer.from($)}async $hasResolve(t){const c=this.a.get(t);if(!c)throw new T.$qG(t);return c.hasResolve}$resolve(t,c,l){const g=this.a.get(t);if(!g)throw new T.$qG(t);return g.resolveTreeItem(c,l)}$setExpanded(t,c,l){const g=this.a.get(t);if(!g)throw new T.$qG(t);g.setExpanded(c,l)}$setSelectionAndFocus(t,c,l){const g=this.a.get(t);if(!g)throw new T.$qG(t);g.setSelectionAndFocus(c,l)}$setVisible(t,c){const l=this.a.get(t);if(!l){if(!c)return;throw new T.$qG(t)}l.setVisible(c)}$changeCheckboxState(t,c){const l=this.a.get(t);if(!l)throw new T.$qG(t);l.setCheckboxState(c)}m(t,c,l){const g=this.B(new i(t,c,this.f,this.g.converter,this.h,l));return this.a.set(t,g),g}r(t){const c=this.a.get(t.$treeViewId);return c&&"$treeItemHandle"in t?c.getExtensionElement(t.$treeItemHandle):c&&"$focusedTreeItem"in t&&t.$focusedTreeItem?c.focusedElement:null}}e.$lqc=h;class i extends A.$Wc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,P.$og)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,c,l,g,m,$){if(super(),this.I=t,this.J=l,this.L=g,this.M=m,this.N=$,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$me),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$me),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$me),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$me),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$me),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$me),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$me),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$xe,$.contributes&&$.contributes.views)for(const I in $.contributes.views)for(const R of $.contributes.views[I])R.id===t&&(this.P=R.name);this.f=c.treeDataProvider,this.g=c.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(I=>{Array.isArray(I)&&I.length===0||this.F.fire({message:!1,element:I})}));let S,D;const b=O.Event.debounce(this.F.event,(I,R)=>(I||(I={message:!1,elements:[]}),R.element!==!1&&(S||(S=new Promise(f=>D=f),this.G=this.G.then(()=>S)),Array.isArray(R.element)?I.elements.push(...R.element):I.elements.push(R.element)),R.message&&(I.message=!0),I),200,!0);this.B(b(({message:I,elements:R})=>{R.length&&(this.H=this.H.then(()=>{const f=D;return S=null,this.$(R).then(()=>f())})),I&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const c=t?this.getExtensionElement(t):void 0;if(t&&!c)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let l=this.X(t);return l||(l=await this.Y(c)),l?l.map(g=>g.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,c){c=c||{select:!0,focus:!1};const l=(0,P.$og)(c.select)?!0:c.select,g=(0,P.$og)(c.focus)?!1:c.focus,m=(0,P.$og)(c.expand)?!1:c.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then($=>this.W(t,$[$.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:$.map(D=>D.item)},{select:l,focus:g,expand:m})),$=>this.M.error($)):this.J.$reveal(this.I,void 0,{select:l,focus:g,expand:m})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,c){const l=this.getExtensionElement(t);l&&(c?this.u.fire(Object.freeze({element:l})):this.w.fire(Object.freeze({element:l})))}setSelectionAndFocus(t,c){const l=!(0,y.$wb)(this.s,t);this.s=t;const g=this.t!==c;this.t=c,l&&this.y.fire(Object.freeze({selection:this.selectedElements})),g&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const c=(await Promise.all(t.map(async l=>{const g=this.getExtensionElement(l.treeItemHandle);return g?{extensionItem:g,treeItem:await this.f.getTreeItem(g),newState:l.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);c.forEach(l=>{l.treeItem.checkboxState=l.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}),this.D.fire({items:c.map(l=>[l.extensionItem,l.newState])})}async handleDrag(t,c,l){const g=[];for(const m of t){const $=this.getExtensionElement(m);$&&g.push($)}if(!(!this.g?.handleDrag||g.length===0))return await this.g.handleDrag(g,c,l),c}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,c,l){const g=c?this.getExtensionElement(c):void 0;if(!(!g&&c||!this.g?.handleDrop))return(0,p.$xh)(()=>this.g?.handleDrop?this.g.handleDrop(g,t,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,c){if(!this.f.resolveTreeItem)return;const l=this.j.get(t);if(l){const g=this.m.get(l);if(g){const m=await this.f.resolveTreeItem(g.extensionItem,l,c)??g.extensionItem;return this.hb(m),g.item.tooltip=this.eb(m.tooltip),g.item.command=this.fb(g.disposableStore,m.command),g.item}}}S(t){return this.U(t).then(c=>c?this.S(c).then(l=>this.W(c,l[l.length-1]).then(g=>(l.push(g),l))):Promise.resolve([]))}U(t){const c=this.m.get(t);return c?Promise.resolve(c.parent?this.j.get(c.parent.item.handle):void 0):(0,p.$xh)(()=>this.f.getParent(t))}W(t,c){const l=this.m.get(t);return l?Promise.resolve(l):(0,p.$xh)(()=>this.f.getTreeItem(t)).then(g=>this.kb(t,g,c,!0)).then(g=>this.getChildren(c?c.item.handle:void 0).then(()=>{const m=this.getExtensionElement(g);if(m){const $=this.m.get(m);if($)return Promise.resolve($)}throw new Error(`Cannot resolve tree item for element ${g} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let c;if(typeof t=="string"){const l=this.getExtensionElement(t);c=l?this.m.get(l):void 0}else c=t;return c&&c.children||void 0}return this.h}async Y(t){this.rb(t);const c=new d.$xe(this.Z.token);try{const l=t?this.m.get(t):void 0,g=await this.f.getChildren(t);if(c.token.isCancellationRequested)return;const m=(0,y.$Jb)(g||[]),$=await Promise.all((0,y.$Jb)(m).map(D=>this.f.getTreeItem(D)));if(c.token.isCancellationRequested)return;const S=$.map((D,b)=>D?this.db(m[b],D,l):null);return(0,y.$Jb)(S)}finally{c.dispose()}}$(t){if(t.some(l=>!l))return this.Z.dispose(!0),this.Z=new d.$xe,this.tb(),this.J.$refresh(this.I);{const l=this.ab(t);if(l.length)return this.bb(l)}return Promise.resolve(void 0)}ab(t){const c=new Set,l=t.map(m=>this.m.get(m));for(const m of l)if(m&&!c.has(m.item.handle)){let $=m;for(;$&&$.parent&&l.findIndex(S=>$&&$.parent&&S&&S.item.handle===$.parent.item.handle)===-1;){const S=this.j.get($.parent.item.handle);$=S?this.m.get(S):void 0}$&&!$.parent&&c.add(m.item.handle)}const g=[];return c.forEach(m=>{const $=this.j.get(m);if($){const S=this.m.get($);S&&(!S.parent||!c.has(S.parent.item.handle))&&g.push(m)}}),g}bb(t){const c={};return Promise.all(t.map(l=>this.cb(l).then(g=>{g&&(c[l]=g.item)}))).then(()=>Object.keys(c).length?this.J.$refresh(this.I,c):void 0)}cb(t){const c=this.getExtensionElement(t);if(c){const l=this.m.get(c);if(l)return this.rb(c),(0,p.$xh)(()=>this.f.getTreeItem(c)).then(g=>{if(g){const m=this.ib(c,g,l.parent);return this.pb(c,m,l,l.parent),l.dispose(),m}return null})}return Promise.resolve(null)}db(t,c,l){const g=this.ib(t,c,l);if(c.id&&this.j.has(g.item.handle))throw new Error((0,v.localize)(0,null,c.id));return this.ob(t,g),this.qb(g,l),g}eb(t){return a.$YN.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,c){return c?{...this.L.toInternal(c,t),originalId:c.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let c,l,g;return typeof t.checkboxState=="number"?c=t.checkboxState:(c=t.checkboxState.state,l=t.checkboxState.tooltip,g=t.checkboxState.accessibilityInformation),{isChecked:c===a.TreeItemCheckboxState.Checked,tooltip:l,accessibilityInformation:g}}hb(t){if(!a.$kO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,c,l){this.hb(c);const g=this.B(new A.$Vc),m=this.kb(t,c,l),$=this.lb(c);return{item:{handle:m,parentHandle:l?l.item.handle:void 0,label:o(c.label,this.N),description:c.description,resourceUri:c.resourceUri,tooltip:this.eb(c.tooltip),command:this.fb(g,c.command),contextValue:c.contextValue,icon:$,iconDark:this.mb(c)||$,themeIcon:this.jb(c),collapsibleState:(0,P.$og)(c.collapsibleState)?a.TreeItemCollapsibleState.None:c.collapsibleState,accessibilityInformation:c.accessibilityInformation,checkbox:this.gb(c)},extensionItem:c,parent:l,children:void 0,disposableStore:g,dispose(){g.dispose()}}}jb(t){return t.iconPath instanceof a.$tO?t.iconPath:void 0}kb(t,{id:c,label:l,resourceUri:g},m,$){if(c)return`${i.b}/${c}`;const S=o(l,this.N),D=m?m.item.handle:i.a;let b=S?S.label:g?(0,k.$dh)(g):"";b=b.indexOf("/")!==-1?b.replace("/","//"):b;const I=this.m.has(t)?this.m.get(t).item.handle:void 0,R=this.X(m)||[];let f,w=0;do{if(f=`${D}/${w}:${b}`,$||!this.j.has(f)||I===f)break;w++}while(w<=R.length);return f}lb(t){if(t.iconPath&&!(t.iconPath instanceof a.$tO))return typeof t.iconPath=="string"||C.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof a.$tO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return C.URI.isUri(t)?t:C.URI.file(t)}ob(t,c){this.j.set(c.item.handle,t),this.m.set(t,c)}pb(t,c,l,g){this.j.delete(c.item.handle),this.m.delete(t),c.item.handle!==l.item.handle&&this.j.delete(l.item.handle),this.ob(t,c);const m=this.X(g)||[],$=m.filter(S=>S.item.handle===l.item.handle)[0];$&&m.splice(m.indexOf($),1,c)}qb(t,c){c?(c.children||(c.children=[]),c.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const c=this.m.get(t);if(c){if(c.children)for(const l of c.children){const g=this.j.get(l.item.handle);g&&this.sb(g)}c.children=void 0}}else this.tb()}sb(t){const c=this.m.get(t);if(c){if(c.children)for(const l of c.children){const g=this.j.get(l.item.handle);g&&this.sb(g)}this.m.delete(t),this.j.delete(c.item.handle),c.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[304],Ie([1,0,6,4,2,37,8,68,5,7]),function(oe,e,v,k,C,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Soc=void 0,A=qe(A),p=qe(p),a=qe(a);class P extends k.$Wc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(d,n,s,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new v.$me),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$me),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=n,this.#n=s,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,C.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(d){this.#l||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#u=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,n){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:A.ViewColumn.from(d),preserveFocus:!!n})}c(){if(this.#l)throw new Error("Webview is disposed")}}class y extends k.$Wc{static c(){return(0,O.$2g)()}constructor(d,n,s){super(),this.j=n,this.m=s,this.g=new Map,this.h=new Map,this.f=d.getProxy(p.$uN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,n,s,o,h={}){const i=typeof o=="object"?o.viewColumn:o,r={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},t=(0,T.$Ooc)(d),c=y.c();this.f.$createWebviewPanel((0,T.$Qoc)(d),c,n,{title:s,panelOptions:u(h),webviewOptions:(0,T.$Roc)(d,this.m,h),serializeBuffersForPostMessage:t},r);const l=this.j.createNewWebview(c,h,d);return this.createNewWebviewPanel(c,n,s,i,h,l,!0)}$onDidChangeWebviewPanelViewStates(d){const n=Object.keys(d);n.sort((s,o)=>{const h=d[s],i=d[o];return h.active?1:i.active?-1:+h.visible-+i.visible});for(const s of n){const o=this.getWebviewPanel(s);if(!o)continue;const h=d[s];o._updateViewState({active:h.active,visible:h.visible,viewColumn:A.ViewColumn.to(h.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,n,s){if(this.h.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.h.set(n,{serializer:s,extension:d}),this.f.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.$Ooc)(d)}),new a.$wN(()=>{this.h.delete(n),this.f.$unregisterSerializer(n)})}async $deserializeWebviewPanel(d,n,s,o){const h=this.h.get(n);if(!h)throw new Error(`No serializer found for '${n}'`);const{serializer:i,extension:r}=h,t=this.j.createNewWebview(d,s.webviewOptions,r),c=this.createNewWebviewPanel(d,n,s.title,o,s.panelOptions,t,s.active);await i.deserializeWebviewPanel(c,s.state)}createNewWebviewPanel(d,n,s,o,h,i,r){const t=new P(d,this.f,i,{viewType:n,title:s,viewColumn:o,panelOptions:h,active:r});return this.g.set(d,t),t}getWebviewPanel(d){return this.g.get(d)}}e.$Soc=y;function u(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Ce[305],Ie([1,0,6,4,68,8,5,7]),function(oe,e,v,k,C,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oqc=void 0,A=qe(A),T=qe(T);class p extends k.$Wc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,u,E,d,n,s){super(),this.#s=!1,this.#u=this.B(new v.$me),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new v.$me),this.onDidDispose=this.#l.event,this.#i=E,this.#a=d,this.#e=y,this.#t=u,this.#n=n,this.#r=s}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class a{constructor(y,u){this.d=u,this.b=new Map,this.c=new Map,this.a=y.getProxy(A.$uN.MainThreadWebviewViews)}registerWebviewViewProvider(y,u,E,d){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:E,extension:y}),this.a.$registerWebviewViewProvider((0,C.$Qoc)(y),u,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Ooc)(y)}),new T.$wN(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(y,u,E,d,n){const s=this.b.get(u);if(!s)throw new Error(`No view provider found for '${u}'`);const{provider:o,extension:h}=s,i=this.d.createNewWebview(y,{},h),r=new p(y,this.a,u,E,i,!0);this.c.set(y,r),await o.resolveWebviewView(r,{state:d},n)}async $onDidChangeWebviewViewVisibility(y,u){this.e(y)._setVisible(u)}async $disposeWebviewView(y){const u=this.e(y);this.c.delete(y),u.dispose(),this.d.deleteWebview(y)}e(y){const u=this.c.get(y);if(!u)throw new Error("No webview found");return u}}e.$oqc=a}),define(Ce[306],Ie([1,0,6,31,32,3]),function(oe,e,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.OutputChannelUpdateMode=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=void 0,e.$CM="text/x-code-output",e.$DM="output",e.$EM="Log",e.$FM="text/x-code-log-output",e.$GM="log",e.$HM="workbench.panel.output",e.$IM=new C.$Wj("inOutput",!1),e.$JM=new C.$Wj("activeLogOutput",!1),e.$KM=new C.$Wj("activeLogOutput.levelSettable",!1),e.$LM=new C.$Wj("activeLogOutput.level",""),e.$MM=new C.$Wj("activeLogOutput.levelIsDefault",!1),e.$NM=new C.$Wj("outputView.scrollLock",!1),e.$OM=(0,O.$Fi)("outputService");var A;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$PM={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new v.$me,this.onDidRegisterChannel=this.b.event,this.c=new v.$me,this.onDidRemoveChannel=this.c.event}registerChannel(a){this.a.has(a.id)||(this.a.set(a.id,a),this.b.fire(a.id))}getChannels(){const a=[];return this.a.forEach(P=>a.push(P)),a}getChannel(a){return this.a.get(a)}removeChannel(a){this.a.delete(a),this.c.fire(a)}}k.$qo.add(e.$PM.OutputChannels,new T),e.$QM=new C.$Wj("activeOutputChannel","")}),define(Ce[128],Ie([1,0,5,3,17,19,12,306,69,27,51,158,23,15,30,6,4]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=e.$4pc=void 0;class o extends A.$fk{get disposed(){return this.n}constructor(t,c,l,g,m){super(),this.id=t,this.name=c,this.r=l,this.s=g,this.extension=m,this.m=0,this.n=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel($=>this.setLevel($)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,t)}replace(t){const c=this.m;this.info(t),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,c),this.visible&&this.r.flush()}show(t,c){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:c))}hide(){this.s.$close(this.id)}g(t,c){this.m+=u.$Oe.fromString(c).byteLength,(0,A.log)(this.r,t,c),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class h extends o{appendLine(t){this.append(t)}}let i=class{constructor(t,c,l,g,m,$){this.i=c,this.j=l,this.k=g,this.l=m,this.m=$,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(v.$uN.MainThreadOutputService),this.b=this.k.extUri.joinPath(c.logsLocation,`output_logging_${(0,y.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[c,l]of this.g)l.visible=c===this.h}createOutputChannel(t,c,l){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const g=typeof c=="object"&&c.log,m=(0,E.$fg)(c)?c:void 0;if((0,E.$fg)(m)&&!m.trim())throw new Error("illegal argument `languageId`. must not be empty");let $;const S=this.i.environment.extensionLogLevel?.find(([b])=>O.$qn.equals(l.identifier,b))?.[1];S&&($=(0,A.$qk)(S));const D=g?this.o(t,$,l):this.n(t,m,l);return D.then(b=>{this.g.set(b.id,b),b.visible=b.id===this.h}),g?this.r(t,$??this.m.getLevel(),D):this.q(t,D)}async n(t,c,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const g=await this.c,m=this.k.extUri.joinPath(g,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),$=this.l.createLogger(m,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(t,m,c,l.identifier.value);return new o(S,t,$,this.a,l)}async o(t,c,l){const g=await this.p(l),m=t.replace(/[\\/:\*\?"<>\|]/g,""),$=this.k.extUri.joinPath(g,`${m}.log`),S=`${l.identifier.value}.${m}`,D=this.l.createLogger($,{id:S,name:t,logLevel:c,extensionId:l.identifier.value});return new h(S,t,D,this.a,l)}p(t){let c=this.d.get(t.identifier.value);if(!c){const l=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,c=(async()=>{try{await this.j.value.createDirectory(l)}catch(g){if((0,d.$pl)(g)!==d.FileSystemProviderErrorCode.FileExists)throw g}return l})())}return c}q(t,c){let l=!1;const g=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return t},append(m){g(),c.then($=>$.append(m))},appendLine(m){g(),c.then($=>$.appendLine(m))},clear(){g(),c.then(m=>m.clear())},replace(m){g(),c.then($=>$.replace(m))},show(m,$){g(),c.then(S=>S.show(m,$))},hide(){g(),c.then(m=>m.hide())},dispose(){l=!0,c.then(m=>m.dispose())}}}r(t,c,l){const g=new s.$Vc,m=()=>{if(g.isDisposed)throw new Error("Channel has been closed")},$=g.add(new n.$me);function S(D){c=D,$.fire(D)}return l.then(D=>{g.add(D),D.logLevel!==c&&S(D.logLevel),g.add(D.onDidChangeLogLevel(b=>S(b)))}),{...this.q(t,l),get logLevel(){return c},onDidChangeLogLevel:$.event,trace(D,...b){m(),l.then(I=>I.trace(D,...b))},debug(D,...b){m(),l.then(I=>I.debug(D,...b))},info(D,...b){m(),l.then(I=>I.info(D,...b))},warn(D,...b){m(),l.then(I=>I.warn(D,...b))},error(D,...b){m(),l.then(I=>I.error(D,...b))},dispose(){g.dispose()}}}};e.$4pc=i,e.$4pc=i=Qe([Ve(0,C.$1P),Ve(1,a.$eQ),Ve(2,p.$Koc),Ve(3,P.$noc),Ve(4,A.$ak),Ve(5,A.$_j)],i),e.$5pc=(0,k.$Fi)("IExtHostOutputService")}),define(Ce[129],Ie([1,0,3,11]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0,e.$Vm=(0,v.$Fi)("remoteAgentService"),e.$Wm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let O=1/0;for(let T=0;T<this.maxSampleCount;T++){const p=await C.getRoundTripTime();if(p===void 0)return;O=Math.min(O,p/2),await(0,k.$Gh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(O):A=this.initial.reduce((T,p)=>T+p,0)/this.initial.length,this.lastMeasurement={initial:A,current:O,average:this.average.reduce((T,p)=>T+p,0)/this.average.length,high:typeof A>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[307],Ie([1,0,193,54,31,50,43,4,6,129,21,26,11,114]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=void 0,e.$7K=Object.freeze({id:"application",order:100,title:(0,v.localize)(0,null),type:"object"}),e.$8K=Object.freeze({id:"workbench",order:7,title:(0,v.localize)(1,null),type:"object"}),e.$9K=Object.freeze({id:"security",scope:k.ConfigurationScope.APPLICATION,title:(0,v.localize)(2,null),type:"object",order:7}),e.$0K=Object.freeze({id:"problems",title:(0,v.localize)(3,null),type:"object",order:101}),e.$$K=Object.freeze({id:"window",order:8,title:(0,v.localize)(4,null),type:"object"}),e.$_K={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new p.$me,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const n=new d;C.$qo.add(e.$_K.ConfigurationMigration,n);let s=class extends T.$Wc{static{this.ID="workbench.contrib.configurationMigration"}constructor(r,t){super(),this.a=r,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const l of c.added)await this.f(l,n.migrations)})),this.c(n.migrations),this.B(n.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(r){await this.f(void 0,r);for(const t of this.b.getWorkspace().folders)await this.f(t,r)}async f(r,t){await Promise.all([t.map(c=>this.g(c,r?.uri))])}async g(r,t){const c=this.a.inspect(r.key,{resource:t}),l=this.b.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[g,m]of l){const $=c[g];if(!$)continue;const S=[];if($.value!==void 0){const D=await this.h(r,g,$.value,t,void 0);for(const b of D??[])S.push([b,[]])}for(const{identifiers:D,value:b}of $.overrides??[])if(b!==void 0){const I=await this.h(r,g,b,t,D);for(const R of I??[])S.push([R,D])}S.length&&await Promise.allSettled(S.map(async([[D,b],I])=>this.a.updateValue(D,b.value,{resource:t,overrideIdentifiers:I},m)))}}async h(r,t,c,l,g){const m=S=>{const b=this.a.inspect(S,{resource:l})[t];if(b)return g?b.overrides?.find(({identifiers:I})=>(0,y.$ho)(I,g))?.value:b.value},$=await r.migrateFn(c,m);return Array.isArray($)?$:[[r.key,$]]}};e.$aL=s,e.$aL=s=Qe([Ve(0,A.$_i),Ve(1,O.$Oi)],s);let o=class extends T.$Wc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(r){super(),this.b=r,this.a=new u.$3h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!P.$i&&(await this.b.getEnvironment())?.os!==P.OperatingSystem.Windows)return;C.$qo.as(k.$vo.Configuration).registerConfiguration({...e.$9K,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,v.localize)(5,null)},default:[],markdownDescription:(0,v.localize)(6,null),scope:k.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,v.localize)(7,null),scope:k.ConfigurationScope.MACHINE}}})}};e.$bL=o,e.$bL=o=Qe([Ve(0,a.$Vm)],o),e.$cL="window.newWindowProfile";let h=class extends T.$Wc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(r,t){super(),this.c=r,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(c=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(c=>{c.source!==A.ConfigurationTarget.DEFAULT&&c.affectsConfiguration(e.$cL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const r=C.$qo.as(k.$vo.Configuration),t={...e.$$K,properties:{[e.$cL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(c=>c.name),null],enumItemLabels:[...this.c.profiles.map(c=>""),(0,v.localize)(8,null)],description:(0,v.localize)(9,null),scope:k.ConfigurationScope.APPLICATION}}};this.a?r.updateConfigurations({add:[t],remove:[this.a]}):r.registerConfiguration(t),this.a=t}h(){const r=this.f.getValue(e.$cL);this.b=r?this.c.profiles.find(t=>t.name===r):void 0}j(){const r=this.f.getValue(e.$cL);if(!r)return;const t=this.b?this.c.profiles.find(c=>c.id===this.b.id):void 0;r!==t?.name&&this.f.updateValue(e.$cL,t?.name)}};e.$dL=h,e.$dL=h=Qe([Ve(0,E.$Ll),Ve(1,A.$_i)],h)}),define(Ce[308],Ie([1,0,42,16,20,24,204,307,54,3,31]),function(oe,e,v,k,C,O,A,T,p,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$fL=e.$eL=void 0,e.$gL=n,e.$hL=s,v=qe(v),e.$eL=(0,a.$Fi)("editorResolverService"),e.$fL="workbench.editorAssociations";const y=P.$qo.as(p.$vo.Configuration),u={...T.$8K,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(u);var E;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(E||(e.RegisteredEditorPriority=E={}));var d;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function n(o){switch(o){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function s(o,h){if(new Set([k.Schemas.extension,k.Schemas.webviewPanel,k.Schemas.vscodeWorkspaceTrust,k.Schemas.vscodeSettings]).has(h.scheme))return!1;const t=typeof o=="string"&&o.indexOf(C.$ic.sep)>=0?`${h.scheme}:${h.path}`:(0,O.$dh)(h);return v.$yk(typeof o=="string"?o.toLowerCase():o,t.toLowerCase())}}),define(Ce[309],Ie([1,0,53,16,20,21,24,2,3,227,50,247,129]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=void 0,e.$9M=(0,p.$Fi)("pathService");let d=E=class{constructor(s,o,h,i){this.d=s,this.e=o,this.f=h,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??s})()}hasValidBasename(s,o,h){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(s,i,o)):this.h(s,o,h)}h(s,o,h){return s.scheme===k.Schemas.file||s.scheme===k.Schemas.vscodeRemote?(0,v.$Cg)(h??(0,A.$dh)(s),o===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,o){if(s.remoteAuthority)return k.Schemas.vscodeRemote;const h=(0,a.$6M)(o.getWorkspace());if(h)return h;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:k.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===O.OperatingSystem.Windows?C.$hc:C.$ic)}async fileURI(s){let o="";if(await this.a===O.OperatingSystem.Windows&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const i=s.indexOf("/",2);i===-1?(o=s.substring(2),s="/"):(o=s.substring(2,i),s=s.substring(i)||"/")}return T.URI.from({scheme:k.Schemas.file,authority:o,path:s,query:"",fragment:""})}};e.$0M=d,e.$0M=d=E=Qe([Ve(1,u.$Vm),Ve(2,y.$RM),Ve(3,P.$Oi)],d)}),define(Ce[130],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$KL=e.$JL=void 0;class v{constructor(A,T){this.line=A,this.character=T}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,T){return new v(0,0)}with(A){return new v(0,0)}}e.$JL=v;class k{constructor(A,T,p,a){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(A,T),this.end=new v(p,a)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new k(0,0,0,0)}with(A){return new k(0,0,0,0)}}e.$KL=k;var C;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ce[44],Ie([1,0,18,42,26,53,13,3,20,14,130,11]),function(oe,e,v,k,C,O,A,T,p,a,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$9L=e.$2L=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$YL=e.$XL=e.$WL=e.$VL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.TextSearchCompleteMessageType=void 0,e.$SL=o,e.$TL=h,e.$UL=i,e.$ZL=D,e.$1L=b,e.$3L=f,e.$4L=w,e.$5L=M,e.$6L=N,e.$7L=L,e.$8L=G,e.$0L=F,e.$_L=$e,e.$aM=_,k=qe(k),C=qe(C),O=qe(O),p=qe(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$LL="workbench.view.search",e.$ML="workbench.panel.search",e.$NL="workbench.view.search",e.$OL="search-result",e.$PL="search.exclude",e.$QL=2e4;const u="\u27EA ",E=" characters skipped \u27EB",d=(u.length+E.length+5)*2;e.$RL=(0,T.$Fi)("searchService");var n;(function(se){se[se.file=0]="file",se[se.text=1]="text",se[se.aiText=2]="aiText"})(n||(e.SearchProviderType=n={}));var s;(function(se){se[se.File=1]="File",se[se.Text=2]="Text",se[se.aiText=3]="aiText"})(s||(e.QueryType=s={}));function o(se){return!!se.preview}function h(se){return!!se.resource}function i(se){return!!se.message}var r;(function(se){se[se.Normal=0]="Normal",se[se.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class t{constructor(ce){this.resource=ce,this.results=[]}}e.$VL=t;class c{constructor(ce,we,re,Pe){this.ranges=we,this.webviewIndex=Pe;const Me=Array.isArray(we)?we:[we];if(re&&re.matchLines===1&&l(Me)){ce=(0,A.$$f)(ce,re.matchLines);let Y="",q=0,ee=0;const ve=Math.floor(re.charsPerLine/5),ue=[];for(const be of Me){const de=Math.max(be.startColumn-ve,0),X=be.startColumn+re.charsPerLine;if(de>ee+ve+d){const Z=u+(de-ee)+E;Y+=Z+ce.slice(de,X),q+=de-(ee+Z.length)}else Y+=ce.slice(ee,X);ue.push(new m(0,be.startColumn-q,be.endColumn-q)),ee=X}this.preview={text:Y,matches:Array.isArray(this.ranges)?ue:ue[0]}}else{const Y=Array.isArray(we)?we[0].startLineNumber:we.startLineNumber;this.preview={text:ce,matches:(0,v.$3b)(we,q=>new g(q.startLineNumber-Y,q.startColumn,q.endLineNumber-Y,q.endColumn))}}}}e.$WL=c;function l(se){const ce=se[0].startLineNumber;for(const we of se)if(we.startLineNumber!==ce||we.endLineNumber!==ce)return!1;return!0}class g{constructor(ce,we,re,Pe){this.startLineNumber=ce,this.startColumn=we,this.endLineNumber=re,this.endColumn=Pe}}e.$XL=g;class m extends g{constructor(ce,we,re){super(ce,we,ce,re)}}e.$YL=m;var $;(function(se){se.List="list",se.Tree="tree"})($||(e.ViewMode=$={}));var S;(function(se){se.Default="default",se.FileNames="fileNames",se.Type="type",se.Modified="modified",se.CountDescending="countDescending",se.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function D(se,ce=!0){const we=se&&se.files&&se.files.exclude,re=ce&&se&&se.search&&se.search.exclude;if(!we&&!re)return;if(!we||!re)return we||re;let Pe=Object.create(null);return Pe=C.$go(Pe,C.$do(we)),Pe=C.$go(Pe,C.$do(re),!0),Pe}function b(se,ce){return se.excludePattern&&k.$yk(se.excludePattern,ce)?!1:se.includePattern||se.usingSearchPaths?se.includePattern&&k.$yk(se.includePattern,ce)?!0:se.usingSearchPaths?!!se.folderQueries&&se.folderQueries.some(we=>{const re=we.folder.fsPath;if(O.$Eg(ce,re)){const Pe=p.$nc(re,ce);return!we.includePattern||!!k.$yk(we.includePattern,Pe)}else return!1}):!1:!0}var I;(function(se){se[se.unknownEncoding=1]="unknownEncoding",se[se.regexParseError=2]="regexParseError",se[se.globParseError=3]="globParseError",se[se.invalidLiteral=4]="invalidLiteral",se[se.rgProcessError=5]="rgProcessError",se[se.other=6]="other",se[se.canceled=7]="canceled"})(I||(e.SearchErrorCode=I={}));class R extends Error{constructor(ce,we){super(ce),this.code=we}}e.$2L=R;function f(se){const ce=se.message;if((0,a.$6)(se))return new R(ce,I.canceled);try{const we=JSON.parse(ce);return new R(we.message,we.code)}catch{return new R(ce,I.other)}}function w(se){const ce={message:se.message,code:se.code};return new Error(JSON.stringify(ce))}function M(se){return se.type==="error"?!0:se.type==="success"}function N(se){return se.type==="success"}function L(se){return!!se.path}function G(se,ce,we=!0){const re=se.searchPath?se.searchPath:se.relativePath;return we?(0,A.$8f)(re,ce):k.$yk(ce,re)}class W{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$9L=W;function F(se,ce){const we={...se||{},...ce||{}};return Object.keys(we).filter(re=>{const Pe=we[re];return typeof Pe=="boolean"&&Pe})}class V{constructor(ce,we){this.c=null,this.a={...ce.excludePattern||{},...we.excludePattern||{}},this.b=k.$zk(this.a);let re=ce.includePattern;we.includePattern&&(re?re={...re,...we.includePattern}:re=we.includePattern),re&&(this.c=k.$zk(re))}matchesExcludesSync(ce,we,re){return!!(this.b&&this.b(ce,we,re))}includedInQuerySync(ce,we,re){return!(this.b&&this.b(ce,we,re)||this.c&&!this.c(ce,we,re))}includedInQuery(ce,we,re){const Pe=this.b(ce,we,re),Me=()=>this.c?!!this.c(ce,we,re):!0;return(0,y.$rh)(Pe)?Pe.then(Y=>Y?!1:Me()):Me()}hasSiblingExcludeClauses(){return ae(this.a)}}e.$$L=V;function ae(se){for(const ce in se)if(typeof se[ce]!="boolean")return!0;return!1}function $e(se){if(!se)return;let ce;return we=>(ce||(ce=(se()||Promise.resolve([])).then(re=>re?ge(re):{})),ce.then(re=>!!re[we]))}function _(se){if(!se)return;let ce;return we=>{if(!ce){const re=se();ce=re?ge(re):{}}return!!ce[we]}}function ge(se){const ce={};for(const we of se)ce[we]=!0;return ce}}),define(Ce[45],Ie([1,0,18,11,22,6,4,59,16,139,24,13,2,192,30,3,12,214,50,51,27,17,8,7,66,44,5,49]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h,i,r,t,c,l,g,m,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=e.$Eoc=void 0;function D(L,G,W){return new P.$8g(F=>f(F,W)).isEqual(L,G)}function b(L,G,W){return D(L.uri,G.uri,W)?0:(0,y.$zf)(L.uri.toString(),G.uri.toString())}function I(L,G,W){return L.index!==G.index?L.index<G.index?-1:1:D(L.uri,G.uri,W)?(0,y.$zf)(L.name,G.name):(0,y.$zf)(L.uri.toString(),G.uri.toString())}function R(L,G,W,F){const V=L.slice(0).sort(($e,_)=>W($e,_,F)),ae=G.slice(0).sort(($e,_)=>W($e,_,F));return(0,v.$Gb)(V,ae,($e,_)=>W($e,_,F))}function f(L,G){const W=G.getCapabilities(L.scheme);return!(W&&W&d.FileSystemProviderCapabilities.PathCaseSensitive)}class w extends h.$Yi{static toExtHostWorkspace(G,W,F,V){if(!G)return{workspace:null,added:[],removed:[]};const{id:ae,name:$e,folders:_,configuration:ge,transient:se,isUntitled:ce}=G,we=[],re=W;W?_.forEach((q,ee)=>{const ve=u.URI.revive(q.uri),ue=w.o(F||W,ve,V);ue?(ue.name=q.name,ue.index=q.index,we.push(ue)):we.push({uri:ve,name:q.name,index:ee})}):we.push(..._.map(({uri:q,name:ee,index:ve})=>({uri:u.URI.revive(q),name:ee,index:ve}))),we.sort((q,ee)=>q.index<ee.index?-1:1);const Pe=new w(ae,$e,we,!!se,ge?u.URI.revive(ge):null,!!ce,q=>f(q,V)),{added:Me,removed:Y}=R(re?re.workspaceFolders:[],Pe.workspaceFolders,b,V);return{workspace:Pe,added:Me,removed:Y}}static o(G,W,F){for(let V=0;V<G.folders.length;V++){const ae=G.workspaceFolders[V];if(D(ae.uri,W,F))return ae}}constructor(G,W,F,V,ae,$e,_){super(G,F.map(ge=>new h.$Zi(ge)),V,ae,_),this.t=W,this.u=$e,this.q=[],this.s=T.$Li.forUris(_,()=>!0),F.forEach(ge=>{this.q.push(ge),this.s.set(ge.uri,ge)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(G,W){return W&&this.s.get(G)&&(G=(0,P.$fh)(G)),this.s.findSubstr(G)}resolveWorkspaceFolder(G){return this.s.get(G)}}let M=class{constructor(G,W,F,V,ae){this.c=new O.$me,this.onDidChangeWorkspace=this.c.event,this.g=new O.$me,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$oe,this.C=new Map,this.h=V,this.s=F,this.t=ae,this.j=new a.$Mm,this.k=new k.$Eh,this.o=G.getProxy($.$uN.MainThreadWorkspace),this.q=G.getProxy($.$uN.MainThreadMessageService);const $e=W.workspace;this.l=$e?new w($e.id,$e.name,[],!!$e.transient,$e.configuration?u.URI.revive($e.configuration):null,!!$e.isUntitled,_=>f(_,F)):void 0}$initializeWorkspace(G,W){this.v=W,this.$acceptWorkspaceData(G),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:p.Schemas.untitled,path:(0,P.$dh)((0,P.$fh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(G,W,F,...V){const ae=[];if(Array.isArray(V)&&V.forEach(ce=>{u.URI.isUri(ce.uri)&&!ae.some(we=>D(we.uri,ce.uri,this.s))&&ae.push({uri:ce.uri,name:ce.name||(0,P.$ch)(ce.uri)})}),this.n||[W,F].some(ce=>typeof ce!="number"||ce<0)||F===0&&ae.length===0)return!1;const $e=this.x?this.x.workspaceFolders:[];if(W+F>$e.length)return!1;const _=$e.slice(0);_.splice(W,F,...ae.map(ce=>({uri:ce.uri,name:ce.name||(0,P.$ch)(ce.uri),index:void 0})));for(let ce=0;ce<_.length;ce++){const we=_[ce];if(_.some((re,Pe)=>Pe!==ce&&D(we.uri,re.uri,this.s)))return!1}_.forEach((ce,we)=>ce.index=we);const{added:ge,removed:se}=R($e,_,I,this.s);if(ge.length===0&&se.length===0)return!1;if(this.o){const ce=G.displayName||G.name;this.o.$updateWorkspaceFolders(ce,W,F,ae).then(void 0,we=>{this.n=void 0;const re={source:{identifier:G.identifier,label:G.displayName||G.name}};this.q.$showMessage(o.Severity.Error,(0,E.localize)(0,null,ce,we.toString()),re,[])})}return this.y(_),!0}getWorkspaceFolder(G,W){if(this.x)return this.x.getWorkspaceFolder(G,W)}async getWorkspaceFolder2(G,W){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(G,W)}async resolveWorkspaceFolder(G){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(G)}getPath(){if(!this.x)return;const{folders:G}=this.x;if(G.length!==0)return G[0].uri.fsPath}getRelativePath(G,W){let F,V="";if(typeof G=="string"?(F=u.URI.file(G),V=G):typeof G<"u"&&(F=G,V=G.fsPath),!F)return V;const ae=this.getWorkspaceFolder(F,!0);if(!ae)return V;typeof W>"u"&&this.x&&(W=this.x.folders.length>1);let $e=(0,P.$ih)(ae.uri,F);return W&&ae.name&&($e=`${ae.name}/${$e}`),$e}y(G){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:G,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(G){const{workspace:W,added:F,removed:V}=w.toExtHostWorkspace(G,this.l,this.n,this.s);this.l=W||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:V}))}findFiles(G,W,F,V,ae=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let $e="",_=!0;return W===null?_=!1:W!==void 0&&(typeof W=="string"?$e=W:$e=W.pattern),this.z(G,void 0,{exclude:$e,maxResults:F,useDefaultExcludes:_,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},ae)}findFiles2(G,W={},F,V=C.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${F.value}, entryPoint: findFiles2`),this.z(void 0,G,W,V)}async z(G,W,F,V=C.CancellationToken.None){if(V&&V.isCancellationRequested)return Promise.resolve([]);const ae=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,$e={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof F.useDefaultSearchExcludes=="boolean"?!F.useDefaultSearchExcludes:!1,maxResults:F.maxResults,excludePattern:ae,shouldGlobSearch:typeof F.fuzzy=="boolean"?!F.fuzzy:!0,_reason:"startFileSearch"};let _;if(G){const{includePattern:ge,folder:se}=N(c.GlobPattern.from(G));_=se,$e.includePattern=ge}else{const{includePattern:ge,folder:se}=N(c.GlobPattern.from(W));_=se,$e.filePattern=ge}return this.o.$startFileSearch(_??null,$e,V).then(ge=>Array.isArray(ge)?ge.map(se=>u.URI.revive(se)):[])}async findTextInFiles(G,W,F,V,ae=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const $e=this.j.getNext(),_=typeof W.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:ge,folder:se}=N(c.GlobPattern.from(W.include)),ce=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,we={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:_,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:ge,excludePattern:ce},re=!1;if(this.u[$e]=Pe=>{if(re)return;const Me=u.URI.revive(Pe.resource);Pe.results.forEach(Y=>{const q=(0,S.$ci)(Y);(0,m.$SL)(q)?F({uri:Me,preview:{text:q.preview.text,matches:(0,v.$3b)(q.preview.matches,ee=>new l.$yN(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))},ranges:(0,v.$3b)(q.ranges,ee=>new l.$yN(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))}):F({uri:Me,text:q.text,lineNumber:q.lineNumber})})},ae.isCancellationRequested)return{};try{const Pe=await this.o.$startTextSearch(G,se??null,we,$e,ae);return delete this.u[$e],Pe||{}}catch(Pe){throw delete this.u[$e],Pe}}$handleTextSearchResult(G,W){this.u[W]?.(G)}async save(G){const W=await this.o.$save(G,{saveAs:!1});return u.URI.revive(W)}async saveAs(G){const W=await this.o.$save(G,{saveAs:!0});return u.URI.revive(W)}saveAll(G){return this.o.$saveAll(G)}resolveProxy(G){return this.o.$resolveProxy(G)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(G){return this.o.$requestWorkspaceTrust(G)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(G,W){if(this.w.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.w.set(G,W);const F=this.t.transformOutgoingScheme(G),V=this.A++;return this.o.$registerEditSessionIdentityProvider(V,F),(0,A.$Uc)(()=>{this.w.delete(G),this.o.$unregisterEditSessionIdentityProvider(V)})}async $getEditSessionIdentifier(G,W){this.h.info("Getting edit session identifier for workspaceFolder",G);const F=await this.resolveWorkspaceFolder(u.URI.revive(G));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const V=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!V),!V)return;const ae=await V.provideEditSessionIdentity(F,W);if(this.h.info("Provider returned edit session identifier: ",ae),!!ae)return ae}async $provideEditSessionIdentityMatch(G,W,F,V){this.h.info("Getting edit session identifier for workspaceFolder",G);const ae=await this.resolveWorkspaceFolder(u.URI.revive(G));if(!ae){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",ae);const $e=this.w.get(ae.uri.scheme);if(this.h.info(`Provider for scheme ${ae.uri.scheme} is defined: `,!!$e),!$e)return;const _=await $e.provideEditSessionIdentityMatch?.(W,F,V);if(this.h.info("Provider returned edit session identifier match result: ",_),!!_)return _}getOnWillCreateEditSessionIdentityEvent(G){return(W,F,V)=>{const ae=function(_){W.call(F,_)};return ae.extension=G,this.B.event(ae,void 0,V)}}async $onWillCreateEditSessionIdentity(G,W,F){const V=await this.resolveWorkspaceFolder(u.URI.revive(G));if(V===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:V},W,async(ae,$e)=>{const _=Date.now();await Promise.resolve(ae),Date.now()-_>F&&this.h.warn("SLOW edit session create-participant",$e.extension.identifier)}),W.isCancellationRequested}registerCanonicalUriProvider(G,W){if(this.C.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.C.set(G,W);const F=this.t.transformOutgoingScheme(G),V=this.A++;return this.o.$registerCanonicalUriProvider(V,F),(0,A.$Uc)(()=>{this.C.delete(G),this.o.$unregisterCanonicalUriProvider(V)})}async provideCanonicalUri(G,W,F){const V=this.C.get(G.scheme);if(!V)return;const ae=await V.provideCanonicalUri?.(u.URI.revive(G),W,F);if(ae)return ae}async $provideCanonicalUri(G,W,F){return this.provideCanonicalUri(u.URI.revive(G),{targetScheme:W},F)}};e.$Eoc=M,e.$Eoc=M=Qe([Ve(0,t.$1P),Ve(1,r.$eQ),Ve(2,i.$noc),Ve(3,s.$_j),Ve(4,g.$Coc)],M),e.$Foc=(0,n.$Fi)("IExtHostWorkspace");function N(L){let G,W;return L&&(typeof L=="string"?G=L:(G=L.pattern,W=u.URI.revive(L.baseUri))),{includePattern:G,folder:W}}}),define(Ce[46],Ie([1,0,26,6,45,5,7,43,215,54,15,11,3,17,12,2]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ioc=e.$Hoc=e.$Goc=void 0;function s(g,m){if(m){const $=m.split(".");let S=g;for(let D=0;S&&D<$.length;D++)S=S[$[D]];return S}}function o(g){return g instanceof n.URI}function h(g){return g&&g.uri instanceof n.URI&&g.languageId&&typeof g.languageId=="string"}function i(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function r(g){return g&&g.uri instanceof n.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function t(g){if(o(g))return{resource:g};if(h(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(i(g))return{overrideIdentifier:g.languageId};if(r(g))return{resource:g.uri};if(g===null)return{resource:null}}let c=class{constructor(m,$,S){this.a=m.getProxy(O.$uN.MainThreadConfiguration),this.c=$,this.b=S,this.d=new y.$Eh,this.e=null}getConfigProvider(){return this.d.wait().then(m=>this.e)}$initializeConfiguration(m){this.e=new l(this.a,this.c,m,this.b),this.d.open()}$acceptConfigurationChanged(m,$){this.getConfigProvider().then(S=>S.$acceptConfigurationChanged(m,$))}};e.$Goc=c,e.$Goc=c=Qe([Ve(0,E.$1P),Ve(1,C.$Foc),Ve(2,d.$_j)],c);class l{constructor(m,$,S,D){this.a=new k.$me,this.b=m,this.f=D,this.c=$,this.e=p.$Oo.parse(S,D),this.d=this.k(S.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(m,$){const S={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Oo.parse(m,this.f),this.d=this.k(m.configurationScopes),this.a.fire(this.j($,S))}getConfiguration(m,$,S){const D=t($)||{},b=this.g(m?s(this.e.getValue(void 0,D,this.c.workspace),m):this.e.getValue(void 0,D,this.c.workspace));m&&this.h(m,D,S?.identifier);function I(f){if(f==null)return null;if(typeof f=="boolean")return f?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(f){case A.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const R={has(f){return typeof s(b,f)<"u"},get:(f,w)=>{this.h(m?`${m}.${f}`:f,D,S?.identifier);let M=s(b,f);if(typeof M>"u")M=w;else{let N;const L=(G,W)=>{if((0,P.$hg)(G)){let F;const V=()=>{N=N||(0,v.$do)(b),F=F||s(N,W)};return new Proxy(G,{get:(ae,$e)=>{if(typeof $e=="string"&&$e.toLowerCase()==="tojson")return V(),()=>F;if(N)return F=F||s(N,W),F[$e];const _=ae[$e];return typeof $e=="string"?L(_,`${W}.${$e}`):_},set:(ae,$e,_)=>(V(),F&&(F[$e]=_),!0),deleteProperty:(ae,$e)=>(V(),F&&delete F[$e],!0),defineProperty:(ae,$e,_)=>(V(),F&&Object.defineProperty(F,$e,_),!0)})}return Array.isArray(G)?(0,v.$do)(G):G};M=L(M,f)}return M},update:(f,w,M,N)=>{f=m?`${m}.${f}`:f;const L=I(M);return w!==void 0?this.b.$updateConfigurationOption(L,f,w,D,N):this.b.$removeConfigurationOption(L,f,D,N)},inspect:f=>{f=m?`${m}.${f}`:f;const w=this.e.inspect(f,D,this.c.workspace);if(w)return{key:f,defaultValue:(0,v.$do)(w.policy?.value??w.default?.value),globalValue:(0,v.$do)(w.user?.value??w.application?.value),workspaceValue:(0,v.$do)(w.workspace?.value),workspaceFolderValue:(0,v.$do)(w.workspaceFolder?.value),defaultLanguageValue:(0,v.$do)(w.default?.override),globalLanguageValue:(0,v.$do)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,v.$do)(w.workspace?.override),workspaceFolderLanguageValue:(0,v.$do)(w.workspaceFolder?.override),languageIds:(0,v.$do)(w.overrideIdentifiers)}}};return typeof b=="object"&&(0,v.$go)(R,b,!1),Object.freeze(R)}g(m){const $=S=>(0,P.$hg)(S)?new Proxy(S,{get:(D,b)=>$(D[b]),set:(D,b,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(D,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(D,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):S;return $(m)}h(m,$,S){const D=a.$Fo.test(m)?a.ConfigurationScope.RESOURCE:this.d.get(m),b=S?`[${S.value}] `:"";if(a.ConfigurationScope.RESOURCE===D){typeof $?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${m}', provide the URI of a resource or 'null' for any resource.`);return}if(a.ConfigurationScope.WINDOW===D){$?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${m}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(m,$){const S=new p.$Qo(m,$,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,b)=>S.affectsConfiguration(D,t(b))})}k(m){return m.reduce(($,S)=>($.set(S[0],S[1]),$),new Map)}}e.$Hoc=l,e.$Ioc=(0,u.$Fi)("IExtHostConfiguration")}),define(Ce[131],Ie([1,0,2,11,6,5,7,45,58,46,22,57,17,27,3,16,21,12,85,251,14]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fqc=e.$eqc=e.$dqc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,A=qe(A),s=qe(s);var t;(function(N){function L(W){if(W!=null)return W}N.from=L;function G(W){if(W!=null)return W}N.to=G})(t||(t={}));var c;(function(N){function L(W){if(W!=null)return W}N.from=L;function G(W){if(W!=null)return W}N.to=G})(c||(c={}));var l;(function(N){function L(W){if(W!=null)return W}N.from=L;function G(W){if(W!=null)return W}N.to=G})(l||(l={}));var g;(function(N){function L(F){if(F){const V=F;return V&&!!V.process}else return!1}N.is=L;function G(F){if(F==null)return;const V={process:F.process,args:F.args};return F.options&&(V.options=l.from(F.options)),V}N.from=G;function W(F){if(F!=null)return new A.$gO(F.process,F.args,F.options)}N.to=W})(g||(g={}));var m;(function(N){function L(W){if(W!=null)return W}N.from=L;function G(W){if(W!=null)return W}N.to=G})(m||(m={}));var $;(function(N){function L(F){if(F){const V=F;return V&&(!!V.commandLine||!!V.command)}else return!1}N.is=L;function G(F){if(F==null)return;const V={};return F.commandLine!==void 0?V.commandLine=F.commandLine:(V.command=F.command,V.args=F.args),F.options&&(V.options=m.from(F.options)),V}N.from=G;function W(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new A.$hO(F.commandLine,F.options):new A.$hO(F.command,F.args?F.args:[],F.options)}N.to=W})($||($={}));var S;(function(N){function L(F){if(F){const V=F;return V&&V.customExecution==="customExecution"}else return!1}N.is=L;function G(F){return{customExecution:"customExecution"}}N.from=G;function W(F,V){return V.get(F)}N.to=W})(S||(e.CustomExecutionDTO=S={}));var D;(function(N){function L(G,W){let F;return G.scope!==void 0&&typeof G.scope!="number"?F=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===A.TaskScope.Workspace&&W&&W.workspaceFile?F=W.workspaceFile:F=i.$II),{id:G._id,workspaceFolder:F}}N.from=L})(D||(e.TaskHandleDTO=D={}));var b;(function(N){function L(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}N.from=L})(b||(b={}));var I;(function(N){function L(F,V){if(F==null)return[];const ae=[];for(const $e of F){const _=G($e,V);_&&ae.push(_)}return ae}N.fromMany=L;function G(F,V){if(F==null)return;let ae;F.execution instanceof A.$gO?ae=g.from(F.execution):F.execution instanceof A.$hO?ae=$.from(F.execution):F.execution&&F.execution instanceof A.$iO&&(ae=S.from(F.execution));const $e=t.from(F.definition);let _;return F.scope?typeof F.scope=="number"?_=F.scope:_=F.scope.uri:_=A.TaskScope.Workspace,!$e||!_?void 0:{_id:F._id,definition:$e,name:F.name,source:{extensionId:V.identifier.value,label:F.source,scope:_},execution:ae,isBackground:F.isBackground,group:b.from(F.group),presentationOptions:c.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}N.from=G;async function W(F,V,ae){if(F==null)return;let $e;g.is(F.execution)?$e=g.to(F.execution):$.is(F.execution)?$e=$.to(F.execution):S.is(F.execution)&&($e=S.to(F._id,ae));const _=t.to(F.definition);let ge;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?ge=F.source.scope:ge=await V.resolveWorkspaceFolder(v.URI.revive(F.source.scope)):ge=A.TaskScope.Workspace),!_||!ge)return;const se=new A.$jO(_,ge,F.name,F.source.label,$e,F.problemMatchers);return F.isBackground!==void 0&&(se.isBackground=F.isBackground),F.group!==void 0&&(se.group=A.$fO.from(F.group._id),se.group&&F.group.isDefault&&(se.group=new A.$fO(se.group.id,se.group.label),F.group.isDefault===!0&&(se.group.isDefault=F.group.isDefault))),F.presentationOptions&&(se.presentationOptions=c.to(F.presentationOptions)),F._id&&(se._id=F._id),F.detail&&(se.detail=F.detail),se}N.to=W})(I||(e.TaskDTO=I={}));var R;(function(N){function L(W){return W}N.from=L;function G(W){if(W)return Object.assign(Object.create(null),W)}N.to=G})(R||(R={}));class f{#e;constructor(L,G,W){this._id=G,this.a=W,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let w=class{constructor(L,G,W,F,V,ae,$e,_){this.q=new C.$me,this.r=new C.$me,this.s=new C.$me,this.u=new C.$me,this.a=L.getProxy(O.$uN.MainThreadTask),this.b=W,this.c=F,this.d=V,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=$e,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,G,W){if(!W)return new A.$wN(()=>{});const F=this.x();return this.j.set(F,{type:G,provider:W,extension:L}),this.a.$registerTaskProvider(F,G),new A.$wN(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(L,G){this.a.$registerTaskSystem(L,G)}fetchTasks(L){return this.a.$fetchTasks(R.from(L)).then(async G=>{const W=[];for(const F of G){const V=await I.to(F,this.b,this.m);V&&W.push(V)}return W})}get taskExecutions(){const L=[];return this.k.forEach(G=>L.push(G)),L}terminateTask(L){if(!(L instanceof f))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,G,W){const F=this.m.get(L.id);F&&(this.o.set(L.id,F),this.e.attachPtyToTerminal(G,await F.callback(W))),this.p=L.id,this.q.fire({execution:await this.z(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){if(!this.l.has(L.id))return;const G=await this.z(L);this.l.delete(L.id),this.k.delete(L.id),this.B(L),this.r.fire({execution:G})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const G=await this.z(L.id);this.s.fire({execution:G,processId:L.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(L){const G=await this.z(L.id);this.u.fire({execution:G,exitCode:L.exitCode})}$provideTasks(L,G){const W=this.j.get(L);if(!W)return Promise.reject(new Error("no handler found"));const F=[],V=(0,k.$xh)(()=>W.provider.provideTasks(P.CancellationToken.None)).then(ae=>this.v(G,F,W,ae));return new Promise(ae=>{V.then($e=>{Promise.all(F).then(()=>{ae($e)})})})}async $resolveTask(L,G){const W=this.j.get(L);if(!W)return Promise.reject(new Error("no handler found"));if(G.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${W.type}].`);const F=await I.to(G,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const V=await W.provider.resolveTask(F,P.CancellationToken.None);if(!V)return;this.A(V,W);const ae=I.from(V,W.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return S.is(ae.execution)&&await this.y(ae,V,!0),await this.w(ae)}x(){return this.h++}async y(L,G,W){const F=await this.a.$createTaskId(L);!W&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,G.execution)),this.m.set(F,G.execution)}async z(L,G){if(typeof L=="string"){const V=this.l.get(L);if(!V)throw new r.$db("Unexpected: The specified task is missing an execution");return V}const W=this.l.get(L.id);if(W)return W;let F;return G?F=Promise.resolve(new f(this,L.id,G)):F=I.to(L.task,this.b,this.m).then(V=>{if(!V)throw new r.$db("Unexpected: Task does not exist.");return new f(this,L.id,V)}),this.l.set(L.id,F),F.then(V=>(this.k.set(L.id,V),V))}A(L,G){L._deprecated&&this.g.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}B(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const W=this.n.values();let F=W.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=W.next()}};e.$dqc=w,e.$dqc=w=Qe([Ve(0,u.$1P),Ve(1,E.$eQ),Ve(2,T.$Foc),Ve(3,p.$_P),Ve(4,a.$Ioc),Ve(5,y.$7oc),Ve(6,o.$_j),Ve(7,h.$joc)],w);let M=class extends w{constructor(L,G,W,F,V,ae,$e,_){super(L,G,W,F,V,ae,$e,_),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:s.$h(s.Platform.Web)})}async executeTask(L,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const W=I.from(G,L);if(W===void 0)throw new Error("Task is not valid");if(S.is(W.execution))await this.y(W,G,!1);else throw new r.$bb;const F=await this.z(await this.a.$getTaskExecution(W),G);return this.a.$executeTask(W).catch(V=>{throw new Error(V)}),F}v(L,G,W,F){const V=[];if(F)for(const ae of F){if(this.A(ae,W),!ae.definition||!L[ae.definition.type]){const _=ae.source?ae.source:"No task source";this.f.warn(`The task [${_}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`)}const $e=I.from(ae,W.extension);$e&&S.is($e.execution)?(V.push($e),G.push(this.y($e,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:W.extension}}async w(L){if(S.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,G,W){}};e.$eqc=M,e.$eqc=M=Qe([Ve(0,u.$1P),Ve(1,E.$eQ),Ve(2,T.$Foc),Ve(3,p.$_P),Ve(4,a.$Ioc),Ve(5,y.$7oc),Ve(6,o.$_j),Ve(7,h.$joc)],M),e.$fqc=(0,d.$Fi)("IExtHostTask")}),define(Ce[310],Ie([1,0,44,33]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=void 0,e.$gM=C,e.$iM=O;function C(A){return"cellResults"in A}e.$hM="rawCell#";function O(A,T){let p=-1;const a=[];let P=[];return A.forEach(u=>{u.range.startLineNumber!==p&&P.length>0&&(a.push([...P]),P=[]),P.push(u),p=u.range.endLineNumber}),P.length>0&&a.push([...P]),a.map(u=>{const E=[],d=u[0].range.startLineNumber,n=u[u.length-1].range.endLineNumber;for(let s=d;s<=n;s++)E.push(T.getLineContent(s));return new v.$WL(E.join(`
`)+`
`,u.map(s=>new k.$Lt(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}}),define(Ce[311],Ie([1,0,186,23,6,4,29,38,13,15,2,30,80,5,34,8,7,39,288,124,26,16,44,241,310,308]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h,i,r,t,c,l,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=void 0,y=qe(y),n=qe(n),s=qe(s);class ${static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,b,I,R,f,w,M){this.q=I,this.r=R,this.s=f,this.t=w,this.u=M,this.f=new Map,this.g=new A.$Cc,this.h=new Map,this.j=new C.$me,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$me,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$me,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$me,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$hoc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(E.$uN.MainThreadNotebook),this.c=D.getProxy(E.$uN.MainThreadNotebookDocuments),this.d=D.getProxy(E.$uN.MainThreadNotebookEditors),this.i=b.converter,b.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===T.MarshalledId.NotebookCellActionContext){const L=N.notebookEditor?.notebookUri,G=N.cell.handle,F=this.g.get(L)?.getCell(G);if(F)return F.apiCell}if(N&&N.$mid===T.MarshalledId.NotebookActionContext){const L=N.uri,G=this.g.get(L);if(G)return G.apiNotebook}return N}}),$.C(b)}getEditorById(D){const b=this.h.get(D);if(!b)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return b}getIdByEditor(D){for(const[b,I]of this.h)if(I.apiEditor===D)return b}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,b){const I=this.g.get(D);if(!I&&!b)throw new Error(`NO notebook document for '${D}'`);return I}static w(D,b){if(!b)return;const I=b.filenamePattern.map(R=>n.NotebookExclusiveDocumentPattern.from(R)).filter(R=>R!==void 0);if(b.filenamePattern&&!I){console.warn(`Notebook content provider view options file name pattern is invalid ${b.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:b.displayName,filenamePattern:I,priority:b.exclusive?m.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,b,I){const R=$.a++,f=typeof I.onDidChangeCellStatusBarItems=="function"?$.a++:void 0;this.f.set(R,I),this.b.$registerNotebookCellStatusBarItemProvider(R,f,b);let w;return f!==void 0&&(w=I.onDidChangeCellStatusBarItems(M=>this.b.$emitCellStatusBarEvent(f))),new s.$wN(()=>{this.f.delete(R),this.b.$unregisterNotebookCellStatusBarItemProvider(R,f),w?.dispose()})}async createNotebookDocument(D){const b=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&n.NotebookData.from(D.content)});return P.URI.revive(b)}async openNotebookDocument(D){const b=this.g.get(D);if(b)return b.apiNotebook;const I=await this.c.$tryOpenNotebook(D),R=this.g.get(P.URI.revive(I));return(0,a.$qg)(R?.apiNotebook)}async showNotebookDocument(D,b){P.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let I;typeof b=="object"?I={position:n.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selections:b.selections&&b.selections.map(n.NotebookRange.from),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:I={preserveFocus:!1};const R=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,I),f=R&&this.h.get(R)?.apiEditor;if(f)return f;throw R?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,b,I,R){const f=this.f.get(D),w=P.URI.revive(b),M=this.g.get(w);if(!M||!f)return;const N=M.getCellFromIndex(I);if(!N)return;const L=await f.provideCellStatusBarItems(N.apiCell,R);if(!L)return;const G=new O.$Vc,W=this.p.add([G]),V=(Array.isArray(L)?L:[L]).map(ae=>n.NotebookStatusBarItem.from(ae,this.i,G));return{cacheId:W,items:V}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,b,I,R,f){if((0,p.$df)(b))throw new Error("viewType cannot be empty or just whitespace");const w=this.x++;return this.y.set(w,{viewType:b,serializer:I,options:R}),this.b.$registerNotebookSerializer(w,{id:D.identifier,location:D.extensionLocation},b,n.NotebookDocumentContentOptions.from(R),$.w(D,f)),(0,O.$Uc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(D,b,I){const R=this.y.get(D);if(!R)throw new Error("NO serializer found");const f=await R.serializer.deserializeNotebook(b.buffer,I);return new o.$Tw(n.NotebookData.from(f))}async $notebookToData(D,b,I){const R=this.y.get(D);if(!R)throw new Error("NO serializer found");const f=await R.serializer.serializeNotebook(n.NotebookData.to(b.value),I);return k.$Oe.wrap(f)}async $saveNotebook(D,b,I,R,f){const w=P.URI.revive(b),M=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${I}, ${w.toString()})`),!M)throw new Error("NO serializer found");const N=this.g.get(w);if(!N)throw new Error("Document NOT found");if(N.versionId!==I)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new y.$ul((0,v.localize)(0,null,this.A(w)),y.FileOperationResult.FILE_PERMISSION_DENIED);const L={metadata:(0,r.$lo)(N.apiNotebook.metadata,ae=>!(M.options?.transientDocumentMetadata??{})[ae]),cells:[]};for(const ae of N.apiNotebook.getCells()){const $e=new s.$ZO(ae.kind,ae.document.getText(),ae.document.languageId,ae.mime,M.options?.transientOutputs?[]:[...ae.outputs],ae.metadata,ae.executionSummary);$e.metadata=(0,r.$lo)(ae.metadata,_=>!(M.options?.transientCellMetadata??{})[_]),L.cells.push($e)}if(await this.z(w,R),f.isCancellationRequested)throw new Error("canceled");const G=await M.serializer.serializeNotebook(L,f);if(f.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${I} ${w.toString()}`),await this.s.value.writeFile(w,G),this.D(`Finished write versionId: ${I} ${w.toString()}`);const W=this.s.getFileSystemProviderExtUri(w.scheme),F=await this.s.value.stat(w),V={name:W.basename(w),isFile:(F.type&y.FileType.File)!==0,isDirectory:(F.type&y.FileType.Directory)!==0,isSymbolicLink:(F.type&y.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((F.permissions??0)&y.FilePermission.Locked),etag:y.$Fl({mtime:F.mtime,size:F.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${I}, ${w.toString()})`),V}async $searchInNotebooks(D,b,I,R,f){const w=this.y.get(D)?.serializer;if(!w)return{limitHit:!1,results:[]};const M=new A.$Dc;await(async(F,V,ae)=>{await Promise.all(F.map(async $e=>await Promise.all($e.filenamePatterns.map(_=>{const ge={_reason:ae._reason,folderQueries:ae.folderQueries,includePattern:ae.includePattern,excludePattern:ae.excludePattern,maxResults:ae.maxResults,type:c.QueryType.File,filePattern:_};return this.t.doInternalFileSearchWithCustomCallback(ge,V,se=>{se.forEach(ce=>{M.has(ce)||R.some(re=>$e.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(Pe=>(0,m.$hL)(Pe,ce)))||M.add(ce)})}).catch(se=>{if(se.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw se})}))))})(I,f,b);const L=new A.$Cc;let G=!1;const W=Array.from(M).map(async F=>{const V=[];try{if(f.isCancellationRequested)return;if(b.maxResults&&[...L.values()].reduce((ge,se)=>ge+se.cellResults.length,0)>b.maxResults){G=!0;return}const ae=[],$e=this.g.get(F);if($e)$e.apiNotebook.getCells().forEach(se=>ae.push({input:se.document.getText(),outputs:se.outputs.flatMap(ce=>ce.items.map(we=>we.data.toString()))}));else{const ge=await this.s.value.readFile(F),se=k.$Oe.fromString(ge.toString()),ce=await w.deserializeNotebook(se.buffer,f);if(f.isCancellationRequested)return;n.NotebookData.from(ce).cells.forEach(re=>ae.push({input:re.source,outputs:re.outputs.flatMap(Pe=>Pe.items.map(Me=>Me.valueBytes.toString()))}))}if(f.isCancellationRequested)return;ae.forEach((ge,se)=>{const ce=b.contentPattern.pattern,we=new l.$wZb(ge.input,void 0,ge.outputs),re=we.findInInputs(ce),Pe=we.findInOutputs(ce),Me=Pe.flatMap(Y=>(0,g.$iM)(Y.matches,Y.textBuffer)).map((Y,q)=>(Y.webviewIndex=q,Y));if(re.length>0||Pe.length>0){const Y={index:se,contentResults:(0,g.$iM)(re,we.inputTextBuffer),webviewResults:Me};V.push(Y)}});const _={resource:F,cellResults:V};L.set(F,_);return}catch{return}});return await Promise.all(W),{limitHit:G,results:[...L.values()]}}async z(D,b){const I=await this.s.value.stat(D);if(typeof b?.mtime=="number"&&typeof b.etag=="string"&&b.etag!==y.$El&&typeof I.mtime=="number"&&typeof I.size=="number"&&b.mtime<I.mtime&&b.etag!==y.$Fl({mtime:b.mtime,size:I.size}))throw new y.$ul((0,v.localize)(1,null),y.FileOperationResult.FILE_MODIFIED_SINCE,b)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,b,I){if(this.h.has(b))throw new Error(`editor with id ALREADY EXSIST: ${b}`);const R=new i.$Jpc(b,this.d,D,I.visibleRanges.map(n.NotebookRange.to),I.selections.map(n.NotebookRange.to),typeof I.viewColumn=="number"?n.ViewColumn.to(I.viewColumn):void 0);this.h.set(b,R)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const I of D.value.removedDocuments){const R=P.URI.revive(I),f=this.g.get(R);f&&(f.dispose(),this.g.delete(R),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(f.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===R.toString()&&this.h.delete(w.id)}if(D.value.addedDocuments){const I=[];for(const R of D.value.addedDocuments){const f=P.URI.revive(R.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const w=new h.$Ipc(this.c,this.q,this.r,f,R);I.push(...R.cells.map(M=>h.$Hpc.asModelAddData(M))),this.g.get(f)?.dispose(),this.g.set(f,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:I}),this.m.fire(w.apiNotebook)}}if(D.value.addedEditors)for(const I of D.value.addedEditors){if(this.h.has(I.id))return;const R=P.URI.revive(I.documentUri),f=this.g.get(R);f&&this.B(f,I.id,I)}const b=[];if(D.value.removedEditors)for(const I of D.value.removedEditors){const R=this.h.get(I);R&&(this.h.delete(I),this.k?.id===R.id&&(this.k=void 0),b.push(R))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(R=>this.h.get(R)).filter(R=>!!R);const I=new Set;this.l.forEach(R=>I.add(R.id));for(const R of this.h.values()){const f=I.has(R.id);R._acceptVisibility(f)}this.l=[...this.h.values()].map(R=>R).filter(R=>R.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const b=d.$mQ.String.with("notebookType","A notebook type"),I=new d.$oQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[b,new d.$mQ("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>k.$Oe.wrap(f))],new d.$nQ("Notebook Data",f=>n.NotebookData.to(f.value))),R=new d.$oQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[b,new d.$mQ("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new o.$Tw(n.NotebookData.from(f)))],new d.$nQ("Bytes",f=>f.buffer));D.registerApiCommand(I),D.registerApiCommand(R)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$Spc=$}),define(Ce[312],Ie([1,0,20,22,41,42,24,70,44]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=void 0,v=qe(v),O=qe(O),A=qe(A);class a{constructor(u,E,d){this.k=u,this.l=E,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&O.$zk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&O.$zk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const E=this.k.folderQueries||[];return new Promise((d,n)=>{const s=o=>{this.f++,u(o)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const h=o.toString(),i=v.$pc(h);this.j&&this.j(h,i)||this.v(s,{base:o,basename:i})}),Promise.all(E.map(o=>this.p(o,s))).then(o=>{d({limitHit:this.e,stats:o[0]||void 0})},o=>{n(new Error((0,C.$qj)(o)))})})}async p(u,E){const d=new k.$xe,n=this.q(u),s=this.r(),o=new p.$$L(this.k,u),h=!o.hasSiblingExcludeClauses();let i;try{this.h.add(d),i=T.$ge.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,d.token),t=i.elapsed(),c=T.$ge.create();return this.g&&!this.e||(r&&r.forEach(l=>{const g=v.$ic.relative(u.folder.path,l.path);if(h){const m=v.$pc(l.path);this.v(E,{base:u.folder,relativePath:g,basename:m});return}this.s(s,u.folder,g,E)}),this.g&&!this.e)?null:(this.u(s,o,E),{providerTime:t,postProcessTime:c.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(u){const E=(0,p.$0L)(this.k.includePattern,u.includePattern),d=(0,p.$0L)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:d,includes:E,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},E,d,n){if(d===this.a){const o=v.$pc(this.a);this.v(n,{base:E,relativePath:this.a,basename:o})}function s(o){const h=v.$pc(o),i=v.$oc(o);let r=u[i];r||(r=u[i]=[],s(i)),r.push({base:E,relativePath:o,basename:h})}s(d)}u({rootEntries:u,pathToEntries:E},d,n){const s=this,o=this.a;function h(i){const r=(0,p.$aM)(()=>i.map(t=>t.basename));for(let t=0,c=i.length;t<c;t++){const l=i[t],{relativePath:g,basename:m}=l;if(d.matchesExcludesSync(g,m,o!==m?r:void 0))continue;const $=E[g];if($)h($);else{if(g===o)continue;s.v(n,l)}if(s.e)break}}h(u)}v(u,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(E))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,E,d,n){const s=this.c(u.cacheKey),o=new a(u,E,s&&s.token);let h=0;const i=r=>{h+=r.length,d(r.map(t=>this.d(t)))};return this.e(o,P.a,i,n).then(r=>({limitHit:r.limitHit,stats:r.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:r.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new k.$xe),this.b.get(u)}d(u){return u.relativePath?{resource:A.$gh(u.base,u.relativePath)}:{resource:u.base}}e(u,E,d,n){const s=n.onCancellationRequested(()=>{u.cancel()}),o=i=>{i&&(h.push(i),E>0&&h.length>=E&&(d(h),h=[]))};let h=[];return u.search(o).then(i=>(h.length&&d(h),s.dispose(),i),i=>(h.length&&d(h),s.dispose(),Promise.reject(i)))}}e.$Kpc=P}),define(Ce[313],Ie([1,0,18,282,42,103,29,16,20,24,13,15,2,102,206,43,12,50,118,309,44]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0,e.$_M=b,v=qe(v),k=qe(k),C=qe(C),p=qe(p),P=qe(P),d=qe(d);let t=class{constructor(R,f,w,M,N){this.a=R,this.b=f,this.c=w,this.d=M,this.e=N}text(R,f,w={}){R=this.f(R,w);const M=this.a.getValue(),N=f&&f.some(G=>!this.a.getValue({resource:G}).search.useRipgrep);return{...this.h(f?.map(o.$1i),w),type:r.QueryType.Text,contentPattern:R,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:M.search.usePCRE2||N||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles}}f(R,f){const w=this.a.getValue();R.isRegExp&&(R.pattern=R.pattern.replace(/\r?\n/g,"\\n"));const M={...R,wordSeparators:w.editor.wordSeparators};return this.j(R,f)&&(M.isCaseSensitive=!0),this.k(R)&&(M.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=f.notebookSearchConfig.includeMarkupPreview),f.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),M}file(R,f={}){return{...this.h(R,f),type:r.QueryType.File,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey,shouldGlobMatchFilePattern:f.shouldGlobSearch}}g(R,f){return R?(R=Array.isArray(R)?R.map($):$(R),f?this.parseSearchPaths(R):{pattern:l(...Array.isArray(R)?R:[R])}):{}}h(R=[],f={}){const w=this.g(f.includePattern,f.expandPatterns),M=this.g(f.excludePattern,f.expandPatterns),N=R.length>1,L=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(F=>this.q(F,f,M)):R.map(F=>this.r(F,f,M,N))).filter(F=>!!F),G={_reason:f._reason,folderQueries:L,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:M.pattern,includePattern:w.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const F=v.$Jb(this.c.groups.flatMap($e=>$e.editors.map(_=>_.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const V=F.filter($e=>(0,r.$1L)(G,$e.fsPath)),ae=this.i(V);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ae)),{...G,...ae}}const W=f.extraFileResources&&f.extraFileResources.filter(F=>(0,r.$1L)(G,F.fsPath));return G.extraFileResources=W&&W.length?W:void 0,G}i(R){const f=[],w=new A.$Cc,M={};let N=!1;return R.forEach(L=>{if(L.scheme===T.Schemas.walkThrough)return;if((0,a.$kh)(L)){const W=this.b.getWorkspaceFolder(L)?.uri??L.with({path:p.$oc(L.fsPath)});let F=w.get(W);F||(N=!0,F={folder:W,includePattern:{}},f.push(F),w.set(W,F));const V=p.$nc(W.fsPath,L.fsPath);(0,y.$qg)(F.includePattern)[V.replace(/\\/g,"/")]=!0}else L.fsPath&&(N=!0,M[L.fsPath]=!0)}),{folderQueries:f,includePattern:M,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(R,f){if(f.isSmartCase){if(R.isRegExp){if(P.$9f(R.pattern,!0))return!0}else if(P.$9f(R.pattern))return!0}return!!R.isCaseSensitive}k(R){return R.isMultiline||R.isRegExp&&(0,E.$bD)(R.pattern)||R.pattern.indexOf(`
`)>=0?!0:!!R.isMultiline}parseSearchPaths(R){const f=ae=>p.$kc(ae)||/^\.\.?([\/\\]|$)/.test(ae),M=(Array.isArray(R)?R:g(R)).map(ae=>{const $e=this.e.resolvedUserHome;return $e?(0,O.$Yw)(ae,$e.scheme===T.Schemas.file?$e.fsPath:$e.path):ae}),N=k.$K(M,ae=>f(ae)?"searchPaths":"exprSegments"),L=(N.exprSegments||[]).map(ae=>P.$of(ae,"/")).map(ae=>P.$of(ae,"\\")).map(ae=>(ae[0]==="."&&(ae="*"+ae),m(ae))),G={},W=this.m(N.searchPaths||[]);W&&W.length&&(G.searchPaths=W);const F=L.flat(),V=l(...F);return V&&(G.pattern=V),G}l(R,f){return f.disregardExcludeSettings?void 0:(0,r.$ZL)(R,!f.disregardSearchExcludeSettings)}m(R){if(!R||!R.length)return[];const f=R.flatMap(M=>{let{pathPortion:N,globPortion:L}=c(M);return L&&(L=S(L)),this.n(N).flatMap(W=>this.o(W,L))}),w=new Map;return f.forEach(M=>{const N=M.searchPath.toString(),L=w.get(N);L?M.pattern&&(L.pattern=L.pattern||{},L.pattern[M.pattern]=!0):w.set(N,{searchPath:M.searchPath,pattern:M.pattern?l(M.pattern):void 0})}),Array.from(w.values())}n(R){if(p.$kc(R)){const f=this.b.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==T.Schemas.file?[{searchPath:f[0].uri.with({path:R})}]:[{searchPath:u.URI.file(p.$jc(R))}]}if(this.b.getWorkbenchState()===o.WorkbenchState.FOLDER){const f=this.b.getWorkspace().folders[0].uri;if(R=$(R),R.startsWith("../")||R===".."){const M=p.$ic.resolve(f.path,R);return[{searchPath:f.with({path:M})}]}const w=S(R);return[{searchPath:f,pattern:w}]}else{if(R==="./"||R===".\\")return[];{const f=R.replace(/^\.[\/\\]/,""),M=this.b.getWorkspace().folders.map(N=>{const L=f.match(new RegExp(`^${P.$if(N.name)}(?:/(.*)|$)`));return L?{match:L,folder:N}:null}).filter(y.$ng);if(M.length)return M.map(N=>{const L=N.match[1];return{searchPath:N.folder.uri,pattern:L&&S(L)}});{const N=R.match(/\.[\/\\](.+)[\/\\]?/),L=N?N[1]:R,G=d.localize(0,null,L);throw new Error(G)}}}}o(R,f){const w=R.pattern&&f?`${R.pattern}/${f}`:R.pattern||f,M=[{searchPath:R.searchPath,pattern:w}];return w&&!w.endsWith("**")&&M.push({searchPath:R.searchPath,pattern:w+"/**"}),M}q(R,f,w){const M=this.r((0,o.$1i)(R.searchPath),f,w,!1);return M?{...M,includePattern:R.pattern}:null}r(R,f,w,M){let N;const L=u.URI.isUri(R)?R:R.uri;if(w.searchPaths){const ae=w.searchPaths.filter($e=>(0,a.$_g)($e.searchPath,L))[0];if(ae&&!ae.pattern)return null;ae&&(N=ae.pattern)}const G=this.a.getValue({resource:L}),F={...this.l(G,f)||{},...N||{}},V=u.URI.isUri(R)?(0,a.$dh)(R):R.name;return{folder:L,folderName:M?V:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:G.files&&G.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!G.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!G.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!G.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!G.search.followSymlinks}}};e.$$M=t,e.$$M=t=Qe([Ve(0,n.$_i),Ve(1,o.$Oi),Ve(2,h.$jE),Ve(3,s.$_j),Ve(4,i.$9M)],t);function c(I){const R=I.match(/[\*\{\}\(\)\[\]\?]/);if(R){const f=R.index,w=I.substr(0,f).match(/[/|\\][^/\\]*$/);if(w){let M=I.substr(0,w.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:I.substr((w.index||0)+1)}}}return{pathPortion:I}}function l(...I){return I.length?I.reduce((R,f)=>(R[f]=!0,R),Object.create(null)):void 0}function g(I){return C.$xk(I,",").map(R=>R.trim()).filter(R=>!!R.length)}function m(I){return[`**/${I}/**`,`**/${I}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function $(I){return I.replace(/\\/g,"/")}function S(I){return $(I).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(I){return I.replace(/([?*[\]])/g,"[$1]")}function b(I,R){I=v.$Ob(I,M=>M.toString());const f=[],w=R.getWorkspace();return I&&I.forEach(M=>{let N;if(R.getWorkbenchState()===o.WorkbenchState.FOLDER)N=(0,a.$ih)(w.folders[0].uri,M),N&&N!=="."&&(N="./"+N);else{const L=R.getWorkspaceFolder(M);if(L){const G=L.name;if(w.folders.filter(F=>F.name===G).length===1){const F=(0,a.$ih)(L.uri,M);F===""?N=`./${L.name}`:N=`./${L.name}/${F}`}else N=M.fsPath}}N&&f.push(D(N))}),f}}),define(Ce[314],Ie([1,0,24,2,22,14,3,313,44,50,11]),function(oe,e,v,k,C,O,A,T,p,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cyb=u,e.$dyb=n,v=qe(v),O=qe(O);const y=7e3;function u(s,o){const h=o.activationEvents;if(!h)return Promise.resolve(void 0);const i=[],r=[];for(const $ of h)if(/^workspaceContains:/.test($)){const S=$.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||s.forceUsingSearch?r.push(S):i.push(S)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:t,resolve:c}=(0,P.$yh)(),l=$=>c({activationEvent:$}),g=Promise.all(i.map($=>E(s,$,l))).then(()=>{}),m=d(s,o.identifier,r,l);return Promise.all([g,m]).then(()=>{c(void 0)}),t}async function E(s,o,h){for(const i of s.folders)if(await s.exists(v.$gh(k.URI.revive(i),o))){h(`workspaceContains:${o}`);return}}async function d(s,o,h,i){if(h.length===0)return Promise.resolve(void 0);const r=new C.$xe,t=s.checkExists(s.folders,h,r.token),c=setTimeout(async()=>{r.cancel(),s.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},y);let l=!1;try{l=await t}catch(g){O.$6(g)||O.$3(g)}r.dispose(),clearTimeout(c),l&&i(`workspaceContains:${h.join(",")}`)}function n(s,o,h,i){const r=s.get(A.$Ei),t=s.get(p.$RL),l=r.createInstance(T.$$M).file(o.map(g=>(0,a.$1i)(k.URI.revive(g))),{_reason:"checkExists",includePattern:h,exists:!0});return t.fileSearch(l,i).then(g=>!!g.limitHit,g=>O.$6(g)?!1:Promise.reject(g))}}),define(Ce[47],Ie([1,0,182,20,65,24,11,4,59,2,12,5,46,248,89,45,25,119,14,19,23,230,7,110,3,27,92,17,75,93,57,95,6,314,88,232,16,86,70,21,87]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h,i,r,t,c,l,g,m,$,S,D,b,I,R,f,w,M,N,L,G,W,F,V){"use strict";var ae;Object.defineProperty(e,"__esModule",{value:!0}),e.$lpc=e.$kpc=e.$jpc=e.$ipc=e.$hpc=void 0,v=qe(v),k=qe(k),C=qe(C),h=qe(h),e.$hpc=(0,g.$Fi)("IHostUtils");let $e=ae=class extends T.$Wc{constructor(Y,q,ee,ve,ue,be,de,X,Z,me,pe,Oe,ze){super(),this.Y=Oe,this.Z=ze,this.a=this.B(new f.$me),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=q,this.g=ee,this.f=de,this.j=ve,this.m=ue,this.s=be,this.t=Z,this.u=me,this.w=pe,this.y=this.g.getProxy(y.$uN.MainThreadWorkspace),this.z=this.g.getProxy(y.$uN.MainThreadTelemetry),this.C=this.g.getProxy(y.$uN.MainThreadExtensionService),this.D=new A.$Eh,this.F=new A.$Eh,this.G=new A.$Eh,this.H=new A.$Eh,this.I=new Pe(this.f.extensions.activationEvents),this.L=new o.$Kcc(this.I,this.f.extensions.allExtensions);const ke=new i.$rn(this.f.extensions.myExtensions);this.J=new o.$Kcc(this.I,we(this.L,ke)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${se(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${se(this.J)}`)),this.M=new d.$3oc(this.g,this.s),this.N=new M.$apc(this.g),this.O=X,this.h=Y.createChild(new D.$Di([d.$4oc,this.M],[M.$bpc,this.N])),this.P=this.B(new E.$2oc(this.J,this.L,{onExtensionActivationError:(Ae,Ne,j)=>{this.C.$onExtensionActivationError(Ae,h.$5(Ne),j)},actualActivateExtension:async(Ae,Ne)=>{if(o.$Kcc.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,Ne),new E.$1oc;const j=this.J.getExtensionDescription(Ae);return this.fb(j,Ne)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Y){h.$3(Y)}}async $(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(ue=>ue.identifier).filter(ue=>this.isActivated(ue)).map(ue=>this.eb(ue))}catch{}await Promise.all(Y)}terminate(Y,q=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),h.setUnexpectedErrorHandler(ve=>{this.s.error(ve)}),this.g.dispose();const ee=this.$();Promise.race([(0,A.$Gh)(5e3),ee]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const q=await this.C.$getExtension(Y);return q&&{...q,identifier:new i.$qn(q.identifier.value),extensionLocation:a.URI.revive(q.extensionLocation)}}ab(Y,q){return this.P.activateByEvent(Y,q)}bb(Y,q){return this.P.activateById(Y,q)}activateByIdWithErrors(Y,q){return this.bb(Y,q).then(()=>{const ee=this.P.getActivatedExtension(Y);if(ee.activationFailed)return Promise.reject(ee.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async cb(Y){if(Y.scheme===L.Schemas.file&&this.c.fsRealpath){const q=Y.fsPath;this.R.has(q)||this.R.set(q,this.c.fsRealpath(q));const ee=await this.R.get(q);return a.URI.file(ee)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Y=>new re(Y))),this.Q}async db(Y){const q=p.$Li.forUris(ee=>O.$0g.ignorePathCasing(ee));return await Promise.all(Y.map(async ee=>{if(this.wb(ee)){const ve=await this.cb(ee.extensionLocation);q.set(ve,ee)}})),q}eb(Y){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return q;const ee=this.P.getActivatedExtension(Y);if(!ee)return q;try{typeof ee.module.deactivate=="function"&&(q=Promise.resolve(ee.module.deactivate()).then(void 0,ve=>(this.s.error(ve),Promise.resolve(void 0))))}catch(ve){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(ve)}try{(0,T.$Rc)(ee.subscriptions)}catch(ve){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this.s.error(ve)}return q}async fb(Y,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.hb(Y,q).then(ee=>{const ve=ee.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,q),this.gb(Y,q,"success",ve),ee},ee=>{throw this.gb(Y,q,"failure"),ee})}gb(Y,q,ee,ve){const ue=ge(Y,q);this.z.$publicLog2("extensionActivationTimes",{...ue,...ve||{},outcome:ee})}hb(Y,q){const ee=ge(Y,q);this.z.$publicLog2("activatePlugin",ee);const ve=this.wb(Y);if(!ve)return Promise.resolve(new E.$Zoc(E.$Woc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${Y.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const ue=new E.$Xoc(q.startup);return Promise.all([this.xb(Y,(0,O.$gh)(Y.extensionLocation,ve),ue),this.ib(Y)]).then(be=>(C.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),ae.jb(this.s,Y.identifier,be[0],be[1],ue))).then(be=>(C.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),be))}ib(Y){const q=this.Z.createLanguageModelAccessInformation(Y),ee=new t.$6oc(Y,this.M),ve=new t.$5oc(Y.identifier.value,!1,this.M),ue=new N.$cpc(Y,this.N),be=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?c.ExtensionMode.Test:c.ExtensionMode.Development:c.ExtensionMode.Production,de=this.f.remote.isRemote?c.ExtensionKind.Workspace:c.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([ee.whenReady,ve.whenReady,this.O.whenReady]).then(()=>{const X=this;let Z,me;const pe=(0,s.$6G)(Y,"ipc")?this.f.messagePorts?.get(i.$qn.toKey(Y.identifier)):void 0;return Object.freeze({globalState:ee,workspaceState:ve,secrets:ue,subscriptions:[],get languageModelAccessInformation(){return q},get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(Oe){return k.$lc(Y.extensionLocation.fsPath,Oe)},get storagePath(){return X.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return X.O.globalValue(Y).fsPath},get logPath(){return k.$lc(X.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return a.URI.joinPath(X.f.logsLocation,Y.identifier.value)},get storageUri(){return X.O.workspaceValue(Y)},get globalStorageUri(){return X.O.globalValue(Y)},get extensionMode(){return be},get extension(){return Z===void 0&&(Z=new ce(X,Y.identifier,Y,de,!1)),Z},get extensionRuntime(){return(0,s.$7G)(Y,"extensionRuntime"),X.extensionRuntime},get environmentVariableCollection(){return X.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!me){if(!pe)return;const Oe=f.Event.buffer(f.Event.fromDOMEventEmitter(pe,"message",ze=>ze.data));pe.start(),me={onDidReceiveMessage:Oe,postMessage:pe.postMessage.bind(pe)}}return me}})})}static jb(Y,q,ee,ve,ue){return ee=ee||{activate:void 0,deactivate:void 0},this.kb(Y,q,ee,ve,ue).then(be=>new E.$Yoc(!1,null,ue.build(),ee,be,ve.subscriptions))}static kb(Y,q,ee,ve,ue){if(typeof ee.activate=="function")try{ue.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${q.value}`);const be=typeof global=="object"?global:self,de=ee.activate.apply(be,[ve]);return ue.activateCallStop(),ue.activateResolveStart(),Promise.resolve(de).then(X=>(ue.activateResolveStop(),X))}catch(be){return Promise.reject(be)}else return Promise.resolve(ee)}lb(Y,q){this.bb(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:q}).then(void 0,ee=>{this.s.error(ee)})}mb(Y,q=0){const ve=Date.now();(0,F.$B)(()=>{for(let ue=q;ue<Y.length;ue+=1){const be=Y[ue];for(const de of be.activationEvents??[])if(de==="onStartupFinished")if(Date.now()-ve>50){this.mb(Y,ue);break}else this.lb(be,de)}})}nb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(Y=>{const q=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ee=this.J.getAllExtensionDescriptions();if(q)this.mb(ee);else for(const ve of ee)if(ve.activationEvents)for(const ue of ve.activationEvents)ue==="onStartupFinished"&&this.lb(ve,ue)})}ob(){const Y=this.ab("*",!0).then(void 0,be=>{this.s.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.pb(be.added)));const q=this.j.workspace?this.j.workspace.folders:[],ee=this.pb(q),ve=this.rb(),ue=Promise.all([ve,Y,ee]).then(()=>{});return Promise.race([ue,(0,A.$Gh)(1e4)]).then(()=>{this.nb()}),ue}pb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.qb(Y,q))).then(()=>{})}async qb(Y,q){if(this.isActivated(q.identifier))return;const ee=!this.f.remote.isRemote&&!!this.f.remote.authority,ve={logService:this.s,folders:Y.map(be=>be.uri),forceUsingSearch:ee||!this.c.fsExists,exists:be=>this.c.fsExists(be.fsPath),checkExists:(be,de,X)=>this.y.$checkExists(be,de,X)},ue=await(0,w.$cyb)(ve,q);if(ue)return this.bb(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:ue.activationEvent}).then(void 0,be=>this.s.error(be))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Y){throw console.error(Y),Y}}async sb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:q}=this.f.environment;if(!Y||!q)throw new Error(v.localize(0,null));const ee=await this.xb(null,q,new E.$Xoc(!1));if(!ee||typeof ee.run!="function")throw new Error(v.localize(1,null,q.toString()));return new Promise((ve,ue)=>{const be=(Z,me)=>{Z?(F.$t&&this.s.error("Test runner called back with error",Z),ue(Z)):(F.$t&&(me?this.s.info(`Test runner called back with ${me} failures.`):this.s.info("Test runner called back with successful outcome.")),ve(typeof me=="number"&&me>0?1:0))},de=(0,O.$7g)(q),X=ee.run(de,be);X&&X.then&&X.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),ve(0)}).catch(Z=>{F.$t&&this.s.error("Test runner finished with error",Z),ue(Z instanceof Error&&Z.stack?Z.stack:String(Z))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Gh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,q){return this.S[Y]=q,(0,T.$Uc)(()=>{delete this.S[Y]})}async getRemoteExecServer(Y){const{resolver:q}=await this.ub(Y);return q?.resolveExecServer?.(Y,{resolveAttempt:0})}async ub(Y){const q=Y.indexOf("+");if(q===-1)throw new c.$CN("Not an authority that can be resolved!",l.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ee=Y.substr(0,q);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ee}`,!1),{authorityPrefix:ee,resolver:this.S[ee]}}async $resolveAuthority(Y,q){const ee=W.$ge.create(!1),ve=()=>`[resolveAuthority(${(0,l.$Ul)(Y)},${q})][${ee.elapsed()}ms] `,ue=U=>this.s.info(`${ve()}${U}`),be=U=>this.s.warn(`${ve()}${U}`),de=(U,K=void 0)=>this.s.error(`${ve()}${U}`,K),X=U=>{if(U instanceof c.$CN)return{type:"error",error:{code:U._code,message:U._message,detail:U._detail}};throw U},Z=async U=>{ue(`activating resolver for ${U}...`);const{resolver:K,authorityPrefix:H}=await this.ub(U);if(!K)throw de(`no resolver for ${H}`),new c.$CN(`No remote extension installed to resolve ${H}.`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:H,remoteAuthority:U}},me=Y.split(/@|%40/g).reverse();ue(`activating remote resolvers ${me.join(" -> ")}`);let pe;try{pe=await Promise.all(me.map(Z)).catch(async U=>{if(!(U instanceof c.$CN)||U._code!==l.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw U;return be(`resolving nested authorities failed: ${U.message}`),[await Z(Y)]})}catch(U){return X(U)}const Oe=new A.$Qh;Oe.cancelAndSet(()=>ue("waiting..."),1e3);let ze,ke;for(const[U,{authorityPrefix:K,resolver:H,remoteAuthority:ie}]of pe.entries())try{if(U===pe.length-1)ue("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${K}`),ze=await H.resolve(ie,{resolveAttempt:q,execServer:ke}),C.mark(`code/extHost/didResolveAuthorityOK/${K}`),ue("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,c.$BN.isManagedResolvedAuthority(ze)?ze:void 0));else{if(ue(`invoking resolveExecServer() for ${ie}`),C.mark(`code/extHost/willResolveExecServer/${K}`),ke=await H.resolveExecServer?.(ie,{resolveAttempt:q,execServer:ke}),!ke)throw new c.$CN(`Exec server was not available for ${ie}`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(fe){return C.mark(`code/extHost/didResolveAuthorityError/${K}`),de("returned an error",fe),Oe.dispose(),X(fe)}Oe.dispose();const Ae={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Ne={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};ue(`returned ${c.$BN.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let j;if(c.$BN.isManagedResolvedAuthority(ze)){const U=q;this.Y.setFactory(U,ze.makeConnection),j={authority:Y,connectTo:new l.$Rl(U),connectionToken:ze.connectionToken}}else j={authority:Y,connectTo:new l.$Sl(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:j,options:Ne,tunnelInformation:Ae}}}async $getCanonicalURI(Y,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,l.$Ul)(Y)})`);const{resolver:ee}=await this.ub(Y);if(!ee)return null;const ve=a.URI.revive(q);if(typeof ee.getCanonicalURI>"u")return ve;const ue=await(0,A.$xh)(()=>ee.getCanonicalURI(ve));return ue||ve}async $startExtensionHost(Y){Y.toAdd.forEach(be=>be.extensionLocation=a.URI.revive(be.extensionLocation));const{globalRegistry:q,myExtensions:ee}=_(this.I,this.L,this.J,Y),ve=await this.db(ee);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(q.getAllExtensionDescriptions()),this.J.set(ee),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${se(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${se(this.J)}`)),this.tb()}$activateByEvent(Y,q){return q===s.ActivationKind.Immediate?this.D.wait().then(ee=>this.ab(Y,!1)):this.G.wait().then(ee=>this.ab(Y,!1))}async $activate(Y,q){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.bb(Y,q),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(be=>be.extensionLocation=a.URI.revive(be.extensionLocation));const{globalRegistry:q,myExtensions:ee}=_(this.I,this.L,this.J,Y),ve=await this.db(ee);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(q.getAllExtensionDescriptions()),this.J.set(ee),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${se(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${se(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const q=r.$Oe.alloc(Y),ee=Math.random()%256;for(let ve=0;ve<Y;ve++)q.writeUInt8(ee,ve);return q}async $updateRemoteConnectionData(Y){this.X=Y,this.a.fire()}};e.$ipc=$e,e.$ipc=$e=ae=Qe([Ve(0,g.$Ei),Ve(1,e.$hpc),Ve(2,S.$1P),Ve(3,n.$Foc),Ve(4,u.$Ioc),Ve(5,P.$_j),Ve(6,m.$eQ),Ve(7,$.$Loc),Ve(8,b.$XFb),Ve(9,I.$7oc),Ve(10,G.$epc),Ve(11,V.$fpc),Ve(12,R.$$oc)],$e);function _(Me,Y,q,ee){Me.addActivationEvents(ee.addActivationEvents);const ve=new o.$Kcc(Me,Y.getAllExtensionDescriptions());ve.deltaExtensions(ee.toAdd,ee.toRemove);const ue=new i.$rn(q.getAllExtensionDescriptions().map(de=>de.identifier));for(const de of ee.myToRemove)ue.delete(de);for(const de of ee.myToAdd)ue.add(de);const be=we(ve,ue);return{globalRegistry:ve,myExtensions:be}}function ge(Me,Y){return{id:Me.identifier.value,name:Me.name,extensionVersion:Me.version,publisherDisplayName:Me.publisher,activationEvents:Me.activationEvents?Me.activationEvents.join(","):null,isBuiltin:Me.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function se(Me){return Me.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$jpc=(0,g.$Fi)("IExtHostExtensionService");class ce{#e;#t;#i;constructor(Y,q,ee,ve,ue){this.#e=Y,this.#t=q,this.#i=ee.identifier,this.id=ee.identifier.value,this.extensionUri=ee.extensionLocation,this.extensionPath=k.$jc((0,O.$7g)(ee.extensionLocation)),this.packageJSON=ee,this.extensionKind=ve,this.isFromDifferentExtensionHost=ue}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$kpc=ce;function we(Me,Y){return Me.getAllExtensionDescriptions().filter(q=>Y.has(q.identifier))}class re{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$lpc=re;class Pe{constructor(Y){this.a=new i.$sn,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const q of Object.keys(Y))this.a.set(q,Y[q])}}}),define(Ce[315],Ie([1,0,65,2,5,46,25,19,17,27,3,47,12,13]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=void 0,v=qe(v);let n=class{constructor(r,t,c,l,g,m,$){this.c=r,this.d=t,this.e=c,this.f=l,this.g=g,this.h=m,this.i=$,this.a=new Map,this.b=[]}async install(){this.j(),v.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new o(this.c,t,this.d,r,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(h,t,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const t of r.nodeModuleName)this.a.set(t,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(t=>r.alternativeModuleName(t))}};e.$wqc=n,e.$wqc=n=Qe([Ve(2,P.$Ei),Ve(3,O.$Ioc),Ve(4,y.$jpc),Ve(5,a.$eQ),Ve(6,u.$_j)],n);let s=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&d.a.size){const t=(0,E.$if)(this.c(r.environment.appRoot.fsPath)),c="[a-z0-9_.-]",l=`@${c}+\\/${c}+|${c}+`,g="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${g}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const t=this.b.exec(this.c(r));if(!t)return;const[,c,l,g]=t,m=d.a.get(l);if(m!==void 0)return console.warn(`${l} as been renamed to ${m}, please update your imports`),c+m+g}c(r){return r.replace(/\\/g,"/")}};s=d=Qe([Ve(0,a.$eQ)],s);class o{constructor(r,t,c,l,g){this.c=r,this.d=t,this.e=c,this.f=l,this.g=g,this.nodeModuleName="vscode",this.a=new T.$sn}load(r,t){const c=this.d.findSubstr(t);if(c){let l=this.a.get(c.identifier);return l||(l=this.c(c,this.e,this.f),this.a.set(c.identifier,l)),l}if(!this.b){let l="";this.d.forEach((g,m)=>l+=`	${m} -> ${g.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${l}`),this.b=this.c(A.$1G,this.e,this.f)}return this.b}}let h=class{constructor(r,t,c){this.e=r,this.f=t,this.nodeModuleName=["open","opn"],this.d=c.getProxy(C.$uN.MainThreadTelemetry);const l=c.getProxy(C.$uN.MainThreadWindow);this.c=(g,m)=>{const $=k.URI.parse(g);return m?this.g(g,m):$.scheme==="http"||$.scheme==="https"?l.$openUri($,g,{allowTunneling:!0}):$.scheme==="mailto"||$.scheme===this.f?l.$openUri($,g,{}):this.g(g,m)}}load(r,t,c){const l=this.e.findSubstr(t);return l&&(this.a=l.identifier.value,this.h()),this.b=c(r),this.c}g(r,t){return this.i(),this.b(r,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};h=Qe([Ve(2,p.$1P)],h)}),define(Ce[132],Ie([1,0,48,4,20,79,3,58,71,47,7,45,245,46]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$npc=e.$mpc=void 0,C=qe(C),O=qe(O),e.$mpc=(0,A.$Fi)("IExtHostVariableResolverProvider");class d extends u.$5Q{constructor(o,h,i,r,t,c,l){function g(){if(i){const m=i.activeEditor();if(m)return m.document.uri;const $=r.tabGroups.all.find(S=>S.isActive)?.activeTab;if($!==void 0){if($.input instanceof P.$iP||$.input instanceof P.$nP)return $.input.modified;if($.input instanceof P.$hP||$.input instanceof P.$mP||$.input instanceof P.$kP)return $.input.uri}}}super({getFolderUri:m=>{const $=c.folders.filter(S=>S.name===m);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>c.folders.length,getConfigurationValue:(m,$)=>t.getConfiguration(void 0,m).get($),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const m=g();if(m)return C.$jc(m.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const m=g();if(m){const $=h.getWorkspaceFolder(m);if($)return C.$jc($.uri.fsPath)}}},getSelectedText:()=>{if(i){const m=i.activeEditor();if(m&&!m.selection.isEmpty)return m.document.getText(m.selection)}},getLineNumber:()=>{if(i){const m=i.activeEditor();if(m)return String(m.selection.end.line+1)}},getExtension:m=>o.getExtension(m)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(O.env))}}let n=class extends k.$Wc{constructor(o,h,i,r,t){super(),this.b=o,this.c=h,this.g=i,this.h=r,this.j=t,this.a=new v.$X(async()=>{const c=await this.h.getConfigProvider(),g={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async m=>{g.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,c,g,this.m())})}getResolver(){return this.a.value}m(){}};e.$npc=n,e.$npc=n=Qe([Ve(0,a.$jpc),Ve(1,y.$Foc),Ve(2,T.$_P),Ve(3,E.$Ioc),Ve(4,p.$Uoc)],n)}),define(Ce[133],Ie([1,0,11,6,2,4,19,3,5,71,47,17,7,45,237,81,238,46,132,35,34,8,18,96]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h,i,r,t,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xpc=e.$wpc=e.$vpc=e.$upc=e.$tpc=void 0,t=qe(t),e.$tpc=(0,T.$Fi)("IExtHostDebugService");let g=class extends O.$Wc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(R,f,w,M,N,L,G,W){super(),this.Y=f,this.Z=w,this.$=M,this.ab=N,this.bb=L,this.cb=G,this.db=W,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new k.$me),this.z=this.B(new k.$me),this.C=this.B(new k.$me),this.F=this.B(new k.$me),this.u=R.getProxy(p.$uN.MainThreadDebugService),this.I=this.B(new k.$me),this.L=this.B(new k.$me),this.G=new $(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(F=>{this.B(F.onDidChange(V=>{this.fb(F)})),this.fb(F)})}async $getVisualizerTreeItem(R,f){const w=this.gb(f);if(!w)return;const M=await this.Q.get(R)?.getTreeItem?.(w);return M?this.eb(R,M):void 0}registerDebugVisualizationTree(R,f,w){const M=A.$qn.toKey(R.identifier),N=this.ub(M,f);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.Q.set(N,w),this.u.$registerDebugVisualizerTree(N,!!w.editItem),(0,O.$Uc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(f)})}async $getVisualizerTreeItemChildren(R,f){const w=this.S.get(f)?.item;return w?(await this.Q.get(R)?.getChildren?.(w))?.map(N=>this.eb(R,N))||[]:[]}async $editVisualizerTreeItem(R,f){const w=this.S.get(R);if(!w)return;const M=await this.Q.get(w.provider)?.editItem?.(w.item,f);return this.eb(w.provider,M||w.item)}$disposeVisualizedTree(R){const f=this.S.get(R);if(!f)return;const w=[f.children];for(const M of w)if(M)for(const N of M)w.push(this.S.get(N)?.children),this.S.delete(N)}eb(R,f){let w=this.R.get(f);return w||(w=this.O++,this.R.set(f,w),this.S.set(w,{provider:R,item:f})),t.DebugTreeItem.from(f,w)}asDebugSourceUri(R,f){const w=R;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let M=`debug:${encodeURIComponent(w.path||"")}`,N="?";return f&&(M+=`${N}session=${encodeURIComponent(f.id)}`,N="&"),M+=`${N}ref=${w.sourceReference}`,C.URI.parse(M)}else{if(w.path)return C.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(R){const f=[];for(const w of R.getAllExtensionDescriptions())if(w.contributes){const M=w.contributes.debuggers;if(M&&M.length>0)for(const N of M)(0,s.$YH)(N)&&f.push(N.type)}this.u.$registerDebugTypes(f)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const R=[];return this.H.forEach(f=>R.push(f)),R}async $resolveDebugVisualizer(R,f){const w=this.W.get(R);if(!w)throw new Error(`No debug visualizer found with id '${R}'`);let{v:M,provider:N,extensionId:L}=w;if(M.visualization||(M=await N.resolveDebugVisualization?.(M,f)||M,w.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(L,M.visualization)}async $executeDebugVisualizerCommand(R){const f=this.W.get(R);if(!f)throw new Error(`No debug visualizer found with id '${R}'`);const w=f.v.visualization;w&&"command"in w&&this.cb.executeCommand(w.command,...w.arguments||[])}gb(R){const f=this.w.get(R.sessionId);return f&&{session:f.api,variable:R.variable,containerId:R.containerId,frameId:R.frameId,threadId:R.threadId}}async $provideDebugVisualizers(R,f,w,M){const N=this.gb(w),L=this.ub(R,f),G=this.P.get(L);if(!N||!G)return[];const W=await G.provideDebugVisualization(N,M);return W?W.map(F=>{const V=++this.X;this.W.set(V,{v:F,provider:G,extensionId:R});const ae=F.iconPath?this.wb(F.iconPath):void 0;return{id:V,name:F.name,iconClass:ae?.iconClass,iconPath:ae?.iconPath,visualization:this.vb(R,F.visualization)}}):[]}$disposeDebugVisualizers(R){for(const f of R)this.W.delete(f)}registerDebugVisualizationProvider(R,f,w){if(!R.contributes?.debugVisualizers?.some(L=>L.id===f))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${f})`);const M=A.$qn.toKey(R.identifier),N=this.ub(M,f);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.P.set(N,w),this.u.$registerDebugVisualizer(M,f),(0,O.$Uc)(()=>{this.u.$unregisterDebugVisualizer(M,f),this.P.delete(f)})}addBreakpoints(R){const f=R.filter(N=>{const L=N.id;return this.H.has(L)?!1:(this.H.set(L,N),!0)});this.rb(f,[],[]);const w=[],M=new Map;for(const N of f)if(N instanceof u.$yO){let L=M.get(N.location.uri.toString());L||(L={type:"sourceMulti",uri:N.location.uri,lines:[]},M.set(N.location.uri.toString(),L),w.push(L)),L.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof u.$zO&&w.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(w)}removeBreakpoints(R){const f=R.filter(L=>this.H.delete(L.id));this.rb([],f,[]);const w=f.filter(L=>L instanceof u.$yO).map(L=>L.id),M=f.filter(L=>L instanceof u.$zO).map(L=>L.id),N=f.filter(L=>L instanceof u.$AO).map(L=>L.id);return this.u.$unregisterBreakpoints(w,M,N)}startDebugging(R,f,w){const M=w.testRun&&this.db.getMetadataForRun(w.testRun);return this.u.$startDebugging(R?R.uri:void 0,f,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(R){return this.u.$stopDebugging(R?R.id:void 0)}registerDebugConfigurationProvider(R,f,w){if(!f)return new u.$wN(()=>{});const M=this.f++;return this.g.push({type:R,handle:M,provider:f}),this.u.$registerDebugConfigurationProvider(R,w,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,M),new u.$wN(()=>{this.g=this.g.filter(N=>N.provider!==f),this.u.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(R,f,w){if(!w)return new u.$wN(()=>{});if(!this.nb(R,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.kb(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this.h++;return this.j.push({type:f,handle:M,factory:w}),this.u.$registerDebugAdapterDescriptorFactory(f,M),new u.$wN(()=>{this.j=this.j.filter(N=>N.factory!==w),this.u.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(R,f){if(!f)return new u.$wN(()=>{});const w=this.m++;return this.n.push({type:R,handle:w,factory:f}),new u.$wN(()=>{this.n=this.n.filter(M=>M.factory!==f)})}async $runInTerminal(R,f){return Promise.resolve(void 0)}async $substituteVariables(R,f){let w;const M=await this.tb(R);return M&&(w={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(w,f)}hb(R,f){if(R.type==="implementation")return new D(R.implementation)}ib(){}async $startDASession(R,f){const w=this,M=await this.sb(f);return this.pb(this.kb(M.type),M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const L=this.jb(N),G=this.hb(L,M);if(!G)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const W=G;return this.M.set(R,W),this.ob(M).then(F=>(F&&this.N.set(R,F),W.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const ae=V,$e={type:"response",seq:0,command:ae.command,request_seq:ae.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const _=await this.U.sign(ae.arguments.value);$e.body={signature:_},W.sendResponse($e)}else throw new Error("no signer")}catch(_){$e.success=!1,$e.message=_.message,W.sendResponse($e)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(V),V=(0,s.$4H)(V,!0),w.u.$acceptDAMessage(R,V)}),W.onError(V=>{F&&F.onError&&F.onError(V),this.u.$acceptDAError(R,V.name,V.message,V.stack)}),W.onExit(V=>{F&&F.onExit&&F.onExit(V??void 0,void 0),this.u.$acceptDAExit(R,V??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),W.startSession()))})}$sendDAMessage(R,f){f=(0,s.$3H)(f,!1);const w=this.N.get(R);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(f),this.M.get(R)?.sendMessage(f)}$stopDASession(R){const f=this.N.get(R);this.N.delete(R),f&&f.onWillStopSession&&f.onWillStopSession();const w=this.M.get(R);return this.M.delete(R),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(R){const f=[],w=[],M=[];if(R.added)for(const N of R.added){const L=N.id;if(L&&!this.H.has(L)){let G;if(N.type==="function")G=new u.$zO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")G=new u.$AO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const W=C.URI.revive(N.uri);G=new u.$yO(new u.$IN(W,new u.$xN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,u.$wO)(G,L),this.H.set(L,G),f.push(G)}}if(R.removed)for(const N of R.removed){const L=this.H.get(N);L&&(this.H.delete(N),w.push(L))}if(R.changed){for(const N of R.changed)if(N.id){const L=this.H.get(N.id);if(L){if(L instanceof u.$zO&&N.type==="function"){const G=L;G.enabled=N.enabled,G.condition=N.condition,G.hitCondition=N.hitCondition,G.logMessage=N.logMessage,G.functionName=N.functionName}else if(L instanceof u.$yO&&N.type==="source"){const G=L;G.enabled=N.enabled,G.condition=N.condition,G.hitCondition=N.hitCondition,G.logMessage=N.logMessage,G.location=new u.$IN(C.URI.revive(N.uri),new u.$xN(N.line,N.character))}M.push(L)}}}this.rb(f,w,M)}async $acceptStackFrameFocus(R){let f;if(R){const w=await this.sb(R.sessionId);R.kind==="thread"?f=new u.$GO(w.api,R.threadId):f=new u.$FO(w.api,R.threadId,R.frameId)}this.J=f,this.L.fire(this.J)}$provideDebugConfigurations(R,f,w){return(0,v.$xh)(async()=>{const M=this.mb(R);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(f);return M.provideDebugConfigurations(N,w)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(R,f,w,M){return(0,v.$xh)(async()=>{const N=this.mb(R);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.tb(f);return N.resolveDebugConfiguration(L,w,M)})}$resolveDebugConfigurationWithSubstitutedVariables(R,f,w,M){return(0,v.$xh)(async()=>{const N=this.mb(R);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.tb(f);return N.resolveDebugConfigurationWithSubstitutedVariables(L,w,M)})}async $provideDebugAdapter(R,f){const w=this.lb(R);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.sb(f);return this.pb(w,M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(R){const f=await this.sb(R);this.y.fire(f.api)}async $acceptDebugSessionTerminated(R){const f=await this.sb(R);f&&(this.z.fire(f.api),this.w.delete(f.id))}async $acceptDebugSessionActiveChanged(R){this.D=R?await this.sb(R):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(R,f){(await this.sb(R))?._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(R,f){const M={session:(await this.sb(R)).api,event:f.event,body:f.body};this.F.fire(M)}jb(R){if(R instanceof u.$BO)return{type:"executable",command:R.command,args:R.args,options:R.options};if(R instanceof u.$CO)return{type:"server",port:R.port,host:R.host};if(R instanceof u.$DO)return{type:"pipeServer",path:R.path};if(R instanceof u.$EO)return{type:"implementation",implementation:R.implementation};throw new Error("convertToDto unexpected type")}kb(R){const f=this.j.filter(w=>w.type===R);if(f.length>0)return f[0].factory}lb(R){const f=this.j.filter(w=>w.handle===R);if(f.length>0)return f[0].factory}mb(R){const f=this.g.filter(w=>w.handle===R);if(f.length>0)return f[0].provider}nb(R,f){if(R.contributes){const w=R.contributes.debuggers;if(w&&w.length>0){for(const M of w)if(M.label&&M.type&&M.type===f)return!0}}return!1}ob(R){const w=R.configuration.type,M=this.n.filter(N=>N.type===w||N.type==="*").map(N=>(0,v.$xh)(()=>N.factory.createDebugAdapterTracker(R.api)).then(L=>L,L=>null));return Promise.race([Promise.all(M).then(N=>{const L=(0,c.$Jb)(N);if(L.length>0)return new S(L)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(R,f){const w=f.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new u.$CO(w));if(R){const N=await this.Z.getExtensionRegistry();return(0,v.$xh)(()=>R.createDebugAdapterDescriptor(f.api,this.qb(f,N))).then(L=>{if(L)return L})}const M=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(f,M))}qb(R,f){}rb(R,f,w){(R.length>0||f.length>0||w.length>0)&&this.I.fire(Object.freeze({added:R,removed:f,changed:w}))}async sb(R){if(R)if(typeof R=="string"){const f=this.w.get(R);if(f)return f}else{let f=this.w.get(R.id);if(!f){const w=await this.tb(R.folderUri),M=R.parent?this.w.get(R.parent):void 0;f=new m(this.u,R.id,R.type,R.name,w,R.configuration,M?.api),this.w.set(f.id,f),this.u.$sessionCached(f.id)}return f}throw new Error("cannot find session")}tb(R){if(R){const f=C.URI.revive(R);return this.Y.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}ub(R,f){return`${R}\0${f}`}vb(R,f){if(f){if("title"in f&&"command"in f)return{type:n.DebugVisualizationType.Command};if("treeId"in f)return{type:n.DebugVisualizationType.Tree,id:`${R}\0${f.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(R){const f=this.xb(R);let w,M;return"id"in f?M=i.ThemeIcon.asClassName(f):w=f,{iconPath:w,iconClass:M}}xb(R){if(R instanceof u.$tO)return{id:R.id};const f=typeof R=="object"&&"dark"in R?R.dark:R,w=typeof R=="object"&&"light"in R?R.light:R;return{dark:typeof f=="string"?C.URI.file(f):f,light:typeof w=="string"?C.URI.file(w):w}}};e.$upc=g,e.$upc=g=Qe([Ve(0,y.$1P),Ve(1,E.$Foc),Ve(2,P.$jpc),Ve(3,o.$Ioc),Ve(4,a.$Uoc),Ve(5,h.$mpc),Ve(6,r.$kQ),Ve(7,l.$opc)],g);class m{constructor(R,f,w,M,N,L,G){this.f=R,this.g=f,this.h=w,this.j=M,this.k=N,this.l=L,this.m=G}get api(){const R=this;return this.d??=Object.freeze({id:R.g,type:R.h,get name(){return R.j},set name(f){R.j=f,R.f.$setDebugSessionName(R.g,f)},parentSession:R.m,workspaceFolder:R.k,configuration:R.l,customRequest(f,w){return R.f.$customDebugAdapterRequest(R.g,f,w)},getDebugProtocolBreakpoint(f){return R.f.$getDebugProtocolBreakpoint(R.g,f.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(R){this.j=R}get configuration(){return this.l}}e.$vpc=m;class ${constructor(R){this.value=Object.freeze({append(f){R.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.$wpc=$;class S{constructor(R){this.d=R}onWillStartSession(){this.d.forEach(R=>R.onWillStartSession?R.onWillStartSession():void 0)}onWillReceiveMessage(R){this.d.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(R):void 0)}onDidSendMessage(R){this.d.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(R):void 0)}onWillStopSession(){this.d.forEach(R=>R.onWillStopSession?R.onWillStopSession():void 0)}onError(R){this.d.forEach(f=>f.onError?f.onError(R):void 0)}onExit(R,f){this.d.forEach(w=>w.onExit?w.onExit(R,f):void 0)}}class D extends d.$Itb{constructor(R){super(),this.h=R,R.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(R){this.h.handleMessage(R)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let b=class extends g{constructor(R,f,w,M,N,L,G,W){super(R,f,w,M,N,L,G,W)}};e.$xpc=b,e.$xpc=b=Qe([Ve(0,y.$1P),Ve(1,E.$Foc),Ve(2,P.$jpc),Ve(3,o.$Ioc),Ve(4,a.$Uoc),Ve(5,h.$mpc),Ve(6,r.$kQ),Ve(7,l.$opc)],b)}),define(Ce[316],Ie([1,0,14,65,2,5,266,12,61,75,27,211,17,66,47,67]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=e.$xqc=void 0,v=qe(v),k=qe(k);class s{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(T.$_j),c=i.get(u.$1P).getProxy(O.$uN.MainThreadErrors);v.setUnexpectedErrorHandler(l=>{r.error(l);const g=v.$5(l);c.$onUnexpectedError(g)})}static async installFullHandler(i){const r=i.get(T.$_j),t=i.get(u.$1P),c=i.get(d.$jpc),l=i.get(n.$iQ),g=t.getProxy(O.$uN.MainThreadExtensionService),m=t.getProxy(O.$uN.MainThreadErrors),$=await c.getExtensionPathIndex(),S=new WeakMap;function D(R,f){if(S.has(R))return S.get(R).stack;let w="",M,N;for(const G of f)w+=`
	at ${G.toString()}`,N=G.getFileName(),!M&&N&&(M=$.findSubstr(C.URI.file(N)));const L=`${R.name||"Error"}: ${R.message||""}${w}`;return S.set(R,{extensionIdentifier:M?.identifier,stack:L}),L}const b=Symbol("prepareStackTrace wrapped");let I=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return I},set(R){if(R===D||!R||R[b]){I=R||D;return}I=function(f,w){return D(f,w),R.call(Error,f,w)},Object.assign(I,{[b]:!0})}}),v.setUnexpectedErrorHandler(R=>{r.error(R);const f=v.$5(R),w=S.get(R);if(!w?.extensionIdentifier){m.$onUnexpectedError(f);return}g.$onExtensionRuntimeError(w.extensionIdentifier,f);const M=l.onExtensionError(w.extensionIdentifier,R);r.trace("forwarded error to extension?",M,w)})}}e.$xqc=s;class o{constructor(i,r,t,c,l){this.a=t,this.b=new A.$Scc(i,null,c),r=o.e(r,this.b);const g=new a.$Di(...(0,p.$Ps)());g.set(P.$eQ,{_serviceBrand:void 0,...r,messagePorts:l}),g.set(u.$1P,new u.$2P(this.b)),g.set(E.$Coc,new E.$Doc(c)),g.set(d.$hpc,t);const m=new y.$tr(g,!0);m.invokeFunction(s.installEarlyHandler),this.d=m.invokeFunction($=>$.get(T.$_j)),k.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=m.invokeFunction($=>$.get(d.$jpc)),this.c.initialize(),m.invokeFunction(s.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(O.$uN.MainThreadExtensionService);return C.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(c=>{c.extensionLocation=C.URI.revive(r.transformIncomingURIs(c.extensionLocation))}),i.environment.appRoot=C.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(c=>C.URI.revive(r.transformIncomingURIs(c)))),i.environment.extensionTestsLocationURI=C.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=C.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=C.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=C.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=C.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=C.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$yqc=o}),define(Ce[317],Ie([1,0,18,11,22,41,16,20,24,2,44]),function(oe,e,v,k,C,O,A,T,p,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=e.$Mpc=e.$Lpc=void 0,e.$Npc=n,T=qe(T),p=qe(p);class y{constructor(h,i,r){this.d=h,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(h,i){const r=this.g.folderQueries||[],t=new C.$xe(i);return new Promise((c,l)=>{this.a=new E(h);let g=!1;const m=($,S)=>{if(!g&&!this.b){const D=this.h($);n($)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,g=!0,t.cancel(),$=this.j($,this.g.maxResults-this.c));const b=this.h($);this.c+=b,(b>0||!n($))&&this.a.add($,S)}};Promise.all(r.map(($,S)=>this.k($,D=>m(D,S),t.token))).then($=>{t.dispose(),this.a.flush();const S=$.some(D=>!!D&&!!D.limitHit);c({limitHit:this.b||S,messages:$.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},$=>{t.dispose();const S=(0,O.$qj)($);l(new Error(S))})})}h(h){return n(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}j(h,i){const r=Array.isArray(h.ranges)?h.ranges:[h.ranges],t=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:r.slice(0,i),preview:{matches:t.slice(0,i),text:h.preview.text},uri:h.uri}}async k(h,i,r){const t=new P.$$L(this.g,h),c=[],l={report:$=>{if(!this.l($))return;const S=h.folder.scheme===A.Schemas.file?(0,P.$_L)(()=>this.e.readdir(p.$fh($.uri))):void 0,D=p.$ih(h.folder,$.uri);if(D){const b=t.includedInQuery(D,T.$pc(D),S);(0,k.$rh)(b)?c.push(b.then(I=>{I&&i($)})):b&&i($)}}},g=this.n(h);let m;return this.d.query.type===P.QueryType.aiText?m=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,g,l,r):m=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),g,l,r),c.length&&await Promise.all(c),m}l(h){if(n(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(h){const i=(0,P.$0L)(this.g.includePattern,h.includePattern),r=(0,P.$0L)(this.g.excludePattern,h.excludePattern),t={folder:a.URI.from(h.folder),excludes:r,includes:i,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.e.toCanonicalName(h.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??P.$QL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$Lpc=y;function u(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class E{constructor(h){this.e=h,this.b=-1,this.d=null,this.a=new s(512,i=>this.g(i))}add(h,i){this.d&&(this.b!==i||!p.$_g(this.c,h.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:h.uri,results:[]}),this.d.results.push(d(h))}f(){const h=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,h)}flush(){this.f(),this.a.flush()}g(h){this.e(h)}}e.$Mpc=E;function d(o){return n(o)?{preview:{matches:(0,v.$3b)(o.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:o.preview.text},ranges:(0,v.$3b)(o.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function n(o){return!!o.preview}class s{static{this.a=4e3}static{this.b=50}constructor(h,i){this.g=h,this.h=i,this.c=0,this.d=[],this.e=0}addItem(h,i){h&&this.j(h,i)}addItems(h,i){h&&this.k(h,i)}j(h,i){this.d.push(h),this.e+=i,this.l()}k(h,i){this.d=this.d.concat(h),this.e+=i,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Opc=s}),define(Ce[134],Ie([1,0,4,5,3,312,17,66,12,2,317]),function(oe,e,v,k,C,O,A,T,p,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=e.$Ppc=void 0,e.$Rpc=u,e.$Ppc=(0,C.$Fi)("IExtHostSearch");let y=class{constructor(n,s,o){this.n=n,this.o=s,this.q=o,this.c=this.n.getProxy(k.$uN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$Kpc}s(n){return this.o.transformOutgoingScheme(n)}registerTextSearchProvider(n,s){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const o=this.d++;return this.e.set(o,s),this.c.$registerTextSearchProvider(o,this.s(n)),(0,v.$Uc)(()=>{this.g.delete(n),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(n,s){if(this.i.has(n))throw new Error(`an AI text search provider for the scheme '${n}'is already registered`);this.i.add(n);const o=this.d++;return this.h.set(o,s),this.c.$registerAITextSearchProvider(o,this.s(n)),(0,v.$Uc)(()=>{this.i.delete(n),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(n,s){if(this.k.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.k.add(n);const o=this.d++;return this.j.set(o,s),this.c.$registerFileSearchProvider(o,this.s(n)),(0,v.$Uc)(()=>{this.k.delete(n),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(n,s,o,h){const i=u(o),r=this.j.get(n);if(r)return this.l.fileSearch(i,r,t=>{this.c.$handleFileMatch(n,s,t.map(c=>c.resource))},h);throw new Error("3 unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,s,o){return{messages:[]}}$clearCache(n){return this.l.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,s,o,h){const i=this.e.get(n);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${n}`);const r=u(o);return this.t(r,i).search(c=>this.c.$handleTextMatch(n,s,c),h)}$provideAITextSearchResults(n,s,o,h){const i=this.h.get(n);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${n}`);const r=u(o);return this.v(r,i).search(c=>this.c.$handleTextMatch(n,s,c),h)}$enableExtensionHostSearch(){}t(n,s){return new P.$Lpc({query:n,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(n,s){return new P.$Lpc({query:n,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$Qpc=y,e.$Qpc=y=Qe([Ve(0,A.$1P),Ve(1,T.$Coc),Ve(2,p.$_j)],y);function u(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(E),extraFileResources:d.extraFileResources&&d.extraFileResources.map(n=>a.URI.revive(n))}}function E(d){return{...d,folder:a.URI.revive(d.folder)}}});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[318],Ie([1,0,22,14,6,4,16,36,2,106,165,151,52,19,30,12,63,64,226,5,269,298,85,91,274,275,276,253,243,34,277,46,278,133,122,279,255,270,280,281,58,71,256,271,47,283,69,284,51,27,299,257,285,95,287,86,87,259,311,289,231,290,300,291,128,260,292,293,294,17,295,134,88,296,261,297,89,92,131,67,57,126,96,301,272,302,303,93,8,7,262,66,263,68,304,305,121,45,81,84,25,130,286]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h,i,r,t,c,l,g,m,$,S,D,b,I,R,f,w,M,N,L,G,W,F,V,ae,$e,_,ge,se,ce,we,re,Pe,Me,Y,q,ee,ve,ue,be,de,X,Z,me,pe,Oe,ze,ke,Ae,Ne,j,U,K,H,ie,fe,Re,Ue,Ke,_e,tt,nt,et,rt,ft,ct,st,ut,gt,pt,Be,je,Q,x,De,Je,xe,ht,$t,Ft,zt,Yt,fi,Ze,Pt,Kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sqc=Qt,k=qe(k),T=ti(T),y=qe(y),d=qe(d),je=qe(je),Q=qe(Q);function Qt(mt){const vt=mt.get(Pe.$eQ),ii=mt.get(re.$noc),Zt=mt.get(ce.$Koc),qt=mt.get(ge.$jpc),yt=mt.get(zt.$Foc),Nt=mt.get(et.$iQ),li=mt.get(R.$Ioc),Vt=mt.get(De.$Coc),Xe=mt.get(K.$1P),xt=mt.get(_e.$4oc),ni=mt.get(tt.$Loc),hi=mt.get(n.$ak),kt=mt.get(n.$_j),Lt=mt.get(Be.$XFb),At=mt.get(c.$joc),Ut=mt.get(Ft.$qqc),ri=mt.get(fe.$bpc),_t=mt.get(ae.$Uoc),si=mt.get(be.$fpc),jt=mt.get(l.$toc),Ht=mt.get(ee.$$oc);Xe.set(i.$vN.ExtHostFileSystemInfo,ii),Xe.set(i.$vN.ExtHostLogLevelServiceShape,hi),Xe.set(i.$vN.ExtHostWorkspace,yt),Xe.set(i.$vN.ExtHostConfiguration,li),Xe.set(i.$vN.ExtHostExtensionService,qt),Xe.set(i.$vN.ExtHostStorage,xt),Xe.set(i.$vN.ExtHostTunnelService,Lt),Xe.set(i.$vN.ExtHostWindow,Ut),Xe.set(i.$vN.ExtHostSecretState,ri),Xe.set(i.$vN.ExtHostTelemetry,Nt),Xe.set(i.$vN.ExtHostEditorTabs,_t),Xe.set(i.$vN.ExtHostManagedSockets,si),Xe.set(i.$vN.ExtHostAuthentication,jt),Xe.set(i.$vN.ExtHostChatProvider,Ht);const oi=Xe.set(i.$vN.ExtHostDecorations,mt.get(M.$zpc)),Rt=Xe.set(i.$vN.ExtHostDocumentsAndEditors,mt.get(V.$_P)),St=Xe.set(i.$vN.ExtHostCommands,mt.get(b.$kQ)),bt=Xe.set(i.$vN.ExtHostTerminalService,mt.get(rt.$7oc)),ei=Xe.set(i.$vN.ExtHostTerminalShellIntegration,mt.get(ft.$gqc)),Ct=Xe.set(i.$vN.ExtHostDebugService,mt.get(w.$tpc)),di=Xe.set(i.$vN.ExtHostSearch,mt.get(ie.$Ppc)),Gt=Xe.set(i.$vN.ExtHostTask,mt.get(nt.$fqc)),bi=Xe.set(i.$vN.ExtHostOutputService,mt.get(ke.$5pc)),vi=Xe.set(i.$vN.ExtHostLocalization,mt.get(ue.$epc)),gi=Xe.set(i.$vN.ExtHostUrls,new Je.$nqc(Xe)),Bt=Xe.set(i.$vN.ExtHostDocuments,new F.$qoc(Xe,Rt)),ai=Xe.set(i.$vN.ExtHostDocumentContentProviders,new G.$Bpc(Xe,Rt,kt)),Ii=Xe.set(i.$vN.ExtHostDocumentSaveParticipant,new W.$Cpc(kt,Bt,Xe.getProxy(i.$uN.MainThreadBulkEdits))),Tt=Xe.set(i.$vN.ExtHostNotebook,new X.$Spc(Xe,St,Rt,Bt,Zt,di,kt)),Di=Xe.set(i.$vN.ExtHostNotebookDocuments,new me.$Ypc(Tt)),Pi=Xe.set(i.$vN.ExtHostNotebookEditors,new pe.$Zpc(kt,Tt)),Si=Xe.set(i.$vN.ExtHostNotebookKernels,new Oe.$1pc(Xe,vt,Tt,St,kt)),pi=Xe.set(i.$vN.ExtHostNotebookRenderers,new ze.$3pc(Xe,Tt)),Ri=Xe.set(i.$vN.ExtHostNotebookDocumentSaveParticipant,new Z.$Xpc(kt,Tt,Xe.getProxy(i.$uN.MainThreadBulkEdits))),Wt=Xe.set(i.$vN.ExtHostEditors,new st.$zoc(Xe,Rt)),ye=Xe.set(i.$vN.ExtHostTreeViews,new pt.$lqc(Xe.getProxy(i.$uN.MainThreadTreeViews),St,kt)),Te=Xe.set(i.$vN.ExtHostEditorInsets,new D.$Aoc(Xe.getProxy(i.$uN.MainThreadEditorInsets),Wt,vt.remote)),le=Xe.set(i.$vN.ExtHostDiagnostics,new N.$poc(Xe,kt,ii,Rt)),J=Xe.set(i.$vN.ExtHostLanguages,new ve.$Vpc(Xe,Bt,St.converter,Vt)),Ee=Xe.set(i.$vN.ExtHostLanguageFeatures,new q.$roc(Xe,Vt,Bt,St,le,kt,At,Nt)),We=Xe.set(i.$vN.ExtHostFileSystem,new se.$Fpc(Xe,Ee)),Ye=Xe.set(i.$vN.ExtHostFileSystemEventService,new we.$Gpc(Xe,kt,Rt)),Ge=Xe.set(i.$vN.ExtHostQuickOpen,(0,U.$9pc)(Xe,yt,St)),lt=Xe.set(i.$vN.ExtHostSCM,new H.$$pc(Xe,St,Bt,kt)),It=Xe.set(i.$vN.ExtHostQuickDiff,new j.$8pc(Xe,Vt)),Jt=Xe.set(i.$vN.ExtHostShare,new Re.$_pc(Xe,Vt)),ci=Xe.set(i.$vN.ExtHostComments,(0,I.$Boc)(Xe,St,Bt)),Mt=Xe.set(i.$vN.ExtHostProgress,new Ne.$7pc(Xe.getProxy(i.$uN.MainThreadProgress))),ui=Xe.set(i.$vN.ExtHostLabelService,new Y.$Upc(Xe)),qi=Xe.set(i.$vN.ExtHostTheming,new ut.$iqc(Xe)),$n=Xe.set(i.$vN.ExtHostTimeline,new gt.$kqc(Xe,St)),Li=Xe.set(i.$vN.ExtHostWebviews,new xe.$Poc(Xe,vt.remote,yt,kt,At)),Oi=Xe.set(i.$vN.ExtHostWebviewPanels,new ht.$Soc(Xe,Li,yt)),Vi=Xe.set(i.$vN.ExtHostCustomEditors,new f.$Toc(Xe,Bt,ni,Li,Oi)),xi=Xe.set(i.$vN.ExtHostWebviewViews,new $t.$oqc(Xe,Li)),ki=Xe.set(i.$vN.ExtHostTesting,mt.get(ct.$opc)),_i=Xe.set(i.$vN.ExtHostUriOpeners,new x.$mqc(Xe)),en=Xe.set(i.$vN.ExtHostProfileContentHandlers,new Ae.$6pc(Xe));Xe.set(i.$vN.ExtHostInteractive,new Me.$Tpc(Xe,Tt,Rt,St,kt));const Mi=Xe.set(i.$vN.ExtHostChatAgents2,new m.$woc(Xe,kt,St,vt.quality)),tn=Xe.set(i.$vN.ExtHostChatVariables,new $.$xoc(Xe)),Gi=Xe.set(i.$vN.ExtHostLanguageModelTools,new Kt.$rqc(Xe)),nn=Xe.set(i.$vN.ExtHostAiRelatedInformation,new r.$ioc(Xe)),Ki=Xe.set(i.$vN.ExtHostAiEmbeddingVector,new _.$Epc(Xe)),zi=Xe.set(i.$vN.ExtHostStatusBar,new Ke.$cqc(Xe,St.converter)),wn=Xe.set(i.$vN.ExtHostSpeech,new Ue.$aqc(Xe)),Ni=Xe.set(i.$vN.ExtHostEmbeddings,new $e.$Dpc(Xe)),rn=Object.values(i.$vN);Xe.assertRegistered(rn);const bn=new g.$voc(Xe,Rt),Qi=new S.$yoc(Xe),Ui=new de.$Wpc(Xe,kt),Hi=new L.$Apc(Xe);return t.$soc.register(St),function(Le,yi,ji){function ot(te){return(he,Fe,at)=>{const Dt=te(Ot=>{try{he.call(Fe,Ot)}catch(Ai){k.$4(new Error(`[ExtensionListenerError] Extension '${Le.identifier.value}' FAILED to handle event: ${Ai.toString()}`,{cause:Ai})),Nt.onExtensionError(Le.identifier,Ai)}});return at?.push(Dt),Dt}}const wt=function(){let te=!Le.isUnderDevelopment;function he(){te||(kt.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Fe(at){if(Array.isArray(at))at.forEach(Fe);else if(typeof at=="string")he();else{const Dt=at;typeof Dt.scheme>"u"&&he(),typeof Dt.exclusive=="boolean"&&(0,Ze.$7G)(Le,"documentFiltersExclusive")}return at}}(),Bi={getSession(te,he,Fe){return typeof Fe?.forceNewSession=="object"&&Fe.forceNewSession.learnMore&&(0,Ze.$7G)(Le,"authLearnMore"),Fe?.account&&(0,Ze.$7G)(Le,"authGetSessions"),jt.getSession(Le,te,he,Fe)},getSessions(te,he){return(0,Ze.$7G)(Le,"authGetSessions"),jt.getSessions(Le,te,he)},getAccounts(te){return(0,Ze.$7G)(Le,"authGetSessions"),jt.getAccounts(te)},async hasSession(te,he){return(0,Ze.$7G)(Le,"authSession"),!!await jt.getSession(Le,te,he,{silent:!0})},get onDidChangeSessions(){return ot(jt.onDidChangeSessions)},registerAuthenticationProvider(te,he,Fe,at){return jt.registerAuthenticationProvider(te,he,Fe,at)}},vn={registerCommand(te,he,Fe){return St.registerCommand(!0,te,he,Fe,void 0,Le)},registerTextEditorCommand(te,he,Fe){return St.registerCommand(!0,te,(...at)=>{const Dt=Wt.getActiveTextEditor();if(!Dt){kt.warn("Cannot execute "+te+" because there is no active text editor.");return}return Dt.edit(Ot=>{he.apply(Fe,[Dt,Ot,...at])}).then(Ot=>{Ot||kt.warn("Edits from command "+te+" were not applied.")},Ot=>{kt.warn("An error occurred while running command "+te,Ot)})},void 0,void 0,Le)},registerDiffInformationCommand:(te,he,Fe)=>((0,Ze.$7G)(Le,"diffCommand"),St.registerCommand(!0,te,async(...at)=>{const Dt=Rt.activeEditor(!0);if(!Dt){kt.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ot=await Wt.getDiffInformation(Dt.id);he.apply(Fe,[Ot,...at])},void 0,void 0,Le)),executeCommand(te,...he){return St.executeCommand(te,...he)},getCommands(te=!1){return St.getCommands(te)}},mi={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Qi.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return ot(bt.onDidChangeShell)},get isTelemetryEnabled(){return Nt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Nt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$7G)(Le,"telemetry"),Nt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$7G)(Le,"telemetry"),ot(Nt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,et.$hQ)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,he){return et.$gQ.validateSender(te),Nt.instantiateLogger(Le,te,he)},openExternal(te,he){return Ut.openUri(te,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===vt.environment.appUriScheme)return gi.createAppUri(te);try{return await Ut.asExternalUri(te,{allowTunneling:!!vt.remote.authority})}catch(he){if((0,A.$Og)(te,A.Schemas.http)||(0,A.$Og)(te,A.Schemas.https))return te;throw he}},get remoteName(){return(0,s.$hn)(vt.remote.authority)},get remoteAuthority(){return(0,Ze.$7G)(Le,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return kt.getLevel()},get onDidChangeLogLevel(){return ot(kt.onDidChangeLogLevel)},get appQuality(){return(0,Ze.$7G)(Le,"resolvers"),vt.quality},get appCommit(){return(0,Ze.$7G)(Le,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(mi);const Wi={createTestController(te,he,Fe){return ki.createTestController(Le,te,he,Fe)},createTestObserver(){return(0,Ze.$7G)(Le,"testObserver"),ki.createTestObserver()},runTests(te){return(0,Ze.$7G)(Le,"testObserver"),ki.runTests(te)},registerTestFollowupProvider(te){return(0,Ze.$7G)(Le,"testObserver"),ki.registerTestFollowupProvider(te)},get onDidChangeTestResults(){return(0,Ze.$7G)(Le,"testObserver"),ot(ki.onResultsChanged)},get testResults(){return(0,Ze.$7G)(Le,"testObserver"),ki.results}},Fi=vt.remote.isRemote?Q.ExtensionKind.Workspace:Q.ExtensionKind.UI,sn={getExtension(te,he){(0,Ze.$6G)(Le,"extensionsAny")||(he=!1);const Fe=yi.mine.getExtensionDescription(te);if(Fe)return new ge.$kpc(qt,Le.identifier,Fe,Fi,!1);if(he){const at=yi.all.getExtensionDescription(te);if(at)return new ge.$kpc(qt,Le.identifier,at,Fi,!0)}},get all(){const te=[];for(const he of yi.mine.getAllExtensionDescriptions())te.push(new ge.$kpc(qt,Le.identifier,he,Fi,!1));return te},get allAcrossExtensionHosts(){(0,Ze.$7G)(Le,"extensionsAny");const te=new E.$rn(yi.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),he=[];for(const Fe of yi.all.getAllExtensionDescriptions()){const at=!te.has(Fe.identifier);he.push(new ge.$kpc(qt,Le.identifier,Fe,Fi,at))}return he},get onDidChange(){return(0,Ze.$6G)(Le,"extensionsAny")?ot(C.Event.any(yi.mine.onDidChange,yi.all.onDidChange)):ot(yi.mine.onDidChange)}},on={createDiagnosticCollection(te){return le.createDiagnosticCollection(Le.identifier,te)},get onDidChangeDiagnostics(){return ot(le.onDidChangeDiagnostics)},getDiagnostics:te=>le.getDiagnostics(te),getLanguages(){return J.getLanguages()},setTextDocumentLanguage(te,he){return J.changeLanguage(te.uri,he)},match(te,he){const Fe=je.LanguageSelector.from(te);let at;return(0,P.$tu)(Fe)&&(at=Tt.notebookDocuments.find(Dt=>Dt.apiNotebook.getCells().find(Ot=>Ot.document===he))?.apiNotebook),(0,P.$su)(Fe,he.uri,he.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(te,he,Fe){return Ee.registerCodeActionProvider(Le,wt(te),he,Fe)},registerDocumentPasteEditProvider(te,he,Fe){return(0,Ze.$7G)(Le,"documentPaste"),Ee.registerDocumentPasteEditProvider(Le,wt(te),he,Fe)},registerCodeLensProvider(te,he){return Ee.registerCodeLensProvider(Le,wt(te),he)},registerDefinitionProvider(te,he){return Ee.registerDefinitionProvider(Le,wt(te),he)},registerDeclarationProvider(te,he){return Ee.registerDeclarationProvider(Le,wt(te),he)},registerImplementationProvider(te,he){return Ee.registerImplementationProvider(Le,wt(te),he)},registerTypeDefinitionProvider(te,he){return Ee.registerTypeDefinitionProvider(Le,wt(te),he)},registerHoverProvider(te,he){return Ee.registerHoverProvider(Le,wt(te),he,Le.identifier)},registerEvaluatableExpressionProvider(te,he){return Ee.registerEvaluatableExpressionProvider(Le,wt(te),he,Le.identifier)},registerInlineValuesProvider(te,he){return Ee.registerInlineValuesProvider(Le,wt(te),he,Le.identifier)},registerDocumentHighlightProvider(te,he){return Ee.registerDocumentHighlightProvider(Le,wt(te),he)},registerMultiDocumentHighlightProvider(te,he){return Ee.registerMultiDocumentHighlightProvider(Le,wt(te),he)},registerLinkedEditingRangeProvider(te,he){return Ee.registerLinkedEditingRangeProvider(Le,wt(te),he)},registerReferenceProvider(te,he){return Ee.registerReferenceProvider(Le,wt(te),he)},registerRenameProvider(te,he){return Ee.registerRenameProvider(Le,wt(te),he)},registerNewSymbolNamesProvider(te,he){return(0,Ze.$7G)(Le,"newSymbolNamesProvider"),Ee.registerNewSymbolNamesProvider(Le,wt(te),he)},registerDocumentSymbolProvider(te,he,Fe){return Ee.registerDocumentSymbolProvider(Le,wt(te),he,Fe)},registerWorkspaceSymbolProvider(te){return Ee.registerWorkspaceSymbolProvider(Le,te)},registerDocumentFormattingEditProvider(te,he){return Ee.registerDocumentFormattingEditProvider(Le,wt(te),he)},registerDocumentRangeFormattingEditProvider(te,he){return Ee.registerDocumentRangeFormattingEditProvider(Le,wt(te),he)},registerOnTypeFormattingEditProvider(te,he,Fe,...at){return Ee.registerOnTypeFormattingEditProvider(Le,wt(te),he,[Fe].concat(at))},registerDocumentSemanticTokensProvider(te,he,Fe){return Ee.registerDocumentSemanticTokensProvider(Le,wt(te),he,Fe)},registerDocumentRangeSemanticTokensProvider(te,he,Fe){return Ee.registerDocumentRangeSemanticTokensProvider(Le,wt(te),he,Fe)},registerSignatureHelpProvider(te,he,Fe,...at){return typeof Fe=="object"?Ee.registerSignatureHelpProvider(Le,wt(te),he,Fe):Ee.registerSignatureHelpProvider(Le,wt(te),he,typeof Fe>"u"?[]:[Fe,...at])},registerCompletionItemProvider(te,he,...Fe){return Ee.registerCompletionItemProvider(Le,wt(te),he,Fe)},registerInlineCompletionItemProvider(te,he,Fe){return he.handleDidShowCompletionItem&&(0,Ze.$7G)(Le,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$7G)(Le,"inlineCompletionsAdditions"),Fe&&(0,Ze.$7G)(Le,"inlineCompletionsAdditions"),Ee.registerInlineCompletionsProvider(Le,wt(te),he,Fe)},registerInlineEditProvider(te,he){return(0,Ze.$7G)(Le,"inlineEdit"),Ee.registerInlineEditProvider(Le,wt(te),he)},registerDocumentLinkProvider(te,he){return Ee.registerDocumentLinkProvider(Le,wt(te),he)},registerColorProvider(te,he){return Ee.registerColorProvider(Le,wt(te),he)},registerFoldingRangeProvider(te,he){return Ee.registerFoldingRangeProvider(Le,wt(te),he)},registerSelectionRangeProvider(te,he){return Ee.registerSelectionRangeProvider(Le,te,he)},registerCallHierarchyProvider(te,he){return Ee.registerCallHierarchyProvider(Le,te,he)},registerTypeHierarchyProvider(te,he){return Ee.registerTypeHierarchyProvider(Le,te,he)},setLanguageConfiguration:(te,he)=>Ee.setLanguageConfiguration(Le,te,he),getTokenInformationAtPosition(te,he){return(0,Ze.$7G)(Le,"tokenInformation"),J.tokenAtPosition(te,he)},registerInlayHintsProvider(te,he){return Ee.registerInlayHintsProvider(Le,te,he)},createLanguageStatusItem(te,he){return J.createLanguageStatusItem(Le,te,he)},registerDocumentDropEditProvider(te,he,Fe){return Ee.registerDocumentOnDropEditProvider(Le,te,he,(0,Ze.$6G)(Le,"documentPaste")?Fe:void 0)}},an={get activeTextEditor(){return Wt.getActiveTextEditor()},get visibleTextEditors(){return Wt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(te,he,Fe){p.URI.isUri(te)&&te.scheme===A.Schemas.vscodeRemote&&!te.authority&&At.report("workspace.showTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(p.URI.isUri(te)?Promise.resolve(cn.openTextDocument(te)):Promise.resolve(te));return Wt.showTextDocument(at,he,Fe)},createTextEditorDecorationType(te){return Wt.createTextEditorDecorationType(Le,te)},onDidChangeActiveTextEditor(te,he,Fe){return ot(Wt.onDidChangeActiveTextEditor)(te,he,Fe)},onDidChangeVisibleTextEditors(te,he,Fe){return ot(Wt.onDidChangeVisibleTextEditors)(te,he,Fe)},onDidChangeTextEditorSelection(te,he,Fe){return ot(Wt.onDidChangeTextEditorSelection)(te,he,Fe)},onDidChangeTextEditorOptions(te,he,Fe){return ot(Wt.onDidChangeTextEditorOptions)(te,he,Fe)},onDidChangeTextEditorVisibleRanges(te,he,Fe){return ot(Wt.onDidChangeTextEditorVisibleRanges)(te,he,Fe)},onDidChangeTextEditorViewColumn(te,he,Fe){return ot(Wt.onDidChangeTextEditorViewColumn)(te,he,Fe)},onDidCloseTerminal(te,he,Fe){return ot(bt.onDidCloseTerminal)(te,he,Fe)},onDidOpenTerminal(te,he,Fe){return ot(bt.onDidOpenTerminal)(te,he,Fe)},onDidChangeActiveTerminal(te,he,Fe){return ot(bt.onDidChangeActiveTerminal)(te,he,Fe)},onDidChangeTerminalDimensions(te,he,Fe){return(0,Ze.$7G)(Le,"terminalDimensions"),ot(bt.onDidChangeTerminalDimensions)(te,he,Fe)},onDidChangeTerminalState(te,he,Fe){return ot(bt.onDidChangeTerminalState)(te,he,Fe)},onDidWriteTerminalData(te,he,Fe){return(0,Ze.$7G)(Le,"terminalDataWriteEvent"),ot(bt.onDidWriteTerminalData)(te,he,Fe)},onDidExecuteTerminalCommand(te,he,Fe){return(0,Ze.$7G)(Le,"terminalExecuteCommandEvent"),ot(bt.onDidExecuteTerminalCommand)(te,he,Fe)},onDidChangeTerminalShellIntegration(te,he,Fe){return(0,Ze.$7G)(Le,"terminalShellIntegration"),ot(ei.onDidChangeTerminalShellIntegration)(te,he,Fe)},onDidStartTerminalShellExecution(te,he,Fe){return(0,Ze.$7G)(Le,"terminalShellIntegration"),ot(ei.onDidStartTerminalShellExecution)(te,he,Fe)},onDidEndTerminalShellExecution(te,he,Fe){return(0,Ze.$7G)(Le,"terminalShellIntegration"),ot(ei.onDidEndTerminalShellExecution)(te,he,Fe)},get state(){return Ut.getState()},onDidChangeWindowState(te,he,Fe){return ot(Ut.onDidChangeWindowState)(te,he,Fe)},showInformationMessage(te,...he){return Ui.showMessage(Le,T.default.Info,te,he[0],he.slice(1))},showWarningMessage(te,...he){return Ui.showMessage(Le,T.default.Warning,te,he[0],he.slice(1))},showErrorMessage(te,...he){return Ui.showMessage(Le,T.default.Error,te,he[0],he.slice(1))},showQuickPick(te,he,Fe){return Ge.showQuickPick(Le,te,he,Fe)},showWorkspaceFolderPick(te){return Ge.showWorkspaceFolderPick(te)},showInputBox(te,he){return Ge.showInput(te,he)},showOpenDialog(te){return Hi.showOpenDialog(Le,te)},showSaveDialog(te){return Hi.showSaveDialog(te)},createStatusBarItem(te,he,Fe){let at,Dt,Ot;return typeof te=="string"?(at=te,Dt=he,Ot=Fe):(Dt=te,Ot=he),zi.createStatusBarEntry(Le,at,Dt,Ot)},setStatusBarMessage(te,he){return zi.setStatusBarMessage(te,he)},withScmProgress(te){return At.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Mt.withProgress(Le,{location:Q.ProgressLocation.SourceControl},(he,Fe)=>te({report(at){}}))},withProgress(te,he){return Mt.withProgress(Le,te,he)},createOutputChannel(te,he){return bi.createOutputChannel(te,he,Le)},createWebviewPanel(te,he,Fe,at){return Oi.createWebviewPanel(Le,te,he,Fe,at)},createWebviewTextEditorInset(te,he,Fe,at){return(0,Ze.$7G)(Le,"editorInsets"),Te.createWebviewEditorInset(te,he,Fe,at,Le)},createTerminal(te,he,Fe){return typeof te=="object"?"pty"in te?bt.createExtensionTerminal(te):bt.createTerminalFromOptions(te):bt.createTerminal(te,he,Fe)},registerTerminalLinkProvider(te){return bt.registerLinkProvider(te)},registerTerminalProfileProvider(te,he){return bt.registerProfileProvider(Le,te,he)},registerTerminalQuickFixProvider(te,he){return(0,Ze.$7G)(Le,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(te,Le.identifier.value,he)},registerTreeDataProvider(te,he){return ye.registerTreeDataProvider(te,he,Le)},createTreeView(te,he){return ye.createTreeView(te,he,Le)},registerWebviewPanelSerializer:(te,he)=>Oi.registerWebviewPanelSerializer(Le,te,he),registerCustomEditorProvider:(te,he,Fe={})=>Vi.registerCustomEditorProvider(Le,te,he,Fe),registerFileDecorationProvider(te){return oi.registerFileDecorationProvider(te,Le)},registerUriHandler(te){return gi.registerUriHandler(Le,te)},createQuickPick(){return Ge.createQuickPick(Le)},createInputBox(){return Ge.createInputBox(Le)},get activeColorTheme(){return qi.activeColorTheme},onDidChangeActiveColorTheme(te,he,Fe){return ot(qi.onDidChangeActiveColorTheme)(te,he,Fe)},registerWebviewViewProvider(te,he,Fe){return xi.registerWebviewViewProvider(Le,te,he,Fe?.webviewOptions)},get activeNotebookEditor(){return Tt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,he,Fe){return ot(Tt.onDidChangeActiveNotebookEditor)(te,he,Fe)},get visibleNotebookEditors(){return Tt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Tt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(te,he,Fe){return ot(Pi.onDidChangeNotebookEditorSelection)(te,he,Fe)},onDidChangeNotebookEditorVisibleRanges(te,he,Fe){return ot(Pi.onDidChangeNotebookEditorVisibleRanges)(te,he,Fe)},showNotebookDocument(te,he){return Tt.showNotebookDocument(te,he)},registerExternalUriOpener(te,he,Fe){return(0,Ze.$7G)(Le,"externalUriOpener"),_i.registerExternalUriOpener(Le.identifier,te,he,Fe)},registerProfileContentHandler(te,he){return(0,Ze.$7G)(Le,"profileContentHandlers"),en.registerProfileContentHandler(Le,te,he)},registerQuickDiffProvider(te,he,Fe,at){return(0,Ze.$7G)(Le,"quickDiffProvider"),It.registerQuickDiffProvider(wt(te),he,Fe,at)},get tabGroups(){return _t.tabGroups},registerShareProvider(te,he){return(0,Ze.$7G)(Le,"shareProvider"),Jt.registerShareProvider(wt(te),he)}},cn={get rootPath(){return At.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),yt.getPath()},set rootPath(te){throw new k.$$("rootPath")},getWorkspaceFolder(te){return yt.getWorkspaceFolder(te)},get workspaceFolders(){return yt.getWorkspaceFolders()},get name(){return yt.name},set name(te){throw new k.$$("name")},get workspaceFile(){return yt.workspaceFile},set workspaceFile(te){throw new k.$$("workspaceFile")},updateWorkspaceFolders:(te,he,...Fe)=>yt.updateWorkspaceFolders(Le,te,he||0,...Fe),onDidChangeWorkspaceFolders:function(te,he,Fe){return ot(yt.onDidChangeWorkspace)(te,he,Fe)},asRelativePath:(te,he)=>yt.getRelativePath(te,he),findFiles:(te,he,Fe,at)=>yt.findFiles(te,he,Fe,Le.identifier,at),findFiles2:(te,he,Fe)=>((0,Ze.$7G)(Le,"findFiles2"),yt.findFiles2(te,he,Le.identifier,Fe)),findTextInFiles:(te,he,Fe,at)=>{(0,Ze.$7G)(Le,"findTextInFiles");let Dt,Ot;return typeof he=="object"?(Dt=he,Ot=Fe):(Dt={},Ot=he,at=Fe),yt.findTextInFiles(te,Dt||{},Ot,Le.identifier,at)},save:te=>yt.save(te),saveAs:te=>yt.saveAs(te),saveAll:te=>yt.saveAll(te),applyEdit(te,he){return bn.applyWorkspaceEdit(te,Le,he)},createFileSystemWatcher:(te,he,Fe,at)=>{let Dt;return typeof he=="boolean"?Dt={ignoreCreateEvents:!!he,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!at,correlate:!1}:he&&((0,Ze.$7G)(Le,"createFileSystemWatcher"),Dt={...he,correlate:!0}),Ye.createFileSystemWatcher(yt,Le,te,Dt)},get textDocuments(){return Bt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new k.$$("textDocuments")},openTextDocument(te){let he;const Fe=te;if(typeof te=="string")he=Promise.resolve(p.URI.file(te));else if(p.URI.isUri(te))he=Promise.resolve(te);else if(!Fe||typeof Fe=="object")he=Bt.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(at=>(at.scheme===A.Schemas.vscodeRemote&&!at.authority&&At.report("workspace.openTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority."),Bt.ensureDocumentData(at).then(Dt=>Dt.document)))},onDidOpenTextDocument:(te,he,Fe)=>ot(Bt.onDidAddDocument)(te,he,Fe),onDidCloseTextDocument:(te,he,Fe)=>ot(Bt.onDidRemoveDocument)(te,he,Fe),onDidChangeTextDocument:(te,he,Fe)=>ot(Bt.onDidChangeDocument)(te,he,Fe),onDidSaveTextDocument:(te,he,Fe)=>ot(Bt.onDidSaveDocument)(te,he,Fe),onWillSaveTextDocument:(te,he,Fe)=>ot(Ii.getOnWillSaveTextDocumentEvent(Le))(te,he,Fe),get notebookDocuments(){return Tt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,he){let Fe;if(p.URI.isUri(te))Fe=te,await Tt.openNotebookDocument(te);else if(typeof te=="string")Fe=p.URI.revive(await Tt.createNotebookDocument({viewType:te,content:he}));else throw new Error("Invalid arguments");return Tt.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(te,he,Fe){return ot(Di.onDidSaveNotebookDocument)(te,he,Fe)},onDidChangeNotebookDocument(te,he,Fe){return ot(Di.onDidChangeNotebookDocument)(te,he,Fe)},onWillSaveNotebookDocument(te,he,Fe){return ot(Ri.getOnWillSaveNotebookDocumentEvent(Le))(te,he,Fe)},get onDidOpenNotebookDocument(){return ot(Tt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Tt.onDidCloseNotebookDocument)},registerNotebookSerializer(te,he,Fe,at){return Tt.registerNotebookSerializer(Le,te,he,Fe,(0,Ze.$6G)(Le,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(te,he,Fe)=>ot(ji.onDidChangeConfiguration)(te,he,Fe),getConfiguration(te,he){return he=arguments.length===1?void 0:he,ji.getConfiguration(te,he,Le)},registerTextDocumentContentProvider(te,he){return ai.registerTextDocumentContentProvider(te,he)},registerTaskProvider:(te,he)=>(At.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Gt.registerTaskProvider(Le,te,he)),registerFileSystemProvider(te,he,Fe){return(0,O.$Tc)(We.registerFileSystemProvider(Le,te,he,Fe),Zt.addFileSystemProvider(te,he,Fe))},get fs(){return Zt.value},registerFileSearchProvider:(te,he)=>((0,Ze.$7G)(Le,"fileSearchProvider"),di.registerFileSearchProvider(te,he)),registerTextSearchProvider:(te,he)=>((0,Ze.$7G)(Le,"textSearchProvider"),di.registerTextSearchProvider(te,he)),registerAITextSearchProvider:(te,he)=>((0,Ze.$7G)(Le,"aiTextSearchProvider"),(0,Ze.$7G)(Le,"textSearchProvider"),di.registerAITextSearchProvider(te,he)),registerRemoteAuthorityResolver:(te,he)=>((0,Ze.$7G)(Le,"resolvers"),qt.registerRemoteAuthorityResolver(te,he)),registerResourceLabelFormatter:te=>((0,Ze.$7G)(Le,"resolvers"),ui.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Ze.$7G)(Le,"resolvers"),qt.getRemoteExecServer(te)),onDidCreateFiles:(te,he,Fe)=>ot(Ye.onDidCreateFile)(te,he,Fe),onDidDeleteFiles:(te,he,Fe)=>ot(Ye.onDidDeleteFile)(te,he,Fe),onDidRenameFiles:(te,he,Fe)=>ot(Ye.onDidRenameFile)(te,he,Fe),onWillCreateFiles:(te,he,Fe)=>ot(Ye.getOnWillCreateFileEvent(Le))(te,he,Fe),onWillDeleteFiles:(te,he,Fe)=>ot(Ye.getOnWillDeleteFileEvent(Le))(te,he,Fe),onWillRenameFiles:(te,he,Fe)=>ot(Ye.getOnWillRenameFileEvent(Le))(te,he,Fe),openTunnel:te=>((0,Ze.$7G)(Le,"tunnels"),Lt.openTunnel(Le,te).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ze.$7G)(Le,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(te,he,Fe)=>((0,Ze.$7G)(Le,"tunnels"),ot(Lt.onDidChangeTunnels)(te,he,Fe)),registerPortAttributesProvider:(te,he)=>((0,Ze.$7G)(Le,"portsAttributes"),Lt.registerPortsAttributesProvider(te,he)),registerTunnelProvider:(te,he)=>((0,Ze.$7G)(Le,"tunnelFactory"),Lt.registerTunnelProvider(te,he)),registerTimelineProvider:(te,he)=>((0,Ze.$7G)(Le,"timeline"),$n.registerTimelineProvider(te,he,Le.identifier,St.converter)),get isTrusted(){return yt.trusted},requestWorkspaceTrust:te=>((0,Ze.$7G)(Le,"workspaceTrust"),yt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,he,Fe)=>ot(yt.onDidGrantWorkspaceTrust)(te,he,Fe),registerEditSessionIdentityProvider:(te,he)=>((0,Ze.$7G)(Le,"editSessionIdentityProvider"),yt.registerEditSessionIdentityProvider(te,he)),onWillCreateEditSessionIdentity:(te,he,Fe)=>((0,Ze.$7G)(Le,"editSessionIdentityProvider"),ot(yt.getOnWillCreateEditSessionIdentityEvent(Le))(te,he,Fe)),registerCanonicalUriProvider:(te,he)=>((0,Ze.$7G)(Le,"canonicalUriProvider"),yt.registerCanonicalUriProvider(te,he)),getCanonicalUri:(te,he,Fe)=>((0,Ze.$7G)(Le,"canonicalUriProvider"),yt.provideCanonicalUri(te,he,Fe))},un={get inputBox(){return At.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),lt.getLastInputBox(Le)},createSourceControl(te,he,Fe){return lt.createSourceControl(Le,te,he,Fe)}},ln={createCommentController(te,he){return ci.createCommentController(Le,te,he)}},yn={get activeDebugSession(){return Ct.activeDebugSession},get activeDebugConsole(){return Ct.activeDebugConsole},get breakpoints(){return Ct.breakpoints},get activeStackItem(){return Ct.activeStackItem},registerDebugVisualizationProvider(te,he){return(0,Ze.$7G)(Le,"debugVisualization"),Ct.registerDebugVisualizationProvider(Le,te,he)},registerDebugVisualizationTreeProvider(te,he){return(0,Ze.$7G)(Le,"debugVisualization"),Ct.registerDebugVisualizationTree(Le,te,he)},onDidStartDebugSession(te,he,Fe){return ot(Ct.onDidStartDebugSession)(te,he,Fe)},onDidTerminateDebugSession(te,he,Fe){return ot(Ct.onDidTerminateDebugSession)(te,he,Fe)},onDidChangeActiveDebugSession(te,he,Fe){return ot(Ct.onDidChangeActiveDebugSession)(te,he,Fe)},onDidReceiveDebugSessionCustomEvent(te,he,Fe){return ot(Ct.onDidReceiveDebugSessionCustomEvent)(te,he,Fe)},onDidChangeBreakpoints(te,he,Fe){return ot(Ct.onDidChangeBreakpoints)(te,he,Fe)},onDidChangeActiveStackItem(te,he,Fe){return ot(Ct.onDidChangeActiveStackItem)(te,he,Fe)},registerDebugConfigurationProvider(te,he,Fe){return Ct.registerDebugConfigurationProvider(te,he,Fe||Yt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,he){return Ct.registerDebugAdapterDescriptorFactory(Le,te,he)},registerDebugAdapterTrackerFactory(te,he){return Ct.registerDebugAdapterTrackerFactory(te,he)},startDebugging(te,he,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?Ct.startDebugging(te,he,{parentSession:Fe}):Ct.startDebugging(te,he,Fe||{})},stopDebugging(te){return Ct.stopDebugging(te)},addBreakpoints(te){return Ct.addBreakpoints(te)},removeBreakpoints(te){return Ct.removeBreakpoints(te)},asDebugSourceUri(te,he){return Ct.asDebugSourceUri(te,he)}},En={registerTaskProvider:(te,he)=>Gt.registerTaskProvider(Le,te,he),fetchTasks:te=>Gt.fetchTasks(te),executeTask:te=>Gt.executeTask(Le,te),get taskExecutions(){return Gt.taskExecutions},onDidStartTask:(te,he,Fe)=>ot(Gt.onDidStartTask)(te,he,Fe),onDidEndTask:(te,he,Fe)=>ot(Gt.onDidEndTask)(te,he,Fe),onDidStartTaskProcess:(te,he,Fe)=>ot(Gt.onDidStartTaskProcess)(te,he,Fe),onDidEndTaskProcess:(te,he,Fe)=>ot(Gt.onDidEndTaskProcess)(te,he,Fe)},hn={createNotebookController(te,he,Fe,at,Dt){return Si.createNotebookController(Le,te,he,Fe,at,(0,Ze.$6G)(Le,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(te,he)=>Tt.registerNotebookCellStatusBarItemProvider(Le,te,he),createRendererMessaging(te){return pi.createRendererMessaging(Le,te)},createNotebookControllerDetectionTask(te){return(0,Ze.$7G)(Le,"notebookKernelSource"),Si.createNotebookControllerDetectionTask(Le,te)},registerKernelSourceActionProvider(te,he){return(0,Ze.$7G)(Le,"notebookKernelSource"),Si.registerKernelSourceActionProvider(Le,te,he)},onDidChangeNotebookCellExecutionState(te,he,Fe){return(0,Ze.$7G)(Le,"notebookCellExecutionState"),ot(Si.onDidChangeNotebookCellExecutionState)(te,he,Fe)}},Ji={t(...te){if(typeof te[0]=="string"){const he=te.shift(),Fe=!te||typeof te[0]!="object"?te:te[0];return vi.getMessage(Le.identifier.value,{message:he,args:Fe})}return vi.getMessage(Le.identifier.value,te[0])},get bundle(){return vi.getBundle(Le.identifier.value)},get uri(){return vi.getBundleUri(Le.identifier.value)}},dn={_version:1,transferActiveChat(te){return(0,Ze.$7G)(Le,"interactive"),Mi.transferActiveChat(te)}},fn={getRelatedInformation(te,he){return(0,Ze.$7G)(Le,"aiRelatedInformation"),nn.getRelatedInformation(Le,te,he)},registerRelatedInformationProvider(te,he){return(0,Ze.$7G)(Le,"aiRelatedInformation"),nn.registerRelatedInformationProvider(Le,te,he)},registerEmbeddingVectorProvider(te,he){return(0,Ze.$7G)(Le,"aiRelatedInformation"),Ki.registerEmbeddingVectorProvider(Le,te,he)}},gn={_version:1,registerChatResponseProvider(te,he,Fe){return(0,Ze.$7G)(Le,"chatProvider"),Ht.registerLanguageModel(Le,te,he,Fe)},registerChatVariableResolver(te,he,Fe,at,Dt,Ot,Ai,Xi){return(0,Ze.$7G)(Le,"chatVariableResolver"),tn.registerVariableResolver(Le,te,he,Fe,at,Dt,Ot,Ai,Xi?.id)},registerMappedEditsProvider(te,he){return(0,Ze.$7G)(Le,"mappedEditsProvider"),Ee.registerMappedEditsProvider(Le,te,he)},createChatParticipant(te,he){return Mi.createChatAgent(Le,te,he)},createDynamicChatParticipant(te,he,Fe){return(0,Ze.$7G)(Le,"chatParticipantPrivate"),Mi.createDynamicChatAgent(Le,te,he,Fe)}},Dn={selectChatModels:te=>vt.quality==="stable"?(console.warn(`[${E.$qn.toKey(Le.identifier)}] This API is disabled in '${vt.environment.appName}'-stable.`),Promise.resolve([])):Ht.selectLanguageModels(Le,te??{}),onDidChangeChatModels:(te,he,Fe)=>vt.quality==="stable"?(console.warn(`[${E.$qn.toKey(Le.identifier)}] This API is disabled in '${vt.environment.appName}'-stable.`),C.Event.None(te,he,Fe)):Ht.onDidChangeProviders(te,he,Fe),registerChatModelProvider:(te,he,Fe)=>((0,Ze.$7G)(Le,"chatProvider"),Ht.registerLanguageModel(Le,te,he,Fe)),get embeddingModels(){return(0,Ze.$7G)(Le,"embeddings"),Ni.embeddingsModels},onDidChangeEmbeddingModels:(te,he,Fe)=>((0,Ze.$7G)(Le,"embeddings"),Ni.onDidChange(te,he,Fe)),registerEmbeddingsProvider(te,he){return(0,Ze.$7G)(Le,"embeddings"),Ni.registerEmbeddingsProvider(Le,te,he)},async computeEmbeddings(te,he,Fe){return(0,Ze.$7G)(Le,"embeddings"),Ni.computeEmbeddings(te,he,Fe)},registerTool(te,he){return(0,Ze.$7G)(Le,"lmTools"),Gi.registerTool(Le,te,he)},invokeTool(te,he,Fe){return(0,Ze.$7G)(Le,"lmTools"),Gi.invokeTool(te,he,Fe)},get tools(){return(0,Ze.$7G)(Le,"lmTools"),Gi.tools}},Sn={registerSpeechProvider(te,he){return(0,Ze.$7G)(Le,"speech"),wn.registerProvider(Le.identifier,te,he)}};return{version:vt.version,ai:fn,authentication:Bi,commands:vn,comments:ln,chat:gn,debug:yn,env:mi,extensions:sn,interactive:dn,l10n:Ji,languages:on,lm:Dn,notebooks:hn,scm:un,speech:Sn,tasks:En,tests:Wi,window:an,workspace:cn,Breakpoint:Q.$xO,TerminalOutputAnchor:Q.TerminalOutputAnchor,ChatResultFeedbackKind:Q.ChatResultFeedbackKind,ChatVariableLevel:Q.ChatVariableLevel,ChatCompletionItem:Q.$sP,CallHierarchyIncomingCall:Q.$VN,CallHierarchyItem:Q.$UN,CallHierarchyOutgoingCall:Q.$WN,CancellationError:k.$7,CancellationTokenSource:v.$xe,CandidatePortSource:i.CandidatePortSource,CodeAction:Q.$RN,CodeActionKind:Q.$SN,CodeActionTriggerKind:Q.CodeActionTriggerKind,CodeLens:Q.$XN,Color:Q.$$N,ColorInformation:Q.$_N,ColorPresentation:Q.$aO,ColorThemeKind:Q.ColorThemeKind,CommentMode:Q.CommentMode,CommentState:Q.CommentState,CommentThreadCollapsibleState:Q.CommentThreadCollapsibleState,CommentThreadState:Q.CommentThreadState,CommentThreadApplicability:Q.CommentThreadApplicability,CompletionItem:Q.$5N,CompletionItemKind:Q.CompletionItemKind,CompletionItemTag:Q.CompletionItemTag,CompletionList:Q.$6N,CompletionTriggerKind:Q.CompletionTriggerKind,ConfigurationTarget:Q.ConfigurationTarget,CustomExecution:Q.$iO,DebugAdapterExecutable:Q.$BO,DebugAdapterInlineImplementation:Q.$EO,DebugAdapterNamedPipeServer:Q.$DO,DebugAdapterServer:Q.$CO,DebugConfigurationProviderTriggerKind:Yt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Q.DebugConsoleMode,DebugVisualization:Q.$UO,DecorationRangeBehavior:Q.DecorationRangeBehavior,Diagnostic:Q.$KN,DiagnosticRelatedInformation:Q.$JN,DiagnosticSeverity:Q.DiagnosticSeverity,DiagnosticTag:Q.DiagnosticTag,Disposable:Q.$wN,DocumentHighlight:Q.$NN,DocumentHighlightKind:Q.DocumentHighlightKind,MultiDocumentHighlight:Q.$ON,DocumentLink:Q.$0N,DocumentSymbol:Q.$QN,EndOfLine:Q.EndOfLine,EnvironmentVariableMutatorType:Q.EnvironmentVariableMutatorType,EvaluatableExpression:Q.$HO,InlineValueText:Q.$IO,InlineValueVariableLookup:Q.$JO,InlineValueEvaluatableExpression:Q.$KO,InlineCompletionTriggerKind:Q.InlineCompletionTriggerKind,EventEmitter:C.$me,ExtensionKind:Q.ExtensionKind,ExtensionMode:Q.ExtensionMode,ExternalUriOpenerPriority:Q.ExternalUriOpenerPriority,FileChangeType:Q.FileChangeType,FileDecoration:Q.$WO,FileDecoration2:Q.$WO,FileSystemError:Q.$NO,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:Q.$OO,FoldingRangeKind:Q.FoldingRangeKind,FunctionBreakpoint:Q.$zO,InlineCompletionItem:Q.$7N,InlineCompletionList:Q.$8N,Hover:Q.$LN,VerboseHover:Q.$MN,HoverVerbosityAction:Q.HoverVerbosityAction,IndentAction:y.IndentAction,Location:Q.$IN,MarkdownString:Q.$YN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Q.$ZN,PortAutoForwardAction:Q.PortAutoForwardAction,Position:Q.$xN,ProcessExecution:Q.$gO,ProgressLocation:Q.ProgressLocation,QuickInputButtons:Q.$VO,Range:Q.$yN,RelativePattern:Q.$vO,Selection:Q.$zN,SelectionRange:Q.$TN,SemanticTokens:Q.$RO,SemanticTokensBuilder:Q.$QO,SemanticTokensEdit:Q.$SO,SemanticTokensEdits:Q.$TO,SemanticTokensLegend:Q.$PO,ShellExecution:Q.$hO,ShellQuoting:Q.ShellQuoting,SignatureHelp:Q.$2N,SignatureHelpTriggerKind:Q.SignatureHelpTriggerKind,SignatureInformation:Q.$1N,SnippetString:Q.$HN,SourceBreakpoint:Q.$yO,StandardTokenType:Q.StandardTokenType,StatusBarAlignment:Q.StatusBarAlignment,SymbolInformation:Q.$PN,SymbolKind:Q.SymbolKind,SymbolTag:Q.SymbolTag,Task:Q.$jO,TaskGroup:Q.$fO,TaskPanelKind:Q.TaskPanelKind,TaskRevealKind:Q.TaskRevealKind,TaskScope:Q.TaskScope,TerminalLink:Q.$bO,TerminalQuickFixTerminalCommand:Q.$dO,TerminalQuickFixOpener:Q.$cO,TerminalLocation:Q.TerminalLocation,TerminalProfile:Q.$eO,TerminalExitReason:Q.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Q.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Q.TextDocumentSaveReason,TextEdit:Q.$DN,SnippetTextEdit:Q.$FN,TextEditorCursorStyle:a.TextEditorCursorStyle,TextEditorLineNumbersStyle:Q.TextEditorLineNumbersStyle,TextEditorRevealType:Q.TextEditorRevealType,TextEditorSelectionChangeKind:Q.TextEditorSelectionChangeKind,SyntaxTokenType:Q.SyntaxTokenType,TextDocumentChangeReason:Q.TextDocumentChangeReason,ThemeColor:Q.$uO,ThemeIcon:Q.$tO,TreeItem:Q.$kO,TreeItemCheckboxState:Q.TreeItemCheckboxState,TreeItemCollapsibleState:Q.TreeItemCollapsibleState,TypeHierarchyItem:Q.$gP,UIKind:fi.UIKind,Uri:p.URI,ViewColumn:Q.ViewColumn,WorkspaceEdit:Q.$GN,DocumentPasteTriggerKind:Q.DocumentPasteTriggerKind,DocumentDropEdit:Q.$qO,DocumentDropOrPasteEditKind:Q.$rO,DocumentPasteEdit:Q.$sO,InlayHint:Q.$4N,InlayHintLabelPart:Q.$3N,InlayHintKind:Q.InlayHintKind,RemoteAuthorityResolverError:Q.$CN,ResolvedAuthority:Q.$AN,ManagedResolvedAuthority:Q.$BN,SourceControlInputBoxValidationType:Q.SourceControlInputBoxValidationType,ExtensionRuntime:Q.ExtensionRuntime,TimelineItem:Q.$7O,NotebookRange:Q.$YO,NotebookCellKind:Q.NotebookCellKind,NotebookCellExecutionState:Q.NotebookCellExecutionState,NotebookCellData:Q.$ZO,NotebookData:Q.$1O,NotebookRendererScript:Q.$5O,NotebookCellStatusBarAlignment:Q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Q.NotebookEditorRevealType,NotebookCellOutput:Q.$3O,NotebookCellOutputItem:Q.$2O,NotebookCellStatusBarItem:Q.$4O,NotebookControllerAffinity:Q.NotebookControllerAffinity,NotebookControllerAffinity2:Q.NotebookControllerAffinity2,NotebookEdit:Q.$EN,NotebookKernelSourceAction:Q.$6O,NotebookVariablesRequestKind:Q.NotebookVariablesRequestKind,PortAttributes:Q.$9O,LinkedEditingRanges:Q.$8O,TestResultState:Q.TestResultState,TestRunRequest:Q.$0O,TestMessage:Q.$$O,TestTag:Q.$_O,TestRunProfileKind:Q.TestRunProfileKind,TextSearchCompleteMessageType:Pt.TextSearchCompleteMessageType,DataTransfer:Q.$pO,DataTransferItem:Q.$lO,TestCoverageCount:Q.$aP,FileCoverage:Q.$cP,FileCoverage2:Q.$cP,StatementCoverage:Q.$dP,BranchCoverage:Q.$eP,DeclarationCoverage:Q.$fP,WorkspaceTrustState:Q.WorkspaceTrustState,LanguageStatusSeverity:Q.LanguageStatusSeverity,QuickPickItemKind:Q.QuickPickItemKind,InputBoxValidationSeverity:Q.InputBoxValidationSeverity,TabInputText:Q.$hP,TabInputTextDiff:Q.$iP,TabInputTextMerge:Q.$jP,TabInputCustom:Q.$kP,TabInputNotebook:Q.$mP,TabInputNotebookDiff:Q.$nP,TabInputWebview:Q.$lP,TabInputTerminal:Q.$oP,TabInputInteractiveWindow:Q.$pP,TabInputChat:Q.$qP,TabInputTextMultiDiff:Q.$rP,TelemetryTrustedValue:o.$up,LogLevel:n.LogLevel,EditSessionIdentityMatch:h.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Q.InteractiveSessionVoteDirection,ChatCopyKind:Q.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Q.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Q.$FO,DebugThread:Q.$GO,RelatedInformationType:Q.RelatedInformationType,SpeechToTextStatus:Q.SpeechToTextStatus,TextToSpeechStatus:Q.TextToSpeechStatus,PartialAcceptTriggerKind:Q.PartialAcceptTriggerKind,KeywordRecognitionStatus:Q.KeywordRecognitionStatus,ChatResponseMarkdownPart:Q.$tP,ChatResponseFileTreePart:Q.$xP,ChatResponseAnchorPart:Q.$yP,ChatResponseProgressPart:Q.$zP,ChatResponseProgressPart2:Q.$AP,ChatResponseReferencePart:Q.$DP,ChatResponseWarningPart:Q.$BP,ChatResponseTextEditPart:Q.$EP,ChatResponseMarkdownWithVulnerabilitiesPart:Q.$uP,ChatResponseCommandButtonPart:Q.$CP,ChatResponseDetectedParticipantPart:Q.$vP,ChatResponseConfirmationPart:Q.$wP,ChatRequestTurn:Q.$FP,ChatResponseTurn:Q.$GP,ChatLocation:Q.ChatLocation,LanguageModelChatMessageRole:Q.LanguageModelChatMessageRole,LanguageModelChatMessage:Q.$IP,LanguageModelChatMessageFunctionResultPart:Q.$HP,LanguageModelChatResponseTextPart:Q.$KP,LanguageModelChatResponseFunctionUsePart:Q.$JP,LanguageModelChatMessage2:Q.$IP,LanguageModelChatSystemMessage:Q.$LP,LanguageModelChatUserMessage:Q.$MP,LanguageModelChatAssistantMessage:Q.$NP,LanguageModelError:Q.$OP,NewSymbolName:Q.$MO,NewSymbolNameTag:Q.NewSymbolNameTag,NewSymbolNameTriggerKind:Q.NewSymbolNameTriggerKind,InlineEdit:Q.$PP,InlineEditTriggerKind:Q.InlineEditTriggerKind}}}}),define(Ce[319],Ie([1,0,61,128,45,122,46,34,58,57,131,133,134,89,93,85,121,69,51,88,67,71,258,12,132,86,87,91,95,126,96]),function(oe,e,v,k,C,O,A,T,p,a,P,y,u,E,d,n,s,o,h,i,r,t,c,l,g,m,$,S,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$Os)(m.$epc,m.$dpc,v.InstantiationType.Delayed),(0,v.$Os)(l.$ak,c.$tqc,v.InstantiationType.Delayed),(0,v.$Os)(n.$joc,n.$koc,v.InstantiationType.Delayed),(0,v.$Os)(T.$kQ,T.$jQ,v.InstantiationType.Eager),(0,v.$Os)(S.$toc,S.$uoc,v.InstantiationType.Eager),(0,v.$Os)(D.$$oc,D.$_oc,v.InstantiationType.Eager),(0,v.$Os)(A.$Ioc,A.$Goc,v.InstantiationType.Eager),(0,v.$Os)(o.$Koc,o.$Joc,v.InstantiationType.Eager),(0,v.$Os)(I.$opc,I.$ppc,v.InstantiationType.Eager),(0,v.$Os)(y.$tpc,y.$xpc,v.InstantiationType.Eager),(0,v.$Os)(O.$zpc,O.$ypc,v.InstantiationType.Eager),(0,v.$Os)(p.$_P,p.$$P,v.InstantiationType.Eager),(0,v.$Os)($.$fpc,$.$gpc,v.InstantiationType.Eager),(0,v.$Os)(h.$noc,h.$moc,v.InstantiationType.Eager),(0,v.$Os)(k.$5pc,k.$4pc,v.InstantiationType.Delayed),(0,v.$Os)(u.$Ppc,u.$Qpc,v.InstantiationType.Eager),(0,v.$Os)(E.$4oc,E.$3oc,v.InstantiationType.Eager),(0,v.$Os)(P.$fqc,P.$eqc,v.InstantiationType.Eager),(0,v.$Os)(a.$7oc,a.$0oc,v.InstantiationType.Eager),(0,v.$Os)(b.$gqc,b.$hqc,v.InstantiationType.Eager),(0,v.$Os)(d.$XFb,d.$YFb,v.InstantiationType.Eager),(0,v.$Os)(s.$qqc,s.$pqc,v.InstantiationType.Eager),(0,v.$Os)(C.$Foc,C.$Eoc,v.InstantiationType.Eager),(0,v.$Os)(i.$bpc,i.$apc,v.InstantiationType.Eager),(0,v.$Os)(r.$iQ,r.$fQ,v.InstantiationType.Eager),(0,v.$Os)(t.$Uoc,t.$Voc,v.InstantiationType.Eager),(0,v.$Os)(g.$mpc,g.$npc,v.InstantiationType.Eager)}),define(Ce[320],Ie([1,0,318,47,2,315,7,11,265]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fsc=void 0;class a extends O.$wqc{j(){}getModule(E,d){for(const n of this.b){const s=n(E);if(s){E=s;break}}if(this.a.has(E))return this.a.get(E).load(E,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends k.$ipc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(p.$Esc);const E=this.h.invokeFunction(v.$sqc);this.r=this.h.createInstance(a,E,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(E){return E.browser}async xb(E,d,n){d=d.with({path:y(d.path,".js")});const s=E?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const o=C.URI.revive(await this.C.$asBrowserUri(d)),h=await fetch(o.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),h.status!==200)throw new Error(h.statusText);const i=await h.text(),r=`${d.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${r}`;let c;try{c=new Function("module","exports","require",t)}catch($){throw console.error(s?`Loading code for extension ${s} failed: ${$.message}`:`Loading code failed: ${$.message}`),console.error(`${d.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}E&&await this.w.initializeLocalizedMessages(E);const l={},g={exports:l},m=$=>{const S=this.r.getModule($,d);if(S===void 0)throw new Error(`Cannot load module '${$}'`);return S};try{return n.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),c(g,l,m),g.exports!==l?g.exports:l}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),n.codeLoadingStop()}}async $setRemoteEnvironment(E){}async Bb(E=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+E;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,T.$Gh)(10)}}e.$Fsc=P;function y(u,E){return u.endsWith(E)?u:u+E}}),define(Ce[321],Ie([1,0,74,61,12,47,229,92,320]),function(oe,e,v,k,C,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,k.$Os)(C.$_j,new v.$Ci(A.$vqc,[!0],!0)),(0,k.$Os)(O.$jpc,p.$Fsc,k.InstantiationType.Eager),(0,k.$Os)(T.$Loc,T.$Moc,k.InstantiationType.Eager)}),define(Ce[329],Ie([1,0,23,6,84,316,267,20,65,16,2,319,321]),function(oe,e,v,k,C,O,A,T,p,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,T=qe(T),p=qe(p);const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(c){return/^(file|vscode-remote):/i.test(c)}const d=fetch.bind(self);function n(c){self.fetch=async function(l,g){return l instanceof Request||E(String(l))&&(l=(await c(P.URI.parse(String(l)))).toString(!0)),d(l,g)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,g,m,$,S){(async()=>(E(g.toString())&&(g=(await c(P.URI.parse(g.toString()))).toString(!0)),super.open(l,g,m??!0,$,S)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const c=self.Worker;Worker=function(l,g){if(/^file:/i.test(l.toString()))l=a.$Zg.uriToBrowserUri(P.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const $=`(${function(I){function R(M){return typeof M=="string"||M instanceof URL?String(M).replace(/^file:\/\//i,"vscode-file://vscode-app"):M}const f=fetch.bind(self);self.fetch=function(M,N){return M instanceof Request?f(M,N):f(R(M),N)},self.XMLHttpRequest=class extends XMLHttpRequest{open(M,N,L,G,W){return super.open(M,R(N),L??!0,G,W)}};const w=importScripts.bind(self);self.importScripts=(...M)=>{w(...M.map(R))},w(I)}.toString()}('${l}'))`;g=g||{},g.name=`${name} -> ${g.name||T.$pc(l.toString())}`;const S=new Blob([$],{type:"application/javascript"}),D=URL.createObjectURL(S);return new c(D,g)}}else self.Worker=class extends A.$Gsc{constructor(c,l){super(u,c,{name:T.$pc(c.toString()),...l})}};const s=new class{constructor(){this.pid=void 0}exit(c){y()}};class o{constructor(){const l=new MessageChannel,g=new k.$me;let m=!1;u(l.port2,[l.port2]),l.port1.onmessage=$=>{const{data:S}=$;if(!(S instanceof ArrayBuffer)){console.warn("UNKNOWN data received",S);return}const D=v.$Oe.wrap(new Uint8Array(S,0,S.byteLength));if((0,C.$Bn)(D,C.MessageType.Terminate)){m=!0,i("received terminate message from renderer");return}g.fire(D)},this.protocol={onMessage:g.event,send:$=>{if(!m){const S=$.buffer.buffer.slice($.buffer.byteOffset,$.buffer.byteOffset+$.buffer.byteLength);l.port1.postMessage(S,[S])}}}}}function h(c){return new Promise(l=>{const g=c.onMessage(m=>{g.dispose();const $=JSON.parse(m.toString());c.send((0,C.$An)(C.MessageType.Initialized)),l({protocol:c,initData:$})});c.send((0,C.$An)(C.MessageType.Ready))})}let i=c=>y();function r(c){return!!c&&typeof c=="object"&&c.type==="vscode.init"&&c.data instanceof Map}function t(){p.mark("code/extHost/willConnectToRenderer");const c=new o;return{onmessage(l){r(l)&&h(c.protocol).then(g=>{p.mark("code/extHost/didWaitForInitData");const m=new O.$yqc(g.protocol,g.initData,s,null,l.data);n($=>m.asBrowserUri($)),i=$=>m.terminate($)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/a8f7d1c13f1922bd44e1bd4d709dfe6e7579c86a/core/vs/workbench/api/worker/extensionHostWorker.js.map
